#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 2819
#define LARGE_STATE_COUNT 189
#define SYMBOL_COUNT 270
#define ALIAS_COUNT 4
#define TOKEN_COUNT 108
#define EXTERNAL_TOKEN_COUNT 12
#define FIELD_COUNT 32
#define MAX_ALIAS_SEQUENCE_LENGTH 10
#define PRODUCTION_ID_COUNT 140

enum ts_symbol_identifiers {
  sym_identifier = 1,
  anon_sym_SEMI = 2,
  anon_sym_import = 3,
  anon_sym_DOT = 4,
  anon_sym_from = 5,
  anon_sym___future__ = 6,
  anon_sym_LPAREN = 7,
  anon_sym_RPAREN = 8,
  anon_sym_COMMA = 9,
  anon_sym_as = 10,
  anon_sym_STAR = 11,
  anon_sym_print = 12,
  anon_sym_GT_GT = 13,
  anon_sym_assert = 14,
  anon_sym_COLON_EQ = 15,
  anon_sym_return = 16,
  anon_sym_del = 17,
  anon_sym_raise = 18,
  anon_sym_pass = 19,
  anon_sym_break = 20,
  anon_sym_continue = 21,
  anon_sym_if = 22,
  anon_sym_COLON = 23,
  anon_sym_elif = 24,
  anon_sym_else = 25,
  anon_sym_match = 26,
  anon_sym_case = 27,
  anon_sym_async = 28,
  anon_sym_for = 29,
  anon_sym_in = 30,
  anon_sym_while = 31,
  anon_sym_try = 32,
  anon_sym_except = 33,
  anon_sym_except_STAR = 34,
  anon_sym_finally = 35,
  anon_sym_with = 36,
  anon_sym_def = 37,
  anon_sym_DASH_GT = 38,
  anon_sym_STAR_STAR = 39,
  anon_sym_global = 40,
  anon_sym_nonlocal = 41,
  anon_sym_exec = 42,
  anon_sym_type = 43,
  anon_sym_EQ = 44,
  anon_sym_class = 45,
  anon_sym_LBRACK = 46,
  anon_sym_RBRACK = 47,
  anon_sym_AT = 48,
  anon_sym_DASH = 49,
  anon_sym__ = 50,
  anon_sym_PIPE = 51,
  anon_sym_LBRACE = 52,
  anon_sym_RBRACE = 53,
  anon_sym_PLUS = 54,
  anon_sym_not = 55,
  anon_sym_and = 56,
  anon_sym_or = 57,
  anon_sym_SLASH = 58,
  anon_sym_PERCENT = 59,
  anon_sym_SLASH_SLASH = 60,
  anon_sym_AMP = 61,
  anon_sym_CARET = 62,
  anon_sym_LT_LT = 63,
  anon_sym_TILDE = 64,
  anon_sym_LT = 65,
  anon_sym_LT_EQ = 66,
  anon_sym_EQ_EQ = 67,
  anon_sym_BANG_EQ = 68,
  anon_sym_GT_EQ = 69,
  anon_sym_GT = 70,
  anon_sym_LT_GT = 71,
  anon_sym_is = 72,
  anon_sym_lambda = 73,
  anon_sym_PLUS_EQ = 74,
  anon_sym_DASH_EQ = 75,
  anon_sym_STAR_EQ = 76,
  anon_sym_SLASH_EQ = 77,
  anon_sym_AT_EQ = 78,
  anon_sym_SLASH_SLASH_EQ = 79,
  anon_sym_PERCENT_EQ = 80,
  anon_sym_STAR_STAR_EQ = 81,
  anon_sym_GT_GT_EQ = 82,
  anon_sym_LT_LT_EQ = 83,
  anon_sym_AMP_EQ = 84,
  anon_sym_CARET_EQ = 85,
  anon_sym_PIPE_EQ = 86,
  anon_sym_yield = 87,
  sym_ellipsis = 88,
  sym_escape_sequence = 89,
  sym__not_escape_sequence = 90,
  aux_sym_format_specifier_token1 = 91,
  sym_type_conversion = 92,
  sym_integer = 93,
  sym_float = 94,
  anon_sym_await = 95,
  sym_true = 96,
  sym_false = 97,
  sym_none = 98,
  sym_comment = 99,
  sym_line_continuation = 100,
  sym__newline = 101,
  sym__indent = 102,
  sym__dedent = 103,
  sym_string_start = 104,
  sym__string_content = 105,
  sym_escape_interpolation = 106,
  sym_string_end = 107,
  sym_module = 108,
  sym__statement = 109,
  sym__simple_statements = 110,
  sym_import_statement = 111,
  sym_import_prefix = 112,
  sym_relative_import = 113,
  sym_future_import_statement = 114,
  sym_import_from_statement = 115,
  sym__import_list = 116,
  sym_aliased_import = 117,
  sym_wildcard_import = 118,
  sym_print_statement = 119,
  sym_chevron = 120,
  sym_assert_statement = 121,
  sym_expression_statement = 122,
  sym_named_expression = 123,
  sym__named_expression_lhs = 124,
  sym_return_statement = 125,
  sym_delete_statement = 126,
  sym_raise_statement = 127,
  sym_pass_statement = 128,
  sym_break_statement = 129,
  sym_continue_statement = 130,
  sym_if_statement = 131,
  sym_elif_clause = 132,
  sym_else_clause = 133,
  sym_match_statement = 134,
  sym__match_block = 135,
  sym_case_clause = 136,
  sym_for_statement = 137,
  sym_while_statement = 138,
  sym_try_statement = 139,
  sym_except_clause = 140,
  sym_except_group_clause = 141,
  sym_finally_clause = 142,
  sym_with_statement = 143,
  sym_with_clause = 144,
  sym_with_item = 145,
  sym_function_definition = 146,
  sym_parameters = 147,
  sym_lambda_parameters = 148,
  sym_list_splat = 149,
  sym_dictionary_splat = 150,
  sym_global_statement = 151,
  sym_nonlocal_statement = 152,
  sym_exec_statement = 153,
  sym_type_alias_statement = 154,
  sym_class_definition = 155,
  sym_type_parameter = 156,
  sym_parenthesized_list_splat = 157,
  sym_argument_list = 158,
  sym_decorated_definition = 159,
  sym_decorator = 160,
  sym_block = 161,
  sym_expression_list = 162,
  sym_dotted_name = 163,
  sym_case_pattern = 164,
  sym__simple_pattern = 165,
  sym__as_pattern = 166,
  sym_union_pattern = 167,
  sym__list_pattern = 168,
  sym__tuple_pattern = 169,
  sym_dict_pattern = 170,
  sym__key_value_pattern = 171,
  sym_keyword_pattern = 172,
  sym_splat_pattern = 173,
  sym_class_pattern = 174,
  sym_complex_pattern = 175,
  sym__parameters = 176,
  sym__patterns = 177,
  sym_parameter = 178,
  sym_pattern = 179,
  sym_tuple_pattern = 180,
  sym_list_pattern = 181,
  sym_default_parameter = 182,
  sym_typed_default_parameter = 183,
  sym_list_splat_pattern = 184,
  sym_dictionary_splat_pattern = 185,
  sym_as_pattern = 186,
  sym__expression_within_for_in_clause = 187,
  sym_expression = 188,
  sym_primary_expression = 189,
  sym_not_operator = 190,
  sym_boolean_operator = 191,
  sym_binary_operator = 192,
  sym_unary_operator = 193,
  sym_comparison_operator = 194,
  sym_lambda = 195,
  sym_lambda_within_for_in_clause = 196,
  sym_assignment = 197,
  sym_augmented_assignment = 198,
  sym_pattern_list = 199,
  sym__right_hand_side = 200,
  sym_yield = 201,
  sym_attribute = 202,
  sym_subscript = 203,
  sym_slice = 204,
  sym_call = 205,
  sym_typed_parameter = 206,
  sym_type = 207,
  sym_splat_type = 208,
  sym_generic_type = 209,
  sym_union_type = 210,
  sym_constrained_type = 211,
  sym_member_type = 212,
  sym_keyword_argument = 213,
  sym_list = 214,
  sym_set = 215,
  sym_tuple = 216,
  sym_dictionary = 217,
  sym_pair = 218,
  sym_list_comprehension = 219,
  sym_dictionary_comprehension = 220,
  sym_set_comprehension = 221,
  sym_generator_expression = 222,
  sym__comprehension_clauses = 223,
  sym_parenthesized_expression = 224,
  sym__collection_elements = 225,
  sym_for_in_clause = 226,
  sym_if_clause = 227,
  sym_conditional_expression = 228,
  sym_concatenated_string = 229,
  sym_string = 230,
  sym_string_content = 231,
  sym_interpolation = 232,
  sym__f_expression = 233,
  sym_format_specifier = 234,
  sym_await = 235,
  sym_positional_separator = 236,
  sym_keyword_separator = 237,
  aux_sym_module_repeat1 = 238,
  aux_sym__simple_statements_repeat1 = 239,
  aux_sym_import_prefix_repeat1 = 240,
  aux_sym__import_list_repeat1 = 241,
  aux_sym_print_statement_repeat1 = 242,
  aux_sym_assert_statement_repeat1 = 243,
  aux_sym_if_statement_repeat1 = 244,
  aux_sym_match_statement_repeat1 = 245,
  aux_sym__match_block_repeat1 = 246,
  aux_sym_case_clause_repeat1 = 247,
  aux_sym_try_statement_repeat1 = 248,
  aux_sym_try_statement_repeat2 = 249,
  aux_sym_with_clause_repeat1 = 250,
  aux_sym_global_statement_repeat1 = 251,
  aux_sym_type_parameter_repeat1 = 252,
  aux_sym_argument_list_repeat1 = 253,
  aux_sym_decorated_definition_repeat1 = 254,
  aux_sym_dotted_name_repeat1 = 255,
  aux_sym_union_pattern_repeat1 = 256,
  aux_sym_dict_pattern_repeat1 = 257,
  aux_sym__parameters_repeat1 = 258,
  aux_sym__patterns_repeat1 = 259,
  aux_sym_comparison_operator_repeat1 = 260,
  aux_sym_subscript_repeat1 = 261,
  aux_sym_dictionary_repeat1 = 262,
  aux_sym__comprehension_clauses_repeat1 = 263,
  aux_sym__collection_elements_repeat1 = 264,
  aux_sym_for_in_clause_repeat1 = 265,
  aux_sym_concatenated_string_repeat1 = 266,
  aux_sym_string_repeat1 = 267,
  aux_sym_string_content_repeat1 = 268,
  aux_sym_format_specifier_repeat1 = 269,
  alias_sym_as_pattern_target = 270,
  alias_sym_format_expression = 271,
  anon_alias_sym_isnot = 272,
  anon_alias_sym_notin = 273,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [anon_sym_SEMI] = ";",
  [anon_sym_import] = "import",
  [anon_sym_DOT] = ".",
  [anon_sym_from] = "from",
  [anon_sym___future__] = "__future__",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_COMMA] = ",",
  [anon_sym_as] = "as",
  [anon_sym_STAR] = "*",
  [anon_sym_print] = "print",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_assert] = "assert",
  [anon_sym_COLON_EQ] = ":=",
  [anon_sym_return] = "return",
  [anon_sym_del] = "del",
  [anon_sym_raise] = "raise",
  [anon_sym_pass] = "pass",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_if] = "if",
  [anon_sym_COLON] = ":",
  [anon_sym_elif] = "elif",
  [anon_sym_else] = "else",
  [anon_sym_match] = "match",
  [anon_sym_case] = "case",
  [anon_sym_async] = "async",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [anon_sym_while] = "while",
  [anon_sym_try] = "try",
  [anon_sym_except] = "except",
  [anon_sym_except_STAR] = "except*",
  [anon_sym_finally] = "finally",
  [anon_sym_with] = "with",
  [anon_sym_def] = "def",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_global] = "global",
  [anon_sym_nonlocal] = "nonlocal",
  [anon_sym_exec] = "exec",
  [anon_sym_type] = "type",
  [anon_sym_EQ] = "=",
  [anon_sym_class] = "class",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_AT] = "@",
  [anon_sym_DASH] = "-",
  [anon_sym__] = "_",
  [anon_sym_PIPE] = "|",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_PLUS] = "+",
  [anon_sym_not] = "not",
  [anon_sym_and] = "and",
  [anon_sym_or] = "or",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_SLASH_SLASH] = "//",
  [anon_sym_AMP] = "&",
  [anon_sym_CARET] = "^",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_TILDE] = "~",
  [anon_sym_LT] = "<",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_GT] = ">",
  [anon_sym_LT_GT] = "<>",
  [anon_sym_is] = "is",
  [anon_sym_lambda] = "lambda",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_AT_EQ] = "@=",
  [anon_sym_SLASH_SLASH_EQ] = "//=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_STAR_STAR_EQ] = "**=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_yield] = "yield",
  [sym_ellipsis] = "ellipsis",
  [sym_escape_sequence] = "escape_sequence",
  [sym__not_escape_sequence] = "_not_escape_sequence",
  [aux_sym_format_specifier_token1] = "format_specifier_token1",
  [sym_type_conversion] = "type_conversion",
  [sym_integer] = "integer",
  [sym_float] = "float",
  [anon_sym_await] = "await",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_none] = "none",
  [sym_comment] = "comment",
  [sym_line_continuation] = "line_continuation",
  [sym__newline] = "_newline",
  [sym__indent] = "_indent",
  [sym__dedent] = "_dedent",
  [sym_string_start] = "string_start",
  [sym__string_content] = "_string_content",
  [sym_escape_interpolation] = "escape_interpolation",
  [sym_string_end] = "string_end",
  [sym_module] = "module",
  [sym__statement] = "_statement",
  [sym__simple_statements] = "_simple_statements",
  [sym_import_statement] = "import_statement",
  [sym_import_prefix] = "import_prefix",
  [sym_relative_import] = "relative_import",
  [sym_future_import_statement] = "future_import_statement",
  [sym_import_from_statement] = "import_from_statement",
  [sym__import_list] = "_import_list",
  [sym_aliased_import] = "aliased_import",
  [sym_wildcard_import] = "wildcard_import",
  [sym_print_statement] = "print_statement",
  [sym_chevron] = "chevron",
  [sym_assert_statement] = "assert_statement",
  [sym_expression_statement] = "expression_statement",
  [sym_named_expression] = "named_expression",
  [sym__named_expression_lhs] = "_named_expression_lhs",
  [sym_return_statement] = "return_statement",
  [sym_delete_statement] = "delete_statement",
  [sym_raise_statement] = "raise_statement",
  [sym_pass_statement] = "pass_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_if_statement] = "if_statement",
  [sym_elif_clause] = "elif_clause",
  [sym_else_clause] = "else_clause",
  [sym_match_statement] = "match_statement",
  [sym__match_block] = "block",
  [sym_case_clause] = "case_clause",
  [sym_for_statement] = "for_statement",
  [sym_while_statement] = "while_statement",
  [sym_try_statement] = "try_statement",
  [sym_except_clause] = "except_clause",
  [sym_except_group_clause] = "except_group_clause",
  [sym_finally_clause] = "finally_clause",
  [sym_with_statement] = "with_statement",
  [sym_with_clause] = "with_clause",
  [sym_with_item] = "with_item",
  [sym_function_definition] = "function_definition",
  [sym_parameters] = "parameters",
  [sym_lambda_parameters] = "lambda_parameters",
  [sym_list_splat] = "list_splat",
  [sym_dictionary_splat] = "dictionary_splat",
  [sym_global_statement] = "global_statement",
  [sym_nonlocal_statement] = "nonlocal_statement",
  [sym_exec_statement] = "exec_statement",
  [sym_type_alias_statement] = "type_alias_statement",
  [sym_class_definition] = "class_definition",
  [sym_type_parameter] = "type_parameter",
  [sym_parenthesized_list_splat] = "parenthesized_list_splat",
  [sym_argument_list] = "argument_list",
  [sym_decorated_definition] = "decorated_definition",
  [sym_decorator] = "decorator",
  [sym_block] = "block",
  [sym_expression_list] = "expression_list",
  [sym_dotted_name] = "dotted_name",
  [sym_case_pattern] = "case_pattern",
  [sym__simple_pattern] = "_simple_pattern",
  [sym__as_pattern] = "as_pattern",
  [sym_union_pattern] = "union_pattern",
  [sym__list_pattern] = "list_pattern",
  [sym__tuple_pattern] = "tuple_pattern",
  [sym_dict_pattern] = "dict_pattern",
  [sym__key_value_pattern] = "_key_value_pattern",
  [sym_keyword_pattern] = "keyword_pattern",
  [sym_splat_pattern] = "splat_pattern",
  [sym_class_pattern] = "class_pattern",
  [sym_complex_pattern] = "complex_pattern",
  [sym__parameters] = "_parameters",
  [sym__patterns] = "_patterns",
  [sym_parameter] = "parameter",
  [sym_pattern] = "pattern",
  [sym_tuple_pattern] = "tuple_pattern",
  [sym_list_pattern] = "list_pattern",
  [sym_default_parameter] = "default_parameter",
  [sym_typed_default_parameter] = "typed_default_parameter",
  [sym_list_splat_pattern] = "list_splat_pattern",
  [sym_dictionary_splat_pattern] = "dictionary_splat_pattern",
  [sym_as_pattern] = "as_pattern",
  [sym__expression_within_for_in_clause] = "_expression_within_for_in_clause",
  [sym_expression] = "expression",
  [sym_primary_expression] = "primary_expression",
  [sym_not_operator] = "not_operator",
  [sym_boolean_operator] = "boolean_operator",
  [sym_binary_operator] = "binary_operator",
  [sym_unary_operator] = "unary_operator",
  [sym_comparison_operator] = "comparison_operator",
  [sym_lambda] = "lambda",
  [sym_lambda_within_for_in_clause] = "lambda",
  [sym_assignment] = "assignment",
  [sym_augmented_assignment] = "augmented_assignment",
  [sym_pattern_list] = "pattern_list",
  [sym__right_hand_side] = "_right_hand_side",
  [sym_yield] = "yield",
  [sym_attribute] = "attribute",
  [sym_subscript] = "subscript",
  [sym_slice] = "slice",
  [sym_call] = "call",
  [sym_typed_parameter] = "typed_parameter",
  [sym_type] = "type",
  [sym_splat_type] = "splat_type",
  [sym_generic_type] = "generic_type",
  [sym_union_type] = "union_type",
  [sym_constrained_type] = "constrained_type",
  [sym_member_type] = "member_type",
  [sym_keyword_argument] = "keyword_argument",
  [sym_list] = "list",
  [sym_set] = "set",
  [sym_tuple] = "tuple",
  [sym_dictionary] = "dictionary",
  [sym_pair] = "pair",
  [sym_list_comprehension] = "list_comprehension",
  [sym_dictionary_comprehension] = "dictionary_comprehension",
  [sym_set_comprehension] = "set_comprehension",
  [sym_generator_expression] = "generator_expression",
  [sym__comprehension_clauses] = "_comprehension_clauses",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym__collection_elements] = "_collection_elements",
  [sym_for_in_clause] = "for_in_clause",
  [sym_if_clause] = "if_clause",
  [sym_conditional_expression] = "conditional_expression",
  [sym_concatenated_string] = "concatenated_string",
  [sym_string] = "string",
  [sym_string_content] = "string_content",
  [sym_interpolation] = "interpolation",
  [sym__f_expression] = "_f_expression",
  [sym_format_specifier] = "format_specifier",
  [sym_await] = "await",
  [sym_positional_separator] = "positional_separator",
  [sym_keyword_separator] = "keyword_separator",
  [aux_sym_module_repeat1] = "module_repeat1",
  [aux_sym__simple_statements_repeat1] = "_simple_statements_repeat1",
  [aux_sym_import_prefix_repeat1] = "import_prefix_repeat1",
  [aux_sym__import_list_repeat1] = "_import_list_repeat1",
  [aux_sym_print_statement_repeat1] = "print_statement_repeat1",
  [aux_sym_assert_statement_repeat1] = "assert_statement_repeat1",
  [aux_sym_if_statement_repeat1] = "if_statement_repeat1",
  [aux_sym_match_statement_repeat1] = "match_statement_repeat1",
  [aux_sym__match_block_repeat1] = "_match_block_repeat1",
  [aux_sym_case_clause_repeat1] = "case_clause_repeat1",
  [aux_sym_try_statement_repeat1] = "try_statement_repeat1",
  [aux_sym_try_statement_repeat2] = "try_statement_repeat2",
  [aux_sym_with_clause_repeat1] = "with_clause_repeat1",
  [aux_sym_global_statement_repeat1] = "global_statement_repeat1",
  [aux_sym_type_parameter_repeat1] = "type_parameter_repeat1",
  [aux_sym_argument_list_repeat1] = "argument_list_repeat1",
  [aux_sym_decorated_definition_repeat1] = "decorated_definition_repeat1",
  [aux_sym_dotted_name_repeat1] = "dotted_name_repeat1",
  [aux_sym_union_pattern_repeat1] = "union_pattern_repeat1",
  [aux_sym_dict_pattern_repeat1] = "dict_pattern_repeat1",
  [aux_sym__parameters_repeat1] = "_parameters_repeat1",
  [aux_sym__patterns_repeat1] = "_patterns_repeat1",
  [aux_sym_comparison_operator_repeat1] = "comparison_operator_repeat1",
  [aux_sym_subscript_repeat1] = "subscript_repeat1",
  [aux_sym_dictionary_repeat1] = "dictionary_repeat1",
  [aux_sym__comprehension_clauses_repeat1] = "_comprehension_clauses_repeat1",
  [aux_sym__collection_elements_repeat1] = "_collection_elements_repeat1",
  [aux_sym_for_in_clause_repeat1] = "for_in_clause_repeat1",
  [aux_sym_concatenated_string_repeat1] = "concatenated_string_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_string_content_repeat1] = "string_content_repeat1",
  [aux_sym_format_specifier_repeat1] = "format_specifier_repeat1",
  [alias_sym_as_pattern_target] = "as_pattern_target",
  [alias_sym_format_expression] = "format_expression",
  [anon_alias_sym_isnot] = "is not",
  [anon_alias_sym_notin] = "not in",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_from] = anon_sym_from,
  [anon_sym___future__] = anon_sym___future__,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_print] = anon_sym_print,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_assert] = anon_sym_assert,
  [anon_sym_COLON_EQ] = anon_sym_COLON_EQ,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_del] = anon_sym_del,
  [anon_sym_raise] = anon_sym_raise,
  [anon_sym_pass] = anon_sym_pass,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_elif] = anon_sym_elif,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_match] = anon_sym_match,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_async] = anon_sym_async,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_except] = anon_sym_except,
  [anon_sym_except_STAR] = anon_sym_except_STAR,
  [anon_sym_finally] = anon_sym_finally,
  [anon_sym_with] = anon_sym_with,
  [anon_sym_def] = anon_sym_def,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_STAR_STAR] = anon_sym_STAR_STAR,
  [anon_sym_global] = anon_sym_global,
  [anon_sym_nonlocal] = anon_sym_nonlocal,
  [anon_sym_exec] = anon_sym_exec,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym__] = anon_sym__,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_not] = anon_sym_not,
  [anon_sym_and] = anon_sym_and,
  [anon_sym_or] = anon_sym_or,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_SLASH_SLASH] = anon_sym_SLASH_SLASH,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_LT_GT] = anon_sym_LT_GT,
  [anon_sym_is] = anon_sym_is,
  [anon_sym_lambda] = anon_sym_lambda,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_AT_EQ] = anon_sym_AT_EQ,
  [anon_sym_SLASH_SLASH_EQ] = anon_sym_SLASH_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_STAR_STAR_EQ] = anon_sym_STAR_STAR_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_yield] = anon_sym_yield,
  [sym_ellipsis] = sym_ellipsis,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym__not_escape_sequence] = sym__not_escape_sequence,
  [aux_sym_format_specifier_token1] = aux_sym_format_specifier_token1,
  [sym_type_conversion] = sym_type_conversion,
  [sym_integer] = sym_integer,
  [sym_float] = sym_float,
  [anon_sym_await] = anon_sym_await,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_none] = sym_none,
  [sym_comment] = sym_comment,
  [sym_line_continuation] = sym_line_continuation,
  [sym__newline] = sym__newline,
  [sym__indent] = sym__indent,
  [sym__dedent] = sym__dedent,
  [sym_string_start] = sym_string_start,
  [sym__string_content] = sym__string_content,
  [sym_escape_interpolation] = sym_escape_interpolation,
  [sym_string_end] = sym_string_end,
  [sym_module] = sym_module,
  [sym__statement] = sym__statement,
  [sym__simple_statements] = sym__simple_statements,
  [sym_import_statement] = sym_import_statement,
  [sym_import_prefix] = sym_import_prefix,
  [sym_relative_import] = sym_relative_import,
  [sym_future_import_statement] = sym_future_import_statement,
  [sym_import_from_statement] = sym_import_from_statement,
  [sym__import_list] = sym__import_list,
  [sym_aliased_import] = sym_aliased_import,
  [sym_wildcard_import] = sym_wildcard_import,
  [sym_print_statement] = sym_print_statement,
  [sym_chevron] = sym_chevron,
  [sym_assert_statement] = sym_assert_statement,
  [sym_expression_statement] = sym_expression_statement,
  [sym_named_expression] = sym_named_expression,
  [sym__named_expression_lhs] = sym__named_expression_lhs,
  [sym_return_statement] = sym_return_statement,
  [sym_delete_statement] = sym_delete_statement,
  [sym_raise_statement] = sym_raise_statement,
  [sym_pass_statement] = sym_pass_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_if_statement] = sym_if_statement,
  [sym_elif_clause] = sym_elif_clause,
  [sym_else_clause] = sym_else_clause,
  [sym_match_statement] = sym_match_statement,
  [sym__match_block] = sym_block,
  [sym_case_clause] = sym_case_clause,
  [sym_for_statement] = sym_for_statement,
  [sym_while_statement] = sym_while_statement,
  [sym_try_statement] = sym_try_statement,
  [sym_except_clause] = sym_except_clause,
  [sym_except_group_clause] = sym_except_group_clause,
  [sym_finally_clause] = sym_finally_clause,
  [sym_with_statement] = sym_with_statement,
  [sym_with_clause] = sym_with_clause,
  [sym_with_item] = sym_with_item,
  [sym_function_definition] = sym_function_definition,
  [sym_parameters] = sym_parameters,
  [sym_lambda_parameters] = sym_lambda_parameters,
  [sym_list_splat] = sym_list_splat,
  [sym_dictionary_splat] = sym_dictionary_splat,
  [sym_global_statement] = sym_global_statement,
  [sym_nonlocal_statement] = sym_nonlocal_statement,
  [sym_exec_statement] = sym_exec_statement,
  [sym_type_alias_statement] = sym_type_alias_statement,
  [sym_class_definition] = sym_class_definition,
  [sym_type_parameter] = sym_type_parameter,
  [sym_parenthesized_list_splat] = sym_parenthesized_list_splat,
  [sym_argument_list] = sym_argument_list,
  [sym_decorated_definition] = sym_decorated_definition,
  [sym_decorator] = sym_decorator,
  [sym_block] = sym_block,
  [sym_expression_list] = sym_expression_list,
  [sym_dotted_name] = sym_dotted_name,
  [sym_case_pattern] = sym_case_pattern,
  [sym__simple_pattern] = sym__simple_pattern,
  [sym__as_pattern] = sym_as_pattern,
  [sym_union_pattern] = sym_union_pattern,
  [sym__list_pattern] = sym_list_pattern,
  [sym__tuple_pattern] = sym_tuple_pattern,
  [sym_dict_pattern] = sym_dict_pattern,
  [sym__key_value_pattern] = sym__key_value_pattern,
  [sym_keyword_pattern] = sym_keyword_pattern,
  [sym_splat_pattern] = sym_splat_pattern,
  [sym_class_pattern] = sym_class_pattern,
  [sym_complex_pattern] = sym_complex_pattern,
  [sym__parameters] = sym__parameters,
  [sym__patterns] = sym__patterns,
  [sym_parameter] = sym_parameter,
  [sym_pattern] = sym_pattern,
  [sym_tuple_pattern] = sym_tuple_pattern,
  [sym_list_pattern] = sym_list_pattern,
  [sym_default_parameter] = sym_default_parameter,
  [sym_typed_default_parameter] = sym_typed_default_parameter,
  [sym_list_splat_pattern] = sym_list_splat_pattern,
  [sym_dictionary_splat_pattern] = sym_dictionary_splat_pattern,
  [sym_as_pattern] = sym_as_pattern,
  [sym__expression_within_for_in_clause] = sym__expression_within_for_in_clause,
  [sym_expression] = sym_expression,
  [sym_primary_expression] = sym_primary_expression,
  [sym_not_operator] = sym_not_operator,
  [sym_boolean_operator] = sym_boolean_operator,
  [sym_binary_operator] = sym_binary_operator,
  [sym_unary_operator] = sym_unary_operator,
  [sym_comparison_operator] = sym_comparison_operator,
  [sym_lambda] = sym_lambda,
  [sym_lambda_within_for_in_clause] = sym_lambda,
  [sym_assignment] = sym_assignment,
  [sym_augmented_assignment] = sym_augmented_assignment,
  [sym_pattern_list] = sym_pattern_list,
  [sym__right_hand_side] = sym__right_hand_side,
  [sym_yield] = sym_yield,
  [sym_attribute] = sym_attribute,
  [sym_subscript] = sym_subscript,
  [sym_slice] = sym_slice,
  [sym_call] = sym_call,
  [sym_typed_parameter] = sym_typed_parameter,
  [sym_type] = sym_type,
  [sym_splat_type] = sym_splat_type,
  [sym_generic_type] = sym_generic_type,
  [sym_union_type] = sym_union_type,
  [sym_constrained_type] = sym_constrained_type,
  [sym_member_type] = sym_member_type,
  [sym_keyword_argument] = sym_keyword_argument,
  [sym_list] = sym_list,
  [sym_set] = sym_set,
  [sym_tuple] = sym_tuple,
  [sym_dictionary] = sym_dictionary,
  [sym_pair] = sym_pair,
  [sym_list_comprehension] = sym_list_comprehension,
  [sym_dictionary_comprehension] = sym_dictionary_comprehension,
  [sym_set_comprehension] = sym_set_comprehension,
  [sym_generator_expression] = sym_generator_expression,
  [sym__comprehension_clauses] = sym__comprehension_clauses,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym__collection_elements] = sym__collection_elements,
  [sym_for_in_clause] = sym_for_in_clause,
  [sym_if_clause] = sym_if_clause,
  [sym_conditional_expression] = sym_conditional_expression,
  [sym_concatenated_string] = sym_concatenated_string,
  [sym_string] = sym_string,
  [sym_string_content] = sym_string_content,
  [sym_interpolation] = sym_interpolation,
  [sym__f_expression] = sym__f_expression,
  [sym_format_specifier] = sym_format_specifier,
  [sym_await] = sym_await,
  [sym_positional_separator] = sym_positional_separator,
  [sym_keyword_separator] = sym_keyword_separator,
  [aux_sym_module_repeat1] = aux_sym_module_repeat1,
  [aux_sym__simple_statements_repeat1] = aux_sym__simple_statements_repeat1,
  [aux_sym_import_prefix_repeat1] = aux_sym_import_prefix_repeat1,
  [aux_sym__import_list_repeat1] = aux_sym__import_list_repeat1,
  [aux_sym_print_statement_repeat1] = aux_sym_print_statement_repeat1,
  [aux_sym_assert_statement_repeat1] = aux_sym_assert_statement_repeat1,
  [aux_sym_if_statement_repeat1] = aux_sym_if_statement_repeat1,
  [aux_sym_match_statement_repeat1] = aux_sym_match_statement_repeat1,
  [aux_sym__match_block_repeat1] = aux_sym__match_block_repeat1,
  [aux_sym_case_clause_repeat1] = aux_sym_case_clause_repeat1,
  [aux_sym_try_statement_repeat1] = aux_sym_try_statement_repeat1,
  [aux_sym_try_statement_repeat2] = aux_sym_try_statement_repeat2,
  [aux_sym_with_clause_repeat1] = aux_sym_with_clause_repeat1,
  [aux_sym_global_statement_repeat1] = aux_sym_global_statement_repeat1,
  [aux_sym_type_parameter_repeat1] = aux_sym_type_parameter_repeat1,
  [aux_sym_argument_list_repeat1] = aux_sym_argument_list_repeat1,
  [aux_sym_decorated_definition_repeat1] = aux_sym_decorated_definition_repeat1,
  [aux_sym_dotted_name_repeat1] = aux_sym_dotted_name_repeat1,
  [aux_sym_union_pattern_repeat1] = aux_sym_union_pattern_repeat1,
  [aux_sym_dict_pattern_repeat1] = aux_sym_dict_pattern_repeat1,
  [aux_sym__parameters_repeat1] = aux_sym__parameters_repeat1,
  [aux_sym__patterns_repeat1] = aux_sym__patterns_repeat1,
  [aux_sym_comparison_operator_repeat1] = aux_sym_comparison_operator_repeat1,
  [aux_sym_subscript_repeat1] = aux_sym_subscript_repeat1,
  [aux_sym_dictionary_repeat1] = aux_sym_dictionary_repeat1,
  [aux_sym__comprehension_clauses_repeat1] = aux_sym__comprehension_clauses_repeat1,
  [aux_sym__collection_elements_repeat1] = aux_sym__collection_elements_repeat1,
  [aux_sym_for_in_clause_repeat1] = aux_sym_for_in_clause_repeat1,
  [aux_sym_concatenated_string_repeat1] = aux_sym_concatenated_string_repeat1,
  [aux_sym_string_repeat1] = aux_sym_string_repeat1,
  [aux_sym_string_content_repeat1] = aux_sym_string_content_repeat1,
  [aux_sym_format_specifier_repeat1] = aux_sym_format_specifier_repeat1,
  [alias_sym_as_pattern_target] = alias_sym_as_pattern_target,
  [alias_sym_format_expression] = alias_sym_format_expression,
  [anon_alias_sym_isnot] = anon_alias_sym_isnot,
  [anon_alias_sym_notin] = anon_alias_sym_notin,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___future__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_print] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_assert] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_del] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_raise] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_pass] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_match] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_except] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_except_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_def] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_global] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nonlocal] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_exec] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_is] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_lambda] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [sym_ellipsis] = {
    .visible = true,
    .named = true,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym__not_escape_sequence] = {
    .visible = false,
    .named = true,
  },
  [aux_sym_format_specifier_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_type_conversion] = {
    .visible = true,
    .named = true,
  },
  [sym_integer] = {
    .visible = true,
    .named = true,
  },
  [sym_float] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = false,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_none] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_line_continuation] = {
    .visible = true,
    .named = true,
  },
  [sym__newline] = {
    .visible = false,
    .named = true,
  },
  [sym__indent] = {
    .visible = false,
    .named = true,
  },
  [sym__dedent] = {
    .visible = false,
    .named = true,
  },
  [sym_string_start] = {
    .visible = true,
    .named = true,
  },
  [sym__string_content] = {
    .visible = false,
    .named = true,
  },
  [sym_escape_interpolation] = {
    .visible = true,
    .named = true,
  },
  [sym_string_end] = {
    .visible = true,
    .named = true,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym__statement] = {
    .visible = false,
    .named = true,
  },
  [sym__simple_statements] = {
    .visible = false,
    .named = true,
  },
  [sym_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_import_prefix] = {
    .visible = true,
    .named = true,
  },
  [sym_relative_import] = {
    .visible = true,
    .named = true,
  },
  [sym_future_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_import_from_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__import_list] = {
    .visible = false,
    .named = true,
  },
  [sym_aliased_import] = {
    .visible = true,
    .named = true,
  },
  [sym_wildcard_import] = {
    .visible = true,
    .named = true,
  },
  [sym_print_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_chevron] = {
    .visible = true,
    .named = true,
  },
  [sym_assert_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_named_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__named_expression_lhs] = {
    .visible = false,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_delete_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_raise_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_pass_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_elif_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_match_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__match_block] = {
    .visible = true,
    .named = true,
  },
  [sym_case_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_except_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_except_group_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_with_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_with_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_with_item] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_list_splat] = {
    .visible = true,
    .named = true,
  },
  [sym_dictionary_splat] = {
    .visible = true,
    .named = true,
  },
  [sym_global_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_nonlocal_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_exec_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_type_alias_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_class_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_list_splat] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_decorated_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator] = {
    .visible = true,
    .named = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_list] = {
    .visible = true,
    .named = true,
  },
  [sym_dotted_name] = {
    .visible = true,
    .named = true,
  },
  [sym_case_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__simple_pattern] = {
    .visible = false,
    .named = true,
  },
  [sym__as_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_union_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__list_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__tuple_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_dict_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__key_value_pattern] = {
    .visible = false,
    .named = true,
  },
  [sym_keyword_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_splat_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_class_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_complex_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__parameters] = {
    .visible = false,
    .named = true,
  },
  [sym__patterns] = {
    .visible = false,
    .named = true,
  },
  [sym_parameter] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_pattern] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_tuple_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_list_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_default_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_typed_default_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_list_splat_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_dictionary_splat_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_as_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__expression_within_for_in_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_primary_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_not_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_boolean_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_comparison_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_within_for_in_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_augmented_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_pattern_list] = {
    .visible = true,
    .named = true,
  },
  [sym__right_hand_side] = {
    .visible = false,
    .named = true,
  },
  [sym_yield] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript] = {
    .visible = true,
    .named = true,
  },
  [sym_slice] = {
    .visible = true,
    .named = true,
  },
  [sym_call] = {
    .visible = true,
    .named = true,
  },
  [sym_typed_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_type] = {
    .visible = true,
    .named = true,
  },
  [sym_splat_type] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_union_type] = {
    .visible = true,
    .named = true,
  },
  [sym_constrained_type] = {
    .visible = true,
    .named = true,
  },
  [sym_member_type] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_list] = {
    .visible = true,
    .named = true,
  },
  [sym_set] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple] = {
    .visible = true,
    .named = true,
  },
  [sym_dictionary] = {
    .visible = true,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_list_comprehension] = {
    .visible = true,
    .named = true,
  },
  [sym_dictionary_comprehension] = {
    .visible = true,
    .named = true,
  },
  [sym_set_comprehension] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__comprehension_clauses] = {
    .visible = false,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__collection_elements] = {
    .visible = false,
    .named = true,
  },
  [sym_for_in_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_if_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_concatenated_string] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_string_content] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolation] = {
    .visible = true,
    .named = true,
  },
  [sym__f_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_format_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_await] = {
    .visible = true,
    .named = true,
  },
  [sym_positional_separator] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_separator] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_module_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__simple_statements_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_import_prefix_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__import_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_print_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_assert_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_match_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__match_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_try_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_try_statement_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_with_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_global_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameter_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_decorated_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_dotted_name_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_union_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_dict_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__patterns_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_comparison_operator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_subscript_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_dictionary_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__comprehension_clauses_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__collection_elements_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_for_in_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_concatenated_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_content_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_format_specifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_as_pattern_target] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_format_expression] = {
    .visible = true,
    .named = true,
  },
  [anon_alias_sym_isnot] = {
    .visible = true,
    .named = false,
  },
  [anon_alias_sym_notin] = {
    .visible = true,
    .named = false,
  },
};

enum ts_field_identifiers {
  field_alias = 1,
  field_alternative = 2,
  field_argument = 3,
  field_arguments = 4,
  field_attribute = 5,
  field_body = 6,
  field_cause = 7,
  field_code = 8,
  field_condition = 9,
  field_consequence = 10,
  field_definition = 11,
  field_expression = 12,
  field_format_specifier = 13,
  field_function = 14,
  field_guard = 15,
  field_key = 16,
  field_left = 17,
  field_module_name = 18,
  field_name = 19,
  field_object = 20,
  field_operator = 21,
  field_operators = 22,
  field_parameters = 23,
  field_return_type = 24,
  field_right = 25,
  field_subject = 26,
  field_subscript = 27,
  field_superclasses = 28,
  field_type = 29,
  field_type_conversion = 30,
  field_type_parameters = 31,
  field_value = 32,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_attribute] = "attribute",
  [field_body] = "body",
  [field_cause] = "cause",
  [field_code] = "code",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_definition] = "definition",
  [field_expression] = "expression",
  [field_format_specifier] = "format_specifier",
  [field_function] = "function",
  [field_guard] = "guard",
  [field_key] = "key",
  [field_left] = "left",
  [field_module_name] = "module_name",
  [field_name] = "name",
  [field_object] = "object",
  [field_operator] = "operator",
  [field_operators] = "operators",
  [field_parameters] = "parameters",
  [field_return_type] = "return_type",
  [field_right] = "right",
  [field_subject] = "subject",
  [field_subscript] = "subscript",
  [field_superclasses] = "superclasses",
  [field_type] = "type",
  [field_type_conversion] = "type_conversion",
  [field_type_parameters] = "type_parameters",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [3] = {.index = 0, .length = 1},
  [4] = {.index = 1, .length = 1},
  [6] = {.index = 2, .length = 1},
  [7] = {.index = 3, .length = 1},
  [8] = {.index = 4, .length = 1},
  [9] = {.index = 5, .length = 2},
  [10] = {.index = 7, .length = 2},
  [11] = {.index = 9, .length = 1},
  [12] = {.index = 10, .length = 1},
  [13] = {.index = 11, .length = 2},
  [14] = {.index = 13, .length = 1},
  [15] = {.index = 14, .length = 2},
  [16] = {.index = 16, .length = 1},
  [17] = {.index = 17, .length = 1},
  [18] = {.index = 18, .length = 2},
  [19] = {.index = 20, .length = 2},
  [20] = {.index = 22, .length = 2},
  [21] = {.index = 24, .length = 3},
  [22] = {.index = 27, .length = 1},
  [23] = {.index = 28, .length = 2},
  [24] = {.index = 30, .length = 1},
  [25] = {.index = 31, .length = 2},
  [26] = {.index = 33, .length = 1},
  [27] = {.index = 34, .length = 1},
  [28] = {.index = 35, .length = 2},
  [29] = {.index = 37, .length = 2},
  [30] = {.index = 39, .length = 1},
  [31] = {.index = 40, .length = 2},
  [32] = {.index = 42, .length = 1},
  [34] = {.index = 43, .length = 1},
  [35] = {.index = 44, .length = 2},
  [36] = {.index = 46, .length = 1},
  [37] = {.index = 47, .length = 2},
  [38] = {.index = 49, .length = 1},
  [39] = {.index = 50, .length = 3},
  [40] = {.index = 53, .length = 2},
  [41] = {.index = 55, .length = 2},
  [42] = {.index = 17, .length = 1},
  [43] = {.index = 57, .length = 1},
  [44] = {.index = 58, .length = 2},
  [45] = {.index = 60, .length = 2},
  [46] = {.index = 62, .length = 1},
  [47] = {.index = 63, .length = 2},
  [48] = {.index = 65, .length = 2},
  [49] = {.index = 67, .length = 2},
  [50] = {.index = 67, .length = 2},
  [52] = {.index = 69, .length = 2},
  [53] = {.index = 71, .length = 2},
  [54] = {.index = 73, .length = 1},
  [55] = {.index = 74, .length = 3},
  [56] = {.index = 77, .length = 3},
  [57] = {.index = 80, .length = 3},
  [58] = {.index = 83, .length = 3},
  [59] = {.index = 86, .length = 4},
  [60] = {.index = 90, .length = 1},
  [61] = {.index = 91, .length = 3},
  [62] = {.index = 94, .length = 3},
  [63] = {.index = 97, .length = 2},
  [64] = {.index = 99, .length = 2},
  [65] = {.index = 101, .length = 3},
  [66] = {.index = 104, .length = 3},
  [67] = {.index = 107, .length = 3},
  [68] = {.index = 110, .length = 3},
  [69] = {.index = 113, .length = 3},
  [70] = {.index = 18, .length = 2},
  [71] = {.index = 116, .length = 1},
  [72] = {.index = 117, .length = 3},
  [73] = {.index = 120, .length = 2},
  [74] = {.index = 122, .length = 2},
  [75] = {.index = 124, .length = 2},
  [76] = {.index = 126, .length = 3},
  [77] = {.index = 129, .length = 1},
  [78] = {.index = 130, .length = 2},
  [79] = {.index = 132, .length = 2},
  [80] = {.index = 134, .length = 4},
  [81] = {.index = 138, .length = 2},
  [82] = {.index = 140, .length = 4},
  [83] = {.index = 144, .length = 4},
  [84] = {.index = 148, .length = 1},
  [85] = {.index = 149, .length = 4},
  [86] = {.index = 153, .length = 2},
  [87] = {.index = 155, .length = 3},
  [88] = {.index = 158, .length = 3},
  [89] = {.index = 161, .length = 4},
  [91] = {.index = 165, .length = 4},
  [92] = {.index = 169, .length = 4},
  [93] = {.index = 173, .length = 4},
  [94] = {.index = 177, .length = 4},
  [95] = {.index = 181, .length = 4},
  [96] = {.index = 185, .length = 3},
  [97] = {.index = 188, .length = 3},
  [98] = {.index = 191, .length = 2},
  [99] = {.index = 193, .length = 3},
  [100] = {.index = 196, .length = 5},
  [101] = {.index = 201, .length = 3},
  [102] = {.index = 204, .length = 4},
  [103] = {.index = 208, .length = 4},
  [104] = {.index = 212, .length = 4},
  [105] = {.index = 216, .length = 4},
  [107] = {.index = 220, .length = 4},
  [108] = {.index = 224, .length = 5},
  [109] = {.index = 229, .length = 5},
  [110] = {.index = 234, .length = 3},
  [111] = {.index = 237, .length = 2},
  [112] = {.index = 239, .length = 1},
  [113] = {.index = 240, .length = 4},
  [114] = {.index = 244, .length = 4},
  [115] = {.index = 248, .length = 4},
  [116] = {.index = 252, .length = 5},
  [117] = {.index = 257, .length = 5},
  [118] = {.index = 262, .length = 5},
  [119] = {.index = 267, .length = 5},
  [120] = {.index = 272, .length = 4},
  [121] = {.index = 276, .length = 4},
  [122] = {.index = 280, .length = 2},
  [123] = {.index = 282, .length = 1},
  [124] = {.index = 283, .length = 2},
  [125] = {.index = 285, .length = 2},
  [126] = {.index = 287, .length = 5},
  [127] = {.index = 292, .length = 5},
  [128] = {.index = 297, .length = 5},
  [130] = {.index = 302, .length = 6},
  [131] = {.index = 308, .length = 2},
  [132] = {.index = 310, .length = 2},
  [133] = {.index = 312, .length = 3},
  [134] = {.index = 315, .length = 1},
  [135] = {.index = 316, .length = 6},
  [136] = {.index = 322, .length = 3},
  [137] = {.index = 325, .length = 2},
  [138] = {.index = 327, .length = 2},
  [139] = {.index = 329, .length = 3},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_name, 1, .inherited = true},
  [1] =
    {field_name, 0},
  [2] =
    {field_argument, 1},
  [3] =
    {field_value, 0},
  [4] =
    {field_code, 1},
  [5] =
    {field_argument, 1},
    {field_operator, 0},
  [7] =
    {field_arguments, 1},
    {field_function, 0},
  [9] =
    {field_operators, 1, .inherited = true},
  [10] =
    {field_definition, 1},
  [11] =
    {field_name, 0},
    {field_name, 1, .inherited = true},
  [13] =
    {field_argument, 2, .inherited = true},
  [14] =
    {field_argument, 1},
    {field_argument, 2, .inherited = true},
  [16] =
    {field_cause, 2},
  [17] =
    {field_body, 2},
  [18] =
    {field_name, 0},
    {field_value, 2},
  [20] =
    {field_left, 0},
    {field_type, 2},
  [22] =
    {field_left, 0},
    {field_right, 2},
  [24] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [27] =
    {field_alias, 2},
  [28] =
    {field_attribute, 2},
    {field_object, 0},
  [30] =
    {field_operators, 0},
  [31] =
    {field_operators, 0, .inherited = true},
    {field_operators, 1, .inherited = true},
  [33] =
    {field_expression, 1},
  [34] =
    {field_name, 1},
  [35] =
    {field_name, 0, .inherited = true},
    {field_name, 1, .inherited = true},
  [37] =
    {field_alias, 2},
    {field_name, 0},
  [39] =
    {field_name, 3, .inherited = true},
  [40] =
    {field_module_name, 1},
    {field_name, 3, .inherited = true},
  [42] =
    {field_module_name, 1},
  [43] =
    {field_body, 1},
  [44] =
    {field_argument, 0, .inherited = true},
    {field_argument, 1, .inherited = true},
  [46] =
    {field_cause, 3},
  [47] =
    {field_condition, 1},
    {field_consequence, 3},
  [49] =
    {field_subject, 1},
  [50] =
    {field_alternative, 3, .inherited = true},
    {field_body, 3},
    {field_subject, 1},
  [53] =
    {field_subject, 0, .inherited = true},
    {field_subject, 1, .inherited = true},
  [55] =
    {field_body, 3},
    {field_condition, 1},
  [57] =
    {field_body, 3},
  [58] =
    {field_body, 3},
    {field_name, 1},
  [60] =
    {field_key, 0},
    {field_value, 2},
  [62] =
    {field_type, 2},
  [63] =
    {field_body, 3},
    {field_parameters, 1},
  [65] =
    {field_subscript, 2},
    {field_value, 0},
  [67] =
    {field_operators, 0},
    {field_operators, 1},
  [69] =
    {field_expression, 1},
    {field_type_conversion, 2},
  [71] =
    {field_expression, 1},
    {field_format_specifier, 2},
  [73] =
    {field_alternative, 0},
  [74] =
    {field_alternative, 4},
    {field_condition, 1},
    {field_consequence, 3},
  [77] =
    {field_alternative, 4, .inherited = true},
    {field_condition, 1},
    {field_consequence, 3},
  [80] =
    {field_condition, 1},
    {field_consequence, 3},
    {field_consequence, 4},
  [83] =
    {field_alternative, 4, .inherited = true},
    {field_body, 4},
    {field_subject, 1},
  [86] =
    {field_alternative, 4, .inherited = true},
    {field_body, 4},
    {field_subject, 1},
    {field_subject, 2, .inherited = true},
  [90] =
    {field_body, 4},
  [91] =
    {field_alternative, 4},
    {field_body, 3},
    {field_condition, 1},
  [94] =
    {field_body, 3},
    {field_body, 4},
    {field_condition, 1},
  [97] =
    {field_body, 2},
    {field_body, 3},
  [99] =
    {field_body, 3},
    {field_body, 4},
  [101] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 2},
  [104] =
    {field_body, 3},
    {field_body, 4},
    {field_name, 1},
  [107] =
    {field_body, 4},
    {field_name, 1},
    {field_type_parameters, 2},
  [110] =
    {field_body, 4},
    {field_name, 1},
    {field_superclasses, 2},
  [113] =
    {field_left, 0},
    {field_right, 4},
    {field_type, 2},
  [116] =
    {field_subscript, 1},
  [117] =
    {field_subscript, 2},
    {field_subscript, 3, .inherited = true},
    {field_value, 0},
  [120] =
    {field_subscript, 0, .inherited = true},
    {field_subscript, 1, .inherited = true},
  [122] =
    {field_expression, 1},
    {field_type_conversion, 3},
  [124] =
    {field_expression, 1},
    {field_format_specifier, 3},
  [126] =
    {field_expression, 1},
    {field_format_specifier, 3},
    {field_type_conversion, 2},
  [129] =
    {field_name, 4, .inherited = true},
  [130] =
    {field_module_name, 1},
    {field_name, 4, .inherited = true},
  [132] =
    {field_left, 1},
    {field_right, 3},
  [134] =
    {field_alternative, 4, .inherited = true},
    {field_alternative, 5},
    {field_condition, 1},
    {field_consequence, 3},
  [138] =
    {field_alternative, 0, .inherited = true},
    {field_alternative, 1, .inherited = true},
  [140] =
    {field_alternative, 5},
    {field_condition, 1},
    {field_consequence, 3},
    {field_consequence, 4},
  [144] =
    {field_alternative, 5, .inherited = true},
    {field_condition, 1},
    {field_consequence, 3},
    {field_consequence, 4},
  [148] =
    {field_alternative, 1, .inherited = true},
  [149] =
    {field_alternative, 5, .inherited = true},
    {field_body, 5},
    {field_subject, 1},
    {field_subject, 2, .inherited = true},
  [153] =
    {field_body, 4},
    {field_body, 5},
  [155] =
    {field_body, 5},
    {field_name, 2},
    {field_parameters, 3},
  [158] =
    {field_body, 5},
    {field_left, 1},
    {field_right, 3},
  [161] =
    {field_alternative, 5},
    {field_body, 3},
    {field_body, 4},
    {field_condition, 1},
  [165] =
    {field_body, 4},
    {field_body, 5},
    {field_name, 1},
    {field_parameters, 2},
  [169] =
    {field_body, 5},
    {field_name, 1},
    {field_parameters, 3},
    {field_type_parameters, 2},
  [173] =
    {field_body, 4},
    {field_body, 5},
    {field_name, 1},
    {field_type_parameters, 2},
  [177] =
    {field_body, 5},
    {field_name, 1},
    {field_superclasses, 3},
    {field_type_parameters, 2},
  [181] =
    {field_body, 4},
    {field_body, 5},
    {field_name, 1},
    {field_superclasses, 2},
  [185] =
    {field_name, 0},
    {field_type, 2},
    {field_value, 4},
  [188] =
    {field_expression, 1},
    {field_format_specifier, 4},
    {field_type_conversion, 3},
  [191] =
    {field_left, 2},
    {field_right, 4},
  [193] =
    {field_left, 1},
    {field_right, 3},
    {field_right, 4},
  [196] =
    {field_alternative, 5, .inherited = true},
    {field_alternative, 6},
    {field_condition, 1},
    {field_consequence, 3},
    {field_consequence, 4},
  [201] =
    {field_body, 6},
    {field_left, 2},
    {field_right, 4},
  [204] =
    {field_body, 5},
    {field_body, 6},
    {field_name, 2},
    {field_parameters, 3},
  [208] =
    {field_body, 6},
    {field_name, 2},
    {field_parameters, 4},
    {field_type_parameters, 3},
  [212] =
    {field_alternative, 6},
    {field_body, 5},
    {field_left, 1},
    {field_right, 3},
  [216] =
    {field_body, 5},
    {field_body, 6},
    {field_left, 1},
    {field_right, 3},
  [220] =
    {field_body, 6},
    {field_name, 1},
    {field_parameters, 2},
    {field_return_type, 4},
  [224] =
    {field_body, 5},
    {field_body, 6},
    {field_name, 1},
    {field_parameters, 3},
    {field_type_parameters, 2},
  [229] =
    {field_body, 5},
    {field_body, 6},
    {field_name, 1},
    {field_superclasses, 3},
    {field_type_parameters, 2},
  [234] =
    {field_left, 2},
    {field_right, 4},
    {field_right, 5},
  [237] =
    {field_key, 1, .inherited = true},
    {field_value, 1, .inherited = true},
  [239] =
    {field_consequence, 3},
  [240] =
    {field_alternative, 7},
    {field_body, 6},
    {field_left, 2},
    {field_right, 4},
  [244] =
    {field_body, 6},
    {field_body, 7},
    {field_left, 2},
    {field_right, 4},
  [248] =
    {field_body, 7},
    {field_name, 2},
    {field_parameters, 3},
    {field_return_type, 5},
  [252] =
    {field_body, 6},
    {field_body, 7},
    {field_name, 2},
    {field_parameters, 4},
    {field_type_parameters, 3},
  [257] =
    {field_alternative, 7},
    {field_body, 5},
    {field_body, 6},
    {field_left, 1},
    {field_right, 3},
  [262] =
    {field_body, 6},
    {field_body, 7},
    {field_name, 1},
    {field_parameters, 2},
    {field_return_type, 4},
  [267] =
    {field_body, 7},
    {field_name, 1},
    {field_parameters, 3},
    {field_return_type, 5},
    {field_type_parameters, 2},
  [272] =
    {field_key, 1, .inherited = true},
    {field_key, 2, .inherited = true},
    {field_value, 1, .inherited = true},
    {field_value, 2, .inherited = true},
  [276] =
    {field_key, 0, .inherited = true},
    {field_key, 1, .inherited = true},
    {field_value, 0, .inherited = true},
    {field_value, 1, .inherited = true},
  [280] =
    {field_key, 2, .inherited = true},
    {field_value, 2, .inherited = true},
  [282] =
    {field_consequence, 4},
  [283] =
    {field_consequence, 3},
    {field_consequence, 4},
  [285] =
    {field_consequence, 4},
    {field_guard, 2},
  [287] =
    {field_alternative, 8},
    {field_body, 6},
    {field_body, 7},
    {field_left, 2},
    {field_right, 4},
  [292] =
    {field_body, 7},
    {field_body, 8},
    {field_name, 2},
    {field_parameters, 3},
    {field_return_type, 5},
  [297] =
    {field_body, 8},
    {field_name, 2},
    {field_parameters, 4},
    {field_return_type, 6},
    {field_type_parameters, 3},
  [302] =
    {field_body, 7},
    {field_body, 8},
    {field_name, 1},
    {field_parameters, 3},
    {field_return_type, 5},
    {field_type_parameters, 2},
  [308] =
    {field_consequence, 4},
    {field_consequence, 5},
  [310] =
    {field_consequence, 5},
    {field_guard, 3},
  [312] =
    {field_consequence, 4},
    {field_consequence, 5},
    {field_guard, 2},
  [315] =
    {field_consequence, 5},
  [316] =
    {field_body, 8},
    {field_body, 9},
    {field_name, 2},
    {field_parameters, 4},
    {field_return_type, 6},
    {field_type_parameters, 3},
  [322] =
    {field_consequence, 5},
    {field_consequence, 6},
    {field_guard, 3},
  [325] =
    {field_consequence, 5},
    {field_consequence, 6},
  [327] =
    {field_consequence, 6},
    {field_guard, 4},
  [329] =
    {field_consequence, 6},
    {field_consequence, 7},
    {field_guard, 4},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = sym_identifier,
  },
  [2] = {
    [0] = sym_list_splat,
  },
  [5] = {
    [1] = sym_identifier,
  },
  [22] = {
    [2] = alias_sym_as_pattern_target,
  },
  [33] = {
    [1] = sym_parenthesized_expression,
  },
  [37] = {
    [3] = sym_block,
  },
  [41] = {
    [3] = sym_block,
  },
  [42] = {
    [2] = sym_block,
  },
  [43] = {
    [3] = sym_block,
  },
  [44] = {
    [3] = sym_block,
  },
  [49] = {
    [0] = anon_alias_sym_notin,
    [1] = anon_alias_sym_notin,
  },
  [50] = {
    [0] = anon_alias_sym_isnot,
    [1] = anon_alias_sym_isnot,
  },
  [51] = {
    [0] = alias_sym_format_expression,
  },
  [55] = {
    [3] = sym_block,
  },
  [56] = {
    [3] = sym_block,
  },
  [60] = {
    [4] = sym_block,
  },
  [61] = {
    [3] = sym_block,
  },
  [65] = {
    [4] = sym_block,
  },
  [67] = {
    [4] = sym_block,
  },
  [68] = {
    [4] = sym_block,
  },
  [70] = {
    [0] = sym_identifier,
  },
  [80] = {
    [3] = sym_block,
  },
  [87] = {
    [5] = sym_block,
  },
  [88] = {
    [5] = sym_block,
  },
  [90] = {
    [2] = sym_block,
  },
  [92] = {
    [5] = sym_block,
  },
  [94] = {
    [5] = sym_block,
  },
  [101] = {
    [6] = sym_block,
  },
  [103] = {
    [6] = sym_block,
  },
  [104] = {
    [5] = sym_block,
  },
  [106] = {
    [3] = sym_block,
  },
  [107] = {
    [6] = sym_block,
  },
  [112] = {
    [3] = sym_block,
  },
  [113] = {
    [6] = sym_block,
  },
  [115] = {
    [7] = sym_block,
  },
  [119] = {
    [7] = sym_block,
  },
  [123] = {
    [4] = sym_block,
  },
  [125] = {
    [4] = sym_block,
  },
  [128] = {
    [8] = sym_block,
  },
  [129] = {
    [5] = sym_block,
  },
  [132] = {
    [5] = sym_block,
  },
  [134] = {
    [5] = sym_block,
  },
  [138] = {
    [6] = sym_block,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym__simple_statements, 2,
    sym__simple_statements,
    sym_block,
  sym_parenthesized_list_splat, 2,
    sym_parenthesized_list_splat,
    sym_parenthesized_expression,
  sym_list_splat_pattern, 2,
    sym_list_splat_pattern,
    sym_list_splat,
  sym_expression, 2,
    sym_expression,
    alias_sym_as_pattern_target,
  sym_interpolation, 2,
    sym_interpolation,
    alias_sym_format_expression,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 5,
  [6] = 6,
  [7] = 7,
  [8] = 8,
  [9] = 9,
  [10] = 10,
  [11] = 11,
  [12] = 2,
  [13] = 13,
  [14] = 3,
  [15] = 15,
  [16] = 16,
  [17] = 17,
  [18] = 18,
  [19] = 19,
  [20] = 7,
  [21] = 21,
  [22] = 22,
  [23] = 23,
  [24] = 5,
  [25] = 25,
  [26] = 8,
  [27] = 27,
  [28] = 16,
  [29] = 11,
  [30] = 30,
  [31] = 6,
  [32] = 19,
  [33] = 33,
  [34] = 10,
  [35] = 23,
  [36] = 22,
  [37] = 17,
  [38] = 21,
  [39] = 39,
  [40] = 40,
  [41] = 41,
  [42] = 25,
  [43] = 43,
  [44] = 44,
  [45] = 45,
  [46] = 44,
  [47] = 47,
  [48] = 48,
  [49] = 13,
  [50] = 15,
  [51] = 51,
  [52] = 52,
  [53] = 52,
  [54] = 48,
  [55] = 18,
  [56] = 51,
  [57] = 4,
  [58] = 47,
  [59] = 30,
  [60] = 40,
  [61] = 43,
  [62] = 62,
  [63] = 62,
  [64] = 64,
  [65] = 62,
  [66] = 66,
  [67] = 62,
  [68] = 62,
  [69] = 62,
  [70] = 62,
  [71] = 64,
  [72] = 62,
  [73] = 73,
  [74] = 73,
  [75] = 75,
  [76] = 75,
  [77] = 77,
  [78] = 78,
  [79] = 78,
  [80] = 77,
  [81] = 81,
  [82] = 81,
  [83] = 83,
  [84] = 83,
  [85] = 85,
  [86] = 85,
  [87] = 87,
  [88] = 88,
  [89] = 89,
  [90] = 90,
  [91] = 91,
  [92] = 92,
  [93] = 93,
  [94] = 92,
  [95] = 90,
  [96] = 96,
  [97] = 91,
  [98] = 98,
  [99] = 87,
  [100] = 100,
  [101] = 101,
  [102] = 102,
  [103] = 103,
  [104] = 104,
  [105] = 105,
  [106] = 106,
  [107] = 88,
  [108] = 108,
  [109] = 106,
  [110] = 96,
  [111] = 104,
  [112] = 112,
  [113] = 113,
  [114] = 114,
  [115] = 101,
  [116] = 116,
  [117] = 100,
  [118] = 118,
  [119] = 118,
  [120] = 108,
  [121] = 113,
  [122] = 122,
  [123] = 123,
  [124] = 116,
  [125] = 125,
  [126] = 122,
  [127] = 102,
  [128] = 93,
  [129] = 123,
  [130] = 130,
  [131] = 98,
  [132] = 132,
  [133] = 114,
  [134] = 112,
  [135] = 135,
  [136] = 89,
  [137] = 137,
  [138] = 138,
  [139] = 138,
  [140] = 137,
  [141] = 137,
  [142] = 138,
  [143] = 137,
  [144] = 137,
  [145] = 138,
  [146] = 137,
  [147] = 138,
  [148] = 137,
  [149] = 137,
  [150] = 138,
  [151] = 138,
  [152] = 138,
  [153] = 153,
  [154] = 154,
  [155] = 154,
  [156] = 156,
  [157] = 157,
  [158] = 158,
  [159] = 156,
  [160] = 154,
  [161] = 156,
  [162] = 157,
  [163] = 157,
  [164] = 157,
  [165] = 165,
  [166] = 166,
  [167] = 158,
  [168] = 156,
  [169] = 157,
  [170] = 158,
  [171] = 154,
  [172] = 158,
  [173] = 156,
  [174] = 174,
  [175] = 157,
  [176] = 166,
  [177] = 165,
  [178] = 156,
  [179] = 157,
  [180] = 157,
  [181] = 158,
  [182] = 166,
  [183] = 154,
  [184] = 158,
  [185] = 158,
  [186] = 158,
  [187] = 174,
  [188] = 156,
  [189] = 189,
  [190] = 189,
  [191] = 191,
  [192] = 189,
  [193] = 189,
  [194] = 191,
  [195] = 195,
  [196] = 195,
  [197] = 197,
  [198] = 195,
  [199] = 191,
  [200] = 191,
  [201] = 189,
  [202] = 195,
  [203] = 203,
  [204] = 189,
  [205] = 191,
  [206] = 197,
  [207] = 207,
  [208] = 195,
  [209] = 189,
  [210] = 195,
  [211] = 195,
  [212] = 191,
  [213] = 195,
  [214] = 195,
  [215] = 191,
  [216] = 216,
  [217] = 195,
  [218] = 189,
  [219] = 189,
  [220] = 191,
  [221] = 195,
  [222] = 222,
  [223] = 223,
  [224] = 224,
  [225] = 224,
  [226] = 226,
  [227] = 227,
  [228] = 228,
  [229] = 229,
  [230] = 226,
  [231] = 231,
  [232] = 232,
  [233] = 226,
  [234] = 222,
  [235] = 235,
  [236] = 226,
  [237] = 237,
  [238] = 231,
  [239] = 239,
  [240] = 226,
  [241] = 229,
  [242] = 226,
  [243] = 239,
  [244] = 228,
  [245] = 245,
  [246] = 223,
  [247] = 237,
  [248] = 226,
  [249] = 228,
  [250] = 229,
  [251] = 251,
  [252] = 252,
  [253] = 232,
  [254] = 228,
  [255] = 229,
  [256] = 256,
  [257] = 257,
  [258] = 258,
  [259] = 239,
  [260] = 239,
  [261] = 235,
  [262] = 226,
  [263] = 263,
  [264] = 264,
  [265] = 265,
  [266] = 266,
  [267] = 267,
  [268] = 266,
  [269] = 265,
  [270] = 270,
  [271] = 271,
  [272] = 271,
  [273] = 267,
  [274] = 265,
  [275] = 265,
  [276] = 264,
  [277] = 265,
  [278] = 278,
  [279] = 271,
  [280] = 271,
  [281] = 271,
  [282] = 278,
  [283] = 265,
  [284] = 278,
  [285] = 264,
  [286] = 264,
  [287] = 278,
  [288] = 267,
  [289] = 278,
  [290] = 271,
  [291] = 266,
  [292] = 266,
  [293] = 270,
  [294] = 270,
  [295] = 264,
  [296] = 278,
  [297] = 267,
  [298] = 266,
  [299] = 278,
  [300] = 271,
  [301] = 265,
  [302] = 270,
  [303] = 264,
  [304] = 278,
  [305] = 267,
  [306] = 270,
  [307] = 266,
  [308] = 270,
  [309] = 266,
  [310] = 267,
  [311] = 264,
  [312] = 270,
  [313] = 266,
  [314] = 264,
  [315] = 270,
  [316] = 271,
  [317] = 265,
  [318] = 318,
  [319] = 319,
  [320] = 318,
  [321] = 321,
  [322] = 319,
  [323] = 318,
  [324] = 324,
  [325] = 325,
  [326] = 326,
  [327] = 327,
  [328] = 319,
  [329] = 321,
  [330] = 321,
  [331] = 331,
  [332] = 325,
  [333] = 325,
  [334] = 326,
  [335] = 327,
  [336] = 326,
  [337] = 327,
  [338] = 338,
  [339] = 174,
  [340] = 340,
  [341] = 341,
  [342] = 341,
  [343] = 341,
  [344] = 258,
  [345] = 340,
  [346] = 340,
  [347] = 340,
  [348] = 340,
  [349] = 349,
  [350] = 349,
  [351] = 341,
  [352] = 340,
  [353] = 340,
  [354] = 341,
  [355] = 341,
  [356] = 341,
  [357] = 258,
  [358] = 341,
  [359] = 258,
  [360] = 360,
  [361] = 340,
  [362] = 349,
  [363] = 363,
  [364] = 363,
  [365] = 365,
  [366] = 366,
  [367] = 363,
  [368] = 368,
  [369] = 366,
  [370] = 365,
  [371] = 365,
  [372] = 365,
  [373] = 373,
  [374] = 365,
  [375] = 375,
  [376] = 376,
  [377] = 365,
  [378] = 366,
  [379] = 363,
  [380] = 366,
  [381] = 365,
  [382] = 324,
  [383] = 363,
  [384] = 366,
  [385] = 363,
  [386] = 338,
  [387] = 363,
  [388] = 388,
  [389] = 366,
  [390] = 366,
  [391] = 366,
  [392] = 363,
  [393] = 365,
  [394] = 363,
  [395] = 366,
  [396] = 365,
  [397] = 156,
  [398] = 363,
  [399] = 366,
  [400] = 365,
  [401] = 401,
  [402] = 324,
  [403] = 403,
  [404] = 156,
  [405] = 405,
  [406] = 406,
  [407] = 405,
  [408] = 403,
  [409] = 409,
  [410] = 403,
  [411] = 174,
  [412] = 412,
  [413] = 413,
  [414] = 414,
  [415] = 338,
  [416] = 412,
  [417] = 417,
  [418] = 418,
  [419] = 338,
  [420] = 420,
  [421] = 405,
  [422] = 401,
  [423] = 423,
  [424] = 424,
  [425] = 425,
  [426] = 324,
  [427] = 427,
  [428] = 428,
  [429] = 401,
  [430] = 427,
  [431] = 420,
  [432] = 373,
  [433] = 433,
  [434] = 418,
  [435] = 435,
  [436] = 436,
  [437] = 427,
  [438] = 427,
  [439] = 427,
  [440] = 427,
  [441] = 174,
  [442] = 427,
  [443] = 435,
  [444] = 435,
  [445] = 427,
  [446] = 446,
  [447] = 427,
  [448] = 448,
  [449] = 174,
  [450] = 450,
  [451] = 412,
  [452] = 427,
  [453] = 453,
  [454] = 454,
  [455] = 455,
  [456] = 454,
  [457] = 457,
  [458] = 458,
  [459] = 453,
  [460] = 460,
  [461] = 455,
  [462] = 462,
  [463] = 457,
  [464] = 464,
  [465] = 338,
  [466] = 324,
  [467] = 467,
  [468] = 460,
  [469] = 462,
  [470] = 464,
  [471] = 458,
  [472] = 472,
  [473] = 473,
  [474] = 474,
  [475] = 475,
  [476] = 476,
  [477] = 477,
  [478] = 478,
  [479] = 479,
  [480] = 473,
  [481] = 481,
  [482] = 482,
  [483] = 483,
  [484] = 474,
  [485] = 485,
  [486] = 486,
  [487] = 487,
  [488] = 477,
  [489] = 489,
  [490] = 472,
  [491] = 491,
  [492] = 487,
  [493] = 479,
  [494] = 481,
  [495] = 495,
  [496] = 496,
  [497] = 497,
  [498] = 498,
  [499] = 472,
  [500] = 491,
  [501] = 501,
  [502] = 489,
  [503] = 491,
  [504] = 504,
  [505] = 472,
  [506] = 482,
  [507] = 507,
  [508] = 472,
  [509] = 481,
  [510] = 497,
  [511] = 483,
  [512] = 512,
  [513] = 496,
  [514] = 504,
  [515] = 477,
  [516] = 516,
  [517] = 474,
  [518] = 518,
  [519] = 477,
  [520] = 478,
  [521] = 507,
  [522] = 487,
  [523] = 523,
  [524] = 486,
  [525] = 482,
  [526] = 472,
  [527] = 477,
  [528] = 528,
  [529] = 529,
  [530] = 482,
  [531] = 531,
  [532] = 532,
  [533] = 474,
  [534] = 485,
  [535] = 479,
  [536] = 496,
  [537] = 479,
  [538] = 473,
  [539] = 473,
  [540] = 477,
  [541] = 483,
  [542] = 474,
  [543] = 497,
  [544] = 478,
  [545] = 532,
  [546] = 546,
  [547] = 547,
  [548] = 548,
  [549] = 473,
  [550] = 482,
  [551] = 528,
  [552] = 552,
  [553] = 553,
  [554] = 529,
  [555] = 497,
  [556] = 483,
  [557] = 548,
  [558] = 558,
  [559] = 491,
  [560] = 478,
  [561] = 523,
  [562] = 477,
  [563] = 496,
  [564] = 487,
  [565] = 497,
  [566] = 479,
  [567] = 474,
  [568] = 472,
  [569] = 552,
  [570] = 487,
  [571] = 518,
  [572] = 553,
  [573] = 496,
  [574] = 496,
  [575] = 477,
  [576] = 496,
  [577] = 473,
  [578] = 473,
  [579] = 474,
  [580] = 479,
  [581] = 482,
  [582] = 497,
  [583] = 478,
  [584] = 478,
  [585] = 585,
  [586] = 479,
  [587] = 472,
  [588] = 482,
  [589] = 491,
  [590] = 497,
  [591] = 481,
  [592] = 496,
  [593] = 478,
  [594] = 482,
  [595] = 491,
  [596] = 474,
  [597] = 479,
  [598] = 497,
  [599] = 478,
  [600] = 473,
  [601] = 601,
  [602] = 602,
  [603] = 603,
  [604] = 604,
  [605] = 605,
  [606] = 606,
  [607] = 604,
  [608] = 605,
  [609] = 609,
  [610] = 609,
  [611] = 611,
  [612] = 612,
  [613] = 613,
  [614] = 606,
  [615] = 613,
  [616] = 611,
  [617] = 602,
  [618] = 618,
  [619] = 619,
  [620] = 620,
  [621] = 621,
  [622] = 622,
  [623] = 623,
  [624] = 624,
  [625] = 625,
  [626] = 626,
  [627] = 627,
  [628] = 628,
  [629] = 621,
  [630] = 630,
  [631] = 627,
  [632] = 632,
  [633] = 619,
  [634] = 626,
  [635] = 635,
  [636] = 636,
  [637] = 637,
  [638] = 632,
  [639] = 639,
  [640] = 640,
  [641] = 641,
  [642] = 642,
  [643] = 642,
  [644] = 644,
  [645] = 645,
  [646] = 646,
  [647] = 647,
  [648] = 648,
  [649] = 649,
  [650] = 648,
  [651] = 223,
  [652] = 642,
  [653] = 645,
  [654] = 654,
  [655] = 647,
  [656] = 644,
  [657] = 657,
  [658] = 658,
  [659] = 641,
  [660] = 646,
  [661] = 641,
  [662] = 641,
  [663] = 642,
  [664] = 654,
  [665] = 649,
  [666] = 639,
  [667] = 642,
  [668] = 649,
  [669] = 640,
  [670] = 654,
  [671] = 671,
  [672] = 649,
  [673] = 649,
  [674] = 639,
  [675] = 654,
  [676] = 639,
  [677] = 222,
  [678] = 654,
  [679] = 679,
  [680] = 658,
  [681] = 639,
  [682] = 649,
  [683] = 671,
  [684] = 654,
  [685] = 657,
  [686] = 679,
  [687] = 641,
  [688] = 642,
  [689] = 639,
  [690] = 641,
  [691] = 691,
  [692] = 692,
  [693] = 693,
  [694] = 694,
  [695] = 691,
  [696] = 692,
  [697] = 697,
  [698] = 698,
  [699] = 699,
  [700] = 700,
  [701] = 701,
  [702] = 701,
  [703] = 698,
  [704] = 704,
  [705] = 699,
  [706] = 697,
  [707] = 694,
  [708] = 704,
  [709] = 709,
  [710] = 693,
  [711] = 709,
  [712] = 700,
  [713] = 713,
  [714] = 714,
  [715] = 715,
  [716] = 713,
  [717] = 715,
  [718] = 714,
  [719] = 719,
  [720] = 720,
  [721] = 721,
  [722] = 722,
  [723] = 723,
  [724] = 724,
  [725] = 725,
  [726] = 726,
  [727] = 727,
  [728] = 728,
  [729] = 720,
  [730] = 730,
  [731] = 731,
  [732] = 732,
  [733] = 722,
  [734] = 734,
  [735] = 735,
  [736] = 736,
  [737] = 737,
  [738] = 738,
  [739] = 739,
  [740] = 740,
  [741] = 741,
  [742] = 742,
  [743] = 743,
  [744] = 730,
  [745] = 743,
  [746] = 742,
  [747] = 741,
  [748] = 222,
  [749] = 749,
  [750] = 725,
  [751] = 726,
  [752] = 752,
  [753] = 724,
  [754] = 754,
  [755] = 725,
  [756] = 756,
  [757] = 757,
  [758] = 758,
  [759] = 759,
  [760] = 760,
  [761] = 761,
  [762] = 762,
  [763] = 763,
  [764] = 764,
  [765] = 734,
  [766] = 735,
  [767] = 767,
  [768] = 737,
  [769] = 769,
  [770] = 738,
  [771] = 771,
  [772] = 736,
  [773] = 739,
  [774] = 769,
  [775] = 740,
  [776] = 749,
  [777] = 752,
  [778] = 756,
  [779] = 757,
  [780] = 780,
  [781] = 781,
  [782] = 758,
  [783] = 783,
  [784] = 784,
  [785] = 785,
  [786] = 786,
  [787] = 784,
  [788] = 788,
  [789] = 789,
  [790] = 790,
  [791] = 791,
  [792] = 785,
  [793] = 771,
  [794] = 794,
  [795] = 790,
  [796] = 789,
  [797] = 786,
  [798] = 798,
  [799] = 799,
  [800] = 800,
  [801] = 223,
  [802] = 802,
  [803] = 783,
  [804] = 804,
  [805] = 805,
  [806] = 806,
  [807] = 807,
  [808] = 764,
  [809] = 763,
  [810] = 719,
  [811] = 762,
  [812] = 761,
  [813] = 794,
  [814] = 760,
  [815] = 788,
  [816] = 759,
  [817] = 817,
  [818] = 780,
  [819] = 819,
  [820] = 819,
  [821] = 817,
  [822] = 798,
  [823] = 767,
  [824] = 799,
  [825] = 807,
  [826] = 791,
  [827] = 800,
  [828] = 754,
  [829] = 829,
  [830] = 806,
  [831] = 802,
  [832] = 728,
  [833] = 805,
  [834] = 781,
  [835] = 727,
  [836] = 726,
  [837] = 721,
  [838] = 804,
  [839] = 829,
  [840] = 723,
  [841] = 732,
  [842] = 731,
  [843] = 843,
  [844] = 843,
  [845] = 843,
  [846] = 843,
  [847] = 843,
  [848] = 843,
  [849] = 849,
  [850] = 849,
  [851] = 851,
  [852] = 851,
  [853] = 851,
  [854] = 851,
  [855] = 851,
  [856] = 851,
  [857] = 851,
  [858] = 851,
  [859] = 859,
  [860] = 860,
  [861] = 861,
  [862] = 862,
  [863] = 863,
  [864] = 864,
  [865] = 865,
  [866] = 859,
  [867] = 867,
  [868] = 868,
  [869] = 864,
  [870] = 870,
  [871] = 859,
  [872] = 872,
  [873] = 860,
  [874] = 864,
  [875] = 875,
  [876] = 862,
  [877] = 864,
  [878] = 863,
  [879] = 865,
  [880] = 880,
  [881] = 861,
  [882] = 868,
  [883] = 860,
  [884] = 870,
  [885] = 859,
  [886] = 872,
  [887] = 868,
  [888] = 875,
  [889] = 870,
  [890] = 859,
  [891] = 872,
  [892] = 860,
  [893] = 880,
  [894] = 865,
  [895] = 863,
  [896] = 862,
  [897] = 875,
  [898] = 872,
  [899] = 859,
  [900] = 870,
  [901] = 875,
  [902] = 862,
  [903] = 864,
  [904] = 863,
  [905] = 862,
  [906] = 864,
  [907] = 907,
  [908] = 870,
  [909] = 863,
  [910] = 870,
  [911] = 865,
  [912] = 860,
  [913] = 865,
  [914] = 868,
  [915] = 861,
  [916] = 860,
  [917] = 870,
  [918] = 880,
  [919] = 859,
  [920] = 864,
  [921] = 861,
  [922] = 880,
  [923] = 860,
  [924] = 868,
  [925] = 864,
  [926] = 860,
  [927] = 864,
  [928] = 868,
  [929] = 872,
  [930] = 859,
  [931] = 875,
  [932] = 861,
  [933] = 867,
  [934] = 861,
  [935] = 872,
  [936] = 864,
  [937] = 867,
  [938] = 864,
  [939] = 864,
  [940] = 875,
  [941] = 862,
  [942] = 867,
  [943] = 880,
  [944] = 865,
  [945] = 863,
  [946] = 862,
  [947] = 875,
  [948] = 872,
  [949] = 907,
  [950] = 861,
  [951] = 872,
  [952] = 870,
  [953] = 868,
  [954] = 861,
  [955] = 880,
  [956] = 863,
  [957] = 867,
  [958] = 865,
  [959] = 863,
  [960] = 868,
  [961] = 880,
  [962] = 862,
  [963] = 864,
  [964] = 880,
  [965] = 875,
  [966] = 865,
  [967] = 967,
  [968] = 968,
  [969] = 969,
  [970] = 970,
  [971] = 971,
  [972] = 969,
  [973] = 973,
  [974] = 974,
  [975] = 975,
  [976] = 976,
  [977] = 968,
  [978] = 967,
  [979] = 969,
  [980] = 980,
  [981] = 970,
  [982] = 982,
  [983] = 983,
  [984] = 984,
  [985] = 985,
  [986] = 986,
  [987] = 968,
  [988] = 988,
  [989] = 967,
  [990] = 970,
  [991] = 970,
  [992] = 967,
  [993] = 970,
  [994] = 967,
  [995] = 967,
  [996] = 971,
  [997] = 970,
  [998] = 969,
  [999] = 999,
  [1000] = 1000,
  [1001] = 1001,
  [1002] = 984,
  [1003] = 967,
  [1004] = 986,
  [1005] = 1005,
  [1006] = 969,
  [1007] = 968,
  [1008] = 969,
  [1009] = 968,
  [1010] = 969,
  [1011] = 968,
  [1012] = 637,
  [1013] = 976,
  [1014] = 635,
  [1015] = 630,
  [1016] = 985,
  [1017] = 618,
  [1018] = 628,
  [1019] = 980,
  [1020] = 974,
  [1021] = 973,
  [1022] = 988,
  [1023] = 636,
  [1024] = 1024,
  [1025] = 982,
  [1026] = 983,
  [1027] = 983,
  [1028] = 984,
  [1029] = 982,
  [1030] = 985,
  [1031] = 969,
  [1032] = 976,
  [1033] = 975,
  [1034] = 968,
  [1035] = 986,
  [1036] = 971,
  [1037] = 624,
  [1038] = 975,
  [1039] = 970,
  [1040] = 988,
  [1041] = 980,
  [1042] = 973,
  [1043] = 974,
  [1044] = 1001,
  [1045] = 618,
  [1046] = 624,
  [1047] = 1047,
  [1048] = 971,
  [1049] = 986,
  [1050] = 1050,
  [1051] = 976,
  [1052] = 985,
  [1053] = 984,
  [1054] = 1054,
  [1055] = 983,
  [1056] = 974,
  [1057] = 973,
  [1058] = 1058,
  [1059] = 982,
  [1060] = 1060,
  [1061] = 1061,
  [1062] = 1062,
  [1063] = 1063,
  [1064] = 1064,
  [1065] = 999,
  [1066] = 975,
  [1067] = 1067,
  [1068] = 975,
  [1069] = 982,
  [1070] = 983,
  [1071] = 984,
  [1072] = 985,
  [1073] = 976,
  [1074] = 986,
  [1075] = 971,
  [1076] = 1024,
  [1077] = 1077,
  [1078] = 980,
  [1079] = 975,
  [1080] = 974,
  [1081] = 982,
  [1082] = 988,
  [1083] = 969,
  [1084] = 636,
  [1085] = 973,
  [1086] = 973,
  [1087] = 974,
  [1088] = 983,
  [1089] = 628,
  [1090] = 630,
  [1091] = 1005,
  [1092] = 1092,
  [1093] = 1001,
  [1094] = 1094,
  [1095] = 1000,
  [1096] = 980,
  [1097] = 1097,
  [1098] = 1000,
  [1099] = 635,
  [1100] = 622,
  [1101] = 623,
  [1102] = 637,
  [1103] = 988,
  [1104] = 975,
  [1105] = 982,
  [1106] = 612,
  [1107] = 613,
  [1108] = 980,
  [1109] = 983,
  [1110] = 984,
  [1111] = 1111,
  [1112] = 985,
  [1113] = 1113,
  [1114] = 1024,
  [1115] = 976,
  [1116] = 986,
  [1117] = 971,
  [1118] = 984,
  [1119] = 1005,
  [1120] = 985,
  [1121] = 1121,
  [1122] = 1122,
  [1123] = 1123,
  [1124] = 988,
  [1125] = 1125,
  [1126] = 1126,
  [1127] = 603,
  [1128] = 1128,
  [1129] = 999,
  [1130] = 976,
  [1131] = 986,
  [1132] = 971,
  [1133] = 1133,
  [1134] = 1134,
  [1135] = 620,
  [1136] = 1136,
  [1137] = 1137,
  [1138] = 1138,
  [1139] = 1139,
  [1140] = 1140,
  [1141] = 974,
  [1142] = 973,
  [1143] = 1143,
  [1144] = 1113,
  [1145] = 988,
  [1146] = 980,
  [1147] = 1147,
  [1148] = 1148,
  [1149] = 967,
  [1150] = 970,
  [1151] = 1151,
  [1152] = 968,
  [1153] = 983,
  [1154] = 624,
  [1155] = 1047,
  [1156] = 1151,
  [1157] = 1128,
  [1158] = 1024,
  [1159] = 1067,
  [1160] = 1139,
  [1161] = 1138,
  [1162] = 1136,
  [1163] = 1064,
  [1164] = 1063,
  [1165] = 1134,
  [1166] = 1133,
  [1167] = 603,
  [1168] = 1126,
  [1169] = 1123,
  [1170] = 627,
  [1171] = 1128,
  [1172] = 636,
  [1173] = 1050,
  [1174] = 1005,
  [1175] = 1005,
  [1176] = 1001,
  [1177] = 1000,
  [1178] = 1054,
  [1179] = 1058,
  [1180] = 1001,
  [1181] = 999,
  [1182] = 1000,
  [1183] = 1147,
  [1184] = 1140,
  [1185] = 1047,
  [1186] = 1111,
  [1187] = 622,
  [1188] = 613,
  [1189] = 612,
  [1190] = 969,
  [1191] = 1121,
  [1192] = 1122,
  [1193] = 980,
  [1194] = 1060,
  [1195] = 1122,
  [1196] = 603,
  [1197] = 988,
  [1198] = 1137,
  [1199] = 1000,
  [1200] = 1113,
  [1201] = 1001,
  [1202] = 1005,
  [1203] = 1143,
  [1204] = 999,
  [1205] = 637,
  [1206] = 1148,
  [1207] = 982,
  [1208] = 1148,
  [1209] = 971,
  [1210] = 986,
  [1211] = 976,
  [1212] = 985,
  [1213] = 984,
  [1214] = 1125,
  [1215] = 1062,
  [1216] = 1061,
  [1217] = 635,
  [1218] = 1125,
  [1219] = 975,
  [1220] = 1067,
  [1221] = 969,
  [1222] = 1113,
  [1223] = 1024,
  [1224] = 1126,
  [1225] = 1151,
  [1226] = 973,
  [1227] = 1062,
  [1228] = 1061,
  [1229] = 1060,
  [1230] = 974,
  [1231] = 1005,
  [1232] = 1121,
  [1233] = 612,
  [1234] = 613,
  [1235] = 1077,
  [1236] = 1111,
  [1237] = 620,
  [1238] = 1024,
  [1239] = 999,
  [1240] = 1143,
  [1241] = 623,
  [1242] = 626,
  [1243] = 624,
  [1244] = 630,
  [1245] = 618,
  [1246] = 628,
  [1247] = 1001,
  [1248] = 619,
  [1249] = 1000,
  [1250] = 999,
  [1251] = 632,
  [1252] = 1137,
  [1253] = 622,
  [1254] = 1123,
  [1255] = 1024,
  [1256] = 620,
  [1257] = 620,
  [1258] = 1077,
  [1259] = 1140,
  [1260] = 636,
  [1261] = 1147,
  [1262] = 1058,
  [1263] = 1054,
  [1264] = 1050,
  [1265] = 1133,
  [1266] = 1134,
  [1267] = 623,
  [1268] = 1064,
  [1269] = 1063,
  [1270] = 628,
  [1271] = 618,
  [1272] = 1136,
  [1273] = 1138,
  [1274] = 1139,
  [1275] = 630,
  [1276] = 635,
  [1277] = 637,
  [1278] = 969,
  [1279] = 1077,
  [1280] = 1140,
  [1281] = 1121,
  [1282] = 1077,
  [1283] = 1123,
  [1284] = 632,
  [1285] = 623,
  [1286] = 627,
  [1287] = 1111,
  [1288] = 1121,
  [1289] = 1122,
  [1290] = 1151,
  [1291] = 1126,
  [1292] = 1128,
  [1293] = 622,
  [1294] = 620,
  [1295] = 1063,
  [1296] = 1111,
  [1297] = 1064,
  [1298] = 1123,
  [1299] = 619,
  [1300] = 1137,
  [1301] = 626,
  [1302] = 1143,
  [1303] = 1077,
  [1304] = 1077,
  [1305] = 1305,
  [1306] = 1306,
  [1307] = 623,
  [1308] = 622,
  [1309] = 1140,
  [1310] = 1125,
  [1311] = 1143,
  [1312] = 1000,
  [1313] = 622,
  [1314] = 623,
  [1315] = 1148,
  [1316] = 1137,
  [1317] = 1047,
  [1318] = 1001,
  [1319] = 625,
  [1320] = 1005,
  [1321] = 637,
  [1322] = 635,
  [1323] = 1125,
  [1324] = 1067,
  [1325] = 1139,
  [1326] = 1138,
  [1327] = 1136,
  [1328] = 1151,
  [1329] = 1126,
  [1330] = 630,
  [1331] = 1134,
  [1332] = 1133,
  [1333] = 1128,
  [1334] = 1126,
  [1335] = 1151,
  [1336] = 618,
  [1337] = 628,
  [1338] = 1123,
  [1339] = 1122,
  [1340] = 1050,
  [1341] = 1128,
  [1342] = 1054,
  [1343] = 1058,
  [1344] = 1121,
  [1345] = 636,
  [1346] = 1148,
  [1347] = 1143,
  [1348] = 1137,
  [1349] = 1147,
  [1350] = 620,
  [1351] = 1123,
  [1352] = 1122,
  [1353] = 1121,
  [1354] = 1111,
  [1355] = 1097,
  [1356] = 1147,
  [1357] = 1140,
  [1358] = 1094,
  [1359] = 620,
  [1360] = 1092,
  [1361] = 1148,
  [1362] = 624,
  [1363] = 1111,
  [1364] = 1122,
  [1365] = 1047,
  [1366] = 1067,
  [1367] = 1139,
  [1368] = 1138,
  [1369] = 1136,
  [1370] = 1134,
  [1371] = 1063,
  [1372] = 1064,
  [1373] = 1133,
  [1374] = 1050,
  [1375] = 1047,
  [1376] = 625,
  [1377] = 1067,
  [1378] = 1054,
  [1379] = 1058,
  [1380] = 1064,
  [1381] = 1063,
  [1382] = 1047,
  [1383] = 1147,
  [1384] = 624,
  [1385] = 1139,
  [1386] = 1067,
  [1387] = 1139,
  [1388] = 1063,
  [1389] = 1064,
  [1390] = 1138,
  [1391] = 1136,
  [1392] = 1137,
  [1393] = 1143,
  [1394] = 1138,
  [1395] = 1136,
  [1396] = 1133,
  [1397] = 1134,
  [1398] = 1133,
  [1399] = 636,
  [1400] = 1148,
  [1401] = 1125,
  [1402] = 627,
  [1403] = 620,
  [1404] = 1050,
  [1405] = 624,
  [1406] = 1050,
  [1407] = 620,
  [1408] = 1054,
  [1409] = 1058,
  [1410] = 1054,
  [1411] = 1058,
  [1412] = 1134,
  [1413] = 628,
  [1414] = 626,
  [1415] = 618,
  [1416] = 619,
  [1417] = 630,
  [1418] = 632,
  [1419] = 619,
  [1420] = 632,
  [1421] = 636,
  [1422] = 626,
  [1423] = 1147,
  [1424] = 1140,
  [1425] = 628,
  [1426] = 618,
  [1427] = 1125,
  [1428] = 630,
  [1429] = 635,
  [1430] = 637,
  [1431] = 635,
  [1432] = 637,
  [1433] = 999,
  [1434] = 623,
  [1435] = 622,
  [1436] = 620,
  [1437] = 1024,
  [1438] = 627,
  [1439] = 1151,
  [1440] = 1126,
  [1441] = 1128,
  [1442] = 636,
  [1443] = 624,
  [1444] = 628,
  [1445] = 1140,
  [1446] = 1147,
  [1447] = 1058,
  [1448] = 1054,
  [1449] = 618,
  [1450] = 630,
  [1451] = 635,
  [1452] = 637,
  [1453] = 1050,
  [1454] = 1133,
  [1455] = 1134,
  [1456] = 1136,
  [1457] = 1138,
  [1458] = 1139,
  [1459] = 1067,
  [1460] = 1047,
  [1461] = 1111,
  [1462] = 1121,
  [1463] = 1122,
  [1464] = 1123,
  [1465] = 1137,
  [1466] = 1143,
  [1467] = 1148,
  [1468] = 1128,
  [1469] = 1062,
  [1470] = 1061,
  [1471] = 1060,
  [1472] = 1126,
  [1473] = 1151,
  [1474] = 622,
  [1475] = 625,
  [1476] = 623,
  [1477] = 1077,
  [1478] = 1062,
  [1479] = 1061,
  [1480] = 620,
  [1481] = 1060,
  [1482] = 1063,
  [1483] = 1064,
  [1484] = 1125,
  [1485] = 625,
  [1486] = 1062,
  [1487] = 1061,
  [1488] = 1060,
  [1489] = 622,
  [1490] = 636,
  [1491] = 1306,
  [1492] = 624,
  [1493] = 628,
  [1494] = 618,
  [1495] = 630,
  [1496] = 635,
  [1497] = 637,
  [1498] = 623,
  [1499] = 1305,
  [1500] = 620,
  [1501] = 620,
  [1502] = 627,
  [1503] = 620,
  [1504] = 626,
  [1505] = 619,
  [1506] = 620,
  [1507] = 632,
  [1508] = 1508,
  [1509] = 1509,
  [1510] = 1510,
  [1511] = 1511,
  [1512] = 1512,
  [1513] = 1513,
  [1514] = 1514,
  [1515] = 1514,
  [1516] = 1512,
  [1517] = 1517,
  [1518] = 1517,
  [1519] = 1512,
  [1520] = 1517,
  [1521] = 1511,
  [1522] = 1522,
  [1523] = 1512,
  [1524] = 1511,
  [1525] = 1525,
  [1526] = 1513,
  [1527] = 1527,
  [1528] = 1522,
  [1529] = 1527,
  [1530] = 1511,
  [1531] = 1525,
  [1532] = 1514,
  [1533] = 1527,
  [1534] = 1510,
  [1535] = 1514,
  [1536] = 1510,
  [1537] = 1513,
  [1538] = 1513,
  [1539] = 1525,
  [1540] = 1522,
  [1541] = 1517,
  [1542] = 1525,
  [1543] = 1522,
  [1544] = 1527,
  [1545] = 1510,
  [1546] = 1546,
  [1547] = 1547,
  [1548] = 1548,
  [1549] = 1548,
  [1550] = 1548,
  [1551] = 1551,
  [1552] = 1552,
  [1553] = 1553,
  [1554] = 1554,
  [1555] = 1552,
  [1556] = 1551,
  [1557] = 1557,
  [1558] = 1557,
  [1559] = 1557,
  [1560] = 1557,
  [1561] = 1552,
  [1562] = 1552,
  [1563] = 1551,
  [1564] = 1553,
  [1565] = 1554,
  [1566] = 1553,
  [1567] = 1551,
  [1568] = 1553,
  [1569] = 1554,
  [1570] = 1554,
  [1571] = 1571,
  [1572] = 1572,
  [1573] = 1573,
  [1574] = 1572,
  [1575] = 1573,
  [1576] = 1573,
  [1577] = 1572,
  [1578] = 1572,
  [1579] = 1573,
  [1580] = 1580,
  [1581] = 1581,
  [1582] = 632,
  [1583] = 1306,
  [1584] = 1581,
  [1585] = 1305,
  [1586] = 1580,
  [1587] = 619,
  [1588] = 627,
  [1589] = 1580,
  [1590] = 626,
  [1591] = 1581,
  [1592] = 1580,
  [1593] = 1581,
  [1594] = 1581,
  [1595] = 1580,
  [1596] = 1581,
  [1597] = 1580,
  [1598] = 1598,
  [1599] = 622,
  [1600] = 620,
  [1601] = 1581,
  [1602] = 623,
  [1603] = 1580,
  [1604] = 1604,
  [1605] = 1605,
  [1606] = 1606,
  [1607] = 1607,
  [1608] = 1581,
  [1609] = 1580,
  [1610] = 619,
  [1611] = 619,
  [1612] = 1598,
  [1613] = 1604,
  [1614] = 1306,
  [1615] = 1615,
  [1616] = 1305,
  [1617] = 626,
  [1618] = 1618,
  [1619] = 1618,
  [1620] = 626,
  [1621] = 627,
  [1622] = 627,
  [1623] = 632,
  [1624] = 1618,
  [1625] = 619,
  [1626] = 1618,
  [1627] = 1618,
  [1628] = 632,
  [1629] = 1607,
  [1630] = 626,
  [1631] = 1618,
  [1632] = 632,
  [1633] = 1618,
  [1634] = 1618,
  [1635] = 1618,
  [1636] = 620,
  [1637] = 623,
  [1638] = 1638,
  [1639] = 622,
  [1640] = 1306,
  [1641] = 1306,
  [1642] = 1642,
  [1643] = 1643,
  [1644] = 1305,
  [1645] = 1305,
  [1646] = 627,
  [1647] = 1618,
  [1648] = 1648,
  [1649] = 1648,
  [1650] = 1648,
  [1651] = 1651,
  [1652] = 1648,
  [1653] = 1605,
  [1654] = 1648,
  [1655] = 1655,
  [1656] = 1656,
  [1657] = 1606,
  [1658] = 1656,
  [1659] = 1638,
  [1660] = 1643,
  [1661] = 1642,
  [1662] = 1648,
  [1663] = 1615,
  [1664] = 1656,
  [1665] = 1648,
  [1666] = 1651,
  [1667] = 1648,
  [1668] = 1668,
  [1669] = 1669,
  [1670] = 1669,
  [1671] = 1671,
  [1672] = 1672,
  [1673] = 1671,
  [1674] = 1674,
  [1675] = 1674,
  [1676] = 1676,
  [1677] = 1677,
  [1678] = 1678,
  [1679] = 1678,
  [1680] = 1678,
  [1681] = 1678,
  [1682] = 1682,
  [1683] = 1678,
  [1684] = 1678,
  [1685] = 1685,
  [1686] = 1686,
  [1687] = 1687,
  [1688] = 1688,
  [1689] = 1678,
  [1690] = 1690,
  [1691] = 1691,
  [1692] = 1678,
  [1693] = 1693,
  [1694] = 1694,
  [1695] = 1695,
  [1696] = 1693,
  [1697] = 1697,
  [1698] = 1695,
  [1699] = 1693,
  [1700] = 1700,
  [1701] = 1695,
  [1702] = 1694,
  [1703] = 1694,
  [1704] = 1694,
  [1705] = 1695,
  [1706] = 1694,
  [1707] = 1693,
  [1708] = 1693,
  [1709] = 1695,
  [1710] = 1694,
  [1711] = 1695,
  [1712] = 1694,
  [1713] = 1693,
  [1714] = 1693,
  [1715] = 1694,
  [1716] = 1693,
  [1717] = 1695,
  [1718] = 1695,
  [1719] = 1687,
  [1720] = 1682,
  [1721] = 1688,
  [1722] = 1722,
  [1723] = 1723,
  [1724] = 1724,
  [1725] = 1723,
  [1726] = 1726,
  [1727] = 1686,
  [1728] = 1685,
  [1729] = 1729,
  [1730] = 1723,
  [1731] = 1731,
  [1732] = 1722,
  [1733] = 1722,
  [1734] = 1685,
  [1735] = 1677,
  [1736] = 1722,
  [1737] = 1723,
  [1738] = 1723,
  [1739] = 1690,
  [1740] = 1691,
  [1741] = 1686,
  [1742] = 1722,
  [1743] = 1676,
  [1744] = 1723,
  [1745] = 1722,
  [1746] = 1682,
  [1747] = 1722,
  [1748] = 1688,
  [1749] = 1691,
  [1750] = 1677,
  [1751] = 1690,
  [1752] = 1723,
  [1753] = 1722,
  [1754] = 1726,
  [1755] = 1723,
  [1756] = 1723,
  [1757] = 1687,
  [1758] = 1722,
  [1759] = 1676,
  [1760] = 1688,
  [1761] = 1761,
  [1762] = 1690,
  [1763] = 1686,
  [1764] = 1685,
  [1765] = 1765,
  [1766] = 1688,
  [1767] = 1682,
  [1768] = 1691,
  [1769] = 1677,
  [1770] = 1687,
  [1771] = 1677,
  [1772] = 1691,
  [1773] = 1688,
  [1774] = 1687,
  [1775] = 1682,
  [1776] = 1776,
  [1777] = 1777,
  [1778] = 1676,
  [1779] = 1676,
  [1780] = 1726,
  [1781] = 1685,
  [1782] = 1682,
  [1783] = 1687,
  [1784] = 1677,
  [1785] = 1785,
  [1786] = 1686,
  [1787] = 1726,
  [1788] = 1788,
  [1789] = 1690,
  [1790] = 1691,
  [1791] = 1690,
  [1792] = 1676,
  [1793] = 1686,
  [1794] = 1685,
  [1795] = 1795,
  [1796] = 1765,
  [1797] = 1797,
  [1798] = 1798,
  [1799] = 1765,
  [1800] = 1690,
  [1801] = 1677,
  [1802] = 1802,
  [1803] = 1765,
  [1804] = 1802,
  [1805] = 1686,
  [1806] = 1676,
  [1807] = 1690,
  [1808] = 1808,
  [1809] = 1809,
  [1810] = 1810,
  [1811] = 1685,
  [1812] = 1809,
  [1813] = 1724,
  [1814] = 1809,
  [1815] = 1815,
  [1816] = 1816,
  [1817] = 1682,
  [1818] = 1809,
  [1819] = 1809,
  [1820] = 1820,
  [1821] = 1816,
  [1822] = 1686,
  [1823] = 1823,
  [1824] = 1687,
  [1825] = 1825,
  [1826] = 1685,
  [1827] = 1676,
  [1828] = 1828,
  [1829] = 1809,
  [1830] = 1830,
  [1831] = 1831,
  [1832] = 1809,
  [1833] = 1809,
  [1834] = 1688,
  [1835] = 1835,
  [1836] = 1825,
  [1837] = 1687,
  [1838] = 1798,
  [1839] = 1795,
  [1840] = 1820,
  [1841] = 1841,
  [1842] = 1823,
  [1843] = 1691,
  [1844] = 1677,
  [1845] = 1809,
  [1846] = 1798,
  [1847] = 1682,
  [1848] = 1848,
  [1849] = 1825,
  [1850] = 1691,
  [1851] = 1688,
  [1852] = 1809,
  [1853] = 1802,
  [1854] = 1854,
  [1855] = 1855,
  [1856] = 1856,
  [1857] = 1855,
  [1858] = 1855,
  [1859] = 1777,
  [1860] = 1860,
  [1861] = 1761,
  [1862] = 1854,
  [1863] = 1863,
  [1864] = 1776,
  [1865] = 1854,
  [1866] = 1866,
  [1867] = 1808,
  [1868] = 1868,
  [1869] = 1776,
  [1870] = 1777,
  [1871] = 1871,
  [1872] = 1854,
  [1873] = 1873,
  [1874] = 1724,
  [1875] = 1875,
  [1876] = 1876,
  [1877] = 1877,
  [1878] = 1776,
  [1879] = 1879,
  [1880] = 1856,
  [1881] = 1881,
  [1882] = 1724,
  [1883] = 1777,
  [1884] = 1873,
  [1885] = 1885,
  [1886] = 1886,
  [1887] = 1877,
  [1888] = 1885,
  [1889] = 1889,
  [1890] = 1877,
  [1891] = 1854,
  [1892] = 1854,
  [1893] = 1876,
  [1894] = 1854,
  [1895] = 1808,
  [1896] = 1896,
  [1897] = 1897,
  [1898] = 1856,
  [1899] = 1866,
  [1900] = 1854,
  [1901] = 1901,
  [1902] = 1761,
  [1903] = 1808,
  [1904] = 1761,
  [1905] = 1876,
  [1906] = 1889,
  [1907] = 1907,
  [1908] = 1908,
  [1909] = 1909,
  [1910] = 1910,
  [1911] = 1911,
  [1912] = 1912,
  [1913] = 1913,
  [1914] = 1871,
  [1915] = 1915,
  [1916] = 1776,
  [1917] = 1917,
  [1918] = 1918,
  [1919] = 1919,
  [1920] = 1920,
  [1921] = 1917,
  [1922] = 1922,
  [1923] = 1923,
  [1924] = 1924,
  [1925] = 1841,
  [1926] = 1926,
  [1927] = 1927,
  [1928] = 1928,
  [1929] = 1929,
  [1930] = 1606,
  [1931] = 1931,
  [1932] = 1932,
  [1933] = 1911,
  [1934] = 1605,
  [1935] = 1935,
  [1936] = 1777,
  [1937] = 1795,
  [1938] = 1938,
  [1939] = 1871,
  [1940] = 1917,
  [1941] = 1918,
  [1942] = 1942,
  [1943] = 1943,
  [1944] = 1944,
  [1945] = 1945,
  [1946] = 1945,
  [1947] = 1932,
  [1948] = 1948,
  [1949] = 1949,
  [1950] = 1950,
  [1951] = 1945,
  [1952] = 1952,
  [1953] = 1953,
  [1954] = 1889,
  [1955] = 1955,
  [1956] = 1917,
  [1957] = 1785,
  [1958] = 1932,
  [1959] = 1815,
  [1960] = 1931,
  [1961] = 1961,
  [1962] = 1761,
  [1963] = 1928,
  [1964] = 1911,
  [1965] = 1912,
  [1966] = 1795,
  [1967] = 1785,
  [1968] = 1968,
  [1969] = 1915,
  [1970] = 1912,
  [1971] = 1907,
  [1972] = 1972,
  [1973] = 1815,
  [1974] = 1974,
  [1975] = 1975,
  [1976] = 1976,
  [1977] = 1908,
  [1978] = 1785,
  [1979] = 1979,
  [1980] = 1980,
  [1981] = 1981,
  [1982] = 1982,
  [1983] = 1983,
  [1984] = 1984,
  [1985] = 1910,
  [1986] = 1920,
  [1987] = 1987,
  [1988] = 1795,
  [1989] = 1923,
  [1990] = 1924,
  [1991] = 1991,
  [1992] = 1909,
  [1993] = 1993,
  [1994] = 1994,
  [1995] = 1995,
  [1996] = 1931,
  [1997] = 1815,
  [1998] = 1929,
  [1999] = 1871,
  [2000] = 1942,
  [2001] = 1918,
  [2002] = 1972,
  [2003] = 1915,
  [2004] = 1910,
  [2005] = 1980,
  [2006] = 1984,
  [2007] = 2007,
  [2008] = 1889,
  [2009] = 1907,
  [2010] = 1983,
  [2011] = 1915,
  [2012] = 2012,
  [2013] = 2013,
  [2014] = 2014,
  [2015] = 2015,
  [2016] = 1926,
  [2017] = 1972,
  [2018] = 1981,
  [2019] = 1980,
  [2020] = 2020,
  [2021] = 2021,
  [2022] = 2022,
  [2023] = 1953,
  [2024] = 2012,
  [2025] = 1974,
  [2026] = 1976,
  [2027] = 2027,
  [2028] = 1643,
  [2029] = 2029,
  [2030] = 2030,
  [2031] = 1815,
  [2032] = 2032,
  [2033] = 2033,
  [2034] = 1877,
  [2035] = 2035,
  [2036] = 2036,
  [2037] = 1976,
  [2038] = 1974,
  [2039] = 2039,
  [2040] = 2040,
  [2041] = 2041,
  [2042] = 1920,
  [2043] = 1926,
  [2044] = 1642,
  [2045] = 2045,
  [2046] = 1923,
  [2047] = 2047,
  [2048] = 1924,
  [2049] = 2049,
  [2050] = 2032,
  [2051] = 2014,
  [2052] = 2052,
  [2053] = 1953,
  [2054] = 1926,
  [2055] = 2055,
  [2056] = 2056,
  [2057] = 2057,
  [2058] = 2058,
  [2059] = 1981,
  [2060] = 1983,
  [2061] = 1974,
  [2062] = 2052,
  [2063] = 2063,
  [2064] = 2064,
  [2065] = 2065,
  [2066] = 2066,
  [2067] = 1955,
  [2068] = 2068,
  [2069] = 1984,
  [2070] = 2070,
  [2071] = 1920,
  [2072] = 2020,
  [2073] = 2073,
  [2074] = 1923,
  [2075] = 2075,
  [2076] = 2076,
  [2077] = 2014,
  [2078] = 1924,
  [2079] = 2052,
  [2080] = 2014,
  [2081] = 2081,
  [2082] = 2040,
  [2083] = 1638,
  [2084] = 1907,
  [2085] = 1953,
  [2086] = 2086,
  [2087] = 2014,
  [2088] = 2088,
  [2089] = 2089,
  [2090] = 2090,
  [2091] = 2091,
  [2092] = 2007,
  [2093] = 1984,
  [2094] = 1927,
  [2095] = 2045,
  [2096] = 2096,
  [2097] = 1981,
  [2098] = 2070,
  [2099] = 1983,
  [2100] = 2014,
  [2101] = 2101,
  [2102] = 2102,
  [2103] = 2103,
  [2104] = 2063,
  [2105] = 2032,
  [2106] = 2063,
  [2107] = 1980,
  [2108] = 2108,
  [2109] = 1972,
  [2110] = 2090,
  [2111] = 2111,
  [2112] = 2012,
  [2113] = 2014,
  [2114] = 2114,
  [2115] = 2086,
  [2116] = 2116,
  [2117] = 2117,
  [2118] = 2014,
  [2119] = 2119,
  [2120] = 2027,
  [2121] = 2121,
  [2122] = 1615,
  [2123] = 2111,
  [2124] = 2124,
  [2125] = 1976,
  [2126] = 2052,
  [2127] = 2127,
  [2128] = 2036,
  [2129] = 2035,
  [2130] = 2130,
  [2131] = 2033,
  [2132] = 2132,
  [2133] = 2022,
  [2134] = 2134,
  [2135] = 2135,
  [2136] = 2015,
  [2137] = 2039,
  [2138] = 2013,
  [2139] = 2139,
  [2140] = 2140,
  [2141] = 2141,
  [2142] = 2116,
  [2143] = 2041,
  [2144] = 2057,
  [2145] = 2058,
  [2146] = 2022,
  [2147] = 2033,
  [2148] = 2065,
  [2149] = 2088,
  [2150] = 2091,
  [2151] = 2035,
  [2152] = 2096,
  [2153] = 2036,
  [2154] = 2029,
  [2155] = 2127,
  [2156] = 2039,
  [2157] = 2103,
  [2158] = 2130,
  [2159] = 2159,
  [2160] = 2160,
  [2161] = 2041,
  [2162] = 2162,
  [2163] = 2163,
  [2164] = 2164,
  [2165] = 2057,
  [2166] = 2058,
  [2167] = 2081,
  [2168] = 2065,
  [2169] = 2169,
  [2170] = 2088,
  [2171] = 2171,
  [2172] = 2172,
  [2173] = 2173,
  [2174] = 2174,
  [2175] = 2091,
  [2176] = 2176,
  [2177] = 2177,
  [2178] = 2178,
  [2179] = 2114,
  [2180] = 2180,
  [2181] = 2076,
  [2182] = 2096,
  [2183] = 2117,
  [2184] = 2029,
  [2185] = 2119,
  [2186] = 2121,
  [2187] = 2140,
  [2188] = 2124,
  [2189] = 2073,
  [2190] = 2190,
  [2191] = 2191,
  [2192] = 2141,
  [2193] = 2020,
  [2194] = 2117,
  [2195] = 2103,
  [2196] = 2068,
  [2197] = 2068,
  [2198] = 2141,
  [2199] = 2140,
  [2200] = 2200,
  [2201] = 2020,
  [2202] = 2073,
  [2203] = 2056,
  [2204] = 2076,
  [2205] = 2127,
  [2206] = 2206,
  [2207] = 2114,
  [2208] = 2208,
  [2209] = 2209,
  [2210] = 2210,
  [2211] = 2211,
  [2212] = 2140,
  [2213] = 2141,
  [2214] = 2022,
  [2215] = 2117,
  [2216] = 2033,
  [2217] = 2119,
  [2218] = 2121,
  [2219] = 2035,
  [2220] = 2124,
  [2221] = 2036,
  [2222] = 2039,
  [2223] = 2127,
  [2224] = 2116,
  [2225] = 2225,
  [2226] = 2135,
  [2227] = 2132,
  [2228] = 2041,
  [2229] = 2057,
  [2230] = 2058,
  [2231] = 2065,
  [2232] = 2088,
  [2233] = 2091,
  [2234] = 2096,
  [2235] = 2029,
  [2236] = 2103,
  [2237] = 2237,
  [2238] = 2238,
  [2239] = 2239,
  [2240] = 2114,
  [2241] = 2068,
  [2242] = 2242,
  [2243] = 2073,
  [2244] = 2244,
  [2245] = 2076,
  [2246] = 2116,
  [2247] = 2139,
  [2248] = 2173,
  [2249] = 2124,
  [2250] = 2250,
  [2251] = 2021,
  [2252] = 2252,
  [2253] = 2253,
  [2254] = 2121,
  [2255] = 2119,
  [2256] = 2256,
  [2257] = 2257,
  [2258] = 2258,
  [2259] = 2259,
  [2260] = 2260,
  [2261] = 2261,
  [2262] = 2262,
  [2263] = 1605,
  [2264] = 2264,
  [2265] = 2242,
  [2266] = 2266,
  [2267] = 1955,
  [2268] = 2268,
  [2269] = 2257,
  [2270] = 2007,
  [2271] = 2271,
  [2272] = 2272,
  [2273] = 2273,
  [2274] = 2264,
  [2275] = 2258,
  [2276] = 2276,
  [2277] = 2277,
  [2278] = 2278,
  [2279] = 2260,
  [2280] = 2280,
  [2281] = 2281,
  [2282] = 2282,
  [2283] = 2283,
  [2284] = 2284,
  [2285] = 2285,
  [2286] = 2262,
  [2287] = 654,
  [2288] = 2288,
  [2289] = 2289,
  [2290] = 1024,
  [2291] = 2206,
  [2292] = 2292,
  [2293] = 2200,
  [2294] = 2271,
  [2295] = 2278,
  [2296] = 2296,
  [2297] = 2284,
  [2298] = 2298,
  [2299] = 2299,
  [2300] = 1643,
  [2301] = 2301,
  [2302] = 2302,
  [2303] = 2303,
  [2304] = 2304,
  [2305] = 2280,
  [2306] = 2007,
  [2307] = 2307,
  [2308] = 2299,
  [2309] = 2309,
  [2310] = 2292,
  [2311] = 2311,
  [2312] = 2312,
  [2313] = 2313,
  [2314] = 2314,
  [2315] = 2315,
  [2316] = 2316,
  [2317] = 2317,
  [2318] = 2289,
  [2319] = 2319,
  [2320] = 2320,
  [2321] = 2321,
  [2322] = 2322,
  [2323] = 2323,
  [2324] = 2283,
  [2325] = 2325,
  [2326] = 2256,
  [2327] = 641,
  [2328] = 2319,
  [2329] = 2160,
  [2330] = 2317,
  [2331] = 2284,
  [2332] = 2162,
  [2333] = 2313,
  [2334] = 2334,
  [2335] = 2312,
  [2336] = 2336,
  [2337] = 642,
  [2338] = 2338,
  [2339] = 1605,
  [2340] = 1991,
  [2341] = 2321,
  [2342] = 2342,
  [2343] = 2280,
  [2344] = 2278,
  [2345] = 2312,
  [2346] = 1955,
  [2347] = 2347,
  [2348] = 2348,
  [2349] = 2313,
  [2350] = 2317,
  [2351] = 2250,
  [2352] = 2244,
  [2353] = 2261,
  [2354] = 2354,
  [2355] = 2262,
  [2356] = 2304,
  [2357] = 2303,
  [2358] = 2319,
  [2359] = 2292,
  [2360] = 2360,
  [2361] = 2260,
  [2362] = 2007,
  [2363] = 2299,
  [2364] = 2307,
  [2365] = 2301,
  [2366] = 2366,
  [2367] = 2304,
  [2368] = 2303,
  [2369] = 2303,
  [2370] = 2292,
  [2371] = 2257,
  [2372] = 2304,
  [2373] = 2285,
  [2374] = 2210,
  [2375] = 2375,
  [2376] = 2272,
  [2377] = 2377,
  [2378] = 2378,
  [2379] = 2342,
  [2380] = 2314,
  [2381] = 2304,
  [2382] = 2303,
  [2383] = 2301,
  [2384] = 2360,
  [2385] = 2282,
  [2386] = 2299,
  [2387] = 2292,
  [2388] = 2388,
  [2389] = 639,
  [2390] = 2289,
  [2391] = 2256,
  [2392] = 2289,
  [2393] = 2256,
  [2394] = 2388,
  [2395] = 2292,
  [2396] = 2325,
  [2397] = 2304,
  [2398] = 2303,
  [2399] = 2321,
  [2400] = 999,
  [2401] = 2301,
  [2402] = 2299,
  [2403] = 2302,
  [2404] = 2301,
  [2405] = 2323,
  [2406] = 2303,
  [2407] = 2304,
  [2408] = 2307,
  [2409] = 2257,
  [2410] = 2282,
  [2411] = 2282,
  [2412] = 2264,
  [2413] = 2413,
  [2414] = 2414,
  [2415] = 2163,
  [2416] = 2272,
  [2417] = 2257,
  [2418] = 1968,
  [2419] = 2283,
  [2420] = 2321,
  [2421] = 2260,
  [2422] = 2422,
  [2423] = 2315,
  [2424] = 2262,
  [2425] = 1950,
  [2426] = 2319,
  [2427] = 2134,
  [2428] = 2317,
  [2429] = 2288,
  [2430] = 2348,
  [2431] = 2313,
  [2432] = 2432,
  [2433] = 2312,
  [2434] = 2266,
  [2435] = 1948,
  [2436] = 2292,
  [2437] = 2289,
  [2438] = 2256,
  [2439] = 1944,
  [2440] = 2280,
  [2441] = 2441,
  [2442] = 1605,
  [2443] = 2443,
  [2444] = 2272,
  [2445] = 2304,
  [2446] = 2303,
  [2447] = 2334,
  [2448] = 2413,
  [2449] = 2301,
  [2450] = 2262,
  [2451] = 2299,
  [2452] = 2432,
  [2453] = 2282,
  [2454] = 2292,
  [2455] = 2316,
  [2456] = 2260,
  [2457] = 2289,
  [2458] = 649,
  [2459] = 2256,
  [2460] = 1987,
  [2461] = 2282,
  [2462] = 1993,
  [2463] = 2272,
  [2464] = 2257,
  [2465] = 1994,
  [2466] = 2257,
  [2467] = 2162,
  [2468] = 2468,
  [2469] = 2272,
  [2470] = 2260,
  [2471] = 2262,
  [2472] = 2210,
  [2473] = 2210,
  [2474] = 2474,
  [2475] = 2262,
  [2476] = 2304,
  [2477] = 2282,
  [2478] = 2303,
  [2479] = 2260,
  [2480] = 2301,
  [2481] = 2481,
  [2482] = 2276,
  [2483] = 2256,
  [2484] = 2289,
  [2485] = 2299,
  [2486] = 2277,
  [2487] = 2292,
  [2488] = 2276,
  [2489] = 2277,
  [2490] = 2163,
  [2491] = 2491,
  [2492] = 2299,
  [2493] = 2271,
  [2494] = 2301,
  [2495] = 2292,
  [2496] = 2303,
  [2497] = 2304,
  [2498] = 2289,
  [2499] = 2256,
  [2500] = 2259,
  [2501] = 2468,
  [2502] = 2162,
  [2503] = 2481,
  [2504] = 2282,
  [2505] = 2307,
  [2506] = 2311,
  [2507] = 1606,
  [2508] = 2272,
  [2509] = 2160,
  [2510] = 2262,
  [2511] = 2272,
  [2512] = 2320,
  [2513] = 2257,
  [2514] = 1955,
  [2515] = 2260,
  [2516] = 2516,
  [2517] = 2517,
  [2518] = 642,
  [2519] = 2519,
  [2520] = 2520,
  [2521] = 2521,
  [2522] = 2522,
  [2523] = 2523,
  [2524] = 1638,
  [2525] = 2525,
  [2526] = 1642,
  [2527] = 2527,
  [2528] = 2528,
  [2529] = 2529,
  [2530] = 2530,
  [2531] = 1615,
  [2532] = 2532,
  [2533] = 2533,
  [2534] = 2534,
  [2535] = 2535,
  [2536] = 2536,
  [2537] = 2537,
  [2538] = 641,
  [2539] = 2539,
  [2540] = 1643,
  [2541] = 2541,
  [2542] = 2542,
  [2543] = 2543,
  [2544] = 639,
  [2545] = 2066,
  [2546] = 649,
  [2547] = 2547,
  [2548] = 2516,
  [2549] = 2549,
  [2550] = 654,
  [2551] = 2551,
  [2552] = 2552,
  [2553] = 2553,
  [2554] = 2554,
  [2555] = 2066,
  [2556] = 2556,
  [2557] = 2547,
  [2558] = 2528,
  [2559] = 2559,
  [2560] = 2516,
  [2561] = 2561,
  [2562] = 2562,
  [2563] = 2549,
  [2564] = 2564,
  [2565] = 2565,
  [2566] = 2566,
  [2567] = 2567,
  [2568] = 2568,
  [2569] = 2569,
  [2570] = 2570,
  [2571] = 2527,
  [2572] = 2281,
  [2573] = 1642,
  [2574] = 2574,
  [2575] = 2517,
  [2576] = 2562,
  [2577] = 2566,
  [2578] = 2578,
  [2579] = 2579,
  [2580] = 2567,
  [2581] = 2581,
  [2582] = 2564,
  [2583] = 2583,
  [2584] = 2551,
  [2585] = 2585,
  [2586] = 2586,
  [2587] = 1638,
  [2588] = 2517,
  [2589] = 2589,
  [2590] = 2579,
  [2591] = 2570,
  [2592] = 2566,
  [2593] = 2567,
  [2594] = 2594,
  [2595] = 2296,
  [2596] = 2570,
  [2597] = 2597,
  [2598] = 2598,
  [2599] = 2599,
  [2600] = 2600,
  [2601] = 2547,
  [2602] = 2549,
  [2603] = 2586,
  [2604] = 2599,
  [2605] = 2605,
  [2606] = 2606,
  [2607] = 2517,
  [2608] = 2567,
  [2609] = 2609,
  [2610] = 2066,
  [2611] = 2268,
  [2612] = 2566,
  [2613] = 2532,
  [2614] = 2597,
  [2615] = 2570,
  [2616] = 1615,
  [2617] = 2617,
  [2618] = 2618,
  [2619] = 2619,
  [2620] = 2620,
  [2621] = 2621,
  [2622] = 2622,
  [2623] = 2623,
  [2624] = 2624,
  [2625] = 2625,
  [2626] = 2626,
  [2627] = 2627,
  [2628] = 2628,
  [2629] = 2629,
  [2630] = 2617,
  [2631] = 2631,
  [2632] = 2632,
  [2633] = 2633,
  [2634] = 2634,
  [2635] = 2624,
  [2636] = 2634,
  [2637] = 2637,
  [2638] = 2638,
  [2639] = 2639,
  [2640] = 2640,
  [2641] = 2619,
  [2642] = 2642,
  [2643] = 2643,
  [2644] = 2644,
  [2645] = 2643,
  [2646] = 2644,
  [2647] = 2620,
  [2648] = 2648,
  [2649] = 2648,
  [2650] = 2619,
  [2651] = 2620,
  [2652] = 2642,
  [2653] = 2631,
  [2654] = 2654,
  [2655] = 2617,
  [2656] = 2644,
  [2657] = 2657,
  [2658] = 2658,
  [2659] = 2659,
  [2660] = 2619,
  [2661] = 2658,
  [2662] = 2644,
  [2663] = 2627,
  [2664] = 2664,
  [2665] = 2640,
  [2666] = 2666,
  [2667] = 2667,
  [2668] = 2639,
  [2669] = 2626,
  [2670] = 2638,
  [2671] = 2638,
  [2672] = 2624,
  [2673] = 2634,
  [2674] = 2674,
  [2675] = 2631,
  [2676] = 2617,
  [2677] = 2626,
  [2678] = 2643,
  [2679] = 2659,
  [2680] = 2680,
  [2681] = 2638,
  [2682] = 2667,
  [2683] = 2628,
  [2684] = 2684,
  [2685] = 2638,
  [2686] = 2639,
  [2687] = 2687,
  [2688] = 2626,
  [2689] = 2684,
  [2690] = 2690,
  [2691] = 2628,
  [2692] = 2628,
  [2693] = 2658,
  [2694] = 2659,
  [2695] = 2620,
  [2696] = 2634,
  [2697] = 2680,
  [2698] = 2698,
  [2699] = 2699,
  [2700] = 2644,
  [2701] = 2643,
  [2702] = 2702,
  [2703] = 2627,
  [2704] = 2704,
  [2705] = 2631,
  [2706] = 2619,
  [2707] = 2640,
  [2708] = 2620,
  [2709] = 2657,
  [2710] = 2710,
  [2711] = 2711,
  [2712] = 2639,
  [2713] = 2713,
  [2714] = 2714,
  [2715] = 2638,
  [2716] = 2716,
  [2717] = 2634,
  [2718] = 2618,
  [2719] = 2627,
  [2720] = 2629,
  [2721] = 2625,
  [2722] = 2621,
  [2723] = 2624,
  [2724] = 2634,
  [2725] = 2716,
  [2726] = 2624,
  [2727] = 2713,
  [2728] = 2631,
  [2729] = 2617,
  [2730] = 2638,
  [2731] = 2628,
  [2732] = 2633,
  [2733] = 2733,
  [2734] = 2626,
  [2735] = 2639,
  [2736] = 2690,
  [2737] = 2622,
  [2738] = 2711,
  [2739] = 2666,
  [2740] = 2643,
  [2741] = 2619,
  [2742] = 2742,
  [2743] = 2626,
  [2744] = 2620,
  [2745] = 2711,
  [2746] = 2644,
  [2747] = 2629,
  [2748] = 2643,
  [2749] = 2633,
  [2750] = 2750,
  [2751] = 2684,
  [2752] = 2643,
  [2753] = 2628,
  [2754] = 2619,
  [2755] = 2755,
  [2756] = 2658,
  [2757] = 2644,
  [2758] = 2620,
  [2759] = 2640,
  [2760] = 2684,
  [2761] = 2640,
  [2762] = 2666,
  [2763] = 2742,
  [2764] = 2666,
  [2765] = 2628,
  [2766] = 2666,
  [2767] = 2704,
  [2768] = 2667,
  [2769] = 2769,
  [2770] = 2639,
  [2771] = 2638,
  [2772] = 2772,
  [2773] = 2639,
  [2774] = 2774,
  [2775] = 2620,
  [2776] = 2624,
  [2777] = 2659,
  [2778] = 2617,
  [2779] = 2644,
  [2780] = 2634,
  [2781] = 2643,
  [2782] = 2638,
  [2783] = 2783,
  [2784] = 2626,
  [2785] = 2785,
  [2786] = 2631,
  [2787] = 2619,
  [2788] = 2640,
  [2789] = 2639,
  [2790] = 2617,
  [2791] = 2791,
  [2792] = 2659,
  [2793] = 2667,
  [2794] = 2638,
  [2795] = 2626,
  [2796] = 2624,
  [2797] = 2640,
  [2798] = 2798,
  [2799] = 2624,
  [2800] = 2785,
  [2801] = 2801,
  [2802] = 2802,
  [2803] = 2803,
  [2804] = 2783,
  [2805] = 2634,
  [2806] = 2631,
  [2807] = 2640,
  [2808] = 2803,
  [2809] = 2654,
  [2810] = 2631,
  [2811] = 2687,
  [2812] = 2698,
  [2813] = 2791,
  [2814] = 2628,
  [2815] = 2772,
  [2816] = 2791,
  [2817] = 2617,
  [2818] = 2684,
};

static inline bool sym_identifier_character_set_1(int32_t c) {
  return (c < 43514
    ? (c < 4193
      ? (c < 2707
        ? (c < 1994
          ? (c < 931
            ? (c < 748
              ? (c < 192
                ? (c < 170
                  ? (c < 'a'
                    ? (c >= 'A' && c <= '_')
                    : c <= 'z')
                  : (c <= 170 || (c < 186
                    ? c == 181
                    : c <= 186)))
                : (c <= 214 || (c < 710
                  ? (c < 248
                    ? (c >= 216 && c <= 246)
                    : c <= 705)
                  : (c <= 721 || (c >= 736 && c <= 740)))))
              : (c <= 748 || (c < 895
                ? (c < 886
                  ? (c < 880
                    ? c == 750
                    : c <= 884)
                  : (c <= 887 || (c >= 891 && c <= 893)))
                : (c <= 895 || (c < 908
                  ? (c < 904
                    ? c == 902
                    : c <= 906)
                  : (c <= 908 || (c >= 910 && c <= 929)))))))
            : (c <= 1013 || (c < 1649
              ? (c < 1376
                ? (c < 1329
                  ? (c < 1162
                    ? (c >= 1015 && c <= 1153)
                    : c <= 1327)
                  : (c <= 1366 || c == 1369))
                : (c <= 1416 || (c < 1568
                  ? (c < 1519
                    ? (c >= 1488 && c <= 1514)
                    : c <= 1522)
                  : (c <= 1610 || (c >= 1646 && c <= 1647)))))
              : (c <= 1747 || (c < 1791
                ? (c < 1774
                  ? (c < 1765
                    ? c == 1749
                    : c <= 1766)
                  : (c <= 1775 || (c >= 1786 && c <= 1788)))
                : (c <= 1791 || (c < 1869
                  ? (c < 1810
                    ? c == 1808
                    : c <= 1839)
                  : (c <= 1957 || c == 1969))))))))
          : (c <= 2026 || (c < 2482
            ? (c < 2208
              ? (c < 2088
                ? (c < 2048
                  ? (c < 2042
                    ? (c >= 2036 && c <= 2037)
                    : c <= 2042)
                  : (c <= 2069 || (c < 2084
                    ? c == 2074
                    : c <= 2084)))
                : (c <= 2088 || (c < 2160
                  ? (c < 2144
                    ? (c >= 2112 && c <= 2136)
                    : c <= 2154)
                  : (c <= 2183 || (c >= 2185 && c <= 2190)))))
              : (c <= 2249 || (c < 2417
                ? (c < 2384
                  ? (c < 2365
                    ? (c >= 2308 && c <= 2361)
                    : c <= 2365)
                  : (c <= 2384 || (c >= 2392 && c <= 2401)))
                : (c <= 2432 || (c < 2451
                  ? (c < 2447
                    ? (c >= 2437 && c <= 2444)
                    : c <= 2448)
                  : (c <= 2472 || (c >= 2474 && c <= 2480)))))))
            : (c <= 2482 || (c < 2579
              ? (c < 2527
                ? (c < 2510
                  ? (c < 2493
                    ? (c >= 2486 && c <= 2489)
                    : c <= 2493)
                  : (c <= 2510 || (c >= 2524 && c <= 2525)))
                : (c <= 2529 || (c < 2565
                  ? (c < 2556
                    ? (c >= 2544 && c <= 2545)
                    : c <= 2556)
                  : (c <= 2570 || (c >= 2575 && c <= 2576)))))
              : (c <= 2600 || (c < 2649
                ? (c < 2613
                  ? (c < 2610
                    ? (c >= 2602 && c <= 2608)
                    : c <= 2611)
                  : (c <= 2614 || (c >= 2616 && c <= 2617)))
                : (c <= 2652 || (c < 2693
                  ? (c < 2674
                    ? c == 2654
                    : c <= 2676)
                  : (c <= 2701 || (c >= 2703 && c <= 2705)))))))))))
        : (c <= 2728 || (c < 3242
          ? (c < 2962
            ? (c < 2858
              ? (c < 2784
                ? (c < 2741
                  ? (c < 2738
                    ? (c >= 2730 && c <= 2736)
                    : c <= 2739)
                  : (c <= 2745 || (c < 2768
                    ? c == 2749
                    : c <= 2768)))
                : (c <= 2785 || (c < 2831
                  ? (c < 2821
                    ? c == 2809
                    : c <= 2828)
                  : (c <= 2832 || (c >= 2835 && c <= 2856)))))
              : (c <= 2864 || (c < 2911
                ? (c < 2877
                  ? (c < 2869
                    ? (c >= 2866 && c <= 2867)
                    : c <= 2873)
                  : (c <= 2877 || (c >= 2908 && c <= 2909)))
                : (c <= 2913 || (c < 2949
                  ? (c < 2947
                    ? c == 2929
                    : c <= 2947)
                  : (c <= 2954 || (c >= 2958 && c <= 2960)))))))
            : (c <= 2965 || (c < 3090
              ? (c < 2984
                ? (c < 2974
                  ? (c < 2972
                    ? (c >= 2969 && c <= 2970)
                    : c <= 2972)
                  : (c <= 2975 || (c >= 2979 && c <= 2980)))
                : (c <= 2986 || (c < 3077
                  ? (c < 3024
                    ? (c >= 2990 && c <= 3001)
                    : c <= 3024)
                  : (c <= 3084 || (c >= 3086 && c <= 3088)))))
              : (c <= 3112 || (c < 3168
                ? (c < 3160
                  ? (c < 3133
                    ? (c >= 3114 && c <= 3129)
                    : c <= 3133)
                  : (c <= 3162 || c == 3165))
                : (c <= 3169 || (c < 3214
                  ? (c < 3205
                    ? c == 3200
                    : c <= 3212)
                  : (c <= 3216 || (c >= 3218 && c <= 3240)))))))))
          : (c <= 3251 || (c < 3648
            ? (c < 3412
              ? (c < 3332
                ? (c < 3293
                  ? (c < 3261
                    ? (c >= 3253 && c <= 3257)
                    : c <= 3261)
                  : (c <= 3294 || (c < 3313
                    ? (c >= 3296 && c <= 3297)
                    : c <= 3314)))
                : (c <= 3340 || (c < 3389
                  ? (c < 3346
                    ? (c >= 3342 && c <= 3344)
                    : c <= 3386)
                  : (c <= 3389 || c == 3406))))
              : (c <= 3414 || (c < 3507
                ? (c < 3461
                  ? (c < 3450
                    ? (c >= 3423 && c <= 3425)
                    : c <= 3455)
                  : (c <= 3478 || (c >= 3482 && c <= 3505)))
                : (c <= 3515 || (c < 3585
                  ? (c < 3520
                    ? c == 3517
                    : c <= 3526)
                  : (c <= 3632 || c == 3634))))))
            : (c <= 3654 || (c < 3782
              ? (c < 3749
                ? (c < 3718
                  ? (c < 3716
                    ? (c >= 3713 && c <= 3714)
                    : c <= 3716)
                  : (c <= 3722 || (c >= 3724 && c <= 3747)))
                : (c <= 3749 || (c < 3773
                  ? (c < 3762
                    ? (c >= 3751 && c <= 3760)
                    : c <= 3762)
                  : (c <= 3773 || (c >= 3776 && c <= 3780)))))
              : (c <= 3782 || (c < 3976
                ? (c < 3904
                  ? (c < 3840
                    ? (c >= 3804 && c <= 3807)
                    : c <= 3840)
                  : (c <= 3911 || (c >= 3913 && c <= 3948)))
                : (c <= 3980 || (c < 4176
                  ? (c < 4159
                    ? (c >= 4096 && c <= 4138)
                    : c <= 4159)
                  : (c <= 4181 || (c >= 4186 && c <= 4189)))))))))))))
      : (c <= 4193 || (c < 8134
        ? (c < 6176
          ? (c < 4808
            ? (c < 4688
              ? (c < 4295
                ? (c < 4213
                  ? (c < 4206
                    ? (c >= 4197 && c <= 4198)
                    : c <= 4208)
                  : (c <= 4225 || (c < 4256
                    ? c == 4238
                    : c <= 4293)))
                : (c <= 4295 || (c < 4348
                  ? (c < 4304
                    ? c == 4301
                    : c <= 4346)
                  : (c <= 4680 || (c >= 4682 && c <= 4685)))))
              : (c <= 4694 || (c < 4752
                ? (c < 4704
                  ? (c < 4698
                    ? c == 4696
                    : c <= 4701)
                  : (c <= 4744 || (c >= 4746 && c <= 4749)))
                : (c <= 4784 || (c < 4800
                  ? (c < 4792
                    ? (c >= 4786 && c <= 4789)
                    : c <= 4798)
                  : (c <= 4800 || (c >= 4802 && c <= 4805)))))))
            : (c <= 4822 || (c < 5792
              ? (c < 5024
                ? (c < 4888
                  ? (c < 4882
                    ? (c >= 4824 && c <= 4880)
                    : c <= 4885)
                  : (c <= 4954 || (c >= 4992 && c <= 5007)))
                : (c <= 5109 || (c < 5743
                  ? (c < 5121
                    ? (c >= 5112 && c <= 5117)
                    : c <= 5740)
                  : (c <= 5759 || (c >= 5761 && c <= 5786)))))
              : (c <= 5866 || (c < 5984
                ? (c < 5919
                  ? (c < 5888
                    ? (c >= 5870 && c <= 5880)
                    : c <= 5905)
                  : (c <= 5937 || (c >= 5952 && c <= 5969)))
                : (c <= 5996 || (c < 6103
                  ? (c < 6016
                    ? (c >= 5998 && c <= 6000)
                    : c <= 6067)
                  : (c <= 6103 || c == 6108))))))))
          : (c <= 6264 || (c < 7312
            ? (c < 6823
              ? (c < 6512
                ? (c < 6320
                  ? (c < 6314
                    ? (c >= 6272 && c <= 6312)
                    : c <= 6314)
                  : (c <= 6389 || (c < 6480
                    ? (c >= 6400 && c <= 6430)
                    : c <= 6509)))
                : (c <= 6516 || (c < 6656
                  ? (c < 6576
                    ? (c >= 6528 && c <= 6571)
                    : c <= 6601)
                  : (c <= 6678 || (c >= 6688 && c <= 6740)))))
              : (c <= 6823 || (c < 7098
                ? (c < 7043
                  ? (c < 6981
                    ? (c >= 6917 && c <= 6963)
                    : c <= 6988)
                  : (c <= 7072 || (c >= 7086 && c <= 7087)))
                : (c <= 7141 || (c < 7258
                  ? (c < 7245
                    ? (c >= 7168 && c <= 7203)
                    : c <= 7247)
                  : (c <= 7293 || (c >= 7296 && c <= 7304)))))))
            : (c <= 7354 || (c < 8008
              ? (c < 7418
                ? (c < 7406
                  ? (c < 7401
                    ? (c >= 7357 && c <= 7359)
                    : c <= 7404)
                  : (c <= 7411 || (c >= 7413 && c <= 7414)))
                : (c <= 7418 || (c < 7960
                  ? (c < 7680
                    ? (c >= 7424 && c <= 7615)
                    : c <= 7957)
                  : (c <= 7965 || (c >= 7968 && c <= 8005)))))
              : (c <= 8013 || (c < 8031
                ? (c < 8027
                  ? (c < 8025
                    ? (c >= 8016 && c <= 8023)
                    : c <= 8025)
                  : (c <= 8027 || c == 8029))
                : (c <= 8061 || (c < 8126
                  ? (c < 8118
                    ? (c >= 8064 && c <= 8116)
                    : c <= 8124)
                  : (c <= 8126 || (c >= 8130 && c <= 8132)))))))))))
        : (c <= 8140 || (c < 12337
          ? (c < 8544
            ? (c < 8458
              ? (c < 8305
                ? (c < 8160
                  ? (c < 8150
                    ? (c >= 8144 && c <= 8147)
                    : c <= 8155)
                  : (c <= 8172 || (c < 8182
                    ? (c >= 8178 && c <= 8180)
                    : c <= 8188)))
                : (c <= 8305 || (c < 8450
                  ? (c < 8336
                    ? c == 8319
                    : c <= 8348)
                  : (c <= 8450 || c == 8455))))
              : (c <= 8467 || (c < 8488
                ? (c < 8484
                  ? (c < 8472
                    ? c == 8469
                    : c <= 8477)
                  : (c <= 8484 || c == 8486))
                : (c <= 8488 || (c < 8517
                  ? (c < 8508
                    ? (c >= 8490 && c <= 8505)
                    : c <= 8511)
                  : (c <= 8521 || c == 8526))))))
            : (c <= 8584 || (c < 11680
              ? (c < 11559
                ? (c < 11506
                  ? (c < 11499
                    ? (c >= 11264 && c <= 11492)
                    : c <= 11502)
                  : (c <= 11507 || (c >= 11520 && c <= 11557)))
                : (c <= 11559 || (c < 11631
                  ? (c < 11568
                    ? c == 11565
                    : c <= 11623)
                  : (c <= 11631 || (c >= 11648 && c <= 11670)))))
              : (c <= 11686 || (c < 11720
                ? (c < 11704
                  ? (c < 11696
                    ? (c >= 11688 && c <= 11694)
                    : c <= 11702)
                  : (c <= 11710 || (c >= 11712 && c <= 11718)))
                : (c <= 11726 || (c < 12293
                  ? (c < 11736
                    ? (c >= 11728 && c <= 11734)
                    : c <= 11742)
                  : (c <= 12295 || (c >= 12321 && c <= 12329)))))))))
          : (c <= 12341 || (c < 42891
            ? (c < 19968
              ? (c < 12549
                ? (c < 12445
                  ? (c < 12353
                    ? (c >= 12344 && c <= 12348)
                    : c <= 12438)
                  : (c <= 12447 || (c < 12540
                    ? (c >= 12449 && c <= 12538)
                    : c <= 12543)))
                : (c <= 12591 || (c < 12784
                  ? (c < 12704
                    ? (c >= 12593 && c <= 12686)
                    : c <= 12735)
                  : (c <= 12799 || (c >= 13312 && c <= 19903)))))
              : (c <= 42124 || (c < 42560
                ? (c < 42512
                  ? (c < 42240
                    ? (c >= 42192 && c <= 42237)
                    : c <= 42508)
                  : (c <= 42527 || (c >= 42538 && c <= 42539)))
                : (c <= 42606 || (c < 42775
                  ? (c < 42656
                    ? (c >= 42623 && c <= 42653)
                    : c <= 42735)
                  : (c <= 42783 || (c >= 42786 && c <= 42888)))))))
            : (c <= 42954 || (c < 43250
              ? (c < 43011
                ? (c < 42965
                  ? (c < 42963
                    ? (c >= 42960 && c <= 42961)
                    : c <= 42963)
                  : (c <= 42969 || (c >= 42994 && c <= 43009)))
                : (c <= 43013 || (c < 43072
                  ? (c < 43020
                    ? (c >= 43015 && c <= 43018)
                    : c <= 43042)
                  : (c <= 43123 || (c >= 43138 && c <= 43187)))))
              : (c <= 43255 || (c < 43360
                ? (c < 43274
                  ? (c < 43261
                    ? c == 43259
                    : c <= 43262)
                  : (c <= 43301 || (c >= 43312 && c <= 43334)))
                : (c <= 43388 || (c < 43488
                  ? (c < 43471
                    ? (c >= 43396 && c <= 43442)
                    : c <= 43471)
                  : (c <= 43492 || (c >= 43494 && c <= 43503)))))))))))))))
    : (c <= 43518 || (c < 70727
      ? (c < 66956
        ? (c < 64914
          ? (c < 43868
            ? (c < 43714
              ? (c < 43646
                ? (c < 43588
                  ? (c < 43584
                    ? (c >= 43520 && c <= 43560)
                    : c <= 43586)
                  : (c <= 43595 || (c < 43642
                    ? (c >= 43616 && c <= 43638)
                    : c <= 43642)))
                : (c <= 43695 || (c < 43705
                  ? (c < 43701
                    ? c == 43697
                    : c <= 43702)
                  : (c <= 43709 || c == 43712))))
              : (c <= 43714 || (c < 43785
                ? (c < 43762
                  ? (c < 43744
                    ? (c >= 43739 && c <= 43741)
                    : c <= 43754)
                  : (c <= 43764 || (c >= 43777 && c <= 43782)))
                : (c <= 43790 || (c < 43816
                  ? (c < 43808
                    ? (c >= 43793 && c <= 43798)
                    : c <= 43814)
                  : (c <= 43822 || (c >= 43824 && c <= 43866)))))))
            : (c <= 43881 || (c < 64287
              ? (c < 63744
                ? (c < 55216
                  ? (c < 44032
                    ? (c >= 43888 && c <= 44002)
                    : c <= 55203)
                  : (c <= 55238 || (c >= 55243 && c <= 55291)))
                : (c <= 64109 || (c < 64275
                  ? (c < 64256
                    ? (c >= 64112 && c <= 64217)
                    : c <= 64262)
                  : (c <= 64279 || c == 64285))))
              : (c <= 64296 || (c < 64323
                ? (c < 64318
                  ? (c < 64312
                    ? (c >= 64298 && c <= 64310)
                    : c <= 64316)
                  : (c <= 64318 || (c >= 64320 && c <= 64321)))
                : (c <= 64324 || (c < 64612
                  ? (c < 64467
                    ? (c >= 64326 && c <= 64433)
                    : c <= 64605)
                  : (c <= 64829 || (c >= 64848 && c <= 64911)))))))))
          : (c <= 64967 || (c < 65599
            ? (c < 65382
              ? (c < 65147
                ? (c < 65139
                  ? (c < 65137
                    ? (c >= 65008 && c <= 65017)
                    : c <= 65137)
                  : (c <= 65139 || (c < 65145
                    ? c == 65143
                    : c <= 65145)))
                : (c <= 65147 || (c < 65313
                  ? (c < 65151
                    ? c == 65149
                    : c <= 65276)
                  : (c <= 65338 || (c >= 65345 && c <= 65370)))))
              : (c <= 65437 || (c < 65498
                ? (c < 65482
                  ? (c < 65474
                    ? (c >= 65440 && c <= 65470)
                    : c <= 65479)
                  : (c <= 65487 || (c >= 65490 && c <= 65495)))
                : (c <= 65500 || (c < 65576
                  ? (c < 65549
                    ? (c >= 65536 && c <= 65547)
                    : c <= 65574)
                  : (c <= 65594 || (c >= 65596 && c <= 65597)))))))
            : (c <= 65613 || (c < 66464
              ? (c < 66208
                ? (c < 65856
                  ? (c < 65664
                    ? (c >= 65616 && c <= 65629)
                    : c <= 65786)
                  : (c <= 65908 || (c >= 66176 && c <= 66204)))
                : (c <= 66256 || (c < 66384
                  ? (c < 66349
                    ? (c >= 66304 && c <= 66335)
                    : c <= 66378)
                  : (c <= 66421 || (c >= 66432 && c <= 66461)))))
              : (c <= 66499 || (c < 66776
                ? (c < 66560
                  ? (c < 66513
                    ? (c >= 66504 && c <= 66511)
                    : c <= 66517)
                  : (c <= 66717 || (c >= 66736 && c <= 66771)))
                : (c <= 66811 || (c < 66928
                  ? (c < 66864
                    ? (c >= 66816 && c <= 66855)
                    : c <= 66915)
                  : (c <= 66938 || (c >= 66940 && c <= 66954)))))))))))
        : (c <= 66962 || (c < 68864
          ? (c < 67828
            ? (c < 67506
              ? (c < 67072
                ? (c < 66979
                  ? (c < 66967
                    ? (c >= 66964 && c <= 66965)
                    : c <= 66977)
                  : (c <= 66993 || (c < 67003
                    ? (c >= 66995 && c <= 67001)
                    : c <= 67004)))
                : (c <= 67382 || (c < 67456
                  ? (c < 67424
                    ? (c >= 67392 && c <= 67413)
                    : c <= 67431)
                  : (c <= 67461 || (c >= 67463 && c <= 67504)))))
              : (c <= 67514 || (c < 67644
                ? (c < 67594
                  ? (c < 67592
                    ? (c >= 67584 && c <= 67589)
                    : c <= 67592)
                  : (c <= 67637 || (c >= 67639 && c <= 67640)))
                : (c <= 67644 || (c < 67712
                  ? (c < 67680
                    ? (c >= 67647 && c <= 67669)
                    : c <= 67702)
                  : (c <= 67742 || (c >= 67808 && c <= 67826)))))))
            : (c <= 67829 || (c < 68224
              ? (c < 68096
                ? (c < 67968
                  ? (c < 67872
                    ? (c >= 67840 && c <= 67861)
                    : c <= 67897)
                  : (c <= 68023 || (c >= 68030 && c <= 68031)))
                : (c <= 68096 || (c < 68121
                  ? (c < 68117
                    ? (c >= 68112 && c <= 68115)
                    : c <= 68119)
                  : (c <= 68149 || (c >= 68192 && c <= 68220)))))
              : (c <= 68252 || (c < 68448
                ? (c < 68352
                  ? (c < 68297
                    ? (c >= 68288 && c <= 68295)
                    : c <= 68324)
                  : (c <= 68405 || (c >= 68416 && c <= 68437)))
                : (c <= 68466 || (c < 68736
                  ? (c < 68608
                    ? (c >= 68480 && c <= 68497)
                    : c <= 68680)
                  : (c <= 68786 || (c >= 68800 && c <= 68850)))))))))
          : (c <= 68899 || (c < 70106
            ? (c < 69749
              ? (c < 69488
                ? (c < 69376
                  ? (c < 69296
                    ? (c >= 69248 && c <= 69289)
                    : c <= 69297)
                  : (c <= 69404 || (c < 69424
                    ? c == 69415
                    : c <= 69445)))
                : (c <= 69505 || (c < 69635
                  ? (c < 69600
                    ? (c >= 69552 && c <= 69572)
                    : c <= 69622)
                  : (c <= 69687 || (c >= 69745 && c <= 69746)))))
              : (c <= 69749 || (c < 69959
                ? (c < 69891
                  ? (c < 69840
                    ? (c >= 69763 && c <= 69807)
                    : c <= 69864)
                  : (c <= 69926 || c == 69956))
                : (c <= 69959 || (c < 70019
                  ? (c < 70006
                    ? (c >= 69968 && c <= 70002)
                    : c <= 70006)
                  : (c <= 70066 || (c >= 70081 && c <= 70084)))))))
            : (c <= 70106 || (c < 70405
              ? (c < 70280
                ? (c < 70163
                  ? (c < 70144
                    ? c == 70108
                    : c <= 70161)
                  : (c <= 70187 || (c >= 70272 && c <= 70278)))
                : (c <= 70280 || (c < 70303
                  ? (c < 70287
                    ? (c >= 70282 && c <= 70285)
                    : c <= 70301)
                  : (c <= 70312 || (c >= 70320 && c <= 70366)))))
              : (c <= 70412 || (c < 70453
                ? (c < 70442
                  ? (c < 70419
                    ? (c >= 70415 && c <= 70416)
                    : c <= 70440)
                  : (c <= 70448 || (c >= 70450 && c <= 70451)))
                : (c <= 70457 || (c < 70493
                  ? (c < 70480
                    ? c == 70461
                    : c <= 70480)
                  : (c <= 70497 || (c >= 70656 && c <= 70708)))))))))))))
      : (c <= 70730 || (c < 119894
        ? (c < 73056
          ? (c < 72001
            ? (c < 71424
              ? (c < 71128
                ? (c < 70852
                  ? (c < 70784
                    ? (c >= 70751 && c <= 70753)
                    : c <= 70831)
                  : (c <= 70853 || (c < 71040
                    ? c == 70855
                    : c <= 71086)))
                : (c <= 71131 || (c < 71296
                  ? (c < 71236
                    ? (c >= 71168 && c <= 71215)
                    : c <= 71236)
                  : (c <= 71338 || c == 71352))))
              : (c <= 71450 || (c < 71945
                ? (c < 71840
                  ? (c < 71680
                    ? (c >= 71488 && c <= 71494)
                    : c <= 71723)
                  : (c <= 71903 || (c >= 71935 && c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71983 || c == 71999))))))
            : (c <= 72001 || (c < 72349
              ? (c < 72192
                ? (c < 72161
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72144)
                  : (c <= 72161 || c == 72163))
                : (c <= 72192 || (c < 72272
                  ? (c < 72250
                    ? (c >= 72203 && c <= 72242)
                    : c <= 72250)
                  : (c <= 72272 || (c >= 72284 && c <= 72329)))))
              : (c <= 72349 || (c < 72818
                ? (c < 72714
                  ? (c < 72704
                    ? (c >= 72368 && c <= 72440)
                    : c <= 72712)
                  : (c <= 72750 || c == 72768))
                : (c <= 72847 || (c < 72971
                  ? (c < 72968
                    ? (c >= 72960 && c <= 72966)
                    : c <= 72969)
                  : (c <= 73008 || c == 73030))))))))
          : (c <= 73061 || (c < 93952
            ? (c < 82944
              ? (c < 73728
                ? (c < 73112
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73097)
                  : (c <= 73112 || (c < 73648
                    ? (c >= 73440 && c <= 73458)
                    : c <= 73648)))
                : (c <= 74649 || (c < 77712
                  ? (c < 74880
                    ? (c >= 74752 && c <= 74862)
                    : c <= 75075)
                  : (c <= 77808 || (c >= 77824 && c <= 78894)))))
              : (c <= 83526 || (c < 92928
                ? (c < 92784
                  ? (c < 92736
                    ? (c >= 92160 && c <= 92728)
                    : c <= 92766)
                  : (c <= 92862 || (c >= 92880 && c <= 92909)))
                : (c <= 92975 || (c < 93053
                  ? (c < 93027
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93047)
                  : (c <= 93071 || (c >= 93760 && c <= 93823)))))))
            : (c <= 94026 || (c < 110589
              ? (c < 94208
                ? (c < 94176
                  ? (c < 94099
                    ? c == 94032
                    : c <= 94111)
                  : (c <= 94177 || c == 94179))
                : (c <= 100343 || (c < 110576
                  ? (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)
                  : (c <= 110579 || (c >= 110581 && c <= 110587)))))
              : (c <= 110590 || (c < 113664
                ? (c < 110948
                  ? (c < 110928
                    ? (c >= 110592 && c <= 110882)
                    : c <= 110930)
                  : (c <= 110951 || (c >= 110960 && c <= 111355)))
                : (c <= 113770 || (c < 113808
                  ? (c < 113792
                    ? (c >= 113776 && c <= 113788)
                    : c <= 113800)
                  : (c <= 113817 || (c >= 119808 && c <= 119892)))))))))))
        : (c <= 119964 || (c < 125259
          ? (c < 120572
            ? (c < 120086
              ? (c < 119995
                ? (c < 119973
                  ? (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)
                  : (c <= 119974 || (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)))
                : (c <= 119995 || (c < 120071
                  ? (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)
                  : (c <= 120074 || (c >= 120077 && c <= 120084)))))
              : (c <= 120092 || (c < 120138
                ? (c < 120128
                  ? (c < 120123
                    ? (c >= 120094 && c <= 120121)
                    : c <= 120126)
                  : (c <= 120132 || c == 120134))
                : (c <= 120144 || (c < 120514
                  ? (c < 120488
                    ? (c >= 120146 && c <= 120485)
                    : c <= 120512)
                  : (c <= 120538 || (c >= 120540 && c <= 120570)))))))
            : (c <= 120596 || (c < 123191
              ? (c < 120714
                ? (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c >= 120688 && c <= 120712)))
                : (c <= 120744 || (c < 122624
                  ? (c < 120772
                    ? (c >= 120746 && c <= 120770)
                    : c <= 120779)
                  : (c <= 122654 || (c >= 123136 && c <= 123180)))))
              : (c <= 123197 || (c < 124904
                ? (c < 123584
                  ? (c < 123536
                    ? c == 123214
                    : c <= 123565)
                  : (c <= 123627 || (c >= 124896 && c <= 124902)))
                : (c <= 124907 || (c < 124928
                  ? (c < 124912
                    ? (c >= 124909 && c <= 124910)
                    : c <= 124926)
                  : (c <= 125124 || (c >= 125184 && c <= 125251)))))))))
          : (c <= 125259 || (c < 126559
            ? (c < 126535
              ? (c < 126505
                ? (c < 126497
                  ? (c < 126469
                    ? (c >= 126464 && c <= 126467)
                    : c <= 126495)
                  : (c <= 126498 || (c < 126503
                    ? c == 126500
                    : c <= 126503)))
                : (c <= 126514 || (c < 126523
                  ? (c < 126521
                    ? (c >= 126516 && c <= 126519)
                    : c <= 126521)
                  : (c <= 126523 || c == 126530))))
              : (c <= 126535 || (c < 126548
                ? (c < 126541
                  ? (c < 126539
                    ? c == 126537
                    : c <= 126539)
                  : (c <= 126543 || (c >= 126545 && c <= 126546)))
                : (c <= 126548 || (c < 126555
                  ? (c < 126553
                    ? c == 126551
                    : c <= 126553)
                  : (c <= 126555 || c == 126557))))))
            : (c <= 126559 || (c < 126625
              ? (c < 126580
                ? (c < 126567
                  ? (c < 126564
                    ? (c >= 126561 && c <= 126562)
                    : c <= 126564)
                  : (c <= 126570 || (c >= 126572 && c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c >= 126603 && c <= 126619)))))
              : (c <= 126627 || (c < 177984
                ? (c < 131072
                  ? (c < 126635
                    ? (c >= 126629 && c <= 126633)
                    : c <= 126651)
                  : (c <= 173791 || (c >= 173824 && c <= 177976)))
                : (c <= 178205 || (c < 194560
                  ? (c < 183984
                    ? (c >= 178208 && c <= 183969)
                    : c <= 191456)
                  : (c <= 195101 || (c >= 196608 && c <= 201546)))))))))))))))));
}

static inline bool sym_identifier_character_set_2(int32_t c) {
  return (c < 43514
    ? (c < 4193
      ? (c < 2707
        ? (c < 1994
          ? (c < 910
            ? (c < 736
              ? (c < 186
                ? (c < 'a'
                  ? (c < '_'
                    ? (c >= 'A' && c <= 'Z')
                    : c <= '_')
                  : (c <= 'z' || (c < 181
                    ? c == 170
                    : c <= 181)))
                : (c <= 186 || (c < 248
                  ? (c < 216
                    ? (c >= 192 && c <= 214)
                    : c <= 246)
                  : (c <= 705 || (c >= 710 && c <= 721)))))
              : (c <= 740 || (c < 891
                ? (c < 880
                  ? (c < 750
                    ? c == 748
                    : c <= 750)
                  : (c <= 884 || (c >= 886 && c <= 887)))
                : (c <= 893 || (c < 904
                  ? (c < 902
                    ? c == 895
                    : c <= 902)
                  : (c <= 906 || c == 908))))))
            : (c <= 929 || (c < 1649
              ? (c < 1376
                ? (c < 1162
                  ? (c < 1015
                    ? (c >= 931 && c <= 1013)
                    : c <= 1153)
                  : (c <= 1327 || (c < 1369
                    ? (c >= 1329 && c <= 1366)
                    : c <= 1369)))
                : (c <= 1416 || (c < 1568
                  ? (c < 1519
                    ? (c >= 1488 && c <= 1514)
                    : c <= 1522)
                  : (c <= 1610 || (c >= 1646 && c <= 1647)))))
              : (c <= 1747 || (c < 1791
                ? (c < 1774
                  ? (c < 1765
                    ? c == 1749
                    : c <= 1766)
                  : (c <= 1775 || (c >= 1786 && c <= 1788)))
                : (c <= 1791 || (c < 1869
                  ? (c < 1810
                    ? c == 1808
                    : c <= 1839)
                  : (c <= 1957 || c == 1969))))))))
          : (c <= 2026 || (c < 2482
            ? (c < 2208
              ? (c < 2088
                ? (c < 2048
                  ? (c < 2042
                    ? (c >= 2036 && c <= 2037)
                    : c <= 2042)
                  : (c <= 2069 || (c < 2084
                    ? c == 2074
                    : c <= 2084)))
                : (c <= 2088 || (c < 2160
                  ? (c < 2144
                    ? (c >= 2112 && c <= 2136)
                    : c <= 2154)
                  : (c <= 2183 || (c >= 2185 && c <= 2190)))))
              : (c <= 2249 || (c < 2417
                ? (c < 2384
                  ? (c < 2365
                    ? (c >= 2308 && c <= 2361)
                    : c <= 2365)
                  : (c <= 2384 || (c >= 2392 && c <= 2401)))
                : (c <= 2432 || (c < 2451
                  ? (c < 2447
                    ? (c >= 2437 && c <= 2444)
                    : c <= 2448)
                  : (c <= 2472 || (c >= 2474 && c <= 2480)))))))
            : (c <= 2482 || (c < 2579
              ? (c < 2527
                ? (c < 2510
                  ? (c < 2493
                    ? (c >= 2486 && c <= 2489)
                    : c <= 2493)
                  : (c <= 2510 || (c >= 2524 && c <= 2525)))
                : (c <= 2529 || (c < 2565
                  ? (c < 2556
                    ? (c >= 2544 && c <= 2545)
                    : c <= 2556)
                  : (c <= 2570 || (c >= 2575 && c <= 2576)))))
              : (c <= 2600 || (c < 2649
                ? (c < 2613
                  ? (c < 2610
                    ? (c >= 2602 && c <= 2608)
                    : c <= 2611)
                  : (c <= 2614 || (c >= 2616 && c <= 2617)))
                : (c <= 2652 || (c < 2693
                  ? (c < 2674
                    ? c == 2654
                    : c <= 2676)
                  : (c <= 2701 || (c >= 2703 && c <= 2705)))))))))))
        : (c <= 2728 || (c < 3242
          ? (c < 2962
            ? (c < 2858
              ? (c < 2784
                ? (c < 2741
                  ? (c < 2738
                    ? (c >= 2730 && c <= 2736)
                    : c <= 2739)
                  : (c <= 2745 || (c < 2768
                    ? c == 2749
                    : c <= 2768)))
                : (c <= 2785 || (c < 2831
                  ? (c < 2821
                    ? c == 2809
                    : c <= 2828)
                  : (c <= 2832 || (c >= 2835 && c <= 2856)))))
              : (c <= 2864 || (c < 2911
                ? (c < 2877
                  ? (c < 2869
                    ? (c >= 2866 && c <= 2867)
                    : c <= 2873)
                  : (c <= 2877 || (c >= 2908 && c <= 2909)))
                : (c <= 2913 || (c < 2949
                  ? (c < 2947
                    ? c == 2929
                    : c <= 2947)
                  : (c <= 2954 || (c >= 2958 && c <= 2960)))))))
            : (c <= 2965 || (c < 3090
              ? (c < 2984
                ? (c < 2974
                  ? (c < 2972
                    ? (c >= 2969 && c <= 2970)
                    : c <= 2972)
                  : (c <= 2975 || (c >= 2979 && c <= 2980)))
                : (c <= 2986 || (c < 3077
                  ? (c < 3024
                    ? (c >= 2990 && c <= 3001)
                    : c <= 3024)
                  : (c <= 3084 || (c >= 3086 && c <= 3088)))))
              : (c <= 3112 || (c < 3168
                ? (c < 3160
                  ? (c < 3133
                    ? (c >= 3114 && c <= 3129)
                    : c <= 3133)
                  : (c <= 3162 || c == 3165))
                : (c <= 3169 || (c < 3214
                  ? (c < 3205
                    ? c == 3200
                    : c <= 3212)
                  : (c <= 3216 || (c >= 3218 && c <= 3240)))))))))
          : (c <= 3251 || (c < 3648
            ? (c < 3412
              ? (c < 3332
                ? (c < 3293
                  ? (c < 3261
                    ? (c >= 3253 && c <= 3257)
                    : c <= 3261)
                  : (c <= 3294 || (c < 3313
                    ? (c >= 3296 && c <= 3297)
                    : c <= 3314)))
                : (c <= 3340 || (c < 3389
                  ? (c < 3346
                    ? (c >= 3342 && c <= 3344)
                    : c <= 3386)
                  : (c <= 3389 || c == 3406))))
              : (c <= 3414 || (c < 3507
                ? (c < 3461
                  ? (c < 3450
                    ? (c >= 3423 && c <= 3425)
                    : c <= 3455)
                  : (c <= 3478 || (c >= 3482 && c <= 3505)))
                : (c <= 3515 || (c < 3585
                  ? (c < 3520
                    ? c == 3517
                    : c <= 3526)
                  : (c <= 3632 || c == 3634))))))
            : (c <= 3654 || (c < 3782
              ? (c < 3749
                ? (c < 3718
                  ? (c < 3716
                    ? (c >= 3713 && c <= 3714)
                    : c <= 3716)
                  : (c <= 3722 || (c >= 3724 && c <= 3747)))
                : (c <= 3749 || (c < 3773
                  ? (c < 3762
                    ? (c >= 3751 && c <= 3760)
                    : c <= 3762)
                  : (c <= 3773 || (c >= 3776 && c <= 3780)))))
              : (c <= 3782 || (c < 3976
                ? (c < 3904
                  ? (c < 3840
                    ? (c >= 3804 && c <= 3807)
                    : c <= 3840)
                  : (c <= 3911 || (c >= 3913 && c <= 3948)))
                : (c <= 3980 || (c < 4176
                  ? (c < 4159
                    ? (c >= 4096 && c <= 4138)
                    : c <= 4159)
                  : (c <= 4181 || (c >= 4186 && c <= 4189)))))))))))))
      : (c <= 4193 || (c < 8134
        ? (c < 6176
          ? (c < 4808
            ? (c < 4688
              ? (c < 4295
                ? (c < 4213
                  ? (c < 4206
                    ? (c >= 4197 && c <= 4198)
                    : c <= 4208)
                  : (c <= 4225 || (c < 4256
                    ? c == 4238
                    : c <= 4293)))
                : (c <= 4295 || (c < 4348
                  ? (c < 4304
                    ? c == 4301
                    : c <= 4346)
                  : (c <= 4680 || (c >= 4682 && c <= 4685)))))
              : (c <= 4694 || (c < 4752
                ? (c < 4704
                  ? (c < 4698
                    ? c == 4696
                    : c <= 4701)
                  : (c <= 4744 || (c >= 4746 && c <= 4749)))
                : (c <= 4784 || (c < 4800
                  ? (c < 4792
                    ? (c >= 4786 && c <= 4789)
                    : c <= 4798)
                  : (c <= 4800 || (c >= 4802 && c <= 4805)))))))
            : (c <= 4822 || (c < 5792
              ? (c < 5024
                ? (c < 4888
                  ? (c < 4882
                    ? (c >= 4824 && c <= 4880)
                    : c <= 4885)
                  : (c <= 4954 || (c >= 4992 && c <= 5007)))
                : (c <= 5109 || (c < 5743
                  ? (c < 5121
                    ? (c >= 5112 && c <= 5117)
                    : c <= 5740)
                  : (c <= 5759 || (c >= 5761 && c <= 5786)))))
              : (c <= 5866 || (c < 5984
                ? (c < 5919
                  ? (c < 5888
                    ? (c >= 5870 && c <= 5880)
                    : c <= 5905)
                  : (c <= 5937 || (c >= 5952 && c <= 5969)))
                : (c <= 5996 || (c < 6103
                  ? (c < 6016
                    ? (c >= 5998 && c <= 6000)
                    : c <= 6067)
                  : (c <= 6103 || c == 6108))))))))
          : (c <= 6264 || (c < 7312
            ? (c < 6823
              ? (c < 6512
                ? (c < 6320
                  ? (c < 6314
                    ? (c >= 6272 && c <= 6312)
                    : c <= 6314)
                  : (c <= 6389 || (c < 6480
                    ? (c >= 6400 && c <= 6430)
                    : c <= 6509)))
                : (c <= 6516 || (c < 6656
                  ? (c < 6576
                    ? (c >= 6528 && c <= 6571)
                    : c <= 6601)
                  : (c <= 6678 || (c >= 6688 && c <= 6740)))))
              : (c <= 6823 || (c < 7098
                ? (c < 7043
                  ? (c < 6981
                    ? (c >= 6917 && c <= 6963)
                    : c <= 6988)
                  : (c <= 7072 || (c >= 7086 && c <= 7087)))
                : (c <= 7141 || (c < 7258
                  ? (c < 7245
                    ? (c >= 7168 && c <= 7203)
                    : c <= 7247)
                  : (c <= 7293 || (c >= 7296 && c <= 7304)))))))
            : (c <= 7354 || (c < 8008
              ? (c < 7418
                ? (c < 7406
                  ? (c < 7401
                    ? (c >= 7357 && c <= 7359)
                    : c <= 7404)
                  : (c <= 7411 || (c >= 7413 && c <= 7414)))
                : (c <= 7418 || (c < 7960
                  ? (c < 7680
                    ? (c >= 7424 && c <= 7615)
                    : c <= 7957)
                  : (c <= 7965 || (c >= 7968 && c <= 8005)))))
              : (c <= 8013 || (c < 8031
                ? (c < 8027
                  ? (c < 8025
                    ? (c >= 8016 && c <= 8023)
                    : c <= 8025)
                  : (c <= 8027 || c == 8029))
                : (c <= 8061 || (c < 8126
                  ? (c < 8118
                    ? (c >= 8064 && c <= 8116)
                    : c <= 8124)
                  : (c <= 8126 || (c >= 8130 && c <= 8132)))))))))))
        : (c <= 8140 || (c < 12337
          ? (c < 8544
            ? (c < 8458
              ? (c < 8305
                ? (c < 8160
                  ? (c < 8150
                    ? (c >= 8144 && c <= 8147)
                    : c <= 8155)
                  : (c <= 8172 || (c < 8182
                    ? (c >= 8178 && c <= 8180)
                    : c <= 8188)))
                : (c <= 8305 || (c < 8450
                  ? (c < 8336
                    ? c == 8319
                    : c <= 8348)
                  : (c <= 8450 || c == 8455))))
              : (c <= 8467 || (c < 8488
                ? (c < 8484
                  ? (c < 8472
                    ? c == 8469
                    : c <= 8477)
                  : (c <= 8484 || c == 8486))
                : (c <= 8488 || (c < 8517
                  ? (c < 8508
                    ? (c >= 8490 && c <= 8505)
                    : c <= 8511)
                  : (c <= 8521 || c == 8526))))))
            : (c <= 8584 || (c < 11680
              ? (c < 11559
                ? (c < 11506
                  ? (c < 11499
                    ? (c >= 11264 && c <= 11492)
                    : c <= 11502)
                  : (c <= 11507 || (c >= 11520 && c <= 11557)))
                : (c <= 11559 || (c < 11631
                  ? (c < 11568
                    ? c == 11565
                    : c <= 11623)
                  : (c <= 11631 || (c >= 11648 && c <= 11670)))))
              : (c <= 11686 || (c < 11720
                ? (c < 11704
                  ? (c < 11696
                    ? (c >= 11688 && c <= 11694)
                    : c <= 11702)
                  : (c <= 11710 || (c >= 11712 && c <= 11718)))
                : (c <= 11726 || (c < 12293
                  ? (c < 11736
                    ? (c >= 11728 && c <= 11734)
                    : c <= 11742)
                  : (c <= 12295 || (c >= 12321 && c <= 12329)))))))))
          : (c <= 12341 || (c < 42891
            ? (c < 19968
              ? (c < 12549
                ? (c < 12445
                  ? (c < 12353
                    ? (c >= 12344 && c <= 12348)
                    : c <= 12438)
                  : (c <= 12447 || (c < 12540
                    ? (c >= 12449 && c <= 12538)
                    : c <= 12543)))
                : (c <= 12591 || (c < 12784
                  ? (c < 12704
                    ? (c >= 12593 && c <= 12686)
                    : c <= 12735)
                  : (c <= 12799 || (c >= 13312 && c <= 19903)))))
              : (c <= 42124 || (c < 42560
                ? (c < 42512
                  ? (c < 42240
                    ? (c >= 42192 && c <= 42237)
                    : c <= 42508)
                  : (c <= 42527 || (c >= 42538 && c <= 42539)))
                : (c <= 42606 || (c < 42775
                  ? (c < 42656
                    ? (c >= 42623 && c <= 42653)
                    : c <= 42735)
                  : (c <= 42783 || (c >= 42786 && c <= 42888)))))))
            : (c <= 42954 || (c < 43250
              ? (c < 43011
                ? (c < 42965
                  ? (c < 42963
                    ? (c >= 42960 && c <= 42961)
                    : c <= 42963)
                  : (c <= 42969 || (c >= 42994 && c <= 43009)))
                : (c <= 43013 || (c < 43072
                  ? (c < 43020
                    ? (c >= 43015 && c <= 43018)
                    : c <= 43042)
                  : (c <= 43123 || (c >= 43138 && c <= 43187)))))
              : (c <= 43255 || (c < 43360
                ? (c < 43274
                  ? (c < 43261
                    ? c == 43259
                    : c <= 43262)
                  : (c <= 43301 || (c >= 43312 && c <= 43334)))
                : (c <= 43388 || (c < 43488
                  ? (c < 43471
                    ? (c >= 43396 && c <= 43442)
                    : c <= 43471)
                  : (c <= 43492 || (c >= 43494 && c <= 43503)))))))))))))))
    : (c <= 43518 || (c < 70727
      ? (c < 66956
        ? (c < 64914
          ? (c < 43868
            ? (c < 43714
              ? (c < 43646
                ? (c < 43588
                  ? (c < 43584
                    ? (c >= 43520 && c <= 43560)
                    : c <= 43586)
                  : (c <= 43595 || (c < 43642
                    ? (c >= 43616 && c <= 43638)
                    : c <= 43642)))
                : (c <= 43695 || (c < 43705
                  ? (c < 43701
                    ? c == 43697
                    : c <= 43702)
                  : (c <= 43709 || c == 43712))))
              : (c <= 43714 || (c < 43785
                ? (c < 43762
                  ? (c < 43744
                    ? (c >= 43739 && c <= 43741)
                    : c <= 43754)
                  : (c <= 43764 || (c >= 43777 && c <= 43782)))
                : (c <= 43790 || (c < 43816
                  ? (c < 43808
                    ? (c >= 43793 && c <= 43798)
                    : c <= 43814)
                  : (c <= 43822 || (c >= 43824 && c <= 43866)))))))
            : (c <= 43881 || (c < 64287
              ? (c < 63744
                ? (c < 55216
                  ? (c < 44032
                    ? (c >= 43888 && c <= 44002)
                    : c <= 55203)
                  : (c <= 55238 || (c >= 55243 && c <= 55291)))
                : (c <= 64109 || (c < 64275
                  ? (c < 64256
                    ? (c >= 64112 && c <= 64217)
                    : c <= 64262)
                  : (c <= 64279 || c == 64285))))
              : (c <= 64296 || (c < 64323
                ? (c < 64318
                  ? (c < 64312
                    ? (c >= 64298 && c <= 64310)
                    : c <= 64316)
                  : (c <= 64318 || (c >= 64320 && c <= 64321)))
                : (c <= 64324 || (c < 64612
                  ? (c < 64467
                    ? (c >= 64326 && c <= 64433)
                    : c <= 64605)
                  : (c <= 64829 || (c >= 64848 && c <= 64911)))))))))
          : (c <= 64967 || (c < 65599
            ? (c < 65382
              ? (c < 65147
                ? (c < 65139
                  ? (c < 65137
                    ? (c >= 65008 && c <= 65017)
                    : c <= 65137)
                  : (c <= 65139 || (c < 65145
                    ? c == 65143
                    : c <= 65145)))
                : (c <= 65147 || (c < 65313
                  ? (c < 65151
                    ? c == 65149
                    : c <= 65276)
                  : (c <= 65338 || (c >= 65345 && c <= 65370)))))
              : (c <= 65437 || (c < 65498
                ? (c < 65482
                  ? (c < 65474
                    ? (c >= 65440 && c <= 65470)
                    : c <= 65479)
                  : (c <= 65487 || (c >= 65490 && c <= 65495)))
                : (c <= 65500 || (c < 65576
                  ? (c < 65549
                    ? (c >= 65536 && c <= 65547)
                    : c <= 65574)
                  : (c <= 65594 || (c >= 65596 && c <= 65597)))))))
            : (c <= 65613 || (c < 66464
              ? (c < 66208
                ? (c < 65856
                  ? (c < 65664
                    ? (c >= 65616 && c <= 65629)
                    : c <= 65786)
                  : (c <= 65908 || (c >= 66176 && c <= 66204)))
                : (c <= 66256 || (c < 66384
                  ? (c < 66349
                    ? (c >= 66304 && c <= 66335)
                    : c <= 66378)
                  : (c <= 66421 || (c >= 66432 && c <= 66461)))))
              : (c <= 66499 || (c < 66776
                ? (c < 66560
                  ? (c < 66513
                    ? (c >= 66504 && c <= 66511)
                    : c <= 66517)
                  : (c <= 66717 || (c >= 66736 && c <= 66771)))
                : (c <= 66811 || (c < 66928
                  ? (c < 66864
                    ? (c >= 66816 && c <= 66855)
                    : c <= 66915)
                  : (c <= 66938 || (c >= 66940 && c <= 66954)))))))))))
        : (c <= 66962 || (c < 68864
          ? (c < 67828
            ? (c < 67506
              ? (c < 67072
                ? (c < 66979
                  ? (c < 66967
                    ? (c >= 66964 && c <= 66965)
                    : c <= 66977)
                  : (c <= 66993 || (c < 67003
                    ? (c >= 66995 && c <= 67001)
                    : c <= 67004)))
                : (c <= 67382 || (c < 67456
                  ? (c < 67424
                    ? (c >= 67392 && c <= 67413)
                    : c <= 67431)
                  : (c <= 67461 || (c >= 67463 && c <= 67504)))))
              : (c <= 67514 || (c < 67644
                ? (c < 67594
                  ? (c < 67592
                    ? (c >= 67584 && c <= 67589)
                    : c <= 67592)
                  : (c <= 67637 || (c >= 67639 && c <= 67640)))
                : (c <= 67644 || (c < 67712
                  ? (c < 67680
                    ? (c >= 67647 && c <= 67669)
                    : c <= 67702)
                  : (c <= 67742 || (c >= 67808 && c <= 67826)))))))
            : (c <= 67829 || (c < 68224
              ? (c < 68096
                ? (c < 67968
                  ? (c < 67872
                    ? (c >= 67840 && c <= 67861)
                    : c <= 67897)
                  : (c <= 68023 || (c >= 68030 && c <= 68031)))
                : (c <= 68096 || (c < 68121
                  ? (c < 68117
                    ? (c >= 68112 && c <= 68115)
                    : c <= 68119)
                  : (c <= 68149 || (c >= 68192 && c <= 68220)))))
              : (c <= 68252 || (c < 68448
                ? (c < 68352
                  ? (c < 68297
                    ? (c >= 68288 && c <= 68295)
                    : c <= 68324)
                  : (c <= 68405 || (c >= 68416 && c <= 68437)))
                : (c <= 68466 || (c < 68736
                  ? (c < 68608
                    ? (c >= 68480 && c <= 68497)
                    : c <= 68680)
                  : (c <= 68786 || (c >= 68800 && c <= 68850)))))))))
          : (c <= 68899 || (c < 70106
            ? (c < 69749
              ? (c < 69488
                ? (c < 69376
                  ? (c < 69296
                    ? (c >= 69248 && c <= 69289)
                    : c <= 69297)
                  : (c <= 69404 || (c < 69424
                    ? c == 69415
                    : c <= 69445)))
                : (c <= 69505 || (c < 69635
                  ? (c < 69600
                    ? (c >= 69552 && c <= 69572)
                    : c <= 69622)
                  : (c <= 69687 || (c >= 69745 && c <= 69746)))))
              : (c <= 69749 || (c < 69959
                ? (c < 69891
                  ? (c < 69840
                    ? (c >= 69763 && c <= 69807)
                    : c <= 69864)
                  : (c <= 69926 || c == 69956))
                : (c <= 69959 || (c < 70019
                  ? (c < 70006
                    ? (c >= 69968 && c <= 70002)
                    : c <= 70006)
                  : (c <= 70066 || (c >= 70081 && c <= 70084)))))))
            : (c <= 70106 || (c < 70405
              ? (c < 70280
                ? (c < 70163
                  ? (c < 70144
                    ? c == 70108
                    : c <= 70161)
                  : (c <= 70187 || (c >= 70272 && c <= 70278)))
                : (c <= 70280 || (c < 70303
                  ? (c < 70287
                    ? (c >= 70282 && c <= 70285)
                    : c <= 70301)
                  : (c <= 70312 || (c >= 70320 && c <= 70366)))))
              : (c <= 70412 || (c < 70453
                ? (c < 70442
                  ? (c < 70419
                    ? (c >= 70415 && c <= 70416)
                    : c <= 70440)
                  : (c <= 70448 || (c >= 70450 && c <= 70451)))
                : (c <= 70457 || (c < 70493
                  ? (c < 70480
                    ? c == 70461
                    : c <= 70480)
                  : (c <= 70497 || (c >= 70656 && c <= 70708)))))))))))))
      : (c <= 70730 || (c < 119894
        ? (c < 73056
          ? (c < 72001
            ? (c < 71424
              ? (c < 71128
                ? (c < 70852
                  ? (c < 70784
                    ? (c >= 70751 && c <= 70753)
                    : c <= 70831)
                  : (c <= 70853 || (c < 71040
                    ? c == 70855
                    : c <= 71086)))
                : (c <= 71131 || (c < 71296
                  ? (c < 71236
                    ? (c >= 71168 && c <= 71215)
                    : c <= 71236)
                  : (c <= 71338 || c == 71352))))
              : (c <= 71450 || (c < 71945
                ? (c < 71840
                  ? (c < 71680
                    ? (c >= 71488 && c <= 71494)
                    : c <= 71723)
                  : (c <= 71903 || (c >= 71935 && c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71983 || c == 71999))))))
            : (c <= 72001 || (c < 72349
              ? (c < 72192
                ? (c < 72161
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72144)
                  : (c <= 72161 || c == 72163))
                : (c <= 72192 || (c < 72272
                  ? (c < 72250
                    ? (c >= 72203 && c <= 72242)
                    : c <= 72250)
                  : (c <= 72272 || (c >= 72284 && c <= 72329)))))
              : (c <= 72349 || (c < 72818
                ? (c < 72714
                  ? (c < 72704
                    ? (c >= 72368 && c <= 72440)
                    : c <= 72712)
                  : (c <= 72750 || c == 72768))
                : (c <= 72847 || (c < 72971
                  ? (c < 72968
                    ? (c >= 72960 && c <= 72966)
                    : c <= 72969)
                  : (c <= 73008 || c == 73030))))))))
          : (c <= 73061 || (c < 93952
            ? (c < 82944
              ? (c < 73728
                ? (c < 73112
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73097)
                  : (c <= 73112 || (c < 73648
                    ? (c >= 73440 && c <= 73458)
                    : c <= 73648)))
                : (c <= 74649 || (c < 77712
                  ? (c < 74880
                    ? (c >= 74752 && c <= 74862)
                    : c <= 75075)
                  : (c <= 77808 || (c >= 77824 && c <= 78894)))))
              : (c <= 83526 || (c < 92928
                ? (c < 92784
                  ? (c < 92736
                    ? (c >= 92160 && c <= 92728)
                    : c <= 92766)
                  : (c <= 92862 || (c >= 92880 && c <= 92909)))
                : (c <= 92975 || (c < 93053
                  ? (c < 93027
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93047)
                  : (c <= 93071 || (c >= 93760 && c <= 93823)))))))
            : (c <= 94026 || (c < 110589
              ? (c < 94208
                ? (c < 94176
                  ? (c < 94099
                    ? c == 94032
                    : c <= 94111)
                  : (c <= 94177 || c == 94179))
                : (c <= 100343 || (c < 110576
                  ? (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)
                  : (c <= 110579 || (c >= 110581 && c <= 110587)))))
              : (c <= 110590 || (c < 113664
                ? (c < 110948
                  ? (c < 110928
                    ? (c >= 110592 && c <= 110882)
                    : c <= 110930)
                  : (c <= 110951 || (c >= 110960 && c <= 111355)))
                : (c <= 113770 || (c < 113808
                  ? (c < 113792
                    ? (c >= 113776 && c <= 113788)
                    : c <= 113800)
                  : (c <= 113817 || (c >= 119808 && c <= 119892)))))))))))
        : (c <= 119964 || (c < 125259
          ? (c < 120572
            ? (c < 120086
              ? (c < 119995
                ? (c < 119973
                  ? (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)
                  : (c <= 119974 || (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)))
                : (c <= 119995 || (c < 120071
                  ? (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)
                  : (c <= 120074 || (c >= 120077 && c <= 120084)))))
              : (c <= 120092 || (c < 120138
                ? (c < 120128
                  ? (c < 120123
                    ? (c >= 120094 && c <= 120121)
                    : c <= 120126)
                  : (c <= 120132 || c == 120134))
                : (c <= 120144 || (c < 120514
                  ? (c < 120488
                    ? (c >= 120146 && c <= 120485)
                    : c <= 120512)
                  : (c <= 120538 || (c >= 120540 && c <= 120570)))))))
            : (c <= 120596 || (c < 123191
              ? (c < 120714
                ? (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c >= 120688 && c <= 120712)))
                : (c <= 120744 || (c < 122624
                  ? (c < 120772
                    ? (c >= 120746 && c <= 120770)
                    : c <= 120779)
                  : (c <= 122654 || (c >= 123136 && c <= 123180)))))
              : (c <= 123197 || (c < 124904
                ? (c < 123584
                  ? (c < 123536
                    ? c == 123214
                    : c <= 123565)
                  : (c <= 123627 || (c >= 124896 && c <= 124902)))
                : (c <= 124907 || (c < 124928
                  ? (c < 124912
                    ? (c >= 124909 && c <= 124910)
                    : c <= 124926)
                  : (c <= 125124 || (c >= 125184 && c <= 125251)))))))))
          : (c <= 125259 || (c < 126559
            ? (c < 126535
              ? (c < 126505
                ? (c < 126497
                  ? (c < 126469
                    ? (c >= 126464 && c <= 126467)
                    : c <= 126495)
                  : (c <= 126498 || (c < 126503
                    ? c == 126500
                    : c <= 126503)))
                : (c <= 126514 || (c < 126523
                  ? (c < 126521
                    ? (c >= 126516 && c <= 126519)
                    : c <= 126521)
                  : (c <= 126523 || c == 126530))))
              : (c <= 126535 || (c < 126548
                ? (c < 126541
                  ? (c < 126539
                    ? c == 126537
                    : c <= 126539)
                  : (c <= 126543 || (c >= 126545 && c <= 126546)))
                : (c <= 126548 || (c < 126555
                  ? (c < 126553
                    ? c == 126551
                    : c <= 126553)
                  : (c <= 126555 || c == 126557))))))
            : (c <= 126559 || (c < 126625
              ? (c < 126580
                ? (c < 126567
                  ? (c < 126564
                    ? (c >= 126561 && c <= 126562)
                    : c <= 126564)
                  : (c <= 126570 || (c >= 126572 && c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c >= 126603 && c <= 126619)))))
              : (c <= 126627 || (c < 177984
                ? (c < 131072
                  ? (c < 126635
                    ? (c >= 126629 && c <= 126633)
                    : c <= 126651)
                  : (c <= 173791 || (c >= 173824 && c <= 177976)))
                : (c <= 178205 || (c < 194560
                  ? (c < 183984
                    ? (c >= 178208 && c <= 183969)
                    : c <= 191456)
                  : (c <= 195101 || (c >= 196608 && c <= 201546)))))))))))))))));
}

static inline bool sym_identifier_character_set_3(int32_t c) {
  return (c < 43616
    ? (c < 3782
      ? (c < 2748
        ? (c < 2045
          ? (c < 1015
            ? (c < 710
              ? (c < 181
                ? (c < '_'
                  ? (c < 'A'
                    ? (c >= '0' && c <= '9')
                    : c <= 'Z')
                  : (c <= '_' || (c < 170
                    ? (c >= 'a' && c <= 'z')
                    : c <= 170)))
                : (c <= 181 || (c < 192
                  ? (c < 186
                    ? c == 183
                    : c <= 186)
                  : (c <= 214 || (c < 248
                    ? (c >= 216 && c <= 246)
                    : c <= 705)))))
              : (c <= 721 || (c < 891
                ? (c < 750
                  ? (c < 748
                    ? (c >= 736 && c <= 740)
                    : c <= 748)
                  : (c <= 750 || (c < 886
                    ? (c >= 768 && c <= 884)
                    : c <= 887)))
                : (c <= 893 || (c < 908
                  ? (c < 902
                    ? c == 895
                    : c <= 906)
                  : (c <= 908 || (c < 931
                    ? (c >= 910 && c <= 929)
                    : c <= 1013)))))))
            : (c <= 1153 || (c < 1519
              ? (c < 1425
                ? (c < 1329
                  ? (c < 1162
                    ? (c >= 1155 && c <= 1159)
                    : c <= 1327)
                  : (c <= 1366 || (c < 1376
                    ? c == 1369
                    : c <= 1416)))
                : (c <= 1469 || (c < 1476
                  ? (c < 1473
                    ? c == 1471
                    : c <= 1474)
                  : (c <= 1477 || (c < 1488
                    ? c == 1479
                    : c <= 1514)))))
              : (c <= 1522 || (c < 1770
                ? (c < 1646
                  ? (c < 1568
                    ? (c >= 1552 && c <= 1562)
                    : c <= 1641)
                  : (c <= 1747 || (c < 1759
                    ? (c >= 1749 && c <= 1756)
                    : c <= 1768)))
                : (c <= 1788 || (c < 1869
                  ? (c < 1808
                    ? c == 1791
                    : c <= 1866)
                  : (c <= 1969 || (c < 2042
                    ? (c >= 1984 && c <= 2037)
                    : c <= 2042)))))))))
          : (c <= 2045 || (c < 2558
            ? (c < 2451
              ? (c < 2200
                ? (c < 2144
                  ? (c < 2112
                    ? (c >= 2048 && c <= 2093)
                    : c <= 2139)
                  : (c <= 2154 || (c < 2185
                    ? (c >= 2160 && c <= 2183)
                    : c <= 2190)))
                : (c <= 2273 || (c < 2417
                  ? (c < 2406
                    ? (c >= 2275 && c <= 2403)
                    : c <= 2415)
                  : (c <= 2435 || (c < 2447
                    ? (c >= 2437 && c <= 2444)
                    : c <= 2448)))))
              : (c <= 2472 || (c < 2507
                ? (c < 2486
                  ? (c < 2482
                    ? (c >= 2474 && c <= 2480)
                    : c <= 2482)
                  : (c <= 2489 || (c < 2503
                    ? (c >= 2492 && c <= 2500)
                    : c <= 2504)))
                : (c <= 2510 || (c < 2527
                  ? (c < 2524
                    ? c == 2519
                    : c <= 2525)
                  : (c <= 2531 || (c < 2556
                    ? (c >= 2534 && c <= 2545)
                    : c <= 2556)))))))
            : (c <= 2558 || (c < 2635
              ? (c < 2610
                ? (c < 2575
                  ? (c < 2565
                    ? (c >= 2561 && c <= 2563)
                    : c <= 2570)
                  : (c <= 2576 || (c < 2602
                    ? (c >= 2579 && c <= 2600)
                    : c <= 2608)))
                : (c <= 2611 || (c < 2620
                  ? (c < 2616
                    ? (c >= 2613 && c <= 2614)
                    : c <= 2617)
                  : (c <= 2620 || (c < 2631
                    ? (c >= 2622 && c <= 2626)
                    : c <= 2632)))))
              : (c <= 2637 || (c < 2693
                ? (c < 2654
                  ? (c < 2649
                    ? c == 2641
                    : c <= 2652)
                  : (c <= 2654 || (c < 2689
                    ? (c >= 2662 && c <= 2677)
                    : c <= 2691)))
                : (c <= 2701 || (c < 2730
                  ? (c < 2707
                    ? (c >= 2703 && c <= 2705)
                    : c <= 2728)
                  : (c <= 2736 || (c < 2741
                    ? (c >= 2738 && c <= 2739)
                    : c <= 2745)))))))))))
        : (c <= 2757 || (c < 3168
          ? (c < 2958
            ? (c < 2866
              ? (c < 2809
                ? (c < 2768
                  ? (c < 2763
                    ? (c >= 2759 && c <= 2761)
                    : c <= 2765)
                  : (c <= 2768 || (c < 2790
                    ? (c >= 2784 && c <= 2787)
                    : c <= 2799)))
                : (c <= 2815 || (c < 2831
                  ? (c < 2821
                    ? (c >= 2817 && c <= 2819)
                    : c <= 2828)
                  : (c <= 2832 || (c < 2858
                    ? (c >= 2835 && c <= 2856)
                    : c <= 2864)))))
              : (c <= 2867 || (c < 2908
                ? (c < 2887
                  ? (c < 2876
                    ? (c >= 2869 && c <= 2873)
                    : c <= 2884)
                  : (c <= 2888 || (c < 2901
                    ? (c >= 2891 && c <= 2893)
                    : c <= 2903)))
                : (c <= 2909 || (c < 2929
                  ? (c < 2918
                    ? (c >= 2911 && c <= 2915)
                    : c <= 2927)
                  : (c <= 2929 || (c < 2949
                    ? (c >= 2946 && c <= 2947)
                    : c <= 2954)))))))
            : (c <= 2960 || (c < 3031
              ? (c < 2984
                ? (c < 2972
                  ? (c < 2969
                    ? (c >= 2962 && c <= 2965)
                    : c <= 2970)
                  : (c <= 2972 || (c < 2979
                    ? (c >= 2974 && c <= 2975)
                    : c <= 2980)))
                : (c <= 2986 || (c < 3014
                  ? (c < 3006
                    ? (c >= 2990 && c <= 3001)
                    : c <= 3010)
                  : (c <= 3016 || (c < 3024
                    ? (c >= 3018 && c <= 3021)
                    : c <= 3024)))))
              : (c <= 3031 || (c < 3132
                ? (c < 3086
                  ? (c < 3072
                    ? (c >= 3046 && c <= 3055)
                    : c <= 3084)
                  : (c <= 3088 || (c < 3114
                    ? (c >= 3090 && c <= 3112)
                    : c <= 3129)))
                : (c <= 3140 || (c < 3157
                  ? (c < 3146
                    ? (c >= 3142 && c <= 3144)
                    : c <= 3149)
                  : (c <= 3158 || (c < 3165
                    ? (c >= 3160 && c <= 3162)
                    : c <= 3165)))))))))
          : (c <= 3171 || (c < 3450
            ? (c < 3293
              ? (c < 3242
                ? (c < 3205
                  ? (c < 3200
                    ? (c >= 3174 && c <= 3183)
                    : c <= 3203)
                  : (c <= 3212 || (c < 3218
                    ? (c >= 3214 && c <= 3216)
                    : c <= 3240)))
                : (c <= 3251 || (c < 3270
                  ? (c < 3260
                    ? (c >= 3253 && c <= 3257)
                    : c <= 3268)
                  : (c <= 3272 || (c < 3285
                    ? (c >= 3274 && c <= 3277)
                    : c <= 3286)))))
              : (c <= 3294 || (c < 3346
                ? (c < 3313
                  ? (c < 3302
                    ? (c >= 3296 && c <= 3299)
                    : c <= 3311)
                  : (c <= 3314 || (c < 3342
                    ? (c >= 3328 && c <= 3340)
                    : c <= 3344)))
                : (c <= 3396 || (c < 3412
                  ? (c < 3402
                    ? (c >= 3398 && c <= 3400)
                    : c <= 3406)
                  : (c <= 3415 || (c < 3430
                    ? (c >= 3423 && c <= 3427)
                    : c <= 3439)))))))
            : (c <= 3455 || (c < 3570
              ? (c < 3520
                ? (c < 3482
                  ? (c < 3461
                    ? (c >= 3457 && c <= 3459)
                    : c <= 3478)
                  : (c <= 3505 || (c < 3517
                    ? (c >= 3507 && c <= 3515)
                    : c <= 3517)))
                : (c <= 3526 || (c < 3542
                  ? (c < 3535
                    ? c == 3530
                    : c <= 3540)
                  : (c <= 3542 || (c < 3558
                    ? (c >= 3544 && c <= 3551)
                    : c <= 3567)))))
              : (c <= 3571 || (c < 3718
                ? (c < 3664
                  ? (c < 3648
                    ? (c >= 3585 && c <= 3642)
                    : c <= 3662)
                  : (c <= 3673 || (c < 3716
                    ? (c >= 3713 && c <= 3714)
                    : c <= 3716)))
                : (c <= 3722 || (c < 3751
                  ? (c < 3749
                    ? (c >= 3724 && c <= 3747)
                    : c <= 3749)
                  : (c <= 3773 || (c >= 3776 && c <= 3780)))))))))))))
      : (c <= 3782 || (c < 8025
        ? (c < 5888
          ? (c < 4688
            ? (c < 3953
              ? (c < 3872
                ? (c < 3804
                  ? (c < 3792
                    ? (c >= 3784 && c <= 3789)
                    : c <= 3801)
                  : (c <= 3807 || (c < 3864
                    ? c == 3840
                    : c <= 3865)))
                : (c <= 3881 || (c < 3897
                  ? (c < 3895
                    ? c == 3893
                    : c <= 3895)
                  : (c <= 3897 || (c < 3913
                    ? (c >= 3902 && c <= 3911)
                    : c <= 3948)))))
              : (c <= 3972 || (c < 4256
                ? (c < 4038
                  ? (c < 3993
                    ? (c >= 3974 && c <= 3991)
                    : c <= 4028)
                  : (c <= 4038 || (c < 4176
                    ? (c >= 4096 && c <= 4169)
                    : c <= 4253)))
                : (c <= 4293 || (c < 4304
                  ? (c < 4301
                    ? c == 4295
                    : c <= 4301)
                  : (c <= 4346 || (c < 4682
                    ? (c >= 4348 && c <= 4680)
                    : c <= 4685)))))))
            : (c <= 4694 || (c < 4882
              ? (c < 4786
                ? (c < 4704
                  ? (c < 4698
                    ? c == 4696
                    : c <= 4701)
                  : (c <= 4744 || (c < 4752
                    ? (c >= 4746 && c <= 4749)
                    : c <= 4784)))
                : (c <= 4789 || (c < 4802
                  ? (c < 4800
                    ? (c >= 4792 && c <= 4798)
                    : c <= 4800)
                  : (c <= 4805 || (c < 4824
                    ? (c >= 4808 && c <= 4822)
                    : c <= 4880)))))
              : (c <= 4885 || (c < 5112
                ? (c < 4969
                  ? (c < 4957
                    ? (c >= 4888 && c <= 4954)
                    : c <= 4959)
                  : (c <= 4977 || (c < 5024
                    ? (c >= 4992 && c <= 5007)
                    : c <= 5109)))
                : (c <= 5117 || (c < 5761
                  ? (c < 5743
                    ? (c >= 5121 && c <= 5740)
                    : c <= 5759)
                  : (c <= 5786 || (c < 5870
                    ? (c >= 5792 && c <= 5866)
                    : c <= 5880)))))))))
          : (c <= 5909 || (c < 6688
            ? (c < 6176
              ? (c < 6016
                ? (c < 5984
                  ? (c < 5952
                    ? (c >= 5919 && c <= 5940)
                    : c <= 5971)
                  : (c <= 5996 || (c < 6002
                    ? (c >= 5998 && c <= 6000)
                    : c <= 6003)))
                : (c <= 6099 || (c < 6112
                  ? (c < 6108
                    ? c == 6103
                    : c <= 6109)
                  : (c <= 6121 || (c < 6159
                    ? (c >= 6155 && c <= 6157)
                    : c <= 6169)))))
              : (c <= 6264 || (c < 6470
                ? (c < 6400
                  ? (c < 6320
                    ? (c >= 6272 && c <= 6314)
                    : c <= 6389)
                  : (c <= 6430 || (c < 6448
                    ? (c >= 6432 && c <= 6443)
                    : c <= 6459)))
                : (c <= 6509 || (c < 6576
                  ? (c < 6528
                    ? (c >= 6512 && c <= 6516)
                    : c <= 6571)
                  : (c <= 6601 || (c < 6656
                    ? (c >= 6608 && c <= 6618)
                    : c <= 6683)))))))
            : (c <= 6750 || (c < 7232
              ? (c < 6847
                ? (c < 6800
                  ? (c < 6783
                    ? (c >= 6752 && c <= 6780)
                    : c <= 6793)
                  : (c <= 6809 || (c < 6832
                    ? c == 6823
                    : c <= 6845)))
                : (c <= 6862 || (c < 7019
                  ? (c < 6992
                    ? (c >= 6912 && c <= 6988)
                    : c <= 7001)
                  : (c <= 7027 || (c < 7168
                    ? (c >= 7040 && c <= 7155)
                    : c <= 7223)))))
              : (c <= 7241 || (c < 7380
                ? (c < 7312
                  ? (c < 7296
                    ? (c >= 7245 && c <= 7293)
                    : c <= 7304)
                  : (c <= 7354 || (c < 7376
                    ? (c >= 7357 && c <= 7359)
                    : c <= 7378)))
                : (c <= 7418 || (c < 7968
                  ? (c < 7960
                    ? (c >= 7424 && c <= 7957)
                    : c <= 7965)
                  : (c <= 8005 || (c < 8016
                    ? (c >= 8008 && c <= 8013)
                    : c <= 8023)))))))))))
        : (c <= 8025 || (c < 11720
          ? (c < 8458
            ? (c < 8178
              ? (c < 8126
                ? (c < 8031
                  ? (c < 8029
                    ? c == 8027
                    : c <= 8029)
                  : (c <= 8061 || (c < 8118
                    ? (c >= 8064 && c <= 8116)
                    : c <= 8124)))
                : (c <= 8126 || (c < 8144
                  ? (c < 8134
                    ? (c >= 8130 && c <= 8132)
                    : c <= 8140)
                  : (c <= 8147 || (c < 8160
                    ? (c >= 8150 && c <= 8155)
                    : c <= 8172)))))
              : (c <= 8180 || (c < 8336
                ? (c < 8276
                  ? (c < 8255
                    ? (c >= 8182 && c <= 8188)
                    : c <= 8256)
                  : (c <= 8276 || (c < 8319
                    ? c == 8305
                    : c <= 8319)))
                : (c <= 8348 || (c < 8421
                  ? (c < 8417
                    ? (c >= 8400 && c <= 8412)
                    : c <= 8417)
                  : (c <= 8432 || (c < 8455
                    ? c == 8450
                    : c <= 8455)))))))
            : (c <= 8467 || (c < 11499
              ? (c < 8490
                ? (c < 8484
                  ? (c < 8472
                    ? c == 8469
                    : c <= 8477)
                  : (c <= 8484 || (c < 8488
                    ? c == 8486
                    : c <= 8488)))
                : (c <= 8505 || (c < 8526
                  ? (c < 8517
                    ? (c >= 8508 && c <= 8511)
                    : c <= 8521)
                  : (c <= 8526 || (c < 11264
                    ? (c >= 8544 && c <= 8584)
                    : c <= 11492)))))
              : (c <= 11507 || (c < 11647
                ? (c < 11565
                  ? (c < 11559
                    ? (c >= 11520 && c <= 11557)
                    : c <= 11559)
                  : (c <= 11565 || (c < 11631
                    ? (c >= 11568 && c <= 11623)
                    : c <= 11631)))
                : (c <= 11670 || (c < 11696
                  ? (c < 11688
                    ? (c >= 11680 && c <= 11686)
                    : c <= 11694)
                  : (c <= 11702 || (c < 11712
                    ? (c >= 11704 && c <= 11710)
                    : c <= 11718)))))))))
          : (c <= 11726 || (c < 42623
            ? (c < 12540
              ? (c < 12337
                ? (c < 11744
                  ? (c < 11736
                    ? (c >= 11728 && c <= 11734)
                    : c <= 11742)
                  : (c <= 11775 || (c < 12321
                    ? (c >= 12293 && c <= 12295)
                    : c <= 12335)))
                : (c <= 12341 || (c < 12441
                  ? (c < 12353
                    ? (c >= 12344 && c <= 12348)
                    : c <= 12438)
                  : (c <= 12442 || (c < 12449
                    ? (c >= 12445 && c <= 12447)
                    : c <= 12538)))))
              : (c <= 12543 || (c < 19968
                ? (c < 12704
                  ? (c < 12593
                    ? (c >= 12549 && c <= 12591)
                    : c <= 12686)
                  : (c <= 12735 || (c < 13312
                    ? (c >= 12784 && c <= 12799)
                    : c <= 19903)))
                : (c <= 42124 || (c < 42512
                  ? (c < 42240
                    ? (c >= 42192 && c <= 42237)
                    : c <= 42508)
                  : (c <= 42539 || (c < 42612
                    ? (c >= 42560 && c <= 42607)
                    : c <= 42621)))))))
            : (c <= 42737 || (c < 43232
              ? (c < 42965
                ? (c < 42891
                  ? (c < 42786
                    ? (c >= 42775 && c <= 42783)
                    : c <= 42888)
                  : (c <= 42954 || (c < 42963
                    ? (c >= 42960 && c <= 42961)
                    : c <= 42963)))
                : (c <= 42969 || (c < 43072
                  ? (c < 43052
                    ? (c >= 42994 && c <= 43047)
                    : c <= 43052)
                  : (c <= 43123 || (c < 43216
                    ? (c >= 43136 && c <= 43205)
                    : c <= 43225)))))
              : (c <= 43255 || (c < 43471
                ? (c < 43312
                  ? (c < 43261
                    ? c == 43259
                    : c <= 43309)
                  : (c <= 43347 || (c < 43392
                    ? (c >= 43360 && c <= 43388)
                    : c <= 43456)))
                : (c <= 43481 || (c < 43584
                  ? (c < 43520
                    ? (c >= 43488 && c <= 43518)
                    : c <= 43574)
                  : (c <= 43597 || (c >= 43600 && c <= 43609)))))))))))))))
    : (c <= 43638 || (c < 71453
      ? (c < 67639
        ? (c < 65345
          ? (c < 64312
            ? (c < 43888
              ? (c < 43785
                ? (c < 43744
                  ? (c < 43739
                    ? (c >= 43642 && c <= 43714)
                    : c <= 43741)
                  : (c <= 43759 || (c < 43777
                    ? (c >= 43762 && c <= 43766)
                    : c <= 43782)))
                : (c <= 43790 || (c < 43816
                  ? (c < 43808
                    ? (c >= 43793 && c <= 43798)
                    : c <= 43814)
                  : (c <= 43822 || (c < 43868
                    ? (c >= 43824 && c <= 43866)
                    : c <= 43881)))))
              : (c <= 44010 || (c < 63744
                ? (c < 44032
                  ? (c < 44016
                    ? (c >= 44012 && c <= 44013)
                    : c <= 44025)
                  : (c <= 55203 || (c < 55243
                    ? (c >= 55216 && c <= 55238)
                    : c <= 55291)))
                : (c <= 64109 || (c < 64275
                  ? (c < 64256
                    ? (c >= 64112 && c <= 64217)
                    : c <= 64262)
                  : (c <= 64279 || (c < 64298
                    ? (c >= 64285 && c <= 64296)
                    : c <= 64310)))))))
            : (c <= 64316 || (c < 65075
              ? (c < 64612
                ? (c < 64323
                  ? (c < 64320
                    ? c == 64318
                    : c <= 64321)
                  : (c <= 64324 || (c < 64467
                    ? (c >= 64326 && c <= 64433)
                    : c <= 64605)))
                : (c <= 64829 || (c < 65008
                  ? (c < 64914
                    ? (c >= 64848 && c <= 64911)
                    : c <= 64967)
                  : (c <= 65017 || (c < 65056
                    ? (c >= 65024 && c <= 65039)
                    : c <= 65071)))))
              : (c <= 65076 || (c < 65147
                ? (c < 65139
                  ? (c < 65137
                    ? (c >= 65101 && c <= 65103)
                    : c <= 65137)
                  : (c <= 65139 || (c < 65145
                    ? c == 65143
                    : c <= 65145)))
                : (c <= 65147 || (c < 65296
                  ? (c < 65151
                    ? c == 65149
                    : c <= 65276)
                  : (c <= 65305 || (c < 65343
                    ? (c >= 65313 && c <= 65338)
                    : c <= 65343)))))))))
          : (c <= 65370 || (c < 66513
            ? (c < 65664
              ? (c < 65536
                ? (c < 65482
                  ? (c < 65474
                    ? (c >= 65382 && c <= 65470)
                    : c <= 65479)
                  : (c <= 65487 || (c < 65498
                    ? (c >= 65490 && c <= 65495)
                    : c <= 65500)))
                : (c <= 65547 || (c < 65596
                  ? (c < 65576
                    ? (c >= 65549 && c <= 65574)
                    : c <= 65594)
                  : (c <= 65597 || (c < 65616
                    ? (c >= 65599 && c <= 65613)
                    : c <= 65629)))))
              : (c <= 65786 || (c < 66304
                ? (c < 66176
                  ? (c < 66045
                    ? (c >= 65856 && c <= 65908)
                    : c <= 66045)
                  : (c <= 66204 || (c < 66272
                    ? (c >= 66208 && c <= 66256)
                    : c <= 66272)))
                : (c <= 66335 || (c < 66432
                  ? (c < 66384
                    ? (c >= 66349 && c <= 66378)
                    : c <= 66426)
                  : (c <= 66461 || (c < 66504
                    ? (c >= 66464 && c <= 66499)
                    : c <= 66511)))))))
            : (c <= 66517 || (c < 66979
              ? (c < 66864
                ? (c < 66736
                  ? (c < 66720
                    ? (c >= 66560 && c <= 66717)
                    : c <= 66729)
                  : (c <= 66771 || (c < 66816
                    ? (c >= 66776 && c <= 66811)
                    : c <= 66855)))
                : (c <= 66915 || (c < 66956
                  ? (c < 66940
                    ? (c >= 66928 && c <= 66938)
                    : c <= 66954)
                  : (c <= 66962 || (c < 66967
                    ? (c >= 66964 && c <= 66965)
                    : c <= 66977)))))
              : (c <= 66993 || (c < 67456
                ? (c < 67072
                  ? (c < 67003
                    ? (c >= 66995 && c <= 67001)
                    : c <= 67004)
                  : (c <= 67382 || (c < 67424
                    ? (c >= 67392 && c <= 67413)
                    : c <= 67431)))
                : (c <= 67461 || (c < 67584
                  ? (c < 67506
                    ? (c >= 67463 && c <= 67504)
                    : c <= 67514)
                  : (c <= 67589 || (c < 67594
                    ? c == 67592
                    : c <= 67637)))))))))))
        : (c <= 67640 || (c < 69956
          ? (c < 68448
            ? (c < 68101
              ? (c < 67828
                ? (c < 67680
                  ? (c < 67647
                    ? c == 67644
                    : c <= 67669)
                  : (c <= 67702 || (c < 67808
                    ? (c >= 67712 && c <= 67742)
                    : c <= 67826)))
                : (c <= 67829 || (c < 67968
                  ? (c < 67872
                    ? (c >= 67840 && c <= 67861)
                    : c <= 67897)
                  : (c <= 68023 || (c < 68096
                    ? (c >= 68030 && c <= 68031)
                    : c <= 68099)))))
              : (c <= 68102 || (c < 68192
                ? (c < 68121
                  ? (c < 68117
                    ? (c >= 68108 && c <= 68115)
                    : c <= 68119)
                  : (c <= 68149 || (c < 68159
                    ? (c >= 68152 && c <= 68154)
                    : c <= 68159)))
                : (c <= 68220 || (c < 68297
                  ? (c < 68288
                    ? (c >= 68224 && c <= 68252)
                    : c <= 68295)
                  : (c <= 68326 || (c < 68416
                    ? (c >= 68352 && c <= 68405)
                    : c <= 68437)))))))
            : (c <= 68466 || (c < 69424
              ? (c < 68912
                ? (c < 68736
                  ? (c < 68608
                    ? (c >= 68480 && c <= 68497)
                    : c <= 68680)
                  : (c <= 68786 || (c < 68864
                    ? (c >= 68800 && c <= 68850)
                    : c <= 68903)))
                : (c <= 68921 || (c < 69296
                  ? (c < 69291
                    ? (c >= 69248 && c <= 69289)
                    : c <= 69292)
                  : (c <= 69297 || (c < 69415
                    ? (c >= 69376 && c <= 69404)
                    : c <= 69415)))))
              : (c <= 69456 || (c < 69759
                ? (c < 69600
                  ? (c < 69552
                    ? (c >= 69488 && c <= 69509)
                    : c <= 69572)
                  : (c <= 69622 || (c < 69734
                    ? (c >= 69632 && c <= 69702)
                    : c <= 69749)))
                : (c <= 69818 || (c < 69872
                  ? (c < 69840
                    ? c == 69826
                    : c <= 69864)
                  : (c <= 69881 || (c < 69942
                    ? (c >= 69888 && c <= 69940)
                    : c <= 69951)))))))))
          : (c <= 69959 || (c < 70459
            ? (c < 70282
              ? (c < 70108
                ? (c < 70016
                  ? (c < 70006
                    ? (c >= 69968 && c <= 70003)
                    : c <= 70006)
                  : (c <= 70084 || (c < 70094
                    ? (c >= 70089 && c <= 70092)
                    : c <= 70106)))
                : (c <= 70108 || (c < 70206
                  ? (c < 70163
                    ? (c >= 70144 && c <= 70161)
                    : c <= 70199)
                  : (c <= 70206 || (c < 70280
                    ? (c >= 70272 && c <= 70278)
                    : c <= 70280)))))
              : (c <= 70285 || (c < 70405
                ? (c < 70320
                  ? (c < 70303
                    ? (c >= 70287 && c <= 70301)
                    : c <= 70312)
                  : (c <= 70378 || (c < 70400
                    ? (c >= 70384 && c <= 70393)
                    : c <= 70403)))
                : (c <= 70412 || (c < 70442
                  ? (c < 70419
                    ? (c >= 70415 && c <= 70416)
                    : c <= 70440)
                  : (c <= 70448 || (c < 70453
                    ? (c >= 70450 && c <= 70451)
                    : c <= 70457)))))))
            : (c <= 70468 || (c < 70855
              ? (c < 70502
                ? (c < 70480
                  ? (c < 70475
                    ? (c >= 70471 && c <= 70472)
                    : c <= 70477)
                  : (c <= 70480 || (c < 70493
                    ? c == 70487
                    : c <= 70499)))
                : (c <= 70508 || (c < 70736
                  ? (c < 70656
                    ? (c >= 70512 && c <= 70516)
                    : c <= 70730)
                  : (c <= 70745 || (c < 70784
                    ? (c >= 70750 && c <= 70753)
                    : c <= 70853)))))
              : (c <= 70855 || (c < 71236
                ? (c < 71096
                  ? (c < 71040
                    ? (c >= 70864 && c <= 70873)
                    : c <= 71093)
                  : (c <= 71104 || (c < 71168
                    ? (c >= 71128 && c <= 71133)
                    : c <= 71232)))
                : (c <= 71236 || (c < 71360
                  ? (c < 71296
                    ? (c >= 71248 && c <= 71257)
                    : c <= 71352)
                  : (c <= 71369 || (c >= 71424 && c <= 71450)))))))))))))
      : (c <= 71467 || (c < 119973
        ? (c < 77824
          ? (c < 72760
            ? (c < 72016
              ? (c < 71945
                ? (c < 71680
                  ? (c < 71488
                    ? (c >= 71472 && c <= 71481)
                    : c <= 71494)
                  : (c <= 71738 || (c < 71935
                    ? (c >= 71840 && c <= 71913)
                    : c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71989 || (c < 71995
                    ? (c >= 71991 && c <= 71992)
                    : c <= 72003)))))
              : (c <= 72025 || (c < 72263
                ? (c < 72154
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72151)
                  : (c <= 72161 || (c < 72192
                    ? (c >= 72163 && c <= 72164)
                    : c <= 72254)))
                : (c <= 72263 || (c < 72368
                  ? (c < 72349
                    ? (c >= 72272 && c <= 72345)
                    : c <= 72349)
                  : (c <= 72440 || (c < 72714
                    ? (c >= 72704 && c <= 72712)
                    : c <= 72758)))))))
            : (c <= 72768 || (c < 73056
              ? (c < 72968
                ? (c < 72850
                  ? (c < 72818
                    ? (c >= 72784 && c <= 72793)
                    : c <= 72847)
                  : (c <= 72871 || (c < 72960
                    ? (c >= 72873 && c <= 72886)
                    : c <= 72966)))
                : (c <= 72969 || (c < 73020
                  ? (c < 73018
                    ? (c >= 72971 && c <= 73014)
                    : c <= 73018)
                  : (c <= 73021 || (c < 73040
                    ? (c >= 73023 && c <= 73031)
                    : c <= 73049)))))
              : (c <= 73061 || (c < 73440
                ? (c < 73104
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73102)
                  : (c <= 73105 || (c < 73120
                    ? (c >= 73107 && c <= 73112)
                    : c <= 73129)))
                : (c <= 73462 || (c < 74752
                  ? (c < 73728
                    ? c == 73648
                    : c <= 74649)
                  : (c <= 74862 || (c < 77712
                    ? (c >= 74880 && c <= 75075)
                    : c <= 77808)))))))))
          : (c <= 78894 || (c < 110576
            ? (c < 93027
              ? (c < 92864
                ? (c < 92736
                  ? (c < 92160
                    ? (c >= 82944 && c <= 83526)
                    : c <= 92728)
                  : (c <= 92766 || (c < 92784
                    ? (c >= 92768 && c <= 92777)
                    : c <= 92862)))
                : (c <= 92873 || (c < 92928
                  ? (c < 92912
                    ? (c >= 92880 && c <= 92909)
                    : c <= 92916)
                  : (c <= 92982 || (c < 93008
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93017)))))
              : (c <= 93047 || (c < 94176
                ? (c < 93952
                  ? (c < 93760
                    ? (c >= 93053 && c <= 93071)
                    : c <= 93823)
                  : (c <= 94026 || (c < 94095
                    ? (c >= 94031 && c <= 94087)
                    : c <= 94111)))
                : (c <= 94177 || (c < 94208
                  ? (c < 94192
                    ? (c >= 94179 && c <= 94180)
                    : c <= 94193)
                  : (c <= 100343 || (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)))))))
            : (c <= 110579 || (c < 118528
              ? (c < 110960
                ? (c < 110592
                  ? (c < 110589
                    ? (c >= 110581 && c <= 110587)
                    : c <= 110590)
                  : (c <= 110882 || (c < 110948
                    ? (c >= 110928 && c <= 110930)
                    : c <= 110951)))
                : (c <= 111355 || (c < 113792
                  ? (c < 113776
                    ? (c >= 113664 && c <= 113770)
                    : c <= 113788)
                  : (c <= 113800 || (c < 113821
                    ? (c >= 113808 && c <= 113817)
                    : c <= 113822)))))
              : (c <= 118573 || (c < 119210
                ? (c < 119149
                  ? (c < 119141
                    ? (c >= 118576 && c <= 118598)
                    : c <= 119145)
                  : (c <= 119154 || (c < 119173
                    ? (c >= 119163 && c <= 119170)
                    : c <= 119179)))
                : (c <= 119213 || (c < 119894
                  ? (c < 119808
                    ? (c >= 119362 && c <= 119364)
                    : c <= 119892)
                  : (c <= 119964 || (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)))))))))))
        : (c <= 119974 || (c < 124912
          ? (c < 120746
            ? (c < 120134
              ? (c < 120071
                ? (c < 119995
                  ? (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)
                  : (c <= 119995 || (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)))
                : (c <= 120074 || (c < 120094
                  ? (c < 120086
                    ? (c >= 120077 && c <= 120084)
                    : c <= 120092)
                  : (c <= 120121 || (c < 120128
                    ? (c >= 120123 && c <= 120126)
                    : c <= 120132)))))
              : (c <= 120134 || (c < 120572
                ? (c < 120488
                  ? (c < 120146
                    ? (c >= 120138 && c <= 120144)
                    : c <= 120485)
                  : (c <= 120512 || (c < 120540
                    ? (c >= 120514 && c <= 120538)
                    : c <= 120570)))
                : (c <= 120596 || (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c < 120714
                    ? (c >= 120688 && c <= 120712)
                    : c <= 120744)))))))
            : (c <= 120770 || (c < 122907
              ? (c < 121476
                ? (c < 121344
                  ? (c < 120782
                    ? (c >= 120772 && c <= 120779)
                    : c <= 120831)
                  : (c <= 121398 || (c < 121461
                    ? (c >= 121403 && c <= 121452)
                    : c <= 121461)))
                : (c <= 121476 || (c < 122624
                  ? (c < 121505
                    ? (c >= 121499 && c <= 121503)
                    : c <= 121519)
                  : (c <= 122654 || (c < 122888
                    ? (c >= 122880 && c <= 122886)
                    : c <= 122904)))))
              : (c <= 122913 || (c < 123214
                ? (c < 123136
                  ? (c < 122918
                    ? (c >= 122915 && c <= 122916)
                    : c <= 122922)
                  : (c <= 123180 || (c < 123200
                    ? (c >= 123184 && c <= 123197)
                    : c <= 123209)))
                : (c <= 123214 || (c < 124896
                  ? (c < 123584
                    ? (c >= 123536 && c <= 123566)
                    : c <= 123641)
                  : (c <= 124902 || (c < 124909
                    ? (c >= 124904 && c <= 124907)
                    : c <= 124910)))))))))
          : (c <= 124926 || (c < 126557
            ? (c < 126521
              ? (c < 126469
                ? (c < 125184
                  ? (c < 125136
                    ? (c >= 124928 && c <= 125124)
                    : c <= 125142)
                  : (c <= 125259 || (c < 126464
                    ? (c >= 125264 && c <= 125273)
                    : c <= 126467)))
                : (c <= 126495 || (c < 126503
                  ? (c < 126500
                    ? (c >= 126497 && c <= 126498)
                    : c <= 126500)
                  : (c <= 126503 || (c < 126516
                    ? (c >= 126505 && c <= 126514)
                    : c <= 126519)))))
              : (c <= 126521 || (c < 126541
                ? (c < 126535
                  ? (c < 126530
                    ? c == 126523
                    : c <= 126530)
                  : (c <= 126535 || (c < 126539
                    ? c == 126537
                    : c <= 126539)))
                : (c <= 126543 || (c < 126551
                  ? (c < 126548
                    ? (c >= 126545 && c <= 126546)
                    : c <= 126548)
                  : (c <= 126551 || (c < 126555
                    ? c == 126553
                    : c <= 126555)))))))
            : (c <= 126557 || (c < 126629
              ? (c < 126580
                ? (c < 126564
                  ? (c < 126561
                    ? c == 126559
                    : c <= 126562)
                  : (c <= 126564 || (c < 126572
                    ? (c >= 126567 && c <= 126570)
                    : c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c < 126625
                    ? (c >= 126603 && c <= 126619)
                    : c <= 126627)))))
              : (c <= 126633 || (c < 178208
                ? (c < 131072
                  ? (c < 130032
                    ? (c >= 126635 && c <= 126651)
                    : c <= 130041)
                  : (c <= 173791 || (c < 177984
                    ? (c >= 173824 && c <= 177976)
                    : c <= 178205)))
                : (c <= 183969 || (c < 196608
                  ? (c < 194560
                    ? (c >= 183984 && c <= 191456)
                    : c <= 195101)
                  : (c <= 201546 || (c >= 917760 && c <= 917999)))))))))))))))));
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (eof) ADVANCE(57);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(53)
      if (lookahead == '\r') SKIP(53)
      if (lookahead == '!') ADVANCE(9);
      if (lookahead == '#') ADVANCE(167);
      if (lookahead == '%') ADVANCE(97);
      if (lookahead == '&') ADVANCE(101);
      if (lookahead == '(') ADVANCE(61);
      if (lookahead == ')') ADVANCE(62);
      if (lookahead == '*') ADVANCE(65);
      if (lookahead == '+') ADVANCE(93);
      if (lookahead == ',') ADVANCE(63);
      if (lookahead == '-') ADVANCE(87);
      if (lookahead == '.') ADVANCE(60);
      if (lookahead == '/') ADVANCE(94);
      if (lookahead == '0') ADVANCE(140);
      if (lookahead == ':') ADVANCE(72);
      if (lookahead == ';') ADVANCE(58);
      if (lookahead == '<') ADVANCE(107);
      if (lookahead == '=') ADVANCE(80);
      if (lookahead == '>') ADVANCE(115);
      if (lookahead == '@') ADVANCE(84);
      if (lookahead == '[') ADVANCE(81);
      if (lookahead == '\\') ADVANCE(133);
      if (lookahead == ']') ADVANCE(82);
      if (lookahead == '^') ADVANCE(103);
      if (lookahead == 'e') ADVANCE(163);
      if (lookahead == '{') ADVANCE(90);
      if (lookahead == '|') ADVANCE(89);
      if (lookahead == '}') ADVANCE(91);
      if (lookahead == '~') ADVANCE(106);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(139);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(166);
      END_STATE();
    case 1:
      if (lookahead == '\n') ADVANCE(168);
      END_STATE();
    case 2:
      if (lookahead == '\n') ADVANCE(132);
      END_STATE();
    case 3:
      if (lookahead == '\n') SKIP(3)
      if (lookahead == '\r') ADVANCE(135);
      if (lookahead == '#') ADVANCE(136);
      if (lookahead == '\\') ADVANCE(134);
      if (lookahead == '{') ADVANCE(90);
      if (lookahead == '}') ADVANCE(91);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(135);
      if (lookahead != 0) ADVANCE(136);
      END_STATE();
    case 4:
      if (lookahead == '.') ADVANCE(5);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(146);
      END_STATE();
    case 5:
      if (lookahead == '.') ADVANCE(131);
      END_STATE();
    case 6:
      if (lookahead == '/') ADVANCE(16);
      if (lookahead == '=') ADVANCE(121);
      END_STATE();
    case 7:
      if (lookahead == '<') ADVANCE(17);
      END_STATE();
    case 8:
      if (lookahead == '=') ADVANCE(112);
      END_STATE();
    case 9:
      if (lookahead == '=') ADVANCE(112);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(137);
      END_STATE();
    case 10:
      if (lookahead == '=') ADVANCE(124);
      END_STATE();
    case 11:
      if (lookahead == '=') ADVANCE(128);
      END_STATE();
    case 12:
      if (lookahead == '=') ADVANCE(122);
      END_STATE();
    case 13:
      if (lookahead == '=') ADVANCE(129);
      END_STATE();
    case 14:
      if (lookahead == '=') ADVANCE(130);
      END_STATE();
    case 15:
      if (lookahead == '=') ADVANCE(125);
      END_STATE();
    case 16:
      if (lookahead == '=') ADVANCE(123);
      END_STATE();
    case 17:
      if (lookahead == '=') ADVANCE(127);
      END_STATE();
    case 18:
      if (lookahead == '=') ADVANCE(126);
      END_STATE();
    case 19:
      if (lookahead == '>') ADVANCE(76);
      END_STATE();
    case 20:
      if (lookahead == '>') ADVANCE(18);
      END_STATE();
    case 21:
      if (lookahead == '_') ADVANCE(28);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(142);
      END_STATE();
    case 22:
      if (lookahead == '_') ADVANCE(39);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(143);
      END_STATE();
    case 23:
      if (lookahead == '_') ADVANCE(44);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(144);
      END_STATE();
    case 24:
      if (lookahead == '{') ADVANCE(52);
      END_STATE();
    case 25:
      if (lookahead == '}') ADVANCE(132);
      if (lookahead != 0) ADVANCE(25);
      END_STATE();
    case 26:
      if (!eof && lookahead == 0 ||
          lookahead == '\n') ADVANCE(168);
      if (lookahead == '\r') ADVANCE(1);
      END_STATE();
    case 27:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(41);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(147);
      END_STATE();
    case 28:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(142);
      END_STATE();
    case 29:
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(29)
      if (lookahead == '\r') SKIP(29)
      if (lookahead == '!') ADVANCE(8);
      if (lookahead == '#') ADVANCE(167);
      if (lookahead == '%') ADVANCE(97);
      if (lookahead == '&') ADVANCE(101);
      if (lookahead == '(') ADVANCE(61);
      if (lookahead == '*') ADVANCE(65);
      if (lookahead == '+') ADVANCE(93);
      if (lookahead == ',') ADVANCE(63);
      if (lookahead == '-') ADVANCE(86);
      if (lookahead == '.') ADVANCE(60);
      if (lookahead == '/') ADVANCE(94);
      if (lookahead == '0') ADVANCE(140);
      if (lookahead == ':') ADVANCE(72);
      if (lookahead == ';') ADVANCE(58);
      if (lookahead == '<') ADVANCE(107);
      if (lookahead == '=') ADVANCE(80);
      if (lookahead == '>') ADVANCE(115);
      if (lookahead == '@') ADVANCE(84);
      if (lookahead == '[') ADVANCE(81);
      if (lookahead == '\\') ADVANCE(26);
      if (lookahead == '^') ADVANCE(103);
      if (lookahead == '{') ADVANCE(90);
      if (lookahead == '|') ADVANCE(89);
      if (lookahead == '~') ADVANCE(106);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(139);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(166);
      END_STATE();
    case 30:
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(30)
      if (lookahead == '\r') SKIP(30)
      if (lookahead == '!') ADVANCE(9);
      if (lookahead == '#') ADVANCE(167);
      if (lookahead == '%') ADVANCE(96);
      if (lookahead == '&') ADVANCE(100);
      if (lookahead == '(') ADVANCE(61);
      if (lookahead == ')') ADVANCE(62);
      if (lookahead == '*') ADVANCE(66);
      if (lookahead == '+') ADVANCE(92);
      if (lookahead == ',') ADVANCE(63);
      if (lookahead == '-') ADVANCE(85);
      if (lookahead == '.') ADVANCE(60);
      if (lookahead == '/') ADVANCE(95);
      if (lookahead == '0') ADVANCE(140);
      if (lookahead == ':') ADVANCE(72);
      if (lookahead == ';') ADVANCE(58);
      if (lookahead == '<') ADVANCE(108);
      if (lookahead == '=') ADVANCE(80);
      if (lookahead == '>') ADVANCE(116);
      if (lookahead == '@') ADVANCE(83);
      if (lookahead == '[') ADVANCE(81);
      if (lookahead == '\\') ADVANCE(26);
      if (lookahead == ']') ADVANCE(82);
      if (lookahead == '^') ADVANCE(102);
      if (lookahead == '{') ADVANCE(90);
      if (lookahead == '|') ADVANCE(88);
      if (lookahead == '}') ADVANCE(91);
      if (lookahead == '~') ADVANCE(106);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(139);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(166);
      END_STATE();
    case 31:
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(31)
      if (lookahead == '\r') SKIP(31)
      if (lookahead == '#') ADVANCE(167);
      if (lookahead == '%') ADVANCE(10);
      if (lookahead == '&') ADVANCE(11);
      if (lookahead == '(') ADVANCE(61);
      if (lookahead == '*') ADVANCE(67);
      if (lookahead == '+') ADVANCE(93);
      if (lookahead == '-') ADVANCE(86);
      if (lookahead == '.') ADVANCE(4);
      if (lookahead == '/') ADVANCE(6);
      if (lookahead == '0') ADVANCE(140);
      if (lookahead == ':') ADVANCE(71);
      if (lookahead == ';') ADVANCE(58);
      if (lookahead == '<') ADVANCE(7);
      if (lookahead == '=') ADVANCE(79);
      if (lookahead == '>') ADVANCE(20);
      if (lookahead == '@') ADVANCE(12);
      if (lookahead == '[') ADVANCE(81);
      if (lookahead == '\\') ADVANCE(26);
      if (lookahead == '^') ADVANCE(13);
      if (lookahead == '{') ADVANCE(90);
      if (lookahead == '|') ADVANCE(14);
      if (lookahead == '~') ADVANCE(106);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(139);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(166);
      END_STATE();
    case 32:
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(32)
      if (lookahead == '\r') SKIP(32)
      if (lookahead == '!') ADVANCE(8);
      if (lookahead == '#') ADVANCE(167);
      if (lookahead == '%') ADVANCE(97);
      if (lookahead == '&') ADVANCE(101);
      if (lookahead == '(') ADVANCE(61);
      if (lookahead == ')') ADVANCE(62);
      if (lookahead == '*') ADVANCE(65);
      if (lookahead == '+') ADVANCE(93);
      if (lookahead == ',') ADVANCE(63);
      if (lookahead == '-') ADVANCE(86);
      if (lookahead == '.') ADVANCE(59);
      if (lookahead == '/') ADVANCE(94);
      if (lookahead == ':') ADVANCE(72);
      if (lookahead == ';') ADVANCE(58);
      if (lookahead == '<') ADVANCE(107);
      if (lookahead == '=') ADVANCE(80);
      if (lookahead == '>') ADVANCE(115);
      if (lookahead == '@') ADVANCE(84);
      if (lookahead == '[') ADVANCE(81);
      if (lookahead == '\\') ADVANCE(26);
      if (lookahead == ']') ADVANCE(82);
      if (lookahead == '^') ADVANCE(103);
      if (lookahead == '|') ADVANCE(89);
      if (lookahead == '}') ADVANCE(91);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(166);
      END_STATE();
    case 33:
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(33)
      if (lookahead == '\r') SKIP(33)
      if (lookahead == '!') ADVANCE(8);
      if (lookahead == '#') ADVANCE(167);
      if (lookahead == '%') ADVANCE(97);
      if (lookahead == '&') ADVANCE(101);
      if (lookahead == '(') ADVANCE(61);
      if (lookahead == ')') ADVANCE(62);
      if (lookahead == '*') ADVANCE(65);
      if (lookahead == '+') ADVANCE(93);
      if (lookahead == ',') ADVANCE(63);
      if (lookahead == '-') ADVANCE(86);
      if (lookahead == '.') ADVANCE(59);
      if (lookahead == '/') ADVANCE(94);
      if (lookahead == ':') ADVANCE(71);
      if (lookahead == ';') ADVANCE(58);
      if (lookahead == '<') ADVANCE(107);
      if (lookahead == '=') ADVANCE(80);
      if (lookahead == '>') ADVANCE(115);
      if (lookahead == '@') ADVANCE(84);
      if (lookahead == '[') ADVANCE(81);
      if (lookahead == '\\') ADVANCE(26);
      if (lookahead == ']') ADVANCE(82);
      if (lookahead == '^') ADVANCE(103);
      if (lookahead == '|') ADVANCE(89);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(166);
      END_STATE();
    case 34:
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(34)
      if (lookahead == '\r') SKIP(34)
      if (lookahead == '#') ADVANCE(167);
      if (lookahead == '-') ADVANCE(19);
      if (lookahead == ':') ADVANCE(71);
      if (lookahead == '\\') ADVANCE(26);
      if (lookahead == 'e') ADVANCE(163);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(166);
      END_STATE();
    case 35:
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(35)
      if (lookahead == '\r') SKIP(35)
      if (lookahead == '!') ADVANCE(8);
      if (lookahead == '#') ADVANCE(167);
      if (lookahead == '%') ADVANCE(97);
      if (lookahead == '&') ADVANCE(101);
      if (lookahead == '(') ADVANCE(61);
      if (lookahead == '*') ADVANCE(65);
      if (lookahead == '+') ADVANCE(93);
      if (lookahead == ',') ADVANCE(63);
      if (lookahead == '-') ADVANCE(86);
      if (lookahead == '.') ADVANCE(60);
      if (lookahead == '/') ADVANCE(94);
      if (lookahead == '0') ADVANCE(140);
      if (lookahead == ':') ADVANCE(71);
      if (lookahead == ';') ADVANCE(58);
      if (lookahead == '<') ADVANCE(107);
      if (lookahead == '=') ADVANCE(80);
      if (lookahead == '>') ADVANCE(115);
      if (lookahead == '@') ADVANCE(84);
      if (lookahead == '[') ADVANCE(81);
      if (lookahead == '\\') ADVANCE(26);
      if (lookahead == '^') ADVANCE(103);
      if (lookahead == '{') ADVANCE(90);
      if (lookahead == '|') ADVANCE(89);
      if (lookahead == '~') ADVANCE(106);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(139);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(166);
      END_STATE();
    case 36:
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(36)
      if (lookahead == '\r') SKIP(36)
      if (lookahead == '!') ADVANCE(9);
      if (lookahead == '#') ADVANCE(167);
      if (lookahead == '%') ADVANCE(96);
      if (lookahead == '&') ADVANCE(100);
      if (lookahead == '(') ADVANCE(61);
      if (lookahead == ')') ADVANCE(62);
      if (lookahead == '*') ADVANCE(66);
      if (lookahead == '+') ADVANCE(92);
      if (lookahead == ',') ADVANCE(63);
      if (lookahead == '-') ADVANCE(85);
      if (lookahead == '.') ADVANCE(60);
      if (lookahead == '/') ADVANCE(95);
      if (lookahead == '0') ADVANCE(140);
      if (lookahead == ':') ADVANCE(71);
      if (lookahead == ';') ADVANCE(58);
      if (lookahead == '<') ADVANCE(108);
      if (lookahead == '=') ADVANCE(80);
      if (lookahead == '>') ADVANCE(116);
      if (lookahead == '@') ADVANCE(83);
      if (lookahead == '[') ADVANCE(81);
      if (lookahead == '\\') ADVANCE(26);
      if (lookahead == ']') ADVANCE(82);
      if (lookahead == '^') ADVANCE(102);
      if (lookahead == '{') ADVANCE(90);
      if (lookahead == '|') ADVANCE(88);
      if (lookahead == '}') ADVANCE(91);
      if (lookahead == '~') ADVANCE(106);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(139);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(166);
      END_STATE();
    case 37:
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(37)
      if (lookahead == '\r') SKIP(37)
      if (lookahead == '!') ADVANCE(9);
      if (lookahead == '#') ADVANCE(167);
      if (lookahead == '%') ADVANCE(96);
      if (lookahead == '&') ADVANCE(100);
      if (lookahead == '(') ADVANCE(61);
      if (lookahead == ')') ADVANCE(62);
      if (lookahead == '*') ADVANCE(66);
      if (lookahead == '+') ADVANCE(92);
      if (lookahead == ',') ADVANCE(63);
      if (lookahead == '-') ADVANCE(85);
      if (lookahead == '.') ADVANCE(59);
      if (lookahead == '/') ADVANCE(95);
      if (lookahead == ':') ADVANCE(71);
      if (lookahead == ';') ADVANCE(58);
      if (lookahead == '<') ADVANCE(108);
      if (lookahead == '=') ADVANCE(80);
      if (lookahead == '>') ADVANCE(116);
      if (lookahead == '@') ADVANCE(83);
      if (lookahead == '[') ADVANCE(81);
      if (lookahead == '\\') ADVANCE(26);
      if (lookahead == ']') ADVANCE(82);
      if (lookahead == '^') ADVANCE(102);
      if (lookahead == '|') ADVANCE(88);
      if (lookahead == '}') ADVANCE(91);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(166);
      END_STATE();
    case 38:
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(38)
      if (lookahead == '\r') SKIP(38)
      if (lookahead == '!') ADVANCE(9);
      if (lookahead == '#') ADVANCE(167);
      if (lookahead == '%') ADVANCE(96);
      if (lookahead == '&') ADVANCE(100);
      if (lookahead == '(') ADVANCE(61);
      if (lookahead == ')') ADVANCE(62);
      if (lookahead == '*') ADVANCE(66);
      if (lookahead == '+') ADVANCE(92);
      if (lookahead == ',') ADVANCE(63);
      if (lookahead == '-') ADVANCE(85);
      if (lookahead == '.') ADVANCE(59);
      if (lookahead == '/') ADVANCE(95);
      if (lookahead == ':') ADVANCE(72);
      if (lookahead == ';') ADVANCE(58);
      if (lookahead == '<') ADVANCE(108);
      if (lookahead == '=') ADVANCE(80);
      if (lookahead == '>') ADVANCE(116);
      if (lookahead == '@') ADVANCE(83);
      if (lookahead == '[') ADVANCE(81);
      if (lookahead == '\\') ADVANCE(26);
      if (lookahead == ']') ADVANCE(82);
      if (lookahead == '^') ADVANCE(102);
      if (lookahead == '|') ADVANCE(88);
      if (lookahead == '}') ADVANCE(91);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(166);
      END_STATE();
    case 39:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(143);
      END_STATE();
    case 40:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(132);
      END_STATE();
    case 41:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(147);
      END_STATE();
    case 42:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(40);
      END_STATE();
    case 43:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(132);
      END_STATE();
    case 44:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(144);
      END_STATE();
    case 45:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(43);
      END_STATE();
    case 46:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(45);
      END_STATE();
    case 47:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(46);
      END_STATE();
    case 48:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(47);
      END_STATE();
    case 49:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(48);
      END_STATE();
    case 50:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(49);
      END_STATE();
    case 51:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(50);
      END_STATE();
    case 52:
      if (lookahead != 0 &&
          lookahead != '}') ADVANCE(25);
      END_STATE();
    case 53:
      if (eof) ADVANCE(57);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(53)
      if (lookahead == '\r') SKIP(53)
      if (lookahead == '!') ADVANCE(9);
      if (lookahead == '#') ADVANCE(167);
      if (lookahead == '%') ADVANCE(97);
      if (lookahead == '&') ADVANCE(101);
      if (lookahead == '(') ADVANCE(61);
      if (lookahead == ')') ADVANCE(62);
      if (lookahead == '*') ADVANCE(65);
      if (lookahead == '+') ADVANCE(93);
      if (lookahead == ',') ADVANCE(63);
      if (lookahead == '-') ADVANCE(87);
      if (lookahead == '.') ADVANCE(60);
      if (lookahead == '/') ADVANCE(94);
      if (lookahead == '0') ADVANCE(140);
      if (lookahead == ':') ADVANCE(72);
      if (lookahead == ';') ADVANCE(58);
      if (lookahead == '<') ADVANCE(107);
      if (lookahead == '=') ADVANCE(80);
      if (lookahead == '>') ADVANCE(115);
      if (lookahead == '@') ADVANCE(84);
      if (lookahead == '[') ADVANCE(81);
      if (lookahead == '\\') ADVANCE(26);
      if (lookahead == ']') ADVANCE(82);
      if (lookahead == '^') ADVANCE(103);
      if (lookahead == 'e') ADVANCE(163);
      if (lookahead == '{') ADVANCE(90);
      if (lookahead == '|') ADVANCE(89);
      if (lookahead == '}') ADVANCE(91);
      if (lookahead == '~') ADVANCE(106);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(139);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(166);
      END_STATE();
    case 54:
      if (eof) ADVANCE(57);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(54)
      if (lookahead == '\r') SKIP(54)
      if (lookahead == '!') ADVANCE(9);
      if (lookahead == '#') ADVANCE(167);
      if (lookahead == '(') ADVANCE(61);
      if (lookahead == ')') ADVANCE(62);
      if (lookahead == '*') ADVANCE(64);
      if (lookahead == '+') ADVANCE(92);
      if (lookahead == ',') ADVANCE(63);
      if (lookahead == '-') ADVANCE(85);
      if (lookahead == '.') ADVANCE(4);
      if (lookahead == '0') ADVANCE(140);
      if (lookahead == ':') ADVANCE(71);
      if (lookahead == ';') ADVANCE(58);
      if (lookahead == '<') ADVANCE(109);
      if (lookahead == '=') ADVANCE(80);
      if (lookahead == '>') ADVANCE(114);
      if (lookahead == '@') ADVANCE(83);
      if (lookahead == '[') ADVANCE(81);
      if (lookahead == '\\') ADVANCE(26);
      if (lookahead == ']') ADVANCE(82);
      if (lookahead == '{') ADVANCE(90);
      if (lookahead == '|') ADVANCE(88);
      if (lookahead == '}') ADVANCE(91);
      if (lookahead == '~') ADVANCE(106);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(139);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(166);
      END_STATE();
    case 55:
      if (eof) ADVANCE(57);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(55)
      if (lookahead == '\r') SKIP(55)
      if (lookahead == '#') ADVANCE(167);
      if (lookahead == '(') ADVANCE(61);
      if (lookahead == '*') ADVANCE(64);
      if (lookahead == '+') ADVANCE(92);
      if (lookahead == '-') ADVANCE(85);
      if (lookahead == '.') ADVANCE(4);
      if (lookahead == '0') ADVANCE(140);
      if (lookahead == '@') ADVANCE(83);
      if (lookahead == '[') ADVANCE(81);
      if (lookahead == '\\') ADVANCE(26);
      if (lookahead == 'e') ADVANCE(164);
      if (lookahead == '{') ADVANCE(90);
      if (lookahead == '~') ADVANCE(106);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(139);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(166);
      END_STATE();
    case 56:
      if (eof) ADVANCE(57);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(56)
      if (lookahead == '\r') SKIP(56)
      if (lookahead == '#') ADVANCE(167);
      if (lookahead == '(') ADVANCE(61);
      if (lookahead == '*') ADVANCE(64);
      if (lookahead == '+') ADVANCE(92);
      if (lookahead == '-') ADVANCE(85);
      if (lookahead == '.') ADVANCE(4);
      if (lookahead == '0') ADVANCE(140);
      if (lookahead == '@') ADVANCE(83);
      if (lookahead == '[') ADVANCE(81);
      if (lookahead == '\\') ADVANCE(26);
      if (lookahead == 'e') ADVANCE(165);
      if (lookahead == '{') ADVANCE(90);
      if (lookahead == '~') ADVANCE(106);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(139);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(166);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(5);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(146);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(78);
      if (lookahead == '=') ADVANCE(120);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(77);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(15);
      if (lookahead == '=') ADVANCE(120);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(126);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_COLON_EQ);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '=') ADVANCE(70);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_except);
      if (lookahead == '*') ADVANCE(75);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(166);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_except);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(166);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_except_STAR);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      if (lookahead == '=') ADVANCE(125);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(111);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_AT);
      if (lookahead == '=') ADVANCE(122);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=') ADVANCE(119);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=') ADVANCE(119);
      if (lookahead == '>') ADVANCE(76);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(130);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=') ADVANCE(118);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '/') ADVANCE(99);
      if (lookahead == '=') ADVANCE(121);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '/') ADVANCE(98);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(124);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH);
      if (lookahead == '=') ADVANCE(123);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '=') ADVANCE(128);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(129);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(127);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(105);
      if (lookahead == '=') ADVANCE(110);
      if (lookahead == '>') ADVANCE(117);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(104);
      if (lookahead == '=') ADVANCE(110);
      if (lookahead == '>') ADVANCE(117);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '=') ADVANCE(110);
      if (lookahead == '>') ADVANCE(117);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(113);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(113);
      if (lookahead == '>') ADVANCE(69);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(113);
      if (lookahead == '>') ADVANCE(68);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_LT_GT);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_AT_EQ);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH_EQ);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_STAR_STAR_EQ);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(sym_ellipsis);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(sym__not_escape_sequence);
      if (!eof && lookahead == 0) ADVANCE(168);
      if (lookahead == '\n') ADVANCE(132);
      if (lookahead == '\r') ADVANCE(2);
      if (lookahead == 'N') ADVANCE(24);
      if (lookahead == 'U') ADVANCE(51);
      if (lookahead == 'u') ADVANCE(47);
      if (lookahead == 'x') ADVANCE(45);
      if (lookahead == '"' ||
          lookahead == '\'' ||
          lookahead == '\\' ||
          lookahead == 'a' ||
          lookahead == 'b' ||
          lookahead == 'f' ||
          lookahead == 'n' ||
          lookahead == 'r' ||
          ('t' <= lookahead && lookahead <= 'v')) ADVANCE(132);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(42);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(aux_sym_format_specifier_token1);
      if (!eof && lookahead == 0) ADVANCE(136);
      if (lookahead == '\r') ADVANCE(136);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(136);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(aux_sym_format_specifier_token1);
      if (lookahead == '\r') ADVANCE(135);
      if (lookahead == '#') ADVANCE(136);
      if (lookahead == '\\') ADVANCE(134);
      if (lookahead == '\t' ||
          lookahead == 11 ||
          lookahead == '\f' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(135);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(136);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(aux_sym_format_specifier_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(136);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(sym_type_conversion);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(sym_integer);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(148);
      if (lookahead == '_') ADVANCE(141);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(27);
      if (lookahead == 'J' ||
          lookahead == 'L' ||
          lookahead == 'j' ||
          lookahead == 'l') ADVANCE(138);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(139);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(148);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(21);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(22);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(23);
      if (lookahead == '_') ADVANCE(141);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(27);
      if (lookahead == 'J' ||
          lookahead == 'L' ||
          lookahead == 'j' ||
          lookahead == 'l') ADVANCE(138);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(139);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(148);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(27);
      if (lookahead == 'J' ||
          lookahead == 'L' ||
          lookahead == 'j' ||
          lookahead == 'l') ADVANCE(138);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(139);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(28);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(138);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(142);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(39);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(138);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(143);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(44);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(138);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(144);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(sym_float);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_') ADVANCE(148);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(27);
      if (lookahead == 'J' ||
          lookahead == 'L' ||
          lookahead == 'j' ||
          lookahead == 'l') ADVANCE(145);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(146);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_') ADVANCE(149);
      if (lookahead == 'J' ||
          lookahead == 'L' ||
          lookahead == 'j' ||
          lookahead == 'l') ADVANCE(145);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(147);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(27);
      if (lookahead == 'J' ||
          lookahead == 'L' ||
          lookahead == 'j' ||
          lookahead == 'l') ADVANCE(145);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(146);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == 'J' ||
          lookahead == 'L' ||
          lookahead == 'j' ||
          lookahead == 'l') ADVANCE(145);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(147);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '*') ADVANCE(75);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(166);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'c') ADVANCE(154);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(166);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'c') ADVANCE(155);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(166);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'c') ADVANCE(156);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(166);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(157);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(166);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(158);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(166);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(159);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(166);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'p') ADVANCE(160);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(166);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'p') ADVANCE(161);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(166);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'p') ADVANCE(162);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(166);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(73);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(166);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(150);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(166);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(74);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(166);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'x') ADVANCE(151);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(166);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'x') ADVANCE(152);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(166);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'x') ADVANCE(153);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(166);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(166);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(167);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(sym_line_continuation);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(0)
      if (lookahead == '\r') SKIP(0)
      if (lookahead == 'F') ADVANCE(1);
      if (lookahead == 'N') ADVANCE(2);
      if (lookahead == 'T') ADVANCE(3);
      if (lookahead == '_') ADVANCE(4);
      if (lookahead == 'a') ADVANCE(5);
      if (lookahead == 'b') ADVANCE(6);
      if (lookahead == 'c') ADVANCE(7);
      if (lookahead == 'd') ADVANCE(8);
      if (lookahead == 'e') ADVANCE(9);
      if (lookahead == 'f') ADVANCE(10);
      if (lookahead == 'g') ADVANCE(11);
      if (lookahead == 'i') ADVANCE(12);
      if (lookahead == 'l') ADVANCE(13);
      if (lookahead == 'm') ADVANCE(14);
      if (lookahead == 'n') ADVANCE(15);
      if (lookahead == 'o') ADVANCE(16);
      if (lookahead == 'p') ADVANCE(17);
      if (lookahead == 'r') ADVANCE(18);
      if (lookahead == 't') ADVANCE(19);
      if (lookahead == 'w') ADVANCE(20);
      if (lookahead == 'y') ADVANCE(21);
      END_STATE();
    case 1:
      if (lookahead == 'a') ADVANCE(22);
      END_STATE();
    case 2:
      if (lookahead == 'o') ADVANCE(23);
      END_STATE();
    case 3:
      if (lookahead == 'r') ADVANCE(24);
      END_STATE();
    case 4:
      ACCEPT_TOKEN(anon_sym__);
      if (lookahead == '_') ADVANCE(25);
      END_STATE();
    case 5:
      if (lookahead == 'n') ADVANCE(26);
      if (lookahead == 's') ADVANCE(27);
      if (lookahead == 'w') ADVANCE(28);
      END_STATE();
    case 6:
      if (lookahead == 'r') ADVANCE(29);
      END_STATE();
    case 7:
      if (lookahead == 'a') ADVANCE(30);
      if (lookahead == 'l') ADVANCE(31);
      if (lookahead == 'o') ADVANCE(32);
      END_STATE();
    case 8:
      if (lookahead == 'e') ADVANCE(33);
      END_STATE();
    case 9:
      if (lookahead == 'l') ADVANCE(34);
      if (lookahead == 'x') ADVANCE(35);
      END_STATE();
    case 10:
      if (lookahead == 'i') ADVANCE(36);
      if (lookahead == 'o') ADVANCE(37);
      if (lookahead == 'r') ADVANCE(38);
      END_STATE();
    case 11:
      if (lookahead == 'l') ADVANCE(39);
      END_STATE();
    case 12:
      if (lookahead == 'f') ADVANCE(40);
      if (lookahead == 'm') ADVANCE(41);
      if (lookahead == 'n') ADVANCE(42);
      if (lookahead == 's') ADVANCE(43);
      END_STATE();
    case 13:
      if (lookahead == 'a') ADVANCE(44);
      END_STATE();
    case 14:
      if (lookahead == 'a') ADVANCE(45);
      END_STATE();
    case 15:
      if (lookahead == 'o') ADVANCE(46);
      END_STATE();
    case 16:
      if (lookahead == 'r') ADVANCE(47);
      END_STATE();
    case 17:
      if (lookahead == 'a') ADVANCE(48);
      if (lookahead == 'r') ADVANCE(49);
      END_STATE();
    case 18:
      if (lookahead == 'a') ADVANCE(50);
      if (lookahead == 'e') ADVANCE(51);
      END_STATE();
    case 19:
      if (lookahead == 'r') ADVANCE(52);
      if (lookahead == 'y') ADVANCE(53);
      END_STATE();
    case 20:
      if (lookahead == 'h') ADVANCE(54);
      if (lookahead == 'i') ADVANCE(55);
      END_STATE();
    case 21:
      if (lookahead == 'i') ADVANCE(56);
      END_STATE();
    case 22:
      if (lookahead == 'l') ADVANCE(57);
      END_STATE();
    case 23:
      if (lookahead == 'n') ADVANCE(58);
      END_STATE();
    case 24:
      if (lookahead == 'u') ADVANCE(59);
      END_STATE();
    case 25:
      if (lookahead == 'f') ADVANCE(60);
      END_STATE();
    case 26:
      if (lookahead == 'd') ADVANCE(61);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 's') ADVANCE(62);
      if (lookahead == 'y') ADVANCE(63);
      END_STATE();
    case 28:
      if (lookahead == 'a') ADVANCE(64);
      END_STATE();
    case 29:
      if (lookahead == 'e') ADVANCE(65);
      END_STATE();
    case 30:
      if (lookahead == 's') ADVANCE(66);
      END_STATE();
    case 31:
      if (lookahead == 'a') ADVANCE(67);
      END_STATE();
    case 32:
      if (lookahead == 'n') ADVANCE(68);
      END_STATE();
    case 33:
      if (lookahead == 'f') ADVANCE(69);
      if (lookahead == 'l') ADVANCE(70);
      END_STATE();
    case 34:
      if (lookahead == 'i') ADVANCE(71);
      if (lookahead == 's') ADVANCE(72);
      END_STATE();
    case 35:
      if (lookahead == 'e') ADVANCE(73);
      END_STATE();
    case 36:
      if (lookahead == 'n') ADVANCE(74);
      END_STATE();
    case 37:
      if (lookahead == 'r') ADVANCE(75);
      END_STATE();
    case 38:
      if (lookahead == 'o') ADVANCE(76);
      END_STATE();
    case 39:
      if (lookahead == 'o') ADVANCE(77);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 41:
      if (lookahead == 'p') ADVANCE(78);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_is);
      END_STATE();
    case 44:
      if (lookahead == 'm') ADVANCE(79);
      END_STATE();
    case 45:
      if (lookahead == 't') ADVANCE(80);
      END_STATE();
    case 46:
      if (lookahead == 'n') ADVANCE(81);
      if (lookahead == 't') ADVANCE(82);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_or);
      END_STATE();
    case 48:
      if (lookahead == 's') ADVANCE(83);
      END_STATE();
    case 49:
      if (lookahead == 'i') ADVANCE(84);
      END_STATE();
    case 50:
      if (lookahead == 'i') ADVANCE(85);
      END_STATE();
    case 51:
      if (lookahead == 't') ADVANCE(86);
      END_STATE();
    case 52:
      if (lookahead == 'y') ADVANCE(87);
      END_STATE();
    case 53:
      if (lookahead == 'p') ADVANCE(88);
      END_STATE();
    case 54:
      if (lookahead == 'i') ADVANCE(89);
      END_STATE();
    case 55:
      if (lookahead == 't') ADVANCE(90);
      END_STATE();
    case 56:
      if (lookahead == 'e') ADVANCE(91);
      END_STATE();
    case 57:
      if (lookahead == 's') ADVANCE(92);
      END_STATE();
    case 58:
      if (lookahead == 'e') ADVANCE(93);
      END_STATE();
    case 59:
      if (lookahead == 'e') ADVANCE(94);
      END_STATE();
    case 60:
      if (lookahead == 'u') ADVANCE(95);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_and);
      END_STATE();
    case 62:
      if (lookahead == 'e') ADVANCE(96);
      END_STATE();
    case 63:
      if (lookahead == 'n') ADVANCE(97);
      END_STATE();
    case 64:
      if (lookahead == 'i') ADVANCE(98);
      END_STATE();
    case 65:
      if (lookahead == 'a') ADVANCE(99);
      END_STATE();
    case 66:
      if (lookahead == 'e') ADVANCE(100);
      END_STATE();
    case 67:
      if (lookahead == 's') ADVANCE(101);
      END_STATE();
    case 68:
      if (lookahead == 't') ADVANCE(102);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_def);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_del);
      END_STATE();
    case 71:
      if (lookahead == 'f') ADVANCE(103);
      END_STATE();
    case 72:
      if (lookahead == 'e') ADVANCE(104);
      END_STATE();
    case 73:
      if (lookahead == 'c') ADVANCE(105);
      END_STATE();
    case 74:
      if (lookahead == 'a') ADVANCE(106);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 76:
      if (lookahead == 'm') ADVANCE(107);
      END_STATE();
    case 77:
      if (lookahead == 'b') ADVANCE(108);
      END_STATE();
    case 78:
      if (lookahead == 'o') ADVANCE(109);
      END_STATE();
    case 79:
      if (lookahead == 'b') ADVANCE(110);
      END_STATE();
    case 80:
      if (lookahead == 'c') ADVANCE(111);
      END_STATE();
    case 81:
      if (lookahead == 'l') ADVANCE(112);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_not);
      END_STATE();
    case 83:
      if (lookahead == 's') ADVANCE(113);
      END_STATE();
    case 84:
      if (lookahead == 'n') ADVANCE(114);
      END_STATE();
    case 85:
      if (lookahead == 's') ADVANCE(115);
      END_STATE();
    case 86:
      if (lookahead == 'u') ADVANCE(116);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 88:
      if (lookahead == 'e') ADVANCE(117);
      END_STATE();
    case 89:
      if (lookahead == 'l') ADVANCE(118);
      END_STATE();
    case 90:
      if (lookahead == 'h') ADVANCE(119);
      END_STATE();
    case 91:
      if (lookahead == 'l') ADVANCE(120);
      END_STATE();
    case 92:
      if (lookahead == 'e') ADVANCE(121);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(sym_none);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 95:
      if (lookahead == 't') ADVANCE(122);
      END_STATE();
    case 96:
      if (lookahead == 'r') ADVANCE(123);
      END_STATE();
    case 97:
      if (lookahead == 'c') ADVANCE(124);
      END_STATE();
    case 98:
      if (lookahead == 't') ADVANCE(125);
      END_STATE();
    case 99:
      if (lookahead == 'k') ADVANCE(126);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 101:
      if (lookahead == 's') ADVANCE(127);
      END_STATE();
    case 102:
      if (lookahead == 'i') ADVANCE(128);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_elif);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_exec);
      END_STATE();
    case 106:
      if (lookahead == 'l') ADVANCE(129);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 108:
      if (lookahead == 'a') ADVANCE(130);
      END_STATE();
    case 109:
      if (lookahead == 'r') ADVANCE(131);
      END_STATE();
    case 110:
      if (lookahead == 'd') ADVANCE(132);
      END_STATE();
    case 111:
      if (lookahead == 'h') ADVANCE(133);
      END_STATE();
    case 112:
      if (lookahead == 'o') ADVANCE(134);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_pass);
      END_STATE();
    case 114:
      if (lookahead == 't') ADVANCE(135);
      END_STATE();
    case 115:
      if (lookahead == 'e') ADVANCE(136);
      END_STATE();
    case 116:
      if (lookahead == 'r') ADVANCE(137);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_type);
      END_STATE();
    case 118:
      if (lookahead == 'e') ADVANCE(138);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 120:
      if (lookahead == 'd') ADVANCE(139);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 122:
      if (lookahead == 'u') ADVANCE(140);
      END_STATE();
    case 123:
      if (lookahead == 't') ADVANCE(141);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_async);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 128:
      if (lookahead == 'n') ADVANCE(142);
      END_STATE();
    case 129:
      if (lookahead == 'l') ADVANCE(143);
      END_STATE();
    case 130:
      if (lookahead == 'l') ADVANCE(144);
      END_STATE();
    case 131:
      if (lookahead == 't') ADVANCE(145);
      END_STATE();
    case 132:
      if (lookahead == 'a') ADVANCE(146);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_match);
      END_STATE();
    case 134:
      if (lookahead == 'c') ADVANCE(147);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_print);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_raise);
      END_STATE();
    case 137:
      if (lookahead == 'n') ADVANCE(148);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 140:
      if (lookahead == 'r') ADVANCE(149);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_assert);
      END_STATE();
    case 142:
      if (lookahead == 'u') ADVANCE(150);
      END_STATE();
    case 143:
      if (lookahead == 'y') ADVANCE(151);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_global);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_lambda);
      END_STATE();
    case 147:
      if (lookahead == 'a') ADVANCE(152);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 149:
      if (lookahead == 'e') ADVANCE(153);
      END_STATE();
    case 150:
      if (lookahead == 'e') ADVANCE(154);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 152:
      if (lookahead == 'l') ADVANCE(155);
      END_STATE();
    case 153:
      if (lookahead == '_') ADVANCE(156);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_nonlocal);
      END_STATE();
    case 156:
      if (lookahead == '_') ADVANCE(157);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym___future__);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 54, .external_lex_state = 2},
  [2] = {.lex_state = 54, .external_lex_state = 3},
  [3] = {.lex_state = 54, .external_lex_state = 3},
  [4] = {.lex_state = 54, .external_lex_state = 3},
  [5] = {.lex_state = 54, .external_lex_state = 3},
  [6] = {.lex_state = 54, .external_lex_state = 3},
  [7] = {.lex_state = 54, .external_lex_state = 3},
  [8] = {.lex_state = 54, .external_lex_state = 3},
  [9] = {.lex_state = 54, .external_lex_state = 3},
  [10] = {.lex_state = 54, .external_lex_state = 3},
  [11] = {.lex_state = 54, .external_lex_state = 3},
  [12] = {.lex_state = 54, .external_lex_state = 3},
  [13] = {.lex_state = 54, .external_lex_state = 3},
  [14] = {.lex_state = 54, .external_lex_state = 3},
  [15] = {.lex_state = 54, .external_lex_state = 3},
  [16] = {.lex_state = 54, .external_lex_state = 3},
  [17] = {.lex_state = 54, .external_lex_state = 3},
  [18] = {.lex_state = 54, .external_lex_state = 3},
  [19] = {.lex_state = 54, .external_lex_state = 3},
  [20] = {.lex_state = 54, .external_lex_state = 3},
  [21] = {.lex_state = 54, .external_lex_state = 3},
  [22] = {.lex_state = 54, .external_lex_state = 3},
  [23] = {.lex_state = 54, .external_lex_state = 3},
  [24] = {.lex_state = 54, .external_lex_state = 3},
  [25] = {.lex_state = 54, .external_lex_state = 3},
  [26] = {.lex_state = 54, .external_lex_state = 3},
  [27] = {.lex_state = 54, .external_lex_state = 3},
  [28] = {.lex_state = 54, .external_lex_state = 3},
  [29] = {.lex_state = 54, .external_lex_state = 3},
  [30] = {.lex_state = 54, .external_lex_state = 3},
  [31] = {.lex_state = 54, .external_lex_state = 3},
  [32] = {.lex_state = 54, .external_lex_state = 3},
  [33] = {.lex_state = 54, .external_lex_state = 3},
  [34] = {.lex_state = 54, .external_lex_state = 3},
  [35] = {.lex_state = 54, .external_lex_state = 3},
  [36] = {.lex_state = 54, .external_lex_state = 3},
  [37] = {.lex_state = 54, .external_lex_state = 3},
  [38] = {.lex_state = 54, .external_lex_state = 3},
  [39] = {.lex_state = 54, .external_lex_state = 3},
  [40] = {.lex_state = 54, .external_lex_state = 3},
  [41] = {.lex_state = 54, .external_lex_state = 3},
  [42] = {.lex_state = 54, .external_lex_state = 3},
  [43] = {.lex_state = 54, .external_lex_state = 3},
  [44] = {.lex_state = 54, .external_lex_state = 3},
  [45] = {.lex_state = 54, .external_lex_state = 3},
  [46] = {.lex_state = 54, .external_lex_state = 3},
  [47] = {.lex_state = 54, .external_lex_state = 3},
  [48] = {.lex_state = 54, .external_lex_state = 3},
  [49] = {.lex_state = 54, .external_lex_state = 3},
  [50] = {.lex_state = 54, .external_lex_state = 3},
  [51] = {.lex_state = 54, .external_lex_state = 3},
  [52] = {.lex_state = 54, .external_lex_state = 3},
  [53] = {.lex_state = 54, .external_lex_state = 3},
  [54] = {.lex_state = 54, .external_lex_state = 3},
  [55] = {.lex_state = 54, .external_lex_state = 3},
  [56] = {.lex_state = 54, .external_lex_state = 3},
  [57] = {.lex_state = 54, .external_lex_state = 3},
  [58] = {.lex_state = 54, .external_lex_state = 3},
  [59] = {.lex_state = 54, .external_lex_state = 3},
  [60] = {.lex_state = 54, .external_lex_state = 3},
  [61] = {.lex_state = 54, .external_lex_state = 3},
  [62] = {.lex_state = 54, .external_lex_state = 3},
  [63] = {.lex_state = 54, .external_lex_state = 3},
  [64] = {.lex_state = 54, .external_lex_state = 3},
  [65] = {.lex_state = 54, .external_lex_state = 3},
  [66] = {.lex_state = 54, .external_lex_state = 2},
  [67] = {.lex_state = 54, .external_lex_state = 3},
  [68] = {.lex_state = 54, .external_lex_state = 3},
  [69] = {.lex_state = 54, .external_lex_state = 3},
  [70] = {.lex_state = 54, .external_lex_state = 3},
  [71] = {.lex_state = 54, .external_lex_state = 2},
  [72] = {.lex_state = 54, .external_lex_state = 3},
  [73] = {.lex_state = 29, .external_lex_state = 4},
  [74] = {.lex_state = 29, .external_lex_state = 4},
  [75] = {.lex_state = 30, .external_lex_state = 5},
  [76] = {.lex_state = 30, .external_lex_state = 5},
  [77] = {.lex_state = 30, .external_lex_state = 5},
  [78] = {.lex_state = 30, .external_lex_state = 5},
  [79] = {.lex_state = 30, .external_lex_state = 5},
  [80] = {.lex_state = 30, .external_lex_state = 5},
  [81] = {.lex_state = 30, .external_lex_state = 5},
  [82] = {.lex_state = 30, .external_lex_state = 5},
  [83] = {.lex_state = 29, .external_lex_state = 4},
  [84] = {.lex_state = 29, .external_lex_state = 4},
  [85] = {.lex_state = 29, .external_lex_state = 4},
  [86] = {.lex_state = 29, .external_lex_state = 4},
  [87] = {.lex_state = 54, .external_lex_state = 5},
  [88] = {.lex_state = 54, .external_lex_state = 5},
  [89] = {.lex_state = 54, .external_lex_state = 5},
  [90] = {.lex_state = 54, .external_lex_state = 5},
  [91] = {.lex_state = 54, .external_lex_state = 5},
  [92] = {.lex_state = 54, .external_lex_state = 5},
  [93] = {.lex_state = 54, .external_lex_state = 5},
  [94] = {.lex_state = 54, .external_lex_state = 5},
  [95] = {.lex_state = 54, .external_lex_state = 5},
  [96] = {.lex_state = 54, .external_lex_state = 5},
  [97] = {.lex_state = 54, .external_lex_state = 5},
  [98] = {.lex_state = 54, .external_lex_state = 5},
  [99] = {.lex_state = 54, .external_lex_state = 5},
  [100] = {.lex_state = 54, .external_lex_state = 5},
  [101] = {.lex_state = 54, .external_lex_state = 5},
  [102] = {.lex_state = 54, .external_lex_state = 5},
  [103] = {.lex_state = 54, .external_lex_state = 5},
  [104] = {.lex_state = 54, .external_lex_state = 5},
  [105] = {.lex_state = 54, .external_lex_state = 5},
  [106] = {.lex_state = 54, .external_lex_state = 5},
  [107] = {.lex_state = 54, .external_lex_state = 5},
  [108] = {.lex_state = 54, .external_lex_state = 5},
  [109] = {.lex_state = 54, .external_lex_state = 5},
  [110] = {.lex_state = 54, .external_lex_state = 5},
  [111] = {.lex_state = 54, .external_lex_state = 5},
  [112] = {.lex_state = 54, .external_lex_state = 5},
  [113] = {.lex_state = 54, .external_lex_state = 5},
  [114] = {.lex_state = 54, .external_lex_state = 5},
  [115] = {.lex_state = 54, .external_lex_state = 5},
  [116] = {.lex_state = 54, .external_lex_state = 5},
  [117] = {.lex_state = 54, .external_lex_state = 5},
  [118] = {.lex_state = 54, .external_lex_state = 5},
  [119] = {.lex_state = 54, .external_lex_state = 5},
  [120] = {.lex_state = 54, .external_lex_state = 5},
  [121] = {.lex_state = 54, .external_lex_state = 5},
  [122] = {.lex_state = 54, .external_lex_state = 5},
  [123] = {.lex_state = 54, .external_lex_state = 5},
  [124] = {.lex_state = 54, .external_lex_state = 5},
  [125] = {.lex_state = 54, .external_lex_state = 5},
  [126] = {.lex_state = 54, .external_lex_state = 5},
  [127] = {.lex_state = 54, .external_lex_state = 5},
  [128] = {.lex_state = 54, .external_lex_state = 5},
  [129] = {.lex_state = 54, .external_lex_state = 5},
  [130] = {.lex_state = 54, .external_lex_state = 5},
  [131] = {.lex_state = 54, .external_lex_state = 5},
  [132] = {.lex_state = 54, .external_lex_state = 5},
  [133] = {.lex_state = 54, .external_lex_state = 5},
  [134] = {.lex_state = 54, .external_lex_state = 5},
  [135] = {.lex_state = 54, .external_lex_state = 5},
  [136] = {.lex_state = 54, .external_lex_state = 5},
  [137] = {.lex_state = 54, .external_lex_state = 4},
  [138] = {.lex_state = 54, .external_lex_state = 4},
  [139] = {.lex_state = 54, .external_lex_state = 4},
  [140] = {.lex_state = 54, .external_lex_state = 4},
  [141] = {.lex_state = 54, .external_lex_state = 4},
  [142] = {.lex_state = 54, .external_lex_state = 4},
  [143] = {.lex_state = 54, .external_lex_state = 4},
  [144] = {.lex_state = 54, .external_lex_state = 4},
  [145] = {.lex_state = 54, .external_lex_state = 4},
  [146] = {.lex_state = 54, .external_lex_state = 4},
  [147] = {.lex_state = 54, .external_lex_state = 4},
  [148] = {.lex_state = 54, .external_lex_state = 4},
  [149] = {.lex_state = 54, .external_lex_state = 4},
  [150] = {.lex_state = 54, .external_lex_state = 4},
  [151] = {.lex_state = 54, .external_lex_state = 4},
  [152] = {.lex_state = 54, .external_lex_state = 4},
  [153] = {.lex_state = 54, .external_lex_state = 2},
  [154] = {.lex_state = 29, .external_lex_state = 4},
  [155] = {.lex_state = 29, .external_lex_state = 4},
  [156] = {.lex_state = 35, .external_lex_state = 4},
  [157] = {.lex_state = 30, .external_lex_state = 4},
  [158] = {.lex_state = 36, .external_lex_state = 4},
  [159] = {.lex_state = 36, .external_lex_state = 4},
  [160] = {.lex_state = 30, .external_lex_state = 6},
  [161] = {.lex_state = 36, .external_lex_state = 6},
  [162] = {.lex_state = 30, .external_lex_state = 6},
  [163] = {.lex_state = 30, .external_lex_state = 2},
  [164] = {.lex_state = 30, .external_lex_state = 6},
  [165] = {.lex_state = 30, .external_lex_state = 7},
  [166] = {.lex_state = 30, .external_lex_state = 6},
  [167] = {.lex_state = 36, .external_lex_state = 6},
  [168] = {.lex_state = 36, .external_lex_state = 7},
  [169] = {.lex_state = 30, .external_lex_state = 7},
  [170] = {.lex_state = 36, .external_lex_state = 6},
  [171] = {.lex_state = 30, .external_lex_state = 8},
  [172] = {.lex_state = 36, .external_lex_state = 2},
  [173] = {.lex_state = 36, .external_lex_state = 2},
  [174] = {.lex_state = 35, .external_lex_state = 4},
  [175] = {.lex_state = 30, .external_lex_state = 8},
  [176] = {.lex_state = 30, .external_lex_state = 8},
  [177] = {.lex_state = 30, .external_lex_state = 7},
  [178] = {.lex_state = 36, .external_lex_state = 8},
  [179] = {.lex_state = 30, .external_lex_state = 7},
  [180] = {.lex_state = 30, .external_lex_state = 8},
  [181] = {.lex_state = 36, .external_lex_state = 7},
  [182] = {.lex_state = 30, .external_lex_state = 7},
  [183] = {.lex_state = 30, .external_lex_state = 7},
  [184] = {.lex_state = 30, .external_lex_state = 7},
  [185] = {.lex_state = 30, .external_lex_state = 8},
  [186] = {.lex_state = 36, .external_lex_state = 8},
  [187] = {.lex_state = 35, .external_lex_state = 2},
  [188] = {.lex_state = 35, .external_lex_state = 2},
  [189] = {.lex_state = 54, .external_lex_state = 7},
  [190] = {.lex_state = 54, .external_lex_state = 7},
  [191] = {.lex_state = 30, .external_lex_state = 6},
  [192] = {.lex_state = 54, .external_lex_state = 7},
  [193] = {.lex_state = 54, .external_lex_state = 7},
  [194] = {.lex_state = 30, .external_lex_state = 6},
  [195] = {.lex_state = 54, .external_lex_state = 8},
  [196] = {.lex_state = 54, .external_lex_state = 8},
  [197] = {.lex_state = 54, .external_lex_state = 7},
  [198] = {.lex_state = 54, .external_lex_state = 8},
  [199] = {.lex_state = 30, .external_lex_state = 6},
  [200] = {.lex_state = 30, .external_lex_state = 6},
  [201] = {.lex_state = 54, .external_lex_state = 7},
  [202] = {.lex_state = 54, .external_lex_state = 8},
  [203] = {.lex_state = 54, .external_lex_state = 2},
  [204] = {.lex_state = 54, .external_lex_state = 7},
  [205] = {.lex_state = 30, .external_lex_state = 6},
  [206] = {.lex_state = 54, .external_lex_state = 7},
  [207] = {.lex_state = 54, .external_lex_state = 2},
  [208] = {.lex_state = 54, .external_lex_state = 8},
  [209] = {.lex_state = 54, .external_lex_state = 7},
  [210] = {.lex_state = 54, .external_lex_state = 8},
  [211] = {.lex_state = 54, .external_lex_state = 8},
  [212] = {.lex_state = 30, .external_lex_state = 6},
  [213] = {.lex_state = 54, .external_lex_state = 8},
  [214] = {.lex_state = 54, .external_lex_state = 8},
  [215] = {.lex_state = 30, .external_lex_state = 6},
  [216] = {.lex_state = 54, .external_lex_state = 2},
  [217] = {.lex_state = 54, .external_lex_state = 8},
  [218] = {.lex_state = 54, .external_lex_state = 7},
  [219] = {.lex_state = 54, .external_lex_state = 7},
  [220] = {.lex_state = 30, .external_lex_state = 6},
  [221] = {.lex_state = 54, .external_lex_state = 8},
  [222] = {.lex_state = 31, .external_lex_state = 4},
  [223] = {.lex_state = 31, .external_lex_state = 4},
  [224] = {.lex_state = 54, .external_lex_state = 2},
  [225] = {.lex_state = 54, .external_lex_state = 2},
  [226] = {.lex_state = 30, .external_lex_state = 7},
  [227] = {.lex_state = 30, .external_lex_state = 2},
  [228] = {.lex_state = 30, .external_lex_state = 2},
  [229] = {.lex_state = 30, .external_lex_state = 2},
  [230] = {.lex_state = 30, .external_lex_state = 7},
  [231] = {.lex_state = 30, .external_lex_state = 2},
  [232] = {.lex_state = 30, .external_lex_state = 2},
  [233] = {.lex_state = 30, .external_lex_state = 7},
  [234] = {.lex_state = 31, .external_lex_state = 2},
  [235] = {.lex_state = 30, .external_lex_state = 2},
  [236] = {.lex_state = 30, .external_lex_state = 7},
  [237] = {.lex_state = 30, .external_lex_state = 2},
  [238] = {.lex_state = 30, .external_lex_state = 2},
  [239] = {.lex_state = 30, .external_lex_state = 2},
  [240] = {.lex_state = 30, .external_lex_state = 7},
  [241] = {.lex_state = 30, .external_lex_state = 2},
  [242] = {.lex_state = 30, .external_lex_state = 7},
  [243] = {.lex_state = 30, .external_lex_state = 2},
  [244] = {.lex_state = 30, .external_lex_state = 2},
  [245] = {.lex_state = 30, .external_lex_state = 2},
  [246] = {.lex_state = 31, .external_lex_state = 2},
  [247] = {.lex_state = 30, .external_lex_state = 2},
  [248] = {.lex_state = 30, .external_lex_state = 7},
  [249] = {.lex_state = 30, .external_lex_state = 2},
  [250] = {.lex_state = 30, .external_lex_state = 2},
  [251] = {.lex_state = 30, .external_lex_state = 2},
  [252] = {.lex_state = 30, .external_lex_state = 7},
  [253] = {.lex_state = 30, .external_lex_state = 2},
  [254] = {.lex_state = 30, .external_lex_state = 2},
  [255] = {.lex_state = 30, .external_lex_state = 2},
  [256] = {.lex_state = 30, .external_lex_state = 2},
  [257] = {.lex_state = 30, .external_lex_state = 2},
  [258] = {.lex_state = 54, .external_lex_state = 6},
  [259] = {.lex_state = 30, .external_lex_state = 2},
  [260] = {.lex_state = 30, .external_lex_state = 2},
  [261] = {.lex_state = 30, .external_lex_state = 2},
  [262] = {.lex_state = 30, .external_lex_state = 7},
  [263] = {.lex_state = 54, .external_lex_state = 7},
  [264] = {.lex_state = 30, .external_lex_state = 7},
  [265] = {.lex_state = 30, .external_lex_state = 7},
  [266] = {.lex_state = 54, .external_lex_state = 8},
  [267] = {.lex_state = 54, .external_lex_state = 7},
  [268] = {.lex_state = 54, .external_lex_state = 8},
  [269] = {.lex_state = 30, .external_lex_state = 7},
  [270] = {.lex_state = 54, .external_lex_state = 7},
  [271] = {.lex_state = 30, .external_lex_state = 7},
  [272] = {.lex_state = 30, .external_lex_state = 7},
  [273] = {.lex_state = 54, .external_lex_state = 7},
  [274] = {.lex_state = 30, .external_lex_state = 7},
  [275] = {.lex_state = 30, .external_lex_state = 7},
  [276] = {.lex_state = 30, .external_lex_state = 7},
  [277] = {.lex_state = 30, .external_lex_state = 7},
  [278] = {.lex_state = 30, .external_lex_state = 7},
  [279] = {.lex_state = 30, .external_lex_state = 7},
  [280] = {.lex_state = 30, .external_lex_state = 7},
  [281] = {.lex_state = 30, .external_lex_state = 7},
  [282] = {.lex_state = 30, .external_lex_state = 7},
  [283] = {.lex_state = 30, .external_lex_state = 7},
  [284] = {.lex_state = 30, .external_lex_state = 7},
  [285] = {.lex_state = 30, .external_lex_state = 7},
  [286] = {.lex_state = 30, .external_lex_state = 7},
  [287] = {.lex_state = 30, .external_lex_state = 7},
  [288] = {.lex_state = 54, .external_lex_state = 7},
  [289] = {.lex_state = 30, .external_lex_state = 7},
  [290] = {.lex_state = 30, .external_lex_state = 7},
  [291] = {.lex_state = 54, .external_lex_state = 8},
  [292] = {.lex_state = 54, .external_lex_state = 8},
  [293] = {.lex_state = 54, .external_lex_state = 7},
  [294] = {.lex_state = 54, .external_lex_state = 7},
  [295] = {.lex_state = 30, .external_lex_state = 7},
  [296] = {.lex_state = 30, .external_lex_state = 7},
  [297] = {.lex_state = 54, .external_lex_state = 7},
  [298] = {.lex_state = 54, .external_lex_state = 8},
  [299] = {.lex_state = 30, .external_lex_state = 7},
  [300] = {.lex_state = 30, .external_lex_state = 7},
  [301] = {.lex_state = 30, .external_lex_state = 7},
  [302] = {.lex_state = 54, .external_lex_state = 7},
  [303] = {.lex_state = 30, .external_lex_state = 7},
  [304] = {.lex_state = 30, .external_lex_state = 7},
  [305] = {.lex_state = 54, .external_lex_state = 7},
  [306] = {.lex_state = 54, .external_lex_state = 7},
  [307] = {.lex_state = 54, .external_lex_state = 8},
  [308] = {.lex_state = 54, .external_lex_state = 7},
  [309] = {.lex_state = 54, .external_lex_state = 8},
  [310] = {.lex_state = 54, .external_lex_state = 7},
  [311] = {.lex_state = 30, .external_lex_state = 7},
  [312] = {.lex_state = 54, .external_lex_state = 7},
  [313] = {.lex_state = 54, .external_lex_state = 8},
  [314] = {.lex_state = 30, .external_lex_state = 7},
  [315] = {.lex_state = 54, .external_lex_state = 7},
  [316] = {.lex_state = 30, .external_lex_state = 7},
  [317] = {.lex_state = 30, .external_lex_state = 7},
  [318] = {.lex_state = 54, .external_lex_state = 6},
  [319] = {.lex_state = 54, .external_lex_state = 6},
  [320] = {.lex_state = 54, .external_lex_state = 7},
  [321] = {.lex_state = 54, .external_lex_state = 8},
  [322] = {.lex_state = 54, .external_lex_state = 7},
  [323] = {.lex_state = 54, .external_lex_state = 8},
  [324] = {.lex_state = 54, .external_lex_state = 6},
  [325] = {.lex_state = 54, .external_lex_state = 8},
  [326] = {.lex_state = 54, .external_lex_state = 7},
  [327] = {.lex_state = 54, .external_lex_state = 6},
  [328] = {.lex_state = 54, .external_lex_state = 8},
  [329] = {.lex_state = 54, .external_lex_state = 6},
  [330] = {.lex_state = 54, .external_lex_state = 7},
  [331] = {.lex_state = 30, .external_lex_state = 2},
  [332] = {.lex_state = 54, .external_lex_state = 6},
  [333] = {.lex_state = 54, .external_lex_state = 7},
  [334] = {.lex_state = 54, .external_lex_state = 8},
  [335] = {.lex_state = 54, .external_lex_state = 7},
  [336] = {.lex_state = 54, .external_lex_state = 6},
  [337] = {.lex_state = 54, .external_lex_state = 8},
  [338] = {.lex_state = 54, .external_lex_state = 6},
  [339] = {.lex_state = 36, .external_lex_state = 6},
  [340] = {.lex_state = 30, .external_lex_state = 6},
  [341] = {.lex_state = 30, .external_lex_state = 6},
  [342] = {.lex_state = 30, .external_lex_state = 6},
  [343] = {.lex_state = 30, .external_lex_state = 6},
  [344] = {.lex_state = 54, .external_lex_state = 8},
  [345] = {.lex_state = 30, .external_lex_state = 6},
  [346] = {.lex_state = 30, .external_lex_state = 6},
  [347] = {.lex_state = 30, .external_lex_state = 6},
  [348] = {.lex_state = 30, .external_lex_state = 6},
  [349] = {.lex_state = 54, .external_lex_state = 2},
  [350] = {.lex_state = 54, .external_lex_state = 2},
  [351] = {.lex_state = 30, .external_lex_state = 6},
  [352] = {.lex_state = 30, .external_lex_state = 6},
  [353] = {.lex_state = 30, .external_lex_state = 6},
  [354] = {.lex_state = 30, .external_lex_state = 6},
  [355] = {.lex_state = 30, .external_lex_state = 6},
  [356] = {.lex_state = 30, .external_lex_state = 6},
  [357] = {.lex_state = 54, .external_lex_state = 7},
  [358] = {.lex_state = 30, .external_lex_state = 6},
  [359] = {.lex_state = 54, .external_lex_state = 4},
  [360] = {.lex_state = 54, .external_lex_state = 4},
  [361] = {.lex_state = 30, .external_lex_state = 6},
  [362] = {.lex_state = 54, .external_lex_state = 2},
  [363] = {.lex_state = 54, .external_lex_state = 8},
  [364] = {.lex_state = 54, .external_lex_state = 8},
  [365] = {.lex_state = 54, .external_lex_state = 8},
  [366] = {.lex_state = 54, .external_lex_state = 8},
  [367] = {.lex_state = 54, .external_lex_state = 8},
  [368] = {.lex_state = 54, .external_lex_state = 4},
  [369] = {.lex_state = 54, .external_lex_state = 8},
  [370] = {.lex_state = 54, .external_lex_state = 8},
  [371] = {.lex_state = 54, .external_lex_state = 8},
  [372] = {.lex_state = 54, .external_lex_state = 8},
  [373] = {.lex_state = 36, .external_lex_state = 7},
  [374] = {.lex_state = 54, .external_lex_state = 8},
  [375] = {.lex_state = 30, .external_lex_state = 2},
  [376] = {.lex_state = 54, .external_lex_state = 8},
  [377] = {.lex_state = 54, .external_lex_state = 8},
  [378] = {.lex_state = 54, .external_lex_state = 8},
  [379] = {.lex_state = 54, .external_lex_state = 8},
  [380] = {.lex_state = 54, .external_lex_state = 8},
  [381] = {.lex_state = 54, .external_lex_state = 8},
  [382] = {.lex_state = 54, .external_lex_state = 4},
  [383] = {.lex_state = 54, .external_lex_state = 8},
  [384] = {.lex_state = 54, .external_lex_state = 8},
  [385] = {.lex_state = 54, .external_lex_state = 8},
  [386] = {.lex_state = 54, .external_lex_state = 4},
  [387] = {.lex_state = 54, .external_lex_state = 8},
  [388] = {.lex_state = 54, .external_lex_state = 8},
  [389] = {.lex_state = 54, .external_lex_state = 8},
  [390] = {.lex_state = 54, .external_lex_state = 8},
  [391] = {.lex_state = 54, .external_lex_state = 8},
  [392] = {.lex_state = 54, .external_lex_state = 8},
  [393] = {.lex_state = 54, .external_lex_state = 8},
  [394] = {.lex_state = 54, .external_lex_state = 8},
  [395] = {.lex_state = 54, .external_lex_state = 8},
  [396] = {.lex_state = 54, .external_lex_state = 8},
  [397] = {.lex_state = 36, .external_lex_state = 7},
  [398] = {.lex_state = 54, .external_lex_state = 8},
  [399] = {.lex_state = 54, .external_lex_state = 8},
  [400] = {.lex_state = 54, .external_lex_state = 8},
  [401] = {.lex_state = 54, .external_lex_state = 2},
  [402] = {.lex_state = 54, .external_lex_state = 7},
  [403] = {.lex_state = 54, .external_lex_state = 2},
  [404] = {.lex_state = 36, .external_lex_state = 2},
  [405] = {.lex_state = 54, .external_lex_state = 2},
  [406] = {.lex_state = 54, .external_lex_state = 4},
  [407] = {.lex_state = 54, .external_lex_state = 2},
  [408] = {.lex_state = 54, .external_lex_state = 2},
  [409] = {.lex_state = 54, .external_lex_state = 4},
  [410] = {.lex_state = 54, .external_lex_state = 2},
  [411] = {.lex_state = 30, .external_lex_state = 2},
  [412] = {.lex_state = 54, .external_lex_state = 2},
  [413] = {.lex_state = 54, .external_lex_state = 4},
  [414] = {.lex_state = 54, .external_lex_state = 8},
  [415] = {.lex_state = 54, .external_lex_state = 7},
  [416] = {.lex_state = 54, .external_lex_state = 2},
  [417] = {.lex_state = 54, .external_lex_state = 4},
  [418] = {.lex_state = 54, .external_lex_state = 2},
  [419] = {.lex_state = 54, .external_lex_state = 8},
  [420] = {.lex_state = 54, .external_lex_state = 2},
  [421] = {.lex_state = 54, .external_lex_state = 2},
  [422] = {.lex_state = 54, .external_lex_state = 2},
  [423] = {.lex_state = 54, .external_lex_state = 7},
  [424] = {.lex_state = 54, .external_lex_state = 2},
  [425] = {.lex_state = 54, .external_lex_state = 8},
  [426] = {.lex_state = 54, .external_lex_state = 8},
  [427] = {.lex_state = 54, .external_lex_state = 2},
  [428] = {.lex_state = 54, .external_lex_state = 2},
  [429] = {.lex_state = 54, .external_lex_state = 2},
  [430] = {.lex_state = 54, .external_lex_state = 2},
  [431] = {.lex_state = 54, .external_lex_state = 2},
  [432] = {.lex_state = 36, .external_lex_state = 2},
  [433] = {.lex_state = 54, .external_lex_state = 2},
  [434] = {.lex_state = 54, .external_lex_state = 2},
  [435] = {.lex_state = 54, .external_lex_state = 2},
  [436] = {.lex_state = 54, .external_lex_state = 7},
  [437] = {.lex_state = 54, .external_lex_state = 2},
  [438] = {.lex_state = 54, .external_lex_state = 2},
  [439] = {.lex_state = 54, .external_lex_state = 2},
  [440] = {.lex_state = 54, .external_lex_state = 2},
  [441] = {.lex_state = 30, .external_lex_state = 7},
  [442] = {.lex_state = 54, .external_lex_state = 2},
  [443] = {.lex_state = 54, .external_lex_state = 2},
  [444] = {.lex_state = 54, .external_lex_state = 2},
  [445] = {.lex_state = 54, .external_lex_state = 2},
  [446] = {.lex_state = 54, .external_lex_state = 4},
  [447] = {.lex_state = 54, .external_lex_state = 2},
  [448] = {.lex_state = 54, .external_lex_state = 8},
  [449] = {.lex_state = 30, .external_lex_state = 8},
  [450] = {.lex_state = 54, .external_lex_state = 4},
  [451] = {.lex_state = 54, .external_lex_state = 2},
  [452] = {.lex_state = 54, .external_lex_state = 2},
  [453] = {.lex_state = 54, .external_lex_state = 2},
  [454] = {.lex_state = 54, .external_lex_state = 2},
  [455] = {.lex_state = 32, .external_lex_state = 4},
  [456] = {.lex_state = 54, .external_lex_state = 2},
  [457] = {.lex_state = 54, .external_lex_state = 2},
  [458] = {.lex_state = 54, .external_lex_state = 2},
  [459] = {.lex_state = 54, .external_lex_state = 2},
  [460] = {.lex_state = 54, .external_lex_state = 2},
  [461] = {.lex_state = 32, .external_lex_state = 4},
  [462] = {.lex_state = 32, .external_lex_state = 9},
  [463] = {.lex_state = 54, .external_lex_state = 2},
  [464] = {.lex_state = 54, .external_lex_state = 2},
  [465] = {.lex_state = 54, .external_lex_state = 2},
  [466] = {.lex_state = 54, .external_lex_state = 2},
  [467] = {.lex_state = 54, .external_lex_state = 2},
  [468] = {.lex_state = 54, .external_lex_state = 2},
  [469] = {.lex_state = 32, .external_lex_state = 9},
  [470] = {.lex_state = 54, .external_lex_state = 2},
  [471] = {.lex_state = 54, .external_lex_state = 2},
  [472] = {.lex_state = 54, .external_lex_state = 2},
  [473] = {.lex_state = 54, .external_lex_state = 2},
  [474] = {.lex_state = 54, .external_lex_state = 2},
  [475] = {.lex_state = 54, .external_lex_state = 2},
  [476] = {.lex_state = 54, .external_lex_state = 2},
  [477] = {.lex_state = 54, .external_lex_state = 2},
  [478] = {.lex_state = 54, .external_lex_state = 2},
  [479] = {.lex_state = 54, .external_lex_state = 2},
  [480] = {.lex_state = 54, .external_lex_state = 2},
  [481] = {.lex_state = 54, .external_lex_state = 2},
  [482] = {.lex_state = 54, .external_lex_state = 2},
  [483] = {.lex_state = 54, .external_lex_state = 2},
  [484] = {.lex_state = 54, .external_lex_state = 2},
  [485] = {.lex_state = 55, .external_lex_state = 3},
  [486] = {.lex_state = 56, .external_lex_state = 10},
  [487] = {.lex_state = 54, .external_lex_state = 2},
  [488] = {.lex_state = 54, .external_lex_state = 2},
  [489] = {.lex_state = 54, .external_lex_state = 2},
  [490] = {.lex_state = 54, .external_lex_state = 2},
  [491] = {.lex_state = 54, .external_lex_state = 2},
  [492] = {.lex_state = 54, .external_lex_state = 2},
  [493] = {.lex_state = 54, .external_lex_state = 2},
  [494] = {.lex_state = 54, .external_lex_state = 2},
  [495] = {.lex_state = 54, .external_lex_state = 2},
  [496] = {.lex_state = 54, .external_lex_state = 2},
  [497] = {.lex_state = 54, .external_lex_state = 2},
  [498] = {.lex_state = 54, .external_lex_state = 2},
  [499] = {.lex_state = 54, .external_lex_state = 2},
  [500] = {.lex_state = 54, .external_lex_state = 2},
  [501] = {.lex_state = 54, .external_lex_state = 2},
  [502] = {.lex_state = 54, .external_lex_state = 2},
  [503] = {.lex_state = 54, .external_lex_state = 2},
  [504] = {.lex_state = 54, .external_lex_state = 2},
  [505] = {.lex_state = 54, .external_lex_state = 2},
  [506] = {.lex_state = 54, .external_lex_state = 2},
  [507] = {.lex_state = 54, .external_lex_state = 2},
  [508] = {.lex_state = 54, .external_lex_state = 2},
  [509] = {.lex_state = 54, .external_lex_state = 2},
  [510] = {.lex_state = 54, .external_lex_state = 2},
  [511] = {.lex_state = 54, .external_lex_state = 2},
  [512] = {.lex_state = 54, .external_lex_state = 2},
  [513] = {.lex_state = 54, .external_lex_state = 2},
  [514] = {.lex_state = 54, .external_lex_state = 2},
  [515] = {.lex_state = 54, .external_lex_state = 2},
  [516] = {.lex_state = 54, .external_lex_state = 2},
  [517] = {.lex_state = 54, .external_lex_state = 2},
  [518] = {.lex_state = 54, .external_lex_state = 2},
  [519] = {.lex_state = 54, .external_lex_state = 2},
  [520] = {.lex_state = 54, .external_lex_state = 2},
  [521] = {.lex_state = 54, .external_lex_state = 2},
  [522] = {.lex_state = 54, .external_lex_state = 2},
  [523] = {.lex_state = 54, .external_lex_state = 2},
  [524] = {.lex_state = 56, .external_lex_state = 11},
  [525] = {.lex_state = 54, .external_lex_state = 2},
  [526] = {.lex_state = 54, .external_lex_state = 2},
  [527] = {.lex_state = 54, .external_lex_state = 2},
  [528] = {.lex_state = 56, .external_lex_state = 11},
  [529] = {.lex_state = 55, .external_lex_state = 2},
  [530] = {.lex_state = 54, .external_lex_state = 2},
  [531] = {.lex_state = 54, .external_lex_state = 2},
  [532] = {.lex_state = 54, .external_lex_state = 2},
  [533] = {.lex_state = 54, .external_lex_state = 2},
  [534] = {.lex_state = 55, .external_lex_state = 2},
  [535] = {.lex_state = 54, .external_lex_state = 2},
  [536] = {.lex_state = 54, .external_lex_state = 2},
  [537] = {.lex_state = 54, .external_lex_state = 2},
  [538] = {.lex_state = 54, .external_lex_state = 2},
  [539] = {.lex_state = 54, .external_lex_state = 2},
  [540] = {.lex_state = 54, .external_lex_state = 2},
  [541] = {.lex_state = 54, .external_lex_state = 2},
  [542] = {.lex_state = 54, .external_lex_state = 2},
  [543] = {.lex_state = 54, .external_lex_state = 2},
  [544] = {.lex_state = 54, .external_lex_state = 2},
  [545] = {.lex_state = 54, .external_lex_state = 2},
  [546] = {.lex_state = 54, .external_lex_state = 2},
  [547] = {.lex_state = 54, .external_lex_state = 2},
  [548] = {.lex_state = 54, .external_lex_state = 2},
  [549] = {.lex_state = 54, .external_lex_state = 2},
  [550] = {.lex_state = 54, .external_lex_state = 2},
  [551] = {.lex_state = 56, .external_lex_state = 10},
  [552] = {.lex_state = 54, .external_lex_state = 2},
  [553] = {.lex_state = 54, .external_lex_state = 2},
  [554] = {.lex_state = 55, .external_lex_state = 3},
  [555] = {.lex_state = 54, .external_lex_state = 2},
  [556] = {.lex_state = 54, .external_lex_state = 2},
  [557] = {.lex_state = 54, .external_lex_state = 2},
  [558] = {.lex_state = 54, .external_lex_state = 2},
  [559] = {.lex_state = 54, .external_lex_state = 2},
  [560] = {.lex_state = 54, .external_lex_state = 2},
  [561] = {.lex_state = 54, .external_lex_state = 2},
  [562] = {.lex_state = 54, .external_lex_state = 2},
  [563] = {.lex_state = 54, .external_lex_state = 2},
  [564] = {.lex_state = 54, .external_lex_state = 2},
  [565] = {.lex_state = 54, .external_lex_state = 2},
  [566] = {.lex_state = 54, .external_lex_state = 2},
  [567] = {.lex_state = 54, .external_lex_state = 2},
  [568] = {.lex_state = 54, .external_lex_state = 2},
  [569] = {.lex_state = 54, .external_lex_state = 2},
  [570] = {.lex_state = 54, .external_lex_state = 2},
  [571] = {.lex_state = 54, .external_lex_state = 2},
  [572] = {.lex_state = 54, .external_lex_state = 2},
  [573] = {.lex_state = 54, .external_lex_state = 2},
  [574] = {.lex_state = 54, .external_lex_state = 2},
  [575] = {.lex_state = 54, .external_lex_state = 2},
  [576] = {.lex_state = 54, .external_lex_state = 2},
  [577] = {.lex_state = 54, .external_lex_state = 2},
  [578] = {.lex_state = 54, .external_lex_state = 2},
  [579] = {.lex_state = 54, .external_lex_state = 2},
  [580] = {.lex_state = 54, .external_lex_state = 2},
  [581] = {.lex_state = 54, .external_lex_state = 2},
  [582] = {.lex_state = 54, .external_lex_state = 2},
  [583] = {.lex_state = 54, .external_lex_state = 2},
  [584] = {.lex_state = 54, .external_lex_state = 2},
  [585] = {.lex_state = 54, .external_lex_state = 2},
  [586] = {.lex_state = 54, .external_lex_state = 2},
  [587] = {.lex_state = 54, .external_lex_state = 2},
  [588] = {.lex_state = 54, .external_lex_state = 2},
  [589] = {.lex_state = 54, .external_lex_state = 2},
  [590] = {.lex_state = 54, .external_lex_state = 2},
  [591] = {.lex_state = 54, .external_lex_state = 2},
  [592] = {.lex_state = 54, .external_lex_state = 2},
  [593] = {.lex_state = 54, .external_lex_state = 2},
  [594] = {.lex_state = 54, .external_lex_state = 2},
  [595] = {.lex_state = 54, .external_lex_state = 2},
  [596] = {.lex_state = 54, .external_lex_state = 2},
  [597] = {.lex_state = 54, .external_lex_state = 2},
  [598] = {.lex_state = 54, .external_lex_state = 2},
  [599] = {.lex_state = 54, .external_lex_state = 2},
  [600] = {.lex_state = 54, .external_lex_state = 2},
  [601] = {.lex_state = 32, .external_lex_state = 9},
  [602] = {.lex_state = 55, .external_lex_state = 3},
  [603] = {.lex_state = 32, .external_lex_state = 9},
  [604] = {.lex_state = 54, .external_lex_state = 3},
  [605] = {.lex_state = 54, .external_lex_state = 3},
  [606] = {.lex_state = 54, .external_lex_state = 3},
  [607] = {.lex_state = 54, .external_lex_state = 2},
  [608] = {.lex_state = 54, .external_lex_state = 2},
  [609] = {.lex_state = 54, .external_lex_state = 3},
  [610] = {.lex_state = 54, .external_lex_state = 2},
  [611] = {.lex_state = 56, .external_lex_state = 10},
  [612] = {.lex_state = 32, .external_lex_state = 9},
  [613] = {.lex_state = 32, .external_lex_state = 9},
  [614] = {.lex_state = 54, .external_lex_state = 2},
  [615] = {.lex_state = 32, .external_lex_state = 9},
  [616] = {.lex_state = 56, .external_lex_state = 11},
  [617] = {.lex_state = 55, .external_lex_state = 2},
  [618] = {.lex_state = 33, .external_lex_state = 9},
  [619] = {.lex_state = 33, .external_lex_state = 9},
  [620] = {.lex_state = 33, .external_lex_state = 9},
  [621] = {.lex_state = 54, .external_lex_state = 2},
  [622] = {.lex_state = 33, .external_lex_state = 9},
  [623] = {.lex_state = 33, .external_lex_state = 9},
  [624] = {.lex_state = 33, .external_lex_state = 9},
  [625] = {.lex_state = 33, .external_lex_state = 9},
  [626] = {.lex_state = 33, .external_lex_state = 9},
  [627] = {.lex_state = 33, .external_lex_state = 9},
  [628] = {.lex_state = 33, .external_lex_state = 9},
  [629] = {.lex_state = 54, .external_lex_state = 3},
  [630] = {.lex_state = 33, .external_lex_state = 9},
  [631] = {.lex_state = 33, .external_lex_state = 9},
  [632] = {.lex_state = 33, .external_lex_state = 9},
  [633] = {.lex_state = 33, .external_lex_state = 9},
  [634] = {.lex_state = 33, .external_lex_state = 9},
  [635] = {.lex_state = 33, .external_lex_state = 9},
  [636] = {.lex_state = 33, .external_lex_state = 9},
  [637] = {.lex_state = 33, .external_lex_state = 9},
  [638] = {.lex_state = 33, .external_lex_state = 9},
  [639] = {.lex_state = 55, .external_lex_state = 3},
  [640] = {.lex_state = 55, .external_lex_state = 2},
  [641] = {.lex_state = 55, .external_lex_state = 2},
  [642] = {.lex_state = 56, .external_lex_state = 11},
  [643] = {.lex_state = 56, .external_lex_state = 10},
  [644] = {.lex_state = 56, .external_lex_state = 10},
  [645] = {.lex_state = 56, .external_lex_state = 10},
  [646] = {.lex_state = 56, .external_lex_state = 11},
  [647] = {.lex_state = 55, .external_lex_state = 2},
  [648] = {.lex_state = 55, .external_lex_state = 3},
  [649] = {.lex_state = 56, .external_lex_state = 10},
  [650] = {.lex_state = 55, .external_lex_state = 2},
  [651] = {.lex_state = 54, .external_lex_state = 6},
  [652] = {.lex_state = 55, .external_lex_state = 3},
  [653] = {.lex_state = 56, .external_lex_state = 11},
  [654] = {.lex_state = 54, .external_lex_state = 3},
  [655] = {.lex_state = 55, .external_lex_state = 3},
  [656] = {.lex_state = 56, .external_lex_state = 11},
  [657] = {.lex_state = 55, .external_lex_state = 3},
  [658] = {.lex_state = 56, .external_lex_state = 10},
  [659] = {.lex_state = 54, .external_lex_state = 2},
  [660] = {.lex_state = 56, .external_lex_state = 10},
  [661] = {.lex_state = 55, .external_lex_state = 3},
  [662] = {.lex_state = 56, .external_lex_state = 11},
  [663] = {.lex_state = 54, .external_lex_state = 3},
  [664] = {.lex_state = 54, .external_lex_state = 2},
  [665] = {.lex_state = 55, .external_lex_state = 3},
  [666] = {.lex_state = 56, .external_lex_state = 11},
  [667] = {.lex_state = 54, .external_lex_state = 2},
  [668] = {.lex_state = 55, .external_lex_state = 2},
  [669] = {.lex_state = 55, .external_lex_state = 3},
  [670] = {.lex_state = 55, .external_lex_state = 3},
  [671] = {.lex_state = 56, .external_lex_state = 10},
  [672] = {.lex_state = 54, .external_lex_state = 2},
  [673] = {.lex_state = 54, .external_lex_state = 3},
  [674] = {.lex_state = 54, .external_lex_state = 2},
  [675] = {.lex_state = 56, .external_lex_state = 10},
  [676] = {.lex_state = 55, .external_lex_state = 2},
  [677] = {.lex_state = 54, .external_lex_state = 6},
  [678] = {.lex_state = 56, .external_lex_state = 11},
  [679] = {.lex_state = 56, .external_lex_state = 10},
  [680] = {.lex_state = 56, .external_lex_state = 11},
  [681] = {.lex_state = 54, .external_lex_state = 3},
  [682] = {.lex_state = 56, .external_lex_state = 11},
  [683] = {.lex_state = 56, .external_lex_state = 11},
  [684] = {.lex_state = 55, .external_lex_state = 2},
  [685] = {.lex_state = 55, .external_lex_state = 2},
  [686] = {.lex_state = 56, .external_lex_state = 11},
  [687] = {.lex_state = 54, .external_lex_state = 3},
  [688] = {.lex_state = 55, .external_lex_state = 2},
  [689] = {.lex_state = 56, .external_lex_state = 10},
  [690] = {.lex_state = 56, .external_lex_state = 10},
  [691] = {.lex_state = 54, .external_lex_state = 3},
  [692] = {.lex_state = 54, .external_lex_state = 3},
  [693] = {.lex_state = 54, .external_lex_state = 2},
  [694] = {.lex_state = 54, .external_lex_state = 2},
  [695] = {.lex_state = 54, .external_lex_state = 2},
  [696] = {.lex_state = 54, .external_lex_state = 2},
  [697] = {.lex_state = 54, .external_lex_state = 2},
  [698] = {.lex_state = 54, .external_lex_state = 2},
  [699] = {.lex_state = 54, .external_lex_state = 3},
  [700] = {.lex_state = 54, .external_lex_state = 2},
  [701] = {.lex_state = 54, .external_lex_state = 3},
  [702] = {.lex_state = 54, .external_lex_state = 2},
  [703] = {.lex_state = 54, .external_lex_state = 3},
  [704] = {.lex_state = 54, .external_lex_state = 2},
  [705] = {.lex_state = 54, .external_lex_state = 2},
  [706] = {.lex_state = 54, .external_lex_state = 3},
  [707] = {.lex_state = 54, .external_lex_state = 3},
  [708] = {.lex_state = 54, .external_lex_state = 3},
  [709] = {.lex_state = 54, .external_lex_state = 3},
  [710] = {.lex_state = 54, .external_lex_state = 3},
  [711] = {.lex_state = 54, .external_lex_state = 2},
  [712] = {.lex_state = 54, .external_lex_state = 3},
  [713] = {.lex_state = 54, .external_lex_state = 3},
  [714] = {.lex_state = 54, .external_lex_state = 7},
  [715] = {.lex_state = 54, .external_lex_state = 2},
  [716] = {.lex_state = 54, .external_lex_state = 2},
  [717] = {.lex_state = 54, .external_lex_state = 3},
  [718] = {.lex_state = 54, .external_lex_state = 7},
  [719] = {.lex_state = 54, .external_lex_state = 2},
  [720] = {.lex_state = 54, .external_lex_state = 3},
  [721] = {.lex_state = 54, .external_lex_state = 2},
  [722] = {.lex_state = 54, .external_lex_state = 2},
  [723] = {.lex_state = 54, .external_lex_state = 2},
  [724] = {.lex_state = 54, .external_lex_state = 3},
  [725] = {.lex_state = 54, .external_lex_state = 2},
  [726] = {.lex_state = 54, .external_lex_state = 2},
  [727] = {.lex_state = 54, .external_lex_state = 2},
  [728] = {.lex_state = 54, .external_lex_state = 2},
  [729] = {.lex_state = 54, .external_lex_state = 2},
  [730] = {.lex_state = 54, .external_lex_state = 3},
  [731] = {.lex_state = 54, .external_lex_state = 2},
  [732] = {.lex_state = 54, .external_lex_state = 2},
  [733] = {.lex_state = 54, .external_lex_state = 2},
  [734] = {.lex_state = 54, .external_lex_state = 2},
  [735] = {.lex_state = 54, .external_lex_state = 2},
  [736] = {.lex_state = 54, .external_lex_state = 8},
  [737] = {.lex_state = 54, .external_lex_state = 2},
  [738] = {.lex_state = 54, .external_lex_state = 2},
  [739] = {.lex_state = 54, .external_lex_state = 2},
  [740] = {.lex_state = 54, .external_lex_state = 2},
  [741] = {.lex_state = 54, .external_lex_state = 3},
  [742] = {.lex_state = 54, .external_lex_state = 3},
  [743] = {.lex_state = 54, .external_lex_state = 3},
  [744] = {.lex_state = 54, .external_lex_state = 2},
  [745] = {.lex_state = 54, .external_lex_state = 2},
  [746] = {.lex_state = 54, .external_lex_state = 2},
  [747] = {.lex_state = 54, .external_lex_state = 2},
  [748] = {.lex_state = 54, .external_lex_state = 2},
  [749] = {.lex_state = 54, .external_lex_state = 2},
  [750] = {.lex_state = 54, .external_lex_state = 2},
  [751] = {.lex_state = 54, .external_lex_state = 2},
  [752] = {.lex_state = 54, .external_lex_state = 2},
  [753] = {.lex_state = 54, .external_lex_state = 2},
  [754] = {.lex_state = 54, .external_lex_state = 3},
  [755] = {.lex_state = 54, .external_lex_state = 2},
  [756] = {.lex_state = 54, .external_lex_state = 2},
  [757] = {.lex_state = 54, .external_lex_state = 2},
  [758] = {.lex_state = 54, .external_lex_state = 2},
  [759] = {.lex_state = 54, .external_lex_state = 2},
  [760] = {.lex_state = 54, .external_lex_state = 2},
  [761] = {.lex_state = 54, .external_lex_state = 2},
  [762] = {.lex_state = 54, .external_lex_state = 2},
  [763] = {.lex_state = 54, .external_lex_state = 2},
  [764] = {.lex_state = 54, .external_lex_state = 2},
  [765] = {.lex_state = 54, .external_lex_state = 3},
  [766] = {.lex_state = 54, .external_lex_state = 3},
  [767] = {.lex_state = 54, .external_lex_state = 2},
  [768] = {.lex_state = 54, .external_lex_state = 3},
  [769] = {.lex_state = 54, .external_lex_state = 2},
  [770] = {.lex_state = 54, .external_lex_state = 3},
  [771] = {.lex_state = 54, .external_lex_state = 3},
  [772] = {.lex_state = 54, .external_lex_state = 7},
  [773] = {.lex_state = 54, .external_lex_state = 3},
  [774] = {.lex_state = 54, .external_lex_state = 2},
  [775] = {.lex_state = 54, .external_lex_state = 3},
  [776] = {.lex_state = 54, .external_lex_state = 3},
  [777] = {.lex_state = 54, .external_lex_state = 3},
  [778] = {.lex_state = 54, .external_lex_state = 3},
  [779] = {.lex_state = 54, .external_lex_state = 3},
  [780] = {.lex_state = 54, .external_lex_state = 3},
  [781] = {.lex_state = 54, .external_lex_state = 8},
  [782] = {.lex_state = 54, .external_lex_state = 3},
  [783] = {.lex_state = 54, .external_lex_state = 3},
  [784] = {.lex_state = 54, .external_lex_state = 3},
  [785] = {.lex_state = 54, .external_lex_state = 3},
  [786] = {.lex_state = 54, .external_lex_state = 3},
  [787] = {.lex_state = 54, .external_lex_state = 2},
  [788] = {.lex_state = 54, .external_lex_state = 3},
  [789] = {.lex_state = 54, .external_lex_state = 3},
  [790] = {.lex_state = 54, .external_lex_state = 3},
  [791] = {.lex_state = 54, .external_lex_state = 2},
  [792] = {.lex_state = 54, .external_lex_state = 2},
  [793] = {.lex_state = 54, .external_lex_state = 2},
  [794] = {.lex_state = 54, .external_lex_state = 3},
  [795] = {.lex_state = 54, .external_lex_state = 2},
  [796] = {.lex_state = 54, .external_lex_state = 2},
  [797] = {.lex_state = 54, .external_lex_state = 2},
  [798] = {.lex_state = 54, .external_lex_state = 3},
  [799] = {.lex_state = 54, .external_lex_state = 3},
  [800] = {.lex_state = 54, .external_lex_state = 3},
  [801] = {.lex_state = 54, .external_lex_state = 2},
  [802] = {.lex_state = 54, .external_lex_state = 3},
  [803] = {.lex_state = 54, .external_lex_state = 2},
  [804] = {.lex_state = 54, .external_lex_state = 3},
  [805] = {.lex_state = 54, .external_lex_state = 3},
  [806] = {.lex_state = 54, .external_lex_state = 3},
  [807] = {.lex_state = 54, .external_lex_state = 3},
  [808] = {.lex_state = 54, .external_lex_state = 3},
  [809] = {.lex_state = 54, .external_lex_state = 3},
  [810] = {.lex_state = 54, .external_lex_state = 3},
  [811] = {.lex_state = 54, .external_lex_state = 3},
  [812] = {.lex_state = 54, .external_lex_state = 3},
  [813] = {.lex_state = 54, .external_lex_state = 2},
  [814] = {.lex_state = 54, .external_lex_state = 3},
  [815] = {.lex_state = 54, .external_lex_state = 2},
  [816] = {.lex_state = 54, .external_lex_state = 3},
  [817] = {.lex_state = 54, .external_lex_state = 2},
  [818] = {.lex_state = 54, .external_lex_state = 2},
  [819] = {.lex_state = 54, .external_lex_state = 2},
  [820] = {.lex_state = 54, .external_lex_state = 3},
  [821] = {.lex_state = 54, .external_lex_state = 3},
  [822] = {.lex_state = 54, .external_lex_state = 2},
  [823] = {.lex_state = 54, .external_lex_state = 3},
  [824] = {.lex_state = 54, .external_lex_state = 2},
  [825] = {.lex_state = 54, .external_lex_state = 2},
  [826] = {.lex_state = 54, .external_lex_state = 3},
  [827] = {.lex_state = 54, .external_lex_state = 2},
  [828] = {.lex_state = 54, .external_lex_state = 2},
  [829] = {.lex_state = 54, .external_lex_state = 3},
  [830] = {.lex_state = 54, .external_lex_state = 2},
  [831] = {.lex_state = 54, .external_lex_state = 2},
  [832] = {.lex_state = 54, .external_lex_state = 3},
  [833] = {.lex_state = 54, .external_lex_state = 2},
  [834] = {.lex_state = 54, .external_lex_state = 7},
  [835] = {.lex_state = 54, .external_lex_state = 3},
  [836] = {.lex_state = 54, .external_lex_state = 2},
  [837] = {.lex_state = 54, .external_lex_state = 3},
  [838] = {.lex_state = 54, .external_lex_state = 2},
  [839] = {.lex_state = 54, .external_lex_state = 2},
  [840] = {.lex_state = 54, .external_lex_state = 3},
  [841] = {.lex_state = 54, .external_lex_state = 3},
  [842] = {.lex_state = 54, .external_lex_state = 3},
  [843] = {.lex_state = 54, .external_lex_state = 2},
  [844] = {.lex_state = 54, .external_lex_state = 2},
  [845] = {.lex_state = 54, .external_lex_state = 2},
  [846] = {.lex_state = 54, .external_lex_state = 2},
  [847] = {.lex_state = 54, .external_lex_state = 2},
  [848] = {.lex_state = 54, .external_lex_state = 2},
  [849] = {.lex_state = 54, .external_lex_state = 7},
  [850] = {.lex_state = 54, .external_lex_state = 2},
  [851] = {.lex_state = 54, .external_lex_state = 2},
  [852] = {.lex_state = 54, .external_lex_state = 2},
  [853] = {.lex_state = 54, .external_lex_state = 2},
  [854] = {.lex_state = 54, .external_lex_state = 2},
  [855] = {.lex_state = 54, .external_lex_state = 2},
  [856] = {.lex_state = 54, .external_lex_state = 2},
  [857] = {.lex_state = 54, .external_lex_state = 2},
  [858] = {.lex_state = 54, .external_lex_state = 2},
  [859] = {.lex_state = 54, .external_lex_state = 2},
  [860] = {.lex_state = 54, .external_lex_state = 2},
  [861] = {.lex_state = 54, .external_lex_state = 2},
  [862] = {.lex_state = 54, .external_lex_state = 2},
  [863] = {.lex_state = 54, .external_lex_state = 2},
  [864] = {.lex_state = 54, .external_lex_state = 2},
  [865] = {.lex_state = 54, .external_lex_state = 2},
  [866] = {.lex_state = 54, .external_lex_state = 2},
  [867] = {.lex_state = 54, .external_lex_state = 2},
  [868] = {.lex_state = 54, .external_lex_state = 2},
  [869] = {.lex_state = 54, .external_lex_state = 2},
  [870] = {.lex_state = 54, .external_lex_state = 2},
  [871] = {.lex_state = 54, .external_lex_state = 2},
  [872] = {.lex_state = 54, .external_lex_state = 2},
  [873] = {.lex_state = 54, .external_lex_state = 2},
  [874] = {.lex_state = 54, .external_lex_state = 2},
  [875] = {.lex_state = 54, .external_lex_state = 2},
  [876] = {.lex_state = 54, .external_lex_state = 2},
  [877] = {.lex_state = 54, .external_lex_state = 2},
  [878] = {.lex_state = 54, .external_lex_state = 2},
  [879] = {.lex_state = 54, .external_lex_state = 2},
  [880] = {.lex_state = 54, .external_lex_state = 2},
  [881] = {.lex_state = 54, .external_lex_state = 2},
  [882] = {.lex_state = 54, .external_lex_state = 2},
  [883] = {.lex_state = 54, .external_lex_state = 2},
  [884] = {.lex_state = 54, .external_lex_state = 2},
  [885] = {.lex_state = 54, .external_lex_state = 2},
  [886] = {.lex_state = 54, .external_lex_state = 2},
  [887] = {.lex_state = 54, .external_lex_state = 2},
  [888] = {.lex_state = 54, .external_lex_state = 2},
  [889] = {.lex_state = 54, .external_lex_state = 2},
  [890] = {.lex_state = 54, .external_lex_state = 2},
  [891] = {.lex_state = 54, .external_lex_state = 2},
  [892] = {.lex_state = 54, .external_lex_state = 2},
  [893] = {.lex_state = 54, .external_lex_state = 2},
  [894] = {.lex_state = 54, .external_lex_state = 2},
  [895] = {.lex_state = 54, .external_lex_state = 2},
  [896] = {.lex_state = 54, .external_lex_state = 2},
  [897] = {.lex_state = 54, .external_lex_state = 2},
  [898] = {.lex_state = 54, .external_lex_state = 2},
  [899] = {.lex_state = 54, .external_lex_state = 2},
  [900] = {.lex_state = 54, .external_lex_state = 2},
  [901] = {.lex_state = 54, .external_lex_state = 2},
  [902] = {.lex_state = 54, .external_lex_state = 2},
  [903] = {.lex_state = 54, .external_lex_state = 2},
  [904] = {.lex_state = 54, .external_lex_state = 2},
  [905] = {.lex_state = 54, .external_lex_state = 2},
  [906] = {.lex_state = 54, .external_lex_state = 2},
  [907] = {.lex_state = 54, .external_lex_state = 2},
  [908] = {.lex_state = 54, .external_lex_state = 2},
  [909] = {.lex_state = 54, .external_lex_state = 2},
  [910] = {.lex_state = 54, .external_lex_state = 2},
  [911] = {.lex_state = 54, .external_lex_state = 2},
  [912] = {.lex_state = 54, .external_lex_state = 2},
  [913] = {.lex_state = 54, .external_lex_state = 2},
  [914] = {.lex_state = 54, .external_lex_state = 2},
  [915] = {.lex_state = 54, .external_lex_state = 2},
  [916] = {.lex_state = 54, .external_lex_state = 2},
  [917] = {.lex_state = 54, .external_lex_state = 2},
  [918] = {.lex_state = 54, .external_lex_state = 2},
  [919] = {.lex_state = 54, .external_lex_state = 2},
  [920] = {.lex_state = 54, .external_lex_state = 2},
  [921] = {.lex_state = 54, .external_lex_state = 2},
  [922] = {.lex_state = 54, .external_lex_state = 2},
  [923] = {.lex_state = 54, .external_lex_state = 2},
  [924] = {.lex_state = 54, .external_lex_state = 2},
  [925] = {.lex_state = 54, .external_lex_state = 2},
  [926] = {.lex_state = 54, .external_lex_state = 2},
  [927] = {.lex_state = 54, .external_lex_state = 2},
  [928] = {.lex_state = 54, .external_lex_state = 2},
  [929] = {.lex_state = 54, .external_lex_state = 2},
  [930] = {.lex_state = 54, .external_lex_state = 2},
  [931] = {.lex_state = 54, .external_lex_state = 2},
  [932] = {.lex_state = 54, .external_lex_state = 2},
  [933] = {.lex_state = 54, .external_lex_state = 2},
  [934] = {.lex_state = 54, .external_lex_state = 2},
  [935] = {.lex_state = 54, .external_lex_state = 2},
  [936] = {.lex_state = 54, .external_lex_state = 2},
  [937] = {.lex_state = 54, .external_lex_state = 2},
  [938] = {.lex_state = 54, .external_lex_state = 2},
  [939] = {.lex_state = 54, .external_lex_state = 2},
  [940] = {.lex_state = 54, .external_lex_state = 2},
  [941] = {.lex_state = 54, .external_lex_state = 2},
  [942] = {.lex_state = 54, .external_lex_state = 2},
  [943] = {.lex_state = 54, .external_lex_state = 2},
  [944] = {.lex_state = 54, .external_lex_state = 2},
  [945] = {.lex_state = 54, .external_lex_state = 2},
  [946] = {.lex_state = 54, .external_lex_state = 2},
  [947] = {.lex_state = 54, .external_lex_state = 2},
  [948] = {.lex_state = 54, .external_lex_state = 2},
  [949] = {.lex_state = 54, .external_lex_state = 2},
  [950] = {.lex_state = 54, .external_lex_state = 2},
  [951] = {.lex_state = 54, .external_lex_state = 2},
  [952] = {.lex_state = 54, .external_lex_state = 2},
  [953] = {.lex_state = 54, .external_lex_state = 2},
  [954] = {.lex_state = 54, .external_lex_state = 2},
  [955] = {.lex_state = 54, .external_lex_state = 2},
  [956] = {.lex_state = 54, .external_lex_state = 2},
  [957] = {.lex_state = 54, .external_lex_state = 2},
  [958] = {.lex_state = 54, .external_lex_state = 2},
  [959] = {.lex_state = 54, .external_lex_state = 2},
  [960] = {.lex_state = 54, .external_lex_state = 2},
  [961] = {.lex_state = 54, .external_lex_state = 2},
  [962] = {.lex_state = 54, .external_lex_state = 2},
  [963] = {.lex_state = 54, .external_lex_state = 2},
  [964] = {.lex_state = 54, .external_lex_state = 2},
  [965] = {.lex_state = 54, .external_lex_state = 2},
  [966] = {.lex_state = 54, .external_lex_state = 2},
  [967] = {.lex_state = 37, .external_lex_state = 4},
  [968] = {.lex_state = 37, .external_lex_state = 4},
  [969] = {.lex_state = 37, .external_lex_state = 9},
  [970] = {.lex_state = 37, .external_lex_state = 4},
  [971] = {.lex_state = 37, .external_lex_state = 9},
  [972] = {.lex_state = 37, .external_lex_state = 12},
  [973] = {.lex_state = 37, .external_lex_state = 9},
  [974] = {.lex_state = 37, .external_lex_state = 9},
  [975] = {.lex_state = 37, .external_lex_state = 9},
  [976] = {.lex_state = 37, .external_lex_state = 9},
  [977] = {.lex_state = 37, .external_lex_state = 6},
  [978] = {.lex_state = 37, .external_lex_state = 6},
  [979] = {.lex_state = 37, .external_lex_state = 12},
  [980] = {.lex_state = 37, .external_lex_state = 9},
  [981] = {.lex_state = 37, .external_lex_state = 6},
  [982] = {.lex_state = 37, .external_lex_state = 9},
  [983] = {.lex_state = 37, .external_lex_state = 9},
  [984] = {.lex_state = 37, .external_lex_state = 9},
  [985] = {.lex_state = 37, .external_lex_state = 9},
  [986] = {.lex_state = 37, .external_lex_state = 9},
  [987] = {.lex_state = 37, .external_lex_state = 6},
  [988] = {.lex_state = 37, .external_lex_state = 9},
  [989] = {.lex_state = 37, .external_lex_state = 6},
  [990] = {.lex_state = 37, .external_lex_state = 6},
  [991] = {.lex_state = 37, .external_lex_state = 8},
  [992] = {.lex_state = 37, .external_lex_state = 8},
  [993] = {.lex_state = 37, .external_lex_state = 2},
  [994] = {.lex_state = 37, .external_lex_state = 7},
  [995] = {.lex_state = 37, .external_lex_state = 2},
  [996] = {.lex_state = 37, .external_lex_state = 12},
  [997] = {.lex_state = 37, .external_lex_state = 7},
  [998] = {.lex_state = 37, .external_lex_state = 9},
  [999] = {.lex_state = 37, .external_lex_state = 4},
  [1000] = {.lex_state = 38, .external_lex_state = 9},
  [1001] = {.lex_state = 38, .external_lex_state = 9},
  [1002] = {.lex_state = 37, .external_lex_state = 12},
  [1003] = {.lex_state = 37, .external_lex_state = 7},
  [1004] = {.lex_state = 37, .external_lex_state = 12},
  [1005] = {.lex_state = 38, .external_lex_state = 9},
  [1006] = {.lex_state = 37, .external_lex_state = 13},
  [1007] = {.lex_state = 37, .external_lex_state = 2},
  [1008] = {.lex_state = 37, .external_lex_state = 14},
  [1009] = {.lex_state = 37, .external_lex_state = 7},
  [1010] = {.lex_state = 37, .external_lex_state = 15},
  [1011] = {.lex_state = 37, .external_lex_state = 8},
  [1012] = {.lex_state = 37, .external_lex_state = 12},
  [1013] = {.lex_state = 37, .external_lex_state = 12},
  [1014] = {.lex_state = 37, .external_lex_state = 12},
  [1015] = {.lex_state = 37, .external_lex_state = 12},
  [1016] = {.lex_state = 37, .external_lex_state = 12},
  [1017] = {.lex_state = 37, .external_lex_state = 12},
  [1018] = {.lex_state = 37, .external_lex_state = 12},
  [1019] = {.lex_state = 37, .external_lex_state = 12},
  [1020] = {.lex_state = 37, .external_lex_state = 12},
  [1021] = {.lex_state = 37, .external_lex_state = 12},
  [1022] = {.lex_state = 37, .external_lex_state = 12},
  [1023] = {.lex_state = 37, .external_lex_state = 12},
  [1024] = {.lex_state = 37, .external_lex_state = 4},
  [1025] = {.lex_state = 37, .external_lex_state = 12},
  [1026] = {.lex_state = 37, .external_lex_state = 12},
  [1027] = {.lex_state = 37, .external_lex_state = 12},
  [1028] = {.lex_state = 37, .external_lex_state = 12},
  [1029] = {.lex_state = 37, .external_lex_state = 12},
  [1030] = {.lex_state = 37, .external_lex_state = 12},
  [1031] = {.lex_state = 37, .external_lex_state = 13},
  [1032] = {.lex_state = 37, .external_lex_state = 12},
  [1033] = {.lex_state = 37, .external_lex_state = 12},
  [1034] = {.lex_state = 37, .external_lex_state = 7},
  [1035] = {.lex_state = 37, .external_lex_state = 12},
  [1036] = {.lex_state = 37, .external_lex_state = 12},
  [1037] = {.lex_state = 37, .external_lex_state = 12},
  [1038] = {.lex_state = 37, .external_lex_state = 12},
  [1039] = {.lex_state = 37, .external_lex_state = 7},
  [1040] = {.lex_state = 37, .external_lex_state = 12},
  [1041] = {.lex_state = 37, .external_lex_state = 12},
  [1042] = {.lex_state = 37, .external_lex_state = 12},
  [1043] = {.lex_state = 37, .external_lex_state = 12},
  [1044] = {.lex_state = 38, .external_lex_state = 12},
  [1045] = {.lex_state = 37, .external_lex_state = 9},
  [1046] = {.lex_state = 37, .external_lex_state = 9},
  [1047] = {.lex_state = 37, .external_lex_state = 9},
  [1048] = {.lex_state = 37, .external_lex_state = 14},
  [1049] = {.lex_state = 37, .external_lex_state = 14},
  [1050] = {.lex_state = 37, .external_lex_state = 9},
  [1051] = {.lex_state = 37, .external_lex_state = 14},
  [1052] = {.lex_state = 37, .external_lex_state = 14},
  [1053] = {.lex_state = 37, .external_lex_state = 14},
  [1054] = {.lex_state = 37, .external_lex_state = 9},
  [1055] = {.lex_state = 37, .external_lex_state = 14},
  [1056] = {.lex_state = 37, .external_lex_state = 13},
  [1057] = {.lex_state = 37, .external_lex_state = 13},
  [1058] = {.lex_state = 37, .external_lex_state = 9},
  [1059] = {.lex_state = 37, .external_lex_state = 14},
  [1060] = {.lex_state = 38, .external_lex_state = 12},
  [1061] = {.lex_state = 38, .external_lex_state = 12},
  [1062] = {.lex_state = 38, .external_lex_state = 12},
  [1063] = {.lex_state = 37, .external_lex_state = 9},
  [1064] = {.lex_state = 37, .external_lex_state = 9},
  [1065] = {.lex_state = 37, .external_lex_state = 6},
  [1066] = {.lex_state = 37, .external_lex_state = 14},
  [1067] = {.lex_state = 37, .external_lex_state = 9},
  [1068] = {.lex_state = 37, .external_lex_state = 13},
  [1069] = {.lex_state = 37, .external_lex_state = 13},
  [1070] = {.lex_state = 37, .external_lex_state = 13},
  [1071] = {.lex_state = 37, .external_lex_state = 13},
  [1072] = {.lex_state = 37, .external_lex_state = 13},
  [1073] = {.lex_state = 37, .external_lex_state = 13},
  [1074] = {.lex_state = 37, .external_lex_state = 13},
  [1075] = {.lex_state = 37, .external_lex_state = 13},
  [1076] = {.lex_state = 37, .external_lex_state = 6},
  [1077] = {.lex_state = 37, .external_lex_state = 9},
  [1078] = {.lex_state = 37, .external_lex_state = 14},
  [1079] = {.lex_state = 37, .external_lex_state = 13},
  [1080] = {.lex_state = 37, .external_lex_state = 15},
  [1081] = {.lex_state = 37, .external_lex_state = 13},
  [1082] = {.lex_state = 37, .external_lex_state = 14},
  [1083] = {.lex_state = 37, .external_lex_state = 15},
  [1084] = {.lex_state = 37, .external_lex_state = 9},
  [1085] = {.lex_state = 37, .external_lex_state = 15},
  [1086] = {.lex_state = 37, .external_lex_state = 14},
  [1087] = {.lex_state = 37, .external_lex_state = 14},
  [1088] = {.lex_state = 37, .external_lex_state = 13},
  [1089] = {.lex_state = 37, .external_lex_state = 9},
  [1090] = {.lex_state = 37, .external_lex_state = 9},
  [1091] = {.lex_state = 38, .external_lex_state = 12},
  [1092] = {.lex_state = 38, .external_lex_state = 13},
  [1093] = {.lex_state = 38, .external_lex_state = 12},
  [1094] = {.lex_state = 38, .external_lex_state = 13},
  [1095] = {.lex_state = 38, .external_lex_state = 12},
  [1096] = {.lex_state = 37, .external_lex_state = 13},
  [1097] = {.lex_state = 38, .external_lex_state = 13},
  [1098] = {.lex_state = 38, .external_lex_state = 12},
  [1099] = {.lex_state = 37, .external_lex_state = 9},
  [1100] = {.lex_state = 37, .external_lex_state = 9},
  [1101] = {.lex_state = 37, .external_lex_state = 9},
  [1102] = {.lex_state = 37, .external_lex_state = 9},
  [1103] = {.lex_state = 37, .external_lex_state = 13},
  [1104] = {.lex_state = 37, .external_lex_state = 15},
  [1105] = {.lex_state = 37, .external_lex_state = 15},
  [1106] = {.lex_state = 38, .external_lex_state = 12},
  [1107] = {.lex_state = 38, .external_lex_state = 12},
  [1108] = {.lex_state = 37, .external_lex_state = 13},
  [1109] = {.lex_state = 37, .external_lex_state = 15},
  [1110] = {.lex_state = 37, .external_lex_state = 15},
  [1111] = {.lex_state = 37, .external_lex_state = 9},
  [1112] = {.lex_state = 37, .external_lex_state = 15},
  [1113] = {.lex_state = 38, .external_lex_state = 9},
  [1114] = {.lex_state = 37, .external_lex_state = 6},
  [1115] = {.lex_state = 37, .external_lex_state = 15},
  [1116] = {.lex_state = 37, .external_lex_state = 15},
  [1117] = {.lex_state = 37, .external_lex_state = 15},
  [1118] = {.lex_state = 37, .external_lex_state = 13},
  [1119] = {.lex_state = 38, .external_lex_state = 12},
  [1120] = {.lex_state = 37, .external_lex_state = 13},
  [1121] = {.lex_state = 37, .external_lex_state = 9},
  [1122] = {.lex_state = 37, .external_lex_state = 9},
  [1123] = {.lex_state = 37, .external_lex_state = 9},
  [1124] = {.lex_state = 37, .external_lex_state = 13},
  [1125] = {.lex_state = 37, .external_lex_state = 9},
  [1126] = {.lex_state = 37, .external_lex_state = 9},
  [1127] = {.lex_state = 38, .external_lex_state = 12},
  [1128] = {.lex_state = 37, .external_lex_state = 9},
  [1129] = {.lex_state = 37, .external_lex_state = 6},
  [1130] = {.lex_state = 37, .external_lex_state = 13},
  [1131] = {.lex_state = 37, .external_lex_state = 13},
  [1132] = {.lex_state = 37, .external_lex_state = 13},
  [1133] = {.lex_state = 37, .external_lex_state = 9},
  [1134] = {.lex_state = 37, .external_lex_state = 9},
  [1135] = {.lex_state = 37, .external_lex_state = 9},
  [1136] = {.lex_state = 37, .external_lex_state = 9},
  [1137] = {.lex_state = 37, .external_lex_state = 9},
  [1138] = {.lex_state = 37, .external_lex_state = 9},
  [1139] = {.lex_state = 37, .external_lex_state = 9},
  [1140] = {.lex_state = 37, .external_lex_state = 9},
  [1141] = {.lex_state = 37, .external_lex_state = 13},
  [1142] = {.lex_state = 37, .external_lex_state = 13},
  [1143] = {.lex_state = 37, .external_lex_state = 9},
  [1144] = {.lex_state = 38, .external_lex_state = 13},
  [1145] = {.lex_state = 37, .external_lex_state = 15},
  [1146] = {.lex_state = 37, .external_lex_state = 15},
  [1147] = {.lex_state = 37, .external_lex_state = 9},
  [1148] = {.lex_state = 37, .external_lex_state = 9},
  [1149] = {.lex_state = 37, .external_lex_state = 8},
  [1150] = {.lex_state = 37, .external_lex_state = 8},
  [1151] = {.lex_state = 37, .external_lex_state = 9},
  [1152] = {.lex_state = 37, .external_lex_state = 8},
  [1153] = {.lex_state = 37, .external_lex_state = 15},
  [1154] = {.lex_state = 37, .external_lex_state = 13},
  [1155] = {.lex_state = 37, .external_lex_state = 12},
  [1156] = {.lex_state = 37, .external_lex_state = 12},
  [1157] = {.lex_state = 37, .external_lex_state = 12},
  [1158] = {.lex_state = 37, .external_lex_state = 7},
  [1159] = {.lex_state = 37, .external_lex_state = 12},
  [1160] = {.lex_state = 37, .external_lex_state = 12},
  [1161] = {.lex_state = 37, .external_lex_state = 12},
  [1162] = {.lex_state = 37, .external_lex_state = 12},
  [1163] = {.lex_state = 37, .external_lex_state = 12},
  [1164] = {.lex_state = 37, .external_lex_state = 12},
  [1165] = {.lex_state = 37, .external_lex_state = 12},
  [1166] = {.lex_state = 37, .external_lex_state = 12},
  [1167] = {.lex_state = 38, .external_lex_state = 13},
  [1168] = {.lex_state = 37, .external_lex_state = 12},
  [1169] = {.lex_state = 37, .external_lex_state = 12},
  [1170] = {.lex_state = 37, .external_lex_state = 12},
  [1171] = {.lex_state = 37, .external_lex_state = 12},
  [1172] = {.lex_state = 37, .external_lex_state = 13},
  [1173] = {.lex_state = 37, .external_lex_state = 12},
  [1174] = {.lex_state = 38, .external_lex_state = 13},
  [1175] = {.lex_state = 38, .external_lex_state = 13},
  [1176] = {.lex_state = 38, .external_lex_state = 13},
  [1177] = {.lex_state = 38, .external_lex_state = 13},
  [1178] = {.lex_state = 37, .external_lex_state = 12},
  [1179] = {.lex_state = 37, .external_lex_state = 12},
  [1180] = {.lex_state = 38, .external_lex_state = 13},
  [1181] = {.lex_state = 37, .external_lex_state = 7},
  [1182] = {.lex_state = 38, .external_lex_state = 13},
  [1183] = {.lex_state = 37, .external_lex_state = 12},
  [1184] = {.lex_state = 37, .external_lex_state = 12},
  [1185] = {.lex_state = 37, .external_lex_state = 12},
  [1186] = {.lex_state = 37, .external_lex_state = 12},
  [1187] = {.lex_state = 37, .external_lex_state = 12},
  [1188] = {.lex_state = 38, .external_lex_state = 15},
  [1189] = {.lex_state = 38, .external_lex_state = 15},
  [1190] = {.lex_state = 37, .external_lex_state = 13},
  [1191] = {.lex_state = 37, .external_lex_state = 12},
  [1192] = {.lex_state = 37, .external_lex_state = 12},
  [1193] = {.lex_state = 37, .external_lex_state = 15},
  [1194] = {.lex_state = 38, .external_lex_state = 13},
  [1195] = {.lex_state = 37, .external_lex_state = 12},
  [1196] = {.lex_state = 38, .external_lex_state = 15},
  [1197] = {.lex_state = 37, .external_lex_state = 15},
  [1198] = {.lex_state = 37, .external_lex_state = 12},
  [1199] = {.lex_state = 38, .external_lex_state = 14},
  [1200] = {.lex_state = 38, .external_lex_state = 14},
  [1201] = {.lex_state = 38, .external_lex_state = 14},
  [1202] = {.lex_state = 38, .external_lex_state = 14},
  [1203] = {.lex_state = 37, .external_lex_state = 12},
  [1204] = {.lex_state = 37, .external_lex_state = 2},
  [1205] = {.lex_state = 37, .external_lex_state = 13},
  [1206] = {.lex_state = 37, .external_lex_state = 12},
  [1207] = {.lex_state = 37, .external_lex_state = 15},
  [1208] = {.lex_state = 37, .external_lex_state = 12},
  [1209] = {.lex_state = 37, .external_lex_state = 15},
  [1210] = {.lex_state = 37, .external_lex_state = 15},
  [1211] = {.lex_state = 37, .external_lex_state = 15},
  [1212] = {.lex_state = 37, .external_lex_state = 15},
  [1213] = {.lex_state = 37, .external_lex_state = 15},
  [1214] = {.lex_state = 37, .external_lex_state = 12},
  [1215] = {.lex_state = 38, .external_lex_state = 13},
  [1216] = {.lex_state = 38, .external_lex_state = 13},
  [1217] = {.lex_state = 37, .external_lex_state = 13},
  [1218] = {.lex_state = 37, .external_lex_state = 12},
  [1219] = {.lex_state = 37, .external_lex_state = 15},
  [1220] = {.lex_state = 37, .external_lex_state = 12},
  [1221] = {.lex_state = 37, .external_lex_state = 12},
  [1222] = {.lex_state = 38, .external_lex_state = 15},
  [1223] = {.lex_state = 37, .external_lex_state = 7},
  [1224] = {.lex_state = 37, .external_lex_state = 12},
  [1225] = {.lex_state = 37, .external_lex_state = 12},
  [1226] = {.lex_state = 37, .external_lex_state = 15},
  [1227] = {.lex_state = 38, .external_lex_state = 15},
  [1228] = {.lex_state = 38, .external_lex_state = 15},
  [1229] = {.lex_state = 38, .external_lex_state = 15},
  [1230] = {.lex_state = 37, .external_lex_state = 15},
  [1231] = {.lex_state = 38, .external_lex_state = 15},
  [1232] = {.lex_state = 37, .external_lex_state = 12},
  [1233] = {.lex_state = 38, .external_lex_state = 13},
  [1234] = {.lex_state = 38, .external_lex_state = 13},
  [1235] = {.lex_state = 37, .external_lex_state = 12},
  [1236] = {.lex_state = 37, .external_lex_state = 12},
  [1237] = {.lex_state = 37, .external_lex_state = 12},
  [1238] = {.lex_state = 37, .external_lex_state = 8},
  [1239] = {.lex_state = 37, .external_lex_state = 7},
  [1240] = {.lex_state = 37, .external_lex_state = 12},
  [1241] = {.lex_state = 37, .external_lex_state = 12},
  [1242] = {.lex_state = 37, .external_lex_state = 12},
  [1243] = {.lex_state = 37, .external_lex_state = 12},
  [1244] = {.lex_state = 37, .external_lex_state = 13},
  [1245] = {.lex_state = 37, .external_lex_state = 13},
  [1246] = {.lex_state = 37, .external_lex_state = 13},
  [1247] = {.lex_state = 38, .external_lex_state = 15},
  [1248] = {.lex_state = 37, .external_lex_state = 12},
  [1249] = {.lex_state = 38, .external_lex_state = 15},
  [1250] = {.lex_state = 37, .external_lex_state = 8},
  [1251] = {.lex_state = 37, .external_lex_state = 12},
  [1252] = {.lex_state = 37, .external_lex_state = 12},
  [1253] = {.lex_state = 37, .external_lex_state = 12},
  [1254] = {.lex_state = 37, .external_lex_state = 12},
  [1255] = {.lex_state = 37, .external_lex_state = 2},
  [1256] = {.lex_state = 37, .external_lex_state = 12},
  [1257] = {.lex_state = 37, .external_lex_state = 12},
  [1258] = {.lex_state = 37, .external_lex_state = 12},
  [1259] = {.lex_state = 37, .external_lex_state = 12},
  [1260] = {.lex_state = 37, .external_lex_state = 12},
  [1261] = {.lex_state = 37, .external_lex_state = 12},
  [1262] = {.lex_state = 37, .external_lex_state = 12},
  [1263] = {.lex_state = 37, .external_lex_state = 12},
  [1264] = {.lex_state = 37, .external_lex_state = 12},
  [1265] = {.lex_state = 37, .external_lex_state = 12},
  [1266] = {.lex_state = 37, .external_lex_state = 12},
  [1267] = {.lex_state = 37, .external_lex_state = 12},
  [1268] = {.lex_state = 37, .external_lex_state = 12},
  [1269] = {.lex_state = 37, .external_lex_state = 12},
  [1270] = {.lex_state = 37, .external_lex_state = 12},
  [1271] = {.lex_state = 37, .external_lex_state = 12},
  [1272] = {.lex_state = 37, .external_lex_state = 12},
  [1273] = {.lex_state = 37, .external_lex_state = 12},
  [1274] = {.lex_state = 37, .external_lex_state = 12},
  [1275] = {.lex_state = 37, .external_lex_state = 12},
  [1276] = {.lex_state = 37, .external_lex_state = 12},
  [1277] = {.lex_state = 37, .external_lex_state = 12},
  [1278] = {.lex_state = 37, .external_lex_state = 15},
  [1279] = {.lex_state = 37, .external_lex_state = 15},
  [1280] = {.lex_state = 37, .external_lex_state = 13},
  [1281] = {.lex_state = 37, .external_lex_state = 14},
  [1282] = {.lex_state = 37, .external_lex_state = 14},
  [1283] = {.lex_state = 37, .external_lex_state = 14},
  [1284] = {.lex_state = 37, .external_lex_state = 13},
  [1285] = {.lex_state = 37, .external_lex_state = 14},
  [1286] = {.lex_state = 37, .external_lex_state = 13},
  [1287] = {.lex_state = 37, .external_lex_state = 15},
  [1288] = {.lex_state = 37, .external_lex_state = 15},
  [1289] = {.lex_state = 37, .external_lex_state = 15},
  [1290] = {.lex_state = 37, .external_lex_state = 13},
  [1291] = {.lex_state = 37, .external_lex_state = 13},
  [1292] = {.lex_state = 37, .external_lex_state = 13},
  [1293] = {.lex_state = 37, .external_lex_state = 14},
  [1294] = {.lex_state = 37, .external_lex_state = 13},
  [1295] = {.lex_state = 37, .external_lex_state = 15},
  [1296] = {.lex_state = 37, .external_lex_state = 14},
  [1297] = {.lex_state = 37, .external_lex_state = 15},
  [1298] = {.lex_state = 37, .external_lex_state = 15},
  [1299] = {.lex_state = 37, .external_lex_state = 13},
  [1300] = {.lex_state = 37, .external_lex_state = 14},
  [1301] = {.lex_state = 37, .external_lex_state = 13},
  [1302] = {.lex_state = 37, .external_lex_state = 14},
  [1303] = {.lex_state = 37, .external_lex_state = 13},
  [1304] = {.lex_state = 37, .external_lex_state = 13},
  [1305] = {.lex_state = 33, .external_lex_state = 9},
  [1306] = {.lex_state = 33, .external_lex_state = 9},
  [1307] = {.lex_state = 37, .external_lex_state = 13},
  [1308] = {.lex_state = 37, .external_lex_state = 13},
  [1309] = {.lex_state = 37, .external_lex_state = 13},
  [1310] = {.lex_state = 37, .external_lex_state = 15},
  [1311] = {.lex_state = 37, .external_lex_state = 13},
  [1312] = {.lex_state = 38, .external_lex_state = 15},
  [1313] = {.lex_state = 37, .external_lex_state = 13},
  [1314] = {.lex_state = 37, .external_lex_state = 13},
  [1315] = {.lex_state = 37, .external_lex_state = 14},
  [1316] = {.lex_state = 37, .external_lex_state = 13},
  [1317] = {.lex_state = 37, .external_lex_state = 14},
  [1318] = {.lex_state = 38, .external_lex_state = 15},
  [1319] = {.lex_state = 37, .external_lex_state = 9},
  [1320] = {.lex_state = 38, .external_lex_state = 15},
  [1321] = {.lex_state = 37, .external_lex_state = 15},
  [1322] = {.lex_state = 37, .external_lex_state = 15},
  [1323] = {.lex_state = 37, .external_lex_state = 14},
  [1324] = {.lex_state = 37, .external_lex_state = 14},
  [1325] = {.lex_state = 37, .external_lex_state = 14},
  [1326] = {.lex_state = 37, .external_lex_state = 14},
  [1327] = {.lex_state = 37, .external_lex_state = 14},
  [1328] = {.lex_state = 37, .external_lex_state = 13},
  [1329] = {.lex_state = 37, .external_lex_state = 13},
  [1330] = {.lex_state = 37, .external_lex_state = 15},
  [1331] = {.lex_state = 37, .external_lex_state = 14},
  [1332] = {.lex_state = 37, .external_lex_state = 14},
  [1333] = {.lex_state = 37, .external_lex_state = 14},
  [1334] = {.lex_state = 37, .external_lex_state = 14},
  [1335] = {.lex_state = 37, .external_lex_state = 14},
  [1336] = {.lex_state = 37, .external_lex_state = 15},
  [1337] = {.lex_state = 37, .external_lex_state = 15},
  [1338] = {.lex_state = 37, .external_lex_state = 13},
  [1339] = {.lex_state = 37, .external_lex_state = 13},
  [1340] = {.lex_state = 37, .external_lex_state = 14},
  [1341] = {.lex_state = 37, .external_lex_state = 13},
  [1342] = {.lex_state = 37, .external_lex_state = 14},
  [1343] = {.lex_state = 37, .external_lex_state = 14},
  [1344] = {.lex_state = 37, .external_lex_state = 13},
  [1345] = {.lex_state = 37, .external_lex_state = 15},
  [1346] = {.lex_state = 37, .external_lex_state = 13},
  [1347] = {.lex_state = 37, .external_lex_state = 13},
  [1348] = {.lex_state = 37, .external_lex_state = 13},
  [1349] = {.lex_state = 37, .external_lex_state = 13},
  [1350] = {.lex_state = 37, .external_lex_state = 15},
  [1351] = {.lex_state = 37, .external_lex_state = 13},
  [1352] = {.lex_state = 37, .external_lex_state = 13},
  [1353] = {.lex_state = 37, .external_lex_state = 13},
  [1354] = {.lex_state = 37, .external_lex_state = 13},
  [1355] = {.lex_state = 38, .external_lex_state = 13},
  [1356] = {.lex_state = 37, .external_lex_state = 14},
  [1357] = {.lex_state = 37, .external_lex_state = 14},
  [1358] = {.lex_state = 38, .external_lex_state = 13},
  [1359] = {.lex_state = 37, .external_lex_state = 14},
  [1360] = {.lex_state = 38, .external_lex_state = 13},
  [1361] = {.lex_state = 37, .external_lex_state = 13},
  [1362] = {.lex_state = 37, .external_lex_state = 15},
  [1363] = {.lex_state = 37, .external_lex_state = 13},
  [1364] = {.lex_state = 37, .external_lex_state = 14},
  [1365] = {.lex_state = 37, .external_lex_state = 13},
  [1366] = {.lex_state = 37, .external_lex_state = 13},
  [1367] = {.lex_state = 37, .external_lex_state = 13},
  [1368] = {.lex_state = 37, .external_lex_state = 13},
  [1369] = {.lex_state = 37, .external_lex_state = 13},
  [1370] = {.lex_state = 37, .external_lex_state = 13},
  [1371] = {.lex_state = 37, .external_lex_state = 13},
  [1372] = {.lex_state = 37, .external_lex_state = 13},
  [1373] = {.lex_state = 37, .external_lex_state = 13},
  [1374] = {.lex_state = 37, .external_lex_state = 13},
  [1375] = {.lex_state = 37, .external_lex_state = 15},
  [1376] = {.lex_state = 37, .external_lex_state = 13},
  [1377] = {.lex_state = 37, .external_lex_state = 15},
  [1378] = {.lex_state = 37, .external_lex_state = 13},
  [1379] = {.lex_state = 37, .external_lex_state = 13},
  [1380] = {.lex_state = 37, .external_lex_state = 14},
  [1381] = {.lex_state = 37, .external_lex_state = 14},
  [1382] = {.lex_state = 37, .external_lex_state = 13},
  [1383] = {.lex_state = 37, .external_lex_state = 13},
  [1384] = {.lex_state = 37, .external_lex_state = 14},
  [1385] = {.lex_state = 37, .external_lex_state = 15},
  [1386] = {.lex_state = 37, .external_lex_state = 13},
  [1387] = {.lex_state = 37, .external_lex_state = 13},
  [1388] = {.lex_state = 37, .external_lex_state = 13},
  [1389] = {.lex_state = 37, .external_lex_state = 13},
  [1390] = {.lex_state = 37, .external_lex_state = 13},
  [1391] = {.lex_state = 37, .external_lex_state = 13},
  [1392] = {.lex_state = 37, .external_lex_state = 15},
  [1393] = {.lex_state = 37, .external_lex_state = 15},
  [1394] = {.lex_state = 37, .external_lex_state = 15},
  [1395] = {.lex_state = 37, .external_lex_state = 15},
  [1396] = {.lex_state = 37, .external_lex_state = 13},
  [1397] = {.lex_state = 37, .external_lex_state = 15},
  [1398] = {.lex_state = 37, .external_lex_state = 15},
  [1399] = {.lex_state = 37, .external_lex_state = 14},
  [1400] = {.lex_state = 37, .external_lex_state = 15},
  [1401] = {.lex_state = 37, .external_lex_state = 13},
  [1402] = {.lex_state = 33, .external_lex_state = 9},
  [1403] = {.lex_state = 37, .external_lex_state = 15},
  [1404] = {.lex_state = 37, .external_lex_state = 15},
  [1405] = {.lex_state = 37, .external_lex_state = 13},
  [1406] = {.lex_state = 37, .external_lex_state = 13},
  [1407] = {.lex_state = 37, .external_lex_state = 13},
  [1408] = {.lex_state = 37, .external_lex_state = 13},
  [1409] = {.lex_state = 37, .external_lex_state = 13},
  [1410] = {.lex_state = 37, .external_lex_state = 15},
  [1411] = {.lex_state = 37, .external_lex_state = 15},
  [1412] = {.lex_state = 37, .external_lex_state = 13},
  [1413] = {.lex_state = 37, .external_lex_state = 14},
  [1414] = {.lex_state = 37, .external_lex_state = 15},
  [1415] = {.lex_state = 37, .external_lex_state = 14},
  [1416] = {.lex_state = 37, .external_lex_state = 15},
  [1417] = {.lex_state = 37, .external_lex_state = 14},
  [1418] = {.lex_state = 33, .external_lex_state = 9},
  [1419] = {.lex_state = 33, .external_lex_state = 9},
  [1420] = {.lex_state = 37, .external_lex_state = 15},
  [1421] = {.lex_state = 37, .external_lex_state = 13},
  [1422] = {.lex_state = 33, .external_lex_state = 9},
  [1423] = {.lex_state = 37, .external_lex_state = 15},
  [1424] = {.lex_state = 37, .external_lex_state = 15},
  [1425] = {.lex_state = 37, .external_lex_state = 13},
  [1426] = {.lex_state = 37, .external_lex_state = 13},
  [1427] = {.lex_state = 37, .external_lex_state = 13},
  [1428] = {.lex_state = 37, .external_lex_state = 13},
  [1429] = {.lex_state = 37, .external_lex_state = 14},
  [1430] = {.lex_state = 37, .external_lex_state = 14},
  [1431] = {.lex_state = 37, .external_lex_state = 13},
  [1432] = {.lex_state = 37, .external_lex_state = 13},
  [1433] = {.lex_state = 37, .external_lex_state = 8},
  [1434] = {.lex_state = 37, .external_lex_state = 15},
  [1435] = {.lex_state = 37, .external_lex_state = 15},
  [1436] = {.lex_state = 37, .external_lex_state = 13},
  [1437] = {.lex_state = 37, .external_lex_state = 8},
  [1438] = {.lex_state = 37, .external_lex_state = 15},
  [1439] = {.lex_state = 37, .external_lex_state = 15},
  [1440] = {.lex_state = 37, .external_lex_state = 15},
  [1441] = {.lex_state = 37, .external_lex_state = 15},
  [1442] = {.lex_state = 37, .external_lex_state = 15},
  [1443] = {.lex_state = 37, .external_lex_state = 15},
  [1444] = {.lex_state = 37, .external_lex_state = 15},
  [1445] = {.lex_state = 37, .external_lex_state = 15},
  [1446] = {.lex_state = 37, .external_lex_state = 15},
  [1447] = {.lex_state = 37, .external_lex_state = 15},
  [1448] = {.lex_state = 37, .external_lex_state = 15},
  [1449] = {.lex_state = 37, .external_lex_state = 15},
  [1450] = {.lex_state = 37, .external_lex_state = 15},
  [1451] = {.lex_state = 37, .external_lex_state = 15},
  [1452] = {.lex_state = 37, .external_lex_state = 15},
  [1453] = {.lex_state = 37, .external_lex_state = 15},
  [1454] = {.lex_state = 37, .external_lex_state = 15},
  [1455] = {.lex_state = 37, .external_lex_state = 15},
  [1456] = {.lex_state = 37, .external_lex_state = 15},
  [1457] = {.lex_state = 37, .external_lex_state = 15},
  [1458] = {.lex_state = 37, .external_lex_state = 15},
  [1459] = {.lex_state = 37, .external_lex_state = 15},
  [1460] = {.lex_state = 37, .external_lex_state = 15},
  [1461] = {.lex_state = 37, .external_lex_state = 15},
  [1462] = {.lex_state = 37, .external_lex_state = 15},
  [1463] = {.lex_state = 37, .external_lex_state = 15},
  [1464] = {.lex_state = 37, .external_lex_state = 15},
  [1465] = {.lex_state = 37, .external_lex_state = 15},
  [1466] = {.lex_state = 37, .external_lex_state = 15},
  [1467] = {.lex_state = 37, .external_lex_state = 15},
  [1468] = {.lex_state = 37, .external_lex_state = 15},
  [1469] = {.lex_state = 38, .external_lex_state = 13},
  [1470] = {.lex_state = 38, .external_lex_state = 13},
  [1471] = {.lex_state = 38, .external_lex_state = 13},
  [1472] = {.lex_state = 37, .external_lex_state = 15},
  [1473] = {.lex_state = 37, .external_lex_state = 15},
  [1474] = {.lex_state = 37, .external_lex_state = 15},
  [1475] = {.lex_state = 37, .external_lex_state = 14},
  [1476] = {.lex_state = 37, .external_lex_state = 15},
  [1477] = {.lex_state = 37, .external_lex_state = 15},
  [1478] = {.lex_state = 38, .external_lex_state = 15},
  [1479] = {.lex_state = 38, .external_lex_state = 15},
  [1480] = {.lex_state = 37, .external_lex_state = 15},
  [1481] = {.lex_state = 38, .external_lex_state = 15},
  [1482] = {.lex_state = 37, .external_lex_state = 15},
  [1483] = {.lex_state = 37, .external_lex_state = 15},
  [1484] = {.lex_state = 37, .external_lex_state = 15},
  [1485] = {.lex_state = 37, .external_lex_state = 15},
  [1486] = {.lex_state = 38, .external_lex_state = 12},
  [1487] = {.lex_state = 38, .external_lex_state = 12},
  [1488] = {.lex_state = 38, .external_lex_state = 12},
  [1489] = {.lex_state = 33, .external_lex_state = 14},
  [1490] = {.lex_state = 33, .external_lex_state = 14},
  [1491] = {.lex_state = 33, .external_lex_state = 14},
  [1492] = {.lex_state = 33, .external_lex_state = 14},
  [1493] = {.lex_state = 33, .external_lex_state = 14},
  [1494] = {.lex_state = 33, .external_lex_state = 14},
  [1495] = {.lex_state = 33, .external_lex_state = 14},
  [1496] = {.lex_state = 33, .external_lex_state = 14},
  [1497] = {.lex_state = 33, .external_lex_state = 14},
  [1498] = {.lex_state = 33, .external_lex_state = 14},
  [1499] = {.lex_state = 33, .external_lex_state = 14},
  [1500] = {.lex_state = 33, .external_lex_state = 14},
  [1501] = {.lex_state = 37, .external_lex_state = 13},
  [1502] = {.lex_state = 33, .external_lex_state = 14},
  [1503] = {.lex_state = 37, .external_lex_state = 15},
  [1504] = {.lex_state = 33, .external_lex_state = 14},
  [1505] = {.lex_state = 33, .external_lex_state = 14},
  [1506] = {.lex_state = 37, .external_lex_state = 12},
  [1507] = {.lex_state = 33, .external_lex_state = 14},
  [1508] = {.lex_state = 36, .external_lex_state = 2},
  [1509] = {.lex_state = 36, .external_lex_state = 2},
  [1510] = {.lex_state = 30, .external_lex_state = 7},
  [1511] = {.lex_state = 30, .external_lex_state = 8},
  [1512] = {.lex_state = 30, .external_lex_state = 8},
  [1513] = {.lex_state = 30, .external_lex_state = 7},
  [1514] = {.lex_state = 30, .external_lex_state = 7},
  [1515] = {.lex_state = 30, .external_lex_state = 7},
  [1516] = {.lex_state = 30, .external_lex_state = 8},
  [1517] = {.lex_state = 30, .external_lex_state = 7},
  [1518] = {.lex_state = 30, .external_lex_state = 7},
  [1519] = {.lex_state = 30, .external_lex_state = 8},
  [1520] = {.lex_state = 30, .external_lex_state = 7},
  [1521] = {.lex_state = 30, .external_lex_state = 8},
  [1522] = {.lex_state = 30, .external_lex_state = 7},
  [1523] = {.lex_state = 30, .external_lex_state = 8},
  [1524] = {.lex_state = 30, .external_lex_state = 8},
  [1525] = {.lex_state = 30, .external_lex_state = 7},
  [1526] = {.lex_state = 30, .external_lex_state = 7},
  [1527] = {.lex_state = 30, .external_lex_state = 8},
  [1528] = {.lex_state = 30, .external_lex_state = 7},
  [1529] = {.lex_state = 30, .external_lex_state = 8},
  [1530] = {.lex_state = 30, .external_lex_state = 8},
  [1531] = {.lex_state = 30, .external_lex_state = 7},
  [1532] = {.lex_state = 30, .external_lex_state = 7},
  [1533] = {.lex_state = 30, .external_lex_state = 8},
  [1534] = {.lex_state = 30, .external_lex_state = 7},
  [1535] = {.lex_state = 30, .external_lex_state = 7},
  [1536] = {.lex_state = 30, .external_lex_state = 7},
  [1537] = {.lex_state = 30, .external_lex_state = 7},
  [1538] = {.lex_state = 30, .external_lex_state = 7},
  [1539] = {.lex_state = 30, .external_lex_state = 7},
  [1540] = {.lex_state = 30, .external_lex_state = 7},
  [1541] = {.lex_state = 30, .external_lex_state = 7},
  [1542] = {.lex_state = 30, .external_lex_state = 7},
  [1543] = {.lex_state = 30, .external_lex_state = 7},
  [1544] = {.lex_state = 30, .external_lex_state = 8},
  [1545] = {.lex_state = 30, .external_lex_state = 7},
  [1546] = {.lex_state = 30, .external_lex_state = 2},
  [1547] = {.lex_state = 30, .external_lex_state = 2},
  [1548] = {.lex_state = 30, .external_lex_state = 2},
  [1549] = {.lex_state = 30, .external_lex_state = 2},
  [1550] = {.lex_state = 30, .external_lex_state = 2},
  [1551] = {.lex_state = 30, .external_lex_state = 6},
  [1552] = {.lex_state = 30, .external_lex_state = 6},
  [1553] = {.lex_state = 30, .external_lex_state = 6},
  [1554] = {.lex_state = 30, .external_lex_state = 6},
  [1555] = {.lex_state = 30, .external_lex_state = 6},
  [1556] = {.lex_state = 30, .external_lex_state = 6},
  [1557] = {.lex_state = 30, .external_lex_state = 6},
  [1558] = {.lex_state = 30, .external_lex_state = 6},
  [1559] = {.lex_state = 30, .external_lex_state = 6},
  [1560] = {.lex_state = 30, .external_lex_state = 6},
  [1561] = {.lex_state = 30, .external_lex_state = 6},
  [1562] = {.lex_state = 30, .external_lex_state = 6},
  [1563] = {.lex_state = 30, .external_lex_state = 6},
  [1564] = {.lex_state = 30, .external_lex_state = 6},
  [1565] = {.lex_state = 30, .external_lex_state = 6},
  [1566] = {.lex_state = 30, .external_lex_state = 6},
  [1567] = {.lex_state = 30, .external_lex_state = 6},
  [1568] = {.lex_state = 30, .external_lex_state = 6},
  [1569] = {.lex_state = 30, .external_lex_state = 6},
  [1570] = {.lex_state = 30, .external_lex_state = 6},
  [1571] = {.lex_state = 30, .external_lex_state = 2},
  [1572] = {.lex_state = 30, .external_lex_state = 2},
  [1573] = {.lex_state = 30, .external_lex_state = 2},
  [1574] = {.lex_state = 30, .external_lex_state = 2},
  [1575] = {.lex_state = 30, .external_lex_state = 2},
  [1576] = {.lex_state = 30, .external_lex_state = 2},
  [1577] = {.lex_state = 30, .external_lex_state = 2},
  [1578] = {.lex_state = 30, .external_lex_state = 2},
  [1579] = {.lex_state = 30, .external_lex_state = 2},
  [1580] = {.lex_state = 33, .external_lex_state = 9},
  [1581] = {.lex_state = 33, .external_lex_state = 9},
  [1582] = {.lex_state = 37, .external_lex_state = 12},
  [1583] = {.lex_state = 37, .external_lex_state = 12},
  [1584] = {.lex_state = 33, .external_lex_state = 14},
  [1585] = {.lex_state = 37, .external_lex_state = 12},
  [1586] = {.lex_state = 33, .external_lex_state = 14},
  [1587] = {.lex_state = 37, .external_lex_state = 12},
  [1588] = {.lex_state = 37, .external_lex_state = 12},
  [1589] = {.lex_state = 33, .external_lex_state = 13},
  [1590] = {.lex_state = 37, .external_lex_state = 12},
  [1591] = {.lex_state = 33, .external_lex_state = 13},
  [1592] = {.lex_state = 54, .external_lex_state = 12},
  [1593] = {.lex_state = 33, .external_lex_state = 15},
  [1594] = {.lex_state = 54, .external_lex_state = 12},
  [1595] = {.lex_state = 54, .external_lex_state = 12},
  [1596] = {.lex_state = 54, .external_lex_state = 12},
  [1597] = {.lex_state = 33, .external_lex_state = 15},
  [1598] = {.lex_state = 37, .external_lex_state = 13},
  [1599] = {.lex_state = 37, .external_lex_state = 13},
  [1600] = {.lex_state = 37, .external_lex_state = 13},
  [1601] = {.lex_state = 54, .external_lex_state = 13},
  [1602] = {.lex_state = 37, .external_lex_state = 13},
  [1603] = {.lex_state = 54, .external_lex_state = 15},
  [1604] = {.lex_state = 37, .external_lex_state = 13},
  [1605] = {.lex_state = 35, .external_lex_state = 9},
  [1606] = {.lex_state = 35, .external_lex_state = 9},
  [1607] = {.lex_state = 37, .external_lex_state = 13},
  [1608] = {.lex_state = 54, .external_lex_state = 15},
  [1609] = {.lex_state = 54, .external_lex_state = 13},
  [1610] = {.lex_state = 37, .external_lex_state = 13},
  [1611] = {.lex_state = 37, .external_lex_state = 15},
  [1612] = {.lex_state = 37, .external_lex_state = 14},
  [1613] = {.lex_state = 37, .external_lex_state = 14},
  [1614] = {.lex_state = 37, .external_lex_state = 14},
  [1615] = {.lex_state = 35, .external_lex_state = 9},
  [1616] = {.lex_state = 37, .external_lex_state = 14},
  [1617] = {.lex_state = 37, .external_lex_state = 14},
  [1618] = {.lex_state = 37, .external_lex_state = 14},
  [1619] = {.lex_state = 37, .external_lex_state = 14},
  [1620] = {.lex_state = 37, .external_lex_state = 13},
  [1621] = {.lex_state = 37, .external_lex_state = 15},
  [1622] = {.lex_state = 37, .external_lex_state = 14},
  [1623] = {.lex_state = 37, .external_lex_state = 14},
  [1624] = {.lex_state = 37, .external_lex_state = 14},
  [1625] = {.lex_state = 37, .external_lex_state = 14},
  [1626] = {.lex_state = 37, .external_lex_state = 14},
  [1627] = {.lex_state = 37, .external_lex_state = 14},
  [1628] = {.lex_state = 37, .external_lex_state = 15},
  [1629] = {.lex_state = 37, .external_lex_state = 14},
  [1630] = {.lex_state = 37, .external_lex_state = 15},
  [1631] = {.lex_state = 37, .external_lex_state = 14},
  [1632] = {.lex_state = 37, .external_lex_state = 13},
  [1633] = {.lex_state = 37, .external_lex_state = 14},
  [1634] = {.lex_state = 37, .external_lex_state = 14},
  [1635] = {.lex_state = 37, .external_lex_state = 14},
  [1636] = {.lex_state = 37, .external_lex_state = 14},
  [1637] = {.lex_state = 37, .external_lex_state = 14},
  [1638] = {.lex_state = 35, .external_lex_state = 9},
  [1639] = {.lex_state = 37, .external_lex_state = 14},
  [1640] = {.lex_state = 37, .external_lex_state = 15},
  [1641] = {.lex_state = 37, .external_lex_state = 13},
  [1642] = {.lex_state = 35, .external_lex_state = 9},
  [1643] = {.lex_state = 35, .external_lex_state = 9},
  [1644] = {.lex_state = 37, .external_lex_state = 13},
  [1645] = {.lex_state = 37, .external_lex_state = 15},
  [1646] = {.lex_state = 37, .external_lex_state = 13},
  [1647] = {.lex_state = 37, .external_lex_state = 14},
  [1648] = {.lex_state = 36, .external_lex_state = 14},
  [1649] = {.lex_state = 36, .external_lex_state = 14},
  [1650] = {.lex_state = 36, .external_lex_state = 14},
  [1651] = {.lex_state = 35, .external_lex_state = 14},
  [1652] = {.lex_state = 36, .external_lex_state = 14},
  [1653] = {.lex_state = 35, .external_lex_state = 14},
  [1654] = {.lex_state = 36, .external_lex_state = 14},
  [1655] = {.lex_state = 35, .external_lex_state = 9},
  [1656] = {.lex_state = 36, .external_lex_state = 14},
  [1657] = {.lex_state = 35, .external_lex_state = 14},
  [1658] = {.lex_state = 36, .external_lex_state = 14},
  [1659] = {.lex_state = 35, .external_lex_state = 14},
  [1660] = {.lex_state = 35, .external_lex_state = 14},
  [1661] = {.lex_state = 35, .external_lex_state = 14},
  [1662] = {.lex_state = 36, .external_lex_state = 14},
  [1663] = {.lex_state = 35, .external_lex_state = 14},
  [1664] = {.lex_state = 36, .external_lex_state = 14},
  [1665] = {.lex_state = 36, .external_lex_state = 14},
  [1666] = {.lex_state = 35, .external_lex_state = 14},
  [1667] = {.lex_state = 36, .external_lex_state = 14},
  [1668] = {.lex_state = 30, .external_lex_state = 13},
  [1669] = {.lex_state = 36, .external_lex_state = 14},
  [1670] = {.lex_state = 30, .external_lex_state = 13},
  [1671] = {.lex_state = 36, .external_lex_state = 14},
  [1672] = {.lex_state = 35, .external_lex_state = 14},
  [1673] = {.lex_state = 30, .external_lex_state = 13},
  [1674] = {.lex_state = 30, .external_lex_state = 14},
  [1675] = {.lex_state = 30, .external_lex_state = 14},
  [1676] = {.lex_state = 33, .external_lex_state = 9},
  [1677] = {.lex_state = 33, .external_lex_state = 9},
  [1678] = {.lex_state = 54, .external_lex_state = 12},
  [1679] = {.lex_state = 54, .external_lex_state = 12},
  [1680] = {.lex_state = 54, .external_lex_state = 12},
  [1681] = {.lex_state = 54, .external_lex_state = 12},
  [1682] = {.lex_state = 33, .external_lex_state = 9},
  [1683] = {.lex_state = 54, .external_lex_state = 12},
  [1684] = {.lex_state = 54, .external_lex_state = 12},
  [1685] = {.lex_state = 33, .external_lex_state = 9},
  [1686] = {.lex_state = 33, .external_lex_state = 9},
  [1687] = {.lex_state = 33, .external_lex_state = 9},
  [1688] = {.lex_state = 33, .external_lex_state = 9},
  [1689] = {.lex_state = 54, .external_lex_state = 12},
  [1690] = {.lex_state = 33, .external_lex_state = 9},
  [1691] = {.lex_state = 33, .external_lex_state = 9},
  [1692] = {.lex_state = 54, .external_lex_state = 12},
  [1693] = {.lex_state = 54, .external_lex_state = 13},
  [1694] = {.lex_state = 54, .external_lex_state = 15},
  [1695] = {.lex_state = 54, .external_lex_state = 13},
  [1696] = {.lex_state = 54, .external_lex_state = 13},
  [1697] = {.lex_state = 54, .external_lex_state = 13},
  [1698] = {.lex_state = 54, .external_lex_state = 13},
  [1699] = {.lex_state = 54, .external_lex_state = 13},
  [1700] = {.lex_state = 33, .external_lex_state = 9},
  [1701] = {.lex_state = 54, .external_lex_state = 13},
  [1702] = {.lex_state = 54, .external_lex_state = 15},
  [1703] = {.lex_state = 54, .external_lex_state = 15},
  [1704] = {.lex_state = 54, .external_lex_state = 15},
  [1705] = {.lex_state = 54, .external_lex_state = 13},
  [1706] = {.lex_state = 54, .external_lex_state = 15},
  [1707] = {.lex_state = 54, .external_lex_state = 13},
  [1708] = {.lex_state = 54, .external_lex_state = 13},
  [1709] = {.lex_state = 54, .external_lex_state = 13},
  [1710] = {.lex_state = 54, .external_lex_state = 15},
  [1711] = {.lex_state = 54, .external_lex_state = 13},
  [1712] = {.lex_state = 54, .external_lex_state = 15},
  [1713] = {.lex_state = 54, .external_lex_state = 13},
  [1714] = {.lex_state = 54, .external_lex_state = 13},
  [1715] = {.lex_state = 54, .external_lex_state = 15},
  [1716] = {.lex_state = 54, .external_lex_state = 13},
  [1717] = {.lex_state = 54, .external_lex_state = 13},
  [1718] = {.lex_state = 54, .external_lex_state = 13},
  [1719] = {.lex_state = 33, .external_lex_state = 13},
  [1720] = {.lex_state = 33, .external_lex_state = 13},
  [1721] = {.lex_state = 33, .external_lex_state = 13},
  [1722] = {.lex_state = 0, .external_lex_state = 16},
  [1723] = {.lex_state = 0, .external_lex_state = 16},
  [1724] = {.lex_state = 54, .external_lex_state = 12},
  [1725] = {.lex_state = 0, .external_lex_state = 16},
  [1726] = {.lex_state = 33, .external_lex_state = 13},
  [1727] = {.lex_state = 33, .external_lex_state = 13},
  [1728] = {.lex_state = 33, .external_lex_state = 14},
  [1729] = {.lex_state = 54, .external_lex_state = 12},
  [1730] = {.lex_state = 0, .external_lex_state = 16},
  [1731] = {.lex_state = 0, .external_lex_state = 16},
  [1732] = {.lex_state = 0, .external_lex_state = 16},
  [1733] = {.lex_state = 0, .external_lex_state = 16},
  [1734] = {.lex_state = 33, .external_lex_state = 13},
  [1735] = {.lex_state = 33, .external_lex_state = 13},
  [1736] = {.lex_state = 0, .external_lex_state = 16},
  [1737] = {.lex_state = 0, .external_lex_state = 16},
  [1738] = {.lex_state = 0, .external_lex_state = 16},
  [1739] = {.lex_state = 33, .external_lex_state = 13},
  [1740] = {.lex_state = 33, .external_lex_state = 13},
  [1741] = {.lex_state = 33, .external_lex_state = 14},
  [1742] = {.lex_state = 0, .external_lex_state = 16},
  [1743] = {.lex_state = 33, .external_lex_state = 14},
  [1744] = {.lex_state = 0, .external_lex_state = 16},
  [1745] = {.lex_state = 0, .external_lex_state = 16},
  [1746] = {.lex_state = 33, .external_lex_state = 14},
  [1747] = {.lex_state = 0, .external_lex_state = 16},
  [1748] = {.lex_state = 33, .external_lex_state = 14},
  [1749] = {.lex_state = 33, .external_lex_state = 14},
  [1750] = {.lex_state = 33, .external_lex_state = 14},
  [1751] = {.lex_state = 33, .external_lex_state = 14},
  [1752] = {.lex_state = 0, .external_lex_state = 16},
  [1753] = {.lex_state = 0, .external_lex_state = 16},
  [1754] = {.lex_state = 33, .external_lex_state = 9},
  [1755] = {.lex_state = 0, .external_lex_state = 16},
  [1756] = {.lex_state = 0, .external_lex_state = 16},
  [1757] = {.lex_state = 33, .external_lex_state = 14},
  [1758] = {.lex_state = 0, .external_lex_state = 16},
  [1759] = {.lex_state = 33, .external_lex_state = 13},
  [1760] = {.lex_state = 54, .external_lex_state = 12},
  [1761] = {.lex_state = 33, .external_lex_state = 14},
  [1762] = {.lex_state = 33, .external_lex_state = 15},
  [1763] = {.lex_state = 33, .external_lex_state = 15},
  [1764] = {.lex_state = 54, .external_lex_state = 12},
  [1765] = {.lex_state = 33, .external_lex_state = 14},
  [1766] = {.lex_state = 33, .external_lex_state = 15},
  [1767] = {.lex_state = 54, .external_lex_state = 12},
  [1768] = {.lex_state = 33, .external_lex_state = 15},
  [1769] = {.lex_state = 33, .external_lex_state = 15},
  [1770] = {.lex_state = 54, .external_lex_state = 12},
  [1771] = {.lex_state = 54, .external_lex_state = 12},
  [1772] = {.lex_state = 54, .external_lex_state = 12},
  [1773] = {.lex_state = 54, .external_lex_state = 12},
  [1774] = {.lex_state = 33, .external_lex_state = 15},
  [1775] = {.lex_state = 33, .external_lex_state = 15},
  [1776] = {.lex_state = 33, .external_lex_state = 14},
  [1777] = {.lex_state = 33, .external_lex_state = 14},
  [1778] = {.lex_state = 33, .external_lex_state = 15},
  [1779] = {.lex_state = 54, .external_lex_state = 12},
  [1780] = {.lex_state = 33, .external_lex_state = 14},
  [1781] = {.lex_state = 33, .external_lex_state = 15},
  [1782] = {.lex_state = 54, .external_lex_state = 12},
  [1783] = {.lex_state = 54, .external_lex_state = 12},
  [1784] = {.lex_state = 54, .external_lex_state = 12},
  [1785] = {.lex_state = 54, .external_lex_state = 12},
  [1786] = {.lex_state = 54, .external_lex_state = 12},
  [1787] = {.lex_state = 33, .external_lex_state = 15},
  [1788] = {.lex_state = 54, .external_lex_state = 9},
  [1789] = {.lex_state = 54, .external_lex_state = 12},
  [1790] = {.lex_state = 54, .external_lex_state = 12},
  [1791] = {.lex_state = 54, .external_lex_state = 12},
  [1792] = {.lex_state = 54, .external_lex_state = 12},
  [1793] = {.lex_state = 54, .external_lex_state = 12},
  [1794] = {.lex_state = 54, .external_lex_state = 12},
  [1795] = {.lex_state = 54, .external_lex_state = 12},
  [1796] = {.lex_state = 32, .external_lex_state = 15},
  [1797] = {.lex_state = 54, .external_lex_state = 9},
  [1798] = {.lex_state = 54, .external_lex_state = 12},
  [1799] = {.lex_state = 32, .external_lex_state = 12},
  [1800] = {.lex_state = 54, .external_lex_state = 15},
  [1801] = {.lex_state = 54, .external_lex_state = 15},
  [1802] = {.lex_state = 54, .external_lex_state = 15},
  [1803] = {.lex_state = 32, .external_lex_state = 13},
  [1804] = {.lex_state = 54, .external_lex_state = 13},
  [1805] = {.lex_state = 54, .external_lex_state = 15},
  [1806] = {.lex_state = 54, .external_lex_state = 13},
  [1807] = {.lex_state = 54, .external_lex_state = 13},
  [1808] = {.lex_state = 54, .external_lex_state = 2},
  [1809] = {.lex_state = 54, .external_lex_state = 15},
  [1810] = {.lex_state = 54, .external_lex_state = 9},
  [1811] = {.lex_state = 54, .external_lex_state = 15},
  [1812] = {.lex_state = 54, .external_lex_state = 15},
  [1813] = {.lex_state = 54, .external_lex_state = 9},
  [1814] = {.lex_state = 54, .external_lex_state = 15},
  [1815] = {.lex_state = 33, .external_lex_state = 14},
  [1816] = {.lex_state = 54, .external_lex_state = 14},
  [1817] = {.lex_state = 54, .external_lex_state = 15},
  [1818] = {.lex_state = 54, .external_lex_state = 15},
  [1819] = {.lex_state = 54, .external_lex_state = 15},
  [1820] = {.lex_state = 34, .external_lex_state = 17},
  [1821] = {.lex_state = 54, .external_lex_state = 14},
  [1822] = {.lex_state = 54, .external_lex_state = 13},
  [1823] = {.lex_state = 34, .external_lex_state = 17},
  [1824] = {.lex_state = 54, .external_lex_state = 15},
  [1825] = {.lex_state = 54, .external_lex_state = 15},
  [1826] = {.lex_state = 54, .external_lex_state = 13},
  [1827] = {.lex_state = 54, .external_lex_state = 15},
  [1828] = {.lex_state = 54, .external_lex_state = 9},
  [1829] = {.lex_state = 54, .external_lex_state = 15},
  [1830] = {.lex_state = 54, .external_lex_state = 9},
  [1831] = {.lex_state = 54, .external_lex_state = 9},
  [1832] = {.lex_state = 54, .external_lex_state = 15},
  [1833] = {.lex_state = 54, .external_lex_state = 15},
  [1834] = {.lex_state = 54, .external_lex_state = 15},
  [1835] = {.lex_state = 54, .external_lex_state = 9},
  [1836] = {.lex_state = 54, .external_lex_state = 12},
  [1837] = {.lex_state = 54, .external_lex_state = 13},
  [1838] = {.lex_state = 54, .external_lex_state = 13},
  [1839] = {.lex_state = 54, .external_lex_state = 9},
  [1840] = {.lex_state = 34, .external_lex_state = 17},
  [1841] = {.lex_state = 54, .external_lex_state = 12},
  [1842] = {.lex_state = 34, .external_lex_state = 17},
  [1843] = {.lex_state = 54, .external_lex_state = 15},
  [1844] = {.lex_state = 54, .external_lex_state = 13},
  [1845] = {.lex_state = 54, .external_lex_state = 15},
  [1846] = {.lex_state = 54, .external_lex_state = 15},
  [1847] = {.lex_state = 54, .external_lex_state = 13},
  [1848] = {.lex_state = 54, .external_lex_state = 9},
  [1849] = {.lex_state = 54, .external_lex_state = 13},
  [1850] = {.lex_state = 54, .external_lex_state = 13},
  [1851] = {.lex_state = 54, .external_lex_state = 13},
  [1852] = {.lex_state = 54, .external_lex_state = 15},
  [1853] = {.lex_state = 54, .external_lex_state = 12},
  [1854] = {.lex_state = 54, .external_lex_state = 12},
  [1855] = {.lex_state = 54, .external_lex_state = 13},
  [1856] = {.lex_state = 54, .external_lex_state = 13},
  [1857] = {.lex_state = 54, .external_lex_state = 15},
  [1858] = {.lex_state = 54, .external_lex_state = 12},
  [1859] = {.lex_state = 32, .external_lex_state = 13},
  [1860] = {.lex_state = 54, .external_lex_state = 9},
  [1861] = {.lex_state = 32, .external_lex_state = 13},
  [1862] = {.lex_state = 54, .external_lex_state = 12},
  [1863] = {.lex_state = 0, .external_lex_state = 16},
  [1864] = {.lex_state = 32, .external_lex_state = 13},
  [1865] = {.lex_state = 54, .external_lex_state = 12},
  [1866] = {.lex_state = 54, .external_lex_state = 14},
  [1867] = {.lex_state = 54, .external_lex_state = 7},
  [1868] = {.lex_state = 54, .external_lex_state = 15},
  [1869] = {.lex_state = 32, .external_lex_state = 15},
  [1870] = {.lex_state = 32, .external_lex_state = 12},
  [1871] = {.lex_state = 54, .external_lex_state = 14},
  [1872] = {.lex_state = 54, .external_lex_state = 12},
  [1873] = {.lex_state = 54, .external_lex_state = 14},
  [1874] = {.lex_state = 54, .external_lex_state = 13},
  [1875] = {.lex_state = 32, .external_lex_state = 14},
  [1876] = {.lex_state = 54, .external_lex_state = 15},
  [1877] = {.lex_state = 54, .external_lex_state = 15},
  [1878] = {.lex_state = 32, .external_lex_state = 12},
  [1879] = {.lex_state = 54, .external_lex_state = 15},
  [1880] = {.lex_state = 54, .external_lex_state = 12},
  [1881] = {.lex_state = 54, .external_lex_state = 15},
  [1882] = {.lex_state = 54, .external_lex_state = 15},
  [1883] = {.lex_state = 32, .external_lex_state = 15},
  [1884] = {.lex_state = 54, .external_lex_state = 14},
  [1885] = {.lex_state = 54, .external_lex_state = 14},
  [1886] = {.lex_state = 54, .external_lex_state = 14},
  [1887] = {.lex_state = 54, .external_lex_state = 12},
  [1888] = {.lex_state = 54, .external_lex_state = 14},
  [1889] = {.lex_state = 54, .external_lex_state = 14},
  [1890] = {.lex_state = 54, .external_lex_state = 13},
  [1891] = {.lex_state = 54, .external_lex_state = 12},
  [1892] = {.lex_state = 54, .external_lex_state = 12},
  [1893] = {.lex_state = 54, .external_lex_state = 13},
  [1894] = {.lex_state = 54, .external_lex_state = 12},
  [1895] = {.lex_state = 54, .external_lex_state = 6},
  [1896] = {.lex_state = 0, .external_lex_state = 16},
  [1897] = {.lex_state = 54, .external_lex_state = 9},
  [1898] = {.lex_state = 54, .external_lex_state = 15},
  [1899] = {.lex_state = 54, .external_lex_state = 14},
  [1900] = {.lex_state = 54, .external_lex_state = 12},
  [1901] = {.lex_state = 54, .external_lex_state = 13},
  [1902] = {.lex_state = 32, .external_lex_state = 12},
  [1903] = {.lex_state = 54, .external_lex_state = 8},
  [1904] = {.lex_state = 32, .external_lex_state = 15},
  [1905] = {.lex_state = 54, .external_lex_state = 12},
  [1906] = {.lex_state = 54, .external_lex_state = 13},
  [1907] = {.lex_state = 33, .external_lex_state = 14},
  [1908] = {.lex_state = 54, .external_lex_state = 14},
  [1909] = {.lex_state = 54, .external_lex_state = 14},
  [1910] = {.lex_state = 54, .external_lex_state = 13},
  [1911] = {.lex_state = 54, .external_lex_state = 15},
  [1912] = {.lex_state = 54, .external_lex_state = 13},
  [1913] = {.lex_state = 54, .external_lex_state = 15},
  [1914] = {.lex_state = 54, .external_lex_state = 12},
  [1915] = {.lex_state = 33, .external_lex_state = 14},
  [1916] = {.lex_state = 32, .external_lex_state = 9},
  [1917] = {.lex_state = 33, .external_lex_state = 15},
  [1918] = {.lex_state = 54, .external_lex_state = 15},
  [1919] = {.lex_state = 54, .external_lex_state = 14},
  [1920] = {.lex_state = 33, .external_lex_state = 9},
  [1921] = {.lex_state = 33, .external_lex_state = 15},
  [1922] = {.lex_state = 54, .external_lex_state = 9},
  [1923] = {.lex_state = 33, .external_lex_state = 9},
  [1924] = {.lex_state = 33, .external_lex_state = 9},
  [1925] = {.lex_state = 54, .external_lex_state = 12},
  [1926] = {.lex_state = 54, .external_lex_state = 14},
  [1927] = {.lex_state = 33, .external_lex_state = 13},
  [1928] = {.lex_state = 54, .external_lex_state = 14},
  [1929] = {.lex_state = 54, .external_lex_state = 13},
  [1930] = {.lex_state = 54, .external_lex_state = 12},
  [1931] = {.lex_state = 54, .external_lex_state = 15},
  [1932] = {.lex_state = 54, .external_lex_state = 12},
  [1933] = {.lex_state = 54, .external_lex_state = 13},
  [1934] = {.lex_state = 54, .external_lex_state = 12},
  [1935] = {.lex_state = 54, .external_lex_state = 13},
  [1936] = {.lex_state = 32, .external_lex_state = 9},
  [1937] = {.lex_state = 54, .external_lex_state = 14},
  [1938] = {.lex_state = 54, .external_lex_state = 13},
  [1939] = {.lex_state = 54, .external_lex_state = 15},
  [1940] = {.lex_state = 33, .external_lex_state = 15},
  [1941] = {.lex_state = 54, .external_lex_state = 13},
  [1942] = {.lex_state = 54, .external_lex_state = 12},
  [1943] = {.lex_state = 54, .external_lex_state = 13},
  [1944] = {.lex_state = 0, .external_lex_state = 16},
  [1945] = {.lex_state = 54, .external_lex_state = 13},
  [1946] = {.lex_state = 54, .external_lex_state = 12},
  [1947] = {.lex_state = 54, .external_lex_state = 13},
  [1948] = {.lex_state = 0, .external_lex_state = 16},
  [1949] = {.lex_state = 54, .external_lex_state = 15},
  [1950] = {.lex_state = 0, .external_lex_state = 16},
  [1951] = {.lex_state = 54, .external_lex_state = 15},
  [1952] = {.lex_state = 54, .external_lex_state = 15},
  [1953] = {.lex_state = 54, .external_lex_state = 14},
  [1954] = {.lex_state = 54, .external_lex_state = 15},
  [1955] = {.lex_state = 54, .external_lex_state = 12},
  [1956] = {.lex_state = 33, .external_lex_state = 15},
  [1957] = {.lex_state = 54, .external_lex_state = 15},
  [1958] = {.lex_state = 54, .external_lex_state = 15},
  [1959] = {.lex_state = 32, .external_lex_state = 12},
  [1960] = {.lex_state = 54, .external_lex_state = 12},
  [1961] = {.lex_state = 54, .external_lex_state = 14},
  [1962] = {.lex_state = 32, .external_lex_state = 9},
  [1963] = {.lex_state = 54, .external_lex_state = 13},
  [1964] = {.lex_state = 54, .external_lex_state = 12},
  [1965] = {.lex_state = 54, .external_lex_state = 15},
  [1966] = {.lex_state = 54, .external_lex_state = 13},
  [1967] = {.lex_state = 54, .external_lex_state = 9},
  [1968] = {.lex_state = 0, .external_lex_state = 16},
  [1969] = {.lex_state = 33, .external_lex_state = 9},
  [1970] = {.lex_state = 54, .external_lex_state = 12},
  [1971] = {.lex_state = 33, .external_lex_state = 9},
  [1972] = {.lex_state = 33, .external_lex_state = 13},
  [1973] = {.lex_state = 32, .external_lex_state = 15},
  [1974] = {.lex_state = 54, .external_lex_state = 14},
  [1975] = {.lex_state = 54, .external_lex_state = 14},
  [1976] = {.lex_state = 54, .external_lex_state = 14},
  [1977] = {.lex_state = 54, .external_lex_state = 13},
  [1978] = {.lex_state = 54, .external_lex_state = 13},
  [1979] = {.lex_state = 33, .external_lex_state = 9},
  [1980] = {.lex_state = 33, .external_lex_state = 13},
  [1981] = {.lex_state = 54, .external_lex_state = 14},
  [1982] = {.lex_state = 54, .external_lex_state = 14},
  [1983] = {.lex_state = 54, .external_lex_state = 14},
  [1984] = {.lex_state = 33, .external_lex_state = 9},
  [1985] = {.lex_state = 54, .external_lex_state = 15},
  [1986] = {.lex_state = 33, .external_lex_state = 13},
  [1987] = {.lex_state = 0, .external_lex_state = 16},
  [1988] = {.lex_state = 54, .external_lex_state = 15},
  [1989] = {.lex_state = 33, .external_lex_state = 13},
  [1990] = {.lex_state = 33, .external_lex_state = 13},
  [1991] = {.lex_state = 0, .external_lex_state = 16},
  [1992] = {.lex_state = 54, .external_lex_state = 14},
  [1993] = {.lex_state = 0, .external_lex_state = 16},
  [1994] = {.lex_state = 0, .external_lex_state = 16},
  [1995] = {.lex_state = 54, .external_lex_state = 9},
  [1996] = {.lex_state = 54, .external_lex_state = 13},
  [1997] = {.lex_state = 32, .external_lex_state = 13},
  [1998] = {.lex_state = 54, .external_lex_state = 14},
  [1999] = {.lex_state = 54, .external_lex_state = 13},
  [2000] = {.lex_state = 54, .external_lex_state = 13},
  [2001] = {.lex_state = 54, .external_lex_state = 12},
  [2002] = {.lex_state = 33, .external_lex_state = 9},
  [2003] = {.lex_state = 33, .external_lex_state = 13},
  [2004] = {.lex_state = 54, .external_lex_state = 12},
  [2005] = {.lex_state = 33, .external_lex_state = 9},
  [2006] = {.lex_state = 33, .external_lex_state = 13},
  [2007] = {.lex_state = 54, .external_lex_state = 12},
  [2008] = {.lex_state = 54, .external_lex_state = 12},
  [2009] = {.lex_state = 33, .external_lex_state = 13},
  [2010] = {.lex_state = 54, .external_lex_state = 12},
  [2011] = {.lex_state = 33, .external_lex_state = 15},
  [2012] = {.lex_state = 54, .external_lex_state = 15},
  [2013] = {.lex_state = 54, .external_lex_state = 9},
  [2014] = {.lex_state = 54, .external_lex_state = 14},
  [2015] = {.lex_state = 54, .external_lex_state = 9},
  [2016] = {.lex_state = 54, .external_lex_state = 12},
  [2017] = {.lex_state = 33, .external_lex_state = 15},
  [2018] = {.lex_state = 54, .external_lex_state = 12},
  [2019] = {.lex_state = 33, .external_lex_state = 15},
  [2020] = {.lex_state = 54, .external_lex_state = 12},
  [2021] = {.lex_state = 54, .external_lex_state = 9},
  [2022] = {.lex_state = 54, .external_lex_state = 14},
  [2023] = {.lex_state = 54, .external_lex_state = 12},
  [2024] = {.lex_state = 54, .external_lex_state = 12},
  [2025] = {.lex_state = 54, .external_lex_state = 12},
  [2026] = {.lex_state = 54, .external_lex_state = 12},
  [2027] = {.lex_state = 54, .external_lex_state = 14},
  [2028] = {.lex_state = 54, .external_lex_state = 12},
  [2029] = {.lex_state = 54, .external_lex_state = 14},
  [2030] = {.lex_state = 3, .external_lex_state = 12},
  [2031] = {.lex_state = 32, .external_lex_state = 9},
  [2032] = {.lex_state = 54, .external_lex_state = 15},
  [2033] = {.lex_state = 54, .external_lex_state = 14},
  [2034] = {.lex_state = 54, .external_lex_state = 14},
  [2035] = {.lex_state = 54, .external_lex_state = 14},
  [2036] = {.lex_state = 54, .external_lex_state = 14},
  [2037] = {.lex_state = 54, .external_lex_state = 13},
  [2038] = {.lex_state = 54, .external_lex_state = 13},
  [2039] = {.lex_state = 54, .external_lex_state = 14},
  [2040] = {.lex_state = 54, .external_lex_state = 14},
  [2041] = {.lex_state = 54, .external_lex_state = 14},
  [2042] = {.lex_state = 33, .external_lex_state = 15},
  [2043] = {.lex_state = 54, .external_lex_state = 13},
  [2044] = {.lex_state = 54, .external_lex_state = 12},
  [2045] = {.lex_state = 54, .external_lex_state = 12},
  [2046] = {.lex_state = 33, .external_lex_state = 15},
  [2047] = {.lex_state = 54, .external_lex_state = 9},
  [2048] = {.lex_state = 33, .external_lex_state = 15},
  [2049] = {.lex_state = 3, .external_lex_state = 12},
  [2050] = {.lex_state = 54, .external_lex_state = 12},
  [2051] = {.lex_state = 54, .external_lex_state = 14},
  [2052] = {.lex_state = 54, .external_lex_state = 12},
  [2053] = {.lex_state = 54, .external_lex_state = 13},
  [2054] = {.lex_state = 54, .external_lex_state = 15},
  [2055] = {.lex_state = 33, .external_lex_state = 15},
  [2056] = {.lex_state = 54, .external_lex_state = 9},
  [2057] = {.lex_state = 54, .external_lex_state = 14},
  [2058] = {.lex_state = 54, .external_lex_state = 14},
  [2059] = {.lex_state = 54, .external_lex_state = 13},
  [2060] = {.lex_state = 54, .external_lex_state = 13},
  [2061] = {.lex_state = 54, .external_lex_state = 15},
  [2062] = {.lex_state = 54, .external_lex_state = 12},
  [2063] = {.lex_state = 54, .external_lex_state = 15},
  [2064] = {.lex_state = 54, .external_lex_state = 14},
  [2065] = {.lex_state = 54, .external_lex_state = 14},
  [2066] = {.lex_state = 54, .external_lex_state = 12},
  [2067] = {.lex_state = 54, .external_lex_state = 9},
  [2068] = {.lex_state = 54, .external_lex_state = 14},
  [2069] = {.lex_state = 33, .external_lex_state = 15},
  [2070] = {.lex_state = 54, .external_lex_state = 14},
  [2071] = {.lex_state = 33, .external_lex_state = 14},
  [2072] = {.lex_state = 54, .external_lex_state = 14},
  [2073] = {.lex_state = 54, .external_lex_state = 14},
  [2074] = {.lex_state = 33, .external_lex_state = 14},
  [2075] = {.lex_state = 33, .external_lex_state = 9},
  [2076] = {.lex_state = 54, .external_lex_state = 14},
  [2077] = {.lex_state = 54, .external_lex_state = 14},
  [2078] = {.lex_state = 33, .external_lex_state = 14},
  [2079] = {.lex_state = 54, .external_lex_state = 12},
  [2080] = {.lex_state = 54, .external_lex_state = 14},
  [2081] = {.lex_state = 33, .external_lex_state = 13},
  [2082] = {.lex_state = 54, .external_lex_state = 14},
  [2083] = {.lex_state = 54, .external_lex_state = 12},
  [2084] = {.lex_state = 33, .external_lex_state = 15},
  [2085] = {.lex_state = 54, .external_lex_state = 15},
  [2086] = {.lex_state = 54, .external_lex_state = 14},
  [2087] = {.lex_state = 54, .external_lex_state = 14},
  [2088] = {.lex_state = 54, .external_lex_state = 14},
  [2089] = {.lex_state = 54, .external_lex_state = 14},
  [2090] = {.lex_state = 54, .external_lex_state = 14},
  [2091] = {.lex_state = 54, .external_lex_state = 14},
  [2092] = {.lex_state = 54, .external_lex_state = 9},
  [2093] = {.lex_state = 33, .external_lex_state = 14},
  [2094] = {.lex_state = 33, .external_lex_state = 14},
  [2095] = {.lex_state = 54, .external_lex_state = 12},
  [2096] = {.lex_state = 54, .external_lex_state = 14},
  [2097] = {.lex_state = 54, .external_lex_state = 15},
  [2098] = {.lex_state = 54, .external_lex_state = 14},
  [2099] = {.lex_state = 54, .external_lex_state = 15},
  [2100] = {.lex_state = 54, .external_lex_state = 14},
  [2101] = {.lex_state = 54, .external_lex_state = 14},
  [2102] = {.lex_state = 54, .external_lex_state = 14},
  [2103] = {.lex_state = 54, .external_lex_state = 14},
  [2104] = {.lex_state = 54, .external_lex_state = 13},
  [2105] = {.lex_state = 54, .external_lex_state = 13},
  [2106] = {.lex_state = 54, .external_lex_state = 12},
  [2107] = {.lex_state = 33, .external_lex_state = 14},
  [2108] = {.lex_state = 3, .external_lex_state = 12},
  [2109] = {.lex_state = 33, .external_lex_state = 14},
  [2110] = {.lex_state = 54, .external_lex_state = 14},
  [2111] = {.lex_state = 54, .external_lex_state = 14},
  [2112] = {.lex_state = 54, .external_lex_state = 13},
  [2113] = {.lex_state = 54, .external_lex_state = 14},
  [2114] = {.lex_state = 54, .external_lex_state = 14},
  [2115] = {.lex_state = 54, .external_lex_state = 14},
  [2116] = {.lex_state = 54, .external_lex_state = 14},
  [2117] = {.lex_state = 54, .external_lex_state = 14},
  [2118] = {.lex_state = 54, .external_lex_state = 14},
  [2119] = {.lex_state = 54, .external_lex_state = 14},
  [2120] = {.lex_state = 54, .external_lex_state = 14},
  [2121] = {.lex_state = 54, .external_lex_state = 14},
  [2122] = {.lex_state = 54, .external_lex_state = 12},
  [2123] = {.lex_state = 54, .external_lex_state = 14},
  [2124] = {.lex_state = 54, .external_lex_state = 14},
  [2125] = {.lex_state = 54, .external_lex_state = 15},
  [2126] = {.lex_state = 54, .external_lex_state = 12},
  [2127] = {.lex_state = 54, .external_lex_state = 13},
  [2128] = {.lex_state = 54, .external_lex_state = 15},
  [2129] = {.lex_state = 54, .external_lex_state = 15},
  [2130] = {.lex_state = 54, .external_lex_state = 18},
  [2131] = {.lex_state = 54, .external_lex_state = 15},
  [2132] = {.lex_state = 54, .external_lex_state = 18},
  [2133] = {.lex_state = 54, .external_lex_state = 15},
  [2134] = {.lex_state = 54, .external_lex_state = 13},
  [2135] = {.lex_state = 54, .external_lex_state = 12},
  [2136] = {.lex_state = 54, .external_lex_state = 13},
  [2137] = {.lex_state = 54, .external_lex_state = 15},
  [2138] = {.lex_state = 54, .external_lex_state = 13},
  [2139] = {.lex_state = 54, .external_lex_state = 14},
  [2140] = {.lex_state = 54, .external_lex_state = 15},
  [2141] = {.lex_state = 54, .external_lex_state = 13},
  [2142] = {.lex_state = 54, .external_lex_state = 15},
  [2143] = {.lex_state = 54, .external_lex_state = 15},
  [2144] = {.lex_state = 54, .external_lex_state = 15},
  [2145] = {.lex_state = 54, .external_lex_state = 15},
  [2146] = {.lex_state = 54, .external_lex_state = 13},
  [2147] = {.lex_state = 54, .external_lex_state = 13},
  [2148] = {.lex_state = 54, .external_lex_state = 15},
  [2149] = {.lex_state = 54, .external_lex_state = 15},
  [2150] = {.lex_state = 54, .external_lex_state = 15},
  [2151] = {.lex_state = 54, .external_lex_state = 13},
  [2152] = {.lex_state = 54, .external_lex_state = 15},
  [2153] = {.lex_state = 54, .external_lex_state = 13},
  [2154] = {.lex_state = 54, .external_lex_state = 15},
  [2155] = {.lex_state = 54, .external_lex_state = 13},
  [2156] = {.lex_state = 54, .external_lex_state = 13},
  [2157] = {.lex_state = 54, .external_lex_state = 15},
  [2158] = {.lex_state = 54, .external_lex_state = 18},
  [2159] = {.lex_state = 54, .external_lex_state = 9},
  [2160] = {.lex_state = 54, .external_lex_state = 14},
  [2161] = {.lex_state = 54, .external_lex_state = 13},
  [2162] = {.lex_state = 54, .external_lex_state = 14},
  [2163] = {.lex_state = 54, .external_lex_state = 14},
  [2164] = {.lex_state = 54, .external_lex_state = 9},
  [2165] = {.lex_state = 54, .external_lex_state = 13},
  [2166] = {.lex_state = 54, .external_lex_state = 13},
  [2167] = {.lex_state = 33, .external_lex_state = 14},
  [2168] = {.lex_state = 54, .external_lex_state = 13},
  [2169] = {.lex_state = 54, .external_lex_state = 9},
  [2170] = {.lex_state = 54, .external_lex_state = 13},
  [2171] = {.lex_state = 54, .external_lex_state = 9},
  [2172] = {.lex_state = 33, .external_lex_state = 14},
  [2173] = {.lex_state = 54, .external_lex_state = 14},
  [2174] = {.lex_state = 54, .external_lex_state = 9},
  [2175] = {.lex_state = 54, .external_lex_state = 13},
  [2176] = {.lex_state = 54, .external_lex_state = 9},
  [2177] = {.lex_state = 54, .external_lex_state = 9},
  [2178] = {.lex_state = 54, .external_lex_state = 12},
  [2179] = {.lex_state = 54, .external_lex_state = 15},
  [2180] = {.lex_state = 54, .external_lex_state = 9},
  [2181] = {.lex_state = 54, .external_lex_state = 13},
  [2182] = {.lex_state = 54, .external_lex_state = 13},
  [2183] = {.lex_state = 54, .external_lex_state = 15},
  [2184] = {.lex_state = 54, .external_lex_state = 13},
  [2185] = {.lex_state = 54, .external_lex_state = 15},
  [2186] = {.lex_state = 54, .external_lex_state = 15},
  [2187] = {.lex_state = 54, .external_lex_state = 15},
  [2188] = {.lex_state = 54, .external_lex_state = 15},
  [2189] = {.lex_state = 54, .external_lex_state = 13},
  [2190] = {.lex_state = 32, .external_lex_state = 14},
  [2191] = {.lex_state = 54, .external_lex_state = 9},
  [2192] = {.lex_state = 54, .external_lex_state = 13},
  [2193] = {.lex_state = 54, .external_lex_state = 13},
  [2194] = {.lex_state = 54, .external_lex_state = 12},
  [2195] = {.lex_state = 54, .external_lex_state = 13},
  [2196] = {.lex_state = 54, .external_lex_state = 15},
  [2197] = {.lex_state = 54, .external_lex_state = 13},
  [2198] = {.lex_state = 54, .external_lex_state = 13},
  [2199] = {.lex_state = 54, .external_lex_state = 15},
  [2200] = {.lex_state = 54, .external_lex_state = 9},
  [2201] = {.lex_state = 54, .external_lex_state = 15},
  [2202] = {.lex_state = 54, .external_lex_state = 15},
  [2203] = {.lex_state = 54, .external_lex_state = 13},
  [2204] = {.lex_state = 54, .external_lex_state = 15},
  [2205] = {.lex_state = 54, .external_lex_state = 13},
  [2206] = {.lex_state = 54, .external_lex_state = 9},
  [2207] = {.lex_state = 54, .external_lex_state = 13},
  [2208] = {.lex_state = 54, .external_lex_state = 9},
  [2209] = {.lex_state = 54, .external_lex_state = 18},
  [2210] = {.lex_state = 54, .external_lex_state = 14},
  [2211] = {.lex_state = 54, .external_lex_state = 9},
  [2212] = {.lex_state = 54, .external_lex_state = 15},
  [2213] = {.lex_state = 54, .external_lex_state = 13},
  [2214] = {.lex_state = 54, .external_lex_state = 12},
  [2215] = {.lex_state = 54, .external_lex_state = 13},
  [2216] = {.lex_state = 54, .external_lex_state = 12},
  [2217] = {.lex_state = 54, .external_lex_state = 13},
  [2218] = {.lex_state = 54, .external_lex_state = 13},
  [2219] = {.lex_state = 54, .external_lex_state = 12},
  [2220] = {.lex_state = 54, .external_lex_state = 13},
  [2221] = {.lex_state = 54, .external_lex_state = 12},
  [2222] = {.lex_state = 54, .external_lex_state = 12},
  [2223] = {.lex_state = 54, .external_lex_state = 13},
  [2224] = {.lex_state = 54, .external_lex_state = 13},
  [2225] = {.lex_state = 54, .external_lex_state = 14},
  [2226] = {.lex_state = 54, .external_lex_state = 12},
  [2227] = {.lex_state = 54, .external_lex_state = 18},
  [2228] = {.lex_state = 54, .external_lex_state = 12},
  [2229] = {.lex_state = 54, .external_lex_state = 12},
  [2230] = {.lex_state = 54, .external_lex_state = 12},
  [2231] = {.lex_state = 54, .external_lex_state = 12},
  [2232] = {.lex_state = 54, .external_lex_state = 12},
  [2233] = {.lex_state = 54, .external_lex_state = 12},
  [2234] = {.lex_state = 54, .external_lex_state = 12},
  [2235] = {.lex_state = 54, .external_lex_state = 12},
  [2236] = {.lex_state = 54, .external_lex_state = 12},
  [2237] = {.lex_state = 54, .external_lex_state = 9},
  [2238] = {.lex_state = 54, .external_lex_state = 14},
  [2239] = {.lex_state = 32, .external_lex_state = 14},
  [2240] = {.lex_state = 54, .external_lex_state = 12},
  [2241] = {.lex_state = 54, .external_lex_state = 12},
  [2242] = {.lex_state = 54, .external_lex_state = 9},
  [2243] = {.lex_state = 54, .external_lex_state = 12},
  [2244] = {.lex_state = 54, .external_lex_state = 9},
  [2245] = {.lex_state = 54, .external_lex_state = 12},
  [2246] = {.lex_state = 54, .external_lex_state = 12},
  [2247] = {.lex_state = 54, .external_lex_state = 14},
  [2248] = {.lex_state = 54, .external_lex_state = 14},
  [2249] = {.lex_state = 54, .external_lex_state = 12},
  [2250] = {.lex_state = 54, .external_lex_state = 9},
  [2251] = {.lex_state = 54, .external_lex_state = 13},
  [2252] = {.lex_state = 54, .external_lex_state = 14},
  [2253] = {.lex_state = 54, .external_lex_state = 14},
  [2254] = {.lex_state = 54, .external_lex_state = 12},
  [2255] = {.lex_state = 54, .external_lex_state = 12},
  [2256] = {.lex_state = 54, .external_lex_state = 13},
  [2257] = {.lex_state = 54, .external_lex_state = 12},
  [2258] = {.lex_state = 54, .external_lex_state = 15},
  [2259] = {.lex_state = 54, .external_lex_state = 14},
  [2260] = {.lex_state = 54, .external_lex_state = 13},
  [2261] = {.lex_state = 54, .external_lex_state = 14},
  [2262] = {.lex_state = 54, .external_lex_state = 9},
  [2263] = {.lex_state = 54, .external_lex_state = 15},
  [2264] = {.lex_state = 54, .external_lex_state = 15},
  [2265] = {.lex_state = 54, .external_lex_state = 13},
  [2266] = {.lex_state = 54, .external_lex_state = 13},
  [2267] = {.lex_state = 54, .external_lex_state = 13},
  [2268] = {.lex_state = 54, .external_lex_state = 13},
  [2269] = {.lex_state = 54, .external_lex_state = 12},
  [2270] = {.lex_state = 54, .external_lex_state = 13},
  [2271] = {.lex_state = 54, .external_lex_state = 12},
  [2272] = {.lex_state = 54, .external_lex_state = 9},
  [2273] = {.lex_state = 54, .external_lex_state = 14},
  [2274] = {.lex_state = 54, .external_lex_state = 13},
  [2275] = {.lex_state = 54, .external_lex_state = 13},
  [2276] = {.lex_state = 54, .external_lex_state = 13},
  [2277] = {.lex_state = 54, .external_lex_state = 13},
  [2278] = {.lex_state = 54, .external_lex_state = 12},
  [2279] = {.lex_state = 54, .external_lex_state = 13},
  [2280] = {.lex_state = 54, .external_lex_state = 13},
  [2281] = {.lex_state = 54, .external_lex_state = 9},
  [2282] = {.lex_state = 54, .external_lex_state = 12},
  [2283] = {.lex_state = 54, .external_lex_state = 14},
  [2284] = {.lex_state = 54, .external_lex_state = 14},
  [2285] = {.lex_state = 54, .external_lex_state = 19},
  [2286] = {.lex_state = 54, .external_lex_state = 9},
  [2287] = {.lex_state = 34, .external_lex_state = 17},
  [2288] = {.lex_state = 54, .external_lex_state = 13},
  [2289] = {.lex_state = 54, .external_lex_state = 13},
  [2290] = {.lex_state = 54, .external_lex_state = 9},
  [2291] = {.lex_state = 54, .external_lex_state = 13},
  [2292] = {.lex_state = 54, .external_lex_state = 15},
  [2293] = {.lex_state = 54, .external_lex_state = 13},
  [2294] = {.lex_state = 54, .external_lex_state = 15},
  [2295] = {.lex_state = 54, .external_lex_state = 13},
  [2296] = {.lex_state = 54, .external_lex_state = 9},
  [2297] = {.lex_state = 54, .external_lex_state = 14},
  [2298] = {.lex_state = 54, .external_lex_state = 12},
  [2299] = {.lex_state = 54, .external_lex_state = 13},
  [2300] = {.lex_state = 54, .external_lex_state = 13},
  [2301] = {.lex_state = 54, .external_lex_state = 13},
  [2302] = {.lex_state = 54, .external_lex_state = 12},
  [2303] = {.lex_state = 54, .external_lex_state = 15},
  [2304] = {.lex_state = 54, .external_lex_state = 15},
  [2305] = {.lex_state = 54, .external_lex_state = 13},
  [2306] = {.lex_state = 54, .external_lex_state = 15},
  [2307] = {.lex_state = 54, .external_lex_state = 15},
  [2308] = {.lex_state = 54, .external_lex_state = 13},
  [2309] = {.lex_state = 54, .external_lex_state = 14},
  [2310] = {.lex_state = 54, .external_lex_state = 15},
  [2311] = {.lex_state = 54, .external_lex_state = 15},
  [2312] = {.lex_state = 54, .external_lex_state = 12},
  [2313] = {.lex_state = 54, .external_lex_state = 12},
  [2314] = {.lex_state = 33, .external_lex_state = 14},
  [2315] = {.lex_state = 33, .external_lex_state = 14},
  [2316] = {.lex_state = 33, .external_lex_state = 14},
  [2317] = {.lex_state = 54, .external_lex_state = 15},
  [2318] = {.lex_state = 54, .external_lex_state = 13},
  [2319] = {.lex_state = 54, .external_lex_state = 13},
  [2320] = {.lex_state = 33, .external_lex_state = 14},
  [2321] = {.lex_state = 54, .external_lex_state = 12},
  [2322] = {.lex_state = 54, .external_lex_state = 12},
  [2323] = {.lex_state = 54, .external_lex_state = 13},
  [2324] = {.lex_state = 54, .external_lex_state = 14},
  [2325] = {.lex_state = 54, .external_lex_state = 13},
  [2326] = {.lex_state = 54, .external_lex_state = 13},
  [2327] = {.lex_state = 34, .external_lex_state = 17},
  [2328] = {.lex_state = 54, .external_lex_state = 13},
  [2329] = {.lex_state = 54, .external_lex_state = 13},
  [2330] = {.lex_state = 54, .external_lex_state = 15},
  [2331] = {.lex_state = 54, .external_lex_state = 14},
  [2332] = {.lex_state = 54, .external_lex_state = 13},
  [2333] = {.lex_state = 54, .external_lex_state = 12},
  [2334] = {.lex_state = 54, .external_lex_state = 14},
  [2335] = {.lex_state = 54, .external_lex_state = 12},
  [2336] = {.lex_state = 54, .external_lex_state = 13},
  [2337] = {.lex_state = 34, .external_lex_state = 17},
  [2338] = {.lex_state = 54, .external_lex_state = 9},
  [2339] = {.lex_state = 54, .external_lex_state = 13},
  [2340] = {.lex_state = 3, .external_lex_state = 12},
  [2341] = {.lex_state = 54, .external_lex_state = 12},
  [2342] = {.lex_state = 54, .external_lex_state = 14},
  [2343] = {.lex_state = 54, .external_lex_state = 13},
  [2344] = {.lex_state = 54, .external_lex_state = 15},
  [2345] = {.lex_state = 54, .external_lex_state = 12},
  [2346] = {.lex_state = 54, .external_lex_state = 14},
  [2347] = {.lex_state = 54, .external_lex_state = 9},
  [2348] = {.lex_state = 54, .external_lex_state = 19},
  [2349] = {.lex_state = 54, .external_lex_state = 12},
  [2350] = {.lex_state = 54, .external_lex_state = 15},
  [2351] = {.lex_state = 54, .external_lex_state = 13},
  [2352] = {.lex_state = 54, .external_lex_state = 13},
  [2353] = {.lex_state = 54, .external_lex_state = 14},
  [2354] = {.lex_state = 54, .external_lex_state = 12},
  [2355] = {.lex_state = 54, .external_lex_state = 9},
  [2356] = {.lex_state = 54, .external_lex_state = 15},
  [2357] = {.lex_state = 54, .external_lex_state = 15},
  [2358] = {.lex_state = 54, .external_lex_state = 13},
  [2359] = {.lex_state = 54, .external_lex_state = 15},
  [2360] = {.lex_state = 54, .external_lex_state = 14},
  [2361] = {.lex_state = 54, .external_lex_state = 13},
  [2362] = {.lex_state = 54, .external_lex_state = 14},
  [2363] = {.lex_state = 54, .external_lex_state = 13},
  [2364] = {.lex_state = 54, .external_lex_state = 15},
  [2365] = {.lex_state = 54, .external_lex_state = 13},
  [2366] = {.lex_state = 54, .external_lex_state = 14},
  [2367] = {.lex_state = 54, .external_lex_state = 15},
  [2368] = {.lex_state = 54, .external_lex_state = 15},
  [2369] = {.lex_state = 54, .external_lex_state = 15},
  [2370] = {.lex_state = 54, .external_lex_state = 15},
  [2371] = {.lex_state = 54, .external_lex_state = 12},
  [2372] = {.lex_state = 54, .external_lex_state = 15},
  [2373] = {.lex_state = 54, .external_lex_state = 19},
  [2374] = {.lex_state = 54, .external_lex_state = 15},
  [2375] = {.lex_state = 3, .external_lex_state = 12},
  [2376] = {.lex_state = 54, .external_lex_state = 9},
  [2377] = {.lex_state = 54, .external_lex_state = 9},
  [2378] = {.lex_state = 54, .external_lex_state = 9},
  [2379] = {.lex_state = 54, .external_lex_state = 13},
  [2380] = {.lex_state = 33, .external_lex_state = 14},
  [2381] = {.lex_state = 54, .external_lex_state = 15},
  [2382] = {.lex_state = 54, .external_lex_state = 15},
  [2383] = {.lex_state = 54, .external_lex_state = 13},
  [2384] = {.lex_state = 54, .external_lex_state = 13},
  [2385] = {.lex_state = 54, .external_lex_state = 12},
  [2386] = {.lex_state = 54, .external_lex_state = 13},
  [2387] = {.lex_state = 54, .external_lex_state = 15},
  [2388] = {.lex_state = 54, .external_lex_state = 12},
  [2389] = {.lex_state = 34, .external_lex_state = 17},
  [2390] = {.lex_state = 54, .external_lex_state = 13},
  [2391] = {.lex_state = 54, .external_lex_state = 13},
  [2392] = {.lex_state = 54, .external_lex_state = 13},
  [2393] = {.lex_state = 54, .external_lex_state = 13},
  [2394] = {.lex_state = 54, .external_lex_state = 12},
  [2395] = {.lex_state = 54, .external_lex_state = 15},
  [2396] = {.lex_state = 54, .external_lex_state = 14},
  [2397] = {.lex_state = 54, .external_lex_state = 15},
  [2398] = {.lex_state = 54, .external_lex_state = 15},
  [2399] = {.lex_state = 54, .external_lex_state = 12},
  [2400] = {.lex_state = 54, .external_lex_state = 9},
  [2401] = {.lex_state = 54, .external_lex_state = 13},
  [2402] = {.lex_state = 54, .external_lex_state = 13},
  [2403] = {.lex_state = 54, .external_lex_state = 12},
  [2404] = {.lex_state = 54, .external_lex_state = 13},
  [2405] = {.lex_state = 54, .external_lex_state = 14},
  [2406] = {.lex_state = 54, .external_lex_state = 15},
  [2407] = {.lex_state = 54, .external_lex_state = 15},
  [2408] = {.lex_state = 54, .external_lex_state = 15},
  [2409] = {.lex_state = 54, .external_lex_state = 12},
  [2410] = {.lex_state = 54, .external_lex_state = 12},
  [2411] = {.lex_state = 54, .external_lex_state = 12},
  [2412] = {.lex_state = 54, .external_lex_state = 12},
  [2413] = {.lex_state = 54, .external_lex_state = 14},
  [2414] = {.lex_state = 54, .external_lex_state = 14},
  [2415] = {.lex_state = 54, .external_lex_state = 13},
  [2416] = {.lex_state = 54, .external_lex_state = 9},
  [2417] = {.lex_state = 54, .external_lex_state = 12},
  [2418] = {.lex_state = 3, .external_lex_state = 12},
  [2419] = {.lex_state = 54, .external_lex_state = 14},
  [2420] = {.lex_state = 54, .external_lex_state = 12},
  [2421] = {.lex_state = 54, .external_lex_state = 13},
  [2422] = {.lex_state = 54, .external_lex_state = 15},
  [2423] = {.lex_state = 33, .external_lex_state = 14},
  [2424] = {.lex_state = 54, .external_lex_state = 9},
  [2425] = {.lex_state = 3, .external_lex_state = 12},
  [2426] = {.lex_state = 54, .external_lex_state = 13},
  [2427] = {.lex_state = 54, .external_lex_state = 14},
  [2428] = {.lex_state = 54, .external_lex_state = 15},
  [2429] = {.lex_state = 54, .external_lex_state = 14},
  [2430] = {.lex_state = 54, .external_lex_state = 19},
  [2431] = {.lex_state = 54, .external_lex_state = 12},
  [2432] = {.lex_state = 54, .external_lex_state = 19},
  [2433] = {.lex_state = 54, .external_lex_state = 12},
  [2434] = {.lex_state = 54, .external_lex_state = 14},
  [2435] = {.lex_state = 3, .external_lex_state = 12},
  [2436] = {.lex_state = 54, .external_lex_state = 15},
  [2437] = {.lex_state = 54, .external_lex_state = 13},
  [2438] = {.lex_state = 54, .external_lex_state = 13},
  [2439] = {.lex_state = 3, .external_lex_state = 12},
  [2440] = {.lex_state = 54, .external_lex_state = 13},
  [2441] = {.lex_state = 54, .external_lex_state = 15},
  [2442] = {.lex_state = 54, .external_lex_state = 14},
  [2443] = {.lex_state = 54, .external_lex_state = 14},
  [2444] = {.lex_state = 54, .external_lex_state = 9},
  [2445] = {.lex_state = 54, .external_lex_state = 15},
  [2446] = {.lex_state = 54, .external_lex_state = 15},
  [2447] = {.lex_state = 54, .external_lex_state = 14},
  [2448] = {.lex_state = 54, .external_lex_state = 14},
  [2449] = {.lex_state = 54, .external_lex_state = 13},
  [2450] = {.lex_state = 54, .external_lex_state = 9},
  [2451] = {.lex_state = 54, .external_lex_state = 13},
  [2452] = {.lex_state = 54, .external_lex_state = 19},
  [2453] = {.lex_state = 54, .external_lex_state = 12},
  [2454] = {.lex_state = 54, .external_lex_state = 15},
  [2455] = {.lex_state = 33, .external_lex_state = 14},
  [2456] = {.lex_state = 54, .external_lex_state = 13},
  [2457] = {.lex_state = 54, .external_lex_state = 13},
  [2458] = {.lex_state = 34, .external_lex_state = 17},
  [2459] = {.lex_state = 54, .external_lex_state = 13},
  [2460] = {.lex_state = 3, .external_lex_state = 12},
  [2461] = {.lex_state = 54, .external_lex_state = 12},
  [2462] = {.lex_state = 3, .external_lex_state = 12},
  [2463] = {.lex_state = 54, .external_lex_state = 9},
  [2464] = {.lex_state = 54, .external_lex_state = 12},
  [2465] = {.lex_state = 3, .external_lex_state = 12},
  [2466] = {.lex_state = 54, .external_lex_state = 12},
  [2467] = {.lex_state = 54, .external_lex_state = 12},
  [2468] = {.lex_state = 54, .external_lex_state = 14},
  [2469] = {.lex_state = 54, .external_lex_state = 9},
  [2470] = {.lex_state = 54, .external_lex_state = 13},
  [2471] = {.lex_state = 54, .external_lex_state = 9},
  [2472] = {.lex_state = 54, .external_lex_state = 13},
  [2473] = {.lex_state = 54, .external_lex_state = 12},
  [2474] = {.lex_state = 54, .external_lex_state = 13},
  [2475] = {.lex_state = 54, .external_lex_state = 9},
  [2476] = {.lex_state = 54, .external_lex_state = 15},
  [2477] = {.lex_state = 54, .external_lex_state = 12},
  [2478] = {.lex_state = 54, .external_lex_state = 15},
  [2479] = {.lex_state = 54, .external_lex_state = 13},
  [2480] = {.lex_state = 54, .external_lex_state = 13},
  [2481] = {.lex_state = 54, .external_lex_state = 19},
  [2482] = {.lex_state = 54, .external_lex_state = 13},
  [2483] = {.lex_state = 54, .external_lex_state = 13},
  [2484] = {.lex_state = 54, .external_lex_state = 13},
  [2485] = {.lex_state = 54, .external_lex_state = 13},
  [2486] = {.lex_state = 54, .external_lex_state = 13},
  [2487] = {.lex_state = 54, .external_lex_state = 15},
  [2488] = {.lex_state = 54, .external_lex_state = 13},
  [2489] = {.lex_state = 54, .external_lex_state = 13},
  [2490] = {.lex_state = 54, .external_lex_state = 15},
  [2491] = {.lex_state = 54, .external_lex_state = 13},
  [2492] = {.lex_state = 54, .external_lex_state = 13},
  [2493] = {.lex_state = 54, .external_lex_state = 13},
  [2494] = {.lex_state = 54, .external_lex_state = 13},
  [2495] = {.lex_state = 54, .external_lex_state = 15},
  [2496] = {.lex_state = 54, .external_lex_state = 15},
  [2497] = {.lex_state = 54, .external_lex_state = 15},
  [2498] = {.lex_state = 54, .external_lex_state = 13},
  [2499] = {.lex_state = 54, .external_lex_state = 13},
  [2500] = {.lex_state = 54, .external_lex_state = 14},
  [2501] = {.lex_state = 54, .external_lex_state = 14},
  [2502] = {.lex_state = 54, .external_lex_state = 15},
  [2503] = {.lex_state = 54, .external_lex_state = 19},
  [2504] = {.lex_state = 54, .external_lex_state = 12},
  [2505] = {.lex_state = 54, .external_lex_state = 15},
  [2506] = {.lex_state = 54, .external_lex_state = 13},
  [2507] = {.lex_state = 54, .external_lex_state = 14},
  [2508] = {.lex_state = 54, .external_lex_state = 9},
  [2509] = {.lex_state = 54, .external_lex_state = 15},
  [2510] = {.lex_state = 54, .external_lex_state = 9},
  [2511] = {.lex_state = 54, .external_lex_state = 9},
  [2512] = {.lex_state = 33, .external_lex_state = 14},
  [2513] = {.lex_state = 54, .external_lex_state = 12},
  [2514] = {.lex_state = 54, .external_lex_state = 15},
  [2515] = {.lex_state = 54, .external_lex_state = 13},
  [2516] = {.lex_state = 54, .external_lex_state = 15},
  [2517] = {.lex_state = 54, .external_lex_state = 14},
  [2518] = {.lex_state = 54, .external_lex_state = 18},
  [2519] = {.lex_state = 54, .external_lex_state = 9},
  [2520] = {.lex_state = 54, .external_lex_state = 9},
  [2521] = {.lex_state = 54, .external_lex_state = 9},
  [2522] = {.lex_state = 54, .external_lex_state = 9},
  [2523] = {.lex_state = 54, .external_lex_state = 9},
  [2524] = {.lex_state = 54, .external_lex_state = 15},
  [2525] = {.lex_state = 54, .external_lex_state = 9},
  [2526] = {.lex_state = 54, .external_lex_state = 15},
  [2527] = {.lex_state = 54, .external_lex_state = 14},
  [2528] = {.lex_state = 54, .external_lex_state = 14},
  [2529] = {.lex_state = 54, .external_lex_state = 9},
  [2530] = {.lex_state = 54, .external_lex_state = 9},
  [2531] = {.lex_state = 54, .external_lex_state = 13},
  [2532] = {.lex_state = 54, .external_lex_state = 13},
  [2533] = {.lex_state = 54, .external_lex_state = 18},
  [2534] = {.lex_state = 54, .external_lex_state = 18},
  [2535] = {.lex_state = 54, .external_lex_state = 9},
  [2536] = {.lex_state = 54, .external_lex_state = 18},
  [2537] = {.lex_state = 54, .external_lex_state = 18},
  [2538] = {.lex_state = 54, .external_lex_state = 18},
  [2539] = {.lex_state = 54, .external_lex_state = 18},
  [2540] = {.lex_state = 54, .external_lex_state = 15},
  [2541] = {.lex_state = 54, .external_lex_state = 18},
  [2542] = {.lex_state = 54, .external_lex_state = 18},
  [2543] = {.lex_state = 54, .external_lex_state = 13},
  [2544] = {.lex_state = 54, .external_lex_state = 18},
  [2545] = {.lex_state = 54, .external_lex_state = 13},
  [2546] = {.lex_state = 54, .external_lex_state = 18},
  [2547] = {.lex_state = 54, .external_lex_state = 12},
  [2548] = {.lex_state = 54, .external_lex_state = 12},
  [2549] = {.lex_state = 54, .external_lex_state = 12},
  [2550] = {.lex_state = 54, .external_lex_state = 18},
  [2551] = {.lex_state = 34, .external_lex_state = 14},
  [2552] = {.lex_state = 54, .external_lex_state = 18},
  [2553] = {.lex_state = 54, .external_lex_state = 18},
  [2554] = {.lex_state = 54, .external_lex_state = 18},
  [2555] = {.lex_state = 54, .external_lex_state = 15},
  [2556] = {.lex_state = 54, .external_lex_state = 13},
  [2557] = {.lex_state = 54, .external_lex_state = 13},
  [2558] = {.lex_state = 54, .external_lex_state = 14},
  [2559] = {.lex_state = 54, .external_lex_state = 18},
  [2560] = {.lex_state = 54, .external_lex_state = 13},
  [2561] = {.lex_state = 54, .external_lex_state = 15},
  [2562] = {.lex_state = 34, .external_lex_state = 14},
  [2563] = {.lex_state = 54, .external_lex_state = 13},
  [2564] = {.lex_state = 34, .external_lex_state = 14},
  [2565] = {.lex_state = 54, .external_lex_state = 9},
  [2566] = {.lex_state = 54, .external_lex_state = 14},
  [2567] = {.lex_state = 54, .external_lex_state = 14},
  [2568] = {.lex_state = 54, .external_lex_state = 9},
  [2569] = {.lex_state = 54, .external_lex_state = 9},
  [2570] = {.lex_state = 54, .external_lex_state = 14},
  [2571] = {.lex_state = 54, .external_lex_state = 14},
  [2572] = {.lex_state = 54, .external_lex_state = 13},
  [2573] = {.lex_state = 54, .external_lex_state = 13},
  [2574] = {.lex_state = 54, .external_lex_state = 12},
  [2575] = {.lex_state = 54, .external_lex_state = 14},
  [2576] = {.lex_state = 34, .external_lex_state = 14},
  [2577] = {.lex_state = 54, .external_lex_state = 14},
  [2578] = {.lex_state = 54, .external_lex_state = 18},
  [2579] = {.lex_state = 34, .external_lex_state = 14},
  [2580] = {.lex_state = 54, .external_lex_state = 14},
  [2581] = {.lex_state = 34, .external_lex_state = 14},
  [2582] = {.lex_state = 34, .external_lex_state = 14},
  [2583] = {.lex_state = 54, .external_lex_state = 14},
  [2584] = {.lex_state = 34, .external_lex_state = 14},
  [2585] = {.lex_state = 54, .external_lex_state = 9},
  [2586] = {.lex_state = 54, .external_lex_state = 14},
  [2587] = {.lex_state = 54, .external_lex_state = 13},
  [2588] = {.lex_state = 54, .external_lex_state = 14},
  [2589] = {.lex_state = 34, .external_lex_state = 14},
  [2590] = {.lex_state = 34, .external_lex_state = 14},
  [2591] = {.lex_state = 54, .external_lex_state = 14},
  [2592] = {.lex_state = 54, .external_lex_state = 14},
  [2593] = {.lex_state = 54, .external_lex_state = 14},
  [2594] = {.lex_state = 54, .external_lex_state = 9},
  [2595] = {.lex_state = 54, .external_lex_state = 13},
  [2596] = {.lex_state = 54, .external_lex_state = 14},
  [2597] = {.lex_state = 54, .external_lex_state = 13},
  [2598] = {.lex_state = 54, .external_lex_state = 9},
  [2599] = {.lex_state = 54, .external_lex_state = 14},
  [2600] = {.lex_state = 54, .external_lex_state = 9},
  [2601] = {.lex_state = 54, .external_lex_state = 15},
  [2602] = {.lex_state = 54, .external_lex_state = 15},
  [2603] = {.lex_state = 54, .external_lex_state = 13},
  [2604] = {.lex_state = 54, .external_lex_state = 13},
  [2605] = {.lex_state = 54, .external_lex_state = 9},
  [2606] = {.lex_state = 54, .external_lex_state = 12},
  [2607] = {.lex_state = 54, .external_lex_state = 14},
  [2608] = {.lex_state = 54, .external_lex_state = 14},
  [2609] = {.lex_state = 54, .external_lex_state = 18},
  [2610] = {.lex_state = 54, .external_lex_state = 9},
  [2611] = {.lex_state = 54, .external_lex_state = 14},
  [2612] = {.lex_state = 54, .external_lex_state = 14},
  [2613] = {.lex_state = 54, .external_lex_state = 14},
  [2614] = {.lex_state = 54, .external_lex_state = 14},
  [2615] = {.lex_state = 54, .external_lex_state = 14},
  [2616] = {.lex_state = 54, .external_lex_state = 15},
  [2617] = {.lex_state = 54, .external_lex_state = 15},
  [2618] = {.lex_state = 54, .external_lex_state = 14},
  [2619] = {.lex_state = 54, .external_lex_state = 15},
  [2620] = {.lex_state = 54, .external_lex_state = 13},
  [2621] = {.lex_state = 54, .external_lex_state = 14},
  [2622] = {.lex_state = 54, .external_lex_state = 12},
  [2623] = {.lex_state = 54, .external_lex_state = 14},
  [2624] = {.lex_state = 54, .external_lex_state = 14},
  [2625] = {.lex_state = 54, .external_lex_state = 14},
  [2626] = {.lex_state = 29, .external_lex_state = 14},
  [2627] = {.lex_state = 54, .external_lex_state = 14},
  [2628] = {.lex_state = 54, .external_lex_state = 13},
  [2629] = {.lex_state = 54, .external_lex_state = 14},
  [2630] = {.lex_state = 54, .external_lex_state = 15},
  [2631] = {.lex_state = 54, .external_lex_state = 12},
  [2632] = {.lex_state = 54, .external_lex_state = 13},
  [2633] = {.lex_state = 54, .external_lex_state = 14},
  [2634] = {.lex_state = 54, .external_lex_state = 12},
  [2635] = {.lex_state = 54, .external_lex_state = 14},
  [2636] = {.lex_state = 54, .external_lex_state = 12},
  [2637] = {.lex_state = 54, .external_lex_state = 13},
  [2638] = {.lex_state = 54, .external_lex_state = 14},
  [2639] = {.lex_state = 54, .external_lex_state = 14},
  [2640] = {.lex_state = 54, .external_lex_state = 13},
  [2641] = {.lex_state = 54, .external_lex_state = 15},
  [2642] = {.lex_state = 54, .external_lex_state = 12},
  [2643] = {.lex_state = 54, .external_lex_state = 12},
  [2644] = {.lex_state = 54, .external_lex_state = 12},
  [2645] = {.lex_state = 54, .external_lex_state = 12},
  [2646] = {.lex_state = 54, .external_lex_state = 12},
  [2647] = {.lex_state = 54, .external_lex_state = 13},
  [2648] = {.lex_state = 54, .external_lex_state = 12},
  [2649] = {.lex_state = 54, .external_lex_state = 12},
  [2650] = {.lex_state = 54, .external_lex_state = 15},
  [2651] = {.lex_state = 54, .external_lex_state = 13},
  [2652] = {.lex_state = 54, .external_lex_state = 12},
  [2653] = {.lex_state = 54, .external_lex_state = 12},
  [2654] = {.lex_state = 54, .external_lex_state = 14},
  [2655] = {.lex_state = 54, .external_lex_state = 15},
  [2656] = {.lex_state = 54, .external_lex_state = 12},
  [2657] = {.lex_state = 54, .external_lex_state = 14},
  [2658] = {.lex_state = 54, .external_lex_state = 14},
  [2659] = {.lex_state = 54, .external_lex_state = 15},
  [2660] = {.lex_state = 54, .external_lex_state = 15},
  [2661] = {.lex_state = 54, .external_lex_state = 14},
  [2662] = {.lex_state = 54, .external_lex_state = 12},
  [2663] = {.lex_state = 54, .external_lex_state = 14},
  [2664] = {.lex_state = 54, .external_lex_state = 14},
  [2665] = {.lex_state = 54, .external_lex_state = 13},
  [2666] = {.lex_state = 54, .external_lex_state = 14},
  [2667] = {.lex_state = 54, .external_lex_state = 14},
  [2668] = {.lex_state = 54, .external_lex_state = 14},
  [2669] = {.lex_state = 29, .external_lex_state = 14},
  [2670] = {.lex_state = 54, .external_lex_state = 14},
  [2671] = {.lex_state = 54, .external_lex_state = 14},
  [2672] = {.lex_state = 54, .external_lex_state = 14},
  [2673] = {.lex_state = 54, .external_lex_state = 12},
  [2674] = {.lex_state = 54, .external_lex_state = 14},
  [2675] = {.lex_state = 54, .external_lex_state = 12},
  [2676] = {.lex_state = 54, .external_lex_state = 15},
  [2677] = {.lex_state = 29, .external_lex_state = 14},
  [2678] = {.lex_state = 54, .external_lex_state = 12},
  [2679] = {.lex_state = 54, .external_lex_state = 15},
  [2680] = {.lex_state = 54, .external_lex_state = 14},
  [2681] = {.lex_state = 54, .external_lex_state = 14},
  [2682] = {.lex_state = 54, .external_lex_state = 14},
  [2683] = {.lex_state = 54, .external_lex_state = 13},
  [2684] = {.lex_state = 54, .external_lex_state = 13},
  [2685] = {.lex_state = 54, .external_lex_state = 14},
  [2686] = {.lex_state = 54, .external_lex_state = 14},
  [2687] = {.lex_state = 54, .external_lex_state = 14},
  [2688] = {.lex_state = 29, .external_lex_state = 14},
  [2689] = {.lex_state = 54, .external_lex_state = 13},
  [2690] = {.lex_state = 54, .external_lex_state = 12},
  [2691] = {.lex_state = 54, .external_lex_state = 13},
  [2692] = {.lex_state = 54, .external_lex_state = 13},
  [2693] = {.lex_state = 54, .external_lex_state = 14},
  [2694] = {.lex_state = 54, .external_lex_state = 15},
  [2695] = {.lex_state = 54, .external_lex_state = 13},
  [2696] = {.lex_state = 54, .external_lex_state = 12},
  [2697] = {.lex_state = 54, .external_lex_state = 14},
  [2698] = {.lex_state = 54, .external_lex_state = 14},
  [2699] = {.lex_state = 54, .external_lex_state = 13},
  [2700] = {.lex_state = 54, .external_lex_state = 12},
  [2701] = {.lex_state = 54, .external_lex_state = 12},
  [2702] = {.lex_state = 54, .external_lex_state = 14},
  [2703] = {.lex_state = 54, .external_lex_state = 14},
  [2704] = {.lex_state = 54, .external_lex_state = 14},
  [2705] = {.lex_state = 54, .external_lex_state = 12},
  [2706] = {.lex_state = 54, .external_lex_state = 15},
  [2707] = {.lex_state = 54, .external_lex_state = 13},
  [2708] = {.lex_state = 54, .external_lex_state = 13},
  [2709] = {.lex_state = 54, .external_lex_state = 14},
  [2710] = {.lex_state = 54, .external_lex_state = 14},
  [2711] = {.lex_state = 54, .external_lex_state = 14},
  [2712] = {.lex_state = 54, .external_lex_state = 14},
  [2713] = {.lex_state = 54, .external_lex_state = 14},
  [2714] = {.lex_state = 54, .external_lex_state = 14},
  [2715] = {.lex_state = 54, .external_lex_state = 14},
  [2716] = {.lex_state = 54, .external_lex_state = 14},
  [2717] = {.lex_state = 54, .external_lex_state = 12},
  [2718] = {.lex_state = 54, .external_lex_state = 14},
  [2719] = {.lex_state = 54, .external_lex_state = 14},
  [2720] = {.lex_state = 54, .external_lex_state = 14},
  [2721] = {.lex_state = 54, .external_lex_state = 14},
  [2722] = {.lex_state = 54, .external_lex_state = 14},
  [2723] = {.lex_state = 54, .external_lex_state = 14},
  [2724] = {.lex_state = 54, .external_lex_state = 12},
  [2725] = {.lex_state = 54, .external_lex_state = 14},
  [2726] = {.lex_state = 54, .external_lex_state = 14},
  [2727] = {.lex_state = 54, .external_lex_state = 14},
  [2728] = {.lex_state = 54, .external_lex_state = 12},
  [2729] = {.lex_state = 54, .external_lex_state = 15},
  [2730] = {.lex_state = 54, .external_lex_state = 14},
  [2731] = {.lex_state = 54, .external_lex_state = 13},
  [2732] = {.lex_state = 54, .external_lex_state = 14},
  [2733] = {.lex_state = 54, .external_lex_state = 14},
  [2734] = {.lex_state = 29, .external_lex_state = 14},
  [2735] = {.lex_state = 54, .external_lex_state = 14},
  [2736] = {.lex_state = 54, .external_lex_state = 12},
  [2737] = {.lex_state = 54, .external_lex_state = 12},
  [2738] = {.lex_state = 54, .external_lex_state = 14},
  [2739] = {.lex_state = 54, .external_lex_state = 14},
  [2740] = {.lex_state = 54, .external_lex_state = 12},
  [2741] = {.lex_state = 54, .external_lex_state = 15},
  [2742] = {.lex_state = 54, .external_lex_state = 14},
  [2743] = {.lex_state = 29, .external_lex_state = 14},
  [2744] = {.lex_state = 54, .external_lex_state = 13},
  [2745] = {.lex_state = 54, .external_lex_state = 14},
  [2746] = {.lex_state = 54, .external_lex_state = 12},
  [2747] = {.lex_state = 54, .external_lex_state = 14},
  [2748] = {.lex_state = 54, .external_lex_state = 12},
  [2749] = {.lex_state = 54, .external_lex_state = 14},
  [2750] = {.lex_state = 54, .external_lex_state = 14},
  [2751] = {.lex_state = 54, .external_lex_state = 13},
  [2752] = {.lex_state = 54, .external_lex_state = 12},
  [2753] = {.lex_state = 54, .external_lex_state = 13},
  [2754] = {.lex_state = 54, .external_lex_state = 15},
  [2755] = {.lex_state = 54, .external_lex_state = 14},
  [2756] = {.lex_state = 54, .external_lex_state = 14},
  [2757] = {.lex_state = 54, .external_lex_state = 12},
  [2758] = {.lex_state = 54, .external_lex_state = 13},
  [2759] = {.lex_state = 54, .external_lex_state = 13},
  [2760] = {.lex_state = 54, .external_lex_state = 13},
  [2761] = {.lex_state = 54, .external_lex_state = 13},
  [2762] = {.lex_state = 54, .external_lex_state = 14},
  [2763] = {.lex_state = 54, .external_lex_state = 14},
  [2764] = {.lex_state = 54, .external_lex_state = 14},
  [2765] = {.lex_state = 54, .external_lex_state = 13},
  [2766] = {.lex_state = 54, .external_lex_state = 14},
  [2767] = {.lex_state = 54, .external_lex_state = 14},
  [2768] = {.lex_state = 54, .external_lex_state = 14},
  [2769] = {.lex_state = 54, .external_lex_state = 14},
  [2770] = {.lex_state = 54, .external_lex_state = 14},
  [2771] = {.lex_state = 54, .external_lex_state = 14},
  [2772] = {.lex_state = 54, .external_lex_state = 14},
  [2773] = {.lex_state = 54, .external_lex_state = 14},
  [2774] = {.lex_state = 54, .external_lex_state = 14},
  [2775] = {.lex_state = 54, .external_lex_state = 13},
  [2776] = {.lex_state = 54, .external_lex_state = 14},
  [2777] = {.lex_state = 54, .external_lex_state = 15},
  [2778] = {.lex_state = 54, .external_lex_state = 15},
  [2779] = {.lex_state = 54, .external_lex_state = 12},
  [2780] = {.lex_state = 54, .external_lex_state = 12},
  [2781] = {.lex_state = 54, .external_lex_state = 12},
  [2782] = {.lex_state = 54, .external_lex_state = 14},
  [2783] = {.lex_state = 54, .external_lex_state = 14},
  [2784] = {.lex_state = 29, .external_lex_state = 14},
  [2785] = {.lex_state = 54, .external_lex_state = 14},
  [2786] = {.lex_state = 54, .external_lex_state = 12},
  [2787] = {.lex_state = 54, .external_lex_state = 15},
  [2788] = {.lex_state = 54, .external_lex_state = 13},
  [2789] = {.lex_state = 54, .external_lex_state = 14},
  [2790] = {.lex_state = 54, .external_lex_state = 15},
  [2791] = {.lex_state = 54, .external_lex_state = 14},
  [2792] = {.lex_state = 54, .external_lex_state = 15},
  [2793] = {.lex_state = 54, .external_lex_state = 14},
  [2794] = {.lex_state = 54, .external_lex_state = 14},
  [2795] = {.lex_state = 29, .external_lex_state = 14},
  [2796] = {.lex_state = 54, .external_lex_state = 14},
  [2797] = {.lex_state = 54, .external_lex_state = 13},
  [2798] = {.lex_state = 54, .external_lex_state = 14},
  [2799] = {.lex_state = 54, .external_lex_state = 14},
  [2800] = {.lex_state = 54, .external_lex_state = 14},
  [2801] = {.lex_state = 54, .external_lex_state = 14},
  [2802] = {.lex_state = 54, .external_lex_state = 14},
  [2803] = {.lex_state = 54, .external_lex_state = 14},
  [2804] = {.lex_state = 54, .external_lex_state = 14},
  [2805] = {.lex_state = 54, .external_lex_state = 12},
  [2806] = {.lex_state = 54, .external_lex_state = 12},
  [2807] = {.lex_state = 54, .external_lex_state = 13},
  [2808] = {.lex_state = 54, .external_lex_state = 14},
  [2809] = {.lex_state = 54, .external_lex_state = 14},
  [2810] = {.lex_state = 54, .external_lex_state = 12},
  [2811] = {.lex_state = 54, .external_lex_state = 14},
  [2812] = {.lex_state = 54, .external_lex_state = 14},
  [2813] = {.lex_state = 54, .external_lex_state = 14},
  [2814] = {.lex_state = 54, .external_lex_state = 13},
  [2815] = {.lex_state = 54, .external_lex_state = 14},
  [2816] = {.lex_state = 54, .external_lex_state = 14},
  [2817] = {.lex_state = 54, .external_lex_state = 15},
  [2818] = {.lex_state = 54, .external_lex_state = 13},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_from] = ACTIONS(1),
    [anon_sym___future__] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_print] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_assert] = ACTIONS(1),
    [anon_sym_COLON_EQ] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_del] = ACTIONS(1),
    [anon_sym_raise] = ACTIONS(1),
    [anon_sym_pass] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_elif] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_match] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_async] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_except] = ACTIONS(1),
    [anon_sym_except_STAR] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_def] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_global] = ACTIONS(1),
    [anon_sym_nonlocal] = ACTIONS(1),
    [anon_sym_exec] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym__] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_not] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_SLASH_SLASH] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_LT_GT] = ACTIONS(1),
    [anon_sym_is] = ACTIONS(1),
    [anon_sym_lambda] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_AT_EQ] = ACTIONS(1),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [sym_ellipsis] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [sym__not_escape_sequence] = ACTIONS(1),
    [sym_type_conversion] = ACTIONS(1),
    [sym_integer] = ACTIONS(1),
    [sym_float] = ACTIONS(1),
    [anon_sym_await] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_none] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(5),
    [sym__newline] = ACTIONS(1),
    [sym__indent] = ACTIONS(1),
    [sym__dedent] = ACTIONS(1),
    [sym_string_start] = ACTIONS(1),
    [sym__string_content] = ACTIONS(1),
    [sym_escape_interpolation] = ACTIONS(1),
    [sym_string_end] = ACTIONS(1),
  },
  [1] = {
    [sym_module] = STATE(2798),
    [sym__statement] = STATE(66),
    [sym__simple_statements] = STATE(66),
    [sym_import_statement] = STATE(2262),
    [sym_future_import_statement] = STATE(2262),
    [sym_import_from_statement] = STATE(2262),
    [sym_print_statement] = STATE(2262),
    [sym_assert_statement] = STATE(2262),
    [sym_expression_statement] = STATE(2262),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2262),
    [sym_delete_statement] = STATE(2262),
    [sym_raise_statement] = STATE(2262),
    [sym_pass_statement] = STATE(2262),
    [sym_break_statement] = STATE(2262),
    [sym_continue_statement] = STATE(2262),
    [sym_if_statement] = STATE(66),
    [sym_match_statement] = STATE(66),
    [sym_for_statement] = STATE(66),
    [sym_while_statement] = STATE(66),
    [sym_try_statement] = STATE(66),
    [sym_with_statement] = STATE(66),
    [sym_function_definition] = STATE(66),
    [sym_global_statement] = STATE(2262),
    [sym_nonlocal_statement] = STATE(2262),
    [sym_exec_statement] = STATE(2262),
    [sym_type_alias_statement] = STATE(2262),
    [sym_class_definition] = STATE(66),
    [sym_decorated_definition] = STATE(66),
    [sym_decorator] = STATE(1821),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(66),
    [aux_sym_decorated_definition_repeat1] = STATE(1821),
    [ts_builtin_sym_end] = ACTIONS(7),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(35),
    [anon_sym_match] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_def] = ACTIONS(49),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(81),
  },
  [2] = {
    [sym__statement] = STATE(70),
    [sym__simple_statements] = STATE(70),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(70),
    [sym_match_statement] = STATE(70),
    [sym_for_statement] = STATE(70),
    [sym_while_statement] = STATE(70),
    [sym_try_statement] = STATE(70),
    [sym_with_statement] = STATE(70),
    [sym_function_definition] = STATE(70),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(70),
    [sym_decorated_definition] = STATE(70),
    [sym_decorator] = STATE(1816),
    [sym_block] = STATE(657),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(70),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(101),
    [sym_string_start] = ACTIONS(81),
  },
  [3] = {
    [sym__statement] = STATE(65),
    [sym__simple_statements] = STATE(65),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(65),
    [sym_match_statement] = STATE(65),
    [sym_for_statement] = STATE(65),
    [sym_while_statement] = STATE(65),
    [sym_try_statement] = STATE(65),
    [sym_with_statement] = STATE(65),
    [sym_function_definition] = STATE(65),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(65),
    [sym_decorated_definition] = STATE(65),
    [sym_decorator] = STATE(1816),
    [sym_block] = STATE(1820),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(65),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(103),
    [sym_string_start] = ACTIONS(81),
  },
  [4] = {
    [sym__statement] = STATE(68),
    [sym__simple_statements] = STATE(68),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(68),
    [sym_match_statement] = STATE(68),
    [sym_for_statement] = STATE(68),
    [sym_while_statement] = STATE(68),
    [sym_try_statement] = STATE(68),
    [sym_with_statement] = STATE(68),
    [sym_function_definition] = STATE(68),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(68),
    [sym_decorated_definition] = STATE(68),
    [sym_decorator] = STATE(1816),
    [sym_block] = STATE(776),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(68),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(105),
    [sym_string_start] = ACTIONS(81),
  },
  [5] = {
    [sym__statement] = STATE(68),
    [sym__simple_statements] = STATE(68),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(68),
    [sym_match_statement] = STATE(68),
    [sym_for_statement] = STATE(68),
    [sym_while_statement] = STATE(68),
    [sym_try_statement] = STATE(68),
    [sym_with_statement] = STATE(68),
    [sym_function_definition] = STATE(68),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(68),
    [sym_decorated_definition] = STATE(68),
    [sym_decorator] = STATE(1816),
    [sym_block] = STATE(605),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(68),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(105),
    [sym_string_start] = ACTIONS(81),
  },
  [6] = {
    [sym__statement] = STATE(67),
    [sym__simple_statements] = STATE(67),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(67),
    [sym_match_statement] = STATE(67),
    [sym_for_statement] = STATE(67),
    [sym_while_statement] = STATE(67),
    [sym_try_statement] = STATE(67),
    [sym_with_statement] = STATE(67),
    [sym_function_definition] = STATE(67),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(67),
    [sym_decorated_definition] = STATE(67),
    [sym_decorator] = STATE(1816),
    [sym_block] = STATE(696),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(67),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(107),
    [sym_string_start] = ACTIONS(81),
  },
  [7] = {
    [sym__statement] = STATE(67),
    [sym__simple_statements] = STATE(67),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(67),
    [sym_match_statement] = STATE(67),
    [sym_for_statement] = STATE(67),
    [sym_while_statement] = STATE(67),
    [sym_try_statement] = STATE(67),
    [sym_with_statement] = STATE(67),
    [sym_function_definition] = STATE(67),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(67),
    [sym_decorated_definition] = STATE(67),
    [sym_decorator] = STATE(1816),
    [sym_block] = STATE(824),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(67),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(107),
    [sym_string_start] = ACTIONS(81),
  },
  [8] = {
    [sym__statement] = STATE(67),
    [sym__simple_statements] = STATE(67),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(67),
    [sym_match_statement] = STATE(67),
    [sym_for_statement] = STATE(67),
    [sym_while_statement] = STATE(67),
    [sym_try_statement] = STATE(67),
    [sym_with_statement] = STATE(67),
    [sym_function_definition] = STATE(67),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(67),
    [sym_decorated_definition] = STATE(67),
    [sym_decorator] = STATE(1816),
    [sym_block] = STATE(825),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(67),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(107),
    [sym_string_start] = ACTIONS(81),
  },
  [9] = {
    [sym__statement] = STATE(63),
    [sym__simple_statements] = STATE(63),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(63),
    [sym_match_statement] = STATE(63),
    [sym_for_statement] = STATE(63),
    [sym_while_statement] = STATE(63),
    [sym_try_statement] = STATE(63),
    [sym_with_statement] = STATE(63),
    [sym_function_definition] = STATE(63),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(63),
    [sym_decorated_definition] = STATE(63),
    [sym_decorator] = STATE(1816),
    [sym_block] = STATE(2553),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(63),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(109),
    [sym_string_start] = ACTIONS(81),
  },
  [10] = {
    [sym__statement] = STATE(67),
    [sym__simple_statements] = STATE(67),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(67),
    [sym_match_statement] = STATE(67),
    [sym_for_statement] = STATE(67),
    [sym_while_statement] = STATE(67),
    [sym_try_statement] = STATE(67),
    [sym_with_statement] = STATE(67),
    [sym_function_definition] = STATE(67),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(67),
    [sym_decorated_definition] = STATE(67),
    [sym_decorator] = STATE(1816),
    [sym_block] = STATE(763),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(67),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(107),
    [sym_string_start] = ACTIONS(81),
  },
  [11] = {
    [sym__statement] = STATE(67),
    [sym__simple_statements] = STATE(67),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(67),
    [sym_match_statement] = STATE(67),
    [sym_for_statement] = STATE(67),
    [sym_while_statement] = STATE(67),
    [sym_try_statement] = STATE(67),
    [sym_with_statement] = STATE(67),
    [sym_function_definition] = STATE(67),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(67),
    [sym_decorated_definition] = STATE(67),
    [sym_decorator] = STATE(1816),
    [sym_block] = STATE(796),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(67),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(107),
    [sym_string_start] = ACTIONS(81),
  },
  [12] = {
    [sym__statement] = STATE(69),
    [sym__simple_statements] = STATE(69),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(69),
    [sym_match_statement] = STATE(69),
    [sym_for_statement] = STATE(69),
    [sym_while_statement] = STATE(69),
    [sym_try_statement] = STATE(69),
    [sym_with_statement] = STATE(69),
    [sym_function_definition] = STATE(69),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(69),
    [sym_decorated_definition] = STATE(69),
    [sym_decorator] = STATE(1816),
    [sym_block] = STATE(685),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(69),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(111),
    [sym_string_start] = ACTIONS(81),
  },
  [13] = {
    [sym__statement] = STATE(62),
    [sym__simple_statements] = STATE(62),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(62),
    [sym_match_statement] = STATE(62),
    [sym_for_statement] = STATE(62),
    [sym_while_statement] = STATE(62),
    [sym_try_statement] = STATE(62),
    [sym_with_statement] = STATE(62),
    [sym_function_definition] = STATE(62),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(62),
    [sym_decorated_definition] = STATE(62),
    [sym_decorator] = STATE(1816),
    [sym_block] = STATE(646),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(62),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(113),
    [sym_string_start] = ACTIONS(81),
  },
  [14] = {
    [sym__statement] = STATE(65),
    [sym__simple_statements] = STATE(65),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(65),
    [sym_match_statement] = STATE(65),
    [sym_for_statement] = STATE(65),
    [sym_while_statement] = STATE(65),
    [sym_try_statement] = STATE(65),
    [sym_with_statement] = STATE(65),
    [sym_function_definition] = STATE(65),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(65),
    [sym_decorated_definition] = STATE(65),
    [sym_decorator] = STATE(1816),
    [sym_block] = STATE(1840),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(65),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(103),
    [sym_string_start] = ACTIONS(81),
  },
  [15] = {
    [sym__statement] = STATE(67),
    [sym__simple_statements] = STATE(67),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(67),
    [sym_match_statement] = STATE(67),
    [sym_for_statement] = STATE(67),
    [sym_while_statement] = STATE(67),
    [sym_try_statement] = STATE(67),
    [sym_with_statement] = STATE(67),
    [sym_function_definition] = STATE(67),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(67),
    [sym_decorated_definition] = STATE(67),
    [sym_decorator] = STATE(1816),
    [sym_block] = STATE(761),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(67),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(107),
    [sym_string_start] = ACTIONS(81),
  },
  [16] = {
    [sym__statement] = STATE(67),
    [sym__simple_statements] = STATE(67),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(67),
    [sym_match_statement] = STATE(67),
    [sym_for_statement] = STATE(67),
    [sym_while_statement] = STATE(67),
    [sym_try_statement] = STATE(67),
    [sym_with_statement] = STATE(67),
    [sym_function_definition] = STATE(67),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(67),
    [sym_decorated_definition] = STATE(67),
    [sym_decorator] = STATE(1816),
    [sym_block] = STATE(819),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(67),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(107),
    [sym_string_start] = ACTIONS(81),
  },
  [17] = {
    [sym__statement] = STATE(68),
    [sym__simple_statements] = STATE(68),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(68),
    [sym_match_statement] = STATE(68),
    [sym_for_statement] = STATE(68),
    [sym_while_statement] = STATE(68),
    [sym_try_statement] = STATE(68),
    [sym_with_statement] = STATE(68),
    [sym_function_definition] = STATE(68),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(68),
    [sym_decorated_definition] = STATE(68),
    [sym_decorator] = STATE(1816),
    [sym_block] = STATE(708),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(68),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(105),
    [sym_string_start] = ACTIONS(81),
  },
  [18] = {
    [sym__statement] = STATE(67),
    [sym__simple_statements] = STATE(67),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(67),
    [sym_match_statement] = STATE(67),
    [sym_for_statement] = STATE(67),
    [sym_while_statement] = STATE(67),
    [sym_try_statement] = STATE(67),
    [sym_with_statement] = STATE(67),
    [sym_function_definition] = STATE(67),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(67),
    [sym_decorated_definition] = STATE(67),
    [sym_decorator] = STATE(1816),
    [sym_block] = STATE(697),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(67),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(107),
    [sym_string_start] = ACTIONS(81),
  },
  [19] = {
    [sym__statement] = STATE(67),
    [sym__simple_statements] = STATE(67),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(67),
    [sym_match_statement] = STATE(67),
    [sym_for_statement] = STATE(67),
    [sym_while_statement] = STATE(67),
    [sym_try_statement] = STATE(67),
    [sym_with_statement] = STATE(67),
    [sym_function_definition] = STATE(67),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(67),
    [sym_decorated_definition] = STATE(67),
    [sym_decorator] = STATE(1816),
    [sym_block] = STATE(767),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(67),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(107),
    [sym_string_start] = ACTIONS(81),
  },
  [20] = {
    [sym__statement] = STATE(68),
    [sym__simple_statements] = STATE(68),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(68),
    [sym_match_statement] = STATE(68),
    [sym_for_statement] = STATE(68),
    [sym_while_statement] = STATE(68),
    [sym_try_statement] = STATE(68),
    [sym_with_statement] = STATE(68),
    [sym_function_definition] = STATE(68),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(68),
    [sym_decorated_definition] = STATE(68),
    [sym_decorator] = STATE(1816),
    [sym_block] = STATE(799),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(68),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(105),
    [sym_string_start] = ACTIONS(81),
  },
  [21] = {
    [sym__statement] = STATE(70),
    [sym__simple_statements] = STATE(70),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(70),
    [sym_match_statement] = STATE(70),
    [sym_for_statement] = STATE(70),
    [sym_while_statement] = STATE(70),
    [sym_try_statement] = STATE(70),
    [sym_with_statement] = STATE(70),
    [sym_function_definition] = STATE(70),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(70),
    [sym_decorated_definition] = STATE(70),
    [sym_decorator] = STATE(1816),
    [sym_block] = STATE(648),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(70),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(101),
    [sym_string_start] = ACTIONS(81),
  },
  [22] = {
    [sym__statement] = STATE(72),
    [sym__simple_statements] = STATE(72),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(72),
    [sym_match_statement] = STATE(72),
    [sym_for_statement] = STATE(72),
    [sym_while_statement] = STATE(72),
    [sym_try_statement] = STATE(72),
    [sym_with_statement] = STATE(72),
    [sym_function_definition] = STATE(72),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(72),
    [sym_decorated_definition] = STATE(72),
    [sym_decorator] = STATE(1816),
    [sym_block] = STATE(644),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(72),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(115),
    [sym_string_start] = ACTIONS(81),
  },
  [23] = {
    [sym__statement] = STATE(68),
    [sym__simple_statements] = STATE(68),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(68),
    [sym_match_statement] = STATE(68),
    [sym_for_statement] = STATE(68),
    [sym_while_statement] = STATE(68),
    [sym_try_statement] = STATE(68),
    [sym_with_statement] = STATE(68),
    [sym_function_definition] = STATE(68),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(68),
    [sym_decorated_definition] = STATE(68),
    [sym_decorator] = STATE(1816),
    [sym_block] = STATE(780),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(68),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(105),
    [sym_string_start] = ACTIONS(81),
  },
  [24] = {
    [sym__statement] = STATE(67),
    [sym__simple_statements] = STATE(67),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(67),
    [sym_match_statement] = STATE(67),
    [sym_for_statement] = STATE(67),
    [sym_while_statement] = STATE(67),
    [sym_try_statement] = STATE(67),
    [sym_with_statement] = STATE(67),
    [sym_function_definition] = STATE(67),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(67),
    [sym_decorated_definition] = STATE(67),
    [sym_decorator] = STATE(1816),
    [sym_block] = STATE(608),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(67),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(107),
    [sym_string_start] = ACTIONS(81),
  },
  [25] = {
    [sym__statement] = STATE(68),
    [sym__simple_statements] = STATE(68),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(68),
    [sym_match_statement] = STATE(68),
    [sym_for_statement] = STATE(68),
    [sym_while_statement] = STATE(68),
    [sym_try_statement] = STATE(68),
    [sym_with_statement] = STATE(68),
    [sym_function_definition] = STATE(68),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(68),
    [sym_decorated_definition] = STATE(68),
    [sym_decorator] = STATE(1816),
    [sym_block] = STATE(783),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(68),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(105),
    [sym_string_start] = ACTIONS(81),
  },
  [26] = {
    [sym__statement] = STATE(68),
    [sym__simple_statements] = STATE(68),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(68),
    [sym_match_statement] = STATE(68),
    [sym_for_statement] = STATE(68),
    [sym_while_statement] = STATE(68),
    [sym_try_statement] = STATE(68),
    [sym_with_statement] = STATE(68),
    [sym_function_definition] = STATE(68),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(68),
    [sym_decorated_definition] = STATE(68),
    [sym_decorator] = STATE(1816),
    [sym_block] = STATE(807),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(68),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(105),
    [sym_string_start] = ACTIONS(81),
  },
  [27] = {
    [sym__statement] = STATE(63),
    [sym__simple_statements] = STATE(63),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(63),
    [sym_match_statement] = STATE(63),
    [sym_for_statement] = STATE(63),
    [sym_while_statement] = STATE(63),
    [sym_try_statement] = STATE(63),
    [sym_with_statement] = STATE(63),
    [sym_function_definition] = STATE(63),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(63),
    [sym_decorated_definition] = STATE(63),
    [sym_decorator] = STATE(1816),
    [sym_block] = STATE(2559),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(63),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(109),
    [sym_string_start] = ACTIONS(81),
  },
  [28] = {
    [sym__statement] = STATE(68),
    [sym__simple_statements] = STATE(68),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(68),
    [sym_match_statement] = STATE(68),
    [sym_for_statement] = STATE(68),
    [sym_while_statement] = STATE(68),
    [sym_try_statement] = STATE(68),
    [sym_with_statement] = STATE(68),
    [sym_function_definition] = STATE(68),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(68),
    [sym_decorated_definition] = STATE(68),
    [sym_decorator] = STATE(1816),
    [sym_block] = STATE(820),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(68),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(105),
    [sym_string_start] = ACTIONS(81),
  },
  [29] = {
    [sym__statement] = STATE(68),
    [sym__simple_statements] = STATE(68),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(68),
    [sym_match_statement] = STATE(68),
    [sym_for_statement] = STATE(68),
    [sym_while_statement] = STATE(68),
    [sym_try_statement] = STATE(68),
    [sym_with_statement] = STATE(68),
    [sym_function_definition] = STATE(68),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(68),
    [sym_decorated_definition] = STATE(68),
    [sym_decorator] = STATE(1816),
    [sym_block] = STATE(789),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(68),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(105),
    [sym_string_start] = ACTIONS(81),
  },
  [30] = {
    [sym__statement] = STATE(67),
    [sym__simple_statements] = STATE(67),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(67),
    [sym_match_statement] = STATE(67),
    [sym_for_statement] = STATE(67),
    [sym_while_statement] = STATE(67),
    [sym_try_statement] = STATE(67),
    [sym_with_statement] = STATE(67),
    [sym_function_definition] = STATE(67),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(67),
    [sym_decorated_definition] = STATE(67),
    [sym_decorator] = STATE(1816),
    [sym_block] = STATE(716),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(67),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(107),
    [sym_string_start] = ACTIONS(81),
  },
  [31] = {
    [sym__statement] = STATE(68),
    [sym__simple_statements] = STATE(68),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(68),
    [sym_match_statement] = STATE(68),
    [sym_for_statement] = STATE(68),
    [sym_while_statement] = STATE(68),
    [sym_try_statement] = STATE(68),
    [sym_with_statement] = STATE(68),
    [sym_function_definition] = STATE(68),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(68),
    [sym_decorated_definition] = STATE(68),
    [sym_decorator] = STATE(1816),
    [sym_block] = STATE(692),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(68),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(105),
    [sym_string_start] = ACTIONS(81),
  },
  [32] = {
    [sym__statement] = STATE(68),
    [sym__simple_statements] = STATE(68),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(68),
    [sym_match_statement] = STATE(68),
    [sym_for_statement] = STATE(68),
    [sym_while_statement] = STATE(68),
    [sym_try_statement] = STATE(68),
    [sym_with_statement] = STATE(68),
    [sym_function_definition] = STATE(68),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(68),
    [sym_decorated_definition] = STATE(68),
    [sym_decorator] = STATE(1816),
    [sym_block] = STATE(823),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(68),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(105),
    [sym_string_start] = ACTIONS(81),
  },
  [33] = {
    [sym__statement] = STATE(63),
    [sym__simple_statements] = STATE(63),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(63),
    [sym_match_statement] = STATE(63),
    [sym_for_statement] = STATE(63),
    [sym_while_statement] = STATE(63),
    [sym_try_statement] = STATE(63),
    [sym_with_statement] = STATE(63),
    [sym_function_definition] = STATE(63),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(63),
    [sym_decorated_definition] = STATE(63),
    [sym_decorator] = STATE(1816),
    [sym_block] = STATE(2541),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(63),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(109),
    [sym_string_start] = ACTIONS(81),
  },
  [34] = {
    [sym__statement] = STATE(68),
    [sym__simple_statements] = STATE(68),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(68),
    [sym_match_statement] = STATE(68),
    [sym_for_statement] = STATE(68),
    [sym_while_statement] = STATE(68),
    [sym_try_statement] = STATE(68),
    [sym_with_statement] = STATE(68),
    [sym_function_definition] = STATE(68),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(68),
    [sym_decorated_definition] = STATE(68),
    [sym_decorator] = STATE(1816),
    [sym_block] = STATE(809),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(68),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(105),
    [sym_string_start] = ACTIONS(81),
  },
  [35] = {
    [sym__statement] = STATE(67),
    [sym__simple_statements] = STATE(67),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(67),
    [sym_match_statement] = STATE(67),
    [sym_for_statement] = STATE(67),
    [sym_while_statement] = STATE(67),
    [sym_try_statement] = STATE(67),
    [sym_with_statement] = STATE(67),
    [sym_function_definition] = STATE(67),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(67),
    [sym_decorated_definition] = STATE(67),
    [sym_decorator] = STATE(1816),
    [sym_block] = STATE(818),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(67),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(107),
    [sym_string_start] = ACTIONS(81),
  },
  [36] = {
    [sym__statement] = STATE(62),
    [sym__simple_statements] = STATE(62),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(62),
    [sym_match_statement] = STATE(62),
    [sym_for_statement] = STATE(62),
    [sym_while_statement] = STATE(62),
    [sym_try_statement] = STATE(62),
    [sym_with_statement] = STATE(62),
    [sym_function_definition] = STATE(62),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(62),
    [sym_decorated_definition] = STATE(62),
    [sym_decorator] = STATE(1816),
    [sym_block] = STATE(656),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(62),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(113),
    [sym_string_start] = ACTIONS(81),
  },
  [37] = {
    [sym__statement] = STATE(67),
    [sym__simple_statements] = STATE(67),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(67),
    [sym_match_statement] = STATE(67),
    [sym_for_statement] = STATE(67),
    [sym_while_statement] = STATE(67),
    [sym_try_statement] = STATE(67),
    [sym_with_statement] = STATE(67),
    [sym_function_definition] = STATE(67),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(67),
    [sym_decorated_definition] = STATE(67),
    [sym_decorator] = STATE(1816),
    [sym_block] = STATE(704),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(67),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(107),
    [sym_string_start] = ACTIONS(81),
  },
  [38] = {
    [sym__statement] = STATE(69),
    [sym__simple_statements] = STATE(69),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(69),
    [sym_match_statement] = STATE(69),
    [sym_for_statement] = STATE(69),
    [sym_while_statement] = STATE(69),
    [sym_try_statement] = STATE(69),
    [sym_with_statement] = STATE(69),
    [sym_function_definition] = STATE(69),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(69),
    [sym_decorated_definition] = STATE(69),
    [sym_decorator] = STATE(1816),
    [sym_block] = STATE(650),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(69),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(111),
    [sym_string_start] = ACTIONS(81),
  },
  [39] = {
    [sym__statement] = STATE(63),
    [sym__simple_statements] = STATE(63),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(63),
    [sym_match_statement] = STATE(63),
    [sym_for_statement] = STATE(63),
    [sym_while_statement] = STATE(63),
    [sym_try_statement] = STATE(63),
    [sym_with_statement] = STATE(63),
    [sym_function_definition] = STATE(63),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(63),
    [sym_decorated_definition] = STATE(63),
    [sym_decorator] = STATE(1816),
    [sym_block] = STATE(2537),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(63),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(109),
    [sym_string_start] = ACTIONS(81),
  },
  [40] = {
    [sym__statement] = STATE(67),
    [sym__simple_statements] = STATE(67),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(67),
    [sym_match_statement] = STATE(67),
    [sym_for_statement] = STATE(67),
    [sym_while_statement] = STATE(67),
    [sym_try_statement] = STATE(67),
    [sym_with_statement] = STATE(67),
    [sym_function_definition] = STATE(67),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(67),
    [sym_decorated_definition] = STATE(67),
    [sym_decorator] = STATE(1816),
    [sym_block] = STATE(732),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(67),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(107),
    [sym_string_start] = ACTIONS(81),
  },
  [41] = {
    [sym__statement] = STATE(63),
    [sym__simple_statements] = STATE(63),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(63),
    [sym_match_statement] = STATE(63),
    [sym_for_statement] = STATE(63),
    [sym_while_statement] = STATE(63),
    [sym_try_statement] = STATE(63),
    [sym_with_statement] = STATE(63),
    [sym_function_definition] = STATE(63),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(63),
    [sym_decorated_definition] = STATE(63),
    [sym_decorator] = STATE(1816),
    [sym_block] = STATE(2536),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(63),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(109),
    [sym_string_start] = ACTIONS(81),
  },
  [42] = {
    [sym__statement] = STATE(67),
    [sym__simple_statements] = STATE(67),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(67),
    [sym_match_statement] = STATE(67),
    [sym_for_statement] = STATE(67),
    [sym_while_statement] = STATE(67),
    [sym_try_statement] = STATE(67),
    [sym_with_statement] = STATE(67),
    [sym_function_definition] = STATE(67),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(67),
    [sym_decorated_definition] = STATE(67),
    [sym_decorator] = STATE(1816),
    [sym_block] = STATE(803),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(67),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(107),
    [sym_string_start] = ACTIONS(81),
  },
  [43] = {
    [sym__statement] = STATE(67),
    [sym__simple_statements] = STATE(67),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(67),
    [sym_match_statement] = STATE(67),
    [sym_for_statement] = STATE(67),
    [sym_while_statement] = STATE(67),
    [sym_try_statement] = STATE(67),
    [sym_with_statement] = STATE(67),
    [sym_function_definition] = STATE(67),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(67),
    [sym_decorated_definition] = STATE(67),
    [sym_decorator] = STATE(1816),
    [sym_block] = STATE(731),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(67),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(107),
    [sym_string_start] = ACTIONS(81),
  },
  [44] = {
    [sym__statement] = STATE(68),
    [sym__simple_statements] = STATE(68),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(68),
    [sym_match_statement] = STATE(68),
    [sym_for_statement] = STATE(68),
    [sym_while_statement] = STATE(68),
    [sym_try_statement] = STATE(68),
    [sym_with_statement] = STATE(68),
    [sym_function_definition] = STATE(68),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(68),
    [sym_decorated_definition] = STATE(68),
    [sym_decorator] = STATE(1816),
    [sym_block] = STATE(778),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(68),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(105),
    [sym_string_start] = ACTIONS(81),
  },
  [45] = {
    [sym__statement] = STATE(63),
    [sym__simple_statements] = STATE(63),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(63),
    [sym_match_statement] = STATE(63),
    [sym_for_statement] = STATE(63),
    [sym_while_statement] = STATE(63),
    [sym_try_statement] = STATE(63),
    [sym_with_statement] = STATE(63),
    [sym_function_definition] = STATE(63),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(63),
    [sym_decorated_definition] = STATE(63),
    [sym_decorator] = STATE(1816),
    [sym_block] = STATE(2533),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(63),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(109),
    [sym_string_start] = ACTIONS(81),
  },
  [46] = {
    [sym__statement] = STATE(67),
    [sym__simple_statements] = STATE(67),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(67),
    [sym_match_statement] = STATE(67),
    [sym_for_statement] = STATE(67),
    [sym_while_statement] = STATE(67),
    [sym_try_statement] = STATE(67),
    [sym_with_statement] = STATE(67),
    [sym_function_definition] = STATE(67),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(67),
    [sym_decorated_definition] = STATE(67),
    [sym_decorator] = STATE(1816),
    [sym_block] = STATE(756),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(67),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(107),
    [sym_string_start] = ACTIONS(81),
  },
  [47] = {
    [sym__statement] = STATE(68),
    [sym__simple_statements] = STATE(68),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(68),
    [sym_match_statement] = STATE(68),
    [sym_for_statement] = STATE(68),
    [sym_while_statement] = STATE(68),
    [sym_try_statement] = STATE(68),
    [sym_with_statement] = STATE(68),
    [sym_function_definition] = STATE(68),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(68),
    [sym_decorated_definition] = STATE(68),
    [sym_decorator] = STATE(1816),
    [sym_block] = STATE(829),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(68),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(105),
    [sym_string_start] = ACTIONS(81),
  },
  [48] = {
    [sym__statement] = STATE(67),
    [sym__simple_statements] = STATE(67),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(67),
    [sym_match_statement] = STATE(67),
    [sym_for_statement] = STATE(67),
    [sym_while_statement] = STATE(67),
    [sym_try_statement] = STATE(67),
    [sym_with_statement] = STATE(67),
    [sym_function_definition] = STATE(67),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(67),
    [sym_decorated_definition] = STATE(67),
    [sym_decorator] = STATE(1816),
    [sym_block] = STATE(727),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(67),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(107),
    [sym_string_start] = ACTIONS(81),
  },
  [49] = {
    [sym__statement] = STATE(72),
    [sym__simple_statements] = STATE(72),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(72),
    [sym_match_statement] = STATE(72),
    [sym_for_statement] = STATE(72),
    [sym_while_statement] = STATE(72),
    [sym_try_statement] = STATE(72),
    [sym_with_statement] = STATE(72),
    [sym_function_definition] = STATE(72),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(72),
    [sym_decorated_definition] = STATE(72),
    [sym_decorator] = STATE(1816),
    [sym_block] = STATE(660),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(72),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(115),
    [sym_string_start] = ACTIONS(81),
  },
  [50] = {
    [sym__statement] = STATE(68),
    [sym__simple_statements] = STATE(68),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(68),
    [sym_match_statement] = STATE(68),
    [sym_for_statement] = STATE(68),
    [sym_while_statement] = STATE(68),
    [sym_try_statement] = STATE(68),
    [sym_with_statement] = STATE(68),
    [sym_function_definition] = STATE(68),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(68),
    [sym_decorated_definition] = STATE(68),
    [sym_decorator] = STATE(1816),
    [sym_block] = STATE(812),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(68),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(105),
    [sym_string_start] = ACTIONS(81),
  },
  [51] = {
    [sym__statement] = STATE(68),
    [sym__simple_statements] = STATE(68),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(68),
    [sym_match_statement] = STATE(68),
    [sym_for_statement] = STATE(68),
    [sym_while_statement] = STATE(68),
    [sym_try_statement] = STATE(68),
    [sym_with_statement] = STATE(68),
    [sym_function_definition] = STATE(68),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(68),
    [sym_decorated_definition] = STATE(68),
    [sym_decorator] = STATE(1816),
    [sym_block] = STATE(703),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(68),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(105),
    [sym_string_start] = ACTIONS(81),
  },
  [52] = {
    [sym__statement] = STATE(72),
    [sym__simple_statements] = STATE(72),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(72),
    [sym_match_statement] = STATE(72),
    [sym_for_statement] = STATE(72),
    [sym_while_statement] = STATE(72),
    [sym_try_statement] = STATE(72),
    [sym_with_statement] = STATE(72),
    [sym_function_definition] = STATE(72),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(72),
    [sym_decorated_definition] = STATE(72),
    [sym_decorator] = STATE(1816),
    [sym_block] = STATE(679),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(72),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(115),
    [sym_string_start] = ACTIONS(81),
  },
  [53] = {
    [sym__statement] = STATE(62),
    [sym__simple_statements] = STATE(62),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(62),
    [sym_match_statement] = STATE(62),
    [sym_for_statement] = STATE(62),
    [sym_while_statement] = STATE(62),
    [sym_try_statement] = STATE(62),
    [sym_with_statement] = STATE(62),
    [sym_function_definition] = STATE(62),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(62),
    [sym_decorated_definition] = STATE(62),
    [sym_decorator] = STATE(1816),
    [sym_block] = STATE(686),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(62),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(113),
    [sym_string_start] = ACTIONS(81),
  },
  [54] = {
    [sym__statement] = STATE(68),
    [sym__simple_statements] = STATE(68),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(68),
    [sym_match_statement] = STATE(68),
    [sym_for_statement] = STATE(68),
    [sym_while_statement] = STATE(68),
    [sym_try_statement] = STATE(68),
    [sym_with_statement] = STATE(68),
    [sym_function_definition] = STATE(68),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(68),
    [sym_decorated_definition] = STATE(68),
    [sym_decorator] = STATE(1816),
    [sym_block] = STATE(835),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(68),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(105),
    [sym_string_start] = ACTIONS(81),
  },
  [55] = {
    [sym__statement] = STATE(68),
    [sym__simple_statements] = STATE(68),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(68),
    [sym_match_statement] = STATE(68),
    [sym_for_statement] = STATE(68),
    [sym_while_statement] = STATE(68),
    [sym_try_statement] = STATE(68),
    [sym_with_statement] = STATE(68),
    [sym_function_definition] = STATE(68),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(68),
    [sym_decorated_definition] = STATE(68),
    [sym_decorator] = STATE(1816),
    [sym_block] = STATE(706),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(68),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(105),
    [sym_string_start] = ACTIONS(81),
  },
  [56] = {
    [sym__statement] = STATE(67),
    [sym__simple_statements] = STATE(67),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(67),
    [sym_match_statement] = STATE(67),
    [sym_for_statement] = STATE(67),
    [sym_while_statement] = STATE(67),
    [sym_try_statement] = STATE(67),
    [sym_with_statement] = STATE(67),
    [sym_function_definition] = STATE(67),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(67),
    [sym_decorated_definition] = STATE(67),
    [sym_decorator] = STATE(1816),
    [sym_block] = STATE(698),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(67),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(107),
    [sym_string_start] = ACTIONS(81),
  },
  [57] = {
    [sym__statement] = STATE(67),
    [sym__simple_statements] = STATE(67),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(67),
    [sym_match_statement] = STATE(67),
    [sym_for_statement] = STATE(67),
    [sym_while_statement] = STATE(67),
    [sym_try_statement] = STATE(67),
    [sym_with_statement] = STATE(67),
    [sym_function_definition] = STATE(67),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(67),
    [sym_decorated_definition] = STATE(67),
    [sym_decorator] = STATE(1816),
    [sym_block] = STATE(749),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(67),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(107),
    [sym_string_start] = ACTIONS(81),
  },
  [58] = {
    [sym__statement] = STATE(67),
    [sym__simple_statements] = STATE(67),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(67),
    [sym_match_statement] = STATE(67),
    [sym_for_statement] = STATE(67),
    [sym_while_statement] = STATE(67),
    [sym_try_statement] = STATE(67),
    [sym_with_statement] = STATE(67),
    [sym_function_definition] = STATE(67),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(67),
    [sym_decorated_definition] = STATE(67),
    [sym_decorator] = STATE(1816),
    [sym_block] = STATE(839),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(67),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(107),
    [sym_string_start] = ACTIONS(81),
  },
  [59] = {
    [sym__statement] = STATE(68),
    [sym__simple_statements] = STATE(68),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(68),
    [sym_match_statement] = STATE(68),
    [sym_for_statement] = STATE(68),
    [sym_while_statement] = STATE(68),
    [sym_try_statement] = STATE(68),
    [sym_with_statement] = STATE(68),
    [sym_function_definition] = STATE(68),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(68),
    [sym_decorated_definition] = STATE(68),
    [sym_decorator] = STATE(1816),
    [sym_block] = STATE(713),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(68),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(105),
    [sym_string_start] = ACTIONS(81),
  },
  [60] = {
    [sym__statement] = STATE(68),
    [sym__simple_statements] = STATE(68),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(68),
    [sym_match_statement] = STATE(68),
    [sym_for_statement] = STATE(68),
    [sym_while_statement] = STATE(68),
    [sym_try_statement] = STATE(68),
    [sym_with_statement] = STATE(68),
    [sym_function_definition] = STATE(68),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(68),
    [sym_decorated_definition] = STATE(68),
    [sym_decorator] = STATE(1816),
    [sym_block] = STATE(841),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(68),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(105),
    [sym_string_start] = ACTIONS(81),
  },
  [61] = {
    [sym__statement] = STATE(68),
    [sym__simple_statements] = STATE(68),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(68),
    [sym_match_statement] = STATE(68),
    [sym_for_statement] = STATE(68),
    [sym_while_statement] = STATE(68),
    [sym_try_statement] = STATE(68),
    [sym_with_statement] = STATE(68),
    [sym_function_definition] = STATE(68),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(68),
    [sym_decorated_definition] = STATE(68),
    [sym_decorator] = STATE(1816),
    [sym_block] = STATE(842),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(68),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(105),
    [sym_string_start] = ACTIONS(81),
  },
  [62] = {
    [sym__statement] = STATE(64),
    [sym__simple_statements] = STATE(64),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(64),
    [sym_match_statement] = STATE(64),
    [sym_for_statement] = STATE(64),
    [sym_while_statement] = STATE(64),
    [sym_try_statement] = STATE(64),
    [sym_with_statement] = STATE(64),
    [sym_function_definition] = STATE(64),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(64),
    [sym_decorated_definition] = STATE(64),
    [sym_decorator] = STATE(1816),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(64),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(117),
    [sym_string_start] = ACTIONS(81),
  },
  [63] = {
    [sym__statement] = STATE(64),
    [sym__simple_statements] = STATE(64),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(64),
    [sym_match_statement] = STATE(64),
    [sym_for_statement] = STATE(64),
    [sym_while_statement] = STATE(64),
    [sym_try_statement] = STATE(64),
    [sym_with_statement] = STATE(64),
    [sym_function_definition] = STATE(64),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(64),
    [sym_decorated_definition] = STATE(64),
    [sym_decorator] = STATE(1816),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(64),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(119),
    [sym_string_start] = ACTIONS(81),
  },
  [64] = {
    [sym__statement] = STATE(64),
    [sym__simple_statements] = STATE(64),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(64),
    [sym_match_statement] = STATE(64),
    [sym_for_statement] = STATE(64),
    [sym_while_statement] = STATE(64),
    [sym_try_statement] = STATE(64),
    [sym_with_statement] = STATE(64),
    [sym_function_definition] = STATE(64),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(64),
    [sym_decorated_definition] = STATE(64),
    [sym_decorator] = STATE(1816),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(64),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_from] = ACTIONS(127),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_print] = ACTIONS(136),
    [anon_sym_assert] = ACTIONS(139),
    [anon_sym_return] = ACTIONS(142),
    [anon_sym_del] = ACTIONS(145),
    [anon_sym_raise] = ACTIONS(148),
    [anon_sym_pass] = ACTIONS(151),
    [anon_sym_break] = ACTIONS(154),
    [anon_sym_continue] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(160),
    [anon_sym_match] = ACTIONS(163),
    [anon_sym_async] = ACTIONS(166),
    [anon_sym_for] = ACTIONS(169),
    [anon_sym_while] = ACTIONS(172),
    [anon_sym_try] = ACTIONS(175),
    [anon_sym_with] = ACTIONS(178),
    [anon_sym_def] = ACTIONS(181),
    [anon_sym_global] = ACTIONS(184),
    [anon_sym_nonlocal] = ACTIONS(187),
    [anon_sym_exec] = ACTIONS(190),
    [anon_sym_type] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(196),
    [anon_sym_LBRACK] = ACTIONS(199),
    [anon_sym_AT] = ACTIONS(202),
    [anon_sym_DASH] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_PLUS] = ACTIONS(205),
    [anon_sym_not] = ACTIONS(211),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_lambda] = ACTIONS(214),
    [anon_sym_yield] = ACTIONS(217),
    [sym_ellipsis] = ACTIONS(220),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(220),
    [anon_sym_await] = ACTIONS(226),
    [sym_true] = ACTIONS(223),
    [sym_false] = ACTIONS(223),
    [sym_none] = ACTIONS(223),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(229),
    [sym_string_start] = ACTIONS(231),
  },
  [65] = {
    [sym__statement] = STATE(64),
    [sym__simple_statements] = STATE(64),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(64),
    [sym_match_statement] = STATE(64),
    [sym_for_statement] = STATE(64),
    [sym_while_statement] = STATE(64),
    [sym_try_statement] = STATE(64),
    [sym_with_statement] = STATE(64),
    [sym_function_definition] = STATE(64),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(64),
    [sym_decorated_definition] = STATE(64),
    [sym_decorator] = STATE(1816),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(64),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(234),
    [sym_string_start] = ACTIONS(81),
  },
  [66] = {
    [sym__statement] = STATE(71),
    [sym__simple_statements] = STATE(71),
    [sym_import_statement] = STATE(2262),
    [sym_future_import_statement] = STATE(2262),
    [sym_import_from_statement] = STATE(2262),
    [sym_print_statement] = STATE(2262),
    [sym_assert_statement] = STATE(2262),
    [sym_expression_statement] = STATE(2262),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2262),
    [sym_delete_statement] = STATE(2262),
    [sym_raise_statement] = STATE(2262),
    [sym_pass_statement] = STATE(2262),
    [sym_break_statement] = STATE(2262),
    [sym_continue_statement] = STATE(2262),
    [sym_if_statement] = STATE(71),
    [sym_match_statement] = STATE(71),
    [sym_for_statement] = STATE(71),
    [sym_while_statement] = STATE(71),
    [sym_try_statement] = STATE(71),
    [sym_with_statement] = STATE(71),
    [sym_function_definition] = STATE(71),
    [sym_global_statement] = STATE(2262),
    [sym_nonlocal_statement] = STATE(2262),
    [sym_exec_statement] = STATE(2262),
    [sym_type_alias_statement] = STATE(2262),
    [sym_class_definition] = STATE(71),
    [sym_decorated_definition] = STATE(71),
    [sym_decorator] = STATE(1821),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(71),
    [aux_sym_decorated_definition_repeat1] = STATE(1821),
    [ts_builtin_sym_end] = ACTIONS(236),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(35),
    [anon_sym_match] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_def] = ACTIONS(49),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(81),
  },
  [67] = {
    [sym__statement] = STATE(64),
    [sym__simple_statements] = STATE(64),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(64),
    [sym_match_statement] = STATE(64),
    [sym_for_statement] = STATE(64),
    [sym_while_statement] = STATE(64),
    [sym_try_statement] = STATE(64),
    [sym_with_statement] = STATE(64),
    [sym_function_definition] = STATE(64),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(64),
    [sym_decorated_definition] = STATE(64),
    [sym_decorator] = STATE(1816),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(64),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(238),
    [sym_string_start] = ACTIONS(81),
  },
  [68] = {
    [sym__statement] = STATE(64),
    [sym__simple_statements] = STATE(64),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(64),
    [sym_match_statement] = STATE(64),
    [sym_for_statement] = STATE(64),
    [sym_while_statement] = STATE(64),
    [sym_try_statement] = STATE(64),
    [sym_with_statement] = STATE(64),
    [sym_function_definition] = STATE(64),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(64),
    [sym_decorated_definition] = STATE(64),
    [sym_decorator] = STATE(1816),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(64),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(240),
    [sym_string_start] = ACTIONS(81),
  },
  [69] = {
    [sym__statement] = STATE(64),
    [sym__simple_statements] = STATE(64),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(64),
    [sym_match_statement] = STATE(64),
    [sym_for_statement] = STATE(64),
    [sym_while_statement] = STATE(64),
    [sym_try_statement] = STATE(64),
    [sym_with_statement] = STATE(64),
    [sym_function_definition] = STATE(64),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(64),
    [sym_decorated_definition] = STATE(64),
    [sym_decorator] = STATE(1816),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(64),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(242),
    [sym_string_start] = ACTIONS(81),
  },
  [70] = {
    [sym__statement] = STATE(64),
    [sym__simple_statements] = STATE(64),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(64),
    [sym_match_statement] = STATE(64),
    [sym_for_statement] = STATE(64),
    [sym_while_statement] = STATE(64),
    [sym_try_statement] = STATE(64),
    [sym_with_statement] = STATE(64),
    [sym_function_definition] = STATE(64),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(64),
    [sym_decorated_definition] = STATE(64),
    [sym_decorator] = STATE(1816),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(64),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(244),
    [sym_string_start] = ACTIONS(81),
  },
  [71] = {
    [sym__statement] = STATE(71),
    [sym__simple_statements] = STATE(71),
    [sym_import_statement] = STATE(2262),
    [sym_future_import_statement] = STATE(2262),
    [sym_import_from_statement] = STATE(2262),
    [sym_print_statement] = STATE(2262),
    [sym_assert_statement] = STATE(2262),
    [sym_expression_statement] = STATE(2262),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2262),
    [sym_delete_statement] = STATE(2262),
    [sym_raise_statement] = STATE(2262),
    [sym_pass_statement] = STATE(2262),
    [sym_break_statement] = STATE(2262),
    [sym_continue_statement] = STATE(2262),
    [sym_if_statement] = STATE(71),
    [sym_match_statement] = STATE(71),
    [sym_for_statement] = STATE(71),
    [sym_while_statement] = STATE(71),
    [sym_try_statement] = STATE(71),
    [sym_with_statement] = STATE(71),
    [sym_function_definition] = STATE(71),
    [sym_global_statement] = STATE(2262),
    [sym_nonlocal_statement] = STATE(2262),
    [sym_exec_statement] = STATE(2262),
    [sym_type_alias_statement] = STATE(2262),
    [sym_class_definition] = STATE(71),
    [sym_decorated_definition] = STATE(71),
    [sym_decorator] = STATE(1821),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(71),
    [aux_sym_decorated_definition_repeat1] = STATE(1821),
    [ts_builtin_sym_end] = ACTIONS(229),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_from] = ACTIONS(127),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_print] = ACTIONS(136),
    [anon_sym_assert] = ACTIONS(139),
    [anon_sym_return] = ACTIONS(142),
    [anon_sym_del] = ACTIONS(145),
    [anon_sym_raise] = ACTIONS(148),
    [anon_sym_pass] = ACTIONS(151),
    [anon_sym_break] = ACTIONS(154),
    [anon_sym_continue] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(246),
    [anon_sym_match] = ACTIONS(249),
    [anon_sym_async] = ACTIONS(252),
    [anon_sym_for] = ACTIONS(255),
    [anon_sym_while] = ACTIONS(258),
    [anon_sym_try] = ACTIONS(261),
    [anon_sym_with] = ACTIONS(264),
    [anon_sym_def] = ACTIONS(267),
    [anon_sym_global] = ACTIONS(184),
    [anon_sym_nonlocal] = ACTIONS(187),
    [anon_sym_exec] = ACTIONS(190),
    [anon_sym_type] = ACTIONS(193),
    [anon_sym_class] = ACTIONS(270),
    [anon_sym_LBRACK] = ACTIONS(199),
    [anon_sym_AT] = ACTIONS(202),
    [anon_sym_DASH] = ACTIONS(205),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_PLUS] = ACTIONS(205),
    [anon_sym_not] = ACTIONS(211),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_lambda] = ACTIONS(214),
    [anon_sym_yield] = ACTIONS(217),
    [sym_ellipsis] = ACTIONS(220),
    [sym_integer] = ACTIONS(223),
    [sym_float] = ACTIONS(220),
    [anon_sym_await] = ACTIONS(226),
    [sym_true] = ACTIONS(223),
    [sym_false] = ACTIONS(223),
    [sym_none] = ACTIONS(223),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(231),
  },
  [72] = {
    [sym__statement] = STATE(64),
    [sym__simple_statements] = STATE(64),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_if_statement] = STATE(64),
    [sym_match_statement] = STATE(64),
    [sym_for_statement] = STATE(64),
    [sym_while_statement] = STATE(64),
    [sym_try_statement] = STATE(64),
    [sym_with_statement] = STATE(64),
    [sym_function_definition] = STATE(64),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_class_definition] = STATE(64),
    [sym_decorated_definition] = STATE(64),
    [sym_decorator] = STATE(1816),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [aux_sym_module_repeat1] = STATE(64),
    [aux_sym_decorated_definition_repeat1] = STATE(1816),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_match] = ACTIONS(85),
    [anon_sym_async] = ACTIONS(87),
    [anon_sym_for] = ACTIONS(89),
    [anon_sym_while] = ACTIONS(91),
    [anon_sym_try] = ACTIONS(93),
    [anon_sym_with] = ACTIONS(95),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(273),
    [sym_string_start] = ACTIONS(81),
  },
  [73] = {
    [sym_named_expression] = STATE(1728),
    [sym__named_expression_lhs] = STATE(2677),
    [sym_list_splat_pattern] = STATE(1323),
    [sym_as_pattern] = STATE(1728),
    [sym_expression] = STATE(1780),
    [sym_primary_expression] = STATE(1008),
    [sym_not_operator] = STATE(1728),
    [sym_boolean_operator] = STATE(1728),
    [sym_binary_operator] = STATE(1282),
    [sym_unary_operator] = STATE(1282),
    [sym_comparison_operator] = STATE(1728),
    [sym_lambda] = STATE(1728),
    [sym_attribute] = STATE(1282),
    [sym_subscript] = STATE(1282),
    [sym_call] = STATE(1282),
    [sym_type] = STATE(2172),
    [sym_splat_type] = STATE(2093),
    [sym_generic_type] = STATE(2093),
    [sym_union_type] = STATE(2093),
    [sym_constrained_type] = STATE(2093),
    [sym_member_type] = STATE(2093),
    [sym_list] = STATE(1282),
    [sym_set] = STATE(1282),
    [sym_tuple] = STATE(1282),
    [sym_dictionary] = STATE(1282),
    [sym_list_comprehension] = STATE(1282),
    [sym_dictionary_comprehension] = STATE(1282),
    [sym_set_comprehension] = STATE(1282),
    [sym_generator_expression] = STATE(1282),
    [sym_parenthesized_expression] = STATE(1282),
    [sym_conditional_expression] = STATE(1728),
    [sym_concatenated_string] = STATE(1282),
    [sym_string] = STATE(1007),
    [sym_await] = STATE(1282),
    [sym_identifier] = ACTIONS(275),
    [anon_sym_SEMI] = ACTIONS(277),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(281),
    [anon_sym_COMMA] = ACTIONS(284),
    [anon_sym_as] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(287),
    [anon_sym_print] = ACTIONS(290),
    [anon_sym_GT_GT] = ACTIONS(279),
    [anon_sym_COLON_EQ] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_COLON] = ACTIONS(294),
    [anon_sym_match] = ACTIONS(290),
    [anon_sym_async] = ACTIONS(290),
    [anon_sym_in] = ACTIONS(279),
    [anon_sym_STAR_STAR] = ACTIONS(296),
    [anon_sym_exec] = ACTIONS(290),
    [anon_sym_type] = ACTIONS(299),
    [anon_sym_EQ] = ACTIONS(294),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_AT] = ACTIONS(279),
    [anon_sym_DASH] = ACTIONS(304),
    [anon_sym_PIPE] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_PLUS] = ACTIONS(304),
    [anon_sym_not] = ACTIONS(309),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(279),
    [anon_sym_SLASH_SLASH] = ACTIONS(279),
    [anon_sym_AMP] = ACTIONS(279),
    [anon_sym_CARET] = ACTIONS(279),
    [anon_sym_LT_LT] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(279),
    [anon_sym_LT_EQ] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_BANG_EQ] = ACTIONS(277),
    [anon_sym_GT_EQ] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_LT_GT] = ACTIONS(277),
    [anon_sym_is] = ACTIONS(279),
    [anon_sym_lambda] = ACTIONS(314),
    [anon_sym_PLUS_EQ] = ACTIONS(316),
    [anon_sym_DASH_EQ] = ACTIONS(316),
    [anon_sym_STAR_EQ] = ACTIONS(316),
    [anon_sym_SLASH_EQ] = ACTIONS(316),
    [anon_sym_AT_EQ] = ACTIONS(316),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(316),
    [anon_sym_PERCENT_EQ] = ACTIONS(316),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(316),
    [anon_sym_GT_GT_EQ] = ACTIONS(316),
    [anon_sym_LT_LT_EQ] = ACTIONS(316),
    [anon_sym_AMP_EQ] = ACTIONS(316),
    [anon_sym_CARET_EQ] = ACTIONS(316),
    [anon_sym_PIPE_EQ] = ACTIONS(316),
    [sym_ellipsis] = ACTIONS(318),
    [sym_integer] = ACTIONS(320),
    [sym_float] = ACTIONS(318),
    [anon_sym_await] = ACTIONS(322),
    [sym_true] = ACTIONS(320),
    [sym_false] = ACTIONS(320),
    [sym_none] = ACTIONS(320),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(277),
    [sym_string_start] = ACTIONS(324),
  },
  [74] = {
    [sym_named_expression] = STATE(1728),
    [sym__named_expression_lhs] = STATE(2677),
    [sym_list_splat_pattern] = STATE(1323),
    [sym_as_pattern] = STATE(1728),
    [sym_expression] = STATE(1780),
    [sym_primary_expression] = STATE(1008),
    [sym_not_operator] = STATE(1728),
    [sym_boolean_operator] = STATE(1728),
    [sym_binary_operator] = STATE(1282),
    [sym_unary_operator] = STATE(1282),
    [sym_comparison_operator] = STATE(1728),
    [sym_lambda] = STATE(1728),
    [sym_attribute] = STATE(1282),
    [sym_subscript] = STATE(1282),
    [sym_call] = STATE(1282),
    [sym_type] = STATE(2172),
    [sym_splat_type] = STATE(2093),
    [sym_generic_type] = STATE(2093),
    [sym_union_type] = STATE(2093),
    [sym_constrained_type] = STATE(2093),
    [sym_member_type] = STATE(2093),
    [sym_list] = STATE(1282),
    [sym_set] = STATE(1282),
    [sym_tuple] = STATE(1282),
    [sym_dictionary] = STATE(1282),
    [sym_list_comprehension] = STATE(1282),
    [sym_dictionary_comprehension] = STATE(1282),
    [sym_set_comprehension] = STATE(1282),
    [sym_generator_expression] = STATE(1282),
    [sym_parenthesized_expression] = STATE(1282),
    [sym_conditional_expression] = STATE(1728),
    [sym_concatenated_string] = STATE(1282),
    [sym_string] = STATE(1007),
    [sym_await] = STATE(1282),
    [sym_identifier] = ACTIONS(275),
    [anon_sym_SEMI] = ACTIONS(277),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(281),
    [anon_sym_COMMA] = ACTIONS(284),
    [anon_sym_as] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(287),
    [anon_sym_print] = ACTIONS(290),
    [anon_sym_GT_GT] = ACTIONS(279),
    [anon_sym_COLON_EQ] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_COLON] = ACTIONS(326),
    [anon_sym_match] = ACTIONS(290),
    [anon_sym_async] = ACTIONS(290),
    [anon_sym_in] = ACTIONS(279),
    [anon_sym_STAR_STAR] = ACTIONS(296),
    [anon_sym_exec] = ACTIONS(290),
    [anon_sym_type] = ACTIONS(299),
    [anon_sym_EQ] = ACTIONS(294),
    [anon_sym_LBRACK] = ACTIONS(301),
    [anon_sym_AT] = ACTIONS(279),
    [anon_sym_DASH] = ACTIONS(304),
    [anon_sym_PIPE] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_PLUS] = ACTIONS(304),
    [anon_sym_not] = ACTIONS(309),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(279),
    [anon_sym_SLASH_SLASH] = ACTIONS(279),
    [anon_sym_AMP] = ACTIONS(279),
    [anon_sym_CARET] = ACTIONS(279),
    [anon_sym_LT_LT] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(279),
    [anon_sym_LT_EQ] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_BANG_EQ] = ACTIONS(277),
    [anon_sym_GT_EQ] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_LT_GT] = ACTIONS(277),
    [anon_sym_is] = ACTIONS(279),
    [anon_sym_lambda] = ACTIONS(314),
    [anon_sym_PLUS_EQ] = ACTIONS(316),
    [anon_sym_DASH_EQ] = ACTIONS(316),
    [anon_sym_STAR_EQ] = ACTIONS(316),
    [anon_sym_SLASH_EQ] = ACTIONS(316),
    [anon_sym_AT_EQ] = ACTIONS(316),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(316),
    [anon_sym_PERCENT_EQ] = ACTIONS(316),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(316),
    [anon_sym_GT_GT_EQ] = ACTIONS(316),
    [anon_sym_LT_LT_EQ] = ACTIONS(316),
    [anon_sym_AMP_EQ] = ACTIONS(316),
    [anon_sym_CARET_EQ] = ACTIONS(316),
    [anon_sym_PIPE_EQ] = ACTIONS(316),
    [sym_ellipsis] = ACTIONS(318),
    [sym_integer] = ACTIONS(320),
    [sym_float] = ACTIONS(318),
    [anon_sym_await] = ACTIONS(322),
    [sym_true] = ACTIONS(320),
    [sym_false] = ACTIONS(320),
    [sym_none] = ACTIONS(320),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(277),
    [sym_string_start] = ACTIONS(324),
  },
  [75] = {
    [sym__simple_statements] = STATE(814),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(634),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1700),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(633),
    [sym_subscript] = STATE(633),
    [sym_call] = STATE(1077),
    [sym_type] = STATE(2074),
    [sym_splat_type] = STATE(2093),
    [sym_generic_type] = STATE(2093),
    [sym_union_type] = STATE(2093),
    [sym_constrained_type] = STATE(2093),
    [sym_member_type] = STATE(2093),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(331),
    [anon_sym_STAR] = ACTIONS(333),
    [anon_sym_print] = ACTIONS(335),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(337),
    [anon_sym_async] = ACTIONS(337),
    [anon_sym_STAR_STAR] = ACTIONS(339),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(341),
    [anon_sym_type] = ACTIONS(343),
    [anon_sym_LBRACK] = ACTIONS(345),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(347),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(349),
    [sym__indent] = ACTIONS(351),
    [sym_string_start] = ACTIONS(81),
  },
  [76] = {
    [sym__simple_statements] = STATE(760),
    [sym_import_statement] = STATE(2262),
    [sym_future_import_statement] = STATE(2262),
    [sym_import_from_statement] = STATE(2262),
    [sym_print_statement] = STATE(2262),
    [sym_assert_statement] = STATE(2262),
    [sym_expression_statement] = STATE(2262),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2262),
    [sym_delete_statement] = STATE(2262),
    [sym_raise_statement] = STATE(2262),
    [sym_pass_statement] = STATE(2262),
    [sym_break_statement] = STATE(2262),
    [sym_continue_statement] = STATE(2262),
    [sym_global_statement] = STATE(2262),
    [sym_nonlocal_statement] = STATE(2262),
    [sym_exec_statement] = STATE(2262),
    [sym_type_alias_statement] = STATE(2262),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(634),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1700),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(633),
    [sym_subscript] = STATE(633),
    [sym_call] = STATE(1077),
    [sym_type] = STATE(2074),
    [sym_splat_type] = STATE(2093),
    [sym_generic_type] = STATE(2093),
    [sym_union_type] = STATE(2093),
    [sym_constrained_type] = STATE(2093),
    [sym_member_type] = STATE(2093),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(331),
    [anon_sym_STAR] = ACTIONS(333),
    [anon_sym_print] = ACTIONS(335),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(337),
    [anon_sym_async] = ACTIONS(337),
    [anon_sym_STAR_STAR] = ACTIONS(339),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(341),
    [anon_sym_type] = ACTIONS(343),
    [anon_sym_LBRACK] = ACTIONS(345),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(347),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(353),
    [sym__indent] = ACTIONS(355),
    [sym_string_start] = ACTIONS(81),
  },
  [77] = {
    [sym__simple_statements] = STATE(808),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(634),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1700),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(633),
    [sym_subscript] = STATE(633),
    [sym_call] = STATE(1077),
    [sym_type] = STATE(2074),
    [sym_splat_type] = STATE(2093),
    [sym_generic_type] = STATE(2093),
    [sym_union_type] = STATE(2093),
    [sym_constrained_type] = STATE(2093),
    [sym_member_type] = STATE(2093),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(331),
    [anon_sym_STAR] = ACTIONS(333),
    [anon_sym_print] = ACTIONS(335),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(337),
    [anon_sym_async] = ACTIONS(337),
    [anon_sym_STAR_STAR] = ACTIONS(339),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(341),
    [anon_sym_type] = ACTIONS(343),
    [anon_sym_LBRACK] = ACTIONS(345),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(347),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(357),
    [sym__indent] = ACTIONS(359),
    [sym_string_start] = ACTIONS(81),
  },
  [78] = {
    [sym__simple_statements] = STATE(720),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(634),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1700),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(633),
    [sym_subscript] = STATE(633),
    [sym_call] = STATE(1077),
    [sym_type] = STATE(2074),
    [sym_splat_type] = STATE(2093),
    [sym_generic_type] = STATE(2093),
    [sym_union_type] = STATE(2093),
    [sym_constrained_type] = STATE(2093),
    [sym_member_type] = STATE(2093),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(331),
    [anon_sym_STAR] = ACTIONS(333),
    [anon_sym_print] = ACTIONS(335),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(337),
    [anon_sym_async] = ACTIONS(337),
    [anon_sym_STAR_STAR] = ACTIONS(339),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(341),
    [anon_sym_type] = ACTIONS(343),
    [anon_sym_LBRACK] = ACTIONS(345),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(347),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(361),
    [sym__indent] = ACTIONS(363),
    [sym_string_start] = ACTIONS(81),
  },
  [79] = {
    [sym__simple_statements] = STATE(729),
    [sym_import_statement] = STATE(2262),
    [sym_future_import_statement] = STATE(2262),
    [sym_import_from_statement] = STATE(2262),
    [sym_print_statement] = STATE(2262),
    [sym_assert_statement] = STATE(2262),
    [sym_expression_statement] = STATE(2262),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2262),
    [sym_delete_statement] = STATE(2262),
    [sym_raise_statement] = STATE(2262),
    [sym_pass_statement] = STATE(2262),
    [sym_break_statement] = STATE(2262),
    [sym_continue_statement] = STATE(2262),
    [sym_global_statement] = STATE(2262),
    [sym_nonlocal_statement] = STATE(2262),
    [sym_exec_statement] = STATE(2262),
    [sym_type_alias_statement] = STATE(2262),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(634),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1700),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(633),
    [sym_subscript] = STATE(633),
    [sym_call] = STATE(1077),
    [sym_type] = STATE(2074),
    [sym_splat_type] = STATE(2093),
    [sym_generic_type] = STATE(2093),
    [sym_union_type] = STATE(2093),
    [sym_constrained_type] = STATE(2093),
    [sym_member_type] = STATE(2093),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(331),
    [anon_sym_STAR] = ACTIONS(333),
    [anon_sym_print] = ACTIONS(335),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(337),
    [anon_sym_async] = ACTIONS(337),
    [anon_sym_STAR_STAR] = ACTIONS(339),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(341),
    [anon_sym_type] = ACTIONS(343),
    [anon_sym_LBRACK] = ACTIONS(345),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(347),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(365),
    [sym__indent] = ACTIONS(367),
    [sym_string_start] = ACTIONS(81),
  },
  [80] = {
    [sym__simple_statements] = STATE(764),
    [sym_import_statement] = STATE(2262),
    [sym_future_import_statement] = STATE(2262),
    [sym_import_from_statement] = STATE(2262),
    [sym_print_statement] = STATE(2262),
    [sym_assert_statement] = STATE(2262),
    [sym_expression_statement] = STATE(2262),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2262),
    [sym_delete_statement] = STATE(2262),
    [sym_raise_statement] = STATE(2262),
    [sym_pass_statement] = STATE(2262),
    [sym_break_statement] = STATE(2262),
    [sym_continue_statement] = STATE(2262),
    [sym_global_statement] = STATE(2262),
    [sym_nonlocal_statement] = STATE(2262),
    [sym_exec_statement] = STATE(2262),
    [sym_type_alias_statement] = STATE(2262),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(634),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1700),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(633),
    [sym_subscript] = STATE(633),
    [sym_call] = STATE(1077),
    [sym_type] = STATE(2074),
    [sym_splat_type] = STATE(2093),
    [sym_generic_type] = STATE(2093),
    [sym_union_type] = STATE(2093),
    [sym_constrained_type] = STATE(2093),
    [sym_member_type] = STATE(2093),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(331),
    [anon_sym_STAR] = ACTIONS(333),
    [anon_sym_print] = ACTIONS(335),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(337),
    [anon_sym_async] = ACTIONS(337),
    [anon_sym_STAR_STAR] = ACTIONS(339),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(341),
    [anon_sym_type] = ACTIONS(343),
    [anon_sym_LBRACK] = ACTIONS(345),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(347),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(369),
    [sym__indent] = ACTIONS(371),
    [sym_string_start] = ACTIONS(81),
  },
  [81] = {
    [sym__simple_statements] = STATE(786),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(634),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1700),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(633),
    [sym_subscript] = STATE(633),
    [sym_call] = STATE(1077),
    [sym_type] = STATE(2074),
    [sym_splat_type] = STATE(2093),
    [sym_generic_type] = STATE(2093),
    [sym_union_type] = STATE(2093),
    [sym_constrained_type] = STATE(2093),
    [sym_member_type] = STATE(2093),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(331),
    [anon_sym_STAR] = ACTIONS(333),
    [anon_sym_print] = ACTIONS(335),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(337),
    [anon_sym_async] = ACTIONS(337),
    [anon_sym_STAR_STAR] = ACTIONS(339),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(341),
    [anon_sym_type] = ACTIONS(343),
    [anon_sym_LBRACK] = ACTIONS(345),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(347),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(373),
    [sym__indent] = ACTIONS(375),
    [sym_string_start] = ACTIONS(81),
  },
  [82] = {
    [sym__simple_statements] = STATE(797),
    [sym_import_statement] = STATE(2262),
    [sym_future_import_statement] = STATE(2262),
    [sym_import_from_statement] = STATE(2262),
    [sym_print_statement] = STATE(2262),
    [sym_assert_statement] = STATE(2262),
    [sym_expression_statement] = STATE(2262),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2262),
    [sym_delete_statement] = STATE(2262),
    [sym_raise_statement] = STATE(2262),
    [sym_pass_statement] = STATE(2262),
    [sym_break_statement] = STATE(2262),
    [sym_continue_statement] = STATE(2262),
    [sym_global_statement] = STATE(2262),
    [sym_nonlocal_statement] = STATE(2262),
    [sym_exec_statement] = STATE(2262),
    [sym_type_alias_statement] = STATE(2262),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(634),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1700),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(633),
    [sym_subscript] = STATE(633),
    [sym_call] = STATE(1077),
    [sym_type] = STATE(2074),
    [sym_splat_type] = STATE(2093),
    [sym_generic_type] = STATE(2093),
    [sym_union_type] = STATE(2093),
    [sym_constrained_type] = STATE(2093),
    [sym_member_type] = STATE(2093),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(329),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(331),
    [anon_sym_STAR] = ACTIONS(333),
    [anon_sym_print] = ACTIONS(335),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(337),
    [anon_sym_async] = ACTIONS(337),
    [anon_sym_STAR_STAR] = ACTIONS(339),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(341),
    [anon_sym_type] = ACTIONS(343),
    [anon_sym_LBRACK] = ACTIONS(345),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(347),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(377),
    [sym__indent] = ACTIONS(379),
    [sym_string_start] = ACTIONS(81),
  },
  [83] = {
    [sym_chevron] = STATE(2211),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_list_splat_pattern] = STATE(1125),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1830),
    [sym_primary_expression] = STATE(969),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_attribute] = STATE(1077),
    [sym_subscript] = STATE(1077),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_SEMI] = ACTIONS(277),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_COMMA] = ACTIONS(284),
    [anon_sym_as] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(386),
    [anon_sym_print] = ACTIONS(389),
    [anon_sym_GT_GT] = ACTIONS(391),
    [anon_sym_COLON_EQ] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_COLON] = ACTIONS(326),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_async] = ACTIONS(389),
    [anon_sym_in] = ACTIONS(279),
    [anon_sym_STAR_STAR] = ACTIONS(279),
    [anon_sym_exec] = ACTIONS(389),
    [anon_sym_type] = ACTIONS(393),
    [anon_sym_EQ] = ACTIONS(294),
    [anon_sym_LBRACK] = ACTIONS(395),
    [anon_sym_AT] = ACTIONS(279),
    [anon_sym_DASH] = ACTIONS(398),
    [anon_sym_PIPE] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(398),
    [anon_sym_not] = ACTIONS(401),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(279),
    [anon_sym_SLASH_SLASH] = ACTIONS(279),
    [anon_sym_AMP] = ACTIONS(279),
    [anon_sym_CARET] = ACTIONS(279),
    [anon_sym_LT_LT] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(279),
    [anon_sym_LT_EQ] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_BANG_EQ] = ACTIONS(277),
    [anon_sym_GT_EQ] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_LT_GT] = ACTIONS(277),
    [anon_sym_is] = ACTIONS(279),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_PLUS_EQ] = ACTIONS(316),
    [anon_sym_DASH_EQ] = ACTIONS(316),
    [anon_sym_STAR_EQ] = ACTIONS(316),
    [anon_sym_SLASH_EQ] = ACTIONS(316),
    [anon_sym_AT_EQ] = ACTIONS(316),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(316),
    [anon_sym_PERCENT_EQ] = ACTIONS(316),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(316),
    [anon_sym_GT_GT_EQ] = ACTIONS(316),
    [anon_sym_LT_LT_EQ] = ACTIONS(316),
    [anon_sym_AMP_EQ] = ACTIONS(316),
    [anon_sym_CARET_EQ] = ACTIONS(316),
    [anon_sym_PIPE_EQ] = ACTIONS(316),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(404),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(277),
    [sym_string_start] = ACTIONS(81),
  },
  [84] = {
    [sym_chevron] = STATE(2211),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_list_splat_pattern] = STATE(1125),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1830),
    [sym_primary_expression] = STATE(969),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_attribute] = STATE(1077),
    [sym_subscript] = STATE(1077),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(381),
    [anon_sym_SEMI] = ACTIONS(277),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_COMMA] = ACTIONS(284),
    [anon_sym_as] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(386),
    [anon_sym_print] = ACTIONS(389),
    [anon_sym_GT_GT] = ACTIONS(391),
    [anon_sym_COLON_EQ] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_COLON] = ACTIONS(294),
    [anon_sym_match] = ACTIONS(389),
    [anon_sym_async] = ACTIONS(389),
    [anon_sym_in] = ACTIONS(279),
    [anon_sym_STAR_STAR] = ACTIONS(279),
    [anon_sym_exec] = ACTIONS(389),
    [anon_sym_type] = ACTIONS(393),
    [anon_sym_EQ] = ACTIONS(294),
    [anon_sym_LBRACK] = ACTIONS(395),
    [anon_sym_AT] = ACTIONS(279),
    [anon_sym_DASH] = ACTIONS(398),
    [anon_sym_PIPE] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(398),
    [anon_sym_not] = ACTIONS(401),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(279),
    [anon_sym_SLASH_SLASH] = ACTIONS(279),
    [anon_sym_AMP] = ACTIONS(279),
    [anon_sym_CARET] = ACTIONS(279),
    [anon_sym_LT_LT] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(279),
    [anon_sym_LT_EQ] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_BANG_EQ] = ACTIONS(277),
    [anon_sym_GT_EQ] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_LT_GT] = ACTIONS(277),
    [anon_sym_is] = ACTIONS(279),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_PLUS_EQ] = ACTIONS(316),
    [anon_sym_DASH_EQ] = ACTIONS(316),
    [anon_sym_STAR_EQ] = ACTIONS(316),
    [anon_sym_SLASH_EQ] = ACTIONS(316),
    [anon_sym_AT_EQ] = ACTIONS(316),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(316),
    [anon_sym_PERCENT_EQ] = ACTIONS(316),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(316),
    [anon_sym_GT_GT_EQ] = ACTIONS(316),
    [anon_sym_LT_LT_EQ] = ACTIONS(316),
    [anon_sym_AMP_EQ] = ACTIONS(316),
    [anon_sym_CARET_EQ] = ACTIONS(316),
    [anon_sym_PIPE_EQ] = ACTIONS(316),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(404),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(277),
    [sym_string_start] = ACTIONS(81),
  },
  [85] = {
    [sym_named_expression] = STATE(1728),
    [sym__named_expression_lhs] = STATE(2677),
    [sym_list_splat_pattern] = STATE(1323),
    [sym_as_pattern] = STATE(1728),
    [sym_expression] = STATE(1888),
    [sym_primary_expression] = STATE(1008),
    [sym_not_operator] = STATE(1728),
    [sym_boolean_operator] = STATE(1728),
    [sym_binary_operator] = STATE(1282),
    [sym_unary_operator] = STATE(1282),
    [sym_comparison_operator] = STATE(1728),
    [sym_lambda] = STATE(1728),
    [sym_attribute] = STATE(1282),
    [sym_subscript] = STATE(1282),
    [sym_call] = STATE(1282),
    [sym_list] = STATE(1282),
    [sym_set] = STATE(1282),
    [sym_tuple] = STATE(1282),
    [sym_dictionary] = STATE(1282),
    [sym_list_comprehension] = STATE(1282),
    [sym_dictionary_comprehension] = STATE(1282),
    [sym_set_comprehension] = STATE(1282),
    [sym_generator_expression] = STATE(1282),
    [sym_parenthesized_expression] = STATE(1282),
    [sym_conditional_expression] = STATE(1728),
    [sym_concatenated_string] = STATE(1282),
    [sym_string] = STATE(1007),
    [sym_await] = STATE(1282),
    [sym_identifier] = ACTIONS(406),
    [anon_sym_SEMI] = ACTIONS(277),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(408),
    [anon_sym_COMMA] = ACTIONS(284),
    [anon_sym_as] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(410),
    [anon_sym_print] = ACTIONS(290),
    [anon_sym_GT_GT] = ACTIONS(279),
    [anon_sym_COLON_EQ] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_COLON] = ACTIONS(294),
    [anon_sym_match] = ACTIONS(290),
    [anon_sym_async] = ACTIONS(290),
    [anon_sym_in] = ACTIONS(279),
    [anon_sym_STAR_STAR] = ACTIONS(279),
    [anon_sym_exec] = ACTIONS(290),
    [anon_sym_type] = ACTIONS(299),
    [anon_sym_EQ] = ACTIONS(294),
    [anon_sym_LBRACK] = ACTIONS(412),
    [anon_sym_AT] = ACTIONS(279),
    [anon_sym_DASH] = ACTIONS(414),
    [anon_sym_PIPE] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_PLUS] = ACTIONS(414),
    [anon_sym_not] = ACTIONS(416),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(279),
    [anon_sym_SLASH_SLASH] = ACTIONS(279),
    [anon_sym_AMP] = ACTIONS(279),
    [anon_sym_CARET] = ACTIONS(279),
    [anon_sym_LT_LT] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(279),
    [anon_sym_LT_EQ] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_BANG_EQ] = ACTIONS(277),
    [anon_sym_GT_EQ] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_LT_GT] = ACTIONS(277),
    [anon_sym_is] = ACTIONS(279),
    [anon_sym_lambda] = ACTIONS(314),
    [anon_sym_PLUS_EQ] = ACTIONS(316),
    [anon_sym_DASH_EQ] = ACTIONS(316),
    [anon_sym_STAR_EQ] = ACTIONS(316),
    [anon_sym_SLASH_EQ] = ACTIONS(316),
    [anon_sym_AT_EQ] = ACTIONS(316),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(316),
    [anon_sym_PERCENT_EQ] = ACTIONS(316),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(316),
    [anon_sym_GT_GT_EQ] = ACTIONS(316),
    [anon_sym_LT_LT_EQ] = ACTIONS(316),
    [anon_sym_AMP_EQ] = ACTIONS(316),
    [anon_sym_CARET_EQ] = ACTIONS(316),
    [anon_sym_PIPE_EQ] = ACTIONS(316),
    [sym_ellipsis] = ACTIONS(318),
    [sym_integer] = ACTIONS(320),
    [sym_float] = ACTIONS(318),
    [anon_sym_await] = ACTIONS(322),
    [sym_true] = ACTIONS(320),
    [sym_false] = ACTIONS(320),
    [sym_none] = ACTIONS(320),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(277),
    [sym_string_start] = ACTIONS(324),
  },
  [86] = {
    [sym_named_expression] = STATE(1728),
    [sym__named_expression_lhs] = STATE(2677),
    [sym_list_splat_pattern] = STATE(1323),
    [sym_as_pattern] = STATE(1728),
    [sym_expression] = STATE(1885),
    [sym_primary_expression] = STATE(1008),
    [sym_not_operator] = STATE(1728),
    [sym_boolean_operator] = STATE(1728),
    [sym_binary_operator] = STATE(1282),
    [sym_unary_operator] = STATE(1282),
    [sym_comparison_operator] = STATE(1728),
    [sym_lambda] = STATE(1728),
    [sym_attribute] = STATE(1282),
    [sym_subscript] = STATE(1282),
    [sym_call] = STATE(1282),
    [sym_list] = STATE(1282),
    [sym_set] = STATE(1282),
    [sym_tuple] = STATE(1282),
    [sym_dictionary] = STATE(1282),
    [sym_list_comprehension] = STATE(1282),
    [sym_dictionary_comprehension] = STATE(1282),
    [sym_set_comprehension] = STATE(1282),
    [sym_generator_expression] = STATE(1282),
    [sym_parenthesized_expression] = STATE(1282),
    [sym_conditional_expression] = STATE(1728),
    [sym_concatenated_string] = STATE(1282),
    [sym_string] = STATE(1007),
    [sym_await] = STATE(1282),
    [sym_identifier] = ACTIONS(406),
    [anon_sym_SEMI] = ACTIONS(277),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(408),
    [anon_sym_COMMA] = ACTIONS(284),
    [anon_sym_as] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(410),
    [anon_sym_print] = ACTIONS(290),
    [anon_sym_GT_GT] = ACTIONS(279),
    [anon_sym_COLON_EQ] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_COLON] = ACTIONS(294),
    [anon_sym_match] = ACTIONS(290),
    [anon_sym_async] = ACTIONS(290),
    [anon_sym_in] = ACTIONS(279),
    [anon_sym_STAR_STAR] = ACTIONS(279),
    [anon_sym_exec] = ACTIONS(290),
    [anon_sym_type] = ACTIONS(299),
    [anon_sym_EQ] = ACTIONS(294),
    [anon_sym_LBRACK] = ACTIONS(412),
    [anon_sym_AT] = ACTIONS(279),
    [anon_sym_DASH] = ACTIONS(414),
    [anon_sym_PIPE] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_PLUS] = ACTIONS(414),
    [anon_sym_not] = ACTIONS(416),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(279),
    [anon_sym_SLASH_SLASH] = ACTIONS(279),
    [anon_sym_AMP] = ACTIONS(279),
    [anon_sym_CARET] = ACTIONS(279),
    [anon_sym_LT_LT] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(279),
    [anon_sym_LT_EQ] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_BANG_EQ] = ACTIONS(277),
    [anon_sym_GT_EQ] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_LT_GT] = ACTIONS(277),
    [anon_sym_is] = ACTIONS(279),
    [anon_sym_lambda] = ACTIONS(314),
    [anon_sym_PLUS_EQ] = ACTIONS(316),
    [anon_sym_DASH_EQ] = ACTIONS(316),
    [anon_sym_STAR_EQ] = ACTIONS(316),
    [anon_sym_SLASH_EQ] = ACTIONS(316),
    [anon_sym_AT_EQ] = ACTIONS(316),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(316),
    [anon_sym_PERCENT_EQ] = ACTIONS(316),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(316),
    [anon_sym_GT_GT_EQ] = ACTIONS(316),
    [anon_sym_LT_LT_EQ] = ACTIONS(316),
    [anon_sym_AMP_EQ] = ACTIONS(316),
    [anon_sym_CARET_EQ] = ACTIONS(316),
    [anon_sym_PIPE_EQ] = ACTIONS(316),
    [sym_ellipsis] = ACTIONS(318),
    [sym_integer] = ACTIONS(320),
    [sym_float] = ACTIONS(318),
    [anon_sym_await] = ACTIONS(322),
    [sym_true] = ACTIONS(320),
    [sym_false] = ACTIONS(320),
    [sym_none] = ACTIONS(320),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(277),
    [sym_string_start] = ACTIONS(324),
  },
  [87] = {
    [sym__simple_statements] = STATE(658),
    [sym_import_statement] = STATE(2471),
    [sym_future_import_statement] = STATE(2471),
    [sym_import_from_statement] = STATE(2471),
    [sym_print_statement] = STATE(2471),
    [sym_assert_statement] = STATE(2471),
    [sym_expression_statement] = STATE(2471),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2471),
    [sym_delete_statement] = STATE(2471),
    [sym_raise_statement] = STATE(2471),
    [sym_pass_statement] = STATE(2471),
    [sym_break_statement] = STATE(2471),
    [sym_continue_statement] = STATE(2471),
    [sym_global_statement] = STATE(2471),
    [sym_nonlocal_statement] = STATE(2471),
    [sym_exec_statement] = STATE(2471),
    [sym_type_alias_statement] = STATE(2471),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(420),
    [sym__indent] = ACTIONS(422),
    [sym_string_start] = ACTIONS(81),
  },
  [88] = {
    [sym__simple_statements] = STATE(738),
    [sym_import_statement] = STATE(2262),
    [sym_future_import_statement] = STATE(2262),
    [sym_import_from_statement] = STATE(2262),
    [sym_print_statement] = STATE(2262),
    [sym_assert_statement] = STATE(2262),
    [sym_expression_statement] = STATE(2262),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2262),
    [sym_delete_statement] = STATE(2262),
    [sym_raise_statement] = STATE(2262),
    [sym_pass_statement] = STATE(2262),
    [sym_break_statement] = STATE(2262),
    [sym_continue_statement] = STATE(2262),
    [sym_global_statement] = STATE(2262),
    [sym_nonlocal_statement] = STATE(2262),
    [sym_exec_statement] = STATE(2262),
    [sym_type_alias_statement] = STATE(2262),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(424),
    [sym__indent] = ACTIONS(426),
    [sym_string_start] = ACTIONS(81),
  },
  [89] = {
    [sym__simple_statements] = STATE(710),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(428),
    [sym__indent] = ACTIONS(430),
    [sym_string_start] = ACTIONS(81),
  },
  [90] = {
    [sym__simple_statements] = STATE(606),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(432),
    [sym__indent] = ACTIONS(434),
    [sym_string_start] = ACTIONS(81),
  },
  [91] = {
    [sym__simple_statements] = STATE(712),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(436),
    [sym__indent] = ACTIONS(438),
    [sym_string_start] = ACTIONS(81),
  },
  [92] = {
    [sym__simple_statements] = STATE(742),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(440),
    [sym__indent] = ACTIONS(442),
    [sym_string_start] = ACTIONS(81),
  },
  [93] = {
    [sym__simple_statements] = STATE(838),
    [sym_import_statement] = STATE(2262),
    [sym_future_import_statement] = STATE(2262),
    [sym_import_from_statement] = STATE(2262),
    [sym_print_statement] = STATE(2262),
    [sym_assert_statement] = STATE(2262),
    [sym_expression_statement] = STATE(2262),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2262),
    [sym_delete_statement] = STATE(2262),
    [sym_raise_statement] = STATE(2262),
    [sym_pass_statement] = STATE(2262),
    [sym_break_statement] = STATE(2262),
    [sym_continue_statement] = STATE(2262),
    [sym_global_statement] = STATE(2262),
    [sym_nonlocal_statement] = STATE(2262),
    [sym_exec_statement] = STATE(2262),
    [sym_type_alias_statement] = STATE(2262),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(444),
    [sym__indent] = ACTIONS(446),
    [sym_string_start] = ACTIONS(81),
  },
  [94] = {
    [sym__simple_statements] = STATE(746),
    [sym_import_statement] = STATE(2262),
    [sym_future_import_statement] = STATE(2262),
    [sym_import_from_statement] = STATE(2262),
    [sym_print_statement] = STATE(2262),
    [sym_assert_statement] = STATE(2262),
    [sym_expression_statement] = STATE(2262),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2262),
    [sym_delete_statement] = STATE(2262),
    [sym_raise_statement] = STATE(2262),
    [sym_pass_statement] = STATE(2262),
    [sym_break_statement] = STATE(2262),
    [sym_continue_statement] = STATE(2262),
    [sym_global_statement] = STATE(2262),
    [sym_nonlocal_statement] = STATE(2262),
    [sym_exec_statement] = STATE(2262),
    [sym_type_alias_statement] = STATE(2262),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(448),
    [sym__indent] = ACTIONS(450),
    [sym_string_start] = ACTIONS(81),
  },
  [95] = {
    [sym__simple_statements] = STATE(614),
    [sym_import_statement] = STATE(2262),
    [sym_future_import_statement] = STATE(2262),
    [sym_import_from_statement] = STATE(2262),
    [sym_print_statement] = STATE(2262),
    [sym_assert_statement] = STATE(2262),
    [sym_expression_statement] = STATE(2262),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2262),
    [sym_delete_statement] = STATE(2262),
    [sym_raise_statement] = STATE(2262),
    [sym_pass_statement] = STATE(2262),
    [sym_break_statement] = STATE(2262),
    [sym_continue_statement] = STATE(2262),
    [sym_global_statement] = STATE(2262),
    [sym_nonlocal_statement] = STATE(2262),
    [sym_exec_statement] = STATE(2262),
    [sym_type_alias_statement] = STATE(2262),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(452),
    [sym__indent] = ACTIONS(454),
    [sym_string_start] = ACTIONS(81),
  },
  [96] = {
    [sym__simple_statements] = STATE(743),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(456),
    [sym__indent] = ACTIONS(458),
    [sym_string_start] = ACTIONS(81),
  },
  [97] = {
    [sym__simple_statements] = STATE(700),
    [sym_import_statement] = STATE(2262),
    [sym_future_import_statement] = STATE(2262),
    [sym_import_from_statement] = STATE(2262),
    [sym_print_statement] = STATE(2262),
    [sym_assert_statement] = STATE(2262),
    [sym_expression_statement] = STATE(2262),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2262),
    [sym_delete_statement] = STATE(2262),
    [sym_raise_statement] = STATE(2262),
    [sym_pass_statement] = STATE(2262),
    [sym_break_statement] = STATE(2262),
    [sym_continue_statement] = STATE(2262),
    [sym_global_statement] = STATE(2262),
    [sym_nonlocal_statement] = STATE(2262),
    [sym_exec_statement] = STATE(2262),
    [sym_type_alias_statement] = STATE(2262),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(460),
    [sym__indent] = ACTIONS(462),
    [sym_string_start] = ACTIONS(81),
  },
  [98] = {
    [sym__simple_statements] = STATE(695),
    [sym_import_statement] = STATE(2262),
    [sym_future_import_statement] = STATE(2262),
    [sym_import_from_statement] = STATE(2262),
    [sym_print_statement] = STATE(2262),
    [sym_assert_statement] = STATE(2262),
    [sym_expression_statement] = STATE(2262),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2262),
    [sym_delete_statement] = STATE(2262),
    [sym_raise_statement] = STATE(2262),
    [sym_pass_statement] = STATE(2262),
    [sym_break_statement] = STATE(2262),
    [sym_continue_statement] = STATE(2262),
    [sym_global_statement] = STATE(2262),
    [sym_nonlocal_statement] = STATE(2262),
    [sym_exec_statement] = STATE(2262),
    [sym_type_alias_statement] = STATE(2262),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(464),
    [sym__indent] = ACTIONS(466),
    [sym_string_start] = ACTIONS(81),
  },
  [99] = {
    [sym__simple_statements] = STATE(680),
    [sym_import_statement] = STATE(2355),
    [sym_future_import_statement] = STATE(2355),
    [sym_import_from_statement] = STATE(2355),
    [sym_print_statement] = STATE(2355),
    [sym_assert_statement] = STATE(2355),
    [sym_expression_statement] = STATE(2355),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2355),
    [sym_delete_statement] = STATE(2355),
    [sym_raise_statement] = STATE(2355),
    [sym_pass_statement] = STATE(2355),
    [sym_break_statement] = STATE(2355),
    [sym_continue_statement] = STATE(2355),
    [sym_global_statement] = STATE(2355),
    [sym_nonlocal_statement] = STATE(2355),
    [sym_exec_statement] = STATE(2355),
    [sym_type_alias_statement] = STATE(2355),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(468),
    [sym__indent] = ACTIONS(470),
    [sym_string_start] = ACTIONS(81),
  },
  [100] = {
    [sym__simple_statements] = STATE(711),
    [sym_import_statement] = STATE(2262),
    [sym_future_import_statement] = STATE(2262),
    [sym_import_from_statement] = STATE(2262),
    [sym_print_statement] = STATE(2262),
    [sym_assert_statement] = STATE(2262),
    [sym_expression_statement] = STATE(2262),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2262),
    [sym_delete_statement] = STATE(2262),
    [sym_raise_statement] = STATE(2262),
    [sym_pass_statement] = STATE(2262),
    [sym_break_statement] = STATE(2262),
    [sym_continue_statement] = STATE(2262),
    [sym_global_statement] = STATE(2262),
    [sym_nonlocal_statement] = STATE(2262),
    [sym_exec_statement] = STATE(2262),
    [sym_type_alias_statement] = STATE(2262),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(472),
    [sym__indent] = ACTIONS(474),
    [sym_string_start] = ACTIONS(81),
  },
  [101] = {
    [sym__simple_statements] = STATE(827),
    [sym_import_statement] = STATE(2262),
    [sym_future_import_statement] = STATE(2262),
    [sym_import_from_statement] = STATE(2262),
    [sym_print_statement] = STATE(2262),
    [sym_assert_statement] = STATE(2262),
    [sym_expression_statement] = STATE(2262),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2262),
    [sym_delete_statement] = STATE(2262),
    [sym_raise_statement] = STATE(2262),
    [sym_pass_statement] = STATE(2262),
    [sym_break_statement] = STATE(2262),
    [sym_continue_statement] = STATE(2262),
    [sym_global_statement] = STATE(2262),
    [sym_nonlocal_statement] = STATE(2262),
    [sym_exec_statement] = STATE(2262),
    [sym_type_alias_statement] = STATE(2262),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(476),
    [sym__indent] = ACTIONS(478),
    [sym_string_start] = ACTIONS(81),
  },
  [102] = {
    [sym__simple_statements] = STATE(721),
    [sym_import_statement] = STATE(2262),
    [sym_future_import_statement] = STATE(2262),
    [sym_import_from_statement] = STATE(2262),
    [sym_print_statement] = STATE(2262),
    [sym_assert_statement] = STATE(2262),
    [sym_expression_statement] = STATE(2262),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2262),
    [sym_delete_statement] = STATE(2262),
    [sym_raise_statement] = STATE(2262),
    [sym_pass_statement] = STATE(2262),
    [sym_break_statement] = STATE(2262),
    [sym_continue_statement] = STATE(2262),
    [sym_global_statement] = STATE(2262),
    [sym_nonlocal_statement] = STATE(2262),
    [sym_exec_statement] = STATE(2262),
    [sym_type_alias_statement] = STATE(2262),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(480),
    [sym__indent] = ACTIONS(482),
    [sym_string_start] = ACTIONS(81),
  },
  [103] = {
    [sym__simple_statements] = STATE(2552),
    [sym_import_statement] = STATE(2510),
    [sym_future_import_statement] = STATE(2510),
    [sym_import_from_statement] = STATE(2510),
    [sym_print_statement] = STATE(2510),
    [sym_assert_statement] = STATE(2510),
    [sym_expression_statement] = STATE(2510),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2510),
    [sym_delete_statement] = STATE(2510),
    [sym_raise_statement] = STATE(2510),
    [sym_pass_statement] = STATE(2510),
    [sym_break_statement] = STATE(2510),
    [sym_continue_statement] = STATE(2510),
    [sym_global_statement] = STATE(2510),
    [sym_nonlocal_statement] = STATE(2510),
    [sym_exec_statement] = STATE(2510),
    [sym_type_alias_statement] = STATE(2510),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(484),
    [sym__indent] = ACTIONS(486),
    [sym_string_start] = ACTIONS(81),
  },
  [104] = {
    [sym__simple_statements] = STATE(1842),
    [sym_import_statement] = STATE(2475),
    [sym_future_import_statement] = STATE(2475),
    [sym_import_from_statement] = STATE(2475),
    [sym_print_statement] = STATE(2475),
    [sym_assert_statement] = STATE(2475),
    [sym_expression_statement] = STATE(2475),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2475),
    [sym_delete_statement] = STATE(2475),
    [sym_raise_statement] = STATE(2475),
    [sym_pass_statement] = STATE(2475),
    [sym_break_statement] = STATE(2475),
    [sym_continue_statement] = STATE(2475),
    [sym_global_statement] = STATE(2475),
    [sym_nonlocal_statement] = STATE(2475),
    [sym_exec_statement] = STATE(2475),
    [sym_type_alias_statement] = STATE(2475),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(488),
    [sym__indent] = ACTIONS(490),
    [sym_string_start] = ACTIONS(81),
  },
  [105] = {
    [sym__simple_statements] = STATE(2554),
    [sym_import_statement] = STATE(2510),
    [sym_future_import_statement] = STATE(2510),
    [sym_import_from_statement] = STATE(2510),
    [sym_print_statement] = STATE(2510),
    [sym_assert_statement] = STATE(2510),
    [sym_expression_statement] = STATE(2510),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2510),
    [sym_delete_statement] = STATE(2510),
    [sym_raise_statement] = STATE(2510),
    [sym_pass_statement] = STATE(2510),
    [sym_break_statement] = STATE(2510),
    [sym_continue_statement] = STATE(2510),
    [sym_global_statement] = STATE(2510),
    [sym_nonlocal_statement] = STATE(2510),
    [sym_exec_statement] = STATE(2510),
    [sym_type_alias_statement] = STATE(2510),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(492),
    [sym__indent] = ACTIONS(494),
    [sym_string_start] = ACTIONS(81),
  },
  [106] = {
    [sym__simple_statements] = STATE(752),
    [sym_import_statement] = STATE(2262),
    [sym_future_import_statement] = STATE(2262),
    [sym_import_from_statement] = STATE(2262),
    [sym_print_statement] = STATE(2262),
    [sym_assert_statement] = STATE(2262),
    [sym_expression_statement] = STATE(2262),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2262),
    [sym_delete_statement] = STATE(2262),
    [sym_raise_statement] = STATE(2262),
    [sym_pass_statement] = STATE(2262),
    [sym_break_statement] = STATE(2262),
    [sym_continue_statement] = STATE(2262),
    [sym_global_statement] = STATE(2262),
    [sym_nonlocal_statement] = STATE(2262),
    [sym_exec_statement] = STATE(2262),
    [sym_type_alias_statement] = STATE(2262),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(496),
    [sym__indent] = ACTIONS(498),
    [sym_string_start] = ACTIONS(81),
  },
  [107] = {
    [sym__simple_statements] = STATE(770),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(500),
    [sym__indent] = ACTIONS(502),
    [sym_string_start] = ACTIONS(81),
  },
  [108] = {
    [sym__simple_statements] = STATE(683),
    [sym_import_statement] = STATE(2355),
    [sym_future_import_statement] = STATE(2355),
    [sym_import_from_statement] = STATE(2355),
    [sym_print_statement] = STATE(2355),
    [sym_assert_statement] = STATE(2355),
    [sym_expression_statement] = STATE(2355),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2355),
    [sym_delete_statement] = STATE(2355),
    [sym_raise_statement] = STATE(2355),
    [sym_pass_statement] = STATE(2355),
    [sym_break_statement] = STATE(2355),
    [sym_continue_statement] = STATE(2355),
    [sym_global_statement] = STATE(2355),
    [sym_nonlocal_statement] = STATE(2355),
    [sym_exec_statement] = STATE(2355),
    [sym_type_alias_statement] = STATE(2355),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(504),
    [sym__indent] = ACTIONS(506),
    [sym_string_start] = ACTIONS(81),
  },
  [109] = {
    [sym__simple_statements] = STATE(777),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(508),
    [sym__indent] = ACTIONS(510),
    [sym_string_start] = ACTIONS(81),
  },
  [110] = {
    [sym__simple_statements] = STATE(745),
    [sym_import_statement] = STATE(2262),
    [sym_future_import_statement] = STATE(2262),
    [sym_import_from_statement] = STATE(2262),
    [sym_print_statement] = STATE(2262),
    [sym_assert_statement] = STATE(2262),
    [sym_expression_statement] = STATE(2262),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2262),
    [sym_delete_statement] = STATE(2262),
    [sym_raise_statement] = STATE(2262),
    [sym_pass_statement] = STATE(2262),
    [sym_break_statement] = STATE(2262),
    [sym_continue_statement] = STATE(2262),
    [sym_global_statement] = STATE(2262),
    [sym_nonlocal_statement] = STATE(2262),
    [sym_exec_statement] = STATE(2262),
    [sym_type_alias_statement] = STATE(2262),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(512),
    [sym__indent] = ACTIONS(514),
    [sym_string_start] = ACTIONS(81),
  },
  [111] = {
    [sym__simple_statements] = STATE(1823),
    [sym_import_statement] = STATE(2475),
    [sym_future_import_statement] = STATE(2475),
    [sym_import_from_statement] = STATE(2475),
    [sym_print_statement] = STATE(2475),
    [sym_assert_statement] = STATE(2475),
    [sym_expression_statement] = STATE(2475),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2475),
    [sym_delete_statement] = STATE(2475),
    [sym_raise_statement] = STATE(2475),
    [sym_pass_statement] = STATE(2475),
    [sym_break_statement] = STATE(2475),
    [sym_continue_statement] = STATE(2475),
    [sym_global_statement] = STATE(2475),
    [sym_nonlocal_statement] = STATE(2475),
    [sym_exec_statement] = STATE(2475),
    [sym_type_alias_statement] = STATE(2475),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(516),
    [sym__indent] = ACTIONS(518),
    [sym_string_start] = ACTIONS(81),
  },
  [112] = {
    [sym__simple_statements] = STATE(779),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(520),
    [sym__indent] = ACTIONS(522),
    [sym_string_start] = ACTIONS(81),
  },
  [113] = {
    [sym__simple_statements] = STATE(782),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(524),
    [sym__indent] = ACTIONS(526),
    [sym_string_start] = ACTIONS(81),
  },
  [114] = {
    [sym__simple_statements] = STATE(653),
    [sym_import_statement] = STATE(2355),
    [sym_future_import_statement] = STATE(2355),
    [sym_import_from_statement] = STATE(2355),
    [sym_print_statement] = STATE(2355),
    [sym_assert_statement] = STATE(2355),
    [sym_expression_statement] = STATE(2355),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2355),
    [sym_delete_statement] = STATE(2355),
    [sym_raise_statement] = STATE(2355),
    [sym_pass_statement] = STATE(2355),
    [sym_break_statement] = STATE(2355),
    [sym_continue_statement] = STATE(2355),
    [sym_global_statement] = STATE(2355),
    [sym_nonlocal_statement] = STATE(2355),
    [sym_exec_statement] = STATE(2355),
    [sym_type_alias_statement] = STATE(2355),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(528),
    [sym__indent] = ACTIONS(530),
    [sym_string_start] = ACTIONS(81),
  },
  [115] = {
    [sym__simple_statements] = STATE(800),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(532),
    [sym__indent] = ACTIONS(534),
    [sym_string_start] = ACTIONS(81),
  },
  [116] = {
    [sym__simple_statements] = STATE(719),
    [sym_import_statement] = STATE(2262),
    [sym_future_import_statement] = STATE(2262),
    [sym_import_from_statement] = STATE(2262),
    [sym_print_statement] = STATE(2262),
    [sym_assert_statement] = STATE(2262),
    [sym_expression_statement] = STATE(2262),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2262),
    [sym_delete_statement] = STATE(2262),
    [sym_raise_statement] = STATE(2262),
    [sym_pass_statement] = STATE(2262),
    [sym_break_statement] = STATE(2262),
    [sym_continue_statement] = STATE(2262),
    [sym_global_statement] = STATE(2262),
    [sym_nonlocal_statement] = STATE(2262),
    [sym_exec_statement] = STATE(2262),
    [sym_type_alias_statement] = STATE(2262),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(536),
    [sym__indent] = ACTIONS(538),
    [sym_string_start] = ACTIONS(81),
  },
  [117] = {
    [sym__simple_statements] = STATE(709),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(540),
    [sym__indent] = ACTIONS(542),
    [sym_string_start] = ACTIONS(81),
  },
  [118] = {
    [sym__simple_statements] = STATE(640),
    [sym_import_statement] = STATE(2450),
    [sym_future_import_statement] = STATE(2450),
    [sym_import_from_statement] = STATE(2450),
    [sym_print_statement] = STATE(2450),
    [sym_assert_statement] = STATE(2450),
    [sym_expression_statement] = STATE(2450),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2450),
    [sym_delete_statement] = STATE(2450),
    [sym_raise_statement] = STATE(2450),
    [sym_pass_statement] = STATE(2450),
    [sym_break_statement] = STATE(2450),
    [sym_continue_statement] = STATE(2450),
    [sym_global_statement] = STATE(2450),
    [sym_nonlocal_statement] = STATE(2450),
    [sym_exec_statement] = STATE(2450),
    [sym_type_alias_statement] = STATE(2450),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(544),
    [sym__indent] = ACTIONS(546),
    [sym_string_start] = ACTIONS(81),
  },
  [119] = {
    [sym__simple_statements] = STATE(669),
    [sym_import_statement] = STATE(2424),
    [sym_future_import_statement] = STATE(2424),
    [sym_import_from_statement] = STATE(2424),
    [sym_print_statement] = STATE(2424),
    [sym_assert_statement] = STATE(2424),
    [sym_expression_statement] = STATE(2424),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2424),
    [sym_delete_statement] = STATE(2424),
    [sym_raise_statement] = STATE(2424),
    [sym_pass_statement] = STATE(2424),
    [sym_break_statement] = STATE(2424),
    [sym_continue_statement] = STATE(2424),
    [sym_global_statement] = STATE(2424),
    [sym_nonlocal_statement] = STATE(2424),
    [sym_exec_statement] = STATE(2424),
    [sym_type_alias_statement] = STATE(2424),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(548),
    [sym__indent] = ACTIONS(550),
    [sym_string_start] = ACTIONS(81),
  },
  [120] = {
    [sym__simple_statements] = STATE(671),
    [sym_import_statement] = STATE(2471),
    [sym_future_import_statement] = STATE(2471),
    [sym_import_from_statement] = STATE(2471),
    [sym_print_statement] = STATE(2471),
    [sym_assert_statement] = STATE(2471),
    [sym_expression_statement] = STATE(2471),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2471),
    [sym_delete_statement] = STATE(2471),
    [sym_raise_statement] = STATE(2471),
    [sym_pass_statement] = STATE(2471),
    [sym_break_statement] = STATE(2471),
    [sym_continue_statement] = STATE(2471),
    [sym_global_statement] = STATE(2471),
    [sym_nonlocal_statement] = STATE(2471),
    [sym_exec_statement] = STATE(2471),
    [sym_type_alias_statement] = STATE(2471),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(552),
    [sym__indent] = ACTIONS(554),
    [sym_string_start] = ACTIONS(81),
  },
  [121] = {
    [sym__simple_statements] = STATE(758),
    [sym_import_statement] = STATE(2262),
    [sym_future_import_statement] = STATE(2262),
    [sym_import_from_statement] = STATE(2262),
    [sym_print_statement] = STATE(2262),
    [sym_assert_statement] = STATE(2262),
    [sym_expression_statement] = STATE(2262),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2262),
    [sym_delete_statement] = STATE(2262),
    [sym_raise_statement] = STATE(2262),
    [sym_pass_statement] = STATE(2262),
    [sym_break_statement] = STATE(2262),
    [sym_continue_statement] = STATE(2262),
    [sym_global_statement] = STATE(2262),
    [sym_nonlocal_statement] = STATE(2262),
    [sym_exec_statement] = STATE(2262),
    [sym_type_alias_statement] = STATE(2262),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(556),
    [sym__indent] = ACTIONS(558),
    [sym_string_start] = ACTIONS(81),
  },
  [122] = {
    [sym__simple_statements] = STATE(817),
    [sym_import_statement] = STATE(2262),
    [sym_future_import_statement] = STATE(2262),
    [sym_import_from_statement] = STATE(2262),
    [sym_print_statement] = STATE(2262),
    [sym_assert_statement] = STATE(2262),
    [sym_expression_statement] = STATE(2262),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2262),
    [sym_delete_statement] = STATE(2262),
    [sym_raise_statement] = STATE(2262),
    [sym_pass_statement] = STATE(2262),
    [sym_break_statement] = STATE(2262),
    [sym_continue_statement] = STATE(2262),
    [sym_global_statement] = STATE(2262),
    [sym_nonlocal_statement] = STATE(2262),
    [sym_exec_statement] = STATE(2262),
    [sym_type_alias_statement] = STATE(2262),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(560),
    [sym__indent] = ACTIONS(562),
    [sym_string_start] = ACTIONS(81),
  },
  [123] = {
    [sym__simple_statements] = STATE(715),
    [sym_import_statement] = STATE(2262),
    [sym_future_import_statement] = STATE(2262),
    [sym_import_from_statement] = STATE(2262),
    [sym_print_statement] = STATE(2262),
    [sym_assert_statement] = STATE(2262),
    [sym_expression_statement] = STATE(2262),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2262),
    [sym_delete_statement] = STATE(2262),
    [sym_raise_statement] = STATE(2262),
    [sym_pass_statement] = STATE(2262),
    [sym_break_statement] = STATE(2262),
    [sym_continue_statement] = STATE(2262),
    [sym_global_statement] = STATE(2262),
    [sym_nonlocal_statement] = STATE(2262),
    [sym_exec_statement] = STATE(2262),
    [sym_type_alias_statement] = STATE(2262),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(564),
    [sym__indent] = ACTIONS(566),
    [sym_string_start] = ACTIONS(81),
  },
  [124] = {
    [sym__simple_statements] = STATE(810),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(568),
    [sym__indent] = ACTIONS(570),
    [sym_string_start] = ACTIONS(81),
  },
  [125] = {
    [sym__simple_statements] = STATE(2534),
    [sym_import_statement] = STATE(2510),
    [sym_future_import_statement] = STATE(2510),
    [sym_import_from_statement] = STATE(2510),
    [sym_print_statement] = STATE(2510),
    [sym_assert_statement] = STATE(2510),
    [sym_expression_statement] = STATE(2510),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2510),
    [sym_delete_statement] = STATE(2510),
    [sym_raise_statement] = STATE(2510),
    [sym_pass_statement] = STATE(2510),
    [sym_break_statement] = STATE(2510),
    [sym_continue_statement] = STATE(2510),
    [sym_global_statement] = STATE(2510),
    [sym_nonlocal_statement] = STATE(2510),
    [sym_exec_statement] = STATE(2510),
    [sym_type_alias_statement] = STATE(2510),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(572),
    [sym__indent] = ACTIONS(574),
    [sym_string_start] = ACTIONS(81),
  },
  [126] = {
    [sym__simple_statements] = STATE(821),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(576),
    [sym__indent] = ACTIONS(578),
    [sym_string_start] = ACTIONS(81),
  },
  [127] = {
    [sym__simple_statements] = STATE(837),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(580),
    [sym__indent] = ACTIONS(582),
    [sym_string_start] = ACTIONS(81),
  },
  [128] = {
    [sym__simple_statements] = STATE(804),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(584),
    [sym__indent] = ACTIONS(586),
    [sym_string_start] = ACTIONS(81),
  },
  [129] = {
    [sym__simple_statements] = STATE(717),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(588),
    [sym__indent] = ACTIONS(590),
    [sym_string_start] = ACTIONS(81),
  },
  [130] = {
    [sym__simple_statements] = STATE(2539),
    [sym_import_statement] = STATE(2510),
    [sym_future_import_statement] = STATE(2510),
    [sym_import_from_statement] = STATE(2510),
    [sym_print_statement] = STATE(2510),
    [sym_assert_statement] = STATE(2510),
    [sym_expression_statement] = STATE(2510),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2510),
    [sym_delete_statement] = STATE(2510),
    [sym_raise_statement] = STATE(2510),
    [sym_pass_statement] = STATE(2510),
    [sym_break_statement] = STATE(2510),
    [sym_continue_statement] = STATE(2510),
    [sym_global_statement] = STATE(2510),
    [sym_nonlocal_statement] = STATE(2510),
    [sym_exec_statement] = STATE(2510),
    [sym_type_alias_statement] = STATE(2510),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(592),
    [sym__indent] = ACTIONS(594),
    [sym_string_start] = ACTIONS(81),
  },
  [131] = {
    [sym__simple_statements] = STATE(691),
    [sym_import_statement] = STATE(2286),
    [sym_future_import_statement] = STATE(2286),
    [sym_import_from_statement] = STATE(2286),
    [sym_print_statement] = STATE(2286),
    [sym_assert_statement] = STATE(2286),
    [sym_expression_statement] = STATE(2286),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2286),
    [sym_delete_statement] = STATE(2286),
    [sym_raise_statement] = STATE(2286),
    [sym_pass_statement] = STATE(2286),
    [sym_break_statement] = STATE(2286),
    [sym_continue_statement] = STATE(2286),
    [sym_global_statement] = STATE(2286),
    [sym_nonlocal_statement] = STATE(2286),
    [sym_exec_statement] = STATE(2286),
    [sym_type_alias_statement] = STATE(2286),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(596),
    [sym__indent] = ACTIONS(598),
    [sym_string_start] = ACTIONS(81),
  },
  [132] = {
    [sym__simple_statements] = STATE(2578),
    [sym_import_statement] = STATE(2510),
    [sym_future_import_statement] = STATE(2510),
    [sym_import_from_statement] = STATE(2510),
    [sym_print_statement] = STATE(2510),
    [sym_assert_statement] = STATE(2510),
    [sym_expression_statement] = STATE(2510),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2510),
    [sym_delete_statement] = STATE(2510),
    [sym_raise_statement] = STATE(2510),
    [sym_pass_statement] = STATE(2510),
    [sym_break_statement] = STATE(2510),
    [sym_continue_statement] = STATE(2510),
    [sym_global_statement] = STATE(2510),
    [sym_nonlocal_statement] = STATE(2510),
    [sym_exec_statement] = STATE(2510),
    [sym_type_alias_statement] = STATE(2510),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(600),
    [sym__indent] = ACTIONS(602),
    [sym_string_start] = ACTIONS(81),
  },
  [133] = {
    [sym__simple_statements] = STATE(645),
    [sym_import_statement] = STATE(2471),
    [sym_future_import_statement] = STATE(2471),
    [sym_import_from_statement] = STATE(2471),
    [sym_print_statement] = STATE(2471),
    [sym_assert_statement] = STATE(2471),
    [sym_expression_statement] = STATE(2471),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2471),
    [sym_delete_statement] = STATE(2471),
    [sym_raise_statement] = STATE(2471),
    [sym_pass_statement] = STATE(2471),
    [sym_break_statement] = STATE(2471),
    [sym_continue_statement] = STATE(2471),
    [sym_global_statement] = STATE(2471),
    [sym_nonlocal_statement] = STATE(2471),
    [sym_exec_statement] = STATE(2471),
    [sym_type_alias_statement] = STATE(2471),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(604),
    [sym__indent] = ACTIONS(606),
    [sym_string_start] = ACTIONS(81),
  },
  [134] = {
    [sym__simple_statements] = STATE(757),
    [sym_import_statement] = STATE(2262),
    [sym_future_import_statement] = STATE(2262),
    [sym_import_from_statement] = STATE(2262),
    [sym_print_statement] = STATE(2262),
    [sym_assert_statement] = STATE(2262),
    [sym_expression_statement] = STATE(2262),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2262),
    [sym_delete_statement] = STATE(2262),
    [sym_raise_statement] = STATE(2262),
    [sym_pass_statement] = STATE(2262),
    [sym_break_statement] = STATE(2262),
    [sym_continue_statement] = STATE(2262),
    [sym_global_statement] = STATE(2262),
    [sym_nonlocal_statement] = STATE(2262),
    [sym_exec_statement] = STATE(2262),
    [sym_type_alias_statement] = STATE(2262),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(608),
    [sym__indent] = ACTIONS(610),
    [sym_string_start] = ACTIONS(81),
  },
  [135] = {
    [sym__simple_statements] = STATE(2542),
    [sym_import_statement] = STATE(2510),
    [sym_future_import_statement] = STATE(2510),
    [sym_import_from_statement] = STATE(2510),
    [sym_print_statement] = STATE(2510),
    [sym_assert_statement] = STATE(2510),
    [sym_expression_statement] = STATE(2510),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2510),
    [sym_delete_statement] = STATE(2510),
    [sym_raise_statement] = STATE(2510),
    [sym_pass_statement] = STATE(2510),
    [sym_break_statement] = STATE(2510),
    [sym_continue_statement] = STATE(2510),
    [sym_global_statement] = STATE(2510),
    [sym_nonlocal_statement] = STATE(2510),
    [sym_exec_statement] = STATE(2510),
    [sym_type_alias_statement] = STATE(2510),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(612),
    [sym__indent] = ACTIONS(614),
    [sym_string_start] = ACTIONS(81),
  },
  [136] = {
    [sym__simple_statements] = STATE(693),
    [sym_import_statement] = STATE(2262),
    [sym_future_import_statement] = STATE(2262),
    [sym_import_from_statement] = STATE(2262),
    [sym_print_statement] = STATE(2262),
    [sym_assert_statement] = STATE(2262),
    [sym_expression_statement] = STATE(2262),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2262),
    [sym_delete_statement] = STATE(2262),
    [sym_raise_statement] = STATE(2262),
    [sym_pass_statement] = STATE(2262),
    [sym_break_statement] = STATE(2262),
    [sym_continue_statement] = STATE(2262),
    [sym_global_statement] = STATE(2262),
    [sym_nonlocal_statement] = STATE(2262),
    [sym_exec_statement] = STATE(2262),
    [sym_type_alias_statement] = STATE(2262),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(616),
    [sym__indent] = ACTIONS(618),
    [sym_string_start] = ACTIONS(81),
  },
  [137] = {
    [sym_import_statement] = STATE(2605),
    [sym_future_import_statement] = STATE(2605),
    [sym_import_from_statement] = STATE(2605),
    [sym_print_statement] = STATE(2605),
    [sym_assert_statement] = STATE(2605),
    [sym_expression_statement] = STATE(2605),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2605),
    [sym_delete_statement] = STATE(2605),
    [sym_raise_statement] = STATE(2605),
    [sym_pass_statement] = STATE(2605),
    [sym_break_statement] = STATE(2605),
    [sym_continue_statement] = STATE(2605),
    [sym_global_statement] = STATE(2605),
    [sym_nonlocal_statement] = STATE(2605),
    [sym_exec_statement] = STATE(2605),
    [sym_type_alias_statement] = STATE(2605),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(620),
    [sym_string_start] = ACTIONS(81),
  },
  [138] = {
    [sym_import_statement] = STATE(2605),
    [sym_future_import_statement] = STATE(2605),
    [sym_import_from_statement] = STATE(2605),
    [sym_print_statement] = STATE(2605),
    [sym_assert_statement] = STATE(2605),
    [sym_expression_statement] = STATE(2605),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2605),
    [sym_delete_statement] = STATE(2605),
    [sym_raise_statement] = STATE(2605),
    [sym_pass_statement] = STATE(2605),
    [sym_break_statement] = STATE(2605),
    [sym_continue_statement] = STATE(2605),
    [sym_global_statement] = STATE(2605),
    [sym_nonlocal_statement] = STATE(2605),
    [sym_exec_statement] = STATE(2605),
    [sym_type_alias_statement] = STATE(2605),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(622),
    [sym_string_start] = ACTIONS(81),
  },
  [139] = {
    [sym_import_statement] = STATE(2605),
    [sym_future_import_statement] = STATE(2605),
    [sym_import_from_statement] = STATE(2605),
    [sym_print_statement] = STATE(2605),
    [sym_assert_statement] = STATE(2605),
    [sym_expression_statement] = STATE(2605),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2605),
    [sym_delete_statement] = STATE(2605),
    [sym_raise_statement] = STATE(2605),
    [sym_pass_statement] = STATE(2605),
    [sym_break_statement] = STATE(2605),
    [sym_continue_statement] = STATE(2605),
    [sym_global_statement] = STATE(2605),
    [sym_nonlocal_statement] = STATE(2605),
    [sym_exec_statement] = STATE(2605),
    [sym_type_alias_statement] = STATE(2605),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(624),
    [sym_string_start] = ACTIONS(81),
  },
  [140] = {
    [sym_import_statement] = STATE(2605),
    [sym_future_import_statement] = STATE(2605),
    [sym_import_from_statement] = STATE(2605),
    [sym_print_statement] = STATE(2605),
    [sym_assert_statement] = STATE(2605),
    [sym_expression_statement] = STATE(2605),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2605),
    [sym_delete_statement] = STATE(2605),
    [sym_raise_statement] = STATE(2605),
    [sym_pass_statement] = STATE(2605),
    [sym_break_statement] = STATE(2605),
    [sym_continue_statement] = STATE(2605),
    [sym_global_statement] = STATE(2605),
    [sym_nonlocal_statement] = STATE(2605),
    [sym_exec_statement] = STATE(2605),
    [sym_type_alias_statement] = STATE(2605),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(626),
    [sym_string_start] = ACTIONS(81),
  },
  [141] = {
    [sym_import_statement] = STATE(2605),
    [sym_future_import_statement] = STATE(2605),
    [sym_import_from_statement] = STATE(2605),
    [sym_print_statement] = STATE(2605),
    [sym_assert_statement] = STATE(2605),
    [sym_expression_statement] = STATE(2605),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2605),
    [sym_delete_statement] = STATE(2605),
    [sym_raise_statement] = STATE(2605),
    [sym_pass_statement] = STATE(2605),
    [sym_break_statement] = STATE(2605),
    [sym_continue_statement] = STATE(2605),
    [sym_global_statement] = STATE(2605),
    [sym_nonlocal_statement] = STATE(2605),
    [sym_exec_statement] = STATE(2605),
    [sym_type_alias_statement] = STATE(2605),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(628),
    [sym_string_start] = ACTIONS(81),
  },
  [142] = {
    [sym_import_statement] = STATE(2605),
    [sym_future_import_statement] = STATE(2605),
    [sym_import_from_statement] = STATE(2605),
    [sym_print_statement] = STATE(2605),
    [sym_assert_statement] = STATE(2605),
    [sym_expression_statement] = STATE(2605),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2605),
    [sym_delete_statement] = STATE(2605),
    [sym_raise_statement] = STATE(2605),
    [sym_pass_statement] = STATE(2605),
    [sym_break_statement] = STATE(2605),
    [sym_continue_statement] = STATE(2605),
    [sym_global_statement] = STATE(2605),
    [sym_nonlocal_statement] = STATE(2605),
    [sym_exec_statement] = STATE(2605),
    [sym_type_alias_statement] = STATE(2605),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(630),
    [sym_string_start] = ACTIONS(81),
  },
  [143] = {
    [sym_import_statement] = STATE(2605),
    [sym_future_import_statement] = STATE(2605),
    [sym_import_from_statement] = STATE(2605),
    [sym_print_statement] = STATE(2605),
    [sym_assert_statement] = STATE(2605),
    [sym_expression_statement] = STATE(2605),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2605),
    [sym_delete_statement] = STATE(2605),
    [sym_raise_statement] = STATE(2605),
    [sym_pass_statement] = STATE(2605),
    [sym_break_statement] = STATE(2605),
    [sym_continue_statement] = STATE(2605),
    [sym_global_statement] = STATE(2605),
    [sym_nonlocal_statement] = STATE(2605),
    [sym_exec_statement] = STATE(2605),
    [sym_type_alias_statement] = STATE(2605),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(632),
    [sym_string_start] = ACTIONS(81),
  },
  [144] = {
    [sym_import_statement] = STATE(2605),
    [sym_future_import_statement] = STATE(2605),
    [sym_import_from_statement] = STATE(2605),
    [sym_print_statement] = STATE(2605),
    [sym_assert_statement] = STATE(2605),
    [sym_expression_statement] = STATE(2605),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2605),
    [sym_delete_statement] = STATE(2605),
    [sym_raise_statement] = STATE(2605),
    [sym_pass_statement] = STATE(2605),
    [sym_break_statement] = STATE(2605),
    [sym_continue_statement] = STATE(2605),
    [sym_global_statement] = STATE(2605),
    [sym_nonlocal_statement] = STATE(2605),
    [sym_exec_statement] = STATE(2605),
    [sym_type_alias_statement] = STATE(2605),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(634),
    [sym_string_start] = ACTIONS(81),
  },
  [145] = {
    [sym_import_statement] = STATE(2605),
    [sym_future_import_statement] = STATE(2605),
    [sym_import_from_statement] = STATE(2605),
    [sym_print_statement] = STATE(2605),
    [sym_assert_statement] = STATE(2605),
    [sym_expression_statement] = STATE(2605),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2605),
    [sym_delete_statement] = STATE(2605),
    [sym_raise_statement] = STATE(2605),
    [sym_pass_statement] = STATE(2605),
    [sym_break_statement] = STATE(2605),
    [sym_continue_statement] = STATE(2605),
    [sym_global_statement] = STATE(2605),
    [sym_nonlocal_statement] = STATE(2605),
    [sym_exec_statement] = STATE(2605),
    [sym_type_alias_statement] = STATE(2605),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(636),
    [sym_string_start] = ACTIONS(81),
  },
  [146] = {
    [sym_import_statement] = STATE(2605),
    [sym_future_import_statement] = STATE(2605),
    [sym_import_from_statement] = STATE(2605),
    [sym_print_statement] = STATE(2605),
    [sym_assert_statement] = STATE(2605),
    [sym_expression_statement] = STATE(2605),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2605),
    [sym_delete_statement] = STATE(2605),
    [sym_raise_statement] = STATE(2605),
    [sym_pass_statement] = STATE(2605),
    [sym_break_statement] = STATE(2605),
    [sym_continue_statement] = STATE(2605),
    [sym_global_statement] = STATE(2605),
    [sym_nonlocal_statement] = STATE(2605),
    [sym_exec_statement] = STATE(2605),
    [sym_type_alias_statement] = STATE(2605),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(638),
    [sym_string_start] = ACTIONS(81),
  },
  [147] = {
    [sym_import_statement] = STATE(2605),
    [sym_future_import_statement] = STATE(2605),
    [sym_import_from_statement] = STATE(2605),
    [sym_print_statement] = STATE(2605),
    [sym_assert_statement] = STATE(2605),
    [sym_expression_statement] = STATE(2605),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2605),
    [sym_delete_statement] = STATE(2605),
    [sym_raise_statement] = STATE(2605),
    [sym_pass_statement] = STATE(2605),
    [sym_break_statement] = STATE(2605),
    [sym_continue_statement] = STATE(2605),
    [sym_global_statement] = STATE(2605),
    [sym_nonlocal_statement] = STATE(2605),
    [sym_exec_statement] = STATE(2605),
    [sym_type_alias_statement] = STATE(2605),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(640),
    [sym_string_start] = ACTIONS(81),
  },
  [148] = {
    [sym_import_statement] = STATE(2605),
    [sym_future_import_statement] = STATE(2605),
    [sym_import_from_statement] = STATE(2605),
    [sym_print_statement] = STATE(2605),
    [sym_assert_statement] = STATE(2605),
    [sym_expression_statement] = STATE(2605),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2605),
    [sym_delete_statement] = STATE(2605),
    [sym_raise_statement] = STATE(2605),
    [sym_pass_statement] = STATE(2605),
    [sym_break_statement] = STATE(2605),
    [sym_continue_statement] = STATE(2605),
    [sym_global_statement] = STATE(2605),
    [sym_nonlocal_statement] = STATE(2605),
    [sym_exec_statement] = STATE(2605),
    [sym_type_alias_statement] = STATE(2605),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(642),
    [sym_string_start] = ACTIONS(81),
  },
  [149] = {
    [sym_import_statement] = STATE(2605),
    [sym_future_import_statement] = STATE(2605),
    [sym_import_from_statement] = STATE(2605),
    [sym_print_statement] = STATE(2605),
    [sym_assert_statement] = STATE(2605),
    [sym_expression_statement] = STATE(2605),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2605),
    [sym_delete_statement] = STATE(2605),
    [sym_raise_statement] = STATE(2605),
    [sym_pass_statement] = STATE(2605),
    [sym_break_statement] = STATE(2605),
    [sym_continue_statement] = STATE(2605),
    [sym_global_statement] = STATE(2605),
    [sym_nonlocal_statement] = STATE(2605),
    [sym_exec_statement] = STATE(2605),
    [sym_type_alias_statement] = STATE(2605),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(644),
    [sym_string_start] = ACTIONS(81),
  },
  [150] = {
    [sym_import_statement] = STATE(2605),
    [sym_future_import_statement] = STATE(2605),
    [sym_import_from_statement] = STATE(2605),
    [sym_print_statement] = STATE(2605),
    [sym_assert_statement] = STATE(2605),
    [sym_expression_statement] = STATE(2605),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2605),
    [sym_delete_statement] = STATE(2605),
    [sym_raise_statement] = STATE(2605),
    [sym_pass_statement] = STATE(2605),
    [sym_break_statement] = STATE(2605),
    [sym_continue_statement] = STATE(2605),
    [sym_global_statement] = STATE(2605),
    [sym_nonlocal_statement] = STATE(2605),
    [sym_exec_statement] = STATE(2605),
    [sym_type_alias_statement] = STATE(2605),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(646),
    [sym_string_start] = ACTIONS(81),
  },
  [151] = {
    [sym_import_statement] = STATE(2605),
    [sym_future_import_statement] = STATE(2605),
    [sym_import_from_statement] = STATE(2605),
    [sym_print_statement] = STATE(2605),
    [sym_assert_statement] = STATE(2605),
    [sym_expression_statement] = STATE(2605),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2605),
    [sym_delete_statement] = STATE(2605),
    [sym_raise_statement] = STATE(2605),
    [sym_pass_statement] = STATE(2605),
    [sym_break_statement] = STATE(2605),
    [sym_continue_statement] = STATE(2605),
    [sym_global_statement] = STATE(2605),
    [sym_nonlocal_statement] = STATE(2605),
    [sym_exec_statement] = STATE(2605),
    [sym_type_alias_statement] = STATE(2605),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(648),
    [sym_string_start] = ACTIONS(81),
  },
  [152] = {
    [sym_import_statement] = STATE(2605),
    [sym_future_import_statement] = STATE(2605),
    [sym_import_from_statement] = STATE(2605),
    [sym_print_statement] = STATE(2605),
    [sym_assert_statement] = STATE(2605),
    [sym_expression_statement] = STATE(2605),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2605),
    [sym_delete_statement] = STATE(2605),
    [sym_raise_statement] = STATE(2605),
    [sym_pass_statement] = STATE(2605),
    [sym_break_statement] = STATE(2605),
    [sym_continue_statement] = STATE(2605),
    [sym_global_statement] = STATE(2605),
    [sym_nonlocal_statement] = STATE(2605),
    [sym_exec_statement] = STATE(2605),
    [sym_type_alias_statement] = STATE(2605),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(650),
    [sym_string_start] = ACTIONS(81),
  },
  [153] = {
    [sym_import_statement] = STATE(2605),
    [sym_future_import_statement] = STATE(2605),
    [sym_import_from_statement] = STATE(2605),
    [sym_print_statement] = STATE(2605),
    [sym_assert_statement] = STATE(2605),
    [sym_expression_statement] = STATE(2605),
    [sym_named_expression] = STATE(1685),
    [sym__named_expression_lhs] = STATE(2795),
    [sym_return_statement] = STATE(2605),
    [sym_delete_statement] = STATE(2605),
    [sym_raise_statement] = STATE(2605),
    [sym_pass_statement] = STATE(2605),
    [sym_break_statement] = STATE(2605),
    [sym_continue_statement] = STATE(2605),
    [sym_global_statement] = STATE(2605),
    [sym_nonlocal_statement] = STATE(2605),
    [sym_exec_statement] = STATE(2605),
    [sym_type_alias_statement] = STATE(2605),
    [sym_pattern] = STATE(1666),
    [sym_tuple_pattern] = STATE(1663),
    [sym_list_pattern] = STATE(1663),
    [sym_list_splat_pattern] = STATE(626),
    [sym_as_pattern] = STATE(1685),
    [sym_expression] = STATE(1810),
    [sym_primary_expression] = STATE(998),
    [sym_not_operator] = STATE(1685),
    [sym_boolean_operator] = STATE(1685),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_comparison_operator] = STATE(1685),
    [sym_lambda] = STATE(1685),
    [sym_assignment] = STATE(2530),
    [sym_augmented_assignment] = STATE(2530),
    [sym_pattern_list] = STATE(1672),
    [sym_yield] = STATE(2530),
    [sym_attribute] = STATE(619),
    [sym_subscript] = STATE(619),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_conditional_expression] = STATE(1685),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(418),
    [anon_sym_async] = ACTIONS(418),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(81),
  },
  [154] = {
    [sym_list_splat_pattern] = STATE(1125),
    [sym_primary_expression] = STATE(980),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_attribute] = STATE(1077),
    [sym_subscript] = STATE(1077),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_SEMI] = ACTIONS(277),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(652),
    [anon_sym_COMMA] = ACTIONS(284),
    [anon_sym_as] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(654),
    [anon_sym_print] = ACTIONS(656),
    [anon_sym_GT_GT] = ACTIONS(279),
    [anon_sym_COLON_EQ] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_COLON] = ACTIONS(326),
    [anon_sym_match] = ACTIONS(656),
    [anon_sym_async] = ACTIONS(656),
    [anon_sym_in] = ACTIONS(279),
    [anon_sym_STAR_STAR] = ACTIONS(279),
    [anon_sym_exec] = ACTIONS(656),
    [anon_sym_type] = ACTIONS(658),
    [anon_sym_EQ] = ACTIONS(294),
    [anon_sym_LBRACK] = ACTIONS(660),
    [anon_sym_AT] = ACTIONS(279),
    [anon_sym_DASH] = ACTIONS(662),
    [anon_sym_PIPE] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(662),
    [anon_sym_not] = ACTIONS(279),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(279),
    [anon_sym_SLASH_SLASH] = ACTIONS(279),
    [anon_sym_AMP] = ACTIONS(279),
    [anon_sym_CARET] = ACTIONS(279),
    [anon_sym_LT_LT] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(279),
    [anon_sym_LT_EQ] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_BANG_EQ] = ACTIONS(277),
    [anon_sym_GT_EQ] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_LT_GT] = ACTIONS(277),
    [anon_sym_is] = ACTIONS(279),
    [anon_sym_PLUS_EQ] = ACTIONS(316),
    [anon_sym_DASH_EQ] = ACTIONS(316),
    [anon_sym_STAR_EQ] = ACTIONS(316),
    [anon_sym_SLASH_EQ] = ACTIONS(316),
    [anon_sym_AT_EQ] = ACTIONS(316),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(316),
    [anon_sym_PERCENT_EQ] = ACTIONS(316),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(316),
    [anon_sym_GT_GT_EQ] = ACTIONS(316),
    [anon_sym_LT_LT_EQ] = ACTIONS(316),
    [anon_sym_AMP_EQ] = ACTIONS(316),
    [anon_sym_CARET_EQ] = ACTIONS(316),
    [anon_sym_PIPE_EQ] = ACTIONS(316),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(664),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(277),
    [sym_string_start] = ACTIONS(81),
  },
  [155] = {
    [sym_list_splat_pattern] = STATE(1125),
    [sym_primary_expression] = STATE(980),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_attribute] = STATE(1077),
    [sym_subscript] = STATE(1077),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_SEMI] = ACTIONS(277),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(652),
    [anon_sym_COMMA] = ACTIONS(284),
    [anon_sym_as] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(654),
    [anon_sym_print] = ACTIONS(656),
    [anon_sym_GT_GT] = ACTIONS(279),
    [anon_sym_COLON_EQ] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_COLON] = ACTIONS(294),
    [anon_sym_match] = ACTIONS(656),
    [anon_sym_async] = ACTIONS(656),
    [anon_sym_in] = ACTIONS(279),
    [anon_sym_STAR_STAR] = ACTIONS(279),
    [anon_sym_exec] = ACTIONS(656),
    [anon_sym_type] = ACTIONS(658),
    [anon_sym_EQ] = ACTIONS(294),
    [anon_sym_LBRACK] = ACTIONS(660),
    [anon_sym_AT] = ACTIONS(279),
    [anon_sym_DASH] = ACTIONS(662),
    [anon_sym_PIPE] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(662),
    [anon_sym_not] = ACTIONS(279),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(279),
    [anon_sym_SLASH_SLASH] = ACTIONS(279),
    [anon_sym_AMP] = ACTIONS(279),
    [anon_sym_CARET] = ACTIONS(279),
    [anon_sym_LT_LT] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(279),
    [anon_sym_LT_EQ] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_BANG_EQ] = ACTIONS(277),
    [anon_sym_GT_EQ] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_LT_GT] = ACTIONS(277),
    [anon_sym_is] = ACTIONS(279),
    [anon_sym_PLUS_EQ] = ACTIONS(316),
    [anon_sym_DASH_EQ] = ACTIONS(316),
    [anon_sym_STAR_EQ] = ACTIONS(316),
    [anon_sym_SLASH_EQ] = ACTIONS(316),
    [anon_sym_AT_EQ] = ACTIONS(316),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(316),
    [anon_sym_PERCENT_EQ] = ACTIONS(316),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(316),
    [anon_sym_GT_GT_EQ] = ACTIONS(316),
    [anon_sym_LT_LT_EQ] = ACTIONS(316),
    [anon_sym_AMP_EQ] = ACTIONS(316),
    [anon_sym_CARET_EQ] = ACTIONS(316),
    [anon_sym_PIPE_EQ] = ACTIONS(316),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(664),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(277),
    [sym_string_start] = ACTIONS(81),
  },
  [156] = {
    [sym_list_splat_pattern] = STATE(1323),
    [sym_primary_expression] = STATE(1078),
    [sym_binary_operator] = STATE(1282),
    [sym_unary_operator] = STATE(1282),
    [sym_attribute] = STATE(1282),
    [sym_subscript] = STATE(1282),
    [sym_call] = STATE(1282),
    [sym_list] = STATE(1282),
    [sym_set] = STATE(1282),
    [sym_tuple] = STATE(1282),
    [sym_dictionary] = STATE(1282),
    [sym_list_comprehension] = STATE(1282),
    [sym_dictionary_comprehension] = STATE(1282),
    [sym_set_comprehension] = STATE(1282),
    [sym_generator_expression] = STATE(1282),
    [sym_parenthesized_expression] = STATE(1282),
    [sym_concatenated_string] = STATE(1282),
    [sym_string] = STATE(1007),
    [sym_await] = STATE(1282),
    [sym_identifier] = ACTIONS(320),
    [anon_sym_SEMI] = ACTIONS(666),
    [anon_sym_DOT] = ACTIONS(668),
    [anon_sym_LPAREN] = ACTIONS(408),
    [anon_sym_COMMA] = ACTIONS(666),
    [anon_sym_as] = ACTIONS(671),
    [anon_sym_STAR] = ACTIONS(410),
    [anon_sym_print] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(668),
    [anon_sym_if] = ACTIONS(671),
    [anon_sym_COLON] = ACTIONS(666),
    [anon_sym_match] = ACTIONS(673),
    [anon_sym_async] = ACTIONS(673),
    [anon_sym_in] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(668),
    [anon_sym_exec] = ACTIONS(673),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_EQ] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(412),
    [anon_sym_AT] = ACTIONS(668),
    [anon_sym_DASH] = ACTIONS(414),
    [anon_sym_PIPE] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_PLUS] = ACTIONS(414),
    [anon_sym_not] = ACTIONS(671),
    [anon_sym_and] = ACTIONS(671),
    [anon_sym_or] = ACTIONS(671),
    [anon_sym_SLASH] = ACTIONS(668),
    [anon_sym_PERCENT] = ACTIONS(668),
    [anon_sym_SLASH_SLASH] = ACTIONS(668),
    [anon_sym_AMP] = ACTIONS(668),
    [anon_sym_CARET] = ACTIONS(668),
    [anon_sym_LT_LT] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(671),
    [anon_sym_LT_EQ] = ACTIONS(666),
    [anon_sym_EQ_EQ] = ACTIONS(666),
    [anon_sym_BANG_EQ] = ACTIONS(666),
    [anon_sym_GT_EQ] = ACTIONS(666),
    [anon_sym_GT] = ACTIONS(671),
    [anon_sym_LT_GT] = ACTIONS(666),
    [anon_sym_is] = ACTIONS(671),
    [anon_sym_PLUS_EQ] = ACTIONS(666),
    [anon_sym_DASH_EQ] = ACTIONS(666),
    [anon_sym_STAR_EQ] = ACTIONS(666),
    [anon_sym_SLASH_EQ] = ACTIONS(666),
    [anon_sym_AT_EQ] = ACTIONS(666),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(666),
    [anon_sym_PERCENT_EQ] = ACTIONS(666),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(666),
    [anon_sym_GT_GT_EQ] = ACTIONS(666),
    [anon_sym_LT_LT_EQ] = ACTIONS(666),
    [anon_sym_AMP_EQ] = ACTIONS(666),
    [anon_sym_CARET_EQ] = ACTIONS(666),
    [anon_sym_PIPE_EQ] = ACTIONS(666),
    [sym_ellipsis] = ACTIONS(318),
    [sym_integer] = ACTIONS(320),
    [sym_float] = ACTIONS(318),
    [anon_sym_await] = ACTIONS(677),
    [sym_true] = ACTIONS(320),
    [sym_false] = ACTIONS(320),
    [sym_none] = ACTIONS(320),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(666),
    [sym_string_start] = ACTIONS(324),
  },
  [157] = {
    [sym_list_splat_pattern] = STATE(1125),
    [sym_primary_expression] = STATE(980),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_attribute] = STATE(1077),
    [sym_subscript] = STATE(1077),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_SEMI] = ACTIONS(277),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_from] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(652),
    [anon_sym_COMMA] = ACTIONS(277),
    [anon_sym_as] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(654),
    [anon_sym_print] = ACTIONS(656),
    [anon_sym_GT_GT] = ACTIONS(277),
    [anon_sym_COLON_EQ] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_COLON] = ACTIONS(279),
    [anon_sym_match] = ACTIONS(656),
    [anon_sym_async] = ACTIONS(656),
    [anon_sym_in] = ACTIONS(279),
    [anon_sym_STAR_STAR] = ACTIONS(277),
    [anon_sym_exec] = ACTIONS(656),
    [anon_sym_type] = ACTIONS(658),
    [anon_sym_EQ] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(660),
    [anon_sym_AT] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(279),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(277),
    [anon_sym_SLASH_SLASH] = ACTIONS(277),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_CARET] = ACTIONS(277),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(279),
    [anon_sym_LT_EQ] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_BANG_EQ] = ACTIONS(277),
    [anon_sym_GT_EQ] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_LT_GT] = ACTIONS(277),
    [anon_sym_is] = ACTIONS(279),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(664),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(277),
    [sym_string_start] = ACTIONS(81),
  },
  [158] = {
    [sym_list_splat_pattern] = STATE(1125),
    [sym_primary_expression] = STATE(980),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_attribute] = STATE(1077),
    [sym_subscript] = STATE(1077),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(968),
    [sym_await] = STATE(1077),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_SEMI] = ACTIONS(277),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_from] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(652),
    [anon_sym_COMMA] = ACTIONS(277),
    [anon_sym_as] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(654),
    [anon_sym_print] = ACTIONS(656),
    [anon_sym_GT_GT] = ACTIONS(277),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_COLON] = ACTIONS(277),
    [anon_sym_match] = ACTIONS(656),
    [anon_sym_async] = ACTIONS(656),
    [anon_sym_in] = ACTIONS(279),
    [anon_sym_STAR_STAR] = ACTIONS(277),
    [anon_sym_exec] = ACTIONS(656),
    [anon_sym_type] = ACTIONS(658),
    [anon_sym_EQ] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(660),
    [anon_sym_AT] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(279),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(277),
    [anon_sym_SLASH_SLASH] = ACTIONS(277),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_CARET] = ACTIONS(277),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(279),
    [anon_sym_LT_EQ] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_BANG_EQ] = ACTIONS(277),
    [anon_sym_GT_EQ] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_LT_GT] = ACTIONS(277),
    [anon_sym_is] = ACTIONS(279),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(664),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(277),
    [sym_string_start] = ACTIONS(81),
  },
  [159] = {
    [sym_list_splat_pattern] = STATE(1323),
    [sym_primary_expression] = STATE(1078),
    [sym_binary_operator] = STATE(1282),
    [sym_unary_operator] = STATE(1282),
    [sym_attribute] = STATE(1282),
    [sym_subscript] = STATE(1282),
    [sym_call] = STATE(1282),
    [sym_list] = STATE(1282),
    [sym_set] = STATE(1282),
    [sym_tuple] = STATE(1282),
    [sym_dictionary] = STATE(1282),
    [sym_list_comprehension] = STATE(1282),
    [sym_dictionary_comprehension] = STATE(1282),
    [sym_set_comprehension] = STATE(1282),
    [sym_generator_expression] = STATE(1282),
    [sym_parenthesized_expression] = STATE(1282),
    [sym_concatenated_string] = STATE(1282),
    [sym_string] = STATE(1007),
    [sym_await] = STATE(1282),
    [sym_identifier] = ACTIONS(320),
    [anon_sym_SEMI] = ACTIONS(666),
    [anon_sym_DOT] = ACTIONS(668),
    [anon_sym_from] = ACTIONS(671),
    [anon_sym_LPAREN] = ACTIONS(408),
    [anon_sym_COMMA] = ACTIONS(666),
    [anon_sym_as] = ACTIONS(671),
    [anon_sym_STAR] = ACTIONS(410),
    [anon_sym_print] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(671),
    [anon_sym_COLON] = ACTIONS(666),
    [anon_sym_match] = ACTIONS(673),
    [anon_sym_async] = ACTIONS(673),
    [anon_sym_in] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(679),
    [anon_sym_exec] = ACTIONS(673),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_EQ] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(412),
    [anon_sym_AT] = ACTIONS(679),
    [anon_sym_DASH] = ACTIONS(312),
    [anon_sym_PIPE] = ACTIONS(679),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_PLUS] = ACTIONS(312),
    [anon_sym_not] = ACTIONS(671),
    [anon_sym_and] = ACTIONS(671),
    [anon_sym_or] = ACTIONS(671),
    [anon_sym_SLASH] = ACTIONS(668),
    [anon_sym_PERCENT] = ACTIONS(679),
    [anon_sym_SLASH_SLASH] = ACTIONS(679),
    [anon_sym_AMP] = ACTIONS(679),
    [anon_sym_CARET] = ACTIONS(679),
    [anon_sym_LT_LT] = ACTIONS(679),
    [anon_sym_TILDE] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(671),
    [anon_sym_LT_EQ] = ACTIONS(666),
    [anon_sym_EQ_EQ] = ACTIONS(666),
    [anon_sym_BANG_EQ] = ACTIONS(666),
    [anon_sym_GT_EQ] = ACTIONS(666),
    [anon_sym_GT] = ACTIONS(671),
    [anon_sym_LT_GT] = ACTIONS(666),
    [anon_sym_is] = ACTIONS(671),
    [sym_ellipsis] = ACTIONS(318),
    [sym_integer] = ACTIONS(320),
    [sym_float] = ACTIONS(318),
    [anon_sym_await] = ACTIONS(677),
    [sym_true] = ACTIONS(320),
    [sym_false] = ACTIONS(320),
    [sym_none] = ACTIONS(320),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(666),
    [sym_string_start] = ACTIONS(324),
  },
  [160] = {
    [sym_list_splat_pattern] = STATE(1218),
    [sym_primary_expression] = STATE(1041),
    [sym_binary_operator] = STATE(1258),
    [sym_unary_operator] = STATE(1258),
    [sym_attribute] = STATE(1258),
    [sym_subscript] = STATE(1258),
    [sym_call] = STATE(1258),
    [sym_list] = STATE(1258),
    [sym_set] = STATE(1258),
    [sym_tuple] = STATE(1258),
    [sym_dictionary] = STATE(1258),
    [sym_list_comprehension] = STATE(1258),
    [sym_dictionary_comprehension] = STATE(1258),
    [sym_set_comprehension] = STATE(1258),
    [sym_generator_expression] = STATE(1258),
    [sym_parenthesized_expression] = STATE(1258),
    [sym_concatenated_string] = STATE(1258),
    [sym_string] = STATE(977),
    [sym_await] = STATE(1258),
    [sym_identifier] = ACTIONS(682),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(684),
    [anon_sym_COMMA] = ACTIONS(284),
    [anon_sym_as] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_print] = ACTIONS(688),
    [anon_sym_GT_GT] = ACTIONS(277),
    [anon_sym_COLON_EQ] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_COLON] = ACTIONS(279),
    [anon_sym_match] = ACTIONS(688),
    [anon_sym_async] = ACTIONS(688),
    [anon_sym_in] = ACTIONS(279),
    [anon_sym_STAR_STAR] = ACTIONS(277),
    [anon_sym_exec] = ACTIONS(688),
    [anon_sym_type] = ACTIONS(690),
    [anon_sym_EQ] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_AT] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(694),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_LBRACE] = ACTIONS(696),
    [anon_sym_RBRACE] = ACTIONS(277),
    [anon_sym_PLUS] = ACTIONS(694),
    [anon_sym_not] = ACTIONS(279),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(277),
    [anon_sym_SLASH_SLASH] = ACTIONS(277),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_CARET] = ACTIONS(277),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_TILDE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(279),
    [anon_sym_LT_EQ] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_BANG_EQ] = ACTIONS(277),
    [anon_sym_GT_EQ] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_LT_GT] = ACTIONS(277),
    [anon_sym_is] = ACTIONS(279),
    [sym_ellipsis] = ACTIONS(698),
    [sym_type_conversion] = ACTIONS(277),
    [sym_integer] = ACTIONS(682),
    [sym_float] = ACTIONS(698),
    [anon_sym_await] = ACTIONS(700),
    [sym_true] = ACTIONS(682),
    [sym_false] = ACTIONS(682),
    [sym_none] = ACTIONS(682),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(702),
  },
  [161] = {
    [sym_list_splat_pattern] = STATE(1323),
    [sym_primary_expression] = STATE(1078),
    [sym_binary_operator] = STATE(1282),
    [sym_unary_operator] = STATE(1282),
    [sym_attribute] = STATE(1282),
    [sym_subscript] = STATE(1282),
    [sym_call] = STATE(1282),
    [sym_list] = STATE(1282),
    [sym_set] = STATE(1282),
    [sym_tuple] = STATE(1282),
    [sym_dictionary] = STATE(1282),
    [sym_list_comprehension] = STATE(1282),
    [sym_dictionary_comprehension] = STATE(1282),
    [sym_set_comprehension] = STATE(1282),
    [sym_generator_expression] = STATE(1282),
    [sym_parenthesized_expression] = STATE(1282),
    [sym_concatenated_string] = STATE(1282),
    [sym_string] = STATE(1007),
    [sym_await] = STATE(1282),
    [sym_identifier] = ACTIONS(320),
    [anon_sym_DOT] = ACTIONS(668),
    [anon_sym_LPAREN] = ACTIONS(408),
    [anon_sym_COMMA] = ACTIONS(666),
    [anon_sym_as] = ACTIONS(671),
    [anon_sym_STAR] = ACTIONS(410),
    [anon_sym_print] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(671),
    [anon_sym_COLON] = ACTIONS(666),
    [anon_sym_match] = ACTIONS(673),
    [anon_sym_async] = ACTIONS(673),
    [anon_sym_for] = ACTIONS(671),
    [anon_sym_in] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(679),
    [anon_sym_exec] = ACTIONS(673),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_EQ] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(412),
    [anon_sym_AT] = ACTIONS(679),
    [anon_sym_DASH] = ACTIONS(312),
    [anon_sym_PIPE] = ACTIONS(679),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_RBRACE] = ACTIONS(666),
    [anon_sym_PLUS] = ACTIONS(312),
    [anon_sym_not] = ACTIONS(671),
    [anon_sym_and] = ACTIONS(671),
    [anon_sym_or] = ACTIONS(671),
    [anon_sym_SLASH] = ACTIONS(668),
    [anon_sym_PERCENT] = ACTIONS(679),
    [anon_sym_SLASH_SLASH] = ACTIONS(679),
    [anon_sym_AMP] = ACTIONS(679),
    [anon_sym_CARET] = ACTIONS(679),
    [anon_sym_LT_LT] = ACTIONS(679),
    [anon_sym_TILDE] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(671),
    [anon_sym_LT_EQ] = ACTIONS(666),
    [anon_sym_EQ_EQ] = ACTIONS(666),
    [anon_sym_BANG_EQ] = ACTIONS(666),
    [anon_sym_GT_EQ] = ACTIONS(666),
    [anon_sym_GT] = ACTIONS(671),
    [anon_sym_LT_GT] = ACTIONS(666),
    [anon_sym_is] = ACTIONS(671),
    [sym_ellipsis] = ACTIONS(318),
    [sym_type_conversion] = ACTIONS(666),
    [sym_integer] = ACTIONS(320),
    [sym_float] = ACTIONS(318),
    [anon_sym_await] = ACTIONS(677),
    [sym_true] = ACTIONS(320),
    [sym_false] = ACTIONS(320),
    [sym_none] = ACTIONS(320),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(324),
  },
  [162] = {
    [sym_list_splat_pattern] = STATE(1218),
    [sym_primary_expression] = STATE(1041),
    [sym_binary_operator] = STATE(1258),
    [sym_unary_operator] = STATE(1258),
    [sym_attribute] = STATE(1258),
    [sym_subscript] = STATE(1258),
    [sym_call] = STATE(1258),
    [sym_list] = STATE(1258),
    [sym_set] = STATE(1258),
    [sym_tuple] = STATE(1258),
    [sym_dictionary] = STATE(1258),
    [sym_list_comprehension] = STATE(1258),
    [sym_dictionary_comprehension] = STATE(1258),
    [sym_set_comprehension] = STATE(1258),
    [sym_generator_expression] = STATE(1258),
    [sym_parenthesized_expression] = STATE(1258),
    [sym_concatenated_string] = STATE(1258),
    [sym_string] = STATE(977),
    [sym_await] = STATE(1258),
    [sym_identifier] = ACTIONS(682),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(684),
    [anon_sym_COMMA] = ACTIONS(277),
    [anon_sym_as] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_print] = ACTIONS(688),
    [anon_sym_GT_GT] = ACTIONS(277),
    [anon_sym_COLON_EQ] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_COLON] = ACTIONS(279),
    [anon_sym_match] = ACTIONS(688),
    [anon_sym_async] = ACTIONS(688),
    [anon_sym_in] = ACTIONS(279),
    [anon_sym_STAR_STAR] = ACTIONS(277),
    [anon_sym_exec] = ACTIONS(688),
    [anon_sym_type] = ACTIONS(690),
    [anon_sym_EQ] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_AT] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(694),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_LBRACE] = ACTIONS(696),
    [anon_sym_RBRACE] = ACTIONS(277),
    [anon_sym_PLUS] = ACTIONS(694),
    [anon_sym_not] = ACTIONS(279),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(277),
    [anon_sym_SLASH_SLASH] = ACTIONS(277),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_CARET] = ACTIONS(277),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_TILDE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(279),
    [anon_sym_LT_EQ] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_BANG_EQ] = ACTIONS(277),
    [anon_sym_GT_EQ] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_LT_GT] = ACTIONS(277),
    [anon_sym_is] = ACTIONS(279),
    [sym_ellipsis] = ACTIONS(698),
    [sym_type_conversion] = ACTIONS(277),
    [sym_integer] = ACTIONS(682),
    [sym_float] = ACTIONS(698),
    [anon_sym_await] = ACTIONS(700),
    [sym_true] = ACTIONS(682),
    [sym_false] = ACTIONS(682),
    [sym_none] = ACTIONS(682),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(702),
  },
  [163] = {
    [sym_list_splat_pattern] = STATE(1323),
    [sym_primary_expression] = STATE(1078),
    [sym_binary_operator] = STATE(1282),
    [sym_unary_operator] = STATE(1282),
    [sym_attribute] = STATE(1282),
    [sym_subscript] = STATE(1282),
    [sym_call] = STATE(1282),
    [sym_list] = STATE(1282),
    [sym_set] = STATE(1282),
    [sym_tuple] = STATE(1282),
    [sym_dictionary] = STATE(1282),
    [sym_list_comprehension] = STATE(1282),
    [sym_dictionary_comprehension] = STATE(1282),
    [sym_set_comprehension] = STATE(1282),
    [sym_generator_expression] = STATE(1282),
    [sym_parenthesized_expression] = STATE(1282),
    [sym_concatenated_string] = STATE(1282),
    [sym_string] = STATE(1007),
    [sym_await] = STATE(1282),
    [sym_identifier] = ACTIONS(320),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(408),
    [anon_sym_COMMA] = ACTIONS(277),
    [anon_sym_as] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(410),
    [anon_sym_print] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(277),
    [anon_sym_COLON_EQ] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_COLON] = ACTIONS(279),
    [anon_sym_else] = ACTIONS(279),
    [anon_sym_match] = ACTIONS(673),
    [anon_sym_async] = ACTIONS(673),
    [anon_sym_in] = ACTIONS(279),
    [anon_sym_STAR_STAR] = ACTIONS(277),
    [anon_sym_exec] = ACTIONS(673),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_EQ] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(412),
    [anon_sym_AT] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(312),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_PLUS] = ACTIONS(312),
    [anon_sym_not] = ACTIONS(279),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(277),
    [anon_sym_SLASH_SLASH] = ACTIONS(277),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_CARET] = ACTIONS(277),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_TILDE] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(279),
    [anon_sym_LT_EQ] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_BANG_EQ] = ACTIONS(277),
    [anon_sym_GT_EQ] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_LT_GT] = ACTIONS(277),
    [anon_sym_is] = ACTIONS(279),
    [sym_ellipsis] = ACTIONS(318),
    [sym_integer] = ACTIONS(320),
    [sym_float] = ACTIONS(318),
    [anon_sym_await] = ACTIONS(677),
    [sym_true] = ACTIONS(320),
    [sym_false] = ACTIONS(320),
    [sym_none] = ACTIONS(320),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(324),
  },
  [164] = {
    [sym_list_splat_pattern] = STATE(1214),
    [sym_primary_expression] = STATE(1019),
    [sym_binary_operator] = STATE(1235),
    [sym_unary_operator] = STATE(1235),
    [sym_attribute] = STATE(1235),
    [sym_subscript] = STATE(1235),
    [sym_call] = STATE(1235),
    [sym_list] = STATE(1235),
    [sym_set] = STATE(1235),
    [sym_tuple] = STATE(1235),
    [sym_dictionary] = STATE(1235),
    [sym_list_comprehension] = STATE(1235),
    [sym_dictionary_comprehension] = STATE(1235),
    [sym_set_comprehension] = STATE(1235),
    [sym_generator_expression] = STATE(1235),
    [sym_parenthesized_expression] = STATE(1235),
    [sym_concatenated_string] = STATE(1235),
    [sym_string] = STATE(987),
    [sym_await] = STATE(1235),
    [sym_identifier] = ACTIONS(704),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(706),
    [anon_sym_COMMA] = ACTIONS(277),
    [anon_sym_as] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(708),
    [anon_sym_print] = ACTIONS(710),
    [anon_sym_GT_GT] = ACTIONS(277),
    [anon_sym_COLON_EQ] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_COLON] = ACTIONS(279),
    [anon_sym_match] = ACTIONS(710),
    [anon_sym_async] = ACTIONS(710),
    [anon_sym_for] = ACTIONS(279),
    [anon_sym_in] = ACTIONS(279),
    [anon_sym_STAR_STAR] = ACTIONS(277),
    [anon_sym_exec] = ACTIONS(710),
    [anon_sym_type] = ACTIONS(712),
    [anon_sym_LBRACK] = ACTIONS(714),
    [anon_sym_AT] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(716),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_LBRACE] = ACTIONS(718),
    [anon_sym_RBRACE] = ACTIONS(277),
    [anon_sym_PLUS] = ACTIONS(716),
    [anon_sym_not] = ACTIONS(279),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(277),
    [anon_sym_SLASH_SLASH] = ACTIONS(277),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_CARET] = ACTIONS(277),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_TILDE] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(279),
    [anon_sym_LT_EQ] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_BANG_EQ] = ACTIONS(277),
    [anon_sym_GT_EQ] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_LT_GT] = ACTIONS(277),
    [anon_sym_is] = ACTIONS(279),
    [sym_ellipsis] = ACTIONS(720),
    [sym_integer] = ACTIONS(704),
    [sym_float] = ACTIONS(720),
    [anon_sym_await] = ACTIONS(722),
    [sym_true] = ACTIONS(704),
    [sym_false] = ACTIONS(704),
    [sym_none] = ACTIONS(704),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(724),
  },
  [165] = {
    [sym_list_splat_pattern] = STATE(1401),
    [sym_primary_expression] = STATE(1096),
    [sym_binary_operator] = STATE(1303),
    [sym_unary_operator] = STATE(1303),
    [sym_attribute] = STATE(1303),
    [sym_subscript] = STATE(1303),
    [sym_call] = STATE(1303),
    [sym_list] = STATE(1303),
    [sym_set] = STATE(1303),
    [sym_tuple] = STATE(1303),
    [sym_dictionary] = STATE(1303),
    [sym_list_comprehension] = STATE(1303),
    [sym_dictionary_comprehension] = STATE(1303),
    [sym_set_comprehension] = STATE(1303),
    [sym_generator_expression] = STATE(1303),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_concatenated_string] = STATE(1303),
    [sym_string] = STATE(1034),
    [sym_await] = STATE(1303),
    [sym_identifier] = ACTIONS(726),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(728),
    [anon_sym_RPAREN] = ACTIONS(277),
    [anon_sym_COMMA] = ACTIONS(277),
    [anon_sym_as] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(730),
    [anon_sym_print] = ACTIONS(732),
    [anon_sym_GT_GT] = ACTIONS(277),
    [anon_sym_COLON_EQ] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_match] = ACTIONS(732),
    [anon_sym_async] = ACTIONS(732),
    [anon_sym_for] = ACTIONS(279),
    [anon_sym_in] = ACTIONS(279),
    [anon_sym_STAR_STAR] = ACTIONS(277),
    [anon_sym_exec] = ACTIONS(732),
    [anon_sym_type] = ACTIONS(734),
    [anon_sym_EQ] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_AT] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(740),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_LBRACE] = ACTIONS(742),
    [anon_sym_PLUS] = ACTIONS(740),
    [anon_sym_not] = ACTIONS(279),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(277),
    [anon_sym_SLASH_SLASH] = ACTIONS(277),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_CARET] = ACTIONS(277),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_TILDE] = ACTIONS(740),
    [anon_sym_LT] = ACTIONS(279),
    [anon_sym_LT_EQ] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_BANG_EQ] = ACTIONS(277),
    [anon_sym_GT_EQ] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_LT_GT] = ACTIONS(277),
    [anon_sym_is] = ACTIONS(279),
    [sym_ellipsis] = ACTIONS(744),
    [sym_integer] = ACTIONS(726),
    [sym_float] = ACTIONS(744),
    [anon_sym_await] = ACTIONS(746),
    [sym_true] = ACTIONS(726),
    [sym_false] = ACTIONS(726),
    [sym_none] = ACTIONS(726),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(748),
  },
  [166] = {
    [sym_list_splat_pattern] = STATE(1218),
    [sym_primary_expression] = STATE(1041),
    [sym_binary_operator] = STATE(1258),
    [sym_unary_operator] = STATE(1258),
    [sym_attribute] = STATE(1258),
    [sym_subscript] = STATE(1258),
    [sym_call] = STATE(1258),
    [sym_list] = STATE(1258),
    [sym_set] = STATE(1258),
    [sym_tuple] = STATE(1258),
    [sym_dictionary] = STATE(1258),
    [sym_list_comprehension] = STATE(1258),
    [sym_dictionary_comprehension] = STATE(1258),
    [sym_set_comprehension] = STATE(1258),
    [sym_generator_expression] = STATE(1258),
    [sym_parenthesized_expression] = STATE(1258),
    [sym_concatenated_string] = STATE(1258),
    [sym_string] = STATE(977),
    [sym_await] = STATE(1258),
    [sym_identifier] = ACTIONS(682),
    [anon_sym_DOT] = ACTIONS(668),
    [anon_sym_LPAREN] = ACTIONS(684),
    [anon_sym_COMMA] = ACTIONS(679),
    [anon_sym_as] = ACTIONS(668),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_print] = ACTIONS(688),
    [anon_sym_GT_GT] = ACTIONS(679),
    [anon_sym_COLON_EQ] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(668),
    [anon_sym_COLON] = ACTIONS(671),
    [anon_sym_match] = ACTIONS(688),
    [anon_sym_async] = ACTIONS(688),
    [anon_sym_for] = ACTIONS(671),
    [anon_sym_in] = ACTIONS(668),
    [anon_sym_STAR_STAR] = ACTIONS(679),
    [anon_sym_exec] = ACTIONS(688),
    [anon_sym_type] = ACTIONS(690),
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_AT] = ACTIONS(679),
    [anon_sym_DASH] = ACTIONS(694),
    [anon_sym_PIPE] = ACTIONS(679),
    [anon_sym_LBRACE] = ACTIONS(696),
    [anon_sym_RBRACE] = ACTIONS(679),
    [anon_sym_PLUS] = ACTIONS(694),
    [anon_sym_not] = ACTIONS(668),
    [anon_sym_and] = ACTIONS(668),
    [anon_sym_or] = ACTIONS(668),
    [anon_sym_SLASH] = ACTIONS(668),
    [anon_sym_PERCENT] = ACTIONS(679),
    [anon_sym_SLASH_SLASH] = ACTIONS(679),
    [anon_sym_AMP] = ACTIONS(679),
    [anon_sym_CARET] = ACTIONS(679),
    [anon_sym_LT_LT] = ACTIONS(679),
    [anon_sym_TILDE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(668),
    [anon_sym_LT_EQ] = ACTIONS(679),
    [anon_sym_EQ_EQ] = ACTIONS(679),
    [anon_sym_BANG_EQ] = ACTIONS(679),
    [anon_sym_GT_EQ] = ACTIONS(679),
    [anon_sym_GT] = ACTIONS(668),
    [anon_sym_LT_GT] = ACTIONS(679),
    [anon_sym_is] = ACTIONS(668),
    [sym_ellipsis] = ACTIONS(698),
    [sym_integer] = ACTIONS(682),
    [sym_float] = ACTIONS(698),
    [anon_sym_await] = ACTIONS(700),
    [sym_true] = ACTIONS(682),
    [sym_false] = ACTIONS(682),
    [sym_none] = ACTIONS(682),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(702),
  },
  [167] = {
    [sym_list_splat_pattern] = STATE(1218),
    [sym_primary_expression] = STATE(1041),
    [sym_binary_operator] = STATE(1258),
    [sym_unary_operator] = STATE(1258),
    [sym_attribute] = STATE(1258),
    [sym_subscript] = STATE(1258),
    [sym_call] = STATE(1258),
    [sym_list] = STATE(1258),
    [sym_set] = STATE(1258),
    [sym_tuple] = STATE(1258),
    [sym_dictionary] = STATE(1258),
    [sym_list_comprehension] = STATE(1258),
    [sym_dictionary_comprehension] = STATE(1258),
    [sym_set_comprehension] = STATE(1258),
    [sym_generator_expression] = STATE(1258),
    [sym_parenthesized_expression] = STATE(1258),
    [sym_concatenated_string] = STATE(1258),
    [sym_string] = STATE(977),
    [sym_await] = STATE(1258),
    [sym_identifier] = ACTIONS(682),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(684),
    [anon_sym_COMMA] = ACTIONS(277),
    [anon_sym_as] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(686),
    [anon_sym_print] = ACTIONS(688),
    [anon_sym_GT_GT] = ACTIONS(277),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_COLON] = ACTIONS(277),
    [anon_sym_match] = ACTIONS(688),
    [anon_sym_async] = ACTIONS(688),
    [anon_sym_in] = ACTIONS(279),
    [anon_sym_STAR_STAR] = ACTIONS(277),
    [anon_sym_exec] = ACTIONS(688),
    [anon_sym_type] = ACTIONS(690),
    [anon_sym_EQ] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(692),
    [anon_sym_AT] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(694),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_LBRACE] = ACTIONS(696),
    [anon_sym_RBRACE] = ACTIONS(277),
    [anon_sym_PLUS] = ACTIONS(694),
    [anon_sym_not] = ACTIONS(279),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(277),
    [anon_sym_SLASH_SLASH] = ACTIONS(277),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_CARET] = ACTIONS(277),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_TILDE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(279),
    [anon_sym_LT_EQ] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_BANG_EQ] = ACTIONS(277),
    [anon_sym_GT_EQ] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_LT_GT] = ACTIONS(277),
    [anon_sym_is] = ACTIONS(279),
    [sym_ellipsis] = ACTIONS(698),
    [sym_type_conversion] = ACTIONS(277),
    [sym_integer] = ACTIONS(682),
    [sym_float] = ACTIONS(698),
    [anon_sym_await] = ACTIONS(700),
    [sym_true] = ACTIONS(682),
    [sym_false] = ACTIONS(682),
    [sym_none] = ACTIONS(682),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(702),
  },
  [168] = {
    [sym_list_splat_pattern] = STATE(1323),
    [sym_primary_expression] = STATE(1078),
    [sym_binary_operator] = STATE(1282),
    [sym_unary_operator] = STATE(1282),
    [sym_attribute] = STATE(1282),
    [sym_subscript] = STATE(1282),
    [sym_call] = STATE(1282),
    [sym_list] = STATE(1282),
    [sym_set] = STATE(1282),
    [sym_tuple] = STATE(1282),
    [sym_dictionary] = STATE(1282),
    [sym_list_comprehension] = STATE(1282),
    [sym_dictionary_comprehension] = STATE(1282),
    [sym_set_comprehension] = STATE(1282),
    [sym_generator_expression] = STATE(1282),
    [sym_parenthesized_expression] = STATE(1282),
    [sym_concatenated_string] = STATE(1282),
    [sym_string] = STATE(1007),
    [sym_await] = STATE(1282),
    [sym_identifier] = ACTIONS(320),
    [anon_sym_DOT] = ACTIONS(668),
    [anon_sym_LPAREN] = ACTIONS(408),
    [anon_sym_RPAREN] = ACTIONS(666),
    [anon_sym_COMMA] = ACTIONS(666),
    [anon_sym_as] = ACTIONS(671),
    [anon_sym_STAR] = ACTIONS(410),
    [anon_sym_print] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(671),
    [anon_sym_COLON] = ACTIONS(666),
    [anon_sym_match] = ACTIONS(673),
    [anon_sym_async] = ACTIONS(673),
    [anon_sym_for] = ACTIONS(671),
    [anon_sym_in] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(679),
    [anon_sym_exec] = ACTIONS(673),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_EQ] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(412),
    [anon_sym_AT] = ACTIONS(679),
    [anon_sym_DASH] = ACTIONS(312),
    [anon_sym_PIPE] = ACTIONS(679),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_PLUS] = ACTIONS(312),
    [anon_sym_not] = ACTIONS(671),
    [anon_sym_and] = ACTIONS(671),
    [anon_sym_or] = ACTIONS(671),
    [anon_sym_SLASH] = ACTIONS(668),
    [anon_sym_PERCENT] = ACTIONS(679),
    [anon_sym_SLASH_SLASH] = ACTIONS(679),
    [anon_sym_AMP] = ACTIONS(679),
    [anon_sym_CARET] = ACTIONS(679),
    [anon_sym_LT_LT] = ACTIONS(679),
    [anon_sym_TILDE] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(671),
    [anon_sym_LT_EQ] = ACTIONS(666),
    [anon_sym_EQ_EQ] = ACTIONS(666),
    [anon_sym_BANG_EQ] = ACTIONS(666),
    [anon_sym_GT_EQ] = ACTIONS(666),
    [anon_sym_GT] = ACTIONS(671),
    [anon_sym_LT_GT] = ACTIONS(666),
    [anon_sym_is] = ACTIONS(671),
    [sym_ellipsis] = ACTIONS(318),
    [sym_integer] = ACTIONS(320),
    [sym_float] = ACTIONS(318),
    [anon_sym_await] = ACTIONS(677),
    [sym_true] = ACTIONS(320),
    [sym_false] = ACTIONS(320),
    [sym_none] = ACTIONS(320),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(324),
  },
  [169] = {
    [sym_list_splat_pattern] = STATE(1427),
    [sym_primary_expression] = STATE(1108),
    [sym_binary_operator] = STATE(1304),
    [sym_unary_operator] = STATE(1304),
    [sym_attribute] = STATE(1304),
    [sym_subscript] = STATE(1304),
    [sym_call] = STATE(1304),
    [sym_list] = STATE(1304),
    [sym_set] = STATE(1304),
    [sym_tuple] = STATE(1304),
    [sym_dictionary] = STATE(1304),
    [sym_list_comprehension] = STATE(1304),
    [sym_dictionary_comprehension] = STATE(1304),
    [sym_set_comprehension] = STATE(1304),
    [sym_generator_expression] = STATE(1304),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_concatenated_string] = STATE(1304),
    [sym_string] = STATE(1009),
    [sym_await] = STATE(1304),
    [sym_identifier] = ACTIONS(750),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(752),
    [anon_sym_RPAREN] = ACTIONS(277),
    [anon_sym_COMMA] = ACTIONS(277),
    [anon_sym_as] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(754),
    [anon_sym_print] = ACTIONS(756),
    [anon_sym_GT_GT] = ACTIONS(277),
    [anon_sym_COLON_EQ] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_COLON] = ACTIONS(279),
    [anon_sym_match] = ACTIONS(756),
    [anon_sym_async] = ACTIONS(756),
    [anon_sym_in] = ACTIONS(279),
    [anon_sym_STAR_STAR] = ACTIONS(277),
    [anon_sym_exec] = ACTIONS(756),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_EQ] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(760),
    [anon_sym_AT] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(762),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_LBRACE] = ACTIONS(764),
    [anon_sym_PLUS] = ACTIONS(762),
    [anon_sym_not] = ACTIONS(279),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(277),
    [anon_sym_SLASH_SLASH] = ACTIONS(277),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_CARET] = ACTIONS(277),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_TILDE] = ACTIONS(762),
    [anon_sym_LT] = ACTIONS(279),
    [anon_sym_LT_EQ] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_BANG_EQ] = ACTIONS(277),
    [anon_sym_GT_EQ] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_LT_GT] = ACTIONS(277),
    [anon_sym_is] = ACTIONS(279),
    [sym_ellipsis] = ACTIONS(766),
    [sym_integer] = ACTIONS(750),
    [sym_float] = ACTIONS(766),
    [anon_sym_await] = ACTIONS(768),
    [sym_true] = ACTIONS(750),
    [sym_false] = ACTIONS(750),
    [sym_none] = ACTIONS(750),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(770),
  },
  [170] = {
    [sym_list_splat_pattern] = STATE(1214),
    [sym_primary_expression] = STATE(1019),
    [sym_binary_operator] = STATE(1235),
    [sym_unary_operator] = STATE(1235),
    [sym_attribute] = STATE(1235),
    [sym_subscript] = STATE(1235),
    [sym_call] = STATE(1235),
    [sym_list] = STATE(1235),
    [sym_set] = STATE(1235),
    [sym_tuple] = STATE(1235),
    [sym_dictionary] = STATE(1235),
    [sym_list_comprehension] = STATE(1235),
    [sym_dictionary_comprehension] = STATE(1235),
    [sym_set_comprehension] = STATE(1235),
    [sym_generator_expression] = STATE(1235),
    [sym_parenthesized_expression] = STATE(1235),
    [sym_concatenated_string] = STATE(1235),
    [sym_string] = STATE(987),
    [sym_await] = STATE(1235),
    [sym_identifier] = ACTIONS(704),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(706),
    [anon_sym_COMMA] = ACTIONS(277),
    [anon_sym_as] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(708),
    [anon_sym_print] = ACTIONS(710),
    [anon_sym_GT_GT] = ACTIONS(277),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_COLON] = ACTIONS(277),
    [anon_sym_match] = ACTIONS(710),
    [anon_sym_async] = ACTIONS(710),
    [anon_sym_for] = ACTIONS(279),
    [anon_sym_in] = ACTIONS(279),
    [anon_sym_STAR_STAR] = ACTIONS(277),
    [anon_sym_exec] = ACTIONS(710),
    [anon_sym_type] = ACTIONS(712),
    [anon_sym_LBRACK] = ACTIONS(714),
    [anon_sym_AT] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(716),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_LBRACE] = ACTIONS(718),
    [anon_sym_RBRACE] = ACTIONS(277),
    [anon_sym_PLUS] = ACTIONS(716),
    [anon_sym_not] = ACTIONS(279),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(277),
    [anon_sym_SLASH_SLASH] = ACTIONS(277),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_CARET] = ACTIONS(277),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_TILDE] = ACTIONS(716),
    [anon_sym_LT] = ACTIONS(279),
    [anon_sym_LT_EQ] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_BANG_EQ] = ACTIONS(277),
    [anon_sym_GT_EQ] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_LT_GT] = ACTIONS(277),
    [anon_sym_is] = ACTIONS(279),
    [sym_ellipsis] = ACTIONS(720),
    [sym_integer] = ACTIONS(704),
    [sym_float] = ACTIONS(720),
    [anon_sym_await] = ACTIONS(722),
    [sym_true] = ACTIONS(704),
    [sym_false] = ACTIONS(704),
    [sym_none] = ACTIONS(704),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(724),
  },
  [171] = {
    [sym_list_splat_pattern] = STATE(1310),
    [sym_primary_expression] = STATE(1146),
    [sym_binary_operator] = STATE(1279),
    [sym_unary_operator] = STATE(1279),
    [sym_attribute] = STATE(1279),
    [sym_subscript] = STATE(1279),
    [sym_call] = STATE(1279),
    [sym_list] = STATE(1279),
    [sym_set] = STATE(1279),
    [sym_tuple] = STATE(1279),
    [sym_dictionary] = STATE(1279),
    [sym_list_comprehension] = STATE(1279),
    [sym_dictionary_comprehension] = STATE(1279),
    [sym_set_comprehension] = STATE(1279),
    [sym_generator_expression] = STATE(1279),
    [sym_parenthesized_expression] = STATE(1279),
    [sym_concatenated_string] = STATE(1279),
    [sym_string] = STATE(1011),
    [sym_await] = STATE(1279),
    [sym_identifier] = ACTIONS(772),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(774),
    [anon_sym_COMMA] = ACTIONS(284),
    [anon_sym_as] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(776),
    [anon_sym_print] = ACTIONS(778),
    [anon_sym_GT_GT] = ACTIONS(277),
    [anon_sym_COLON_EQ] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_match] = ACTIONS(778),
    [anon_sym_async] = ACTIONS(778),
    [anon_sym_for] = ACTIONS(279),
    [anon_sym_in] = ACTIONS(279),
    [anon_sym_STAR_STAR] = ACTIONS(277),
    [anon_sym_exec] = ACTIONS(778),
    [anon_sym_type] = ACTIONS(780),
    [anon_sym_LBRACK] = ACTIONS(782),
    [anon_sym_RBRACK] = ACTIONS(284),
    [anon_sym_AT] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(784),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_LBRACE] = ACTIONS(786),
    [anon_sym_PLUS] = ACTIONS(784),
    [anon_sym_not] = ACTIONS(279),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(277),
    [anon_sym_SLASH_SLASH] = ACTIONS(277),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_CARET] = ACTIONS(277),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_TILDE] = ACTIONS(784),
    [anon_sym_LT] = ACTIONS(279),
    [anon_sym_LT_EQ] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_BANG_EQ] = ACTIONS(277),
    [anon_sym_GT_EQ] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_LT_GT] = ACTIONS(277),
    [anon_sym_is] = ACTIONS(279),
    [sym_ellipsis] = ACTIONS(788),
    [sym_integer] = ACTIONS(772),
    [sym_float] = ACTIONS(788),
    [anon_sym_await] = ACTIONS(790),
    [sym_true] = ACTIONS(772),
    [sym_false] = ACTIONS(772),
    [sym_none] = ACTIONS(772),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(792),
  },
  [172] = {
    [sym_list_splat_pattern] = STATE(1323),
    [sym_primary_expression] = STATE(1078),
    [sym_binary_operator] = STATE(1282),
    [sym_unary_operator] = STATE(1282),
    [sym_attribute] = STATE(1282),
    [sym_subscript] = STATE(1282),
    [sym_call] = STATE(1282),
    [sym_list] = STATE(1282),
    [sym_set] = STATE(1282),
    [sym_tuple] = STATE(1282),
    [sym_dictionary] = STATE(1282),
    [sym_list_comprehension] = STATE(1282),
    [sym_dictionary_comprehension] = STATE(1282),
    [sym_set_comprehension] = STATE(1282),
    [sym_generator_expression] = STATE(1282),
    [sym_parenthesized_expression] = STATE(1282),
    [sym_concatenated_string] = STATE(1282),
    [sym_string] = STATE(1007),
    [sym_await] = STATE(1282),
    [sym_identifier] = ACTIONS(320),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(408),
    [anon_sym_COMMA] = ACTIONS(277),
    [anon_sym_as] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(410),
    [anon_sym_print] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(277),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_COLON] = ACTIONS(277),
    [anon_sym_else] = ACTIONS(279),
    [anon_sym_match] = ACTIONS(673),
    [anon_sym_async] = ACTIONS(673),
    [anon_sym_in] = ACTIONS(279),
    [anon_sym_STAR_STAR] = ACTIONS(277),
    [anon_sym_exec] = ACTIONS(673),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_EQ] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(412),
    [anon_sym_AT] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(312),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_PLUS] = ACTIONS(312),
    [anon_sym_not] = ACTIONS(279),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(277),
    [anon_sym_SLASH_SLASH] = ACTIONS(277),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_CARET] = ACTIONS(277),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_TILDE] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(279),
    [anon_sym_LT_EQ] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_BANG_EQ] = ACTIONS(277),
    [anon_sym_GT_EQ] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_LT_GT] = ACTIONS(277),
    [anon_sym_is] = ACTIONS(279),
    [sym_ellipsis] = ACTIONS(318),
    [sym_integer] = ACTIONS(320),
    [sym_float] = ACTIONS(318),
    [anon_sym_await] = ACTIONS(677),
    [sym_true] = ACTIONS(320),
    [sym_false] = ACTIONS(320),
    [sym_none] = ACTIONS(320),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(324),
  },
  [173] = {
    [sym_list_splat_pattern] = STATE(1323),
    [sym_primary_expression] = STATE(1078),
    [sym_binary_operator] = STATE(1282),
    [sym_unary_operator] = STATE(1282),
    [sym_attribute] = STATE(1282),
    [sym_subscript] = STATE(1282),
    [sym_call] = STATE(1282),
    [sym_list] = STATE(1282),
    [sym_set] = STATE(1282),
    [sym_tuple] = STATE(1282),
    [sym_dictionary] = STATE(1282),
    [sym_list_comprehension] = STATE(1282),
    [sym_dictionary_comprehension] = STATE(1282),
    [sym_set_comprehension] = STATE(1282),
    [sym_generator_expression] = STATE(1282),
    [sym_parenthesized_expression] = STATE(1282),
    [sym_concatenated_string] = STATE(1282),
    [sym_string] = STATE(1007),
    [sym_await] = STATE(1282),
    [sym_identifier] = ACTIONS(320),
    [anon_sym_DOT] = ACTIONS(668),
    [anon_sym_LPAREN] = ACTIONS(408),
    [anon_sym_COMMA] = ACTIONS(666),
    [anon_sym_as] = ACTIONS(671),
    [anon_sym_STAR] = ACTIONS(410),
    [anon_sym_print] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(671),
    [anon_sym_COLON] = ACTIONS(666),
    [anon_sym_else] = ACTIONS(671),
    [anon_sym_match] = ACTIONS(673),
    [anon_sym_async] = ACTIONS(673),
    [anon_sym_in] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(679),
    [anon_sym_exec] = ACTIONS(673),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_EQ] = ACTIONS(671),
    [anon_sym_LBRACK] = ACTIONS(412),
    [anon_sym_AT] = ACTIONS(679),
    [anon_sym_DASH] = ACTIONS(312),
    [anon_sym_PIPE] = ACTIONS(679),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_PLUS] = ACTIONS(312),
    [anon_sym_not] = ACTIONS(671),
    [anon_sym_and] = ACTIONS(671),
    [anon_sym_or] = ACTIONS(671),
    [anon_sym_SLASH] = ACTIONS(668),
    [anon_sym_PERCENT] = ACTIONS(679),
    [anon_sym_SLASH_SLASH] = ACTIONS(679),
    [anon_sym_AMP] = ACTIONS(679),
    [anon_sym_CARET] = ACTIONS(679),
    [anon_sym_LT_LT] = ACTIONS(679),
    [anon_sym_TILDE] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(671),
    [anon_sym_LT_EQ] = ACTIONS(666),
    [anon_sym_EQ_EQ] = ACTIONS(666),
    [anon_sym_BANG_EQ] = ACTIONS(666),
    [anon_sym_GT_EQ] = ACTIONS(666),
    [anon_sym_GT] = ACTIONS(671),
    [anon_sym_LT_GT] = ACTIONS(666),
    [anon_sym_is] = ACTIONS(671),
    [sym_ellipsis] = ACTIONS(318),
    [sym_integer] = ACTIONS(320),
    [sym_float] = ACTIONS(318),
    [anon_sym_await] = ACTIONS(677),
    [sym_true] = ACTIONS(320),
    [sym_false] = ACTIONS(320),
    [sym_none] = ACTIONS(320),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(324),
  },
  [174] = {
    [sym_list_splat_pattern] = STATE(1323),
    [sym_primary_expression] = STATE(1078),
    [sym_binary_operator] = STATE(1282),
    [sym_unary_operator] = STATE(1282),
    [sym_attribute] = STATE(1282),
    [sym_subscript] = STATE(1282),
    [sym_call] = STATE(1282),
    [sym_list] = STATE(1282),
    [sym_set] = STATE(1282),
    [sym_tuple] = STATE(1282),
    [sym_dictionary] = STATE(1282),
    [sym_list_comprehension] = STATE(1282),
    [sym_dictionary_comprehension] = STATE(1282),
    [sym_set_comprehension] = STATE(1282),
    [sym_generator_expression] = STATE(1282),
    [sym_parenthesized_expression] = STATE(1282),
    [sym_concatenated_string] = STATE(1282),
    [sym_string] = STATE(1007),
    [sym_await] = STATE(1282),
    [sym_identifier] = ACTIONS(320),
    [anon_sym_SEMI] = ACTIONS(316),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(408),
    [anon_sym_COMMA] = ACTIONS(316),
    [anon_sym_STAR] = ACTIONS(410),
    [anon_sym_print] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(279),
    [anon_sym_COLON] = ACTIONS(316),
    [anon_sym_match] = ACTIONS(673),
    [anon_sym_async] = ACTIONS(673),
    [anon_sym_STAR_STAR] = ACTIONS(279),
    [anon_sym_exec] = ACTIONS(673),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_EQ] = ACTIONS(316),
    [anon_sym_LBRACK] = ACTIONS(412),
    [anon_sym_AT] = ACTIONS(279),
    [anon_sym_DASH] = ACTIONS(414),
    [anon_sym_PIPE] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_PLUS] = ACTIONS(414),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(279),
    [anon_sym_SLASH_SLASH] = ACTIONS(279),
    [anon_sym_AMP] = ACTIONS(279),
    [anon_sym_CARET] = ACTIONS(279),
    [anon_sym_LT_LT] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(312),
    [anon_sym_PLUS_EQ] = ACTIONS(316),
    [anon_sym_DASH_EQ] = ACTIONS(316),
    [anon_sym_STAR_EQ] = ACTIONS(316),
    [anon_sym_SLASH_EQ] = ACTIONS(316),
    [anon_sym_AT_EQ] = ACTIONS(316),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(316),
    [anon_sym_PERCENT_EQ] = ACTIONS(316),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(316),
    [anon_sym_GT_GT_EQ] = ACTIONS(316),
    [anon_sym_LT_LT_EQ] = ACTIONS(316),
    [anon_sym_AMP_EQ] = ACTIONS(316),
    [anon_sym_CARET_EQ] = ACTIONS(316),
    [anon_sym_PIPE_EQ] = ACTIONS(316),
    [sym_ellipsis] = ACTIONS(318),
    [sym_integer] = ACTIONS(320),
    [sym_float] = ACTIONS(318),
    [anon_sym_await] = ACTIONS(677),
    [sym_true] = ACTIONS(320),
    [sym_false] = ACTIONS(320),
    [sym_none] = ACTIONS(320),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(316),
    [sym_string_start] = ACTIONS(324),
  },
  [175] = {
    [sym_list_splat_pattern] = STATE(1310),
    [sym_primary_expression] = STATE(1146),
    [sym_binary_operator] = STATE(1279),
    [sym_unary_operator] = STATE(1279),
    [sym_attribute] = STATE(1279),
    [sym_subscript] = STATE(1279),
    [sym_call] = STATE(1279),
    [sym_list] = STATE(1279),
    [sym_set] = STATE(1279),
    [sym_tuple] = STATE(1279),
    [sym_dictionary] = STATE(1279),
    [sym_list_comprehension] = STATE(1279),
    [sym_dictionary_comprehension] = STATE(1279),
    [sym_set_comprehension] = STATE(1279),
    [sym_generator_expression] = STATE(1279),
    [sym_parenthesized_expression] = STATE(1279),
    [sym_concatenated_string] = STATE(1279),
    [sym_string] = STATE(1011),
    [sym_await] = STATE(1279),
    [sym_identifier] = ACTIONS(772),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(774),
    [anon_sym_COMMA] = ACTIONS(277),
    [anon_sym_as] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(776),
    [anon_sym_print] = ACTIONS(778),
    [anon_sym_GT_GT] = ACTIONS(277),
    [anon_sym_COLON_EQ] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_match] = ACTIONS(778),
    [anon_sym_async] = ACTIONS(778),
    [anon_sym_for] = ACTIONS(279),
    [anon_sym_in] = ACTIONS(279),
    [anon_sym_STAR_STAR] = ACTIONS(277),
    [anon_sym_exec] = ACTIONS(778),
    [anon_sym_type] = ACTIONS(780),
    [anon_sym_LBRACK] = ACTIONS(782),
    [anon_sym_RBRACK] = ACTIONS(277),
    [anon_sym_AT] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(784),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_LBRACE] = ACTIONS(786),
    [anon_sym_PLUS] = ACTIONS(784),
    [anon_sym_not] = ACTIONS(279),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(277),
    [anon_sym_SLASH_SLASH] = ACTIONS(277),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_CARET] = ACTIONS(277),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_TILDE] = ACTIONS(784),
    [anon_sym_LT] = ACTIONS(279),
    [anon_sym_LT_EQ] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_BANG_EQ] = ACTIONS(277),
    [anon_sym_GT_EQ] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_LT_GT] = ACTIONS(277),
    [anon_sym_is] = ACTIONS(279),
    [sym_ellipsis] = ACTIONS(788),
    [sym_integer] = ACTIONS(772),
    [sym_float] = ACTIONS(788),
    [anon_sym_await] = ACTIONS(790),
    [sym_true] = ACTIONS(772),
    [sym_false] = ACTIONS(772),
    [sym_none] = ACTIONS(772),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(792),
  },
  [176] = {
    [sym_list_splat_pattern] = STATE(1484),
    [sym_primary_expression] = STATE(1193),
    [sym_binary_operator] = STATE(1477),
    [sym_unary_operator] = STATE(1477),
    [sym_attribute] = STATE(1477),
    [sym_subscript] = STATE(1477),
    [sym_call] = STATE(1477),
    [sym_list] = STATE(1477),
    [sym_set] = STATE(1477),
    [sym_tuple] = STATE(1477),
    [sym_dictionary] = STATE(1477),
    [sym_list_comprehension] = STATE(1477),
    [sym_dictionary_comprehension] = STATE(1477),
    [sym_set_comprehension] = STATE(1477),
    [sym_generator_expression] = STATE(1477),
    [sym_parenthesized_expression] = STATE(1477),
    [sym_concatenated_string] = STATE(1477),
    [sym_string] = STATE(1152),
    [sym_await] = STATE(1477),
    [sym_identifier] = ACTIONS(794),
    [anon_sym_DOT] = ACTIONS(668),
    [anon_sym_LPAREN] = ACTIONS(796),
    [anon_sym_COMMA] = ACTIONS(679),
    [anon_sym_as] = ACTIONS(668),
    [anon_sym_STAR] = ACTIONS(798),
    [anon_sym_print] = ACTIONS(800),
    [anon_sym_GT_GT] = ACTIONS(679),
    [anon_sym_COLON_EQ] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(668),
    [anon_sym_match] = ACTIONS(800),
    [anon_sym_async] = ACTIONS(800),
    [anon_sym_for] = ACTIONS(671),
    [anon_sym_in] = ACTIONS(668),
    [anon_sym_STAR_STAR] = ACTIONS(679),
    [anon_sym_exec] = ACTIONS(800),
    [anon_sym_type] = ACTIONS(802),
    [anon_sym_LBRACK] = ACTIONS(804),
    [anon_sym_RBRACK] = ACTIONS(679),
    [anon_sym_AT] = ACTIONS(679),
    [anon_sym_DASH] = ACTIONS(806),
    [anon_sym_PIPE] = ACTIONS(679),
    [anon_sym_LBRACE] = ACTIONS(808),
    [anon_sym_PLUS] = ACTIONS(806),
    [anon_sym_not] = ACTIONS(668),
    [anon_sym_and] = ACTIONS(668),
    [anon_sym_or] = ACTIONS(668),
    [anon_sym_SLASH] = ACTIONS(668),
    [anon_sym_PERCENT] = ACTIONS(679),
    [anon_sym_SLASH_SLASH] = ACTIONS(679),
    [anon_sym_AMP] = ACTIONS(679),
    [anon_sym_CARET] = ACTIONS(679),
    [anon_sym_LT_LT] = ACTIONS(679),
    [anon_sym_TILDE] = ACTIONS(806),
    [anon_sym_LT] = ACTIONS(668),
    [anon_sym_LT_EQ] = ACTIONS(679),
    [anon_sym_EQ_EQ] = ACTIONS(679),
    [anon_sym_BANG_EQ] = ACTIONS(679),
    [anon_sym_GT_EQ] = ACTIONS(679),
    [anon_sym_GT] = ACTIONS(668),
    [anon_sym_LT_GT] = ACTIONS(679),
    [anon_sym_is] = ACTIONS(668),
    [sym_ellipsis] = ACTIONS(810),
    [sym_integer] = ACTIONS(794),
    [sym_float] = ACTIONS(810),
    [anon_sym_await] = ACTIONS(812),
    [sym_true] = ACTIONS(794),
    [sym_false] = ACTIONS(794),
    [sym_none] = ACTIONS(794),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(814),
  },
  [177] = {
    [sym_list_splat_pattern] = STATE(1427),
    [sym_primary_expression] = STATE(1108),
    [sym_binary_operator] = STATE(1304),
    [sym_unary_operator] = STATE(1304),
    [sym_attribute] = STATE(1304),
    [sym_subscript] = STATE(1304),
    [sym_call] = STATE(1304),
    [sym_list] = STATE(1304),
    [sym_set] = STATE(1304),
    [sym_tuple] = STATE(1304),
    [sym_dictionary] = STATE(1304),
    [sym_list_comprehension] = STATE(1304),
    [sym_dictionary_comprehension] = STATE(1304),
    [sym_set_comprehension] = STATE(1304),
    [sym_generator_expression] = STATE(1304),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_concatenated_string] = STATE(1304),
    [sym_string] = STATE(1009),
    [sym_await] = STATE(1304),
    [sym_identifier] = ACTIONS(750),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(752),
    [anon_sym_RPAREN] = ACTIONS(277),
    [anon_sym_COMMA] = ACTIONS(277),
    [anon_sym_as] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(754),
    [anon_sym_print] = ACTIONS(756),
    [anon_sym_GT_GT] = ACTIONS(277),
    [anon_sym_COLON_EQ] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_match] = ACTIONS(756),
    [anon_sym_async] = ACTIONS(756),
    [anon_sym_in] = ACTIONS(279),
    [anon_sym_STAR_STAR] = ACTIONS(277),
    [anon_sym_exec] = ACTIONS(756),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_EQ] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(760),
    [anon_sym_AT] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(762),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_LBRACE] = ACTIONS(764),
    [anon_sym_PLUS] = ACTIONS(762),
    [anon_sym_not] = ACTIONS(279),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(277),
    [anon_sym_SLASH_SLASH] = ACTIONS(277),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_CARET] = ACTIONS(277),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_TILDE] = ACTIONS(762),
    [anon_sym_LT] = ACTIONS(279),
    [anon_sym_LT_EQ] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_BANG_EQ] = ACTIONS(277),
    [anon_sym_GT_EQ] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_LT_GT] = ACTIONS(277),
    [anon_sym_is] = ACTIONS(279),
    [sym_ellipsis] = ACTIONS(766),
    [sym_integer] = ACTIONS(750),
    [sym_float] = ACTIONS(766),
    [anon_sym_await] = ACTIONS(768),
    [sym_true] = ACTIONS(750),
    [sym_false] = ACTIONS(750),
    [sym_none] = ACTIONS(750),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(770),
  },
  [178] = {
    [sym_list_splat_pattern] = STATE(1323),
    [sym_primary_expression] = STATE(1078),
    [sym_binary_operator] = STATE(1282),
    [sym_unary_operator] = STATE(1282),
    [sym_attribute] = STATE(1282),
    [sym_subscript] = STATE(1282),
    [sym_call] = STATE(1282),
    [sym_list] = STATE(1282),
    [sym_set] = STATE(1282),
    [sym_tuple] = STATE(1282),
    [sym_dictionary] = STATE(1282),
    [sym_list_comprehension] = STATE(1282),
    [sym_dictionary_comprehension] = STATE(1282),
    [sym_set_comprehension] = STATE(1282),
    [sym_generator_expression] = STATE(1282),
    [sym_parenthesized_expression] = STATE(1282),
    [sym_concatenated_string] = STATE(1282),
    [sym_string] = STATE(1007),
    [sym_await] = STATE(1282),
    [sym_identifier] = ACTIONS(320),
    [anon_sym_DOT] = ACTIONS(668),
    [anon_sym_LPAREN] = ACTIONS(408),
    [anon_sym_COMMA] = ACTIONS(666),
    [anon_sym_as] = ACTIONS(671),
    [anon_sym_STAR] = ACTIONS(410),
    [anon_sym_print] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(671),
    [anon_sym_COLON] = ACTIONS(666),
    [anon_sym_match] = ACTIONS(673),
    [anon_sym_async] = ACTIONS(673),
    [anon_sym_for] = ACTIONS(671),
    [anon_sym_in] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(679),
    [anon_sym_exec] = ACTIONS(673),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_LBRACK] = ACTIONS(412),
    [anon_sym_RBRACK] = ACTIONS(666),
    [anon_sym_AT] = ACTIONS(679),
    [anon_sym_DASH] = ACTIONS(312),
    [anon_sym_PIPE] = ACTIONS(679),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_PLUS] = ACTIONS(312),
    [anon_sym_not] = ACTIONS(671),
    [anon_sym_and] = ACTIONS(671),
    [anon_sym_or] = ACTIONS(671),
    [anon_sym_SLASH] = ACTIONS(668),
    [anon_sym_PERCENT] = ACTIONS(679),
    [anon_sym_SLASH_SLASH] = ACTIONS(679),
    [anon_sym_AMP] = ACTIONS(679),
    [anon_sym_CARET] = ACTIONS(679),
    [anon_sym_LT_LT] = ACTIONS(679),
    [anon_sym_TILDE] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(671),
    [anon_sym_LT_EQ] = ACTIONS(666),
    [anon_sym_EQ_EQ] = ACTIONS(666),
    [anon_sym_BANG_EQ] = ACTIONS(666),
    [anon_sym_GT_EQ] = ACTIONS(666),
    [anon_sym_GT] = ACTIONS(671),
    [anon_sym_LT_GT] = ACTIONS(666),
    [anon_sym_is] = ACTIONS(671),
    [sym_ellipsis] = ACTIONS(318),
    [sym_integer] = ACTIONS(320),
    [sym_float] = ACTIONS(318),
    [anon_sym_await] = ACTIONS(677),
    [sym_true] = ACTIONS(320),
    [sym_false] = ACTIONS(320),
    [sym_none] = ACTIONS(320),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(324),
  },
  [179] = {
    [sym_list_splat_pattern] = STATE(1401),
    [sym_primary_expression] = STATE(1096),
    [sym_binary_operator] = STATE(1303),
    [sym_unary_operator] = STATE(1303),
    [sym_attribute] = STATE(1303),
    [sym_subscript] = STATE(1303),
    [sym_call] = STATE(1303),
    [sym_list] = STATE(1303),
    [sym_set] = STATE(1303),
    [sym_tuple] = STATE(1303),
    [sym_dictionary] = STATE(1303),
    [sym_list_comprehension] = STATE(1303),
    [sym_dictionary_comprehension] = STATE(1303),
    [sym_set_comprehension] = STATE(1303),
    [sym_generator_expression] = STATE(1303),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_concatenated_string] = STATE(1303),
    [sym_string] = STATE(1034),
    [sym_await] = STATE(1303),
    [sym_identifier] = ACTIONS(726),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(728),
    [anon_sym_RPAREN] = ACTIONS(277),
    [anon_sym_COMMA] = ACTIONS(277),
    [anon_sym_as] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(730),
    [anon_sym_print] = ACTIONS(732),
    [anon_sym_GT_GT] = ACTIONS(277),
    [anon_sym_COLON_EQ] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_match] = ACTIONS(732),
    [anon_sym_async] = ACTIONS(732),
    [anon_sym_for] = ACTIONS(279),
    [anon_sym_in] = ACTIONS(279),
    [anon_sym_STAR_STAR] = ACTIONS(277),
    [anon_sym_exec] = ACTIONS(732),
    [anon_sym_type] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_AT] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(740),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_LBRACE] = ACTIONS(742),
    [anon_sym_PLUS] = ACTIONS(740),
    [anon_sym_not] = ACTIONS(279),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(277),
    [anon_sym_SLASH_SLASH] = ACTIONS(277),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_CARET] = ACTIONS(277),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_TILDE] = ACTIONS(740),
    [anon_sym_LT] = ACTIONS(279),
    [anon_sym_LT_EQ] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_BANG_EQ] = ACTIONS(277),
    [anon_sym_GT_EQ] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_LT_GT] = ACTIONS(277),
    [anon_sym_is] = ACTIONS(279),
    [sym_ellipsis] = ACTIONS(744),
    [sym_integer] = ACTIONS(726),
    [sym_float] = ACTIONS(744),
    [anon_sym_await] = ACTIONS(746),
    [sym_true] = ACTIONS(726),
    [sym_false] = ACTIONS(726),
    [sym_none] = ACTIONS(726),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(748),
  },
  [180] = {
    [sym_list_splat_pattern] = STATE(1484),
    [sym_primary_expression] = STATE(1193),
    [sym_binary_operator] = STATE(1477),
    [sym_unary_operator] = STATE(1477),
    [sym_attribute] = STATE(1477),
    [sym_subscript] = STATE(1477),
    [sym_call] = STATE(1477),
    [sym_list] = STATE(1477),
    [sym_set] = STATE(1477),
    [sym_tuple] = STATE(1477),
    [sym_dictionary] = STATE(1477),
    [sym_list_comprehension] = STATE(1477),
    [sym_dictionary_comprehension] = STATE(1477),
    [sym_set_comprehension] = STATE(1477),
    [sym_generator_expression] = STATE(1477),
    [sym_parenthesized_expression] = STATE(1477),
    [sym_concatenated_string] = STATE(1477),
    [sym_string] = STATE(1152),
    [sym_await] = STATE(1477),
    [sym_identifier] = ACTIONS(794),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(796),
    [anon_sym_COMMA] = ACTIONS(277),
    [anon_sym_as] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(798),
    [anon_sym_print] = ACTIONS(800),
    [anon_sym_GT_GT] = ACTIONS(277),
    [anon_sym_COLON_EQ] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_COLON] = ACTIONS(279),
    [anon_sym_match] = ACTIONS(800),
    [anon_sym_async] = ACTIONS(800),
    [anon_sym_in] = ACTIONS(279),
    [anon_sym_STAR_STAR] = ACTIONS(277),
    [anon_sym_exec] = ACTIONS(800),
    [anon_sym_type] = ACTIONS(802),
    [anon_sym_LBRACK] = ACTIONS(804),
    [anon_sym_RBRACK] = ACTIONS(277),
    [anon_sym_AT] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(806),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_LBRACE] = ACTIONS(808),
    [anon_sym_PLUS] = ACTIONS(806),
    [anon_sym_not] = ACTIONS(279),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(277),
    [anon_sym_SLASH_SLASH] = ACTIONS(277),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_CARET] = ACTIONS(277),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_TILDE] = ACTIONS(806),
    [anon_sym_LT] = ACTIONS(279),
    [anon_sym_LT_EQ] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_BANG_EQ] = ACTIONS(277),
    [anon_sym_GT_EQ] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_LT_GT] = ACTIONS(277),
    [anon_sym_is] = ACTIONS(279),
    [sym_ellipsis] = ACTIONS(810),
    [sym_integer] = ACTIONS(794),
    [sym_float] = ACTIONS(810),
    [anon_sym_await] = ACTIONS(812),
    [sym_true] = ACTIONS(794),
    [sym_false] = ACTIONS(794),
    [sym_none] = ACTIONS(794),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(814),
  },
  [181] = {
    [sym_list_splat_pattern] = STATE(1427),
    [sym_primary_expression] = STATE(1108),
    [sym_binary_operator] = STATE(1304),
    [sym_unary_operator] = STATE(1304),
    [sym_attribute] = STATE(1304),
    [sym_subscript] = STATE(1304),
    [sym_call] = STATE(1304),
    [sym_list] = STATE(1304),
    [sym_set] = STATE(1304),
    [sym_tuple] = STATE(1304),
    [sym_dictionary] = STATE(1304),
    [sym_list_comprehension] = STATE(1304),
    [sym_dictionary_comprehension] = STATE(1304),
    [sym_set_comprehension] = STATE(1304),
    [sym_generator_expression] = STATE(1304),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_concatenated_string] = STATE(1304),
    [sym_string] = STATE(1009),
    [sym_await] = STATE(1304),
    [sym_identifier] = ACTIONS(750),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(752),
    [anon_sym_RPAREN] = ACTIONS(277),
    [anon_sym_COMMA] = ACTIONS(277),
    [anon_sym_as] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(754),
    [anon_sym_print] = ACTIONS(756),
    [anon_sym_GT_GT] = ACTIONS(277),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_COLON] = ACTIONS(277),
    [anon_sym_match] = ACTIONS(756),
    [anon_sym_async] = ACTIONS(756),
    [anon_sym_in] = ACTIONS(279),
    [anon_sym_STAR_STAR] = ACTIONS(277),
    [anon_sym_exec] = ACTIONS(756),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_EQ] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(760),
    [anon_sym_AT] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(762),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_LBRACE] = ACTIONS(764),
    [anon_sym_PLUS] = ACTIONS(762),
    [anon_sym_not] = ACTIONS(279),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(277),
    [anon_sym_SLASH_SLASH] = ACTIONS(277),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_CARET] = ACTIONS(277),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_TILDE] = ACTIONS(762),
    [anon_sym_LT] = ACTIONS(279),
    [anon_sym_LT_EQ] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_BANG_EQ] = ACTIONS(277),
    [anon_sym_GT_EQ] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_LT_GT] = ACTIONS(277),
    [anon_sym_is] = ACTIONS(279),
    [sym_ellipsis] = ACTIONS(766),
    [sym_integer] = ACTIONS(750),
    [sym_float] = ACTIONS(766),
    [anon_sym_await] = ACTIONS(768),
    [sym_true] = ACTIONS(750),
    [sym_false] = ACTIONS(750),
    [sym_none] = ACTIONS(750),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(770),
  },
  [182] = {
    [sym_list_splat_pattern] = STATE(1427),
    [sym_primary_expression] = STATE(1108),
    [sym_binary_operator] = STATE(1304),
    [sym_unary_operator] = STATE(1304),
    [sym_attribute] = STATE(1304),
    [sym_subscript] = STATE(1304),
    [sym_call] = STATE(1304),
    [sym_list] = STATE(1304),
    [sym_set] = STATE(1304),
    [sym_tuple] = STATE(1304),
    [sym_dictionary] = STATE(1304),
    [sym_list_comprehension] = STATE(1304),
    [sym_dictionary_comprehension] = STATE(1304),
    [sym_set_comprehension] = STATE(1304),
    [sym_generator_expression] = STATE(1304),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_concatenated_string] = STATE(1304),
    [sym_string] = STATE(1009),
    [sym_await] = STATE(1304),
    [sym_identifier] = ACTIONS(750),
    [anon_sym_DOT] = ACTIONS(668),
    [anon_sym_LPAREN] = ACTIONS(752),
    [anon_sym_RPAREN] = ACTIONS(679),
    [anon_sym_COMMA] = ACTIONS(679),
    [anon_sym_as] = ACTIONS(668),
    [anon_sym_STAR] = ACTIONS(754),
    [anon_sym_print] = ACTIONS(756),
    [anon_sym_GT_GT] = ACTIONS(679),
    [anon_sym_COLON_EQ] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(668),
    [anon_sym_match] = ACTIONS(756),
    [anon_sym_async] = ACTIONS(756),
    [anon_sym_for] = ACTIONS(671),
    [anon_sym_in] = ACTIONS(668),
    [anon_sym_STAR_STAR] = ACTIONS(679),
    [anon_sym_exec] = ACTIONS(756),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_LBRACK] = ACTIONS(760),
    [anon_sym_AT] = ACTIONS(679),
    [anon_sym_DASH] = ACTIONS(762),
    [anon_sym_PIPE] = ACTIONS(679),
    [anon_sym_LBRACE] = ACTIONS(764),
    [anon_sym_PLUS] = ACTIONS(762),
    [anon_sym_not] = ACTIONS(668),
    [anon_sym_and] = ACTIONS(668),
    [anon_sym_or] = ACTIONS(668),
    [anon_sym_SLASH] = ACTIONS(668),
    [anon_sym_PERCENT] = ACTIONS(679),
    [anon_sym_SLASH_SLASH] = ACTIONS(679),
    [anon_sym_AMP] = ACTIONS(679),
    [anon_sym_CARET] = ACTIONS(679),
    [anon_sym_LT_LT] = ACTIONS(679),
    [anon_sym_TILDE] = ACTIONS(762),
    [anon_sym_LT] = ACTIONS(668),
    [anon_sym_LT_EQ] = ACTIONS(679),
    [anon_sym_EQ_EQ] = ACTIONS(679),
    [anon_sym_BANG_EQ] = ACTIONS(679),
    [anon_sym_GT_EQ] = ACTIONS(679),
    [anon_sym_GT] = ACTIONS(668),
    [anon_sym_LT_GT] = ACTIONS(679),
    [anon_sym_is] = ACTIONS(668),
    [sym_ellipsis] = ACTIONS(766),
    [sym_integer] = ACTIONS(750),
    [sym_float] = ACTIONS(766),
    [anon_sym_await] = ACTIONS(768),
    [sym_true] = ACTIONS(750),
    [sym_false] = ACTIONS(750),
    [sym_none] = ACTIONS(750),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(770),
  },
  [183] = {
    [sym_list_splat_pattern] = STATE(1401),
    [sym_primary_expression] = STATE(1096),
    [sym_binary_operator] = STATE(1303),
    [sym_unary_operator] = STATE(1303),
    [sym_attribute] = STATE(1303),
    [sym_subscript] = STATE(1303),
    [sym_call] = STATE(1303),
    [sym_list] = STATE(1303),
    [sym_set] = STATE(1303),
    [sym_tuple] = STATE(1303),
    [sym_dictionary] = STATE(1303),
    [sym_list_comprehension] = STATE(1303),
    [sym_dictionary_comprehension] = STATE(1303),
    [sym_set_comprehension] = STATE(1303),
    [sym_generator_expression] = STATE(1303),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_concatenated_string] = STATE(1303),
    [sym_string] = STATE(1034),
    [sym_await] = STATE(1303),
    [sym_identifier] = ACTIONS(726),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(728),
    [anon_sym_RPAREN] = ACTIONS(284),
    [anon_sym_COMMA] = ACTIONS(284),
    [anon_sym_as] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(730),
    [anon_sym_print] = ACTIONS(732),
    [anon_sym_GT_GT] = ACTIONS(277),
    [anon_sym_COLON_EQ] = ACTIONS(292),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_match] = ACTIONS(732),
    [anon_sym_async] = ACTIONS(732),
    [anon_sym_for] = ACTIONS(279),
    [anon_sym_in] = ACTIONS(279),
    [anon_sym_STAR_STAR] = ACTIONS(277),
    [anon_sym_exec] = ACTIONS(732),
    [anon_sym_type] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_AT] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(740),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_LBRACE] = ACTIONS(742),
    [anon_sym_PLUS] = ACTIONS(740),
    [anon_sym_not] = ACTIONS(279),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(277),
    [anon_sym_SLASH_SLASH] = ACTIONS(277),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_CARET] = ACTIONS(277),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_TILDE] = ACTIONS(740),
    [anon_sym_LT] = ACTIONS(279),
    [anon_sym_LT_EQ] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_BANG_EQ] = ACTIONS(277),
    [anon_sym_GT_EQ] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_LT_GT] = ACTIONS(277),
    [anon_sym_is] = ACTIONS(279),
    [sym_ellipsis] = ACTIONS(744),
    [sym_integer] = ACTIONS(726),
    [sym_float] = ACTIONS(744),
    [anon_sym_await] = ACTIONS(746),
    [sym_true] = ACTIONS(726),
    [sym_false] = ACTIONS(726),
    [sym_none] = ACTIONS(726),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(748),
  },
  [184] = {
    [sym_list_splat_pattern] = STATE(1401),
    [sym_primary_expression] = STATE(1096),
    [sym_binary_operator] = STATE(1303),
    [sym_unary_operator] = STATE(1303),
    [sym_attribute] = STATE(1303),
    [sym_subscript] = STATE(1303),
    [sym_call] = STATE(1303),
    [sym_list] = STATE(1303),
    [sym_set] = STATE(1303),
    [sym_tuple] = STATE(1303),
    [sym_dictionary] = STATE(1303),
    [sym_list_comprehension] = STATE(1303),
    [sym_dictionary_comprehension] = STATE(1303),
    [sym_set_comprehension] = STATE(1303),
    [sym_generator_expression] = STATE(1303),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_concatenated_string] = STATE(1303),
    [sym_string] = STATE(1034),
    [sym_await] = STATE(1303),
    [sym_identifier] = ACTIONS(726),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(728),
    [anon_sym_RPAREN] = ACTIONS(277),
    [anon_sym_COMMA] = ACTIONS(277),
    [anon_sym_as] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(730),
    [anon_sym_print] = ACTIONS(732),
    [anon_sym_GT_GT] = ACTIONS(277),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_match] = ACTIONS(732),
    [anon_sym_async] = ACTIONS(732),
    [anon_sym_for] = ACTIONS(279),
    [anon_sym_in] = ACTIONS(279),
    [anon_sym_STAR_STAR] = ACTIONS(277),
    [anon_sym_exec] = ACTIONS(732),
    [anon_sym_type] = ACTIONS(734),
    [anon_sym_LBRACK] = ACTIONS(738),
    [anon_sym_AT] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(740),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_LBRACE] = ACTIONS(742),
    [anon_sym_PLUS] = ACTIONS(740),
    [anon_sym_not] = ACTIONS(279),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(277),
    [anon_sym_SLASH_SLASH] = ACTIONS(277),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_CARET] = ACTIONS(277),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_TILDE] = ACTIONS(740),
    [anon_sym_LT] = ACTIONS(279),
    [anon_sym_LT_EQ] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_BANG_EQ] = ACTIONS(277),
    [anon_sym_GT_EQ] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_LT_GT] = ACTIONS(277),
    [anon_sym_is] = ACTIONS(279),
    [sym_ellipsis] = ACTIONS(744),
    [sym_integer] = ACTIONS(726),
    [sym_float] = ACTIONS(744),
    [anon_sym_await] = ACTIONS(746),
    [sym_true] = ACTIONS(726),
    [sym_false] = ACTIONS(726),
    [sym_none] = ACTIONS(726),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(748),
  },
  [185] = {
    [sym_list_splat_pattern] = STATE(1310),
    [sym_primary_expression] = STATE(1146),
    [sym_binary_operator] = STATE(1279),
    [sym_unary_operator] = STATE(1279),
    [sym_attribute] = STATE(1279),
    [sym_subscript] = STATE(1279),
    [sym_call] = STATE(1279),
    [sym_list] = STATE(1279),
    [sym_set] = STATE(1279),
    [sym_tuple] = STATE(1279),
    [sym_dictionary] = STATE(1279),
    [sym_list_comprehension] = STATE(1279),
    [sym_dictionary_comprehension] = STATE(1279),
    [sym_set_comprehension] = STATE(1279),
    [sym_generator_expression] = STATE(1279),
    [sym_parenthesized_expression] = STATE(1279),
    [sym_concatenated_string] = STATE(1279),
    [sym_string] = STATE(1011),
    [sym_await] = STATE(1279),
    [sym_identifier] = ACTIONS(772),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(774),
    [anon_sym_COMMA] = ACTIONS(277),
    [anon_sym_as] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(776),
    [anon_sym_print] = ACTIONS(778),
    [anon_sym_GT_GT] = ACTIONS(277),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_match] = ACTIONS(778),
    [anon_sym_async] = ACTIONS(778),
    [anon_sym_for] = ACTIONS(279),
    [anon_sym_in] = ACTIONS(279),
    [anon_sym_STAR_STAR] = ACTIONS(277),
    [anon_sym_exec] = ACTIONS(778),
    [anon_sym_type] = ACTIONS(780),
    [anon_sym_LBRACK] = ACTIONS(782),
    [anon_sym_RBRACK] = ACTIONS(277),
    [anon_sym_AT] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(784),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_LBRACE] = ACTIONS(786),
    [anon_sym_PLUS] = ACTIONS(784),
    [anon_sym_not] = ACTIONS(279),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(277),
    [anon_sym_SLASH_SLASH] = ACTIONS(277),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_CARET] = ACTIONS(277),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_TILDE] = ACTIONS(784),
    [anon_sym_LT] = ACTIONS(279),
    [anon_sym_LT_EQ] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_BANG_EQ] = ACTIONS(277),
    [anon_sym_GT_EQ] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_LT_GT] = ACTIONS(277),
    [anon_sym_is] = ACTIONS(279),
    [sym_ellipsis] = ACTIONS(788),
    [sym_integer] = ACTIONS(772),
    [sym_float] = ACTIONS(788),
    [anon_sym_await] = ACTIONS(790),
    [sym_true] = ACTIONS(772),
    [sym_false] = ACTIONS(772),
    [sym_none] = ACTIONS(772),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(792),
  },
  [186] = {
    [sym_list_splat_pattern] = STATE(1484),
    [sym_primary_expression] = STATE(1193),
    [sym_binary_operator] = STATE(1477),
    [sym_unary_operator] = STATE(1477),
    [sym_attribute] = STATE(1477),
    [sym_subscript] = STATE(1477),
    [sym_call] = STATE(1477),
    [sym_list] = STATE(1477),
    [sym_set] = STATE(1477),
    [sym_tuple] = STATE(1477),
    [sym_dictionary] = STATE(1477),
    [sym_list_comprehension] = STATE(1477),
    [sym_dictionary_comprehension] = STATE(1477),
    [sym_set_comprehension] = STATE(1477),
    [sym_generator_expression] = STATE(1477),
    [sym_parenthesized_expression] = STATE(1477),
    [sym_concatenated_string] = STATE(1477),
    [sym_string] = STATE(1152),
    [sym_await] = STATE(1477),
    [sym_identifier] = ACTIONS(794),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(796),
    [anon_sym_COMMA] = ACTIONS(277),
    [anon_sym_as] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(798),
    [anon_sym_print] = ACTIONS(800),
    [anon_sym_GT_GT] = ACTIONS(277),
    [anon_sym_if] = ACTIONS(279),
    [anon_sym_COLON] = ACTIONS(277),
    [anon_sym_match] = ACTIONS(800),
    [anon_sym_async] = ACTIONS(800),
    [anon_sym_in] = ACTIONS(279),
    [anon_sym_STAR_STAR] = ACTIONS(277),
    [anon_sym_exec] = ACTIONS(800),
    [anon_sym_type] = ACTIONS(802),
    [anon_sym_LBRACK] = ACTIONS(804),
    [anon_sym_RBRACK] = ACTIONS(277),
    [anon_sym_AT] = ACTIONS(277),
    [anon_sym_DASH] = ACTIONS(806),
    [anon_sym_PIPE] = ACTIONS(277),
    [anon_sym_LBRACE] = ACTIONS(808),
    [anon_sym_PLUS] = ACTIONS(806),
    [anon_sym_not] = ACTIONS(279),
    [anon_sym_and] = ACTIONS(279),
    [anon_sym_or] = ACTIONS(279),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(277),
    [anon_sym_SLASH_SLASH] = ACTIONS(277),
    [anon_sym_AMP] = ACTIONS(277),
    [anon_sym_CARET] = ACTIONS(277),
    [anon_sym_LT_LT] = ACTIONS(277),
    [anon_sym_TILDE] = ACTIONS(806),
    [anon_sym_LT] = ACTIONS(279),
    [anon_sym_LT_EQ] = ACTIONS(277),
    [anon_sym_EQ_EQ] = ACTIONS(277),
    [anon_sym_BANG_EQ] = ACTIONS(277),
    [anon_sym_GT_EQ] = ACTIONS(277),
    [anon_sym_GT] = ACTIONS(279),
    [anon_sym_LT_GT] = ACTIONS(277),
    [anon_sym_is] = ACTIONS(279),
    [sym_ellipsis] = ACTIONS(810),
    [sym_integer] = ACTIONS(794),
    [sym_float] = ACTIONS(810),
    [anon_sym_await] = ACTIONS(812),
    [sym_true] = ACTIONS(794),
    [sym_false] = ACTIONS(794),
    [sym_none] = ACTIONS(794),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(814),
  },
  [187] = {
    [sym_list_splat_pattern] = STATE(1323),
    [sym_primary_expression] = STATE(1078),
    [sym_binary_operator] = STATE(1282),
    [sym_unary_operator] = STATE(1282),
    [sym_attribute] = STATE(1282),
    [sym_subscript] = STATE(1282),
    [sym_call] = STATE(1282),
    [sym_list] = STATE(1282),
    [sym_set] = STATE(1282),
    [sym_tuple] = STATE(1282),
    [sym_dictionary] = STATE(1282),
    [sym_list_comprehension] = STATE(1282),
    [sym_dictionary_comprehension] = STATE(1282),
    [sym_set_comprehension] = STATE(1282),
    [sym_generator_expression] = STATE(1282),
    [sym_parenthesized_expression] = STATE(1282),
    [sym_concatenated_string] = STATE(1282),
    [sym_string] = STATE(1007),
    [sym_await] = STATE(1282),
    [sym_identifier] = ACTIONS(320),
    [anon_sym_DOT] = ACTIONS(279),
    [anon_sym_LPAREN] = ACTIONS(408),
    [anon_sym_COMMA] = ACTIONS(316),
    [anon_sym_STAR] = ACTIONS(410),
    [anon_sym_print] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(279),
    [anon_sym_COLON] = ACTIONS(316),
    [anon_sym_match] = ACTIONS(673),
    [anon_sym_async] = ACTIONS(673),
    [anon_sym_STAR_STAR] = ACTIONS(279),
    [anon_sym_exec] = ACTIONS(673),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_EQ] = ACTIONS(316),
    [anon_sym_LBRACK] = ACTIONS(412),
    [anon_sym_AT] = ACTIONS(279),
    [anon_sym_DASH] = ACTIONS(414),
    [anon_sym_PIPE] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_PLUS] = ACTIONS(414),
    [anon_sym_SLASH] = ACTIONS(279),
    [anon_sym_PERCENT] = ACTIONS(279),
    [anon_sym_SLASH_SLASH] = ACTIONS(279),
    [anon_sym_AMP] = ACTIONS(279),
    [anon_sym_CARET] = ACTIONS(279),
    [anon_sym_LT_LT] = ACTIONS(279),
    [anon_sym_TILDE] = ACTIONS(312),
    [anon_sym_PLUS_EQ] = ACTIONS(316),
    [anon_sym_DASH_EQ] = ACTIONS(316),
    [anon_sym_STAR_EQ] = ACTIONS(316),
    [anon_sym_SLASH_EQ] = ACTIONS(316),
    [anon_sym_AT_EQ] = ACTIONS(316),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(316),
    [anon_sym_PERCENT_EQ] = ACTIONS(316),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(316),
    [anon_sym_GT_GT_EQ] = ACTIONS(316),
    [anon_sym_LT_LT_EQ] = ACTIONS(316),
    [anon_sym_AMP_EQ] = ACTIONS(316),
    [anon_sym_CARET_EQ] = ACTIONS(316),
    [anon_sym_PIPE_EQ] = ACTIONS(316),
    [sym_ellipsis] = ACTIONS(318),
    [sym_integer] = ACTIONS(320),
    [sym_float] = ACTIONS(318),
    [anon_sym_await] = ACTIONS(677),
    [sym_true] = ACTIONS(320),
    [sym_false] = ACTIONS(320),
    [sym_none] = ACTIONS(320),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(324),
  },
  [188] = {
    [sym_list_splat_pattern] = STATE(1323),
    [sym_primary_expression] = STATE(1078),
    [sym_binary_operator] = STATE(1282),
    [sym_unary_operator] = STATE(1282),
    [sym_attribute] = STATE(1282),
    [sym_subscript] = STATE(1282),
    [sym_call] = STATE(1282),
    [sym_list] = STATE(1282),
    [sym_set] = STATE(1282),
    [sym_tuple] = STATE(1282),
    [sym_dictionary] = STATE(1282),
    [sym_list_comprehension] = STATE(1282),
    [sym_dictionary_comprehension] = STATE(1282),
    [sym_set_comprehension] = STATE(1282),
    [sym_generator_expression] = STATE(1282),
    [sym_parenthesized_expression] = STATE(1282),
    [sym_concatenated_string] = STATE(1282),
    [sym_string] = STATE(1007),
    [sym_await] = STATE(1282),
    [sym_identifier] = ACTIONS(320),
    [anon_sym_DOT] = ACTIONS(668),
    [anon_sym_LPAREN] = ACTIONS(408),
    [anon_sym_COMMA] = ACTIONS(666),
    [anon_sym_STAR] = ACTIONS(410),
    [anon_sym_print] = ACTIONS(673),
    [anon_sym_GT_GT] = ACTIONS(668),
    [anon_sym_COLON] = ACTIONS(666),
    [anon_sym_match] = ACTIONS(673),
    [anon_sym_async] = ACTIONS(673),
    [anon_sym_STAR_STAR] = ACTIONS(668),
    [anon_sym_exec] = ACTIONS(673),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_EQ] = ACTIONS(666),
    [anon_sym_LBRACK] = ACTIONS(412),
    [anon_sym_AT] = ACTIONS(668),
    [anon_sym_DASH] = ACTIONS(414),
    [anon_sym_PIPE] = ACTIONS(668),
    [anon_sym_LBRACE] = ACTIONS(307),
    [anon_sym_PLUS] = ACTIONS(414),
    [anon_sym_SLASH] = ACTIONS(668),
    [anon_sym_PERCENT] = ACTIONS(668),
    [anon_sym_SLASH_SLASH] = ACTIONS(668),
    [anon_sym_AMP] = ACTIONS(668),
    [anon_sym_CARET] = ACTIONS(668),
    [anon_sym_LT_LT] = ACTIONS(668),
    [anon_sym_TILDE] = ACTIONS(312),
    [anon_sym_PLUS_EQ] = ACTIONS(666),
    [anon_sym_DASH_EQ] = ACTIONS(666),
    [anon_sym_STAR_EQ] = ACTIONS(666),
    [anon_sym_SLASH_EQ] = ACTIONS(666),
    [anon_sym_AT_EQ] = ACTIONS(666),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(666),
    [anon_sym_PERCENT_EQ] = ACTIONS(666),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(666),
    [anon_sym_GT_GT_EQ] = ACTIONS(666),
    [anon_sym_LT_LT_EQ] = ACTIONS(666),
    [anon_sym_AMP_EQ] = ACTIONS(666),
    [anon_sym_CARET_EQ] = ACTIONS(666),
    [anon_sym_PIPE_EQ] = ACTIONS(666),
    [sym_ellipsis] = ACTIONS(318),
    [sym_integer] = ACTIONS(320),
    [sym_float] = ACTIONS(318),
    [anon_sym_await] = ACTIONS(677),
    [sym_true] = ACTIONS(320),
    [sym_false] = ACTIONS(320),
    [sym_none] = ACTIONS(320),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(324),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 31,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(816), 1,
      sym_identifier,
    ACTIONS(818), 1,
      anon_sym_LPAREN,
    ACTIONS(820), 1,
      anon_sym_RPAREN,
    ACTIONS(822), 1,
      anon_sym_STAR,
    ACTIONS(826), 1,
      anon_sym_type,
    ACTIONS(828), 1,
      anon_sym_LBRACK,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(834), 1,
      anon_sym_yield,
    ACTIONS(836), 1,
      anon_sym_await,
    STATE(1031), 1,
      sym_primary_expression,
    STATE(1034), 1,
      sym_string,
    STATE(1301), 1,
      sym_list_splat_pattern,
    STATE(1701), 1,
      sym_expression,
    STATE(2260), 1,
      sym_yield,
    STATE(2275), 1,
      sym_pattern,
    STATE(2743), 1,
      sym__named_expression_lhs,
    STATE(2751), 1,
      sym__patterns,
    STATE(2814), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    STATE(1299), 2,
      sym_attribute,
      sym_subscript,
    STATE(2274), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    STATE(2531), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(726), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(824), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1826), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1303), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [126] = 31,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(816), 1,
      sym_identifier,
    ACTIONS(818), 1,
      anon_sym_LPAREN,
    ACTIONS(822), 1,
      anon_sym_STAR,
    ACTIONS(826), 1,
      anon_sym_type,
    ACTIONS(828), 1,
      anon_sym_LBRACK,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(834), 1,
      anon_sym_yield,
    ACTIONS(836), 1,
      anon_sym_await,
    ACTIONS(838), 1,
      anon_sym_RPAREN,
    STATE(1031), 1,
      sym_primary_expression,
    STATE(1034), 1,
      sym_string,
    STATE(1301), 1,
      sym_list_splat_pattern,
    STATE(1717), 1,
      sym_expression,
    STATE(2275), 1,
      sym_pattern,
    STATE(2279), 1,
      sym_yield,
    STATE(2743), 1,
      sym__named_expression_lhs,
    STATE(2753), 1,
      sym__collection_elements,
    STATE(2760), 1,
      sym__patterns,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    STATE(1299), 2,
      sym_attribute,
      sym_subscript,
    STATE(2274), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    STATE(2531), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(726), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(824), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1826), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1303), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [252] = 30,
    ACTIONS(714), 1,
      anon_sym_LBRACK,
    ACTIONS(718), 1,
      anon_sym_LBRACE,
    ACTIONS(724), 1,
      sym_string_start,
    ACTIONS(840), 1,
      sym_identifier,
    ACTIONS(842), 1,
      anon_sym_LPAREN,
    ACTIONS(844), 1,
      anon_sym_COMMA,
    ACTIONS(846), 1,
      anon_sym_STAR,
    ACTIONS(850), 1,
      anon_sym_STAR_STAR,
    ACTIONS(852), 1,
      anon_sym_type,
    ACTIONS(854), 1,
      anon_sym_RBRACE,
    ACTIONS(856), 1,
      anon_sym_not,
    ACTIONS(858), 1,
      anon_sym_lambda,
    ACTIONS(860), 1,
      anon_sym_yield,
    ACTIONS(862), 1,
      anon_sym_await,
    STATE(979), 1,
      sym_primary_expression,
    STATE(987), 1,
      sym_string,
    STATE(1214), 1,
      sym_list_splat_pattern,
    STATE(1679), 1,
      sym_expression,
    STATE(1862), 1,
      sym_pair,
    STATE(2269), 1,
      sym_dictionary_splat,
    STATE(2669), 1,
      sym__named_expression_lhs,
    STATE(2780), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(720), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(716), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2412), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(848), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1764), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1235), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [376] = 31,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(816), 1,
      sym_identifier,
    ACTIONS(818), 1,
      anon_sym_LPAREN,
    ACTIONS(822), 1,
      anon_sym_STAR,
    ACTIONS(826), 1,
      anon_sym_type,
    ACTIONS(828), 1,
      anon_sym_LBRACK,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(834), 1,
      anon_sym_yield,
    ACTIONS(836), 1,
      anon_sym_await,
    ACTIONS(864), 1,
      anon_sym_RPAREN,
    STATE(1031), 1,
      sym_primary_expression,
    STATE(1034), 1,
      sym_string,
    STATE(1301), 1,
      sym_list_splat_pattern,
    STATE(1701), 1,
      sym_expression,
    STATE(2260), 1,
      sym_yield,
    STATE(2275), 1,
      sym_pattern,
    STATE(2689), 1,
      sym__patterns,
    STATE(2743), 1,
      sym__named_expression_lhs,
    STATE(2814), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    STATE(1299), 2,
      sym_attribute,
      sym_subscript,
    STATE(2274), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    STATE(2531), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(726), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(824), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1826), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1303), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [502] = 31,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(816), 1,
      sym_identifier,
    ACTIONS(818), 1,
      anon_sym_LPAREN,
    ACTIONS(822), 1,
      anon_sym_STAR,
    ACTIONS(826), 1,
      anon_sym_type,
    ACTIONS(828), 1,
      anon_sym_LBRACK,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(834), 1,
      anon_sym_yield,
    ACTIONS(836), 1,
      anon_sym_await,
    ACTIONS(866), 1,
      anon_sym_RPAREN,
    STATE(1031), 1,
      sym_primary_expression,
    STATE(1034), 1,
      sym_string,
    STATE(1301), 1,
      sym_list_splat_pattern,
    STATE(1701), 1,
      sym_expression,
    STATE(2260), 1,
      sym_yield,
    STATE(2275), 1,
      sym_pattern,
    STATE(2743), 1,
      sym__named_expression_lhs,
    STATE(2760), 1,
      sym__patterns,
    STATE(2814), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    STATE(1299), 2,
      sym_attribute,
      sym_subscript,
    STATE(2274), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    STATE(2531), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(726), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(824), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1826), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1303), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [628] = 30,
    ACTIONS(714), 1,
      anon_sym_LBRACK,
    ACTIONS(718), 1,
      anon_sym_LBRACE,
    ACTIONS(724), 1,
      sym_string_start,
    ACTIONS(840), 1,
      sym_identifier,
    ACTIONS(842), 1,
      anon_sym_LPAREN,
    ACTIONS(846), 1,
      anon_sym_STAR,
    ACTIONS(850), 1,
      anon_sym_STAR_STAR,
    ACTIONS(852), 1,
      anon_sym_type,
    ACTIONS(856), 1,
      anon_sym_not,
    ACTIONS(858), 1,
      anon_sym_lambda,
    ACTIONS(860), 1,
      anon_sym_yield,
    ACTIONS(862), 1,
      anon_sym_await,
    ACTIONS(868), 1,
      anon_sym_COMMA,
    ACTIONS(870), 1,
      anon_sym_RBRACE,
    STATE(979), 1,
      sym_primary_expression,
    STATE(987), 1,
      sym_string,
    STATE(1214), 1,
      sym_list_splat_pattern,
    STATE(1680), 1,
      sym_expression,
    STATE(1891), 1,
      sym_pair,
    STATE(2417), 1,
      sym_dictionary_splat,
    STATE(2634), 1,
      sym__collection_elements,
    STATE(2669), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(720), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(716), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2412), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(848), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1764), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1235), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [752] = 30,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(872), 1,
      sym_identifier,
    ACTIONS(874), 1,
      anon_sym_LPAREN,
    ACTIONS(876), 1,
      anon_sym_STAR,
    ACTIONS(880), 1,
      anon_sym_type,
    ACTIONS(882), 1,
      anon_sym_LBRACK,
    ACTIONS(884), 1,
      anon_sym_RBRACK,
    ACTIONS(886), 1,
      anon_sym_not,
    ACTIONS(888), 1,
      anon_sym_lambda,
    ACTIONS(890), 1,
      anon_sym_yield,
    ACTIONS(892), 1,
      anon_sym_await,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1011), 1,
      sym_string,
    STATE(1414), 1,
      sym_list_splat_pattern,
    STATE(1702), 1,
      sym_expression,
    STATE(2258), 1,
      sym_pattern,
    STATE(2688), 1,
      sym__named_expression_lhs,
    STATE(2777), 1,
      sym__patterns,
    STATE(2778), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    STATE(1416), 2,
      sym_attribute,
      sym_subscript,
    STATE(2616), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2264), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(878), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1811), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1279), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [876] = 30,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(872), 1,
      sym_identifier,
    ACTIONS(874), 1,
      anon_sym_LPAREN,
    ACTIONS(876), 1,
      anon_sym_STAR,
    ACTIONS(880), 1,
      anon_sym_type,
    ACTIONS(882), 1,
      anon_sym_LBRACK,
    ACTIONS(886), 1,
      anon_sym_not,
    ACTIONS(888), 1,
      anon_sym_lambda,
    ACTIONS(890), 1,
      anon_sym_yield,
    ACTIONS(892), 1,
      anon_sym_await,
    ACTIONS(894), 1,
      anon_sym_RBRACK,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1011), 1,
      sym_string,
    STATE(1414), 1,
      sym_list_splat_pattern,
    STATE(1703), 1,
      sym_expression,
    STATE(2258), 1,
      sym_pattern,
    STATE(2688), 1,
      sym__named_expression_lhs,
    STATE(2790), 1,
      sym__collection_elements,
    STATE(2792), 1,
      sym__patterns,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    STATE(1416), 2,
      sym_attribute,
      sym_subscript,
    STATE(2616), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2264), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(878), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1811), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1279), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [1000] = 32,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(816), 1,
      sym_identifier,
    ACTIONS(818), 1,
      anon_sym_LPAREN,
    ACTIONS(822), 1,
      anon_sym_STAR,
    ACTIONS(826), 1,
      anon_sym_type,
    ACTIONS(828), 1,
      anon_sym_LBRACK,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(834), 1,
      anon_sym_yield,
    ACTIONS(836), 1,
      anon_sym_await,
    ACTIONS(896), 1,
      anon_sym_RPAREN,
    STATE(1031), 1,
      sym_primary_expression,
    STATE(1034), 1,
      sym_string,
    STATE(1301), 1,
      sym_list_splat_pattern,
    STATE(1709), 1,
      sym_expression,
    STATE(2275), 1,
      sym_pattern,
    STATE(2479), 1,
      sym_yield,
    STATE(2482), 1,
      sym_list_splat,
    STATE(2489), 1,
      sym_parenthesized_list_splat,
    STATE(2743), 1,
      sym__named_expression_lhs,
    STATE(2751), 1,
      sym__patterns,
    STATE(2765), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    STATE(1299), 2,
      sym_attribute,
      sym_subscript,
    STATE(2531), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(726), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(824), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1826), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1303), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [1128] = 30,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(872), 1,
      sym_identifier,
    ACTIONS(874), 1,
      anon_sym_LPAREN,
    ACTIONS(876), 1,
      anon_sym_STAR,
    ACTIONS(880), 1,
      anon_sym_type,
    ACTIONS(882), 1,
      anon_sym_LBRACK,
    ACTIONS(886), 1,
      anon_sym_not,
    ACTIONS(888), 1,
      anon_sym_lambda,
    ACTIONS(890), 1,
      anon_sym_yield,
    ACTIONS(892), 1,
      anon_sym_await,
    ACTIONS(898), 1,
      anon_sym_RBRACK,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1011), 1,
      sym_string,
    STATE(1414), 1,
      sym_list_splat_pattern,
    STATE(1712), 1,
      sym_expression,
    STATE(2258), 1,
      sym_pattern,
    STATE(2676), 1,
      sym__collection_elements,
    STATE(2688), 1,
      sym__named_expression_lhs,
    STATE(2792), 1,
      sym__patterns,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    STATE(1416), 2,
      sym_attribute,
      sym_subscript,
    STATE(2616), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2264), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(878), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1811), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1279), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [1252] = 30,
    ACTIONS(714), 1,
      anon_sym_LBRACK,
    ACTIONS(718), 1,
      anon_sym_LBRACE,
    ACTIONS(724), 1,
      sym_string_start,
    ACTIONS(840), 1,
      sym_identifier,
    ACTIONS(842), 1,
      anon_sym_LPAREN,
    ACTIONS(846), 1,
      anon_sym_STAR,
    ACTIONS(850), 1,
      anon_sym_STAR_STAR,
    ACTIONS(852), 1,
      anon_sym_type,
    ACTIONS(856), 1,
      anon_sym_not,
    ACTIONS(858), 1,
      anon_sym_lambda,
    ACTIONS(860), 1,
      anon_sym_yield,
    ACTIONS(862), 1,
      anon_sym_await,
    ACTIONS(900), 1,
      anon_sym_COMMA,
    ACTIONS(902), 1,
      anon_sym_RBRACE,
    STATE(979), 1,
      sym_primary_expression,
    STATE(987), 1,
      sym_string,
    STATE(1214), 1,
      sym_list_splat_pattern,
    STATE(1681), 1,
      sym_expression,
    STATE(1872), 1,
      sym_pair,
    STATE(2371), 1,
      sym_dictionary_splat,
    STATE(2669), 1,
      sym__named_expression_lhs,
    STATE(2673), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(720), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(716), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2412), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(848), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1764), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1235), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [1376] = 30,
    ACTIONS(714), 1,
      anon_sym_LBRACK,
    ACTIONS(718), 1,
      anon_sym_LBRACE,
    ACTIONS(724), 1,
      sym_string_start,
    ACTIONS(840), 1,
      sym_identifier,
    ACTIONS(842), 1,
      anon_sym_LPAREN,
    ACTIONS(846), 1,
      anon_sym_STAR,
    ACTIONS(850), 1,
      anon_sym_STAR_STAR,
    ACTIONS(852), 1,
      anon_sym_type,
    ACTIONS(856), 1,
      anon_sym_not,
    ACTIONS(858), 1,
      anon_sym_lambda,
    ACTIONS(860), 1,
      anon_sym_yield,
    ACTIONS(862), 1,
      anon_sym_await,
    ACTIONS(904), 1,
      anon_sym_COMMA,
    ACTIONS(906), 1,
      anon_sym_RBRACE,
    STATE(979), 1,
      sym_primary_expression,
    STATE(987), 1,
      sym_string,
    STATE(1214), 1,
      sym_list_splat_pattern,
    STATE(1683), 1,
      sym_expression,
    STATE(1865), 1,
      sym_pair,
    STATE(2466), 1,
      sym_dictionary_splat,
    STATE(2669), 1,
      sym__named_expression_lhs,
    STATE(2724), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(720), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(716), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2412), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(848), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1764), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1235), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [1500] = 31,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(816), 1,
      sym_identifier,
    ACTIONS(818), 1,
      anon_sym_LPAREN,
    ACTIONS(822), 1,
      anon_sym_STAR,
    ACTIONS(826), 1,
      anon_sym_type,
    ACTIONS(828), 1,
      anon_sym_LBRACK,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(834), 1,
      anon_sym_yield,
    ACTIONS(836), 1,
      anon_sym_await,
    ACTIONS(908), 1,
      anon_sym_RPAREN,
    STATE(1031), 1,
      sym_primary_expression,
    STATE(1034), 1,
      sym_string,
    STATE(1301), 1,
      sym_list_splat_pattern,
    STATE(1717), 1,
      sym_expression,
    STATE(2275), 1,
      sym_pattern,
    STATE(2279), 1,
      sym_yield,
    STATE(2743), 1,
      sym__named_expression_lhs,
    STATE(2753), 1,
      sym__collection_elements,
    STATE(2760), 1,
      sym__patterns,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    STATE(1299), 2,
      sym_attribute,
      sym_subscript,
    STATE(2274), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    STATE(2531), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(726), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(824), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1826), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1303), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [1626] = 30,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(872), 1,
      sym_identifier,
    ACTIONS(874), 1,
      anon_sym_LPAREN,
    ACTIONS(876), 1,
      anon_sym_STAR,
    ACTIONS(880), 1,
      anon_sym_type,
    ACTIONS(882), 1,
      anon_sym_LBRACK,
    ACTIONS(886), 1,
      anon_sym_not,
    ACTIONS(888), 1,
      anon_sym_lambda,
    ACTIONS(890), 1,
      anon_sym_yield,
    ACTIONS(892), 1,
      anon_sym_await,
    ACTIONS(910), 1,
      anon_sym_RBRACK,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1011), 1,
      sym_string,
    STATE(1414), 1,
      sym_list_splat_pattern,
    STATE(1703), 1,
      sym_expression,
    STATE(2258), 1,
      sym_pattern,
    STATE(2659), 1,
      sym__patterns,
    STATE(2688), 1,
      sym__named_expression_lhs,
    STATE(2790), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    STATE(1416), 2,
      sym_attribute,
      sym_subscript,
    STATE(2616), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2264), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(878), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1811), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1279), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [1750] = 28,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(15), 1,
      anon_sym_LPAREN,
    ACTIONS(17), 1,
      anon_sym_STAR,
    ACTIONS(61), 1,
      anon_sym_LBRACK,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(73), 1,
      anon_sym_yield,
    ACTIONS(79), 1,
      anon_sym_await,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(912), 1,
      anon_sym_type,
    STATE(626), 1,
      sym_list_splat_pattern,
    STATE(968), 1,
      sym_string,
    STATE(998), 1,
      sym_primary_expression,
    STATE(1651), 1,
      sym_pattern,
    STATE(1655), 1,
      sym_pattern_list,
    STATE(1848), 1,
      sym_expression,
    STATE(2795), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    STATE(619), 2,
      sym_attribute,
      sym_subscript,
    STATE(1663), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(418), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2598), 5,
      sym_expression_list,
      sym_assignment,
      sym_augmented_assignment,
      sym__right_hand_side,
      sym_yield,
    STATE(1685), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1077), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [1870] = 31,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(816), 1,
      sym_identifier,
    ACTIONS(818), 1,
      anon_sym_LPAREN,
    ACTIONS(822), 1,
      anon_sym_STAR,
    ACTIONS(826), 1,
      anon_sym_type,
    ACTIONS(828), 1,
      anon_sym_LBRACK,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(834), 1,
      anon_sym_yield,
    ACTIONS(836), 1,
      anon_sym_await,
    ACTIONS(914), 1,
      anon_sym_RPAREN,
    STATE(1031), 1,
      sym_primary_expression,
    STATE(1034), 1,
      sym_string,
    STATE(1301), 1,
      sym_list_splat_pattern,
    STATE(1701), 1,
      sym_expression,
    STATE(2260), 1,
      sym_yield,
    STATE(2275), 1,
      sym_pattern,
    STATE(2684), 1,
      sym__patterns,
    STATE(2743), 1,
      sym__named_expression_lhs,
    STATE(2814), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    STATE(1299), 2,
      sym_attribute,
      sym_subscript,
    STATE(2274), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    STATE(2531), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(726), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(824), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1826), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1303), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [1996] = 30,
    ACTIONS(714), 1,
      anon_sym_LBRACK,
    ACTIONS(718), 1,
      anon_sym_LBRACE,
    ACTIONS(724), 1,
      sym_string_start,
    ACTIONS(840), 1,
      sym_identifier,
    ACTIONS(842), 1,
      anon_sym_LPAREN,
    ACTIONS(846), 1,
      anon_sym_STAR,
    ACTIONS(850), 1,
      anon_sym_STAR_STAR,
    ACTIONS(852), 1,
      anon_sym_type,
    ACTIONS(856), 1,
      anon_sym_not,
    ACTIONS(858), 1,
      anon_sym_lambda,
    ACTIONS(860), 1,
      anon_sym_yield,
    ACTIONS(862), 1,
      anon_sym_await,
    ACTIONS(916), 1,
      anon_sym_COMMA,
    ACTIONS(918), 1,
      anon_sym_RBRACE,
    STATE(979), 1,
      sym_primary_expression,
    STATE(987), 1,
      sym_string,
    STATE(1214), 1,
      sym_list_splat_pattern,
    STATE(1689), 1,
      sym_expression,
    STATE(1900), 1,
      sym_pair,
    STATE(2257), 1,
      sym_dictionary_splat,
    STATE(2669), 1,
      sym__named_expression_lhs,
    STATE(2696), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(720), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(716), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2412), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(848), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1764), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1235), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [2120] = 32,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(816), 1,
      sym_identifier,
    ACTIONS(818), 1,
      anon_sym_LPAREN,
    ACTIONS(822), 1,
      anon_sym_STAR,
    ACTIONS(826), 1,
      anon_sym_type,
    ACTIONS(828), 1,
      anon_sym_LBRACK,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(834), 1,
      anon_sym_yield,
    ACTIONS(836), 1,
      anon_sym_await,
    ACTIONS(920), 1,
      anon_sym_RPAREN,
    STATE(1031), 1,
      sym_primary_expression,
    STATE(1034), 1,
      sym_string,
    STATE(1301), 1,
      sym_list_splat_pattern,
    STATE(1695), 1,
      sym_expression,
    STATE(2275), 1,
      sym_pattern,
    STATE(2361), 1,
      sym_yield,
    STATE(2486), 1,
      sym_parenthesized_list_splat,
    STATE(2488), 1,
      sym_list_splat,
    STATE(2683), 1,
      sym__collection_elements,
    STATE(2743), 1,
      sym__named_expression_lhs,
    STATE(2818), 1,
      sym__patterns,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    STATE(1299), 2,
      sym_attribute,
      sym_subscript,
    STATE(2531), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(726), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(824), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1826), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1303), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [2248] = 28,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(15), 1,
      anon_sym_LPAREN,
    ACTIONS(17), 1,
      anon_sym_STAR,
    ACTIONS(61), 1,
      anon_sym_LBRACK,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(73), 1,
      anon_sym_yield,
    ACTIONS(79), 1,
      anon_sym_await,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(912), 1,
      anon_sym_type,
    STATE(626), 1,
      sym_list_splat_pattern,
    STATE(968), 1,
      sym_string,
    STATE(998), 1,
      sym_primary_expression,
    STATE(1651), 1,
      sym_pattern,
    STATE(1655), 1,
      sym_pattern_list,
    STATE(1848), 1,
      sym_expression,
    STATE(2795), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    STATE(619), 2,
      sym_attribute,
      sym_subscript,
    STATE(1663), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(418), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2520), 5,
      sym_expression_list,
      sym_assignment,
      sym_augmented_assignment,
      sym__right_hand_side,
      sym_yield,
    STATE(1685), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1077), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [2368] = 30,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(872), 1,
      sym_identifier,
    ACTIONS(874), 1,
      anon_sym_LPAREN,
    ACTIONS(876), 1,
      anon_sym_STAR,
    ACTIONS(880), 1,
      anon_sym_type,
    ACTIONS(882), 1,
      anon_sym_LBRACK,
    ACTIONS(886), 1,
      anon_sym_not,
    ACTIONS(888), 1,
      anon_sym_lambda,
    ACTIONS(890), 1,
      anon_sym_yield,
    ACTIONS(892), 1,
      anon_sym_await,
    ACTIONS(922), 1,
      anon_sym_RBRACK,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1011), 1,
      sym_string,
    STATE(1414), 1,
      sym_list_splat_pattern,
    STATE(1703), 1,
      sym_expression,
    STATE(2258), 1,
      sym_pattern,
    STATE(2659), 1,
      sym__patterns,
    STATE(2688), 1,
      sym__named_expression_lhs,
    STATE(2790), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    STATE(1416), 2,
      sym_attribute,
      sym_subscript,
    STATE(2616), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2264), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(878), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1811), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1279), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [2492] = 31,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(816), 1,
      sym_identifier,
    ACTIONS(818), 1,
      anon_sym_LPAREN,
    ACTIONS(822), 1,
      anon_sym_STAR,
    ACTIONS(826), 1,
      anon_sym_type,
    ACTIONS(828), 1,
      anon_sym_LBRACK,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(834), 1,
      anon_sym_yield,
    ACTIONS(836), 1,
      anon_sym_await,
    ACTIONS(924), 1,
      anon_sym_RPAREN,
    STATE(1031), 1,
      sym_primary_expression,
    STATE(1034), 1,
      sym_string,
    STATE(1301), 1,
      sym_list_splat_pattern,
    STATE(1701), 1,
      sym_expression,
    STATE(2260), 1,
      sym_yield,
    STATE(2275), 1,
      sym_pattern,
    STATE(2743), 1,
      sym__named_expression_lhs,
    STATE(2760), 1,
      sym__patterns,
    STATE(2814), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    STATE(1299), 2,
      sym_attribute,
      sym_subscript,
    STATE(2274), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    STATE(2531), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(726), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(824), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1826), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1303), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [2618] = 30,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(872), 1,
      sym_identifier,
    ACTIONS(874), 1,
      anon_sym_LPAREN,
    ACTIONS(876), 1,
      anon_sym_STAR,
    ACTIONS(880), 1,
      anon_sym_type,
    ACTIONS(882), 1,
      anon_sym_LBRACK,
    ACTIONS(886), 1,
      anon_sym_not,
    ACTIONS(888), 1,
      anon_sym_lambda,
    ACTIONS(890), 1,
      anon_sym_yield,
    ACTIONS(892), 1,
      anon_sym_await,
    ACTIONS(926), 1,
      anon_sym_RBRACK,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1011), 1,
      sym_string,
    STATE(1414), 1,
      sym_list_splat_pattern,
    STATE(1715), 1,
      sym_expression,
    STATE(2258), 1,
      sym_pattern,
    STATE(2659), 1,
      sym__patterns,
    STATE(2688), 1,
      sym__named_expression_lhs,
    STATE(2817), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    STATE(1416), 2,
      sym_attribute,
      sym_subscript,
    STATE(2616), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2264), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(878), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1811), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1279), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [2742] = 30,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(872), 1,
      sym_identifier,
    ACTIONS(874), 1,
      anon_sym_LPAREN,
    ACTIONS(876), 1,
      anon_sym_STAR,
    ACTIONS(880), 1,
      anon_sym_type,
    ACTIONS(882), 1,
      anon_sym_LBRACK,
    ACTIONS(886), 1,
      anon_sym_not,
    ACTIONS(888), 1,
      anon_sym_lambda,
    ACTIONS(890), 1,
      anon_sym_yield,
    ACTIONS(892), 1,
      anon_sym_await,
    ACTIONS(928), 1,
      anon_sym_RBRACK,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1011), 1,
      sym_string,
    STATE(1414), 1,
      sym_list_splat_pattern,
    STATE(1703), 1,
      sym_expression,
    STATE(2258), 1,
      sym_pattern,
    STATE(2679), 1,
      sym__patterns,
    STATE(2688), 1,
      sym__named_expression_lhs,
    STATE(2790), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    STATE(1416), 2,
      sym_attribute,
      sym_subscript,
    STATE(2616), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2264), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(878), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1811), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1279), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [2866] = 30,
    ACTIONS(714), 1,
      anon_sym_LBRACK,
    ACTIONS(718), 1,
      anon_sym_LBRACE,
    ACTIONS(724), 1,
      sym_string_start,
    ACTIONS(840), 1,
      sym_identifier,
    ACTIONS(842), 1,
      anon_sym_LPAREN,
    ACTIONS(846), 1,
      anon_sym_STAR,
    ACTIONS(850), 1,
      anon_sym_STAR_STAR,
    ACTIONS(852), 1,
      anon_sym_type,
    ACTIONS(856), 1,
      anon_sym_not,
    ACTIONS(858), 1,
      anon_sym_lambda,
    ACTIONS(860), 1,
      anon_sym_yield,
    ACTIONS(862), 1,
      anon_sym_await,
    ACTIONS(930), 1,
      anon_sym_COMMA,
    ACTIONS(932), 1,
      anon_sym_RBRACE,
    STATE(979), 1,
      sym_primary_expression,
    STATE(987), 1,
      sym_string,
    STATE(1214), 1,
      sym_list_splat_pattern,
    STATE(1684), 1,
      sym_expression,
    STATE(1854), 1,
      sym_pair,
    STATE(2464), 1,
      sym_dictionary_splat,
    STATE(2669), 1,
      sym__named_expression_lhs,
    STATE(2717), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(720), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(716), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2412), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(848), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1764), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1235), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [2990] = 30,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(872), 1,
      sym_identifier,
    ACTIONS(874), 1,
      anon_sym_LPAREN,
    ACTIONS(876), 1,
      anon_sym_STAR,
    ACTIONS(880), 1,
      anon_sym_type,
    ACTIONS(882), 1,
      anon_sym_LBRACK,
    ACTIONS(886), 1,
      anon_sym_not,
    ACTIONS(888), 1,
      anon_sym_lambda,
    ACTIONS(890), 1,
      anon_sym_yield,
    ACTIONS(892), 1,
      anon_sym_await,
    ACTIONS(934), 1,
      anon_sym_RBRACK,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1011), 1,
      sym_string,
    STATE(1414), 1,
      sym_list_splat_pattern,
    STATE(1703), 1,
      sym_expression,
    STATE(2258), 1,
      sym_pattern,
    STATE(2688), 1,
      sym__named_expression_lhs,
    STATE(2694), 1,
      sym__patterns,
    STATE(2790), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    STATE(1416), 2,
      sym_attribute,
      sym_subscript,
    STATE(2616), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2264), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(878), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1811), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1279), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [3114] = 30,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(872), 1,
      sym_identifier,
    ACTIONS(874), 1,
      anon_sym_LPAREN,
    ACTIONS(876), 1,
      anon_sym_STAR,
    ACTIONS(880), 1,
      anon_sym_type,
    ACTIONS(882), 1,
      anon_sym_LBRACK,
    ACTIONS(886), 1,
      anon_sym_not,
    ACTIONS(888), 1,
      anon_sym_lambda,
    ACTIONS(890), 1,
      anon_sym_yield,
    ACTIONS(892), 1,
      anon_sym_await,
    ACTIONS(936), 1,
      anon_sym_RBRACK,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1011), 1,
      sym_string,
    STATE(1414), 1,
      sym_list_splat_pattern,
    STATE(1706), 1,
      sym_expression,
    STATE(2258), 1,
      sym_pattern,
    STATE(2655), 1,
      sym__collection_elements,
    STATE(2659), 1,
      sym__patterns,
    STATE(2688), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    STATE(1416), 2,
      sym_attribute,
      sym_subscript,
    STATE(2616), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2264), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(878), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1811), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1279), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [3238] = 30,
    ACTIONS(714), 1,
      anon_sym_LBRACK,
    ACTIONS(718), 1,
      anon_sym_LBRACE,
    ACTIONS(724), 1,
      sym_string_start,
    ACTIONS(840), 1,
      sym_identifier,
    ACTIONS(842), 1,
      anon_sym_LPAREN,
    ACTIONS(846), 1,
      anon_sym_STAR,
    ACTIONS(850), 1,
      anon_sym_STAR_STAR,
    ACTIONS(852), 1,
      anon_sym_type,
    ACTIONS(856), 1,
      anon_sym_not,
    ACTIONS(858), 1,
      anon_sym_lambda,
    ACTIONS(860), 1,
      anon_sym_yield,
    ACTIONS(862), 1,
      anon_sym_await,
    ACTIONS(938), 1,
      anon_sym_COMMA,
    ACTIONS(940), 1,
      anon_sym_RBRACE,
    STATE(979), 1,
      sym_primary_expression,
    STATE(987), 1,
      sym_string,
    STATE(1214), 1,
      sym_list_splat_pattern,
    STATE(1678), 1,
      sym_expression,
    STATE(1892), 1,
      sym_pair,
    STATE(2409), 1,
      sym_dictionary_splat,
    STATE(2636), 1,
      sym__collection_elements,
    STATE(2669), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(720), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(716), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2412), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(848), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1764), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1235), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [3362] = 28,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(15), 1,
      anon_sym_LPAREN,
    ACTIONS(17), 1,
      anon_sym_STAR,
    ACTIONS(61), 1,
      anon_sym_LBRACK,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(73), 1,
      anon_sym_yield,
    ACTIONS(79), 1,
      anon_sym_await,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(912), 1,
      anon_sym_type,
    STATE(626), 1,
      sym_list_splat_pattern,
    STATE(968), 1,
      sym_string,
    STATE(998), 1,
      sym_primary_expression,
    STATE(1651), 1,
      sym_pattern,
    STATE(1655), 1,
      sym_pattern_list,
    STATE(1848), 1,
      sym_expression,
    STATE(2795), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    STATE(619), 2,
      sym_attribute,
      sym_subscript,
    STATE(1663), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(418), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2600), 5,
      sym_expression_list,
      sym_assignment,
      sym_augmented_assignment,
      sym__right_hand_side,
      sym_yield,
    STATE(1685), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1077), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [3482] = 30,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(872), 1,
      sym_identifier,
    ACTIONS(874), 1,
      anon_sym_LPAREN,
    ACTIONS(876), 1,
      anon_sym_STAR,
    ACTIONS(880), 1,
      anon_sym_type,
    ACTIONS(882), 1,
      anon_sym_LBRACK,
    ACTIONS(886), 1,
      anon_sym_not,
    ACTIONS(888), 1,
      anon_sym_lambda,
    ACTIONS(890), 1,
      anon_sym_yield,
    ACTIONS(892), 1,
      anon_sym_await,
    ACTIONS(942), 1,
      anon_sym_RBRACK,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1011), 1,
      sym_string,
    STATE(1414), 1,
      sym_list_splat_pattern,
    STATE(1703), 1,
      sym_expression,
    STATE(2258), 1,
      sym_pattern,
    STATE(2688), 1,
      sym__named_expression_lhs,
    STATE(2777), 1,
      sym__patterns,
    STATE(2790), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    STATE(1416), 2,
      sym_attribute,
      sym_subscript,
    STATE(2616), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2264), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(878), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1811), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1279), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [3606] = 31,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(816), 1,
      sym_identifier,
    ACTIONS(818), 1,
      anon_sym_LPAREN,
    ACTIONS(822), 1,
      anon_sym_STAR,
    ACTIONS(826), 1,
      anon_sym_type,
    ACTIONS(828), 1,
      anon_sym_LBRACK,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(834), 1,
      anon_sym_yield,
    ACTIONS(836), 1,
      anon_sym_await,
    ACTIONS(944), 1,
      anon_sym_RPAREN,
    STATE(1031), 1,
      sym_primary_expression,
    STATE(1034), 1,
      sym_string,
    STATE(1301), 1,
      sym_list_splat_pattern,
    STATE(1701), 1,
      sym_expression,
    STATE(2260), 1,
      sym_yield,
    STATE(2275), 1,
      sym_pattern,
    STATE(2743), 1,
      sym__named_expression_lhs,
    STATE(2814), 1,
      sym__collection_elements,
    STATE(2818), 1,
      sym__patterns,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    STATE(1299), 2,
      sym_attribute,
      sym_subscript,
    STATE(2274), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    STATE(2531), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(726), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(824), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1826), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1303), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [3732] = 31,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(816), 1,
      sym_identifier,
    ACTIONS(818), 1,
      anon_sym_LPAREN,
    ACTIONS(822), 1,
      anon_sym_STAR,
    ACTIONS(826), 1,
      anon_sym_type,
    ACTIONS(828), 1,
      anon_sym_LBRACK,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(834), 1,
      anon_sym_yield,
    ACTIONS(836), 1,
      anon_sym_await,
    ACTIONS(946), 1,
      anon_sym_RPAREN,
    STATE(1031), 1,
      sym_primary_expression,
    STATE(1034), 1,
      sym_string,
    STATE(1301), 1,
      sym_list_splat_pattern,
    STATE(1705), 1,
      sym_expression,
    STATE(2275), 1,
      sym_pattern,
    STATE(2515), 1,
      sym_yield,
    STATE(2691), 1,
      sym__collection_elements,
    STATE(2743), 1,
      sym__named_expression_lhs,
    STATE(2760), 1,
      sym__patterns,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    STATE(1299), 2,
      sym_attribute,
      sym_subscript,
    STATE(2274), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    STATE(2531), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(726), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(824), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1826), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1303), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [3858] = 30,
    ACTIONS(714), 1,
      anon_sym_LBRACK,
    ACTIONS(718), 1,
      anon_sym_LBRACE,
    ACTIONS(724), 1,
      sym_string_start,
    ACTIONS(840), 1,
      sym_identifier,
    ACTIONS(842), 1,
      anon_sym_LPAREN,
    ACTIONS(846), 1,
      anon_sym_STAR,
    ACTIONS(850), 1,
      anon_sym_STAR_STAR,
    ACTIONS(852), 1,
      anon_sym_type,
    ACTIONS(856), 1,
      anon_sym_not,
    ACTIONS(858), 1,
      anon_sym_lambda,
    ACTIONS(860), 1,
      anon_sym_yield,
    ACTIONS(862), 1,
      anon_sym_await,
    ACTIONS(948), 1,
      anon_sym_COMMA,
    ACTIONS(950), 1,
      anon_sym_RBRACE,
    STATE(979), 1,
      sym_primary_expression,
    STATE(987), 1,
      sym_string,
    STATE(1214), 1,
      sym_list_splat_pattern,
    STATE(1692), 1,
      sym_expression,
    STATE(1894), 1,
      sym_pair,
    STATE(2513), 1,
      sym_dictionary_splat,
    STATE(2669), 1,
      sym__named_expression_lhs,
    STATE(2805), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(720), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(716), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2412), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(848), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1764), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1235), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [3982] = 30,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(872), 1,
      sym_identifier,
    ACTIONS(874), 1,
      anon_sym_LPAREN,
    ACTIONS(876), 1,
      anon_sym_STAR,
    ACTIONS(880), 1,
      anon_sym_type,
    ACTIONS(882), 1,
      anon_sym_LBRACK,
    ACTIONS(886), 1,
      anon_sym_not,
    ACTIONS(888), 1,
      anon_sym_lambda,
    ACTIONS(890), 1,
      anon_sym_yield,
    ACTIONS(892), 1,
      anon_sym_await,
    ACTIONS(952), 1,
      anon_sym_RBRACK,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1011), 1,
      sym_string,
    STATE(1414), 1,
      sym_list_splat_pattern,
    STATE(1706), 1,
      sym_expression,
    STATE(2258), 1,
      sym_pattern,
    STATE(2655), 1,
      sym__collection_elements,
    STATE(2659), 1,
      sym__patterns,
    STATE(2688), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    STATE(1416), 2,
      sym_attribute,
      sym_subscript,
    STATE(2616), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2264), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(878), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1811), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1279), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [4106] = 22,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(312), 1,
      anon_sym_TILDE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(954), 1,
      sym_identifier,
    ACTIONS(958), 1,
      anon_sym_LPAREN,
    ACTIONS(960), 1,
      anon_sym_STAR,
    ACTIONS(964), 1,
      anon_sym_type,
    ACTIONS(966), 1,
      anon_sym_LBRACK,
    ACTIONS(968), 1,
      anon_sym_await,
    STATE(1007), 1,
      sym_string,
    STATE(1422), 1,
      sym_list_splat_pattern,
    STATE(1618), 1,
      sym_primary_expression,
    STATE(1638), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(414), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1419), 2,
      sym_attribute,
      sym_subscript,
    STATE(1615), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(962), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1282), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
    ACTIONS(956), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [4213] = 22,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(312), 1,
      anon_sym_TILDE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(954), 1,
      sym_identifier,
    ACTIONS(958), 1,
      anon_sym_LPAREN,
    ACTIONS(960), 1,
      anon_sym_STAR,
    ACTIONS(964), 1,
      anon_sym_type,
    ACTIONS(966), 1,
      anon_sym_LBRACK,
    ACTIONS(968), 1,
      anon_sym_await,
    STATE(1007), 1,
      sym_string,
    STATE(1422), 1,
      sym_list_splat_pattern,
    STATE(1618), 1,
      sym_primary_expression,
    STATE(1638), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(414), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1419), 2,
      sym_attribute,
      sym_subscript,
    STATE(1615), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(962), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1282), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
    ACTIONS(970), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [4320] = 27,
    ACTIONS(696), 1,
      anon_sym_LBRACE,
    ACTIONS(702), 1,
      sym_string_start,
    ACTIONS(860), 1,
      anon_sym_yield,
    ACTIONS(972), 1,
      sym_identifier,
    ACTIONS(974), 1,
      anon_sym_LPAREN,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(982), 1,
      anon_sym_LBRACK,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    STATE(972), 1,
      sym_primary_expression,
    STATE(977), 1,
      sym_string,
    STATE(1242), 1,
      sym_list_splat_pattern,
    STATE(1729), 1,
      sym_expression,
    STATE(2583), 1,
      sym_pattern,
    STATE(2784), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(698), 2,
      sym_ellipsis,
      sym_float,
    STATE(1248), 2,
      sym_attribute,
      sym_subscript,
    STATE(1663), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(694), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(682), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(978), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2095), 4,
      sym_expression_list,
      sym_pattern_list,
      sym_yield,
      sym__f_expression,
    STATE(1794), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1258), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [4436] = 27,
    ACTIONS(696), 1,
      anon_sym_LBRACE,
    ACTIONS(702), 1,
      sym_string_start,
    ACTIONS(860), 1,
      anon_sym_yield,
    ACTIONS(972), 1,
      sym_identifier,
    ACTIONS(974), 1,
      anon_sym_LPAREN,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(980), 1,
      anon_sym_type,
    ACTIONS(982), 1,
      anon_sym_LBRACK,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(988), 1,
      anon_sym_await,
    STATE(972), 1,
      sym_primary_expression,
    STATE(977), 1,
      sym_string,
    STATE(1242), 1,
      sym_list_splat_pattern,
    STATE(1729), 1,
      sym_expression,
    STATE(2583), 1,
      sym_pattern,
    STATE(2784), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(698), 2,
      sym_ellipsis,
      sym_float,
    STATE(1248), 2,
      sym_attribute,
      sym_subscript,
    STATE(1663), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(694), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(682), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(978), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2045), 4,
      sym_expression_list,
      sym_pattern_list,
      sym_yield,
      sym__f_expression,
    STATE(1794), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1258), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [4552] = 27,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(990), 1,
      sym_identifier,
    ACTIONS(992), 1,
      anon_sym_LPAREN,
    ACTIONS(994), 1,
      anon_sym_RPAREN,
    ACTIONS(996), 1,
      anon_sym_COMMA,
    ACTIONS(998), 1,
      anon_sym_STAR,
    ACTIONS(1002), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1004), 1,
      anon_sym_type,
    ACTIONS(1006), 1,
      anon_sym_await,
    STATE(1031), 1,
      sym_primary_expression,
    STATE(1034), 1,
      sym_string,
    STATE(1401), 1,
      sym_list_splat_pattern,
    STATE(1707), 1,
      sym_expression,
    STATE(2437), 1,
      sym_parenthesized_list_splat,
    STATE(2743), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2438), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(726), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1000), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1826), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1303), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [4667] = 25,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1008), 1,
      sym_identifier,
    ACTIONS(1010), 1,
      anon_sym_STAR,
    ACTIONS(1012), 1,
      anon_sym_STAR_STAR,
    STATE(968), 1,
      sym_string,
    STATE(969), 1,
      sym_primary_expression,
    STATE(1125), 1,
      sym_list_splat_pattern,
    STATE(1754), 1,
      sym_expression,
    STATE(2075), 1,
      sym_type,
    STATE(2795), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1984), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1685), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1077), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [4778] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1014), 1,
      sym_identifier,
    ACTIONS(1016), 1,
      anon_sym_STAR,
    ACTIONS(1020), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1787), 1,
      sym_expression,
    STATE(2048), 1,
      sym_type,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2069), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [4889] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1014), 1,
      sym_identifier,
    ACTIONS(1016), 1,
      anon_sym_STAR,
    ACTIONS(1020), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1787), 1,
      sym_expression,
    STATE(2046), 1,
      sym_type,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2069), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [5000] = 27,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(990), 1,
      sym_identifier,
    ACTIONS(992), 1,
      anon_sym_LPAREN,
    ACTIONS(998), 1,
      anon_sym_STAR,
    ACTIONS(1002), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1004), 1,
      anon_sym_type,
    ACTIONS(1006), 1,
      anon_sym_await,
    ACTIONS(1030), 1,
      anon_sym_RPAREN,
    ACTIONS(1032), 1,
      anon_sym_COMMA,
    STATE(1031), 1,
      sym_primary_expression,
    STATE(1034), 1,
      sym_string,
    STATE(1401), 1,
      sym_list_splat_pattern,
    STATE(1693), 1,
      sym_expression,
    STATE(2498), 1,
      sym_parenthesized_list_splat,
    STATE(2743), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2499), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(726), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1000), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1826), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1303), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [5115] = 25,
    ACTIONS(275), 1,
      sym_identifier,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(339), 1,
      anon_sym_STAR_STAR,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1034), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1780), 1,
      sym_expression,
    STATE(2314), 1,
      sym_type,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2093), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [5226] = 25,
    ACTIONS(275), 1,
      sym_identifier,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(339), 1,
      anon_sym_STAR_STAR,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1034), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1780), 1,
      sym_expression,
    STATE(2315), 1,
      sym_type,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2093), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [5337] = 27,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(990), 1,
      sym_identifier,
    ACTIONS(992), 1,
      anon_sym_LPAREN,
    ACTIONS(998), 1,
      anon_sym_STAR,
    ACTIONS(1002), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1004), 1,
      anon_sym_type,
    ACTIONS(1006), 1,
      anon_sym_await,
    ACTIONS(1036), 1,
      anon_sym_RPAREN,
    ACTIONS(1038), 1,
      anon_sym_COMMA,
    STATE(1031), 1,
      sym_primary_expression,
    STATE(1034), 1,
      sym_string,
    STATE(1401), 1,
      sym_list_splat_pattern,
    STATE(1716), 1,
      sym_expression,
    STATE(2457), 1,
      sym_parenthesized_list_splat,
    STATE(2743), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2459), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(726), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1000), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1826), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1303), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [5452] = 22,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(312), 1,
      anon_sym_TILDE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(1040), 1,
      sym_identifier,
    ACTIONS(1042), 1,
      anon_sym_LPAREN,
    ACTIONS(1044), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_type,
    ACTIONS(1050), 1,
      anon_sym_LBRACK,
    ACTIONS(1052), 1,
      anon_sym_await,
    STATE(1007), 1,
      sym_string,
    STATE(1504), 1,
      sym_list_splat_pattern,
    STATE(1634), 1,
      sym_primary_expression,
    STATE(1659), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(414), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1505), 2,
      sym_attribute,
      sym_subscript,
    STATE(1663), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1046), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1282), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
    ACTIONS(956), 15,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [5557] = 25,
    ACTIONS(275), 1,
      sym_identifier,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(339), 1,
      anon_sym_STAR_STAR,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1034), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1780), 1,
      sym_expression,
    STATE(2316), 1,
      sym_type,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2093), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [5668] = 27,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(990), 1,
      sym_identifier,
    ACTIONS(992), 1,
      anon_sym_LPAREN,
    ACTIONS(998), 1,
      anon_sym_STAR,
    ACTIONS(1002), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1004), 1,
      anon_sym_type,
    ACTIONS(1006), 1,
      anon_sym_await,
    ACTIONS(1054), 1,
      anon_sym_RPAREN,
    ACTIONS(1056), 1,
      anon_sym_COMMA,
    STATE(1031), 1,
      sym_primary_expression,
    STATE(1034), 1,
      sym_string,
    STATE(1401), 1,
      sym_list_splat_pattern,
    STATE(1708), 1,
      sym_expression,
    STATE(2289), 1,
      sym_parenthesized_list_splat,
    STATE(2743), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2256), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(726), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1000), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1826), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1303), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [5783] = 25,
    ACTIONS(275), 1,
      sym_identifier,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(339), 1,
      anon_sym_STAR_STAR,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1034), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1780), 1,
      sym_expression,
    STATE(2320), 1,
      sym_type,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2093), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [5894] = 25,
    ACTIONS(275), 1,
      sym_identifier,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(339), 1,
      anon_sym_STAR_STAR,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1034), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1780), 1,
      sym_expression,
    STATE(2380), 1,
      sym_type,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2093), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [6005] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1014), 1,
      sym_identifier,
    ACTIONS(1016), 1,
      anon_sym_STAR,
    ACTIONS(1020), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1787), 1,
      sym_expression,
    STATE(1956), 1,
      sym_type,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2069), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [6116] = 27,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(990), 1,
      sym_identifier,
    ACTIONS(992), 1,
      anon_sym_LPAREN,
    ACTIONS(998), 1,
      anon_sym_STAR,
    ACTIONS(1002), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1004), 1,
      anon_sym_type,
    ACTIONS(1006), 1,
      anon_sym_await,
    ACTIONS(1058), 1,
      anon_sym_RPAREN,
    ACTIONS(1060), 1,
      anon_sym_COMMA,
    STATE(1031), 1,
      sym_primary_expression,
    STATE(1034), 1,
      sym_string,
    STATE(1401), 1,
      sym_list_splat_pattern,
    STATE(1714), 1,
      sym_expression,
    STATE(2318), 1,
      sym_parenthesized_list_splat,
    STATE(2743), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2326), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(726), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1000), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1826), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1303), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [6231] = 25,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1008), 1,
      sym_identifier,
    ACTIONS(1010), 1,
      anon_sym_STAR,
    ACTIONS(1012), 1,
      anon_sym_STAR_STAR,
    STATE(968), 1,
      sym_string,
    STATE(969), 1,
      sym_primary_expression,
    STATE(1125), 1,
      sym_list_splat_pattern,
    STATE(1754), 1,
      sym_expression,
    STATE(1923), 1,
      sym_type,
    STATE(2795), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1984), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1685), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1077), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [6342] = 27,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(990), 1,
      sym_identifier,
    ACTIONS(992), 1,
      anon_sym_LPAREN,
    ACTIONS(998), 1,
      anon_sym_STAR,
    ACTIONS(1002), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1004), 1,
      anon_sym_type,
    ACTIONS(1006), 1,
      anon_sym_await,
    ACTIONS(1062), 1,
      anon_sym_RPAREN,
    ACTIONS(1064), 1,
      anon_sym_COMMA,
    STATE(1031), 1,
      sym_primary_expression,
    STATE(1034), 1,
      sym_string,
    STATE(1401), 1,
      sym_list_splat_pattern,
    STATE(1696), 1,
      sym_expression,
    STATE(2392), 1,
      sym_parenthesized_list_splat,
    STATE(2743), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2391), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(726), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1000), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1826), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1303), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [6457] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1014), 1,
      sym_identifier,
    ACTIONS(1016), 1,
      anon_sym_STAR,
    ACTIONS(1020), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1787), 1,
      sym_expression,
    STATE(1917), 1,
      sym_type,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2069), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [6568] = 25,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1008), 1,
      sym_identifier,
    ACTIONS(1010), 1,
      anon_sym_STAR,
    ACTIONS(1012), 1,
      anon_sym_STAR_STAR,
    STATE(968), 1,
      sym_string,
    STATE(969), 1,
      sym_primary_expression,
    STATE(1125), 1,
      sym_list_splat_pattern,
    STATE(1754), 1,
      sym_expression,
    STATE(1924), 1,
      sym_type,
    STATE(2795), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1984), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1685), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1077), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [6679] = 25,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1008), 1,
      sym_identifier,
    ACTIONS(1010), 1,
      anon_sym_STAR,
    ACTIONS(1012), 1,
      anon_sym_STAR_STAR,
    STATE(968), 1,
      sym_string,
    STATE(969), 1,
      sym_primary_expression,
    STATE(1125), 1,
      sym_list_splat_pattern,
    STATE(1754), 1,
      sym_expression,
    STATE(1979), 1,
      sym_type,
    STATE(2795), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1984), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1685), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1077), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [6790] = 22,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(312), 1,
      anon_sym_TILDE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(1040), 1,
      sym_identifier,
    ACTIONS(1042), 1,
      anon_sym_LPAREN,
    ACTIONS(1044), 1,
      anon_sym_STAR,
    ACTIONS(1048), 1,
      anon_sym_type,
    ACTIONS(1050), 1,
      anon_sym_LBRACK,
    ACTIONS(1052), 1,
      anon_sym_await,
    STATE(1007), 1,
      sym_string,
    STATE(1504), 1,
      sym_list_splat_pattern,
    STATE(1634), 1,
      sym_primary_expression,
    STATE(1659), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(414), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1505), 2,
      sym_attribute,
      sym_subscript,
    STATE(1663), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1046), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1282), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
    ACTIONS(970), 15,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [6895] = 25,
    ACTIONS(275), 1,
      sym_identifier,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(339), 1,
      anon_sym_STAR_STAR,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1034), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1780), 1,
      sym_expression,
    STATE(2512), 1,
      sym_type,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2093), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [7006] = 27,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(990), 1,
      sym_identifier,
    ACTIONS(992), 1,
      anon_sym_LPAREN,
    ACTIONS(998), 1,
      anon_sym_STAR,
    ACTIONS(1002), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1004), 1,
      anon_sym_type,
    ACTIONS(1006), 1,
      anon_sym_await,
    ACTIONS(1066), 1,
      anon_sym_RPAREN,
    ACTIONS(1068), 1,
      anon_sym_COMMA,
    STATE(1031), 1,
      sym_primary_expression,
    STATE(1034), 1,
      sym_string,
    STATE(1401), 1,
      sym_list_splat_pattern,
    STATE(1713), 1,
      sym_expression,
    STATE(2390), 1,
      sym_parenthesized_list_splat,
    STATE(2743), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2393), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(726), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1000), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1826), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1303), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [7121] = 25,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1070), 1,
      sym_identifier,
    ACTIONS(1072), 1,
      anon_sym_STAR,
    ACTIONS(1076), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1078), 1,
      anon_sym_type,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1084), 1,
      anon_sym_await,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1726), 1,
      sym_expression,
    STATE(1990), 1,
      sym_type,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1074), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2006), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [7232] = 25,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1070), 1,
      sym_identifier,
    ACTIONS(1072), 1,
      anon_sym_STAR,
    ACTIONS(1076), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1078), 1,
      anon_sym_type,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1084), 1,
      anon_sym_await,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1726), 1,
      sym_expression,
    STATE(1989), 1,
      sym_type,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1074), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2006), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [7343] = 25,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1070), 1,
      sym_identifier,
    ACTIONS(1072), 1,
      anon_sym_STAR,
    ACTIONS(1076), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1078), 1,
      anon_sym_type,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1084), 1,
      anon_sym_await,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1726), 1,
      sym_expression,
    STATE(1927), 1,
      sym_type,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1074), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2006), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [7454] = 27,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1002), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1054), 1,
      anon_sym_RPAREN,
    ACTIONS(1056), 1,
      anon_sym_COMMA,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1086), 1,
      sym_identifier,
    ACTIONS(1088), 1,
      anon_sym_LPAREN,
    ACTIONS(1090), 1,
      anon_sym_STAR,
    ACTIONS(1094), 1,
      anon_sym_type,
    ACTIONS(1096), 1,
      anon_sym_await,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1901), 1,
      sym_expression,
    STATE(2289), 1,
      sym_parenthesized_list_splat,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2256), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1092), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [7569] = 25,
    ACTIONS(275), 1,
      sym_identifier,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(339), 1,
      anon_sym_STAR_STAR,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1034), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1780), 1,
      sym_expression,
    STATE(2423), 1,
      sym_type,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2093), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [7680] = 25,
    ACTIONS(275), 1,
      sym_identifier,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(339), 1,
      anon_sym_STAR_STAR,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1034), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1780), 1,
      sym_expression,
    STATE(2078), 1,
      sym_type,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2093), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [7791] = 25,
    ACTIONS(275), 1,
      sym_identifier,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(339), 1,
      anon_sym_STAR_STAR,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1034), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1780), 1,
      sym_expression,
    STATE(2074), 1,
      sym_type,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2093), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [7902] = 25,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1070), 1,
      sym_identifier,
    ACTIONS(1072), 1,
      anon_sym_STAR,
    ACTIONS(1076), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1078), 1,
      anon_sym_type,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1084), 1,
      anon_sym_await,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1726), 1,
      sym_expression,
    STATE(2081), 1,
      sym_type,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1074), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2006), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [8013] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1014), 1,
      sym_identifier,
    ACTIONS(1016), 1,
      anon_sym_STAR,
    ACTIONS(1020), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1787), 1,
      sym_expression,
    STATE(2055), 1,
      sym_type,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2069), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [8124] = 25,
    ACTIONS(684), 1,
      anon_sym_LPAREN,
    ACTIONS(692), 1,
      anon_sym_LBRACK,
    ACTIONS(696), 1,
      anon_sym_LBRACE,
    ACTIONS(702), 1,
      sym_string_start,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(1098), 1,
      sym_identifier,
    ACTIONS(1100), 1,
      anon_sym_from,
    ACTIONS(1106), 1,
      anon_sym_type,
    ACTIONS(1108), 1,
      anon_sym_await,
    STATE(972), 1,
      sym_primary_expression,
    STATE(977), 1,
      sym_string,
    STATE(1218), 1,
      sym_list_splat_pattern,
    STATE(1724), 1,
      sym_expression,
    STATE(2066), 1,
      sym_expression_list,
    STATE(2784), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(698), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(694), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(682), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1104), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(1102), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
    STATE(1794), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1258), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [8235] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1014), 1,
      sym_identifier,
    ACTIONS(1016), 1,
      anon_sym_STAR,
    ACTIONS(1020), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1787), 1,
      sym_expression,
    STATE(1940), 1,
      sym_type,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2069), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [8346] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1014), 1,
      sym_identifier,
    ACTIONS(1016), 1,
      anon_sym_STAR,
    ACTIONS(1020), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1787), 1,
      sym_expression,
    STATE(1921), 1,
      sym_type,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2069), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [8457] = 25,
    ACTIONS(275), 1,
      sym_identifier,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(339), 1,
      anon_sym_STAR_STAR,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1034), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1780), 1,
      sym_expression,
    STATE(2455), 1,
      sym_type,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2093), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [8568] = 27,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(990), 1,
      sym_identifier,
    ACTIONS(992), 1,
      anon_sym_LPAREN,
    ACTIONS(998), 1,
      anon_sym_STAR,
    ACTIONS(1002), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1004), 1,
      anon_sym_type,
    ACTIONS(1006), 1,
      anon_sym_await,
    ACTIONS(1110), 1,
      anon_sym_RPAREN,
    ACTIONS(1112), 1,
      anon_sym_COMMA,
    STATE(1031), 1,
      sym_primary_expression,
    STATE(1034), 1,
      sym_string,
    STATE(1401), 1,
      sym_list_splat_pattern,
    STATE(1699), 1,
      sym_expression,
    STATE(2484), 1,
      sym_parenthesized_list_splat,
    STATE(2743), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2483), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(726), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1000), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1826), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1303), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [8683] = 28,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(822), 1,
      anon_sym_STAR,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(834), 1,
      anon_sym_yield,
    ACTIONS(992), 1,
      anon_sym_LPAREN,
    ACTIONS(1114), 1,
      sym_identifier,
    ACTIONS(1116), 1,
      anon_sym_RPAREN,
    ACTIONS(1120), 1,
      anon_sym_type,
    ACTIONS(1122), 1,
      anon_sym_await,
    STATE(1031), 1,
      sym_primary_expression,
    STATE(1034), 1,
      sym_string,
    STATE(1401), 1,
      sym_list_splat_pattern,
    STATE(1697), 1,
      sym_expression,
    STATE(2260), 1,
      sym_yield,
    STATE(2491), 1,
      sym_with_item,
    STATE(2743), 1,
      sym__named_expression_lhs,
    STATE(2814), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    STATE(2274), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(726), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1118), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1826), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1303), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [8800] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1002), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1086), 1,
      sym_identifier,
    ACTIONS(1088), 1,
      anon_sym_LPAREN,
    ACTIONS(1090), 1,
      anon_sym_STAR,
    ACTIONS(1094), 1,
      anon_sym_type,
    ACTIONS(1096), 1,
      anon_sym_await,
    ACTIONS(1124), 1,
      anon_sym_RPAREN,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1943), 1,
      sym_expression,
    STATE(2556), 1,
      sym_parenthesized_list_splat,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2543), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1092), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [8912] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1002), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1086), 1,
      sym_identifier,
    ACTIONS(1088), 1,
      anon_sym_LPAREN,
    ACTIONS(1090), 1,
      anon_sym_STAR,
    ACTIONS(1094), 1,
      anon_sym_type,
    ACTIONS(1096), 1,
      anon_sym_await,
    ACTIONS(1126), 1,
      anon_sym_RPAREN,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1943), 1,
      sym_expression,
    STATE(2556), 1,
      sym_parenthesized_list_splat,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2543), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1092), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [9024] = 26,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(876), 1,
      anon_sym_STAR,
    ACTIONS(886), 1,
      anon_sym_not,
    ACTIONS(888), 1,
      anon_sym_lambda,
    ACTIONS(890), 1,
      anon_sym_yield,
    ACTIONS(1128), 1,
      sym_identifier,
    ACTIONS(1130), 1,
      anon_sym_LPAREN,
    ACTIONS(1134), 1,
      anon_sym_type,
    ACTIONS(1136), 1,
      anon_sym_RBRACK,
    ACTIONS(1138), 1,
      anon_sym_await,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1011), 1,
      sym_string,
    STATE(1310), 1,
      sym_list_splat_pattern,
    STATE(1704), 1,
      sym_expression,
    STATE(2630), 1,
      sym__collection_elements,
    STATE(2688), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2264), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1132), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1811), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1279), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [9136] = 28,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(822), 1,
      anon_sym_STAR,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(834), 1,
      anon_sym_yield,
    ACTIONS(992), 1,
      anon_sym_LPAREN,
    ACTIONS(1114), 1,
      sym_identifier,
    ACTIONS(1120), 1,
      anon_sym_type,
    ACTIONS(1122), 1,
      anon_sym_await,
    ACTIONS(1140), 1,
      anon_sym_RPAREN,
    STATE(1031), 1,
      sym_primary_expression,
    STATE(1034), 1,
      sym_string,
    STATE(1401), 1,
      sym_list_splat_pattern,
    STATE(1718), 1,
      sym_expression,
    STATE(2421), 1,
      sym_yield,
    STATE(2486), 1,
      sym_parenthesized_list_splat,
    STATE(2488), 1,
      sym_list_splat,
    STATE(2628), 1,
      sym__collection_elements,
    STATE(2743), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(726), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1118), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1826), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1303), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [9252] = 26,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(876), 1,
      anon_sym_STAR,
    ACTIONS(886), 1,
      anon_sym_not,
    ACTIONS(888), 1,
      anon_sym_lambda,
    ACTIONS(890), 1,
      anon_sym_yield,
    ACTIONS(1128), 1,
      sym_identifier,
    ACTIONS(1130), 1,
      anon_sym_LPAREN,
    ACTIONS(1134), 1,
      anon_sym_type,
    ACTIONS(1138), 1,
      anon_sym_await,
    ACTIONS(1142), 1,
      anon_sym_RBRACK,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1011), 1,
      sym_string,
    STATE(1310), 1,
      sym_list_splat_pattern,
    STATE(1702), 1,
      sym_expression,
    STATE(2688), 1,
      sym__named_expression_lhs,
    STATE(2778), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2264), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1132), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1811), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1279), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [9364] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1002), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1086), 1,
      sym_identifier,
    ACTIONS(1088), 1,
      anon_sym_LPAREN,
    ACTIONS(1090), 1,
      anon_sym_STAR,
    ACTIONS(1094), 1,
      anon_sym_type,
    ACTIONS(1096), 1,
      anon_sym_await,
    ACTIONS(1144), 1,
      anon_sym_RPAREN,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1943), 1,
      sym_expression,
    STATE(2556), 1,
      sym_parenthesized_list_splat,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2543), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1092), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [9476] = 27,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(822), 1,
      anon_sym_STAR,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(834), 1,
      anon_sym_yield,
    ACTIONS(992), 1,
      anon_sym_LPAREN,
    ACTIONS(1114), 1,
      sym_identifier,
    ACTIONS(1120), 1,
      anon_sym_type,
    ACTIONS(1122), 1,
      anon_sym_await,
    ACTIONS(1140), 1,
      anon_sym_RPAREN,
    STATE(1031), 1,
      sym_primary_expression,
    STATE(1034), 1,
      sym_string,
    STATE(1401), 1,
      sym_list_splat_pattern,
    STATE(1718), 1,
      sym_expression,
    STATE(2421), 1,
      sym_yield,
    STATE(2628), 1,
      sym__collection_elements,
    STATE(2743), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    STATE(2274), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(726), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1118), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1826), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1303), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [9590] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1002), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1086), 1,
      sym_identifier,
    ACTIONS(1088), 1,
      anon_sym_LPAREN,
    ACTIONS(1090), 1,
      anon_sym_STAR,
    ACTIONS(1094), 1,
      anon_sym_type,
    ACTIONS(1096), 1,
      anon_sym_await,
    ACTIONS(1146), 1,
      anon_sym_RPAREN,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1943), 1,
      sym_expression,
    STATE(2556), 1,
      sym_parenthesized_list_splat,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2543), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1092), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [9702] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1002), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1086), 1,
      sym_identifier,
    ACTIONS(1088), 1,
      anon_sym_LPAREN,
    ACTIONS(1090), 1,
      anon_sym_STAR,
    ACTIONS(1094), 1,
      anon_sym_type,
    ACTIONS(1096), 1,
      anon_sym_await,
    ACTIONS(1148), 1,
      anon_sym_RPAREN,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1943), 1,
      sym_expression,
    STATE(2556), 1,
      sym_parenthesized_list_splat,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2543), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1092), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [9814] = 28,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(822), 1,
      anon_sym_STAR,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(834), 1,
      anon_sym_yield,
    ACTIONS(992), 1,
      anon_sym_LPAREN,
    ACTIONS(1114), 1,
      sym_identifier,
    ACTIONS(1120), 1,
      anon_sym_type,
    ACTIONS(1122), 1,
      anon_sym_await,
    ACTIONS(1150), 1,
      anon_sym_RPAREN,
    STATE(1031), 1,
      sym_primary_expression,
    STATE(1034), 1,
      sym_string,
    STATE(1401), 1,
      sym_list_splat_pattern,
    STATE(1705), 1,
      sym_expression,
    STATE(2276), 1,
      sym_list_splat,
    STATE(2277), 1,
      sym_parenthesized_list_splat,
    STATE(2515), 1,
      sym_yield,
    STATE(2691), 1,
      sym__collection_elements,
    STATE(2743), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(726), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1118), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1826), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1303), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [9930] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1002), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1086), 1,
      sym_identifier,
    ACTIONS(1088), 1,
      anon_sym_LPAREN,
    ACTIONS(1090), 1,
      anon_sym_STAR,
    ACTIONS(1094), 1,
      anon_sym_type,
    ACTIONS(1096), 1,
      anon_sym_await,
    ACTIONS(1152), 1,
      anon_sym_RPAREN,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1943), 1,
      sym_expression,
    STATE(2556), 1,
      sym_parenthesized_list_splat,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2543), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1092), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [10042] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1002), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1086), 1,
      sym_identifier,
    ACTIONS(1088), 1,
      anon_sym_LPAREN,
    ACTIONS(1090), 1,
      anon_sym_STAR,
    ACTIONS(1094), 1,
      anon_sym_type,
    ACTIONS(1096), 1,
      anon_sym_await,
    ACTIONS(1154), 1,
      anon_sym_RPAREN,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1943), 1,
      sym_expression,
    STATE(2556), 1,
      sym_parenthesized_list_splat,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2543), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1092), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [10154] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1002), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1086), 1,
      sym_identifier,
    ACTIONS(1088), 1,
      anon_sym_LPAREN,
    ACTIONS(1090), 1,
      anon_sym_STAR,
    ACTIONS(1094), 1,
      anon_sym_type,
    ACTIONS(1096), 1,
      anon_sym_await,
    ACTIONS(1156), 1,
      anon_sym_RPAREN,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1943), 1,
      sym_expression,
    STATE(2556), 1,
      sym_parenthesized_list_splat,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2543), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1092), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [10266] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1002), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1086), 1,
      sym_identifier,
    ACTIONS(1088), 1,
      anon_sym_LPAREN,
    ACTIONS(1090), 1,
      anon_sym_STAR,
    ACTIONS(1094), 1,
      anon_sym_type,
    ACTIONS(1096), 1,
      anon_sym_await,
    ACTIONS(1158), 1,
      anon_sym_RPAREN,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1943), 1,
      sym_expression,
    STATE(2556), 1,
      sym_parenthesized_list_splat,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2543), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1092), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [10378] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1002), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1086), 1,
      sym_identifier,
    ACTIONS(1088), 1,
      anon_sym_LPAREN,
    ACTIONS(1090), 1,
      anon_sym_STAR,
    ACTIONS(1094), 1,
      anon_sym_type,
    ACTIONS(1096), 1,
      anon_sym_await,
    ACTIONS(1160), 1,
      anon_sym_RPAREN,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1943), 1,
      sym_expression,
    STATE(2556), 1,
      sym_parenthesized_list_splat,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2543), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1092), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [10490] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1002), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1086), 1,
      sym_identifier,
    ACTIONS(1088), 1,
      anon_sym_LPAREN,
    ACTIONS(1090), 1,
      anon_sym_STAR,
    ACTIONS(1094), 1,
      anon_sym_type,
    ACTIONS(1096), 1,
      anon_sym_await,
    ACTIONS(1162), 1,
      anon_sym_RPAREN,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1943), 1,
      sym_expression,
    STATE(2556), 1,
      sym_parenthesized_list_splat,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2543), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1092), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [10602] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1002), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1086), 1,
      sym_identifier,
    ACTIONS(1088), 1,
      anon_sym_LPAREN,
    ACTIONS(1090), 1,
      anon_sym_STAR,
    ACTIONS(1094), 1,
      anon_sym_type,
    ACTIONS(1096), 1,
      anon_sym_await,
    ACTIONS(1164), 1,
      anon_sym_RPAREN,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1943), 1,
      sym_expression,
    STATE(2556), 1,
      sym_parenthesized_list_splat,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2543), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1092), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [10714] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1002), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1086), 1,
      sym_identifier,
    ACTIONS(1088), 1,
      anon_sym_LPAREN,
    ACTIONS(1090), 1,
      anon_sym_STAR,
    ACTIONS(1094), 1,
      anon_sym_type,
    ACTIONS(1096), 1,
      anon_sym_await,
    ACTIONS(1166), 1,
      anon_sym_RPAREN,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1943), 1,
      sym_expression,
    STATE(2556), 1,
      sym_parenthesized_list_splat,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2543), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1092), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [10826] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1002), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1086), 1,
      sym_identifier,
    ACTIONS(1088), 1,
      anon_sym_LPAREN,
    ACTIONS(1090), 1,
      anon_sym_STAR,
    ACTIONS(1094), 1,
      anon_sym_type,
    ACTIONS(1096), 1,
      anon_sym_await,
    ACTIONS(1168), 1,
      anon_sym_RPAREN,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1943), 1,
      sym_expression,
    STATE(2556), 1,
      sym_parenthesized_list_splat,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2543), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1092), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [10938] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1002), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1086), 1,
      sym_identifier,
    ACTIONS(1088), 1,
      anon_sym_LPAREN,
    ACTIONS(1090), 1,
      anon_sym_STAR,
    ACTIONS(1094), 1,
      anon_sym_type,
    ACTIONS(1096), 1,
      anon_sym_await,
    ACTIONS(1170), 1,
      anon_sym_RPAREN,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1943), 1,
      sym_expression,
    STATE(2556), 1,
      sym_parenthesized_list_splat,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2543), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1092), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [11050] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1002), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1086), 1,
      sym_identifier,
    ACTIONS(1088), 1,
      anon_sym_LPAREN,
    ACTIONS(1090), 1,
      anon_sym_STAR,
    ACTIONS(1094), 1,
      anon_sym_type,
    ACTIONS(1096), 1,
      anon_sym_await,
    ACTIONS(1172), 1,
      anon_sym_RPAREN,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1943), 1,
      sym_expression,
    STATE(2556), 1,
      sym_parenthesized_list_splat,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2543), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1092), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [11162] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1002), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1086), 1,
      sym_identifier,
    ACTIONS(1088), 1,
      anon_sym_LPAREN,
    ACTIONS(1090), 1,
      anon_sym_STAR,
    ACTIONS(1094), 1,
      anon_sym_type,
    ACTIONS(1096), 1,
      anon_sym_await,
    ACTIONS(1174), 1,
      anon_sym_RPAREN,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1943), 1,
      sym_expression,
    STATE(2556), 1,
      sym_parenthesized_list_splat,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2543), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1092), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [11274] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1002), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1086), 1,
      sym_identifier,
    ACTIONS(1088), 1,
      anon_sym_LPAREN,
    ACTIONS(1090), 1,
      anon_sym_STAR,
    ACTIONS(1094), 1,
      anon_sym_type,
    ACTIONS(1096), 1,
      anon_sym_await,
    ACTIONS(1176), 1,
      anon_sym_RPAREN,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1943), 1,
      sym_expression,
    STATE(2556), 1,
      sym_parenthesized_list_splat,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2543), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1092), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [11386] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1002), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1086), 1,
      sym_identifier,
    ACTIONS(1088), 1,
      anon_sym_LPAREN,
    ACTIONS(1090), 1,
      anon_sym_STAR,
    ACTIONS(1094), 1,
      anon_sym_type,
    ACTIONS(1096), 1,
      anon_sym_await,
    ACTIONS(1178), 1,
      anon_sym_RPAREN,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1943), 1,
      sym_expression,
    STATE(2556), 1,
      sym_parenthesized_list_splat,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2543), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1092), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [11498] = 28,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(822), 1,
      anon_sym_STAR,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(834), 1,
      anon_sym_yield,
    ACTIONS(992), 1,
      anon_sym_LPAREN,
    ACTIONS(1114), 1,
      sym_identifier,
    ACTIONS(1120), 1,
      anon_sym_type,
    ACTIONS(1122), 1,
      anon_sym_await,
    ACTIONS(1180), 1,
      anon_sym_RPAREN,
    STATE(1031), 1,
      sym_primary_expression,
    STATE(1034), 1,
      sym_string,
    STATE(1401), 1,
      sym_list_splat_pattern,
    STATE(1698), 1,
      sym_expression,
    STATE(2276), 1,
      sym_list_splat,
    STATE(2277), 1,
      sym_parenthesized_list_splat,
    STATE(2456), 1,
      sym_yield,
    STATE(2692), 1,
      sym__collection_elements,
    STATE(2743), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(726), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1118), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1826), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1303), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [11614] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1002), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1086), 1,
      sym_identifier,
    ACTIONS(1088), 1,
      anon_sym_LPAREN,
    ACTIONS(1090), 1,
      anon_sym_STAR,
    ACTIONS(1094), 1,
      anon_sym_type,
    ACTIONS(1096), 1,
      anon_sym_await,
    ACTIONS(1182), 1,
      anon_sym_RPAREN,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1943), 1,
      sym_expression,
    STATE(2556), 1,
      sym_parenthesized_list_splat,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2543), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1092), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [11726] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1002), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1086), 1,
      sym_identifier,
    ACTIONS(1088), 1,
      anon_sym_LPAREN,
    ACTIONS(1090), 1,
      anon_sym_STAR,
    ACTIONS(1094), 1,
      anon_sym_type,
    ACTIONS(1096), 1,
      anon_sym_await,
    ACTIONS(1184), 1,
      anon_sym_RPAREN,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1943), 1,
      sym_expression,
    STATE(2556), 1,
      sym_parenthesized_list_splat,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2543), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1092), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [11838] = 26,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(876), 1,
      anon_sym_STAR,
    ACTIONS(886), 1,
      anon_sym_not,
    ACTIONS(888), 1,
      anon_sym_lambda,
    ACTIONS(890), 1,
      anon_sym_yield,
    ACTIONS(1128), 1,
      sym_identifier,
    ACTIONS(1130), 1,
      anon_sym_LPAREN,
    ACTIONS(1134), 1,
      anon_sym_type,
    ACTIONS(1138), 1,
      anon_sym_await,
    ACTIONS(1186), 1,
      anon_sym_RBRACK,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1011), 1,
      sym_string,
    STATE(1310), 1,
      sym_list_splat_pattern,
    STATE(1703), 1,
      sym_expression,
    STATE(2688), 1,
      sym__named_expression_lhs,
    STATE(2790), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2264), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1132), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1811), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1279), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [11950] = 26,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(876), 1,
      anon_sym_STAR,
    ACTIONS(886), 1,
      anon_sym_not,
    ACTIONS(888), 1,
      anon_sym_lambda,
    ACTIONS(890), 1,
      anon_sym_yield,
    ACTIONS(1128), 1,
      sym_identifier,
    ACTIONS(1130), 1,
      anon_sym_LPAREN,
    ACTIONS(1134), 1,
      anon_sym_type,
    ACTIONS(1138), 1,
      anon_sym_await,
    ACTIONS(1188), 1,
      anon_sym_RBRACK,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1011), 1,
      sym_string,
    STATE(1310), 1,
      sym_list_splat_pattern,
    STATE(1715), 1,
      sym_expression,
    STATE(2688), 1,
      sym__named_expression_lhs,
    STATE(2817), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2264), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1132), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1811), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1279), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [12062] = 27,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(822), 1,
      anon_sym_STAR,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(834), 1,
      anon_sym_yield,
    ACTIONS(992), 1,
      anon_sym_LPAREN,
    ACTIONS(1114), 1,
      sym_identifier,
    ACTIONS(1120), 1,
      anon_sym_type,
    ACTIONS(1122), 1,
      anon_sym_await,
    ACTIONS(1180), 1,
      anon_sym_RPAREN,
    STATE(1031), 1,
      sym_primary_expression,
    STATE(1034), 1,
      sym_string,
    STATE(1401), 1,
      sym_list_splat_pattern,
    STATE(1698), 1,
      sym_expression,
    STATE(2456), 1,
      sym_yield,
    STATE(2692), 1,
      sym__collection_elements,
    STATE(2743), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    STATE(2274), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(726), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1118), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1826), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1303), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [12176] = 27,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(822), 1,
      anon_sym_STAR,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(834), 1,
      anon_sym_yield,
    ACTIONS(992), 1,
      anon_sym_LPAREN,
    ACTIONS(1114), 1,
      sym_identifier,
    ACTIONS(1116), 1,
      anon_sym_RPAREN,
    ACTIONS(1120), 1,
      anon_sym_type,
    ACTIONS(1122), 1,
      anon_sym_await,
    STATE(1031), 1,
      sym_primary_expression,
    STATE(1034), 1,
      sym_string,
    STATE(1401), 1,
      sym_list_splat_pattern,
    STATE(1701), 1,
      sym_expression,
    STATE(2260), 1,
      sym_yield,
    STATE(2743), 1,
      sym__named_expression_lhs,
    STATE(2814), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    STATE(2274), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(726), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1118), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1826), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1303), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [12290] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1002), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1086), 1,
      sym_identifier,
    ACTIONS(1088), 1,
      anon_sym_LPAREN,
    ACTIONS(1090), 1,
      anon_sym_STAR,
    ACTIONS(1094), 1,
      anon_sym_type,
    ACTIONS(1096), 1,
      anon_sym_await,
    ACTIONS(1190), 1,
      anon_sym_RPAREN,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1943), 1,
      sym_expression,
    STATE(2556), 1,
      sym_parenthesized_list_splat,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2543), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1092), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [12402] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1002), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1086), 1,
      sym_identifier,
    ACTIONS(1088), 1,
      anon_sym_LPAREN,
    ACTIONS(1090), 1,
      anon_sym_STAR,
    ACTIONS(1094), 1,
      anon_sym_type,
    ACTIONS(1096), 1,
      anon_sym_await,
    ACTIONS(1192), 1,
      anon_sym_RPAREN,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1943), 1,
      sym_expression,
    STATE(2556), 1,
      sym_parenthesized_list_splat,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2543), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1092), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [12514] = 28,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(822), 1,
      anon_sym_STAR,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(834), 1,
      anon_sym_yield,
    ACTIONS(992), 1,
      anon_sym_LPAREN,
    ACTIONS(1114), 1,
      sym_identifier,
    ACTIONS(1120), 1,
      anon_sym_type,
    ACTIONS(1122), 1,
      anon_sym_await,
    ACTIONS(1194), 1,
      anon_sym_RPAREN,
    STATE(1031), 1,
      sym_primary_expression,
    STATE(1034), 1,
      sym_string,
    STATE(1401), 1,
      sym_list_splat_pattern,
    STATE(1709), 1,
      sym_expression,
    STATE(2479), 1,
      sym_yield,
    STATE(2482), 1,
      sym_list_splat,
    STATE(2489), 1,
      sym_parenthesized_list_splat,
    STATE(2743), 1,
      sym__named_expression_lhs,
    STATE(2765), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(726), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1118), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1826), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1303), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [12630] = 26,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(876), 1,
      anon_sym_STAR,
    ACTIONS(886), 1,
      anon_sym_not,
    ACTIONS(888), 1,
      anon_sym_lambda,
    ACTIONS(890), 1,
      anon_sym_yield,
    ACTIONS(1128), 1,
      sym_identifier,
    ACTIONS(1130), 1,
      anon_sym_LPAREN,
    ACTIONS(1134), 1,
      anon_sym_type,
    ACTIONS(1138), 1,
      anon_sym_await,
    ACTIONS(1196), 1,
      anon_sym_RBRACK,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1011), 1,
      sym_string,
    STATE(1310), 1,
      sym_list_splat_pattern,
    STATE(1706), 1,
      sym_expression,
    STATE(2655), 1,
      sym__collection_elements,
    STATE(2688), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2264), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1132), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1811), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1279), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [12742] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1002), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1086), 1,
      sym_identifier,
    ACTIONS(1088), 1,
      anon_sym_LPAREN,
    ACTIONS(1090), 1,
      anon_sym_STAR,
    ACTIONS(1094), 1,
      anon_sym_type,
    ACTIONS(1096), 1,
      anon_sym_await,
    ACTIONS(1198), 1,
      anon_sym_RPAREN,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1943), 1,
      sym_expression,
    STATE(2556), 1,
      sym_parenthesized_list_splat,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2543), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1092), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [12854] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1002), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1086), 1,
      sym_identifier,
    ACTIONS(1088), 1,
      anon_sym_LPAREN,
    ACTIONS(1090), 1,
      anon_sym_STAR,
    ACTIONS(1094), 1,
      anon_sym_type,
    ACTIONS(1096), 1,
      anon_sym_await,
    ACTIONS(1200), 1,
      anon_sym_RPAREN,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1943), 1,
      sym_expression,
    STATE(2556), 1,
      sym_parenthesized_list_splat,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2543), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1092), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [12966] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1002), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1086), 1,
      sym_identifier,
    ACTIONS(1088), 1,
      anon_sym_LPAREN,
    ACTIONS(1090), 1,
      anon_sym_STAR,
    ACTIONS(1094), 1,
      anon_sym_type,
    ACTIONS(1096), 1,
      anon_sym_await,
    ACTIONS(1202), 1,
      anon_sym_RPAREN,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1943), 1,
      sym_expression,
    STATE(2556), 1,
      sym_parenthesized_list_splat,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2543), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1092), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [13078] = 27,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(822), 1,
      anon_sym_STAR,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(834), 1,
      anon_sym_yield,
    ACTIONS(992), 1,
      anon_sym_LPAREN,
    ACTIONS(1114), 1,
      sym_identifier,
    ACTIONS(1120), 1,
      anon_sym_type,
    ACTIONS(1122), 1,
      anon_sym_await,
    ACTIONS(1204), 1,
      anon_sym_RPAREN,
    STATE(1031), 1,
      sym_primary_expression,
    STATE(1034), 1,
      sym_string,
    STATE(1401), 1,
      sym_list_splat_pattern,
    STATE(1717), 1,
      sym_expression,
    STATE(2279), 1,
      sym_yield,
    STATE(2743), 1,
      sym__named_expression_lhs,
    STATE(2753), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    STATE(2274), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(726), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1118), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1826), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1303), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [13192] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1002), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1086), 1,
      sym_identifier,
    ACTIONS(1088), 1,
      anon_sym_LPAREN,
    ACTIONS(1090), 1,
      anon_sym_STAR,
    ACTIONS(1094), 1,
      anon_sym_type,
    ACTIONS(1096), 1,
      anon_sym_await,
    ACTIONS(1206), 1,
      anon_sym_RPAREN,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1943), 1,
      sym_expression,
    STATE(2556), 1,
      sym_parenthesized_list_splat,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2543), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1092), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [13304] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1002), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1086), 1,
      sym_identifier,
    ACTIONS(1088), 1,
      anon_sym_LPAREN,
    ACTIONS(1090), 1,
      anon_sym_STAR,
    ACTIONS(1094), 1,
      anon_sym_type,
    ACTIONS(1096), 1,
      anon_sym_await,
    ACTIONS(1208), 1,
      anon_sym_RPAREN,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1943), 1,
      sym_expression,
    STATE(2556), 1,
      sym_parenthesized_list_splat,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2543), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1092), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [13416] = 28,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(822), 1,
      anon_sym_STAR,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(834), 1,
      anon_sym_yield,
    ACTIONS(992), 1,
      anon_sym_LPAREN,
    ACTIONS(1114), 1,
      sym_identifier,
    ACTIONS(1120), 1,
      anon_sym_type,
    ACTIONS(1122), 1,
      anon_sym_await,
    ACTIONS(1210), 1,
      anon_sym_RPAREN,
    STATE(1031), 1,
      sym_primary_expression,
    STATE(1034), 1,
      sym_string,
    STATE(1401), 1,
      sym_list_splat_pattern,
    STATE(1711), 1,
      sym_expression,
    STATE(2470), 1,
      sym_yield,
    STATE(2482), 1,
      sym_list_splat,
    STATE(2489), 1,
      sym_parenthesized_list_splat,
    STATE(2731), 1,
      sym__collection_elements,
    STATE(2743), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(726), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1118), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1826), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1303), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [13532] = 27,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(822), 1,
      anon_sym_STAR,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(834), 1,
      anon_sym_yield,
    ACTIONS(992), 1,
      anon_sym_LPAREN,
    ACTIONS(1114), 1,
      sym_identifier,
    ACTIONS(1120), 1,
      anon_sym_type,
    ACTIONS(1122), 1,
      anon_sym_await,
    ACTIONS(1210), 1,
      anon_sym_RPAREN,
    STATE(1031), 1,
      sym_primary_expression,
    STATE(1034), 1,
      sym_string,
    STATE(1401), 1,
      sym_list_splat_pattern,
    STATE(1711), 1,
      sym_expression,
    STATE(2470), 1,
      sym_yield,
    STATE(2731), 1,
      sym__collection_elements,
    STATE(2743), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    STATE(2274), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(726), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1118), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1826), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1303), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [13646] = 26,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(876), 1,
      anon_sym_STAR,
    ACTIONS(886), 1,
      anon_sym_not,
    ACTIONS(888), 1,
      anon_sym_lambda,
    ACTIONS(890), 1,
      anon_sym_yield,
    ACTIONS(1128), 1,
      sym_identifier,
    ACTIONS(1130), 1,
      anon_sym_LPAREN,
    ACTIONS(1134), 1,
      anon_sym_type,
    ACTIONS(1138), 1,
      anon_sym_await,
    ACTIONS(1212), 1,
      anon_sym_RBRACK,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1011), 1,
      sym_string,
    STATE(1310), 1,
      sym_list_splat_pattern,
    STATE(1710), 1,
      sym_expression,
    STATE(2688), 1,
      sym__named_expression_lhs,
    STATE(2729), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2264), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1132), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1811), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1279), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [13758] = 27,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(822), 1,
      anon_sym_STAR,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(834), 1,
      anon_sym_yield,
    ACTIONS(992), 1,
      anon_sym_LPAREN,
    ACTIONS(1114), 1,
      sym_identifier,
    ACTIONS(1120), 1,
      anon_sym_type,
    ACTIONS(1122), 1,
      anon_sym_await,
    ACTIONS(1194), 1,
      anon_sym_RPAREN,
    STATE(1031), 1,
      sym_primary_expression,
    STATE(1034), 1,
      sym_string,
    STATE(1401), 1,
      sym_list_splat_pattern,
    STATE(1709), 1,
      sym_expression,
    STATE(2479), 1,
      sym_yield,
    STATE(2743), 1,
      sym__named_expression_lhs,
    STATE(2765), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    STATE(2274), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(726), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1118), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1826), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1303), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [13872] = 26,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(876), 1,
      anon_sym_STAR,
    ACTIONS(886), 1,
      anon_sym_not,
    ACTIONS(888), 1,
      anon_sym_lambda,
    ACTIONS(890), 1,
      anon_sym_yield,
    ACTIONS(1128), 1,
      sym_identifier,
    ACTIONS(1130), 1,
      anon_sym_LPAREN,
    ACTIONS(1134), 1,
      anon_sym_type,
    ACTIONS(1138), 1,
      anon_sym_await,
    ACTIONS(1214), 1,
      anon_sym_RBRACK,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1011), 1,
      sym_string,
    STATE(1310), 1,
      sym_list_splat_pattern,
    STATE(1694), 1,
      sym_expression,
    STATE(2617), 1,
      sym__collection_elements,
    STATE(2688), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2264), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1132), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1811), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1279), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [13984] = 28,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(822), 1,
      anon_sym_STAR,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(834), 1,
      anon_sym_yield,
    ACTIONS(992), 1,
      anon_sym_LPAREN,
    ACTIONS(1114), 1,
      sym_identifier,
    ACTIONS(1120), 1,
      anon_sym_type,
    ACTIONS(1122), 1,
      anon_sym_await,
    ACTIONS(1216), 1,
      anon_sym_RPAREN,
    STATE(1031), 1,
      sym_primary_expression,
    STATE(1034), 1,
      sym_string,
    STATE(1401), 1,
      sym_list_splat_pattern,
    STATE(1695), 1,
      sym_expression,
    STATE(2361), 1,
      sym_yield,
    STATE(2486), 1,
      sym_parenthesized_list_splat,
    STATE(2488), 1,
      sym_list_splat,
    STATE(2683), 1,
      sym__collection_elements,
    STATE(2743), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(726), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1118), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1826), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1303), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [14100] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1002), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1086), 1,
      sym_identifier,
    ACTIONS(1088), 1,
      anon_sym_LPAREN,
    ACTIONS(1090), 1,
      anon_sym_STAR,
    ACTIONS(1094), 1,
      anon_sym_type,
    ACTIONS(1096), 1,
      anon_sym_await,
    ACTIONS(1218), 1,
      anon_sym_RPAREN,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1943), 1,
      sym_expression,
    STATE(2556), 1,
      sym_parenthesized_list_splat,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2543), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1092), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [14212] = 27,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(822), 1,
      anon_sym_STAR,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(834), 1,
      anon_sym_yield,
    ACTIONS(992), 1,
      anon_sym_LPAREN,
    ACTIONS(1114), 1,
      sym_identifier,
    ACTIONS(1120), 1,
      anon_sym_type,
    ACTIONS(1122), 1,
      anon_sym_await,
    ACTIONS(1216), 1,
      anon_sym_RPAREN,
    STATE(1031), 1,
      sym_primary_expression,
    STATE(1034), 1,
      sym_string,
    STATE(1401), 1,
      sym_list_splat_pattern,
    STATE(1695), 1,
      sym_expression,
    STATE(2361), 1,
      sym_yield,
    STATE(2683), 1,
      sym__collection_elements,
    STATE(2743), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    STATE(2274), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(726), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1118), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1826), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1303), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [14326] = 26,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(876), 1,
      anon_sym_STAR,
    ACTIONS(886), 1,
      anon_sym_not,
    ACTIONS(888), 1,
      anon_sym_lambda,
    ACTIONS(890), 1,
      anon_sym_yield,
    ACTIONS(1128), 1,
      sym_identifier,
    ACTIONS(1130), 1,
      anon_sym_LPAREN,
    ACTIONS(1134), 1,
      anon_sym_type,
    ACTIONS(1138), 1,
      anon_sym_await,
    ACTIONS(1220), 1,
      anon_sym_RBRACK,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1011), 1,
      sym_string,
    STATE(1310), 1,
      sym_list_splat_pattern,
    STATE(1712), 1,
      sym_expression,
    STATE(2676), 1,
      sym__collection_elements,
    STATE(2688), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2264), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1132), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1811), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1279), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [14438] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1002), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1086), 1,
      sym_identifier,
    ACTIONS(1088), 1,
      anon_sym_LPAREN,
    ACTIONS(1090), 1,
      anon_sym_STAR,
    ACTIONS(1094), 1,
      anon_sym_type,
    ACTIONS(1096), 1,
      anon_sym_await,
    ACTIONS(1222), 1,
      anon_sym_RPAREN,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1943), 1,
      sym_expression,
    STATE(2556), 1,
      sym_parenthesized_list_splat,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2543), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1092), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [14550] = 27,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(822), 1,
      anon_sym_STAR,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(834), 1,
      anon_sym_yield,
    ACTIONS(992), 1,
      anon_sym_LPAREN,
    ACTIONS(1114), 1,
      sym_identifier,
    ACTIONS(1120), 1,
      anon_sym_type,
    ACTIONS(1122), 1,
      anon_sym_await,
    ACTIONS(1150), 1,
      anon_sym_RPAREN,
    STATE(1031), 1,
      sym_primary_expression,
    STATE(1034), 1,
      sym_string,
    STATE(1401), 1,
      sym_list_splat_pattern,
    STATE(1705), 1,
      sym_expression,
    STATE(2515), 1,
      sym_yield,
    STATE(2691), 1,
      sym__collection_elements,
    STATE(2743), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    STATE(2274), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(726), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1118), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1826), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1303), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [14664] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1002), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1086), 1,
      sym_identifier,
    ACTIONS(1088), 1,
      anon_sym_LPAREN,
    ACTIONS(1090), 1,
      anon_sym_STAR,
    ACTIONS(1094), 1,
      anon_sym_type,
    ACTIONS(1096), 1,
      anon_sym_await,
    ACTIONS(1224), 1,
      anon_sym_RPAREN,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1943), 1,
      sym_expression,
    STATE(2556), 1,
      sym_parenthesized_list_splat,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2543), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1092), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [14776] = 26,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1002), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1086), 1,
      sym_identifier,
    ACTIONS(1088), 1,
      anon_sym_LPAREN,
    ACTIONS(1090), 1,
      anon_sym_STAR,
    ACTIONS(1094), 1,
      anon_sym_type,
    ACTIONS(1096), 1,
      anon_sym_await,
    ACTIONS(1226), 1,
      anon_sym_RPAREN,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1943), 1,
      sym_expression,
    STATE(2556), 1,
      sym_parenthesized_list_splat,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2543), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1092), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [14888] = 25,
    ACTIONS(706), 1,
      anon_sym_LPAREN,
    ACTIONS(714), 1,
      anon_sym_LBRACK,
    ACTIONS(718), 1,
      anon_sym_LBRACE,
    ACTIONS(724), 1,
      sym_string_start,
    ACTIONS(840), 1,
      sym_identifier,
    ACTIONS(852), 1,
      anon_sym_type,
    ACTIONS(856), 1,
      anon_sym_not,
    ACTIONS(862), 1,
      anon_sym_await,
    ACTIONS(1228), 1,
      anon_sym_STAR,
    ACTIONS(1232), 1,
      anon_sym_RBRACE,
    ACTIONS(1234), 1,
      anon_sym_lambda,
    STATE(979), 1,
      sym_primary_expression,
    STATE(987), 1,
      sym_string,
    STATE(1214), 1,
      sym_list_splat_pattern,
    STATE(1853), 1,
      sym_expression,
    STATE(2669), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(720), 2,
      sym_ellipsis,
      sym_float,
    STATE(2024), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(716), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(848), 3,
      anon_sym_print,
      anon_sym_match,
      anon_sym_exec,
    ACTIONS(1230), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1764), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1235), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [14997] = 25,
    ACTIONS(706), 1,
      anon_sym_LPAREN,
    ACTIONS(714), 1,
      anon_sym_LBRACK,
    ACTIONS(718), 1,
      anon_sym_LBRACE,
    ACTIONS(724), 1,
      sym_string_start,
    ACTIONS(840), 1,
      sym_identifier,
    ACTIONS(852), 1,
      anon_sym_type,
    ACTIONS(856), 1,
      anon_sym_not,
    ACTIONS(862), 1,
      anon_sym_await,
    ACTIONS(1228), 1,
      anon_sym_STAR,
    ACTIONS(1234), 1,
      anon_sym_lambda,
    ACTIONS(1238), 1,
      anon_sym_RBRACE,
    STATE(979), 1,
      sym_primary_expression,
    STATE(987), 1,
      sym_string,
    STATE(1214), 1,
      sym_list_splat_pattern,
    STATE(1853), 1,
      sym_expression,
    STATE(2669), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(720), 2,
      sym_ellipsis,
      sym_float,
    STATE(2024), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(716), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(848), 3,
      anon_sym_print,
      anon_sym_match,
      anon_sym_exec,
    ACTIONS(1236), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1764), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1235), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [15106] = 25,
    ACTIONS(728), 1,
      anon_sym_LPAREN,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(1114), 1,
      sym_identifier,
    ACTIONS(1120), 1,
      anon_sym_type,
    ACTIONS(1122), 1,
      anon_sym_await,
    ACTIONS(1232), 1,
      anon_sym_RPAREN,
    ACTIONS(1240), 1,
      anon_sym_STAR,
    ACTIONS(1242), 1,
      anon_sym_lambda,
    STATE(1031), 1,
      sym_primary_expression,
    STATE(1034), 1,
      sym_string,
    STATE(1401), 1,
      sym_list_splat_pattern,
    STATE(1804), 1,
      sym_expression,
    STATE(2743), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    STATE(2112), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1118), 3,
      anon_sym_print,
      anon_sym_match,
      anon_sym_exec,
    ACTIONS(1230), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(726), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1826), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1303), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [15215] = 25,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(886), 1,
      anon_sym_not,
    ACTIONS(1128), 1,
      sym_identifier,
    ACTIONS(1134), 1,
      anon_sym_type,
    ACTIONS(1138), 1,
      anon_sym_await,
    ACTIONS(1244), 1,
      anon_sym_STAR,
    ACTIONS(1248), 1,
      anon_sym_RBRACK,
    ACTIONS(1250), 1,
      anon_sym_lambda,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1011), 1,
      sym_string,
    STATE(1310), 1,
      sym_list_splat_pattern,
    STATE(1802), 1,
      sym_expression,
    STATE(2688), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    STATE(2012), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1132), 3,
      anon_sym_print,
      anon_sym_match,
      anon_sym_exec,
    ACTIONS(1246), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1811), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1279), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [15324] = 25,
    ACTIONS(728), 1,
      anon_sym_LPAREN,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(1114), 1,
      sym_identifier,
    ACTIONS(1120), 1,
      anon_sym_type,
    ACTIONS(1122), 1,
      anon_sym_await,
    ACTIONS(1238), 1,
      anon_sym_RPAREN,
    ACTIONS(1240), 1,
      anon_sym_STAR,
    ACTIONS(1242), 1,
      anon_sym_lambda,
    STATE(1031), 1,
      sym_primary_expression,
    STATE(1034), 1,
      sym_string,
    STATE(1401), 1,
      sym_list_splat_pattern,
    STATE(1804), 1,
      sym_expression,
    STATE(2743), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    STATE(2112), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1118), 3,
      anon_sym_print,
      anon_sym_match,
      anon_sym_exec,
    ACTIONS(1236), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(726), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1826), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1303), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [15433] = 25,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(886), 1,
      anon_sym_not,
    ACTIONS(1128), 1,
      sym_identifier,
    ACTIONS(1134), 1,
      anon_sym_type,
    ACTIONS(1138), 1,
      anon_sym_await,
    ACTIONS(1232), 1,
      anon_sym_RBRACK,
    ACTIONS(1244), 1,
      anon_sym_STAR,
    ACTIONS(1250), 1,
      anon_sym_lambda,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1011), 1,
      sym_string,
    STATE(1310), 1,
      sym_list_splat_pattern,
    STATE(1802), 1,
      sym_expression,
    STATE(2688), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    STATE(2012), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1132), 3,
      anon_sym_print,
      anon_sym_match,
      anon_sym_exec,
    ACTIONS(1230), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1811), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1279), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [15542] = 23,
    ACTIONS(684), 1,
      anon_sym_LPAREN,
    ACTIONS(692), 1,
      anon_sym_LBRACK,
    ACTIONS(696), 1,
      anon_sym_LBRACE,
    ACTIONS(702), 1,
      sym_string_start,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(1098), 1,
      sym_identifier,
    ACTIONS(1106), 1,
      anon_sym_type,
    ACTIONS(1108), 1,
      anon_sym_await,
    STATE(972), 1,
      sym_primary_expression,
    STATE(977), 1,
      sym_string,
    STATE(1218), 1,
      sym_list_splat_pattern,
    STATE(1795), 1,
      sym_expression,
    STATE(2784), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(698), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(694), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(682), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1104), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(1252), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
    STATE(1794), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1258), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [15647] = 25,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(890), 1,
      anon_sym_yield,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_STAR,
    ACTIONS(1260), 1,
      anon_sym_RBRACK,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1911), 1,
      sym_expression,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2602), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [15756] = 25,
    ACTIONS(728), 1,
      anon_sym_LPAREN,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(1114), 1,
      sym_identifier,
    ACTIONS(1120), 1,
      anon_sym_type,
    ACTIONS(1122), 1,
      anon_sym_await,
    ACTIONS(1240), 1,
      anon_sym_STAR,
    ACTIONS(1242), 1,
      anon_sym_lambda,
    ACTIONS(1262), 1,
      anon_sym_RPAREN,
    STATE(1031), 1,
      sym_primary_expression,
    STATE(1034), 1,
      sym_string,
    STATE(1401), 1,
      sym_list_splat_pattern,
    STATE(1804), 1,
      sym_expression,
    STATE(2743), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    STATE(2112), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1118), 3,
      anon_sym_print,
      anon_sym_match,
      anon_sym_exec,
    ACTIONS(1264), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(726), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1826), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1303), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [15865] = 25,
    ACTIONS(692), 1,
      anon_sym_LBRACK,
    ACTIONS(696), 1,
      anon_sym_LBRACE,
    ACTIONS(702), 1,
      sym_string_start,
    ACTIONS(860), 1,
      anon_sym_yield,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(1098), 1,
      sym_identifier,
    ACTIONS(1106), 1,
      anon_sym_type,
    ACTIONS(1108), 1,
      anon_sym_await,
    ACTIONS(1266), 1,
      anon_sym_LPAREN,
    ACTIONS(1268), 1,
      anon_sym_STAR,
    ACTIONS(1270), 1,
      anon_sym_RBRACE,
    STATE(972), 1,
      sym_primary_expression,
    STATE(977), 1,
      sym_string,
    STATE(1218), 1,
      sym_list_splat_pattern,
    STATE(1964), 1,
      sym_expression,
    STATE(2784), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(698), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(694), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2549), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(682), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1104), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1794), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1258), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [15974] = 25,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(886), 1,
      anon_sym_not,
    ACTIONS(1128), 1,
      sym_identifier,
    ACTIONS(1134), 1,
      anon_sym_type,
    ACTIONS(1138), 1,
      anon_sym_await,
    ACTIONS(1238), 1,
      anon_sym_RBRACK,
    ACTIONS(1244), 1,
      anon_sym_STAR,
    ACTIONS(1250), 1,
      anon_sym_lambda,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1011), 1,
      sym_string,
    STATE(1310), 1,
      sym_list_splat_pattern,
    STATE(1802), 1,
      sym_expression,
    STATE(2688), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    STATE(2012), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1132), 3,
      anon_sym_print,
      anon_sym_match,
      anon_sym_exec,
    ACTIONS(1236), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1811), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1279), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [16083] = 25,
    ACTIONS(706), 1,
      anon_sym_LPAREN,
    ACTIONS(714), 1,
      anon_sym_LBRACK,
    ACTIONS(718), 1,
      anon_sym_LBRACE,
    ACTIONS(724), 1,
      sym_string_start,
    ACTIONS(840), 1,
      sym_identifier,
    ACTIONS(852), 1,
      anon_sym_type,
    ACTIONS(856), 1,
      anon_sym_not,
    ACTIONS(862), 1,
      anon_sym_await,
    ACTIONS(1228), 1,
      anon_sym_STAR,
    ACTIONS(1234), 1,
      anon_sym_lambda,
    ACTIONS(1248), 1,
      anon_sym_RBRACE,
    STATE(979), 1,
      sym_primary_expression,
    STATE(987), 1,
      sym_string,
    STATE(1214), 1,
      sym_list_splat_pattern,
    STATE(1853), 1,
      sym_expression,
    STATE(2669), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(720), 2,
      sym_ellipsis,
      sym_float,
    STATE(2024), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(716), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(848), 3,
      anon_sym_print,
      anon_sym_match,
      anon_sym_exec,
    ACTIONS(1246), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1764), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1235), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [16192] = 25,
    ACTIONS(728), 1,
      anon_sym_LPAREN,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(1114), 1,
      sym_identifier,
    ACTIONS(1120), 1,
      anon_sym_type,
    ACTIONS(1122), 1,
      anon_sym_await,
    ACTIONS(1240), 1,
      anon_sym_STAR,
    ACTIONS(1242), 1,
      anon_sym_lambda,
    ACTIONS(1248), 1,
      anon_sym_RPAREN,
    STATE(1031), 1,
      sym_primary_expression,
    STATE(1034), 1,
      sym_string,
    STATE(1401), 1,
      sym_list_splat_pattern,
    STATE(1804), 1,
      sym_expression,
    STATE(2743), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    STATE(2112), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1118), 3,
      anon_sym_print,
      anon_sym_match,
      anon_sym_exec,
    ACTIONS(1246), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(726), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1826), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1303), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [16301] = 25,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1002), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1086), 1,
      sym_identifier,
    ACTIONS(1088), 1,
      anon_sym_LPAREN,
    ACTIONS(1090), 1,
      anon_sym_STAR,
    ACTIONS(1094), 1,
      anon_sym_type,
    ACTIONS(1096), 1,
      anon_sym_await,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1943), 1,
      sym_expression,
    STATE(2556), 1,
      sym_parenthesized_list_splat,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2543), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1092), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [16410] = 25,
    ACTIONS(692), 1,
      anon_sym_LBRACK,
    ACTIONS(696), 1,
      anon_sym_LBRACE,
    ACTIONS(702), 1,
      sym_string_start,
    ACTIONS(860), 1,
      anon_sym_yield,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(1098), 1,
      sym_identifier,
    ACTIONS(1106), 1,
      anon_sym_type,
    ACTIONS(1108), 1,
      anon_sym_await,
    ACTIONS(1260), 1,
      anon_sym_RBRACE,
    ACTIONS(1266), 1,
      anon_sym_LPAREN,
    ACTIONS(1268), 1,
      anon_sym_STAR,
    STATE(972), 1,
      sym_primary_expression,
    STATE(977), 1,
      sym_string,
    STATE(1218), 1,
      sym_list_splat_pattern,
    STATE(1964), 1,
      sym_expression,
    STATE(2784), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(698), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(694), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2549), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(682), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1104), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1794), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1258), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [16519] = 25,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(834), 1,
      anon_sym_yield,
    ACTIONS(1078), 1,
      anon_sym_type,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1084), 1,
      anon_sym_await,
    ACTIONS(1088), 1,
      anon_sym_LPAREN,
    ACTIONS(1260), 1,
      anon_sym_RPAREN,
    ACTIONS(1272), 1,
      sym_identifier,
    ACTIONS(1274), 1,
      anon_sym_STAR,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1933), 1,
      sym_expression,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2563), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1074), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [16628] = 25,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(886), 1,
      anon_sym_not,
    ACTIONS(1128), 1,
      sym_identifier,
    ACTIONS(1134), 1,
      anon_sym_type,
    ACTIONS(1138), 1,
      anon_sym_await,
    ACTIONS(1244), 1,
      anon_sym_STAR,
    ACTIONS(1250), 1,
      anon_sym_lambda,
    ACTIONS(1262), 1,
      anon_sym_RBRACK,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1011), 1,
      sym_string,
    STATE(1310), 1,
      sym_list_splat_pattern,
    STATE(1802), 1,
      sym_expression,
    STATE(2688), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    STATE(2012), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1132), 3,
      anon_sym_print,
      anon_sym_match,
      anon_sym_exec,
    ACTIONS(1264), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1811), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1279), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [16737] = 25,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(834), 1,
      anon_sym_yield,
    ACTIONS(1078), 1,
      anon_sym_type,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1084), 1,
      anon_sym_await,
    ACTIONS(1088), 1,
      anon_sym_LPAREN,
    ACTIONS(1270), 1,
      anon_sym_RPAREN,
    ACTIONS(1272), 1,
      sym_identifier,
    ACTIONS(1274), 1,
      anon_sym_STAR,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1933), 1,
      sym_expression,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2563), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1074), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [16846] = 25,
    ACTIONS(706), 1,
      anon_sym_LPAREN,
    ACTIONS(714), 1,
      anon_sym_LBRACK,
    ACTIONS(718), 1,
      anon_sym_LBRACE,
    ACTIONS(724), 1,
      sym_string_start,
    ACTIONS(840), 1,
      sym_identifier,
    ACTIONS(852), 1,
      anon_sym_type,
    ACTIONS(856), 1,
      anon_sym_not,
    ACTIONS(862), 1,
      anon_sym_await,
    ACTIONS(1228), 1,
      anon_sym_STAR,
    ACTIONS(1234), 1,
      anon_sym_lambda,
    ACTIONS(1262), 1,
      anon_sym_RBRACE,
    STATE(979), 1,
      sym_primary_expression,
    STATE(987), 1,
      sym_string,
    STATE(1214), 1,
      sym_list_splat_pattern,
    STATE(1853), 1,
      sym_expression,
    STATE(2669), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(720), 2,
      sym_ellipsis,
      sym_float,
    STATE(2024), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(716), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(848), 3,
      anon_sym_print,
      anon_sym_match,
      anon_sym_exec,
    ACTIONS(1264), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1764), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1235), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [16955] = 25,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(890), 1,
      anon_sym_yield,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_STAR,
    ACTIONS(1270), 1,
      anon_sym_RBRACK,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1911), 1,
      sym_expression,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2602), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [17064] = 23,
    ACTIONS(684), 1,
      anon_sym_LPAREN,
    ACTIONS(692), 1,
      anon_sym_LBRACK,
    ACTIONS(696), 1,
      anon_sym_LBRACE,
    ACTIONS(702), 1,
      sym_string_start,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(1098), 1,
      sym_identifier,
    ACTIONS(1106), 1,
      anon_sym_type,
    ACTIONS(1108), 1,
      anon_sym_await,
    STATE(972), 1,
      sym_primary_expression,
    STATE(977), 1,
      sym_string,
    STATE(1218), 1,
      sym_list_splat_pattern,
    STATE(1795), 1,
      sym_expression,
    STATE(2784), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(698), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(694), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(682), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1104), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(1276), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
    STATE(1794), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1258), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [17169] = 19,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(410), 1,
      anon_sym_STAR,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(675), 1,
      anon_sym_type,
    ACTIONS(677), 1,
      anon_sym_await,
    STATE(1007), 1,
      sym_string,
    STATE(1078), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 2,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(316), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
    ACTIONS(320), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(277), 9,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [17266] = 25,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(410), 1,
      anon_sym_STAR,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(850), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1278), 1,
      anon_sym_RBRACE,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(2089), 1,
      sym_expression,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(2606), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [17374] = 25,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(410), 1,
      anon_sym_STAR,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(850), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1280), 1,
      anon_sym_RBRACE,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(2089), 1,
      sym_expression,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(2606), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [17482] = 25,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(410), 1,
      anon_sym_STAR,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(850), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1282), 1,
      anon_sym_RBRACE,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(2089), 1,
      sym_expression,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(2606), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [17590] = 25,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(410), 1,
      anon_sym_STAR,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(850), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1284), 1,
      anon_sym_RBRACE,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(2089), 1,
      sym_expression,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(2606), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [17698] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1286), 1,
      anon_sym_from,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1882), 1,
      sym_expression,
    STATE(2555), 1,
      sym_expression_list,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1102), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [17806] = 25,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(410), 1,
      anon_sym_STAR,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(850), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1290), 1,
      anon_sym_RBRACE,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(2089), 1,
      sym_expression,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(2606), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [17914] = 25,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(410), 1,
      anon_sym_STAR,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(850), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1292), 1,
      anon_sym_RBRACE,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(2089), 1,
      sym_expression,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(2606), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [18022] = 25,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(410), 1,
      anon_sym_STAR,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(850), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1294), 1,
      anon_sym_RBRACE,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(2089), 1,
      sym_expression,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(2606), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [18130] = 25,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(410), 1,
      anon_sym_STAR,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(850), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1296), 1,
      anon_sym_RBRACE,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(2089), 1,
      sym_expression,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(2606), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [18238] = 24,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(890), 1,
      anon_sym_yield,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1256), 1,
      anon_sym_LPAREN,
    ACTIONS(1258), 1,
      anon_sym_STAR,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1911), 1,
      sym_expression,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2602), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [18344] = 24,
    ACTIONS(692), 1,
      anon_sym_LBRACK,
    ACTIONS(696), 1,
      anon_sym_LBRACE,
    ACTIONS(702), 1,
      sym_string_start,
    ACTIONS(860), 1,
      anon_sym_yield,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(1098), 1,
      sym_identifier,
    ACTIONS(1106), 1,
      anon_sym_type,
    ACTIONS(1108), 1,
      anon_sym_await,
    ACTIONS(1266), 1,
      anon_sym_LPAREN,
    ACTIONS(1268), 1,
      anon_sym_STAR,
    STATE(972), 1,
      sym_primary_expression,
    STATE(977), 1,
      sym_string,
    STATE(1218), 1,
      sym_list_splat_pattern,
    STATE(1964), 1,
      sym_expression,
    STATE(2784), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(698), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(694), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2549), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(682), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1104), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1794), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1258), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [18450] = 25,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(410), 1,
      anon_sym_STAR,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(850), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1298), 1,
      anon_sym_RBRACE,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(2089), 1,
      sym_expression,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(2606), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [18558] = 25,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(410), 1,
      anon_sym_STAR,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(850), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1300), 1,
      anon_sym_RBRACE,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(2089), 1,
      sym_expression,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(2606), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [18666] = 25,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(410), 1,
      anon_sym_STAR,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(850), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1302), 1,
      anon_sym_RBRACE,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(2089), 1,
      sym_expression,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(2606), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [18774] = 25,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(410), 1,
      anon_sym_STAR,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(850), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1304), 1,
      anon_sym_RBRACE,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(2089), 1,
      sym_expression,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(2606), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [18882] = 25,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(410), 1,
      anon_sym_STAR,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(850), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1306), 1,
      anon_sym_RBRACE,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(2089), 1,
      sym_expression,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(2606), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [18990] = 25,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(410), 1,
      anon_sym_STAR,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(850), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1308), 1,
      anon_sym_RBRACE,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(2089), 1,
      sym_expression,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(2606), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [19098] = 25,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1078), 1,
      anon_sym_type,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1084), 1,
      anon_sym_await,
    ACTIONS(1272), 1,
      sym_identifier,
    ACTIONS(1310), 1,
      anon_sym_from,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1874), 1,
      sym_expression,
    STATE(2545), 1,
      sym_expression_list,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1102), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1074), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [19206] = 25,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(410), 1,
      anon_sym_STAR,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(850), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1314), 1,
      anon_sym_RBRACE,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(2089), 1,
      sym_expression,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(2606), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [19314] = 25,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1316), 1,
      anon_sym_from,
    ACTIONS(1318), 1,
      anon_sym_STAR,
    STATE(968), 1,
      sym_string,
    STATE(969), 1,
      sym_primary_expression,
    STATE(1125), 1,
      sym_list_splat_pattern,
    STATE(1813), 1,
      sym_expression,
    STATE(2610), 1,
      sym_expression_list,
    STATE(2795), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1102), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1685), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1077), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [19422] = 25,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1318), 1,
      anon_sym_STAR,
    ACTIONS(1322), 1,
      anon_sym_from,
    STATE(968), 1,
      sym_string,
    STATE(969), 1,
      sym_primary_expression,
    STATE(1125), 1,
      sym_list_splat_pattern,
    STATE(1788), 1,
      sym_expression,
    STATE(2338), 1,
      sym_expression_list,
    STATE(2795), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1320), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1685), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1077), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [19530] = 25,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(410), 1,
      anon_sym_STAR,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(850), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1324), 1,
      anon_sym_RBRACE,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(2089), 1,
      sym_expression,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(2606), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [19638] = 24,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(834), 1,
      anon_sym_yield,
    ACTIONS(1078), 1,
      anon_sym_type,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1084), 1,
      anon_sym_await,
    ACTIONS(1088), 1,
      anon_sym_LPAREN,
    ACTIONS(1272), 1,
      sym_identifier,
    ACTIONS(1274), 1,
      anon_sym_STAR,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1933), 1,
      sym_expression,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2563), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1074), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [19744] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    ACTIONS(1326), 1,
      anon_sym_COLON,
    ACTIONS(1328), 1,
      anon_sym_RBRACK,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1881), 1,
      sym_expression,
    STATE(2561), 1,
      sym_slice,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [19851] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    ACTIONS(1326), 1,
      anon_sym_COLON,
    ACTIONS(1330), 1,
      anon_sym_RBRACK,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1881), 1,
      sym_expression,
    STATE(2561), 1,
      sym_slice,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [19958] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    ACTIONS(1326), 1,
      anon_sym_COLON,
    ACTIONS(1332), 1,
      anon_sym_RBRACK,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1881), 1,
      sym_expression,
    STATE(2561), 1,
      sym_slice,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [20065] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    ACTIONS(1326), 1,
      anon_sym_COLON,
    ACTIONS(1334), 1,
      anon_sym_RBRACK,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1881), 1,
      sym_expression,
    STATE(2561), 1,
      sym_slice,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [20172] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    ACTIONS(1326), 1,
      anon_sym_COLON,
    ACTIONS(1336), 1,
      anon_sym_RBRACK,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1881), 1,
      sym_expression,
    STATE(2561), 1,
      sym_slice,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [20279] = 24,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1318), 1,
      anon_sym_STAR,
    STATE(968), 1,
      sym_string,
    STATE(969), 1,
      sym_primary_expression,
    STATE(1125), 1,
      sym_list_splat_pattern,
    STATE(1797), 1,
      sym_expression,
    STATE(2565), 1,
      sym_expression_list,
    STATE(2795), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1338), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1685), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1077), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [20384] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    ACTIONS(1326), 1,
      anon_sym_COLON,
    ACTIONS(1340), 1,
      anon_sym_RBRACK,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1881), 1,
      sym_expression,
    STATE(2561), 1,
      sym_slice,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [20491] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    ACTIONS(1326), 1,
      anon_sym_COLON,
    ACTIONS(1342), 1,
      anon_sym_RBRACK,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1881), 1,
      sym_expression,
    STATE(2561), 1,
      sym_slice,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [20598] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    ACTIONS(1326), 1,
      anon_sym_COLON,
    ACTIONS(1344), 1,
      anon_sym_RBRACK,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1881), 1,
      sym_expression,
    STATE(2561), 1,
      sym_slice,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [20705] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    ACTIONS(1326), 1,
      anon_sym_COLON,
    ACTIONS(1346), 1,
      anon_sym_RBRACK,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1881), 1,
      sym_expression,
    STATE(2561), 1,
      sym_slice,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [20812] = 19,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(410), 1,
      anon_sym_STAR,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(675), 1,
      anon_sym_type,
    ACTIONS(677), 1,
      anon_sym_await,
    STATE(1007), 1,
      sym_string,
    STATE(1078), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 2,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1348), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(277), 9,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [20907] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    ACTIONS(1326), 1,
      anon_sym_COLON,
    ACTIONS(1350), 1,
      anon_sym_RBRACK,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1881), 1,
      sym_expression,
    STATE(2561), 1,
      sym_slice,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [21014] = 24,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(410), 1,
      anon_sym_STAR,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(850), 1,
      anon_sym_STAR_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(2089), 1,
      sym_expression,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(2606), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [21119] = 24,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    ACTIONS(1354), 1,
      anon_sym_COLON,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1879), 1,
      sym_expression,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1352), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [21224] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    ACTIONS(1326), 1,
      anon_sym_COLON,
    ACTIONS(1356), 1,
      anon_sym_RBRACK,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1881), 1,
      sym_expression,
    STATE(2561), 1,
      sym_slice,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [21331] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    ACTIONS(1326), 1,
      anon_sym_COLON,
    ACTIONS(1358), 1,
      anon_sym_RBRACK,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1881), 1,
      sym_expression,
    STATE(2561), 1,
      sym_slice,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [21438] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    ACTIONS(1326), 1,
      anon_sym_COLON,
    ACTIONS(1360), 1,
      anon_sym_RBRACK,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1881), 1,
      sym_expression,
    STATE(2561), 1,
      sym_slice,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [21545] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    ACTIONS(1326), 1,
      anon_sym_COLON,
    ACTIONS(1362), 1,
      anon_sym_RBRACK,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1881), 1,
      sym_expression,
    STATE(2561), 1,
      sym_slice,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [21652] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    ACTIONS(1326), 1,
      anon_sym_COLON,
    ACTIONS(1364), 1,
      anon_sym_RBRACK,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1881), 1,
      sym_expression,
    STATE(2561), 1,
      sym_slice,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [21759] = 24,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1318), 1,
      anon_sym_STAR,
    ACTIONS(1366), 1,
      anon_sym_from,
    STATE(968), 1,
      sym_string,
    STATE(969), 1,
      sym_primary_expression,
    STATE(1125), 1,
      sym_list_splat_pattern,
    STATE(1839), 1,
      sym_expression,
    STATE(2795), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1252), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1685), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1077), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [21864] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    ACTIONS(1326), 1,
      anon_sym_COLON,
    ACTIONS(1368), 1,
      anon_sym_RBRACK,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1881), 1,
      sym_expression,
    STATE(2561), 1,
      sym_slice,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [21971] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    ACTIONS(1326), 1,
      anon_sym_COLON,
    ACTIONS(1370), 1,
      anon_sym_RBRACK,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1881), 1,
      sym_expression,
    STATE(2561), 1,
      sym_slice,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [22078] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    ACTIONS(1326), 1,
      anon_sym_COLON,
    ACTIONS(1372), 1,
      anon_sym_RBRACK,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1881), 1,
      sym_expression,
    STATE(2561), 1,
      sym_slice,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [22185] = 24,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1318), 1,
      anon_sym_STAR,
    ACTIONS(1374), 1,
      anon_sym_from,
    STATE(968), 1,
      sym_string,
    STATE(969), 1,
      sym_primary_expression,
    STATE(1125), 1,
      sym_list_splat_pattern,
    STATE(1839), 1,
      sym_expression,
    STATE(2795), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1276), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1685), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1077), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [22290] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    ACTIONS(1326), 1,
      anon_sym_COLON,
    ACTIONS(1376), 1,
      anon_sym_RBRACK,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1881), 1,
      sym_expression,
    STATE(2561), 1,
      sym_slice,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [22397] = 24,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    ACTIONS(1380), 1,
      anon_sym_COLON,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1868), 1,
      sym_expression,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1378), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [22502] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    ACTIONS(1326), 1,
      anon_sym_COLON,
    ACTIONS(1382), 1,
      anon_sym_RBRACK,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1881), 1,
      sym_expression,
    STATE(2561), 1,
      sym_slice,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [22609] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    ACTIONS(1326), 1,
      anon_sym_COLON,
    ACTIONS(1384), 1,
      anon_sym_RBRACK,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1881), 1,
      sym_expression,
    STATE(2561), 1,
      sym_slice,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [22716] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    ACTIONS(1326), 1,
      anon_sym_COLON,
    ACTIONS(1386), 1,
      anon_sym_RBRACK,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1881), 1,
      sym_expression,
    STATE(2561), 1,
      sym_slice,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [22823] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    ACTIONS(1326), 1,
      anon_sym_COLON,
    ACTIONS(1388), 1,
      anon_sym_RBRACK,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1881), 1,
      sym_expression,
    STATE(2561), 1,
      sym_slice,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [22930] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    ACTIONS(1326), 1,
      anon_sym_COLON,
    ACTIONS(1390), 1,
      anon_sym_RBRACK,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1881), 1,
      sym_expression,
    STATE(2561), 1,
      sym_slice,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [23037] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    ACTIONS(1326), 1,
      anon_sym_COLON,
    ACTIONS(1392), 1,
      anon_sym_RBRACK,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1881), 1,
      sym_expression,
    STATE(2561), 1,
      sym_slice,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [23144] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    ACTIONS(1326), 1,
      anon_sym_COLON,
    ACTIONS(1394), 1,
      anon_sym_RBRACK,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1881), 1,
      sym_expression,
    STATE(2561), 1,
      sym_slice,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [23251] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    ACTIONS(1326), 1,
      anon_sym_COLON,
    ACTIONS(1396), 1,
      anon_sym_RBRACK,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1881), 1,
      sym_expression,
    STATE(2561), 1,
      sym_slice,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [23358] = 19,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(410), 1,
      anon_sym_STAR,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(675), 1,
      anon_sym_type,
    ACTIONS(677), 1,
      anon_sym_await,
    STATE(1007), 1,
      sym_string,
    STATE(1078), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 2,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(666), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(277), 9,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [23453] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    ACTIONS(1326), 1,
      anon_sym_COLON,
    ACTIONS(1398), 1,
      anon_sym_RBRACK,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1881), 1,
      sym_expression,
    STATE(2561), 1,
      sym_slice,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [23560] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    ACTIONS(1326), 1,
      anon_sym_COLON,
    ACTIONS(1400), 1,
      anon_sym_RBRACK,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1881), 1,
      sym_expression,
    STATE(2561), 1,
      sym_slice,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [23667] = 25,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    ACTIONS(1326), 1,
      anon_sym_COLON,
    ACTIONS(1402), 1,
      anon_sym_RBRACK,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1881), 1,
      sym_expression,
    STATE(2561), 1,
      sym_slice,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [23774] = 23,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(886), 1,
      anon_sym_not,
    ACTIONS(1128), 1,
      sym_identifier,
    ACTIONS(1134), 1,
      anon_sym_type,
    ACTIONS(1138), 1,
      anon_sym_await,
    ACTIONS(1244), 1,
      anon_sym_STAR,
    ACTIONS(1250), 1,
      anon_sym_lambda,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1011), 1,
      sym_string,
    STATE(1310), 1,
      sym_list_splat_pattern,
    STATE(1846), 1,
      sym_expression,
    STATE(2688), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    STATE(2032), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1132), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1811), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1279), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [23876] = 23,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1078), 1,
      anon_sym_type,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1084), 1,
      anon_sym_await,
    ACTIONS(1272), 1,
      sym_identifier,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1966), 1,
      sym_expression,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1252), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1074), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [23978] = 23,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(886), 1,
      anon_sym_not,
    ACTIONS(1128), 1,
      sym_identifier,
    ACTIONS(1134), 1,
      anon_sym_type,
    ACTIONS(1138), 1,
      anon_sym_await,
    ACTIONS(1244), 1,
      anon_sym_STAR,
    ACTIONS(1250), 1,
      anon_sym_lambda,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1011), 1,
      sym_string,
    STATE(1310), 1,
      sym_list_splat_pattern,
    STATE(1802), 1,
      sym_expression,
    STATE(2688), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    STATE(2012), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1132), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1811), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1279), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [24080] = 19,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(410), 1,
      anon_sym_STAR,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(675), 1,
      anon_sym_type,
    ACTIONS(677), 1,
      anon_sym_await,
    STATE(1007), 1,
      sym_string,
    STATE(1078), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 2,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(666), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(277), 9,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [24174] = 23,
    ACTIONS(728), 1,
      anon_sym_LPAREN,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(1114), 1,
      sym_identifier,
    ACTIONS(1120), 1,
      anon_sym_type,
    ACTIONS(1122), 1,
      anon_sym_await,
    ACTIONS(1240), 1,
      anon_sym_STAR,
    ACTIONS(1242), 1,
      anon_sym_lambda,
    STATE(1031), 1,
      sym_primary_expression,
    STATE(1034), 1,
      sym_string,
    STATE(1401), 1,
      sym_list_splat_pattern,
    STATE(1849), 1,
      sym_expression,
    STATE(2743), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    STATE(2104), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(726), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1118), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1826), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1303), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [24276] = 23,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1318), 1,
      anon_sym_STAR,
    STATE(968), 1,
      sym_string,
    STATE(969), 1,
      sym_primary_expression,
    STATE(1125), 1,
      sym_list_splat_pattern,
    STATE(1839), 1,
      sym_expression,
    STATE(2795), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1404), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1685), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1077), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [24378] = 23,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(886), 1,
      anon_sym_not,
    ACTIONS(1128), 1,
      sym_identifier,
    ACTIONS(1134), 1,
      anon_sym_type,
    ACTIONS(1138), 1,
      anon_sym_await,
    ACTIONS(1244), 1,
      anon_sym_STAR,
    ACTIONS(1250), 1,
      anon_sym_lambda,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1011), 1,
      sym_string,
    STATE(1310), 1,
      sym_list_splat_pattern,
    STATE(1825), 1,
      sym_expression,
    STATE(2688), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    STATE(2063), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1132), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1811), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1279), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [24480] = 23,
    ACTIONS(706), 1,
      anon_sym_LPAREN,
    ACTIONS(714), 1,
      anon_sym_LBRACK,
    ACTIONS(718), 1,
      anon_sym_LBRACE,
    ACTIONS(724), 1,
      sym_string_start,
    ACTIONS(840), 1,
      sym_identifier,
    ACTIONS(852), 1,
      anon_sym_type,
    ACTIONS(856), 1,
      anon_sym_not,
    ACTIONS(862), 1,
      anon_sym_await,
    ACTIONS(1228), 1,
      anon_sym_STAR,
    ACTIONS(1234), 1,
      anon_sym_lambda,
    STATE(979), 1,
      sym_primary_expression,
    STATE(987), 1,
      sym_string,
    STATE(1214), 1,
      sym_list_splat_pattern,
    STATE(1853), 1,
      sym_expression,
    STATE(2669), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(720), 2,
      sym_ellipsis,
      sym_float,
    STATE(2024), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(716), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(848), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1764), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1235), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [24582] = 23,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1318), 1,
      anon_sym_STAR,
    STATE(968), 1,
      sym_string,
    STATE(969), 1,
      sym_primary_expression,
    STATE(1125), 1,
      sym_list_splat_pattern,
    STATE(1839), 1,
      sym_expression,
    STATE(2795), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1406), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1685), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1077), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [24684] = 23,
    ACTIONS(728), 1,
      anon_sym_LPAREN,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(1114), 1,
      sym_identifier,
    ACTIONS(1120), 1,
      anon_sym_type,
    ACTIONS(1122), 1,
      anon_sym_await,
    ACTIONS(1240), 1,
      anon_sym_STAR,
    ACTIONS(1242), 1,
      anon_sym_lambda,
    STATE(1031), 1,
      sym_primary_expression,
    STATE(1034), 1,
      sym_string,
    STATE(1401), 1,
      sym_list_splat_pattern,
    STATE(1804), 1,
      sym_expression,
    STATE(2743), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    STATE(2112), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(726), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1118), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1826), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1303), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [24786] = 20,
    ACTIONS(294), 1,
      anon_sym_in,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(316), 1,
      anon_sym_COMMA,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(410), 1,
      anon_sym_STAR,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(675), 1,
      anon_sym_type,
    ACTIONS(677), 1,
      anon_sym_await,
    STATE(1007), 1,
      sym_string,
    STATE(1078), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 2,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(277), 9,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [24882] = 23,
    ACTIONS(728), 1,
      anon_sym_LPAREN,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(1114), 1,
      sym_identifier,
    ACTIONS(1120), 1,
      anon_sym_type,
    ACTIONS(1122), 1,
      anon_sym_await,
    ACTIONS(1240), 1,
      anon_sym_STAR,
    ACTIONS(1242), 1,
      anon_sym_lambda,
    STATE(1031), 1,
      sym_primary_expression,
    STATE(1034), 1,
      sym_string,
    STATE(1401), 1,
      sym_list_splat_pattern,
    STATE(1804), 1,
      sym_expression,
    STATE(2743), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    STATE(1996), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(726), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1118), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1826), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1303), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [24984] = 23,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1318), 1,
      anon_sym_STAR,
    STATE(968), 1,
      sym_string,
    STATE(969), 1,
      sym_primary_expression,
    STATE(1125), 1,
      sym_list_splat_pattern,
    STATE(1860), 1,
      sym_expression,
    STATE(2795), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1408), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1685), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1077), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [25086] = 23,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1952), 1,
      sym_expression,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1352), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [25188] = 23,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1078), 1,
      anon_sym_type,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1084), 1,
      anon_sym_await,
    ACTIONS(1272), 1,
      sym_identifier,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1966), 1,
      sym_expression,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1276), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1074), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [25290] = 23,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(886), 1,
      anon_sym_not,
    ACTIONS(1128), 1,
      sym_identifier,
    ACTIONS(1134), 1,
      anon_sym_type,
    ACTIONS(1138), 1,
      anon_sym_await,
    ACTIONS(1244), 1,
      anon_sym_STAR,
    ACTIONS(1250), 1,
      anon_sym_lambda,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1011), 1,
      sym_string,
    STATE(1310), 1,
      sym_list_splat_pattern,
    STATE(1802), 1,
      sym_expression,
    STATE(2688), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    STATE(1931), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1132), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1811), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1279), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [25392] = 23,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1318), 1,
      anon_sym_STAR,
    STATE(968), 1,
      sym_string,
    STATE(969), 1,
      sym_primary_expression,
    STATE(1125), 1,
      sym_list_splat_pattern,
    STATE(1860), 1,
      sym_expression,
    STATE(2795), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1410), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1685), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1077), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [25494] = 24,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1412), 1,
      anon_sym_LPAREN,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1908), 1,
      sym_expression,
    STATE(2366), 1,
      sym_with_item,
    STATE(2677), 1,
      sym__named_expression_lhs,
    STATE(2680), 1,
      sym_with_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [25598] = 23,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1988), 1,
      sym_expression,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1276), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [25700] = 24,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1412), 1,
      anon_sym_LPAREN,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1908), 1,
      sym_expression,
    STATE(2366), 1,
      sym_with_item,
    STATE(2677), 1,
      sym__named_expression_lhs,
    STATE(2767), 1,
      sym_with_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [25804] = 23,
    ACTIONS(706), 1,
      anon_sym_LPAREN,
    ACTIONS(714), 1,
      anon_sym_LBRACK,
    ACTIONS(718), 1,
      anon_sym_LBRACE,
    ACTIONS(724), 1,
      sym_string_start,
    ACTIONS(840), 1,
      sym_identifier,
    ACTIONS(852), 1,
      anon_sym_type,
    ACTIONS(856), 1,
      anon_sym_not,
    ACTIONS(862), 1,
      anon_sym_await,
    ACTIONS(1228), 1,
      anon_sym_STAR,
    ACTIONS(1234), 1,
      anon_sym_lambda,
    STATE(979), 1,
      sym_primary_expression,
    STATE(987), 1,
      sym_string,
    STATE(1214), 1,
      sym_list_splat_pattern,
    STATE(1836), 1,
      sym_expression,
    STATE(2669), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(720), 2,
      sym_ellipsis,
      sym_float,
    STATE(2106), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(716), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(848), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1764), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1235), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [25906] = 23,
    ACTIONS(728), 1,
      anon_sym_LPAREN,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(1114), 1,
      sym_identifier,
    ACTIONS(1120), 1,
      anon_sym_type,
    ACTIONS(1122), 1,
      anon_sym_await,
    ACTIONS(1240), 1,
      anon_sym_STAR,
    ACTIONS(1242), 1,
      anon_sym_lambda,
    STATE(1031), 1,
      sym_primary_expression,
    STATE(1034), 1,
      sym_string,
    STATE(1401), 1,
      sym_list_splat_pattern,
    STATE(1838), 1,
      sym_expression,
    STATE(2743), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    STATE(2105), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(726), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1118), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1826), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1303), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [26008] = 24,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1078), 1,
      anon_sym_type,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1084), 1,
      anon_sym_await,
    ACTIONS(1272), 1,
      sym_identifier,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    ACTIONS(1416), 1,
      anon_sym_RPAREN,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1977), 1,
      sym_expression,
    STATE(2603), 1,
      sym_with_item,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1074), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [26112] = 24,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    ACTIONS(1326), 1,
      anon_sym_COLON,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1881), 1,
      sym_expression,
    STATE(2561), 1,
      sym_slice,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [26216] = 23,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1913), 1,
      sym_expression,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1418), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [26318] = 23,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1988), 1,
      sym_expression,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1252), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [26420] = 24,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    ACTIONS(1326), 1,
      anon_sym_COLON,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1832), 1,
      sym_expression,
    STATE(2436), 1,
      sym_slice,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [26524] = 24,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    ACTIONS(1420), 1,
      anon_sym_COLON,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1908), 1,
      sym_expression,
    STATE(2586), 1,
      sym_with_item,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [26628] = 23,
    ACTIONS(706), 1,
      anon_sym_LPAREN,
    ACTIONS(714), 1,
      anon_sym_LBRACK,
    ACTIONS(718), 1,
      anon_sym_LBRACE,
    ACTIONS(724), 1,
      sym_string_start,
    ACTIONS(840), 1,
      sym_identifier,
    ACTIONS(852), 1,
      anon_sym_type,
    ACTIONS(856), 1,
      anon_sym_not,
    ACTIONS(862), 1,
      anon_sym_await,
    ACTIONS(1228), 1,
      anon_sym_STAR,
    ACTIONS(1234), 1,
      anon_sym_lambda,
    STATE(979), 1,
      sym_primary_expression,
    STATE(987), 1,
      sym_string,
    STATE(1214), 1,
      sym_list_splat_pattern,
    STATE(1798), 1,
      sym_expression,
    STATE(2669), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(720), 2,
      sym_ellipsis,
      sym_float,
    STATE(2050), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(716), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(848), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1764), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1235), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [26730] = 24,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    ACTIONS(1326), 1,
      anon_sym_COLON,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1812), 1,
      sym_expression,
    STATE(2292), 1,
      sym_slice,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [26834] = 24,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1412), 1,
      anon_sym_LPAREN,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1908), 1,
      sym_expression,
    STATE(2366), 1,
      sym_with_item,
    STATE(2677), 1,
      sym__named_expression_lhs,
    STATE(2704), 1,
      sym_with_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [26938] = 19,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(410), 1,
      anon_sym_STAR,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(675), 1,
      anon_sym_type,
    ACTIONS(677), 1,
      anon_sym_await,
    STATE(1007), 1,
      sym_string,
    STATE(1078), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 2,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1348), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(277), 9,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [27032] = 24,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    ACTIONS(1422), 1,
      anon_sym_COLON,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1908), 1,
      sym_expression,
    STATE(2586), 1,
      sym_with_item,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [27136] = 24,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1412), 1,
      anon_sym_LPAREN,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1908), 1,
      sym_expression,
    STATE(2366), 1,
      sym_with_item,
    STATE(2677), 1,
      sym__named_expression_lhs,
    STATE(2697), 1,
      sym_with_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [27240] = 23,
    ACTIONS(706), 1,
      anon_sym_LPAREN,
    ACTIONS(714), 1,
      anon_sym_LBRACK,
    ACTIONS(718), 1,
      anon_sym_LBRACE,
    ACTIONS(724), 1,
      sym_string_start,
    ACTIONS(840), 1,
      sym_identifier,
    ACTIONS(852), 1,
      anon_sym_type,
    ACTIONS(856), 1,
      anon_sym_not,
    ACTIONS(862), 1,
      anon_sym_await,
    ACTIONS(1228), 1,
      anon_sym_STAR,
    ACTIONS(1234), 1,
      anon_sym_lambda,
    STATE(979), 1,
      sym_primary_expression,
    STATE(987), 1,
      sym_string,
    STATE(1214), 1,
      sym_list_splat_pattern,
    STATE(1853), 1,
      sym_expression,
    STATE(2669), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(720), 2,
      sym_ellipsis,
      sym_float,
    STATE(1932), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(716), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(848), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1764), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1235), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [27342] = 24,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1078), 1,
      anon_sym_type,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1084), 1,
      anon_sym_await,
    ACTIONS(1272), 1,
      sym_identifier,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    ACTIONS(1424), 1,
      anon_sym_RPAREN,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1977), 1,
      sym_expression,
    STATE(2603), 1,
      sym_with_item,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1074), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [27446] = 24,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    ACTIONS(1326), 1,
      anon_sym_COLON,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1833), 1,
      sym_expression,
    STATE(2359), 1,
      sym_slice,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [27550] = 24,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    ACTIONS(1326), 1,
      anon_sym_COLON,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1852), 1,
      sym_expression,
    STATE(2370), 1,
      sym_slice,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [27654] = 24,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    ACTIONS(1326), 1,
      anon_sym_COLON,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1819), 1,
      sym_expression,
    STATE(2387), 1,
      sym_slice,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [27758] = 24,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    ACTIONS(1326), 1,
      anon_sym_COLON,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1809), 1,
      sym_expression,
    STATE(2454), 1,
      sym_slice,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [27862] = 19,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(410), 1,
      anon_sym_STAR,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(675), 1,
      anon_sym_type,
    ACTIONS(677), 1,
      anon_sym_await,
    STATE(1007), 1,
      sym_string,
    STATE(1078), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 2,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(316), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(277), 9,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [27956] = 24,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    ACTIONS(1326), 1,
      anon_sym_COLON,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1818), 1,
      sym_expression,
    STATE(2495), 1,
      sym_slice,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [28060] = 23,
    ACTIONS(728), 1,
      anon_sym_LPAREN,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(1114), 1,
      sym_identifier,
    ACTIONS(1120), 1,
      anon_sym_type,
    ACTIONS(1122), 1,
      anon_sym_await,
    ACTIONS(1240), 1,
      anon_sym_STAR,
    ACTIONS(1242), 1,
      anon_sym_lambda,
    STATE(1031), 1,
      sym_primary_expression,
    STATE(1034), 1,
      sym_string,
    STATE(1401), 1,
      sym_list_splat_pattern,
    STATE(1804), 1,
      sym_expression,
    STATE(2743), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    STATE(1947), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(726), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1118), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1826), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1303), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [28162] = 23,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(886), 1,
      anon_sym_not,
    ACTIONS(1128), 1,
      sym_identifier,
    ACTIONS(1134), 1,
      anon_sym_type,
    ACTIONS(1138), 1,
      anon_sym_await,
    ACTIONS(1244), 1,
      anon_sym_STAR,
    ACTIONS(1250), 1,
      anon_sym_lambda,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1011), 1,
      sym_string,
    STATE(1310), 1,
      sym_list_splat_pattern,
    STATE(1802), 1,
      sym_expression,
    STATE(2688), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    STATE(1958), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1132), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1811), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1279), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [28264] = 24,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    ACTIONS(1326), 1,
      anon_sym_COLON,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1829), 1,
      sym_expression,
    STATE(2487), 1,
      sym_slice,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [28368] = 23,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1318), 1,
      anon_sym_STAR,
    STATE(968), 1,
      sym_string,
    STATE(969), 1,
      sym_primary_expression,
    STATE(1125), 1,
      sym_list_splat_pattern,
    STATE(1860), 1,
      sym_expression,
    STATE(2795), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1426), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1685), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1077), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [28470] = 24,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    ACTIONS(1326), 1,
      anon_sym_COLON,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1845), 1,
      sym_expression,
    STATE(2395), 1,
      sym_slice,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [28574] = 23,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1949), 1,
      sym_expression,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1428), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [28676] = 19,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(410), 1,
      anon_sym_STAR,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(675), 1,
      anon_sym_type,
    ACTIONS(677), 1,
      anon_sym_await,
    STATE(1007), 1,
      sym_string,
    STATE(1078), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 2,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(316), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(277), 9,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [28770] = 23,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1318), 1,
      anon_sym_STAR,
    STATE(968), 1,
      sym_string,
    STATE(969), 1,
      sym_primary_expression,
    STATE(1125), 1,
      sym_list_splat_pattern,
    STATE(1860), 1,
      sym_expression,
    STATE(2795), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1430), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1685), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1077), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [28872] = 23,
    ACTIONS(706), 1,
      anon_sym_LPAREN,
    ACTIONS(714), 1,
      anon_sym_LBRACK,
    ACTIONS(718), 1,
      anon_sym_LBRACE,
    ACTIONS(724), 1,
      sym_string_start,
    ACTIONS(840), 1,
      sym_identifier,
    ACTIONS(852), 1,
      anon_sym_type,
    ACTIONS(856), 1,
      anon_sym_not,
    ACTIONS(862), 1,
      anon_sym_await,
    ACTIONS(1228), 1,
      anon_sym_STAR,
    ACTIONS(1234), 1,
      anon_sym_lambda,
    STATE(979), 1,
      sym_primary_expression,
    STATE(987), 1,
      sym_string,
    STATE(1214), 1,
      sym_list_splat_pattern,
    STATE(1853), 1,
      sym_expression,
    STATE(2669), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(720), 2,
      sym_ellipsis,
      sym_float,
    STATE(1960), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(716), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(848), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1764), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1235), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [28974] = 24,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    ACTIONS(1326), 1,
      anon_sym_COLON,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1814), 1,
      sym_expression,
    STATE(2310), 1,
      sym_slice,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [29078] = 23,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    ACTIONS(1432), 1,
      anon_sym_COLON,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1961), 1,
      sym_expression,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [29179] = 23,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1884), 1,
      sym_expression,
    STATE(2677), 1,
      sym__named_expression_lhs,
    STATE(2727), 1,
      sym_expression_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [29280] = 11,
    ACTIONS(284), 1,
      anon_sym_COMMA,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(294), 1,
      anon_sym_EQ,
    ACTIONS(326), 1,
      anon_sym_COLON,
    ACTIONS(1434), 1,
      sym_identifier,
    ACTIONS(1436), 1,
      sym_string_start,
    STATE(2377), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(277), 10,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(316), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(279), 22,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_is,
  [29357] = 23,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1873), 1,
      sym_expression,
    STATE(2677), 1,
      sym__named_expression_lhs,
    STATE(2713), 1,
      sym_expression_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [29458] = 23,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1908), 1,
      sym_expression,
    STATE(2586), 1,
      sym_with_item,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [29559] = 23,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    ACTIONS(1438), 1,
      anon_sym_COLON,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1961), 1,
      sym_expression,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [29660] = 23,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    ACTIONS(1440), 1,
      anon_sym_COLON,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1961), 1,
      sym_expression,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [29761] = 23,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1866), 1,
      sym_expression,
    STATE(2677), 1,
      sym__named_expression_lhs,
    STATE(2722), 1,
      sym_expression_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [29862] = 10,
    ACTIONS(284), 1,
      anon_sym_COMMA,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1434), 1,
      sym_identifier,
    ACTIONS(1436), 1,
      sym_string_start,
    STATE(2377), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(294), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(277), 10,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(316), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(279), 22,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_is,
  [29937] = 10,
    ACTIONS(284), 1,
      anon_sym_COMMA,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1442), 1,
      anon_sym_for,
    ACTIONS(1444), 1,
      anon_sym_with,
    ACTIONS(1446), 1,
      anon_sym_def,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(294), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(316), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(279), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [30012] = 23,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1078), 1,
      anon_sym_type,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1084), 1,
      anon_sym_await,
    ACTIONS(1272), 1,
      sym_identifier,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1977), 1,
      sym_expression,
    STATE(2603), 1,
      sym_with_item,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1074), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [30113] = 23,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    ACTIONS(1448), 1,
      anon_sym_COLON,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1909), 1,
      sym_expression,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [30214] = 23,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1276), 1,
      anon_sym_COLON,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1937), 1,
      sym_expression,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [30315] = 23,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1252), 1,
      anon_sym_COLON,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1937), 1,
      sym_expression,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [30416] = 23,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1318), 1,
      anon_sym_STAR,
    STATE(968), 1,
      sym_string,
    STATE(969), 1,
      sym_primary_expression,
    STATE(1125), 1,
      sym_list_splat_pattern,
    STATE(1835), 1,
      sym_expression,
    STATE(2585), 1,
      sym_expression_list,
    STATE(2795), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1685), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1077), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [30517] = 23,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1899), 1,
      sym_expression,
    STATE(2621), 1,
      sym_expression_list,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [30618] = 10,
    ACTIONS(284), 1,
      anon_sym_COMMA,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1450), 1,
      anon_sym_for,
    ACTIONS(1452), 1,
      anon_sym_with,
    ACTIONS(1454), 1,
      anon_sym_def,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(294), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(316), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(279), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [30693] = 23,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    ACTIONS(1456), 1,
      anon_sym_COLON,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1992), 1,
      sym_expression,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [30794] = 23,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    ACTIONS(1458), 1,
      anon_sym_COLON,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1961), 1,
      sym_expression,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [30895] = 22,
    ACTIONS(728), 1,
      anon_sym_LPAREN,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(1114), 1,
      sym_identifier,
    ACTIONS(1120), 1,
      anon_sym_type,
    ACTIONS(1122), 1,
      anon_sym_await,
    ACTIONS(1240), 1,
      anon_sym_STAR,
    STATE(1031), 1,
      sym_primary_expression,
    STATE(1034), 1,
      sym_string,
    STATE(1401), 1,
      sym_list_splat_pattern,
    STATE(1806), 1,
      sym_expression,
    STATE(2743), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(726), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1118), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1826), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1303), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [30993] = 22,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1775), 1,
      sym_expression,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [31091] = 22,
    ACTIONS(706), 1,
      anon_sym_LPAREN,
    ACTIONS(714), 1,
      anon_sym_LBRACK,
    ACTIONS(718), 1,
      anon_sym_LBRACE,
    ACTIONS(724), 1,
      sym_string_start,
    ACTIONS(840), 1,
      sym_identifier,
    ACTIONS(852), 1,
      anon_sym_type,
    ACTIONS(856), 1,
      anon_sym_not,
    ACTIONS(858), 1,
      anon_sym_lambda,
    ACTIONS(862), 1,
      anon_sym_await,
    ACTIONS(1228), 1,
      anon_sym_STAR,
    STATE(979), 1,
      sym_primary_expression,
    STATE(987), 1,
      sym_string,
    STATE(1214), 1,
      sym_list_splat_pattern,
    STATE(1760), 1,
      sym_expression,
    STATE(2669), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(720), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(716), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(848), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1764), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1235), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [31189] = 22,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1078), 1,
      anon_sym_type,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1084), 1,
      anon_sym_await,
    ACTIONS(1272), 1,
      sym_identifier,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1935), 1,
      sym_expression,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1074), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [31287] = 22,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1078), 1,
      anon_sym_type,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1084), 1,
      anon_sym_await,
    ACTIONS(1272), 1,
      sym_identifier,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1938), 1,
      sym_expression,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1074), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [31385] = 22,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1078), 1,
      anon_sym_type,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1084), 1,
      anon_sym_await,
    ACTIONS(1272), 1,
      sym_identifier,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1727), 1,
      sym_expression,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1074), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [31483] = 22,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(886), 1,
      anon_sym_not,
    ACTIONS(888), 1,
      anon_sym_lambda,
    ACTIONS(1128), 1,
      sym_identifier,
    ACTIONS(1134), 1,
      anon_sym_type,
    ACTIONS(1138), 1,
      anon_sym_await,
    ACTIONS(1244), 1,
      anon_sym_STAR,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1011), 1,
      sym_string,
    STATE(1310), 1,
      sym_list_splat_pattern,
    STATE(1824), 1,
      sym_expression,
    STATE(2688), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1132), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1811), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1279), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [31581] = 22,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(886), 1,
      anon_sym_not,
    ACTIONS(888), 1,
      anon_sym_lambda,
    ACTIONS(1128), 1,
      sym_identifier,
    ACTIONS(1134), 1,
      anon_sym_type,
    ACTIONS(1138), 1,
      anon_sym_await,
    ACTIONS(1244), 1,
      anon_sym_STAR,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1011), 1,
      sym_string,
    STATE(1310), 1,
      sym_list_splat_pattern,
    STATE(1843), 1,
      sym_expression,
    STATE(2688), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1132), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1811), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1279), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [31679] = 22,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(886), 1,
      anon_sym_not,
    ACTIONS(888), 1,
      anon_sym_lambda,
    ACTIONS(1128), 1,
      sym_identifier,
    ACTIONS(1134), 1,
      anon_sym_type,
    ACTIONS(1138), 1,
      anon_sym_await,
    ACTIONS(1244), 1,
      anon_sym_STAR,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1011), 1,
      sym_string,
    STATE(1310), 1,
      sym_list_splat_pattern,
    STATE(1817), 1,
      sym_expression,
    STATE(2688), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1132), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1811), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1279), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [31777] = 22,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1957), 1,
      sym_expression,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [31875] = 22,
    ACTIONS(728), 1,
      anon_sym_LPAREN,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(1114), 1,
      sym_identifier,
    ACTIONS(1120), 1,
      anon_sym_type,
    ACTIONS(1122), 1,
      anon_sym_await,
    ACTIONS(1240), 1,
      anon_sym_STAR,
    STATE(1031), 1,
      sym_primary_expression,
    STATE(1034), 1,
      sym_string,
    STATE(1401), 1,
      sym_list_splat_pattern,
    STATE(1807), 1,
      sym_expression,
    STATE(2743), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(726), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1118), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1826), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1303), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [31973] = 22,
    ACTIONS(728), 1,
      anon_sym_LPAREN,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(1114), 1,
      sym_identifier,
    ACTIONS(1120), 1,
      anon_sym_type,
    ACTIONS(1122), 1,
      anon_sym_await,
    ACTIONS(1240), 1,
      anon_sym_STAR,
    STATE(1031), 1,
      sym_primary_expression,
    STATE(1034), 1,
      sym_string,
    STATE(1401), 1,
      sym_list_splat_pattern,
    STATE(1890), 1,
      sym_expression,
    STATE(2743), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(726), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1118), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1826), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1303), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [32071] = 22,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1318), 1,
      anon_sym_STAR,
    STATE(968), 1,
      sym_string,
    STATE(969), 1,
      sym_primary_expression,
    STATE(1125), 1,
      sym_list_splat_pattern,
    STATE(1688), 1,
      sym_expression,
    STATE(2795), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1685), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1077), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [32169] = 9,
    ACTIONS(1464), 1,
      anon_sym_else,
    ACTIONS(1466), 1,
      anon_sym_except_STAR,
    ACTIONS(1468), 1,
      anon_sym_finally,
    STATE(707), 1,
      sym_else_clause,
    STATE(773), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(602), 2,
      sym_except_group_clause,
      aux_sym_try_statement_repeat2,
    ACTIONS(1462), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1460), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [32241] = 9,
    ACTIONS(1464), 1,
      anon_sym_else,
    ACTIONS(1468), 1,
      anon_sym_finally,
    ACTIONS(1470), 1,
      anon_sym_except,
    STATE(707), 1,
      sym_else_clause,
    STATE(773), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(611), 2,
      sym_except_clause,
      aux_sym_try_statement_repeat1,
    ACTIONS(1462), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1460), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [32313] = 22,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1078), 1,
      anon_sym_type,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1084), 1,
      anon_sym_await,
    ACTIONS(1272), 1,
      sym_identifier,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1966), 1,
      sym_expression,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1074), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [32411] = 22,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1318), 1,
      anon_sym_STAR,
    STATE(968), 1,
      sym_string,
    STATE(969), 1,
      sym_primary_expression,
    STATE(1125), 1,
      sym_list_splat_pattern,
    STATE(1686), 1,
      sym_expression,
    STATE(2795), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1685), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1077), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [32509] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(2082), 1,
      sym_expression,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [32607] = 22,
    ACTIONS(706), 1,
      anon_sym_LPAREN,
    ACTIONS(714), 1,
      anon_sym_LBRACK,
    ACTIONS(718), 1,
      anon_sym_LBRACE,
    ACTIONS(724), 1,
      sym_string_start,
    ACTIONS(840), 1,
      sym_identifier,
    ACTIONS(852), 1,
      anon_sym_type,
    ACTIONS(856), 1,
      anon_sym_not,
    ACTIONS(858), 1,
      anon_sym_lambda,
    ACTIONS(862), 1,
      anon_sym_await,
    ACTIONS(1228), 1,
      anon_sym_STAR,
    STATE(979), 1,
      sym_primary_expression,
    STATE(987), 1,
      sym_string,
    STATE(1214), 1,
      sym_list_splat_pattern,
    STATE(1779), 1,
      sym_expression,
    STATE(2669), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(720), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(716), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(848), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1764), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1235), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [32705] = 23,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    ACTIONS(1472), 1,
      sym_identifier,
    ACTIONS(1476), 1,
      anon_sym_type,
    ACTIONS(1478), 1,
      anon_sym_await,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1918), 1,
      sym_expression,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    STATE(1503), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1474), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [32805] = 22,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1988), 1,
      sym_expression,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [32903] = 22,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1318), 1,
      anon_sym_STAR,
    STATE(968), 1,
      sym_string,
    STATE(969), 1,
      sym_primary_expression,
    STATE(1125), 1,
      sym_list_splat_pattern,
    STATE(1691), 1,
      sym_expression,
    STATE(2795), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1685), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1077), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [33001] = 22,
    ACTIONS(684), 1,
      anon_sym_LPAREN,
    ACTIONS(692), 1,
      anon_sym_LBRACK,
    ACTIONS(696), 1,
      anon_sym_LBRACE,
    ACTIONS(702), 1,
      sym_string_start,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(1098), 1,
      sym_identifier,
    ACTIONS(1106), 1,
      anon_sym_type,
    ACTIONS(1108), 1,
      anon_sym_await,
    STATE(972), 1,
      sym_primary_expression,
    STATE(977), 1,
      sym_string,
    STATE(1218), 1,
      sym_list_splat_pattern,
    STATE(1785), 1,
      sym_expression,
    STATE(2784), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(698), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(694), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(682), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1104), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1794), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1258), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [33099] = 22,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1318), 1,
      anon_sym_STAR,
    STATE(968), 1,
      sym_string,
    STATE(969), 1,
      sym_primary_expression,
    STATE(1125), 1,
      sym_list_splat_pattern,
    STATE(1831), 1,
      sym_expression,
    STATE(2795), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1685), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1077), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [33197] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(2087), 1,
      sym_expression,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [33295] = 22,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1318), 1,
      anon_sym_STAR,
    STATE(968), 1,
      sym_string,
    STATE(969), 1,
      sym_primary_expression,
    STATE(1125), 1,
      sym_list_splat_pattern,
    STATE(1677), 1,
      sym_expression,
    STATE(2795), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1685), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1077), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [33393] = 22,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1318), 1,
      anon_sym_STAR,
    STATE(968), 1,
      sym_string,
    STATE(969), 1,
      sym_primary_expression,
    STATE(1125), 1,
      sym_list_splat_pattern,
    STATE(1828), 1,
      sym_expression,
    STATE(2795), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1685), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1077), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [33491] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1743), 1,
      sym_expression,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [33589] = 23,
    ACTIONS(684), 1,
      anon_sym_LPAREN,
    ACTIONS(692), 1,
      anon_sym_LBRACK,
    ACTIONS(696), 1,
      anon_sym_LBRACE,
    ACTIONS(702), 1,
      sym_string_start,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(1480), 1,
      sym_identifier,
    ACTIONS(1484), 1,
      anon_sym_type,
    ACTIONS(1486), 1,
      anon_sym_await,
    STATE(977), 1,
      sym_string,
    STATE(1218), 1,
      sym_list_splat_pattern,
    STATE(1221), 1,
      sym_primary_expression,
    STATE(2001), 1,
      sym_expression,
    STATE(2784), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(698), 2,
      sym_ellipsis,
      sym_float,
    STATE(1256), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(694), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(682), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1482), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1794), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1258), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [33689] = 22,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1318), 1,
      anon_sym_STAR,
    STATE(968), 1,
      sym_string,
    STATE(969), 1,
      sym_primary_expression,
    STATE(1125), 1,
      sym_list_splat_pattern,
    STATE(1860), 1,
      sym_expression,
    STATE(2795), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1685), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1077), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [33787] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(2040), 1,
      sym_expression,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [33885] = 23,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    ACTIONS(1488), 1,
      sym_identifier,
    ACTIONS(1492), 1,
      anon_sym_type,
    ACTIONS(1494), 1,
      anon_sym_await,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1941), 1,
      sym_expression,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    STATE(1501), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1490), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [33985] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1998), 1,
      sym_expression,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [34083] = 22,
    ACTIONS(684), 1,
      anon_sym_LPAREN,
    ACTIONS(692), 1,
      anon_sym_LBRACK,
    ACTIONS(696), 1,
      anon_sym_LBRACE,
    ACTIONS(702), 1,
      sym_string_start,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(1098), 1,
      sym_identifier,
    ACTIONS(1106), 1,
      anon_sym_type,
    ACTIONS(1108), 1,
      anon_sym_await,
    STATE(972), 1,
      sym_primary_expression,
    STATE(977), 1,
      sym_string,
    STATE(1218), 1,
      sym_list_splat_pattern,
    STATE(1792), 1,
      sym_expression,
    STATE(2784), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(698), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(694), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(682), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1104), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1794), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1258), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [34181] = 22,
    ACTIONS(684), 1,
      anon_sym_LPAREN,
    ACTIONS(692), 1,
      anon_sym_LBRACK,
    ACTIONS(696), 1,
      anon_sym_LBRACE,
    ACTIONS(702), 1,
      sym_string_start,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(1098), 1,
      sym_identifier,
    ACTIONS(1106), 1,
      anon_sym_type,
    ACTIONS(1108), 1,
      anon_sym_await,
    STATE(972), 1,
      sym_primary_expression,
    STATE(977), 1,
      sym_string,
    STATE(1218), 1,
      sym_list_splat_pattern,
    STATE(1791), 1,
      sym_expression,
    STATE(2784), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(698), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(694), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(682), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1104), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1794), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1258), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [34279] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(2090), 1,
      sym_expression,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [34377] = 22,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(886), 1,
      anon_sym_not,
    ACTIONS(888), 1,
      anon_sym_lambda,
    ACTIONS(1128), 1,
      sym_identifier,
    ACTIONS(1134), 1,
      anon_sym_type,
    ACTIONS(1138), 1,
      anon_sym_await,
    ACTIONS(1244), 1,
      anon_sym_STAR,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1011), 1,
      sym_string,
    STATE(1310), 1,
      sym_list_splat_pattern,
    STATE(1827), 1,
      sym_expression,
    STATE(2688), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1132), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1811), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1279), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [34475] = 22,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1318), 1,
      anon_sym_STAR,
    STATE(968), 1,
      sym_string,
    STATE(969), 1,
      sym_primary_expression,
    STATE(1125), 1,
      sym_list_splat_pattern,
    STATE(1967), 1,
      sym_expression,
    STATE(2795), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1685), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1077), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [34573] = 22,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(886), 1,
      anon_sym_not,
    ACTIONS(888), 1,
      anon_sym_lambda,
    ACTIONS(1128), 1,
      sym_identifier,
    ACTIONS(1134), 1,
      anon_sym_type,
    ACTIONS(1138), 1,
      anon_sym_await,
    ACTIONS(1244), 1,
      anon_sym_STAR,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1011), 1,
      sym_string,
    STATE(1310), 1,
      sym_list_splat_pattern,
    STATE(1801), 1,
      sym_expression,
    STATE(2688), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1132), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1811), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1279), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [34671] = 22,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(886), 1,
      anon_sym_not,
    ACTIONS(888), 1,
      anon_sym_lambda,
    ACTIONS(1128), 1,
      sym_identifier,
    ACTIONS(1134), 1,
      anon_sym_type,
    ACTIONS(1138), 1,
      anon_sym_await,
    ACTIONS(1244), 1,
      anon_sym_STAR,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1011), 1,
      sym_string,
    STATE(1310), 1,
      sym_list_splat_pattern,
    STATE(1877), 1,
      sym_expression,
    STATE(2688), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1132), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1811), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1279), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [34769] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1961), 1,
      sym_expression,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [34867] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(2118), 1,
      sym_expression,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [34965] = 22,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1078), 1,
      anon_sym_type,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1084), 1,
      anon_sym_await,
    ACTIONS(1272), 1,
      sym_identifier,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1929), 1,
      sym_expression,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1074), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [35063] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1741), 1,
      sym_expression,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [35161] = 22,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1318), 1,
      anon_sym_STAR,
    STATE(968), 1,
      sym_string,
    STATE(969), 1,
      sym_primary_expression,
    STATE(1125), 1,
      sym_list_splat_pattern,
    STATE(1922), 1,
      sym_expression,
    STATE(2795), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1685), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1077), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [35259] = 22,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(886), 1,
      anon_sym_not,
    ACTIONS(888), 1,
      anon_sym_lambda,
    ACTIONS(1128), 1,
      sym_identifier,
    ACTIONS(1134), 1,
      anon_sym_type,
    ACTIONS(1138), 1,
      anon_sym_await,
    ACTIONS(1244), 1,
      anon_sym_STAR,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1011), 1,
      sym_string,
    STATE(1310), 1,
      sym_list_splat_pattern,
    STATE(1834), 1,
      sym_expression,
    STATE(2688), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1132), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1811), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1279), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [35357] = 22,
    ACTIONS(684), 1,
      anon_sym_LPAREN,
    ACTIONS(692), 1,
      anon_sym_LBRACK,
    ACTIONS(696), 1,
      anon_sym_LBRACE,
    ACTIONS(702), 1,
      sym_string_start,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(1098), 1,
      sym_identifier,
    ACTIONS(1106), 1,
      anon_sym_type,
    ACTIONS(1108), 1,
      anon_sym_await,
    STATE(972), 1,
      sym_primary_expression,
    STATE(977), 1,
      sym_string,
    STATE(1218), 1,
      sym_list_splat_pattern,
    STATE(1925), 1,
      sym_expression,
    STATE(2784), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(698), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(694), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(682), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1104), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1794), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1258), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [35455] = 22,
    ACTIONS(706), 1,
      anon_sym_LPAREN,
    ACTIONS(714), 1,
      anon_sym_LBRACK,
    ACTIONS(718), 1,
      anon_sym_LBRACE,
    ACTIONS(724), 1,
      sym_string_start,
    ACTIONS(840), 1,
      sym_identifier,
    ACTIONS(852), 1,
      anon_sym_type,
    ACTIONS(856), 1,
      anon_sym_not,
    ACTIONS(858), 1,
      anon_sym_lambda,
    ACTIONS(862), 1,
      anon_sym_await,
    ACTIONS(1228), 1,
      anon_sym_STAR,
    STATE(979), 1,
      sym_primary_expression,
    STATE(987), 1,
      sym_string,
    STATE(1214), 1,
      sym_list_splat_pattern,
    STATE(1786), 1,
      sym_expression,
    STATE(2669), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(720), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(716), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(848), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1764), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1235), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [35553] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1757), 1,
      sym_expression,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [35651] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(2110), 1,
      sym_expression,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [35749] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1937), 1,
      sym_expression,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [35847] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(2111), 1,
      sym_expression,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [35945] = 9,
    ACTIONS(1496), 1,
      anon_sym_else,
    ACTIONS(1498), 1,
      anon_sym_except,
    ACTIONS(1500), 1,
      anon_sym_finally,
    STATE(694), 1,
      sym_else_clause,
    STATE(739), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(616), 2,
      sym_except_clause,
      aux_sym_try_statement_repeat1,
    ACTIONS(1462), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1460), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [36017] = 22,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1078), 1,
      anon_sym_type,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1084), 1,
      anon_sym_await,
    ACTIONS(1272), 1,
      sym_identifier,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1739), 1,
      sym_expression,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1074), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [36115] = 22,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1778), 1,
      sym_expression,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [36213] = 22,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1763), 1,
      sym_expression,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [36311] = 9,
    ACTIONS(1496), 1,
      anon_sym_else,
    ACTIONS(1498), 1,
      anon_sym_except,
    ACTIONS(1500), 1,
      anon_sym_finally,
    STATE(702), 1,
      sym_else_clause,
    STATE(830), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(616), 2,
      sym_except_clause,
      aux_sym_try_statement_repeat1,
    ACTIONS(1502), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1504), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [36383] = 9,
    ACTIONS(1496), 1,
      anon_sym_else,
    ACTIONS(1500), 1,
      anon_sym_finally,
    ACTIONS(1506), 1,
      anon_sym_except_STAR,
    STATE(702), 1,
      sym_else_clause,
    STATE(830), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(617), 2,
      sym_except_group_clause,
      aux_sym_try_statement_repeat2,
    ACTIONS(1502), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1504), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [36455] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1751), 1,
      sym_expression,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [36553] = 22,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1318), 1,
      anon_sym_STAR,
    STATE(968), 1,
      sym_string,
    STATE(969), 1,
      sym_primary_expression,
    STATE(1125), 1,
      sym_list_splat_pattern,
    STATE(1897), 1,
      sym_expression,
    STATE(2795), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1685), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1077), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [36651] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(2027), 1,
      sym_expression,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [36749] = 22,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1078), 1,
      anon_sym_type,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1084), 1,
      anon_sym_await,
    ACTIONS(1272), 1,
      sym_identifier,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1721), 1,
      sym_expression,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1074), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [36847] = 9,
    ACTIONS(1496), 1,
      anon_sym_else,
    ACTIONS(1500), 1,
      anon_sym_finally,
    ACTIONS(1506), 1,
      anon_sym_except_STAR,
    STATE(694), 1,
      sym_else_clause,
    STATE(739), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(617), 2,
      sym_except_group_clause,
      aux_sym_try_statement_repeat2,
    ACTIONS(1462), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1460), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [36919] = 22,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1078), 1,
      anon_sym_type,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1084), 1,
      anon_sym_await,
    ACTIONS(1272), 1,
      sym_identifier,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1740), 1,
      sym_expression,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1074), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [37017] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(2014), 1,
      sym_expression,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [37115] = 22,
    ACTIONS(706), 1,
      anon_sym_LPAREN,
    ACTIONS(714), 1,
      anon_sym_LBRACK,
    ACTIONS(718), 1,
      anon_sym_LBRACE,
    ACTIONS(724), 1,
      sym_string_start,
    ACTIONS(840), 1,
      sym_identifier,
    ACTIONS(852), 1,
      anon_sym_type,
    ACTIONS(856), 1,
      anon_sym_not,
    ACTIONS(858), 1,
      anon_sym_lambda,
    ACTIONS(862), 1,
      anon_sym_await,
    ACTIONS(1228), 1,
      anon_sym_STAR,
    STATE(979), 1,
      sym_primary_expression,
    STATE(987), 1,
      sym_string,
    STATE(1214), 1,
      sym_list_splat_pattern,
    STATE(1790), 1,
      sym_expression,
    STATE(2669), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(720), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(716), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(848), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1764), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1235), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [37213] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1746), 1,
      sym_expression,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [37311] = 22,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1318), 1,
      anon_sym_STAR,
    STATE(968), 1,
      sym_string,
    STATE(969), 1,
      sym_primary_expression,
    STATE(1125), 1,
      sym_list_splat_pattern,
    STATE(1682), 1,
      sym_expression,
    STATE(2795), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1685), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1077), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [37409] = 22,
    ACTIONS(728), 1,
      anon_sym_LPAREN,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(1114), 1,
      sym_identifier,
    ACTIONS(1120), 1,
      anon_sym_type,
    ACTIONS(1122), 1,
      anon_sym_await,
    ACTIONS(1240), 1,
      anon_sym_STAR,
    STATE(1031), 1,
      sym_primary_expression,
    STATE(1034), 1,
      sym_string,
    STATE(1401), 1,
      sym_list_splat_pattern,
    STATE(1822), 1,
      sym_expression,
    STATE(2743), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(726), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1118), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1826), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1303), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [37507] = 22,
    ACTIONS(706), 1,
      anon_sym_LPAREN,
    ACTIONS(714), 1,
      anon_sym_LBRACK,
    ACTIONS(718), 1,
      anon_sym_LBRACE,
    ACTIONS(724), 1,
      sym_string_start,
    ACTIONS(840), 1,
      sym_identifier,
    ACTIONS(852), 1,
      anon_sym_type,
    ACTIONS(856), 1,
      anon_sym_not,
    ACTIONS(858), 1,
      anon_sym_lambda,
    ACTIONS(862), 1,
      anon_sym_await,
    ACTIONS(1228), 1,
      anon_sym_STAR,
    STATE(979), 1,
      sym_primary_expression,
    STATE(987), 1,
      sym_string,
    STATE(1214), 1,
      sym_list_splat_pattern,
    STATE(1887), 1,
      sym_expression,
    STATE(2669), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(720), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(716), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(848), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1764), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1235), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [37605] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1748), 1,
      sym_expression,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [37703] = 22,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1078), 1,
      anon_sym_type,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1084), 1,
      anon_sym_await,
    ACTIONS(1272), 1,
      sym_identifier,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1735), 1,
      sym_expression,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1074), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [37801] = 22,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1078), 1,
      anon_sym_type,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1084), 1,
      anon_sym_await,
    ACTIONS(1272), 1,
      sym_identifier,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1719), 1,
      sym_expression,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1074), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [37899] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(2120), 1,
      sym_expression,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [37997] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(2101), 1,
      sym_expression,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [38095] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1919), 1,
      sym_expression,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [38193] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(2070), 1,
      sym_expression,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [38291] = 22,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1078), 1,
      anon_sym_type,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1084), 1,
      anon_sym_await,
    ACTIONS(1272), 1,
      sym_identifier,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1720), 1,
      sym_expression,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1074), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [38389] = 22,
    ACTIONS(706), 1,
      anon_sym_LPAREN,
    ACTIONS(714), 1,
      anon_sym_LBRACK,
    ACTIONS(718), 1,
      anon_sym_LBRACE,
    ACTIONS(724), 1,
      sym_string_start,
    ACTIONS(840), 1,
      sym_identifier,
    ACTIONS(852), 1,
      anon_sym_type,
    ACTIONS(856), 1,
      anon_sym_not,
    ACTIONS(858), 1,
      anon_sym_lambda,
    ACTIONS(862), 1,
      anon_sym_await,
    ACTIONS(1228), 1,
      anon_sym_STAR,
    STATE(979), 1,
      sym_primary_expression,
    STATE(987), 1,
      sym_string,
    STATE(1214), 1,
      sym_list_splat_pattern,
    STATE(1789), 1,
      sym_expression,
    STATE(2669), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(720), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(716), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(848), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1764), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1235), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [38487] = 9,
    ACTIONS(1464), 1,
      anon_sym_else,
    ACTIONS(1468), 1,
      anon_sym_finally,
    ACTIONS(1470), 1,
      anon_sym_except,
    STATE(701), 1,
      sym_else_clause,
    STATE(806), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(611), 2,
      sym_except_clause,
      aux_sym_try_statement_repeat1,
    ACTIONS(1502), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1504), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [38559] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1928), 1,
      sym_expression,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [38657] = 22,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1078), 1,
      anon_sym_type,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1084), 1,
      anon_sym_await,
    ACTIONS(1272), 1,
      sym_identifier,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(2000), 1,
      sym_expression,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1074), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [38755] = 9,
    ACTIONS(1464), 1,
      anon_sym_else,
    ACTIONS(1466), 1,
      anon_sym_except_STAR,
    ACTIONS(1468), 1,
      anon_sym_finally,
    STATE(701), 1,
      sym_else_clause,
    STATE(806), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(602), 2,
      sym_except_group_clause,
      aux_sym_try_statement_repeat2,
    ACTIONS(1502), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1504), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [38827] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1750), 1,
      sym_expression,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [38925] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(2034), 1,
      sym_expression,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [39023] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(2098), 1,
      sym_expression,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [39121] = 22,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1318), 1,
      anon_sym_STAR,
    STATE(968), 1,
      sym_string,
    STATE(969), 1,
      sym_primary_expression,
    STATE(1125), 1,
      sym_list_splat_pattern,
    STATE(1995), 1,
      sym_expression,
    STATE(2795), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1685), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1077), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [39219] = 23,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    ACTIONS(1478), 1,
      anon_sym_await,
    ACTIONS(1508), 1,
      sym_identifier,
    ACTIONS(1512), 1,
      anon_sym_type,
    STATE(1152), 1,
      sym_string,
    STATE(1278), 1,
      sym_primary_expression,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1918), 1,
      sym_expression,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    STATE(1403), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1510), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [39319] = 22,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1774), 1,
      sym_expression,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [39417] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(2123), 1,
      sym_expression,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [39515] = 22,
    ACTIONS(684), 1,
      anon_sym_LPAREN,
    ACTIONS(692), 1,
      anon_sym_LBRACK,
    ACTIONS(696), 1,
      anon_sym_LBRACE,
    ACTIONS(702), 1,
      sym_string_start,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(1098), 1,
      sym_identifier,
    ACTIONS(1106), 1,
      anon_sym_type,
    ACTIONS(1108), 1,
      anon_sym_await,
    STATE(972), 1,
      sym_primary_expression,
    STATE(977), 1,
      sym_string,
    STATE(1218), 1,
      sym_list_splat_pattern,
    STATE(1793), 1,
      sym_expression,
    STATE(2784), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(698), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(694), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(682), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1104), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1794), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1258), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [39613] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(2113), 1,
      sym_expression,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [39711] = 22,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1318), 1,
      anon_sym_STAR,
    STATE(968), 1,
      sym_string,
    STATE(969), 1,
      sym_primary_expression,
    STATE(1125), 1,
      sym_list_splat_pattern,
    STATE(1839), 1,
      sym_expression,
    STATE(2795), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1685), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1077), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [39809] = 22,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1769), 1,
      sym_expression,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [39907] = 22,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1768), 1,
      sym_expression,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [40005] = 22,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1766), 1,
      sym_expression,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [40103] = 22,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1078), 1,
      anon_sym_type,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1084), 1,
      anon_sym_await,
    ACTIONS(1272), 1,
      sym_identifier,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1759), 1,
      sym_expression,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1074), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [40201] = 22,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1078), 1,
      anon_sym_type,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1084), 1,
      anon_sym_await,
    ACTIONS(1272), 1,
      sym_identifier,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1963), 1,
      sym_expression,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1074), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [40299] = 22,
    ACTIONS(684), 1,
      anon_sym_LPAREN,
    ACTIONS(692), 1,
      anon_sym_LBRACK,
    ACTIONS(696), 1,
      anon_sym_LBRACE,
    ACTIONS(702), 1,
      sym_string_start,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(1098), 1,
      sym_identifier,
    ACTIONS(1106), 1,
      anon_sym_type,
    ACTIONS(1108), 1,
      anon_sym_await,
    STATE(972), 1,
      sym_primary_expression,
    STATE(977), 1,
      sym_string,
    STATE(1218), 1,
      sym_list_splat_pattern,
    STATE(1795), 1,
      sym_expression,
    STATE(2784), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(698), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(694), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(682), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1104), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1794), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1258), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [40397] = 22,
    ACTIONS(706), 1,
      anon_sym_LPAREN,
    ACTIONS(714), 1,
      anon_sym_LBRACK,
    ACTIONS(718), 1,
      anon_sym_LBRACE,
    ACTIONS(724), 1,
      sym_string_start,
    ACTIONS(840), 1,
      sym_identifier,
    ACTIONS(852), 1,
      anon_sym_type,
    ACTIONS(856), 1,
      anon_sym_not,
    ACTIONS(858), 1,
      anon_sym_lambda,
    ACTIONS(862), 1,
      anon_sym_await,
    ACTIONS(1228), 1,
      anon_sym_STAR,
    STATE(979), 1,
      sym_primary_expression,
    STATE(987), 1,
      sym_string,
    STATE(1214), 1,
      sym_list_splat_pattern,
    STATE(1841), 1,
      sym_expression,
    STATE(2669), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(720), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(716), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(848), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1764), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1235), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [40495] = 22,
    ACTIONS(684), 1,
      anon_sym_LPAREN,
    ACTIONS(692), 1,
      anon_sym_LBRACK,
    ACTIONS(696), 1,
      anon_sym_LBRACE,
    ACTIONS(702), 1,
      sym_string_start,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(1098), 1,
      sym_identifier,
    ACTIONS(1106), 1,
      anon_sym_type,
    ACTIONS(1108), 1,
      anon_sym_await,
    STATE(972), 1,
      sym_primary_expression,
    STATE(977), 1,
      sym_string,
    STATE(1218), 1,
      sym_list_splat_pattern,
    STATE(1942), 1,
      sym_expression,
    STATE(2784), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(698), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(694), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(682), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1104), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1794), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1258), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [40593] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(2080), 1,
      sym_expression,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [40691] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(2100), 1,
      sym_expression,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [40789] = 22,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(886), 1,
      anon_sym_not,
    ACTIONS(888), 1,
      anon_sym_lambda,
    ACTIONS(1128), 1,
      sym_identifier,
    ACTIONS(1134), 1,
      anon_sym_type,
    ACTIONS(1138), 1,
      anon_sym_await,
    ACTIONS(1244), 1,
      anon_sym_STAR,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1011), 1,
      sym_string,
    STATE(1310), 1,
      sym_list_splat_pattern,
    STATE(1805), 1,
      sym_expression,
    STATE(2688), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1132), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1811), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1279), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [40887] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(2051), 1,
      sym_expression,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [40985] = 22,
    ACTIONS(706), 1,
      anon_sym_LPAREN,
    ACTIONS(714), 1,
      anon_sym_LBRACK,
    ACTIONS(718), 1,
      anon_sym_LBRACE,
    ACTIONS(724), 1,
      sym_string_start,
    ACTIONS(840), 1,
      sym_identifier,
    ACTIONS(852), 1,
      anon_sym_type,
    ACTIONS(856), 1,
      anon_sym_not,
    ACTIONS(858), 1,
      anon_sym_lambda,
    ACTIONS(862), 1,
      anon_sym_await,
    ACTIONS(1228), 1,
      anon_sym_STAR,
    STATE(979), 1,
      sym_primary_expression,
    STATE(987), 1,
      sym_string,
    STATE(1214), 1,
      sym_list_splat_pattern,
    STATE(1782), 1,
      sym_expression,
    STATE(2669), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(720), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(716), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(848), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1764), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1235), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [41083] = 22,
    ACTIONS(728), 1,
      anon_sym_LPAREN,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(1114), 1,
      sym_identifier,
    ACTIONS(1120), 1,
      anon_sym_type,
    ACTIONS(1122), 1,
      anon_sym_await,
    ACTIONS(1240), 1,
      anon_sym_STAR,
    STATE(1031), 1,
      sym_primary_expression,
    STATE(1034), 1,
      sym_string,
    STATE(1401), 1,
      sym_list_splat_pattern,
    STATE(1847), 1,
      sym_expression,
    STATE(2743), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(726), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1118), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1826), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1303), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [41181] = 22,
    ACTIONS(684), 1,
      anon_sym_LPAREN,
    ACTIONS(692), 1,
      anon_sym_LBRACK,
    ACTIONS(696), 1,
      anon_sym_LBRACE,
    ACTIONS(702), 1,
      sym_string_start,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(1098), 1,
      sym_identifier,
    ACTIONS(1106), 1,
      anon_sym_type,
    ACTIONS(1108), 1,
      anon_sym_await,
    STATE(972), 1,
      sym_primary_expression,
    STATE(977), 1,
      sym_string,
    STATE(1218), 1,
      sym_list_splat_pattern,
    STATE(1773), 1,
      sym_expression,
    STATE(2784), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(698), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(694), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(682), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1104), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1794), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1258), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [41279] = 22,
    ACTIONS(684), 1,
      anon_sym_LPAREN,
    ACTIONS(692), 1,
      anon_sym_LBRACK,
    ACTIONS(696), 1,
      anon_sym_LBRACE,
    ACTIONS(702), 1,
      sym_string_start,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(1098), 1,
      sym_identifier,
    ACTIONS(1106), 1,
      anon_sym_type,
    ACTIONS(1108), 1,
      anon_sym_await,
    STATE(972), 1,
      sym_primary_expression,
    STATE(977), 1,
      sym_string,
    STATE(1218), 1,
      sym_list_splat_pattern,
    STATE(1772), 1,
      sym_expression,
    STATE(2784), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(698), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(694), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(682), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1104), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1794), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1258), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [41377] = 22,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(886), 1,
      anon_sym_not,
    ACTIONS(888), 1,
      anon_sym_lambda,
    ACTIONS(1128), 1,
      sym_identifier,
    ACTIONS(1134), 1,
      anon_sym_type,
    ACTIONS(1138), 1,
      anon_sym_await,
    ACTIONS(1244), 1,
      anon_sym_STAR,
    STATE(1010), 1,
      sym_primary_expression,
    STATE(1011), 1,
      sym_string,
    STATE(1310), 1,
      sym_list_splat_pattern,
    STATE(1800), 1,
      sym_expression,
    STATE(2688), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(772), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1132), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1811), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1279), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [41475] = 22,
    ACTIONS(706), 1,
      anon_sym_LPAREN,
    ACTIONS(714), 1,
      anon_sym_LBRACK,
    ACTIONS(718), 1,
      anon_sym_LBRACE,
    ACTIONS(724), 1,
      sym_string_start,
    ACTIONS(840), 1,
      sym_identifier,
    ACTIONS(852), 1,
      anon_sym_type,
    ACTIONS(856), 1,
      anon_sym_not,
    ACTIONS(858), 1,
      anon_sym_lambda,
    ACTIONS(862), 1,
      anon_sym_await,
    ACTIONS(1228), 1,
      anon_sym_STAR,
    STATE(979), 1,
      sym_primary_expression,
    STATE(987), 1,
      sym_string,
    STATE(1214), 1,
      sym_list_splat_pattern,
    STATE(1784), 1,
      sym_expression,
    STATE(2669), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(720), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(716), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(848), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1764), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1235), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [41573] = 22,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1318), 1,
      anon_sym_STAR,
    STATE(968), 1,
      sym_string,
    STATE(969), 1,
      sym_primary_expression,
    STATE(1125), 1,
      sym_list_splat_pattern,
    STATE(1687), 1,
      sym_expression,
    STATE(2795), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1685), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1077), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [41671] = 22,
    ACTIONS(706), 1,
      anon_sym_LPAREN,
    ACTIONS(714), 1,
      anon_sym_LBRACK,
    ACTIONS(718), 1,
      anon_sym_LBRACE,
    ACTIONS(724), 1,
      sym_string_start,
    ACTIONS(840), 1,
      sym_identifier,
    ACTIONS(852), 1,
      anon_sym_type,
    ACTIONS(856), 1,
      anon_sym_not,
    ACTIONS(858), 1,
      anon_sym_lambda,
    ACTIONS(862), 1,
      anon_sym_await,
    ACTIONS(1228), 1,
      anon_sym_STAR,
    STATE(979), 1,
      sym_primary_expression,
    STATE(987), 1,
      sym_string,
    STATE(1214), 1,
      sym_list_splat_pattern,
    STATE(1783), 1,
      sym_expression,
    STATE(2669), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(720), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(716), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(704), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(848), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1764), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1235), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [41769] = 22,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1318), 1,
      anon_sym_STAR,
    STATE(968), 1,
      sym_string,
    STATE(969), 1,
      sym_primary_expression,
    STATE(1125), 1,
      sym_list_splat_pattern,
    STATE(2047), 1,
      sym_expression,
    STATE(2795), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1685), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1077), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [41867] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1749), 1,
      sym_expression,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [41965] = 22,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1318), 1,
      anon_sym_STAR,
    STATE(968), 1,
      sym_string,
    STATE(969), 1,
      sym_primary_expression,
    STATE(1125), 1,
      sym_list_splat_pattern,
    STATE(1676), 1,
      sym_expression,
    STATE(2795), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1685), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1077), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [42063] = 22,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1022), 1,
      anon_sym_type,
    ACTIONS(1024), 1,
      anon_sym_not,
    ACTIONS(1026), 1,
      anon_sym_lambda,
    ACTIONS(1028), 1,
      anon_sym_await,
    ACTIONS(1254), 1,
      sym_identifier,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    STATE(1083), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_string,
    STATE(1484), 1,
      sym_list_splat_pattern,
    STATE(1762), 1,
      sym_expression,
    STATE(2626), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(794), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1018), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1781), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [42161] = 23,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    ACTIONS(1494), 1,
      anon_sym_await,
    ACTIONS(1514), 1,
      sym_identifier,
    ACTIONS(1518), 1,
      anon_sym_type,
    STATE(1009), 1,
      sym_string,
    STATE(1190), 1,
      sym_primary_expression,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1941), 1,
      sym_expression,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    STATE(1294), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1516), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [42261] = 22,
    ACTIONS(684), 1,
      anon_sym_LPAREN,
    ACTIONS(692), 1,
      anon_sym_LBRACK,
    ACTIONS(696), 1,
      anon_sym_LBRACE,
    ACTIONS(702), 1,
      sym_string_start,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(1098), 1,
      sym_identifier,
    ACTIONS(1106), 1,
      anon_sym_type,
    ACTIONS(1108), 1,
      anon_sym_await,
    STATE(972), 1,
      sym_primary_expression,
    STATE(977), 1,
      sym_string,
    STATE(1218), 1,
      sym_list_splat_pattern,
    STATE(1771), 1,
      sym_expression,
    STATE(2784), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(698), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(694), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(682), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1104), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1794), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1258), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [42359] = 22,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1078), 1,
      anon_sym_type,
    ACTIONS(1080), 1,
      anon_sym_not,
    ACTIONS(1082), 1,
      anon_sym_lambda,
    ACTIONS(1084), 1,
      anon_sym_await,
    ACTIONS(1272), 1,
      sym_identifier,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(1006), 1,
      sym_primary_expression,
    STATE(1009), 1,
      sym_string,
    STATE(1427), 1,
      sym_list_splat_pattern,
    STATE(1978), 1,
      sym_expression,
    STATE(2734), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(750), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1074), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1734), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [42457] = 22,
    ACTIONS(299), 1,
      anon_sym_type,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(314), 1,
      anon_sym_lambda,
    ACTIONS(322), 1,
      anon_sym_await,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(406), 1,
      sym_identifier,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(416), 1,
      anon_sym_not,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1008), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(2077), 1,
      sym_expression,
    STATE(2677), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(290), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1728), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [42555] = 22,
    ACTIONS(684), 1,
      anon_sym_LPAREN,
    ACTIONS(692), 1,
      anon_sym_LBRACK,
    ACTIONS(696), 1,
      anon_sym_LBRACE,
    ACTIONS(702), 1,
      sym_string_start,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(1098), 1,
      sym_identifier,
    ACTIONS(1106), 1,
      anon_sym_type,
    ACTIONS(1108), 1,
      anon_sym_await,
    STATE(972), 1,
      sym_primary_expression,
    STATE(977), 1,
      sym_string,
    STATE(1218), 1,
      sym_list_splat_pattern,
    STATE(1770), 1,
      sym_expression,
    STATE(2784), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(698), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(694), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(682), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1104), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1794), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1258), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [42653] = 22,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(381), 1,
      sym_identifier,
    ACTIONS(393), 1,
      anon_sym_type,
    ACTIONS(404), 1,
      anon_sym_await,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(1318), 1,
      anon_sym_STAR,
    STATE(968), 1,
      sym_string,
    STATE(969), 1,
      sym_primary_expression,
    STATE(1125), 1,
      sym_list_splat_pattern,
    STATE(1690), 1,
      sym_expression,
    STATE(2795), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(389), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1685), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1077), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [42751] = 23,
    ACTIONS(684), 1,
      anon_sym_LPAREN,
    ACTIONS(692), 1,
      anon_sym_LBRACK,
    ACTIONS(696), 1,
      anon_sym_LBRACE,
    ACTIONS(702), 1,
      sym_string_start,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(1486), 1,
      anon_sym_await,
    ACTIONS(1520), 1,
      sym_identifier,
    ACTIONS(1524), 1,
      anon_sym_type,
    STATE(972), 1,
      sym_primary_expression,
    STATE(977), 1,
      sym_string,
    STATE(1218), 1,
      sym_list_splat_pattern,
    STATE(2001), 1,
      sym_expression,
    STATE(2784), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(698), 2,
      sym_ellipsis,
      sym_float,
    STATE(1506), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(694), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(682), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1522), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1794), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1258), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [42851] = 22,
    ACTIONS(728), 1,
      anon_sym_LPAREN,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(1114), 1,
      sym_identifier,
    ACTIONS(1120), 1,
      anon_sym_type,
    ACTIONS(1122), 1,
      anon_sym_await,
    ACTIONS(1240), 1,
      anon_sym_STAR,
    STATE(1031), 1,
      sym_primary_expression,
    STATE(1034), 1,
      sym_string,
    STATE(1401), 1,
      sym_list_splat_pattern,
    STATE(1851), 1,
      sym_expression,
    STATE(2743), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(726), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1118), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1826), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1303), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [42949] = 22,
    ACTIONS(728), 1,
      anon_sym_LPAREN,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(1114), 1,
      sym_identifier,
    ACTIONS(1120), 1,
      anon_sym_type,
    ACTIONS(1122), 1,
      anon_sym_await,
    ACTIONS(1240), 1,
      anon_sym_STAR,
    STATE(1031), 1,
      sym_primary_expression,
    STATE(1034), 1,
      sym_string,
    STATE(1401), 1,
      sym_list_splat_pattern,
    STATE(1850), 1,
      sym_expression,
    STATE(2743), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(726), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1118), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1826), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1303), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [43047] = 22,
    ACTIONS(728), 1,
      anon_sym_LPAREN,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(1114), 1,
      sym_identifier,
    ACTIONS(1120), 1,
      anon_sym_type,
    ACTIONS(1122), 1,
      anon_sym_await,
    ACTIONS(1240), 1,
      anon_sym_STAR,
    STATE(1031), 1,
      sym_primary_expression,
    STATE(1034), 1,
      sym_string,
    STATE(1401), 1,
      sym_list_splat_pattern,
    STATE(1844), 1,
      sym_expression,
    STATE(2743), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(726), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1118), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1826), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1303), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [43145] = 22,
    ACTIONS(728), 1,
      anon_sym_LPAREN,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(830), 1,
      anon_sym_not,
    ACTIONS(832), 1,
      anon_sym_lambda,
    ACTIONS(1114), 1,
      sym_identifier,
    ACTIONS(1120), 1,
      anon_sym_type,
    ACTIONS(1122), 1,
      anon_sym_await,
    ACTIONS(1240), 1,
      anon_sym_STAR,
    STATE(1031), 1,
      sym_primary_expression,
    STATE(1034), 1,
      sym_string,
    STATE(1401), 1,
      sym_list_splat_pattern,
    STATE(1837), 1,
      sym_expression,
    STATE(2743), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(726), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1118), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1826), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1303), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [43243] = 22,
    ACTIONS(684), 1,
      anon_sym_LPAREN,
    ACTIONS(692), 1,
      anon_sym_LBRACK,
    ACTIONS(696), 1,
      anon_sym_LBRACE,
    ACTIONS(702), 1,
      sym_string_start,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(984), 1,
      anon_sym_not,
    ACTIONS(986), 1,
      anon_sym_lambda,
    ACTIONS(1098), 1,
      sym_identifier,
    ACTIONS(1106), 1,
      anon_sym_type,
    ACTIONS(1108), 1,
      anon_sym_await,
    STATE(972), 1,
      sym_primary_expression,
    STATE(977), 1,
      sym_string,
    STATE(1218), 1,
      sym_list_splat_pattern,
    STATE(1767), 1,
      sym_expression,
    STATE(2784), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(698), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(694), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(682), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1104), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1794), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1258), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [43341] = 10,
    ACTIONS(1528), 1,
      anon_sym_COMMA,
    ACTIONS(1533), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1535), 1,
      anon_sym_COLON,
    ACTIONS(1538), 1,
      anon_sym_EQ,
    ACTIONS(1540), 1,
      anon_sym_LBRACK,
    STATE(2109), 1,
      sym_type_parameter,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1542), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1531), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1526), 16,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [43414] = 5,
    ACTIONS(1548), 1,
      anon_sym_except_STAR,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(602), 2,
      sym_except_group_clause,
      aux_sym_try_statement_repeat2,
    ACTIONS(1546), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1544), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [43476] = 7,
    ACTIONS(1528), 1,
      anon_sym_COMMA,
    ACTIONS(1533), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1538), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(1542), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1531), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1526), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [43542] = 8,
    ACTIONS(1464), 1,
      anon_sym_else,
    ACTIONS(1555), 1,
      anon_sym_elif,
    STATE(629), 1,
      aux_sym_if_statement_repeat1,
    STATE(699), 1,
      sym_elif_clause,
    STATE(784), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1553), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1551), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [43610] = 8,
    ACTIONS(1464), 1,
      anon_sym_else,
    ACTIONS(1555), 1,
      anon_sym_elif,
    STATE(609), 1,
      aux_sym_if_statement_repeat1,
    STATE(699), 1,
      sym_elif_clause,
    STATE(785), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1559), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1557), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [43678] = 8,
    ACTIONS(1464), 1,
      anon_sym_else,
    ACTIONS(1555), 1,
      anon_sym_elif,
    STATE(604), 1,
      aux_sym_if_statement_repeat1,
    STATE(699), 1,
      sym_elif_clause,
    STATE(754), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1563), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1561), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [43746] = 8,
    ACTIONS(1496), 1,
      anon_sym_else,
    ACTIONS(1565), 1,
      anon_sym_elif,
    STATE(621), 1,
      aux_sym_if_statement_repeat1,
    STATE(705), 1,
      sym_elif_clause,
    STATE(787), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1553), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1551), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [43814] = 8,
    ACTIONS(1496), 1,
      anon_sym_else,
    ACTIONS(1565), 1,
      anon_sym_elif,
    STATE(610), 1,
      aux_sym_if_statement_repeat1,
    STATE(705), 1,
      sym_elif_clause,
    STATE(792), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1559), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1557), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [43882] = 8,
    ACTIONS(1464), 1,
      anon_sym_else,
    ACTIONS(1555), 1,
      anon_sym_elif,
    STATE(629), 1,
      aux_sym_if_statement_repeat1,
    STATE(699), 1,
      sym_elif_clause,
    STATE(826), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1569), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1567), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [43950] = 8,
    ACTIONS(1496), 1,
      anon_sym_else,
    ACTIONS(1565), 1,
      anon_sym_elif,
    STATE(621), 1,
      aux_sym_if_statement_repeat1,
    STATE(705), 1,
      sym_elif_clause,
    STATE(791), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1569), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1567), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [44018] = 5,
    ACTIONS(1575), 1,
      anon_sym_except,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(611), 2,
      sym_except_clause,
      aux_sym_try_statement_repeat1,
    ACTIONS(1573), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1571), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [44080] = 7,
    ACTIONS(284), 1,
      anon_sym_COMMA,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(294), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(316), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(279), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [44146] = 8,
    ACTIONS(284), 1,
      anon_sym_COMMA,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(294), 1,
      anon_sym_EQ,
    ACTIONS(326), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(316), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(279), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [44214] = 8,
    ACTIONS(1496), 1,
      anon_sym_else,
    ACTIONS(1565), 1,
      anon_sym_elif,
    STATE(607), 1,
      aux_sym_if_statement_repeat1,
    STATE(705), 1,
      sym_elif_clause,
    STATE(828), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1563), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1561), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [44282] = 7,
    ACTIONS(284), 1,
      anon_sym_COMMA,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(294), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(316), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(279), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [44348] = 5,
    ACTIONS(1578), 1,
      anon_sym_except,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(616), 2,
      sym_except_clause,
      aux_sym_try_statement_repeat1,
    ACTIONS(1573), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1571), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [44410] = 5,
    ACTIONS(1581), 1,
      anon_sym_except_STAR,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(617), 2,
      sym_except_group_clause,
      aux_sym_try_statement_repeat2,
    ACTIONS(1546), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1544), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [44472] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1586), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1584), 32,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [44529] = 6,
    ACTIONS(1528), 1,
      anon_sym_COMMA,
    ACTIONS(1538), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1542), 14,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1531), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1526), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [44592] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1590), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(1596), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1593), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1588), 29,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [44653] = 6,
    ACTIONS(1602), 1,
      anon_sym_elif,
    STATE(621), 1,
      aux_sym_if_statement_repeat1,
    STATE(705), 1,
      sym_elif_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1598), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1600), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [44716] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(671), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(679), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(668), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(666), 29,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [44777] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(671), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(679), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(668), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(666), 29,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [44838] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1607), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1605), 32,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [44895] = 7,
    ACTIONS(1611), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1590), 2,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(1609), 2,
      anon_sym_DOT,
      anon_sym_COLON,
    ACTIONS(1596), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1593), 12,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1588), 28,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [44960] = 6,
    ACTIONS(1538), 1,
      anon_sym_EQ,
    ACTIONS(1615), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1542), 14,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1618), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1613), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [45023] = 6,
    ACTIONS(1622), 1,
      anon_sym_COMMA,
    ACTIONS(1629), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1627), 14,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1625), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1620), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [45086] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1633), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1631), 32,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [45143] = 6,
    ACTIONS(1635), 1,
      anon_sym_elif,
    STATE(629), 1,
      aux_sym_if_statement_repeat1,
    STATE(699), 1,
      sym_elif_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1598), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1600), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [45206] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1586), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1584), 32,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [45263] = 6,
    ACTIONS(1629), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1622), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1627), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1625), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1620), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [45326] = 6,
    ACTIONS(1645), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1640), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1647), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1643), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1638), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [45389] = 6,
    ACTIONS(1538), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1528), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1542), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1531), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1526), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [45452] = 6,
    ACTIONS(1538), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1615), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1542), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1618), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1613), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [45515] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1651), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1649), 32,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [45572] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1655), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1653), 32,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [45629] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1651), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1649), 32,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [45686] = 6,
    ACTIONS(1640), 1,
      anon_sym_COMMA,
    ACTIONS(1645), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1647), 14,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1643), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1638), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [45749] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1659), 13,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_except_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1657), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [45805] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1661), 13,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_except_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1663), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [45861] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1665), 13,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_except_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1667), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [45917] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1669), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1671), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [45973] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1669), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1671), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [46029] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1675), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1673), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [46085] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1679), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1677), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [46141] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1681), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1683), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [46197] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1685), 13,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_except_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1687), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [46253] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1691), 13,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_except_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1689), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [46309] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1695), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1693), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [46365] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1691), 13,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_except_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1689), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [46421] = 21,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(1697), 1,
      sym_identifier,
    ACTIONS(1699), 1,
      anon_sym_LPAREN,
    ACTIONS(1701), 1,
      anon_sym_STAR,
    ACTIONS(1705), 1,
      anon_sym_type,
    ACTIONS(1707), 1,
      anon_sym_LBRACK,
    ACTIONS(1709), 1,
      anon_sym_await,
    STATE(1007), 1,
      sym_string,
    STATE(1590), 1,
      sym_list_splat_pattern,
    STATE(1626), 1,
      sym_primary_expression,
    STATE(2083), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1587), 2,
      sym_attribute,
      sym_subscript,
    STATE(2122), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(970), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
    ACTIONS(1703), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1282), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [46513] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1669), 13,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_except_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1671), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [46569] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1679), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1677), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [46625] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1713), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1711), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [46681] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1685), 13,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_except_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1687), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [46737] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1675), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1673), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [46793] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1717), 13,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_except_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1715), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [46849] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1721), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1719), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [46905] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1665), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1667), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [46961] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1681), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1683), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [47017] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1665), 13,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_except_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1667), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [47073] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1665), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1667), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [47129] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1669), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1671), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [47185] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1713), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1711), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [47241] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1695), 13,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_except_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1693), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [47297] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1659), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1657), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [47353] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1669), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1671), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [47409] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1695), 13,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_except_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1693), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [47465] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1661), 13,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_except_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1663), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [47521] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1713), 13,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_except_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1711), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [47577] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1725), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1723), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [47633] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1695), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1693), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [47689] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1695), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1693), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [47745] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1659), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1657), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [47801] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1713), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1711), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [47857] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1659), 13,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_except_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1657), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [47913] = 21,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(1697), 1,
      sym_identifier,
    ACTIONS(1699), 1,
      anon_sym_LPAREN,
    ACTIONS(1701), 1,
      anon_sym_STAR,
    ACTIONS(1705), 1,
      anon_sym_type,
    ACTIONS(1707), 1,
      anon_sym_LBRACK,
    ACTIONS(1709), 1,
      anon_sym_await,
    STATE(1007), 1,
      sym_string,
    STATE(1590), 1,
      sym_list_splat_pattern,
    STATE(1626), 1,
      sym_primary_expression,
    STATE(2083), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1587), 2,
      sym_attribute,
      sym_subscript,
    STATE(2122), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(956), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
    ACTIONS(1703), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1282), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [48005] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1713), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1711), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [48061] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1729), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1727), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [48117] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1721), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1719), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [48173] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1659), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1657), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [48229] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1695), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1693), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [48285] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1725), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1723), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [48341] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1713), 13,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_except_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1711), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [48397] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1717), 13,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_except_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1715), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [48453] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1729), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1727), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [48509] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1665), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1667), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [48565] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1669), 13,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_except_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1671), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [48621] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1659), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1657), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [48677] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1665), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1667), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [48733] = 5,
    ACTIONS(1464), 1,
      anon_sym_else,
    STATE(816), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1733), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1731), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [48792] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1737), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1735), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [48847] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1739), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1741), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [48902] = 5,
    ACTIONS(1500), 1,
      anon_sym_finally,
    STATE(833), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1743), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1745), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [48961] = 5,
    ACTIONS(1496), 1,
      anon_sym_else,
    STATE(759), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1733), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1731), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [49020] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1737), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1735), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [49075] = 5,
    ACTIONS(1496), 1,
      anon_sym_else,
    STATE(795), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1747), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1749), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [49134] = 5,
    ACTIONS(1496), 1,
      anon_sym_else,
    STATE(762), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1751), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1753), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [49193] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1757), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1755), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [49248] = 5,
    ACTIONS(1496), 1,
      anon_sym_else,
    STATE(793), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1759), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1761), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [49307] = 5,
    ACTIONS(1468), 1,
      anon_sym_finally,
    STATE(832), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1765), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1763), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [49366] = 5,
    ACTIONS(1500), 1,
      anon_sym_finally,
    STATE(728), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1765), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1763), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [49425] = 5,
    ACTIONS(1464), 1,
      anon_sym_else,
    STATE(811), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1751), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1753), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [49484] = 5,
    ACTIONS(1496), 1,
      anon_sym_else,
    STATE(831), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1767), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1769), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [49543] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1757), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1755), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [49598] = 5,
    ACTIONS(1464), 1,
      anon_sym_else,
    STATE(790), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1747), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1749), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [49657] = 5,
    ACTIONS(1468), 1,
      anon_sym_finally,
    STATE(805), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1743), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1745), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [49716] = 5,
    ACTIONS(1464), 1,
      anon_sym_else,
    STATE(802), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1767), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1769), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [49775] = 5,
    ACTIONS(1464), 1,
      anon_sym_else,
    STATE(840), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1773), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1771), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [49834] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1739), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1741), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [49889] = 5,
    ACTIONS(1496), 1,
      anon_sym_else,
    STATE(723), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1773), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1771), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [49948] = 5,
    ACTIONS(1464), 1,
      anon_sym_else,
    STATE(771), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1759), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1761), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [50007] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1777), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1775), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [50061] = 22,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(1779), 1,
      sym_identifier,
    ACTIONS(1781), 1,
      anon_sym_LPAREN,
    ACTIONS(1783), 1,
      anon_sym_RPAREN,
    ACTIONS(1785), 1,
      anon_sym_STAR,
    ACTIONS(1789), 1,
      anon_sym_type,
    ACTIONS(1791), 1,
      anon_sym_LBRACK,
    ACTIONS(1793), 1,
      anon_sym_await,
    STATE(1007), 1,
      sym_string,
    STATE(1619), 1,
      sym_primary_expression,
    STATE(1620), 1,
      sym_list_splat_pattern,
    STATE(2275), 1,
      sym_pattern,
    STATE(2760), 1,
      sym__patterns,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1610), 2,
      sym_attribute,
      sym_subscript,
    STATE(2531), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1787), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1282), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [50153] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1795), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1797), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [50207] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1777), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1775), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [50261] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1795), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1797), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [50315] = 22,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(1779), 1,
      sym_identifier,
    ACTIONS(1781), 1,
      anon_sym_LPAREN,
    ACTIONS(1785), 1,
      anon_sym_STAR,
    ACTIONS(1789), 1,
      anon_sym_type,
    ACTIONS(1791), 1,
      anon_sym_LBRACK,
    ACTIONS(1793), 1,
      anon_sym_await,
    ACTIONS(1799), 1,
      anon_sym_RPAREN,
    STATE(1007), 1,
      sym_string,
    STATE(1619), 1,
      sym_primary_expression,
    STATE(1620), 1,
      sym_list_splat_pattern,
    STATE(2275), 1,
      sym_pattern,
    STATE(2751), 1,
      sym__patterns,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1610), 2,
      sym_attribute,
      sym_subscript,
    STATE(2531), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1787), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1282), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [50407] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1801), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1803), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [50460] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1807), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1805), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [50513] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1809), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1811), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [50566] = 21,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    ACTIONS(1813), 1,
      sym_identifier,
    ACTIONS(1815), 1,
      anon_sym_LPAREN,
    ACTIONS(1819), 1,
      anon_sym_type,
    ACTIONS(1821), 1,
      anon_sym_LBRACK,
    ACTIONS(1823), 1,
      anon_sym_await,
    STATE(1007), 1,
      sym_string,
    STATE(1617), 1,
      sym_list_splat_pattern,
    STATE(1627), 1,
      sym_primary_expression,
    STATE(2261), 1,
      sym_pattern,
    STATE(2811), 1,
      sym_pattern_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1625), 2,
      sym_attribute,
      sym_subscript,
    STATE(1663), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1817), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1282), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [50655] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1825), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1827), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [50708] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1831), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1829), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [50761] = 21,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    ACTIONS(1813), 1,
      sym_identifier,
    ACTIONS(1815), 1,
      anon_sym_LPAREN,
    ACTIONS(1819), 1,
      anon_sym_type,
    ACTIONS(1821), 1,
      anon_sym_LBRACK,
    ACTIONS(1823), 1,
      anon_sym_await,
    STATE(1007), 1,
      sym_string,
    STATE(1617), 1,
      sym_list_splat_pattern,
    STATE(1627), 1,
      sym_primary_expression,
    STATE(2283), 1,
      sym_pattern,
    STATE(2747), 1,
      sym_pattern_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1625), 2,
      sym_attribute,
      sym_subscript,
    STATE(1663), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1817), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1282), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [50850] = 21,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    ACTIONS(1813), 1,
      sym_identifier,
    ACTIONS(1815), 1,
      anon_sym_LPAREN,
    ACTIONS(1819), 1,
      anon_sym_type,
    ACTIONS(1821), 1,
      anon_sym_LBRACK,
    ACTIONS(1823), 1,
      anon_sym_await,
    STATE(1007), 1,
      sym_string,
    STATE(1617), 1,
      sym_list_splat_pattern,
    STATE(1627), 1,
      sym_primary_expression,
    STATE(2284), 1,
      sym_pattern,
    STATE(2745), 1,
      sym_pattern_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1625), 2,
      sym_attribute,
      sym_subscript,
    STATE(1663), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1817), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1282), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [50939] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1833), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1835), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [50992] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1837), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1839), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [51045] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1807), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1805), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [51098] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1843), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1841), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [51151] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1845), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1847), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [51204] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1849), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1851), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [51257] = 21,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    ACTIONS(1813), 1,
      sym_identifier,
    ACTIONS(1815), 1,
      anon_sym_LPAREN,
    ACTIONS(1819), 1,
      anon_sym_type,
    ACTIONS(1821), 1,
      anon_sym_LBRACK,
    ACTIONS(1823), 1,
      anon_sym_await,
    STATE(1007), 1,
      sym_string,
    STATE(1617), 1,
      sym_list_splat_pattern,
    STATE(1627), 1,
      sym_primary_expression,
    STATE(2353), 1,
      sym_pattern,
    STATE(2687), 1,
      sym_pattern_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1625), 2,
      sym_attribute,
      sym_subscript,
    STATE(1663), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1817), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1282), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [51346] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1853), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1855), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [51399] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1857), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1859), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [51452] = 21,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(1861), 1,
      sym_identifier,
    ACTIONS(1863), 1,
      anon_sym_LPAREN,
    ACTIONS(1865), 1,
      anon_sym_STAR,
    ACTIONS(1869), 1,
      anon_sym_type,
    ACTIONS(1871), 1,
      anon_sym_LBRACK,
    ACTIONS(1873), 1,
      anon_sym_RBRACK,
    ACTIONS(1875), 1,
      anon_sym_await,
    STATE(1007), 1,
      sym_string,
    STATE(1630), 1,
      sym_list_splat_pattern,
    STATE(1631), 1,
      sym_primary_expression,
    STATE(2524), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1611), 2,
      sym_attribute,
      sym_subscript,
    STATE(2616), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1867), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1282), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [51541] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1877), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1879), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [51594] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1881), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1883), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [51647] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1743), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1745), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [51700] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1502), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1504), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [51753] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1462), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1460), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [51806] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1887), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1885), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [51859] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1891), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1889), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [51912] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1843), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1841), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [51965] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1891), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1889), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [52018] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1887), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1885), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [52071] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1462), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1460), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [52124] = 21,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    ACTIONS(1813), 1,
      sym_identifier,
    ACTIONS(1815), 1,
      anon_sym_LPAREN,
    ACTIONS(1819), 1,
      anon_sym_type,
    ACTIONS(1821), 1,
      anon_sym_LBRACK,
    ACTIONS(1823), 1,
      anon_sym_await,
    ACTIONS(1893), 1,
      anon_sym_in,
    STATE(1007), 1,
      sym_string,
    STATE(1617), 1,
      sym_list_splat_pattern,
    STATE(1627), 1,
      sym_primary_expression,
    STATE(1659), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1625), 2,
      sym_attribute,
      sym_subscript,
    STATE(1663), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1817), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1282), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [52213] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1895), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1897), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [52266] = 21,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    ACTIONS(1813), 1,
      sym_identifier,
    ACTIONS(1815), 1,
      anon_sym_LPAREN,
    ACTIONS(1819), 1,
      anon_sym_type,
    ACTIONS(1821), 1,
      anon_sym_LBRACK,
    ACTIONS(1823), 1,
      anon_sym_await,
    STATE(1007), 1,
      sym_string,
    STATE(1617), 1,
      sym_list_splat_pattern,
    STATE(1627), 1,
      sym_primary_expression,
    STATE(2324), 1,
      sym_pattern,
    STATE(2720), 1,
      sym_pattern_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1625), 2,
      sym_attribute,
      sym_subscript,
    STATE(1663), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1817), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1282), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [52355] = 21,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    ACTIONS(1813), 1,
      sym_identifier,
    ACTIONS(1815), 1,
      anon_sym_LPAREN,
    ACTIONS(1819), 1,
      anon_sym_type,
    ACTIONS(1821), 1,
      anon_sym_LBRACK,
    ACTIONS(1823), 1,
      anon_sym_await,
    STATE(1007), 1,
      sym_string,
    STATE(1617), 1,
      sym_list_splat_pattern,
    STATE(1627), 1,
      sym_primary_expression,
    STATE(2331), 1,
      sym_pattern,
    STATE(2711), 1,
      sym_pattern_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1625), 2,
      sym_attribute,
      sym_subscript,
    STATE(1663), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1817), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1282), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [52444] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1899), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1901), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [52497] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1831), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1829), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [52550] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1905), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1903), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [52603] = 21,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    ACTIONS(1813), 1,
      sym_identifier,
    ACTIONS(1815), 1,
      anon_sym_LPAREN,
    ACTIONS(1819), 1,
      anon_sym_type,
    ACTIONS(1821), 1,
      anon_sym_LBRACK,
    ACTIONS(1823), 1,
      anon_sym_await,
    STATE(1007), 1,
      sym_string,
    STATE(1617), 1,
      sym_list_splat_pattern,
    STATE(1627), 1,
      sym_primary_expression,
    STATE(2419), 1,
      sym_pattern,
    STATE(2629), 1,
      sym_pattern_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1625), 2,
      sym_attribute,
      sym_subscript,
    STATE(1663), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1817), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1282), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [52692] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1907), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1909), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [52745] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1911), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1913), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [52798] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1915), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1917), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [52851] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1919), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1921), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [52904] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1923), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1925), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [52957] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1927), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1929), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [53010] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1931), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1933), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [53063] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1935), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1937), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [53116] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1939), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1941), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [53169] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1853), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1855), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [53222] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1857), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1859), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [53275] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1943), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1945), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [53328] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1877), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1879), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [53381] = 21,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    ACTIONS(1813), 1,
      sym_identifier,
    ACTIONS(1815), 1,
      anon_sym_LPAREN,
    ACTIONS(1819), 1,
      anon_sym_type,
    ACTIONS(1821), 1,
      anon_sym_LBRACK,
    ACTIONS(1823), 1,
      anon_sym_await,
    STATE(1007), 1,
      sym_string,
    STATE(1617), 1,
      sym_list_splat_pattern,
    STATE(1627), 1,
      sym_primary_expression,
    STATE(2500), 1,
      sym_pattern,
    STATE(2772), 1,
      sym_pattern_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1625), 2,
      sym_attribute,
      sym_subscript,
    STATE(1663), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1817), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1282), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [53470] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1881), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1883), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [53523] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1949), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1947), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [53576] = 21,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(1779), 1,
      sym_identifier,
    ACTIONS(1781), 1,
      anon_sym_LPAREN,
    ACTIONS(1785), 1,
      anon_sym_STAR,
    ACTIONS(1789), 1,
      anon_sym_type,
    ACTIONS(1791), 1,
      anon_sym_LBRACK,
    ACTIONS(1793), 1,
      anon_sym_await,
    ACTIONS(1873), 1,
      anon_sym_RPAREN,
    STATE(1007), 1,
      sym_string,
    STATE(1619), 1,
      sym_primary_expression,
    STATE(1620), 1,
      sym_list_splat_pattern,
    STATE(2587), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1610), 2,
      sym_attribute,
      sym_subscript,
    STATE(2531), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1787), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1282), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [53665] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1743), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1745), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [53718] = 21,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    ACTIONS(1813), 1,
      sym_identifier,
    ACTIONS(1815), 1,
      anon_sym_LPAREN,
    ACTIONS(1819), 1,
      anon_sym_type,
    ACTIONS(1821), 1,
      anon_sym_LBRACK,
    ACTIONS(1823), 1,
      anon_sym_await,
    STATE(1007), 1,
      sym_string,
    STATE(1617), 1,
      sym_list_splat_pattern,
    STATE(1627), 1,
      sym_primary_expression,
    STATE(2259), 1,
      sym_pattern,
    STATE(2815), 1,
      sym_pattern_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1625), 2,
      sym_attribute,
      sym_subscript,
    STATE(1663), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1817), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1282), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [53807] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1502), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1504), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [53860] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1895), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1897), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [53913] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1899), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1901), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [53966] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1907), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1909), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [54019] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1911), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1913), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [54072] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1953), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1951), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [54125] = 21,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(1861), 1,
      sym_identifier,
    ACTIONS(1863), 1,
      anon_sym_LPAREN,
    ACTIONS(1865), 1,
      anon_sym_STAR,
    ACTIONS(1869), 1,
      anon_sym_type,
    ACTIONS(1871), 1,
      anon_sym_LBRACK,
    ACTIONS(1875), 1,
      anon_sym_await,
    ACTIONS(1955), 1,
      anon_sym_RBRACK,
    STATE(1007), 1,
      sym_string,
    STATE(1630), 1,
      sym_list_splat_pattern,
    STATE(1631), 1,
      sym_primary_expression,
    STATE(2524), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1611), 2,
      sym_attribute,
      sym_subscript,
    STATE(2616), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1867), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1282), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [54214] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1915), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1917), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [54267] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1959), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1957), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [54320] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1963), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1961), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [54373] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1967), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1965), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [54426] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1971), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1969), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [54479] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1963), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1961), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [54532] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1975), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1973), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [54585] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1979), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1977), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [54638] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1983), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1981), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [54691] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1985), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1987), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [54744] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1967), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1965), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [54797] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1949), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1947), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [54850] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1991), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1989), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [54903] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1983), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1981), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [54956] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1979), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1977), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [55009] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1971), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1969), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [55062] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1995), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1993), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [55115] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1999), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1997), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [55168] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2003), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(2001), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [55221] = 21,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    ACTIONS(1813), 1,
      sym_identifier,
    ACTIONS(1815), 1,
      anon_sym_LPAREN,
    ACTIONS(1819), 1,
      anon_sym_type,
    ACTIONS(1821), 1,
      anon_sym_LBRACK,
    ACTIONS(1823), 1,
      anon_sym_await,
    ACTIONS(2005), 1,
      anon_sym_in,
    STATE(1007), 1,
      sym_string,
    STATE(1617), 1,
      sym_list_splat_pattern,
    STATE(1627), 1,
      sym_primary_expression,
    STATE(1659), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1625), 2,
      sym_attribute,
      sym_subscript,
    STATE(1663), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1817), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1282), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [55310] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2009), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(2007), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [55363] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1959), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1957), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [55416] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2013), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(2011), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [55469] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2017), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(2015), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [55522] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1765), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1763), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [55575] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2021), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(2019), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [55628] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1939), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1941), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [55681] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1935), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1937), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [55734] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1801), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1803), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [55787] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1931), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1933), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [55840] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1927), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1929), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [55893] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1991), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1989), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [55946] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1923), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1925), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [55999] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1975), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1973), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [56052] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1919), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1921), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [56105] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2023), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(2025), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [56158] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1953), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1951), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [56211] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2027), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(2029), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [56264] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2027), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(2029), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [56317] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2023), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(2025), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [56370] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1995), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1993), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [56423] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1943), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1945), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [56476] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1999), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1997), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [56529] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2021), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(2019), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [56582] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1985), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1987), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [56635] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2003), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(2001), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [56688] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1905), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1903), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [56741] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2033), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(2031), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [56794] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1765), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1763), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [56847] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2009), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(2007), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [56900] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1837), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1839), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [56953] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2017), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(2015), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [57006] = 21,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(1779), 1,
      sym_identifier,
    ACTIONS(1781), 1,
      anon_sym_LPAREN,
    ACTIONS(1785), 1,
      anon_sym_STAR,
    ACTIONS(1789), 1,
      anon_sym_type,
    ACTIONS(1791), 1,
      anon_sym_LBRACK,
    ACTIONS(1793), 1,
      anon_sym_await,
    ACTIONS(1955), 1,
      anon_sym_RPAREN,
    STATE(1007), 1,
      sym_string,
    STATE(1619), 1,
      sym_primary_expression,
    STATE(1620), 1,
      sym_list_splat_pattern,
    STATE(2587), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1610), 2,
      sym_attribute,
      sym_subscript,
    STATE(2531), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1787), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1282), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [57095] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1833), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1835), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [57148] = 21,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    ACTIONS(1813), 1,
      sym_identifier,
    ACTIONS(1815), 1,
      anon_sym_LPAREN,
    ACTIONS(1819), 1,
      anon_sym_type,
    ACTIONS(1821), 1,
      anon_sym_LBRACK,
    ACTIONS(1823), 1,
      anon_sym_await,
    STATE(1007), 1,
      sym_string,
    STATE(1617), 1,
      sym_list_splat_pattern,
    STATE(1627), 1,
      sym_primary_expression,
    STATE(2297), 1,
      sym_pattern,
    STATE(2738), 1,
      sym_pattern_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1625), 2,
      sym_attribute,
      sym_subscript,
    STATE(1663), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1817), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1282), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [57237] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1809), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1811), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [57290] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2013), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(2011), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [57343] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2033), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(2031), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [57396] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1825), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1827), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [57449] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1849), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1851), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [57502] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1845), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1847), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [57555] = 20,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(1697), 1,
      sym_identifier,
    ACTIONS(1699), 1,
      anon_sym_LPAREN,
    ACTIONS(1701), 1,
      anon_sym_STAR,
    ACTIONS(1705), 1,
      anon_sym_type,
    ACTIONS(1707), 1,
      anon_sym_LBRACK,
    ACTIONS(1709), 1,
      anon_sym_await,
    STATE(1007), 1,
      sym_string,
    STATE(1590), 1,
      sym_list_splat_pattern,
    STATE(1626), 1,
      sym_primary_expression,
    STATE(2083), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1587), 2,
      sym_attribute,
      sym_subscript,
    STATE(2122), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1703), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1282), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [57641] = 20,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(1779), 1,
      sym_identifier,
    ACTIONS(1781), 1,
      anon_sym_LPAREN,
    ACTIONS(1785), 1,
      anon_sym_STAR,
    ACTIONS(1789), 1,
      anon_sym_type,
    ACTIONS(1791), 1,
      anon_sym_LBRACK,
    ACTIONS(1793), 1,
      anon_sym_await,
    STATE(1007), 1,
      sym_string,
    STATE(1619), 1,
      sym_primary_expression,
    STATE(1620), 1,
      sym_list_splat_pattern,
    STATE(2587), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1610), 2,
      sym_attribute,
      sym_subscript,
    STATE(2531), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1787), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1282), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [57727] = 20,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(1040), 1,
      sym_identifier,
    ACTIONS(1042), 1,
      anon_sym_LPAREN,
    ACTIONS(1048), 1,
      anon_sym_type,
    ACTIONS(1050), 1,
      anon_sym_LBRACK,
    ACTIONS(1052), 1,
      anon_sym_await,
    ACTIONS(2035), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1504), 1,
      sym_list_splat_pattern,
    STATE(1634), 1,
      sym_primary_expression,
    STATE(1659), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1505), 2,
      sym_attribute,
      sym_subscript,
    STATE(1663), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1046), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1282), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [57813] = 20,
    ACTIONS(17), 1,
      anon_sym_STAR,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(954), 1,
      sym_identifier,
    ACTIONS(958), 1,
      anon_sym_LPAREN,
    ACTIONS(964), 1,
      anon_sym_type,
    ACTIONS(966), 1,
      anon_sym_LBRACK,
    ACTIONS(968), 1,
      anon_sym_await,
    STATE(1007), 1,
      sym_string,
    STATE(1422), 1,
      sym_list_splat_pattern,
    STATE(1618), 1,
      sym_primary_expression,
    STATE(1638), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1419), 2,
      sym_attribute,
      sym_subscript,
    STATE(1615), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(962), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1282), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [57899] = 20,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    ACTIONS(1813), 1,
      sym_identifier,
    ACTIONS(1815), 1,
      anon_sym_LPAREN,
    ACTIONS(1819), 1,
      anon_sym_type,
    ACTIONS(1821), 1,
      anon_sym_LBRACK,
    ACTIONS(1823), 1,
      anon_sym_await,
    STATE(1007), 1,
      sym_string,
    STATE(1617), 1,
      sym_list_splat_pattern,
    STATE(1627), 1,
      sym_primary_expression,
    STATE(1659), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1625), 2,
      sym_attribute,
      sym_subscript,
    STATE(1663), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1817), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1282), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [57985] = 20,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(1861), 1,
      sym_identifier,
    ACTIONS(1863), 1,
      anon_sym_LPAREN,
    ACTIONS(1865), 1,
      anon_sym_STAR,
    ACTIONS(1869), 1,
      anon_sym_type,
    ACTIONS(1871), 1,
      anon_sym_LBRACK,
    ACTIONS(1875), 1,
      anon_sym_await,
    STATE(1007), 1,
      sym_string,
    STATE(1630), 1,
      sym_list_splat_pattern,
    STATE(1631), 1,
      sym_primary_expression,
    STATE(2524), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1611), 2,
      sym_attribute,
      sym_subscript,
    STATE(2616), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1867), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1282), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [58071] = 19,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    ACTIONS(2037), 1,
      sym_identifier,
    ACTIONS(2043), 1,
      anon_sym_type,
    ACTIONS(2045), 1,
      anon_sym_await,
    STATE(1007), 1,
      sym_string,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1619), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(2039), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(1600), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2041), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1282), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [58154] = 19,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    ACTIONS(2047), 1,
      sym_identifier,
    ACTIONS(2051), 1,
      anon_sym_type,
    ACTIONS(2053), 1,
      anon_sym_await,
    STATE(1007), 1,
      sym_string,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1627), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(2039), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    STATE(1636), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2049), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1282), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [58237] = 17,
    ACTIONS(706), 1,
      anon_sym_LPAREN,
    ACTIONS(712), 1,
      anon_sym_type,
    ACTIONS(714), 1,
      anon_sym_LBRACK,
    ACTIONS(718), 1,
      anon_sym_LBRACE,
    ACTIONS(722), 1,
      anon_sym_await,
    ACTIONS(724), 1,
      sym_string_start,
    ACTIONS(1228), 1,
      anon_sym_STAR,
    ACTIONS(2055), 1,
      anon_sym_not,
    STATE(987), 1,
      sym_string,
    STATE(1013), 1,
      sym_primary_expression,
    STATE(1214), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(720), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(716), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(710), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(704), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1235), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [58315] = 17,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(675), 1,
      anon_sym_type,
    ACTIONS(677), 1,
      anon_sym_await,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    ACTIONS(2057), 1,
      anon_sym_not,
    STATE(1007), 1,
      sym_string,
    STATE(1051), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [58393] = 17,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(780), 1,
      anon_sym_type,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(790), 1,
      anon_sym_await,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(1244), 1,
      anon_sym_STAR,
    ACTIONS(2059), 1,
      anon_sym_not,
    STATE(1011), 1,
      sym_string,
    STATE(1115), 1,
      sym_primary_expression,
    STATE(1310), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(778), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(772), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1279), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [58471] = 17,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(758), 1,
      anon_sym_type,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(768), 1,
      anon_sym_await,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    ACTIONS(2061), 1,
      anon_sym_not,
    STATE(1009), 1,
      sym_string,
    STATE(1073), 1,
      sym_primary_expression,
    STATE(1427), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(756), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(750), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [58549] = 17,
    ACTIONS(684), 1,
      anon_sym_LPAREN,
    ACTIONS(690), 1,
      anon_sym_type,
    ACTIONS(692), 1,
      anon_sym_LBRACK,
    ACTIONS(696), 1,
      anon_sym_LBRACE,
    ACTIONS(700), 1,
      anon_sym_await,
    ACTIONS(702), 1,
      sym_string_start,
    ACTIONS(976), 1,
      anon_sym_STAR,
    ACTIONS(2063), 1,
      anon_sym_not,
    STATE(977), 1,
      sym_string,
    STATE(1032), 1,
      sym_primary_expression,
    STATE(1218), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(698), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(694), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(688), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(682), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1258), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [58627] = 17,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(658), 1,
      anon_sym_type,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(664), 1,
      anon_sym_await,
    ACTIONS(1318), 1,
      anon_sym_STAR,
    ACTIONS(2065), 1,
      anon_sym_not,
    STATE(968), 1,
      sym_string,
    STATE(976), 1,
      sym_primary_expression,
    STATE(1125), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(656), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(77), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1077), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [58705] = 17,
    ACTIONS(728), 1,
      anon_sym_LPAREN,
    ACTIONS(734), 1,
      anon_sym_type,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(746), 1,
      anon_sym_await,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(1240), 1,
      anon_sym_STAR,
    ACTIONS(2067), 1,
      anon_sym_not,
    STATE(1034), 1,
      sym_string,
    STATE(1130), 1,
      sym_primary_expression,
    STATE(1401), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(732), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(726), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1303), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [58783] = 17,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(802), 1,
      anon_sym_type,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(812), 1,
      anon_sym_await,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    ACTIONS(2069), 1,
      anon_sym_not,
    STATE(1152), 1,
      sym_string,
    STATE(1211), 1,
      sym_primary_expression,
    STATE(1484), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(800), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(794), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [58861] = 16,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(758), 1,
      anon_sym_type,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(768), 1,
      anon_sym_await,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(1009), 1,
      sym_string,
    STATE(1069), 1,
      sym_primary_expression,
    STATE(1427), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(756), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(750), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [58936] = 16,
    ACTIONS(706), 1,
      anon_sym_LPAREN,
    ACTIONS(712), 1,
      anon_sym_type,
    ACTIONS(714), 1,
      anon_sym_LBRACK,
    ACTIONS(718), 1,
      anon_sym_LBRACE,
    ACTIONS(722), 1,
      anon_sym_await,
    ACTIONS(724), 1,
      sym_string_start,
    ACTIONS(1228), 1,
      anon_sym_STAR,
    STATE(987), 1,
      sym_string,
    STATE(1043), 1,
      sym_primary_expression,
    STATE(1214), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(720), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(716), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(710), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(704), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1235), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [59011] = 16,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(780), 1,
      anon_sym_type,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(790), 1,
      anon_sym_await,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(1244), 1,
      anon_sym_STAR,
    STATE(1011), 1,
      sym_string,
    STATE(1145), 1,
      sym_primary_expression,
    STATE(1310), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(778), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(772), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1279), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [59086] = 16,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(780), 1,
      anon_sym_type,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(790), 1,
      anon_sym_await,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(1244), 1,
      anon_sym_STAR,
    STATE(1011), 1,
      sym_string,
    STATE(1112), 1,
      sym_primary_expression,
    STATE(1310), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(778), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(772), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1279), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [59161] = 16,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(780), 1,
      anon_sym_type,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(790), 1,
      anon_sym_await,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(1244), 1,
      anon_sym_STAR,
    STATE(1011), 1,
      sym_string,
    STATE(1115), 1,
      sym_primary_expression,
    STATE(1310), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(778), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(772), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1279), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [59236] = 18,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    ACTIONS(2071), 1,
      sym_identifier,
    ACTIONS(2075), 1,
      anon_sym_type,
    ACTIONS(2077), 1,
      anon_sym_await,
    STATE(1007), 1,
      sym_string,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1635), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1237), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2073), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1282), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [59315] = 16,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(780), 1,
      anon_sym_type,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(790), 1,
      anon_sym_await,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(1244), 1,
      anon_sym_STAR,
    STATE(1011), 1,
      sym_string,
    STATE(1116), 1,
      sym_primary_expression,
    STATE(1310), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(778), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(772), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1279), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [59390] = 16,
    ACTIONS(706), 1,
      anon_sym_LPAREN,
    ACTIONS(712), 1,
      anon_sym_type,
    ACTIONS(714), 1,
      anon_sym_LBRACK,
    ACTIONS(718), 1,
      anon_sym_LBRACE,
    ACTIONS(722), 1,
      anon_sym_await,
    ACTIONS(724), 1,
      sym_string_start,
    ACTIONS(1228), 1,
      anon_sym_STAR,
    STATE(987), 1,
      sym_string,
    STATE(1029), 1,
      sym_primary_expression,
    STATE(1214), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(720), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(716), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(710), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(704), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1235), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [59465] = 18,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    ACTIONS(2079), 1,
      sym_identifier,
    ACTIONS(2083), 1,
      anon_sym_type,
    ACTIONS(2085), 1,
      anon_sym_await,
    STATE(1007), 1,
      sym_string,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1618), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(620), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2081), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1282), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [59544] = 16,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(780), 1,
      anon_sym_type,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(790), 1,
      anon_sym_await,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(1244), 1,
      anon_sym_STAR,
    STATE(1011), 1,
      sym_string,
    STATE(1085), 1,
      sym_primary_expression,
    STATE(1310), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(778), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(772), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1279), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [59619] = 18,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    ACTIONS(2083), 1,
      anon_sym_type,
    ACTIONS(2085), 1,
      anon_sym_await,
    ACTIONS(2087), 1,
      sym_identifier,
    STATE(1007), 1,
      sym_string,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1618), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(620), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2081), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1282), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [59698] = 16,
    ACTIONS(684), 1,
      anon_sym_LPAREN,
    ACTIONS(690), 1,
      anon_sym_type,
    ACTIONS(692), 1,
      anon_sym_LBRACK,
    ACTIONS(696), 1,
      anon_sym_LBRACE,
    ACTIONS(700), 1,
      anon_sym_await,
    ACTIONS(702), 1,
      sym_string_start,
    ACTIONS(976), 1,
      anon_sym_STAR,
    STATE(977), 1,
      sym_string,
    STATE(1038), 1,
      sym_primary_expression,
    STATE(1218), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(698), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(694), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(688), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(682), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1258), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [59773] = 16,
    ACTIONS(684), 1,
      anon_sym_LPAREN,
    ACTIONS(690), 1,
      anon_sym_type,
    ACTIONS(692), 1,
      anon_sym_LBRACK,
    ACTIONS(696), 1,
      anon_sym_LBRACE,
    ACTIONS(700), 1,
      anon_sym_await,
    ACTIONS(702), 1,
      sym_string_start,
    ACTIONS(976), 1,
      anon_sym_STAR,
    STATE(977), 1,
      sym_string,
    STATE(1025), 1,
      sym_primary_expression,
    STATE(1218), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(698), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(694), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(688), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(682), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1258), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [59848] = 16,
    ACTIONS(684), 1,
      anon_sym_LPAREN,
    ACTIONS(690), 1,
      anon_sym_type,
    ACTIONS(692), 1,
      anon_sym_LBRACK,
    ACTIONS(696), 1,
      anon_sym_LBRACE,
    ACTIONS(700), 1,
      anon_sym_await,
    ACTIONS(702), 1,
      sym_string_start,
    ACTIONS(976), 1,
      anon_sym_STAR,
    STATE(977), 1,
      sym_string,
    STATE(1027), 1,
      sym_primary_expression,
    STATE(1218), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(698), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(694), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(688), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(682), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1258), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [59923] = 16,
    ACTIONS(684), 1,
      anon_sym_LPAREN,
    ACTIONS(690), 1,
      anon_sym_type,
    ACTIONS(692), 1,
      anon_sym_LBRACK,
    ACTIONS(696), 1,
      anon_sym_LBRACE,
    ACTIONS(700), 1,
      anon_sym_await,
    ACTIONS(702), 1,
      sym_string_start,
    ACTIONS(976), 1,
      anon_sym_STAR,
    STATE(977), 1,
      sym_string,
    STATE(1020), 1,
      sym_primary_expression,
    STATE(1218), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(698), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(694), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(688), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(682), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1258), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [59998] = 18,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    ACTIONS(2089), 1,
      sym_identifier,
    ACTIONS(2093), 1,
      anon_sym_type,
    ACTIONS(2095), 1,
      anon_sym_await,
    STATE(1007), 1,
      sym_string,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1631), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1480), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2091), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1282), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [60077] = 16,
    ACTIONS(684), 1,
      anon_sym_LPAREN,
    ACTIONS(690), 1,
      anon_sym_type,
    ACTIONS(692), 1,
      anon_sym_LBRACK,
    ACTIONS(696), 1,
      anon_sym_LBRACE,
    ACTIONS(700), 1,
      anon_sym_await,
    ACTIONS(702), 1,
      sym_string_start,
    ACTIONS(976), 1,
      anon_sym_STAR,
    STATE(977), 1,
      sym_string,
    STATE(1028), 1,
      sym_primary_expression,
    STATE(1218), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(698), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(694), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(688), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(682), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1258), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [60152] = 16,
    ACTIONS(684), 1,
      anon_sym_LPAREN,
    ACTIONS(690), 1,
      anon_sym_type,
    ACTIONS(692), 1,
      anon_sym_LBRACK,
    ACTIONS(696), 1,
      anon_sym_LBRACE,
    ACTIONS(700), 1,
      anon_sym_await,
    ACTIONS(702), 1,
      sym_string_start,
    ACTIONS(976), 1,
      anon_sym_STAR,
    STATE(977), 1,
      sym_string,
    STATE(1030), 1,
      sym_primary_expression,
    STATE(1218), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(698), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(694), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(688), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(682), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1258), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [60227] = 18,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    ACTIONS(2089), 1,
      sym_identifier,
    ACTIONS(2093), 1,
      anon_sym_type,
    ACTIONS(2095), 1,
      anon_sym_await,
    STATE(1007), 1,
      sym_string,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1633), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1480), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2091), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1282), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [60306] = 16,
    ACTIONS(684), 1,
      anon_sym_LPAREN,
    ACTIONS(690), 1,
      anon_sym_type,
    ACTIONS(692), 1,
      anon_sym_LBRACK,
    ACTIONS(696), 1,
      anon_sym_LBRACE,
    ACTIONS(700), 1,
      anon_sym_await,
    ACTIONS(702), 1,
      sym_string_start,
    ACTIONS(976), 1,
      anon_sym_STAR,
    STATE(977), 1,
      sym_string,
    STATE(1032), 1,
      sym_primary_expression,
    STATE(1218), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(698), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(694), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(688), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(682), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1258), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [60381] = 16,
    ACTIONS(684), 1,
      anon_sym_LPAREN,
    ACTIONS(690), 1,
      anon_sym_type,
    ACTIONS(692), 1,
      anon_sym_LBRACK,
    ACTIONS(696), 1,
      anon_sym_LBRACE,
    ACTIONS(700), 1,
      anon_sym_await,
    ACTIONS(702), 1,
      sym_string_start,
    ACTIONS(976), 1,
      anon_sym_STAR,
    STATE(977), 1,
      sym_string,
    STATE(1035), 1,
      sym_primary_expression,
    STATE(1218), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(698), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(694), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(688), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(682), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1258), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [60456] = 16,
    ACTIONS(684), 1,
      anon_sym_LPAREN,
    ACTIONS(690), 1,
      anon_sym_type,
    ACTIONS(692), 1,
      anon_sym_LBRACK,
    ACTIONS(696), 1,
      anon_sym_LBRACE,
    ACTIONS(700), 1,
      anon_sym_await,
    ACTIONS(702), 1,
      sym_string_start,
    ACTIONS(976), 1,
      anon_sym_STAR,
    STATE(977), 1,
      sym_string,
    STATE(1036), 1,
      sym_primary_expression,
    STATE(1218), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(698), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(694), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(688), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(682), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1258), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [60531] = 16,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(758), 1,
      anon_sym_type,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(768), 1,
      anon_sym_await,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(1009), 1,
      sym_string,
    STATE(1124), 1,
      sym_primary_expression,
    STATE(1427), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(756), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(750), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [60606] = 16,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(675), 1,
      anon_sym_type,
    ACTIONS(677), 1,
      anon_sym_await,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1086), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [60681] = 16,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(780), 1,
      anon_sym_type,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(790), 1,
      anon_sym_await,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(1244), 1,
      anon_sym_STAR,
    STATE(1011), 1,
      sym_string,
    STATE(1080), 1,
      sym_primary_expression,
    STATE(1310), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(778), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(772), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1279), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [60756] = 16,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(658), 1,
      anon_sym_type,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(664), 1,
      anon_sym_await,
    ACTIONS(1318), 1,
      anon_sym_STAR,
    STATE(968), 1,
      sym_string,
    STATE(975), 1,
      sym_primary_expression,
    STATE(1125), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(656), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(77), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1077), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [60831] = 16,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(658), 1,
      anon_sym_type,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(664), 1,
      anon_sym_await,
    ACTIONS(1318), 1,
      anon_sym_STAR,
    STATE(968), 1,
      sym_string,
    STATE(982), 1,
      sym_primary_expression,
    STATE(1125), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(656), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(77), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1077), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [60906] = 16,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(658), 1,
      anon_sym_type,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(664), 1,
      anon_sym_await,
    ACTIONS(1318), 1,
      anon_sym_STAR,
    STATE(968), 1,
      sym_string,
    STATE(983), 1,
      sym_primary_expression,
    STATE(1125), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(656), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(77), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1077), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [60981] = 16,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(802), 1,
      anon_sym_type,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(812), 1,
      anon_sym_await,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    STATE(1152), 1,
      sym_string,
    STATE(1226), 1,
      sym_primary_expression,
    STATE(1484), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(800), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(794), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [61056] = 16,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(658), 1,
      anon_sym_type,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(664), 1,
      anon_sym_await,
    ACTIONS(1318), 1,
      anon_sym_STAR,
    STATE(968), 1,
      sym_string,
    STATE(984), 1,
      sym_primary_expression,
    STATE(1125), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(656), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(77), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1077), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [61131] = 16,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(802), 1,
      anon_sym_type,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(812), 1,
      anon_sym_await,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    STATE(1152), 1,
      sym_string,
    STATE(1219), 1,
      sym_primary_expression,
    STATE(1484), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(800), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(794), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [61206] = 16,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(802), 1,
      anon_sym_type,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(812), 1,
      anon_sym_await,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    STATE(1152), 1,
      sym_string,
    STATE(1207), 1,
      sym_primary_expression,
    STATE(1484), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(800), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(794), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [61281] = 16,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(802), 1,
      anon_sym_type,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(812), 1,
      anon_sym_await,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    STATE(1152), 1,
      sym_string,
    STATE(1153), 1,
      sym_primary_expression,
    STATE(1484), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(800), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(794), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [61356] = 16,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(802), 1,
      anon_sym_type,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(812), 1,
      anon_sym_await,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    STATE(1152), 1,
      sym_string,
    STATE(1230), 1,
      sym_primary_expression,
    STATE(1484), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(800), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(794), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [61431] = 16,
    ACTIONS(728), 1,
      anon_sym_LPAREN,
    ACTIONS(734), 1,
      anon_sym_type,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(746), 1,
      anon_sym_await,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(1240), 1,
      anon_sym_STAR,
    STATE(1034), 1,
      sym_string,
    STATE(1132), 1,
      sym_primary_expression,
    STATE(1401), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(732), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(726), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1303), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [61506] = 16,
    ACTIONS(728), 1,
      anon_sym_LPAREN,
    ACTIONS(734), 1,
      anon_sym_type,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(746), 1,
      anon_sym_await,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(1240), 1,
      anon_sym_STAR,
    STATE(1034), 1,
      sym_string,
    STATE(1131), 1,
      sym_primary_expression,
    STATE(1401), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(732), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(726), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1303), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [61581] = 16,
    ACTIONS(728), 1,
      anon_sym_LPAREN,
    ACTIONS(734), 1,
      anon_sym_type,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(746), 1,
      anon_sym_await,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(1240), 1,
      anon_sym_STAR,
    STATE(1034), 1,
      sym_string,
    STATE(1130), 1,
      sym_primary_expression,
    STATE(1401), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(732), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(726), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1303), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [61656] = 16,
    ACTIONS(728), 1,
      anon_sym_LPAREN,
    ACTIONS(734), 1,
      anon_sym_type,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(746), 1,
      anon_sym_await,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(1240), 1,
      anon_sym_STAR,
    STATE(1034), 1,
      sym_string,
    STATE(1120), 1,
      sym_primary_expression,
    STATE(1401), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(732), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(726), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1303), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [61731] = 16,
    ACTIONS(728), 1,
      anon_sym_LPAREN,
    ACTIONS(734), 1,
      anon_sym_type,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(746), 1,
      anon_sym_await,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(1240), 1,
      anon_sym_STAR,
    STATE(1034), 1,
      sym_string,
    STATE(1118), 1,
      sym_primary_expression,
    STATE(1401), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(732), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(726), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1303), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [61806] = 16,
    ACTIONS(728), 1,
      anon_sym_LPAREN,
    ACTIONS(734), 1,
      anon_sym_type,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(746), 1,
      anon_sym_await,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(1240), 1,
      anon_sym_STAR,
    STATE(1034), 1,
      sym_string,
    STATE(1088), 1,
      sym_primary_expression,
    STATE(1401), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(732), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(726), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1303), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [61881] = 16,
    ACTIONS(728), 1,
      anon_sym_LPAREN,
    ACTIONS(734), 1,
      anon_sym_type,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(746), 1,
      anon_sym_await,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(1240), 1,
      anon_sym_STAR,
    STATE(1034), 1,
      sym_string,
    STATE(1081), 1,
      sym_primary_expression,
    STATE(1401), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(732), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(726), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1303), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [61956] = 16,
    ACTIONS(728), 1,
      anon_sym_LPAREN,
    ACTIONS(734), 1,
      anon_sym_type,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(746), 1,
      anon_sym_await,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(1240), 1,
      anon_sym_STAR,
    STATE(1034), 1,
      sym_string,
    STATE(1079), 1,
      sym_primary_expression,
    STATE(1401), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(732), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(726), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1303), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [62031] = 16,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(802), 1,
      anon_sym_type,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(812), 1,
      anon_sym_await,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    STATE(1152), 1,
      sym_string,
    STATE(1213), 1,
      sym_primary_expression,
    STATE(1484), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(800), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(794), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [62106] = 16,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(658), 1,
      anon_sym_type,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(664), 1,
      anon_sym_await,
    ACTIONS(1318), 1,
      anon_sym_STAR,
    STATE(968), 1,
      sym_string,
    STATE(985), 1,
      sym_primary_expression,
    STATE(1125), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(656), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(77), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1077), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [62181] = 18,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    ACTIONS(2097), 1,
      sym_identifier,
    ACTIONS(2101), 1,
      anon_sym_type,
    ACTIONS(2103), 1,
      anon_sym_await,
    STATE(1007), 1,
      sym_string,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1619), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1436), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2099), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1282), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [62260] = 16,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(658), 1,
      anon_sym_type,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(664), 1,
      anon_sym_await,
    ACTIONS(1318), 1,
      anon_sym_STAR,
    STATE(968), 1,
      sym_string,
    STATE(976), 1,
      sym_primary_expression,
    STATE(1125), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(656), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(77), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1077), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [62335] = 16,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(802), 1,
      anon_sym_type,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(812), 1,
      anon_sym_await,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    STATE(1152), 1,
      sym_string,
    STATE(1212), 1,
      sym_primary_expression,
    STATE(1484), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(800), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(794), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [62410] = 18,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    ACTIONS(2071), 1,
      sym_identifier,
    ACTIONS(2075), 1,
      anon_sym_type,
    ACTIONS(2077), 1,
      anon_sym_await,
    STATE(1007), 1,
      sym_string,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1626), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1237), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2073), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1282), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [62489] = 18,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    ACTIONS(2105), 1,
      sym_identifier,
    ACTIONS(2109), 1,
      anon_sym_type,
    ACTIONS(2111), 1,
      anon_sym_await,
    STATE(1007), 1,
      sym_string,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1627), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1629), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2107), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1282), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [62568] = 16,
    ACTIONS(706), 1,
      anon_sym_LPAREN,
    ACTIONS(712), 1,
      anon_sym_type,
    ACTIONS(714), 1,
      anon_sym_LBRACK,
    ACTIONS(718), 1,
      anon_sym_LBRACE,
    ACTIONS(722), 1,
      anon_sym_await,
    ACTIONS(724), 1,
      sym_string_start,
    ACTIONS(1228), 1,
      anon_sym_STAR,
    STATE(987), 1,
      sym_string,
    STATE(1033), 1,
      sym_primary_expression,
    STATE(1214), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(720), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(716), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(710), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(704), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1235), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [62643] = 16,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(802), 1,
      anon_sym_type,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(812), 1,
      anon_sym_await,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    STATE(1152), 1,
      sym_string,
    STATE(1211), 1,
      sym_primary_expression,
    STATE(1484), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(800), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(794), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [62718] = 16,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(780), 1,
      anon_sym_type,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(790), 1,
      anon_sym_await,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(1244), 1,
      anon_sym_STAR,
    STATE(1011), 1,
      sym_string,
    STATE(1104), 1,
      sym_primary_expression,
    STATE(1310), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(778), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(772), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1279), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [62793] = 16,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(802), 1,
      anon_sym_type,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(812), 1,
      anon_sym_await,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    STATE(1152), 1,
      sym_string,
    STATE(1210), 1,
      sym_primary_expression,
    STATE(1484), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(800), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(794), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [62868] = 16,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(675), 1,
      anon_sym_type,
    ACTIONS(677), 1,
      anon_sym_await,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1087), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [62943] = 16,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(658), 1,
      anon_sym_type,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(664), 1,
      anon_sym_await,
    ACTIONS(1318), 1,
      anon_sym_STAR,
    STATE(968), 1,
      sym_string,
    STATE(986), 1,
      sym_primary_expression,
    STATE(1125), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(656), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(77), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1077), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [63018] = 16,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(658), 1,
      anon_sym_type,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(664), 1,
      anon_sym_await,
    ACTIONS(1318), 1,
      anon_sym_STAR,
    STATE(968), 1,
      sym_string,
    STATE(973), 1,
      sym_primary_expression,
    STATE(1125), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(656), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(77), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1077), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [63093] = 16,
    ACTIONS(684), 1,
      anon_sym_LPAREN,
    ACTIONS(690), 1,
      anon_sym_type,
    ACTIONS(692), 1,
      anon_sym_LBRACK,
    ACTIONS(696), 1,
      anon_sym_LBRACE,
    ACTIONS(700), 1,
      anon_sym_await,
    ACTIONS(702), 1,
      sym_string_start,
    ACTIONS(976), 1,
      anon_sym_STAR,
    STATE(977), 1,
      sym_string,
    STATE(1040), 1,
      sym_primary_expression,
    STATE(1218), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(698), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(694), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(688), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(682), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1258), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [63168] = 16,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(758), 1,
      anon_sym_type,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(768), 1,
      anon_sym_await,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(1009), 1,
      sym_string,
    STATE(1056), 1,
      sym_primary_expression,
    STATE(1427), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(756), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(750), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [63243] = 16,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(675), 1,
      anon_sym_type,
    ACTIONS(677), 1,
      anon_sym_await,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1066), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [63318] = 16,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(658), 1,
      anon_sym_type,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(664), 1,
      anon_sym_await,
    ACTIONS(1318), 1,
      anon_sym_STAR,
    STATE(968), 1,
      sym_string,
    STATE(971), 1,
      sym_primary_expression,
    STATE(1125), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(656), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(77), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1077), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [63393] = 16,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(675), 1,
      anon_sym_type,
    ACTIONS(677), 1,
      anon_sym_await,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1059), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [63468] = 18,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    ACTIONS(2095), 1,
      anon_sym_await,
    ACTIONS(2113), 1,
      sym_identifier,
    ACTIONS(2117), 1,
      anon_sym_type,
    STATE(1007), 1,
      sym_string,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1631), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1350), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2115), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1282), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [63547] = 16,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(802), 1,
      anon_sym_type,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(812), 1,
      anon_sym_await,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    STATE(1152), 1,
      sym_string,
    STATE(1197), 1,
      sym_primary_expression,
    STATE(1484), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(800), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(794), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [63622] = 16,
    ACTIONS(796), 1,
      anon_sym_LPAREN,
    ACTIONS(802), 1,
      anon_sym_type,
    ACTIONS(804), 1,
      anon_sym_LBRACK,
    ACTIONS(808), 1,
      anon_sym_LBRACE,
    ACTIONS(812), 1,
      anon_sym_await,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(1288), 1,
      anon_sym_STAR,
    STATE(1152), 1,
      sym_string,
    STATE(1209), 1,
      sym_primary_expression,
    STATE(1484), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(810), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(806), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(800), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(794), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [63697] = 16,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(658), 1,
      anon_sym_type,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(664), 1,
      anon_sym_await,
    ACTIONS(1318), 1,
      anon_sym_STAR,
    STATE(968), 1,
      sym_string,
    STATE(974), 1,
      sym_primary_expression,
    STATE(1125), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(656), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(77), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1077), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [63772] = 16,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(758), 1,
      anon_sym_type,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(768), 1,
      anon_sym_await,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(1009), 1,
      sym_string,
    STATE(1057), 1,
      sym_primary_expression,
    STATE(1427), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(756), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(750), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [63847] = 18,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    ACTIONS(2103), 1,
      anon_sym_await,
    ACTIONS(2119), 1,
      sym_identifier,
    ACTIONS(2123), 1,
      anon_sym_type,
    STATE(1007), 1,
      sym_string,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1619), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1407), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2121), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1282), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [63926] = 16,
    ACTIONS(728), 1,
      anon_sym_LPAREN,
    ACTIONS(734), 1,
      anon_sym_type,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(746), 1,
      anon_sym_await,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(1240), 1,
      anon_sym_STAR,
    STATE(1034), 1,
      sym_string,
    STATE(1141), 1,
      sym_primary_expression,
    STATE(1401), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(732), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(726), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1303), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [64001] = 18,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    ACTIONS(2125), 1,
      sym_identifier,
    ACTIONS(2129), 1,
      anon_sym_type,
    ACTIONS(2131), 1,
      anon_sym_await,
    STATE(1007), 1,
      sym_string,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1627), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1359), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2127), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1282), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [64080] = 16,
    ACTIONS(728), 1,
      anon_sym_LPAREN,
    ACTIONS(734), 1,
      anon_sym_type,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(746), 1,
      anon_sym_await,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(1240), 1,
      anon_sym_STAR,
    STATE(1034), 1,
      sym_string,
    STATE(1142), 1,
      sym_primary_expression,
    STATE(1401), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(732), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(726), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1303), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [64155] = 16,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(675), 1,
      anon_sym_type,
    ACTIONS(677), 1,
      anon_sym_await,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1055), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [64230] = 16,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(780), 1,
      anon_sym_type,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(790), 1,
      anon_sym_await,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(1244), 1,
      anon_sym_STAR,
    STATE(1011), 1,
      sym_string,
    STATE(1105), 1,
      sym_primary_expression,
    STATE(1310), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(778), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(772), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1279), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [64305] = 16,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(780), 1,
      anon_sym_type,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(790), 1,
      anon_sym_await,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(1244), 1,
      anon_sym_STAR,
    STATE(1011), 1,
      sym_string,
    STATE(1110), 1,
      sym_primary_expression,
    STATE(1310), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(778), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(772), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1279), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [64380] = 16,
    ACTIONS(728), 1,
      anon_sym_LPAREN,
    ACTIONS(734), 1,
      anon_sym_type,
    ACTIONS(738), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_LBRACE,
    ACTIONS(746), 1,
      anon_sym_await,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(1240), 1,
      anon_sym_STAR,
    STATE(1034), 1,
      sym_string,
    STATE(1103), 1,
      sym_primary_expression,
    STATE(1401), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(744), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(740), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(732), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(726), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1303), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [64455] = 18,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    ACTIONS(2093), 1,
      anon_sym_type,
    ACTIONS(2095), 1,
      anon_sym_await,
    ACTIONS(2133), 1,
      sym_identifier,
    STATE(1007), 1,
      sym_string,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1633), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1480), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2091), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1282), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [64534] = 16,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(675), 1,
      anon_sym_type,
    ACTIONS(677), 1,
      anon_sym_await,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1082), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [64609] = 16,
    ACTIONS(706), 1,
      anon_sym_LPAREN,
    ACTIONS(712), 1,
      anon_sym_type,
    ACTIONS(714), 1,
      anon_sym_LBRACK,
    ACTIONS(718), 1,
      anon_sym_LBRACE,
    ACTIONS(722), 1,
      anon_sym_await,
    ACTIONS(724), 1,
      sym_string_start,
    ACTIONS(1228), 1,
      anon_sym_STAR,
    STATE(987), 1,
      sym_string,
    STATE(1026), 1,
      sym_primary_expression,
    STATE(1214), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(720), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(716), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(710), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(704), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1235), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [64684] = 18,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    ACTIONS(2135), 1,
      sym_identifier,
    ACTIONS(2139), 1,
      anon_sym_type,
    ACTIONS(2141), 1,
      anon_sym_await,
    STATE(1007), 1,
      sym_string,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1624), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1135), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2137), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1282), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [64763] = 18,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    ACTIONS(2129), 1,
      anon_sym_type,
    ACTIONS(2131), 1,
      anon_sym_await,
    ACTIONS(2143), 1,
      sym_identifier,
    STATE(1007), 1,
      sym_string,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1627), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1359), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2127), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1282), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [64842] = 18,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    ACTIONS(2077), 1,
      anon_sym_await,
    ACTIONS(2145), 1,
      sym_identifier,
    ACTIONS(2149), 1,
      anon_sym_type,
    STATE(1007), 1,
      sym_string,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1626), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1257), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2147), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1282), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [64921] = 18,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    ACTIONS(2151), 1,
      sym_identifier,
    ACTIONS(2155), 1,
      anon_sym_type,
    ACTIONS(2157), 1,
      anon_sym_await,
    STATE(1007), 1,
      sym_string,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1634), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1500), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2153), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1282), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [65000] = 16,
    ACTIONS(706), 1,
      anon_sym_LPAREN,
    ACTIONS(712), 1,
      anon_sym_type,
    ACTIONS(714), 1,
      anon_sym_LBRACK,
    ACTIONS(718), 1,
      anon_sym_LBRACE,
    ACTIONS(722), 1,
      anon_sym_await,
    ACTIONS(724), 1,
      sym_string_start,
    ACTIONS(1228), 1,
      anon_sym_STAR,
    STATE(987), 1,
      sym_string,
    STATE(1002), 1,
      sym_primary_expression,
    STATE(1214), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(720), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(716), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(710), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(704), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1235), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [65075] = 16,
    ACTIONS(706), 1,
      anon_sym_LPAREN,
    ACTIONS(712), 1,
      anon_sym_type,
    ACTIONS(714), 1,
      anon_sym_LBRACK,
    ACTIONS(718), 1,
      anon_sym_LBRACE,
    ACTIONS(722), 1,
      anon_sym_await,
    ACTIONS(724), 1,
      sym_string_start,
    ACTIONS(1228), 1,
      anon_sym_STAR,
    STATE(987), 1,
      sym_string,
    STATE(1016), 1,
      sym_primary_expression,
    STATE(1214), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(720), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(716), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(710), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(704), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1235), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [65150] = 18,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    ACTIONS(2139), 1,
      anon_sym_type,
    ACTIONS(2141), 1,
      anon_sym_await,
    ACTIONS(2159), 1,
      sym_identifier,
    STATE(1007), 1,
      sym_string,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1624), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1135), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2137), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1282), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [65229] = 16,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(758), 1,
      anon_sym_type,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(768), 1,
      anon_sym_await,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(1009), 1,
      sym_string,
    STATE(1075), 1,
      sym_primary_expression,
    STATE(1427), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(756), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(750), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [65304] = 16,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(758), 1,
      anon_sym_type,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(768), 1,
      anon_sym_await,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(1009), 1,
      sym_string,
    STATE(1074), 1,
      sym_primary_expression,
    STATE(1427), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(756), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(750), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [65379] = 16,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(758), 1,
      anon_sym_type,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(768), 1,
      anon_sym_await,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(1009), 1,
      sym_string,
    STATE(1073), 1,
      sym_primary_expression,
    STATE(1427), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(756), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(750), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [65454] = 16,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(758), 1,
      anon_sym_type,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(768), 1,
      anon_sym_await,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(1009), 1,
      sym_string,
    STATE(1072), 1,
      sym_primary_expression,
    STATE(1427), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(756), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(750), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [65529] = 16,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(758), 1,
      anon_sym_type,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(768), 1,
      anon_sym_await,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(1009), 1,
      sym_string,
    STATE(1071), 1,
      sym_primary_expression,
    STATE(1427), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(756), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(750), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [65604] = 16,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(758), 1,
      anon_sym_type,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(768), 1,
      anon_sym_await,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(1009), 1,
      sym_string,
    STATE(1070), 1,
      sym_primary_expression,
    STATE(1427), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(756), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(750), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [65679] = 18,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    ACTIONS(2161), 1,
      sym_identifier,
    ACTIONS(2165), 1,
      anon_sym_type,
    ACTIONS(2167), 1,
      anon_sym_await,
    STATE(1007), 1,
      sym_string,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1619), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1607), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2163), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1282), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [65758] = 16,
    ACTIONS(706), 1,
      anon_sym_LPAREN,
    ACTIONS(712), 1,
      anon_sym_type,
    ACTIONS(714), 1,
      anon_sym_LBRACK,
    ACTIONS(718), 1,
      anon_sym_LBRACE,
    ACTIONS(722), 1,
      anon_sym_await,
    ACTIONS(724), 1,
      sym_string_start,
    ACTIONS(1228), 1,
      anon_sym_STAR,
    STATE(987), 1,
      sym_string,
    STATE(1022), 1,
      sym_primary_expression,
    STATE(1214), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(720), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(716), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(710), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(704), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1235), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [65833] = 16,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(780), 1,
      anon_sym_type,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(790), 1,
      anon_sym_await,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(1244), 1,
      anon_sym_STAR,
    STATE(1011), 1,
      sym_string,
    STATE(1109), 1,
      sym_primary_expression,
    STATE(1310), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(778), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(772), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1279), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [65908] = 16,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(758), 1,
      anon_sym_type,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_LBRACE,
    ACTIONS(768), 1,
      anon_sym_await,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(1312), 1,
      anon_sym_STAR,
    STATE(1009), 1,
      sym_string,
    STATE(1068), 1,
      sym_primary_expression,
    STATE(1427), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(762), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(756), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(750), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1304), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [65983] = 16,
    ACTIONS(684), 1,
      anon_sym_LPAREN,
    ACTIONS(690), 1,
      anon_sym_type,
    ACTIONS(692), 1,
      anon_sym_LBRACK,
    ACTIONS(696), 1,
      anon_sym_LBRACE,
    ACTIONS(700), 1,
      anon_sym_await,
    ACTIONS(702), 1,
      sym_string_start,
    ACTIONS(976), 1,
      anon_sym_STAR,
    STATE(977), 1,
      sym_string,
    STATE(1021), 1,
      sym_primary_expression,
    STATE(1218), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(698), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(694), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(688), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(682), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1258), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [66058] = 16,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(652), 1,
      anon_sym_LPAREN,
    ACTIONS(658), 1,
      anon_sym_type,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(664), 1,
      anon_sym_await,
    ACTIONS(1318), 1,
      anon_sym_STAR,
    STATE(968), 1,
      sym_string,
    STATE(988), 1,
      sym_primary_expression,
    STATE(1125), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(656), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(77), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1077), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [66133] = 16,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(675), 1,
      anon_sym_type,
    ACTIONS(677), 1,
      anon_sym_await,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1048), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [66208] = 16,
    ACTIONS(706), 1,
      anon_sym_LPAREN,
    ACTIONS(712), 1,
      anon_sym_type,
    ACTIONS(714), 1,
      anon_sym_LBRACK,
    ACTIONS(718), 1,
      anon_sym_LBRACE,
    ACTIONS(722), 1,
      anon_sym_await,
    ACTIONS(724), 1,
      sym_string_start,
    ACTIONS(1228), 1,
      anon_sym_STAR,
    STATE(987), 1,
      sym_string,
    STATE(1013), 1,
      sym_primary_expression,
    STATE(1214), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(720), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(716), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(710), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(704), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1235), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [66283] = 18,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    ACTIONS(2101), 1,
      anon_sym_type,
    ACTIONS(2103), 1,
      anon_sym_await,
    ACTIONS(2169), 1,
      sym_identifier,
    STATE(1007), 1,
      sym_string,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1647), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1436), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2099), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1282), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [66362] = 16,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(675), 1,
      anon_sym_type,
    ACTIONS(677), 1,
      anon_sym_await,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1049), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [66437] = 16,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(675), 1,
      anon_sym_type,
    ACTIONS(677), 1,
      anon_sym_await,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1051), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [66512] = 16,
    ACTIONS(706), 1,
      anon_sym_LPAREN,
    ACTIONS(712), 1,
      anon_sym_type,
    ACTIONS(714), 1,
      anon_sym_LBRACK,
    ACTIONS(718), 1,
      anon_sym_LBRACE,
    ACTIONS(722), 1,
      anon_sym_await,
    ACTIONS(724), 1,
      sym_string_start,
    ACTIONS(1228), 1,
      anon_sym_STAR,
    STATE(987), 1,
      sym_string,
    STATE(1042), 1,
      sym_primary_expression,
    STATE(1214), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(720), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(716), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(710), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(704), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1235), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [66587] = 16,
    ACTIONS(774), 1,
      anon_sym_LPAREN,
    ACTIONS(780), 1,
      anon_sym_type,
    ACTIONS(782), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_LBRACE,
    ACTIONS(790), 1,
      anon_sym_await,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(1244), 1,
      anon_sym_STAR,
    STATE(1011), 1,
      sym_string,
    STATE(1117), 1,
      sym_primary_expression,
    STATE(1310), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(788), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(784), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(778), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(772), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1279), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [66662] = 16,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(675), 1,
      anon_sym_type,
    ACTIONS(677), 1,
      anon_sym_await,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1052), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [66737] = 18,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    ACTIONS(2097), 1,
      sym_identifier,
    ACTIONS(2101), 1,
      anon_sym_type,
    ACTIONS(2103), 1,
      anon_sym_await,
    STATE(1007), 1,
      sym_string,
    STATE(1323), 1,
      sym_list_splat_pattern,
    STATE(1647), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    STATE(1436), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(320), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2099), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1282), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [66816] = 16,
    ACTIONS(706), 1,
      anon_sym_LPAREN,
    ACTIONS(712), 1,
      anon_sym_type,
    ACTIONS(714), 1,
      anon_sym_LBRACK,
    ACTIONS(718), 1,
      anon_sym_LBRACE,
    ACTIONS(722), 1,
      anon_sym_await,
    ACTIONS(724), 1,
      sym_string_start,
    ACTIONS(1228), 1,
      anon_sym_STAR,
    STATE(987), 1,
      sym_string,
    STATE(996), 1,
      sym_primary_expression,
    STATE(1214), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(720), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(716), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(710), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(704), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1235), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [66891] = 16,
    ACTIONS(307), 1,
      anon_sym_LBRACE,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(408), 1,
      anon_sym_LPAREN,
    ACTIONS(412), 1,
      anon_sym_LBRACK,
    ACTIONS(675), 1,
      anon_sym_type,
    ACTIONS(677), 1,
      anon_sym_await,
    ACTIONS(1414), 1,
      anon_sym_STAR,
    STATE(1007), 1,
      sym_string,
    STATE(1053), 1,
      sym_primary_expression,
    STATE(1323), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(312), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(673), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(320), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1282), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [66966] = 16,
    ACTIONS(706), 1,
      anon_sym_LPAREN,
    ACTIONS(712), 1,
      anon_sym_type,
    ACTIONS(714), 1,
      anon_sym_LBRACK,
    ACTIONS(718), 1,
      anon_sym_LBRACE,
    ACTIONS(722), 1,
      anon_sym_await,
    ACTIONS(724), 1,
      sym_string_start,
    ACTIONS(1228), 1,
      anon_sym_STAR,
    STATE(987), 1,
      sym_string,
    STATE(1004), 1,
      sym_primary_expression,
    STATE(1214), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(720), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(716), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(710), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(704), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1235), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [67041] = 5,
    ACTIONS(2175), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(967), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2173), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2171), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [67093] = 5,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(970), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1531), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1526), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [67145] = 20,
    ACTIONS(2180), 1,
      anon_sym_DOT,
    ACTIONS(2182), 1,
      anon_sym_LPAREN,
    ACTIONS(2190), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2192), 1,
      anon_sym_EQ,
    ACTIONS(2194), 1,
      anon_sym_LBRACK,
    ACTIONS(2200), 1,
      anon_sym_PIPE,
    ACTIONS(2202), 1,
      anon_sym_not,
    ACTIONS(2204), 1,
      anon_sym_AMP,
    ACTIONS(2206), 1,
      anon_sym_CARET,
    ACTIONS(2210), 1,
      anon_sym_is,
    STATE(1581), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2184), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2186), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2198), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2208), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1148), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2196), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2188), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2178), 9,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
  [67227] = 5,
    ACTIONS(81), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(967), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2214), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2212), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [67279] = 8,
    ACTIONS(2180), 1,
      anon_sym_DOT,
    ACTIONS(2182), 1,
      anon_sym_LPAREN,
    ACTIONS(2190), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2194), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1148), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2218), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2216), 27,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [67336] = 20,
    ACTIONS(2192), 1,
      anon_sym_EQ,
    ACTIONS(2220), 1,
      anon_sym_DOT,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2230), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2232), 1,
      anon_sym_LBRACK,
    ACTIONS(2238), 1,
      anon_sym_PIPE,
    ACTIONS(2240), 1,
      anon_sym_not,
    ACTIONS(2242), 1,
      anon_sym_AMP,
    ACTIONS(2244), 1,
      anon_sym_CARET,
    ACTIONS(2248), 1,
      anon_sym_is,
    STATE(1596), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2224), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2226), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2236), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2246), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1208), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2234), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2228), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2178), 8,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      sym_type_conversion,
  [67417] = 15,
    ACTIONS(2180), 1,
      anon_sym_DOT,
    ACTIONS(2182), 1,
      anon_sym_LPAREN,
    ACTIONS(2190), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2194), 1,
      anon_sym_LBRACK,
    ACTIONS(2200), 1,
      anon_sym_PIPE,
    ACTIONS(2204), 1,
      anon_sym_AMP,
    ACTIONS(2206), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2184), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2186), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2198), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1148), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2196), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2252), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2250), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [67488] = 15,
    ACTIONS(2180), 1,
      anon_sym_DOT,
    ACTIONS(2182), 1,
      anon_sym_LPAREN,
    ACTIONS(2190), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2194), 1,
      anon_sym_LBRACK,
    ACTIONS(2200), 1,
      anon_sym_PIPE,
    ACTIONS(2204), 1,
      anon_sym_AMP,
    ACTIONS(2206), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2184), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2186), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2198), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1148), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2196), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2256), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2254), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [67559] = 12,
    ACTIONS(2180), 1,
      anon_sym_DOT,
    ACTIONS(2182), 1,
      anon_sym_LPAREN,
    ACTIONS(2190), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2194), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2184), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2186), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2198), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1148), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2196), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2218), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2216), 20,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [67624] = 15,
    ACTIONS(2180), 1,
      anon_sym_DOT,
    ACTIONS(2182), 1,
      anon_sym_LPAREN,
    ACTIONS(2190), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2194), 1,
      anon_sym_LBRACK,
    ACTIONS(2200), 1,
      anon_sym_PIPE,
    ACTIONS(2204), 1,
      anon_sym_AMP,
    ACTIONS(2206), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2184), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2186), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2198), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1148), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2196), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2260), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2258), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [67695] = 5,
    ACTIONS(702), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(990), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1531), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1526), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [67746] = 5,
    ACTIONS(2262), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(978), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2173), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2171), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [67797] = 20,
    ACTIONS(2192), 1,
      anon_sym_as,
    ACTIONS(2265), 1,
      anon_sym_DOT,
    ACTIONS(2267), 1,
      anon_sym_LPAREN,
    ACTIONS(2275), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2277), 1,
      anon_sym_LBRACK,
    ACTIONS(2283), 1,
      anon_sym_PIPE,
    ACTIONS(2285), 1,
      anon_sym_not,
    ACTIONS(2287), 1,
      anon_sym_AMP,
    ACTIONS(2289), 1,
      anon_sym_CARET,
    ACTIONS(2293), 1,
      anon_sym_is,
    STATE(1594), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2269), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2271), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2291), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1206), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2279), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2273), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2178), 8,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
  [67878] = 8,
    ACTIONS(2180), 1,
      anon_sym_DOT,
    ACTIONS(2182), 1,
      anon_sym_LPAREN,
    ACTIONS(2190), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2194), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1148), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2297), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2295), 27,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [67935] = 5,
    ACTIONS(724), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(978), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2214), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2212), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [67986] = 13,
    ACTIONS(2180), 1,
      anon_sym_DOT,
    ACTIONS(2182), 1,
      anon_sym_LPAREN,
    ACTIONS(2190), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2194), 1,
      anon_sym_LBRACK,
    ACTIONS(2206), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2184), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2186), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2198), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1148), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2196), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2218), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2216), 19,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68053] = 14,
    ACTIONS(2180), 1,
      anon_sym_DOT,
    ACTIONS(2182), 1,
      anon_sym_LPAREN,
    ACTIONS(2190), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2194), 1,
      anon_sym_LBRACK,
    ACTIONS(2204), 1,
      anon_sym_AMP,
    ACTIONS(2206), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2184), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2186), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2198), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1148), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2196), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2218), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2216), 18,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68122] = 10,
    ACTIONS(2180), 1,
      anon_sym_DOT,
    ACTIONS(2182), 1,
      anon_sym_LPAREN,
    ACTIONS(2190), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2194), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2184), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1148), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2196), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2218), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2216), 24,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68183] = 8,
    ACTIONS(2180), 1,
      anon_sym_DOT,
    ACTIONS(2182), 1,
      anon_sym_LPAREN,
    ACTIONS(2190), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2194), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1148), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2218), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2216), 27,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68240] = 11,
    ACTIONS(2180), 1,
      anon_sym_DOT,
    ACTIONS(2182), 1,
      anon_sym_LPAREN,
    ACTIONS(2190), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2194), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2184), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2198), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1148), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2196), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2218), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2216), 22,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68303] = 5,
    ACTIONS(724), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(981), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1531), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1526), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68354] = 8,
    ACTIONS(2180), 1,
      anon_sym_DOT,
    ACTIONS(2182), 1,
      anon_sym_LPAREN,
    ACTIONS(2190), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2194), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1148), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2301), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2299), 27,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68411] = 5,
    ACTIONS(2303), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(989), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2173), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2171), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [68462] = 5,
    ACTIONS(702), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(989), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2214), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2212), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [68513] = 5,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(992), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2214), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2212), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68563] = 5,
    ACTIONS(2306), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(992), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2173), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2171), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68613] = 5,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(995), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2214), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2212), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68663] = 5,
    ACTIONS(2309), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(994), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2173), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2171), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68713] = 5,
    ACTIONS(2312), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(995), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2173), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2171), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68763] = 8,
    ACTIONS(2265), 1,
      anon_sym_DOT,
    ACTIONS(2267), 1,
      anon_sym_LPAREN,
    ACTIONS(2275), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2277), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1206), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2218), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2216), 26,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68819] = 5,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(994), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2214), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2212), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68869] = 19,
    ACTIONS(2182), 1,
      anon_sym_LPAREN,
    ACTIONS(2190), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2200), 1,
      anon_sym_PIPE,
    ACTIONS(2202), 1,
      anon_sym_not,
    ACTIONS(2204), 1,
      anon_sym_AMP,
    ACTIONS(2206), 1,
      anon_sym_CARET,
    ACTIONS(2210), 1,
      anon_sym_is,
    ACTIONS(2315), 1,
      anon_sym_DOT,
    ACTIONS(2317), 1,
      anon_sym_LBRACK,
    STATE(1581), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2184), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2186), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2198), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2208), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1148), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2196), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2188), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2178), 8,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
  [68947] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2321), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2319), 32,
      sym__newline,
      sym_string_start,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68993] = 4,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 30,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [69041] = 4,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 30,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [69089] = 10,
    ACTIONS(2265), 1,
      anon_sym_DOT,
    ACTIONS(2267), 1,
      anon_sym_LPAREN,
    ACTIONS(2275), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2277), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2269), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1206), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2218), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2279), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2216), 23,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [69149] = 5,
    ACTIONS(2323), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1003), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2173), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2171), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [69199] = 11,
    ACTIONS(2265), 1,
      anon_sym_DOT,
    ACTIONS(2267), 1,
      anon_sym_LPAREN,
    ACTIONS(2275), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2277), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2269), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1206), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2218), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2279), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2216), 21,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [69261] = 4,
    ACTIONS(1533), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1531), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1526), 30,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [69309] = 20,
    ACTIONS(2192), 1,
      anon_sym_EQ,
    ACTIONS(2326), 1,
      anon_sym_DOT,
    ACTIONS(2328), 1,
      anon_sym_LPAREN,
    ACTIONS(2336), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2338), 1,
      anon_sym_LBRACK,
    ACTIONS(2344), 1,
      anon_sym_PIPE,
    ACTIONS(2346), 1,
      anon_sym_not,
    ACTIONS(2348), 1,
      anon_sym_AMP,
    ACTIONS(2350), 1,
      anon_sym_CARET,
    ACTIONS(2354), 1,
      anon_sym_is,
    STATE(1591), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2330), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2332), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2342), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2352), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1346), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2340), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2334), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2178), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
  [69389] = 5,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(993), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1531), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1526), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [69439] = 20,
    ACTIONS(2192), 1,
      anon_sym_EQ,
    ACTIONS(2356), 1,
      anon_sym_DOT,
    ACTIONS(2358), 1,
      anon_sym_LPAREN,
    ACTIONS(2366), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2368), 1,
      anon_sym_LBRACK,
    ACTIONS(2374), 1,
      anon_sym_PIPE,
    ACTIONS(2376), 1,
      anon_sym_not,
    ACTIONS(2378), 1,
      anon_sym_AMP,
    ACTIONS(2380), 1,
      anon_sym_CARET,
    ACTIONS(2384), 1,
      anon_sym_is,
    STATE(1584), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2360), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2362), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2372), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2382), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1315), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2370), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2364), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2178), 7,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_and,
      anon_sym_or,
  [69519] = 5,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(997), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1531), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1526), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [69569] = 20,
    ACTIONS(2192), 1,
      anon_sym_as,
    ACTIONS(2386), 1,
      anon_sym_DOT,
    ACTIONS(2388), 1,
      anon_sym_LPAREN,
    ACTIONS(2396), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2398), 1,
      anon_sym_LBRACK,
    ACTIONS(2404), 1,
      anon_sym_PIPE,
    ACTIONS(2406), 1,
      anon_sym_not,
    ACTIONS(2408), 1,
      anon_sym_AMP,
    ACTIONS(2410), 1,
      anon_sym_CARET,
    ACTIONS(2414), 1,
      anon_sym_is,
    STATE(1608), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2390), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2392), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2402), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2412), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1400), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2400), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2394), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2178), 7,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [69649] = 5,
    ACTIONS(792), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(991), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1531), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1526), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [69699] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1651), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1649), 31,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [69745] = 15,
    ACTIONS(2265), 1,
      anon_sym_DOT,
    ACTIONS(2267), 1,
      anon_sym_LPAREN,
    ACTIONS(2275), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2277), 1,
      anon_sym_LBRACK,
    ACTIONS(2283), 1,
      anon_sym_PIPE,
    ACTIONS(2287), 1,
      anon_sym_AMP,
    ACTIONS(2289), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2269), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2271), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1206), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2260), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2279), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2258), 16,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [69815] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1651), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1649), 31,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [69861] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1586), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1584), 31,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [69907] = 8,
    ACTIONS(2265), 1,
      anon_sym_DOT,
    ACTIONS(2267), 1,
      anon_sym_LPAREN,
    ACTIONS(2275), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2277), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1206), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2218), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2216), 26,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [69963] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1586), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1584), 31,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [70009] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1633), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1631), 31,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [70055] = 8,
    ACTIONS(2265), 1,
      anon_sym_DOT,
    ACTIONS(2267), 1,
      anon_sym_LPAREN,
    ACTIONS(2275), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2277), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1206), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2297), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2295), 26,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [70111] = 15,
    ACTIONS(2220), 1,
      anon_sym_DOT,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2230), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2232), 1,
      anon_sym_LBRACK,
    ACTIONS(2238), 1,
      anon_sym_PIPE,
    ACTIONS(2242), 1,
      anon_sym_AMP,
    ACTIONS(2244), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2224), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2226), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2236), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1208), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2234), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2256), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2254), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [70181] = 15,
    ACTIONS(2220), 1,
      anon_sym_DOT,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2230), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2232), 1,
      anon_sym_LBRACK,
    ACTIONS(2238), 1,
      anon_sym_PIPE,
    ACTIONS(2242), 1,
      anon_sym_AMP,
    ACTIONS(2244), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2224), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2226), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2236), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1208), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2234), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2252), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2250), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [70251] = 8,
    ACTIONS(2265), 1,
      anon_sym_DOT,
    ACTIONS(2267), 1,
      anon_sym_LPAREN,
    ACTIONS(2275), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2277), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1206), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2301), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2299), 26,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [70307] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1655), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1653), 31,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [70353] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2418), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2416), 32,
      sym__newline,
      sym_string_start,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [70399] = 13,
    ACTIONS(2220), 1,
      anon_sym_DOT,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2230), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2232), 1,
      anon_sym_LBRACK,
    ACTIONS(2244), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2224), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2226), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2236), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1208), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2218), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2234), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2216), 18,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [70465] = 14,
    ACTIONS(2265), 1,
      anon_sym_DOT,
    ACTIONS(2267), 1,
      anon_sym_LPAREN,
    ACTIONS(2275), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2277), 1,
      anon_sym_LBRACK,
    ACTIONS(2287), 1,
      anon_sym_AMP,
    ACTIONS(2289), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2269), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2271), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1206), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2218), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2279), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2216), 17,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [70533] = 14,
    ACTIONS(2220), 1,
      anon_sym_DOT,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2230), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2232), 1,
      anon_sym_LBRACK,
    ACTIONS(2242), 1,
      anon_sym_AMP,
    ACTIONS(2244), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2224), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2226), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2236), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1208), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2218), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2234), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2216), 17,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [70601] = 10,
    ACTIONS(2220), 1,
      anon_sym_DOT,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2230), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2232), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2224), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1208), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2218), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2234), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2216), 23,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [70661] = 13,
    ACTIONS(2265), 1,
      anon_sym_DOT,
    ACTIONS(2267), 1,
      anon_sym_LPAREN,
    ACTIONS(2275), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2277), 1,
      anon_sym_LBRACK,
    ACTIONS(2289), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2269), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2271), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1206), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2218), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2279), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2216), 18,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [70727] = 8,
    ACTIONS(2220), 1,
      anon_sym_DOT,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2230), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2232), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1208), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2218), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2216), 26,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [70783] = 20,
    ACTIONS(2192), 1,
      anon_sym_as,
    ACTIONS(2420), 1,
      anon_sym_DOT,
    ACTIONS(2422), 1,
      anon_sym_LPAREN,
    ACTIONS(2430), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2432), 1,
      anon_sym_LBRACK,
    ACTIONS(2438), 1,
      anon_sym_PIPE,
    ACTIONS(2440), 1,
      anon_sym_not,
    ACTIONS(2442), 1,
      anon_sym_AMP,
    ACTIONS(2444), 1,
      anon_sym_CARET,
    ACTIONS(2448), 1,
      anon_sym_is,
    STATE(1601), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2424), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2426), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2436), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2446), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1361), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2434), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2428), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2178), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_and,
      anon_sym_or,
  [70863] = 15,
    ACTIONS(2220), 1,
      anon_sym_DOT,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2230), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2232), 1,
      anon_sym_LBRACK,
    ACTIONS(2238), 1,
      anon_sym_PIPE,
    ACTIONS(2242), 1,
      anon_sym_AMP,
    ACTIONS(2244), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2224), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2226), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2236), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1208), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2234), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2260), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2258), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [70933] = 12,
    ACTIONS(2265), 1,
      anon_sym_DOT,
    ACTIONS(2267), 1,
      anon_sym_LPAREN,
    ACTIONS(2275), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2277), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2269), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2271), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1206), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2218), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2279), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2216), 19,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [70997] = 5,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1039), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1531), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1526), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [71047] = 11,
    ACTIONS(2220), 1,
      anon_sym_DOT,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2230), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2232), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2224), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2236), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1208), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2218), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2234), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2216), 21,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [71109] = 8,
    ACTIONS(2220), 1,
      anon_sym_DOT,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2230), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2232), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1208), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2218), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2216), 26,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [71165] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1607), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1605), 31,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [71211] = 12,
    ACTIONS(2220), 1,
      anon_sym_DOT,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2230), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2232), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2224), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2226), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2236), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1208), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2218), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2234), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2216), 19,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [71275] = 5,
    ACTIONS(748), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1003), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2214), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2212), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [71325] = 8,
    ACTIONS(2220), 1,
      anon_sym_DOT,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2230), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2232), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1208), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2301), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2299), 26,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [71381] = 8,
    ACTIONS(2220), 1,
      anon_sym_DOT,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2230), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2232), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1208), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2297), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2295), 26,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [71437] = 15,
    ACTIONS(2265), 1,
      anon_sym_DOT,
    ACTIONS(2267), 1,
      anon_sym_LPAREN,
    ACTIONS(2275), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2277), 1,
      anon_sym_LBRACK,
    ACTIONS(2283), 1,
      anon_sym_PIPE,
    ACTIONS(2287), 1,
      anon_sym_AMP,
    ACTIONS(2289), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2269), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2271), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1206), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2252), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2279), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2250), 16,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [71507] = 15,
    ACTIONS(2265), 1,
      anon_sym_DOT,
    ACTIONS(2267), 1,
      anon_sym_LPAREN,
    ACTIONS(2275), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2277), 1,
      anon_sym_LBRACK,
    ACTIONS(2283), 1,
      anon_sym_PIPE,
    ACTIONS(2287), 1,
      anon_sym_AMP,
    ACTIONS(2289), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2269), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2271), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2281), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1206), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2256), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2279), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2254), 16,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [71577] = 4,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [71624] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1586), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1584), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [71669] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1607), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1605), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [71714] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2452), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2450), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [71759] = 8,
    ACTIONS(2356), 1,
      anon_sym_DOT,
    ACTIONS(2358), 1,
      anon_sym_LPAREN,
    ACTIONS(2366), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2368), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1315), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2218), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2216), 25,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [71814] = 11,
    ACTIONS(2356), 1,
      anon_sym_DOT,
    ACTIONS(2358), 1,
      anon_sym_LPAREN,
    ACTIONS(2366), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2368), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2360), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2372), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1315), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2218), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2370), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2216), 20,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [71875] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2456), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2454), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [71920] = 15,
    ACTIONS(2356), 1,
      anon_sym_DOT,
    ACTIONS(2358), 1,
      anon_sym_LPAREN,
    ACTIONS(2366), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2368), 1,
      anon_sym_LBRACK,
    ACTIONS(2374), 1,
      anon_sym_PIPE,
    ACTIONS(2378), 1,
      anon_sym_AMP,
    ACTIONS(2380), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2360), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2362), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2372), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1315), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2260), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2370), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2258), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [71989] = 8,
    ACTIONS(2356), 1,
      anon_sym_DOT,
    ACTIONS(2358), 1,
      anon_sym_LPAREN,
    ACTIONS(2366), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2368), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1315), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2218), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2216), 25,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72044] = 10,
    ACTIONS(2356), 1,
      anon_sym_DOT,
    ACTIONS(2358), 1,
      anon_sym_LPAREN,
    ACTIONS(2366), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2368), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2360), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1315), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2218), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2370), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2216), 22,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72103] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2460), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2458), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72148] = 14,
    ACTIONS(2356), 1,
      anon_sym_DOT,
    ACTIONS(2358), 1,
      anon_sym_LPAREN,
    ACTIONS(2366), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2368), 1,
      anon_sym_LBRACK,
    ACTIONS(2378), 1,
      anon_sym_AMP,
    ACTIONS(2380), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2360), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2362), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2372), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1315), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2218), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2370), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2216), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72215] = 15,
    ACTIONS(2326), 1,
      anon_sym_DOT,
    ACTIONS(2328), 1,
      anon_sym_LPAREN,
    ACTIONS(2336), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2338), 1,
      anon_sym_LBRACK,
    ACTIONS(2344), 1,
      anon_sym_PIPE,
    ACTIONS(2348), 1,
      anon_sym_AMP,
    ACTIONS(2350), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2330), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2332), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2342), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1346), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2256), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2340), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2254), 15,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72284] = 15,
    ACTIONS(2326), 1,
      anon_sym_DOT,
    ACTIONS(2328), 1,
      anon_sym_LPAREN,
    ACTIONS(2336), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2338), 1,
      anon_sym_LBRACK,
    ACTIONS(2344), 1,
      anon_sym_PIPE,
    ACTIONS(2348), 1,
      anon_sym_AMP,
    ACTIONS(2350), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2330), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2332), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2342), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1346), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2252), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2340), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2250), 15,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72353] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2464), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2462), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72398] = 13,
    ACTIONS(2356), 1,
      anon_sym_DOT,
    ACTIONS(2358), 1,
      anon_sym_LPAREN,
    ACTIONS(2366), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2368), 1,
      anon_sym_LBRACK,
    ACTIONS(2380), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2360), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2362), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2372), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1315), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2218), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2370), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2216), 17,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72463] = 6,
    ACTIONS(1533), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1596), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1588), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(1593), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1590), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72514] = 6,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(671), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(666), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(668), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(679), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72565] = 6,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(671), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(666), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(668), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(679), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72616] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1625), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1620), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72661] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1643), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1638), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72706] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2321), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2319), 31,
      sym_string_start,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72751] = 12,
    ACTIONS(2356), 1,
      anon_sym_DOT,
    ACTIONS(2358), 1,
      anon_sym_LPAREN,
    ACTIONS(2366), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2368), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2360), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2362), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2372), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1315), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2218), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2370), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2216), 18,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72814] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2468), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2466), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72859] = 12,
    ACTIONS(2326), 1,
      anon_sym_DOT,
    ACTIONS(2328), 1,
      anon_sym_LPAREN,
    ACTIONS(2336), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2338), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2330), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2332), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2342), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1346), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2218), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2340), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2216), 18,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72922] = 13,
    ACTIONS(2326), 1,
      anon_sym_DOT,
    ACTIONS(2328), 1,
      anon_sym_LPAREN,
    ACTIONS(2336), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2338), 1,
      anon_sym_LBRACK,
    ACTIONS(2350), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2330), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2332), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2342), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1346), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2218), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2340), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2216), 17,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72987] = 14,
    ACTIONS(2326), 1,
      anon_sym_DOT,
    ACTIONS(2328), 1,
      anon_sym_LPAREN,
    ACTIONS(2336), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2338), 1,
      anon_sym_LBRACK,
    ACTIONS(2348), 1,
      anon_sym_AMP,
    ACTIONS(2350), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2330), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2332), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2342), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1346), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2218), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2340), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2216), 16,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73054] = 10,
    ACTIONS(2326), 1,
      anon_sym_DOT,
    ACTIONS(2328), 1,
      anon_sym_LPAREN,
    ACTIONS(2336), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2338), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2330), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1346), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2218), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2340), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2216), 22,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73113] = 8,
    ACTIONS(2326), 1,
      anon_sym_DOT,
    ACTIONS(2328), 1,
      anon_sym_LPAREN,
    ACTIONS(2336), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2338), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1346), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2218), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2216), 25,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73168] = 15,
    ACTIONS(2326), 1,
      anon_sym_DOT,
    ACTIONS(2328), 1,
      anon_sym_LPAREN,
    ACTIONS(2336), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2338), 1,
      anon_sym_LBRACK,
    ACTIONS(2344), 1,
      anon_sym_PIPE,
    ACTIONS(2348), 1,
      anon_sym_AMP,
    ACTIONS(2350), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2330), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2332), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2342), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1346), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2260), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2340), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2258), 15,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73237] = 11,
    ACTIONS(2326), 1,
      anon_sym_DOT,
    ACTIONS(2328), 1,
      anon_sym_LPAREN,
    ACTIONS(2336), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2338), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2330), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2342), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1346), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2218), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2340), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2216), 20,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73298] = 8,
    ACTIONS(2326), 1,
      anon_sym_DOT,
    ACTIONS(2328), 1,
      anon_sym_LPAREN,
    ACTIONS(2336), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2338), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1346), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2218), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2216), 25,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73353] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2418), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2416), 31,
      sym_string_start,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [73398] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1531), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1526), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73443] = 8,
    ACTIONS(2356), 1,
      anon_sym_DOT,
    ACTIONS(2358), 1,
      anon_sym_LPAREN,
    ACTIONS(2366), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2368), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1315), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2297), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2295), 25,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73498] = 12,
    ACTIONS(2420), 1,
      anon_sym_DOT,
    ACTIONS(2422), 1,
      anon_sym_LPAREN,
    ACTIONS(2430), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2432), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2424), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2426), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2436), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1361), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2218), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2434), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2216), 18,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73561] = 15,
    ACTIONS(2386), 1,
      anon_sym_DOT,
    ACTIONS(2388), 1,
      anon_sym_LPAREN,
    ACTIONS(2396), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2398), 1,
      anon_sym_LBRACK,
    ACTIONS(2404), 1,
      anon_sym_PIPE,
    ACTIONS(2408), 1,
      anon_sym_AMP,
    ACTIONS(2410), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2390), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2392), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2402), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1400), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2256), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2400), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2254), 15,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73630] = 13,
    ACTIONS(2420), 1,
      anon_sym_DOT,
    ACTIONS(2422), 1,
      anon_sym_LPAREN,
    ACTIONS(2430), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2432), 1,
      anon_sym_LBRACK,
    ACTIONS(2444), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2424), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2426), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2436), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1361), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2218), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2434), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2216), 17,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73695] = 8,
    ACTIONS(2356), 1,
      anon_sym_DOT,
    ACTIONS(2358), 1,
      anon_sym_LPAREN,
    ACTIONS(2366), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2368), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1315), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2301), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2299), 25,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73750] = 19,
    ACTIONS(2470), 1,
      anon_sym_DOT,
    ACTIONS(2472), 1,
      anon_sym_LPAREN,
    ACTIONS(2480), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2482), 1,
      anon_sym_LBRACK,
    ACTIONS(2488), 1,
      anon_sym_PIPE,
    ACTIONS(2490), 1,
      anon_sym_not,
    ACTIONS(2492), 1,
      anon_sym_AMP,
    ACTIONS(2494), 1,
      anon_sym_CARET,
    ACTIONS(2498), 1,
      anon_sym_is,
    STATE(1593), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2474), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2476), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2486), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2496), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1467), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2484), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2478), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2178), 7,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [73827] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1655), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1653), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73872] = 15,
    ACTIONS(2386), 1,
      anon_sym_DOT,
    ACTIONS(2388), 1,
      anon_sym_LPAREN,
    ACTIONS(2396), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2398), 1,
      anon_sym_LBRACK,
    ACTIONS(2404), 1,
      anon_sym_PIPE,
    ACTIONS(2408), 1,
      anon_sym_AMP,
    ACTIONS(2410), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2390), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2392), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2402), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1400), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2252), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2400), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2250), 15,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73941] = 15,
    ACTIONS(2356), 1,
      anon_sym_DOT,
    ACTIONS(2358), 1,
      anon_sym_LPAREN,
    ACTIONS(2366), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2368), 1,
      anon_sym_LBRACK,
    ACTIONS(2374), 1,
      anon_sym_PIPE,
    ACTIONS(2378), 1,
      anon_sym_AMP,
    ACTIONS(2380), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2360), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2362), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2372), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1315), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2252), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2370), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2250), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74010] = 15,
    ACTIONS(2356), 1,
      anon_sym_DOT,
    ACTIONS(2358), 1,
      anon_sym_LPAREN,
    ACTIONS(2366), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2368), 1,
      anon_sym_LBRACK,
    ACTIONS(2374), 1,
      anon_sym_PIPE,
    ACTIONS(2378), 1,
      anon_sym_AMP,
    ACTIONS(2380), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2360), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2362), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2372), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1315), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2256), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2370), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2254), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74079] = 14,
    ACTIONS(2420), 1,
      anon_sym_DOT,
    ACTIONS(2422), 1,
      anon_sym_LPAREN,
    ACTIONS(2430), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2432), 1,
      anon_sym_LBRACK,
    ACTIONS(2442), 1,
      anon_sym_AMP,
    ACTIONS(2444), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2424), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2426), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2436), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1361), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2218), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2434), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2216), 16,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74146] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1633), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1631), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74191] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1586), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1584), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74236] = 4,
    ACTIONS(1533), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1531), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1526), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74283] = 5,
    ACTIONS(1533), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2500), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1531), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1526), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74332] = 4,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74379] = 5,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(736), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74428] = 4,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74475] = 8,
    ACTIONS(2420), 1,
      anon_sym_DOT,
    ACTIONS(2422), 1,
      anon_sym_LPAREN,
    ACTIONS(2430), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2432), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1361), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2297), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2295), 25,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74530] = 5,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(736), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74579] = 4,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [74626] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1651), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1649), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74671] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(668), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(671), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(679), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(666), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74720] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(668), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(671), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(679), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(666), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74769] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1651), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1649), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74814] = 8,
    ACTIONS(2420), 1,
      anon_sym_DOT,
    ACTIONS(2422), 1,
      anon_sym_LPAREN,
    ACTIONS(2430), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2432), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1361), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2301), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2299), 25,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74869] = 12,
    ACTIONS(2386), 1,
      anon_sym_DOT,
    ACTIONS(2388), 1,
      anon_sym_LPAREN,
    ACTIONS(2396), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2398), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2390), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2392), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2402), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1400), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2218), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2400), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2216), 18,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74932] = 13,
    ACTIONS(2386), 1,
      anon_sym_DOT,
    ACTIONS(2388), 1,
      anon_sym_LPAREN,
    ACTIONS(2396), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2398), 1,
      anon_sym_LBRACK,
    ACTIONS(2410), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2390), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2392), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2402), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1400), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2218), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2400), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2216), 17,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74997] = 5,
    ACTIONS(284), 1,
      anon_sym_COMMA,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [75046] = 5,
    ACTIONS(284), 1,
      anon_sym_COMMA,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [75095] = 8,
    ACTIONS(2326), 1,
      anon_sym_DOT,
    ACTIONS(2328), 1,
      anon_sym_LPAREN,
    ACTIONS(2336), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2338), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1346), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2297), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2295), 25,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75150] = 14,
    ACTIONS(2386), 1,
      anon_sym_DOT,
    ACTIONS(2388), 1,
      anon_sym_LPAREN,
    ACTIONS(2396), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2398), 1,
      anon_sym_LBRACK,
    ACTIONS(2408), 1,
      anon_sym_AMP,
    ACTIONS(2410), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2390), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2392), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2402), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1400), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2218), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2400), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2216), 16,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75217] = 10,
    ACTIONS(2386), 1,
      anon_sym_DOT,
    ACTIONS(2388), 1,
      anon_sym_LPAREN,
    ACTIONS(2396), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2398), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2390), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1400), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2218), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2400), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2216), 22,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75276] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2504), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2502), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75321] = 8,
    ACTIONS(2386), 1,
      anon_sym_DOT,
    ACTIONS(2388), 1,
      anon_sym_LPAREN,
    ACTIONS(2396), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2398), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1400), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2218), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2216), 25,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75376] = 6,
    ACTIONS(1533), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2506), 1,
      anon_sym_LBRACK,
    STATE(2002), 1,
      sym_type_parameter,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1531), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1526), 27,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75427] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2418), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2416), 31,
      sym_string_start,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75472] = 15,
    ACTIONS(2386), 1,
      anon_sym_DOT,
    ACTIONS(2388), 1,
      anon_sym_LPAREN,
    ACTIONS(2396), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2398), 1,
      anon_sym_LBRACK,
    ACTIONS(2404), 1,
      anon_sym_PIPE,
    ACTIONS(2408), 1,
      anon_sym_AMP,
    ACTIONS(2410), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2390), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2392), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2402), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1400), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2260), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2400), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2258), 15,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75541] = 11,
    ACTIONS(2386), 1,
      anon_sym_DOT,
    ACTIONS(2388), 1,
      anon_sym_LPAREN,
    ACTIONS(2396), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2398), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2390), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2402), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1400), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2218), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2400), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2216), 20,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75602] = 8,
    ACTIONS(2386), 1,
      anon_sym_DOT,
    ACTIONS(2388), 1,
      anon_sym_LPAREN,
    ACTIONS(2396), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2398), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1400), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2218), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2216), 25,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75657] = 10,
    ACTIONS(2420), 1,
      anon_sym_DOT,
    ACTIONS(2422), 1,
      anon_sym_LPAREN,
    ACTIONS(2430), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2432), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2424), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1361), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2218), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2434), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2216), 22,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75716] = 4,
    ACTIONS(1533), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1531), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1526), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [75763] = 8,
    ACTIONS(2420), 1,
      anon_sym_DOT,
    ACTIONS(2422), 1,
      anon_sym_LPAREN,
    ACTIONS(2430), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2432), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1361), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2218), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2216), 25,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75818] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2510), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2508), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75863] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2514), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2512), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75908] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2518), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2516), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75953] = 8,
    ACTIONS(2326), 1,
      anon_sym_DOT,
    ACTIONS(2328), 1,
      anon_sym_LPAREN,
    ACTIONS(2336), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2338), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1346), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2301), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2299), 25,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76008] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1618), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1613), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76053] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76098] = 5,
    ACTIONS(1528), 1,
      anon_sym_COMMA,
    ACTIONS(1533), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1531), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1526), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [76147] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2522), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2520), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76192] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2321), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2319), 31,
      sym_string_start,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [76237] = 15,
    ACTIONS(2420), 1,
      anon_sym_DOT,
    ACTIONS(2422), 1,
      anon_sym_LPAREN,
    ACTIONS(2430), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2432), 1,
      anon_sym_LBRACK,
    ACTIONS(2438), 1,
      anon_sym_PIPE,
    ACTIONS(2442), 1,
      anon_sym_AMP,
    ACTIONS(2444), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2424), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2426), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2436), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1361), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2260), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2434), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2258), 15,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76306] = 11,
    ACTIONS(2420), 1,
      anon_sym_DOT,
    ACTIONS(2422), 1,
      anon_sym_LPAREN,
    ACTIONS(2430), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2432), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2424), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2436), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1361), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2218), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2434), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2216), 20,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76367] = 8,
    ACTIONS(2420), 1,
      anon_sym_DOT,
    ACTIONS(2422), 1,
      anon_sym_LPAREN,
    ACTIONS(2430), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2432), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1361), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2218), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2216), 25,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76422] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2526), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2524), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76467] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2530), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2528), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76512] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1593), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1596), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1590), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1588), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76561] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2534), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2532), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76606] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2538), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2536), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76651] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2542), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2540), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76696] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2546), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2544), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76741] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2550), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2548), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76786] = 15,
    ACTIONS(2420), 1,
      anon_sym_DOT,
    ACTIONS(2422), 1,
      anon_sym_LPAREN,
    ACTIONS(2430), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2432), 1,
      anon_sym_LBRACK,
    ACTIONS(2438), 1,
      anon_sym_PIPE,
    ACTIONS(2442), 1,
      anon_sym_AMP,
    ACTIONS(2444), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2424), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2426), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2436), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1361), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2256), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2434), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2254), 15,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76855] = 15,
    ACTIONS(2420), 1,
      anon_sym_DOT,
    ACTIONS(2422), 1,
      anon_sym_LPAREN,
    ACTIONS(2430), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2432), 1,
      anon_sym_LBRACK,
    ACTIONS(2438), 1,
      anon_sym_PIPE,
    ACTIONS(2442), 1,
      anon_sym_AMP,
    ACTIONS(2444), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2424), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2426), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2436), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1361), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2252), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2434), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2250), 15,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76924] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2554), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2552), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76969] = 6,
    ACTIONS(1533), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2556), 1,
      anon_sym_LBRACK,
    STATE(1972), 1,
      sym_type_parameter,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1531), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1526), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [77020] = 8,
    ACTIONS(2386), 1,
      anon_sym_DOT,
    ACTIONS(2388), 1,
      anon_sym_LPAREN,
    ACTIONS(2396), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2398), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1400), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2301), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2299), 25,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [77075] = 8,
    ACTIONS(2386), 1,
      anon_sym_DOT,
    ACTIONS(2388), 1,
      anon_sym_LPAREN,
    ACTIONS(2396), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2398), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1400), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2297), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2295), 25,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [77130] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2560), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2558), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [77175] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2564), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2562), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [77220] = 5,
    ACTIONS(2566), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1149), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2173), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2171), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [77269] = 5,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1149), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2214), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2212), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [77318] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [77363] = 5,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1150), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1531), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1526), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [77412] = 14,
    ACTIONS(2470), 1,
      anon_sym_DOT,
    ACTIONS(2472), 1,
      anon_sym_LPAREN,
    ACTIONS(2480), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2482), 1,
      anon_sym_LBRACK,
    ACTIONS(2492), 1,
      anon_sym_AMP,
    ACTIONS(2494), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2218), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2474), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2476), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2486), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1467), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2484), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2216), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [77478] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1607), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1605), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [77522] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2452), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2450), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [77566] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [77610] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2522), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2520), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [77654] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2418), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2416), 30,
      sym_string_start,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [77698] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2468), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2466), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [77742] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2546), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2544), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [77786] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2542), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2540), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [77830] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2534), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2532), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [77874] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1643), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1638), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [77918] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1625), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1620), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [77962] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2530), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2528), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [78006] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2526), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2524), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [78050] = 5,
    ACTIONS(1533), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1528), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1531), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1526), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78098] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78142] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2518), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2516), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [78186] = 4,
    ACTIONS(1622), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1625), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1620), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [78232] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2522), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2520), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78276] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1655), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1653), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78320] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2456), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2454), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [78364] = 4,
    ACTIONS(1533), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1531), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1526), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78410] = 4,
    ACTIONS(1533), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1531), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1526), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78456] = 4,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78502] = 4,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78548] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2460), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2458), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [78592] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2464), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2462), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [78636] = 4,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78682] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2321), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2319), 30,
      sym_string_start,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78726] = 4,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78772] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2560), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2558), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [78816] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2550), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2548), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [78860] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2452), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2450), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78904] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2504), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2502), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [78948] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(668), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(671), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(679), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(666), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [78996] = 5,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(284), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(279), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79044] = 5,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(284), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(279), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79092] = 19,
    ACTIONS(2328), 1,
      anon_sym_LPAREN,
    ACTIONS(2336), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2344), 1,
      anon_sym_PIPE,
    ACTIONS(2346), 1,
      anon_sym_not,
    ACTIONS(2348), 1,
      anon_sym_AMP,
    ACTIONS(2350), 1,
      anon_sym_CARET,
    ACTIONS(2354), 1,
      anon_sym_is,
    ACTIONS(2420), 1,
      anon_sym_DOT,
    ACTIONS(2432), 1,
      anon_sym_LBRACK,
    STATE(1591), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2330), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2332), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2342), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2352), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1346), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2340), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2178), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2334), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [79168] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2510), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2508), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [79212] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2514), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2512), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [79256] = 8,
    ACTIONS(2470), 1,
      anon_sym_DOT,
    ACTIONS(2472), 1,
      anon_sym_LPAREN,
    ACTIONS(2480), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2482), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1467), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2297), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2295), 25,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79310] = 5,
    ACTIONS(1533), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1588), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(1593), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1590), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79358] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2514), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2512), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79402] = 5,
    ACTIONS(1533), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1528), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1531), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1526), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79450] = 8,
    ACTIONS(2470), 1,
      anon_sym_DOT,
    ACTIONS(2472), 1,
      anon_sym_LPAREN,
    ACTIONS(2480), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2482), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1467), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2301), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2299), 25,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79504] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2538), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2536), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [79548] = 4,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79594] = 6,
    ACTIONS(1533), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1540), 1,
      anon_sym_LBRACK,
    STATE(2109), 1,
      sym_type_parameter,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1531), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1526), 26,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79644] = 4,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79690] = 4,
    ACTIONS(1533), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1531), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1526), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79736] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2554), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2552), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [79780] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2321), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2319), 30,
      sym_string_start,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79824] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1651), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1649), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79868] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2564), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2562), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79912] = 13,
    ACTIONS(2470), 1,
      anon_sym_DOT,
    ACTIONS(2472), 1,
      anon_sym_LPAREN,
    ACTIONS(2480), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2482), 1,
      anon_sym_LBRACK,
    ACTIONS(2494), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2218), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2474), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2476), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2486), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1467), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2484), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2216), 17,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79976] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2564), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2562), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [80020] = 8,
    ACTIONS(2470), 1,
      anon_sym_DOT,
    ACTIONS(2472), 1,
      anon_sym_LPAREN,
    ACTIONS(2480), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2482), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1467), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2218), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2216), 25,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80074] = 11,
    ACTIONS(2470), 1,
      anon_sym_DOT,
    ACTIONS(2472), 1,
      anon_sym_LPAREN,
    ACTIONS(2480), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2482), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2218), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2474), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2486), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1467), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2484), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2216), 20,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80134] = 15,
    ACTIONS(2470), 1,
      anon_sym_DOT,
    ACTIONS(2472), 1,
      anon_sym_LPAREN,
    ACTIONS(2480), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2482), 1,
      anon_sym_LBRACK,
    ACTIONS(2488), 1,
      anon_sym_PIPE,
    ACTIONS(2492), 1,
      anon_sym_AMP,
    ACTIONS(2494), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2260), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2474), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2476), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2486), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1467), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2484), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2258), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80202] = 8,
    ACTIONS(2470), 1,
      anon_sym_DOT,
    ACTIONS(2472), 1,
      anon_sym_LPAREN,
    ACTIONS(2480), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2482), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1467), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2218), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2216), 25,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80256] = 10,
    ACTIONS(2470), 1,
      anon_sym_DOT,
    ACTIONS(2472), 1,
      anon_sym_LPAREN,
    ACTIONS(2480), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2482), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2218), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2474), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1467), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2484), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2216), 22,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80314] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1618), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1613), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80358] = 5,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(666), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(668), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(679), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80406] = 5,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(666), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(668), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(679), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80454] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1651), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1649), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80498] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1618), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1613), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [80542] = 12,
    ACTIONS(2470), 1,
      anon_sym_DOT,
    ACTIONS(2472), 1,
      anon_sym_LPAREN,
    ACTIONS(2480), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2482), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2218), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2474), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2476), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2486), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1467), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2484), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2216), 18,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80604] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2468), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2466), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80648] = 19,
    ACTIONS(2222), 1,
      anon_sym_LPAREN,
    ACTIONS(2230), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2238), 1,
      anon_sym_PIPE,
    ACTIONS(2240), 1,
      anon_sym_not,
    ACTIONS(2242), 1,
      anon_sym_AMP,
    ACTIONS(2244), 1,
      anon_sym_CARET,
    ACTIONS(2248), 1,
      anon_sym_is,
    ACTIONS(2265), 1,
      anon_sym_DOT,
    ACTIONS(2277), 1,
      anon_sym_LBRACK,
    STATE(1596), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2224), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2226), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2236), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2246), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1208), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2234), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2178), 6,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2228), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [80724] = 6,
    ACTIONS(1533), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2569), 1,
      anon_sym_LBRACK,
    STATE(2017), 1,
      sym_type_parameter,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1531), 5,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1526), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80774] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2418), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2416), 30,
      sym_string_start,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80818] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [80862] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [80906] = 15,
    ACTIONS(2470), 1,
      anon_sym_DOT,
    ACTIONS(2472), 1,
      anon_sym_LPAREN,
    ACTIONS(2480), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2482), 1,
      anon_sym_LBRACK,
    ACTIONS(2488), 1,
      anon_sym_PIPE,
    ACTIONS(2492), 1,
      anon_sym_AMP,
    ACTIONS(2494), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2252), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2474), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2476), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2486), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1467), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2484), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2250), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80974] = 5,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(666), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(668), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(679), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81022] = 5,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(666), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(668), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(679), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81070] = 5,
    ACTIONS(1533), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1588), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(1593), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1590), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81118] = 15,
    ACTIONS(2470), 1,
      anon_sym_DOT,
    ACTIONS(2472), 1,
      anon_sym_LPAREN,
    ACTIONS(2480), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2482), 1,
      anon_sym_LBRACK,
    ACTIONS(2488), 1,
      anon_sym_PIPE,
    ACTIONS(2492), 1,
      anon_sym_AMP,
    ACTIONS(2494), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2256), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2474), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2476), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2486), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1467), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2484), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2254), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81186] = 4,
    ACTIONS(1533), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1531), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1526), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81232] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2510), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2508), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81276] = 5,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(284), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(279), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81324] = 5,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(284), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(279), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81372] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1531), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1526), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81416] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2504), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2502), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81460] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1593), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1596), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1590), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1588), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [81508] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2418), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2416), 30,
      sym_string_start,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81552] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2321), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2319), 30,
      sym_string_start,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81596] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2554), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2552), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81640] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(668), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(671), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(679), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(666), 16,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81688] = 4,
    ACTIONS(1615), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1618), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1613), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [81734] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1607), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1605), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [81778] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1586), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1584), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81822] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1586), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1584), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81866] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1633), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1631), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81910] = 4,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81956] = 4,
    ACTIONS(1528), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1531), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1526), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [82002] = 4,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82048] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2321), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2319), 30,
      sym_string_start,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82092] = 4,
    ACTIONS(1640), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1643), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1638), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [82138] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2538), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2536), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82182] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(668), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(671), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(679), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(666), 16,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82230] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2518), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2516), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82274] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2418), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2416), 30,
      sym_string_start,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82318] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1588), 3,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(1593), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1590), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82364] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1593), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1596), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1590), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1588), 16,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82412] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1531), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1526), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [82456] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2550), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2548), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82500] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1655), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1653), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [82544] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2560), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2558), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82588] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2464), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2462), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82632] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2460), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2458), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82676] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2456), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2454), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82720] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2526), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2524), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82764] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2530), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2528), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82808] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(668), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(671), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(679), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(666), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [82856] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1643), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1638), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82900] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1625), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1620), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82944] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1633), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1631), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [82988] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1586), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1584), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [83032] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2534), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2532), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83076] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2542), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2540), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83120] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2546), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2544), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83164] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1586), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1584), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [83208] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1651), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1649), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [83252] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1651), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1649), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [83296] = 19,
    ACTIONS(2386), 1,
      anon_sym_DOT,
    ACTIONS(2398), 1,
      anon_sym_LBRACK,
    ACTIONS(2472), 1,
      anon_sym_LPAREN,
    ACTIONS(2480), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2488), 1,
      anon_sym_PIPE,
    ACTIONS(2490), 1,
      anon_sym_not,
    ACTIONS(2492), 1,
      anon_sym_AMP,
    ACTIONS(2494), 1,
      anon_sym_CARET,
    ACTIONS(2498), 1,
      anon_sym_is,
    STATE(1593), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2474), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2476), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2486), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2496), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1467), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2484), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2178), 6,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2478), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [83372] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1531), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1526), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83415] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2550), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2548), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83458] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2510), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2508), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83501] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1531), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1526), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83544] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2518), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2516), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83587] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1640), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1643), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1638), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83632] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(668), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(671), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(679), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(666), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83679] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1622), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1625), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1620), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83724] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2504), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2502), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83767] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2510), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2508), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83810] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2514), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2512), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83853] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83896] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83939] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2522), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2520), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83982] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(668), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(671), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(679), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(666), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84029] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1588), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(1593), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1590), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84074] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1625), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1620), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84117] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2504), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2502), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84160] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1643), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1638), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84203] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2518), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2516), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84246] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1528), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1531), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1526), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84291] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2538), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2536), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84334] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1615), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1618), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1613), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84379] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2554), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2552), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84422] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1531), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1526), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84465] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1531), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1526), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84508] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(277), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(279), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(316), 18,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [84553] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(277), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(279), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(316), 18,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [84598] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(668), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(671), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(679), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(666), 15,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84645] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(668), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(671), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(679), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(666), 15,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84692] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2550), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2548), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84735] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1618), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1613), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84778] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2554), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2552), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84821] = 4,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 5,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84866] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(668), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(671), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(679), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(666), 15,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84913] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(668), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(671), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(679), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(666), 15,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84960] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2564), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2562), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85003] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2538), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2536), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85046] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2452), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2450), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85089] = 4,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 5,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85134] = 7,
    ACTIONS(1611), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1593), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1596), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1609), 5,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(1588), 12,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
    ACTIONS(1590), 12,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [85185] = 4,
    ACTIONS(1533), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1531), 5,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1526), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85230] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1651), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1649), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85273] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1651), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1649), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85316] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1618), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1613), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85359] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2468), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2466), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85402] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2546), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2544), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85445] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2542), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2540), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85488] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2534), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2532), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85531] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85574] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85617] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1586), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1584), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85660] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2530), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2528), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85703] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2526), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2524), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85746] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2522), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2520), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85789] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85832] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85875] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1586), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1584), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85918] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1633), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1631), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85961] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2518), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2516), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86004] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2514), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2512), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86047] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2456), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2454), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86090] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2522), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2520), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86133] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2460), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2458), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86176] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2464), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2462), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86219] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2510), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2508), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86262] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1655), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1653), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86305] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2564), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2562), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86348] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2554), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2552), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86391] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2538), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2536), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86434] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2560), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2558), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86477] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1593), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1596), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1590), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1588), 15,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86524] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2518), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2516), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86567] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2514), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2512), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86610] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2510), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2508), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86653] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2504), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2502), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86696] = 5,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(736), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86743] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2560), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2558), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86786] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2550), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2548), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86829] = 5,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(736), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86876] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1593), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1596), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1590), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1588), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86923] = 5,
    ACTIONS(1533), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2500), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1531), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1526), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86970] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2564), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2562), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87013] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1607), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1605), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87056] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2504), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2502), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87099] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2514), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2512), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87142] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2452), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2450), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87185] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2468), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2466), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87228] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2546), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2544), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87271] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2542), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2540), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87314] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2534), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2532), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87357] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2530), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2528), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87400] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1625), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1620), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87443] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1643), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1638), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87486] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2526), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2524), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87529] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2456), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2454), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87572] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2452), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2450), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87615] = 7,
    ACTIONS(1611), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1593), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1596), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1609), 5,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(1588), 12,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
    ACTIONS(1590), 12,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [87666] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2468), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2466), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87709] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2460), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2458), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87752] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2464), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2462), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87795] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1643), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1638), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87838] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1625), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1620), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87881] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2452), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2450), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87924] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2560), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2558), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87967] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1607), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1605), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88010] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2546), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2544), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88053] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2468), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2466), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88096] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2546), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2544), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88139] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1625), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1620), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88182] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1643), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1638), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88225] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2542), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2540), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88268] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2534), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2532), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88311] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2538), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2536), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88354] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2554), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2552), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88397] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2542), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2540), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88440] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2534), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2532), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88483] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2526), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2524), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88526] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2530), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2528), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88569] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2526), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2524), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88612] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1655), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1653), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88655] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2564), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2562), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88698] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1618), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1613), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88741] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1620), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(1625), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1627), 18,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [88786] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1588), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(1593), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1590), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88831] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2456), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2454), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88874] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1607), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1605), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88917] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2456), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2454), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88960] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1593), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1596), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1590), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1588), 15,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89007] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2460), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2458), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89050] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2464), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2462), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89093] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2460), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2458), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89136] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2464), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2462), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89179] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2530), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2528), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89222] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1633), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1631), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89265] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1615), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1618), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1613), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89310] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1586), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1584), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89353] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1528), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1531), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1526), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89398] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1586), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1584), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89441] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1638), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(1643), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1647), 18,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [89486] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1526), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(1531), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1542), 18,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [89531] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1640), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1643), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1638), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89576] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1655), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1653), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89619] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1613), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(1618), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1542), 18,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [89664] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2560), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2558), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89707] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2550), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2548), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89750] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1633), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1631), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89793] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1586), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1584), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89836] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1618), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1613), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89879] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1586), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1584), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89922] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1651), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1649), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89965] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1651), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1649), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90008] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1651), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1649), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90051] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1651), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1649), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90094] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2321), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2319), 30,
      sym_string_start,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90137] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(668), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(671), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(679), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(666), 15,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90184] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(668), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(671), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(679), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(666), 15,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90231] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1593), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1596), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1590), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1588), 15,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90278] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2418), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2416), 30,
      sym_string_start,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90321] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1622), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1625), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1620), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90366] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90409] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90452] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2522), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2520), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90495] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1655), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1653), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90537] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1607), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1605), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90579] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1633), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1631), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90621] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2550), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2548), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90663] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2560), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2558), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90705] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2464), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2462), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90747] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2460), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2458), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90789] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1586), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1584), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90831] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1586), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1584), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90873] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1651), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1649), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90915] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1651), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1649), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90957] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2456), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2454), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90999] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2526), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2524), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91041] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2530), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2528), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91083] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2534), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2532), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91125] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2542), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2540), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91167] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2546), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2544), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91209] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2468), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2466), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91251] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2452), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2450), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91293] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2504), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2502), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91335] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2510), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2508), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91377] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2514), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2512), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91419] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2518), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2516), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91461] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2538), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2536), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91503] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2554), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2552), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91545] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2564), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2562), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91587] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2522), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2520), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91629] = 4,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(668), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(679), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91673] = 4,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(668), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(679), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91717] = 4,
    ACTIONS(1533), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1593), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1590), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91761] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91803] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(277), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91845] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(668), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(671), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(679), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(666), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91891] = 7,
    ACTIONS(1611), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1593), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1596), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1609), 4,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(1588), 12,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
    ACTIONS(1590), 12,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [91941] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(668), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(671), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(679), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(666), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91987] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1531), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1526), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92029] = 4,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(668), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(679), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92073] = 4,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(668), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(679), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92117] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1593), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1596), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1590), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1588), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92163] = 4,
    ACTIONS(1533), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1593), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1590), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92207] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1625), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1620), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92249] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1643), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1638), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92291] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1618), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1613), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92333] = 6,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1593), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1596), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1609), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
    ACTIONS(1588), 12,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
    ACTIONS(1590), 12,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [92381] = 4,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(668), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(679), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92425] = 4,
    ACTIONS(292), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(668), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(679), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92469] = 4,
    ACTIONS(1533), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1593), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1590), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92513] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(679), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(668), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(666), 16,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [92556] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1655), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1653), 19,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [92597] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(277), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(279), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(316), 16,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [92640] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1607), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1605), 19,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [92681] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1633), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1631), 19,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [92722] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1586), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1584), 19,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [92763] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1586), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1584), 19,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [92804] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1651), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1649), 19,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [92845] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1651), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1649), 19,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [92886] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(679), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(668), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(666), 16,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [92929] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(277), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(279), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(316), 16,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [92972] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1590), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(1593), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1588), 16,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [93015] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1593), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1590), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [93056] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1620), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(1625), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1627), 16,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [93099] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1593), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1590), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [93140] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1613), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(1618), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1542), 16,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [93183] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1526), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(1531), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1542), 16,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [93226] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1593), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1590), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [93267] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1638), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(1643), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1647), 16,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [93310] = 20,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(2571), 1,
      sym_identifier,
    ACTIONS(2573), 1,
      anon_sym_LPAREN,
    ACTIONS(2575), 1,
      anon_sym_STAR,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2579), 1,
      anon_sym_COLON,
    ACTIONS(2581), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2583), 1,
      anon_sym_LBRACK,
    ACTIONS(2585), 1,
      anon_sym_DASH,
    ACTIONS(2589), 1,
      anon_sym_LBRACE,
    ACTIONS(2591), 1,
      sym_integer,
    ACTIONS(2593), 1,
      sym_float,
    STATE(1808), 1,
      sym_string,
    STATE(1976), 1,
      sym_dotted_name,
    STATE(2160), 1,
      sym_case_pattern,
    STATE(2755), 1,
      sym_if_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2210), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2587), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1974), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [93384] = 20,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(2571), 1,
      sym_identifier,
    ACTIONS(2573), 1,
      anon_sym_LPAREN,
    ACTIONS(2575), 1,
      anon_sym_STAR,
    ACTIONS(2577), 1,
      anon_sym_if,
    ACTIONS(2581), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2583), 1,
      anon_sym_LBRACK,
    ACTIONS(2585), 1,
      anon_sym_DASH,
    ACTIONS(2589), 1,
      anon_sym_LBRACE,
    ACTIONS(2591), 1,
      sym_integer,
    ACTIONS(2593), 1,
      sym_float,
    ACTIONS(2595), 1,
      anon_sym_COLON,
    STATE(1808), 1,
      sym_string,
    STATE(1976), 1,
      sym_dotted_name,
    STATE(2160), 1,
      sym_case_pattern,
    STATE(2714), 1,
      sym_if_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2210), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2587), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1974), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [93458] = 18,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(2597), 1,
      sym_identifier,
    ACTIONS(2599), 1,
      anon_sym_LPAREN,
    ACTIONS(2601), 1,
      anon_sym_RPAREN,
    ACTIONS(2603), 1,
      anon_sym_STAR,
    ACTIONS(2605), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2607), 1,
      anon_sym_LBRACK,
    ACTIONS(2609), 1,
      anon_sym_DASH,
    ACTIONS(2613), 1,
      anon_sym_LBRACE,
    ACTIONS(2615), 1,
      sym_integer,
    ACTIONS(2617), 1,
      sym_float,
    STATE(1867), 1,
      sym_string,
    STATE(2037), 1,
      sym_dotted_name,
    STATE(2127), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2472), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2611), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2038), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [93526] = 18,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(2619), 1,
      sym_identifier,
    ACTIONS(2621), 1,
      anon_sym_LPAREN,
    ACTIONS(2623), 1,
      anon_sym_STAR,
    ACTIONS(2625), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2627), 1,
      anon_sym_LBRACK,
    ACTIONS(2629), 1,
      anon_sym_RBRACK,
    ACTIONS(2631), 1,
      anon_sym_DASH,
    ACTIONS(2635), 1,
      anon_sym_LBRACE,
    ACTIONS(2637), 1,
      sym_integer,
    ACTIONS(2639), 1,
      sym_float,
    STATE(1903), 1,
      sym_string,
    STATE(2125), 1,
      sym_dotted_name,
    STATE(2509), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2374), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2633), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2061), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [93594] = 18,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(2619), 1,
      sym_identifier,
    ACTIONS(2621), 1,
      anon_sym_LPAREN,
    ACTIONS(2623), 1,
      anon_sym_STAR,
    ACTIONS(2625), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2627), 1,
      anon_sym_LBRACK,
    ACTIONS(2631), 1,
      anon_sym_DASH,
    ACTIONS(2635), 1,
      anon_sym_LBRACE,
    ACTIONS(2637), 1,
      sym_integer,
    ACTIONS(2639), 1,
      sym_float,
    ACTIONS(2641), 1,
      anon_sym_RBRACK,
    STATE(1903), 1,
      sym_string,
    STATE(2125), 1,
      sym_dotted_name,
    STATE(2509), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2374), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2633), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2061), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [93662] = 18,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(2597), 1,
      sym_identifier,
    ACTIONS(2599), 1,
      anon_sym_LPAREN,
    ACTIONS(2603), 1,
      anon_sym_STAR,
    ACTIONS(2605), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2607), 1,
      anon_sym_LBRACK,
    ACTIONS(2609), 1,
      anon_sym_DASH,
    ACTIONS(2613), 1,
      anon_sym_LBRACE,
    ACTIONS(2615), 1,
      sym_integer,
    ACTIONS(2617), 1,
      sym_float,
    ACTIONS(2643), 1,
      anon_sym_RPAREN,
    STATE(1867), 1,
      sym_string,
    STATE(2037), 1,
      sym_dotted_name,
    STATE(2329), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2472), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2611), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2038), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [93730] = 18,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(2597), 1,
      sym_identifier,
    ACTIONS(2599), 1,
      anon_sym_LPAREN,
    ACTIONS(2603), 1,
      anon_sym_STAR,
    ACTIONS(2605), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2607), 1,
      anon_sym_LBRACK,
    ACTIONS(2609), 1,
      anon_sym_DASH,
    ACTIONS(2613), 1,
      anon_sym_LBRACE,
    ACTIONS(2615), 1,
      sym_integer,
    ACTIONS(2617), 1,
      sym_float,
    ACTIONS(2645), 1,
      anon_sym_RPAREN,
    STATE(1867), 1,
      sym_string,
    STATE(2037), 1,
      sym_dotted_name,
    STATE(2329), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2472), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2611), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2038), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [93798] = 18,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(2597), 1,
      sym_identifier,
    ACTIONS(2599), 1,
      anon_sym_LPAREN,
    ACTIONS(2603), 1,
      anon_sym_STAR,
    ACTIONS(2605), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2607), 1,
      anon_sym_LBRACK,
    ACTIONS(2609), 1,
      anon_sym_DASH,
    ACTIONS(2613), 1,
      anon_sym_LBRACE,
    ACTIONS(2615), 1,
      sym_integer,
    ACTIONS(2617), 1,
      sym_float,
    ACTIONS(2647), 1,
      anon_sym_RPAREN,
    STATE(1867), 1,
      sym_string,
    STATE(2037), 1,
      sym_dotted_name,
    STATE(2329), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2472), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2611), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2038), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [93866] = 18,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(2619), 1,
      sym_identifier,
    ACTIONS(2621), 1,
      anon_sym_LPAREN,
    ACTIONS(2623), 1,
      anon_sym_STAR,
    ACTIONS(2625), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2627), 1,
      anon_sym_LBRACK,
    ACTIONS(2631), 1,
      anon_sym_DASH,
    ACTIONS(2635), 1,
      anon_sym_LBRACE,
    ACTIONS(2637), 1,
      sym_integer,
    ACTIONS(2639), 1,
      sym_float,
    ACTIONS(2649), 1,
      anon_sym_RBRACK,
    STATE(1903), 1,
      sym_string,
    STATE(2125), 1,
      sym_dotted_name,
    STATE(2509), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2374), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2633), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2061), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [93934] = 18,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(2597), 1,
      sym_identifier,
    ACTIONS(2599), 1,
      anon_sym_LPAREN,
    ACTIONS(2603), 1,
      anon_sym_STAR,
    ACTIONS(2605), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2607), 1,
      anon_sym_LBRACK,
    ACTIONS(2609), 1,
      anon_sym_DASH,
    ACTIONS(2613), 1,
      anon_sym_LBRACE,
    ACTIONS(2615), 1,
      sym_integer,
    ACTIONS(2617), 1,
      sym_float,
    ACTIONS(2651), 1,
      anon_sym_RPAREN,
    STATE(1867), 1,
      sym_string,
    STATE(2037), 1,
      sym_dotted_name,
    STATE(2329), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2472), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2611), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2038), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [94002] = 18,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(2597), 1,
      sym_identifier,
    ACTIONS(2599), 1,
      anon_sym_LPAREN,
    ACTIONS(2603), 1,
      anon_sym_STAR,
    ACTIONS(2605), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2607), 1,
      anon_sym_LBRACK,
    ACTIONS(2609), 1,
      anon_sym_DASH,
    ACTIONS(2613), 1,
      anon_sym_LBRACE,
    ACTIONS(2615), 1,
      sym_integer,
    ACTIONS(2617), 1,
      sym_float,
    ACTIONS(2653), 1,
      anon_sym_RPAREN,
    STATE(1867), 1,
      sym_string,
    STATE(2037), 1,
      sym_dotted_name,
    STATE(2329), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2472), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2611), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2038), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [94070] = 18,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(2619), 1,
      sym_identifier,
    ACTIONS(2621), 1,
      anon_sym_LPAREN,
    ACTIONS(2623), 1,
      anon_sym_STAR,
    ACTIONS(2625), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2627), 1,
      anon_sym_LBRACK,
    ACTIONS(2631), 1,
      anon_sym_DASH,
    ACTIONS(2635), 1,
      anon_sym_LBRACE,
    ACTIONS(2637), 1,
      sym_integer,
    ACTIONS(2639), 1,
      sym_float,
    ACTIONS(2655), 1,
      anon_sym_RBRACK,
    STATE(1903), 1,
      sym_string,
    STATE(2125), 1,
      sym_dotted_name,
    STATE(2509), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2374), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2633), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2061), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [94138] = 18,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(2597), 1,
      sym_identifier,
    ACTIONS(2599), 1,
      anon_sym_LPAREN,
    ACTIONS(2603), 1,
      anon_sym_STAR,
    ACTIONS(2605), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2607), 1,
      anon_sym_LBRACK,
    ACTIONS(2609), 1,
      anon_sym_DASH,
    ACTIONS(2613), 1,
      anon_sym_LBRACE,
    ACTIONS(2615), 1,
      sym_integer,
    ACTIONS(2617), 1,
      sym_float,
    ACTIONS(2657), 1,
      anon_sym_RPAREN,
    STATE(1867), 1,
      sym_string,
    STATE(2037), 1,
      sym_dotted_name,
    STATE(2329), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2472), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2611), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2038), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [94206] = 18,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(2619), 1,
      sym_identifier,
    ACTIONS(2621), 1,
      anon_sym_LPAREN,
    ACTIONS(2623), 1,
      anon_sym_STAR,
    ACTIONS(2625), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2627), 1,
      anon_sym_LBRACK,
    ACTIONS(2631), 1,
      anon_sym_DASH,
    ACTIONS(2635), 1,
      anon_sym_LBRACE,
    ACTIONS(2637), 1,
      sym_integer,
    ACTIONS(2639), 1,
      sym_float,
    ACTIONS(2659), 1,
      anon_sym_RBRACK,
    STATE(1903), 1,
      sym_string,
    STATE(2125), 1,
      sym_dotted_name,
    STATE(2509), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2374), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2633), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2061), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [94274] = 18,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(2597), 1,
      sym_identifier,
    ACTIONS(2599), 1,
      anon_sym_LPAREN,
    ACTIONS(2603), 1,
      anon_sym_STAR,
    ACTIONS(2605), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2607), 1,
      anon_sym_LBRACK,
    ACTIONS(2609), 1,
      anon_sym_DASH,
    ACTIONS(2613), 1,
      anon_sym_LBRACE,
    ACTIONS(2615), 1,
      sym_integer,
    ACTIONS(2617), 1,
      sym_float,
    ACTIONS(2661), 1,
      anon_sym_RPAREN,
    STATE(1867), 1,
      sym_string,
    STATE(2037), 1,
      sym_dotted_name,
    STATE(2141), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2472), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2611), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2038), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [94342] = 18,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(2619), 1,
      sym_identifier,
    ACTIONS(2621), 1,
      anon_sym_LPAREN,
    ACTIONS(2623), 1,
      anon_sym_STAR,
    ACTIONS(2625), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2627), 1,
      anon_sym_LBRACK,
    ACTIONS(2631), 1,
      anon_sym_DASH,
    ACTIONS(2635), 1,
      anon_sym_LBRACE,
    ACTIONS(2637), 1,
      sym_integer,
    ACTIONS(2639), 1,
      sym_float,
    ACTIONS(2663), 1,
      anon_sym_RBRACK,
    STATE(1903), 1,
      sym_string,
    STATE(2125), 1,
      sym_dotted_name,
    STATE(2509), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2374), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2633), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2061), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [94410] = 18,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(2619), 1,
      sym_identifier,
    ACTIONS(2621), 1,
      anon_sym_LPAREN,
    ACTIONS(2623), 1,
      anon_sym_STAR,
    ACTIONS(2625), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2627), 1,
      anon_sym_LBRACK,
    ACTIONS(2631), 1,
      anon_sym_DASH,
    ACTIONS(2635), 1,
      anon_sym_LBRACE,
    ACTIONS(2637), 1,
      sym_integer,
    ACTIONS(2639), 1,
      sym_float,
    ACTIONS(2665), 1,
      anon_sym_RBRACK,
    STATE(1903), 1,
      sym_string,
    STATE(2125), 1,
      sym_dotted_name,
    STATE(2509), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2374), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2633), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2061), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [94478] = 18,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(2597), 1,
      sym_identifier,
    ACTIONS(2599), 1,
      anon_sym_LPAREN,
    ACTIONS(2603), 1,
      anon_sym_STAR,
    ACTIONS(2605), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2607), 1,
      anon_sym_LBRACK,
    ACTIONS(2609), 1,
      anon_sym_DASH,
    ACTIONS(2613), 1,
      anon_sym_LBRACE,
    ACTIONS(2615), 1,
      sym_integer,
    ACTIONS(2617), 1,
      sym_float,
    ACTIONS(2667), 1,
      anon_sym_RPAREN,
    STATE(1867), 1,
      sym_string,
    STATE(2037), 1,
      sym_dotted_name,
    STATE(2329), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2472), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2611), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2038), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [94546] = 18,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(2597), 1,
      sym_identifier,
    ACTIONS(2599), 1,
      anon_sym_LPAREN,
    ACTIONS(2603), 1,
      anon_sym_STAR,
    ACTIONS(2605), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2607), 1,
      anon_sym_LBRACK,
    ACTIONS(2609), 1,
      anon_sym_DASH,
    ACTIONS(2613), 1,
      anon_sym_LBRACE,
    ACTIONS(2615), 1,
      sym_integer,
    ACTIONS(2617), 1,
      sym_float,
    ACTIONS(2669), 1,
      anon_sym_RPAREN,
    STATE(1867), 1,
      sym_string,
    STATE(2037), 1,
      sym_dotted_name,
    STATE(2329), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2472), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2611), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2038), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [94614] = 18,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(2619), 1,
      sym_identifier,
    ACTIONS(2621), 1,
      anon_sym_LPAREN,
    ACTIONS(2623), 1,
      anon_sym_STAR,
    ACTIONS(2625), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2627), 1,
      anon_sym_LBRACK,
    ACTIONS(2631), 1,
      anon_sym_DASH,
    ACTIONS(2635), 1,
      anon_sym_LBRACE,
    ACTIONS(2637), 1,
      sym_integer,
    ACTIONS(2639), 1,
      sym_float,
    ACTIONS(2671), 1,
      anon_sym_RBRACK,
    STATE(1903), 1,
      sym_string,
    STATE(2125), 1,
      sym_dotted_name,
    STATE(2187), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2374), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2633), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2061), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [94682] = 18,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(2597), 1,
      sym_identifier,
    ACTIONS(2599), 1,
      anon_sym_LPAREN,
    ACTIONS(2603), 1,
      anon_sym_STAR,
    ACTIONS(2605), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2607), 1,
      anon_sym_LBRACK,
    ACTIONS(2609), 1,
      anon_sym_DASH,
    ACTIONS(2613), 1,
      anon_sym_LBRACE,
    ACTIONS(2615), 1,
      sym_integer,
    ACTIONS(2617), 1,
      sym_float,
    ACTIONS(2673), 1,
      anon_sym_RPAREN,
    STATE(1867), 1,
      sym_string,
    STATE(2037), 1,
      sym_dotted_name,
    STATE(2198), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2472), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2611), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2038), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [94750] = 18,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(2619), 1,
      sym_identifier,
    ACTIONS(2621), 1,
      anon_sym_LPAREN,
    ACTIONS(2623), 1,
      anon_sym_STAR,
    ACTIONS(2625), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2627), 1,
      anon_sym_LBRACK,
    ACTIONS(2631), 1,
      anon_sym_DASH,
    ACTIONS(2635), 1,
      anon_sym_LBRACE,
    ACTIONS(2637), 1,
      sym_integer,
    ACTIONS(2639), 1,
      sym_float,
    ACTIONS(2675), 1,
      anon_sym_RBRACK,
    STATE(1903), 1,
      sym_string,
    STATE(2125), 1,
      sym_dotted_name,
    STATE(2199), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2374), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2633), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2061), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [94818] = 18,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(2619), 1,
      sym_identifier,
    ACTIONS(2621), 1,
      anon_sym_LPAREN,
    ACTIONS(2623), 1,
      anon_sym_STAR,
    ACTIONS(2625), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2627), 1,
      anon_sym_LBRACK,
    ACTIONS(2631), 1,
      anon_sym_DASH,
    ACTIONS(2635), 1,
      anon_sym_LBRACE,
    ACTIONS(2637), 1,
      sym_integer,
    ACTIONS(2639), 1,
      sym_float,
    ACTIONS(2677), 1,
      anon_sym_RBRACK,
    STATE(1903), 1,
      sym_string,
    STATE(2125), 1,
      sym_dotted_name,
    STATE(2509), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2374), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2633), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2061), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [94886] = 18,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(2597), 1,
      sym_identifier,
    ACTIONS(2599), 1,
      anon_sym_LPAREN,
    ACTIONS(2603), 1,
      anon_sym_STAR,
    ACTIONS(2605), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2607), 1,
      anon_sym_LBRACK,
    ACTIONS(2609), 1,
      anon_sym_DASH,
    ACTIONS(2613), 1,
      anon_sym_LBRACE,
    ACTIONS(2615), 1,
      sym_integer,
    ACTIONS(2617), 1,
      sym_float,
    ACTIONS(2679), 1,
      anon_sym_RPAREN,
    STATE(1867), 1,
      sym_string,
    STATE(2037), 1,
      sym_dotted_name,
    STATE(2329), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2472), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2611), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2038), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [94954] = 18,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(2597), 1,
      sym_identifier,
    ACTIONS(2599), 1,
      anon_sym_LPAREN,
    ACTIONS(2603), 1,
      anon_sym_STAR,
    ACTIONS(2605), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2607), 1,
      anon_sym_LBRACK,
    ACTIONS(2609), 1,
      anon_sym_DASH,
    ACTIONS(2613), 1,
      anon_sym_LBRACE,
    ACTIONS(2615), 1,
      sym_integer,
    ACTIONS(2617), 1,
      sym_float,
    ACTIONS(2681), 1,
      anon_sym_RPAREN,
    STATE(1867), 1,
      sym_string,
    STATE(2037), 1,
      sym_dotted_name,
    STATE(2329), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2472), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2611), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2038), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [95022] = 18,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(2619), 1,
      sym_identifier,
    ACTIONS(2621), 1,
      anon_sym_LPAREN,
    ACTIONS(2623), 1,
      anon_sym_STAR,
    ACTIONS(2625), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2627), 1,
      anon_sym_LBRACK,
    ACTIONS(2631), 1,
      anon_sym_DASH,
    ACTIONS(2635), 1,
      anon_sym_LBRACE,
    ACTIONS(2637), 1,
      sym_integer,
    ACTIONS(2639), 1,
      sym_float,
    ACTIONS(2683), 1,
      anon_sym_RBRACK,
    STATE(1903), 1,
      sym_string,
    STATE(2125), 1,
      sym_dotted_name,
    STATE(2140), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2374), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2633), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2061), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [95090] = 18,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(2597), 1,
      sym_identifier,
    ACTIONS(2599), 1,
      anon_sym_LPAREN,
    ACTIONS(2603), 1,
      anon_sym_STAR,
    ACTIONS(2605), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2607), 1,
      anon_sym_LBRACK,
    ACTIONS(2609), 1,
      anon_sym_DASH,
    ACTIONS(2613), 1,
      anon_sym_LBRACE,
    ACTIONS(2615), 1,
      sym_integer,
    ACTIONS(2617), 1,
      sym_float,
    ACTIONS(2685), 1,
      anon_sym_RPAREN,
    STATE(1867), 1,
      sym_string,
    STATE(2037), 1,
      sym_dotted_name,
    STATE(2155), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2472), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2611), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2038), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [95158] = 18,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(2597), 1,
      sym_identifier,
    ACTIONS(2599), 1,
      anon_sym_LPAREN,
    ACTIONS(2603), 1,
      anon_sym_STAR,
    ACTIONS(2605), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2607), 1,
      anon_sym_LBRACK,
    ACTIONS(2609), 1,
      anon_sym_DASH,
    ACTIONS(2613), 1,
      anon_sym_LBRACE,
    ACTIONS(2615), 1,
      sym_integer,
    ACTIONS(2617), 1,
      sym_float,
    ACTIONS(2687), 1,
      anon_sym_RPAREN,
    STATE(1867), 1,
      sym_string,
    STATE(2037), 1,
      sym_dotted_name,
    STATE(2329), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2472), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2611), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2038), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [95226] = 18,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(2597), 1,
      sym_identifier,
    ACTIONS(2599), 1,
      anon_sym_LPAREN,
    ACTIONS(2603), 1,
      anon_sym_STAR,
    ACTIONS(2605), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2607), 1,
      anon_sym_LBRACK,
    ACTIONS(2609), 1,
      anon_sym_DASH,
    ACTIONS(2613), 1,
      anon_sym_LBRACE,
    ACTIONS(2615), 1,
      sym_integer,
    ACTIONS(2617), 1,
      sym_float,
    ACTIONS(2689), 1,
      anon_sym_RPAREN,
    STATE(1867), 1,
      sym_string,
    STATE(2037), 1,
      sym_dotted_name,
    STATE(2223), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2472), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2611), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2038), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [95294] = 18,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(2597), 1,
      sym_identifier,
    ACTIONS(2599), 1,
      anon_sym_LPAREN,
    ACTIONS(2603), 1,
      anon_sym_STAR,
    ACTIONS(2605), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2607), 1,
      anon_sym_LBRACK,
    ACTIONS(2609), 1,
      anon_sym_DASH,
    ACTIONS(2613), 1,
      anon_sym_LBRACE,
    ACTIONS(2615), 1,
      sym_integer,
    ACTIONS(2617), 1,
      sym_float,
    ACTIONS(2691), 1,
      anon_sym_RPAREN,
    STATE(1867), 1,
      sym_string,
    STATE(2037), 1,
      sym_dotted_name,
    STATE(2329), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2472), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2611), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2038), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [95362] = 18,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(2597), 1,
      sym_identifier,
    ACTIONS(2599), 1,
      anon_sym_LPAREN,
    ACTIONS(2603), 1,
      anon_sym_STAR,
    ACTIONS(2605), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2607), 1,
      anon_sym_LBRACK,
    ACTIONS(2609), 1,
      anon_sym_DASH,
    ACTIONS(2613), 1,
      anon_sym_LBRACE,
    ACTIONS(2615), 1,
      sym_integer,
    ACTIONS(2617), 1,
      sym_float,
    ACTIONS(2693), 1,
      anon_sym_RPAREN,
    STATE(1867), 1,
      sym_string,
    STATE(2037), 1,
      sym_dotted_name,
    STATE(2329), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2472), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2611), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2038), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [95430] = 18,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(2597), 1,
      sym_identifier,
    ACTIONS(2599), 1,
      anon_sym_LPAREN,
    ACTIONS(2603), 1,
      anon_sym_STAR,
    ACTIONS(2605), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2607), 1,
      anon_sym_LBRACK,
    ACTIONS(2609), 1,
      anon_sym_DASH,
    ACTIONS(2613), 1,
      anon_sym_LBRACE,
    ACTIONS(2615), 1,
      sym_integer,
    ACTIONS(2617), 1,
      sym_float,
    ACTIONS(2695), 1,
      anon_sym_RPAREN,
    STATE(1867), 1,
      sym_string,
    STATE(2037), 1,
      sym_dotted_name,
    STATE(2329), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2472), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2611), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2038), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [95498] = 18,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(2597), 1,
      sym_identifier,
    ACTIONS(2599), 1,
      anon_sym_LPAREN,
    ACTIONS(2603), 1,
      anon_sym_STAR,
    ACTIONS(2605), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2607), 1,
      anon_sym_LBRACK,
    ACTIONS(2609), 1,
      anon_sym_DASH,
    ACTIONS(2613), 1,
      anon_sym_LBRACE,
    ACTIONS(2615), 1,
      sym_integer,
    ACTIONS(2617), 1,
      sym_float,
    ACTIONS(2697), 1,
      anon_sym_RPAREN,
    STATE(1867), 1,
      sym_string,
    STATE(2037), 1,
      sym_dotted_name,
    STATE(2192), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2472), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2611), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2038), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [95566] = 18,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(2597), 1,
      sym_identifier,
    ACTIONS(2599), 1,
      anon_sym_LPAREN,
    ACTIONS(2603), 1,
      anon_sym_STAR,
    ACTIONS(2605), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2607), 1,
      anon_sym_LBRACK,
    ACTIONS(2609), 1,
      anon_sym_DASH,
    ACTIONS(2613), 1,
      anon_sym_LBRACE,
    ACTIONS(2615), 1,
      sym_integer,
    ACTIONS(2617), 1,
      sym_float,
    ACTIONS(2699), 1,
      anon_sym_RPAREN,
    STATE(1867), 1,
      sym_string,
    STATE(2037), 1,
      sym_dotted_name,
    STATE(2329), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2472), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2611), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2038), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [95634] = 18,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(2597), 1,
      sym_identifier,
    ACTIONS(2599), 1,
      anon_sym_LPAREN,
    ACTIONS(2603), 1,
      anon_sym_STAR,
    ACTIONS(2605), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2607), 1,
      anon_sym_LBRACK,
    ACTIONS(2609), 1,
      anon_sym_DASH,
    ACTIONS(2613), 1,
      anon_sym_LBRACE,
    ACTIONS(2615), 1,
      sym_integer,
    ACTIONS(2617), 1,
      sym_float,
    ACTIONS(2701), 1,
      anon_sym_RPAREN,
    STATE(1867), 1,
      sym_string,
    STATE(2037), 1,
      sym_dotted_name,
    STATE(2329), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2472), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2611), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2038), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [95702] = 18,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(2597), 1,
      sym_identifier,
    ACTIONS(2599), 1,
      anon_sym_LPAREN,
    ACTIONS(2603), 1,
      anon_sym_STAR,
    ACTIONS(2605), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2607), 1,
      anon_sym_LBRACK,
    ACTIONS(2609), 1,
      anon_sym_DASH,
    ACTIONS(2613), 1,
      anon_sym_LBRACE,
    ACTIONS(2615), 1,
      sym_integer,
    ACTIONS(2617), 1,
      sym_float,
    ACTIONS(2703), 1,
      anon_sym_RPAREN,
    STATE(1867), 1,
      sym_string,
    STATE(2037), 1,
      sym_dotted_name,
    STATE(2213), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2472), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2611), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2038), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [95770] = 18,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(2619), 1,
      sym_identifier,
    ACTIONS(2621), 1,
      anon_sym_LPAREN,
    ACTIONS(2623), 1,
      anon_sym_STAR,
    ACTIONS(2625), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2627), 1,
      anon_sym_LBRACK,
    ACTIONS(2631), 1,
      anon_sym_DASH,
    ACTIONS(2635), 1,
      anon_sym_LBRACE,
    ACTIONS(2637), 1,
      sym_integer,
    ACTIONS(2639), 1,
      sym_float,
    ACTIONS(2705), 1,
      anon_sym_RBRACK,
    STATE(1903), 1,
      sym_string,
    STATE(2125), 1,
      sym_dotted_name,
    STATE(2212), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2374), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2633), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2061), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [95838] = 18,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(2597), 1,
      sym_identifier,
    ACTIONS(2599), 1,
      anon_sym_LPAREN,
    ACTIONS(2603), 1,
      anon_sym_STAR,
    ACTIONS(2605), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2607), 1,
      anon_sym_LBRACK,
    ACTIONS(2609), 1,
      anon_sym_DASH,
    ACTIONS(2613), 1,
      anon_sym_LBRACE,
    ACTIONS(2615), 1,
      sym_integer,
    ACTIONS(2617), 1,
      sym_float,
    ACTIONS(2707), 1,
      anon_sym_RPAREN,
    STATE(1867), 1,
      sym_string,
    STATE(2037), 1,
      sym_dotted_name,
    STATE(2205), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2472), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2611), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2038), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [95906] = 17,
    ACTIONS(702), 1,
      sym_string_start,
    ACTIONS(2709), 1,
      sym_identifier,
    ACTIONS(2711), 1,
      anon_sym_LPAREN,
    ACTIONS(2713), 1,
      anon_sym_STAR,
    ACTIONS(2715), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2717), 1,
      anon_sym_LBRACK,
    ACTIONS(2719), 1,
      anon_sym_DASH,
    ACTIONS(2723), 1,
      anon_sym_LBRACE,
    ACTIONS(2725), 1,
      sym_integer,
    ACTIONS(2727), 1,
      sym_float,
    STATE(1895), 1,
      sym_string,
    STATE(2026), 1,
      sym_dotted_name,
    STATE(2322), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2473), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2721), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2025), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [95971] = 17,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(2571), 1,
      sym_identifier,
    ACTIONS(2573), 1,
      anon_sym_LPAREN,
    ACTIONS(2575), 1,
      anon_sym_STAR,
    ACTIONS(2581), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2583), 1,
      anon_sym_LBRACK,
    ACTIONS(2585), 1,
      anon_sym_DASH,
    ACTIONS(2589), 1,
      anon_sym_LBRACE,
    ACTIONS(2591), 1,
      sym_integer,
    ACTIONS(2593), 1,
      sym_float,
    STATE(1808), 1,
      sym_string,
    STATE(1975), 1,
      sym_case_pattern,
    STATE(1976), 1,
      sym_dotted_name,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2210), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2587), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1974), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [96036] = 17,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(2597), 1,
      sym_identifier,
    ACTIONS(2599), 1,
      anon_sym_LPAREN,
    ACTIONS(2603), 1,
      anon_sym_STAR,
    ACTIONS(2605), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2607), 1,
      anon_sym_LBRACK,
    ACTIONS(2609), 1,
      anon_sym_DASH,
    ACTIONS(2613), 1,
      anon_sym_LBRACE,
    ACTIONS(2615), 1,
      sym_integer,
    ACTIONS(2617), 1,
      sym_float,
    STATE(1867), 1,
      sym_string,
    STATE(2037), 1,
      sym_dotted_name,
    STATE(2329), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2472), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2611), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2038), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [96101] = 17,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(2619), 1,
      sym_identifier,
    ACTIONS(2621), 1,
      anon_sym_LPAREN,
    ACTIONS(2623), 1,
      anon_sym_STAR,
    ACTIONS(2625), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2627), 1,
      anon_sym_LBRACK,
    ACTIONS(2631), 1,
      anon_sym_DASH,
    ACTIONS(2635), 1,
      anon_sym_LBRACE,
    ACTIONS(2637), 1,
      sym_integer,
    ACTIONS(2639), 1,
      sym_float,
    STATE(1903), 1,
      sym_string,
    STATE(2125), 1,
      sym_dotted_name,
    STATE(2509), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2374), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2633), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2061), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [96166] = 17,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(2571), 1,
      sym_identifier,
    ACTIONS(2573), 1,
      anon_sym_LPAREN,
    ACTIONS(2575), 1,
      anon_sym_STAR,
    ACTIONS(2581), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2583), 1,
      anon_sym_LBRACK,
    ACTIONS(2585), 1,
      anon_sym_DASH,
    ACTIONS(2589), 1,
      anon_sym_LBRACE,
    ACTIONS(2591), 1,
      sym_integer,
    ACTIONS(2593), 1,
      sym_float,
    STATE(1808), 1,
      sym_string,
    STATE(1976), 1,
      sym_dotted_name,
    STATE(2160), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2210), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2587), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1974), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [96231] = 18,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(2573), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LBRACK,
    ACTIONS(2585), 1,
      anon_sym_DASH,
    ACTIONS(2589), 1,
      anon_sym_LBRACE,
    ACTIONS(2591), 1,
      sym_integer,
    ACTIONS(2593), 1,
      sym_float,
    ACTIONS(2713), 1,
      anon_sym_STAR,
    ACTIONS(2715), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2729), 1,
      sym_identifier,
    ACTIONS(2733), 1,
      anon_sym_RBRACE,
    STATE(1808), 1,
      sym_string,
    STATE(1976), 1,
      sym_dotted_name,
    STATE(2178), 1,
      sym_splat_pattern,
    STATE(2574), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2731), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2414), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [96297] = 18,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(2573), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LBRACK,
    ACTIONS(2585), 1,
      anon_sym_DASH,
    ACTIONS(2589), 1,
      anon_sym_LBRACE,
    ACTIONS(2591), 1,
      sym_integer,
    ACTIONS(2593), 1,
      sym_float,
    ACTIONS(2713), 1,
      anon_sym_STAR,
    ACTIONS(2715), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2729), 1,
      sym_identifier,
    ACTIONS(2735), 1,
      anon_sym_RBRACE,
    STATE(1808), 1,
      sym_string,
    STATE(1976), 1,
      sym_dotted_name,
    STATE(2178), 1,
      sym_splat_pattern,
    STATE(2574), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2731), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2414), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [96363] = 18,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(2573), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LBRACK,
    ACTIONS(2585), 1,
      anon_sym_DASH,
    ACTIONS(2589), 1,
      anon_sym_LBRACE,
    ACTIONS(2591), 1,
      sym_integer,
    ACTIONS(2593), 1,
      sym_float,
    ACTIONS(2713), 1,
      anon_sym_STAR,
    ACTIONS(2715), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2729), 1,
      sym_identifier,
    ACTIONS(2737), 1,
      anon_sym_RBRACE,
    STATE(1808), 1,
      sym_string,
    STATE(1976), 1,
      sym_dotted_name,
    STATE(2178), 1,
      sym_splat_pattern,
    STATE(2574), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2731), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2414), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [96429] = 18,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(2573), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LBRACK,
    ACTIONS(2585), 1,
      anon_sym_DASH,
    ACTIONS(2589), 1,
      anon_sym_LBRACE,
    ACTIONS(2591), 1,
      sym_integer,
    ACTIONS(2593), 1,
      sym_float,
    ACTIONS(2713), 1,
      anon_sym_STAR,
    ACTIONS(2715), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2729), 1,
      sym_identifier,
    ACTIONS(2739), 1,
      anon_sym_RBRACE,
    STATE(1808), 1,
      sym_string,
    STATE(1976), 1,
      sym_dotted_name,
    STATE(2178), 1,
      sym_splat_pattern,
    STATE(2574), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2731), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2414), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [96495] = 18,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(2573), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LBRACK,
    ACTIONS(2585), 1,
      anon_sym_DASH,
    ACTIONS(2589), 1,
      anon_sym_LBRACE,
    ACTIONS(2591), 1,
      sym_integer,
    ACTIONS(2593), 1,
      sym_float,
    ACTIONS(2713), 1,
      anon_sym_STAR,
    ACTIONS(2715), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2729), 1,
      sym_identifier,
    ACTIONS(2741), 1,
      anon_sym_RBRACE,
    STATE(1808), 1,
      sym_string,
    STATE(1976), 1,
      sym_dotted_name,
    STATE(2178), 1,
      sym_splat_pattern,
    STATE(2574), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2731), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2414), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [96561] = 18,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(2573), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LBRACK,
    ACTIONS(2585), 1,
      anon_sym_DASH,
    ACTIONS(2589), 1,
      anon_sym_LBRACE,
    ACTIONS(2591), 1,
      sym_integer,
    ACTIONS(2593), 1,
      sym_float,
    ACTIONS(2713), 1,
      anon_sym_STAR,
    ACTIONS(2715), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2729), 1,
      sym_identifier,
    ACTIONS(2743), 1,
      anon_sym_RBRACE,
    STATE(1808), 1,
      sym_string,
    STATE(1976), 1,
      sym_dotted_name,
    STATE(2178), 1,
      sym_splat_pattern,
    STATE(2574), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2731), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2414), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [96627] = 18,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(2573), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LBRACK,
    ACTIONS(2585), 1,
      anon_sym_DASH,
    ACTIONS(2589), 1,
      anon_sym_LBRACE,
    ACTIONS(2591), 1,
      sym_integer,
    ACTIONS(2593), 1,
      sym_float,
    ACTIONS(2713), 1,
      anon_sym_STAR,
    ACTIONS(2715), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2729), 1,
      sym_identifier,
    ACTIONS(2745), 1,
      anon_sym_RBRACE,
    STATE(1808), 1,
      sym_string,
    STATE(1976), 1,
      sym_dotted_name,
    STATE(2052), 1,
      sym_splat_pattern,
    STATE(2321), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2731), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2414), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [96693] = 18,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(2573), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LBRACK,
    ACTIONS(2585), 1,
      anon_sym_DASH,
    ACTIONS(2589), 1,
      anon_sym_LBRACE,
    ACTIONS(2591), 1,
      sym_integer,
    ACTIONS(2593), 1,
      sym_float,
    ACTIONS(2713), 1,
      anon_sym_STAR,
    ACTIONS(2715), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2729), 1,
      sym_identifier,
    ACTIONS(2747), 1,
      anon_sym_RBRACE,
    STATE(1808), 1,
      sym_string,
    STATE(1976), 1,
      sym_dotted_name,
    STATE(2079), 1,
      sym_splat_pattern,
    STATE(2399), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2731), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2414), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [96759] = 18,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(2573), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LBRACK,
    ACTIONS(2585), 1,
      anon_sym_DASH,
    ACTIONS(2589), 1,
      anon_sym_LBRACE,
    ACTIONS(2591), 1,
      sym_integer,
    ACTIONS(2593), 1,
      sym_float,
    ACTIONS(2713), 1,
      anon_sym_STAR,
    ACTIONS(2715), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2729), 1,
      sym_identifier,
    ACTIONS(2749), 1,
      anon_sym_RBRACE,
    STATE(1808), 1,
      sym_string,
    STATE(1976), 1,
      sym_dotted_name,
    STATE(2126), 1,
      sym_splat_pattern,
    STATE(2420), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2731), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2414), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [96825] = 18,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(2573), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LBRACK,
    ACTIONS(2585), 1,
      anon_sym_DASH,
    ACTIONS(2589), 1,
      anon_sym_LBRACE,
    ACTIONS(2591), 1,
      sym_integer,
    ACTIONS(2593), 1,
      sym_float,
    ACTIONS(2713), 1,
      anon_sym_STAR,
    ACTIONS(2715), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2729), 1,
      sym_identifier,
    ACTIONS(2751), 1,
      anon_sym_RBRACE,
    STATE(1808), 1,
      sym_string,
    STATE(1976), 1,
      sym_dotted_name,
    STATE(2062), 1,
      sym_splat_pattern,
    STATE(2341), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2731), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2414), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [96891] = 18,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(2573), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LBRACK,
    ACTIONS(2585), 1,
      anon_sym_DASH,
    ACTIONS(2589), 1,
      anon_sym_LBRACE,
    ACTIONS(2591), 1,
      sym_integer,
    ACTIONS(2593), 1,
      sym_float,
    ACTIONS(2713), 1,
      anon_sym_STAR,
    ACTIONS(2715), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2729), 1,
      sym_identifier,
    ACTIONS(2753), 1,
      anon_sym_RBRACE,
    STATE(1808), 1,
      sym_string,
    STATE(1976), 1,
      sym_dotted_name,
    STATE(2178), 1,
      sym_splat_pattern,
    STATE(2574), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2731), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2414), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [96957] = 18,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(2573), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LBRACK,
    ACTIONS(2585), 1,
      anon_sym_DASH,
    ACTIONS(2589), 1,
      anon_sym_LBRACE,
    ACTIONS(2591), 1,
      sym_integer,
    ACTIONS(2593), 1,
      sym_float,
    ACTIONS(2713), 1,
      anon_sym_STAR,
    ACTIONS(2715), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2729), 1,
      sym_identifier,
    ACTIONS(2755), 1,
      anon_sym_RBRACE,
    STATE(1808), 1,
      sym_string,
    STATE(1976), 1,
      sym_dotted_name,
    STATE(2178), 1,
      sym_splat_pattern,
    STATE(2574), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2731), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2414), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [97023] = 18,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(2573), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LBRACK,
    ACTIONS(2585), 1,
      anon_sym_DASH,
    ACTIONS(2589), 1,
      anon_sym_LBRACE,
    ACTIONS(2591), 1,
      sym_integer,
    ACTIONS(2593), 1,
      sym_float,
    ACTIONS(2713), 1,
      anon_sym_STAR,
    ACTIONS(2715), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2729), 1,
      sym_identifier,
    ACTIONS(2757), 1,
      anon_sym_RBRACE,
    STATE(1808), 1,
      sym_string,
    STATE(1976), 1,
      sym_dotted_name,
    STATE(2178), 1,
      sym_splat_pattern,
    STATE(2574), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2731), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2414), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [97089] = 18,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(2573), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LBRACK,
    ACTIONS(2585), 1,
      anon_sym_DASH,
    ACTIONS(2589), 1,
      anon_sym_LBRACE,
    ACTIONS(2591), 1,
      sym_integer,
    ACTIONS(2593), 1,
      sym_float,
    ACTIONS(2713), 1,
      anon_sym_STAR,
    ACTIONS(2715), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2729), 1,
      sym_identifier,
    ACTIONS(2759), 1,
      anon_sym_RBRACE,
    STATE(1808), 1,
      sym_string,
    STATE(1976), 1,
      sym_dotted_name,
    STATE(2178), 1,
      sym_splat_pattern,
    STATE(2574), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2731), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2414), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [97155] = 18,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(2573), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LBRACK,
    ACTIONS(2585), 1,
      anon_sym_DASH,
    ACTIONS(2589), 1,
      anon_sym_LBRACE,
    ACTIONS(2591), 1,
      sym_integer,
    ACTIONS(2593), 1,
      sym_float,
    ACTIONS(2713), 1,
      anon_sym_STAR,
    ACTIONS(2715), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2729), 1,
      sym_identifier,
    ACTIONS(2761), 1,
      anon_sym_RBRACE,
    STATE(1808), 1,
      sym_string,
    STATE(1976), 1,
      sym_dotted_name,
    STATE(2178), 1,
      sym_splat_pattern,
    STATE(2574), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2731), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2414), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [97221] = 18,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(2573), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LBRACK,
    ACTIONS(2585), 1,
      anon_sym_DASH,
    ACTIONS(2589), 1,
      anon_sym_LBRACE,
    ACTIONS(2591), 1,
      sym_integer,
    ACTIONS(2593), 1,
      sym_float,
    ACTIONS(2713), 1,
      anon_sym_STAR,
    ACTIONS(2715), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2729), 1,
      sym_identifier,
    ACTIONS(2763), 1,
      anon_sym_RBRACE,
    STATE(1808), 1,
      sym_string,
    STATE(1976), 1,
      sym_dotted_name,
    STATE(2178), 1,
      sym_splat_pattern,
    STATE(2574), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2731), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2414), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [97287] = 18,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(2573), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LBRACK,
    ACTIONS(2585), 1,
      anon_sym_DASH,
    ACTIONS(2589), 1,
      anon_sym_LBRACE,
    ACTIONS(2591), 1,
      sym_integer,
    ACTIONS(2593), 1,
      sym_float,
    ACTIONS(2713), 1,
      anon_sym_STAR,
    ACTIONS(2715), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2729), 1,
      sym_identifier,
    ACTIONS(2765), 1,
      anon_sym_RBRACE,
    STATE(1808), 1,
      sym_string,
    STATE(1976), 1,
      sym_dotted_name,
    STATE(2178), 1,
      sym_splat_pattern,
    STATE(2574), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2731), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2414), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [97353] = 18,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(2573), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LBRACK,
    ACTIONS(2585), 1,
      anon_sym_DASH,
    ACTIONS(2589), 1,
      anon_sym_LBRACE,
    ACTIONS(2591), 1,
      sym_integer,
    ACTIONS(2593), 1,
      sym_float,
    ACTIONS(2713), 1,
      anon_sym_STAR,
    ACTIONS(2715), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2729), 1,
      sym_identifier,
    ACTIONS(2767), 1,
      anon_sym_RBRACE,
    STATE(1808), 1,
      sym_string,
    STATE(1976), 1,
      sym_dotted_name,
    STATE(2178), 1,
      sym_splat_pattern,
    STATE(2574), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2731), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2414), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [97419] = 18,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(2573), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LBRACK,
    ACTIONS(2585), 1,
      anon_sym_DASH,
    ACTIONS(2589), 1,
      anon_sym_LBRACE,
    ACTIONS(2591), 1,
      sym_integer,
    ACTIONS(2593), 1,
      sym_float,
    ACTIONS(2713), 1,
      anon_sym_STAR,
    ACTIONS(2715), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2729), 1,
      sym_identifier,
    ACTIONS(2769), 1,
      anon_sym_RBRACE,
    STATE(1808), 1,
      sym_string,
    STATE(1976), 1,
      sym_dotted_name,
    STATE(2178), 1,
      sym_splat_pattern,
    STATE(2574), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2731), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2414), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [97485] = 18,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(2573), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LBRACK,
    ACTIONS(2585), 1,
      anon_sym_DASH,
    ACTIONS(2589), 1,
      anon_sym_LBRACE,
    ACTIONS(2591), 1,
      sym_integer,
    ACTIONS(2593), 1,
      sym_float,
    ACTIONS(2713), 1,
      anon_sym_STAR,
    ACTIONS(2715), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2729), 1,
      sym_identifier,
    ACTIONS(2771), 1,
      anon_sym_RBRACE,
    STATE(1808), 1,
      sym_string,
    STATE(1976), 1,
      sym_dotted_name,
    STATE(2178), 1,
      sym_splat_pattern,
    STATE(2574), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2731), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2414), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [97551] = 17,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(2573), 1,
      anon_sym_LPAREN,
    ACTIONS(2583), 1,
      anon_sym_LBRACK,
    ACTIONS(2585), 1,
      anon_sym_DASH,
    ACTIONS(2589), 1,
      anon_sym_LBRACE,
    ACTIONS(2591), 1,
      sym_integer,
    ACTIONS(2593), 1,
      sym_float,
    ACTIONS(2713), 1,
      anon_sym_STAR,
    ACTIONS(2715), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2729), 1,
      sym_identifier,
    STATE(1808), 1,
      sym_string,
    STATE(1976), 1,
      sym_dotted_name,
    STATE(2178), 1,
      sym_splat_pattern,
    STATE(2574), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2731), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2414), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [97614] = 15,
    ACTIONS(702), 1,
      sym_string_start,
    ACTIONS(2711), 1,
      anon_sym_LPAREN,
    ACTIONS(2713), 1,
      anon_sym_STAR,
    ACTIONS(2715), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2717), 1,
      anon_sym_LBRACK,
    ACTIONS(2719), 1,
      anon_sym_DASH,
    ACTIONS(2723), 1,
      anon_sym_LBRACE,
    ACTIONS(2725), 1,
      sym_integer,
    ACTIONS(2727), 1,
      sym_float,
    ACTIONS(2773), 1,
      sym_identifier,
    STATE(1895), 1,
      sym_string,
    STATE(2026), 1,
      sym_dotted_name,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2775), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2018), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [97672] = 15,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(2599), 1,
      anon_sym_LPAREN,
    ACTIONS(2603), 1,
      anon_sym_STAR,
    ACTIONS(2605), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2607), 1,
      anon_sym_LBRACK,
    ACTIONS(2609), 1,
      anon_sym_DASH,
    ACTIONS(2613), 1,
      anon_sym_LBRACE,
    ACTIONS(2615), 1,
      sym_integer,
    ACTIONS(2617), 1,
      sym_float,
    ACTIONS(2777), 1,
      sym_identifier,
    STATE(1867), 1,
      sym_string,
    STATE(2037), 1,
      sym_dotted_name,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2779), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2053), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [97730] = 15,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(2599), 1,
      anon_sym_LPAREN,
    ACTIONS(2603), 1,
      anon_sym_STAR,
    ACTIONS(2605), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2607), 1,
      anon_sym_LBRACK,
    ACTIONS(2609), 1,
      anon_sym_DASH,
    ACTIONS(2613), 1,
      anon_sym_LBRACE,
    ACTIONS(2615), 1,
      sym_integer,
    ACTIONS(2617), 1,
      sym_float,
    ACTIONS(2777), 1,
      sym_identifier,
    STATE(1867), 1,
      sym_string,
    STATE(2037), 1,
      sym_dotted_name,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2781), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2059), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [97788] = 15,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(2573), 1,
      anon_sym_LPAREN,
    ACTIONS(2575), 1,
      anon_sym_STAR,
    ACTIONS(2581), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2583), 1,
      anon_sym_LBRACK,
    ACTIONS(2585), 1,
      anon_sym_DASH,
    ACTIONS(2589), 1,
      anon_sym_LBRACE,
    ACTIONS(2591), 1,
      sym_integer,
    ACTIONS(2593), 1,
      sym_float,
    ACTIONS(2729), 1,
      sym_identifier,
    STATE(1808), 1,
      sym_string,
    STATE(1976), 1,
      sym_dotted_name,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2783), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1953), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [97846] = 15,
    ACTIONS(702), 1,
      sym_string_start,
    ACTIONS(2711), 1,
      anon_sym_LPAREN,
    ACTIONS(2713), 1,
      anon_sym_STAR,
    ACTIONS(2715), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2717), 1,
      anon_sym_LBRACK,
    ACTIONS(2719), 1,
      anon_sym_DASH,
    ACTIONS(2723), 1,
      anon_sym_LBRACE,
    ACTIONS(2725), 1,
      sym_integer,
    ACTIONS(2727), 1,
      sym_float,
    ACTIONS(2773), 1,
      sym_identifier,
    STATE(1895), 1,
      sym_string,
    STATE(2026), 1,
      sym_dotted_name,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2785), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2023), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [97904] = 15,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(2621), 1,
      anon_sym_LPAREN,
    ACTIONS(2623), 1,
      anon_sym_STAR,
    ACTIONS(2625), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2627), 1,
      anon_sym_LBRACK,
    ACTIONS(2631), 1,
      anon_sym_DASH,
    ACTIONS(2635), 1,
      anon_sym_LBRACE,
    ACTIONS(2637), 1,
      sym_integer,
    ACTIONS(2639), 1,
      sym_float,
    ACTIONS(2787), 1,
      sym_identifier,
    STATE(1903), 1,
      sym_string,
    STATE(2125), 1,
      sym_dotted_name,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2789), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2097), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [97962] = 15,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(2573), 1,
      anon_sym_LPAREN,
    ACTIONS(2575), 1,
      anon_sym_STAR,
    ACTIONS(2581), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2583), 1,
      anon_sym_LBRACK,
    ACTIONS(2585), 1,
      anon_sym_DASH,
    ACTIONS(2589), 1,
      anon_sym_LBRACE,
    ACTIONS(2591), 1,
      sym_integer,
    ACTIONS(2593), 1,
      sym_float,
    ACTIONS(2729), 1,
      sym_identifier,
    STATE(1808), 1,
      sym_string,
    STATE(1976), 1,
      sym_dotted_name,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2791), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1981), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [98020] = 15,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(2621), 1,
      anon_sym_LPAREN,
    ACTIONS(2623), 1,
      anon_sym_STAR,
    ACTIONS(2625), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2627), 1,
      anon_sym_LBRACK,
    ACTIONS(2631), 1,
      anon_sym_DASH,
    ACTIONS(2635), 1,
      anon_sym_LBRACE,
    ACTIONS(2637), 1,
      sym_integer,
    ACTIONS(2639), 1,
      sym_float,
    ACTIONS(2787), 1,
      sym_identifier,
    STATE(1903), 1,
      sym_string,
    STATE(2125), 1,
      sym_dotted_name,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2793), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2085), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [98078] = 8,
    ACTIONS(2800), 1,
      anon_sym_EQ,
    ACTIONS(2802), 1,
      anon_sym_not,
    ACTIONS(2808), 1,
      anon_sym_is,
    STATE(1580), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2805), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2797), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2795), 11,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [98120] = 8,
    ACTIONS(2202), 1,
      anon_sym_not,
    ACTIONS(2210), 1,
      anon_sym_is,
    ACTIONS(2813), 1,
      anon_sym_EQ,
    STATE(1580), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2208), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2188), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2811), 11,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [98162] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1643), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1647), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
    ACTIONS(1638), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [98194] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(316), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
    ACTIONS(277), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [98226] = 8,
    ACTIONS(2376), 1,
      anon_sym_not,
    ACTIONS(2384), 1,
      anon_sym_is,
    ACTIONS(2813), 1,
      anon_sym_EQ,
    STATE(1586), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2382), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2364), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2811), 9,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [98266] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(316), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
    ACTIONS(277), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [98298] = 8,
    ACTIONS(2800), 1,
      anon_sym_EQ,
    ACTIONS(2818), 1,
      anon_sym_not,
    ACTIONS(2824), 1,
      anon_sym_is,
    STATE(1586), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2821), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2815), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2795), 9,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [98338] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1531), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1542), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
    ACTIONS(1526), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [98370] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1625), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1627), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
    ACTIONS(1620), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [98402] = 8,
    ACTIONS(2800), 1,
      anon_sym_EQ,
    ACTIONS(2830), 1,
      anon_sym_not,
    ACTIONS(2836), 1,
      anon_sym_is,
    STATE(1589), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2833), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2827), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2795), 9,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [98442] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1618), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1542), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
    ACTIONS(1613), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [98474] = 8,
    ACTIONS(2346), 1,
      anon_sym_not,
    ACTIONS(2354), 1,
      anon_sym_is,
    ACTIONS(2813), 1,
      anon_sym_EQ,
    STATE(1589), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2352), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2334), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2811), 9,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [98514] = 8,
    ACTIONS(2800), 1,
      anon_sym_as,
    ACTIONS(2842), 1,
      anon_sym_not,
    ACTIONS(2848), 1,
      anon_sym_is,
    STATE(1592), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2845), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2839), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2795), 8,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
  [98553] = 7,
    ACTIONS(2490), 1,
      anon_sym_not,
    ACTIONS(2498), 1,
      anon_sym_is,
    STATE(1597), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2496), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2478), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2811), 9,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [98590] = 8,
    ACTIONS(2285), 1,
      anon_sym_not,
    ACTIONS(2293), 1,
      anon_sym_is,
    ACTIONS(2813), 1,
      anon_sym_as,
    STATE(1592), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2291), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2273), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2811), 8,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
  [98629] = 8,
    ACTIONS(2800), 1,
      anon_sym_EQ,
    ACTIONS(2854), 1,
      anon_sym_not,
    ACTIONS(2860), 1,
      anon_sym_is,
    STATE(1595), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2851), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2795), 8,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      sym_type_conversion,
  [98668] = 8,
    ACTIONS(2240), 1,
      anon_sym_not,
    ACTIONS(2248), 1,
      anon_sym_is,
    ACTIONS(2813), 1,
      anon_sym_EQ,
    STATE(1595), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2246), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2228), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2811), 8,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      sym_type_conversion,
  [98707] = 7,
    ACTIONS(2866), 1,
      anon_sym_not,
    ACTIONS(2872), 1,
      anon_sym_is,
    STATE(1597), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2869), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2863), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2795), 9,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [98744] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1348), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(277), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [98774] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(666), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(277), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [98804] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1531), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1588), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1526), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [98834] = 8,
    ACTIONS(2440), 1,
      anon_sym_not,
    ACTIONS(2448), 1,
      anon_sym_is,
    ACTIONS(2813), 1,
      anon_sym_as,
    STATE(1609), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2446), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2428), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2811), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_and,
      anon_sym_or,
  [98872] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(666), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(277), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [98902] = 8,
    ACTIONS(2800), 1,
      anon_sym_as,
    ACTIONS(2878), 1,
      anon_sym_not,
    ACTIONS(2884), 1,
      anon_sym_is,
    STATE(1603), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2881), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2875), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2795), 7,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [98940] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1348), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(277), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [98970] = 4,
    ACTIONS(2889), 1,
      anon_sym_COMMA,
    STATE(1605), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2887), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [99000] = 4,
    ACTIONS(2892), 1,
      anon_sym_COMMA,
    STATE(1605), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(970), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [99030] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1531), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2894), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1526), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [99060] = 8,
    ACTIONS(2406), 1,
      anon_sym_not,
    ACTIONS(2414), 1,
      anon_sym_is,
    ACTIONS(2813), 1,
      anon_sym_as,
    STATE(1603), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2412), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2394), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2811), 7,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [99098] = 8,
    ACTIONS(2800), 1,
      anon_sym_as,
    ACTIONS(2899), 1,
      anon_sym_not,
    ACTIONS(2905), 1,
      anon_sym_is,
    STATE(1609), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2902), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2896), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2795), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_and,
      anon_sym_or,
  [99136] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1531), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1542), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1526), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [99165] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1531), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1542), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1526), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [99194] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1348), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(277), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [99223] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1348), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(277), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [99252] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(316), 2,
      anon_sym_COMMA,
      anon_sym_in,
    ACTIONS(277), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [99281] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1542), 18,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [99306] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(316), 2,
      anon_sym_COMMA,
      anon_sym_in,
    ACTIONS(277), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [99335] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1542), 2,
      anon_sym_COMMA,
      anon_sym_in,
    ACTIONS(1618), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1613), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [99364] = 13,
    ACTIONS(2315), 1,
      anon_sym_DOT,
    ACTIONS(2317), 1,
      anon_sym_LBRACK,
    ACTIONS(2358), 1,
      anon_sym_LPAREN,
    ACTIONS(2366), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2374), 1,
      anon_sym_PIPE,
    ACTIONS(2378), 1,
      anon_sym_AMP,
    ACTIONS(2380), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2360), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2362), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2372), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1315), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2370), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [99411] = 13,
    ACTIONS(2358), 1,
      anon_sym_LPAREN,
    ACTIONS(2366), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2374), 1,
      anon_sym_PIPE,
    ACTIONS(2378), 1,
      anon_sym_AMP,
    ACTIONS(2380), 1,
      anon_sym_CARET,
    ACTIONS(2420), 1,
      anon_sym_DOT,
    ACTIONS(2432), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2360), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2362), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2372), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1315), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2370), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [99458] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1542), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1618), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1613), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [99487] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1625), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1627), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1620), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [99516] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1625), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1627), 2,
      anon_sym_COMMA,
      anon_sym_in,
    ACTIONS(1620), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [99545] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1643), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1647), 2,
      anon_sym_COMMA,
      anon_sym_in,
    ACTIONS(1638), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [99574] = 13,
    ACTIONS(2180), 1,
      anon_sym_DOT,
    ACTIONS(2194), 1,
      anon_sym_LBRACK,
    ACTIONS(2358), 1,
      anon_sym_LPAREN,
    ACTIONS(2366), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2374), 1,
      anon_sym_PIPE,
    ACTIONS(2378), 1,
      anon_sym_AMP,
    ACTIONS(2380), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2360), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2362), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2372), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1315), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2370), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [99621] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1531), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1542), 2,
      anon_sym_COMMA,
      anon_sym_in,
    ACTIONS(1526), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [99650] = 13,
    ACTIONS(2265), 1,
      anon_sym_DOT,
    ACTIONS(2277), 1,
      anon_sym_LBRACK,
    ACTIONS(2358), 1,
      anon_sym_LPAREN,
    ACTIONS(2366), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2374), 1,
      anon_sym_PIPE,
    ACTIONS(2378), 1,
      anon_sym_AMP,
    ACTIONS(2380), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2360), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2362), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2372), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1315), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2370), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [99697] = 13,
    ACTIONS(2356), 1,
      anon_sym_DOT,
    ACTIONS(2358), 1,
      anon_sym_LPAREN,
    ACTIONS(2366), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2368), 1,
      anon_sym_LBRACK,
    ACTIONS(2374), 1,
      anon_sym_PIPE,
    ACTIONS(2378), 1,
      anon_sym_AMP,
    ACTIONS(2380), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2360), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2362), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2372), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1315), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2370), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [99744] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1643), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1647), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1638), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [99773] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1531), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2894), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1526), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [99802] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1542), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1618), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1613), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [99831] = 13,
    ACTIONS(2358), 1,
      anon_sym_LPAREN,
    ACTIONS(2366), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2374), 1,
      anon_sym_PIPE,
    ACTIONS(2378), 1,
      anon_sym_AMP,
    ACTIONS(2380), 1,
      anon_sym_CARET,
    ACTIONS(2386), 1,
      anon_sym_DOT,
    ACTIONS(2398), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2360), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2362), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2372), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1315), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2370), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [99878] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1643), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1647), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1638), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [99907] = 13,
    ACTIONS(2358), 1,
      anon_sym_LPAREN,
    ACTIONS(2366), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2374), 1,
      anon_sym_PIPE,
    ACTIONS(2378), 1,
      anon_sym_AMP,
    ACTIONS(2380), 1,
      anon_sym_CARET,
    ACTIONS(2470), 1,
      anon_sym_DOT,
    ACTIONS(2482), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2360), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2362), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2372), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1315), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2370), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [99954] = 13,
    ACTIONS(2358), 1,
      anon_sym_LPAREN,
    ACTIONS(2366), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2374), 1,
      anon_sym_PIPE,
    ACTIONS(2378), 1,
      anon_sym_AMP,
    ACTIONS(2380), 1,
      anon_sym_CARET,
    ACTIONS(2908), 1,
      anon_sym_DOT,
    ACTIONS(2910), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2360), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2362), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2372), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1315), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2370), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [100001] = 13,
    ACTIONS(2220), 1,
      anon_sym_DOT,
    ACTIONS(2232), 1,
      anon_sym_LBRACK,
    ACTIONS(2358), 1,
      anon_sym_LPAREN,
    ACTIONS(2366), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2374), 1,
      anon_sym_PIPE,
    ACTIONS(2378), 1,
      anon_sym_AMP,
    ACTIONS(2380), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2360), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2362), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2372), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1315), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2370), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [100048] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1531), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1588), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1526), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [100077] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(666), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(277), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [100106] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2887), 18,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [100131] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(666), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(277), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [100160] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(316), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(277), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [100189] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(316), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(277), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [100218] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2912), 18,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [100243] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2914), 18,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [100268] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(316), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(277), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [100297] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(279), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(316), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(277), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [100326] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1625), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1627), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1620), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [100355] = 13,
    ACTIONS(2326), 1,
      anon_sym_DOT,
    ACTIONS(2338), 1,
      anon_sym_LBRACK,
    ACTIONS(2358), 1,
      anon_sym_LPAREN,
    ACTIONS(2366), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2374), 1,
      anon_sym_PIPE,
    ACTIONS(2378), 1,
      anon_sym_AMP,
    ACTIONS(2380), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2360), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2362), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2372), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1315), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2370), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [100402] = 13,
    ACTIONS(2916), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      anon_sym_LPAREN,
    ACTIONS(2920), 1,
      anon_sym_STAR,
    ACTIONS(2922), 1,
      anon_sym_COLON,
    ACTIONS(2924), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2926), 1,
      anon_sym_SLASH,
    STATE(2429), 1,
      sym_parameter,
    STATE(2434), 1,
      sym_tuple_pattern,
    STATE(2623), 1,
      sym__parameters,
    STATE(2726), 1,
      sym_lambda_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2611), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2613), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [100448] = 13,
    ACTIONS(2916), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      anon_sym_LPAREN,
    ACTIONS(2920), 1,
      anon_sym_STAR,
    ACTIONS(2924), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2926), 1,
      anon_sym_SLASH,
    ACTIONS(2928), 1,
      anon_sym_COLON,
    STATE(2429), 1,
      sym_parameter,
    STATE(2434), 1,
      sym_tuple_pattern,
    STATE(2623), 1,
      sym__parameters,
    STATE(2799), 1,
      sym_lambda_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2611), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2613), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [100494] = 13,
    ACTIONS(2916), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      anon_sym_LPAREN,
    ACTIONS(2920), 1,
      anon_sym_STAR,
    ACTIONS(2924), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2926), 1,
      anon_sym_SLASH,
    ACTIONS(2930), 1,
      anon_sym_COLON,
    STATE(2429), 1,
      sym_parameter,
    STATE(2434), 1,
      sym_tuple_pattern,
    STATE(2623), 1,
      sym__parameters,
    STATE(2796), 1,
      sym_lambda_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2611), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2613), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [100540] = 6,
    ACTIONS(2932), 1,
      anon_sym_COMMA,
    ACTIONS(2934), 1,
      anon_sym_COLON,
    ACTIONS(2936), 1,
      anon_sym_EQ,
    STATE(1606), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2938), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [100572] = 13,
    ACTIONS(2916), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      anon_sym_LPAREN,
    ACTIONS(2920), 1,
      anon_sym_STAR,
    ACTIONS(2924), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2926), 1,
      anon_sym_SLASH,
    ACTIONS(2940), 1,
      anon_sym_COLON,
    STATE(2429), 1,
      sym_parameter,
    STATE(2434), 1,
      sym_tuple_pattern,
    STATE(2623), 1,
      sym__parameters,
    STATE(2723), 1,
      sym_lambda_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2611), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2613), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [100618] = 4,
    ACTIONS(2942), 1,
      anon_sym_COMMA,
    STATE(1653), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2887), 15,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [100646] = 13,
    ACTIONS(2916), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      anon_sym_LPAREN,
    ACTIONS(2920), 1,
      anon_sym_STAR,
    ACTIONS(2924), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2926), 1,
      anon_sym_SLASH,
    ACTIONS(2945), 1,
      anon_sym_COLON,
    STATE(2429), 1,
      sym_parameter,
    STATE(2434), 1,
      sym_tuple_pattern,
    STATE(2623), 1,
      sym__parameters,
    STATE(2624), 1,
      sym_lambda_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2611), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2613), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [100692] = 5,
    ACTIONS(2934), 1,
      anon_sym_COLON,
    ACTIONS(2936), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2947), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(2938), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [100722] = 13,
    ACTIONS(2916), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      anon_sym_LPAREN,
    ACTIONS(2920), 1,
      anon_sym_STAR,
    ACTIONS(2924), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2926), 1,
      anon_sym_SLASH,
    ACTIONS(2949), 1,
      anon_sym_COLON,
    STATE(2429), 1,
      sym_parameter,
    STATE(2434), 1,
      sym_tuple_pattern,
    STATE(2623), 1,
      sym__parameters,
    STATE(2732), 1,
      sym_lambda_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2611), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2613), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [100768] = 4,
    ACTIONS(2951), 1,
      anon_sym_COMMA,
    STATE(1653), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(970), 15,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [100796] = 13,
    ACTIONS(2916), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      anon_sym_LPAREN,
    ACTIONS(2920), 1,
      anon_sym_STAR,
    ACTIONS(2924), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2926), 1,
      anon_sym_SLASH,
    ACTIONS(2953), 1,
      anon_sym_COLON,
    STATE(2429), 1,
      sym_parameter,
    STATE(2434), 1,
      sym_tuple_pattern,
    STATE(2623), 1,
      sym__parameters,
    STATE(2633), 1,
      sym_lambda_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2611), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2613), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [100842] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2887), 17,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [100866] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2914), 17,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [100890] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2912), 17,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [100914] = 13,
    ACTIONS(2916), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      anon_sym_LPAREN,
    ACTIONS(2920), 1,
      anon_sym_STAR,
    ACTIONS(2924), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2926), 1,
      anon_sym_SLASH,
    ACTIONS(2955), 1,
      anon_sym_COLON,
    STATE(2429), 1,
      sym_parameter,
    STATE(2434), 1,
      sym_tuple_pattern,
    STATE(2623), 1,
      sym__parameters,
    STATE(2776), 1,
      sym_lambda_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2611), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2613), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [100960] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1542), 17,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [100984] = 13,
    ACTIONS(2916), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      anon_sym_LPAREN,
    ACTIONS(2920), 1,
      anon_sym_STAR,
    ACTIONS(2924), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2926), 1,
      anon_sym_SLASH,
    ACTIONS(2957), 1,
      anon_sym_COLON,
    STATE(2429), 1,
      sym_parameter,
    STATE(2434), 1,
      sym_tuple_pattern,
    STATE(2623), 1,
      sym__parameters,
    STATE(2749), 1,
      sym_lambda_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2611), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2613), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [101030] = 13,
    ACTIONS(2916), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      anon_sym_LPAREN,
    ACTIONS(2920), 1,
      anon_sym_STAR,
    ACTIONS(2924), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2926), 1,
      anon_sym_SLASH,
    ACTIONS(2959), 1,
      anon_sym_COLON,
    STATE(2429), 1,
      sym_parameter,
    STATE(2434), 1,
      sym_tuple_pattern,
    STATE(2623), 1,
      sym__parameters,
    STATE(2635), 1,
      sym_lambda_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2611), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2613), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [101076] = 6,
    ACTIONS(2934), 1,
      anon_sym_COLON,
    ACTIONS(2936), 1,
      anon_sym_EQ,
    ACTIONS(2961), 1,
      anon_sym_COMMA,
    STATE(1657), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2938), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [101108] = 13,
    ACTIONS(2916), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      anon_sym_LPAREN,
    ACTIONS(2920), 1,
      anon_sym_STAR,
    ACTIONS(2924), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2926), 1,
      anon_sym_SLASH,
    ACTIONS(2963), 1,
      anon_sym_COLON,
    STATE(2429), 1,
      sym_parameter,
    STATE(2434), 1,
      sym_tuple_pattern,
    STATE(2623), 1,
      sym__parameters,
    STATE(2672), 1,
      sym_lambda_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2611), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2613), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [101154] = 12,
    ACTIONS(2965), 1,
      sym_identifier,
    ACTIONS(2967), 1,
      anon_sym_LPAREN,
    ACTIONS(2969), 1,
      anon_sym_RPAREN,
    ACTIONS(2971), 1,
      anon_sym_STAR,
    ACTIONS(2973), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2975), 1,
      anon_sym_SLASH,
    STATE(2266), 1,
      sym_tuple_pattern,
    STATE(2288), 1,
      sym_parameter,
    STATE(2699), 1,
      sym__parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2268), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2532), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [101197] = 11,
    ACTIONS(2916), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      anon_sym_LPAREN,
    ACTIONS(2920), 1,
      anon_sym_STAR,
    ACTIONS(2924), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2926), 1,
      anon_sym_SLASH,
    ACTIONS(2977), 1,
      anon_sym_COLON,
    STATE(2434), 1,
      sym_tuple_pattern,
    STATE(2599), 1,
      sym_parameter,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2611), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2613), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [101237] = 11,
    ACTIONS(2965), 1,
      sym_identifier,
    ACTIONS(2967), 1,
      anon_sym_LPAREN,
    ACTIONS(2971), 1,
      anon_sym_STAR,
    ACTIONS(2973), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2975), 1,
      anon_sym_SLASH,
    ACTIONS(2977), 1,
      anon_sym_RPAREN,
    STATE(2266), 1,
      sym_tuple_pattern,
    STATE(2604), 1,
      sym_parameter,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2268), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2532), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [101277] = 11,
    ACTIONS(2916), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      anon_sym_LPAREN,
    ACTIONS(2920), 1,
      anon_sym_STAR,
    ACTIONS(2924), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2926), 1,
      anon_sym_SLASH,
    ACTIONS(2979), 1,
      anon_sym_COLON,
    STATE(2434), 1,
      sym_tuple_pattern,
    STATE(2599), 1,
      sym_parameter,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2611), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2613), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [101317] = 4,
    ACTIONS(2934), 1,
      anon_sym_COLON,
    ACTIONS(2936), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2938), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [101343] = 11,
    ACTIONS(2965), 1,
      sym_identifier,
    ACTIONS(2967), 1,
      anon_sym_LPAREN,
    ACTIONS(2971), 1,
      anon_sym_STAR,
    ACTIONS(2973), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2975), 1,
      anon_sym_SLASH,
    ACTIONS(2979), 1,
      anon_sym_RPAREN,
    STATE(2266), 1,
      sym_tuple_pattern,
    STATE(2604), 1,
      sym_parameter,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2268), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2532), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [101383] = 10,
    ACTIONS(2965), 1,
      sym_identifier,
    ACTIONS(2967), 1,
      anon_sym_LPAREN,
    ACTIONS(2971), 1,
      anon_sym_STAR,
    ACTIONS(2973), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2975), 1,
      anon_sym_SLASH,
    STATE(2266), 1,
      sym_tuple_pattern,
    STATE(2604), 1,
      sym_parameter,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2268), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2532), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [101420] = 10,
    ACTIONS(2916), 1,
      sym_identifier,
    ACTIONS(2918), 1,
      anon_sym_LPAREN,
    ACTIONS(2920), 1,
      anon_sym_STAR,
    ACTIONS(2924), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2926), 1,
      anon_sym_SLASH,
    STATE(2434), 1,
      sym_tuple_pattern,
    STATE(2599), 1,
      sym_parameter,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2611), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2613), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [101457] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2981), 12,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [101476] = 4,
    ACTIONS(2985), 1,
      anon_sym_and,
    ACTIONS(2987), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2983), 10,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [101499] = 13,
    ACTIONS(2989), 1,
      anon_sym_COMMA,
    ACTIONS(2991), 1,
      anon_sym_as,
    ACTIONS(2993), 1,
      anon_sym_if,
    ACTIONS(2995), 1,
      anon_sym_COLON,
    ACTIONS(2997), 1,
      anon_sym_async,
    ACTIONS(2999), 1,
      anon_sym_for,
    ACTIONS(3001), 1,
      anon_sym_RBRACE,
    ACTIONS(3003), 1,
      anon_sym_and,
    ACTIONS(3005), 1,
      anon_sym_or,
    STATE(1858), 1,
      sym_for_in_clause,
    STATE(2271), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2645), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [101540] = 13,
    ACTIONS(2989), 1,
      anon_sym_COMMA,
    ACTIONS(2991), 1,
      anon_sym_as,
    ACTIONS(2993), 1,
      anon_sym_if,
    ACTIONS(2995), 1,
      anon_sym_COLON,
    ACTIONS(2997), 1,
      anon_sym_async,
    ACTIONS(2999), 1,
      anon_sym_for,
    ACTIONS(3001), 1,
      anon_sym_RBRACE,
    ACTIONS(3003), 1,
      anon_sym_and,
    ACTIONS(3005), 1,
      anon_sym_or,
    STATE(1858), 1,
      sym_for_in_clause,
    STATE(2271), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2748), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [101581] = 13,
    ACTIONS(2989), 1,
      anon_sym_COMMA,
    ACTIONS(2991), 1,
      anon_sym_as,
    ACTIONS(2993), 1,
      anon_sym_if,
    ACTIONS(2995), 1,
      anon_sym_COLON,
    ACTIONS(2997), 1,
      anon_sym_async,
    ACTIONS(2999), 1,
      anon_sym_for,
    ACTIONS(3001), 1,
      anon_sym_RBRACE,
    ACTIONS(3003), 1,
      anon_sym_and,
    ACTIONS(3005), 1,
      anon_sym_or,
    STATE(1858), 1,
      sym_for_in_clause,
    STATE(2271), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2643), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [101622] = 13,
    ACTIONS(2989), 1,
      anon_sym_COMMA,
    ACTIONS(2991), 1,
      anon_sym_as,
    ACTIONS(2993), 1,
      anon_sym_if,
    ACTIONS(2995), 1,
      anon_sym_COLON,
    ACTIONS(2997), 1,
      anon_sym_async,
    ACTIONS(2999), 1,
      anon_sym_for,
    ACTIONS(3001), 1,
      anon_sym_RBRACE,
    ACTIONS(3003), 1,
      anon_sym_and,
    ACTIONS(3005), 1,
      anon_sym_or,
    STATE(1858), 1,
      sym_for_in_clause,
    STATE(2271), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2740), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [101663] = 6,
    ACTIONS(2985), 1,
      anon_sym_and,
    ACTIONS(2987), 1,
      anon_sym_or,
    ACTIONS(3009), 1,
      anon_sym_as,
    ACTIONS(3011), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3007), 8,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [101690] = 13,
    ACTIONS(2989), 1,
      anon_sym_COMMA,
    ACTIONS(2991), 1,
      anon_sym_as,
    ACTIONS(2993), 1,
      anon_sym_if,
    ACTIONS(2995), 1,
      anon_sym_COLON,
    ACTIONS(2997), 1,
      anon_sym_async,
    ACTIONS(2999), 1,
      anon_sym_for,
    ACTIONS(3001), 1,
      anon_sym_RBRACE,
    ACTIONS(3003), 1,
      anon_sym_and,
    ACTIONS(3005), 1,
      anon_sym_or,
    STATE(1858), 1,
      sym_for_in_clause,
    STATE(2271), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2701), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [101731] = 13,
    ACTIONS(2989), 1,
      anon_sym_COMMA,
    ACTIONS(2991), 1,
      anon_sym_as,
    ACTIONS(2993), 1,
      anon_sym_if,
    ACTIONS(2995), 1,
      anon_sym_COLON,
    ACTIONS(2997), 1,
      anon_sym_async,
    ACTIONS(2999), 1,
      anon_sym_for,
    ACTIONS(3001), 1,
      anon_sym_RBRACE,
    ACTIONS(3003), 1,
      anon_sym_and,
    ACTIONS(3005), 1,
      anon_sym_or,
    STATE(1858), 1,
      sym_for_in_clause,
    STATE(2271), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2752), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [101772] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2178), 12,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [101791] = 6,
    ACTIONS(2985), 1,
      anon_sym_and,
    ACTIONS(2987), 1,
      anon_sym_or,
    ACTIONS(3009), 1,
      anon_sym_as,
    ACTIONS(3011), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3013), 8,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [101818] = 5,
    ACTIONS(2985), 1,
      anon_sym_and,
    ACTIONS(2987), 1,
      anon_sym_or,
    ACTIONS(3017), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3015), 9,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [101843] = 3,
    ACTIONS(2985), 1,
      anon_sym_and,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3020), 11,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_or,
  [101864] = 13,
    ACTIONS(2989), 1,
      anon_sym_COMMA,
    ACTIONS(2991), 1,
      anon_sym_as,
    ACTIONS(2993), 1,
      anon_sym_if,
    ACTIONS(2995), 1,
      anon_sym_COLON,
    ACTIONS(2997), 1,
      anon_sym_async,
    ACTIONS(2999), 1,
      anon_sym_for,
    ACTIONS(3001), 1,
      anon_sym_RBRACE,
    ACTIONS(3003), 1,
      anon_sym_and,
    ACTIONS(3005), 1,
      anon_sym_or,
    STATE(1858), 1,
      sym_for_in_clause,
    STATE(2271), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2678), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [101905] = 6,
    ACTIONS(2985), 1,
      anon_sym_and,
    ACTIONS(2987), 1,
      anon_sym_or,
    ACTIONS(3009), 1,
      anon_sym_as,
    ACTIONS(3011), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3022), 8,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [101932] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3020), 12,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [101951] = 13,
    ACTIONS(2989), 1,
      anon_sym_COMMA,
    ACTIONS(2991), 1,
      anon_sym_as,
    ACTIONS(2993), 1,
      anon_sym_if,
    ACTIONS(2995), 1,
      anon_sym_COLON,
    ACTIONS(2997), 1,
      anon_sym_async,
    ACTIONS(2999), 1,
      anon_sym_for,
    ACTIONS(3001), 1,
      anon_sym_RBRACE,
    ACTIONS(3003), 1,
      anon_sym_and,
    ACTIONS(3005), 1,
      anon_sym_or,
    STATE(1858), 1,
      sym_for_in_clause,
    STATE(2271), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2781), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [101992] = 12,
    ACTIONS(3024), 1,
      anon_sym_RPAREN,
    ACTIONS(3026), 1,
      anon_sym_COMMA,
    ACTIONS(3028), 1,
      anon_sym_as,
    ACTIONS(3030), 1,
      anon_sym_if,
    ACTIONS(3032), 1,
      anon_sym_async,
    ACTIONS(3034), 1,
      anon_sym_for,
    ACTIONS(3036), 1,
      anon_sym_and,
    ACTIONS(3038), 1,
      anon_sym_or,
    STATE(1855), 1,
      sym_for_in_clause,
    STATE(2485), 1,
      aux_sym_argument_list_repeat1,
    STATE(2788), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [102030] = 12,
    ACTIONS(3001), 1,
      anon_sym_RBRACK,
    ACTIONS(3040), 1,
      anon_sym_COMMA,
    ACTIONS(3042), 1,
      anon_sym_as,
    ACTIONS(3044), 1,
      anon_sym_if,
    ACTIONS(3046), 1,
      anon_sym_async,
    ACTIONS(3048), 1,
      anon_sym_for,
    ACTIONS(3050), 1,
      anon_sym_and,
    ACTIONS(3052), 1,
      anon_sym_or,
    STATE(1857), 1,
      sym_for_in_clause,
    STATE(2294), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2741), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [102068] = 12,
    ACTIONS(3028), 1,
      anon_sym_as,
    ACTIONS(3030), 1,
      anon_sym_if,
    ACTIONS(3032), 1,
      anon_sym_async,
    ACTIONS(3034), 1,
      anon_sym_for,
    ACTIONS(3036), 1,
      anon_sym_and,
    ACTIONS(3038), 1,
      anon_sym_or,
    ACTIONS(3054), 1,
      anon_sym_RPAREN,
    ACTIONS(3056), 1,
      anon_sym_COMMA,
    STATE(1855), 1,
      sym_for_in_clause,
    STATE(2493), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2665), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [102106] = 12,
    ACTIONS(3028), 1,
      anon_sym_as,
    ACTIONS(3030), 1,
      anon_sym_if,
    ACTIONS(3032), 1,
      anon_sym_async,
    ACTIONS(3034), 1,
      anon_sym_for,
    ACTIONS(3036), 1,
      anon_sym_and,
    ACTIONS(3038), 1,
      anon_sym_or,
    ACTIONS(3058), 1,
      anon_sym_RPAREN,
    ACTIONS(3060), 1,
      anon_sym_COMMA,
    STATE(1855), 1,
      sym_for_in_clause,
    STATE(2402), 1,
      aux_sym_argument_list_repeat1,
    STATE(2665), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [102144] = 12,
    ACTIONS(3028), 1,
      anon_sym_as,
    ACTIONS(3030), 1,
      anon_sym_if,
    ACTIONS(3032), 1,
      anon_sym_async,
    ACTIONS(3034), 1,
      anon_sym_for,
    ACTIONS(3036), 1,
      anon_sym_and,
    ACTIONS(3038), 1,
      anon_sym_or,
    ACTIONS(3062), 1,
      anon_sym_RPAREN,
    ACTIONS(3064), 1,
      anon_sym_COMMA,
    STATE(1855), 1,
      sym_for_in_clause,
    STATE(2493), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2759), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [102182] = 12,
    ACTIONS(3028), 1,
      anon_sym_as,
    ACTIONS(3030), 1,
      anon_sym_if,
    ACTIONS(3032), 1,
      anon_sym_async,
    ACTIONS(3034), 1,
      anon_sym_for,
    ACTIONS(3036), 1,
      anon_sym_and,
    ACTIONS(3038), 1,
      anon_sym_or,
    ACTIONS(3056), 1,
      anon_sym_COMMA,
    ACTIONS(3067), 1,
      anon_sym_RPAREN,
    STATE(1855), 1,
      sym_for_in_clause,
    STATE(2493), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2807), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [102220] = 12,
    ACTIONS(3028), 1,
      anon_sym_as,
    ACTIONS(3030), 1,
      anon_sym_if,
    ACTIONS(3032), 1,
      anon_sym_async,
    ACTIONS(3034), 1,
      anon_sym_for,
    ACTIONS(3036), 1,
      anon_sym_and,
    ACTIONS(3038), 1,
      anon_sym_or,
    ACTIONS(3069), 1,
      anon_sym_RPAREN,
    ACTIONS(3071), 1,
      anon_sym_COMMA,
    STATE(1855), 1,
      sym_for_in_clause,
    STATE(2492), 1,
      aux_sym_argument_list_repeat1,
    STATE(2807), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [102258] = 9,
    ACTIONS(2985), 1,
      anon_sym_and,
    ACTIONS(2987), 1,
      anon_sym_or,
    ACTIONS(3009), 1,
      anon_sym_as,
    ACTIONS(3011), 1,
      anon_sym_if,
    ACTIONS(3077), 1,
      anon_sym_COMMA,
    STATE(2208), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3073), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3075), 3,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_PIPE,
  [102290] = 12,
    ACTIONS(3028), 1,
      anon_sym_as,
    ACTIONS(3030), 1,
      anon_sym_if,
    ACTIONS(3032), 1,
      anon_sym_async,
    ACTIONS(3034), 1,
      anon_sym_for,
    ACTIONS(3036), 1,
      anon_sym_and,
    ACTIONS(3038), 1,
      anon_sym_or,
    ACTIONS(3056), 1,
      anon_sym_COMMA,
    ACTIONS(3062), 1,
      anon_sym_RPAREN,
    STATE(1855), 1,
      sym_for_in_clause,
    STATE(2493), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2759), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [102328] = 12,
    ACTIONS(3001), 1,
      anon_sym_RBRACK,
    ACTIONS(3040), 1,
      anon_sym_COMMA,
    ACTIONS(3042), 1,
      anon_sym_as,
    ACTIONS(3044), 1,
      anon_sym_if,
    ACTIONS(3046), 1,
      anon_sym_async,
    ACTIONS(3048), 1,
      anon_sym_for,
    ACTIONS(3050), 1,
      anon_sym_and,
    ACTIONS(3052), 1,
      anon_sym_or,
    STATE(1857), 1,
      sym_for_in_clause,
    STATE(2294), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2650), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [102366] = 12,
    ACTIONS(3001), 1,
      anon_sym_RBRACK,
    ACTIONS(3040), 1,
      anon_sym_COMMA,
    ACTIONS(3042), 1,
      anon_sym_as,
    ACTIONS(3044), 1,
      anon_sym_if,
    ACTIONS(3046), 1,
      anon_sym_async,
    ACTIONS(3048), 1,
      anon_sym_for,
    ACTIONS(3050), 1,
      anon_sym_and,
    ACTIONS(3052), 1,
      anon_sym_or,
    STATE(1857), 1,
      sym_for_in_clause,
    STATE(2294), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2754), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [102404] = 12,
    ACTIONS(3001), 1,
      anon_sym_RBRACK,
    ACTIONS(3040), 1,
      anon_sym_COMMA,
    ACTIONS(3042), 1,
      anon_sym_as,
    ACTIONS(3044), 1,
      anon_sym_if,
    ACTIONS(3046), 1,
      anon_sym_async,
    ACTIONS(3048), 1,
      anon_sym_for,
    ACTIONS(3050), 1,
      anon_sym_and,
    ACTIONS(3052), 1,
      anon_sym_or,
    STATE(1857), 1,
      sym_for_in_clause,
    STATE(2294), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2641), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [102442] = 12,
    ACTIONS(3028), 1,
      anon_sym_as,
    ACTIONS(3030), 1,
      anon_sym_if,
    ACTIONS(3032), 1,
      anon_sym_async,
    ACTIONS(3034), 1,
      anon_sym_for,
    ACTIONS(3036), 1,
      anon_sym_and,
    ACTIONS(3038), 1,
      anon_sym_or,
    ACTIONS(3056), 1,
      anon_sym_COMMA,
    ACTIONS(3079), 1,
      anon_sym_RPAREN,
    STATE(1855), 1,
      sym_for_in_clause,
    STATE(2493), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2788), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [102480] = 12,
    ACTIONS(3001), 1,
      anon_sym_RBRACK,
    ACTIONS(3040), 1,
      anon_sym_COMMA,
    ACTIONS(3042), 1,
      anon_sym_as,
    ACTIONS(3044), 1,
      anon_sym_if,
    ACTIONS(3046), 1,
      anon_sym_async,
    ACTIONS(3048), 1,
      anon_sym_for,
    ACTIONS(3050), 1,
      anon_sym_and,
    ACTIONS(3052), 1,
      anon_sym_or,
    STATE(1857), 1,
      sym_for_in_clause,
    STATE(2294), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2619), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [102518] = 12,
    ACTIONS(3028), 1,
      anon_sym_as,
    ACTIONS(3030), 1,
      anon_sym_if,
    ACTIONS(3032), 1,
      anon_sym_async,
    ACTIONS(3034), 1,
      anon_sym_for,
    ACTIONS(3036), 1,
      anon_sym_and,
    ACTIONS(3038), 1,
      anon_sym_or,
    ACTIONS(3081), 1,
      anon_sym_RPAREN,
    ACTIONS(3083), 1,
      anon_sym_COMMA,
    STATE(1855), 1,
      sym_for_in_clause,
    STATE(2308), 1,
      aux_sym_argument_list_repeat1,
    STATE(2761), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [102556] = 12,
    ACTIONS(3028), 1,
      anon_sym_as,
    ACTIONS(3030), 1,
      anon_sym_if,
    ACTIONS(3032), 1,
      anon_sym_async,
    ACTIONS(3034), 1,
      anon_sym_for,
    ACTIONS(3036), 1,
      anon_sym_and,
    ACTIONS(3038), 1,
      anon_sym_or,
    ACTIONS(3085), 1,
      anon_sym_RPAREN,
    ACTIONS(3087), 1,
      anon_sym_COMMA,
    STATE(1855), 1,
      sym_for_in_clause,
    STATE(2299), 1,
      aux_sym_argument_list_repeat1,
    STATE(2759), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [102594] = 12,
    ACTIONS(3028), 1,
      anon_sym_as,
    ACTIONS(3030), 1,
      anon_sym_if,
    ACTIONS(3032), 1,
      anon_sym_async,
    ACTIONS(3034), 1,
      anon_sym_for,
    ACTIONS(3036), 1,
      anon_sym_and,
    ACTIONS(3038), 1,
      anon_sym_or,
    ACTIONS(3056), 1,
      anon_sym_COMMA,
    ACTIONS(3089), 1,
      anon_sym_RPAREN,
    STATE(1855), 1,
      sym_for_in_clause,
    STATE(2493), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2761), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [102632] = 12,
    ACTIONS(3001), 1,
      anon_sym_RBRACK,
    ACTIONS(3040), 1,
      anon_sym_COMMA,
    ACTIONS(3042), 1,
      anon_sym_as,
    ACTIONS(3044), 1,
      anon_sym_if,
    ACTIONS(3046), 1,
      anon_sym_async,
    ACTIONS(3048), 1,
      anon_sym_for,
    ACTIONS(3050), 1,
      anon_sym_and,
    ACTIONS(3052), 1,
      anon_sym_or,
    STATE(1857), 1,
      sym_for_in_clause,
    STATE(2294), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2706), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [102670] = 12,
    ACTIONS(3028), 1,
      anon_sym_as,
    ACTIONS(3030), 1,
      anon_sym_if,
    ACTIONS(3032), 1,
      anon_sym_async,
    ACTIONS(3034), 1,
      anon_sym_for,
    ACTIONS(3036), 1,
      anon_sym_and,
    ACTIONS(3038), 1,
      anon_sym_or,
    ACTIONS(3056), 1,
      anon_sym_COMMA,
    ACTIONS(3091), 1,
      anon_sym_RPAREN,
    STATE(1855), 1,
      sym_for_in_clause,
    STATE(2493), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2707), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [102708] = 12,
    ACTIONS(3001), 1,
      anon_sym_RBRACK,
    ACTIONS(3040), 1,
      anon_sym_COMMA,
    ACTIONS(3042), 1,
      anon_sym_as,
    ACTIONS(3044), 1,
      anon_sym_if,
    ACTIONS(3046), 1,
      anon_sym_async,
    ACTIONS(3048), 1,
      anon_sym_for,
    ACTIONS(3050), 1,
      anon_sym_and,
    ACTIONS(3052), 1,
      anon_sym_or,
    STATE(1857), 1,
      sym_for_in_clause,
    STATE(2294), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2660), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [102746] = 12,
    ACTIONS(3028), 1,
      anon_sym_as,
    ACTIONS(3030), 1,
      anon_sym_if,
    ACTIONS(3032), 1,
      anon_sym_async,
    ACTIONS(3034), 1,
      anon_sym_for,
    ACTIONS(3036), 1,
      anon_sym_and,
    ACTIONS(3038), 1,
      anon_sym_or,
    ACTIONS(3093), 1,
      anon_sym_RPAREN,
    ACTIONS(3095), 1,
      anon_sym_COMMA,
    STATE(1855), 1,
      sym_for_in_clause,
    STATE(2386), 1,
      aux_sym_argument_list_repeat1,
    STATE(2640), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [102784] = 12,
    ACTIONS(3028), 1,
      anon_sym_as,
    ACTIONS(3030), 1,
      anon_sym_if,
    ACTIONS(3032), 1,
      anon_sym_async,
    ACTIONS(3034), 1,
      anon_sym_for,
    ACTIONS(3036), 1,
      anon_sym_and,
    ACTIONS(3038), 1,
      anon_sym_or,
    ACTIONS(3097), 1,
      anon_sym_RPAREN,
    ACTIONS(3099), 1,
      anon_sym_COMMA,
    STATE(1855), 1,
      sym_for_in_clause,
    STATE(2363), 1,
      aux_sym_argument_list_repeat1,
    STATE(2797), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [102822] = 12,
    ACTIONS(3001), 1,
      anon_sym_RBRACK,
    ACTIONS(3040), 1,
      anon_sym_COMMA,
    ACTIONS(3042), 1,
      anon_sym_as,
    ACTIONS(3044), 1,
      anon_sym_if,
    ACTIONS(3046), 1,
      anon_sym_async,
    ACTIONS(3048), 1,
      anon_sym_for,
    ACTIONS(3050), 1,
      anon_sym_and,
    ACTIONS(3052), 1,
      anon_sym_or,
    STATE(1857), 1,
      sym_for_in_clause,
    STATE(2294), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2787), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [102860] = 12,
    ACTIONS(3028), 1,
      anon_sym_as,
    ACTIONS(3030), 1,
      anon_sym_if,
    ACTIONS(3032), 1,
      anon_sym_async,
    ACTIONS(3034), 1,
      anon_sym_for,
    ACTIONS(3036), 1,
      anon_sym_and,
    ACTIONS(3038), 1,
      anon_sym_or,
    ACTIONS(3101), 1,
      anon_sym_RPAREN,
    ACTIONS(3103), 1,
      anon_sym_COMMA,
    STATE(1855), 1,
      sym_for_in_clause,
    STATE(2451), 1,
      aux_sym_argument_list_repeat1,
    STATE(2707), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [102898] = 12,
    ACTIONS(3028), 1,
      anon_sym_as,
    ACTIONS(3030), 1,
      anon_sym_if,
    ACTIONS(3032), 1,
      anon_sym_async,
    ACTIONS(3034), 1,
      anon_sym_for,
    ACTIONS(3036), 1,
      anon_sym_and,
    ACTIONS(3038), 1,
      anon_sym_or,
    ACTIONS(3056), 1,
      anon_sym_COMMA,
    ACTIONS(3105), 1,
      anon_sym_RPAREN,
    STATE(1855), 1,
      sym_for_in_clause,
    STATE(2493), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2797), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [102936] = 12,
    ACTIONS(3028), 1,
      anon_sym_as,
    ACTIONS(3030), 1,
      anon_sym_if,
    ACTIONS(3032), 1,
      anon_sym_async,
    ACTIONS(3034), 1,
      anon_sym_for,
    ACTIONS(3036), 1,
      anon_sym_and,
    ACTIONS(3038), 1,
      anon_sym_or,
    ACTIONS(3056), 1,
      anon_sym_COMMA,
    ACTIONS(3107), 1,
      anon_sym_RPAREN,
    STATE(1855), 1,
      sym_for_in_clause,
    STATE(2493), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2640), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [102974] = 5,
    ACTIONS(3109), 1,
      anon_sym_as,
    ACTIONS(3112), 1,
      anon_sym_and,
    ACTIONS(3114), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3015), 7,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [102997] = 6,
    ACTIONS(3112), 1,
      anon_sym_and,
    ACTIONS(3114), 1,
      anon_sym_or,
    ACTIONS(3116), 1,
      anon_sym_as,
    ACTIONS(3118), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3007), 6,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [103022] = 3,
    ACTIONS(3112), 1,
      anon_sym_and,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3020), 9,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_or,
  [103041] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3120), 1,
      anon_sym_LBRACE,
    ACTIONS(3124), 1,
      sym__not_escape_sequence,
    ACTIONS(3126), 1,
      sym_string_end,
    STATE(1896), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(3122), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1731), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_string_repeat1,
  [103070] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3120), 1,
      anon_sym_LBRACE,
    ACTIONS(3124), 1,
      sym__not_escape_sequence,
    ACTIONS(3128), 1,
      sym_string_end,
    STATE(1896), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(3122), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1722), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_string_repeat1,
  [103099] = 8,
    ACTIONS(3130), 1,
      anon_sym_COMMA,
    ACTIONS(3132), 1,
      anon_sym_as,
    ACTIONS(3134), 1,
      anon_sym_if,
    ACTIONS(3138), 1,
      anon_sym_and,
    ACTIONS(3140), 1,
      anon_sym_or,
    STATE(2007), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3136), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [103128] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3120), 1,
      anon_sym_LBRACE,
    ACTIONS(3124), 1,
      sym__not_escape_sequence,
    ACTIONS(3142), 1,
      sym_string_end,
    STATE(1896), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(3122), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1745), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_string_repeat1,
  [103157] = 6,
    ACTIONS(3112), 1,
      anon_sym_and,
    ACTIONS(3114), 1,
      anon_sym_or,
    ACTIONS(3116), 1,
      anon_sym_as,
    ACTIONS(3118), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3075), 6,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [103182] = 6,
    ACTIONS(3112), 1,
      anon_sym_and,
    ACTIONS(3114), 1,
      anon_sym_or,
    ACTIONS(3116), 1,
      anon_sym_as,
    ACTIONS(3118), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3013), 6,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [103207] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2178), 10,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [103224] = 8,
    ACTIONS(3130), 1,
      anon_sym_COMMA,
    ACTIONS(3132), 1,
      anon_sym_as,
    ACTIONS(3134), 1,
      anon_sym_if,
    ACTIONS(3138), 1,
      anon_sym_and,
    ACTIONS(3140), 1,
      anon_sym_or,
    STATE(2007), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3144), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [103253] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3120), 1,
      anon_sym_LBRACE,
    ACTIONS(3124), 1,
      sym__not_escape_sequence,
    ACTIONS(3146), 1,
      sym_string_end,
    STATE(1896), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(3122), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1736), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_string_repeat1,
  [103282] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3148), 1,
      anon_sym_LBRACE,
    ACTIONS(3154), 1,
      sym__not_escape_sequence,
    ACTIONS(3157), 1,
      sym_string_end,
    STATE(1896), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(3151), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1731), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_string_repeat1,
  [103311] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3120), 1,
      anon_sym_LBRACE,
    ACTIONS(3124), 1,
      sym__not_escape_sequence,
    ACTIONS(3159), 1,
      sym_string_end,
    STATE(1896), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(3122), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1731), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_string_repeat1,
  [103340] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3120), 1,
      anon_sym_LBRACE,
    ACTIONS(3124), 1,
      sym__not_escape_sequence,
    ACTIONS(3161), 1,
      sym_string_end,
    STATE(1896), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(3122), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1731), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_string_repeat1,
  [103369] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2178), 10,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [103386] = 4,
    ACTIONS(3112), 1,
      anon_sym_and,
    ACTIONS(3114), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2983), 8,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [103407] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3120), 1,
      anon_sym_LBRACE,
    ACTIONS(3124), 1,
      sym__not_escape_sequence,
    ACTIONS(3163), 1,
      sym_string_end,
    STATE(1896), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(3122), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1731), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_string_repeat1,
  [103436] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3120), 1,
      anon_sym_LBRACE,
    ACTIONS(3124), 1,
      sym__not_escape_sequence,
    ACTIONS(3165), 1,
      sym_string_end,
    STATE(1896), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(3122), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1732), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_string_repeat1,
  [103465] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3120), 1,
      anon_sym_LBRACE,
    ACTIONS(3124), 1,
      sym__not_escape_sequence,
    ACTIONS(3167), 1,
      sym_string_end,
    STATE(1896), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(3122), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1733), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_string_repeat1,
  [103494] = 6,
    ACTIONS(3112), 1,
      anon_sym_and,
    ACTIONS(3114), 1,
      anon_sym_or,
    ACTIONS(3116), 1,
      anon_sym_as,
    ACTIONS(3118), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3022), 6,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [103519] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3020), 10,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [103536] = 6,
    ACTIONS(3169), 1,
      anon_sym_as,
    ACTIONS(3171), 1,
      anon_sym_if,
    ACTIONS(3173), 1,
      anon_sym_and,
    ACTIONS(3175), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3013), 6,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_EQ,
      anon_sym_PIPE,
  [103561] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3120), 1,
      anon_sym_LBRACE,
    ACTIONS(3124), 1,
      sym__not_escape_sequence,
    ACTIONS(3177), 1,
      sym_string_end,
    STATE(1896), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(3122), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1731), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_string_repeat1,
  [103590] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2981), 10,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [103607] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3120), 1,
      anon_sym_LBRACE,
    ACTIONS(3124), 1,
      sym__not_escape_sequence,
    ACTIONS(3179), 1,
      sym_string_end,
    STATE(1896), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(3122), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1742), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_string_repeat1,
  [103636] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3120), 1,
      anon_sym_LBRACE,
    ACTIONS(3124), 1,
      sym__not_escape_sequence,
    ACTIONS(3181), 1,
      sym_string_end,
    STATE(1896), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(3122), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1731), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_string_repeat1,
  [103665] = 6,
    ACTIONS(3169), 1,
      anon_sym_as,
    ACTIONS(3171), 1,
      anon_sym_if,
    ACTIONS(3173), 1,
      anon_sym_and,
    ACTIONS(3175), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3007), 6,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_EQ,
      anon_sym_PIPE,
  [103690] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3120), 1,
      anon_sym_LBRACE,
    ACTIONS(3124), 1,
      sym__not_escape_sequence,
    ACTIONS(3183), 1,
      sym_string_end,
    STATE(1896), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(3122), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1731), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_string_repeat1,
  [103719] = 3,
    ACTIONS(3173), 1,
      anon_sym_and,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3020), 9,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_or,
  [103738] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3020), 10,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [103755] = 4,
    ACTIONS(3173), 1,
      anon_sym_and,
    ACTIONS(3175), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2983), 8,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_EQ,
      anon_sym_PIPE,
  [103776] = 6,
    ACTIONS(3169), 1,
      anon_sym_as,
    ACTIONS(3171), 1,
      anon_sym_if,
    ACTIONS(3173), 1,
      anon_sym_and,
    ACTIONS(3175), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3022), 6,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_EQ,
      anon_sym_PIPE,
  [103801] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3120), 1,
      anon_sym_LBRACE,
    ACTIONS(3124), 1,
      sym__not_escape_sequence,
    ACTIONS(3185), 1,
      sym_string_end,
    STATE(1896), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(3122), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1758), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_string_repeat1,
  [103830] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3120), 1,
      anon_sym_LBRACE,
    ACTIONS(3124), 1,
      sym__not_escape_sequence,
    ACTIONS(3187), 1,
      sym_string_end,
    STATE(1896), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(3122), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1731), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_string_repeat1,
  [103859] = 6,
    ACTIONS(2985), 1,
      anon_sym_and,
    ACTIONS(2987), 1,
      anon_sym_or,
    ACTIONS(3009), 1,
      anon_sym_as,
    ACTIONS(3011), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3075), 6,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [103884] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3120), 1,
      anon_sym_LBRACE,
    ACTIONS(3124), 1,
      sym__not_escape_sequence,
    ACTIONS(3189), 1,
      sym_string_end,
    STATE(1896), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(3122), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1753), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_string_repeat1,
  [103913] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3120), 1,
      anon_sym_LBRACE,
    ACTIONS(3124), 1,
      sym__not_escape_sequence,
    ACTIONS(3191), 1,
      sym_string_end,
    STATE(1896), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(3122), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1747), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_string_repeat1,
  [103942] = 5,
    ACTIONS(3173), 1,
      anon_sym_and,
    ACTIONS(3175), 1,
      anon_sym_or,
    ACTIONS(3193), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3015), 7,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_EQ,
      anon_sym_PIPE,
  [103965] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3120), 1,
      anon_sym_LBRACE,
    ACTIONS(3124), 1,
      sym__not_escape_sequence,
    ACTIONS(3196), 1,
      sym_string_end,
    STATE(1896), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(3122), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1731), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_string_repeat1,
  [103994] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2981), 10,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [104011] = 4,
    ACTIONS(3003), 1,
      anon_sym_and,
    ACTIONS(3198), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3020), 7,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
      anon_sym_or,
  [104031] = 4,
    ACTIONS(3202), 1,
      anon_sym_DOT,
    STATE(1776), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3200), 7,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [104051] = 6,
    ACTIONS(3204), 1,
      anon_sym_as,
    ACTIONS(3206), 1,
      anon_sym_if,
    ACTIONS(3208), 1,
      anon_sym_and,
    ACTIONS(3210), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3022), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [104075] = 6,
    ACTIONS(3204), 1,
      anon_sym_as,
    ACTIONS(3206), 1,
      anon_sym_if,
    ACTIONS(3208), 1,
      anon_sym_and,
    ACTIONS(3210), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3013), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [104099] = 3,
    ACTIONS(2192), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2178), 8,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
  [104117] = 5,
    ACTIONS(3202), 1,
      anon_sym_DOT,
    ACTIONS(3214), 1,
      anon_sym_EQ,
    STATE(1761), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3212), 6,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [104139] = 3,
    ACTIONS(3208), 1,
      anon_sym_and,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3020), 8,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_or,
  [104157] = 6,
    ACTIONS(3132), 1,
      anon_sym_as,
    ACTIONS(3134), 1,
      anon_sym_if,
    ACTIONS(3138), 1,
      anon_sym_and,
    ACTIONS(3140), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3007), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [104181] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3020), 9,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [104197] = 4,
    ACTIONS(3208), 1,
      anon_sym_and,
    ACTIONS(3210), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2983), 7,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [104217] = 5,
    ACTIONS(3138), 1,
      anon_sym_and,
    ACTIONS(3140), 1,
      anon_sym_or,
    ACTIONS(3216), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3015), 6,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [104239] = 4,
    ACTIONS(3138), 1,
      anon_sym_and,
    ACTIONS(3140), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2983), 7,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [104259] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3020), 9,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      sym_type_conversion,
  [104275] = 3,
    ACTIONS(3138), 1,
      anon_sym_and,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3020), 8,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_or,
      sym_type_conversion,
  [104293] = 5,
    ACTIONS(3208), 1,
      anon_sym_and,
    ACTIONS(3210), 1,
      anon_sym_or,
    ACTIONS(3219), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3015), 6,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [104315] = 6,
    ACTIONS(3204), 1,
      anon_sym_as,
    ACTIONS(3206), 1,
      anon_sym_if,
    ACTIONS(3208), 1,
      anon_sym_and,
    ACTIONS(3210), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3007), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [104339] = 4,
    ACTIONS(3224), 1,
      anon_sym_DOT,
    STATE(1776), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3222), 7,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [104359] = 4,
    ACTIONS(3202), 1,
      anon_sym_DOT,
    STATE(1761), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3212), 7,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [104379] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2981), 9,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [104395] = 3,
    ACTIONS(3227), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2981), 8,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
  [104413] = 6,
    ACTIONS(3169), 1,
      anon_sym_as,
    ACTIONS(3171), 1,
      anon_sym_if,
    ACTIONS(3173), 1,
      anon_sym_and,
    ACTIONS(3175), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3075), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [104437] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2178), 9,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [104453] = 6,
    ACTIONS(2991), 1,
      anon_sym_as,
    ACTIONS(2993), 1,
      anon_sym_if,
    ACTIONS(3003), 1,
      anon_sym_and,
    ACTIONS(3005), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3007), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [104477] = 5,
    ACTIONS(3003), 1,
      anon_sym_and,
    ACTIONS(3005), 1,
      anon_sym_or,
    ACTIONS(3229), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3015), 6,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [104499] = 5,
    ACTIONS(3003), 1,
      anon_sym_and,
    ACTIONS(3005), 1,
      anon_sym_or,
    ACTIONS(3232), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2983), 6,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [104521] = 6,
    ACTIONS(3132), 1,
      anon_sym_as,
    ACTIONS(3134), 1,
      anon_sym_if,
    ACTIONS(3138), 1,
      anon_sym_and,
    ACTIONS(3140), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3234), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [104545] = 6,
    ACTIONS(2991), 1,
      anon_sym_as,
    ACTIONS(2993), 1,
      anon_sym_if,
    ACTIONS(3003), 1,
      anon_sym_and,
    ACTIONS(3005), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3013), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [104569] = 6,
    ACTIONS(3204), 1,
      anon_sym_as,
    ACTIONS(3206), 1,
      anon_sym_if,
    ACTIONS(3208), 1,
      anon_sym_and,
    ACTIONS(3210), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3075), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [104593] = 9,
    ACTIONS(2985), 1,
      anon_sym_and,
    ACTIONS(2987), 1,
      anon_sym_or,
    ACTIONS(3009), 1,
      anon_sym_as,
    ACTIONS(3011), 1,
      anon_sym_if,
    ACTIONS(3238), 1,
      anon_sym_from,
    ACTIONS(3240), 1,
      anon_sym_COMMA,
    STATE(2092), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3236), 2,
      sym__newline,
      anon_sym_SEMI,
  [104623] = 6,
    ACTIONS(2991), 1,
      anon_sym_as,
    ACTIONS(2993), 1,
      anon_sym_if,
    ACTIONS(3003), 1,
      anon_sym_and,
    ACTIONS(3005), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3022), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [104647] = 3,
    ACTIONS(3198), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3020), 8,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
  [104665] = 6,
    ACTIONS(3132), 1,
      anon_sym_as,
    ACTIONS(3134), 1,
      anon_sym_if,
    ACTIONS(3138), 1,
      anon_sym_and,
    ACTIONS(3140), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3022), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [104689] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2981), 9,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      sym_type_conversion,
  [104705] = 6,
    ACTIONS(3132), 1,
      anon_sym_as,
    ACTIONS(3134), 1,
      anon_sym_if,
    ACTIONS(3138), 1,
      anon_sym_and,
    ACTIONS(3140), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3013), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [104729] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2178), 9,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      sym_type_conversion,
  [104745] = 6,
    ACTIONS(3132), 1,
      anon_sym_as,
    ACTIONS(3134), 1,
      anon_sym_if,
    ACTIONS(3138), 1,
      anon_sym_and,
    ACTIONS(3140), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3242), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [104769] = 5,
    ACTIONS(3244), 1,
      anon_sym_DOT,
    ACTIONS(3246), 1,
      anon_sym_EQ,
    STATE(1904), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3212), 5,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [104790] = 8,
    ACTIONS(2985), 1,
      anon_sym_and,
    ACTIONS(2987), 1,
      anon_sym_or,
    ACTIONS(3009), 1,
      anon_sym_as,
    ACTIONS(3011), 1,
      anon_sym_if,
    ACTIONS(3240), 1,
      anon_sym_COMMA,
    STATE(2092), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3248), 2,
      sym__newline,
      anon_sym_SEMI,
  [104817] = 5,
    ACTIONS(2991), 1,
      anon_sym_as,
    ACTIONS(3003), 1,
      anon_sym_and,
    ACTIONS(3005), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3250), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [104838] = 5,
    ACTIONS(3252), 1,
      anon_sym_DOT,
    ACTIONS(3254), 1,
      anon_sym_EQ,
    STATE(1902), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3212), 5,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [104859] = 6,
    ACTIONS(3042), 1,
      anon_sym_as,
    ACTIONS(3044), 1,
      anon_sym_if,
    ACTIONS(3050), 1,
      anon_sym_and,
    ACTIONS(3052), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3022), 4,
      anon_sym_COMMA,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [104882] = 5,
    ACTIONS(3050), 1,
      anon_sym_and,
    ACTIONS(3052), 1,
      anon_sym_or,
    ACTIONS(3232), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2983), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [104903] = 5,
    ACTIONS(3042), 1,
      anon_sym_as,
    ACTIONS(3050), 1,
      anon_sym_and,
    ACTIONS(3052), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3250), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [104924] = 5,
    ACTIONS(3256), 1,
      anon_sym_DOT,
    ACTIONS(3258), 1,
      anon_sym_EQ,
    STATE(1861), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3212), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [104945] = 5,
    ACTIONS(3028), 1,
      anon_sym_as,
    ACTIONS(3036), 1,
      anon_sym_and,
    ACTIONS(3038), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3250), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [104966] = 6,
    ACTIONS(3042), 1,
      anon_sym_as,
    ACTIONS(3044), 1,
      anon_sym_if,
    ACTIONS(3050), 1,
      anon_sym_and,
    ACTIONS(3052), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3013), 4,
      anon_sym_COMMA,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [104989] = 3,
    ACTIONS(3227), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2981), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_and,
      anon_sym_or,
  [105006] = 6,
    ACTIONS(3028), 1,
      anon_sym_as,
    ACTIONS(3030), 1,
      anon_sym_if,
    ACTIONS(3036), 1,
      anon_sym_and,
    ACTIONS(3038), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3022), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_async,
      anon_sym_for,
  [105029] = 4,
    ACTIONS(324), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(993), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(3260), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [105048] = 9,
    ACTIONS(3204), 1,
      anon_sym_as,
    ACTIONS(3206), 1,
      anon_sym_if,
    ACTIONS(3208), 1,
      anon_sym_and,
    ACTIONS(3210), 1,
      anon_sym_or,
    ACTIONS(3262), 1,
      anon_sym_COMMA,
    ACTIONS(3264), 1,
      anon_sym_COLON,
    ACTIONS(3266), 1,
      anon_sym_RBRACK,
    STATE(2446), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [105077] = 8,
    ACTIONS(2985), 1,
      anon_sym_and,
    ACTIONS(2987), 1,
      anon_sym_or,
    ACTIONS(3009), 1,
      anon_sym_as,
    ACTIONS(3011), 1,
      anon_sym_if,
    ACTIONS(3077), 1,
      anon_sym_COMMA,
    STATE(2208), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3073), 2,
      sym__newline,
      anon_sym_SEMI,
  [105104] = 3,
    ACTIONS(2192), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2178), 7,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [105121] = 9,
    ACTIONS(3204), 1,
      anon_sym_as,
    ACTIONS(3206), 1,
      anon_sym_if,
    ACTIONS(3208), 1,
      anon_sym_and,
    ACTIONS(3210), 1,
      anon_sym_or,
    ACTIONS(3264), 1,
      anon_sym_COLON,
    ACTIONS(3268), 1,
      anon_sym_COMMA,
    ACTIONS(3270), 1,
      anon_sym_RBRACK,
    STATE(2303), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [105150] = 8,
    ACTIONS(2985), 1,
      anon_sym_and,
    ACTIONS(2987), 1,
      anon_sym_or,
    ACTIONS(3009), 1,
      anon_sym_as,
    ACTIONS(3011), 1,
      anon_sym_if,
    ACTIONS(3240), 1,
      anon_sym_COMMA,
    STATE(2092), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3136), 2,
      sym__newline,
      anon_sym_SEMI,
  [105177] = 9,
    ACTIONS(3204), 1,
      anon_sym_as,
    ACTIONS(3206), 1,
      anon_sym_if,
    ACTIONS(3208), 1,
      anon_sym_and,
    ACTIONS(3210), 1,
      anon_sym_or,
    ACTIONS(3264), 1,
      anon_sym_COLON,
    ACTIONS(3272), 1,
      anon_sym_COMMA,
    ACTIONS(3274), 1,
      anon_sym_RBRACK,
    STATE(2369), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [105206] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3222), 8,
      anon_sym_import,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [105221] = 7,
    ACTIONS(63), 1,
      anon_sym_AT,
    ACTIONS(3276), 1,
      anon_sym_async,
    ACTIONS(3278), 1,
      anon_sym_def,
    ACTIONS(3280), 1,
      anon_sym_class,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(788), 2,
      sym_function_definition,
      sym_class_definition,
    STATE(1982), 2,
      sym_decorator,
      aux_sym_decorated_definition_repeat1,
  [105246] = 6,
    ACTIONS(3042), 1,
      anon_sym_as,
    ACTIONS(3044), 1,
      anon_sym_if,
    ACTIONS(3050), 1,
      anon_sym_and,
    ACTIONS(3052), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3007), 4,
      anon_sym_COMMA,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [105269] = 9,
    ACTIONS(3204), 1,
      anon_sym_as,
    ACTIONS(3206), 1,
      anon_sym_if,
    ACTIONS(3208), 1,
      anon_sym_and,
    ACTIONS(3210), 1,
      anon_sym_or,
    ACTIONS(3264), 1,
      anon_sym_COLON,
    ACTIONS(3282), 1,
      anon_sym_COMMA,
    ACTIONS(3284), 1,
      anon_sym_RBRACK,
    STATE(2478), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [105298] = 9,
    ACTIONS(3204), 1,
      anon_sym_as,
    ACTIONS(3206), 1,
      anon_sym_if,
    ACTIONS(3208), 1,
      anon_sym_and,
    ACTIONS(3210), 1,
      anon_sym_or,
    ACTIONS(3264), 1,
      anon_sym_COLON,
    ACTIONS(3286), 1,
      anon_sym_COMMA,
    ACTIONS(3288), 1,
      anon_sym_RBRACK,
    STATE(2382), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [105327] = 7,
    ACTIONS(1498), 1,
      anon_sym_except,
    ACTIONS(1506), 1,
      anon_sym_except_STAR,
    ACTIONS(3290), 1,
      anon_sym_finally,
    STATE(740), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(528), 2,
      sym_except_clause,
      aux_sym_try_statement_repeat1,
    STATE(529), 2,
      sym_except_group_clause,
      aux_sym_try_statement_repeat2,
  [105352] = 7,
    ACTIONS(63), 1,
      anon_sym_AT,
    ACTIONS(3292), 1,
      anon_sym_async,
    ACTIONS(3294), 1,
      anon_sym_def,
    ACTIONS(3296), 1,
      anon_sym_class,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(815), 2,
      sym_function_definition,
      sym_class_definition,
    STATE(1982), 2,
      sym_decorator,
      aux_sym_decorated_definition_repeat1,
  [105377] = 6,
    ACTIONS(3028), 1,
      anon_sym_as,
    ACTIONS(3030), 1,
      anon_sym_if,
    ACTIONS(3036), 1,
      anon_sym_and,
    ACTIONS(3038), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3013), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_async,
      anon_sym_for,
  [105400] = 7,
    ACTIONS(1498), 1,
      anon_sym_except,
    ACTIONS(1506), 1,
      anon_sym_except_STAR,
    ACTIONS(3290), 1,
      anon_sym_finally,
    STATE(747), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(524), 2,
      sym_except_clause,
      aux_sym_try_statement_repeat1,
    STATE(534), 2,
      sym_except_group_clause,
      aux_sym_try_statement_repeat2,
  [105425] = 5,
    ACTIONS(3050), 1,
      anon_sym_and,
    ACTIONS(3052), 1,
      anon_sym_or,
    ACTIONS(3298), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3015), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [105446] = 5,
    ACTIONS(3042), 1,
      anon_sym_as,
    ACTIONS(3050), 1,
      anon_sym_and,
    ACTIONS(3052), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3250), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [105467] = 3,
    ACTIONS(2192), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2178), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_and,
      anon_sym_or,
  [105484] = 3,
    ACTIONS(3227), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2981), 7,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [105501] = 8,
    ACTIONS(2985), 1,
      anon_sym_and,
    ACTIONS(2987), 1,
      anon_sym_or,
    ACTIONS(3009), 1,
      anon_sym_as,
    ACTIONS(3011), 1,
      anon_sym_if,
    ACTIONS(3303), 1,
      anon_sym_COMMA,
    STATE(2180), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3301), 2,
      sym__newline,
      anon_sym_SEMI,
  [105528] = 9,
    ACTIONS(3204), 1,
      anon_sym_as,
    ACTIONS(3206), 1,
      anon_sym_if,
    ACTIONS(3208), 1,
      anon_sym_and,
    ACTIONS(3210), 1,
      anon_sym_or,
    ACTIONS(3264), 1,
      anon_sym_COLON,
    ACTIONS(3305), 1,
      anon_sym_COMMA,
    ACTIONS(3307), 1,
      anon_sym_RBRACK,
    STATE(2496), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [105557] = 8,
    ACTIONS(2985), 1,
      anon_sym_and,
    ACTIONS(2987), 1,
      anon_sym_or,
    ACTIONS(3009), 1,
      anon_sym_as,
    ACTIONS(3011), 1,
      anon_sym_if,
    ACTIONS(3311), 1,
      anon_sym_COMMA,
    STATE(2176), 1,
      aux_sym_print_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3309), 2,
      sym__newline,
      anon_sym_SEMI,
  [105584] = 8,
    ACTIONS(2985), 1,
      anon_sym_and,
    ACTIONS(2987), 1,
      anon_sym_or,
    ACTIONS(3009), 1,
      anon_sym_as,
    ACTIONS(3011), 1,
      anon_sym_if,
    ACTIONS(3303), 1,
      anon_sym_COMMA,
    STATE(2174), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3313), 2,
      sym__newline,
      anon_sym_SEMI,
  [105611] = 9,
    ACTIONS(3204), 1,
      anon_sym_as,
    ACTIONS(3206), 1,
      anon_sym_if,
    ACTIONS(3208), 1,
      anon_sym_and,
    ACTIONS(3210), 1,
      anon_sym_or,
    ACTIONS(3264), 1,
      anon_sym_COLON,
    ACTIONS(3315), 1,
      anon_sym_COMMA,
    ACTIONS(3317), 1,
      anon_sym_RBRACK,
    STATE(2398), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [105640] = 9,
    ACTIONS(3204), 1,
      anon_sym_as,
    ACTIONS(3206), 1,
      anon_sym_if,
    ACTIONS(3208), 1,
      anon_sym_and,
    ACTIONS(3210), 1,
      anon_sym_or,
    ACTIONS(3264), 1,
      anon_sym_COLON,
    ACTIONS(3319), 1,
      anon_sym_COMMA,
    ACTIONS(3321), 1,
      anon_sym_RBRACK,
    STATE(2357), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [105669] = 4,
    ACTIONS(3050), 1,
      anon_sym_and,
    ACTIONS(3198), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3020), 6,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_or,
  [105688] = 8,
    ACTIONS(2985), 1,
      anon_sym_and,
    ACTIONS(2987), 1,
      anon_sym_or,
    ACTIONS(3009), 1,
      anon_sym_as,
    ACTIONS(3011), 1,
      anon_sym_if,
    ACTIONS(3240), 1,
      anon_sym_COMMA,
    STATE(2092), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3323), 2,
      sym__newline,
      anon_sym_SEMI,
  [105715] = 5,
    ACTIONS(2991), 1,
      anon_sym_as,
    ACTIONS(3003), 1,
      anon_sym_and,
    ACTIONS(3005), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3250), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [105736] = 5,
    ACTIONS(3036), 1,
      anon_sym_and,
    ACTIONS(3038), 1,
      anon_sym_or,
    ACTIONS(3325), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3015), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [105757] = 5,
    ACTIONS(3028), 1,
      anon_sym_as,
    ACTIONS(3036), 1,
      anon_sym_and,
    ACTIONS(3038), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3250), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [105778] = 6,
    ACTIONS(2985), 1,
      anon_sym_and,
    ACTIONS(2987), 1,
      anon_sym_or,
    ACTIONS(3009), 1,
      anon_sym_as,
    ACTIONS(3011), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3242), 4,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
  [105801] = 7,
    ACTIONS(1466), 1,
      anon_sym_except_STAR,
    ACTIONS(1470), 1,
      anon_sym_except,
    ACTIONS(3328), 1,
      anon_sym_finally,
    STATE(775), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(551), 2,
      sym_except_clause,
      aux_sym_try_statement_repeat1,
    STATE(554), 2,
      sym_except_group_clause,
      aux_sym_try_statement_repeat2,
  [105826] = 6,
    ACTIONS(2991), 1,
      anon_sym_as,
    ACTIONS(2993), 1,
      anon_sym_if,
    ACTIONS(3003), 1,
      anon_sym_and,
    ACTIONS(3005), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3330), 4,
      anon_sym_COMMA,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [105849] = 7,
    ACTIONS(1466), 1,
      anon_sym_except_STAR,
    ACTIONS(1470), 1,
      anon_sym_except,
    ACTIONS(3328), 1,
      anon_sym_finally,
    STATE(741), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(485), 2,
      sym_except_group_clause,
      aux_sym_try_statement_repeat2,
    STATE(486), 2,
      sym_except_clause,
      aux_sym_try_statement_repeat1,
  [105874] = 3,
    ACTIONS(3198), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3020), 7,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [105891] = 5,
    ACTIONS(3036), 1,
      anon_sym_and,
    ACTIONS(3038), 1,
      anon_sym_or,
    ACTIONS(3232), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2983), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [105912] = 9,
    ACTIONS(3204), 1,
      anon_sym_as,
    ACTIONS(3206), 1,
      anon_sym_if,
    ACTIONS(3208), 1,
      anon_sym_and,
    ACTIONS(3210), 1,
      anon_sym_or,
    ACTIONS(3264), 1,
      anon_sym_COLON,
    ACTIONS(3332), 1,
      anon_sym_COMMA,
    ACTIONS(3334), 1,
      anon_sym_RBRACK,
    STATE(2406), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [105941] = 5,
    ACTIONS(3042), 1,
      anon_sym_as,
    ACTIONS(3050), 1,
      anon_sym_and,
    ACTIONS(3052), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3250), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [105962] = 6,
    ACTIONS(3028), 1,
      anon_sym_as,
    ACTIONS(3030), 1,
      anon_sym_if,
    ACTIONS(3036), 1,
      anon_sym_and,
    ACTIONS(3038), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3007), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_async,
      anon_sym_for,
  [105985] = 8,
    ACTIONS(2985), 1,
      anon_sym_and,
    ACTIONS(2987), 1,
      anon_sym_or,
    ACTIONS(3009), 1,
      anon_sym_as,
    ACTIONS(3011), 1,
      anon_sym_if,
    ACTIONS(3240), 1,
      anon_sym_COMMA,
    STATE(2092), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2947), 2,
      sym__newline,
      anon_sym_SEMI,
  [106012] = 5,
    ACTIONS(3028), 1,
      anon_sym_as,
    ACTIONS(3036), 1,
      anon_sym_and,
    ACTIONS(3038), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3250), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [106033] = 3,
    ACTIONS(3198), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3020), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_and,
      anon_sym_or,
  [106050] = 4,
    ACTIONS(3036), 1,
      anon_sym_and,
    ACTIONS(3198), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3020), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_or,
  [106069] = 9,
    ACTIONS(3204), 1,
      anon_sym_as,
    ACTIONS(3206), 1,
      anon_sym_if,
    ACTIONS(3208), 1,
      anon_sym_and,
    ACTIONS(3210), 1,
      anon_sym_or,
    ACTIONS(3264), 1,
      anon_sym_COLON,
    ACTIONS(3336), 1,
      anon_sym_COMMA,
    ACTIONS(3338), 1,
      anon_sym_RBRACK,
    STATE(2368), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [106098] = 5,
    ACTIONS(2991), 1,
      anon_sym_as,
    ACTIONS(3003), 1,
      anon_sym_and,
    ACTIONS(3005), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3250), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [106119] = 8,
    ACTIONS(2997), 1,
      anon_sym_async,
    ACTIONS(2999), 1,
      anon_sym_for,
    ACTIONS(3340), 1,
      anon_sym_COMMA,
    ACTIONS(3342), 1,
      anon_sym_RBRACE,
    STATE(1858), 1,
      sym_for_in_clause,
    STATE(2477), 1,
      aux_sym_dictionary_repeat1,
    STATE(2757), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [106145] = 6,
    ACTIONS(3032), 1,
      anon_sym_async,
    ACTIONS(3034), 1,
      anon_sym_for,
    ACTIONS(3344), 1,
      anon_sym_RPAREN,
    ACTIONS(3346), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1856), 3,
      sym_for_in_clause,
      sym_if_clause,
      aux_sym__comprehension_clauses_repeat1,
  [106167] = 6,
    ACTIONS(3032), 1,
      anon_sym_async,
    ACTIONS(3034), 1,
      anon_sym_for,
    ACTIONS(3346), 1,
      anon_sym_if,
    ACTIONS(3348), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1893), 3,
      sym_for_in_clause,
      sym_if_clause,
      aux_sym__comprehension_clauses_repeat1,
  [106189] = 6,
    ACTIONS(3046), 1,
      anon_sym_async,
    ACTIONS(3048), 1,
      anon_sym_for,
    ACTIONS(3344), 1,
      anon_sym_RBRACK,
    ACTIONS(3350), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1898), 3,
      sym_for_in_clause,
      sym_if_clause,
      aux_sym__comprehension_clauses_repeat1,
  [106211] = 6,
    ACTIONS(2997), 1,
      anon_sym_async,
    ACTIONS(2999), 1,
      anon_sym_for,
    ACTIONS(3344), 1,
      anon_sym_RBRACE,
    ACTIONS(3352), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1880), 3,
      sym_for_in_clause,
      sym_if_clause,
      aux_sym__comprehension_clauses_repeat1,
  [106233] = 4,
    ACTIONS(3256), 1,
      anon_sym_DOT,
    STATE(1861), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3212), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [106251] = 6,
    ACTIONS(2985), 1,
      anon_sym_and,
    ACTIONS(2987), 1,
      anon_sym_or,
    ACTIONS(3009), 1,
      anon_sym_as,
    ACTIONS(3011), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3354), 3,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [106273] = 4,
    ACTIONS(3256), 1,
      anon_sym_DOT,
    STATE(1864), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3200), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [106291] = 8,
    ACTIONS(2997), 1,
      anon_sym_async,
    ACTIONS(2999), 1,
      anon_sym_for,
    ACTIONS(3356), 1,
      anon_sym_COMMA,
    ACTIONS(3358), 1,
      anon_sym_RBRACE,
    STATE(1858), 1,
      sym_for_in_clause,
    STATE(2282), 1,
      aux_sym_dictionary_repeat1,
    STATE(2746), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [106317] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3365), 1,
      sym__not_escape_sequence,
    STATE(1863), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(3360), 2,
      sym_string_end,
      anon_sym_LBRACE,
    ACTIONS(3362), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
  [106339] = 4,
    ACTIONS(3368), 1,
      anon_sym_DOT,
    STATE(1864), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3222), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [106357] = 8,
    ACTIONS(2997), 1,
      anon_sym_async,
    ACTIONS(2999), 1,
      anon_sym_for,
    ACTIONS(3371), 1,
      anon_sym_COMMA,
    ACTIONS(3373), 1,
      anon_sym_RBRACE,
    STATE(1858), 1,
      sym_for_in_clause,
    STATE(2461), 1,
      aux_sym_dictionary_repeat1,
    STATE(2700), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [106383] = 8,
    ACTIONS(3169), 1,
      anon_sym_as,
    ACTIONS(3171), 1,
      anon_sym_if,
    ACTIONS(3173), 1,
      anon_sym_and,
    ACTIONS(3175), 1,
      anon_sym_or,
    ACTIONS(3375), 1,
      anon_sym_COMMA,
    ACTIONS(3377), 1,
      anon_sym_COLON,
    STATE(2362), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [106409] = 4,
    ACTIONS(770), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(997), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(3260), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [106427] = 7,
    ACTIONS(1354), 1,
      anon_sym_COLON,
    ACTIONS(3204), 1,
      anon_sym_as,
    ACTIONS(3206), 1,
      anon_sym_if,
    ACTIONS(3208), 1,
      anon_sym_and,
    ACTIONS(3210), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1352), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [106451] = 4,
    ACTIONS(3379), 1,
      anon_sym_DOT,
    STATE(1869), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3222), 5,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [106469] = 4,
    ACTIONS(3252), 1,
      anon_sym_DOT,
    STATE(1902), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3212), 5,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [106487] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3382), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3260), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [106503] = 8,
    ACTIONS(2997), 1,
      anon_sym_async,
    ACTIONS(2999), 1,
      anon_sym_for,
    ACTIONS(3384), 1,
      anon_sym_COMMA,
    ACTIONS(3386), 1,
      anon_sym_RBRACE,
    STATE(1858), 1,
      sym_for_in_clause,
    STATE(2385), 1,
      aux_sym_dictionary_repeat1,
    STATE(2656), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [106529] = 8,
    ACTIONS(3169), 1,
      anon_sym_as,
    ACTIONS(3171), 1,
      anon_sym_if,
    ACTIONS(3173), 1,
      anon_sym_and,
    ACTIONS(3175), 1,
      anon_sym_or,
    ACTIONS(3375), 1,
      anon_sym_COMMA,
    ACTIONS(3388), 1,
      anon_sym_COLON,
    STATE(2362), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [106555] = 8,
    ACTIONS(3112), 1,
      anon_sym_and,
    ACTIONS(3114), 1,
      anon_sym_or,
    ACTIONS(3116), 1,
      anon_sym_as,
    ACTIONS(3118), 1,
      anon_sym_if,
    ACTIONS(3136), 1,
      anon_sym_RPAREN,
    ACTIONS(3390), 1,
      anon_sym_COMMA,
    STATE(2270), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [106581] = 7,
    ACTIONS(2729), 1,
      sym_identifier,
    ACTIONS(3392), 1,
      anon_sym_DOT,
    ACTIONS(3394), 1,
      anon_sym___future__,
    STATE(2239), 1,
      aux_sym_import_prefix_repeat1,
    STATE(2273), 1,
      sym_import_prefix,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2769), 2,
      sym_relative_import,
      sym_dotted_name,
  [106605] = 6,
    ACTIONS(3396), 1,
      anon_sym_if,
    ACTIONS(3399), 1,
      anon_sym_async,
    ACTIONS(3402), 1,
      anon_sym_for,
    ACTIONS(3405), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1876), 3,
      sym_for_in_clause,
      sym_if_clause,
      aux_sym__comprehension_clauses_repeat1,
  [106627] = 5,
    ACTIONS(3042), 1,
      anon_sym_as,
    ACTIONS(3050), 1,
      anon_sym_and,
    ACTIONS(3052), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3407), 4,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [106647] = 4,
    ACTIONS(3409), 1,
      anon_sym_DOT,
    STATE(1878), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3222), 5,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [106665] = 7,
    ACTIONS(3204), 1,
      anon_sym_as,
    ACTIONS(3206), 1,
      anon_sym_if,
    ACTIONS(3208), 1,
      anon_sym_and,
    ACTIONS(3210), 1,
      anon_sym_or,
    ACTIONS(3412), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1428), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [106689] = 6,
    ACTIONS(2997), 1,
      anon_sym_async,
    ACTIONS(2999), 1,
      anon_sym_for,
    ACTIONS(3348), 1,
      anon_sym_RBRACE,
    ACTIONS(3352), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1905), 3,
      sym_for_in_clause,
      sym_if_clause,
      aux_sym__comprehension_clauses_repeat1,
  [106711] = 7,
    ACTIONS(3204), 1,
      anon_sym_as,
    ACTIONS(3206), 1,
      anon_sym_if,
    ACTIONS(3208), 1,
      anon_sym_and,
    ACTIONS(3210), 1,
      anon_sym_or,
    ACTIONS(3264), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3414), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [106735] = 8,
    ACTIONS(3136), 1,
      anon_sym_RBRACK,
    ACTIONS(3204), 1,
      anon_sym_as,
    ACTIONS(3206), 1,
      anon_sym_if,
    ACTIONS(3208), 1,
      anon_sym_and,
    ACTIONS(3210), 1,
      anon_sym_or,
    ACTIONS(3416), 1,
      anon_sym_COMMA,
    STATE(2306), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [106761] = 4,
    ACTIONS(3244), 1,
      anon_sym_DOT,
    STATE(1904), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3212), 5,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [106779] = 8,
    ACTIONS(3169), 1,
      anon_sym_as,
    ACTIONS(3171), 1,
      anon_sym_if,
    ACTIONS(3173), 1,
      anon_sym_and,
    ACTIONS(3175), 1,
      anon_sym_or,
    ACTIONS(3375), 1,
      anon_sym_COMMA,
    ACTIONS(3418), 1,
      anon_sym_COLON,
    STATE(2362), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [106805] = 8,
    ACTIONS(3169), 1,
      anon_sym_as,
    ACTIONS(3171), 1,
      anon_sym_if,
    ACTIONS(3173), 1,
      anon_sym_and,
    ACTIONS(3175), 1,
      anon_sym_or,
    ACTIONS(3420), 1,
      anon_sym_COMMA,
    ACTIONS(3422), 1,
      anon_sym_COLON,
    STATE(2501), 1,
      aux_sym_match_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [106831] = 8,
    ACTIONS(3424), 1,
      sym_identifier,
    ACTIONS(3426), 1,
      anon_sym_LPAREN,
    ACTIONS(3428), 1,
      anon_sym_STAR,
    STATE(2021), 1,
      sym_dotted_name,
    STATE(2242), 1,
      sym_aliased_import,
    STATE(2519), 1,
      sym__import_list,
    STATE(2594), 1,
      sym_wildcard_import,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [106857] = 5,
    ACTIONS(2991), 1,
      anon_sym_as,
    ACTIONS(3003), 1,
      anon_sym_and,
    ACTIONS(3005), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3407), 4,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [106877] = 8,
    ACTIONS(3169), 1,
      anon_sym_as,
    ACTIONS(3171), 1,
      anon_sym_if,
    ACTIONS(3173), 1,
      anon_sym_and,
    ACTIONS(3175), 1,
      anon_sym_or,
    ACTIONS(3430), 1,
      anon_sym_COMMA,
    ACTIONS(3432), 1,
      anon_sym_COLON,
    STATE(2468), 1,
      aux_sym_match_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [106903] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3436), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3434), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [106919] = 5,
    ACTIONS(3028), 1,
      anon_sym_as,
    ACTIONS(3036), 1,
      anon_sym_and,
    ACTIONS(3038), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3407), 4,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [106939] = 8,
    ACTIONS(2997), 1,
      anon_sym_async,
    ACTIONS(2999), 1,
      anon_sym_for,
    ACTIONS(3438), 1,
      anon_sym_COMMA,
    ACTIONS(3440), 1,
      anon_sym_RBRACE,
    STATE(1858), 1,
      sym_for_in_clause,
    STATE(2410), 1,
      aux_sym_dictionary_repeat1,
    STATE(2644), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [106965] = 8,
    ACTIONS(2997), 1,
      anon_sym_async,
    ACTIONS(2999), 1,
      anon_sym_for,
    ACTIONS(3442), 1,
      anon_sym_COMMA,
    ACTIONS(3444), 1,
      anon_sym_RBRACE,
    STATE(1858), 1,
      sym_for_in_clause,
    STATE(2411), 1,
      aux_sym_dictionary_repeat1,
    STATE(2646), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [106991] = 6,
    ACTIONS(3405), 1,
      anon_sym_RPAREN,
    ACTIONS(3446), 1,
      anon_sym_if,
    ACTIONS(3449), 1,
      anon_sym_async,
    ACTIONS(3452), 1,
      anon_sym_for,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1893), 3,
      sym_for_in_clause,
      sym_if_clause,
      aux_sym__comprehension_clauses_repeat1,
  [107013] = 8,
    ACTIONS(2997), 1,
      anon_sym_async,
    ACTIONS(2999), 1,
      anon_sym_for,
    ACTIONS(3455), 1,
      anon_sym_COMMA,
    ACTIONS(3457), 1,
      anon_sym_RBRACE,
    STATE(1858), 1,
      sym_for_in_clause,
    STATE(2504), 1,
      aux_sym_dictionary_repeat1,
    STATE(2779), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [107039] = 4,
    ACTIONS(702), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(990), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(3260), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [107057] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3463), 1,
      sym__not_escape_sequence,
    STATE(1863), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(3459), 2,
      sym_string_end,
      anon_sym_LBRACE,
    ACTIONS(3461), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
  [107079] = 6,
    ACTIONS(2985), 1,
      anon_sym_and,
    ACTIONS(2987), 1,
      anon_sym_or,
    ACTIONS(3009), 1,
      anon_sym_as,
    ACTIONS(3011), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3465), 3,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [107101] = 6,
    ACTIONS(3046), 1,
      anon_sym_async,
    ACTIONS(3048), 1,
      anon_sym_for,
    ACTIONS(3348), 1,
      anon_sym_RBRACK,
    ACTIONS(3350), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1876), 3,
      sym_for_in_clause,
      sym_if_clause,
      aux_sym__comprehension_clauses_repeat1,
  [107123] = 8,
    ACTIONS(3169), 1,
      anon_sym_as,
    ACTIONS(3171), 1,
      anon_sym_if,
    ACTIONS(3173), 1,
      anon_sym_and,
    ACTIONS(3175), 1,
      anon_sym_or,
    ACTIONS(3375), 1,
      anon_sym_COMMA,
    ACTIONS(3467), 1,
      anon_sym_COLON,
    STATE(2362), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [107149] = 8,
    ACTIONS(2997), 1,
      anon_sym_async,
    ACTIONS(2999), 1,
      anon_sym_for,
    ACTIONS(3469), 1,
      anon_sym_COMMA,
    ACTIONS(3471), 1,
      anon_sym_RBRACE,
    STATE(1858), 1,
      sym_for_in_clause,
    STATE(2453), 1,
      aux_sym_dictionary_repeat1,
    STATE(2662), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [107175] = 8,
    ACTIONS(3085), 1,
      anon_sym_RPAREN,
    ACTIONS(3087), 1,
      anon_sym_COMMA,
    ACTIONS(3112), 1,
      anon_sym_and,
    ACTIONS(3114), 1,
      anon_sym_or,
    ACTIONS(3116), 1,
      anon_sym_as,
    ACTIONS(3118), 1,
      anon_sym_if,
    STATE(2299), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [107201] = 4,
    ACTIONS(3252), 1,
      anon_sym_DOT,
    STATE(1878), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3200), 5,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [107219] = 4,
    ACTIONS(814), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1150), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(3260), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [107237] = 4,
    ACTIONS(3244), 1,
      anon_sym_DOT,
    STATE(1869), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3200), 5,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [107255] = 6,
    ACTIONS(3405), 1,
      anon_sym_RBRACE,
    ACTIONS(3473), 1,
      anon_sym_if,
    ACTIONS(3476), 1,
      anon_sym_async,
    ACTIONS(3479), 1,
      anon_sym_for,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1905), 3,
      sym_for_in_clause,
      sym_if_clause,
      aux_sym__comprehension_clauses_repeat1,
  [107277] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3482), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3434), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [107292] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3484), 6,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [107305] = 6,
    ACTIONS(3169), 1,
      anon_sym_as,
    ACTIONS(3171), 1,
      anon_sym_if,
    ACTIONS(3173), 1,
      anon_sym_and,
    ACTIONS(3175), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3486), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [107326] = 7,
    ACTIONS(3171), 1,
      anon_sym_if,
    ACTIONS(3173), 1,
      anon_sym_and,
    ACTIONS(3175), 1,
      anon_sym_or,
    ACTIONS(3488), 1,
      anon_sym_COMMA,
    ACTIONS(3490), 1,
      anon_sym_as,
    ACTIONS(3492), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [107349] = 4,
    ACTIONS(3496), 1,
      anon_sym_COMMA,
    STATE(1910), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3494), 4,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [107366] = 6,
    ACTIONS(3204), 1,
      anon_sym_as,
    ACTIONS(3206), 1,
      anon_sym_if,
    ACTIONS(3208), 1,
      anon_sym_and,
    ACTIONS(3210), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3499), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [107387] = 4,
    ACTIONS(3503), 1,
      anon_sym_COMMA,
    STATE(1910), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3501), 4,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [107404] = 6,
    ACTIONS(3204), 1,
      anon_sym_as,
    ACTIONS(3206), 1,
      anon_sym_if,
    ACTIONS(3208), 1,
      anon_sym_and,
    ACTIONS(3210), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3505), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [107425] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3507), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3260), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [107440] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3509), 6,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [107453] = 4,
    ACTIONS(3511), 1,
      anon_sym_DOT,
    STATE(1916), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3222), 4,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
  [107470] = 7,
    ACTIONS(3514), 1,
      anon_sym_DOT,
    ACTIONS(3516), 1,
      anon_sym_COMMA,
    ACTIONS(3518), 1,
      anon_sym_COLON,
    ACTIONS(3520), 1,
      anon_sym_RBRACK,
    ACTIONS(3522), 1,
      anon_sym_PIPE,
    STATE(2307), 1,
      aux_sym_type_parameter_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [107493] = 6,
    ACTIONS(3204), 1,
      anon_sym_as,
    ACTIONS(3206), 1,
      anon_sym_if,
    ACTIONS(3208), 1,
      anon_sym_and,
    ACTIONS(3210), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3524), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [107514] = 4,
    ACTIONS(3173), 1,
      anon_sym_and,
    ACTIONS(3175), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2983), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
  [107531] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3526), 6,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [107544] = 7,
    ACTIONS(3514), 1,
      anon_sym_DOT,
    ACTIONS(3516), 1,
      anon_sym_COMMA,
    ACTIONS(3518), 1,
      anon_sym_COLON,
    ACTIONS(3522), 1,
      anon_sym_PIPE,
    ACTIONS(3528), 1,
      anon_sym_RBRACK,
    STATE(2505), 1,
      aux_sym_type_parameter_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [107567] = 6,
    ACTIONS(2985), 1,
      anon_sym_and,
    ACTIONS(2987), 1,
      anon_sym_or,
    ACTIONS(3009), 1,
      anon_sym_as,
    ACTIONS(3011), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3530), 2,
      sym__newline,
      anon_sym_SEMI,
  [107588] = 5,
    ACTIONS(3534), 1,
      anon_sym_DOT,
    ACTIONS(3536), 1,
      anon_sym_COLON,
    ACTIONS(3538), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3532), 3,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_EQ,
  [107607] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3540), 6,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [107620] = 6,
    ACTIONS(3132), 1,
      anon_sym_as,
    ACTIONS(3134), 1,
      anon_sym_if,
    ACTIONS(3138), 1,
      anon_sym_and,
    ACTIONS(3140), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3330), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [107641] = 4,
    ACTIONS(3544), 1,
      anon_sym_PIPE,
    STATE(1983), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3542), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
  [107658] = 6,
    ACTIONS(3546), 1,
      anon_sym_DOT,
    ACTIONS(3550), 1,
      anon_sym_COLON,
    ACTIONS(3552), 1,
      anon_sym_EQ,
    ACTIONS(3554), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3548), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [107679] = 6,
    ACTIONS(3169), 1,
      anon_sym_as,
    ACTIONS(3171), 1,
      anon_sym_if,
    ACTIONS(3173), 1,
      anon_sym_and,
    ACTIONS(3175), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3556), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [107700] = 6,
    ACTIONS(3112), 1,
      anon_sym_and,
    ACTIONS(3114), 1,
      anon_sym_or,
    ACTIONS(3116), 1,
      anon_sym_as,
    ACTIONS(3118), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3558), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [107721] = 4,
    ACTIONS(3560), 1,
      anon_sym_COMMA,
    STATE(1934), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(970), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [107738] = 4,
    ACTIONS(3562), 1,
      anon_sym_COMMA,
    STATE(1951), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3564), 4,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [107755] = 4,
    ACTIONS(3566), 1,
      anon_sym_COMMA,
    STATE(1970), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3568), 4,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [107772] = 6,
    ACTIONS(3112), 1,
      anon_sym_and,
    ACTIONS(3114), 1,
      anon_sym_or,
    ACTIONS(3116), 1,
      anon_sym_as,
    ACTIONS(3118), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3499), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [107793] = 4,
    ACTIONS(3570), 1,
      anon_sym_COMMA,
    STATE(1934), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2887), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [107810] = 6,
    ACTIONS(3112), 1,
      anon_sym_and,
    ACTIONS(3114), 1,
      anon_sym_or,
    ACTIONS(3116), 1,
      anon_sym_as,
    ACTIONS(3118), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3573), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [107831] = 4,
    ACTIONS(3575), 1,
      anon_sym_DOT,
    STATE(1962), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3212), 4,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
  [107848] = 6,
    ACTIONS(3169), 1,
      anon_sym_as,
    ACTIONS(3171), 1,
      anon_sym_if,
    ACTIONS(3173), 1,
      anon_sym_and,
    ACTIONS(3175), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3242), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [107869] = 6,
    ACTIONS(3112), 1,
      anon_sym_and,
    ACTIONS(3114), 1,
      anon_sym_or,
    ACTIONS(3116), 1,
      anon_sym_as,
    ACTIONS(3118), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3577), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [107890] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3579), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3260), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [107905] = 7,
    ACTIONS(3514), 1,
      anon_sym_DOT,
    ACTIONS(3516), 1,
      anon_sym_COMMA,
    ACTIONS(3518), 1,
      anon_sym_COLON,
    ACTIONS(3522), 1,
      anon_sym_PIPE,
    ACTIONS(3581), 1,
      anon_sym_RBRACK,
    STATE(2364), 1,
      aux_sym_type_parameter_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [107928] = 6,
    ACTIONS(3112), 1,
      anon_sym_and,
    ACTIONS(3114), 1,
      anon_sym_or,
    ACTIONS(3116), 1,
      anon_sym_as,
    ACTIONS(3118), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3524), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [107949] = 6,
    ACTIONS(3132), 1,
      anon_sym_as,
    ACTIONS(3134), 1,
      anon_sym_if,
    ACTIONS(3138), 1,
      anon_sym_and,
    ACTIONS(3140), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3583), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [107970] = 6,
    ACTIONS(3112), 1,
      anon_sym_and,
    ACTIONS(3114), 1,
      anon_sym_or,
    ACTIONS(3116), 1,
      anon_sym_as,
    ACTIONS(3118), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3585), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [107991] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3589), 1,
      sym__not_escape_sequence,
    ACTIONS(3587), 5,
      sym__string_content,
      sym_escape_interpolation,
      sym_string_end,
      anon_sym_LBRACE,
      sym_escape_sequence,
  [108008] = 4,
    ACTIONS(3593), 1,
      anon_sym_COMMA,
    STATE(1910), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3591), 4,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [108025] = 4,
    ACTIONS(3595), 1,
      anon_sym_COMMA,
    STATE(2004), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3591), 4,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [108042] = 4,
    ACTIONS(3597), 1,
      anon_sym_COMMA,
    STATE(1912), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3568), 4,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [108059] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3601), 1,
      sym__not_escape_sequence,
    ACTIONS(3599), 5,
      sym__string_content,
      sym_escape_interpolation,
      sym_string_end,
      anon_sym_LBRACE,
      sym_escape_sequence,
  [108076] = 6,
    ACTIONS(3204), 1,
      anon_sym_as,
    ACTIONS(3206), 1,
      anon_sym_if,
    ACTIONS(3208), 1,
      anon_sym_and,
    ACTIONS(3210), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1418), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [108097] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3605), 1,
      sym__not_escape_sequence,
    ACTIONS(3603), 5,
      sym__string_content,
      sym_escape_interpolation,
      sym_string_end,
      anon_sym_LBRACE,
      sym_escape_sequence,
  [108114] = 4,
    ACTIONS(3607), 1,
      anon_sym_COMMA,
    STATE(1985), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3591), 4,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [108131] = 6,
    ACTIONS(3204), 1,
      anon_sym_as,
    ACTIONS(3206), 1,
      anon_sym_if,
    ACTIONS(3208), 1,
      anon_sym_and,
    ACTIONS(3210), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1428), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [108152] = 4,
    ACTIONS(3544), 1,
      anon_sym_PIPE,
    STATE(1926), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3609), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
  [108169] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3611), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3434), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [108184] = 4,
    ACTIONS(3613), 1,
      anon_sym_COMMA,
    STATE(1955), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3242), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [108201] = 7,
    ACTIONS(3514), 1,
      anon_sym_DOT,
    ACTIONS(3516), 1,
      anon_sym_COMMA,
    ACTIONS(3518), 1,
      anon_sym_COLON,
    ACTIONS(3522), 1,
      anon_sym_PIPE,
    ACTIONS(3616), 1,
      anon_sym_RBRACK,
    STATE(2408), 1,
      aux_sym_type_parameter_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [108224] = 6,
    ACTIONS(3204), 1,
      anon_sym_as,
    ACTIONS(3206), 1,
      anon_sym_if,
    ACTIONS(3208), 1,
      anon_sym_and,
    ACTIONS(3210), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3234), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [108245] = 4,
    ACTIONS(3618), 1,
      anon_sym_COMMA,
    STATE(1965), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3568), 4,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [108262] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3222), 6,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [108275] = 4,
    ACTIONS(3620), 1,
      anon_sym_COMMA,
    STATE(1946), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3564), 4,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [108292] = 6,
    ACTIONS(3169), 1,
      anon_sym_as,
    ACTIONS(3171), 1,
      anon_sym_if,
    ACTIONS(3173), 1,
      anon_sym_and,
    ACTIONS(3175), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3622), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [108313] = 4,
    ACTIONS(3575), 1,
      anon_sym_DOT,
    STATE(1916), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3200), 4,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
  [108330] = 6,
    ACTIONS(3112), 1,
      anon_sym_and,
    ACTIONS(3114), 1,
      anon_sym_or,
    ACTIONS(3116), 1,
      anon_sym_as,
    ACTIONS(3118), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3556), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [108351] = 6,
    ACTIONS(3132), 1,
      anon_sym_as,
    ACTIONS(3134), 1,
      anon_sym_if,
    ACTIONS(3138), 1,
      anon_sym_and,
    ACTIONS(3140), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3499), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [108372] = 4,
    ACTIONS(3624), 1,
      anon_sym_COMMA,
    STATE(1985), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3501), 4,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [108389] = 6,
    ACTIONS(3112), 1,
      anon_sym_and,
    ACTIONS(3114), 1,
      anon_sym_or,
    ACTIONS(3116), 1,
      anon_sym_as,
    ACTIONS(3118), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3242), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [108410] = 6,
    ACTIONS(2985), 1,
      anon_sym_and,
    ACTIONS(2987), 1,
      anon_sym_or,
    ACTIONS(3009), 1,
      anon_sym_as,
    ACTIONS(3011), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3234), 2,
      sym__newline,
      anon_sym_SEMI,
  [108431] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3628), 1,
      sym__not_escape_sequence,
    ACTIONS(3626), 5,
      sym__string_content,
      sym_escape_interpolation,
      sym_string_end,
      anon_sym_LBRACE,
      sym_escape_sequence,
  [108448] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3509), 6,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [108461] = 4,
    ACTIONS(3630), 1,
      anon_sym_COMMA,
    STATE(2004), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3501), 4,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [108478] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3484), 6,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [108491] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3632), 6,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [108504] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3222), 6,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [108517] = 4,
    ACTIONS(3544), 1,
      anon_sym_PIPE,
    STATE(1926), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3634), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
  [108534] = 7,
    ACTIONS(3636), 1,
      anon_sym_COMMA,
    ACTIONS(3638), 1,
      anon_sym_as,
    ACTIONS(3640), 1,
      anon_sym_if,
    ACTIONS(3642), 1,
      anon_sym_COLON,
    STATE(2102), 1,
      aux_sym_case_clause_repeat1,
    STATE(2664), 1,
      sym_if_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [108557] = 3,
    ACTIONS(3644), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3260), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [108572] = 6,
    ACTIONS(3112), 1,
      anon_sym_and,
    ACTIONS(3114), 1,
      anon_sym_or,
    ACTIONS(3116), 1,
      anon_sym_as,
    ACTIONS(3118), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3486), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [108593] = 6,
    ACTIONS(3112), 1,
      anon_sym_and,
    ACTIONS(3114), 1,
      anon_sym_or,
    ACTIONS(3116), 1,
      anon_sym_as,
    ACTIONS(3118), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3234), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [108614] = 6,
    ACTIONS(3534), 1,
      anon_sym_DOT,
    ACTIONS(3536), 1,
      anon_sym_COLON,
    ACTIONS(3538), 1,
      anon_sym_PIPE,
    ACTIONS(3648), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3646), 2,
      sym__newline,
      anon_sym_SEMI,
  [108635] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1609), 6,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [108648] = 3,
    STATE(1926), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3650), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [108663] = 4,
    ACTIONS(3654), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1982), 2,
      sym_decorator,
      aux_sym_decorated_definition_repeat1,
    ACTIONS(3652), 3,
      anon_sym_async,
      anon_sym_def,
      anon_sym_class,
  [108680] = 4,
    ACTIONS(3657), 1,
      anon_sym_PIPE,
    STATE(1983), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3650), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
  [108697] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3075), 6,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [108710] = 4,
    ACTIONS(3660), 1,
      anon_sym_COMMA,
    STATE(1985), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3494), 4,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [108727] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3526), 6,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [108740] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3665), 1,
      sym__not_escape_sequence,
    ACTIONS(3663), 5,
      sym__string_content,
      sym_escape_interpolation,
      sym_string_end,
      anon_sym_LBRACE,
      sym_escape_sequence,
  [108757] = 6,
    ACTIONS(3204), 1,
      anon_sym_as,
    ACTIONS(3206), 1,
      anon_sym_if,
    ACTIONS(3208), 1,
      anon_sym_and,
    ACTIONS(3210), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3242), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [108778] = 5,
    ACTIONS(3546), 1,
      anon_sym_DOT,
    ACTIONS(3550), 1,
      anon_sym_COLON,
    ACTIONS(3554), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3532), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
  [108797] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3540), 6,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [108810] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3669), 1,
      sym__not_escape_sequence,
    ACTIONS(3667), 5,
      sym__string_content,
      sym_escape_interpolation,
      sym_string_end,
      anon_sym_LBRACE,
      sym_escape_sequence,
  [108827] = 7,
    ACTIONS(3171), 1,
      anon_sym_if,
    ACTIONS(3173), 1,
      anon_sym_and,
    ACTIONS(3175), 1,
      anon_sym_or,
    ACTIONS(3490), 1,
      anon_sym_as,
    ACTIONS(3671), 1,
      anon_sym_COMMA,
    ACTIONS(3673), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [108850] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3677), 1,
      sym__not_escape_sequence,
    ACTIONS(3675), 5,
      sym__string_content,
      sym_escape_interpolation,
      sym_string_end,
      anon_sym_LBRACE,
      sym_escape_sequence,
  [108867] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3681), 1,
      sym__not_escape_sequence,
    ACTIONS(3679), 5,
      sym__string_content,
      sym_escape_interpolation,
      sym_string_end,
      anon_sym_LBRACE,
      sym_escape_sequence,
  [108884] = 6,
    ACTIONS(2985), 1,
      anon_sym_and,
    ACTIONS(2987), 1,
      anon_sym_or,
    ACTIONS(3009), 1,
      anon_sym_as,
    ACTIONS(3011), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3683), 2,
      sym__newline,
      anon_sym_SEMI,
  [108905] = 4,
    ACTIONS(3685), 1,
      anon_sym_COMMA,
    STATE(1945), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3564), 4,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [108922] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3222), 6,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [108935] = 6,
    ACTIONS(3169), 1,
      anon_sym_as,
    ACTIONS(3171), 1,
      anon_sym_if,
    ACTIONS(3173), 1,
      anon_sym_and,
    ACTIONS(3175), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3558), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [108956] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3687), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3260), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [108971] = 6,
    ACTIONS(3112), 1,
      anon_sym_and,
    ACTIONS(3114), 1,
      anon_sym_or,
    ACTIONS(3116), 1,
      anon_sym_as,
    ACTIONS(3118), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3583), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [108992] = 6,
    ACTIONS(3132), 1,
      anon_sym_as,
    ACTIONS(3134), 1,
      anon_sym_if,
    ACTIONS(3138), 1,
      anon_sym_and,
    ACTIONS(3140), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3524), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [109013] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3632), 6,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [109026] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3509), 6,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [109039] = 4,
    ACTIONS(3689), 1,
      anon_sym_COMMA,
    STATE(2004), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3494), 4,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [109056] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1609), 6,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [109069] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3075), 6,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [109082] = 4,
    ACTIONS(3692), 1,
      anon_sym_COMMA,
    STATE(1955), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1276), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [109099] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3694), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3434), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [109114] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3484), 6,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [109127] = 4,
    ACTIONS(3696), 1,
      anon_sym_PIPE,
    STATE(2010), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3650), 3,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
  [109143] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3509), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [109155] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3494), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [109167] = 5,
    ACTIONS(3424), 1,
      sym_identifier,
    STATE(2244), 1,
      sym_dotted_name,
    STATE(2296), 1,
      sym_aliased_import,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3699), 2,
      sym__newline,
      anon_sym_SEMI,
  [109185] = 6,
    ACTIONS(3169), 1,
      anon_sym_as,
    ACTIONS(3171), 1,
      anon_sym_if,
    ACTIONS(3173), 1,
      anon_sym_and,
    ACTIONS(3175), 1,
      anon_sym_or,
    ACTIONS(3701), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [109205] = 5,
    ACTIONS(3424), 1,
      sym_identifier,
    STATE(2244), 1,
      sym_dotted_name,
    STATE(2296), 1,
      sym_aliased_import,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3699), 2,
      sym__newline,
      anon_sym_SEMI,
  [109223] = 4,
    ACTIONS(3703), 1,
      anon_sym_PIPE,
    STATE(2010), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3542), 3,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
  [109239] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3632), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [109251] = 3,
    STATE(2016), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3650), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [109265] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1609), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [109277] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3705), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [109289] = 5,
    ACTIONS(3709), 1,
      anon_sym_COMMA,
    ACTIONS(3711), 1,
      anon_sym_as,
    STATE(2200), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3707), 2,
      sym__newline,
      anon_sym_SEMI,
  [109307] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3713), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [109319] = 4,
    ACTIONS(3703), 1,
      anon_sym_PIPE,
    STATE(2016), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3609), 3,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
  [109335] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3494), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [109347] = 4,
    ACTIONS(3703), 1,
      anon_sym_PIPE,
    STATE(2016), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3634), 3,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
  [109363] = 3,
    ACTIONS(3715), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3260), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [109377] = 6,
    ACTIONS(3169), 1,
      anon_sym_as,
    ACTIONS(3171), 1,
      anon_sym_if,
    ACTIONS(3173), 1,
      anon_sym_and,
    ACTIONS(3175), 1,
      anon_sym_or,
    ACTIONS(3717), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [109397] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2914), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [109409] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3719), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [109421] = 6,
    ACTIONS(3721), 1,
      anon_sym_LBRACE,
    ACTIONS(3723), 1,
      anon_sym_RBRACE,
    ACTIONS(3725), 1,
      aux_sym_format_specifier_token1,
    STATE(2108), 1,
      aux_sym_format_specifier_repeat1,
    STATE(2375), 1,
      sym_interpolation,
    ACTIONS(5), 2,
      sym_comment,
      sym_line_continuation,
  [109441] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3222), 5,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
  [109453] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3727), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [109465] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3729), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [109477] = 6,
    ACTIONS(3169), 1,
      anon_sym_as,
    ACTIONS(3171), 1,
      anon_sym_if,
    ACTIONS(3173), 1,
      anon_sym_and,
    ACTIONS(3175), 1,
      anon_sym_or,
    ACTIONS(3407), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [109497] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3731), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [109509] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3733), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [109521] = 3,
    ACTIONS(3735), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3260), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [109535] = 4,
    ACTIONS(3737), 1,
      anon_sym_PIPE,
    STATE(2043), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3634), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
  [109551] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3739), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [109563] = 6,
    ACTIONS(3169), 1,
      anon_sym_as,
    ACTIONS(3171), 1,
      anon_sym_if,
    ACTIONS(3173), 1,
      anon_sym_and,
    ACTIONS(3175), 1,
      anon_sym_or,
    ACTIONS(3741), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [109583] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3743), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [109595] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3526), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [109607] = 4,
    ACTIONS(3737), 1,
      anon_sym_PIPE,
    STATE(2060), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3542), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
  [109623] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2912), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [109635] = 6,
    ACTIONS(3745), 1,
      anon_sym_COLON,
    ACTIONS(3747), 1,
      anon_sym_EQ,
    ACTIONS(3749), 1,
      anon_sym_RBRACE,
    ACTIONS(3751), 1,
      sym_type_conversion,
    STATE(2737), 1,
      sym_format_specifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [109655] = 5,
    ACTIONS(3514), 1,
      anon_sym_DOT,
    ACTIONS(3518), 1,
      anon_sym_COLON,
    ACTIONS(3522), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3532), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [109673] = 6,
    ACTIONS(2985), 1,
      anon_sym_and,
    ACTIONS(2987), 1,
      anon_sym_or,
    ACTIONS(3009), 1,
      anon_sym_as,
    ACTIONS(3011), 1,
      anon_sym_if,
    ACTIONS(3753), 1,
      sym__newline,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [109693] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3540), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [109705] = 6,
    ACTIONS(3755), 1,
      anon_sym_LBRACE,
    ACTIONS(3758), 1,
      anon_sym_RBRACE,
    ACTIONS(3760), 1,
      aux_sym_format_specifier_token1,
    STATE(2049), 1,
      aux_sym_format_specifier_repeat1,
    STATE(2375), 1,
      sym_interpolation,
    ACTIONS(5), 2,
      sym_comment,
      sym_line_continuation,
  [109725] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3727), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [109737] = 6,
    ACTIONS(3169), 1,
      anon_sym_as,
    ACTIONS(3171), 1,
      anon_sym_if,
    ACTIONS(3173), 1,
      anon_sym_and,
    ACTIONS(3175), 1,
      anon_sym_or,
    ACTIONS(3763), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [109757] = 5,
    ACTIONS(3765), 1,
      anon_sym_COMMA,
    ACTIONS(3767), 1,
      anon_sym_RBRACE,
    STATE(2335), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3260), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
  [109775] = 4,
    ACTIONS(3737), 1,
      anon_sym_PIPE,
    STATE(2043), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3609), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
  [109791] = 4,
    ACTIONS(3769), 1,
      anon_sym_PIPE,
    STATE(2099), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3542), 3,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
  [109807] = 5,
    ACTIONS(3514), 1,
      anon_sym_DOT,
    ACTIONS(3518), 1,
      anon_sym_COLON,
    ACTIONS(3522), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3771), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [109825] = 5,
    ACTIONS(3424), 1,
      sym_identifier,
    STATE(2244), 1,
      sym_dotted_name,
    STATE(2296), 1,
      sym_aliased_import,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3773), 2,
      sym__newline,
      anon_sym_SEMI,
  [109843] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3775), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [109855] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3777), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [109867] = 3,
    STATE(2043), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3650), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [109881] = 4,
    ACTIONS(3779), 1,
      anon_sym_PIPE,
    STATE(2060), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3650), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
  [109897] = 4,
    ACTIONS(3769), 1,
      anon_sym_PIPE,
    STATE(2054), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3634), 3,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
  [109913] = 5,
    ACTIONS(3782), 1,
      anon_sym_COMMA,
    ACTIONS(3784), 1,
      anon_sym_RBRACE,
    STATE(2312), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3260), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
  [109931] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3786), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [109943] = 6,
    ACTIONS(3424), 1,
      sym_identifier,
    ACTIONS(3788), 1,
      anon_sym_LPAREN,
    STATE(2021), 1,
      sym_dotted_name,
    STATE(2242), 1,
      sym_aliased_import,
    STATE(2529), 1,
      sym__import_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [109963] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3790), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [109975] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3136), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [109987] = 4,
    ACTIONS(3792), 1,
      anon_sym_COMMA,
    STATE(2067), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3242), 3,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
  [110003] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3795), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [110015] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3075), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [110027] = 6,
    ACTIONS(3169), 1,
      anon_sym_as,
    ACTIONS(3171), 1,
      anon_sym_if,
    ACTIONS(3173), 1,
      anon_sym_and,
    ACTIONS(3175), 1,
      anon_sym_or,
    ACTIONS(3797), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [110047] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3526), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [110059] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3705), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [110071] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3799), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [110083] = 5,
    ACTIONS(3801), 1,
      anon_sym_DOT,
    ACTIONS(3803), 1,
      anon_sym_COLON,
    ACTIONS(3805), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3532), 2,
      anon_sym_COMMA,
      anon_sym_EQ,
  [110101] = 5,
    ACTIONS(3534), 1,
      anon_sym_DOT,
    ACTIONS(3536), 1,
      anon_sym_COLON,
    ACTIONS(3538), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3807), 2,
      sym__newline,
      anon_sym_SEMI,
  [110119] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3809), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [110131] = 6,
    ACTIONS(3169), 1,
      anon_sym_as,
    ACTIONS(3171), 1,
      anon_sym_if,
    ACTIONS(3173), 1,
      anon_sym_and,
    ACTIONS(3175), 1,
      anon_sym_or,
    ACTIONS(3811), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [110151] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3540), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [110163] = 5,
    ACTIONS(3813), 1,
      anon_sym_COMMA,
    ACTIONS(3815), 1,
      anon_sym_RBRACE,
    STATE(2345), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3260), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
  [110181] = 6,
    ACTIONS(3169), 1,
      anon_sym_as,
    ACTIONS(3171), 1,
      anon_sym_if,
    ACTIONS(3173), 1,
      anon_sym_and,
    ACTIONS(3175), 1,
      anon_sym_or,
    ACTIONS(3817), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [110201] = 5,
    ACTIONS(3546), 1,
      anon_sym_DOT,
    ACTIONS(3550), 1,
      anon_sym_COLON,
    ACTIONS(3554), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3548), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [110219] = 6,
    ACTIONS(3169), 1,
      anon_sym_as,
    ACTIONS(3171), 1,
      anon_sym_if,
    ACTIONS(3173), 1,
      anon_sym_and,
    ACTIONS(3175), 1,
      anon_sym_or,
    ACTIONS(3819), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [110239] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2887), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [110251] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3484), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [110263] = 4,
    ACTIONS(3769), 1,
      anon_sym_PIPE,
    STATE(2054), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3609), 3,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
  [110279] = 6,
    ACTIONS(1540), 1,
      anon_sym_LBRACK,
    ACTIONS(3821), 1,
      anon_sym_LPAREN,
    ACTIONS(3823), 1,
      anon_sym_COLON,
    STATE(2447), 1,
      sym_type_parameter,
    STATE(2657), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [110299] = 6,
    ACTIONS(3169), 1,
      anon_sym_as,
    ACTIONS(3171), 1,
      anon_sym_if,
    ACTIONS(3173), 1,
      anon_sym_and,
    ACTIONS(3175), 1,
      anon_sym_or,
    ACTIONS(3825), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [110319] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3827), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [110331] = 6,
    ACTIONS(3169), 1,
      anon_sym_as,
    ACTIONS(3171), 1,
      anon_sym_if,
    ACTIONS(3173), 1,
      anon_sym_and,
    ACTIONS(3175), 1,
      anon_sym_or,
    ACTIONS(3829), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [110351] = 6,
    ACTIONS(3171), 1,
      anon_sym_if,
    ACTIONS(3173), 1,
      anon_sym_and,
    ACTIONS(3175), 1,
      anon_sym_or,
    ACTIONS(3831), 1,
      anon_sym_as,
    ACTIONS(3833), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [110371] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3835), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [110383] = 4,
    ACTIONS(3837), 1,
      anon_sym_COMMA,
    STATE(2067), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1276), 3,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
  [110399] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3075), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [110411] = 6,
    ACTIONS(3548), 1,
      anon_sym_COMMA,
    ACTIONS(3801), 1,
      anon_sym_DOT,
    ACTIONS(3803), 1,
      anon_sym_COLON,
    ACTIONS(3805), 1,
      anon_sym_PIPE,
    ACTIONS(3839), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [110431] = 6,
    ACTIONS(3745), 1,
      anon_sym_COLON,
    ACTIONS(3841), 1,
      anon_sym_EQ,
    ACTIONS(3843), 1,
      anon_sym_RBRACE,
    ACTIONS(3845), 1,
      sym_type_conversion,
    STATE(2622), 1,
      sym_format_specifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [110451] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3847), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [110463] = 3,
    STATE(2054), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3650), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [110477] = 6,
    ACTIONS(3169), 1,
      anon_sym_as,
    ACTIONS(3171), 1,
      anon_sym_if,
    ACTIONS(3173), 1,
      anon_sym_and,
    ACTIONS(3175), 1,
      anon_sym_or,
    ACTIONS(3849), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [110497] = 4,
    ACTIONS(3851), 1,
      anon_sym_PIPE,
    STATE(2099), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3650), 3,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
  [110513] = 6,
    ACTIONS(3169), 1,
      anon_sym_as,
    ACTIONS(3171), 1,
      anon_sym_if,
    ACTIONS(3173), 1,
      anon_sym_and,
    ACTIONS(3175), 1,
      anon_sym_or,
    ACTIONS(3854), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [110533] = 4,
    ACTIONS(3173), 1,
      anon_sym_and,
    ACTIONS(3175), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2983), 3,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
  [110549] = 6,
    ACTIONS(2595), 1,
      anon_sym_COLON,
    ACTIONS(3640), 1,
      anon_sym_if,
    ACTIONS(3856), 1,
      anon_sym_COMMA,
    STATE(2163), 1,
      aux_sym_case_clause_repeat1,
    STATE(2714), 1,
      sym_if_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [110569] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3858), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [110581] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3786), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [110593] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3727), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [110605] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3786), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [110617] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1609), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [110629] = 6,
    ACTIONS(3721), 1,
      anon_sym_LBRACE,
    ACTIONS(3860), 1,
      anon_sym_RBRACE,
    ACTIONS(3862), 1,
      aux_sym_format_specifier_token1,
    STATE(2049), 1,
      aux_sym_format_specifier_repeat1,
    STATE(2375), 1,
      sym_interpolation,
    ACTIONS(5), 2,
      sym_comment,
      sym_line_continuation,
  [110649] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3632), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [110661] = 6,
    ACTIONS(3171), 1,
      anon_sym_if,
    ACTIONS(3173), 1,
      anon_sym_and,
    ACTIONS(3175), 1,
      anon_sym_or,
    ACTIONS(3831), 1,
      anon_sym_as,
    ACTIONS(3864), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [110681] = 6,
    ACTIONS(3169), 1,
      anon_sym_as,
    ACTIONS(3171), 1,
      anon_sym_if,
    ACTIONS(3173), 1,
      anon_sym_and,
    ACTIONS(3175), 1,
      anon_sym_or,
    ACTIONS(3866), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [110701] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3494), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [110713] = 6,
    ACTIONS(3169), 1,
      anon_sym_as,
    ACTIONS(3171), 1,
      anon_sym_if,
    ACTIONS(3173), 1,
      anon_sym_and,
    ACTIONS(3175), 1,
      anon_sym_or,
    ACTIONS(3868), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [110733] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3870), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [110745] = 6,
    ACTIONS(1540), 1,
      anon_sym_LBRACK,
    ACTIONS(3821), 1,
      anon_sym_LPAREN,
    ACTIONS(3872), 1,
      anon_sym_COLON,
    STATE(2334), 1,
      sym_type_parameter,
    STATE(2709), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [110765] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3874), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [110777] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3876), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [110789] = 6,
    ACTIONS(3169), 1,
      anon_sym_as,
    ACTIONS(3171), 1,
      anon_sym_if,
    ACTIONS(3173), 1,
      anon_sym_and,
    ACTIONS(3175), 1,
      anon_sym_or,
    ACTIONS(3878), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [110809] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3880), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [110821] = 6,
    ACTIONS(3169), 1,
      anon_sym_as,
    ACTIONS(3171), 1,
      anon_sym_if,
    ACTIONS(3173), 1,
      anon_sym_and,
    ACTIONS(3175), 1,
      anon_sym_or,
    ACTIONS(3882), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [110841] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3884), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [110853] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1542), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [110865] = 6,
    ACTIONS(3169), 1,
      anon_sym_as,
    ACTIONS(3171), 1,
      anon_sym_if,
    ACTIONS(3173), 1,
      anon_sym_and,
    ACTIONS(3175), 1,
      anon_sym_or,
    ACTIONS(3886), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [110885] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3888), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [110897] = 3,
    ACTIONS(3890), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3260), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [110911] = 5,
    ACTIONS(3892), 1,
      anon_sym_COMMA,
    ACTIONS(3894), 1,
      anon_sym_RBRACE,
    STATE(2433), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3260), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
  [110929] = 5,
    ACTIONS(3896), 1,
      anon_sym_RPAREN,
    ACTIONS(3898), 1,
      anon_sym_COMMA,
    ACTIONS(3900), 1,
      anon_sym_as,
    STATE(2440), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [110946] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3733), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [110957] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3731), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [110968] = 5,
    ACTIONS(3902), 1,
      anon_sym_case,
    ACTIONS(3904), 1,
      sym__dedent,
    STATE(2209), 1,
      aux_sym__match_block_repeat1,
    STATE(2609), 1,
      sym_case_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [110985] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3729), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [110996] = 5,
    ACTIONS(3902), 1,
      anon_sym_case,
    ACTIONS(3906), 1,
      sym__dedent,
    STATE(2158), 1,
      aux_sym__match_block_repeat1,
    STATE(2609), 1,
      sym_case_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [111013] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3713), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [111024] = 4,
    ACTIONS(3910), 1,
      anon_sym_COLON,
    ACTIONS(3912), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3908), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [111039] = 5,
    ACTIONS(3745), 1,
      anon_sym_COLON,
    ACTIONS(3914), 1,
      anon_sym_RBRACE,
    ACTIONS(3916), 1,
      sym_type_conversion,
    STATE(2649), 1,
      sym_format_specifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [111056] = 5,
    ACTIONS(3699), 1,
      anon_sym_RPAREN,
    ACTIONS(3918), 1,
      sym_identifier,
    STATE(2352), 1,
      sym_dotted_name,
    STATE(2595), 1,
      sym_aliased_import,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [111073] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3739), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [111084] = 5,
    ACTIONS(3699), 1,
      anon_sym_RPAREN,
    ACTIONS(3918), 1,
      sym_identifier,
    STATE(2352), 1,
      sym_dotted_name,
    STATE(2595), 1,
      sym_aliased_import,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [111101] = 5,
    ACTIONS(1540), 1,
      anon_sym_LBRACK,
    ACTIONS(3920), 1,
      anon_sym_LPAREN,
    STATE(2551), 1,
      sym_parameters,
    STATE(2558), 1,
      sym_type_parameter,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [111118] = 5,
    ACTIONS(3922), 1,
      anon_sym_COMMA,
    ACTIONS(3924), 1,
      anon_sym_as,
    ACTIONS(3926), 1,
      anon_sym_RBRACK,
    STATE(2428), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [111135] = 5,
    ACTIONS(3900), 1,
      anon_sym_as,
    ACTIONS(3928), 1,
      anon_sym_RPAREN,
    ACTIONS(3930), 1,
      anon_sym_COMMA,
    STATE(2426), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [111152] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3874), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [111163] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3743), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [111174] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3775), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [111185] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3777), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [111196] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3713), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [111207] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3729), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [111218] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3790), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [111229] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3827), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [111240] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3835), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [111251] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3731), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [111262] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3847), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [111273] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3733), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [111284] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3719), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [111295] = 5,
    ACTIONS(3900), 1,
      anon_sym_as,
    ACTIONS(3932), 1,
      anon_sym_RPAREN,
    ACTIONS(3934), 1,
      anon_sym_COMMA,
    STATE(2280), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [111312] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3739), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [111323] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3858), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [111334] = 5,
    ACTIONS(3902), 1,
      anon_sym_case,
    ACTIONS(3936), 1,
      sym__dedent,
    STATE(2209), 1,
      aux_sym__match_block_repeat1,
    STATE(2609), 1,
      sym_case_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [111351] = 4,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    STATE(2171), 1,
      aux_sym_global_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3938), 2,
      sym__newline,
      anon_sym_SEMI,
  [111366] = 3,
    ACTIONS(3638), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3942), 3,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
  [111379] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3743), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [111390] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3944), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
  [111401] = 4,
    ACTIONS(3946), 1,
      anon_sym_COMMA,
    STATE(2163), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3942), 2,
      anon_sym_if,
      anon_sym_COLON,
  [111416] = 4,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    STATE(2191), 1,
      aux_sym_global_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3949), 2,
      sym__newline,
      anon_sym_SEMI,
  [111431] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3775), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [111442] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3777), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [111453] = 5,
    ACTIONS(3548), 1,
      anon_sym_COMMA,
    ACTIONS(3801), 1,
      anon_sym_DOT,
    ACTIONS(3803), 1,
      anon_sym_COLON,
    ACTIONS(3805), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [111470] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3790), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [111481] = 4,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    STATE(2164), 1,
      aux_sym_global_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3951), 2,
      sym__newline,
      anon_sym_SEMI,
  [111496] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3827), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [111507] = 4,
    ACTIONS(3940), 1,
      anon_sym_COMMA,
    STATE(2191), 1,
      aux_sym_global_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3953), 2,
      sym__newline,
      anon_sym_SEMI,
  [111522] = 5,
    ACTIONS(3801), 1,
      anon_sym_DOT,
    ACTIONS(3803), 1,
      anon_sym_COLON,
    ACTIONS(3805), 1,
      anon_sym_PIPE,
    ACTIONS(3955), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [111539] = 5,
    ACTIONS(1540), 1,
      anon_sym_LBRACK,
    ACTIONS(3920), 1,
      anon_sym_LPAREN,
    STATE(2564), 1,
      sym_parameters,
    STATE(2571), 1,
      sym_type_parameter,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [111556] = 4,
    ACTIONS(3303), 1,
      anon_sym_COMMA,
    STATE(2067), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3957), 2,
      sym__newline,
      anon_sym_SEMI,
  [111571] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3835), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [111582] = 4,
    ACTIONS(3961), 1,
      anon_sym_COMMA,
    STATE(2237), 1,
      aux_sym_print_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3959), 2,
      sym__newline,
      anon_sym_SEMI,
  [111597] = 4,
    ACTIONS(3965), 1,
      anon_sym_COMMA,
    STATE(2237), 1,
      aux_sym_print_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3963), 2,
      sym__newline,
      anon_sym_SEMI,
  [111612] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3260), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(3967), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [111625] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3870), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [111636] = 4,
    ACTIONS(3303), 1,
      anon_sym_COMMA,
    STATE(2067), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3969), 2,
      sym__newline,
      anon_sym_SEMI,
  [111651] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3809), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [111662] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3847), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [111673] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3876), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [111684] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3719), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [111695] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3880), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [111706] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3884), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [111717] = 5,
    ACTIONS(3924), 1,
      anon_sym_as,
    ACTIONS(3971), 1,
      anon_sym_COMMA,
    ACTIONS(3973), 1,
      anon_sym_RBRACK,
    STATE(2350), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [111734] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3888), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [111745] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3799), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [111756] = 4,
    ACTIONS(3977), 1,
      anon_sym_DOT,
    STATE(2190), 1,
      aux_sym_import_prefix_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3975), 2,
      anon_sym_import,
      sym_identifier,
  [111771] = 4,
    ACTIONS(3982), 1,
      anon_sym_COMMA,
    STATE(2191), 1,
      aux_sym_global_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3980), 2,
      sym__newline,
      anon_sym_SEMI,
  [111786] = 5,
    ACTIONS(3900), 1,
      anon_sym_as,
    ACTIONS(3985), 1,
      anon_sym_RPAREN,
    ACTIONS(3987), 1,
      anon_sym_COMMA,
    STATE(2358), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [111803] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3705), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [111814] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3876), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [111825] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3858), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [111836] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3795), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [111847] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3795), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [111858] = 5,
    ACTIONS(3900), 1,
      anon_sym_as,
    ACTIONS(3989), 1,
      anon_sym_RPAREN,
    ACTIONS(3991), 1,
      anon_sym_COMMA,
    STATE(2319), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [111875] = 5,
    ACTIONS(3924), 1,
      anon_sym_as,
    ACTIONS(3993), 1,
      anon_sym_COMMA,
    ACTIONS(3995), 1,
      anon_sym_RBRACK,
    STATE(2317), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [111892] = 4,
    ACTIONS(3999), 1,
      anon_sym_COMMA,
    STATE(2250), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3997), 2,
      sym__newline,
      anon_sym_SEMI,
  [111907] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3705), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [111918] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3799), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [111929] = 5,
    ACTIONS(3773), 1,
      anon_sym_RPAREN,
    ACTIONS(3918), 1,
      sym_identifier,
    STATE(2352), 1,
      sym_dotted_name,
    STATE(2595), 1,
      sym_aliased_import,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [111946] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3809), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [111957] = 5,
    ACTIONS(3900), 1,
      anon_sym_as,
    ACTIONS(4001), 1,
      anon_sym_RPAREN,
    ACTIONS(4003), 1,
      anon_sym_COMMA,
    STATE(2343), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [111974] = 4,
    ACTIONS(4005), 1,
      anon_sym_COMMA,
    STATE(2250), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3997), 2,
      sym__newline,
      anon_sym_SEMI,
  [111989] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3870), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [112000] = 4,
    ACTIONS(4007), 1,
      anon_sym_COMMA,
    STATE(2067), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1406), 2,
      sym__newline,
      anon_sym_SEMI,
  [112015] = 5,
    ACTIONS(4009), 1,
      anon_sym_case,
    ACTIONS(4012), 1,
      sym__dedent,
    STATE(2209), 1,
      aux_sym__match_block_repeat1,
    STATE(2609), 1,
      sym_case_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112032] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3634), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
  [112043] = 4,
    ACTIONS(4016), 1,
      anon_sym_COMMA,
    STATE(2177), 1,
      aux_sym_print_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4014), 2,
      sym__newline,
      anon_sym_SEMI,
  [112058] = 5,
    ACTIONS(3924), 1,
      anon_sym_as,
    ACTIONS(4018), 1,
      anon_sym_COMMA,
    ACTIONS(4020), 1,
      anon_sym_RBRACK,
    STATE(2330), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112075] = 5,
    ACTIONS(3900), 1,
      anon_sym_as,
    ACTIONS(4022), 1,
      anon_sym_RPAREN,
    ACTIONS(4024), 1,
      anon_sym_COMMA,
    STATE(2328), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112092] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3713), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [112103] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3876), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [112114] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3729), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [112125] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3880), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [112136] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3884), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [112147] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3731), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [112158] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3888), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [112169] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3733), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [112180] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3739), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [112191] = 5,
    ACTIONS(3900), 1,
      anon_sym_as,
    ACTIONS(4026), 1,
      anon_sym_RPAREN,
    ACTIONS(4028), 1,
      anon_sym_COMMA,
    STATE(2305), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112208] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3874), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [112219] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4030), 4,
      anon_sym_async,
      anon_sym_def,
      anon_sym_class,
      anon_sym_AT,
  [112230] = 5,
    ACTIONS(3745), 1,
      anon_sym_COLON,
    ACTIONS(4032), 1,
      anon_sym_RBRACE,
    ACTIONS(4034), 1,
      sym_type_conversion,
    STATE(2648), 1,
      sym_format_specifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112247] = 5,
    ACTIONS(3902), 1,
      anon_sym_case,
    ACTIONS(4036), 1,
      sym__dedent,
    STATE(2130), 1,
      aux_sym__match_block_repeat1,
    STATE(2609), 1,
      sym_case_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112264] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3743), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [112275] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3775), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [112286] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3777), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [112297] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3790), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [112308] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3827), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [112319] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3835), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [112330] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3847), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [112341] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3719), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [112352] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3858), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [112363] = 4,
    ACTIONS(4040), 1,
      anon_sym_COMMA,
    STATE(2237), 1,
      aux_sym_print_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4038), 2,
      sym__newline,
      anon_sym_SEMI,
  [112378] = 5,
    ACTIONS(3918), 1,
      sym_identifier,
    STATE(2251), 1,
      sym_dotted_name,
    STATE(2265), 1,
      sym_aliased_import,
    STATE(2632), 1,
      sym__import_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112395] = 4,
    ACTIONS(4045), 1,
      anon_sym_DOT,
    STATE(2190), 1,
      aux_sym_import_prefix_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4043), 2,
      anon_sym_import,
      sym_identifier,
  [112410] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3870), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [112421] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3795), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [112432] = 4,
    ACTIONS(3709), 1,
      anon_sym_COMMA,
    STATE(2206), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3707), 2,
      sym__newline,
      anon_sym_SEMI,
  [112447] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3799), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [112458] = 3,
    ACTIONS(3711), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4047), 3,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [112471] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3809), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [112482] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3874), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [112493] = 5,
    ACTIONS(1540), 1,
      anon_sym_LBRACK,
    ACTIONS(3920), 1,
      anon_sym_LPAREN,
    STATE(2528), 1,
      sym_type_parameter,
    STATE(2584), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112510] = 5,
    ACTIONS(1540), 1,
      anon_sym_LBRACK,
    ACTIONS(3920), 1,
      anon_sym_LPAREN,
    STATE(2527), 1,
      sym_type_parameter,
    STATE(2582), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112527] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3888), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [112538] = 4,
    ACTIONS(4051), 1,
      anon_sym_COMMA,
    STATE(2250), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4049), 2,
      sym__newline,
      anon_sym_SEMI,
  [112553] = 5,
    ACTIONS(3707), 1,
      anon_sym_RPAREN,
    ACTIONS(4054), 1,
      anon_sym_COMMA,
    ACTIONS(4056), 1,
      anon_sym_as,
    STATE(2293), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112570] = 5,
    ACTIONS(3424), 1,
      sym_identifier,
    STATE(2021), 1,
      sym_dotted_name,
    STATE(2242), 1,
      sym_aliased_import,
    STATE(2535), 1,
      sym__import_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112587] = 5,
    ACTIONS(3918), 1,
      sym_identifier,
    STATE(2251), 1,
      sym_dotted_name,
    STATE(2265), 1,
      sym_aliased_import,
    STATE(2637), 1,
      sym__import_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112604] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3884), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [112615] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3880), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [112626] = 4,
    ACTIONS(3085), 1,
      anon_sym_RPAREN,
    ACTIONS(3087), 1,
      anon_sym_COMMA,
    STATE(2299), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112640] = 4,
    ACTIONS(3469), 1,
      anon_sym_COMMA,
    ACTIONS(3471), 1,
      anon_sym_RBRACE,
    STATE(2453), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112654] = 4,
    ACTIONS(4058), 1,
      anon_sym_COMMA,
    ACTIONS(4060), 1,
      anon_sym_RBRACK,
    STATE(2311), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112668] = 4,
    ACTIONS(4062), 1,
      anon_sym_COMMA,
    ACTIONS(4064), 1,
      anon_sym_in,
    STATE(2507), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112682] = 4,
    ACTIONS(3056), 1,
      anon_sym_COMMA,
    ACTIONS(3062), 1,
      anon_sym_RPAREN,
    STATE(2493), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112696] = 4,
    ACTIONS(4062), 1,
      anon_sym_COMMA,
    ACTIONS(4066), 1,
      anon_sym_in,
    STATE(2507), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112710] = 4,
    ACTIONS(4068), 1,
      anon_sym_SEMI,
    ACTIONS(4070), 1,
      sym__newline,
    STATE(2444), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112724] = 4,
    ACTIONS(2887), 1,
      anon_sym_RBRACK,
    ACTIONS(4072), 1,
      anon_sym_COMMA,
    STATE(2263), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112738] = 4,
    ACTIONS(3001), 1,
      anon_sym_RBRACK,
    ACTIONS(3040), 1,
      anon_sym_COMMA,
    STATE(2294), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112752] = 4,
    ACTIONS(3707), 1,
      anon_sym_RPAREN,
    ACTIONS(4054), 1,
      anon_sym_COMMA,
    STATE(2291), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112766] = 3,
    ACTIONS(3912), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3908), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [112778] = 4,
    ACTIONS(3242), 1,
      anon_sym_RPAREN,
    ACTIONS(4075), 1,
      anon_sym_COMMA,
    STATE(2267), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112792] = 3,
    ACTIONS(4078), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3908), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [112804] = 4,
    ACTIONS(3356), 1,
      anon_sym_COMMA,
    ACTIONS(3358), 1,
      anon_sym_RBRACE,
    STATE(2282), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112818] = 4,
    ACTIONS(1276), 1,
      anon_sym_RPAREN,
    ACTIONS(4080), 1,
      anon_sym_COMMA,
    STATE(2267), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112832] = 4,
    ACTIONS(1270), 1,
      anon_sym_RBRACE,
    ACTIONS(4082), 1,
      anon_sym_COMMA,
    STATE(2278), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112846] = 4,
    ACTIONS(626), 1,
      sym__newline,
    ACTIONS(4084), 1,
      anon_sym_SEMI,
    STATE(2378), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112860] = 4,
    ACTIONS(2729), 1,
      sym_identifier,
    ACTIONS(4086), 1,
      anon_sym_import,
    STATE(2750), 1,
      sym_dotted_name,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112874] = 4,
    ACTIONS(3001), 1,
      anon_sym_RPAREN,
    ACTIONS(3056), 1,
      anon_sym_COMMA,
    STATE(2493), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112888] = 4,
    ACTIONS(4060), 1,
      anon_sym_RPAREN,
    ACTIONS(4088), 1,
      anon_sym_COMMA,
    STATE(2506), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112902] = 4,
    ACTIONS(3056), 1,
      anon_sym_COMMA,
    ACTIONS(4090), 1,
      anon_sym_RPAREN,
    STATE(2493), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112916] = 4,
    ACTIONS(3056), 1,
      anon_sym_COMMA,
    ACTIONS(4092), 1,
      anon_sym_RPAREN,
    STATE(2493), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112930] = 4,
    ACTIONS(3499), 1,
      anon_sym_RBRACE,
    ACTIONS(4094), 1,
      anon_sym_COMMA,
    STATE(2278), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112944] = 4,
    ACTIONS(3056), 1,
      anon_sym_COMMA,
    ACTIONS(3105), 1,
      anon_sym_RPAREN,
    STATE(2493), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112958] = 4,
    ACTIONS(2691), 1,
      anon_sym_RPAREN,
    ACTIONS(4097), 1,
      anon_sym_COMMA,
    STATE(2415), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112972] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4099), 3,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [112982] = 4,
    ACTIONS(1308), 1,
      anon_sym_RBRACE,
    ACTIONS(4101), 1,
      anon_sym_COMMA,
    STATE(2354), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112996] = 4,
    ACTIONS(4062), 1,
      anon_sym_COMMA,
    ACTIONS(4103), 1,
      anon_sym_in,
    STATE(2507), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113010] = 4,
    ACTIONS(4062), 1,
      anon_sym_COMMA,
    ACTIONS(4105), 1,
      anon_sym_in,
    STATE(2507), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113024] = 4,
    ACTIONS(4107), 1,
      sym__newline,
    ACTIONS(4109), 1,
      sym__indent,
    STATE(737), 1,
      sym__match_block,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113038] = 4,
    ACTIONS(4111), 1,
      anon_sym_SEMI,
    ACTIONS(4113), 1,
      sym__newline,
    STATE(2272), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113052] = 3,
    ACTIONS(1711), 1,
      anon_sym_except,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1713), 2,
      anon_sym_except_STAR,
      anon_sym_finally,
  [113064] = 4,
    ACTIONS(4115), 1,
      anon_sym_RPAREN,
    ACTIONS(4117), 1,
      anon_sym_COMMA,
    STATE(2325), 1,
      aux_sym__parameters_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113078] = 4,
    ACTIONS(4119), 1,
      anon_sym_RPAREN,
    ACTIONS(4121), 1,
      anon_sym_COMMA,
    STATE(2301), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113092] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2416), 3,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_in,
  [113102] = 4,
    ACTIONS(3997), 1,
      anon_sym_RPAREN,
    ACTIONS(4123), 1,
      anon_sym_COMMA,
    STATE(2351), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113116] = 4,
    ACTIONS(3268), 1,
      anon_sym_COMMA,
    ACTIONS(3270), 1,
      anon_sym_RBRACK,
    STATE(2304), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113130] = 4,
    ACTIONS(3997), 1,
      anon_sym_RPAREN,
    ACTIONS(4125), 1,
      anon_sym_COMMA,
    STATE(2351), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113144] = 4,
    ACTIONS(1270), 1,
      anon_sym_RBRACK,
    ACTIONS(4127), 1,
      anon_sym_COMMA,
    STATE(2344), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113158] = 4,
    ACTIONS(3499), 1,
      anon_sym_RPAREN,
    ACTIONS(4129), 1,
      anon_sym_COMMA,
    STATE(2295), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113172] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4047), 3,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [113182] = 4,
    ACTIONS(4062), 1,
      anon_sym_COMMA,
    ACTIONS(4132), 1,
      anon_sym_in,
    STATE(2507), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113196] = 4,
    ACTIONS(4134), 1,
      anon_sym_COMMA,
    ACTIONS(4137), 1,
      anon_sym_RBRACE,
    STATE(2298), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113210] = 4,
    ACTIONS(1226), 1,
      anon_sym_RPAREN,
    ACTIONS(4139), 1,
      anon_sym_COMMA,
    STATE(2474), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113224] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2914), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
  [113234] = 4,
    ACTIONS(1224), 1,
      anon_sym_RPAREN,
    ACTIONS(4141), 1,
      anon_sym_COMMA,
    STATE(2474), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113248] = 4,
    ACTIONS(3745), 1,
      anon_sym_COLON,
    ACTIONS(4143), 1,
      anon_sym_RBRACE,
    STATE(2642), 1,
      sym_format_specifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113262] = 4,
    ACTIONS(4145), 1,
      anon_sym_COMMA,
    ACTIONS(4147), 1,
      anon_sym_RBRACK,
    STATE(2422), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113276] = 4,
    ACTIONS(4149), 1,
      anon_sym_COMMA,
    ACTIONS(4151), 1,
      anon_sym_RBRACK,
    STATE(2422), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113290] = 4,
    ACTIONS(2669), 1,
      anon_sym_RPAREN,
    ACTIONS(4153), 1,
      anon_sym_COMMA,
    STATE(2415), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113304] = 4,
    ACTIONS(1276), 1,
      anon_sym_RBRACK,
    ACTIONS(4155), 1,
      anon_sym_COMMA,
    STATE(2514), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113318] = 4,
    ACTIONS(3516), 1,
      anon_sym_COMMA,
    ACTIONS(4157), 1,
      anon_sym_RBRACK,
    STATE(2441), 1,
      aux_sym_type_parameter_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113332] = 4,
    ACTIONS(1144), 1,
      anon_sym_RPAREN,
    ACTIONS(4159), 1,
      anon_sym_COMMA,
    STATE(2474), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113346] = 4,
    ACTIONS(4161), 1,
      anon_sym_COMMA,
    ACTIONS(4164), 1,
      anon_sym_COLON,
    STATE(2309), 1,
      aux_sym_match_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113360] = 4,
    ACTIONS(3272), 1,
      anon_sym_COMMA,
    ACTIONS(3274), 1,
      anon_sym_RBRACK,
    STATE(2372), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113374] = 4,
    ACTIONS(1955), 1,
      anon_sym_RBRACK,
    ACTIONS(4166), 1,
      anon_sym_COMMA,
    STATE(2263), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113388] = 4,
    ACTIONS(4168), 1,
      anon_sym_COMMA,
    ACTIONS(4170), 1,
      anon_sym_RBRACE,
    STATE(2298), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113402] = 4,
    ACTIONS(4172), 1,
      anon_sym_COMMA,
    ACTIONS(4174), 1,
      anon_sym_RBRACE,
    STATE(2298), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113416] = 4,
    ACTIONS(3801), 1,
      anon_sym_DOT,
    ACTIONS(3805), 1,
      anon_sym_PIPE,
    ACTIONS(4176), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113430] = 4,
    ACTIONS(3801), 1,
      anon_sym_DOT,
    ACTIONS(3805), 1,
      anon_sym_PIPE,
    ACTIONS(4178), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113444] = 4,
    ACTIONS(3801), 1,
      anon_sym_DOT,
    ACTIONS(3805), 1,
      anon_sym_PIPE,
    ACTIONS(4180), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113458] = 4,
    ACTIONS(2677), 1,
      anon_sym_RBRACK,
    ACTIONS(4182), 1,
      anon_sym_COMMA,
    STATE(2490), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113472] = 4,
    ACTIONS(4184), 1,
      anon_sym_RPAREN,
    ACTIONS(4186), 1,
      anon_sym_COMMA,
    STATE(2365), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113486] = 4,
    ACTIONS(2679), 1,
      anon_sym_RPAREN,
    ACTIONS(4188), 1,
      anon_sym_COMMA,
    STATE(2415), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113500] = 4,
    ACTIONS(3801), 1,
      anon_sym_DOT,
    ACTIONS(3805), 1,
      anon_sym_PIPE,
    ACTIONS(4190), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113514] = 4,
    ACTIONS(4192), 1,
      anon_sym_COMMA,
    ACTIONS(4194), 1,
      anon_sym_RBRACE,
    STATE(2333), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113528] = 3,
    ACTIONS(4198), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4196), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [113540] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1647), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
  [113550] = 4,
    ACTIONS(4062), 1,
      anon_sym_COMMA,
    ACTIONS(4200), 1,
      anon_sym_in,
    STATE(2507), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113564] = 4,
    ACTIONS(2979), 1,
      anon_sym_RPAREN,
    ACTIONS(4202), 1,
      anon_sym_COMMA,
    STATE(2384), 1,
      aux_sym__parameters_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113578] = 4,
    ACTIONS(3097), 1,
      anon_sym_RPAREN,
    ACTIONS(3099), 1,
      anon_sym_COMMA,
    STATE(2363), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113592] = 3,
    ACTIONS(1667), 1,
      anon_sym_except,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1665), 2,
      anon_sym_except_STAR,
      anon_sym_finally,
  [113604] = 4,
    ACTIONS(2701), 1,
      anon_sym_RPAREN,
    ACTIONS(4204), 1,
      anon_sym_COMMA,
    STATE(2415), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113618] = 3,
    ACTIONS(3900), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3942), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [113630] = 4,
    ACTIONS(2659), 1,
      anon_sym_RBRACK,
    ACTIONS(4206), 1,
      anon_sym_COMMA,
    STATE(2490), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113644] = 4,
    ACTIONS(4062), 1,
      anon_sym_COMMA,
    ACTIONS(4208), 1,
      anon_sym_in,
    STATE(2507), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113658] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3944), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
  [113668] = 4,
    ACTIONS(4210), 1,
      anon_sym_COMMA,
    ACTIONS(4212), 1,
      anon_sym_RBRACE,
    STATE(2298), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113682] = 4,
    ACTIONS(3821), 1,
      anon_sym_LPAREN,
    ACTIONS(4214), 1,
      anon_sym_COLON,
    STATE(2618), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113696] = 4,
    ACTIONS(4216), 1,
      anon_sym_COMMA,
    ACTIONS(4218), 1,
      anon_sym_RBRACE,
    STATE(2298), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113710] = 4,
    ACTIONS(1416), 1,
      anon_sym_RPAREN,
    ACTIONS(4220), 1,
      anon_sym_COMMA,
    STATE(2379), 1,
      aux_sym_with_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113724] = 3,
    ACTIONS(1671), 1,
      anon_sym_except,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1669), 2,
      anon_sym_except_STAR,
      anon_sym_finally,
  [113736] = 3,
    ACTIONS(3238), 1,
      anon_sym_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3236), 2,
      sym__newline,
      anon_sym_SEMI,
  [113748] = 4,
    ACTIONS(2887), 1,
      anon_sym_RPAREN,
    ACTIONS(4222), 1,
      anon_sym_COMMA,
    STATE(2339), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113762] = 3,
    ACTIONS(3667), 1,
      aux_sym_format_specifier_token1,
    ACTIONS(5), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3669), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [113774] = 4,
    ACTIONS(4225), 1,
      anon_sym_COMMA,
    ACTIONS(4227), 1,
      anon_sym_RBRACE,
    STATE(2313), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113788] = 4,
    ACTIONS(4229), 1,
      anon_sym_COMMA,
    ACTIONS(4232), 1,
      anon_sym_COLON,
    STATE(2342), 1,
      aux_sym_with_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113802] = 4,
    ACTIONS(2643), 1,
      anon_sym_RPAREN,
    ACTIONS(4234), 1,
      anon_sym_COMMA,
    STATE(2415), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113816] = 4,
    ACTIONS(3499), 1,
      anon_sym_RBRACK,
    ACTIONS(4236), 1,
      anon_sym_COMMA,
    STATE(2344), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113830] = 4,
    ACTIONS(4239), 1,
      anon_sym_COMMA,
    ACTIONS(4241), 1,
      anon_sym_RBRACE,
    STATE(2298), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113844] = 4,
    ACTIONS(3242), 1,
      anon_sym_COLON,
    ACTIONS(4243), 1,
      anon_sym_COMMA,
    STATE(2346), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113858] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3980), 3,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [113868] = 4,
    ACTIONS(4107), 1,
      sym__newline,
    ACTIONS(4109), 1,
      sym__indent,
    STATE(734), 1,
      sym__match_block,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113882] = 4,
    ACTIONS(4246), 1,
      anon_sym_COMMA,
    ACTIONS(4248), 1,
      anon_sym_RBRACE,
    STATE(2298), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113896] = 4,
    ACTIONS(2629), 1,
      anon_sym_RBRACK,
    ACTIONS(4250), 1,
      anon_sym_COMMA,
    STATE(2490), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113910] = 4,
    ACTIONS(4049), 1,
      anon_sym_RPAREN,
    ACTIONS(4252), 1,
      anon_sym_COMMA,
    STATE(2351), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113924] = 3,
    ACTIONS(4056), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4047), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [113936] = 4,
    ACTIONS(4062), 1,
      anon_sym_COMMA,
    ACTIONS(4255), 1,
      anon_sym_in,
    STATE(2507), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113950] = 4,
    ACTIONS(4257), 1,
      anon_sym_COMMA,
    ACTIONS(4260), 1,
      anon_sym_RBRACE,
    STATE(2354), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113964] = 4,
    ACTIONS(4262), 1,
      anon_sym_SEMI,
    ACTIONS(4264), 1,
      sym__newline,
    STATE(2376), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113978] = 4,
    ACTIONS(4266), 1,
      anon_sym_COMMA,
    ACTIONS(4268), 1,
      anon_sym_RBRACK,
    STATE(2422), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113992] = 4,
    ACTIONS(4270), 1,
      anon_sym_COMMA,
    ACTIONS(4272), 1,
      anon_sym_RBRACK,
    STATE(2422), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114006] = 4,
    ACTIONS(2695), 1,
      anon_sym_RPAREN,
    ACTIONS(4274), 1,
      anon_sym_COMMA,
    STATE(2415), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114020] = 4,
    ACTIONS(3319), 1,
      anon_sym_COMMA,
    ACTIONS(3321), 1,
      anon_sym_RBRACK,
    STATE(2356), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114034] = 4,
    ACTIONS(4276), 1,
      anon_sym_COMMA,
    ACTIONS(4279), 1,
      anon_sym_COLON,
    STATE(2360), 1,
      aux_sym__parameters_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114048] = 4,
    ACTIONS(3054), 1,
      anon_sym_RPAREN,
    ACTIONS(3056), 1,
      anon_sym_COMMA,
    STATE(2493), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114062] = 4,
    ACTIONS(1276), 1,
      anon_sym_COLON,
    ACTIONS(4281), 1,
      anon_sym_COMMA,
    STATE(2346), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114076] = 4,
    ACTIONS(1154), 1,
      anon_sym_RPAREN,
    ACTIONS(4283), 1,
      anon_sym_COMMA,
    STATE(2474), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114090] = 4,
    ACTIONS(3516), 1,
      anon_sym_COMMA,
    ACTIONS(4285), 1,
      anon_sym_RBRACK,
    STATE(2441), 1,
      aux_sym_type_parameter_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114104] = 4,
    ACTIONS(1148), 1,
      anon_sym_RPAREN,
    ACTIONS(4287), 1,
      anon_sym_COMMA,
    STATE(2474), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114118] = 4,
    ACTIONS(4289), 1,
      anon_sym_COMMA,
    ACTIONS(4291), 1,
      anon_sym_COLON,
    STATE(2443), 1,
      aux_sym_with_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114132] = 4,
    ACTIONS(4293), 1,
      anon_sym_COMMA,
    ACTIONS(4295), 1,
      anon_sym_RBRACK,
    STATE(2422), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114146] = 4,
    ACTIONS(4297), 1,
      anon_sym_COMMA,
    ACTIONS(4299), 1,
      anon_sym_RBRACK,
    STATE(2422), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114160] = 4,
    ACTIONS(4301), 1,
      anon_sym_COMMA,
    ACTIONS(4303), 1,
      anon_sym_RBRACK,
    STATE(2422), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114174] = 4,
    ACTIONS(3336), 1,
      anon_sym_COMMA,
    ACTIONS(3338), 1,
      anon_sym_RBRACK,
    STATE(2367), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114188] = 4,
    ACTIONS(3384), 1,
      anon_sym_COMMA,
    ACTIONS(3386), 1,
      anon_sym_RBRACE,
    STATE(2385), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114202] = 4,
    ACTIONS(4305), 1,
      anon_sym_COMMA,
    ACTIONS(4307), 1,
      anon_sym_RBRACK,
    STATE(2422), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114216] = 4,
    ACTIONS(4309), 1,
      sym__newline,
    ACTIONS(4311), 1,
      sym__indent,
    STATE(768), 1,
      sym__match_block,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114230] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3634), 3,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
  [114240] = 3,
    ACTIONS(4315), 1,
      aux_sym_format_specifier_token1,
    ACTIONS(5), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4313), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [114252] = 4,
    ACTIONS(634), 1,
      sym__newline,
    ACTIONS(4317), 1,
      anon_sym_SEMI,
    STATE(2378), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114266] = 3,
    ACTIONS(4321), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4319), 2,
      sym__newline,
      anon_sym_SEMI,
  [114278] = 4,
    ACTIONS(4323), 1,
      anon_sym_SEMI,
    ACTIONS(4326), 1,
      sym__newline,
    STATE(2378), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114292] = 4,
    ACTIONS(4232), 1,
      anon_sym_RPAREN,
    ACTIONS(4328), 1,
      anon_sym_COMMA,
    STATE(2379), 1,
      aux_sym_with_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114306] = 4,
    ACTIONS(3801), 1,
      anon_sym_DOT,
    ACTIONS(3805), 1,
      anon_sym_PIPE,
    ACTIONS(4331), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114320] = 4,
    ACTIONS(4333), 1,
      anon_sym_COMMA,
    ACTIONS(4335), 1,
      anon_sym_RBRACK,
    STATE(2422), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114334] = 4,
    ACTIONS(4337), 1,
      anon_sym_COMMA,
    ACTIONS(4339), 1,
      anon_sym_RBRACK,
    STATE(2422), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114348] = 4,
    ACTIONS(1166), 1,
      anon_sym_RPAREN,
    ACTIONS(4341), 1,
      anon_sym_COMMA,
    STATE(2474), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114362] = 4,
    ACTIONS(4279), 1,
      anon_sym_RPAREN,
    ACTIONS(4343), 1,
      anon_sym_COMMA,
    STATE(2384), 1,
      aux_sym__parameters_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114376] = 4,
    ACTIONS(1298), 1,
      anon_sym_RBRACE,
    ACTIONS(4346), 1,
      anon_sym_COMMA,
    STATE(2354), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114390] = 4,
    ACTIONS(1170), 1,
      anon_sym_RPAREN,
    ACTIONS(4348), 1,
      anon_sym_COMMA,
    STATE(2474), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114404] = 4,
    ACTIONS(3286), 1,
      anon_sym_COMMA,
    ACTIONS(3288), 1,
      anon_sym_RBRACK,
    STATE(2381), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114418] = 4,
    ACTIONS(3745), 1,
      anon_sym_COLON,
    ACTIONS(4350), 1,
      anon_sym_RBRACE,
    STATE(2736), 1,
      sym_format_specifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114432] = 3,
    ACTIONS(1657), 1,
      anon_sym_except,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1659), 2,
      anon_sym_except_STAR,
      anon_sym_finally,
  [114444] = 4,
    ACTIONS(4352), 1,
      anon_sym_RPAREN,
    ACTIONS(4354), 1,
      anon_sym_COMMA,
    STATE(2383), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114458] = 4,
    ACTIONS(3058), 1,
      anon_sym_RPAREN,
    ACTIONS(3060), 1,
      anon_sym_COMMA,
    STATE(2402), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114472] = 4,
    ACTIONS(4356), 1,
      anon_sym_RPAREN,
    ACTIONS(4358), 1,
      anon_sym_COMMA,
    STATE(2404), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114486] = 4,
    ACTIONS(3093), 1,
      anon_sym_RPAREN,
    ACTIONS(3095), 1,
      anon_sym_COMMA,
    STATE(2386), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114500] = 4,
    ACTIONS(3745), 1,
      anon_sym_COLON,
    ACTIONS(4360), 1,
      anon_sym_RBRACE,
    STATE(2690), 1,
      sym_format_specifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114514] = 4,
    ACTIONS(3332), 1,
      anon_sym_COMMA,
    ACTIONS(3334), 1,
      anon_sym_RBRACK,
    STATE(2407), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114528] = 4,
    ACTIONS(2979), 1,
      anon_sym_COLON,
    ACTIONS(4362), 1,
      anon_sym_COMMA,
    STATE(2360), 1,
      aux_sym__parameters_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114542] = 4,
    ACTIONS(4364), 1,
      anon_sym_COMMA,
    ACTIONS(4366), 1,
      anon_sym_RBRACK,
    STATE(2422), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114556] = 4,
    ACTIONS(4368), 1,
      anon_sym_COMMA,
    ACTIONS(4370), 1,
      anon_sym_RBRACK,
    STATE(2422), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114570] = 4,
    ACTIONS(4372), 1,
      anon_sym_COMMA,
    ACTIONS(4374), 1,
      anon_sym_RBRACE,
    STATE(2349), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114584] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2319), 3,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_in,
  [114594] = 4,
    ACTIONS(1146), 1,
      anon_sym_RPAREN,
    ACTIONS(4376), 1,
      anon_sym_COMMA,
    STATE(2474), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114608] = 4,
    ACTIONS(1126), 1,
      anon_sym_RPAREN,
    ACTIONS(4378), 1,
      anon_sym_COMMA,
    STATE(2474), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114622] = 4,
    ACTIONS(3745), 1,
      anon_sym_COLON,
    ACTIONS(4380), 1,
      anon_sym_RBRACE,
    STATE(2652), 1,
      sym_format_specifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114636] = 4,
    ACTIONS(1184), 1,
      anon_sym_RPAREN,
    ACTIONS(4382), 1,
      anon_sym_COMMA,
    STATE(2474), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114650] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1647), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
  [114660] = 4,
    ACTIONS(4384), 1,
      anon_sym_COMMA,
    ACTIONS(4386), 1,
      anon_sym_RBRACK,
    STATE(2422), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114674] = 4,
    ACTIONS(4388), 1,
      anon_sym_COMMA,
    ACTIONS(4390), 1,
      anon_sym_RBRACK,
    STATE(2422), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114688] = 4,
    ACTIONS(3516), 1,
      anon_sym_COMMA,
    ACTIONS(4392), 1,
      anon_sym_RBRACK,
    STATE(2441), 1,
      aux_sym_type_parameter_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114702] = 4,
    ACTIONS(3442), 1,
      anon_sym_COMMA,
    ACTIONS(3444), 1,
      anon_sym_RBRACE,
    STATE(2411), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114716] = 4,
    ACTIONS(1282), 1,
      anon_sym_RBRACE,
    ACTIONS(4394), 1,
      anon_sym_COMMA,
    STATE(2354), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114730] = 4,
    ACTIONS(1284), 1,
      anon_sym_RBRACE,
    ACTIONS(4396), 1,
      anon_sym_COMMA,
    STATE(2354), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114744] = 4,
    ACTIONS(2989), 1,
      anon_sym_COMMA,
    ACTIONS(3001), 1,
      anon_sym_RBRACE,
    STATE(2271), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114758] = 4,
    ACTIONS(3424), 1,
      sym_identifier,
    STATE(2244), 1,
      sym_dotted_name,
    STATE(2296), 1,
      sym_aliased_import,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114772] = 4,
    ACTIONS(3544), 1,
      anon_sym_PIPE,
    ACTIONS(4398), 1,
      anon_sym_COLON,
    STATE(1926), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114786] = 4,
    ACTIONS(3942), 1,
      anon_sym_RPAREN,
    ACTIONS(4400), 1,
      anon_sym_COMMA,
    STATE(2415), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114800] = 4,
    ACTIONS(628), 1,
      sym__newline,
    ACTIONS(4403), 1,
      anon_sym_SEMI,
    STATE(2378), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114814] = 4,
    ACTIONS(3438), 1,
      anon_sym_COMMA,
    ACTIONS(3440), 1,
      anon_sym_RBRACE,
    STATE(2410), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114828] = 3,
    ACTIONS(3626), 1,
      aux_sym_format_specifier_token1,
    ACTIONS(5), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3628), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [114840] = 4,
    ACTIONS(4062), 1,
      anon_sym_COMMA,
    ACTIONS(4405), 1,
      anon_sym_in,
    STATE(2507), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114854] = 4,
    ACTIONS(4407), 1,
      anon_sym_COMMA,
    ACTIONS(4409), 1,
      anon_sym_RBRACE,
    STATE(2431), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114868] = 4,
    ACTIONS(3056), 1,
      anon_sym_COMMA,
    ACTIONS(3107), 1,
      anon_sym_RPAREN,
    STATE(2493), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114882] = 4,
    ACTIONS(4411), 1,
      anon_sym_COMMA,
    ACTIONS(4414), 1,
      anon_sym_RBRACK,
    STATE(2422), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114896] = 4,
    ACTIONS(3801), 1,
      anon_sym_DOT,
    ACTIONS(3805), 1,
      anon_sym_PIPE,
    ACTIONS(4416), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114910] = 4,
    ACTIONS(4418), 1,
      anon_sym_SEMI,
    ACTIONS(4420), 1,
      sym__newline,
    STATE(2416), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114924] = 3,
    ACTIONS(3603), 1,
      aux_sym_format_specifier_token1,
    ACTIONS(5), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3605), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [114936] = 4,
    ACTIONS(2667), 1,
      anon_sym_RPAREN,
    ACTIONS(4422), 1,
      anon_sym_COMMA,
    STATE(2415), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114950] = 3,
    ACTIONS(4424), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3908), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [114962] = 4,
    ACTIONS(2665), 1,
      anon_sym_RBRACK,
    ACTIONS(4426), 1,
      anon_sym_COMMA,
    STATE(2490), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114976] = 4,
    ACTIONS(4115), 1,
      anon_sym_COLON,
    ACTIONS(4428), 1,
      anon_sym_COMMA,
    STATE(2396), 1,
      aux_sym__parameters_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114990] = 4,
    ACTIONS(4309), 1,
      sym__newline,
    ACTIONS(4311), 1,
      sym__indent,
    STATE(765), 1,
      sym__match_block,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115004] = 4,
    ACTIONS(4430), 1,
      anon_sym_COMMA,
    ACTIONS(4432), 1,
      anon_sym_RBRACE,
    STATE(2298), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115018] = 4,
    ACTIONS(4107), 1,
      sym__newline,
    ACTIONS(4109), 1,
      sym__indent,
    STATE(822), 1,
      sym__match_block,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115032] = 4,
    ACTIONS(4434), 1,
      anon_sym_COMMA,
    ACTIONS(4436), 1,
      anon_sym_RBRACE,
    STATE(2298), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115046] = 3,
    ACTIONS(4424), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3908), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [115058] = 3,
    ACTIONS(3599), 1,
      aux_sym_format_specifier_token1,
    ACTIONS(5), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3601), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [115070] = 4,
    ACTIONS(3315), 1,
      anon_sym_COMMA,
    ACTIONS(3317), 1,
      anon_sym_RBRACK,
    STATE(2397), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115084] = 4,
    ACTIONS(4438), 1,
      anon_sym_RPAREN,
    ACTIONS(4440), 1,
      anon_sym_COMMA,
    STATE(2401), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115098] = 4,
    ACTIONS(3081), 1,
      anon_sym_RPAREN,
    ACTIONS(3083), 1,
      anon_sym_COMMA,
    STATE(2308), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115112] = 3,
    ACTIONS(3587), 1,
      aux_sym_format_specifier_token1,
    ACTIONS(5), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3589), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [115124] = 4,
    ACTIONS(2693), 1,
      anon_sym_RPAREN,
    ACTIONS(4442), 1,
      anon_sym_COMMA,
    STATE(2415), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115138] = 4,
    ACTIONS(3771), 1,
      anon_sym_RBRACK,
    ACTIONS(4444), 1,
      anon_sym_COMMA,
    STATE(2441), 1,
      aux_sym_type_parameter_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115152] = 4,
    ACTIONS(2887), 1,
      anon_sym_in,
    ACTIONS(4447), 1,
      anon_sym_COMMA,
    STATE(2442), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115166] = 4,
    ACTIONS(1422), 1,
      anon_sym_COLON,
    ACTIONS(4450), 1,
      anon_sym_COMMA,
    STATE(2342), 1,
      aux_sym_with_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115180] = 4,
    ACTIONS(644), 1,
      sym__newline,
    ACTIONS(4452), 1,
      anon_sym_SEMI,
    STATE(2378), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115194] = 4,
    ACTIONS(4454), 1,
      anon_sym_COMMA,
    ACTIONS(4456), 1,
      anon_sym_RBRACK,
    STATE(2422), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115208] = 4,
    ACTIONS(4458), 1,
      anon_sym_COMMA,
    ACTIONS(4460), 1,
      anon_sym_RBRACK,
    STATE(2422), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115222] = 4,
    ACTIONS(3821), 1,
      anon_sym_LPAREN,
    ACTIONS(4462), 1,
      anon_sym_COLON,
    STATE(2718), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115236] = 4,
    ACTIONS(3918), 1,
      sym_identifier,
    STATE(2352), 1,
      sym_dotted_name,
    STATE(2595), 1,
      sym_aliased_import,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115250] = 4,
    ACTIONS(1200), 1,
      anon_sym_RPAREN,
    ACTIONS(4464), 1,
      anon_sym_COMMA,
    STATE(2474), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115264] = 4,
    ACTIONS(4466), 1,
      anon_sym_SEMI,
    ACTIONS(4468), 1,
      sym__newline,
    STATE(2469), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115278] = 4,
    ACTIONS(1202), 1,
      anon_sym_RPAREN,
    ACTIONS(4470), 1,
      anon_sym_COMMA,
    STATE(2474), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115292] = 4,
    ACTIONS(4309), 1,
      sym__newline,
    ACTIONS(4311), 1,
      sym__indent,
    STATE(798), 1,
      sym__match_block,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115306] = 4,
    ACTIONS(1304), 1,
      anon_sym_RBRACE,
    ACTIONS(4472), 1,
      anon_sym_COMMA,
    STATE(2354), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115320] = 4,
    ACTIONS(3262), 1,
      anon_sym_COMMA,
    ACTIONS(3266), 1,
      anon_sym_RBRACK,
    STATE(2445), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115334] = 4,
    ACTIONS(3801), 1,
      anon_sym_DOT,
    ACTIONS(3805), 1,
      anon_sym_PIPE,
    ACTIONS(4474), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115348] = 4,
    ACTIONS(3056), 1,
      anon_sym_COMMA,
    ACTIONS(3067), 1,
      anon_sym_RPAREN,
    STATE(2493), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115362] = 4,
    ACTIONS(4476), 1,
      anon_sym_RPAREN,
    ACTIONS(4478), 1,
      anon_sym_COMMA,
    STATE(2449), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115376] = 3,
    ACTIONS(1693), 1,
      anon_sym_except,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1695), 2,
      anon_sym_except_STAR,
      anon_sym_finally,
  [115388] = 4,
    ACTIONS(3101), 1,
      anon_sym_RPAREN,
    ACTIONS(3103), 1,
      anon_sym_COMMA,
    STATE(2451), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115402] = 3,
    ACTIONS(3663), 1,
      aux_sym_format_specifier_token1,
    ACTIONS(5), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3665), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [115414] = 4,
    ACTIONS(1314), 1,
      anon_sym_RBRACE,
    ACTIONS(4480), 1,
      anon_sym_COMMA,
    STATE(2354), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115428] = 3,
    ACTIONS(3675), 1,
      aux_sym_format_specifier_token1,
    ACTIONS(5), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3677), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [115440] = 4,
    ACTIONS(632), 1,
      sym__newline,
    ACTIONS(4482), 1,
      anon_sym_SEMI,
    STATE(2378), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115454] = 4,
    ACTIONS(3340), 1,
      anon_sym_COMMA,
    ACTIONS(3342), 1,
      anon_sym_RBRACE,
    STATE(2477), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115468] = 3,
    ACTIONS(3679), 1,
      aux_sym_format_specifier_token1,
    ACTIONS(5), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3681), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [115480] = 4,
    ACTIONS(3371), 1,
      anon_sym_COMMA,
    ACTIONS(3373), 1,
      anon_sym_RBRACE,
    STATE(2461), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115494] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3944), 3,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
  [115504] = 4,
    ACTIONS(4484), 1,
      anon_sym_COMMA,
    ACTIONS(4486), 1,
      anon_sym_COLON,
    STATE(2309), 1,
      aux_sym_match_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115518] = 4,
    ACTIONS(642), 1,
      sym__newline,
    ACTIONS(4488), 1,
      anon_sym_SEMI,
    STATE(2378), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115532] = 4,
    ACTIONS(3056), 1,
      anon_sym_COMMA,
    ACTIONS(3091), 1,
      anon_sym_RPAREN,
    STATE(2493), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115546] = 4,
    ACTIONS(4490), 1,
      anon_sym_SEMI,
    ACTIONS(4492), 1,
      sym__newline,
    STATE(2463), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115560] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3634), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
  [115570] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3634), 3,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
  [115580] = 4,
    ACTIONS(3585), 1,
      anon_sym_RPAREN,
    ACTIONS(4494), 1,
      anon_sym_COMMA,
    STATE(2474), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115594] = 4,
    ACTIONS(4497), 1,
      anon_sym_SEMI,
    ACTIONS(4499), 1,
      sym__newline,
    STATE(2508), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115608] = 4,
    ACTIONS(4501), 1,
      anon_sym_COMMA,
    ACTIONS(4503), 1,
      anon_sym_RBRACK,
    STATE(2422), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115622] = 4,
    ACTIONS(1306), 1,
      anon_sym_RBRACE,
    ACTIONS(4505), 1,
      anon_sym_COMMA,
    STATE(2354), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115636] = 4,
    ACTIONS(4507), 1,
      anon_sym_COMMA,
    ACTIONS(4509), 1,
      anon_sym_RBRACK,
    STATE(2422), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115650] = 4,
    ACTIONS(3056), 1,
      anon_sym_COMMA,
    ACTIONS(3089), 1,
      anon_sym_RPAREN,
    STATE(2493), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115664] = 4,
    ACTIONS(1162), 1,
      anon_sym_RPAREN,
    ACTIONS(4511), 1,
      anon_sym_COMMA,
    STATE(2474), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115678] = 4,
    ACTIONS(4309), 1,
      sym__newline,
    ACTIONS(4311), 1,
      sym__indent,
    STATE(724), 1,
      sym__match_block,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115692] = 4,
    ACTIONS(3056), 1,
      anon_sym_COMMA,
    ACTIONS(4513), 1,
      anon_sym_RPAREN,
    STATE(2493), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115706] = 4,
    ACTIONS(3069), 1,
      anon_sym_RPAREN,
    ACTIONS(3071), 1,
      anon_sym_COMMA,
    STATE(2492), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115720] = 4,
    ACTIONS(4515), 1,
      anon_sym_RPAREN,
    ACTIONS(4517), 1,
      anon_sym_COMMA,
    STATE(2494), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115734] = 4,
    ACTIONS(1158), 1,
      anon_sym_RPAREN,
    ACTIONS(4519), 1,
      anon_sym_COMMA,
    STATE(2474), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115748] = 4,
    ACTIONS(3056), 1,
      anon_sym_COMMA,
    ACTIONS(4521), 1,
      anon_sym_RPAREN,
    STATE(2493), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115762] = 4,
    ACTIONS(3305), 1,
      anon_sym_COMMA,
    ACTIONS(3307), 1,
      anon_sym_RBRACK,
    STATE(2497), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115776] = 4,
    ACTIONS(3056), 1,
      anon_sym_COMMA,
    ACTIONS(4523), 1,
      anon_sym_RPAREN,
    STATE(2493), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115790] = 4,
    ACTIONS(3056), 1,
      anon_sym_COMMA,
    ACTIONS(4525), 1,
      anon_sym_RPAREN,
    STATE(2493), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115804] = 4,
    ACTIONS(3942), 1,
      anon_sym_RBRACK,
    ACTIONS(4527), 1,
      anon_sym_COMMA,
    STATE(2490), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115818] = 4,
    ACTIONS(4530), 1,
      anon_sym_RPAREN,
    ACTIONS(4532), 1,
      anon_sym_COMMA,
    STATE(2336), 1,
      aux_sym_with_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115832] = 4,
    ACTIONS(1152), 1,
      anon_sym_RPAREN,
    ACTIONS(4534), 1,
      anon_sym_COMMA,
    STATE(2474), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115846] = 4,
    ACTIONS(1270), 1,
      anon_sym_RPAREN,
    ACTIONS(4536), 1,
      anon_sym_COMMA,
    STATE(2295), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115860] = 4,
    ACTIONS(1164), 1,
      anon_sym_RPAREN,
    ACTIONS(4538), 1,
      anon_sym_COMMA,
    STATE(2474), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115874] = 4,
    ACTIONS(3282), 1,
      anon_sym_COMMA,
    ACTIONS(3284), 1,
      anon_sym_RBRACK,
    STATE(2476), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115888] = 4,
    ACTIONS(4540), 1,
      anon_sym_COMMA,
    ACTIONS(4542), 1,
      anon_sym_RBRACK,
    STATE(2422), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115902] = 4,
    ACTIONS(4544), 1,
      anon_sym_COMMA,
    ACTIONS(4546), 1,
      anon_sym_RBRACK,
    STATE(2422), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115916] = 4,
    ACTIONS(4548), 1,
      anon_sym_RPAREN,
    ACTIONS(4550), 1,
      anon_sym_COMMA,
    STATE(2480), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115930] = 4,
    ACTIONS(3024), 1,
      anon_sym_RPAREN,
    ACTIONS(3026), 1,
      anon_sym_COMMA,
    STATE(2485), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115944] = 4,
    ACTIONS(4062), 1,
      anon_sym_COMMA,
    ACTIONS(4552), 1,
      anon_sym_in,
    STATE(2507), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115958] = 4,
    ACTIONS(4554), 1,
      anon_sym_COMMA,
    ACTIONS(4556), 1,
      anon_sym_COLON,
    STATE(2309), 1,
      aux_sym_match_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115972] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3944), 3,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
  [115982] = 4,
    ACTIONS(4107), 1,
      sym__newline,
    ACTIONS(4109), 1,
      sym__indent,
    STATE(753), 1,
      sym__match_block,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115996] = 4,
    ACTIONS(1280), 1,
      anon_sym_RBRACE,
    ACTIONS(4558), 1,
      anon_sym_COMMA,
    STATE(2354), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116010] = 4,
    ACTIONS(3516), 1,
      anon_sym_COMMA,
    ACTIONS(4560), 1,
      anon_sym_RBRACK,
    STATE(2441), 1,
      aux_sym_type_parameter_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116024] = 4,
    ACTIONS(1955), 1,
      anon_sym_RPAREN,
    ACTIONS(4562), 1,
      anon_sym_COMMA,
    STATE(2339), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116038] = 4,
    ACTIONS(970), 1,
      anon_sym_in,
    ACTIONS(4564), 1,
      anon_sym_COMMA,
    STATE(2442), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116052] = 4,
    ACTIONS(620), 1,
      sym__newline,
    ACTIONS(4566), 1,
      anon_sym_SEMI,
    STATE(2378), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116066] = 3,
    ACTIONS(3924), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3942), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [116078] = 4,
    ACTIONS(4568), 1,
      anon_sym_SEMI,
    ACTIONS(4570), 1,
      sym__newline,
    STATE(2511), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116092] = 4,
    ACTIONS(638), 1,
      sym__newline,
    ACTIONS(4572), 1,
      anon_sym_SEMI,
    STATE(2378), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116106] = 4,
    ACTIONS(3801), 1,
      anon_sym_DOT,
    ACTIONS(3805), 1,
      anon_sym_PIPE,
    ACTIONS(4574), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116120] = 4,
    ACTIONS(3455), 1,
      anon_sym_COMMA,
    ACTIONS(3457), 1,
      anon_sym_RBRACE,
    STATE(2504), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116134] = 4,
    ACTIONS(3242), 1,
      anon_sym_RBRACK,
    ACTIONS(4576), 1,
      anon_sym_COMMA,
    STATE(2514), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116148] = 4,
    ACTIONS(3056), 1,
      anon_sym_COMMA,
    ACTIONS(3079), 1,
      anon_sym_RPAREN,
    STATE(2493), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116162] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4579), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [116171] = 3,
    ACTIONS(4581), 1,
      sym_integer,
    ACTIONS(4583), 1,
      sym_float,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116182] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1669), 2,
      sym__dedent,
      anon_sym_case,
  [116191] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4585), 2,
      sym__newline,
      anon_sym_SEMI,
  [116200] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4587), 2,
      sym__newline,
      anon_sym_SEMI,
  [116209] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4589), 2,
      sym__newline,
      anon_sym_SEMI,
  [116218] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4591), 2,
      sym__newline,
      anon_sym_SEMI,
  [116227] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4593), 2,
      sym__newline,
      anon_sym_SEMI,
  [116236] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2887), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [116245] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4595), 2,
      sym__newline,
      anon_sym_SEMI,
  [116254] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2912), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [116263] = 3,
    ACTIONS(3920), 1,
      anon_sym_LPAREN,
    STATE(2576), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116274] = 3,
    ACTIONS(3920), 1,
      anon_sym_LPAREN,
    STATE(2579), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116285] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4597), 2,
      sym__newline,
      anon_sym_SEMI,
  [116294] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3073), 2,
      sym__newline,
      anon_sym_SEMI,
  [116303] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1542), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [116312] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3908), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [116321] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4599), 2,
      sym__dedent,
      anon_sym_case,
  [116330] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4601), 2,
      sym__dedent,
      anon_sym_case,
  [116339] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4603), 2,
      sym__newline,
      anon_sym_SEMI,
  [116348] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4605), 2,
      sym__dedent,
      anon_sym_case,
  [116357] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4607), 2,
      sym__dedent,
      anon_sym_case,
  [116366] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1665), 2,
      sym__dedent,
      anon_sym_case,
  [116375] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4609), 2,
      sym__dedent,
      anon_sym_case,
  [116384] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2914), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [116393] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4611), 2,
      sym__dedent,
      anon_sym_case,
  [116402] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4613), 2,
      sym__dedent,
      anon_sym_case,
  [116411] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3585), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [116420] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1659), 2,
      sym__dedent,
      anon_sym_case,
  [116429] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3136), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [116438] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1695), 2,
      sym__dedent,
      anon_sym_case,
  [116447] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4615), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [116456] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4579), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [116465] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3499), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [116474] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1713), 2,
      sym__dedent,
      anon_sym_case,
  [116483] = 3,
    ACTIONS(4617), 1,
      anon_sym_COLON,
    ACTIONS(4619), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116494] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4621), 2,
      sym__dedent,
      anon_sym_case,
  [116503] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4623), 2,
      sym__dedent,
      anon_sym_case,
  [116512] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4625), 2,
      sym__dedent,
      anon_sym_case,
  [116521] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3136), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [116530] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4627), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [116539] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4615), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [116548] = 3,
    ACTIONS(3920), 1,
      anon_sym_LPAREN,
    STATE(2590), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116559] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4629), 2,
      sym__dedent,
      anon_sym_case,
  [116568] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4579), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [116577] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3414), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [116586] = 3,
    ACTIONS(4631), 1,
      anon_sym_COLON,
    ACTIONS(4633), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116597] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3499), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [116606] = 3,
    ACTIONS(4635), 1,
      anon_sym_COLON,
    ACTIONS(4637), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116617] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3248), 2,
      sym__newline,
      anon_sym_SEMI,
  [116626] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4639), 2,
      anon_sym__,
      sym_identifier,
  [116635] = 3,
    ACTIONS(4641), 1,
      sym_integer,
    ACTIONS(4643), 1,
      sym_float,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116646] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4645), 2,
      sym__newline,
      anon_sym_SEMI,
  [116655] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4647), 2,
      sym__newline,
      anon_sym_SEMI,
  [116664] = 3,
    ACTIONS(4649), 1,
      sym_integer,
    ACTIONS(4651), 1,
      sym_float,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116675] = 3,
    ACTIONS(3920), 1,
      anon_sym_LPAREN,
    STATE(2562), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116686] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4099), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [116695] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2912), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [116704] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4653), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [116713] = 3,
    ACTIONS(4655), 1,
      sym_integer,
    ACTIONS(4657), 1,
      sym_float,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116724] = 3,
    ACTIONS(4659), 1,
      anon_sym_COLON,
    ACTIONS(4661), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116735] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4663), 2,
      anon_sym__,
      sym_identifier,
  [116744] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4665), 2,
      sym__dedent,
      anon_sym_case,
  [116753] = 3,
    ACTIONS(4667), 1,
      anon_sym_COLON,
    ACTIONS(4669), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116764] = 3,
    ACTIONS(4671), 1,
      sym_integer,
    ACTIONS(4673), 1,
      sym_float,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116775] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4675), 2,
      anon_sym_COLON,
      anon_sym_DASH_GT,
  [116784] = 3,
    ACTIONS(4677), 1,
      anon_sym_COLON,
    ACTIONS(4679), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116795] = 3,
    ACTIONS(4681), 1,
      anon_sym_COMMA,
    STATE(1930), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116806] = 3,
    ACTIONS(4683), 1,
      anon_sym_COLON,
    ACTIONS(4685), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116817] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3323), 2,
      sym__newline,
      anon_sym_SEMI,
  [116826] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4232), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [116835] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2887), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [116844] = 3,
    ACTIONS(4687), 1,
      sym_integer,
    ACTIONS(4689), 1,
      sym_float,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116855] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4691), 2,
      anon_sym_COLON,
      anon_sym_DASH_GT,
  [116864] = 3,
    ACTIONS(4693), 1,
      anon_sym_COLON,
    ACTIONS(4695), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116875] = 3,
    ACTIONS(4697), 1,
      sym_integer,
    ACTIONS(4699), 1,
      sym_float,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116886] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4701), 2,
      anon_sym__,
      sym_identifier,
  [116895] = 3,
    ACTIONS(4703), 1,
      sym_integer,
    ACTIONS(4705), 1,
      sym_float,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116906] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4707), 2,
      sym__newline,
      anon_sym_SEMI,
  [116915] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4047), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [116924] = 3,
    ACTIONS(4709), 1,
      sym_integer,
    ACTIONS(4711), 1,
      sym_float,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116935] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4713), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [116944] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4715), 2,
      sym__newline,
      anon_sym_SEMI,
  [116953] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4279), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [116962] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4717), 2,
      sym__newline,
      anon_sym_SEMI,
  [116971] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4615), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [116980] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3499), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [116989] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4232), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [116998] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4279), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [117007] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4326), 2,
      sym__newline,
      anon_sym_SEMI,
  [117016] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4260), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [117025] = 3,
    ACTIONS(4719), 1,
      sym_integer,
    ACTIONS(4721), 1,
      sym_float,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117036] = 3,
    ACTIONS(4723), 1,
      sym_integer,
    ACTIONS(4725), 1,
      sym_float,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117047] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4727), 2,
      sym__dedent,
      anon_sym_case,
  [117056] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3136), 2,
      sym__newline,
      anon_sym_SEMI,
  [117065] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3908), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [117074] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4729), 2,
      anon_sym__,
      sym_identifier,
  [117083] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3908), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [117092] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4713), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [117101] = 3,
    ACTIONS(4731), 1,
      sym_integer,
    ACTIONS(4733), 1,
      sym_float,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117112] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1542), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [117121] = 2,
    ACTIONS(4735), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117129] = 2,
    ACTIONS(4737), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117137] = 2,
    ACTIONS(4739), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117145] = 2,
    ACTIONS(3081), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117153] = 2,
    ACTIONS(3467), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117161] = 2,
    ACTIONS(4741), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117169] = 2,
    ACTIONS(4743), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117177] = 2,
    ACTIONS(4745), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117185] = 2,
    ACTIONS(4747), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117193] = 2,
    ACTIONS(4749), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117201] = 2,
    ACTIONS(4751), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117209] = 2,
    ACTIONS(4753), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117217] = 2,
    ACTIONS(4405), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117225] = 2,
    ACTIONS(4755), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117233] = 2,
    ACTIONS(3440), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117241] = 2,
    ACTIONS(4757), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117249] = 2,
    ACTIONS(4759), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117257] = 2,
    ACTIONS(4761), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117265] = 2,
    ACTIONS(4763), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117273] = 2,
    ACTIONS(4765), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117281] = 2,
    ACTIONS(4767), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117289] = 2,
    ACTIONS(4769), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117297] = 2,
    ACTIONS(4771), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117305] = 2,
    ACTIONS(4773), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117313] = 2,
    ACTIONS(4775), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117321] = 2,
    ACTIONS(4777), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117329] = 2,
    ACTIONS(4779), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117337] = 2,
    ACTIONS(4781), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117345] = 2,
    ACTIONS(4783), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117353] = 2,
    ACTIONS(4785), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117361] = 2,
    ACTIONS(3093), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117369] = 2,
    ACTIONS(4787), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117377] = 2,
    ACTIONS(4789), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117385] = 2,
    ACTIONS(4791), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117393] = 2,
    ACTIONS(3058), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117401] = 2,
    ACTIONS(4793), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117409] = 2,
    ACTIONS(3444), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117417] = 2,
    ACTIONS(4795), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117425] = 2,
    ACTIONS(4797), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117433] = 2,
    ACTIONS(4799), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117441] = 2,
    ACTIONS(4801), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117449] = 2,
    ACTIONS(4803), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117457] = 2,
    ACTIONS(4805), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117465] = 2,
    ACTIONS(4807), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117473] = 2,
    ACTIONS(4809), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117481] = 2,
    ACTIONS(4811), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117489] = 2,
    ACTIONS(4813), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117497] = 2,
    ACTIONS(4815), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117505] = 2,
    ACTIONS(4817), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117513] = 2,
    ACTIONS(4819), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117521] = 2,
    ACTIONS(4821), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117529] = 2,
    ACTIONS(4823), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117537] = 2,
    ACTIONS(4825), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117545] = 2,
    ACTIONS(4827), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117553] = 2,
    ACTIONS(4829), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117561] = 2,
    ACTIONS(4831), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117569] = 2,
    ACTIONS(4833), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117577] = 2,
    ACTIONS(4835), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117585] = 2,
    ACTIONS(3386), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117593] = 2,
    ACTIONS(4837), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117601] = 2,
    ACTIONS(4839), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117609] = 2,
    ACTIONS(4841), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117617] = 2,
    ACTIONS(4843), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117625] = 2,
    ACTIONS(4845), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117633] = 2,
    ACTIONS(4847), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117641] = 2,
    ACTIONS(4849), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117649] = 2,
    ACTIONS(4851), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117657] = 2,
    ACTIONS(4853), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117665] = 2,
    ACTIONS(4855), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117673] = 2,
    ACTIONS(4857), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117681] = 2,
    ACTIONS(4255), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117689] = 2,
    ACTIONS(4859), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117697] = 2,
    ACTIONS(4861), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117705] = 2,
    ACTIONS(4863), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117713] = 2,
    ACTIONS(4865), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117721] = 2,
    ACTIONS(4867), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117729] = 2,
    ACTIONS(4869), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117737] = 2,
    ACTIONS(4871), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117745] = 2,
    ACTIONS(3101), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117753] = 2,
    ACTIONS(4873), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117761] = 2,
    ACTIONS(4875), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117769] = 2,
    ACTIONS(1446), 1,
      anon_sym_def,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117777] = 2,
    ACTIONS(4877), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117785] = 2,
    ACTIONS(4879), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117793] = 2,
    ACTIONS(4881), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117801] = 2,
    ACTIONS(4883), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117809] = 2,
    ACTIONS(4885), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117817] = 2,
    ACTIONS(4887), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117825] = 2,
    ACTIONS(3342), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117833] = 2,
    ACTIONS(4889), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117841] = 2,
    ACTIONS(4891), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117849] = 2,
    ACTIONS(3097), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117857] = 2,
    ACTIONS(4893), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117865] = 2,
    ACTIONS(1420), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117873] = 2,
    ACTIONS(4208), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117881] = 2,
    ACTIONS(4895), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117889] = 2,
    ACTIONS(3388), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117897] = 2,
    ACTIONS(4897), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117905] = 2,
    ACTIONS(4899), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117913] = 2,
    ACTIONS(4901), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117921] = 2,
    ACTIONS(4903), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117929] = 2,
    ACTIONS(4905), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117937] = 2,
    ACTIONS(4907), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117945] = 2,
    ACTIONS(4200), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117953] = 2,
    ACTIONS(4909), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117961] = 2,
    ACTIONS(3377), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117969] = 2,
    ACTIONS(4911), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117977] = 2,
    ACTIONS(4913), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117985] = 2,
    ACTIONS(4915), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117993] = 2,
    ACTIONS(4917), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118001] = 2,
    ACTIONS(3418), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118009] = 2,
    ACTIONS(3373), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118017] = 2,
    ACTIONS(4919), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118025] = 2,
    ACTIONS(4921), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118033] = 2,
    ACTIONS(4923), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118041] = 2,
    ACTIONS(4925), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118049] = 2,
    ACTIONS(4927), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118057] = 2,
    ACTIONS(4929), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118065] = 2,
    ACTIONS(4931), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118073] = 2,
    ACTIONS(4933), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118081] = 2,
    ACTIONS(4935), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118089] = 2,
    ACTIONS(4132), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118097] = 2,
    ACTIONS(4937), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118105] = 2,
    ACTIONS(4939), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118113] = 2,
    ACTIONS(4941), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118121] = 2,
    ACTIONS(4943), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118129] = 2,
    ACTIONS(4945), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118137] = 2,
    ACTIONS(3085), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118145] = 2,
    ACTIONS(4105), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118153] = 2,
    ACTIONS(4947), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118161] = 2,
    ACTIONS(4103), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118169] = 2,
    ACTIONS(4949), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118177] = 2,
    ACTIONS(4951), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118185] = 2,
    ACTIONS(4953), 1,
      anon_sym_import,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118193] = 2,
    ACTIONS(4955), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118201] = 2,
    ACTIONS(4957), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118209] = 2,
    ACTIONS(4959), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118217] = 2,
    ACTIONS(4961), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118225] = 2,
    ACTIONS(4963), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118233] = 2,
    ACTIONS(4965), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118241] = 2,
    ACTIONS(4967), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118249] = 2,
    ACTIONS(3069), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118257] = 2,
    ACTIONS(4969), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118265] = 2,
    ACTIONS(4971), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118273] = 2,
    ACTIONS(4973), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118281] = 2,
    ACTIONS(4975), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118289] = 2,
    ACTIONS(4977), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118297] = 2,
    ACTIONS(4979), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118305] = 2,
    ACTIONS(4981), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118313] = 2,
    ACTIONS(4983), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118321] = 2,
    ACTIONS(4985), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118329] = 2,
    ACTIONS(4987), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118337] = 2,
    ACTIONS(4989), 1,
      anon_sym_import,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118345] = 2,
    ACTIONS(4991), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118353] = 2,
    ACTIONS(4993), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118361] = 2,
    ACTIONS(4552), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118369] = 2,
    ACTIONS(4995), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118377] = 2,
    ACTIONS(4997), 1,
      anon_sym_import,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118385] = 2,
    ACTIONS(3024), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118393] = 2,
    ACTIONS(4999), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118401] = 2,
    ACTIONS(5001), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118409] = 2,
    ACTIONS(5003), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118417] = 2,
    ACTIONS(5005), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118425] = 2,
    ACTIONS(5007), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118433] = 2,
    ACTIONS(5009), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118441] = 2,
    ACTIONS(5011), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118449] = 2,
    ACTIONS(5013), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118457] = 2,
    ACTIONS(5015), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118465] = 2,
    ACTIONS(5017), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118473] = 2,
    ACTIONS(3358), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118481] = 2,
    ACTIONS(5019), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118489] = 2,
    ACTIONS(5021), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118497] = 2,
    ACTIONS(5023), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118505] = 2,
    ACTIONS(5025), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118513] = 2,
    ACTIONS(5027), 1,
      anon_sym_for,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118521] = 2,
    ACTIONS(5029), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118529] = 2,
    ACTIONS(5031), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118537] = 2,
    ACTIONS(5033), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118545] = 2,
    ACTIONS(5035), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118553] = 2,
    ACTIONS(5037), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118561] = 2,
    ACTIONS(5039), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118569] = 2,
    ACTIONS(5041), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118577] = 2,
    ACTIONS(5043), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118585] = 2,
    ACTIONS(5045), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118593] = 2,
    ACTIONS(5047), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118601] = 2,
    ACTIONS(5049), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118609] = 2,
    ACTIONS(5051), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118617] = 2,
    ACTIONS(5053), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118625] = 2,
    ACTIONS(5055), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118633] = 2,
    ACTIONS(3471), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118641] = 2,
    ACTIONS(5057), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118649] = 2,
    ACTIONS(5059), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118657] = 2,
    ACTIONS(5061), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118665] = 2,
    ACTIONS(3457), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118673] = 2,
    ACTIONS(4066), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118681] = 2,
    ACTIONS(1454), 1,
      anon_sym_def,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118689] = 2,
    ACTIONS(5063), 1,
      anon_sym_for,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118697] = 2,
    ACTIONS(5065), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118705] = 2,
    ACTIONS(4064), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118713] = 2,
    ACTIONS(5067), 1,
      anon_sym_for,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118721] = 2,
    ACTIONS(5069), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118729] = 2,
    ACTIONS(5071), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(189)] = 0,
  [SMALL_STATE(190)] = 126,
  [SMALL_STATE(191)] = 252,
  [SMALL_STATE(192)] = 376,
  [SMALL_STATE(193)] = 502,
  [SMALL_STATE(194)] = 628,
  [SMALL_STATE(195)] = 752,
  [SMALL_STATE(196)] = 876,
  [SMALL_STATE(197)] = 1000,
  [SMALL_STATE(198)] = 1128,
  [SMALL_STATE(199)] = 1252,
  [SMALL_STATE(200)] = 1376,
  [SMALL_STATE(201)] = 1500,
  [SMALL_STATE(202)] = 1626,
  [SMALL_STATE(203)] = 1750,
  [SMALL_STATE(204)] = 1870,
  [SMALL_STATE(205)] = 1996,
  [SMALL_STATE(206)] = 2120,
  [SMALL_STATE(207)] = 2248,
  [SMALL_STATE(208)] = 2368,
  [SMALL_STATE(209)] = 2492,
  [SMALL_STATE(210)] = 2618,
  [SMALL_STATE(211)] = 2742,
  [SMALL_STATE(212)] = 2866,
  [SMALL_STATE(213)] = 2990,
  [SMALL_STATE(214)] = 3114,
  [SMALL_STATE(215)] = 3238,
  [SMALL_STATE(216)] = 3362,
  [SMALL_STATE(217)] = 3482,
  [SMALL_STATE(218)] = 3606,
  [SMALL_STATE(219)] = 3732,
  [SMALL_STATE(220)] = 3858,
  [SMALL_STATE(221)] = 3982,
  [SMALL_STATE(222)] = 4106,
  [SMALL_STATE(223)] = 4213,
  [SMALL_STATE(224)] = 4320,
  [SMALL_STATE(225)] = 4436,
  [SMALL_STATE(226)] = 4552,
  [SMALL_STATE(227)] = 4667,
  [SMALL_STATE(228)] = 4778,
  [SMALL_STATE(229)] = 4889,
  [SMALL_STATE(230)] = 5000,
  [SMALL_STATE(231)] = 5115,
  [SMALL_STATE(232)] = 5226,
  [SMALL_STATE(233)] = 5337,
  [SMALL_STATE(234)] = 5452,
  [SMALL_STATE(235)] = 5557,
  [SMALL_STATE(236)] = 5668,
  [SMALL_STATE(237)] = 5783,
  [SMALL_STATE(238)] = 5894,
  [SMALL_STATE(239)] = 6005,
  [SMALL_STATE(240)] = 6116,
  [SMALL_STATE(241)] = 6231,
  [SMALL_STATE(242)] = 6342,
  [SMALL_STATE(243)] = 6457,
  [SMALL_STATE(244)] = 6568,
  [SMALL_STATE(245)] = 6679,
  [SMALL_STATE(246)] = 6790,
  [SMALL_STATE(247)] = 6895,
  [SMALL_STATE(248)] = 7006,
  [SMALL_STATE(249)] = 7121,
  [SMALL_STATE(250)] = 7232,
  [SMALL_STATE(251)] = 7343,
  [SMALL_STATE(252)] = 7454,
  [SMALL_STATE(253)] = 7569,
  [SMALL_STATE(254)] = 7680,
  [SMALL_STATE(255)] = 7791,
  [SMALL_STATE(256)] = 7902,
  [SMALL_STATE(257)] = 8013,
  [SMALL_STATE(258)] = 8124,
  [SMALL_STATE(259)] = 8235,
  [SMALL_STATE(260)] = 8346,
  [SMALL_STATE(261)] = 8457,
  [SMALL_STATE(262)] = 8568,
  [SMALL_STATE(263)] = 8683,
  [SMALL_STATE(264)] = 8800,
  [SMALL_STATE(265)] = 8912,
  [SMALL_STATE(266)] = 9024,
  [SMALL_STATE(267)] = 9136,
  [SMALL_STATE(268)] = 9252,
  [SMALL_STATE(269)] = 9364,
  [SMALL_STATE(270)] = 9476,
  [SMALL_STATE(271)] = 9590,
  [SMALL_STATE(272)] = 9702,
  [SMALL_STATE(273)] = 9814,
  [SMALL_STATE(274)] = 9930,
  [SMALL_STATE(275)] = 10042,
  [SMALL_STATE(276)] = 10154,
  [SMALL_STATE(277)] = 10266,
  [SMALL_STATE(278)] = 10378,
  [SMALL_STATE(279)] = 10490,
  [SMALL_STATE(280)] = 10602,
  [SMALL_STATE(281)] = 10714,
  [SMALL_STATE(282)] = 10826,
  [SMALL_STATE(283)] = 10938,
  [SMALL_STATE(284)] = 11050,
  [SMALL_STATE(285)] = 11162,
  [SMALL_STATE(286)] = 11274,
  [SMALL_STATE(287)] = 11386,
  [SMALL_STATE(288)] = 11498,
  [SMALL_STATE(289)] = 11614,
  [SMALL_STATE(290)] = 11726,
  [SMALL_STATE(291)] = 11838,
  [SMALL_STATE(292)] = 11950,
  [SMALL_STATE(293)] = 12062,
  [SMALL_STATE(294)] = 12176,
  [SMALL_STATE(295)] = 12290,
  [SMALL_STATE(296)] = 12402,
  [SMALL_STATE(297)] = 12514,
  [SMALL_STATE(298)] = 12630,
  [SMALL_STATE(299)] = 12742,
  [SMALL_STATE(300)] = 12854,
  [SMALL_STATE(301)] = 12966,
  [SMALL_STATE(302)] = 13078,
  [SMALL_STATE(303)] = 13192,
  [SMALL_STATE(304)] = 13304,
  [SMALL_STATE(305)] = 13416,
  [SMALL_STATE(306)] = 13532,
  [SMALL_STATE(307)] = 13646,
  [SMALL_STATE(308)] = 13758,
  [SMALL_STATE(309)] = 13872,
  [SMALL_STATE(310)] = 13984,
  [SMALL_STATE(311)] = 14100,
  [SMALL_STATE(312)] = 14212,
  [SMALL_STATE(313)] = 14326,
  [SMALL_STATE(314)] = 14438,
  [SMALL_STATE(315)] = 14550,
  [SMALL_STATE(316)] = 14664,
  [SMALL_STATE(317)] = 14776,
  [SMALL_STATE(318)] = 14888,
  [SMALL_STATE(319)] = 14997,
  [SMALL_STATE(320)] = 15106,
  [SMALL_STATE(321)] = 15215,
  [SMALL_STATE(322)] = 15324,
  [SMALL_STATE(323)] = 15433,
  [SMALL_STATE(324)] = 15542,
  [SMALL_STATE(325)] = 15647,
  [SMALL_STATE(326)] = 15756,
  [SMALL_STATE(327)] = 15865,
  [SMALL_STATE(328)] = 15974,
  [SMALL_STATE(329)] = 16083,
  [SMALL_STATE(330)] = 16192,
  [SMALL_STATE(331)] = 16301,
  [SMALL_STATE(332)] = 16410,
  [SMALL_STATE(333)] = 16519,
  [SMALL_STATE(334)] = 16628,
  [SMALL_STATE(335)] = 16737,
  [SMALL_STATE(336)] = 16846,
  [SMALL_STATE(337)] = 16955,
  [SMALL_STATE(338)] = 17064,
  [SMALL_STATE(339)] = 17169,
  [SMALL_STATE(340)] = 17266,
  [SMALL_STATE(341)] = 17374,
  [SMALL_STATE(342)] = 17482,
  [SMALL_STATE(343)] = 17590,
  [SMALL_STATE(344)] = 17698,
  [SMALL_STATE(345)] = 17806,
  [SMALL_STATE(346)] = 17914,
  [SMALL_STATE(347)] = 18022,
  [SMALL_STATE(348)] = 18130,
  [SMALL_STATE(349)] = 18238,
  [SMALL_STATE(350)] = 18344,
  [SMALL_STATE(351)] = 18450,
  [SMALL_STATE(352)] = 18558,
  [SMALL_STATE(353)] = 18666,
  [SMALL_STATE(354)] = 18774,
  [SMALL_STATE(355)] = 18882,
  [SMALL_STATE(356)] = 18990,
  [SMALL_STATE(357)] = 19098,
  [SMALL_STATE(358)] = 19206,
  [SMALL_STATE(359)] = 19314,
  [SMALL_STATE(360)] = 19422,
  [SMALL_STATE(361)] = 19530,
  [SMALL_STATE(362)] = 19638,
  [SMALL_STATE(363)] = 19744,
  [SMALL_STATE(364)] = 19851,
  [SMALL_STATE(365)] = 19958,
  [SMALL_STATE(366)] = 20065,
  [SMALL_STATE(367)] = 20172,
  [SMALL_STATE(368)] = 20279,
  [SMALL_STATE(369)] = 20384,
  [SMALL_STATE(370)] = 20491,
  [SMALL_STATE(371)] = 20598,
  [SMALL_STATE(372)] = 20705,
  [SMALL_STATE(373)] = 20812,
  [SMALL_STATE(374)] = 20907,
  [SMALL_STATE(375)] = 21014,
  [SMALL_STATE(376)] = 21119,
  [SMALL_STATE(377)] = 21224,
  [SMALL_STATE(378)] = 21331,
  [SMALL_STATE(379)] = 21438,
  [SMALL_STATE(380)] = 21545,
  [SMALL_STATE(381)] = 21652,
  [SMALL_STATE(382)] = 21759,
  [SMALL_STATE(383)] = 21864,
  [SMALL_STATE(384)] = 21971,
  [SMALL_STATE(385)] = 22078,
  [SMALL_STATE(386)] = 22185,
  [SMALL_STATE(387)] = 22290,
  [SMALL_STATE(388)] = 22397,
  [SMALL_STATE(389)] = 22502,
  [SMALL_STATE(390)] = 22609,
  [SMALL_STATE(391)] = 22716,
  [SMALL_STATE(392)] = 22823,
  [SMALL_STATE(393)] = 22930,
  [SMALL_STATE(394)] = 23037,
  [SMALL_STATE(395)] = 23144,
  [SMALL_STATE(396)] = 23251,
  [SMALL_STATE(397)] = 23358,
  [SMALL_STATE(398)] = 23453,
  [SMALL_STATE(399)] = 23560,
  [SMALL_STATE(400)] = 23667,
  [SMALL_STATE(401)] = 23774,
  [SMALL_STATE(402)] = 23876,
  [SMALL_STATE(403)] = 23978,
  [SMALL_STATE(404)] = 24080,
  [SMALL_STATE(405)] = 24174,
  [SMALL_STATE(406)] = 24276,
  [SMALL_STATE(407)] = 24378,
  [SMALL_STATE(408)] = 24480,
  [SMALL_STATE(409)] = 24582,
  [SMALL_STATE(410)] = 24684,
  [SMALL_STATE(411)] = 24786,
  [SMALL_STATE(412)] = 24882,
  [SMALL_STATE(413)] = 24984,
  [SMALL_STATE(414)] = 25086,
  [SMALL_STATE(415)] = 25188,
  [SMALL_STATE(416)] = 25290,
  [SMALL_STATE(417)] = 25392,
  [SMALL_STATE(418)] = 25494,
  [SMALL_STATE(419)] = 25598,
  [SMALL_STATE(420)] = 25700,
  [SMALL_STATE(421)] = 25804,
  [SMALL_STATE(422)] = 25906,
  [SMALL_STATE(423)] = 26008,
  [SMALL_STATE(424)] = 26112,
  [SMALL_STATE(425)] = 26216,
  [SMALL_STATE(426)] = 26318,
  [SMALL_STATE(427)] = 26420,
  [SMALL_STATE(428)] = 26524,
  [SMALL_STATE(429)] = 26628,
  [SMALL_STATE(430)] = 26730,
  [SMALL_STATE(431)] = 26834,
  [SMALL_STATE(432)] = 26938,
  [SMALL_STATE(433)] = 27032,
  [SMALL_STATE(434)] = 27136,
  [SMALL_STATE(435)] = 27240,
  [SMALL_STATE(436)] = 27342,
  [SMALL_STATE(437)] = 27446,
  [SMALL_STATE(438)] = 27550,
  [SMALL_STATE(439)] = 27654,
  [SMALL_STATE(440)] = 27758,
  [SMALL_STATE(441)] = 27862,
  [SMALL_STATE(442)] = 27956,
  [SMALL_STATE(443)] = 28060,
  [SMALL_STATE(444)] = 28162,
  [SMALL_STATE(445)] = 28264,
  [SMALL_STATE(446)] = 28368,
  [SMALL_STATE(447)] = 28470,
  [SMALL_STATE(448)] = 28574,
  [SMALL_STATE(449)] = 28676,
  [SMALL_STATE(450)] = 28770,
  [SMALL_STATE(451)] = 28872,
  [SMALL_STATE(452)] = 28974,
  [SMALL_STATE(453)] = 29078,
  [SMALL_STATE(454)] = 29179,
  [SMALL_STATE(455)] = 29280,
  [SMALL_STATE(456)] = 29357,
  [SMALL_STATE(457)] = 29458,
  [SMALL_STATE(458)] = 29559,
  [SMALL_STATE(459)] = 29660,
  [SMALL_STATE(460)] = 29761,
  [SMALL_STATE(461)] = 29862,
  [SMALL_STATE(462)] = 29937,
  [SMALL_STATE(463)] = 30012,
  [SMALL_STATE(464)] = 30113,
  [SMALL_STATE(465)] = 30214,
  [SMALL_STATE(466)] = 30315,
  [SMALL_STATE(467)] = 30416,
  [SMALL_STATE(468)] = 30517,
  [SMALL_STATE(469)] = 30618,
  [SMALL_STATE(470)] = 30693,
  [SMALL_STATE(471)] = 30794,
  [SMALL_STATE(472)] = 30895,
  [SMALL_STATE(473)] = 30993,
  [SMALL_STATE(474)] = 31091,
  [SMALL_STATE(475)] = 31189,
  [SMALL_STATE(476)] = 31287,
  [SMALL_STATE(477)] = 31385,
  [SMALL_STATE(478)] = 31483,
  [SMALL_STATE(479)] = 31581,
  [SMALL_STATE(480)] = 31679,
  [SMALL_STATE(481)] = 31777,
  [SMALL_STATE(482)] = 31875,
  [SMALL_STATE(483)] = 31973,
  [SMALL_STATE(484)] = 32071,
  [SMALL_STATE(485)] = 32169,
  [SMALL_STATE(486)] = 32241,
  [SMALL_STATE(487)] = 32313,
  [SMALL_STATE(488)] = 32411,
  [SMALL_STATE(489)] = 32509,
  [SMALL_STATE(490)] = 32607,
  [SMALL_STATE(491)] = 32705,
  [SMALL_STATE(492)] = 32805,
  [SMALL_STATE(493)] = 32903,
  [SMALL_STATE(494)] = 33001,
  [SMALL_STATE(495)] = 33099,
  [SMALL_STATE(496)] = 33197,
  [SMALL_STATE(497)] = 33295,
  [SMALL_STATE(498)] = 33393,
  [SMALL_STATE(499)] = 33491,
  [SMALL_STATE(500)] = 33589,
  [SMALL_STATE(501)] = 33689,
  [SMALL_STATE(502)] = 33787,
  [SMALL_STATE(503)] = 33885,
  [SMALL_STATE(504)] = 33985,
  [SMALL_STATE(505)] = 34083,
  [SMALL_STATE(506)] = 34181,
  [SMALL_STATE(507)] = 34279,
  [SMALL_STATE(508)] = 34377,
  [SMALL_STATE(509)] = 34475,
  [SMALL_STATE(510)] = 34573,
  [SMALL_STATE(511)] = 34671,
  [SMALL_STATE(512)] = 34769,
  [SMALL_STATE(513)] = 34867,
  [SMALL_STATE(514)] = 34965,
  [SMALL_STATE(515)] = 35063,
  [SMALL_STATE(516)] = 35161,
  [SMALL_STATE(517)] = 35259,
  [SMALL_STATE(518)] = 35357,
  [SMALL_STATE(519)] = 35455,
  [SMALL_STATE(520)] = 35553,
  [SMALL_STATE(521)] = 35651,
  [SMALL_STATE(522)] = 35749,
  [SMALL_STATE(523)] = 35847,
  [SMALL_STATE(524)] = 35945,
  [SMALL_STATE(525)] = 36017,
  [SMALL_STATE(526)] = 36115,
  [SMALL_STATE(527)] = 36213,
  [SMALL_STATE(528)] = 36311,
  [SMALL_STATE(529)] = 36383,
  [SMALL_STATE(530)] = 36455,
  [SMALL_STATE(531)] = 36553,
  [SMALL_STATE(532)] = 36651,
  [SMALL_STATE(533)] = 36749,
  [SMALL_STATE(534)] = 36847,
  [SMALL_STATE(535)] = 36919,
  [SMALL_STATE(536)] = 37017,
  [SMALL_STATE(537)] = 37115,
  [SMALL_STATE(538)] = 37213,
  [SMALL_STATE(539)] = 37311,
  [SMALL_STATE(540)] = 37409,
  [SMALL_STATE(541)] = 37507,
  [SMALL_STATE(542)] = 37605,
  [SMALL_STATE(543)] = 37703,
  [SMALL_STATE(544)] = 37801,
  [SMALL_STATE(545)] = 37899,
  [SMALL_STATE(546)] = 37997,
  [SMALL_STATE(547)] = 38095,
  [SMALL_STATE(548)] = 38193,
  [SMALL_STATE(549)] = 38291,
  [SMALL_STATE(550)] = 38389,
  [SMALL_STATE(551)] = 38487,
  [SMALL_STATE(552)] = 38559,
  [SMALL_STATE(553)] = 38657,
  [SMALL_STATE(554)] = 38755,
  [SMALL_STATE(555)] = 38827,
  [SMALL_STATE(556)] = 38925,
  [SMALL_STATE(557)] = 39023,
  [SMALL_STATE(558)] = 39121,
  [SMALL_STATE(559)] = 39219,
  [SMALL_STATE(560)] = 39319,
  [SMALL_STATE(561)] = 39417,
  [SMALL_STATE(562)] = 39515,
  [SMALL_STATE(563)] = 39613,
  [SMALL_STATE(564)] = 39711,
  [SMALL_STATE(565)] = 39809,
  [SMALL_STATE(566)] = 39907,
  [SMALL_STATE(567)] = 40005,
  [SMALL_STATE(568)] = 40103,
  [SMALL_STATE(569)] = 40201,
  [SMALL_STATE(570)] = 40299,
  [SMALL_STATE(571)] = 40397,
  [SMALL_STATE(572)] = 40495,
  [SMALL_STATE(573)] = 40593,
  [SMALL_STATE(574)] = 40691,
  [SMALL_STATE(575)] = 40789,
  [SMALL_STATE(576)] = 40887,
  [SMALL_STATE(577)] = 40985,
  [SMALL_STATE(578)] = 41083,
  [SMALL_STATE(579)] = 41181,
  [SMALL_STATE(580)] = 41279,
  [SMALL_STATE(581)] = 41377,
  [SMALL_STATE(582)] = 41475,
  [SMALL_STATE(583)] = 41573,
  [SMALL_STATE(584)] = 41671,
  [SMALL_STATE(585)] = 41769,
  [SMALL_STATE(586)] = 41867,
  [SMALL_STATE(587)] = 41965,
  [SMALL_STATE(588)] = 42063,
  [SMALL_STATE(589)] = 42161,
  [SMALL_STATE(590)] = 42261,
  [SMALL_STATE(591)] = 42359,
  [SMALL_STATE(592)] = 42457,
  [SMALL_STATE(593)] = 42555,
  [SMALL_STATE(594)] = 42653,
  [SMALL_STATE(595)] = 42751,
  [SMALL_STATE(596)] = 42851,
  [SMALL_STATE(597)] = 42949,
  [SMALL_STATE(598)] = 43047,
  [SMALL_STATE(599)] = 43145,
  [SMALL_STATE(600)] = 43243,
  [SMALL_STATE(601)] = 43341,
  [SMALL_STATE(602)] = 43414,
  [SMALL_STATE(603)] = 43476,
  [SMALL_STATE(604)] = 43542,
  [SMALL_STATE(605)] = 43610,
  [SMALL_STATE(606)] = 43678,
  [SMALL_STATE(607)] = 43746,
  [SMALL_STATE(608)] = 43814,
  [SMALL_STATE(609)] = 43882,
  [SMALL_STATE(610)] = 43950,
  [SMALL_STATE(611)] = 44018,
  [SMALL_STATE(612)] = 44080,
  [SMALL_STATE(613)] = 44146,
  [SMALL_STATE(614)] = 44214,
  [SMALL_STATE(615)] = 44282,
  [SMALL_STATE(616)] = 44348,
  [SMALL_STATE(617)] = 44410,
  [SMALL_STATE(618)] = 44472,
  [SMALL_STATE(619)] = 44529,
  [SMALL_STATE(620)] = 44592,
  [SMALL_STATE(621)] = 44653,
  [SMALL_STATE(622)] = 44716,
  [SMALL_STATE(623)] = 44777,
  [SMALL_STATE(624)] = 44838,
  [SMALL_STATE(625)] = 44895,
  [SMALL_STATE(626)] = 44960,
  [SMALL_STATE(627)] = 45023,
  [SMALL_STATE(628)] = 45086,
  [SMALL_STATE(629)] = 45143,
  [SMALL_STATE(630)] = 45206,
  [SMALL_STATE(631)] = 45263,
  [SMALL_STATE(632)] = 45326,
  [SMALL_STATE(633)] = 45389,
  [SMALL_STATE(634)] = 45452,
  [SMALL_STATE(635)] = 45515,
  [SMALL_STATE(636)] = 45572,
  [SMALL_STATE(637)] = 45629,
  [SMALL_STATE(638)] = 45686,
  [SMALL_STATE(639)] = 45749,
  [SMALL_STATE(640)] = 45805,
  [SMALL_STATE(641)] = 45861,
  [SMALL_STATE(642)] = 45917,
  [SMALL_STATE(643)] = 45973,
  [SMALL_STATE(644)] = 46029,
  [SMALL_STATE(645)] = 46085,
  [SMALL_STATE(646)] = 46141,
  [SMALL_STATE(647)] = 46197,
  [SMALL_STATE(648)] = 46253,
  [SMALL_STATE(649)] = 46309,
  [SMALL_STATE(650)] = 46365,
  [SMALL_STATE(651)] = 46421,
  [SMALL_STATE(652)] = 46513,
  [SMALL_STATE(653)] = 46569,
  [SMALL_STATE(654)] = 46625,
  [SMALL_STATE(655)] = 46681,
  [SMALL_STATE(656)] = 46737,
  [SMALL_STATE(657)] = 46793,
  [SMALL_STATE(658)] = 46849,
  [SMALL_STATE(659)] = 46905,
  [SMALL_STATE(660)] = 46961,
  [SMALL_STATE(661)] = 47017,
  [SMALL_STATE(662)] = 47073,
  [SMALL_STATE(663)] = 47129,
  [SMALL_STATE(664)] = 47185,
  [SMALL_STATE(665)] = 47241,
  [SMALL_STATE(666)] = 47297,
  [SMALL_STATE(667)] = 47353,
  [SMALL_STATE(668)] = 47409,
  [SMALL_STATE(669)] = 47465,
  [SMALL_STATE(670)] = 47521,
  [SMALL_STATE(671)] = 47577,
  [SMALL_STATE(672)] = 47633,
  [SMALL_STATE(673)] = 47689,
  [SMALL_STATE(674)] = 47745,
  [SMALL_STATE(675)] = 47801,
  [SMALL_STATE(676)] = 47857,
  [SMALL_STATE(677)] = 47913,
  [SMALL_STATE(678)] = 48005,
  [SMALL_STATE(679)] = 48061,
  [SMALL_STATE(680)] = 48117,
  [SMALL_STATE(681)] = 48173,
  [SMALL_STATE(682)] = 48229,
  [SMALL_STATE(683)] = 48285,
  [SMALL_STATE(684)] = 48341,
  [SMALL_STATE(685)] = 48397,
  [SMALL_STATE(686)] = 48453,
  [SMALL_STATE(687)] = 48509,
  [SMALL_STATE(688)] = 48565,
  [SMALL_STATE(689)] = 48621,
  [SMALL_STATE(690)] = 48677,
  [SMALL_STATE(691)] = 48733,
  [SMALL_STATE(692)] = 48792,
  [SMALL_STATE(693)] = 48847,
  [SMALL_STATE(694)] = 48902,
  [SMALL_STATE(695)] = 48961,
  [SMALL_STATE(696)] = 49020,
  [SMALL_STATE(697)] = 49075,
  [SMALL_STATE(698)] = 49134,
  [SMALL_STATE(699)] = 49193,
  [SMALL_STATE(700)] = 49248,
  [SMALL_STATE(701)] = 49307,
  [SMALL_STATE(702)] = 49366,
  [SMALL_STATE(703)] = 49425,
  [SMALL_STATE(704)] = 49484,
  [SMALL_STATE(705)] = 49543,
  [SMALL_STATE(706)] = 49598,
  [SMALL_STATE(707)] = 49657,
  [SMALL_STATE(708)] = 49716,
  [SMALL_STATE(709)] = 49775,
  [SMALL_STATE(710)] = 49834,
  [SMALL_STATE(711)] = 49889,
  [SMALL_STATE(712)] = 49948,
  [SMALL_STATE(713)] = 50007,
  [SMALL_STATE(714)] = 50061,
  [SMALL_STATE(715)] = 50153,
  [SMALL_STATE(716)] = 50207,
  [SMALL_STATE(717)] = 50261,
  [SMALL_STATE(718)] = 50315,
  [SMALL_STATE(719)] = 50407,
  [SMALL_STATE(720)] = 50460,
  [SMALL_STATE(721)] = 50513,
  [SMALL_STATE(722)] = 50566,
  [SMALL_STATE(723)] = 50655,
  [SMALL_STATE(724)] = 50708,
  [SMALL_STATE(725)] = 50761,
  [SMALL_STATE(726)] = 50850,
  [SMALL_STATE(727)] = 50939,
  [SMALL_STATE(728)] = 50992,
  [SMALL_STATE(729)] = 51045,
  [SMALL_STATE(730)] = 51098,
  [SMALL_STATE(731)] = 51151,
  [SMALL_STATE(732)] = 51204,
  [SMALL_STATE(733)] = 51257,
  [SMALL_STATE(734)] = 51346,
  [SMALL_STATE(735)] = 51399,
  [SMALL_STATE(736)] = 51452,
  [SMALL_STATE(737)] = 51541,
  [SMALL_STATE(738)] = 51594,
  [SMALL_STATE(739)] = 51647,
  [SMALL_STATE(740)] = 51700,
  [SMALL_STATE(741)] = 51753,
  [SMALL_STATE(742)] = 51806,
  [SMALL_STATE(743)] = 51859,
  [SMALL_STATE(744)] = 51912,
  [SMALL_STATE(745)] = 51965,
  [SMALL_STATE(746)] = 52018,
  [SMALL_STATE(747)] = 52071,
  [SMALL_STATE(748)] = 52124,
  [SMALL_STATE(749)] = 52213,
  [SMALL_STATE(750)] = 52266,
  [SMALL_STATE(751)] = 52355,
  [SMALL_STATE(752)] = 52444,
  [SMALL_STATE(753)] = 52497,
  [SMALL_STATE(754)] = 52550,
  [SMALL_STATE(755)] = 52603,
  [SMALL_STATE(756)] = 52692,
  [SMALL_STATE(757)] = 52745,
  [SMALL_STATE(758)] = 52798,
  [SMALL_STATE(759)] = 52851,
  [SMALL_STATE(760)] = 52904,
  [SMALL_STATE(761)] = 52957,
  [SMALL_STATE(762)] = 53010,
  [SMALL_STATE(763)] = 53063,
  [SMALL_STATE(764)] = 53116,
  [SMALL_STATE(765)] = 53169,
  [SMALL_STATE(766)] = 53222,
  [SMALL_STATE(767)] = 53275,
  [SMALL_STATE(768)] = 53328,
  [SMALL_STATE(769)] = 53381,
  [SMALL_STATE(770)] = 53470,
  [SMALL_STATE(771)] = 53523,
  [SMALL_STATE(772)] = 53576,
  [SMALL_STATE(773)] = 53665,
  [SMALL_STATE(774)] = 53718,
  [SMALL_STATE(775)] = 53807,
  [SMALL_STATE(776)] = 53860,
  [SMALL_STATE(777)] = 53913,
  [SMALL_STATE(778)] = 53966,
  [SMALL_STATE(779)] = 54019,
  [SMALL_STATE(780)] = 54072,
  [SMALL_STATE(781)] = 54125,
  [SMALL_STATE(782)] = 54214,
  [SMALL_STATE(783)] = 54267,
  [SMALL_STATE(784)] = 54320,
  [SMALL_STATE(785)] = 54373,
  [SMALL_STATE(786)] = 54426,
  [SMALL_STATE(787)] = 54479,
  [SMALL_STATE(788)] = 54532,
  [SMALL_STATE(789)] = 54585,
  [SMALL_STATE(790)] = 54638,
  [SMALL_STATE(791)] = 54691,
  [SMALL_STATE(792)] = 54744,
  [SMALL_STATE(793)] = 54797,
  [SMALL_STATE(794)] = 54850,
  [SMALL_STATE(795)] = 54903,
  [SMALL_STATE(796)] = 54956,
  [SMALL_STATE(797)] = 55009,
  [SMALL_STATE(798)] = 55062,
  [SMALL_STATE(799)] = 55115,
  [SMALL_STATE(800)] = 55168,
  [SMALL_STATE(801)] = 55221,
  [SMALL_STATE(802)] = 55310,
  [SMALL_STATE(803)] = 55363,
  [SMALL_STATE(804)] = 55416,
  [SMALL_STATE(805)] = 55469,
  [SMALL_STATE(806)] = 55522,
  [SMALL_STATE(807)] = 55575,
  [SMALL_STATE(808)] = 55628,
  [SMALL_STATE(809)] = 55681,
  [SMALL_STATE(810)] = 55734,
  [SMALL_STATE(811)] = 55787,
  [SMALL_STATE(812)] = 55840,
  [SMALL_STATE(813)] = 55893,
  [SMALL_STATE(814)] = 55946,
  [SMALL_STATE(815)] = 55999,
  [SMALL_STATE(816)] = 56052,
  [SMALL_STATE(817)] = 56105,
  [SMALL_STATE(818)] = 56158,
  [SMALL_STATE(819)] = 56211,
  [SMALL_STATE(820)] = 56264,
  [SMALL_STATE(821)] = 56317,
  [SMALL_STATE(822)] = 56370,
  [SMALL_STATE(823)] = 56423,
  [SMALL_STATE(824)] = 56476,
  [SMALL_STATE(825)] = 56529,
  [SMALL_STATE(826)] = 56582,
  [SMALL_STATE(827)] = 56635,
  [SMALL_STATE(828)] = 56688,
  [SMALL_STATE(829)] = 56741,
  [SMALL_STATE(830)] = 56794,
  [SMALL_STATE(831)] = 56847,
  [SMALL_STATE(832)] = 56900,
  [SMALL_STATE(833)] = 56953,
  [SMALL_STATE(834)] = 57006,
  [SMALL_STATE(835)] = 57095,
  [SMALL_STATE(836)] = 57148,
  [SMALL_STATE(837)] = 57237,
  [SMALL_STATE(838)] = 57290,
  [SMALL_STATE(839)] = 57343,
  [SMALL_STATE(840)] = 57396,
  [SMALL_STATE(841)] = 57449,
  [SMALL_STATE(842)] = 57502,
  [SMALL_STATE(843)] = 57555,
  [SMALL_STATE(844)] = 57641,
  [SMALL_STATE(845)] = 57727,
  [SMALL_STATE(846)] = 57813,
  [SMALL_STATE(847)] = 57899,
  [SMALL_STATE(848)] = 57985,
  [SMALL_STATE(849)] = 58071,
  [SMALL_STATE(850)] = 58154,
  [SMALL_STATE(851)] = 58237,
  [SMALL_STATE(852)] = 58315,
  [SMALL_STATE(853)] = 58393,
  [SMALL_STATE(854)] = 58471,
  [SMALL_STATE(855)] = 58549,
  [SMALL_STATE(856)] = 58627,
  [SMALL_STATE(857)] = 58705,
  [SMALL_STATE(858)] = 58783,
  [SMALL_STATE(859)] = 58861,
  [SMALL_STATE(860)] = 58936,
  [SMALL_STATE(861)] = 59011,
  [SMALL_STATE(862)] = 59086,
  [SMALL_STATE(863)] = 59161,
  [SMALL_STATE(864)] = 59236,
  [SMALL_STATE(865)] = 59315,
  [SMALL_STATE(866)] = 59390,
  [SMALL_STATE(867)] = 59465,
  [SMALL_STATE(868)] = 59544,
  [SMALL_STATE(869)] = 59619,
  [SMALL_STATE(870)] = 59698,
  [SMALL_STATE(871)] = 59773,
  [SMALL_STATE(872)] = 59848,
  [SMALL_STATE(873)] = 59923,
  [SMALL_STATE(874)] = 59998,
  [SMALL_STATE(875)] = 60077,
  [SMALL_STATE(876)] = 60152,
  [SMALL_STATE(877)] = 60227,
  [SMALL_STATE(878)] = 60306,
  [SMALL_STATE(879)] = 60381,
  [SMALL_STATE(880)] = 60456,
  [SMALL_STATE(881)] = 60531,
  [SMALL_STATE(882)] = 60606,
  [SMALL_STATE(883)] = 60681,
  [SMALL_STATE(884)] = 60756,
  [SMALL_STATE(885)] = 60831,
  [SMALL_STATE(886)] = 60906,
  [SMALL_STATE(887)] = 60981,
  [SMALL_STATE(888)] = 61056,
  [SMALL_STATE(889)] = 61131,
  [SMALL_STATE(890)] = 61206,
  [SMALL_STATE(891)] = 61281,
  [SMALL_STATE(892)] = 61356,
  [SMALL_STATE(893)] = 61431,
  [SMALL_STATE(894)] = 61506,
  [SMALL_STATE(895)] = 61581,
  [SMALL_STATE(896)] = 61656,
  [SMALL_STATE(897)] = 61731,
  [SMALL_STATE(898)] = 61806,
  [SMALL_STATE(899)] = 61881,
  [SMALL_STATE(900)] = 61956,
  [SMALL_STATE(901)] = 62031,
  [SMALL_STATE(902)] = 62106,
  [SMALL_STATE(903)] = 62181,
  [SMALL_STATE(904)] = 62260,
  [SMALL_STATE(905)] = 62335,
  [SMALL_STATE(906)] = 62410,
  [SMALL_STATE(907)] = 62489,
  [SMALL_STATE(908)] = 62568,
  [SMALL_STATE(909)] = 62643,
  [SMALL_STATE(910)] = 62718,
  [SMALL_STATE(911)] = 62793,
  [SMALL_STATE(912)] = 62868,
  [SMALL_STATE(913)] = 62943,
  [SMALL_STATE(914)] = 63018,
  [SMALL_STATE(915)] = 63093,
  [SMALL_STATE(916)] = 63168,
  [SMALL_STATE(917)] = 63243,
  [SMALL_STATE(918)] = 63318,
  [SMALL_STATE(919)] = 63393,
  [SMALL_STATE(920)] = 63468,
  [SMALL_STATE(921)] = 63547,
  [SMALL_STATE(922)] = 63622,
  [SMALL_STATE(923)] = 63697,
  [SMALL_STATE(924)] = 63772,
  [SMALL_STATE(925)] = 63847,
  [SMALL_STATE(926)] = 63926,
  [SMALL_STATE(927)] = 64001,
  [SMALL_STATE(928)] = 64080,
  [SMALL_STATE(929)] = 64155,
  [SMALL_STATE(930)] = 64230,
  [SMALL_STATE(931)] = 64305,
  [SMALL_STATE(932)] = 64380,
  [SMALL_STATE(933)] = 64455,
  [SMALL_STATE(934)] = 64534,
  [SMALL_STATE(935)] = 64609,
  [SMALL_STATE(936)] = 64684,
  [SMALL_STATE(937)] = 64763,
  [SMALL_STATE(938)] = 64842,
  [SMALL_STATE(939)] = 64921,
  [SMALL_STATE(940)] = 65000,
  [SMALL_STATE(941)] = 65075,
  [SMALL_STATE(942)] = 65150,
  [SMALL_STATE(943)] = 65229,
  [SMALL_STATE(944)] = 65304,
  [SMALL_STATE(945)] = 65379,
  [SMALL_STATE(946)] = 65454,
  [SMALL_STATE(947)] = 65529,
  [SMALL_STATE(948)] = 65604,
  [SMALL_STATE(949)] = 65679,
  [SMALL_STATE(950)] = 65758,
  [SMALL_STATE(951)] = 65833,
  [SMALL_STATE(952)] = 65908,
  [SMALL_STATE(953)] = 65983,
  [SMALL_STATE(954)] = 66058,
  [SMALL_STATE(955)] = 66133,
  [SMALL_STATE(956)] = 66208,
  [SMALL_STATE(957)] = 66283,
  [SMALL_STATE(958)] = 66362,
  [SMALL_STATE(959)] = 66437,
  [SMALL_STATE(960)] = 66512,
  [SMALL_STATE(961)] = 66587,
  [SMALL_STATE(962)] = 66662,
  [SMALL_STATE(963)] = 66737,
  [SMALL_STATE(964)] = 66816,
  [SMALL_STATE(965)] = 66891,
  [SMALL_STATE(966)] = 66966,
  [SMALL_STATE(967)] = 67041,
  [SMALL_STATE(968)] = 67093,
  [SMALL_STATE(969)] = 67145,
  [SMALL_STATE(970)] = 67227,
  [SMALL_STATE(971)] = 67279,
  [SMALL_STATE(972)] = 67336,
  [SMALL_STATE(973)] = 67417,
  [SMALL_STATE(974)] = 67488,
  [SMALL_STATE(975)] = 67559,
  [SMALL_STATE(976)] = 67624,
  [SMALL_STATE(977)] = 67695,
  [SMALL_STATE(978)] = 67746,
  [SMALL_STATE(979)] = 67797,
  [SMALL_STATE(980)] = 67878,
  [SMALL_STATE(981)] = 67935,
  [SMALL_STATE(982)] = 67986,
  [SMALL_STATE(983)] = 68053,
  [SMALL_STATE(984)] = 68122,
  [SMALL_STATE(985)] = 68183,
  [SMALL_STATE(986)] = 68240,
  [SMALL_STATE(987)] = 68303,
  [SMALL_STATE(988)] = 68354,
  [SMALL_STATE(989)] = 68411,
  [SMALL_STATE(990)] = 68462,
  [SMALL_STATE(991)] = 68513,
  [SMALL_STATE(992)] = 68563,
  [SMALL_STATE(993)] = 68613,
  [SMALL_STATE(994)] = 68663,
  [SMALL_STATE(995)] = 68713,
  [SMALL_STATE(996)] = 68763,
  [SMALL_STATE(997)] = 68819,
  [SMALL_STATE(998)] = 68869,
  [SMALL_STATE(999)] = 68947,
  [SMALL_STATE(1000)] = 68993,
  [SMALL_STATE(1001)] = 69041,
  [SMALL_STATE(1002)] = 69089,
  [SMALL_STATE(1003)] = 69149,
  [SMALL_STATE(1004)] = 69199,
  [SMALL_STATE(1005)] = 69261,
  [SMALL_STATE(1006)] = 69309,
  [SMALL_STATE(1007)] = 69389,
  [SMALL_STATE(1008)] = 69439,
  [SMALL_STATE(1009)] = 69519,
  [SMALL_STATE(1010)] = 69569,
  [SMALL_STATE(1011)] = 69649,
  [SMALL_STATE(1012)] = 69699,
  [SMALL_STATE(1013)] = 69745,
  [SMALL_STATE(1014)] = 69815,
  [SMALL_STATE(1015)] = 69861,
  [SMALL_STATE(1016)] = 69907,
  [SMALL_STATE(1017)] = 69963,
  [SMALL_STATE(1018)] = 70009,
  [SMALL_STATE(1019)] = 70055,
  [SMALL_STATE(1020)] = 70111,
  [SMALL_STATE(1021)] = 70181,
  [SMALL_STATE(1022)] = 70251,
  [SMALL_STATE(1023)] = 70307,
  [SMALL_STATE(1024)] = 70353,
  [SMALL_STATE(1025)] = 70399,
  [SMALL_STATE(1026)] = 70465,
  [SMALL_STATE(1027)] = 70533,
  [SMALL_STATE(1028)] = 70601,
  [SMALL_STATE(1029)] = 70661,
  [SMALL_STATE(1030)] = 70727,
  [SMALL_STATE(1031)] = 70783,
  [SMALL_STATE(1032)] = 70863,
  [SMALL_STATE(1033)] = 70933,
  [SMALL_STATE(1034)] = 70997,
  [SMALL_STATE(1035)] = 71047,
  [SMALL_STATE(1036)] = 71109,
  [SMALL_STATE(1037)] = 71165,
  [SMALL_STATE(1038)] = 71211,
  [SMALL_STATE(1039)] = 71275,
  [SMALL_STATE(1040)] = 71325,
  [SMALL_STATE(1041)] = 71381,
  [SMALL_STATE(1042)] = 71437,
  [SMALL_STATE(1043)] = 71507,
  [SMALL_STATE(1044)] = 71577,
  [SMALL_STATE(1045)] = 71624,
  [SMALL_STATE(1046)] = 71669,
  [SMALL_STATE(1047)] = 71714,
  [SMALL_STATE(1048)] = 71759,
  [SMALL_STATE(1049)] = 71814,
  [SMALL_STATE(1050)] = 71875,
  [SMALL_STATE(1051)] = 71920,
  [SMALL_STATE(1052)] = 71989,
  [SMALL_STATE(1053)] = 72044,
  [SMALL_STATE(1054)] = 72103,
  [SMALL_STATE(1055)] = 72148,
  [SMALL_STATE(1056)] = 72215,
  [SMALL_STATE(1057)] = 72284,
  [SMALL_STATE(1058)] = 72353,
  [SMALL_STATE(1059)] = 72398,
  [SMALL_STATE(1060)] = 72463,
  [SMALL_STATE(1061)] = 72514,
  [SMALL_STATE(1062)] = 72565,
  [SMALL_STATE(1063)] = 72616,
  [SMALL_STATE(1064)] = 72661,
  [SMALL_STATE(1065)] = 72706,
  [SMALL_STATE(1066)] = 72751,
  [SMALL_STATE(1067)] = 72814,
  [SMALL_STATE(1068)] = 72859,
  [SMALL_STATE(1069)] = 72922,
  [SMALL_STATE(1070)] = 72987,
  [SMALL_STATE(1071)] = 73054,
  [SMALL_STATE(1072)] = 73113,
  [SMALL_STATE(1073)] = 73168,
  [SMALL_STATE(1074)] = 73237,
  [SMALL_STATE(1075)] = 73298,
  [SMALL_STATE(1076)] = 73353,
  [SMALL_STATE(1077)] = 73398,
  [SMALL_STATE(1078)] = 73443,
  [SMALL_STATE(1079)] = 73498,
  [SMALL_STATE(1080)] = 73561,
  [SMALL_STATE(1081)] = 73630,
  [SMALL_STATE(1082)] = 73695,
  [SMALL_STATE(1083)] = 73750,
  [SMALL_STATE(1084)] = 73827,
  [SMALL_STATE(1085)] = 73872,
  [SMALL_STATE(1086)] = 73941,
  [SMALL_STATE(1087)] = 74010,
  [SMALL_STATE(1088)] = 74079,
  [SMALL_STATE(1089)] = 74146,
  [SMALL_STATE(1090)] = 74191,
  [SMALL_STATE(1091)] = 74236,
  [SMALL_STATE(1092)] = 74283,
  [SMALL_STATE(1093)] = 74332,
  [SMALL_STATE(1094)] = 74379,
  [SMALL_STATE(1095)] = 74428,
  [SMALL_STATE(1096)] = 74475,
  [SMALL_STATE(1097)] = 74530,
  [SMALL_STATE(1098)] = 74579,
  [SMALL_STATE(1099)] = 74626,
  [SMALL_STATE(1100)] = 74671,
  [SMALL_STATE(1101)] = 74720,
  [SMALL_STATE(1102)] = 74769,
  [SMALL_STATE(1103)] = 74814,
  [SMALL_STATE(1104)] = 74869,
  [SMALL_STATE(1105)] = 74932,
  [SMALL_STATE(1106)] = 74997,
  [SMALL_STATE(1107)] = 75046,
  [SMALL_STATE(1108)] = 75095,
  [SMALL_STATE(1109)] = 75150,
  [SMALL_STATE(1110)] = 75217,
  [SMALL_STATE(1111)] = 75276,
  [SMALL_STATE(1112)] = 75321,
  [SMALL_STATE(1113)] = 75376,
  [SMALL_STATE(1114)] = 75427,
  [SMALL_STATE(1115)] = 75472,
  [SMALL_STATE(1116)] = 75541,
  [SMALL_STATE(1117)] = 75602,
  [SMALL_STATE(1118)] = 75657,
  [SMALL_STATE(1119)] = 75716,
  [SMALL_STATE(1120)] = 75763,
  [SMALL_STATE(1121)] = 75818,
  [SMALL_STATE(1122)] = 75863,
  [SMALL_STATE(1123)] = 75908,
  [SMALL_STATE(1124)] = 75953,
  [SMALL_STATE(1125)] = 76008,
  [SMALL_STATE(1126)] = 76053,
  [SMALL_STATE(1127)] = 76098,
  [SMALL_STATE(1128)] = 76147,
  [SMALL_STATE(1129)] = 76192,
  [SMALL_STATE(1130)] = 76237,
  [SMALL_STATE(1131)] = 76306,
  [SMALL_STATE(1132)] = 76367,
  [SMALL_STATE(1133)] = 76422,
  [SMALL_STATE(1134)] = 76467,
  [SMALL_STATE(1135)] = 76512,
  [SMALL_STATE(1136)] = 76561,
  [SMALL_STATE(1137)] = 76606,
  [SMALL_STATE(1138)] = 76651,
  [SMALL_STATE(1139)] = 76696,
  [SMALL_STATE(1140)] = 76741,
  [SMALL_STATE(1141)] = 76786,
  [SMALL_STATE(1142)] = 76855,
  [SMALL_STATE(1143)] = 76924,
  [SMALL_STATE(1144)] = 76969,
  [SMALL_STATE(1145)] = 77020,
  [SMALL_STATE(1146)] = 77075,
  [SMALL_STATE(1147)] = 77130,
  [SMALL_STATE(1148)] = 77175,
  [SMALL_STATE(1149)] = 77220,
  [SMALL_STATE(1150)] = 77269,
  [SMALL_STATE(1151)] = 77318,
  [SMALL_STATE(1152)] = 77363,
  [SMALL_STATE(1153)] = 77412,
  [SMALL_STATE(1154)] = 77478,
  [SMALL_STATE(1155)] = 77522,
  [SMALL_STATE(1156)] = 77566,
  [SMALL_STATE(1157)] = 77610,
  [SMALL_STATE(1158)] = 77654,
  [SMALL_STATE(1159)] = 77698,
  [SMALL_STATE(1160)] = 77742,
  [SMALL_STATE(1161)] = 77786,
  [SMALL_STATE(1162)] = 77830,
  [SMALL_STATE(1163)] = 77874,
  [SMALL_STATE(1164)] = 77918,
  [SMALL_STATE(1165)] = 77962,
  [SMALL_STATE(1166)] = 78006,
  [SMALL_STATE(1167)] = 78050,
  [SMALL_STATE(1168)] = 78098,
  [SMALL_STATE(1169)] = 78142,
  [SMALL_STATE(1170)] = 78186,
  [SMALL_STATE(1171)] = 78232,
  [SMALL_STATE(1172)] = 78276,
  [SMALL_STATE(1173)] = 78320,
  [SMALL_STATE(1174)] = 78364,
  [SMALL_STATE(1175)] = 78410,
  [SMALL_STATE(1176)] = 78456,
  [SMALL_STATE(1177)] = 78502,
  [SMALL_STATE(1178)] = 78548,
  [SMALL_STATE(1179)] = 78592,
  [SMALL_STATE(1180)] = 78636,
  [SMALL_STATE(1181)] = 78682,
  [SMALL_STATE(1182)] = 78726,
  [SMALL_STATE(1183)] = 78772,
  [SMALL_STATE(1184)] = 78816,
  [SMALL_STATE(1185)] = 78860,
  [SMALL_STATE(1186)] = 78904,
  [SMALL_STATE(1187)] = 78948,
  [SMALL_STATE(1188)] = 78996,
  [SMALL_STATE(1189)] = 79044,
  [SMALL_STATE(1190)] = 79092,
  [SMALL_STATE(1191)] = 79168,
  [SMALL_STATE(1192)] = 79212,
  [SMALL_STATE(1193)] = 79256,
  [SMALL_STATE(1194)] = 79310,
  [SMALL_STATE(1195)] = 79358,
  [SMALL_STATE(1196)] = 79402,
  [SMALL_STATE(1197)] = 79450,
  [SMALL_STATE(1198)] = 79504,
  [SMALL_STATE(1199)] = 79548,
  [SMALL_STATE(1200)] = 79594,
  [SMALL_STATE(1201)] = 79644,
  [SMALL_STATE(1202)] = 79690,
  [SMALL_STATE(1203)] = 79736,
  [SMALL_STATE(1204)] = 79780,
  [SMALL_STATE(1205)] = 79824,
  [SMALL_STATE(1206)] = 79868,
  [SMALL_STATE(1207)] = 79912,
  [SMALL_STATE(1208)] = 79976,
  [SMALL_STATE(1209)] = 80020,
  [SMALL_STATE(1210)] = 80074,
  [SMALL_STATE(1211)] = 80134,
  [SMALL_STATE(1212)] = 80202,
  [SMALL_STATE(1213)] = 80256,
  [SMALL_STATE(1214)] = 80314,
  [SMALL_STATE(1215)] = 80358,
  [SMALL_STATE(1216)] = 80406,
  [SMALL_STATE(1217)] = 80454,
  [SMALL_STATE(1218)] = 80498,
  [SMALL_STATE(1219)] = 80542,
  [SMALL_STATE(1220)] = 80604,
  [SMALL_STATE(1221)] = 80648,
  [SMALL_STATE(1222)] = 80724,
  [SMALL_STATE(1223)] = 80774,
  [SMALL_STATE(1224)] = 80818,
  [SMALL_STATE(1225)] = 80862,
  [SMALL_STATE(1226)] = 80906,
  [SMALL_STATE(1227)] = 80974,
  [SMALL_STATE(1228)] = 81022,
  [SMALL_STATE(1229)] = 81070,
  [SMALL_STATE(1230)] = 81118,
  [SMALL_STATE(1231)] = 81186,
  [SMALL_STATE(1232)] = 81232,
  [SMALL_STATE(1233)] = 81276,
  [SMALL_STATE(1234)] = 81324,
  [SMALL_STATE(1235)] = 81372,
  [SMALL_STATE(1236)] = 81416,
  [SMALL_STATE(1237)] = 81460,
  [SMALL_STATE(1238)] = 81508,
  [SMALL_STATE(1239)] = 81552,
  [SMALL_STATE(1240)] = 81596,
  [SMALL_STATE(1241)] = 81640,
  [SMALL_STATE(1242)] = 81688,
  [SMALL_STATE(1243)] = 81734,
  [SMALL_STATE(1244)] = 81778,
  [SMALL_STATE(1245)] = 81822,
  [SMALL_STATE(1246)] = 81866,
  [SMALL_STATE(1247)] = 81910,
  [SMALL_STATE(1248)] = 81956,
  [SMALL_STATE(1249)] = 82002,
  [SMALL_STATE(1250)] = 82048,
  [SMALL_STATE(1251)] = 82092,
  [SMALL_STATE(1252)] = 82138,
  [SMALL_STATE(1253)] = 82182,
  [SMALL_STATE(1254)] = 82230,
  [SMALL_STATE(1255)] = 82274,
  [SMALL_STATE(1256)] = 82318,
  [SMALL_STATE(1257)] = 82364,
  [SMALL_STATE(1258)] = 82412,
  [SMALL_STATE(1259)] = 82456,
  [SMALL_STATE(1260)] = 82500,
  [SMALL_STATE(1261)] = 82544,
  [SMALL_STATE(1262)] = 82588,
  [SMALL_STATE(1263)] = 82632,
  [SMALL_STATE(1264)] = 82676,
  [SMALL_STATE(1265)] = 82720,
  [SMALL_STATE(1266)] = 82764,
  [SMALL_STATE(1267)] = 82808,
  [SMALL_STATE(1268)] = 82856,
  [SMALL_STATE(1269)] = 82900,
  [SMALL_STATE(1270)] = 82944,
  [SMALL_STATE(1271)] = 82988,
  [SMALL_STATE(1272)] = 83032,
  [SMALL_STATE(1273)] = 83076,
  [SMALL_STATE(1274)] = 83120,
  [SMALL_STATE(1275)] = 83164,
  [SMALL_STATE(1276)] = 83208,
  [SMALL_STATE(1277)] = 83252,
  [SMALL_STATE(1278)] = 83296,
  [SMALL_STATE(1279)] = 83372,
  [SMALL_STATE(1280)] = 83415,
  [SMALL_STATE(1281)] = 83458,
  [SMALL_STATE(1282)] = 83501,
  [SMALL_STATE(1283)] = 83544,
  [SMALL_STATE(1284)] = 83587,
  [SMALL_STATE(1285)] = 83632,
  [SMALL_STATE(1286)] = 83679,
  [SMALL_STATE(1287)] = 83724,
  [SMALL_STATE(1288)] = 83767,
  [SMALL_STATE(1289)] = 83810,
  [SMALL_STATE(1290)] = 83853,
  [SMALL_STATE(1291)] = 83896,
  [SMALL_STATE(1292)] = 83939,
  [SMALL_STATE(1293)] = 83982,
  [SMALL_STATE(1294)] = 84029,
  [SMALL_STATE(1295)] = 84074,
  [SMALL_STATE(1296)] = 84117,
  [SMALL_STATE(1297)] = 84160,
  [SMALL_STATE(1298)] = 84203,
  [SMALL_STATE(1299)] = 84246,
  [SMALL_STATE(1300)] = 84291,
  [SMALL_STATE(1301)] = 84334,
  [SMALL_STATE(1302)] = 84379,
  [SMALL_STATE(1303)] = 84422,
  [SMALL_STATE(1304)] = 84465,
  [SMALL_STATE(1305)] = 84508,
  [SMALL_STATE(1306)] = 84553,
  [SMALL_STATE(1307)] = 84598,
  [SMALL_STATE(1308)] = 84645,
  [SMALL_STATE(1309)] = 84692,
  [SMALL_STATE(1310)] = 84735,
  [SMALL_STATE(1311)] = 84778,
  [SMALL_STATE(1312)] = 84821,
  [SMALL_STATE(1313)] = 84866,
  [SMALL_STATE(1314)] = 84913,
  [SMALL_STATE(1315)] = 84960,
  [SMALL_STATE(1316)] = 85003,
  [SMALL_STATE(1317)] = 85046,
  [SMALL_STATE(1318)] = 85089,
  [SMALL_STATE(1319)] = 85134,
  [SMALL_STATE(1320)] = 85185,
  [SMALL_STATE(1321)] = 85230,
  [SMALL_STATE(1322)] = 85273,
  [SMALL_STATE(1323)] = 85316,
  [SMALL_STATE(1324)] = 85359,
  [SMALL_STATE(1325)] = 85402,
  [SMALL_STATE(1326)] = 85445,
  [SMALL_STATE(1327)] = 85488,
  [SMALL_STATE(1328)] = 85531,
  [SMALL_STATE(1329)] = 85574,
  [SMALL_STATE(1330)] = 85617,
  [SMALL_STATE(1331)] = 85660,
  [SMALL_STATE(1332)] = 85703,
  [SMALL_STATE(1333)] = 85746,
  [SMALL_STATE(1334)] = 85789,
  [SMALL_STATE(1335)] = 85832,
  [SMALL_STATE(1336)] = 85875,
  [SMALL_STATE(1337)] = 85918,
  [SMALL_STATE(1338)] = 85961,
  [SMALL_STATE(1339)] = 86004,
  [SMALL_STATE(1340)] = 86047,
  [SMALL_STATE(1341)] = 86090,
  [SMALL_STATE(1342)] = 86133,
  [SMALL_STATE(1343)] = 86176,
  [SMALL_STATE(1344)] = 86219,
  [SMALL_STATE(1345)] = 86262,
  [SMALL_STATE(1346)] = 86305,
  [SMALL_STATE(1347)] = 86348,
  [SMALL_STATE(1348)] = 86391,
  [SMALL_STATE(1349)] = 86434,
  [SMALL_STATE(1350)] = 86477,
  [SMALL_STATE(1351)] = 86524,
  [SMALL_STATE(1352)] = 86567,
  [SMALL_STATE(1353)] = 86610,
  [SMALL_STATE(1354)] = 86653,
  [SMALL_STATE(1355)] = 86696,
  [SMALL_STATE(1356)] = 86743,
  [SMALL_STATE(1357)] = 86786,
  [SMALL_STATE(1358)] = 86829,
  [SMALL_STATE(1359)] = 86876,
  [SMALL_STATE(1360)] = 86923,
  [SMALL_STATE(1361)] = 86970,
  [SMALL_STATE(1362)] = 87013,
  [SMALL_STATE(1363)] = 87056,
  [SMALL_STATE(1364)] = 87099,
  [SMALL_STATE(1365)] = 87142,
  [SMALL_STATE(1366)] = 87185,
  [SMALL_STATE(1367)] = 87228,
  [SMALL_STATE(1368)] = 87271,
  [SMALL_STATE(1369)] = 87314,
  [SMALL_STATE(1370)] = 87357,
  [SMALL_STATE(1371)] = 87400,
  [SMALL_STATE(1372)] = 87443,
  [SMALL_STATE(1373)] = 87486,
  [SMALL_STATE(1374)] = 87529,
  [SMALL_STATE(1375)] = 87572,
  [SMALL_STATE(1376)] = 87615,
  [SMALL_STATE(1377)] = 87666,
  [SMALL_STATE(1378)] = 87709,
  [SMALL_STATE(1379)] = 87752,
  [SMALL_STATE(1380)] = 87795,
  [SMALL_STATE(1381)] = 87838,
  [SMALL_STATE(1382)] = 87881,
  [SMALL_STATE(1383)] = 87924,
  [SMALL_STATE(1384)] = 87967,
  [SMALL_STATE(1385)] = 88010,
  [SMALL_STATE(1386)] = 88053,
  [SMALL_STATE(1387)] = 88096,
  [SMALL_STATE(1388)] = 88139,
  [SMALL_STATE(1389)] = 88182,
  [SMALL_STATE(1390)] = 88225,
  [SMALL_STATE(1391)] = 88268,
  [SMALL_STATE(1392)] = 88311,
  [SMALL_STATE(1393)] = 88354,
  [SMALL_STATE(1394)] = 88397,
  [SMALL_STATE(1395)] = 88440,
  [SMALL_STATE(1396)] = 88483,
  [SMALL_STATE(1397)] = 88526,
  [SMALL_STATE(1398)] = 88569,
  [SMALL_STATE(1399)] = 88612,
  [SMALL_STATE(1400)] = 88655,
  [SMALL_STATE(1401)] = 88698,
  [SMALL_STATE(1402)] = 88741,
  [SMALL_STATE(1403)] = 88786,
  [SMALL_STATE(1404)] = 88831,
  [SMALL_STATE(1405)] = 88874,
  [SMALL_STATE(1406)] = 88917,
  [SMALL_STATE(1407)] = 88960,
  [SMALL_STATE(1408)] = 89007,
  [SMALL_STATE(1409)] = 89050,
  [SMALL_STATE(1410)] = 89093,
  [SMALL_STATE(1411)] = 89136,
  [SMALL_STATE(1412)] = 89179,
  [SMALL_STATE(1413)] = 89222,
  [SMALL_STATE(1414)] = 89265,
  [SMALL_STATE(1415)] = 89310,
  [SMALL_STATE(1416)] = 89353,
  [SMALL_STATE(1417)] = 89398,
  [SMALL_STATE(1418)] = 89441,
  [SMALL_STATE(1419)] = 89486,
  [SMALL_STATE(1420)] = 89531,
  [SMALL_STATE(1421)] = 89576,
  [SMALL_STATE(1422)] = 89619,
  [SMALL_STATE(1423)] = 89664,
  [SMALL_STATE(1424)] = 89707,
  [SMALL_STATE(1425)] = 89750,
  [SMALL_STATE(1426)] = 89793,
  [SMALL_STATE(1427)] = 89836,
  [SMALL_STATE(1428)] = 89879,
  [SMALL_STATE(1429)] = 89922,
  [SMALL_STATE(1430)] = 89965,
  [SMALL_STATE(1431)] = 90008,
  [SMALL_STATE(1432)] = 90051,
  [SMALL_STATE(1433)] = 90094,
  [SMALL_STATE(1434)] = 90137,
  [SMALL_STATE(1435)] = 90184,
  [SMALL_STATE(1436)] = 90231,
  [SMALL_STATE(1437)] = 90278,
  [SMALL_STATE(1438)] = 90321,
  [SMALL_STATE(1439)] = 90366,
  [SMALL_STATE(1440)] = 90409,
  [SMALL_STATE(1441)] = 90452,
  [SMALL_STATE(1442)] = 90495,
  [SMALL_STATE(1443)] = 90537,
  [SMALL_STATE(1444)] = 90579,
  [SMALL_STATE(1445)] = 90621,
  [SMALL_STATE(1446)] = 90663,
  [SMALL_STATE(1447)] = 90705,
  [SMALL_STATE(1448)] = 90747,
  [SMALL_STATE(1449)] = 90789,
  [SMALL_STATE(1450)] = 90831,
  [SMALL_STATE(1451)] = 90873,
  [SMALL_STATE(1452)] = 90915,
  [SMALL_STATE(1453)] = 90957,
  [SMALL_STATE(1454)] = 90999,
  [SMALL_STATE(1455)] = 91041,
  [SMALL_STATE(1456)] = 91083,
  [SMALL_STATE(1457)] = 91125,
  [SMALL_STATE(1458)] = 91167,
  [SMALL_STATE(1459)] = 91209,
  [SMALL_STATE(1460)] = 91251,
  [SMALL_STATE(1461)] = 91293,
  [SMALL_STATE(1462)] = 91335,
  [SMALL_STATE(1463)] = 91377,
  [SMALL_STATE(1464)] = 91419,
  [SMALL_STATE(1465)] = 91461,
  [SMALL_STATE(1466)] = 91503,
  [SMALL_STATE(1467)] = 91545,
  [SMALL_STATE(1468)] = 91587,
  [SMALL_STATE(1469)] = 91629,
  [SMALL_STATE(1470)] = 91673,
  [SMALL_STATE(1471)] = 91717,
  [SMALL_STATE(1472)] = 91761,
  [SMALL_STATE(1473)] = 91803,
  [SMALL_STATE(1474)] = 91845,
  [SMALL_STATE(1475)] = 91891,
  [SMALL_STATE(1476)] = 91941,
  [SMALL_STATE(1477)] = 91987,
  [SMALL_STATE(1478)] = 92029,
  [SMALL_STATE(1479)] = 92073,
  [SMALL_STATE(1480)] = 92117,
  [SMALL_STATE(1481)] = 92163,
  [SMALL_STATE(1482)] = 92207,
  [SMALL_STATE(1483)] = 92249,
  [SMALL_STATE(1484)] = 92291,
  [SMALL_STATE(1485)] = 92333,
  [SMALL_STATE(1486)] = 92381,
  [SMALL_STATE(1487)] = 92425,
  [SMALL_STATE(1488)] = 92469,
  [SMALL_STATE(1489)] = 92513,
  [SMALL_STATE(1490)] = 92556,
  [SMALL_STATE(1491)] = 92597,
  [SMALL_STATE(1492)] = 92640,
  [SMALL_STATE(1493)] = 92681,
  [SMALL_STATE(1494)] = 92722,
  [SMALL_STATE(1495)] = 92763,
  [SMALL_STATE(1496)] = 92804,
  [SMALL_STATE(1497)] = 92845,
  [SMALL_STATE(1498)] = 92886,
  [SMALL_STATE(1499)] = 92929,
  [SMALL_STATE(1500)] = 92972,
  [SMALL_STATE(1501)] = 93015,
  [SMALL_STATE(1502)] = 93056,
  [SMALL_STATE(1503)] = 93099,
  [SMALL_STATE(1504)] = 93140,
  [SMALL_STATE(1505)] = 93183,
  [SMALL_STATE(1506)] = 93226,
  [SMALL_STATE(1507)] = 93267,
  [SMALL_STATE(1508)] = 93310,
  [SMALL_STATE(1509)] = 93384,
  [SMALL_STATE(1510)] = 93458,
  [SMALL_STATE(1511)] = 93526,
  [SMALL_STATE(1512)] = 93594,
  [SMALL_STATE(1513)] = 93662,
  [SMALL_STATE(1514)] = 93730,
  [SMALL_STATE(1515)] = 93798,
  [SMALL_STATE(1516)] = 93866,
  [SMALL_STATE(1517)] = 93934,
  [SMALL_STATE(1518)] = 94002,
  [SMALL_STATE(1519)] = 94070,
  [SMALL_STATE(1520)] = 94138,
  [SMALL_STATE(1521)] = 94206,
  [SMALL_STATE(1522)] = 94274,
  [SMALL_STATE(1523)] = 94342,
  [SMALL_STATE(1524)] = 94410,
  [SMALL_STATE(1525)] = 94478,
  [SMALL_STATE(1526)] = 94546,
  [SMALL_STATE(1527)] = 94614,
  [SMALL_STATE(1528)] = 94682,
  [SMALL_STATE(1529)] = 94750,
  [SMALL_STATE(1530)] = 94818,
  [SMALL_STATE(1531)] = 94886,
  [SMALL_STATE(1532)] = 94954,
  [SMALL_STATE(1533)] = 95022,
  [SMALL_STATE(1534)] = 95090,
  [SMALL_STATE(1535)] = 95158,
  [SMALL_STATE(1536)] = 95226,
  [SMALL_STATE(1537)] = 95294,
  [SMALL_STATE(1538)] = 95362,
  [SMALL_STATE(1539)] = 95430,
  [SMALL_STATE(1540)] = 95498,
  [SMALL_STATE(1541)] = 95566,
  [SMALL_STATE(1542)] = 95634,
  [SMALL_STATE(1543)] = 95702,
  [SMALL_STATE(1544)] = 95770,
  [SMALL_STATE(1545)] = 95838,
  [SMALL_STATE(1546)] = 95906,
  [SMALL_STATE(1547)] = 95971,
  [SMALL_STATE(1548)] = 96036,
  [SMALL_STATE(1549)] = 96101,
  [SMALL_STATE(1550)] = 96166,
  [SMALL_STATE(1551)] = 96231,
  [SMALL_STATE(1552)] = 96297,
  [SMALL_STATE(1553)] = 96363,
  [SMALL_STATE(1554)] = 96429,
  [SMALL_STATE(1555)] = 96495,
  [SMALL_STATE(1556)] = 96561,
  [SMALL_STATE(1557)] = 96627,
  [SMALL_STATE(1558)] = 96693,
  [SMALL_STATE(1559)] = 96759,
  [SMALL_STATE(1560)] = 96825,
  [SMALL_STATE(1561)] = 96891,
  [SMALL_STATE(1562)] = 96957,
  [SMALL_STATE(1563)] = 97023,
  [SMALL_STATE(1564)] = 97089,
  [SMALL_STATE(1565)] = 97155,
  [SMALL_STATE(1566)] = 97221,
  [SMALL_STATE(1567)] = 97287,
  [SMALL_STATE(1568)] = 97353,
  [SMALL_STATE(1569)] = 97419,
  [SMALL_STATE(1570)] = 97485,
  [SMALL_STATE(1571)] = 97551,
  [SMALL_STATE(1572)] = 97614,
  [SMALL_STATE(1573)] = 97672,
  [SMALL_STATE(1574)] = 97730,
  [SMALL_STATE(1575)] = 97788,
  [SMALL_STATE(1576)] = 97846,
  [SMALL_STATE(1577)] = 97904,
  [SMALL_STATE(1578)] = 97962,
  [SMALL_STATE(1579)] = 98020,
  [SMALL_STATE(1580)] = 98078,
  [SMALL_STATE(1581)] = 98120,
  [SMALL_STATE(1582)] = 98162,
  [SMALL_STATE(1583)] = 98194,
  [SMALL_STATE(1584)] = 98226,
  [SMALL_STATE(1585)] = 98266,
  [SMALL_STATE(1586)] = 98298,
  [SMALL_STATE(1587)] = 98338,
  [SMALL_STATE(1588)] = 98370,
  [SMALL_STATE(1589)] = 98402,
  [SMALL_STATE(1590)] = 98442,
  [SMALL_STATE(1591)] = 98474,
  [SMALL_STATE(1592)] = 98514,
  [SMALL_STATE(1593)] = 98553,
  [SMALL_STATE(1594)] = 98590,
  [SMALL_STATE(1595)] = 98629,
  [SMALL_STATE(1596)] = 98668,
  [SMALL_STATE(1597)] = 98707,
  [SMALL_STATE(1598)] = 98744,
  [SMALL_STATE(1599)] = 98774,
  [SMALL_STATE(1600)] = 98804,
  [SMALL_STATE(1601)] = 98834,
  [SMALL_STATE(1602)] = 98872,
  [SMALL_STATE(1603)] = 98902,
  [SMALL_STATE(1604)] = 98940,
  [SMALL_STATE(1605)] = 98970,
  [SMALL_STATE(1606)] = 99000,
  [SMALL_STATE(1607)] = 99030,
  [SMALL_STATE(1608)] = 99060,
  [SMALL_STATE(1609)] = 99098,
  [SMALL_STATE(1610)] = 99136,
  [SMALL_STATE(1611)] = 99165,
  [SMALL_STATE(1612)] = 99194,
  [SMALL_STATE(1613)] = 99223,
  [SMALL_STATE(1614)] = 99252,
  [SMALL_STATE(1615)] = 99281,
  [SMALL_STATE(1616)] = 99306,
  [SMALL_STATE(1617)] = 99335,
  [SMALL_STATE(1618)] = 99364,
  [SMALL_STATE(1619)] = 99411,
  [SMALL_STATE(1620)] = 99458,
  [SMALL_STATE(1621)] = 99487,
  [SMALL_STATE(1622)] = 99516,
  [SMALL_STATE(1623)] = 99545,
  [SMALL_STATE(1624)] = 99574,
  [SMALL_STATE(1625)] = 99621,
  [SMALL_STATE(1626)] = 99650,
  [SMALL_STATE(1627)] = 99697,
  [SMALL_STATE(1628)] = 99744,
  [SMALL_STATE(1629)] = 99773,
  [SMALL_STATE(1630)] = 99802,
  [SMALL_STATE(1631)] = 99831,
  [SMALL_STATE(1632)] = 99878,
  [SMALL_STATE(1633)] = 99907,
  [SMALL_STATE(1634)] = 99954,
  [SMALL_STATE(1635)] = 100001,
  [SMALL_STATE(1636)] = 100048,
  [SMALL_STATE(1637)] = 100077,
  [SMALL_STATE(1638)] = 100106,
  [SMALL_STATE(1639)] = 100131,
  [SMALL_STATE(1640)] = 100160,
  [SMALL_STATE(1641)] = 100189,
  [SMALL_STATE(1642)] = 100218,
  [SMALL_STATE(1643)] = 100243,
  [SMALL_STATE(1644)] = 100268,
  [SMALL_STATE(1645)] = 100297,
  [SMALL_STATE(1646)] = 100326,
  [SMALL_STATE(1647)] = 100355,
  [SMALL_STATE(1648)] = 100402,
  [SMALL_STATE(1649)] = 100448,
  [SMALL_STATE(1650)] = 100494,
  [SMALL_STATE(1651)] = 100540,
  [SMALL_STATE(1652)] = 100572,
  [SMALL_STATE(1653)] = 100618,
  [SMALL_STATE(1654)] = 100646,
  [SMALL_STATE(1655)] = 100692,
  [SMALL_STATE(1656)] = 100722,
  [SMALL_STATE(1657)] = 100768,
  [SMALL_STATE(1658)] = 100796,
  [SMALL_STATE(1659)] = 100842,
  [SMALL_STATE(1660)] = 100866,
  [SMALL_STATE(1661)] = 100890,
  [SMALL_STATE(1662)] = 100914,
  [SMALL_STATE(1663)] = 100960,
  [SMALL_STATE(1664)] = 100984,
  [SMALL_STATE(1665)] = 101030,
  [SMALL_STATE(1666)] = 101076,
  [SMALL_STATE(1667)] = 101108,
  [SMALL_STATE(1668)] = 101154,
  [SMALL_STATE(1669)] = 101197,
  [SMALL_STATE(1670)] = 101237,
  [SMALL_STATE(1671)] = 101277,
  [SMALL_STATE(1672)] = 101317,
  [SMALL_STATE(1673)] = 101343,
  [SMALL_STATE(1674)] = 101383,
  [SMALL_STATE(1675)] = 101420,
  [SMALL_STATE(1676)] = 101457,
  [SMALL_STATE(1677)] = 101476,
  [SMALL_STATE(1678)] = 101499,
  [SMALL_STATE(1679)] = 101540,
  [SMALL_STATE(1680)] = 101581,
  [SMALL_STATE(1681)] = 101622,
  [SMALL_STATE(1682)] = 101663,
  [SMALL_STATE(1683)] = 101690,
  [SMALL_STATE(1684)] = 101731,
  [SMALL_STATE(1685)] = 101772,
  [SMALL_STATE(1686)] = 101791,
  [SMALL_STATE(1687)] = 101818,
  [SMALL_STATE(1688)] = 101843,
  [SMALL_STATE(1689)] = 101864,
  [SMALL_STATE(1690)] = 101905,
  [SMALL_STATE(1691)] = 101932,
  [SMALL_STATE(1692)] = 101951,
  [SMALL_STATE(1693)] = 101992,
  [SMALL_STATE(1694)] = 102030,
  [SMALL_STATE(1695)] = 102068,
  [SMALL_STATE(1696)] = 102106,
  [SMALL_STATE(1697)] = 102144,
  [SMALL_STATE(1698)] = 102182,
  [SMALL_STATE(1699)] = 102220,
  [SMALL_STATE(1700)] = 102258,
  [SMALL_STATE(1701)] = 102290,
  [SMALL_STATE(1702)] = 102328,
  [SMALL_STATE(1703)] = 102366,
  [SMALL_STATE(1704)] = 102404,
  [SMALL_STATE(1705)] = 102442,
  [SMALL_STATE(1706)] = 102480,
  [SMALL_STATE(1707)] = 102518,
  [SMALL_STATE(1708)] = 102556,
  [SMALL_STATE(1709)] = 102594,
  [SMALL_STATE(1710)] = 102632,
  [SMALL_STATE(1711)] = 102670,
  [SMALL_STATE(1712)] = 102708,
  [SMALL_STATE(1713)] = 102746,
  [SMALL_STATE(1714)] = 102784,
  [SMALL_STATE(1715)] = 102822,
  [SMALL_STATE(1716)] = 102860,
  [SMALL_STATE(1717)] = 102898,
  [SMALL_STATE(1718)] = 102936,
  [SMALL_STATE(1719)] = 102974,
  [SMALL_STATE(1720)] = 102997,
  [SMALL_STATE(1721)] = 103022,
  [SMALL_STATE(1722)] = 103041,
  [SMALL_STATE(1723)] = 103070,
  [SMALL_STATE(1724)] = 103099,
  [SMALL_STATE(1725)] = 103128,
  [SMALL_STATE(1726)] = 103157,
  [SMALL_STATE(1727)] = 103182,
  [SMALL_STATE(1728)] = 103207,
  [SMALL_STATE(1729)] = 103224,
  [SMALL_STATE(1730)] = 103253,
  [SMALL_STATE(1731)] = 103282,
  [SMALL_STATE(1732)] = 103311,
  [SMALL_STATE(1733)] = 103340,
  [SMALL_STATE(1734)] = 103369,
  [SMALL_STATE(1735)] = 103386,
  [SMALL_STATE(1736)] = 103407,
  [SMALL_STATE(1737)] = 103436,
  [SMALL_STATE(1738)] = 103465,
  [SMALL_STATE(1739)] = 103494,
  [SMALL_STATE(1740)] = 103519,
  [SMALL_STATE(1741)] = 103536,
  [SMALL_STATE(1742)] = 103561,
  [SMALL_STATE(1743)] = 103590,
  [SMALL_STATE(1744)] = 103607,
  [SMALL_STATE(1745)] = 103636,
  [SMALL_STATE(1746)] = 103665,
  [SMALL_STATE(1747)] = 103690,
  [SMALL_STATE(1748)] = 103719,
  [SMALL_STATE(1749)] = 103738,
  [SMALL_STATE(1750)] = 103755,
  [SMALL_STATE(1751)] = 103776,
  [SMALL_STATE(1752)] = 103801,
  [SMALL_STATE(1753)] = 103830,
  [SMALL_STATE(1754)] = 103859,
  [SMALL_STATE(1755)] = 103884,
  [SMALL_STATE(1756)] = 103913,
  [SMALL_STATE(1757)] = 103942,
  [SMALL_STATE(1758)] = 103965,
  [SMALL_STATE(1759)] = 103994,
  [SMALL_STATE(1760)] = 104011,
  [SMALL_STATE(1761)] = 104031,
  [SMALL_STATE(1762)] = 104051,
  [SMALL_STATE(1763)] = 104075,
  [SMALL_STATE(1764)] = 104099,
  [SMALL_STATE(1765)] = 104117,
  [SMALL_STATE(1766)] = 104139,
  [SMALL_STATE(1767)] = 104157,
  [SMALL_STATE(1768)] = 104181,
  [SMALL_STATE(1769)] = 104197,
  [SMALL_STATE(1770)] = 104217,
  [SMALL_STATE(1771)] = 104239,
  [SMALL_STATE(1772)] = 104259,
  [SMALL_STATE(1773)] = 104275,
  [SMALL_STATE(1774)] = 104293,
  [SMALL_STATE(1775)] = 104315,
  [SMALL_STATE(1776)] = 104339,
  [SMALL_STATE(1777)] = 104359,
  [SMALL_STATE(1778)] = 104379,
  [SMALL_STATE(1779)] = 104395,
  [SMALL_STATE(1780)] = 104413,
  [SMALL_STATE(1781)] = 104437,
  [SMALL_STATE(1782)] = 104453,
  [SMALL_STATE(1783)] = 104477,
  [SMALL_STATE(1784)] = 104499,
  [SMALL_STATE(1785)] = 104521,
  [SMALL_STATE(1786)] = 104545,
  [SMALL_STATE(1787)] = 104569,
  [SMALL_STATE(1788)] = 104593,
  [SMALL_STATE(1789)] = 104623,
  [SMALL_STATE(1790)] = 104647,
  [SMALL_STATE(1791)] = 104665,
  [SMALL_STATE(1792)] = 104689,
  [SMALL_STATE(1793)] = 104705,
  [SMALL_STATE(1794)] = 104729,
  [SMALL_STATE(1795)] = 104745,
  [SMALL_STATE(1796)] = 104769,
  [SMALL_STATE(1797)] = 104790,
  [SMALL_STATE(1798)] = 104817,
  [SMALL_STATE(1799)] = 104838,
  [SMALL_STATE(1800)] = 104859,
  [SMALL_STATE(1801)] = 104882,
  [SMALL_STATE(1802)] = 104903,
  [SMALL_STATE(1803)] = 104924,
  [SMALL_STATE(1804)] = 104945,
  [SMALL_STATE(1805)] = 104966,
  [SMALL_STATE(1806)] = 104989,
  [SMALL_STATE(1807)] = 105006,
  [SMALL_STATE(1808)] = 105029,
  [SMALL_STATE(1809)] = 105048,
  [SMALL_STATE(1810)] = 105077,
  [SMALL_STATE(1811)] = 105104,
  [SMALL_STATE(1812)] = 105121,
  [SMALL_STATE(1813)] = 105150,
  [SMALL_STATE(1814)] = 105177,
  [SMALL_STATE(1815)] = 105206,
  [SMALL_STATE(1816)] = 105221,
  [SMALL_STATE(1817)] = 105246,
  [SMALL_STATE(1818)] = 105269,
  [SMALL_STATE(1819)] = 105298,
  [SMALL_STATE(1820)] = 105327,
  [SMALL_STATE(1821)] = 105352,
  [SMALL_STATE(1822)] = 105377,
  [SMALL_STATE(1823)] = 105400,
  [SMALL_STATE(1824)] = 105425,
  [SMALL_STATE(1825)] = 105446,
  [SMALL_STATE(1826)] = 105467,
  [SMALL_STATE(1827)] = 105484,
  [SMALL_STATE(1828)] = 105501,
  [SMALL_STATE(1829)] = 105528,
  [SMALL_STATE(1830)] = 105557,
  [SMALL_STATE(1831)] = 105584,
  [SMALL_STATE(1832)] = 105611,
  [SMALL_STATE(1833)] = 105640,
  [SMALL_STATE(1834)] = 105669,
  [SMALL_STATE(1835)] = 105688,
  [SMALL_STATE(1836)] = 105715,
  [SMALL_STATE(1837)] = 105736,
  [SMALL_STATE(1838)] = 105757,
  [SMALL_STATE(1839)] = 105778,
  [SMALL_STATE(1840)] = 105801,
  [SMALL_STATE(1841)] = 105826,
  [SMALL_STATE(1842)] = 105849,
  [SMALL_STATE(1843)] = 105874,
  [SMALL_STATE(1844)] = 105891,
  [SMALL_STATE(1845)] = 105912,
  [SMALL_STATE(1846)] = 105941,
  [SMALL_STATE(1847)] = 105962,
  [SMALL_STATE(1848)] = 105985,
  [SMALL_STATE(1849)] = 106012,
  [SMALL_STATE(1850)] = 106033,
  [SMALL_STATE(1851)] = 106050,
  [SMALL_STATE(1852)] = 106069,
  [SMALL_STATE(1853)] = 106098,
  [SMALL_STATE(1854)] = 106119,
  [SMALL_STATE(1855)] = 106145,
  [SMALL_STATE(1856)] = 106167,
  [SMALL_STATE(1857)] = 106189,
  [SMALL_STATE(1858)] = 106211,
  [SMALL_STATE(1859)] = 106233,
  [SMALL_STATE(1860)] = 106251,
  [SMALL_STATE(1861)] = 106273,
  [SMALL_STATE(1862)] = 106291,
  [SMALL_STATE(1863)] = 106317,
  [SMALL_STATE(1864)] = 106339,
  [SMALL_STATE(1865)] = 106357,
  [SMALL_STATE(1866)] = 106383,
  [SMALL_STATE(1867)] = 106409,
  [SMALL_STATE(1868)] = 106427,
  [SMALL_STATE(1869)] = 106451,
  [SMALL_STATE(1870)] = 106469,
  [SMALL_STATE(1871)] = 106487,
  [SMALL_STATE(1872)] = 106503,
  [SMALL_STATE(1873)] = 106529,
  [SMALL_STATE(1874)] = 106555,
  [SMALL_STATE(1875)] = 106581,
  [SMALL_STATE(1876)] = 106605,
  [SMALL_STATE(1877)] = 106627,
  [SMALL_STATE(1878)] = 106647,
  [SMALL_STATE(1879)] = 106665,
  [SMALL_STATE(1880)] = 106689,
  [SMALL_STATE(1881)] = 106711,
  [SMALL_STATE(1882)] = 106735,
  [SMALL_STATE(1883)] = 106761,
  [SMALL_STATE(1884)] = 106779,
  [SMALL_STATE(1885)] = 106805,
  [SMALL_STATE(1886)] = 106831,
  [SMALL_STATE(1887)] = 106857,
  [SMALL_STATE(1888)] = 106877,
  [SMALL_STATE(1889)] = 106903,
  [SMALL_STATE(1890)] = 106919,
  [SMALL_STATE(1891)] = 106939,
  [SMALL_STATE(1892)] = 106965,
  [SMALL_STATE(1893)] = 106991,
  [SMALL_STATE(1894)] = 107013,
  [SMALL_STATE(1895)] = 107039,
  [SMALL_STATE(1896)] = 107057,
  [SMALL_STATE(1897)] = 107079,
  [SMALL_STATE(1898)] = 107101,
  [SMALL_STATE(1899)] = 107123,
  [SMALL_STATE(1900)] = 107149,
  [SMALL_STATE(1901)] = 107175,
  [SMALL_STATE(1902)] = 107201,
  [SMALL_STATE(1903)] = 107219,
  [SMALL_STATE(1904)] = 107237,
  [SMALL_STATE(1905)] = 107255,
  [SMALL_STATE(1906)] = 107277,
  [SMALL_STATE(1907)] = 107292,
  [SMALL_STATE(1908)] = 107305,
  [SMALL_STATE(1909)] = 107326,
  [SMALL_STATE(1910)] = 107349,
  [SMALL_STATE(1911)] = 107366,
  [SMALL_STATE(1912)] = 107387,
  [SMALL_STATE(1913)] = 107404,
  [SMALL_STATE(1914)] = 107425,
  [SMALL_STATE(1915)] = 107440,
  [SMALL_STATE(1916)] = 107453,
  [SMALL_STATE(1917)] = 107470,
  [SMALL_STATE(1918)] = 107493,
  [SMALL_STATE(1919)] = 107514,
  [SMALL_STATE(1920)] = 107531,
  [SMALL_STATE(1921)] = 107544,
  [SMALL_STATE(1922)] = 107567,
  [SMALL_STATE(1923)] = 107588,
  [SMALL_STATE(1924)] = 107607,
  [SMALL_STATE(1925)] = 107620,
  [SMALL_STATE(1926)] = 107641,
  [SMALL_STATE(1927)] = 107658,
  [SMALL_STATE(1928)] = 107679,
  [SMALL_STATE(1929)] = 107700,
  [SMALL_STATE(1930)] = 107721,
  [SMALL_STATE(1931)] = 107738,
  [SMALL_STATE(1932)] = 107755,
  [SMALL_STATE(1933)] = 107772,
  [SMALL_STATE(1934)] = 107793,
  [SMALL_STATE(1935)] = 107810,
  [SMALL_STATE(1936)] = 107831,
  [SMALL_STATE(1937)] = 107848,
  [SMALL_STATE(1938)] = 107869,
  [SMALL_STATE(1939)] = 107890,
  [SMALL_STATE(1940)] = 107905,
  [SMALL_STATE(1941)] = 107928,
  [SMALL_STATE(1942)] = 107949,
  [SMALL_STATE(1943)] = 107970,
  [SMALL_STATE(1944)] = 107991,
  [SMALL_STATE(1945)] = 108008,
  [SMALL_STATE(1946)] = 108025,
  [SMALL_STATE(1947)] = 108042,
  [SMALL_STATE(1948)] = 108059,
  [SMALL_STATE(1949)] = 108076,
  [SMALL_STATE(1950)] = 108097,
  [SMALL_STATE(1951)] = 108114,
  [SMALL_STATE(1952)] = 108131,
  [SMALL_STATE(1953)] = 108152,
  [SMALL_STATE(1954)] = 108169,
  [SMALL_STATE(1955)] = 108184,
  [SMALL_STATE(1956)] = 108201,
  [SMALL_STATE(1957)] = 108224,
  [SMALL_STATE(1958)] = 108245,
  [SMALL_STATE(1959)] = 108262,
  [SMALL_STATE(1960)] = 108275,
  [SMALL_STATE(1961)] = 108292,
  [SMALL_STATE(1962)] = 108313,
  [SMALL_STATE(1963)] = 108330,
  [SMALL_STATE(1964)] = 108351,
  [SMALL_STATE(1965)] = 108372,
  [SMALL_STATE(1966)] = 108389,
  [SMALL_STATE(1967)] = 108410,
  [SMALL_STATE(1968)] = 108431,
  [SMALL_STATE(1969)] = 108448,
  [SMALL_STATE(1970)] = 108461,
  [SMALL_STATE(1971)] = 108478,
  [SMALL_STATE(1972)] = 108491,
  [SMALL_STATE(1973)] = 108504,
  [SMALL_STATE(1974)] = 108517,
  [SMALL_STATE(1975)] = 108534,
  [SMALL_STATE(1976)] = 108557,
  [SMALL_STATE(1977)] = 108572,
  [SMALL_STATE(1978)] = 108593,
  [SMALL_STATE(1979)] = 108614,
  [SMALL_STATE(1980)] = 108635,
  [SMALL_STATE(1981)] = 108648,
  [SMALL_STATE(1982)] = 108663,
  [SMALL_STATE(1983)] = 108680,
  [SMALL_STATE(1984)] = 108697,
  [SMALL_STATE(1985)] = 108710,
  [SMALL_STATE(1986)] = 108727,
  [SMALL_STATE(1987)] = 108740,
  [SMALL_STATE(1988)] = 108757,
  [SMALL_STATE(1989)] = 108778,
  [SMALL_STATE(1990)] = 108797,
  [SMALL_STATE(1991)] = 108810,
  [SMALL_STATE(1992)] = 108827,
  [SMALL_STATE(1993)] = 108850,
  [SMALL_STATE(1994)] = 108867,
  [SMALL_STATE(1995)] = 108884,
  [SMALL_STATE(1996)] = 108905,
  [SMALL_STATE(1997)] = 108922,
  [SMALL_STATE(1998)] = 108935,
  [SMALL_STATE(1999)] = 108956,
  [SMALL_STATE(2000)] = 108971,
  [SMALL_STATE(2001)] = 108992,
  [SMALL_STATE(2002)] = 109013,
  [SMALL_STATE(2003)] = 109026,
  [SMALL_STATE(2004)] = 109039,
  [SMALL_STATE(2005)] = 109056,
  [SMALL_STATE(2006)] = 109069,
  [SMALL_STATE(2007)] = 109082,
  [SMALL_STATE(2008)] = 109099,
  [SMALL_STATE(2009)] = 109114,
  [SMALL_STATE(2010)] = 109127,
  [SMALL_STATE(2011)] = 109143,
  [SMALL_STATE(2012)] = 109155,
  [SMALL_STATE(2013)] = 109167,
  [SMALL_STATE(2014)] = 109185,
  [SMALL_STATE(2015)] = 109205,
  [SMALL_STATE(2016)] = 109223,
  [SMALL_STATE(2017)] = 109239,
  [SMALL_STATE(2018)] = 109251,
  [SMALL_STATE(2019)] = 109265,
  [SMALL_STATE(2020)] = 109277,
  [SMALL_STATE(2021)] = 109289,
  [SMALL_STATE(2022)] = 109307,
  [SMALL_STATE(2023)] = 109319,
  [SMALL_STATE(2024)] = 109335,
  [SMALL_STATE(2025)] = 109347,
  [SMALL_STATE(2026)] = 109363,
  [SMALL_STATE(2027)] = 109377,
  [SMALL_STATE(2028)] = 109397,
  [SMALL_STATE(2029)] = 109409,
  [SMALL_STATE(2030)] = 109421,
  [SMALL_STATE(2031)] = 109441,
  [SMALL_STATE(2032)] = 109453,
  [SMALL_STATE(2033)] = 109465,
  [SMALL_STATE(2034)] = 109477,
  [SMALL_STATE(2035)] = 109497,
  [SMALL_STATE(2036)] = 109509,
  [SMALL_STATE(2037)] = 109521,
  [SMALL_STATE(2038)] = 109535,
  [SMALL_STATE(2039)] = 109551,
  [SMALL_STATE(2040)] = 109563,
  [SMALL_STATE(2041)] = 109583,
  [SMALL_STATE(2042)] = 109595,
  [SMALL_STATE(2043)] = 109607,
  [SMALL_STATE(2044)] = 109623,
  [SMALL_STATE(2045)] = 109635,
  [SMALL_STATE(2046)] = 109655,
  [SMALL_STATE(2047)] = 109673,
  [SMALL_STATE(2048)] = 109693,
  [SMALL_STATE(2049)] = 109705,
  [SMALL_STATE(2050)] = 109725,
  [SMALL_STATE(2051)] = 109737,
  [SMALL_STATE(2052)] = 109757,
  [SMALL_STATE(2053)] = 109775,
  [SMALL_STATE(2054)] = 109791,
  [SMALL_STATE(2055)] = 109807,
  [SMALL_STATE(2056)] = 109825,
  [SMALL_STATE(2057)] = 109843,
  [SMALL_STATE(2058)] = 109855,
  [SMALL_STATE(2059)] = 109867,
  [SMALL_STATE(2060)] = 109881,
  [SMALL_STATE(2061)] = 109897,
  [SMALL_STATE(2062)] = 109913,
  [SMALL_STATE(2063)] = 109931,
  [SMALL_STATE(2064)] = 109943,
  [SMALL_STATE(2065)] = 109963,
  [SMALL_STATE(2066)] = 109975,
  [SMALL_STATE(2067)] = 109987,
  [SMALL_STATE(2068)] = 110003,
  [SMALL_STATE(2069)] = 110015,
  [SMALL_STATE(2070)] = 110027,
  [SMALL_STATE(2071)] = 110047,
  [SMALL_STATE(2072)] = 110059,
  [SMALL_STATE(2073)] = 110071,
  [SMALL_STATE(2074)] = 110083,
  [SMALL_STATE(2075)] = 110101,
  [SMALL_STATE(2076)] = 110119,
  [SMALL_STATE(2077)] = 110131,
  [SMALL_STATE(2078)] = 110151,
  [SMALL_STATE(2079)] = 110163,
  [SMALL_STATE(2080)] = 110181,
  [SMALL_STATE(2081)] = 110201,
  [SMALL_STATE(2082)] = 110219,
  [SMALL_STATE(2083)] = 110239,
  [SMALL_STATE(2084)] = 110251,
  [SMALL_STATE(2085)] = 110263,
  [SMALL_STATE(2086)] = 110279,
  [SMALL_STATE(2087)] = 110299,
  [SMALL_STATE(2088)] = 110319,
  [SMALL_STATE(2089)] = 110331,
  [SMALL_STATE(2090)] = 110351,
  [SMALL_STATE(2091)] = 110371,
  [SMALL_STATE(2092)] = 110383,
  [SMALL_STATE(2093)] = 110399,
  [SMALL_STATE(2094)] = 110411,
  [SMALL_STATE(2095)] = 110431,
  [SMALL_STATE(2096)] = 110451,
  [SMALL_STATE(2097)] = 110463,
  [SMALL_STATE(2098)] = 110477,
  [SMALL_STATE(2099)] = 110497,
  [SMALL_STATE(2100)] = 110513,
  [SMALL_STATE(2101)] = 110533,
  [SMALL_STATE(2102)] = 110549,
  [SMALL_STATE(2103)] = 110569,
  [SMALL_STATE(2104)] = 110581,
  [SMALL_STATE(2105)] = 110593,
  [SMALL_STATE(2106)] = 110605,
  [SMALL_STATE(2107)] = 110617,
  [SMALL_STATE(2108)] = 110629,
  [SMALL_STATE(2109)] = 110649,
  [SMALL_STATE(2110)] = 110661,
  [SMALL_STATE(2111)] = 110681,
  [SMALL_STATE(2112)] = 110701,
  [SMALL_STATE(2113)] = 110713,
  [SMALL_STATE(2114)] = 110733,
  [SMALL_STATE(2115)] = 110745,
  [SMALL_STATE(2116)] = 110765,
  [SMALL_STATE(2117)] = 110777,
  [SMALL_STATE(2118)] = 110789,
  [SMALL_STATE(2119)] = 110809,
  [SMALL_STATE(2120)] = 110821,
  [SMALL_STATE(2121)] = 110841,
  [SMALL_STATE(2122)] = 110853,
  [SMALL_STATE(2123)] = 110865,
  [SMALL_STATE(2124)] = 110885,
  [SMALL_STATE(2125)] = 110897,
  [SMALL_STATE(2126)] = 110911,
  [SMALL_STATE(2127)] = 110929,
  [SMALL_STATE(2128)] = 110946,
  [SMALL_STATE(2129)] = 110957,
  [SMALL_STATE(2130)] = 110968,
  [SMALL_STATE(2131)] = 110985,
  [SMALL_STATE(2132)] = 110996,
  [SMALL_STATE(2133)] = 111013,
  [SMALL_STATE(2134)] = 111024,
  [SMALL_STATE(2135)] = 111039,
  [SMALL_STATE(2136)] = 111056,
  [SMALL_STATE(2137)] = 111073,
  [SMALL_STATE(2138)] = 111084,
  [SMALL_STATE(2139)] = 111101,
  [SMALL_STATE(2140)] = 111118,
  [SMALL_STATE(2141)] = 111135,
  [SMALL_STATE(2142)] = 111152,
  [SMALL_STATE(2143)] = 111163,
  [SMALL_STATE(2144)] = 111174,
  [SMALL_STATE(2145)] = 111185,
  [SMALL_STATE(2146)] = 111196,
  [SMALL_STATE(2147)] = 111207,
  [SMALL_STATE(2148)] = 111218,
  [SMALL_STATE(2149)] = 111229,
  [SMALL_STATE(2150)] = 111240,
  [SMALL_STATE(2151)] = 111251,
  [SMALL_STATE(2152)] = 111262,
  [SMALL_STATE(2153)] = 111273,
  [SMALL_STATE(2154)] = 111284,
  [SMALL_STATE(2155)] = 111295,
  [SMALL_STATE(2156)] = 111312,
  [SMALL_STATE(2157)] = 111323,
  [SMALL_STATE(2158)] = 111334,
  [SMALL_STATE(2159)] = 111351,
  [SMALL_STATE(2160)] = 111366,
  [SMALL_STATE(2161)] = 111379,
  [SMALL_STATE(2162)] = 111390,
  [SMALL_STATE(2163)] = 111401,
  [SMALL_STATE(2164)] = 111416,
  [SMALL_STATE(2165)] = 111431,
  [SMALL_STATE(2166)] = 111442,
  [SMALL_STATE(2167)] = 111453,
  [SMALL_STATE(2168)] = 111470,
  [SMALL_STATE(2169)] = 111481,
  [SMALL_STATE(2170)] = 111496,
  [SMALL_STATE(2171)] = 111507,
  [SMALL_STATE(2172)] = 111522,
  [SMALL_STATE(2173)] = 111539,
  [SMALL_STATE(2174)] = 111556,
  [SMALL_STATE(2175)] = 111571,
  [SMALL_STATE(2176)] = 111582,
  [SMALL_STATE(2177)] = 111597,
  [SMALL_STATE(2178)] = 111612,
  [SMALL_STATE(2179)] = 111625,
  [SMALL_STATE(2180)] = 111636,
  [SMALL_STATE(2181)] = 111651,
  [SMALL_STATE(2182)] = 111662,
  [SMALL_STATE(2183)] = 111673,
  [SMALL_STATE(2184)] = 111684,
  [SMALL_STATE(2185)] = 111695,
  [SMALL_STATE(2186)] = 111706,
  [SMALL_STATE(2187)] = 111717,
  [SMALL_STATE(2188)] = 111734,
  [SMALL_STATE(2189)] = 111745,
  [SMALL_STATE(2190)] = 111756,
  [SMALL_STATE(2191)] = 111771,
  [SMALL_STATE(2192)] = 111786,
  [SMALL_STATE(2193)] = 111803,
  [SMALL_STATE(2194)] = 111814,
  [SMALL_STATE(2195)] = 111825,
  [SMALL_STATE(2196)] = 111836,
  [SMALL_STATE(2197)] = 111847,
  [SMALL_STATE(2198)] = 111858,
  [SMALL_STATE(2199)] = 111875,
  [SMALL_STATE(2200)] = 111892,
  [SMALL_STATE(2201)] = 111907,
  [SMALL_STATE(2202)] = 111918,
  [SMALL_STATE(2203)] = 111929,
  [SMALL_STATE(2204)] = 111946,
  [SMALL_STATE(2205)] = 111957,
  [SMALL_STATE(2206)] = 111974,
  [SMALL_STATE(2207)] = 111989,
  [SMALL_STATE(2208)] = 112000,
  [SMALL_STATE(2209)] = 112015,
  [SMALL_STATE(2210)] = 112032,
  [SMALL_STATE(2211)] = 112043,
  [SMALL_STATE(2212)] = 112058,
  [SMALL_STATE(2213)] = 112075,
  [SMALL_STATE(2214)] = 112092,
  [SMALL_STATE(2215)] = 112103,
  [SMALL_STATE(2216)] = 112114,
  [SMALL_STATE(2217)] = 112125,
  [SMALL_STATE(2218)] = 112136,
  [SMALL_STATE(2219)] = 112147,
  [SMALL_STATE(2220)] = 112158,
  [SMALL_STATE(2221)] = 112169,
  [SMALL_STATE(2222)] = 112180,
  [SMALL_STATE(2223)] = 112191,
  [SMALL_STATE(2224)] = 112208,
  [SMALL_STATE(2225)] = 112219,
  [SMALL_STATE(2226)] = 112230,
  [SMALL_STATE(2227)] = 112247,
  [SMALL_STATE(2228)] = 112264,
  [SMALL_STATE(2229)] = 112275,
  [SMALL_STATE(2230)] = 112286,
  [SMALL_STATE(2231)] = 112297,
  [SMALL_STATE(2232)] = 112308,
  [SMALL_STATE(2233)] = 112319,
  [SMALL_STATE(2234)] = 112330,
  [SMALL_STATE(2235)] = 112341,
  [SMALL_STATE(2236)] = 112352,
  [SMALL_STATE(2237)] = 112363,
  [SMALL_STATE(2238)] = 112378,
  [SMALL_STATE(2239)] = 112395,
  [SMALL_STATE(2240)] = 112410,
  [SMALL_STATE(2241)] = 112421,
  [SMALL_STATE(2242)] = 112432,
  [SMALL_STATE(2243)] = 112447,
  [SMALL_STATE(2244)] = 112458,
  [SMALL_STATE(2245)] = 112471,
  [SMALL_STATE(2246)] = 112482,
  [SMALL_STATE(2247)] = 112493,
  [SMALL_STATE(2248)] = 112510,
  [SMALL_STATE(2249)] = 112527,
  [SMALL_STATE(2250)] = 112538,
  [SMALL_STATE(2251)] = 112553,
  [SMALL_STATE(2252)] = 112570,
  [SMALL_STATE(2253)] = 112587,
  [SMALL_STATE(2254)] = 112604,
  [SMALL_STATE(2255)] = 112615,
  [SMALL_STATE(2256)] = 112626,
  [SMALL_STATE(2257)] = 112640,
  [SMALL_STATE(2258)] = 112654,
  [SMALL_STATE(2259)] = 112668,
  [SMALL_STATE(2260)] = 112682,
  [SMALL_STATE(2261)] = 112696,
  [SMALL_STATE(2262)] = 112710,
  [SMALL_STATE(2263)] = 112724,
  [SMALL_STATE(2264)] = 112738,
  [SMALL_STATE(2265)] = 112752,
  [SMALL_STATE(2266)] = 112766,
  [SMALL_STATE(2267)] = 112778,
  [SMALL_STATE(2268)] = 112792,
  [SMALL_STATE(2269)] = 112804,
  [SMALL_STATE(2270)] = 112818,
  [SMALL_STATE(2271)] = 112832,
  [SMALL_STATE(2272)] = 112846,
  [SMALL_STATE(2273)] = 112860,
  [SMALL_STATE(2274)] = 112874,
  [SMALL_STATE(2275)] = 112888,
  [SMALL_STATE(2276)] = 112902,
  [SMALL_STATE(2277)] = 112916,
  [SMALL_STATE(2278)] = 112930,
  [SMALL_STATE(2279)] = 112944,
  [SMALL_STATE(2280)] = 112958,
  [SMALL_STATE(2281)] = 112972,
  [SMALL_STATE(2282)] = 112982,
  [SMALL_STATE(2283)] = 112996,
  [SMALL_STATE(2284)] = 113010,
  [SMALL_STATE(2285)] = 113024,
  [SMALL_STATE(2286)] = 113038,
  [SMALL_STATE(2287)] = 113052,
  [SMALL_STATE(2288)] = 113064,
  [SMALL_STATE(2289)] = 113078,
  [SMALL_STATE(2290)] = 113092,
  [SMALL_STATE(2291)] = 113102,
  [SMALL_STATE(2292)] = 113116,
  [SMALL_STATE(2293)] = 113130,
  [SMALL_STATE(2294)] = 113144,
  [SMALL_STATE(2295)] = 113158,
  [SMALL_STATE(2296)] = 113172,
  [SMALL_STATE(2297)] = 113182,
  [SMALL_STATE(2298)] = 113196,
  [SMALL_STATE(2299)] = 113210,
  [SMALL_STATE(2300)] = 113224,
  [SMALL_STATE(2301)] = 113234,
  [SMALL_STATE(2302)] = 113248,
  [SMALL_STATE(2303)] = 113262,
  [SMALL_STATE(2304)] = 113276,
  [SMALL_STATE(2305)] = 113290,
  [SMALL_STATE(2306)] = 113304,
  [SMALL_STATE(2307)] = 113318,
  [SMALL_STATE(2308)] = 113332,
  [SMALL_STATE(2309)] = 113346,
  [SMALL_STATE(2310)] = 113360,
  [SMALL_STATE(2311)] = 113374,
  [SMALL_STATE(2312)] = 113388,
  [SMALL_STATE(2313)] = 113402,
  [SMALL_STATE(2314)] = 113416,
  [SMALL_STATE(2315)] = 113430,
  [SMALL_STATE(2316)] = 113444,
  [SMALL_STATE(2317)] = 113458,
  [SMALL_STATE(2318)] = 113472,
  [SMALL_STATE(2319)] = 113486,
  [SMALL_STATE(2320)] = 113500,
  [SMALL_STATE(2321)] = 113514,
  [SMALL_STATE(2322)] = 113528,
  [SMALL_STATE(2323)] = 113540,
  [SMALL_STATE(2324)] = 113550,
  [SMALL_STATE(2325)] = 113564,
  [SMALL_STATE(2326)] = 113578,
  [SMALL_STATE(2327)] = 113592,
  [SMALL_STATE(2328)] = 113604,
  [SMALL_STATE(2329)] = 113618,
  [SMALL_STATE(2330)] = 113630,
  [SMALL_STATE(2331)] = 113644,
  [SMALL_STATE(2332)] = 113658,
  [SMALL_STATE(2333)] = 113668,
  [SMALL_STATE(2334)] = 113682,
  [SMALL_STATE(2335)] = 113696,
  [SMALL_STATE(2336)] = 113710,
  [SMALL_STATE(2337)] = 113724,
  [SMALL_STATE(2338)] = 113736,
  [SMALL_STATE(2339)] = 113748,
  [SMALL_STATE(2340)] = 113762,
  [SMALL_STATE(2341)] = 113774,
  [SMALL_STATE(2342)] = 113788,
  [SMALL_STATE(2343)] = 113802,
  [SMALL_STATE(2344)] = 113816,
  [SMALL_STATE(2345)] = 113830,
  [SMALL_STATE(2346)] = 113844,
  [SMALL_STATE(2347)] = 113858,
  [SMALL_STATE(2348)] = 113868,
  [SMALL_STATE(2349)] = 113882,
  [SMALL_STATE(2350)] = 113896,
  [SMALL_STATE(2351)] = 113910,
  [SMALL_STATE(2352)] = 113924,
  [SMALL_STATE(2353)] = 113936,
  [SMALL_STATE(2354)] = 113950,
  [SMALL_STATE(2355)] = 113964,
  [SMALL_STATE(2356)] = 113978,
  [SMALL_STATE(2357)] = 113992,
  [SMALL_STATE(2358)] = 114006,
  [SMALL_STATE(2359)] = 114020,
  [SMALL_STATE(2360)] = 114034,
  [SMALL_STATE(2361)] = 114048,
  [SMALL_STATE(2362)] = 114062,
  [SMALL_STATE(2363)] = 114076,
  [SMALL_STATE(2364)] = 114090,
  [SMALL_STATE(2365)] = 114104,
  [SMALL_STATE(2366)] = 114118,
  [SMALL_STATE(2367)] = 114132,
  [SMALL_STATE(2368)] = 114146,
  [SMALL_STATE(2369)] = 114160,
  [SMALL_STATE(2370)] = 114174,
  [SMALL_STATE(2371)] = 114188,
  [SMALL_STATE(2372)] = 114202,
  [SMALL_STATE(2373)] = 114216,
  [SMALL_STATE(2374)] = 114230,
  [SMALL_STATE(2375)] = 114240,
  [SMALL_STATE(2376)] = 114252,
  [SMALL_STATE(2377)] = 114266,
  [SMALL_STATE(2378)] = 114278,
  [SMALL_STATE(2379)] = 114292,
  [SMALL_STATE(2380)] = 114306,
  [SMALL_STATE(2381)] = 114320,
  [SMALL_STATE(2382)] = 114334,
  [SMALL_STATE(2383)] = 114348,
  [SMALL_STATE(2384)] = 114362,
  [SMALL_STATE(2385)] = 114376,
  [SMALL_STATE(2386)] = 114390,
  [SMALL_STATE(2387)] = 114404,
  [SMALL_STATE(2388)] = 114418,
  [SMALL_STATE(2389)] = 114432,
  [SMALL_STATE(2390)] = 114444,
  [SMALL_STATE(2391)] = 114458,
  [SMALL_STATE(2392)] = 114472,
  [SMALL_STATE(2393)] = 114486,
  [SMALL_STATE(2394)] = 114500,
  [SMALL_STATE(2395)] = 114514,
  [SMALL_STATE(2396)] = 114528,
  [SMALL_STATE(2397)] = 114542,
  [SMALL_STATE(2398)] = 114556,
  [SMALL_STATE(2399)] = 114570,
  [SMALL_STATE(2400)] = 114584,
  [SMALL_STATE(2401)] = 114594,
  [SMALL_STATE(2402)] = 114608,
  [SMALL_STATE(2403)] = 114622,
  [SMALL_STATE(2404)] = 114636,
  [SMALL_STATE(2405)] = 114650,
  [SMALL_STATE(2406)] = 114660,
  [SMALL_STATE(2407)] = 114674,
  [SMALL_STATE(2408)] = 114688,
  [SMALL_STATE(2409)] = 114702,
  [SMALL_STATE(2410)] = 114716,
  [SMALL_STATE(2411)] = 114730,
  [SMALL_STATE(2412)] = 114744,
  [SMALL_STATE(2413)] = 114758,
  [SMALL_STATE(2414)] = 114772,
  [SMALL_STATE(2415)] = 114786,
  [SMALL_STATE(2416)] = 114800,
  [SMALL_STATE(2417)] = 114814,
  [SMALL_STATE(2418)] = 114828,
  [SMALL_STATE(2419)] = 114840,
  [SMALL_STATE(2420)] = 114854,
  [SMALL_STATE(2421)] = 114868,
  [SMALL_STATE(2422)] = 114882,
  [SMALL_STATE(2423)] = 114896,
  [SMALL_STATE(2424)] = 114910,
  [SMALL_STATE(2425)] = 114924,
  [SMALL_STATE(2426)] = 114936,
  [SMALL_STATE(2427)] = 114950,
  [SMALL_STATE(2428)] = 114962,
  [SMALL_STATE(2429)] = 114976,
  [SMALL_STATE(2430)] = 114990,
  [SMALL_STATE(2431)] = 115004,
  [SMALL_STATE(2432)] = 115018,
  [SMALL_STATE(2433)] = 115032,
  [SMALL_STATE(2434)] = 115046,
  [SMALL_STATE(2435)] = 115058,
  [SMALL_STATE(2436)] = 115070,
  [SMALL_STATE(2437)] = 115084,
  [SMALL_STATE(2438)] = 115098,
  [SMALL_STATE(2439)] = 115112,
  [SMALL_STATE(2440)] = 115124,
  [SMALL_STATE(2441)] = 115138,
  [SMALL_STATE(2442)] = 115152,
  [SMALL_STATE(2443)] = 115166,
  [SMALL_STATE(2444)] = 115180,
  [SMALL_STATE(2445)] = 115194,
  [SMALL_STATE(2446)] = 115208,
  [SMALL_STATE(2447)] = 115222,
  [SMALL_STATE(2448)] = 115236,
  [SMALL_STATE(2449)] = 115250,
  [SMALL_STATE(2450)] = 115264,
  [SMALL_STATE(2451)] = 115278,
  [SMALL_STATE(2452)] = 115292,
  [SMALL_STATE(2453)] = 115306,
  [SMALL_STATE(2454)] = 115320,
  [SMALL_STATE(2455)] = 115334,
  [SMALL_STATE(2456)] = 115348,
  [SMALL_STATE(2457)] = 115362,
  [SMALL_STATE(2458)] = 115376,
  [SMALL_STATE(2459)] = 115388,
  [SMALL_STATE(2460)] = 115402,
  [SMALL_STATE(2461)] = 115414,
  [SMALL_STATE(2462)] = 115428,
  [SMALL_STATE(2463)] = 115440,
  [SMALL_STATE(2464)] = 115454,
  [SMALL_STATE(2465)] = 115468,
  [SMALL_STATE(2466)] = 115480,
  [SMALL_STATE(2467)] = 115494,
  [SMALL_STATE(2468)] = 115504,
  [SMALL_STATE(2469)] = 115518,
  [SMALL_STATE(2470)] = 115532,
  [SMALL_STATE(2471)] = 115546,
  [SMALL_STATE(2472)] = 115560,
  [SMALL_STATE(2473)] = 115570,
  [SMALL_STATE(2474)] = 115580,
  [SMALL_STATE(2475)] = 115594,
  [SMALL_STATE(2476)] = 115608,
  [SMALL_STATE(2477)] = 115622,
  [SMALL_STATE(2478)] = 115636,
  [SMALL_STATE(2479)] = 115650,
  [SMALL_STATE(2480)] = 115664,
  [SMALL_STATE(2481)] = 115678,
  [SMALL_STATE(2482)] = 115692,
  [SMALL_STATE(2483)] = 115706,
  [SMALL_STATE(2484)] = 115720,
  [SMALL_STATE(2485)] = 115734,
  [SMALL_STATE(2486)] = 115748,
  [SMALL_STATE(2487)] = 115762,
  [SMALL_STATE(2488)] = 115776,
  [SMALL_STATE(2489)] = 115790,
  [SMALL_STATE(2490)] = 115804,
  [SMALL_STATE(2491)] = 115818,
  [SMALL_STATE(2492)] = 115832,
  [SMALL_STATE(2493)] = 115846,
  [SMALL_STATE(2494)] = 115860,
  [SMALL_STATE(2495)] = 115874,
  [SMALL_STATE(2496)] = 115888,
  [SMALL_STATE(2497)] = 115902,
  [SMALL_STATE(2498)] = 115916,
  [SMALL_STATE(2499)] = 115930,
  [SMALL_STATE(2500)] = 115944,
  [SMALL_STATE(2501)] = 115958,
  [SMALL_STATE(2502)] = 115972,
  [SMALL_STATE(2503)] = 115982,
  [SMALL_STATE(2504)] = 115996,
  [SMALL_STATE(2505)] = 116010,
  [SMALL_STATE(2506)] = 116024,
  [SMALL_STATE(2507)] = 116038,
  [SMALL_STATE(2508)] = 116052,
  [SMALL_STATE(2509)] = 116066,
  [SMALL_STATE(2510)] = 116078,
  [SMALL_STATE(2511)] = 116092,
  [SMALL_STATE(2512)] = 116106,
  [SMALL_STATE(2513)] = 116120,
  [SMALL_STATE(2514)] = 116134,
  [SMALL_STATE(2515)] = 116148,
  [SMALL_STATE(2516)] = 116162,
  [SMALL_STATE(2517)] = 116171,
  [SMALL_STATE(2518)] = 116182,
  [SMALL_STATE(2519)] = 116191,
  [SMALL_STATE(2520)] = 116200,
  [SMALL_STATE(2521)] = 116209,
  [SMALL_STATE(2522)] = 116218,
  [SMALL_STATE(2523)] = 116227,
  [SMALL_STATE(2524)] = 116236,
  [SMALL_STATE(2525)] = 116245,
  [SMALL_STATE(2526)] = 116254,
  [SMALL_STATE(2527)] = 116263,
  [SMALL_STATE(2528)] = 116274,
  [SMALL_STATE(2529)] = 116285,
  [SMALL_STATE(2530)] = 116294,
  [SMALL_STATE(2531)] = 116303,
  [SMALL_STATE(2532)] = 116312,
  [SMALL_STATE(2533)] = 116321,
  [SMALL_STATE(2534)] = 116330,
  [SMALL_STATE(2535)] = 116339,
  [SMALL_STATE(2536)] = 116348,
  [SMALL_STATE(2537)] = 116357,
  [SMALL_STATE(2538)] = 116366,
  [SMALL_STATE(2539)] = 116375,
  [SMALL_STATE(2540)] = 116384,
  [SMALL_STATE(2541)] = 116393,
  [SMALL_STATE(2542)] = 116402,
  [SMALL_STATE(2543)] = 116411,
  [SMALL_STATE(2544)] = 116420,
  [SMALL_STATE(2545)] = 116429,
  [SMALL_STATE(2546)] = 116438,
  [SMALL_STATE(2547)] = 116447,
  [SMALL_STATE(2548)] = 116456,
  [SMALL_STATE(2549)] = 116465,
  [SMALL_STATE(2550)] = 116474,
  [SMALL_STATE(2551)] = 116483,
  [SMALL_STATE(2552)] = 116494,
  [SMALL_STATE(2553)] = 116503,
  [SMALL_STATE(2554)] = 116512,
  [SMALL_STATE(2555)] = 116521,
  [SMALL_STATE(2556)] = 116530,
  [SMALL_STATE(2557)] = 116539,
  [SMALL_STATE(2558)] = 116548,
  [SMALL_STATE(2559)] = 116559,
  [SMALL_STATE(2560)] = 116568,
  [SMALL_STATE(2561)] = 116577,
  [SMALL_STATE(2562)] = 116586,
  [SMALL_STATE(2563)] = 116597,
  [SMALL_STATE(2564)] = 116606,
  [SMALL_STATE(2565)] = 116617,
  [SMALL_STATE(2566)] = 116626,
  [SMALL_STATE(2567)] = 116635,
  [SMALL_STATE(2568)] = 116646,
  [SMALL_STATE(2569)] = 116655,
  [SMALL_STATE(2570)] = 116664,
  [SMALL_STATE(2571)] = 116675,
  [SMALL_STATE(2572)] = 116686,
  [SMALL_STATE(2573)] = 116695,
  [SMALL_STATE(2574)] = 116704,
  [SMALL_STATE(2575)] = 116713,
  [SMALL_STATE(2576)] = 116724,
  [SMALL_STATE(2577)] = 116735,
  [SMALL_STATE(2578)] = 116744,
  [SMALL_STATE(2579)] = 116753,
  [SMALL_STATE(2580)] = 116764,
  [SMALL_STATE(2581)] = 116775,
  [SMALL_STATE(2582)] = 116784,
  [SMALL_STATE(2583)] = 116795,
  [SMALL_STATE(2584)] = 116806,
  [SMALL_STATE(2585)] = 116817,
  [SMALL_STATE(2586)] = 116826,
  [SMALL_STATE(2587)] = 116835,
  [SMALL_STATE(2588)] = 116844,
  [SMALL_STATE(2589)] = 116855,
  [SMALL_STATE(2590)] = 116864,
  [SMALL_STATE(2591)] = 116875,
  [SMALL_STATE(2592)] = 116886,
  [SMALL_STATE(2593)] = 116895,
  [SMALL_STATE(2594)] = 116906,
  [SMALL_STATE(2595)] = 116915,
  [SMALL_STATE(2596)] = 116924,
  [SMALL_STATE(2597)] = 116935,
  [SMALL_STATE(2598)] = 116944,
  [SMALL_STATE(2599)] = 116953,
  [SMALL_STATE(2600)] = 116962,
  [SMALL_STATE(2601)] = 116971,
  [SMALL_STATE(2602)] = 116980,
  [SMALL_STATE(2603)] = 116989,
  [SMALL_STATE(2604)] = 116998,
  [SMALL_STATE(2605)] = 117007,
  [SMALL_STATE(2606)] = 117016,
  [SMALL_STATE(2607)] = 117025,
  [SMALL_STATE(2608)] = 117036,
  [SMALL_STATE(2609)] = 117047,
  [SMALL_STATE(2610)] = 117056,
  [SMALL_STATE(2611)] = 117065,
  [SMALL_STATE(2612)] = 117074,
  [SMALL_STATE(2613)] = 117083,
  [SMALL_STATE(2614)] = 117092,
  [SMALL_STATE(2615)] = 117101,
  [SMALL_STATE(2616)] = 117112,
  [SMALL_STATE(2617)] = 117121,
  [SMALL_STATE(2618)] = 117129,
  [SMALL_STATE(2619)] = 117137,
  [SMALL_STATE(2620)] = 117145,
  [SMALL_STATE(2621)] = 117153,
  [SMALL_STATE(2622)] = 117161,
  [SMALL_STATE(2623)] = 117169,
  [SMALL_STATE(2624)] = 117177,
  [SMALL_STATE(2625)] = 117185,
  [SMALL_STATE(2626)] = 117193,
  [SMALL_STATE(2627)] = 117201,
  [SMALL_STATE(2628)] = 117209,
  [SMALL_STATE(2629)] = 117217,
  [SMALL_STATE(2630)] = 117225,
  [SMALL_STATE(2631)] = 117233,
  [SMALL_STATE(2632)] = 117241,
  [SMALL_STATE(2633)] = 117249,
  [SMALL_STATE(2634)] = 117257,
  [SMALL_STATE(2635)] = 117265,
  [SMALL_STATE(2636)] = 117273,
  [SMALL_STATE(2637)] = 117281,
  [SMALL_STATE(2638)] = 117289,
  [SMALL_STATE(2639)] = 117297,
  [SMALL_STATE(2640)] = 117305,
  [SMALL_STATE(2641)] = 117313,
  [SMALL_STATE(2642)] = 117321,
  [SMALL_STATE(2643)] = 117329,
  [SMALL_STATE(2644)] = 117337,
  [SMALL_STATE(2645)] = 117345,
  [SMALL_STATE(2646)] = 117353,
  [SMALL_STATE(2647)] = 117361,
  [SMALL_STATE(2648)] = 117369,
  [SMALL_STATE(2649)] = 117377,
  [SMALL_STATE(2650)] = 117385,
  [SMALL_STATE(2651)] = 117393,
  [SMALL_STATE(2652)] = 117401,
  [SMALL_STATE(2653)] = 117409,
  [SMALL_STATE(2654)] = 117417,
  [SMALL_STATE(2655)] = 117425,
  [SMALL_STATE(2656)] = 117433,
  [SMALL_STATE(2657)] = 117441,
  [SMALL_STATE(2658)] = 117449,
  [SMALL_STATE(2659)] = 117457,
  [SMALL_STATE(2660)] = 117465,
  [SMALL_STATE(2661)] = 117473,
  [SMALL_STATE(2662)] = 117481,
  [SMALL_STATE(2663)] = 117489,
  [SMALL_STATE(2664)] = 117497,
  [SMALL_STATE(2665)] = 117505,
  [SMALL_STATE(2666)] = 117513,
  [SMALL_STATE(2667)] = 117521,
  [SMALL_STATE(2668)] = 117529,
  [SMALL_STATE(2669)] = 117537,
  [SMALL_STATE(2670)] = 117545,
  [SMALL_STATE(2671)] = 117553,
  [SMALL_STATE(2672)] = 117561,
  [SMALL_STATE(2673)] = 117569,
  [SMALL_STATE(2674)] = 117577,
  [SMALL_STATE(2675)] = 117585,
  [SMALL_STATE(2676)] = 117593,
  [SMALL_STATE(2677)] = 117601,
  [SMALL_STATE(2678)] = 117609,
  [SMALL_STATE(2679)] = 117617,
  [SMALL_STATE(2680)] = 117625,
  [SMALL_STATE(2681)] = 117633,
  [SMALL_STATE(2682)] = 117641,
  [SMALL_STATE(2683)] = 117649,
  [SMALL_STATE(2684)] = 117657,
  [SMALL_STATE(2685)] = 117665,
  [SMALL_STATE(2686)] = 117673,
  [SMALL_STATE(2687)] = 117681,
  [SMALL_STATE(2688)] = 117689,
  [SMALL_STATE(2689)] = 117697,
  [SMALL_STATE(2690)] = 117705,
  [SMALL_STATE(2691)] = 117713,
  [SMALL_STATE(2692)] = 117721,
  [SMALL_STATE(2693)] = 117729,
  [SMALL_STATE(2694)] = 117737,
  [SMALL_STATE(2695)] = 117745,
  [SMALL_STATE(2696)] = 117753,
  [SMALL_STATE(2697)] = 117761,
  [SMALL_STATE(2698)] = 117769,
  [SMALL_STATE(2699)] = 117777,
  [SMALL_STATE(2700)] = 117785,
  [SMALL_STATE(2701)] = 117793,
  [SMALL_STATE(2702)] = 117801,
  [SMALL_STATE(2703)] = 117809,
  [SMALL_STATE(2704)] = 117817,
  [SMALL_STATE(2705)] = 117825,
  [SMALL_STATE(2706)] = 117833,
  [SMALL_STATE(2707)] = 117841,
  [SMALL_STATE(2708)] = 117849,
  [SMALL_STATE(2709)] = 117857,
  [SMALL_STATE(2710)] = 117865,
  [SMALL_STATE(2711)] = 117873,
  [SMALL_STATE(2712)] = 117881,
  [SMALL_STATE(2713)] = 117889,
  [SMALL_STATE(2714)] = 117897,
  [SMALL_STATE(2715)] = 117905,
  [SMALL_STATE(2716)] = 117913,
  [SMALL_STATE(2717)] = 117921,
  [SMALL_STATE(2718)] = 117929,
  [SMALL_STATE(2719)] = 117937,
  [SMALL_STATE(2720)] = 117945,
  [SMALL_STATE(2721)] = 117953,
  [SMALL_STATE(2722)] = 117961,
  [SMALL_STATE(2723)] = 117969,
  [SMALL_STATE(2724)] = 117977,
  [SMALL_STATE(2725)] = 117985,
  [SMALL_STATE(2726)] = 117993,
  [SMALL_STATE(2727)] = 118001,
  [SMALL_STATE(2728)] = 118009,
  [SMALL_STATE(2729)] = 118017,
  [SMALL_STATE(2730)] = 118025,
  [SMALL_STATE(2731)] = 118033,
  [SMALL_STATE(2732)] = 118041,
  [SMALL_STATE(2733)] = 118049,
  [SMALL_STATE(2734)] = 118057,
  [SMALL_STATE(2735)] = 118065,
  [SMALL_STATE(2736)] = 118073,
  [SMALL_STATE(2737)] = 118081,
  [SMALL_STATE(2738)] = 118089,
  [SMALL_STATE(2739)] = 118097,
  [SMALL_STATE(2740)] = 118105,
  [SMALL_STATE(2741)] = 118113,
  [SMALL_STATE(2742)] = 118121,
  [SMALL_STATE(2743)] = 118129,
  [SMALL_STATE(2744)] = 118137,
  [SMALL_STATE(2745)] = 118145,
  [SMALL_STATE(2746)] = 118153,
  [SMALL_STATE(2747)] = 118161,
  [SMALL_STATE(2748)] = 118169,
  [SMALL_STATE(2749)] = 118177,
  [SMALL_STATE(2750)] = 118185,
  [SMALL_STATE(2751)] = 118193,
  [SMALL_STATE(2752)] = 118201,
  [SMALL_STATE(2753)] = 118209,
  [SMALL_STATE(2754)] = 118217,
  [SMALL_STATE(2755)] = 118225,
  [SMALL_STATE(2756)] = 118233,
  [SMALL_STATE(2757)] = 118241,
  [SMALL_STATE(2758)] = 118249,
  [SMALL_STATE(2759)] = 118257,
  [SMALL_STATE(2760)] = 118265,
  [SMALL_STATE(2761)] = 118273,
  [SMALL_STATE(2762)] = 118281,
  [SMALL_STATE(2763)] = 118289,
  [SMALL_STATE(2764)] = 118297,
  [SMALL_STATE(2765)] = 118305,
  [SMALL_STATE(2766)] = 118313,
  [SMALL_STATE(2767)] = 118321,
  [SMALL_STATE(2768)] = 118329,
  [SMALL_STATE(2769)] = 118337,
  [SMALL_STATE(2770)] = 118345,
  [SMALL_STATE(2771)] = 118353,
  [SMALL_STATE(2772)] = 118361,
  [SMALL_STATE(2773)] = 118369,
  [SMALL_STATE(2774)] = 118377,
  [SMALL_STATE(2775)] = 118385,
  [SMALL_STATE(2776)] = 118393,
  [SMALL_STATE(2777)] = 118401,
  [SMALL_STATE(2778)] = 118409,
  [SMALL_STATE(2779)] = 118417,
  [SMALL_STATE(2780)] = 118425,
  [SMALL_STATE(2781)] = 118433,
  [SMALL_STATE(2782)] = 118441,
  [SMALL_STATE(2783)] = 118449,
  [SMALL_STATE(2784)] = 118457,
  [SMALL_STATE(2785)] = 118465,
  [SMALL_STATE(2786)] = 118473,
  [SMALL_STATE(2787)] = 118481,
  [SMALL_STATE(2788)] = 118489,
  [SMALL_STATE(2789)] = 118497,
  [SMALL_STATE(2790)] = 118505,
  [SMALL_STATE(2791)] = 118513,
  [SMALL_STATE(2792)] = 118521,
  [SMALL_STATE(2793)] = 118529,
  [SMALL_STATE(2794)] = 118537,
  [SMALL_STATE(2795)] = 118545,
  [SMALL_STATE(2796)] = 118553,
  [SMALL_STATE(2797)] = 118561,
  [SMALL_STATE(2798)] = 118569,
  [SMALL_STATE(2799)] = 118577,
  [SMALL_STATE(2800)] = 118585,
  [SMALL_STATE(2801)] = 118593,
  [SMALL_STATE(2802)] = 118601,
  [SMALL_STATE(2803)] = 118609,
  [SMALL_STATE(2804)] = 118617,
  [SMALL_STATE(2805)] = 118625,
  [SMALL_STATE(2806)] = 118633,
  [SMALL_STATE(2807)] = 118641,
  [SMALL_STATE(2808)] = 118649,
  [SMALL_STATE(2809)] = 118657,
  [SMALL_STATE(2810)] = 118665,
  [SMALL_STATE(2811)] = 118673,
  [SMALL_STATE(2812)] = 118681,
  [SMALL_STATE(2813)] = 118689,
  [SMALL_STATE(2814)] = 118697,
  [SMALL_STATE(2815)] = 118705,
  [SMALL_STATE(2816)] = 118713,
  [SMALL_STATE(2817)] = 118721,
  [SMALL_STATE(2818)] = 118729,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [7] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 0),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(603),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2252),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1875),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(84),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(495),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(368),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(467),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(360),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2521),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2522),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2523),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(523),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(86),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(462),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(733),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(532),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2804),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(418),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2803),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2802),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2801),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(461),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(73),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2800),
  [61] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [63] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [65] = {.entry = {.count = 1, .reusable = true}}, SHIFT(954),
  [67] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(587),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1654),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(359),
  [75] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1077),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1077),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(155),
  [81] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1756),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(561),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(85),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(469),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(722),
  [91] = {.entry = {.count = 1, .reusable = false}}, SHIFT(545),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2783),
  [95] = {.entry = {.count = 1, .reusable = false}}, SHIFT(434),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2808),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2785),
  [101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2327),
  [105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2538),
  [111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2546),
  [121] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(603),
  [124] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(2252),
  [127] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1875),
  [130] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(201),
  [133] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(869),
  [136] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(84),
  [139] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(495),
  [142] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(368),
  [145] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(467),
  [148] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(360),
  [151] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(2521),
  [154] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(2522),
  [157] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(2523),
  [160] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(561),
  [163] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(85),
  [166] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(469),
  [169] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(722),
  [172] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(545),
  [175] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(2783),
  [178] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(434),
  [181] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(2808),
  [184] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(2802),
  [187] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(2801),
  [190] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(461),
  [193] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(73),
  [196] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(2785),
  [199] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(221),
  [202] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(585),
  [205] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(954),
  [208] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(215),
  [211] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(587),
  [214] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1654),
  [217] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(359),
  [220] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1077),
  [223] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1077),
  [226] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(155),
  [229] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2),
  [231] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1756),
  [234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2458),
  [236] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 1),
  [238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [246] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(523),
  [249] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(86),
  [252] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(462),
  [255] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(733),
  [258] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(532),
  [261] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(2804),
  [264] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(418),
  [267] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(2803),
  [270] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(2800),
  [273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1200),
  [277] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1),
  [279] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1),
  [281] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(294),
  [284] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, .production_id = 1), REDUCE(sym_primary_expression, 1, .production_id = 1),
  [287] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(937),
  [290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1199),
  [292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__named_expression_lhs, 1, .production_id = 1),
  [294] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern, 1, .production_id = 1),
  [296] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(2667),
  [299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1201),
  [301] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(291),
  [304] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(934),
  [307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [309] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(499),
  [312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1662),
  [316] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1, .production_id = 1),
  [318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1282),
  [320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1282),
  [322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(163),
  [324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1737),
  [326] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, .production_id = 1), REDUCE(sym_primary_expression, 1, .production_id = 1),
  [329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(601),
  [331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(867),
  [335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(83),
  [337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(613),
  [339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2667),
  [341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(455),
  [343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(74),
  [345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(154),
  [349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(764),
  [371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1005),
  [383] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(302),
  [386] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(936),
  [389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1000),
  [391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(531),
  [393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1001),
  [395] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(298),
  [398] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(954),
  [401] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(587),
  [404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(157),
  [406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1202),
  [408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(927),
  [412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(934),
  [416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(499),
  [418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(615),
  [420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(658),
  [422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2552),
  [486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1842),
  [490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2554),
  [494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1823),
  [518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(653),
  [530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(758),
  [558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2534),
  [574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2539),
  [594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2578),
  [602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2542),
  [614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2337),
  [622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(643),
  [634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2518),
  [640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2389),
  [650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2544),
  [652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(936),
  [656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1151),
  [658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1126),
  [660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(954),
  [664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(158),
  [666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_splat_pattern, 2, .production_id = 5),
  [668] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym_list_splat_pattern, 2, .production_id = 5),
  [671] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_splat_pattern, 2, .production_id = 5),
  [673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1335),
  [675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1334),
  [677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(172),
  [679] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym_list_splat_pattern, 2, .production_id = 5),
  [682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1258),
  [684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(864),
  [688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1225),
  [690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1224),
  [692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1258),
  [700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(167),
  [702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1738),
  [704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1235),
  [706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(938),
  [710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1156),
  [712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1168),
  [714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(950),
  [718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1235),
  [722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(170),
  [724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1744),
  [726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1303),
  [728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(925),
  [732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1290),
  [734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1291),
  [736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(475),
  [738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(932),
  [742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1303),
  [746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(184),
  [748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1730),
  [750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1304),
  [752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(963),
  [756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1328),
  [758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1329),
  [760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1304),
  [768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(181),
  [770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1723),
  [772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1279),
  [774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(920),
  [778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1439),
  [780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1440),
  [782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1279),
  [790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(185),
  [792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1755),
  [794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1477),
  [796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(877),
  [800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1473),
  [802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1472),
  [804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1477),
  [812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(186),
  [814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1752),
  [816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1167),
  [818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1632),
  [822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1234),
  [826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1233),
  [828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(472),
  [832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1650),
  [834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(357),
  [836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(183),
  [838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(632),
  [840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1091),
  [842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2786),
  [846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(500),
  [848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1095),
  [850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1093),
  [854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1333),
  [856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(490),
  [858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1648),
  [860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(258),
  [862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(164),
  [864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1418),
  [866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1623),
  [868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2631),
  [870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1468),
  [872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1196),
  [874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1188),
  [880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1189),
  [882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1286),
  [886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(508),
  [888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1667),
  [890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(344),
  [892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(171),
  [894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1621),
  [896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1284),
  [898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1438),
  [900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2675),
  [902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1441),
  [904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2728),
  [906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1341),
  [908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1502),
  [912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(612),
  [914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1582),
  [916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2806),
  [918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1292),
  [920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1420),
  [922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1622),
  [924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1507),
  [926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1170),
  [928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1588),
  [930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2705),
  [932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1171),
  [934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1402),
  [936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2653),
  [940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1128),
  [942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1646),
  [944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1628),
  [946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1251),
  [948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2810),
  [950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1157),
  [952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1419),
  [956] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern_list, 3),
  [958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(869),
  [962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1306),
  [964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1305),
  [966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(174),
  [970] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern_list, 2),
  [972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1127),
  [974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1107),
  [980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1106),
  [982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(505),
  [986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1649),
  [988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(160),
  [990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1092),
  [992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1354),
  [996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2620),
  [998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(589),
  [1000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1097),
  [1002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [1004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1094),
  [1006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(165),
  [1008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1113),
  [1010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(942),
  [1012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2768),
  [1014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1222),
  [1016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(933),
  [1018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1312),
  [1020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2793),
  [1022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1318),
  [1024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(526),
  [1026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1665),
  [1028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(180),
  [1030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1186),
  [1032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2775),
  [1034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(937),
  [1036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1363),
  [1038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2695),
  [1040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1505),
  [1042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [1044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(939),
  [1046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1491),
  [1048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1499),
  [1050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [1052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(187),
  [1054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1296),
  [1056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2744),
  [1058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1111),
  [1060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2708),
  [1062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1287),
  [1064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2651),
  [1066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1461),
  [1068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2647),
  [1070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1144),
  [1072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(957),
  [1074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1182),
  [1076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2682),
  [1078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1180),
  [1080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(568),
  [1082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1652),
  [1084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(169),
  [1086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1360),
  [1088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [1090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(503),
  [1092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1355),
  [1094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1358),
  [1096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(177),
  [1098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1119),
  [1100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(494),
  [1102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield, 1),
  [1104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1098),
  [1106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1044),
  [1108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(162),
  [1110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1236),
  [1112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2758),
  [1114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1175),
  [1116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1380),
  [1118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1177),
  [1120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1176),
  [1122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(179),
  [1124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1259),
  [1126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1410),
  [1128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1231),
  [1130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [1132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1249),
  [1134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1247),
  [1136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1482),
  [1138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(175),
  [1140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1483),
  [1142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1371),
  [1144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1408),
  [1146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1409),
  [1148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1058),
  [1150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1163),
  [1152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1263),
  [1154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1054),
  [1156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1445),
  [1158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1178),
  [1160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1446),
  [1162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1179),
  [1164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1262),
  [1166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1447),
  [1168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1261),
  [1170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1448),
  [1172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1349),
  [1174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1424),
  [1176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1309),
  [1178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1423),
  [1180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1268),
  [1182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1356),
  [1184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1411),
  [1186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1381),
  [1188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1164),
  [1190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1280),
  [1192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1383),
  [1194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1372),
  [1196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1063),
  [1198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1183),
  [1200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1379),
  [1202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1378),
  [1204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1064),
  [1206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1184),
  [1208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1147),
  [1210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1389),
  [1212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1388),
  [1214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1269),
  [1216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1297),
  [1218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1140),
  [1220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1295),
  [1222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1357),
  [1224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1343),
  [1226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1342),
  [1228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [1230] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_clause, 6, .production_id = 99),
  [1232] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 6, .production_id = 99),
  [1234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1664),
  [1236] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_clause, 6, .production_id = 98),
  [1238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 6, .production_id = 98),
  [1240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [1242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1658),
  [1244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(920),
  [1246] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_clause, 5, .production_id = 79),
  [1248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 5, .production_id = 79),
  [1250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1656),
  [1252] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_list, 3),
  [1254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1320),
  [1256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [1258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [1260] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__collection_elements, 3),
  [1262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 7, .production_id = 110),
  [1264] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_clause, 7, .production_id = 110),
  [1266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [1268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(595),
  [1270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__collection_elements, 2),
  [1272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1174),
  [1274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [1276] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_list, 2),
  [1278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1453),
  [1280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1160),
  [1282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1458),
  [1284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1139),
  [1286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(481),
  [1288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [1290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1173),
  [1292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1374),
  [1294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1050),
  [1296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1404),
  [1298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1385),
  [1300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1264),
  [1302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1340),
  [1304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1387),
  [1306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1274),
  [1308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1325),
  [1310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(591),
  [1312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(963),
  [1314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1367),
  [1316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(509),
  [1318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [1320] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raise_statement, 1),
  [1322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(516),
  [1324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1406),
  [1326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [1328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [1330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1496),
  [1332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1493),
  [1334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1452),
  [1336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1451),
  [1338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 1),
  [1340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1497),
  [1342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1246),
  [1344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1089),
  [1346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1444),
  [1348] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary_splat_pattern, 2, .production_id = 5),
  [1350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1337),
  [1352] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice, 2),
  [1354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [1356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [1358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1432),
  [1360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1322),
  [1362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1430),
  [1364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1425),
  [1366] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_list, 3),
  [1368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1429),
  [1370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1321),
  [1372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1431),
  [1374] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_list, 2),
  [1376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1099),
  [1378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice, 1),
  [1380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [1382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1012),
  [1384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1205),
  [1386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(637),
  [1388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1014),
  [1390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1018),
  [1392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1276),
  [1394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1277),
  [1396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1270),
  [1398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [1400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1102),
  [1402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1413),
  [1404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 3),
  [1406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2),
  [1408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 4, .production_id = 14),
  [1410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 3),
  [1412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [1414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [1416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2702),
  [1418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice, 4),
  [1420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 3),
  [1422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 2),
  [1424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2674),
  [1426] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 3, .dynamic_precedence = -1, .production_id = 6),
  [1428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice, 3),
  [1430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 4, .dynamic_precedence = -1, .production_id = 15),
  [1432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2348),
  [1434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2377),
  [1436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1725),
  [1438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2452),
  [1440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2430),
  [1442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [1444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [1446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2654),
  [1448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [1450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [1452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [1454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2809),
  [1456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [1458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2432),
  [1460] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 4, .production_id = 42),
  [1462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 4, .production_id = 42),
  [1464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2721),
  [1466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [1468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2716),
  [1470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(470),
  [1472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1481),
  [1474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1478),
  [1476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1479),
  [1478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(176),
  [1480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1060),
  [1482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1062),
  [1484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1061),
  [1486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(166),
  [1488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1471),
  [1490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1469),
  [1492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1470),
  [1494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(182),
  [1496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2625),
  [1498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(464),
  [1500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2725),
  [1502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 5, .production_id = 63),
  [1504] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 5, .production_id = 63),
  [1506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [1508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1229),
  [1510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1227),
  [1512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1228),
  [1514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1194),
  [1516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1215),
  [1518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1216),
  [1520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1488),
  [1522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1486),
  [1524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1487),
  [1526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_expression, 1),
  [1528] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1), REDUCE(sym_primary_expression, 1),
  [1531] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primary_expression, 1),
  [1533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__named_expression_lhs, 1),
  [1535] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1), REDUCE(sym_primary_expression, 1),
  [1538] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern, 1),
  [1540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [1542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1),
  [1544] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat2, 2),
  [1546] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat2, 2),
  [1548] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat2, 2), SHIFT_REPEAT(507),
  [1551] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, .production_id = 56),
  [1553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, .production_id = 56),
  [1555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(489),
  [1557] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, .production_id = 57),
  [1559] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, .production_id = 57),
  [1561] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, .production_id = 37),
  [1563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, .production_id = 37),
  [1565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(502),
  [1567] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, .production_id = 83),
  [1569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, .production_id = 83),
  [1571] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2),
  [1573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat1, 2),
  [1575] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(470),
  [1578] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(464),
  [1581] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat2, 2), SHIFT_REPEAT(521),
  [1584] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript, 5, .production_id = 72),
  [1586] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript, 5, .production_id = 72),
  [1588] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_splat_pattern, 2),
  [1590] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_list_splat_pattern, 2),
  [1593] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_list_splat_pattern, 2),
  [1596] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_splat_pattern, 2),
  [1598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 2, .production_id = 81),
  [1600] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 2, .production_id = 81),
  [1602] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 2, .production_id = 81), SHIFT_REPEAT(502),
  [1605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 3, .production_id = 23),
  [1607] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute, 3, .production_id = 23),
  [1609] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_splat_type, 2),
  [1611] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_splat_type, 2),
  [1613] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 2),
  [1615] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1), REDUCE(sym_primary_expression, 1, .production_id = 2),
  [1618] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 2),
  [1620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 2),
  [1622] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_list_pattern, 2), REDUCE(sym_list, 2),
  [1625] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 2),
  [1627] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_pattern, 2),
  [1629] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_pattern, 2),
  [1631] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript, 5, .production_id = 48),
  [1633] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript, 5, .production_id = 48),
  [1635] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 2, .production_id = 81), SHIFT_REPEAT(489),
  [1638] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple, 2),
  [1640] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_tuple_pattern, 2), REDUCE(sym_tuple, 2),
  [1643] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple, 2),
  [1645] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_pattern, 2),
  [1647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 2),
  [1649] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript, 6, .production_id = 72),
  [1651] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript, 6, .production_id = 72),
  [1653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript, 4, .production_id = 48),
  [1655] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript, 4, .production_id = 48),
  [1657] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_statements, 4),
  [1659] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_statements, 4),
  [1661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_group_clause, 4, .production_id = 106),
  [1663] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_group_clause, 4, .production_id = 106),
  [1665] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 1),
  [1667] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 1),
  [1669] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_statements, 3),
  [1671] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_statements, 3),
  [1673] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_clause, 7),
  [1675] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_clause, 7),
  [1677] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_clause, 6, .production_id = 129),
  [1679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_clause, 6, .production_id = 129),
  [1681] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_clause, 5),
  [1683] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_clause, 5),
  [1685] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_group_clause, 6, .production_id = 129),
  [1687] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_group_clause, 6, .production_id = 129),
  [1689] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_group_clause, 7),
  [1691] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_group_clause, 7),
  [1693] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 2),
  [1695] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 2),
  [1697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1587),
  [1699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [1701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [1703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1583),
  [1705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1585),
  [1707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [1709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(339),
  [1711] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_statements, 2),
  [1713] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_statements, 2),
  [1715] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_group_clause, 5),
  [1717] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_group_clause, 5),
  [1719] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_clause, 3, .production_id = 90),
  [1721] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_clause, 3, .production_id = 90),
  [1723] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_clause, 4, .production_id = 106),
  [1725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_clause, 4, .production_id = 106),
  [1727] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_clause, 4),
  [1729] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_clause, 4),
  [1731] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 101),
  [1733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 101),
  [1735] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elif_clause, 5, .production_id = 57),
  [1737] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elif_clause, 5, .production_id = 57),
  [1739] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elif_clause, 4, .production_id = 37),
  [1741] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elif_clause, 4, .production_id = 37),
  [1743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 5, .production_id = 42),
  [1745] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 5, .production_id = 42),
  [1747] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 114),
  [1749] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 114),
  [1751] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 105),
  [1753] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 105),
  [1755] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 1, .production_id = 54),
  [1757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 1, .production_id = 54),
  [1759] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 4, .production_id = 41),
  [1761] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 4, .production_id = 41),
  [1763] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 6, .production_id = 63),
  [1765] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 6, .production_id = 63),
  [1767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 5, .production_id = 62),
  [1769] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 5, .production_id = 62),
  [1771] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, .production_id = 88),
  [1773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, .production_id = 88),
  [1775] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 4, .production_id = 63),
  [1777] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 4, .production_id = 63),
  [1779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1610),
  [1781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [1783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2405),
  [1785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [1787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1641),
  [1789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1644),
  [1791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [1793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(441),
  [1795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 3, .production_id = 42),
  [1797] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 3, .production_id = 42),
  [1799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2323),
  [1801] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 6, .production_id = 92),
  [1803] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 6, .production_id = 92),
  [1805] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 7, .production_id = 107),
  [1807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 7, .production_id = 107),
  [1809] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 7, .production_id = 103),
  [1811] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 7, .production_id = 103),
  [1813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1625),
  [1815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [1817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1614),
  [1819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1616),
  [1821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [1823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(411),
  [1825] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 104),
  [1827] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 104),
  [1829] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_statement, 4, .production_id = 39),
  [1831] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_statement, 4, .production_id = 39),
  [1833] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally_clause, 4),
  [1835] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finally_clause, 4),
  [1837] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 7, .production_id = 63),
  [1839] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 7, .production_id = 63),
  [1841] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__match_block, 1),
  [1843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__match_block, 1),
  [1845] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 7, .production_id = 108),
  [1847] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 7, .production_id = 108),
  [1849] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 7, .production_id = 109),
  [1851] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 7, .production_id = 109),
  [1853] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_statement, 5, .production_id = 58),
  [1855] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_statement, 5, .production_id = 58),
  [1857] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__match_block, 2),
  [1859] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__match_block, 2),
  [1861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1611),
  [1863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [1865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [1867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1640),
  [1869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1645),
  [1871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [1873] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__patterns, 3),
  [1875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(449),
  [1877] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_statement, 5, .production_id = 59),
  [1879] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_statement, 5, .production_id = 59),
  [1881] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_statement, 5, .production_id = 60),
  [1883] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_statement, 5, .production_id = 60),
  [1885] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_statement, 4, .production_id = 43),
  [1887] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_statement, 4, .production_id = 43),
  [1889] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 4, .production_id = 44),
  [1891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 4, .production_id = 44),
  [1893] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern_list, 3),
  [1895] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_statement, 5, .production_id = 64),
  [1897] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_statement, 5, .production_id = 64),
  [1899] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 5, .production_id = 65),
  [1901] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 5, .production_id = 65),
  [1903] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, .production_id = 55),
  [1905] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, .production_id = 55),
  [1907] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 5, .production_id = 66),
  [1909] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 5, .production_id = 66),
  [1911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 5, .production_id = 67),
  [1913] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 5, .production_id = 67),
  [1915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 5, .production_id = 68),
  [1917] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 5, .production_id = 68),
  [1919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 113),
  [1921] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 113),
  [1923] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 8, .production_id = 115),
  [1925] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 8, .production_id = 115),
  [1927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 8, .production_id = 116),
  [1929] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 8, .production_id = 116),
  [1931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 117),
  [1933] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 117),
  [1935] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 8, .production_id = 118),
  [1937] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 8, .production_id = 118),
  [1939] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 8, .production_id = 119),
  [1941] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 8, .production_id = 119),
  [1943] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 6, .production_id = 95),
  [1945] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 6, .production_id = 95),
  [1947] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 5, .production_id = 61),
  [1949] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 5, .production_id = 61),
  [1951] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 10, .production_id = 135),
  [1953] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 10, .production_id = 135),
  [1955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__patterns, 2),
  [1957] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 9, .production_id = 130),
  [1959] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 9, .production_id = 130),
  [1961] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, .production_id = 80),
  [1963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, .production_id = 80),
  [1965] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, .production_id = 82),
  [1967] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, .production_id = 82),
  [1969] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 9, .production_id = 128),
  [1971] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 9, .production_id = 128),
  [1973] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorated_definition, 2, .production_id = 12),
  [1975] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorated_definition, 2, .production_id = 12),
  [1977] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 9, .production_id = 127),
  [1979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 9, .production_id = 127),
  [1981] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9, .production_id = 126),
  [1983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9, .production_id = 126),
  [1985] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 7, .production_id = 100),
  [1987] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 7, .production_id = 100),
  [1989] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__match_block, 3, .production_id = 84),
  [1991] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__match_block, 3, .production_id = 84),
  [1993] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_statement, 6, .production_id = 85),
  [1995] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_statement, 6, .production_id = 85),
  [1997] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_statement, 6, .production_id = 86),
  [1999] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_statement, 6, .production_id = 86),
  [2001] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 6, .production_id = 87),
  [2003] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 6, .production_id = 87),
  [2005] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern_list, 2),
  [2007] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 6, .production_id = 89),
  [2009] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 6, .production_id = 89),
  [2011] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finally_clause, 3, .production_id = 90),
  [2013] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally_clause, 3, .production_id = 90),
  [2015] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 6, .production_id = 42),
  [2017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 6, .production_id = 42),
  [2019] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 6, .production_id = 91),
  [2021] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 6, .production_id = 91),
  [2023] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 6, .production_id = 94),
  [2025] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 6, .production_id = 94),
  [2027] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 6, .production_id = 93),
  [2029] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 6, .production_id = 93),
  [2031] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 7, .production_id = 102),
  [2033] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 7, .production_id = 102),
  [2035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(939),
  [2037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1600),
  [2039] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_separator, 1),
  [2041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1602),
  [2043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1599),
  [2045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(397),
  [2047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1636),
  [2049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1637),
  [2051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1639),
  [2053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(404),
  [2055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(860),
  [2057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(912),
  [2059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(883),
  [2061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(916),
  [2063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(873),
  [2065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(923),
  [2067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(926),
  [2069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(892),
  [2071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1237),
  [2073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1267),
  [2075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1187),
  [2077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(161),
  [2079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(625),
  [2081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(623),
  [2083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(622),
  [2085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(156),
  [2087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(620),
  [2089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1480),
  [2091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1476),
  [2093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1474),
  [2095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(178),
  [2097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1436),
  [2099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1314),
  [2101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1313),
  [2103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(168),
  [2105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1629),
  [2107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1613),
  [2109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1612),
  [2111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(432),
  [2113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1350),
  [2115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1434),
  [2117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1435),
  [2119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1407),
  [2121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1307),
  [2123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1308),
  [2125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1359),
  [2127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1285),
  [2129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1293),
  [2131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(173),
  [2133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1485),
  [2135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1135),
  [2137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1101),
  [2139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1100),
  [2141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(159),
  [2143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1475),
  [2145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1257),
  [2147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1241),
  [2149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1253),
  [2151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1500),
  [2153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1498),
  [2155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1489),
  [2157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(188),
  [2159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1319),
  [2161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1607),
  [2163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1604),
  [2165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1598),
  [2167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(373),
  [2169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1376),
  [2171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2),
  [2173] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2),
  [2175] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(1756),
  [2178] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1),
  [2180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2771),
  [2182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [2184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(918),
  [2186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [2188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [2190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [2192] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1),
  [2194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [2196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [2198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [2200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [2202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2686),
  [2204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [2206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [2208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(904),
  [2210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [2212] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concatenated_string, 2),
  [2214] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concatenated_string, 2),
  [2216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_operator, 3, .production_id = 21),
  [2218] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_operator, 3, .production_id = 21),
  [2220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2715),
  [2222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [2224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(880),
  [2226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [2228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [2230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [2232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [2234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [2236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [2238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [2240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2789),
  [2242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(871),
  [2244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [2246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(878),
  [2248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [2250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 3, .production_id = 49),
  [2252] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 3, .production_id = 49),
  [2254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 3, .production_id = 50),
  [2256] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 3, .production_id = 50),
  [2258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 24),
  [2260] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 24),
  [2262] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(1744),
  [2265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2794),
  [2267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [2269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(964),
  [2271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(966),
  [2273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(956),
  [2275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(941),
  [2277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [2279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(964),
  [2281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [2283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [2285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2735),
  [2287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [2289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [2291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(956),
  [2293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [2295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_await, 2),
  [2297] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_await, 2),
  [2299] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_operator, 2, .production_id = 9),
  [2301] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_operator, 2, .production_id = 9),
  [2303] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(1738),
  [2306] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(1755),
  [2309] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(1723),
  [2312] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(1737),
  [2315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2685),
  [2317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [2319] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2),
  [2321] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 2),
  [2323] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(1730),
  [2326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2638),
  [2328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [2330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(943),
  [2332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [2334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(945),
  [2336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [2338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [2340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(943),
  [2342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [2344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [2346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2712),
  [2348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [2350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(952),
  [2352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(945),
  [2354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [2356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2670),
  [2358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [2360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(955),
  [2362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(958),
  [2364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(959),
  [2366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [2368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [2370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(955),
  [2372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(965),
  [2374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [2376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2770),
  [2378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [2380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [2382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(959),
  [2384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [2386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2730),
  [2388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [2390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(961),
  [2392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [2394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [2396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [2398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [2400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(961),
  [2402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [2404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [2406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2668),
  [2408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [2410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [2412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(863),
  [2414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [2416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3),
  [2418] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 3),
  [2420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2782),
  [2422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [2424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(893),
  [2426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [2428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [2430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [2432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [2434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [2436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(897),
  [2438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [2440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2773),
  [2442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [2444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [2446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(895),
  [2448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [2450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_expression, 4, .production_id = 34),
  [2452] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_expression, 4, .production_id = 34),
  [2454] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary, 5),
  [2456] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dictionary, 5),
  [2458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 4),
  [2460] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 4),
  [2462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 4, .production_id = 33),
  [2464] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 4, .production_id = 33),
  [2466] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_comprehension, 4, .production_id = 34),
  [2468] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_comprehension, 4, .production_id = 34),
  [2470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2671),
  [2472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [2474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(922),
  [2476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [2478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [2480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [2482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [2484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [2486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [2488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [2490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2639),
  [2492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [2494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [2496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(909),
  [2498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [2500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(476),
  [2502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 2),
  [2504] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 2),
  [2506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [2508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set, 3),
  [2510] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_set, 3),
  [2512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary, 3),
  [2514] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dictionary, 3),
  [2516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 3),
  [2518] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 3),
  [2520] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary, 2),
  [2522] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dictionary, 2),
  [2524] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 3, .production_id = 33),
  [2526] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 3, .production_id = 33),
  [2528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 3),
  [2530] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 3),
  [2532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary_comprehension, 4, .production_id = 34),
  [2534] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dictionary_comprehension, 4, .production_id = 34),
  [2536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple, 3),
  [2538] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple, 3),
  [2540] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set_comprehension, 4, .production_id = 34),
  [2542] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_set_comprehension, 4, .production_id = 34),
  [2544] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary, 4),
  [2546] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dictionary, 4),
  [2548] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 5, .production_id = 33),
  [2550] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 5, .production_id = 33),
  [2552] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3),
  [2554] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3),
  [2556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [2558] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 5),
  [2560] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 5),
  [2562] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call, 2, .production_id = 10),
  [2564] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call, 2, .production_id = 10),
  [2566] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(1752),
  [2569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [2571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1765),
  [2573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1540),
  [2575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2577),
  [2577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(556),
  [2579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [2581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2577),
  [2583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1527),
  [2585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2596),
  [2587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1974),
  [2589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1558),
  [2591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1871),
  [2593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1871),
  [2595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [2597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1803),
  [2599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1528),
  [2601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2240),
  [2603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2592),
  [2605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2592),
  [2607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1529),
  [2609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2591),
  [2611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2038),
  [2613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1560),
  [2615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1999),
  [2617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1999),
  [2619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1796),
  [2621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1543),
  [2623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2566),
  [2625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2566),
  [2627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1544),
  [2629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2029),
  [2631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2570),
  [2633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2061),
  [2635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1557),
  [2637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1939),
  [2639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1939),
  [2641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2222),
  [2643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2131),
  [2645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2214),
  [2647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2022),
  [2649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2137),
  [2651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2228),
  [2653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2143),
  [2655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2039),
  [2657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2161),
  [2659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2154),
  [2661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2241),
  [2663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2156),
  [2665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2235),
  [2667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2236),
  [2669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2147),
  [2671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2073),
  [2673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2197),
  [2675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2189),
  [2677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2184),
  [2679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2195),
  [2681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2146),
  [2683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2243),
  [2685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2114),
  [2687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2133),
  [2689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2207),
  [2691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2033),
  [2693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2216),
  [2695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2103),
  [2697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2068),
  [2699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2041),
  [2701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2157),
  [2703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2196),
  [2705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2202),
  [2707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2179),
  [2709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1799),
  [2711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1522),
  [2713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2612),
  [2715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2612),
  [2717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1533),
  [2719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2615),
  [2721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2025),
  [2723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1559),
  [2725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1914),
  [2727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1914),
  [2729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1777),
  [2731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2414),
  [2733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2168),
  [2735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2151),
  [2737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2128),
  [2739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2091),
  [2741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2129),
  [2743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2148),
  [2745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2204),
  [2747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2076),
  [2749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2245),
  [2751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2181),
  [2753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2035),
  [2755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2219),
  [2757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2065),
  [2759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2221),
  [2761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2175),
  [2763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2036),
  [2765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2231),
  [2767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2153),
  [2769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2233),
  [2771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2150),
  [2773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1870),
  [2775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2018),
  [2777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1859),
  [2779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2053),
  [2781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2059),
  [2783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1953),
  [2785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2023),
  [2787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1883),
  [2789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2097),
  [2791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1981),
  [2793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2085),
  [2795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 25),
  [2797] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 25), SHIFT_REPEAT(904),
  [2800] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 25),
  [2802] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 25), SHIFT_REPEAT(2686),
  [2805] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 25), SHIFT_REPEAT(904),
  [2808] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 25), SHIFT_REPEAT(856),
  [2811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comparison_operator, 2, .production_id = 11),
  [2813] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_comparison_operator, 2, .production_id = 11),
  [2815] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 25), SHIFT_REPEAT(959),
  [2818] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 25), SHIFT_REPEAT(2770),
  [2821] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 25), SHIFT_REPEAT(959),
  [2824] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 25), SHIFT_REPEAT(852),
  [2827] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 25), SHIFT_REPEAT(945),
  [2830] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 25), SHIFT_REPEAT(2712),
  [2833] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 25), SHIFT_REPEAT(945),
  [2836] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 25), SHIFT_REPEAT(854),
  [2839] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 25), SHIFT_REPEAT(956),
  [2842] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 25), SHIFT_REPEAT(2735),
  [2845] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 25), SHIFT_REPEAT(956),
  [2848] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 25), SHIFT_REPEAT(851),
  [2851] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 25), SHIFT_REPEAT(878),
  [2854] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 25), SHIFT_REPEAT(2789),
  [2857] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 25), SHIFT_REPEAT(878),
  [2860] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 25), SHIFT_REPEAT(855),
  [2863] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 25), SHIFT_REPEAT(909),
  [2866] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 25), SHIFT_REPEAT(2639),
  [2869] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 25), SHIFT_REPEAT(909),
  [2872] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 25), SHIFT_REPEAT(858),
  [2875] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 25), SHIFT_REPEAT(863),
  [2878] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 25), SHIFT_REPEAT(2668),
  [2881] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 25), SHIFT_REPEAT(863),
  [2884] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 25), SHIFT_REPEAT(853),
  [2887] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__patterns_repeat1, 2),
  [2889] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__patterns_repeat1, 2), SHIFT_REPEAT(846),
  [2892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [2894] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary_splat_pattern, 2),
  [2896] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 25), SHIFT_REPEAT(895),
  [2899] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 25), SHIFT_REPEAT(2773),
  [2902] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 25), SHIFT_REPEAT(895),
  [2905] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 25), SHIFT_REPEAT(857),
  [2908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2681),
  [2910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [2912] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_pattern, 3),
  [2914] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 3),
  [2916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2427),
  [2918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [2920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(850),
  [2922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [2924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [2926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2614),
  [2928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [2930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [2932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [2934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [2936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [2938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [2940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [2942] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__patterns_repeat1, 2), SHIFT_REPEAT(845),
  [2945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [2947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__right_hand_side, 1),
  [2949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [2951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [2953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [2955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [2957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [2959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [2961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [2963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [2965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2134),
  [2967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(718),
  [2969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2589),
  [2971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(849),
  [2973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(949),
  [2975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2597),
  [2977] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameters, 3),
  [2979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameters, 2),
  [2981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_not_operator, 2, .production_id = 6),
  [2983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_as_pattern, 3, .production_id = 22),
  [2985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [2987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [2989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [2991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(582),
  [2993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [2995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [2997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2816),
  [2999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [3001] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__collection_elements, 1),
  [3003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [3005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [3007] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda, 3, .production_id = 17),
  [3009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [3011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [3013] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda, 4, .production_id = 47),
  [3015] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_expression, 3, .production_id = 18),
  [3017] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_named_expression, 3, .production_id = 18), SHIFT(497),
  [3020] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_boolean_operator, 3, .production_id = 21),
  [3022] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_expression, 5),
  [3024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1165),
  [3026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [3028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(598),
  [3030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [3032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2791),
  [3034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [3036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [3038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [3040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [3042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(510),
  [3044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [3046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2813),
  [3048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [3050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [3052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [3054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1393),
  [3056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [3058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1397),
  [3060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [3062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1302),
  [3064] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_item, 1, .dynamic_precedence = 1, .production_id = 7), SHIFT(335),
  [3067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1240),
  [3069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1266),
  [3071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [3073] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 1),
  [3075] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 1),
  [3077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [3079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1203),
  [3081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1412),
  [3083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [3085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1331),
  [3087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [3089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1311),
  [3091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1347),
  [3093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1455),
  [3095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [3097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1134),
  [3099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [3101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1370),
  [3103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [3105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1143),
  [3107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1466),
  [3109] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_named_expression, 3, .production_id = 18), SHIFT(543),
  [3112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [3114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [3116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [3118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [3120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [3122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1896),
  [3124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1896),
  [3126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1158),
  [3128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1239),
  [3130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [3132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [3134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [3136] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield, 2),
  [3138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [3140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [3142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2400),
  [3144] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__f_expression, 1),
  [3146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1181),
  [3148] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(225),
  [3151] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(1896),
  [3154] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(1896),
  [3157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2),
  [3159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1255),
  [3161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1076),
  [3163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1223),
  [3165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1204),
  [3167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1129),
  [3169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [3171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [3173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [3175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [3177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1114),
  [3179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1065),
  [3181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2290),
  [3183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1024),
  [3185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1433),
  [3187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1238),
  [3189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1250),
  [3191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(999),
  [3193] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_named_expression, 3, .production_id = 18), SHIFT(555),
  [3196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1437),
  [3198] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_boolean_operator, 3, .production_id = 21),
  [3200] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dotted_name, 2),
  [3202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2766),
  [3204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [3206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [3208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [3210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [3212] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dotted_name, 1),
  [3214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1575),
  [3216] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_named_expression, 3, .production_id = 18), SHIFT(590),
  [3219] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_named_expression, 3, .production_id = 18), SHIFT(565),
  [3222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_dotted_name_repeat1, 2),
  [3224] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dotted_name_repeat1, 2), SHIFT_REPEAT(2766),
  [3227] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_not_operator, 2, .production_id = 6),
  [3229] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_named_expression, 3, .production_id = 18), SHIFT(582),
  [3232] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_as_pattern, 3, .production_id = 22),
  [3234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield, 3),
  [3236] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raise_statement, 2),
  [3238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [3240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [3242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_assert_statement_repeat1, 2),
  [3244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2666),
  [3246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1579),
  [3248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2),
  [3250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_within_for_in_clause, 1),
  [3252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2739),
  [3254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1576),
  [3256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2764),
  [3258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1573),
  [3260] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_pattern, 1),
  [3262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [3264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [3266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1260),
  [3268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [3270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1084),
  [3272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [3274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [3276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2812),
  [3278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2808),
  [3280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2785),
  [3282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [3284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1023),
  [3286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [3288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1421),
  [3290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2725),
  [3292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2698),
  [3294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2803),
  [3296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2800),
  [3298] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_named_expression, 3, .production_id = 18), SHIFT(510),
  [3301] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exec_statement, 4, .production_id = 8),
  [3303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [3305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [3307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1345),
  [3309] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 2, .dynamic_precedence = -1, .production_id = 6),
  [3311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [3313] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assert_statement, 2),
  [3315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [3317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1172),
  [3319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [3321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1490),
  [3323] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delete_statement, 2),
  [3325] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_named_expression, 3, .production_id = 18), SHIFT(598),
  [3328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2716),
  [3330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair, 3, .production_id = 45),
  [3332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [3334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1399),
  [3336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [3338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1442),
  [3340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [3342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1195),
  [3344] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__comprehension_clauses, 1),
  [3346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [3348] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__comprehension_clauses, 2),
  [3350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [3352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [3354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_print_statement_repeat1, 2, .production_id = 6),
  [3356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [3358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1364),
  [3360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_content_repeat1, 2),
  [3362] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_content_repeat1, 2), SHIFT_REPEAT(1863),
  [3365] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_content_repeat1, 2), SHIFT_REPEAT(1863),
  [3368] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dotted_name_repeat1, 2), SHIFT_REPEAT(2764),
  [3371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [3373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1352),
  [3375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [3377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [3379] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dotted_name_repeat1, 2), SHIFT_REPEAT(2666),
  [3382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2607),
  [3384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [3386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1289),
  [3388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [3390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [3392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2239),
  [3394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2774),
  [3396] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2), SHIFT_REPEAT(511),
  [3399] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2), SHIFT_REPEAT(2813),
  [3402] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2), SHIFT_REPEAT(751),
  [3405] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2),
  [3407] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_clause, 2),
  [3409] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dotted_name_repeat1, 2), SHIFT_REPEAT(2739),
  [3412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [3414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_subscript_repeat1, 2, .production_id = 71),
  [3416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [3418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [3420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [3422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2503),
  [3424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1936),
  [3426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2238),
  [3428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2525),
  [3430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [3432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2481),
  [3434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_pattern, 2),
  [3436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2593),
  [3438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [3440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1463),
  [3442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [3444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1122),
  [3446] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2), SHIFT_REPEAT(483),
  [3449] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2), SHIFT_REPEAT(2791),
  [3452] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2), SHIFT_REPEAT(836),
  [3455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [3457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1192),
  [3459] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_content, 1),
  [3461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1863),
  [3463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1863),
  [3465] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_chevron, 2),
  [3467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [3469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [3471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1339),
  [3473] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2), SHIFT_REPEAT(541),
  [3476] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2), SHIFT_REPEAT(2816),
  [3479] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2), SHIFT_REPEAT(726),
  [3482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2567),
  [3484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 4),
  [3486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_item, 1, .dynamic_precedence = 1, .production_id = 7),
  [3488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [3490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [3492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [3494] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_for_in_clause_repeat1, 2),
  [3496] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_for_in_clause_repeat1, 2), SHIFT_REPEAT(410),
  [3499] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__collection_elements_repeat1, 2),
  [3501] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 6, .production_id = 110),
  [3503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [3505] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice, 5),
  [3507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2517),
  [3509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 3),
  [3511] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dotted_name_repeat1, 2), SHIFT_REPEAT(2762),
  [3514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2756),
  [3516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [3518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [3520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2011),
  [3522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [3524] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_splat, 2),
  [3526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_type, 3),
  [3528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1915),
  [3530] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raise_statement, 3, .production_id = 16),
  [3532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constrained_type, 3),
  [3534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2693),
  [3536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [3538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [3540] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type, 3),
  [3542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_pattern, 2),
  [3544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1578),
  [3546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2661),
  [3548] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_parameter, 3, .production_id = 46),
  [3550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [3552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [3554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [3556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_default_parameter, 5, .production_id = 96),
  [3558] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_parameter, 3, .production_id = 18),
  [3560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [3562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [3564] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 4, .production_id = 79),
  [3566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [3568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 5, .production_id = 98),
  [3570] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__patterns_repeat1, 2), SHIFT_REPEAT(843),
  [3573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_argument, 3, .production_id = 70),
  [3575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2762),
  [3577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_argument, 3, .production_id = 18),
  [3579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2575),
  [3581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1969),
  [3583] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary_splat, 2),
  [3585] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2),
  [3587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 4, .production_id = 53),
  [3589] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 4, .production_id = 53),
  [3591] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 5, .production_id = 99),
  [3593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [3595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [3597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [3599] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 6, .production_id = 97),
  [3601] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 6, .production_id = 97),
  [3603] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 4, .production_id = 52),
  [3605] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 4, .production_id = 52),
  [3607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [3609] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_pattern, 3),
  [3611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2580),
  [3613] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_assert_statement_repeat1, 2), SHIFT_REPEAT(570),
  [3616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2003),
  [3618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [3620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [3622] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_match_statement_repeat1, 2, .production_id = 38),
  [3624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [3626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 4, .production_id = 26),
  [3628] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 4, .production_id = 26),
  [3630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [3632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2),
  [3634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_pattern, 1),
  [3636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1509),
  [3638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2663),
  [3640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [3642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [3644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1534),
  [3646] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment, 3, .production_id = 19),
  [3648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [3650] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_union_pattern_repeat1, 2),
  [3652] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_decorated_definition_repeat1, 2),
  [3654] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decorated_definition_repeat1, 2), SHIFT_REPEAT(585),
  [3657] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_union_pattern_repeat1, 2), SHIFT_REPEAT(1578),
  [3660] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_for_in_clause_repeat1, 2), SHIFT_REPEAT(403),
  [3663] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 5, .production_id = 74),
  [3665] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 5, .production_id = 74),
  [3667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 3, .production_id = 26),
  [3669] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 3, .production_id = 26),
  [3671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [3673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [3675] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 5, .production_id = 75),
  [3677] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 5, .production_id = 75),
  [3679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 5, .production_id = 76),
  [3681] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 5, .production_id = 76),
  [3683] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raise_statement, 4, .production_id = 36),
  [3685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [3687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2588),
  [3689] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_for_in_clause_repeat1, 2), SHIFT_REPEAT(408),
  [3692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [3694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2608),
  [3696] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_union_pattern_repeat1, 2), SHIFT_REPEAT(1572),
  [3699] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_list, 3, .production_id = 13),
  [3701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [3703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1572),
  [3705] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_splat_pattern, 2),
  [3707] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_list, 1, .production_id = 4),
  [3709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2056),
  [3711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2742),
  [3713] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_pattern, 6),
  [3715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1510),
  [3717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [3719] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_pattern, 4),
  [3721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(224),
  [3723] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_format_specifier, 1),
  [3725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2108),
  [3727] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_within_for_in_clause, 3, .production_id = 17),
  [3729] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_pattern, 5),
  [3731] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dict_pattern, 5, .production_id = 122),
  [3733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dict_pattern, 5, .production_id = 120),
  [3735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1536),
  [3737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1574),
  [3739] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_pattern, 5),
  [3741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [3743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tuple_pattern, 5),
  [3745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2030),
  [3747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2226),
  [3749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1991),
  [3751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2302),
  [3753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2225),
  [3755] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_format_specifier_repeat1, 2), SHIFT_REPEAT(224),
  [3758] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_format_specifier_repeat1, 2),
  [3760] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_format_specifier_repeat1, 2), SHIFT_REPEAT(2049),
  [3763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [3765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1556),
  [3767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2185),
  [3769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1577),
  [3771] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameter_repeat1, 2),
  [3773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_list, 2, .production_id = 4),
  [3775] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_pattern, 4),
  [3777] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dict_pattern, 4, .production_id = 122),
  [3779] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_union_pattern_repeat1, 2), SHIFT_REPEAT(1574),
  [3782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1551),
  [3784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2217),
  [3786] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_within_for_in_clause, 4, .production_id = 47),
  [3788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2253),
  [3790] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dict_pattern, 4),
  [3792] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_assert_statement_repeat1, 2), SHIFT_REPEAT(564),
  [3795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tuple_pattern, 2),
  [3797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [3799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_pattern, 2),
  [3801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2658),
  [3803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [3805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [3807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias_statement, 4, .dynamic_precedence = 1),
  [3809] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dict_pattern, 2),
  [3811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [3813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1563),
  [3815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2119),
  [3817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [3819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [3821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [3823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [3825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [3827] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dict_pattern, 4, .production_id = 120),
  [3829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [3831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [3833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [3835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dict_pattern, 4, .production_id = 111),
  [3837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [3839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [3841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2135),
  [3843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2340),
  [3845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2403),
  [3847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_complex_pattern, 4),
  [3849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [3851] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_union_pattern_repeat1, 2), SHIFT_REPEAT(1577),
  [3854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [3856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1508),
  [3858] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tuple_pattern, 4),
  [3860] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_format_specifier, 2),
  [3862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2049),
  [3864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [3866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [3868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [3870] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_pattern, 3),
  [3872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [3874] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tuple_pattern, 3),
  [3876] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_complex_pattern, 3),
  [3878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [3880] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dict_pattern, 3),
  [3882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [3884] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dict_pattern, 3, .production_id = 111),
  [3886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [3888] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_pattern, 3),
  [3890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1545),
  [3892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1567),
  [3894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2255),
  [3896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2229),
  [3898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1538),
  [3900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2703),
  [3902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1547),
  [3904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [3906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [3908] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 1),
  [3910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [3912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [3914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2418),
  [3916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2394),
  [3918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1859),
  [3920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1668),
  [3922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1524),
  [3924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2719),
  [3926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2249),
  [3928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2246),
  [3930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1525),
  [3932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2057),
  [3934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1537),
  [3936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [3938] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_statement, 2),
  [3940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2733),
  [3942] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_case_clause_repeat1, 2),
  [3944] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__as_pattern, 3),
  [3946] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_clause_repeat1, 2), SHIFT_REPEAT(1550),
  [3949] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nonlocal_statement, 3),
  [3951] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nonlocal_statement, 2),
  [3953] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_statement, 3),
  [3955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [3957] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assert_statement, 3),
  [3959] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 3, .dynamic_precedence = -1, .production_id = 15),
  [3961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [3963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 3, .production_id = 14),
  [3965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [3967] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_dict_pattern_repeat1, 2),
  [3969] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exec_statement, 5, .production_id = 8),
  [3971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1511),
  [3973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2124),
  [3975] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_import_prefix_repeat1, 2),
  [3977] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_import_prefix_repeat1, 2), SHIFT_REPEAT(2190),
  [3980] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_global_statement_repeat1, 2),
  [3982] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_global_statement_repeat1, 2), SHIFT_REPEAT(2733),
  [3985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2116),
  [3987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1539),
  [3989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2224),
  [3991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1531),
  [3993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1530),
  [3995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2220),
  [3997] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_list, 2, .production_id = 13),
  [3999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2013),
  [4001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2144),
  [4003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1513),
  [4005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2015),
  [4007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [4009] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__match_block_repeat1, 2, .production_id = 81), SHIFT_REPEAT(1547),
  [4012] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__match_block_repeat1, 2, .production_id = 81),
  [4014] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 2),
  [4016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [4018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1521),
  [4020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2188),
  [4022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2142),
  [4024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1542),
  [4026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2165),
  [4028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1526),
  [4030] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator, 3),
  [4032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1968),
  [4034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2388),
  [4036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [4038] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_print_statement_repeat1, 2, .production_id = 35),
  [4040] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_print_statement_repeat1, 2, .production_id = 35), SHIFT_REPEAT(501),
  [4043] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_prefix, 1),
  [4045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2190),
  [4047] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__import_list_repeat1, 2, .production_id = 27),
  [4049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__import_list_repeat1, 2, .production_id = 28),
  [4051] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__import_list_repeat1, 2, .production_id = 28), SHIFT_REPEAT(2413),
  [4054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2203),
  [4056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2763),
  [4058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [4060] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__patterns, 1),
  [4062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [4064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [4066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [4068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [4070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [4072] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__patterns_repeat1, 2), SHIFT_REPEAT(848),
  [4075] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_assert_statement_repeat1, 2), SHIFT_REPEAT(487),
  [4078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [4080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [4082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [4084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [4086] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_relative_import, 1),
  [4088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [4090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2547),
  [4092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2548),
  [4094] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__collection_elements_repeat1, 2), SHIFT_REPEAT(350),
  [4097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1515),
  [4099] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_aliased_import, 3, .production_id = 29),
  [4101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [4103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [4105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [4107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [4109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2227),
  [4111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [4113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [4115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameters, 1),
  [4117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1673),
  [4119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1332),
  [4121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [4123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2136),
  [4125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2138),
  [4127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [4129] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__collection_elements_repeat1, 2), SHIFT_REPEAT(362),
  [4132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [4134] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dict_pattern_repeat1, 2, .production_id = 121), SHIFT_REPEAT(1571),
  [4137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_dict_pattern_repeat1, 2, .production_id = 121),
  [4139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [4141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [4143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1950),
  [4145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [4147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1045),
  [4149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [4151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1090),
  [4153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1532),
  [4155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [4157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2084),
  [4159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [4161] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_statement_repeat1, 2, .production_id = 40), SHIFT_REPEAT(512),
  [4164] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_match_statement_repeat1, 2, .production_id = 40),
  [4166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [4168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1552),
  [4170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2166),
  [4172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1568),
  [4174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2170),
  [4176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [4178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [4180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [4182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1523),
  [4184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1133),
  [4186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [4188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1520),
  [4190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [4192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1570),
  [4194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2186),
  [4196] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__key_value_pattern, 3, .production_id = 45),
  [4198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2627),
  [4200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [4202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1670),
  [4204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1518),
  [4206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1516),
  [4208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [4210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1553),
  [4212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2149),
  [4214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [4216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1555),
  [4218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2145),
  [4220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [4222] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__patterns_repeat1, 2), SHIFT_REPEAT(844),
  [4225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1565),
  [4227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2218),
  [4229] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_with_clause_repeat1, 2), SHIFT_REPEAT(457),
  [4232] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_with_clause_repeat1, 2),
  [4234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1535),
  [4236] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__collection_elements_repeat1, 2), SHIFT_REPEAT(349),
  [4239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1561),
  [4241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2058),
  [4243] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_assert_statement_repeat1, 2), SHIFT_REPEAT(522),
  [4246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1566),
  [4248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2088),
  [4250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1519),
  [4252] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__import_list_repeat1, 2, .production_id = 28), SHIFT_REPEAT(2448),
  [4255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [4257] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dictionary_repeat1, 2), SHIFT_REPEAT(375),
  [4260] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_dictionary_repeat1, 2),
  [4262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [4264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [4266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [4268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1495),
  [4270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [4272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1494),
  [4274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1541),
  [4276] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__parameters_repeat1, 2), SHIFT_REPEAT(1675),
  [4279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__parameters_repeat1, 2),
  [4281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [4283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [4285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1971),
  [4287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [4289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [4291] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 1),
  [4293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [4295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1450),
  [4297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [4299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1449),
  [4301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [4303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(618),
  [4305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [4307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(630),
  [4309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [4311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2132),
  [4313] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_format_specifier_repeat1, 1, .production_id = 51),
  [4315] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_format_specifier_repeat1, 1, .production_id = 51),
  [4317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [4319] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exec_statement, 2, .production_id = 8),
  [4321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [4323] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__simple_statements_repeat1, 2), SHIFT_REPEAT(153),
  [4326] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__simple_statements_repeat1, 2),
  [4328] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_with_clause_repeat1, 2), SHIFT_REPEAT(463),
  [4331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [4333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [4335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1428),
  [4337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [4339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1426),
  [4341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [4343] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__parameters_repeat1, 2), SHIFT_REPEAT(1674),
  [4346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [4348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [4350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1987),
  [4352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1454),
  [4354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [4356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1398),
  [4358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [4360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2460),
  [4362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1669),
  [4364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [4366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1244),
  [4368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [4370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1245),
  [4372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1554),
  [4374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2121),
  [4376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [4378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [4380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2425),
  [4382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [4384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [4386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1415),
  [4388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [4390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1417),
  [4392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2009),
  [4394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [4396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [4398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1546),
  [4400] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_clause_repeat1, 2), SHIFT_REPEAT(1548),
  [4403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [4405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [4407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1569),
  [4409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2254),
  [4411] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subscript_repeat1, 2, .production_id = 73), SHIFT_REPEAT(424),
  [4414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_subscript_repeat1, 2, .production_id = 73),
  [4416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [4418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [4420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [4422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1517),
  [4424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [4426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1512),
  [4428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1671),
  [4430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1564),
  [4432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2232),
  [4434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1562),
  [4436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2230),
  [4438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1396),
  [4440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [4442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1514),
  [4444] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_parameter_repeat1, 2), SHIFT_REPEAT(257),
  [4447] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__patterns_repeat1, 2), SHIFT_REPEAT(847),
  [4450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [4452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [4454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [4456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1275),
  [4458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [4460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1271),
  [4462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [4464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [4466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [4468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [4470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [4472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [4474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [4476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1373),
  [4478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [4480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [4482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [4484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [4486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2373),
  [4488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [4490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [4492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [4494] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(331),
  [4497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [4499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2287),
  [4501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [4503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1015),
  [4505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [4507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [4509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1017),
  [4511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [4513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2557),
  [4515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1265),
  [4517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [4519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [4521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2516),
  [4523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2601),
  [4525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2560),
  [4527] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_clause_repeat1, 2), SHIFT_REPEAT(1549),
  [4530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2710),
  [4532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [4534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [4536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [4538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [4540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [4542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1336),
  [4544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [4546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1330),
  [4548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1166),
  [4550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [4552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [4554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [4556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2285),
  [4558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [4560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1907),
  [4562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [4564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [4566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [4568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [4570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2550),
  [4572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [4574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [4576] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_assert_statement_repeat1, 2), SHIFT_REPEAT(492),
  [4579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_list_splat, 3, .production_id = 33),
  [4581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2194),
  [4583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2194),
  [4585] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_from_statement, 4, .production_id = 31),
  [4587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment, 5, .production_id = 69),
  [4589] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pass_statement, 1),
  [4591] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 1),
  [4593] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 1),
  [4595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_wildcard_import, 1),
  [4597] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_future_import_statement, 4, .production_id = 30),
  [4599] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause, 8, .production_id = 139),
  [4601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause, 7, .production_id = 138),
  [4603] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 2, .production_id = 3),
  [4605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause, 7, .production_id = 137),
  [4607] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause, 7, .production_id = 136),
  [4609] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause, 6, .production_id = 134),
  [4611] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause, 6, .production_id = 133),
  [4613] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause, 6, .production_id = 132),
  [4615] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_list_splat, 3),
  [4617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [4619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [4621] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause, 5, .production_id = 125),
  [4623] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause, 5, .production_id = 124),
  [4625] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause, 5, .production_id = 123),
  [4627] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, .production_id = 33),
  [4629] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause, 6, .production_id = 131),
  [4631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [4633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [4635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [4637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [4639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2201),
  [4641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2182),
  [4643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2182),
  [4645] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_future_import_statement, 6, .production_id = 77),
  [4647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_from_statement, 6, .production_id = 78),
  [4649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1954),
  [4651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1954),
  [4653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_dict_pattern_repeat1, 2, .production_id = 111),
  [4655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2183),
  [4657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2183),
  [4659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [4661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [4663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2072),
  [4665] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause, 4, .production_id = 112),
  [4667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [4669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [4671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2152),
  [4673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2152),
  [4675] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 3),
  [4677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [4679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [4681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [4683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [4685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [4687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2215),
  [4689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2215),
  [4691] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 2),
  [4693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [4695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [4697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1906),
  [4699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1906),
  [4701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2193),
  [4703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2096),
  [4705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2096),
  [4707] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_from_statement, 4, .production_id = 32),
  [4709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1889),
  [4711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1889),
  [4713] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_positional_separator, 1),
  [4715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_augmented_assignment, 3, .production_id = 21),
  [4717] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment, 3, .production_id = 20),
  [4719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2117),
  [4721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2117),
  [4723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2234),
  [4725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2234),
  [4727] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__match_block_repeat1, 1, .production_id = 54),
  [4729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2020),
  [4731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2008),
  [4733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2008),
  [4735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1254),
  [4737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [4739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1067),
  [4741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2439),
  [4743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_parameters, 1),
  [4745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [4747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [4749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [4751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2467),
  [4753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1465),
  [4755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1464),
  [4757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2569),
  [4759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [4761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1462),
  [4763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [4765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1121),
  [4767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2568),
  [4769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1405),
  [4771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [4773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1460),
  [4775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1459),
  [4777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1994),
  [4779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1457),
  [4781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1456),
  [4783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1138),
  [4785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1136),
  [4787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1993),
  [4789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2462),
  [4791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1386),
  [4793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2465),
  [4795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2173),
  [4797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1123),
  [4799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1395),
  [4801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [4803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2071),
  [4805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1661),
  [4807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1377),
  [4809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1986),
  [4811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1391),
  [4813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2162),
  [4815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [4817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1375),
  [4819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1973),
  [4821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2107),
  [4823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [4825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [4827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1384),
  [4829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1443),
  [4831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [4833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1288),
  [4835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 5),
  [4837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1298),
  [4839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [4841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1390),
  [4843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2044),
  [4845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [4847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1492),
  [4849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1980),
  [4851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1392),
  [4853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2028),
  [4855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [4857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [4859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [4861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1643),
  [4863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2435),
  [4865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1198),
  [4867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1252),
  [4869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1920),
  [4871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1642),
  [4873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1344),
  [4875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [4877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2581),
  [4879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1369),
  [4881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1368),
  [4883] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 4),
  [4885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2332),
  [4887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [4889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1366),
  [4891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1365),
  [4893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [4895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [4897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [4899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1243),
  [4901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [4903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1232),
  [4905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [4907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2502),
  [4909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [4911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [4913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1353),
  [4915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [4917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [4919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1351),
  [4921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1362),
  [4923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1348),
  [4925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [4927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2347),
  [4929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [4931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(960),
  [4933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1948),
  [4935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1944),
  [4937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1959),
  [4939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1394),
  [4941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1220),
  [4943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2281),
  [4945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(599),
  [4947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1327),
  [4949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1326),
  [4951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [4953] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_relative_import, 2),
  [4955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2300),
  [4957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1273),
  [4959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1137),
  [4961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1324),
  [4963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [4965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2042),
  [4967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1272),
  [4969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1317),
  [4971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1660),
  [4973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1382),
  [4975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2031),
  [4977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2572),
  [4979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1997),
  [4981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1316),
  [4983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1815),
  [4985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [4987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2005),
  [4989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1886),
  [4991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [4993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1046),
  [4995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(928),
  [4997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2064),
  [4999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [5001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2573),
  [5003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1338),
  [5005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1162),
  [5007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1281),
  [5009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1161),
  [5011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1154),
  [5013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [5015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(593),
  [5017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2115),
  [5019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1159),
  [5021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1155),
  [5023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(953),
  [5025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1283),
  [5027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [5029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2526),
  [5031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2019),
  [5033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1037),
  [5035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [5037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [5039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1047),
  [5041] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [5043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [5045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2086),
  [5047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2169),
  [5049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2159),
  [5051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2139),
  [5053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [5055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1191),
  [5057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1185),
  [5059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2247),
  [5061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2248),
  [5063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [5065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1300),
  [5067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [5069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1169),
  [5071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2540),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token__newline = 0,
  ts_external_token__indent = 1,
  ts_external_token__dedent = 2,
  ts_external_token_string_start = 3,
  ts_external_token__string_content = 4,
  ts_external_token_escape_interpolation = 5,
  ts_external_token_string_end = 6,
  ts_external_token_comment = 7,
  ts_external_token_RBRACK = 8,
  ts_external_token_RPAREN = 9,
  ts_external_token_RBRACE = 10,
  ts_external_token_except = 11,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__newline] = sym__newline,
  [ts_external_token__indent] = sym__indent,
  [ts_external_token__dedent] = sym__dedent,
  [ts_external_token_string_start] = sym_string_start,
  [ts_external_token__string_content] = sym__string_content,
  [ts_external_token_escape_interpolation] = sym_escape_interpolation,
  [ts_external_token_string_end] = sym_string_end,
  [ts_external_token_comment] = sym_comment,
  [ts_external_token_RBRACK] = anon_sym_RBRACK,
  [ts_external_token_RPAREN] = anon_sym_RPAREN,
  [ts_external_token_RBRACE] = anon_sym_RBRACE,
  [ts_external_token_except] = anon_sym_except,
};

static const bool ts_external_scanner_states[20][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__newline] = true,
    [ts_external_token__indent] = true,
    [ts_external_token__dedent] = true,
    [ts_external_token_string_start] = true,
    [ts_external_token__string_content] = true,
    [ts_external_token_escape_interpolation] = true,
    [ts_external_token_string_end] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_RBRACK] = true,
    [ts_external_token_RPAREN] = true,
    [ts_external_token_RBRACE] = true,
    [ts_external_token_except] = true,
  },
  [2] = {
    [ts_external_token_string_start] = true,
    [ts_external_token_comment] = true,
  },
  [3] = {
    [ts_external_token__dedent] = true,
    [ts_external_token_string_start] = true,
    [ts_external_token_comment] = true,
  },
  [4] = {
    [ts_external_token__newline] = true,
    [ts_external_token_string_start] = true,
    [ts_external_token_comment] = true,
  },
  [5] = {
    [ts_external_token__newline] = true,
    [ts_external_token__indent] = true,
    [ts_external_token_string_start] = true,
    [ts_external_token_comment] = true,
  },
  [6] = {
    [ts_external_token_string_start] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_RBRACE] = true,
  },
  [7] = {
    [ts_external_token_string_start] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_RPAREN] = true,
  },
  [8] = {
    [ts_external_token_string_start] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_RBRACK] = true,
  },
  [9] = {
    [ts_external_token__newline] = true,
    [ts_external_token_comment] = true,
  },
  [10] = {
    [ts_external_token__dedent] = true,
    [ts_external_token_string_start] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_except] = true,
  },
  [11] = {
    [ts_external_token_string_start] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_except] = true,
  },
  [12] = {
    [ts_external_token_comment] = true,
    [ts_external_token_RBRACE] = true,
  },
  [13] = {
    [ts_external_token_comment] = true,
    [ts_external_token_RPAREN] = true,
  },
  [14] = {
    [ts_external_token_comment] = true,
  },
  [15] = {
    [ts_external_token_comment] = true,
    [ts_external_token_RBRACK] = true,
  },
  [16] = {
    [ts_external_token__string_content] = true,
    [ts_external_token_escape_interpolation] = true,
    [ts_external_token_string_end] = true,
    [ts_external_token_comment] = true,
  },
  [17] = {
    [ts_external_token_comment] = true,
    [ts_external_token_except] = true,
  },
  [18] = {
    [ts_external_token__dedent] = true,
    [ts_external_token_comment] = true,
  },
  [19] = {
    [ts_external_token__newline] = true,
    [ts_external_token__indent] = true,
    [ts_external_token_comment] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_python_external_scanner_create(void);
void tree_sitter_python_external_scanner_destroy(void *);
bool tree_sitter_python_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_python_external_scanner_serialize(void *, char *);
void tree_sitter_python_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_python(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_python_external_scanner_create,
      tree_sitter_python_external_scanner_destroy,
      tree_sitter_python_external_scanner_scan,
      tree_sitter_python_external_scanner_serialize,
      tree_sitter_python_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
