#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 3457
#define LARGE_STATE_COUNT 515
#define SYMBOL_COUNT 368
#define ALIAS_COUNT 3
#define TOKEN_COUNT 167
#define EXTERNAL_TOKEN_COUNT 17
#define FIELD_COUNT 32
#define MAX_ALIAS_SEQUENCE_LENGTH 12
#define PRODUCTION_ID_COUNT 154

enum ts_symbol_identifiers {
  sym_identifier = 1,
  anon_sym_SEMI = 2,
  anon_sym_import = 3,
  anon_sym_DOT = 4,
  anon_sym_from = 5,
  anon_sym___future__ = 6,
  anon_sym_LPAREN = 7,
  anon_sym_RPAREN = 8,
  anon_sym_COMMA = 9,
  anon_sym_as = 10,
  anon_sym_STAR = 11,
  anon_sym_print = 12,
  anon_sym_GT_GT = 13,
  anon_sym_assert = 14,
  anon_sym_COLON_EQ = 15,
  anon_sym_return = 16,
  anon_sym_del = 17,
  anon_sym_raise = 18,
  anon_sym_pass = 19,
  anon_sym_break = 20,
  anon_sym_continue = 21,
  anon_sym_if = 22,
  anon_sym_COLON = 23,
  anon_sym_elif = 24,
  anon_sym_else = 25,
  anon_sym_match = 26,
  anon_sym_case = 27,
  anon_sym_async = 28,
  anon_sym_for = 29,
  anon_sym_in = 30,
  anon_sym_while = 31,
  anon_sym_try = 32,
  anon_sym_except = 33,
  anon_sym_except_STAR = 34,
  anon_sym_finally = 35,
  anon_sym_with = 36,
  anon_sym_def = 37,
  anon_sym_DASH_GT = 38,
  anon_sym_STAR_STAR = 39,
  anon_sym_global = 40,
  anon_sym_nonlocal = 41,
  anon_sym_exec = 42,
  anon_sym_type = 43,
  anon_sym_EQ = 44,
  anon_sym_class = 45,
  anon_sym_LBRACK = 46,
  anon_sym_RBRACK = 47,
  anon_sym_AT = 48,
  anon_sym_DASH = 49,
  anon_sym__ = 50,
  anon_sym_PIPE = 51,
  anon_sym_LBRACE = 52,
  anon_sym_RBRACE = 53,
  anon_sym_PLUS = 54,
  anon_sym_not = 55,
  anon_sym_and = 56,
  anon_sym_or = 57,
  anon_sym_SLASH = 58,
  anon_sym_PERCENT = 59,
  anon_sym_SLASH_SLASH = 60,
  anon_sym_AMP = 61,
  anon_sym_CARET = 62,
  anon_sym_LT_LT = 63,
  anon_sym_TILDE = 64,
  anon_sym_LT = 65,
  anon_sym_LT_EQ = 66,
  anon_sym_EQ_EQ = 67,
  anon_sym_BANG_EQ = 68,
  anon_sym_GT_EQ = 69,
  anon_sym_GT = 70,
  anon_sym_LT_GT = 71,
  anon_sym_is = 72,
  anon_sym_lambda = 73,
  anon_sym_PLUS_EQ = 74,
  anon_sym_DASH_EQ = 75,
  anon_sym_STAR_EQ = 76,
  anon_sym_SLASH_EQ = 77,
  anon_sym_AT_EQ = 78,
  anon_sym_SLASH_SLASH_EQ = 79,
  anon_sym_PERCENT_EQ = 80,
  anon_sym_STAR_STAR_EQ = 81,
  anon_sym_GT_GT_EQ = 82,
  anon_sym_LT_LT_EQ = 83,
  anon_sym_AMP_EQ = 84,
  anon_sym_CARET_EQ = 85,
  anon_sym_PIPE_EQ = 86,
  anon_sym_yield = 87,
  sym_ellipsis = 88,
  sym_escape_sequence = 89,
  sym__not_escape_sequence = 90,
  aux_sym_format_specifier_token1 = 91,
  sym_type_conversion = 92,
  sym_integer = 93,
  sym_float = 94,
  anon_sym_await = 95,
  sym_true = 96,
  sym_false = 97,
  sym_none = 98,
  sym_comment = 99,
  sym_line_continuation = 100,
  anon_sym_configfile = 101,
  anon_sym_container = 102,
  anon_sym_envvars = 103,
  anon_sym_include = 104,
  anon_sym_pepfile = 105,
  anon_sym_pepschema = 106,
  anon_sym_scattergather = 107,
  anon_sym_version = 108,
  anon_sym_wildcard_constraints = 109,
  anon_sym_workdir = 110,
  anon_sym_onerror = 111,
  anon_sym_onstart = 112,
  anon_sym_onsuccess = 113,
  anon_sym_localrules = 114,
  anon_sym_ruleorder = 115,
  anon_sym_rule = 116,
  anon_sym_checkpoint = 117,
  anon_sym_use = 118,
  anon_sym_exclude = 119,
  sym__rule_import_as_pattern_target = 120,
  anon_sym_benchmark = 121,
  anon_sym_input = 122,
  anon_sym_log = 123,
  anon_sym_output = 124,
  anon_sym_message = 125,
  anon_sym_notebook = 126,
  anon_sym_script = 127,
  anon_sym_shell = 128,
  anon_sym_cache = 129,
  anon_sym_conda = 130,
  anon_sym_cwl = 131,
  anon_sym_default_target = 132,
  anon_sym_envmodules = 133,
  anon_sym_group = 134,
  anon_sym_handover = 135,
  anon_sym_localrule = 136,
  anon_sym_params = 137,
  anon_sym_priority = 138,
  anon_sym_resources = 139,
  anon_sym_retries = 140,
  anon_sym_shadow = 141,
  anon_sym_singularity = 142,
  anon_sym_template_engine = 143,
  anon_sym_threads = 144,
  anon_sym_wrapper = 145,
  anon_sym_run = 146,
  anon_sym_module = 147,
  anon_sym_config = 148,
  anon_sym_meta_wrapper = 149,
  anon_sym_prefix = 150,
  anon_sym_skip_validation = 151,
  anon_sym_snakefile = 152,
  anon_sym_q = 153,
  sym_constraint = 154,
  sym__newline = 155,
  sym__indent = 156,
  sym__dedent = 157,
  sym_string_start = 158,
  sym__string_content = 159,
  sym_escape_interpolation = 160,
  sym_string_end = 161,
  sym__ALLOW_WC_DEF = 162,
  sym__ALLOW_WC_INTERP = 163,
  sym__DISALLOW_WC = 164,
  sym__WILDCARD_DEF_OPEN = 165,
  sym__WILDCARD_INTERP_OPEN = 166,
  sym_module = 167,
  sym__statement = 168,
  sym__simple_statements = 169,
  sym_import_statement = 170,
  sym_import_prefix = 171,
  sym_relative_import = 172,
  sym_future_import_statement = 173,
  sym_import_from_statement = 174,
  sym__import_list = 175,
  sym_aliased_import = 176,
  sym_wildcard_import = 177,
  sym_print_statement = 178,
  sym_chevron = 179,
  sym_assert_statement = 180,
  sym_expression_statement = 181,
  sym_named_expression = 182,
  sym__named_expression_lhs = 183,
  sym_return_statement = 184,
  sym_delete_statement = 185,
  sym_raise_statement = 186,
  sym_pass_statement = 187,
  sym_break_statement = 188,
  sym_continue_statement = 189,
  sym_if_statement = 190,
  sym_elif_clause = 191,
  sym_else_clause = 192,
  sym_match_statement = 193,
  sym__match_block = 194,
  sym_case_clause = 195,
  sym_for_statement = 196,
  sym_while_statement = 197,
  sym_try_statement = 198,
  sym_except_clause = 199,
  sym_except_group_clause = 200,
  sym_finally_clause = 201,
  sym_with_statement = 202,
  sym_with_clause = 203,
  sym_with_item = 204,
  sym_function_definition = 205,
  sym_parameters = 206,
  sym_lambda_parameters = 207,
  sym_list_splat = 208,
  sym_dictionary_splat = 209,
  sym_global_statement = 210,
  sym_nonlocal_statement = 211,
  sym_exec_statement = 212,
  sym_type_alias_statement = 213,
  sym_class_definition = 214,
  sym_type_parameter = 215,
  sym_parenthesized_list_splat = 216,
  sym_argument_list = 217,
  sym_decorated_definition = 218,
  sym_decorator = 219,
  sym_block = 220,
  sym_expression_list = 221,
  sym_dotted_name = 222,
  sym_case_pattern = 223,
  sym__simple_pattern = 224,
  sym__as_pattern = 225,
  sym_union_pattern = 226,
  sym__list_pattern = 227,
  sym__tuple_pattern = 228,
  sym_dict_pattern = 229,
  sym__key_value_pattern = 230,
  sym_keyword_pattern = 231,
  sym_splat_pattern = 232,
  sym_class_pattern = 233,
  sym_complex_pattern = 234,
  sym__parameters = 235,
  sym__patterns = 236,
  sym_parameter = 237,
  sym_pattern = 238,
  sym_tuple_pattern = 239,
  sym_list_pattern = 240,
  sym_default_parameter = 241,
  sym_typed_default_parameter = 242,
  sym_list_splat_pattern = 243,
  sym_dictionary_splat_pattern = 244,
  sym_as_pattern = 245,
  sym__expression_within_for_in_clause = 246,
  sym_expression = 247,
  sym_primary_expression = 248,
  sym_not_operator = 249,
  sym_boolean_operator = 250,
  sym_binary_operator = 251,
  sym_unary_operator = 252,
  sym_comparison_operator = 253,
  sym_lambda = 254,
  sym_lambda_within_for_in_clause = 255,
  sym_assignment = 256,
  sym_augmented_assignment = 257,
  sym_pattern_list = 258,
  sym__right_hand_side = 259,
  sym_yield = 260,
  sym_attribute = 261,
  sym_subscript = 262,
  sym_slice = 263,
  sym_call = 264,
  sym_typed_parameter = 265,
  sym_type = 266,
  sym_splat_type = 267,
  sym_generic_type = 268,
  sym_union_type = 269,
  sym_constrained_type = 270,
  sym_member_type = 271,
  sym_keyword_argument = 272,
  sym_list = 273,
  sym_set = 274,
  sym_tuple = 275,
  sym_dictionary = 276,
  sym_pair = 277,
  sym_list_comprehension = 278,
  sym_dictionary_comprehension = 279,
  sym_set_comprehension = 280,
  sym_generator_expression = 281,
  sym__comprehension_clauses = 282,
  sym_parenthesized_expression = 283,
  sym__collection_elements = 284,
  sym_for_in_clause = 285,
  sym_if_clause = 286,
  sym_conditional_expression = 287,
  sym_concatenated_string = 288,
  sym_string = 289,
  sym_string_content = 290,
  sym_interpolation = 291,
  sym__f_expression = 292,
  sym_format_specifier = 293,
  sym_await = 294,
  sym_positional_separator = 295,
  sym_keyword_separator = 296,
  sym__simple_directive_wc_none = 297,
  sym__simple_directive_block = 298,
  sym_localrules_directive = 299,
  sym_ruleorder_directive = 300,
  sym__compound_directive = 301,
  sym_rule_definition = 302,
  sym_checkpoint_definition = 303,
  sym_rule_import = 304,
  sym_rule_import_list = 305,
  sym_rule_exclude_list = 306,
  sym_rule_inheritance = 307,
  sym__rule_suite = 308,
  sym_rule_body = 309,
  sym__rule_directive_wc_def = 310,
  sym__rule_directive_wc_interp = 311,
  sym__rule_directive_wc_none = 312,
  sym__rule_directive_block = 313,
  sym_module_definition = 314,
  sym_module_body = 315,
  sym__module_directive_wc_none = 316,
  sym___directive_parameters_wc_none = 317,
  sym__directive_parameters_wc_none = 318,
  sym___directive_parameters_wc_def = 319,
  sym__directive_parameters_wc_def = 320,
  sym___directive_parameters_wc_interp = 321,
  sym__directive_parameters_wc_interp = 322,
  sym___directive_parameters_identifiers = 323,
  sym__directive_parameters_identifiers = 324,
  sym___directive_parameters_ruleorder = 325,
  sym__directive_parameters_ruleorder = 326,
  sym__directive_parameter = 327,
  sym__wildcard_definition = 328,
  sym_flag = 329,
  sym__wildcard_interpolation = 330,
  sym_wildcard = 331,
  aux_sym_module_repeat1 = 332,
  aux_sym__simple_statements_repeat1 = 333,
  aux_sym_import_prefix_repeat1 = 334,
  aux_sym__import_list_repeat1 = 335,
  aux_sym_print_statement_repeat1 = 336,
  aux_sym_assert_statement_repeat1 = 337,
  aux_sym_if_statement_repeat1 = 338,
  aux_sym_match_statement_repeat1 = 339,
  aux_sym__match_block_repeat1 = 340,
  aux_sym_case_clause_repeat1 = 341,
  aux_sym_try_statement_repeat1 = 342,
  aux_sym_try_statement_repeat2 = 343,
  aux_sym_with_clause_repeat1 = 344,
  aux_sym_global_statement_repeat1 = 345,
  aux_sym_type_parameter_repeat1 = 346,
  aux_sym_argument_list_repeat1 = 347,
  aux_sym_decorated_definition_repeat1 = 348,
  aux_sym_dotted_name_repeat1 = 349,
  aux_sym_union_pattern_repeat1 = 350,
  aux_sym_dict_pattern_repeat1 = 351,
  aux_sym__parameters_repeat1 = 352,
  aux_sym__patterns_repeat1 = 353,
  aux_sym_comparison_operator_repeat1 = 354,
  aux_sym_subscript_repeat1 = 355,
  aux_sym_dictionary_repeat1 = 356,
  aux_sym__comprehension_clauses_repeat1 = 357,
  aux_sym__collection_elements_repeat1 = 358,
  aux_sym_for_in_clause_repeat1 = 359,
  aux_sym_concatenated_string_repeat1 = 360,
  aux_sym_string_repeat1 = 361,
  aux_sym_string_content_repeat1 = 362,
  aux_sym_format_specifier_repeat1 = 363,
  aux_sym_rule_body_repeat1 = 364,
  aux_sym_module_body_repeat1 = 365,
  aux_sym___directive_parameters_wc_none_repeat1 = 366,
  aux_sym___directive_parameters_ruleorder_repeat1 = 367,
  alias_sym_format_expression = 368,
  anon_alias_sym_isnot = 369,
  anon_alias_sym_notin = 370,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [anon_sym_SEMI] = ";",
  [anon_sym_import] = "import",
  [anon_sym_DOT] = ".",
  [anon_sym_from] = "from",
  [anon_sym___future__] = "__future__",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_COMMA] = ",",
  [anon_sym_as] = "as",
  [anon_sym_STAR] = "*",
  [anon_sym_print] = "print",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_assert] = "assert",
  [anon_sym_COLON_EQ] = ":=",
  [anon_sym_return] = "return",
  [anon_sym_del] = "del",
  [anon_sym_raise] = "raise",
  [anon_sym_pass] = "pass",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_if] = "if",
  [anon_sym_COLON] = ":",
  [anon_sym_elif] = "elif",
  [anon_sym_else] = "else",
  [anon_sym_match] = "match",
  [anon_sym_case] = "case",
  [anon_sym_async] = "async",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [anon_sym_while] = "while",
  [anon_sym_try] = "try",
  [anon_sym_except] = "except",
  [anon_sym_except_STAR] = "except*",
  [anon_sym_finally] = "finally",
  [anon_sym_with] = "with",
  [anon_sym_def] = "def",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_global] = "global",
  [anon_sym_nonlocal] = "nonlocal",
  [anon_sym_exec] = "exec",
  [anon_sym_type] = "type",
  [anon_sym_EQ] = "=",
  [anon_sym_class] = "class",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_AT] = "@",
  [anon_sym_DASH] = "-",
  [anon_sym__] = "_",
  [anon_sym_PIPE] = "|",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_PLUS] = "+",
  [anon_sym_not] = "not",
  [anon_sym_and] = "and",
  [anon_sym_or] = "or",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_SLASH_SLASH] = "//",
  [anon_sym_AMP] = "&",
  [anon_sym_CARET] = "^",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_TILDE] = "~",
  [anon_sym_LT] = "<",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_GT] = ">",
  [anon_sym_LT_GT] = "<>",
  [anon_sym_is] = "is",
  [anon_sym_lambda] = "lambda",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_AT_EQ] = "@=",
  [anon_sym_SLASH_SLASH_EQ] = "//=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_STAR_STAR_EQ] = "**=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_yield] = "yield",
  [sym_ellipsis] = "ellipsis",
  [sym_escape_sequence] = "escape_sequence",
  [sym__not_escape_sequence] = "_not_escape_sequence",
  [aux_sym_format_specifier_token1] = "format_specifier_token1",
  [sym_type_conversion] = "type_conversion",
  [sym_integer] = "integer",
  [sym_float] = "float",
  [anon_sym_await] = "await",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_none] = "none",
  [sym_comment] = "comment",
  [sym_line_continuation] = "line_continuation",
  [anon_sym_configfile] = "configfile",
  [anon_sym_container] = "container",
  [anon_sym_envvars] = "envvars",
  [anon_sym_include] = "include",
  [anon_sym_pepfile] = "pepfile",
  [anon_sym_pepschema] = "pepschema",
  [anon_sym_scattergather] = "scattergather",
  [anon_sym_version] = "version",
  [anon_sym_wildcard_constraints] = "wildcard_constraints",
  [anon_sym_workdir] = "workdir",
  [anon_sym_onerror] = "onerror",
  [anon_sym_onstart] = "onstart",
  [anon_sym_onsuccess] = "onsuccess",
  [anon_sym_localrules] = "localrules",
  [anon_sym_ruleorder] = "ruleorder",
  [anon_sym_rule] = "rule",
  [anon_sym_checkpoint] = "checkpoint",
  [anon_sym_use] = "use",
  [anon_sym_exclude] = "exclude",
  [sym__rule_import_as_pattern_target] = "as_pattern_target",
  [anon_sym_benchmark] = "benchmark",
  [anon_sym_input] = "input",
  [anon_sym_log] = "log",
  [anon_sym_output] = "output",
  [anon_sym_message] = "message",
  [anon_sym_notebook] = "notebook",
  [anon_sym_script] = "script",
  [anon_sym_shell] = "shell",
  [anon_sym_cache] = "cache",
  [anon_sym_conda] = "conda",
  [anon_sym_cwl] = "cwl",
  [anon_sym_default_target] = "default_target",
  [anon_sym_envmodules] = "envmodules",
  [anon_sym_group] = "group",
  [anon_sym_handover] = "handover",
  [anon_sym_localrule] = "localrule",
  [anon_sym_params] = "params",
  [anon_sym_priority] = "priority",
  [anon_sym_resources] = "resources",
  [anon_sym_retries] = "retries",
  [anon_sym_shadow] = "shadow",
  [anon_sym_singularity] = "singularity",
  [anon_sym_template_engine] = "template_engine",
  [anon_sym_threads] = "threads",
  [anon_sym_wrapper] = "wrapper",
  [anon_sym_run] = "run",
  [anon_sym_module] = "module",
  [anon_sym_config] = "config",
  [anon_sym_meta_wrapper] = "meta_wrapper",
  [anon_sym_prefix] = "prefix",
  [anon_sym_skip_validation] = "skip_validation",
  [anon_sym_snakefile] = "snakefile",
  [anon_sym_q] = "q",
  [sym_constraint] = "constraint",
  [sym__newline] = "_newline",
  [sym__indent] = "_indent",
  [sym__dedent] = "_dedent",
  [sym_string_start] = "string_start",
  [sym__string_content] = "_string_content",
  [sym_escape_interpolation] = "escape_interpolation",
  [sym_string_end] = "string_end",
  [sym__ALLOW_WC_DEF] = "_ALLOW_WC_DEF",
  [sym__ALLOW_WC_INTERP] = "_ALLOW_WC_INTERP",
  [sym__DISALLOW_WC] = "_DISALLOW_WC",
  [sym__WILDCARD_DEF_OPEN] = "_WILDCARD_DEF_OPEN",
  [sym__WILDCARD_INTERP_OPEN] = "_WILDCARD_INTERP_OPEN",
  [sym_module] = "module",
  [sym__statement] = "_statement",
  [sym__simple_statements] = "_simple_statements",
  [sym_import_statement] = "import_statement",
  [sym_import_prefix] = "import_prefix",
  [sym_relative_import] = "relative_import",
  [sym_future_import_statement] = "future_import_statement",
  [sym_import_from_statement] = "import_from_statement",
  [sym__import_list] = "_import_list",
  [sym_aliased_import] = "aliased_import",
  [sym_wildcard_import] = "wildcard_import",
  [sym_print_statement] = "print_statement",
  [sym_chevron] = "chevron",
  [sym_assert_statement] = "assert_statement",
  [sym_expression_statement] = "expression_statement",
  [sym_named_expression] = "named_expression",
  [sym__named_expression_lhs] = "_named_expression_lhs",
  [sym_return_statement] = "return_statement",
  [sym_delete_statement] = "delete_statement",
  [sym_raise_statement] = "raise_statement",
  [sym_pass_statement] = "pass_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_if_statement] = "if_statement",
  [sym_elif_clause] = "elif_clause",
  [sym_else_clause] = "else_clause",
  [sym_match_statement] = "match_statement",
  [sym__match_block] = "block",
  [sym_case_clause] = "case_clause",
  [sym_for_statement] = "for_statement",
  [sym_while_statement] = "while_statement",
  [sym_try_statement] = "try_statement",
  [sym_except_clause] = "except_clause",
  [sym_except_group_clause] = "except_group_clause",
  [sym_finally_clause] = "finally_clause",
  [sym_with_statement] = "with_statement",
  [sym_with_clause] = "with_clause",
  [sym_with_item] = "with_item",
  [sym_function_definition] = "function_definition",
  [sym_parameters] = "parameters",
  [sym_lambda_parameters] = "lambda_parameters",
  [sym_list_splat] = "list_splat",
  [sym_dictionary_splat] = "dictionary_splat",
  [sym_global_statement] = "global_statement",
  [sym_nonlocal_statement] = "nonlocal_statement",
  [sym_exec_statement] = "exec_statement",
  [sym_type_alias_statement] = "type_alias_statement",
  [sym_class_definition] = "class_definition",
  [sym_type_parameter] = "type_parameter",
  [sym_parenthesized_list_splat] = "parenthesized_list_splat",
  [sym_argument_list] = "argument_list",
  [sym_decorated_definition] = "decorated_definition",
  [sym_decorator] = "decorator",
  [sym_block] = "block",
  [sym_expression_list] = "expression_list",
  [sym_dotted_name] = "dotted_name",
  [sym_case_pattern] = "case_pattern",
  [sym__simple_pattern] = "_simple_pattern",
  [sym__as_pattern] = "as_pattern",
  [sym_union_pattern] = "union_pattern",
  [sym__list_pattern] = "list_pattern",
  [sym__tuple_pattern] = "tuple_pattern",
  [sym_dict_pattern] = "dict_pattern",
  [sym__key_value_pattern] = "_key_value_pattern",
  [sym_keyword_pattern] = "keyword_pattern",
  [sym_splat_pattern] = "splat_pattern",
  [sym_class_pattern] = "class_pattern",
  [sym_complex_pattern] = "complex_pattern",
  [sym__parameters] = "_parameters",
  [sym__patterns] = "_patterns",
  [sym_parameter] = "parameter",
  [sym_pattern] = "pattern",
  [sym_tuple_pattern] = "tuple_pattern",
  [sym_list_pattern] = "list_pattern",
  [sym_default_parameter] = "default_parameter",
  [sym_typed_default_parameter] = "typed_default_parameter",
  [sym_list_splat_pattern] = "list_splat_pattern",
  [sym_dictionary_splat_pattern] = "dictionary_splat_pattern",
  [sym_as_pattern] = "as_pattern",
  [sym__expression_within_for_in_clause] = "_expression_within_for_in_clause",
  [sym_expression] = "expression",
  [sym_primary_expression] = "primary_expression",
  [sym_not_operator] = "not_operator",
  [sym_boolean_operator] = "boolean_operator",
  [sym_binary_operator] = "binary_operator",
  [sym_unary_operator] = "unary_operator",
  [sym_comparison_operator] = "comparison_operator",
  [sym_lambda] = "lambda",
  [sym_lambda_within_for_in_clause] = "lambda",
  [sym_assignment] = "assignment",
  [sym_augmented_assignment] = "augmented_assignment",
  [sym_pattern_list] = "pattern_list",
  [sym__right_hand_side] = "_right_hand_side",
  [sym_yield] = "yield",
  [sym_attribute] = "attribute",
  [sym_subscript] = "subscript",
  [sym_slice] = "slice",
  [sym_call] = "call",
  [sym_typed_parameter] = "typed_parameter",
  [sym_type] = "type",
  [sym_splat_type] = "splat_type",
  [sym_generic_type] = "generic_type",
  [sym_union_type] = "union_type",
  [sym_constrained_type] = "constrained_type",
  [sym_member_type] = "member_type",
  [sym_keyword_argument] = "keyword_argument",
  [sym_list] = "list",
  [sym_set] = "set",
  [sym_tuple] = "tuple",
  [sym_dictionary] = "dictionary",
  [sym_pair] = "pair",
  [sym_list_comprehension] = "list_comprehension",
  [sym_dictionary_comprehension] = "dictionary_comprehension",
  [sym_set_comprehension] = "set_comprehension",
  [sym_generator_expression] = "generator_expression",
  [sym__comprehension_clauses] = "_comprehension_clauses",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym__collection_elements] = "_collection_elements",
  [sym_for_in_clause] = "for_in_clause",
  [sym_if_clause] = "if_clause",
  [sym_conditional_expression] = "conditional_expression",
  [sym_concatenated_string] = "concatenated_string",
  [sym_string] = "string",
  [sym_string_content] = "string_content",
  [sym_interpolation] = "interpolation",
  [sym__f_expression] = "_f_expression",
  [sym_format_specifier] = "format_specifier",
  [sym_await] = "await",
  [sym_positional_separator] = "positional_separator",
  [sym_keyword_separator] = "keyword_separator",
  [sym__simple_directive_wc_none] = "directive",
  [sym__simple_directive_block] = "directive",
  [sym_localrules_directive] = "directive",
  [sym_ruleorder_directive] = "directive",
  [sym__compound_directive] = "_compound_directive",
  [sym_rule_definition] = "rule_definition",
  [sym_checkpoint_definition] = "checkpoint_definition",
  [sym_rule_import] = "rule_import",
  [sym_rule_import_list] = "rule_import_list",
  [sym_rule_exclude_list] = "rule_exclude_list",
  [sym_rule_inheritance] = "rule_inheritance",
  [sym__rule_suite] = "_rule_suite",
  [sym_rule_body] = "rule_body",
  [sym__rule_directive_wc_def] = "directive",
  [sym__rule_directive_wc_interp] = "directive",
  [sym__rule_directive_wc_none] = "directive",
  [sym__rule_directive_block] = "directive",
  [sym_module_definition] = "module_definition",
  [sym_module_body] = "module_body",
  [sym__module_directive_wc_none] = "directive",
  [sym___directive_parameters_wc_none] = "directive_parameters",
  [sym__directive_parameters_wc_none] = "_directive_parameters_wc_none",
  [sym___directive_parameters_wc_def] = "directive_parameters",
  [sym__directive_parameters_wc_def] = "_directive_parameters_wc_def",
  [sym___directive_parameters_wc_interp] = "directive_parameters",
  [sym__directive_parameters_wc_interp] = "_directive_parameters_wc_interp",
  [sym___directive_parameters_identifiers] = "directive_parameters",
  [sym__directive_parameters_identifiers] = "_directive_parameters_identifiers",
  [sym___directive_parameters_ruleorder] = "directive_parameters",
  [sym__directive_parameters_ruleorder] = "_directive_parameters_ruleorder",
  [sym__directive_parameter] = "_directive_parameter",
  [sym__wildcard_definition] = "_wildcard_definition",
  [sym_flag] = "flag",
  [sym__wildcard_interpolation] = "_wildcard_interpolation",
  [sym_wildcard] = "wildcard",
  [aux_sym_module_repeat1] = "module_repeat1",
  [aux_sym__simple_statements_repeat1] = "_simple_statements_repeat1",
  [aux_sym_import_prefix_repeat1] = "import_prefix_repeat1",
  [aux_sym__import_list_repeat1] = "_import_list_repeat1",
  [aux_sym_print_statement_repeat1] = "print_statement_repeat1",
  [aux_sym_assert_statement_repeat1] = "assert_statement_repeat1",
  [aux_sym_if_statement_repeat1] = "if_statement_repeat1",
  [aux_sym_match_statement_repeat1] = "match_statement_repeat1",
  [aux_sym__match_block_repeat1] = "_match_block_repeat1",
  [aux_sym_case_clause_repeat1] = "case_clause_repeat1",
  [aux_sym_try_statement_repeat1] = "try_statement_repeat1",
  [aux_sym_try_statement_repeat2] = "try_statement_repeat2",
  [aux_sym_with_clause_repeat1] = "with_clause_repeat1",
  [aux_sym_global_statement_repeat1] = "global_statement_repeat1",
  [aux_sym_type_parameter_repeat1] = "type_parameter_repeat1",
  [aux_sym_argument_list_repeat1] = "argument_list_repeat1",
  [aux_sym_decorated_definition_repeat1] = "decorated_definition_repeat1",
  [aux_sym_dotted_name_repeat1] = "dotted_name_repeat1",
  [aux_sym_union_pattern_repeat1] = "union_pattern_repeat1",
  [aux_sym_dict_pattern_repeat1] = "dict_pattern_repeat1",
  [aux_sym__parameters_repeat1] = "_parameters_repeat1",
  [aux_sym__patterns_repeat1] = "_patterns_repeat1",
  [aux_sym_comparison_operator_repeat1] = "comparison_operator_repeat1",
  [aux_sym_subscript_repeat1] = "subscript_repeat1",
  [aux_sym_dictionary_repeat1] = "dictionary_repeat1",
  [aux_sym__comprehension_clauses_repeat1] = "_comprehension_clauses_repeat1",
  [aux_sym__collection_elements_repeat1] = "_collection_elements_repeat1",
  [aux_sym_for_in_clause_repeat1] = "for_in_clause_repeat1",
  [aux_sym_concatenated_string_repeat1] = "concatenated_string_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_string_content_repeat1] = "string_content_repeat1",
  [aux_sym_format_specifier_repeat1] = "format_specifier_repeat1",
  [aux_sym_rule_body_repeat1] = "rule_body_repeat1",
  [aux_sym_module_body_repeat1] = "module_body_repeat1",
  [aux_sym___directive_parameters_wc_none_repeat1] = "__directive_parameters_wc_none_repeat1",
  [aux_sym___directive_parameters_ruleorder_repeat1] = "__directive_parameters_ruleorder_repeat1",
  [alias_sym_format_expression] = "format_expression",
  [anon_alias_sym_isnot] = "is not",
  [anon_alias_sym_notin] = "not in",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_from] = anon_sym_from,
  [anon_sym___future__] = anon_sym___future__,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_print] = anon_sym_print,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_assert] = anon_sym_assert,
  [anon_sym_COLON_EQ] = anon_sym_COLON_EQ,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_del] = anon_sym_del,
  [anon_sym_raise] = anon_sym_raise,
  [anon_sym_pass] = anon_sym_pass,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_elif] = anon_sym_elif,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_match] = anon_sym_match,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_async] = anon_sym_async,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_except] = anon_sym_except,
  [anon_sym_except_STAR] = anon_sym_except_STAR,
  [anon_sym_finally] = anon_sym_finally,
  [anon_sym_with] = anon_sym_with,
  [anon_sym_def] = anon_sym_def,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_STAR_STAR] = anon_sym_STAR_STAR,
  [anon_sym_global] = anon_sym_global,
  [anon_sym_nonlocal] = anon_sym_nonlocal,
  [anon_sym_exec] = anon_sym_exec,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym__] = anon_sym__,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_not] = anon_sym_not,
  [anon_sym_and] = anon_sym_and,
  [anon_sym_or] = anon_sym_or,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_SLASH_SLASH] = anon_sym_SLASH_SLASH,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_LT_GT] = anon_sym_LT_GT,
  [anon_sym_is] = anon_sym_is,
  [anon_sym_lambda] = anon_sym_lambda,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_AT_EQ] = anon_sym_AT_EQ,
  [anon_sym_SLASH_SLASH_EQ] = anon_sym_SLASH_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_STAR_STAR_EQ] = anon_sym_STAR_STAR_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_yield] = anon_sym_yield,
  [sym_ellipsis] = sym_ellipsis,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym__not_escape_sequence] = sym__not_escape_sequence,
  [aux_sym_format_specifier_token1] = aux_sym_format_specifier_token1,
  [sym_type_conversion] = sym_type_conversion,
  [sym_integer] = sym_integer,
  [sym_float] = sym_float,
  [anon_sym_await] = anon_sym_await,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_none] = sym_none,
  [sym_comment] = sym_comment,
  [sym_line_continuation] = sym_line_continuation,
  [anon_sym_configfile] = anon_sym_configfile,
  [anon_sym_container] = anon_sym_container,
  [anon_sym_envvars] = anon_sym_envvars,
  [anon_sym_include] = anon_sym_include,
  [anon_sym_pepfile] = anon_sym_pepfile,
  [anon_sym_pepschema] = anon_sym_pepschema,
  [anon_sym_scattergather] = anon_sym_scattergather,
  [anon_sym_version] = anon_sym_version,
  [anon_sym_wildcard_constraints] = anon_sym_wildcard_constraints,
  [anon_sym_workdir] = anon_sym_workdir,
  [anon_sym_onerror] = anon_sym_onerror,
  [anon_sym_onstart] = anon_sym_onstart,
  [anon_sym_onsuccess] = anon_sym_onsuccess,
  [anon_sym_localrules] = anon_sym_localrules,
  [anon_sym_ruleorder] = anon_sym_ruleorder,
  [anon_sym_rule] = anon_sym_rule,
  [anon_sym_checkpoint] = anon_sym_checkpoint,
  [anon_sym_use] = anon_sym_use,
  [anon_sym_exclude] = anon_sym_exclude,
  [sym__rule_import_as_pattern_target] = sym__rule_import_as_pattern_target,
  [anon_sym_benchmark] = anon_sym_benchmark,
  [anon_sym_input] = anon_sym_input,
  [anon_sym_log] = anon_sym_log,
  [anon_sym_output] = anon_sym_output,
  [anon_sym_message] = anon_sym_message,
  [anon_sym_notebook] = anon_sym_notebook,
  [anon_sym_script] = anon_sym_script,
  [anon_sym_shell] = anon_sym_shell,
  [anon_sym_cache] = anon_sym_cache,
  [anon_sym_conda] = anon_sym_conda,
  [anon_sym_cwl] = anon_sym_cwl,
  [anon_sym_default_target] = anon_sym_default_target,
  [anon_sym_envmodules] = anon_sym_envmodules,
  [anon_sym_group] = anon_sym_group,
  [anon_sym_handover] = anon_sym_handover,
  [anon_sym_localrule] = anon_sym_localrule,
  [anon_sym_params] = anon_sym_params,
  [anon_sym_priority] = anon_sym_priority,
  [anon_sym_resources] = anon_sym_resources,
  [anon_sym_retries] = anon_sym_retries,
  [anon_sym_shadow] = anon_sym_shadow,
  [anon_sym_singularity] = anon_sym_singularity,
  [anon_sym_template_engine] = anon_sym_template_engine,
  [anon_sym_threads] = anon_sym_threads,
  [anon_sym_wrapper] = anon_sym_wrapper,
  [anon_sym_run] = anon_sym_run,
  [anon_sym_module] = anon_sym_module,
  [anon_sym_config] = anon_sym_config,
  [anon_sym_meta_wrapper] = anon_sym_meta_wrapper,
  [anon_sym_prefix] = anon_sym_prefix,
  [anon_sym_skip_validation] = anon_sym_skip_validation,
  [anon_sym_snakefile] = anon_sym_snakefile,
  [anon_sym_q] = anon_sym_q,
  [sym_constraint] = sym_constraint,
  [sym__newline] = sym__newline,
  [sym__indent] = sym__indent,
  [sym__dedent] = sym__dedent,
  [sym_string_start] = sym_string_start,
  [sym__string_content] = sym__string_content,
  [sym_escape_interpolation] = sym_escape_interpolation,
  [sym_string_end] = sym_string_end,
  [sym__ALLOW_WC_DEF] = sym__ALLOW_WC_DEF,
  [sym__ALLOW_WC_INTERP] = sym__ALLOW_WC_INTERP,
  [sym__DISALLOW_WC] = sym__DISALLOW_WC,
  [sym__WILDCARD_DEF_OPEN] = sym__WILDCARD_DEF_OPEN,
  [sym__WILDCARD_INTERP_OPEN] = sym__WILDCARD_INTERP_OPEN,
  [sym_module] = sym_module,
  [sym__statement] = sym__statement,
  [sym__simple_statements] = sym__simple_statements,
  [sym_import_statement] = sym_import_statement,
  [sym_import_prefix] = sym_import_prefix,
  [sym_relative_import] = sym_relative_import,
  [sym_future_import_statement] = sym_future_import_statement,
  [sym_import_from_statement] = sym_import_from_statement,
  [sym__import_list] = sym__import_list,
  [sym_aliased_import] = sym_aliased_import,
  [sym_wildcard_import] = sym_wildcard_import,
  [sym_print_statement] = sym_print_statement,
  [sym_chevron] = sym_chevron,
  [sym_assert_statement] = sym_assert_statement,
  [sym_expression_statement] = sym_expression_statement,
  [sym_named_expression] = sym_named_expression,
  [sym__named_expression_lhs] = sym__named_expression_lhs,
  [sym_return_statement] = sym_return_statement,
  [sym_delete_statement] = sym_delete_statement,
  [sym_raise_statement] = sym_raise_statement,
  [sym_pass_statement] = sym_pass_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_if_statement] = sym_if_statement,
  [sym_elif_clause] = sym_elif_clause,
  [sym_else_clause] = sym_else_clause,
  [sym_match_statement] = sym_match_statement,
  [sym__match_block] = sym_block,
  [sym_case_clause] = sym_case_clause,
  [sym_for_statement] = sym_for_statement,
  [sym_while_statement] = sym_while_statement,
  [sym_try_statement] = sym_try_statement,
  [sym_except_clause] = sym_except_clause,
  [sym_except_group_clause] = sym_except_group_clause,
  [sym_finally_clause] = sym_finally_clause,
  [sym_with_statement] = sym_with_statement,
  [sym_with_clause] = sym_with_clause,
  [sym_with_item] = sym_with_item,
  [sym_function_definition] = sym_function_definition,
  [sym_parameters] = sym_parameters,
  [sym_lambda_parameters] = sym_lambda_parameters,
  [sym_list_splat] = sym_list_splat,
  [sym_dictionary_splat] = sym_dictionary_splat,
  [sym_global_statement] = sym_global_statement,
  [sym_nonlocal_statement] = sym_nonlocal_statement,
  [sym_exec_statement] = sym_exec_statement,
  [sym_type_alias_statement] = sym_type_alias_statement,
  [sym_class_definition] = sym_class_definition,
  [sym_type_parameter] = sym_type_parameter,
  [sym_parenthesized_list_splat] = sym_parenthesized_list_splat,
  [sym_argument_list] = sym_argument_list,
  [sym_decorated_definition] = sym_decorated_definition,
  [sym_decorator] = sym_decorator,
  [sym_block] = sym_block,
  [sym_expression_list] = sym_expression_list,
  [sym_dotted_name] = sym_dotted_name,
  [sym_case_pattern] = sym_case_pattern,
  [sym__simple_pattern] = sym__simple_pattern,
  [sym__as_pattern] = sym_as_pattern,
  [sym_union_pattern] = sym_union_pattern,
  [sym__list_pattern] = sym_list_pattern,
  [sym__tuple_pattern] = sym_tuple_pattern,
  [sym_dict_pattern] = sym_dict_pattern,
  [sym__key_value_pattern] = sym__key_value_pattern,
  [sym_keyword_pattern] = sym_keyword_pattern,
  [sym_splat_pattern] = sym_splat_pattern,
  [sym_class_pattern] = sym_class_pattern,
  [sym_complex_pattern] = sym_complex_pattern,
  [sym__parameters] = sym__parameters,
  [sym__patterns] = sym__patterns,
  [sym_parameter] = sym_parameter,
  [sym_pattern] = sym_pattern,
  [sym_tuple_pattern] = sym_tuple_pattern,
  [sym_list_pattern] = sym_list_pattern,
  [sym_default_parameter] = sym_default_parameter,
  [sym_typed_default_parameter] = sym_typed_default_parameter,
  [sym_list_splat_pattern] = sym_list_splat_pattern,
  [sym_dictionary_splat_pattern] = sym_dictionary_splat_pattern,
  [sym_as_pattern] = sym_as_pattern,
  [sym__expression_within_for_in_clause] = sym__expression_within_for_in_clause,
  [sym_expression] = sym_expression,
  [sym_primary_expression] = sym_primary_expression,
  [sym_not_operator] = sym_not_operator,
  [sym_boolean_operator] = sym_boolean_operator,
  [sym_binary_operator] = sym_binary_operator,
  [sym_unary_operator] = sym_unary_operator,
  [sym_comparison_operator] = sym_comparison_operator,
  [sym_lambda] = sym_lambda,
  [sym_lambda_within_for_in_clause] = sym_lambda,
  [sym_assignment] = sym_assignment,
  [sym_augmented_assignment] = sym_augmented_assignment,
  [sym_pattern_list] = sym_pattern_list,
  [sym__right_hand_side] = sym__right_hand_side,
  [sym_yield] = sym_yield,
  [sym_attribute] = sym_attribute,
  [sym_subscript] = sym_subscript,
  [sym_slice] = sym_slice,
  [sym_call] = sym_call,
  [sym_typed_parameter] = sym_typed_parameter,
  [sym_type] = sym_type,
  [sym_splat_type] = sym_splat_type,
  [sym_generic_type] = sym_generic_type,
  [sym_union_type] = sym_union_type,
  [sym_constrained_type] = sym_constrained_type,
  [sym_member_type] = sym_member_type,
  [sym_keyword_argument] = sym_keyword_argument,
  [sym_list] = sym_list,
  [sym_set] = sym_set,
  [sym_tuple] = sym_tuple,
  [sym_dictionary] = sym_dictionary,
  [sym_pair] = sym_pair,
  [sym_list_comprehension] = sym_list_comprehension,
  [sym_dictionary_comprehension] = sym_dictionary_comprehension,
  [sym_set_comprehension] = sym_set_comprehension,
  [sym_generator_expression] = sym_generator_expression,
  [sym__comprehension_clauses] = sym__comprehension_clauses,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym__collection_elements] = sym__collection_elements,
  [sym_for_in_clause] = sym_for_in_clause,
  [sym_if_clause] = sym_if_clause,
  [sym_conditional_expression] = sym_conditional_expression,
  [sym_concatenated_string] = sym_concatenated_string,
  [sym_string] = sym_string,
  [sym_string_content] = sym_string_content,
  [sym_interpolation] = sym_interpolation,
  [sym__f_expression] = sym__f_expression,
  [sym_format_specifier] = sym_format_specifier,
  [sym_await] = sym_await,
  [sym_positional_separator] = sym_positional_separator,
  [sym_keyword_separator] = sym_keyword_separator,
  [sym__simple_directive_wc_none] = sym__simple_directive_wc_none,
  [sym__simple_directive_block] = sym__simple_directive_wc_none,
  [sym_localrules_directive] = sym__simple_directive_wc_none,
  [sym_ruleorder_directive] = sym__simple_directive_wc_none,
  [sym__compound_directive] = sym__compound_directive,
  [sym_rule_definition] = sym_rule_definition,
  [sym_checkpoint_definition] = sym_checkpoint_definition,
  [sym_rule_import] = sym_rule_import,
  [sym_rule_import_list] = sym_rule_import_list,
  [sym_rule_exclude_list] = sym_rule_exclude_list,
  [sym_rule_inheritance] = sym_rule_inheritance,
  [sym__rule_suite] = sym__rule_suite,
  [sym_rule_body] = sym_rule_body,
  [sym__rule_directive_wc_def] = sym__simple_directive_wc_none,
  [sym__rule_directive_wc_interp] = sym__simple_directive_wc_none,
  [sym__rule_directive_wc_none] = sym__simple_directive_wc_none,
  [sym__rule_directive_block] = sym__simple_directive_wc_none,
  [sym_module_definition] = sym_module_definition,
  [sym_module_body] = sym_module_body,
  [sym__module_directive_wc_none] = sym__simple_directive_wc_none,
  [sym___directive_parameters_wc_none] = sym___directive_parameters_wc_none,
  [sym__directive_parameters_wc_none] = sym__directive_parameters_wc_none,
  [sym___directive_parameters_wc_def] = sym___directive_parameters_wc_none,
  [sym__directive_parameters_wc_def] = sym__directive_parameters_wc_def,
  [sym___directive_parameters_wc_interp] = sym___directive_parameters_wc_none,
  [sym__directive_parameters_wc_interp] = sym__directive_parameters_wc_interp,
  [sym___directive_parameters_identifiers] = sym___directive_parameters_wc_none,
  [sym__directive_parameters_identifiers] = sym__directive_parameters_identifiers,
  [sym___directive_parameters_ruleorder] = sym___directive_parameters_wc_none,
  [sym__directive_parameters_ruleorder] = sym__directive_parameters_ruleorder,
  [sym__directive_parameter] = sym__directive_parameter,
  [sym__wildcard_definition] = sym__wildcard_definition,
  [sym_flag] = sym_flag,
  [sym__wildcard_interpolation] = sym__wildcard_interpolation,
  [sym_wildcard] = sym_wildcard,
  [aux_sym_module_repeat1] = aux_sym_module_repeat1,
  [aux_sym__simple_statements_repeat1] = aux_sym__simple_statements_repeat1,
  [aux_sym_import_prefix_repeat1] = aux_sym_import_prefix_repeat1,
  [aux_sym__import_list_repeat1] = aux_sym__import_list_repeat1,
  [aux_sym_print_statement_repeat1] = aux_sym_print_statement_repeat1,
  [aux_sym_assert_statement_repeat1] = aux_sym_assert_statement_repeat1,
  [aux_sym_if_statement_repeat1] = aux_sym_if_statement_repeat1,
  [aux_sym_match_statement_repeat1] = aux_sym_match_statement_repeat1,
  [aux_sym__match_block_repeat1] = aux_sym__match_block_repeat1,
  [aux_sym_case_clause_repeat1] = aux_sym_case_clause_repeat1,
  [aux_sym_try_statement_repeat1] = aux_sym_try_statement_repeat1,
  [aux_sym_try_statement_repeat2] = aux_sym_try_statement_repeat2,
  [aux_sym_with_clause_repeat1] = aux_sym_with_clause_repeat1,
  [aux_sym_global_statement_repeat1] = aux_sym_global_statement_repeat1,
  [aux_sym_type_parameter_repeat1] = aux_sym_type_parameter_repeat1,
  [aux_sym_argument_list_repeat1] = aux_sym_argument_list_repeat1,
  [aux_sym_decorated_definition_repeat1] = aux_sym_decorated_definition_repeat1,
  [aux_sym_dotted_name_repeat1] = aux_sym_dotted_name_repeat1,
  [aux_sym_union_pattern_repeat1] = aux_sym_union_pattern_repeat1,
  [aux_sym_dict_pattern_repeat1] = aux_sym_dict_pattern_repeat1,
  [aux_sym__parameters_repeat1] = aux_sym__parameters_repeat1,
  [aux_sym__patterns_repeat1] = aux_sym__patterns_repeat1,
  [aux_sym_comparison_operator_repeat1] = aux_sym_comparison_operator_repeat1,
  [aux_sym_subscript_repeat1] = aux_sym_subscript_repeat1,
  [aux_sym_dictionary_repeat1] = aux_sym_dictionary_repeat1,
  [aux_sym__comprehension_clauses_repeat1] = aux_sym__comprehension_clauses_repeat1,
  [aux_sym__collection_elements_repeat1] = aux_sym__collection_elements_repeat1,
  [aux_sym_for_in_clause_repeat1] = aux_sym_for_in_clause_repeat1,
  [aux_sym_concatenated_string_repeat1] = aux_sym_concatenated_string_repeat1,
  [aux_sym_string_repeat1] = aux_sym_string_repeat1,
  [aux_sym_string_content_repeat1] = aux_sym_string_content_repeat1,
  [aux_sym_format_specifier_repeat1] = aux_sym_format_specifier_repeat1,
  [aux_sym_rule_body_repeat1] = aux_sym_rule_body_repeat1,
  [aux_sym_module_body_repeat1] = aux_sym_module_body_repeat1,
  [aux_sym___directive_parameters_wc_none_repeat1] = aux_sym___directive_parameters_wc_none_repeat1,
  [aux_sym___directive_parameters_ruleorder_repeat1] = aux_sym___directive_parameters_ruleorder_repeat1,
  [alias_sym_format_expression] = alias_sym_format_expression,
  [anon_alias_sym_isnot] = anon_alias_sym_isnot,
  [anon_alias_sym_notin] = anon_alias_sym_notin,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___future__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_print] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_assert] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_del] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_raise] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_pass] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_match] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_except] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_except_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_def] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_global] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nonlocal] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_exec] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_is] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_lambda] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [sym_ellipsis] = {
    .visible = true,
    .named = true,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym__not_escape_sequence] = {
    .visible = false,
    .named = true,
  },
  [aux_sym_format_specifier_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_type_conversion] = {
    .visible = true,
    .named = true,
  },
  [sym_integer] = {
    .visible = true,
    .named = true,
  },
  [sym_float] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = false,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_none] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_line_continuation] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_configfile] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_container] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_envvars] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_include] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_pepfile] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_pepschema] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_scattergather] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_version] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_wildcard_constraints] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_workdir] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_onerror] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_onstart] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_onsuccess] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_localrules] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ruleorder] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_rule] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_checkpoint] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_use] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_exclude] = {
    .visible = true,
    .named = false,
  },
  [sym__rule_import_as_pattern_target] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_benchmark] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_input] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_log] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_output] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_message] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_notebook] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_script] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_shell] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_cache] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_conda] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_cwl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default_target] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_envmodules] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_group] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_handover] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_localrule] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_params] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_priority] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_resources] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_retries] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_shadow] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_singularity] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_template_engine] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_threads] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_wrapper] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_run] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_config] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_meta_wrapper] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_prefix] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_skip_validation] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_snakefile] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_q] = {
    .visible = true,
    .named = false,
  },
  [sym_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym__newline] = {
    .visible = false,
    .named = true,
  },
  [sym__indent] = {
    .visible = false,
    .named = true,
  },
  [sym__dedent] = {
    .visible = false,
    .named = true,
  },
  [sym_string_start] = {
    .visible = true,
    .named = true,
  },
  [sym__string_content] = {
    .visible = false,
    .named = true,
  },
  [sym_escape_interpolation] = {
    .visible = true,
    .named = true,
  },
  [sym_string_end] = {
    .visible = true,
    .named = true,
  },
  [sym__ALLOW_WC_DEF] = {
    .visible = false,
    .named = true,
  },
  [sym__ALLOW_WC_INTERP] = {
    .visible = false,
    .named = true,
  },
  [sym__DISALLOW_WC] = {
    .visible = false,
    .named = true,
  },
  [sym__WILDCARD_DEF_OPEN] = {
    .visible = false,
    .named = true,
  },
  [sym__WILDCARD_INTERP_OPEN] = {
    .visible = false,
    .named = true,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym__statement] = {
    .visible = false,
    .named = true,
  },
  [sym__simple_statements] = {
    .visible = false,
    .named = true,
  },
  [sym_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_import_prefix] = {
    .visible = true,
    .named = true,
  },
  [sym_relative_import] = {
    .visible = true,
    .named = true,
  },
  [sym_future_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_import_from_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__import_list] = {
    .visible = false,
    .named = true,
  },
  [sym_aliased_import] = {
    .visible = true,
    .named = true,
  },
  [sym_wildcard_import] = {
    .visible = true,
    .named = true,
  },
  [sym_print_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_chevron] = {
    .visible = true,
    .named = true,
  },
  [sym_assert_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_named_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__named_expression_lhs] = {
    .visible = false,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_delete_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_raise_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_pass_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_elif_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_match_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__match_block] = {
    .visible = true,
    .named = true,
  },
  [sym_case_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_except_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_except_group_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_with_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_with_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_with_item] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_list_splat] = {
    .visible = true,
    .named = true,
  },
  [sym_dictionary_splat] = {
    .visible = true,
    .named = true,
  },
  [sym_global_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_nonlocal_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_exec_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_type_alias_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_class_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_list_splat] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_decorated_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator] = {
    .visible = true,
    .named = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_list] = {
    .visible = true,
    .named = true,
  },
  [sym_dotted_name] = {
    .visible = true,
    .named = true,
  },
  [sym_case_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__simple_pattern] = {
    .visible = false,
    .named = true,
  },
  [sym__as_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_union_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__list_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__tuple_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_dict_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__key_value_pattern] = {
    .visible = false,
    .named = true,
  },
  [sym_keyword_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_splat_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_class_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_complex_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__parameters] = {
    .visible = false,
    .named = true,
  },
  [sym__patterns] = {
    .visible = false,
    .named = true,
  },
  [sym_parameter] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_pattern] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_tuple_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_list_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_default_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_typed_default_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_list_splat_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_dictionary_splat_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_as_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__expression_within_for_in_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_primary_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_not_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_boolean_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_comparison_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_within_for_in_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_augmented_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_pattern_list] = {
    .visible = true,
    .named = true,
  },
  [sym__right_hand_side] = {
    .visible = false,
    .named = true,
  },
  [sym_yield] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript] = {
    .visible = true,
    .named = true,
  },
  [sym_slice] = {
    .visible = true,
    .named = true,
  },
  [sym_call] = {
    .visible = true,
    .named = true,
  },
  [sym_typed_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_type] = {
    .visible = true,
    .named = true,
  },
  [sym_splat_type] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_union_type] = {
    .visible = true,
    .named = true,
  },
  [sym_constrained_type] = {
    .visible = true,
    .named = true,
  },
  [sym_member_type] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_list] = {
    .visible = true,
    .named = true,
  },
  [sym_set] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple] = {
    .visible = true,
    .named = true,
  },
  [sym_dictionary] = {
    .visible = true,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_list_comprehension] = {
    .visible = true,
    .named = true,
  },
  [sym_dictionary_comprehension] = {
    .visible = true,
    .named = true,
  },
  [sym_set_comprehension] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__comprehension_clauses] = {
    .visible = false,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__collection_elements] = {
    .visible = false,
    .named = true,
  },
  [sym_for_in_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_if_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_concatenated_string] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_string_content] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolation] = {
    .visible = true,
    .named = true,
  },
  [sym__f_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_format_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_await] = {
    .visible = true,
    .named = true,
  },
  [sym_positional_separator] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_separator] = {
    .visible = true,
    .named = true,
  },
  [sym__simple_directive_wc_none] = {
    .visible = true,
    .named = true,
  },
  [sym__simple_directive_block] = {
    .visible = true,
    .named = true,
  },
  [sym_localrules_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_ruleorder_directive] = {
    .visible = true,
    .named = true,
  },
  [sym__compound_directive] = {
    .visible = false,
    .named = true,
  },
  [sym_rule_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_checkpoint_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_rule_import] = {
    .visible = true,
    .named = true,
  },
  [sym_rule_import_list] = {
    .visible = true,
    .named = true,
  },
  [sym_rule_exclude_list] = {
    .visible = true,
    .named = true,
  },
  [sym_rule_inheritance] = {
    .visible = true,
    .named = true,
  },
  [sym__rule_suite] = {
    .visible = false,
    .named = true,
  },
  [sym_rule_body] = {
    .visible = true,
    .named = true,
  },
  [sym__rule_directive_wc_def] = {
    .visible = true,
    .named = true,
  },
  [sym__rule_directive_wc_interp] = {
    .visible = true,
    .named = true,
  },
  [sym__rule_directive_wc_none] = {
    .visible = true,
    .named = true,
  },
  [sym__rule_directive_block] = {
    .visible = true,
    .named = true,
  },
  [sym_module_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_module_body] = {
    .visible = true,
    .named = true,
  },
  [sym__module_directive_wc_none] = {
    .visible = true,
    .named = true,
  },
  [sym___directive_parameters_wc_none] = {
    .visible = true,
    .named = true,
  },
  [sym__directive_parameters_wc_none] = {
    .visible = false,
    .named = true,
  },
  [sym___directive_parameters_wc_def] = {
    .visible = true,
    .named = true,
  },
  [sym__directive_parameters_wc_def] = {
    .visible = false,
    .named = true,
  },
  [sym___directive_parameters_wc_interp] = {
    .visible = true,
    .named = true,
  },
  [sym__directive_parameters_wc_interp] = {
    .visible = false,
    .named = true,
  },
  [sym___directive_parameters_identifiers] = {
    .visible = true,
    .named = true,
  },
  [sym__directive_parameters_identifiers] = {
    .visible = false,
    .named = true,
  },
  [sym___directive_parameters_ruleorder] = {
    .visible = true,
    .named = true,
  },
  [sym__directive_parameters_ruleorder] = {
    .visible = false,
    .named = true,
  },
  [sym__directive_parameter] = {
    .visible = false,
    .named = true,
  },
  [sym__wildcard_definition] = {
    .visible = false,
    .named = true,
  },
  [sym_flag] = {
    .visible = true,
    .named = true,
  },
  [sym__wildcard_interpolation] = {
    .visible = false,
    .named = true,
  },
  [sym_wildcard] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_module_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__simple_statements_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_import_prefix_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__import_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_print_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_assert_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_match_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__match_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_try_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_try_statement_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_with_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_global_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameter_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_decorated_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_dotted_name_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_union_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_dict_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__patterns_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_comparison_operator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_subscript_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_dictionary_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__comprehension_clauses_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__collection_elements_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_for_in_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_concatenated_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_content_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_format_specifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_rule_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_module_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym___directive_parameters_wc_none_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym___directive_parameters_ruleorder_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_format_expression] = {
    .visible = true,
    .named = true,
  },
  [anon_alias_sym_isnot] = {
    .visible = true,
    .named = false,
  },
  [anon_alias_sym_notin] = {
    .visible = true,
    .named = false,
  },
};

enum ts_field_identifiers {
  field_alias = 1,
  field_alternative = 2,
  field_argument = 3,
  field_arguments = 4,
  field_attribute = 5,
  field_body = 6,
  field_cause = 7,
  field_code = 8,
  field_condition = 9,
  field_consequence = 10,
  field_definition = 11,
  field_expression = 12,
  field_format_specifier = 13,
  field_function = 14,
  field_guard = 15,
  field_key = 16,
  field_left = 17,
  field_module_name = 18,
  field_name = 19,
  field_object = 20,
  field_operator = 21,
  field_operators = 22,
  field_parameters = 23,
  field_return_type = 24,
  field_right = 25,
  field_subject = 26,
  field_subscript = 27,
  field_superclasses = 28,
  field_type = 29,
  field_type_conversion = 30,
  field_type_parameters = 31,
  field_value = 32,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_attribute] = "attribute",
  [field_body] = "body",
  [field_cause] = "cause",
  [field_code] = "code",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_definition] = "definition",
  [field_expression] = "expression",
  [field_format_specifier] = "format_specifier",
  [field_function] = "function",
  [field_guard] = "guard",
  [field_key] = "key",
  [field_left] = "left",
  [field_module_name] = "module_name",
  [field_name] = "name",
  [field_object] = "object",
  [field_operator] = "operator",
  [field_operators] = "operators",
  [field_parameters] = "parameters",
  [field_return_type] = "return_type",
  [field_right] = "right",
  [field_subject] = "subject",
  [field_subscript] = "subscript",
  [field_superclasses] = "superclasses",
  [field_type] = "type",
  [field_type_conversion] = "type_conversion",
  [field_type_parameters] = "type_parameters",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [3] = {.index = 0, .length = 2},
  [4] = {.index = 2, .length = 2},
  [5] = {.index = 4, .length = 1},
  [6] = {.index = 5, .length = 1},
  [8] = {.index = 6, .length = 1},
  [9] = {.index = 7, .length = 1},
  [10] = {.index = 8, .length = 1},
  [11] = {.index = 9, .length = 2},
  [12] = {.index = 11, .length = 2},
  [13] = {.index = 13, .length = 1},
  [14] = {.index = 14, .length = 1},
  [15] = {.index = 15, .length = 2},
  [16] = {.index = 17, .length = 1},
  [17] = {.index = 18, .length = 2},
  [18] = {.index = 20, .length = 1},
  [19] = {.index = 21, .length = 1},
  [20] = {.index = 22, .length = 2},
  [21] = {.index = 24, .length = 2},
  [22] = {.index = 26, .length = 2},
  [23] = {.index = 28, .length = 2},
  [24] = {.index = 30, .length = 2},
  [25] = {.index = 32, .length = 3},
  [26] = {.index = 35, .length = 1},
  [27] = {.index = 36, .length = 2},
  [28] = {.index = 38, .length = 1},
  [29] = {.index = 39, .length = 2},
  [30] = {.index = 41, .length = 1},
  [31] = {.index = 42, .length = 1},
  [32] = {.index = 43, .length = 2},
  [33] = {.index = 45, .length = 2},
  [34] = {.index = 47, .length = 1},
  [35] = {.index = 48, .length = 2},
  [36] = {.index = 50, .length = 1},
  [38] = {.index = 51, .length = 1},
  [39] = {.index = 52, .length = 2},
  [40] = {.index = 54, .length = 1},
  [41] = {.index = 55, .length = 2},
  [42] = {.index = 57, .length = 1},
  [43] = {.index = 58, .length = 3},
  [44] = {.index = 61, .length = 2},
  [45] = {.index = 63, .length = 2},
  [46] = {.index = 21, .length = 1},
  [47] = {.index = 65, .length = 1},
  [48] = {.index = 66, .length = 2},
  [49] = {.index = 68, .length = 2},
  [50] = {.index = 70, .length = 1},
  [51] = {.index = 71, .length = 2},
  [52] = {.index = 73, .length = 3},
  [53] = {.index = 66, .length = 2},
  [54] = {.index = 76, .length = 2},
  [55] = {.index = 78, .length = 2},
  [56] = {.index = 78, .length = 2},
  [58] = {.index = 80, .length = 2},
  [59] = {.index = 82, .length = 2},
  [60] = {.index = 84, .length = 1},
  [61] = {.index = 85, .length = 3},
  [62] = {.index = 88, .length = 3},
  [63] = {.index = 91, .length = 3},
  [64] = {.index = 94, .length = 3},
  [65] = {.index = 97, .length = 4},
  [66] = {.index = 101, .length = 1},
  [67] = {.index = 102, .length = 3},
  [68] = {.index = 105, .length = 3},
  [69] = {.index = 108, .length = 2},
  [70] = {.index = 110, .length = 2},
  [71] = {.index = 112, .length = 3},
  [72] = {.index = 115, .length = 3},
  [73] = {.index = 118, .length = 3},
  [74] = {.index = 121, .length = 3},
  [75] = {.index = 26, .length = 2},
  [76] = {.index = 124, .length = 1},
  [77] = {.index = 125, .length = 3},
  [78] = {.index = 128, .length = 1},
  [79] = {.index = 129, .length = 3},
  [80] = {.index = 132, .length = 2},
  [81] = {.index = 134, .length = 2},
  [82] = {.index = 136, .length = 2},
  [83] = {.index = 138, .length = 3},
  [84] = {.index = 141, .length = 1},
  [85] = {.index = 142, .length = 2},
  [86] = {.index = 144, .length = 2},
  [87] = {.index = 146, .length = 4},
  [88] = {.index = 150, .length = 2},
  [89] = {.index = 152, .length = 4},
  [90] = {.index = 156, .length = 4},
  [91] = {.index = 160, .length = 1},
  [92] = {.index = 161, .length = 4},
  [93] = {.index = 165, .length = 2},
  [94] = {.index = 167, .length = 3},
  [95] = {.index = 170, .length = 3},
  [96] = {.index = 173, .length = 4},
  [98] = {.index = 177, .length = 4},
  [99] = {.index = 181, .length = 4},
  [100] = {.index = 185, .length = 4},
  [101] = {.index = 189, .length = 4},
  [102] = {.index = 193, .length = 4},
  [103] = {.index = 197, .length = 3},
  [104] = {.index = 200, .length = 3},
  [105] = {.index = 203, .length = 2},
  [106] = {.index = 205, .length = 3},
  [107] = {.index = 208, .length = 5},
  [108] = {.index = 213, .length = 3},
  [109] = {.index = 216, .length = 4},
  [110] = {.index = 220, .length = 4},
  [111] = {.index = 224, .length = 4},
  [112] = {.index = 228, .length = 4},
  [114] = {.index = 232, .length = 4},
  [115] = {.index = 236, .length = 5},
  [116] = {.index = 241, .length = 5},
  [117] = {.index = 246, .length = 2},
  [118] = {.index = 248, .length = 3},
  [119] = {.index = 251, .length = 2},
  [120] = {.index = 253, .length = 1},
  [121] = {.index = 254, .length = 4},
  [122] = {.index = 258, .length = 4},
  [123] = {.index = 262, .length = 4},
  [124] = {.index = 266, .length = 5},
  [125] = {.index = 271, .length = 5},
  [126] = {.index = 276, .length = 5},
  [127] = {.index = 281, .length = 5},
  [128] = {.index = 286, .length = 3},
  [129] = {.index = 289, .length = 2},
  [130] = {.index = 291, .length = 4},
  [131] = {.index = 295, .length = 4},
  [132] = {.index = 299, .length = 2},
  [133] = {.index = 301, .length = 1},
  [134] = {.index = 302, .length = 2},
  [135] = {.index = 304, .length = 2},
  [136] = {.index = 306, .length = 5},
  [137] = {.index = 311, .length = 5},
  [138] = {.index = 316, .length = 5},
  [140] = {.index = 321, .length = 6},
  [141] = {.index = 327, .length = 2},
  [142] = {.index = 329, .length = 2},
  [143] = {.index = 331, .length = 2},
  [144] = {.index = 333, .length = 3},
  [145] = {.index = 336, .length = 1},
  [146] = {.index = 337, .length = 6},
  [147] = {.index = 343, .length = 3},
  [148] = {.index = 346, .length = 2},
  [149] = {.index = 348, .length = 3},
  [150] = {.index = 351, .length = 2},
  [151] = {.index = 353, .length = 2},
  [152] = {.index = 355, .length = 3},
  [153] = {.index = 358, .length = 3},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_arguments, 0, .inherited = true},
    {field_name, 0, .inherited = true},
  [2] =
    {field_body, 0, .inherited = true},
    {field_name, 0, .inherited = true},
  [4] =
    {field_name, 1, .inherited = true},
  [5] =
    {field_name, 0},
  [6] =
    {field_argument, 1},
  [7] =
    {field_value, 0},
  [8] =
    {field_code, 1},
  [9] =
    {field_argument, 1},
    {field_operator, 0},
  [11] =
    {field_arguments, 1},
    {field_function, 0},
  [13] =
    {field_operators, 1, .inherited = true},
  [14] =
    {field_definition, 1},
  [15] =
    {field_name, 0},
    {field_name, 1, .inherited = true},
  [17] =
    {field_argument, 2, .inherited = true},
  [18] =
    {field_argument, 1},
    {field_argument, 2, .inherited = true},
  [20] =
    {field_cause, 2},
  [21] =
    {field_body, 2},
  [22] =
    {field_arguments, 2},
    {field_name, 0},
  [24] =
    {field_body, 2},
    {field_name, 0},
  [26] =
    {field_name, 0},
    {field_value, 2},
  [28] =
    {field_left, 0},
    {field_type, 2},
  [30] =
    {field_left, 0},
    {field_right, 2},
  [32] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [35] =
    {field_alias, 2},
  [36] =
    {field_attribute, 2},
    {field_object, 0},
  [38] =
    {field_operators, 0},
  [39] =
    {field_operators, 0, .inherited = true},
    {field_operators, 1, .inherited = true},
  [41] =
    {field_expression, 1},
  [42] =
    {field_name, 1},
  [43] =
    {field_name, 0, .inherited = true},
    {field_name, 1, .inherited = true},
  [45] =
    {field_alias, 2},
    {field_name, 0},
  [47] =
    {field_name, 3, .inherited = true},
  [48] =
    {field_module_name, 1},
    {field_name, 3, .inherited = true},
  [50] =
    {field_module_name, 1},
  [51] =
    {field_body, 1},
  [52] =
    {field_argument, 0, .inherited = true},
    {field_argument, 1, .inherited = true},
  [54] =
    {field_cause, 3},
  [55] =
    {field_condition, 1},
    {field_consequence, 3},
  [57] =
    {field_subject, 1},
  [58] =
    {field_alternative, 3, .inherited = true},
    {field_body, 3},
    {field_subject, 1},
  [61] =
    {field_subject, 0, .inherited = true},
    {field_subject, 1, .inherited = true},
  [63] =
    {field_body, 3},
    {field_condition, 1},
  [65] =
    {field_body, 3},
  [66] =
    {field_body, 3},
    {field_name, 1},
  [68] =
    {field_key, 0},
    {field_value, 2},
  [70] =
    {field_type, 2},
  [71] =
    {field_body, 3},
    {field_parameters, 1},
  [73] =
    {field_body, 2},
    {field_body, 3},
    {field_name, 0},
  [76] =
    {field_subscript, 2},
    {field_value, 0},
  [78] =
    {field_operators, 0},
    {field_operators, 1},
  [80] =
    {field_expression, 1},
    {field_type_conversion, 2},
  [82] =
    {field_expression, 1},
    {field_format_specifier, 2},
  [84] =
    {field_alternative, 0},
  [85] =
    {field_alternative, 4},
    {field_condition, 1},
    {field_consequence, 3},
  [88] =
    {field_alternative, 4, .inherited = true},
    {field_condition, 1},
    {field_consequence, 3},
  [91] =
    {field_condition, 1},
    {field_consequence, 3},
    {field_consequence, 4},
  [94] =
    {field_alternative, 4, .inherited = true},
    {field_body, 4},
    {field_subject, 1},
  [97] =
    {field_alternative, 4, .inherited = true},
    {field_body, 4},
    {field_subject, 1},
    {field_subject, 2, .inherited = true},
  [101] =
    {field_body, 4},
  [102] =
    {field_alternative, 4},
    {field_body, 3},
    {field_condition, 1},
  [105] =
    {field_body, 3},
    {field_body, 4},
    {field_condition, 1},
  [108] =
    {field_body, 2},
    {field_body, 3},
  [110] =
    {field_body, 3},
    {field_body, 4},
  [112] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 2},
  [115] =
    {field_body, 3},
    {field_body, 4},
    {field_name, 1},
  [118] =
    {field_body, 4},
    {field_name, 1},
    {field_type_parameters, 2},
  [121] =
    {field_body, 4},
    {field_name, 1},
    {field_superclasses, 2},
  [124] =
    {field_module_name, 4},
  [125] =
    {field_left, 0},
    {field_right, 4},
    {field_type, 2},
  [128] =
    {field_subscript, 1},
  [129] =
    {field_subscript, 2},
    {field_subscript, 3, .inherited = true},
    {field_value, 0},
  [132] =
    {field_subscript, 0, .inherited = true},
    {field_subscript, 1, .inherited = true},
  [134] =
    {field_expression, 1},
    {field_type_conversion, 3},
  [136] =
    {field_expression, 1},
    {field_format_specifier, 3},
  [138] =
    {field_expression, 1},
    {field_format_specifier, 3},
    {field_type_conversion, 2},
  [141] =
    {field_name, 4, .inherited = true},
  [142] =
    {field_module_name, 1},
    {field_name, 4, .inherited = true},
  [144] =
    {field_left, 1},
    {field_right, 3},
  [146] =
    {field_alternative, 4, .inherited = true},
    {field_alternative, 5},
    {field_condition, 1},
    {field_consequence, 3},
  [150] =
    {field_alternative, 0, .inherited = true},
    {field_alternative, 1, .inherited = true},
  [152] =
    {field_alternative, 5},
    {field_condition, 1},
    {field_consequence, 3},
    {field_consequence, 4},
  [156] =
    {field_alternative, 5, .inherited = true},
    {field_condition, 1},
    {field_consequence, 3},
    {field_consequence, 4},
  [160] =
    {field_alternative, 1, .inherited = true},
  [161] =
    {field_alternative, 5, .inherited = true},
    {field_body, 5},
    {field_subject, 1},
    {field_subject, 2, .inherited = true},
  [165] =
    {field_body, 4},
    {field_body, 5},
  [167] =
    {field_body, 5},
    {field_name, 2},
    {field_parameters, 3},
  [170] =
    {field_body, 5},
    {field_left, 1},
    {field_right, 3},
  [173] =
    {field_alternative, 5},
    {field_body, 3},
    {field_body, 4},
    {field_condition, 1},
  [177] =
    {field_body, 4},
    {field_body, 5},
    {field_name, 1},
    {field_parameters, 2},
  [181] =
    {field_body, 5},
    {field_name, 1},
    {field_parameters, 3},
    {field_type_parameters, 2},
  [185] =
    {field_body, 4},
    {field_body, 5},
    {field_name, 1},
    {field_type_parameters, 2},
  [189] =
    {field_body, 5},
    {field_name, 1},
    {field_superclasses, 3},
    {field_type_parameters, 2},
  [193] =
    {field_body, 4},
    {field_body, 5},
    {field_name, 1},
    {field_superclasses, 2},
  [197] =
    {field_name, 0},
    {field_type, 2},
    {field_value, 4},
  [200] =
    {field_expression, 1},
    {field_format_specifier, 4},
    {field_type_conversion, 3},
  [203] =
    {field_left, 2},
    {field_right, 4},
  [205] =
    {field_left, 1},
    {field_right, 3},
    {field_right, 4},
  [208] =
    {field_alternative, 5, .inherited = true},
    {field_alternative, 6},
    {field_condition, 1},
    {field_consequence, 3},
    {field_consequence, 4},
  [213] =
    {field_body, 6},
    {field_left, 2},
    {field_right, 4},
  [216] =
    {field_body, 5},
    {field_body, 6},
    {field_name, 2},
    {field_parameters, 3},
  [220] =
    {field_body, 6},
    {field_name, 2},
    {field_parameters, 4},
    {field_type_parameters, 3},
  [224] =
    {field_alternative, 6},
    {field_body, 5},
    {field_left, 1},
    {field_right, 3},
  [228] =
    {field_body, 5},
    {field_body, 6},
    {field_left, 1},
    {field_right, 3},
  [232] =
    {field_body, 6},
    {field_name, 1},
    {field_parameters, 2},
    {field_return_type, 4},
  [236] =
    {field_body, 5},
    {field_body, 6},
    {field_name, 1},
    {field_parameters, 3},
    {field_type_parameters, 2},
  [241] =
    {field_body, 5},
    {field_body, 6},
    {field_name, 1},
    {field_superclasses, 3},
    {field_type_parameters, 2},
  [246] =
    {field_alias, 6},
    {field_module_name, 4},
  [248] =
    {field_left, 2},
    {field_right, 4},
    {field_right, 5},
  [251] =
    {field_key, 1, .inherited = true},
    {field_value, 1, .inherited = true},
  [253] =
    {field_consequence, 3},
  [254] =
    {field_alternative, 7},
    {field_body, 6},
    {field_left, 2},
    {field_right, 4},
  [258] =
    {field_body, 6},
    {field_body, 7},
    {field_left, 2},
    {field_right, 4},
  [262] =
    {field_body, 7},
    {field_name, 2},
    {field_parameters, 3},
    {field_return_type, 5},
  [266] =
    {field_body, 6},
    {field_body, 7},
    {field_name, 2},
    {field_parameters, 4},
    {field_type_parameters, 3},
  [271] =
    {field_alternative, 7},
    {field_body, 5},
    {field_body, 6},
    {field_left, 1},
    {field_right, 3},
  [276] =
    {field_body, 6},
    {field_body, 7},
    {field_name, 1},
    {field_parameters, 2},
    {field_return_type, 4},
  [281] =
    {field_body, 7},
    {field_name, 1},
    {field_parameters, 3},
    {field_return_type, 5},
    {field_type_parameters, 2},
  [286] =
    {field_alias, 4},
    {field_body, 7},
    {field_name, 2},
  [289] =
    {field_body, 7},
    {field_module_name, 4},
  [291] =
    {field_key, 1, .inherited = true},
    {field_key, 2, .inherited = true},
    {field_value, 1, .inherited = true},
    {field_value, 2, .inherited = true},
  [295] =
    {field_key, 0, .inherited = true},
    {field_key, 1, .inherited = true},
    {field_value, 0, .inherited = true},
    {field_value, 1, .inherited = true},
  [299] =
    {field_key, 2, .inherited = true},
    {field_value, 2, .inherited = true},
  [301] =
    {field_consequence, 4},
  [302] =
    {field_consequence, 3},
    {field_consequence, 4},
  [304] =
    {field_consequence, 4},
    {field_guard, 2},
  [306] =
    {field_alternative, 8},
    {field_body, 6},
    {field_body, 7},
    {field_left, 2},
    {field_right, 4},
  [311] =
    {field_body, 7},
    {field_body, 8},
    {field_name, 2},
    {field_parameters, 3},
    {field_return_type, 5},
  [316] =
    {field_body, 8},
    {field_name, 2},
    {field_parameters, 4},
    {field_return_type, 6},
    {field_type_parameters, 3},
  [321] =
    {field_body, 7},
    {field_body, 8},
    {field_name, 1},
    {field_parameters, 3},
    {field_return_type, 5},
    {field_type_parameters, 2},
  [327] =
    {field_alias, 8},
    {field_module_name, 4},
  [329] =
    {field_consequence, 4},
    {field_consequence, 5},
  [331] =
    {field_consequence, 5},
    {field_guard, 3},
  [333] =
    {field_consequence, 4},
    {field_consequence, 5},
    {field_guard, 2},
  [336] =
    {field_consequence, 5},
  [337] =
    {field_body, 8},
    {field_body, 9},
    {field_name, 2},
    {field_parameters, 4},
    {field_return_type, 6},
    {field_type_parameters, 3},
  [343] =
    {field_alias, 6},
    {field_body, 9},
    {field_module_name, 4},
  [346] =
    {field_body, 9},
    {field_module_name, 4},
  [348] =
    {field_consequence, 5},
    {field_consequence, 6},
    {field_guard, 3},
  [351] =
    {field_consequence, 5},
    {field_consequence, 6},
  [353] =
    {field_consequence, 6},
    {field_guard, 4},
  [355] =
    {field_consequence, 6},
    {field_consequence, 7},
    {field_guard, 4},
  [358] =
    {field_alias, 8},
    {field_body, 11},
    {field_module_name, 4},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = sym_identifier,
  },
  [2] = {
    [0] = sym_list_splat,
  },
  [7] = {
    [1] = sym_identifier,
  },
  [21] = {
    [2] = sym_block,
  },
  [26] = {
    [2] = sym__rule_import_as_pattern_target,
  },
  [37] = {
    [1] = sym_parenthesized_expression,
  },
  [41] = {
    [3] = sym_block,
  },
  [45] = {
    [3] = sym_block,
  },
  [46] = {
    [2] = sym_block,
  },
  [47] = {
    [3] = sym_block,
  },
  [48] = {
    [3] = sym_block,
  },
  [55] = {
    [0] = anon_alias_sym_notin,
    [1] = anon_alias_sym_notin,
  },
  [56] = {
    [0] = anon_alias_sym_isnot,
    [1] = anon_alias_sym_isnot,
  },
  [57] = {
    [0] = alias_sym_format_expression,
  },
  [61] = {
    [3] = sym_block,
  },
  [62] = {
    [3] = sym_block,
  },
  [66] = {
    [4] = sym_block,
  },
  [67] = {
    [3] = sym_block,
  },
  [71] = {
    [4] = sym_block,
  },
  [73] = {
    [4] = sym_block,
  },
  [74] = {
    [4] = sym_block,
  },
  [75] = {
    [0] = sym_identifier,
  },
  [87] = {
    [3] = sym_block,
  },
  [94] = {
    [5] = sym_block,
  },
  [95] = {
    [5] = sym_block,
  },
  [97] = {
    [2] = sym_block,
  },
  [99] = {
    [5] = sym_block,
  },
  [101] = {
    [5] = sym_block,
  },
  [108] = {
    [6] = sym_block,
  },
  [110] = {
    [6] = sym_block,
  },
  [111] = {
    [5] = sym_block,
  },
  [113] = {
    [3] = sym_block,
  },
  [114] = {
    [6] = sym_block,
  },
  [120] = {
    [3] = sym_block,
  },
  [121] = {
    [6] = sym_block,
  },
  [123] = {
    [7] = sym_block,
  },
  [127] = {
    [7] = sym_block,
  },
  [128] = {
    [4] = sym__rule_import_as_pattern_target,
  },
  [133] = {
    [4] = sym_block,
  },
  [135] = {
    [4] = sym_block,
  },
  [138] = {
    [8] = sym_block,
  },
  [139] = {
    [5] = sym_block,
  },
  [143] = {
    [5] = sym_block,
  },
  [145] = {
    [5] = sym_block,
  },
  [151] = {
    [6] = sym_block,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym__simple_statements, 2,
    sym__simple_statements,
    sym_block,
  sym_parenthesized_list_splat, 2,
    sym_parenthesized_list_splat,
    sym_parenthesized_expression,
  sym_list_splat_pattern, 2,
    sym_list_splat_pattern,
    sym_list_splat,
  sym_expression, 2,
    sym_expression,
    sym__rule_import_as_pattern_target,
  sym_interpolation, 2,
    sym_interpolation,
    alias_sym_format_expression,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 5,
  [6] = 6,
  [7] = 7,
  [8] = 8,
  [9] = 9,
  [10] = 10,
  [11] = 9,
  [12] = 12,
  [13] = 13,
  [14] = 14,
  [15] = 4,
  [16] = 16,
  [17] = 7,
  [18] = 16,
  [19] = 19,
  [20] = 10,
  [21] = 21,
  [22] = 8,
  [23] = 23,
  [24] = 24,
  [25] = 25,
  [26] = 13,
  [27] = 27,
  [28] = 28,
  [29] = 29,
  [30] = 30,
  [31] = 31,
  [32] = 32,
  [33] = 33,
  [34] = 21,
  [35] = 35,
  [36] = 36,
  [37] = 37,
  [38] = 24,
  [39] = 39,
  [40] = 40,
  [41] = 41,
  [42] = 2,
  [43] = 3,
  [44] = 44,
  [45] = 25,
  [46] = 28,
  [47] = 33,
  [48] = 48,
  [49] = 5,
  [50] = 50,
  [51] = 32,
  [52] = 41,
  [53] = 35,
  [54] = 39,
  [55] = 36,
  [56] = 50,
  [57] = 37,
  [58] = 27,
  [59] = 31,
  [60] = 60,
  [61] = 6,
  [62] = 48,
  [63] = 23,
  [64] = 44,
  [65] = 65,
  [66] = 65,
  [67] = 67,
  [68] = 68,
  [69] = 65,
  [70] = 65,
  [71] = 65,
  [72] = 65,
  [73] = 65,
  [74] = 65,
  [75] = 65,
  [76] = 67,
  [77] = 77,
  [78] = 77,
  [79] = 79,
  [80] = 80,
  [81] = 81,
  [82] = 82,
  [83] = 79,
  [84] = 80,
  [85] = 81,
  [86] = 82,
  [87] = 87,
  [88] = 87,
  [89] = 89,
  [90] = 89,
  [91] = 91,
  [92] = 92,
  [93] = 93,
  [94] = 94,
  [95] = 95,
  [96] = 96,
  [97] = 97,
  [98] = 98,
  [99] = 99,
  [100] = 100,
  [101] = 101,
  [102] = 102,
  [103] = 103,
  [104] = 97,
  [105] = 105,
  [106] = 106,
  [107] = 107,
  [108] = 108,
  [109] = 106,
  [110] = 110,
  [111] = 111,
  [112] = 112,
  [113] = 113,
  [114] = 101,
  [115] = 115,
  [116] = 116,
  [117] = 117,
  [118] = 105,
  [119] = 119,
  [120] = 98,
  [121] = 94,
  [122] = 122,
  [123] = 92,
  [124] = 124,
  [125] = 125,
  [126] = 93,
  [127] = 91,
  [128] = 119,
  [129] = 129,
  [130] = 130,
  [131] = 99,
  [132] = 108,
  [133] = 124,
  [134] = 110,
  [135] = 96,
  [136] = 102,
  [137] = 100,
  [138] = 95,
  [139] = 103,
  [140] = 117,
  [141] = 115,
  [142] = 112,
  [143] = 111,
  [144] = 144,
  [145] = 145,
  [146] = 144,
  [147] = 144,
  [148] = 145,
  [149] = 144,
  [150] = 144,
  [151] = 145,
  [152] = 144,
  [153] = 144,
  [154] = 145,
  [155] = 145,
  [156] = 145,
  [157] = 145,
  [158] = 144,
  [159] = 145,
  [160] = 145,
  [161] = 144,
  [162] = 162,
  [163] = 163,
  [164] = 163,
  [165] = 165,
  [166] = 166,
  [167] = 163,
  [168] = 166,
  [169] = 165,
  [170] = 170,
  [171] = 165,
  [172] = 172,
  [173] = 173,
  [174] = 172,
  [175] = 173,
  [176] = 176,
  [177] = 177,
  [178] = 178,
  [179] = 166,
  [180] = 165,
  [181] = 166,
  [182] = 177,
  [183] = 183,
  [184] = 166,
  [185] = 176,
  [186] = 170,
  [187] = 166,
  [188] = 166,
  [189] = 178,
  [190] = 183,
  [191] = 178,
  [192] = 165,
  [193] = 163,
  [194] = 194,
  [195] = 183,
  [196] = 166,
  [197] = 170,
  [198] = 170,
  [199] = 165,
  [200] = 178,
  [201] = 170,
  [202] = 163,
  [203] = 203,
  [204] = 204,
  [205] = 205,
  [206] = 206,
  [207] = 207,
  [208] = 166,
  [209] = 209,
  [210] = 170,
  [211] = 211,
  [212] = 183,
  [213] = 209,
  [214] = 183,
  [215] = 170,
  [216] = 216,
  [217] = 217,
  [218] = 207,
  [219] = 219,
  [220] = 170,
  [221] = 216,
  [222] = 222,
  [223] = 219,
  [224] = 217,
  [225] = 206,
  [226] = 226,
  [227] = 227,
  [228] = 228,
  [229] = 194,
  [230] = 230,
  [231] = 165,
  [232] = 230,
  [233] = 170,
  [234] = 165,
  [235] = 235,
  [236] = 236,
  [237] = 237,
  [238] = 238,
  [239] = 238,
  [240] = 240,
  [241] = 241,
  [242] = 242,
  [243] = 235,
  [244] = 244,
  [245] = 245,
  [246] = 246,
  [247] = 247,
  [248] = 237,
  [249] = 238,
  [250] = 240,
  [251] = 241,
  [252] = 252,
  [253] = 241,
  [254] = 247,
  [255] = 237,
  [256] = 238,
  [257] = 240,
  [258] = 247,
  [259] = 259,
  [260] = 260,
  [261] = 261,
  [262] = 246,
  [263] = 240,
  [264] = 237,
  [265] = 241,
  [266] = 247,
  [267] = 259,
  [268] = 252,
  [269] = 242,
  [270] = 237,
  [271] = 238,
  [272] = 240,
  [273] = 241,
  [274] = 247,
  [275] = 237,
  [276] = 238,
  [277] = 240,
  [278] = 241,
  [279] = 247,
  [280] = 244,
  [281] = 281,
  [282] = 282,
  [283] = 283,
  [284] = 261,
  [285] = 245,
  [286] = 283,
  [287] = 282,
  [288] = 281,
  [289] = 236,
  [290] = 260,
  [291] = 291,
  [292] = 292,
  [293] = 293,
  [294] = 294,
  [295] = 294,
  [296] = 296,
  [297] = 297,
  [298] = 292,
  [299] = 291,
  [300] = 300,
  [301] = 301,
  [302] = 302,
  [303] = 301,
  [304] = 304,
  [305] = 305,
  [306] = 302,
  [307] = 307,
  [308] = 308,
  [309] = 304,
  [310] = 310,
  [311] = 308,
  [312] = 296,
  [313] = 313,
  [314] = 314,
  [315] = 297,
  [316] = 300,
  [317] = 314,
  [318] = 307,
  [319] = 293,
  [320] = 313,
  [321] = 310,
  [322] = 305,
  [323] = 323,
  [324] = 324,
  [325] = 325,
  [326] = 325,
  [327] = 327,
  [328] = 328,
  [329] = 323,
  [330] = 324,
  [331] = 331,
  [332] = 327,
  [333] = 331,
  [334] = 328,
  [335] = 335,
  [336] = 336,
  [337] = 337,
  [338] = 338,
  [339] = 339,
  [340] = 340,
  [341] = 341,
  [342] = 342,
  [343] = 343,
  [344] = 222,
  [345] = 345,
  [346] = 346,
  [347] = 347,
  [348] = 348,
  [349] = 227,
  [350] = 350,
  [351] = 351,
  [352] = 352,
  [353] = 353,
  [354] = 354,
  [355] = 355,
  [356] = 356,
  [357] = 357,
  [358] = 358,
  [359] = 359,
  [360] = 360,
  [361] = 361,
  [362] = 362,
  [363] = 363,
  [364] = 364,
  [365] = 365,
  [366] = 366,
  [367] = 367,
  [368] = 368,
  [369] = 369,
  [370] = 370,
  [371] = 371,
  [372] = 228,
  [373] = 373,
  [374] = 373,
  [375] = 370,
  [376] = 371,
  [377] = 369,
  [378] = 368,
  [379] = 366,
  [380] = 367,
  [381] = 205,
  [382] = 382,
  [383] = 383,
  [384] = 384,
  [385] = 385,
  [386] = 364,
  [387] = 387,
  [388] = 361,
  [389] = 389,
  [390] = 359,
  [391] = 391,
  [392] = 392,
  [393] = 365,
  [394] = 351,
  [395] = 395,
  [396] = 396,
  [397] = 363,
  [398] = 343,
  [399] = 362,
  [400] = 342,
  [401] = 203,
  [402] = 341,
  [403] = 360,
  [404] = 340,
  [405] = 405,
  [406] = 406,
  [407] = 382,
  [408] = 408,
  [409] = 383,
  [410] = 391,
  [411] = 211,
  [412] = 396,
  [413] = 356,
  [414] = 335,
  [415] = 353,
  [416] = 347,
  [417] = 346,
  [418] = 345,
  [419] = 419,
  [420] = 420,
  [421] = 421,
  [422] = 422,
  [423] = 420,
  [424] = 405,
  [425] = 339,
  [426] = 338,
  [427] = 336,
  [428] = 428,
  [429] = 337,
  [430] = 430,
  [431] = 431,
  [432] = 428,
  [433] = 433,
  [434] = 385,
  [435] = 435,
  [436] = 392,
  [437] = 437,
  [438] = 438,
  [439] = 439,
  [440] = 430,
  [441] = 395,
  [442] = 408,
  [443] = 431,
  [444] = 435,
  [445] = 387,
  [446] = 419,
  [447] = 447,
  [448] = 421,
  [449] = 438,
  [450] = 422,
  [451] = 451,
  [452] = 447,
  [453] = 453,
  [454] = 454,
  [455] = 433,
  [456] = 456,
  [457] = 204,
  [458] = 456,
  [459] = 453,
  [460] = 460,
  [461] = 460,
  [462] = 462,
  [463] = 463,
  [464] = 464,
  [465] = 462,
  [466] = 464,
  [467] = 467,
  [468] = 348,
  [469] = 350,
  [470] = 467,
  [471] = 352,
  [472] = 472,
  [473] = 354,
  [474] = 355,
  [475] = 472,
  [476] = 476,
  [477] = 357,
  [478] = 358,
  [479] = 406,
  [480] = 437,
  [481] = 439,
  [482] = 482,
  [483] = 454,
  [484] = 476,
  [485] = 463,
  [486] = 482,
  [487] = 487,
  [488] = 389,
  [489] = 489,
  [490] = 384,
  [491] = 491,
  [492] = 492,
  [493] = 493,
  [494] = 494,
  [495] = 495,
  [496] = 496,
  [497] = 497,
  [498] = 498,
  [499] = 499,
  [500] = 500,
  [501] = 499,
  [502] = 496,
  [503] = 226,
  [504] = 500,
  [505] = 498,
  [506] = 495,
  [507] = 497,
  [508] = 494,
  [509] = 487,
  [510] = 489,
  [511] = 491,
  [512] = 493,
  [513] = 451,
  [514] = 492,
  [515] = 515,
  [516] = 516,
  [517] = 515,
  [518] = 518,
  [519] = 519,
  [520] = 519,
  [521] = 518,
  [522] = 515,
  [523] = 519,
  [524] = 518,
  [525] = 515,
  [526] = 526,
  [527] = 519,
  [528] = 515,
  [529] = 519,
  [530] = 518,
  [531] = 526,
  [532] = 519,
  [533] = 533,
  [534] = 518,
  [535] = 519,
  [536] = 515,
  [537] = 537,
  [538] = 515,
  [539] = 518,
  [540] = 515,
  [541] = 519,
  [542] = 518,
  [543] = 515,
  [544] = 519,
  [545] = 518,
  [546] = 519,
  [547] = 518,
  [548] = 519,
  [549] = 549,
  [550] = 550,
  [551] = 551,
  [552] = 552,
  [553] = 549,
  [554] = 554,
  [555] = 555,
  [556] = 555,
  [557] = 557,
  [558] = 555,
  [559] = 559,
  [560] = 559,
  [561] = 557,
  [562] = 557,
  [563] = 555,
  [564] = 557,
  [565] = 565,
  [566] = 565,
  [567] = 567,
  [568] = 568,
  [569] = 569,
  [570] = 570,
  [571] = 571,
  [572] = 572,
  [573] = 573,
  [574] = 574,
  [575] = 550,
  [576] = 576,
  [577] = 577,
  [578] = 578,
  [579] = 579,
  [580] = 569,
  [581] = 567,
  [582] = 571,
  [583] = 583,
  [584] = 571,
  [585] = 569,
  [586] = 571,
  [587] = 552,
  [588] = 588,
  [589] = 589,
  [590] = 576,
  [591] = 576,
  [592] = 592,
  [593] = 593,
  [594] = 578,
  [595] = 571,
  [596] = 571,
  [597] = 576,
  [598] = 579,
  [599] = 578,
  [600] = 600,
  [601] = 579,
  [602] = 602,
  [603] = 603,
  [604] = 578,
  [605] = 605,
  [606] = 606,
  [607] = 571,
  [608] = 606,
  [609] = 567,
  [610] = 571,
  [611] = 571,
  [612] = 602,
  [613] = 579,
  [614] = 614,
  [615] = 568,
  [616] = 616,
  [617] = 617,
  [618] = 618,
  [619] = 619,
  [620] = 620,
  [621] = 621,
  [622] = 622,
  [623] = 619,
  [624] = 617,
  [625] = 625,
  [626] = 626,
  [627] = 627,
  [628] = 628,
  [629] = 629,
  [630] = 630,
  [631] = 631,
  [632] = 632,
  [633] = 618,
  [634] = 621,
  [635] = 628,
  [636] = 636,
  [637] = 637,
  [638] = 617,
  [639] = 639,
  [640] = 640,
  [641] = 641,
  [642] = 617,
  [643] = 643,
  [644] = 622,
  [645] = 630,
  [646] = 646,
  [647] = 628,
  [648] = 648,
  [649] = 619,
  [650] = 621,
  [651] = 618,
  [652] = 626,
  [653] = 621,
  [654] = 619,
  [655] = 655,
  [656] = 617,
  [657] = 628,
  [658] = 628,
  [659] = 659,
  [660] = 626,
  [661] = 648,
  [662] = 622,
  [663] = 617,
  [664] = 664,
  [665] = 621,
  [666] = 666,
  [667] = 619,
  [668] = 628,
  [669] = 669,
  [670] = 629,
  [671] = 671,
  [672] = 669,
  [673] = 641,
  [674] = 629,
  [675] = 618,
  [676] = 622,
  [677] = 641,
  [678] = 622,
  [679] = 646,
  [680] = 669,
  [681] = 618,
  [682] = 630,
  [683] = 646,
  [684] = 626,
  [685] = 671,
  [686] = 617,
  [687] = 626,
  [688] = 622,
  [689] = 637,
  [690] = 628,
  [691] = 621,
  [692] = 619,
  [693] = 621,
  [694] = 621,
  [695] = 619,
  [696] = 621,
  [697] = 619,
  [698] = 637,
  [699] = 626,
  [700] = 619,
  [701] = 618,
  [702] = 622,
  [703] = 618,
  [704] = 622,
  [705] = 618,
  [706] = 706,
  [707] = 617,
  [708] = 618,
  [709] = 709,
  [710] = 628,
  [711] = 628,
  [712] = 617,
  [713] = 671,
  [714] = 648,
  [715] = 622,
  [716] = 716,
  [717] = 717,
  [718] = 718,
  [719] = 719,
  [720] = 720,
  [721] = 721,
  [722] = 722,
  [723] = 722,
  [724] = 718,
  [725] = 716,
  [726] = 721,
  [727] = 719,
  [728] = 728,
  [729] = 194,
  [730] = 718,
  [731] = 728,
  [732] = 732,
  [733] = 733,
  [734] = 720,
  [735] = 722,
  [736] = 716,
  [737] = 721,
  [738] = 719,
  [739] = 720,
  [740] = 605,
  [741] = 741,
  [742] = 742,
  [743] = 741,
  [744] = 741,
  [745] = 742,
  [746] = 742,
  [747] = 742,
  [748] = 742,
  [749] = 742,
  [750] = 741,
  [751] = 742,
  [752] = 752,
  [753] = 741,
  [754] = 742,
  [755] = 605,
  [756] = 741,
  [757] = 741,
  [758] = 741,
  [759] = 752,
  [760] = 605,
  [761] = 742,
  [762] = 741,
  [763] = 752,
  [764] = 764,
  [765] = 765,
  [766] = 766,
  [767] = 767,
  [768] = 768,
  [769] = 768,
  [770] = 766,
  [771] = 768,
  [772] = 767,
  [773] = 766,
  [774] = 768,
  [775] = 766,
  [776] = 165,
  [777] = 766,
  [778] = 778,
  [779] = 732,
  [780] = 767,
  [781] = 781,
  [782] = 767,
  [783] = 766,
  [784] = 733,
  [785] = 768,
  [786] = 767,
  [787] = 767,
  [788] = 766,
  [789] = 767,
  [790] = 768,
  [791] = 766,
  [792] = 768,
  [793] = 766,
  [794] = 766,
  [795] = 767,
  [796] = 768,
  [797] = 767,
  [798] = 798,
  [799] = 768,
  [800] = 768,
  [801] = 801,
  [802] = 768,
  [803] = 766,
  [804] = 767,
  [805] = 767,
  [806] = 806,
  [807] = 806,
  [808] = 808,
  [809] = 809,
  [810] = 810,
  [811] = 194,
  [812] = 809,
  [813] = 813,
  [814] = 806,
  [815] = 733,
  [816] = 816,
  [817] = 817,
  [818] = 818,
  [819] = 808,
  [820] = 806,
  [821] = 732,
  [822] = 810,
  [823] = 194,
  [824] = 813,
  [825] = 825,
  [826] = 806,
  [827] = 827,
  [828] = 806,
  [829] = 165,
  [830] = 194,
  [831] = 827,
  [832] = 832,
  [833] = 833,
  [834] = 834,
  [835] = 835,
  [836] = 806,
  [837] = 837,
  [838] = 827,
  [839] = 839,
  [840] = 840,
  [841] = 810,
  [842] = 732,
  [843] = 834,
  [844] = 806,
  [845] = 845,
  [846] = 846,
  [847] = 806,
  [848] = 806,
  [849] = 849,
  [850] = 834,
  [851] = 733,
  [852] = 813,
  [853] = 781,
  [854] = 854,
  [855] = 854,
  [856] = 854,
  [857] = 857,
  [858] = 806,
  [859] = 859,
  [860] = 733,
  [861] = 732,
  [862] = 862,
  [863] = 862,
  [864] = 864,
  [865] = 864,
  [866] = 866,
  [867] = 867,
  [868] = 868,
  [869] = 869,
  [870] = 870,
  [871] = 869,
  [872] = 868,
  [873] = 873,
  [874] = 873,
  [875] = 866,
  [876] = 867,
  [877] = 870,
  [878] = 878,
  [879] = 879,
  [880] = 880,
  [881] = 878,
  [882] = 878,
  [883] = 883,
  [884] = 884,
  [885] = 885,
  [886] = 886,
  [887] = 887,
  [888] = 888,
  [889] = 889,
  [890] = 890,
  [891] = 891,
  [892] = 892,
  [893] = 893,
  [894] = 894,
  [895] = 886,
  [896] = 896,
  [897] = 891,
  [898] = 898,
  [899] = 899,
  [900] = 887,
  [901] = 885,
  [902] = 902,
  [903] = 902,
  [904] = 904,
  [905] = 894,
  [906] = 891,
  [907] = 907,
  [908] = 907,
  [909] = 909,
  [910] = 879,
  [911] = 883,
  [912] = 912,
  [913] = 909,
  [914] = 902,
  [915] = 884,
  [916] = 894,
  [917] = 902,
  [918] = 880,
  [919] = 886,
  [920] = 920,
  [921] = 891,
  [922] = 902,
  [923] = 891,
  [924] = 889,
  [925] = 879,
  [926] = 926,
  [927] = 927,
  [928] = 891,
  [929] = 886,
  [930] = 883,
  [931] = 884,
  [932] = 891,
  [933] = 907,
  [934] = 909,
  [935] = 935,
  [936] = 904,
  [937] = 907,
  [938] = 879,
  [939] = 886,
  [940] = 902,
  [941] = 909,
  [942] = 880,
  [943] = 888,
  [944] = 944,
  [945] = 886,
  [946] = 894,
  [947] = 904,
  [948] = 879,
  [949] = 894,
  [950] = 884,
  [951] = 883,
  [952] = 904,
  [953] = 953,
  [954] = 886,
  [955] = 955,
  [956] = 904,
  [957] = 878,
  [958] = 894,
  [959] = 886,
  [960] = 880,
  [961] = 904,
  [962] = 883,
  [963] = 884,
  [964] = 964,
  [965] = 883,
  [966] = 953,
  [967] = 892,
  [968] = 884,
  [969] = 888,
  [970] = 904,
  [971] = 971,
  [972] = 972,
  [973] = 902,
  [974] = 879,
  [975] = 907,
  [976] = 909,
  [977] = 907,
  [978] = 883,
  [979] = 894,
  [980] = 884,
  [981] = 909,
  [982] = 907,
  [983] = 909,
  [984] = 879,
  [985] = 907,
  [986] = 894,
  [987] = 907,
  [988] = 972,
  [989] = 935,
  [990] = 883,
  [991] = 909,
  [992] = 891,
  [993] = 955,
  [994] = 878,
  [995] = 879,
  [996] = 955,
  [997] = 904,
  [998] = 909,
  [999] = 888,
  [1000] = 944,
  [1001] = 879,
  [1002] = 885,
  [1003] = 883,
  [1004] = 955,
  [1005] = 904,
  [1006] = 1006,
  [1007] = 902,
  [1008] = 894,
  [1009] = 912,
  [1010] = 884,
  [1011] = 884,
  [1012] = 886,
  [1013] = 898,
  [1014] = 887,
  [1015] = 891,
  [1016] = 1016,
  [1017] = 1017,
  [1018] = 1018,
  [1019] = 1019,
  [1020] = 1018,
  [1021] = 1021,
  [1022] = 1022,
  [1023] = 1023,
  [1024] = 1024,
  [1025] = 1025,
  [1026] = 1026,
  [1027] = 1026,
  [1028] = 1028,
  [1029] = 1029,
  [1030] = 1030,
  [1031] = 1031,
  [1032] = 1032,
  [1033] = 1028,
  [1034] = 1034,
  [1035] = 1035,
  [1036] = 1024,
  [1037] = 1029,
  [1038] = 1038,
  [1039] = 1039,
  [1040] = 552,
  [1041] = 550,
  [1042] = 1042,
  [1043] = 1042,
  [1044] = 1044,
  [1045] = 550,
  [1046] = 1046,
  [1047] = 1047,
  [1048] = 1046,
  [1049] = 1049,
  [1050] = 1050,
  [1051] = 1047,
  [1052] = 1052,
  [1053] = 552,
  [1054] = 1052,
  [1055] = 1050,
  [1056] = 1049,
  [1057] = 1052,
  [1058] = 1044,
  [1059] = 1046,
  [1060] = 1060,
  [1061] = 1060,
  [1062] = 1060,
  [1063] = 1060,
  [1064] = 1060,
  [1065] = 1060,
  [1066] = 1066,
  [1067] = 1066,
  [1068] = 1068,
  [1069] = 1068,
  [1070] = 1068,
  [1071] = 1068,
  [1072] = 1068,
  [1073] = 1068,
  [1074] = 1068,
  [1075] = 1068,
  [1076] = 1068,
  [1077] = 1077,
  [1078] = 1078,
  [1079] = 1079,
  [1080] = 1077,
  [1081] = 1081,
  [1082] = 1081,
  [1083] = 1083,
  [1084] = 1084,
  [1085] = 1085,
  [1086] = 1079,
  [1087] = 1078,
  [1088] = 1088,
  [1089] = 1089,
  [1090] = 1083,
  [1091] = 1091,
  [1092] = 1092,
  [1093] = 1093,
  [1094] = 1091,
  [1095] = 1092,
  [1096] = 1093,
  [1097] = 1092,
  [1098] = 1089,
  [1099] = 1099,
  [1100] = 1081,
  [1101] = 1091,
  [1102] = 1089,
  [1103] = 1092,
  [1104] = 1078,
  [1105] = 1105,
  [1106] = 1093,
  [1107] = 1083,
  [1108] = 1081,
  [1109] = 1099,
  [1110] = 1084,
  [1111] = 1078,
  [1112] = 1081,
  [1113] = 1088,
  [1114] = 1081,
  [1115] = 1099,
  [1116] = 1077,
  [1117] = 1105,
  [1118] = 1083,
  [1119] = 1084,
  [1120] = 1077,
  [1121] = 1091,
  [1122] = 1089,
  [1123] = 1078,
  [1124] = 1079,
  [1125] = 1084,
  [1126] = 1105,
  [1127] = 1077,
  [1128] = 1079,
  [1129] = 1088,
  [1130] = 1099,
  [1131] = 1093,
  [1132] = 1083,
  [1133] = 1084,
  [1134] = 1078,
  [1135] = 1089,
  [1136] = 1091,
  [1137] = 1093,
  [1138] = 1092,
  [1139] = 1079,
  [1140] = 1083,
  [1141] = 1088,
  [1142] = 1088,
  [1143] = 1081,
  [1144] = 1144,
  [1145] = 1081,
  [1146] = 1099,
  [1147] = 1099,
  [1148] = 1092,
  [1149] = 1093,
  [1150] = 1105,
  [1151] = 1091,
  [1152] = 1081,
  [1153] = 1089,
  [1154] = 1078,
  [1155] = 1084,
  [1156] = 1077,
  [1157] = 1099,
  [1158] = 1088,
  [1159] = 1079,
  [1160] = 1077,
  [1161] = 1084,
  [1162] = 1078,
  [1163] = 1089,
  [1164] = 1091,
  [1165] = 1081,
  [1166] = 1079,
  [1167] = 1088,
  [1168] = 1099,
  [1169] = 1093,
  [1170] = 1093,
  [1171] = 1099,
  [1172] = 1105,
  [1173] = 1088,
  [1174] = 1083,
  [1175] = 1088,
  [1176] = 1079,
  [1177] = 1077,
  [1178] = 1079,
  [1179] = 1084,
  [1180] = 1081,
  [1181] = 1089,
  [1182] = 1091,
  [1183] = 1092,
  [1184] = 1081,
  [1185] = 1185,
  [1186] = 1077,
  [1187] = 1092,
  [1188] = 1083,
  [1189] = 1084,
  [1190] = 1190,
  [1191] = 1081,
  [1192] = 1081,
  [1193] = 1093,
  [1194] = 1185,
  [1195] = 1091,
  [1196] = 1083,
  [1197] = 1092,
  [1198] = 1089,
  [1199] = 1078,
  [1200] = 1200,
  [1201] = 1190,
  [1202] = 1085,
  [1203] = 1203,
  [1204] = 1204,
  [1205] = 1205,
  [1206] = 1206,
  [1207] = 1207,
  [1208] = 1208,
  [1209] = 1209,
  [1210] = 1210,
  [1211] = 1211,
  [1212] = 1212,
  [1213] = 1213,
  [1214] = 1214,
  [1215] = 1215,
  [1216] = 1085,
  [1217] = 1217,
  [1218] = 1218,
  [1219] = 1190,
  [1220] = 1203,
  [1221] = 1203,
  [1222] = 1085,
  [1223] = 1200,
  [1224] = 1208,
  [1225] = 1225,
  [1226] = 1190,
  [1227] = 1200,
  [1228] = 1030,
  [1229] = 1209,
  [1230] = 1210,
  [1231] = 1212,
  [1232] = 1085,
  [1233] = 1203,
  [1234] = 1200,
  [1235] = 1235,
  [1236] = 1025,
  [1237] = 1203,
  [1238] = 1212,
  [1239] = 1021,
  [1240] = 1190,
  [1241] = 1210,
  [1242] = 1213,
  [1243] = 1217,
  [1244] = 1218,
  [1245] = 1200,
  [1246] = 1218,
  [1247] = 1247,
  [1248] = 1248,
  [1249] = 1206,
  [1250] = 1038,
  [1251] = 1225,
  [1252] = 1207,
  [1253] = 1203,
  [1254] = 1085,
  [1255] = 1217,
  [1256] = 1190,
  [1257] = 1257,
  [1258] = 1085,
  [1259] = 1214,
  [1260] = 1023,
  [1261] = 1190,
  [1262] = 1262,
  [1263] = 1262,
  [1264] = 1203,
  [1265] = 1085,
  [1266] = 1031,
  [1267] = 1205,
  [1268] = 1032,
  [1269] = 1205,
  [1270] = 1204,
  [1271] = 1200,
  [1272] = 1213,
  [1273] = 1211,
  [1274] = 1215,
  [1275] = 1203,
  [1276] = 1214,
  [1277] = 1190,
  [1278] = 1225,
  [1279] = 1200,
  [1280] = 1206,
  [1281] = 1215,
  [1282] = 1211,
  [1283] = 1204,
  [1284] = 1284,
  [1285] = 1285,
  [1286] = 1018,
  [1287] = 1019,
  [1288] = 1190,
  [1289] = 1034,
  [1290] = 1035,
  [1291] = 1291,
  [1292] = 1292,
  [1293] = 1257,
  [1294] = 1235,
  [1295] = 1247,
  [1296] = 1218,
  [1297] = 1217,
  [1298] = 1218,
  [1299] = 1299,
  [1300] = 1300,
  [1301] = 1301,
  [1302] = 1217,
  [1303] = 1285,
  [1304] = 1304,
  [1305] = 1305,
  [1306] = 1306,
  [1307] = 1085,
  [1308] = 1308,
  [1309] = 1309,
  [1310] = 1310,
  [1311] = 1311,
  [1312] = 1312,
  [1313] = 1313,
  [1314] = 1314,
  [1315] = 1315,
  [1316] = 1316,
  [1317] = 1317,
  [1318] = 1318,
  [1319] = 1319,
  [1320] = 1320,
  [1321] = 1247,
  [1322] = 1322,
  [1323] = 1235,
  [1324] = 1212,
  [1325] = 1210,
  [1326] = 1257,
  [1327] = 1327,
  [1328] = 1032,
  [1329] = 1205,
  [1330] = 1204,
  [1331] = 1213,
  [1332] = 1211,
  [1333] = 1215,
  [1334] = 1214,
  [1335] = 1225,
  [1336] = 1206,
  [1337] = 1200,
  [1338] = 1209,
  [1339] = 1025,
  [1340] = 1210,
  [1341] = 1203,
  [1342] = 1212,
  [1343] = 1212,
  [1344] = 1210,
  [1345] = 1210,
  [1346] = 1212,
  [1347] = 1031,
  [1348] = 1348,
  [1349] = 1023,
  [1350] = 1206,
  [1351] = 1225,
  [1352] = 1214,
  [1353] = 1215,
  [1354] = 1211,
  [1355] = 1206,
  [1356] = 1213,
  [1357] = 1204,
  [1358] = 1205,
  [1359] = 1038,
  [1360] = 1021,
  [1361] = 1030,
  [1362] = 1225,
  [1363] = 1214,
  [1364] = 1215,
  [1365] = 1211,
  [1366] = 1213,
  [1367] = 1207,
  [1368] = 1204,
  [1369] = 1206,
  [1370] = 1225,
  [1371] = 1214,
  [1372] = 1215,
  [1373] = 1211,
  [1374] = 1213,
  [1375] = 1205,
  [1376] = 1204,
  [1377] = 1205,
  [1378] = 1207,
  [1379] = 1218,
  [1380] = 1217,
  [1381] = 1381,
  [1382] = 1382,
  [1383] = 1383,
  [1384] = 1017,
  [1385] = 1209,
  [1386] = 1386,
  [1387] = 1387,
  [1388] = 1388,
  [1389] = 1218,
  [1390] = 1039,
  [1391] = 1217,
  [1392] = 1392,
  [1393] = 1257,
  [1394] = 1209,
  [1395] = 1018,
  [1396] = 1313,
  [1397] = 1316,
  [1398] = 1318,
  [1399] = 1035,
  [1400] = 1034,
  [1401] = 1317,
  [1402] = 1247,
  [1403] = 1235,
  [1404] = 1257,
  [1405] = 1319,
  [1406] = 1207,
  [1407] = 1203,
  [1408] = 1300,
  [1409] = 1019,
  [1410] = 1304,
  [1411] = 1305,
  [1412] = 1308,
  [1413] = 1311,
  [1414] = 1021,
  [1415] = 1030,
  [1416] = 1322,
  [1417] = 1392,
  [1418] = 1032,
  [1419] = 1348,
  [1420] = 1032,
  [1421] = 1381,
  [1422] = 1038,
  [1423] = 1023,
  [1424] = 1031,
  [1425] = 1383,
  [1426] = 1310,
  [1427] = 1315,
  [1428] = 1382,
  [1429] = 1299,
  [1430] = 1292,
  [1431] = 1291,
  [1432] = 1025,
  [1433] = 1247,
  [1434] = 1039,
  [1435] = 1235,
  [1436] = 1207,
  [1437] = 1039,
  [1438] = 1031,
  [1439] = 1023,
  [1440] = 1038,
  [1441] = 1017,
  [1442] = 1021,
  [1443] = 1030,
  [1444] = 1203,
  [1445] = 1306,
  [1446] = 1209,
  [1447] = 1284,
  [1448] = 1309,
  [1449] = 1312,
  [1450] = 1319,
  [1451] = 1203,
  [1452] = 1317,
  [1453] = 1318,
  [1454] = 1316,
  [1455] = 1313,
  [1456] = 1301,
  [1457] = 1039,
  [1458] = 1301,
  [1459] = 1314,
  [1460] = 1300,
  [1461] = 1304,
  [1462] = 1381,
  [1463] = 1025,
  [1464] = 1305,
  [1465] = 1217,
  [1466] = 1018,
  [1467] = 1218,
  [1468] = 1308,
  [1469] = 1019,
  [1470] = 1311,
  [1471] = 1322,
  [1472] = 1392,
  [1473] = 1257,
  [1474] = 1327,
  [1475] = 1320,
  [1476] = 1235,
  [1477] = 1312,
  [1478] = 1024,
  [1479] = 1029,
  [1480] = 1207,
  [1481] = 1207,
  [1482] = 1247,
  [1483] = 1209,
  [1484] = 1026,
  [1485] = 1034,
  [1486] = 1320,
  [1487] = 1327,
  [1488] = 1200,
  [1489] = 1035,
  [1490] = 1309,
  [1491] = 1203,
  [1492] = 1257,
  [1493] = 1205,
  [1494] = 1285,
  [1495] = 1235,
  [1496] = 1204,
  [1497] = 1247,
  [1498] = 1348,
  [1499] = 1028,
  [1500] = 1284,
  [1501] = 1306,
  [1502] = 1291,
  [1503] = 1292,
  [1504] = 1314,
  [1505] = 1213,
  [1506] = 1299,
  [1507] = 1315,
  [1508] = 1211,
  [1509] = 1310,
  [1510] = 1215,
  [1511] = 1210,
  [1512] = 1212,
  [1513] = 1382,
  [1514] = 1206,
  [1515] = 1225,
  [1516] = 1383,
  [1517] = 1017,
  [1518] = 1209,
  [1519] = 1214,
  [1520] = 1285,
  [1521] = 1207,
  [1522] = 1317,
  [1523] = 1327,
  [1524] = 1320,
  [1525] = 1025,
  [1526] = 1311,
  [1527] = 1308,
  [1528] = 1305,
  [1529] = 1304,
  [1530] = 1314,
  [1531] = 1039,
  [1532] = 1327,
  [1533] = 1382,
  [1534] = 1320,
  [1535] = 1322,
  [1536] = 1312,
  [1537] = 1032,
  [1538] = 1386,
  [1539] = 1387,
  [1540] = 1388,
  [1541] = 1314,
  [1542] = 1029,
  [1543] = 1217,
  [1544] = 1300,
  [1545] = 1039,
  [1546] = 1031,
  [1547] = 1301,
  [1548] = 1023,
  [1549] = 1025,
  [1550] = 1038,
  [1551] = 1031,
  [1552] = 1023,
  [1553] = 1038,
  [1554] = 1030,
  [1555] = 1021,
  [1556] = 1030,
  [1557] = 1021,
  [1558] = 1319,
  [1559] = 1291,
  [1560] = 1292,
  [1561] = 1032,
  [1562] = 1317,
  [1563] = 1299,
  [1564] = 1021,
  [1565] = 1030,
  [1566] = 1038,
  [1567] = 1023,
  [1568] = 1031,
  [1569] = 1318,
  [1570] = 1209,
  [1571] = 1299,
  [1572] = 1316,
  [1573] = 1313,
  [1574] = 1034,
  [1575] = 1292,
  [1576] = 1291,
  [1577] = 1028,
  [1578] = 1025,
  [1579] = 1301,
  [1580] = 1034,
  [1581] = 1300,
  [1582] = 1035,
  [1583] = 1304,
  [1584] = 1305,
  [1585] = 1382,
  [1586] = 1308,
  [1587] = 1035,
  [1588] = 1039,
  [1589] = 1311,
  [1590] = 1314,
  [1591] = 1591,
  [1592] = 1039,
  [1593] = 1322,
  [1594] = 1594,
  [1595] = 1313,
  [1596] = 1392,
  [1597] = 1032,
  [1598] = 1315,
  [1599] = 1388,
  [1600] = 1310,
  [1601] = 1315,
  [1602] = 1387,
  [1603] = 1386,
  [1604] = 1310,
  [1605] = 1039,
  [1606] = 1316,
  [1607] = 1348,
  [1608] = 1318,
  [1609] = 1035,
  [1610] = 1034,
  [1611] = 1381,
  [1612] = 1383,
  [1613] = 1381,
  [1614] = 1383,
  [1615] = 1348,
  [1616] = 1320,
  [1617] = 1327,
  [1618] = 1392,
  [1619] = 1022,
  [1620] = 1386,
  [1621] = 1387,
  [1622] = 1388,
  [1623] = 1026,
  [1624] = 1327,
  [1625] = 1320,
  [1626] = 1310,
  [1627] = 1315,
  [1628] = 1218,
  [1629] = 1382,
  [1630] = 1028,
  [1631] = 1299,
  [1632] = 1292,
  [1633] = 1291,
  [1634] = 1028,
  [1635] = 1392,
  [1636] = 1039,
  [1637] = 1026,
  [1638] = 1029,
  [1639] = 1024,
  [1640] = 1022,
  [1641] = 1314,
  [1642] = 1312,
  [1643] = 1205,
  [1644] = 1204,
  [1645] = 1024,
  [1646] = 1026,
  [1647] = 1029,
  [1648] = 1317,
  [1649] = 1213,
  [1650] = 1024,
  [1651] = 1034,
  [1652] = 1211,
  [1653] = 1319,
  [1654] = 1312,
  [1655] = 1383,
  [1656] = 1322,
  [1657] = 1381,
  [1658] = 1215,
  [1659] = 1319,
  [1660] = 1312,
  [1661] = 1317,
  [1662] = 1214,
  [1663] = 1225,
  [1664] = 1035,
  [1665] = 1311,
  [1666] = 1308,
  [1667] = 1305,
  [1668] = 1304,
  [1669] = 1318,
  [1670] = 1257,
  [1671] = 1316,
  [1672] = 1235,
  [1673] = 1300,
  [1674] = 1301,
  [1675] = 1206,
  [1676] = 1348,
  [1677] = 1247,
  [1678] = 1313,
  [1679] = 1291,
  [1680] = 1292,
  [1681] = 1299,
  [1682] = 1313,
  [1683] = 1382,
  [1684] = 1319,
  [1685] = 1210,
  [1686] = 1301,
  [1687] = 1316,
  [1688] = 1318,
  [1689] = 1315,
  [1690] = 1383,
  [1691] = 1310,
  [1692] = 1300,
  [1693] = 1348,
  [1694] = 1304,
  [1695] = 1305,
  [1696] = 1308,
  [1697] = 1311,
  [1698] = 1392,
  [1699] = 1381,
  [1700] = 1322,
  [1701] = 1212,
  [1702] = 1035,
  [1703] = 1257,
  [1704] = 1292,
  [1705] = 1291,
  [1706] = 1313,
  [1707] = 1301,
  [1708] = 1309,
  [1709] = 1300,
  [1710] = 1304,
  [1711] = 1305,
  [1712] = 1284,
  [1713] = 1308,
  [1714] = 1311,
  [1715] = 1322,
  [1716] = 1031,
  [1717] = 1299,
  [1718] = 1025,
  [1719] = 1309,
  [1720] = 1284,
  [1721] = 1306,
  [1722] = 1247,
  [1723] = 1317,
  [1724] = 1309,
  [1725] = 1284,
  [1726] = 1022,
  [1727] = 1235,
  [1728] = 1327,
  [1729] = 1320,
  [1730] = 1309,
  [1731] = 1284,
  [1732] = 1306,
  [1733] = 1032,
  [1734] = 1022,
  [1735] = 1306,
  [1736] = 1039,
  [1737] = 1319,
  [1738] = 1030,
  [1739] = 1392,
  [1740] = 1021,
  [1741] = 1318,
  [1742] = 1316,
  [1743] = 1348,
  [1744] = 1381,
  [1745] = 1023,
  [1746] = 1383,
  [1747] = 1310,
  [1748] = 1382,
  [1749] = 1315,
  [1750] = 1034,
  [1751] = 1038,
  [1752] = 1312,
  [1753] = 1309,
  [1754] = 1284,
  [1755] = 1306,
  [1756] = 1314,
  [1757] = 1306,
  [1758] = 1035,
  [1759] = 1383,
  [1760] = 1308,
  [1761] = 1314,
  [1762] = 1034,
  [1763] = 1030,
  [1764] = 1026,
  [1765] = 1021,
  [1766] = 1038,
  [1767] = 1023,
  [1768] = 1029,
  [1769] = 1028,
  [1770] = 1024,
  [1771] = 1039,
  [1772] = 1039,
  [1773] = 1031,
  [1774] = 1025,
  [1775] = 1322,
  [1776] = 1317,
  [1777] = 1319,
  [1778] = 1035,
  [1779] = 1039,
  [1780] = 1312,
  [1781] = 1392,
  [1782] = 1032,
  [1783] = 1382,
  [1784] = 1039,
  [1785] = 1318,
  [1786] = 1594,
  [1787] = 1348,
  [1788] = 1381,
  [1789] = 1039,
  [1790] = 1327,
  [1791] = 1320,
  [1792] = 1591,
  [1793] = 1039,
  [1794] = 1039,
  [1795] = 1310,
  [1796] = 1316,
  [1797] = 1085,
  [1798] = 1311,
  [1799] = 1032,
  [1800] = 1190,
  [1801] = 1025,
  [1802] = 1291,
  [1803] = 1292,
  [1804] = 1031,
  [1805] = 1023,
  [1806] = 1038,
  [1807] = 1313,
  [1808] = 1021,
  [1809] = 1301,
  [1810] = 1030,
  [1811] = 1299,
  [1812] = 1300,
  [1813] = 1304,
  [1814] = 1814,
  [1815] = 1315,
  [1816] = 1305,
  [1817] = 1034,
  [1818] = 1818,
  [1819] = 1819,
  [1820] = 237,
  [1821] = 1821,
  [1822] = 240,
  [1823] = 1209,
  [1824] = 238,
  [1825] = 1825,
  [1826] = 1826,
  [1827] = 1827,
  [1828] = 1828,
  [1829] = 227,
  [1830] = 1830,
  [1831] = 204,
  [1832] = 1832,
  [1833] = 1833,
  [1834] = 222,
  [1835] = 1835,
  [1836] = 228,
  [1837] = 1837,
  [1838] = 205,
  [1839] = 1839,
  [1840] = 1840,
  [1841] = 241,
  [1842] = 1842,
  [1843] = 1843,
  [1844] = 211,
  [1845] = 226,
  [1846] = 1846,
  [1847] = 1847,
  [1848] = 1848,
  [1849] = 1849,
  [1850] = 1850,
  [1851] = 1851,
  [1852] = 1852,
  [1853] = 1853,
  [1854] = 203,
  [1855] = 1855,
  [1856] = 1207,
  [1857] = 1857,
  [1858] = 247,
  [1859] = 1859,
  [1860] = 1860,
  [1861] = 1861,
  [1862] = 1862,
  [1863] = 1863,
  [1864] = 1864,
  [1865] = 1865,
  [1866] = 1866,
  [1867] = 1867,
  [1868] = 1863,
  [1869] = 1865,
  [1870] = 1862,
  [1871] = 1861,
  [1872] = 1867,
  [1873] = 1860,
  [1874] = 1874,
  [1875] = 1867,
  [1876] = 1874,
  [1877] = 1867,
  [1878] = 1865,
  [1879] = 1864,
  [1880] = 1862,
  [1881] = 1863,
  [1882] = 1864,
  [1883] = 1866,
  [1884] = 1861,
  [1885] = 1864,
  [1886] = 1865,
  [1887] = 1863,
  [1888] = 1860,
  [1889] = 1874,
  [1890] = 1862,
  [1891] = 1874,
  [1892] = 1866,
  [1893] = 1861,
  [1894] = 1860,
  [1895] = 1866,
  [1896] = 1896,
  [1897] = 1897,
  [1898] = 1896,
  [1899] = 1899,
  [1900] = 1896,
  [1901] = 1901,
  [1902] = 1902,
  [1903] = 1903,
  [1904] = 1901,
  [1905] = 1905,
  [1906] = 1901,
  [1907] = 1905,
  [1908] = 1908,
  [1909] = 1903,
  [1910] = 1908,
  [1911] = 1908,
  [1912] = 1902,
  [1913] = 1902,
  [1914] = 1905,
  [1915] = 1905,
  [1916] = 1903,
  [1917] = 1903,
  [1918] = 1901,
  [1919] = 1908,
  [1920] = 1902,
  [1921] = 1921,
  [1922] = 1922,
  [1923] = 1923,
  [1924] = 1922,
  [1925] = 1922,
  [1926] = 1922,
  [1927] = 1923,
  [1928] = 1923,
  [1929] = 1923,
  [1930] = 1930,
  [1931] = 1931,
  [1932] = 1931,
  [1933] = 1026,
  [1934] = 1028,
  [1935] = 1930,
  [1936] = 1930,
  [1937] = 1931,
  [1938] = 1591,
  [1939] = 1594,
  [1940] = 1024,
  [1941] = 1029,
  [1942] = 1931,
  [1943] = 1931,
  [1944] = 1930,
  [1945] = 1931,
  [1946] = 1930,
  [1947] = 1930,
  [1948] = 1039,
  [1949] = 1931,
  [1950] = 1950,
  [1951] = 1951,
  [1952] = 1930,
  [1953] = 1931,
  [1954] = 1035,
  [1955] = 1034,
  [1956] = 1956,
  [1957] = 1930,
  [1958] = 1958,
  [1959] = 1959,
  [1960] = 1039,
  [1961] = 1961,
  [1962] = 1594,
  [1963] = 1956,
  [1964] = 1964,
  [1965] = 1591,
  [1966] = 1964,
  [1967] = 1964,
  [1968] = 1964,
  [1969] = 1024,
  [1970] = 1026,
  [1971] = 1591,
  [1972] = 1964,
  [1973] = 1959,
  [1974] = 1028,
  [1975] = 1975,
  [1976] = 1024,
  [1977] = 1964,
  [1978] = 1026,
  [1979] = 1964,
  [1980] = 1034,
  [1981] = 1035,
  [1982] = 1029,
  [1983] = 1591,
  [1984] = 1594,
  [1985] = 1029,
  [1986] = 1026,
  [1987] = 1964,
  [1988] = 1964,
  [1989] = 1024,
  [1990] = 1958,
  [1991] = 1964,
  [1992] = 1992,
  [1993] = 1594,
  [1994] = 1994,
  [1995] = 1028,
  [1996] = 1964,
  [1997] = 1997,
  [1998] = 1028,
  [1999] = 1029,
  [2000] = 2000,
  [2001] = 2000,
  [2002] = 1961,
  [2003] = 2000,
  [2004] = 2000,
  [2005] = 2000,
  [2006] = 2000,
  [2007] = 1992,
  [2008] = 2008,
  [2009] = 2009,
  [2010] = 2010,
  [2011] = 1930,
  [2012] = 2000,
  [2013] = 2008,
  [2014] = 2000,
  [2015] = 1975,
  [2016] = 1951,
  [2017] = 2008,
  [2018] = 2000,
  [2019] = 2009,
  [2020] = 1994,
  [2021] = 1950,
  [2022] = 1931,
  [2023] = 2023,
  [2024] = 2024,
  [2025] = 2025,
  [2026] = 2026,
  [2027] = 2027,
  [2028] = 2025,
  [2029] = 2025,
  [2030] = 2026,
  [2031] = 2025,
  [2032] = 2032,
  [2033] = 2033,
  [2034] = 2026,
  [2035] = 2026,
  [2036] = 2032,
  [2037] = 2026,
  [2038] = 2025,
  [2039] = 2025,
  [2040] = 2026,
  [2041] = 2024,
  [2042] = 2026,
  [2043] = 2025,
  [2044] = 2026,
  [2045] = 2025,
  [2046] = 2026,
  [2047] = 2025,
  [2048] = 2026,
  [2049] = 2026,
  [2050] = 2025,
  [2051] = 2025,
  [2052] = 2052,
  [2053] = 2052,
  [2054] = 2054,
  [2055] = 2055,
  [2056] = 2056,
  [2057] = 2054,
  [2058] = 2054,
  [2059] = 2054,
  [2060] = 2054,
  [2061] = 2061,
  [2062] = 2062,
  [2063] = 2054,
  [2064] = 2054,
  [2065] = 2065,
  [2066] = 2066,
  [2067] = 2067,
  [2068] = 2054,
  [2069] = 2069,
  [2070] = 2070,
  [2071] = 2054,
  [2072] = 2072,
  [2073] = 2073,
  [2074] = 2074,
  [2075] = 2072,
  [2076] = 2072,
  [2077] = 2073,
  [2078] = 2078,
  [2079] = 2073,
  [2080] = 2072,
  [2081] = 2073,
  [2082] = 2073,
  [2083] = 2078,
  [2084] = 2084,
  [2085] = 2078,
  [2086] = 2072,
  [2087] = 2078,
  [2088] = 2072,
  [2089] = 2073,
  [2090] = 2078,
  [2091] = 2078,
  [2092] = 2073,
  [2093] = 2093,
  [2094] = 2072,
  [2095] = 2072,
  [2096] = 2093,
  [2097] = 2078,
  [2098] = 2073,
  [2099] = 2099,
  [2100] = 2073,
  [2101] = 2078,
  [2102] = 2072,
  [2103] = 2078,
  [2104] = 2070,
  [2105] = 2105,
  [2106] = 2069,
  [2107] = 2055,
  [2108] = 2062,
  [2109] = 2061,
  [2110] = 2066,
  [2111] = 2067,
  [2112] = 2066,
  [2113] = 2113,
  [2114] = 2065,
  [2115] = 2056,
  [2116] = 2056,
  [2117] = 2117,
  [2118] = 2065,
  [2119] = 2069,
  [2120] = 2113,
  [2121] = 2055,
  [2122] = 2070,
  [2123] = 2067,
  [2124] = 2061,
  [2125] = 2062,
  [2126] = 2126,
  [2127] = 2105,
  [2128] = 2128,
  [2129] = 2066,
  [2130] = 2070,
  [2131] = 2066,
  [2132] = 2132,
  [2133] = 2133,
  [2134] = 2065,
  [2135] = 2066,
  [2136] = 2056,
  [2137] = 2137,
  [2138] = 2138,
  [2139] = 2070,
  [2140] = 2069,
  [2141] = 2069,
  [2142] = 2055,
  [2143] = 2055,
  [2144] = 2062,
  [2145] = 2061,
  [2146] = 2067,
  [2147] = 2062,
  [2148] = 2061,
  [2149] = 2149,
  [2150] = 2067,
  [2151] = 2113,
  [2152] = 2152,
  [2153] = 2113,
  [2154] = 2154,
  [2155] = 2065,
  [2156] = 2156,
  [2157] = 2056,
  [2158] = 2069,
  [2159] = 2055,
  [2160] = 2062,
  [2161] = 2061,
  [2162] = 2067,
  [2163] = 2056,
  [2164] = 2164,
  [2165] = 2070,
  [2166] = 2065,
  [2167] = 2167,
  [2168] = 2168,
  [2169] = 2169,
  [2170] = 2170,
  [2171] = 2170,
  [2172] = 2172,
  [2173] = 2070,
  [2174] = 2174,
  [2175] = 2175,
  [2176] = 2066,
  [2177] = 2177,
  [2178] = 2069,
  [2179] = 2170,
  [2180] = 2180,
  [2181] = 2181,
  [2182] = 2170,
  [2183] = 2062,
  [2184] = 2184,
  [2185] = 2185,
  [2186] = 2170,
  [2187] = 2187,
  [2188] = 2188,
  [2189] = 2070,
  [2190] = 2126,
  [2191] = 2170,
  [2192] = 2066,
  [2193] = 2170,
  [2194] = 2194,
  [2195] = 2195,
  [2196] = 2187,
  [2197] = 2170,
  [2198] = 2198,
  [2199] = 2199,
  [2200] = 2170,
  [2201] = 2201,
  [2202] = 2195,
  [2203] = 2055,
  [2204] = 2170,
  [2205] = 2205,
  [2206] = 2206,
  [2207] = 2207,
  [2208] = 2154,
  [2209] = 2061,
  [2210] = 2169,
  [2211] = 2211,
  [2212] = 2188,
  [2213] = 2065,
  [2214] = 2214,
  [2215] = 2207,
  [2216] = 2207,
  [2217] = 2067,
  [2218] = 2218,
  [2219] = 2062,
  [2220] = 2149,
  [2221] = 2069,
  [2222] = 2056,
  [2223] = 2055,
  [2224] = 2224,
  [2225] = 2225,
  [2226] = 2194,
  [2227] = 2227,
  [2228] = 2170,
  [2229] = 2229,
  [2230] = 2149,
  [2231] = 2194,
  [2232] = 2065,
  [2233] = 2233,
  [2234] = 2056,
  [2235] = 2149,
  [2236] = 2061,
  [2237] = 2067,
  [2238] = 2188,
  [2239] = 2177,
  [2240] = 2240,
  [2241] = 2126,
  [2242] = 2242,
  [2243] = 2243,
  [2244] = 2244,
  [2245] = 2133,
  [2246] = 2240,
  [2247] = 2247,
  [2248] = 2126,
  [2249] = 2240,
  [2250] = 2250,
  [2251] = 2251,
  [2252] = 2252,
  [2253] = 2177,
  [2254] = 2152,
  [2255] = 2255,
  [2256] = 2256,
  [2257] = 2177,
  [2258] = 2240,
  [2259] = 2259,
  [2260] = 2240,
  [2261] = 2261,
  [2262] = 2262,
  [2263] = 2132,
  [2264] = 2261,
  [2265] = 2152,
  [2266] = 2266,
  [2267] = 2240,
  [2268] = 2259,
  [2269] = 2152,
  [2270] = 2242,
  [2271] = 2240,
  [2272] = 2272,
  [2273] = 2273,
  [2274] = 2240,
  [2275] = 2250,
  [2276] = 2276,
  [2277] = 2277,
  [2278] = 2278,
  [2279] = 2242,
  [2280] = 2276,
  [2281] = 2240,
  [2282] = 2259,
  [2283] = 2133,
  [2284] = 2272,
  [2285] = 2276,
  [2286] = 2132,
  [2287] = 2133,
  [2288] = 2251,
  [2289] = 2289,
  [2290] = 2251,
  [2291] = 2132,
  [2292] = 2292,
  [2293] = 2293,
  [2294] = 2137,
  [2295] = 2295,
  [2296] = 2154,
  [2297] = 2293,
  [2298] = 2243,
  [2299] = 2299,
  [2300] = 2300,
  [2301] = 2225,
  [2302] = 2302,
  [2303] = 2137,
  [2304] = 2304,
  [2305] = 2305,
  [2306] = 2154,
  [2307] = 2304,
  [2308] = 2308,
  [2309] = 2309,
  [2310] = 2310,
  [2311] = 2311,
  [2312] = 2312,
  [2313] = 2313,
  [2314] = 2314,
  [2315] = 2315,
  [2316] = 2185,
  [2317] = 2317,
  [2318] = 2318,
  [2319] = 2319,
  [2320] = 2308,
  [2321] = 2312,
  [2322] = 2313,
  [2323] = 2305,
  [2324] = 2324,
  [2325] = 2310,
  [2326] = 2256,
  [2327] = 2299,
  [2328] = 2328,
  [2329] = 2329,
  [2330] = 2309,
  [2331] = 2185,
  [2332] = 2243,
  [2333] = 2319,
  [2334] = 2293,
  [2335] = 2335,
  [2336] = 2336,
  [2337] = 2300,
  [2338] = 2256,
  [2339] = 2295,
  [2340] = 2340,
  [2341] = 2341,
  [2342] = 2342,
  [2343] = 2343,
  [2344] = 2185,
  [2345] = 2345,
  [2346] = 1950,
  [2347] = 2340,
  [2348] = 2317,
  [2349] = 2349,
  [2350] = 2350,
  [2351] = 2154,
  [2352] = 1951,
  [2353] = 2305,
  [2354] = 2152,
  [2355] = 2315,
  [2356] = 2319,
  [2357] = 2315,
  [2358] = 2358,
  [2359] = 2359,
  [2360] = 2312,
  [2361] = 2313,
  [2362] = 2362,
  [2363] = 2133,
  [2364] = 2364,
  [2365] = 2317,
  [2366] = 2366,
  [2367] = 2305,
  [2368] = 2349,
  [2369] = 2243,
  [2370] = 2342,
  [2371] = 2371,
  [2372] = 2372,
  [2373] = 2318,
  [2374] = 2328,
  [2375] = 2375,
  [2376] = 2311,
  [2377] = 2377,
  [2378] = 2310,
  [2379] = 2308,
  [2380] = 2309,
  [2381] = 2056,
  [2382] = 2382,
  [2383] = 2070,
  [2384] = 2256,
  [2385] = 2065,
  [2386] = 2329,
  [2387] = 2315,
  [2388] = 2388,
  [2389] = 2324,
  [2390] = 2305,
  [2391] = 2324,
  [2392] = 2308,
  [2393] = 2358,
  [2394] = 2359,
  [2395] = 2395,
  [2396] = 2342,
  [2397] = 2067,
  [2398] = 2061,
  [2399] = 2062,
  [2400] = 2055,
  [2401] = 2069,
  [2402] = 2402,
  [2403] = 2403,
  [2404] = 2066,
  [2405] = 2132,
  [2406] = 2349,
  [2407] = 2377,
  [2408] = 2328,
  [2409] = 2137,
  [2410] = 2372,
  [2411] = 2411,
  [2412] = 2412,
  [2413] = 2413,
  [2414] = 2414,
  [2415] = 2415,
  [2416] = 2416,
  [2417] = 2417,
  [2418] = 2418,
  [2419] = 2340,
  [2420] = 2420,
  [2421] = 2413,
  [2422] = 2422,
  [2423] = 2423,
  [2424] = 2424,
  [2425] = 2425,
  [2426] = 2295,
  [2427] = 2427,
  [2428] = 2428,
  [2429] = 2429,
  [2430] = 2428,
  [2431] = 2364,
  [2432] = 2432,
  [2433] = 2433,
  [2434] = 2434,
  [2435] = 2300,
  [2436] = 2343,
  [2437] = 2341,
  [2438] = 2302,
  [2439] = 2439,
  [2440] = 2440,
  [2441] = 2319,
  [2442] = 2358,
  [2443] = 2185,
  [2444] = 2444,
  [2445] = 2445,
  [2446] = 2446,
  [2447] = 2403,
  [2448] = 2359,
  [2449] = 2449,
  [2450] = 2450,
  [2451] = 1975,
  [2452] = 2341,
  [2453] = 2411,
  [2454] = 2454,
  [2455] = 2454,
  [2456] = 2358,
  [2457] = 2359,
  [2458] = 2458,
  [2459] = 2459,
  [2460] = 2366,
  [2461] = 2413,
  [2462] = 2395,
  [2463] = 2343,
  [2464] = 2300,
  [2465] = 2465,
  [2466] = 2295,
  [2467] = 2340,
  [2468] = 2468,
  [2469] = 2413,
  [2470] = 2470,
  [2471] = 2471,
  [2472] = 2372,
  [2473] = 2473,
  [2474] = 2474,
  [2475] = 2413,
  [2476] = 2382,
  [2477] = 2477,
  [2478] = 2328,
  [2479] = 2479,
  [2480] = 2413,
  [2481] = 2481,
  [2482] = 2411,
  [2483] = 2483,
  [2484] = 2395,
  [2485] = 2459,
  [2486] = 2486,
  [2487] = 2458,
  [2488] = 2488,
  [2489] = 2483,
  [2490] = 2341,
  [2491] = 2413,
  [2492] = 2439,
  [2493] = 2440,
  [2494] = 2382,
  [2495] = 2372,
  [2496] = 2428,
  [2497] = 2343,
  [2498] = 2498,
  [2499] = 2499,
  [2500] = 2500,
  [2501] = 2501,
  [2502] = 2501,
  [2503] = 1961,
  [2504] = 2382,
  [2505] = 2505,
  [2506] = 2506,
  [2507] = 2364,
  [2508] = 2329,
  [2509] = 2251,
  [2510] = 2446,
  [2511] = 2498,
  [2512] = 2395,
  [2513] = 1994,
  [2514] = 2458,
  [2515] = 2324,
  [2516] = 2439,
  [2517] = 2517,
  [2518] = 2470,
  [2519] = 2329,
  [2520] = 2520,
  [2521] = 2521,
  [2522] = 1992,
  [2523] = 2505,
  [2524] = 2524,
  [2525] = 2458,
  [2526] = 2364,
  [2527] = 2413,
  [2528] = 2528,
  [2529] = 2413,
  [2530] = 2530,
  [2531] = 2531,
  [2532] = 2473,
  [2533] = 2418,
  [2534] = 2534,
  [2535] = 2535,
  [2536] = 2536,
  [2537] = 2528,
  [2538] = 2524,
  [2539] = 2539,
  [2540] = 2540,
  [2541] = 2541,
  [2542] = 2542,
  [2543] = 2543,
  [2544] = 2544,
  [2545] = 2545,
  [2546] = 2546,
  [2547] = 2543,
  [2548] = 2548,
  [2549] = 2549,
  [2550] = 2550,
  [2551] = 2551,
  [2552] = 2539,
  [2553] = 2479,
  [2554] = 2412,
  [2555] = 2434,
  [2556] = 2535,
  [2557] = 2531,
  [2558] = 2543,
  [2559] = 2424,
  [2560] = 2560,
  [2561] = 2414,
  [2562] = 2549,
  [2563] = 2506,
  [2564] = 2530,
  [2565] = 2565,
  [2566] = 2501,
  [2567] = 2567,
  [2568] = 2528,
  [2569] = 2486,
  [2570] = 2488,
  [2571] = 2449,
  [2572] = 2449,
  [2573] = 2471,
  [2574] = 2506,
  [2575] = 2500,
  [2576] = 2468,
  [2577] = 2481,
  [2578] = 2517,
  [2579] = 2539,
  [2580] = 2543,
  [2581] = 2549,
  [2582] = 2582,
  [2583] = 2549,
  [2584] = 2499,
  [2585] = 2585,
  [2586] = 2524,
  [2587] = 2551,
  [2588] = 2415,
  [2589] = 2589,
  [2590] = 2434,
  [2591] = 2531,
  [2592] = 2418,
  [2593] = 2530,
  [2594] = 2594,
  [2595] = 2420,
  [2596] = 2423,
  [2597] = 2597,
  [2598] = 2499,
  [2599] = 2481,
  [2600] = 259,
  [2601] = 2449,
  [2602] = 2425,
  [2603] = 2501,
  [2604] = 2506,
  [2605] = 2427,
  [2606] = 2481,
  [2607] = 2607,
  [2608] = 2429,
  [2609] = 2609,
  [2610] = 2429,
  [2611] = 2429,
  [2612] = 2427,
  [2613] = 2425,
  [2614] = 2614,
  [2615] = 2615,
  [2616] = 2616,
  [2617] = 2427,
  [2618] = 2424,
  [2619] = 2423,
  [2620] = 2534,
  [2621] = 2420,
  [2622] = 2622,
  [2623] = 2479,
  [2624] = 2425,
  [2625] = 2625,
  [2626] = 2626,
  [2627] = 2424,
  [2628] = 2628,
  [2629] = 2589,
  [2630] = 2423,
  [2631] = 2418,
  [2632] = 2415,
  [2633] = 2468,
  [2634] = 2500,
  [2635] = 2471,
  [2636] = 2488,
  [2637] = 2486,
  [2638] = 2486,
  [2639] = 2488,
  [2640] = 2479,
  [2641] = 2420,
  [2642] = 2471,
  [2643] = 2528,
  [2644] = 2499,
  [2645] = 2645,
  [2646] = 2524,
  [2647] = 2434,
  [2648] = 2444,
  [2649] = 2614,
  [2650] = 2531,
  [2651] = 2651,
  [2652] = 2530,
  [2653] = 2500,
  [2654] = 2468,
  [2655] = 2625,
  [2656] = 2656,
  [2657] = 2657,
  [2658] = 2415,
  [2659] = 2659,
  [2660] = 2660,
  [2661] = 2539,
  [2662] = 2432,
  [2663] = 2663,
  [2664] = 2664,
  [2665] = 2665,
  [2666] = 2666,
  [2667] = 2667,
  [2668] = 2668,
  [2669] = 2669,
  [2670] = 2670,
  [2671] = 2671,
  [2672] = 2672,
  [2673] = 2673,
  [2674] = 2674,
  [2675] = 2675,
  [2676] = 2676,
  [2677] = 2677,
  [2678] = 2678,
  [2679] = 2679,
  [2680] = 2680,
  [2681] = 2681,
  [2682] = 2682,
  [2683] = 2683,
  [2684] = 2684,
  [2685] = 2685,
  [2686] = 2686,
  [2687] = 2687,
  [2688] = 2688,
  [2689] = 2673,
  [2690] = 1950,
  [2691] = 2691,
  [2692] = 2692,
  [2693] = 2693,
  [2694] = 2694,
  [2695] = 2695,
  [2696] = 1951,
  [2697] = 2697,
  [2698] = 2698,
  [2699] = 2699,
  [2700] = 2700,
  [2701] = 2701,
  [2702] = 2567,
  [2703] = 2703,
  [2704] = 2704,
  [2705] = 2705,
  [2706] = 2706,
  [2707] = 2707,
  [2708] = 2708,
  [2709] = 2709,
  [2710] = 2710,
  [2711] = 2711,
  [2712] = 2712,
  [2713] = 2713,
  [2714] = 2714,
  [2715] = 2715,
  [2716] = 2716,
  [2717] = 2717,
  [2718] = 2718,
  [2719] = 2717,
  [2720] = 2720,
  [2721] = 2714,
  [2722] = 2722,
  [2723] = 2723,
  [2724] = 2724,
  [2725] = 2725,
  [2726] = 2726,
  [2727] = 2679,
  [2728] = 2711,
  [2729] = 2715,
  [2730] = 2710,
  [2731] = 2731,
  [2732] = 2732,
  [2733] = 2672,
  [2734] = 2734,
  [2735] = 2664,
  [2736] = 2712,
  [2737] = 2709,
  [2738] = 2708,
  [2739] = 2739,
  [2740] = 2740,
  [2741] = 2741,
  [2742] = 2742,
  [2743] = 2713,
  [2744] = 2744,
  [2745] = 2701,
  [2746] = 2746,
  [2747] = 2747,
  [2748] = 2716,
  [2749] = 2747,
  [2750] = 2703,
  [2751] = 2751,
  [2752] = 2687,
  [2753] = 2753,
  [2754] = 2754,
  [2755] = 2755,
  [2756] = 2700,
  [2757] = 2698,
  [2758] = 2758,
  [2759] = 2759,
  [2760] = 2677,
  [2761] = 2676,
  [2762] = 2692,
  [2763] = 2697,
  [2764] = 2764,
  [2765] = 2765,
  [2766] = 2677,
  [2767] = 2542,
  [2768] = 2366,
  [2769] = 2403,
  [2770] = 2676,
  [2771] = 1207,
  [2772] = 2692,
  [2773] = 2607,
  [2774] = 259,
  [2775] = 2694,
  [2776] = 2366,
  [2777] = 2403,
  [2778] = 2607,
  [2779] = 1209,
  [2780] = 2545,
  [2781] = 2542,
  [2782] = 2540,
  [2783] = 2693,
  [2784] = 259,
  [2785] = 2692,
  [2786] = 2679,
  [2787] = 2787,
  [2788] = 2788,
  [2789] = 2789,
  [2790] = 2677,
  [2791] = 2676,
  [2792] = 2687,
  [2793] = 2675,
  [2794] = 2674,
  [2795] = 2366,
  [2796] = 1951,
  [2797] = 2692,
  [2798] = 2788,
  [2799] = 2713,
  [2800] = 2693,
  [2801] = 2694,
  [2802] = 2666,
  [2803] = 2701,
  [2804] = 2403,
  [2805] = 2703,
  [2806] = 2806,
  [2807] = 2807,
  [2808] = 2711,
  [2809] = 2711,
  [2810] = 2720,
  [2811] = 2701,
  [2812] = 2687,
  [2813] = 2714,
  [2814] = 2717,
  [2815] = 240,
  [2816] = 2679,
  [2817] = 2817,
  [2818] = 2818,
  [2819] = 2665,
  [2820] = 2703,
  [2821] = 314,
  [2822] = 2822,
  [2823] = 2683,
  [2824] = 2700,
  [2825] = 2825,
  [2826] = 2826,
  [2827] = 2677,
  [2828] = 2694,
  [2829] = 2693,
  [2830] = 2830,
  [2831] = 2831,
  [2832] = 2692,
  [2833] = 2545,
  [2834] = 2542,
  [2835] = 2540,
  [2836] = 2836,
  [2837] = 2667,
  [2838] = 2676,
  [2839] = 2668,
  [2840] = 2205,
  [2841] = 2607,
  [2842] = 2674,
  [2843] = 2167,
  [2844] = 2675,
  [2845] = 2218,
  [2846] = 2676,
  [2847] = 2677,
  [2848] = 2224,
  [2849] = 2849,
  [2850] = 2667,
  [2851] = 2681,
  [2852] = 2852,
  [2853] = 2682,
  [2854] = 2854,
  [2855] = 2174,
  [2856] = 2181,
  [2857] = 2184,
  [2858] = 238,
  [2859] = 2825,
  [2860] = 2550,
  [2861] = 259,
  [2862] = 2675,
  [2863] = 2668,
  [2864] = 2674,
  [2865] = 2818,
  [2866] = 2669,
  [2867] = 2806,
  [2868] = 2704,
  [2869] = 2788,
  [2870] = 2670,
  [2871] = 2671,
  [2872] = 2692,
  [2873] = 2718,
  [2874] = 2693,
  [2875] = 2694,
  [2876] = 2663,
  [2877] = 2703,
  [2878] = 2541,
  [2879] = 2731,
  [2880] = 2732,
  [2881] = 2691,
  [2882] = 2198,
  [2883] = 2739,
  [2884] = 1951,
  [2885] = 2741,
  [2886] = 2711,
  [2887] = 2701,
  [2888] = 2744,
  [2889] = 241,
  [2890] = 2746,
  [2891] = 2891,
  [2892] = 2759,
  [2893] = 2753,
  [2894] = 2758,
  [2895] = 2754,
  [2896] = 2751,
  [2897] = 2687,
  [2898] = 2722,
  [2899] = 1961,
  [2900] = 2765,
  [2901] = 2720,
  [2902] = 2548,
  [2903] = 2826,
  [2904] = 247,
  [2905] = 2674,
  [2906] = 2906,
  [2907] = 2675,
  [2908] = 2706,
  [2909] = 2705,
  [2910] = 2679,
  [2911] = 2685,
  [2912] = 2683,
  [2913] = 2679,
  [2914] = 2676,
  [2915] = 2560,
  [2916] = 2677,
  [2917] = 2917,
  [2918] = 2678,
  [2919] = 2687,
  [2920] = 2854,
  [2921] = 2712,
  [2922] = 2677,
  [2923] = 2676,
  [2924] = 2675,
  [2925] = 2674,
  [2926] = 2852,
  [2927] = 2927,
  [2928] = 2692,
  [2929] = 2701,
  [2930] = 237,
  [2931] = 2693,
  [2932] = 2694,
  [2933] = 2933,
  [2934] = 2711,
  [2935] = 2703,
  [2936] = 2681,
  [2937] = 2726,
  [2938] = 2711,
  [2939] = 2682,
  [2940] = 2701,
  [2941] = 2849,
  [2942] = 2687,
  [2943] = 2684,
  [2944] = 2703,
  [2945] = 2945,
  [2946] = 2686,
  [2947] = 2679,
  [2948] = 2948,
  [2949] = 2949,
  [2950] = 2694,
  [2951] = 2693,
  [2952] = 2952,
  [2953] = 2953,
  [2954] = 2692,
  [2955] = 2955,
  [2956] = 2956,
  [2957] = 2957,
  [2958] = 2958,
  [2959] = 2677,
  [2960] = 2676,
  [2961] = 2674,
  [2962] = 2675,
  [2963] = 2675,
  [2964] = 2964,
  [2965] = 2676,
  [2966] = 2677,
  [2967] = 2967,
  [2968] = 2681,
  [2969] = 2969,
  [2970] = 2674,
  [2971] = 2692,
  [2972] = 2693,
  [2973] = 2694,
  [2974] = 2703,
  [2975] = 2725,
  [2976] = 2711,
  [2977] = 2830,
  [2978] = 2831,
  [2979] = 2979,
  [2980] = 2980,
  [2981] = 2718,
  [2982] = 2982,
  [2983] = 2701,
  [2984] = 2724,
  [2985] = 2704,
  [2986] = 2687,
  [2987] = 2739,
  [2988] = 2707,
  [2989] = 2741,
  [2990] = 2679,
  [2991] = 2991,
  [2992] = 2744,
  [2993] = 2718,
  [2994] = 2746,
  [2995] = 2723,
  [2996] = 2765,
  [2997] = 2997,
  [2998] = 2677,
  [2999] = 2999,
  [3000] = 2676,
  [3001] = 2765,
  [3002] = 2731,
  [3003] = 2675,
  [3004] = 3004,
  [3005] = 3005,
  [3006] = 2741,
  [3007] = 3007,
  [3008] = 3008,
  [3009] = 2711,
  [3010] = 2755,
  [3011] = 2679,
  [3012] = 2674,
  [3013] = 2739,
  [3014] = 2753,
  [3015] = 2734,
  [3016] = 2694,
  [3017] = 2687,
  [3018] = 2693,
  [3019] = 3019,
  [3020] = 2746,
  [3021] = 2732,
  [3022] = 2836,
  [3023] = 2744,
  [3024] = 2703,
  [3025] = 2701,
  [3026] = 2692,
  [3027] = 3027,
  [3028] = 314,
  [3029] = 1975,
  [3030] = 3030,
  [3031] = 3031,
  [3032] = 3032,
  [3033] = 3033,
  [3034] = 3034,
  [3035] = 3035,
  [3036] = 3036,
  [3037] = 3037,
  [3038] = 3038,
  [3039] = 3039,
  [3040] = 3040,
  [3041] = 3041,
  [3042] = 3042,
  [3043] = 3043,
  [3044] = 3044,
  [3045] = 3045,
  [3046] = 3046,
  [3047] = 3047,
  [3048] = 3048,
  [3049] = 3049,
  [3050] = 3050,
  [3051] = 3051,
  [3052] = 3052,
  [3053] = 2906,
  [3054] = 2474,
  [3055] = 3055,
  [3056] = 3056,
  [3057] = 3057,
  [3058] = 3058,
  [3059] = 3059,
  [3060] = 3060,
  [3061] = 3055,
  [3062] = 3062,
  [3063] = 3059,
  [3064] = 3064,
  [3065] = 3065,
  [3066] = 3066,
  [3067] = 3057,
  [3068] = 3040,
  [3069] = 3069,
  [3070] = 3070,
  [3071] = 3071,
  [3072] = 3070,
  [3073] = 3032,
  [3074] = 3042,
  [3075] = 3051,
  [3076] = 3040,
  [3077] = 3047,
  [3078] = 3035,
  [3079] = 3050,
  [3080] = 3080,
  [3081] = 3033,
  [3082] = 247,
  [3083] = 237,
  [3084] = 238,
  [3085] = 3059,
  [3086] = 240,
  [3087] = 3087,
  [3088] = 241,
  [3089] = 3089,
  [3090] = 3090,
  [3091] = 3046,
  [3092] = 3080,
  [3093] = 314,
  [3094] = 2474,
  [3095] = 314,
  [3096] = 3046,
  [3097] = 3097,
  [3098] = 3098,
  [3099] = 3037,
  [3100] = 3043,
  [3101] = 3101,
  [3102] = 3102,
  [3103] = 3043,
  [3104] = 3104,
  [3105] = 3105,
  [3106] = 3106,
  [3107] = 3107,
  [3108] = 3108,
  [3109] = 3109,
  [3110] = 3110,
  [3111] = 3111,
  [3112] = 3112,
  [3113] = 3110,
  [3114] = 3114,
  [3115] = 3108,
  [3116] = 3116,
  [3117] = 3117,
  [3118] = 3118,
  [3119] = 3119,
  [3120] = 3120,
  [3121] = 3102,
  [3122] = 3122,
  [3123] = 1994,
  [3124] = 3124,
  [3125] = 3125,
  [3126] = 1961,
  [3127] = 3069,
  [3128] = 3036,
  [3129] = 3129,
  [3130] = 3130,
  [3131] = 3066,
  [3132] = 3132,
  [3133] = 1975,
  [3134] = 3134,
  [3135] = 3135,
  [3136] = 3041,
  [3137] = 3135,
  [3138] = 3138,
  [3139] = 3043,
  [3140] = 3046,
  [3141] = 3138,
  [3142] = 3129,
  [3143] = 3102,
  [3144] = 3108,
  [3145] = 3110,
  [3146] = 2789,
  [3147] = 3059,
  [3148] = 2787,
  [3149] = 3040,
  [3150] = 1992,
  [3151] = 3151,
  [3152] = 3152,
  [3153] = 1994,
  [3154] = 2474,
  [3155] = 3155,
  [3156] = 3052,
  [3157] = 3049,
  [3158] = 3062,
  [3159] = 1992,
  [3160] = 3160,
  [3161] = 3161,
  [3162] = 3162,
  [3163] = 3163,
  [3164] = 3164,
  [3165] = 3165,
  [3166] = 3166,
  [3167] = 3167,
  [3168] = 3168,
  [3169] = 3169,
  [3170] = 3170,
  [3171] = 3171,
  [3172] = 3172,
  [3173] = 3173,
  [3174] = 3174,
  [3175] = 3175,
  [3176] = 3176,
  [3177] = 3177,
  [3178] = 3162,
  [3179] = 3179,
  [3180] = 3180,
  [3181] = 3181,
  [3182] = 3182,
  [3183] = 3183,
  [3184] = 3184,
  [3185] = 3184,
  [3186] = 3186,
  [3187] = 3187,
  [3188] = 3188,
  [3189] = 3162,
  [3190] = 3190,
  [3191] = 3191,
  [3192] = 3166,
  [3193] = 3193,
  [3194] = 3194,
  [3195] = 3195,
  [3196] = 3165,
  [3197] = 3164,
  [3198] = 3198,
  [3199] = 3199,
  [3200] = 3180,
  [3201] = 3184,
  [3202] = 3199,
  [3203] = 3203,
  [3204] = 3186,
  [3205] = 3205,
  [3206] = 3203,
  [3207] = 3194,
  [3208] = 3191,
  [3209] = 3209,
  [3210] = 3210,
  [3211] = 3187,
  [3212] = 3212,
  [3213] = 3199,
  [3214] = 3214,
  [3215] = 3215,
  [3216] = 3216,
  [3217] = 3180,
  [3218] = 3203,
  [3219] = 3219,
  [3220] = 3164,
  [3221] = 3165,
  [3222] = 3222,
  [3223] = 3223,
  [3224] = 3193,
  [3225] = 3166,
  [3226] = 3187,
  [3227] = 3186,
  [3228] = 3162,
  [3229] = 3194,
  [3230] = 3230,
  [3231] = 3191,
  [3232] = 3191,
  [3233] = 3233,
  [3234] = 3234,
  [3235] = 3194,
  [3236] = 3184,
  [3237] = 3186,
  [3238] = 3223,
  [3239] = 3184,
  [3240] = 3240,
  [3241] = 3219,
  [3242] = 3203,
  [3243] = 3243,
  [3244] = 3244,
  [3245] = 3245,
  [3246] = 3166,
  [3247] = 3193,
  [3248] = 3216,
  [3249] = 3187,
  [3250] = 3165,
  [3251] = 3164,
  [3252] = 3252,
  [3253] = 3199,
  [3254] = 3180,
  [3255] = 3180,
  [3256] = 3199,
  [3257] = 3203,
  [3258] = 3186,
  [3259] = 3259,
  [3260] = 3164,
  [3261] = 3194,
  [3262] = 3191,
  [3263] = 3165,
  [3264] = 3264,
  [3265] = 3187,
  [3266] = 3266,
  [3267] = 3193,
  [3268] = 3170,
  [3269] = 3166,
  [3270] = 3168,
  [3271] = 3271,
  [3272] = 3272,
  [3273] = 3273,
  [3274] = 3170,
  [3275] = 3275,
  [3276] = 3276,
  [3277] = 3277,
  [3278] = 3162,
  [3279] = 3279,
  [3280] = 3280,
  [3281] = 3182,
  [3282] = 3282,
  [3283] = 3222,
  [3284] = 3187,
  [3285] = 3191,
  [3286] = 3184,
  [3287] = 3194,
  [3288] = 3180,
  [3289] = 3186,
  [3290] = 3219,
  [3291] = 3187,
  [3292] = 3273,
  [3293] = 3203,
  [3294] = 3199,
  [3295] = 3180,
  [3296] = 3296,
  [3297] = 3297,
  [3298] = 3164,
  [3299] = 3299,
  [3300] = 3180,
  [3301] = 3152,
  [3302] = 3165,
  [3303] = 3303,
  [3304] = 3304,
  [3305] = 3193,
  [3306] = 3184,
  [3307] = 3182,
  [3308] = 3308,
  [3309] = 3309,
  [3310] = 3310,
  [3311] = 3311,
  [3312] = 3212,
  [3313] = 3166,
  [3314] = 3314,
  [3315] = 3162,
  [3316] = 3316,
  [3317] = 3317,
  [3318] = 3318,
  [3319] = 3191,
  [3320] = 3194,
  [3321] = 3321,
  [3322] = 3162,
  [3323] = 3186,
  [3324] = 3324,
  [3325] = 3325,
  [3326] = 3215,
  [3327] = 3223,
  [3328] = 3219,
  [3329] = 3329,
  [3330] = 3168,
  [3331] = 3331,
  [3332] = 3193,
  [3333] = 3166,
  [3334] = 3324,
  [3335] = 3299,
  [3336] = 3193,
  [3337] = 3264,
  [3338] = 3338,
  [3339] = 3245,
  [3340] = 3165,
  [3341] = 3341,
  [3342] = 3244,
  [3343] = 3343,
  [3344] = 3230,
  [3345] = 3329,
  [3346] = 3164,
  [3347] = 3169,
  [3348] = 3167,
  [3349] = 3309,
  [3350] = 3350,
  [3351] = 3351,
  [3352] = 3352,
  [3353] = 3212,
  [3354] = 3354,
  [3355] = 3271,
  [3356] = 3168,
  [3357] = 3203,
  [3358] = 3180,
  [3359] = 3199,
  [3360] = 3351,
  [3361] = 3216,
  [3362] = 3362,
  [3363] = 3363,
  [3364] = 3212,
  [3365] = 3365,
  [3366] = 3203,
  [3367] = 3367,
  [3368] = 3363,
  [3369] = 3216,
  [3370] = 3314,
  [3371] = 3371,
  [3372] = 3219,
  [3373] = 3264,
  [3374] = 3223,
  [3375] = 3169,
  [3376] = 3376,
  [3377] = 3351,
  [3378] = 3199,
  [3379] = 3180,
  [3380] = 3316,
  [3381] = 3325,
  [3382] = 3354,
  [3383] = 3343,
  [3384] = 3352,
  [3385] = 3341,
  [3386] = 3338,
  [3387] = 3317,
  [3388] = 3388,
  [3389] = 3389,
  [3390] = 3187,
  [3391] = 3391,
  [3392] = 3392,
  [3393] = 3164,
  [3394] = 3186,
  [3395] = 3191,
  [3396] = 3165,
  [3397] = 3194,
  [3398] = 3193,
  [3399] = 3166,
  [3400] = 3194,
  [3401] = 3170,
  [3402] = 3191,
  [3403] = 3186,
  [3404] = 3321,
  [3405] = 3405,
  [3406] = 3187,
  [3407] = 3407,
  [3408] = 3219,
  [3409] = 3203,
  [3410] = 3216,
  [3411] = 3162,
  [3412] = 3199,
  [3413] = 3282,
  [3414] = 3182,
  [3415] = 3180,
  [3416] = 3416,
  [3417] = 3417,
  [3418] = 3418,
  [3419] = 3419,
  [3420] = 3164,
  [3421] = 3421,
  [3422] = 3165,
  [3423] = 3423,
  [3424] = 3424,
  [3425] = 3193,
  [3426] = 3166,
  [3427] = 3184,
  [3428] = 3176,
  [3429] = 3168,
  [3430] = 3430,
  [3431] = 3419,
  [3432] = 3195,
  [3433] = 3433,
  [3434] = 3434,
  [3435] = 3162,
  [3436] = 3311,
  [3437] = 3310,
  [3438] = 3163,
  [3439] = 3308,
  [3440] = 3418,
  [3441] = 3441,
  [3442] = 3442,
  [3443] = 3443,
  [3444] = 3443,
  [3445] = 3433,
  [3446] = 3407,
  [3447] = 3177,
  [3448] = 3405,
  [3449] = 3376,
  [3450] = 3362,
  [3451] = 3190,
  [3452] = 3350,
  [3453] = 3416,
  [3454] = 3362,
  [3455] = 3182,
  [3456] = 3184,
};

static inline bool sym_identifier_character_set_1(int32_t c) {
  return (c < 43514
    ? (c < 4193
      ? (c < 2707
        ? (c < 1994
          ? (c < 931
            ? (c < 748
              ? (c < 192
                ? (c < 170
                  ? (c < 'a'
                    ? (c >= 'A' && c <= '_')
                    : c <= 'z')
                  : (c <= 170 || (c < 186
                    ? c == 181
                    : c <= 186)))
                : (c <= 214 || (c < 710
                  ? (c < 248
                    ? (c >= 216 && c <= 246)
                    : c <= 705)
                  : (c <= 721 || (c >= 736 && c <= 740)))))
              : (c <= 748 || (c < 895
                ? (c < 886
                  ? (c < 880
                    ? c == 750
                    : c <= 884)
                  : (c <= 887 || (c >= 891 && c <= 893)))
                : (c <= 895 || (c < 908
                  ? (c < 904
                    ? c == 902
                    : c <= 906)
                  : (c <= 908 || (c >= 910 && c <= 929)))))))
            : (c <= 1013 || (c < 1649
              ? (c < 1376
                ? (c < 1329
                  ? (c < 1162
                    ? (c >= 1015 && c <= 1153)
                    : c <= 1327)
                  : (c <= 1366 || c == 1369))
                : (c <= 1416 || (c < 1568
                  ? (c < 1519
                    ? (c >= 1488 && c <= 1514)
                    : c <= 1522)
                  : (c <= 1610 || (c >= 1646 && c <= 1647)))))
              : (c <= 1747 || (c < 1791
                ? (c < 1774
                  ? (c < 1765
                    ? c == 1749
                    : c <= 1766)
                  : (c <= 1775 || (c >= 1786 && c <= 1788)))
                : (c <= 1791 || (c < 1869
                  ? (c < 1810
                    ? c == 1808
                    : c <= 1839)
                  : (c <= 1957 || c == 1969))))))))
          : (c <= 2026 || (c < 2482
            ? (c < 2208
              ? (c < 2088
                ? (c < 2048
                  ? (c < 2042
                    ? (c >= 2036 && c <= 2037)
                    : c <= 2042)
                  : (c <= 2069 || (c < 2084
                    ? c == 2074
                    : c <= 2084)))
                : (c <= 2088 || (c < 2160
                  ? (c < 2144
                    ? (c >= 2112 && c <= 2136)
                    : c <= 2154)
                  : (c <= 2183 || (c >= 2185 && c <= 2190)))))
              : (c <= 2249 || (c < 2417
                ? (c < 2384
                  ? (c < 2365
                    ? (c >= 2308 && c <= 2361)
                    : c <= 2365)
                  : (c <= 2384 || (c >= 2392 && c <= 2401)))
                : (c <= 2432 || (c < 2451
                  ? (c < 2447
                    ? (c >= 2437 && c <= 2444)
                    : c <= 2448)
                  : (c <= 2472 || (c >= 2474 && c <= 2480)))))))
            : (c <= 2482 || (c < 2579
              ? (c < 2527
                ? (c < 2510
                  ? (c < 2493
                    ? (c >= 2486 && c <= 2489)
                    : c <= 2493)
                  : (c <= 2510 || (c >= 2524 && c <= 2525)))
                : (c <= 2529 || (c < 2565
                  ? (c < 2556
                    ? (c >= 2544 && c <= 2545)
                    : c <= 2556)
                  : (c <= 2570 || (c >= 2575 && c <= 2576)))))
              : (c <= 2600 || (c < 2649
                ? (c < 2613
                  ? (c < 2610
                    ? (c >= 2602 && c <= 2608)
                    : c <= 2611)
                  : (c <= 2614 || (c >= 2616 && c <= 2617)))
                : (c <= 2652 || (c < 2693
                  ? (c < 2674
                    ? c == 2654
                    : c <= 2676)
                  : (c <= 2701 || (c >= 2703 && c <= 2705)))))))))))
        : (c <= 2728 || (c < 3242
          ? (c < 2962
            ? (c < 2858
              ? (c < 2784
                ? (c < 2741
                  ? (c < 2738
                    ? (c >= 2730 && c <= 2736)
                    : c <= 2739)
                  : (c <= 2745 || (c < 2768
                    ? c == 2749
                    : c <= 2768)))
                : (c <= 2785 || (c < 2831
                  ? (c < 2821
                    ? c == 2809
                    : c <= 2828)
                  : (c <= 2832 || (c >= 2835 && c <= 2856)))))
              : (c <= 2864 || (c < 2911
                ? (c < 2877
                  ? (c < 2869
                    ? (c >= 2866 && c <= 2867)
                    : c <= 2873)
                  : (c <= 2877 || (c >= 2908 && c <= 2909)))
                : (c <= 2913 || (c < 2949
                  ? (c < 2947
                    ? c == 2929
                    : c <= 2947)
                  : (c <= 2954 || (c >= 2958 && c <= 2960)))))))
            : (c <= 2965 || (c < 3090
              ? (c < 2984
                ? (c < 2974
                  ? (c < 2972
                    ? (c >= 2969 && c <= 2970)
                    : c <= 2972)
                  : (c <= 2975 || (c >= 2979 && c <= 2980)))
                : (c <= 2986 || (c < 3077
                  ? (c < 3024
                    ? (c >= 2990 && c <= 3001)
                    : c <= 3024)
                  : (c <= 3084 || (c >= 3086 && c <= 3088)))))
              : (c <= 3112 || (c < 3168
                ? (c < 3160
                  ? (c < 3133
                    ? (c >= 3114 && c <= 3129)
                    : c <= 3133)
                  : (c <= 3162 || c == 3165))
                : (c <= 3169 || (c < 3214
                  ? (c < 3205
                    ? c == 3200
                    : c <= 3212)
                  : (c <= 3216 || (c >= 3218 && c <= 3240)))))))))
          : (c <= 3251 || (c < 3648
            ? (c < 3412
              ? (c < 3332
                ? (c < 3293
                  ? (c < 3261
                    ? (c >= 3253 && c <= 3257)
                    : c <= 3261)
                  : (c <= 3294 || (c < 3313
                    ? (c >= 3296 && c <= 3297)
                    : c <= 3314)))
                : (c <= 3340 || (c < 3389
                  ? (c < 3346
                    ? (c >= 3342 && c <= 3344)
                    : c <= 3386)
                  : (c <= 3389 || c == 3406))))
              : (c <= 3414 || (c < 3507
                ? (c < 3461
                  ? (c < 3450
                    ? (c >= 3423 && c <= 3425)
                    : c <= 3455)
                  : (c <= 3478 || (c >= 3482 && c <= 3505)))
                : (c <= 3515 || (c < 3585
                  ? (c < 3520
                    ? c == 3517
                    : c <= 3526)
                  : (c <= 3632 || c == 3634))))))
            : (c <= 3654 || (c < 3782
              ? (c < 3749
                ? (c < 3718
                  ? (c < 3716
                    ? (c >= 3713 && c <= 3714)
                    : c <= 3716)
                  : (c <= 3722 || (c >= 3724 && c <= 3747)))
                : (c <= 3749 || (c < 3773
                  ? (c < 3762
                    ? (c >= 3751 && c <= 3760)
                    : c <= 3762)
                  : (c <= 3773 || (c >= 3776 && c <= 3780)))))
              : (c <= 3782 || (c < 3976
                ? (c < 3904
                  ? (c < 3840
                    ? (c >= 3804 && c <= 3807)
                    : c <= 3840)
                  : (c <= 3911 || (c >= 3913 && c <= 3948)))
                : (c <= 3980 || (c < 4176
                  ? (c < 4159
                    ? (c >= 4096 && c <= 4138)
                    : c <= 4159)
                  : (c <= 4181 || (c >= 4186 && c <= 4189)))))))))))))
      : (c <= 4193 || (c < 8134
        ? (c < 6176
          ? (c < 4808
            ? (c < 4688
              ? (c < 4295
                ? (c < 4213
                  ? (c < 4206
                    ? (c >= 4197 && c <= 4198)
                    : c <= 4208)
                  : (c <= 4225 || (c < 4256
                    ? c == 4238
                    : c <= 4293)))
                : (c <= 4295 || (c < 4348
                  ? (c < 4304
                    ? c == 4301
                    : c <= 4346)
                  : (c <= 4680 || (c >= 4682 && c <= 4685)))))
              : (c <= 4694 || (c < 4752
                ? (c < 4704
                  ? (c < 4698
                    ? c == 4696
                    : c <= 4701)
                  : (c <= 4744 || (c >= 4746 && c <= 4749)))
                : (c <= 4784 || (c < 4800
                  ? (c < 4792
                    ? (c >= 4786 && c <= 4789)
                    : c <= 4798)
                  : (c <= 4800 || (c >= 4802 && c <= 4805)))))))
            : (c <= 4822 || (c < 5792
              ? (c < 5024
                ? (c < 4888
                  ? (c < 4882
                    ? (c >= 4824 && c <= 4880)
                    : c <= 4885)
                  : (c <= 4954 || (c >= 4992 && c <= 5007)))
                : (c <= 5109 || (c < 5743
                  ? (c < 5121
                    ? (c >= 5112 && c <= 5117)
                    : c <= 5740)
                  : (c <= 5759 || (c >= 5761 && c <= 5786)))))
              : (c <= 5866 || (c < 5984
                ? (c < 5919
                  ? (c < 5888
                    ? (c >= 5870 && c <= 5880)
                    : c <= 5905)
                  : (c <= 5937 || (c >= 5952 && c <= 5969)))
                : (c <= 5996 || (c < 6103
                  ? (c < 6016
                    ? (c >= 5998 && c <= 6000)
                    : c <= 6067)
                  : (c <= 6103 || c == 6108))))))))
          : (c <= 6264 || (c < 7312
            ? (c < 6823
              ? (c < 6512
                ? (c < 6320
                  ? (c < 6314
                    ? (c >= 6272 && c <= 6312)
                    : c <= 6314)
                  : (c <= 6389 || (c < 6480
                    ? (c >= 6400 && c <= 6430)
                    : c <= 6509)))
                : (c <= 6516 || (c < 6656
                  ? (c < 6576
                    ? (c >= 6528 && c <= 6571)
                    : c <= 6601)
                  : (c <= 6678 || (c >= 6688 && c <= 6740)))))
              : (c <= 6823 || (c < 7098
                ? (c < 7043
                  ? (c < 6981
                    ? (c >= 6917 && c <= 6963)
                    : c <= 6988)
                  : (c <= 7072 || (c >= 7086 && c <= 7087)))
                : (c <= 7141 || (c < 7258
                  ? (c < 7245
                    ? (c >= 7168 && c <= 7203)
                    : c <= 7247)
                  : (c <= 7293 || (c >= 7296 && c <= 7304)))))))
            : (c <= 7354 || (c < 8008
              ? (c < 7418
                ? (c < 7406
                  ? (c < 7401
                    ? (c >= 7357 && c <= 7359)
                    : c <= 7404)
                  : (c <= 7411 || (c >= 7413 && c <= 7414)))
                : (c <= 7418 || (c < 7960
                  ? (c < 7680
                    ? (c >= 7424 && c <= 7615)
                    : c <= 7957)
                  : (c <= 7965 || (c >= 7968 && c <= 8005)))))
              : (c <= 8013 || (c < 8031
                ? (c < 8027
                  ? (c < 8025
                    ? (c >= 8016 && c <= 8023)
                    : c <= 8025)
                  : (c <= 8027 || c == 8029))
                : (c <= 8061 || (c < 8126
                  ? (c < 8118
                    ? (c >= 8064 && c <= 8116)
                    : c <= 8124)
                  : (c <= 8126 || (c >= 8130 && c <= 8132)))))))))))
        : (c <= 8140 || (c < 12337
          ? (c < 8544
            ? (c < 8458
              ? (c < 8305
                ? (c < 8160
                  ? (c < 8150
                    ? (c >= 8144 && c <= 8147)
                    : c <= 8155)
                  : (c <= 8172 || (c < 8182
                    ? (c >= 8178 && c <= 8180)
                    : c <= 8188)))
                : (c <= 8305 || (c < 8450
                  ? (c < 8336
                    ? c == 8319
                    : c <= 8348)
                  : (c <= 8450 || c == 8455))))
              : (c <= 8467 || (c < 8488
                ? (c < 8484
                  ? (c < 8472
                    ? c == 8469
                    : c <= 8477)
                  : (c <= 8484 || c == 8486))
                : (c <= 8488 || (c < 8517
                  ? (c < 8508
                    ? (c >= 8490 && c <= 8505)
                    : c <= 8511)
                  : (c <= 8521 || c == 8526))))))
            : (c <= 8584 || (c < 11680
              ? (c < 11559
                ? (c < 11506
                  ? (c < 11499
                    ? (c >= 11264 && c <= 11492)
                    : c <= 11502)
                  : (c <= 11507 || (c >= 11520 && c <= 11557)))
                : (c <= 11559 || (c < 11631
                  ? (c < 11568
                    ? c == 11565
                    : c <= 11623)
                  : (c <= 11631 || (c >= 11648 && c <= 11670)))))
              : (c <= 11686 || (c < 11720
                ? (c < 11704
                  ? (c < 11696
                    ? (c >= 11688 && c <= 11694)
                    : c <= 11702)
                  : (c <= 11710 || (c >= 11712 && c <= 11718)))
                : (c <= 11726 || (c < 12293
                  ? (c < 11736
                    ? (c >= 11728 && c <= 11734)
                    : c <= 11742)
                  : (c <= 12295 || (c >= 12321 && c <= 12329)))))))))
          : (c <= 12341 || (c < 42891
            ? (c < 19968
              ? (c < 12549
                ? (c < 12445
                  ? (c < 12353
                    ? (c >= 12344 && c <= 12348)
                    : c <= 12438)
                  : (c <= 12447 || (c < 12540
                    ? (c >= 12449 && c <= 12538)
                    : c <= 12543)))
                : (c <= 12591 || (c < 12784
                  ? (c < 12704
                    ? (c >= 12593 && c <= 12686)
                    : c <= 12735)
                  : (c <= 12799 || (c >= 13312 && c <= 19903)))))
              : (c <= 42124 || (c < 42560
                ? (c < 42512
                  ? (c < 42240
                    ? (c >= 42192 && c <= 42237)
                    : c <= 42508)
                  : (c <= 42527 || (c >= 42538 && c <= 42539)))
                : (c <= 42606 || (c < 42775
                  ? (c < 42656
                    ? (c >= 42623 && c <= 42653)
                    : c <= 42735)
                  : (c <= 42783 || (c >= 42786 && c <= 42888)))))))
            : (c <= 42954 || (c < 43250
              ? (c < 43011
                ? (c < 42965
                  ? (c < 42963
                    ? (c >= 42960 && c <= 42961)
                    : c <= 42963)
                  : (c <= 42969 || (c >= 42994 && c <= 43009)))
                : (c <= 43013 || (c < 43072
                  ? (c < 43020
                    ? (c >= 43015 && c <= 43018)
                    : c <= 43042)
                  : (c <= 43123 || (c >= 43138 && c <= 43187)))))
              : (c <= 43255 || (c < 43360
                ? (c < 43274
                  ? (c < 43261
                    ? c == 43259
                    : c <= 43262)
                  : (c <= 43301 || (c >= 43312 && c <= 43334)))
                : (c <= 43388 || (c < 43488
                  ? (c < 43471
                    ? (c >= 43396 && c <= 43442)
                    : c <= 43471)
                  : (c <= 43492 || (c >= 43494 && c <= 43503)))))))))))))))
    : (c <= 43518 || (c < 70727
      ? (c < 66956
        ? (c < 64914
          ? (c < 43868
            ? (c < 43714
              ? (c < 43646
                ? (c < 43588
                  ? (c < 43584
                    ? (c >= 43520 && c <= 43560)
                    : c <= 43586)
                  : (c <= 43595 || (c < 43642
                    ? (c >= 43616 && c <= 43638)
                    : c <= 43642)))
                : (c <= 43695 || (c < 43705
                  ? (c < 43701
                    ? c == 43697
                    : c <= 43702)
                  : (c <= 43709 || c == 43712))))
              : (c <= 43714 || (c < 43785
                ? (c < 43762
                  ? (c < 43744
                    ? (c >= 43739 && c <= 43741)
                    : c <= 43754)
                  : (c <= 43764 || (c >= 43777 && c <= 43782)))
                : (c <= 43790 || (c < 43816
                  ? (c < 43808
                    ? (c >= 43793 && c <= 43798)
                    : c <= 43814)
                  : (c <= 43822 || (c >= 43824 && c <= 43866)))))))
            : (c <= 43881 || (c < 64287
              ? (c < 63744
                ? (c < 55216
                  ? (c < 44032
                    ? (c >= 43888 && c <= 44002)
                    : c <= 55203)
                  : (c <= 55238 || (c >= 55243 && c <= 55291)))
                : (c <= 64109 || (c < 64275
                  ? (c < 64256
                    ? (c >= 64112 && c <= 64217)
                    : c <= 64262)
                  : (c <= 64279 || c == 64285))))
              : (c <= 64296 || (c < 64323
                ? (c < 64318
                  ? (c < 64312
                    ? (c >= 64298 && c <= 64310)
                    : c <= 64316)
                  : (c <= 64318 || (c >= 64320 && c <= 64321)))
                : (c <= 64324 || (c < 64612
                  ? (c < 64467
                    ? (c >= 64326 && c <= 64433)
                    : c <= 64605)
                  : (c <= 64829 || (c >= 64848 && c <= 64911)))))))))
          : (c <= 64967 || (c < 65599
            ? (c < 65382
              ? (c < 65147
                ? (c < 65139
                  ? (c < 65137
                    ? (c >= 65008 && c <= 65017)
                    : c <= 65137)
                  : (c <= 65139 || (c < 65145
                    ? c == 65143
                    : c <= 65145)))
                : (c <= 65147 || (c < 65313
                  ? (c < 65151
                    ? c == 65149
                    : c <= 65276)
                  : (c <= 65338 || (c >= 65345 && c <= 65370)))))
              : (c <= 65437 || (c < 65498
                ? (c < 65482
                  ? (c < 65474
                    ? (c >= 65440 && c <= 65470)
                    : c <= 65479)
                  : (c <= 65487 || (c >= 65490 && c <= 65495)))
                : (c <= 65500 || (c < 65576
                  ? (c < 65549
                    ? (c >= 65536 && c <= 65547)
                    : c <= 65574)
                  : (c <= 65594 || (c >= 65596 && c <= 65597)))))))
            : (c <= 65613 || (c < 66464
              ? (c < 66208
                ? (c < 65856
                  ? (c < 65664
                    ? (c >= 65616 && c <= 65629)
                    : c <= 65786)
                  : (c <= 65908 || (c >= 66176 && c <= 66204)))
                : (c <= 66256 || (c < 66384
                  ? (c < 66349
                    ? (c >= 66304 && c <= 66335)
                    : c <= 66378)
                  : (c <= 66421 || (c >= 66432 && c <= 66461)))))
              : (c <= 66499 || (c < 66776
                ? (c < 66560
                  ? (c < 66513
                    ? (c >= 66504 && c <= 66511)
                    : c <= 66517)
                  : (c <= 66717 || (c >= 66736 && c <= 66771)))
                : (c <= 66811 || (c < 66928
                  ? (c < 66864
                    ? (c >= 66816 && c <= 66855)
                    : c <= 66915)
                  : (c <= 66938 || (c >= 66940 && c <= 66954)))))))))))
        : (c <= 66962 || (c < 68864
          ? (c < 67828
            ? (c < 67506
              ? (c < 67072
                ? (c < 66979
                  ? (c < 66967
                    ? (c >= 66964 && c <= 66965)
                    : c <= 66977)
                  : (c <= 66993 || (c < 67003
                    ? (c >= 66995 && c <= 67001)
                    : c <= 67004)))
                : (c <= 67382 || (c < 67456
                  ? (c < 67424
                    ? (c >= 67392 && c <= 67413)
                    : c <= 67431)
                  : (c <= 67461 || (c >= 67463 && c <= 67504)))))
              : (c <= 67514 || (c < 67644
                ? (c < 67594
                  ? (c < 67592
                    ? (c >= 67584 && c <= 67589)
                    : c <= 67592)
                  : (c <= 67637 || (c >= 67639 && c <= 67640)))
                : (c <= 67644 || (c < 67712
                  ? (c < 67680
                    ? (c >= 67647 && c <= 67669)
                    : c <= 67702)
                  : (c <= 67742 || (c >= 67808 && c <= 67826)))))))
            : (c <= 67829 || (c < 68224
              ? (c < 68096
                ? (c < 67968
                  ? (c < 67872
                    ? (c >= 67840 && c <= 67861)
                    : c <= 67897)
                  : (c <= 68023 || (c >= 68030 && c <= 68031)))
                : (c <= 68096 || (c < 68121
                  ? (c < 68117
                    ? (c >= 68112 && c <= 68115)
                    : c <= 68119)
                  : (c <= 68149 || (c >= 68192 && c <= 68220)))))
              : (c <= 68252 || (c < 68448
                ? (c < 68352
                  ? (c < 68297
                    ? (c >= 68288 && c <= 68295)
                    : c <= 68324)
                  : (c <= 68405 || (c >= 68416 && c <= 68437)))
                : (c <= 68466 || (c < 68736
                  ? (c < 68608
                    ? (c >= 68480 && c <= 68497)
                    : c <= 68680)
                  : (c <= 68786 || (c >= 68800 && c <= 68850)))))))))
          : (c <= 68899 || (c < 70106
            ? (c < 69749
              ? (c < 69488
                ? (c < 69376
                  ? (c < 69296
                    ? (c >= 69248 && c <= 69289)
                    : c <= 69297)
                  : (c <= 69404 || (c < 69424
                    ? c == 69415
                    : c <= 69445)))
                : (c <= 69505 || (c < 69635
                  ? (c < 69600
                    ? (c >= 69552 && c <= 69572)
                    : c <= 69622)
                  : (c <= 69687 || (c >= 69745 && c <= 69746)))))
              : (c <= 69749 || (c < 69959
                ? (c < 69891
                  ? (c < 69840
                    ? (c >= 69763 && c <= 69807)
                    : c <= 69864)
                  : (c <= 69926 || c == 69956))
                : (c <= 69959 || (c < 70019
                  ? (c < 70006
                    ? (c >= 69968 && c <= 70002)
                    : c <= 70006)
                  : (c <= 70066 || (c >= 70081 && c <= 70084)))))))
            : (c <= 70106 || (c < 70405
              ? (c < 70280
                ? (c < 70163
                  ? (c < 70144
                    ? c == 70108
                    : c <= 70161)
                  : (c <= 70187 || (c >= 70272 && c <= 70278)))
                : (c <= 70280 || (c < 70303
                  ? (c < 70287
                    ? (c >= 70282 && c <= 70285)
                    : c <= 70301)
                  : (c <= 70312 || (c >= 70320 && c <= 70366)))))
              : (c <= 70412 || (c < 70453
                ? (c < 70442
                  ? (c < 70419
                    ? (c >= 70415 && c <= 70416)
                    : c <= 70440)
                  : (c <= 70448 || (c >= 70450 && c <= 70451)))
                : (c <= 70457 || (c < 70493
                  ? (c < 70480
                    ? c == 70461
                    : c <= 70480)
                  : (c <= 70497 || (c >= 70656 && c <= 70708)))))))))))))
      : (c <= 70730 || (c < 119894
        ? (c < 73056
          ? (c < 72001
            ? (c < 71424
              ? (c < 71128
                ? (c < 70852
                  ? (c < 70784
                    ? (c >= 70751 && c <= 70753)
                    : c <= 70831)
                  : (c <= 70853 || (c < 71040
                    ? c == 70855
                    : c <= 71086)))
                : (c <= 71131 || (c < 71296
                  ? (c < 71236
                    ? (c >= 71168 && c <= 71215)
                    : c <= 71236)
                  : (c <= 71338 || c == 71352))))
              : (c <= 71450 || (c < 71945
                ? (c < 71840
                  ? (c < 71680
                    ? (c >= 71488 && c <= 71494)
                    : c <= 71723)
                  : (c <= 71903 || (c >= 71935 && c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71983 || c == 71999))))))
            : (c <= 72001 || (c < 72349
              ? (c < 72192
                ? (c < 72161
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72144)
                  : (c <= 72161 || c == 72163))
                : (c <= 72192 || (c < 72272
                  ? (c < 72250
                    ? (c >= 72203 && c <= 72242)
                    : c <= 72250)
                  : (c <= 72272 || (c >= 72284 && c <= 72329)))))
              : (c <= 72349 || (c < 72818
                ? (c < 72714
                  ? (c < 72704
                    ? (c >= 72368 && c <= 72440)
                    : c <= 72712)
                  : (c <= 72750 || c == 72768))
                : (c <= 72847 || (c < 72971
                  ? (c < 72968
                    ? (c >= 72960 && c <= 72966)
                    : c <= 72969)
                  : (c <= 73008 || c == 73030))))))))
          : (c <= 73061 || (c < 93952
            ? (c < 82944
              ? (c < 73728
                ? (c < 73112
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73097)
                  : (c <= 73112 || (c < 73648
                    ? (c >= 73440 && c <= 73458)
                    : c <= 73648)))
                : (c <= 74649 || (c < 77712
                  ? (c < 74880
                    ? (c >= 74752 && c <= 74862)
                    : c <= 75075)
                  : (c <= 77808 || (c >= 77824 && c <= 78894)))))
              : (c <= 83526 || (c < 92928
                ? (c < 92784
                  ? (c < 92736
                    ? (c >= 92160 && c <= 92728)
                    : c <= 92766)
                  : (c <= 92862 || (c >= 92880 && c <= 92909)))
                : (c <= 92975 || (c < 93053
                  ? (c < 93027
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93047)
                  : (c <= 93071 || (c >= 93760 && c <= 93823)))))))
            : (c <= 94026 || (c < 110589
              ? (c < 94208
                ? (c < 94176
                  ? (c < 94099
                    ? c == 94032
                    : c <= 94111)
                  : (c <= 94177 || c == 94179))
                : (c <= 100343 || (c < 110576
                  ? (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)
                  : (c <= 110579 || (c >= 110581 && c <= 110587)))))
              : (c <= 110590 || (c < 113664
                ? (c < 110948
                  ? (c < 110928
                    ? (c >= 110592 && c <= 110882)
                    : c <= 110930)
                  : (c <= 110951 || (c >= 110960 && c <= 111355)))
                : (c <= 113770 || (c < 113808
                  ? (c < 113792
                    ? (c >= 113776 && c <= 113788)
                    : c <= 113800)
                  : (c <= 113817 || (c >= 119808 && c <= 119892)))))))))))
        : (c <= 119964 || (c < 125259
          ? (c < 120572
            ? (c < 120086
              ? (c < 119995
                ? (c < 119973
                  ? (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)
                  : (c <= 119974 || (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)))
                : (c <= 119995 || (c < 120071
                  ? (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)
                  : (c <= 120074 || (c >= 120077 && c <= 120084)))))
              : (c <= 120092 || (c < 120138
                ? (c < 120128
                  ? (c < 120123
                    ? (c >= 120094 && c <= 120121)
                    : c <= 120126)
                  : (c <= 120132 || c == 120134))
                : (c <= 120144 || (c < 120514
                  ? (c < 120488
                    ? (c >= 120146 && c <= 120485)
                    : c <= 120512)
                  : (c <= 120538 || (c >= 120540 && c <= 120570)))))))
            : (c <= 120596 || (c < 123191
              ? (c < 120714
                ? (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c >= 120688 && c <= 120712)))
                : (c <= 120744 || (c < 122624
                  ? (c < 120772
                    ? (c >= 120746 && c <= 120770)
                    : c <= 120779)
                  : (c <= 122654 || (c >= 123136 && c <= 123180)))))
              : (c <= 123197 || (c < 124904
                ? (c < 123584
                  ? (c < 123536
                    ? c == 123214
                    : c <= 123565)
                  : (c <= 123627 || (c >= 124896 && c <= 124902)))
                : (c <= 124907 || (c < 124928
                  ? (c < 124912
                    ? (c >= 124909 && c <= 124910)
                    : c <= 124926)
                  : (c <= 125124 || (c >= 125184 && c <= 125251)))))))))
          : (c <= 125259 || (c < 126559
            ? (c < 126535
              ? (c < 126505
                ? (c < 126497
                  ? (c < 126469
                    ? (c >= 126464 && c <= 126467)
                    : c <= 126495)
                  : (c <= 126498 || (c < 126503
                    ? c == 126500
                    : c <= 126503)))
                : (c <= 126514 || (c < 126523
                  ? (c < 126521
                    ? (c >= 126516 && c <= 126519)
                    : c <= 126521)
                  : (c <= 126523 || c == 126530))))
              : (c <= 126535 || (c < 126548
                ? (c < 126541
                  ? (c < 126539
                    ? c == 126537
                    : c <= 126539)
                  : (c <= 126543 || (c >= 126545 && c <= 126546)))
                : (c <= 126548 || (c < 126555
                  ? (c < 126553
                    ? c == 126551
                    : c <= 126553)
                  : (c <= 126555 || c == 126557))))))
            : (c <= 126559 || (c < 126625
              ? (c < 126580
                ? (c < 126567
                  ? (c < 126564
                    ? (c >= 126561 && c <= 126562)
                    : c <= 126564)
                  : (c <= 126570 || (c >= 126572 && c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c >= 126603 && c <= 126619)))))
              : (c <= 126627 || (c < 177984
                ? (c < 131072
                  ? (c < 126635
                    ? (c >= 126629 && c <= 126633)
                    : c <= 126651)
                  : (c <= 173791 || (c >= 173824 && c <= 177976)))
                : (c <= 178205 || (c < 194560
                  ? (c < 183984
                    ? (c >= 178208 && c <= 183969)
                    : c <= 191456)
                  : (c <= 195101 || (c >= 196608 && c <= 201546)))))))))))))))));
}

static inline bool sym_identifier_character_set_2(int32_t c) {
  return (c < 43514
    ? (c < 4193
      ? (c < 2707
        ? (c < 1994
          ? (c < 910
            ? (c < 736
              ? (c < 186
                ? (c < 'a'
                  ? (c < '_'
                    ? (c >= 'A' && c <= 'Z')
                    : c <= '_')
                  : (c <= 'z' || (c < 181
                    ? c == 170
                    : c <= 181)))
                : (c <= 186 || (c < 248
                  ? (c < 216
                    ? (c >= 192 && c <= 214)
                    : c <= 246)
                  : (c <= 705 || (c >= 710 && c <= 721)))))
              : (c <= 740 || (c < 891
                ? (c < 880
                  ? (c < 750
                    ? c == 748
                    : c <= 750)
                  : (c <= 884 || (c >= 886 && c <= 887)))
                : (c <= 893 || (c < 904
                  ? (c < 902
                    ? c == 895
                    : c <= 902)
                  : (c <= 906 || c == 908))))))
            : (c <= 929 || (c < 1649
              ? (c < 1376
                ? (c < 1162
                  ? (c < 1015
                    ? (c >= 931 && c <= 1013)
                    : c <= 1153)
                  : (c <= 1327 || (c < 1369
                    ? (c >= 1329 && c <= 1366)
                    : c <= 1369)))
                : (c <= 1416 || (c < 1568
                  ? (c < 1519
                    ? (c >= 1488 && c <= 1514)
                    : c <= 1522)
                  : (c <= 1610 || (c >= 1646 && c <= 1647)))))
              : (c <= 1747 || (c < 1791
                ? (c < 1774
                  ? (c < 1765
                    ? c == 1749
                    : c <= 1766)
                  : (c <= 1775 || (c >= 1786 && c <= 1788)))
                : (c <= 1791 || (c < 1869
                  ? (c < 1810
                    ? c == 1808
                    : c <= 1839)
                  : (c <= 1957 || c == 1969))))))))
          : (c <= 2026 || (c < 2482
            ? (c < 2208
              ? (c < 2088
                ? (c < 2048
                  ? (c < 2042
                    ? (c >= 2036 && c <= 2037)
                    : c <= 2042)
                  : (c <= 2069 || (c < 2084
                    ? c == 2074
                    : c <= 2084)))
                : (c <= 2088 || (c < 2160
                  ? (c < 2144
                    ? (c >= 2112 && c <= 2136)
                    : c <= 2154)
                  : (c <= 2183 || (c >= 2185 && c <= 2190)))))
              : (c <= 2249 || (c < 2417
                ? (c < 2384
                  ? (c < 2365
                    ? (c >= 2308 && c <= 2361)
                    : c <= 2365)
                  : (c <= 2384 || (c >= 2392 && c <= 2401)))
                : (c <= 2432 || (c < 2451
                  ? (c < 2447
                    ? (c >= 2437 && c <= 2444)
                    : c <= 2448)
                  : (c <= 2472 || (c >= 2474 && c <= 2480)))))))
            : (c <= 2482 || (c < 2579
              ? (c < 2527
                ? (c < 2510
                  ? (c < 2493
                    ? (c >= 2486 && c <= 2489)
                    : c <= 2493)
                  : (c <= 2510 || (c >= 2524 && c <= 2525)))
                : (c <= 2529 || (c < 2565
                  ? (c < 2556
                    ? (c >= 2544 && c <= 2545)
                    : c <= 2556)
                  : (c <= 2570 || (c >= 2575 && c <= 2576)))))
              : (c <= 2600 || (c < 2649
                ? (c < 2613
                  ? (c < 2610
                    ? (c >= 2602 && c <= 2608)
                    : c <= 2611)
                  : (c <= 2614 || (c >= 2616 && c <= 2617)))
                : (c <= 2652 || (c < 2693
                  ? (c < 2674
                    ? c == 2654
                    : c <= 2676)
                  : (c <= 2701 || (c >= 2703 && c <= 2705)))))))))))
        : (c <= 2728 || (c < 3242
          ? (c < 2962
            ? (c < 2858
              ? (c < 2784
                ? (c < 2741
                  ? (c < 2738
                    ? (c >= 2730 && c <= 2736)
                    : c <= 2739)
                  : (c <= 2745 || (c < 2768
                    ? c == 2749
                    : c <= 2768)))
                : (c <= 2785 || (c < 2831
                  ? (c < 2821
                    ? c == 2809
                    : c <= 2828)
                  : (c <= 2832 || (c >= 2835 && c <= 2856)))))
              : (c <= 2864 || (c < 2911
                ? (c < 2877
                  ? (c < 2869
                    ? (c >= 2866 && c <= 2867)
                    : c <= 2873)
                  : (c <= 2877 || (c >= 2908 && c <= 2909)))
                : (c <= 2913 || (c < 2949
                  ? (c < 2947
                    ? c == 2929
                    : c <= 2947)
                  : (c <= 2954 || (c >= 2958 && c <= 2960)))))))
            : (c <= 2965 || (c < 3090
              ? (c < 2984
                ? (c < 2974
                  ? (c < 2972
                    ? (c >= 2969 && c <= 2970)
                    : c <= 2972)
                  : (c <= 2975 || (c >= 2979 && c <= 2980)))
                : (c <= 2986 || (c < 3077
                  ? (c < 3024
                    ? (c >= 2990 && c <= 3001)
                    : c <= 3024)
                  : (c <= 3084 || (c >= 3086 && c <= 3088)))))
              : (c <= 3112 || (c < 3168
                ? (c < 3160
                  ? (c < 3133
                    ? (c >= 3114 && c <= 3129)
                    : c <= 3133)
                  : (c <= 3162 || c == 3165))
                : (c <= 3169 || (c < 3214
                  ? (c < 3205
                    ? c == 3200
                    : c <= 3212)
                  : (c <= 3216 || (c >= 3218 && c <= 3240)))))))))
          : (c <= 3251 || (c < 3648
            ? (c < 3412
              ? (c < 3332
                ? (c < 3293
                  ? (c < 3261
                    ? (c >= 3253 && c <= 3257)
                    : c <= 3261)
                  : (c <= 3294 || (c < 3313
                    ? (c >= 3296 && c <= 3297)
                    : c <= 3314)))
                : (c <= 3340 || (c < 3389
                  ? (c < 3346
                    ? (c >= 3342 && c <= 3344)
                    : c <= 3386)
                  : (c <= 3389 || c == 3406))))
              : (c <= 3414 || (c < 3507
                ? (c < 3461
                  ? (c < 3450
                    ? (c >= 3423 && c <= 3425)
                    : c <= 3455)
                  : (c <= 3478 || (c >= 3482 && c <= 3505)))
                : (c <= 3515 || (c < 3585
                  ? (c < 3520
                    ? c == 3517
                    : c <= 3526)
                  : (c <= 3632 || c == 3634))))))
            : (c <= 3654 || (c < 3782
              ? (c < 3749
                ? (c < 3718
                  ? (c < 3716
                    ? (c >= 3713 && c <= 3714)
                    : c <= 3716)
                  : (c <= 3722 || (c >= 3724 && c <= 3747)))
                : (c <= 3749 || (c < 3773
                  ? (c < 3762
                    ? (c >= 3751 && c <= 3760)
                    : c <= 3762)
                  : (c <= 3773 || (c >= 3776 && c <= 3780)))))
              : (c <= 3782 || (c < 3976
                ? (c < 3904
                  ? (c < 3840
                    ? (c >= 3804 && c <= 3807)
                    : c <= 3840)
                  : (c <= 3911 || (c >= 3913 && c <= 3948)))
                : (c <= 3980 || (c < 4176
                  ? (c < 4159
                    ? (c >= 4096 && c <= 4138)
                    : c <= 4159)
                  : (c <= 4181 || (c >= 4186 && c <= 4189)))))))))))))
      : (c <= 4193 || (c < 8134
        ? (c < 6176
          ? (c < 4808
            ? (c < 4688
              ? (c < 4295
                ? (c < 4213
                  ? (c < 4206
                    ? (c >= 4197 && c <= 4198)
                    : c <= 4208)
                  : (c <= 4225 || (c < 4256
                    ? c == 4238
                    : c <= 4293)))
                : (c <= 4295 || (c < 4348
                  ? (c < 4304
                    ? c == 4301
                    : c <= 4346)
                  : (c <= 4680 || (c >= 4682 && c <= 4685)))))
              : (c <= 4694 || (c < 4752
                ? (c < 4704
                  ? (c < 4698
                    ? c == 4696
                    : c <= 4701)
                  : (c <= 4744 || (c >= 4746 && c <= 4749)))
                : (c <= 4784 || (c < 4800
                  ? (c < 4792
                    ? (c >= 4786 && c <= 4789)
                    : c <= 4798)
                  : (c <= 4800 || (c >= 4802 && c <= 4805)))))))
            : (c <= 4822 || (c < 5792
              ? (c < 5024
                ? (c < 4888
                  ? (c < 4882
                    ? (c >= 4824 && c <= 4880)
                    : c <= 4885)
                  : (c <= 4954 || (c >= 4992 && c <= 5007)))
                : (c <= 5109 || (c < 5743
                  ? (c < 5121
                    ? (c >= 5112 && c <= 5117)
                    : c <= 5740)
                  : (c <= 5759 || (c >= 5761 && c <= 5786)))))
              : (c <= 5866 || (c < 5984
                ? (c < 5919
                  ? (c < 5888
                    ? (c >= 5870 && c <= 5880)
                    : c <= 5905)
                  : (c <= 5937 || (c >= 5952 && c <= 5969)))
                : (c <= 5996 || (c < 6103
                  ? (c < 6016
                    ? (c >= 5998 && c <= 6000)
                    : c <= 6067)
                  : (c <= 6103 || c == 6108))))))))
          : (c <= 6264 || (c < 7312
            ? (c < 6823
              ? (c < 6512
                ? (c < 6320
                  ? (c < 6314
                    ? (c >= 6272 && c <= 6312)
                    : c <= 6314)
                  : (c <= 6389 || (c < 6480
                    ? (c >= 6400 && c <= 6430)
                    : c <= 6509)))
                : (c <= 6516 || (c < 6656
                  ? (c < 6576
                    ? (c >= 6528 && c <= 6571)
                    : c <= 6601)
                  : (c <= 6678 || (c >= 6688 && c <= 6740)))))
              : (c <= 6823 || (c < 7098
                ? (c < 7043
                  ? (c < 6981
                    ? (c >= 6917 && c <= 6963)
                    : c <= 6988)
                  : (c <= 7072 || (c >= 7086 && c <= 7087)))
                : (c <= 7141 || (c < 7258
                  ? (c < 7245
                    ? (c >= 7168 && c <= 7203)
                    : c <= 7247)
                  : (c <= 7293 || (c >= 7296 && c <= 7304)))))))
            : (c <= 7354 || (c < 8008
              ? (c < 7418
                ? (c < 7406
                  ? (c < 7401
                    ? (c >= 7357 && c <= 7359)
                    : c <= 7404)
                  : (c <= 7411 || (c >= 7413 && c <= 7414)))
                : (c <= 7418 || (c < 7960
                  ? (c < 7680
                    ? (c >= 7424 && c <= 7615)
                    : c <= 7957)
                  : (c <= 7965 || (c >= 7968 && c <= 8005)))))
              : (c <= 8013 || (c < 8031
                ? (c < 8027
                  ? (c < 8025
                    ? (c >= 8016 && c <= 8023)
                    : c <= 8025)
                  : (c <= 8027 || c == 8029))
                : (c <= 8061 || (c < 8126
                  ? (c < 8118
                    ? (c >= 8064 && c <= 8116)
                    : c <= 8124)
                  : (c <= 8126 || (c >= 8130 && c <= 8132)))))))))))
        : (c <= 8140 || (c < 12337
          ? (c < 8544
            ? (c < 8458
              ? (c < 8305
                ? (c < 8160
                  ? (c < 8150
                    ? (c >= 8144 && c <= 8147)
                    : c <= 8155)
                  : (c <= 8172 || (c < 8182
                    ? (c >= 8178 && c <= 8180)
                    : c <= 8188)))
                : (c <= 8305 || (c < 8450
                  ? (c < 8336
                    ? c == 8319
                    : c <= 8348)
                  : (c <= 8450 || c == 8455))))
              : (c <= 8467 || (c < 8488
                ? (c < 8484
                  ? (c < 8472
                    ? c == 8469
                    : c <= 8477)
                  : (c <= 8484 || c == 8486))
                : (c <= 8488 || (c < 8517
                  ? (c < 8508
                    ? (c >= 8490 && c <= 8505)
                    : c <= 8511)
                  : (c <= 8521 || c == 8526))))))
            : (c <= 8584 || (c < 11680
              ? (c < 11559
                ? (c < 11506
                  ? (c < 11499
                    ? (c >= 11264 && c <= 11492)
                    : c <= 11502)
                  : (c <= 11507 || (c >= 11520 && c <= 11557)))
                : (c <= 11559 || (c < 11631
                  ? (c < 11568
                    ? c == 11565
                    : c <= 11623)
                  : (c <= 11631 || (c >= 11648 && c <= 11670)))))
              : (c <= 11686 || (c < 11720
                ? (c < 11704
                  ? (c < 11696
                    ? (c >= 11688 && c <= 11694)
                    : c <= 11702)
                  : (c <= 11710 || (c >= 11712 && c <= 11718)))
                : (c <= 11726 || (c < 12293
                  ? (c < 11736
                    ? (c >= 11728 && c <= 11734)
                    : c <= 11742)
                  : (c <= 12295 || (c >= 12321 && c <= 12329)))))))))
          : (c <= 12341 || (c < 42891
            ? (c < 19968
              ? (c < 12549
                ? (c < 12445
                  ? (c < 12353
                    ? (c >= 12344 && c <= 12348)
                    : c <= 12438)
                  : (c <= 12447 || (c < 12540
                    ? (c >= 12449 && c <= 12538)
                    : c <= 12543)))
                : (c <= 12591 || (c < 12784
                  ? (c < 12704
                    ? (c >= 12593 && c <= 12686)
                    : c <= 12735)
                  : (c <= 12799 || (c >= 13312 && c <= 19903)))))
              : (c <= 42124 || (c < 42560
                ? (c < 42512
                  ? (c < 42240
                    ? (c >= 42192 && c <= 42237)
                    : c <= 42508)
                  : (c <= 42527 || (c >= 42538 && c <= 42539)))
                : (c <= 42606 || (c < 42775
                  ? (c < 42656
                    ? (c >= 42623 && c <= 42653)
                    : c <= 42735)
                  : (c <= 42783 || (c >= 42786 && c <= 42888)))))))
            : (c <= 42954 || (c < 43250
              ? (c < 43011
                ? (c < 42965
                  ? (c < 42963
                    ? (c >= 42960 && c <= 42961)
                    : c <= 42963)
                  : (c <= 42969 || (c >= 42994 && c <= 43009)))
                : (c <= 43013 || (c < 43072
                  ? (c < 43020
                    ? (c >= 43015 && c <= 43018)
                    : c <= 43042)
                  : (c <= 43123 || (c >= 43138 && c <= 43187)))))
              : (c <= 43255 || (c < 43360
                ? (c < 43274
                  ? (c < 43261
                    ? c == 43259
                    : c <= 43262)
                  : (c <= 43301 || (c >= 43312 && c <= 43334)))
                : (c <= 43388 || (c < 43488
                  ? (c < 43471
                    ? (c >= 43396 && c <= 43442)
                    : c <= 43471)
                  : (c <= 43492 || (c >= 43494 && c <= 43503)))))))))))))))
    : (c <= 43518 || (c < 70727
      ? (c < 66956
        ? (c < 64914
          ? (c < 43868
            ? (c < 43714
              ? (c < 43646
                ? (c < 43588
                  ? (c < 43584
                    ? (c >= 43520 && c <= 43560)
                    : c <= 43586)
                  : (c <= 43595 || (c < 43642
                    ? (c >= 43616 && c <= 43638)
                    : c <= 43642)))
                : (c <= 43695 || (c < 43705
                  ? (c < 43701
                    ? c == 43697
                    : c <= 43702)
                  : (c <= 43709 || c == 43712))))
              : (c <= 43714 || (c < 43785
                ? (c < 43762
                  ? (c < 43744
                    ? (c >= 43739 && c <= 43741)
                    : c <= 43754)
                  : (c <= 43764 || (c >= 43777 && c <= 43782)))
                : (c <= 43790 || (c < 43816
                  ? (c < 43808
                    ? (c >= 43793 && c <= 43798)
                    : c <= 43814)
                  : (c <= 43822 || (c >= 43824 && c <= 43866)))))))
            : (c <= 43881 || (c < 64287
              ? (c < 63744
                ? (c < 55216
                  ? (c < 44032
                    ? (c >= 43888 && c <= 44002)
                    : c <= 55203)
                  : (c <= 55238 || (c >= 55243 && c <= 55291)))
                : (c <= 64109 || (c < 64275
                  ? (c < 64256
                    ? (c >= 64112 && c <= 64217)
                    : c <= 64262)
                  : (c <= 64279 || c == 64285))))
              : (c <= 64296 || (c < 64323
                ? (c < 64318
                  ? (c < 64312
                    ? (c >= 64298 && c <= 64310)
                    : c <= 64316)
                  : (c <= 64318 || (c >= 64320 && c <= 64321)))
                : (c <= 64324 || (c < 64612
                  ? (c < 64467
                    ? (c >= 64326 && c <= 64433)
                    : c <= 64605)
                  : (c <= 64829 || (c >= 64848 && c <= 64911)))))))))
          : (c <= 64967 || (c < 65599
            ? (c < 65382
              ? (c < 65147
                ? (c < 65139
                  ? (c < 65137
                    ? (c >= 65008 && c <= 65017)
                    : c <= 65137)
                  : (c <= 65139 || (c < 65145
                    ? c == 65143
                    : c <= 65145)))
                : (c <= 65147 || (c < 65313
                  ? (c < 65151
                    ? c == 65149
                    : c <= 65276)
                  : (c <= 65338 || (c >= 65345 && c <= 65370)))))
              : (c <= 65437 || (c < 65498
                ? (c < 65482
                  ? (c < 65474
                    ? (c >= 65440 && c <= 65470)
                    : c <= 65479)
                  : (c <= 65487 || (c >= 65490 && c <= 65495)))
                : (c <= 65500 || (c < 65576
                  ? (c < 65549
                    ? (c >= 65536 && c <= 65547)
                    : c <= 65574)
                  : (c <= 65594 || (c >= 65596 && c <= 65597)))))))
            : (c <= 65613 || (c < 66464
              ? (c < 66208
                ? (c < 65856
                  ? (c < 65664
                    ? (c >= 65616 && c <= 65629)
                    : c <= 65786)
                  : (c <= 65908 || (c >= 66176 && c <= 66204)))
                : (c <= 66256 || (c < 66384
                  ? (c < 66349
                    ? (c >= 66304 && c <= 66335)
                    : c <= 66378)
                  : (c <= 66421 || (c >= 66432 && c <= 66461)))))
              : (c <= 66499 || (c < 66776
                ? (c < 66560
                  ? (c < 66513
                    ? (c >= 66504 && c <= 66511)
                    : c <= 66517)
                  : (c <= 66717 || (c >= 66736 && c <= 66771)))
                : (c <= 66811 || (c < 66928
                  ? (c < 66864
                    ? (c >= 66816 && c <= 66855)
                    : c <= 66915)
                  : (c <= 66938 || (c >= 66940 && c <= 66954)))))))))))
        : (c <= 66962 || (c < 68864
          ? (c < 67828
            ? (c < 67506
              ? (c < 67072
                ? (c < 66979
                  ? (c < 66967
                    ? (c >= 66964 && c <= 66965)
                    : c <= 66977)
                  : (c <= 66993 || (c < 67003
                    ? (c >= 66995 && c <= 67001)
                    : c <= 67004)))
                : (c <= 67382 || (c < 67456
                  ? (c < 67424
                    ? (c >= 67392 && c <= 67413)
                    : c <= 67431)
                  : (c <= 67461 || (c >= 67463 && c <= 67504)))))
              : (c <= 67514 || (c < 67644
                ? (c < 67594
                  ? (c < 67592
                    ? (c >= 67584 && c <= 67589)
                    : c <= 67592)
                  : (c <= 67637 || (c >= 67639 && c <= 67640)))
                : (c <= 67644 || (c < 67712
                  ? (c < 67680
                    ? (c >= 67647 && c <= 67669)
                    : c <= 67702)
                  : (c <= 67742 || (c >= 67808 && c <= 67826)))))))
            : (c <= 67829 || (c < 68224
              ? (c < 68096
                ? (c < 67968
                  ? (c < 67872
                    ? (c >= 67840 && c <= 67861)
                    : c <= 67897)
                  : (c <= 68023 || (c >= 68030 && c <= 68031)))
                : (c <= 68096 || (c < 68121
                  ? (c < 68117
                    ? (c >= 68112 && c <= 68115)
                    : c <= 68119)
                  : (c <= 68149 || (c >= 68192 && c <= 68220)))))
              : (c <= 68252 || (c < 68448
                ? (c < 68352
                  ? (c < 68297
                    ? (c >= 68288 && c <= 68295)
                    : c <= 68324)
                  : (c <= 68405 || (c >= 68416 && c <= 68437)))
                : (c <= 68466 || (c < 68736
                  ? (c < 68608
                    ? (c >= 68480 && c <= 68497)
                    : c <= 68680)
                  : (c <= 68786 || (c >= 68800 && c <= 68850)))))))))
          : (c <= 68899 || (c < 70106
            ? (c < 69749
              ? (c < 69488
                ? (c < 69376
                  ? (c < 69296
                    ? (c >= 69248 && c <= 69289)
                    : c <= 69297)
                  : (c <= 69404 || (c < 69424
                    ? c == 69415
                    : c <= 69445)))
                : (c <= 69505 || (c < 69635
                  ? (c < 69600
                    ? (c >= 69552 && c <= 69572)
                    : c <= 69622)
                  : (c <= 69687 || (c >= 69745 && c <= 69746)))))
              : (c <= 69749 || (c < 69959
                ? (c < 69891
                  ? (c < 69840
                    ? (c >= 69763 && c <= 69807)
                    : c <= 69864)
                  : (c <= 69926 || c == 69956))
                : (c <= 69959 || (c < 70019
                  ? (c < 70006
                    ? (c >= 69968 && c <= 70002)
                    : c <= 70006)
                  : (c <= 70066 || (c >= 70081 && c <= 70084)))))))
            : (c <= 70106 || (c < 70405
              ? (c < 70280
                ? (c < 70163
                  ? (c < 70144
                    ? c == 70108
                    : c <= 70161)
                  : (c <= 70187 || (c >= 70272 && c <= 70278)))
                : (c <= 70280 || (c < 70303
                  ? (c < 70287
                    ? (c >= 70282 && c <= 70285)
                    : c <= 70301)
                  : (c <= 70312 || (c >= 70320 && c <= 70366)))))
              : (c <= 70412 || (c < 70453
                ? (c < 70442
                  ? (c < 70419
                    ? (c >= 70415 && c <= 70416)
                    : c <= 70440)
                  : (c <= 70448 || (c >= 70450 && c <= 70451)))
                : (c <= 70457 || (c < 70493
                  ? (c < 70480
                    ? c == 70461
                    : c <= 70480)
                  : (c <= 70497 || (c >= 70656 && c <= 70708)))))))))))))
      : (c <= 70730 || (c < 119894
        ? (c < 73056
          ? (c < 72001
            ? (c < 71424
              ? (c < 71128
                ? (c < 70852
                  ? (c < 70784
                    ? (c >= 70751 && c <= 70753)
                    : c <= 70831)
                  : (c <= 70853 || (c < 71040
                    ? c == 70855
                    : c <= 71086)))
                : (c <= 71131 || (c < 71296
                  ? (c < 71236
                    ? (c >= 71168 && c <= 71215)
                    : c <= 71236)
                  : (c <= 71338 || c == 71352))))
              : (c <= 71450 || (c < 71945
                ? (c < 71840
                  ? (c < 71680
                    ? (c >= 71488 && c <= 71494)
                    : c <= 71723)
                  : (c <= 71903 || (c >= 71935 && c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71983 || c == 71999))))))
            : (c <= 72001 || (c < 72349
              ? (c < 72192
                ? (c < 72161
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72144)
                  : (c <= 72161 || c == 72163))
                : (c <= 72192 || (c < 72272
                  ? (c < 72250
                    ? (c >= 72203 && c <= 72242)
                    : c <= 72250)
                  : (c <= 72272 || (c >= 72284 && c <= 72329)))))
              : (c <= 72349 || (c < 72818
                ? (c < 72714
                  ? (c < 72704
                    ? (c >= 72368 && c <= 72440)
                    : c <= 72712)
                  : (c <= 72750 || c == 72768))
                : (c <= 72847 || (c < 72971
                  ? (c < 72968
                    ? (c >= 72960 && c <= 72966)
                    : c <= 72969)
                  : (c <= 73008 || c == 73030))))))))
          : (c <= 73061 || (c < 93952
            ? (c < 82944
              ? (c < 73728
                ? (c < 73112
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73097)
                  : (c <= 73112 || (c < 73648
                    ? (c >= 73440 && c <= 73458)
                    : c <= 73648)))
                : (c <= 74649 || (c < 77712
                  ? (c < 74880
                    ? (c >= 74752 && c <= 74862)
                    : c <= 75075)
                  : (c <= 77808 || (c >= 77824 && c <= 78894)))))
              : (c <= 83526 || (c < 92928
                ? (c < 92784
                  ? (c < 92736
                    ? (c >= 92160 && c <= 92728)
                    : c <= 92766)
                  : (c <= 92862 || (c >= 92880 && c <= 92909)))
                : (c <= 92975 || (c < 93053
                  ? (c < 93027
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93047)
                  : (c <= 93071 || (c >= 93760 && c <= 93823)))))))
            : (c <= 94026 || (c < 110589
              ? (c < 94208
                ? (c < 94176
                  ? (c < 94099
                    ? c == 94032
                    : c <= 94111)
                  : (c <= 94177 || c == 94179))
                : (c <= 100343 || (c < 110576
                  ? (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)
                  : (c <= 110579 || (c >= 110581 && c <= 110587)))))
              : (c <= 110590 || (c < 113664
                ? (c < 110948
                  ? (c < 110928
                    ? (c >= 110592 && c <= 110882)
                    : c <= 110930)
                  : (c <= 110951 || (c >= 110960 && c <= 111355)))
                : (c <= 113770 || (c < 113808
                  ? (c < 113792
                    ? (c >= 113776 && c <= 113788)
                    : c <= 113800)
                  : (c <= 113817 || (c >= 119808 && c <= 119892)))))))))))
        : (c <= 119964 || (c < 125259
          ? (c < 120572
            ? (c < 120086
              ? (c < 119995
                ? (c < 119973
                  ? (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)
                  : (c <= 119974 || (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)))
                : (c <= 119995 || (c < 120071
                  ? (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)
                  : (c <= 120074 || (c >= 120077 && c <= 120084)))))
              : (c <= 120092 || (c < 120138
                ? (c < 120128
                  ? (c < 120123
                    ? (c >= 120094 && c <= 120121)
                    : c <= 120126)
                  : (c <= 120132 || c == 120134))
                : (c <= 120144 || (c < 120514
                  ? (c < 120488
                    ? (c >= 120146 && c <= 120485)
                    : c <= 120512)
                  : (c <= 120538 || (c >= 120540 && c <= 120570)))))))
            : (c <= 120596 || (c < 123191
              ? (c < 120714
                ? (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c >= 120688 && c <= 120712)))
                : (c <= 120744 || (c < 122624
                  ? (c < 120772
                    ? (c >= 120746 && c <= 120770)
                    : c <= 120779)
                  : (c <= 122654 || (c >= 123136 && c <= 123180)))))
              : (c <= 123197 || (c < 124904
                ? (c < 123584
                  ? (c < 123536
                    ? c == 123214
                    : c <= 123565)
                  : (c <= 123627 || (c >= 124896 && c <= 124902)))
                : (c <= 124907 || (c < 124928
                  ? (c < 124912
                    ? (c >= 124909 && c <= 124910)
                    : c <= 124926)
                  : (c <= 125124 || (c >= 125184 && c <= 125251)))))))))
          : (c <= 125259 || (c < 126559
            ? (c < 126535
              ? (c < 126505
                ? (c < 126497
                  ? (c < 126469
                    ? (c >= 126464 && c <= 126467)
                    : c <= 126495)
                  : (c <= 126498 || (c < 126503
                    ? c == 126500
                    : c <= 126503)))
                : (c <= 126514 || (c < 126523
                  ? (c < 126521
                    ? (c >= 126516 && c <= 126519)
                    : c <= 126521)
                  : (c <= 126523 || c == 126530))))
              : (c <= 126535 || (c < 126548
                ? (c < 126541
                  ? (c < 126539
                    ? c == 126537
                    : c <= 126539)
                  : (c <= 126543 || (c >= 126545 && c <= 126546)))
                : (c <= 126548 || (c < 126555
                  ? (c < 126553
                    ? c == 126551
                    : c <= 126553)
                  : (c <= 126555 || c == 126557))))))
            : (c <= 126559 || (c < 126625
              ? (c < 126580
                ? (c < 126567
                  ? (c < 126564
                    ? (c >= 126561 && c <= 126562)
                    : c <= 126564)
                  : (c <= 126570 || (c >= 126572 && c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c >= 126603 && c <= 126619)))))
              : (c <= 126627 || (c < 177984
                ? (c < 131072
                  ? (c < 126635
                    ? (c >= 126629 && c <= 126633)
                    : c <= 126651)
                  : (c <= 173791 || (c >= 173824 && c <= 177976)))
                : (c <= 178205 || (c < 194560
                  ? (c < 183984
                    ? (c >= 178208 && c <= 183969)
                    : c <= 191456)
                  : (c <= 195101 || (c >= 196608 && c <= 201546)))))))))))))))));
}

static inline bool sym_identifier_character_set_3(int32_t c) {
  return (c < 43616
    ? (c < 3782
      ? (c < 2748
        ? (c < 2045
          ? (c < 1015
            ? (c < 710
              ? (c < 181
                ? (c < '_'
                  ? (c < 'A'
                    ? (c >= '0' && c <= '9')
                    : c <= 'Z')
                  : (c <= '_' || (c < 170
                    ? (c >= 'a' && c <= 'z')
                    : c <= 170)))
                : (c <= 181 || (c < 192
                  ? (c < 186
                    ? c == 183
                    : c <= 186)
                  : (c <= 214 || (c < 248
                    ? (c >= 216 && c <= 246)
                    : c <= 705)))))
              : (c <= 721 || (c < 891
                ? (c < 750
                  ? (c < 748
                    ? (c >= 736 && c <= 740)
                    : c <= 748)
                  : (c <= 750 || (c < 886
                    ? (c >= 768 && c <= 884)
                    : c <= 887)))
                : (c <= 893 || (c < 908
                  ? (c < 902
                    ? c == 895
                    : c <= 906)
                  : (c <= 908 || (c < 931
                    ? (c >= 910 && c <= 929)
                    : c <= 1013)))))))
            : (c <= 1153 || (c < 1519
              ? (c < 1425
                ? (c < 1329
                  ? (c < 1162
                    ? (c >= 1155 && c <= 1159)
                    : c <= 1327)
                  : (c <= 1366 || (c < 1376
                    ? c == 1369
                    : c <= 1416)))
                : (c <= 1469 || (c < 1476
                  ? (c < 1473
                    ? c == 1471
                    : c <= 1474)
                  : (c <= 1477 || (c < 1488
                    ? c == 1479
                    : c <= 1514)))))
              : (c <= 1522 || (c < 1770
                ? (c < 1646
                  ? (c < 1568
                    ? (c >= 1552 && c <= 1562)
                    : c <= 1641)
                  : (c <= 1747 || (c < 1759
                    ? (c >= 1749 && c <= 1756)
                    : c <= 1768)))
                : (c <= 1788 || (c < 1869
                  ? (c < 1808
                    ? c == 1791
                    : c <= 1866)
                  : (c <= 1969 || (c < 2042
                    ? (c >= 1984 && c <= 2037)
                    : c <= 2042)))))))))
          : (c <= 2045 || (c < 2558
            ? (c < 2451
              ? (c < 2200
                ? (c < 2144
                  ? (c < 2112
                    ? (c >= 2048 && c <= 2093)
                    : c <= 2139)
                  : (c <= 2154 || (c < 2185
                    ? (c >= 2160 && c <= 2183)
                    : c <= 2190)))
                : (c <= 2273 || (c < 2417
                  ? (c < 2406
                    ? (c >= 2275 && c <= 2403)
                    : c <= 2415)
                  : (c <= 2435 || (c < 2447
                    ? (c >= 2437 && c <= 2444)
                    : c <= 2448)))))
              : (c <= 2472 || (c < 2507
                ? (c < 2486
                  ? (c < 2482
                    ? (c >= 2474 && c <= 2480)
                    : c <= 2482)
                  : (c <= 2489 || (c < 2503
                    ? (c >= 2492 && c <= 2500)
                    : c <= 2504)))
                : (c <= 2510 || (c < 2527
                  ? (c < 2524
                    ? c == 2519
                    : c <= 2525)
                  : (c <= 2531 || (c < 2556
                    ? (c >= 2534 && c <= 2545)
                    : c <= 2556)))))))
            : (c <= 2558 || (c < 2635
              ? (c < 2610
                ? (c < 2575
                  ? (c < 2565
                    ? (c >= 2561 && c <= 2563)
                    : c <= 2570)
                  : (c <= 2576 || (c < 2602
                    ? (c >= 2579 && c <= 2600)
                    : c <= 2608)))
                : (c <= 2611 || (c < 2620
                  ? (c < 2616
                    ? (c >= 2613 && c <= 2614)
                    : c <= 2617)
                  : (c <= 2620 || (c < 2631
                    ? (c >= 2622 && c <= 2626)
                    : c <= 2632)))))
              : (c <= 2637 || (c < 2693
                ? (c < 2654
                  ? (c < 2649
                    ? c == 2641
                    : c <= 2652)
                  : (c <= 2654 || (c < 2689
                    ? (c >= 2662 && c <= 2677)
                    : c <= 2691)))
                : (c <= 2701 || (c < 2730
                  ? (c < 2707
                    ? (c >= 2703 && c <= 2705)
                    : c <= 2728)
                  : (c <= 2736 || (c < 2741
                    ? (c >= 2738 && c <= 2739)
                    : c <= 2745)))))))))))
        : (c <= 2757 || (c < 3168
          ? (c < 2958
            ? (c < 2866
              ? (c < 2809
                ? (c < 2768
                  ? (c < 2763
                    ? (c >= 2759 && c <= 2761)
                    : c <= 2765)
                  : (c <= 2768 || (c < 2790
                    ? (c >= 2784 && c <= 2787)
                    : c <= 2799)))
                : (c <= 2815 || (c < 2831
                  ? (c < 2821
                    ? (c >= 2817 && c <= 2819)
                    : c <= 2828)
                  : (c <= 2832 || (c < 2858
                    ? (c >= 2835 && c <= 2856)
                    : c <= 2864)))))
              : (c <= 2867 || (c < 2908
                ? (c < 2887
                  ? (c < 2876
                    ? (c >= 2869 && c <= 2873)
                    : c <= 2884)
                  : (c <= 2888 || (c < 2901
                    ? (c >= 2891 && c <= 2893)
                    : c <= 2903)))
                : (c <= 2909 || (c < 2929
                  ? (c < 2918
                    ? (c >= 2911 && c <= 2915)
                    : c <= 2927)
                  : (c <= 2929 || (c < 2949
                    ? (c >= 2946 && c <= 2947)
                    : c <= 2954)))))))
            : (c <= 2960 || (c < 3031
              ? (c < 2984
                ? (c < 2972
                  ? (c < 2969
                    ? (c >= 2962 && c <= 2965)
                    : c <= 2970)
                  : (c <= 2972 || (c < 2979
                    ? (c >= 2974 && c <= 2975)
                    : c <= 2980)))
                : (c <= 2986 || (c < 3014
                  ? (c < 3006
                    ? (c >= 2990 && c <= 3001)
                    : c <= 3010)
                  : (c <= 3016 || (c < 3024
                    ? (c >= 3018 && c <= 3021)
                    : c <= 3024)))))
              : (c <= 3031 || (c < 3132
                ? (c < 3086
                  ? (c < 3072
                    ? (c >= 3046 && c <= 3055)
                    : c <= 3084)
                  : (c <= 3088 || (c < 3114
                    ? (c >= 3090 && c <= 3112)
                    : c <= 3129)))
                : (c <= 3140 || (c < 3157
                  ? (c < 3146
                    ? (c >= 3142 && c <= 3144)
                    : c <= 3149)
                  : (c <= 3158 || (c < 3165
                    ? (c >= 3160 && c <= 3162)
                    : c <= 3165)))))))))
          : (c <= 3171 || (c < 3450
            ? (c < 3293
              ? (c < 3242
                ? (c < 3205
                  ? (c < 3200
                    ? (c >= 3174 && c <= 3183)
                    : c <= 3203)
                  : (c <= 3212 || (c < 3218
                    ? (c >= 3214 && c <= 3216)
                    : c <= 3240)))
                : (c <= 3251 || (c < 3270
                  ? (c < 3260
                    ? (c >= 3253 && c <= 3257)
                    : c <= 3268)
                  : (c <= 3272 || (c < 3285
                    ? (c >= 3274 && c <= 3277)
                    : c <= 3286)))))
              : (c <= 3294 || (c < 3346
                ? (c < 3313
                  ? (c < 3302
                    ? (c >= 3296 && c <= 3299)
                    : c <= 3311)
                  : (c <= 3314 || (c < 3342
                    ? (c >= 3328 && c <= 3340)
                    : c <= 3344)))
                : (c <= 3396 || (c < 3412
                  ? (c < 3402
                    ? (c >= 3398 && c <= 3400)
                    : c <= 3406)
                  : (c <= 3415 || (c < 3430
                    ? (c >= 3423 && c <= 3427)
                    : c <= 3439)))))))
            : (c <= 3455 || (c < 3570
              ? (c < 3520
                ? (c < 3482
                  ? (c < 3461
                    ? (c >= 3457 && c <= 3459)
                    : c <= 3478)
                  : (c <= 3505 || (c < 3517
                    ? (c >= 3507 && c <= 3515)
                    : c <= 3517)))
                : (c <= 3526 || (c < 3542
                  ? (c < 3535
                    ? c == 3530
                    : c <= 3540)
                  : (c <= 3542 || (c < 3558
                    ? (c >= 3544 && c <= 3551)
                    : c <= 3567)))))
              : (c <= 3571 || (c < 3718
                ? (c < 3664
                  ? (c < 3648
                    ? (c >= 3585 && c <= 3642)
                    : c <= 3662)
                  : (c <= 3673 || (c < 3716
                    ? (c >= 3713 && c <= 3714)
                    : c <= 3716)))
                : (c <= 3722 || (c < 3751
                  ? (c < 3749
                    ? (c >= 3724 && c <= 3747)
                    : c <= 3749)
                  : (c <= 3773 || (c >= 3776 && c <= 3780)))))))))))))
      : (c <= 3782 || (c < 8025
        ? (c < 5888
          ? (c < 4688
            ? (c < 3953
              ? (c < 3872
                ? (c < 3804
                  ? (c < 3792
                    ? (c >= 3784 && c <= 3789)
                    : c <= 3801)
                  : (c <= 3807 || (c < 3864
                    ? c == 3840
                    : c <= 3865)))
                : (c <= 3881 || (c < 3897
                  ? (c < 3895
                    ? c == 3893
                    : c <= 3895)
                  : (c <= 3897 || (c < 3913
                    ? (c >= 3902 && c <= 3911)
                    : c <= 3948)))))
              : (c <= 3972 || (c < 4256
                ? (c < 4038
                  ? (c < 3993
                    ? (c >= 3974 && c <= 3991)
                    : c <= 4028)
                  : (c <= 4038 || (c < 4176
                    ? (c >= 4096 && c <= 4169)
                    : c <= 4253)))
                : (c <= 4293 || (c < 4304
                  ? (c < 4301
                    ? c == 4295
                    : c <= 4301)
                  : (c <= 4346 || (c < 4682
                    ? (c >= 4348 && c <= 4680)
                    : c <= 4685)))))))
            : (c <= 4694 || (c < 4882
              ? (c < 4786
                ? (c < 4704
                  ? (c < 4698
                    ? c == 4696
                    : c <= 4701)
                  : (c <= 4744 || (c < 4752
                    ? (c >= 4746 && c <= 4749)
                    : c <= 4784)))
                : (c <= 4789 || (c < 4802
                  ? (c < 4800
                    ? (c >= 4792 && c <= 4798)
                    : c <= 4800)
                  : (c <= 4805 || (c < 4824
                    ? (c >= 4808 && c <= 4822)
                    : c <= 4880)))))
              : (c <= 4885 || (c < 5112
                ? (c < 4969
                  ? (c < 4957
                    ? (c >= 4888 && c <= 4954)
                    : c <= 4959)
                  : (c <= 4977 || (c < 5024
                    ? (c >= 4992 && c <= 5007)
                    : c <= 5109)))
                : (c <= 5117 || (c < 5761
                  ? (c < 5743
                    ? (c >= 5121 && c <= 5740)
                    : c <= 5759)
                  : (c <= 5786 || (c < 5870
                    ? (c >= 5792 && c <= 5866)
                    : c <= 5880)))))))))
          : (c <= 5909 || (c < 6688
            ? (c < 6176
              ? (c < 6016
                ? (c < 5984
                  ? (c < 5952
                    ? (c >= 5919 && c <= 5940)
                    : c <= 5971)
                  : (c <= 5996 || (c < 6002
                    ? (c >= 5998 && c <= 6000)
                    : c <= 6003)))
                : (c <= 6099 || (c < 6112
                  ? (c < 6108
                    ? c == 6103
                    : c <= 6109)
                  : (c <= 6121 || (c < 6159
                    ? (c >= 6155 && c <= 6157)
                    : c <= 6169)))))
              : (c <= 6264 || (c < 6470
                ? (c < 6400
                  ? (c < 6320
                    ? (c >= 6272 && c <= 6314)
                    : c <= 6389)
                  : (c <= 6430 || (c < 6448
                    ? (c >= 6432 && c <= 6443)
                    : c <= 6459)))
                : (c <= 6509 || (c < 6576
                  ? (c < 6528
                    ? (c >= 6512 && c <= 6516)
                    : c <= 6571)
                  : (c <= 6601 || (c < 6656
                    ? (c >= 6608 && c <= 6618)
                    : c <= 6683)))))))
            : (c <= 6750 || (c < 7232
              ? (c < 6847
                ? (c < 6800
                  ? (c < 6783
                    ? (c >= 6752 && c <= 6780)
                    : c <= 6793)
                  : (c <= 6809 || (c < 6832
                    ? c == 6823
                    : c <= 6845)))
                : (c <= 6862 || (c < 7019
                  ? (c < 6992
                    ? (c >= 6912 && c <= 6988)
                    : c <= 7001)
                  : (c <= 7027 || (c < 7168
                    ? (c >= 7040 && c <= 7155)
                    : c <= 7223)))))
              : (c <= 7241 || (c < 7380
                ? (c < 7312
                  ? (c < 7296
                    ? (c >= 7245 && c <= 7293)
                    : c <= 7304)
                  : (c <= 7354 || (c < 7376
                    ? (c >= 7357 && c <= 7359)
                    : c <= 7378)))
                : (c <= 7418 || (c < 7968
                  ? (c < 7960
                    ? (c >= 7424 && c <= 7957)
                    : c <= 7965)
                  : (c <= 8005 || (c < 8016
                    ? (c >= 8008 && c <= 8013)
                    : c <= 8023)))))))))))
        : (c <= 8025 || (c < 11720
          ? (c < 8458
            ? (c < 8178
              ? (c < 8126
                ? (c < 8031
                  ? (c < 8029
                    ? c == 8027
                    : c <= 8029)
                  : (c <= 8061 || (c < 8118
                    ? (c >= 8064 && c <= 8116)
                    : c <= 8124)))
                : (c <= 8126 || (c < 8144
                  ? (c < 8134
                    ? (c >= 8130 && c <= 8132)
                    : c <= 8140)
                  : (c <= 8147 || (c < 8160
                    ? (c >= 8150 && c <= 8155)
                    : c <= 8172)))))
              : (c <= 8180 || (c < 8336
                ? (c < 8276
                  ? (c < 8255
                    ? (c >= 8182 && c <= 8188)
                    : c <= 8256)
                  : (c <= 8276 || (c < 8319
                    ? c == 8305
                    : c <= 8319)))
                : (c <= 8348 || (c < 8421
                  ? (c < 8417
                    ? (c >= 8400 && c <= 8412)
                    : c <= 8417)
                  : (c <= 8432 || (c < 8455
                    ? c == 8450
                    : c <= 8455)))))))
            : (c <= 8467 || (c < 11499
              ? (c < 8490
                ? (c < 8484
                  ? (c < 8472
                    ? c == 8469
                    : c <= 8477)
                  : (c <= 8484 || (c < 8488
                    ? c == 8486
                    : c <= 8488)))
                : (c <= 8505 || (c < 8526
                  ? (c < 8517
                    ? (c >= 8508 && c <= 8511)
                    : c <= 8521)
                  : (c <= 8526 || (c < 11264
                    ? (c >= 8544 && c <= 8584)
                    : c <= 11492)))))
              : (c <= 11507 || (c < 11647
                ? (c < 11565
                  ? (c < 11559
                    ? (c >= 11520 && c <= 11557)
                    : c <= 11559)
                  : (c <= 11565 || (c < 11631
                    ? (c >= 11568 && c <= 11623)
                    : c <= 11631)))
                : (c <= 11670 || (c < 11696
                  ? (c < 11688
                    ? (c >= 11680 && c <= 11686)
                    : c <= 11694)
                  : (c <= 11702 || (c < 11712
                    ? (c >= 11704 && c <= 11710)
                    : c <= 11718)))))))))
          : (c <= 11726 || (c < 42623
            ? (c < 12540
              ? (c < 12337
                ? (c < 11744
                  ? (c < 11736
                    ? (c >= 11728 && c <= 11734)
                    : c <= 11742)
                  : (c <= 11775 || (c < 12321
                    ? (c >= 12293 && c <= 12295)
                    : c <= 12335)))
                : (c <= 12341 || (c < 12441
                  ? (c < 12353
                    ? (c >= 12344 && c <= 12348)
                    : c <= 12438)
                  : (c <= 12442 || (c < 12449
                    ? (c >= 12445 && c <= 12447)
                    : c <= 12538)))))
              : (c <= 12543 || (c < 19968
                ? (c < 12704
                  ? (c < 12593
                    ? (c >= 12549 && c <= 12591)
                    : c <= 12686)
                  : (c <= 12735 || (c < 13312
                    ? (c >= 12784 && c <= 12799)
                    : c <= 19903)))
                : (c <= 42124 || (c < 42512
                  ? (c < 42240
                    ? (c >= 42192 && c <= 42237)
                    : c <= 42508)
                  : (c <= 42539 || (c < 42612
                    ? (c >= 42560 && c <= 42607)
                    : c <= 42621)))))))
            : (c <= 42737 || (c < 43232
              ? (c < 42965
                ? (c < 42891
                  ? (c < 42786
                    ? (c >= 42775 && c <= 42783)
                    : c <= 42888)
                  : (c <= 42954 || (c < 42963
                    ? (c >= 42960 && c <= 42961)
                    : c <= 42963)))
                : (c <= 42969 || (c < 43072
                  ? (c < 43052
                    ? (c >= 42994 && c <= 43047)
                    : c <= 43052)
                  : (c <= 43123 || (c < 43216
                    ? (c >= 43136 && c <= 43205)
                    : c <= 43225)))))
              : (c <= 43255 || (c < 43471
                ? (c < 43312
                  ? (c < 43261
                    ? c == 43259
                    : c <= 43309)
                  : (c <= 43347 || (c < 43392
                    ? (c >= 43360 && c <= 43388)
                    : c <= 43456)))
                : (c <= 43481 || (c < 43584
                  ? (c < 43520
                    ? (c >= 43488 && c <= 43518)
                    : c <= 43574)
                  : (c <= 43597 || (c >= 43600 && c <= 43609)))))))))))))))
    : (c <= 43638 || (c < 71453
      ? (c < 67639
        ? (c < 65345
          ? (c < 64312
            ? (c < 43888
              ? (c < 43785
                ? (c < 43744
                  ? (c < 43739
                    ? (c >= 43642 && c <= 43714)
                    : c <= 43741)
                  : (c <= 43759 || (c < 43777
                    ? (c >= 43762 && c <= 43766)
                    : c <= 43782)))
                : (c <= 43790 || (c < 43816
                  ? (c < 43808
                    ? (c >= 43793 && c <= 43798)
                    : c <= 43814)
                  : (c <= 43822 || (c < 43868
                    ? (c >= 43824 && c <= 43866)
                    : c <= 43881)))))
              : (c <= 44010 || (c < 63744
                ? (c < 44032
                  ? (c < 44016
                    ? (c >= 44012 && c <= 44013)
                    : c <= 44025)
                  : (c <= 55203 || (c < 55243
                    ? (c >= 55216 && c <= 55238)
                    : c <= 55291)))
                : (c <= 64109 || (c < 64275
                  ? (c < 64256
                    ? (c >= 64112 && c <= 64217)
                    : c <= 64262)
                  : (c <= 64279 || (c < 64298
                    ? (c >= 64285 && c <= 64296)
                    : c <= 64310)))))))
            : (c <= 64316 || (c < 65075
              ? (c < 64612
                ? (c < 64323
                  ? (c < 64320
                    ? c == 64318
                    : c <= 64321)
                  : (c <= 64324 || (c < 64467
                    ? (c >= 64326 && c <= 64433)
                    : c <= 64605)))
                : (c <= 64829 || (c < 65008
                  ? (c < 64914
                    ? (c >= 64848 && c <= 64911)
                    : c <= 64967)
                  : (c <= 65017 || (c < 65056
                    ? (c >= 65024 && c <= 65039)
                    : c <= 65071)))))
              : (c <= 65076 || (c < 65147
                ? (c < 65139
                  ? (c < 65137
                    ? (c >= 65101 && c <= 65103)
                    : c <= 65137)
                  : (c <= 65139 || (c < 65145
                    ? c == 65143
                    : c <= 65145)))
                : (c <= 65147 || (c < 65296
                  ? (c < 65151
                    ? c == 65149
                    : c <= 65276)
                  : (c <= 65305 || (c < 65343
                    ? (c >= 65313 && c <= 65338)
                    : c <= 65343)))))))))
          : (c <= 65370 || (c < 66513
            ? (c < 65664
              ? (c < 65536
                ? (c < 65482
                  ? (c < 65474
                    ? (c >= 65382 && c <= 65470)
                    : c <= 65479)
                  : (c <= 65487 || (c < 65498
                    ? (c >= 65490 && c <= 65495)
                    : c <= 65500)))
                : (c <= 65547 || (c < 65596
                  ? (c < 65576
                    ? (c >= 65549 && c <= 65574)
                    : c <= 65594)
                  : (c <= 65597 || (c < 65616
                    ? (c >= 65599 && c <= 65613)
                    : c <= 65629)))))
              : (c <= 65786 || (c < 66304
                ? (c < 66176
                  ? (c < 66045
                    ? (c >= 65856 && c <= 65908)
                    : c <= 66045)
                  : (c <= 66204 || (c < 66272
                    ? (c >= 66208 && c <= 66256)
                    : c <= 66272)))
                : (c <= 66335 || (c < 66432
                  ? (c < 66384
                    ? (c >= 66349 && c <= 66378)
                    : c <= 66426)
                  : (c <= 66461 || (c < 66504
                    ? (c >= 66464 && c <= 66499)
                    : c <= 66511)))))))
            : (c <= 66517 || (c < 66979
              ? (c < 66864
                ? (c < 66736
                  ? (c < 66720
                    ? (c >= 66560 && c <= 66717)
                    : c <= 66729)
                  : (c <= 66771 || (c < 66816
                    ? (c >= 66776 && c <= 66811)
                    : c <= 66855)))
                : (c <= 66915 || (c < 66956
                  ? (c < 66940
                    ? (c >= 66928 && c <= 66938)
                    : c <= 66954)
                  : (c <= 66962 || (c < 66967
                    ? (c >= 66964 && c <= 66965)
                    : c <= 66977)))))
              : (c <= 66993 || (c < 67456
                ? (c < 67072
                  ? (c < 67003
                    ? (c >= 66995 && c <= 67001)
                    : c <= 67004)
                  : (c <= 67382 || (c < 67424
                    ? (c >= 67392 && c <= 67413)
                    : c <= 67431)))
                : (c <= 67461 || (c < 67584
                  ? (c < 67506
                    ? (c >= 67463 && c <= 67504)
                    : c <= 67514)
                  : (c <= 67589 || (c < 67594
                    ? c == 67592
                    : c <= 67637)))))))))))
        : (c <= 67640 || (c < 69956
          ? (c < 68448
            ? (c < 68101
              ? (c < 67828
                ? (c < 67680
                  ? (c < 67647
                    ? c == 67644
                    : c <= 67669)
                  : (c <= 67702 || (c < 67808
                    ? (c >= 67712 && c <= 67742)
                    : c <= 67826)))
                : (c <= 67829 || (c < 67968
                  ? (c < 67872
                    ? (c >= 67840 && c <= 67861)
                    : c <= 67897)
                  : (c <= 68023 || (c < 68096
                    ? (c >= 68030 && c <= 68031)
                    : c <= 68099)))))
              : (c <= 68102 || (c < 68192
                ? (c < 68121
                  ? (c < 68117
                    ? (c >= 68108 && c <= 68115)
                    : c <= 68119)
                  : (c <= 68149 || (c < 68159
                    ? (c >= 68152 && c <= 68154)
                    : c <= 68159)))
                : (c <= 68220 || (c < 68297
                  ? (c < 68288
                    ? (c >= 68224 && c <= 68252)
                    : c <= 68295)
                  : (c <= 68326 || (c < 68416
                    ? (c >= 68352 && c <= 68405)
                    : c <= 68437)))))))
            : (c <= 68466 || (c < 69424
              ? (c < 68912
                ? (c < 68736
                  ? (c < 68608
                    ? (c >= 68480 && c <= 68497)
                    : c <= 68680)
                  : (c <= 68786 || (c < 68864
                    ? (c >= 68800 && c <= 68850)
                    : c <= 68903)))
                : (c <= 68921 || (c < 69296
                  ? (c < 69291
                    ? (c >= 69248 && c <= 69289)
                    : c <= 69292)
                  : (c <= 69297 || (c < 69415
                    ? (c >= 69376 && c <= 69404)
                    : c <= 69415)))))
              : (c <= 69456 || (c < 69759
                ? (c < 69600
                  ? (c < 69552
                    ? (c >= 69488 && c <= 69509)
                    : c <= 69572)
                  : (c <= 69622 || (c < 69734
                    ? (c >= 69632 && c <= 69702)
                    : c <= 69749)))
                : (c <= 69818 || (c < 69872
                  ? (c < 69840
                    ? c == 69826
                    : c <= 69864)
                  : (c <= 69881 || (c < 69942
                    ? (c >= 69888 && c <= 69940)
                    : c <= 69951)))))))))
          : (c <= 69959 || (c < 70459
            ? (c < 70282
              ? (c < 70108
                ? (c < 70016
                  ? (c < 70006
                    ? (c >= 69968 && c <= 70003)
                    : c <= 70006)
                  : (c <= 70084 || (c < 70094
                    ? (c >= 70089 && c <= 70092)
                    : c <= 70106)))
                : (c <= 70108 || (c < 70206
                  ? (c < 70163
                    ? (c >= 70144 && c <= 70161)
                    : c <= 70199)
                  : (c <= 70206 || (c < 70280
                    ? (c >= 70272 && c <= 70278)
                    : c <= 70280)))))
              : (c <= 70285 || (c < 70405
                ? (c < 70320
                  ? (c < 70303
                    ? (c >= 70287 && c <= 70301)
                    : c <= 70312)
                  : (c <= 70378 || (c < 70400
                    ? (c >= 70384 && c <= 70393)
                    : c <= 70403)))
                : (c <= 70412 || (c < 70442
                  ? (c < 70419
                    ? (c >= 70415 && c <= 70416)
                    : c <= 70440)
                  : (c <= 70448 || (c < 70453
                    ? (c >= 70450 && c <= 70451)
                    : c <= 70457)))))))
            : (c <= 70468 || (c < 70855
              ? (c < 70502
                ? (c < 70480
                  ? (c < 70475
                    ? (c >= 70471 && c <= 70472)
                    : c <= 70477)
                  : (c <= 70480 || (c < 70493
                    ? c == 70487
                    : c <= 70499)))
                : (c <= 70508 || (c < 70736
                  ? (c < 70656
                    ? (c >= 70512 && c <= 70516)
                    : c <= 70730)
                  : (c <= 70745 || (c < 70784
                    ? (c >= 70750 && c <= 70753)
                    : c <= 70853)))))
              : (c <= 70855 || (c < 71236
                ? (c < 71096
                  ? (c < 71040
                    ? (c >= 70864 && c <= 70873)
                    : c <= 71093)
                  : (c <= 71104 || (c < 71168
                    ? (c >= 71128 && c <= 71133)
                    : c <= 71232)))
                : (c <= 71236 || (c < 71360
                  ? (c < 71296
                    ? (c >= 71248 && c <= 71257)
                    : c <= 71352)
                  : (c <= 71369 || (c >= 71424 && c <= 71450)))))))))))))
      : (c <= 71467 || (c < 119973
        ? (c < 77824
          ? (c < 72760
            ? (c < 72016
              ? (c < 71945
                ? (c < 71680
                  ? (c < 71488
                    ? (c >= 71472 && c <= 71481)
                    : c <= 71494)
                  : (c <= 71738 || (c < 71935
                    ? (c >= 71840 && c <= 71913)
                    : c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71989 || (c < 71995
                    ? (c >= 71991 && c <= 71992)
                    : c <= 72003)))))
              : (c <= 72025 || (c < 72263
                ? (c < 72154
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72151)
                  : (c <= 72161 || (c < 72192
                    ? (c >= 72163 && c <= 72164)
                    : c <= 72254)))
                : (c <= 72263 || (c < 72368
                  ? (c < 72349
                    ? (c >= 72272 && c <= 72345)
                    : c <= 72349)
                  : (c <= 72440 || (c < 72714
                    ? (c >= 72704 && c <= 72712)
                    : c <= 72758)))))))
            : (c <= 72768 || (c < 73056
              ? (c < 72968
                ? (c < 72850
                  ? (c < 72818
                    ? (c >= 72784 && c <= 72793)
                    : c <= 72847)
                  : (c <= 72871 || (c < 72960
                    ? (c >= 72873 && c <= 72886)
                    : c <= 72966)))
                : (c <= 72969 || (c < 73020
                  ? (c < 73018
                    ? (c >= 72971 && c <= 73014)
                    : c <= 73018)
                  : (c <= 73021 || (c < 73040
                    ? (c >= 73023 && c <= 73031)
                    : c <= 73049)))))
              : (c <= 73061 || (c < 73440
                ? (c < 73104
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73102)
                  : (c <= 73105 || (c < 73120
                    ? (c >= 73107 && c <= 73112)
                    : c <= 73129)))
                : (c <= 73462 || (c < 74752
                  ? (c < 73728
                    ? c == 73648
                    : c <= 74649)
                  : (c <= 74862 || (c < 77712
                    ? (c >= 74880 && c <= 75075)
                    : c <= 77808)))))))))
          : (c <= 78894 || (c < 110576
            ? (c < 93027
              ? (c < 92864
                ? (c < 92736
                  ? (c < 92160
                    ? (c >= 82944 && c <= 83526)
                    : c <= 92728)
                  : (c <= 92766 || (c < 92784
                    ? (c >= 92768 && c <= 92777)
                    : c <= 92862)))
                : (c <= 92873 || (c < 92928
                  ? (c < 92912
                    ? (c >= 92880 && c <= 92909)
                    : c <= 92916)
                  : (c <= 92982 || (c < 93008
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93017)))))
              : (c <= 93047 || (c < 94176
                ? (c < 93952
                  ? (c < 93760
                    ? (c >= 93053 && c <= 93071)
                    : c <= 93823)
                  : (c <= 94026 || (c < 94095
                    ? (c >= 94031 && c <= 94087)
                    : c <= 94111)))
                : (c <= 94177 || (c < 94208
                  ? (c < 94192
                    ? (c >= 94179 && c <= 94180)
                    : c <= 94193)
                  : (c <= 100343 || (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)))))))
            : (c <= 110579 || (c < 118528
              ? (c < 110960
                ? (c < 110592
                  ? (c < 110589
                    ? (c >= 110581 && c <= 110587)
                    : c <= 110590)
                  : (c <= 110882 || (c < 110948
                    ? (c >= 110928 && c <= 110930)
                    : c <= 110951)))
                : (c <= 111355 || (c < 113792
                  ? (c < 113776
                    ? (c >= 113664 && c <= 113770)
                    : c <= 113788)
                  : (c <= 113800 || (c < 113821
                    ? (c >= 113808 && c <= 113817)
                    : c <= 113822)))))
              : (c <= 118573 || (c < 119210
                ? (c < 119149
                  ? (c < 119141
                    ? (c >= 118576 && c <= 118598)
                    : c <= 119145)
                  : (c <= 119154 || (c < 119173
                    ? (c >= 119163 && c <= 119170)
                    : c <= 119179)))
                : (c <= 119213 || (c < 119894
                  ? (c < 119808
                    ? (c >= 119362 && c <= 119364)
                    : c <= 119892)
                  : (c <= 119964 || (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)))))))))))
        : (c <= 119974 || (c < 124912
          ? (c < 120746
            ? (c < 120134
              ? (c < 120071
                ? (c < 119995
                  ? (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)
                  : (c <= 119995 || (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)))
                : (c <= 120074 || (c < 120094
                  ? (c < 120086
                    ? (c >= 120077 && c <= 120084)
                    : c <= 120092)
                  : (c <= 120121 || (c < 120128
                    ? (c >= 120123 && c <= 120126)
                    : c <= 120132)))))
              : (c <= 120134 || (c < 120572
                ? (c < 120488
                  ? (c < 120146
                    ? (c >= 120138 && c <= 120144)
                    : c <= 120485)
                  : (c <= 120512 || (c < 120540
                    ? (c >= 120514 && c <= 120538)
                    : c <= 120570)))
                : (c <= 120596 || (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c < 120714
                    ? (c >= 120688 && c <= 120712)
                    : c <= 120744)))))))
            : (c <= 120770 || (c < 122907
              ? (c < 121476
                ? (c < 121344
                  ? (c < 120782
                    ? (c >= 120772 && c <= 120779)
                    : c <= 120831)
                  : (c <= 121398 || (c < 121461
                    ? (c >= 121403 && c <= 121452)
                    : c <= 121461)))
                : (c <= 121476 || (c < 122624
                  ? (c < 121505
                    ? (c >= 121499 && c <= 121503)
                    : c <= 121519)
                  : (c <= 122654 || (c < 122888
                    ? (c >= 122880 && c <= 122886)
                    : c <= 122904)))))
              : (c <= 122913 || (c < 123214
                ? (c < 123136
                  ? (c < 122918
                    ? (c >= 122915 && c <= 122916)
                    : c <= 122922)
                  : (c <= 123180 || (c < 123200
                    ? (c >= 123184 && c <= 123197)
                    : c <= 123209)))
                : (c <= 123214 || (c < 124896
                  ? (c < 123584
                    ? (c >= 123536 && c <= 123566)
                    : c <= 123641)
                  : (c <= 124902 || (c < 124909
                    ? (c >= 124904 && c <= 124907)
                    : c <= 124910)))))))))
          : (c <= 124926 || (c < 126557
            ? (c < 126521
              ? (c < 126469
                ? (c < 125184
                  ? (c < 125136
                    ? (c >= 124928 && c <= 125124)
                    : c <= 125142)
                  : (c <= 125259 || (c < 126464
                    ? (c >= 125264 && c <= 125273)
                    : c <= 126467)))
                : (c <= 126495 || (c < 126503
                  ? (c < 126500
                    ? (c >= 126497 && c <= 126498)
                    : c <= 126500)
                  : (c <= 126503 || (c < 126516
                    ? (c >= 126505 && c <= 126514)
                    : c <= 126519)))))
              : (c <= 126521 || (c < 126541
                ? (c < 126535
                  ? (c < 126530
                    ? c == 126523
                    : c <= 126530)
                  : (c <= 126535 || (c < 126539
                    ? c == 126537
                    : c <= 126539)))
                : (c <= 126543 || (c < 126551
                  ? (c < 126548
                    ? (c >= 126545 && c <= 126546)
                    : c <= 126548)
                  : (c <= 126551 || (c < 126555
                    ? c == 126553
                    : c <= 126555)))))))
            : (c <= 126557 || (c < 126629
              ? (c < 126580
                ? (c < 126564
                  ? (c < 126561
                    ? c == 126559
                    : c <= 126562)
                  : (c <= 126564 || (c < 126572
                    ? (c >= 126567 && c <= 126570)
                    : c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c < 126625
                    ? (c >= 126603 && c <= 126619)
                    : c <= 126627)))))
              : (c <= 126633 || (c < 178208
                ? (c < 131072
                  ? (c < 130032
                    ? (c >= 126635 && c <= 126651)
                    : c <= 130041)
                  : (c <= 173791 || (c < 177984
                    ? (c >= 173824 && c <= 177976)
                    : c <= 178205)))
                : (c <= 183969 || (c < 196608
                  ? (c < 194560
                    ? (c >= 183984 && c <= 191456)
                    : c <= 195101)
                  : (c <= 201546 || (c >= 917760 && c <= 917999)))))))))))))))));
}

static inline bool sym__rule_import_as_pattern_target_character_set_1(int32_t c) {
  return (c < 43494
    ? (c < 4186
      ? (c < 2703
        ? (c < 1969
          ? (c < 908
            ? (c < 710
              ? (c < 181
                ? (c < '_'
                  ? (c < 'A'
                    ? c == '*'
                    : c <= 'Z')
                  : (c <= '_' || (c < 170
                    ? (c >= 'a' && c <= 'z')
                    : c <= 170)))
                : (c <= 181 || (c < 216
                  ? (c < 192
                    ? c == 186
                    : c <= 214)
                  : (c <= 246 || (c >= 248 && c <= 705)))))
              : (c <= 721 || (c < 886
                ? (c < 750
                  ? (c < 748
                    ? (c >= 736 && c <= 740)
                    : c <= 748)
                  : (c <= 750 || (c >= 880 && c <= 884)))
                : (c <= 887 || (c < 902
                  ? (c < 895
                    ? (c >= 891 && c <= 893)
                    : c <= 895)
                  : (c <= 902 || (c >= 904 && c <= 906)))))))
            : (c <= 908 || (c < 1646
              ? (c < 1369
                ? (c < 1015
                  ? (c < 931
                    ? (c >= 910 && c <= 929)
                    : c <= 1013)
                  : (c <= 1153 || (c < 1329
                    ? (c >= 1162 && c <= 1327)
                    : c <= 1366)))
                : (c <= 1369 || (c < 1519
                  ? (c < 1488
                    ? (c >= 1376 && c <= 1416)
                    : c <= 1514)
                  : (c <= 1522 || (c >= 1568 && c <= 1610)))))
              : (c <= 1647 || (c < 1786
                ? (c < 1765
                  ? (c < 1749
                    ? (c >= 1649 && c <= 1747)
                    : c <= 1749)
                  : (c <= 1766 || (c >= 1774 && c <= 1775)))
                : (c <= 1788 || (c < 1810
                  ? (c < 1808
                    ? c == 1791
                    : c <= 1808)
                  : (c <= 1839 || (c >= 1869 && c <= 1957)))))))))
          : (c <= 1969 || (c < 2474
            ? (c < 2185
              ? (c < 2084
                ? (c < 2042
                  ? (c < 2036
                    ? (c >= 1994 && c <= 2026)
                    : c <= 2037)
                  : (c <= 2042 || (c < 2074
                    ? (c >= 2048 && c <= 2069)
                    : c <= 2074)))
                : (c <= 2084 || (c < 2144
                  ? (c < 2112
                    ? c == 2088
                    : c <= 2136)
                  : (c <= 2154 || (c >= 2160 && c <= 2183)))))
              : (c <= 2190 || (c < 2392
                ? (c < 2365
                  ? (c < 2308
                    ? (c >= 2208 && c <= 2249)
                    : c <= 2361)
                  : (c <= 2365 || c == 2384))
                : (c <= 2401 || (c < 2447
                  ? (c < 2437
                    ? (c >= 2417 && c <= 2432)
                    : c <= 2444)
                  : (c <= 2448 || (c >= 2451 && c <= 2472)))))))
            : (c <= 2480 || (c < 2575
              ? (c < 2524
                ? (c < 2493
                  ? (c < 2486
                    ? c == 2482
                    : c <= 2489)
                  : (c <= 2493 || c == 2510))
                : (c <= 2525 || (c < 2556
                  ? (c < 2544
                    ? (c >= 2527 && c <= 2529)
                    : c <= 2545)
                  : (c <= 2556 || (c >= 2565 && c <= 2570)))))
              : (c <= 2576 || (c < 2616
                ? (c < 2610
                  ? (c < 2602
                    ? (c >= 2579 && c <= 2600)
                    : c <= 2608)
                  : (c <= 2611 || (c >= 2613 && c <= 2614)))
                : (c <= 2617 || (c < 2674
                  ? (c < 2654
                    ? (c >= 2649 && c <= 2652)
                    : c <= 2654)
                  : (c <= 2676 || (c >= 2693 && c <= 2701)))))))))))
        : (c <= 2705 || (c < 3218
          ? (c < 2958
            ? (c < 2835
              ? (c < 2768
                ? (c < 2738
                  ? (c < 2730
                    ? (c >= 2707 && c <= 2728)
                    : c <= 2736)
                  : (c <= 2739 || (c < 2749
                    ? (c >= 2741 && c <= 2745)
                    : c <= 2749)))
                : (c <= 2768 || (c < 2821
                  ? (c < 2809
                    ? (c >= 2784 && c <= 2785)
                    : c <= 2809)
                  : (c <= 2828 || (c >= 2831 && c <= 2832)))))
              : (c <= 2856 || (c < 2908
                ? (c < 2869
                  ? (c < 2866
                    ? (c >= 2858 && c <= 2864)
                    : c <= 2867)
                  : (c <= 2873 || c == 2877))
                : (c <= 2909 || (c < 2947
                  ? (c < 2929
                    ? (c >= 2911 && c <= 2913)
                    : c <= 2929)
                  : (c <= 2947 || (c >= 2949 && c <= 2954)))))))
            : (c <= 2960 || (c < 3086
              ? (c < 2979
                ? (c < 2972
                  ? (c < 2969
                    ? (c >= 2962 && c <= 2965)
                    : c <= 2970)
                  : (c <= 2972 || (c >= 2974 && c <= 2975)))
                : (c <= 2980 || (c < 3024
                  ? (c < 2990
                    ? (c >= 2984 && c <= 2986)
                    : c <= 3001)
                  : (c <= 3024 || (c >= 3077 && c <= 3084)))))
              : (c <= 3088 || (c < 3165
                ? (c < 3133
                  ? (c < 3114
                    ? (c >= 3090 && c <= 3112)
                    : c <= 3129)
                  : (c <= 3133 || (c >= 3160 && c <= 3162)))
                : (c <= 3165 || (c < 3205
                  ? (c < 3200
                    ? (c >= 3168 && c <= 3169)
                    : c <= 3200)
                  : (c <= 3212 || (c >= 3214 && c <= 3216)))))))))
          : (c <= 3240 || (c < 3634
            ? (c < 3406
              ? (c < 3313
                ? (c < 3261
                  ? (c < 3253
                    ? (c >= 3242 && c <= 3251)
                    : c <= 3257)
                  : (c <= 3261 || (c < 3296
                    ? (c >= 3293 && c <= 3294)
                    : c <= 3297)))
                : (c <= 3314 || (c < 3346
                  ? (c < 3342
                    ? (c >= 3332 && c <= 3340)
                    : c <= 3344)
                  : (c <= 3386 || c == 3389))))
              : (c <= 3406 || (c < 3482
                ? (c < 3450
                  ? (c < 3423
                    ? (c >= 3412 && c <= 3414)
                    : c <= 3425)
                  : (c <= 3455 || (c >= 3461 && c <= 3478)))
                : (c <= 3505 || (c < 3520
                  ? (c < 3517
                    ? (c >= 3507 && c <= 3515)
                    : c <= 3517)
                  : (c <= 3526 || (c >= 3585 && c <= 3632)))))))
            : (c <= 3634 || (c < 3776
              ? (c < 3724
                ? (c < 3716
                  ? (c < 3713
                    ? (c >= 3648 && c <= 3654)
                    : c <= 3714)
                  : (c <= 3716 || (c >= 3718 && c <= 3722)))
                : (c <= 3747 || (c < 3762
                  ? (c < 3751
                    ? c == 3749
                    : c <= 3760)
                  : (c <= 3762 || c == 3773))))
              : (c <= 3780 || (c < 3913
                ? (c < 3840
                  ? (c < 3804
                    ? c == 3782
                    : c <= 3807)
                  : (c <= 3840 || (c >= 3904 && c <= 3911)))
                : (c <= 3948 || (c < 4159
                  ? (c < 4096
                    ? (c >= 3976 && c <= 3980)
                    : c <= 4138)
                  : (c <= 4159 || (c >= 4176 && c <= 4181)))))))))))))
      : (c <= 4189 || (c < 8130
        ? (c < 6108
          ? (c < 4802
            ? (c < 4682
              ? (c < 4256
                ? (c < 4206
                  ? (c < 4197
                    ? c == 4193
                    : c <= 4198)
                  : (c <= 4208 || (c < 4238
                    ? (c >= 4213 && c <= 4225)
                    : c <= 4238)))
                : (c <= 4293 || (c < 4304
                  ? (c < 4301
                    ? c == 4295
                    : c <= 4301)
                  : (c <= 4346 || (c >= 4348 && c <= 4680)))))
              : (c <= 4685 || (c < 4746
                ? (c < 4698
                  ? (c < 4696
                    ? (c >= 4688 && c <= 4694)
                    : c <= 4696)
                  : (c <= 4701 || (c >= 4704 && c <= 4744)))
                : (c <= 4749 || (c < 4792
                  ? (c < 4786
                    ? (c >= 4752 && c <= 4784)
                    : c <= 4789)
                  : (c <= 4798 || c == 4800))))))
            : (c <= 4805 || (c < 5761
              ? (c < 4992
                ? (c < 4882
                  ? (c < 4824
                    ? (c >= 4808 && c <= 4822)
                    : c <= 4880)
                  : (c <= 4885 || (c >= 4888 && c <= 4954)))
                : (c <= 5007 || (c < 5121
                  ? (c < 5112
                    ? (c >= 5024 && c <= 5109)
                    : c <= 5117)
                  : (c <= 5740 || (c >= 5743 && c <= 5759)))))
              : (c <= 5786 || (c < 5952
                ? (c < 5888
                  ? (c < 5870
                    ? (c >= 5792 && c <= 5866)
                    : c <= 5880)
                  : (c <= 5905 || (c >= 5919 && c <= 5937)))
                : (c <= 5969 || (c < 6016
                  ? (c < 5998
                    ? (c >= 5984 && c <= 5996)
                    : c <= 6000)
                  : (c <= 6067 || c == 6103))))))))
          : (c <= 6108 || (c < 7296
            ? (c < 6688
              ? (c < 6480
                ? (c < 6314
                  ? (c < 6272
                    ? (c >= 6176 && c <= 6264)
                    : c <= 6312)
                  : (c <= 6314 || (c < 6400
                    ? (c >= 6320 && c <= 6389)
                    : c <= 6430)))
                : (c <= 6509 || (c < 6576
                  ? (c < 6528
                    ? (c >= 6512 && c <= 6516)
                    : c <= 6571)
                  : (c <= 6601 || (c >= 6656 && c <= 6678)))))
              : (c <= 6740 || (c < 7086
                ? (c < 6981
                  ? (c < 6917
                    ? c == 6823
                    : c <= 6963)
                  : (c <= 6988 || (c >= 7043 && c <= 7072)))
                : (c <= 7087 || (c < 7245
                  ? (c < 7168
                    ? (c >= 7098 && c <= 7141)
                    : c <= 7203)
                  : (c <= 7247 || (c >= 7258 && c <= 7293)))))))
            : (c <= 7304 || (c < 7968
              ? (c < 7413
                ? (c < 7401
                  ? (c < 7357
                    ? (c >= 7312 && c <= 7354)
                    : c <= 7359)
                  : (c <= 7404 || (c >= 7406 && c <= 7411)))
                : (c <= 7414 || (c < 7680
                  ? (c < 7424
                    ? c == 7418
                    : c <= 7615)
                  : (c <= 7957 || (c >= 7960 && c <= 7965)))))
              : (c <= 8005 || (c < 8029
                ? (c < 8025
                  ? (c < 8016
                    ? (c >= 8008 && c <= 8013)
                    : c <= 8023)
                  : (c <= 8025 || c == 8027))
                : (c <= 8029 || (c < 8118
                  ? (c < 8064
                    ? (c >= 8031 && c <= 8061)
                    : c <= 8116)
                  : (c <= 8124 || c == 8126))))))))))
        : (c <= 8132 || (c < 12321
          ? (c < 8526
            ? (c < 8455
              ? (c < 8182
                ? (c < 8150
                  ? (c < 8144
                    ? (c >= 8134 && c <= 8140)
                    : c <= 8147)
                  : (c <= 8155 || (c < 8178
                    ? (c >= 8160 && c <= 8172)
                    : c <= 8180)))
                : (c <= 8188 || (c < 8336
                  ? (c < 8319
                    ? c == 8305
                    : c <= 8319)
                  : (c <= 8348 || c == 8450))))
              : (c <= 8455 || (c < 8486
                ? (c < 8472
                  ? (c < 8469
                    ? (c >= 8458 && c <= 8467)
                    : c <= 8469)
                  : (c <= 8477 || c == 8484))
                : (c <= 8486 || (c < 8508
                  ? (c < 8490
                    ? c == 8488
                    : c <= 8505)
                  : (c <= 8511 || (c >= 8517 && c <= 8521)))))))
            : (c <= 8526 || (c < 11648
              ? (c < 11520
                ? (c < 11499
                  ? (c < 11264
                    ? (c >= 8544 && c <= 8584)
                    : c <= 11492)
                  : (c <= 11502 || (c >= 11506 && c <= 11507)))
                : (c <= 11557 || (c < 11568
                  ? (c < 11565
                    ? c == 11559
                    : c <= 11565)
                  : (c <= 11623 || c == 11631))))
              : (c <= 11670 || (c < 11712
                ? (c < 11696
                  ? (c < 11688
                    ? (c >= 11680 && c <= 11686)
                    : c <= 11694)
                  : (c <= 11702 || (c >= 11704 && c <= 11710)))
                : (c <= 11718 || (c < 11736
                  ? (c < 11728
                    ? (c >= 11720 && c <= 11726)
                    : c <= 11734)
                  : (c <= 11742 || (c >= 12293 && c <= 12295)))))))))
          : (c <= 12329 || (c < 42786
            ? (c < 13312
              ? (c < 12540
                ? (c < 12353
                  ? (c < 12344
                    ? (c >= 12337 && c <= 12341)
                    : c <= 12348)
                  : (c <= 12438 || (c < 12449
                    ? (c >= 12445 && c <= 12447)
                    : c <= 12538)))
                : (c <= 12543 || (c < 12704
                  ? (c < 12593
                    ? (c >= 12549 && c <= 12591)
                    : c <= 12686)
                  : (c <= 12735 || (c >= 12784 && c <= 12799)))))
              : (c <= 19903 || (c < 42538
                ? (c < 42240
                  ? (c < 42192
                    ? (c >= 19968 && c <= 42124)
                    : c <= 42237)
                  : (c <= 42508 || (c >= 42512 && c <= 42527)))
                : (c <= 42539 || (c < 42656
                  ? (c < 42623
                    ? (c >= 42560 && c <= 42606)
                    : c <= 42653)
                  : (c <= 42735 || (c >= 42775 && c <= 42783)))))))
            : (c <= 42888 || (c < 43138
              ? (c < 42994
                ? (c < 42963
                  ? (c < 42960
                    ? (c >= 42891 && c <= 42954)
                    : c <= 42961)
                  : (c <= 42963 || (c >= 42965 && c <= 42969)))
                : (c <= 43009 || (c < 43020
                  ? (c < 43015
                    ? (c >= 43011 && c <= 43013)
                    : c <= 43018)
                  : (c <= 43042 || (c >= 43072 && c <= 43123)))))
              : (c <= 43187 || (c < 43312
                ? (c < 43261
                  ? (c < 43259
                    ? (c >= 43250 && c <= 43255)
                    : c <= 43259)
                  : (c <= 43262 || (c >= 43274 && c <= 43301)))
                : (c <= 43334 || (c < 43471
                  ? (c < 43396
                    ? (c >= 43360 && c <= 43388)
                    : c <= 43442)
                  : (c <= 43471 || (c >= 43488 && c <= 43492)))))))))))))))
    : (c <= 43503 || (c < 70727
      ? (c < 66956
        ? (c < 64914
          ? (c < 43824
            ? (c < 43712
              ? (c < 43642
                ? (c < 43584
                  ? (c < 43520
                    ? (c >= 43514 && c <= 43518)
                    : c <= 43560)
                  : (c <= 43586 || (c < 43616
                    ? (c >= 43588 && c <= 43595)
                    : c <= 43638)))
                : (c <= 43642 || (c < 43701
                  ? (c < 43697
                    ? (c >= 43646 && c <= 43695)
                    : c <= 43697)
                  : (c <= 43702 || (c >= 43705 && c <= 43709)))))
              : (c <= 43712 || (c < 43777
                ? (c < 43744
                  ? (c < 43739
                    ? c == 43714
                    : c <= 43741)
                  : (c <= 43754 || (c >= 43762 && c <= 43764)))
                : (c <= 43782 || (c < 43808
                  ? (c < 43793
                    ? (c >= 43785 && c <= 43790)
                    : c <= 43798)
                  : (c <= 43814 || (c >= 43816 && c <= 43822)))))))
            : (c <= 43866 || (c < 64287
              ? (c < 63744
                ? (c < 44032
                  ? (c < 43888
                    ? (c >= 43868 && c <= 43881)
                    : c <= 44002)
                  : (c <= 55203 || (c < 55243
                    ? (c >= 55216 && c <= 55238)
                    : c <= 55291)))
                : (c <= 64109 || (c < 64275
                  ? (c < 64256
                    ? (c >= 64112 && c <= 64217)
                    : c <= 64262)
                  : (c <= 64279 || c == 64285))))
              : (c <= 64296 || (c < 64323
                ? (c < 64318
                  ? (c < 64312
                    ? (c >= 64298 && c <= 64310)
                    : c <= 64316)
                  : (c <= 64318 || (c >= 64320 && c <= 64321)))
                : (c <= 64324 || (c < 64612
                  ? (c < 64467
                    ? (c >= 64326 && c <= 64433)
                    : c <= 64605)
                  : (c <= 64829 || (c >= 64848 && c <= 64911)))))))))
          : (c <= 64967 || (c < 65599
            ? (c < 65382
              ? (c < 65147
                ? (c < 65139
                  ? (c < 65137
                    ? (c >= 65008 && c <= 65017)
                    : c <= 65137)
                  : (c <= 65139 || (c < 65145
                    ? c == 65143
                    : c <= 65145)))
                : (c <= 65147 || (c < 65313
                  ? (c < 65151
                    ? c == 65149
                    : c <= 65276)
                  : (c <= 65338 || (c >= 65345 && c <= 65370)))))
              : (c <= 65437 || (c < 65498
                ? (c < 65482
                  ? (c < 65474
                    ? (c >= 65440 && c <= 65470)
                    : c <= 65479)
                  : (c <= 65487 || (c >= 65490 && c <= 65495)))
                : (c <= 65500 || (c < 65576
                  ? (c < 65549
                    ? (c >= 65536 && c <= 65547)
                    : c <= 65574)
                  : (c <= 65594 || (c >= 65596 && c <= 65597)))))))
            : (c <= 65613 || (c < 66464
              ? (c < 66208
                ? (c < 65856
                  ? (c < 65664
                    ? (c >= 65616 && c <= 65629)
                    : c <= 65786)
                  : (c <= 65908 || (c >= 66176 && c <= 66204)))
                : (c <= 66256 || (c < 66384
                  ? (c < 66349
                    ? (c >= 66304 && c <= 66335)
                    : c <= 66378)
                  : (c <= 66421 || (c >= 66432 && c <= 66461)))))
              : (c <= 66499 || (c < 66776
                ? (c < 66560
                  ? (c < 66513
                    ? (c >= 66504 && c <= 66511)
                    : c <= 66517)
                  : (c <= 66717 || (c >= 66736 && c <= 66771)))
                : (c <= 66811 || (c < 66928
                  ? (c < 66864
                    ? (c >= 66816 && c <= 66855)
                    : c <= 66915)
                  : (c <= 66938 || (c >= 66940 && c <= 66954)))))))))))
        : (c <= 66962 || (c < 68864
          ? (c < 67828
            ? (c < 67506
              ? (c < 67072
                ? (c < 66979
                  ? (c < 66967
                    ? (c >= 66964 && c <= 66965)
                    : c <= 66977)
                  : (c <= 66993 || (c < 67003
                    ? (c >= 66995 && c <= 67001)
                    : c <= 67004)))
                : (c <= 67382 || (c < 67456
                  ? (c < 67424
                    ? (c >= 67392 && c <= 67413)
                    : c <= 67431)
                  : (c <= 67461 || (c >= 67463 && c <= 67504)))))
              : (c <= 67514 || (c < 67644
                ? (c < 67594
                  ? (c < 67592
                    ? (c >= 67584 && c <= 67589)
                    : c <= 67592)
                  : (c <= 67637 || (c >= 67639 && c <= 67640)))
                : (c <= 67644 || (c < 67712
                  ? (c < 67680
                    ? (c >= 67647 && c <= 67669)
                    : c <= 67702)
                  : (c <= 67742 || (c >= 67808 && c <= 67826)))))))
            : (c <= 67829 || (c < 68224
              ? (c < 68096
                ? (c < 67968
                  ? (c < 67872
                    ? (c >= 67840 && c <= 67861)
                    : c <= 67897)
                  : (c <= 68023 || (c >= 68030 && c <= 68031)))
                : (c <= 68096 || (c < 68121
                  ? (c < 68117
                    ? (c >= 68112 && c <= 68115)
                    : c <= 68119)
                  : (c <= 68149 || (c >= 68192 && c <= 68220)))))
              : (c <= 68252 || (c < 68448
                ? (c < 68352
                  ? (c < 68297
                    ? (c >= 68288 && c <= 68295)
                    : c <= 68324)
                  : (c <= 68405 || (c >= 68416 && c <= 68437)))
                : (c <= 68466 || (c < 68736
                  ? (c < 68608
                    ? (c >= 68480 && c <= 68497)
                    : c <= 68680)
                  : (c <= 68786 || (c >= 68800 && c <= 68850)))))))))
          : (c <= 68899 || (c < 70106
            ? (c < 69749
              ? (c < 69488
                ? (c < 69376
                  ? (c < 69296
                    ? (c >= 69248 && c <= 69289)
                    : c <= 69297)
                  : (c <= 69404 || (c < 69424
                    ? c == 69415
                    : c <= 69445)))
                : (c <= 69505 || (c < 69635
                  ? (c < 69600
                    ? (c >= 69552 && c <= 69572)
                    : c <= 69622)
                  : (c <= 69687 || (c >= 69745 && c <= 69746)))))
              : (c <= 69749 || (c < 69959
                ? (c < 69891
                  ? (c < 69840
                    ? (c >= 69763 && c <= 69807)
                    : c <= 69864)
                  : (c <= 69926 || c == 69956))
                : (c <= 69959 || (c < 70019
                  ? (c < 70006
                    ? (c >= 69968 && c <= 70002)
                    : c <= 70006)
                  : (c <= 70066 || (c >= 70081 && c <= 70084)))))))
            : (c <= 70106 || (c < 70405
              ? (c < 70280
                ? (c < 70163
                  ? (c < 70144
                    ? c == 70108
                    : c <= 70161)
                  : (c <= 70187 || (c >= 70272 && c <= 70278)))
                : (c <= 70280 || (c < 70303
                  ? (c < 70287
                    ? (c >= 70282 && c <= 70285)
                    : c <= 70301)
                  : (c <= 70312 || (c >= 70320 && c <= 70366)))))
              : (c <= 70412 || (c < 70453
                ? (c < 70442
                  ? (c < 70419
                    ? (c >= 70415 && c <= 70416)
                    : c <= 70440)
                  : (c <= 70448 || (c >= 70450 && c <= 70451)))
                : (c <= 70457 || (c < 70493
                  ? (c < 70480
                    ? c == 70461
                    : c <= 70480)
                  : (c <= 70497 || (c >= 70656 && c <= 70708)))))))))))))
      : (c <= 70730 || (c < 119894
        ? (c < 73056
          ? (c < 72001
            ? (c < 71424
              ? (c < 71128
                ? (c < 70852
                  ? (c < 70784
                    ? (c >= 70751 && c <= 70753)
                    : c <= 70831)
                  : (c <= 70853 || (c < 71040
                    ? c == 70855
                    : c <= 71086)))
                : (c <= 71131 || (c < 71296
                  ? (c < 71236
                    ? (c >= 71168 && c <= 71215)
                    : c <= 71236)
                  : (c <= 71338 || c == 71352))))
              : (c <= 71450 || (c < 71945
                ? (c < 71840
                  ? (c < 71680
                    ? (c >= 71488 && c <= 71494)
                    : c <= 71723)
                  : (c <= 71903 || (c >= 71935 && c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71983 || c == 71999))))))
            : (c <= 72001 || (c < 72349
              ? (c < 72192
                ? (c < 72161
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72144)
                  : (c <= 72161 || c == 72163))
                : (c <= 72192 || (c < 72272
                  ? (c < 72250
                    ? (c >= 72203 && c <= 72242)
                    : c <= 72250)
                  : (c <= 72272 || (c >= 72284 && c <= 72329)))))
              : (c <= 72349 || (c < 72818
                ? (c < 72714
                  ? (c < 72704
                    ? (c >= 72368 && c <= 72440)
                    : c <= 72712)
                  : (c <= 72750 || c == 72768))
                : (c <= 72847 || (c < 72971
                  ? (c < 72968
                    ? (c >= 72960 && c <= 72966)
                    : c <= 72969)
                  : (c <= 73008 || c == 73030))))))))
          : (c <= 73061 || (c < 93952
            ? (c < 82944
              ? (c < 73728
                ? (c < 73112
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73097)
                  : (c <= 73112 || (c < 73648
                    ? (c >= 73440 && c <= 73458)
                    : c <= 73648)))
                : (c <= 74649 || (c < 77712
                  ? (c < 74880
                    ? (c >= 74752 && c <= 74862)
                    : c <= 75075)
                  : (c <= 77808 || (c >= 77824 && c <= 78894)))))
              : (c <= 83526 || (c < 92928
                ? (c < 92784
                  ? (c < 92736
                    ? (c >= 92160 && c <= 92728)
                    : c <= 92766)
                  : (c <= 92862 || (c >= 92880 && c <= 92909)))
                : (c <= 92975 || (c < 93053
                  ? (c < 93027
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93047)
                  : (c <= 93071 || (c >= 93760 && c <= 93823)))))))
            : (c <= 94026 || (c < 110589
              ? (c < 94208
                ? (c < 94176
                  ? (c < 94099
                    ? c == 94032
                    : c <= 94111)
                  : (c <= 94177 || c == 94179))
                : (c <= 100343 || (c < 110576
                  ? (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)
                  : (c <= 110579 || (c >= 110581 && c <= 110587)))))
              : (c <= 110590 || (c < 113664
                ? (c < 110948
                  ? (c < 110928
                    ? (c >= 110592 && c <= 110882)
                    : c <= 110930)
                  : (c <= 110951 || (c >= 110960 && c <= 111355)))
                : (c <= 113770 || (c < 113808
                  ? (c < 113792
                    ? (c >= 113776 && c <= 113788)
                    : c <= 113800)
                  : (c <= 113817 || (c >= 119808 && c <= 119892)))))))))))
        : (c <= 119964 || (c < 125259
          ? (c < 120572
            ? (c < 120086
              ? (c < 119995
                ? (c < 119973
                  ? (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)
                  : (c <= 119974 || (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)))
                : (c <= 119995 || (c < 120071
                  ? (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)
                  : (c <= 120074 || (c >= 120077 && c <= 120084)))))
              : (c <= 120092 || (c < 120138
                ? (c < 120128
                  ? (c < 120123
                    ? (c >= 120094 && c <= 120121)
                    : c <= 120126)
                  : (c <= 120132 || c == 120134))
                : (c <= 120144 || (c < 120514
                  ? (c < 120488
                    ? (c >= 120146 && c <= 120485)
                    : c <= 120512)
                  : (c <= 120538 || (c >= 120540 && c <= 120570)))))))
            : (c <= 120596 || (c < 123191
              ? (c < 120714
                ? (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c >= 120688 && c <= 120712)))
                : (c <= 120744 || (c < 122624
                  ? (c < 120772
                    ? (c >= 120746 && c <= 120770)
                    : c <= 120779)
                  : (c <= 122654 || (c >= 123136 && c <= 123180)))))
              : (c <= 123197 || (c < 124904
                ? (c < 123584
                  ? (c < 123536
                    ? c == 123214
                    : c <= 123565)
                  : (c <= 123627 || (c >= 124896 && c <= 124902)))
                : (c <= 124907 || (c < 124928
                  ? (c < 124912
                    ? (c >= 124909 && c <= 124910)
                    : c <= 124926)
                  : (c <= 125124 || (c >= 125184 && c <= 125251)))))))))
          : (c <= 125259 || (c < 126559
            ? (c < 126535
              ? (c < 126505
                ? (c < 126497
                  ? (c < 126469
                    ? (c >= 126464 && c <= 126467)
                    : c <= 126495)
                  : (c <= 126498 || (c < 126503
                    ? c == 126500
                    : c <= 126503)))
                : (c <= 126514 || (c < 126523
                  ? (c < 126521
                    ? (c >= 126516 && c <= 126519)
                    : c <= 126521)
                  : (c <= 126523 || c == 126530))))
              : (c <= 126535 || (c < 126548
                ? (c < 126541
                  ? (c < 126539
                    ? c == 126537
                    : c <= 126539)
                  : (c <= 126543 || (c >= 126545 && c <= 126546)))
                : (c <= 126548 || (c < 126555
                  ? (c < 126553
                    ? c == 126551
                    : c <= 126553)
                  : (c <= 126555 || c == 126557))))))
            : (c <= 126559 || (c < 126625
              ? (c < 126580
                ? (c < 126567
                  ? (c < 126564
                    ? (c >= 126561 && c <= 126562)
                    : c <= 126564)
                  : (c <= 126570 || (c >= 126572 && c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c >= 126603 && c <= 126619)))))
              : (c <= 126627 || (c < 177984
                ? (c < 131072
                  ? (c < 126635
                    ? (c >= 126629 && c <= 126633)
                    : c <= 126651)
                  : (c <= 173791 || (c >= 173824 && c <= 177976)))
                : (c <= 178205 || (c < 194560
                  ? (c < 183984
                    ? (c >= 178208 && c <= 183969)
                    : c <= 191456)
                  : (c <= 195101 || (c >= 196608 && c <= 201546)))))))))))))))));
}

static inline bool sym__rule_import_as_pattern_target_character_set_2(int32_t c) {
  return (c < 43616
    ? (c < 3782
      ? (c < 2741
        ? (c < 2042
          ? (c < 931
            ? (c < 248
              ? (c < 170
                ? (c < 'A'
                  ? (c < '0'
                    ? c == '*'
                    : c <= '9')
                  : (c <= 'Z' || (c < 'a'
                    ? c == '_'
                    : c <= 'z')))
                : (c <= 170 || (c < 186
                  ? (c < 183
                    ? c == 181
                    : c <= 183)
                  : (c <= 186 || (c < 216
                    ? (c >= 192 && c <= 214)
                    : c <= 246)))))
              : (c <= 705 || (c < 886
                ? (c < 748
                  ? (c < 736
                    ? (c >= 710 && c <= 721)
                    : c <= 740)
                  : (c <= 748 || (c < 768
                    ? c == 750
                    : c <= 884)))
                : (c <= 887 || (c < 902
                  ? (c < 895
                    ? (c >= 891 && c <= 893)
                    : c <= 895)
                  : (c <= 906 || (c < 910
                    ? c == 908
                    : c <= 929)))))))
            : (c <= 1013 || (c < 1488
              ? (c < 1376
                ? (c < 1162
                  ? (c < 1155
                    ? (c >= 1015 && c <= 1153)
                    : c <= 1159)
                  : (c <= 1327 || (c < 1369
                    ? (c >= 1329 && c <= 1366)
                    : c <= 1369)))
                : (c <= 1416 || (c < 1473
                  ? (c < 1471
                    ? (c >= 1425 && c <= 1469)
                    : c <= 1471)
                  : (c <= 1474 || (c < 1479
                    ? (c >= 1476 && c <= 1477)
                    : c <= 1479)))))
              : (c <= 1514 || (c < 1759
                ? (c < 1568
                  ? (c < 1552
                    ? (c >= 1519 && c <= 1522)
                    : c <= 1562)
                  : (c <= 1641 || (c < 1749
                    ? (c >= 1646 && c <= 1747)
                    : c <= 1756)))
                : (c <= 1768 || (c < 1808
                  ? (c < 1791
                    ? (c >= 1770 && c <= 1788)
                    : c <= 1791)
                  : (c <= 1866 || (c < 1984
                    ? (c >= 1869 && c <= 1969)
                    : c <= 2037)))))))))
          : (c <= 2042 || (c < 2556
            ? (c < 2447
              ? (c < 2185
                ? (c < 2112
                  ? (c < 2048
                    ? c == 2045
                    : c <= 2093)
                  : (c <= 2139 || (c < 2160
                    ? (c >= 2144 && c <= 2154)
                    : c <= 2183)))
                : (c <= 2190 || (c < 2406
                  ? (c < 2275
                    ? (c >= 2200 && c <= 2273)
                    : c <= 2403)
                  : (c <= 2415 || (c < 2437
                    ? (c >= 2417 && c <= 2435)
                    : c <= 2444)))))
              : (c <= 2448 || (c < 2503
                ? (c < 2482
                  ? (c < 2474
                    ? (c >= 2451 && c <= 2472)
                    : c <= 2480)
                  : (c <= 2482 || (c < 2492
                    ? (c >= 2486 && c <= 2489)
                    : c <= 2500)))
                : (c <= 2504 || (c < 2524
                  ? (c < 2519
                    ? (c >= 2507 && c <= 2510)
                    : c <= 2519)
                  : (c <= 2525 || (c < 2534
                    ? (c >= 2527 && c <= 2531)
                    : c <= 2545)))))))
            : (c <= 2556 || (c < 2631
              ? (c < 2602
                ? (c < 2565
                  ? (c < 2561
                    ? c == 2558
                    : c <= 2563)
                  : (c <= 2570 || (c < 2579
                    ? (c >= 2575 && c <= 2576)
                    : c <= 2600)))
                : (c <= 2608 || (c < 2616
                  ? (c < 2613
                    ? (c >= 2610 && c <= 2611)
                    : c <= 2614)
                  : (c <= 2617 || (c < 2622
                    ? c == 2620
                    : c <= 2626)))))
              : (c <= 2632 || (c < 2689
                ? (c < 2649
                  ? (c < 2641
                    ? (c >= 2635 && c <= 2637)
                    : c <= 2641)
                  : (c <= 2652 || (c < 2662
                    ? c == 2654
                    : c <= 2677)))
                : (c <= 2691 || (c < 2707
                  ? (c < 2703
                    ? (c >= 2693 && c <= 2701)
                    : c <= 2705)
                  : (c <= 2728 || (c < 2738
                    ? (c >= 2730 && c <= 2736)
                    : c <= 2739)))))))))))
        : (c <= 2745 || (c < 3165
          ? (c < 2949
            ? (c < 2858
              ? (c < 2790
                ? (c < 2763
                  ? (c < 2759
                    ? (c >= 2748 && c <= 2757)
                    : c <= 2761)
                  : (c <= 2765 || (c < 2784
                    ? c == 2768
                    : c <= 2787)))
                : (c <= 2799 || (c < 2821
                  ? (c < 2817
                    ? (c >= 2809 && c <= 2815)
                    : c <= 2819)
                  : (c <= 2828 || (c < 2835
                    ? (c >= 2831 && c <= 2832)
                    : c <= 2856)))))
              : (c <= 2864 || (c < 2901
                ? (c < 2876
                  ? (c < 2869
                    ? (c >= 2866 && c <= 2867)
                    : c <= 2873)
                  : (c <= 2884 || (c < 2891
                    ? (c >= 2887 && c <= 2888)
                    : c <= 2893)))
                : (c <= 2903 || (c < 2918
                  ? (c < 2911
                    ? (c >= 2908 && c <= 2909)
                    : c <= 2915)
                  : (c <= 2927 || (c < 2946
                    ? c == 2929
                    : c <= 2947)))))))
            : (c <= 2954 || (c < 3024
              ? (c < 2979
                ? (c < 2969
                  ? (c < 2962
                    ? (c >= 2958 && c <= 2960)
                    : c <= 2965)
                  : (c <= 2970 || (c < 2974
                    ? c == 2972
                    : c <= 2975)))
                : (c <= 2980 || (c < 3006
                  ? (c < 2990
                    ? (c >= 2984 && c <= 2986)
                    : c <= 3001)
                  : (c <= 3010 || (c < 3018
                    ? (c >= 3014 && c <= 3016)
                    : c <= 3021)))))
              : (c <= 3024 || (c < 3114
                ? (c < 3072
                  ? (c < 3046
                    ? c == 3031
                    : c <= 3055)
                  : (c <= 3084 || (c < 3090
                    ? (c >= 3086 && c <= 3088)
                    : c <= 3112)))
                : (c <= 3129 || (c < 3146
                  ? (c < 3142
                    ? (c >= 3132 && c <= 3140)
                    : c <= 3144)
                  : (c <= 3149 || (c < 3160
                    ? (c >= 3157 && c <= 3158)
                    : c <= 3162)))))))))
          : (c <= 3165 || (c < 3430
            ? (c < 3285
              ? (c < 3218
                ? (c < 3200
                  ? (c < 3174
                    ? (c >= 3168 && c <= 3171)
                    : c <= 3183)
                  : (c <= 3203 || (c < 3214
                    ? (c >= 3205 && c <= 3212)
                    : c <= 3216)))
                : (c <= 3240 || (c < 3260
                  ? (c < 3253
                    ? (c >= 3242 && c <= 3251)
                    : c <= 3257)
                  : (c <= 3268 || (c < 3274
                    ? (c >= 3270 && c <= 3272)
                    : c <= 3277)))))
              : (c <= 3286 || (c < 3342
                ? (c < 3302
                  ? (c < 3296
                    ? (c >= 3293 && c <= 3294)
                    : c <= 3299)
                  : (c <= 3311 || (c < 3328
                    ? (c >= 3313 && c <= 3314)
                    : c <= 3340)))
                : (c <= 3344 || (c < 3402
                  ? (c < 3398
                    ? (c >= 3346 && c <= 3396)
                    : c <= 3400)
                  : (c <= 3406 || (c < 3423
                    ? (c >= 3412 && c <= 3415)
                    : c <= 3427)))))))
            : (c <= 3439 || (c < 3558
              ? (c < 3517
                ? (c < 3461
                  ? (c < 3457
                    ? (c >= 3450 && c <= 3455)
                    : c <= 3459)
                  : (c <= 3478 || (c < 3507
                    ? (c >= 3482 && c <= 3505)
                    : c <= 3515)))
                : (c <= 3517 || (c < 3535
                  ? (c < 3530
                    ? (c >= 3520 && c <= 3526)
                    : c <= 3530)
                  : (c <= 3540 || (c < 3544
                    ? c == 3542
                    : c <= 3551)))))
              : (c <= 3567 || (c < 3716
                ? (c < 3648
                  ? (c < 3585
                    ? (c >= 3570 && c <= 3571)
                    : c <= 3642)
                  : (c <= 3662 || (c < 3713
                    ? (c >= 3664 && c <= 3673)
                    : c <= 3714)))
                : (c <= 3716 || (c < 3749
                  ? (c < 3724
                    ? (c >= 3718 && c <= 3722)
                    : c <= 3747)
                  : (c <= 3749 || (c < 3776
                    ? (c >= 3751 && c <= 3773)
                    : c <= 3780)))))))))))))
      : (c <= 3782 || (c < 8025
        ? (c < 5888
          ? (c < 4688
            ? (c < 3953
              ? (c < 3872
                ? (c < 3804
                  ? (c < 3792
                    ? (c >= 3784 && c <= 3789)
                    : c <= 3801)
                  : (c <= 3807 || (c < 3864
                    ? c == 3840
                    : c <= 3865)))
                : (c <= 3881 || (c < 3897
                  ? (c < 3895
                    ? c == 3893
                    : c <= 3895)
                  : (c <= 3897 || (c < 3913
                    ? (c >= 3902 && c <= 3911)
                    : c <= 3948)))))
              : (c <= 3972 || (c < 4256
                ? (c < 4038
                  ? (c < 3993
                    ? (c >= 3974 && c <= 3991)
                    : c <= 4028)
                  : (c <= 4038 || (c < 4176
                    ? (c >= 4096 && c <= 4169)
                    : c <= 4253)))
                : (c <= 4293 || (c < 4304
                  ? (c < 4301
                    ? c == 4295
                    : c <= 4301)
                  : (c <= 4346 || (c < 4682
                    ? (c >= 4348 && c <= 4680)
                    : c <= 4685)))))))
            : (c <= 4694 || (c < 4882
              ? (c < 4786
                ? (c < 4704
                  ? (c < 4698
                    ? c == 4696
                    : c <= 4701)
                  : (c <= 4744 || (c < 4752
                    ? (c >= 4746 && c <= 4749)
                    : c <= 4784)))
                : (c <= 4789 || (c < 4802
                  ? (c < 4800
                    ? (c >= 4792 && c <= 4798)
                    : c <= 4800)
                  : (c <= 4805 || (c < 4824
                    ? (c >= 4808 && c <= 4822)
                    : c <= 4880)))))
              : (c <= 4885 || (c < 5112
                ? (c < 4969
                  ? (c < 4957
                    ? (c >= 4888 && c <= 4954)
                    : c <= 4959)
                  : (c <= 4977 || (c < 5024
                    ? (c >= 4992 && c <= 5007)
                    : c <= 5109)))
                : (c <= 5117 || (c < 5761
                  ? (c < 5743
                    ? (c >= 5121 && c <= 5740)
                    : c <= 5759)
                  : (c <= 5786 || (c < 5870
                    ? (c >= 5792 && c <= 5866)
                    : c <= 5880)))))))))
          : (c <= 5909 || (c < 6688
            ? (c < 6176
              ? (c < 6016
                ? (c < 5984
                  ? (c < 5952
                    ? (c >= 5919 && c <= 5940)
                    : c <= 5971)
                  : (c <= 5996 || (c < 6002
                    ? (c >= 5998 && c <= 6000)
                    : c <= 6003)))
                : (c <= 6099 || (c < 6112
                  ? (c < 6108
                    ? c == 6103
                    : c <= 6109)
                  : (c <= 6121 || (c < 6159
                    ? (c >= 6155 && c <= 6157)
                    : c <= 6169)))))
              : (c <= 6264 || (c < 6470
                ? (c < 6400
                  ? (c < 6320
                    ? (c >= 6272 && c <= 6314)
                    : c <= 6389)
                  : (c <= 6430 || (c < 6448
                    ? (c >= 6432 && c <= 6443)
                    : c <= 6459)))
                : (c <= 6509 || (c < 6576
                  ? (c < 6528
                    ? (c >= 6512 && c <= 6516)
                    : c <= 6571)
                  : (c <= 6601 || (c < 6656
                    ? (c >= 6608 && c <= 6618)
                    : c <= 6683)))))))
            : (c <= 6750 || (c < 7232
              ? (c < 6847
                ? (c < 6800
                  ? (c < 6783
                    ? (c >= 6752 && c <= 6780)
                    : c <= 6793)
                  : (c <= 6809 || (c < 6832
                    ? c == 6823
                    : c <= 6845)))
                : (c <= 6862 || (c < 7019
                  ? (c < 6992
                    ? (c >= 6912 && c <= 6988)
                    : c <= 7001)
                  : (c <= 7027 || (c < 7168
                    ? (c >= 7040 && c <= 7155)
                    : c <= 7223)))))
              : (c <= 7241 || (c < 7380
                ? (c < 7312
                  ? (c < 7296
                    ? (c >= 7245 && c <= 7293)
                    : c <= 7304)
                  : (c <= 7354 || (c < 7376
                    ? (c >= 7357 && c <= 7359)
                    : c <= 7378)))
                : (c <= 7418 || (c < 7968
                  ? (c < 7960
                    ? (c >= 7424 && c <= 7957)
                    : c <= 7965)
                  : (c <= 8005 || (c < 8016
                    ? (c >= 8008 && c <= 8013)
                    : c <= 8023)))))))))))
        : (c <= 8025 || (c < 11720
          ? (c < 8458
            ? (c < 8178
              ? (c < 8126
                ? (c < 8031
                  ? (c < 8029
                    ? c == 8027
                    : c <= 8029)
                  : (c <= 8061 || (c < 8118
                    ? (c >= 8064 && c <= 8116)
                    : c <= 8124)))
                : (c <= 8126 || (c < 8144
                  ? (c < 8134
                    ? (c >= 8130 && c <= 8132)
                    : c <= 8140)
                  : (c <= 8147 || (c < 8160
                    ? (c >= 8150 && c <= 8155)
                    : c <= 8172)))))
              : (c <= 8180 || (c < 8336
                ? (c < 8276
                  ? (c < 8255
                    ? (c >= 8182 && c <= 8188)
                    : c <= 8256)
                  : (c <= 8276 || (c < 8319
                    ? c == 8305
                    : c <= 8319)))
                : (c <= 8348 || (c < 8421
                  ? (c < 8417
                    ? (c >= 8400 && c <= 8412)
                    : c <= 8417)
                  : (c <= 8432 || (c < 8455
                    ? c == 8450
                    : c <= 8455)))))))
            : (c <= 8467 || (c < 11499
              ? (c < 8490
                ? (c < 8484
                  ? (c < 8472
                    ? c == 8469
                    : c <= 8477)
                  : (c <= 8484 || (c < 8488
                    ? c == 8486
                    : c <= 8488)))
                : (c <= 8505 || (c < 8526
                  ? (c < 8517
                    ? (c >= 8508 && c <= 8511)
                    : c <= 8521)
                  : (c <= 8526 || (c < 11264
                    ? (c >= 8544 && c <= 8584)
                    : c <= 11492)))))
              : (c <= 11507 || (c < 11647
                ? (c < 11565
                  ? (c < 11559
                    ? (c >= 11520 && c <= 11557)
                    : c <= 11559)
                  : (c <= 11565 || (c < 11631
                    ? (c >= 11568 && c <= 11623)
                    : c <= 11631)))
                : (c <= 11670 || (c < 11696
                  ? (c < 11688
                    ? (c >= 11680 && c <= 11686)
                    : c <= 11694)
                  : (c <= 11702 || (c < 11712
                    ? (c >= 11704 && c <= 11710)
                    : c <= 11718)))))))))
          : (c <= 11726 || (c < 42623
            ? (c < 12540
              ? (c < 12337
                ? (c < 11744
                  ? (c < 11736
                    ? (c >= 11728 && c <= 11734)
                    : c <= 11742)
                  : (c <= 11775 || (c < 12321
                    ? (c >= 12293 && c <= 12295)
                    : c <= 12335)))
                : (c <= 12341 || (c < 12441
                  ? (c < 12353
                    ? (c >= 12344 && c <= 12348)
                    : c <= 12438)
                  : (c <= 12442 || (c < 12449
                    ? (c >= 12445 && c <= 12447)
                    : c <= 12538)))))
              : (c <= 12543 || (c < 19968
                ? (c < 12704
                  ? (c < 12593
                    ? (c >= 12549 && c <= 12591)
                    : c <= 12686)
                  : (c <= 12735 || (c < 13312
                    ? (c >= 12784 && c <= 12799)
                    : c <= 19903)))
                : (c <= 42124 || (c < 42512
                  ? (c < 42240
                    ? (c >= 42192 && c <= 42237)
                    : c <= 42508)
                  : (c <= 42539 || (c < 42612
                    ? (c >= 42560 && c <= 42607)
                    : c <= 42621)))))))
            : (c <= 42737 || (c < 43232
              ? (c < 42965
                ? (c < 42891
                  ? (c < 42786
                    ? (c >= 42775 && c <= 42783)
                    : c <= 42888)
                  : (c <= 42954 || (c < 42963
                    ? (c >= 42960 && c <= 42961)
                    : c <= 42963)))
                : (c <= 42969 || (c < 43072
                  ? (c < 43052
                    ? (c >= 42994 && c <= 43047)
                    : c <= 43052)
                  : (c <= 43123 || (c < 43216
                    ? (c >= 43136 && c <= 43205)
                    : c <= 43225)))))
              : (c <= 43255 || (c < 43471
                ? (c < 43312
                  ? (c < 43261
                    ? c == 43259
                    : c <= 43309)
                  : (c <= 43347 || (c < 43392
                    ? (c >= 43360 && c <= 43388)
                    : c <= 43456)))
                : (c <= 43481 || (c < 43584
                  ? (c < 43520
                    ? (c >= 43488 && c <= 43518)
                    : c <= 43574)
                  : (c <= 43597 || (c >= 43600 && c <= 43609)))))))))))))))
    : (c <= 43638 || (c < 71453
      ? (c < 67639
        ? (c < 65345
          ? (c < 64312
            ? (c < 43888
              ? (c < 43785
                ? (c < 43744
                  ? (c < 43739
                    ? (c >= 43642 && c <= 43714)
                    : c <= 43741)
                  : (c <= 43759 || (c < 43777
                    ? (c >= 43762 && c <= 43766)
                    : c <= 43782)))
                : (c <= 43790 || (c < 43816
                  ? (c < 43808
                    ? (c >= 43793 && c <= 43798)
                    : c <= 43814)
                  : (c <= 43822 || (c < 43868
                    ? (c >= 43824 && c <= 43866)
                    : c <= 43881)))))
              : (c <= 44010 || (c < 63744
                ? (c < 44032
                  ? (c < 44016
                    ? (c >= 44012 && c <= 44013)
                    : c <= 44025)
                  : (c <= 55203 || (c < 55243
                    ? (c >= 55216 && c <= 55238)
                    : c <= 55291)))
                : (c <= 64109 || (c < 64275
                  ? (c < 64256
                    ? (c >= 64112 && c <= 64217)
                    : c <= 64262)
                  : (c <= 64279 || (c < 64298
                    ? (c >= 64285 && c <= 64296)
                    : c <= 64310)))))))
            : (c <= 64316 || (c < 65075
              ? (c < 64612
                ? (c < 64323
                  ? (c < 64320
                    ? c == 64318
                    : c <= 64321)
                  : (c <= 64324 || (c < 64467
                    ? (c >= 64326 && c <= 64433)
                    : c <= 64605)))
                : (c <= 64829 || (c < 65008
                  ? (c < 64914
                    ? (c >= 64848 && c <= 64911)
                    : c <= 64967)
                  : (c <= 65017 || (c < 65056
                    ? (c >= 65024 && c <= 65039)
                    : c <= 65071)))))
              : (c <= 65076 || (c < 65147
                ? (c < 65139
                  ? (c < 65137
                    ? (c >= 65101 && c <= 65103)
                    : c <= 65137)
                  : (c <= 65139 || (c < 65145
                    ? c == 65143
                    : c <= 65145)))
                : (c <= 65147 || (c < 65296
                  ? (c < 65151
                    ? c == 65149
                    : c <= 65276)
                  : (c <= 65305 || (c < 65343
                    ? (c >= 65313 && c <= 65338)
                    : c <= 65343)))))))))
          : (c <= 65370 || (c < 66513
            ? (c < 65664
              ? (c < 65536
                ? (c < 65482
                  ? (c < 65474
                    ? (c >= 65382 && c <= 65470)
                    : c <= 65479)
                  : (c <= 65487 || (c < 65498
                    ? (c >= 65490 && c <= 65495)
                    : c <= 65500)))
                : (c <= 65547 || (c < 65596
                  ? (c < 65576
                    ? (c >= 65549 && c <= 65574)
                    : c <= 65594)
                  : (c <= 65597 || (c < 65616
                    ? (c >= 65599 && c <= 65613)
                    : c <= 65629)))))
              : (c <= 65786 || (c < 66304
                ? (c < 66176
                  ? (c < 66045
                    ? (c >= 65856 && c <= 65908)
                    : c <= 66045)
                  : (c <= 66204 || (c < 66272
                    ? (c >= 66208 && c <= 66256)
                    : c <= 66272)))
                : (c <= 66335 || (c < 66432
                  ? (c < 66384
                    ? (c >= 66349 && c <= 66378)
                    : c <= 66426)
                  : (c <= 66461 || (c < 66504
                    ? (c >= 66464 && c <= 66499)
                    : c <= 66511)))))))
            : (c <= 66517 || (c < 66979
              ? (c < 66864
                ? (c < 66736
                  ? (c < 66720
                    ? (c >= 66560 && c <= 66717)
                    : c <= 66729)
                  : (c <= 66771 || (c < 66816
                    ? (c >= 66776 && c <= 66811)
                    : c <= 66855)))
                : (c <= 66915 || (c < 66956
                  ? (c < 66940
                    ? (c >= 66928 && c <= 66938)
                    : c <= 66954)
                  : (c <= 66962 || (c < 66967
                    ? (c >= 66964 && c <= 66965)
                    : c <= 66977)))))
              : (c <= 66993 || (c < 67456
                ? (c < 67072
                  ? (c < 67003
                    ? (c >= 66995 && c <= 67001)
                    : c <= 67004)
                  : (c <= 67382 || (c < 67424
                    ? (c >= 67392 && c <= 67413)
                    : c <= 67431)))
                : (c <= 67461 || (c < 67584
                  ? (c < 67506
                    ? (c >= 67463 && c <= 67504)
                    : c <= 67514)
                  : (c <= 67589 || (c < 67594
                    ? c == 67592
                    : c <= 67637)))))))))))
        : (c <= 67640 || (c < 69956
          ? (c < 68448
            ? (c < 68101
              ? (c < 67828
                ? (c < 67680
                  ? (c < 67647
                    ? c == 67644
                    : c <= 67669)
                  : (c <= 67702 || (c < 67808
                    ? (c >= 67712 && c <= 67742)
                    : c <= 67826)))
                : (c <= 67829 || (c < 67968
                  ? (c < 67872
                    ? (c >= 67840 && c <= 67861)
                    : c <= 67897)
                  : (c <= 68023 || (c < 68096
                    ? (c >= 68030 && c <= 68031)
                    : c <= 68099)))))
              : (c <= 68102 || (c < 68192
                ? (c < 68121
                  ? (c < 68117
                    ? (c >= 68108 && c <= 68115)
                    : c <= 68119)
                  : (c <= 68149 || (c < 68159
                    ? (c >= 68152 && c <= 68154)
                    : c <= 68159)))
                : (c <= 68220 || (c < 68297
                  ? (c < 68288
                    ? (c >= 68224 && c <= 68252)
                    : c <= 68295)
                  : (c <= 68326 || (c < 68416
                    ? (c >= 68352 && c <= 68405)
                    : c <= 68437)))))))
            : (c <= 68466 || (c < 69424
              ? (c < 68912
                ? (c < 68736
                  ? (c < 68608
                    ? (c >= 68480 && c <= 68497)
                    : c <= 68680)
                  : (c <= 68786 || (c < 68864
                    ? (c >= 68800 && c <= 68850)
                    : c <= 68903)))
                : (c <= 68921 || (c < 69296
                  ? (c < 69291
                    ? (c >= 69248 && c <= 69289)
                    : c <= 69292)
                  : (c <= 69297 || (c < 69415
                    ? (c >= 69376 && c <= 69404)
                    : c <= 69415)))))
              : (c <= 69456 || (c < 69759
                ? (c < 69600
                  ? (c < 69552
                    ? (c >= 69488 && c <= 69509)
                    : c <= 69572)
                  : (c <= 69622 || (c < 69734
                    ? (c >= 69632 && c <= 69702)
                    : c <= 69749)))
                : (c <= 69818 || (c < 69872
                  ? (c < 69840
                    ? c == 69826
                    : c <= 69864)
                  : (c <= 69881 || (c < 69942
                    ? (c >= 69888 && c <= 69940)
                    : c <= 69951)))))))))
          : (c <= 69959 || (c < 70459
            ? (c < 70282
              ? (c < 70108
                ? (c < 70016
                  ? (c < 70006
                    ? (c >= 69968 && c <= 70003)
                    : c <= 70006)
                  : (c <= 70084 || (c < 70094
                    ? (c >= 70089 && c <= 70092)
                    : c <= 70106)))
                : (c <= 70108 || (c < 70206
                  ? (c < 70163
                    ? (c >= 70144 && c <= 70161)
                    : c <= 70199)
                  : (c <= 70206 || (c < 70280
                    ? (c >= 70272 && c <= 70278)
                    : c <= 70280)))))
              : (c <= 70285 || (c < 70405
                ? (c < 70320
                  ? (c < 70303
                    ? (c >= 70287 && c <= 70301)
                    : c <= 70312)
                  : (c <= 70378 || (c < 70400
                    ? (c >= 70384 && c <= 70393)
                    : c <= 70403)))
                : (c <= 70412 || (c < 70442
                  ? (c < 70419
                    ? (c >= 70415 && c <= 70416)
                    : c <= 70440)
                  : (c <= 70448 || (c < 70453
                    ? (c >= 70450 && c <= 70451)
                    : c <= 70457)))))))
            : (c <= 70468 || (c < 70855
              ? (c < 70502
                ? (c < 70480
                  ? (c < 70475
                    ? (c >= 70471 && c <= 70472)
                    : c <= 70477)
                  : (c <= 70480 || (c < 70493
                    ? c == 70487
                    : c <= 70499)))
                : (c <= 70508 || (c < 70736
                  ? (c < 70656
                    ? (c >= 70512 && c <= 70516)
                    : c <= 70730)
                  : (c <= 70745 || (c < 70784
                    ? (c >= 70750 && c <= 70753)
                    : c <= 70853)))))
              : (c <= 70855 || (c < 71236
                ? (c < 71096
                  ? (c < 71040
                    ? (c >= 70864 && c <= 70873)
                    : c <= 71093)
                  : (c <= 71104 || (c < 71168
                    ? (c >= 71128 && c <= 71133)
                    : c <= 71232)))
                : (c <= 71236 || (c < 71360
                  ? (c < 71296
                    ? (c >= 71248 && c <= 71257)
                    : c <= 71352)
                  : (c <= 71369 || (c >= 71424 && c <= 71450)))))))))))))
      : (c <= 71467 || (c < 119973
        ? (c < 77824
          ? (c < 72760
            ? (c < 72016
              ? (c < 71945
                ? (c < 71680
                  ? (c < 71488
                    ? (c >= 71472 && c <= 71481)
                    : c <= 71494)
                  : (c <= 71738 || (c < 71935
                    ? (c >= 71840 && c <= 71913)
                    : c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71989 || (c < 71995
                    ? (c >= 71991 && c <= 71992)
                    : c <= 72003)))))
              : (c <= 72025 || (c < 72263
                ? (c < 72154
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72151)
                  : (c <= 72161 || (c < 72192
                    ? (c >= 72163 && c <= 72164)
                    : c <= 72254)))
                : (c <= 72263 || (c < 72368
                  ? (c < 72349
                    ? (c >= 72272 && c <= 72345)
                    : c <= 72349)
                  : (c <= 72440 || (c < 72714
                    ? (c >= 72704 && c <= 72712)
                    : c <= 72758)))))))
            : (c <= 72768 || (c < 73056
              ? (c < 72968
                ? (c < 72850
                  ? (c < 72818
                    ? (c >= 72784 && c <= 72793)
                    : c <= 72847)
                  : (c <= 72871 || (c < 72960
                    ? (c >= 72873 && c <= 72886)
                    : c <= 72966)))
                : (c <= 72969 || (c < 73020
                  ? (c < 73018
                    ? (c >= 72971 && c <= 73014)
                    : c <= 73018)
                  : (c <= 73021 || (c < 73040
                    ? (c >= 73023 && c <= 73031)
                    : c <= 73049)))))
              : (c <= 73061 || (c < 73440
                ? (c < 73104
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73102)
                  : (c <= 73105 || (c < 73120
                    ? (c >= 73107 && c <= 73112)
                    : c <= 73129)))
                : (c <= 73462 || (c < 74752
                  ? (c < 73728
                    ? c == 73648
                    : c <= 74649)
                  : (c <= 74862 || (c < 77712
                    ? (c >= 74880 && c <= 75075)
                    : c <= 77808)))))))))
          : (c <= 78894 || (c < 110576
            ? (c < 93027
              ? (c < 92864
                ? (c < 92736
                  ? (c < 92160
                    ? (c >= 82944 && c <= 83526)
                    : c <= 92728)
                  : (c <= 92766 || (c < 92784
                    ? (c >= 92768 && c <= 92777)
                    : c <= 92862)))
                : (c <= 92873 || (c < 92928
                  ? (c < 92912
                    ? (c >= 92880 && c <= 92909)
                    : c <= 92916)
                  : (c <= 92982 || (c < 93008
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93017)))))
              : (c <= 93047 || (c < 94176
                ? (c < 93952
                  ? (c < 93760
                    ? (c >= 93053 && c <= 93071)
                    : c <= 93823)
                  : (c <= 94026 || (c < 94095
                    ? (c >= 94031 && c <= 94087)
                    : c <= 94111)))
                : (c <= 94177 || (c < 94208
                  ? (c < 94192
                    ? (c >= 94179 && c <= 94180)
                    : c <= 94193)
                  : (c <= 100343 || (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)))))))
            : (c <= 110579 || (c < 118528
              ? (c < 110960
                ? (c < 110592
                  ? (c < 110589
                    ? (c >= 110581 && c <= 110587)
                    : c <= 110590)
                  : (c <= 110882 || (c < 110948
                    ? (c >= 110928 && c <= 110930)
                    : c <= 110951)))
                : (c <= 111355 || (c < 113792
                  ? (c < 113776
                    ? (c >= 113664 && c <= 113770)
                    : c <= 113788)
                  : (c <= 113800 || (c < 113821
                    ? (c >= 113808 && c <= 113817)
                    : c <= 113822)))))
              : (c <= 118573 || (c < 119210
                ? (c < 119149
                  ? (c < 119141
                    ? (c >= 118576 && c <= 118598)
                    : c <= 119145)
                  : (c <= 119154 || (c < 119173
                    ? (c >= 119163 && c <= 119170)
                    : c <= 119179)))
                : (c <= 119213 || (c < 119894
                  ? (c < 119808
                    ? (c >= 119362 && c <= 119364)
                    : c <= 119892)
                  : (c <= 119964 || (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)))))))))))
        : (c <= 119974 || (c < 124912
          ? (c < 120746
            ? (c < 120134
              ? (c < 120071
                ? (c < 119995
                  ? (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)
                  : (c <= 119995 || (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)))
                : (c <= 120074 || (c < 120094
                  ? (c < 120086
                    ? (c >= 120077 && c <= 120084)
                    : c <= 120092)
                  : (c <= 120121 || (c < 120128
                    ? (c >= 120123 && c <= 120126)
                    : c <= 120132)))))
              : (c <= 120134 || (c < 120572
                ? (c < 120488
                  ? (c < 120146
                    ? (c >= 120138 && c <= 120144)
                    : c <= 120485)
                  : (c <= 120512 || (c < 120540
                    ? (c >= 120514 && c <= 120538)
                    : c <= 120570)))
                : (c <= 120596 || (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c < 120714
                    ? (c >= 120688 && c <= 120712)
                    : c <= 120744)))))))
            : (c <= 120770 || (c < 122907
              ? (c < 121476
                ? (c < 121344
                  ? (c < 120782
                    ? (c >= 120772 && c <= 120779)
                    : c <= 120831)
                  : (c <= 121398 || (c < 121461
                    ? (c >= 121403 && c <= 121452)
                    : c <= 121461)))
                : (c <= 121476 || (c < 122624
                  ? (c < 121505
                    ? (c >= 121499 && c <= 121503)
                    : c <= 121519)
                  : (c <= 122654 || (c < 122888
                    ? (c >= 122880 && c <= 122886)
                    : c <= 122904)))))
              : (c <= 122913 || (c < 123214
                ? (c < 123136
                  ? (c < 122918
                    ? (c >= 122915 && c <= 122916)
                    : c <= 122922)
                  : (c <= 123180 || (c < 123200
                    ? (c >= 123184 && c <= 123197)
                    : c <= 123209)))
                : (c <= 123214 || (c < 124896
                  ? (c < 123584
                    ? (c >= 123536 && c <= 123566)
                    : c <= 123641)
                  : (c <= 124902 || (c < 124909
                    ? (c >= 124904 && c <= 124907)
                    : c <= 124910)))))))))
          : (c <= 124926 || (c < 126557
            ? (c < 126521
              ? (c < 126469
                ? (c < 125184
                  ? (c < 125136
                    ? (c >= 124928 && c <= 125124)
                    : c <= 125142)
                  : (c <= 125259 || (c < 126464
                    ? (c >= 125264 && c <= 125273)
                    : c <= 126467)))
                : (c <= 126495 || (c < 126503
                  ? (c < 126500
                    ? (c >= 126497 && c <= 126498)
                    : c <= 126500)
                  : (c <= 126503 || (c < 126516
                    ? (c >= 126505 && c <= 126514)
                    : c <= 126519)))))
              : (c <= 126521 || (c < 126541
                ? (c < 126535
                  ? (c < 126530
                    ? c == 126523
                    : c <= 126530)
                  : (c <= 126535 || (c < 126539
                    ? c == 126537
                    : c <= 126539)))
                : (c <= 126543 || (c < 126551
                  ? (c < 126548
                    ? (c >= 126545 && c <= 126546)
                    : c <= 126548)
                  : (c <= 126551 || (c < 126555
                    ? c == 126553
                    : c <= 126555)))))))
            : (c <= 126557 || (c < 126629
              ? (c < 126580
                ? (c < 126564
                  ? (c < 126561
                    ? c == 126559
                    : c <= 126562)
                  : (c <= 126564 || (c < 126572
                    ? (c >= 126567 && c <= 126570)
                    : c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c < 126625
                    ? (c >= 126603 && c <= 126619)
                    : c <= 126627)))))
              : (c <= 126633 || (c < 178208
                ? (c < 131072
                  ? (c < 130032
                    ? (c >= 126635 && c <= 126651)
                    : c <= 130041)
                  : (c <= 173791 || (c < 177984
                    ? (c >= 173824 && c <= 177976)
                    : c <= 178205)))
                : (c <= 183969 || (c < 196608
                  ? (c < 194560
                    ? (c >= 183984 && c <= 191456)
                    : c <= 195101)
                  : (c <= 201546 || (c >= 917760 && c <= 917999)))))))))))))))));
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(61);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(57)
      if (lookahead == '\r') SKIP(57)
      if (lookahead == '!') ADVANCE(9);
      if (lookahead == '#') ADVANCE(174);
      if (lookahead == '%') ADVANCE(101);
      if (lookahead == '&') ADVANCE(105);
      if (lookahead == '(') ADVANCE(65);
      if (lookahead == ')') ADVANCE(66);
      if (lookahead == '*') ADVANCE(69);
      if (lookahead == '+') ADVANCE(97);
      if (lookahead == ',') ADVANCE(67);
      if (lookahead == '-') ADVANCE(91);
      if (lookahead == '.') ADVANCE(64);
      if (lookahead == '/') ADVANCE(98);
      if (lookahead == '0') ADVANCE(144);
      if (lookahead == ':') ADVANCE(76);
      if (lookahead == ';') ADVANCE(62);
      if (lookahead == '<') ADVANCE(111);
      if (lookahead == '=') ADVANCE(84);
      if (lookahead == '>') ADVANCE(119);
      if (lookahead == '@') ADVANCE(88);
      if (lookahead == '[') ADVANCE(85);
      if (lookahead == '\\') ADVANCE(137);
      if (lookahead == ']') ADVANCE(86);
      if (lookahead == '^') ADVANCE(107);
      if (lookahead == 'e') ADVANCE(167);
      if (lookahead == '{') ADVANCE(94);
      if (lookahead == '|') ADVANCE(93);
      if (lookahead == '}') ADVANCE(95);
      if (lookahead == '~') ADVANCE(110);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(143);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(170);
      END_STATE();
    case 1:
      if (lookahead == '\n') ADVANCE(175);
      END_STATE();
    case 2:
      if (lookahead == '\n') ADVANCE(136);
      END_STATE();
    case 3:
      if (lookahead == '\n') SKIP(3)
      if (lookahead == '\r') ADVANCE(139);
      if (lookahead == '#') ADVANCE(140);
      if (lookahead == '\\') ADVANCE(138);
      if (lookahead == '{') ADVANCE(94);
      if (lookahead == '}') ADVANCE(95);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(139);
      if (lookahead != 0) ADVANCE(140);
      END_STATE();
    case 4:
      if (lookahead == '.') ADVANCE(5);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(150);
      END_STATE();
    case 5:
      if (lookahead == '.') ADVANCE(135);
      END_STATE();
    case 6:
      if (lookahead == '/') ADVANCE(16);
      if (lookahead == '=') ADVANCE(125);
      END_STATE();
    case 7:
      if (lookahead == '<') ADVANCE(17);
      END_STATE();
    case 8:
      if (lookahead == '=') ADVANCE(116);
      END_STATE();
    case 9:
      if (lookahead == '=') ADVANCE(116);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(141);
      END_STATE();
    case 10:
      if (lookahead == '=') ADVANCE(128);
      END_STATE();
    case 11:
      if (lookahead == '=') ADVANCE(132);
      END_STATE();
    case 12:
      if (lookahead == '=') ADVANCE(126);
      END_STATE();
    case 13:
      if (lookahead == '=') ADVANCE(133);
      END_STATE();
    case 14:
      if (lookahead == '=') ADVANCE(134);
      END_STATE();
    case 15:
      if (lookahead == '=') ADVANCE(129);
      END_STATE();
    case 16:
      if (lookahead == '=') ADVANCE(127);
      END_STATE();
    case 17:
      if (lookahead == '=') ADVANCE(131);
      END_STATE();
    case 18:
      if (lookahead == '=') ADVANCE(130);
      END_STATE();
    case 19:
      if (lookahead == '>') ADVANCE(80);
      END_STATE();
    case 20:
      if (lookahead == '>') ADVANCE(18);
      END_STATE();
    case 21:
      if (lookahead == '_') ADVANCE(29);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(146);
      END_STATE();
    case 22:
      if (lookahead == '_') ADVANCE(42);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(147);
      END_STATE();
    case 23:
      if (lookahead == '_') ADVANCE(48);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(148);
      END_STATE();
    case 24:
      if (lookahead == '{') ADVANCE(56);
      END_STATE();
    case 25:
      if (lookahead == '}') ADVANCE(136);
      if (lookahead != 0) ADVANCE(25);
      END_STATE();
    case 26:
      if (lookahead == '}') ADVANCE(179);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(26);
      END_STATE();
    case 27:
      if (!eof && lookahead == 0 ||
          lookahead == '\n') ADVANCE(175);
      if (lookahead == '\r') ADVANCE(1);
      END_STATE();
    case 28:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(44);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(151);
      END_STATE();
    case 29:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(146);
      END_STATE();
    case 30:
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(30)
      if (lookahead == '\r') SKIP(30)
      if (lookahead == '!') ADVANCE(8);
      if (lookahead == '#') ADVANCE(174);
      if (lookahead == '%') ADVANCE(101);
      if (lookahead == '&') ADVANCE(105);
      if (lookahead == '(') ADVANCE(65);
      if (lookahead == '*') ADVANCE(69);
      if (lookahead == '+') ADVANCE(97);
      if (lookahead == ',') ADVANCE(67);
      if (lookahead == '-') ADVANCE(90);
      if (lookahead == '.') ADVANCE(64);
      if (lookahead == '/') ADVANCE(98);
      if (lookahead == '0') ADVANCE(144);
      if (lookahead == ':') ADVANCE(76);
      if (lookahead == ';') ADVANCE(62);
      if (lookahead == '<') ADVANCE(111);
      if (lookahead == '=') ADVANCE(84);
      if (lookahead == '>') ADVANCE(119);
      if (lookahead == '@') ADVANCE(88);
      if (lookahead == '[') ADVANCE(85);
      if (lookahead == '\\') ADVANCE(27);
      if (lookahead == '^') ADVANCE(107);
      if (lookahead == '{') ADVANCE(94);
      if (lookahead == '|') ADVANCE(93);
      if (lookahead == '~') ADVANCE(110);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(143);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(170);
      END_STATE();
    case 31:
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(31)
      if (lookahead == '\r') SKIP(31)
      if (lookahead == '!') ADVANCE(9);
      if (lookahead == '#') ADVANCE(174);
      if (lookahead == '%') ADVANCE(100);
      if (lookahead == '&') ADVANCE(104);
      if (lookahead == '(') ADVANCE(65);
      if (lookahead == ')') ADVANCE(66);
      if (lookahead == '*') ADVANCE(70);
      if (lookahead == '+') ADVANCE(96);
      if (lookahead == ',') ADVANCE(67);
      if (lookahead == '-') ADVANCE(89);
      if (lookahead == '.') ADVANCE(64);
      if (lookahead == '/') ADVANCE(99);
      if (lookahead == '0') ADVANCE(144);
      if (lookahead == ':') ADVANCE(76);
      if (lookahead == ';') ADVANCE(62);
      if (lookahead == '<') ADVANCE(112);
      if (lookahead == '=') ADVANCE(84);
      if (lookahead == '>') ADVANCE(120);
      if (lookahead == '@') ADVANCE(87);
      if (lookahead == '[') ADVANCE(85);
      if (lookahead == '\\') ADVANCE(27);
      if (lookahead == ']') ADVANCE(86);
      if (lookahead == '^') ADVANCE(106);
      if (lookahead == '{') ADVANCE(94);
      if (lookahead == '|') ADVANCE(92);
      if (lookahead == '}') ADVANCE(95);
      if (lookahead == '~') ADVANCE(110);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(143);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(170);
      END_STATE();
    case 32:
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(32)
      if (lookahead == '\r') SKIP(32)
      if (lookahead == '#') ADVANCE(174);
      if (lookahead == '%') ADVANCE(10);
      if (lookahead == '&') ADVANCE(11);
      if (lookahead == '(') ADVANCE(65);
      if (lookahead == '*') ADVANCE(71);
      if (lookahead == '+') ADVANCE(97);
      if (lookahead == '-') ADVANCE(90);
      if (lookahead == '.') ADVANCE(4);
      if (lookahead == '/') ADVANCE(6);
      if (lookahead == '0') ADVANCE(144);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == ';') ADVANCE(62);
      if (lookahead == '<') ADVANCE(7);
      if (lookahead == '=') ADVANCE(83);
      if (lookahead == '>') ADVANCE(20);
      if (lookahead == '@') ADVANCE(12);
      if (lookahead == '[') ADVANCE(85);
      if (lookahead == '\\') ADVANCE(27);
      if (lookahead == '^') ADVANCE(13);
      if (lookahead == '{') ADVANCE(94);
      if (lookahead == '|') ADVANCE(14);
      if (lookahead == '~') ADVANCE(110);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(143);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(170);
      END_STATE();
    case 33:
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(33)
      if (lookahead == '\r') SKIP(33)
      if (lookahead == '!') ADVANCE(8);
      if (lookahead == '#') ADVANCE(174);
      if (lookahead == '%') ADVANCE(101);
      if (lookahead == '&') ADVANCE(105);
      if (lookahead == '(') ADVANCE(65);
      if (lookahead == ')') ADVANCE(66);
      if (lookahead == '*') ADVANCE(69);
      if (lookahead == '+') ADVANCE(97);
      if (lookahead == ',') ADVANCE(67);
      if (lookahead == '-') ADVANCE(90);
      if (lookahead == '.') ADVANCE(63);
      if (lookahead == '/') ADVANCE(98);
      if (lookahead == ':') ADVANCE(76);
      if (lookahead == ';') ADVANCE(62);
      if (lookahead == '<') ADVANCE(111);
      if (lookahead == '=') ADVANCE(84);
      if (lookahead == '>') ADVANCE(119);
      if (lookahead == '@') ADVANCE(88);
      if (lookahead == '[') ADVANCE(85);
      if (lookahead == '\\') ADVANCE(27);
      if (lookahead == ']') ADVANCE(86);
      if (lookahead == '^') ADVANCE(107);
      if (lookahead == '|') ADVANCE(93);
      if (lookahead == '}') ADVANCE(95);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(170);
      END_STATE();
    case 34:
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(34)
      if (lookahead == '\r') SKIP(34)
      if (lookahead == '!') ADVANCE(8);
      if (lookahead == '#') ADVANCE(174);
      if (lookahead == '%') ADVANCE(101);
      if (lookahead == '&') ADVANCE(105);
      if (lookahead == '(') ADVANCE(65);
      if (lookahead == ')') ADVANCE(66);
      if (lookahead == '*') ADVANCE(69);
      if (lookahead == '+') ADVANCE(97);
      if (lookahead == ',') ADVANCE(67);
      if (lookahead == '-') ADVANCE(90);
      if (lookahead == '.') ADVANCE(63);
      if (lookahead == '/') ADVANCE(98);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == ';') ADVANCE(62);
      if (lookahead == '<') ADVANCE(111);
      if (lookahead == '=') ADVANCE(84);
      if (lookahead == '>') ADVANCE(119);
      if (lookahead == '@') ADVANCE(88);
      if (lookahead == '[') ADVANCE(85);
      if (lookahead == '\\') ADVANCE(27);
      if (lookahead == ']') ADVANCE(86);
      if (lookahead == '^') ADVANCE(107);
      if (lookahead == '|') ADVANCE(93);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(170);
      END_STATE();
    case 35:
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(35)
      if (lookahead == '\r') SKIP(35)
      if (lookahead == '#') ADVANCE(174);
      if (lookahead == '-') ADVANCE(19);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == '\\') ADVANCE(27);
      if (lookahead == 'e') ADVANCE(167);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(170);
      END_STATE();
    case 36:
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(181);
      if (lookahead == '\r') ADVANCE(181);
      if (lookahead == '#') ADVANCE(171);
      if (lookahead == '\\') ADVANCE(180);
      if (lookahead == '{') ADVANCE(45);
      if (lookahead != 0 &&
          lookahead != '}') ADVANCE(179);
      END_STATE();
    case 37:
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(37)
      if (lookahead == '\r') SKIP(37)
      if (lookahead == '#') ADVANCE(174);
      if (lookahead == '\\') ADVANCE(27);
      if (sym__rule_import_as_pattern_target_character_set_1(lookahead)) ADVANCE(177);
      END_STATE();
    case 38:
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(38)
      if (lookahead == '\r') SKIP(38)
      if (lookahead == '!') ADVANCE(8);
      if (lookahead == '#') ADVANCE(174);
      if (lookahead == '%') ADVANCE(101);
      if (lookahead == '&') ADVANCE(105);
      if (lookahead == '(') ADVANCE(65);
      if (lookahead == '*') ADVANCE(69);
      if (lookahead == '+') ADVANCE(97);
      if (lookahead == ',') ADVANCE(67);
      if (lookahead == '-') ADVANCE(90);
      if (lookahead == '.') ADVANCE(64);
      if (lookahead == '/') ADVANCE(98);
      if (lookahead == '0') ADVANCE(144);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == ';') ADVANCE(62);
      if (lookahead == '<') ADVANCE(111);
      if (lookahead == '=') ADVANCE(84);
      if (lookahead == '>') ADVANCE(119);
      if (lookahead == '@') ADVANCE(88);
      if (lookahead == '[') ADVANCE(85);
      if (lookahead == '\\') ADVANCE(27);
      if (lookahead == '^') ADVANCE(107);
      if (lookahead == '{') ADVANCE(94);
      if (lookahead == '|') ADVANCE(93);
      if (lookahead == '~') ADVANCE(110);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(143);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(170);
      END_STATE();
    case 39:
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(39)
      if (lookahead == '\r') SKIP(39)
      if (lookahead == '!') ADVANCE(9);
      if (lookahead == '#') ADVANCE(174);
      if (lookahead == '%') ADVANCE(100);
      if (lookahead == '&') ADVANCE(104);
      if (lookahead == '(') ADVANCE(65);
      if (lookahead == ')') ADVANCE(66);
      if (lookahead == '*') ADVANCE(70);
      if (lookahead == '+') ADVANCE(96);
      if (lookahead == ',') ADVANCE(67);
      if (lookahead == '-') ADVANCE(89);
      if (lookahead == '.') ADVANCE(64);
      if (lookahead == '/') ADVANCE(99);
      if (lookahead == '0') ADVANCE(144);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == ';') ADVANCE(62);
      if (lookahead == '<') ADVANCE(112);
      if (lookahead == '=') ADVANCE(84);
      if (lookahead == '>') ADVANCE(120);
      if (lookahead == '@') ADVANCE(87);
      if (lookahead == '[') ADVANCE(85);
      if (lookahead == '\\') ADVANCE(27);
      if (lookahead == ']') ADVANCE(86);
      if (lookahead == '^') ADVANCE(106);
      if (lookahead == '{') ADVANCE(94);
      if (lookahead == '|') ADVANCE(92);
      if (lookahead == '}') ADVANCE(95);
      if (lookahead == '~') ADVANCE(110);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(143);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(170);
      END_STATE();
    case 40:
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(40)
      if (lookahead == '\r') SKIP(40)
      if (lookahead == '!') ADVANCE(9);
      if (lookahead == '#') ADVANCE(174);
      if (lookahead == '%') ADVANCE(100);
      if (lookahead == '&') ADVANCE(104);
      if (lookahead == '(') ADVANCE(65);
      if (lookahead == ')') ADVANCE(66);
      if (lookahead == '*') ADVANCE(70);
      if (lookahead == '+') ADVANCE(96);
      if (lookahead == ',') ADVANCE(67);
      if (lookahead == '-') ADVANCE(89);
      if (lookahead == '.') ADVANCE(63);
      if (lookahead == '/') ADVANCE(99);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == ';') ADVANCE(62);
      if (lookahead == '<') ADVANCE(112);
      if (lookahead == '=') ADVANCE(84);
      if (lookahead == '>') ADVANCE(120);
      if (lookahead == '@') ADVANCE(87);
      if (lookahead == '[') ADVANCE(85);
      if (lookahead == '\\') ADVANCE(27);
      if (lookahead == ']') ADVANCE(86);
      if (lookahead == '^') ADVANCE(106);
      if (lookahead == '|') ADVANCE(92);
      if (lookahead == '}') ADVANCE(95);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(170);
      END_STATE();
    case 41:
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(41)
      if (lookahead == '\r') SKIP(41)
      if (lookahead == '!') ADVANCE(9);
      if (lookahead == '#') ADVANCE(174);
      if (lookahead == '%') ADVANCE(100);
      if (lookahead == '&') ADVANCE(104);
      if (lookahead == '(') ADVANCE(65);
      if (lookahead == ')') ADVANCE(66);
      if (lookahead == '*') ADVANCE(70);
      if (lookahead == '+') ADVANCE(96);
      if (lookahead == ',') ADVANCE(67);
      if (lookahead == '-') ADVANCE(89);
      if (lookahead == '.') ADVANCE(63);
      if (lookahead == '/') ADVANCE(99);
      if (lookahead == ':') ADVANCE(76);
      if (lookahead == ';') ADVANCE(62);
      if (lookahead == '<') ADVANCE(112);
      if (lookahead == '=') ADVANCE(84);
      if (lookahead == '>') ADVANCE(120);
      if (lookahead == '@') ADVANCE(87);
      if (lookahead == '[') ADVANCE(85);
      if (lookahead == '\\') ADVANCE(27);
      if (lookahead == ']') ADVANCE(86);
      if (lookahead == '^') ADVANCE(106);
      if (lookahead == '|') ADVANCE(92);
      if (lookahead == '}') ADVANCE(95);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(170);
      END_STATE();
    case 42:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(147);
      END_STATE();
    case 43:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(136);
      END_STATE();
    case 44:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(151);
      END_STATE();
    case 45:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(26);
      END_STATE();
    case 46:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(43);
      END_STATE();
    case 47:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(136);
      END_STATE();
    case 48:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(148);
      END_STATE();
    case 49:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(47);
      END_STATE();
    case 50:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(49);
      END_STATE();
    case 51:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(50);
      END_STATE();
    case 52:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(51);
      END_STATE();
    case 53:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(52);
      END_STATE();
    case 54:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(53);
      END_STATE();
    case 55:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(54);
      END_STATE();
    case 56:
      if (lookahead != 0 &&
          lookahead != '}') ADVANCE(25);
      END_STATE();
    case 57:
      if (eof) ADVANCE(61);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(57)
      if (lookahead == '\r') SKIP(57)
      if (lookahead == '!') ADVANCE(9);
      if (lookahead == '#') ADVANCE(174);
      if (lookahead == '%') ADVANCE(101);
      if (lookahead == '&') ADVANCE(105);
      if (lookahead == '(') ADVANCE(65);
      if (lookahead == ')') ADVANCE(66);
      if (lookahead == '*') ADVANCE(69);
      if (lookahead == '+') ADVANCE(97);
      if (lookahead == ',') ADVANCE(67);
      if (lookahead == '-') ADVANCE(91);
      if (lookahead == '.') ADVANCE(64);
      if (lookahead == '/') ADVANCE(98);
      if (lookahead == '0') ADVANCE(144);
      if (lookahead == ':') ADVANCE(76);
      if (lookahead == ';') ADVANCE(62);
      if (lookahead == '<') ADVANCE(111);
      if (lookahead == '=') ADVANCE(84);
      if (lookahead == '>') ADVANCE(119);
      if (lookahead == '@') ADVANCE(88);
      if (lookahead == '[') ADVANCE(85);
      if (lookahead == '\\') ADVANCE(27);
      if (lookahead == ']') ADVANCE(86);
      if (lookahead == '^') ADVANCE(107);
      if (lookahead == 'e') ADVANCE(167);
      if (lookahead == '{') ADVANCE(94);
      if (lookahead == '|') ADVANCE(93);
      if (lookahead == '}') ADVANCE(95);
      if (lookahead == '~') ADVANCE(110);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(143);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(170);
      END_STATE();
    case 58:
      if (eof) ADVANCE(61);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(58)
      if (lookahead == '\r') SKIP(58)
      if (lookahead == '!') ADVANCE(9);
      if (lookahead == '#') ADVANCE(174);
      if (lookahead == '(') ADVANCE(65);
      if (lookahead == ')') ADVANCE(66);
      if (lookahead == '*') ADVANCE(68);
      if (lookahead == '+') ADVANCE(96);
      if (lookahead == ',') ADVANCE(67);
      if (lookahead == '-') ADVANCE(89);
      if (lookahead == '.') ADVANCE(4);
      if (lookahead == '0') ADVANCE(144);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == ';') ADVANCE(62);
      if (lookahead == '<') ADVANCE(113);
      if (lookahead == '=') ADVANCE(84);
      if (lookahead == '>') ADVANCE(118);
      if (lookahead == '@') ADVANCE(87);
      if (lookahead == '[') ADVANCE(85);
      if (lookahead == '\\') ADVANCE(27);
      if (lookahead == ']') ADVANCE(86);
      if (lookahead == '{') ADVANCE(94);
      if (lookahead == '|') ADVANCE(92);
      if (lookahead == '}') ADVANCE(95);
      if (lookahead == '~') ADVANCE(110);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(143);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(170);
      END_STATE();
    case 59:
      if (eof) ADVANCE(61);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(59)
      if (lookahead == '\r') SKIP(59)
      if (lookahead == '#') ADVANCE(174);
      if (lookahead == '(') ADVANCE(65);
      if (lookahead == '*') ADVANCE(68);
      if (lookahead == '+') ADVANCE(96);
      if (lookahead == '-') ADVANCE(89);
      if (lookahead == '.') ADVANCE(4);
      if (lookahead == '0') ADVANCE(144);
      if (lookahead == '@') ADVANCE(87);
      if (lookahead == '[') ADVANCE(85);
      if (lookahead == '\\') ADVANCE(27);
      if (lookahead == 'e') ADVANCE(168);
      if (lookahead == '{') ADVANCE(94);
      if (lookahead == '~') ADVANCE(110);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(143);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(170);
      END_STATE();
    case 60:
      if (eof) ADVANCE(61);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(60)
      if (lookahead == '\r') SKIP(60)
      if (lookahead == '#') ADVANCE(174);
      if (lookahead == '(') ADVANCE(65);
      if (lookahead == '*') ADVANCE(68);
      if (lookahead == '+') ADVANCE(96);
      if (lookahead == '-') ADVANCE(89);
      if (lookahead == '.') ADVANCE(4);
      if (lookahead == '0') ADVANCE(144);
      if (lookahead == '@') ADVANCE(87);
      if (lookahead == '[') ADVANCE(85);
      if (lookahead == '\\') ADVANCE(27);
      if (lookahead == 'e') ADVANCE(169);
      if (lookahead == '{') ADVANCE(94);
      if (lookahead == '~') ADVANCE(110);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(143);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(170);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(5);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(150);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(82);
      if (lookahead == '=') ADVANCE(124);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(81);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(15);
      if (lookahead == '=') ADVANCE(124);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(130);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_COLON_EQ);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '=') ADVANCE(74);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_except);
      if (lookahead == '*') ADVANCE(79);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(170);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_except);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(170);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_except_STAR);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      if (lookahead == '=') ADVANCE(129);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(115);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_AT);
      if (lookahead == '=') ADVANCE(126);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=') ADVANCE(123);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=') ADVANCE(123);
      if (lookahead == '>') ADVANCE(80);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(134);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=') ADVANCE(122);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '/') ADVANCE(103);
      if (lookahead == '=') ADVANCE(125);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '/') ADVANCE(102);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(128);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH);
      if (lookahead == '=') ADVANCE(127);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '=') ADVANCE(132);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(133);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(131);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(109);
      if (lookahead == '=') ADVANCE(114);
      if (lookahead == '>') ADVANCE(121);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(108);
      if (lookahead == '=') ADVANCE(114);
      if (lookahead == '>') ADVANCE(121);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '=') ADVANCE(114);
      if (lookahead == '>') ADVANCE(121);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(117);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(117);
      if (lookahead == '>') ADVANCE(73);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(117);
      if (lookahead == '>') ADVANCE(72);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_LT_GT);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_AT_EQ);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH_EQ);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_STAR_STAR_EQ);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(sym_ellipsis);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(sym__not_escape_sequence);
      if (!eof && lookahead == 0) ADVANCE(175);
      if (lookahead == '\n') ADVANCE(136);
      if (lookahead == '\r') ADVANCE(2);
      if (lookahead == 'N') ADVANCE(24);
      if (lookahead == 'U') ADVANCE(55);
      if (lookahead == 'u') ADVANCE(51);
      if (lookahead == 'x') ADVANCE(49);
      if (lookahead == '"' ||
          lookahead == '\'' ||
          lookahead == '\\' ||
          lookahead == 'a' ||
          lookahead == 'b' ||
          lookahead == 'f' ||
          lookahead == 'n' ||
          lookahead == 'r' ||
          ('t' <= lookahead && lookahead <= 'v')) ADVANCE(136);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(46);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(aux_sym_format_specifier_token1);
      if (!eof && lookahead == 0) ADVANCE(140);
      if (lookahead == '\r') ADVANCE(140);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(140);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(aux_sym_format_specifier_token1);
      if (lookahead == '\r') ADVANCE(139);
      if (lookahead == '#') ADVANCE(140);
      if (lookahead == '\\') ADVANCE(138);
      if (lookahead == '\t' ||
          lookahead == 11 ||
          lookahead == '\f' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(139);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(140);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(aux_sym_format_specifier_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(140);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(sym_type_conversion);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(sym_integer);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(152);
      if (lookahead == '_') ADVANCE(145);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(28);
      if (lookahead == 'J' ||
          lookahead == 'L' ||
          lookahead == 'j' ||
          lookahead == 'l') ADVANCE(142);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(143);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(152);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(21);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(22);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(23);
      if (lookahead == '_') ADVANCE(145);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(28);
      if (lookahead == 'J' ||
          lookahead == 'L' ||
          lookahead == 'j' ||
          lookahead == 'l') ADVANCE(142);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(143);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(152);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(28);
      if (lookahead == 'J' ||
          lookahead == 'L' ||
          lookahead == 'j' ||
          lookahead == 'l') ADVANCE(142);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(143);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(29);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(142);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(146);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(42);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(142);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(147);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(48);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(142);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(148);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(sym_float);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_') ADVANCE(152);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(28);
      if (lookahead == 'J' ||
          lookahead == 'j') ADVANCE(149);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(150);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_') ADVANCE(153);
      if (lookahead == 'J' ||
          lookahead == 'j') ADVANCE(149);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(151);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(28);
      if (lookahead == 'J' ||
          lookahead == 'j') ADVANCE(149);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(150);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == 'J' ||
          lookahead == 'j') ADVANCE(149);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(151);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '*') ADVANCE(79);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(170);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'c') ADVANCE(158);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(170);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'c') ADVANCE(159);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(170);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'c') ADVANCE(160);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(170);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(161);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(170);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(162);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(170);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(163);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(170);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'p') ADVANCE(164);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(170);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'p') ADVANCE(165);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(170);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'p') ADVANCE(166);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(170);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(77);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(170);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(154);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(170);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(78);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(170);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'x') ADVANCE(155);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(170);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'x') ADVANCE(156);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(170);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'x') ADVANCE(157);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(170);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(170);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\n') ADVANCE(179);
      if (lookahead == '{') ADVANCE(173);
      if (lookahead == '}') ADVANCE(174);
      if (lookahead != 0) ADVANCE(171);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '}') ADVANCE(171);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(172);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(174);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(sym_comment);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(172);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(174);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(174);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(sym_line_continuation);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(sym_line_continuation);
      if (lookahead == '{') ADVANCE(45);
      if (lookahead != 0 &&
          lookahead != '}') ADVANCE(179);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(sym__rule_import_as_pattern_target);
      if (sym__rule_import_as_pattern_target_character_set_2(lookahead)) ADVANCE(177);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(sym_constraint);
      if (lookahead == '\n') ADVANCE(176);
      if (lookahead == '{') ADVANCE(45);
      if (lookahead != 0 &&
          lookahead != '}') ADVANCE(179);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(sym_constraint);
      if (lookahead == '{') ADVANCE(45);
      if (lookahead != 0 &&
          lookahead != '}') ADVANCE(179);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(sym_constraint);
      if (!eof && lookahead == 0 ||
          lookahead == '\n') ADVANCE(176);
      if (lookahead == '\r') ADVANCE(178);
      if (lookahead == '{') ADVANCE(45);
      if (lookahead != 0 &&
          lookahead != '}') ADVANCE(179);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(sym_constraint);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(181);
      if (lookahead == '\r') ADVANCE(181);
      if (lookahead == '#') ADVANCE(171);
      if (lookahead == '\\') ADVANCE(180);
      if (lookahead == '{') ADVANCE(45);
      if (lookahead != 0 &&
          lookahead != '}') ADVANCE(179);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(0)
      if (lookahead == '\r') SKIP(0)
      if (lookahead == 'F') ADVANCE(1);
      if (lookahead == 'N') ADVANCE(2);
      if (lookahead == 'T') ADVANCE(3);
      if (lookahead == '_') ADVANCE(4);
      if (lookahead == 'a') ADVANCE(5);
      if (lookahead == 'b') ADVANCE(6);
      if (lookahead == 'c') ADVANCE(7);
      if (lookahead == 'd') ADVANCE(8);
      if (lookahead == 'e') ADVANCE(9);
      if (lookahead == 'f') ADVANCE(10);
      if (lookahead == 'g') ADVANCE(11);
      if (lookahead == 'h') ADVANCE(12);
      if (lookahead == 'i') ADVANCE(13);
      if (lookahead == 'l') ADVANCE(14);
      if (lookahead == 'm') ADVANCE(15);
      if (lookahead == 'n') ADVANCE(16);
      if (lookahead == 'o') ADVANCE(17);
      if (lookahead == 'p') ADVANCE(18);
      if (lookahead == 'q') ADVANCE(19);
      if (lookahead == 'r') ADVANCE(20);
      if (lookahead == 's') ADVANCE(21);
      if (lookahead == 't') ADVANCE(22);
      if (lookahead == 'u') ADVANCE(23);
      if (lookahead == 'v') ADVANCE(24);
      if (lookahead == 'w') ADVANCE(25);
      if (lookahead == 'y') ADVANCE(26);
      END_STATE();
    case 1:
      if (lookahead == 'a') ADVANCE(27);
      END_STATE();
    case 2:
      if (lookahead == 'o') ADVANCE(28);
      END_STATE();
    case 3:
      if (lookahead == 'r') ADVANCE(29);
      END_STATE();
    case 4:
      ACCEPT_TOKEN(anon_sym__);
      if (lookahead == '_') ADVANCE(30);
      END_STATE();
    case 5:
      if (lookahead == 'n') ADVANCE(31);
      if (lookahead == 's') ADVANCE(32);
      if (lookahead == 'w') ADVANCE(33);
      END_STATE();
    case 6:
      if (lookahead == 'e') ADVANCE(34);
      if (lookahead == 'r') ADVANCE(35);
      END_STATE();
    case 7:
      if (lookahead == 'a') ADVANCE(36);
      if (lookahead == 'h') ADVANCE(37);
      if (lookahead == 'l') ADVANCE(38);
      if (lookahead == 'o') ADVANCE(39);
      if (lookahead == 'w') ADVANCE(40);
      END_STATE();
    case 8:
      if (lookahead == 'e') ADVANCE(41);
      END_STATE();
    case 9:
      if (lookahead == 'l') ADVANCE(42);
      if (lookahead == 'n') ADVANCE(43);
      if (lookahead == 'x') ADVANCE(44);
      END_STATE();
    case 10:
      if (lookahead == 'i') ADVANCE(45);
      if (lookahead == 'o') ADVANCE(46);
      if (lookahead == 'r') ADVANCE(47);
      END_STATE();
    case 11:
      if (lookahead == 'l') ADVANCE(48);
      if (lookahead == 'r') ADVANCE(49);
      END_STATE();
    case 12:
      if (lookahead == 'a') ADVANCE(50);
      END_STATE();
    case 13:
      if (lookahead == 'f') ADVANCE(51);
      if (lookahead == 'm') ADVANCE(52);
      if (lookahead == 'n') ADVANCE(53);
      if (lookahead == 's') ADVANCE(54);
      END_STATE();
    case 14:
      if (lookahead == 'a') ADVANCE(55);
      if (lookahead == 'o') ADVANCE(56);
      END_STATE();
    case 15:
      if (lookahead == 'a') ADVANCE(57);
      if (lookahead == 'e') ADVANCE(58);
      if (lookahead == 'o') ADVANCE(59);
      END_STATE();
    case 16:
      if (lookahead == 'o') ADVANCE(60);
      END_STATE();
    case 17:
      if (lookahead == 'n') ADVANCE(61);
      if (lookahead == 'r') ADVANCE(62);
      if (lookahead == 'u') ADVANCE(63);
      END_STATE();
    case 18:
      if (lookahead == 'a') ADVANCE(64);
      if (lookahead == 'e') ADVANCE(65);
      if (lookahead == 'r') ADVANCE(66);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(anon_sym_q);
      END_STATE();
    case 20:
      if (lookahead == 'a') ADVANCE(67);
      if (lookahead == 'e') ADVANCE(68);
      if (lookahead == 'u') ADVANCE(69);
      END_STATE();
    case 21:
      if (lookahead == 'c') ADVANCE(70);
      if (lookahead == 'h') ADVANCE(71);
      if (lookahead == 'i') ADVANCE(72);
      if (lookahead == 'k') ADVANCE(73);
      if (lookahead == 'n') ADVANCE(74);
      END_STATE();
    case 22:
      if (lookahead == 'e') ADVANCE(75);
      if (lookahead == 'h') ADVANCE(76);
      if (lookahead == 'r') ADVANCE(77);
      if (lookahead == 'y') ADVANCE(78);
      END_STATE();
    case 23:
      if (lookahead == 's') ADVANCE(79);
      END_STATE();
    case 24:
      if (lookahead == 'e') ADVANCE(80);
      END_STATE();
    case 25:
      if (lookahead == 'h') ADVANCE(81);
      if (lookahead == 'i') ADVANCE(82);
      if (lookahead == 'o') ADVANCE(83);
      if (lookahead == 'r') ADVANCE(84);
      END_STATE();
    case 26:
      if (lookahead == 'i') ADVANCE(85);
      END_STATE();
    case 27:
      if (lookahead == 'l') ADVANCE(86);
      END_STATE();
    case 28:
      if (lookahead == 'n') ADVANCE(87);
      END_STATE();
    case 29:
      if (lookahead == 'u') ADVANCE(88);
      END_STATE();
    case 30:
      if (lookahead == 'f') ADVANCE(89);
      END_STATE();
    case 31:
      if (lookahead == 'd') ADVANCE(90);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 's') ADVANCE(91);
      if (lookahead == 'y') ADVANCE(92);
      END_STATE();
    case 33:
      if (lookahead == 'a') ADVANCE(93);
      END_STATE();
    case 34:
      if (lookahead == 'n') ADVANCE(94);
      END_STATE();
    case 35:
      if (lookahead == 'e') ADVANCE(95);
      END_STATE();
    case 36:
      if (lookahead == 'c') ADVANCE(96);
      if (lookahead == 's') ADVANCE(97);
      END_STATE();
    case 37:
      if (lookahead == 'e') ADVANCE(98);
      END_STATE();
    case 38:
      if (lookahead == 'a') ADVANCE(99);
      END_STATE();
    case 39:
      if (lookahead == 'n') ADVANCE(100);
      END_STATE();
    case 40:
      if (lookahead == 'l') ADVANCE(101);
      END_STATE();
    case 41:
      if (lookahead == 'f') ADVANCE(102);
      if (lookahead == 'l') ADVANCE(103);
      END_STATE();
    case 42:
      if (lookahead == 'i') ADVANCE(104);
      if (lookahead == 's') ADVANCE(105);
      END_STATE();
    case 43:
      if (lookahead == 'v') ADVANCE(106);
      END_STATE();
    case 44:
      if (lookahead == 'c') ADVANCE(107);
      if (lookahead == 'e') ADVANCE(108);
      END_STATE();
    case 45:
      if (lookahead == 'n') ADVANCE(109);
      END_STATE();
    case 46:
      if (lookahead == 'r') ADVANCE(110);
      END_STATE();
    case 47:
      if (lookahead == 'o') ADVANCE(111);
      END_STATE();
    case 48:
      if (lookahead == 'o') ADVANCE(112);
      END_STATE();
    case 49:
      if (lookahead == 'o') ADVANCE(113);
      END_STATE();
    case 50:
      if (lookahead == 'n') ADVANCE(114);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 52:
      if (lookahead == 'p') ADVANCE(115);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 'c') ADVANCE(116);
      if (lookahead == 'p') ADVANCE(117);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_is);
      END_STATE();
    case 55:
      if (lookahead == 'm') ADVANCE(118);
      END_STATE();
    case 56:
      if (lookahead == 'c') ADVANCE(119);
      if (lookahead == 'g') ADVANCE(120);
      END_STATE();
    case 57:
      if (lookahead == 't') ADVANCE(121);
      END_STATE();
    case 58:
      if (lookahead == 's') ADVANCE(122);
      if (lookahead == 't') ADVANCE(123);
      END_STATE();
    case 59:
      if (lookahead == 'd') ADVANCE(124);
      END_STATE();
    case 60:
      if (lookahead == 'n') ADVANCE(125);
      if (lookahead == 't') ADVANCE(126);
      END_STATE();
    case 61:
      if (lookahead == 'e') ADVANCE(127);
      if (lookahead == 's') ADVANCE(128);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_or);
      END_STATE();
    case 63:
      if (lookahead == 't') ADVANCE(129);
      END_STATE();
    case 64:
      if (lookahead == 'r') ADVANCE(130);
      if (lookahead == 's') ADVANCE(131);
      END_STATE();
    case 65:
      if (lookahead == 'p') ADVANCE(132);
      END_STATE();
    case 66:
      if (lookahead == 'e') ADVANCE(133);
      if (lookahead == 'i') ADVANCE(134);
      END_STATE();
    case 67:
      if (lookahead == 'i') ADVANCE(135);
      END_STATE();
    case 68:
      if (lookahead == 's') ADVANCE(136);
      if (lookahead == 't') ADVANCE(137);
      END_STATE();
    case 69:
      if (lookahead == 'l') ADVANCE(138);
      if (lookahead == 'n') ADVANCE(139);
      END_STATE();
    case 70:
      if (lookahead == 'a') ADVANCE(140);
      if (lookahead == 'r') ADVANCE(141);
      END_STATE();
    case 71:
      if (lookahead == 'a') ADVANCE(142);
      if (lookahead == 'e') ADVANCE(143);
      END_STATE();
    case 72:
      if (lookahead == 'n') ADVANCE(144);
      END_STATE();
    case 73:
      if (lookahead == 'i') ADVANCE(145);
      END_STATE();
    case 74:
      if (lookahead == 'a') ADVANCE(146);
      END_STATE();
    case 75:
      if (lookahead == 'm') ADVANCE(147);
      END_STATE();
    case 76:
      if (lookahead == 'r') ADVANCE(148);
      END_STATE();
    case 77:
      if (lookahead == 'y') ADVANCE(149);
      END_STATE();
    case 78:
      if (lookahead == 'p') ADVANCE(150);
      END_STATE();
    case 79:
      if (lookahead == 'e') ADVANCE(151);
      END_STATE();
    case 80:
      if (lookahead == 'r') ADVANCE(152);
      END_STATE();
    case 81:
      if (lookahead == 'i') ADVANCE(153);
      END_STATE();
    case 82:
      if (lookahead == 'l') ADVANCE(154);
      if (lookahead == 't') ADVANCE(155);
      END_STATE();
    case 83:
      if (lookahead == 'r') ADVANCE(156);
      END_STATE();
    case 84:
      if (lookahead == 'a') ADVANCE(157);
      END_STATE();
    case 85:
      if (lookahead == 'e') ADVANCE(158);
      END_STATE();
    case 86:
      if (lookahead == 's') ADVANCE(159);
      END_STATE();
    case 87:
      if (lookahead == 'e') ADVANCE(160);
      END_STATE();
    case 88:
      if (lookahead == 'e') ADVANCE(161);
      END_STATE();
    case 89:
      if (lookahead == 'u') ADVANCE(162);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_and);
      END_STATE();
    case 91:
      if (lookahead == 'e') ADVANCE(163);
      END_STATE();
    case 92:
      if (lookahead == 'n') ADVANCE(164);
      END_STATE();
    case 93:
      if (lookahead == 'i') ADVANCE(165);
      END_STATE();
    case 94:
      if (lookahead == 'c') ADVANCE(166);
      END_STATE();
    case 95:
      if (lookahead == 'a') ADVANCE(167);
      END_STATE();
    case 96:
      if (lookahead == 'h') ADVANCE(168);
      END_STATE();
    case 97:
      if (lookahead == 'e') ADVANCE(169);
      END_STATE();
    case 98:
      if (lookahead == 'c') ADVANCE(170);
      END_STATE();
    case 99:
      if (lookahead == 's') ADVANCE(171);
      END_STATE();
    case 100:
      if (lookahead == 'd') ADVANCE(172);
      if (lookahead == 'f') ADVANCE(173);
      if (lookahead == 't') ADVANCE(174);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_cwl);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_def);
      if (lookahead == 'a') ADVANCE(175);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_del);
      END_STATE();
    case 104:
      if (lookahead == 'f') ADVANCE(176);
      END_STATE();
    case 105:
      if (lookahead == 'e') ADVANCE(177);
      END_STATE();
    case 106:
      if (lookahead == 'm') ADVANCE(178);
      if (lookahead == 'v') ADVANCE(179);
      END_STATE();
    case 107:
      if (lookahead == 'l') ADVANCE(180);
      END_STATE();
    case 108:
      if (lookahead == 'c') ADVANCE(181);
      END_STATE();
    case 109:
      if (lookahead == 'a') ADVANCE(182);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 111:
      if (lookahead == 'm') ADVANCE(183);
      END_STATE();
    case 112:
      if (lookahead == 'b') ADVANCE(184);
      END_STATE();
    case 113:
      if (lookahead == 'u') ADVANCE(185);
      END_STATE();
    case 114:
      if (lookahead == 'd') ADVANCE(186);
      END_STATE();
    case 115:
      if (lookahead == 'o') ADVANCE(187);
      END_STATE();
    case 116:
      if (lookahead == 'l') ADVANCE(188);
      END_STATE();
    case 117:
      if (lookahead == 'u') ADVANCE(189);
      END_STATE();
    case 118:
      if (lookahead == 'b') ADVANCE(190);
      END_STATE();
    case 119:
      if (lookahead == 'a') ADVANCE(191);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_log);
      END_STATE();
    case 121:
      if (lookahead == 'c') ADVANCE(192);
      END_STATE();
    case 122:
      if (lookahead == 's') ADVANCE(193);
      END_STATE();
    case 123:
      if (lookahead == 'a') ADVANCE(194);
      END_STATE();
    case 124:
      if (lookahead == 'u') ADVANCE(195);
      END_STATE();
    case 125:
      if (lookahead == 'l') ADVANCE(196);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_not);
      if (lookahead == 'e') ADVANCE(197);
      END_STATE();
    case 127:
      if (lookahead == 'r') ADVANCE(198);
      END_STATE();
    case 128:
      if (lookahead == 't') ADVANCE(199);
      if (lookahead == 'u') ADVANCE(200);
      END_STATE();
    case 129:
      if (lookahead == 'p') ADVANCE(201);
      END_STATE();
    case 130:
      if (lookahead == 'a') ADVANCE(202);
      END_STATE();
    case 131:
      if (lookahead == 's') ADVANCE(203);
      END_STATE();
    case 132:
      if (lookahead == 'f') ADVANCE(204);
      if (lookahead == 's') ADVANCE(205);
      END_STATE();
    case 133:
      if (lookahead == 'f') ADVANCE(206);
      END_STATE();
    case 134:
      if (lookahead == 'n') ADVANCE(207);
      if (lookahead == 'o') ADVANCE(208);
      END_STATE();
    case 135:
      if (lookahead == 's') ADVANCE(209);
      END_STATE();
    case 136:
      if (lookahead == 'o') ADVANCE(210);
      END_STATE();
    case 137:
      if (lookahead == 'r') ADVANCE(211);
      if (lookahead == 'u') ADVANCE(212);
      END_STATE();
    case 138:
      if (lookahead == 'e') ADVANCE(213);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_run);
      END_STATE();
    case 140:
      if (lookahead == 't') ADVANCE(214);
      END_STATE();
    case 141:
      if (lookahead == 'i') ADVANCE(215);
      END_STATE();
    case 142:
      if (lookahead == 'd') ADVANCE(216);
      END_STATE();
    case 143:
      if (lookahead == 'l') ADVANCE(217);
      END_STATE();
    case 144:
      if (lookahead == 'g') ADVANCE(218);
      END_STATE();
    case 145:
      if (lookahead == 'p') ADVANCE(219);
      END_STATE();
    case 146:
      if (lookahead == 'k') ADVANCE(220);
      END_STATE();
    case 147:
      if (lookahead == 'p') ADVANCE(221);
      END_STATE();
    case 148:
      if (lookahead == 'e') ADVANCE(222);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 150:
      if (lookahead == 'e') ADVANCE(223);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_use);
      END_STATE();
    case 152:
      if (lookahead == 's') ADVANCE(224);
      END_STATE();
    case 153:
      if (lookahead == 'l') ADVANCE(225);
      END_STATE();
    case 154:
      if (lookahead == 'd') ADVANCE(226);
      END_STATE();
    case 155:
      if (lookahead == 'h') ADVANCE(227);
      END_STATE();
    case 156:
      if (lookahead == 'k') ADVANCE(228);
      END_STATE();
    case 157:
      if (lookahead == 'p') ADVANCE(229);
      END_STATE();
    case 158:
      if (lookahead == 'l') ADVANCE(230);
      END_STATE();
    case 159:
      if (lookahead == 'e') ADVANCE(231);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(sym_none);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 162:
      if (lookahead == 't') ADVANCE(232);
      END_STATE();
    case 163:
      if (lookahead == 'r') ADVANCE(233);
      END_STATE();
    case 164:
      if (lookahead == 'c') ADVANCE(234);
      END_STATE();
    case 165:
      if (lookahead == 't') ADVANCE(235);
      END_STATE();
    case 166:
      if (lookahead == 'h') ADVANCE(236);
      END_STATE();
    case 167:
      if (lookahead == 'k') ADVANCE(237);
      END_STATE();
    case 168:
      if (lookahead == 'e') ADVANCE(238);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 170:
      if (lookahead == 'k') ADVANCE(239);
      END_STATE();
    case 171:
      if (lookahead == 's') ADVANCE(240);
      END_STATE();
    case 172:
      if (lookahead == 'a') ADVANCE(241);
      END_STATE();
    case 173:
      if (lookahead == 'i') ADVANCE(242);
      END_STATE();
    case 174:
      if (lookahead == 'a') ADVANCE(243);
      if (lookahead == 'i') ADVANCE(244);
      END_STATE();
    case 175:
      if (lookahead == 'u') ADVANCE(245);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_elif);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 178:
      if (lookahead == 'o') ADVANCE(246);
      END_STATE();
    case 179:
      if (lookahead == 'a') ADVANCE(247);
      END_STATE();
    case 180:
      if (lookahead == 'u') ADVANCE(248);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(anon_sym_exec);
      END_STATE();
    case 182:
      if (lookahead == 'l') ADVANCE(249);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 184:
      if (lookahead == 'a') ADVANCE(250);
      END_STATE();
    case 185:
      if (lookahead == 'p') ADVANCE(251);
      END_STATE();
    case 186:
      if (lookahead == 'o') ADVANCE(252);
      END_STATE();
    case 187:
      if (lookahead == 'r') ADVANCE(253);
      END_STATE();
    case 188:
      if (lookahead == 'u') ADVANCE(254);
      END_STATE();
    case 189:
      if (lookahead == 't') ADVANCE(255);
      END_STATE();
    case 190:
      if (lookahead == 'd') ADVANCE(256);
      END_STATE();
    case 191:
      if (lookahead == 'l') ADVANCE(257);
      END_STATE();
    case 192:
      if (lookahead == 'h') ADVANCE(258);
      END_STATE();
    case 193:
      if (lookahead == 'a') ADVANCE(259);
      END_STATE();
    case 194:
      if (lookahead == '_') ADVANCE(260);
      END_STATE();
    case 195:
      if (lookahead == 'l') ADVANCE(261);
      END_STATE();
    case 196:
      if (lookahead == 'o') ADVANCE(262);
      END_STATE();
    case 197:
      if (lookahead == 'b') ADVANCE(263);
      END_STATE();
    case 198:
      if (lookahead == 'r') ADVANCE(264);
      END_STATE();
    case 199:
      if (lookahead == 'a') ADVANCE(265);
      END_STATE();
    case 200:
      if (lookahead == 'c') ADVANCE(266);
      END_STATE();
    case 201:
      if (lookahead == 'u') ADVANCE(267);
      END_STATE();
    case 202:
      if (lookahead == 'm') ADVANCE(268);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(anon_sym_pass);
      END_STATE();
    case 204:
      if (lookahead == 'i') ADVANCE(269);
      END_STATE();
    case 205:
      if (lookahead == 'c') ADVANCE(270);
      END_STATE();
    case 206:
      if (lookahead == 'i') ADVANCE(271);
      END_STATE();
    case 207:
      if (lookahead == 't') ADVANCE(272);
      END_STATE();
    case 208:
      if (lookahead == 'r') ADVANCE(273);
      END_STATE();
    case 209:
      if (lookahead == 'e') ADVANCE(274);
      END_STATE();
    case 210:
      if (lookahead == 'u') ADVANCE(275);
      END_STATE();
    case 211:
      if (lookahead == 'i') ADVANCE(276);
      END_STATE();
    case 212:
      if (lookahead == 'r') ADVANCE(277);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(anon_sym_rule);
      if (lookahead == 'o') ADVANCE(278);
      END_STATE();
    case 214:
      if (lookahead == 't') ADVANCE(279);
      END_STATE();
    case 215:
      if (lookahead == 'p') ADVANCE(280);
      END_STATE();
    case 216:
      if (lookahead == 'o') ADVANCE(281);
      END_STATE();
    case 217:
      if (lookahead == 'l') ADVANCE(282);
      END_STATE();
    case 218:
      if (lookahead == 'u') ADVANCE(283);
      END_STATE();
    case 219:
      if (lookahead == '_') ADVANCE(284);
      END_STATE();
    case 220:
      if (lookahead == 'e') ADVANCE(285);
      END_STATE();
    case 221:
      if (lookahead == 'l') ADVANCE(286);
      END_STATE();
    case 222:
      if (lookahead == 'a') ADVANCE(287);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(anon_sym_type);
      END_STATE();
    case 224:
      if (lookahead == 'i') ADVANCE(288);
      END_STATE();
    case 225:
      if (lookahead == 'e') ADVANCE(289);
      END_STATE();
    case 226:
      if (lookahead == 'c') ADVANCE(290);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 228:
      if (lookahead == 'd') ADVANCE(291);
      END_STATE();
    case 229:
      if (lookahead == 'p') ADVANCE(292);
      END_STATE();
    case 230:
      if (lookahead == 'd') ADVANCE(293);
      END_STATE();
    case 231:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 232:
      if (lookahead == 'u') ADVANCE(294);
      END_STATE();
    case 233:
      if (lookahead == 't') ADVANCE(295);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(anon_sym_async);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 236:
      if (lookahead == 'm') ADVANCE(296);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(anon_sym_cache);
      END_STATE();
    case 239:
      if (lookahead == 'p') ADVANCE(297);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(anon_sym_conda);
      END_STATE();
    case 242:
      if (lookahead == 'g') ADVANCE(298);
      END_STATE();
    case 243:
      if (lookahead == 'i') ADVANCE(299);
      END_STATE();
    case 244:
      if (lookahead == 'n') ADVANCE(300);
      END_STATE();
    case 245:
      if (lookahead == 'l') ADVANCE(301);
      END_STATE();
    case 246:
      if (lookahead == 'd') ADVANCE(302);
      END_STATE();
    case 247:
      if (lookahead == 'r') ADVANCE(303);
      END_STATE();
    case 248:
      if (lookahead == 'd') ADVANCE(304);
      END_STATE();
    case 249:
      if (lookahead == 'l') ADVANCE(305);
      END_STATE();
    case 250:
      if (lookahead == 'l') ADVANCE(306);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(anon_sym_group);
      END_STATE();
    case 252:
      if (lookahead == 'v') ADVANCE(307);
      END_STATE();
    case 253:
      if (lookahead == 't') ADVANCE(308);
      END_STATE();
    case 254:
      if (lookahead == 'd') ADVANCE(309);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(anon_sym_input);
      END_STATE();
    case 256:
      if (lookahead == 'a') ADVANCE(310);
      END_STATE();
    case 257:
      if (lookahead == 'r') ADVANCE(311);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(anon_sym_match);
      END_STATE();
    case 259:
      if (lookahead == 'g') ADVANCE(312);
      END_STATE();
    case 260:
      if (lookahead == 'w') ADVANCE(313);
      END_STATE();
    case 261:
      if (lookahead == 'e') ADVANCE(314);
      END_STATE();
    case 262:
      if (lookahead == 'c') ADVANCE(315);
      END_STATE();
    case 263:
      if (lookahead == 'o') ADVANCE(316);
      END_STATE();
    case 264:
      if (lookahead == 'o') ADVANCE(317);
      END_STATE();
    case 265:
      if (lookahead == 'r') ADVANCE(318);
      END_STATE();
    case 266:
      if (lookahead == 'c') ADVANCE(319);
      END_STATE();
    case 267:
      if (lookahead == 't') ADVANCE(320);
      END_STATE();
    case 268:
      if (lookahead == 's') ADVANCE(321);
      END_STATE();
    case 269:
      if (lookahead == 'l') ADVANCE(322);
      END_STATE();
    case 270:
      if (lookahead == 'h') ADVANCE(323);
      END_STATE();
    case 271:
      if (lookahead == 'x') ADVANCE(324);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(anon_sym_print);
      END_STATE();
    case 273:
      if (lookahead == 'i') ADVANCE(325);
      END_STATE();
    case 274:
      ACCEPT_TOKEN(anon_sym_raise);
      END_STATE();
    case 275:
      if (lookahead == 'r') ADVANCE(326);
      END_STATE();
    case 276:
      if (lookahead == 'e') ADVANCE(327);
      END_STATE();
    case 277:
      if (lookahead == 'n') ADVANCE(328);
      END_STATE();
    case 278:
      if (lookahead == 'r') ADVANCE(329);
      END_STATE();
    case 279:
      if (lookahead == 'e') ADVANCE(330);
      END_STATE();
    case 280:
      if (lookahead == 't') ADVANCE(331);
      END_STATE();
    case 281:
      if (lookahead == 'w') ADVANCE(332);
      END_STATE();
    case 282:
      ACCEPT_TOKEN(anon_sym_shell);
      END_STATE();
    case 283:
      if (lookahead == 'l') ADVANCE(333);
      END_STATE();
    case 284:
      if (lookahead == 'v') ADVANCE(334);
      END_STATE();
    case 285:
      if (lookahead == 'f') ADVANCE(335);
      END_STATE();
    case 286:
      if (lookahead == 'a') ADVANCE(336);
      END_STATE();
    case 287:
      if (lookahead == 'd') ADVANCE(337);
      END_STATE();
    case 288:
      if (lookahead == 'o') ADVANCE(338);
      END_STATE();
    case 289:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 290:
      if (lookahead == 'a') ADVANCE(339);
      END_STATE();
    case 291:
      if (lookahead == 'i') ADVANCE(340);
      END_STATE();
    case 292:
      if (lookahead == 'e') ADVANCE(341);
      END_STATE();
    case 293:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 294:
      if (lookahead == 'r') ADVANCE(342);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(anon_sym_assert);
      END_STATE();
    case 296:
      if (lookahead == 'a') ADVANCE(343);
      END_STATE();
    case 297:
      if (lookahead == 'o') ADVANCE(344);
      END_STATE();
    case 298:
      ACCEPT_TOKEN(anon_sym_config);
      if (lookahead == 'f') ADVANCE(345);
      END_STATE();
    case 299:
      if (lookahead == 'n') ADVANCE(346);
      END_STATE();
    case 300:
      if (lookahead == 'u') ADVANCE(347);
      END_STATE();
    case 301:
      if (lookahead == 't') ADVANCE(348);
      END_STATE();
    case 302:
      if (lookahead == 'u') ADVANCE(349);
      END_STATE();
    case 303:
      if (lookahead == 's') ADVANCE(350);
      END_STATE();
    case 304:
      if (lookahead == 'e') ADVANCE(351);
      END_STATE();
    case 305:
      if (lookahead == 'y') ADVANCE(352);
      END_STATE();
    case 306:
      ACCEPT_TOKEN(anon_sym_global);
      END_STATE();
    case 307:
      if (lookahead == 'e') ADVANCE(353);
      END_STATE();
    case 308:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 309:
      if (lookahead == 'e') ADVANCE(354);
      END_STATE();
    case 310:
      ACCEPT_TOKEN(anon_sym_lambda);
      END_STATE();
    case 311:
      if (lookahead == 'u') ADVANCE(355);
      END_STATE();
    case 312:
      if (lookahead == 'e') ADVANCE(356);
      END_STATE();
    case 313:
      if (lookahead == 'r') ADVANCE(357);
      END_STATE();
    case 314:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 315:
      if (lookahead == 'a') ADVANCE(358);
      END_STATE();
    case 316:
      if (lookahead == 'o') ADVANCE(359);
      END_STATE();
    case 317:
      if (lookahead == 'r') ADVANCE(360);
      END_STATE();
    case 318:
      if (lookahead == 't') ADVANCE(361);
      END_STATE();
    case 319:
      if (lookahead == 'e') ADVANCE(362);
      END_STATE();
    case 320:
      ACCEPT_TOKEN(anon_sym_output);
      END_STATE();
    case 321:
      ACCEPT_TOKEN(anon_sym_params);
      END_STATE();
    case 322:
      if (lookahead == 'e') ADVANCE(363);
      END_STATE();
    case 323:
      if (lookahead == 'e') ADVANCE(364);
      END_STATE();
    case 324:
      ACCEPT_TOKEN(anon_sym_prefix);
      END_STATE();
    case 325:
      if (lookahead == 't') ADVANCE(365);
      END_STATE();
    case 326:
      if (lookahead == 'c') ADVANCE(366);
      END_STATE();
    case 327:
      if (lookahead == 's') ADVANCE(367);
      END_STATE();
    case 328:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 329:
      if (lookahead == 'd') ADVANCE(368);
      END_STATE();
    case 330:
      if (lookahead == 'r') ADVANCE(369);
      END_STATE();
    case 331:
      ACCEPT_TOKEN(anon_sym_script);
      END_STATE();
    case 332:
      ACCEPT_TOKEN(anon_sym_shadow);
      END_STATE();
    case 333:
      if (lookahead == 'a') ADVANCE(370);
      END_STATE();
    case 334:
      if (lookahead == 'a') ADVANCE(371);
      END_STATE();
    case 335:
      if (lookahead == 'i') ADVANCE(372);
      END_STATE();
    case 336:
      if (lookahead == 't') ADVANCE(373);
      END_STATE();
    case 337:
      if (lookahead == 's') ADVANCE(374);
      END_STATE();
    case 338:
      if (lookahead == 'n') ADVANCE(375);
      END_STATE();
    case 339:
      if (lookahead == 'r') ADVANCE(376);
      END_STATE();
    case 340:
      if (lookahead == 'r') ADVANCE(377);
      END_STATE();
    case 341:
      if (lookahead == 'r') ADVANCE(378);
      END_STATE();
    case 342:
      if (lookahead == 'e') ADVANCE(379);
      END_STATE();
    case 343:
      if (lookahead == 'r') ADVANCE(380);
      END_STATE();
    case 344:
      if (lookahead == 'i') ADVANCE(381);
      END_STATE();
    case 345:
      if (lookahead == 'i') ADVANCE(382);
      END_STATE();
    case 346:
      if (lookahead == 'e') ADVANCE(383);
      END_STATE();
    case 347:
      if (lookahead == 'e') ADVANCE(384);
      END_STATE();
    case 348:
      if (lookahead == '_') ADVANCE(385);
      END_STATE();
    case 349:
      if (lookahead == 'l') ADVANCE(386);
      END_STATE();
    case 350:
      ACCEPT_TOKEN(anon_sym_envvars);
      END_STATE();
    case 351:
      ACCEPT_TOKEN(anon_sym_exclude);
      END_STATE();
    case 352:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 353:
      if (lookahead == 'r') ADVANCE(387);
      END_STATE();
    case 354:
      ACCEPT_TOKEN(anon_sym_include);
      END_STATE();
    case 355:
      if (lookahead == 'l') ADVANCE(388);
      END_STATE();
    case 356:
      ACCEPT_TOKEN(anon_sym_message);
      END_STATE();
    case 357:
      if (lookahead == 'a') ADVANCE(389);
      END_STATE();
    case 358:
      if (lookahead == 'l') ADVANCE(390);
      END_STATE();
    case 359:
      if (lookahead == 'k') ADVANCE(391);
      END_STATE();
    case 360:
      ACCEPT_TOKEN(anon_sym_onerror);
      END_STATE();
    case 361:
      ACCEPT_TOKEN(anon_sym_onstart);
      END_STATE();
    case 362:
      if (lookahead == 's') ADVANCE(392);
      END_STATE();
    case 363:
      ACCEPT_TOKEN(anon_sym_pepfile);
      END_STATE();
    case 364:
      if (lookahead == 'm') ADVANCE(393);
      END_STATE();
    case 365:
      if (lookahead == 'y') ADVANCE(394);
      END_STATE();
    case 366:
      if (lookahead == 'e') ADVANCE(395);
      END_STATE();
    case 367:
      ACCEPT_TOKEN(anon_sym_retries);
      END_STATE();
    case 368:
      if (lookahead == 'e') ADVANCE(396);
      END_STATE();
    case 369:
      if (lookahead == 'g') ADVANCE(397);
      END_STATE();
    case 370:
      if (lookahead == 'r') ADVANCE(398);
      END_STATE();
    case 371:
      if (lookahead == 'l') ADVANCE(399);
      END_STATE();
    case 372:
      if (lookahead == 'l') ADVANCE(400);
      END_STATE();
    case 373:
      if (lookahead == 'e') ADVANCE(401);
      END_STATE();
    case 374:
      ACCEPT_TOKEN(anon_sym_threads);
      END_STATE();
    case 375:
      ACCEPT_TOKEN(anon_sym_version);
      END_STATE();
    case 376:
      if (lookahead == 'd') ADVANCE(402);
      END_STATE();
    case 377:
      ACCEPT_TOKEN(anon_sym_workdir);
      END_STATE();
    case 378:
      ACCEPT_TOKEN(anon_sym_wrapper);
      END_STATE();
    case 379:
      if (lookahead == '_') ADVANCE(403);
      END_STATE();
    case 380:
      if (lookahead == 'k') ADVANCE(404);
      END_STATE();
    case 381:
      if (lookahead == 'n') ADVANCE(405);
      END_STATE();
    case 382:
      if (lookahead == 'l') ADVANCE(406);
      END_STATE();
    case 383:
      if (lookahead == 'r') ADVANCE(407);
      END_STATE();
    case 384:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 385:
      if (lookahead == 't') ADVANCE(408);
      END_STATE();
    case 386:
      if (lookahead == 'e') ADVANCE(409);
      END_STATE();
    case 387:
      ACCEPT_TOKEN(anon_sym_handover);
      END_STATE();
    case 388:
      if (lookahead == 'e') ADVANCE(410);
      END_STATE();
    case 389:
      if (lookahead == 'p') ADVANCE(411);
      END_STATE();
    case 390:
      ACCEPT_TOKEN(anon_sym_nonlocal);
      END_STATE();
    case 391:
      ACCEPT_TOKEN(anon_sym_notebook);
      END_STATE();
    case 392:
      if (lookahead == 's') ADVANCE(412);
      END_STATE();
    case 393:
      if (lookahead == 'a') ADVANCE(413);
      END_STATE();
    case 394:
      ACCEPT_TOKEN(anon_sym_priority);
      END_STATE();
    case 395:
      if (lookahead == 's') ADVANCE(414);
      END_STATE();
    case 396:
      if (lookahead == 'r') ADVANCE(415);
      END_STATE();
    case 397:
      if (lookahead == 'a') ADVANCE(416);
      END_STATE();
    case 398:
      if (lookahead == 'i') ADVANCE(417);
      END_STATE();
    case 399:
      if (lookahead == 'i') ADVANCE(418);
      END_STATE();
    case 400:
      if (lookahead == 'e') ADVANCE(419);
      END_STATE();
    case 401:
      if (lookahead == '_') ADVANCE(420);
      END_STATE();
    case 402:
      if (lookahead == '_') ADVANCE(421);
      END_STATE();
    case 403:
      if (lookahead == '_') ADVANCE(422);
      END_STATE();
    case 404:
      ACCEPT_TOKEN(anon_sym_benchmark);
      END_STATE();
    case 405:
      if (lookahead == 't') ADVANCE(423);
      END_STATE();
    case 406:
      if (lookahead == 'e') ADVANCE(424);
      END_STATE();
    case 407:
      ACCEPT_TOKEN(anon_sym_container);
      END_STATE();
    case 408:
      if (lookahead == 'a') ADVANCE(425);
      END_STATE();
    case 409:
      if (lookahead == 's') ADVANCE(426);
      END_STATE();
    case 410:
      ACCEPT_TOKEN(anon_sym_localrule);
      if (lookahead == 's') ADVANCE(427);
      END_STATE();
    case 411:
      if (lookahead == 'p') ADVANCE(428);
      END_STATE();
    case 412:
      ACCEPT_TOKEN(anon_sym_onsuccess);
      END_STATE();
    case 413:
      ACCEPT_TOKEN(anon_sym_pepschema);
      END_STATE();
    case 414:
      ACCEPT_TOKEN(anon_sym_resources);
      END_STATE();
    case 415:
      ACCEPT_TOKEN(anon_sym_ruleorder);
      END_STATE();
    case 416:
      if (lookahead == 't') ADVANCE(429);
      END_STATE();
    case 417:
      if (lookahead == 't') ADVANCE(430);
      END_STATE();
    case 418:
      if (lookahead == 'd') ADVANCE(431);
      END_STATE();
    case 419:
      ACCEPT_TOKEN(anon_sym_snakefile);
      END_STATE();
    case 420:
      if (lookahead == 'e') ADVANCE(432);
      END_STATE();
    case 421:
      if (lookahead == 'c') ADVANCE(433);
      END_STATE();
    case 422:
      ACCEPT_TOKEN(anon_sym___future__);
      END_STATE();
    case 423:
      ACCEPT_TOKEN(anon_sym_checkpoint);
      END_STATE();
    case 424:
      ACCEPT_TOKEN(anon_sym_configfile);
      END_STATE();
    case 425:
      if (lookahead == 'r') ADVANCE(434);
      END_STATE();
    case 426:
      ACCEPT_TOKEN(anon_sym_envmodules);
      END_STATE();
    case 427:
      ACCEPT_TOKEN(anon_sym_localrules);
      END_STATE();
    case 428:
      if (lookahead == 'e') ADVANCE(435);
      END_STATE();
    case 429:
      if (lookahead == 'h') ADVANCE(436);
      END_STATE();
    case 430:
      if (lookahead == 'y') ADVANCE(437);
      END_STATE();
    case 431:
      if (lookahead == 'a') ADVANCE(438);
      END_STATE();
    case 432:
      if (lookahead == 'n') ADVANCE(439);
      END_STATE();
    case 433:
      if (lookahead == 'o') ADVANCE(440);
      END_STATE();
    case 434:
      if (lookahead == 'g') ADVANCE(441);
      END_STATE();
    case 435:
      if (lookahead == 'r') ADVANCE(442);
      END_STATE();
    case 436:
      if (lookahead == 'e') ADVANCE(443);
      END_STATE();
    case 437:
      ACCEPT_TOKEN(anon_sym_singularity);
      END_STATE();
    case 438:
      if (lookahead == 't') ADVANCE(444);
      END_STATE();
    case 439:
      if (lookahead == 'g') ADVANCE(445);
      END_STATE();
    case 440:
      if (lookahead == 'n') ADVANCE(446);
      END_STATE();
    case 441:
      if (lookahead == 'e') ADVANCE(447);
      END_STATE();
    case 442:
      ACCEPT_TOKEN(anon_sym_meta_wrapper);
      END_STATE();
    case 443:
      if (lookahead == 'r') ADVANCE(448);
      END_STATE();
    case 444:
      if (lookahead == 'i') ADVANCE(449);
      END_STATE();
    case 445:
      if (lookahead == 'i') ADVANCE(450);
      END_STATE();
    case 446:
      if (lookahead == 's') ADVANCE(451);
      END_STATE();
    case 447:
      if (lookahead == 't') ADVANCE(452);
      END_STATE();
    case 448:
      ACCEPT_TOKEN(anon_sym_scattergather);
      END_STATE();
    case 449:
      if (lookahead == 'o') ADVANCE(453);
      END_STATE();
    case 450:
      if (lookahead == 'n') ADVANCE(454);
      END_STATE();
    case 451:
      if (lookahead == 't') ADVANCE(455);
      END_STATE();
    case 452:
      ACCEPT_TOKEN(anon_sym_default_target);
      END_STATE();
    case 453:
      if (lookahead == 'n') ADVANCE(456);
      END_STATE();
    case 454:
      if (lookahead == 'e') ADVANCE(457);
      END_STATE();
    case 455:
      if (lookahead == 'r') ADVANCE(458);
      END_STATE();
    case 456:
      ACCEPT_TOKEN(anon_sym_skip_validation);
      END_STATE();
    case 457:
      ACCEPT_TOKEN(anon_sym_template_engine);
      END_STATE();
    case 458:
      if (lookahead == 'a') ADVANCE(459);
      END_STATE();
    case 459:
      if (lookahead == 'i') ADVANCE(460);
      END_STATE();
    case 460:
      if (lookahead == 'n') ADVANCE(461);
      END_STATE();
    case 461:
      if (lookahead == 't') ADVANCE(462);
      END_STATE();
    case 462:
      if (lookahead == 's') ADVANCE(463);
      END_STATE();
    case 463:
      ACCEPT_TOKEN(anon_sym_wildcard_constraints);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 58, .external_lex_state = 2},
  [2] = {.lex_state = 58, .external_lex_state = 3},
  [3] = {.lex_state = 58, .external_lex_state = 3},
  [4] = {.lex_state = 58, .external_lex_state = 3},
  [5] = {.lex_state = 58, .external_lex_state = 3},
  [6] = {.lex_state = 58, .external_lex_state = 3},
  [7] = {.lex_state = 58, .external_lex_state = 3},
  [8] = {.lex_state = 58, .external_lex_state = 3},
  [9] = {.lex_state = 58, .external_lex_state = 3},
  [10] = {.lex_state = 58, .external_lex_state = 3},
  [11] = {.lex_state = 58, .external_lex_state = 3},
  [12] = {.lex_state = 58, .external_lex_state = 3},
  [13] = {.lex_state = 58, .external_lex_state = 3},
  [14] = {.lex_state = 58, .external_lex_state = 3},
  [15] = {.lex_state = 58, .external_lex_state = 3},
  [16] = {.lex_state = 58, .external_lex_state = 3},
  [17] = {.lex_state = 58, .external_lex_state = 3},
  [18] = {.lex_state = 58, .external_lex_state = 3},
  [19] = {.lex_state = 58, .external_lex_state = 3},
  [20] = {.lex_state = 58, .external_lex_state = 3},
  [21] = {.lex_state = 58, .external_lex_state = 3},
  [22] = {.lex_state = 58, .external_lex_state = 3},
  [23] = {.lex_state = 58, .external_lex_state = 3},
  [24] = {.lex_state = 58, .external_lex_state = 3},
  [25] = {.lex_state = 58, .external_lex_state = 3},
  [26] = {.lex_state = 58, .external_lex_state = 3},
  [27] = {.lex_state = 58, .external_lex_state = 3},
  [28] = {.lex_state = 58, .external_lex_state = 3},
  [29] = {.lex_state = 58, .external_lex_state = 3},
  [30] = {.lex_state = 58, .external_lex_state = 3},
  [31] = {.lex_state = 58, .external_lex_state = 3},
  [32] = {.lex_state = 58, .external_lex_state = 3},
  [33] = {.lex_state = 58, .external_lex_state = 3},
  [34] = {.lex_state = 58, .external_lex_state = 3},
  [35] = {.lex_state = 58, .external_lex_state = 3},
  [36] = {.lex_state = 58, .external_lex_state = 3},
  [37] = {.lex_state = 58, .external_lex_state = 3},
  [38] = {.lex_state = 58, .external_lex_state = 3},
  [39] = {.lex_state = 58, .external_lex_state = 3},
  [40] = {.lex_state = 58, .external_lex_state = 3},
  [41] = {.lex_state = 58, .external_lex_state = 3},
  [42] = {.lex_state = 58, .external_lex_state = 3},
  [43] = {.lex_state = 58, .external_lex_state = 3},
  [44] = {.lex_state = 58, .external_lex_state = 3},
  [45] = {.lex_state = 58, .external_lex_state = 3},
  [46] = {.lex_state = 58, .external_lex_state = 3},
  [47] = {.lex_state = 58, .external_lex_state = 3},
  [48] = {.lex_state = 58, .external_lex_state = 3},
  [49] = {.lex_state = 58, .external_lex_state = 3},
  [50] = {.lex_state = 58, .external_lex_state = 3},
  [51] = {.lex_state = 58, .external_lex_state = 3},
  [52] = {.lex_state = 58, .external_lex_state = 3},
  [53] = {.lex_state = 58, .external_lex_state = 3},
  [54] = {.lex_state = 58, .external_lex_state = 3},
  [55] = {.lex_state = 58, .external_lex_state = 3},
  [56] = {.lex_state = 58, .external_lex_state = 3},
  [57] = {.lex_state = 58, .external_lex_state = 3},
  [58] = {.lex_state = 58, .external_lex_state = 3},
  [59] = {.lex_state = 58, .external_lex_state = 3},
  [60] = {.lex_state = 58, .external_lex_state = 3},
  [61] = {.lex_state = 58, .external_lex_state = 3},
  [62] = {.lex_state = 58, .external_lex_state = 3},
  [63] = {.lex_state = 58, .external_lex_state = 3},
  [64] = {.lex_state = 58, .external_lex_state = 3},
  [65] = {.lex_state = 58, .external_lex_state = 3},
  [66] = {.lex_state = 58, .external_lex_state = 3},
  [67] = {.lex_state = 58, .external_lex_state = 2},
  [68] = {.lex_state = 58, .external_lex_state = 2},
  [69] = {.lex_state = 58, .external_lex_state = 3},
  [70] = {.lex_state = 58, .external_lex_state = 3},
  [71] = {.lex_state = 58, .external_lex_state = 3},
  [72] = {.lex_state = 58, .external_lex_state = 3},
  [73] = {.lex_state = 58, .external_lex_state = 3},
  [74] = {.lex_state = 58, .external_lex_state = 3},
  [75] = {.lex_state = 58, .external_lex_state = 3},
  [76] = {.lex_state = 58, .external_lex_state = 3},
  [77] = {.lex_state = 30, .external_lex_state = 4},
  [78] = {.lex_state = 30, .external_lex_state = 4},
  [79] = {.lex_state = 31, .external_lex_state = 5},
  [80] = {.lex_state = 31, .external_lex_state = 5},
  [81] = {.lex_state = 31, .external_lex_state = 5},
  [82] = {.lex_state = 31, .external_lex_state = 5},
  [83] = {.lex_state = 31, .external_lex_state = 5},
  [84] = {.lex_state = 31, .external_lex_state = 5},
  [85] = {.lex_state = 31, .external_lex_state = 5},
  [86] = {.lex_state = 31, .external_lex_state = 5},
  [87] = {.lex_state = 30, .external_lex_state = 4},
  [88] = {.lex_state = 30, .external_lex_state = 4},
  [89] = {.lex_state = 30, .external_lex_state = 4},
  [90] = {.lex_state = 30, .external_lex_state = 4},
  [91] = {.lex_state = 58, .external_lex_state = 5},
  [92] = {.lex_state = 58, .external_lex_state = 5},
  [93] = {.lex_state = 58, .external_lex_state = 5},
  [94] = {.lex_state = 58, .external_lex_state = 5},
  [95] = {.lex_state = 58, .external_lex_state = 5},
  [96] = {.lex_state = 58, .external_lex_state = 5},
  [97] = {.lex_state = 58, .external_lex_state = 5},
  [98] = {.lex_state = 58, .external_lex_state = 5},
  [99] = {.lex_state = 58, .external_lex_state = 5},
  [100] = {.lex_state = 58, .external_lex_state = 5},
  [101] = {.lex_state = 58, .external_lex_state = 5},
  [102] = {.lex_state = 58, .external_lex_state = 5},
  [103] = {.lex_state = 58, .external_lex_state = 5},
  [104] = {.lex_state = 58, .external_lex_state = 5},
  [105] = {.lex_state = 58, .external_lex_state = 5},
  [106] = {.lex_state = 58, .external_lex_state = 5},
  [107] = {.lex_state = 58, .external_lex_state = 5},
  [108] = {.lex_state = 58, .external_lex_state = 5},
  [109] = {.lex_state = 58, .external_lex_state = 5},
  [110] = {.lex_state = 58, .external_lex_state = 5},
  [111] = {.lex_state = 58, .external_lex_state = 5},
  [112] = {.lex_state = 58, .external_lex_state = 5},
  [113] = {.lex_state = 58, .external_lex_state = 5},
  [114] = {.lex_state = 58, .external_lex_state = 5},
  [115] = {.lex_state = 58, .external_lex_state = 5},
  [116] = {.lex_state = 58, .external_lex_state = 5},
  [117] = {.lex_state = 58, .external_lex_state = 5},
  [118] = {.lex_state = 58, .external_lex_state = 5},
  [119] = {.lex_state = 58, .external_lex_state = 5},
  [120] = {.lex_state = 58, .external_lex_state = 5},
  [121] = {.lex_state = 58, .external_lex_state = 5},
  [122] = {.lex_state = 58, .external_lex_state = 5},
  [123] = {.lex_state = 58, .external_lex_state = 5},
  [124] = {.lex_state = 58, .external_lex_state = 5},
  [125] = {.lex_state = 58, .external_lex_state = 5},
  [126] = {.lex_state = 58, .external_lex_state = 5},
  [127] = {.lex_state = 58, .external_lex_state = 5},
  [128] = {.lex_state = 58, .external_lex_state = 5},
  [129] = {.lex_state = 58, .external_lex_state = 5},
  [130] = {.lex_state = 58, .external_lex_state = 5},
  [131] = {.lex_state = 58, .external_lex_state = 5},
  [132] = {.lex_state = 58, .external_lex_state = 5},
  [133] = {.lex_state = 58, .external_lex_state = 5},
  [134] = {.lex_state = 58, .external_lex_state = 5},
  [135] = {.lex_state = 58, .external_lex_state = 5},
  [136] = {.lex_state = 58, .external_lex_state = 5},
  [137] = {.lex_state = 58, .external_lex_state = 5},
  [138] = {.lex_state = 58, .external_lex_state = 5},
  [139] = {.lex_state = 58, .external_lex_state = 5},
  [140] = {.lex_state = 58, .external_lex_state = 5},
  [141] = {.lex_state = 58, .external_lex_state = 5},
  [142] = {.lex_state = 58, .external_lex_state = 5},
  [143] = {.lex_state = 58, .external_lex_state = 5},
  [144] = {.lex_state = 58, .external_lex_state = 4},
  [145] = {.lex_state = 58, .external_lex_state = 4},
  [146] = {.lex_state = 58, .external_lex_state = 4},
  [147] = {.lex_state = 58, .external_lex_state = 4},
  [148] = {.lex_state = 58, .external_lex_state = 4},
  [149] = {.lex_state = 58, .external_lex_state = 4},
  [150] = {.lex_state = 58, .external_lex_state = 4},
  [151] = {.lex_state = 58, .external_lex_state = 4},
  [152] = {.lex_state = 58, .external_lex_state = 4},
  [153] = {.lex_state = 58, .external_lex_state = 4},
  [154] = {.lex_state = 58, .external_lex_state = 4},
  [155] = {.lex_state = 58, .external_lex_state = 4},
  [156] = {.lex_state = 58, .external_lex_state = 4},
  [157] = {.lex_state = 58, .external_lex_state = 4},
  [158] = {.lex_state = 58, .external_lex_state = 4},
  [159] = {.lex_state = 58, .external_lex_state = 4},
  [160] = {.lex_state = 58, .external_lex_state = 4},
  [161] = {.lex_state = 58, .external_lex_state = 4},
  [162] = {.lex_state = 58, .external_lex_state = 2},
  [163] = {.lex_state = 30, .external_lex_state = 4},
  [164] = {.lex_state = 30, .external_lex_state = 4},
  [165] = {.lex_state = 38, .external_lex_state = 4},
  [166] = {.lex_state = 31, .external_lex_state = 4},
  [167] = {.lex_state = 31, .external_lex_state = 6},
  [168] = {.lex_state = 31, .external_lex_state = 6},
  [169] = {.lex_state = 39, .external_lex_state = 6},
  [170] = {.lex_state = 39, .external_lex_state = 4},
  [171] = {.lex_state = 39, .external_lex_state = 4},
  [172] = {.lex_state = 59, .external_lex_state = 2},
  [173] = {.lex_state = 60, .external_lex_state = 7},
  [174] = {.lex_state = 59, .external_lex_state = 3},
  [175] = {.lex_state = 60, .external_lex_state = 8},
  [176] = {.lex_state = 59, .external_lex_state = 3},
  [177] = {.lex_state = 60, .external_lex_state = 8},
  [178] = {.lex_state = 31, .external_lex_state = 9},
  [179] = {.lex_state = 31, .external_lex_state = 6},
  [180] = {.lex_state = 39, .external_lex_state = 9},
  [181] = {.lex_state = 31, .external_lex_state = 2},
  [182] = {.lex_state = 60, .external_lex_state = 7},
  [183] = {.lex_state = 31, .external_lex_state = 6},
  [184] = {.lex_state = 31, .external_lex_state = 9},
  [185] = {.lex_state = 59, .external_lex_state = 2},
  [186] = {.lex_state = 39, .external_lex_state = 6},
  [187] = {.lex_state = 31, .external_lex_state = 10},
  [188] = {.lex_state = 31, .external_lex_state = 10},
  [189] = {.lex_state = 31, .external_lex_state = 9},
  [190] = {.lex_state = 31, .external_lex_state = 9},
  [191] = {.lex_state = 31, .external_lex_state = 4},
  [192] = {.lex_state = 39, .external_lex_state = 10},
  [193] = {.lex_state = 31, .external_lex_state = 10},
  [194] = {.lex_state = 38, .external_lex_state = 4},
  [195] = {.lex_state = 31, .external_lex_state = 10},
  [196] = {.lex_state = 31, .external_lex_state = 9},
  [197] = {.lex_state = 39, .external_lex_state = 2},
  [198] = {.lex_state = 39, .external_lex_state = 9},
  [199] = {.lex_state = 39, .external_lex_state = 2},
  [200] = {.lex_state = 31, .external_lex_state = 3},
  [201] = {.lex_state = 39, .external_lex_state = 6},
  [202] = {.lex_state = 31, .external_lex_state = 9},
  [203] = {.lex_state = 58, .external_lex_state = 3},
  [204] = {.lex_state = 58, .external_lex_state = 3},
  [205] = {.lex_state = 58, .external_lex_state = 3},
  [206] = {.lex_state = 58, .external_lex_state = 2},
  [207] = {.lex_state = 58, .external_lex_state = 3},
  [208] = {.lex_state = 31, .external_lex_state = 3},
  [209] = {.lex_state = 58, .external_lex_state = 3},
  [210] = {.lex_state = 39, .external_lex_state = 10},
  [211] = {.lex_state = 58, .external_lex_state = 3},
  [212] = {.lex_state = 31, .external_lex_state = 4},
  [213] = {.lex_state = 58, .external_lex_state = 2},
  [214] = {.lex_state = 31, .external_lex_state = 3},
  [215] = {.lex_state = 31, .external_lex_state = 9},
  [216] = {.lex_state = 58, .external_lex_state = 3},
  [217] = {.lex_state = 60, .external_lex_state = 8},
  [218] = {.lex_state = 58, .external_lex_state = 2},
  [219] = {.lex_state = 59, .external_lex_state = 3},
  [220] = {.lex_state = 31, .external_lex_state = 10},
  [221] = {.lex_state = 58, .external_lex_state = 2},
  [222] = {.lex_state = 58, .external_lex_state = 3},
  [223] = {.lex_state = 59, .external_lex_state = 2},
  [224] = {.lex_state = 60, .external_lex_state = 7},
  [225] = {.lex_state = 58, .external_lex_state = 3},
  [226] = {.lex_state = 58, .external_lex_state = 3},
  [227] = {.lex_state = 58, .external_lex_state = 3},
  [228] = {.lex_state = 58, .external_lex_state = 3},
  [229] = {.lex_state = 38, .external_lex_state = 2},
  [230] = {.lex_state = 58, .external_lex_state = 3},
  [231] = {.lex_state = 38, .external_lex_state = 2},
  [232] = {.lex_state = 58, .external_lex_state = 2},
  [233] = {.lex_state = 31, .external_lex_state = 3},
  [234] = {.lex_state = 31, .external_lex_state = 3},
  [235] = {.lex_state = 60, .external_lex_state = 7},
  [236] = {.lex_state = 59, .external_lex_state = 2},
  [237] = {.lex_state = 59, .external_lex_state = 3},
  [238] = {.lex_state = 59, .external_lex_state = 3},
  [239] = {.lex_state = 58, .external_lex_state = 2},
  [240] = {.lex_state = 59, .external_lex_state = 3},
  [241] = {.lex_state = 59, .external_lex_state = 3},
  [242] = {.lex_state = 60, .external_lex_state = 8},
  [243] = {.lex_state = 60, .external_lex_state = 8},
  [244] = {.lex_state = 60, .external_lex_state = 7},
  [245] = {.lex_state = 59, .external_lex_state = 2},
  [246] = {.lex_state = 58, .external_lex_state = 2},
  [247] = {.lex_state = 59, .external_lex_state = 3},
  [248] = {.lex_state = 60, .external_lex_state = 8},
  [249] = {.lex_state = 60, .external_lex_state = 8},
  [250] = {.lex_state = 60, .external_lex_state = 8},
  [251] = {.lex_state = 60, .external_lex_state = 8},
  [252] = {.lex_state = 58, .external_lex_state = 2},
  [253] = {.lex_state = 58, .external_lex_state = 2},
  [254] = {.lex_state = 60, .external_lex_state = 8},
  [255] = {.lex_state = 59, .external_lex_state = 2},
  [256] = {.lex_state = 59, .external_lex_state = 2},
  [257] = {.lex_state = 58, .external_lex_state = 2},
  [258] = {.lex_state = 58, .external_lex_state = 2},
  [259] = {.lex_state = 58, .external_lex_state = 3},
  [260] = {.lex_state = 60, .external_lex_state = 7},
  [261] = {.lex_state = 59, .external_lex_state = 2},
  [262] = {.lex_state = 58, .external_lex_state = 3},
  [263] = {.lex_state = 59, .external_lex_state = 2},
  [264] = {.lex_state = 58, .external_lex_state = 2},
  [265] = {.lex_state = 59, .external_lex_state = 2},
  [266] = {.lex_state = 59, .external_lex_state = 2},
  [267] = {.lex_state = 58, .external_lex_state = 2},
  [268] = {.lex_state = 58, .external_lex_state = 3},
  [269] = {.lex_state = 60, .external_lex_state = 7},
  [270] = {.lex_state = 58, .external_lex_state = 3},
  [271] = {.lex_state = 60, .external_lex_state = 7},
  [272] = {.lex_state = 58, .external_lex_state = 3},
  [273] = {.lex_state = 60, .external_lex_state = 7},
  [274] = {.lex_state = 60, .external_lex_state = 7},
  [275] = {.lex_state = 60, .external_lex_state = 7},
  [276] = {.lex_state = 58, .external_lex_state = 3},
  [277] = {.lex_state = 60, .external_lex_state = 7},
  [278] = {.lex_state = 58, .external_lex_state = 3},
  [279] = {.lex_state = 58, .external_lex_state = 3},
  [280] = {.lex_state = 60, .external_lex_state = 8},
  [281] = {.lex_state = 60, .external_lex_state = 7},
  [282] = {.lex_state = 59, .external_lex_state = 2},
  [283] = {.lex_state = 60, .external_lex_state = 8},
  [284] = {.lex_state = 59, .external_lex_state = 3},
  [285] = {.lex_state = 59, .external_lex_state = 3},
  [286] = {.lex_state = 60, .external_lex_state = 7},
  [287] = {.lex_state = 59, .external_lex_state = 3},
  [288] = {.lex_state = 60, .external_lex_state = 8},
  [289] = {.lex_state = 59, .external_lex_state = 3},
  [290] = {.lex_state = 60, .external_lex_state = 8},
  [291] = {.lex_state = 58, .external_lex_state = 3},
  [292] = {.lex_state = 58, .external_lex_state = 3},
  [293] = {.lex_state = 58, .external_lex_state = 3},
  [294] = {.lex_state = 58, .external_lex_state = 3},
  [295] = {.lex_state = 58, .external_lex_state = 2},
  [296] = {.lex_state = 58, .external_lex_state = 2},
  [297] = {.lex_state = 58, .external_lex_state = 3},
  [298] = {.lex_state = 58, .external_lex_state = 2},
  [299] = {.lex_state = 58, .external_lex_state = 2},
  [300] = {.lex_state = 58, .external_lex_state = 2},
  [301] = {.lex_state = 58, .external_lex_state = 2},
  [302] = {.lex_state = 58, .external_lex_state = 3},
  [303] = {.lex_state = 58, .external_lex_state = 3},
  [304] = {.lex_state = 58, .external_lex_state = 2},
  [305] = {.lex_state = 58, .external_lex_state = 3},
  [306] = {.lex_state = 58, .external_lex_state = 2},
  [307] = {.lex_state = 58, .external_lex_state = 2},
  [308] = {.lex_state = 58, .external_lex_state = 3},
  [309] = {.lex_state = 58, .external_lex_state = 3},
  [310] = {.lex_state = 58, .external_lex_state = 3},
  [311] = {.lex_state = 58, .external_lex_state = 2},
  [312] = {.lex_state = 58, .external_lex_state = 3},
  [313] = {.lex_state = 58, .external_lex_state = 3},
  [314] = {.lex_state = 58, .external_lex_state = 2},
  [315] = {.lex_state = 58, .external_lex_state = 2},
  [316] = {.lex_state = 58, .external_lex_state = 3},
  [317] = {.lex_state = 58, .external_lex_state = 3},
  [318] = {.lex_state = 58, .external_lex_state = 3},
  [319] = {.lex_state = 58, .external_lex_state = 2},
  [320] = {.lex_state = 58, .external_lex_state = 2},
  [321] = {.lex_state = 58, .external_lex_state = 2},
  [322] = {.lex_state = 58, .external_lex_state = 2},
  [323] = {.lex_state = 58, .external_lex_state = 2},
  [324] = {.lex_state = 58, .external_lex_state = 2},
  [325] = {.lex_state = 58, .external_lex_state = 3},
  [326] = {.lex_state = 58, .external_lex_state = 2},
  [327] = {.lex_state = 58, .external_lex_state = 3},
  [328] = {.lex_state = 58, .external_lex_state = 2},
  [329] = {.lex_state = 58, .external_lex_state = 3},
  [330] = {.lex_state = 58, .external_lex_state = 3},
  [331] = {.lex_state = 58, .external_lex_state = 3},
  [332] = {.lex_state = 58, .external_lex_state = 2},
  [333] = {.lex_state = 58, .external_lex_state = 2},
  [334] = {.lex_state = 58, .external_lex_state = 3},
  [335] = {.lex_state = 58, .external_lex_state = 3},
  [336] = {.lex_state = 58, .external_lex_state = 3},
  [337] = {.lex_state = 58, .external_lex_state = 2},
  [338] = {.lex_state = 58, .external_lex_state = 2},
  [339] = {.lex_state = 58, .external_lex_state = 2},
  [340] = {.lex_state = 58, .external_lex_state = 3},
  [341] = {.lex_state = 58, .external_lex_state = 3},
  [342] = {.lex_state = 58, .external_lex_state = 3},
  [343] = {.lex_state = 58, .external_lex_state = 3},
  [344] = {.lex_state = 58, .external_lex_state = 2},
  [345] = {.lex_state = 58, .external_lex_state = 2},
  [346] = {.lex_state = 58, .external_lex_state = 2},
  [347] = {.lex_state = 58, .external_lex_state = 2},
  [348] = {.lex_state = 58, .external_lex_state = 2},
  [349] = {.lex_state = 58, .external_lex_state = 2},
  [350] = {.lex_state = 58, .external_lex_state = 2},
  [351] = {.lex_state = 58, .external_lex_state = 3},
  [352] = {.lex_state = 58, .external_lex_state = 2},
  [353] = {.lex_state = 58, .external_lex_state = 2},
  [354] = {.lex_state = 58, .external_lex_state = 2},
  [355] = {.lex_state = 58, .external_lex_state = 2},
  [356] = {.lex_state = 58, .external_lex_state = 2},
  [357] = {.lex_state = 58, .external_lex_state = 2},
  [358] = {.lex_state = 58, .external_lex_state = 2},
  [359] = {.lex_state = 58, .external_lex_state = 3},
  [360] = {.lex_state = 58, .external_lex_state = 2},
  [361] = {.lex_state = 58, .external_lex_state = 3},
  [362] = {.lex_state = 58, .external_lex_state = 2},
  [363] = {.lex_state = 58, .external_lex_state = 2},
  [364] = {.lex_state = 58, .external_lex_state = 3},
  [365] = {.lex_state = 58, .external_lex_state = 2},
  [366] = {.lex_state = 58, .external_lex_state = 3},
  [367] = {.lex_state = 58, .external_lex_state = 2},
  [368] = {.lex_state = 58, .external_lex_state = 3},
  [369] = {.lex_state = 58, .external_lex_state = 3},
  [370] = {.lex_state = 58, .external_lex_state = 3},
  [371] = {.lex_state = 58, .external_lex_state = 2},
  [372] = {.lex_state = 58, .external_lex_state = 2},
  [373] = {.lex_state = 58, .external_lex_state = 2},
  [374] = {.lex_state = 58, .external_lex_state = 3},
  [375] = {.lex_state = 58, .external_lex_state = 2},
  [376] = {.lex_state = 58, .external_lex_state = 3},
  [377] = {.lex_state = 58, .external_lex_state = 2},
  [378] = {.lex_state = 58, .external_lex_state = 2},
  [379] = {.lex_state = 58, .external_lex_state = 2},
  [380] = {.lex_state = 58, .external_lex_state = 3},
  [381] = {.lex_state = 58, .external_lex_state = 2},
  [382] = {.lex_state = 58, .external_lex_state = 3},
  [383] = {.lex_state = 58, .external_lex_state = 3},
  [384] = {.lex_state = 58, .external_lex_state = 2},
  [385] = {.lex_state = 58, .external_lex_state = 2},
  [386] = {.lex_state = 58, .external_lex_state = 2},
  [387] = {.lex_state = 58, .external_lex_state = 2},
  [388] = {.lex_state = 58, .external_lex_state = 2},
  [389] = {.lex_state = 58, .external_lex_state = 3},
  [390] = {.lex_state = 58, .external_lex_state = 2},
  [391] = {.lex_state = 58, .external_lex_state = 3},
  [392] = {.lex_state = 58, .external_lex_state = 2},
  [393] = {.lex_state = 58, .external_lex_state = 3},
  [394] = {.lex_state = 58, .external_lex_state = 2},
  [395] = {.lex_state = 58, .external_lex_state = 2},
  [396] = {.lex_state = 58, .external_lex_state = 3},
  [397] = {.lex_state = 58, .external_lex_state = 3},
  [398] = {.lex_state = 58, .external_lex_state = 2},
  [399] = {.lex_state = 58, .external_lex_state = 3},
  [400] = {.lex_state = 58, .external_lex_state = 2},
  [401] = {.lex_state = 58, .external_lex_state = 2},
  [402] = {.lex_state = 58, .external_lex_state = 2},
  [403] = {.lex_state = 58, .external_lex_state = 3},
  [404] = {.lex_state = 58, .external_lex_state = 2},
  [405] = {.lex_state = 58, .external_lex_state = 2},
  [406] = {.lex_state = 58, .external_lex_state = 3},
  [407] = {.lex_state = 58, .external_lex_state = 2},
  [408] = {.lex_state = 58, .external_lex_state = 2},
  [409] = {.lex_state = 58, .external_lex_state = 2},
  [410] = {.lex_state = 58, .external_lex_state = 2},
  [411] = {.lex_state = 58, .external_lex_state = 2},
  [412] = {.lex_state = 58, .external_lex_state = 2},
  [413] = {.lex_state = 58, .external_lex_state = 3},
  [414] = {.lex_state = 58, .external_lex_state = 2},
  [415] = {.lex_state = 58, .external_lex_state = 3},
  [416] = {.lex_state = 58, .external_lex_state = 3},
  [417] = {.lex_state = 58, .external_lex_state = 3},
  [418] = {.lex_state = 58, .external_lex_state = 3},
  [419] = {.lex_state = 58, .external_lex_state = 2},
  [420] = {.lex_state = 58, .external_lex_state = 2},
  [421] = {.lex_state = 58, .external_lex_state = 2},
  [422] = {.lex_state = 58, .external_lex_state = 2},
  [423] = {.lex_state = 58, .external_lex_state = 3},
  [424] = {.lex_state = 58, .external_lex_state = 3},
  [425] = {.lex_state = 58, .external_lex_state = 3},
  [426] = {.lex_state = 58, .external_lex_state = 3},
  [427] = {.lex_state = 58, .external_lex_state = 2},
  [428] = {.lex_state = 58, .external_lex_state = 2},
  [429] = {.lex_state = 58, .external_lex_state = 3},
  [430] = {.lex_state = 58, .external_lex_state = 2},
  [431] = {.lex_state = 58, .external_lex_state = 2},
  [432] = {.lex_state = 58, .external_lex_state = 3},
  [433] = {.lex_state = 58, .external_lex_state = 2},
  [434] = {.lex_state = 58, .external_lex_state = 3},
  [435] = {.lex_state = 58, .external_lex_state = 2},
  [436] = {.lex_state = 58, .external_lex_state = 3},
  [437] = {.lex_state = 58, .external_lex_state = 2},
  [438] = {.lex_state = 58, .external_lex_state = 2},
  [439] = {.lex_state = 58, .external_lex_state = 2},
  [440] = {.lex_state = 58, .external_lex_state = 3},
  [441] = {.lex_state = 58, .external_lex_state = 3},
  [442] = {.lex_state = 58, .external_lex_state = 3},
  [443] = {.lex_state = 58, .external_lex_state = 3},
  [444] = {.lex_state = 58, .external_lex_state = 3},
  [445] = {.lex_state = 58, .external_lex_state = 3},
  [446] = {.lex_state = 58, .external_lex_state = 3},
  [447] = {.lex_state = 58, .external_lex_state = 2},
  [448] = {.lex_state = 58, .external_lex_state = 3},
  [449] = {.lex_state = 58, .external_lex_state = 3},
  [450] = {.lex_state = 58, .external_lex_state = 3},
  [451] = {.lex_state = 58, .external_lex_state = 3},
  [452] = {.lex_state = 58, .external_lex_state = 3},
  [453] = {.lex_state = 58, .external_lex_state = 2},
  [454] = {.lex_state = 58, .external_lex_state = 2},
  [455] = {.lex_state = 58, .external_lex_state = 3},
  [456] = {.lex_state = 58, .external_lex_state = 2},
  [457] = {.lex_state = 58, .external_lex_state = 2},
  [458] = {.lex_state = 58, .external_lex_state = 3},
  [459] = {.lex_state = 58, .external_lex_state = 3},
  [460] = {.lex_state = 58, .external_lex_state = 2},
  [461] = {.lex_state = 58, .external_lex_state = 3},
  [462] = {.lex_state = 58, .external_lex_state = 3},
  [463] = {.lex_state = 58, .external_lex_state = 2},
  [464] = {.lex_state = 58, .external_lex_state = 3},
  [465] = {.lex_state = 58, .external_lex_state = 2},
  [466] = {.lex_state = 58, .external_lex_state = 2},
  [467] = {.lex_state = 58, .external_lex_state = 3},
  [468] = {.lex_state = 58, .external_lex_state = 3},
  [469] = {.lex_state = 58, .external_lex_state = 3},
  [470] = {.lex_state = 58, .external_lex_state = 2},
  [471] = {.lex_state = 58, .external_lex_state = 3},
  [472] = {.lex_state = 58, .external_lex_state = 2},
  [473] = {.lex_state = 58, .external_lex_state = 3},
  [474] = {.lex_state = 58, .external_lex_state = 3},
  [475] = {.lex_state = 58, .external_lex_state = 3},
  [476] = {.lex_state = 58, .external_lex_state = 2},
  [477] = {.lex_state = 58, .external_lex_state = 3},
  [478] = {.lex_state = 58, .external_lex_state = 3},
  [479] = {.lex_state = 58, .external_lex_state = 2},
  [480] = {.lex_state = 58, .external_lex_state = 3},
  [481] = {.lex_state = 58, .external_lex_state = 3},
  [482] = {.lex_state = 58, .external_lex_state = 2},
  [483] = {.lex_state = 58, .external_lex_state = 3},
  [484] = {.lex_state = 58, .external_lex_state = 3},
  [485] = {.lex_state = 58, .external_lex_state = 3},
  [486] = {.lex_state = 58, .external_lex_state = 3},
  [487] = {.lex_state = 58, .external_lex_state = 3},
  [488] = {.lex_state = 58, .external_lex_state = 2},
  [489] = {.lex_state = 58, .external_lex_state = 3},
  [490] = {.lex_state = 58, .external_lex_state = 3},
  [491] = {.lex_state = 58, .external_lex_state = 3},
  [492] = {.lex_state = 58, .external_lex_state = 2},
  [493] = {.lex_state = 58, .external_lex_state = 2},
  [494] = {.lex_state = 58, .external_lex_state = 3},
  [495] = {.lex_state = 58, .external_lex_state = 2},
  [496] = {.lex_state = 58, .external_lex_state = 2},
  [497] = {.lex_state = 58, .external_lex_state = 3},
  [498] = {.lex_state = 58, .external_lex_state = 3},
  [499] = {.lex_state = 58, .external_lex_state = 2},
  [500] = {.lex_state = 58, .external_lex_state = 3},
  [501] = {.lex_state = 58, .external_lex_state = 3},
  [502] = {.lex_state = 58, .external_lex_state = 3},
  [503] = {.lex_state = 58, .external_lex_state = 2},
  [504] = {.lex_state = 58, .external_lex_state = 2},
  [505] = {.lex_state = 58, .external_lex_state = 2},
  [506] = {.lex_state = 58, .external_lex_state = 3},
  [507] = {.lex_state = 58, .external_lex_state = 2},
  [508] = {.lex_state = 58, .external_lex_state = 2},
  [509] = {.lex_state = 58, .external_lex_state = 2},
  [510] = {.lex_state = 58, .external_lex_state = 2},
  [511] = {.lex_state = 58, .external_lex_state = 2},
  [512] = {.lex_state = 58, .external_lex_state = 3},
  [513] = {.lex_state = 58, .external_lex_state = 2},
  [514] = {.lex_state = 58, .external_lex_state = 3},
  [515] = {.lex_state = 58, .external_lex_state = 9},
  [516] = {.lex_state = 58, .external_lex_state = 2},
  [517] = {.lex_state = 58, .external_lex_state = 9},
  [518] = {.lex_state = 31, .external_lex_state = 6},
  [519] = {.lex_state = 58, .external_lex_state = 10},
  [520] = {.lex_state = 58, .external_lex_state = 10},
  [521] = {.lex_state = 31, .external_lex_state = 6},
  [522] = {.lex_state = 58, .external_lex_state = 9},
  [523] = {.lex_state = 58, .external_lex_state = 10},
  [524] = {.lex_state = 31, .external_lex_state = 6},
  [525] = {.lex_state = 58, .external_lex_state = 9},
  [526] = {.lex_state = 58, .external_lex_state = 9},
  [527] = {.lex_state = 58, .external_lex_state = 10},
  [528] = {.lex_state = 58, .external_lex_state = 9},
  [529] = {.lex_state = 58, .external_lex_state = 10},
  [530] = {.lex_state = 31, .external_lex_state = 6},
  [531] = {.lex_state = 58, .external_lex_state = 9},
  [532] = {.lex_state = 58, .external_lex_state = 10},
  [533] = {.lex_state = 58, .external_lex_state = 2},
  [534] = {.lex_state = 31, .external_lex_state = 6},
  [535] = {.lex_state = 58, .external_lex_state = 10},
  [536] = {.lex_state = 58, .external_lex_state = 9},
  [537] = {.lex_state = 58, .external_lex_state = 2},
  [538] = {.lex_state = 58, .external_lex_state = 9},
  [539] = {.lex_state = 31, .external_lex_state = 6},
  [540] = {.lex_state = 58, .external_lex_state = 9},
  [541] = {.lex_state = 58, .external_lex_state = 10},
  [542] = {.lex_state = 31, .external_lex_state = 6},
  [543] = {.lex_state = 58, .external_lex_state = 9},
  [544] = {.lex_state = 58, .external_lex_state = 10},
  [545] = {.lex_state = 31, .external_lex_state = 6},
  [546] = {.lex_state = 58, .external_lex_state = 10},
  [547] = {.lex_state = 31, .external_lex_state = 6},
  [548] = {.lex_state = 58, .external_lex_state = 10},
  [549] = {.lex_state = 31, .external_lex_state = 5},
  [550] = {.lex_state = 32, .external_lex_state = 4},
  [551] = {.lex_state = 31, .external_lex_state = 5},
  [552] = {.lex_state = 32, .external_lex_state = 4},
  [553] = {.lex_state = 31, .external_lex_state = 5},
  [554] = {.lex_state = 31, .external_lex_state = 5},
  [555] = {.lex_state = 31, .external_lex_state = 10},
  [556] = {.lex_state = 31, .external_lex_state = 10},
  [557] = {.lex_state = 31, .external_lex_state = 10},
  [558] = {.lex_state = 31, .external_lex_state = 10},
  [559] = {.lex_state = 58, .external_lex_state = 2},
  [560] = {.lex_state = 58, .external_lex_state = 2},
  [561] = {.lex_state = 31, .external_lex_state = 10},
  [562] = {.lex_state = 31, .external_lex_state = 10},
  [563] = {.lex_state = 31, .external_lex_state = 10},
  [564] = {.lex_state = 31, .external_lex_state = 10},
  [565] = {.lex_state = 31, .external_lex_state = 2},
  [566] = {.lex_state = 31, .external_lex_state = 2},
  [567] = {.lex_state = 31, .external_lex_state = 5},
  [568] = {.lex_state = 31, .external_lex_state = 2},
  [569] = {.lex_state = 31, .external_lex_state = 5},
  [570] = {.lex_state = 31, .external_lex_state = 2},
  [571] = {.lex_state = 31, .external_lex_state = 9},
  [572] = {.lex_state = 31, .external_lex_state = 2},
  [573] = {.lex_state = 31, .external_lex_state = 2},
  [574] = {.lex_state = 31, .external_lex_state = 5},
  [575] = {.lex_state = 32, .external_lex_state = 2},
  [576] = {.lex_state = 31, .external_lex_state = 2},
  [577] = {.lex_state = 31, .external_lex_state = 5},
  [578] = {.lex_state = 31, .external_lex_state = 2},
  [579] = {.lex_state = 31, .external_lex_state = 2},
  [580] = {.lex_state = 31, .external_lex_state = 5},
  [581] = {.lex_state = 31, .external_lex_state = 5},
  [582] = {.lex_state = 31, .external_lex_state = 9},
  [583] = {.lex_state = 31, .external_lex_state = 2},
  [584] = {.lex_state = 31, .external_lex_state = 9},
  [585] = {.lex_state = 31, .external_lex_state = 5},
  [586] = {.lex_state = 31, .external_lex_state = 9},
  [587] = {.lex_state = 32, .external_lex_state = 2},
  [588] = {.lex_state = 31, .external_lex_state = 5},
  [589] = {.lex_state = 31, .external_lex_state = 5},
  [590] = {.lex_state = 31, .external_lex_state = 2},
  [591] = {.lex_state = 31, .external_lex_state = 2},
  [592] = {.lex_state = 31, .external_lex_state = 5},
  [593] = {.lex_state = 58, .external_lex_state = 9},
  [594] = {.lex_state = 31, .external_lex_state = 2},
  [595] = {.lex_state = 31, .external_lex_state = 9},
  [596] = {.lex_state = 31, .external_lex_state = 9},
  [597] = {.lex_state = 31, .external_lex_state = 2},
  [598] = {.lex_state = 31, .external_lex_state = 2},
  [599] = {.lex_state = 31, .external_lex_state = 2},
  [600] = {.lex_state = 31, .external_lex_state = 5},
  [601] = {.lex_state = 31, .external_lex_state = 2},
  [602] = {.lex_state = 31, .external_lex_state = 2},
  [603] = {.lex_state = 31, .external_lex_state = 9},
  [604] = {.lex_state = 31, .external_lex_state = 2},
  [605] = {.lex_state = 58, .external_lex_state = 6},
  [606] = {.lex_state = 31, .external_lex_state = 2},
  [607] = {.lex_state = 31, .external_lex_state = 9},
  [608] = {.lex_state = 31, .external_lex_state = 2},
  [609] = {.lex_state = 31, .external_lex_state = 5},
  [610] = {.lex_state = 31, .external_lex_state = 9},
  [611] = {.lex_state = 31, .external_lex_state = 9},
  [612] = {.lex_state = 31, .external_lex_state = 2},
  [613] = {.lex_state = 31, .external_lex_state = 2},
  [614] = {.lex_state = 31, .external_lex_state = 2},
  [615] = {.lex_state = 31, .external_lex_state = 2},
  [616] = {.lex_state = 31, .external_lex_state = 3},
  [617] = {.lex_state = 31, .external_lex_state = 9},
  [618] = {.lex_state = 31, .external_lex_state = 9},
  [619] = {.lex_state = 58, .external_lex_state = 10},
  [620] = {.lex_state = 31, .external_lex_state = 3},
  [621] = {.lex_state = 58, .external_lex_state = 9},
  [622] = {.lex_state = 31, .external_lex_state = 9},
  [623] = {.lex_state = 58, .external_lex_state = 10},
  [624] = {.lex_state = 31, .external_lex_state = 9},
  [625] = {.lex_state = 31, .external_lex_state = 3},
  [626] = {.lex_state = 58, .external_lex_state = 9},
  [627] = {.lex_state = 31, .external_lex_state = 3},
  [628] = {.lex_state = 31, .external_lex_state = 9},
  [629] = {.lex_state = 31, .external_lex_state = 3},
  [630] = {.lex_state = 31, .external_lex_state = 3},
  [631] = {.lex_state = 31, .external_lex_state = 3},
  [632] = {.lex_state = 31, .external_lex_state = 3},
  [633] = {.lex_state = 31, .external_lex_state = 9},
  [634] = {.lex_state = 58, .external_lex_state = 9},
  [635] = {.lex_state = 31, .external_lex_state = 9},
  [636] = {.lex_state = 31, .external_lex_state = 3},
  [637] = {.lex_state = 31, .external_lex_state = 3},
  [638] = {.lex_state = 31, .external_lex_state = 9},
  [639] = {.lex_state = 31, .external_lex_state = 3},
  [640] = {.lex_state = 31, .external_lex_state = 3},
  [641] = {.lex_state = 31, .external_lex_state = 3},
  [642] = {.lex_state = 31, .external_lex_state = 9},
  [643] = {.lex_state = 31, .external_lex_state = 3},
  [644] = {.lex_state = 31, .external_lex_state = 9},
  [645] = {.lex_state = 31, .external_lex_state = 3},
  [646] = {.lex_state = 31, .external_lex_state = 3},
  [647] = {.lex_state = 31, .external_lex_state = 9},
  [648] = {.lex_state = 31, .external_lex_state = 3},
  [649] = {.lex_state = 58, .external_lex_state = 10},
  [650] = {.lex_state = 58, .external_lex_state = 9},
  [651] = {.lex_state = 31, .external_lex_state = 9},
  [652] = {.lex_state = 58, .external_lex_state = 9},
  [653] = {.lex_state = 58, .external_lex_state = 9},
  [654] = {.lex_state = 58, .external_lex_state = 10},
  [655] = {.lex_state = 31, .external_lex_state = 3},
  [656] = {.lex_state = 31, .external_lex_state = 9},
  [657] = {.lex_state = 31, .external_lex_state = 9},
  [658] = {.lex_state = 31, .external_lex_state = 9},
  [659] = {.lex_state = 31, .external_lex_state = 3},
  [660] = {.lex_state = 58, .external_lex_state = 9},
  [661] = {.lex_state = 31, .external_lex_state = 3},
  [662] = {.lex_state = 31, .external_lex_state = 9},
  [663] = {.lex_state = 31, .external_lex_state = 9},
  [664] = {.lex_state = 31, .external_lex_state = 3},
  [665] = {.lex_state = 58, .external_lex_state = 9},
  [666] = {.lex_state = 31, .external_lex_state = 3},
  [667] = {.lex_state = 58, .external_lex_state = 10},
  [668] = {.lex_state = 31, .external_lex_state = 9},
  [669] = {.lex_state = 31, .external_lex_state = 3},
  [670] = {.lex_state = 31, .external_lex_state = 3},
  [671] = {.lex_state = 31, .external_lex_state = 3},
  [672] = {.lex_state = 31, .external_lex_state = 3},
  [673] = {.lex_state = 31, .external_lex_state = 3},
  [674] = {.lex_state = 31, .external_lex_state = 3},
  [675] = {.lex_state = 31, .external_lex_state = 9},
  [676] = {.lex_state = 31, .external_lex_state = 9},
  [677] = {.lex_state = 31, .external_lex_state = 3},
  [678] = {.lex_state = 31, .external_lex_state = 9},
  [679] = {.lex_state = 31, .external_lex_state = 3},
  [680] = {.lex_state = 31, .external_lex_state = 3},
  [681] = {.lex_state = 31, .external_lex_state = 9},
  [682] = {.lex_state = 31, .external_lex_state = 3},
  [683] = {.lex_state = 31, .external_lex_state = 3},
  [684] = {.lex_state = 58, .external_lex_state = 9},
  [685] = {.lex_state = 31, .external_lex_state = 3},
  [686] = {.lex_state = 31, .external_lex_state = 9},
  [687] = {.lex_state = 58, .external_lex_state = 9},
  [688] = {.lex_state = 31, .external_lex_state = 9},
  [689] = {.lex_state = 31, .external_lex_state = 3},
  [690] = {.lex_state = 31, .external_lex_state = 9},
  [691] = {.lex_state = 58, .external_lex_state = 9},
  [692] = {.lex_state = 58, .external_lex_state = 10},
  [693] = {.lex_state = 58, .external_lex_state = 9},
  [694] = {.lex_state = 58, .external_lex_state = 9},
  [695] = {.lex_state = 58, .external_lex_state = 10},
  [696] = {.lex_state = 58, .external_lex_state = 9},
  [697] = {.lex_state = 58, .external_lex_state = 10},
  [698] = {.lex_state = 31, .external_lex_state = 3},
  [699] = {.lex_state = 58, .external_lex_state = 9},
  [700] = {.lex_state = 58, .external_lex_state = 10},
  [701] = {.lex_state = 31, .external_lex_state = 9},
  [702] = {.lex_state = 31, .external_lex_state = 9},
  [703] = {.lex_state = 31, .external_lex_state = 9},
  [704] = {.lex_state = 31, .external_lex_state = 9},
  [705] = {.lex_state = 31, .external_lex_state = 9},
  [706] = {.lex_state = 31, .external_lex_state = 3},
  [707] = {.lex_state = 31, .external_lex_state = 9},
  [708] = {.lex_state = 31, .external_lex_state = 9},
  [709] = {.lex_state = 31, .external_lex_state = 3},
  [710] = {.lex_state = 31, .external_lex_state = 9},
  [711] = {.lex_state = 31, .external_lex_state = 9},
  [712] = {.lex_state = 31, .external_lex_state = 9},
  [713] = {.lex_state = 31, .external_lex_state = 3},
  [714] = {.lex_state = 31, .external_lex_state = 3},
  [715] = {.lex_state = 31, .external_lex_state = 9},
  [716] = {.lex_state = 58, .external_lex_state = 6},
  [717] = {.lex_state = 31, .external_lex_state = 2},
  [718] = {.lex_state = 58, .external_lex_state = 10},
  [719] = {.lex_state = 58, .external_lex_state = 9},
  [720] = {.lex_state = 58, .external_lex_state = 9},
  [721] = {.lex_state = 58, .external_lex_state = 9},
  [722] = {.lex_state = 58, .external_lex_state = 9},
  [723] = {.lex_state = 58, .external_lex_state = 10},
  [724] = {.lex_state = 58, .external_lex_state = 9},
  [725] = {.lex_state = 58, .external_lex_state = 10},
  [726] = {.lex_state = 58, .external_lex_state = 10},
  [727] = {.lex_state = 58, .external_lex_state = 10},
  [728] = {.lex_state = 31, .external_lex_state = 2},
  [729] = {.lex_state = 39, .external_lex_state = 6},
  [730] = {.lex_state = 58, .external_lex_state = 6},
  [731] = {.lex_state = 31, .external_lex_state = 2},
  [732] = {.lex_state = 58, .external_lex_state = 6},
  [733] = {.lex_state = 58, .external_lex_state = 6},
  [734] = {.lex_state = 58, .external_lex_state = 10},
  [735] = {.lex_state = 58, .external_lex_state = 6},
  [736] = {.lex_state = 58, .external_lex_state = 9},
  [737] = {.lex_state = 58, .external_lex_state = 6},
  [738] = {.lex_state = 58, .external_lex_state = 6},
  [739] = {.lex_state = 58, .external_lex_state = 6},
  [740] = {.lex_state = 58, .external_lex_state = 9},
  [741] = {.lex_state = 31, .external_lex_state = 6},
  [742] = {.lex_state = 31, .external_lex_state = 6},
  [743] = {.lex_state = 31, .external_lex_state = 6},
  [744] = {.lex_state = 31, .external_lex_state = 6},
  [745] = {.lex_state = 31, .external_lex_state = 6},
  [746] = {.lex_state = 31, .external_lex_state = 6},
  [747] = {.lex_state = 31, .external_lex_state = 6},
  [748] = {.lex_state = 31, .external_lex_state = 6},
  [749] = {.lex_state = 31, .external_lex_state = 6},
  [750] = {.lex_state = 31, .external_lex_state = 6},
  [751] = {.lex_state = 31, .external_lex_state = 6},
  [752] = {.lex_state = 58, .external_lex_state = 2},
  [753] = {.lex_state = 31, .external_lex_state = 6},
  [754] = {.lex_state = 31, .external_lex_state = 6},
  [755] = {.lex_state = 58, .external_lex_state = 4},
  [756] = {.lex_state = 31, .external_lex_state = 6},
  [757] = {.lex_state = 31, .external_lex_state = 6},
  [758] = {.lex_state = 31, .external_lex_state = 6},
  [759] = {.lex_state = 58, .external_lex_state = 2},
  [760] = {.lex_state = 58, .external_lex_state = 10},
  [761] = {.lex_state = 31, .external_lex_state = 6},
  [762] = {.lex_state = 31, .external_lex_state = 6},
  [763] = {.lex_state = 58, .external_lex_state = 2},
  [764] = {.lex_state = 58, .external_lex_state = 4},
  [765] = {.lex_state = 58, .external_lex_state = 10},
  [766] = {.lex_state = 58, .external_lex_state = 10},
  [767] = {.lex_state = 58, .external_lex_state = 10},
  [768] = {.lex_state = 58, .external_lex_state = 10},
  [769] = {.lex_state = 58, .external_lex_state = 10},
  [770] = {.lex_state = 58, .external_lex_state = 10},
  [771] = {.lex_state = 58, .external_lex_state = 10},
  [772] = {.lex_state = 58, .external_lex_state = 10},
  [773] = {.lex_state = 58, .external_lex_state = 10},
  [774] = {.lex_state = 58, .external_lex_state = 10},
  [775] = {.lex_state = 58, .external_lex_state = 10},
  [776] = {.lex_state = 39, .external_lex_state = 9},
  [777] = {.lex_state = 58, .external_lex_state = 10},
  [778] = {.lex_state = 58, .external_lex_state = 10},
  [779] = {.lex_state = 58, .external_lex_state = 4},
  [780] = {.lex_state = 58, .external_lex_state = 10},
  [781] = {.lex_state = 39, .external_lex_state = 9},
  [782] = {.lex_state = 58, .external_lex_state = 10},
  [783] = {.lex_state = 58, .external_lex_state = 10},
  [784] = {.lex_state = 58, .external_lex_state = 4},
  [785] = {.lex_state = 58, .external_lex_state = 10},
  [786] = {.lex_state = 58, .external_lex_state = 10},
  [787] = {.lex_state = 58, .external_lex_state = 10},
  [788] = {.lex_state = 58, .external_lex_state = 10},
  [789] = {.lex_state = 58, .external_lex_state = 10},
  [790] = {.lex_state = 58, .external_lex_state = 10},
  [791] = {.lex_state = 58, .external_lex_state = 10},
  [792] = {.lex_state = 58, .external_lex_state = 10},
  [793] = {.lex_state = 58, .external_lex_state = 10},
  [794] = {.lex_state = 58, .external_lex_state = 10},
  [795] = {.lex_state = 58, .external_lex_state = 10},
  [796] = {.lex_state = 58, .external_lex_state = 10},
  [797] = {.lex_state = 58, .external_lex_state = 10},
  [798] = {.lex_state = 31, .external_lex_state = 2},
  [799] = {.lex_state = 58, .external_lex_state = 10},
  [800] = {.lex_state = 58, .external_lex_state = 10},
  [801] = {.lex_state = 58, .external_lex_state = 4},
  [802] = {.lex_state = 58, .external_lex_state = 10},
  [803] = {.lex_state = 58, .external_lex_state = 10},
  [804] = {.lex_state = 58, .external_lex_state = 10},
  [805] = {.lex_state = 58, .external_lex_state = 10},
  [806] = {.lex_state = 58, .external_lex_state = 2},
  [807] = {.lex_state = 58, .external_lex_state = 2},
  [808] = {.lex_state = 58, .external_lex_state = 2},
  [809] = {.lex_state = 58, .external_lex_state = 2},
  [810] = {.lex_state = 58, .external_lex_state = 2},
  [811] = {.lex_state = 31, .external_lex_state = 2},
  [812] = {.lex_state = 58, .external_lex_state = 2},
  [813] = {.lex_state = 58, .external_lex_state = 2},
  [814] = {.lex_state = 58, .external_lex_state = 2},
  [815] = {.lex_state = 58, .external_lex_state = 9},
  [816] = {.lex_state = 58, .external_lex_state = 4},
  [817] = {.lex_state = 58, .external_lex_state = 4},
  [818] = {.lex_state = 58, .external_lex_state = 4},
  [819] = {.lex_state = 58, .external_lex_state = 2},
  [820] = {.lex_state = 58, .external_lex_state = 2},
  [821] = {.lex_state = 58, .external_lex_state = 9},
  [822] = {.lex_state = 58, .external_lex_state = 2},
  [823] = {.lex_state = 31, .external_lex_state = 9},
  [824] = {.lex_state = 58, .external_lex_state = 2},
  [825] = {.lex_state = 58, .external_lex_state = 9},
  [826] = {.lex_state = 58, .external_lex_state = 2},
  [827] = {.lex_state = 58, .external_lex_state = 2},
  [828] = {.lex_state = 58, .external_lex_state = 2},
  [829] = {.lex_state = 39, .external_lex_state = 2},
  [830] = {.lex_state = 31, .external_lex_state = 10},
  [831] = {.lex_state = 58, .external_lex_state = 2},
  [832] = {.lex_state = 58, .external_lex_state = 2},
  [833] = {.lex_state = 58, .external_lex_state = 9},
  [834] = {.lex_state = 58, .external_lex_state = 2},
  [835] = {.lex_state = 58, .external_lex_state = 4},
  [836] = {.lex_state = 58, .external_lex_state = 2},
  [837] = {.lex_state = 58, .external_lex_state = 2},
  [838] = {.lex_state = 58, .external_lex_state = 2},
  [839] = {.lex_state = 58, .external_lex_state = 2},
  [840] = {.lex_state = 58, .external_lex_state = 10},
  [841] = {.lex_state = 58, .external_lex_state = 2},
  [842] = {.lex_state = 58, .external_lex_state = 10},
  [843] = {.lex_state = 58, .external_lex_state = 2},
  [844] = {.lex_state = 58, .external_lex_state = 2},
  [845] = {.lex_state = 58, .external_lex_state = 10},
  [846] = {.lex_state = 58, .external_lex_state = 4},
  [847] = {.lex_state = 58, .external_lex_state = 2},
  [848] = {.lex_state = 58, .external_lex_state = 2},
  [849] = {.lex_state = 58, .external_lex_state = 4},
  [850] = {.lex_state = 58, .external_lex_state = 2},
  [851] = {.lex_state = 58, .external_lex_state = 10},
  [852] = {.lex_state = 58, .external_lex_state = 2},
  [853] = {.lex_state = 39, .external_lex_state = 2},
  [854] = {.lex_state = 58, .external_lex_state = 2},
  [855] = {.lex_state = 58, .external_lex_state = 2},
  [856] = {.lex_state = 58, .external_lex_state = 2},
  [857] = {.lex_state = 58, .external_lex_state = 10},
  [858] = {.lex_state = 58, .external_lex_state = 2},
  [859] = {.lex_state = 58, .external_lex_state = 2},
  [860] = {.lex_state = 58, .external_lex_state = 2},
  [861] = {.lex_state = 58, .external_lex_state = 2},
  [862] = {.lex_state = 58, .external_lex_state = 2},
  [863] = {.lex_state = 58, .external_lex_state = 2},
  [864] = {.lex_state = 58, .external_lex_state = 2},
  [865] = {.lex_state = 58, .external_lex_state = 2},
  [866] = {.lex_state = 58, .external_lex_state = 2},
  [867] = {.lex_state = 58, .external_lex_state = 2},
  [868] = {.lex_state = 58, .external_lex_state = 2},
  [869] = {.lex_state = 33, .external_lex_state = 11},
  [870] = {.lex_state = 58, .external_lex_state = 2},
  [871] = {.lex_state = 33, .external_lex_state = 11},
  [872] = {.lex_state = 58, .external_lex_state = 2},
  [873] = {.lex_state = 33, .external_lex_state = 4},
  [874] = {.lex_state = 33, .external_lex_state = 4},
  [875] = {.lex_state = 58, .external_lex_state = 2},
  [876] = {.lex_state = 58, .external_lex_state = 2},
  [877] = {.lex_state = 58, .external_lex_state = 2},
  [878] = {.lex_state = 58, .external_lex_state = 2},
  [879] = {.lex_state = 58, .external_lex_state = 2},
  [880] = {.lex_state = 58, .external_lex_state = 2},
  [881] = {.lex_state = 58, .external_lex_state = 2},
  [882] = {.lex_state = 58, .external_lex_state = 2},
  [883] = {.lex_state = 58, .external_lex_state = 2},
  [884] = {.lex_state = 58, .external_lex_state = 2},
  [885] = {.lex_state = 58, .external_lex_state = 2},
  [886] = {.lex_state = 58, .external_lex_state = 2},
  [887] = {.lex_state = 58, .external_lex_state = 2},
  [888] = {.lex_state = 58, .external_lex_state = 2},
  [889] = {.lex_state = 58, .external_lex_state = 2},
  [890] = {.lex_state = 58, .external_lex_state = 2},
  [891] = {.lex_state = 58, .external_lex_state = 2},
  [892] = {.lex_state = 58, .external_lex_state = 2},
  [893] = {.lex_state = 58, .external_lex_state = 2},
  [894] = {.lex_state = 58, .external_lex_state = 2},
  [895] = {.lex_state = 58, .external_lex_state = 2},
  [896] = {.lex_state = 58, .external_lex_state = 2},
  [897] = {.lex_state = 58, .external_lex_state = 2},
  [898] = {.lex_state = 58, .external_lex_state = 2},
  [899] = {.lex_state = 58, .external_lex_state = 2},
  [900] = {.lex_state = 58, .external_lex_state = 2},
  [901] = {.lex_state = 58, .external_lex_state = 2},
  [902] = {.lex_state = 58, .external_lex_state = 2},
  [903] = {.lex_state = 58, .external_lex_state = 2},
  [904] = {.lex_state = 58, .external_lex_state = 2},
  [905] = {.lex_state = 58, .external_lex_state = 2},
  [906] = {.lex_state = 58, .external_lex_state = 2},
  [907] = {.lex_state = 58, .external_lex_state = 2},
  [908] = {.lex_state = 58, .external_lex_state = 2},
  [909] = {.lex_state = 58, .external_lex_state = 2},
  [910] = {.lex_state = 58, .external_lex_state = 2},
  [911] = {.lex_state = 58, .external_lex_state = 2},
  [912] = {.lex_state = 58, .external_lex_state = 2},
  [913] = {.lex_state = 58, .external_lex_state = 2},
  [914] = {.lex_state = 58, .external_lex_state = 2},
  [915] = {.lex_state = 58, .external_lex_state = 2},
  [916] = {.lex_state = 58, .external_lex_state = 2},
  [917] = {.lex_state = 58, .external_lex_state = 2},
  [918] = {.lex_state = 58, .external_lex_state = 2},
  [919] = {.lex_state = 58, .external_lex_state = 2},
  [920] = {.lex_state = 58, .external_lex_state = 2},
  [921] = {.lex_state = 58, .external_lex_state = 2},
  [922] = {.lex_state = 58, .external_lex_state = 2},
  [923] = {.lex_state = 58, .external_lex_state = 2},
  [924] = {.lex_state = 58, .external_lex_state = 2},
  [925] = {.lex_state = 58, .external_lex_state = 2},
  [926] = {.lex_state = 58, .external_lex_state = 2},
  [927] = {.lex_state = 58, .external_lex_state = 2},
  [928] = {.lex_state = 58, .external_lex_state = 2},
  [929] = {.lex_state = 58, .external_lex_state = 2},
  [930] = {.lex_state = 58, .external_lex_state = 2},
  [931] = {.lex_state = 58, .external_lex_state = 2},
  [932] = {.lex_state = 58, .external_lex_state = 2},
  [933] = {.lex_state = 58, .external_lex_state = 2},
  [934] = {.lex_state = 58, .external_lex_state = 2},
  [935] = {.lex_state = 58, .external_lex_state = 2},
  [936] = {.lex_state = 58, .external_lex_state = 2},
  [937] = {.lex_state = 58, .external_lex_state = 2},
  [938] = {.lex_state = 58, .external_lex_state = 2},
  [939] = {.lex_state = 58, .external_lex_state = 2},
  [940] = {.lex_state = 58, .external_lex_state = 2},
  [941] = {.lex_state = 58, .external_lex_state = 2},
  [942] = {.lex_state = 58, .external_lex_state = 2},
  [943] = {.lex_state = 58, .external_lex_state = 2},
  [944] = {.lex_state = 58, .external_lex_state = 2},
  [945] = {.lex_state = 58, .external_lex_state = 2},
  [946] = {.lex_state = 58, .external_lex_state = 2},
  [947] = {.lex_state = 58, .external_lex_state = 2},
  [948] = {.lex_state = 58, .external_lex_state = 2},
  [949] = {.lex_state = 58, .external_lex_state = 2},
  [950] = {.lex_state = 58, .external_lex_state = 2},
  [951] = {.lex_state = 58, .external_lex_state = 2},
  [952] = {.lex_state = 58, .external_lex_state = 2},
  [953] = {.lex_state = 58, .external_lex_state = 2},
  [954] = {.lex_state = 58, .external_lex_state = 2},
  [955] = {.lex_state = 58, .external_lex_state = 2},
  [956] = {.lex_state = 58, .external_lex_state = 2},
  [957] = {.lex_state = 58, .external_lex_state = 2},
  [958] = {.lex_state = 58, .external_lex_state = 2},
  [959] = {.lex_state = 58, .external_lex_state = 2},
  [960] = {.lex_state = 58, .external_lex_state = 2},
  [961] = {.lex_state = 58, .external_lex_state = 2},
  [962] = {.lex_state = 58, .external_lex_state = 2},
  [963] = {.lex_state = 58, .external_lex_state = 2},
  [964] = {.lex_state = 58, .external_lex_state = 2},
  [965] = {.lex_state = 58, .external_lex_state = 2},
  [966] = {.lex_state = 58, .external_lex_state = 2},
  [967] = {.lex_state = 58, .external_lex_state = 2},
  [968] = {.lex_state = 58, .external_lex_state = 2},
  [969] = {.lex_state = 58, .external_lex_state = 2},
  [970] = {.lex_state = 58, .external_lex_state = 2},
  [971] = {.lex_state = 58, .external_lex_state = 2},
  [972] = {.lex_state = 58, .external_lex_state = 2},
  [973] = {.lex_state = 58, .external_lex_state = 2},
  [974] = {.lex_state = 58, .external_lex_state = 2},
  [975] = {.lex_state = 58, .external_lex_state = 2},
  [976] = {.lex_state = 58, .external_lex_state = 2},
  [977] = {.lex_state = 58, .external_lex_state = 2},
  [978] = {.lex_state = 58, .external_lex_state = 2},
  [979] = {.lex_state = 58, .external_lex_state = 2},
  [980] = {.lex_state = 58, .external_lex_state = 2},
  [981] = {.lex_state = 58, .external_lex_state = 2},
  [982] = {.lex_state = 58, .external_lex_state = 2},
  [983] = {.lex_state = 58, .external_lex_state = 2},
  [984] = {.lex_state = 58, .external_lex_state = 2},
  [985] = {.lex_state = 58, .external_lex_state = 2},
  [986] = {.lex_state = 58, .external_lex_state = 2},
  [987] = {.lex_state = 58, .external_lex_state = 2},
  [988] = {.lex_state = 58, .external_lex_state = 2},
  [989] = {.lex_state = 58, .external_lex_state = 2},
  [990] = {.lex_state = 58, .external_lex_state = 2},
  [991] = {.lex_state = 58, .external_lex_state = 2},
  [992] = {.lex_state = 58, .external_lex_state = 2},
  [993] = {.lex_state = 58, .external_lex_state = 2},
  [994] = {.lex_state = 58, .external_lex_state = 2},
  [995] = {.lex_state = 58, .external_lex_state = 2},
  [996] = {.lex_state = 58, .external_lex_state = 2},
  [997] = {.lex_state = 58, .external_lex_state = 2},
  [998] = {.lex_state = 58, .external_lex_state = 2},
  [999] = {.lex_state = 58, .external_lex_state = 2},
  [1000] = {.lex_state = 58, .external_lex_state = 2},
  [1001] = {.lex_state = 58, .external_lex_state = 2},
  [1002] = {.lex_state = 58, .external_lex_state = 2},
  [1003] = {.lex_state = 58, .external_lex_state = 2},
  [1004] = {.lex_state = 58, .external_lex_state = 2},
  [1005] = {.lex_state = 58, .external_lex_state = 2},
  [1006] = {.lex_state = 58, .external_lex_state = 2},
  [1007] = {.lex_state = 58, .external_lex_state = 2},
  [1008] = {.lex_state = 58, .external_lex_state = 2},
  [1009] = {.lex_state = 58, .external_lex_state = 2},
  [1010] = {.lex_state = 58, .external_lex_state = 2},
  [1011] = {.lex_state = 58, .external_lex_state = 2},
  [1012] = {.lex_state = 58, .external_lex_state = 2},
  [1013] = {.lex_state = 58, .external_lex_state = 2},
  [1014] = {.lex_state = 58, .external_lex_state = 2},
  [1015] = {.lex_state = 58, .external_lex_state = 2},
  [1016] = {.lex_state = 33, .external_lex_state = 11},
  [1017] = {.lex_state = 33, .external_lex_state = 11},
  [1018] = {.lex_state = 33, .external_lex_state = 11},
  [1019] = {.lex_state = 33, .external_lex_state = 11},
  [1020] = {.lex_state = 33, .external_lex_state = 11},
  [1021] = {.lex_state = 34, .external_lex_state = 11},
  [1022] = {.lex_state = 34, .external_lex_state = 11},
  [1023] = {.lex_state = 34, .external_lex_state = 11},
  [1024] = {.lex_state = 34, .external_lex_state = 11},
  [1025] = {.lex_state = 34, .external_lex_state = 11},
  [1026] = {.lex_state = 34, .external_lex_state = 11},
  [1027] = {.lex_state = 34, .external_lex_state = 11},
  [1028] = {.lex_state = 34, .external_lex_state = 11},
  [1029] = {.lex_state = 34, .external_lex_state = 11},
  [1030] = {.lex_state = 34, .external_lex_state = 11},
  [1031] = {.lex_state = 34, .external_lex_state = 11},
  [1032] = {.lex_state = 34, .external_lex_state = 11},
  [1033] = {.lex_state = 34, .external_lex_state = 11},
  [1034] = {.lex_state = 34, .external_lex_state = 11},
  [1035] = {.lex_state = 34, .external_lex_state = 11},
  [1036] = {.lex_state = 34, .external_lex_state = 11},
  [1037] = {.lex_state = 34, .external_lex_state = 11},
  [1038] = {.lex_state = 34, .external_lex_state = 11},
  [1039] = {.lex_state = 34, .external_lex_state = 11},
  [1040] = {.lex_state = 58, .external_lex_state = 6},
  [1041] = {.lex_state = 58, .external_lex_state = 6},
  [1042] = {.lex_state = 58, .external_lex_state = 9},
  [1043] = {.lex_state = 58, .external_lex_state = 9},
  [1044] = {.lex_state = 58, .external_lex_state = 9},
  [1045] = {.lex_state = 58, .external_lex_state = 2},
  [1046] = {.lex_state = 58, .external_lex_state = 2},
  [1047] = {.lex_state = 58, .external_lex_state = 2},
  [1048] = {.lex_state = 58, .external_lex_state = 2},
  [1049] = {.lex_state = 58, .external_lex_state = 2},
  [1050] = {.lex_state = 58, .external_lex_state = 9},
  [1051] = {.lex_state = 58, .external_lex_state = 2},
  [1052] = {.lex_state = 58, .external_lex_state = 2},
  [1053] = {.lex_state = 58, .external_lex_state = 2},
  [1054] = {.lex_state = 58, .external_lex_state = 2},
  [1055] = {.lex_state = 58, .external_lex_state = 10},
  [1056] = {.lex_state = 58, .external_lex_state = 2},
  [1057] = {.lex_state = 58, .external_lex_state = 2},
  [1058] = {.lex_state = 58, .external_lex_state = 10},
  [1059] = {.lex_state = 58, .external_lex_state = 2},
  [1060] = {.lex_state = 58, .external_lex_state = 2},
  [1061] = {.lex_state = 58, .external_lex_state = 2},
  [1062] = {.lex_state = 58, .external_lex_state = 2},
  [1063] = {.lex_state = 58, .external_lex_state = 2},
  [1064] = {.lex_state = 58, .external_lex_state = 2},
  [1065] = {.lex_state = 58, .external_lex_state = 2},
  [1066] = {.lex_state = 58, .external_lex_state = 2},
  [1067] = {.lex_state = 58, .external_lex_state = 9},
  [1068] = {.lex_state = 58, .external_lex_state = 2},
  [1069] = {.lex_state = 58, .external_lex_state = 2},
  [1070] = {.lex_state = 58, .external_lex_state = 2},
  [1071] = {.lex_state = 58, .external_lex_state = 2},
  [1072] = {.lex_state = 58, .external_lex_state = 2},
  [1073] = {.lex_state = 58, .external_lex_state = 2},
  [1074] = {.lex_state = 58, .external_lex_state = 2},
  [1075] = {.lex_state = 58, .external_lex_state = 2},
  [1076] = {.lex_state = 58, .external_lex_state = 2},
  [1077] = {.lex_state = 58, .external_lex_state = 2},
  [1078] = {.lex_state = 58, .external_lex_state = 2},
  [1079] = {.lex_state = 58, .external_lex_state = 2},
  [1080] = {.lex_state = 58, .external_lex_state = 2},
  [1081] = {.lex_state = 58, .external_lex_state = 2},
  [1082] = {.lex_state = 58, .external_lex_state = 2},
  [1083] = {.lex_state = 58, .external_lex_state = 2},
  [1084] = {.lex_state = 58, .external_lex_state = 2},
  [1085] = {.lex_state = 40, .external_lex_state = 3},
  [1086] = {.lex_state = 58, .external_lex_state = 2},
  [1087] = {.lex_state = 58, .external_lex_state = 2},
  [1088] = {.lex_state = 58, .external_lex_state = 2},
  [1089] = {.lex_state = 58, .external_lex_state = 2},
  [1090] = {.lex_state = 58, .external_lex_state = 2},
  [1091] = {.lex_state = 58, .external_lex_state = 2},
  [1092] = {.lex_state = 58, .external_lex_state = 2},
  [1093] = {.lex_state = 58, .external_lex_state = 2},
  [1094] = {.lex_state = 58, .external_lex_state = 2},
  [1095] = {.lex_state = 58, .external_lex_state = 2},
  [1096] = {.lex_state = 58, .external_lex_state = 2},
  [1097] = {.lex_state = 58, .external_lex_state = 2},
  [1098] = {.lex_state = 58, .external_lex_state = 2},
  [1099] = {.lex_state = 58, .external_lex_state = 2},
  [1100] = {.lex_state = 58, .external_lex_state = 2},
  [1101] = {.lex_state = 58, .external_lex_state = 2},
  [1102] = {.lex_state = 58, .external_lex_state = 2},
  [1103] = {.lex_state = 58, .external_lex_state = 2},
  [1104] = {.lex_state = 58, .external_lex_state = 2},
  [1105] = {.lex_state = 58, .external_lex_state = 2},
  [1106] = {.lex_state = 58, .external_lex_state = 2},
  [1107] = {.lex_state = 58, .external_lex_state = 2},
  [1108] = {.lex_state = 58, .external_lex_state = 2},
  [1109] = {.lex_state = 58, .external_lex_state = 2},
  [1110] = {.lex_state = 58, .external_lex_state = 2},
  [1111] = {.lex_state = 58, .external_lex_state = 2},
  [1112] = {.lex_state = 58, .external_lex_state = 2},
  [1113] = {.lex_state = 58, .external_lex_state = 2},
  [1114] = {.lex_state = 58, .external_lex_state = 2},
  [1115] = {.lex_state = 58, .external_lex_state = 2},
  [1116] = {.lex_state = 58, .external_lex_state = 2},
  [1117] = {.lex_state = 58, .external_lex_state = 2},
  [1118] = {.lex_state = 58, .external_lex_state = 2},
  [1119] = {.lex_state = 58, .external_lex_state = 2},
  [1120] = {.lex_state = 58, .external_lex_state = 2},
  [1121] = {.lex_state = 58, .external_lex_state = 2},
  [1122] = {.lex_state = 58, .external_lex_state = 2},
  [1123] = {.lex_state = 58, .external_lex_state = 2},
  [1124] = {.lex_state = 58, .external_lex_state = 2},
  [1125] = {.lex_state = 58, .external_lex_state = 2},
  [1126] = {.lex_state = 58, .external_lex_state = 2},
  [1127] = {.lex_state = 58, .external_lex_state = 2},
  [1128] = {.lex_state = 58, .external_lex_state = 2},
  [1129] = {.lex_state = 58, .external_lex_state = 2},
  [1130] = {.lex_state = 58, .external_lex_state = 2},
  [1131] = {.lex_state = 58, .external_lex_state = 2},
  [1132] = {.lex_state = 58, .external_lex_state = 2},
  [1133] = {.lex_state = 58, .external_lex_state = 2},
  [1134] = {.lex_state = 58, .external_lex_state = 2},
  [1135] = {.lex_state = 58, .external_lex_state = 2},
  [1136] = {.lex_state = 58, .external_lex_state = 2},
  [1137] = {.lex_state = 58, .external_lex_state = 2},
  [1138] = {.lex_state = 58, .external_lex_state = 2},
  [1139] = {.lex_state = 58, .external_lex_state = 2},
  [1140] = {.lex_state = 58, .external_lex_state = 2},
  [1141] = {.lex_state = 58, .external_lex_state = 2},
  [1142] = {.lex_state = 58, .external_lex_state = 2},
  [1143] = {.lex_state = 58, .external_lex_state = 2},
  [1144] = {.lex_state = 58, .external_lex_state = 2},
  [1145] = {.lex_state = 58, .external_lex_state = 2},
  [1146] = {.lex_state = 58, .external_lex_state = 2},
  [1147] = {.lex_state = 58, .external_lex_state = 2},
  [1148] = {.lex_state = 58, .external_lex_state = 2},
  [1149] = {.lex_state = 58, .external_lex_state = 2},
  [1150] = {.lex_state = 58, .external_lex_state = 2},
  [1151] = {.lex_state = 58, .external_lex_state = 2},
  [1152] = {.lex_state = 58, .external_lex_state = 2},
  [1153] = {.lex_state = 58, .external_lex_state = 2},
  [1154] = {.lex_state = 58, .external_lex_state = 2},
  [1155] = {.lex_state = 58, .external_lex_state = 2},
  [1156] = {.lex_state = 58, .external_lex_state = 2},
  [1157] = {.lex_state = 58, .external_lex_state = 2},
  [1158] = {.lex_state = 58, .external_lex_state = 2},
  [1159] = {.lex_state = 58, .external_lex_state = 2},
  [1160] = {.lex_state = 58, .external_lex_state = 2},
  [1161] = {.lex_state = 58, .external_lex_state = 2},
  [1162] = {.lex_state = 58, .external_lex_state = 2},
  [1163] = {.lex_state = 58, .external_lex_state = 2},
  [1164] = {.lex_state = 58, .external_lex_state = 2},
  [1165] = {.lex_state = 58, .external_lex_state = 2},
  [1166] = {.lex_state = 58, .external_lex_state = 2},
  [1167] = {.lex_state = 58, .external_lex_state = 2},
  [1168] = {.lex_state = 58, .external_lex_state = 2},
  [1169] = {.lex_state = 58, .external_lex_state = 2},
  [1170] = {.lex_state = 58, .external_lex_state = 2},
  [1171] = {.lex_state = 58, .external_lex_state = 2},
  [1172] = {.lex_state = 58, .external_lex_state = 2},
  [1173] = {.lex_state = 58, .external_lex_state = 2},
  [1174] = {.lex_state = 58, .external_lex_state = 2},
  [1175] = {.lex_state = 58, .external_lex_state = 2},
  [1176] = {.lex_state = 58, .external_lex_state = 2},
  [1177] = {.lex_state = 58, .external_lex_state = 2},
  [1178] = {.lex_state = 58, .external_lex_state = 2},
  [1179] = {.lex_state = 58, .external_lex_state = 2},
  [1180] = {.lex_state = 58, .external_lex_state = 2},
  [1181] = {.lex_state = 58, .external_lex_state = 2},
  [1182] = {.lex_state = 58, .external_lex_state = 2},
  [1183] = {.lex_state = 58, .external_lex_state = 2},
  [1184] = {.lex_state = 58, .external_lex_state = 2},
  [1185] = {.lex_state = 58, .external_lex_state = 2},
  [1186] = {.lex_state = 58, .external_lex_state = 2},
  [1187] = {.lex_state = 58, .external_lex_state = 2},
  [1188] = {.lex_state = 58, .external_lex_state = 2},
  [1189] = {.lex_state = 58, .external_lex_state = 2},
  [1190] = {.lex_state = 40, .external_lex_state = 3},
  [1191] = {.lex_state = 58, .external_lex_state = 2},
  [1192] = {.lex_state = 58, .external_lex_state = 2},
  [1193] = {.lex_state = 58, .external_lex_state = 2},
  [1194] = {.lex_state = 58, .external_lex_state = 2},
  [1195] = {.lex_state = 58, .external_lex_state = 2},
  [1196] = {.lex_state = 58, .external_lex_state = 2},
  [1197] = {.lex_state = 58, .external_lex_state = 2},
  [1198] = {.lex_state = 58, .external_lex_state = 2},
  [1199] = {.lex_state = 58, .external_lex_state = 2},
  [1200] = {.lex_state = 40, .external_lex_state = 4},
  [1201] = {.lex_state = 40, .external_lex_state = 4},
  [1202] = {.lex_state = 40, .external_lex_state = 4},
  [1203] = {.lex_state = 40, .external_lex_state = 11},
  [1204] = {.lex_state = 40, .external_lex_state = 11},
  [1205] = {.lex_state = 40, .external_lex_state = 11},
  [1206] = {.lex_state = 40, .external_lex_state = 11},
  [1207] = {.lex_state = 40, .external_lex_state = 3},
  [1208] = {.lex_state = 58, .external_lex_state = 3},
  [1209] = {.lex_state = 40, .external_lex_state = 3},
  [1210] = {.lex_state = 40, .external_lex_state = 11},
  [1211] = {.lex_state = 40, .external_lex_state = 11},
  [1212] = {.lex_state = 40, .external_lex_state = 11},
  [1213] = {.lex_state = 40, .external_lex_state = 11},
  [1214] = {.lex_state = 40, .external_lex_state = 11},
  [1215] = {.lex_state = 40, .external_lex_state = 11},
  [1216] = {.lex_state = 40, .external_lex_state = 6},
  [1217] = {.lex_state = 40, .external_lex_state = 11},
  [1218] = {.lex_state = 40, .external_lex_state = 11},
  [1219] = {.lex_state = 40, .external_lex_state = 6},
  [1220] = {.lex_state = 40, .external_lex_state = 12},
  [1221] = {.lex_state = 40, .external_lex_state = 12},
  [1222] = {.lex_state = 40, .external_lex_state = 6},
  [1223] = {.lex_state = 40, .external_lex_state = 6},
  [1224] = {.lex_state = 58, .external_lex_state = 3},
  [1225] = {.lex_state = 40, .external_lex_state = 11},
  [1226] = {.lex_state = 40, .external_lex_state = 6},
  [1227] = {.lex_state = 40, .external_lex_state = 6},
  [1228] = {.lex_state = 40, .external_lex_state = 12},
  [1229] = {.lex_state = 40, .external_lex_state = 4},
  [1230] = {.lex_state = 40, .external_lex_state = 12},
  [1231] = {.lex_state = 40, .external_lex_state = 12},
  [1232] = {.lex_state = 40, .external_lex_state = 9},
  [1233] = {.lex_state = 40, .external_lex_state = 13},
  [1234] = {.lex_state = 40, .external_lex_state = 2},
  [1235] = {.lex_state = 41, .external_lex_state = 11},
  [1236] = {.lex_state = 40, .external_lex_state = 12},
  [1237] = {.lex_state = 40, .external_lex_state = 11},
  [1238] = {.lex_state = 40, .external_lex_state = 12},
  [1239] = {.lex_state = 40, .external_lex_state = 12},
  [1240] = {.lex_state = 40, .external_lex_state = 10},
  [1241] = {.lex_state = 40, .external_lex_state = 12},
  [1242] = {.lex_state = 40, .external_lex_state = 12},
  [1243] = {.lex_state = 40, .external_lex_state = 12},
  [1244] = {.lex_state = 40, .external_lex_state = 12},
  [1245] = {.lex_state = 40, .external_lex_state = 9},
  [1246] = {.lex_state = 40, .external_lex_state = 12},
  [1247] = {.lex_state = 41, .external_lex_state = 11},
  [1248] = {.lex_state = 58, .external_lex_state = 3},
  [1249] = {.lex_state = 40, .external_lex_state = 12},
  [1250] = {.lex_state = 40, .external_lex_state = 12},
  [1251] = {.lex_state = 40, .external_lex_state = 12},
  [1252] = {.lex_state = 40, .external_lex_state = 4},
  [1253] = {.lex_state = 40, .external_lex_state = 14},
  [1254] = {.lex_state = 40, .external_lex_state = 10},
  [1255] = {.lex_state = 40, .external_lex_state = 12},
  [1256] = {.lex_state = 40, .external_lex_state = 9},
  [1257] = {.lex_state = 41, .external_lex_state = 11},
  [1258] = {.lex_state = 40, .external_lex_state = 2},
  [1259] = {.lex_state = 40, .external_lex_state = 12},
  [1260] = {.lex_state = 40, .external_lex_state = 12},
  [1261] = {.lex_state = 40, .external_lex_state = 9},
  [1262] = {.lex_state = 58, .external_lex_state = 3},
  [1263] = {.lex_state = 58, .external_lex_state = 3},
  [1264] = {.lex_state = 40, .external_lex_state = 15},
  [1265] = {.lex_state = 40, .external_lex_state = 9},
  [1266] = {.lex_state = 40, .external_lex_state = 12},
  [1267] = {.lex_state = 40, .external_lex_state = 12},
  [1268] = {.lex_state = 40, .external_lex_state = 12},
  [1269] = {.lex_state = 40, .external_lex_state = 12},
  [1270] = {.lex_state = 40, .external_lex_state = 12},
  [1271] = {.lex_state = 40, .external_lex_state = 9},
  [1272] = {.lex_state = 40, .external_lex_state = 12},
  [1273] = {.lex_state = 40, .external_lex_state = 12},
  [1274] = {.lex_state = 40, .external_lex_state = 12},
  [1275] = {.lex_state = 40, .external_lex_state = 14},
  [1276] = {.lex_state = 40, .external_lex_state = 12},
  [1277] = {.lex_state = 40, .external_lex_state = 2},
  [1278] = {.lex_state = 40, .external_lex_state = 12},
  [1279] = {.lex_state = 40, .external_lex_state = 10},
  [1280] = {.lex_state = 40, .external_lex_state = 12},
  [1281] = {.lex_state = 40, .external_lex_state = 12},
  [1282] = {.lex_state = 40, .external_lex_state = 12},
  [1283] = {.lex_state = 40, .external_lex_state = 12},
  [1284] = {.lex_state = 41, .external_lex_state = 12},
  [1285] = {.lex_state = 41, .external_lex_state = 14},
  [1286] = {.lex_state = 41, .external_lex_state = 12},
  [1287] = {.lex_state = 41, .external_lex_state = 12},
  [1288] = {.lex_state = 40, .external_lex_state = 10},
  [1289] = {.lex_state = 40, .external_lex_state = 11},
  [1290] = {.lex_state = 40, .external_lex_state = 11},
  [1291] = {.lex_state = 40, .external_lex_state = 11},
  [1292] = {.lex_state = 40, .external_lex_state = 11},
  [1293] = {.lex_state = 41, .external_lex_state = 12},
  [1294] = {.lex_state = 41, .external_lex_state = 12},
  [1295] = {.lex_state = 41, .external_lex_state = 12},
  [1296] = {.lex_state = 40, .external_lex_state = 14},
  [1297] = {.lex_state = 40, .external_lex_state = 13},
  [1298] = {.lex_state = 40, .external_lex_state = 13},
  [1299] = {.lex_state = 40, .external_lex_state = 11},
  [1300] = {.lex_state = 40, .external_lex_state = 11},
  [1301] = {.lex_state = 40, .external_lex_state = 11},
  [1302] = {.lex_state = 40, .external_lex_state = 14},
  [1303] = {.lex_state = 41, .external_lex_state = 11},
  [1304] = {.lex_state = 40, .external_lex_state = 11},
  [1305] = {.lex_state = 40, .external_lex_state = 11},
  [1306] = {.lex_state = 41, .external_lex_state = 12},
  [1307] = {.lex_state = 40, .external_lex_state = 10},
  [1308] = {.lex_state = 40, .external_lex_state = 11},
  [1309] = {.lex_state = 41, .external_lex_state = 12},
  [1310] = {.lex_state = 40, .external_lex_state = 11},
  [1311] = {.lex_state = 40, .external_lex_state = 11},
  [1312] = {.lex_state = 40, .external_lex_state = 11},
  [1313] = {.lex_state = 40, .external_lex_state = 11},
  [1314] = {.lex_state = 40, .external_lex_state = 11},
  [1315] = {.lex_state = 40, .external_lex_state = 11},
  [1316] = {.lex_state = 40, .external_lex_state = 11},
  [1317] = {.lex_state = 40, .external_lex_state = 11},
  [1318] = {.lex_state = 40, .external_lex_state = 11},
  [1319] = {.lex_state = 40, .external_lex_state = 11},
  [1320] = {.lex_state = 40, .external_lex_state = 11},
  [1321] = {.lex_state = 41, .external_lex_state = 12},
  [1322] = {.lex_state = 40, .external_lex_state = 11},
  [1323] = {.lex_state = 41, .external_lex_state = 12},
  [1324] = {.lex_state = 40, .external_lex_state = 14},
  [1325] = {.lex_state = 40, .external_lex_state = 14},
  [1326] = {.lex_state = 41, .external_lex_state = 12},
  [1327] = {.lex_state = 40, .external_lex_state = 11},
  [1328] = {.lex_state = 40, .external_lex_state = 11},
  [1329] = {.lex_state = 40, .external_lex_state = 13},
  [1330] = {.lex_state = 40, .external_lex_state = 13},
  [1331] = {.lex_state = 40, .external_lex_state = 13},
  [1332] = {.lex_state = 40, .external_lex_state = 13},
  [1333] = {.lex_state = 40, .external_lex_state = 13},
  [1334] = {.lex_state = 40, .external_lex_state = 13},
  [1335] = {.lex_state = 40, .external_lex_state = 13},
  [1336] = {.lex_state = 40, .external_lex_state = 13},
  [1337] = {.lex_state = 40, .external_lex_state = 10},
  [1338] = {.lex_state = 40, .external_lex_state = 6},
  [1339] = {.lex_state = 40, .external_lex_state = 11},
  [1340] = {.lex_state = 40, .external_lex_state = 15},
  [1341] = {.lex_state = 40, .external_lex_state = 15},
  [1342] = {.lex_state = 40, .external_lex_state = 15},
  [1343] = {.lex_state = 40, .external_lex_state = 13},
  [1344] = {.lex_state = 40, .external_lex_state = 13},
  [1345] = {.lex_state = 40, .external_lex_state = 14},
  [1346] = {.lex_state = 40, .external_lex_state = 14},
  [1347] = {.lex_state = 40, .external_lex_state = 11},
  [1348] = {.lex_state = 40, .external_lex_state = 11},
  [1349] = {.lex_state = 40, .external_lex_state = 11},
  [1350] = {.lex_state = 40, .external_lex_state = 15},
  [1351] = {.lex_state = 40, .external_lex_state = 15},
  [1352] = {.lex_state = 40, .external_lex_state = 15},
  [1353] = {.lex_state = 40, .external_lex_state = 15},
  [1354] = {.lex_state = 40, .external_lex_state = 15},
  [1355] = {.lex_state = 40, .external_lex_state = 14},
  [1356] = {.lex_state = 40, .external_lex_state = 15},
  [1357] = {.lex_state = 40, .external_lex_state = 15},
  [1358] = {.lex_state = 40, .external_lex_state = 15},
  [1359] = {.lex_state = 40, .external_lex_state = 11},
  [1360] = {.lex_state = 40, .external_lex_state = 11},
  [1361] = {.lex_state = 40, .external_lex_state = 11},
  [1362] = {.lex_state = 40, .external_lex_state = 14},
  [1363] = {.lex_state = 40, .external_lex_state = 14},
  [1364] = {.lex_state = 40, .external_lex_state = 14},
  [1365] = {.lex_state = 40, .external_lex_state = 14},
  [1366] = {.lex_state = 40, .external_lex_state = 14},
  [1367] = {.lex_state = 40, .external_lex_state = 6},
  [1368] = {.lex_state = 40, .external_lex_state = 14},
  [1369] = {.lex_state = 40, .external_lex_state = 14},
  [1370] = {.lex_state = 40, .external_lex_state = 14},
  [1371] = {.lex_state = 40, .external_lex_state = 14},
  [1372] = {.lex_state = 40, .external_lex_state = 14},
  [1373] = {.lex_state = 40, .external_lex_state = 14},
  [1374] = {.lex_state = 40, .external_lex_state = 14},
  [1375] = {.lex_state = 40, .external_lex_state = 14},
  [1376] = {.lex_state = 40, .external_lex_state = 14},
  [1377] = {.lex_state = 40, .external_lex_state = 14},
  [1378] = {.lex_state = 40, .external_lex_state = 6},
  [1379] = {.lex_state = 40, .external_lex_state = 14},
  [1380] = {.lex_state = 40, .external_lex_state = 14},
  [1381] = {.lex_state = 40, .external_lex_state = 11},
  [1382] = {.lex_state = 40, .external_lex_state = 11},
  [1383] = {.lex_state = 40, .external_lex_state = 11},
  [1384] = {.lex_state = 41, .external_lex_state = 12},
  [1385] = {.lex_state = 40, .external_lex_state = 6},
  [1386] = {.lex_state = 41, .external_lex_state = 14},
  [1387] = {.lex_state = 41, .external_lex_state = 14},
  [1388] = {.lex_state = 41, .external_lex_state = 14},
  [1389] = {.lex_state = 40, .external_lex_state = 15},
  [1390] = {.lex_state = 40, .external_lex_state = 11},
  [1391] = {.lex_state = 40, .external_lex_state = 15},
  [1392] = {.lex_state = 40, .external_lex_state = 11},
  [1393] = {.lex_state = 41, .external_lex_state = 15},
  [1394] = {.lex_state = 40, .external_lex_state = 9},
  [1395] = {.lex_state = 41, .external_lex_state = 14},
  [1396] = {.lex_state = 40, .external_lex_state = 12},
  [1397] = {.lex_state = 40, .external_lex_state = 12},
  [1398] = {.lex_state = 40, .external_lex_state = 12},
  [1399] = {.lex_state = 40, .external_lex_state = 12},
  [1400] = {.lex_state = 40, .external_lex_state = 12},
  [1401] = {.lex_state = 40, .external_lex_state = 12},
  [1402] = {.lex_state = 41, .external_lex_state = 14},
  [1403] = {.lex_state = 41, .external_lex_state = 14},
  [1404] = {.lex_state = 41, .external_lex_state = 14},
  [1405] = {.lex_state = 40, .external_lex_state = 12},
  [1406] = {.lex_state = 40, .external_lex_state = 10},
  [1407] = {.lex_state = 40, .external_lex_state = 14},
  [1408] = {.lex_state = 40, .external_lex_state = 12},
  [1409] = {.lex_state = 41, .external_lex_state = 14},
  [1410] = {.lex_state = 40, .external_lex_state = 12},
  [1411] = {.lex_state = 40, .external_lex_state = 12},
  [1412] = {.lex_state = 40, .external_lex_state = 12},
  [1413] = {.lex_state = 40, .external_lex_state = 12},
  [1414] = {.lex_state = 40, .external_lex_state = 14},
  [1415] = {.lex_state = 40, .external_lex_state = 14},
  [1416] = {.lex_state = 40, .external_lex_state = 12},
  [1417] = {.lex_state = 40, .external_lex_state = 12},
  [1418] = {.lex_state = 40, .external_lex_state = 12},
  [1419] = {.lex_state = 40, .external_lex_state = 12},
  [1420] = {.lex_state = 40, .external_lex_state = 14},
  [1421] = {.lex_state = 40, .external_lex_state = 12},
  [1422] = {.lex_state = 40, .external_lex_state = 14},
  [1423] = {.lex_state = 40, .external_lex_state = 14},
  [1424] = {.lex_state = 40, .external_lex_state = 14},
  [1425] = {.lex_state = 40, .external_lex_state = 12},
  [1426] = {.lex_state = 40, .external_lex_state = 12},
  [1427] = {.lex_state = 40, .external_lex_state = 12},
  [1428] = {.lex_state = 40, .external_lex_state = 12},
  [1429] = {.lex_state = 40, .external_lex_state = 12},
  [1430] = {.lex_state = 40, .external_lex_state = 12},
  [1431] = {.lex_state = 40, .external_lex_state = 12},
  [1432] = {.lex_state = 40, .external_lex_state = 12},
  [1433] = {.lex_state = 41, .external_lex_state = 15},
  [1434] = {.lex_state = 40, .external_lex_state = 12},
  [1435] = {.lex_state = 41, .external_lex_state = 15},
  [1436] = {.lex_state = 40, .external_lex_state = 9},
  [1437] = {.lex_state = 40, .external_lex_state = 12},
  [1438] = {.lex_state = 40, .external_lex_state = 12},
  [1439] = {.lex_state = 40, .external_lex_state = 12},
  [1440] = {.lex_state = 40, .external_lex_state = 12},
  [1441] = {.lex_state = 41, .external_lex_state = 14},
  [1442] = {.lex_state = 40, .external_lex_state = 12},
  [1443] = {.lex_state = 40, .external_lex_state = 12},
  [1444] = {.lex_state = 40, .external_lex_state = 15},
  [1445] = {.lex_state = 41, .external_lex_state = 14},
  [1446] = {.lex_state = 40, .external_lex_state = 9},
  [1447] = {.lex_state = 41, .external_lex_state = 14},
  [1448] = {.lex_state = 41, .external_lex_state = 14},
  [1449] = {.lex_state = 40, .external_lex_state = 12},
  [1450] = {.lex_state = 40, .external_lex_state = 12},
  [1451] = {.lex_state = 40, .external_lex_state = 12},
  [1452] = {.lex_state = 40, .external_lex_state = 12},
  [1453] = {.lex_state = 40, .external_lex_state = 12},
  [1454] = {.lex_state = 40, .external_lex_state = 12},
  [1455] = {.lex_state = 40, .external_lex_state = 12},
  [1456] = {.lex_state = 40, .external_lex_state = 12},
  [1457] = {.lex_state = 40, .external_lex_state = 12},
  [1458] = {.lex_state = 40, .external_lex_state = 12},
  [1459] = {.lex_state = 40, .external_lex_state = 12},
  [1460] = {.lex_state = 40, .external_lex_state = 12},
  [1461] = {.lex_state = 40, .external_lex_state = 12},
  [1462] = {.lex_state = 40, .external_lex_state = 12},
  [1463] = {.lex_state = 40, .external_lex_state = 14},
  [1464] = {.lex_state = 40, .external_lex_state = 12},
  [1465] = {.lex_state = 40, .external_lex_state = 15},
  [1466] = {.lex_state = 41, .external_lex_state = 15},
  [1467] = {.lex_state = 40, .external_lex_state = 15},
  [1468] = {.lex_state = 40, .external_lex_state = 12},
  [1469] = {.lex_state = 41, .external_lex_state = 15},
  [1470] = {.lex_state = 40, .external_lex_state = 12},
  [1471] = {.lex_state = 40, .external_lex_state = 12},
  [1472] = {.lex_state = 40, .external_lex_state = 12},
  [1473] = {.lex_state = 41, .external_lex_state = 13},
  [1474] = {.lex_state = 40, .external_lex_state = 12},
  [1475] = {.lex_state = 40, .external_lex_state = 12},
  [1476] = {.lex_state = 41, .external_lex_state = 13},
  [1477] = {.lex_state = 40, .external_lex_state = 12},
  [1478] = {.lex_state = 40, .external_lex_state = 12},
  [1479] = {.lex_state = 40, .external_lex_state = 12},
  [1480] = {.lex_state = 40, .external_lex_state = 9},
  [1481] = {.lex_state = 40, .external_lex_state = 2},
  [1482] = {.lex_state = 41, .external_lex_state = 13},
  [1483] = {.lex_state = 40, .external_lex_state = 10},
  [1484] = {.lex_state = 40, .external_lex_state = 12},
  [1485] = {.lex_state = 40, .external_lex_state = 12},
  [1486] = {.lex_state = 40, .external_lex_state = 12},
  [1487] = {.lex_state = 40, .external_lex_state = 12},
  [1488] = {.lex_state = 40, .external_lex_state = 3},
  [1489] = {.lex_state = 40, .external_lex_state = 12},
  [1490] = {.lex_state = 41, .external_lex_state = 15},
  [1491] = {.lex_state = 40, .external_lex_state = 16},
  [1492] = {.lex_state = 41, .external_lex_state = 14},
  [1493] = {.lex_state = 40, .external_lex_state = 15},
  [1494] = {.lex_state = 41, .external_lex_state = 15},
  [1495] = {.lex_state = 41, .external_lex_state = 14},
  [1496] = {.lex_state = 40, .external_lex_state = 15},
  [1497] = {.lex_state = 41, .external_lex_state = 14},
  [1498] = {.lex_state = 40, .external_lex_state = 12},
  [1499] = {.lex_state = 40, .external_lex_state = 12},
  [1500] = {.lex_state = 41, .external_lex_state = 15},
  [1501] = {.lex_state = 41, .external_lex_state = 15},
  [1502] = {.lex_state = 40, .external_lex_state = 12},
  [1503] = {.lex_state = 40, .external_lex_state = 12},
  [1504] = {.lex_state = 40, .external_lex_state = 12},
  [1505] = {.lex_state = 40, .external_lex_state = 15},
  [1506] = {.lex_state = 40, .external_lex_state = 12},
  [1507] = {.lex_state = 40, .external_lex_state = 12},
  [1508] = {.lex_state = 40, .external_lex_state = 15},
  [1509] = {.lex_state = 40, .external_lex_state = 12},
  [1510] = {.lex_state = 40, .external_lex_state = 15},
  [1511] = {.lex_state = 40, .external_lex_state = 15},
  [1512] = {.lex_state = 40, .external_lex_state = 15},
  [1513] = {.lex_state = 40, .external_lex_state = 12},
  [1514] = {.lex_state = 40, .external_lex_state = 15},
  [1515] = {.lex_state = 40, .external_lex_state = 15},
  [1516] = {.lex_state = 40, .external_lex_state = 12},
  [1517] = {.lex_state = 41, .external_lex_state = 15},
  [1518] = {.lex_state = 40, .external_lex_state = 2},
  [1519] = {.lex_state = 40, .external_lex_state = 15},
  [1520] = {.lex_state = 41, .external_lex_state = 13},
  [1521] = {.lex_state = 40, .external_lex_state = 10},
  [1522] = {.lex_state = 40, .external_lex_state = 13},
  [1523] = {.lex_state = 40, .external_lex_state = 14},
  [1524] = {.lex_state = 40, .external_lex_state = 14},
  [1525] = {.lex_state = 40, .external_lex_state = 14},
  [1526] = {.lex_state = 40, .external_lex_state = 14},
  [1527] = {.lex_state = 40, .external_lex_state = 14},
  [1528] = {.lex_state = 40, .external_lex_state = 14},
  [1529] = {.lex_state = 40, .external_lex_state = 14},
  [1530] = {.lex_state = 40, .external_lex_state = 14},
  [1531] = {.lex_state = 40, .external_lex_state = 15},
  [1532] = {.lex_state = 40, .external_lex_state = 13},
  [1533] = {.lex_state = 40, .external_lex_state = 14},
  [1534] = {.lex_state = 40, .external_lex_state = 13},
  [1535] = {.lex_state = 40, .external_lex_state = 14},
  [1536] = {.lex_state = 40, .external_lex_state = 13},
  [1537] = {.lex_state = 40, .external_lex_state = 15},
  [1538] = {.lex_state = 41, .external_lex_state = 11},
  [1539] = {.lex_state = 41, .external_lex_state = 11},
  [1540] = {.lex_state = 41, .external_lex_state = 11},
  [1541] = {.lex_state = 40, .external_lex_state = 13},
  [1542] = {.lex_state = 40, .external_lex_state = 14},
  [1543] = {.lex_state = 40, .external_lex_state = 16},
  [1544] = {.lex_state = 40, .external_lex_state = 14},
  [1545] = {.lex_state = 40, .external_lex_state = 13},
  [1546] = {.lex_state = 40, .external_lex_state = 14},
  [1547] = {.lex_state = 40, .external_lex_state = 14},
  [1548] = {.lex_state = 40, .external_lex_state = 14},
  [1549] = {.lex_state = 40, .external_lex_state = 15},
  [1550] = {.lex_state = 40, .external_lex_state = 14},
  [1551] = {.lex_state = 40, .external_lex_state = 15},
  [1552] = {.lex_state = 40, .external_lex_state = 15},
  [1553] = {.lex_state = 40, .external_lex_state = 15},
  [1554] = {.lex_state = 40, .external_lex_state = 13},
  [1555] = {.lex_state = 40, .external_lex_state = 14},
  [1556] = {.lex_state = 40, .external_lex_state = 14},
  [1557] = {.lex_state = 40, .external_lex_state = 13},
  [1558] = {.lex_state = 40, .external_lex_state = 15},
  [1559] = {.lex_state = 40, .external_lex_state = 13},
  [1560] = {.lex_state = 40, .external_lex_state = 13},
  [1561] = {.lex_state = 40, .external_lex_state = 14},
  [1562] = {.lex_state = 40, .external_lex_state = 15},
  [1563] = {.lex_state = 40, .external_lex_state = 13},
  [1564] = {.lex_state = 40, .external_lex_state = 15},
  [1565] = {.lex_state = 40, .external_lex_state = 15},
  [1566] = {.lex_state = 40, .external_lex_state = 13},
  [1567] = {.lex_state = 40, .external_lex_state = 13},
  [1568] = {.lex_state = 40, .external_lex_state = 13},
  [1569] = {.lex_state = 40, .external_lex_state = 15},
  [1570] = {.lex_state = 40, .external_lex_state = 10},
  [1571] = {.lex_state = 40, .external_lex_state = 14},
  [1572] = {.lex_state = 40, .external_lex_state = 15},
  [1573] = {.lex_state = 40, .external_lex_state = 15},
  [1574] = {.lex_state = 40, .external_lex_state = 14},
  [1575] = {.lex_state = 40, .external_lex_state = 14},
  [1576] = {.lex_state = 40, .external_lex_state = 14},
  [1577] = {.lex_state = 40, .external_lex_state = 14},
  [1578] = {.lex_state = 40, .external_lex_state = 13},
  [1579] = {.lex_state = 40, .external_lex_state = 15},
  [1580] = {.lex_state = 40, .external_lex_state = 15},
  [1581] = {.lex_state = 40, .external_lex_state = 15},
  [1582] = {.lex_state = 40, .external_lex_state = 14},
  [1583] = {.lex_state = 40, .external_lex_state = 15},
  [1584] = {.lex_state = 40, .external_lex_state = 15},
  [1585] = {.lex_state = 40, .external_lex_state = 13},
  [1586] = {.lex_state = 40, .external_lex_state = 15},
  [1587] = {.lex_state = 40, .external_lex_state = 15},
  [1588] = {.lex_state = 40, .external_lex_state = 14},
  [1589] = {.lex_state = 40, .external_lex_state = 15},
  [1590] = {.lex_state = 40, .external_lex_state = 15},
  [1591] = {.lex_state = 34, .external_lex_state = 11},
  [1592] = {.lex_state = 40, .external_lex_state = 15},
  [1593] = {.lex_state = 40, .external_lex_state = 15},
  [1594] = {.lex_state = 34, .external_lex_state = 11},
  [1595] = {.lex_state = 40, .external_lex_state = 14},
  [1596] = {.lex_state = 40, .external_lex_state = 15},
  [1597] = {.lex_state = 40, .external_lex_state = 13},
  [1598] = {.lex_state = 40, .external_lex_state = 13},
  [1599] = {.lex_state = 41, .external_lex_state = 16},
  [1600] = {.lex_state = 40, .external_lex_state = 13},
  [1601] = {.lex_state = 40, .external_lex_state = 14},
  [1602] = {.lex_state = 41, .external_lex_state = 16},
  [1603] = {.lex_state = 41, .external_lex_state = 16},
  [1604] = {.lex_state = 40, .external_lex_state = 14},
  [1605] = {.lex_state = 40, .external_lex_state = 14},
  [1606] = {.lex_state = 40, .external_lex_state = 14},
  [1607] = {.lex_state = 40, .external_lex_state = 15},
  [1608] = {.lex_state = 40, .external_lex_state = 14},
  [1609] = {.lex_state = 40, .external_lex_state = 13},
  [1610] = {.lex_state = 40, .external_lex_state = 13},
  [1611] = {.lex_state = 40, .external_lex_state = 15},
  [1612] = {.lex_state = 40, .external_lex_state = 13},
  [1613] = {.lex_state = 40, .external_lex_state = 13},
  [1614] = {.lex_state = 40, .external_lex_state = 15},
  [1615] = {.lex_state = 40, .external_lex_state = 13},
  [1616] = {.lex_state = 40, .external_lex_state = 15},
  [1617] = {.lex_state = 40, .external_lex_state = 15},
  [1618] = {.lex_state = 40, .external_lex_state = 14},
  [1619] = {.lex_state = 40, .external_lex_state = 14},
  [1620] = {.lex_state = 41, .external_lex_state = 14},
  [1621] = {.lex_state = 41, .external_lex_state = 14},
  [1622] = {.lex_state = 41, .external_lex_state = 14},
  [1623] = {.lex_state = 40, .external_lex_state = 14},
  [1624] = {.lex_state = 40, .external_lex_state = 14},
  [1625] = {.lex_state = 40, .external_lex_state = 14},
  [1626] = {.lex_state = 40, .external_lex_state = 15},
  [1627] = {.lex_state = 40, .external_lex_state = 15},
  [1628] = {.lex_state = 40, .external_lex_state = 16},
  [1629] = {.lex_state = 40, .external_lex_state = 15},
  [1630] = {.lex_state = 34, .external_lex_state = 11},
  [1631] = {.lex_state = 40, .external_lex_state = 15},
  [1632] = {.lex_state = 40, .external_lex_state = 15},
  [1633] = {.lex_state = 40, .external_lex_state = 15},
  [1634] = {.lex_state = 40, .external_lex_state = 15},
  [1635] = {.lex_state = 40, .external_lex_state = 13},
  [1636] = {.lex_state = 40, .external_lex_state = 14},
  [1637] = {.lex_state = 34, .external_lex_state = 11},
  [1638] = {.lex_state = 34, .external_lex_state = 11},
  [1639] = {.lex_state = 34, .external_lex_state = 11},
  [1640] = {.lex_state = 40, .external_lex_state = 11},
  [1641] = {.lex_state = 40, .external_lex_state = 14},
  [1642] = {.lex_state = 40, .external_lex_state = 14},
  [1643] = {.lex_state = 40, .external_lex_state = 16},
  [1644] = {.lex_state = 40, .external_lex_state = 16},
  [1645] = {.lex_state = 40, .external_lex_state = 14},
  [1646] = {.lex_state = 40, .external_lex_state = 15},
  [1647] = {.lex_state = 40, .external_lex_state = 15},
  [1648] = {.lex_state = 40, .external_lex_state = 14},
  [1649] = {.lex_state = 40, .external_lex_state = 16},
  [1650] = {.lex_state = 40, .external_lex_state = 15},
  [1651] = {.lex_state = 40, .external_lex_state = 14},
  [1652] = {.lex_state = 40, .external_lex_state = 16},
  [1653] = {.lex_state = 40, .external_lex_state = 14},
  [1654] = {.lex_state = 40, .external_lex_state = 15},
  [1655] = {.lex_state = 40, .external_lex_state = 14},
  [1656] = {.lex_state = 40, .external_lex_state = 13},
  [1657] = {.lex_state = 40, .external_lex_state = 14},
  [1658] = {.lex_state = 40, .external_lex_state = 16},
  [1659] = {.lex_state = 40, .external_lex_state = 14},
  [1660] = {.lex_state = 40, .external_lex_state = 14},
  [1661] = {.lex_state = 40, .external_lex_state = 14},
  [1662] = {.lex_state = 40, .external_lex_state = 16},
  [1663] = {.lex_state = 40, .external_lex_state = 16},
  [1664] = {.lex_state = 40, .external_lex_state = 14},
  [1665] = {.lex_state = 40, .external_lex_state = 13},
  [1666] = {.lex_state = 40, .external_lex_state = 13},
  [1667] = {.lex_state = 40, .external_lex_state = 13},
  [1668] = {.lex_state = 40, .external_lex_state = 13},
  [1669] = {.lex_state = 40, .external_lex_state = 14},
  [1670] = {.lex_state = 41, .external_lex_state = 15},
  [1671] = {.lex_state = 40, .external_lex_state = 14},
  [1672] = {.lex_state = 41, .external_lex_state = 15},
  [1673] = {.lex_state = 40, .external_lex_state = 13},
  [1674] = {.lex_state = 40, .external_lex_state = 13},
  [1675] = {.lex_state = 40, .external_lex_state = 16},
  [1676] = {.lex_state = 40, .external_lex_state = 14},
  [1677] = {.lex_state = 41, .external_lex_state = 15},
  [1678] = {.lex_state = 40, .external_lex_state = 14},
  [1679] = {.lex_state = 40, .external_lex_state = 14},
  [1680] = {.lex_state = 40, .external_lex_state = 14},
  [1681] = {.lex_state = 40, .external_lex_state = 14},
  [1682] = {.lex_state = 40, .external_lex_state = 13},
  [1683] = {.lex_state = 40, .external_lex_state = 14},
  [1684] = {.lex_state = 40, .external_lex_state = 13},
  [1685] = {.lex_state = 40, .external_lex_state = 16},
  [1686] = {.lex_state = 40, .external_lex_state = 14},
  [1687] = {.lex_state = 40, .external_lex_state = 13},
  [1688] = {.lex_state = 40, .external_lex_state = 13},
  [1689] = {.lex_state = 40, .external_lex_state = 14},
  [1690] = {.lex_state = 40, .external_lex_state = 14},
  [1691] = {.lex_state = 40, .external_lex_state = 14},
  [1692] = {.lex_state = 40, .external_lex_state = 14},
  [1693] = {.lex_state = 40, .external_lex_state = 14},
  [1694] = {.lex_state = 40, .external_lex_state = 14},
  [1695] = {.lex_state = 40, .external_lex_state = 14},
  [1696] = {.lex_state = 40, .external_lex_state = 14},
  [1697] = {.lex_state = 40, .external_lex_state = 14},
  [1698] = {.lex_state = 40, .external_lex_state = 14},
  [1699] = {.lex_state = 40, .external_lex_state = 14},
  [1700] = {.lex_state = 40, .external_lex_state = 14},
  [1701] = {.lex_state = 40, .external_lex_state = 16},
  [1702] = {.lex_state = 40, .external_lex_state = 15},
  [1703] = {.lex_state = 41, .external_lex_state = 16},
  [1704] = {.lex_state = 40, .external_lex_state = 15},
  [1705] = {.lex_state = 40, .external_lex_state = 15},
  [1706] = {.lex_state = 40, .external_lex_state = 15},
  [1707] = {.lex_state = 40, .external_lex_state = 15},
  [1708] = {.lex_state = 41, .external_lex_state = 11},
  [1709] = {.lex_state = 40, .external_lex_state = 15},
  [1710] = {.lex_state = 40, .external_lex_state = 15},
  [1711] = {.lex_state = 40, .external_lex_state = 15},
  [1712] = {.lex_state = 41, .external_lex_state = 11},
  [1713] = {.lex_state = 40, .external_lex_state = 15},
  [1714] = {.lex_state = 40, .external_lex_state = 15},
  [1715] = {.lex_state = 40, .external_lex_state = 15},
  [1716] = {.lex_state = 40, .external_lex_state = 15},
  [1717] = {.lex_state = 40, .external_lex_state = 15},
  [1718] = {.lex_state = 40, .external_lex_state = 15},
  [1719] = {.lex_state = 41, .external_lex_state = 14},
  [1720] = {.lex_state = 41, .external_lex_state = 14},
  [1721] = {.lex_state = 41, .external_lex_state = 14},
  [1722] = {.lex_state = 41, .external_lex_state = 16},
  [1723] = {.lex_state = 40, .external_lex_state = 15},
  [1724] = {.lex_state = 41, .external_lex_state = 15},
  [1725] = {.lex_state = 41, .external_lex_state = 15},
  [1726] = {.lex_state = 40, .external_lex_state = 15},
  [1727] = {.lex_state = 41, .external_lex_state = 16},
  [1728] = {.lex_state = 40, .external_lex_state = 15},
  [1729] = {.lex_state = 40, .external_lex_state = 15},
  [1730] = {.lex_state = 41, .external_lex_state = 12},
  [1731] = {.lex_state = 41, .external_lex_state = 12},
  [1732] = {.lex_state = 41, .external_lex_state = 12},
  [1733] = {.lex_state = 40, .external_lex_state = 15},
  [1734] = {.lex_state = 40, .external_lex_state = 13},
  [1735] = {.lex_state = 41, .external_lex_state = 15},
  [1736] = {.lex_state = 40, .external_lex_state = 15},
  [1737] = {.lex_state = 40, .external_lex_state = 15},
  [1738] = {.lex_state = 40, .external_lex_state = 15},
  [1739] = {.lex_state = 40, .external_lex_state = 15},
  [1740] = {.lex_state = 40, .external_lex_state = 15},
  [1741] = {.lex_state = 40, .external_lex_state = 15},
  [1742] = {.lex_state = 40, .external_lex_state = 15},
  [1743] = {.lex_state = 40, .external_lex_state = 15},
  [1744] = {.lex_state = 40, .external_lex_state = 15},
  [1745] = {.lex_state = 40, .external_lex_state = 15},
  [1746] = {.lex_state = 40, .external_lex_state = 15},
  [1747] = {.lex_state = 40, .external_lex_state = 15},
  [1748] = {.lex_state = 40, .external_lex_state = 15},
  [1749] = {.lex_state = 40, .external_lex_state = 15},
  [1750] = {.lex_state = 40, .external_lex_state = 15},
  [1751] = {.lex_state = 40, .external_lex_state = 15},
  [1752] = {.lex_state = 40, .external_lex_state = 15},
  [1753] = {.lex_state = 41, .external_lex_state = 16},
  [1754] = {.lex_state = 41, .external_lex_state = 16},
  [1755] = {.lex_state = 41, .external_lex_state = 16},
  [1756] = {.lex_state = 40, .external_lex_state = 15},
  [1757] = {.lex_state = 41, .external_lex_state = 11},
  [1758] = {.lex_state = 40, .external_lex_state = 16},
  [1759] = {.lex_state = 40, .external_lex_state = 16},
  [1760] = {.lex_state = 40, .external_lex_state = 16},
  [1761] = {.lex_state = 40, .external_lex_state = 16},
  [1762] = {.lex_state = 40, .external_lex_state = 16},
  [1763] = {.lex_state = 40, .external_lex_state = 16},
  [1764] = {.lex_state = 34, .external_lex_state = 13},
  [1765] = {.lex_state = 40, .external_lex_state = 16},
  [1766] = {.lex_state = 40, .external_lex_state = 16},
  [1767] = {.lex_state = 40, .external_lex_state = 16},
  [1768] = {.lex_state = 34, .external_lex_state = 13},
  [1769] = {.lex_state = 34, .external_lex_state = 13},
  [1770] = {.lex_state = 34, .external_lex_state = 13},
  [1771] = {.lex_state = 34, .external_lex_state = 13},
  [1772] = {.lex_state = 40, .external_lex_state = 14},
  [1773] = {.lex_state = 40, .external_lex_state = 16},
  [1774] = {.lex_state = 40, .external_lex_state = 16},
  [1775] = {.lex_state = 40, .external_lex_state = 16},
  [1776] = {.lex_state = 40, .external_lex_state = 16},
  [1777] = {.lex_state = 40, .external_lex_state = 16},
  [1778] = {.lex_state = 34, .external_lex_state = 13},
  [1779] = {.lex_state = 40, .external_lex_state = 15},
  [1780] = {.lex_state = 40, .external_lex_state = 16},
  [1781] = {.lex_state = 40, .external_lex_state = 16},
  [1782] = {.lex_state = 40, .external_lex_state = 16},
  [1783] = {.lex_state = 40, .external_lex_state = 16},
  [1784] = {.lex_state = 40, .external_lex_state = 12},
  [1785] = {.lex_state = 40, .external_lex_state = 16},
  [1786] = {.lex_state = 34, .external_lex_state = 13},
  [1787] = {.lex_state = 40, .external_lex_state = 16},
  [1788] = {.lex_state = 40, .external_lex_state = 16},
  [1789] = {.lex_state = 40, .external_lex_state = 11},
  [1790] = {.lex_state = 40, .external_lex_state = 16},
  [1791] = {.lex_state = 40, .external_lex_state = 16},
  [1792] = {.lex_state = 34, .external_lex_state = 13},
  [1793] = {.lex_state = 40, .external_lex_state = 16},
  [1794] = {.lex_state = 40, .external_lex_state = 16},
  [1795] = {.lex_state = 40, .external_lex_state = 16},
  [1796] = {.lex_state = 40, .external_lex_state = 16},
  [1797] = {.lex_state = 58, .external_lex_state = 3},
  [1798] = {.lex_state = 40, .external_lex_state = 16},
  [1799] = {.lex_state = 34, .external_lex_state = 13},
  [1800] = {.lex_state = 58, .external_lex_state = 3},
  [1801] = {.lex_state = 34, .external_lex_state = 13},
  [1802] = {.lex_state = 40, .external_lex_state = 16},
  [1803] = {.lex_state = 40, .external_lex_state = 16},
  [1804] = {.lex_state = 34, .external_lex_state = 13},
  [1805] = {.lex_state = 34, .external_lex_state = 13},
  [1806] = {.lex_state = 34, .external_lex_state = 13},
  [1807] = {.lex_state = 40, .external_lex_state = 16},
  [1808] = {.lex_state = 34, .external_lex_state = 13},
  [1809] = {.lex_state = 40, .external_lex_state = 16},
  [1810] = {.lex_state = 34, .external_lex_state = 13},
  [1811] = {.lex_state = 40, .external_lex_state = 16},
  [1812] = {.lex_state = 40, .external_lex_state = 16},
  [1813] = {.lex_state = 40, .external_lex_state = 16},
  [1814] = {.lex_state = 58, .external_lex_state = 3},
  [1815] = {.lex_state = 40, .external_lex_state = 16},
  [1816] = {.lex_state = 40, .external_lex_state = 16},
  [1817] = {.lex_state = 34, .external_lex_state = 13},
  [1818] = {.lex_state = 39, .external_lex_state = 2},
  [1819] = {.lex_state = 39, .external_lex_state = 2},
  [1820] = {.lex_state = 58, .external_lex_state = 3},
  [1821] = {.lex_state = 58, .external_lex_state = 3},
  [1822] = {.lex_state = 58, .external_lex_state = 3},
  [1823] = {.lex_state = 58, .external_lex_state = 3},
  [1824] = {.lex_state = 58, .external_lex_state = 3},
  [1825] = {.lex_state = 58, .external_lex_state = 3},
  [1826] = {.lex_state = 58, .external_lex_state = 3},
  [1827] = {.lex_state = 58, .external_lex_state = 3},
  [1828] = {.lex_state = 58, .external_lex_state = 3},
  [1829] = {.lex_state = 58, .external_lex_state = 3},
  [1830] = {.lex_state = 58, .external_lex_state = 3},
  [1831] = {.lex_state = 58, .external_lex_state = 3},
  [1832] = {.lex_state = 58, .external_lex_state = 3},
  [1833] = {.lex_state = 58, .external_lex_state = 3},
  [1834] = {.lex_state = 58, .external_lex_state = 3},
  [1835] = {.lex_state = 58, .external_lex_state = 3},
  [1836] = {.lex_state = 58, .external_lex_state = 3},
  [1837] = {.lex_state = 58, .external_lex_state = 3},
  [1838] = {.lex_state = 58, .external_lex_state = 3},
  [1839] = {.lex_state = 58, .external_lex_state = 3},
  [1840] = {.lex_state = 58, .external_lex_state = 3},
  [1841] = {.lex_state = 58, .external_lex_state = 3},
  [1842] = {.lex_state = 58, .external_lex_state = 3},
  [1843] = {.lex_state = 58, .external_lex_state = 3},
  [1844] = {.lex_state = 58, .external_lex_state = 3},
  [1845] = {.lex_state = 58, .external_lex_state = 3},
  [1846] = {.lex_state = 58, .external_lex_state = 3},
  [1847] = {.lex_state = 58, .external_lex_state = 3},
  [1848] = {.lex_state = 58, .external_lex_state = 3},
  [1849] = {.lex_state = 58, .external_lex_state = 3},
  [1850] = {.lex_state = 58, .external_lex_state = 3},
  [1851] = {.lex_state = 58, .external_lex_state = 3},
  [1852] = {.lex_state = 58, .external_lex_state = 3},
  [1853] = {.lex_state = 58, .external_lex_state = 3},
  [1854] = {.lex_state = 58, .external_lex_state = 3},
  [1855] = {.lex_state = 58, .external_lex_state = 3},
  [1856] = {.lex_state = 58, .external_lex_state = 3},
  [1857] = {.lex_state = 58, .external_lex_state = 3},
  [1858] = {.lex_state = 58, .external_lex_state = 3},
  [1859] = {.lex_state = 58, .external_lex_state = 3},
  [1860] = {.lex_state = 31, .external_lex_state = 9},
  [1861] = {.lex_state = 31, .external_lex_state = 10},
  [1862] = {.lex_state = 31, .external_lex_state = 9},
  [1863] = {.lex_state = 31, .external_lex_state = 9},
  [1864] = {.lex_state = 31, .external_lex_state = 10},
  [1865] = {.lex_state = 31, .external_lex_state = 9},
  [1866] = {.lex_state = 31, .external_lex_state = 9},
  [1867] = {.lex_state = 31, .external_lex_state = 9},
  [1868] = {.lex_state = 31, .external_lex_state = 9},
  [1869] = {.lex_state = 31, .external_lex_state = 9},
  [1870] = {.lex_state = 31, .external_lex_state = 9},
  [1871] = {.lex_state = 31, .external_lex_state = 10},
  [1872] = {.lex_state = 31, .external_lex_state = 9},
  [1873] = {.lex_state = 31, .external_lex_state = 9},
  [1874] = {.lex_state = 31, .external_lex_state = 10},
  [1875] = {.lex_state = 31, .external_lex_state = 9},
  [1876] = {.lex_state = 31, .external_lex_state = 10},
  [1877] = {.lex_state = 31, .external_lex_state = 9},
  [1878] = {.lex_state = 31, .external_lex_state = 9},
  [1879] = {.lex_state = 31, .external_lex_state = 10},
  [1880] = {.lex_state = 31, .external_lex_state = 9},
  [1881] = {.lex_state = 31, .external_lex_state = 9},
  [1882] = {.lex_state = 31, .external_lex_state = 10},
  [1883] = {.lex_state = 31, .external_lex_state = 9},
  [1884] = {.lex_state = 31, .external_lex_state = 10},
  [1885] = {.lex_state = 31, .external_lex_state = 10},
  [1886] = {.lex_state = 31, .external_lex_state = 9},
  [1887] = {.lex_state = 31, .external_lex_state = 9},
  [1888] = {.lex_state = 31, .external_lex_state = 9},
  [1889] = {.lex_state = 31, .external_lex_state = 10},
  [1890] = {.lex_state = 31, .external_lex_state = 9},
  [1891] = {.lex_state = 31, .external_lex_state = 10},
  [1892] = {.lex_state = 31, .external_lex_state = 9},
  [1893] = {.lex_state = 31, .external_lex_state = 10},
  [1894] = {.lex_state = 31, .external_lex_state = 9},
  [1895] = {.lex_state = 31, .external_lex_state = 9},
  [1896] = {.lex_state = 31, .external_lex_state = 2},
  [1897] = {.lex_state = 31, .external_lex_state = 2},
  [1898] = {.lex_state = 31, .external_lex_state = 2},
  [1899] = {.lex_state = 31, .external_lex_state = 2},
  [1900] = {.lex_state = 31, .external_lex_state = 2},
  [1901] = {.lex_state = 31, .external_lex_state = 6},
  [1902] = {.lex_state = 31, .external_lex_state = 6},
  [1903] = {.lex_state = 31, .external_lex_state = 6},
  [1904] = {.lex_state = 31, .external_lex_state = 6},
  [1905] = {.lex_state = 31, .external_lex_state = 6},
  [1906] = {.lex_state = 31, .external_lex_state = 6},
  [1907] = {.lex_state = 31, .external_lex_state = 6},
  [1908] = {.lex_state = 31, .external_lex_state = 6},
  [1909] = {.lex_state = 31, .external_lex_state = 6},
  [1910] = {.lex_state = 31, .external_lex_state = 6},
  [1911] = {.lex_state = 31, .external_lex_state = 6},
  [1912] = {.lex_state = 31, .external_lex_state = 6},
  [1913] = {.lex_state = 31, .external_lex_state = 6},
  [1914] = {.lex_state = 31, .external_lex_state = 6},
  [1915] = {.lex_state = 31, .external_lex_state = 6},
  [1916] = {.lex_state = 31, .external_lex_state = 6},
  [1917] = {.lex_state = 31, .external_lex_state = 6},
  [1918] = {.lex_state = 31, .external_lex_state = 6},
  [1919] = {.lex_state = 31, .external_lex_state = 6},
  [1920] = {.lex_state = 31, .external_lex_state = 6},
  [1921] = {.lex_state = 31, .external_lex_state = 2},
  [1922] = {.lex_state = 31, .external_lex_state = 2},
  [1923] = {.lex_state = 31, .external_lex_state = 2},
  [1924] = {.lex_state = 31, .external_lex_state = 2},
  [1925] = {.lex_state = 31, .external_lex_state = 2},
  [1926] = {.lex_state = 31, .external_lex_state = 2},
  [1927] = {.lex_state = 31, .external_lex_state = 2},
  [1928] = {.lex_state = 31, .external_lex_state = 2},
  [1929] = {.lex_state = 31, .external_lex_state = 2},
  [1930] = {.lex_state = 34, .external_lex_state = 11},
  [1931] = {.lex_state = 34, .external_lex_state = 11},
  [1932] = {.lex_state = 34, .external_lex_state = 13},
  [1933] = {.lex_state = 40, .external_lex_state = 12},
  [1934] = {.lex_state = 40, .external_lex_state = 12},
  [1935] = {.lex_state = 34, .external_lex_state = 14},
  [1936] = {.lex_state = 34, .external_lex_state = 13},
  [1937] = {.lex_state = 34, .external_lex_state = 14},
  [1938] = {.lex_state = 40, .external_lex_state = 12},
  [1939] = {.lex_state = 40, .external_lex_state = 12},
  [1940] = {.lex_state = 40, .external_lex_state = 12},
  [1941] = {.lex_state = 40, .external_lex_state = 12},
  [1942] = {.lex_state = 34, .external_lex_state = 15},
  [1943] = {.lex_state = 58, .external_lex_state = 12},
  [1944] = {.lex_state = 58, .external_lex_state = 12},
  [1945] = {.lex_state = 58, .external_lex_state = 12},
  [1946] = {.lex_state = 58, .external_lex_state = 12},
  [1947] = {.lex_state = 34, .external_lex_state = 15},
  [1948] = {.lex_state = 40, .external_lex_state = 14},
  [1949] = {.lex_state = 58, .external_lex_state = 15},
  [1950] = {.lex_state = 38, .external_lex_state = 11},
  [1951] = {.lex_state = 38, .external_lex_state = 11},
  [1952] = {.lex_state = 58, .external_lex_state = 15},
  [1953] = {.lex_state = 58, .external_lex_state = 14},
  [1954] = {.lex_state = 40, .external_lex_state = 14},
  [1955] = {.lex_state = 40, .external_lex_state = 14},
  [1956] = {.lex_state = 40, .external_lex_state = 14},
  [1957] = {.lex_state = 58, .external_lex_state = 14},
  [1958] = {.lex_state = 40, .external_lex_state = 14},
  [1959] = {.lex_state = 40, .external_lex_state = 14},
  [1960] = {.lex_state = 40, .external_lex_state = 13},
  [1961] = {.lex_state = 38, .external_lex_state = 11},
  [1962] = {.lex_state = 40, .external_lex_state = 14},
  [1963] = {.lex_state = 40, .external_lex_state = 13},
  [1964] = {.lex_state = 40, .external_lex_state = 13},
  [1965] = {.lex_state = 40, .external_lex_state = 14},
  [1966] = {.lex_state = 40, .external_lex_state = 13},
  [1967] = {.lex_state = 40, .external_lex_state = 13},
  [1968] = {.lex_state = 40, .external_lex_state = 13},
  [1969] = {.lex_state = 40, .external_lex_state = 15},
  [1970] = {.lex_state = 40, .external_lex_state = 14},
  [1971] = {.lex_state = 40, .external_lex_state = 13},
  [1972] = {.lex_state = 40, .external_lex_state = 13},
  [1973] = {.lex_state = 40, .external_lex_state = 13},
  [1974] = {.lex_state = 40, .external_lex_state = 14},
  [1975] = {.lex_state = 38, .external_lex_state = 11},
  [1976] = {.lex_state = 40, .external_lex_state = 13},
  [1977] = {.lex_state = 40, .external_lex_state = 13},
  [1978] = {.lex_state = 40, .external_lex_state = 15},
  [1979] = {.lex_state = 40, .external_lex_state = 13},
  [1980] = {.lex_state = 40, .external_lex_state = 13},
  [1981] = {.lex_state = 40, .external_lex_state = 13},
  [1982] = {.lex_state = 40, .external_lex_state = 14},
  [1983] = {.lex_state = 40, .external_lex_state = 15},
  [1984] = {.lex_state = 40, .external_lex_state = 15},
  [1985] = {.lex_state = 40, .external_lex_state = 13},
  [1986] = {.lex_state = 40, .external_lex_state = 13},
  [1987] = {.lex_state = 40, .external_lex_state = 13},
  [1988] = {.lex_state = 40, .external_lex_state = 13},
  [1989] = {.lex_state = 40, .external_lex_state = 14},
  [1990] = {.lex_state = 40, .external_lex_state = 13},
  [1991] = {.lex_state = 40, .external_lex_state = 13},
  [1992] = {.lex_state = 38, .external_lex_state = 11},
  [1993] = {.lex_state = 40, .external_lex_state = 13},
  [1994] = {.lex_state = 38, .external_lex_state = 11},
  [1995] = {.lex_state = 40, .external_lex_state = 15},
  [1996] = {.lex_state = 40, .external_lex_state = 13},
  [1997] = {.lex_state = 40, .external_lex_state = 12},
  [1998] = {.lex_state = 40, .external_lex_state = 13},
  [1999] = {.lex_state = 40, .external_lex_state = 15},
  [2000] = {.lex_state = 39, .external_lex_state = 13},
  [2001] = {.lex_state = 39, .external_lex_state = 13},
  [2002] = {.lex_state = 38, .external_lex_state = 13},
  [2003] = {.lex_state = 39, .external_lex_state = 13},
  [2004] = {.lex_state = 39, .external_lex_state = 13},
  [2005] = {.lex_state = 39, .external_lex_state = 13},
  [2006] = {.lex_state = 39, .external_lex_state = 13},
  [2007] = {.lex_state = 38, .external_lex_state = 13},
  [2008] = {.lex_state = 39, .external_lex_state = 13},
  [2009] = {.lex_state = 38, .external_lex_state = 13},
  [2010] = {.lex_state = 38, .external_lex_state = 11},
  [2011] = {.lex_state = 58, .external_lex_state = 16},
  [2012] = {.lex_state = 39, .external_lex_state = 13},
  [2013] = {.lex_state = 39, .external_lex_state = 13},
  [2014] = {.lex_state = 39, .external_lex_state = 13},
  [2015] = {.lex_state = 38, .external_lex_state = 13},
  [2016] = {.lex_state = 38, .external_lex_state = 13},
  [2017] = {.lex_state = 39, .external_lex_state = 13},
  [2018] = {.lex_state = 39, .external_lex_state = 13},
  [2019] = {.lex_state = 38, .external_lex_state = 13},
  [2020] = {.lex_state = 38, .external_lex_state = 13},
  [2021] = {.lex_state = 38, .external_lex_state = 13},
  [2022] = {.lex_state = 58, .external_lex_state = 16},
  [2023] = {.lex_state = 31, .external_lex_state = 14},
  [2024] = {.lex_state = 39, .external_lex_state = 13},
  [2025] = {.lex_state = 0, .external_lex_state = 17},
  [2026] = {.lex_state = 0, .external_lex_state = 17},
  [2027] = {.lex_state = 38, .external_lex_state = 13},
  [2028] = {.lex_state = 0, .external_lex_state = 17},
  [2029] = {.lex_state = 0, .external_lex_state = 17},
  [2030] = {.lex_state = 0, .external_lex_state = 17},
  [2031] = {.lex_state = 0, .external_lex_state = 17},
  [2032] = {.lex_state = 31, .external_lex_state = 14},
  [2033] = {.lex_state = 0, .external_lex_state = 17},
  [2034] = {.lex_state = 0, .external_lex_state = 17},
  [2035] = {.lex_state = 0, .external_lex_state = 17},
  [2036] = {.lex_state = 39, .external_lex_state = 13},
  [2037] = {.lex_state = 0, .external_lex_state = 17},
  [2038] = {.lex_state = 0, .external_lex_state = 17},
  [2039] = {.lex_state = 0, .external_lex_state = 17},
  [2040] = {.lex_state = 0, .external_lex_state = 17},
  [2041] = {.lex_state = 31, .external_lex_state = 14},
  [2042] = {.lex_state = 0, .external_lex_state = 17},
  [2043] = {.lex_state = 0, .external_lex_state = 17},
  [2044] = {.lex_state = 0, .external_lex_state = 17},
  [2045] = {.lex_state = 0, .external_lex_state = 17},
  [2046] = {.lex_state = 0, .external_lex_state = 17},
  [2047] = {.lex_state = 0, .external_lex_state = 17},
  [2048] = {.lex_state = 0, .external_lex_state = 17},
  [2049] = {.lex_state = 0, .external_lex_state = 17},
  [2050] = {.lex_state = 0, .external_lex_state = 17},
  [2051] = {.lex_state = 0, .external_lex_state = 17},
  [2052] = {.lex_state = 31, .external_lex_state = 13},
  [2053] = {.lex_state = 31, .external_lex_state = 13},
  [2054] = {.lex_state = 58, .external_lex_state = 12},
  [2055] = {.lex_state = 34, .external_lex_state = 11},
  [2056] = {.lex_state = 34, .external_lex_state = 11},
  [2057] = {.lex_state = 58, .external_lex_state = 12},
  [2058] = {.lex_state = 58, .external_lex_state = 12},
  [2059] = {.lex_state = 58, .external_lex_state = 12},
  [2060] = {.lex_state = 58, .external_lex_state = 12},
  [2061] = {.lex_state = 34, .external_lex_state = 11},
  [2062] = {.lex_state = 34, .external_lex_state = 11},
  [2063] = {.lex_state = 58, .external_lex_state = 12},
  [2064] = {.lex_state = 58, .external_lex_state = 12},
  [2065] = {.lex_state = 34, .external_lex_state = 11},
  [2066] = {.lex_state = 34, .external_lex_state = 11},
  [2067] = {.lex_state = 34, .external_lex_state = 11},
  [2068] = {.lex_state = 58, .external_lex_state = 12},
  [2069] = {.lex_state = 34, .external_lex_state = 11},
  [2070] = {.lex_state = 34, .external_lex_state = 11},
  [2071] = {.lex_state = 58, .external_lex_state = 12},
  [2072] = {.lex_state = 58, .external_lex_state = 15},
  [2073] = {.lex_state = 58, .external_lex_state = 14},
  [2074] = {.lex_state = 34, .external_lex_state = 11},
  [2075] = {.lex_state = 58, .external_lex_state = 15},
  [2076] = {.lex_state = 58, .external_lex_state = 15},
  [2077] = {.lex_state = 58, .external_lex_state = 14},
  [2078] = {.lex_state = 58, .external_lex_state = 14},
  [2079] = {.lex_state = 58, .external_lex_state = 14},
  [2080] = {.lex_state = 58, .external_lex_state = 15},
  [2081] = {.lex_state = 58, .external_lex_state = 14},
  [2082] = {.lex_state = 58, .external_lex_state = 14},
  [2083] = {.lex_state = 58, .external_lex_state = 14},
  [2084] = {.lex_state = 58, .external_lex_state = 3},
  [2085] = {.lex_state = 58, .external_lex_state = 14},
  [2086] = {.lex_state = 58, .external_lex_state = 15},
  [2087] = {.lex_state = 58, .external_lex_state = 14},
  [2088] = {.lex_state = 58, .external_lex_state = 15},
  [2089] = {.lex_state = 58, .external_lex_state = 14},
  [2090] = {.lex_state = 58, .external_lex_state = 14},
  [2091] = {.lex_state = 58, .external_lex_state = 14},
  [2092] = {.lex_state = 58, .external_lex_state = 14},
  [2093] = {.lex_state = 58, .external_lex_state = 3},
  [2094] = {.lex_state = 58, .external_lex_state = 15},
  [2095] = {.lex_state = 58, .external_lex_state = 15},
  [2096] = {.lex_state = 58, .external_lex_state = 3},
  [2097] = {.lex_state = 58, .external_lex_state = 14},
  [2098] = {.lex_state = 58, .external_lex_state = 14},
  [2099] = {.lex_state = 58, .external_lex_state = 14},
  [2100] = {.lex_state = 58, .external_lex_state = 14},
  [2101] = {.lex_state = 58, .external_lex_state = 14},
  [2102] = {.lex_state = 58, .external_lex_state = 15},
  [2103] = {.lex_state = 58, .external_lex_state = 14},
  [2104] = {.lex_state = 34, .external_lex_state = 13},
  [2105] = {.lex_state = 58, .external_lex_state = 2},
  [2106] = {.lex_state = 34, .external_lex_state = 14},
  [2107] = {.lex_state = 34, .external_lex_state = 14},
  [2108] = {.lex_state = 34, .external_lex_state = 14},
  [2109] = {.lex_state = 34, .external_lex_state = 14},
  [2110] = {.lex_state = 34, .external_lex_state = 14},
  [2111] = {.lex_state = 34, .external_lex_state = 14},
  [2112] = {.lex_state = 34, .external_lex_state = 13},
  [2113] = {.lex_state = 34, .external_lex_state = 11},
  [2114] = {.lex_state = 34, .external_lex_state = 14},
  [2115] = {.lex_state = 34, .external_lex_state = 13},
  [2116] = {.lex_state = 34, .external_lex_state = 14},
  [2117] = {.lex_state = 58, .external_lex_state = 12},
  [2118] = {.lex_state = 34, .external_lex_state = 13},
  [2119] = {.lex_state = 34, .external_lex_state = 13},
  [2120] = {.lex_state = 34, .external_lex_state = 14},
  [2121] = {.lex_state = 34, .external_lex_state = 13},
  [2122] = {.lex_state = 34, .external_lex_state = 14},
  [2123] = {.lex_state = 34, .external_lex_state = 13},
  [2124] = {.lex_state = 34, .external_lex_state = 13},
  [2125] = {.lex_state = 34, .external_lex_state = 13},
  [2126] = {.lex_state = 58, .external_lex_state = 12},
  [2127] = {.lex_state = 58, .external_lex_state = 2},
  [2128] = {.lex_state = 0, .external_lex_state = 17},
  [2129] = {.lex_state = 58, .external_lex_state = 12},
  [2130] = {.lex_state = 34, .external_lex_state = 15},
  [2131] = {.lex_state = 58, .external_lex_state = 12},
  [2132] = {.lex_state = 34, .external_lex_state = 13},
  [2133] = {.lex_state = 34, .external_lex_state = 13},
  [2134] = {.lex_state = 58, .external_lex_state = 12},
  [2135] = {.lex_state = 34, .external_lex_state = 15},
  [2136] = {.lex_state = 58, .external_lex_state = 12},
  [2137] = {.lex_state = 58, .external_lex_state = 12},
  [2138] = {.lex_state = 58, .external_lex_state = 3},
  [2139] = {.lex_state = 58, .external_lex_state = 12},
  [2140] = {.lex_state = 58, .external_lex_state = 12},
  [2141] = {.lex_state = 34, .external_lex_state = 15},
  [2142] = {.lex_state = 34, .external_lex_state = 15},
  [2143] = {.lex_state = 58, .external_lex_state = 12},
  [2144] = {.lex_state = 58, .external_lex_state = 12},
  [2145] = {.lex_state = 58, .external_lex_state = 12},
  [2146] = {.lex_state = 58, .external_lex_state = 12},
  [2147] = {.lex_state = 34, .external_lex_state = 15},
  [2148] = {.lex_state = 34, .external_lex_state = 15},
  [2149] = {.lex_state = 34, .external_lex_state = 13},
  [2150] = {.lex_state = 34, .external_lex_state = 15},
  [2151] = {.lex_state = 34, .external_lex_state = 15},
  [2152] = {.lex_state = 34, .external_lex_state = 13},
  [2153] = {.lex_state = 34, .external_lex_state = 13},
  [2154] = {.lex_state = 58, .external_lex_state = 12},
  [2155] = {.lex_state = 34, .external_lex_state = 15},
  [2156] = {.lex_state = 0, .external_lex_state = 17},
  [2157] = {.lex_state = 34, .external_lex_state = 15},
  [2158] = {.lex_state = 58, .external_lex_state = 12},
  [2159] = {.lex_state = 58, .external_lex_state = 12},
  [2160] = {.lex_state = 58, .external_lex_state = 12},
  [2161] = {.lex_state = 58, .external_lex_state = 12},
  [2162] = {.lex_state = 58, .external_lex_state = 12},
  [2163] = {.lex_state = 58, .external_lex_state = 12},
  [2164] = {.lex_state = 58, .external_lex_state = 11},
  [2165] = {.lex_state = 58, .external_lex_state = 12},
  [2166] = {.lex_state = 58, .external_lex_state = 12},
  [2167] = {.lex_state = 0, .external_lex_state = 17},
  [2168] = {.lex_state = 0, .external_lex_state = 17},
  [2169] = {.lex_state = 35, .external_lex_state = 18},
  [2170] = {.lex_state = 58, .external_lex_state = 15},
  [2171] = {.lex_state = 58, .external_lex_state = 15},
  [2172] = {.lex_state = 0, .external_lex_state = 17},
  [2173] = {.lex_state = 58, .external_lex_state = 14},
  [2174] = {.lex_state = 0, .external_lex_state = 17},
  [2175] = {.lex_state = 58, .external_lex_state = 11},
  [2176] = {.lex_state = 58, .external_lex_state = 15},
  [2177] = {.lex_state = 58, .external_lex_state = 2},
  [2178] = {.lex_state = 58, .external_lex_state = 14},
  [2179] = {.lex_state = 58, .external_lex_state = 15},
  [2180] = {.lex_state = 58, .external_lex_state = 11},
  [2181] = {.lex_state = 0, .external_lex_state = 17},
  [2182] = {.lex_state = 58, .external_lex_state = 15},
  [2183] = {.lex_state = 58, .external_lex_state = 15},
  [2184] = {.lex_state = 0, .external_lex_state = 17},
  [2185] = {.lex_state = 34, .external_lex_state = 13},
  [2186] = {.lex_state = 58, .external_lex_state = 15},
  [2187] = {.lex_state = 58, .external_lex_state = 13},
  [2188] = {.lex_state = 58, .external_lex_state = 14},
  [2189] = {.lex_state = 58, .external_lex_state = 15},
  [2190] = {.lex_state = 58, .external_lex_state = 11},
  [2191] = {.lex_state = 58, .external_lex_state = 15},
  [2192] = {.lex_state = 58, .external_lex_state = 14},
  [2193] = {.lex_state = 58, .external_lex_state = 15},
  [2194] = {.lex_state = 58, .external_lex_state = 15},
  [2195] = {.lex_state = 35, .external_lex_state = 18},
  [2196] = {.lex_state = 58, .external_lex_state = 13},
  [2197] = {.lex_state = 58, .external_lex_state = 15},
  [2198] = {.lex_state = 0, .external_lex_state = 17},
  [2199] = {.lex_state = 0, .external_lex_state = 17},
  [2200] = {.lex_state = 58, .external_lex_state = 15},
  [2201] = {.lex_state = 58, .external_lex_state = 11},
  [2202] = {.lex_state = 35, .external_lex_state = 18},
  [2203] = {.lex_state = 58, .external_lex_state = 15},
  [2204] = {.lex_state = 58, .external_lex_state = 15},
  [2205] = {.lex_state = 0, .external_lex_state = 17},
  [2206] = {.lex_state = 0, .external_lex_state = 17},
  [2207] = {.lex_state = 58, .external_lex_state = 14},
  [2208] = {.lex_state = 58, .external_lex_state = 11},
  [2209] = {.lex_state = 58, .external_lex_state = 15},
  [2210] = {.lex_state = 35, .external_lex_state = 18},
  [2211] = {.lex_state = 0, .external_lex_state = 17},
  [2212] = {.lex_state = 58, .external_lex_state = 12},
  [2213] = {.lex_state = 58, .external_lex_state = 14},
  [2214] = {.lex_state = 58, .external_lex_state = 11},
  [2215] = {.lex_state = 58, .external_lex_state = 15},
  [2216] = {.lex_state = 58, .external_lex_state = 12},
  [2217] = {.lex_state = 58, .external_lex_state = 15},
  [2218] = {.lex_state = 0, .external_lex_state = 17},
  [2219] = {.lex_state = 58, .external_lex_state = 14},
  [2220] = {.lex_state = 33, .external_lex_state = 15},
  [2221] = {.lex_state = 58, .external_lex_state = 15},
  [2222] = {.lex_state = 58, .external_lex_state = 14},
  [2223] = {.lex_state = 58, .external_lex_state = 14},
  [2224] = {.lex_state = 0, .external_lex_state = 17},
  [2225] = {.lex_state = 58, .external_lex_state = 12},
  [2226] = {.lex_state = 58, .external_lex_state = 14},
  [2227] = {.lex_state = 58, .external_lex_state = 11},
  [2228] = {.lex_state = 58, .external_lex_state = 15},
  [2229] = {.lex_state = 58, .external_lex_state = 11},
  [2230] = {.lex_state = 33, .external_lex_state = 14},
  [2231] = {.lex_state = 58, .external_lex_state = 12},
  [2232] = {.lex_state = 58, .external_lex_state = 15},
  [2233] = {.lex_state = 58, .external_lex_state = 11},
  [2234] = {.lex_state = 58, .external_lex_state = 15},
  [2235] = {.lex_state = 33, .external_lex_state = 12},
  [2236] = {.lex_state = 58, .external_lex_state = 14},
  [2237] = {.lex_state = 58, .external_lex_state = 14},
  [2238] = {.lex_state = 58, .external_lex_state = 15},
  [2239] = {.lex_state = 58, .external_lex_state = 9},
  [2240] = {.lex_state = 58, .external_lex_state = 12},
  [2241] = {.lex_state = 58, .external_lex_state = 14},
  [2242] = {.lex_state = 58, .external_lex_state = 14},
  [2243] = {.lex_state = 58, .external_lex_state = 13},
  [2244] = {.lex_state = 58, .external_lex_state = 15},
  [2245] = {.lex_state = 33, .external_lex_state = 14},
  [2246] = {.lex_state = 58, .external_lex_state = 12},
  [2247] = {.lex_state = 58, .external_lex_state = 15},
  [2248] = {.lex_state = 58, .external_lex_state = 15},
  [2249] = {.lex_state = 58, .external_lex_state = 12},
  [2250] = {.lex_state = 58, .external_lex_state = 13},
  [2251] = {.lex_state = 58, .external_lex_state = 12},
  [2252] = {.lex_state = 58, .external_lex_state = 11},
  [2253] = {.lex_state = 58, .external_lex_state = 6},
  [2254] = {.lex_state = 33, .external_lex_state = 14},
  [2255] = {.lex_state = 58, .external_lex_state = 3},
  [2256] = {.lex_state = 58, .external_lex_state = 13},
  [2257] = {.lex_state = 58, .external_lex_state = 10},
  [2258] = {.lex_state = 58, .external_lex_state = 12},
  [2259] = {.lex_state = 58, .external_lex_state = 12},
  [2260] = {.lex_state = 58, .external_lex_state = 12},
  [2261] = {.lex_state = 58, .external_lex_state = 13},
  [2262] = {.lex_state = 58, .external_lex_state = 3},
  [2263] = {.lex_state = 33, .external_lex_state = 15},
  [2264] = {.lex_state = 58, .external_lex_state = 13},
  [2265] = {.lex_state = 33, .external_lex_state = 12},
  [2266] = {.lex_state = 58, .external_lex_state = 15},
  [2267] = {.lex_state = 58, .external_lex_state = 12},
  [2268] = {.lex_state = 58, .external_lex_state = 15},
  [2269] = {.lex_state = 33, .external_lex_state = 15},
  [2270] = {.lex_state = 58, .external_lex_state = 12},
  [2271] = {.lex_state = 58, .external_lex_state = 12},
  [2272] = {.lex_state = 58, .external_lex_state = 13},
  [2273] = {.lex_state = 33, .external_lex_state = 13},
  [2274] = {.lex_state = 58, .external_lex_state = 12},
  [2275] = {.lex_state = 58, .external_lex_state = 13},
  [2276] = {.lex_state = 58, .external_lex_state = 14},
  [2277] = {.lex_state = 58, .external_lex_state = 13},
  [2278] = {.lex_state = 58, .external_lex_state = 11},
  [2279] = {.lex_state = 58, .external_lex_state = 15},
  [2280] = {.lex_state = 58, .external_lex_state = 12},
  [2281] = {.lex_state = 58, .external_lex_state = 12},
  [2282] = {.lex_state = 58, .external_lex_state = 14},
  [2283] = {.lex_state = 33, .external_lex_state = 15},
  [2284] = {.lex_state = 58, .external_lex_state = 13},
  [2285] = {.lex_state = 58, .external_lex_state = 15},
  [2286] = {.lex_state = 33, .external_lex_state = 14},
  [2287] = {.lex_state = 33, .external_lex_state = 12},
  [2288] = {.lex_state = 58, .external_lex_state = 15},
  [2289] = {.lex_state = 58, .external_lex_state = 14},
  [2290] = {.lex_state = 58, .external_lex_state = 14},
  [2291] = {.lex_state = 33, .external_lex_state = 12},
  [2292] = {.lex_state = 58, .external_lex_state = 11},
  [2293] = {.lex_state = 58, .external_lex_state = 14},
  [2294] = {.lex_state = 58, .external_lex_state = 11},
  [2295] = {.lex_state = 34, .external_lex_state = 11},
  [2296] = {.lex_state = 58, .external_lex_state = 14},
  [2297] = {.lex_state = 58, .external_lex_state = 12},
  [2298] = {.lex_state = 58, .external_lex_state = 15},
  [2299] = {.lex_state = 58, .external_lex_state = 13},
  [2300] = {.lex_state = 34, .external_lex_state = 11},
  [2301] = {.lex_state = 58, .external_lex_state = 12},
  [2302] = {.lex_state = 34, .external_lex_state = 14},
  [2303] = {.lex_state = 58, .external_lex_state = 15},
  [2304] = {.lex_state = 58, .external_lex_state = 14},
  [2305] = {.lex_state = 58, .external_lex_state = 16},
  [2306] = {.lex_state = 58, .external_lex_state = 13},
  [2307] = {.lex_state = 58, .external_lex_state = 13},
  [2308] = {.lex_state = 34, .external_lex_state = 15},
  [2309] = {.lex_state = 58, .external_lex_state = 14},
  [2310] = {.lex_state = 58, .external_lex_state = 14},
  [2311] = {.lex_state = 58, .external_lex_state = 11},
  [2312] = {.lex_state = 58, .external_lex_state = 16},
  [2313] = {.lex_state = 58, .external_lex_state = 16},
  [2314] = {.lex_state = 58, .external_lex_state = 15},
  [2315] = {.lex_state = 58, .external_lex_state = 14},
  [2316] = {.lex_state = 33, .external_lex_state = 12},
  [2317] = {.lex_state = 58, .external_lex_state = 12},
  [2318] = {.lex_state = 58, .external_lex_state = 13},
  [2319] = {.lex_state = 34, .external_lex_state = 13},
  [2320] = {.lex_state = 34, .external_lex_state = 15},
  [2321] = {.lex_state = 58, .external_lex_state = 11},
  [2322] = {.lex_state = 58, .external_lex_state = 11},
  [2323] = {.lex_state = 58, .external_lex_state = 12},
  [2324] = {.lex_state = 34, .external_lex_state = 14},
  [2325] = {.lex_state = 58, .external_lex_state = 12},
  [2326] = {.lex_state = 58, .external_lex_state = 12},
  [2327] = {.lex_state = 58, .external_lex_state = 14},
  [2328] = {.lex_state = 34, .external_lex_state = 14},
  [2329] = {.lex_state = 34, .external_lex_state = 11},
  [2330] = {.lex_state = 58, .external_lex_state = 12},
  [2331] = {.lex_state = 33, .external_lex_state = 14},
  [2332] = {.lex_state = 58, .external_lex_state = 12},
  [2333] = {.lex_state = 34, .external_lex_state = 14},
  [2334] = {.lex_state = 58, .external_lex_state = 15},
  [2335] = {.lex_state = 58, .external_lex_state = 14},
  [2336] = {.lex_state = 58, .external_lex_state = 15},
  [2337] = {.lex_state = 34, .external_lex_state = 14},
  [2338] = {.lex_state = 58, .external_lex_state = 15},
  [2339] = {.lex_state = 34, .external_lex_state = 14},
  [2340] = {.lex_state = 34, .external_lex_state = 14},
  [2341] = {.lex_state = 58, .external_lex_state = 13},
  [2342] = {.lex_state = 58, .external_lex_state = 12},
  [2343] = {.lex_state = 58, .external_lex_state = 13},
  [2344] = {.lex_state = 33, .external_lex_state = 15},
  [2345] = {.lex_state = 34, .external_lex_state = 11},
  [2346] = {.lex_state = 58, .external_lex_state = 12},
  [2347] = {.lex_state = 34, .external_lex_state = 11},
  [2348] = {.lex_state = 58, .external_lex_state = 14},
  [2349] = {.lex_state = 58, .external_lex_state = 12},
  [2350] = {.lex_state = 58, .external_lex_state = 13},
  [2351] = {.lex_state = 58, .external_lex_state = 15},
  [2352] = {.lex_state = 58, .external_lex_state = 12},
  [2353] = {.lex_state = 58, .external_lex_state = 14},
  [2354] = {.lex_state = 33, .external_lex_state = 11},
  [2355] = {.lex_state = 58, .external_lex_state = 16},
  [2356] = {.lex_state = 34, .external_lex_state = 11},
  [2357] = {.lex_state = 58, .external_lex_state = 12},
  [2358] = {.lex_state = 34, .external_lex_state = 14},
  [2359] = {.lex_state = 34, .external_lex_state = 14},
  [2360] = {.lex_state = 58, .external_lex_state = 14},
  [2361] = {.lex_state = 58, .external_lex_state = 14},
  [2362] = {.lex_state = 58, .external_lex_state = 13},
  [2363] = {.lex_state = 33, .external_lex_state = 11},
  [2364] = {.lex_state = 58, .external_lex_state = 13},
  [2365] = {.lex_state = 58, .external_lex_state = 15},
  [2366] = {.lex_state = 58, .external_lex_state = 12},
  [2367] = {.lex_state = 58, .external_lex_state = 11},
  [2368] = {.lex_state = 58, .external_lex_state = 14},
  [2369] = {.lex_state = 58, .external_lex_state = 14},
  [2370] = {.lex_state = 58, .external_lex_state = 14},
  [2371] = {.lex_state = 58, .external_lex_state = 15},
  [2372] = {.lex_state = 58, .external_lex_state = 13},
  [2373] = {.lex_state = 58, .external_lex_state = 13},
  [2374] = {.lex_state = 34, .external_lex_state = 11},
  [2375] = {.lex_state = 58, .external_lex_state = 13},
  [2376] = {.lex_state = 58, .external_lex_state = 16},
  [2377] = {.lex_state = 58, .external_lex_state = 14},
  [2378] = {.lex_state = 58, .external_lex_state = 15},
  [2379] = {.lex_state = 34, .external_lex_state = 15},
  [2380] = {.lex_state = 58, .external_lex_state = 15},
  [2381] = {.lex_state = 58, .external_lex_state = 16},
  [2382] = {.lex_state = 58, .external_lex_state = 13},
  [2383] = {.lex_state = 58, .external_lex_state = 16},
  [2384] = {.lex_state = 58, .external_lex_state = 14},
  [2385] = {.lex_state = 58, .external_lex_state = 16},
  [2386] = {.lex_state = 34, .external_lex_state = 14},
  [2387] = {.lex_state = 58, .external_lex_state = 11},
  [2388] = {.lex_state = 58, .external_lex_state = 11},
  [2389] = {.lex_state = 34, .external_lex_state = 11},
  [2390] = {.lex_state = 58, .external_lex_state = 15},
  [2391] = {.lex_state = 34, .external_lex_state = 13},
  [2392] = {.lex_state = 34, .external_lex_state = 15},
  [2393] = {.lex_state = 34, .external_lex_state = 11},
  [2394] = {.lex_state = 34, .external_lex_state = 11},
  [2395] = {.lex_state = 58, .external_lex_state = 13},
  [2396] = {.lex_state = 58, .external_lex_state = 15},
  [2397] = {.lex_state = 58, .external_lex_state = 16},
  [2398] = {.lex_state = 58, .external_lex_state = 16},
  [2399] = {.lex_state = 58, .external_lex_state = 16},
  [2400] = {.lex_state = 58, .external_lex_state = 16},
  [2401] = {.lex_state = 58, .external_lex_state = 16},
  [2402] = {.lex_state = 58, .external_lex_state = 13},
  [2403] = {.lex_state = 58, .external_lex_state = 12},
  [2404] = {.lex_state = 58, .external_lex_state = 16},
  [2405] = {.lex_state = 33, .external_lex_state = 11},
  [2406] = {.lex_state = 58, .external_lex_state = 15},
  [2407] = {.lex_state = 58, .external_lex_state = 13},
  [2408] = {.lex_state = 34, .external_lex_state = 13},
  [2409] = {.lex_state = 58, .external_lex_state = 14},
  [2410] = {.lex_state = 58, .external_lex_state = 12},
  [2411] = {.lex_state = 58, .external_lex_state = 14},
  [2412] = {.lex_state = 58, .external_lex_state = 11},
  [2413] = {.lex_state = 58, .external_lex_state = 13},
  [2414] = {.lex_state = 58, .external_lex_state = 11},
  [2415] = {.lex_state = 58, .external_lex_state = 13},
  [2416] = {.lex_state = 34, .external_lex_state = 15},
  [2417] = {.lex_state = 3, .external_lex_state = 12},
  [2418] = {.lex_state = 58, .external_lex_state = 13},
  [2419] = {.lex_state = 34, .external_lex_state = 15},
  [2420] = {.lex_state = 58, .external_lex_state = 13},
  [2421] = {.lex_state = 58, .external_lex_state = 13},
  [2422] = {.lex_state = 58, .external_lex_state = 13},
  [2423] = {.lex_state = 58, .external_lex_state = 13},
  [2424] = {.lex_state = 58, .external_lex_state = 13},
  [2425] = {.lex_state = 58, .external_lex_state = 13},
  [2426] = {.lex_state = 34, .external_lex_state = 15},
  [2427] = {.lex_state = 58, .external_lex_state = 13},
  [2428] = {.lex_state = 58, .external_lex_state = 12},
  [2429] = {.lex_state = 58, .external_lex_state = 13},
  [2430] = {.lex_state = 58, .external_lex_state = 15},
  [2431] = {.lex_state = 58, .external_lex_state = 12},
  [2432] = {.lex_state = 58, .external_lex_state = 11},
  [2433] = {.lex_state = 3, .external_lex_state = 12},
  [2434] = {.lex_state = 58, .external_lex_state = 13},
  [2435] = {.lex_state = 34, .external_lex_state = 15},
  [2436] = {.lex_state = 58, .external_lex_state = 14},
  [2437] = {.lex_state = 58, .external_lex_state = 14},
  [2438] = {.lex_state = 34, .external_lex_state = 13},
  [2439] = {.lex_state = 58, .external_lex_state = 15},
  [2440] = {.lex_state = 58, .external_lex_state = 13},
  [2441] = {.lex_state = 34, .external_lex_state = 15},
  [2442] = {.lex_state = 34, .external_lex_state = 15},
  [2443] = {.lex_state = 33, .external_lex_state = 11},
  [2444] = {.lex_state = 34, .external_lex_state = 14},
  [2445] = {.lex_state = 58, .external_lex_state = 13},
  [2446] = {.lex_state = 58, .external_lex_state = 19},
  [2447] = {.lex_state = 58, .external_lex_state = 11},
  [2448] = {.lex_state = 34, .external_lex_state = 13},
  [2449] = {.lex_state = 58, .external_lex_state = 13},
  [2450] = {.lex_state = 58, .external_lex_state = 13},
  [2451] = {.lex_state = 58, .external_lex_state = 12},
  [2452] = {.lex_state = 58, .external_lex_state = 12},
  [2453] = {.lex_state = 58, .external_lex_state = 15},
  [2454] = {.lex_state = 58, .external_lex_state = 13},
  [2455] = {.lex_state = 58, .external_lex_state = 13},
  [2456] = {.lex_state = 34, .external_lex_state = 13},
  [2457] = {.lex_state = 34, .external_lex_state = 15},
  [2458] = {.lex_state = 58, .external_lex_state = 12},
  [2459] = {.lex_state = 58, .external_lex_state = 13},
  [2460] = {.lex_state = 58, .external_lex_state = 11},
  [2461] = {.lex_state = 58, .external_lex_state = 13},
  [2462] = {.lex_state = 58, .external_lex_state = 14},
  [2463] = {.lex_state = 58, .external_lex_state = 12},
  [2464] = {.lex_state = 34, .external_lex_state = 13},
  [2465] = {.lex_state = 34, .external_lex_state = 11},
  [2466] = {.lex_state = 34, .external_lex_state = 13},
  [2467] = {.lex_state = 34, .external_lex_state = 13},
  [2468] = {.lex_state = 58, .external_lex_state = 13},
  [2469] = {.lex_state = 58, .external_lex_state = 13},
  [2470] = {.lex_state = 58, .external_lex_state = 13},
  [2471] = {.lex_state = 58, .external_lex_state = 13},
  [2472] = {.lex_state = 58, .external_lex_state = 15},
  [2473] = {.lex_state = 58, .external_lex_state = 13},
  [2474] = {.lex_state = 58, .external_lex_state = 12},
  [2475] = {.lex_state = 58, .external_lex_state = 13},
  [2476] = {.lex_state = 58, .external_lex_state = 15},
  [2477] = {.lex_state = 58, .external_lex_state = 11},
  [2478] = {.lex_state = 34, .external_lex_state = 15},
  [2479] = {.lex_state = 58, .external_lex_state = 13},
  [2480] = {.lex_state = 58, .external_lex_state = 13},
  [2481] = {.lex_state = 58, .external_lex_state = 13},
  [2482] = {.lex_state = 58, .external_lex_state = 12},
  [2483] = {.lex_state = 58, .external_lex_state = 13},
  [2484] = {.lex_state = 58, .external_lex_state = 12},
  [2485] = {.lex_state = 58, .external_lex_state = 13},
  [2486] = {.lex_state = 58, .external_lex_state = 13},
  [2487] = {.lex_state = 58, .external_lex_state = 12},
  [2488] = {.lex_state = 58, .external_lex_state = 13},
  [2489] = {.lex_state = 58, .external_lex_state = 13},
  [2490] = {.lex_state = 58, .external_lex_state = 15},
  [2491] = {.lex_state = 58, .external_lex_state = 13},
  [2492] = {.lex_state = 58, .external_lex_state = 14},
  [2493] = {.lex_state = 58, .external_lex_state = 13},
  [2494] = {.lex_state = 58, .external_lex_state = 14},
  [2495] = {.lex_state = 58, .external_lex_state = 14},
  [2496] = {.lex_state = 58, .external_lex_state = 14},
  [2497] = {.lex_state = 58, .external_lex_state = 15},
  [2498] = {.lex_state = 58, .external_lex_state = 12},
  [2499] = {.lex_state = 58, .external_lex_state = 13},
  [2500] = {.lex_state = 58, .external_lex_state = 13},
  [2501] = {.lex_state = 58, .external_lex_state = 13},
  [2502] = {.lex_state = 58, .external_lex_state = 12},
  [2503] = {.lex_state = 58, .external_lex_state = 12},
  [2504] = {.lex_state = 58, .external_lex_state = 12},
  [2505] = {.lex_state = 58, .external_lex_state = 13},
  [2506] = {.lex_state = 58, .external_lex_state = 13},
  [2507] = {.lex_state = 58, .external_lex_state = 15},
  [2508] = {.lex_state = 34, .external_lex_state = 13},
  [2509] = {.lex_state = 58, .external_lex_state = 13},
  [2510] = {.lex_state = 58, .external_lex_state = 19},
  [2511] = {.lex_state = 58, .external_lex_state = 12},
  [2512] = {.lex_state = 58, .external_lex_state = 15},
  [2513] = {.lex_state = 58, .external_lex_state = 12},
  [2514] = {.lex_state = 58, .external_lex_state = 12},
  [2515] = {.lex_state = 34, .external_lex_state = 15},
  [2516] = {.lex_state = 58, .external_lex_state = 12},
  [2517] = {.lex_state = 58, .external_lex_state = 11},
  [2518] = {.lex_state = 58, .external_lex_state = 13},
  [2519] = {.lex_state = 34, .external_lex_state = 15},
  [2520] = {.lex_state = 3, .external_lex_state = 12},
  [2521] = {.lex_state = 58, .external_lex_state = 13},
  [2522] = {.lex_state = 58, .external_lex_state = 12},
  [2523] = {.lex_state = 58, .external_lex_state = 13},
  [2524] = {.lex_state = 58, .external_lex_state = 13},
  [2525] = {.lex_state = 58, .external_lex_state = 12},
  [2526] = {.lex_state = 58, .external_lex_state = 14},
  [2527] = {.lex_state = 58, .external_lex_state = 13},
  [2528] = {.lex_state = 58, .external_lex_state = 13},
  [2529] = {.lex_state = 58, .external_lex_state = 13},
  [2530] = {.lex_state = 58, .external_lex_state = 13},
  [2531] = {.lex_state = 58, .external_lex_state = 13},
  [2532] = {.lex_state = 58, .external_lex_state = 13},
  [2533] = {.lex_state = 58, .external_lex_state = 15},
  [2534] = {.lex_state = 58, .external_lex_state = 16},
  [2535] = {.lex_state = 58, .external_lex_state = 13},
  [2536] = {.lex_state = 58, .external_lex_state = 11},
  [2537] = {.lex_state = 58, .external_lex_state = 12},
  [2538] = {.lex_state = 58, .external_lex_state = 15},
  [2539] = {.lex_state = 58, .external_lex_state = 14},
  [2540] = {.lex_state = 58, .external_lex_state = 13},
  [2541] = {.lex_state = 58, .external_lex_state = 11},
  [2542] = {.lex_state = 58, .external_lex_state = 13},
  [2543] = {.lex_state = 58, .external_lex_state = 15},
  [2544] = {.lex_state = 58, .external_lex_state = 11},
  [2545] = {.lex_state = 58, .external_lex_state = 13},
  [2546] = {.lex_state = 33, .external_lex_state = 13},
  [2547] = {.lex_state = 58, .external_lex_state = 15},
  [2548] = {.lex_state = 58, .external_lex_state = 11},
  [2549] = {.lex_state = 58, .external_lex_state = 14},
  [2550] = {.lex_state = 58, .external_lex_state = 11},
  [2551] = {.lex_state = 58, .external_lex_state = 13},
  [2552] = {.lex_state = 58, .external_lex_state = 14},
  [2553] = {.lex_state = 58, .external_lex_state = 14},
  [2554] = {.lex_state = 58, .external_lex_state = 14},
  [2555] = {.lex_state = 58, .external_lex_state = 15},
  [2556] = {.lex_state = 58, .external_lex_state = 13},
  [2557] = {.lex_state = 58, .external_lex_state = 15},
  [2558] = {.lex_state = 58, .external_lex_state = 15},
  [2559] = {.lex_state = 58, .external_lex_state = 14},
  [2560] = {.lex_state = 58, .external_lex_state = 11},
  [2561] = {.lex_state = 58, .external_lex_state = 14},
  [2562] = {.lex_state = 58, .external_lex_state = 14},
  [2563] = {.lex_state = 58, .external_lex_state = 15},
  [2564] = {.lex_state = 58, .external_lex_state = 15},
  [2565] = {.lex_state = 34, .external_lex_state = 13},
  [2566] = {.lex_state = 58, .external_lex_state = 15},
  [2567] = {.lex_state = 58, .external_lex_state = 14},
  [2568] = {.lex_state = 58, .external_lex_state = 15},
  [2569] = {.lex_state = 58, .external_lex_state = 14},
  [2570] = {.lex_state = 58, .external_lex_state = 14},
  [2571] = {.lex_state = 58, .external_lex_state = 15},
  [2572] = {.lex_state = 58, .external_lex_state = 12},
  [2573] = {.lex_state = 58, .external_lex_state = 14},
  [2574] = {.lex_state = 58, .external_lex_state = 12},
  [2575] = {.lex_state = 58, .external_lex_state = 14},
  [2576] = {.lex_state = 58, .external_lex_state = 14},
  [2577] = {.lex_state = 58, .external_lex_state = 12},
  [2578] = {.lex_state = 58, .external_lex_state = 14},
  [2579] = {.lex_state = 58, .external_lex_state = 14},
  [2580] = {.lex_state = 58, .external_lex_state = 15},
  [2581] = {.lex_state = 58, .external_lex_state = 14},
  [2582] = {.lex_state = 58, .external_lex_state = 11},
  [2583] = {.lex_state = 58, .external_lex_state = 14},
  [2584] = {.lex_state = 58, .external_lex_state = 12},
  [2585] = {.lex_state = 58, .external_lex_state = 11},
  [2586] = {.lex_state = 58, .external_lex_state = 12},
  [2587] = {.lex_state = 58, .external_lex_state = 13},
  [2588] = {.lex_state = 58, .external_lex_state = 14},
  [2589] = {.lex_state = 58, .external_lex_state = 13},
  [2590] = {.lex_state = 58, .external_lex_state = 12},
  [2591] = {.lex_state = 58, .external_lex_state = 12},
  [2592] = {.lex_state = 58, .external_lex_state = 14},
  [2593] = {.lex_state = 58, .external_lex_state = 12},
  [2594] = {.lex_state = 58, .external_lex_state = 11},
  [2595] = {.lex_state = 58, .external_lex_state = 14},
  [2596] = {.lex_state = 58, .external_lex_state = 14},
  [2597] = {.lex_state = 58, .external_lex_state = 11},
  [2598] = {.lex_state = 58, .external_lex_state = 15},
  [2599] = {.lex_state = 58, .external_lex_state = 15},
  [2600] = {.lex_state = 58, .external_lex_state = 11},
  [2601] = {.lex_state = 58, .external_lex_state = 14},
  [2602] = {.lex_state = 58, .external_lex_state = 14},
  [2603] = {.lex_state = 58, .external_lex_state = 14},
  [2604] = {.lex_state = 58, .external_lex_state = 14},
  [2605] = {.lex_state = 58, .external_lex_state = 14},
  [2606] = {.lex_state = 58, .external_lex_state = 14},
  [2607] = {.lex_state = 58, .external_lex_state = 13},
  [2608] = {.lex_state = 58, .external_lex_state = 14},
  [2609] = {.lex_state = 58, .external_lex_state = 13},
  [2610] = {.lex_state = 58, .external_lex_state = 15},
  [2611] = {.lex_state = 58, .external_lex_state = 12},
  [2612] = {.lex_state = 58, .external_lex_state = 12},
  [2613] = {.lex_state = 58, .external_lex_state = 12},
  [2614] = {.lex_state = 58, .external_lex_state = 12},
  [2615] = {.lex_state = 58, .external_lex_state = 11},
  [2616] = {.lex_state = 58, .external_lex_state = 16},
  [2617] = {.lex_state = 58, .external_lex_state = 15},
  [2618] = {.lex_state = 58, .external_lex_state = 12},
  [2619] = {.lex_state = 58, .external_lex_state = 12},
  [2620] = {.lex_state = 58, .external_lex_state = 16},
  [2621] = {.lex_state = 58, .external_lex_state = 12},
  [2622] = {.lex_state = 58, .external_lex_state = 11},
  [2623] = {.lex_state = 58, .external_lex_state = 15},
  [2624] = {.lex_state = 58, .external_lex_state = 15},
  [2625] = {.lex_state = 58, .external_lex_state = 16},
  [2626] = {.lex_state = 58, .external_lex_state = 11},
  [2627] = {.lex_state = 58, .external_lex_state = 15},
  [2628] = {.lex_state = 33, .external_lex_state = 13},
  [2629] = {.lex_state = 58, .external_lex_state = 13},
  [2630] = {.lex_state = 58, .external_lex_state = 15},
  [2631] = {.lex_state = 58, .external_lex_state = 12},
  [2632] = {.lex_state = 58, .external_lex_state = 12},
  [2633] = {.lex_state = 58, .external_lex_state = 12},
  [2634] = {.lex_state = 58, .external_lex_state = 12},
  [2635] = {.lex_state = 58, .external_lex_state = 12},
  [2636] = {.lex_state = 58, .external_lex_state = 12},
  [2637] = {.lex_state = 58, .external_lex_state = 15},
  [2638] = {.lex_state = 58, .external_lex_state = 12},
  [2639] = {.lex_state = 58, .external_lex_state = 15},
  [2640] = {.lex_state = 58, .external_lex_state = 12},
  [2641] = {.lex_state = 58, .external_lex_state = 15},
  [2642] = {.lex_state = 58, .external_lex_state = 15},
  [2643] = {.lex_state = 58, .external_lex_state = 14},
  [2644] = {.lex_state = 58, .external_lex_state = 14},
  [2645] = {.lex_state = 58, .external_lex_state = 11},
  [2646] = {.lex_state = 58, .external_lex_state = 14},
  [2647] = {.lex_state = 58, .external_lex_state = 14},
  [2648] = {.lex_state = 34, .external_lex_state = 13},
  [2649] = {.lex_state = 58, .external_lex_state = 12},
  [2650] = {.lex_state = 58, .external_lex_state = 14},
  [2651] = {.lex_state = 58, .external_lex_state = 12},
  [2652] = {.lex_state = 58, .external_lex_state = 14},
  [2653] = {.lex_state = 58, .external_lex_state = 15},
  [2654] = {.lex_state = 58, .external_lex_state = 15},
  [2655] = {.lex_state = 58, .external_lex_state = 16},
  [2656] = {.lex_state = 58, .external_lex_state = 11},
  [2657] = {.lex_state = 58, .external_lex_state = 13},
  [2658] = {.lex_state = 58, .external_lex_state = 15},
  [2659] = {.lex_state = 58, .external_lex_state = 13},
  [2660] = {.lex_state = 58, .external_lex_state = 13},
  [2661] = {.lex_state = 58, .external_lex_state = 14},
  [2662] = {.lex_state = 58, .external_lex_state = 14},
  [2663] = {.lex_state = 58, .external_lex_state = 11},
  [2664] = {.lex_state = 58, .external_lex_state = 16},
  [2665] = {.lex_state = 58, .external_lex_state = 19},
  [2666] = {.lex_state = 58, .external_lex_state = 19},
  [2667] = {.lex_state = 58, .external_lex_state = 16},
  [2668] = {.lex_state = 58, .external_lex_state = 11},
  [2669] = {.lex_state = 58, .external_lex_state = 16},
  [2670] = {.lex_state = 58, .external_lex_state = 19},
  [2671] = {.lex_state = 58, .external_lex_state = 11},
  [2672] = {.lex_state = 58, .external_lex_state = 13},
  [2673] = {.lex_state = 58, .external_lex_state = 13},
  [2674] = {.lex_state = 58, .external_lex_state = 14},
  [2675] = {.lex_state = 58, .external_lex_state = 14},
  [2676] = {.lex_state = 58, .external_lex_state = 15},
  [2677] = {.lex_state = 58, .external_lex_state = 15},
  [2678] = {.lex_state = 58, .external_lex_state = 12},
  [2679] = {.lex_state = 58, .external_lex_state = 11},
  [2680] = {.lex_state = 58, .external_lex_state = 13},
  [2681] = {.lex_state = 58, .external_lex_state = 15},
  [2682] = {.lex_state = 58, .external_lex_state = 16},
  [2683] = {.lex_state = 58, .external_lex_state = 14},
  [2684] = {.lex_state = 58, .external_lex_state = 16},
  [2685] = {.lex_state = 58, .external_lex_state = 14},
  [2686] = {.lex_state = 58, .external_lex_state = 19},
  [2687] = {.lex_state = 58, .external_lex_state = 14},
  [2688] = {.lex_state = 58, .external_lex_state = 11},
  [2689] = {.lex_state = 58, .external_lex_state = 13},
  [2690] = {.lex_state = 58, .external_lex_state = 13},
  [2691] = {.lex_state = 58, .external_lex_state = 12},
  [2692] = {.lex_state = 58, .external_lex_state = 15},
  [2693] = {.lex_state = 58, .external_lex_state = 14},
  [2694] = {.lex_state = 58, .external_lex_state = 14},
  [2695] = {.lex_state = 58, .external_lex_state = 13},
  [2696] = {.lex_state = 58, .external_lex_state = 13},
  [2697] = {.lex_state = 58, .external_lex_state = 19},
  [2698] = {.lex_state = 58, .external_lex_state = 11},
  [2699] = {.lex_state = 58, .external_lex_state = 11},
  [2700] = {.lex_state = 58, .external_lex_state = 11},
  [2701] = {.lex_state = 58, .external_lex_state = 12},
  [2702] = {.lex_state = 58, .external_lex_state = 13},
  [2703] = {.lex_state = 58, .external_lex_state = 12},
  [2704] = {.lex_state = 58, .external_lex_state = 16},
  [2705] = {.lex_state = 58, .external_lex_state = 13},
  [2706] = {.lex_state = 58, .external_lex_state = 13},
  [2707] = {.lex_state = 58, .external_lex_state = 16},
  [2708] = {.lex_state = 58, .external_lex_state = 13},
  [2709] = {.lex_state = 58, .external_lex_state = 19},
  [2710] = {.lex_state = 58, .external_lex_state = 19},
  [2711] = {.lex_state = 58, .external_lex_state = 11},
  [2712] = {.lex_state = 58, .external_lex_state = 13},
  [2713] = {.lex_state = 58, .external_lex_state = 13},
  [2714] = {.lex_state = 58, .external_lex_state = 14},
  [2715] = {.lex_state = 58, .external_lex_state = 13},
  [2716] = {.lex_state = 58, .external_lex_state = 19},
  [2717] = {.lex_state = 58, .external_lex_state = 14},
  [2718] = {.lex_state = 58, .external_lex_state = 12},
  [2719] = {.lex_state = 58, .external_lex_state = 14},
  [2720] = {.lex_state = 58, .external_lex_state = 14},
  [2721] = {.lex_state = 58, .external_lex_state = 14},
  [2722] = {.lex_state = 58, .external_lex_state = 14},
  [2723] = {.lex_state = 34, .external_lex_state = 13},
  [2724] = {.lex_state = 34, .external_lex_state = 13},
  [2725] = {.lex_state = 34, .external_lex_state = 13},
  [2726] = {.lex_state = 34, .external_lex_state = 13},
  [2727] = {.lex_state = 58, .external_lex_state = 11},
  [2728] = {.lex_state = 58, .external_lex_state = 11},
  [2729] = {.lex_state = 58, .external_lex_state = 13},
  [2730] = {.lex_state = 58, .external_lex_state = 19},
  [2731] = {.lex_state = 58, .external_lex_state = 16},
  [2732] = {.lex_state = 58, .external_lex_state = 16},
  [2733] = {.lex_state = 58, .external_lex_state = 13},
  [2734] = {.lex_state = 58, .external_lex_state = 16},
  [2735] = {.lex_state = 58, .external_lex_state = 16},
  [2736] = {.lex_state = 58, .external_lex_state = 13},
  [2737] = {.lex_state = 58, .external_lex_state = 19},
  [2738] = {.lex_state = 58, .external_lex_state = 13},
  [2739] = {.lex_state = 58, .external_lex_state = 14},
  [2740] = {.lex_state = 58, .external_lex_state = 14},
  [2741] = {.lex_state = 58, .external_lex_state = 15},
  [2742] = {.lex_state = 58, .external_lex_state = 13},
  [2743] = {.lex_state = 58, .external_lex_state = 13},
  [2744] = {.lex_state = 58, .external_lex_state = 12},
  [2745] = {.lex_state = 58, .external_lex_state = 12},
  [2746] = {.lex_state = 58, .external_lex_state = 12},
  [2747] = {.lex_state = 58, .external_lex_state = 13},
  [2748] = {.lex_state = 58, .external_lex_state = 19},
  [2749] = {.lex_state = 58, .external_lex_state = 13},
  [2750] = {.lex_state = 58, .external_lex_state = 12},
  [2751] = {.lex_state = 58, .external_lex_state = 13},
  [2752] = {.lex_state = 58, .external_lex_state = 14},
  [2753] = {.lex_state = 58, .external_lex_state = 16},
  [2754] = {.lex_state = 58, .external_lex_state = 13},
  [2755] = {.lex_state = 58, .external_lex_state = 16},
  [2756] = {.lex_state = 58, .external_lex_state = 11},
  [2757] = {.lex_state = 58, .external_lex_state = 11},
  [2758] = {.lex_state = 58, .external_lex_state = 19},
  [2759] = {.lex_state = 58, .external_lex_state = 19},
  [2760] = {.lex_state = 58, .external_lex_state = 15},
  [2761] = {.lex_state = 58, .external_lex_state = 15},
  [2762] = {.lex_state = 58, .external_lex_state = 15},
  [2763] = {.lex_state = 58, .external_lex_state = 19},
  [2764] = {.lex_state = 58, .external_lex_state = 11},
  [2765] = {.lex_state = 58, .external_lex_state = 14},
  [2766] = {.lex_state = 58, .external_lex_state = 15},
  [2767] = {.lex_state = 58, .external_lex_state = 12},
  [2768] = {.lex_state = 58, .external_lex_state = 13},
  [2769] = {.lex_state = 58, .external_lex_state = 13},
  [2770] = {.lex_state = 58, .external_lex_state = 15},
  [2771] = {.lex_state = 58, .external_lex_state = 11},
  [2772] = {.lex_state = 58, .external_lex_state = 15},
  [2773] = {.lex_state = 58, .external_lex_state = 12},
  [2774] = {.lex_state = 58, .external_lex_state = 14},
  [2775] = {.lex_state = 58, .external_lex_state = 14},
  [2776] = {.lex_state = 58, .external_lex_state = 15},
  [2777] = {.lex_state = 58, .external_lex_state = 15},
  [2778] = {.lex_state = 58, .external_lex_state = 15},
  [2779] = {.lex_state = 58, .external_lex_state = 11},
  [2780] = {.lex_state = 58, .external_lex_state = 15},
  [2781] = {.lex_state = 58, .external_lex_state = 15},
  [2782] = {.lex_state = 58, .external_lex_state = 15},
  [2783] = {.lex_state = 58, .external_lex_state = 14},
  [2784] = {.lex_state = 58, .external_lex_state = 16},
  [2785] = {.lex_state = 58, .external_lex_state = 15},
  [2786] = {.lex_state = 58, .external_lex_state = 11},
  [2787] = {.lex_state = 58, .external_lex_state = 11},
  [2788] = {.lex_state = 58, .external_lex_state = 12},
  [2789] = {.lex_state = 58, .external_lex_state = 11},
  [2790] = {.lex_state = 58, .external_lex_state = 15},
  [2791] = {.lex_state = 58, .external_lex_state = 15},
  [2792] = {.lex_state = 58, .external_lex_state = 14},
  [2793] = {.lex_state = 58, .external_lex_state = 14},
  [2794] = {.lex_state = 58, .external_lex_state = 14},
  [2795] = {.lex_state = 58, .external_lex_state = 14},
  [2796] = {.lex_state = 58, .external_lex_state = 15},
  [2797] = {.lex_state = 58, .external_lex_state = 15},
  [2798] = {.lex_state = 58, .external_lex_state = 14},
  [2799] = {.lex_state = 58, .external_lex_state = 13},
  [2800] = {.lex_state = 58, .external_lex_state = 14},
  [2801] = {.lex_state = 58, .external_lex_state = 14},
  [2802] = {.lex_state = 58, .external_lex_state = 19},
  [2803] = {.lex_state = 58, .external_lex_state = 12},
  [2804] = {.lex_state = 58, .external_lex_state = 14},
  [2805] = {.lex_state = 58, .external_lex_state = 12},
  [2806] = {.lex_state = 58, .external_lex_state = 19},
  [2807] = {.lex_state = 58, .external_lex_state = 13},
  [2808] = {.lex_state = 58, .external_lex_state = 11},
  [2809] = {.lex_state = 58, .external_lex_state = 11},
  [2810] = {.lex_state = 58, .external_lex_state = 12},
  [2811] = {.lex_state = 58, .external_lex_state = 12},
  [2812] = {.lex_state = 58, .external_lex_state = 14},
  [2813] = {.lex_state = 58, .external_lex_state = 14},
  [2814] = {.lex_state = 58, .external_lex_state = 14},
  [2815] = {.lex_state = 35, .external_lex_state = 18},
  [2816] = {.lex_state = 58, .external_lex_state = 11},
  [2817] = {.lex_state = 58, .external_lex_state = 14},
  [2818] = {.lex_state = 58, .external_lex_state = 13},
  [2819] = {.lex_state = 58, .external_lex_state = 19},
  [2820] = {.lex_state = 58, .external_lex_state = 12},
  [2821] = {.lex_state = 58, .external_lex_state = 11},
  [2822] = {.lex_state = 58, .external_lex_state = 12},
  [2823] = {.lex_state = 58, .external_lex_state = 12},
  [2824] = {.lex_state = 58, .external_lex_state = 11},
  [2825] = {.lex_state = 58, .external_lex_state = 13},
  [2826] = {.lex_state = 58, .external_lex_state = 19},
  [2827] = {.lex_state = 58, .external_lex_state = 15},
  [2828] = {.lex_state = 58, .external_lex_state = 14},
  [2829] = {.lex_state = 58, .external_lex_state = 14},
  [2830] = {.lex_state = 58, .external_lex_state = 19},
  [2831] = {.lex_state = 58, .external_lex_state = 19},
  [2832] = {.lex_state = 58, .external_lex_state = 15},
  [2833] = {.lex_state = 58, .external_lex_state = 14},
  [2834] = {.lex_state = 58, .external_lex_state = 14},
  [2835] = {.lex_state = 58, .external_lex_state = 14},
  [2836] = {.lex_state = 58, .external_lex_state = 19},
  [2837] = {.lex_state = 58, .external_lex_state = 16},
  [2838] = {.lex_state = 58, .external_lex_state = 15},
  [2839] = {.lex_state = 58, .external_lex_state = 11},
  [2840] = {.lex_state = 3, .external_lex_state = 12},
  [2841] = {.lex_state = 58, .external_lex_state = 14},
  [2842] = {.lex_state = 58, .external_lex_state = 14},
  [2843] = {.lex_state = 3, .external_lex_state = 12},
  [2844] = {.lex_state = 58, .external_lex_state = 14},
  [2845] = {.lex_state = 3, .external_lex_state = 12},
  [2846] = {.lex_state = 58, .external_lex_state = 15},
  [2847] = {.lex_state = 58, .external_lex_state = 15},
  [2848] = {.lex_state = 3, .external_lex_state = 12},
  [2849] = {.lex_state = 58, .external_lex_state = 16},
  [2850] = {.lex_state = 58, .external_lex_state = 16},
  [2851] = {.lex_state = 58, .external_lex_state = 15},
  [2852] = {.lex_state = 58, .external_lex_state = 19},
  [2853] = {.lex_state = 58, .external_lex_state = 16},
  [2854] = {.lex_state = 58, .external_lex_state = 13},
  [2855] = {.lex_state = 3, .external_lex_state = 12},
  [2856] = {.lex_state = 3, .external_lex_state = 12},
  [2857] = {.lex_state = 3, .external_lex_state = 12},
  [2858] = {.lex_state = 35, .external_lex_state = 18},
  [2859] = {.lex_state = 58, .external_lex_state = 14},
  [2860] = {.lex_state = 58, .external_lex_state = 14},
  [2861] = {.lex_state = 58, .external_lex_state = 13},
  [2862] = {.lex_state = 58, .external_lex_state = 14},
  [2863] = {.lex_state = 58, .external_lex_state = 11},
  [2864] = {.lex_state = 58, .external_lex_state = 14},
  [2865] = {.lex_state = 58, .external_lex_state = 14},
  [2866] = {.lex_state = 58, .external_lex_state = 16},
  [2867] = {.lex_state = 58, .external_lex_state = 19},
  [2868] = {.lex_state = 58, .external_lex_state = 16},
  [2869] = {.lex_state = 58, .external_lex_state = 15},
  [2870] = {.lex_state = 58, .external_lex_state = 19},
  [2871] = {.lex_state = 58, .external_lex_state = 11},
  [2872] = {.lex_state = 58, .external_lex_state = 15},
  [2873] = {.lex_state = 58, .external_lex_state = 12},
  [2874] = {.lex_state = 58, .external_lex_state = 14},
  [2875] = {.lex_state = 58, .external_lex_state = 14},
  [2876] = {.lex_state = 58, .external_lex_state = 14},
  [2877] = {.lex_state = 58, .external_lex_state = 12},
  [2878] = {.lex_state = 58, .external_lex_state = 14},
  [2879] = {.lex_state = 58, .external_lex_state = 16},
  [2880] = {.lex_state = 58, .external_lex_state = 16},
  [2881] = {.lex_state = 58, .external_lex_state = 12},
  [2882] = {.lex_state = 3, .external_lex_state = 12},
  [2883] = {.lex_state = 58, .external_lex_state = 14},
  [2884] = {.lex_state = 58, .external_lex_state = 14},
  [2885] = {.lex_state = 58, .external_lex_state = 15},
  [2886] = {.lex_state = 58, .external_lex_state = 11},
  [2887] = {.lex_state = 58, .external_lex_state = 12},
  [2888] = {.lex_state = 58, .external_lex_state = 12},
  [2889] = {.lex_state = 35, .external_lex_state = 18},
  [2890] = {.lex_state = 58, .external_lex_state = 12},
  [2891] = {.lex_state = 58, .external_lex_state = 13},
  [2892] = {.lex_state = 58, .external_lex_state = 19},
  [2893] = {.lex_state = 58, .external_lex_state = 16},
  [2894] = {.lex_state = 58, .external_lex_state = 19},
  [2895] = {.lex_state = 58, .external_lex_state = 14},
  [2896] = {.lex_state = 58, .external_lex_state = 14},
  [2897] = {.lex_state = 58, .external_lex_state = 14},
  [2898] = {.lex_state = 58, .external_lex_state = 15},
  [2899] = {.lex_state = 58, .external_lex_state = 14},
  [2900] = {.lex_state = 58, .external_lex_state = 14},
  [2901] = {.lex_state = 58, .external_lex_state = 15},
  [2902] = {.lex_state = 58, .external_lex_state = 14},
  [2903] = {.lex_state = 58, .external_lex_state = 19},
  [2904] = {.lex_state = 35, .external_lex_state = 18},
  [2905] = {.lex_state = 58, .external_lex_state = 14},
  [2906] = {.lex_state = 58, .external_lex_state = 14},
  [2907] = {.lex_state = 58, .external_lex_state = 14},
  [2908] = {.lex_state = 58, .external_lex_state = 14},
  [2909] = {.lex_state = 58, .external_lex_state = 14},
  [2910] = {.lex_state = 58, .external_lex_state = 11},
  [2911] = {.lex_state = 58, .external_lex_state = 15},
  [2912] = {.lex_state = 58, .external_lex_state = 15},
  [2913] = {.lex_state = 58, .external_lex_state = 11},
  [2914] = {.lex_state = 58, .external_lex_state = 15},
  [2915] = {.lex_state = 58, .external_lex_state = 14},
  [2916] = {.lex_state = 58, .external_lex_state = 15},
  [2917] = {.lex_state = 3, .external_lex_state = 12},
  [2918] = {.lex_state = 58, .external_lex_state = 12},
  [2919] = {.lex_state = 58, .external_lex_state = 14},
  [2920] = {.lex_state = 58, .external_lex_state = 13},
  [2921] = {.lex_state = 58, .external_lex_state = 13},
  [2922] = {.lex_state = 58, .external_lex_state = 15},
  [2923] = {.lex_state = 58, .external_lex_state = 15},
  [2924] = {.lex_state = 58, .external_lex_state = 14},
  [2925] = {.lex_state = 58, .external_lex_state = 14},
  [2926] = {.lex_state = 58, .external_lex_state = 19},
  [2927] = {.lex_state = 58, .external_lex_state = 16},
  [2928] = {.lex_state = 58, .external_lex_state = 15},
  [2929] = {.lex_state = 58, .external_lex_state = 12},
  [2930] = {.lex_state = 35, .external_lex_state = 18},
  [2931] = {.lex_state = 58, .external_lex_state = 14},
  [2932] = {.lex_state = 58, .external_lex_state = 14},
  [2933] = {.lex_state = 58, .external_lex_state = 16},
  [2934] = {.lex_state = 58, .external_lex_state = 11},
  [2935] = {.lex_state = 58, .external_lex_state = 12},
  [2936] = {.lex_state = 58, .external_lex_state = 15},
  [2937] = {.lex_state = 34, .external_lex_state = 13},
  [2938] = {.lex_state = 58, .external_lex_state = 11},
  [2939] = {.lex_state = 58, .external_lex_state = 16},
  [2940] = {.lex_state = 58, .external_lex_state = 12},
  [2941] = {.lex_state = 58, .external_lex_state = 11},
  [2942] = {.lex_state = 58, .external_lex_state = 14},
  [2943] = {.lex_state = 58, .external_lex_state = 16},
  [2944] = {.lex_state = 58, .external_lex_state = 12},
  [2945] = {.lex_state = 58, .external_lex_state = 14},
  [2946] = {.lex_state = 58, .external_lex_state = 19},
  [2947] = {.lex_state = 58, .external_lex_state = 11},
  [2948] = {.lex_state = 58, .external_lex_state = 16},
  [2949] = {.lex_state = 58, .external_lex_state = 20},
  [2950] = {.lex_state = 58, .external_lex_state = 14},
  [2951] = {.lex_state = 58, .external_lex_state = 14},
  [2952] = {.lex_state = 58, .external_lex_state = 16},
  [2953] = {.lex_state = 58, .external_lex_state = 21},
  [2954] = {.lex_state = 58, .external_lex_state = 15},
  [2955] = {.lex_state = 58, .external_lex_state = 16},
  [2956] = {.lex_state = 58, .external_lex_state = 16},
  [2957] = {.lex_state = 58, .external_lex_state = 14},
  [2958] = {.lex_state = 58, .external_lex_state = 14},
  [2959] = {.lex_state = 58, .external_lex_state = 15},
  [2960] = {.lex_state = 58, .external_lex_state = 15},
  [2961] = {.lex_state = 58, .external_lex_state = 14},
  [2962] = {.lex_state = 58, .external_lex_state = 14},
  [2963] = {.lex_state = 58, .external_lex_state = 14},
  [2964] = {.lex_state = 58, .external_lex_state = 16},
  [2965] = {.lex_state = 58, .external_lex_state = 15},
  [2966] = {.lex_state = 58, .external_lex_state = 15},
  [2967] = {.lex_state = 58, .external_lex_state = 15},
  [2968] = {.lex_state = 58, .external_lex_state = 15},
  [2969] = {.lex_state = 58, .external_lex_state = 16},
  [2970] = {.lex_state = 58, .external_lex_state = 14},
  [2971] = {.lex_state = 58, .external_lex_state = 15},
  [2972] = {.lex_state = 58, .external_lex_state = 14},
  [2973] = {.lex_state = 58, .external_lex_state = 14},
  [2974] = {.lex_state = 58, .external_lex_state = 12},
  [2975] = {.lex_state = 34, .external_lex_state = 13},
  [2976] = {.lex_state = 58, .external_lex_state = 11},
  [2977] = {.lex_state = 58, .external_lex_state = 19},
  [2978] = {.lex_state = 58, .external_lex_state = 19},
  [2979] = {.lex_state = 58, .external_lex_state = 16},
  [2980] = {.lex_state = 58, .external_lex_state = 15},
  [2981] = {.lex_state = 58, .external_lex_state = 12},
  [2982] = {.lex_state = 58, .external_lex_state = 16},
  [2983] = {.lex_state = 58, .external_lex_state = 12},
  [2984] = {.lex_state = 34, .external_lex_state = 13},
  [2985] = {.lex_state = 58, .external_lex_state = 16},
  [2986] = {.lex_state = 58, .external_lex_state = 14},
  [2987] = {.lex_state = 58, .external_lex_state = 14},
  [2988] = {.lex_state = 58, .external_lex_state = 16},
  [2989] = {.lex_state = 58, .external_lex_state = 15},
  [2990] = {.lex_state = 58, .external_lex_state = 11},
  [2991] = {.lex_state = 58, .external_lex_state = 13},
  [2992] = {.lex_state = 58, .external_lex_state = 12},
  [2993] = {.lex_state = 58, .external_lex_state = 12},
  [2994] = {.lex_state = 58, .external_lex_state = 12},
  [2995] = {.lex_state = 34, .external_lex_state = 13},
  [2996] = {.lex_state = 58, .external_lex_state = 14},
  [2997] = {.lex_state = 58, .external_lex_state = 12},
  [2998] = {.lex_state = 58, .external_lex_state = 15},
  [2999] = {.lex_state = 58, .external_lex_state = 12},
  [3000] = {.lex_state = 58, .external_lex_state = 15},
  [3001] = {.lex_state = 58, .external_lex_state = 14},
  [3002] = {.lex_state = 58, .external_lex_state = 16},
  [3003] = {.lex_state = 58, .external_lex_state = 14},
  [3004] = {.lex_state = 58, .external_lex_state = 11},
  [3005] = {.lex_state = 58, .external_lex_state = 16},
  [3006] = {.lex_state = 58, .external_lex_state = 15},
  [3007] = {.lex_state = 58, .external_lex_state = 11},
  [3008] = {.lex_state = 58, .external_lex_state = 16},
  [3009] = {.lex_state = 58, .external_lex_state = 11},
  [3010] = {.lex_state = 58, .external_lex_state = 16},
  [3011] = {.lex_state = 58, .external_lex_state = 11},
  [3012] = {.lex_state = 58, .external_lex_state = 14},
  [3013] = {.lex_state = 58, .external_lex_state = 14},
  [3014] = {.lex_state = 58, .external_lex_state = 16},
  [3015] = {.lex_state = 58, .external_lex_state = 16},
  [3016] = {.lex_state = 58, .external_lex_state = 14},
  [3017] = {.lex_state = 58, .external_lex_state = 14},
  [3018] = {.lex_state = 58, .external_lex_state = 14},
  [3019] = {.lex_state = 58, .external_lex_state = 11},
  [3020] = {.lex_state = 58, .external_lex_state = 12},
  [3021] = {.lex_state = 58, .external_lex_state = 16},
  [3022] = {.lex_state = 58, .external_lex_state = 19},
  [3023] = {.lex_state = 58, .external_lex_state = 12},
  [3024] = {.lex_state = 58, .external_lex_state = 12},
  [3025] = {.lex_state = 58, .external_lex_state = 12},
  [3026] = {.lex_state = 58, .external_lex_state = 15},
  [3027] = {.lex_state = 58, .external_lex_state = 11},
  [3028] = {.lex_state = 58, .external_lex_state = 13},
  [3029] = {.lex_state = 58, .external_lex_state = 14},
  [3030] = {.lex_state = 58, .external_lex_state = 11},
  [3031] = {.lex_state = 58, .external_lex_state = 11},
  [3032] = {.lex_state = 58, .external_lex_state = 16},
  [3033] = {.lex_state = 58, .external_lex_state = 13},
  [3034] = {.lex_state = 58, .external_lex_state = 16},
  [3035] = {.lex_state = 58, .external_lex_state = 13},
  [3036] = {.lex_state = 58, .external_lex_state = 13},
  [3037] = {.lex_state = 58, .external_lex_state = 13},
  [3038] = {.lex_state = 58, .external_lex_state = 11},
  [3039] = {.lex_state = 58, .external_lex_state = 11},
  [3040] = {.lex_state = 58, .external_lex_state = 13},
  [3041] = {.lex_state = 58, .external_lex_state = 16},
  [3042] = {.lex_state = 58, .external_lex_state = 16},
  [3043] = {.lex_state = 58, .external_lex_state = 13},
  [3044] = {.lex_state = 58, .external_lex_state = 11},
  [3045] = {.lex_state = 58, .external_lex_state = 11},
  [3046] = {.lex_state = 58, .external_lex_state = 13},
  [3047] = {.lex_state = 58, .external_lex_state = 16},
  [3048] = {.lex_state = 58, .external_lex_state = 11},
  [3049] = {.lex_state = 58, .external_lex_state = 13},
  [3050] = {.lex_state = 58, .external_lex_state = 16},
  [3051] = {.lex_state = 58, .external_lex_state = 16},
  [3052] = {.lex_state = 58, .external_lex_state = 13},
  [3053] = {.lex_state = 58, .external_lex_state = 13},
  [3054] = {.lex_state = 58, .external_lex_state = 11},
  [3055] = {.lex_state = 58, .external_lex_state = 16},
  [3056] = {.lex_state = 58, .external_lex_state = 16},
  [3057] = {.lex_state = 58, .external_lex_state = 13},
  [3058] = {.lex_state = 58, .external_lex_state = 13},
  [3059] = {.lex_state = 58, .external_lex_state = 13},
  [3060] = {.lex_state = 58, .external_lex_state = 12},
  [3061] = {.lex_state = 58, .external_lex_state = 16},
  [3062] = {.lex_state = 35, .external_lex_state = 13},
  [3063] = {.lex_state = 58, .external_lex_state = 13},
  [3064] = {.lex_state = 58, .external_lex_state = 16},
  [3065] = {.lex_state = 58, .external_lex_state = 16},
  [3066] = {.lex_state = 35, .external_lex_state = 13},
  [3067] = {.lex_state = 58, .external_lex_state = 13},
  [3068] = {.lex_state = 58, .external_lex_state = 13},
  [3069] = {.lex_state = 35, .external_lex_state = 13},
  [3070] = {.lex_state = 35, .external_lex_state = 13},
  [3071] = {.lex_state = 58, .external_lex_state = 14},
  [3072] = {.lex_state = 35, .external_lex_state = 13},
  [3073] = {.lex_state = 58, .external_lex_state = 16},
  [3074] = {.lex_state = 58, .external_lex_state = 16},
  [3075] = {.lex_state = 58, .external_lex_state = 16},
  [3076] = {.lex_state = 58, .external_lex_state = 13},
  [3077] = {.lex_state = 58, .external_lex_state = 16},
  [3078] = {.lex_state = 58, .external_lex_state = 13},
  [3079] = {.lex_state = 58, .external_lex_state = 16},
  [3080] = {.lex_state = 58, .external_lex_state = 16},
  [3081] = {.lex_state = 58, .external_lex_state = 13},
  [3082] = {.lex_state = 58, .external_lex_state = 16},
  [3083] = {.lex_state = 58, .external_lex_state = 16},
  [3084] = {.lex_state = 58, .external_lex_state = 16},
  [3085] = {.lex_state = 58, .external_lex_state = 13},
  [3086] = {.lex_state = 58, .external_lex_state = 16},
  [3087] = {.lex_state = 58, .external_lex_state = 11},
  [3088] = {.lex_state = 58, .external_lex_state = 16},
  [3089] = {.lex_state = 58, .external_lex_state = 11},
  [3090] = {.lex_state = 58, .external_lex_state = 11},
  [3091] = {.lex_state = 58, .external_lex_state = 13},
  [3092] = {.lex_state = 58, .external_lex_state = 16},
  [3093] = {.lex_state = 58, .external_lex_state = 14},
  [3094] = {.lex_state = 58, .external_lex_state = 15},
  [3095] = {.lex_state = 58, .external_lex_state = 16},
  [3096] = {.lex_state = 58, .external_lex_state = 13},
  [3097] = {.lex_state = 58, .external_lex_state = 16},
  [3098] = {.lex_state = 58, .external_lex_state = 12},
  [3099] = {.lex_state = 58, .external_lex_state = 13},
  [3100] = {.lex_state = 58, .external_lex_state = 13},
  [3101] = {.lex_state = 58, .external_lex_state = 11},
  [3102] = {.lex_state = 58, .external_lex_state = 12},
  [3103] = {.lex_state = 58, .external_lex_state = 13},
  [3104] = {.lex_state = 58, .external_lex_state = 16},
  [3105] = {.lex_state = 58, .external_lex_state = 11},
  [3106] = {.lex_state = 58, .external_lex_state = 11},
  [3107] = {.lex_state = 58, .external_lex_state = 16},
  [3108] = {.lex_state = 58, .external_lex_state = 12},
  [3109] = {.lex_state = 58, .external_lex_state = 11},
  [3110] = {.lex_state = 58, .external_lex_state = 12},
  [3111] = {.lex_state = 58, .external_lex_state = 16},
  [3112] = {.lex_state = 58, .external_lex_state = 11},
  [3113] = {.lex_state = 58, .external_lex_state = 14},
  [3114] = {.lex_state = 58, .external_lex_state = 15},
  [3115] = {.lex_state = 58, .external_lex_state = 14},
  [3116] = {.lex_state = 58, .external_lex_state = 16},
  [3117] = {.lex_state = 58, .external_lex_state = 16},
  [3118] = {.lex_state = 58, .external_lex_state = 14},
  [3119] = {.lex_state = 58, .external_lex_state = 14},
  [3120] = {.lex_state = 58, .external_lex_state = 11},
  [3121] = {.lex_state = 58, .external_lex_state = 14},
  [3122] = {.lex_state = 58, .external_lex_state = 13},
  [3123] = {.lex_state = 58, .external_lex_state = 15},
  [3124] = {.lex_state = 58, .external_lex_state = 16},
  [3125] = {.lex_state = 58, .external_lex_state = 14},
  [3126] = {.lex_state = 58, .external_lex_state = 15},
  [3127] = {.lex_state = 35, .external_lex_state = 13},
  [3128] = {.lex_state = 58, .external_lex_state = 13},
  [3129] = {.lex_state = 58, .external_lex_state = 13},
  [3130] = {.lex_state = 35, .external_lex_state = 13},
  [3131] = {.lex_state = 35, .external_lex_state = 13},
  [3132] = {.lex_state = 58, .external_lex_state = 12},
  [3133] = {.lex_state = 58, .external_lex_state = 15},
  [3134] = {.lex_state = 58, .external_lex_state = 16},
  [3135] = {.lex_state = 58, .external_lex_state = 13},
  [3136] = {.lex_state = 58, .external_lex_state = 16},
  [3137] = {.lex_state = 58, .external_lex_state = 14},
  [3138] = {.lex_state = 58, .external_lex_state = 16},
  [3139] = {.lex_state = 58, .external_lex_state = 13},
  [3140] = {.lex_state = 58, .external_lex_state = 13},
  [3141] = {.lex_state = 58, .external_lex_state = 11},
  [3142] = {.lex_state = 58, .external_lex_state = 14},
  [3143] = {.lex_state = 58, .external_lex_state = 15},
  [3144] = {.lex_state = 58, .external_lex_state = 15},
  [3145] = {.lex_state = 58, .external_lex_state = 15},
  [3146] = {.lex_state = 58, .external_lex_state = 14},
  [3147] = {.lex_state = 58, .external_lex_state = 13},
  [3148] = {.lex_state = 58, .external_lex_state = 14},
  [3149] = {.lex_state = 58, .external_lex_state = 13},
  [3150] = {.lex_state = 58, .external_lex_state = 15},
  [3151] = {.lex_state = 58, .external_lex_state = 13},
  [3152] = {.lex_state = 58, .external_lex_state = 11},
  [3153] = {.lex_state = 58, .external_lex_state = 14},
  [3154] = {.lex_state = 58, .external_lex_state = 14},
  [3155] = {.lex_state = 35, .external_lex_state = 13},
  [3156] = {.lex_state = 58, .external_lex_state = 14},
  [3157] = {.lex_state = 58, .external_lex_state = 14},
  [3158] = {.lex_state = 35, .external_lex_state = 13},
  [3159] = {.lex_state = 58, .external_lex_state = 14},
  [3160] = {.lex_state = 58, .external_lex_state = 16},
  [3161] = {.lex_state = 58, .external_lex_state = 13},
  [3162] = {.lex_state = 58, .external_lex_state = 14},
  [3163] = {.lex_state = 58, .external_lex_state = 13},
  [3164] = {.lex_state = 58, .external_lex_state = 13},
  [3165] = {.lex_state = 58, .external_lex_state = 12},
  [3166] = {.lex_state = 58, .external_lex_state = 15},
  [3167] = {.lex_state = 58, .external_lex_state = 13},
  [3168] = {.lex_state = 58, .external_lex_state = 15},
  [3169] = {.lex_state = 58, .external_lex_state = 13},
  [3170] = {.lex_state = 58, .external_lex_state = 13},
  [3171] = {.lex_state = 58, .external_lex_state = 22},
  [3172] = {.lex_state = 58, .external_lex_state = 22},
  [3173] = {.lex_state = 58, .external_lex_state = 14},
  [3174] = {.lex_state = 58, .external_lex_state = 14},
  [3175] = {.lex_state = 58, .external_lex_state = 22},
  [3176] = {.lex_state = 58, .external_lex_state = 12},
  [3177] = {.lex_state = 58, .external_lex_state = 12},
  [3178] = {.lex_state = 58, .external_lex_state = 14},
  [3179] = {.lex_state = 58, .external_lex_state = 22},
  [3180] = {.lex_state = 58, .external_lex_state = 13},
  [3181] = {.lex_state = 36, .external_lex_state = 13},
  [3182] = {.lex_state = 58, .external_lex_state = 14},
  [3183] = {.lex_state = 58, .external_lex_state = 22},
  [3184] = {.lex_state = 30, .external_lex_state = 13},
  [3185] = {.lex_state = 30, .external_lex_state = 13},
  [3186] = {.lex_state = 58, .external_lex_state = 15},
  [3187] = {.lex_state = 58, .external_lex_state = 14},
  [3188] = {.lex_state = 58, .external_lex_state = 13},
  [3189] = {.lex_state = 58, .external_lex_state = 14},
  [3190] = {.lex_state = 58, .external_lex_state = 13},
  [3191] = {.lex_state = 58, .external_lex_state = 12},
  [3192] = {.lex_state = 58, .external_lex_state = 15},
  [3193] = {.lex_state = 58, .external_lex_state = 12},
  [3194] = {.lex_state = 58, .external_lex_state = 12},
  [3195] = {.lex_state = 58, .external_lex_state = 13},
  [3196] = {.lex_state = 58, .external_lex_state = 12},
  [3197] = {.lex_state = 58, .external_lex_state = 13},
  [3198] = {.lex_state = 58, .external_lex_state = 22},
  [3199] = {.lex_state = 58, .external_lex_state = 13},
  [3200] = {.lex_state = 58, .external_lex_state = 13},
  [3201] = {.lex_state = 30, .external_lex_state = 13},
  [3202] = {.lex_state = 58, .external_lex_state = 13},
  [3203] = {.lex_state = 58, .external_lex_state = 14},
  [3204] = {.lex_state = 58, .external_lex_state = 15},
  [3205] = {.lex_state = 58, .external_lex_state = 13},
  [3206] = {.lex_state = 58, .external_lex_state = 14},
  [3207] = {.lex_state = 58, .external_lex_state = 12},
  [3208] = {.lex_state = 58, .external_lex_state = 12},
  [3209] = {.lex_state = 58, .external_lex_state = 13},
  [3210] = {.lex_state = 58, .external_lex_state = 13},
  [3211] = {.lex_state = 58, .external_lex_state = 14},
  [3212] = {.lex_state = 58, .external_lex_state = 13},
  [3213] = {.lex_state = 58, .external_lex_state = 13},
  [3214] = {.lex_state = 58, .external_lex_state = 13},
  [3215] = {.lex_state = 58, .external_lex_state = 13},
  [3216] = {.lex_state = 58, .external_lex_state = 13},
  [3217] = {.lex_state = 58, .external_lex_state = 13},
  [3218] = {.lex_state = 58, .external_lex_state = 14},
  [3219] = {.lex_state = 58, .external_lex_state = 13},
  [3220] = {.lex_state = 58, .external_lex_state = 13},
  [3221] = {.lex_state = 58, .external_lex_state = 12},
  [3222] = {.lex_state = 58, .external_lex_state = 12},
  [3223] = {.lex_state = 58, .external_lex_state = 13},
  [3224] = {.lex_state = 58, .external_lex_state = 12},
  [3225] = {.lex_state = 58, .external_lex_state = 15},
  [3226] = {.lex_state = 58, .external_lex_state = 14},
  [3227] = {.lex_state = 58, .external_lex_state = 15},
  [3228] = {.lex_state = 58, .external_lex_state = 14},
  [3229] = {.lex_state = 58, .external_lex_state = 12},
  [3230] = {.lex_state = 58, .external_lex_state = 13},
  [3231] = {.lex_state = 58, .external_lex_state = 12},
  [3232] = {.lex_state = 58, .external_lex_state = 12},
  [3233] = {.lex_state = 58, .external_lex_state = 14},
  [3234] = {.lex_state = 58, .external_lex_state = 22},
  [3235] = {.lex_state = 58, .external_lex_state = 12},
  [3236] = {.lex_state = 30, .external_lex_state = 13},
  [3237] = {.lex_state = 58, .external_lex_state = 15},
  [3238] = {.lex_state = 58, .external_lex_state = 13},
  [3239] = {.lex_state = 30, .external_lex_state = 13},
  [3240] = {.lex_state = 58, .external_lex_state = 13},
  [3241] = {.lex_state = 58, .external_lex_state = 13},
  [3242] = {.lex_state = 58, .external_lex_state = 14},
  [3243] = {.lex_state = 58, .external_lex_state = 22},
  [3244] = {.lex_state = 58, .external_lex_state = 13},
  [3245] = {.lex_state = 58, .external_lex_state = 13},
  [3246] = {.lex_state = 58, .external_lex_state = 15},
  [3247] = {.lex_state = 58, .external_lex_state = 12},
  [3248] = {.lex_state = 58, .external_lex_state = 13},
  [3249] = {.lex_state = 58, .external_lex_state = 14},
  [3250] = {.lex_state = 58, .external_lex_state = 12},
  [3251] = {.lex_state = 58, .external_lex_state = 13},
  [3252] = {.lex_state = 58, .external_lex_state = 22},
  [3253] = {.lex_state = 58, .external_lex_state = 13},
  [3254] = {.lex_state = 58, .external_lex_state = 13},
  [3255] = {.lex_state = 58, .external_lex_state = 13},
  [3256] = {.lex_state = 58, .external_lex_state = 13},
  [3257] = {.lex_state = 58, .external_lex_state = 14},
  [3258] = {.lex_state = 58, .external_lex_state = 15},
  [3259] = {.lex_state = 58, .external_lex_state = 22},
  [3260] = {.lex_state = 58, .external_lex_state = 13},
  [3261] = {.lex_state = 58, .external_lex_state = 12},
  [3262] = {.lex_state = 58, .external_lex_state = 12},
  [3263] = {.lex_state = 58, .external_lex_state = 12},
  [3264] = {.lex_state = 58, .external_lex_state = 13},
  [3265] = {.lex_state = 58, .external_lex_state = 14},
  [3266] = {.lex_state = 58, .external_lex_state = 13},
  [3267] = {.lex_state = 58, .external_lex_state = 12},
  [3268] = {.lex_state = 58, .external_lex_state = 13},
  [3269] = {.lex_state = 58, .external_lex_state = 15},
  [3270] = {.lex_state = 58, .external_lex_state = 15},
  [3271] = {.lex_state = 58, .external_lex_state = 13},
  [3272] = {.lex_state = 58, .external_lex_state = 13},
  [3273] = {.lex_state = 58, .external_lex_state = 13},
  [3274] = {.lex_state = 58, .external_lex_state = 13},
  [3275] = {.lex_state = 58, .external_lex_state = 22},
  [3276] = {.lex_state = 58, .external_lex_state = 13},
  [3277] = {.lex_state = 58, .external_lex_state = 12},
  [3278] = {.lex_state = 58, .external_lex_state = 14},
  [3279] = {.lex_state = 58, .external_lex_state = 12},
  [3280] = {.lex_state = 58, .external_lex_state = 12},
  [3281] = {.lex_state = 58, .external_lex_state = 14},
  [3282] = {.lex_state = 58, .external_lex_state = 12},
  [3283] = {.lex_state = 58, .external_lex_state = 12},
  [3284] = {.lex_state = 58, .external_lex_state = 14},
  [3285] = {.lex_state = 58, .external_lex_state = 12},
  [3286] = {.lex_state = 30, .external_lex_state = 13},
  [3287] = {.lex_state = 58, .external_lex_state = 12},
  [3288] = {.lex_state = 58, .external_lex_state = 13},
  [3289] = {.lex_state = 58, .external_lex_state = 15},
  [3290] = {.lex_state = 58, .external_lex_state = 13},
  [3291] = {.lex_state = 58, .external_lex_state = 14},
  [3292] = {.lex_state = 58, .external_lex_state = 13},
  [3293] = {.lex_state = 58, .external_lex_state = 14},
  [3294] = {.lex_state = 58, .external_lex_state = 13},
  [3295] = {.lex_state = 58, .external_lex_state = 13},
  [3296] = {.lex_state = 58, .external_lex_state = 22},
  [3297] = {.lex_state = 58, .external_lex_state = 13},
  [3298] = {.lex_state = 58, .external_lex_state = 13},
  [3299] = {.lex_state = 58, .external_lex_state = 13},
  [3300] = {.lex_state = 58, .external_lex_state = 13},
  [3301] = {.lex_state = 58, .external_lex_state = 13},
  [3302] = {.lex_state = 58, .external_lex_state = 12},
  [3303] = {.lex_state = 58, .external_lex_state = 13},
  [3304] = {.lex_state = 58, .external_lex_state = 22},
  [3305] = {.lex_state = 58, .external_lex_state = 12},
  [3306] = {.lex_state = 30, .external_lex_state = 13},
  [3307] = {.lex_state = 58, .external_lex_state = 14},
  [3308] = {.lex_state = 58, .external_lex_state = 13},
  [3309] = {.lex_state = 58, .external_lex_state = 13},
  [3310] = {.lex_state = 58, .external_lex_state = 13},
  [3311] = {.lex_state = 58, .external_lex_state = 13},
  [3312] = {.lex_state = 58, .external_lex_state = 13},
  [3313] = {.lex_state = 58, .external_lex_state = 15},
  [3314] = {.lex_state = 58, .external_lex_state = 13},
  [3315] = {.lex_state = 58, .external_lex_state = 14},
  [3316] = {.lex_state = 37, .external_lex_state = 13},
  [3317] = {.lex_state = 58, .external_lex_state = 13},
  [3318] = {.lex_state = 58, .external_lex_state = 13},
  [3319] = {.lex_state = 58, .external_lex_state = 12},
  [3320] = {.lex_state = 58, .external_lex_state = 12},
  [3321] = {.lex_state = 58, .external_lex_state = 13},
  [3322] = {.lex_state = 58, .external_lex_state = 14},
  [3323] = {.lex_state = 58, .external_lex_state = 15},
  [3324] = {.lex_state = 58, .external_lex_state = 13},
  [3325] = {.lex_state = 58, .external_lex_state = 13},
  [3326] = {.lex_state = 58, .external_lex_state = 13},
  [3327] = {.lex_state = 58, .external_lex_state = 13},
  [3328] = {.lex_state = 58, .external_lex_state = 13},
  [3329] = {.lex_state = 58, .external_lex_state = 13},
  [3330] = {.lex_state = 58, .external_lex_state = 15},
  [3331] = {.lex_state = 58, .external_lex_state = 22},
  [3332] = {.lex_state = 58, .external_lex_state = 12},
  [3333] = {.lex_state = 58, .external_lex_state = 15},
  [3334] = {.lex_state = 58, .external_lex_state = 13},
  [3335] = {.lex_state = 58, .external_lex_state = 13},
  [3336] = {.lex_state = 58, .external_lex_state = 12},
  [3337] = {.lex_state = 58, .external_lex_state = 13},
  [3338] = {.lex_state = 58, .external_lex_state = 13},
  [3339] = {.lex_state = 58, .external_lex_state = 13},
  [3340] = {.lex_state = 58, .external_lex_state = 12},
  [3341] = {.lex_state = 37, .external_lex_state = 13},
  [3342] = {.lex_state = 58, .external_lex_state = 13},
  [3343] = {.lex_state = 58, .external_lex_state = 13},
  [3344] = {.lex_state = 58, .external_lex_state = 13},
  [3345] = {.lex_state = 58, .external_lex_state = 13},
  [3346] = {.lex_state = 58, .external_lex_state = 13},
  [3347] = {.lex_state = 58, .external_lex_state = 13},
  [3348] = {.lex_state = 58, .external_lex_state = 13},
  [3349] = {.lex_state = 58, .external_lex_state = 13},
  [3350] = {.lex_state = 58, .external_lex_state = 13},
  [3351] = {.lex_state = 58, .external_lex_state = 13},
  [3352] = {.lex_state = 58, .external_lex_state = 13},
  [3353] = {.lex_state = 58, .external_lex_state = 13},
  [3354] = {.lex_state = 58, .external_lex_state = 13},
  [3355] = {.lex_state = 58, .external_lex_state = 13},
  [3356] = {.lex_state = 58, .external_lex_state = 15},
  [3357] = {.lex_state = 58, .external_lex_state = 14},
  [3358] = {.lex_state = 58, .external_lex_state = 13},
  [3359] = {.lex_state = 58, .external_lex_state = 13},
  [3360] = {.lex_state = 58, .external_lex_state = 13},
  [3361] = {.lex_state = 58, .external_lex_state = 13},
  [3362] = {.lex_state = 58, .external_lex_state = 13},
  [3363] = {.lex_state = 58, .external_lex_state = 13},
  [3364] = {.lex_state = 58, .external_lex_state = 13},
  [3365] = {.lex_state = 58, .external_lex_state = 13},
  [3366] = {.lex_state = 58, .external_lex_state = 14},
  [3367] = {.lex_state = 58, .external_lex_state = 13},
  [3368] = {.lex_state = 58, .external_lex_state = 13},
  [3369] = {.lex_state = 58, .external_lex_state = 13},
  [3370] = {.lex_state = 58, .external_lex_state = 13},
  [3371] = {.lex_state = 58, .external_lex_state = 13},
  [3372] = {.lex_state = 58, .external_lex_state = 13},
  [3373] = {.lex_state = 58, .external_lex_state = 13},
  [3374] = {.lex_state = 58, .external_lex_state = 13},
  [3375] = {.lex_state = 58, .external_lex_state = 13},
  [3376] = {.lex_state = 58, .external_lex_state = 13},
  [3377] = {.lex_state = 58, .external_lex_state = 13},
  [3378] = {.lex_state = 58, .external_lex_state = 13},
  [3379] = {.lex_state = 58, .external_lex_state = 13},
  [3380] = {.lex_state = 37, .external_lex_state = 13},
  [3381] = {.lex_state = 58, .external_lex_state = 13},
  [3382] = {.lex_state = 58, .external_lex_state = 13},
  [3383] = {.lex_state = 58, .external_lex_state = 13},
  [3384] = {.lex_state = 58, .external_lex_state = 13},
  [3385] = {.lex_state = 37, .external_lex_state = 13},
  [3386] = {.lex_state = 58, .external_lex_state = 13},
  [3387] = {.lex_state = 58, .external_lex_state = 13},
  [3388] = {.lex_state = 58, .external_lex_state = 22},
  [3389] = {.lex_state = 58, .external_lex_state = 22},
  [3390] = {.lex_state = 58, .external_lex_state = 14},
  [3391] = {.lex_state = 58, .external_lex_state = 13},
  [3392] = {.lex_state = 58, .external_lex_state = 13},
  [3393] = {.lex_state = 58, .external_lex_state = 13},
  [3394] = {.lex_state = 58, .external_lex_state = 15},
  [3395] = {.lex_state = 58, .external_lex_state = 12},
  [3396] = {.lex_state = 58, .external_lex_state = 12},
  [3397] = {.lex_state = 58, .external_lex_state = 12},
  [3398] = {.lex_state = 58, .external_lex_state = 12},
  [3399] = {.lex_state = 58, .external_lex_state = 15},
  [3400] = {.lex_state = 58, .external_lex_state = 12},
  [3401] = {.lex_state = 58, .external_lex_state = 13},
  [3402] = {.lex_state = 58, .external_lex_state = 12},
  [3403] = {.lex_state = 58, .external_lex_state = 15},
  [3404] = {.lex_state = 58, .external_lex_state = 13},
  [3405] = {.lex_state = 58, .external_lex_state = 13},
  [3406] = {.lex_state = 58, .external_lex_state = 14},
  [3407] = {.lex_state = 58, .external_lex_state = 13},
  [3408] = {.lex_state = 58, .external_lex_state = 13},
  [3409] = {.lex_state = 58, .external_lex_state = 14},
  [3410] = {.lex_state = 58, .external_lex_state = 13},
  [3411] = {.lex_state = 58, .external_lex_state = 14},
  [3412] = {.lex_state = 58, .external_lex_state = 13},
  [3413] = {.lex_state = 58, .external_lex_state = 12},
  [3414] = {.lex_state = 58, .external_lex_state = 14},
  [3415] = {.lex_state = 58, .external_lex_state = 13},
  [3416] = {.lex_state = 58, .external_lex_state = 13},
  [3417] = {.lex_state = 58, .external_lex_state = 13},
  [3418] = {.lex_state = 58, .external_lex_state = 13},
  [3419] = {.lex_state = 58, .external_lex_state = 13},
  [3420] = {.lex_state = 58, .external_lex_state = 13},
  [3421] = {.lex_state = 58, .external_lex_state = 13},
  [3422] = {.lex_state = 58, .external_lex_state = 12},
  [3423] = {.lex_state = 58, .external_lex_state = 13},
  [3424] = {.lex_state = 58, .external_lex_state = 13},
  [3425] = {.lex_state = 58, .external_lex_state = 12},
  [3426] = {.lex_state = 58, .external_lex_state = 15},
  [3427] = {.lex_state = 30, .external_lex_state = 13},
  [3428] = {.lex_state = 58, .external_lex_state = 12},
  [3429] = {.lex_state = 58, .external_lex_state = 15},
  [3430] = {.lex_state = 58, .external_lex_state = 13},
  [3431] = {.lex_state = 58, .external_lex_state = 13},
  [3432] = {.lex_state = 58, .external_lex_state = 13},
  [3433] = {.lex_state = 58, .external_lex_state = 13},
  [3434] = {.lex_state = 58, .external_lex_state = 13},
  [3435] = {.lex_state = 58, .external_lex_state = 14},
  [3436] = {.lex_state = 58, .external_lex_state = 13},
  [3437] = {.lex_state = 58, .external_lex_state = 13},
  [3438] = {.lex_state = 58, .external_lex_state = 13},
  [3439] = {.lex_state = 58, .external_lex_state = 13},
  [3440] = {.lex_state = 58, .external_lex_state = 13},
  [3441] = {.lex_state = 58, .external_lex_state = 13},
  [3442] = {.lex_state = 58, .external_lex_state = 13},
  [3443] = {.lex_state = 58, .external_lex_state = 13},
  [3444] = {.lex_state = 58, .external_lex_state = 13},
  [3445] = {.lex_state = 58, .external_lex_state = 13},
  [3446] = {.lex_state = 58, .external_lex_state = 13},
  [3447] = {.lex_state = 58, .external_lex_state = 12},
  [3448] = {.lex_state = 58, .external_lex_state = 13},
  [3449] = {.lex_state = 58, .external_lex_state = 13},
  [3450] = {.lex_state = 58, .external_lex_state = 13},
  [3451] = {.lex_state = 58, .external_lex_state = 13},
  [3452] = {.lex_state = 58, .external_lex_state = 13},
  [3453] = {.lex_state = 58, .external_lex_state = 13},
  [3454] = {.lex_state = 58, .external_lex_state = 13},
  [3455] = {.lex_state = 58, .external_lex_state = 14},
  [3456] = {.lex_state = 30, .external_lex_state = 13},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_from] = ACTIONS(1),
    [anon_sym___future__] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_print] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_assert] = ACTIONS(1),
    [anon_sym_COLON_EQ] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_del] = ACTIONS(1),
    [anon_sym_raise] = ACTIONS(1),
    [anon_sym_pass] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_elif] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_match] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_async] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_except] = ACTIONS(1),
    [anon_sym_except_STAR] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_def] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_global] = ACTIONS(1),
    [anon_sym_nonlocal] = ACTIONS(1),
    [anon_sym_exec] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym__] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_not] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_SLASH_SLASH] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_LT_GT] = ACTIONS(1),
    [anon_sym_is] = ACTIONS(1),
    [anon_sym_lambda] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_AT_EQ] = ACTIONS(1),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [sym_ellipsis] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [sym__not_escape_sequence] = ACTIONS(1),
    [sym_type_conversion] = ACTIONS(1),
    [sym_integer] = ACTIONS(1),
    [sym_float] = ACTIONS(1),
    [anon_sym_await] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_none] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(5),
    [anon_sym_configfile] = ACTIONS(1),
    [anon_sym_container] = ACTIONS(1),
    [anon_sym_envvars] = ACTIONS(1),
    [anon_sym_include] = ACTIONS(1),
    [anon_sym_pepfile] = ACTIONS(1),
    [anon_sym_pepschema] = ACTIONS(1),
    [anon_sym_scattergather] = ACTIONS(1),
    [anon_sym_version] = ACTIONS(1),
    [anon_sym_wildcard_constraints] = ACTIONS(1),
    [anon_sym_workdir] = ACTIONS(1),
    [anon_sym_onerror] = ACTIONS(1),
    [anon_sym_onstart] = ACTIONS(1),
    [anon_sym_onsuccess] = ACTIONS(1),
    [anon_sym_localrules] = ACTIONS(1),
    [anon_sym_ruleorder] = ACTIONS(1),
    [anon_sym_rule] = ACTIONS(1),
    [anon_sym_checkpoint] = ACTIONS(1),
    [anon_sym_use] = ACTIONS(1),
    [anon_sym_exclude] = ACTIONS(1),
    [anon_sym_benchmark] = ACTIONS(1),
    [anon_sym_input] = ACTIONS(1),
    [anon_sym_log] = ACTIONS(1),
    [anon_sym_output] = ACTIONS(1),
    [anon_sym_message] = ACTIONS(1),
    [anon_sym_notebook] = ACTIONS(1),
    [anon_sym_script] = ACTIONS(1),
    [anon_sym_shell] = ACTIONS(1),
    [anon_sym_cache] = ACTIONS(1),
    [anon_sym_conda] = ACTIONS(1),
    [anon_sym_cwl] = ACTIONS(1),
    [anon_sym_default_target] = ACTIONS(1),
    [anon_sym_envmodules] = ACTIONS(1),
    [anon_sym_group] = ACTIONS(1),
    [anon_sym_handover] = ACTIONS(1),
    [anon_sym_localrule] = ACTIONS(1),
    [anon_sym_params] = ACTIONS(1),
    [anon_sym_priority] = ACTIONS(1),
    [anon_sym_resources] = ACTIONS(1),
    [anon_sym_retries] = ACTIONS(1),
    [anon_sym_shadow] = ACTIONS(1),
    [anon_sym_singularity] = ACTIONS(1),
    [anon_sym_template_engine] = ACTIONS(1),
    [anon_sym_threads] = ACTIONS(1),
    [anon_sym_wrapper] = ACTIONS(1),
    [anon_sym_run] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_config] = ACTIONS(1),
    [anon_sym_meta_wrapper] = ACTIONS(1),
    [anon_sym_prefix] = ACTIONS(1),
    [anon_sym_skip_validation] = ACTIONS(1),
    [anon_sym_snakefile] = ACTIONS(1),
    [anon_sym_q] = ACTIONS(1),
    [sym__newline] = ACTIONS(1),
    [sym__indent] = ACTIONS(1),
    [sym__dedent] = ACTIONS(1),
    [sym_string_start] = ACTIONS(1),
    [sym__string_content] = ACTIONS(1),
    [sym_escape_interpolation] = ACTIONS(1),
    [sym_string_end] = ACTIONS(1),
    [sym__ALLOW_WC_DEF] = ACTIONS(1),
    [sym__ALLOW_WC_INTERP] = ACTIONS(1),
    [sym__DISALLOW_WC] = ACTIONS(1),
    [sym__WILDCARD_DEF_OPEN] = ACTIONS(1),
    [sym__WILDCARD_INTERP_OPEN] = ACTIONS(1),
  },
  [1] = {
    [sym_module] = STATE(3430),
    [sym__statement] = STATE(68),
    [sym__simple_statements] = STATE(68),
    [sym_import_statement] = STATE(2679),
    [sym_future_import_statement] = STATE(2679),
    [sym_import_from_statement] = STATE(2679),
    [sym_print_statement] = STATE(2679),
    [sym_assert_statement] = STATE(2679),
    [sym_expression_statement] = STATE(2679),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2679),
    [sym_delete_statement] = STATE(2679),
    [sym_raise_statement] = STATE(2679),
    [sym_pass_statement] = STATE(2679),
    [sym_break_statement] = STATE(2679),
    [sym_continue_statement] = STATE(2679),
    [sym_if_statement] = STATE(68),
    [sym_match_statement] = STATE(68),
    [sym_for_statement] = STATE(68),
    [sym_while_statement] = STATE(68),
    [sym_try_statement] = STATE(68),
    [sym_with_statement] = STATE(68),
    [sym_function_definition] = STATE(68),
    [sym_global_statement] = STATE(2679),
    [sym_nonlocal_statement] = STATE(2679),
    [sym_exec_statement] = STATE(2679),
    [sym_type_alias_statement] = STATE(2679),
    [sym_class_definition] = STATE(68),
    [sym_decorated_definition] = STATE(68),
    [sym_decorator] = STATE(2187),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(387),
    [sym__simple_directive_block] = STATE(513),
    [sym_localrules_directive] = STATE(68),
    [sym_ruleorder_directive] = STATE(68),
    [sym__compound_directive] = STATE(68),
    [sym_rule_definition] = STATE(68),
    [sym_checkpoint_definition] = STATE(68),
    [sym_rule_import] = STATE(68),
    [sym_rule_inheritance] = STATE(68),
    [sym_module_definition] = STATE(68),
    [aux_sym_module_repeat1] = STATE(68),
    [aux_sym_decorated_definition_repeat1] = STATE(2187),
    [ts_builtin_sym_end] = ACTIONS(7),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(35),
    [anon_sym_match] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_def] = ACTIONS(49),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(81),
    [anon_sym_container] = ACTIONS(81),
    [anon_sym_envvars] = ACTIONS(81),
    [anon_sym_include] = ACTIONS(81),
    [anon_sym_pepfile] = ACTIONS(81),
    [anon_sym_pepschema] = ACTIONS(81),
    [anon_sym_scattergather] = ACTIONS(81),
    [anon_sym_version] = ACTIONS(81),
    [anon_sym_wildcard_constraints] = ACTIONS(81),
    [anon_sym_workdir] = ACTIONS(81),
    [anon_sym_onerror] = ACTIONS(83),
    [anon_sym_onstart] = ACTIONS(83),
    [anon_sym_onsuccess] = ACTIONS(83),
    [anon_sym_localrules] = ACTIONS(85),
    [anon_sym_ruleorder] = ACTIONS(87),
    [anon_sym_rule] = ACTIONS(89),
    [anon_sym_checkpoint] = ACTIONS(91),
    [anon_sym_use] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(95),
    [sym_string_start] = ACTIONS(97),
  },
  [2] = {
    [sym__statement] = STATE(73),
    [sym__simple_statements] = STATE(73),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(73),
    [sym_match_statement] = STATE(73),
    [sym_for_statement] = STATE(73),
    [sym_while_statement] = STATE(73),
    [sym_try_statement] = STATE(73),
    [sym_with_statement] = STATE(73),
    [sym_function_definition] = STATE(73),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(73),
    [sym_decorated_definition] = STATE(73),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(324),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(73),
    [sym_ruleorder_directive] = STATE(73),
    [sym__compound_directive] = STATE(73),
    [sym_rule_definition] = STATE(73),
    [sym_checkpoint_definition] = STATE(73),
    [sym_rule_import] = STATE(73),
    [sym_rule_inheritance] = STATE(73),
    [sym_module_definition] = STATE(73),
    [aux_sym_module_repeat1] = STATE(73),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(133),
    [sym_string_start] = ACTIONS(97),
  },
  [3] = {
    [sym__statement] = STATE(72),
    [sym__simple_statements] = STATE(72),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(72),
    [sym_match_statement] = STATE(72),
    [sym_for_statement] = STATE(72),
    [sym_while_statement] = STATE(72),
    [sym_try_statement] = STATE(72),
    [sym_with_statement] = STATE(72),
    [sym_function_definition] = STATE(72),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(72),
    [sym_decorated_definition] = STATE(72),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(308),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(72),
    [sym_ruleorder_directive] = STATE(72),
    [sym__compound_directive] = STATE(72),
    [sym_rule_definition] = STATE(72),
    [sym_checkpoint_definition] = STATE(72),
    [sym_rule_import] = STATE(72),
    [sym_rule_inheritance] = STATE(72),
    [sym_module_definition] = STATE(72),
    [aux_sym_module_repeat1] = STATE(72),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(135),
    [sym_string_start] = ACTIONS(97),
  },
  [4] = {
    [sym__statement] = STATE(73),
    [sym__simple_statements] = STATE(73),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(73),
    [sym_match_statement] = STATE(73),
    [sym_for_statement] = STATE(73),
    [sym_while_statement] = STATE(73),
    [sym_try_statement] = STATE(73),
    [sym_with_statement] = STATE(73),
    [sym_function_definition] = STATE(73),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(73),
    [sym_decorated_definition] = STATE(73),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(472),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(73),
    [sym_ruleorder_directive] = STATE(73),
    [sym__compound_directive] = STATE(73),
    [sym_rule_definition] = STATE(73),
    [sym_checkpoint_definition] = STATE(73),
    [sym_rule_import] = STATE(73),
    [sym_rule_inheritance] = STATE(73),
    [sym_module_definition] = STATE(73),
    [aux_sym_module_repeat1] = STATE(73),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(133),
    [sym_string_start] = ACTIONS(97),
  },
  [5] = {
    [sym__statement] = STATE(71),
    [sym__simple_statements] = STATE(71),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(71),
    [sym_match_statement] = STATE(71),
    [sym_for_statement] = STATE(71),
    [sym_while_statement] = STATE(71),
    [sym_try_statement] = STATE(71),
    [sym_with_statement] = STATE(71),
    [sym_function_definition] = STATE(71),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(71),
    [sym_decorated_definition] = STATE(71),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(2202),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(71),
    [sym_ruleorder_directive] = STATE(71),
    [sym__compound_directive] = STATE(71),
    [sym_rule_definition] = STATE(71),
    [sym_checkpoint_definition] = STATE(71),
    [sym_rule_import] = STATE(71),
    [sym_rule_inheritance] = STATE(71),
    [sym_module_definition] = STATE(71),
    [aux_sym_module_repeat1] = STATE(71),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(137),
    [sym_string_start] = ACTIONS(97),
  },
  [6] = {
    [sym__statement] = STATE(72),
    [sym__simple_statements] = STATE(72),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(72),
    [sym_match_statement] = STATE(72),
    [sym_for_statement] = STATE(72),
    [sym_while_statement] = STATE(72),
    [sym_try_statement] = STATE(72),
    [sym_with_statement] = STATE(72),
    [sym_function_definition] = STATE(72),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(72),
    [sym_decorated_definition] = STATE(72),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(432),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(72),
    [sym_ruleorder_directive] = STATE(72),
    [sym__compound_directive] = STATE(72),
    [sym_rule_definition] = STATE(72),
    [sym_checkpoint_definition] = STATE(72),
    [sym_rule_import] = STATE(72),
    [sym_rule_inheritance] = STATE(72),
    [sym_module_definition] = STATE(72),
    [aux_sym_module_repeat1] = STATE(72),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(135),
    [sym_string_start] = ACTIONS(97),
  },
  [7] = {
    [sym__statement] = STATE(73),
    [sym__simple_statements] = STATE(73),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(73),
    [sym_match_statement] = STATE(73),
    [sym_for_statement] = STATE(73),
    [sym_while_statement] = STATE(73),
    [sym_try_statement] = STATE(73),
    [sym_with_statement] = STATE(73),
    [sym_function_definition] = STATE(73),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(73),
    [sym_decorated_definition] = STATE(73),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(409),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(73),
    [sym_ruleorder_directive] = STATE(73),
    [sym__compound_directive] = STATE(73),
    [sym_rule_definition] = STATE(73),
    [sym_checkpoint_definition] = STATE(73),
    [sym_rule_import] = STATE(73),
    [sym_rule_inheritance] = STATE(73),
    [sym_module_definition] = STATE(73),
    [aux_sym_module_repeat1] = STATE(73),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(133),
    [sym_string_start] = ACTIONS(97),
  },
  [8] = {
    [sym__statement] = STATE(74),
    [sym__simple_statements] = STATE(74),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(74),
    [sym_match_statement] = STATE(74),
    [sym_for_statement] = STATE(74),
    [sym_while_statement] = STATE(74),
    [sym_try_statement] = STATE(74),
    [sym_with_statement] = STATE(74),
    [sym_function_definition] = STATE(74),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(74),
    [sym_decorated_definition] = STATE(74),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(287),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(74),
    [sym_ruleorder_directive] = STATE(74),
    [sym__compound_directive] = STATE(74),
    [sym_rule_definition] = STATE(74),
    [sym_checkpoint_definition] = STATE(74),
    [sym_rule_import] = STATE(74),
    [sym_rule_inheritance] = STATE(74),
    [sym_module_definition] = STATE(74),
    [aux_sym_module_repeat1] = STATE(74),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(139),
    [sym_string_start] = ACTIONS(97),
  },
  [9] = {
    [sym__statement] = STATE(72),
    [sym__simple_statements] = STATE(72),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(72),
    [sym_match_statement] = STATE(72),
    [sym_for_statement] = STATE(72),
    [sym_while_statement] = STATE(72),
    [sym_try_statement] = STATE(72),
    [sym_with_statement] = STATE(72),
    [sym_function_definition] = STATE(72),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(72),
    [sym_decorated_definition] = STATE(72),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(341),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(72),
    [sym_ruleorder_directive] = STATE(72),
    [sym__compound_directive] = STATE(72),
    [sym_rule_definition] = STATE(72),
    [sym_checkpoint_definition] = STATE(72),
    [sym_rule_import] = STATE(72),
    [sym_rule_inheritance] = STATE(72),
    [sym_module_definition] = STATE(72),
    [aux_sym_module_repeat1] = STATE(72),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(135),
    [sym_string_start] = ACTIONS(97),
  },
  [10] = {
    [sym__statement] = STATE(73),
    [sym__simple_statements] = STATE(73),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(73),
    [sym_match_statement] = STATE(73),
    [sym_for_statement] = STATE(73),
    [sym_while_statement] = STATE(73),
    [sym_try_statement] = STATE(73),
    [sym_with_statement] = STATE(73),
    [sym_function_definition] = STATE(73),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(73),
    [sym_decorated_definition] = STATE(73),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(405),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(73),
    [sym_ruleorder_directive] = STATE(73),
    [sym__compound_directive] = STATE(73),
    [sym_rule_definition] = STATE(73),
    [sym_checkpoint_definition] = STATE(73),
    [sym_rule_import] = STATE(73),
    [sym_rule_inheritance] = STATE(73),
    [sym_module_definition] = STATE(73),
    [aux_sym_module_repeat1] = STATE(73),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(133),
    [sym_string_start] = ACTIONS(97),
  },
  [11] = {
    [sym__statement] = STATE(73),
    [sym__simple_statements] = STATE(73),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(73),
    [sym_match_statement] = STATE(73),
    [sym_for_statement] = STATE(73),
    [sym_while_statement] = STATE(73),
    [sym_try_statement] = STATE(73),
    [sym_with_statement] = STATE(73),
    [sym_function_definition] = STATE(73),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(73),
    [sym_decorated_definition] = STATE(73),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(402),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(73),
    [sym_ruleorder_directive] = STATE(73),
    [sym__compound_directive] = STATE(73),
    [sym_rule_definition] = STATE(73),
    [sym_checkpoint_definition] = STATE(73),
    [sym_rule_import] = STATE(73),
    [sym_rule_inheritance] = STATE(73),
    [sym_module_definition] = STATE(73),
    [aux_sym_module_repeat1] = STATE(73),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(133),
    [sym_string_start] = ACTIONS(97),
  },
  [12] = {
    [sym__statement] = STATE(66),
    [sym__simple_statements] = STATE(66),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(66),
    [sym_match_statement] = STATE(66),
    [sym_for_statement] = STATE(66),
    [sym_while_statement] = STATE(66),
    [sym_try_statement] = STATE(66),
    [sym_with_statement] = STATE(66),
    [sym_function_definition] = STATE(66),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(66),
    [sym_decorated_definition] = STATE(66),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(3134),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(66),
    [sym_ruleorder_directive] = STATE(66),
    [sym__compound_directive] = STATE(66),
    [sym_rule_definition] = STATE(66),
    [sym_checkpoint_definition] = STATE(66),
    [sym_rule_import] = STATE(66),
    [sym_rule_inheritance] = STATE(66),
    [sym_module_definition] = STATE(66),
    [aux_sym_module_repeat1] = STATE(66),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(141),
    [sym_string_start] = ACTIONS(97),
  },
  [13] = {
    [sym__statement] = STATE(72),
    [sym__simple_statements] = STATE(72),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(72),
    [sym_match_statement] = STATE(72),
    [sym_for_statement] = STATE(72),
    [sym_while_statement] = STATE(72),
    [sym_try_statement] = STATE(72),
    [sym_with_statement] = STATE(72),
    [sym_function_definition] = STATE(72),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(72),
    [sym_decorated_definition] = STATE(72),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(464),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(72),
    [sym_ruleorder_directive] = STATE(72),
    [sym__compound_directive] = STATE(72),
    [sym_rule_definition] = STATE(72),
    [sym_checkpoint_definition] = STATE(72),
    [sym_rule_import] = STATE(72),
    [sym_rule_inheritance] = STATE(72),
    [sym_module_definition] = STATE(72),
    [aux_sym_module_repeat1] = STATE(72),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(135),
    [sym_string_start] = ACTIONS(97),
  },
  [14] = {
    [sym__statement] = STATE(66),
    [sym__simple_statements] = STATE(66),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(66),
    [sym_match_statement] = STATE(66),
    [sym_for_statement] = STATE(66),
    [sym_while_statement] = STATE(66),
    [sym_try_statement] = STATE(66),
    [sym_with_statement] = STATE(66),
    [sym_function_definition] = STATE(66),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(66),
    [sym_decorated_definition] = STATE(66),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(3117),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(66),
    [sym_ruleorder_directive] = STATE(66),
    [sym__compound_directive] = STATE(66),
    [sym_rule_definition] = STATE(66),
    [sym_checkpoint_definition] = STATE(66),
    [sym_rule_import] = STATE(66),
    [sym_rule_inheritance] = STATE(66),
    [sym_module_definition] = STATE(66),
    [aux_sym_module_repeat1] = STATE(66),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(141),
    [sym_string_start] = ACTIONS(97),
  },
  [15] = {
    [sym__statement] = STATE(72),
    [sym__simple_statements] = STATE(72),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(72),
    [sym_match_statement] = STATE(72),
    [sym_for_statement] = STATE(72),
    [sym_while_statement] = STATE(72),
    [sym_try_statement] = STATE(72),
    [sym_with_statement] = STATE(72),
    [sym_function_definition] = STATE(72),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(72),
    [sym_decorated_definition] = STATE(72),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(475),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(72),
    [sym_ruleorder_directive] = STATE(72),
    [sym__compound_directive] = STATE(72),
    [sym_rule_definition] = STATE(72),
    [sym_checkpoint_definition] = STATE(72),
    [sym_rule_import] = STATE(72),
    [sym_rule_inheritance] = STATE(72),
    [sym_module_definition] = STATE(72),
    [aux_sym_module_repeat1] = STATE(72),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(135),
    [sym_string_start] = ACTIONS(97),
  },
  [16] = {
    [sym__statement] = STATE(73),
    [sym__simple_statements] = STATE(73),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(73),
    [sym_match_statement] = STATE(73),
    [sym_for_statement] = STATE(73),
    [sym_while_statement] = STATE(73),
    [sym_try_statement] = STATE(73),
    [sym_with_statement] = STATE(73),
    [sym_function_definition] = STATE(73),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(73),
    [sym_decorated_definition] = STATE(73),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(319),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(73),
    [sym_ruleorder_directive] = STATE(73),
    [sym__compound_directive] = STATE(73),
    [sym_rule_definition] = STATE(73),
    [sym_checkpoint_definition] = STATE(73),
    [sym_rule_import] = STATE(73),
    [sym_rule_inheritance] = STATE(73),
    [sym_module_definition] = STATE(73),
    [aux_sym_module_repeat1] = STATE(73),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(133),
    [sym_string_start] = ACTIONS(97),
  },
  [17] = {
    [sym__statement] = STATE(72),
    [sym__simple_statements] = STATE(72),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(72),
    [sym_match_statement] = STATE(72),
    [sym_for_statement] = STATE(72),
    [sym_while_statement] = STATE(72),
    [sym_try_statement] = STATE(72),
    [sym_with_statement] = STATE(72),
    [sym_function_definition] = STATE(72),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(72),
    [sym_decorated_definition] = STATE(72),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(383),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(72),
    [sym_ruleorder_directive] = STATE(72),
    [sym__compound_directive] = STATE(72),
    [sym_rule_definition] = STATE(72),
    [sym_checkpoint_definition] = STATE(72),
    [sym_rule_import] = STATE(72),
    [sym_rule_inheritance] = STATE(72),
    [sym_module_definition] = STATE(72),
    [aux_sym_module_repeat1] = STATE(72),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(135),
    [sym_string_start] = ACTIONS(97),
  },
  [18] = {
    [sym__statement] = STATE(72),
    [sym__simple_statements] = STATE(72),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(72),
    [sym_match_statement] = STATE(72),
    [sym_for_statement] = STATE(72),
    [sym_while_statement] = STATE(72),
    [sym_try_statement] = STATE(72),
    [sym_with_statement] = STATE(72),
    [sym_function_definition] = STATE(72),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(72),
    [sym_decorated_definition] = STATE(72),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(293),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(72),
    [sym_ruleorder_directive] = STATE(72),
    [sym__compound_directive] = STATE(72),
    [sym_rule_definition] = STATE(72),
    [sym_checkpoint_definition] = STATE(72),
    [sym_rule_import] = STATE(72),
    [sym_rule_inheritance] = STATE(72),
    [sym_module_definition] = STATE(72),
    [aux_sym_module_repeat1] = STATE(72),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(135),
    [sym_string_start] = ACTIONS(97),
  },
  [19] = {
    [sym__statement] = STATE(66),
    [sym__simple_statements] = STATE(66),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(66),
    [sym_match_statement] = STATE(66),
    [sym_for_statement] = STATE(66),
    [sym_while_statement] = STATE(66),
    [sym_try_statement] = STATE(66),
    [sym_with_statement] = STATE(66),
    [sym_function_definition] = STATE(66),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(66),
    [sym_decorated_definition] = STATE(66),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(3116),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(66),
    [sym_ruleorder_directive] = STATE(66),
    [sym__compound_directive] = STATE(66),
    [sym_rule_definition] = STATE(66),
    [sym_checkpoint_definition] = STATE(66),
    [sym_rule_import] = STATE(66),
    [sym_rule_inheritance] = STATE(66),
    [sym_module_definition] = STATE(66),
    [aux_sym_module_repeat1] = STATE(66),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(141),
    [sym_string_start] = ACTIONS(97),
  },
  [20] = {
    [sym__statement] = STATE(72),
    [sym__simple_statements] = STATE(72),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(72),
    [sym_match_statement] = STATE(72),
    [sym_for_statement] = STATE(72),
    [sym_while_statement] = STATE(72),
    [sym_try_statement] = STATE(72),
    [sym_with_statement] = STATE(72),
    [sym_function_definition] = STATE(72),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(72),
    [sym_decorated_definition] = STATE(72),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(424),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(72),
    [sym_ruleorder_directive] = STATE(72),
    [sym__compound_directive] = STATE(72),
    [sym_rule_definition] = STATE(72),
    [sym_checkpoint_definition] = STATE(72),
    [sym_rule_import] = STATE(72),
    [sym_rule_inheritance] = STATE(72),
    [sym_module_definition] = STATE(72),
    [aux_sym_module_repeat1] = STATE(72),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(135),
    [sym_string_start] = ACTIONS(97),
  },
  [21] = {
    [sym__statement] = STATE(72),
    [sym__simple_statements] = STATE(72),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(72),
    [sym_match_statement] = STATE(72),
    [sym_for_statement] = STATE(72),
    [sym_while_statement] = STATE(72),
    [sym_try_statement] = STATE(72),
    [sym_with_statement] = STATE(72),
    [sym_function_definition] = STATE(72),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(72),
    [sym_decorated_definition] = STATE(72),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(216),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(72),
    [sym_ruleorder_directive] = STATE(72),
    [sym__compound_directive] = STATE(72),
    [sym_rule_definition] = STATE(72),
    [sym_checkpoint_definition] = STATE(72),
    [sym_rule_import] = STATE(72),
    [sym_rule_inheritance] = STATE(72),
    [sym_module_definition] = STATE(72),
    [aux_sym_module_repeat1] = STATE(72),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(135),
    [sym_string_start] = ACTIONS(97),
  },
  [22] = {
    [sym__statement] = STATE(65),
    [sym__simple_statements] = STATE(65),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(65),
    [sym_match_statement] = STATE(65),
    [sym_for_statement] = STATE(65),
    [sym_while_statement] = STATE(65),
    [sym_try_statement] = STATE(65),
    [sym_with_statement] = STATE(65),
    [sym_function_definition] = STATE(65),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(65),
    [sym_decorated_definition] = STATE(65),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(282),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(65),
    [sym_ruleorder_directive] = STATE(65),
    [sym__compound_directive] = STATE(65),
    [sym_rule_definition] = STATE(65),
    [sym_checkpoint_definition] = STATE(65),
    [sym_rule_import] = STATE(65),
    [sym_rule_inheritance] = STATE(65),
    [sym_module_definition] = STATE(65),
    [aux_sym_module_repeat1] = STATE(65),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(143),
    [sym_string_start] = ACTIONS(97),
  },
  [23] = {
    [sym__statement] = STATE(75),
    [sym__simple_statements] = STATE(75),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(75),
    [sym_match_statement] = STATE(75),
    [sym_for_statement] = STATE(75),
    [sym_while_statement] = STATE(75),
    [sym_try_statement] = STATE(75),
    [sym_with_statement] = STATE(75),
    [sym_function_definition] = STATE(75),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(75),
    [sym_decorated_definition] = STATE(75),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(281),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(75),
    [sym_ruleorder_directive] = STATE(75),
    [sym__compound_directive] = STATE(75),
    [sym_rule_definition] = STATE(75),
    [sym_checkpoint_definition] = STATE(75),
    [sym_rule_import] = STATE(75),
    [sym_rule_inheritance] = STATE(75),
    [sym_module_definition] = STATE(75),
    [aux_sym_module_repeat1] = STATE(75),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(145),
    [sym_string_start] = ACTIONS(97),
  },
  [24] = {
    [sym__statement] = STATE(72),
    [sym__simple_statements] = STATE(72),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(72),
    [sym_match_statement] = STATE(72),
    [sym_for_statement] = STATE(72),
    [sym_while_statement] = STATE(72),
    [sym_try_statement] = STATE(72),
    [sym_with_statement] = STATE(72),
    [sym_function_definition] = STATE(72),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(72),
    [sym_decorated_definition] = STATE(72),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(359),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(72),
    [sym_ruleorder_directive] = STATE(72),
    [sym__compound_directive] = STATE(72),
    [sym_rule_definition] = STATE(72),
    [sym_checkpoint_definition] = STATE(72),
    [sym_rule_import] = STATE(72),
    [sym_rule_inheritance] = STATE(72),
    [sym_module_definition] = STATE(72),
    [aux_sym_module_repeat1] = STATE(72),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(135),
    [sym_string_start] = ACTIONS(97),
  },
  [25] = {
    [sym__statement] = STATE(73),
    [sym__simple_statements] = STATE(73),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(73),
    [sym_match_statement] = STATE(73),
    [sym_for_statement] = STATE(73),
    [sym_while_statement] = STATE(73),
    [sym_try_statement] = STATE(73),
    [sym_with_statement] = STATE(73),
    [sym_function_definition] = STATE(73),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(73),
    [sym_decorated_definition] = STATE(73),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(408),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(73),
    [sym_ruleorder_directive] = STATE(73),
    [sym__compound_directive] = STATE(73),
    [sym_rule_definition] = STATE(73),
    [sym_checkpoint_definition] = STATE(73),
    [sym_rule_import] = STATE(73),
    [sym_rule_inheritance] = STATE(73),
    [sym_module_definition] = STATE(73),
    [aux_sym_module_repeat1] = STATE(73),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(133),
    [sym_string_start] = ACTIONS(97),
  },
  [26] = {
    [sym__statement] = STATE(73),
    [sym__simple_statements] = STATE(73),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(73),
    [sym_match_statement] = STATE(73),
    [sym_for_statement] = STATE(73),
    [sym_while_statement] = STATE(73),
    [sym_try_statement] = STATE(73),
    [sym_with_statement] = STATE(73),
    [sym_function_definition] = STATE(73),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(73),
    [sym_decorated_definition] = STATE(73),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(466),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(73),
    [sym_ruleorder_directive] = STATE(73),
    [sym__compound_directive] = STATE(73),
    [sym_rule_definition] = STATE(73),
    [sym_checkpoint_definition] = STATE(73),
    [sym_rule_import] = STATE(73),
    [sym_rule_inheritance] = STATE(73),
    [sym_module_definition] = STATE(73),
    [aux_sym_module_repeat1] = STATE(73),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(133),
    [sym_string_start] = ACTIONS(97),
  },
  [27] = {
    [sym__statement] = STATE(74),
    [sym__simple_statements] = STATE(74),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(74),
    [sym_match_statement] = STATE(74),
    [sym_for_statement] = STATE(74),
    [sym_while_statement] = STATE(74),
    [sym_try_statement] = STATE(74),
    [sym_with_statement] = STATE(74),
    [sym_function_definition] = STATE(74),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(74),
    [sym_decorated_definition] = STATE(74),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(285),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(74),
    [sym_ruleorder_directive] = STATE(74),
    [sym__compound_directive] = STATE(74),
    [sym_rule_definition] = STATE(74),
    [sym_checkpoint_definition] = STATE(74),
    [sym_rule_import] = STATE(74),
    [sym_rule_inheritance] = STATE(74),
    [sym_module_definition] = STATE(74),
    [aux_sym_module_repeat1] = STATE(74),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(139),
    [sym_string_start] = ACTIONS(97),
  },
  [28] = {
    [sym__statement] = STATE(69),
    [sym__simple_statements] = STATE(69),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(69),
    [sym_match_statement] = STATE(69),
    [sym_for_statement] = STATE(69),
    [sym_while_statement] = STATE(69),
    [sym_try_statement] = STATE(69),
    [sym_with_statement] = STATE(69),
    [sym_function_definition] = STATE(69),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(69),
    [sym_decorated_definition] = STATE(69),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(243),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(69),
    [sym_ruleorder_directive] = STATE(69),
    [sym__compound_directive] = STATE(69),
    [sym_rule_definition] = STATE(69),
    [sym_checkpoint_definition] = STATE(69),
    [sym_rule_import] = STATE(69),
    [sym_rule_inheritance] = STATE(69),
    [sym_module_definition] = STATE(69),
    [aux_sym_module_repeat1] = STATE(69),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(147),
    [sym_string_start] = ACTIONS(97),
  },
  [29] = {
    [sym__statement] = STATE(66),
    [sym__simple_statements] = STATE(66),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(66),
    [sym_match_statement] = STATE(66),
    [sym_for_statement] = STATE(66),
    [sym_while_statement] = STATE(66),
    [sym_try_statement] = STATE(66),
    [sym_with_statement] = STATE(66),
    [sym_function_definition] = STATE(66),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(66),
    [sym_decorated_definition] = STATE(66),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(3107),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(66),
    [sym_ruleorder_directive] = STATE(66),
    [sym__compound_directive] = STATE(66),
    [sym_rule_definition] = STATE(66),
    [sym_checkpoint_definition] = STATE(66),
    [sym_rule_import] = STATE(66),
    [sym_rule_inheritance] = STATE(66),
    [sym_module_definition] = STATE(66),
    [aux_sym_module_repeat1] = STATE(66),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(141),
    [sym_string_start] = ACTIONS(97),
  },
  [30] = {
    [sym__statement] = STATE(66),
    [sym__simple_statements] = STATE(66),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(66),
    [sym_match_statement] = STATE(66),
    [sym_for_statement] = STATE(66),
    [sym_while_statement] = STATE(66),
    [sym_try_statement] = STATE(66),
    [sym_with_statement] = STATE(66),
    [sym_function_definition] = STATE(66),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(66),
    [sym_decorated_definition] = STATE(66),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(3097),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(66),
    [sym_ruleorder_directive] = STATE(66),
    [sym__compound_directive] = STATE(66),
    [sym_rule_definition] = STATE(66),
    [sym_checkpoint_definition] = STATE(66),
    [sym_rule_import] = STATE(66),
    [sym_rule_inheritance] = STATE(66),
    [sym_module_definition] = STATE(66),
    [aux_sym_module_repeat1] = STATE(66),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(141),
    [sym_string_start] = ACTIONS(97),
  },
  [31] = {
    [sym__statement] = STATE(69),
    [sym__simple_statements] = STATE(69),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(69),
    [sym_match_statement] = STATE(69),
    [sym_for_statement] = STATE(69),
    [sym_while_statement] = STATE(69),
    [sym_try_statement] = STATE(69),
    [sym_with_statement] = STATE(69),
    [sym_function_definition] = STATE(69),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(69),
    [sym_decorated_definition] = STATE(69),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(280),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(69),
    [sym_ruleorder_directive] = STATE(69),
    [sym__compound_directive] = STATE(69),
    [sym_rule_definition] = STATE(69),
    [sym_checkpoint_definition] = STATE(69),
    [sym_rule_import] = STATE(69),
    [sym_rule_inheritance] = STATE(69),
    [sym_module_definition] = STATE(69),
    [aux_sym_module_repeat1] = STATE(69),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(147),
    [sym_string_start] = ACTIONS(97),
  },
  [32] = {
    [sym__statement] = STATE(72),
    [sym__simple_statements] = STATE(72),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(72),
    [sym_match_statement] = STATE(72),
    [sym_for_statement] = STATE(72),
    [sym_while_statement] = STATE(72),
    [sym_try_statement] = STATE(72),
    [sym_with_statement] = STATE(72),
    [sym_function_definition] = STATE(72),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(72),
    [sym_decorated_definition] = STATE(72),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(366),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(72),
    [sym_ruleorder_directive] = STATE(72),
    [sym__compound_directive] = STATE(72),
    [sym_rule_definition] = STATE(72),
    [sym_checkpoint_definition] = STATE(72),
    [sym_rule_import] = STATE(72),
    [sym_rule_inheritance] = STATE(72),
    [sym_module_definition] = STATE(72),
    [aux_sym_module_repeat1] = STATE(72),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(135),
    [sym_string_start] = ACTIONS(97),
  },
  [33] = {
    [sym__statement] = STATE(72),
    [sym__simple_statements] = STATE(72),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(72),
    [sym_match_statement] = STATE(72),
    [sym_for_statement] = STATE(72),
    [sym_while_statement] = STATE(72),
    [sym_try_statement] = STATE(72),
    [sym_with_statement] = STATE(72),
    [sym_function_definition] = STATE(72),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(72),
    [sym_decorated_definition] = STATE(72),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(487),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(72),
    [sym_ruleorder_directive] = STATE(72),
    [sym__compound_directive] = STATE(72),
    [sym_rule_definition] = STATE(72),
    [sym_checkpoint_definition] = STATE(72),
    [sym_rule_import] = STATE(72),
    [sym_rule_inheritance] = STATE(72),
    [sym_module_definition] = STATE(72),
    [aux_sym_module_repeat1] = STATE(72),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(135),
    [sym_string_start] = ACTIONS(97),
  },
  [34] = {
    [sym__statement] = STATE(73),
    [sym__simple_statements] = STATE(73),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(73),
    [sym_match_statement] = STATE(73),
    [sym_for_statement] = STATE(73),
    [sym_while_statement] = STATE(73),
    [sym_try_statement] = STATE(73),
    [sym_with_statement] = STATE(73),
    [sym_function_definition] = STATE(73),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(73),
    [sym_decorated_definition] = STATE(73),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(221),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(73),
    [sym_ruleorder_directive] = STATE(73),
    [sym__compound_directive] = STATE(73),
    [sym_rule_definition] = STATE(73),
    [sym_checkpoint_definition] = STATE(73),
    [sym_rule_import] = STATE(73),
    [sym_rule_inheritance] = STATE(73),
    [sym_module_definition] = STATE(73),
    [aux_sym_module_repeat1] = STATE(73),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(133),
    [sym_string_start] = ACTIONS(97),
  },
  [35] = {
    [sym__statement] = STATE(72),
    [sym__simple_statements] = STATE(72),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(72),
    [sym_match_statement] = STATE(72),
    [sym_for_statement] = STATE(72),
    [sym_while_statement] = STATE(72),
    [sym_try_statement] = STATE(72),
    [sym_with_statement] = STATE(72),
    [sym_function_definition] = STATE(72),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(72),
    [sym_decorated_definition] = STATE(72),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(370),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(72),
    [sym_ruleorder_directive] = STATE(72),
    [sym__compound_directive] = STATE(72),
    [sym_rule_definition] = STATE(72),
    [sym_checkpoint_definition] = STATE(72),
    [sym_rule_import] = STATE(72),
    [sym_rule_inheritance] = STATE(72),
    [sym_module_definition] = STATE(72),
    [aux_sym_module_repeat1] = STATE(72),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(135),
    [sym_string_start] = ACTIONS(97),
  },
  [36] = {
    [sym__statement] = STATE(72),
    [sym__simple_statements] = STATE(72),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(72),
    [sym_match_statement] = STATE(72),
    [sym_for_statement] = STATE(72),
    [sym_while_statement] = STATE(72),
    [sym_try_statement] = STATE(72),
    [sym_with_statement] = STATE(72),
    [sym_function_definition] = STATE(72),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(72),
    [sym_decorated_definition] = STATE(72),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(374),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(72),
    [sym_ruleorder_directive] = STATE(72),
    [sym__compound_directive] = STATE(72),
    [sym_rule_definition] = STATE(72),
    [sym_checkpoint_definition] = STATE(72),
    [sym_rule_import] = STATE(72),
    [sym_rule_inheritance] = STATE(72),
    [sym_module_definition] = STATE(72),
    [aux_sym_module_repeat1] = STATE(72),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(135),
    [sym_string_start] = ACTIONS(97),
  },
  [37] = {
    [sym__statement] = STATE(73),
    [sym__simple_statements] = STATE(73),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(73),
    [sym_match_statement] = STATE(73),
    [sym_for_statement] = STATE(73),
    [sym_while_statement] = STATE(73),
    [sym_try_statement] = STATE(73),
    [sym_with_statement] = STATE(73),
    [sym_function_definition] = STATE(73),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(73),
    [sym_decorated_definition] = STATE(73),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(385),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(73),
    [sym_ruleorder_directive] = STATE(73),
    [sym__compound_directive] = STATE(73),
    [sym_rule_definition] = STATE(73),
    [sym_checkpoint_definition] = STATE(73),
    [sym_rule_import] = STATE(73),
    [sym_rule_inheritance] = STATE(73),
    [sym_module_definition] = STATE(73),
    [aux_sym_module_repeat1] = STATE(73),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(133),
    [sym_string_start] = ACTIONS(97),
  },
  [38] = {
    [sym__statement] = STATE(73),
    [sym__simple_statements] = STATE(73),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(73),
    [sym_match_statement] = STATE(73),
    [sym_for_statement] = STATE(73),
    [sym_while_statement] = STATE(73),
    [sym_try_statement] = STATE(73),
    [sym_with_statement] = STATE(73),
    [sym_function_definition] = STATE(73),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(73),
    [sym_decorated_definition] = STATE(73),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(390),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(73),
    [sym_ruleorder_directive] = STATE(73),
    [sym__compound_directive] = STATE(73),
    [sym_rule_definition] = STATE(73),
    [sym_checkpoint_definition] = STATE(73),
    [sym_rule_import] = STATE(73),
    [sym_rule_inheritance] = STATE(73),
    [sym_module_definition] = STATE(73),
    [aux_sym_module_repeat1] = STATE(73),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(133),
    [sym_string_start] = ACTIONS(97),
  },
  [39] = {
    [sym__statement] = STATE(73),
    [sym__simple_statements] = STATE(73),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(73),
    [sym_match_statement] = STATE(73),
    [sym_for_statement] = STATE(73),
    [sym_while_statement] = STATE(73),
    [sym_try_statement] = STATE(73),
    [sym_with_statement] = STATE(73),
    [sym_function_definition] = STATE(73),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(73),
    [sym_decorated_definition] = STATE(73),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(338),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(73),
    [sym_ruleorder_directive] = STATE(73),
    [sym__compound_directive] = STATE(73),
    [sym_rule_definition] = STATE(73),
    [sym_checkpoint_definition] = STATE(73),
    [sym_rule_import] = STATE(73),
    [sym_rule_inheritance] = STATE(73),
    [sym_module_definition] = STATE(73),
    [aux_sym_module_repeat1] = STATE(73),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(133),
    [sym_string_start] = ACTIONS(97),
  },
  [40] = {
    [sym__statement] = STATE(66),
    [sym__simple_statements] = STATE(66),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(66),
    [sym_match_statement] = STATE(66),
    [sym_for_statement] = STATE(66),
    [sym_while_statement] = STATE(66),
    [sym_try_statement] = STATE(66),
    [sym_with_statement] = STATE(66),
    [sym_function_definition] = STATE(66),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(66),
    [sym_decorated_definition] = STATE(66),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(3065),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(66),
    [sym_ruleorder_directive] = STATE(66),
    [sym__compound_directive] = STATE(66),
    [sym_rule_definition] = STATE(66),
    [sym_checkpoint_definition] = STATE(66),
    [sym_rule_import] = STATE(66),
    [sym_rule_inheritance] = STATE(66),
    [sym_module_definition] = STATE(66),
    [aux_sym_module_repeat1] = STATE(66),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(141),
    [sym_string_start] = ACTIONS(97),
  },
  [41] = {
    [sym__statement] = STATE(73),
    [sym__simple_statements] = STATE(73),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(73),
    [sym_match_statement] = STATE(73),
    [sym_for_statement] = STATE(73),
    [sym_while_statement] = STATE(73),
    [sym_try_statement] = STATE(73),
    [sym_with_statement] = STATE(73),
    [sym_function_definition] = STATE(73),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(73),
    [sym_decorated_definition] = STATE(73),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(306),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(73),
    [sym_ruleorder_directive] = STATE(73),
    [sym__compound_directive] = STATE(73),
    [sym_rule_definition] = STATE(73),
    [sym_checkpoint_definition] = STATE(73),
    [sym_rule_import] = STATE(73),
    [sym_rule_inheritance] = STATE(73),
    [sym_module_definition] = STATE(73),
    [aux_sym_module_repeat1] = STATE(73),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(133),
    [sym_string_start] = ACTIONS(97),
  },
  [42] = {
    [sym__statement] = STATE(72),
    [sym__simple_statements] = STATE(72),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(72),
    [sym_match_statement] = STATE(72),
    [sym_for_statement] = STATE(72),
    [sym_while_statement] = STATE(72),
    [sym_try_statement] = STATE(72),
    [sym_with_statement] = STATE(72),
    [sym_function_definition] = STATE(72),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(72),
    [sym_decorated_definition] = STATE(72),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(330),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(72),
    [sym_ruleorder_directive] = STATE(72),
    [sym__compound_directive] = STATE(72),
    [sym_rule_definition] = STATE(72),
    [sym_checkpoint_definition] = STATE(72),
    [sym_rule_import] = STATE(72),
    [sym_rule_inheritance] = STATE(72),
    [sym_module_definition] = STATE(72),
    [aux_sym_module_repeat1] = STATE(72),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(135),
    [sym_string_start] = ACTIONS(97),
  },
  [43] = {
    [sym__statement] = STATE(73),
    [sym__simple_statements] = STATE(73),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(73),
    [sym_match_statement] = STATE(73),
    [sym_for_statement] = STATE(73),
    [sym_while_statement] = STATE(73),
    [sym_try_statement] = STATE(73),
    [sym_with_statement] = STATE(73),
    [sym_function_definition] = STATE(73),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(73),
    [sym_decorated_definition] = STATE(73),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(311),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(73),
    [sym_ruleorder_directive] = STATE(73),
    [sym__compound_directive] = STATE(73),
    [sym_rule_definition] = STATE(73),
    [sym_checkpoint_definition] = STATE(73),
    [sym_rule_import] = STATE(73),
    [sym_rule_inheritance] = STATE(73),
    [sym_module_definition] = STATE(73),
    [aux_sym_module_repeat1] = STATE(73),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(133),
    [sym_string_start] = ACTIONS(97),
  },
  [44] = {
    [sym__statement] = STATE(72),
    [sym__simple_statements] = STATE(72),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(72),
    [sym_match_statement] = STATE(72),
    [sym_for_statement] = STATE(72),
    [sym_while_statement] = STATE(72),
    [sym_try_statement] = STATE(72),
    [sym_with_statement] = STATE(72),
    [sym_function_definition] = STATE(72),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(72),
    [sym_decorated_definition] = STATE(72),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(305),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(72),
    [sym_ruleorder_directive] = STATE(72),
    [sym__compound_directive] = STATE(72),
    [sym_rule_definition] = STATE(72),
    [sym_checkpoint_definition] = STATE(72),
    [sym_rule_import] = STATE(72),
    [sym_rule_inheritance] = STATE(72),
    [sym_module_definition] = STATE(72),
    [aux_sym_module_repeat1] = STATE(72),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(135),
    [sym_string_start] = ACTIONS(97),
  },
  [45] = {
    [sym__statement] = STATE(72),
    [sym__simple_statements] = STATE(72),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(72),
    [sym_match_statement] = STATE(72),
    [sym_for_statement] = STATE(72),
    [sym_while_statement] = STATE(72),
    [sym_try_statement] = STATE(72),
    [sym_with_statement] = STATE(72),
    [sym_function_definition] = STATE(72),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(72),
    [sym_decorated_definition] = STATE(72),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(442),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(72),
    [sym_ruleorder_directive] = STATE(72),
    [sym__compound_directive] = STATE(72),
    [sym_rule_definition] = STATE(72),
    [sym_checkpoint_definition] = STATE(72),
    [sym_rule_import] = STATE(72),
    [sym_rule_inheritance] = STATE(72),
    [sym_module_definition] = STATE(72),
    [aux_sym_module_repeat1] = STATE(72),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(135),
    [sym_string_start] = ACTIONS(97),
  },
  [46] = {
    [sym__statement] = STATE(75),
    [sym__simple_statements] = STATE(75),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(75),
    [sym_match_statement] = STATE(75),
    [sym_for_statement] = STATE(75),
    [sym_while_statement] = STATE(75),
    [sym_try_statement] = STATE(75),
    [sym_with_statement] = STATE(75),
    [sym_function_definition] = STATE(75),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(75),
    [sym_decorated_definition] = STATE(75),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(235),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(75),
    [sym_ruleorder_directive] = STATE(75),
    [sym__compound_directive] = STATE(75),
    [sym_rule_definition] = STATE(75),
    [sym_checkpoint_definition] = STATE(75),
    [sym_rule_import] = STATE(75),
    [sym_rule_inheritance] = STATE(75),
    [sym_module_definition] = STATE(75),
    [aux_sym_module_repeat1] = STATE(75),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(145),
    [sym_string_start] = ACTIONS(97),
  },
  [47] = {
    [sym__statement] = STATE(73),
    [sym__simple_statements] = STATE(73),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(73),
    [sym_match_statement] = STATE(73),
    [sym_for_statement] = STATE(73),
    [sym_while_statement] = STATE(73),
    [sym_try_statement] = STATE(73),
    [sym_with_statement] = STATE(73),
    [sym_function_definition] = STATE(73),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(73),
    [sym_decorated_definition] = STATE(73),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(509),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(73),
    [sym_ruleorder_directive] = STATE(73),
    [sym__compound_directive] = STATE(73),
    [sym_rule_definition] = STATE(73),
    [sym_checkpoint_definition] = STATE(73),
    [sym_rule_import] = STATE(73),
    [sym_rule_inheritance] = STATE(73),
    [sym_module_definition] = STATE(73),
    [aux_sym_module_repeat1] = STATE(73),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(133),
    [sym_string_start] = ACTIONS(97),
  },
  [48] = {
    [sym__statement] = STATE(72),
    [sym__simple_statements] = STATE(72),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(72),
    [sym_match_statement] = STATE(72),
    [sym_for_statement] = STATE(72),
    [sym_while_statement] = STATE(72),
    [sym_try_statement] = STATE(72),
    [sym_with_statement] = STATE(72),
    [sym_function_definition] = STATE(72),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(72),
    [sym_decorated_definition] = STATE(72),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(399),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(72),
    [sym_ruleorder_directive] = STATE(72),
    [sym__compound_directive] = STATE(72),
    [sym_rule_definition] = STATE(72),
    [sym_checkpoint_definition] = STATE(72),
    [sym_rule_import] = STATE(72),
    [sym_rule_inheritance] = STATE(72),
    [sym_module_definition] = STATE(72),
    [aux_sym_module_repeat1] = STATE(72),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(135),
    [sym_string_start] = ACTIONS(97),
  },
  [49] = {
    [sym__statement] = STATE(71),
    [sym__simple_statements] = STATE(71),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(71),
    [sym_match_statement] = STATE(71),
    [sym_for_statement] = STATE(71),
    [sym_while_statement] = STATE(71),
    [sym_try_statement] = STATE(71),
    [sym_with_statement] = STATE(71),
    [sym_function_definition] = STATE(71),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(71),
    [sym_decorated_definition] = STATE(71),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(2195),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(71),
    [sym_ruleorder_directive] = STATE(71),
    [sym__compound_directive] = STATE(71),
    [sym_rule_definition] = STATE(71),
    [sym_checkpoint_definition] = STATE(71),
    [sym_rule_import] = STATE(71),
    [sym_rule_inheritance] = STATE(71),
    [sym_module_definition] = STATE(71),
    [aux_sym_module_repeat1] = STATE(71),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(137),
    [sym_string_start] = ACTIONS(97),
  },
  [50] = {
    [sym__statement] = STATE(72),
    [sym__simple_statements] = STATE(72),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(72),
    [sym_match_statement] = STATE(72),
    [sym_for_statement] = STATE(72),
    [sym_while_statement] = STATE(72),
    [sym_try_statement] = STATE(72),
    [sym_with_statement] = STATE(72),
    [sym_function_definition] = STATE(72),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(72),
    [sym_decorated_definition] = STATE(72),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(413),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(72),
    [sym_ruleorder_directive] = STATE(72),
    [sym__compound_directive] = STATE(72),
    [sym_rule_definition] = STATE(72),
    [sym_checkpoint_definition] = STATE(72),
    [sym_rule_import] = STATE(72),
    [sym_rule_inheritance] = STATE(72),
    [sym_module_definition] = STATE(72),
    [aux_sym_module_repeat1] = STATE(72),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(135),
    [sym_string_start] = ACTIONS(97),
  },
  [51] = {
    [sym__statement] = STATE(73),
    [sym__simple_statements] = STATE(73),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(73),
    [sym_match_statement] = STATE(73),
    [sym_for_statement] = STATE(73),
    [sym_while_statement] = STATE(73),
    [sym_try_statement] = STATE(73),
    [sym_with_statement] = STATE(73),
    [sym_function_definition] = STATE(73),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(73),
    [sym_decorated_definition] = STATE(73),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(379),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(73),
    [sym_ruleorder_directive] = STATE(73),
    [sym__compound_directive] = STATE(73),
    [sym_rule_definition] = STATE(73),
    [sym_checkpoint_definition] = STATE(73),
    [sym_rule_import] = STATE(73),
    [sym_rule_inheritance] = STATE(73),
    [sym_module_definition] = STATE(73),
    [aux_sym_module_repeat1] = STATE(73),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(133),
    [sym_string_start] = ACTIONS(97),
  },
  [52] = {
    [sym__statement] = STATE(72),
    [sym__simple_statements] = STATE(72),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(72),
    [sym_match_statement] = STATE(72),
    [sym_for_statement] = STATE(72),
    [sym_while_statement] = STATE(72),
    [sym_try_statement] = STATE(72),
    [sym_with_statement] = STATE(72),
    [sym_function_definition] = STATE(72),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(72),
    [sym_decorated_definition] = STATE(72),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(302),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(72),
    [sym_ruleorder_directive] = STATE(72),
    [sym__compound_directive] = STATE(72),
    [sym_rule_definition] = STATE(72),
    [sym_checkpoint_definition] = STATE(72),
    [sym_rule_import] = STATE(72),
    [sym_rule_inheritance] = STATE(72),
    [sym_module_definition] = STATE(72),
    [aux_sym_module_repeat1] = STATE(72),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(135),
    [sym_string_start] = ACTIONS(97),
  },
  [53] = {
    [sym__statement] = STATE(73),
    [sym__simple_statements] = STATE(73),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(73),
    [sym_match_statement] = STATE(73),
    [sym_for_statement] = STATE(73),
    [sym_while_statement] = STATE(73),
    [sym_try_statement] = STATE(73),
    [sym_with_statement] = STATE(73),
    [sym_function_definition] = STATE(73),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(73),
    [sym_decorated_definition] = STATE(73),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(375),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(73),
    [sym_ruleorder_directive] = STATE(73),
    [sym__compound_directive] = STATE(73),
    [sym_rule_definition] = STATE(73),
    [sym_checkpoint_definition] = STATE(73),
    [sym_rule_import] = STATE(73),
    [sym_rule_inheritance] = STATE(73),
    [sym_module_definition] = STATE(73),
    [aux_sym_module_repeat1] = STATE(73),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(133),
    [sym_string_start] = ACTIONS(97),
  },
  [54] = {
    [sym__statement] = STATE(72),
    [sym__simple_statements] = STATE(72),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(72),
    [sym_match_statement] = STATE(72),
    [sym_for_statement] = STATE(72),
    [sym_while_statement] = STATE(72),
    [sym_try_statement] = STATE(72),
    [sym_with_statement] = STATE(72),
    [sym_function_definition] = STATE(72),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(72),
    [sym_decorated_definition] = STATE(72),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(426),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(72),
    [sym_ruleorder_directive] = STATE(72),
    [sym__compound_directive] = STATE(72),
    [sym_rule_definition] = STATE(72),
    [sym_checkpoint_definition] = STATE(72),
    [sym_rule_import] = STATE(72),
    [sym_rule_inheritance] = STATE(72),
    [sym_module_definition] = STATE(72),
    [aux_sym_module_repeat1] = STATE(72),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(135),
    [sym_string_start] = ACTIONS(97),
  },
  [55] = {
    [sym__statement] = STATE(73),
    [sym__simple_statements] = STATE(73),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(73),
    [sym_match_statement] = STATE(73),
    [sym_for_statement] = STATE(73),
    [sym_while_statement] = STATE(73),
    [sym_try_statement] = STATE(73),
    [sym_with_statement] = STATE(73),
    [sym_function_definition] = STATE(73),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(73),
    [sym_decorated_definition] = STATE(73),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(373),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(73),
    [sym_ruleorder_directive] = STATE(73),
    [sym__compound_directive] = STATE(73),
    [sym_rule_definition] = STATE(73),
    [sym_checkpoint_definition] = STATE(73),
    [sym_rule_import] = STATE(73),
    [sym_rule_inheritance] = STATE(73),
    [sym_module_definition] = STATE(73),
    [aux_sym_module_repeat1] = STATE(73),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(133),
    [sym_string_start] = ACTIONS(97),
  },
  [56] = {
    [sym__statement] = STATE(73),
    [sym__simple_statements] = STATE(73),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(73),
    [sym_match_statement] = STATE(73),
    [sym_for_statement] = STATE(73),
    [sym_while_statement] = STATE(73),
    [sym_try_statement] = STATE(73),
    [sym_with_statement] = STATE(73),
    [sym_function_definition] = STATE(73),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(73),
    [sym_decorated_definition] = STATE(73),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(356),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(73),
    [sym_ruleorder_directive] = STATE(73),
    [sym__compound_directive] = STATE(73),
    [sym_rule_definition] = STATE(73),
    [sym_checkpoint_definition] = STATE(73),
    [sym_rule_import] = STATE(73),
    [sym_rule_inheritance] = STATE(73),
    [sym_module_definition] = STATE(73),
    [aux_sym_module_repeat1] = STATE(73),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(133),
    [sym_string_start] = ACTIONS(97),
  },
  [57] = {
    [sym__statement] = STATE(72),
    [sym__simple_statements] = STATE(72),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(72),
    [sym_match_statement] = STATE(72),
    [sym_for_statement] = STATE(72),
    [sym_while_statement] = STATE(72),
    [sym_try_statement] = STATE(72),
    [sym_with_statement] = STATE(72),
    [sym_function_definition] = STATE(72),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(72),
    [sym_decorated_definition] = STATE(72),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(434),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(72),
    [sym_ruleorder_directive] = STATE(72),
    [sym__compound_directive] = STATE(72),
    [sym_rule_definition] = STATE(72),
    [sym_checkpoint_definition] = STATE(72),
    [sym_rule_import] = STATE(72),
    [sym_rule_inheritance] = STATE(72),
    [sym_module_definition] = STATE(72),
    [aux_sym_module_repeat1] = STATE(72),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(135),
    [sym_string_start] = ACTIONS(97),
  },
  [58] = {
    [sym__statement] = STATE(65),
    [sym__simple_statements] = STATE(65),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(65),
    [sym_match_statement] = STATE(65),
    [sym_for_statement] = STATE(65),
    [sym_while_statement] = STATE(65),
    [sym_try_statement] = STATE(65),
    [sym_with_statement] = STATE(65),
    [sym_function_definition] = STATE(65),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(65),
    [sym_decorated_definition] = STATE(65),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(245),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(65),
    [sym_ruleorder_directive] = STATE(65),
    [sym__compound_directive] = STATE(65),
    [sym_rule_definition] = STATE(65),
    [sym_checkpoint_definition] = STATE(65),
    [sym_rule_import] = STATE(65),
    [sym_rule_inheritance] = STATE(65),
    [sym_module_definition] = STATE(65),
    [aux_sym_module_repeat1] = STATE(65),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(143),
    [sym_string_start] = ACTIONS(97),
  },
  [59] = {
    [sym__statement] = STATE(75),
    [sym__simple_statements] = STATE(75),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(75),
    [sym_match_statement] = STATE(75),
    [sym_for_statement] = STATE(75),
    [sym_while_statement] = STATE(75),
    [sym_try_statement] = STATE(75),
    [sym_with_statement] = STATE(75),
    [sym_function_definition] = STATE(75),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(75),
    [sym_decorated_definition] = STATE(75),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(244),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(75),
    [sym_ruleorder_directive] = STATE(75),
    [sym__compound_directive] = STATE(75),
    [sym_rule_definition] = STATE(75),
    [sym_checkpoint_definition] = STATE(75),
    [sym_rule_import] = STATE(75),
    [sym_rule_inheritance] = STATE(75),
    [sym_module_definition] = STATE(75),
    [aux_sym_module_repeat1] = STATE(75),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(145),
    [sym_string_start] = ACTIONS(97),
  },
  [60] = {
    [sym__statement] = STATE(70),
    [sym__simple_statements] = STATE(70),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(70),
    [sym_match_statement] = STATE(70),
    [sym_for_statement] = STATE(70),
    [sym_while_statement] = STATE(70),
    [sym_try_statement] = STATE(70),
    [sym_with_statement] = STATE(70),
    [sym_function_definition] = STATE(70),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(70),
    [sym_decorated_definition] = STATE(70),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(1839),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(70),
    [sym_ruleorder_directive] = STATE(70),
    [sym__compound_directive] = STATE(70),
    [sym_rule_definition] = STATE(70),
    [sym_checkpoint_definition] = STATE(70),
    [sym_rule_import] = STATE(70),
    [sym_rule_inheritance] = STATE(70),
    [sym_module_definition] = STATE(70),
    [aux_sym_module_repeat1] = STATE(70),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(149),
    [sym_string_start] = ACTIONS(97),
  },
  [61] = {
    [sym__statement] = STATE(73),
    [sym__simple_statements] = STATE(73),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(73),
    [sym_match_statement] = STATE(73),
    [sym_for_statement] = STATE(73),
    [sym_while_statement] = STATE(73),
    [sym_try_statement] = STATE(73),
    [sym_with_statement] = STATE(73),
    [sym_function_definition] = STATE(73),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(73),
    [sym_decorated_definition] = STATE(73),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(428),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(73),
    [sym_ruleorder_directive] = STATE(73),
    [sym__compound_directive] = STATE(73),
    [sym_rule_definition] = STATE(73),
    [sym_checkpoint_definition] = STATE(73),
    [sym_rule_import] = STATE(73),
    [sym_rule_inheritance] = STATE(73),
    [sym_module_definition] = STATE(73),
    [aux_sym_module_repeat1] = STATE(73),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(133),
    [sym_string_start] = ACTIONS(97),
  },
  [62] = {
    [sym__statement] = STATE(73),
    [sym__simple_statements] = STATE(73),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(73),
    [sym_match_statement] = STATE(73),
    [sym_for_statement] = STATE(73),
    [sym_while_statement] = STATE(73),
    [sym_try_statement] = STATE(73),
    [sym_with_statement] = STATE(73),
    [sym_function_definition] = STATE(73),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(73),
    [sym_decorated_definition] = STATE(73),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(362),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(73),
    [sym_ruleorder_directive] = STATE(73),
    [sym__compound_directive] = STATE(73),
    [sym_rule_definition] = STATE(73),
    [sym_checkpoint_definition] = STATE(73),
    [sym_rule_import] = STATE(73),
    [sym_rule_inheritance] = STATE(73),
    [sym_module_definition] = STATE(73),
    [aux_sym_module_repeat1] = STATE(73),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(133),
    [sym_string_start] = ACTIONS(97),
  },
  [63] = {
    [sym__statement] = STATE(69),
    [sym__simple_statements] = STATE(69),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(69),
    [sym_match_statement] = STATE(69),
    [sym_for_statement] = STATE(69),
    [sym_while_statement] = STATE(69),
    [sym_try_statement] = STATE(69),
    [sym_with_statement] = STATE(69),
    [sym_function_definition] = STATE(69),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(69),
    [sym_decorated_definition] = STATE(69),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(288),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(69),
    [sym_ruleorder_directive] = STATE(69),
    [sym__compound_directive] = STATE(69),
    [sym_rule_definition] = STATE(69),
    [sym_checkpoint_definition] = STATE(69),
    [sym_rule_import] = STATE(69),
    [sym_rule_inheritance] = STATE(69),
    [sym_module_definition] = STATE(69),
    [aux_sym_module_repeat1] = STATE(69),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(147),
    [sym_string_start] = ACTIONS(97),
  },
  [64] = {
    [sym__statement] = STATE(73),
    [sym__simple_statements] = STATE(73),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(73),
    [sym_match_statement] = STATE(73),
    [sym_for_statement] = STATE(73),
    [sym_while_statement] = STATE(73),
    [sym_try_statement] = STATE(73),
    [sym_with_statement] = STATE(73),
    [sym_function_definition] = STATE(73),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(73),
    [sym_decorated_definition] = STATE(73),
    [sym_decorator] = STATE(2196),
    [sym_block] = STATE(322),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(73),
    [sym_ruleorder_directive] = STATE(73),
    [sym__compound_directive] = STATE(73),
    [sym_rule_definition] = STATE(73),
    [sym_checkpoint_definition] = STATE(73),
    [sym_rule_import] = STATE(73),
    [sym_rule_inheritance] = STATE(73),
    [sym_module_definition] = STATE(73),
    [aux_sym_module_repeat1] = STATE(73),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(133),
    [sym_string_start] = ACTIONS(97),
  },
  [65] = {
    [sym__statement] = STATE(76),
    [sym__simple_statements] = STATE(76),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(76),
    [sym_match_statement] = STATE(76),
    [sym_for_statement] = STATE(76),
    [sym_while_statement] = STATE(76),
    [sym_try_statement] = STATE(76),
    [sym_with_statement] = STATE(76),
    [sym_function_definition] = STATE(76),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(76),
    [sym_decorated_definition] = STATE(76),
    [sym_decorator] = STATE(2196),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(76),
    [sym_ruleorder_directive] = STATE(76),
    [sym__compound_directive] = STATE(76),
    [sym_rule_definition] = STATE(76),
    [sym_checkpoint_definition] = STATE(76),
    [sym_rule_import] = STATE(76),
    [sym_rule_inheritance] = STATE(76),
    [sym_module_definition] = STATE(76),
    [aux_sym_module_repeat1] = STATE(76),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(151),
    [sym_string_start] = ACTIONS(97),
  },
  [66] = {
    [sym__statement] = STATE(76),
    [sym__simple_statements] = STATE(76),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(76),
    [sym_match_statement] = STATE(76),
    [sym_for_statement] = STATE(76),
    [sym_while_statement] = STATE(76),
    [sym_try_statement] = STATE(76),
    [sym_with_statement] = STATE(76),
    [sym_function_definition] = STATE(76),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(76),
    [sym_decorated_definition] = STATE(76),
    [sym_decorator] = STATE(2196),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(76),
    [sym_ruleorder_directive] = STATE(76),
    [sym__compound_directive] = STATE(76),
    [sym_rule_definition] = STATE(76),
    [sym_checkpoint_definition] = STATE(76),
    [sym_rule_import] = STATE(76),
    [sym_rule_inheritance] = STATE(76),
    [sym_module_definition] = STATE(76),
    [aux_sym_module_repeat1] = STATE(76),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(153),
    [sym_string_start] = ACTIONS(97),
  },
  [67] = {
    [sym__statement] = STATE(67),
    [sym__simple_statements] = STATE(67),
    [sym_import_statement] = STATE(2679),
    [sym_future_import_statement] = STATE(2679),
    [sym_import_from_statement] = STATE(2679),
    [sym_print_statement] = STATE(2679),
    [sym_assert_statement] = STATE(2679),
    [sym_expression_statement] = STATE(2679),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2679),
    [sym_delete_statement] = STATE(2679),
    [sym_raise_statement] = STATE(2679),
    [sym_pass_statement] = STATE(2679),
    [sym_break_statement] = STATE(2679),
    [sym_continue_statement] = STATE(2679),
    [sym_if_statement] = STATE(67),
    [sym_match_statement] = STATE(67),
    [sym_for_statement] = STATE(67),
    [sym_while_statement] = STATE(67),
    [sym_try_statement] = STATE(67),
    [sym_with_statement] = STATE(67),
    [sym_function_definition] = STATE(67),
    [sym_global_statement] = STATE(2679),
    [sym_nonlocal_statement] = STATE(2679),
    [sym_exec_statement] = STATE(2679),
    [sym_type_alias_statement] = STATE(2679),
    [sym_class_definition] = STATE(67),
    [sym_decorated_definition] = STATE(67),
    [sym_decorator] = STATE(2187),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(387),
    [sym__simple_directive_block] = STATE(513),
    [sym_localrules_directive] = STATE(67),
    [sym_ruleorder_directive] = STATE(67),
    [sym__compound_directive] = STATE(67),
    [sym_rule_definition] = STATE(67),
    [sym_checkpoint_definition] = STATE(67),
    [sym_rule_import] = STATE(67),
    [sym_rule_inheritance] = STATE(67),
    [sym_module_definition] = STATE(67),
    [aux_sym_module_repeat1] = STATE(67),
    [aux_sym_decorated_definition_repeat1] = STATE(2187),
    [ts_builtin_sym_end] = ACTIONS(155),
    [sym_identifier] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(160),
    [anon_sym_from] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(166),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_print] = ACTIONS(172),
    [anon_sym_assert] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(178),
    [anon_sym_del] = ACTIONS(181),
    [anon_sym_raise] = ACTIONS(184),
    [anon_sym_pass] = ACTIONS(187),
    [anon_sym_break] = ACTIONS(190),
    [anon_sym_continue] = ACTIONS(193),
    [anon_sym_if] = ACTIONS(196),
    [anon_sym_match] = ACTIONS(199),
    [anon_sym_async] = ACTIONS(202),
    [anon_sym_for] = ACTIONS(205),
    [anon_sym_while] = ACTIONS(208),
    [anon_sym_try] = ACTIONS(211),
    [anon_sym_with] = ACTIONS(214),
    [anon_sym_def] = ACTIONS(217),
    [anon_sym_global] = ACTIONS(220),
    [anon_sym_nonlocal] = ACTIONS(223),
    [anon_sym_exec] = ACTIONS(226),
    [anon_sym_type] = ACTIONS(229),
    [anon_sym_class] = ACTIONS(232),
    [anon_sym_LBRACK] = ACTIONS(235),
    [anon_sym_AT] = ACTIONS(238),
    [anon_sym_DASH] = ACTIONS(241),
    [anon_sym_LBRACE] = ACTIONS(244),
    [anon_sym_PLUS] = ACTIONS(241),
    [anon_sym_not] = ACTIONS(247),
    [anon_sym_TILDE] = ACTIONS(241),
    [anon_sym_lambda] = ACTIONS(250),
    [anon_sym_yield] = ACTIONS(253),
    [sym_ellipsis] = ACTIONS(256),
    [sym_integer] = ACTIONS(259),
    [sym_float] = ACTIONS(256),
    [anon_sym_await] = ACTIONS(262),
    [sym_true] = ACTIONS(259),
    [sym_false] = ACTIONS(259),
    [sym_none] = ACTIONS(259),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(265),
    [anon_sym_container] = ACTIONS(265),
    [anon_sym_envvars] = ACTIONS(265),
    [anon_sym_include] = ACTIONS(265),
    [anon_sym_pepfile] = ACTIONS(265),
    [anon_sym_pepschema] = ACTIONS(265),
    [anon_sym_scattergather] = ACTIONS(265),
    [anon_sym_version] = ACTIONS(265),
    [anon_sym_wildcard_constraints] = ACTIONS(265),
    [anon_sym_workdir] = ACTIONS(265),
    [anon_sym_onerror] = ACTIONS(268),
    [anon_sym_onstart] = ACTIONS(268),
    [anon_sym_onsuccess] = ACTIONS(268),
    [anon_sym_localrules] = ACTIONS(271),
    [anon_sym_ruleorder] = ACTIONS(274),
    [anon_sym_rule] = ACTIONS(277),
    [anon_sym_checkpoint] = ACTIONS(280),
    [anon_sym_use] = ACTIONS(283),
    [anon_sym_module] = ACTIONS(286),
    [sym_string_start] = ACTIONS(289),
  },
  [68] = {
    [sym__statement] = STATE(67),
    [sym__simple_statements] = STATE(67),
    [sym_import_statement] = STATE(2679),
    [sym_future_import_statement] = STATE(2679),
    [sym_import_from_statement] = STATE(2679),
    [sym_print_statement] = STATE(2679),
    [sym_assert_statement] = STATE(2679),
    [sym_expression_statement] = STATE(2679),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2679),
    [sym_delete_statement] = STATE(2679),
    [sym_raise_statement] = STATE(2679),
    [sym_pass_statement] = STATE(2679),
    [sym_break_statement] = STATE(2679),
    [sym_continue_statement] = STATE(2679),
    [sym_if_statement] = STATE(67),
    [sym_match_statement] = STATE(67),
    [sym_for_statement] = STATE(67),
    [sym_while_statement] = STATE(67),
    [sym_try_statement] = STATE(67),
    [sym_with_statement] = STATE(67),
    [sym_function_definition] = STATE(67),
    [sym_global_statement] = STATE(2679),
    [sym_nonlocal_statement] = STATE(2679),
    [sym_exec_statement] = STATE(2679),
    [sym_type_alias_statement] = STATE(2679),
    [sym_class_definition] = STATE(67),
    [sym_decorated_definition] = STATE(67),
    [sym_decorator] = STATE(2187),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(387),
    [sym__simple_directive_block] = STATE(513),
    [sym_localrules_directive] = STATE(67),
    [sym_ruleorder_directive] = STATE(67),
    [sym__compound_directive] = STATE(67),
    [sym_rule_definition] = STATE(67),
    [sym_checkpoint_definition] = STATE(67),
    [sym_rule_import] = STATE(67),
    [sym_rule_inheritance] = STATE(67),
    [sym_module_definition] = STATE(67),
    [aux_sym_module_repeat1] = STATE(67),
    [aux_sym_decorated_definition_repeat1] = STATE(2187),
    [ts_builtin_sym_end] = ACTIONS(292),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(35),
    [anon_sym_match] = ACTIONS(37),
    [anon_sym_async] = ACTIONS(39),
    [anon_sym_for] = ACTIONS(41),
    [anon_sym_while] = ACTIONS(43),
    [anon_sym_try] = ACTIONS(45),
    [anon_sym_with] = ACTIONS(47),
    [anon_sym_def] = ACTIONS(49),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(81),
    [anon_sym_container] = ACTIONS(81),
    [anon_sym_envvars] = ACTIONS(81),
    [anon_sym_include] = ACTIONS(81),
    [anon_sym_pepfile] = ACTIONS(81),
    [anon_sym_pepschema] = ACTIONS(81),
    [anon_sym_scattergather] = ACTIONS(81),
    [anon_sym_version] = ACTIONS(81),
    [anon_sym_wildcard_constraints] = ACTIONS(81),
    [anon_sym_workdir] = ACTIONS(81),
    [anon_sym_onerror] = ACTIONS(83),
    [anon_sym_onstart] = ACTIONS(83),
    [anon_sym_onsuccess] = ACTIONS(83),
    [anon_sym_localrules] = ACTIONS(85),
    [anon_sym_ruleorder] = ACTIONS(87),
    [anon_sym_rule] = ACTIONS(89),
    [anon_sym_checkpoint] = ACTIONS(91),
    [anon_sym_use] = ACTIONS(93),
    [anon_sym_module] = ACTIONS(95),
    [sym_string_start] = ACTIONS(97),
  },
  [69] = {
    [sym__statement] = STATE(76),
    [sym__simple_statements] = STATE(76),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(76),
    [sym_match_statement] = STATE(76),
    [sym_for_statement] = STATE(76),
    [sym_while_statement] = STATE(76),
    [sym_try_statement] = STATE(76),
    [sym_with_statement] = STATE(76),
    [sym_function_definition] = STATE(76),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(76),
    [sym_decorated_definition] = STATE(76),
    [sym_decorator] = STATE(2196),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(76),
    [sym_ruleorder_directive] = STATE(76),
    [sym__compound_directive] = STATE(76),
    [sym_rule_definition] = STATE(76),
    [sym_checkpoint_definition] = STATE(76),
    [sym_rule_import] = STATE(76),
    [sym_rule_inheritance] = STATE(76),
    [sym_module_definition] = STATE(76),
    [aux_sym_module_repeat1] = STATE(76),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(294),
    [sym_string_start] = ACTIONS(97),
  },
  [70] = {
    [sym__statement] = STATE(76),
    [sym__simple_statements] = STATE(76),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(76),
    [sym_match_statement] = STATE(76),
    [sym_for_statement] = STATE(76),
    [sym_while_statement] = STATE(76),
    [sym_try_statement] = STATE(76),
    [sym_with_statement] = STATE(76),
    [sym_function_definition] = STATE(76),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(76),
    [sym_decorated_definition] = STATE(76),
    [sym_decorator] = STATE(2196),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(76),
    [sym_ruleorder_directive] = STATE(76),
    [sym__compound_directive] = STATE(76),
    [sym_rule_definition] = STATE(76),
    [sym_checkpoint_definition] = STATE(76),
    [sym_rule_import] = STATE(76),
    [sym_rule_inheritance] = STATE(76),
    [sym_module_definition] = STATE(76),
    [aux_sym_module_repeat1] = STATE(76),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(296),
    [sym_string_start] = ACTIONS(97),
  },
  [71] = {
    [sym__statement] = STATE(76),
    [sym__simple_statements] = STATE(76),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(76),
    [sym_match_statement] = STATE(76),
    [sym_for_statement] = STATE(76),
    [sym_while_statement] = STATE(76),
    [sym_try_statement] = STATE(76),
    [sym_with_statement] = STATE(76),
    [sym_function_definition] = STATE(76),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(76),
    [sym_decorated_definition] = STATE(76),
    [sym_decorator] = STATE(2196),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(76),
    [sym_ruleorder_directive] = STATE(76),
    [sym__compound_directive] = STATE(76),
    [sym_rule_definition] = STATE(76),
    [sym_checkpoint_definition] = STATE(76),
    [sym_rule_import] = STATE(76),
    [sym_rule_inheritance] = STATE(76),
    [sym_module_definition] = STATE(76),
    [aux_sym_module_repeat1] = STATE(76),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(298),
    [sym_string_start] = ACTIONS(97),
  },
  [72] = {
    [sym__statement] = STATE(76),
    [sym__simple_statements] = STATE(76),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(76),
    [sym_match_statement] = STATE(76),
    [sym_for_statement] = STATE(76),
    [sym_while_statement] = STATE(76),
    [sym_try_statement] = STATE(76),
    [sym_with_statement] = STATE(76),
    [sym_function_definition] = STATE(76),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(76),
    [sym_decorated_definition] = STATE(76),
    [sym_decorator] = STATE(2196),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(76),
    [sym_ruleorder_directive] = STATE(76),
    [sym__compound_directive] = STATE(76),
    [sym_rule_definition] = STATE(76),
    [sym_checkpoint_definition] = STATE(76),
    [sym_rule_import] = STATE(76),
    [sym_rule_inheritance] = STATE(76),
    [sym_module_definition] = STATE(76),
    [aux_sym_module_repeat1] = STATE(76),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(300),
    [sym_string_start] = ACTIONS(97),
  },
  [73] = {
    [sym__statement] = STATE(76),
    [sym__simple_statements] = STATE(76),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(76),
    [sym_match_statement] = STATE(76),
    [sym_for_statement] = STATE(76),
    [sym_while_statement] = STATE(76),
    [sym_try_statement] = STATE(76),
    [sym_with_statement] = STATE(76),
    [sym_function_definition] = STATE(76),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(76),
    [sym_decorated_definition] = STATE(76),
    [sym_decorator] = STATE(2196),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(76),
    [sym_ruleorder_directive] = STATE(76),
    [sym__compound_directive] = STATE(76),
    [sym_rule_definition] = STATE(76),
    [sym_checkpoint_definition] = STATE(76),
    [sym_rule_import] = STATE(76),
    [sym_rule_inheritance] = STATE(76),
    [sym_module_definition] = STATE(76),
    [aux_sym_module_repeat1] = STATE(76),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(302),
    [sym_string_start] = ACTIONS(97),
  },
  [74] = {
    [sym__statement] = STATE(76),
    [sym__simple_statements] = STATE(76),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(76),
    [sym_match_statement] = STATE(76),
    [sym_for_statement] = STATE(76),
    [sym_while_statement] = STATE(76),
    [sym_try_statement] = STATE(76),
    [sym_with_statement] = STATE(76),
    [sym_function_definition] = STATE(76),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(76),
    [sym_decorated_definition] = STATE(76),
    [sym_decorator] = STATE(2196),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(76),
    [sym_ruleorder_directive] = STATE(76),
    [sym__compound_directive] = STATE(76),
    [sym_rule_definition] = STATE(76),
    [sym_checkpoint_definition] = STATE(76),
    [sym_rule_import] = STATE(76),
    [sym_rule_inheritance] = STATE(76),
    [sym_module_definition] = STATE(76),
    [aux_sym_module_repeat1] = STATE(76),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(304),
    [sym_string_start] = ACTIONS(97),
  },
  [75] = {
    [sym__statement] = STATE(76),
    [sym__simple_statements] = STATE(76),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(76),
    [sym_match_statement] = STATE(76),
    [sym_for_statement] = STATE(76),
    [sym_while_statement] = STATE(76),
    [sym_try_statement] = STATE(76),
    [sym_with_statement] = STATE(76),
    [sym_function_definition] = STATE(76),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(76),
    [sym_decorated_definition] = STATE(76),
    [sym_decorator] = STATE(2196),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(76),
    [sym_ruleorder_directive] = STATE(76),
    [sym__compound_directive] = STATE(76),
    [sym_rule_definition] = STATE(76),
    [sym_checkpoint_definition] = STATE(76),
    [sym_rule_import] = STATE(76),
    [sym_rule_inheritance] = STATE(76),
    [sym_module_definition] = STATE(76),
    [aux_sym_module_repeat1] = STATE(76),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_if] = ACTIONS(99),
    [anon_sym_match] = ACTIONS(101),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_for] = ACTIONS(105),
    [anon_sym_while] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(109),
    [anon_sym_with] = ACTIONS(111),
    [anon_sym_def] = ACTIONS(113),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_AT] = ACTIONS(63),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(117),
    [anon_sym_container] = ACTIONS(117),
    [anon_sym_envvars] = ACTIONS(117),
    [anon_sym_include] = ACTIONS(117),
    [anon_sym_pepfile] = ACTIONS(117),
    [anon_sym_pepschema] = ACTIONS(117),
    [anon_sym_scattergather] = ACTIONS(117),
    [anon_sym_version] = ACTIONS(117),
    [anon_sym_wildcard_constraints] = ACTIONS(117),
    [anon_sym_workdir] = ACTIONS(117),
    [anon_sym_onerror] = ACTIONS(119),
    [anon_sym_onstart] = ACTIONS(119),
    [anon_sym_onsuccess] = ACTIONS(119),
    [anon_sym_localrules] = ACTIONS(121),
    [anon_sym_ruleorder] = ACTIONS(123),
    [anon_sym_rule] = ACTIONS(125),
    [anon_sym_checkpoint] = ACTIONS(127),
    [anon_sym_use] = ACTIONS(129),
    [anon_sym_module] = ACTIONS(131),
    [sym__dedent] = ACTIONS(306),
    [sym_string_start] = ACTIONS(97),
  },
  [76] = {
    [sym__statement] = STATE(76),
    [sym__simple_statements] = STATE(76),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_if_statement] = STATE(76),
    [sym_match_statement] = STATE(76),
    [sym_for_statement] = STATE(76),
    [sym_while_statement] = STATE(76),
    [sym_try_statement] = STATE(76),
    [sym_with_statement] = STATE(76),
    [sym_function_definition] = STATE(76),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_class_definition] = STATE(76),
    [sym_decorated_definition] = STATE(76),
    [sym_decorator] = STATE(2196),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym__simple_directive_wc_none] = STATE(445),
    [sym__simple_directive_block] = STATE(451),
    [sym_localrules_directive] = STATE(76),
    [sym_ruleorder_directive] = STATE(76),
    [sym__compound_directive] = STATE(76),
    [sym_rule_definition] = STATE(76),
    [sym_checkpoint_definition] = STATE(76),
    [sym_rule_import] = STATE(76),
    [sym_rule_inheritance] = STATE(76),
    [sym_module_definition] = STATE(76),
    [aux_sym_module_repeat1] = STATE(76),
    [aux_sym_decorated_definition_repeat1] = STATE(2196),
    [sym_identifier] = ACTIONS(157),
    [anon_sym_import] = ACTIONS(160),
    [anon_sym_from] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(166),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_print] = ACTIONS(172),
    [anon_sym_assert] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(178),
    [anon_sym_del] = ACTIONS(181),
    [anon_sym_raise] = ACTIONS(184),
    [anon_sym_pass] = ACTIONS(187),
    [anon_sym_break] = ACTIONS(190),
    [anon_sym_continue] = ACTIONS(193),
    [anon_sym_if] = ACTIONS(308),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_async] = ACTIONS(314),
    [anon_sym_for] = ACTIONS(317),
    [anon_sym_while] = ACTIONS(320),
    [anon_sym_try] = ACTIONS(323),
    [anon_sym_with] = ACTIONS(326),
    [anon_sym_def] = ACTIONS(329),
    [anon_sym_global] = ACTIONS(220),
    [anon_sym_nonlocal] = ACTIONS(223),
    [anon_sym_exec] = ACTIONS(226),
    [anon_sym_type] = ACTIONS(229),
    [anon_sym_class] = ACTIONS(332),
    [anon_sym_LBRACK] = ACTIONS(235),
    [anon_sym_AT] = ACTIONS(238),
    [anon_sym_DASH] = ACTIONS(241),
    [anon_sym_LBRACE] = ACTIONS(244),
    [anon_sym_PLUS] = ACTIONS(241),
    [anon_sym_not] = ACTIONS(247),
    [anon_sym_TILDE] = ACTIONS(241),
    [anon_sym_lambda] = ACTIONS(250),
    [anon_sym_yield] = ACTIONS(253),
    [sym_ellipsis] = ACTIONS(256),
    [sym_integer] = ACTIONS(259),
    [sym_float] = ACTIONS(256),
    [anon_sym_await] = ACTIONS(262),
    [sym_true] = ACTIONS(259),
    [sym_false] = ACTIONS(259),
    [sym_none] = ACTIONS(259),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(335),
    [anon_sym_container] = ACTIONS(335),
    [anon_sym_envvars] = ACTIONS(335),
    [anon_sym_include] = ACTIONS(335),
    [anon_sym_pepfile] = ACTIONS(335),
    [anon_sym_pepschema] = ACTIONS(335),
    [anon_sym_scattergather] = ACTIONS(335),
    [anon_sym_version] = ACTIONS(335),
    [anon_sym_wildcard_constraints] = ACTIONS(335),
    [anon_sym_workdir] = ACTIONS(335),
    [anon_sym_onerror] = ACTIONS(338),
    [anon_sym_onstart] = ACTIONS(338),
    [anon_sym_onsuccess] = ACTIONS(338),
    [anon_sym_localrules] = ACTIONS(341),
    [anon_sym_ruleorder] = ACTIONS(344),
    [anon_sym_rule] = ACTIONS(347),
    [anon_sym_checkpoint] = ACTIONS(350),
    [anon_sym_use] = ACTIONS(353),
    [anon_sym_module] = ACTIONS(356),
    [sym__dedent] = ACTIONS(155),
    [sym_string_start] = ACTIONS(289),
  },
  [77] = {
    [sym_named_expression] = STATE(2104),
    [sym__named_expression_lhs] = STATE(3286),
    [sym_list_splat_pattern] = STATE(1541),
    [sym_as_pattern] = STATE(2104),
    [sym_expression] = STATE(2153),
    [sym_primary_expression] = STATE(1233),
    [sym_not_operator] = STATE(2104),
    [sym_boolean_operator] = STATE(2104),
    [sym_binary_operator] = STATE(1536),
    [sym_unary_operator] = STATE(1536),
    [sym_comparison_operator] = STATE(2104),
    [sym_lambda] = STATE(2104),
    [sym_attribute] = STATE(1536),
    [sym_subscript] = STATE(1536),
    [sym_call] = STATE(1536),
    [sym_type] = STATE(2565),
    [sym_splat_type] = STATE(2508),
    [sym_generic_type] = STATE(2508),
    [sym_union_type] = STATE(2508),
    [sym_constrained_type] = STATE(2508),
    [sym_member_type] = STATE(2508),
    [sym_list] = STATE(1536),
    [sym_set] = STATE(1536),
    [sym_tuple] = STATE(1536),
    [sym_dictionary] = STATE(1536),
    [sym_list_comprehension] = STATE(1536),
    [sym_dictionary_comprehension] = STATE(1536),
    [sym_set_comprehension] = STATE(1536),
    [sym_generator_expression] = STATE(1536),
    [sym_parenthesized_expression] = STATE(1536),
    [sym_conditional_expression] = STATE(2104),
    [sym_concatenated_string] = STATE(1536),
    [sym_string] = STATE(1234),
    [sym_await] = STATE(1536),
    [sym_identifier] = ACTIONS(359),
    [anon_sym_SEMI] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(363),
    [anon_sym_LPAREN] = ACTIONS(365),
    [anon_sym_COMMA] = ACTIONS(368),
    [anon_sym_as] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(371),
    [anon_sym_print] = ACTIONS(374),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_COLON_EQ] = ACTIONS(376),
    [anon_sym_if] = ACTIONS(363),
    [anon_sym_COLON] = ACTIONS(378),
    [anon_sym_match] = ACTIONS(374),
    [anon_sym_async] = ACTIONS(374),
    [anon_sym_in] = ACTIONS(363),
    [anon_sym_STAR_STAR] = ACTIONS(380),
    [anon_sym_exec] = ACTIONS(374),
    [anon_sym_type] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(378),
    [anon_sym_LBRACK] = ACTIONS(385),
    [anon_sym_AT] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(388),
    [anon_sym_PIPE] = ACTIONS(363),
    [anon_sym_LBRACE] = ACTIONS(391),
    [anon_sym_PLUS] = ACTIONS(388),
    [anon_sym_not] = ACTIONS(393),
    [anon_sym_and] = ACTIONS(363),
    [anon_sym_or] = ACTIONS(363),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_SLASH_SLASH] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(361),
    [anon_sym_EQ_EQ] = ACTIONS(361),
    [anon_sym_BANG_EQ] = ACTIONS(361),
    [anon_sym_GT_EQ] = ACTIONS(361),
    [anon_sym_GT] = ACTIONS(363),
    [anon_sym_LT_GT] = ACTIONS(361),
    [anon_sym_is] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(398),
    [anon_sym_PLUS_EQ] = ACTIONS(400),
    [anon_sym_DASH_EQ] = ACTIONS(400),
    [anon_sym_STAR_EQ] = ACTIONS(400),
    [anon_sym_SLASH_EQ] = ACTIONS(400),
    [anon_sym_AT_EQ] = ACTIONS(400),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(400),
    [anon_sym_PERCENT_EQ] = ACTIONS(400),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(400),
    [anon_sym_GT_GT_EQ] = ACTIONS(400),
    [anon_sym_LT_LT_EQ] = ACTIONS(400),
    [anon_sym_AMP_EQ] = ACTIONS(400),
    [anon_sym_CARET_EQ] = ACTIONS(400),
    [anon_sym_PIPE_EQ] = ACTIONS(400),
    [sym_ellipsis] = ACTIONS(402),
    [sym_integer] = ACTIONS(404),
    [sym_float] = ACTIONS(402),
    [anon_sym_await] = ACTIONS(406),
    [sym_true] = ACTIONS(404),
    [sym_false] = ACTIONS(404),
    [sym_none] = ACTIONS(404),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(361),
    [sym_string_start] = ACTIONS(408),
  },
  [78] = {
    [sym_named_expression] = STATE(2104),
    [sym__named_expression_lhs] = STATE(3286),
    [sym_list_splat_pattern] = STATE(1541),
    [sym_as_pattern] = STATE(2104),
    [sym_expression] = STATE(2153),
    [sym_primary_expression] = STATE(1233),
    [sym_not_operator] = STATE(2104),
    [sym_boolean_operator] = STATE(2104),
    [sym_binary_operator] = STATE(1536),
    [sym_unary_operator] = STATE(1536),
    [sym_comparison_operator] = STATE(2104),
    [sym_lambda] = STATE(2104),
    [sym_attribute] = STATE(1536),
    [sym_subscript] = STATE(1536),
    [sym_call] = STATE(1536),
    [sym_type] = STATE(2565),
    [sym_splat_type] = STATE(2508),
    [sym_generic_type] = STATE(2508),
    [sym_union_type] = STATE(2508),
    [sym_constrained_type] = STATE(2508),
    [sym_member_type] = STATE(2508),
    [sym_list] = STATE(1536),
    [sym_set] = STATE(1536),
    [sym_tuple] = STATE(1536),
    [sym_dictionary] = STATE(1536),
    [sym_list_comprehension] = STATE(1536),
    [sym_dictionary_comprehension] = STATE(1536),
    [sym_set_comprehension] = STATE(1536),
    [sym_generator_expression] = STATE(1536),
    [sym_parenthesized_expression] = STATE(1536),
    [sym_conditional_expression] = STATE(2104),
    [sym_concatenated_string] = STATE(1536),
    [sym_string] = STATE(1234),
    [sym_await] = STATE(1536),
    [sym_identifier] = ACTIONS(359),
    [anon_sym_SEMI] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(363),
    [anon_sym_LPAREN] = ACTIONS(365),
    [anon_sym_COMMA] = ACTIONS(368),
    [anon_sym_as] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(371),
    [anon_sym_print] = ACTIONS(374),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_COLON_EQ] = ACTIONS(376),
    [anon_sym_if] = ACTIONS(363),
    [anon_sym_COLON] = ACTIONS(410),
    [anon_sym_match] = ACTIONS(374),
    [anon_sym_async] = ACTIONS(374),
    [anon_sym_in] = ACTIONS(363),
    [anon_sym_STAR_STAR] = ACTIONS(380),
    [anon_sym_exec] = ACTIONS(374),
    [anon_sym_type] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(378),
    [anon_sym_LBRACK] = ACTIONS(385),
    [anon_sym_AT] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(388),
    [anon_sym_PIPE] = ACTIONS(363),
    [anon_sym_LBRACE] = ACTIONS(391),
    [anon_sym_PLUS] = ACTIONS(388),
    [anon_sym_not] = ACTIONS(393),
    [anon_sym_and] = ACTIONS(363),
    [anon_sym_or] = ACTIONS(363),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_SLASH_SLASH] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(361),
    [anon_sym_EQ_EQ] = ACTIONS(361),
    [anon_sym_BANG_EQ] = ACTIONS(361),
    [anon_sym_GT_EQ] = ACTIONS(361),
    [anon_sym_GT] = ACTIONS(363),
    [anon_sym_LT_GT] = ACTIONS(361),
    [anon_sym_is] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(398),
    [anon_sym_PLUS_EQ] = ACTIONS(400),
    [anon_sym_DASH_EQ] = ACTIONS(400),
    [anon_sym_STAR_EQ] = ACTIONS(400),
    [anon_sym_SLASH_EQ] = ACTIONS(400),
    [anon_sym_AT_EQ] = ACTIONS(400),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(400),
    [anon_sym_PERCENT_EQ] = ACTIONS(400),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(400),
    [anon_sym_GT_GT_EQ] = ACTIONS(400),
    [anon_sym_LT_LT_EQ] = ACTIONS(400),
    [anon_sym_AMP_EQ] = ACTIONS(400),
    [anon_sym_CARET_EQ] = ACTIONS(400),
    [anon_sym_PIPE_EQ] = ACTIONS(400),
    [sym_ellipsis] = ACTIONS(402),
    [sym_integer] = ACTIONS(404),
    [sym_float] = ACTIONS(402),
    [anon_sym_await] = ACTIONS(406),
    [sym_true] = ACTIONS(404),
    [sym_false] = ACTIONS(404),
    [sym_none] = ACTIONS(404),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(361),
    [sym_string_start] = ACTIONS(408),
  },
  [79] = {
    [sym__simple_statements] = STATE(353),
    [sym_import_statement] = STATE(2679),
    [sym_future_import_statement] = STATE(2679),
    [sym_import_from_statement] = STATE(2679),
    [sym_print_statement] = STATE(2679),
    [sym_assert_statement] = STATE(2679),
    [sym_expression_statement] = STATE(2679),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2679),
    [sym_delete_statement] = STATE(2679),
    [sym_raise_statement] = STATE(2679),
    [sym_pass_statement] = STATE(2679),
    [sym_break_statement] = STATE(2679),
    [sym_continue_statement] = STATE(2679),
    [sym_global_statement] = STATE(2679),
    [sym_nonlocal_statement] = STATE(2679),
    [sym_exec_statement] = STATE(2679),
    [sym_type_alias_statement] = STATE(2679),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1036),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2074),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1037),
    [sym_subscript] = STATE(1037),
    [sym_call] = STATE(1312),
    [sym_type] = STATE(2466),
    [sym_splat_type] = STATE(2508),
    [sym_generic_type] = STATE(2508),
    [sym_union_type] = STATE(2508),
    [sym_constrained_type] = STATE(2508),
    [sym_member_type] = STATE(2508),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(413),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(417),
    [anon_sym_print] = ACTIONS(419),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(421),
    [anon_sym_async] = ACTIONS(421),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(425),
    [anon_sym_type] = ACTIONS(427),
    [anon_sym_LBRACK] = ACTIONS(429),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(431),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(433),
    [sym__indent] = ACTIONS(435),
    [sym_string_start] = ACTIONS(97),
  },
  [80] = {
    [sym__simple_statements] = STATE(369),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1036),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2074),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1037),
    [sym_subscript] = STATE(1037),
    [sym_call] = STATE(1312),
    [sym_type] = STATE(2466),
    [sym_splat_type] = STATE(2508),
    [sym_generic_type] = STATE(2508),
    [sym_union_type] = STATE(2508),
    [sym_constrained_type] = STATE(2508),
    [sym_member_type] = STATE(2508),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(413),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(417),
    [anon_sym_print] = ACTIONS(419),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(421),
    [anon_sym_async] = ACTIONS(421),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(425),
    [anon_sym_type] = ACTIONS(427),
    [anon_sym_LBRACK] = ACTIONS(429),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(431),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(437),
    [sym__indent] = ACTIONS(439),
    [sym_string_start] = ACTIONS(97),
  },
  [81] = {
    [sym__simple_statements] = STATE(363),
    [sym_import_statement] = STATE(2679),
    [sym_future_import_statement] = STATE(2679),
    [sym_import_from_statement] = STATE(2679),
    [sym_print_statement] = STATE(2679),
    [sym_assert_statement] = STATE(2679),
    [sym_expression_statement] = STATE(2679),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2679),
    [sym_delete_statement] = STATE(2679),
    [sym_raise_statement] = STATE(2679),
    [sym_pass_statement] = STATE(2679),
    [sym_break_statement] = STATE(2679),
    [sym_continue_statement] = STATE(2679),
    [sym_global_statement] = STATE(2679),
    [sym_nonlocal_statement] = STATE(2679),
    [sym_exec_statement] = STATE(2679),
    [sym_type_alias_statement] = STATE(2679),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1036),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2074),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1037),
    [sym_subscript] = STATE(1037),
    [sym_call] = STATE(1312),
    [sym_type] = STATE(2466),
    [sym_splat_type] = STATE(2508),
    [sym_generic_type] = STATE(2508),
    [sym_union_type] = STATE(2508),
    [sym_constrained_type] = STATE(2508),
    [sym_member_type] = STATE(2508),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(413),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(417),
    [anon_sym_print] = ACTIONS(419),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(421),
    [anon_sym_async] = ACTIONS(421),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(425),
    [anon_sym_type] = ACTIONS(427),
    [anon_sym_LBRACK] = ACTIONS(429),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(431),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(441),
    [sym__indent] = ACTIONS(443),
    [sym_string_start] = ACTIONS(97),
  },
  [82] = {
    [sym__simple_statements] = STATE(337),
    [sym_import_statement] = STATE(2679),
    [sym_future_import_statement] = STATE(2679),
    [sym_import_from_statement] = STATE(2679),
    [sym_print_statement] = STATE(2679),
    [sym_assert_statement] = STATE(2679),
    [sym_expression_statement] = STATE(2679),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2679),
    [sym_delete_statement] = STATE(2679),
    [sym_raise_statement] = STATE(2679),
    [sym_pass_statement] = STATE(2679),
    [sym_break_statement] = STATE(2679),
    [sym_continue_statement] = STATE(2679),
    [sym_global_statement] = STATE(2679),
    [sym_nonlocal_statement] = STATE(2679),
    [sym_exec_statement] = STATE(2679),
    [sym_type_alias_statement] = STATE(2679),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1036),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2074),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1037),
    [sym_subscript] = STATE(1037),
    [sym_call] = STATE(1312),
    [sym_type] = STATE(2466),
    [sym_splat_type] = STATE(2508),
    [sym_generic_type] = STATE(2508),
    [sym_union_type] = STATE(2508),
    [sym_constrained_type] = STATE(2508),
    [sym_member_type] = STATE(2508),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(413),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(417),
    [anon_sym_print] = ACTIONS(419),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(421),
    [anon_sym_async] = ACTIONS(421),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(425),
    [anon_sym_type] = ACTIONS(427),
    [anon_sym_LBRACK] = ACTIONS(429),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(431),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(445),
    [sym__indent] = ACTIONS(447),
    [sym_string_start] = ACTIONS(97),
  },
  [83] = {
    [sym__simple_statements] = STATE(415),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1036),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2074),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1037),
    [sym_subscript] = STATE(1037),
    [sym_call] = STATE(1312),
    [sym_type] = STATE(2466),
    [sym_splat_type] = STATE(2508),
    [sym_generic_type] = STATE(2508),
    [sym_union_type] = STATE(2508),
    [sym_constrained_type] = STATE(2508),
    [sym_member_type] = STATE(2508),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(413),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(417),
    [anon_sym_print] = ACTIONS(419),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(421),
    [anon_sym_async] = ACTIONS(421),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(425),
    [anon_sym_type] = ACTIONS(427),
    [anon_sym_LBRACK] = ACTIONS(429),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(431),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(449),
    [sym__indent] = ACTIONS(451),
    [sym_string_start] = ACTIONS(97),
  },
  [84] = {
    [sym__simple_statements] = STATE(377),
    [sym_import_statement] = STATE(2679),
    [sym_future_import_statement] = STATE(2679),
    [sym_import_from_statement] = STATE(2679),
    [sym_print_statement] = STATE(2679),
    [sym_assert_statement] = STATE(2679),
    [sym_expression_statement] = STATE(2679),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2679),
    [sym_delete_statement] = STATE(2679),
    [sym_raise_statement] = STATE(2679),
    [sym_pass_statement] = STATE(2679),
    [sym_break_statement] = STATE(2679),
    [sym_continue_statement] = STATE(2679),
    [sym_global_statement] = STATE(2679),
    [sym_nonlocal_statement] = STATE(2679),
    [sym_exec_statement] = STATE(2679),
    [sym_type_alias_statement] = STATE(2679),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1036),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2074),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1037),
    [sym_subscript] = STATE(1037),
    [sym_call] = STATE(1312),
    [sym_type] = STATE(2466),
    [sym_splat_type] = STATE(2508),
    [sym_generic_type] = STATE(2508),
    [sym_union_type] = STATE(2508),
    [sym_constrained_type] = STATE(2508),
    [sym_member_type] = STATE(2508),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(413),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(417),
    [anon_sym_print] = ACTIONS(419),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(421),
    [anon_sym_async] = ACTIONS(421),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(425),
    [anon_sym_type] = ACTIONS(427),
    [anon_sym_LBRACK] = ACTIONS(429),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(431),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(453),
    [sym__indent] = ACTIONS(455),
    [sym_string_start] = ACTIONS(97),
  },
  [85] = {
    [sym__simple_statements] = STATE(397),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1036),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2074),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1037),
    [sym_subscript] = STATE(1037),
    [sym_call] = STATE(1312),
    [sym_type] = STATE(2466),
    [sym_splat_type] = STATE(2508),
    [sym_generic_type] = STATE(2508),
    [sym_union_type] = STATE(2508),
    [sym_constrained_type] = STATE(2508),
    [sym_member_type] = STATE(2508),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(413),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(417),
    [anon_sym_print] = ACTIONS(419),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(421),
    [anon_sym_async] = ACTIONS(421),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(425),
    [anon_sym_type] = ACTIONS(427),
    [anon_sym_LBRACK] = ACTIONS(429),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(431),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(457),
    [sym__indent] = ACTIONS(459),
    [sym_string_start] = ACTIONS(97),
  },
  [86] = {
    [sym__simple_statements] = STATE(429),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1036),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2074),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1037),
    [sym_subscript] = STATE(1037),
    [sym_call] = STATE(1312),
    [sym_type] = STATE(2466),
    [sym_splat_type] = STATE(2508),
    [sym_generic_type] = STATE(2508),
    [sym_union_type] = STATE(2508),
    [sym_constrained_type] = STATE(2508),
    [sym_member_type] = STATE(2508),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(413),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(417),
    [anon_sym_print] = ACTIONS(419),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(421),
    [anon_sym_async] = ACTIONS(421),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(425),
    [anon_sym_type] = ACTIONS(427),
    [anon_sym_LBRACK] = ACTIONS(429),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(431),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(461),
    [sym__indent] = ACTIONS(463),
    [sym_string_start] = ACTIONS(97),
  },
  [87] = {
    [sym_chevron] = STATE(2597),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_list_splat_pattern] = STATE(1314),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2229),
    [sym_primary_expression] = STATE(1203),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_attribute] = STATE(1312),
    [sym_subscript] = STATE(1312),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(465),
    [anon_sym_SEMI] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(363),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_COMMA] = ACTIONS(368),
    [anon_sym_as] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_print] = ACTIONS(473),
    [anon_sym_GT_GT] = ACTIONS(475),
    [anon_sym_COLON_EQ] = ACTIONS(376),
    [anon_sym_if] = ACTIONS(363),
    [anon_sym_COLON] = ACTIONS(410),
    [anon_sym_match] = ACTIONS(473),
    [anon_sym_async] = ACTIONS(473),
    [anon_sym_in] = ACTIONS(363),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_exec] = ACTIONS(473),
    [anon_sym_type] = ACTIONS(477),
    [anon_sym_EQ] = ACTIONS(378),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_AT] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(482),
    [anon_sym_PIPE] = ACTIONS(363),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(482),
    [anon_sym_not] = ACTIONS(485),
    [anon_sym_and] = ACTIONS(363),
    [anon_sym_or] = ACTIONS(363),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_SLASH_SLASH] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(361),
    [anon_sym_EQ_EQ] = ACTIONS(361),
    [anon_sym_BANG_EQ] = ACTIONS(361),
    [anon_sym_GT_EQ] = ACTIONS(361),
    [anon_sym_GT] = ACTIONS(363),
    [anon_sym_LT_GT] = ACTIONS(361),
    [anon_sym_is] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_PLUS_EQ] = ACTIONS(400),
    [anon_sym_DASH_EQ] = ACTIONS(400),
    [anon_sym_STAR_EQ] = ACTIONS(400),
    [anon_sym_SLASH_EQ] = ACTIONS(400),
    [anon_sym_AT_EQ] = ACTIONS(400),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(400),
    [anon_sym_PERCENT_EQ] = ACTIONS(400),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(400),
    [anon_sym_GT_GT_EQ] = ACTIONS(400),
    [anon_sym_LT_LT_EQ] = ACTIONS(400),
    [anon_sym_AMP_EQ] = ACTIONS(400),
    [anon_sym_CARET_EQ] = ACTIONS(400),
    [anon_sym_PIPE_EQ] = ACTIONS(400),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(488),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(361),
    [sym_string_start] = ACTIONS(97),
  },
  [88] = {
    [sym_chevron] = STATE(2597),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_list_splat_pattern] = STATE(1314),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2229),
    [sym_primary_expression] = STATE(1203),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_attribute] = STATE(1312),
    [sym_subscript] = STATE(1312),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(465),
    [anon_sym_SEMI] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(363),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_COMMA] = ACTIONS(368),
    [anon_sym_as] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_print] = ACTIONS(473),
    [anon_sym_GT_GT] = ACTIONS(475),
    [anon_sym_COLON_EQ] = ACTIONS(376),
    [anon_sym_if] = ACTIONS(363),
    [anon_sym_COLON] = ACTIONS(378),
    [anon_sym_match] = ACTIONS(473),
    [anon_sym_async] = ACTIONS(473),
    [anon_sym_in] = ACTIONS(363),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_exec] = ACTIONS(473),
    [anon_sym_type] = ACTIONS(477),
    [anon_sym_EQ] = ACTIONS(378),
    [anon_sym_LBRACK] = ACTIONS(479),
    [anon_sym_AT] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(482),
    [anon_sym_PIPE] = ACTIONS(363),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(482),
    [anon_sym_not] = ACTIONS(485),
    [anon_sym_and] = ACTIONS(363),
    [anon_sym_or] = ACTIONS(363),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_SLASH_SLASH] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(361),
    [anon_sym_EQ_EQ] = ACTIONS(361),
    [anon_sym_BANG_EQ] = ACTIONS(361),
    [anon_sym_GT_EQ] = ACTIONS(361),
    [anon_sym_GT] = ACTIONS(363),
    [anon_sym_LT_GT] = ACTIONS(361),
    [anon_sym_is] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_PLUS_EQ] = ACTIONS(400),
    [anon_sym_DASH_EQ] = ACTIONS(400),
    [anon_sym_STAR_EQ] = ACTIONS(400),
    [anon_sym_SLASH_EQ] = ACTIONS(400),
    [anon_sym_AT_EQ] = ACTIONS(400),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(400),
    [anon_sym_PERCENT_EQ] = ACTIONS(400),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(400),
    [anon_sym_GT_GT_EQ] = ACTIONS(400),
    [anon_sym_LT_LT_EQ] = ACTIONS(400),
    [anon_sym_AMP_EQ] = ACTIONS(400),
    [anon_sym_CARET_EQ] = ACTIONS(400),
    [anon_sym_PIPE_EQ] = ACTIONS(400),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(488),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(361),
    [sym_string_start] = ACTIONS(97),
  },
  [89] = {
    [sym_named_expression] = STATE(2104),
    [sym__named_expression_lhs] = STATE(3286),
    [sym_list_splat_pattern] = STATE(1541),
    [sym_as_pattern] = STATE(2104),
    [sym_expression] = STATE(2284),
    [sym_primary_expression] = STATE(1233),
    [sym_not_operator] = STATE(2104),
    [sym_boolean_operator] = STATE(2104),
    [sym_binary_operator] = STATE(1536),
    [sym_unary_operator] = STATE(1536),
    [sym_comparison_operator] = STATE(2104),
    [sym_lambda] = STATE(2104),
    [sym_attribute] = STATE(1536),
    [sym_subscript] = STATE(1536),
    [sym_call] = STATE(1536),
    [sym_list] = STATE(1536),
    [sym_set] = STATE(1536),
    [sym_tuple] = STATE(1536),
    [sym_dictionary] = STATE(1536),
    [sym_list_comprehension] = STATE(1536),
    [sym_dictionary_comprehension] = STATE(1536),
    [sym_set_comprehension] = STATE(1536),
    [sym_generator_expression] = STATE(1536),
    [sym_parenthesized_expression] = STATE(1536),
    [sym_conditional_expression] = STATE(2104),
    [sym_concatenated_string] = STATE(1536),
    [sym_string] = STATE(1234),
    [sym_await] = STATE(1536),
    [sym_identifier] = ACTIONS(490),
    [anon_sym_SEMI] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(363),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_COMMA] = ACTIONS(368),
    [anon_sym_as] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(494),
    [anon_sym_print] = ACTIONS(374),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_COLON_EQ] = ACTIONS(376),
    [anon_sym_if] = ACTIONS(363),
    [anon_sym_COLON] = ACTIONS(378),
    [anon_sym_match] = ACTIONS(374),
    [anon_sym_async] = ACTIONS(374),
    [anon_sym_in] = ACTIONS(363),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_exec] = ACTIONS(374),
    [anon_sym_type] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(378),
    [anon_sym_LBRACK] = ACTIONS(496),
    [anon_sym_AT] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_PIPE] = ACTIONS(363),
    [anon_sym_LBRACE] = ACTIONS(391),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_not] = ACTIONS(500),
    [anon_sym_and] = ACTIONS(363),
    [anon_sym_or] = ACTIONS(363),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_SLASH_SLASH] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(361),
    [anon_sym_EQ_EQ] = ACTIONS(361),
    [anon_sym_BANG_EQ] = ACTIONS(361),
    [anon_sym_GT_EQ] = ACTIONS(361),
    [anon_sym_GT] = ACTIONS(363),
    [anon_sym_LT_GT] = ACTIONS(361),
    [anon_sym_is] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(398),
    [anon_sym_PLUS_EQ] = ACTIONS(400),
    [anon_sym_DASH_EQ] = ACTIONS(400),
    [anon_sym_STAR_EQ] = ACTIONS(400),
    [anon_sym_SLASH_EQ] = ACTIONS(400),
    [anon_sym_AT_EQ] = ACTIONS(400),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(400),
    [anon_sym_PERCENT_EQ] = ACTIONS(400),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(400),
    [anon_sym_GT_GT_EQ] = ACTIONS(400),
    [anon_sym_LT_LT_EQ] = ACTIONS(400),
    [anon_sym_AMP_EQ] = ACTIONS(400),
    [anon_sym_CARET_EQ] = ACTIONS(400),
    [anon_sym_PIPE_EQ] = ACTIONS(400),
    [sym_ellipsis] = ACTIONS(402),
    [sym_integer] = ACTIONS(404),
    [sym_float] = ACTIONS(402),
    [anon_sym_await] = ACTIONS(406),
    [sym_true] = ACTIONS(404),
    [sym_false] = ACTIONS(404),
    [sym_none] = ACTIONS(404),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(361),
    [sym_string_start] = ACTIONS(408),
  },
  [90] = {
    [sym_named_expression] = STATE(2104),
    [sym__named_expression_lhs] = STATE(3286),
    [sym_list_splat_pattern] = STATE(1541),
    [sym_as_pattern] = STATE(2104),
    [sym_expression] = STATE(2272),
    [sym_primary_expression] = STATE(1233),
    [sym_not_operator] = STATE(2104),
    [sym_boolean_operator] = STATE(2104),
    [sym_binary_operator] = STATE(1536),
    [sym_unary_operator] = STATE(1536),
    [sym_comparison_operator] = STATE(2104),
    [sym_lambda] = STATE(2104),
    [sym_attribute] = STATE(1536),
    [sym_subscript] = STATE(1536),
    [sym_call] = STATE(1536),
    [sym_list] = STATE(1536),
    [sym_set] = STATE(1536),
    [sym_tuple] = STATE(1536),
    [sym_dictionary] = STATE(1536),
    [sym_list_comprehension] = STATE(1536),
    [sym_dictionary_comprehension] = STATE(1536),
    [sym_set_comprehension] = STATE(1536),
    [sym_generator_expression] = STATE(1536),
    [sym_parenthesized_expression] = STATE(1536),
    [sym_conditional_expression] = STATE(2104),
    [sym_concatenated_string] = STATE(1536),
    [sym_string] = STATE(1234),
    [sym_await] = STATE(1536),
    [sym_identifier] = ACTIONS(490),
    [anon_sym_SEMI] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(363),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_COMMA] = ACTIONS(368),
    [anon_sym_as] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(494),
    [anon_sym_print] = ACTIONS(374),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_COLON_EQ] = ACTIONS(376),
    [anon_sym_if] = ACTIONS(363),
    [anon_sym_COLON] = ACTIONS(378),
    [anon_sym_match] = ACTIONS(374),
    [anon_sym_async] = ACTIONS(374),
    [anon_sym_in] = ACTIONS(363),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_exec] = ACTIONS(374),
    [anon_sym_type] = ACTIONS(383),
    [anon_sym_EQ] = ACTIONS(378),
    [anon_sym_LBRACK] = ACTIONS(496),
    [anon_sym_AT] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_PIPE] = ACTIONS(363),
    [anon_sym_LBRACE] = ACTIONS(391),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_not] = ACTIONS(500),
    [anon_sym_and] = ACTIONS(363),
    [anon_sym_or] = ACTIONS(363),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_SLASH_SLASH] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(361),
    [anon_sym_EQ_EQ] = ACTIONS(361),
    [anon_sym_BANG_EQ] = ACTIONS(361),
    [anon_sym_GT_EQ] = ACTIONS(361),
    [anon_sym_GT] = ACTIONS(363),
    [anon_sym_LT_GT] = ACTIONS(361),
    [anon_sym_is] = ACTIONS(363),
    [anon_sym_lambda] = ACTIONS(398),
    [anon_sym_PLUS_EQ] = ACTIONS(400),
    [anon_sym_DASH_EQ] = ACTIONS(400),
    [anon_sym_STAR_EQ] = ACTIONS(400),
    [anon_sym_SLASH_EQ] = ACTIONS(400),
    [anon_sym_AT_EQ] = ACTIONS(400),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(400),
    [anon_sym_PERCENT_EQ] = ACTIONS(400),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(400),
    [anon_sym_GT_GT_EQ] = ACTIONS(400),
    [anon_sym_LT_LT_EQ] = ACTIONS(400),
    [anon_sym_AMP_EQ] = ACTIONS(400),
    [anon_sym_CARET_EQ] = ACTIONS(400),
    [anon_sym_PIPE_EQ] = ACTIONS(400),
    [sym_ellipsis] = ACTIONS(402),
    [sym_integer] = ACTIONS(404),
    [sym_float] = ACTIONS(402),
    [anon_sym_await] = ACTIONS(406),
    [sym_true] = ACTIONS(404),
    [sym_false] = ACTIONS(404),
    [sym_none] = ACTIONS(404),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(361),
    [sym_string_start] = ACTIONS(408),
  },
  [91] = {
    [sym__simple_statements] = STATE(350),
    [sym_import_statement] = STATE(2679),
    [sym_future_import_statement] = STATE(2679),
    [sym_import_from_statement] = STATE(2679),
    [sym_print_statement] = STATE(2679),
    [sym_assert_statement] = STATE(2679),
    [sym_expression_statement] = STATE(2679),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2679),
    [sym_delete_statement] = STATE(2679),
    [sym_raise_statement] = STATE(2679),
    [sym_pass_statement] = STATE(2679),
    [sym_break_statement] = STATE(2679),
    [sym_continue_statement] = STATE(2679),
    [sym_global_statement] = STATE(2679),
    [sym_nonlocal_statement] = STATE(2679),
    [sym_exec_statement] = STATE(2679),
    [sym_type_alias_statement] = STATE(2679),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(504),
    [sym__indent] = ACTIONS(506),
    [sym_string_start] = ACTIONS(97),
  },
  [92] = {
    [sym__simple_statements] = STATE(2210),
    [sym_import_statement] = STATE(2727),
    [sym_future_import_statement] = STATE(2727),
    [sym_import_from_statement] = STATE(2727),
    [sym_print_statement] = STATE(2727),
    [sym_assert_statement] = STATE(2727),
    [sym_expression_statement] = STATE(2727),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2727),
    [sym_delete_statement] = STATE(2727),
    [sym_raise_statement] = STATE(2727),
    [sym_pass_statement] = STATE(2727),
    [sym_break_statement] = STATE(2727),
    [sym_continue_statement] = STATE(2727),
    [sym_global_statement] = STATE(2727),
    [sym_nonlocal_statement] = STATE(2727),
    [sym_exec_statement] = STATE(2727),
    [sym_type_alias_statement] = STATE(2727),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(508),
    [sym__indent] = ACTIONS(510),
    [sym_string_start] = ACTIONS(97),
  },
  [93] = {
    [sym__simple_statements] = STATE(206),
    [sym_import_statement] = STATE(2679),
    [sym_future_import_statement] = STATE(2679),
    [sym_import_from_statement] = STATE(2679),
    [sym_print_statement] = STATE(2679),
    [sym_assert_statement] = STATE(2679),
    [sym_expression_statement] = STATE(2679),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2679),
    [sym_delete_statement] = STATE(2679),
    [sym_raise_statement] = STATE(2679),
    [sym_pass_statement] = STATE(2679),
    [sym_break_statement] = STATE(2679),
    [sym_continue_statement] = STATE(2679),
    [sym_global_statement] = STATE(2679),
    [sym_nonlocal_statement] = STATE(2679),
    [sym_exec_statement] = STATE(2679),
    [sym_type_alias_statement] = STATE(2679),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(512),
    [sym__indent] = ACTIONS(514),
    [sym_string_start] = ACTIONS(97),
  },
  [94] = {
    [sym__simple_statements] = STATE(300),
    [sym_import_statement] = STATE(2679),
    [sym_future_import_statement] = STATE(2679),
    [sym_import_from_statement] = STATE(2679),
    [sym_print_statement] = STATE(2679),
    [sym_assert_statement] = STATE(2679),
    [sym_expression_statement] = STATE(2679),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2679),
    [sym_delete_statement] = STATE(2679),
    [sym_raise_statement] = STATE(2679),
    [sym_pass_statement] = STATE(2679),
    [sym_break_statement] = STATE(2679),
    [sym_continue_statement] = STATE(2679),
    [sym_global_statement] = STATE(2679),
    [sym_nonlocal_statement] = STATE(2679),
    [sym_exec_statement] = STATE(2679),
    [sym_type_alias_statement] = STATE(2679),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(516),
    [sym__indent] = ACTIONS(518),
    [sym_string_start] = ACTIONS(97),
  },
  [95] = {
    [sym__simple_statements] = STATE(283),
    [sym_import_statement] = STATE(2910),
    [sym_future_import_statement] = STATE(2910),
    [sym_import_from_statement] = STATE(2910),
    [sym_print_statement] = STATE(2910),
    [sym_assert_statement] = STATE(2910),
    [sym_expression_statement] = STATE(2910),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2910),
    [sym_delete_statement] = STATE(2910),
    [sym_raise_statement] = STATE(2910),
    [sym_pass_statement] = STATE(2910),
    [sym_break_statement] = STATE(2910),
    [sym_continue_statement] = STATE(2910),
    [sym_global_statement] = STATE(2910),
    [sym_nonlocal_statement] = STATE(2910),
    [sym_exec_statement] = STATE(2910),
    [sym_type_alias_statement] = STATE(2910),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(520),
    [sym__indent] = ACTIONS(522),
    [sym_string_start] = ACTIONS(97),
  },
  [96] = {
    [sym__simple_statements] = STATE(294),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(524),
    [sym__indent] = ACTIONS(526),
    [sym_string_start] = ACTIONS(97),
  },
  [97] = {
    [sym__simple_statements] = STATE(470),
    [sym_import_statement] = STATE(2679),
    [sym_future_import_statement] = STATE(2679),
    [sym_import_from_statement] = STATE(2679),
    [sym_print_statement] = STATE(2679),
    [sym_assert_statement] = STATE(2679),
    [sym_expression_statement] = STATE(2679),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2679),
    [sym_delete_statement] = STATE(2679),
    [sym_raise_statement] = STATE(2679),
    [sym_pass_statement] = STATE(2679),
    [sym_break_statement] = STATE(2679),
    [sym_continue_statement] = STATE(2679),
    [sym_global_statement] = STATE(2679),
    [sym_nonlocal_statement] = STATE(2679),
    [sym_exec_statement] = STATE(2679),
    [sym_type_alias_statement] = STATE(2679),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(528),
    [sym__indent] = ACTIONS(530),
    [sym_string_start] = ACTIONS(97),
  },
  [98] = {
    [sym__simple_statements] = STATE(463),
    [sym_import_statement] = STATE(2679),
    [sym_future_import_statement] = STATE(2679),
    [sym_import_from_statement] = STATE(2679),
    [sym_print_statement] = STATE(2679),
    [sym_assert_statement] = STATE(2679),
    [sym_expression_statement] = STATE(2679),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2679),
    [sym_delete_statement] = STATE(2679),
    [sym_raise_statement] = STATE(2679),
    [sym_pass_statement] = STATE(2679),
    [sym_break_statement] = STATE(2679),
    [sym_continue_statement] = STATE(2679),
    [sym_global_statement] = STATE(2679),
    [sym_nonlocal_statement] = STATE(2679),
    [sym_exec_statement] = STATE(2679),
    [sym_type_alias_statement] = STATE(2679),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(532),
    [sym__indent] = ACTIONS(534),
    [sym_string_start] = ACTIONS(97),
  },
  [99] = {
    [sym__simple_statements] = STATE(336),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(536),
    [sym__indent] = ACTIONS(538),
    [sym_string_start] = ACTIONS(97),
  },
  [100] = {
    [sym__simple_statements] = STATE(331),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(540),
    [sym__indent] = ACTIONS(542),
    [sym_string_start] = ACTIONS(97),
  },
  [101] = {
    [sym__simple_statements] = STATE(340),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(544),
    [sym__indent] = ACTIONS(546),
    [sym_string_start] = ACTIONS(97),
  },
  [102] = {
    [sym__simple_statements] = STATE(461),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(548),
    [sym__indent] = ACTIONS(550),
    [sym_string_start] = ACTIONS(97),
  },
  [103] = {
    [sym__simple_statements] = STATE(462),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(552),
    [sym__indent] = ACTIONS(554),
    [sym_string_start] = ACTIONS(97),
  },
  [104] = {
    [sym__simple_statements] = STATE(467),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(556),
    [sym__indent] = ACTIONS(558),
    [sym_string_start] = ACTIONS(97),
  },
  [105] = {
    [sym__simple_statements] = STATE(482),
    [sym_import_statement] = STATE(2679),
    [sym_future_import_statement] = STATE(2679),
    [sym_import_from_statement] = STATE(2679),
    [sym_print_statement] = STATE(2679),
    [sym_assert_statement] = STATE(2679),
    [sym_expression_statement] = STATE(2679),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2679),
    [sym_delete_statement] = STATE(2679),
    [sym_raise_statement] = STATE(2679),
    [sym_pass_statement] = STATE(2679),
    [sym_break_statement] = STATE(2679),
    [sym_continue_statement] = STATE(2679),
    [sym_global_statement] = STATE(2679),
    [sym_nonlocal_statement] = STATE(2679),
    [sym_exec_statement] = STATE(2679),
    [sym_type_alias_statement] = STATE(2679),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(560),
    [sym__indent] = ACTIONS(562),
    [sym_string_start] = ACTIONS(97),
  },
  [106] = {
    [sym__simple_statements] = STATE(407),
    [sym_import_statement] = STATE(2679),
    [sym_future_import_statement] = STATE(2679),
    [sym_import_from_statement] = STATE(2679),
    [sym_print_statement] = STATE(2679),
    [sym_assert_statement] = STATE(2679),
    [sym_expression_statement] = STATE(2679),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2679),
    [sym_delete_statement] = STATE(2679),
    [sym_raise_statement] = STATE(2679),
    [sym_pass_statement] = STATE(2679),
    [sym_break_statement] = STATE(2679),
    [sym_continue_statement] = STATE(2679),
    [sym_global_statement] = STATE(2679),
    [sym_nonlocal_statement] = STATE(2679),
    [sym_exec_statement] = STATE(2679),
    [sym_type_alias_statement] = STATE(2679),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(564),
    [sym__indent] = ACTIONS(566),
    [sym_string_start] = ACTIONS(97),
  },
  [107] = {
    [sym__simple_statements] = STATE(3124),
    [sym_import_statement] = STATE(2947),
    [sym_future_import_statement] = STATE(2947),
    [sym_import_from_statement] = STATE(2947),
    [sym_print_statement] = STATE(2947),
    [sym_assert_statement] = STATE(2947),
    [sym_expression_statement] = STATE(2947),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2947),
    [sym_delete_statement] = STATE(2947),
    [sym_raise_statement] = STATE(2947),
    [sym_pass_statement] = STATE(2947),
    [sym_break_statement] = STATE(2947),
    [sym_continue_statement] = STATE(2947),
    [sym_global_statement] = STATE(2947),
    [sym_nonlocal_statement] = STATE(2947),
    [sym_exec_statement] = STATE(2947),
    [sym_type_alias_statement] = STATE(2947),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(568),
    [sym__indent] = ACTIONS(570),
    [sym_string_start] = ACTIONS(97),
  },
  [108] = {
    [sym__simple_statements] = STATE(514),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(572),
    [sym__indent] = ACTIONS(574),
    [sym_string_start] = ACTIONS(97),
  },
  [109] = {
    [sym__simple_statements] = STATE(382),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(576),
    [sym__indent] = ACTIONS(578),
    [sym_string_start] = ACTIONS(97),
  },
  [110] = {
    [sym__simple_statements] = STATE(335),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(580),
    [sym__indent] = ACTIONS(582),
    [sym_string_start] = ACTIONS(97),
  },
  [111] = {
    [sym__simple_statements] = STATE(318),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(584),
    [sym__indent] = ACTIONS(586),
    [sym_string_start] = ACTIONS(97),
  },
  [112] = {
    [sym__simple_statements] = STATE(361),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(588),
    [sym__indent] = ACTIONS(590),
    [sym_string_start] = ACTIONS(97),
  },
  [113] = {
    [sym__simple_statements] = STATE(3111),
    [sym_import_statement] = STATE(2947),
    [sym_future_import_statement] = STATE(2947),
    [sym_import_from_statement] = STATE(2947),
    [sym_print_statement] = STATE(2947),
    [sym_assert_statement] = STATE(2947),
    [sym_expression_statement] = STATE(2947),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2947),
    [sym_delete_statement] = STATE(2947),
    [sym_raise_statement] = STATE(2947),
    [sym_pass_statement] = STATE(2947),
    [sym_break_statement] = STATE(2947),
    [sym_continue_statement] = STATE(2947),
    [sym_global_statement] = STATE(2947),
    [sym_nonlocal_statement] = STATE(2947),
    [sym_exec_statement] = STATE(2947),
    [sym_type_alias_statement] = STATE(2947),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(592),
    [sym__indent] = ACTIONS(594),
    [sym_string_start] = ACTIONS(97),
  },
  [114] = {
    [sym__simple_statements] = STATE(404),
    [sym_import_statement] = STATE(2679),
    [sym_future_import_statement] = STATE(2679),
    [sym_import_from_statement] = STATE(2679),
    [sym_print_statement] = STATE(2679),
    [sym_assert_statement] = STATE(2679),
    [sym_expression_statement] = STATE(2679),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2679),
    [sym_delete_statement] = STATE(2679),
    [sym_raise_statement] = STATE(2679),
    [sym_pass_statement] = STATE(2679),
    [sym_break_statement] = STATE(2679),
    [sym_continue_statement] = STATE(2679),
    [sym_global_statement] = STATE(2679),
    [sym_nonlocal_statement] = STATE(2679),
    [sym_exec_statement] = STATE(2679),
    [sym_type_alias_statement] = STATE(2679),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(596),
    [sym__indent] = ACTIONS(598),
    [sym_string_start] = ACTIONS(97),
  },
  [115] = {
    [sym__simple_statements] = STATE(242),
    [sym_import_statement] = STATE(2910),
    [sym_future_import_statement] = STATE(2910),
    [sym_import_from_statement] = STATE(2910),
    [sym_print_statement] = STATE(2910),
    [sym_assert_statement] = STATE(2910),
    [sym_expression_statement] = STATE(2910),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2910),
    [sym_delete_statement] = STATE(2910),
    [sym_raise_statement] = STATE(2910),
    [sym_pass_statement] = STATE(2910),
    [sym_break_statement] = STATE(2910),
    [sym_continue_statement] = STATE(2910),
    [sym_global_statement] = STATE(2910),
    [sym_nonlocal_statement] = STATE(2910),
    [sym_exec_statement] = STATE(2910),
    [sym_type_alias_statement] = STATE(2910),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(600),
    [sym__indent] = ACTIONS(602),
    [sym_string_start] = ACTIONS(97),
  },
  [116] = {
    [sym__simple_statements] = STATE(3104),
    [sym_import_statement] = STATE(2947),
    [sym_future_import_statement] = STATE(2947),
    [sym_import_from_statement] = STATE(2947),
    [sym_print_statement] = STATE(2947),
    [sym_assert_statement] = STATE(2947),
    [sym_expression_statement] = STATE(2947),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2947),
    [sym_delete_statement] = STATE(2947),
    [sym_raise_statement] = STATE(2947),
    [sym_pass_statement] = STATE(2947),
    [sym_break_statement] = STATE(2947),
    [sym_continue_statement] = STATE(2947),
    [sym_global_statement] = STATE(2947),
    [sym_nonlocal_statement] = STATE(2947),
    [sym_exec_statement] = STATE(2947),
    [sym_type_alias_statement] = STATE(2947),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(604),
    [sym__indent] = ACTIONS(606),
    [sym_string_start] = ACTIONS(97),
  },
  [117] = {
    [sym__simple_statements] = STATE(284),
    [sym_import_statement] = STATE(2816),
    [sym_future_import_statement] = STATE(2816),
    [sym_import_from_statement] = STATE(2816),
    [sym_print_statement] = STATE(2816),
    [sym_assert_statement] = STATE(2816),
    [sym_expression_statement] = STATE(2816),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2816),
    [sym_delete_statement] = STATE(2816),
    [sym_raise_statement] = STATE(2816),
    [sym_pass_statement] = STATE(2816),
    [sym_break_statement] = STATE(2816),
    [sym_continue_statement] = STATE(2816),
    [sym_global_statement] = STATE(2816),
    [sym_nonlocal_statement] = STATE(2816),
    [sym_exec_statement] = STATE(2816),
    [sym_type_alias_statement] = STATE(2816),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(608),
    [sym__indent] = ACTIONS(610),
    [sym_string_start] = ACTIONS(97),
  },
  [118] = {
    [sym__simple_statements] = STATE(486),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(612),
    [sym__indent] = ACTIONS(614),
    [sym_string_start] = ACTIONS(97),
  },
  [119] = {
    [sym__simple_statements] = STATE(260),
    [sym_import_statement] = STATE(2913),
    [sym_future_import_statement] = STATE(2913),
    [sym_import_from_statement] = STATE(2913),
    [sym_print_statement] = STATE(2913),
    [sym_assert_statement] = STATE(2913),
    [sym_expression_statement] = STATE(2913),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2913),
    [sym_delete_statement] = STATE(2913),
    [sym_raise_statement] = STATE(2913),
    [sym_pass_statement] = STATE(2913),
    [sym_break_statement] = STATE(2913),
    [sym_continue_statement] = STATE(2913),
    [sym_global_statement] = STATE(2913),
    [sym_nonlocal_statement] = STATE(2913),
    [sym_exec_statement] = STATE(2913),
    [sym_type_alias_statement] = STATE(2913),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(616),
    [sym__indent] = ACTIONS(618),
    [sym_string_start] = ACTIONS(97),
  },
  [120] = {
    [sym__simple_statements] = STATE(485),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(620),
    [sym__indent] = ACTIONS(622),
    [sym_string_start] = ACTIONS(97),
  },
  [121] = {
    [sym__simple_statements] = STATE(316),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(624),
    [sym__indent] = ACTIONS(626),
    [sym_string_start] = ACTIONS(97),
  },
  [122] = {
    [sym__simple_statements] = STATE(3056),
    [sym_import_statement] = STATE(2947),
    [sym_future_import_statement] = STATE(2947),
    [sym_import_from_statement] = STATE(2947),
    [sym_print_statement] = STATE(2947),
    [sym_assert_statement] = STATE(2947),
    [sym_expression_statement] = STATE(2947),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2947),
    [sym_delete_statement] = STATE(2947),
    [sym_raise_statement] = STATE(2947),
    [sym_pass_statement] = STATE(2947),
    [sym_break_statement] = STATE(2947),
    [sym_continue_statement] = STATE(2947),
    [sym_global_statement] = STATE(2947),
    [sym_nonlocal_statement] = STATE(2947),
    [sym_exec_statement] = STATE(2947),
    [sym_type_alias_statement] = STATE(2947),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(628),
    [sym__indent] = ACTIONS(630),
    [sym_string_start] = ACTIONS(97),
  },
  [123] = {
    [sym__simple_statements] = STATE(2169),
    [sym_import_statement] = STATE(2727),
    [sym_future_import_statement] = STATE(2727),
    [sym_import_from_statement] = STATE(2727),
    [sym_print_statement] = STATE(2727),
    [sym_assert_statement] = STATE(2727),
    [sym_expression_statement] = STATE(2727),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2727),
    [sym_delete_statement] = STATE(2727),
    [sym_raise_statement] = STATE(2727),
    [sym_pass_statement] = STATE(2727),
    [sym_break_statement] = STATE(2727),
    [sym_continue_statement] = STATE(2727),
    [sym_global_statement] = STATE(2727),
    [sym_nonlocal_statement] = STATE(2727),
    [sym_exec_statement] = STATE(2727),
    [sym_type_alias_statement] = STATE(2727),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(632),
    [sym__indent] = ACTIONS(634),
    [sym_string_start] = ACTIONS(97),
  },
  [124] = {
    [sym__simple_statements] = STATE(310),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(636),
    [sym__indent] = ACTIONS(638),
    [sym_string_start] = ACTIONS(97),
  },
  [125] = {
    [sym__simple_statements] = STATE(3064),
    [sym_import_statement] = STATE(2947),
    [sym_future_import_statement] = STATE(2947),
    [sym_import_from_statement] = STATE(2947),
    [sym_print_statement] = STATE(2947),
    [sym_assert_statement] = STATE(2947),
    [sym_expression_statement] = STATE(2947),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2947),
    [sym_delete_statement] = STATE(2947),
    [sym_raise_statement] = STATE(2947),
    [sym_pass_statement] = STATE(2947),
    [sym_break_statement] = STATE(2947),
    [sym_continue_statement] = STATE(2947),
    [sym_global_statement] = STATE(2947),
    [sym_nonlocal_statement] = STATE(2947),
    [sym_exec_statement] = STATE(2947),
    [sym_type_alias_statement] = STATE(2947),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(640),
    [sym__indent] = ACTIONS(642),
    [sym_string_start] = ACTIONS(97),
  },
  [126] = {
    [sym__simple_statements] = STATE(225),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(644),
    [sym__indent] = ACTIONS(646),
    [sym_string_start] = ACTIONS(97),
  },
  [127] = {
    [sym__simple_statements] = STATE(469),
    [sym_import_statement] = STATE(2786),
    [sym_future_import_statement] = STATE(2786),
    [sym_import_from_statement] = STATE(2786),
    [sym_print_statement] = STATE(2786),
    [sym_assert_statement] = STATE(2786),
    [sym_expression_statement] = STATE(2786),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2786),
    [sym_delete_statement] = STATE(2786),
    [sym_raise_statement] = STATE(2786),
    [sym_pass_statement] = STATE(2786),
    [sym_break_statement] = STATE(2786),
    [sym_continue_statement] = STATE(2786),
    [sym_global_statement] = STATE(2786),
    [sym_nonlocal_statement] = STATE(2786),
    [sym_exec_statement] = STATE(2786),
    [sym_type_alias_statement] = STATE(2786),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(648),
    [sym__indent] = ACTIONS(650),
    [sym_string_start] = ACTIONS(97),
  },
  [128] = {
    [sym__simple_statements] = STATE(290),
    [sym_import_statement] = STATE(2910),
    [sym_future_import_statement] = STATE(2910),
    [sym_import_from_statement] = STATE(2910),
    [sym_print_statement] = STATE(2910),
    [sym_assert_statement] = STATE(2910),
    [sym_expression_statement] = STATE(2910),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2910),
    [sym_delete_statement] = STATE(2910),
    [sym_raise_statement] = STATE(2910),
    [sym_pass_statement] = STATE(2910),
    [sym_break_statement] = STATE(2910),
    [sym_continue_statement] = STATE(2910),
    [sym_global_statement] = STATE(2910),
    [sym_nonlocal_statement] = STATE(2910),
    [sym_exec_statement] = STATE(2910),
    [sym_type_alias_statement] = STATE(2910),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(652),
    [sym__indent] = ACTIONS(654),
    [sym_string_start] = ACTIONS(97),
  },
  [129] = {
    [sym__simple_statements] = STATE(3034),
    [sym_import_statement] = STATE(2947),
    [sym_future_import_statement] = STATE(2947),
    [sym_import_from_statement] = STATE(2947),
    [sym_print_statement] = STATE(2947),
    [sym_assert_statement] = STATE(2947),
    [sym_expression_statement] = STATE(2947),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2947),
    [sym_delete_statement] = STATE(2947),
    [sym_raise_statement] = STATE(2947),
    [sym_pass_statement] = STATE(2947),
    [sym_break_statement] = STATE(2947),
    [sym_continue_statement] = STATE(2947),
    [sym_global_statement] = STATE(2947),
    [sym_nonlocal_statement] = STATE(2947),
    [sym_exec_statement] = STATE(2947),
    [sym_type_alias_statement] = STATE(2947),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(656),
    [sym__indent] = ACTIONS(658),
    [sym_string_start] = ACTIONS(97),
  },
  [130] = {
    [sym__simple_statements] = STATE(1859),
    [sym_import_statement] = STATE(3011),
    [sym_future_import_statement] = STATE(3011),
    [sym_import_from_statement] = STATE(3011),
    [sym_print_statement] = STATE(3011),
    [sym_assert_statement] = STATE(3011),
    [sym_expression_statement] = STATE(3011),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(3011),
    [sym_delete_statement] = STATE(3011),
    [sym_raise_statement] = STATE(3011),
    [sym_pass_statement] = STATE(3011),
    [sym_break_statement] = STATE(3011),
    [sym_continue_statement] = STATE(3011),
    [sym_global_statement] = STATE(3011),
    [sym_nonlocal_statement] = STATE(3011),
    [sym_exec_statement] = STATE(3011),
    [sym_type_alias_statement] = STATE(3011),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(660),
    [sym__indent] = ACTIONS(662),
    [sym_string_start] = ACTIONS(97),
  },
  [131] = {
    [sym__simple_statements] = STATE(427),
    [sym_import_statement] = STATE(2679),
    [sym_future_import_statement] = STATE(2679),
    [sym_import_from_statement] = STATE(2679),
    [sym_print_statement] = STATE(2679),
    [sym_assert_statement] = STATE(2679),
    [sym_expression_statement] = STATE(2679),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2679),
    [sym_delete_statement] = STATE(2679),
    [sym_raise_statement] = STATE(2679),
    [sym_pass_statement] = STATE(2679),
    [sym_break_statement] = STATE(2679),
    [sym_continue_statement] = STATE(2679),
    [sym_global_statement] = STATE(2679),
    [sym_nonlocal_statement] = STATE(2679),
    [sym_exec_statement] = STATE(2679),
    [sym_type_alias_statement] = STATE(2679),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(664),
    [sym__indent] = ACTIONS(666),
    [sym_string_start] = ACTIONS(97),
  },
  [132] = {
    [sym__simple_statements] = STATE(492),
    [sym_import_statement] = STATE(2679),
    [sym_future_import_statement] = STATE(2679),
    [sym_import_from_statement] = STATE(2679),
    [sym_print_statement] = STATE(2679),
    [sym_assert_statement] = STATE(2679),
    [sym_expression_statement] = STATE(2679),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2679),
    [sym_delete_statement] = STATE(2679),
    [sym_raise_statement] = STATE(2679),
    [sym_pass_statement] = STATE(2679),
    [sym_break_statement] = STATE(2679),
    [sym_continue_statement] = STATE(2679),
    [sym_global_statement] = STATE(2679),
    [sym_nonlocal_statement] = STATE(2679),
    [sym_exec_statement] = STATE(2679),
    [sym_type_alias_statement] = STATE(2679),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(668),
    [sym__indent] = ACTIONS(670),
    [sym_string_start] = ACTIONS(97),
  },
  [133] = {
    [sym__simple_statements] = STATE(321),
    [sym_import_statement] = STATE(2679),
    [sym_future_import_statement] = STATE(2679),
    [sym_import_from_statement] = STATE(2679),
    [sym_print_statement] = STATE(2679),
    [sym_assert_statement] = STATE(2679),
    [sym_expression_statement] = STATE(2679),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2679),
    [sym_delete_statement] = STATE(2679),
    [sym_raise_statement] = STATE(2679),
    [sym_pass_statement] = STATE(2679),
    [sym_break_statement] = STATE(2679),
    [sym_continue_statement] = STATE(2679),
    [sym_global_statement] = STATE(2679),
    [sym_nonlocal_statement] = STATE(2679),
    [sym_exec_statement] = STATE(2679),
    [sym_type_alias_statement] = STATE(2679),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(672),
    [sym__indent] = ACTIONS(674),
    [sym_string_start] = ACTIONS(97),
  },
  [134] = {
    [sym__simple_statements] = STATE(414),
    [sym_import_statement] = STATE(2679),
    [sym_future_import_statement] = STATE(2679),
    [sym_import_from_statement] = STATE(2679),
    [sym_print_statement] = STATE(2679),
    [sym_assert_statement] = STATE(2679),
    [sym_expression_statement] = STATE(2679),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2679),
    [sym_delete_statement] = STATE(2679),
    [sym_raise_statement] = STATE(2679),
    [sym_pass_statement] = STATE(2679),
    [sym_break_statement] = STATE(2679),
    [sym_continue_statement] = STATE(2679),
    [sym_global_statement] = STATE(2679),
    [sym_nonlocal_statement] = STATE(2679),
    [sym_exec_statement] = STATE(2679),
    [sym_type_alias_statement] = STATE(2679),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(676),
    [sym__indent] = ACTIONS(678),
    [sym_string_start] = ACTIONS(97),
  },
  [135] = {
    [sym__simple_statements] = STATE(295),
    [sym_import_statement] = STATE(2679),
    [sym_future_import_statement] = STATE(2679),
    [sym_import_from_statement] = STATE(2679),
    [sym_print_statement] = STATE(2679),
    [sym_assert_statement] = STATE(2679),
    [sym_expression_statement] = STATE(2679),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2679),
    [sym_delete_statement] = STATE(2679),
    [sym_raise_statement] = STATE(2679),
    [sym_pass_statement] = STATE(2679),
    [sym_break_statement] = STATE(2679),
    [sym_continue_statement] = STATE(2679),
    [sym_global_statement] = STATE(2679),
    [sym_nonlocal_statement] = STATE(2679),
    [sym_exec_statement] = STATE(2679),
    [sym_type_alias_statement] = STATE(2679),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(680),
    [sym__indent] = ACTIONS(682),
    [sym_string_start] = ACTIONS(97),
  },
  [136] = {
    [sym__simple_statements] = STATE(460),
    [sym_import_statement] = STATE(2679),
    [sym_future_import_statement] = STATE(2679),
    [sym_import_from_statement] = STATE(2679),
    [sym_print_statement] = STATE(2679),
    [sym_assert_statement] = STATE(2679),
    [sym_expression_statement] = STATE(2679),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2679),
    [sym_delete_statement] = STATE(2679),
    [sym_raise_statement] = STATE(2679),
    [sym_pass_statement] = STATE(2679),
    [sym_break_statement] = STATE(2679),
    [sym_continue_statement] = STATE(2679),
    [sym_global_statement] = STATE(2679),
    [sym_nonlocal_statement] = STATE(2679),
    [sym_exec_statement] = STATE(2679),
    [sym_type_alias_statement] = STATE(2679),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(684),
    [sym__indent] = ACTIONS(686),
    [sym_string_start] = ACTIONS(97),
  },
  [137] = {
    [sym__simple_statements] = STATE(333),
    [sym_import_statement] = STATE(2679),
    [sym_future_import_statement] = STATE(2679),
    [sym_import_from_statement] = STATE(2679),
    [sym_print_statement] = STATE(2679),
    [sym_assert_statement] = STATE(2679),
    [sym_expression_statement] = STATE(2679),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2679),
    [sym_delete_statement] = STATE(2679),
    [sym_raise_statement] = STATE(2679),
    [sym_pass_statement] = STATE(2679),
    [sym_break_statement] = STATE(2679),
    [sym_continue_statement] = STATE(2679),
    [sym_global_statement] = STATE(2679),
    [sym_nonlocal_statement] = STATE(2679),
    [sym_exec_statement] = STATE(2679),
    [sym_type_alias_statement] = STATE(2679),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(688),
    [sym__indent] = ACTIONS(690),
    [sym_string_start] = ACTIONS(97),
  },
  [138] = {
    [sym__simple_statements] = STATE(286),
    [sym_import_statement] = STATE(2913),
    [sym_future_import_statement] = STATE(2913),
    [sym_import_from_statement] = STATE(2913),
    [sym_print_statement] = STATE(2913),
    [sym_assert_statement] = STATE(2913),
    [sym_expression_statement] = STATE(2913),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2913),
    [sym_delete_statement] = STATE(2913),
    [sym_raise_statement] = STATE(2913),
    [sym_pass_statement] = STATE(2913),
    [sym_break_statement] = STATE(2913),
    [sym_continue_statement] = STATE(2913),
    [sym_global_statement] = STATE(2913),
    [sym_nonlocal_statement] = STATE(2913),
    [sym_exec_statement] = STATE(2913),
    [sym_type_alias_statement] = STATE(2913),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(692),
    [sym__indent] = ACTIONS(694),
    [sym_string_start] = ACTIONS(97),
  },
  [139] = {
    [sym__simple_statements] = STATE(465),
    [sym_import_statement] = STATE(2679),
    [sym_future_import_statement] = STATE(2679),
    [sym_import_from_statement] = STATE(2679),
    [sym_print_statement] = STATE(2679),
    [sym_assert_statement] = STATE(2679),
    [sym_expression_statement] = STATE(2679),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2679),
    [sym_delete_statement] = STATE(2679),
    [sym_raise_statement] = STATE(2679),
    [sym_pass_statement] = STATE(2679),
    [sym_break_statement] = STATE(2679),
    [sym_continue_statement] = STATE(2679),
    [sym_global_statement] = STATE(2679),
    [sym_nonlocal_statement] = STATE(2679),
    [sym_exec_statement] = STATE(2679),
    [sym_type_alias_statement] = STATE(2679),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(696),
    [sym__indent] = ACTIONS(698),
    [sym_string_start] = ACTIONS(97),
  },
  [140] = {
    [sym__simple_statements] = STATE(261),
    [sym_import_statement] = STATE(2990),
    [sym_future_import_statement] = STATE(2990),
    [sym_import_from_statement] = STATE(2990),
    [sym_print_statement] = STATE(2990),
    [sym_assert_statement] = STATE(2990),
    [sym_expression_statement] = STATE(2990),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2990),
    [sym_delete_statement] = STATE(2990),
    [sym_raise_statement] = STATE(2990),
    [sym_pass_statement] = STATE(2990),
    [sym_break_statement] = STATE(2990),
    [sym_continue_statement] = STATE(2990),
    [sym_global_statement] = STATE(2990),
    [sym_nonlocal_statement] = STATE(2990),
    [sym_exec_statement] = STATE(2990),
    [sym_type_alias_statement] = STATE(2990),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(700),
    [sym__indent] = ACTIONS(702),
    [sym_string_start] = ACTIONS(97),
  },
  [141] = {
    [sym__simple_statements] = STATE(269),
    [sym_import_statement] = STATE(2913),
    [sym_future_import_statement] = STATE(2913),
    [sym_import_from_statement] = STATE(2913),
    [sym_print_statement] = STATE(2913),
    [sym_assert_statement] = STATE(2913),
    [sym_expression_statement] = STATE(2913),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2913),
    [sym_delete_statement] = STATE(2913),
    [sym_raise_statement] = STATE(2913),
    [sym_pass_statement] = STATE(2913),
    [sym_break_statement] = STATE(2913),
    [sym_continue_statement] = STATE(2913),
    [sym_global_statement] = STATE(2913),
    [sym_nonlocal_statement] = STATE(2913),
    [sym_exec_statement] = STATE(2913),
    [sym_type_alias_statement] = STATE(2913),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(704),
    [sym__indent] = ACTIONS(706),
    [sym_string_start] = ACTIONS(97),
  },
  [142] = {
    [sym__simple_statements] = STATE(388),
    [sym_import_statement] = STATE(2679),
    [sym_future_import_statement] = STATE(2679),
    [sym_import_from_statement] = STATE(2679),
    [sym_print_statement] = STATE(2679),
    [sym_assert_statement] = STATE(2679),
    [sym_expression_statement] = STATE(2679),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2679),
    [sym_delete_statement] = STATE(2679),
    [sym_raise_statement] = STATE(2679),
    [sym_pass_statement] = STATE(2679),
    [sym_break_statement] = STATE(2679),
    [sym_continue_statement] = STATE(2679),
    [sym_global_statement] = STATE(2679),
    [sym_nonlocal_statement] = STATE(2679),
    [sym_exec_statement] = STATE(2679),
    [sym_type_alias_statement] = STATE(2679),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(708),
    [sym__indent] = ACTIONS(710),
    [sym_string_start] = ACTIONS(97),
  },
  [143] = {
    [sym__simple_statements] = STATE(307),
    [sym_import_statement] = STATE(2679),
    [sym_future_import_statement] = STATE(2679),
    [sym_import_from_statement] = STATE(2679),
    [sym_print_statement] = STATE(2679),
    [sym_assert_statement] = STATE(2679),
    [sym_expression_statement] = STATE(2679),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(2679),
    [sym_delete_statement] = STATE(2679),
    [sym_raise_statement] = STATE(2679),
    [sym_pass_statement] = STATE(2679),
    [sym_break_statement] = STATE(2679),
    [sym_continue_statement] = STATE(2679),
    [sym_global_statement] = STATE(2679),
    [sym_nonlocal_statement] = STATE(2679),
    [sym_exec_statement] = STATE(2679),
    [sym_type_alias_statement] = STATE(2679),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(712),
    [sym__indent] = ACTIONS(714),
    [sym_string_start] = ACTIONS(97),
  },
  [144] = {
    [sym_import_statement] = STATE(3087),
    [sym_future_import_statement] = STATE(3087),
    [sym_import_from_statement] = STATE(3087),
    [sym_print_statement] = STATE(3087),
    [sym_assert_statement] = STATE(3087),
    [sym_expression_statement] = STATE(3087),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(3087),
    [sym_delete_statement] = STATE(3087),
    [sym_raise_statement] = STATE(3087),
    [sym_pass_statement] = STATE(3087),
    [sym_break_statement] = STATE(3087),
    [sym_continue_statement] = STATE(3087),
    [sym_global_statement] = STATE(3087),
    [sym_nonlocal_statement] = STATE(3087),
    [sym_exec_statement] = STATE(3087),
    [sym_type_alias_statement] = STATE(3087),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(716),
    [sym_string_start] = ACTIONS(97),
  },
  [145] = {
    [sym_import_statement] = STATE(3087),
    [sym_future_import_statement] = STATE(3087),
    [sym_import_from_statement] = STATE(3087),
    [sym_print_statement] = STATE(3087),
    [sym_assert_statement] = STATE(3087),
    [sym_expression_statement] = STATE(3087),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(3087),
    [sym_delete_statement] = STATE(3087),
    [sym_raise_statement] = STATE(3087),
    [sym_pass_statement] = STATE(3087),
    [sym_break_statement] = STATE(3087),
    [sym_continue_statement] = STATE(3087),
    [sym_global_statement] = STATE(3087),
    [sym_nonlocal_statement] = STATE(3087),
    [sym_exec_statement] = STATE(3087),
    [sym_type_alias_statement] = STATE(3087),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(718),
    [sym_string_start] = ACTIONS(97),
  },
  [146] = {
    [sym_import_statement] = STATE(3087),
    [sym_future_import_statement] = STATE(3087),
    [sym_import_from_statement] = STATE(3087),
    [sym_print_statement] = STATE(3087),
    [sym_assert_statement] = STATE(3087),
    [sym_expression_statement] = STATE(3087),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(3087),
    [sym_delete_statement] = STATE(3087),
    [sym_raise_statement] = STATE(3087),
    [sym_pass_statement] = STATE(3087),
    [sym_break_statement] = STATE(3087),
    [sym_continue_statement] = STATE(3087),
    [sym_global_statement] = STATE(3087),
    [sym_nonlocal_statement] = STATE(3087),
    [sym_exec_statement] = STATE(3087),
    [sym_type_alias_statement] = STATE(3087),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(720),
    [sym_string_start] = ACTIONS(97),
  },
  [147] = {
    [sym_import_statement] = STATE(3087),
    [sym_future_import_statement] = STATE(3087),
    [sym_import_from_statement] = STATE(3087),
    [sym_print_statement] = STATE(3087),
    [sym_assert_statement] = STATE(3087),
    [sym_expression_statement] = STATE(3087),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(3087),
    [sym_delete_statement] = STATE(3087),
    [sym_raise_statement] = STATE(3087),
    [sym_pass_statement] = STATE(3087),
    [sym_break_statement] = STATE(3087),
    [sym_continue_statement] = STATE(3087),
    [sym_global_statement] = STATE(3087),
    [sym_nonlocal_statement] = STATE(3087),
    [sym_exec_statement] = STATE(3087),
    [sym_type_alias_statement] = STATE(3087),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(722),
    [sym_string_start] = ACTIONS(97),
  },
  [148] = {
    [sym_import_statement] = STATE(3087),
    [sym_future_import_statement] = STATE(3087),
    [sym_import_from_statement] = STATE(3087),
    [sym_print_statement] = STATE(3087),
    [sym_assert_statement] = STATE(3087),
    [sym_expression_statement] = STATE(3087),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(3087),
    [sym_delete_statement] = STATE(3087),
    [sym_raise_statement] = STATE(3087),
    [sym_pass_statement] = STATE(3087),
    [sym_break_statement] = STATE(3087),
    [sym_continue_statement] = STATE(3087),
    [sym_global_statement] = STATE(3087),
    [sym_nonlocal_statement] = STATE(3087),
    [sym_exec_statement] = STATE(3087),
    [sym_type_alias_statement] = STATE(3087),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(724),
    [sym_string_start] = ACTIONS(97),
  },
  [149] = {
    [sym_import_statement] = STATE(3087),
    [sym_future_import_statement] = STATE(3087),
    [sym_import_from_statement] = STATE(3087),
    [sym_print_statement] = STATE(3087),
    [sym_assert_statement] = STATE(3087),
    [sym_expression_statement] = STATE(3087),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(3087),
    [sym_delete_statement] = STATE(3087),
    [sym_raise_statement] = STATE(3087),
    [sym_pass_statement] = STATE(3087),
    [sym_break_statement] = STATE(3087),
    [sym_continue_statement] = STATE(3087),
    [sym_global_statement] = STATE(3087),
    [sym_nonlocal_statement] = STATE(3087),
    [sym_exec_statement] = STATE(3087),
    [sym_type_alias_statement] = STATE(3087),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(726),
    [sym_string_start] = ACTIONS(97),
  },
  [150] = {
    [sym_import_statement] = STATE(3087),
    [sym_future_import_statement] = STATE(3087),
    [sym_import_from_statement] = STATE(3087),
    [sym_print_statement] = STATE(3087),
    [sym_assert_statement] = STATE(3087),
    [sym_expression_statement] = STATE(3087),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(3087),
    [sym_delete_statement] = STATE(3087),
    [sym_raise_statement] = STATE(3087),
    [sym_pass_statement] = STATE(3087),
    [sym_break_statement] = STATE(3087),
    [sym_continue_statement] = STATE(3087),
    [sym_global_statement] = STATE(3087),
    [sym_nonlocal_statement] = STATE(3087),
    [sym_exec_statement] = STATE(3087),
    [sym_type_alias_statement] = STATE(3087),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(728),
    [sym_string_start] = ACTIONS(97),
  },
  [151] = {
    [sym_import_statement] = STATE(3087),
    [sym_future_import_statement] = STATE(3087),
    [sym_import_from_statement] = STATE(3087),
    [sym_print_statement] = STATE(3087),
    [sym_assert_statement] = STATE(3087),
    [sym_expression_statement] = STATE(3087),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(3087),
    [sym_delete_statement] = STATE(3087),
    [sym_raise_statement] = STATE(3087),
    [sym_pass_statement] = STATE(3087),
    [sym_break_statement] = STATE(3087),
    [sym_continue_statement] = STATE(3087),
    [sym_global_statement] = STATE(3087),
    [sym_nonlocal_statement] = STATE(3087),
    [sym_exec_statement] = STATE(3087),
    [sym_type_alias_statement] = STATE(3087),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(730),
    [sym_string_start] = ACTIONS(97),
  },
  [152] = {
    [sym_import_statement] = STATE(3087),
    [sym_future_import_statement] = STATE(3087),
    [sym_import_from_statement] = STATE(3087),
    [sym_print_statement] = STATE(3087),
    [sym_assert_statement] = STATE(3087),
    [sym_expression_statement] = STATE(3087),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(3087),
    [sym_delete_statement] = STATE(3087),
    [sym_raise_statement] = STATE(3087),
    [sym_pass_statement] = STATE(3087),
    [sym_break_statement] = STATE(3087),
    [sym_continue_statement] = STATE(3087),
    [sym_global_statement] = STATE(3087),
    [sym_nonlocal_statement] = STATE(3087),
    [sym_exec_statement] = STATE(3087),
    [sym_type_alias_statement] = STATE(3087),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(732),
    [sym_string_start] = ACTIONS(97),
  },
  [153] = {
    [sym_import_statement] = STATE(3087),
    [sym_future_import_statement] = STATE(3087),
    [sym_import_from_statement] = STATE(3087),
    [sym_print_statement] = STATE(3087),
    [sym_assert_statement] = STATE(3087),
    [sym_expression_statement] = STATE(3087),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(3087),
    [sym_delete_statement] = STATE(3087),
    [sym_raise_statement] = STATE(3087),
    [sym_pass_statement] = STATE(3087),
    [sym_break_statement] = STATE(3087),
    [sym_continue_statement] = STATE(3087),
    [sym_global_statement] = STATE(3087),
    [sym_nonlocal_statement] = STATE(3087),
    [sym_exec_statement] = STATE(3087),
    [sym_type_alias_statement] = STATE(3087),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(734),
    [sym_string_start] = ACTIONS(97),
  },
  [154] = {
    [sym_import_statement] = STATE(3087),
    [sym_future_import_statement] = STATE(3087),
    [sym_import_from_statement] = STATE(3087),
    [sym_print_statement] = STATE(3087),
    [sym_assert_statement] = STATE(3087),
    [sym_expression_statement] = STATE(3087),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(3087),
    [sym_delete_statement] = STATE(3087),
    [sym_raise_statement] = STATE(3087),
    [sym_pass_statement] = STATE(3087),
    [sym_break_statement] = STATE(3087),
    [sym_continue_statement] = STATE(3087),
    [sym_global_statement] = STATE(3087),
    [sym_nonlocal_statement] = STATE(3087),
    [sym_exec_statement] = STATE(3087),
    [sym_type_alias_statement] = STATE(3087),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(736),
    [sym_string_start] = ACTIONS(97),
  },
  [155] = {
    [sym_import_statement] = STATE(3087),
    [sym_future_import_statement] = STATE(3087),
    [sym_import_from_statement] = STATE(3087),
    [sym_print_statement] = STATE(3087),
    [sym_assert_statement] = STATE(3087),
    [sym_expression_statement] = STATE(3087),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(3087),
    [sym_delete_statement] = STATE(3087),
    [sym_raise_statement] = STATE(3087),
    [sym_pass_statement] = STATE(3087),
    [sym_break_statement] = STATE(3087),
    [sym_continue_statement] = STATE(3087),
    [sym_global_statement] = STATE(3087),
    [sym_nonlocal_statement] = STATE(3087),
    [sym_exec_statement] = STATE(3087),
    [sym_type_alias_statement] = STATE(3087),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(738),
    [sym_string_start] = ACTIONS(97),
  },
  [156] = {
    [sym_import_statement] = STATE(3087),
    [sym_future_import_statement] = STATE(3087),
    [sym_import_from_statement] = STATE(3087),
    [sym_print_statement] = STATE(3087),
    [sym_assert_statement] = STATE(3087),
    [sym_expression_statement] = STATE(3087),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(3087),
    [sym_delete_statement] = STATE(3087),
    [sym_raise_statement] = STATE(3087),
    [sym_pass_statement] = STATE(3087),
    [sym_break_statement] = STATE(3087),
    [sym_continue_statement] = STATE(3087),
    [sym_global_statement] = STATE(3087),
    [sym_nonlocal_statement] = STATE(3087),
    [sym_exec_statement] = STATE(3087),
    [sym_type_alias_statement] = STATE(3087),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(740),
    [sym_string_start] = ACTIONS(97),
  },
  [157] = {
    [sym_import_statement] = STATE(3087),
    [sym_future_import_statement] = STATE(3087),
    [sym_import_from_statement] = STATE(3087),
    [sym_print_statement] = STATE(3087),
    [sym_assert_statement] = STATE(3087),
    [sym_expression_statement] = STATE(3087),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(3087),
    [sym_delete_statement] = STATE(3087),
    [sym_raise_statement] = STATE(3087),
    [sym_pass_statement] = STATE(3087),
    [sym_break_statement] = STATE(3087),
    [sym_continue_statement] = STATE(3087),
    [sym_global_statement] = STATE(3087),
    [sym_nonlocal_statement] = STATE(3087),
    [sym_exec_statement] = STATE(3087),
    [sym_type_alias_statement] = STATE(3087),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(742),
    [sym_string_start] = ACTIONS(97),
  },
  [158] = {
    [sym_import_statement] = STATE(3087),
    [sym_future_import_statement] = STATE(3087),
    [sym_import_from_statement] = STATE(3087),
    [sym_print_statement] = STATE(3087),
    [sym_assert_statement] = STATE(3087),
    [sym_expression_statement] = STATE(3087),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(3087),
    [sym_delete_statement] = STATE(3087),
    [sym_raise_statement] = STATE(3087),
    [sym_pass_statement] = STATE(3087),
    [sym_break_statement] = STATE(3087),
    [sym_continue_statement] = STATE(3087),
    [sym_global_statement] = STATE(3087),
    [sym_nonlocal_statement] = STATE(3087),
    [sym_exec_statement] = STATE(3087),
    [sym_type_alias_statement] = STATE(3087),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(744),
    [sym_string_start] = ACTIONS(97),
  },
  [159] = {
    [sym_import_statement] = STATE(3087),
    [sym_future_import_statement] = STATE(3087),
    [sym_import_from_statement] = STATE(3087),
    [sym_print_statement] = STATE(3087),
    [sym_assert_statement] = STATE(3087),
    [sym_expression_statement] = STATE(3087),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(3087),
    [sym_delete_statement] = STATE(3087),
    [sym_raise_statement] = STATE(3087),
    [sym_pass_statement] = STATE(3087),
    [sym_break_statement] = STATE(3087),
    [sym_continue_statement] = STATE(3087),
    [sym_global_statement] = STATE(3087),
    [sym_nonlocal_statement] = STATE(3087),
    [sym_exec_statement] = STATE(3087),
    [sym_type_alias_statement] = STATE(3087),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(746),
    [sym_string_start] = ACTIONS(97),
  },
  [160] = {
    [sym_import_statement] = STATE(3087),
    [sym_future_import_statement] = STATE(3087),
    [sym_import_from_statement] = STATE(3087),
    [sym_print_statement] = STATE(3087),
    [sym_assert_statement] = STATE(3087),
    [sym_expression_statement] = STATE(3087),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(3087),
    [sym_delete_statement] = STATE(3087),
    [sym_raise_statement] = STATE(3087),
    [sym_pass_statement] = STATE(3087),
    [sym_break_statement] = STATE(3087),
    [sym_continue_statement] = STATE(3087),
    [sym_global_statement] = STATE(3087),
    [sym_nonlocal_statement] = STATE(3087),
    [sym_exec_statement] = STATE(3087),
    [sym_type_alias_statement] = STATE(3087),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(748),
    [sym_string_start] = ACTIONS(97),
  },
  [161] = {
    [sym_import_statement] = STATE(3087),
    [sym_future_import_statement] = STATE(3087),
    [sym_import_from_statement] = STATE(3087),
    [sym_print_statement] = STATE(3087),
    [sym_assert_statement] = STATE(3087),
    [sym_expression_statement] = STATE(3087),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(3087),
    [sym_delete_statement] = STATE(3087),
    [sym_raise_statement] = STATE(3087),
    [sym_pass_statement] = STATE(3087),
    [sym_break_statement] = STATE(3087),
    [sym_continue_statement] = STATE(3087),
    [sym_global_statement] = STATE(3087),
    [sym_nonlocal_statement] = STATE(3087),
    [sym_exec_statement] = STATE(3087),
    [sym_type_alias_statement] = STATE(3087),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(750),
    [sym_string_start] = ACTIONS(97),
  },
  [162] = {
    [sym_import_statement] = STATE(3087),
    [sym_future_import_statement] = STATE(3087),
    [sym_import_from_statement] = STATE(3087),
    [sym_print_statement] = STATE(3087),
    [sym_assert_statement] = STATE(3087),
    [sym_expression_statement] = STATE(3087),
    [sym_named_expression] = STATE(2070),
    [sym__named_expression_lhs] = STATE(3427),
    [sym_return_statement] = STATE(3087),
    [sym_delete_statement] = STATE(3087),
    [sym_raise_statement] = STATE(3087),
    [sym_pass_statement] = STATE(3087),
    [sym_break_statement] = STATE(3087),
    [sym_continue_statement] = STATE(3087),
    [sym_global_statement] = STATE(3087),
    [sym_nonlocal_statement] = STATE(3087),
    [sym_exec_statement] = STATE(3087),
    [sym_type_alias_statement] = STATE(3087),
    [sym_pattern] = STATE(2019),
    [sym_tuple_pattern] = STATE(2015),
    [sym_list_pattern] = STATE(2015),
    [sym_list_splat_pattern] = STATE(1024),
    [sym_as_pattern] = STATE(2070),
    [sym_expression] = STATE(2233),
    [sym_primary_expression] = STATE(1237),
    [sym_not_operator] = STATE(2070),
    [sym_boolean_operator] = STATE(2070),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_comparison_operator] = STATE(2070),
    [sym_lambda] = STATE(2070),
    [sym_assignment] = STATE(3038),
    [sym_augmented_assignment] = STATE(3038),
    [sym_pattern_list] = STATE(2027),
    [sym_yield] = STATE(3038),
    [sym_attribute] = STATE(1029),
    [sym_subscript] = STATE(1029),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_conditional_expression] = STATE(2070),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(17),
    [anon_sym_print] = ACTIONS(19),
    [anon_sym_assert] = ACTIONS(21),
    [anon_sym_return] = ACTIONS(23),
    [anon_sym_del] = ACTIONS(25),
    [anon_sym_raise] = ACTIONS(27),
    [anon_sym_pass] = ACTIONS(29),
    [anon_sym_break] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_match] = ACTIONS(502),
    [anon_sym_async] = ACTIONS(502),
    [anon_sym_global] = ACTIONS(51),
    [anon_sym_nonlocal] = ACTIONS(53),
    [anon_sym_exec] = ACTIONS(55),
    [anon_sym_type] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(97),
  },
  [163] = {
    [sym_list_splat_pattern] = STATE(1314),
    [sym_primary_expression] = STATE(1218),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_attribute] = STATE(1312),
    [sym_subscript] = STATE(1312),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_SEMI] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(363),
    [anon_sym_LPAREN] = ACTIONS(752),
    [anon_sym_COMMA] = ACTIONS(368),
    [anon_sym_as] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(754),
    [anon_sym_print] = ACTIONS(756),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_COLON_EQ] = ACTIONS(376),
    [anon_sym_if] = ACTIONS(363),
    [anon_sym_COLON] = ACTIONS(378),
    [anon_sym_match] = ACTIONS(756),
    [anon_sym_async] = ACTIONS(756),
    [anon_sym_in] = ACTIONS(363),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_exec] = ACTIONS(756),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_EQ] = ACTIONS(378),
    [anon_sym_LBRACK] = ACTIONS(760),
    [anon_sym_AT] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(762),
    [anon_sym_PIPE] = ACTIONS(363),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(762),
    [anon_sym_not] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(363),
    [anon_sym_or] = ACTIONS(363),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_SLASH_SLASH] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(361),
    [anon_sym_EQ_EQ] = ACTIONS(361),
    [anon_sym_BANG_EQ] = ACTIONS(361),
    [anon_sym_GT_EQ] = ACTIONS(361),
    [anon_sym_GT] = ACTIONS(363),
    [anon_sym_LT_GT] = ACTIONS(361),
    [anon_sym_is] = ACTIONS(363),
    [anon_sym_PLUS_EQ] = ACTIONS(400),
    [anon_sym_DASH_EQ] = ACTIONS(400),
    [anon_sym_STAR_EQ] = ACTIONS(400),
    [anon_sym_SLASH_EQ] = ACTIONS(400),
    [anon_sym_AT_EQ] = ACTIONS(400),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(400),
    [anon_sym_PERCENT_EQ] = ACTIONS(400),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(400),
    [anon_sym_GT_GT_EQ] = ACTIONS(400),
    [anon_sym_LT_LT_EQ] = ACTIONS(400),
    [anon_sym_AMP_EQ] = ACTIONS(400),
    [anon_sym_CARET_EQ] = ACTIONS(400),
    [anon_sym_PIPE_EQ] = ACTIONS(400),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(764),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(361),
    [sym_string_start] = ACTIONS(97),
  },
  [164] = {
    [sym_list_splat_pattern] = STATE(1314),
    [sym_primary_expression] = STATE(1218),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_attribute] = STATE(1312),
    [sym_subscript] = STATE(1312),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_SEMI] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(363),
    [anon_sym_LPAREN] = ACTIONS(752),
    [anon_sym_COMMA] = ACTIONS(368),
    [anon_sym_as] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(754),
    [anon_sym_print] = ACTIONS(756),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_COLON_EQ] = ACTIONS(376),
    [anon_sym_if] = ACTIONS(363),
    [anon_sym_COLON] = ACTIONS(410),
    [anon_sym_match] = ACTIONS(756),
    [anon_sym_async] = ACTIONS(756),
    [anon_sym_in] = ACTIONS(363),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_exec] = ACTIONS(756),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_EQ] = ACTIONS(378),
    [anon_sym_LBRACK] = ACTIONS(760),
    [anon_sym_AT] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(762),
    [anon_sym_PIPE] = ACTIONS(363),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(762),
    [anon_sym_not] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(363),
    [anon_sym_or] = ACTIONS(363),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_SLASH_SLASH] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(361),
    [anon_sym_EQ_EQ] = ACTIONS(361),
    [anon_sym_BANG_EQ] = ACTIONS(361),
    [anon_sym_GT_EQ] = ACTIONS(361),
    [anon_sym_GT] = ACTIONS(363),
    [anon_sym_LT_GT] = ACTIONS(361),
    [anon_sym_is] = ACTIONS(363),
    [anon_sym_PLUS_EQ] = ACTIONS(400),
    [anon_sym_DASH_EQ] = ACTIONS(400),
    [anon_sym_STAR_EQ] = ACTIONS(400),
    [anon_sym_SLASH_EQ] = ACTIONS(400),
    [anon_sym_AT_EQ] = ACTIONS(400),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(400),
    [anon_sym_PERCENT_EQ] = ACTIONS(400),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(400),
    [anon_sym_GT_GT_EQ] = ACTIONS(400),
    [anon_sym_LT_LT_EQ] = ACTIONS(400),
    [anon_sym_AMP_EQ] = ACTIONS(400),
    [anon_sym_CARET_EQ] = ACTIONS(400),
    [anon_sym_PIPE_EQ] = ACTIONS(400),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(764),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(361),
    [sym_string_start] = ACTIONS(97),
  },
  [165] = {
    [sym_list_splat_pattern] = STATE(1541),
    [sym_primary_expression] = STATE(1298),
    [sym_binary_operator] = STATE(1536),
    [sym_unary_operator] = STATE(1536),
    [sym_attribute] = STATE(1536),
    [sym_subscript] = STATE(1536),
    [sym_call] = STATE(1536),
    [sym_list] = STATE(1536),
    [sym_set] = STATE(1536),
    [sym_tuple] = STATE(1536),
    [sym_dictionary] = STATE(1536),
    [sym_list_comprehension] = STATE(1536),
    [sym_dictionary_comprehension] = STATE(1536),
    [sym_set_comprehension] = STATE(1536),
    [sym_generator_expression] = STATE(1536),
    [sym_parenthesized_expression] = STATE(1536),
    [sym_concatenated_string] = STATE(1536),
    [sym_string] = STATE(1234),
    [sym_await] = STATE(1536),
    [sym_identifier] = ACTIONS(404),
    [anon_sym_SEMI] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(768),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_COMMA] = ACTIONS(766),
    [anon_sym_as] = ACTIONS(771),
    [anon_sym_STAR] = ACTIONS(494),
    [anon_sym_print] = ACTIONS(773),
    [anon_sym_GT_GT] = ACTIONS(768),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_COLON] = ACTIONS(766),
    [anon_sym_match] = ACTIONS(773),
    [anon_sym_async] = ACTIONS(773),
    [anon_sym_in] = ACTIONS(771),
    [anon_sym_STAR_STAR] = ACTIONS(768),
    [anon_sym_exec] = ACTIONS(773),
    [anon_sym_type] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_LBRACK] = ACTIONS(496),
    [anon_sym_AT] = ACTIONS(768),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_PIPE] = ACTIONS(768),
    [anon_sym_LBRACE] = ACTIONS(391),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_not] = ACTIONS(771),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_PERCENT] = ACTIONS(768),
    [anon_sym_SLASH_SLASH] = ACTIONS(768),
    [anon_sym_AMP] = ACTIONS(768),
    [anon_sym_CARET] = ACTIONS(768),
    [anon_sym_LT_LT] = ACTIONS(768),
    [anon_sym_TILDE] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_LT_EQ] = ACTIONS(766),
    [anon_sym_EQ_EQ] = ACTIONS(766),
    [anon_sym_BANG_EQ] = ACTIONS(766),
    [anon_sym_GT_EQ] = ACTIONS(766),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_LT_GT] = ACTIONS(766),
    [anon_sym_is] = ACTIONS(771),
    [anon_sym_PLUS_EQ] = ACTIONS(766),
    [anon_sym_DASH_EQ] = ACTIONS(766),
    [anon_sym_STAR_EQ] = ACTIONS(766),
    [anon_sym_SLASH_EQ] = ACTIONS(766),
    [anon_sym_AT_EQ] = ACTIONS(766),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(766),
    [anon_sym_PERCENT_EQ] = ACTIONS(766),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(766),
    [anon_sym_GT_GT_EQ] = ACTIONS(766),
    [anon_sym_LT_LT_EQ] = ACTIONS(766),
    [anon_sym_AMP_EQ] = ACTIONS(766),
    [anon_sym_CARET_EQ] = ACTIONS(766),
    [anon_sym_PIPE_EQ] = ACTIONS(766),
    [sym_ellipsis] = ACTIONS(402),
    [sym_integer] = ACTIONS(404),
    [sym_float] = ACTIONS(402),
    [anon_sym_await] = ACTIONS(777),
    [sym_true] = ACTIONS(404),
    [sym_false] = ACTIONS(404),
    [sym_none] = ACTIONS(404),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(766),
    [sym_string_start] = ACTIONS(408),
  },
  [166] = {
    [sym_list_splat_pattern] = STATE(1314),
    [sym_primary_expression] = STATE(1218),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_attribute] = STATE(1312),
    [sym_subscript] = STATE(1312),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_SEMI] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(363),
    [anon_sym_from] = ACTIONS(363),
    [anon_sym_LPAREN] = ACTIONS(752),
    [anon_sym_COMMA] = ACTIONS(361),
    [anon_sym_as] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(754),
    [anon_sym_print] = ACTIONS(756),
    [anon_sym_GT_GT] = ACTIONS(361),
    [anon_sym_COLON_EQ] = ACTIONS(376),
    [anon_sym_if] = ACTIONS(363),
    [anon_sym_COLON] = ACTIONS(363),
    [anon_sym_match] = ACTIONS(756),
    [anon_sym_async] = ACTIONS(756),
    [anon_sym_in] = ACTIONS(363),
    [anon_sym_STAR_STAR] = ACTIONS(361),
    [anon_sym_exec] = ACTIONS(756),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_EQ] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(760),
    [anon_sym_AT] = ACTIONS(361),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_PIPE] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(363),
    [anon_sym_or] = ACTIONS(363),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(361),
    [anon_sym_SLASH_SLASH] = ACTIONS(361),
    [anon_sym_AMP] = ACTIONS(361),
    [anon_sym_CARET] = ACTIONS(361),
    [anon_sym_LT_LT] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(361),
    [anon_sym_EQ_EQ] = ACTIONS(361),
    [anon_sym_BANG_EQ] = ACTIONS(361),
    [anon_sym_GT_EQ] = ACTIONS(361),
    [anon_sym_GT] = ACTIONS(363),
    [anon_sym_LT_GT] = ACTIONS(361),
    [anon_sym_is] = ACTIONS(363),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(764),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(361),
    [sym_string_start] = ACTIONS(97),
  },
  [167] = {
    [sym_list_splat_pattern] = STATE(1459),
    [sym_primary_expression] = STATE(1244),
    [sym_binary_operator] = STATE(1449),
    [sym_unary_operator] = STATE(1449),
    [sym_attribute] = STATE(1449),
    [sym_subscript] = STATE(1449),
    [sym_call] = STATE(1449),
    [sym_list] = STATE(1449),
    [sym_set] = STATE(1449),
    [sym_tuple] = STATE(1449),
    [sym_dictionary] = STATE(1449),
    [sym_list_comprehension] = STATE(1449),
    [sym_dictionary_comprehension] = STATE(1449),
    [sym_set_comprehension] = STATE(1449),
    [sym_generator_expression] = STATE(1449),
    [sym_parenthesized_expression] = STATE(1449),
    [sym_concatenated_string] = STATE(1449),
    [sym_string] = STATE(1223),
    [sym_await] = STATE(1449),
    [sym_identifier] = ACTIONS(779),
    [anon_sym_DOT] = ACTIONS(363),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_COMMA] = ACTIONS(368),
    [anon_sym_as] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(783),
    [anon_sym_print] = ACTIONS(785),
    [anon_sym_GT_GT] = ACTIONS(361),
    [anon_sym_COLON_EQ] = ACTIONS(376),
    [anon_sym_if] = ACTIONS(363),
    [anon_sym_COLON] = ACTIONS(363),
    [anon_sym_match] = ACTIONS(785),
    [anon_sym_async] = ACTIONS(785),
    [anon_sym_in] = ACTIONS(363),
    [anon_sym_STAR_STAR] = ACTIONS(361),
    [anon_sym_exec] = ACTIONS(785),
    [anon_sym_type] = ACTIONS(787),
    [anon_sym_EQ] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(789),
    [anon_sym_AT] = ACTIONS(361),
    [anon_sym_DASH] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(793),
    [anon_sym_RBRACE] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_not] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(363),
    [anon_sym_or] = ACTIONS(363),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(361),
    [anon_sym_SLASH_SLASH] = ACTIONS(361),
    [anon_sym_AMP] = ACTIONS(361),
    [anon_sym_CARET] = ACTIONS(361),
    [anon_sym_LT_LT] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(791),
    [anon_sym_LT] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(361),
    [anon_sym_EQ_EQ] = ACTIONS(361),
    [anon_sym_BANG_EQ] = ACTIONS(361),
    [anon_sym_GT_EQ] = ACTIONS(361),
    [anon_sym_GT] = ACTIONS(363),
    [anon_sym_LT_GT] = ACTIONS(361),
    [anon_sym_is] = ACTIONS(363),
    [sym_ellipsis] = ACTIONS(795),
    [sym_type_conversion] = ACTIONS(361),
    [sym_integer] = ACTIONS(779),
    [sym_float] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(797),
    [sym_true] = ACTIONS(779),
    [sym_false] = ACTIONS(779),
    [sym_none] = ACTIONS(779),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(799),
  },
  [168] = {
    [sym_list_splat_pattern] = STATE(1459),
    [sym_primary_expression] = STATE(1244),
    [sym_binary_operator] = STATE(1449),
    [sym_unary_operator] = STATE(1449),
    [sym_attribute] = STATE(1449),
    [sym_subscript] = STATE(1449),
    [sym_call] = STATE(1449),
    [sym_list] = STATE(1449),
    [sym_set] = STATE(1449),
    [sym_tuple] = STATE(1449),
    [sym_dictionary] = STATE(1449),
    [sym_list_comprehension] = STATE(1449),
    [sym_dictionary_comprehension] = STATE(1449),
    [sym_set_comprehension] = STATE(1449),
    [sym_generator_expression] = STATE(1449),
    [sym_parenthesized_expression] = STATE(1449),
    [sym_concatenated_string] = STATE(1449),
    [sym_string] = STATE(1223),
    [sym_await] = STATE(1449),
    [sym_identifier] = ACTIONS(779),
    [anon_sym_DOT] = ACTIONS(363),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_COMMA] = ACTIONS(361),
    [anon_sym_as] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(783),
    [anon_sym_print] = ACTIONS(785),
    [anon_sym_GT_GT] = ACTIONS(361),
    [anon_sym_COLON_EQ] = ACTIONS(376),
    [anon_sym_if] = ACTIONS(363),
    [anon_sym_COLON] = ACTIONS(363),
    [anon_sym_match] = ACTIONS(785),
    [anon_sym_async] = ACTIONS(785),
    [anon_sym_in] = ACTIONS(363),
    [anon_sym_STAR_STAR] = ACTIONS(361),
    [anon_sym_exec] = ACTIONS(785),
    [anon_sym_type] = ACTIONS(787),
    [anon_sym_EQ] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(789),
    [anon_sym_AT] = ACTIONS(361),
    [anon_sym_DASH] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(793),
    [anon_sym_RBRACE] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_not] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(363),
    [anon_sym_or] = ACTIONS(363),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(361),
    [anon_sym_SLASH_SLASH] = ACTIONS(361),
    [anon_sym_AMP] = ACTIONS(361),
    [anon_sym_CARET] = ACTIONS(361),
    [anon_sym_LT_LT] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(791),
    [anon_sym_LT] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(361),
    [anon_sym_EQ_EQ] = ACTIONS(361),
    [anon_sym_BANG_EQ] = ACTIONS(361),
    [anon_sym_GT_EQ] = ACTIONS(361),
    [anon_sym_GT] = ACTIONS(363),
    [anon_sym_LT_GT] = ACTIONS(361),
    [anon_sym_is] = ACTIONS(363),
    [sym_ellipsis] = ACTIONS(795),
    [sym_type_conversion] = ACTIONS(361),
    [sym_integer] = ACTIONS(779),
    [sym_float] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(797),
    [sym_true] = ACTIONS(779),
    [sym_false] = ACTIONS(779),
    [sym_none] = ACTIONS(779),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(799),
  },
  [169] = {
    [sym_list_splat_pattern] = STATE(1541),
    [sym_primary_expression] = STATE(1298),
    [sym_binary_operator] = STATE(1536),
    [sym_unary_operator] = STATE(1536),
    [sym_attribute] = STATE(1536),
    [sym_subscript] = STATE(1536),
    [sym_call] = STATE(1536),
    [sym_list] = STATE(1536),
    [sym_set] = STATE(1536),
    [sym_tuple] = STATE(1536),
    [sym_dictionary] = STATE(1536),
    [sym_list_comprehension] = STATE(1536),
    [sym_dictionary_comprehension] = STATE(1536),
    [sym_set_comprehension] = STATE(1536),
    [sym_generator_expression] = STATE(1536),
    [sym_parenthesized_expression] = STATE(1536),
    [sym_concatenated_string] = STATE(1536),
    [sym_string] = STATE(1234),
    [sym_await] = STATE(1536),
    [sym_identifier] = ACTIONS(404),
    [anon_sym_DOT] = ACTIONS(768),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_COMMA] = ACTIONS(766),
    [anon_sym_as] = ACTIONS(771),
    [anon_sym_STAR] = ACTIONS(494),
    [anon_sym_print] = ACTIONS(773),
    [anon_sym_GT_GT] = ACTIONS(801),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_COLON] = ACTIONS(766),
    [anon_sym_match] = ACTIONS(773),
    [anon_sym_async] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(771),
    [anon_sym_in] = ACTIONS(771),
    [anon_sym_STAR_STAR] = ACTIONS(801),
    [anon_sym_exec] = ACTIONS(773),
    [anon_sym_type] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_LBRACK] = ACTIONS(496),
    [anon_sym_AT] = ACTIONS(801),
    [anon_sym_DASH] = ACTIONS(396),
    [anon_sym_PIPE] = ACTIONS(801),
    [anon_sym_LBRACE] = ACTIONS(391),
    [anon_sym_RBRACE] = ACTIONS(766),
    [anon_sym_PLUS] = ACTIONS(396),
    [anon_sym_not] = ACTIONS(771),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_PERCENT] = ACTIONS(801),
    [anon_sym_SLASH_SLASH] = ACTIONS(801),
    [anon_sym_AMP] = ACTIONS(801),
    [anon_sym_CARET] = ACTIONS(801),
    [anon_sym_LT_LT] = ACTIONS(801),
    [anon_sym_TILDE] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_LT_EQ] = ACTIONS(766),
    [anon_sym_EQ_EQ] = ACTIONS(766),
    [anon_sym_BANG_EQ] = ACTIONS(766),
    [anon_sym_GT_EQ] = ACTIONS(766),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_LT_GT] = ACTIONS(766),
    [anon_sym_is] = ACTIONS(771),
    [sym_ellipsis] = ACTIONS(402),
    [sym_type_conversion] = ACTIONS(766),
    [sym_integer] = ACTIONS(404),
    [sym_float] = ACTIONS(402),
    [anon_sym_await] = ACTIONS(777),
    [sym_true] = ACTIONS(404),
    [sym_false] = ACTIONS(404),
    [sym_none] = ACTIONS(404),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(408),
  },
  [170] = {
    [sym_list_splat_pattern] = STATE(1314),
    [sym_primary_expression] = STATE(1218),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_attribute] = STATE(1312),
    [sym_subscript] = STATE(1312),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_SEMI] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(363),
    [anon_sym_from] = ACTIONS(363),
    [anon_sym_LPAREN] = ACTIONS(752),
    [anon_sym_COMMA] = ACTIONS(361),
    [anon_sym_as] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(754),
    [anon_sym_print] = ACTIONS(756),
    [anon_sym_GT_GT] = ACTIONS(361),
    [anon_sym_if] = ACTIONS(363),
    [anon_sym_COLON] = ACTIONS(361),
    [anon_sym_match] = ACTIONS(756),
    [anon_sym_async] = ACTIONS(756),
    [anon_sym_in] = ACTIONS(363),
    [anon_sym_STAR_STAR] = ACTIONS(361),
    [anon_sym_exec] = ACTIONS(756),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_EQ] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(760),
    [anon_sym_AT] = ACTIONS(361),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_PIPE] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(363),
    [anon_sym_or] = ACTIONS(363),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(361),
    [anon_sym_SLASH_SLASH] = ACTIONS(361),
    [anon_sym_AMP] = ACTIONS(361),
    [anon_sym_CARET] = ACTIONS(361),
    [anon_sym_LT_LT] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(361),
    [anon_sym_EQ_EQ] = ACTIONS(361),
    [anon_sym_BANG_EQ] = ACTIONS(361),
    [anon_sym_GT_EQ] = ACTIONS(361),
    [anon_sym_GT] = ACTIONS(363),
    [anon_sym_LT_GT] = ACTIONS(361),
    [anon_sym_is] = ACTIONS(363),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(764),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(361),
    [sym_string_start] = ACTIONS(97),
  },
  [171] = {
    [sym_list_splat_pattern] = STATE(1541),
    [sym_primary_expression] = STATE(1298),
    [sym_binary_operator] = STATE(1536),
    [sym_unary_operator] = STATE(1536),
    [sym_attribute] = STATE(1536),
    [sym_subscript] = STATE(1536),
    [sym_call] = STATE(1536),
    [sym_list] = STATE(1536),
    [sym_set] = STATE(1536),
    [sym_tuple] = STATE(1536),
    [sym_dictionary] = STATE(1536),
    [sym_list_comprehension] = STATE(1536),
    [sym_dictionary_comprehension] = STATE(1536),
    [sym_set_comprehension] = STATE(1536),
    [sym_generator_expression] = STATE(1536),
    [sym_parenthesized_expression] = STATE(1536),
    [sym_concatenated_string] = STATE(1536),
    [sym_string] = STATE(1234),
    [sym_await] = STATE(1536),
    [sym_identifier] = ACTIONS(404),
    [anon_sym_SEMI] = ACTIONS(766),
    [anon_sym_DOT] = ACTIONS(768),
    [anon_sym_from] = ACTIONS(771),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_COMMA] = ACTIONS(766),
    [anon_sym_as] = ACTIONS(771),
    [anon_sym_STAR] = ACTIONS(494),
    [anon_sym_print] = ACTIONS(773),
    [anon_sym_GT_GT] = ACTIONS(801),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_COLON] = ACTIONS(766),
    [anon_sym_match] = ACTIONS(773),
    [anon_sym_async] = ACTIONS(773),
    [anon_sym_in] = ACTIONS(771),
    [anon_sym_STAR_STAR] = ACTIONS(801),
    [anon_sym_exec] = ACTIONS(773),
    [anon_sym_type] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_LBRACK] = ACTIONS(496),
    [anon_sym_AT] = ACTIONS(801),
    [anon_sym_DASH] = ACTIONS(396),
    [anon_sym_PIPE] = ACTIONS(801),
    [anon_sym_LBRACE] = ACTIONS(391),
    [anon_sym_PLUS] = ACTIONS(396),
    [anon_sym_not] = ACTIONS(771),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_PERCENT] = ACTIONS(801),
    [anon_sym_SLASH_SLASH] = ACTIONS(801),
    [anon_sym_AMP] = ACTIONS(801),
    [anon_sym_CARET] = ACTIONS(801),
    [anon_sym_LT_LT] = ACTIONS(801),
    [anon_sym_TILDE] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_LT_EQ] = ACTIONS(766),
    [anon_sym_EQ_EQ] = ACTIONS(766),
    [anon_sym_BANG_EQ] = ACTIONS(766),
    [anon_sym_GT_EQ] = ACTIONS(766),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_LT_GT] = ACTIONS(766),
    [anon_sym_is] = ACTIONS(771),
    [sym_ellipsis] = ACTIONS(402),
    [sym_integer] = ACTIONS(404),
    [sym_float] = ACTIONS(402),
    [anon_sym_await] = ACTIONS(777),
    [sym_true] = ACTIONS(404),
    [sym_false] = ACTIONS(404),
    [sym_none] = ACTIONS(404),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(766),
    [sym_string_start] = ACTIONS(408),
  },
  [172] = {
    [sym_else_clause] = STATE(315),
    [sym_except_group_clause] = STATE(223),
    [sym_finally_clause] = STATE(479),
    [aux_sym_try_statement_repeat2] = STATE(223),
    [ts_builtin_sym_end] = ACTIONS(804),
    [sym_identifier] = ACTIONS(806),
    [anon_sym_import] = ACTIONS(806),
    [anon_sym_from] = ACTIONS(806),
    [anon_sym_LPAREN] = ACTIONS(804),
    [anon_sym_STAR] = ACTIONS(804),
    [anon_sym_print] = ACTIONS(806),
    [anon_sym_assert] = ACTIONS(806),
    [anon_sym_return] = ACTIONS(806),
    [anon_sym_del] = ACTIONS(806),
    [anon_sym_raise] = ACTIONS(806),
    [anon_sym_pass] = ACTIONS(806),
    [anon_sym_break] = ACTIONS(806),
    [anon_sym_continue] = ACTIONS(806),
    [anon_sym_if] = ACTIONS(806),
    [anon_sym_else] = ACTIONS(808),
    [anon_sym_match] = ACTIONS(806),
    [anon_sym_async] = ACTIONS(806),
    [anon_sym_for] = ACTIONS(806),
    [anon_sym_while] = ACTIONS(806),
    [anon_sym_try] = ACTIONS(806),
    [anon_sym_except_STAR] = ACTIONS(810),
    [anon_sym_finally] = ACTIONS(812),
    [anon_sym_with] = ACTIONS(806),
    [anon_sym_def] = ACTIONS(806),
    [anon_sym_global] = ACTIONS(806),
    [anon_sym_nonlocal] = ACTIONS(806),
    [anon_sym_exec] = ACTIONS(806),
    [anon_sym_type] = ACTIONS(806),
    [anon_sym_class] = ACTIONS(806),
    [anon_sym_LBRACK] = ACTIONS(804),
    [anon_sym_AT] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_LBRACE] = ACTIONS(804),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_not] = ACTIONS(806),
    [anon_sym_TILDE] = ACTIONS(804),
    [anon_sym_lambda] = ACTIONS(806),
    [anon_sym_yield] = ACTIONS(806),
    [sym_ellipsis] = ACTIONS(804),
    [sym_integer] = ACTIONS(806),
    [sym_float] = ACTIONS(804),
    [anon_sym_await] = ACTIONS(806),
    [sym_true] = ACTIONS(806),
    [sym_false] = ACTIONS(806),
    [sym_none] = ACTIONS(806),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(806),
    [anon_sym_container] = ACTIONS(806),
    [anon_sym_envvars] = ACTIONS(806),
    [anon_sym_include] = ACTIONS(806),
    [anon_sym_pepfile] = ACTIONS(806),
    [anon_sym_pepschema] = ACTIONS(806),
    [anon_sym_scattergather] = ACTIONS(806),
    [anon_sym_version] = ACTIONS(806),
    [anon_sym_wildcard_constraints] = ACTIONS(806),
    [anon_sym_workdir] = ACTIONS(806),
    [anon_sym_onerror] = ACTIONS(806),
    [anon_sym_onstart] = ACTIONS(806),
    [anon_sym_onsuccess] = ACTIONS(806),
    [anon_sym_localrules] = ACTIONS(806),
    [anon_sym_ruleorder] = ACTIONS(806),
    [anon_sym_rule] = ACTIONS(806),
    [anon_sym_checkpoint] = ACTIONS(806),
    [anon_sym_use] = ACTIONS(806),
    [anon_sym_module] = ACTIONS(806),
    [sym_string_start] = ACTIONS(804),
  },
  [173] = {
    [sym_else_clause] = STATE(298),
    [sym_except_clause] = STATE(224),
    [sym_finally_clause] = STATE(410),
    [aux_sym_try_statement_repeat1] = STATE(224),
    [ts_builtin_sym_end] = ACTIONS(814),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_import] = ACTIONS(816),
    [anon_sym_from] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(814),
    [anon_sym_STAR] = ACTIONS(814),
    [anon_sym_print] = ACTIONS(816),
    [anon_sym_assert] = ACTIONS(816),
    [anon_sym_return] = ACTIONS(816),
    [anon_sym_del] = ACTIONS(816),
    [anon_sym_raise] = ACTIONS(816),
    [anon_sym_pass] = ACTIONS(816),
    [anon_sym_break] = ACTIONS(816),
    [anon_sym_continue] = ACTIONS(816),
    [anon_sym_if] = ACTIONS(816),
    [anon_sym_else] = ACTIONS(808),
    [anon_sym_match] = ACTIONS(816),
    [anon_sym_async] = ACTIONS(816),
    [anon_sym_for] = ACTIONS(816),
    [anon_sym_while] = ACTIONS(816),
    [anon_sym_try] = ACTIONS(816),
    [anon_sym_except] = ACTIONS(818),
    [anon_sym_finally] = ACTIONS(812),
    [anon_sym_with] = ACTIONS(816),
    [anon_sym_def] = ACTIONS(816),
    [anon_sym_global] = ACTIONS(816),
    [anon_sym_nonlocal] = ACTIONS(816),
    [anon_sym_exec] = ACTIONS(816),
    [anon_sym_type] = ACTIONS(816),
    [anon_sym_class] = ACTIONS(816),
    [anon_sym_LBRACK] = ACTIONS(814),
    [anon_sym_AT] = ACTIONS(814),
    [anon_sym_DASH] = ACTIONS(814),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_PLUS] = ACTIONS(814),
    [anon_sym_not] = ACTIONS(816),
    [anon_sym_TILDE] = ACTIONS(814),
    [anon_sym_lambda] = ACTIONS(816),
    [anon_sym_yield] = ACTIONS(816),
    [sym_ellipsis] = ACTIONS(814),
    [sym_integer] = ACTIONS(816),
    [sym_float] = ACTIONS(814),
    [anon_sym_await] = ACTIONS(816),
    [sym_true] = ACTIONS(816),
    [sym_false] = ACTIONS(816),
    [sym_none] = ACTIONS(816),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(816),
    [anon_sym_container] = ACTIONS(816),
    [anon_sym_envvars] = ACTIONS(816),
    [anon_sym_include] = ACTIONS(816),
    [anon_sym_pepfile] = ACTIONS(816),
    [anon_sym_pepschema] = ACTIONS(816),
    [anon_sym_scattergather] = ACTIONS(816),
    [anon_sym_version] = ACTIONS(816),
    [anon_sym_wildcard_constraints] = ACTIONS(816),
    [anon_sym_workdir] = ACTIONS(816),
    [anon_sym_onerror] = ACTIONS(816),
    [anon_sym_onstart] = ACTIONS(816),
    [anon_sym_onsuccess] = ACTIONS(816),
    [anon_sym_localrules] = ACTIONS(816),
    [anon_sym_ruleorder] = ACTIONS(816),
    [anon_sym_rule] = ACTIONS(816),
    [anon_sym_checkpoint] = ACTIONS(816),
    [anon_sym_use] = ACTIONS(816),
    [anon_sym_module] = ACTIONS(816),
    [sym_string_start] = ACTIONS(814),
  },
  [174] = {
    [sym_else_clause] = STATE(297),
    [sym_except_group_clause] = STATE(219),
    [sym_finally_clause] = STATE(406),
    [aux_sym_try_statement_repeat2] = STATE(219),
    [sym_identifier] = ACTIONS(806),
    [anon_sym_import] = ACTIONS(806),
    [anon_sym_from] = ACTIONS(806),
    [anon_sym_LPAREN] = ACTIONS(804),
    [anon_sym_STAR] = ACTIONS(804),
    [anon_sym_print] = ACTIONS(806),
    [anon_sym_assert] = ACTIONS(806),
    [anon_sym_return] = ACTIONS(806),
    [anon_sym_del] = ACTIONS(806),
    [anon_sym_raise] = ACTIONS(806),
    [anon_sym_pass] = ACTIONS(806),
    [anon_sym_break] = ACTIONS(806),
    [anon_sym_continue] = ACTIONS(806),
    [anon_sym_if] = ACTIONS(806),
    [anon_sym_else] = ACTIONS(820),
    [anon_sym_match] = ACTIONS(806),
    [anon_sym_async] = ACTIONS(806),
    [anon_sym_for] = ACTIONS(806),
    [anon_sym_while] = ACTIONS(806),
    [anon_sym_try] = ACTIONS(806),
    [anon_sym_except_STAR] = ACTIONS(822),
    [anon_sym_finally] = ACTIONS(824),
    [anon_sym_with] = ACTIONS(806),
    [anon_sym_def] = ACTIONS(806),
    [anon_sym_global] = ACTIONS(806),
    [anon_sym_nonlocal] = ACTIONS(806),
    [anon_sym_exec] = ACTIONS(806),
    [anon_sym_type] = ACTIONS(806),
    [anon_sym_class] = ACTIONS(806),
    [anon_sym_LBRACK] = ACTIONS(804),
    [anon_sym_AT] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_LBRACE] = ACTIONS(804),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_not] = ACTIONS(806),
    [anon_sym_TILDE] = ACTIONS(804),
    [anon_sym_lambda] = ACTIONS(806),
    [anon_sym_yield] = ACTIONS(806),
    [sym_ellipsis] = ACTIONS(804),
    [sym_integer] = ACTIONS(806),
    [sym_float] = ACTIONS(804),
    [anon_sym_await] = ACTIONS(806),
    [sym_true] = ACTIONS(806),
    [sym_false] = ACTIONS(806),
    [sym_none] = ACTIONS(806),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(806),
    [anon_sym_container] = ACTIONS(806),
    [anon_sym_envvars] = ACTIONS(806),
    [anon_sym_include] = ACTIONS(806),
    [anon_sym_pepfile] = ACTIONS(806),
    [anon_sym_pepschema] = ACTIONS(806),
    [anon_sym_scattergather] = ACTIONS(806),
    [anon_sym_version] = ACTIONS(806),
    [anon_sym_wildcard_constraints] = ACTIONS(806),
    [anon_sym_workdir] = ACTIONS(806),
    [anon_sym_onerror] = ACTIONS(806),
    [anon_sym_onstart] = ACTIONS(806),
    [anon_sym_onsuccess] = ACTIONS(806),
    [anon_sym_localrules] = ACTIONS(806),
    [anon_sym_ruleorder] = ACTIONS(806),
    [anon_sym_rule] = ACTIONS(806),
    [anon_sym_checkpoint] = ACTIONS(806),
    [anon_sym_use] = ACTIONS(806),
    [anon_sym_module] = ACTIONS(806),
    [sym__dedent] = ACTIONS(804),
    [sym_string_start] = ACTIONS(804),
  },
  [175] = {
    [sym_else_clause] = STATE(292),
    [sym_except_clause] = STATE(217),
    [sym_finally_clause] = STATE(391),
    [aux_sym_try_statement_repeat1] = STATE(217),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_import] = ACTIONS(816),
    [anon_sym_from] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(814),
    [anon_sym_STAR] = ACTIONS(814),
    [anon_sym_print] = ACTIONS(816),
    [anon_sym_assert] = ACTIONS(816),
    [anon_sym_return] = ACTIONS(816),
    [anon_sym_del] = ACTIONS(816),
    [anon_sym_raise] = ACTIONS(816),
    [anon_sym_pass] = ACTIONS(816),
    [anon_sym_break] = ACTIONS(816),
    [anon_sym_continue] = ACTIONS(816),
    [anon_sym_if] = ACTIONS(816),
    [anon_sym_else] = ACTIONS(820),
    [anon_sym_match] = ACTIONS(816),
    [anon_sym_async] = ACTIONS(816),
    [anon_sym_for] = ACTIONS(816),
    [anon_sym_while] = ACTIONS(816),
    [anon_sym_try] = ACTIONS(816),
    [anon_sym_except] = ACTIONS(826),
    [anon_sym_finally] = ACTIONS(824),
    [anon_sym_with] = ACTIONS(816),
    [anon_sym_def] = ACTIONS(816),
    [anon_sym_global] = ACTIONS(816),
    [anon_sym_nonlocal] = ACTIONS(816),
    [anon_sym_exec] = ACTIONS(816),
    [anon_sym_type] = ACTIONS(816),
    [anon_sym_class] = ACTIONS(816),
    [anon_sym_LBRACK] = ACTIONS(814),
    [anon_sym_AT] = ACTIONS(814),
    [anon_sym_DASH] = ACTIONS(814),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_PLUS] = ACTIONS(814),
    [anon_sym_not] = ACTIONS(816),
    [anon_sym_TILDE] = ACTIONS(814),
    [anon_sym_lambda] = ACTIONS(816),
    [anon_sym_yield] = ACTIONS(816),
    [sym_ellipsis] = ACTIONS(814),
    [sym_integer] = ACTIONS(816),
    [sym_float] = ACTIONS(814),
    [anon_sym_await] = ACTIONS(816),
    [sym_true] = ACTIONS(816),
    [sym_false] = ACTIONS(816),
    [sym_none] = ACTIONS(816),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(816),
    [anon_sym_container] = ACTIONS(816),
    [anon_sym_envvars] = ACTIONS(816),
    [anon_sym_include] = ACTIONS(816),
    [anon_sym_pepfile] = ACTIONS(816),
    [anon_sym_pepschema] = ACTIONS(816),
    [anon_sym_scattergather] = ACTIONS(816),
    [anon_sym_version] = ACTIONS(816),
    [anon_sym_wildcard_constraints] = ACTIONS(816),
    [anon_sym_workdir] = ACTIONS(816),
    [anon_sym_onerror] = ACTIONS(816),
    [anon_sym_onstart] = ACTIONS(816),
    [anon_sym_onsuccess] = ACTIONS(816),
    [anon_sym_localrules] = ACTIONS(816),
    [anon_sym_ruleorder] = ACTIONS(816),
    [anon_sym_rule] = ACTIONS(816),
    [anon_sym_checkpoint] = ACTIONS(816),
    [anon_sym_use] = ACTIONS(816),
    [anon_sym_module] = ACTIONS(816),
    [sym__dedent] = ACTIONS(814),
    [sym_string_start] = ACTIONS(814),
  },
  [176] = {
    [sym_else_clause] = STATE(292),
    [sym_except_group_clause] = STATE(219),
    [sym_finally_clause] = STATE(391),
    [aux_sym_try_statement_repeat2] = STATE(219),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_import] = ACTIONS(816),
    [anon_sym_from] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(814),
    [anon_sym_STAR] = ACTIONS(814),
    [anon_sym_print] = ACTIONS(816),
    [anon_sym_assert] = ACTIONS(816),
    [anon_sym_return] = ACTIONS(816),
    [anon_sym_del] = ACTIONS(816),
    [anon_sym_raise] = ACTIONS(816),
    [anon_sym_pass] = ACTIONS(816),
    [anon_sym_break] = ACTIONS(816),
    [anon_sym_continue] = ACTIONS(816),
    [anon_sym_if] = ACTIONS(816),
    [anon_sym_else] = ACTIONS(820),
    [anon_sym_match] = ACTIONS(816),
    [anon_sym_async] = ACTIONS(816),
    [anon_sym_for] = ACTIONS(816),
    [anon_sym_while] = ACTIONS(816),
    [anon_sym_try] = ACTIONS(816),
    [anon_sym_except_STAR] = ACTIONS(822),
    [anon_sym_finally] = ACTIONS(824),
    [anon_sym_with] = ACTIONS(816),
    [anon_sym_def] = ACTIONS(816),
    [anon_sym_global] = ACTIONS(816),
    [anon_sym_nonlocal] = ACTIONS(816),
    [anon_sym_exec] = ACTIONS(816),
    [anon_sym_type] = ACTIONS(816),
    [anon_sym_class] = ACTIONS(816),
    [anon_sym_LBRACK] = ACTIONS(814),
    [anon_sym_AT] = ACTIONS(814),
    [anon_sym_DASH] = ACTIONS(814),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_PLUS] = ACTIONS(814),
    [anon_sym_not] = ACTIONS(816),
    [anon_sym_TILDE] = ACTIONS(814),
    [anon_sym_lambda] = ACTIONS(816),
    [anon_sym_yield] = ACTIONS(816),
    [sym_ellipsis] = ACTIONS(814),
    [sym_integer] = ACTIONS(816),
    [sym_float] = ACTIONS(814),
    [anon_sym_await] = ACTIONS(816),
    [sym_true] = ACTIONS(816),
    [sym_false] = ACTIONS(816),
    [sym_none] = ACTIONS(816),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(816),
    [anon_sym_container] = ACTIONS(816),
    [anon_sym_envvars] = ACTIONS(816),
    [anon_sym_include] = ACTIONS(816),
    [anon_sym_pepfile] = ACTIONS(816),
    [anon_sym_pepschema] = ACTIONS(816),
    [anon_sym_scattergather] = ACTIONS(816),
    [anon_sym_version] = ACTIONS(816),
    [anon_sym_wildcard_constraints] = ACTIONS(816),
    [anon_sym_workdir] = ACTIONS(816),
    [anon_sym_onerror] = ACTIONS(816),
    [anon_sym_onstart] = ACTIONS(816),
    [anon_sym_onsuccess] = ACTIONS(816),
    [anon_sym_localrules] = ACTIONS(816),
    [anon_sym_ruleorder] = ACTIONS(816),
    [anon_sym_rule] = ACTIONS(816),
    [anon_sym_checkpoint] = ACTIONS(816),
    [anon_sym_use] = ACTIONS(816),
    [anon_sym_module] = ACTIONS(816),
    [sym__dedent] = ACTIONS(814),
    [sym_string_start] = ACTIONS(814),
  },
  [177] = {
    [sym_else_clause] = STATE(297),
    [sym_except_clause] = STATE(217),
    [sym_finally_clause] = STATE(406),
    [aux_sym_try_statement_repeat1] = STATE(217),
    [sym_identifier] = ACTIONS(806),
    [anon_sym_import] = ACTIONS(806),
    [anon_sym_from] = ACTIONS(806),
    [anon_sym_LPAREN] = ACTIONS(804),
    [anon_sym_STAR] = ACTIONS(804),
    [anon_sym_print] = ACTIONS(806),
    [anon_sym_assert] = ACTIONS(806),
    [anon_sym_return] = ACTIONS(806),
    [anon_sym_del] = ACTIONS(806),
    [anon_sym_raise] = ACTIONS(806),
    [anon_sym_pass] = ACTIONS(806),
    [anon_sym_break] = ACTIONS(806),
    [anon_sym_continue] = ACTIONS(806),
    [anon_sym_if] = ACTIONS(806),
    [anon_sym_else] = ACTIONS(820),
    [anon_sym_match] = ACTIONS(806),
    [anon_sym_async] = ACTIONS(806),
    [anon_sym_for] = ACTIONS(806),
    [anon_sym_while] = ACTIONS(806),
    [anon_sym_try] = ACTIONS(806),
    [anon_sym_except] = ACTIONS(826),
    [anon_sym_finally] = ACTIONS(824),
    [anon_sym_with] = ACTIONS(806),
    [anon_sym_def] = ACTIONS(806),
    [anon_sym_global] = ACTIONS(806),
    [anon_sym_nonlocal] = ACTIONS(806),
    [anon_sym_exec] = ACTIONS(806),
    [anon_sym_type] = ACTIONS(806),
    [anon_sym_class] = ACTIONS(806),
    [anon_sym_LBRACK] = ACTIONS(804),
    [anon_sym_AT] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_LBRACE] = ACTIONS(804),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_not] = ACTIONS(806),
    [anon_sym_TILDE] = ACTIONS(804),
    [anon_sym_lambda] = ACTIONS(806),
    [anon_sym_yield] = ACTIONS(806),
    [sym_ellipsis] = ACTIONS(804),
    [sym_integer] = ACTIONS(806),
    [sym_float] = ACTIONS(804),
    [anon_sym_await] = ACTIONS(806),
    [sym_true] = ACTIONS(806),
    [sym_false] = ACTIONS(806),
    [sym_none] = ACTIONS(806),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(806),
    [anon_sym_container] = ACTIONS(806),
    [anon_sym_envvars] = ACTIONS(806),
    [anon_sym_include] = ACTIONS(806),
    [anon_sym_pepfile] = ACTIONS(806),
    [anon_sym_pepschema] = ACTIONS(806),
    [anon_sym_scattergather] = ACTIONS(806),
    [anon_sym_version] = ACTIONS(806),
    [anon_sym_wildcard_constraints] = ACTIONS(806),
    [anon_sym_workdir] = ACTIONS(806),
    [anon_sym_onerror] = ACTIONS(806),
    [anon_sym_onstart] = ACTIONS(806),
    [anon_sym_onsuccess] = ACTIONS(806),
    [anon_sym_localrules] = ACTIONS(806),
    [anon_sym_ruleorder] = ACTIONS(806),
    [anon_sym_rule] = ACTIONS(806),
    [anon_sym_checkpoint] = ACTIONS(806),
    [anon_sym_use] = ACTIONS(806),
    [anon_sym_module] = ACTIONS(806),
    [sym__dedent] = ACTIONS(804),
    [sym_string_start] = ACTIONS(804),
  },
  [178] = {
    [sym_list_splat_pattern] = STATE(1530),
    [sym_primary_expression] = STATE(1296),
    [sym_binary_operator] = STATE(1660),
    [sym_unary_operator] = STATE(1660),
    [sym_attribute] = STATE(1660),
    [sym_subscript] = STATE(1660),
    [sym_call] = STATE(1660),
    [sym_list] = STATE(1660),
    [sym_set] = STATE(1660),
    [sym_tuple] = STATE(1660),
    [sym_dictionary] = STATE(1660),
    [sym_list_comprehension] = STATE(1660),
    [sym_dictionary_comprehension] = STATE(1660),
    [sym_set_comprehension] = STATE(1660),
    [sym_generator_expression] = STATE(1660),
    [sym_parenthesized_expression] = STATE(1660),
    [sym_concatenated_string] = STATE(1660),
    [sym_string] = STATE(1271),
    [sym_await] = STATE(1660),
    [sym_identifier] = ACTIONS(828),
    [anon_sym_DOT] = ACTIONS(363),
    [anon_sym_LPAREN] = ACTIONS(830),
    [anon_sym_RPAREN] = ACTIONS(361),
    [anon_sym_COMMA] = ACTIONS(361),
    [anon_sym_as] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(832),
    [anon_sym_print] = ACTIONS(834),
    [anon_sym_GT_GT] = ACTIONS(361),
    [anon_sym_COLON_EQ] = ACTIONS(376),
    [anon_sym_if] = ACTIONS(363),
    [anon_sym_match] = ACTIONS(834),
    [anon_sym_async] = ACTIONS(834),
    [anon_sym_for] = ACTIONS(363),
    [anon_sym_in] = ACTIONS(363),
    [anon_sym_STAR_STAR] = ACTIONS(361),
    [anon_sym_exec] = ACTIONS(834),
    [anon_sym_type] = ACTIONS(836),
    [anon_sym_EQ] = ACTIONS(838),
    [anon_sym_LBRACK] = ACTIONS(840),
    [anon_sym_AT] = ACTIONS(361),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_PIPE] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(844),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_not] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(363),
    [anon_sym_or] = ACTIONS(363),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(361),
    [anon_sym_SLASH_SLASH] = ACTIONS(361),
    [anon_sym_AMP] = ACTIONS(361),
    [anon_sym_CARET] = ACTIONS(361),
    [anon_sym_LT_LT] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(842),
    [anon_sym_LT] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(361),
    [anon_sym_EQ_EQ] = ACTIONS(361),
    [anon_sym_BANG_EQ] = ACTIONS(361),
    [anon_sym_GT_EQ] = ACTIONS(361),
    [anon_sym_GT] = ACTIONS(363),
    [anon_sym_LT_GT] = ACTIONS(361),
    [anon_sym_is] = ACTIONS(363),
    [sym_ellipsis] = ACTIONS(846),
    [sym_integer] = ACTIONS(828),
    [sym_float] = ACTIONS(846),
    [anon_sym_await] = ACTIONS(848),
    [sym_true] = ACTIONS(828),
    [sym_false] = ACTIONS(828),
    [sym_none] = ACTIONS(828),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(850),
  },
  [179] = {
    [sym_list_splat_pattern] = STATE(1504),
    [sym_primary_expression] = STATE(1246),
    [sym_binary_operator] = STATE(1477),
    [sym_unary_operator] = STATE(1477),
    [sym_attribute] = STATE(1477),
    [sym_subscript] = STATE(1477),
    [sym_call] = STATE(1477),
    [sym_list] = STATE(1477),
    [sym_set] = STATE(1477),
    [sym_tuple] = STATE(1477),
    [sym_dictionary] = STATE(1477),
    [sym_list_comprehension] = STATE(1477),
    [sym_dictionary_comprehension] = STATE(1477),
    [sym_set_comprehension] = STATE(1477),
    [sym_generator_expression] = STATE(1477),
    [sym_parenthesized_expression] = STATE(1477),
    [sym_concatenated_string] = STATE(1477),
    [sym_string] = STATE(1227),
    [sym_await] = STATE(1477),
    [sym_identifier] = ACTIONS(852),
    [anon_sym_DOT] = ACTIONS(363),
    [anon_sym_LPAREN] = ACTIONS(854),
    [anon_sym_COMMA] = ACTIONS(361),
    [anon_sym_as] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(856),
    [anon_sym_print] = ACTIONS(858),
    [anon_sym_GT_GT] = ACTIONS(361),
    [anon_sym_COLON_EQ] = ACTIONS(376),
    [anon_sym_if] = ACTIONS(363),
    [anon_sym_COLON] = ACTIONS(363),
    [anon_sym_match] = ACTIONS(858),
    [anon_sym_async] = ACTIONS(858),
    [anon_sym_for] = ACTIONS(363),
    [anon_sym_in] = ACTIONS(363),
    [anon_sym_STAR_STAR] = ACTIONS(361),
    [anon_sym_exec] = ACTIONS(858),
    [anon_sym_type] = ACTIONS(860),
    [anon_sym_LBRACK] = ACTIONS(862),
    [anon_sym_AT] = ACTIONS(361),
    [anon_sym_DASH] = ACTIONS(864),
    [anon_sym_PIPE] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(866),
    [anon_sym_RBRACE] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(864),
    [anon_sym_not] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(363),
    [anon_sym_or] = ACTIONS(363),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(361),
    [anon_sym_SLASH_SLASH] = ACTIONS(361),
    [anon_sym_AMP] = ACTIONS(361),
    [anon_sym_CARET] = ACTIONS(361),
    [anon_sym_LT_LT] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(864),
    [anon_sym_LT] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(361),
    [anon_sym_EQ_EQ] = ACTIONS(361),
    [anon_sym_BANG_EQ] = ACTIONS(361),
    [anon_sym_GT_EQ] = ACTIONS(361),
    [anon_sym_GT] = ACTIONS(363),
    [anon_sym_LT_GT] = ACTIONS(361),
    [anon_sym_is] = ACTIONS(363),
    [sym_ellipsis] = ACTIONS(868),
    [sym_integer] = ACTIONS(852),
    [sym_float] = ACTIONS(868),
    [anon_sym_await] = ACTIONS(870),
    [sym_true] = ACTIONS(852),
    [sym_false] = ACTIONS(852),
    [sym_none] = ACTIONS(852),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(872),
  },
  [180] = {
    [sym_list_splat_pattern] = STATE(1541),
    [sym_primary_expression] = STATE(1298),
    [sym_binary_operator] = STATE(1536),
    [sym_unary_operator] = STATE(1536),
    [sym_attribute] = STATE(1536),
    [sym_subscript] = STATE(1536),
    [sym_call] = STATE(1536),
    [sym_list] = STATE(1536),
    [sym_set] = STATE(1536),
    [sym_tuple] = STATE(1536),
    [sym_dictionary] = STATE(1536),
    [sym_list_comprehension] = STATE(1536),
    [sym_dictionary_comprehension] = STATE(1536),
    [sym_set_comprehension] = STATE(1536),
    [sym_generator_expression] = STATE(1536),
    [sym_parenthesized_expression] = STATE(1536),
    [sym_concatenated_string] = STATE(1536),
    [sym_string] = STATE(1234),
    [sym_await] = STATE(1536),
    [sym_identifier] = ACTIONS(404),
    [anon_sym_DOT] = ACTIONS(768),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_RPAREN] = ACTIONS(766),
    [anon_sym_COMMA] = ACTIONS(766),
    [anon_sym_as] = ACTIONS(771),
    [anon_sym_STAR] = ACTIONS(494),
    [anon_sym_print] = ACTIONS(773),
    [anon_sym_GT_GT] = ACTIONS(801),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_COLON] = ACTIONS(766),
    [anon_sym_match] = ACTIONS(773),
    [anon_sym_async] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(771),
    [anon_sym_in] = ACTIONS(771),
    [anon_sym_STAR_STAR] = ACTIONS(801),
    [anon_sym_exec] = ACTIONS(773),
    [anon_sym_type] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_LBRACK] = ACTIONS(496),
    [anon_sym_AT] = ACTIONS(801),
    [anon_sym_DASH] = ACTIONS(396),
    [anon_sym_PIPE] = ACTIONS(801),
    [anon_sym_LBRACE] = ACTIONS(391),
    [anon_sym_PLUS] = ACTIONS(396),
    [anon_sym_not] = ACTIONS(771),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_PERCENT] = ACTIONS(801),
    [anon_sym_SLASH_SLASH] = ACTIONS(801),
    [anon_sym_AMP] = ACTIONS(801),
    [anon_sym_CARET] = ACTIONS(801),
    [anon_sym_LT_LT] = ACTIONS(801),
    [anon_sym_TILDE] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_LT_EQ] = ACTIONS(766),
    [anon_sym_EQ_EQ] = ACTIONS(766),
    [anon_sym_BANG_EQ] = ACTIONS(766),
    [anon_sym_GT_EQ] = ACTIONS(766),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_LT_GT] = ACTIONS(766),
    [anon_sym_is] = ACTIONS(771),
    [sym_ellipsis] = ACTIONS(402),
    [sym_integer] = ACTIONS(404),
    [sym_float] = ACTIONS(402),
    [anon_sym_await] = ACTIONS(777),
    [sym_true] = ACTIONS(404),
    [sym_false] = ACTIONS(404),
    [sym_none] = ACTIONS(404),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(408),
  },
  [181] = {
    [sym_list_splat_pattern] = STATE(1541),
    [sym_primary_expression] = STATE(1298),
    [sym_binary_operator] = STATE(1536),
    [sym_unary_operator] = STATE(1536),
    [sym_attribute] = STATE(1536),
    [sym_subscript] = STATE(1536),
    [sym_call] = STATE(1536),
    [sym_list] = STATE(1536),
    [sym_set] = STATE(1536),
    [sym_tuple] = STATE(1536),
    [sym_dictionary] = STATE(1536),
    [sym_list_comprehension] = STATE(1536),
    [sym_dictionary_comprehension] = STATE(1536),
    [sym_set_comprehension] = STATE(1536),
    [sym_generator_expression] = STATE(1536),
    [sym_parenthesized_expression] = STATE(1536),
    [sym_concatenated_string] = STATE(1536),
    [sym_string] = STATE(1234),
    [sym_await] = STATE(1536),
    [sym_identifier] = ACTIONS(404),
    [anon_sym_DOT] = ACTIONS(363),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_COMMA] = ACTIONS(361),
    [anon_sym_as] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(494),
    [anon_sym_print] = ACTIONS(773),
    [anon_sym_GT_GT] = ACTIONS(361),
    [anon_sym_COLON_EQ] = ACTIONS(376),
    [anon_sym_if] = ACTIONS(363),
    [anon_sym_COLON] = ACTIONS(363),
    [anon_sym_else] = ACTIONS(363),
    [anon_sym_match] = ACTIONS(773),
    [anon_sym_async] = ACTIONS(773),
    [anon_sym_in] = ACTIONS(363),
    [anon_sym_STAR_STAR] = ACTIONS(361),
    [anon_sym_exec] = ACTIONS(773),
    [anon_sym_type] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(496),
    [anon_sym_AT] = ACTIONS(361),
    [anon_sym_DASH] = ACTIONS(396),
    [anon_sym_PIPE] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(391),
    [anon_sym_PLUS] = ACTIONS(396),
    [anon_sym_not] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(363),
    [anon_sym_or] = ACTIONS(363),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(361),
    [anon_sym_SLASH_SLASH] = ACTIONS(361),
    [anon_sym_AMP] = ACTIONS(361),
    [anon_sym_CARET] = ACTIONS(361),
    [anon_sym_LT_LT] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(361),
    [anon_sym_EQ_EQ] = ACTIONS(361),
    [anon_sym_BANG_EQ] = ACTIONS(361),
    [anon_sym_GT_EQ] = ACTIONS(361),
    [anon_sym_GT] = ACTIONS(363),
    [anon_sym_LT_GT] = ACTIONS(361),
    [anon_sym_is] = ACTIONS(363),
    [sym_ellipsis] = ACTIONS(402),
    [sym_integer] = ACTIONS(404),
    [sym_float] = ACTIONS(402),
    [anon_sym_await] = ACTIONS(777),
    [sym_true] = ACTIONS(404),
    [sym_false] = ACTIONS(404),
    [sym_none] = ACTIONS(404),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(408),
  },
  [182] = {
    [sym_else_clause] = STATE(315),
    [sym_except_clause] = STATE(224),
    [sym_finally_clause] = STATE(479),
    [aux_sym_try_statement_repeat1] = STATE(224),
    [ts_builtin_sym_end] = ACTIONS(804),
    [sym_identifier] = ACTIONS(806),
    [anon_sym_import] = ACTIONS(806),
    [anon_sym_from] = ACTIONS(806),
    [anon_sym_LPAREN] = ACTIONS(804),
    [anon_sym_STAR] = ACTIONS(804),
    [anon_sym_print] = ACTIONS(806),
    [anon_sym_assert] = ACTIONS(806),
    [anon_sym_return] = ACTIONS(806),
    [anon_sym_del] = ACTIONS(806),
    [anon_sym_raise] = ACTIONS(806),
    [anon_sym_pass] = ACTIONS(806),
    [anon_sym_break] = ACTIONS(806),
    [anon_sym_continue] = ACTIONS(806),
    [anon_sym_if] = ACTIONS(806),
    [anon_sym_else] = ACTIONS(808),
    [anon_sym_match] = ACTIONS(806),
    [anon_sym_async] = ACTIONS(806),
    [anon_sym_for] = ACTIONS(806),
    [anon_sym_while] = ACTIONS(806),
    [anon_sym_try] = ACTIONS(806),
    [anon_sym_except] = ACTIONS(818),
    [anon_sym_finally] = ACTIONS(812),
    [anon_sym_with] = ACTIONS(806),
    [anon_sym_def] = ACTIONS(806),
    [anon_sym_global] = ACTIONS(806),
    [anon_sym_nonlocal] = ACTIONS(806),
    [anon_sym_exec] = ACTIONS(806),
    [anon_sym_type] = ACTIONS(806),
    [anon_sym_class] = ACTIONS(806),
    [anon_sym_LBRACK] = ACTIONS(804),
    [anon_sym_AT] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_LBRACE] = ACTIONS(804),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_not] = ACTIONS(806),
    [anon_sym_TILDE] = ACTIONS(804),
    [anon_sym_lambda] = ACTIONS(806),
    [anon_sym_yield] = ACTIONS(806),
    [sym_ellipsis] = ACTIONS(804),
    [sym_integer] = ACTIONS(806),
    [sym_float] = ACTIONS(804),
    [anon_sym_await] = ACTIONS(806),
    [sym_true] = ACTIONS(806),
    [sym_false] = ACTIONS(806),
    [sym_none] = ACTIONS(806),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(806),
    [anon_sym_container] = ACTIONS(806),
    [anon_sym_envvars] = ACTIONS(806),
    [anon_sym_include] = ACTIONS(806),
    [anon_sym_pepfile] = ACTIONS(806),
    [anon_sym_pepschema] = ACTIONS(806),
    [anon_sym_scattergather] = ACTIONS(806),
    [anon_sym_version] = ACTIONS(806),
    [anon_sym_wildcard_constraints] = ACTIONS(806),
    [anon_sym_workdir] = ACTIONS(806),
    [anon_sym_onerror] = ACTIONS(806),
    [anon_sym_onstart] = ACTIONS(806),
    [anon_sym_onsuccess] = ACTIONS(806),
    [anon_sym_localrules] = ACTIONS(806),
    [anon_sym_ruleorder] = ACTIONS(806),
    [anon_sym_rule] = ACTIONS(806),
    [anon_sym_checkpoint] = ACTIONS(806),
    [anon_sym_use] = ACTIONS(806),
    [anon_sym_module] = ACTIONS(806),
    [sym_string_start] = ACTIONS(804),
  },
  [183] = {
    [sym_list_splat_pattern] = STATE(1459),
    [sym_primary_expression] = STATE(1244),
    [sym_binary_operator] = STATE(1449),
    [sym_unary_operator] = STATE(1449),
    [sym_attribute] = STATE(1449),
    [sym_subscript] = STATE(1449),
    [sym_call] = STATE(1449),
    [sym_list] = STATE(1449),
    [sym_set] = STATE(1449),
    [sym_tuple] = STATE(1449),
    [sym_dictionary] = STATE(1449),
    [sym_list_comprehension] = STATE(1449),
    [sym_dictionary_comprehension] = STATE(1449),
    [sym_set_comprehension] = STATE(1449),
    [sym_generator_expression] = STATE(1449),
    [sym_parenthesized_expression] = STATE(1449),
    [sym_concatenated_string] = STATE(1449),
    [sym_string] = STATE(1223),
    [sym_await] = STATE(1449),
    [sym_identifier] = ACTIONS(779),
    [anon_sym_DOT] = ACTIONS(768),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_COMMA] = ACTIONS(801),
    [anon_sym_as] = ACTIONS(768),
    [anon_sym_STAR] = ACTIONS(783),
    [anon_sym_print] = ACTIONS(785),
    [anon_sym_GT_GT] = ACTIONS(801),
    [anon_sym_COLON_EQ] = ACTIONS(376),
    [anon_sym_if] = ACTIONS(768),
    [anon_sym_COLON] = ACTIONS(771),
    [anon_sym_match] = ACTIONS(785),
    [anon_sym_async] = ACTIONS(785),
    [anon_sym_for] = ACTIONS(771),
    [anon_sym_in] = ACTIONS(768),
    [anon_sym_STAR_STAR] = ACTIONS(801),
    [anon_sym_exec] = ACTIONS(785),
    [anon_sym_type] = ACTIONS(787),
    [anon_sym_LBRACK] = ACTIONS(789),
    [anon_sym_AT] = ACTIONS(801),
    [anon_sym_DASH] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(801),
    [anon_sym_LBRACE] = ACTIONS(793),
    [anon_sym_RBRACE] = ACTIONS(801),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_not] = ACTIONS(768),
    [anon_sym_and] = ACTIONS(768),
    [anon_sym_or] = ACTIONS(768),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_PERCENT] = ACTIONS(801),
    [anon_sym_SLASH_SLASH] = ACTIONS(801),
    [anon_sym_AMP] = ACTIONS(801),
    [anon_sym_CARET] = ACTIONS(801),
    [anon_sym_LT_LT] = ACTIONS(801),
    [anon_sym_TILDE] = ACTIONS(791),
    [anon_sym_LT] = ACTIONS(768),
    [anon_sym_LT_EQ] = ACTIONS(801),
    [anon_sym_EQ_EQ] = ACTIONS(801),
    [anon_sym_BANG_EQ] = ACTIONS(801),
    [anon_sym_GT_EQ] = ACTIONS(801),
    [anon_sym_GT] = ACTIONS(768),
    [anon_sym_LT_GT] = ACTIONS(801),
    [anon_sym_is] = ACTIONS(768),
    [sym_ellipsis] = ACTIONS(795),
    [sym_integer] = ACTIONS(779),
    [sym_float] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(797),
    [sym_true] = ACTIONS(779),
    [sym_false] = ACTIONS(779),
    [sym_none] = ACTIONS(779),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(799),
  },
  [184] = {
    [sym_list_splat_pattern] = STATE(1641),
    [sym_primary_expression] = STATE(1379),
    [sym_binary_operator] = STATE(1642),
    [sym_unary_operator] = STATE(1642),
    [sym_attribute] = STATE(1642),
    [sym_subscript] = STATE(1642),
    [sym_call] = STATE(1642),
    [sym_list] = STATE(1642),
    [sym_set] = STATE(1642),
    [sym_tuple] = STATE(1642),
    [sym_dictionary] = STATE(1642),
    [sym_list_comprehension] = STATE(1642),
    [sym_dictionary_comprehension] = STATE(1642),
    [sym_set_comprehension] = STATE(1642),
    [sym_generator_expression] = STATE(1642),
    [sym_parenthesized_expression] = STATE(1642),
    [sym_concatenated_string] = STATE(1642),
    [sym_string] = STATE(1245),
    [sym_await] = STATE(1642),
    [sym_identifier] = ACTIONS(874),
    [anon_sym_DOT] = ACTIONS(363),
    [anon_sym_LPAREN] = ACTIONS(876),
    [anon_sym_RPAREN] = ACTIONS(361),
    [anon_sym_COMMA] = ACTIONS(361),
    [anon_sym_as] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(878),
    [anon_sym_print] = ACTIONS(880),
    [anon_sym_GT_GT] = ACTIONS(361),
    [anon_sym_COLON_EQ] = ACTIONS(376),
    [anon_sym_if] = ACTIONS(363),
    [anon_sym_COLON] = ACTIONS(363),
    [anon_sym_match] = ACTIONS(880),
    [anon_sym_async] = ACTIONS(880),
    [anon_sym_in] = ACTIONS(363),
    [anon_sym_STAR_STAR] = ACTIONS(361),
    [anon_sym_exec] = ACTIONS(880),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_EQ] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_AT] = ACTIONS(361),
    [anon_sym_DASH] = ACTIONS(886),
    [anon_sym_PIPE] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(888),
    [anon_sym_PLUS] = ACTIONS(886),
    [anon_sym_not] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(363),
    [anon_sym_or] = ACTIONS(363),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(361),
    [anon_sym_SLASH_SLASH] = ACTIONS(361),
    [anon_sym_AMP] = ACTIONS(361),
    [anon_sym_CARET] = ACTIONS(361),
    [anon_sym_LT_LT] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(886),
    [anon_sym_LT] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(361),
    [anon_sym_EQ_EQ] = ACTIONS(361),
    [anon_sym_BANG_EQ] = ACTIONS(361),
    [anon_sym_GT_EQ] = ACTIONS(361),
    [anon_sym_GT] = ACTIONS(363),
    [anon_sym_LT_GT] = ACTIONS(361),
    [anon_sym_is] = ACTIONS(363),
    [sym_ellipsis] = ACTIONS(890),
    [sym_integer] = ACTIONS(874),
    [sym_float] = ACTIONS(890),
    [anon_sym_await] = ACTIONS(892),
    [sym_true] = ACTIONS(874),
    [sym_false] = ACTIONS(874),
    [sym_none] = ACTIONS(874),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(894),
  },
  [185] = {
    [sym_else_clause] = STATE(298),
    [sym_except_group_clause] = STATE(223),
    [sym_finally_clause] = STATE(410),
    [aux_sym_try_statement_repeat2] = STATE(223),
    [ts_builtin_sym_end] = ACTIONS(814),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_import] = ACTIONS(816),
    [anon_sym_from] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(814),
    [anon_sym_STAR] = ACTIONS(814),
    [anon_sym_print] = ACTIONS(816),
    [anon_sym_assert] = ACTIONS(816),
    [anon_sym_return] = ACTIONS(816),
    [anon_sym_del] = ACTIONS(816),
    [anon_sym_raise] = ACTIONS(816),
    [anon_sym_pass] = ACTIONS(816),
    [anon_sym_break] = ACTIONS(816),
    [anon_sym_continue] = ACTIONS(816),
    [anon_sym_if] = ACTIONS(816),
    [anon_sym_else] = ACTIONS(808),
    [anon_sym_match] = ACTIONS(816),
    [anon_sym_async] = ACTIONS(816),
    [anon_sym_for] = ACTIONS(816),
    [anon_sym_while] = ACTIONS(816),
    [anon_sym_try] = ACTIONS(816),
    [anon_sym_except_STAR] = ACTIONS(810),
    [anon_sym_finally] = ACTIONS(812),
    [anon_sym_with] = ACTIONS(816),
    [anon_sym_def] = ACTIONS(816),
    [anon_sym_global] = ACTIONS(816),
    [anon_sym_nonlocal] = ACTIONS(816),
    [anon_sym_exec] = ACTIONS(816),
    [anon_sym_type] = ACTIONS(816),
    [anon_sym_class] = ACTIONS(816),
    [anon_sym_LBRACK] = ACTIONS(814),
    [anon_sym_AT] = ACTIONS(814),
    [anon_sym_DASH] = ACTIONS(814),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_PLUS] = ACTIONS(814),
    [anon_sym_not] = ACTIONS(816),
    [anon_sym_TILDE] = ACTIONS(814),
    [anon_sym_lambda] = ACTIONS(816),
    [anon_sym_yield] = ACTIONS(816),
    [sym_ellipsis] = ACTIONS(814),
    [sym_integer] = ACTIONS(816),
    [sym_float] = ACTIONS(814),
    [anon_sym_await] = ACTIONS(816),
    [sym_true] = ACTIONS(816),
    [sym_false] = ACTIONS(816),
    [sym_none] = ACTIONS(816),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(816),
    [anon_sym_container] = ACTIONS(816),
    [anon_sym_envvars] = ACTIONS(816),
    [anon_sym_include] = ACTIONS(816),
    [anon_sym_pepfile] = ACTIONS(816),
    [anon_sym_pepschema] = ACTIONS(816),
    [anon_sym_scattergather] = ACTIONS(816),
    [anon_sym_version] = ACTIONS(816),
    [anon_sym_wildcard_constraints] = ACTIONS(816),
    [anon_sym_workdir] = ACTIONS(816),
    [anon_sym_onerror] = ACTIONS(816),
    [anon_sym_onstart] = ACTIONS(816),
    [anon_sym_onsuccess] = ACTIONS(816),
    [anon_sym_localrules] = ACTIONS(816),
    [anon_sym_ruleorder] = ACTIONS(816),
    [anon_sym_rule] = ACTIONS(816),
    [anon_sym_checkpoint] = ACTIONS(816),
    [anon_sym_use] = ACTIONS(816),
    [anon_sym_module] = ACTIONS(816),
    [sym_string_start] = ACTIONS(814),
  },
  [186] = {
    [sym_list_splat_pattern] = STATE(1459),
    [sym_primary_expression] = STATE(1244),
    [sym_binary_operator] = STATE(1449),
    [sym_unary_operator] = STATE(1449),
    [sym_attribute] = STATE(1449),
    [sym_subscript] = STATE(1449),
    [sym_call] = STATE(1449),
    [sym_list] = STATE(1449),
    [sym_set] = STATE(1449),
    [sym_tuple] = STATE(1449),
    [sym_dictionary] = STATE(1449),
    [sym_list_comprehension] = STATE(1449),
    [sym_dictionary_comprehension] = STATE(1449),
    [sym_set_comprehension] = STATE(1449),
    [sym_generator_expression] = STATE(1449),
    [sym_parenthesized_expression] = STATE(1449),
    [sym_concatenated_string] = STATE(1449),
    [sym_string] = STATE(1223),
    [sym_await] = STATE(1449),
    [sym_identifier] = ACTIONS(779),
    [anon_sym_DOT] = ACTIONS(363),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_COMMA] = ACTIONS(361),
    [anon_sym_as] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(783),
    [anon_sym_print] = ACTIONS(785),
    [anon_sym_GT_GT] = ACTIONS(361),
    [anon_sym_if] = ACTIONS(363),
    [anon_sym_COLON] = ACTIONS(361),
    [anon_sym_match] = ACTIONS(785),
    [anon_sym_async] = ACTIONS(785),
    [anon_sym_in] = ACTIONS(363),
    [anon_sym_STAR_STAR] = ACTIONS(361),
    [anon_sym_exec] = ACTIONS(785),
    [anon_sym_type] = ACTIONS(787),
    [anon_sym_EQ] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(789),
    [anon_sym_AT] = ACTIONS(361),
    [anon_sym_DASH] = ACTIONS(791),
    [anon_sym_PIPE] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(793),
    [anon_sym_RBRACE] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(791),
    [anon_sym_not] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(363),
    [anon_sym_or] = ACTIONS(363),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(361),
    [anon_sym_SLASH_SLASH] = ACTIONS(361),
    [anon_sym_AMP] = ACTIONS(361),
    [anon_sym_CARET] = ACTIONS(361),
    [anon_sym_LT_LT] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(791),
    [anon_sym_LT] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(361),
    [anon_sym_EQ_EQ] = ACTIONS(361),
    [anon_sym_BANG_EQ] = ACTIONS(361),
    [anon_sym_GT_EQ] = ACTIONS(361),
    [anon_sym_GT] = ACTIONS(363),
    [anon_sym_LT_GT] = ACTIONS(361),
    [anon_sym_is] = ACTIONS(363),
    [sym_ellipsis] = ACTIONS(795),
    [sym_type_conversion] = ACTIONS(361),
    [sym_integer] = ACTIONS(779),
    [sym_float] = ACTIONS(795),
    [anon_sym_await] = ACTIONS(797),
    [sym_true] = ACTIONS(779),
    [sym_false] = ACTIONS(779),
    [sym_none] = ACTIONS(779),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(799),
  },
  [187] = {
    [sym_list_splat_pattern] = STATE(1756),
    [sym_primary_expression] = STATE(1467),
    [sym_binary_operator] = STATE(1752),
    [sym_unary_operator] = STATE(1752),
    [sym_attribute] = STATE(1752),
    [sym_subscript] = STATE(1752),
    [sym_call] = STATE(1752),
    [sym_list] = STATE(1752),
    [sym_set] = STATE(1752),
    [sym_tuple] = STATE(1752),
    [sym_dictionary] = STATE(1752),
    [sym_list_comprehension] = STATE(1752),
    [sym_dictionary_comprehension] = STATE(1752),
    [sym_set_comprehension] = STATE(1752),
    [sym_generator_expression] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1752),
    [sym_concatenated_string] = STATE(1752),
    [sym_string] = STATE(1337),
    [sym_await] = STATE(1752),
    [sym_identifier] = ACTIONS(896),
    [anon_sym_DOT] = ACTIONS(363),
    [anon_sym_LPAREN] = ACTIONS(898),
    [anon_sym_COMMA] = ACTIONS(361),
    [anon_sym_as] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_print] = ACTIONS(902),
    [anon_sym_GT_GT] = ACTIONS(361),
    [anon_sym_COLON_EQ] = ACTIONS(376),
    [anon_sym_if] = ACTIONS(363),
    [anon_sym_COLON] = ACTIONS(363),
    [anon_sym_match] = ACTIONS(902),
    [anon_sym_async] = ACTIONS(902),
    [anon_sym_in] = ACTIONS(363),
    [anon_sym_STAR_STAR] = ACTIONS(361),
    [anon_sym_exec] = ACTIONS(902),
    [anon_sym_type] = ACTIONS(904),
    [anon_sym_LBRACK] = ACTIONS(906),
    [anon_sym_RBRACK] = ACTIONS(361),
    [anon_sym_AT] = ACTIONS(361),
    [anon_sym_DASH] = ACTIONS(908),
    [anon_sym_PIPE] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(910),
    [anon_sym_PLUS] = ACTIONS(908),
    [anon_sym_not] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(363),
    [anon_sym_or] = ACTIONS(363),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(361),
    [anon_sym_SLASH_SLASH] = ACTIONS(361),
    [anon_sym_AMP] = ACTIONS(361),
    [anon_sym_CARET] = ACTIONS(361),
    [anon_sym_LT_LT] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(908),
    [anon_sym_LT] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(361),
    [anon_sym_EQ_EQ] = ACTIONS(361),
    [anon_sym_BANG_EQ] = ACTIONS(361),
    [anon_sym_GT_EQ] = ACTIONS(361),
    [anon_sym_GT] = ACTIONS(363),
    [anon_sym_LT_GT] = ACTIONS(361),
    [anon_sym_is] = ACTIONS(363),
    [sym_ellipsis] = ACTIONS(912),
    [sym_integer] = ACTIONS(896),
    [sym_float] = ACTIONS(912),
    [anon_sym_await] = ACTIONS(914),
    [sym_true] = ACTIONS(896),
    [sym_false] = ACTIONS(896),
    [sym_none] = ACTIONS(896),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(916),
  },
  [188] = {
    [sym_list_splat_pattern] = STATE(1590),
    [sym_primary_expression] = STATE(1389),
    [sym_binary_operator] = STATE(1654),
    [sym_unary_operator] = STATE(1654),
    [sym_attribute] = STATE(1654),
    [sym_subscript] = STATE(1654),
    [sym_call] = STATE(1654),
    [sym_list] = STATE(1654),
    [sym_set] = STATE(1654),
    [sym_tuple] = STATE(1654),
    [sym_dictionary] = STATE(1654),
    [sym_list_comprehension] = STATE(1654),
    [sym_dictionary_comprehension] = STATE(1654),
    [sym_set_comprehension] = STATE(1654),
    [sym_generator_expression] = STATE(1654),
    [sym_parenthesized_expression] = STATE(1654),
    [sym_concatenated_string] = STATE(1654),
    [sym_string] = STATE(1279),
    [sym_await] = STATE(1654),
    [sym_identifier] = ACTIONS(918),
    [anon_sym_DOT] = ACTIONS(363),
    [anon_sym_LPAREN] = ACTIONS(920),
    [anon_sym_COMMA] = ACTIONS(361),
    [anon_sym_as] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(922),
    [anon_sym_print] = ACTIONS(924),
    [anon_sym_GT_GT] = ACTIONS(361),
    [anon_sym_COLON_EQ] = ACTIONS(376),
    [anon_sym_if] = ACTIONS(363),
    [anon_sym_match] = ACTIONS(924),
    [anon_sym_async] = ACTIONS(924),
    [anon_sym_for] = ACTIONS(363),
    [anon_sym_in] = ACTIONS(363),
    [anon_sym_STAR_STAR] = ACTIONS(361),
    [anon_sym_exec] = ACTIONS(924),
    [anon_sym_type] = ACTIONS(926),
    [anon_sym_LBRACK] = ACTIONS(928),
    [anon_sym_RBRACK] = ACTIONS(361),
    [anon_sym_AT] = ACTIONS(361),
    [anon_sym_DASH] = ACTIONS(930),
    [anon_sym_PIPE] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(932),
    [anon_sym_PLUS] = ACTIONS(930),
    [anon_sym_not] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(363),
    [anon_sym_or] = ACTIONS(363),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(361),
    [anon_sym_SLASH_SLASH] = ACTIONS(361),
    [anon_sym_AMP] = ACTIONS(361),
    [anon_sym_CARET] = ACTIONS(361),
    [anon_sym_LT_LT] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(930),
    [anon_sym_LT] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(361),
    [anon_sym_EQ_EQ] = ACTIONS(361),
    [anon_sym_BANG_EQ] = ACTIONS(361),
    [anon_sym_GT_EQ] = ACTIONS(361),
    [anon_sym_GT] = ACTIONS(363),
    [anon_sym_LT_GT] = ACTIONS(361),
    [anon_sym_is] = ACTIONS(363),
    [sym_ellipsis] = ACTIONS(934),
    [sym_integer] = ACTIONS(918),
    [sym_float] = ACTIONS(934),
    [anon_sym_await] = ACTIONS(936),
    [sym_true] = ACTIONS(918),
    [sym_false] = ACTIONS(918),
    [sym_none] = ACTIONS(918),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(938),
  },
  [189] = {
    [sym_list_splat_pattern] = STATE(1641),
    [sym_primary_expression] = STATE(1379),
    [sym_binary_operator] = STATE(1642),
    [sym_unary_operator] = STATE(1642),
    [sym_attribute] = STATE(1642),
    [sym_subscript] = STATE(1642),
    [sym_call] = STATE(1642),
    [sym_list] = STATE(1642),
    [sym_set] = STATE(1642),
    [sym_tuple] = STATE(1642),
    [sym_dictionary] = STATE(1642),
    [sym_list_comprehension] = STATE(1642),
    [sym_dictionary_comprehension] = STATE(1642),
    [sym_set_comprehension] = STATE(1642),
    [sym_generator_expression] = STATE(1642),
    [sym_parenthesized_expression] = STATE(1642),
    [sym_concatenated_string] = STATE(1642),
    [sym_string] = STATE(1245),
    [sym_await] = STATE(1642),
    [sym_identifier] = ACTIONS(874),
    [anon_sym_DOT] = ACTIONS(363),
    [anon_sym_LPAREN] = ACTIONS(876),
    [anon_sym_RPAREN] = ACTIONS(361),
    [anon_sym_COMMA] = ACTIONS(361),
    [anon_sym_as] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(878),
    [anon_sym_print] = ACTIONS(880),
    [anon_sym_GT_GT] = ACTIONS(361),
    [anon_sym_COLON_EQ] = ACTIONS(376),
    [anon_sym_if] = ACTIONS(363),
    [anon_sym_match] = ACTIONS(880),
    [anon_sym_async] = ACTIONS(880),
    [anon_sym_in] = ACTIONS(363),
    [anon_sym_STAR_STAR] = ACTIONS(361),
    [anon_sym_exec] = ACTIONS(880),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_EQ] = ACTIONS(838),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_AT] = ACTIONS(361),
    [anon_sym_DASH] = ACTIONS(886),
    [anon_sym_PIPE] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(888),
    [anon_sym_PLUS] = ACTIONS(886),
    [anon_sym_not] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(363),
    [anon_sym_or] = ACTIONS(363),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(361),
    [anon_sym_SLASH_SLASH] = ACTIONS(361),
    [anon_sym_AMP] = ACTIONS(361),
    [anon_sym_CARET] = ACTIONS(361),
    [anon_sym_LT_LT] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(886),
    [anon_sym_LT] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(361),
    [anon_sym_EQ_EQ] = ACTIONS(361),
    [anon_sym_BANG_EQ] = ACTIONS(361),
    [anon_sym_GT_EQ] = ACTIONS(361),
    [anon_sym_GT] = ACTIONS(363),
    [anon_sym_LT_GT] = ACTIONS(361),
    [anon_sym_is] = ACTIONS(363),
    [sym_ellipsis] = ACTIONS(890),
    [sym_integer] = ACTIONS(874),
    [sym_float] = ACTIONS(890),
    [anon_sym_await] = ACTIONS(892),
    [sym_true] = ACTIONS(874),
    [sym_false] = ACTIONS(874),
    [sym_none] = ACTIONS(874),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(894),
  },
  [190] = {
    [sym_list_splat_pattern] = STATE(1641),
    [sym_primary_expression] = STATE(1379),
    [sym_binary_operator] = STATE(1642),
    [sym_unary_operator] = STATE(1642),
    [sym_attribute] = STATE(1642),
    [sym_subscript] = STATE(1642),
    [sym_call] = STATE(1642),
    [sym_list] = STATE(1642),
    [sym_set] = STATE(1642),
    [sym_tuple] = STATE(1642),
    [sym_dictionary] = STATE(1642),
    [sym_list_comprehension] = STATE(1642),
    [sym_dictionary_comprehension] = STATE(1642),
    [sym_set_comprehension] = STATE(1642),
    [sym_generator_expression] = STATE(1642),
    [sym_parenthesized_expression] = STATE(1642),
    [sym_concatenated_string] = STATE(1642),
    [sym_string] = STATE(1245),
    [sym_await] = STATE(1642),
    [sym_identifier] = ACTIONS(874),
    [anon_sym_DOT] = ACTIONS(768),
    [anon_sym_LPAREN] = ACTIONS(876),
    [anon_sym_RPAREN] = ACTIONS(801),
    [anon_sym_COMMA] = ACTIONS(801),
    [anon_sym_as] = ACTIONS(768),
    [anon_sym_STAR] = ACTIONS(878),
    [anon_sym_print] = ACTIONS(880),
    [anon_sym_GT_GT] = ACTIONS(801),
    [anon_sym_COLON_EQ] = ACTIONS(376),
    [anon_sym_if] = ACTIONS(768),
    [anon_sym_match] = ACTIONS(880),
    [anon_sym_async] = ACTIONS(880),
    [anon_sym_for] = ACTIONS(771),
    [anon_sym_in] = ACTIONS(768),
    [anon_sym_STAR_STAR] = ACTIONS(801),
    [anon_sym_exec] = ACTIONS(880),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_AT] = ACTIONS(801),
    [anon_sym_DASH] = ACTIONS(886),
    [anon_sym_PIPE] = ACTIONS(801),
    [anon_sym_LBRACE] = ACTIONS(888),
    [anon_sym_PLUS] = ACTIONS(886),
    [anon_sym_not] = ACTIONS(768),
    [anon_sym_and] = ACTIONS(768),
    [anon_sym_or] = ACTIONS(768),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_PERCENT] = ACTIONS(801),
    [anon_sym_SLASH_SLASH] = ACTIONS(801),
    [anon_sym_AMP] = ACTIONS(801),
    [anon_sym_CARET] = ACTIONS(801),
    [anon_sym_LT_LT] = ACTIONS(801),
    [anon_sym_TILDE] = ACTIONS(886),
    [anon_sym_LT] = ACTIONS(768),
    [anon_sym_LT_EQ] = ACTIONS(801),
    [anon_sym_EQ_EQ] = ACTIONS(801),
    [anon_sym_BANG_EQ] = ACTIONS(801),
    [anon_sym_GT_EQ] = ACTIONS(801),
    [anon_sym_GT] = ACTIONS(768),
    [anon_sym_LT_GT] = ACTIONS(801),
    [anon_sym_is] = ACTIONS(768),
    [sym_ellipsis] = ACTIONS(890),
    [sym_integer] = ACTIONS(874),
    [sym_float] = ACTIONS(890),
    [anon_sym_await] = ACTIONS(892),
    [sym_true] = ACTIONS(874),
    [sym_false] = ACTIONS(874),
    [sym_none] = ACTIONS(874),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(894),
  },
  [191] = {
    [sym_list_splat_pattern] = STATE(1314),
    [sym_primary_expression] = STATE(1218),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_attribute] = STATE(1312),
    [sym_subscript] = STATE(1312),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_DOT] = ACTIONS(363),
    [anon_sym_LPAREN] = ACTIONS(752),
    [anon_sym_COMMA] = ACTIONS(361),
    [anon_sym_as] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(754),
    [anon_sym_print] = ACTIONS(756),
    [anon_sym_GT_GT] = ACTIONS(361),
    [anon_sym_COLON_EQ] = ACTIONS(376),
    [anon_sym_if] = ACTIONS(363),
    [anon_sym_match] = ACTIONS(756),
    [anon_sym_async] = ACTIONS(756),
    [anon_sym_in] = ACTIONS(363),
    [anon_sym_STAR_STAR] = ACTIONS(361),
    [anon_sym_exec] = ACTIONS(756),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_EQ] = ACTIONS(940),
    [anon_sym_LBRACK] = ACTIONS(760),
    [anon_sym_AT] = ACTIONS(361),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_PIPE] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(363),
    [anon_sym_or] = ACTIONS(363),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(361),
    [anon_sym_SLASH_SLASH] = ACTIONS(361),
    [anon_sym_AMP] = ACTIONS(361),
    [anon_sym_CARET] = ACTIONS(361),
    [anon_sym_LT_LT] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(361),
    [anon_sym_EQ_EQ] = ACTIONS(361),
    [anon_sym_BANG_EQ] = ACTIONS(361),
    [anon_sym_GT_EQ] = ACTIONS(361),
    [anon_sym_GT] = ACTIONS(363),
    [anon_sym_LT_GT] = ACTIONS(361),
    [anon_sym_is] = ACTIONS(363),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(764),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(361),
    [sym_string_start] = ACTIONS(97),
  },
  [192] = {
    [sym_list_splat_pattern] = STATE(1541),
    [sym_primary_expression] = STATE(1298),
    [sym_binary_operator] = STATE(1536),
    [sym_unary_operator] = STATE(1536),
    [sym_attribute] = STATE(1536),
    [sym_subscript] = STATE(1536),
    [sym_call] = STATE(1536),
    [sym_list] = STATE(1536),
    [sym_set] = STATE(1536),
    [sym_tuple] = STATE(1536),
    [sym_dictionary] = STATE(1536),
    [sym_list_comprehension] = STATE(1536),
    [sym_dictionary_comprehension] = STATE(1536),
    [sym_set_comprehension] = STATE(1536),
    [sym_generator_expression] = STATE(1536),
    [sym_parenthesized_expression] = STATE(1536),
    [sym_concatenated_string] = STATE(1536),
    [sym_string] = STATE(1234),
    [sym_await] = STATE(1536),
    [sym_identifier] = ACTIONS(404),
    [anon_sym_DOT] = ACTIONS(768),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_COMMA] = ACTIONS(766),
    [anon_sym_as] = ACTIONS(771),
    [anon_sym_STAR] = ACTIONS(494),
    [anon_sym_print] = ACTIONS(773),
    [anon_sym_GT_GT] = ACTIONS(801),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_COLON] = ACTIONS(766),
    [anon_sym_match] = ACTIONS(773),
    [anon_sym_async] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(771),
    [anon_sym_in] = ACTIONS(771),
    [anon_sym_STAR_STAR] = ACTIONS(801),
    [anon_sym_exec] = ACTIONS(773),
    [anon_sym_type] = ACTIONS(775),
    [anon_sym_LBRACK] = ACTIONS(496),
    [anon_sym_RBRACK] = ACTIONS(766),
    [anon_sym_AT] = ACTIONS(801),
    [anon_sym_DASH] = ACTIONS(396),
    [anon_sym_PIPE] = ACTIONS(801),
    [anon_sym_LBRACE] = ACTIONS(391),
    [anon_sym_PLUS] = ACTIONS(396),
    [anon_sym_not] = ACTIONS(771),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_PERCENT] = ACTIONS(801),
    [anon_sym_SLASH_SLASH] = ACTIONS(801),
    [anon_sym_AMP] = ACTIONS(801),
    [anon_sym_CARET] = ACTIONS(801),
    [anon_sym_LT_LT] = ACTIONS(801),
    [anon_sym_TILDE] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_LT_EQ] = ACTIONS(766),
    [anon_sym_EQ_EQ] = ACTIONS(766),
    [anon_sym_BANG_EQ] = ACTIONS(766),
    [anon_sym_GT_EQ] = ACTIONS(766),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_LT_GT] = ACTIONS(766),
    [anon_sym_is] = ACTIONS(771),
    [sym_ellipsis] = ACTIONS(402),
    [sym_integer] = ACTIONS(404),
    [sym_float] = ACTIONS(402),
    [anon_sym_await] = ACTIONS(777),
    [sym_true] = ACTIONS(404),
    [sym_false] = ACTIONS(404),
    [sym_none] = ACTIONS(404),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(408),
  },
  [193] = {
    [sym_list_splat_pattern] = STATE(1590),
    [sym_primary_expression] = STATE(1389),
    [sym_binary_operator] = STATE(1654),
    [sym_unary_operator] = STATE(1654),
    [sym_attribute] = STATE(1654),
    [sym_subscript] = STATE(1654),
    [sym_call] = STATE(1654),
    [sym_list] = STATE(1654),
    [sym_set] = STATE(1654),
    [sym_tuple] = STATE(1654),
    [sym_dictionary] = STATE(1654),
    [sym_list_comprehension] = STATE(1654),
    [sym_dictionary_comprehension] = STATE(1654),
    [sym_set_comprehension] = STATE(1654),
    [sym_generator_expression] = STATE(1654),
    [sym_parenthesized_expression] = STATE(1654),
    [sym_concatenated_string] = STATE(1654),
    [sym_string] = STATE(1279),
    [sym_await] = STATE(1654),
    [sym_identifier] = ACTIONS(918),
    [anon_sym_DOT] = ACTIONS(363),
    [anon_sym_LPAREN] = ACTIONS(920),
    [anon_sym_COMMA] = ACTIONS(368),
    [anon_sym_as] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(922),
    [anon_sym_print] = ACTIONS(924),
    [anon_sym_GT_GT] = ACTIONS(361),
    [anon_sym_COLON_EQ] = ACTIONS(376),
    [anon_sym_if] = ACTIONS(363),
    [anon_sym_match] = ACTIONS(924),
    [anon_sym_async] = ACTIONS(924),
    [anon_sym_for] = ACTIONS(363),
    [anon_sym_in] = ACTIONS(363),
    [anon_sym_STAR_STAR] = ACTIONS(361),
    [anon_sym_exec] = ACTIONS(924),
    [anon_sym_type] = ACTIONS(926),
    [anon_sym_LBRACK] = ACTIONS(928),
    [anon_sym_RBRACK] = ACTIONS(368),
    [anon_sym_AT] = ACTIONS(361),
    [anon_sym_DASH] = ACTIONS(930),
    [anon_sym_PIPE] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(932),
    [anon_sym_PLUS] = ACTIONS(930),
    [anon_sym_not] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(363),
    [anon_sym_or] = ACTIONS(363),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(361),
    [anon_sym_SLASH_SLASH] = ACTIONS(361),
    [anon_sym_AMP] = ACTIONS(361),
    [anon_sym_CARET] = ACTIONS(361),
    [anon_sym_LT_LT] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(930),
    [anon_sym_LT] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(361),
    [anon_sym_EQ_EQ] = ACTIONS(361),
    [anon_sym_BANG_EQ] = ACTIONS(361),
    [anon_sym_GT_EQ] = ACTIONS(361),
    [anon_sym_GT] = ACTIONS(363),
    [anon_sym_LT_GT] = ACTIONS(361),
    [anon_sym_is] = ACTIONS(363),
    [sym_ellipsis] = ACTIONS(934),
    [sym_integer] = ACTIONS(918),
    [sym_float] = ACTIONS(934),
    [anon_sym_await] = ACTIONS(936),
    [sym_true] = ACTIONS(918),
    [sym_false] = ACTIONS(918),
    [sym_none] = ACTIONS(918),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(938),
  },
  [194] = {
    [sym_list_splat_pattern] = STATE(1541),
    [sym_primary_expression] = STATE(1298),
    [sym_binary_operator] = STATE(1536),
    [sym_unary_operator] = STATE(1536),
    [sym_attribute] = STATE(1536),
    [sym_subscript] = STATE(1536),
    [sym_call] = STATE(1536),
    [sym_list] = STATE(1536),
    [sym_set] = STATE(1536),
    [sym_tuple] = STATE(1536),
    [sym_dictionary] = STATE(1536),
    [sym_list_comprehension] = STATE(1536),
    [sym_dictionary_comprehension] = STATE(1536),
    [sym_set_comprehension] = STATE(1536),
    [sym_generator_expression] = STATE(1536),
    [sym_parenthesized_expression] = STATE(1536),
    [sym_concatenated_string] = STATE(1536),
    [sym_string] = STATE(1234),
    [sym_await] = STATE(1536),
    [sym_identifier] = ACTIONS(404),
    [anon_sym_SEMI] = ACTIONS(400),
    [anon_sym_DOT] = ACTIONS(363),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_COMMA] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(494),
    [anon_sym_print] = ACTIONS(773),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_COLON] = ACTIONS(400),
    [anon_sym_match] = ACTIONS(773),
    [anon_sym_async] = ACTIONS(773),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_exec] = ACTIONS(773),
    [anon_sym_type] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(400),
    [anon_sym_LBRACK] = ACTIONS(496),
    [anon_sym_AT] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_PIPE] = ACTIONS(363),
    [anon_sym_LBRACE] = ACTIONS(391),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_SLASH_SLASH] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(396),
    [anon_sym_PLUS_EQ] = ACTIONS(400),
    [anon_sym_DASH_EQ] = ACTIONS(400),
    [anon_sym_STAR_EQ] = ACTIONS(400),
    [anon_sym_SLASH_EQ] = ACTIONS(400),
    [anon_sym_AT_EQ] = ACTIONS(400),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(400),
    [anon_sym_PERCENT_EQ] = ACTIONS(400),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(400),
    [anon_sym_GT_GT_EQ] = ACTIONS(400),
    [anon_sym_LT_LT_EQ] = ACTIONS(400),
    [anon_sym_AMP_EQ] = ACTIONS(400),
    [anon_sym_CARET_EQ] = ACTIONS(400),
    [anon_sym_PIPE_EQ] = ACTIONS(400),
    [sym_ellipsis] = ACTIONS(402),
    [sym_integer] = ACTIONS(404),
    [sym_float] = ACTIONS(402),
    [anon_sym_await] = ACTIONS(777),
    [sym_true] = ACTIONS(404),
    [sym_false] = ACTIONS(404),
    [sym_none] = ACTIONS(404),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(400),
    [sym_string_start] = ACTIONS(408),
  },
  [195] = {
    [sym_list_splat_pattern] = STATE(1756),
    [sym_primary_expression] = STATE(1467),
    [sym_binary_operator] = STATE(1752),
    [sym_unary_operator] = STATE(1752),
    [sym_attribute] = STATE(1752),
    [sym_subscript] = STATE(1752),
    [sym_call] = STATE(1752),
    [sym_list] = STATE(1752),
    [sym_set] = STATE(1752),
    [sym_tuple] = STATE(1752),
    [sym_dictionary] = STATE(1752),
    [sym_list_comprehension] = STATE(1752),
    [sym_dictionary_comprehension] = STATE(1752),
    [sym_set_comprehension] = STATE(1752),
    [sym_generator_expression] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1752),
    [sym_concatenated_string] = STATE(1752),
    [sym_string] = STATE(1337),
    [sym_await] = STATE(1752),
    [sym_identifier] = ACTIONS(896),
    [anon_sym_DOT] = ACTIONS(768),
    [anon_sym_LPAREN] = ACTIONS(898),
    [anon_sym_COMMA] = ACTIONS(801),
    [anon_sym_as] = ACTIONS(768),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_print] = ACTIONS(902),
    [anon_sym_GT_GT] = ACTIONS(801),
    [anon_sym_COLON_EQ] = ACTIONS(376),
    [anon_sym_if] = ACTIONS(768),
    [anon_sym_match] = ACTIONS(902),
    [anon_sym_async] = ACTIONS(902),
    [anon_sym_for] = ACTIONS(771),
    [anon_sym_in] = ACTIONS(768),
    [anon_sym_STAR_STAR] = ACTIONS(801),
    [anon_sym_exec] = ACTIONS(902),
    [anon_sym_type] = ACTIONS(904),
    [anon_sym_LBRACK] = ACTIONS(906),
    [anon_sym_RBRACK] = ACTIONS(801),
    [anon_sym_AT] = ACTIONS(801),
    [anon_sym_DASH] = ACTIONS(908),
    [anon_sym_PIPE] = ACTIONS(801),
    [anon_sym_LBRACE] = ACTIONS(910),
    [anon_sym_PLUS] = ACTIONS(908),
    [anon_sym_not] = ACTIONS(768),
    [anon_sym_and] = ACTIONS(768),
    [anon_sym_or] = ACTIONS(768),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_PERCENT] = ACTIONS(801),
    [anon_sym_SLASH_SLASH] = ACTIONS(801),
    [anon_sym_AMP] = ACTIONS(801),
    [anon_sym_CARET] = ACTIONS(801),
    [anon_sym_LT_LT] = ACTIONS(801),
    [anon_sym_TILDE] = ACTIONS(908),
    [anon_sym_LT] = ACTIONS(768),
    [anon_sym_LT_EQ] = ACTIONS(801),
    [anon_sym_EQ_EQ] = ACTIONS(801),
    [anon_sym_BANG_EQ] = ACTIONS(801),
    [anon_sym_GT_EQ] = ACTIONS(801),
    [anon_sym_GT] = ACTIONS(768),
    [anon_sym_LT_GT] = ACTIONS(801),
    [anon_sym_is] = ACTIONS(768),
    [sym_ellipsis] = ACTIONS(912),
    [sym_integer] = ACTIONS(896),
    [sym_float] = ACTIONS(912),
    [anon_sym_await] = ACTIONS(914),
    [sym_true] = ACTIONS(896),
    [sym_false] = ACTIONS(896),
    [sym_none] = ACTIONS(896),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(916),
  },
  [196] = {
    [sym_list_splat_pattern] = STATE(1530),
    [sym_primary_expression] = STATE(1296),
    [sym_binary_operator] = STATE(1660),
    [sym_unary_operator] = STATE(1660),
    [sym_attribute] = STATE(1660),
    [sym_subscript] = STATE(1660),
    [sym_call] = STATE(1660),
    [sym_list] = STATE(1660),
    [sym_set] = STATE(1660),
    [sym_tuple] = STATE(1660),
    [sym_dictionary] = STATE(1660),
    [sym_list_comprehension] = STATE(1660),
    [sym_dictionary_comprehension] = STATE(1660),
    [sym_set_comprehension] = STATE(1660),
    [sym_generator_expression] = STATE(1660),
    [sym_parenthesized_expression] = STATE(1660),
    [sym_concatenated_string] = STATE(1660),
    [sym_string] = STATE(1271),
    [sym_await] = STATE(1660),
    [sym_identifier] = ACTIONS(828),
    [anon_sym_DOT] = ACTIONS(363),
    [anon_sym_LPAREN] = ACTIONS(830),
    [anon_sym_RPAREN] = ACTIONS(361),
    [anon_sym_COMMA] = ACTIONS(361),
    [anon_sym_as] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(832),
    [anon_sym_print] = ACTIONS(834),
    [anon_sym_GT_GT] = ACTIONS(361),
    [anon_sym_COLON_EQ] = ACTIONS(376),
    [anon_sym_if] = ACTIONS(363),
    [anon_sym_match] = ACTIONS(834),
    [anon_sym_async] = ACTIONS(834),
    [anon_sym_for] = ACTIONS(363),
    [anon_sym_in] = ACTIONS(363),
    [anon_sym_STAR_STAR] = ACTIONS(361),
    [anon_sym_exec] = ACTIONS(834),
    [anon_sym_type] = ACTIONS(836),
    [anon_sym_LBRACK] = ACTIONS(840),
    [anon_sym_AT] = ACTIONS(361),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_PIPE] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(844),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_not] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(363),
    [anon_sym_or] = ACTIONS(363),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(361),
    [anon_sym_SLASH_SLASH] = ACTIONS(361),
    [anon_sym_AMP] = ACTIONS(361),
    [anon_sym_CARET] = ACTIONS(361),
    [anon_sym_LT_LT] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(842),
    [anon_sym_LT] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(361),
    [anon_sym_EQ_EQ] = ACTIONS(361),
    [anon_sym_BANG_EQ] = ACTIONS(361),
    [anon_sym_GT_EQ] = ACTIONS(361),
    [anon_sym_GT] = ACTIONS(363),
    [anon_sym_LT_GT] = ACTIONS(361),
    [anon_sym_is] = ACTIONS(363),
    [sym_ellipsis] = ACTIONS(846),
    [sym_integer] = ACTIONS(828),
    [sym_float] = ACTIONS(846),
    [anon_sym_await] = ACTIONS(848),
    [sym_true] = ACTIONS(828),
    [sym_false] = ACTIONS(828),
    [sym_none] = ACTIONS(828),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(850),
  },
  [197] = {
    [sym_list_splat_pattern] = STATE(1541),
    [sym_primary_expression] = STATE(1298),
    [sym_binary_operator] = STATE(1536),
    [sym_unary_operator] = STATE(1536),
    [sym_attribute] = STATE(1536),
    [sym_subscript] = STATE(1536),
    [sym_call] = STATE(1536),
    [sym_list] = STATE(1536),
    [sym_set] = STATE(1536),
    [sym_tuple] = STATE(1536),
    [sym_dictionary] = STATE(1536),
    [sym_list_comprehension] = STATE(1536),
    [sym_dictionary_comprehension] = STATE(1536),
    [sym_set_comprehension] = STATE(1536),
    [sym_generator_expression] = STATE(1536),
    [sym_parenthesized_expression] = STATE(1536),
    [sym_concatenated_string] = STATE(1536),
    [sym_string] = STATE(1234),
    [sym_await] = STATE(1536),
    [sym_identifier] = ACTIONS(404),
    [anon_sym_DOT] = ACTIONS(363),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_COMMA] = ACTIONS(361),
    [anon_sym_as] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(494),
    [anon_sym_print] = ACTIONS(773),
    [anon_sym_GT_GT] = ACTIONS(361),
    [anon_sym_if] = ACTIONS(363),
    [anon_sym_COLON] = ACTIONS(361),
    [anon_sym_else] = ACTIONS(363),
    [anon_sym_match] = ACTIONS(773),
    [anon_sym_async] = ACTIONS(773),
    [anon_sym_in] = ACTIONS(363),
    [anon_sym_STAR_STAR] = ACTIONS(361),
    [anon_sym_exec] = ACTIONS(773),
    [anon_sym_type] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(496),
    [anon_sym_AT] = ACTIONS(361),
    [anon_sym_DASH] = ACTIONS(396),
    [anon_sym_PIPE] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(391),
    [anon_sym_PLUS] = ACTIONS(396),
    [anon_sym_not] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(363),
    [anon_sym_or] = ACTIONS(363),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(361),
    [anon_sym_SLASH_SLASH] = ACTIONS(361),
    [anon_sym_AMP] = ACTIONS(361),
    [anon_sym_CARET] = ACTIONS(361),
    [anon_sym_LT_LT] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(361),
    [anon_sym_EQ_EQ] = ACTIONS(361),
    [anon_sym_BANG_EQ] = ACTIONS(361),
    [anon_sym_GT_EQ] = ACTIONS(361),
    [anon_sym_GT] = ACTIONS(363),
    [anon_sym_LT_GT] = ACTIONS(361),
    [anon_sym_is] = ACTIONS(363),
    [sym_ellipsis] = ACTIONS(402),
    [sym_integer] = ACTIONS(404),
    [sym_float] = ACTIONS(402),
    [anon_sym_await] = ACTIONS(777),
    [sym_true] = ACTIONS(404),
    [sym_false] = ACTIONS(404),
    [sym_none] = ACTIONS(404),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(408),
  },
  [198] = {
    [sym_list_splat_pattern] = STATE(1641),
    [sym_primary_expression] = STATE(1379),
    [sym_binary_operator] = STATE(1642),
    [sym_unary_operator] = STATE(1642),
    [sym_attribute] = STATE(1642),
    [sym_subscript] = STATE(1642),
    [sym_call] = STATE(1642),
    [sym_list] = STATE(1642),
    [sym_set] = STATE(1642),
    [sym_tuple] = STATE(1642),
    [sym_dictionary] = STATE(1642),
    [sym_list_comprehension] = STATE(1642),
    [sym_dictionary_comprehension] = STATE(1642),
    [sym_set_comprehension] = STATE(1642),
    [sym_generator_expression] = STATE(1642),
    [sym_parenthesized_expression] = STATE(1642),
    [sym_concatenated_string] = STATE(1642),
    [sym_string] = STATE(1245),
    [sym_await] = STATE(1642),
    [sym_identifier] = ACTIONS(874),
    [anon_sym_DOT] = ACTIONS(363),
    [anon_sym_LPAREN] = ACTIONS(876),
    [anon_sym_RPAREN] = ACTIONS(361),
    [anon_sym_COMMA] = ACTIONS(361),
    [anon_sym_as] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(878),
    [anon_sym_print] = ACTIONS(880),
    [anon_sym_GT_GT] = ACTIONS(361),
    [anon_sym_if] = ACTIONS(363),
    [anon_sym_COLON] = ACTIONS(361),
    [anon_sym_match] = ACTIONS(880),
    [anon_sym_async] = ACTIONS(880),
    [anon_sym_in] = ACTIONS(363),
    [anon_sym_STAR_STAR] = ACTIONS(361),
    [anon_sym_exec] = ACTIONS(880),
    [anon_sym_type] = ACTIONS(882),
    [anon_sym_EQ] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(884),
    [anon_sym_AT] = ACTIONS(361),
    [anon_sym_DASH] = ACTIONS(886),
    [anon_sym_PIPE] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(888),
    [anon_sym_PLUS] = ACTIONS(886),
    [anon_sym_not] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(363),
    [anon_sym_or] = ACTIONS(363),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(361),
    [anon_sym_SLASH_SLASH] = ACTIONS(361),
    [anon_sym_AMP] = ACTIONS(361),
    [anon_sym_CARET] = ACTIONS(361),
    [anon_sym_LT_LT] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(886),
    [anon_sym_LT] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(361),
    [anon_sym_EQ_EQ] = ACTIONS(361),
    [anon_sym_BANG_EQ] = ACTIONS(361),
    [anon_sym_GT_EQ] = ACTIONS(361),
    [anon_sym_GT] = ACTIONS(363),
    [anon_sym_LT_GT] = ACTIONS(361),
    [anon_sym_is] = ACTIONS(363),
    [sym_ellipsis] = ACTIONS(890),
    [sym_integer] = ACTIONS(874),
    [sym_float] = ACTIONS(890),
    [anon_sym_await] = ACTIONS(892),
    [sym_true] = ACTIONS(874),
    [sym_false] = ACTIONS(874),
    [sym_none] = ACTIONS(874),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(894),
  },
  [199] = {
    [sym_list_splat_pattern] = STATE(1541),
    [sym_primary_expression] = STATE(1298),
    [sym_binary_operator] = STATE(1536),
    [sym_unary_operator] = STATE(1536),
    [sym_attribute] = STATE(1536),
    [sym_subscript] = STATE(1536),
    [sym_call] = STATE(1536),
    [sym_list] = STATE(1536),
    [sym_set] = STATE(1536),
    [sym_tuple] = STATE(1536),
    [sym_dictionary] = STATE(1536),
    [sym_list_comprehension] = STATE(1536),
    [sym_dictionary_comprehension] = STATE(1536),
    [sym_set_comprehension] = STATE(1536),
    [sym_generator_expression] = STATE(1536),
    [sym_parenthesized_expression] = STATE(1536),
    [sym_concatenated_string] = STATE(1536),
    [sym_string] = STATE(1234),
    [sym_await] = STATE(1536),
    [sym_identifier] = ACTIONS(404),
    [anon_sym_DOT] = ACTIONS(768),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_COMMA] = ACTIONS(766),
    [anon_sym_as] = ACTIONS(771),
    [anon_sym_STAR] = ACTIONS(494),
    [anon_sym_print] = ACTIONS(773),
    [anon_sym_GT_GT] = ACTIONS(801),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_COLON] = ACTIONS(766),
    [anon_sym_else] = ACTIONS(771),
    [anon_sym_match] = ACTIONS(773),
    [anon_sym_async] = ACTIONS(773),
    [anon_sym_in] = ACTIONS(771),
    [anon_sym_STAR_STAR] = ACTIONS(801),
    [anon_sym_exec] = ACTIONS(773),
    [anon_sym_type] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(771),
    [anon_sym_LBRACK] = ACTIONS(496),
    [anon_sym_AT] = ACTIONS(801),
    [anon_sym_DASH] = ACTIONS(396),
    [anon_sym_PIPE] = ACTIONS(801),
    [anon_sym_LBRACE] = ACTIONS(391),
    [anon_sym_PLUS] = ACTIONS(396),
    [anon_sym_not] = ACTIONS(771),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_PERCENT] = ACTIONS(801),
    [anon_sym_SLASH_SLASH] = ACTIONS(801),
    [anon_sym_AMP] = ACTIONS(801),
    [anon_sym_CARET] = ACTIONS(801),
    [anon_sym_LT_LT] = ACTIONS(801),
    [anon_sym_TILDE] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_LT_EQ] = ACTIONS(766),
    [anon_sym_EQ_EQ] = ACTIONS(766),
    [anon_sym_BANG_EQ] = ACTIONS(766),
    [anon_sym_GT_EQ] = ACTIONS(766),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_LT_GT] = ACTIONS(766),
    [anon_sym_is] = ACTIONS(771),
    [sym_ellipsis] = ACTIONS(402),
    [sym_integer] = ACTIONS(404),
    [sym_float] = ACTIONS(402),
    [anon_sym_await] = ACTIONS(777),
    [sym_true] = ACTIONS(404),
    [sym_false] = ACTIONS(404),
    [sym_none] = ACTIONS(404),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(408),
  },
  [200] = {
    [sym_list_splat_pattern] = STATE(1761),
    [sym_primary_expression] = STATE(1628),
    [sym_binary_operator] = STATE(1780),
    [sym_unary_operator] = STATE(1780),
    [sym_attribute] = STATE(1780),
    [sym_subscript] = STATE(1780),
    [sym_call] = STATE(1780),
    [sym_list] = STATE(1780),
    [sym_set] = STATE(1780),
    [sym_tuple] = STATE(1780),
    [sym_dictionary] = STATE(1780),
    [sym_list_comprehension] = STATE(1780),
    [sym_dictionary_comprehension] = STATE(1780),
    [sym_set_comprehension] = STATE(1780),
    [sym_generator_expression] = STATE(1780),
    [sym_parenthesized_expression] = STATE(1780),
    [sym_concatenated_string] = STATE(1780),
    [sym_string] = STATE(1488),
    [sym_await] = STATE(1780),
    [sym_identifier] = ACTIONS(942),
    [anon_sym_DOT] = ACTIONS(363),
    [anon_sym_LPAREN] = ACTIONS(944),
    [anon_sym_COMMA] = ACTIONS(361),
    [anon_sym_as] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(946),
    [anon_sym_print] = ACTIONS(948),
    [anon_sym_GT_GT] = ACTIONS(361),
    [anon_sym_COLON_EQ] = ACTIONS(376),
    [anon_sym_if] = ACTIONS(363),
    [anon_sym_match] = ACTIONS(948),
    [anon_sym_async] = ACTIONS(948),
    [anon_sym_in] = ACTIONS(363),
    [anon_sym_STAR_STAR] = ACTIONS(361),
    [anon_sym_exec] = ACTIONS(948),
    [anon_sym_type] = ACTIONS(950),
    [anon_sym_EQ] = ACTIONS(952),
    [anon_sym_LBRACK] = ACTIONS(954),
    [anon_sym_AT] = ACTIONS(361),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_PIPE] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(958),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_not] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(363),
    [anon_sym_or] = ACTIONS(363),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(361),
    [anon_sym_SLASH_SLASH] = ACTIONS(361),
    [anon_sym_AMP] = ACTIONS(361),
    [anon_sym_CARET] = ACTIONS(361),
    [anon_sym_LT_LT] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(956),
    [anon_sym_LT] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(361),
    [anon_sym_EQ_EQ] = ACTIONS(361),
    [anon_sym_BANG_EQ] = ACTIONS(361),
    [anon_sym_GT_EQ] = ACTIONS(361),
    [anon_sym_GT] = ACTIONS(363),
    [anon_sym_LT_GT] = ACTIONS(361),
    [anon_sym_is] = ACTIONS(363),
    [sym_ellipsis] = ACTIONS(960),
    [sym_integer] = ACTIONS(942),
    [sym_float] = ACTIONS(960),
    [anon_sym_await] = ACTIONS(962),
    [sym_true] = ACTIONS(942),
    [sym_false] = ACTIONS(942),
    [sym_none] = ACTIONS(942),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(361),
    [sym_string_start] = ACTIONS(964),
  },
  [201] = {
    [sym_list_splat_pattern] = STATE(1504),
    [sym_primary_expression] = STATE(1246),
    [sym_binary_operator] = STATE(1477),
    [sym_unary_operator] = STATE(1477),
    [sym_attribute] = STATE(1477),
    [sym_subscript] = STATE(1477),
    [sym_call] = STATE(1477),
    [sym_list] = STATE(1477),
    [sym_set] = STATE(1477),
    [sym_tuple] = STATE(1477),
    [sym_dictionary] = STATE(1477),
    [sym_list_comprehension] = STATE(1477),
    [sym_dictionary_comprehension] = STATE(1477),
    [sym_set_comprehension] = STATE(1477),
    [sym_generator_expression] = STATE(1477),
    [sym_parenthesized_expression] = STATE(1477),
    [sym_concatenated_string] = STATE(1477),
    [sym_string] = STATE(1227),
    [sym_await] = STATE(1477),
    [sym_identifier] = ACTIONS(852),
    [anon_sym_DOT] = ACTIONS(363),
    [anon_sym_LPAREN] = ACTIONS(854),
    [anon_sym_COMMA] = ACTIONS(361),
    [anon_sym_as] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(856),
    [anon_sym_print] = ACTIONS(858),
    [anon_sym_GT_GT] = ACTIONS(361),
    [anon_sym_if] = ACTIONS(363),
    [anon_sym_COLON] = ACTIONS(361),
    [anon_sym_match] = ACTIONS(858),
    [anon_sym_async] = ACTIONS(858),
    [anon_sym_for] = ACTIONS(363),
    [anon_sym_in] = ACTIONS(363),
    [anon_sym_STAR_STAR] = ACTIONS(361),
    [anon_sym_exec] = ACTIONS(858),
    [anon_sym_type] = ACTIONS(860),
    [anon_sym_LBRACK] = ACTIONS(862),
    [anon_sym_AT] = ACTIONS(361),
    [anon_sym_DASH] = ACTIONS(864),
    [anon_sym_PIPE] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(866),
    [anon_sym_RBRACE] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(864),
    [anon_sym_not] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(363),
    [anon_sym_or] = ACTIONS(363),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(361),
    [anon_sym_SLASH_SLASH] = ACTIONS(361),
    [anon_sym_AMP] = ACTIONS(361),
    [anon_sym_CARET] = ACTIONS(361),
    [anon_sym_LT_LT] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(864),
    [anon_sym_LT] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(361),
    [anon_sym_EQ_EQ] = ACTIONS(361),
    [anon_sym_BANG_EQ] = ACTIONS(361),
    [anon_sym_GT_EQ] = ACTIONS(361),
    [anon_sym_GT] = ACTIONS(363),
    [anon_sym_LT_GT] = ACTIONS(361),
    [anon_sym_is] = ACTIONS(363),
    [sym_ellipsis] = ACTIONS(868),
    [sym_integer] = ACTIONS(852),
    [sym_float] = ACTIONS(868),
    [anon_sym_await] = ACTIONS(870),
    [sym_true] = ACTIONS(852),
    [sym_false] = ACTIONS(852),
    [sym_none] = ACTIONS(852),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(872),
  },
  [202] = {
    [sym_list_splat_pattern] = STATE(1530),
    [sym_primary_expression] = STATE(1296),
    [sym_binary_operator] = STATE(1660),
    [sym_unary_operator] = STATE(1660),
    [sym_attribute] = STATE(1660),
    [sym_subscript] = STATE(1660),
    [sym_call] = STATE(1660),
    [sym_list] = STATE(1660),
    [sym_set] = STATE(1660),
    [sym_tuple] = STATE(1660),
    [sym_dictionary] = STATE(1660),
    [sym_list_comprehension] = STATE(1660),
    [sym_dictionary_comprehension] = STATE(1660),
    [sym_set_comprehension] = STATE(1660),
    [sym_generator_expression] = STATE(1660),
    [sym_parenthesized_expression] = STATE(1660),
    [sym_concatenated_string] = STATE(1660),
    [sym_string] = STATE(1271),
    [sym_await] = STATE(1660),
    [sym_identifier] = ACTIONS(828),
    [anon_sym_DOT] = ACTIONS(363),
    [anon_sym_LPAREN] = ACTIONS(830),
    [anon_sym_RPAREN] = ACTIONS(368),
    [anon_sym_COMMA] = ACTIONS(368),
    [anon_sym_as] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(832),
    [anon_sym_print] = ACTIONS(834),
    [anon_sym_GT_GT] = ACTIONS(361),
    [anon_sym_COLON_EQ] = ACTIONS(376),
    [anon_sym_if] = ACTIONS(363),
    [anon_sym_match] = ACTIONS(834),
    [anon_sym_async] = ACTIONS(834),
    [anon_sym_for] = ACTIONS(363),
    [anon_sym_in] = ACTIONS(363),
    [anon_sym_STAR_STAR] = ACTIONS(361),
    [anon_sym_exec] = ACTIONS(834),
    [anon_sym_type] = ACTIONS(836),
    [anon_sym_LBRACK] = ACTIONS(840),
    [anon_sym_AT] = ACTIONS(361),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_PIPE] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(844),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_not] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(363),
    [anon_sym_or] = ACTIONS(363),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(361),
    [anon_sym_SLASH_SLASH] = ACTIONS(361),
    [anon_sym_AMP] = ACTIONS(361),
    [anon_sym_CARET] = ACTIONS(361),
    [anon_sym_LT_LT] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(842),
    [anon_sym_LT] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(361),
    [anon_sym_EQ_EQ] = ACTIONS(361),
    [anon_sym_BANG_EQ] = ACTIONS(361),
    [anon_sym_GT_EQ] = ACTIONS(361),
    [anon_sym_GT] = ACTIONS(363),
    [anon_sym_LT_GT] = ACTIONS(361),
    [anon_sym_is] = ACTIONS(363),
    [sym_ellipsis] = ACTIONS(846),
    [sym_integer] = ACTIONS(828),
    [sym_float] = ACTIONS(846),
    [anon_sym_await] = ACTIONS(848),
    [sym_true] = ACTIONS(828),
    [sym_false] = ACTIONS(828),
    [sym_none] = ACTIONS(828),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(850),
  },
  [203] = {
    [sym_identifier] = ACTIONS(966),
    [anon_sym_import] = ACTIONS(966),
    [anon_sym_from] = ACTIONS(966),
    [anon_sym_LPAREN] = ACTIONS(968),
    [anon_sym_STAR] = ACTIONS(968),
    [anon_sym_print] = ACTIONS(966),
    [anon_sym_assert] = ACTIONS(966),
    [anon_sym_return] = ACTIONS(966),
    [anon_sym_del] = ACTIONS(966),
    [anon_sym_raise] = ACTIONS(966),
    [anon_sym_pass] = ACTIONS(966),
    [anon_sym_break] = ACTIONS(966),
    [anon_sym_continue] = ACTIONS(966),
    [anon_sym_if] = ACTIONS(966),
    [anon_sym_match] = ACTIONS(966),
    [anon_sym_async] = ACTIONS(966),
    [anon_sym_for] = ACTIONS(966),
    [anon_sym_while] = ACTIONS(966),
    [anon_sym_try] = ACTIONS(966),
    [anon_sym_with] = ACTIONS(966),
    [anon_sym_def] = ACTIONS(966),
    [anon_sym_global] = ACTIONS(966),
    [anon_sym_nonlocal] = ACTIONS(966),
    [anon_sym_exec] = ACTIONS(966),
    [anon_sym_type] = ACTIONS(966),
    [anon_sym_class] = ACTIONS(966),
    [anon_sym_LBRACK] = ACTIONS(968),
    [anon_sym_AT] = ACTIONS(968),
    [anon_sym_DASH] = ACTIONS(968),
    [anon_sym_LBRACE] = ACTIONS(968),
    [anon_sym_PLUS] = ACTIONS(968),
    [anon_sym_not] = ACTIONS(966),
    [anon_sym_TILDE] = ACTIONS(968),
    [anon_sym_lambda] = ACTIONS(966),
    [anon_sym_yield] = ACTIONS(966),
    [sym_ellipsis] = ACTIONS(968),
    [sym_integer] = ACTIONS(966),
    [sym_float] = ACTIONS(968),
    [anon_sym_await] = ACTIONS(966),
    [sym_true] = ACTIONS(966),
    [sym_false] = ACTIONS(966),
    [sym_none] = ACTIONS(966),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(966),
    [anon_sym_container] = ACTIONS(966),
    [anon_sym_envvars] = ACTIONS(966),
    [anon_sym_include] = ACTIONS(966),
    [anon_sym_pepfile] = ACTIONS(966),
    [anon_sym_pepschema] = ACTIONS(966),
    [anon_sym_scattergather] = ACTIONS(966),
    [anon_sym_version] = ACTIONS(966),
    [anon_sym_wildcard_constraints] = ACTIONS(966),
    [anon_sym_workdir] = ACTIONS(966),
    [anon_sym_onerror] = ACTIONS(966),
    [anon_sym_onstart] = ACTIONS(966),
    [anon_sym_onsuccess] = ACTIONS(966),
    [anon_sym_localrules] = ACTIONS(966),
    [anon_sym_ruleorder] = ACTIONS(966),
    [anon_sym_rule] = ACTIONS(966),
    [anon_sym_checkpoint] = ACTIONS(966),
    [anon_sym_use] = ACTIONS(966),
    [anon_sym_module] = ACTIONS(966),
    [anon_sym_config] = ACTIONS(966),
    [anon_sym_meta_wrapper] = ACTIONS(966),
    [anon_sym_prefix] = ACTIONS(966),
    [anon_sym_skip_validation] = ACTIONS(966),
    [anon_sym_snakefile] = ACTIONS(966),
    [sym__dedent] = ACTIONS(968),
    [sym_string_start] = ACTIONS(968),
  },
  [204] = {
    [sym_identifier] = ACTIONS(970),
    [anon_sym_import] = ACTIONS(970),
    [anon_sym_from] = ACTIONS(970),
    [anon_sym_LPAREN] = ACTIONS(972),
    [anon_sym_STAR] = ACTIONS(972),
    [anon_sym_print] = ACTIONS(970),
    [anon_sym_assert] = ACTIONS(970),
    [anon_sym_return] = ACTIONS(970),
    [anon_sym_del] = ACTIONS(970),
    [anon_sym_raise] = ACTIONS(970),
    [anon_sym_pass] = ACTIONS(970),
    [anon_sym_break] = ACTIONS(970),
    [anon_sym_continue] = ACTIONS(970),
    [anon_sym_if] = ACTIONS(970),
    [anon_sym_match] = ACTIONS(970),
    [anon_sym_async] = ACTIONS(970),
    [anon_sym_for] = ACTIONS(970),
    [anon_sym_while] = ACTIONS(970),
    [anon_sym_try] = ACTIONS(970),
    [anon_sym_with] = ACTIONS(970),
    [anon_sym_def] = ACTIONS(970),
    [anon_sym_global] = ACTIONS(970),
    [anon_sym_nonlocal] = ACTIONS(970),
    [anon_sym_exec] = ACTIONS(970),
    [anon_sym_type] = ACTIONS(970),
    [anon_sym_class] = ACTIONS(970),
    [anon_sym_LBRACK] = ACTIONS(972),
    [anon_sym_AT] = ACTIONS(972),
    [anon_sym_DASH] = ACTIONS(972),
    [anon_sym_LBRACE] = ACTIONS(972),
    [anon_sym_PLUS] = ACTIONS(972),
    [anon_sym_not] = ACTIONS(970),
    [anon_sym_TILDE] = ACTIONS(972),
    [anon_sym_lambda] = ACTIONS(970),
    [anon_sym_yield] = ACTIONS(970),
    [sym_ellipsis] = ACTIONS(972),
    [sym_integer] = ACTIONS(970),
    [sym_float] = ACTIONS(972),
    [anon_sym_await] = ACTIONS(970),
    [sym_true] = ACTIONS(970),
    [sym_false] = ACTIONS(970),
    [sym_none] = ACTIONS(970),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(970),
    [anon_sym_container] = ACTIONS(970),
    [anon_sym_envvars] = ACTIONS(970),
    [anon_sym_include] = ACTIONS(970),
    [anon_sym_pepfile] = ACTIONS(970),
    [anon_sym_pepschema] = ACTIONS(970),
    [anon_sym_scattergather] = ACTIONS(970),
    [anon_sym_version] = ACTIONS(970),
    [anon_sym_wildcard_constraints] = ACTIONS(970),
    [anon_sym_workdir] = ACTIONS(970),
    [anon_sym_onerror] = ACTIONS(970),
    [anon_sym_onstart] = ACTIONS(970),
    [anon_sym_onsuccess] = ACTIONS(970),
    [anon_sym_localrules] = ACTIONS(970),
    [anon_sym_ruleorder] = ACTIONS(970),
    [anon_sym_rule] = ACTIONS(970),
    [anon_sym_checkpoint] = ACTIONS(970),
    [anon_sym_use] = ACTIONS(970),
    [anon_sym_module] = ACTIONS(970),
    [anon_sym_config] = ACTIONS(970),
    [anon_sym_meta_wrapper] = ACTIONS(970),
    [anon_sym_prefix] = ACTIONS(970),
    [anon_sym_skip_validation] = ACTIONS(970),
    [anon_sym_snakefile] = ACTIONS(970),
    [sym__dedent] = ACTIONS(972),
    [sym_string_start] = ACTIONS(972),
  },
  [205] = {
    [sym_identifier] = ACTIONS(974),
    [anon_sym_import] = ACTIONS(974),
    [anon_sym_from] = ACTIONS(974),
    [anon_sym_LPAREN] = ACTIONS(976),
    [anon_sym_STAR] = ACTIONS(976),
    [anon_sym_print] = ACTIONS(974),
    [anon_sym_assert] = ACTIONS(974),
    [anon_sym_return] = ACTIONS(974),
    [anon_sym_del] = ACTIONS(974),
    [anon_sym_raise] = ACTIONS(974),
    [anon_sym_pass] = ACTIONS(974),
    [anon_sym_break] = ACTIONS(974),
    [anon_sym_continue] = ACTIONS(974),
    [anon_sym_if] = ACTIONS(974),
    [anon_sym_match] = ACTIONS(974),
    [anon_sym_async] = ACTIONS(974),
    [anon_sym_for] = ACTIONS(974),
    [anon_sym_while] = ACTIONS(974),
    [anon_sym_try] = ACTIONS(974),
    [anon_sym_with] = ACTIONS(974),
    [anon_sym_def] = ACTIONS(974),
    [anon_sym_global] = ACTIONS(974),
    [anon_sym_nonlocal] = ACTIONS(974),
    [anon_sym_exec] = ACTIONS(974),
    [anon_sym_type] = ACTIONS(974),
    [anon_sym_class] = ACTIONS(974),
    [anon_sym_LBRACK] = ACTIONS(976),
    [anon_sym_AT] = ACTIONS(976),
    [anon_sym_DASH] = ACTIONS(976),
    [anon_sym_LBRACE] = ACTIONS(976),
    [anon_sym_PLUS] = ACTIONS(976),
    [anon_sym_not] = ACTIONS(974),
    [anon_sym_TILDE] = ACTIONS(976),
    [anon_sym_lambda] = ACTIONS(974),
    [anon_sym_yield] = ACTIONS(974),
    [sym_ellipsis] = ACTIONS(976),
    [sym_integer] = ACTIONS(974),
    [sym_float] = ACTIONS(976),
    [anon_sym_await] = ACTIONS(974),
    [sym_true] = ACTIONS(974),
    [sym_false] = ACTIONS(974),
    [sym_none] = ACTIONS(974),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(974),
    [anon_sym_container] = ACTIONS(974),
    [anon_sym_envvars] = ACTIONS(974),
    [anon_sym_include] = ACTIONS(974),
    [anon_sym_pepfile] = ACTIONS(974),
    [anon_sym_pepschema] = ACTIONS(974),
    [anon_sym_scattergather] = ACTIONS(974),
    [anon_sym_version] = ACTIONS(974),
    [anon_sym_wildcard_constraints] = ACTIONS(974),
    [anon_sym_workdir] = ACTIONS(974),
    [anon_sym_onerror] = ACTIONS(974),
    [anon_sym_onstart] = ACTIONS(974),
    [anon_sym_onsuccess] = ACTIONS(974),
    [anon_sym_localrules] = ACTIONS(974),
    [anon_sym_ruleorder] = ACTIONS(974),
    [anon_sym_rule] = ACTIONS(974),
    [anon_sym_checkpoint] = ACTIONS(974),
    [anon_sym_use] = ACTIONS(974),
    [anon_sym_module] = ACTIONS(974),
    [anon_sym_config] = ACTIONS(974),
    [anon_sym_meta_wrapper] = ACTIONS(974),
    [anon_sym_prefix] = ACTIONS(974),
    [anon_sym_skip_validation] = ACTIONS(974),
    [anon_sym_snakefile] = ACTIONS(974),
    [sym__dedent] = ACTIONS(976),
    [sym_string_start] = ACTIONS(976),
  },
  [206] = {
    [sym_elif_clause] = STATE(304),
    [sym_else_clause] = STATE(499),
    [aux_sym_if_statement_repeat1] = STATE(218),
    [ts_builtin_sym_end] = ACTIONS(978),
    [sym_identifier] = ACTIONS(980),
    [anon_sym_import] = ACTIONS(980),
    [anon_sym_from] = ACTIONS(980),
    [anon_sym_LPAREN] = ACTIONS(978),
    [anon_sym_STAR] = ACTIONS(978),
    [anon_sym_print] = ACTIONS(980),
    [anon_sym_assert] = ACTIONS(980),
    [anon_sym_return] = ACTIONS(980),
    [anon_sym_del] = ACTIONS(980),
    [anon_sym_raise] = ACTIONS(980),
    [anon_sym_pass] = ACTIONS(980),
    [anon_sym_break] = ACTIONS(980),
    [anon_sym_continue] = ACTIONS(980),
    [anon_sym_if] = ACTIONS(980),
    [anon_sym_elif] = ACTIONS(982),
    [anon_sym_else] = ACTIONS(808),
    [anon_sym_match] = ACTIONS(980),
    [anon_sym_async] = ACTIONS(980),
    [anon_sym_for] = ACTIONS(980),
    [anon_sym_while] = ACTIONS(980),
    [anon_sym_try] = ACTIONS(980),
    [anon_sym_with] = ACTIONS(980),
    [anon_sym_def] = ACTIONS(980),
    [anon_sym_global] = ACTIONS(980),
    [anon_sym_nonlocal] = ACTIONS(980),
    [anon_sym_exec] = ACTIONS(980),
    [anon_sym_type] = ACTIONS(980),
    [anon_sym_class] = ACTIONS(980),
    [anon_sym_LBRACK] = ACTIONS(978),
    [anon_sym_AT] = ACTIONS(978),
    [anon_sym_DASH] = ACTIONS(978),
    [anon_sym_LBRACE] = ACTIONS(978),
    [anon_sym_PLUS] = ACTIONS(978),
    [anon_sym_not] = ACTIONS(980),
    [anon_sym_TILDE] = ACTIONS(978),
    [anon_sym_lambda] = ACTIONS(980),
    [anon_sym_yield] = ACTIONS(980),
    [sym_ellipsis] = ACTIONS(978),
    [sym_integer] = ACTIONS(980),
    [sym_float] = ACTIONS(978),
    [anon_sym_await] = ACTIONS(980),
    [sym_true] = ACTIONS(980),
    [sym_false] = ACTIONS(980),
    [sym_none] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(980),
    [anon_sym_container] = ACTIONS(980),
    [anon_sym_envvars] = ACTIONS(980),
    [anon_sym_include] = ACTIONS(980),
    [anon_sym_pepfile] = ACTIONS(980),
    [anon_sym_pepschema] = ACTIONS(980),
    [anon_sym_scattergather] = ACTIONS(980),
    [anon_sym_version] = ACTIONS(980),
    [anon_sym_wildcard_constraints] = ACTIONS(980),
    [anon_sym_workdir] = ACTIONS(980),
    [anon_sym_onerror] = ACTIONS(980),
    [anon_sym_onstart] = ACTIONS(980),
    [anon_sym_onsuccess] = ACTIONS(980),
    [anon_sym_localrules] = ACTIONS(980),
    [anon_sym_ruleorder] = ACTIONS(980),
    [anon_sym_rule] = ACTIONS(980),
    [anon_sym_checkpoint] = ACTIONS(980),
    [anon_sym_use] = ACTIONS(980),
    [anon_sym_module] = ACTIONS(980),
    [sym_string_start] = ACTIONS(978),
  },
  [207] = {
    [sym_elif_clause] = STATE(309),
    [sym_else_clause] = STATE(449),
    [aux_sym_if_statement_repeat1] = STATE(230),
    [sym_identifier] = ACTIONS(984),
    [anon_sym_import] = ACTIONS(984),
    [anon_sym_from] = ACTIONS(984),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_STAR] = ACTIONS(986),
    [anon_sym_print] = ACTIONS(984),
    [anon_sym_assert] = ACTIONS(984),
    [anon_sym_return] = ACTIONS(984),
    [anon_sym_del] = ACTIONS(984),
    [anon_sym_raise] = ACTIONS(984),
    [anon_sym_pass] = ACTIONS(984),
    [anon_sym_break] = ACTIONS(984),
    [anon_sym_continue] = ACTIONS(984),
    [anon_sym_if] = ACTIONS(984),
    [anon_sym_elif] = ACTIONS(988),
    [anon_sym_else] = ACTIONS(820),
    [anon_sym_match] = ACTIONS(984),
    [anon_sym_async] = ACTIONS(984),
    [anon_sym_for] = ACTIONS(984),
    [anon_sym_while] = ACTIONS(984),
    [anon_sym_try] = ACTIONS(984),
    [anon_sym_with] = ACTIONS(984),
    [anon_sym_def] = ACTIONS(984),
    [anon_sym_global] = ACTIONS(984),
    [anon_sym_nonlocal] = ACTIONS(984),
    [anon_sym_exec] = ACTIONS(984),
    [anon_sym_type] = ACTIONS(984),
    [anon_sym_class] = ACTIONS(984),
    [anon_sym_LBRACK] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(986),
    [anon_sym_DASH] = ACTIONS(986),
    [anon_sym_LBRACE] = ACTIONS(986),
    [anon_sym_PLUS] = ACTIONS(986),
    [anon_sym_not] = ACTIONS(984),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_lambda] = ACTIONS(984),
    [anon_sym_yield] = ACTIONS(984),
    [sym_ellipsis] = ACTIONS(986),
    [sym_integer] = ACTIONS(984),
    [sym_float] = ACTIONS(986),
    [anon_sym_await] = ACTIONS(984),
    [sym_true] = ACTIONS(984),
    [sym_false] = ACTIONS(984),
    [sym_none] = ACTIONS(984),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(984),
    [anon_sym_container] = ACTIONS(984),
    [anon_sym_envvars] = ACTIONS(984),
    [anon_sym_include] = ACTIONS(984),
    [anon_sym_pepfile] = ACTIONS(984),
    [anon_sym_pepschema] = ACTIONS(984),
    [anon_sym_scattergather] = ACTIONS(984),
    [anon_sym_version] = ACTIONS(984),
    [anon_sym_wildcard_constraints] = ACTIONS(984),
    [anon_sym_workdir] = ACTIONS(984),
    [anon_sym_onerror] = ACTIONS(984),
    [anon_sym_onstart] = ACTIONS(984),
    [anon_sym_onsuccess] = ACTIONS(984),
    [anon_sym_localrules] = ACTIONS(984),
    [anon_sym_ruleorder] = ACTIONS(984),
    [anon_sym_rule] = ACTIONS(984),
    [anon_sym_checkpoint] = ACTIONS(984),
    [anon_sym_use] = ACTIONS(984),
    [anon_sym_module] = ACTIONS(984),
    [sym__dedent] = ACTIONS(986),
    [sym_string_start] = ACTIONS(986),
  },
  [208] = {
    [sym_list_splat_pattern] = STATE(1761),
    [sym_primary_expression] = STATE(1628),
    [sym_binary_operator] = STATE(1780),
    [sym_unary_operator] = STATE(1780),
    [sym_attribute] = STATE(1780),
    [sym_subscript] = STATE(1780),
    [sym_call] = STATE(1780),
    [sym_list] = STATE(1780),
    [sym_set] = STATE(1780),
    [sym_tuple] = STATE(1780),
    [sym_dictionary] = STATE(1780),
    [sym_list_comprehension] = STATE(1780),
    [sym_dictionary_comprehension] = STATE(1780),
    [sym_set_comprehension] = STATE(1780),
    [sym_generator_expression] = STATE(1780),
    [sym_parenthesized_expression] = STATE(1780),
    [sym_concatenated_string] = STATE(1780),
    [sym_string] = STATE(1488),
    [sym_await] = STATE(1780),
    [sym_identifier] = ACTIONS(942),
    [anon_sym_DOT] = ACTIONS(363),
    [anon_sym_LPAREN] = ACTIONS(944),
    [anon_sym_COMMA] = ACTIONS(361),
    [anon_sym_as] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(946),
    [anon_sym_print] = ACTIONS(948),
    [anon_sym_GT_GT] = ACTIONS(361),
    [anon_sym_COLON_EQ] = ACTIONS(376),
    [anon_sym_if] = ACTIONS(363),
    [anon_sym_match] = ACTIONS(948),
    [anon_sym_async] = ACTIONS(948),
    [anon_sym_in] = ACTIONS(363),
    [anon_sym_STAR_STAR] = ACTIONS(361),
    [anon_sym_exec] = ACTIONS(948),
    [anon_sym_type] = ACTIONS(950),
    [anon_sym_LBRACK] = ACTIONS(954),
    [anon_sym_AT] = ACTIONS(361),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_PIPE] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(958),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_not] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(363),
    [anon_sym_or] = ACTIONS(363),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(361),
    [anon_sym_SLASH_SLASH] = ACTIONS(361),
    [anon_sym_AMP] = ACTIONS(361),
    [anon_sym_CARET] = ACTIONS(361),
    [anon_sym_LT_LT] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(956),
    [anon_sym_LT] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(361),
    [anon_sym_EQ_EQ] = ACTIONS(361),
    [anon_sym_BANG_EQ] = ACTIONS(361),
    [anon_sym_GT_EQ] = ACTIONS(361),
    [anon_sym_GT] = ACTIONS(363),
    [anon_sym_LT_GT] = ACTIONS(361),
    [anon_sym_is] = ACTIONS(363),
    [sym_ellipsis] = ACTIONS(960),
    [sym_integer] = ACTIONS(942),
    [sym_float] = ACTIONS(960),
    [anon_sym_await] = ACTIONS(962),
    [sym_true] = ACTIONS(942),
    [sym_false] = ACTIONS(942),
    [sym_none] = ACTIONS(942),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(361),
    [sym_string_start] = ACTIONS(964),
  },
  [209] = {
    [sym_elif_clause] = STATE(309),
    [sym_else_clause] = STATE(351),
    [aux_sym_if_statement_repeat1] = STATE(230),
    [sym_identifier] = ACTIONS(990),
    [anon_sym_import] = ACTIONS(990),
    [anon_sym_from] = ACTIONS(990),
    [anon_sym_LPAREN] = ACTIONS(992),
    [anon_sym_STAR] = ACTIONS(992),
    [anon_sym_print] = ACTIONS(990),
    [anon_sym_assert] = ACTIONS(990),
    [anon_sym_return] = ACTIONS(990),
    [anon_sym_del] = ACTIONS(990),
    [anon_sym_raise] = ACTIONS(990),
    [anon_sym_pass] = ACTIONS(990),
    [anon_sym_break] = ACTIONS(990),
    [anon_sym_continue] = ACTIONS(990),
    [anon_sym_if] = ACTIONS(990),
    [anon_sym_elif] = ACTIONS(988),
    [anon_sym_else] = ACTIONS(820),
    [anon_sym_match] = ACTIONS(990),
    [anon_sym_async] = ACTIONS(990),
    [anon_sym_for] = ACTIONS(990),
    [anon_sym_while] = ACTIONS(990),
    [anon_sym_try] = ACTIONS(990),
    [anon_sym_with] = ACTIONS(990),
    [anon_sym_def] = ACTIONS(990),
    [anon_sym_global] = ACTIONS(990),
    [anon_sym_nonlocal] = ACTIONS(990),
    [anon_sym_exec] = ACTIONS(990),
    [anon_sym_type] = ACTIONS(990),
    [anon_sym_class] = ACTIONS(990),
    [anon_sym_LBRACK] = ACTIONS(992),
    [anon_sym_AT] = ACTIONS(992),
    [anon_sym_DASH] = ACTIONS(992),
    [anon_sym_LBRACE] = ACTIONS(992),
    [anon_sym_PLUS] = ACTIONS(992),
    [anon_sym_not] = ACTIONS(990),
    [anon_sym_TILDE] = ACTIONS(992),
    [anon_sym_lambda] = ACTIONS(990),
    [anon_sym_yield] = ACTIONS(990),
    [sym_ellipsis] = ACTIONS(992),
    [sym_integer] = ACTIONS(990),
    [sym_float] = ACTIONS(992),
    [anon_sym_await] = ACTIONS(990),
    [sym_true] = ACTIONS(990),
    [sym_false] = ACTIONS(990),
    [sym_none] = ACTIONS(990),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(990),
    [anon_sym_container] = ACTIONS(990),
    [anon_sym_envvars] = ACTIONS(990),
    [anon_sym_include] = ACTIONS(990),
    [anon_sym_pepfile] = ACTIONS(990),
    [anon_sym_pepschema] = ACTIONS(990),
    [anon_sym_scattergather] = ACTIONS(990),
    [anon_sym_version] = ACTIONS(990),
    [anon_sym_wildcard_constraints] = ACTIONS(990),
    [anon_sym_workdir] = ACTIONS(990),
    [anon_sym_onerror] = ACTIONS(990),
    [anon_sym_onstart] = ACTIONS(990),
    [anon_sym_onsuccess] = ACTIONS(990),
    [anon_sym_localrules] = ACTIONS(990),
    [anon_sym_ruleorder] = ACTIONS(990),
    [anon_sym_rule] = ACTIONS(990),
    [anon_sym_checkpoint] = ACTIONS(990),
    [anon_sym_use] = ACTIONS(990),
    [anon_sym_module] = ACTIONS(990),
    [sym__dedent] = ACTIONS(992),
    [sym_string_start] = ACTIONS(992),
  },
  [210] = {
    [sym_list_splat_pattern] = STATE(1756),
    [sym_primary_expression] = STATE(1467),
    [sym_binary_operator] = STATE(1752),
    [sym_unary_operator] = STATE(1752),
    [sym_attribute] = STATE(1752),
    [sym_subscript] = STATE(1752),
    [sym_call] = STATE(1752),
    [sym_list] = STATE(1752),
    [sym_set] = STATE(1752),
    [sym_tuple] = STATE(1752),
    [sym_dictionary] = STATE(1752),
    [sym_list_comprehension] = STATE(1752),
    [sym_dictionary_comprehension] = STATE(1752),
    [sym_set_comprehension] = STATE(1752),
    [sym_generator_expression] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1752),
    [sym_concatenated_string] = STATE(1752),
    [sym_string] = STATE(1337),
    [sym_await] = STATE(1752),
    [sym_identifier] = ACTIONS(896),
    [anon_sym_DOT] = ACTIONS(363),
    [anon_sym_LPAREN] = ACTIONS(898),
    [anon_sym_COMMA] = ACTIONS(361),
    [anon_sym_as] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_print] = ACTIONS(902),
    [anon_sym_GT_GT] = ACTIONS(361),
    [anon_sym_if] = ACTIONS(363),
    [anon_sym_COLON] = ACTIONS(361),
    [anon_sym_match] = ACTIONS(902),
    [anon_sym_async] = ACTIONS(902),
    [anon_sym_in] = ACTIONS(363),
    [anon_sym_STAR_STAR] = ACTIONS(361),
    [anon_sym_exec] = ACTIONS(902),
    [anon_sym_type] = ACTIONS(904),
    [anon_sym_LBRACK] = ACTIONS(906),
    [anon_sym_RBRACK] = ACTIONS(361),
    [anon_sym_AT] = ACTIONS(361),
    [anon_sym_DASH] = ACTIONS(908),
    [anon_sym_PIPE] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(910),
    [anon_sym_PLUS] = ACTIONS(908),
    [anon_sym_not] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(363),
    [anon_sym_or] = ACTIONS(363),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(361),
    [anon_sym_SLASH_SLASH] = ACTIONS(361),
    [anon_sym_AMP] = ACTIONS(361),
    [anon_sym_CARET] = ACTIONS(361),
    [anon_sym_LT_LT] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(908),
    [anon_sym_LT] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(361),
    [anon_sym_EQ_EQ] = ACTIONS(361),
    [anon_sym_BANG_EQ] = ACTIONS(361),
    [anon_sym_GT_EQ] = ACTIONS(361),
    [anon_sym_GT] = ACTIONS(363),
    [anon_sym_LT_GT] = ACTIONS(361),
    [anon_sym_is] = ACTIONS(363),
    [sym_ellipsis] = ACTIONS(912),
    [sym_integer] = ACTIONS(896),
    [sym_float] = ACTIONS(912),
    [anon_sym_await] = ACTIONS(914),
    [sym_true] = ACTIONS(896),
    [sym_false] = ACTIONS(896),
    [sym_none] = ACTIONS(896),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(916),
  },
  [211] = {
    [sym_identifier] = ACTIONS(994),
    [anon_sym_import] = ACTIONS(994),
    [anon_sym_from] = ACTIONS(994),
    [anon_sym_LPAREN] = ACTIONS(996),
    [anon_sym_STAR] = ACTIONS(996),
    [anon_sym_print] = ACTIONS(994),
    [anon_sym_assert] = ACTIONS(994),
    [anon_sym_return] = ACTIONS(994),
    [anon_sym_del] = ACTIONS(994),
    [anon_sym_raise] = ACTIONS(994),
    [anon_sym_pass] = ACTIONS(994),
    [anon_sym_break] = ACTIONS(994),
    [anon_sym_continue] = ACTIONS(994),
    [anon_sym_if] = ACTIONS(994),
    [anon_sym_match] = ACTIONS(994),
    [anon_sym_async] = ACTIONS(994),
    [anon_sym_for] = ACTIONS(994),
    [anon_sym_while] = ACTIONS(994),
    [anon_sym_try] = ACTIONS(994),
    [anon_sym_with] = ACTIONS(994),
    [anon_sym_def] = ACTIONS(994),
    [anon_sym_global] = ACTIONS(994),
    [anon_sym_nonlocal] = ACTIONS(994),
    [anon_sym_exec] = ACTIONS(994),
    [anon_sym_type] = ACTIONS(994),
    [anon_sym_class] = ACTIONS(994),
    [anon_sym_LBRACK] = ACTIONS(996),
    [anon_sym_AT] = ACTIONS(996),
    [anon_sym_DASH] = ACTIONS(996),
    [anon_sym_LBRACE] = ACTIONS(996),
    [anon_sym_PLUS] = ACTIONS(996),
    [anon_sym_not] = ACTIONS(994),
    [anon_sym_TILDE] = ACTIONS(996),
    [anon_sym_lambda] = ACTIONS(994),
    [anon_sym_yield] = ACTIONS(994),
    [sym_ellipsis] = ACTIONS(996),
    [sym_integer] = ACTIONS(994),
    [sym_float] = ACTIONS(996),
    [anon_sym_await] = ACTIONS(994),
    [sym_true] = ACTIONS(994),
    [sym_false] = ACTIONS(994),
    [sym_none] = ACTIONS(994),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(994),
    [anon_sym_container] = ACTIONS(994),
    [anon_sym_envvars] = ACTIONS(994),
    [anon_sym_include] = ACTIONS(994),
    [anon_sym_pepfile] = ACTIONS(994),
    [anon_sym_pepschema] = ACTIONS(994),
    [anon_sym_scattergather] = ACTIONS(994),
    [anon_sym_version] = ACTIONS(994),
    [anon_sym_wildcard_constraints] = ACTIONS(994),
    [anon_sym_workdir] = ACTIONS(994),
    [anon_sym_onerror] = ACTIONS(994),
    [anon_sym_onstart] = ACTIONS(994),
    [anon_sym_onsuccess] = ACTIONS(994),
    [anon_sym_localrules] = ACTIONS(994),
    [anon_sym_ruleorder] = ACTIONS(994),
    [anon_sym_rule] = ACTIONS(994),
    [anon_sym_checkpoint] = ACTIONS(994),
    [anon_sym_use] = ACTIONS(994),
    [anon_sym_module] = ACTIONS(994),
    [anon_sym_config] = ACTIONS(994),
    [anon_sym_meta_wrapper] = ACTIONS(994),
    [anon_sym_prefix] = ACTIONS(994),
    [anon_sym_skip_validation] = ACTIONS(994),
    [anon_sym_snakefile] = ACTIONS(994),
    [sym__dedent] = ACTIONS(996),
    [sym_string_start] = ACTIONS(996),
  },
  [212] = {
    [sym_list_splat_pattern] = STATE(1314),
    [sym_primary_expression] = STATE(1218),
    [sym_binary_operator] = STATE(1312),
    [sym_unary_operator] = STATE(1312),
    [sym_attribute] = STATE(1312),
    [sym_subscript] = STATE(1312),
    [sym_call] = STATE(1312),
    [sym_list] = STATE(1312),
    [sym_set] = STATE(1312),
    [sym_tuple] = STATE(1312),
    [sym_dictionary] = STATE(1312),
    [sym_list_comprehension] = STATE(1312),
    [sym_dictionary_comprehension] = STATE(1312),
    [sym_set_comprehension] = STATE(1312),
    [sym_generator_expression] = STATE(1312),
    [sym_parenthesized_expression] = STATE(1312),
    [sym_concatenated_string] = STATE(1312),
    [sym_string] = STATE(1200),
    [sym_await] = STATE(1312),
    [sym_identifier] = ACTIONS(77),
    [anon_sym_DOT] = ACTIONS(768),
    [anon_sym_LPAREN] = ACTIONS(752),
    [anon_sym_COMMA] = ACTIONS(801),
    [anon_sym_as] = ACTIONS(768),
    [anon_sym_STAR] = ACTIONS(754),
    [anon_sym_print] = ACTIONS(756),
    [anon_sym_GT_GT] = ACTIONS(801),
    [anon_sym_COLON_EQ] = ACTIONS(376),
    [anon_sym_if] = ACTIONS(768),
    [anon_sym_match] = ACTIONS(756),
    [anon_sym_async] = ACTIONS(756),
    [anon_sym_in] = ACTIONS(768),
    [anon_sym_STAR_STAR] = ACTIONS(801),
    [anon_sym_exec] = ACTIONS(756),
    [anon_sym_type] = ACTIONS(758),
    [anon_sym_LBRACK] = ACTIONS(760),
    [anon_sym_AT] = ACTIONS(801),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_PIPE] = ACTIONS(801),
    [anon_sym_LBRACE] = ACTIONS(67),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_not] = ACTIONS(768),
    [anon_sym_and] = ACTIONS(768),
    [anon_sym_or] = ACTIONS(768),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_PERCENT] = ACTIONS(801),
    [anon_sym_SLASH_SLASH] = ACTIONS(801),
    [anon_sym_AMP] = ACTIONS(801),
    [anon_sym_CARET] = ACTIONS(801),
    [anon_sym_LT_LT] = ACTIONS(801),
    [anon_sym_TILDE] = ACTIONS(65),
    [anon_sym_LT] = ACTIONS(768),
    [anon_sym_LT_EQ] = ACTIONS(801),
    [anon_sym_EQ_EQ] = ACTIONS(801),
    [anon_sym_BANG_EQ] = ACTIONS(801),
    [anon_sym_GT_EQ] = ACTIONS(801),
    [anon_sym_GT] = ACTIONS(768),
    [anon_sym_LT_GT] = ACTIONS(801),
    [anon_sym_is] = ACTIONS(768),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(764),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(801),
    [sym_string_start] = ACTIONS(97),
  },
  [213] = {
    [sym_elif_clause] = STATE(304),
    [sym_else_clause] = STATE(394),
    [aux_sym_if_statement_repeat1] = STATE(232),
    [ts_builtin_sym_end] = ACTIONS(992),
    [sym_identifier] = ACTIONS(990),
    [anon_sym_import] = ACTIONS(990),
    [anon_sym_from] = ACTIONS(990),
    [anon_sym_LPAREN] = ACTIONS(992),
    [anon_sym_STAR] = ACTIONS(992),
    [anon_sym_print] = ACTIONS(990),
    [anon_sym_assert] = ACTIONS(990),
    [anon_sym_return] = ACTIONS(990),
    [anon_sym_del] = ACTIONS(990),
    [anon_sym_raise] = ACTIONS(990),
    [anon_sym_pass] = ACTIONS(990),
    [anon_sym_break] = ACTIONS(990),
    [anon_sym_continue] = ACTIONS(990),
    [anon_sym_if] = ACTIONS(990),
    [anon_sym_elif] = ACTIONS(982),
    [anon_sym_else] = ACTIONS(808),
    [anon_sym_match] = ACTIONS(990),
    [anon_sym_async] = ACTIONS(990),
    [anon_sym_for] = ACTIONS(990),
    [anon_sym_while] = ACTIONS(990),
    [anon_sym_try] = ACTIONS(990),
    [anon_sym_with] = ACTIONS(990),
    [anon_sym_def] = ACTIONS(990),
    [anon_sym_global] = ACTIONS(990),
    [anon_sym_nonlocal] = ACTIONS(990),
    [anon_sym_exec] = ACTIONS(990),
    [anon_sym_type] = ACTIONS(990),
    [anon_sym_class] = ACTIONS(990),
    [anon_sym_LBRACK] = ACTIONS(992),
    [anon_sym_AT] = ACTIONS(992),
    [anon_sym_DASH] = ACTIONS(992),
    [anon_sym_LBRACE] = ACTIONS(992),
    [anon_sym_PLUS] = ACTIONS(992),
    [anon_sym_not] = ACTIONS(990),
    [anon_sym_TILDE] = ACTIONS(992),
    [anon_sym_lambda] = ACTIONS(990),
    [anon_sym_yield] = ACTIONS(990),
    [sym_ellipsis] = ACTIONS(992),
    [sym_integer] = ACTIONS(990),
    [sym_float] = ACTIONS(992),
    [anon_sym_await] = ACTIONS(990),
    [sym_true] = ACTIONS(990),
    [sym_false] = ACTIONS(990),
    [sym_none] = ACTIONS(990),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(990),
    [anon_sym_container] = ACTIONS(990),
    [anon_sym_envvars] = ACTIONS(990),
    [anon_sym_include] = ACTIONS(990),
    [anon_sym_pepfile] = ACTIONS(990),
    [anon_sym_pepschema] = ACTIONS(990),
    [anon_sym_scattergather] = ACTIONS(990),
    [anon_sym_version] = ACTIONS(990),
    [anon_sym_wildcard_constraints] = ACTIONS(990),
    [anon_sym_workdir] = ACTIONS(990),
    [anon_sym_onerror] = ACTIONS(990),
    [anon_sym_onstart] = ACTIONS(990),
    [anon_sym_onsuccess] = ACTIONS(990),
    [anon_sym_localrules] = ACTIONS(990),
    [anon_sym_ruleorder] = ACTIONS(990),
    [anon_sym_rule] = ACTIONS(990),
    [anon_sym_checkpoint] = ACTIONS(990),
    [anon_sym_use] = ACTIONS(990),
    [anon_sym_module] = ACTIONS(990),
    [sym_string_start] = ACTIONS(992),
  },
  [214] = {
    [sym_list_splat_pattern] = STATE(1761),
    [sym_primary_expression] = STATE(1628),
    [sym_binary_operator] = STATE(1780),
    [sym_unary_operator] = STATE(1780),
    [sym_attribute] = STATE(1780),
    [sym_subscript] = STATE(1780),
    [sym_call] = STATE(1780),
    [sym_list] = STATE(1780),
    [sym_set] = STATE(1780),
    [sym_tuple] = STATE(1780),
    [sym_dictionary] = STATE(1780),
    [sym_list_comprehension] = STATE(1780),
    [sym_dictionary_comprehension] = STATE(1780),
    [sym_set_comprehension] = STATE(1780),
    [sym_generator_expression] = STATE(1780),
    [sym_parenthesized_expression] = STATE(1780),
    [sym_concatenated_string] = STATE(1780),
    [sym_string] = STATE(1488),
    [sym_await] = STATE(1780),
    [sym_identifier] = ACTIONS(942),
    [anon_sym_DOT] = ACTIONS(768),
    [anon_sym_LPAREN] = ACTIONS(944),
    [anon_sym_COMMA] = ACTIONS(801),
    [anon_sym_as] = ACTIONS(768),
    [anon_sym_STAR] = ACTIONS(946),
    [anon_sym_print] = ACTIONS(948),
    [anon_sym_GT_GT] = ACTIONS(801),
    [anon_sym_COLON_EQ] = ACTIONS(376),
    [anon_sym_if] = ACTIONS(768),
    [anon_sym_match] = ACTIONS(948),
    [anon_sym_async] = ACTIONS(948),
    [anon_sym_in] = ACTIONS(768),
    [anon_sym_STAR_STAR] = ACTIONS(801),
    [anon_sym_exec] = ACTIONS(948),
    [anon_sym_type] = ACTIONS(950),
    [anon_sym_LBRACK] = ACTIONS(954),
    [anon_sym_AT] = ACTIONS(801),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_PIPE] = ACTIONS(801),
    [anon_sym_LBRACE] = ACTIONS(958),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_not] = ACTIONS(768),
    [anon_sym_and] = ACTIONS(768),
    [anon_sym_or] = ACTIONS(768),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_PERCENT] = ACTIONS(801),
    [anon_sym_SLASH_SLASH] = ACTIONS(801),
    [anon_sym_AMP] = ACTIONS(801),
    [anon_sym_CARET] = ACTIONS(801),
    [anon_sym_LT_LT] = ACTIONS(801),
    [anon_sym_TILDE] = ACTIONS(956),
    [anon_sym_LT] = ACTIONS(768),
    [anon_sym_LT_EQ] = ACTIONS(801),
    [anon_sym_EQ_EQ] = ACTIONS(801),
    [anon_sym_BANG_EQ] = ACTIONS(801),
    [anon_sym_GT_EQ] = ACTIONS(801),
    [anon_sym_GT] = ACTIONS(768),
    [anon_sym_LT_GT] = ACTIONS(801),
    [anon_sym_is] = ACTIONS(768),
    [sym_ellipsis] = ACTIONS(960),
    [sym_integer] = ACTIONS(942),
    [sym_float] = ACTIONS(960),
    [anon_sym_await] = ACTIONS(962),
    [sym_true] = ACTIONS(942),
    [sym_false] = ACTIONS(942),
    [sym_none] = ACTIONS(942),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(801),
    [sym_string_start] = ACTIONS(964),
  },
  [215] = {
    [sym_list_splat_pattern] = STATE(1530),
    [sym_primary_expression] = STATE(1296),
    [sym_binary_operator] = STATE(1660),
    [sym_unary_operator] = STATE(1660),
    [sym_attribute] = STATE(1660),
    [sym_subscript] = STATE(1660),
    [sym_call] = STATE(1660),
    [sym_list] = STATE(1660),
    [sym_set] = STATE(1660),
    [sym_tuple] = STATE(1660),
    [sym_dictionary] = STATE(1660),
    [sym_list_comprehension] = STATE(1660),
    [sym_dictionary_comprehension] = STATE(1660),
    [sym_set_comprehension] = STATE(1660),
    [sym_generator_expression] = STATE(1660),
    [sym_parenthesized_expression] = STATE(1660),
    [sym_concatenated_string] = STATE(1660),
    [sym_string] = STATE(1271),
    [sym_await] = STATE(1660),
    [sym_identifier] = ACTIONS(828),
    [anon_sym_DOT] = ACTIONS(363),
    [anon_sym_LPAREN] = ACTIONS(830),
    [anon_sym_RPAREN] = ACTIONS(361),
    [anon_sym_COMMA] = ACTIONS(361),
    [anon_sym_as] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(832),
    [anon_sym_print] = ACTIONS(834),
    [anon_sym_GT_GT] = ACTIONS(361),
    [anon_sym_if] = ACTIONS(363),
    [anon_sym_match] = ACTIONS(834),
    [anon_sym_async] = ACTIONS(834),
    [anon_sym_for] = ACTIONS(363),
    [anon_sym_in] = ACTIONS(363),
    [anon_sym_STAR_STAR] = ACTIONS(361),
    [anon_sym_exec] = ACTIONS(834),
    [anon_sym_type] = ACTIONS(836),
    [anon_sym_LBRACK] = ACTIONS(840),
    [anon_sym_AT] = ACTIONS(361),
    [anon_sym_DASH] = ACTIONS(842),
    [anon_sym_PIPE] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(844),
    [anon_sym_PLUS] = ACTIONS(842),
    [anon_sym_not] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(363),
    [anon_sym_or] = ACTIONS(363),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(361),
    [anon_sym_SLASH_SLASH] = ACTIONS(361),
    [anon_sym_AMP] = ACTIONS(361),
    [anon_sym_CARET] = ACTIONS(361),
    [anon_sym_LT_LT] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(842),
    [anon_sym_LT] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(361),
    [anon_sym_EQ_EQ] = ACTIONS(361),
    [anon_sym_BANG_EQ] = ACTIONS(361),
    [anon_sym_GT_EQ] = ACTIONS(361),
    [anon_sym_GT] = ACTIONS(363),
    [anon_sym_LT_GT] = ACTIONS(361),
    [anon_sym_is] = ACTIONS(363),
    [sym_ellipsis] = ACTIONS(846),
    [sym_integer] = ACTIONS(828),
    [sym_float] = ACTIONS(846),
    [anon_sym_await] = ACTIONS(848),
    [sym_true] = ACTIONS(828),
    [sym_false] = ACTIONS(828),
    [sym_none] = ACTIONS(828),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(850),
  },
  [216] = {
    [sym_elif_clause] = STATE(309),
    [sym_else_clause] = STATE(444),
    [aux_sym_if_statement_repeat1] = STATE(209),
    [sym_identifier] = ACTIONS(998),
    [anon_sym_import] = ACTIONS(998),
    [anon_sym_from] = ACTIONS(998),
    [anon_sym_LPAREN] = ACTIONS(1000),
    [anon_sym_STAR] = ACTIONS(1000),
    [anon_sym_print] = ACTIONS(998),
    [anon_sym_assert] = ACTIONS(998),
    [anon_sym_return] = ACTIONS(998),
    [anon_sym_del] = ACTIONS(998),
    [anon_sym_raise] = ACTIONS(998),
    [anon_sym_pass] = ACTIONS(998),
    [anon_sym_break] = ACTIONS(998),
    [anon_sym_continue] = ACTIONS(998),
    [anon_sym_if] = ACTIONS(998),
    [anon_sym_elif] = ACTIONS(988),
    [anon_sym_else] = ACTIONS(820),
    [anon_sym_match] = ACTIONS(998),
    [anon_sym_async] = ACTIONS(998),
    [anon_sym_for] = ACTIONS(998),
    [anon_sym_while] = ACTIONS(998),
    [anon_sym_try] = ACTIONS(998),
    [anon_sym_with] = ACTIONS(998),
    [anon_sym_def] = ACTIONS(998),
    [anon_sym_global] = ACTIONS(998),
    [anon_sym_nonlocal] = ACTIONS(998),
    [anon_sym_exec] = ACTIONS(998),
    [anon_sym_type] = ACTIONS(998),
    [anon_sym_class] = ACTIONS(998),
    [anon_sym_LBRACK] = ACTIONS(1000),
    [anon_sym_AT] = ACTIONS(1000),
    [anon_sym_DASH] = ACTIONS(1000),
    [anon_sym_LBRACE] = ACTIONS(1000),
    [anon_sym_PLUS] = ACTIONS(1000),
    [anon_sym_not] = ACTIONS(998),
    [anon_sym_TILDE] = ACTIONS(1000),
    [anon_sym_lambda] = ACTIONS(998),
    [anon_sym_yield] = ACTIONS(998),
    [sym_ellipsis] = ACTIONS(1000),
    [sym_integer] = ACTIONS(998),
    [sym_float] = ACTIONS(1000),
    [anon_sym_await] = ACTIONS(998),
    [sym_true] = ACTIONS(998),
    [sym_false] = ACTIONS(998),
    [sym_none] = ACTIONS(998),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(998),
    [anon_sym_container] = ACTIONS(998),
    [anon_sym_envvars] = ACTIONS(998),
    [anon_sym_include] = ACTIONS(998),
    [anon_sym_pepfile] = ACTIONS(998),
    [anon_sym_pepschema] = ACTIONS(998),
    [anon_sym_scattergather] = ACTIONS(998),
    [anon_sym_version] = ACTIONS(998),
    [anon_sym_wildcard_constraints] = ACTIONS(998),
    [anon_sym_workdir] = ACTIONS(998),
    [anon_sym_onerror] = ACTIONS(998),
    [anon_sym_onstart] = ACTIONS(998),
    [anon_sym_onsuccess] = ACTIONS(998),
    [anon_sym_localrules] = ACTIONS(998),
    [anon_sym_ruleorder] = ACTIONS(998),
    [anon_sym_rule] = ACTIONS(998),
    [anon_sym_checkpoint] = ACTIONS(998),
    [anon_sym_use] = ACTIONS(998),
    [anon_sym_module] = ACTIONS(998),
    [sym__dedent] = ACTIONS(1000),
    [sym_string_start] = ACTIONS(1000),
  },
  [217] = {
    [sym_except_clause] = STATE(217),
    [aux_sym_try_statement_repeat1] = STATE(217),
    [sym_identifier] = ACTIONS(1002),
    [anon_sym_import] = ACTIONS(1002),
    [anon_sym_from] = ACTIONS(1002),
    [anon_sym_LPAREN] = ACTIONS(1004),
    [anon_sym_STAR] = ACTIONS(1004),
    [anon_sym_print] = ACTIONS(1002),
    [anon_sym_assert] = ACTIONS(1002),
    [anon_sym_return] = ACTIONS(1002),
    [anon_sym_del] = ACTIONS(1002),
    [anon_sym_raise] = ACTIONS(1002),
    [anon_sym_pass] = ACTIONS(1002),
    [anon_sym_break] = ACTIONS(1002),
    [anon_sym_continue] = ACTIONS(1002),
    [anon_sym_if] = ACTIONS(1002),
    [anon_sym_else] = ACTIONS(1002),
    [anon_sym_match] = ACTIONS(1002),
    [anon_sym_async] = ACTIONS(1002),
    [anon_sym_for] = ACTIONS(1002),
    [anon_sym_while] = ACTIONS(1002),
    [anon_sym_try] = ACTIONS(1002),
    [anon_sym_except] = ACTIONS(1006),
    [anon_sym_finally] = ACTIONS(1002),
    [anon_sym_with] = ACTIONS(1002),
    [anon_sym_def] = ACTIONS(1002),
    [anon_sym_global] = ACTIONS(1002),
    [anon_sym_nonlocal] = ACTIONS(1002),
    [anon_sym_exec] = ACTIONS(1002),
    [anon_sym_type] = ACTIONS(1002),
    [anon_sym_class] = ACTIONS(1002),
    [anon_sym_LBRACK] = ACTIONS(1004),
    [anon_sym_AT] = ACTIONS(1004),
    [anon_sym_DASH] = ACTIONS(1004),
    [anon_sym_LBRACE] = ACTIONS(1004),
    [anon_sym_PLUS] = ACTIONS(1004),
    [anon_sym_not] = ACTIONS(1002),
    [anon_sym_TILDE] = ACTIONS(1004),
    [anon_sym_lambda] = ACTIONS(1002),
    [anon_sym_yield] = ACTIONS(1002),
    [sym_ellipsis] = ACTIONS(1004),
    [sym_integer] = ACTIONS(1002),
    [sym_float] = ACTIONS(1004),
    [anon_sym_await] = ACTIONS(1002),
    [sym_true] = ACTIONS(1002),
    [sym_false] = ACTIONS(1002),
    [sym_none] = ACTIONS(1002),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1002),
    [anon_sym_container] = ACTIONS(1002),
    [anon_sym_envvars] = ACTIONS(1002),
    [anon_sym_include] = ACTIONS(1002),
    [anon_sym_pepfile] = ACTIONS(1002),
    [anon_sym_pepschema] = ACTIONS(1002),
    [anon_sym_scattergather] = ACTIONS(1002),
    [anon_sym_version] = ACTIONS(1002),
    [anon_sym_wildcard_constraints] = ACTIONS(1002),
    [anon_sym_workdir] = ACTIONS(1002),
    [anon_sym_onerror] = ACTIONS(1002),
    [anon_sym_onstart] = ACTIONS(1002),
    [anon_sym_onsuccess] = ACTIONS(1002),
    [anon_sym_localrules] = ACTIONS(1002),
    [anon_sym_ruleorder] = ACTIONS(1002),
    [anon_sym_rule] = ACTIONS(1002),
    [anon_sym_checkpoint] = ACTIONS(1002),
    [anon_sym_use] = ACTIONS(1002),
    [anon_sym_module] = ACTIONS(1002),
    [sym__dedent] = ACTIONS(1004),
    [sym_string_start] = ACTIONS(1004),
  },
  [218] = {
    [sym_elif_clause] = STATE(304),
    [sym_else_clause] = STATE(438),
    [aux_sym_if_statement_repeat1] = STATE(232),
    [ts_builtin_sym_end] = ACTIONS(986),
    [sym_identifier] = ACTIONS(984),
    [anon_sym_import] = ACTIONS(984),
    [anon_sym_from] = ACTIONS(984),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_STAR] = ACTIONS(986),
    [anon_sym_print] = ACTIONS(984),
    [anon_sym_assert] = ACTIONS(984),
    [anon_sym_return] = ACTIONS(984),
    [anon_sym_del] = ACTIONS(984),
    [anon_sym_raise] = ACTIONS(984),
    [anon_sym_pass] = ACTIONS(984),
    [anon_sym_break] = ACTIONS(984),
    [anon_sym_continue] = ACTIONS(984),
    [anon_sym_if] = ACTIONS(984),
    [anon_sym_elif] = ACTIONS(982),
    [anon_sym_else] = ACTIONS(808),
    [anon_sym_match] = ACTIONS(984),
    [anon_sym_async] = ACTIONS(984),
    [anon_sym_for] = ACTIONS(984),
    [anon_sym_while] = ACTIONS(984),
    [anon_sym_try] = ACTIONS(984),
    [anon_sym_with] = ACTIONS(984),
    [anon_sym_def] = ACTIONS(984),
    [anon_sym_global] = ACTIONS(984),
    [anon_sym_nonlocal] = ACTIONS(984),
    [anon_sym_exec] = ACTIONS(984),
    [anon_sym_type] = ACTIONS(984),
    [anon_sym_class] = ACTIONS(984),
    [anon_sym_LBRACK] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(986),
    [anon_sym_DASH] = ACTIONS(986),
    [anon_sym_LBRACE] = ACTIONS(986),
    [anon_sym_PLUS] = ACTIONS(986),
    [anon_sym_not] = ACTIONS(984),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_lambda] = ACTIONS(984),
    [anon_sym_yield] = ACTIONS(984),
    [sym_ellipsis] = ACTIONS(986),
    [sym_integer] = ACTIONS(984),
    [sym_float] = ACTIONS(986),
    [anon_sym_await] = ACTIONS(984),
    [sym_true] = ACTIONS(984),
    [sym_false] = ACTIONS(984),
    [sym_none] = ACTIONS(984),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(984),
    [anon_sym_container] = ACTIONS(984),
    [anon_sym_envvars] = ACTIONS(984),
    [anon_sym_include] = ACTIONS(984),
    [anon_sym_pepfile] = ACTIONS(984),
    [anon_sym_pepschema] = ACTIONS(984),
    [anon_sym_scattergather] = ACTIONS(984),
    [anon_sym_version] = ACTIONS(984),
    [anon_sym_wildcard_constraints] = ACTIONS(984),
    [anon_sym_workdir] = ACTIONS(984),
    [anon_sym_onerror] = ACTIONS(984),
    [anon_sym_onstart] = ACTIONS(984),
    [anon_sym_onsuccess] = ACTIONS(984),
    [anon_sym_localrules] = ACTIONS(984),
    [anon_sym_ruleorder] = ACTIONS(984),
    [anon_sym_rule] = ACTIONS(984),
    [anon_sym_checkpoint] = ACTIONS(984),
    [anon_sym_use] = ACTIONS(984),
    [anon_sym_module] = ACTIONS(984),
    [sym_string_start] = ACTIONS(986),
  },
  [219] = {
    [sym_except_group_clause] = STATE(219),
    [aux_sym_try_statement_repeat2] = STATE(219),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_import] = ACTIONS(1009),
    [anon_sym_from] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1011),
    [anon_sym_STAR] = ACTIONS(1011),
    [anon_sym_print] = ACTIONS(1009),
    [anon_sym_assert] = ACTIONS(1009),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_del] = ACTIONS(1009),
    [anon_sym_raise] = ACTIONS(1009),
    [anon_sym_pass] = ACTIONS(1009),
    [anon_sym_break] = ACTIONS(1009),
    [anon_sym_continue] = ACTIONS(1009),
    [anon_sym_if] = ACTIONS(1009),
    [anon_sym_else] = ACTIONS(1009),
    [anon_sym_match] = ACTIONS(1009),
    [anon_sym_async] = ACTIONS(1009),
    [anon_sym_for] = ACTIONS(1009),
    [anon_sym_while] = ACTIONS(1009),
    [anon_sym_try] = ACTIONS(1009),
    [anon_sym_except_STAR] = ACTIONS(1013),
    [anon_sym_finally] = ACTIONS(1009),
    [anon_sym_with] = ACTIONS(1009),
    [anon_sym_def] = ACTIONS(1009),
    [anon_sym_global] = ACTIONS(1009),
    [anon_sym_nonlocal] = ACTIONS(1009),
    [anon_sym_exec] = ACTIONS(1009),
    [anon_sym_type] = ACTIONS(1009),
    [anon_sym_class] = ACTIONS(1009),
    [anon_sym_LBRACK] = ACTIONS(1011),
    [anon_sym_AT] = ACTIONS(1011),
    [anon_sym_DASH] = ACTIONS(1011),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1011),
    [anon_sym_not] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_lambda] = ACTIONS(1009),
    [anon_sym_yield] = ACTIONS(1009),
    [sym_ellipsis] = ACTIONS(1011),
    [sym_integer] = ACTIONS(1009),
    [sym_float] = ACTIONS(1011),
    [anon_sym_await] = ACTIONS(1009),
    [sym_true] = ACTIONS(1009),
    [sym_false] = ACTIONS(1009),
    [sym_none] = ACTIONS(1009),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1009),
    [anon_sym_container] = ACTIONS(1009),
    [anon_sym_envvars] = ACTIONS(1009),
    [anon_sym_include] = ACTIONS(1009),
    [anon_sym_pepfile] = ACTIONS(1009),
    [anon_sym_pepschema] = ACTIONS(1009),
    [anon_sym_scattergather] = ACTIONS(1009),
    [anon_sym_version] = ACTIONS(1009),
    [anon_sym_wildcard_constraints] = ACTIONS(1009),
    [anon_sym_workdir] = ACTIONS(1009),
    [anon_sym_onerror] = ACTIONS(1009),
    [anon_sym_onstart] = ACTIONS(1009),
    [anon_sym_onsuccess] = ACTIONS(1009),
    [anon_sym_localrules] = ACTIONS(1009),
    [anon_sym_ruleorder] = ACTIONS(1009),
    [anon_sym_rule] = ACTIONS(1009),
    [anon_sym_checkpoint] = ACTIONS(1009),
    [anon_sym_use] = ACTIONS(1009),
    [anon_sym_module] = ACTIONS(1009),
    [sym__dedent] = ACTIONS(1011),
    [sym_string_start] = ACTIONS(1011),
  },
  [220] = {
    [sym_list_splat_pattern] = STATE(1590),
    [sym_primary_expression] = STATE(1389),
    [sym_binary_operator] = STATE(1654),
    [sym_unary_operator] = STATE(1654),
    [sym_attribute] = STATE(1654),
    [sym_subscript] = STATE(1654),
    [sym_call] = STATE(1654),
    [sym_list] = STATE(1654),
    [sym_set] = STATE(1654),
    [sym_tuple] = STATE(1654),
    [sym_dictionary] = STATE(1654),
    [sym_list_comprehension] = STATE(1654),
    [sym_dictionary_comprehension] = STATE(1654),
    [sym_set_comprehension] = STATE(1654),
    [sym_generator_expression] = STATE(1654),
    [sym_parenthesized_expression] = STATE(1654),
    [sym_concatenated_string] = STATE(1654),
    [sym_string] = STATE(1279),
    [sym_await] = STATE(1654),
    [sym_identifier] = ACTIONS(918),
    [anon_sym_DOT] = ACTIONS(363),
    [anon_sym_LPAREN] = ACTIONS(920),
    [anon_sym_COMMA] = ACTIONS(361),
    [anon_sym_as] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(922),
    [anon_sym_print] = ACTIONS(924),
    [anon_sym_GT_GT] = ACTIONS(361),
    [anon_sym_if] = ACTIONS(363),
    [anon_sym_match] = ACTIONS(924),
    [anon_sym_async] = ACTIONS(924),
    [anon_sym_for] = ACTIONS(363),
    [anon_sym_in] = ACTIONS(363),
    [anon_sym_STAR_STAR] = ACTIONS(361),
    [anon_sym_exec] = ACTIONS(924),
    [anon_sym_type] = ACTIONS(926),
    [anon_sym_LBRACK] = ACTIONS(928),
    [anon_sym_RBRACK] = ACTIONS(361),
    [anon_sym_AT] = ACTIONS(361),
    [anon_sym_DASH] = ACTIONS(930),
    [anon_sym_PIPE] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(932),
    [anon_sym_PLUS] = ACTIONS(930),
    [anon_sym_not] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(363),
    [anon_sym_or] = ACTIONS(363),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(361),
    [anon_sym_SLASH_SLASH] = ACTIONS(361),
    [anon_sym_AMP] = ACTIONS(361),
    [anon_sym_CARET] = ACTIONS(361),
    [anon_sym_LT_LT] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(930),
    [anon_sym_LT] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(361),
    [anon_sym_EQ_EQ] = ACTIONS(361),
    [anon_sym_BANG_EQ] = ACTIONS(361),
    [anon_sym_GT_EQ] = ACTIONS(361),
    [anon_sym_GT] = ACTIONS(363),
    [anon_sym_LT_GT] = ACTIONS(361),
    [anon_sym_is] = ACTIONS(363),
    [sym_ellipsis] = ACTIONS(934),
    [sym_integer] = ACTIONS(918),
    [sym_float] = ACTIONS(934),
    [anon_sym_await] = ACTIONS(936),
    [sym_true] = ACTIONS(918),
    [sym_false] = ACTIONS(918),
    [sym_none] = ACTIONS(918),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(938),
  },
  [221] = {
    [sym_elif_clause] = STATE(304),
    [sym_else_clause] = STATE(435),
    [aux_sym_if_statement_repeat1] = STATE(213),
    [ts_builtin_sym_end] = ACTIONS(1000),
    [sym_identifier] = ACTIONS(998),
    [anon_sym_import] = ACTIONS(998),
    [anon_sym_from] = ACTIONS(998),
    [anon_sym_LPAREN] = ACTIONS(1000),
    [anon_sym_STAR] = ACTIONS(1000),
    [anon_sym_print] = ACTIONS(998),
    [anon_sym_assert] = ACTIONS(998),
    [anon_sym_return] = ACTIONS(998),
    [anon_sym_del] = ACTIONS(998),
    [anon_sym_raise] = ACTIONS(998),
    [anon_sym_pass] = ACTIONS(998),
    [anon_sym_break] = ACTIONS(998),
    [anon_sym_continue] = ACTIONS(998),
    [anon_sym_if] = ACTIONS(998),
    [anon_sym_elif] = ACTIONS(982),
    [anon_sym_else] = ACTIONS(808),
    [anon_sym_match] = ACTIONS(998),
    [anon_sym_async] = ACTIONS(998),
    [anon_sym_for] = ACTIONS(998),
    [anon_sym_while] = ACTIONS(998),
    [anon_sym_try] = ACTIONS(998),
    [anon_sym_with] = ACTIONS(998),
    [anon_sym_def] = ACTIONS(998),
    [anon_sym_global] = ACTIONS(998),
    [anon_sym_nonlocal] = ACTIONS(998),
    [anon_sym_exec] = ACTIONS(998),
    [anon_sym_type] = ACTIONS(998),
    [anon_sym_class] = ACTIONS(998),
    [anon_sym_LBRACK] = ACTIONS(1000),
    [anon_sym_AT] = ACTIONS(1000),
    [anon_sym_DASH] = ACTIONS(1000),
    [anon_sym_LBRACE] = ACTIONS(1000),
    [anon_sym_PLUS] = ACTIONS(1000),
    [anon_sym_not] = ACTIONS(998),
    [anon_sym_TILDE] = ACTIONS(1000),
    [anon_sym_lambda] = ACTIONS(998),
    [anon_sym_yield] = ACTIONS(998),
    [sym_ellipsis] = ACTIONS(1000),
    [sym_integer] = ACTIONS(998),
    [sym_float] = ACTIONS(1000),
    [anon_sym_await] = ACTIONS(998),
    [sym_true] = ACTIONS(998),
    [sym_false] = ACTIONS(998),
    [sym_none] = ACTIONS(998),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(998),
    [anon_sym_container] = ACTIONS(998),
    [anon_sym_envvars] = ACTIONS(998),
    [anon_sym_include] = ACTIONS(998),
    [anon_sym_pepfile] = ACTIONS(998),
    [anon_sym_pepschema] = ACTIONS(998),
    [anon_sym_scattergather] = ACTIONS(998),
    [anon_sym_version] = ACTIONS(998),
    [anon_sym_wildcard_constraints] = ACTIONS(998),
    [anon_sym_workdir] = ACTIONS(998),
    [anon_sym_onerror] = ACTIONS(998),
    [anon_sym_onstart] = ACTIONS(998),
    [anon_sym_onsuccess] = ACTIONS(998),
    [anon_sym_localrules] = ACTIONS(998),
    [anon_sym_ruleorder] = ACTIONS(998),
    [anon_sym_rule] = ACTIONS(998),
    [anon_sym_checkpoint] = ACTIONS(998),
    [anon_sym_use] = ACTIONS(998),
    [anon_sym_module] = ACTIONS(998),
    [sym_string_start] = ACTIONS(1000),
  },
  [222] = {
    [sym_identifier] = ACTIONS(1016),
    [anon_sym_import] = ACTIONS(1016),
    [anon_sym_from] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_STAR] = ACTIONS(1018),
    [anon_sym_print] = ACTIONS(1016),
    [anon_sym_assert] = ACTIONS(1016),
    [anon_sym_return] = ACTIONS(1016),
    [anon_sym_del] = ACTIONS(1016),
    [anon_sym_raise] = ACTIONS(1016),
    [anon_sym_pass] = ACTIONS(1016),
    [anon_sym_break] = ACTIONS(1016),
    [anon_sym_continue] = ACTIONS(1016),
    [anon_sym_if] = ACTIONS(1016),
    [anon_sym_match] = ACTIONS(1016),
    [anon_sym_async] = ACTIONS(1016),
    [anon_sym_for] = ACTIONS(1016),
    [anon_sym_while] = ACTIONS(1016),
    [anon_sym_try] = ACTIONS(1016),
    [anon_sym_with] = ACTIONS(1016),
    [anon_sym_def] = ACTIONS(1016),
    [anon_sym_global] = ACTIONS(1016),
    [anon_sym_nonlocal] = ACTIONS(1016),
    [anon_sym_exec] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(1016),
    [anon_sym_class] = ACTIONS(1016),
    [anon_sym_LBRACK] = ACTIONS(1018),
    [anon_sym_AT] = ACTIONS(1018),
    [anon_sym_DASH] = ACTIONS(1018),
    [anon_sym_LBRACE] = ACTIONS(1018),
    [anon_sym_PLUS] = ACTIONS(1018),
    [anon_sym_not] = ACTIONS(1016),
    [anon_sym_TILDE] = ACTIONS(1018),
    [anon_sym_lambda] = ACTIONS(1016),
    [anon_sym_yield] = ACTIONS(1016),
    [sym_ellipsis] = ACTIONS(1018),
    [sym_integer] = ACTIONS(1016),
    [sym_float] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(1016),
    [sym_true] = ACTIONS(1016),
    [sym_false] = ACTIONS(1016),
    [sym_none] = ACTIONS(1016),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1016),
    [anon_sym_container] = ACTIONS(1016),
    [anon_sym_envvars] = ACTIONS(1016),
    [anon_sym_include] = ACTIONS(1016),
    [anon_sym_pepfile] = ACTIONS(1016),
    [anon_sym_pepschema] = ACTIONS(1016),
    [anon_sym_scattergather] = ACTIONS(1016),
    [anon_sym_version] = ACTIONS(1016),
    [anon_sym_wildcard_constraints] = ACTIONS(1016),
    [anon_sym_workdir] = ACTIONS(1016),
    [anon_sym_onerror] = ACTIONS(1016),
    [anon_sym_onstart] = ACTIONS(1016),
    [anon_sym_onsuccess] = ACTIONS(1016),
    [anon_sym_localrules] = ACTIONS(1016),
    [anon_sym_ruleorder] = ACTIONS(1016),
    [anon_sym_rule] = ACTIONS(1016),
    [anon_sym_checkpoint] = ACTIONS(1016),
    [anon_sym_use] = ACTIONS(1016),
    [anon_sym_module] = ACTIONS(1016),
    [anon_sym_config] = ACTIONS(1016),
    [anon_sym_meta_wrapper] = ACTIONS(1016),
    [anon_sym_prefix] = ACTIONS(1016),
    [anon_sym_skip_validation] = ACTIONS(1016),
    [anon_sym_snakefile] = ACTIONS(1016),
    [sym__dedent] = ACTIONS(1018),
    [sym_string_start] = ACTIONS(1018),
  },
  [223] = {
    [sym_except_group_clause] = STATE(223),
    [aux_sym_try_statement_repeat2] = STATE(223),
    [ts_builtin_sym_end] = ACTIONS(1011),
    [sym_identifier] = ACTIONS(1009),
    [anon_sym_import] = ACTIONS(1009),
    [anon_sym_from] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1011),
    [anon_sym_STAR] = ACTIONS(1011),
    [anon_sym_print] = ACTIONS(1009),
    [anon_sym_assert] = ACTIONS(1009),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_del] = ACTIONS(1009),
    [anon_sym_raise] = ACTIONS(1009),
    [anon_sym_pass] = ACTIONS(1009),
    [anon_sym_break] = ACTIONS(1009),
    [anon_sym_continue] = ACTIONS(1009),
    [anon_sym_if] = ACTIONS(1009),
    [anon_sym_else] = ACTIONS(1009),
    [anon_sym_match] = ACTIONS(1009),
    [anon_sym_async] = ACTIONS(1009),
    [anon_sym_for] = ACTIONS(1009),
    [anon_sym_while] = ACTIONS(1009),
    [anon_sym_try] = ACTIONS(1009),
    [anon_sym_except_STAR] = ACTIONS(1020),
    [anon_sym_finally] = ACTIONS(1009),
    [anon_sym_with] = ACTIONS(1009),
    [anon_sym_def] = ACTIONS(1009),
    [anon_sym_global] = ACTIONS(1009),
    [anon_sym_nonlocal] = ACTIONS(1009),
    [anon_sym_exec] = ACTIONS(1009),
    [anon_sym_type] = ACTIONS(1009),
    [anon_sym_class] = ACTIONS(1009),
    [anon_sym_LBRACK] = ACTIONS(1011),
    [anon_sym_AT] = ACTIONS(1011),
    [anon_sym_DASH] = ACTIONS(1011),
    [anon_sym_LBRACE] = ACTIONS(1011),
    [anon_sym_PLUS] = ACTIONS(1011),
    [anon_sym_not] = ACTIONS(1009),
    [anon_sym_TILDE] = ACTIONS(1011),
    [anon_sym_lambda] = ACTIONS(1009),
    [anon_sym_yield] = ACTIONS(1009),
    [sym_ellipsis] = ACTIONS(1011),
    [sym_integer] = ACTIONS(1009),
    [sym_float] = ACTIONS(1011),
    [anon_sym_await] = ACTIONS(1009),
    [sym_true] = ACTIONS(1009),
    [sym_false] = ACTIONS(1009),
    [sym_none] = ACTIONS(1009),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1009),
    [anon_sym_container] = ACTIONS(1009),
    [anon_sym_envvars] = ACTIONS(1009),
    [anon_sym_include] = ACTIONS(1009),
    [anon_sym_pepfile] = ACTIONS(1009),
    [anon_sym_pepschema] = ACTIONS(1009),
    [anon_sym_scattergather] = ACTIONS(1009),
    [anon_sym_version] = ACTIONS(1009),
    [anon_sym_wildcard_constraints] = ACTIONS(1009),
    [anon_sym_workdir] = ACTIONS(1009),
    [anon_sym_onerror] = ACTIONS(1009),
    [anon_sym_onstart] = ACTIONS(1009),
    [anon_sym_onsuccess] = ACTIONS(1009),
    [anon_sym_localrules] = ACTIONS(1009),
    [anon_sym_ruleorder] = ACTIONS(1009),
    [anon_sym_rule] = ACTIONS(1009),
    [anon_sym_checkpoint] = ACTIONS(1009),
    [anon_sym_use] = ACTIONS(1009),
    [anon_sym_module] = ACTIONS(1009),
    [sym_string_start] = ACTIONS(1011),
  },
  [224] = {
    [sym_except_clause] = STATE(224),
    [aux_sym_try_statement_repeat1] = STATE(224),
    [ts_builtin_sym_end] = ACTIONS(1004),
    [sym_identifier] = ACTIONS(1002),
    [anon_sym_import] = ACTIONS(1002),
    [anon_sym_from] = ACTIONS(1002),
    [anon_sym_LPAREN] = ACTIONS(1004),
    [anon_sym_STAR] = ACTIONS(1004),
    [anon_sym_print] = ACTIONS(1002),
    [anon_sym_assert] = ACTIONS(1002),
    [anon_sym_return] = ACTIONS(1002),
    [anon_sym_del] = ACTIONS(1002),
    [anon_sym_raise] = ACTIONS(1002),
    [anon_sym_pass] = ACTIONS(1002),
    [anon_sym_break] = ACTIONS(1002),
    [anon_sym_continue] = ACTIONS(1002),
    [anon_sym_if] = ACTIONS(1002),
    [anon_sym_else] = ACTIONS(1002),
    [anon_sym_match] = ACTIONS(1002),
    [anon_sym_async] = ACTIONS(1002),
    [anon_sym_for] = ACTIONS(1002),
    [anon_sym_while] = ACTIONS(1002),
    [anon_sym_try] = ACTIONS(1002),
    [anon_sym_except] = ACTIONS(1023),
    [anon_sym_finally] = ACTIONS(1002),
    [anon_sym_with] = ACTIONS(1002),
    [anon_sym_def] = ACTIONS(1002),
    [anon_sym_global] = ACTIONS(1002),
    [anon_sym_nonlocal] = ACTIONS(1002),
    [anon_sym_exec] = ACTIONS(1002),
    [anon_sym_type] = ACTIONS(1002),
    [anon_sym_class] = ACTIONS(1002),
    [anon_sym_LBRACK] = ACTIONS(1004),
    [anon_sym_AT] = ACTIONS(1004),
    [anon_sym_DASH] = ACTIONS(1004),
    [anon_sym_LBRACE] = ACTIONS(1004),
    [anon_sym_PLUS] = ACTIONS(1004),
    [anon_sym_not] = ACTIONS(1002),
    [anon_sym_TILDE] = ACTIONS(1004),
    [anon_sym_lambda] = ACTIONS(1002),
    [anon_sym_yield] = ACTIONS(1002),
    [sym_ellipsis] = ACTIONS(1004),
    [sym_integer] = ACTIONS(1002),
    [sym_float] = ACTIONS(1004),
    [anon_sym_await] = ACTIONS(1002),
    [sym_true] = ACTIONS(1002),
    [sym_false] = ACTIONS(1002),
    [sym_none] = ACTIONS(1002),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1002),
    [anon_sym_container] = ACTIONS(1002),
    [anon_sym_envvars] = ACTIONS(1002),
    [anon_sym_include] = ACTIONS(1002),
    [anon_sym_pepfile] = ACTIONS(1002),
    [anon_sym_pepschema] = ACTIONS(1002),
    [anon_sym_scattergather] = ACTIONS(1002),
    [anon_sym_version] = ACTIONS(1002),
    [anon_sym_wildcard_constraints] = ACTIONS(1002),
    [anon_sym_workdir] = ACTIONS(1002),
    [anon_sym_onerror] = ACTIONS(1002),
    [anon_sym_onstart] = ACTIONS(1002),
    [anon_sym_onsuccess] = ACTIONS(1002),
    [anon_sym_localrules] = ACTIONS(1002),
    [anon_sym_ruleorder] = ACTIONS(1002),
    [anon_sym_rule] = ACTIONS(1002),
    [anon_sym_checkpoint] = ACTIONS(1002),
    [anon_sym_use] = ACTIONS(1002),
    [anon_sym_module] = ACTIONS(1002),
    [sym_string_start] = ACTIONS(1004),
  },
  [225] = {
    [sym_elif_clause] = STATE(309),
    [sym_else_clause] = STATE(501),
    [aux_sym_if_statement_repeat1] = STATE(207),
    [sym_identifier] = ACTIONS(980),
    [anon_sym_import] = ACTIONS(980),
    [anon_sym_from] = ACTIONS(980),
    [anon_sym_LPAREN] = ACTIONS(978),
    [anon_sym_STAR] = ACTIONS(978),
    [anon_sym_print] = ACTIONS(980),
    [anon_sym_assert] = ACTIONS(980),
    [anon_sym_return] = ACTIONS(980),
    [anon_sym_del] = ACTIONS(980),
    [anon_sym_raise] = ACTIONS(980),
    [anon_sym_pass] = ACTIONS(980),
    [anon_sym_break] = ACTIONS(980),
    [anon_sym_continue] = ACTIONS(980),
    [anon_sym_if] = ACTIONS(980),
    [anon_sym_elif] = ACTIONS(988),
    [anon_sym_else] = ACTIONS(820),
    [anon_sym_match] = ACTIONS(980),
    [anon_sym_async] = ACTIONS(980),
    [anon_sym_for] = ACTIONS(980),
    [anon_sym_while] = ACTIONS(980),
    [anon_sym_try] = ACTIONS(980),
    [anon_sym_with] = ACTIONS(980),
    [anon_sym_def] = ACTIONS(980),
    [anon_sym_global] = ACTIONS(980),
    [anon_sym_nonlocal] = ACTIONS(980),
    [anon_sym_exec] = ACTIONS(980),
    [anon_sym_type] = ACTIONS(980),
    [anon_sym_class] = ACTIONS(980),
    [anon_sym_LBRACK] = ACTIONS(978),
    [anon_sym_AT] = ACTIONS(978),
    [anon_sym_DASH] = ACTIONS(978),
    [anon_sym_LBRACE] = ACTIONS(978),
    [anon_sym_PLUS] = ACTIONS(978),
    [anon_sym_not] = ACTIONS(980),
    [anon_sym_TILDE] = ACTIONS(978),
    [anon_sym_lambda] = ACTIONS(980),
    [anon_sym_yield] = ACTIONS(980),
    [sym_ellipsis] = ACTIONS(978),
    [sym_integer] = ACTIONS(980),
    [sym_float] = ACTIONS(978),
    [anon_sym_await] = ACTIONS(980),
    [sym_true] = ACTIONS(980),
    [sym_false] = ACTIONS(980),
    [sym_none] = ACTIONS(980),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(980),
    [anon_sym_container] = ACTIONS(980),
    [anon_sym_envvars] = ACTIONS(980),
    [anon_sym_include] = ACTIONS(980),
    [anon_sym_pepfile] = ACTIONS(980),
    [anon_sym_pepschema] = ACTIONS(980),
    [anon_sym_scattergather] = ACTIONS(980),
    [anon_sym_version] = ACTIONS(980),
    [anon_sym_wildcard_constraints] = ACTIONS(980),
    [anon_sym_workdir] = ACTIONS(980),
    [anon_sym_onerror] = ACTIONS(980),
    [anon_sym_onstart] = ACTIONS(980),
    [anon_sym_onsuccess] = ACTIONS(980),
    [anon_sym_localrules] = ACTIONS(980),
    [anon_sym_ruleorder] = ACTIONS(980),
    [anon_sym_rule] = ACTIONS(980),
    [anon_sym_checkpoint] = ACTIONS(980),
    [anon_sym_use] = ACTIONS(980),
    [anon_sym_module] = ACTIONS(980),
    [sym__dedent] = ACTIONS(978),
    [sym_string_start] = ACTIONS(978),
  },
  [226] = {
    [sym_identifier] = ACTIONS(1026),
    [anon_sym_import] = ACTIONS(1026),
    [anon_sym_from] = ACTIONS(1026),
    [anon_sym_LPAREN] = ACTIONS(1028),
    [anon_sym_STAR] = ACTIONS(1028),
    [anon_sym_print] = ACTIONS(1026),
    [anon_sym_assert] = ACTIONS(1026),
    [anon_sym_return] = ACTIONS(1026),
    [anon_sym_del] = ACTIONS(1026),
    [anon_sym_raise] = ACTIONS(1026),
    [anon_sym_pass] = ACTIONS(1026),
    [anon_sym_break] = ACTIONS(1026),
    [anon_sym_continue] = ACTIONS(1026),
    [anon_sym_if] = ACTIONS(1026),
    [anon_sym_match] = ACTIONS(1026),
    [anon_sym_async] = ACTIONS(1026),
    [anon_sym_for] = ACTIONS(1026),
    [anon_sym_while] = ACTIONS(1026),
    [anon_sym_try] = ACTIONS(1026),
    [anon_sym_with] = ACTIONS(1026),
    [anon_sym_def] = ACTIONS(1026),
    [anon_sym_global] = ACTIONS(1026),
    [anon_sym_nonlocal] = ACTIONS(1026),
    [anon_sym_exec] = ACTIONS(1026),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_class] = ACTIONS(1026),
    [anon_sym_LBRACK] = ACTIONS(1028),
    [anon_sym_AT] = ACTIONS(1028),
    [anon_sym_DASH] = ACTIONS(1028),
    [anon_sym_LBRACE] = ACTIONS(1028),
    [anon_sym_PLUS] = ACTIONS(1028),
    [anon_sym_not] = ACTIONS(1026),
    [anon_sym_TILDE] = ACTIONS(1028),
    [anon_sym_lambda] = ACTIONS(1026),
    [anon_sym_yield] = ACTIONS(1026),
    [sym_ellipsis] = ACTIONS(1028),
    [sym_integer] = ACTIONS(1026),
    [sym_float] = ACTIONS(1028),
    [anon_sym_await] = ACTIONS(1026),
    [sym_true] = ACTIONS(1026),
    [sym_false] = ACTIONS(1026),
    [sym_none] = ACTIONS(1026),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1026),
    [anon_sym_container] = ACTIONS(1026),
    [anon_sym_envvars] = ACTIONS(1026),
    [anon_sym_include] = ACTIONS(1026),
    [anon_sym_pepfile] = ACTIONS(1026),
    [anon_sym_pepschema] = ACTIONS(1026),
    [anon_sym_scattergather] = ACTIONS(1026),
    [anon_sym_version] = ACTIONS(1026),
    [anon_sym_wildcard_constraints] = ACTIONS(1026),
    [anon_sym_workdir] = ACTIONS(1026),
    [anon_sym_onerror] = ACTIONS(1026),
    [anon_sym_onstart] = ACTIONS(1026),
    [anon_sym_onsuccess] = ACTIONS(1026),
    [anon_sym_localrules] = ACTIONS(1026),
    [anon_sym_ruleorder] = ACTIONS(1026),
    [anon_sym_rule] = ACTIONS(1026),
    [anon_sym_checkpoint] = ACTIONS(1026),
    [anon_sym_use] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [anon_sym_config] = ACTIONS(1026),
    [anon_sym_meta_wrapper] = ACTIONS(1026),
    [anon_sym_prefix] = ACTIONS(1026),
    [anon_sym_skip_validation] = ACTIONS(1026),
    [anon_sym_snakefile] = ACTIONS(1026),
    [sym__dedent] = ACTIONS(1028),
    [sym_string_start] = ACTIONS(1028),
  },
  [227] = {
    [sym_identifier] = ACTIONS(1030),
    [anon_sym_import] = ACTIONS(1030),
    [anon_sym_from] = ACTIONS(1030),
    [anon_sym_LPAREN] = ACTIONS(1032),
    [anon_sym_STAR] = ACTIONS(1032),
    [anon_sym_print] = ACTIONS(1030),
    [anon_sym_assert] = ACTIONS(1030),
    [anon_sym_return] = ACTIONS(1030),
    [anon_sym_del] = ACTIONS(1030),
    [anon_sym_raise] = ACTIONS(1030),
    [anon_sym_pass] = ACTIONS(1030),
    [anon_sym_break] = ACTIONS(1030),
    [anon_sym_continue] = ACTIONS(1030),
    [anon_sym_if] = ACTIONS(1030),
    [anon_sym_match] = ACTIONS(1030),
    [anon_sym_async] = ACTIONS(1030),
    [anon_sym_for] = ACTIONS(1030),
    [anon_sym_while] = ACTIONS(1030),
    [anon_sym_try] = ACTIONS(1030),
    [anon_sym_with] = ACTIONS(1030),
    [anon_sym_def] = ACTIONS(1030),
    [anon_sym_global] = ACTIONS(1030),
    [anon_sym_nonlocal] = ACTIONS(1030),
    [anon_sym_exec] = ACTIONS(1030),
    [anon_sym_type] = ACTIONS(1030),
    [anon_sym_class] = ACTIONS(1030),
    [anon_sym_LBRACK] = ACTIONS(1032),
    [anon_sym_AT] = ACTIONS(1032),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_LBRACE] = ACTIONS(1032),
    [anon_sym_PLUS] = ACTIONS(1032),
    [anon_sym_not] = ACTIONS(1030),
    [anon_sym_TILDE] = ACTIONS(1032),
    [anon_sym_lambda] = ACTIONS(1030),
    [anon_sym_yield] = ACTIONS(1030),
    [sym_ellipsis] = ACTIONS(1032),
    [sym_integer] = ACTIONS(1030),
    [sym_float] = ACTIONS(1032),
    [anon_sym_await] = ACTIONS(1030),
    [sym_true] = ACTIONS(1030),
    [sym_false] = ACTIONS(1030),
    [sym_none] = ACTIONS(1030),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1030),
    [anon_sym_container] = ACTIONS(1030),
    [anon_sym_envvars] = ACTIONS(1030),
    [anon_sym_include] = ACTIONS(1030),
    [anon_sym_pepfile] = ACTIONS(1030),
    [anon_sym_pepschema] = ACTIONS(1030),
    [anon_sym_scattergather] = ACTIONS(1030),
    [anon_sym_version] = ACTIONS(1030),
    [anon_sym_wildcard_constraints] = ACTIONS(1030),
    [anon_sym_workdir] = ACTIONS(1030),
    [anon_sym_onerror] = ACTIONS(1030),
    [anon_sym_onstart] = ACTIONS(1030),
    [anon_sym_onsuccess] = ACTIONS(1030),
    [anon_sym_localrules] = ACTIONS(1030),
    [anon_sym_ruleorder] = ACTIONS(1030),
    [anon_sym_rule] = ACTIONS(1030),
    [anon_sym_checkpoint] = ACTIONS(1030),
    [anon_sym_use] = ACTIONS(1030),
    [anon_sym_module] = ACTIONS(1030),
    [anon_sym_config] = ACTIONS(1030),
    [anon_sym_meta_wrapper] = ACTIONS(1030),
    [anon_sym_prefix] = ACTIONS(1030),
    [anon_sym_skip_validation] = ACTIONS(1030),
    [anon_sym_snakefile] = ACTIONS(1030),
    [sym__dedent] = ACTIONS(1032),
    [sym_string_start] = ACTIONS(1032),
  },
  [228] = {
    [sym_identifier] = ACTIONS(1034),
    [anon_sym_import] = ACTIONS(1034),
    [anon_sym_from] = ACTIONS(1034),
    [anon_sym_LPAREN] = ACTIONS(1036),
    [anon_sym_STAR] = ACTIONS(1036),
    [anon_sym_print] = ACTIONS(1034),
    [anon_sym_assert] = ACTIONS(1034),
    [anon_sym_return] = ACTIONS(1034),
    [anon_sym_del] = ACTIONS(1034),
    [anon_sym_raise] = ACTIONS(1034),
    [anon_sym_pass] = ACTIONS(1034),
    [anon_sym_break] = ACTIONS(1034),
    [anon_sym_continue] = ACTIONS(1034),
    [anon_sym_if] = ACTIONS(1034),
    [anon_sym_match] = ACTIONS(1034),
    [anon_sym_async] = ACTIONS(1034),
    [anon_sym_for] = ACTIONS(1034),
    [anon_sym_while] = ACTIONS(1034),
    [anon_sym_try] = ACTIONS(1034),
    [anon_sym_with] = ACTIONS(1034),
    [anon_sym_def] = ACTIONS(1034),
    [anon_sym_global] = ACTIONS(1034),
    [anon_sym_nonlocal] = ACTIONS(1034),
    [anon_sym_exec] = ACTIONS(1034),
    [anon_sym_type] = ACTIONS(1034),
    [anon_sym_class] = ACTIONS(1034),
    [anon_sym_LBRACK] = ACTIONS(1036),
    [anon_sym_AT] = ACTIONS(1036),
    [anon_sym_DASH] = ACTIONS(1036),
    [anon_sym_LBRACE] = ACTIONS(1036),
    [anon_sym_PLUS] = ACTIONS(1036),
    [anon_sym_not] = ACTIONS(1034),
    [anon_sym_TILDE] = ACTIONS(1036),
    [anon_sym_lambda] = ACTIONS(1034),
    [anon_sym_yield] = ACTIONS(1034),
    [sym_ellipsis] = ACTIONS(1036),
    [sym_integer] = ACTIONS(1034),
    [sym_float] = ACTIONS(1036),
    [anon_sym_await] = ACTIONS(1034),
    [sym_true] = ACTIONS(1034),
    [sym_false] = ACTIONS(1034),
    [sym_none] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1034),
    [anon_sym_container] = ACTIONS(1034),
    [anon_sym_envvars] = ACTIONS(1034),
    [anon_sym_include] = ACTIONS(1034),
    [anon_sym_pepfile] = ACTIONS(1034),
    [anon_sym_pepschema] = ACTIONS(1034),
    [anon_sym_scattergather] = ACTIONS(1034),
    [anon_sym_version] = ACTIONS(1034),
    [anon_sym_wildcard_constraints] = ACTIONS(1034),
    [anon_sym_workdir] = ACTIONS(1034),
    [anon_sym_onerror] = ACTIONS(1034),
    [anon_sym_onstart] = ACTIONS(1034),
    [anon_sym_onsuccess] = ACTIONS(1034),
    [anon_sym_localrules] = ACTIONS(1034),
    [anon_sym_ruleorder] = ACTIONS(1034),
    [anon_sym_rule] = ACTIONS(1034),
    [anon_sym_checkpoint] = ACTIONS(1034),
    [anon_sym_use] = ACTIONS(1034),
    [anon_sym_module] = ACTIONS(1034),
    [anon_sym_config] = ACTIONS(1034),
    [anon_sym_meta_wrapper] = ACTIONS(1034),
    [anon_sym_prefix] = ACTIONS(1034),
    [anon_sym_skip_validation] = ACTIONS(1034),
    [anon_sym_snakefile] = ACTIONS(1034),
    [sym__dedent] = ACTIONS(1036),
    [sym_string_start] = ACTIONS(1036),
  },
  [229] = {
    [sym_list_splat_pattern] = STATE(1541),
    [sym_primary_expression] = STATE(1298),
    [sym_binary_operator] = STATE(1536),
    [sym_unary_operator] = STATE(1536),
    [sym_attribute] = STATE(1536),
    [sym_subscript] = STATE(1536),
    [sym_call] = STATE(1536),
    [sym_list] = STATE(1536),
    [sym_set] = STATE(1536),
    [sym_tuple] = STATE(1536),
    [sym_dictionary] = STATE(1536),
    [sym_list_comprehension] = STATE(1536),
    [sym_dictionary_comprehension] = STATE(1536),
    [sym_set_comprehension] = STATE(1536),
    [sym_generator_expression] = STATE(1536),
    [sym_parenthesized_expression] = STATE(1536),
    [sym_concatenated_string] = STATE(1536),
    [sym_string] = STATE(1234),
    [sym_await] = STATE(1536),
    [sym_identifier] = ACTIONS(404),
    [anon_sym_DOT] = ACTIONS(363),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_COMMA] = ACTIONS(400),
    [anon_sym_STAR] = ACTIONS(494),
    [anon_sym_print] = ACTIONS(773),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_COLON] = ACTIONS(400),
    [anon_sym_match] = ACTIONS(773),
    [anon_sym_async] = ACTIONS(773),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_exec] = ACTIONS(773),
    [anon_sym_type] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(400),
    [anon_sym_LBRACK] = ACTIONS(496),
    [anon_sym_AT] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_PIPE] = ACTIONS(363),
    [anon_sym_LBRACE] = ACTIONS(391),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_SLASH_SLASH] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(396),
    [anon_sym_PLUS_EQ] = ACTIONS(400),
    [anon_sym_DASH_EQ] = ACTIONS(400),
    [anon_sym_STAR_EQ] = ACTIONS(400),
    [anon_sym_SLASH_EQ] = ACTIONS(400),
    [anon_sym_AT_EQ] = ACTIONS(400),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(400),
    [anon_sym_PERCENT_EQ] = ACTIONS(400),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(400),
    [anon_sym_GT_GT_EQ] = ACTIONS(400),
    [anon_sym_LT_LT_EQ] = ACTIONS(400),
    [anon_sym_AMP_EQ] = ACTIONS(400),
    [anon_sym_CARET_EQ] = ACTIONS(400),
    [anon_sym_PIPE_EQ] = ACTIONS(400),
    [sym_ellipsis] = ACTIONS(402),
    [sym_integer] = ACTIONS(404),
    [sym_float] = ACTIONS(402),
    [anon_sym_await] = ACTIONS(777),
    [sym_true] = ACTIONS(404),
    [sym_false] = ACTIONS(404),
    [sym_none] = ACTIONS(404),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(408),
  },
  [230] = {
    [sym_elif_clause] = STATE(309),
    [aux_sym_if_statement_repeat1] = STATE(230),
    [sym_identifier] = ACTIONS(1038),
    [anon_sym_import] = ACTIONS(1038),
    [anon_sym_from] = ACTIONS(1038),
    [anon_sym_LPAREN] = ACTIONS(1040),
    [anon_sym_STAR] = ACTIONS(1040),
    [anon_sym_print] = ACTIONS(1038),
    [anon_sym_assert] = ACTIONS(1038),
    [anon_sym_return] = ACTIONS(1038),
    [anon_sym_del] = ACTIONS(1038),
    [anon_sym_raise] = ACTIONS(1038),
    [anon_sym_pass] = ACTIONS(1038),
    [anon_sym_break] = ACTIONS(1038),
    [anon_sym_continue] = ACTIONS(1038),
    [anon_sym_if] = ACTIONS(1038),
    [anon_sym_elif] = ACTIONS(1042),
    [anon_sym_else] = ACTIONS(1038),
    [anon_sym_match] = ACTIONS(1038),
    [anon_sym_async] = ACTIONS(1038),
    [anon_sym_for] = ACTIONS(1038),
    [anon_sym_while] = ACTIONS(1038),
    [anon_sym_try] = ACTIONS(1038),
    [anon_sym_with] = ACTIONS(1038),
    [anon_sym_def] = ACTIONS(1038),
    [anon_sym_global] = ACTIONS(1038),
    [anon_sym_nonlocal] = ACTIONS(1038),
    [anon_sym_exec] = ACTIONS(1038),
    [anon_sym_type] = ACTIONS(1038),
    [anon_sym_class] = ACTIONS(1038),
    [anon_sym_LBRACK] = ACTIONS(1040),
    [anon_sym_AT] = ACTIONS(1040),
    [anon_sym_DASH] = ACTIONS(1040),
    [anon_sym_LBRACE] = ACTIONS(1040),
    [anon_sym_PLUS] = ACTIONS(1040),
    [anon_sym_not] = ACTIONS(1038),
    [anon_sym_TILDE] = ACTIONS(1040),
    [anon_sym_lambda] = ACTIONS(1038),
    [anon_sym_yield] = ACTIONS(1038),
    [sym_ellipsis] = ACTIONS(1040),
    [sym_integer] = ACTIONS(1038),
    [sym_float] = ACTIONS(1040),
    [anon_sym_await] = ACTIONS(1038),
    [sym_true] = ACTIONS(1038),
    [sym_false] = ACTIONS(1038),
    [sym_none] = ACTIONS(1038),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1038),
    [anon_sym_container] = ACTIONS(1038),
    [anon_sym_envvars] = ACTIONS(1038),
    [anon_sym_include] = ACTIONS(1038),
    [anon_sym_pepfile] = ACTIONS(1038),
    [anon_sym_pepschema] = ACTIONS(1038),
    [anon_sym_scattergather] = ACTIONS(1038),
    [anon_sym_version] = ACTIONS(1038),
    [anon_sym_wildcard_constraints] = ACTIONS(1038),
    [anon_sym_workdir] = ACTIONS(1038),
    [anon_sym_onerror] = ACTIONS(1038),
    [anon_sym_onstart] = ACTIONS(1038),
    [anon_sym_onsuccess] = ACTIONS(1038),
    [anon_sym_localrules] = ACTIONS(1038),
    [anon_sym_ruleorder] = ACTIONS(1038),
    [anon_sym_rule] = ACTIONS(1038),
    [anon_sym_checkpoint] = ACTIONS(1038),
    [anon_sym_use] = ACTIONS(1038),
    [anon_sym_module] = ACTIONS(1038),
    [sym__dedent] = ACTIONS(1040),
    [sym_string_start] = ACTIONS(1040),
  },
  [231] = {
    [sym_list_splat_pattern] = STATE(1541),
    [sym_primary_expression] = STATE(1298),
    [sym_binary_operator] = STATE(1536),
    [sym_unary_operator] = STATE(1536),
    [sym_attribute] = STATE(1536),
    [sym_subscript] = STATE(1536),
    [sym_call] = STATE(1536),
    [sym_list] = STATE(1536),
    [sym_set] = STATE(1536),
    [sym_tuple] = STATE(1536),
    [sym_dictionary] = STATE(1536),
    [sym_list_comprehension] = STATE(1536),
    [sym_dictionary_comprehension] = STATE(1536),
    [sym_set_comprehension] = STATE(1536),
    [sym_generator_expression] = STATE(1536),
    [sym_parenthesized_expression] = STATE(1536),
    [sym_concatenated_string] = STATE(1536),
    [sym_string] = STATE(1234),
    [sym_await] = STATE(1536),
    [sym_identifier] = ACTIONS(404),
    [anon_sym_DOT] = ACTIONS(768),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_COMMA] = ACTIONS(766),
    [anon_sym_STAR] = ACTIONS(494),
    [anon_sym_print] = ACTIONS(773),
    [anon_sym_GT_GT] = ACTIONS(768),
    [anon_sym_COLON] = ACTIONS(766),
    [anon_sym_match] = ACTIONS(773),
    [anon_sym_async] = ACTIONS(773),
    [anon_sym_STAR_STAR] = ACTIONS(768),
    [anon_sym_exec] = ACTIONS(773),
    [anon_sym_type] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(496),
    [anon_sym_AT] = ACTIONS(768),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_PIPE] = ACTIONS(768),
    [anon_sym_LBRACE] = ACTIONS(391),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_PERCENT] = ACTIONS(768),
    [anon_sym_SLASH_SLASH] = ACTIONS(768),
    [anon_sym_AMP] = ACTIONS(768),
    [anon_sym_CARET] = ACTIONS(768),
    [anon_sym_LT_LT] = ACTIONS(768),
    [anon_sym_TILDE] = ACTIONS(396),
    [anon_sym_PLUS_EQ] = ACTIONS(766),
    [anon_sym_DASH_EQ] = ACTIONS(766),
    [anon_sym_STAR_EQ] = ACTIONS(766),
    [anon_sym_SLASH_EQ] = ACTIONS(766),
    [anon_sym_AT_EQ] = ACTIONS(766),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(766),
    [anon_sym_PERCENT_EQ] = ACTIONS(766),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(766),
    [anon_sym_GT_GT_EQ] = ACTIONS(766),
    [anon_sym_LT_LT_EQ] = ACTIONS(766),
    [anon_sym_AMP_EQ] = ACTIONS(766),
    [anon_sym_CARET_EQ] = ACTIONS(766),
    [anon_sym_PIPE_EQ] = ACTIONS(766),
    [sym_ellipsis] = ACTIONS(402),
    [sym_integer] = ACTIONS(404),
    [sym_float] = ACTIONS(402),
    [anon_sym_await] = ACTIONS(777),
    [sym_true] = ACTIONS(404),
    [sym_false] = ACTIONS(404),
    [sym_none] = ACTIONS(404),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(408),
  },
  [232] = {
    [sym_elif_clause] = STATE(304),
    [aux_sym_if_statement_repeat1] = STATE(232),
    [ts_builtin_sym_end] = ACTIONS(1040),
    [sym_identifier] = ACTIONS(1038),
    [anon_sym_import] = ACTIONS(1038),
    [anon_sym_from] = ACTIONS(1038),
    [anon_sym_LPAREN] = ACTIONS(1040),
    [anon_sym_STAR] = ACTIONS(1040),
    [anon_sym_print] = ACTIONS(1038),
    [anon_sym_assert] = ACTIONS(1038),
    [anon_sym_return] = ACTIONS(1038),
    [anon_sym_del] = ACTIONS(1038),
    [anon_sym_raise] = ACTIONS(1038),
    [anon_sym_pass] = ACTIONS(1038),
    [anon_sym_break] = ACTIONS(1038),
    [anon_sym_continue] = ACTIONS(1038),
    [anon_sym_if] = ACTIONS(1038),
    [anon_sym_elif] = ACTIONS(1045),
    [anon_sym_else] = ACTIONS(1038),
    [anon_sym_match] = ACTIONS(1038),
    [anon_sym_async] = ACTIONS(1038),
    [anon_sym_for] = ACTIONS(1038),
    [anon_sym_while] = ACTIONS(1038),
    [anon_sym_try] = ACTIONS(1038),
    [anon_sym_with] = ACTIONS(1038),
    [anon_sym_def] = ACTIONS(1038),
    [anon_sym_global] = ACTIONS(1038),
    [anon_sym_nonlocal] = ACTIONS(1038),
    [anon_sym_exec] = ACTIONS(1038),
    [anon_sym_type] = ACTIONS(1038),
    [anon_sym_class] = ACTIONS(1038),
    [anon_sym_LBRACK] = ACTIONS(1040),
    [anon_sym_AT] = ACTIONS(1040),
    [anon_sym_DASH] = ACTIONS(1040),
    [anon_sym_LBRACE] = ACTIONS(1040),
    [anon_sym_PLUS] = ACTIONS(1040),
    [anon_sym_not] = ACTIONS(1038),
    [anon_sym_TILDE] = ACTIONS(1040),
    [anon_sym_lambda] = ACTIONS(1038),
    [anon_sym_yield] = ACTIONS(1038),
    [sym_ellipsis] = ACTIONS(1040),
    [sym_integer] = ACTIONS(1038),
    [sym_float] = ACTIONS(1040),
    [anon_sym_await] = ACTIONS(1038),
    [sym_true] = ACTIONS(1038),
    [sym_false] = ACTIONS(1038),
    [sym_none] = ACTIONS(1038),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1038),
    [anon_sym_container] = ACTIONS(1038),
    [anon_sym_envvars] = ACTIONS(1038),
    [anon_sym_include] = ACTIONS(1038),
    [anon_sym_pepfile] = ACTIONS(1038),
    [anon_sym_pepschema] = ACTIONS(1038),
    [anon_sym_scattergather] = ACTIONS(1038),
    [anon_sym_version] = ACTIONS(1038),
    [anon_sym_wildcard_constraints] = ACTIONS(1038),
    [anon_sym_workdir] = ACTIONS(1038),
    [anon_sym_onerror] = ACTIONS(1038),
    [anon_sym_onstart] = ACTIONS(1038),
    [anon_sym_onsuccess] = ACTIONS(1038),
    [anon_sym_localrules] = ACTIONS(1038),
    [anon_sym_ruleorder] = ACTIONS(1038),
    [anon_sym_rule] = ACTIONS(1038),
    [anon_sym_checkpoint] = ACTIONS(1038),
    [anon_sym_use] = ACTIONS(1038),
    [anon_sym_module] = ACTIONS(1038),
    [sym_string_start] = ACTIONS(1040),
  },
  [233] = {
    [sym_list_splat_pattern] = STATE(1761),
    [sym_primary_expression] = STATE(1628),
    [sym_binary_operator] = STATE(1780),
    [sym_unary_operator] = STATE(1780),
    [sym_attribute] = STATE(1780),
    [sym_subscript] = STATE(1780),
    [sym_call] = STATE(1780),
    [sym_list] = STATE(1780),
    [sym_set] = STATE(1780),
    [sym_tuple] = STATE(1780),
    [sym_dictionary] = STATE(1780),
    [sym_list_comprehension] = STATE(1780),
    [sym_dictionary_comprehension] = STATE(1780),
    [sym_set_comprehension] = STATE(1780),
    [sym_generator_expression] = STATE(1780),
    [sym_parenthesized_expression] = STATE(1780),
    [sym_concatenated_string] = STATE(1780),
    [sym_string] = STATE(1488),
    [sym_await] = STATE(1780),
    [sym_identifier] = ACTIONS(942),
    [anon_sym_DOT] = ACTIONS(363),
    [anon_sym_LPAREN] = ACTIONS(944),
    [anon_sym_COMMA] = ACTIONS(361),
    [anon_sym_as] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(946),
    [anon_sym_print] = ACTIONS(948),
    [anon_sym_GT_GT] = ACTIONS(361),
    [anon_sym_if] = ACTIONS(363),
    [anon_sym_match] = ACTIONS(948),
    [anon_sym_async] = ACTIONS(948),
    [anon_sym_in] = ACTIONS(363),
    [anon_sym_STAR_STAR] = ACTIONS(361),
    [anon_sym_exec] = ACTIONS(948),
    [anon_sym_type] = ACTIONS(950),
    [anon_sym_LBRACK] = ACTIONS(954),
    [anon_sym_AT] = ACTIONS(361),
    [anon_sym_DASH] = ACTIONS(956),
    [anon_sym_PIPE] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(958),
    [anon_sym_PLUS] = ACTIONS(956),
    [anon_sym_not] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(363),
    [anon_sym_or] = ACTIONS(363),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(361),
    [anon_sym_SLASH_SLASH] = ACTIONS(361),
    [anon_sym_AMP] = ACTIONS(361),
    [anon_sym_CARET] = ACTIONS(361),
    [anon_sym_LT_LT] = ACTIONS(361),
    [anon_sym_TILDE] = ACTIONS(956),
    [anon_sym_LT] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(361),
    [anon_sym_EQ_EQ] = ACTIONS(361),
    [anon_sym_BANG_EQ] = ACTIONS(361),
    [anon_sym_GT_EQ] = ACTIONS(361),
    [anon_sym_GT] = ACTIONS(363),
    [anon_sym_LT_GT] = ACTIONS(361),
    [anon_sym_is] = ACTIONS(363),
    [sym_ellipsis] = ACTIONS(960),
    [sym_integer] = ACTIONS(942),
    [sym_float] = ACTIONS(960),
    [anon_sym_await] = ACTIONS(962),
    [sym_true] = ACTIONS(942),
    [sym_false] = ACTIONS(942),
    [sym_none] = ACTIONS(942),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(361),
    [sym_string_start] = ACTIONS(964),
  },
  [234] = {
    [sym_list_splat_pattern] = STATE(1541),
    [sym_primary_expression] = STATE(1298),
    [sym_binary_operator] = STATE(1536),
    [sym_unary_operator] = STATE(1536),
    [sym_attribute] = STATE(1536),
    [sym_subscript] = STATE(1536),
    [sym_call] = STATE(1536),
    [sym_list] = STATE(1536),
    [sym_set] = STATE(1536),
    [sym_tuple] = STATE(1536),
    [sym_dictionary] = STATE(1536),
    [sym_list_comprehension] = STATE(1536),
    [sym_dictionary_comprehension] = STATE(1536),
    [sym_set_comprehension] = STATE(1536),
    [sym_generator_expression] = STATE(1536),
    [sym_parenthesized_expression] = STATE(1536),
    [sym_concatenated_string] = STATE(1536),
    [sym_string] = STATE(1234),
    [sym_await] = STATE(1536),
    [sym_identifier] = ACTIONS(404),
    [anon_sym_DOT] = ACTIONS(768),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_COMMA] = ACTIONS(766),
    [anon_sym_as] = ACTIONS(771),
    [anon_sym_STAR] = ACTIONS(494),
    [anon_sym_print] = ACTIONS(773),
    [anon_sym_GT_GT] = ACTIONS(801),
    [anon_sym_if] = ACTIONS(771),
    [anon_sym_match] = ACTIONS(773),
    [anon_sym_async] = ACTIONS(773),
    [anon_sym_in] = ACTIONS(771),
    [anon_sym_STAR_STAR] = ACTIONS(801),
    [anon_sym_exec] = ACTIONS(773),
    [anon_sym_type] = ACTIONS(775),
    [anon_sym_LBRACK] = ACTIONS(496),
    [anon_sym_AT] = ACTIONS(801),
    [anon_sym_DASH] = ACTIONS(396),
    [anon_sym_PIPE] = ACTIONS(801),
    [anon_sym_LBRACE] = ACTIONS(391),
    [anon_sym_PLUS] = ACTIONS(396),
    [anon_sym_not] = ACTIONS(771),
    [anon_sym_and] = ACTIONS(771),
    [anon_sym_or] = ACTIONS(771),
    [anon_sym_SLASH] = ACTIONS(768),
    [anon_sym_PERCENT] = ACTIONS(801),
    [anon_sym_SLASH_SLASH] = ACTIONS(801),
    [anon_sym_AMP] = ACTIONS(801),
    [anon_sym_CARET] = ACTIONS(801),
    [anon_sym_LT_LT] = ACTIONS(801),
    [anon_sym_TILDE] = ACTIONS(396),
    [anon_sym_LT] = ACTIONS(771),
    [anon_sym_LT_EQ] = ACTIONS(766),
    [anon_sym_EQ_EQ] = ACTIONS(766),
    [anon_sym_BANG_EQ] = ACTIONS(766),
    [anon_sym_GT_EQ] = ACTIONS(766),
    [anon_sym_GT] = ACTIONS(771),
    [anon_sym_LT_GT] = ACTIONS(766),
    [anon_sym_is] = ACTIONS(771),
    [sym_ellipsis] = ACTIONS(402),
    [sym_integer] = ACTIONS(404),
    [sym_float] = ACTIONS(402),
    [anon_sym_await] = ACTIONS(777),
    [sym_true] = ACTIONS(404),
    [sym_false] = ACTIONS(404),
    [sym_none] = ACTIONS(404),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(766),
    [sym_string_start] = ACTIONS(408),
  },
  [235] = {
    [ts_builtin_sym_end] = ACTIONS(1048),
    [sym_identifier] = ACTIONS(1050),
    [anon_sym_import] = ACTIONS(1050),
    [anon_sym_from] = ACTIONS(1050),
    [anon_sym_LPAREN] = ACTIONS(1048),
    [anon_sym_STAR] = ACTIONS(1048),
    [anon_sym_print] = ACTIONS(1050),
    [anon_sym_assert] = ACTIONS(1050),
    [anon_sym_return] = ACTIONS(1050),
    [anon_sym_del] = ACTIONS(1050),
    [anon_sym_raise] = ACTIONS(1050),
    [anon_sym_pass] = ACTIONS(1050),
    [anon_sym_break] = ACTIONS(1050),
    [anon_sym_continue] = ACTIONS(1050),
    [anon_sym_if] = ACTIONS(1050),
    [anon_sym_else] = ACTIONS(1050),
    [anon_sym_match] = ACTIONS(1050),
    [anon_sym_async] = ACTIONS(1050),
    [anon_sym_for] = ACTIONS(1050),
    [anon_sym_while] = ACTIONS(1050),
    [anon_sym_try] = ACTIONS(1050),
    [anon_sym_except] = ACTIONS(1050),
    [anon_sym_finally] = ACTIONS(1050),
    [anon_sym_with] = ACTIONS(1050),
    [anon_sym_def] = ACTIONS(1050),
    [anon_sym_global] = ACTIONS(1050),
    [anon_sym_nonlocal] = ACTIONS(1050),
    [anon_sym_exec] = ACTIONS(1050),
    [anon_sym_type] = ACTIONS(1050),
    [anon_sym_class] = ACTIONS(1050),
    [anon_sym_LBRACK] = ACTIONS(1048),
    [anon_sym_AT] = ACTIONS(1048),
    [anon_sym_DASH] = ACTIONS(1048),
    [anon_sym_LBRACE] = ACTIONS(1048),
    [anon_sym_PLUS] = ACTIONS(1048),
    [anon_sym_not] = ACTIONS(1050),
    [anon_sym_TILDE] = ACTIONS(1048),
    [anon_sym_lambda] = ACTIONS(1050),
    [anon_sym_yield] = ACTIONS(1050),
    [sym_ellipsis] = ACTIONS(1048),
    [sym_integer] = ACTIONS(1050),
    [sym_float] = ACTIONS(1048),
    [anon_sym_await] = ACTIONS(1050),
    [sym_true] = ACTIONS(1050),
    [sym_false] = ACTIONS(1050),
    [sym_none] = ACTIONS(1050),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1050),
    [anon_sym_container] = ACTIONS(1050),
    [anon_sym_envvars] = ACTIONS(1050),
    [anon_sym_include] = ACTIONS(1050),
    [anon_sym_pepfile] = ACTIONS(1050),
    [anon_sym_pepschema] = ACTIONS(1050),
    [anon_sym_scattergather] = ACTIONS(1050),
    [anon_sym_version] = ACTIONS(1050),
    [anon_sym_wildcard_constraints] = ACTIONS(1050),
    [anon_sym_workdir] = ACTIONS(1050),
    [anon_sym_onerror] = ACTIONS(1050),
    [anon_sym_onstart] = ACTIONS(1050),
    [anon_sym_onsuccess] = ACTIONS(1050),
    [anon_sym_localrules] = ACTIONS(1050),
    [anon_sym_ruleorder] = ACTIONS(1050),
    [anon_sym_rule] = ACTIONS(1050),
    [anon_sym_checkpoint] = ACTIONS(1050),
    [anon_sym_use] = ACTIONS(1050),
    [anon_sym_module] = ACTIONS(1050),
    [sym_string_start] = ACTIONS(1048),
  },
  [236] = {
    [ts_builtin_sym_end] = ACTIONS(1052),
    [sym_identifier] = ACTIONS(1054),
    [anon_sym_import] = ACTIONS(1054),
    [anon_sym_from] = ACTIONS(1054),
    [anon_sym_LPAREN] = ACTIONS(1052),
    [anon_sym_STAR] = ACTIONS(1052),
    [anon_sym_print] = ACTIONS(1054),
    [anon_sym_assert] = ACTIONS(1054),
    [anon_sym_return] = ACTIONS(1054),
    [anon_sym_del] = ACTIONS(1054),
    [anon_sym_raise] = ACTIONS(1054),
    [anon_sym_pass] = ACTIONS(1054),
    [anon_sym_break] = ACTIONS(1054),
    [anon_sym_continue] = ACTIONS(1054),
    [anon_sym_if] = ACTIONS(1054),
    [anon_sym_else] = ACTIONS(1054),
    [anon_sym_match] = ACTIONS(1054),
    [anon_sym_async] = ACTIONS(1054),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_while] = ACTIONS(1054),
    [anon_sym_try] = ACTIONS(1054),
    [anon_sym_except_STAR] = ACTIONS(1052),
    [anon_sym_finally] = ACTIONS(1054),
    [anon_sym_with] = ACTIONS(1054),
    [anon_sym_def] = ACTIONS(1054),
    [anon_sym_global] = ACTIONS(1054),
    [anon_sym_nonlocal] = ACTIONS(1054),
    [anon_sym_exec] = ACTIONS(1054),
    [anon_sym_type] = ACTIONS(1054),
    [anon_sym_class] = ACTIONS(1054),
    [anon_sym_LBRACK] = ACTIONS(1052),
    [anon_sym_AT] = ACTIONS(1052),
    [anon_sym_DASH] = ACTIONS(1052),
    [anon_sym_LBRACE] = ACTIONS(1052),
    [anon_sym_PLUS] = ACTIONS(1052),
    [anon_sym_not] = ACTIONS(1054),
    [anon_sym_TILDE] = ACTIONS(1052),
    [anon_sym_lambda] = ACTIONS(1054),
    [anon_sym_yield] = ACTIONS(1054),
    [sym_ellipsis] = ACTIONS(1052),
    [sym_integer] = ACTIONS(1054),
    [sym_float] = ACTIONS(1052),
    [anon_sym_await] = ACTIONS(1054),
    [sym_true] = ACTIONS(1054),
    [sym_false] = ACTIONS(1054),
    [sym_none] = ACTIONS(1054),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1054),
    [anon_sym_container] = ACTIONS(1054),
    [anon_sym_envvars] = ACTIONS(1054),
    [anon_sym_include] = ACTIONS(1054),
    [anon_sym_pepfile] = ACTIONS(1054),
    [anon_sym_pepschema] = ACTIONS(1054),
    [anon_sym_scattergather] = ACTIONS(1054),
    [anon_sym_version] = ACTIONS(1054),
    [anon_sym_wildcard_constraints] = ACTIONS(1054),
    [anon_sym_workdir] = ACTIONS(1054),
    [anon_sym_onerror] = ACTIONS(1054),
    [anon_sym_onstart] = ACTIONS(1054),
    [anon_sym_onsuccess] = ACTIONS(1054),
    [anon_sym_localrules] = ACTIONS(1054),
    [anon_sym_ruleorder] = ACTIONS(1054),
    [anon_sym_rule] = ACTIONS(1054),
    [anon_sym_checkpoint] = ACTIONS(1054),
    [anon_sym_use] = ACTIONS(1054),
    [anon_sym_module] = ACTIONS(1054),
    [sym_string_start] = ACTIONS(1052),
  },
  [237] = {
    [sym_identifier] = ACTIONS(1056),
    [anon_sym_import] = ACTIONS(1056),
    [anon_sym_from] = ACTIONS(1056),
    [anon_sym_LPAREN] = ACTIONS(1058),
    [anon_sym_STAR] = ACTIONS(1058),
    [anon_sym_print] = ACTIONS(1056),
    [anon_sym_assert] = ACTIONS(1056),
    [anon_sym_return] = ACTIONS(1056),
    [anon_sym_del] = ACTIONS(1056),
    [anon_sym_raise] = ACTIONS(1056),
    [anon_sym_pass] = ACTIONS(1056),
    [anon_sym_break] = ACTIONS(1056),
    [anon_sym_continue] = ACTIONS(1056),
    [anon_sym_if] = ACTIONS(1056),
    [anon_sym_else] = ACTIONS(1056),
    [anon_sym_match] = ACTIONS(1056),
    [anon_sym_async] = ACTIONS(1056),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1056),
    [anon_sym_try] = ACTIONS(1056),
    [anon_sym_except_STAR] = ACTIONS(1058),
    [anon_sym_finally] = ACTIONS(1056),
    [anon_sym_with] = ACTIONS(1056),
    [anon_sym_def] = ACTIONS(1056),
    [anon_sym_global] = ACTIONS(1056),
    [anon_sym_nonlocal] = ACTIONS(1056),
    [anon_sym_exec] = ACTIONS(1056),
    [anon_sym_type] = ACTIONS(1056),
    [anon_sym_class] = ACTIONS(1056),
    [anon_sym_LBRACK] = ACTIONS(1058),
    [anon_sym_AT] = ACTIONS(1058),
    [anon_sym_DASH] = ACTIONS(1058),
    [anon_sym_LBRACE] = ACTIONS(1058),
    [anon_sym_PLUS] = ACTIONS(1058),
    [anon_sym_not] = ACTIONS(1056),
    [anon_sym_TILDE] = ACTIONS(1058),
    [anon_sym_lambda] = ACTIONS(1056),
    [anon_sym_yield] = ACTIONS(1056),
    [sym_ellipsis] = ACTIONS(1058),
    [sym_integer] = ACTIONS(1056),
    [sym_float] = ACTIONS(1058),
    [anon_sym_await] = ACTIONS(1056),
    [sym_true] = ACTIONS(1056),
    [sym_false] = ACTIONS(1056),
    [sym_none] = ACTIONS(1056),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1056),
    [anon_sym_container] = ACTIONS(1056),
    [anon_sym_envvars] = ACTIONS(1056),
    [anon_sym_include] = ACTIONS(1056),
    [anon_sym_pepfile] = ACTIONS(1056),
    [anon_sym_pepschema] = ACTIONS(1056),
    [anon_sym_scattergather] = ACTIONS(1056),
    [anon_sym_version] = ACTIONS(1056),
    [anon_sym_wildcard_constraints] = ACTIONS(1056),
    [anon_sym_workdir] = ACTIONS(1056),
    [anon_sym_onerror] = ACTIONS(1056),
    [anon_sym_onstart] = ACTIONS(1056),
    [anon_sym_onsuccess] = ACTIONS(1056),
    [anon_sym_localrules] = ACTIONS(1056),
    [anon_sym_ruleorder] = ACTIONS(1056),
    [anon_sym_rule] = ACTIONS(1056),
    [anon_sym_checkpoint] = ACTIONS(1056),
    [anon_sym_use] = ACTIONS(1056),
    [anon_sym_module] = ACTIONS(1056),
    [sym__dedent] = ACTIONS(1058),
    [sym_string_start] = ACTIONS(1058),
  },
  [238] = {
    [sym_identifier] = ACTIONS(1060),
    [anon_sym_import] = ACTIONS(1060),
    [anon_sym_from] = ACTIONS(1060),
    [anon_sym_LPAREN] = ACTIONS(1062),
    [anon_sym_STAR] = ACTIONS(1062),
    [anon_sym_print] = ACTIONS(1060),
    [anon_sym_assert] = ACTIONS(1060),
    [anon_sym_return] = ACTIONS(1060),
    [anon_sym_del] = ACTIONS(1060),
    [anon_sym_raise] = ACTIONS(1060),
    [anon_sym_pass] = ACTIONS(1060),
    [anon_sym_break] = ACTIONS(1060),
    [anon_sym_continue] = ACTIONS(1060),
    [anon_sym_if] = ACTIONS(1060),
    [anon_sym_else] = ACTIONS(1060),
    [anon_sym_match] = ACTIONS(1060),
    [anon_sym_async] = ACTIONS(1060),
    [anon_sym_for] = ACTIONS(1060),
    [anon_sym_while] = ACTIONS(1060),
    [anon_sym_try] = ACTIONS(1060),
    [anon_sym_except_STAR] = ACTIONS(1062),
    [anon_sym_finally] = ACTIONS(1060),
    [anon_sym_with] = ACTIONS(1060),
    [anon_sym_def] = ACTIONS(1060),
    [anon_sym_global] = ACTIONS(1060),
    [anon_sym_nonlocal] = ACTIONS(1060),
    [anon_sym_exec] = ACTIONS(1060),
    [anon_sym_type] = ACTIONS(1060),
    [anon_sym_class] = ACTIONS(1060),
    [anon_sym_LBRACK] = ACTIONS(1062),
    [anon_sym_AT] = ACTIONS(1062),
    [anon_sym_DASH] = ACTIONS(1062),
    [anon_sym_LBRACE] = ACTIONS(1062),
    [anon_sym_PLUS] = ACTIONS(1062),
    [anon_sym_not] = ACTIONS(1060),
    [anon_sym_TILDE] = ACTIONS(1062),
    [anon_sym_lambda] = ACTIONS(1060),
    [anon_sym_yield] = ACTIONS(1060),
    [sym_ellipsis] = ACTIONS(1062),
    [sym_integer] = ACTIONS(1060),
    [sym_float] = ACTIONS(1062),
    [anon_sym_await] = ACTIONS(1060),
    [sym_true] = ACTIONS(1060),
    [sym_false] = ACTIONS(1060),
    [sym_none] = ACTIONS(1060),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1060),
    [anon_sym_container] = ACTIONS(1060),
    [anon_sym_envvars] = ACTIONS(1060),
    [anon_sym_include] = ACTIONS(1060),
    [anon_sym_pepfile] = ACTIONS(1060),
    [anon_sym_pepschema] = ACTIONS(1060),
    [anon_sym_scattergather] = ACTIONS(1060),
    [anon_sym_version] = ACTIONS(1060),
    [anon_sym_wildcard_constraints] = ACTIONS(1060),
    [anon_sym_workdir] = ACTIONS(1060),
    [anon_sym_onerror] = ACTIONS(1060),
    [anon_sym_onstart] = ACTIONS(1060),
    [anon_sym_onsuccess] = ACTIONS(1060),
    [anon_sym_localrules] = ACTIONS(1060),
    [anon_sym_ruleorder] = ACTIONS(1060),
    [anon_sym_rule] = ACTIONS(1060),
    [anon_sym_checkpoint] = ACTIONS(1060),
    [anon_sym_use] = ACTIONS(1060),
    [anon_sym_module] = ACTIONS(1060),
    [sym__dedent] = ACTIONS(1062),
    [sym_string_start] = ACTIONS(1062),
  },
  [239] = {
    [ts_builtin_sym_end] = ACTIONS(1062),
    [sym_identifier] = ACTIONS(1060),
    [anon_sym_import] = ACTIONS(1060),
    [anon_sym_from] = ACTIONS(1060),
    [anon_sym_LPAREN] = ACTIONS(1062),
    [anon_sym_STAR] = ACTIONS(1062),
    [anon_sym_print] = ACTIONS(1060),
    [anon_sym_assert] = ACTIONS(1060),
    [anon_sym_return] = ACTIONS(1060),
    [anon_sym_del] = ACTIONS(1060),
    [anon_sym_raise] = ACTIONS(1060),
    [anon_sym_pass] = ACTIONS(1060),
    [anon_sym_break] = ACTIONS(1060),
    [anon_sym_continue] = ACTIONS(1060),
    [anon_sym_if] = ACTIONS(1060),
    [anon_sym_elif] = ACTIONS(1060),
    [anon_sym_else] = ACTIONS(1060),
    [anon_sym_match] = ACTIONS(1060),
    [anon_sym_async] = ACTIONS(1060),
    [anon_sym_for] = ACTIONS(1060),
    [anon_sym_while] = ACTIONS(1060),
    [anon_sym_try] = ACTIONS(1060),
    [anon_sym_finally] = ACTIONS(1060),
    [anon_sym_with] = ACTIONS(1060),
    [anon_sym_def] = ACTIONS(1060),
    [anon_sym_global] = ACTIONS(1060),
    [anon_sym_nonlocal] = ACTIONS(1060),
    [anon_sym_exec] = ACTIONS(1060),
    [anon_sym_type] = ACTIONS(1060),
    [anon_sym_class] = ACTIONS(1060),
    [anon_sym_LBRACK] = ACTIONS(1062),
    [anon_sym_AT] = ACTIONS(1062),
    [anon_sym_DASH] = ACTIONS(1062),
    [anon_sym_LBRACE] = ACTIONS(1062),
    [anon_sym_PLUS] = ACTIONS(1062),
    [anon_sym_not] = ACTIONS(1060),
    [anon_sym_TILDE] = ACTIONS(1062),
    [anon_sym_lambda] = ACTIONS(1060),
    [anon_sym_yield] = ACTIONS(1060),
    [sym_ellipsis] = ACTIONS(1062),
    [sym_integer] = ACTIONS(1060),
    [sym_float] = ACTIONS(1062),
    [anon_sym_await] = ACTIONS(1060),
    [sym_true] = ACTIONS(1060),
    [sym_false] = ACTIONS(1060),
    [sym_none] = ACTIONS(1060),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1060),
    [anon_sym_container] = ACTIONS(1060),
    [anon_sym_envvars] = ACTIONS(1060),
    [anon_sym_include] = ACTIONS(1060),
    [anon_sym_pepfile] = ACTIONS(1060),
    [anon_sym_pepschema] = ACTIONS(1060),
    [anon_sym_scattergather] = ACTIONS(1060),
    [anon_sym_version] = ACTIONS(1060),
    [anon_sym_wildcard_constraints] = ACTIONS(1060),
    [anon_sym_workdir] = ACTIONS(1060),
    [anon_sym_onerror] = ACTIONS(1060),
    [anon_sym_onstart] = ACTIONS(1060),
    [anon_sym_onsuccess] = ACTIONS(1060),
    [anon_sym_localrules] = ACTIONS(1060),
    [anon_sym_ruleorder] = ACTIONS(1060),
    [anon_sym_rule] = ACTIONS(1060),
    [anon_sym_checkpoint] = ACTIONS(1060),
    [anon_sym_use] = ACTIONS(1060),
    [anon_sym_module] = ACTIONS(1060),
    [sym_string_start] = ACTIONS(1062),
  },
  [240] = {
    [sym_identifier] = ACTIONS(1064),
    [anon_sym_import] = ACTIONS(1064),
    [anon_sym_from] = ACTIONS(1064),
    [anon_sym_LPAREN] = ACTIONS(1066),
    [anon_sym_STAR] = ACTIONS(1066),
    [anon_sym_print] = ACTIONS(1064),
    [anon_sym_assert] = ACTIONS(1064),
    [anon_sym_return] = ACTIONS(1064),
    [anon_sym_del] = ACTIONS(1064),
    [anon_sym_raise] = ACTIONS(1064),
    [anon_sym_pass] = ACTIONS(1064),
    [anon_sym_break] = ACTIONS(1064),
    [anon_sym_continue] = ACTIONS(1064),
    [anon_sym_if] = ACTIONS(1064),
    [anon_sym_else] = ACTIONS(1064),
    [anon_sym_match] = ACTIONS(1064),
    [anon_sym_async] = ACTIONS(1064),
    [anon_sym_for] = ACTIONS(1064),
    [anon_sym_while] = ACTIONS(1064),
    [anon_sym_try] = ACTIONS(1064),
    [anon_sym_except_STAR] = ACTIONS(1066),
    [anon_sym_finally] = ACTIONS(1064),
    [anon_sym_with] = ACTIONS(1064),
    [anon_sym_def] = ACTIONS(1064),
    [anon_sym_global] = ACTIONS(1064),
    [anon_sym_nonlocal] = ACTIONS(1064),
    [anon_sym_exec] = ACTIONS(1064),
    [anon_sym_type] = ACTIONS(1064),
    [anon_sym_class] = ACTIONS(1064),
    [anon_sym_LBRACK] = ACTIONS(1066),
    [anon_sym_AT] = ACTIONS(1066),
    [anon_sym_DASH] = ACTIONS(1066),
    [anon_sym_LBRACE] = ACTIONS(1066),
    [anon_sym_PLUS] = ACTIONS(1066),
    [anon_sym_not] = ACTIONS(1064),
    [anon_sym_TILDE] = ACTIONS(1066),
    [anon_sym_lambda] = ACTIONS(1064),
    [anon_sym_yield] = ACTIONS(1064),
    [sym_ellipsis] = ACTIONS(1066),
    [sym_integer] = ACTIONS(1064),
    [sym_float] = ACTIONS(1066),
    [anon_sym_await] = ACTIONS(1064),
    [sym_true] = ACTIONS(1064),
    [sym_false] = ACTIONS(1064),
    [sym_none] = ACTIONS(1064),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1064),
    [anon_sym_container] = ACTIONS(1064),
    [anon_sym_envvars] = ACTIONS(1064),
    [anon_sym_include] = ACTIONS(1064),
    [anon_sym_pepfile] = ACTIONS(1064),
    [anon_sym_pepschema] = ACTIONS(1064),
    [anon_sym_scattergather] = ACTIONS(1064),
    [anon_sym_version] = ACTIONS(1064),
    [anon_sym_wildcard_constraints] = ACTIONS(1064),
    [anon_sym_workdir] = ACTIONS(1064),
    [anon_sym_onerror] = ACTIONS(1064),
    [anon_sym_onstart] = ACTIONS(1064),
    [anon_sym_onsuccess] = ACTIONS(1064),
    [anon_sym_localrules] = ACTIONS(1064),
    [anon_sym_ruleorder] = ACTIONS(1064),
    [anon_sym_rule] = ACTIONS(1064),
    [anon_sym_checkpoint] = ACTIONS(1064),
    [anon_sym_use] = ACTIONS(1064),
    [anon_sym_module] = ACTIONS(1064),
    [sym__dedent] = ACTIONS(1066),
    [sym_string_start] = ACTIONS(1066),
  },
  [241] = {
    [sym_identifier] = ACTIONS(1068),
    [anon_sym_import] = ACTIONS(1068),
    [anon_sym_from] = ACTIONS(1068),
    [anon_sym_LPAREN] = ACTIONS(1070),
    [anon_sym_STAR] = ACTIONS(1070),
    [anon_sym_print] = ACTIONS(1068),
    [anon_sym_assert] = ACTIONS(1068),
    [anon_sym_return] = ACTIONS(1068),
    [anon_sym_del] = ACTIONS(1068),
    [anon_sym_raise] = ACTIONS(1068),
    [anon_sym_pass] = ACTIONS(1068),
    [anon_sym_break] = ACTIONS(1068),
    [anon_sym_continue] = ACTIONS(1068),
    [anon_sym_if] = ACTIONS(1068),
    [anon_sym_else] = ACTIONS(1068),
    [anon_sym_match] = ACTIONS(1068),
    [anon_sym_async] = ACTIONS(1068),
    [anon_sym_for] = ACTIONS(1068),
    [anon_sym_while] = ACTIONS(1068),
    [anon_sym_try] = ACTIONS(1068),
    [anon_sym_except_STAR] = ACTIONS(1070),
    [anon_sym_finally] = ACTIONS(1068),
    [anon_sym_with] = ACTIONS(1068),
    [anon_sym_def] = ACTIONS(1068),
    [anon_sym_global] = ACTIONS(1068),
    [anon_sym_nonlocal] = ACTIONS(1068),
    [anon_sym_exec] = ACTIONS(1068),
    [anon_sym_type] = ACTIONS(1068),
    [anon_sym_class] = ACTIONS(1068),
    [anon_sym_LBRACK] = ACTIONS(1070),
    [anon_sym_AT] = ACTIONS(1070),
    [anon_sym_DASH] = ACTIONS(1070),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_PLUS] = ACTIONS(1070),
    [anon_sym_not] = ACTIONS(1068),
    [anon_sym_TILDE] = ACTIONS(1070),
    [anon_sym_lambda] = ACTIONS(1068),
    [anon_sym_yield] = ACTIONS(1068),
    [sym_ellipsis] = ACTIONS(1070),
    [sym_integer] = ACTIONS(1068),
    [sym_float] = ACTIONS(1070),
    [anon_sym_await] = ACTIONS(1068),
    [sym_true] = ACTIONS(1068),
    [sym_false] = ACTIONS(1068),
    [sym_none] = ACTIONS(1068),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1068),
    [anon_sym_container] = ACTIONS(1068),
    [anon_sym_envvars] = ACTIONS(1068),
    [anon_sym_include] = ACTIONS(1068),
    [anon_sym_pepfile] = ACTIONS(1068),
    [anon_sym_pepschema] = ACTIONS(1068),
    [anon_sym_scattergather] = ACTIONS(1068),
    [anon_sym_version] = ACTIONS(1068),
    [anon_sym_wildcard_constraints] = ACTIONS(1068),
    [anon_sym_workdir] = ACTIONS(1068),
    [anon_sym_onerror] = ACTIONS(1068),
    [anon_sym_onstart] = ACTIONS(1068),
    [anon_sym_onsuccess] = ACTIONS(1068),
    [anon_sym_localrules] = ACTIONS(1068),
    [anon_sym_ruleorder] = ACTIONS(1068),
    [anon_sym_rule] = ACTIONS(1068),
    [anon_sym_checkpoint] = ACTIONS(1068),
    [anon_sym_use] = ACTIONS(1068),
    [anon_sym_module] = ACTIONS(1068),
    [sym__dedent] = ACTIONS(1070),
    [sym_string_start] = ACTIONS(1070),
  },
  [242] = {
    [sym_identifier] = ACTIONS(1072),
    [anon_sym_import] = ACTIONS(1072),
    [anon_sym_from] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1074),
    [anon_sym_STAR] = ACTIONS(1074),
    [anon_sym_print] = ACTIONS(1072),
    [anon_sym_assert] = ACTIONS(1072),
    [anon_sym_return] = ACTIONS(1072),
    [anon_sym_del] = ACTIONS(1072),
    [anon_sym_raise] = ACTIONS(1072),
    [anon_sym_pass] = ACTIONS(1072),
    [anon_sym_break] = ACTIONS(1072),
    [anon_sym_continue] = ACTIONS(1072),
    [anon_sym_if] = ACTIONS(1072),
    [anon_sym_else] = ACTIONS(1072),
    [anon_sym_match] = ACTIONS(1072),
    [anon_sym_async] = ACTIONS(1072),
    [anon_sym_for] = ACTIONS(1072),
    [anon_sym_while] = ACTIONS(1072),
    [anon_sym_try] = ACTIONS(1072),
    [anon_sym_except] = ACTIONS(1072),
    [anon_sym_finally] = ACTIONS(1072),
    [anon_sym_with] = ACTIONS(1072),
    [anon_sym_def] = ACTIONS(1072),
    [anon_sym_global] = ACTIONS(1072),
    [anon_sym_nonlocal] = ACTIONS(1072),
    [anon_sym_exec] = ACTIONS(1072),
    [anon_sym_type] = ACTIONS(1072),
    [anon_sym_class] = ACTIONS(1072),
    [anon_sym_LBRACK] = ACTIONS(1074),
    [anon_sym_AT] = ACTIONS(1074),
    [anon_sym_DASH] = ACTIONS(1074),
    [anon_sym_LBRACE] = ACTIONS(1074),
    [anon_sym_PLUS] = ACTIONS(1074),
    [anon_sym_not] = ACTIONS(1072),
    [anon_sym_TILDE] = ACTIONS(1074),
    [anon_sym_lambda] = ACTIONS(1072),
    [anon_sym_yield] = ACTIONS(1072),
    [sym_ellipsis] = ACTIONS(1074),
    [sym_integer] = ACTIONS(1072),
    [sym_float] = ACTIONS(1074),
    [anon_sym_await] = ACTIONS(1072),
    [sym_true] = ACTIONS(1072),
    [sym_false] = ACTIONS(1072),
    [sym_none] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1072),
    [anon_sym_container] = ACTIONS(1072),
    [anon_sym_envvars] = ACTIONS(1072),
    [anon_sym_include] = ACTIONS(1072),
    [anon_sym_pepfile] = ACTIONS(1072),
    [anon_sym_pepschema] = ACTIONS(1072),
    [anon_sym_scattergather] = ACTIONS(1072),
    [anon_sym_version] = ACTIONS(1072),
    [anon_sym_wildcard_constraints] = ACTIONS(1072),
    [anon_sym_workdir] = ACTIONS(1072),
    [anon_sym_onerror] = ACTIONS(1072),
    [anon_sym_onstart] = ACTIONS(1072),
    [anon_sym_onsuccess] = ACTIONS(1072),
    [anon_sym_localrules] = ACTIONS(1072),
    [anon_sym_ruleorder] = ACTIONS(1072),
    [anon_sym_rule] = ACTIONS(1072),
    [anon_sym_checkpoint] = ACTIONS(1072),
    [anon_sym_use] = ACTIONS(1072),
    [anon_sym_module] = ACTIONS(1072),
    [sym__dedent] = ACTIONS(1074),
    [sym_string_start] = ACTIONS(1074),
  },
  [243] = {
    [sym_identifier] = ACTIONS(1050),
    [anon_sym_import] = ACTIONS(1050),
    [anon_sym_from] = ACTIONS(1050),
    [anon_sym_LPAREN] = ACTIONS(1048),
    [anon_sym_STAR] = ACTIONS(1048),
    [anon_sym_print] = ACTIONS(1050),
    [anon_sym_assert] = ACTIONS(1050),
    [anon_sym_return] = ACTIONS(1050),
    [anon_sym_del] = ACTIONS(1050),
    [anon_sym_raise] = ACTIONS(1050),
    [anon_sym_pass] = ACTIONS(1050),
    [anon_sym_break] = ACTIONS(1050),
    [anon_sym_continue] = ACTIONS(1050),
    [anon_sym_if] = ACTIONS(1050),
    [anon_sym_else] = ACTIONS(1050),
    [anon_sym_match] = ACTIONS(1050),
    [anon_sym_async] = ACTIONS(1050),
    [anon_sym_for] = ACTIONS(1050),
    [anon_sym_while] = ACTIONS(1050),
    [anon_sym_try] = ACTIONS(1050),
    [anon_sym_except] = ACTIONS(1050),
    [anon_sym_finally] = ACTIONS(1050),
    [anon_sym_with] = ACTIONS(1050),
    [anon_sym_def] = ACTIONS(1050),
    [anon_sym_global] = ACTIONS(1050),
    [anon_sym_nonlocal] = ACTIONS(1050),
    [anon_sym_exec] = ACTIONS(1050),
    [anon_sym_type] = ACTIONS(1050),
    [anon_sym_class] = ACTIONS(1050),
    [anon_sym_LBRACK] = ACTIONS(1048),
    [anon_sym_AT] = ACTIONS(1048),
    [anon_sym_DASH] = ACTIONS(1048),
    [anon_sym_LBRACE] = ACTIONS(1048),
    [anon_sym_PLUS] = ACTIONS(1048),
    [anon_sym_not] = ACTIONS(1050),
    [anon_sym_TILDE] = ACTIONS(1048),
    [anon_sym_lambda] = ACTIONS(1050),
    [anon_sym_yield] = ACTIONS(1050),
    [sym_ellipsis] = ACTIONS(1048),
    [sym_integer] = ACTIONS(1050),
    [sym_float] = ACTIONS(1048),
    [anon_sym_await] = ACTIONS(1050),
    [sym_true] = ACTIONS(1050),
    [sym_false] = ACTIONS(1050),
    [sym_none] = ACTIONS(1050),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1050),
    [anon_sym_container] = ACTIONS(1050),
    [anon_sym_envvars] = ACTIONS(1050),
    [anon_sym_include] = ACTIONS(1050),
    [anon_sym_pepfile] = ACTIONS(1050),
    [anon_sym_pepschema] = ACTIONS(1050),
    [anon_sym_scattergather] = ACTIONS(1050),
    [anon_sym_version] = ACTIONS(1050),
    [anon_sym_wildcard_constraints] = ACTIONS(1050),
    [anon_sym_workdir] = ACTIONS(1050),
    [anon_sym_onerror] = ACTIONS(1050),
    [anon_sym_onstart] = ACTIONS(1050),
    [anon_sym_onsuccess] = ACTIONS(1050),
    [anon_sym_localrules] = ACTIONS(1050),
    [anon_sym_ruleorder] = ACTIONS(1050),
    [anon_sym_rule] = ACTIONS(1050),
    [anon_sym_checkpoint] = ACTIONS(1050),
    [anon_sym_use] = ACTIONS(1050),
    [anon_sym_module] = ACTIONS(1050),
    [sym__dedent] = ACTIONS(1048),
    [sym_string_start] = ACTIONS(1048),
  },
  [244] = {
    [ts_builtin_sym_end] = ACTIONS(1076),
    [sym_identifier] = ACTIONS(1078),
    [anon_sym_import] = ACTIONS(1078),
    [anon_sym_from] = ACTIONS(1078),
    [anon_sym_LPAREN] = ACTIONS(1076),
    [anon_sym_STAR] = ACTIONS(1076),
    [anon_sym_print] = ACTIONS(1078),
    [anon_sym_assert] = ACTIONS(1078),
    [anon_sym_return] = ACTIONS(1078),
    [anon_sym_del] = ACTIONS(1078),
    [anon_sym_raise] = ACTIONS(1078),
    [anon_sym_pass] = ACTIONS(1078),
    [anon_sym_break] = ACTIONS(1078),
    [anon_sym_continue] = ACTIONS(1078),
    [anon_sym_if] = ACTIONS(1078),
    [anon_sym_else] = ACTIONS(1078),
    [anon_sym_match] = ACTIONS(1078),
    [anon_sym_async] = ACTIONS(1078),
    [anon_sym_for] = ACTIONS(1078),
    [anon_sym_while] = ACTIONS(1078),
    [anon_sym_try] = ACTIONS(1078),
    [anon_sym_except] = ACTIONS(1078),
    [anon_sym_finally] = ACTIONS(1078),
    [anon_sym_with] = ACTIONS(1078),
    [anon_sym_def] = ACTIONS(1078),
    [anon_sym_global] = ACTIONS(1078),
    [anon_sym_nonlocal] = ACTIONS(1078),
    [anon_sym_exec] = ACTIONS(1078),
    [anon_sym_type] = ACTIONS(1078),
    [anon_sym_class] = ACTIONS(1078),
    [anon_sym_LBRACK] = ACTIONS(1076),
    [anon_sym_AT] = ACTIONS(1076),
    [anon_sym_DASH] = ACTIONS(1076),
    [anon_sym_LBRACE] = ACTIONS(1076),
    [anon_sym_PLUS] = ACTIONS(1076),
    [anon_sym_not] = ACTIONS(1078),
    [anon_sym_TILDE] = ACTIONS(1076),
    [anon_sym_lambda] = ACTIONS(1078),
    [anon_sym_yield] = ACTIONS(1078),
    [sym_ellipsis] = ACTIONS(1076),
    [sym_integer] = ACTIONS(1078),
    [sym_float] = ACTIONS(1076),
    [anon_sym_await] = ACTIONS(1078),
    [sym_true] = ACTIONS(1078),
    [sym_false] = ACTIONS(1078),
    [sym_none] = ACTIONS(1078),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1078),
    [anon_sym_container] = ACTIONS(1078),
    [anon_sym_envvars] = ACTIONS(1078),
    [anon_sym_include] = ACTIONS(1078),
    [anon_sym_pepfile] = ACTIONS(1078),
    [anon_sym_pepschema] = ACTIONS(1078),
    [anon_sym_scattergather] = ACTIONS(1078),
    [anon_sym_version] = ACTIONS(1078),
    [anon_sym_wildcard_constraints] = ACTIONS(1078),
    [anon_sym_workdir] = ACTIONS(1078),
    [anon_sym_onerror] = ACTIONS(1078),
    [anon_sym_onstart] = ACTIONS(1078),
    [anon_sym_onsuccess] = ACTIONS(1078),
    [anon_sym_localrules] = ACTIONS(1078),
    [anon_sym_ruleorder] = ACTIONS(1078),
    [anon_sym_rule] = ACTIONS(1078),
    [anon_sym_checkpoint] = ACTIONS(1078),
    [anon_sym_use] = ACTIONS(1078),
    [anon_sym_module] = ACTIONS(1078),
    [sym_string_start] = ACTIONS(1076),
  },
  [245] = {
    [ts_builtin_sym_end] = ACTIONS(1080),
    [sym_identifier] = ACTIONS(1082),
    [anon_sym_import] = ACTIONS(1082),
    [anon_sym_from] = ACTIONS(1082),
    [anon_sym_LPAREN] = ACTIONS(1080),
    [anon_sym_STAR] = ACTIONS(1080),
    [anon_sym_print] = ACTIONS(1082),
    [anon_sym_assert] = ACTIONS(1082),
    [anon_sym_return] = ACTIONS(1082),
    [anon_sym_del] = ACTIONS(1082),
    [anon_sym_raise] = ACTIONS(1082),
    [anon_sym_pass] = ACTIONS(1082),
    [anon_sym_break] = ACTIONS(1082),
    [anon_sym_continue] = ACTIONS(1082),
    [anon_sym_if] = ACTIONS(1082),
    [anon_sym_else] = ACTIONS(1082),
    [anon_sym_match] = ACTIONS(1082),
    [anon_sym_async] = ACTIONS(1082),
    [anon_sym_for] = ACTIONS(1082),
    [anon_sym_while] = ACTIONS(1082),
    [anon_sym_try] = ACTIONS(1082),
    [anon_sym_except_STAR] = ACTIONS(1080),
    [anon_sym_finally] = ACTIONS(1082),
    [anon_sym_with] = ACTIONS(1082),
    [anon_sym_def] = ACTIONS(1082),
    [anon_sym_global] = ACTIONS(1082),
    [anon_sym_nonlocal] = ACTIONS(1082),
    [anon_sym_exec] = ACTIONS(1082),
    [anon_sym_type] = ACTIONS(1082),
    [anon_sym_class] = ACTIONS(1082),
    [anon_sym_LBRACK] = ACTIONS(1080),
    [anon_sym_AT] = ACTIONS(1080),
    [anon_sym_DASH] = ACTIONS(1080),
    [anon_sym_LBRACE] = ACTIONS(1080),
    [anon_sym_PLUS] = ACTIONS(1080),
    [anon_sym_not] = ACTIONS(1082),
    [anon_sym_TILDE] = ACTIONS(1080),
    [anon_sym_lambda] = ACTIONS(1082),
    [anon_sym_yield] = ACTIONS(1082),
    [sym_ellipsis] = ACTIONS(1080),
    [sym_integer] = ACTIONS(1082),
    [sym_float] = ACTIONS(1080),
    [anon_sym_await] = ACTIONS(1082),
    [sym_true] = ACTIONS(1082),
    [sym_false] = ACTIONS(1082),
    [sym_none] = ACTIONS(1082),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1082),
    [anon_sym_container] = ACTIONS(1082),
    [anon_sym_envvars] = ACTIONS(1082),
    [anon_sym_include] = ACTIONS(1082),
    [anon_sym_pepfile] = ACTIONS(1082),
    [anon_sym_pepschema] = ACTIONS(1082),
    [anon_sym_scattergather] = ACTIONS(1082),
    [anon_sym_version] = ACTIONS(1082),
    [anon_sym_wildcard_constraints] = ACTIONS(1082),
    [anon_sym_workdir] = ACTIONS(1082),
    [anon_sym_onerror] = ACTIONS(1082),
    [anon_sym_onstart] = ACTIONS(1082),
    [anon_sym_onsuccess] = ACTIONS(1082),
    [anon_sym_localrules] = ACTIONS(1082),
    [anon_sym_ruleorder] = ACTIONS(1082),
    [anon_sym_rule] = ACTIONS(1082),
    [anon_sym_checkpoint] = ACTIONS(1082),
    [anon_sym_use] = ACTIONS(1082),
    [anon_sym_module] = ACTIONS(1082),
    [sym_string_start] = ACTIONS(1080),
  },
  [246] = {
    [aux_sym_global_statement_repeat1] = STATE(267),
    [ts_builtin_sym_end] = ACTIONS(1084),
    [sym_identifier] = ACTIONS(1086),
    [anon_sym_import] = ACTIONS(1086),
    [anon_sym_from] = ACTIONS(1086),
    [anon_sym_LPAREN] = ACTIONS(1084),
    [anon_sym_COMMA] = ACTIONS(1088),
    [anon_sym_as] = ACTIONS(1086),
    [anon_sym_STAR] = ACTIONS(1084),
    [anon_sym_print] = ACTIONS(1086),
    [anon_sym_assert] = ACTIONS(1086),
    [anon_sym_return] = ACTIONS(1086),
    [anon_sym_del] = ACTIONS(1086),
    [anon_sym_raise] = ACTIONS(1086),
    [anon_sym_pass] = ACTIONS(1086),
    [anon_sym_break] = ACTIONS(1086),
    [anon_sym_continue] = ACTIONS(1086),
    [anon_sym_if] = ACTIONS(1086),
    [anon_sym_match] = ACTIONS(1086),
    [anon_sym_async] = ACTIONS(1086),
    [anon_sym_for] = ACTIONS(1086),
    [anon_sym_while] = ACTIONS(1086),
    [anon_sym_try] = ACTIONS(1086),
    [anon_sym_with] = ACTIONS(1086),
    [anon_sym_def] = ACTIONS(1086),
    [anon_sym_global] = ACTIONS(1086),
    [anon_sym_nonlocal] = ACTIONS(1086),
    [anon_sym_exec] = ACTIONS(1086),
    [anon_sym_type] = ACTIONS(1086),
    [anon_sym_class] = ACTIONS(1086),
    [anon_sym_LBRACK] = ACTIONS(1084),
    [anon_sym_AT] = ACTIONS(1084),
    [anon_sym_DASH] = ACTIONS(1084),
    [anon_sym_LBRACE] = ACTIONS(1084),
    [anon_sym_PLUS] = ACTIONS(1084),
    [anon_sym_not] = ACTIONS(1086),
    [anon_sym_TILDE] = ACTIONS(1084),
    [anon_sym_lambda] = ACTIONS(1086),
    [anon_sym_yield] = ACTIONS(1086),
    [sym_ellipsis] = ACTIONS(1084),
    [sym_integer] = ACTIONS(1086),
    [sym_float] = ACTIONS(1084),
    [anon_sym_await] = ACTIONS(1086),
    [sym_true] = ACTIONS(1086),
    [sym_false] = ACTIONS(1086),
    [sym_none] = ACTIONS(1086),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1086),
    [anon_sym_container] = ACTIONS(1086),
    [anon_sym_envvars] = ACTIONS(1086),
    [anon_sym_include] = ACTIONS(1086),
    [anon_sym_pepfile] = ACTIONS(1086),
    [anon_sym_pepschema] = ACTIONS(1086),
    [anon_sym_scattergather] = ACTIONS(1086),
    [anon_sym_version] = ACTIONS(1086),
    [anon_sym_wildcard_constraints] = ACTIONS(1086),
    [anon_sym_workdir] = ACTIONS(1086),
    [anon_sym_onerror] = ACTIONS(1086),
    [anon_sym_onstart] = ACTIONS(1086),
    [anon_sym_onsuccess] = ACTIONS(1086),
    [anon_sym_localrules] = ACTIONS(1086),
    [anon_sym_ruleorder] = ACTIONS(1086),
    [anon_sym_rule] = ACTIONS(1086),
    [anon_sym_checkpoint] = ACTIONS(1086),
    [anon_sym_use] = ACTIONS(1086),
    [anon_sym_module] = ACTIONS(1086),
    [sym_string_start] = ACTIONS(1084),
  },
  [247] = {
    [sym_identifier] = ACTIONS(1090),
    [anon_sym_import] = ACTIONS(1090),
    [anon_sym_from] = ACTIONS(1090),
    [anon_sym_LPAREN] = ACTIONS(1092),
    [anon_sym_STAR] = ACTIONS(1092),
    [anon_sym_print] = ACTIONS(1090),
    [anon_sym_assert] = ACTIONS(1090),
    [anon_sym_return] = ACTIONS(1090),
    [anon_sym_del] = ACTIONS(1090),
    [anon_sym_raise] = ACTIONS(1090),
    [anon_sym_pass] = ACTIONS(1090),
    [anon_sym_break] = ACTIONS(1090),
    [anon_sym_continue] = ACTIONS(1090),
    [anon_sym_if] = ACTIONS(1090),
    [anon_sym_else] = ACTIONS(1090),
    [anon_sym_match] = ACTIONS(1090),
    [anon_sym_async] = ACTIONS(1090),
    [anon_sym_for] = ACTIONS(1090),
    [anon_sym_while] = ACTIONS(1090),
    [anon_sym_try] = ACTIONS(1090),
    [anon_sym_except_STAR] = ACTIONS(1092),
    [anon_sym_finally] = ACTIONS(1090),
    [anon_sym_with] = ACTIONS(1090),
    [anon_sym_def] = ACTIONS(1090),
    [anon_sym_global] = ACTIONS(1090),
    [anon_sym_nonlocal] = ACTIONS(1090),
    [anon_sym_exec] = ACTIONS(1090),
    [anon_sym_type] = ACTIONS(1090),
    [anon_sym_class] = ACTIONS(1090),
    [anon_sym_LBRACK] = ACTIONS(1092),
    [anon_sym_AT] = ACTIONS(1092),
    [anon_sym_DASH] = ACTIONS(1092),
    [anon_sym_LBRACE] = ACTIONS(1092),
    [anon_sym_PLUS] = ACTIONS(1092),
    [anon_sym_not] = ACTIONS(1090),
    [anon_sym_TILDE] = ACTIONS(1092),
    [anon_sym_lambda] = ACTIONS(1090),
    [anon_sym_yield] = ACTIONS(1090),
    [sym_ellipsis] = ACTIONS(1092),
    [sym_integer] = ACTIONS(1090),
    [sym_float] = ACTIONS(1092),
    [anon_sym_await] = ACTIONS(1090),
    [sym_true] = ACTIONS(1090),
    [sym_false] = ACTIONS(1090),
    [sym_none] = ACTIONS(1090),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1090),
    [anon_sym_container] = ACTIONS(1090),
    [anon_sym_envvars] = ACTIONS(1090),
    [anon_sym_include] = ACTIONS(1090),
    [anon_sym_pepfile] = ACTIONS(1090),
    [anon_sym_pepschema] = ACTIONS(1090),
    [anon_sym_scattergather] = ACTIONS(1090),
    [anon_sym_version] = ACTIONS(1090),
    [anon_sym_wildcard_constraints] = ACTIONS(1090),
    [anon_sym_workdir] = ACTIONS(1090),
    [anon_sym_onerror] = ACTIONS(1090),
    [anon_sym_onstart] = ACTIONS(1090),
    [anon_sym_onsuccess] = ACTIONS(1090),
    [anon_sym_localrules] = ACTIONS(1090),
    [anon_sym_ruleorder] = ACTIONS(1090),
    [anon_sym_rule] = ACTIONS(1090),
    [anon_sym_checkpoint] = ACTIONS(1090),
    [anon_sym_use] = ACTIONS(1090),
    [anon_sym_module] = ACTIONS(1090),
    [sym__dedent] = ACTIONS(1092),
    [sym_string_start] = ACTIONS(1092),
  },
  [248] = {
    [sym_identifier] = ACTIONS(1056),
    [anon_sym_import] = ACTIONS(1056),
    [anon_sym_from] = ACTIONS(1056),
    [anon_sym_LPAREN] = ACTIONS(1058),
    [anon_sym_STAR] = ACTIONS(1058),
    [anon_sym_print] = ACTIONS(1056),
    [anon_sym_assert] = ACTIONS(1056),
    [anon_sym_return] = ACTIONS(1056),
    [anon_sym_del] = ACTIONS(1056),
    [anon_sym_raise] = ACTIONS(1056),
    [anon_sym_pass] = ACTIONS(1056),
    [anon_sym_break] = ACTIONS(1056),
    [anon_sym_continue] = ACTIONS(1056),
    [anon_sym_if] = ACTIONS(1056),
    [anon_sym_else] = ACTIONS(1056),
    [anon_sym_match] = ACTIONS(1056),
    [anon_sym_async] = ACTIONS(1056),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1056),
    [anon_sym_try] = ACTIONS(1056),
    [anon_sym_except] = ACTIONS(1056),
    [anon_sym_finally] = ACTIONS(1056),
    [anon_sym_with] = ACTIONS(1056),
    [anon_sym_def] = ACTIONS(1056),
    [anon_sym_global] = ACTIONS(1056),
    [anon_sym_nonlocal] = ACTIONS(1056),
    [anon_sym_exec] = ACTIONS(1056),
    [anon_sym_type] = ACTIONS(1056),
    [anon_sym_class] = ACTIONS(1056),
    [anon_sym_LBRACK] = ACTIONS(1058),
    [anon_sym_AT] = ACTIONS(1058),
    [anon_sym_DASH] = ACTIONS(1058),
    [anon_sym_LBRACE] = ACTIONS(1058),
    [anon_sym_PLUS] = ACTIONS(1058),
    [anon_sym_not] = ACTIONS(1056),
    [anon_sym_TILDE] = ACTIONS(1058),
    [anon_sym_lambda] = ACTIONS(1056),
    [anon_sym_yield] = ACTIONS(1056),
    [sym_ellipsis] = ACTIONS(1058),
    [sym_integer] = ACTIONS(1056),
    [sym_float] = ACTIONS(1058),
    [anon_sym_await] = ACTIONS(1056),
    [sym_true] = ACTIONS(1056),
    [sym_false] = ACTIONS(1056),
    [sym_none] = ACTIONS(1056),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1056),
    [anon_sym_container] = ACTIONS(1056),
    [anon_sym_envvars] = ACTIONS(1056),
    [anon_sym_include] = ACTIONS(1056),
    [anon_sym_pepfile] = ACTIONS(1056),
    [anon_sym_pepschema] = ACTIONS(1056),
    [anon_sym_scattergather] = ACTIONS(1056),
    [anon_sym_version] = ACTIONS(1056),
    [anon_sym_wildcard_constraints] = ACTIONS(1056),
    [anon_sym_workdir] = ACTIONS(1056),
    [anon_sym_onerror] = ACTIONS(1056),
    [anon_sym_onstart] = ACTIONS(1056),
    [anon_sym_onsuccess] = ACTIONS(1056),
    [anon_sym_localrules] = ACTIONS(1056),
    [anon_sym_ruleorder] = ACTIONS(1056),
    [anon_sym_rule] = ACTIONS(1056),
    [anon_sym_checkpoint] = ACTIONS(1056),
    [anon_sym_use] = ACTIONS(1056),
    [anon_sym_module] = ACTIONS(1056),
    [sym__dedent] = ACTIONS(1058),
    [sym_string_start] = ACTIONS(1058),
  },
  [249] = {
    [sym_identifier] = ACTIONS(1060),
    [anon_sym_import] = ACTIONS(1060),
    [anon_sym_from] = ACTIONS(1060),
    [anon_sym_LPAREN] = ACTIONS(1062),
    [anon_sym_STAR] = ACTIONS(1062),
    [anon_sym_print] = ACTIONS(1060),
    [anon_sym_assert] = ACTIONS(1060),
    [anon_sym_return] = ACTIONS(1060),
    [anon_sym_del] = ACTIONS(1060),
    [anon_sym_raise] = ACTIONS(1060),
    [anon_sym_pass] = ACTIONS(1060),
    [anon_sym_break] = ACTIONS(1060),
    [anon_sym_continue] = ACTIONS(1060),
    [anon_sym_if] = ACTIONS(1060),
    [anon_sym_else] = ACTIONS(1060),
    [anon_sym_match] = ACTIONS(1060),
    [anon_sym_async] = ACTIONS(1060),
    [anon_sym_for] = ACTIONS(1060),
    [anon_sym_while] = ACTIONS(1060),
    [anon_sym_try] = ACTIONS(1060),
    [anon_sym_except] = ACTIONS(1060),
    [anon_sym_finally] = ACTIONS(1060),
    [anon_sym_with] = ACTIONS(1060),
    [anon_sym_def] = ACTIONS(1060),
    [anon_sym_global] = ACTIONS(1060),
    [anon_sym_nonlocal] = ACTIONS(1060),
    [anon_sym_exec] = ACTIONS(1060),
    [anon_sym_type] = ACTIONS(1060),
    [anon_sym_class] = ACTIONS(1060),
    [anon_sym_LBRACK] = ACTIONS(1062),
    [anon_sym_AT] = ACTIONS(1062),
    [anon_sym_DASH] = ACTIONS(1062),
    [anon_sym_LBRACE] = ACTIONS(1062),
    [anon_sym_PLUS] = ACTIONS(1062),
    [anon_sym_not] = ACTIONS(1060),
    [anon_sym_TILDE] = ACTIONS(1062),
    [anon_sym_lambda] = ACTIONS(1060),
    [anon_sym_yield] = ACTIONS(1060),
    [sym_ellipsis] = ACTIONS(1062),
    [sym_integer] = ACTIONS(1060),
    [sym_float] = ACTIONS(1062),
    [anon_sym_await] = ACTIONS(1060),
    [sym_true] = ACTIONS(1060),
    [sym_false] = ACTIONS(1060),
    [sym_none] = ACTIONS(1060),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1060),
    [anon_sym_container] = ACTIONS(1060),
    [anon_sym_envvars] = ACTIONS(1060),
    [anon_sym_include] = ACTIONS(1060),
    [anon_sym_pepfile] = ACTIONS(1060),
    [anon_sym_pepschema] = ACTIONS(1060),
    [anon_sym_scattergather] = ACTIONS(1060),
    [anon_sym_version] = ACTIONS(1060),
    [anon_sym_wildcard_constraints] = ACTIONS(1060),
    [anon_sym_workdir] = ACTIONS(1060),
    [anon_sym_onerror] = ACTIONS(1060),
    [anon_sym_onstart] = ACTIONS(1060),
    [anon_sym_onsuccess] = ACTIONS(1060),
    [anon_sym_localrules] = ACTIONS(1060),
    [anon_sym_ruleorder] = ACTIONS(1060),
    [anon_sym_rule] = ACTIONS(1060),
    [anon_sym_checkpoint] = ACTIONS(1060),
    [anon_sym_use] = ACTIONS(1060),
    [anon_sym_module] = ACTIONS(1060),
    [sym__dedent] = ACTIONS(1062),
    [sym_string_start] = ACTIONS(1062),
  },
  [250] = {
    [sym_identifier] = ACTIONS(1064),
    [anon_sym_import] = ACTIONS(1064),
    [anon_sym_from] = ACTIONS(1064),
    [anon_sym_LPAREN] = ACTIONS(1066),
    [anon_sym_STAR] = ACTIONS(1066),
    [anon_sym_print] = ACTIONS(1064),
    [anon_sym_assert] = ACTIONS(1064),
    [anon_sym_return] = ACTIONS(1064),
    [anon_sym_del] = ACTIONS(1064),
    [anon_sym_raise] = ACTIONS(1064),
    [anon_sym_pass] = ACTIONS(1064),
    [anon_sym_break] = ACTIONS(1064),
    [anon_sym_continue] = ACTIONS(1064),
    [anon_sym_if] = ACTIONS(1064),
    [anon_sym_else] = ACTIONS(1064),
    [anon_sym_match] = ACTIONS(1064),
    [anon_sym_async] = ACTIONS(1064),
    [anon_sym_for] = ACTIONS(1064),
    [anon_sym_while] = ACTIONS(1064),
    [anon_sym_try] = ACTIONS(1064),
    [anon_sym_except] = ACTIONS(1064),
    [anon_sym_finally] = ACTIONS(1064),
    [anon_sym_with] = ACTIONS(1064),
    [anon_sym_def] = ACTIONS(1064),
    [anon_sym_global] = ACTIONS(1064),
    [anon_sym_nonlocal] = ACTIONS(1064),
    [anon_sym_exec] = ACTIONS(1064),
    [anon_sym_type] = ACTIONS(1064),
    [anon_sym_class] = ACTIONS(1064),
    [anon_sym_LBRACK] = ACTIONS(1066),
    [anon_sym_AT] = ACTIONS(1066),
    [anon_sym_DASH] = ACTIONS(1066),
    [anon_sym_LBRACE] = ACTIONS(1066),
    [anon_sym_PLUS] = ACTIONS(1066),
    [anon_sym_not] = ACTIONS(1064),
    [anon_sym_TILDE] = ACTIONS(1066),
    [anon_sym_lambda] = ACTIONS(1064),
    [anon_sym_yield] = ACTIONS(1064),
    [sym_ellipsis] = ACTIONS(1066),
    [sym_integer] = ACTIONS(1064),
    [sym_float] = ACTIONS(1066),
    [anon_sym_await] = ACTIONS(1064),
    [sym_true] = ACTIONS(1064),
    [sym_false] = ACTIONS(1064),
    [sym_none] = ACTIONS(1064),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1064),
    [anon_sym_container] = ACTIONS(1064),
    [anon_sym_envvars] = ACTIONS(1064),
    [anon_sym_include] = ACTIONS(1064),
    [anon_sym_pepfile] = ACTIONS(1064),
    [anon_sym_pepschema] = ACTIONS(1064),
    [anon_sym_scattergather] = ACTIONS(1064),
    [anon_sym_version] = ACTIONS(1064),
    [anon_sym_wildcard_constraints] = ACTIONS(1064),
    [anon_sym_workdir] = ACTIONS(1064),
    [anon_sym_onerror] = ACTIONS(1064),
    [anon_sym_onstart] = ACTIONS(1064),
    [anon_sym_onsuccess] = ACTIONS(1064),
    [anon_sym_localrules] = ACTIONS(1064),
    [anon_sym_ruleorder] = ACTIONS(1064),
    [anon_sym_rule] = ACTIONS(1064),
    [anon_sym_checkpoint] = ACTIONS(1064),
    [anon_sym_use] = ACTIONS(1064),
    [anon_sym_module] = ACTIONS(1064),
    [sym__dedent] = ACTIONS(1066),
    [sym_string_start] = ACTIONS(1066),
  },
  [251] = {
    [sym_identifier] = ACTIONS(1068),
    [anon_sym_import] = ACTIONS(1068),
    [anon_sym_from] = ACTIONS(1068),
    [anon_sym_LPAREN] = ACTIONS(1070),
    [anon_sym_STAR] = ACTIONS(1070),
    [anon_sym_print] = ACTIONS(1068),
    [anon_sym_assert] = ACTIONS(1068),
    [anon_sym_return] = ACTIONS(1068),
    [anon_sym_del] = ACTIONS(1068),
    [anon_sym_raise] = ACTIONS(1068),
    [anon_sym_pass] = ACTIONS(1068),
    [anon_sym_break] = ACTIONS(1068),
    [anon_sym_continue] = ACTIONS(1068),
    [anon_sym_if] = ACTIONS(1068),
    [anon_sym_else] = ACTIONS(1068),
    [anon_sym_match] = ACTIONS(1068),
    [anon_sym_async] = ACTIONS(1068),
    [anon_sym_for] = ACTIONS(1068),
    [anon_sym_while] = ACTIONS(1068),
    [anon_sym_try] = ACTIONS(1068),
    [anon_sym_except] = ACTIONS(1068),
    [anon_sym_finally] = ACTIONS(1068),
    [anon_sym_with] = ACTIONS(1068),
    [anon_sym_def] = ACTIONS(1068),
    [anon_sym_global] = ACTIONS(1068),
    [anon_sym_nonlocal] = ACTIONS(1068),
    [anon_sym_exec] = ACTIONS(1068),
    [anon_sym_type] = ACTIONS(1068),
    [anon_sym_class] = ACTIONS(1068),
    [anon_sym_LBRACK] = ACTIONS(1070),
    [anon_sym_AT] = ACTIONS(1070),
    [anon_sym_DASH] = ACTIONS(1070),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_PLUS] = ACTIONS(1070),
    [anon_sym_not] = ACTIONS(1068),
    [anon_sym_TILDE] = ACTIONS(1070),
    [anon_sym_lambda] = ACTIONS(1068),
    [anon_sym_yield] = ACTIONS(1068),
    [sym_ellipsis] = ACTIONS(1070),
    [sym_integer] = ACTIONS(1068),
    [sym_float] = ACTIONS(1070),
    [anon_sym_await] = ACTIONS(1068),
    [sym_true] = ACTIONS(1068),
    [sym_false] = ACTIONS(1068),
    [sym_none] = ACTIONS(1068),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1068),
    [anon_sym_container] = ACTIONS(1068),
    [anon_sym_envvars] = ACTIONS(1068),
    [anon_sym_include] = ACTIONS(1068),
    [anon_sym_pepfile] = ACTIONS(1068),
    [anon_sym_pepschema] = ACTIONS(1068),
    [anon_sym_scattergather] = ACTIONS(1068),
    [anon_sym_version] = ACTIONS(1068),
    [anon_sym_wildcard_constraints] = ACTIONS(1068),
    [anon_sym_workdir] = ACTIONS(1068),
    [anon_sym_onerror] = ACTIONS(1068),
    [anon_sym_onstart] = ACTIONS(1068),
    [anon_sym_onsuccess] = ACTIONS(1068),
    [anon_sym_localrules] = ACTIONS(1068),
    [anon_sym_ruleorder] = ACTIONS(1068),
    [anon_sym_rule] = ACTIONS(1068),
    [anon_sym_checkpoint] = ACTIONS(1068),
    [anon_sym_use] = ACTIONS(1068),
    [anon_sym_module] = ACTIONS(1068),
    [sym__dedent] = ACTIONS(1070),
    [sym_string_start] = ACTIONS(1070),
  },
  [252] = {
    [aux_sym_global_statement_repeat1] = STATE(246),
    [ts_builtin_sym_end] = ACTIONS(1094),
    [sym_identifier] = ACTIONS(1096),
    [anon_sym_import] = ACTIONS(1096),
    [anon_sym_from] = ACTIONS(1096),
    [anon_sym_LPAREN] = ACTIONS(1094),
    [anon_sym_COMMA] = ACTIONS(1098),
    [anon_sym_as] = ACTIONS(1096),
    [anon_sym_STAR] = ACTIONS(1094),
    [anon_sym_print] = ACTIONS(1096),
    [anon_sym_assert] = ACTIONS(1096),
    [anon_sym_return] = ACTIONS(1096),
    [anon_sym_del] = ACTIONS(1096),
    [anon_sym_raise] = ACTIONS(1096),
    [anon_sym_pass] = ACTIONS(1096),
    [anon_sym_break] = ACTIONS(1096),
    [anon_sym_continue] = ACTIONS(1096),
    [anon_sym_if] = ACTIONS(1096),
    [anon_sym_match] = ACTIONS(1096),
    [anon_sym_async] = ACTIONS(1096),
    [anon_sym_for] = ACTIONS(1096),
    [anon_sym_while] = ACTIONS(1096),
    [anon_sym_try] = ACTIONS(1096),
    [anon_sym_with] = ACTIONS(1096),
    [anon_sym_def] = ACTIONS(1096),
    [anon_sym_global] = ACTIONS(1096),
    [anon_sym_nonlocal] = ACTIONS(1096),
    [anon_sym_exec] = ACTIONS(1096),
    [anon_sym_type] = ACTIONS(1096),
    [anon_sym_class] = ACTIONS(1096),
    [anon_sym_LBRACK] = ACTIONS(1094),
    [anon_sym_AT] = ACTIONS(1094),
    [anon_sym_DASH] = ACTIONS(1094),
    [anon_sym_LBRACE] = ACTIONS(1094),
    [anon_sym_PLUS] = ACTIONS(1094),
    [anon_sym_not] = ACTIONS(1096),
    [anon_sym_TILDE] = ACTIONS(1094),
    [anon_sym_lambda] = ACTIONS(1096),
    [anon_sym_yield] = ACTIONS(1096),
    [sym_ellipsis] = ACTIONS(1094),
    [sym_integer] = ACTIONS(1096),
    [sym_float] = ACTIONS(1094),
    [anon_sym_await] = ACTIONS(1096),
    [sym_true] = ACTIONS(1096),
    [sym_false] = ACTIONS(1096),
    [sym_none] = ACTIONS(1096),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1096),
    [anon_sym_container] = ACTIONS(1096),
    [anon_sym_envvars] = ACTIONS(1096),
    [anon_sym_include] = ACTIONS(1096),
    [anon_sym_pepfile] = ACTIONS(1096),
    [anon_sym_pepschema] = ACTIONS(1096),
    [anon_sym_scattergather] = ACTIONS(1096),
    [anon_sym_version] = ACTIONS(1096),
    [anon_sym_wildcard_constraints] = ACTIONS(1096),
    [anon_sym_workdir] = ACTIONS(1096),
    [anon_sym_onerror] = ACTIONS(1096),
    [anon_sym_onstart] = ACTIONS(1096),
    [anon_sym_onsuccess] = ACTIONS(1096),
    [anon_sym_localrules] = ACTIONS(1096),
    [anon_sym_ruleorder] = ACTIONS(1096),
    [anon_sym_rule] = ACTIONS(1096),
    [anon_sym_checkpoint] = ACTIONS(1096),
    [anon_sym_use] = ACTIONS(1096),
    [anon_sym_module] = ACTIONS(1096),
    [sym_string_start] = ACTIONS(1094),
  },
  [253] = {
    [ts_builtin_sym_end] = ACTIONS(1070),
    [sym_identifier] = ACTIONS(1068),
    [anon_sym_import] = ACTIONS(1068),
    [anon_sym_from] = ACTIONS(1068),
    [anon_sym_LPAREN] = ACTIONS(1070),
    [anon_sym_STAR] = ACTIONS(1070),
    [anon_sym_print] = ACTIONS(1068),
    [anon_sym_assert] = ACTIONS(1068),
    [anon_sym_return] = ACTIONS(1068),
    [anon_sym_del] = ACTIONS(1068),
    [anon_sym_raise] = ACTIONS(1068),
    [anon_sym_pass] = ACTIONS(1068),
    [anon_sym_break] = ACTIONS(1068),
    [anon_sym_continue] = ACTIONS(1068),
    [anon_sym_if] = ACTIONS(1068),
    [anon_sym_elif] = ACTIONS(1068),
    [anon_sym_else] = ACTIONS(1068),
    [anon_sym_match] = ACTIONS(1068),
    [anon_sym_async] = ACTIONS(1068),
    [anon_sym_for] = ACTIONS(1068),
    [anon_sym_while] = ACTIONS(1068),
    [anon_sym_try] = ACTIONS(1068),
    [anon_sym_finally] = ACTIONS(1068),
    [anon_sym_with] = ACTIONS(1068),
    [anon_sym_def] = ACTIONS(1068),
    [anon_sym_global] = ACTIONS(1068),
    [anon_sym_nonlocal] = ACTIONS(1068),
    [anon_sym_exec] = ACTIONS(1068),
    [anon_sym_type] = ACTIONS(1068),
    [anon_sym_class] = ACTIONS(1068),
    [anon_sym_LBRACK] = ACTIONS(1070),
    [anon_sym_AT] = ACTIONS(1070),
    [anon_sym_DASH] = ACTIONS(1070),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_PLUS] = ACTIONS(1070),
    [anon_sym_not] = ACTIONS(1068),
    [anon_sym_TILDE] = ACTIONS(1070),
    [anon_sym_lambda] = ACTIONS(1068),
    [anon_sym_yield] = ACTIONS(1068),
    [sym_ellipsis] = ACTIONS(1070),
    [sym_integer] = ACTIONS(1068),
    [sym_float] = ACTIONS(1070),
    [anon_sym_await] = ACTIONS(1068),
    [sym_true] = ACTIONS(1068),
    [sym_false] = ACTIONS(1068),
    [sym_none] = ACTIONS(1068),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1068),
    [anon_sym_container] = ACTIONS(1068),
    [anon_sym_envvars] = ACTIONS(1068),
    [anon_sym_include] = ACTIONS(1068),
    [anon_sym_pepfile] = ACTIONS(1068),
    [anon_sym_pepschema] = ACTIONS(1068),
    [anon_sym_scattergather] = ACTIONS(1068),
    [anon_sym_version] = ACTIONS(1068),
    [anon_sym_wildcard_constraints] = ACTIONS(1068),
    [anon_sym_workdir] = ACTIONS(1068),
    [anon_sym_onerror] = ACTIONS(1068),
    [anon_sym_onstart] = ACTIONS(1068),
    [anon_sym_onsuccess] = ACTIONS(1068),
    [anon_sym_localrules] = ACTIONS(1068),
    [anon_sym_ruleorder] = ACTIONS(1068),
    [anon_sym_rule] = ACTIONS(1068),
    [anon_sym_checkpoint] = ACTIONS(1068),
    [anon_sym_use] = ACTIONS(1068),
    [anon_sym_module] = ACTIONS(1068),
    [sym_string_start] = ACTIONS(1070),
  },
  [254] = {
    [sym_identifier] = ACTIONS(1090),
    [anon_sym_import] = ACTIONS(1090),
    [anon_sym_from] = ACTIONS(1090),
    [anon_sym_LPAREN] = ACTIONS(1092),
    [anon_sym_STAR] = ACTIONS(1092),
    [anon_sym_print] = ACTIONS(1090),
    [anon_sym_assert] = ACTIONS(1090),
    [anon_sym_return] = ACTIONS(1090),
    [anon_sym_del] = ACTIONS(1090),
    [anon_sym_raise] = ACTIONS(1090),
    [anon_sym_pass] = ACTIONS(1090),
    [anon_sym_break] = ACTIONS(1090),
    [anon_sym_continue] = ACTIONS(1090),
    [anon_sym_if] = ACTIONS(1090),
    [anon_sym_else] = ACTIONS(1090),
    [anon_sym_match] = ACTIONS(1090),
    [anon_sym_async] = ACTIONS(1090),
    [anon_sym_for] = ACTIONS(1090),
    [anon_sym_while] = ACTIONS(1090),
    [anon_sym_try] = ACTIONS(1090),
    [anon_sym_except] = ACTIONS(1090),
    [anon_sym_finally] = ACTIONS(1090),
    [anon_sym_with] = ACTIONS(1090),
    [anon_sym_def] = ACTIONS(1090),
    [anon_sym_global] = ACTIONS(1090),
    [anon_sym_nonlocal] = ACTIONS(1090),
    [anon_sym_exec] = ACTIONS(1090),
    [anon_sym_type] = ACTIONS(1090),
    [anon_sym_class] = ACTIONS(1090),
    [anon_sym_LBRACK] = ACTIONS(1092),
    [anon_sym_AT] = ACTIONS(1092),
    [anon_sym_DASH] = ACTIONS(1092),
    [anon_sym_LBRACE] = ACTIONS(1092),
    [anon_sym_PLUS] = ACTIONS(1092),
    [anon_sym_not] = ACTIONS(1090),
    [anon_sym_TILDE] = ACTIONS(1092),
    [anon_sym_lambda] = ACTIONS(1090),
    [anon_sym_yield] = ACTIONS(1090),
    [sym_ellipsis] = ACTIONS(1092),
    [sym_integer] = ACTIONS(1090),
    [sym_float] = ACTIONS(1092),
    [anon_sym_await] = ACTIONS(1090),
    [sym_true] = ACTIONS(1090),
    [sym_false] = ACTIONS(1090),
    [sym_none] = ACTIONS(1090),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1090),
    [anon_sym_container] = ACTIONS(1090),
    [anon_sym_envvars] = ACTIONS(1090),
    [anon_sym_include] = ACTIONS(1090),
    [anon_sym_pepfile] = ACTIONS(1090),
    [anon_sym_pepschema] = ACTIONS(1090),
    [anon_sym_scattergather] = ACTIONS(1090),
    [anon_sym_version] = ACTIONS(1090),
    [anon_sym_wildcard_constraints] = ACTIONS(1090),
    [anon_sym_workdir] = ACTIONS(1090),
    [anon_sym_onerror] = ACTIONS(1090),
    [anon_sym_onstart] = ACTIONS(1090),
    [anon_sym_onsuccess] = ACTIONS(1090),
    [anon_sym_localrules] = ACTIONS(1090),
    [anon_sym_ruleorder] = ACTIONS(1090),
    [anon_sym_rule] = ACTIONS(1090),
    [anon_sym_checkpoint] = ACTIONS(1090),
    [anon_sym_use] = ACTIONS(1090),
    [anon_sym_module] = ACTIONS(1090),
    [sym__dedent] = ACTIONS(1092),
    [sym_string_start] = ACTIONS(1092),
  },
  [255] = {
    [ts_builtin_sym_end] = ACTIONS(1058),
    [sym_identifier] = ACTIONS(1056),
    [anon_sym_import] = ACTIONS(1056),
    [anon_sym_from] = ACTIONS(1056),
    [anon_sym_LPAREN] = ACTIONS(1058),
    [anon_sym_STAR] = ACTIONS(1058),
    [anon_sym_print] = ACTIONS(1056),
    [anon_sym_assert] = ACTIONS(1056),
    [anon_sym_return] = ACTIONS(1056),
    [anon_sym_del] = ACTIONS(1056),
    [anon_sym_raise] = ACTIONS(1056),
    [anon_sym_pass] = ACTIONS(1056),
    [anon_sym_break] = ACTIONS(1056),
    [anon_sym_continue] = ACTIONS(1056),
    [anon_sym_if] = ACTIONS(1056),
    [anon_sym_else] = ACTIONS(1056),
    [anon_sym_match] = ACTIONS(1056),
    [anon_sym_async] = ACTIONS(1056),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1056),
    [anon_sym_try] = ACTIONS(1056),
    [anon_sym_except_STAR] = ACTIONS(1058),
    [anon_sym_finally] = ACTIONS(1056),
    [anon_sym_with] = ACTIONS(1056),
    [anon_sym_def] = ACTIONS(1056),
    [anon_sym_global] = ACTIONS(1056),
    [anon_sym_nonlocal] = ACTIONS(1056),
    [anon_sym_exec] = ACTIONS(1056),
    [anon_sym_type] = ACTIONS(1056),
    [anon_sym_class] = ACTIONS(1056),
    [anon_sym_LBRACK] = ACTIONS(1058),
    [anon_sym_AT] = ACTIONS(1058),
    [anon_sym_DASH] = ACTIONS(1058),
    [anon_sym_LBRACE] = ACTIONS(1058),
    [anon_sym_PLUS] = ACTIONS(1058),
    [anon_sym_not] = ACTIONS(1056),
    [anon_sym_TILDE] = ACTIONS(1058),
    [anon_sym_lambda] = ACTIONS(1056),
    [anon_sym_yield] = ACTIONS(1056),
    [sym_ellipsis] = ACTIONS(1058),
    [sym_integer] = ACTIONS(1056),
    [sym_float] = ACTIONS(1058),
    [anon_sym_await] = ACTIONS(1056),
    [sym_true] = ACTIONS(1056),
    [sym_false] = ACTIONS(1056),
    [sym_none] = ACTIONS(1056),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1056),
    [anon_sym_container] = ACTIONS(1056),
    [anon_sym_envvars] = ACTIONS(1056),
    [anon_sym_include] = ACTIONS(1056),
    [anon_sym_pepfile] = ACTIONS(1056),
    [anon_sym_pepschema] = ACTIONS(1056),
    [anon_sym_scattergather] = ACTIONS(1056),
    [anon_sym_version] = ACTIONS(1056),
    [anon_sym_wildcard_constraints] = ACTIONS(1056),
    [anon_sym_workdir] = ACTIONS(1056),
    [anon_sym_onerror] = ACTIONS(1056),
    [anon_sym_onstart] = ACTIONS(1056),
    [anon_sym_onsuccess] = ACTIONS(1056),
    [anon_sym_localrules] = ACTIONS(1056),
    [anon_sym_ruleorder] = ACTIONS(1056),
    [anon_sym_rule] = ACTIONS(1056),
    [anon_sym_checkpoint] = ACTIONS(1056),
    [anon_sym_use] = ACTIONS(1056),
    [anon_sym_module] = ACTIONS(1056),
    [sym_string_start] = ACTIONS(1058),
  },
  [256] = {
    [ts_builtin_sym_end] = ACTIONS(1062),
    [sym_identifier] = ACTIONS(1060),
    [anon_sym_import] = ACTIONS(1060),
    [anon_sym_from] = ACTIONS(1060),
    [anon_sym_LPAREN] = ACTIONS(1062),
    [anon_sym_STAR] = ACTIONS(1062),
    [anon_sym_print] = ACTIONS(1060),
    [anon_sym_assert] = ACTIONS(1060),
    [anon_sym_return] = ACTIONS(1060),
    [anon_sym_del] = ACTIONS(1060),
    [anon_sym_raise] = ACTIONS(1060),
    [anon_sym_pass] = ACTIONS(1060),
    [anon_sym_break] = ACTIONS(1060),
    [anon_sym_continue] = ACTIONS(1060),
    [anon_sym_if] = ACTIONS(1060),
    [anon_sym_else] = ACTIONS(1060),
    [anon_sym_match] = ACTIONS(1060),
    [anon_sym_async] = ACTIONS(1060),
    [anon_sym_for] = ACTIONS(1060),
    [anon_sym_while] = ACTIONS(1060),
    [anon_sym_try] = ACTIONS(1060),
    [anon_sym_except_STAR] = ACTIONS(1062),
    [anon_sym_finally] = ACTIONS(1060),
    [anon_sym_with] = ACTIONS(1060),
    [anon_sym_def] = ACTIONS(1060),
    [anon_sym_global] = ACTIONS(1060),
    [anon_sym_nonlocal] = ACTIONS(1060),
    [anon_sym_exec] = ACTIONS(1060),
    [anon_sym_type] = ACTIONS(1060),
    [anon_sym_class] = ACTIONS(1060),
    [anon_sym_LBRACK] = ACTIONS(1062),
    [anon_sym_AT] = ACTIONS(1062),
    [anon_sym_DASH] = ACTIONS(1062),
    [anon_sym_LBRACE] = ACTIONS(1062),
    [anon_sym_PLUS] = ACTIONS(1062),
    [anon_sym_not] = ACTIONS(1060),
    [anon_sym_TILDE] = ACTIONS(1062),
    [anon_sym_lambda] = ACTIONS(1060),
    [anon_sym_yield] = ACTIONS(1060),
    [sym_ellipsis] = ACTIONS(1062),
    [sym_integer] = ACTIONS(1060),
    [sym_float] = ACTIONS(1062),
    [anon_sym_await] = ACTIONS(1060),
    [sym_true] = ACTIONS(1060),
    [sym_false] = ACTIONS(1060),
    [sym_none] = ACTIONS(1060),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1060),
    [anon_sym_container] = ACTIONS(1060),
    [anon_sym_envvars] = ACTIONS(1060),
    [anon_sym_include] = ACTIONS(1060),
    [anon_sym_pepfile] = ACTIONS(1060),
    [anon_sym_pepschema] = ACTIONS(1060),
    [anon_sym_scattergather] = ACTIONS(1060),
    [anon_sym_version] = ACTIONS(1060),
    [anon_sym_wildcard_constraints] = ACTIONS(1060),
    [anon_sym_workdir] = ACTIONS(1060),
    [anon_sym_onerror] = ACTIONS(1060),
    [anon_sym_onstart] = ACTIONS(1060),
    [anon_sym_onsuccess] = ACTIONS(1060),
    [anon_sym_localrules] = ACTIONS(1060),
    [anon_sym_ruleorder] = ACTIONS(1060),
    [anon_sym_rule] = ACTIONS(1060),
    [anon_sym_checkpoint] = ACTIONS(1060),
    [anon_sym_use] = ACTIONS(1060),
    [anon_sym_module] = ACTIONS(1060),
    [sym_string_start] = ACTIONS(1062),
  },
  [257] = {
    [ts_builtin_sym_end] = ACTIONS(1066),
    [sym_identifier] = ACTIONS(1064),
    [anon_sym_import] = ACTIONS(1064),
    [anon_sym_from] = ACTIONS(1064),
    [anon_sym_LPAREN] = ACTIONS(1066),
    [anon_sym_STAR] = ACTIONS(1066),
    [anon_sym_print] = ACTIONS(1064),
    [anon_sym_assert] = ACTIONS(1064),
    [anon_sym_return] = ACTIONS(1064),
    [anon_sym_del] = ACTIONS(1064),
    [anon_sym_raise] = ACTIONS(1064),
    [anon_sym_pass] = ACTIONS(1064),
    [anon_sym_break] = ACTIONS(1064),
    [anon_sym_continue] = ACTIONS(1064),
    [anon_sym_if] = ACTIONS(1064),
    [anon_sym_elif] = ACTIONS(1064),
    [anon_sym_else] = ACTIONS(1064),
    [anon_sym_match] = ACTIONS(1064),
    [anon_sym_async] = ACTIONS(1064),
    [anon_sym_for] = ACTIONS(1064),
    [anon_sym_while] = ACTIONS(1064),
    [anon_sym_try] = ACTIONS(1064),
    [anon_sym_finally] = ACTIONS(1064),
    [anon_sym_with] = ACTIONS(1064),
    [anon_sym_def] = ACTIONS(1064),
    [anon_sym_global] = ACTIONS(1064),
    [anon_sym_nonlocal] = ACTIONS(1064),
    [anon_sym_exec] = ACTIONS(1064),
    [anon_sym_type] = ACTIONS(1064),
    [anon_sym_class] = ACTIONS(1064),
    [anon_sym_LBRACK] = ACTIONS(1066),
    [anon_sym_AT] = ACTIONS(1066),
    [anon_sym_DASH] = ACTIONS(1066),
    [anon_sym_LBRACE] = ACTIONS(1066),
    [anon_sym_PLUS] = ACTIONS(1066),
    [anon_sym_not] = ACTIONS(1064),
    [anon_sym_TILDE] = ACTIONS(1066),
    [anon_sym_lambda] = ACTIONS(1064),
    [anon_sym_yield] = ACTIONS(1064),
    [sym_ellipsis] = ACTIONS(1066),
    [sym_integer] = ACTIONS(1064),
    [sym_float] = ACTIONS(1066),
    [anon_sym_await] = ACTIONS(1064),
    [sym_true] = ACTIONS(1064),
    [sym_false] = ACTIONS(1064),
    [sym_none] = ACTIONS(1064),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1064),
    [anon_sym_container] = ACTIONS(1064),
    [anon_sym_envvars] = ACTIONS(1064),
    [anon_sym_include] = ACTIONS(1064),
    [anon_sym_pepfile] = ACTIONS(1064),
    [anon_sym_pepschema] = ACTIONS(1064),
    [anon_sym_scattergather] = ACTIONS(1064),
    [anon_sym_version] = ACTIONS(1064),
    [anon_sym_wildcard_constraints] = ACTIONS(1064),
    [anon_sym_workdir] = ACTIONS(1064),
    [anon_sym_onerror] = ACTIONS(1064),
    [anon_sym_onstart] = ACTIONS(1064),
    [anon_sym_onsuccess] = ACTIONS(1064),
    [anon_sym_localrules] = ACTIONS(1064),
    [anon_sym_ruleorder] = ACTIONS(1064),
    [anon_sym_rule] = ACTIONS(1064),
    [anon_sym_checkpoint] = ACTIONS(1064),
    [anon_sym_use] = ACTIONS(1064),
    [anon_sym_module] = ACTIONS(1064),
    [sym_string_start] = ACTIONS(1066),
  },
  [258] = {
    [ts_builtin_sym_end] = ACTIONS(1092),
    [sym_identifier] = ACTIONS(1090),
    [anon_sym_import] = ACTIONS(1090),
    [anon_sym_from] = ACTIONS(1090),
    [anon_sym_LPAREN] = ACTIONS(1092),
    [anon_sym_STAR] = ACTIONS(1092),
    [anon_sym_print] = ACTIONS(1090),
    [anon_sym_assert] = ACTIONS(1090),
    [anon_sym_return] = ACTIONS(1090),
    [anon_sym_del] = ACTIONS(1090),
    [anon_sym_raise] = ACTIONS(1090),
    [anon_sym_pass] = ACTIONS(1090),
    [anon_sym_break] = ACTIONS(1090),
    [anon_sym_continue] = ACTIONS(1090),
    [anon_sym_if] = ACTIONS(1090),
    [anon_sym_elif] = ACTIONS(1090),
    [anon_sym_else] = ACTIONS(1090),
    [anon_sym_match] = ACTIONS(1090),
    [anon_sym_async] = ACTIONS(1090),
    [anon_sym_for] = ACTIONS(1090),
    [anon_sym_while] = ACTIONS(1090),
    [anon_sym_try] = ACTIONS(1090),
    [anon_sym_finally] = ACTIONS(1090),
    [anon_sym_with] = ACTIONS(1090),
    [anon_sym_def] = ACTIONS(1090),
    [anon_sym_global] = ACTIONS(1090),
    [anon_sym_nonlocal] = ACTIONS(1090),
    [anon_sym_exec] = ACTIONS(1090),
    [anon_sym_type] = ACTIONS(1090),
    [anon_sym_class] = ACTIONS(1090),
    [anon_sym_LBRACK] = ACTIONS(1092),
    [anon_sym_AT] = ACTIONS(1092),
    [anon_sym_DASH] = ACTIONS(1092),
    [anon_sym_LBRACE] = ACTIONS(1092),
    [anon_sym_PLUS] = ACTIONS(1092),
    [anon_sym_not] = ACTIONS(1090),
    [anon_sym_TILDE] = ACTIONS(1092),
    [anon_sym_lambda] = ACTIONS(1090),
    [anon_sym_yield] = ACTIONS(1090),
    [sym_ellipsis] = ACTIONS(1092),
    [sym_integer] = ACTIONS(1090),
    [sym_float] = ACTIONS(1092),
    [anon_sym_await] = ACTIONS(1090),
    [sym_true] = ACTIONS(1090),
    [sym_false] = ACTIONS(1090),
    [sym_none] = ACTIONS(1090),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1090),
    [anon_sym_container] = ACTIONS(1090),
    [anon_sym_envvars] = ACTIONS(1090),
    [anon_sym_include] = ACTIONS(1090),
    [anon_sym_pepfile] = ACTIONS(1090),
    [anon_sym_pepschema] = ACTIONS(1090),
    [anon_sym_scattergather] = ACTIONS(1090),
    [anon_sym_version] = ACTIONS(1090),
    [anon_sym_wildcard_constraints] = ACTIONS(1090),
    [anon_sym_workdir] = ACTIONS(1090),
    [anon_sym_onerror] = ACTIONS(1090),
    [anon_sym_onstart] = ACTIONS(1090),
    [anon_sym_onsuccess] = ACTIONS(1090),
    [anon_sym_localrules] = ACTIONS(1090),
    [anon_sym_ruleorder] = ACTIONS(1090),
    [anon_sym_rule] = ACTIONS(1090),
    [anon_sym_checkpoint] = ACTIONS(1090),
    [anon_sym_use] = ACTIONS(1090),
    [anon_sym_module] = ACTIONS(1090),
    [sym_string_start] = ACTIONS(1092),
  },
  [259] = {
    [aux_sym_global_statement_repeat1] = STATE(259),
    [sym_identifier] = ACTIONS(1100),
    [anon_sym_import] = ACTIONS(1100),
    [anon_sym_from] = ACTIONS(1100),
    [anon_sym_LPAREN] = ACTIONS(1102),
    [anon_sym_COMMA] = ACTIONS(1104),
    [anon_sym_as] = ACTIONS(1100),
    [anon_sym_STAR] = ACTIONS(1102),
    [anon_sym_print] = ACTIONS(1100),
    [anon_sym_assert] = ACTIONS(1100),
    [anon_sym_return] = ACTIONS(1100),
    [anon_sym_del] = ACTIONS(1100),
    [anon_sym_raise] = ACTIONS(1100),
    [anon_sym_pass] = ACTIONS(1100),
    [anon_sym_break] = ACTIONS(1100),
    [anon_sym_continue] = ACTIONS(1100),
    [anon_sym_if] = ACTIONS(1100),
    [anon_sym_match] = ACTIONS(1100),
    [anon_sym_async] = ACTIONS(1100),
    [anon_sym_for] = ACTIONS(1100),
    [anon_sym_while] = ACTIONS(1100),
    [anon_sym_try] = ACTIONS(1100),
    [anon_sym_with] = ACTIONS(1100),
    [anon_sym_def] = ACTIONS(1100),
    [anon_sym_global] = ACTIONS(1100),
    [anon_sym_nonlocal] = ACTIONS(1100),
    [anon_sym_exec] = ACTIONS(1100),
    [anon_sym_type] = ACTIONS(1100),
    [anon_sym_class] = ACTIONS(1100),
    [anon_sym_LBRACK] = ACTIONS(1102),
    [anon_sym_AT] = ACTIONS(1102),
    [anon_sym_DASH] = ACTIONS(1102),
    [anon_sym_LBRACE] = ACTIONS(1102),
    [anon_sym_PLUS] = ACTIONS(1102),
    [anon_sym_not] = ACTIONS(1100),
    [anon_sym_TILDE] = ACTIONS(1102),
    [anon_sym_lambda] = ACTIONS(1100),
    [anon_sym_yield] = ACTIONS(1100),
    [sym_ellipsis] = ACTIONS(1102),
    [sym_integer] = ACTIONS(1100),
    [sym_float] = ACTIONS(1102),
    [anon_sym_await] = ACTIONS(1100),
    [sym_true] = ACTIONS(1100),
    [sym_false] = ACTIONS(1100),
    [sym_none] = ACTIONS(1100),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1100),
    [anon_sym_container] = ACTIONS(1100),
    [anon_sym_envvars] = ACTIONS(1100),
    [anon_sym_include] = ACTIONS(1100),
    [anon_sym_pepfile] = ACTIONS(1100),
    [anon_sym_pepschema] = ACTIONS(1100),
    [anon_sym_scattergather] = ACTIONS(1100),
    [anon_sym_version] = ACTIONS(1100),
    [anon_sym_wildcard_constraints] = ACTIONS(1100),
    [anon_sym_workdir] = ACTIONS(1100),
    [anon_sym_onerror] = ACTIONS(1100),
    [anon_sym_onstart] = ACTIONS(1100),
    [anon_sym_onsuccess] = ACTIONS(1100),
    [anon_sym_localrules] = ACTIONS(1100),
    [anon_sym_ruleorder] = ACTIONS(1100),
    [anon_sym_rule] = ACTIONS(1100),
    [anon_sym_checkpoint] = ACTIONS(1100),
    [anon_sym_use] = ACTIONS(1100),
    [anon_sym_module] = ACTIONS(1100),
    [sym__dedent] = ACTIONS(1102),
    [sym_string_start] = ACTIONS(1102),
  },
  [260] = {
    [ts_builtin_sym_end] = ACTIONS(1107),
    [sym_identifier] = ACTIONS(1109),
    [anon_sym_import] = ACTIONS(1109),
    [anon_sym_from] = ACTIONS(1109),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(1107),
    [anon_sym_print] = ACTIONS(1109),
    [anon_sym_assert] = ACTIONS(1109),
    [anon_sym_return] = ACTIONS(1109),
    [anon_sym_del] = ACTIONS(1109),
    [anon_sym_raise] = ACTIONS(1109),
    [anon_sym_pass] = ACTIONS(1109),
    [anon_sym_break] = ACTIONS(1109),
    [anon_sym_continue] = ACTIONS(1109),
    [anon_sym_if] = ACTIONS(1109),
    [anon_sym_else] = ACTIONS(1109),
    [anon_sym_match] = ACTIONS(1109),
    [anon_sym_async] = ACTIONS(1109),
    [anon_sym_for] = ACTIONS(1109),
    [anon_sym_while] = ACTIONS(1109),
    [anon_sym_try] = ACTIONS(1109),
    [anon_sym_except] = ACTIONS(1109),
    [anon_sym_finally] = ACTIONS(1109),
    [anon_sym_with] = ACTIONS(1109),
    [anon_sym_def] = ACTIONS(1109),
    [anon_sym_global] = ACTIONS(1109),
    [anon_sym_nonlocal] = ACTIONS(1109),
    [anon_sym_exec] = ACTIONS(1109),
    [anon_sym_type] = ACTIONS(1109),
    [anon_sym_class] = ACTIONS(1109),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_AT] = ACTIONS(1107),
    [anon_sym_DASH] = ACTIONS(1107),
    [anon_sym_LBRACE] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(1107),
    [anon_sym_not] = ACTIONS(1109),
    [anon_sym_TILDE] = ACTIONS(1107),
    [anon_sym_lambda] = ACTIONS(1109),
    [anon_sym_yield] = ACTIONS(1109),
    [sym_ellipsis] = ACTIONS(1107),
    [sym_integer] = ACTIONS(1109),
    [sym_float] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1109),
    [sym_true] = ACTIONS(1109),
    [sym_false] = ACTIONS(1109),
    [sym_none] = ACTIONS(1109),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1109),
    [anon_sym_container] = ACTIONS(1109),
    [anon_sym_envvars] = ACTIONS(1109),
    [anon_sym_include] = ACTIONS(1109),
    [anon_sym_pepfile] = ACTIONS(1109),
    [anon_sym_pepschema] = ACTIONS(1109),
    [anon_sym_scattergather] = ACTIONS(1109),
    [anon_sym_version] = ACTIONS(1109),
    [anon_sym_wildcard_constraints] = ACTIONS(1109),
    [anon_sym_workdir] = ACTIONS(1109),
    [anon_sym_onerror] = ACTIONS(1109),
    [anon_sym_onstart] = ACTIONS(1109),
    [anon_sym_onsuccess] = ACTIONS(1109),
    [anon_sym_localrules] = ACTIONS(1109),
    [anon_sym_ruleorder] = ACTIONS(1109),
    [anon_sym_rule] = ACTIONS(1109),
    [anon_sym_checkpoint] = ACTIONS(1109),
    [anon_sym_use] = ACTIONS(1109),
    [anon_sym_module] = ACTIONS(1109),
    [sym_string_start] = ACTIONS(1107),
  },
  [261] = {
    [ts_builtin_sym_end] = ACTIONS(1111),
    [sym_identifier] = ACTIONS(1113),
    [anon_sym_import] = ACTIONS(1113),
    [anon_sym_from] = ACTIONS(1113),
    [anon_sym_LPAREN] = ACTIONS(1111),
    [anon_sym_STAR] = ACTIONS(1111),
    [anon_sym_print] = ACTIONS(1113),
    [anon_sym_assert] = ACTIONS(1113),
    [anon_sym_return] = ACTIONS(1113),
    [anon_sym_del] = ACTIONS(1113),
    [anon_sym_raise] = ACTIONS(1113),
    [anon_sym_pass] = ACTIONS(1113),
    [anon_sym_break] = ACTIONS(1113),
    [anon_sym_continue] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(1113),
    [anon_sym_else] = ACTIONS(1113),
    [anon_sym_match] = ACTIONS(1113),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_for] = ACTIONS(1113),
    [anon_sym_while] = ACTIONS(1113),
    [anon_sym_try] = ACTIONS(1113),
    [anon_sym_except_STAR] = ACTIONS(1111),
    [anon_sym_finally] = ACTIONS(1113),
    [anon_sym_with] = ACTIONS(1113),
    [anon_sym_def] = ACTIONS(1113),
    [anon_sym_global] = ACTIONS(1113),
    [anon_sym_nonlocal] = ACTIONS(1113),
    [anon_sym_exec] = ACTIONS(1113),
    [anon_sym_type] = ACTIONS(1113),
    [anon_sym_class] = ACTIONS(1113),
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym_DASH] = ACTIONS(1111),
    [anon_sym_LBRACE] = ACTIONS(1111),
    [anon_sym_PLUS] = ACTIONS(1111),
    [anon_sym_not] = ACTIONS(1113),
    [anon_sym_TILDE] = ACTIONS(1111),
    [anon_sym_lambda] = ACTIONS(1113),
    [anon_sym_yield] = ACTIONS(1113),
    [sym_ellipsis] = ACTIONS(1111),
    [sym_integer] = ACTIONS(1113),
    [sym_float] = ACTIONS(1111),
    [anon_sym_await] = ACTIONS(1113),
    [sym_true] = ACTIONS(1113),
    [sym_false] = ACTIONS(1113),
    [sym_none] = ACTIONS(1113),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1113),
    [anon_sym_container] = ACTIONS(1113),
    [anon_sym_envvars] = ACTIONS(1113),
    [anon_sym_include] = ACTIONS(1113),
    [anon_sym_pepfile] = ACTIONS(1113),
    [anon_sym_pepschema] = ACTIONS(1113),
    [anon_sym_scattergather] = ACTIONS(1113),
    [anon_sym_version] = ACTIONS(1113),
    [anon_sym_wildcard_constraints] = ACTIONS(1113),
    [anon_sym_workdir] = ACTIONS(1113),
    [anon_sym_onerror] = ACTIONS(1113),
    [anon_sym_onstart] = ACTIONS(1113),
    [anon_sym_onsuccess] = ACTIONS(1113),
    [anon_sym_localrules] = ACTIONS(1113),
    [anon_sym_ruleorder] = ACTIONS(1113),
    [anon_sym_rule] = ACTIONS(1113),
    [anon_sym_checkpoint] = ACTIONS(1113),
    [anon_sym_use] = ACTIONS(1113),
    [anon_sym_module] = ACTIONS(1113),
    [sym_string_start] = ACTIONS(1111),
  },
  [262] = {
    [aux_sym_global_statement_repeat1] = STATE(259),
    [sym_identifier] = ACTIONS(1086),
    [anon_sym_import] = ACTIONS(1086),
    [anon_sym_from] = ACTIONS(1086),
    [anon_sym_LPAREN] = ACTIONS(1084),
    [anon_sym_COMMA] = ACTIONS(1115),
    [anon_sym_as] = ACTIONS(1086),
    [anon_sym_STAR] = ACTIONS(1084),
    [anon_sym_print] = ACTIONS(1086),
    [anon_sym_assert] = ACTIONS(1086),
    [anon_sym_return] = ACTIONS(1086),
    [anon_sym_del] = ACTIONS(1086),
    [anon_sym_raise] = ACTIONS(1086),
    [anon_sym_pass] = ACTIONS(1086),
    [anon_sym_break] = ACTIONS(1086),
    [anon_sym_continue] = ACTIONS(1086),
    [anon_sym_if] = ACTIONS(1086),
    [anon_sym_match] = ACTIONS(1086),
    [anon_sym_async] = ACTIONS(1086),
    [anon_sym_for] = ACTIONS(1086),
    [anon_sym_while] = ACTIONS(1086),
    [anon_sym_try] = ACTIONS(1086),
    [anon_sym_with] = ACTIONS(1086),
    [anon_sym_def] = ACTIONS(1086),
    [anon_sym_global] = ACTIONS(1086),
    [anon_sym_nonlocal] = ACTIONS(1086),
    [anon_sym_exec] = ACTIONS(1086),
    [anon_sym_type] = ACTIONS(1086),
    [anon_sym_class] = ACTIONS(1086),
    [anon_sym_LBRACK] = ACTIONS(1084),
    [anon_sym_AT] = ACTIONS(1084),
    [anon_sym_DASH] = ACTIONS(1084),
    [anon_sym_LBRACE] = ACTIONS(1084),
    [anon_sym_PLUS] = ACTIONS(1084),
    [anon_sym_not] = ACTIONS(1086),
    [anon_sym_TILDE] = ACTIONS(1084),
    [anon_sym_lambda] = ACTIONS(1086),
    [anon_sym_yield] = ACTIONS(1086),
    [sym_ellipsis] = ACTIONS(1084),
    [sym_integer] = ACTIONS(1086),
    [sym_float] = ACTIONS(1084),
    [anon_sym_await] = ACTIONS(1086),
    [sym_true] = ACTIONS(1086),
    [sym_false] = ACTIONS(1086),
    [sym_none] = ACTIONS(1086),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1086),
    [anon_sym_container] = ACTIONS(1086),
    [anon_sym_envvars] = ACTIONS(1086),
    [anon_sym_include] = ACTIONS(1086),
    [anon_sym_pepfile] = ACTIONS(1086),
    [anon_sym_pepschema] = ACTIONS(1086),
    [anon_sym_scattergather] = ACTIONS(1086),
    [anon_sym_version] = ACTIONS(1086),
    [anon_sym_wildcard_constraints] = ACTIONS(1086),
    [anon_sym_workdir] = ACTIONS(1086),
    [anon_sym_onerror] = ACTIONS(1086),
    [anon_sym_onstart] = ACTIONS(1086),
    [anon_sym_onsuccess] = ACTIONS(1086),
    [anon_sym_localrules] = ACTIONS(1086),
    [anon_sym_ruleorder] = ACTIONS(1086),
    [anon_sym_rule] = ACTIONS(1086),
    [anon_sym_checkpoint] = ACTIONS(1086),
    [anon_sym_use] = ACTIONS(1086),
    [anon_sym_module] = ACTIONS(1086),
    [sym__dedent] = ACTIONS(1084),
    [sym_string_start] = ACTIONS(1084),
  },
  [263] = {
    [ts_builtin_sym_end] = ACTIONS(1066),
    [sym_identifier] = ACTIONS(1064),
    [anon_sym_import] = ACTIONS(1064),
    [anon_sym_from] = ACTIONS(1064),
    [anon_sym_LPAREN] = ACTIONS(1066),
    [anon_sym_STAR] = ACTIONS(1066),
    [anon_sym_print] = ACTIONS(1064),
    [anon_sym_assert] = ACTIONS(1064),
    [anon_sym_return] = ACTIONS(1064),
    [anon_sym_del] = ACTIONS(1064),
    [anon_sym_raise] = ACTIONS(1064),
    [anon_sym_pass] = ACTIONS(1064),
    [anon_sym_break] = ACTIONS(1064),
    [anon_sym_continue] = ACTIONS(1064),
    [anon_sym_if] = ACTIONS(1064),
    [anon_sym_else] = ACTIONS(1064),
    [anon_sym_match] = ACTIONS(1064),
    [anon_sym_async] = ACTIONS(1064),
    [anon_sym_for] = ACTIONS(1064),
    [anon_sym_while] = ACTIONS(1064),
    [anon_sym_try] = ACTIONS(1064),
    [anon_sym_except_STAR] = ACTIONS(1066),
    [anon_sym_finally] = ACTIONS(1064),
    [anon_sym_with] = ACTIONS(1064),
    [anon_sym_def] = ACTIONS(1064),
    [anon_sym_global] = ACTIONS(1064),
    [anon_sym_nonlocal] = ACTIONS(1064),
    [anon_sym_exec] = ACTIONS(1064),
    [anon_sym_type] = ACTIONS(1064),
    [anon_sym_class] = ACTIONS(1064),
    [anon_sym_LBRACK] = ACTIONS(1066),
    [anon_sym_AT] = ACTIONS(1066),
    [anon_sym_DASH] = ACTIONS(1066),
    [anon_sym_LBRACE] = ACTIONS(1066),
    [anon_sym_PLUS] = ACTIONS(1066),
    [anon_sym_not] = ACTIONS(1064),
    [anon_sym_TILDE] = ACTIONS(1066),
    [anon_sym_lambda] = ACTIONS(1064),
    [anon_sym_yield] = ACTIONS(1064),
    [sym_ellipsis] = ACTIONS(1066),
    [sym_integer] = ACTIONS(1064),
    [sym_float] = ACTIONS(1066),
    [anon_sym_await] = ACTIONS(1064),
    [sym_true] = ACTIONS(1064),
    [sym_false] = ACTIONS(1064),
    [sym_none] = ACTIONS(1064),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1064),
    [anon_sym_container] = ACTIONS(1064),
    [anon_sym_envvars] = ACTIONS(1064),
    [anon_sym_include] = ACTIONS(1064),
    [anon_sym_pepfile] = ACTIONS(1064),
    [anon_sym_pepschema] = ACTIONS(1064),
    [anon_sym_scattergather] = ACTIONS(1064),
    [anon_sym_version] = ACTIONS(1064),
    [anon_sym_wildcard_constraints] = ACTIONS(1064),
    [anon_sym_workdir] = ACTIONS(1064),
    [anon_sym_onerror] = ACTIONS(1064),
    [anon_sym_onstart] = ACTIONS(1064),
    [anon_sym_onsuccess] = ACTIONS(1064),
    [anon_sym_localrules] = ACTIONS(1064),
    [anon_sym_ruleorder] = ACTIONS(1064),
    [anon_sym_rule] = ACTIONS(1064),
    [anon_sym_checkpoint] = ACTIONS(1064),
    [anon_sym_use] = ACTIONS(1064),
    [anon_sym_module] = ACTIONS(1064),
    [sym_string_start] = ACTIONS(1066),
  },
  [264] = {
    [ts_builtin_sym_end] = ACTIONS(1058),
    [sym_identifier] = ACTIONS(1056),
    [anon_sym_import] = ACTIONS(1056),
    [anon_sym_from] = ACTIONS(1056),
    [anon_sym_LPAREN] = ACTIONS(1058),
    [anon_sym_STAR] = ACTIONS(1058),
    [anon_sym_print] = ACTIONS(1056),
    [anon_sym_assert] = ACTIONS(1056),
    [anon_sym_return] = ACTIONS(1056),
    [anon_sym_del] = ACTIONS(1056),
    [anon_sym_raise] = ACTIONS(1056),
    [anon_sym_pass] = ACTIONS(1056),
    [anon_sym_break] = ACTIONS(1056),
    [anon_sym_continue] = ACTIONS(1056),
    [anon_sym_if] = ACTIONS(1056),
    [anon_sym_elif] = ACTIONS(1056),
    [anon_sym_else] = ACTIONS(1056),
    [anon_sym_match] = ACTIONS(1056),
    [anon_sym_async] = ACTIONS(1056),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1056),
    [anon_sym_try] = ACTIONS(1056),
    [anon_sym_finally] = ACTIONS(1056),
    [anon_sym_with] = ACTIONS(1056),
    [anon_sym_def] = ACTIONS(1056),
    [anon_sym_global] = ACTIONS(1056),
    [anon_sym_nonlocal] = ACTIONS(1056),
    [anon_sym_exec] = ACTIONS(1056),
    [anon_sym_type] = ACTIONS(1056),
    [anon_sym_class] = ACTIONS(1056),
    [anon_sym_LBRACK] = ACTIONS(1058),
    [anon_sym_AT] = ACTIONS(1058),
    [anon_sym_DASH] = ACTIONS(1058),
    [anon_sym_LBRACE] = ACTIONS(1058),
    [anon_sym_PLUS] = ACTIONS(1058),
    [anon_sym_not] = ACTIONS(1056),
    [anon_sym_TILDE] = ACTIONS(1058),
    [anon_sym_lambda] = ACTIONS(1056),
    [anon_sym_yield] = ACTIONS(1056),
    [sym_ellipsis] = ACTIONS(1058),
    [sym_integer] = ACTIONS(1056),
    [sym_float] = ACTIONS(1058),
    [anon_sym_await] = ACTIONS(1056),
    [sym_true] = ACTIONS(1056),
    [sym_false] = ACTIONS(1056),
    [sym_none] = ACTIONS(1056),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1056),
    [anon_sym_container] = ACTIONS(1056),
    [anon_sym_envvars] = ACTIONS(1056),
    [anon_sym_include] = ACTIONS(1056),
    [anon_sym_pepfile] = ACTIONS(1056),
    [anon_sym_pepschema] = ACTIONS(1056),
    [anon_sym_scattergather] = ACTIONS(1056),
    [anon_sym_version] = ACTIONS(1056),
    [anon_sym_wildcard_constraints] = ACTIONS(1056),
    [anon_sym_workdir] = ACTIONS(1056),
    [anon_sym_onerror] = ACTIONS(1056),
    [anon_sym_onstart] = ACTIONS(1056),
    [anon_sym_onsuccess] = ACTIONS(1056),
    [anon_sym_localrules] = ACTIONS(1056),
    [anon_sym_ruleorder] = ACTIONS(1056),
    [anon_sym_rule] = ACTIONS(1056),
    [anon_sym_checkpoint] = ACTIONS(1056),
    [anon_sym_use] = ACTIONS(1056),
    [anon_sym_module] = ACTIONS(1056),
    [sym_string_start] = ACTIONS(1058),
  },
  [265] = {
    [ts_builtin_sym_end] = ACTIONS(1070),
    [sym_identifier] = ACTIONS(1068),
    [anon_sym_import] = ACTIONS(1068),
    [anon_sym_from] = ACTIONS(1068),
    [anon_sym_LPAREN] = ACTIONS(1070),
    [anon_sym_STAR] = ACTIONS(1070),
    [anon_sym_print] = ACTIONS(1068),
    [anon_sym_assert] = ACTIONS(1068),
    [anon_sym_return] = ACTIONS(1068),
    [anon_sym_del] = ACTIONS(1068),
    [anon_sym_raise] = ACTIONS(1068),
    [anon_sym_pass] = ACTIONS(1068),
    [anon_sym_break] = ACTIONS(1068),
    [anon_sym_continue] = ACTIONS(1068),
    [anon_sym_if] = ACTIONS(1068),
    [anon_sym_else] = ACTIONS(1068),
    [anon_sym_match] = ACTIONS(1068),
    [anon_sym_async] = ACTIONS(1068),
    [anon_sym_for] = ACTIONS(1068),
    [anon_sym_while] = ACTIONS(1068),
    [anon_sym_try] = ACTIONS(1068),
    [anon_sym_except_STAR] = ACTIONS(1070),
    [anon_sym_finally] = ACTIONS(1068),
    [anon_sym_with] = ACTIONS(1068),
    [anon_sym_def] = ACTIONS(1068),
    [anon_sym_global] = ACTIONS(1068),
    [anon_sym_nonlocal] = ACTIONS(1068),
    [anon_sym_exec] = ACTIONS(1068),
    [anon_sym_type] = ACTIONS(1068),
    [anon_sym_class] = ACTIONS(1068),
    [anon_sym_LBRACK] = ACTIONS(1070),
    [anon_sym_AT] = ACTIONS(1070),
    [anon_sym_DASH] = ACTIONS(1070),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_PLUS] = ACTIONS(1070),
    [anon_sym_not] = ACTIONS(1068),
    [anon_sym_TILDE] = ACTIONS(1070),
    [anon_sym_lambda] = ACTIONS(1068),
    [anon_sym_yield] = ACTIONS(1068),
    [sym_ellipsis] = ACTIONS(1070),
    [sym_integer] = ACTIONS(1068),
    [sym_float] = ACTIONS(1070),
    [anon_sym_await] = ACTIONS(1068),
    [sym_true] = ACTIONS(1068),
    [sym_false] = ACTIONS(1068),
    [sym_none] = ACTIONS(1068),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1068),
    [anon_sym_container] = ACTIONS(1068),
    [anon_sym_envvars] = ACTIONS(1068),
    [anon_sym_include] = ACTIONS(1068),
    [anon_sym_pepfile] = ACTIONS(1068),
    [anon_sym_pepschema] = ACTIONS(1068),
    [anon_sym_scattergather] = ACTIONS(1068),
    [anon_sym_version] = ACTIONS(1068),
    [anon_sym_wildcard_constraints] = ACTIONS(1068),
    [anon_sym_workdir] = ACTIONS(1068),
    [anon_sym_onerror] = ACTIONS(1068),
    [anon_sym_onstart] = ACTIONS(1068),
    [anon_sym_onsuccess] = ACTIONS(1068),
    [anon_sym_localrules] = ACTIONS(1068),
    [anon_sym_ruleorder] = ACTIONS(1068),
    [anon_sym_rule] = ACTIONS(1068),
    [anon_sym_checkpoint] = ACTIONS(1068),
    [anon_sym_use] = ACTIONS(1068),
    [anon_sym_module] = ACTIONS(1068),
    [sym_string_start] = ACTIONS(1070),
  },
  [266] = {
    [ts_builtin_sym_end] = ACTIONS(1092),
    [sym_identifier] = ACTIONS(1090),
    [anon_sym_import] = ACTIONS(1090),
    [anon_sym_from] = ACTIONS(1090),
    [anon_sym_LPAREN] = ACTIONS(1092),
    [anon_sym_STAR] = ACTIONS(1092),
    [anon_sym_print] = ACTIONS(1090),
    [anon_sym_assert] = ACTIONS(1090),
    [anon_sym_return] = ACTIONS(1090),
    [anon_sym_del] = ACTIONS(1090),
    [anon_sym_raise] = ACTIONS(1090),
    [anon_sym_pass] = ACTIONS(1090),
    [anon_sym_break] = ACTIONS(1090),
    [anon_sym_continue] = ACTIONS(1090),
    [anon_sym_if] = ACTIONS(1090),
    [anon_sym_else] = ACTIONS(1090),
    [anon_sym_match] = ACTIONS(1090),
    [anon_sym_async] = ACTIONS(1090),
    [anon_sym_for] = ACTIONS(1090),
    [anon_sym_while] = ACTIONS(1090),
    [anon_sym_try] = ACTIONS(1090),
    [anon_sym_except_STAR] = ACTIONS(1092),
    [anon_sym_finally] = ACTIONS(1090),
    [anon_sym_with] = ACTIONS(1090),
    [anon_sym_def] = ACTIONS(1090),
    [anon_sym_global] = ACTIONS(1090),
    [anon_sym_nonlocal] = ACTIONS(1090),
    [anon_sym_exec] = ACTIONS(1090),
    [anon_sym_type] = ACTIONS(1090),
    [anon_sym_class] = ACTIONS(1090),
    [anon_sym_LBRACK] = ACTIONS(1092),
    [anon_sym_AT] = ACTIONS(1092),
    [anon_sym_DASH] = ACTIONS(1092),
    [anon_sym_LBRACE] = ACTIONS(1092),
    [anon_sym_PLUS] = ACTIONS(1092),
    [anon_sym_not] = ACTIONS(1090),
    [anon_sym_TILDE] = ACTIONS(1092),
    [anon_sym_lambda] = ACTIONS(1090),
    [anon_sym_yield] = ACTIONS(1090),
    [sym_ellipsis] = ACTIONS(1092),
    [sym_integer] = ACTIONS(1090),
    [sym_float] = ACTIONS(1092),
    [anon_sym_await] = ACTIONS(1090),
    [sym_true] = ACTIONS(1090),
    [sym_false] = ACTIONS(1090),
    [sym_none] = ACTIONS(1090),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1090),
    [anon_sym_container] = ACTIONS(1090),
    [anon_sym_envvars] = ACTIONS(1090),
    [anon_sym_include] = ACTIONS(1090),
    [anon_sym_pepfile] = ACTIONS(1090),
    [anon_sym_pepschema] = ACTIONS(1090),
    [anon_sym_scattergather] = ACTIONS(1090),
    [anon_sym_version] = ACTIONS(1090),
    [anon_sym_wildcard_constraints] = ACTIONS(1090),
    [anon_sym_workdir] = ACTIONS(1090),
    [anon_sym_onerror] = ACTIONS(1090),
    [anon_sym_onstart] = ACTIONS(1090),
    [anon_sym_onsuccess] = ACTIONS(1090),
    [anon_sym_localrules] = ACTIONS(1090),
    [anon_sym_ruleorder] = ACTIONS(1090),
    [anon_sym_rule] = ACTIONS(1090),
    [anon_sym_checkpoint] = ACTIONS(1090),
    [anon_sym_use] = ACTIONS(1090),
    [anon_sym_module] = ACTIONS(1090),
    [sym_string_start] = ACTIONS(1092),
  },
  [267] = {
    [aux_sym_global_statement_repeat1] = STATE(267),
    [ts_builtin_sym_end] = ACTIONS(1102),
    [sym_identifier] = ACTIONS(1100),
    [anon_sym_import] = ACTIONS(1100),
    [anon_sym_from] = ACTIONS(1100),
    [anon_sym_LPAREN] = ACTIONS(1102),
    [anon_sym_COMMA] = ACTIONS(1117),
    [anon_sym_as] = ACTIONS(1100),
    [anon_sym_STAR] = ACTIONS(1102),
    [anon_sym_print] = ACTIONS(1100),
    [anon_sym_assert] = ACTIONS(1100),
    [anon_sym_return] = ACTIONS(1100),
    [anon_sym_del] = ACTIONS(1100),
    [anon_sym_raise] = ACTIONS(1100),
    [anon_sym_pass] = ACTIONS(1100),
    [anon_sym_break] = ACTIONS(1100),
    [anon_sym_continue] = ACTIONS(1100),
    [anon_sym_if] = ACTIONS(1100),
    [anon_sym_match] = ACTIONS(1100),
    [anon_sym_async] = ACTIONS(1100),
    [anon_sym_for] = ACTIONS(1100),
    [anon_sym_while] = ACTIONS(1100),
    [anon_sym_try] = ACTIONS(1100),
    [anon_sym_with] = ACTIONS(1100),
    [anon_sym_def] = ACTIONS(1100),
    [anon_sym_global] = ACTIONS(1100),
    [anon_sym_nonlocal] = ACTIONS(1100),
    [anon_sym_exec] = ACTIONS(1100),
    [anon_sym_type] = ACTIONS(1100),
    [anon_sym_class] = ACTIONS(1100),
    [anon_sym_LBRACK] = ACTIONS(1102),
    [anon_sym_AT] = ACTIONS(1102),
    [anon_sym_DASH] = ACTIONS(1102),
    [anon_sym_LBRACE] = ACTIONS(1102),
    [anon_sym_PLUS] = ACTIONS(1102),
    [anon_sym_not] = ACTIONS(1100),
    [anon_sym_TILDE] = ACTIONS(1102),
    [anon_sym_lambda] = ACTIONS(1100),
    [anon_sym_yield] = ACTIONS(1100),
    [sym_ellipsis] = ACTIONS(1102),
    [sym_integer] = ACTIONS(1100),
    [sym_float] = ACTIONS(1102),
    [anon_sym_await] = ACTIONS(1100),
    [sym_true] = ACTIONS(1100),
    [sym_false] = ACTIONS(1100),
    [sym_none] = ACTIONS(1100),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1100),
    [anon_sym_container] = ACTIONS(1100),
    [anon_sym_envvars] = ACTIONS(1100),
    [anon_sym_include] = ACTIONS(1100),
    [anon_sym_pepfile] = ACTIONS(1100),
    [anon_sym_pepschema] = ACTIONS(1100),
    [anon_sym_scattergather] = ACTIONS(1100),
    [anon_sym_version] = ACTIONS(1100),
    [anon_sym_wildcard_constraints] = ACTIONS(1100),
    [anon_sym_workdir] = ACTIONS(1100),
    [anon_sym_onerror] = ACTIONS(1100),
    [anon_sym_onstart] = ACTIONS(1100),
    [anon_sym_onsuccess] = ACTIONS(1100),
    [anon_sym_localrules] = ACTIONS(1100),
    [anon_sym_ruleorder] = ACTIONS(1100),
    [anon_sym_rule] = ACTIONS(1100),
    [anon_sym_checkpoint] = ACTIONS(1100),
    [anon_sym_use] = ACTIONS(1100),
    [anon_sym_module] = ACTIONS(1100),
    [sym_string_start] = ACTIONS(1102),
  },
  [268] = {
    [aux_sym_global_statement_repeat1] = STATE(262),
    [sym_identifier] = ACTIONS(1096),
    [anon_sym_import] = ACTIONS(1096),
    [anon_sym_from] = ACTIONS(1096),
    [anon_sym_LPAREN] = ACTIONS(1094),
    [anon_sym_COMMA] = ACTIONS(1120),
    [anon_sym_as] = ACTIONS(1096),
    [anon_sym_STAR] = ACTIONS(1094),
    [anon_sym_print] = ACTIONS(1096),
    [anon_sym_assert] = ACTIONS(1096),
    [anon_sym_return] = ACTIONS(1096),
    [anon_sym_del] = ACTIONS(1096),
    [anon_sym_raise] = ACTIONS(1096),
    [anon_sym_pass] = ACTIONS(1096),
    [anon_sym_break] = ACTIONS(1096),
    [anon_sym_continue] = ACTIONS(1096),
    [anon_sym_if] = ACTIONS(1096),
    [anon_sym_match] = ACTIONS(1096),
    [anon_sym_async] = ACTIONS(1096),
    [anon_sym_for] = ACTIONS(1096),
    [anon_sym_while] = ACTIONS(1096),
    [anon_sym_try] = ACTIONS(1096),
    [anon_sym_with] = ACTIONS(1096),
    [anon_sym_def] = ACTIONS(1096),
    [anon_sym_global] = ACTIONS(1096),
    [anon_sym_nonlocal] = ACTIONS(1096),
    [anon_sym_exec] = ACTIONS(1096),
    [anon_sym_type] = ACTIONS(1096),
    [anon_sym_class] = ACTIONS(1096),
    [anon_sym_LBRACK] = ACTIONS(1094),
    [anon_sym_AT] = ACTIONS(1094),
    [anon_sym_DASH] = ACTIONS(1094),
    [anon_sym_LBRACE] = ACTIONS(1094),
    [anon_sym_PLUS] = ACTIONS(1094),
    [anon_sym_not] = ACTIONS(1096),
    [anon_sym_TILDE] = ACTIONS(1094),
    [anon_sym_lambda] = ACTIONS(1096),
    [anon_sym_yield] = ACTIONS(1096),
    [sym_ellipsis] = ACTIONS(1094),
    [sym_integer] = ACTIONS(1096),
    [sym_float] = ACTIONS(1094),
    [anon_sym_await] = ACTIONS(1096),
    [sym_true] = ACTIONS(1096),
    [sym_false] = ACTIONS(1096),
    [sym_none] = ACTIONS(1096),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1096),
    [anon_sym_container] = ACTIONS(1096),
    [anon_sym_envvars] = ACTIONS(1096),
    [anon_sym_include] = ACTIONS(1096),
    [anon_sym_pepfile] = ACTIONS(1096),
    [anon_sym_pepschema] = ACTIONS(1096),
    [anon_sym_scattergather] = ACTIONS(1096),
    [anon_sym_version] = ACTIONS(1096),
    [anon_sym_wildcard_constraints] = ACTIONS(1096),
    [anon_sym_workdir] = ACTIONS(1096),
    [anon_sym_onerror] = ACTIONS(1096),
    [anon_sym_onstart] = ACTIONS(1096),
    [anon_sym_onsuccess] = ACTIONS(1096),
    [anon_sym_localrules] = ACTIONS(1096),
    [anon_sym_ruleorder] = ACTIONS(1096),
    [anon_sym_rule] = ACTIONS(1096),
    [anon_sym_checkpoint] = ACTIONS(1096),
    [anon_sym_use] = ACTIONS(1096),
    [anon_sym_module] = ACTIONS(1096),
    [sym__dedent] = ACTIONS(1094),
    [sym_string_start] = ACTIONS(1094),
  },
  [269] = {
    [ts_builtin_sym_end] = ACTIONS(1074),
    [sym_identifier] = ACTIONS(1072),
    [anon_sym_import] = ACTIONS(1072),
    [anon_sym_from] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(1074),
    [anon_sym_STAR] = ACTIONS(1074),
    [anon_sym_print] = ACTIONS(1072),
    [anon_sym_assert] = ACTIONS(1072),
    [anon_sym_return] = ACTIONS(1072),
    [anon_sym_del] = ACTIONS(1072),
    [anon_sym_raise] = ACTIONS(1072),
    [anon_sym_pass] = ACTIONS(1072),
    [anon_sym_break] = ACTIONS(1072),
    [anon_sym_continue] = ACTIONS(1072),
    [anon_sym_if] = ACTIONS(1072),
    [anon_sym_else] = ACTIONS(1072),
    [anon_sym_match] = ACTIONS(1072),
    [anon_sym_async] = ACTIONS(1072),
    [anon_sym_for] = ACTIONS(1072),
    [anon_sym_while] = ACTIONS(1072),
    [anon_sym_try] = ACTIONS(1072),
    [anon_sym_except] = ACTIONS(1072),
    [anon_sym_finally] = ACTIONS(1072),
    [anon_sym_with] = ACTIONS(1072),
    [anon_sym_def] = ACTIONS(1072),
    [anon_sym_global] = ACTIONS(1072),
    [anon_sym_nonlocal] = ACTIONS(1072),
    [anon_sym_exec] = ACTIONS(1072),
    [anon_sym_type] = ACTIONS(1072),
    [anon_sym_class] = ACTIONS(1072),
    [anon_sym_LBRACK] = ACTIONS(1074),
    [anon_sym_AT] = ACTIONS(1074),
    [anon_sym_DASH] = ACTIONS(1074),
    [anon_sym_LBRACE] = ACTIONS(1074),
    [anon_sym_PLUS] = ACTIONS(1074),
    [anon_sym_not] = ACTIONS(1072),
    [anon_sym_TILDE] = ACTIONS(1074),
    [anon_sym_lambda] = ACTIONS(1072),
    [anon_sym_yield] = ACTIONS(1072),
    [sym_ellipsis] = ACTIONS(1074),
    [sym_integer] = ACTIONS(1072),
    [sym_float] = ACTIONS(1074),
    [anon_sym_await] = ACTIONS(1072),
    [sym_true] = ACTIONS(1072),
    [sym_false] = ACTIONS(1072),
    [sym_none] = ACTIONS(1072),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1072),
    [anon_sym_container] = ACTIONS(1072),
    [anon_sym_envvars] = ACTIONS(1072),
    [anon_sym_include] = ACTIONS(1072),
    [anon_sym_pepfile] = ACTIONS(1072),
    [anon_sym_pepschema] = ACTIONS(1072),
    [anon_sym_scattergather] = ACTIONS(1072),
    [anon_sym_version] = ACTIONS(1072),
    [anon_sym_wildcard_constraints] = ACTIONS(1072),
    [anon_sym_workdir] = ACTIONS(1072),
    [anon_sym_onerror] = ACTIONS(1072),
    [anon_sym_onstart] = ACTIONS(1072),
    [anon_sym_onsuccess] = ACTIONS(1072),
    [anon_sym_localrules] = ACTIONS(1072),
    [anon_sym_ruleorder] = ACTIONS(1072),
    [anon_sym_rule] = ACTIONS(1072),
    [anon_sym_checkpoint] = ACTIONS(1072),
    [anon_sym_use] = ACTIONS(1072),
    [anon_sym_module] = ACTIONS(1072),
    [sym_string_start] = ACTIONS(1074),
  },
  [270] = {
    [sym_identifier] = ACTIONS(1056),
    [anon_sym_import] = ACTIONS(1056),
    [anon_sym_from] = ACTIONS(1056),
    [anon_sym_LPAREN] = ACTIONS(1058),
    [anon_sym_STAR] = ACTIONS(1058),
    [anon_sym_print] = ACTIONS(1056),
    [anon_sym_assert] = ACTIONS(1056),
    [anon_sym_return] = ACTIONS(1056),
    [anon_sym_del] = ACTIONS(1056),
    [anon_sym_raise] = ACTIONS(1056),
    [anon_sym_pass] = ACTIONS(1056),
    [anon_sym_break] = ACTIONS(1056),
    [anon_sym_continue] = ACTIONS(1056),
    [anon_sym_if] = ACTIONS(1056),
    [anon_sym_elif] = ACTIONS(1056),
    [anon_sym_else] = ACTIONS(1056),
    [anon_sym_match] = ACTIONS(1056),
    [anon_sym_async] = ACTIONS(1056),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1056),
    [anon_sym_try] = ACTIONS(1056),
    [anon_sym_finally] = ACTIONS(1056),
    [anon_sym_with] = ACTIONS(1056),
    [anon_sym_def] = ACTIONS(1056),
    [anon_sym_global] = ACTIONS(1056),
    [anon_sym_nonlocal] = ACTIONS(1056),
    [anon_sym_exec] = ACTIONS(1056),
    [anon_sym_type] = ACTIONS(1056),
    [anon_sym_class] = ACTIONS(1056),
    [anon_sym_LBRACK] = ACTIONS(1058),
    [anon_sym_AT] = ACTIONS(1058),
    [anon_sym_DASH] = ACTIONS(1058),
    [anon_sym_LBRACE] = ACTIONS(1058),
    [anon_sym_PLUS] = ACTIONS(1058),
    [anon_sym_not] = ACTIONS(1056),
    [anon_sym_TILDE] = ACTIONS(1058),
    [anon_sym_lambda] = ACTIONS(1056),
    [anon_sym_yield] = ACTIONS(1056),
    [sym_ellipsis] = ACTIONS(1058),
    [sym_integer] = ACTIONS(1056),
    [sym_float] = ACTIONS(1058),
    [anon_sym_await] = ACTIONS(1056),
    [sym_true] = ACTIONS(1056),
    [sym_false] = ACTIONS(1056),
    [sym_none] = ACTIONS(1056),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1056),
    [anon_sym_container] = ACTIONS(1056),
    [anon_sym_envvars] = ACTIONS(1056),
    [anon_sym_include] = ACTIONS(1056),
    [anon_sym_pepfile] = ACTIONS(1056),
    [anon_sym_pepschema] = ACTIONS(1056),
    [anon_sym_scattergather] = ACTIONS(1056),
    [anon_sym_version] = ACTIONS(1056),
    [anon_sym_wildcard_constraints] = ACTIONS(1056),
    [anon_sym_workdir] = ACTIONS(1056),
    [anon_sym_onerror] = ACTIONS(1056),
    [anon_sym_onstart] = ACTIONS(1056),
    [anon_sym_onsuccess] = ACTIONS(1056),
    [anon_sym_localrules] = ACTIONS(1056),
    [anon_sym_ruleorder] = ACTIONS(1056),
    [anon_sym_rule] = ACTIONS(1056),
    [anon_sym_checkpoint] = ACTIONS(1056),
    [anon_sym_use] = ACTIONS(1056),
    [anon_sym_module] = ACTIONS(1056),
    [sym__dedent] = ACTIONS(1058),
    [sym_string_start] = ACTIONS(1058),
  },
  [271] = {
    [ts_builtin_sym_end] = ACTIONS(1062),
    [sym_identifier] = ACTIONS(1060),
    [anon_sym_import] = ACTIONS(1060),
    [anon_sym_from] = ACTIONS(1060),
    [anon_sym_LPAREN] = ACTIONS(1062),
    [anon_sym_STAR] = ACTIONS(1062),
    [anon_sym_print] = ACTIONS(1060),
    [anon_sym_assert] = ACTIONS(1060),
    [anon_sym_return] = ACTIONS(1060),
    [anon_sym_del] = ACTIONS(1060),
    [anon_sym_raise] = ACTIONS(1060),
    [anon_sym_pass] = ACTIONS(1060),
    [anon_sym_break] = ACTIONS(1060),
    [anon_sym_continue] = ACTIONS(1060),
    [anon_sym_if] = ACTIONS(1060),
    [anon_sym_else] = ACTIONS(1060),
    [anon_sym_match] = ACTIONS(1060),
    [anon_sym_async] = ACTIONS(1060),
    [anon_sym_for] = ACTIONS(1060),
    [anon_sym_while] = ACTIONS(1060),
    [anon_sym_try] = ACTIONS(1060),
    [anon_sym_except] = ACTIONS(1060),
    [anon_sym_finally] = ACTIONS(1060),
    [anon_sym_with] = ACTIONS(1060),
    [anon_sym_def] = ACTIONS(1060),
    [anon_sym_global] = ACTIONS(1060),
    [anon_sym_nonlocal] = ACTIONS(1060),
    [anon_sym_exec] = ACTIONS(1060),
    [anon_sym_type] = ACTIONS(1060),
    [anon_sym_class] = ACTIONS(1060),
    [anon_sym_LBRACK] = ACTIONS(1062),
    [anon_sym_AT] = ACTIONS(1062),
    [anon_sym_DASH] = ACTIONS(1062),
    [anon_sym_LBRACE] = ACTIONS(1062),
    [anon_sym_PLUS] = ACTIONS(1062),
    [anon_sym_not] = ACTIONS(1060),
    [anon_sym_TILDE] = ACTIONS(1062),
    [anon_sym_lambda] = ACTIONS(1060),
    [anon_sym_yield] = ACTIONS(1060),
    [sym_ellipsis] = ACTIONS(1062),
    [sym_integer] = ACTIONS(1060),
    [sym_float] = ACTIONS(1062),
    [anon_sym_await] = ACTIONS(1060),
    [sym_true] = ACTIONS(1060),
    [sym_false] = ACTIONS(1060),
    [sym_none] = ACTIONS(1060),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1060),
    [anon_sym_container] = ACTIONS(1060),
    [anon_sym_envvars] = ACTIONS(1060),
    [anon_sym_include] = ACTIONS(1060),
    [anon_sym_pepfile] = ACTIONS(1060),
    [anon_sym_pepschema] = ACTIONS(1060),
    [anon_sym_scattergather] = ACTIONS(1060),
    [anon_sym_version] = ACTIONS(1060),
    [anon_sym_wildcard_constraints] = ACTIONS(1060),
    [anon_sym_workdir] = ACTIONS(1060),
    [anon_sym_onerror] = ACTIONS(1060),
    [anon_sym_onstart] = ACTIONS(1060),
    [anon_sym_onsuccess] = ACTIONS(1060),
    [anon_sym_localrules] = ACTIONS(1060),
    [anon_sym_ruleorder] = ACTIONS(1060),
    [anon_sym_rule] = ACTIONS(1060),
    [anon_sym_checkpoint] = ACTIONS(1060),
    [anon_sym_use] = ACTIONS(1060),
    [anon_sym_module] = ACTIONS(1060),
    [sym_string_start] = ACTIONS(1062),
  },
  [272] = {
    [sym_identifier] = ACTIONS(1064),
    [anon_sym_import] = ACTIONS(1064),
    [anon_sym_from] = ACTIONS(1064),
    [anon_sym_LPAREN] = ACTIONS(1066),
    [anon_sym_STAR] = ACTIONS(1066),
    [anon_sym_print] = ACTIONS(1064),
    [anon_sym_assert] = ACTIONS(1064),
    [anon_sym_return] = ACTIONS(1064),
    [anon_sym_del] = ACTIONS(1064),
    [anon_sym_raise] = ACTIONS(1064),
    [anon_sym_pass] = ACTIONS(1064),
    [anon_sym_break] = ACTIONS(1064),
    [anon_sym_continue] = ACTIONS(1064),
    [anon_sym_if] = ACTIONS(1064),
    [anon_sym_elif] = ACTIONS(1064),
    [anon_sym_else] = ACTIONS(1064),
    [anon_sym_match] = ACTIONS(1064),
    [anon_sym_async] = ACTIONS(1064),
    [anon_sym_for] = ACTIONS(1064),
    [anon_sym_while] = ACTIONS(1064),
    [anon_sym_try] = ACTIONS(1064),
    [anon_sym_finally] = ACTIONS(1064),
    [anon_sym_with] = ACTIONS(1064),
    [anon_sym_def] = ACTIONS(1064),
    [anon_sym_global] = ACTIONS(1064),
    [anon_sym_nonlocal] = ACTIONS(1064),
    [anon_sym_exec] = ACTIONS(1064),
    [anon_sym_type] = ACTIONS(1064),
    [anon_sym_class] = ACTIONS(1064),
    [anon_sym_LBRACK] = ACTIONS(1066),
    [anon_sym_AT] = ACTIONS(1066),
    [anon_sym_DASH] = ACTIONS(1066),
    [anon_sym_LBRACE] = ACTIONS(1066),
    [anon_sym_PLUS] = ACTIONS(1066),
    [anon_sym_not] = ACTIONS(1064),
    [anon_sym_TILDE] = ACTIONS(1066),
    [anon_sym_lambda] = ACTIONS(1064),
    [anon_sym_yield] = ACTIONS(1064),
    [sym_ellipsis] = ACTIONS(1066),
    [sym_integer] = ACTIONS(1064),
    [sym_float] = ACTIONS(1066),
    [anon_sym_await] = ACTIONS(1064),
    [sym_true] = ACTIONS(1064),
    [sym_false] = ACTIONS(1064),
    [sym_none] = ACTIONS(1064),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1064),
    [anon_sym_container] = ACTIONS(1064),
    [anon_sym_envvars] = ACTIONS(1064),
    [anon_sym_include] = ACTIONS(1064),
    [anon_sym_pepfile] = ACTIONS(1064),
    [anon_sym_pepschema] = ACTIONS(1064),
    [anon_sym_scattergather] = ACTIONS(1064),
    [anon_sym_version] = ACTIONS(1064),
    [anon_sym_wildcard_constraints] = ACTIONS(1064),
    [anon_sym_workdir] = ACTIONS(1064),
    [anon_sym_onerror] = ACTIONS(1064),
    [anon_sym_onstart] = ACTIONS(1064),
    [anon_sym_onsuccess] = ACTIONS(1064),
    [anon_sym_localrules] = ACTIONS(1064),
    [anon_sym_ruleorder] = ACTIONS(1064),
    [anon_sym_rule] = ACTIONS(1064),
    [anon_sym_checkpoint] = ACTIONS(1064),
    [anon_sym_use] = ACTIONS(1064),
    [anon_sym_module] = ACTIONS(1064),
    [sym__dedent] = ACTIONS(1066),
    [sym_string_start] = ACTIONS(1066),
  },
  [273] = {
    [ts_builtin_sym_end] = ACTIONS(1070),
    [sym_identifier] = ACTIONS(1068),
    [anon_sym_import] = ACTIONS(1068),
    [anon_sym_from] = ACTIONS(1068),
    [anon_sym_LPAREN] = ACTIONS(1070),
    [anon_sym_STAR] = ACTIONS(1070),
    [anon_sym_print] = ACTIONS(1068),
    [anon_sym_assert] = ACTIONS(1068),
    [anon_sym_return] = ACTIONS(1068),
    [anon_sym_del] = ACTIONS(1068),
    [anon_sym_raise] = ACTIONS(1068),
    [anon_sym_pass] = ACTIONS(1068),
    [anon_sym_break] = ACTIONS(1068),
    [anon_sym_continue] = ACTIONS(1068),
    [anon_sym_if] = ACTIONS(1068),
    [anon_sym_else] = ACTIONS(1068),
    [anon_sym_match] = ACTIONS(1068),
    [anon_sym_async] = ACTIONS(1068),
    [anon_sym_for] = ACTIONS(1068),
    [anon_sym_while] = ACTIONS(1068),
    [anon_sym_try] = ACTIONS(1068),
    [anon_sym_except] = ACTIONS(1068),
    [anon_sym_finally] = ACTIONS(1068),
    [anon_sym_with] = ACTIONS(1068),
    [anon_sym_def] = ACTIONS(1068),
    [anon_sym_global] = ACTIONS(1068),
    [anon_sym_nonlocal] = ACTIONS(1068),
    [anon_sym_exec] = ACTIONS(1068),
    [anon_sym_type] = ACTIONS(1068),
    [anon_sym_class] = ACTIONS(1068),
    [anon_sym_LBRACK] = ACTIONS(1070),
    [anon_sym_AT] = ACTIONS(1070),
    [anon_sym_DASH] = ACTIONS(1070),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_PLUS] = ACTIONS(1070),
    [anon_sym_not] = ACTIONS(1068),
    [anon_sym_TILDE] = ACTIONS(1070),
    [anon_sym_lambda] = ACTIONS(1068),
    [anon_sym_yield] = ACTIONS(1068),
    [sym_ellipsis] = ACTIONS(1070),
    [sym_integer] = ACTIONS(1068),
    [sym_float] = ACTIONS(1070),
    [anon_sym_await] = ACTIONS(1068),
    [sym_true] = ACTIONS(1068),
    [sym_false] = ACTIONS(1068),
    [sym_none] = ACTIONS(1068),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1068),
    [anon_sym_container] = ACTIONS(1068),
    [anon_sym_envvars] = ACTIONS(1068),
    [anon_sym_include] = ACTIONS(1068),
    [anon_sym_pepfile] = ACTIONS(1068),
    [anon_sym_pepschema] = ACTIONS(1068),
    [anon_sym_scattergather] = ACTIONS(1068),
    [anon_sym_version] = ACTIONS(1068),
    [anon_sym_wildcard_constraints] = ACTIONS(1068),
    [anon_sym_workdir] = ACTIONS(1068),
    [anon_sym_onerror] = ACTIONS(1068),
    [anon_sym_onstart] = ACTIONS(1068),
    [anon_sym_onsuccess] = ACTIONS(1068),
    [anon_sym_localrules] = ACTIONS(1068),
    [anon_sym_ruleorder] = ACTIONS(1068),
    [anon_sym_rule] = ACTIONS(1068),
    [anon_sym_checkpoint] = ACTIONS(1068),
    [anon_sym_use] = ACTIONS(1068),
    [anon_sym_module] = ACTIONS(1068),
    [sym_string_start] = ACTIONS(1070),
  },
  [274] = {
    [ts_builtin_sym_end] = ACTIONS(1092),
    [sym_identifier] = ACTIONS(1090),
    [anon_sym_import] = ACTIONS(1090),
    [anon_sym_from] = ACTIONS(1090),
    [anon_sym_LPAREN] = ACTIONS(1092),
    [anon_sym_STAR] = ACTIONS(1092),
    [anon_sym_print] = ACTIONS(1090),
    [anon_sym_assert] = ACTIONS(1090),
    [anon_sym_return] = ACTIONS(1090),
    [anon_sym_del] = ACTIONS(1090),
    [anon_sym_raise] = ACTIONS(1090),
    [anon_sym_pass] = ACTIONS(1090),
    [anon_sym_break] = ACTIONS(1090),
    [anon_sym_continue] = ACTIONS(1090),
    [anon_sym_if] = ACTIONS(1090),
    [anon_sym_else] = ACTIONS(1090),
    [anon_sym_match] = ACTIONS(1090),
    [anon_sym_async] = ACTIONS(1090),
    [anon_sym_for] = ACTIONS(1090),
    [anon_sym_while] = ACTIONS(1090),
    [anon_sym_try] = ACTIONS(1090),
    [anon_sym_except] = ACTIONS(1090),
    [anon_sym_finally] = ACTIONS(1090),
    [anon_sym_with] = ACTIONS(1090),
    [anon_sym_def] = ACTIONS(1090),
    [anon_sym_global] = ACTIONS(1090),
    [anon_sym_nonlocal] = ACTIONS(1090),
    [anon_sym_exec] = ACTIONS(1090),
    [anon_sym_type] = ACTIONS(1090),
    [anon_sym_class] = ACTIONS(1090),
    [anon_sym_LBRACK] = ACTIONS(1092),
    [anon_sym_AT] = ACTIONS(1092),
    [anon_sym_DASH] = ACTIONS(1092),
    [anon_sym_LBRACE] = ACTIONS(1092),
    [anon_sym_PLUS] = ACTIONS(1092),
    [anon_sym_not] = ACTIONS(1090),
    [anon_sym_TILDE] = ACTIONS(1092),
    [anon_sym_lambda] = ACTIONS(1090),
    [anon_sym_yield] = ACTIONS(1090),
    [sym_ellipsis] = ACTIONS(1092),
    [sym_integer] = ACTIONS(1090),
    [sym_float] = ACTIONS(1092),
    [anon_sym_await] = ACTIONS(1090),
    [sym_true] = ACTIONS(1090),
    [sym_false] = ACTIONS(1090),
    [sym_none] = ACTIONS(1090),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1090),
    [anon_sym_container] = ACTIONS(1090),
    [anon_sym_envvars] = ACTIONS(1090),
    [anon_sym_include] = ACTIONS(1090),
    [anon_sym_pepfile] = ACTIONS(1090),
    [anon_sym_pepschema] = ACTIONS(1090),
    [anon_sym_scattergather] = ACTIONS(1090),
    [anon_sym_version] = ACTIONS(1090),
    [anon_sym_wildcard_constraints] = ACTIONS(1090),
    [anon_sym_workdir] = ACTIONS(1090),
    [anon_sym_onerror] = ACTIONS(1090),
    [anon_sym_onstart] = ACTIONS(1090),
    [anon_sym_onsuccess] = ACTIONS(1090),
    [anon_sym_localrules] = ACTIONS(1090),
    [anon_sym_ruleorder] = ACTIONS(1090),
    [anon_sym_rule] = ACTIONS(1090),
    [anon_sym_checkpoint] = ACTIONS(1090),
    [anon_sym_use] = ACTIONS(1090),
    [anon_sym_module] = ACTIONS(1090),
    [sym_string_start] = ACTIONS(1092),
  },
  [275] = {
    [ts_builtin_sym_end] = ACTIONS(1058),
    [sym_identifier] = ACTIONS(1056),
    [anon_sym_import] = ACTIONS(1056),
    [anon_sym_from] = ACTIONS(1056),
    [anon_sym_LPAREN] = ACTIONS(1058),
    [anon_sym_STAR] = ACTIONS(1058),
    [anon_sym_print] = ACTIONS(1056),
    [anon_sym_assert] = ACTIONS(1056),
    [anon_sym_return] = ACTIONS(1056),
    [anon_sym_del] = ACTIONS(1056),
    [anon_sym_raise] = ACTIONS(1056),
    [anon_sym_pass] = ACTIONS(1056),
    [anon_sym_break] = ACTIONS(1056),
    [anon_sym_continue] = ACTIONS(1056),
    [anon_sym_if] = ACTIONS(1056),
    [anon_sym_else] = ACTIONS(1056),
    [anon_sym_match] = ACTIONS(1056),
    [anon_sym_async] = ACTIONS(1056),
    [anon_sym_for] = ACTIONS(1056),
    [anon_sym_while] = ACTIONS(1056),
    [anon_sym_try] = ACTIONS(1056),
    [anon_sym_except] = ACTIONS(1056),
    [anon_sym_finally] = ACTIONS(1056),
    [anon_sym_with] = ACTIONS(1056),
    [anon_sym_def] = ACTIONS(1056),
    [anon_sym_global] = ACTIONS(1056),
    [anon_sym_nonlocal] = ACTIONS(1056),
    [anon_sym_exec] = ACTIONS(1056),
    [anon_sym_type] = ACTIONS(1056),
    [anon_sym_class] = ACTIONS(1056),
    [anon_sym_LBRACK] = ACTIONS(1058),
    [anon_sym_AT] = ACTIONS(1058),
    [anon_sym_DASH] = ACTIONS(1058),
    [anon_sym_LBRACE] = ACTIONS(1058),
    [anon_sym_PLUS] = ACTIONS(1058),
    [anon_sym_not] = ACTIONS(1056),
    [anon_sym_TILDE] = ACTIONS(1058),
    [anon_sym_lambda] = ACTIONS(1056),
    [anon_sym_yield] = ACTIONS(1056),
    [sym_ellipsis] = ACTIONS(1058),
    [sym_integer] = ACTIONS(1056),
    [sym_float] = ACTIONS(1058),
    [anon_sym_await] = ACTIONS(1056),
    [sym_true] = ACTIONS(1056),
    [sym_false] = ACTIONS(1056),
    [sym_none] = ACTIONS(1056),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1056),
    [anon_sym_container] = ACTIONS(1056),
    [anon_sym_envvars] = ACTIONS(1056),
    [anon_sym_include] = ACTIONS(1056),
    [anon_sym_pepfile] = ACTIONS(1056),
    [anon_sym_pepschema] = ACTIONS(1056),
    [anon_sym_scattergather] = ACTIONS(1056),
    [anon_sym_version] = ACTIONS(1056),
    [anon_sym_wildcard_constraints] = ACTIONS(1056),
    [anon_sym_workdir] = ACTIONS(1056),
    [anon_sym_onerror] = ACTIONS(1056),
    [anon_sym_onstart] = ACTIONS(1056),
    [anon_sym_onsuccess] = ACTIONS(1056),
    [anon_sym_localrules] = ACTIONS(1056),
    [anon_sym_ruleorder] = ACTIONS(1056),
    [anon_sym_rule] = ACTIONS(1056),
    [anon_sym_checkpoint] = ACTIONS(1056),
    [anon_sym_use] = ACTIONS(1056),
    [anon_sym_module] = ACTIONS(1056),
    [sym_string_start] = ACTIONS(1058),
  },
  [276] = {
    [sym_identifier] = ACTIONS(1060),
    [anon_sym_import] = ACTIONS(1060),
    [anon_sym_from] = ACTIONS(1060),
    [anon_sym_LPAREN] = ACTIONS(1062),
    [anon_sym_STAR] = ACTIONS(1062),
    [anon_sym_print] = ACTIONS(1060),
    [anon_sym_assert] = ACTIONS(1060),
    [anon_sym_return] = ACTIONS(1060),
    [anon_sym_del] = ACTIONS(1060),
    [anon_sym_raise] = ACTIONS(1060),
    [anon_sym_pass] = ACTIONS(1060),
    [anon_sym_break] = ACTIONS(1060),
    [anon_sym_continue] = ACTIONS(1060),
    [anon_sym_if] = ACTIONS(1060),
    [anon_sym_elif] = ACTIONS(1060),
    [anon_sym_else] = ACTIONS(1060),
    [anon_sym_match] = ACTIONS(1060),
    [anon_sym_async] = ACTIONS(1060),
    [anon_sym_for] = ACTIONS(1060),
    [anon_sym_while] = ACTIONS(1060),
    [anon_sym_try] = ACTIONS(1060),
    [anon_sym_finally] = ACTIONS(1060),
    [anon_sym_with] = ACTIONS(1060),
    [anon_sym_def] = ACTIONS(1060),
    [anon_sym_global] = ACTIONS(1060),
    [anon_sym_nonlocal] = ACTIONS(1060),
    [anon_sym_exec] = ACTIONS(1060),
    [anon_sym_type] = ACTIONS(1060),
    [anon_sym_class] = ACTIONS(1060),
    [anon_sym_LBRACK] = ACTIONS(1062),
    [anon_sym_AT] = ACTIONS(1062),
    [anon_sym_DASH] = ACTIONS(1062),
    [anon_sym_LBRACE] = ACTIONS(1062),
    [anon_sym_PLUS] = ACTIONS(1062),
    [anon_sym_not] = ACTIONS(1060),
    [anon_sym_TILDE] = ACTIONS(1062),
    [anon_sym_lambda] = ACTIONS(1060),
    [anon_sym_yield] = ACTIONS(1060),
    [sym_ellipsis] = ACTIONS(1062),
    [sym_integer] = ACTIONS(1060),
    [sym_float] = ACTIONS(1062),
    [anon_sym_await] = ACTIONS(1060),
    [sym_true] = ACTIONS(1060),
    [sym_false] = ACTIONS(1060),
    [sym_none] = ACTIONS(1060),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1060),
    [anon_sym_container] = ACTIONS(1060),
    [anon_sym_envvars] = ACTIONS(1060),
    [anon_sym_include] = ACTIONS(1060),
    [anon_sym_pepfile] = ACTIONS(1060),
    [anon_sym_pepschema] = ACTIONS(1060),
    [anon_sym_scattergather] = ACTIONS(1060),
    [anon_sym_version] = ACTIONS(1060),
    [anon_sym_wildcard_constraints] = ACTIONS(1060),
    [anon_sym_workdir] = ACTIONS(1060),
    [anon_sym_onerror] = ACTIONS(1060),
    [anon_sym_onstart] = ACTIONS(1060),
    [anon_sym_onsuccess] = ACTIONS(1060),
    [anon_sym_localrules] = ACTIONS(1060),
    [anon_sym_ruleorder] = ACTIONS(1060),
    [anon_sym_rule] = ACTIONS(1060),
    [anon_sym_checkpoint] = ACTIONS(1060),
    [anon_sym_use] = ACTIONS(1060),
    [anon_sym_module] = ACTIONS(1060),
    [sym__dedent] = ACTIONS(1062),
    [sym_string_start] = ACTIONS(1062),
  },
  [277] = {
    [ts_builtin_sym_end] = ACTIONS(1066),
    [sym_identifier] = ACTIONS(1064),
    [anon_sym_import] = ACTIONS(1064),
    [anon_sym_from] = ACTIONS(1064),
    [anon_sym_LPAREN] = ACTIONS(1066),
    [anon_sym_STAR] = ACTIONS(1066),
    [anon_sym_print] = ACTIONS(1064),
    [anon_sym_assert] = ACTIONS(1064),
    [anon_sym_return] = ACTIONS(1064),
    [anon_sym_del] = ACTIONS(1064),
    [anon_sym_raise] = ACTIONS(1064),
    [anon_sym_pass] = ACTIONS(1064),
    [anon_sym_break] = ACTIONS(1064),
    [anon_sym_continue] = ACTIONS(1064),
    [anon_sym_if] = ACTIONS(1064),
    [anon_sym_else] = ACTIONS(1064),
    [anon_sym_match] = ACTIONS(1064),
    [anon_sym_async] = ACTIONS(1064),
    [anon_sym_for] = ACTIONS(1064),
    [anon_sym_while] = ACTIONS(1064),
    [anon_sym_try] = ACTIONS(1064),
    [anon_sym_except] = ACTIONS(1064),
    [anon_sym_finally] = ACTIONS(1064),
    [anon_sym_with] = ACTIONS(1064),
    [anon_sym_def] = ACTIONS(1064),
    [anon_sym_global] = ACTIONS(1064),
    [anon_sym_nonlocal] = ACTIONS(1064),
    [anon_sym_exec] = ACTIONS(1064),
    [anon_sym_type] = ACTIONS(1064),
    [anon_sym_class] = ACTIONS(1064),
    [anon_sym_LBRACK] = ACTIONS(1066),
    [anon_sym_AT] = ACTIONS(1066),
    [anon_sym_DASH] = ACTIONS(1066),
    [anon_sym_LBRACE] = ACTIONS(1066),
    [anon_sym_PLUS] = ACTIONS(1066),
    [anon_sym_not] = ACTIONS(1064),
    [anon_sym_TILDE] = ACTIONS(1066),
    [anon_sym_lambda] = ACTIONS(1064),
    [anon_sym_yield] = ACTIONS(1064),
    [sym_ellipsis] = ACTIONS(1066),
    [sym_integer] = ACTIONS(1064),
    [sym_float] = ACTIONS(1066),
    [anon_sym_await] = ACTIONS(1064),
    [sym_true] = ACTIONS(1064),
    [sym_false] = ACTIONS(1064),
    [sym_none] = ACTIONS(1064),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1064),
    [anon_sym_container] = ACTIONS(1064),
    [anon_sym_envvars] = ACTIONS(1064),
    [anon_sym_include] = ACTIONS(1064),
    [anon_sym_pepfile] = ACTIONS(1064),
    [anon_sym_pepschema] = ACTIONS(1064),
    [anon_sym_scattergather] = ACTIONS(1064),
    [anon_sym_version] = ACTIONS(1064),
    [anon_sym_wildcard_constraints] = ACTIONS(1064),
    [anon_sym_workdir] = ACTIONS(1064),
    [anon_sym_onerror] = ACTIONS(1064),
    [anon_sym_onstart] = ACTIONS(1064),
    [anon_sym_onsuccess] = ACTIONS(1064),
    [anon_sym_localrules] = ACTIONS(1064),
    [anon_sym_ruleorder] = ACTIONS(1064),
    [anon_sym_rule] = ACTIONS(1064),
    [anon_sym_checkpoint] = ACTIONS(1064),
    [anon_sym_use] = ACTIONS(1064),
    [anon_sym_module] = ACTIONS(1064),
    [sym_string_start] = ACTIONS(1066),
  },
  [278] = {
    [sym_identifier] = ACTIONS(1068),
    [anon_sym_import] = ACTIONS(1068),
    [anon_sym_from] = ACTIONS(1068),
    [anon_sym_LPAREN] = ACTIONS(1070),
    [anon_sym_STAR] = ACTIONS(1070),
    [anon_sym_print] = ACTIONS(1068),
    [anon_sym_assert] = ACTIONS(1068),
    [anon_sym_return] = ACTIONS(1068),
    [anon_sym_del] = ACTIONS(1068),
    [anon_sym_raise] = ACTIONS(1068),
    [anon_sym_pass] = ACTIONS(1068),
    [anon_sym_break] = ACTIONS(1068),
    [anon_sym_continue] = ACTIONS(1068),
    [anon_sym_if] = ACTIONS(1068),
    [anon_sym_elif] = ACTIONS(1068),
    [anon_sym_else] = ACTIONS(1068),
    [anon_sym_match] = ACTIONS(1068),
    [anon_sym_async] = ACTIONS(1068),
    [anon_sym_for] = ACTIONS(1068),
    [anon_sym_while] = ACTIONS(1068),
    [anon_sym_try] = ACTIONS(1068),
    [anon_sym_finally] = ACTIONS(1068),
    [anon_sym_with] = ACTIONS(1068),
    [anon_sym_def] = ACTIONS(1068),
    [anon_sym_global] = ACTIONS(1068),
    [anon_sym_nonlocal] = ACTIONS(1068),
    [anon_sym_exec] = ACTIONS(1068),
    [anon_sym_type] = ACTIONS(1068),
    [anon_sym_class] = ACTIONS(1068),
    [anon_sym_LBRACK] = ACTIONS(1070),
    [anon_sym_AT] = ACTIONS(1070),
    [anon_sym_DASH] = ACTIONS(1070),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_PLUS] = ACTIONS(1070),
    [anon_sym_not] = ACTIONS(1068),
    [anon_sym_TILDE] = ACTIONS(1070),
    [anon_sym_lambda] = ACTIONS(1068),
    [anon_sym_yield] = ACTIONS(1068),
    [sym_ellipsis] = ACTIONS(1070),
    [sym_integer] = ACTIONS(1068),
    [sym_float] = ACTIONS(1070),
    [anon_sym_await] = ACTIONS(1068),
    [sym_true] = ACTIONS(1068),
    [sym_false] = ACTIONS(1068),
    [sym_none] = ACTIONS(1068),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1068),
    [anon_sym_container] = ACTIONS(1068),
    [anon_sym_envvars] = ACTIONS(1068),
    [anon_sym_include] = ACTIONS(1068),
    [anon_sym_pepfile] = ACTIONS(1068),
    [anon_sym_pepschema] = ACTIONS(1068),
    [anon_sym_scattergather] = ACTIONS(1068),
    [anon_sym_version] = ACTIONS(1068),
    [anon_sym_wildcard_constraints] = ACTIONS(1068),
    [anon_sym_workdir] = ACTIONS(1068),
    [anon_sym_onerror] = ACTIONS(1068),
    [anon_sym_onstart] = ACTIONS(1068),
    [anon_sym_onsuccess] = ACTIONS(1068),
    [anon_sym_localrules] = ACTIONS(1068),
    [anon_sym_ruleorder] = ACTIONS(1068),
    [anon_sym_rule] = ACTIONS(1068),
    [anon_sym_checkpoint] = ACTIONS(1068),
    [anon_sym_use] = ACTIONS(1068),
    [anon_sym_module] = ACTIONS(1068),
    [sym__dedent] = ACTIONS(1070),
    [sym_string_start] = ACTIONS(1070),
  },
  [279] = {
    [sym_identifier] = ACTIONS(1090),
    [anon_sym_import] = ACTIONS(1090),
    [anon_sym_from] = ACTIONS(1090),
    [anon_sym_LPAREN] = ACTIONS(1092),
    [anon_sym_STAR] = ACTIONS(1092),
    [anon_sym_print] = ACTIONS(1090),
    [anon_sym_assert] = ACTIONS(1090),
    [anon_sym_return] = ACTIONS(1090),
    [anon_sym_del] = ACTIONS(1090),
    [anon_sym_raise] = ACTIONS(1090),
    [anon_sym_pass] = ACTIONS(1090),
    [anon_sym_break] = ACTIONS(1090),
    [anon_sym_continue] = ACTIONS(1090),
    [anon_sym_if] = ACTIONS(1090),
    [anon_sym_elif] = ACTIONS(1090),
    [anon_sym_else] = ACTIONS(1090),
    [anon_sym_match] = ACTIONS(1090),
    [anon_sym_async] = ACTIONS(1090),
    [anon_sym_for] = ACTIONS(1090),
    [anon_sym_while] = ACTIONS(1090),
    [anon_sym_try] = ACTIONS(1090),
    [anon_sym_finally] = ACTIONS(1090),
    [anon_sym_with] = ACTIONS(1090),
    [anon_sym_def] = ACTIONS(1090),
    [anon_sym_global] = ACTIONS(1090),
    [anon_sym_nonlocal] = ACTIONS(1090),
    [anon_sym_exec] = ACTIONS(1090),
    [anon_sym_type] = ACTIONS(1090),
    [anon_sym_class] = ACTIONS(1090),
    [anon_sym_LBRACK] = ACTIONS(1092),
    [anon_sym_AT] = ACTIONS(1092),
    [anon_sym_DASH] = ACTIONS(1092),
    [anon_sym_LBRACE] = ACTIONS(1092),
    [anon_sym_PLUS] = ACTIONS(1092),
    [anon_sym_not] = ACTIONS(1090),
    [anon_sym_TILDE] = ACTIONS(1092),
    [anon_sym_lambda] = ACTIONS(1090),
    [anon_sym_yield] = ACTIONS(1090),
    [sym_ellipsis] = ACTIONS(1092),
    [sym_integer] = ACTIONS(1090),
    [sym_float] = ACTIONS(1092),
    [anon_sym_await] = ACTIONS(1090),
    [sym_true] = ACTIONS(1090),
    [sym_false] = ACTIONS(1090),
    [sym_none] = ACTIONS(1090),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1090),
    [anon_sym_container] = ACTIONS(1090),
    [anon_sym_envvars] = ACTIONS(1090),
    [anon_sym_include] = ACTIONS(1090),
    [anon_sym_pepfile] = ACTIONS(1090),
    [anon_sym_pepschema] = ACTIONS(1090),
    [anon_sym_scattergather] = ACTIONS(1090),
    [anon_sym_version] = ACTIONS(1090),
    [anon_sym_wildcard_constraints] = ACTIONS(1090),
    [anon_sym_workdir] = ACTIONS(1090),
    [anon_sym_onerror] = ACTIONS(1090),
    [anon_sym_onstart] = ACTIONS(1090),
    [anon_sym_onsuccess] = ACTIONS(1090),
    [anon_sym_localrules] = ACTIONS(1090),
    [anon_sym_ruleorder] = ACTIONS(1090),
    [anon_sym_rule] = ACTIONS(1090),
    [anon_sym_checkpoint] = ACTIONS(1090),
    [anon_sym_use] = ACTIONS(1090),
    [anon_sym_module] = ACTIONS(1090),
    [sym__dedent] = ACTIONS(1092),
    [sym_string_start] = ACTIONS(1092),
  },
  [280] = {
    [sym_identifier] = ACTIONS(1078),
    [anon_sym_import] = ACTIONS(1078),
    [anon_sym_from] = ACTIONS(1078),
    [anon_sym_LPAREN] = ACTIONS(1076),
    [anon_sym_STAR] = ACTIONS(1076),
    [anon_sym_print] = ACTIONS(1078),
    [anon_sym_assert] = ACTIONS(1078),
    [anon_sym_return] = ACTIONS(1078),
    [anon_sym_del] = ACTIONS(1078),
    [anon_sym_raise] = ACTIONS(1078),
    [anon_sym_pass] = ACTIONS(1078),
    [anon_sym_break] = ACTIONS(1078),
    [anon_sym_continue] = ACTIONS(1078),
    [anon_sym_if] = ACTIONS(1078),
    [anon_sym_else] = ACTIONS(1078),
    [anon_sym_match] = ACTIONS(1078),
    [anon_sym_async] = ACTIONS(1078),
    [anon_sym_for] = ACTIONS(1078),
    [anon_sym_while] = ACTIONS(1078),
    [anon_sym_try] = ACTIONS(1078),
    [anon_sym_except] = ACTIONS(1078),
    [anon_sym_finally] = ACTIONS(1078),
    [anon_sym_with] = ACTIONS(1078),
    [anon_sym_def] = ACTIONS(1078),
    [anon_sym_global] = ACTIONS(1078),
    [anon_sym_nonlocal] = ACTIONS(1078),
    [anon_sym_exec] = ACTIONS(1078),
    [anon_sym_type] = ACTIONS(1078),
    [anon_sym_class] = ACTIONS(1078),
    [anon_sym_LBRACK] = ACTIONS(1076),
    [anon_sym_AT] = ACTIONS(1076),
    [anon_sym_DASH] = ACTIONS(1076),
    [anon_sym_LBRACE] = ACTIONS(1076),
    [anon_sym_PLUS] = ACTIONS(1076),
    [anon_sym_not] = ACTIONS(1078),
    [anon_sym_TILDE] = ACTIONS(1076),
    [anon_sym_lambda] = ACTIONS(1078),
    [anon_sym_yield] = ACTIONS(1078),
    [sym_ellipsis] = ACTIONS(1076),
    [sym_integer] = ACTIONS(1078),
    [sym_float] = ACTIONS(1076),
    [anon_sym_await] = ACTIONS(1078),
    [sym_true] = ACTIONS(1078),
    [sym_false] = ACTIONS(1078),
    [sym_none] = ACTIONS(1078),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1078),
    [anon_sym_container] = ACTIONS(1078),
    [anon_sym_envvars] = ACTIONS(1078),
    [anon_sym_include] = ACTIONS(1078),
    [anon_sym_pepfile] = ACTIONS(1078),
    [anon_sym_pepschema] = ACTIONS(1078),
    [anon_sym_scattergather] = ACTIONS(1078),
    [anon_sym_version] = ACTIONS(1078),
    [anon_sym_wildcard_constraints] = ACTIONS(1078),
    [anon_sym_workdir] = ACTIONS(1078),
    [anon_sym_onerror] = ACTIONS(1078),
    [anon_sym_onstart] = ACTIONS(1078),
    [anon_sym_onsuccess] = ACTIONS(1078),
    [anon_sym_localrules] = ACTIONS(1078),
    [anon_sym_ruleorder] = ACTIONS(1078),
    [anon_sym_rule] = ACTIONS(1078),
    [anon_sym_checkpoint] = ACTIONS(1078),
    [anon_sym_use] = ACTIONS(1078),
    [anon_sym_module] = ACTIONS(1078),
    [sym__dedent] = ACTIONS(1076),
    [sym_string_start] = ACTIONS(1076),
  },
  [281] = {
    [ts_builtin_sym_end] = ACTIONS(1122),
    [sym_identifier] = ACTIONS(1124),
    [anon_sym_import] = ACTIONS(1124),
    [anon_sym_from] = ACTIONS(1124),
    [anon_sym_LPAREN] = ACTIONS(1122),
    [anon_sym_STAR] = ACTIONS(1122),
    [anon_sym_print] = ACTIONS(1124),
    [anon_sym_assert] = ACTIONS(1124),
    [anon_sym_return] = ACTIONS(1124),
    [anon_sym_del] = ACTIONS(1124),
    [anon_sym_raise] = ACTIONS(1124),
    [anon_sym_pass] = ACTIONS(1124),
    [anon_sym_break] = ACTIONS(1124),
    [anon_sym_continue] = ACTIONS(1124),
    [anon_sym_if] = ACTIONS(1124),
    [anon_sym_else] = ACTIONS(1124),
    [anon_sym_match] = ACTIONS(1124),
    [anon_sym_async] = ACTIONS(1124),
    [anon_sym_for] = ACTIONS(1124),
    [anon_sym_while] = ACTIONS(1124),
    [anon_sym_try] = ACTIONS(1124),
    [anon_sym_except] = ACTIONS(1124),
    [anon_sym_finally] = ACTIONS(1124),
    [anon_sym_with] = ACTIONS(1124),
    [anon_sym_def] = ACTIONS(1124),
    [anon_sym_global] = ACTIONS(1124),
    [anon_sym_nonlocal] = ACTIONS(1124),
    [anon_sym_exec] = ACTIONS(1124),
    [anon_sym_type] = ACTIONS(1124),
    [anon_sym_class] = ACTIONS(1124),
    [anon_sym_LBRACK] = ACTIONS(1122),
    [anon_sym_AT] = ACTIONS(1122),
    [anon_sym_DASH] = ACTIONS(1122),
    [anon_sym_LBRACE] = ACTIONS(1122),
    [anon_sym_PLUS] = ACTIONS(1122),
    [anon_sym_not] = ACTIONS(1124),
    [anon_sym_TILDE] = ACTIONS(1122),
    [anon_sym_lambda] = ACTIONS(1124),
    [anon_sym_yield] = ACTIONS(1124),
    [sym_ellipsis] = ACTIONS(1122),
    [sym_integer] = ACTIONS(1124),
    [sym_float] = ACTIONS(1122),
    [anon_sym_await] = ACTIONS(1124),
    [sym_true] = ACTIONS(1124),
    [sym_false] = ACTIONS(1124),
    [sym_none] = ACTIONS(1124),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1124),
    [anon_sym_container] = ACTIONS(1124),
    [anon_sym_envvars] = ACTIONS(1124),
    [anon_sym_include] = ACTIONS(1124),
    [anon_sym_pepfile] = ACTIONS(1124),
    [anon_sym_pepschema] = ACTIONS(1124),
    [anon_sym_scattergather] = ACTIONS(1124),
    [anon_sym_version] = ACTIONS(1124),
    [anon_sym_wildcard_constraints] = ACTIONS(1124),
    [anon_sym_workdir] = ACTIONS(1124),
    [anon_sym_onerror] = ACTIONS(1124),
    [anon_sym_onstart] = ACTIONS(1124),
    [anon_sym_onsuccess] = ACTIONS(1124),
    [anon_sym_localrules] = ACTIONS(1124),
    [anon_sym_ruleorder] = ACTIONS(1124),
    [anon_sym_rule] = ACTIONS(1124),
    [anon_sym_checkpoint] = ACTIONS(1124),
    [anon_sym_use] = ACTIONS(1124),
    [anon_sym_module] = ACTIONS(1124),
    [sym_string_start] = ACTIONS(1122),
  },
  [282] = {
    [ts_builtin_sym_end] = ACTIONS(1126),
    [sym_identifier] = ACTIONS(1128),
    [anon_sym_import] = ACTIONS(1128),
    [anon_sym_from] = ACTIONS(1128),
    [anon_sym_LPAREN] = ACTIONS(1126),
    [anon_sym_STAR] = ACTIONS(1126),
    [anon_sym_print] = ACTIONS(1128),
    [anon_sym_assert] = ACTIONS(1128),
    [anon_sym_return] = ACTIONS(1128),
    [anon_sym_del] = ACTIONS(1128),
    [anon_sym_raise] = ACTIONS(1128),
    [anon_sym_pass] = ACTIONS(1128),
    [anon_sym_break] = ACTIONS(1128),
    [anon_sym_continue] = ACTIONS(1128),
    [anon_sym_if] = ACTIONS(1128),
    [anon_sym_else] = ACTIONS(1128),
    [anon_sym_match] = ACTIONS(1128),
    [anon_sym_async] = ACTIONS(1128),
    [anon_sym_for] = ACTIONS(1128),
    [anon_sym_while] = ACTIONS(1128),
    [anon_sym_try] = ACTIONS(1128),
    [anon_sym_except_STAR] = ACTIONS(1126),
    [anon_sym_finally] = ACTIONS(1128),
    [anon_sym_with] = ACTIONS(1128),
    [anon_sym_def] = ACTIONS(1128),
    [anon_sym_global] = ACTIONS(1128),
    [anon_sym_nonlocal] = ACTIONS(1128),
    [anon_sym_exec] = ACTIONS(1128),
    [anon_sym_type] = ACTIONS(1128),
    [anon_sym_class] = ACTIONS(1128),
    [anon_sym_LBRACK] = ACTIONS(1126),
    [anon_sym_AT] = ACTIONS(1126),
    [anon_sym_DASH] = ACTIONS(1126),
    [anon_sym_LBRACE] = ACTIONS(1126),
    [anon_sym_PLUS] = ACTIONS(1126),
    [anon_sym_not] = ACTIONS(1128),
    [anon_sym_TILDE] = ACTIONS(1126),
    [anon_sym_lambda] = ACTIONS(1128),
    [anon_sym_yield] = ACTIONS(1128),
    [sym_ellipsis] = ACTIONS(1126),
    [sym_integer] = ACTIONS(1128),
    [sym_float] = ACTIONS(1126),
    [anon_sym_await] = ACTIONS(1128),
    [sym_true] = ACTIONS(1128),
    [sym_false] = ACTIONS(1128),
    [sym_none] = ACTIONS(1128),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1128),
    [anon_sym_container] = ACTIONS(1128),
    [anon_sym_envvars] = ACTIONS(1128),
    [anon_sym_include] = ACTIONS(1128),
    [anon_sym_pepfile] = ACTIONS(1128),
    [anon_sym_pepschema] = ACTIONS(1128),
    [anon_sym_scattergather] = ACTIONS(1128),
    [anon_sym_version] = ACTIONS(1128),
    [anon_sym_wildcard_constraints] = ACTIONS(1128),
    [anon_sym_workdir] = ACTIONS(1128),
    [anon_sym_onerror] = ACTIONS(1128),
    [anon_sym_onstart] = ACTIONS(1128),
    [anon_sym_onsuccess] = ACTIONS(1128),
    [anon_sym_localrules] = ACTIONS(1128),
    [anon_sym_ruleorder] = ACTIONS(1128),
    [anon_sym_rule] = ACTIONS(1128),
    [anon_sym_checkpoint] = ACTIONS(1128),
    [anon_sym_use] = ACTIONS(1128),
    [anon_sym_module] = ACTIONS(1128),
    [sym_string_start] = ACTIONS(1126),
  },
  [283] = {
    [sym_identifier] = ACTIONS(1130),
    [anon_sym_import] = ACTIONS(1130),
    [anon_sym_from] = ACTIONS(1130),
    [anon_sym_LPAREN] = ACTIONS(1132),
    [anon_sym_STAR] = ACTIONS(1132),
    [anon_sym_print] = ACTIONS(1130),
    [anon_sym_assert] = ACTIONS(1130),
    [anon_sym_return] = ACTIONS(1130),
    [anon_sym_del] = ACTIONS(1130),
    [anon_sym_raise] = ACTIONS(1130),
    [anon_sym_pass] = ACTIONS(1130),
    [anon_sym_break] = ACTIONS(1130),
    [anon_sym_continue] = ACTIONS(1130),
    [anon_sym_if] = ACTIONS(1130),
    [anon_sym_else] = ACTIONS(1130),
    [anon_sym_match] = ACTIONS(1130),
    [anon_sym_async] = ACTIONS(1130),
    [anon_sym_for] = ACTIONS(1130),
    [anon_sym_while] = ACTIONS(1130),
    [anon_sym_try] = ACTIONS(1130),
    [anon_sym_except] = ACTIONS(1130),
    [anon_sym_finally] = ACTIONS(1130),
    [anon_sym_with] = ACTIONS(1130),
    [anon_sym_def] = ACTIONS(1130),
    [anon_sym_global] = ACTIONS(1130),
    [anon_sym_nonlocal] = ACTIONS(1130),
    [anon_sym_exec] = ACTIONS(1130),
    [anon_sym_type] = ACTIONS(1130),
    [anon_sym_class] = ACTIONS(1130),
    [anon_sym_LBRACK] = ACTIONS(1132),
    [anon_sym_AT] = ACTIONS(1132),
    [anon_sym_DASH] = ACTIONS(1132),
    [anon_sym_LBRACE] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(1132),
    [anon_sym_not] = ACTIONS(1130),
    [anon_sym_TILDE] = ACTIONS(1132),
    [anon_sym_lambda] = ACTIONS(1130),
    [anon_sym_yield] = ACTIONS(1130),
    [sym_ellipsis] = ACTIONS(1132),
    [sym_integer] = ACTIONS(1130),
    [sym_float] = ACTIONS(1132),
    [anon_sym_await] = ACTIONS(1130),
    [sym_true] = ACTIONS(1130),
    [sym_false] = ACTIONS(1130),
    [sym_none] = ACTIONS(1130),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1130),
    [anon_sym_container] = ACTIONS(1130),
    [anon_sym_envvars] = ACTIONS(1130),
    [anon_sym_include] = ACTIONS(1130),
    [anon_sym_pepfile] = ACTIONS(1130),
    [anon_sym_pepschema] = ACTIONS(1130),
    [anon_sym_scattergather] = ACTIONS(1130),
    [anon_sym_version] = ACTIONS(1130),
    [anon_sym_wildcard_constraints] = ACTIONS(1130),
    [anon_sym_workdir] = ACTIONS(1130),
    [anon_sym_onerror] = ACTIONS(1130),
    [anon_sym_onstart] = ACTIONS(1130),
    [anon_sym_onsuccess] = ACTIONS(1130),
    [anon_sym_localrules] = ACTIONS(1130),
    [anon_sym_ruleorder] = ACTIONS(1130),
    [anon_sym_rule] = ACTIONS(1130),
    [anon_sym_checkpoint] = ACTIONS(1130),
    [anon_sym_use] = ACTIONS(1130),
    [anon_sym_module] = ACTIONS(1130),
    [sym__dedent] = ACTIONS(1132),
    [sym_string_start] = ACTIONS(1132),
  },
  [284] = {
    [sym_identifier] = ACTIONS(1113),
    [anon_sym_import] = ACTIONS(1113),
    [anon_sym_from] = ACTIONS(1113),
    [anon_sym_LPAREN] = ACTIONS(1111),
    [anon_sym_STAR] = ACTIONS(1111),
    [anon_sym_print] = ACTIONS(1113),
    [anon_sym_assert] = ACTIONS(1113),
    [anon_sym_return] = ACTIONS(1113),
    [anon_sym_del] = ACTIONS(1113),
    [anon_sym_raise] = ACTIONS(1113),
    [anon_sym_pass] = ACTIONS(1113),
    [anon_sym_break] = ACTIONS(1113),
    [anon_sym_continue] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(1113),
    [anon_sym_else] = ACTIONS(1113),
    [anon_sym_match] = ACTIONS(1113),
    [anon_sym_async] = ACTIONS(1113),
    [anon_sym_for] = ACTIONS(1113),
    [anon_sym_while] = ACTIONS(1113),
    [anon_sym_try] = ACTIONS(1113),
    [anon_sym_except_STAR] = ACTIONS(1111),
    [anon_sym_finally] = ACTIONS(1113),
    [anon_sym_with] = ACTIONS(1113),
    [anon_sym_def] = ACTIONS(1113),
    [anon_sym_global] = ACTIONS(1113),
    [anon_sym_nonlocal] = ACTIONS(1113),
    [anon_sym_exec] = ACTIONS(1113),
    [anon_sym_type] = ACTIONS(1113),
    [anon_sym_class] = ACTIONS(1113),
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_AT] = ACTIONS(1111),
    [anon_sym_DASH] = ACTIONS(1111),
    [anon_sym_LBRACE] = ACTIONS(1111),
    [anon_sym_PLUS] = ACTIONS(1111),
    [anon_sym_not] = ACTIONS(1113),
    [anon_sym_TILDE] = ACTIONS(1111),
    [anon_sym_lambda] = ACTIONS(1113),
    [anon_sym_yield] = ACTIONS(1113),
    [sym_ellipsis] = ACTIONS(1111),
    [sym_integer] = ACTIONS(1113),
    [sym_float] = ACTIONS(1111),
    [anon_sym_await] = ACTIONS(1113),
    [sym_true] = ACTIONS(1113),
    [sym_false] = ACTIONS(1113),
    [sym_none] = ACTIONS(1113),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1113),
    [anon_sym_container] = ACTIONS(1113),
    [anon_sym_envvars] = ACTIONS(1113),
    [anon_sym_include] = ACTIONS(1113),
    [anon_sym_pepfile] = ACTIONS(1113),
    [anon_sym_pepschema] = ACTIONS(1113),
    [anon_sym_scattergather] = ACTIONS(1113),
    [anon_sym_version] = ACTIONS(1113),
    [anon_sym_wildcard_constraints] = ACTIONS(1113),
    [anon_sym_workdir] = ACTIONS(1113),
    [anon_sym_onerror] = ACTIONS(1113),
    [anon_sym_onstart] = ACTIONS(1113),
    [anon_sym_onsuccess] = ACTIONS(1113),
    [anon_sym_localrules] = ACTIONS(1113),
    [anon_sym_ruleorder] = ACTIONS(1113),
    [anon_sym_rule] = ACTIONS(1113),
    [anon_sym_checkpoint] = ACTIONS(1113),
    [anon_sym_use] = ACTIONS(1113),
    [anon_sym_module] = ACTIONS(1113),
    [sym__dedent] = ACTIONS(1111),
    [sym_string_start] = ACTIONS(1111),
  },
  [285] = {
    [sym_identifier] = ACTIONS(1082),
    [anon_sym_import] = ACTIONS(1082),
    [anon_sym_from] = ACTIONS(1082),
    [anon_sym_LPAREN] = ACTIONS(1080),
    [anon_sym_STAR] = ACTIONS(1080),
    [anon_sym_print] = ACTIONS(1082),
    [anon_sym_assert] = ACTIONS(1082),
    [anon_sym_return] = ACTIONS(1082),
    [anon_sym_del] = ACTIONS(1082),
    [anon_sym_raise] = ACTIONS(1082),
    [anon_sym_pass] = ACTIONS(1082),
    [anon_sym_break] = ACTIONS(1082),
    [anon_sym_continue] = ACTIONS(1082),
    [anon_sym_if] = ACTIONS(1082),
    [anon_sym_else] = ACTIONS(1082),
    [anon_sym_match] = ACTIONS(1082),
    [anon_sym_async] = ACTIONS(1082),
    [anon_sym_for] = ACTIONS(1082),
    [anon_sym_while] = ACTIONS(1082),
    [anon_sym_try] = ACTIONS(1082),
    [anon_sym_except_STAR] = ACTIONS(1080),
    [anon_sym_finally] = ACTIONS(1082),
    [anon_sym_with] = ACTIONS(1082),
    [anon_sym_def] = ACTIONS(1082),
    [anon_sym_global] = ACTIONS(1082),
    [anon_sym_nonlocal] = ACTIONS(1082),
    [anon_sym_exec] = ACTIONS(1082),
    [anon_sym_type] = ACTIONS(1082),
    [anon_sym_class] = ACTIONS(1082),
    [anon_sym_LBRACK] = ACTIONS(1080),
    [anon_sym_AT] = ACTIONS(1080),
    [anon_sym_DASH] = ACTIONS(1080),
    [anon_sym_LBRACE] = ACTIONS(1080),
    [anon_sym_PLUS] = ACTIONS(1080),
    [anon_sym_not] = ACTIONS(1082),
    [anon_sym_TILDE] = ACTIONS(1080),
    [anon_sym_lambda] = ACTIONS(1082),
    [anon_sym_yield] = ACTIONS(1082),
    [sym_ellipsis] = ACTIONS(1080),
    [sym_integer] = ACTIONS(1082),
    [sym_float] = ACTIONS(1080),
    [anon_sym_await] = ACTIONS(1082),
    [sym_true] = ACTIONS(1082),
    [sym_false] = ACTIONS(1082),
    [sym_none] = ACTIONS(1082),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1082),
    [anon_sym_container] = ACTIONS(1082),
    [anon_sym_envvars] = ACTIONS(1082),
    [anon_sym_include] = ACTIONS(1082),
    [anon_sym_pepfile] = ACTIONS(1082),
    [anon_sym_pepschema] = ACTIONS(1082),
    [anon_sym_scattergather] = ACTIONS(1082),
    [anon_sym_version] = ACTIONS(1082),
    [anon_sym_wildcard_constraints] = ACTIONS(1082),
    [anon_sym_workdir] = ACTIONS(1082),
    [anon_sym_onerror] = ACTIONS(1082),
    [anon_sym_onstart] = ACTIONS(1082),
    [anon_sym_onsuccess] = ACTIONS(1082),
    [anon_sym_localrules] = ACTIONS(1082),
    [anon_sym_ruleorder] = ACTIONS(1082),
    [anon_sym_rule] = ACTIONS(1082),
    [anon_sym_checkpoint] = ACTIONS(1082),
    [anon_sym_use] = ACTIONS(1082),
    [anon_sym_module] = ACTIONS(1082),
    [sym__dedent] = ACTIONS(1080),
    [sym_string_start] = ACTIONS(1080),
  },
  [286] = {
    [ts_builtin_sym_end] = ACTIONS(1132),
    [sym_identifier] = ACTIONS(1130),
    [anon_sym_import] = ACTIONS(1130),
    [anon_sym_from] = ACTIONS(1130),
    [anon_sym_LPAREN] = ACTIONS(1132),
    [anon_sym_STAR] = ACTIONS(1132),
    [anon_sym_print] = ACTIONS(1130),
    [anon_sym_assert] = ACTIONS(1130),
    [anon_sym_return] = ACTIONS(1130),
    [anon_sym_del] = ACTIONS(1130),
    [anon_sym_raise] = ACTIONS(1130),
    [anon_sym_pass] = ACTIONS(1130),
    [anon_sym_break] = ACTIONS(1130),
    [anon_sym_continue] = ACTIONS(1130),
    [anon_sym_if] = ACTIONS(1130),
    [anon_sym_else] = ACTIONS(1130),
    [anon_sym_match] = ACTIONS(1130),
    [anon_sym_async] = ACTIONS(1130),
    [anon_sym_for] = ACTIONS(1130),
    [anon_sym_while] = ACTIONS(1130),
    [anon_sym_try] = ACTIONS(1130),
    [anon_sym_except] = ACTIONS(1130),
    [anon_sym_finally] = ACTIONS(1130),
    [anon_sym_with] = ACTIONS(1130),
    [anon_sym_def] = ACTIONS(1130),
    [anon_sym_global] = ACTIONS(1130),
    [anon_sym_nonlocal] = ACTIONS(1130),
    [anon_sym_exec] = ACTIONS(1130),
    [anon_sym_type] = ACTIONS(1130),
    [anon_sym_class] = ACTIONS(1130),
    [anon_sym_LBRACK] = ACTIONS(1132),
    [anon_sym_AT] = ACTIONS(1132),
    [anon_sym_DASH] = ACTIONS(1132),
    [anon_sym_LBRACE] = ACTIONS(1132),
    [anon_sym_PLUS] = ACTIONS(1132),
    [anon_sym_not] = ACTIONS(1130),
    [anon_sym_TILDE] = ACTIONS(1132),
    [anon_sym_lambda] = ACTIONS(1130),
    [anon_sym_yield] = ACTIONS(1130),
    [sym_ellipsis] = ACTIONS(1132),
    [sym_integer] = ACTIONS(1130),
    [sym_float] = ACTIONS(1132),
    [anon_sym_await] = ACTIONS(1130),
    [sym_true] = ACTIONS(1130),
    [sym_false] = ACTIONS(1130),
    [sym_none] = ACTIONS(1130),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1130),
    [anon_sym_container] = ACTIONS(1130),
    [anon_sym_envvars] = ACTIONS(1130),
    [anon_sym_include] = ACTIONS(1130),
    [anon_sym_pepfile] = ACTIONS(1130),
    [anon_sym_pepschema] = ACTIONS(1130),
    [anon_sym_scattergather] = ACTIONS(1130),
    [anon_sym_version] = ACTIONS(1130),
    [anon_sym_wildcard_constraints] = ACTIONS(1130),
    [anon_sym_workdir] = ACTIONS(1130),
    [anon_sym_onerror] = ACTIONS(1130),
    [anon_sym_onstart] = ACTIONS(1130),
    [anon_sym_onsuccess] = ACTIONS(1130),
    [anon_sym_localrules] = ACTIONS(1130),
    [anon_sym_ruleorder] = ACTIONS(1130),
    [anon_sym_rule] = ACTIONS(1130),
    [anon_sym_checkpoint] = ACTIONS(1130),
    [anon_sym_use] = ACTIONS(1130),
    [anon_sym_module] = ACTIONS(1130),
    [sym_string_start] = ACTIONS(1132),
  },
  [287] = {
    [sym_identifier] = ACTIONS(1128),
    [anon_sym_import] = ACTIONS(1128),
    [anon_sym_from] = ACTIONS(1128),
    [anon_sym_LPAREN] = ACTIONS(1126),
    [anon_sym_STAR] = ACTIONS(1126),
    [anon_sym_print] = ACTIONS(1128),
    [anon_sym_assert] = ACTIONS(1128),
    [anon_sym_return] = ACTIONS(1128),
    [anon_sym_del] = ACTIONS(1128),
    [anon_sym_raise] = ACTIONS(1128),
    [anon_sym_pass] = ACTIONS(1128),
    [anon_sym_break] = ACTIONS(1128),
    [anon_sym_continue] = ACTIONS(1128),
    [anon_sym_if] = ACTIONS(1128),
    [anon_sym_else] = ACTIONS(1128),
    [anon_sym_match] = ACTIONS(1128),
    [anon_sym_async] = ACTIONS(1128),
    [anon_sym_for] = ACTIONS(1128),
    [anon_sym_while] = ACTIONS(1128),
    [anon_sym_try] = ACTIONS(1128),
    [anon_sym_except_STAR] = ACTIONS(1126),
    [anon_sym_finally] = ACTIONS(1128),
    [anon_sym_with] = ACTIONS(1128),
    [anon_sym_def] = ACTIONS(1128),
    [anon_sym_global] = ACTIONS(1128),
    [anon_sym_nonlocal] = ACTIONS(1128),
    [anon_sym_exec] = ACTIONS(1128),
    [anon_sym_type] = ACTIONS(1128),
    [anon_sym_class] = ACTIONS(1128),
    [anon_sym_LBRACK] = ACTIONS(1126),
    [anon_sym_AT] = ACTIONS(1126),
    [anon_sym_DASH] = ACTIONS(1126),
    [anon_sym_LBRACE] = ACTIONS(1126),
    [anon_sym_PLUS] = ACTIONS(1126),
    [anon_sym_not] = ACTIONS(1128),
    [anon_sym_TILDE] = ACTIONS(1126),
    [anon_sym_lambda] = ACTIONS(1128),
    [anon_sym_yield] = ACTIONS(1128),
    [sym_ellipsis] = ACTIONS(1126),
    [sym_integer] = ACTIONS(1128),
    [sym_float] = ACTIONS(1126),
    [anon_sym_await] = ACTIONS(1128),
    [sym_true] = ACTIONS(1128),
    [sym_false] = ACTIONS(1128),
    [sym_none] = ACTIONS(1128),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1128),
    [anon_sym_container] = ACTIONS(1128),
    [anon_sym_envvars] = ACTIONS(1128),
    [anon_sym_include] = ACTIONS(1128),
    [anon_sym_pepfile] = ACTIONS(1128),
    [anon_sym_pepschema] = ACTIONS(1128),
    [anon_sym_scattergather] = ACTIONS(1128),
    [anon_sym_version] = ACTIONS(1128),
    [anon_sym_wildcard_constraints] = ACTIONS(1128),
    [anon_sym_workdir] = ACTIONS(1128),
    [anon_sym_onerror] = ACTIONS(1128),
    [anon_sym_onstart] = ACTIONS(1128),
    [anon_sym_onsuccess] = ACTIONS(1128),
    [anon_sym_localrules] = ACTIONS(1128),
    [anon_sym_ruleorder] = ACTIONS(1128),
    [anon_sym_rule] = ACTIONS(1128),
    [anon_sym_checkpoint] = ACTIONS(1128),
    [anon_sym_use] = ACTIONS(1128),
    [anon_sym_module] = ACTIONS(1128),
    [sym__dedent] = ACTIONS(1126),
    [sym_string_start] = ACTIONS(1126),
  },
  [288] = {
    [sym_identifier] = ACTIONS(1124),
    [anon_sym_import] = ACTIONS(1124),
    [anon_sym_from] = ACTIONS(1124),
    [anon_sym_LPAREN] = ACTIONS(1122),
    [anon_sym_STAR] = ACTIONS(1122),
    [anon_sym_print] = ACTIONS(1124),
    [anon_sym_assert] = ACTIONS(1124),
    [anon_sym_return] = ACTIONS(1124),
    [anon_sym_del] = ACTIONS(1124),
    [anon_sym_raise] = ACTIONS(1124),
    [anon_sym_pass] = ACTIONS(1124),
    [anon_sym_break] = ACTIONS(1124),
    [anon_sym_continue] = ACTIONS(1124),
    [anon_sym_if] = ACTIONS(1124),
    [anon_sym_else] = ACTIONS(1124),
    [anon_sym_match] = ACTIONS(1124),
    [anon_sym_async] = ACTIONS(1124),
    [anon_sym_for] = ACTIONS(1124),
    [anon_sym_while] = ACTIONS(1124),
    [anon_sym_try] = ACTIONS(1124),
    [anon_sym_except] = ACTIONS(1124),
    [anon_sym_finally] = ACTIONS(1124),
    [anon_sym_with] = ACTIONS(1124),
    [anon_sym_def] = ACTIONS(1124),
    [anon_sym_global] = ACTIONS(1124),
    [anon_sym_nonlocal] = ACTIONS(1124),
    [anon_sym_exec] = ACTIONS(1124),
    [anon_sym_type] = ACTIONS(1124),
    [anon_sym_class] = ACTIONS(1124),
    [anon_sym_LBRACK] = ACTIONS(1122),
    [anon_sym_AT] = ACTIONS(1122),
    [anon_sym_DASH] = ACTIONS(1122),
    [anon_sym_LBRACE] = ACTIONS(1122),
    [anon_sym_PLUS] = ACTIONS(1122),
    [anon_sym_not] = ACTIONS(1124),
    [anon_sym_TILDE] = ACTIONS(1122),
    [anon_sym_lambda] = ACTIONS(1124),
    [anon_sym_yield] = ACTIONS(1124),
    [sym_ellipsis] = ACTIONS(1122),
    [sym_integer] = ACTIONS(1124),
    [sym_float] = ACTIONS(1122),
    [anon_sym_await] = ACTIONS(1124),
    [sym_true] = ACTIONS(1124),
    [sym_false] = ACTIONS(1124),
    [sym_none] = ACTIONS(1124),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1124),
    [anon_sym_container] = ACTIONS(1124),
    [anon_sym_envvars] = ACTIONS(1124),
    [anon_sym_include] = ACTIONS(1124),
    [anon_sym_pepfile] = ACTIONS(1124),
    [anon_sym_pepschema] = ACTIONS(1124),
    [anon_sym_scattergather] = ACTIONS(1124),
    [anon_sym_version] = ACTIONS(1124),
    [anon_sym_wildcard_constraints] = ACTIONS(1124),
    [anon_sym_workdir] = ACTIONS(1124),
    [anon_sym_onerror] = ACTIONS(1124),
    [anon_sym_onstart] = ACTIONS(1124),
    [anon_sym_onsuccess] = ACTIONS(1124),
    [anon_sym_localrules] = ACTIONS(1124),
    [anon_sym_ruleorder] = ACTIONS(1124),
    [anon_sym_rule] = ACTIONS(1124),
    [anon_sym_checkpoint] = ACTIONS(1124),
    [anon_sym_use] = ACTIONS(1124),
    [anon_sym_module] = ACTIONS(1124),
    [sym__dedent] = ACTIONS(1122),
    [sym_string_start] = ACTIONS(1122),
  },
  [289] = {
    [sym_identifier] = ACTIONS(1054),
    [anon_sym_import] = ACTIONS(1054),
    [anon_sym_from] = ACTIONS(1054),
    [anon_sym_LPAREN] = ACTIONS(1052),
    [anon_sym_STAR] = ACTIONS(1052),
    [anon_sym_print] = ACTIONS(1054),
    [anon_sym_assert] = ACTIONS(1054),
    [anon_sym_return] = ACTIONS(1054),
    [anon_sym_del] = ACTIONS(1054),
    [anon_sym_raise] = ACTIONS(1054),
    [anon_sym_pass] = ACTIONS(1054),
    [anon_sym_break] = ACTIONS(1054),
    [anon_sym_continue] = ACTIONS(1054),
    [anon_sym_if] = ACTIONS(1054),
    [anon_sym_else] = ACTIONS(1054),
    [anon_sym_match] = ACTIONS(1054),
    [anon_sym_async] = ACTIONS(1054),
    [anon_sym_for] = ACTIONS(1054),
    [anon_sym_while] = ACTIONS(1054),
    [anon_sym_try] = ACTIONS(1054),
    [anon_sym_except_STAR] = ACTIONS(1052),
    [anon_sym_finally] = ACTIONS(1054),
    [anon_sym_with] = ACTIONS(1054),
    [anon_sym_def] = ACTIONS(1054),
    [anon_sym_global] = ACTIONS(1054),
    [anon_sym_nonlocal] = ACTIONS(1054),
    [anon_sym_exec] = ACTIONS(1054),
    [anon_sym_type] = ACTIONS(1054),
    [anon_sym_class] = ACTIONS(1054),
    [anon_sym_LBRACK] = ACTIONS(1052),
    [anon_sym_AT] = ACTIONS(1052),
    [anon_sym_DASH] = ACTIONS(1052),
    [anon_sym_LBRACE] = ACTIONS(1052),
    [anon_sym_PLUS] = ACTIONS(1052),
    [anon_sym_not] = ACTIONS(1054),
    [anon_sym_TILDE] = ACTIONS(1052),
    [anon_sym_lambda] = ACTIONS(1054),
    [anon_sym_yield] = ACTIONS(1054),
    [sym_ellipsis] = ACTIONS(1052),
    [sym_integer] = ACTIONS(1054),
    [sym_float] = ACTIONS(1052),
    [anon_sym_await] = ACTIONS(1054),
    [sym_true] = ACTIONS(1054),
    [sym_false] = ACTIONS(1054),
    [sym_none] = ACTIONS(1054),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1054),
    [anon_sym_container] = ACTIONS(1054),
    [anon_sym_envvars] = ACTIONS(1054),
    [anon_sym_include] = ACTIONS(1054),
    [anon_sym_pepfile] = ACTIONS(1054),
    [anon_sym_pepschema] = ACTIONS(1054),
    [anon_sym_scattergather] = ACTIONS(1054),
    [anon_sym_version] = ACTIONS(1054),
    [anon_sym_wildcard_constraints] = ACTIONS(1054),
    [anon_sym_workdir] = ACTIONS(1054),
    [anon_sym_onerror] = ACTIONS(1054),
    [anon_sym_onstart] = ACTIONS(1054),
    [anon_sym_onsuccess] = ACTIONS(1054),
    [anon_sym_localrules] = ACTIONS(1054),
    [anon_sym_ruleorder] = ACTIONS(1054),
    [anon_sym_rule] = ACTIONS(1054),
    [anon_sym_checkpoint] = ACTIONS(1054),
    [anon_sym_use] = ACTIONS(1054),
    [anon_sym_module] = ACTIONS(1054),
    [sym__dedent] = ACTIONS(1052),
    [sym_string_start] = ACTIONS(1052),
  },
  [290] = {
    [sym_identifier] = ACTIONS(1109),
    [anon_sym_import] = ACTIONS(1109),
    [anon_sym_from] = ACTIONS(1109),
    [anon_sym_LPAREN] = ACTIONS(1107),
    [anon_sym_STAR] = ACTIONS(1107),
    [anon_sym_print] = ACTIONS(1109),
    [anon_sym_assert] = ACTIONS(1109),
    [anon_sym_return] = ACTIONS(1109),
    [anon_sym_del] = ACTIONS(1109),
    [anon_sym_raise] = ACTIONS(1109),
    [anon_sym_pass] = ACTIONS(1109),
    [anon_sym_break] = ACTIONS(1109),
    [anon_sym_continue] = ACTIONS(1109),
    [anon_sym_if] = ACTIONS(1109),
    [anon_sym_else] = ACTIONS(1109),
    [anon_sym_match] = ACTIONS(1109),
    [anon_sym_async] = ACTIONS(1109),
    [anon_sym_for] = ACTIONS(1109),
    [anon_sym_while] = ACTIONS(1109),
    [anon_sym_try] = ACTIONS(1109),
    [anon_sym_except] = ACTIONS(1109),
    [anon_sym_finally] = ACTIONS(1109),
    [anon_sym_with] = ACTIONS(1109),
    [anon_sym_def] = ACTIONS(1109),
    [anon_sym_global] = ACTIONS(1109),
    [anon_sym_nonlocal] = ACTIONS(1109),
    [anon_sym_exec] = ACTIONS(1109),
    [anon_sym_type] = ACTIONS(1109),
    [anon_sym_class] = ACTIONS(1109),
    [anon_sym_LBRACK] = ACTIONS(1107),
    [anon_sym_AT] = ACTIONS(1107),
    [anon_sym_DASH] = ACTIONS(1107),
    [anon_sym_LBRACE] = ACTIONS(1107),
    [anon_sym_PLUS] = ACTIONS(1107),
    [anon_sym_not] = ACTIONS(1109),
    [anon_sym_TILDE] = ACTIONS(1107),
    [anon_sym_lambda] = ACTIONS(1109),
    [anon_sym_yield] = ACTIONS(1109),
    [sym_ellipsis] = ACTIONS(1107),
    [sym_integer] = ACTIONS(1109),
    [sym_float] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(1109),
    [sym_true] = ACTIONS(1109),
    [sym_false] = ACTIONS(1109),
    [sym_none] = ACTIONS(1109),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1109),
    [anon_sym_container] = ACTIONS(1109),
    [anon_sym_envvars] = ACTIONS(1109),
    [anon_sym_include] = ACTIONS(1109),
    [anon_sym_pepfile] = ACTIONS(1109),
    [anon_sym_pepschema] = ACTIONS(1109),
    [anon_sym_scattergather] = ACTIONS(1109),
    [anon_sym_version] = ACTIONS(1109),
    [anon_sym_wildcard_constraints] = ACTIONS(1109),
    [anon_sym_workdir] = ACTIONS(1109),
    [anon_sym_onerror] = ACTIONS(1109),
    [anon_sym_onstart] = ACTIONS(1109),
    [anon_sym_onsuccess] = ACTIONS(1109),
    [anon_sym_localrules] = ACTIONS(1109),
    [anon_sym_ruleorder] = ACTIONS(1109),
    [anon_sym_rule] = ACTIONS(1109),
    [anon_sym_checkpoint] = ACTIONS(1109),
    [anon_sym_use] = ACTIONS(1109),
    [anon_sym_module] = ACTIONS(1109),
    [sym__dedent] = ACTIONS(1107),
    [sym_string_start] = ACTIONS(1107),
  },
  [291] = {
    [sym_identifier] = ACTIONS(1134),
    [anon_sym_import] = ACTIONS(1134),
    [anon_sym_from] = ACTIONS(1134),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [anon_sym_as] = ACTIONS(1138),
    [anon_sym_STAR] = ACTIONS(1136),
    [anon_sym_print] = ACTIONS(1134),
    [anon_sym_assert] = ACTIONS(1134),
    [anon_sym_return] = ACTIONS(1134),
    [anon_sym_del] = ACTIONS(1134),
    [anon_sym_raise] = ACTIONS(1134),
    [anon_sym_pass] = ACTIONS(1134),
    [anon_sym_break] = ACTIONS(1134),
    [anon_sym_continue] = ACTIONS(1134),
    [anon_sym_if] = ACTIONS(1134),
    [anon_sym_match] = ACTIONS(1134),
    [anon_sym_async] = ACTIONS(1134),
    [anon_sym_for] = ACTIONS(1134),
    [anon_sym_while] = ACTIONS(1134),
    [anon_sym_try] = ACTIONS(1134),
    [anon_sym_with] = ACTIONS(1140),
    [anon_sym_def] = ACTIONS(1134),
    [anon_sym_global] = ACTIONS(1134),
    [anon_sym_nonlocal] = ACTIONS(1134),
    [anon_sym_exec] = ACTIONS(1134),
    [anon_sym_type] = ACTIONS(1134),
    [anon_sym_class] = ACTIONS(1134),
    [anon_sym_LBRACK] = ACTIONS(1136),
    [anon_sym_AT] = ACTIONS(1136),
    [anon_sym_DASH] = ACTIONS(1136),
    [anon_sym_LBRACE] = ACTIONS(1136),
    [anon_sym_PLUS] = ACTIONS(1136),
    [anon_sym_not] = ACTIONS(1134),
    [anon_sym_TILDE] = ACTIONS(1136),
    [anon_sym_lambda] = ACTIONS(1134),
    [anon_sym_yield] = ACTIONS(1134),
    [sym_ellipsis] = ACTIONS(1136),
    [sym_integer] = ACTIONS(1134),
    [sym_float] = ACTIONS(1136),
    [anon_sym_await] = ACTIONS(1134),
    [sym_true] = ACTIONS(1134),
    [sym_false] = ACTIONS(1134),
    [sym_none] = ACTIONS(1134),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1134),
    [anon_sym_container] = ACTIONS(1134),
    [anon_sym_envvars] = ACTIONS(1134),
    [anon_sym_include] = ACTIONS(1134),
    [anon_sym_pepfile] = ACTIONS(1134),
    [anon_sym_pepschema] = ACTIONS(1134),
    [anon_sym_scattergather] = ACTIONS(1134),
    [anon_sym_version] = ACTIONS(1134),
    [anon_sym_wildcard_constraints] = ACTIONS(1134),
    [anon_sym_workdir] = ACTIONS(1134),
    [anon_sym_onerror] = ACTIONS(1134),
    [anon_sym_onstart] = ACTIONS(1134),
    [anon_sym_onsuccess] = ACTIONS(1134),
    [anon_sym_localrules] = ACTIONS(1134),
    [anon_sym_ruleorder] = ACTIONS(1134),
    [anon_sym_rule] = ACTIONS(1134),
    [anon_sym_checkpoint] = ACTIONS(1134),
    [anon_sym_use] = ACTIONS(1134),
    [anon_sym_exclude] = ACTIONS(1142),
    [anon_sym_module] = ACTIONS(1134),
    [sym__dedent] = ACTIONS(1136),
    [sym_string_start] = ACTIONS(1136),
  },
  [292] = {
    [sym_finally_clause] = STATE(368),
    [sym_identifier] = ACTIONS(1144),
    [anon_sym_import] = ACTIONS(1144),
    [anon_sym_from] = ACTIONS(1144),
    [anon_sym_LPAREN] = ACTIONS(1146),
    [anon_sym_STAR] = ACTIONS(1146),
    [anon_sym_print] = ACTIONS(1144),
    [anon_sym_assert] = ACTIONS(1144),
    [anon_sym_return] = ACTIONS(1144),
    [anon_sym_del] = ACTIONS(1144),
    [anon_sym_raise] = ACTIONS(1144),
    [anon_sym_pass] = ACTIONS(1144),
    [anon_sym_break] = ACTIONS(1144),
    [anon_sym_continue] = ACTIONS(1144),
    [anon_sym_if] = ACTIONS(1144),
    [anon_sym_match] = ACTIONS(1144),
    [anon_sym_async] = ACTIONS(1144),
    [anon_sym_for] = ACTIONS(1144),
    [anon_sym_while] = ACTIONS(1144),
    [anon_sym_try] = ACTIONS(1144),
    [anon_sym_finally] = ACTIONS(824),
    [anon_sym_with] = ACTIONS(1144),
    [anon_sym_def] = ACTIONS(1144),
    [anon_sym_global] = ACTIONS(1144),
    [anon_sym_nonlocal] = ACTIONS(1144),
    [anon_sym_exec] = ACTIONS(1144),
    [anon_sym_type] = ACTIONS(1144),
    [anon_sym_class] = ACTIONS(1144),
    [anon_sym_LBRACK] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(1146),
    [anon_sym_DASH] = ACTIONS(1146),
    [anon_sym_LBRACE] = ACTIONS(1146),
    [anon_sym_PLUS] = ACTIONS(1146),
    [anon_sym_not] = ACTIONS(1144),
    [anon_sym_TILDE] = ACTIONS(1146),
    [anon_sym_lambda] = ACTIONS(1144),
    [anon_sym_yield] = ACTIONS(1144),
    [sym_ellipsis] = ACTIONS(1146),
    [sym_integer] = ACTIONS(1144),
    [sym_float] = ACTIONS(1146),
    [anon_sym_await] = ACTIONS(1144),
    [sym_true] = ACTIONS(1144),
    [sym_false] = ACTIONS(1144),
    [sym_none] = ACTIONS(1144),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1144),
    [anon_sym_container] = ACTIONS(1144),
    [anon_sym_envvars] = ACTIONS(1144),
    [anon_sym_include] = ACTIONS(1144),
    [anon_sym_pepfile] = ACTIONS(1144),
    [anon_sym_pepschema] = ACTIONS(1144),
    [anon_sym_scattergather] = ACTIONS(1144),
    [anon_sym_version] = ACTIONS(1144),
    [anon_sym_wildcard_constraints] = ACTIONS(1144),
    [anon_sym_workdir] = ACTIONS(1144),
    [anon_sym_onerror] = ACTIONS(1144),
    [anon_sym_onstart] = ACTIONS(1144),
    [anon_sym_onsuccess] = ACTIONS(1144),
    [anon_sym_localrules] = ACTIONS(1144),
    [anon_sym_ruleorder] = ACTIONS(1144),
    [anon_sym_rule] = ACTIONS(1144),
    [anon_sym_checkpoint] = ACTIONS(1144),
    [anon_sym_use] = ACTIONS(1144),
    [anon_sym_module] = ACTIONS(1144),
    [sym__dedent] = ACTIONS(1146),
    [sym_string_start] = ACTIONS(1146),
  },
  [293] = {
    [sym_else_clause] = STATE(423),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_import] = ACTIONS(1148),
    [anon_sym_from] = ACTIONS(1148),
    [anon_sym_LPAREN] = ACTIONS(1150),
    [anon_sym_STAR] = ACTIONS(1150),
    [anon_sym_print] = ACTIONS(1148),
    [anon_sym_assert] = ACTIONS(1148),
    [anon_sym_return] = ACTIONS(1148),
    [anon_sym_del] = ACTIONS(1148),
    [anon_sym_raise] = ACTIONS(1148),
    [anon_sym_pass] = ACTIONS(1148),
    [anon_sym_break] = ACTIONS(1148),
    [anon_sym_continue] = ACTIONS(1148),
    [anon_sym_if] = ACTIONS(1148),
    [anon_sym_else] = ACTIONS(820),
    [anon_sym_match] = ACTIONS(1148),
    [anon_sym_async] = ACTIONS(1148),
    [anon_sym_for] = ACTIONS(1148),
    [anon_sym_while] = ACTIONS(1148),
    [anon_sym_try] = ACTIONS(1148),
    [anon_sym_with] = ACTIONS(1148),
    [anon_sym_def] = ACTIONS(1148),
    [anon_sym_global] = ACTIONS(1148),
    [anon_sym_nonlocal] = ACTIONS(1148),
    [anon_sym_exec] = ACTIONS(1148),
    [anon_sym_type] = ACTIONS(1148),
    [anon_sym_class] = ACTIONS(1148),
    [anon_sym_LBRACK] = ACTIONS(1150),
    [anon_sym_AT] = ACTIONS(1150),
    [anon_sym_DASH] = ACTIONS(1150),
    [anon_sym_LBRACE] = ACTIONS(1150),
    [anon_sym_PLUS] = ACTIONS(1150),
    [anon_sym_not] = ACTIONS(1148),
    [anon_sym_TILDE] = ACTIONS(1150),
    [anon_sym_lambda] = ACTIONS(1148),
    [anon_sym_yield] = ACTIONS(1148),
    [sym_ellipsis] = ACTIONS(1150),
    [sym_integer] = ACTIONS(1148),
    [sym_float] = ACTIONS(1150),
    [anon_sym_await] = ACTIONS(1148),
    [sym_true] = ACTIONS(1148),
    [sym_false] = ACTIONS(1148),
    [sym_none] = ACTIONS(1148),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1148),
    [anon_sym_container] = ACTIONS(1148),
    [anon_sym_envvars] = ACTIONS(1148),
    [anon_sym_include] = ACTIONS(1148),
    [anon_sym_pepfile] = ACTIONS(1148),
    [anon_sym_pepschema] = ACTIONS(1148),
    [anon_sym_scattergather] = ACTIONS(1148),
    [anon_sym_version] = ACTIONS(1148),
    [anon_sym_wildcard_constraints] = ACTIONS(1148),
    [anon_sym_workdir] = ACTIONS(1148),
    [anon_sym_onerror] = ACTIONS(1148),
    [anon_sym_onstart] = ACTIONS(1148),
    [anon_sym_onsuccess] = ACTIONS(1148),
    [anon_sym_localrules] = ACTIONS(1148),
    [anon_sym_ruleorder] = ACTIONS(1148),
    [anon_sym_rule] = ACTIONS(1148),
    [anon_sym_checkpoint] = ACTIONS(1148),
    [anon_sym_use] = ACTIONS(1148),
    [anon_sym_module] = ACTIONS(1148),
    [sym__dedent] = ACTIONS(1150),
    [sym_string_start] = ACTIONS(1150),
  },
  [294] = {
    [sym_else_clause] = STATE(364),
    [sym_identifier] = ACTIONS(1152),
    [anon_sym_import] = ACTIONS(1152),
    [anon_sym_from] = ACTIONS(1152),
    [anon_sym_LPAREN] = ACTIONS(1154),
    [anon_sym_STAR] = ACTIONS(1154),
    [anon_sym_print] = ACTIONS(1152),
    [anon_sym_assert] = ACTIONS(1152),
    [anon_sym_return] = ACTIONS(1152),
    [anon_sym_del] = ACTIONS(1152),
    [anon_sym_raise] = ACTIONS(1152),
    [anon_sym_pass] = ACTIONS(1152),
    [anon_sym_break] = ACTIONS(1152),
    [anon_sym_continue] = ACTIONS(1152),
    [anon_sym_if] = ACTIONS(1152),
    [anon_sym_else] = ACTIONS(820),
    [anon_sym_match] = ACTIONS(1152),
    [anon_sym_async] = ACTIONS(1152),
    [anon_sym_for] = ACTIONS(1152),
    [anon_sym_while] = ACTIONS(1152),
    [anon_sym_try] = ACTIONS(1152),
    [anon_sym_with] = ACTIONS(1152),
    [anon_sym_def] = ACTIONS(1152),
    [anon_sym_global] = ACTIONS(1152),
    [anon_sym_nonlocal] = ACTIONS(1152),
    [anon_sym_exec] = ACTIONS(1152),
    [anon_sym_type] = ACTIONS(1152),
    [anon_sym_class] = ACTIONS(1152),
    [anon_sym_LBRACK] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(1154),
    [anon_sym_DASH] = ACTIONS(1154),
    [anon_sym_LBRACE] = ACTIONS(1154),
    [anon_sym_PLUS] = ACTIONS(1154),
    [anon_sym_not] = ACTIONS(1152),
    [anon_sym_TILDE] = ACTIONS(1154),
    [anon_sym_lambda] = ACTIONS(1152),
    [anon_sym_yield] = ACTIONS(1152),
    [sym_ellipsis] = ACTIONS(1154),
    [sym_integer] = ACTIONS(1152),
    [sym_float] = ACTIONS(1154),
    [anon_sym_await] = ACTIONS(1152),
    [sym_true] = ACTIONS(1152),
    [sym_false] = ACTIONS(1152),
    [sym_none] = ACTIONS(1152),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1152),
    [anon_sym_container] = ACTIONS(1152),
    [anon_sym_envvars] = ACTIONS(1152),
    [anon_sym_include] = ACTIONS(1152),
    [anon_sym_pepfile] = ACTIONS(1152),
    [anon_sym_pepschema] = ACTIONS(1152),
    [anon_sym_scattergather] = ACTIONS(1152),
    [anon_sym_version] = ACTIONS(1152),
    [anon_sym_wildcard_constraints] = ACTIONS(1152),
    [anon_sym_workdir] = ACTIONS(1152),
    [anon_sym_onerror] = ACTIONS(1152),
    [anon_sym_onstart] = ACTIONS(1152),
    [anon_sym_onsuccess] = ACTIONS(1152),
    [anon_sym_localrules] = ACTIONS(1152),
    [anon_sym_ruleorder] = ACTIONS(1152),
    [anon_sym_rule] = ACTIONS(1152),
    [anon_sym_checkpoint] = ACTIONS(1152),
    [anon_sym_use] = ACTIONS(1152),
    [anon_sym_module] = ACTIONS(1152),
    [sym__dedent] = ACTIONS(1154),
    [sym_string_start] = ACTIONS(1154),
  },
  [295] = {
    [sym_else_clause] = STATE(386),
    [ts_builtin_sym_end] = ACTIONS(1154),
    [sym_identifier] = ACTIONS(1152),
    [anon_sym_import] = ACTIONS(1152),
    [anon_sym_from] = ACTIONS(1152),
    [anon_sym_LPAREN] = ACTIONS(1154),
    [anon_sym_STAR] = ACTIONS(1154),
    [anon_sym_print] = ACTIONS(1152),
    [anon_sym_assert] = ACTIONS(1152),
    [anon_sym_return] = ACTIONS(1152),
    [anon_sym_del] = ACTIONS(1152),
    [anon_sym_raise] = ACTIONS(1152),
    [anon_sym_pass] = ACTIONS(1152),
    [anon_sym_break] = ACTIONS(1152),
    [anon_sym_continue] = ACTIONS(1152),
    [anon_sym_if] = ACTIONS(1152),
    [anon_sym_else] = ACTIONS(808),
    [anon_sym_match] = ACTIONS(1152),
    [anon_sym_async] = ACTIONS(1152),
    [anon_sym_for] = ACTIONS(1152),
    [anon_sym_while] = ACTIONS(1152),
    [anon_sym_try] = ACTIONS(1152),
    [anon_sym_with] = ACTIONS(1152),
    [anon_sym_def] = ACTIONS(1152),
    [anon_sym_global] = ACTIONS(1152),
    [anon_sym_nonlocal] = ACTIONS(1152),
    [anon_sym_exec] = ACTIONS(1152),
    [anon_sym_type] = ACTIONS(1152),
    [anon_sym_class] = ACTIONS(1152),
    [anon_sym_LBRACK] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(1154),
    [anon_sym_DASH] = ACTIONS(1154),
    [anon_sym_LBRACE] = ACTIONS(1154),
    [anon_sym_PLUS] = ACTIONS(1154),
    [anon_sym_not] = ACTIONS(1152),
    [anon_sym_TILDE] = ACTIONS(1154),
    [anon_sym_lambda] = ACTIONS(1152),
    [anon_sym_yield] = ACTIONS(1152),
    [sym_ellipsis] = ACTIONS(1154),
    [sym_integer] = ACTIONS(1152),
    [sym_float] = ACTIONS(1154),
    [anon_sym_await] = ACTIONS(1152),
    [sym_true] = ACTIONS(1152),
    [sym_false] = ACTIONS(1152),
    [sym_none] = ACTIONS(1152),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1152),
    [anon_sym_container] = ACTIONS(1152),
    [anon_sym_envvars] = ACTIONS(1152),
    [anon_sym_include] = ACTIONS(1152),
    [anon_sym_pepfile] = ACTIONS(1152),
    [anon_sym_pepschema] = ACTIONS(1152),
    [anon_sym_scattergather] = ACTIONS(1152),
    [anon_sym_version] = ACTIONS(1152),
    [anon_sym_wildcard_constraints] = ACTIONS(1152),
    [anon_sym_workdir] = ACTIONS(1152),
    [anon_sym_onerror] = ACTIONS(1152),
    [anon_sym_onstart] = ACTIONS(1152),
    [anon_sym_onsuccess] = ACTIONS(1152),
    [anon_sym_localrules] = ACTIONS(1152),
    [anon_sym_ruleorder] = ACTIONS(1152),
    [anon_sym_rule] = ACTIONS(1152),
    [anon_sym_checkpoint] = ACTIONS(1152),
    [anon_sym_use] = ACTIONS(1152),
    [anon_sym_module] = ACTIONS(1152),
    [sym_string_start] = ACTIONS(1154),
  },
  [296] = {
    [aux_sym___directive_parameters_ruleorder_repeat1] = STATE(301),
    [ts_builtin_sym_end] = ACTIONS(1156),
    [sym_identifier] = ACTIONS(1158),
    [anon_sym_import] = ACTIONS(1158),
    [anon_sym_from] = ACTIONS(1158),
    [anon_sym_LPAREN] = ACTIONS(1156),
    [anon_sym_STAR] = ACTIONS(1156),
    [anon_sym_print] = ACTIONS(1158),
    [anon_sym_assert] = ACTIONS(1158),
    [anon_sym_return] = ACTIONS(1158),
    [anon_sym_del] = ACTIONS(1158),
    [anon_sym_raise] = ACTIONS(1158),
    [anon_sym_pass] = ACTIONS(1158),
    [anon_sym_break] = ACTIONS(1158),
    [anon_sym_continue] = ACTIONS(1158),
    [anon_sym_if] = ACTIONS(1158),
    [anon_sym_match] = ACTIONS(1158),
    [anon_sym_async] = ACTIONS(1158),
    [anon_sym_for] = ACTIONS(1158),
    [anon_sym_while] = ACTIONS(1158),
    [anon_sym_try] = ACTIONS(1158),
    [anon_sym_with] = ACTIONS(1158),
    [anon_sym_def] = ACTIONS(1158),
    [anon_sym_global] = ACTIONS(1158),
    [anon_sym_nonlocal] = ACTIONS(1158),
    [anon_sym_exec] = ACTIONS(1158),
    [anon_sym_type] = ACTIONS(1158),
    [anon_sym_class] = ACTIONS(1158),
    [anon_sym_LBRACK] = ACTIONS(1156),
    [anon_sym_AT] = ACTIONS(1156),
    [anon_sym_DASH] = ACTIONS(1156),
    [anon_sym_LBRACE] = ACTIONS(1156),
    [anon_sym_PLUS] = ACTIONS(1156),
    [anon_sym_not] = ACTIONS(1158),
    [anon_sym_TILDE] = ACTIONS(1156),
    [anon_sym_GT] = ACTIONS(1160),
    [anon_sym_lambda] = ACTIONS(1158),
    [anon_sym_yield] = ACTIONS(1158),
    [sym_ellipsis] = ACTIONS(1156),
    [sym_integer] = ACTIONS(1158),
    [sym_float] = ACTIONS(1156),
    [anon_sym_await] = ACTIONS(1158),
    [sym_true] = ACTIONS(1158),
    [sym_false] = ACTIONS(1158),
    [sym_none] = ACTIONS(1158),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1158),
    [anon_sym_container] = ACTIONS(1158),
    [anon_sym_envvars] = ACTIONS(1158),
    [anon_sym_include] = ACTIONS(1158),
    [anon_sym_pepfile] = ACTIONS(1158),
    [anon_sym_pepschema] = ACTIONS(1158),
    [anon_sym_scattergather] = ACTIONS(1158),
    [anon_sym_version] = ACTIONS(1158),
    [anon_sym_wildcard_constraints] = ACTIONS(1158),
    [anon_sym_workdir] = ACTIONS(1158),
    [anon_sym_onerror] = ACTIONS(1158),
    [anon_sym_onstart] = ACTIONS(1158),
    [anon_sym_onsuccess] = ACTIONS(1158),
    [anon_sym_localrules] = ACTIONS(1158),
    [anon_sym_ruleorder] = ACTIONS(1158),
    [anon_sym_rule] = ACTIONS(1158),
    [anon_sym_checkpoint] = ACTIONS(1158),
    [anon_sym_use] = ACTIONS(1158),
    [anon_sym_module] = ACTIONS(1158),
    [sym_string_start] = ACTIONS(1156),
  },
  [297] = {
    [sym_finally_clause] = STATE(396),
    [sym_identifier] = ACTIONS(1162),
    [anon_sym_import] = ACTIONS(1162),
    [anon_sym_from] = ACTIONS(1162),
    [anon_sym_LPAREN] = ACTIONS(1164),
    [anon_sym_STAR] = ACTIONS(1164),
    [anon_sym_print] = ACTIONS(1162),
    [anon_sym_assert] = ACTIONS(1162),
    [anon_sym_return] = ACTIONS(1162),
    [anon_sym_del] = ACTIONS(1162),
    [anon_sym_raise] = ACTIONS(1162),
    [anon_sym_pass] = ACTIONS(1162),
    [anon_sym_break] = ACTIONS(1162),
    [anon_sym_continue] = ACTIONS(1162),
    [anon_sym_if] = ACTIONS(1162),
    [anon_sym_match] = ACTIONS(1162),
    [anon_sym_async] = ACTIONS(1162),
    [anon_sym_for] = ACTIONS(1162),
    [anon_sym_while] = ACTIONS(1162),
    [anon_sym_try] = ACTIONS(1162),
    [anon_sym_finally] = ACTIONS(824),
    [anon_sym_with] = ACTIONS(1162),
    [anon_sym_def] = ACTIONS(1162),
    [anon_sym_global] = ACTIONS(1162),
    [anon_sym_nonlocal] = ACTIONS(1162),
    [anon_sym_exec] = ACTIONS(1162),
    [anon_sym_type] = ACTIONS(1162),
    [anon_sym_class] = ACTIONS(1162),
    [anon_sym_LBRACK] = ACTIONS(1164),
    [anon_sym_AT] = ACTIONS(1164),
    [anon_sym_DASH] = ACTIONS(1164),
    [anon_sym_LBRACE] = ACTIONS(1164),
    [anon_sym_PLUS] = ACTIONS(1164),
    [anon_sym_not] = ACTIONS(1162),
    [anon_sym_TILDE] = ACTIONS(1164),
    [anon_sym_lambda] = ACTIONS(1162),
    [anon_sym_yield] = ACTIONS(1162),
    [sym_ellipsis] = ACTIONS(1164),
    [sym_integer] = ACTIONS(1162),
    [sym_float] = ACTIONS(1164),
    [anon_sym_await] = ACTIONS(1162),
    [sym_true] = ACTIONS(1162),
    [sym_false] = ACTIONS(1162),
    [sym_none] = ACTIONS(1162),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1162),
    [anon_sym_container] = ACTIONS(1162),
    [anon_sym_envvars] = ACTIONS(1162),
    [anon_sym_include] = ACTIONS(1162),
    [anon_sym_pepfile] = ACTIONS(1162),
    [anon_sym_pepschema] = ACTIONS(1162),
    [anon_sym_scattergather] = ACTIONS(1162),
    [anon_sym_version] = ACTIONS(1162),
    [anon_sym_wildcard_constraints] = ACTIONS(1162),
    [anon_sym_workdir] = ACTIONS(1162),
    [anon_sym_onerror] = ACTIONS(1162),
    [anon_sym_onstart] = ACTIONS(1162),
    [anon_sym_onsuccess] = ACTIONS(1162),
    [anon_sym_localrules] = ACTIONS(1162),
    [anon_sym_ruleorder] = ACTIONS(1162),
    [anon_sym_rule] = ACTIONS(1162),
    [anon_sym_checkpoint] = ACTIONS(1162),
    [anon_sym_use] = ACTIONS(1162),
    [anon_sym_module] = ACTIONS(1162),
    [sym__dedent] = ACTIONS(1164),
    [sym_string_start] = ACTIONS(1164),
  },
  [298] = {
    [sym_finally_clause] = STATE(378),
    [ts_builtin_sym_end] = ACTIONS(1146),
    [sym_identifier] = ACTIONS(1144),
    [anon_sym_import] = ACTIONS(1144),
    [anon_sym_from] = ACTIONS(1144),
    [anon_sym_LPAREN] = ACTIONS(1146),
    [anon_sym_STAR] = ACTIONS(1146),
    [anon_sym_print] = ACTIONS(1144),
    [anon_sym_assert] = ACTIONS(1144),
    [anon_sym_return] = ACTIONS(1144),
    [anon_sym_del] = ACTIONS(1144),
    [anon_sym_raise] = ACTIONS(1144),
    [anon_sym_pass] = ACTIONS(1144),
    [anon_sym_break] = ACTIONS(1144),
    [anon_sym_continue] = ACTIONS(1144),
    [anon_sym_if] = ACTIONS(1144),
    [anon_sym_match] = ACTIONS(1144),
    [anon_sym_async] = ACTIONS(1144),
    [anon_sym_for] = ACTIONS(1144),
    [anon_sym_while] = ACTIONS(1144),
    [anon_sym_try] = ACTIONS(1144),
    [anon_sym_finally] = ACTIONS(812),
    [anon_sym_with] = ACTIONS(1144),
    [anon_sym_def] = ACTIONS(1144),
    [anon_sym_global] = ACTIONS(1144),
    [anon_sym_nonlocal] = ACTIONS(1144),
    [anon_sym_exec] = ACTIONS(1144),
    [anon_sym_type] = ACTIONS(1144),
    [anon_sym_class] = ACTIONS(1144),
    [anon_sym_LBRACK] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(1146),
    [anon_sym_DASH] = ACTIONS(1146),
    [anon_sym_LBRACE] = ACTIONS(1146),
    [anon_sym_PLUS] = ACTIONS(1146),
    [anon_sym_not] = ACTIONS(1144),
    [anon_sym_TILDE] = ACTIONS(1146),
    [anon_sym_lambda] = ACTIONS(1144),
    [anon_sym_yield] = ACTIONS(1144),
    [sym_ellipsis] = ACTIONS(1146),
    [sym_integer] = ACTIONS(1144),
    [sym_float] = ACTIONS(1146),
    [anon_sym_await] = ACTIONS(1144),
    [sym_true] = ACTIONS(1144),
    [sym_false] = ACTIONS(1144),
    [sym_none] = ACTIONS(1144),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1144),
    [anon_sym_container] = ACTIONS(1144),
    [anon_sym_envvars] = ACTIONS(1144),
    [anon_sym_include] = ACTIONS(1144),
    [anon_sym_pepfile] = ACTIONS(1144),
    [anon_sym_pepschema] = ACTIONS(1144),
    [anon_sym_scattergather] = ACTIONS(1144),
    [anon_sym_version] = ACTIONS(1144),
    [anon_sym_wildcard_constraints] = ACTIONS(1144),
    [anon_sym_workdir] = ACTIONS(1144),
    [anon_sym_onerror] = ACTIONS(1144),
    [anon_sym_onstart] = ACTIONS(1144),
    [anon_sym_onsuccess] = ACTIONS(1144),
    [anon_sym_localrules] = ACTIONS(1144),
    [anon_sym_ruleorder] = ACTIONS(1144),
    [anon_sym_rule] = ACTIONS(1144),
    [anon_sym_checkpoint] = ACTIONS(1144),
    [anon_sym_use] = ACTIONS(1144),
    [anon_sym_module] = ACTIONS(1144),
    [sym_string_start] = ACTIONS(1146),
  },
  [299] = {
    [ts_builtin_sym_end] = ACTIONS(1136),
    [sym_identifier] = ACTIONS(1134),
    [anon_sym_import] = ACTIONS(1134),
    [anon_sym_from] = ACTIONS(1134),
    [anon_sym_LPAREN] = ACTIONS(1136),
    [anon_sym_as] = ACTIONS(1166),
    [anon_sym_STAR] = ACTIONS(1136),
    [anon_sym_print] = ACTIONS(1134),
    [anon_sym_assert] = ACTIONS(1134),
    [anon_sym_return] = ACTIONS(1134),
    [anon_sym_del] = ACTIONS(1134),
    [anon_sym_raise] = ACTIONS(1134),
    [anon_sym_pass] = ACTIONS(1134),
    [anon_sym_break] = ACTIONS(1134),
    [anon_sym_continue] = ACTIONS(1134),
    [anon_sym_if] = ACTIONS(1134),
    [anon_sym_match] = ACTIONS(1134),
    [anon_sym_async] = ACTIONS(1134),
    [anon_sym_for] = ACTIONS(1134),
    [anon_sym_while] = ACTIONS(1134),
    [anon_sym_try] = ACTIONS(1134),
    [anon_sym_with] = ACTIONS(1168),
    [anon_sym_def] = ACTIONS(1134),
    [anon_sym_global] = ACTIONS(1134),
    [anon_sym_nonlocal] = ACTIONS(1134),
    [anon_sym_exec] = ACTIONS(1134),
    [anon_sym_type] = ACTIONS(1134),
    [anon_sym_class] = ACTIONS(1134),
    [anon_sym_LBRACK] = ACTIONS(1136),
    [anon_sym_AT] = ACTIONS(1136),
    [anon_sym_DASH] = ACTIONS(1136),
    [anon_sym_LBRACE] = ACTIONS(1136),
    [anon_sym_PLUS] = ACTIONS(1136),
    [anon_sym_not] = ACTIONS(1134),
    [anon_sym_TILDE] = ACTIONS(1136),
    [anon_sym_lambda] = ACTIONS(1134),
    [anon_sym_yield] = ACTIONS(1134),
    [sym_ellipsis] = ACTIONS(1136),
    [sym_integer] = ACTIONS(1134),
    [sym_float] = ACTIONS(1136),
    [anon_sym_await] = ACTIONS(1134),
    [sym_true] = ACTIONS(1134),
    [sym_false] = ACTIONS(1134),
    [sym_none] = ACTIONS(1134),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1134),
    [anon_sym_container] = ACTIONS(1134),
    [anon_sym_envvars] = ACTIONS(1134),
    [anon_sym_include] = ACTIONS(1134),
    [anon_sym_pepfile] = ACTIONS(1134),
    [anon_sym_pepschema] = ACTIONS(1134),
    [anon_sym_scattergather] = ACTIONS(1134),
    [anon_sym_version] = ACTIONS(1134),
    [anon_sym_wildcard_constraints] = ACTIONS(1134),
    [anon_sym_workdir] = ACTIONS(1134),
    [anon_sym_onerror] = ACTIONS(1134),
    [anon_sym_onstart] = ACTIONS(1134),
    [anon_sym_onsuccess] = ACTIONS(1134),
    [anon_sym_localrules] = ACTIONS(1134),
    [anon_sym_ruleorder] = ACTIONS(1134),
    [anon_sym_rule] = ACTIONS(1134),
    [anon_sym_checkpoint] = ACTIONS(1134),
    [anon_sym_use] = ACTIONS(1134),
    [anon_sym_exclude] = ACTIONS(1170),
    [anon_sym_module] = ACTIONS(1134),
    [sym_string_start] = ACTIONS(1136),
  },
  [300] = {
    [sym_else_clause] = STATE(488),
    [ts_builtin_sym_end] = ACTIONS(1172),
    [sym_identifier] = ACTIONS(1174),
    [anon_sym_import] = ACTIONS(1174),
    [anon_sym_from] = ACTIONS(1174),
    [anon_sym_LPAREN] = ACTIONS(1172),
    [anon_sym_STAR] = ACTIONS(1172),
    [anon_sym_print] = ACTIONS(1174),
    [anon_sym_assert] = ACTIONS(1174),
    [anon_sym_return] = ACTIONS(1174),
    [anon_sym_del] = ACTIONS(1174),
    [anon_sym_raise] = ACTIONS(1174),
    [anon_sym_pass] = ACTIONS(1174),
    [anon_sym_break] = ACTIONS(1174),
    [anon_sym_continue] = ACTIONS(1174),
    [anon_sym_if] = ACTIONS(1174),
    [anon_sym_else] = ACTIONS(808),
    [anon_sym_match] = ACTIONS(1174),
    [anon_sym_async] = ACTIONS(1174),
    [anon_sym_for] = ACTIONS(1174),
    [anon_sym_while] = ACTIONS(1174),
    [anon_sym_try] = ACTIONS(1174),
    [anon_sym_with] = ACTIONS(1174),
    [anon_sym_def] = ACTIONS(1174),
    [anon_sym_global] = ACTIONS(1174),
    [anon_sym_nonlocal] = ACTIONS(1174),
    [anon_sym_exec] = ACTIONS(1174),
    [anon_sym_type] = ACTIONS(1174),
    [anon_sym_class] = ACTIONS(1174),
    [anon_sym_LBRACK] = ACTIONS(1172),
    [anon_sym_AT] = ACTIONS(1172),
    [anon_sym_DASH] = ACTIONS(1172),
    [anon_sym_LBRACE] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(1172),
    [anon_sym_not] = ACTIONS(1174),
    [anon_sym_TILDE] = ACTIONS(1172),
    [anon_sym_lambda] = ACTIONS(1174),
    [anon_sym_yield] = ACTIONS(1174),
    [sym_ellipsis] = ACTIONS(1172),
    [sym_integer] = ACTIONS(1174),
    [sym_float] = ACTIONS(1172),
    [anon_sym_await] = ACTIONS(1174),
    [sym_true] = ACTIONS(1174),
    [sym_false] = ACTIONS(1174),
    [sym_none] = ACTIONS(1174),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1174),
    [anon_sym_container] = ACTIONS(1174),
    [anon_sym_envvars] = ACTIONS(1174),
    [anon_sym_include] = ACTIONS(1174),
    [anon_sym_pepfile] = ACTIONS(1174),
    [anon_sym_pepschema] = ACTIONS(1174),
    [anon_sym_scattergather] = ACTIONS(1174),
    [anon_sym_version] = ACTIONS(1174),
    [anon_sym_wildcard_constraints] = ACTIONS(1174),
    [anon_sym_workdir] = ACTIONS(1174),
    [anon_sym_onerror] = ACTIONS(1174),
    [anon_sym_onstart] = ACTIONS(1174),
    [anon_sym_onsuccess] = ACTIONS(1174),
    [anon_sym_localrules] = ACTIONS(1174),
    [anon_sym_ruleorder] = ACTIONS(1174),
    [anon_sym_rule] = ACTIONS(1174),
    [anon_sym_checkpoint] = ACTIONS(1174),
    [anon_sym_use] = ACTIONS(1174),
    [anon_sym_module] = ACTIONS(1174),
    [sym_string_start] = ACTIONS(1172),
  },
  [301] = {
    [aux_sym___directive_parameters_ruleorder_repeat1] = STATE(301),
    [ts_builtin_sym_end] = ACTIONS(1176),
    [sym_identifier] = ACTIONS(1178),
    [anon_sym_import] = ACTIONS(1178),
    [anon_sym_from] = ACTIONS(1178),
    [anon_sym_LPAREN] = ACTIONS(1176),
    [anon_sym_STAR] = ACTIONS(1176),
    [anon_sym_print] = ACTIONS(1178),
    [anon_sym_assert] = ACTIONS(1178),
    [anon_sym_return] = ACTIONS(1178),
    [anon_sym_del] = ACTIONS(1178),
    [anon_sym_raise] = ACTIONS(1178),
    [anon_sym_pass] = ACTIONS(1178),
    [anon_sym_break] = ACTIONS(1178),
    [anon_sym_continue] = ACTIONS(1178),
    [anon_sym_if] = ACTIONS(1178),
    [anon_sym_match] = ACTIONS(1178),
    [anon_sym_async] = ACTIONS(1178),
    [anon_sym_for] = ACTIONS(1178),
    [anon_sym_while] = ACTIONS(1178),
    [anon_sym_try] = ACTIONS(1178),
    [anon_sym_with] = ACTIONS(1178),
    [anon_sym_def] = ACTIONS(1178),
    [anon_sym_global] = ACTIONS(1178),
    [anon_sym_nonlocal] = ACTIONS(1178),
    [anon_sym_exec] = ACTIONS(1178),
    [anon_sym_type] = ACTIONS(1178),
    [anon_sym_class] = ACTIONS(1178),
    [anon_sym_LBRACK] = ACTIONS(1176),
    [anon_sym_AT] = ACTIONS(1176),
    [anon_sym_DASH] = ACTIONS(1176),
    [anon_sym_LBRACE] = ACTIONS(1176),
    [anon_sym_PLUS] = ACTIONS(1176),
    [anon_sym_not] = ACTIONS(1178),
    [anon_sym_TILDE] = ACTIONS(1176),
    [anon_sym_GT] = ACTIONS(1180),
    [anon_sym_lambda] = ACTIONS(1178),
    [anon_sym_yield] = ACTIONS(1178),
    [sym_ellipsis] = ACTIONS(1176),
    [sym_integer] = ACTIONS(1178),
    [sym_float] = ACTIONS(1176),
    [anon_sym_await] = ACTIONS(1178),
    [sym_true] = ACTIONS(1178),
    [sym_false] = ACTIONS(1178),
    [sym_none] = ACTIONS(1178),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1178),
    [anon_sym_container] = ACTIONS(1178),
    [anon_sym_envvars] = ACTIONS(1178),
    [anon_sym_include] = ACTIONS(1178),
    [anon_sym_pepfile] = ACTIONS(1178),
    [anon_sym_pepschema] = ACTIONS(1178),
    [anon_sym_scattergather] = ACTIONS(1178),
    [anon_sym_version] = ACTIONS(1178),
    [anon_sym_wildcard_constraints] = ACTIONS(1178),
    [anon_sym_workdir] = ACTIONS(1178),
    [anon_sym_onerror] = ACTIONS(1178),
    [anon_sym_onstart] = ACTIONS(1178),
    [anon_sym_onsuccess] = ACTIONS(1178),
    [anon_sym_localrules] = ACTIONS(1178),
    [anon_sym_ruleorder] = ACTIONS(1178),
    [anon_sym_rule] = ACTIONS(1178),
    [anon_sym_checkpoint] = ACTIONS(1178),
    [anon_sym_use] = ACTIONS(1178),
    [anon_sym_module] = ACTIONS(1178),
    [sym_string_start] = ACTIONS(1176),
  },
  [302] = {
    [sym_identifier] = ACTIONS(1183),
    [anon_sym_import] = ACTIONS(1183),
    [anon_sym_from] = ACTIONS(1183),
    [anon_sym_LPAREN] = ACTIONS(1185),
    [anon_sym_STAR] = ACTIONS(1185),
    [anon_sym_print] = ACTIONS(1183),
    [anon_sym_assert] = ACTIONS(1183),
    [anon_sym_return] = ACTIONS(1183),
    [anon_sym_del] = ACTIONS(1183),
    [anon_sym_raise] = ACTIONS(1183),
    [anon_sym_pass] = ACTIONS(1183),
    [anon_sym_break] = ACTIONS(1183),
    [anon_sym_continue] = ACTIONS(1183),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_elif] = ACTIONS(1183),
    [anon_sym_else] = ACTIONS(1183),
    [anon_sym_match] = ACTIONS(1183),
    [anon_sym_async] = ACTIONS(1183),
    [anon_sym_for] = ACTIONS(1183),
    [anon_sym_while] = ACTIONS(1183),
    [anon_sym_try] = ACTIONS(1183),
    [anon_sym_with] = ACTIONS(1183),
    [anon_sym_def] = ACTIONS(1183),
    [anon_sym_global] = ACTIONS(1183),
    [anon_sym_nonlocal] = ACTIONS(1183),
    [anon_sym_exec] = ACTIONS(1183),
    [anon_sym_type] = ACTIONS(1183),
    [anon_sym_class] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1185),
    [anon_sym_AT] = ACTIONS(1185),
    [anon_sym_DASH] = ACTIONS(1185),
    [anon_sym_LBRACE] = ACTIONS(1185),
    [anon_sym_PLUS] = ACTIONS(1185),
    [anon_sym_not] = ACTIONS(1183),
    [anon_sym_TILDE] = ACTIONS(1185),
    [anon_sym_lambda] = ACTIONS(1183),
    [anon_sym_yield] = ACTIONS(1183),
    [sym_ellipsis] = ACTIONS(1185),
    [sym_integer] = ACTIONS(1183),
    [sym_float] = ACTIONS(1185),
    [anon_sym_await] = ACTIONS(1183),
    [sym_true] = ACTIONS(1183),
    [sym_false] = ACTIONS(1183),
    [sym_none] = ACTIONS(1183),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1183),
    [anon_sym_container] = ACTIONS(1183),
    [anon_sym_envvars] = ACTIONS(1183),
    [anon_sym_include] = ACTIONS(1183),
    [anon_sym_pepfile] = ACTIONS(1183),
    [anon_sym_pepschema] = ACTIONS(1183),
    [anon_sym_scattergather] = ACTIONS(1183),
    [anon_sym_version] = ACTIONS(1183),
    [anon_sym_wildcard_constraints] = ACTIONS(1183),
    [anon_sym_workdir] = ACTIONS(1183),
    [anon_sym_onerror] = ACTIONS(1183),
    [anon_sym_onstart] = ACTIONS(1183),
    [anon_sym_onsuccess] = ACTIONS(1183),
    [anon_sym_localrules] = ACTIONS(1183),
    [anon_sym_ruleorder] = ACTIONS(1183),
    [anon_sym_rule] = ACTIONS(1183),
    [anon_sym_checkpoint] = ACTIONS(1183),
    [anon_sym_use] = ACTIONS(1183),
    [anon_sym_module] = ACTIONS(1183),
    [sym__dedent] = ACTIONS(1185),
    [sym_string_start] = ACTIONS(1185),
  },
  [303] = {
    [aux_sym___directive_parameters_ruleorder_repeat1] = STATE(303),
    [sym_identifier] = ACTIONS(1178),
    [anon_sym_import] = ACTIONS(1178),
    [anon_sym_from] = ACTIONS(1178),
    [anon_sym_LPAREN] = ACTIONS(1176),
    [anon_sym_STAR] = ACTIONS(1176),
    [anon_sym_print] = ACTIONS(1178),
    [anon_sym_assert] = ACTIONS(1178),
    [anon_sym_return] = ACTIONS(1178),
    [anon_sym_del] = ACTIONS(1178),
    [anon_sym_raise] = ACTIONS(1178),
    [anon_sym_pass] = ACTIONS(1178),
    [anon_sym_break] = ACTIONS(1178),
    [anon_sym_continue] = ACTIONS(1178),
    [anon_sym_if] = ACTIONS(1178),
    [anon_sym_match] = ACTIONS(1178),
    [anon_sym_async] = ACTIONS(1178),
    [anon_sym_for] = ACTIONS(1178),
    [anon_sym_while] = ACTIONS(1178),
    [anon_sym_try] = ACTIONS(1178),
    [anon_sym_with] = ACTIONS(1178),
    [anon_sym_def] = ACTIONS(1178),
    [anon_sym_global] = ACTIONS(1178),
    [anon_sym_nonlocal] = ACTIONS(1178),
    [anon_sym_exec] = ACTIONS(1178),
    [anon_sym_type] = ACTIONS(1178),
    [anon_sym_class] = ACTIONS(1178),
    [anon_sym_LBRACK] = ACTIONS(1176),
    [anon_sym_AT] = ACTIONS(1176),
    [anon_sym_DASH] = ACTIONS(1176),
    [anon_sym_LBRACE] = ACTIONS(1176),
    [anon_sym_PLUS] = ACTIONS(1176),
    [anon_sym_not] = ACTIONS(1178),
    [anon_sym_TILDE] = ACTIONS(1176),
    [anon_sym_GT] = ACTIONS(1187),
    [anon_sym_lambda] = ACTIONS(1178),
    [anon_sym_yield] = ACTIONS(1178),
    [sym_ellipsis] = ACTIONS(1176),
    [sym_integer] = ACTIONS(1178),
    [sym_float] = ACTIONS(1176),
    [anon_sym_await] = ACTIONS(1178),
    [sym_true] = ACTIONS(1178),
    [sym_false] = ACTIONS(1178),
    [sym_none] = ACTIONS(1178),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1178),
    [anon_sym_container] = ACTIONS(1178),
    [anon_sym_envvars] = ACTIONS(1178),
    [anon_sym_include] = ACTIONS(1178),
    [anon_sym_pepfile] = ACTIONS(1178),
    [anon_sym_pepschema] = ACTIONS(1178),
    [anon_sym_scattergather] = ACTIONS(1178),
    [anon_sym_version] = ACTIONS(1178),
    [anon_sym_wildcard_constraints] = ACTIONS(1178),
    [anon_sym_workdir] = ACTIONS(1178),
    [anon_sym_onerror] = ACTIONS(1178),
    [anon_sym_onstart] = ACTIONS(1178),
    [anon_sym_onsuccess] = ACTIONS(1178),
    [anon_sym_localrules] = ACTIONS(1178),
    [anon_sym_ruleorder] = ACTIONS(1178),
    [anon_sym_rule] = ACTIONS(1178),
    [anon_sym_checkpoint] = ACTIONS(1178),
    [anon_sym_use] = ACTIONS(1178),
    [anon_sym_module] = ACTIONS(1178),
    [sym__dedent] = ACTIONS(1176),
    [sym_string_start] = ACTIONS(1176),
  },
  [304] = {
    [ts_builtin_sym_end] = ACTIONS(1190),
    [sym_identifier] = ACTIONS(1192),
    [anon_sym_import] = ACTIONS(1192),
    [anon_sym_from] = ACTIONS(1192),
    [anon_sym_LPAREN] = ACTIONS(1190),
    [anon_sym_STAR] = ACTIONS(1190),
    [anon_sym_print] = ACTIONS(1192),
    [anon_sym_assert] = ACTIONS(1192),
    [anon_sym_return] = ACTIONS(1192),
    [anon_sym_del] = ACTIONS(1192),
    [anon_sym_raise] = ACTIONS(1192),
    [anon_sym_pass] = ACTIONS(1192),
    [anon_sym_break] = ACTIONS(1192),
    [anon_sym_continue] = ACTIONS(1192),
    [anon_sym_if] = ACTIONS(1192),
    [anon_sym_elif] = ACTIONS(1192),
    [anon_sym_else] = ACTIONS(1192),
    [anon_sym_match] = ACTIONS(1192),
    [anon_sym_async] = ACTIONS(1192),
    [anon_sym_for] = ACTIONS(1192),
    [anon_sym_while] = ACTIONS(1192),
    [anon_sym_try] = ACTIONS(1192),
    [anon_sym_with] = ACTIONS(1192),
    [anon_sym_def] = ACTIONS(1192),
    [anon_sym_global] = ACTIONS(1192),
    [anon_sym_nonlocal] = ACTIONS(1192),
    [anon_sym_exec] = ACTIONS(1192),
    [anon_sym_type] = ACTIONS(1192),
    [anon_sym_class] = ACTIONS(1192),
    [anon_sym_LBRACK] = ACTIONS(1190),
    [anon_sym_AT] = ACTIONS(1190),
    [anon_sym_DASH] = ACTIONS(1190),
    [anon_sym_LBRACE] = ACTIONS(1190),
    [anon_sym_PLUS] = ACTIONS(1190),
    [anon_sym_not] = ACTIONS(1192),
    [anon_sym_TILDE] = ACTIONS(1190),
    [anon_sym_lambda] = ACTIONS(1192),
    [anon_sym_yield] = ACTIONS(1192),
    [sym_ellipsis] = ACTIONS(1190),
    [sym_integer] = ACTIONS(1192),
    [sym_float] = ACTIONS(1190),
    [anon_sym_await] = ACTIONS(1192),
    [sym_true] = ACTIONS(1192),
    [sym_false] = ACTIONS(1192),
    [sym_none] = ACTIONS(1192),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1192),
    [anon_sym_container] = ACTIONS(1192),
    [anon_sym_envvars] = ACTIONS(1192),
    [anon_sym_include] = ACTIONS(1192),
    [anon_sym_pepfile] = ACTIONS(1192),
    [anon_sym_pepschema] = ACTIONS(1192),
    [anon_sym_scattergather] = ACTIONS(1192),
    [anon_sym_version] = ACTIONS(1192),
    [anon_sym_wildcard_constraints] = ACTIONS(1192),
    [anon_sym_workdir] = ACTIONS(1192),
    [anon_sym_onerror] = ACTIONS(1192),
    [anon_sym_onstart] = ACTIONS(1192),
    [anon_sym_onsuccess] = ACTIONS(1192),
    [anon_sym_localrules] = ACTIONS(1192),
    [anon_sym_ruleorder] = ACTIONS(1192),
    [anon_sym_rule] = ACTIONS(1192),
    [anon_sym_checkpoint] = ACTIONS(1192),
    [anon_sym_use] = ACTIONS(1192),
    [anon_sym_module] = ACTIONS(1192),
    [sym_string_start] = ACTIONS(1190),
  },
  [305] = {
    [sym_else_clause] = STATE(425),
    [sym_identifier] = ACTIONS(1194),
    [anon_sym_import] = ACTIONS(1194),
    [anon_sym_from] = ACTIONS(1194),
    [anon_sym_LPAREN] = ACTIONS(1196),
    [anon_sym_STAR] = ACTIONS(1196),
    [anon_sym_print] = ACTIONS(1194),
    [anon_sym_assert] = ACTIONS(1194),
    [anon_sym_return] = ACTIONS(1194),
    [anon_sym_del] = ACTIONS(1194),
    [anon_sym_raise] = ACTIONS(1194),
    [anon_sym_pass] = ACTIONS(1194),
    [anon_sym_break] = ACTIONS(1194),
    [anon_sym_continue] = ACTIONS(1194),
    [anon_sym_if] = ACTIONS(1194),
    [anon_sym_else] = ACTIONS(820),
    [anon_sym_match] = ACTIONS(1194),
    [anon_sym_async] = ACTIONS(1194),
    [anon_sym_for] = ACTIONS(1194),
    [anon_sym_while] = ACTIONS(1194),
    [anon_sym_try] = ACTIONS(1194),
    [anon_sym_with] = ACTIONS(1194),
    [anon_sym_def] = ACTIONS(1194),
    [anon_sym_global] = ACTIONS(1194),
    [anon_sym_nonlocal] = ACTIONS(1194),
    [anon_sym_exec] = ACTIONS(1194),
    [anon_sym_type] = ACTIONS(1194),
    [anon_sym_class] = ACTIONS(1194),
    [anon_sym_LBRACK] = ACTIONS(1196),
    [anon_sym_AT] = ACTIONS(1196),
    [anon_sym_DASH] = ACTIONS(1196),
    [anon_sym_LBRACE] = ACTIONS(1196),
    [anon_sym_PLUS] = ACTIONS(1196),
    [anon_sym_not] = ACTIONS(1194),
    [anon_sym_TILDE] = ACTIONS(1196),
    [anon_sym_lambda] = ACTIONS(1194),
    [anon_sym_yield] = ACTIONS(1194),
    [sym_ellipsis] = ACTIONS(1196),
    [sym_integer] = ACTIONS(1194),
    [sym_float] = ACTIONS(1196),
    [anon_sym_await] = ACTIONS(1194),
    [sym_true] = ACTIONS(1194),
    [sym_false] = ACTIONS(1194),
    [sym_none] = ACTIONS(1194),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1194),
    [anon_sym_container] = ACTIONS(1194),
    [anon_sym_envvars] = ACTIONS(1194),
    [anon_sym_include] = ACTIONS(1194),
    [anon_sym_pepfile] = ACTIONS(1194),
    [anon_sym_pepschema] = ACTIONS(1194),
    [anon_sym_scattergather] = ACTIONS(1194),
    [anon_sym_version] = ACTIONS(1194),
    [anon_sym_wildcard_constraints] = ACTIONS(1194),
    [anon_sym_workdir] = ACTIONS(1194),
    [anon_sym_onerror] = ACTIONS(1194),
    [anon_sym_onstart] = ACTIONS(1194),
    [anon_sym_onsuccess] = ACTIONS(1194),
    [anon_sym_localrules] = ACTIONS(1194),
    [anon_sym_ruleorder] = ACTIONS(1194),
    [anon_sym_rule] = ACTIONS(1194),
    [anon_sym_checkpoint] = ACTIONS(1194),
    [anon_sym_use] = ACTIONS(1194),
    [anon_sym_module] = ACTIONS(1194),
    [sym__dedent] = ACTIONS(1196),
    [sym_string_start] = ACTIONS(1196),
  },
  [306] = {
    [ts_builtin_sym_end] = ACTIONS(1185),
    [sym_identifier] = ACTIONS(1183),
    [anon_sym_import] = ACTIONS(1183),
    [anon_sym_from] = ACTIONS(1183),
    [anon_sym_LPAREN] = ACTIONS(1185),
    [anon_sym_STAR] = ACTIONS(1185),
    [anon_sym_print] = ACTIONS(1183),
    [anon_sym_assert] = ACTIONS(1183),
    [anon_sym_return] = ACTIONS(1183),
    [anon_sym_del] = ACTIONS(1183),
    [anon_sym_raise] = ACTIONS(1183),
    [anon_sym_pass] = ACTIONS(1183),
    [anon_sym_break] = ACTIONS(1183),
    [anon_sym_continue] = ACTIONS(1183),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_elif] = ACTIONS(1183),
    [anon_sym_else] = ACTIONS(1183),
    [anon_sym_match] = ACTIONS(1183),
    [anon_sym_async] = ACTIONS(1183),
    [anon_sym_for] = ACTIONS(1183),
    [anon_sym_while] = ACTIONS(1183),
    [anon_sym_try] = ACTIONS(1183),
    [anon_sym_with] = ACTIONS(1183),
    [anon_sym_def] = ACTIONS(1183),
    [anon_sym_global] = ACTIONS(1183),
    [anon_sym_nonlocal] = ACTIONS(1183),
    [anon_sym_exec] = ACTIONS(1183),
    [anon_sym_type] = ACTIONS(1183),
    [anon_sym_class] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1185),
    [anon_sym_AT] = ACTIONS(1185),
    [anon_sym_DASH] = ACTIONS(1185),
    [anon_sym_LBRACE] = ACTIONS(1185),
    [anon_sym_PLUS] = ACTIONS(1185),
    [anon_sym_not] = ACTIONS(1183),
    [anon_sym_TILDE] = ACTIONS(1185),
    [anon_sym_lambda] = ACTIONS(1183),
    [anon_sym_yield] = ACTIONS(1183),
    [sym_ellipsis] = ACTIONS(1185),
    [sym_integer] = ACTIONS(1183),
    [sym_float] = ACTIONS(1185),
    [anon_sym_await] = ACTIONS(1183),
    [sym_true] = ACTIONS(1183),
    [sym_false] = ACTIONS(1183),
    [sym_none] = ACTIONS(1183),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1183),
    [anon_sym_container] = ACTIONS(1183),
    [anon_sym_envvars] = ACTIONS(1183),
    [anon_sym_include] = ACTIONS(1183),
    [anon_sym_pepfile] = ACTIONS(1183),
    [anon_sym_pepschema] = ACTIONS(1183),
    [anon_sym_scattergather] = ACTIONS(1183),
    [anon_sym_version] = ACTIONS(1183),
    [anon_sym_wildcard_constraints] = ACTIONS(1183),
    [anon_sym_workdir] = ACTIONS(1183),
    [anon_sym_onerror] = ACTIONS(1183),
    [anon_sym_onstart] = ACTIONS(1183),
    [anon_sym_onsuccess] = ACTIONS(1183),
    [anon_sym_localrules] = ACTIONS(1183),
    [anon_sym_ruleorder] = ACTIONS(1183),
    [anon_sym_rule] = ACTIONS(1183),
    [anon_sym_checkpoint] = ACTIONS(1183),
    [anon_sym_use] = ACTIONS(1183),
    [anon_sym_module] = ACTIONS(1183),
    [sym_string_start] = ACTIONS(1185),
  },
  [307] = {
    [sym_else_clause] = STATE(365),
    [ts_builtin_sym_end] = ACTIONS(1198),
    [sym_identifier] = ACTIONS(1200),
    [anon_sym_import] = ACTIONS(1200),
    [anon_sym_from] = ACTIONS(1200),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_STAR] = ACTIONS(1198),
    [anon_sym_print] = ACTIONS(1200),
    [anon_sym_assert] = ACTIONS(1200),
    [anon_sym_return] = ACTIONS(1200),
    [anon_sym_del] = ACTIONS(1200),
    [anon_sym_raise] = ACTIONS(1200),
    [anon_sym_pass] = ACTIONS(1200),
    [anon_sym_break] = ACTIONS(1200),
    [anon_sym_continue] = ACTIONS(1200),
    [anon_sym_if] = ACTIONS(1200),
    [anon_sym_else] = ACTIONS(808),
    [anon_sym_match] = ACTIONS(1200),
    [anon_sym_async] = ACTIONS(1200),
    [anon_sym_for] = ACTIONS(1200),
    [anon_sym_while] = ACTIONS(1200),
    [anon_sym_try] = ACTIONS(1200),
    [anon_sym_with] = ACTIONS(1200),
    [anon_sym_def] = ACTIONS(1200),
    [anon_sym_global] = ACTIONS(1200),
    [anon_sym_nonlocal] = ACTIONS(1200),
    [anon_sym_exec] = ACTIONS(1200),
    [anon_sym_type] = ACTIONS(1200),
    [anon_sym_class] = ACTIONS(1200),
    [anon_sym_LBRACK] = ACTIONS(1198),
    [anon_sym_AT] = ACTIONS(1198),
    [anon_sym_DASH] = ACTIONS(1198),
    [anon_sym_LBRACE] = ACTIONS(1198),
    [anon_sym_PLUS] = ACTIONS(1198),
    [anon_sym_not] = ACTIONS(1200),
    [anon_sym_TILDE] = ACTIONS(1198),
    [anon_sym_lambda] = ACTIONS(1200),
    [anon_sym_yield] = ACTIONS(1200),
    [sym_ellipsis] = ACTIONS(1198),
    [sym_integer] = ACTIONS(1200),
    [sym_float] = ACTIONS(1198),
    [anon_sym_await] = ACTIONS(1200),
    [sym_true] = ACTIONS(1200),
    [sym_false] = ACTIONS(1200),
    [sym_none] = ACTIONS(1200),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1200),
    [anon_sym_container] = ACTIONS(1200),
    [anon_sym_envvars] = ACTIONS(1200),
    [anon_sym_include] = ACTIONS(1200),
    [anon_sym_pepfile] = ACTIONS(1200),
    [anon_sym_pepschema] = ACTIONS(1200),
    [anon_sym_scattergather] = ACTIONS(1200),
    [anon_sym_version] = ACTIONS(1200),
    [anon_sym_wildcard_constraints] = ACTIONS(1200),
    [anon_sym_workdir] = ACTIONS(1200),
    [anon_sym_onerror] = ACTIONS(1200),
    [anon_sym_onstart] = ACTIONS(1200),
    [anon_sym_onsuccess] = ACTIONS(1200),
    [anon_sym_localrules] = ACTIONS(1200),
    [anon_sym_ruleorder] = ACTIONS(1200),
    [anon_sym_rule] = ACTIONS(1200),
    [anon_sym_checkpoint] = ACTIONS(1200),
    [anon_sym_use] = ACTIONS(1200),
    [anon_sym_module] = ACTIONS(1200),
    [sym_string_start] = ACTIONS(1198),
  },
  [308] = {
    [sym_else_clause] = STATE(403),
    [sym_identifier] = ACTIONS(1202),
    [anon_sym_import] = ACTIONS(1202),
    [anon_sym_from] = ACTIONS(1202),
    [anon_sym_LPAREN] = ACTIONS(1204),
    [anon_sym_STAR] = ACTIONS(1204),
    [anon_sym_print] = ACTIONS(1202),
    [anon_sym_assert] = ACTIONS(1202),
    [anon_sym_return] = ACTIONS(1202),
    [anon_sym_del] = ACTIONS(1202),
    [anon_sym_raise] = ACTIONS(1202),
    [anon_sym_pass] = ACTIONS(1202),
    [anon_sym_break] = ACTIONS(1202),
    [anon_sym_continue] = ACTIONS(1202),
    [anon_sym_if] = ACTIONS(1202),
    [anon_sym_else] = ACTIONS(820),
    [anon_sym_match] = ACTIONS(1202),
    [anon_sym_async] = ACTIONS(1202),
    [anon_sym_for] = ACTIONS(1202),
    [anon_sym_while] = ACTIONS(1202),
    [anon_sym_try] = ACTIONS(1202),
    [anon_sym_with] = ACTIONS(1202),
    [anon_sym_def] = ACTIONS(1202),
    [anon_sym_global] = ACTIONS(1202),
    [anon_sym_nonlocal] = ACTIONS(1202),
    [anon_sym_exec] = ACTIONS(1202),
    [anon_sym_type] = ACTIONS(1202),
    [anon_sym_class] = ACTIONS(1202),
    [anon_sym_LBRACK] = ACTIONS(1204),
    [anon_sym_AT] = ACTIONS(1204),
    [anon_sym_DASH] = ACTIONS(1204),
    [anon_sym_LBRACE] = ACTIONS(1204),
    [anon_sym_PLUS] = ACTIONS(1204),
    [anon_sym_not] = ACTIONS(1202),
    [anon_sym_TILDE] = ACTIONS(1204),
    [anon_sym_lambda] = ACTIONS(1202),
    [anon_sym_yield] = ACTIONS(1202),
    [sym_ellipsis] = ACTIONS(1204),
    [sym_integer] = ACTIONS(1202),
    [sym_float] = ACTIONS(1204),
    [anon_sym_await] = ACTIONS(1202),
    [sym_true] = ACTIONS(1202),
    [sym_false] = ACTIONS(1202),
    [sym_none] = ACTIONS(1202),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1202),
    [anon_sym_container] = ACTIONS(1202),
    [anon_sym_envvars] = ACTIONS(1202),
    [anon_sym_include] = ACTIONS(1202),
    [anon_sym_pepfile] = ACTIONS(1202),
    [anon_sym_pepschema] = ACTIONS(1202),
    [anon_sym_scattergather] = ACTIONS(1202),
    [anon_sym_version] = ACTIONS(1202),
    [anon_sym_wildcard_constraints] = ACTIONS(1202),
    [anon_sym_workdir] = ACTIONS(1202),
    [anon_sym_onerror] = ACTIONS(1202),
    [anon_sym_onstart] = ACTIONS(1202),
    [anon_sym_onsuccess] = ACTIONS(1202),
    [anon_sym_localrules] = ACTIONS(1202),
    [anon_sym_ruleorder] = ACTIONS(1202),
    [anon_sym_rule] = ACTIONS(1202),
    [anon_sym_checkpoint] = ACTIONS(1202),
    [anon_sym_use] = ACTIONS(1202),
    [anon_sym_module] = ACTIONS(1202),
    [sym__dedent] = ACTIONS(1204),
    [sym_string_start] = ACTIONS(1204),
  },
  [309] = {
    [sym_identifier] = ACTIONS(1192),
    [anon_sym_import] = ACTIONS(1192),
    [anon_sym_from] = ACTIONS(1192),
    [anon_sym_LPAREN] = ACTIONS(1190),
    [anon_sym_STAR] = ACTIONS(1190),
    [anon_sym_print] = ACTIONS(1192),
    [anon_sym_assert] = ACTIONS(1192),
    [anon_sym_return] = ACTIONS(1192),
    [anon_sym_del] = ACTIONS(1192),
    [anon_sym_raise] = ACTIONS(1192),
    [anon_sym_pass] = ACTIONS(1192),
    [anon_sym_break] = ACTIONS(1192),
    [anon_sym_continue] = ACTIONS(1192),
    [anon_sym_if] = ACTIONS(1192),
    [anon_sym_elif] = ACTIONS(1192),
    [anon_sym_else] = ACTIONS(1192),
    [anon_sym_match] = ACTIONS(1192),
    [anon_sym_async] = ACTIONS(1192),
    [anon_sym_for] = ACTIONS(1192),
    [anon_sym_while] = ACTIONS(1192),
    [anon_sym_try] = ACTIONS(1192),
    [anon_sym_with] = ACTIONS(1192),
    [anon_sym_def] = ACTIONS(1192),
    [anon_sym_global] = ACTIONS(1192),
    [anon_sym_nonlocal] = ACTIONS(1192),
    [anon_sym_exec] = ACTIONS(1192),
    [anon_sym_type] = ACTIONS(1192),
    [anon_sym_class] = ACTIONS(1192),
    [anon_sym_LBRACK] = ACTIONS(1190),
    [anon_sym_AT] = ACTIONS(1190),
    [anon_sym_DASH] = ACTIONS(1190),
    [anon_sym_LBRACE] = ACTIONS(1190),
    [anon_sym_PLUS] = ACTIONS(1190),
    [anon_sym_not] = ACTIONS(1192),
    [anon_sym_TILDE] = ACTIONS(1190),
    [anon_sym_lambda] = ACTIONS(1192),
    [anon_sym_yield] = ACTIONS(1192),
    [sym_ellipsis] = ACTIONS(1190),
    [sym_integer] = ACTIONS(1192),
    [sym_float] = ACTIONS(1190),
    [anon_sym_await] = ACTIONS(1192),
    [sym_true] = ACTIONS(1192),
    [sym_false] = ACTIONS(1192),
    [sym_none] = ACTIONS(1192),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1192),
    [anon_sym_container] = ACTIONS(1192),
    [anon_sym_envvars] = ACTIONS(1192),
    [anon_sym_include] = ACTIONS(1192),
    [anon_sym_pepfile] = ACTIONS(1192),
    [anon_sym_pepschema] = ACTIONS(1192),
    [anon_sym_scattergather] = ACTIONS(1192),
    [anon_sym_version] = ACTIONS(1192),
    [anon_sym_wildcard_constraints] = ACTIONS(1192),
    [anon_sym_workdir] = ACTIONS(1192),
    [anon_sym_onerror] = ACTIONS(1192),
    [anon_sym_onstart] = ACTIONS(1192),
    [anon_sym_onsuccess] = ACTIONS(1192),
    [anon_sym_localrules] = ACTIONS(1192),
    [anon_sym_ruleorder] = ACTIONS(1192),
    [anon_sym_rule] = ACTIONS(1192),
    [anon_sym_checkpoint] = ACTIONS(1192),
    [anon_sym_use] = ACTIONS(1192),
    [anon_sym_module] = ACTIONS(1192),
    [sym__dedent] = ACTIONS(1190),
    [sym_string_start] = ACTIONS(1190),
  },
  [310] = {
    [sym_identifier] = ACTIONS(1206),
    [anon_sym_import] = ACTIONS(1206),
    [anon_sym_from] = ACTIONS(1206),
    [anon_sym_LPAREN] = ACTIONS(1208),
    [anon_sym_STAR] = ACTIONS(1208),
    [anon_sym_print] = ACTIONS(1206),
    [anon_sym_assert] = ACTIONS(1206),
    [anon_sym_return] = ACTIONS(1206),
    [anon_sym_del] = ACTIONS(1206),
    [anon_sym_raise] = ACTIONS(1206),
    [anon_sym_pass] = ACTIONS(1206),
    [anon_sym_break] = ACTIONS(1206),
    [anon_sym_continue] = ACTIONS(1206),
    [anon_sym_if] = ACTIONS(1206),
    [anon_sym_elif] = ACTIONS(1206),
    [anon_sym_else] = ACTIONS(1206),
    [anon_sym_match] = ACTIONS(1206),
    [anon_sym_async] = ACTIONS(1206),
    [anon_sym_for] = ACTIONS(1206),
    [anon_sym_while] = ACTIONS(1206),
    [anon_sym_try] = ACTIONS(1206),
    [anon_sym_with] = ACTIONS(1206),
    [anon_sym_def] = ACTIONS(1206),
    [anon_sym_global] = ACTIONS(1206),
    [anon_sym_nonlocal] = ACTIONS(1206),
    [anon_sym_exec] = ACTIONS(1206),
    [anon_sym_type] = ACTIONS(1206),
    [anon_sym_class] = ACTIONS(1206),
    [anon_sym_LBRACK] = ACTIONS(1208),
    [anon_sym_AT] = ACTIONS(1208),
    [anon_sym_DASH] = ACTIONS(1208),
    [anon_sym_LBRACE] = ACTIONS(1208),
    [anon_sym_PLUS] = ACTIONS(1208),
    [anon_sym_not] = ACTIONS(1206),
    [anon_sym_TILDE] = ACTIONS(1208),
    [anon_sym_lambda] = ACTIONS(1206),
    [anon_sym_yield] = ACTIONS(1206),
    [sym_ellipsis] = ACTIONS(1208),
    [sym_integer] = ACTIONS(1206),
    [sym_float] = ACTIONS(1208),
    [anon_sym_await] = ACTIONS(1206),
    [sym_true] = ACTIONS(1206),
    [sym_false] = ACTIONS(1206),
    [sym_none] = ACTIONS(1206),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1206),
    [anon_sym_container] = ACTIONS(1206),
    [anon_sym_envvars] = ACTIONS(1206),
    [anon_sym_include] = ACTIONS(1206),
    [anon_sym_pepfile] = ACTIONS(1206),
    [anon_sym_pepschema] = ACTIONS(1206),
    [anon_sym_scattergather] = ACTIONS(1206),
    [anon_sym_version] = ACTIONS(1206),
    [anon_sym_wildcard_constraints] = ACTIONS(1206),
    [anon_sym_workdir] = ACTIONS(1206),
    [anon_sym_onerror] = ACTIONS(1206),
    [anon_sym_onstart] = ACTIONS(1206),
    [anon_sym_onsuccess] = ACTIONS(1206),
    [anon_sym_localrules] = ACTIONS(1206),
    [anon_sym_ruleorder] = ACTIONS(1206),
    [anon_sym_rule] = ACTIONS(1206),
    [anon_sym_checkpoint] = ACTIONS(1206),
    [anon_sym_use] = ACTIONS(1206),
    [anon_sym_module] = ACTIONS(1206),
    [sym__dedent] = ACTIONS(1208),
    [sym_string_start] = ACTIONS(1208),
  },
  [311] = {
    [sym_else_clause] = STATE(360),
    [ts_builtin_sym_end] = ACTIONS(1204),
    [sym_identifier] = ACTIONS(1202),
    [anon_sym_import] = ACTIONS(1202),
    [anon_sym_from] = ACTIONS(1202),
    [anon_sym_LPAREN] = ACTIONS(1204),
    [anon_sym_STAR] = ACTIONS(1204),
    [anon_sym_print] = ACTIONS(1202),
    [anon_sym_assert] = ACTIONS(1202),
    [anon_sym_return] = ACTIONS(1202),
    [anon_sym_del] = ACTIONS(1202),
    [anon_sym_raise] = ACTIONS(1202),
    [anon_sym_pass] = ACTIONS(1202),
    [anon_sym_break] = ACTIONS(1202),
    [anon_sym_continue] = ACTIONS(1202),
    [anon_sym_if] = ACTIONS(1202),
    [anon_sym_else] = ACTIONS(808),
    [anon_sym_match] = ACTIONS(1202),
    [anon_sym_async] = ACTIONS(1202),
    [anon_sym_for] = ACTIONS(1202),
    [anon_sym_while] = ACTIONS(1202),
    [anon_sym_try] = ACTIONS(1202),
    [anon_sym_with] = ACTIONS(1202),
    [anon_sym_def] = ACTIONS(1202),
    [anon_sym_global] = ACTIONS(1202),
    [anon_sym_nonlocal] = ACTIONS(1202),
    [anon_sym_exec] = ACTIONS(1202),
    [anon_sym_type] = ACTIONS(1202),
    [anon_sym_class] = ACTIONS(1202),
    [anon_sym_LBRACK] = ACTIONS(1204),
    [anon_sym_AT] = ACTIONS(1204),
    [anon_sym_DASH] = ACTIONS(1204),
    [anon_sym_LBRACE] = ACTIONS(1204),
    [anon_sym_PLUS] = ACTIONS(1204),
    [anon_sym_not] = ACTIONS(1202),
    [anon_sym_TILDE] = ACTIONS(1204),
    [anon_sym_lambda] = ACTIONS(1202),
    [anon_sym_yield] = ACTIONS(1202),
    [sym_ellipsis] = ACTIONS(1204),
    [sym_integer] = ACTIONS(1202),
    [sym_float] = ACTIONS(1204),
    [anon_sym_await] = ACTIONS(1202),
    [sym_true] = ACTIONS(1202),
    [sym_false] = ACTIONS(1202),
    [sym_none] = ACTIONS(1202),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1202),
    [anon_sym_container] = ACTIONS(1202),
    [anon_sym_envvars] = ACTIONS(1202),
    [anon_sym_include] = ACTIONS(1202),
    [anon_sym_pepfile] = ACTIONS(1202),
    [anon_sym_pepschema] = ACTIONS(1202),
    [anon_sym_scattergather] = ACTIONS(1202),
    [anon_sym_version] = ACTIONS(1202),
    [anon_sym_wildcard_constraints] = ACTIONS(1202),
    [anon_sym_workdir] = ACTIONS(1202),
    [anon_sym_onerror] = ACTIONS(1202),
    [anon_sym_onstart] = ACTIONS(1202),
    [anon_sym_onsuccess] = ACTIONS(1202),
    [anon_sym_localrules] = ACTIONS(1202),
    [anon_sym_ruleorder] = ACTIONS(1202),
    [anon_sym_rule] = ACTIONS(1202),
    [anon_sym_checkpoint] = ACTIONS(1202),
    [anon_sym_use] = ACTIONS(1202),
    [anon_sym_module] = ACTIONS(1202),
    [sym_string_start] = ACTIONS(1204),
  },
  [312] = {
    [aux_sym___directive_parameters_ruleorder_repeat1] = STATE(303),
    [sym_identifier] = ACTIONS(1158),
    [anon_sym_import] = ACTIONS(1158),
    [anon_sym_from] = ACTIONS(1158),
    [anon_sym_LPAREN] = ACTIONS(1156),
    [anon_sym_STAR] = ACTIONS(1156),
    [anon_sym_print] = ACTIONS(1158),
    [anon_sym_assert] = ACTIONS(1158),
    [anon_sym_return] = ACTIONS(1158),
    [anon_sym_del] = ACTIONS(1158),
    [anon_sym_raise] = ACTIONS(1158),
    [anon_sym_pass] = ACTIONS(1158),
    [anon_sym_break] = ACTIONS(1158),
    [anon_sym_continue] = ACTIONS(1158),
    [anon_sym_if] = ACTIONS(1158),
    [anon_sym_match] = ACTIONS(1158),
    [anon_sym_async] = ACTIONS(1158),
    [anon_sym_for] = ACTIONS(1158),
    [anon_sym_while] = ACTIONS(1158),
    [anon_sym_try] = ACTIONS(1158),
    [anon_sym_with] = ACTIONS(1158),
    [anon_sym_def] = ACTIONS(1158),
    [anon_sym_global] = ACTIONS(1158),
    [anon_sym_nonlocal] = ACTIONS(1158),
    [anon_sym_exec] = ACTIONS(1158),
    [anon_sym_type] = ACTIONS(1158),
    [anon_sym_class] = ACTIONS(1158),
    [anon_sym_LBRACK] = ACTIONS(1156),
    [anon_sym_AT] = ACTIONS(1156),
    [anon_sym_DASH] = ACTIONS(1156),
    [anon_sym_LBRACE] = ACTIONS(1156),
    [anon_sym_PLUS] = ACTIONS(1156),
    [anon_sym_not] = ACTIONS(1158),
    [anon_sym_TILDE] = ACTIONS(1156),
    [anon_sym_GT] = ACTIONS(1210),
    [anon_sym_lambda] = ACTIONS(1158),
    [anon_sym_yield] = ACTIONS(1158),
    [sym_ellipsis] = ACTIONS(1156),
    [sym_integer] = ACTIONS(1158),
    [sym_float] = ACTIONS(1156),
    [anon_sym_await] = ACTIONS(1158),
    [sym_true] = ACTIONS(1158),
    [sym_false] = ACTIONS(1158),
    [sym_none] = ACTIONS(1158),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1158),
    [anon_sym_container] = ACTIONS(1158),
    [anon_sym_envvars] = ACTIONS(1158),
    [anon_sym_include] = ACTIONS(1158),
    [anon_sym_pepfile] = ACTIONS(1158),
    [anon_sym_pepschema] = ACTIONS(1158),
    [anon_sym_scattergather] = ACTIONS(1158),
    [anon_sym_version] = ACTIONS(1158),
    [anon_sym_wildcard_constraints] = ACTIONS(1158),
    [anon_sym_workdir] = ACTIONS(1158),
    [anon_sym_onerror] = ACTIONS(1158),
    [anon_sym_onstart] = ACTIONS(1158),
    [anon_sym_onsuccess] = ACTIONS(1158),
    [anon_sym_localrules] = ACTIONS(1158),
    [anon_sym_ruleorder] = ACTIONS(1158),
    [anon_sym_rule] = ACTIONS(1158),
    [anon_sym_checkpoint] = ACTIONS(1158),
    [anon_sym_use] = ACTIONS(1158),
    [anon_sym_module] = ACTIONS(1158),
    [sym__dedent] = ACTIONS(1156),
    [sym_string_start] = ACTIONS(1156),
  },
  [313] = {
    [aux_sym___directive_parameters_ruleorder_repeat1] = STATE(312),
    [sym_identifier] = ACTIONS(1212),
    [anon_sym_import] = ACTIONS(1212),
    [anon_sym_from] = ACTIONS(1212),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_STAR] = ACTIONS(1214),
    [anon_sym_print] = ACTIONS(1212),
    [anon_sym_assert] = ACTIONS(1212),
    [anon_sym_return] = ACTIONS(1212),
    [anon_sym_del] = ACTIONS(1212),
    [anon_sym_raise] = ACTIONS(1212),
    [anon_sym_pass] = ACTIONS(1212),
    [anon_sym_break] = ACTIONS(1212),
    [anon_sym_continue] = ACTIONS(1212),
    [anon_sym_if] = ACTIONS(1212),
    [anon_sym_match] = ACTIONS(1212),
    [anon_sym_async] = ACTIONS(1212),
    [anon_sym_for] = ACTIONS(1212),
    [anon_sym_while] = ACTIONS(1212),
    [anon_sym_try] = ACTIONS(1212),
    [anon_sym_with] = ACTIONS(1212),
    [anon_sym_def] = ACTIONS(1212),
    [anon_sym_global] = ACTIONS(1212),
    [anon_sym_nonlocal] = ACTIONS(1212),
    [anon_sym_exec] = ACTIONS(1212),
    [anon_sym_type] = ACTIONS(1212),
    [anon_sym_class] = ACTIONS(1212),
    [anon_sym_LBRACK] = ACTIONS(1214),
    [anon_sym_AT] = ACTIONS(1214),
    [anon_sym_DASH] = ACTIONS(1214),
    [anon_sym_LBRACE] = ACTIONS(1214),
    [anon_sym_PLUS] = ACTIONS(1214),
    [anon_sym_not] = ACTIONS(1212),
    [anon_sym_TILDE] = ACTIONS(1214),
    [anon_sym_GT] = ACTIONS(1210),
    [anon_sym_lambda] = ACTIONS(1212),
    [anon_sym_yield] = ACTIONS(1212),
    [sym_ellipsis] = ACTIONS(1214),
    [sym_integer] = ACTIONS(1212),
    [sym_float] = ACTIONS(1214),
    [anon_sym_await] = ACTIONS(1212),
    [sym_true] = ACTIONS(1212),
    [sym_false] = ACTIONS(1212),
    [sym_none] = ACTIONS(1212),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1212),
    [anon_sym_container] = ACTIONS(1212),
    [anon_sym_envvars] = ACTIONS(1212),
    [anon_sym_include] = ACTIONS(1212),
    [anon_sym_pepfile] = ACTIONS(1212),
    [anon_sym_pepschema] = ACTIONS(1212),
    [anon_sym_scattergather] = ACTIONS(1212),
    [anon_sym_version] = ACTIONS(1212),
    [anon_sym_wildcard_constraints] = ACTIONS(1212),
    [anon_sym_workdir] = ACTIONS(1212),
    [anon_sym_onerror] = ACTIONS(1212),
    [anon_sym_onstart] = ACTIONS(1212),
    [anon_sym_onsuccess] = ACTIONS(1212),
    [anon_sym_localrules] = ACTIONS(1212),
    [anon_sym_ruleorder] = ACTIONS(1212),
    [anon_sym_rule] = ACTIONS(1212),
    [anon_sym_checkpoint] = ACTIONS(1212),
    [anon_sym_use] = ACTIONS(1212),
    [anon_sym_module] = ACTIONS(1212),
    [sym__dedent] = ACTIONS(1214),
    [sym_string_start] = ACTIONS(1214),
  },
  [314] = {
    [ts_builtin_sym_end] = ACTIONS(1102),
    [sym_identifier] = ACTIONS(1100),
    [anon_sym_import] = ACTIONS(1100),
    [anon_sym_from] = ACTIONS(1100),
    [anon_sym_LPAREN] = ACTIONS(1102),
    [anon_sym_COMMA] = ACTIONS(1102),
    [anon_sym_as] = ACTIONS(1100),
    [anon_sym_STAR] = ACTIONS(1102),
    [anon_sym_print] = ACTIONS(1100),
    [anon_sym_assert] = ACTIONS(1100),
    [anon_sym_return] = ACTIONS(1100),
    [anon_sym_del] = ACTIONS(1100),
    [anon_sym_raise] = ACTIONS(1100),
    [anon_sym_pass] = ACTIONS(1100),
    [anon_sym_break] = ACTIONS(1100),
    [anon_sym_continue] = ACTIONS(1100),
    [anon_sym_if] = ACTIONS(1100),
    [anon_sym_match] = ACTIONS(1100),
    [anon_sym_async] = ACTIONS(1100),
    [anon_sym_for] = ACTIONS(1100),
    [anon_sym_while] = ACTIONS(1100),
    [anon_sym_try] = ACTIONS(1100),
    [anon_sym_with] = ACTIONS(1100),
    [anon_sym_def] = ACTIONS(1100),
    [anon_sym_global] = ACTIONS(1100),
    [anon_sym_nonlocal] = ACTIONS(1100),
    [anon_sym_exec] = ACTIONS(1100),
    [anon_sym_type] = ACTIONS(1100),
    [anon_sym_class] = ACTIONS(1100),
    [anon_sym_LBRACK] = ACTIONS(1102),
    [anon_sym_AT] = ACTIONS(1102),
    [anon_sym_DASH] = ACTIONS(1102),
    [anon_sym_LBRACE] = ACTIONS(1102),
    [anon_sym_PLUS] = ACTIONS(1102),
    [anon_sym_not] = ACTIONS(1100),
    [anon_sym_TILDE] = ACTIONS(1102),
    [anon_sym_lambda] = ACTIONS(1100),
    [anon_sym_yield] = ACTIONS(1100),
    [sym_ellipsis] = ACTIONS(1102),
    [sym_integer] = ACTIONS(1100),
    [sym_float] = ACTIONS(1102),
    [anon_sym_await] = ACTIONS(1100),
    [sym_true] = ACTIONS(1100),
    [sym_false] = ACTIONS(1100),
    [sym_none] = ACTIONS(1100),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1100),
    [anon_sym_container] = ACTIONS(1100),
    [anon_sym_envvars] = ACTIONS(1100),
    [anon_sym_include] = ACTIONS(1100),
    [anon_sym_pepfile] = ACTIONS(1100),
    [anon_sym_pepschema] = ACTIONS(1100),
    [anon_sym_scattergather] = ACTIONS(1100),
    [anon_sym_version] = ACTIONS(1100),
    [anon_sym_wildcard_constraints] = ACTIONS(1100),
    [anon_sym_workdir] = ACTIONS(1100),
    [anon_sym_onerror] = ACTIONS(1100),
    [anon_sym_onstart] = ACTIONS(1100),
    [anon_sym_onsuccess] = ACTIONS(1100),
    [anon_sym_localrules] = ACTIONS(1100),
    [anon_sym_ruleorder] = ACTIONS(1100),
    [anon_sym_rule] = ACTIONS(1100),
    [anon_sym_checkpoint] = ACTIONS(1100),
    [anon_sym_use] = ACTIONS(1100),
    [anon_sym_module] = ACTIONS(1100),
    [sym_string_start] = ACTIONS(1102),
  },
  [315] = {
    [sym_finally_clause] = STATE(412),
    [ts_builtin_sym_end] = ACTIONS(1164),
    [sym_identifier] = ACTIONS(1162),
    [anon_sym_import] = ACTIONS(1162),
    [anon_sym_from] = ACTIONS(1162),
    [anon_sym_LPAREN] = ACTIONS(1164),
    [anon_sym_STAR] = ACTIONS(1164),
    [anon_sym_print] = ACTIONS(1162),
    [anon_sym_assert] = ACTIONS(1162),
    [anon_sym_return] = ACTIONS(1162),
    [anon_sym_del] = ACTIONS(1162),
    [anon_sym_raise] = ACTIONS(1162),
    [anon_sym_pass] = ACTIONS(1162),
    [anon_sym_break] = ACTIONS(1162),
    [anon_sym_continue] = ACTIONS(1162),
    [anon_sym_if] = ACTIONS(1162),
    [anon_sym_match] = ACTIONS(1162),
    [anon_sym_async] = ACTIONS(1162),
    [anon_sym_for] = ACTIONS(1162),
    [anon_sym_while] = ACTIONS(1162),
    [anon_sym_try] = ACTIONS(1162),
    [anon_sym_finally] = ACTIONS(812),
    [anon_sym_with] = ACTIONS(1162),
    [anon_sym_def] = ACTIONS(1162),
    [anon_sym_global] = ACTIONS(1162),
    [anon_sym_nonlocal] = ACTIONS(1162),
    [anon_sym_exec] = ACTIONS(1162),
    [anon_sym_type] = ACTIONS(1162),
    [anon_sym_class] = ACTIONS(1162),
    [anon_sym_LBRACK] = ACTIONS(1164),
    [anon_sym_AT] = ACTIONS(1164),
    [anon_sym_DASH] = ACTIONS(1164),
    [anon_sym_LBRACE] = ACTIONS(1164),
    [anon_sym_PLUS] = ACTIONS(1164),
    [anon_sym_not] = ACTIONS(1162),
    [anon_sym_TILDE] = ACTIONS(1164),
    [anon_sym_lambda] = ACTIONS(1162),
    [anon_sym_yield] = ACTIONS(1162),
    [sym_ellipsis] = ACTIONS(1164),
    [sym_integer] = ACTIONS(1162),
    [sym_float] = ACTIONS(1164),
    [anon_sym_await] = ACTIONS(1162),
    [sym_true] = ACTIONS(1162),
    [sym_false] = ACTIONS(1162),
    [sym_none] = ACTIONS(1162),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1162),
    [anon_sym_container] = ACTIONS(1162),
    [anon_sym_envvars] = ACTIONS(1162),
    [anon_sym_include] = ACTIONS(1162),
    [anon_sym_pepfile] = ACTIONS(1162),
    [anon_sym_pepschema] = ACTIONS(1162),
    [anon_sym_scattergather] = ACTIONS(1162),
    [anon_sym_version] = ACTIONS(1162),
    [anon_sym_wildcard_constraints] = ACTIONS(1162),
    [anon_sym_workdir] = ACTIONS(1162),
    [anon_sym_onerror] = ACTIONS(1162),
    [anon_sym_onstart] = ACTIONS(1162),
    [anon_sym_onsuccess] = ACTIONS(1162),
    [anon_sym_localrules] = ACTIONS(1162),
    [anon_sym_ruleorder] = ACTIONS(1162),
    [anon_sym_rule] = ACTIONS(1162),
    [anon_sym_checkpoint] = ACTIONS(1162),
    [anon_sym_use] = ACTIONS(1162),
    [anon_sym_module] = ACTIONS(1162),
    [sym_string_start] = ACTIONS(1164),
  },
  [316] = {
    [sym_else_clause] = STATE(389),
    [sym_identifier] = ACTIONS(1174),
    [anon_sym_import] = ACTIONS(1174),
    [anon_sym_from] = ACTIONS(1174),
    [anon_sym_LPAREN] = ACTIONS(1172),
    [anon_sym_STAR] = ACTIONS(1172),
    [anon_sym_print] = ACTIONS(1174),
    [anon_sym_assert] = ACTIONS(1174),
    [anon_sym_return] = ACTIONS(1174),
    [anon_sym_del] = ACTIONS(1174),
    [anon_sym_raise] = ACTIONS(1174),
    [anon_sym_pass] = ACTIONS(1174),
    [anon_sym_break] = ACTIONS(1174),
    [anon_sym_continue] = ACTIONS(1174),
    [anon_sym_if] = ACTIONS(1174),
    [anon_sym_else] = ACTIONS(820),
    [anon_sym_match] = ACTIONS(1174),
    [anon_sym_async] = ACTIONS(1174),
    [anon_sym_for] = ACTIONS(1174),
    [anon_sym_while] = ACTIONS(1174),
    [anon_sym_try] = ACTIONS(1174),
    [anon_sym_with] = ACTIONS(1174),
    [anon_sym_def] = ACTIONS(1174),
    [anon_sym_global] = ACTIONS(1174),
    [anon_sym_nonlocal] = ACTIONS(1174),
    [anon_sym_exec] = ACTIONS(1174),
    [anon_sym_type] = ACTIONS(1174),
    [anon_sym_class] = ACTIONS(1174),
    [anon_sym_LBRACK] = ACTIONS(1172),
    [anon_sym_AT] = ACTIONS(1172),
    [anon_sym_DASH] = ACTIONS(1172),
    [anon_sym_LBRACE] = ACTIONS(1172),
    [anon_sym_PLUS] = ACTIONS(1172),
    [anon_sym_not] = ACTIONS(1174),
    [anon_sym_TILDE] = ACTIONS(1172),
    [anon_sym_lambda] = ACTIONS(1174),
    [anon_sym_yield] = ACTIONS(1174),
    [sym_ellipsis] = ACTIONS(1172),
    [sym_integer] = ACTIONS(1174),
    [sym_float] = ACTIONS(1172),
    [anon_sym_await] = ACTIONS(1174),
    [sym_true] = ACTIONS(1174),
    [sym_false] = ACTIONS(1174),
    [sym_none] = ACTIONS(1174),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1174),
    [anon_sym_container] = ACTIONS(1174),
    [anon_sym_envvars] = ACTIONS(1174),
    [anon_sym_include] = ACTIONS(1174),
    [anon_sym_pepfile] = ACTIONS(1174),
    [anon_sym_pepschema] = ACTIONS(1174),
    [anon_sym_scattergather] = ACTIONS(1174),
    [anon_sym_version] = ACTIONS(1174),
    [anon_sym_wildcard_constraints] = ACTIONS(1174),
    [anon_sym_workdir] = ACTIONS(1174),
    [anon_sym_onerror] = ACTIONS(1174),
    [anon_sym_onstart] = ACTIONS(1174),
    [anon_sym_onsuccess] = ACTIONS(1174),
    [anon_sym_localrules] = ACTIONS(1174),
    [anon_sym_ruleorder] = ACTIONS(1174),
    [anon_sym_rule] = ACTIONS(1174),
    [anon_sym_checkpoint] = ACTIONS(1174),
    [anon_sym_use] = ACTIONS(1174),
    [anon_sym_module] = ACTIONS(1174),
    [sym__dedent] = ACTIONS(1172),
    [sym_string_start] = ACTIONS(1172),
  },
  [317] = {
    [sym_identifier] = ACTIONS(1100),
    [anon_sym_import] = ACTIONS(1100),
    [anon_sym_from] = ACTIONS(1100),
    [anon_sym_LPAREN] = ACTIONS(1102),
    [anon_sym_COMMA] = ACTIONS(1102),
    [anon_sym_as] = ACTIONS(1100),
    [anon_sym_STAR] = ACTIONS(1102),
    [anon_sym_print] = ACTIONS(1100),
    [anon_sym_assert] = ACTIONS(1100),
    [anon_sym_return] = ACTIONS(1100),
    [anon_sym_del] = ACTIONS(1100),
    [anon_sym_raise] = ACTIONS(1100),
    [anon_sym_pass] = ACTIONS(1100),
    [anon_sym_break] = ACTIONS(1100),
    [anon_sym_continue] = ACTIONS(1100),
    [anon_sym_if] = ACTIONS(1100),
    [anon_sym_match] = ACTIONS(1100),
    [anon_sym_async] = ACTIONS(1100),
    [anon_sym_for] = ACTIONS(1100),
    [anon_sym_while] = ACTIONS(1100),
    [anon_sym_try] = ACTIONS(1100),
    [anon_sym_with] = ACTIONS(1100),
    [anon_sym_def] = ACTIONS(1100),
    [anon_sym_global] = ACTIONS(1100),
    [anon_sym_nonlocal] = ACTIONS(1100),
    [anon_sym_exec] = ACTIONS(1100),
    [anon_sym_type] = ACTIONS(1100),
    [anon_sym_class] = ACTIONS(1100),
    [anon_sym_LBRACK] = ACTIONS(1102),
    [anon_sym_AT] = ACTIONS(1102),
    [anon_sym_DASH] = ACTIONS(1102),
    [anon_sym_LBRACE] = ACTIONS(1102),
    [anon_sym_PLUS] = ACTIONS(1102),
    [anon_sym_not] = ACTIONS(1100),
    [anon_sym_TILDE] = ACTIONS(1102),
    [anon_sym_lambda] = ACTIONS(1100),
    [anon_sym_yield] = ACTIONS(1100),
    [sym_ellipsis] = ACTIONS(1102),
    [sym_integer] = ACTIONS(1100),
    [sym_float] = ACTIONS(1102),
    [anon_sym_await] = ACTIONS(1100),
    [sym_true] = ACTIONS(1100),
    [sym_false] = ACTIONS(1100),
    [sym_none] = ACTIONS(1100),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1100),
    [anon_sym_container] = ACTIONS(1100),
    [anon_sym_envvars] = ACTIONS(1100),
    [anon_sym_include] = ACTIONS(1100),
    [anon_sym_pepfile] = ACTIONS(1100),
    [anon_sym_pepschema] = ACTIONS(1100),
    [anon_sym_scattergather] = ACTIONS(1100),
    [anon_sym_version] = ACTIONS(1100),
    [anon_sym_wildcard_constraints] = ACTIONS(1100),
    [anon_sym_workdir] = ACTIONS(1100),
    [anon_sym_onerror] = ACTIONS(1100),
    [anon_sym_onstart] = ACTIONS(1100),
    [anon_sym_onsuccess] = ACTIONS(1100),
    [anon_sym_localrules] = ACTIONS(1100),
    [anon_sym_ruleorder] = ACTIONS(1100),
    [anon_sym_rule] = ACTIONS(1100),
    [anon_sym_checkpoint] = ACTIONS(1100),
    [anon_sym_use] = ACTIONS(1100),
    [anon_sym_module] = ACTIONS(1100),
    [sym__dedent] = ACTIONS(1102),
    [sym_string_start] = ACTIONS(1102),
  },
  [318] = {
    [sym_else_clause] = STATE(393),
    [sym_identifier] = ACTIONS(1200),
    [anon_sym_import] = ACTIONS(1200),
    [anon_sym_from] = ACTIONS(1200),
    [anon_sym_LPAREN] = ACTIONS(1198),
    [anon_sym_STAR] = ACTIONS(1198),
    [anon_sym_print] = ACTIONS(1200),
    [anon_sym_assert] = ACTIONS(1200),
    [anon_sym_return] = ACTIONS(1200),
    [anon_sym_del] = ACTIONS(1200),
    [anon_sym_raise] = ACTIONS(1200),
    [anon_sym_pass] = ACTIONS(1200),
    [anon_sym_break] = ACTIONS(1200),
    [anon_sym_continue] = ACTIONS(1200),
    [anon_sym_if] = ACTIONS(1200),
    [anon_sym_else] = ACTIONS(820),
    [anon_sym_match] = ACTIONS(1200),
    [anon_sym_async] = ACTIONS(1200),
    [anon_sym_for] = ACTIONS(1200),
    [anon_sym_while] = ACTIONS(1200),
    [anon_sym_try] = ACTIONS(1200),
    [anon_sym_with] = ACTIONS(1200),
    [anon_sym_def] = ACTIONS(1200),
    [anon_sym_global] = ACTIONS(1200),
    [anon_sym_nonlocal] = ACTIONS(1200),
    [anon_sym_exec] = ACTIONS(1200),
    [anon_sym_type] = ACTIONS(1200),
    [anon_sym_class] = ACTIONS(1200),
    [anon_sym_LBRACK] = ACTIONS(1198),
    [anon_sym_AT] = ACTIONS(1198),
    [anon_sym_DASH] = ACTIONS(1198),
    [anon_sym_LBRACE] = ACTIONS(1198),
    [anon_sym_PLUS] = ACTIONS(1198),
    [anon_sym_not] = ACTIONS(1200),
    [anon_sym_TILDE] = ACTIONS(1198),
    [anon_sym_lambda] = ACTIONS(1200),
    [anon_sym_yield] = ACTIONS(1200),
    [sym_ellipsis] = ACTIONS(1198),
    [sym_integer] = ACTIONS(1200),
    [sym_float] = ACTIONS(1198),
    [anon_sym_await] = ACTIONS(1200),
    [sym_true] = ACTIONS(1200),
    [sym_false] = ACTIONS(1200),
    [sym_none] = ACTIONS(1200),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1200),
    [anon_sym_container] = ACTIONS(1200),
    [anon_sym_envvars] = ACTIONS(1200),
    [anon_sym_include] = ACTIONS(1200),
    [anon_sym_pepfile] = ACTIONS(1200),
    [anon_sym_pepschema] = ACTIONS(1200),
    [anon_sym_scattergather] = ACTIONS(1200),
    [anon_sym_version] = ACTIONS(1200),
    [anon_sym_wildcard_constraints] = ACTIONS(1200),
    [anon_sym_workdir] = ACTIONS(1200),
    [anon_sym_onerror] = ACTIONS(1200),
    [anon_sym_onstart] = ACTIONS(1200),
    [anon_sym_onsuccess] = ACTIONS(1200),
    [anon_sym_localrules] = ACTIONS(1200),
    [anon_sym_ruleorder] = ACTIONS(1200),
    [anon_sym_rule] = ACTIONS(1200),
    [anon_sym_checkpoint] = ACTIONS(1200),
    [anon_sym_use] = ACTIONS(1200),
    [anon_sym_module] = ACTIONS(1200),
    [sym__dedent] = ACTIONS(1198),
    [sym_string_start] = ACTIONS(1198),
  },
  [319] = {
    [sym_else_clause] = STATE(420),
    [ts_builtin_sym_end] = ACTIONS(1150),
    [sym_identifier] = ACTIONS(1148),
    [anon_sym_import] = ACTIONS(1148),
    [anon_sym_from] = ACTIONS(1148),
    [anon_sym_LPAREN] = ACTIONS(1150),
    [anon_sym_STAR] = ACTIONS(1150),
    [anon_sym_print] = ACTIONS(1148),
    [anon_sym_assert] = ACTIONS(1148),
    [anon_sym_return] = ACTIONS(1148),
    [anon_sym_del] = ACTIONS(1148),
    [anon_sym_raise] = ACTIONS(1148),
    [anon_sym_pass] = ACTIONS(1148),
    [anon_sym_break] = ACTIONS(1148),
    [anon_sym_continue] = ACTIONS(1148),
    [anon_sym_if] = ACTIONS(1148),
    [anon_sym_else] = ACTIONS(808),
    [anon_sym_match] = ACTIONS(1148),
    [anon_sym_async] = ACTIONS(1148),
    [anon_sym_for] = ACTIONS(1148),
    [anon_sym_while] = ACTIONS(1148),
    [anon_sym_try] = ACTIONS(1148),
    [anon_sym_with] = ACTIONS(1148),
    [anon_sym_def] = ACTIONS(1148),
    [anon_sym_global] = ACTIONS(1148),
    [anon_sym_nonlocal] = ACTIONS(1148),
    [anon_sym_exec] = ACTIONS(1148),
    [anon_sym_type] = ACTIONS(1148),
    [anon_sym_class] = ACTIONS(1148),
    [anon_sym_LBRACK] = ACTIONS(1150),
    [anon_sym_AT] = ACTIONS(1150),
    [anon_sym_DASH] = ACTIONS(1150),
    [anon_sym_LBRACE] = ACTIONS(1150),
    [anon_sym_PLUS] = ACTIONS(1150),
    [anon_sym_not] = ACTIONS(1148),
    [anon_sym_TILDE] = ACTIONS(1150),
    [anon_sym_lambda] = ACTIONS(1148),
    [anon_sym_yield] = ACTIONS(1148),
    [sym_ellipsis] = ACTIONS(1150),
    [sym_integer] = ACTIONS(1148),
    [sym_float] = ACTIONS(1150),
    [anon_sym_await] = ACTIONS(1148),
    [sym_true] = ACTIONS(1148),
    [sym_false] = ACTIONS(1148),
    [sym_none] = ACTIONS(1148),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1148),
    [anon_sym_container] = ACTIONS(1148),
    [anon_sym_envvars] = ACTIONS(1148),
    [anon_sym_include] = ACTIONS(1148),
    [anon_sym_pepfile] = ACTIONS(1148),
    [anon_sym_pepschema] = ACTIONS(1148),
    [anon_sym_scattergather] = ACTIONS(1148),
    [anon_sym_version] = ACTIONS(1148),
    [anon_sym_wildcard_constraints] = ACTIONS(1148),
    [anon_sym_workdir] = ACTIONS(1148),
    [anon_sym_onerror] = ACTIONS(1148),
    [anon_sym_onstart] = ACTIONS(1148),
    [anon_sym_onsuccess] = ACTIONS(1148),
    [anon_sym_localrules] = ACTIONS(1148),
    [anon_sym_ruleorder] = ACTIONS(1148),
    [anon_sym_rule] = ACTIONS(1148),
    [anon_sym_checkpoint] = ACTIONS(1148),
    [anon_sym_use] = ACTIONS(1148),
    [anon_sym_module] = ACTIONS(1148),
    [sym_string_start] = ACTIONS(1150),
  },
  [320] = {
    [aux_sym___directive_parameters_ruleorder_repeat1] = STATE(296),
    [ts_builtin_sym_end] = ACTIONS(1214),
    [sym_identifier] = ACTIONS(1212),
    [anon_sym_import] = ACTIONS(1212),
    [anon_sym_from] = ACTIONS(1212),
    [anon_sym_LPAREN] = ACTIONS(1214),
    [anon_sym_STAR] = ACTIONS(1214),
    [anon_sym_print] = ACTIONS(1212),
    [anon_sym_assert] = ACTIONS(1212),
    [anon_sym_return] = ACTIONS(1212),
    [anon_sym_del] = ACTIONS(1212),
    [anon_sym_raise] = ACTIONS(1212),
    [anon_sym_pass] = ACTIONS(1212),
    [anon_sym_break] = ACTIONS(1212),
    [anon_sym_continue] = ACTIONS(1212),
    [anon_sym_if] = ACTIONS(1212),
    [anon_sym_match] = ACTIONS(1212),
    [anon_sym_async] = ACTIONS(1212),
    [anon_sym_for] = ACTIONS(1212),
    [anon_sym_while] = ACTIONS(1212),
    [anon_sym_try] = ACTIONS(1212),
    [anon_sym_with] = ACTIONS(1212),
    [anon_sym_def] = ACTIONS(1212),
    [anon_sym_global] = ACTIONS(1212),
    [anon_sym_nonlocal] = ACTIONS(1212),
    [anon_sym_exec] = ACTIONS(1212),
    [anon_sym_type] = ACTIONS(1212),
    [anon_sym_class] = ACTIONS(1212),
    [anon_sym_LBRACK] = ACTIONS(1214),
    [anon_sym_AT] = ACTIONS(1214),
    [anon_sym_DASH] = ACTIONS(1214),
    [anon_sym_LBRACE] = ACTIONS(1214),
    [anon_sym_PLUS] = ACTIONS(1214),
    [anon_sym_not] = ACTIONS(1212),
    [anon_sym_TILDE] = ACTIONS(1214),
    [anon_sym_GT] = ACTIONS(1160),
    [anon_sym_lambda] = ACTIONS(1212),
    [anon_sym_yield] = ACTIONS(1212),
    [sym_ellipsis] = ACTIONS(1214),
    [sym_integer] = ACTIONS(1212),
    [sym_float] = ACTIONS(1214),
    [anon_sym_await] = ACTIONS(1212),
    [sym_true] = ACTIONS(1212),
    [sym_false] = ACTIONS(1212),
    [sym_none] = ACTIONS(1212),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1212),
    [anon_sym_container] = ACTIONS(1212),
    [anon_sym_envvars] = ACTIONS(1212),
    [anon_sym_include] = ACTIONS(1212),
    [anon_sym_pepfile] = ACTIONS(1212),
    [anon_sym_pepschema] = ACTIONS(1212),
    [anon_sym_scattergather] = ACTIONS(1212),
    [anon_sym_version] = ACTIONS(1212),
    [anon_sym_wildcard_constraints] = ACTIONS(1212),
    [anon_sym_workdir] = ACTIONS(1212),
    [anon_sym_onerror] = ACTIONS(1212),
    [anon_sym_onstart] = ACTIONS(1212),
    [anon_sym_onsuccess] = ACTIONS(1212),
    [anon_sym_localrules] = ACTIONS(1212),
    [anon_sym_ruleorder] = ACTIONS(1212),
    [anon_sym_rule] = ACTIONS(1212),
    [anon_sym_checkpoint] = ACTIONS(1212),
    [anon_sym_use] = ACTIONS(1212),
    [anon_sym_module] = ACTIONS(1212),
    [sym_string_start] = ACTIONS(1214),
  },
  [321] = {
    [ts_builtin_sym_end] = ACTIONS(1208),
    [sym_identifier] = ACTIONS(1206),
    [anon_sym_import] = ACTIONS(1206),
    [anon_sym_from] = ACTIONS(1206),
    [anon_sym_LPAREN] = ACTIONS(1208),
    [anon_sym_STAR] = ACTIONS(1208),
    [anon_sym_print] = ACTIONS(1206),
    [anon_sym_assert] = ACTIONS(1206),
    [anon_sym_return] = ACTIONS(1206),
    [anon_sym_del] = ACTIONS(1206),
    [anon_sym_raise] = ACTIONS(1206),
    [anon_sym_pass] = ACTIONS(1206),
    [anon_sym_break] = ACTIONS(1206),
    [anon_sym_continue] = ACTIONS(1206),
    [anon_sym_if] = ACTIONS(1206),
    [anon_sym_elif] = ACTIONS(1206),
    [anon_sym_else] = ACTIONS(1206),
    [anon_sym_match] = ACTIONS(1206),
    [anon_sym_async] = ACTIONS(1206),
    [anon_sym_for] = ACTIONS(1206),
    [anon_sym_while] = ACTIONS(1206),
    [anon_sym_try] = ACTIONS(1206),
    [anon_sym_with] = ACTIONS(1206),
    [anon_sym_def] = ACTIONS(1206),
    [anon_sym_global] = ACTIONS(1206),
    [anon_sym_nonlocal] = ACTIONS(1206),
    [anon_sym_exec] = ACTIONS(1206),
    [anon_sym_type] = ACTIONS(1206),
    [anon_sym_class] = ACTIONS(1206),
    [anon_sym_LBRACK] = ACTIONS(1208),
    [anon_sym_AT] = ACTIONS(1208),
    [anon_sym_DASH] = ACTIONS(1208),
    [anon_sym_LBRACE] = ACTIONS(1208),
    [anon_sym_PLUS] = ACTIONS(1208),
    [anon_sym_not] = ACTIONS(1206),
    [anon_sym_TILDE] = ACTIONS(1208),
    [anon_sym_lambda] = ACTIONS(1206),
    [anon_sym_yield] = ACTIONS(1206),
    [sym_ellipsis] = ACTIONS(1208),
    [sym_integer] = ACTIONS(1206),
    [sym_float] = ACTIONS(1208),
    [anon_sym_await] = ACTIONS(1206),
    [sym_true] = ACTIONS(1206),
    [sym_false] = ACTIONS(1206),
    [sym_none] = ACTIONS(1206),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1206),
    [anon_sym_container] = ACTIONS(1206),
    [anon_sym_envvars] = ACTIONS(1206),
    [anon_sym_include] = ACTIONS(1206),
    [anon_sym_pepfile] = ACTIONS(1206),
    [anon_sym_pepschema] = ACTIONS(1206),
    [anon_sym_scattergather] = ACTIONS(1206),
    [anon_sym_version] = ACTIONS(1206),
    [anon_sym_wildcard_constraints] = ACTIONS(1206),
    [anon_sym_workdir] = ACTIONS(1206),
    [anon_sym_onerror] = ACTIONS(1206),
    [anon_sym_onstart] = ACTIONS(1206),
    [anon_sym_onsuccess] = ACTIONS(1206),
    [anon_sym_localrules] = ACTIONS(1206),
    [anon_sym_ruleorder] = ACTIONS(1206),
    [anon_sym_rule] = ACTIONS(1206),
    [anon_sym_checkpoint] = ACTIONS(1206),
    [anon_sym_use] = ACTIONS(1206),
    [anon_sym_module] = ACTIONS(1206),
    [sym_string_start] = ACTIONS(1208),
  },
  [322] = {
    [sym_else_clause] = STATE(339),
    [ts_builtin_sym_end] = ACTIONS(1196),
    [sym_identifier] = ACTIONS(1194),
    [anon_sym_import] = ACTIONS(1194),
    [anon_sym_from] = ACTIONS(1194),
    [anon_sym_LPAREN] = ACTIONS(1196),
    [anon_sym_STAR] = ACTIONS(1196),
    [anon_sym_print] = ACTIONS(1194),
    [anon_sym_assert] = ACTIONS(1194),
    [anon_sym_return] = ACTIONS(1194),
    [anon_sym_del] = ACTIONS(1194),
    [anon_sym_raise] = ACTIONS(1194),
    [anon_sym_pass] = ACTIONS(1194),
    [anon_sym_break] = ACTIONS(1194),
    [anon_sym_continue] = ACTIONS(1194),
    [anon_sym_if] = ACTIONS(1194),
    [anon_sym_else] = ACTIONS(808),
    [anon_sym_match] = ACTIONS(1194),
    [anon_sym_async] = ACTIONS(1194),
    [anon_sym_for] = ACTIONS(1194),
    [anon_sym_while] = ACTIONS(1194),
    [anon_sym_try] = ACTIONS(1194),
    [anon_sym_with] = ACTIONS(1194),
    [anon_sym_def] = ACTIONS(1194),
    [anon_sym_global] = ACTIONS(1194),
    [anon_sym_nonlocal] = ACTIONS(1194),
    [anon_sym_exec] = ACTIONS(1194),
    [anon_sym_type] = ACTIONS(1194),
    [anon_sym_class] = ACTIONS(1194),
    [anon_sym_LBRACK] = ACTIONS(1196),
    [anon_sym_AT] = ACTIONS(1196),
    [anon_sym_DASH] = ACTIONS(1196),
    [anon_sym_LBRACE] = ACTIONS(1196),
    [anon_sym_PLUS] = ACTIONS(1196),
    [anon_sym_not] = ACTIONS(1194),
    [anon_sym_TILDE] = ACTIONS(1196),
    [anon_sym_lambda] = ACTIONS(1194),
    [anon_sym_yield] = ACTIONS(1194),
    [sym_ellipsis] = ACTIONS(1196),
    [sym_integer] = ACTIONS(1194),
    [sym_float] = ACTIONS(1196),
    [anon_sym_await] = ACTIONS(1194),
    [sym_true] = ACTIONS(1194),
    [sym_false] = ACTIONS(1194),
    [sym_none] = ACTIONS(1194),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1194),
    [anon_sym_container] = ACTIONS(1194),
    [anon_sym_envvars] = ACTIONS(1194),
    [anon_sym_include] = ACTIONS(1194),
    [anon_sym_pepfile] = ACTIONS(1194),
    [anon_sym_pepschema] = ACTIONS(1194),
    [anon_sym_scattergather] = ACTIONS(1194),
    [anon_sym_version] = ACTIONS(1194),
    [anon_sym_wildcard_constraints] = ACTIONS(1194),
    [anon_sym_workdir] = ACTIONS(1194),
    [anon_sym_onerror] = ACTIONS(1194),
    [anon_sym_onstart] = ACTIONS(1194),
    [anon_sym_onsuccess] = ACTIONS(1194),
    [anon_sym_localrules] = ACTIONS(1194),
    [anon_sym_ruleorder] = ACTIONS(1194),
    [anon_sym_rule] = ACTIONS(1194),
    [anon_sym_checkpoint] = ACTIONS(1194),
    [anon_sym_use] = ACTIONS(1194),
    [anon_sym_module] = ACTIONS(1194),
    [sym_string_start] = ACTIONS(1196),
  },
  [323] = {
    [ts_builtin_sym_end] = ACTIONS(1176),
    [sym_identifier] = ACTIONS(1178),
    [anon_sym_import] = ACTIONS(1178),
    [anon_sym_from] = ACTIONS(1178),
    [anon_sym_LPAREN] = ACTIONS(1176),
    [anon_sym_STAR] = ACTIONS(1176),
    [anon_sym_print] = ACTIONS(1178),
    [anon_sym_assert] = ACTIONS(1178),
    [anon_sym_return] = ACTIONS(1178),
    [anon_sym_del] = ACTIONS(1178),
    [anon_sym_raise] = ACTIONS(1178),
    [anon_sym_pass] = ACTIONS(1178),
    [anon_sym_break] = ACTIONS(1178),
    [anon_sym_continue] = ACTIONS(1178),
    [anon_sym_if] = ACTIONS(1178),
    [anon_sym_match] = ACTIONS(1178),
    [anon_sym_async] = ACTIONS(1178),
    [anon_sym_for] = ACTIONS(1178),
    [anon_sym_while] = ACTIONS(1178),
    [anon_sym_try] = ACTIONS(1178),
    [anon_sym_with] = ACTIONS(1178),
    [anon_sym_def] = ACTIONS(1178),
    [anon_sym_global] = ACTIONS(1178),
    [anon_sym_nonlocal] = ACTIONS(1178),
    [anon_sym_exec] = ACTIONS(1178),
    [anon_sym_type] = ACTIONS(1178),
    [anon_sym_class] = ACTIONS(1178),
    [anon_sym_LBRACK] = ACTIONS(1176),
    [anon_sym_AT] = ACTIONS(1176),
    [anon_sym_DASH] = ACTIONS(1176),
    [anon_sym_LBRACE] = ACTIONS(1176),
    [anon_sym_PLUS] = ACTIONS(1176),
    [anon_sym_not] = ACTIONS(1178),
    [anon_sym_TILDE] = ACTIONS(1176),
    [anon_sym_GT] = ACTIONS(1176),
    [anon_sym_lambda] = ACTIONS(1178),
    [anon_sym_yield] = ACTIONS(1178),
    [sym_ellipsis] = ACTIONS(1176),
    [sym_integer] = ACTIONS(1178),
    [sym_float] = ACTIONS(1176),
    [anon_sym_await] = ACTIONS(1178),
    [sym_true] = ACTIONS(1178),
    [sym_false] = ACTIONS(1178),
    [sym_none] = ACTIONS(1178),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1178),
    [anon_sym_container] = ACTIONS(1178),
    [anon_sym_envvars] = ACTIONS(1178),
    [anon_sym_include] = ACTIONS(1178),
    [anon_sym_pepfile] = ACTIONS(1178),
    [anon_sym_pepschema] = ACTIONS(1178),
    [anon_sym_scattergather] = ACTIONS(1178),
    [anon_sym_version] = ACTIONS(1178),
    [anon_sym_wildcard_constraints] = ACTIONS(1178),
    [anon_sym_workdir] = ACTIONS(1178),
    [anon_sym_onerror] = ACTIONS(1178),
    [anon_sym_onstart] = ACTIONS(1178),
    [anon_sym_onsuccess] = ACTIONS(1178),
    [anon_sym_localrules] = ACTIONS(1178),
    [anon_sym_ruleorder] = ACTIONS(1178),
    [anon_sym_rule] = ACTIONS(1178),
    [anon_sym_checkpoint] = ACTIONS(1178),
    [anon_sym_use] = ACTIONS(1178),
    [anon_sym_module] = ACTIONS(1178),
    [sym_string_start] = ACTIONS(1176),
  },
  [324] = {
    [ts_builtin_sym_end] = ACTIONS(1216),
    [sym_identifier] = ACTIONS(1218),
    [anon_sym_import] = ACTIONS(1218),
    [anon_sym_from] = ACTIONS(1218),
    [anon_sym_LPAREN] = ACTIONS(1216),
    [anon_sym_STAR] = ACTIONS(1216),
    [anon_sym_print] = ACTIONS(1218),
    [anon_sym_assert] = ACTIONS(1218),
    [anon_sym_return] = ACTIONS(1218),
    [anon_sym_del] = ACTIONS(1218),
    [anon_sym_raise] = ACTIONS(1218),
    [anon_sym_pass] = ACTIONS(1218),
    [anon_sym_break] = ACTIONS(1218),
    [anon_sym_continue] = ACTIONS(1218),
    [anon_sym_if] = ACTIONS(1218),
    [anon_sym_match] = ACTIONS(1218),
    [anon_sym_async] = ACTIONS(1218),
    [anon_sym_for] = ACTIONS(1218),
    [anon_sym_while] = ACTIONS(1218),
    [anon_sym_try] = ACTIONS(1218),
    [anon_sym_finally] = ACTIONS(1218),
    [anon_sym_with] = ACTIONS(1218),
    [anon_sym_def] = ACTIONS(1218),
    [anon_sym_global] = ACTIONS(1218),
    [anon_sym_nonlocal] = ACTIONS(1218),
    [anon_sym_exec] = ACTIONS(1218),
    [anon_sym_type] = ACTIONS(1218),
    [anon_sym_class] = ACTIONS(1218),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_AT] = ACTIONS(1216),
    [anon_sym_DASH] = ACTIONS(1216),
    [anon_sym_LBRACE] = ACTIONS(1216),
    [anon_sym_PLUS] = ACTIONS(1216),
    [anon_sym_not] = ACTIONS(1218),
    [anon_sym_TILDE] = ACTIONS(1216),
    [anon_sym_lambda] = ACTIONS(1218),
    [anon_sym_yield] = ACTIONS(1218),
    [sym_ellipsis] = ACTIONS(1216),
    [sym_integer] = ACTIONS(1218),
    [sym_float] = ACTIONS(1216),
    [anon_sym_await] = ACTIONS(1218),
    [sym_true] = ACTIONS(1218),
    [sym_false] = ACTIONS(1218),
    [sym_none] = ACTIONS(1218),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1218),
    [anon_sym_container] = ACTIONS(1218),
    [anon_sym_envvars] = ACTIONS(1218),
    [anon_sym_include] = ACTIONS(1218),
    [anon_sym_pepfile] = ACTIONS(1218),
    [anon_sym_pepschema] = ACTIONS(1218),
    [anon_sym_scattergather] = ACTIONS(1218),
    [anon_sym_version] = ACTIONS(1218),
    [anon_sym_wildcard_constraints] = ACTIONS(1218),
    [anon_sym_workdir] = ACTIONS(1218),
    [anon_sym_onerror] = ACTIONS(1218),
    [anon_sym_onstart] = ACTIONS(1218),
    [anon_sym_onsuccess] = ACTIONS(1218),
    [anon_sym_localrules] = ACTIONS(1218),
    [anon_sym_ruleorder] = ACTIONS(1218),
    [anon_sym_rule] = ACTIONS(1218),
    [anon_sym_checkpoint] = ACTIONS(1218),
    [anon_sym_use] = ACTIONS(1218),
    [anon_sym_module] = ACTIONS(1218),
    [sym_string_start] = ACTIONS(1216),
  },
  [325] = {
    [sym_identifier] = ACTIONS(1220),
    [anon_sym_import] = ACTIONS(1220),
    [anon_sym_from] = ACTIONS(1220),
    [anon_sym_LPAREN] = ACTIONS(1222),
    [anon_sym_as] = ACTIONS(1224),
    [anon_sym_STAR] = ACTIONS(1222),
    [anon_sym_print] = ACTIONS(1220),
    [anon_sym_assert] = ACTIONS(1220),
    [anon_sym_return] = ACTIONS(1220),
    [anon_sym_del] = ACTIONS(1220),
    [anon_sym_raise] = ACTIONS(1220),
    [anon_sym_pass] = ACTIONS(1220),
    [anon_sym_break] = ACTIONS(1220),
    [anon_sym_continue] = ACTIONS(1220),
    [anon_sym_if] = ACTIONS(1220),
    [anon_sym_match] = ACTIONS(1220),
    [anon_sym_async] = ACTIONS(1220),
    [anon_sym_for] = ACTIONS(1220),
    [anon_sym_while] = ACTIONS(1220),
    [anon_sym_try] = ACTIONS(1220),
    [anon_sym_with] = ACTIONS(1226),
    [anon_sym_def] = ACTIONS(1220),
    [anon_sym_global] = ACTIONS(1220),
    [anon_sym_nonlocal] = ACTIONS(1220),
    [anon_sym_exec] = ACTIONS(1220),
    [anon_sym_type] = ACTIONS(1220),
    [anon_sym_class] = ACTIONS(1220),
    [anon_sym_LBRACK] = ACTIONS(1222),
    [anon_sym_AT] = ACTIONS(1222),
    [anon_sym_DASH] = ACTIONS(1222),
    [anon_sym_LBRACE] = ACTIONS(1222),
    [anon_sym_PLUS] = ACTIONS(1222),
    [anon_sym_not] = ACTIONS(1220),
    [anon_sym_TILDE] = ACTIONS(1222),
    [anon_sym_lambda] = ACTIONS(1220),
    [anon_sym_yield] = ACTIONS(1220),
    [sym_ellipsis] = ACTIONS(1222),
    [sym_integer] = ACTIONS(1220),
    [sym_float] = ACTIONS(1222),
    [anon_sym_await] = ACTIONS(1220),
    [sym_true] = ACTIONS(1220),
    [sym_false] = ACTIONS(1220),
    [sym_none] = ACTIONS(1220),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1220),
    [anon_sym_container] = ACTIONS(1220),
    [anon_sym_envvars] = ACTIONS(1220),
    [anon_sym_include] = ACTIONS(1220),
    [anon_sym_pepfile] = ACTIONS(1220),
    [anon_sym_pepschema] = ACTIONS(1220),
    [anon_sym_scattergather] = ACTIONS(1220),
    [anon_sym_version] = ACTIONS(1220),
    [anon_sym_wildcard_constraints] = ACTIONS(1220),
    [anon_sym_workdir] = ACTIONS(1220),
    [anon_sym_onerror] = ACTIONS(1220),
    [anon_sym_onstart] = ACTIONS(1220),
    [anon_sym_onsuccess] = ACTIONS(1220),
    [anon_sym_localrules] = ACTIONS(1220),
    [anon_sym_ruleorder] = ACTIONS(1220),
    [anon_sym_rule] = ACTIONS(1220),
    [anon_sym_checkpoint] = ACTIONS(1220),
    [anon_sym_use] = ACTIONS(1220),
    [anon_sym_module] = ACTIONS(1220),
    [sym__dedent] = ACTIONS(1222),
    [sym_string_start] = ACTIONS(1222),
  },
  [326] = {
    [ts_builtin_sym_end] = ACTIONS(1222),
    [sym_identifier] = ACTIONS(1220),
    [anon_sym_import] = ACTIONS(1220),
    [anon_sym_from] = ACTIONS(1220),
    [anon_sym_LPAREN] = ACTIONS(1222),
    [anon_sym_as] = ACTIONS(1228),
    [anon_sym_STAR] = ACTIONS(1222),
    [anon_sym_print] = ACTIONS(1220),
    [anon_sym_assert] = ACTIONS(1220),
    [anon_sym_return] = ACTIONS(1220),
    [anon_sym_del] = ACTIONS(1220),
    [anon_sym_raise] = ACTIONS(1220),
    [anon_sym_pass] = ACTIONS(1220),
    [anon_sym_break] = ACTIONS(1220),
    [anon_sym_continue] = ACTIONS(1220),
    [anon_sym_if] = ACTIONS(1220),
    [anon_sym_match] = ACTIONS(1220),
    [anon_sym_async] = ACTIONS(1220),
    [anon_sym_for] = ACTIONS(1220),
    [anon_sym_while] = ACTIONS(1220),
    [anon_sym_try] = ACTIONS(1220),
    [anon_sym_with] = ACTIONS(1230),
    [anon_sym_def] = ACTIONS(1220),
    [anon_sym_global] = ACTIONS(1220),
    [anon_sym_nonlocal] = ACTIONS(1220),
    [anon_sym_exec] = ACTIONS(1220),
    [anon_sym_type] = ACTIONS(1220),
    [anon_sym_class] = ACTIONS(1220),
    [anon_sym_LBRACK] = ACTIONS(1222),
    [anon_sym_AT] = ACTIONS(1222),
    [anon_sym_DASH] = ACTIONS(1222),
    [anon_sym_LBRACE] = ACTIONS(1222),
    [anon_sym_PLUS] = ACTIONS(1222),
    [anon_sym_not] = ACTIONS(1220),
    [anon_sym_TILDE] = ACTIONS(1222),
    [anon_sym_lambda] = ACTIONS(1220),
    [anon_sym_yield] = ACTIONS(1220),
    [sym_ellipsis] = ACTIONS(1222),
    [sym_integer] = ACTIONS(1220),
    [sym_float] = ACTIONS(1222),
    [anon_sym_await] = ACTIONS(1220),
    [sym_true] = ACTIONS(1220),
    [sym_false] = ACTIONS(1220),
    [sym_none] = ACTIONS(1220),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1220),
    [anon_sym_container] = ACTIONS(1220),
    [anon_sym_envvars] = ACTIONS(1220),
    [anon_sym_include] = ACTIONS(1220),
    [anon_sym_pepfile] = ACTIONS(1220),
    [anon_sym_pepschema] = ACTIONS(1220),
    [anon_sym_scattergather] = ACTIONS(1220),
    [anon_sym_version] = ACTIONS(1220),
    [anon_sym_wildcard_constraints] = ACTIONS(1220),
    [anon_sym_workdir] = ACTIONS(1220),
    [anon_sym_onerror] = ACTIONS(1220),
    [anon_sym_onstart] = ACTIONS(1220),
    [anon_sym_onsuccess] = ACTIONS(1220),
    [anon_sym_localrules] = ACTIONS(1220),
    [anon_sym_ruleorder] = ACTIONS(1220),
    [anon_sym_rule] = ACTIONS(1220),
    [anon_sym_checkpoint] = ACTIONS(1220),
    [anon_sym_use] = ACTIONS(1220),
    [anon_sym_module] = ACTIONS(1220),
    [sym_string_start] = ACTIONS(1222),
  },
  [327] = {
    [sym_identifier] = ACTIONS(1232),
    [anon_sym_import] = ACTIONS(1234),
    [anon_sym_from] = ACTIONS(1234),
    [anon_sym_LPAREN] = ACTIONS(1236),
    [anon_sym_as] = ACTIONS(1234),
    [anon_sym_STAR] = ACTIONS(1236),
    [anon_sym_print] = ACTIONS(1234),
    [anon_sym_assert] = ACTIONS(1234),
    [anon_sym_return] = ACTIONS(1234),
    [anon_sym_del] = ACTIONS(1234),
    [anon_sym_raise] = ACTIONS(1234),
    [anon_sym_pass] = ACTIONS(1234),
    [anon_sym_break] = ACTIONS(1234),
    [anon_sym_continue] = ACTIONS(1234),
    [anon_sym_if] = ACTIONS(1234),
    [anon_sym_match] = ACTIONS(1234),
    [anon_sym_async] = ACTIONS(1234),
    [anon_sym_for] = ACTIONS(1234),
    [anon_sym_while] = ACTIONS(1234),
    [anon_sym_try] = ACTIONS(1234),
    [anon_sym_with] = ACTIONS(1234),
    [anon_sym_def] = ACTIONS(1234),
    [anon_sym_global] = ACTIONS(1234),
    [anon_sym_nonlocal] = ACTIONS(1234),
    [anon_sym_exec] = ACTIONS(1234),
    [anon_sym_type] = ACTIONS(1234),
    [anon_sym_class] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_AT] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LBRACE] = ACTIONS(1236),
    [anon_sym_PLUS] = ACTIONS(1236),
    [anon_sym_not] = ACTIONS(1234),
    [anon_sym_TILDE] = ACTIONS(1236),
    [anon_sym_lambda] = ACTIONS(1234),
    [anon_sym_yield] = ACTIONS(1234),
    [sym_ellipsis] = ACTIONS(1236),
    [sym_integer] = ACTIONS(1234),
    [sym_float] = ACTIONS(1236),
    [anon_sym_await] = ACTIONS(1234),
    [sym_true] = ACTIONS(1234),
    [sym_false] = ACTIONS(1234),
    [sym_none] = ACTIONS(1234),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1234),
    [anon_sym_container] = ACTIONS(1234),
    [anon_sym_envvars] = ACTIONS(1234),
    [anon_sym_include] = ACTIONS(1234),
    [anon_sym_pepfile] = ACTIONS(1234),
    [anon_sym_pepschema] = ACTIONS(1234),
    [anon_sym_scattergather] = ACTIONS(1234),
    [anon_sym_version] = ACTIONS(1234),
    [anon_sym_wildcard_constraints] = ACTIONS(1234),
    [anon_sym_workdir] = ACTIONS(1234),
    [anon_sym_onerror] = ACTIONS(1234),
    [anon_sym_onstart] = ACTIONS(1234),
    [anon_sym_onsuccess] = ACTIONS(1234),
    [anon_sym_localrules] = ACTIONS(1234),
    [anon_sym_ruleorder] = ACTIONS(1234),
    [anon_sym_rule] = ACTIONS(1234),
    [anon_sym_checkpoint] = ACTIONS(1234),
    [anon_sym_use] = ACTIONS(1234),
    [anon_sym_module] = ACTIONS(1234),
    [sym__dedent] = ACTIONS(1236),
    [sym_string_start] = ACTIONS(1236),
  },
  [328] = {
    [ts_builtin_sym_end] = ACTIONS(1084),
    [sym_identifier] = ACTIONS(1238),
    [anon_sym_import] = ACTIONS(1086),
    [anon_sym_from] = ACTIONS(1086),
    [anon_sym_LPAREN] = ACTIONS(1084),
    [anon_sym_as] = ACTIONS(1086),
    [anon_sym_STAR] = ACTIONS(1084),
    [anon_sym_print] = ACTIONS(1086),
    [anon_sym_assert] = ACTIONS(1086),
    [anon_sym_return] = ACTIONS(1086),
    [anon_sym_del] = ACTIONS(1086),
    [anon_sym_raise] = ACTIONS(1086),
    [anon_sym_pass] = ACTIONS(1086),
    [anon_sym_break] = ACTIONS(1086),
    [anon_sym_continue] = ACTIONS(1086),
    [anon_sym_if] = ACTIONS(1086),
    [anon_sym_match] = ACTIONS(1086),
    [anon_sym_async] = ACTIONS(1086),
    [anon_sym_for] = ACTIONS(1086),
    [anon_sym_while] = ACTIONS(1086),
    [anon_sym_try] = ACTIONS(1086),
    [anon_sym_with] = ACTIONS(1086),
    [anon_sym_def] = ACTIONS(1086),
    [anon_sym_global] = ACTIONS(1086),
    [anon_sym_nonlocal] = ACTIONS(1086),
    [anon_sym_exec] = ACTIONS(1086),
    [anon_sym_type] = ACTIONS(1086),
    [anon_sym_class] = ACTIONS(1086),
    [anon_sym_LBRACK] = ACTIONS(1084),
    [anon_sym_AT] = ACTIONS(1084),
    [anon_sym_DASH] = ACTIONS(1084),
    [anon_sym_LBRACE] = ACTIONS(1084),
    [anon_sym_PLUS] = ACTIONS(1084),
    [anon_sym_not] = ACTIONS(1086),
    [anon_sym_TILDE] = ACTIONS(1084),
    [anon_sym_lambda] = ACTIONS(1086),
    [anon_sym_yield] = ACTIONS(1086),
    [sym_ellipsis] = ACTIONS(1084),
    [sym_integer] = ACTIONS(1086),
    [sym_float] = ACTIONS(1084),
    [anon_sym_await] = ACTIONS(1086),
    [sym_true] = ACTIONS(1086),
    [sym_false] = ACTIONS(1086),
    [sym_none] = ACTIONS(1086),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1086),
    [anon_sym_container] = ACTIONS(1086),
    [anon_sym_envvars] = ACTIONS(1086),
    [anon_sym_include] = ACTIONS(1086),
    [anon_sym_pepfile] = ACTIONS(1086),
    [anon_sym_pepschema] = ACTIONS(1086),
    [anon_sym_scattergather] = ACTIONS(1086),
    [anon_sym_version] = ACTIONS(1086),
    [anon_sym_wildcard_constraints] = ACTIONS(1086),
    [anon_sym_workdir] = ACTIONS(1086),
    [anon_sym_onerror] = ACTIONS(1086),
    [anon_sym_onstart] = ACTIONS(1086),
    [anon_sym_onsuccess] = ACTIONS(1086),
    [anon_sym_localrules] = ACTIONS(1086),
    [anon_sym_ruleorder] = ACTIONS(1086),
    [anon_sym_rule] = ACTIONS(1086),
    [anon_sym_checkpoint] = ACTIONS(1086),
    [anon_sym_use] = ACTIONS(1086),
    [anon_sym_module] = ACTIONS(1086),
    [sym_string_start] = ACTIONS(1084),
  },
  [329] = {
    [sym_identifier] = ACTIONS(1178),
    [anon_sym_import] = ACTIONS(1178),
    [anon_sym_from] = ACTIONS(1178),
    [anon_sym_LPAREN] = ACTIONS(1176),
    [anon_sym_STAR] = ACTIONS(1176),
    [anon_sym_print] = ACTIONS(1178),
    [anon_sym_assert] = ACTIONS(1178),
    [anon_sym_return] = ACTIONS(1178),
    [anon_sym_del] = ACTIONS(1178),
    [anon_sym_raise] = ACTIONS(1178),
    [anon_sym_pass] = ACTIONS(1178),
    [anon_sym_break] = ACTIONS(1178),
    [anon_sym_continue] = ACTIONS(1178),
    [anon_sym_if] = ACTIONS(1178),
    [anon_sym_match] = ACTIONS(1178),
    [anon_sym_async] = ACTIONS(1178),
    [anon_sym_for] = ACTIONS(1178),
    [anon_sym_while] = ACTIONS(1178),
    [anon_sym_try] = ACTIONS(1178),
    [anon_sym_with] = ACTIONS(1178),
    [anon_sym_def] = ACTIONS(1178),
    [anon_sym_global] = ACTIONS(1178),
    [anon_sym_nonlocal] = ACTIONS(1178),
    [anon_sym_exec] = ACTIONS(1178),
    [anon_sym_type] = ACTIONS(1178),
    [anon_sym_class] = ACTIONS(1178),
    [anon_sym_LBRACK] = ACTIONS(1176),
    [anon_sym_AT] = ACTIONS(1176),
    [anon_sym_DASH] = ACTIONS(1176),
    [anon_sym_LBRACE] = ACTIONS(1176),
    [anon_sym_PLUS] = ACTIONS(1176),
    [anon_sym_not] = ACTIONS(1178),
    [anon_sym_TILDE] = ACTIONS(1176),
    [anon_sym_GT] = ACTIONS(1176),
    [anon_sym_lambda] = ACTIONS(1178),
    [anon_sym_yield] = ACTIONS(1178),
    [sym_ellipsis] = ACTIONS(1176),
    [sym_integer] = ACTIONS(1178),
    [sym_float] = ACTIONS(1176),
    [anon_sym_await] = ACTIONS(1178),
    [sym_true] = ACTIONS(1178),
    [sym_false] = ACTIONS(1178),
    [sym_none] = ACTIONS(1178),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1178),
    [anon_sym_container] = ACTIONS(1178),
    [anon_sym_envvars] = ACTIONS(1178),
    [anon_sym_include] = ACTIONS(1178),
    [anon_sym_pepfile] = ACTIONS(1178),
    [anon_sym_pepschema] = ACTIONS(1178),
    [anon_sym_scattergather] = ACTIONS(1178),
    [anon_sym_version] = ACTIONS(1178),
    [anon_sym_wildcard_constraints] = ACTIONS(1178),
    [anon_sym_workdir] = ACTIONS(1178),
    [anon_sym_onerror] = ACTIONS(1178),
    [anon_sym_onstart] = ACTIONS(1178),
    [anon_sym_onsuccess] = ACTIONS(1178),
    [anon_sym_localrules] = ACTIONS(1178),
    [anon_sym_ruleorder] = ACTIONS(1178),
    [anon_sym_rule] = ACTIONS(1178),
    [anon_sym_checkpoint] = ACTIONS(1178),
    [anon_sym_use] = ACTIONS(1178),
    [anon_sym_module] = ACTIONS(1178),
    [sym__dedent] = ACTIONS(1176),
    [sym_string_start] = ACTIONS(1176),
  },
  [330] = {
    [sym_identifier] = ACTIONS(1218),
    [anon_sym_import] = ACTIONS(1218),
    [anon_sym_from] = ACTIONS(1218),
    [anon_sym_LPAREN] = ACTIONS(1216),
    [anon_sym_STAR] = ACTIONS(1216),
    [anon_sym_print] = ACTIONS(1218),
    [anon_sym_assert] = ACTIONS(1218),
    [anon_sym_return] = ACTIONS(1218),
    [anon_sym_del] = ACTIONS(1218),
    [anon_sym_raise] = ACTIONS(1218),
    [anon_sym_pass] = ACTIONS(1218),
    [anon_sym_break] = ACTIONS(1218),
    [anon_sym_continue] = ACTIONS(1218),
    [anon_sym_if] = ACTIONS(1218),
    [anon_sym_match] = ACTIONS(1218),
    [anon_sym_async] = ACTIONS(1218),
    [anon_sym_for] = ACTIONS(1218),
    [anon_sym_while] = ACTIONS(1218),
    [anon_sym_try] = ACTIONS(1218),
    [anon_sym_finally] = ACTIONS(1218),
    [anon_sym_with] = ACTIONS(1218),
    [anon_sym_def] = ACTIONS(1218),
    [anon_sym_global] = ACTIONS(1218),
    [anon_sym_nonlocal] = ACTIONS(1218),
    [anon_sym_exec] = ACTIONS(1218),
    [anon_sym_type] = ACTIONS(1218),
    [anon_sym_class] = ACTIONS(1218),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_AT] = ACTIONS(1216),
    [anon_sym_DASH] = ACTIONS(1216),
    [anon_sym_LBRACE] = ACTIONS(1216),
    [anon_sym_PLUS] = ACTIONS(1216),
    [anon_sym_not] = ACTIONS(1218),
    [anon_sym_TILDE] = ACTIONS(1216),
    [anon_sym_lambda] = ACTIONS(1218),
    [anon_sym_yield] = ACTIONS(1218),
    [sym_ellipsis] = ACTIONS(1216),
    [sym_integer] = ACTIONS(1218),
    [sym_float] = ACTIONS(1216),
    [anon_sym_await] = ACTIONS(1218),
    [sym_true] = ACTIONS(1218),
    [sym_false] = ACTIONS(1218),
    [sym_none] = ACTIONS(1218),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1218),
    [anon_sym_container] = ACTIONS(1218),
    [anon_sym_envvars] = ACTIONS(1218),
    [anon_sym_include] = ACTIONS(1218),
    [anon_sym_pepfile] = ACTIONS(1218),
    [anon_sym_pepschema] = ACTIONS(1218),
    [anon_sym_scattergather] = ACTIONS(1218),
    [anon_sym_version] = ACTIONS(1218),
    [anon_sym_wildcard_constraints] = ACTIONS(1218),
    [anon_sym_workdir] = ACTIONS(1218),
    [anon_sym_onerror] = ACTIONS(1218),
    [anon_sym_onstart] = ACTIONS(1218),
    [anon_sym_onsuccess] = ACTIONS(1218),
    [anon_sym_localrules] = ACTIONS(1218),
    [anon_sym_ruleorder] = ACTIONS(1218),
    [anon_sym_rule] = ACTIONS(1218),
    [anon_sym_checkpoint] = ACTIONS(1218),
    [anon_sym_use] = ACTIONS(1218),
    [anon_sym_module] = ACTIONS(1218),
    [sym__dedent] = ACTIONS(1216),
    [sym_string_start] = ACTIONS(1216),
  },
  [331] = {
    [sym_identifier] = ACTIONS(1240),
    [anon_sym_import] = ACTIONS(1240),
    [anon_sym_from] = ACTIONS(1240),
    [anon_sym_LPAREN] = ACTIONS(1242),
    [anon_sym_STAR] = ACTIONS(1242),
    [anon_sym_print] = ACTIONS(1240),
    [anon_sym_assert] = ACTIONS(1240),
    [anon_sym_return] = ACTIONS(1240),
    [anon_sym_del] = ACTIONS(1240),
    [anon_sym_raise] = ACTIONS(1240),
    [anon_sym_pass] = ACTIONS(1240),
    [anon_sym_break] = ACTIONS(1240),
    [anon_sym_continue] = ACTIONS(1240),
    [anon_sym_if] = ACTIONS(1240),
    [anon_sym_match] = ACTIONS(1240),
    [anon_sym_async] = ACTIONS(1240),
    [anon_sym_for] = ACTIONS(1240),
    [anon_sym_while] = ACTIONS(1240),
    [anon_sym_try] = ACTIONS(1240),
    [anon_sym_finally] = ACTIONS(1240),
    [anon_sym_with] = ACTIONS(1240),
    [anon_sym_def] = ACTIONS(1240),
    [anon_sym_global] = ACTIONS(1240),
    [anon_sym_nonlocal] = ACTIONS(1240),
    [anon_sym_exec] = ACTIONS(1240),
    [anon_sym_type] = ACTIONS(1240),
    [anon_sym_class] = ACTIONS(1240),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [anon_sym_AT] = ACTIONS(1242),
    [anon_sym_DASH] = ACTIONS(1242),
    [anon_sym_LBRACE] = ACTIONS(1242),
    [anon_sym_PLUS] = ACTIONS(1242),
    [anon_sym_not] = ACTIONS(1240),
    [anon_sym_TILDE] = ACTIONS(1242),
    [anon_sym_lambda] = ACTIONS(1240),
    [anon_sym_yield] = ACTIONS(1240),
    [sym_ellipsis] = ACTIONS(1242),
    [sym_integer] = ACTIONS(1240),
    [sym_float] = ACTIONS(1242),
    [anon_sym_await] = ACTIONS(1240),
    [sym_true] = ACTIONS(1240),
    [sym_false] = ACTIONS(1240),
    [sym_none] = ACTIONS(1240),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1240),
    [anon_sym_container] = ACTIONS(1240),
    [anon_sym_envvars] = ACTIONS(1240),
    [anon_sym_include] = ACTIONS(1240),
    [anon_sym_pepfile] = ACTIONS(1240),
    [anon_sym_pepschema] = ACTIONS(1240),
    [anon_sym_scattergather] = ACTIONS(1240),
    [anon_sym_version] = ACTIONS(1240),
    [anon_sym_wildcard_constraints] = ACTIONS(1240),
    [anon_sym_workdir] = ACTIONS(1240),
    [anon_sym_onerror] = ACTIONS(1240),
    [anon_sym_onstart] = ACTIONS(1240),
    [anon_sym_onsuccess] = ACTIONS(1240),
    [anon_sym_localrules] = ACTIONS(1240),
    [anon_sym_ruleorder] = ACTIONS(1240),
    [anon_sym_rule] = ACTIONS(1240),
    [anon_sym_checkpoint] = ACTIONS(1240),
    [anon_sym_use] = ACTIONS(1240),
    [anon_sym_module] = ACTIONS(1240),
    [sym__dedent] = ACTIONS(1242),
    [sym_string_start] = ACTIONS(1242),
  },
  [332] = {
    [ts_builtin_sym_end] = ACTIONS(1236),
    [sym_identifier] = ACTIONS(1238),
    [anon_sym_import] = ACTIONS(1234),
    [anon_sym_from] = ACTIONS(1234),
    [anon_sym_LPAREN] = ACTIONS(1236),
    [anon_sym_as] = ACTIONS(1234),
    [anon_sym_STAR] = ACTIONS(1236),
    [anon_sym_print] = ACTIONS(1234),
    [anon_sym_assert] = ACTIONS(1234),
    [anon_sym_return] = ACTIONS(1234),
    [anon_sym_del] = ACTIONS(1234),
    [anon_sym_raise] = ACTIONS(1234),
    [anon_sym_pass] = ACTIONS(1234),
    [anon_sym_break] = ACTIONS(1234),
    [anon_sym_continue] = ACTIONS(1234),
    [anon_sym_if] = ACTIONS(1234),
    [anon_sym_match] = ACTIONS(1234),
    [anon_sym_async] = ACTIONS(1234),
    [anon_sym_for] = ACTIONS(1234),
    [anon_sym_while] = ACTIONS(1234),
    [anon_sym_try] = ACTIONS(1234),
    [anon_sym_with] = ACTIONS(1234),
    [anon_sym_def] = ACTIONS(1234),
    [anon_sym_global] = ACTIONS(1234),
    [anon_sym_nonlocal] = ACTIONS(1234),
    [anon_sym_exec] = ACTIONS(1234),
    [anon_sym_type] = ACTIONS(1234),
    [anon_sym_class] = ACTIONS(1234),
    [anon_sym_LBRACK] = ACTIONS(1236),
    [anon_sym_AT] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LBRACE] = ACTIONS(1236),
    [anon_sym_PLUS] = ACTIONS(1236),
    [anon_sym_not] = ACTIONS(1234),
    [anon_sym_TILDE] = ACTIONS(1236),
    [anon_sym_lambda] = ACTIONS(1234),
    [anon_sym_yield] = ACTIONS(1234),
    [sym_ellipsis] = ACTIONS(1236),
    [sym_integer] = ACTIONS(1234),
    [sym_float] = ACTIONS(1236),
    [anon_sym_await] = ACTIONS(1234),
    [sym_true] = ACTIONS(1234),
    [sym_false] = ACTIONS(1234),
    [sym_none] = ACTIONS(1234),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1234),
    [anon_sym_container] = ACTIONS(1234),
    [anon_sym_envvars] = ACTIONS(1234),
    [anon_sym_include] = ACTIONS(1234),
    [anon_sym_pepfile] = ACTIONS(1234),
    [anon_sym_pepschema] = ACTIONS(1234),
    [anon_sym_scattergather] = ACTIONS(1234),
    [anon_sym_version] = ACTIONS(1234),
    [anon_sym_wildcard_constraints] = ACTIONS(1234),
    [anon_sym_workdir] = ACTIONS(1234),
    [anon_sym_onerror] = ACTIONS(1234),
    [anon_sym_onstart] = ACTIONS(1234),
    [anon_sym_onsuccess] = ACTIONS(1234),
    [anon_sym_localrules] = ACTIONS(1234),
    [anon_sym_ruleorder] = ACTIONS(1234),
    [anon_sym_rule] = ACTIONS(1234),
    [anon_sym_checkpoint] = ACTIONS(1234),
    [anon_sym_use] = ACTIONS(1234),
    [anon_sym_module] = ACTIONS(1234),
    [sym_string_start] = ACTIONS(1236),
  },
  [333] = {
    [ts_builtin_sym_end] = ACTIONS(1242),
    [sym_identifier] = ACTIONS(1240),
    [anon_sym_import] = ACTIONS(1240),
    [anon_sym_from] = ACTIONS(1240),
    [anon_sym_LPAREN] = ACTIONS(1242),
    [anon_sym_STAR] = ACTIONS(1242),
    [anon_sym_print] = ACTIONS(1240),
    [anon_sym_assert] = ACTIONS(1240),
    [anon_sym_return] = ACTIONS(1240),
    [anon_sym_del] = ACTIONS(1240),
    [anon_sym_raise] = ACTIONS(1240),
    [anon_sym_pass] = ACTIONS(1240),
    [anon_sym_break] = ACTIONS(1240),
    [anon_sym_continue] = ACTIONS(1240),
    [anon_sym_if] = ACTIONS(1240),
    [anon_sym_match] = ACTIONS(1240),
    [anon_sym_async] = ACTIONS(1240),
    [anon_sym_for] = ACTIONS(1240),
    [anon_sym_while] = ACTIONS(1240),
    [anon_sym_try] = ACTIONS(1240),
    [anon_sym_finally] = ACTIONS(1240),
    [anon_sym_with] = ACTIONS(1240),
    [anon_sym_def] = ACTIONS(1240),
    [anon_sym_global] = ACTIONS(1240),
    [anon_sym_nonlocal] = ACTIONS(1240),
    [anon_sym_exec] = ACTIONS(1240),
    [anon_sym_type] = ACTIONS(1240),
    [anon_sym_class] = ACTIONS(1240),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [anon_sym_AT] = ACTIONS(1242),
    [anon_sym_DASH] = ACTIONS(1242),
    [anon_sym_LBRACE] = ACTIONS(1242),
    [anon_sym_PLUS] = ACTIONS(1242),
    [anon_sym_not] = ACTIONS(1240),
    [anon_sym_TILDE] = ACTIONS(1242),
    [anon_sym_lambda] = ACTIONS(1240),
    [anon_sym_yield] = ACTIONS(1240),
    [sym_ellipsis] = ACTIONS(1242),
    [sym_integer] = ACTIONS(1240),
    [sym_float] = ACTIONS(1242),
    [anon_sym_await] = ACTIONS(1240),
    [sym_true] = ACTIONS(1240),
    [sym_false] = ACTIONS(1240),
    [sym_none] = ACTIONS(1240),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1240),
    [anon_sym_container] = ACTIONS(1240),
    [anon_sym_envvars] = ACTIONS(1240),
    [anon_sym_include] = ACTIONS(1240),
    [anon_sym_pepfile] = ACTIONS(1240),
    [anon_sym_pepschema] = ACTIONS(1240),
    [anon_sym_scattergather] = ACTIONS(1240),
    [anon_sym_version] = ACTIONS(1240),
    [anon_sym_wildcard_constraints] = ACTIONS(1240),
    [anon_sym_workdir] = ACTIONS(1240),
    [anon_sym_onerror] = ACTIONS(1240),
    [anon_sym_onstart] = ACTIONS(1240),
    [anon_sym_onsuccess] = ACTIONS(1240),
    [anon_sym_localrules] = ACTIONS(1240),
    [anon_sym_ruleorder] = ACTIONS(1240),
    [anon_sym_rule] = ACTIONS(1240),
    [anon_sym_checkpoint] = ACTIONS(1240),
    [anon_sym_use] = ACTIONS(1240),
    [anon_sym_module] = ACTIONS(1240),
    [sym_string_start] = ACTIONS(1242),
  },
  [334] = {
    [sym_identifier] = ACTIONS(1232),
    [anon_sym_import] = ACTIONS(1086),
    [anon_sym_from] = ACTIONS(1086),
    [anon_sym_LPAREN] = ACTIONS(1084),
    [anon_sym_as] = ACTIONS(1086),
    [anon_sym_STAR] = ACTIONS(1084),
    [anon_sym_print] = ACTIONS(1086),
    [anon_sym_assert] = ACTIONS(1086),
    [anon_sym_return] = ACTIONS(1086),
    [anon_sym_del] = ACTIONS(1086),
    [anon_sym_raise] = ACTIONS(1086),
    [anon_sym_pass] = ACTIONS(1086),
    [anon_sym_break] = ACTIONS(1086),
    [anon_sym_continue] = ACTIONS(1086),
    [anon_sym_if] = ACTIONS(1086),
    [anon_sym_match] = ACTIONS(1086),
    [anon_sym_async] = ACTIONS(1086),
    [anon_sym_for] = ACTIONS(1086),
    [anon_sym_while] = ACTIONS(1086),
    [anon_sym_try] = ACTIONS(1086),
    [anon_sym_with] = ACTIONS(1086),
    [anon_sym_def] = ACTIONS(1086),
    [anon_sym_global] = ACTIONS(1086),
    [anon_sym_nonlocal] = ACTIONS(1086),
    [anon_sym_exec] = ACTIONS(1086),
    [anon_sym_type] = ACTIONS(1086),
    [anon_sym_class] = ACTIONS(1086),
    [anon_sym_LBRACK] = ACTIONS(1084),
    [anon_sym_AT] = ACTIONS(1084),
    [anon_sym_DASH] = ACTIONS(1084),
    [anon_sym_LBRACE] = ACTIONS(1084),
    [anon_sym_PLUS] = ACTIONS(1084),
    [anon_sym_not] = ACTIONS(1086),
    [anon_sym_TILDE] = ACTIONS(1084),
    [anon_sym_lambda] = ACTIONS(1086),
    [anon_sym_yield] = ACTIONS(1086),
    [sym_ellipsis] = ACTIONS(1084),
    [sym_integer] = ACTIONS(1086),
    [sym_float] = ACTIONS(1084),
    [anon_sym_await] = ACTIONS(1086),
    [sym_true] = ACTIONS(1086),
    [sym_false] = ACTIONS(1086),
    [sym_none] = ACTIONS(1086),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1086),
    [anon_sym_container] = ACTIONS(1086),
    [anon_sym_envvars] = ACTIONS(1086),
    [anon_sym_include] = ACTIONS(1086),
    [anon_sym_pepfile] = ACTIONS(1086),
    [anon_sym_pepschema] = ACTIONS(1086),
    [anon_sym_scattergather] = ACTIONS(1086),
    [anon_sym_version] = ACTIONS(1086),
    [anon_sym_wildcard_constraints] = ACTIONS(1086),
    [anon_sym_workdir] = ACTIONS(1086),
    [anon_sym_onerror] = ACTIONS(1086),
    [anon_sym_onstart] = ACTIONS(1086),
    [anon_sym_onsuccess] = ACTIONS(1086),
    [anon_sym_localrules] = ACTIONS(1086),
    [anon_sym_ruleorder] = ACTIONS(1086),
    [anon_sym_rule] = ACTIONS(1086),
    [anon_sym_checkpoint] = ACTIONS(1086),
    [anon_sym_use] = ACTIONS(1086),
    [anon_sym_module] = ACTIONS(1086),
    [sym__dedent] = ACTIONS(1084),
    [sym_string_start] = ACTIONS(1084),
  },
  [335] = {
    [sym_identifier] = ACTIONS(1244),
    [anon_sym_import] = ACTIONS(1244),
    [anon_sym_from] = ACTIONS(1244),
    [anon_sym_LPAREN] = ACTIONS(1246),
    [anon_sym_STAR] = ACTIONS(1246),
    [anon_sym_print] = ACTIONS(1244),
    [anon_sym_assert] = ACTIONS(1244),
    [anon_sym_return] = ACTIONS(1244),
    [anon_sym_del] = ACTIONS(1244),
    [anon_sym_raise] = ACTIONS(1244),
    [anon_sym_pass] = ACTIONS(1244),
    [anon_sym_break] = ACTIONS(1244),
    [anon_sym_continue] = ACTIONS(1244),
    [anon_sym_if] = ACTIONS(1244),
    [anon_sym_match] = ACTIONS(1244),
    [anon_sym_async] = ACTIONS(1244),
    [anon_sym_for] = ACTIONS(1244),
    [anon_sym_while] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(1244),
    [anon_sym_with] = ACTIONS(1244),
    [anon_sym_def] = ACTIONS(1244),
    [anon_sym_global] = ACTIONS(1244),
    [anon_sym_nonlocal] = ACTIONS(1244),
    [anon_sym_exec] = ACTIONS(1244),
    [anon_sym_type] = ACTIONS(1244),
    [anon_sym_class] = ACTIONS(1244),
    [anon_sym_LBRACK] = ACTIONS(1246),
    [anon_sym_AT] = ACTIONS(1246),
    [anon_sym_DASH] = ACTIONS(1246),
    [anon_sym_LBRACE] = ACTIONS(1246),
    [anon_sym_PLUS] = ACTIONS(1246),
    [anon_sym_not] = ACTIONS(1244),
    [anon_sym_TILDE] = ACTIONS(1246),
    [anon_sym_lambda] = ACTIONS(1244),
    [anon_sym_yield] = ACTIONS(1244),
    [sym_ellipsis] = ACTIONS(1246),
    [sym_integer] = ACTIONS(1244),
    [sym_float] = ACTIONS(1246),
    [anon_sym_await] = ACTIONS(1244),
    [sym_true] = ACTIONS(1244),
    [sym_false] = ACTIONS(1244),
    [sym_none] = ACTIONS(1244),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1244),
    [anon_sym_container] = ACTIONS(1244),
    [anon_sym_envvars] = ACTIONS(1244),
    [anon_sym_include] = ACTIONS(1244),
    [anon_sym_pepfile] = ACTIONS(1244),
    [anon_sym_pepschema] = ACTIONS(1244),
    [anon_sym_scattergather] = ACTIONS(1244),
    [anon_sym_version] = ACTIONS(1244),
    [anon_sym_wildcard_constraints] = ACTIONS(1244),
    [anon_sym_workdir] = ACTIONS(1244),
    [anon_sym_onerror] = ACTIONS(1244),
    [anon_sym_onstart] = ACTIONS(1244),
    [anon_sym_onsuccess] = ACTIONS(1244),
    [anon_sym_localrules] = ACTIONS(1244),
    [anon_sym_ruleorder] = ACTIONS(1244),
    [anon_sym_rule] = ACTIONS(1244),
    [anon_sym_checkpoint] = ACTIONS(1244),
    [anon_sym_use] = ACTIONS(1244),
    [anon_sym_module] = ACTIONS(1244),
    [sym__dedent] = ACTIONS(1246),
    [sym_string_start] = ACTIONS(1246),
  },
  [336] = {
    [sym_identifier] = ACTIONS(1248),
    [anon_sym_import] = ACTIONS(1248),
    [anon_sym_from] = ACTIONS(1248),
    [anon_sym_LPAREN] = ACTIONS(1250),
    [anon_sym_STAR] = ACTIONS(1250),
    [anon_sym_print] = ACTIONS(1248),
    [anon_sym_assert] = ACTIONS(1248),
    [anon_sym_return] = ACTIONS(1248),
    [anon_sym_del] = ACTIONS(1248),
    [anon_sym_raise] = ACTIONS(1248),
    [anon_sym_pass] = ACTIONS(1248),
    [anon_sym_break] = ACTIONS(1248),
    [anon_sym_continue] = ACTIONS(1248),
    [anon_sym_if] = ACTIONS(1248),
    [anon_sym_match] = ACTIONS(1248),
    [anon_sym_async] = ACTIONS(1248),
    [anon_sym_for] = ACTIONS(1248),
    [anon_sym_while] = ACTIONS(1248),
    [anon_sym_try] = ACTIONS(1248),
    [anon_sym_with] = ACTIONS(1248),
    [anon_sym_def] = ACTIONS(1248),
    [anon_sym_global] = ACTIONS(1248),
    [anon_sym_nonlocal] = ACTIONS(1248),
    [anon_sym_exec] = ACTIONS(1248),
    [anon_sym_type] = ACTIONS(1248),
    [anon_sym_class] = ACTIONS(1248),
    [anon_sym_LBRACK] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1250),
    [anon_sym_DASH] = ACTIONS(1250),
    [anon_sym_LBRACE] = ACTIONS(1250),
    [anon_sym_PLUS] = ACTIONS(1250),
    [anon_sym_not] = ACTIONS(1248),
    [anon_sym_TILDE] = ACTIONS(1250),
    [anon_sym_lambda] = ACTIONS(1248),
    [anon_sym_yield] = ACTIONS(1248),
    [sym_ellipsis] = ACTIONS(1250),
    [sym_integer] = ACTIONS(1248),
    [sym_float] = ACTIONS(1250),
    [anon_sym_await] = ACTIONS(1248),
    [sym_true] = ACTIONS(1248),
    [sym_false] = ACTIONS(1248),
    [sym_none] = ACTIONS(1248),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1248),
    [anon_sym_container] = ACTIONS(1248),
    [anon_sym_envvars] = ACTIONS(1248),
    [anon_sym_include] = ACTIONS(1248),
    [anon_sym_pepfile] = ACTIONS(1248),
    [anon_sym_pepschema] = ACTIONS(1248),
    [anon_sym_scattergather] = ACTIONS(1248),
    [anon_sym_version] = ACTIONS(1248),
    [anon_sym_wildcard_constraints] = ACTIONS(1248),
    [anon_sym_workdir] = ACTIONS(1248),
    [anon_sym_onerror] = ACTIONS(1248),
    [anon_sym_onstart] = ACTIONS(1248),
    [anon_sym_onsuccess] = ACTIONS(1248),
    [anon_sym_localrules] = ACTIONS(1248),
    [anon_sym_ruleorder] = ACTIONS(1248),
    [anon_sym_rule] = ACTIONS(1248),
    [anon_sym_checkpoint] = ACTIONS(1248),
    [anon_sym_use] = ACTIONS(1248),
    [anon_sym_module] = ACTIONS(1248),
    [sym__dedent] = ACTIONS(1250),
    [sym_string_start] = ACTIONS(1250),
  },
  [337] = {
    [ts_builtin_sym_end] = ACTIONS(1252),
    [sym_identifier] = ACTIONS(1254),
    [anon_sym_import] = ACTIONS(1254),
    [anon_sym_from] = ACTIONS(1254),
    [anon_sym_LPAREN] = ACTIONS(1252),
    [anon_sym_STAR] = ACTIONS(1252),
    [anon_sym_print] = ACTIONS(1254),
    [anon_sym_assert] = ACTIONS(1254),
    [anon_sym_return] = ACTIONS(1254),
    [anon_sym_del] = ACTIONS(1254),
    [anon_sym_raise] = ACTIONS(1254),
    [anon_sym_pass] = ACTIONS(1254),
    [anon_sym_break] = ACTIONS(1254),
    [anon_sym_continue] = ACTIONS(1254),
    [anon_sym_if] = ACTIONS(1254),
    [anon_sym_match] = ACTIONS(1254),
    [anon_sym_async] = ACTIONS(1254),
    [anon_sym_for] = ACTIONS(1254),
    [anon_sym_while] = ACTIONS(1254),
    [anon_sym_try] = ACTIONS(1254),
    [anon_sym_with] = ACTIONS(1254),
    [anon_sym_def] = ACTIONS(1254),
    [anon_sym_global] = ACTIONS(1254),
    [anon_sym_nonlocal] = ACTIONS(1254),
    [anon_sym_exec] = ACTIONS(1254),
    [anon_sym_type] = ACTIONS(1254),
    [anon_sym_class] = ACTIONS(1254),
    [anon_sym_LBRACK] = ACTIONS(1252),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_DASH] = ACTIONS(1252),
    [anon_sym_LBRACE] = ACTIONS(1252),
    [anon_sym_PLUS] = ACTIONS(1252),
    [anon_sym_not] = ACTIONS(1254),
    [anon_sym_TILDE] = ACTIONS(1252),
    [anon_sym_lambda] = ACTIONS(1254),
    [anon_sym_yield] = ACTIONS(1254),
    [sym_ellipsis] = ACTIONS(1252),
    [sym_integer] = ACTIONS(1254),
    [sym_float] = ACTIONS(1252),
    [anon_sym_await] = ACTIONS(1254),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_none] = ACTIONS(1254),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1254),
    [anon_sym_container] = ACTIONS(1254),
    [anon_sym_envvars] = ACTIONS(1254),
    [anon_sym_include] = ACTIONS(1254),
    [anon_sym_pepfile] = ACTIONS(1254),
    [anon_sym_pepschema] = ACTIONS(1254),
    [anon_sym_scattergather] = ACTIONS(1254),
    [anon_sym_version] = ACTIONS(1254),
    [anon_sym_wildcard_constraints] = ACTIONS(1254),
    [anon_sym_workdir] = ACTIONS(1254),
    [anon_sym_onerror] = ACTIONS(1254),
    [anon_sym_onstart] = ACTIONS(1254),
    [anon_sym_onsuccess] = ACTIONS(1254),
    [anon_sym_localrules] = ACTIONS(1254),
    [anon_sym_ruleorder] = ACTIONS(1254),
    [anon_sym_rule] = ACTIONS(1254),
    [anon_sym_checkpoint] = ACTIONS(1254),
    [anon_sym_use] = ACTIONS(1254),
    [anon_sym_module] = ACTIONS(1254),
    [sym_string_start] = ACTIONS(1252),
  },
  [338] = {
    [ts_builtin_sym_end] = ACTIONS(1256),
    [sym_identifier] = ACTIONS(1258),
    [anon_sym_import] = ACTIONS(1258),
    [anon_sym_from] = ACTIONS(1258),
    [anon_sym_LPAREN] = ACTIONS(1256),
    [anon_sym_STAR] = ACTIONS(1256),
    [anon_sym_print] = ACTIONS(1258),
    [anon_sym_assert] = ACTIONS(1258),
    [anon_sym_return] = ACTIONS(1258),
    [anon_sym_del] = ACTIONS(1258),
    [anon_sym_raise] = ACTIONS(1258),
    [anon_sym_pass] = ACTIONS(1258),
    [anon_sym_break] = ACTIONS(1258),
    [anon_sym_continue] = ACTIONS(1258),
    [anon_sym_if] = ACTIONS(1258),
    [anon_sym_match] = ACTIONS(1258),
    [anon_sym_async] = ACTIONS(1258),
    [anon_sym_for] = ACTIONS(1258),
    [anon_sym_while] = ACTIONS(1258),
    [anon_sym_try] = ACTIONS(1258),
    [anon_sym_with] = ACTIONS(1258),
    [anon_sym_def] = ACTIONS(1258),
    [anon_sym_global] = ACTIONS(1258),
    [anon_sym_nonlocal] = ACTIONS(1258),
    [anon_sym_exec] = ACTIONS(1258),
    [anon_sym_type] = ACTIONS(1258),
    [anon_sym_class] = ACTIONS(1258),
    [anon_sym_LBRACK] = ACTIONS(1256),
    [anon_sym_AT] = ACTIONS(1256),
    [anon_sym_DASH] = ACTIONS(1256),
    [anon_sym_LBRACE] = ACTIONS(1256),
    [anon_sym_PLUS] = ACTIONS(1256),
    [anon_sym_not] = ACTIONS(1258),
    [anon_sym_TILDE] = ACTIONS(1256),
    [anon_sym_lambda] = ACTIONS(1258),
    [anon_sym_yield] = ACTIONS(1258),
    [sym_ellipsis] = ACTIONS(1256),
    [sym_integer] = ACTIONS(1258),
    [sym_float] = ACTIONS(1256),
    [anon_sym_await] = ACTIONS(1258),
    [sym_true] = ACTIONS(1258),
    [sym_false] = ACTIONS(1258),
    [sym_none] = ACTIONS(1258),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1258),
    [anon_sym_container] = ACTIONS(1258),
    [anon_sym_envvars] = ACTIONS(1258),
    [anon_sym_include] = ACTIONS(1258),
    [anon_sym_pepfile] = ACTIONS(1258),
    [anon_sym_pepschema] = ACTIONS(1258),
    [anon_sym_scattergather] = ACTIONS(1258),
    [anon_sym_version] = ACTIONS(1258),
    [anon_sym_wildcard_constraints] = ACTIONS(1258),
    [anon_sym_workdir] = ACTIONS(1258),
    [anon_sym_onerror] = ACTIONS(1258),
    [anon_sym_onstart] = ACTIONS(1258),
    [anon_sym_onsuccess] = ACTIONS(1258),
    [anon_sym_localrules] = ACTIONS(1258),
    [anon_sym_ruleorder] = ACTIONS(1258),
    [anon_sym_rule] = ACTIONS(1258),
    [anon_sym_checkpoint] = ACTIONS(1258),
    [anon_sym_use] = ACTIONS(1258),
    [anon_sym_module] = ACTIONS(1258),
    [sym_string_start] = ACTIONS(1256),
  },
  [339] = {
    [ts_builtin_sym_end] = ACTIONS(1260),
    [sym_identifier] = ACTIONS(1262),
    [anon_sym_import] = ACTIONS(1262),
    [anon_sym_from] = ACTIONS(1262),
    [anon_sym_LPAREN] = ACTIONS(1260),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_print] = ACTIONS(1262),
    [anon_sym_assert] = ACTIONS(1262),
    [anon_sym_return] = ACTIONS(1262),
    [anon_sym_del] = ACTIONS(1262),
    [anon_sym_raise] = ACTIONS(1262),
    [anon_sym_pass] = ACTIONS(1262),
    [anon_sym_break] = ACTIONS(1262),
    [anon_sym_continue] = ACTIONS(1262),
    [anon_sym_if] = ACTIONS(1262),
    [anon_sym_match] = ACTIONS(1262),
    [anon_sym_async] = ACTIONS(1262),
    [anon_sym_for] = ACTIONS(1262),
    [anon_sym_while] = ACTIONS(1262),
    [anon_sym_try] = ACTIONS(1262),
    [anon_sym_with] = ACTIONS(1262),
    [anon_sym_def] = ACTIONS(1262),
    [anon_sym_global] = ACTIONS(1262),
    [anon_sym_nonlocal] = ACTIONS(1262),
    [anon_sym_exec] = ACTIONS(1262),
    [anon_sym_type] = ACTIONS(1262),
    [anon_sym_class] = ACTIONS(1262),
    [anon_sym_LBRACK] = ACTIONS(1260),
    [anon_sym_AT] = ACTIONS(1260),
    [anon_sym_DASH] = ACTIONS(1260),
    [anon_sym_LBRACE] = ACTIONS(1260),
    [anon_sym_PLUS] = ACTIONS(1260),
    [anon_sym_not] = ACTIONS(1262),
    [anon_sym_TILDE] = ACTIONS(1260),
    [anon_sym_lambda] = ACTIONS(1262),
    [anon_sym_yield] = ACTIONS(1262),
    [sym_ellipsis] = ACTIONS(1260),
    [sym_integer] = ACTIONS(1262),
    [sym_float] = ACTIONS(1260),
    [anon_sym_await] = ACTIONS(1262),
    [sym_true] = ACTIONS(1262),
    [sym_false] = ACTIONS(1262),
    [sym_none] = ACTIONS(1262),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1262),
    [anon_sym_container] = ACTIONS(1262),
    [anon_sym_envvars] = ACTIONS(1262),
    [anon_sym_include] = ACTIONS(1262),
    [anon_sym_pepfile] = ACTIONS(1262),
    [anon_sym_pepschema] = ACTIONS(1262),
    [anon_sym_scattergather] = ACTIONS(1262),
    [anon_sym_version] = ACTIONS(1262),
    [anon_sym_wildcard_constraints] = ACTIONS(1262),
    [anon_sym_workdir] = ACTIONS(1262),
    [anon_sym_onerror] = ACTIONS(1262),
    [anon_sym_onstart] = ACTIONS(1262),
    [anon_sym_onsuccess] = ACTIONS(1262),
    [anon_sym_localrules] = ACTIONS(1262),
    [anon_sym_ruleorder] = ACTIONS(1262),
    [anon_sym_rule] = ACTIONS(1262),
    [anon_sym_checkpoint] = ACTIONS(1262),
    [anon_sym_use] = ACTIONS(1262),
    [anon_sym_module] = ACTIONS(1262),
    [sym_string_start] = ACTIONS(1260),
  },
  [340] = {
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_import] = ACTIONS(1264),
    [anon_sym_from] = ACTIONS(1264),
    [anon_sym_LPAREN] = ACTIONS(1266),
    [anon_sym_STAR] = ACTIONS(1266),
    [anon_sym_print] = ACTIONS(1264),
    [anon_sym_assert] = ACTIONS(1264),
    [anon_sym_return] = ACTIONS(1264),
    [anon_sym_del] = ACTIONS(1264),
    [anon_sym_raise] = ACTIONS(1264),
    [anon_sym_pass] = ACTIONS(1264),
    [anon_sym_break] = ACTIONS(1264),
    [anon_sym_continue] = ACTIONS(1264),
    [anon_sym_if] = ACTIONS(1264),
    [anon_sym_match] = ACTIONS(1264),
    [anon_sym_async] = ACTIONS(1264),
    [anon_sym_for] = ACTIONS(1264),
    [anon_sym_while] = ACTIONS(1264),
    [anon_sym_try] = ACTIONS(1264),
    [anon_sym_with] = ACTIONS(1264),
    [anon_sym_def] = ACTIONS(1264),
    [anon_sym_global] = ACTIONS(1264),
    [anon_sym_nonlocal] = ACTIONS(1264),
    [anon_sym_exec] = ACTIONS(1264),
    [anon_sym_type] = ACTIONS(1264),
    [anon_sym_class] = ACTIONS(1264),
    [anon_sym_LBRACK] = ACTIONS(1266),
    [anon_sym_AT] = ACTIONS(1266),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_LBRACE] = ACTIONS(1266),
    [anon_sym_PLUS] = ACTIONS(1266),
    [anon_sym_not] = ACTIONS(1264),
    [anon_sym_TILDE] = ACTIONS(1266),
    [anon_sym_lambda] = ACTIONS(1264),
    [anon_sym_yield] = ACTIONS(1264),
    [sym_ellipsis] = ACTIONS(1266),
    [sym_integer] = ACTIONS(1264),
    [sym_float] = ACTIONS(1266),
    [anon_sym_await] = ACTIONS(1264),
    [sym_true] = ACTIONS(1264),
    [sym_false] = ACTIONS(1264),
    [sym_none] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1264),
    [anon_sym_container] = ACTIONS(1264),
    [anon_sym_envvars] = ACTIONS(1264),
    [anon_sym_include] = ACTIONS(1264),
    [anon_sym_pepfile] = ACTIONS(1264),
    [anon_sym_pepschema] = ACTIONS(1264),
    [anon_sym_scattergather] = ACTIONS(1264),
    [anon_sym_version] = ACTIONS(1264),
    [anon_sym_wildcard_constraints] = ACTIONS(1264),
    [anon_sym_workdir] = ACTIONS(1264),
    [anon_sym_onerror] = ACTIONS(1264),
    [anon_sym_onstart] = ACTIONS(1264),
    [anon_sym_onsuccess] = ACTIONS(1264),
    [anon_sym_localrules] = ACTIONS(1264),
    [anon_sym_ruleorder] = ACTIONS(1264),
    [anon_sym_rule] = ACTIONS(1264),
    [anon_sym_checkpoint] = ACTIONS(1264),
    [anon_sym_use] = ACTIONS(1264),
    [anon_sym_module] = ACTIONS(1264),
    [sym__dedent] = ACTIONS(1266),
    [sym_string_start] = ACTIONS(1266),
  },
  [341] = {
    [sym_identifier] = ACTIONS(1268),
    [anon_sym_import] = ACTIONS(1268),
    [anon_sym_from] = ACTIONS(1268),
    [anon_sym_LPAREN] = ACTIONS(1270),
    [anon_sym_STAR] = ACTIONS(1270),
    [anon_sym_print] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_del] = ACTIONS(1268),
    [anon_sym_raise] = ACTIONS(1268),
    [anon_sym_pass] = ACTIONS(1268),
    [anon_sym_break] = ACTIONS(1268),
    [anon_sym_continue] = ACTIONS(1268),
    [anon_sym_if] = ACTIONS(1268),
    [anon_sym_match] = ACTIONS(1268),
    [anon_sym_async] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(1268),
    [anon_sym_while] = ACTIONS(1268),
    [anon_sym_try] = ACTIONS(1268),
    [anon_sym_with] = ACTIONS(1268),
    [anon_sym_def] = ACTIONS(1268),
    [anon_sym_global] = ACTIONS(1268),
    [anon_sym_nonlocal] = ACTIONS(1268),
    [anon_sym_exec] = ACTIONS(1268),
    [anon_sym_type] = ACTIONS(1268),
    [anon_sym_class] = ACTIONS(1268),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_AT] = ACTIONS(1270),
    [anon_sym_DASH] = ACTIONS(1270),
    [anon_sym_LBRACE] = ACTIONS(1270),
    [anon_sym_PLUS] = ACTIONS(1270),
    [anon_sym_not] = ACTIONS(1268),
    [anon_sym_TILDE] = ACTIONS(1270),
    [anon_sym_lambda] = ACTIONS(1268),
    [anon_sym_yield] = ACTIONS(1268),
    [sym_ellipsis] = ACTIONS(1270),
    [sym_integer] = ACTIONS(1268),
    [sym_float] = ACTIONS(1270),
    [anon_sym_await] = ACTIONS(1268),
    [sym_true] = ACTIONS(1268),
    [sym_false] = ACTIONS(1268),
    [sym_none] = ACTIONS(1268),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1268),
    [anon_sym_container] = ACTIONS(1268),
    [anon_sym_envvars] = ACTIONS(1268),
    [anon_sym_include] = ACTIONS(1268),
    [anon_sym_pepfile] = ACTIONS(1268),
    [anon_sym_pepschema] = ACTIONS(1268),
    [anon_sym_scattergather] = ACTIONS(1268),
    [anon_sym_version] = ACTIONS(1268),
    [anon_sym_wildcard_constraints] = ACTIONS(1268),
    [anon_sym_workdir] = ACTIONS(1268),
    [anon_sym_onerror] = ACTIONS(1268),
    [anon_sym_onstart] = ACTIONS(1268),
    [anon_sym_onsuccess] = ACTIONS(1268),
    [anon_sym_localrules] = ACTIONS(1268),
    [anon_sym_ruleorder] = ACTIONS(1268),
    [anon_sym_rule] = ACTIONS(1268),
    [anon_sym_checkpoint] = ACTIONS(1268),
    [anon_sym_use] = ACTIONS(1268),
    [anon_sym_module] = ACTIONS(1268),
    [sym__dedent] = ACTIONS(1270),
    [sym_string_start] = ACTIONS(1270),
  },
  [342] = {
    [sym_identifier] = ACTIONS(1272),
    [anon_sym_import] = ACTIONS(1272),
    [anon_sym_from] = ACTIONS(1272),
    [anon_sym_LPAREN] = ACTIONS(1274),
    [anon_sym_STAR] = ACTIONS(1274),
    [anon_sym_print] = ACTIONS(1272),
    [anon_sym_assert] = ACTIONS(1272),
    [anon_sym_return] = ACTIONS(1272),
    [anon_sym_del] = ACTIONS(1272),
    [anon_sym_raise] = ACTIONS(1272),
    [anon_sym_pass] = ACTIONS(1272),
    [anon_sym_break] = ACTIONS(1272),
    [anon_sym_continue] = ACTIONS(1272),
    [anon_sym_if] = ACTIONS(1272),
    [anon_sym_match] = ACTIONS(1272),
    [anon_sym_async] = ACTIONS(1272),
    [anon_sym_for] = ACTIONS(1272),
    [anon_sym_while] = ACTIONS(1272),
    [anon_sym_try] = ACTIONS(1272),
    [anon_sym_with] = ACTIONS(1272),
    [anon_sym_def] = ACTIONS(1272),
    [anon_sym_global] = ACTIONS(1272),
    [anon_sym_nonlocal] = ACTIONS(1272),
    [anon_sym_exec] = ACTIONS(1272),
    [anon_sym_type] = ACTIONS(1272),
    [anon_sym_class] = ACTIONS(1272),
    [anon_sym_LBRACK] = ACTIONS(1274),
    [anon_sym_AT] = ACTIONS(1274),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_LBRACE] = ACTIONS(1274),
    [anon_sym_PLUS] = ACTIONS(1274),
    [anon_sym_not] = ACTIONS(1272),
    [anon_sym_TILDE] = ACTIONS(1274),
    [anon_sym_lambda] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1272),
    [sym_ellipsis] = ACTIONS(1274),
    [sym_integer] = ACTIONS(1272),
    [sym_float] = ACTIONS(1274),
    [anon_sym_await] = ACTIONS(1272),
    [sym_true] = ACTIONS(1272),
    [sym_false] = ACTIONS(1272),
    [sym_none] = ACTIONS(1272),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1272),
    [anon_sym_container] = ACTIONS(1272),
    [anon_sym_envvars] = ACTIONS(1272),
    [anon_sym_include] = ACTIONS(1272),
    [anon_sym_pepfile] = ACTIONS(1272),
    [anon_sym_pepschema] = ACTIONS(1272),
    [anon_sym_scattergather] = ACTIONS(1272),
    [anon_sym_version] = ACTIONS(1272),
    [anon_sym_wildcard_constraints] = ACTIONS(1272),
    [anon_sym_workdir] = ACTIONS(1272),
    [anon_sym_onerror] = ACTIONS(1272),
    [anon_sym_onstart] = ACTIONS(1272),
    [anon_sym_onsuccess] = ACTIONS(1272),
    [anon_sym_localrules] = ACTIONS(1272),
    [anon_sym_ruleorder] = ACTIONS(1272),
    [anon_sym_rule] = ACTIONS(1272),
    [anon_sym_checkpoint] = ACTIONS(1272),
    [anon_sym_use] = ACTIONS(1272),
    [anon_sym_module] = ACTIONS(1272),
    [sym__dedent] = ACTIONS(1274),
    [sym_string_start] = ACTIONS(1274),
  },
  [343] = {
    [sym_identifier] = ACTIONS(1276),
    [anon_sym_import] = ACTIONS(1276),
    [anon_sym_from] = ACTIONS(1276),
    [anon_sym_LPAREN] = ACTIONS(1278),
    [anon_sym_STAR] = ACTIONS(1278),
    [anon_sym_print] = ACTIONS(1276),
    [anon_sym_assert] = ACTIONS(1276),
    [anon_sym_return] = ACTIONS(1276),
    [anon_sym_del] = ACTIONS(1276),
    [anon_sym_raise] = ACTIONS(1276),
    [anon_sym_pass] = ACTIONS(1276),
    [anon_sym_break] = ACTIONS(1276),
    [anon_sym_continue] = ACTIONS(1276),
    [anon_sym_if] = ACTIONS(1276),
    [anon_sym_match] = ACTIONS(1276),
    [anon_sym_async] = ACTIONS(1276),
    [anon_sym_for] = ACTIONS(1276),
    [anon_sym_while] = ACTIONS(1276),
    [anon_sym_try] = ACTIONS(1276),
    [anon_sym_with] = ACTIONS(1276),
    [anon_sym_def] = ACTIONS(1276),
    [anon_sym_global] = ACTIONS(1276),
    [anon_sym_nonlocal] = ACTIONS(1276),
    [anon_sym_exec] = ACTIONS(1276),
    [anon_sym_type] = ACTIONS(1276),
    [anon_sym_class] = ACTIONS(1276),
    [anon_sym_LBRACK] = ACTIONS(1278),
    [anon_sym_AT] = ACTIONS(1278),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_LBRACE] = ACTIONS(1278),
    [anon_sym_PLUS] = ACTIONS(1278),
    [anon_sym_not] = ACTIONS(1276),
    [anon_sym_TILDE] = ACTIONS(1278),
    [anon_sym_lambda] = ACTIONS(1276),
    [anon_sym_yield] = ACTIONS(1276),
    [sym_ellipsis] = ACTIONS(1278),
    [sym_integer] = ACTIONS(1276),
    [sym_float] = ACTIONS(1278),
    [anon_sym_await] = ACTIONS(1276),
    [sym_true] = ACTIONS(1276),
    [sym_false] = ACTIONS(1276),
    [sym_none] = ACTIONS(1276),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1276),
    [anon_sym_container] = ACTIONS(1276),
    [anon_sym_envvars] = ACTIONS(1276),
    [anon_sym_include] = ACTIONS(1276),
    [anon_sym_pepfile] = ACTIONS(1276),
    [anon_sym_pepschema] = ACTIONS(1276),
    [anon_sym_scattergather] = ACTIONS(1276),
    [anon_sym_version] = ACTIONS(1276),
    [anon_sym_wildcard_constraints] = ACTIONS(1276),
    [anon_sym_workdir] = ACTIONS(1276),
    [anon_sym_onerror] = ACTIONS(1276),
    [anon_sym_onstart] = ACTIONS(1276),
    [anon_sym_onsuccess] = ACTIONS(1276),
    [anon_sym_localrules] = ACTIONS(1276),
    [anon_sym_ruleorder] = ACTIONS(1276),
    [anon_sym_rule] = ACTIONS(1276),
    [anon_sym_checkpoint] = ACTIONS(1276),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_module] = ACTIONS(1276),
    [sym__dedent] = ACTIONS(1278),
    [sym_string_start] = ACTIONS(1278),
  },
  [344] = {
    [ts_builtin_sym_end] = ACTIONS(1018),
    [sym_identifier] = ACTIONS(1016),
    [anon_sym_import] = ACTIONS(1016),
    [anon_sym_from] = ACTIONS(1016),
    [anon_sym_LPAREN] = ACTIONS(1018),
    [anon_sym_STAR] = ACTIONS(1018),
    [anon_sym_print] = ACTIONS(1016),
    [anon_sym_assert] = ACTIONS(1016),
    [anon_sym_return] = ACTIONS(1016),
    [anon_sym_del] = ACTIONS(1016),
    [anon_sym_raise] = ACTIONS(1016),
    [anon_sym_pass] = ACTIONS(1016),
    [anon_sym_break] = ACTIONS(1016),
    [anon_sym_continue] = ACTIONS(1016),
    [anon_sym_if] = ACTIONS(1016),
    [anon_sym_match] = ACTIONS(1016),
    [anon_sym_async] = ACTIONS(1016),
    [anon_sym_for] = ACTIONS(1016),
    [anon_sym_while] = ACTIONS(1016),
    [anon_sym_try] = ACTIONS(1016),
    [anon_sym_with] = ACTIONS(1016),
    [anon_sym_def] = ACTIONS(1016),
    [anon_sym_global] = ACTIONS(1016),
    [anon_sym_nonlocal] = ACTIONS(1016),
    [anon_sym_exec] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(1016),
    [anon_sym_class] = ACTIONS(1016),
    [anon_sym_LBRACK] = ACTIONS(1018),
    [anon_sym_AT] = ACTIONS(1018),
    [anon_sym_DASH] = ACTIONS(1018),
    [anon_sym_LBRACE] = ACTIONS(1018),
    [anon_sym_PLUS] = ACTIONS(1018),
    [anon_sym_not] = ACTIONS(1016),
    [anon_sym_TILDE] = ACTIONS(1018),
    [anon_sym_lambda] = ACTIONS(1016),
    [anon_sym_yield] = ACTIONS(1016),
    [sym_ellipsis] = ACTIONS(1018),
    [sym_integer] = ACTIONS(1016),
    [sym_float] = ACTIONS(1018),
    [anon_sym_await] = ACTIONS(1016),
    [sym_true] = ACTIONS(1016),
    [sym_false] = ACTIONS(1016),
    [sym_none] = ACTIONS(1016),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1016),
    [anon_sym_container] = ACTIONS(1016),
    [anon_sym_envvars] = ACTIONS(1016),
    [anon_sym_include] = ACTIONS(1016),
    [anon_sym_pepfile] = ACTIONS(1016),
    [anon_sym_pepschema] = ACTIONS(1016),
    [anon_sym_scattergather] = ACTIONS(1016),
    [anon_sym_version] = ACTIONS(1016),
    [anon_sym_wildcard_constraints] = ACTIONS(1016),
    [anon_sym_workdir] = ACTIONS(1016),
    [anon_sym_onerror] = ACTIONS(1016),
    [anon_sym_onstart] = ACTIONS(1016),
    [anon_sym_onsuccess] = ACTIONS(1016),
    [anon_sym_localrules] = ACTIONS(1016),
    [anon_sym_ruleorder] = ACTIONS(1016),
    [anon_sym_rule] = ACTIONS(1016),
    [anon_sym_checkpoint] = ACTIONS(1016),
    [anon_sym_use] = ACTIONS(1016),
    [anon_sym_module] = ACTIONS(1016),
    [sym_string_start] = ACTIONS(1018),
  },
  [345] = {
    [ts_builtin_sym_end] = ACTIONS(1280),
    [sym_identifier] = ACTIONS(1282),
    [anon_sym_import] = ACTIONS(1282),
    [anon_sym_from] = ACTIONS(1282),
    [anon_sym_LPAREN] = ACTIONS(1280),
    [anon_sym_STAR] = ACTIONS(1280),
    [anon_sym_print] = ACTIONS(1282),
    [anon_sym_assert] = ACTIONS(1282),
    [anon_sym_return] = ACTIONS(1282),
    [anon_sym_del] = ACTIONS(1282),
    [anon_sym_raise] = ACTIONS(1282),
    [anon_sym_pass] = ACTIONS(1282),
    [anon_sym_break] = ACTIONS(1282),
    [anon_sym_continue] = ACTIONS(1282),
    [anon_sym_if] = ACTIONS(1282),
    [anon_sym_match] = ACTIONS(1282),
    [anon_sym_async] = ACTIONS(1282),
    [anon_sym_for] = ACTIONS(1282),
    [anon_sym_while] = ACTIONS(1282),
    [anon_sym_try] = ACTIONS(1282),
    [anon_sym_with] = ACTIONS(1282),
    [anon_sym_def] = ACTIONS(1282),
    [anon_sym_global] = ACTIONS(1282),
    [anon_sym_nonlocal] = ACTIONS(1282),
    [anon_sym_exec] = ACTIONS(1282),
    [anon_sym_type] = ACTIONS(1282),
    [anon_sym_class] = ACTIONS(1282),
    [anon_sym_LBRACK] = ACTIONS(1280),
    [anon_sym_AT] = ACTIONS(1280),
    [anon_sym_DASH] = ACTIONS(1280),
    [anon_sym_LBRACE] = ACTIONS(1280),
    [anon_sym_PLUS] = ACTIONS(1280),
    [anon_sym_not] = ACTIONS(1282),
    [anon_sym_TILDE] = ACTIONS(1280),
    [anon_sym_lambda] = ACTIONS(1282),
    [anon_sym_yield] = ACTIONS(1282),
    [sym_ellipsis] = ACTIONS(1280),
    [sym_integer] = ACTIONS(1282),
    [sym_float] = ACTIONS(1280),
    [anon_sym_await] = ACTIONS(1282),
    [sym_true] = ACTIONS(1282),
    [sym_false] = ACTIONS(1282),
    [sym_none] = ACTIONS(1282),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1282),
    [anon_sym_container] = ACTIONS(1282),
    [anon_sym_envvars] = ACTIONS(1282),
    [anon_sym_include] = ACTIONS(1282),
    [anon_sym_pepfile] = ACTIONS(1282),
    [anon_sym_pepschema] = ACTIONS(1282),
    [anon_sym_scattergather] = ACTIONS(1282),
    [anon_sym_version] = ACTIONS(1282),
    [anon_sym_wildcard_constraints] = ACTIONS(1282),
    [anon_sym_workdir] = ACTIONS(1282),
    [anon_sym_onerror] = ACTIONS(1282),
    [anon_sym_onstart] = ACTIONS(1282),
    [anon_sym_onsuccess] = ACTIONS(1282),
    [anon_sym_localrules] = ACTIONS(1282),
    [anon_sym_ruleorder] = ACTIONS(1282),
    [anon_sym_rule] = ACTIONS(1282),
    [anon_sym_checkpoint] = ACTIONS(1282),
    [anon_sym_use] = ACTIONS(1282),
    [anon_sym_module] = ACTIONS(1282),
    [sym_string_start] = ACTIONS(1280),
  },
  [346] = {
    [ts_builtin_sym_end] = ACTIONS(1284),
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_import] = ACTIONS(1286),
    [anon_sym_from] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_STAR] = ACTIONS(1284),
    [anon_sym_print] = ACTIONS(1286),
    [anon_sym_assert] = ACTIONS(1286),
    [anon_sym_return] = ACTIONS(1286),
    [anon_sym_del] = ACTIONS(1286),
    [anon_sym_raise] = ACTIONS(1286),
    [anon_sym_pass] = ACTIONS(1286),
    [anon_sym_break] = ACTIONS(1286),
    [anon_sym_continue] = ACTIONS(1286),
    [anon_sym_if] = ACTIONS(1286),
    [anon_sym_match] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1286),
    [anon_sym_for] = ACTIONS(1286),
    [anon_sym_while] = ACTIONS(1286),
    [anon_sym_try] = ACTIONS(1286),
    [anon_sym_with] = ACTIONS(1286),
    [anon_sym_def] = ACTIONS(1286),
    [anon_sym_global] = ACTIONS(1286),
    [anon_sym_nonlocal] = ACTIONS(1286),
    [anon_sym_exec] = ACTIONS(1286),
    [anon_sym_type] = ACTIONS(1286),
    [anon_sym_class] = ACTIONS(1286),
    [anon_sym_LBRACK] = ACTIONS(1284),
    [anon_sym_AT] = ACTIONS(1284),
    [anon_sym_DASH] = ACTIONS(1284),
    [anon_sym_LBRACE] = ACTIONS(1284),
    [anon_sym_PLUS] = ACTIONS(1284),
    [anon_sym_not] = ACTIONS(1286),
    [anon_sym_TILDE] = ACTIONS(1284),
    [anon_sym_lambda] = ACTIONS(1286),
    [anon_sym_yield] = ACTIONS(1286),
    [sym_ellipsis] = ACTIONS(1284),
    [sym_integer] = ACTIONS(1286),
    [sym_float] = ACTIONS(1284),
    [anon_sym_await] = ACTIONS(1286),
    [sym_true] = ACTIONS(1286),
    [sym_false] = ACTIONS(1286),
    [sym_none] = ACTIONS(1286),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1286),
    [anon_sym_container] = ACTIONS(1286),
    [anon_sym_envvars] = ACTIONS(1286),
    [anon_sym_include] = ACTIONS(1286),
    [anon_sym_pepfile] = ACTIONS(1286),
    [anon_sym_pepschema] = ACTIONS(1286),
    [anon_sym_scattergather] = ACTIONS(1286),
    [anon_sym_version] = ACTIONS(1286),
    [anon_sym_wildcard_constraints] = ACTIONS(1286),
    [anon_sym_workdir] = ACTIONS(1286),
    [anon_sym_onerror] = ACTIONS(1286),
    [anon_sym_onstart] = ACTIONS(1286),
    [anon_sym_onsuccess] = ACTIONS(1286),
    [anon_sym_localrules] = ACTIONS(1286),
    [anon_sym_ruleorder] = ACTIONS(1286),
    [anon_sym_rule] = ACTIONS(1286),
    [anon_sym_checkpoint] = ACTIONS(1286),
    [anon_sym_use] = ACTIONS(1286),
    [anon_sym_module] = ACTIONS(1286),
    [sym_string_start] = ACTIONS(1284),
  },
  [347] = {
    [ts_builtin_sym_end] = ACTIONS(1288),
    [sym_identifier] = ACTIONS(1290),
    [anon_sym_import] = ACTIONS(1290),
    [anon_sym_from] = ACTIONS(1290),
    [anon_sym_LPAREN] = ACTIONS(1288),
    [anon_sym_STAR] = ACTIONS(1288),
    [anon_sym_print] = ACTIONS(1290),
    [anon_sym_assert] = ACTIONS(1290),
    [anon_sym_return] = ACTIONS(1290),
    [anon_sym_del] = ACTIONS(1290),
    [anon_sym_raise] = ACTIONS(1290),
    [anon_sym_pass] = ACTIONS(1290),
    [anon_sym_break] = ACTIONS(1290),
    [anon_sym_continue] = ACTIONS(1290),
    [anon_sym_if] = ACTIONS(1290),
    [anon_sym_match] = ACTIONS(1290),
    [anon_sym_async] = ACTIONS(1290),
    [anon_sym_for] = ACTIONS(1290),
    [anon_sym_while] = ACTIONS(1290),
    [anon_sym_try] = ACTIONS(1290),
    [anon_sym_with] = ACTIONS(1290),
    [anon_sym_def] = ACTIONS(1290),
    [anon_sym_global] = ACTIONS(1290),
    [anon_sym_nonlocal] = ACTIONS(1290),
    [anon_sym_exec] = ACTIONS(1290),
    [anon_sym_type] = ACTIONS(1290),
    [anon_sym_class] = ACTIONS(1290),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_AT] = ACTIONS(1288),
    [anon_sym_DASH] = ACTIONS(1288),
    [anon_sym_LBRACE] = ACTIONS(1288),
    [anon_sym_PLUS] = ACTIONS(1288),
    [anon_sym_not] = ACTIONS(1290),
    [anon_sym_TILDE] = ACTIONS(1288),
    [anon_sym_lambda] = ACTIONS(1290),
    [anon_sym_yield] = ACTIONS(1290),
    [sym_ellipsis] = ACTIONS(1288),
    [sym_integer] = ACTIONS(1290),
    [sym_float] = ACTIONS(1288),
    [anon_sym_await] = ACTIONS(1290),
    [sym_true] = ACTIONS(1290),
    [sym_false] = ACTIONS(1290),
    [sym_none] = ACTIONS(1290),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1290),
    [anon_sym_container] = ACTIONS(1290),
    [anon_sym_envvars] = ACTIONS(1290),
    [anon_sym_include] = ACTIONS(1290),
    [anon_sym_pepfile] = ACTIONS(1290),
    [anon_sym_pepschema] = ACTIONS(1290),
    [anon_sym_scattergather] = ACTIONS(1290),
    [anon_sym_version] = ACTIONS(1290),
    [anon_sym_wildcard_constraints] = ACTIONS(1290),
    [anon_sym_workdir] = ACTIONS(1290),
    [anon_sym_onerror] = ACTIONS(1290),
    [anon_sym_onstart] = ACTIONS(1290),
    [anon_sym_onsuccess] = ACTIONS(1290),
    [anon_sym_localrules] = ACTIONS(1290),
    [anon_sym_ruleorder] = ACTIONS(1290),
    [anon_sym_rule] = ACTIONS(1290),
    [anon_sym_checkpoint] = ACTIONS(1290),
    [anon_sym_use] = ACTIONS(1290),
    [anon_sym_module] = ACTIONS(1290),
    [sym_string_start] = ACTIONS(1288),
  },
  [348] = {
    [ts_builtin_sym_end] = ACTIONS(1292),
    [sym_identifier] = ACTIONS(1294),
    [anon_sym_import] = ACTIONS(1294),
    [anon_sym_from] = ACTIONS(1294),
    [anon_sym_LPAREN] = ACTIONS(1292),
    [anon_sym_STAR] = ACTIONS(1292),
    [anon_sym_print] = ACTIONS(1294),
    [anon_sym_assert] = ACTIONS(1294),
    [anon_sym_return] = ACTIONS(1294),
    [anon_sym_del] = ACTIONS(1294),
    [anon_sym_raise] = ACTIONS(1294),
    [anon_sym_pass] = ACTIONS(1294),
    [anon_sym_break] = ACTIONS(1294),
    [anon_sym_continue] = ACTIONS(1294),
    [anon_sym_if] = ACTIONS(1294),
    [anon_sym_match] = ACTIONS(1294),
    [anon_sym_async] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1294),
    [anon_sym_while] = ACTIONS(1294),
    [anon_sym_try] = ACTIONS(1294),
    [anon_sym_with] = ACTIONS(1294),
    [anon_sym_def] = ACTIONS(1294),
    [anon_sym_global] = ACTIONS(1294),
    [anon_sym_nonlocal] = ACTIONS(1294),
    [anon_sym_exec] = ACTIONS(1294),
    [anon_sym_type] = ACTIONS(1294),
    [anon_sym_class] = ACTIONS(1294),
    [anon_sym_LBRACK] = ACTIONS(1292),
    [anon_sym_AT] = ACTIONS(1292),
    [anon_sym_DASH] = ACTIONS(1292),
    [anon_sym_LBRACE] = ACTIONS(1292),
    [anon_sym_PLUS] = ACTIONS(1292),
    [anon_sym_not] = ACTIONS(1294),
    [anon_sym_TILDE] = ACTIONS(1292),
    [anon_sym_lambda] = ACTIONS(1294),
    [anon_sym_yield] = ACTIONS(1294),
    [sym_ellipsis] = ACTIONS(1292),
    [sym_integer] = ACTIONS(1294),
    [sym_float] = ACTIONS(1292),
    [anon_sym_await] = ACTIONS(1294),
    [sym_true] = ACTIONS(1294),
    [sym_false] = ACTIONS(1294),
    [sym_none] = ACTIONS(1294),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1294),
    [anon_sym_container] = ACTIONS(1294),
    [anon_sym_envvars] = ACTIONS(1294),
    [anon_sym_include] = ACTIONS(1294),
    [anon_sym_pepfile] = ACTIONS(1294),
    [anon_sym_pepschema] = ACTIONS(1294),
    [anon_sym_scattergather] = ACTIONS(1294),
    [anon_sym_version] = ACTIONS(1294),
    [anon_sym_wildcard_constraints] = ACTIONS(1294),
    [anon_sym_workdir] = ACTIONS(1294),
    [anon_sym_onerror] = ACTIONS(1294),
    [anon_sym_onstart] = ACTIONS(1294),
    [anon_sym_onsuccess] = ACTIONS(1294),
    [anon_sym_localrules] = ACTIONS(1294),
    [anon_sym_ruleorder] = ACTIONS(1294),
    [anon_sym_rule] = ACTIONS(1294),
    [anon_sym_checkpoint] = ACTIONS(1294),
    [anon_sym_use] = ACTIONS(1294),
    [anon_sym_module] = ACTIONS(1294),
    [sym_string_start] = ACTIONS(1292),
  },
  [349] = {
    [ts_builtin_sym_end] = ACTIONS(1032),
    [sym_identifier] = ACTIONS(1030),
    [anon_sym_import] = ACTIONS(1030),
    [anon_sym_from] = ACTIONS(1030),
    [anon_sym_LPAREN] = ACTIONS(1032),
    [anon_sym_STAR] = ACTIONS(1032),
    [anon_sym_print] = ACTIONS(1030),
    [anon_sym_assert] = ACTIONS(1030),
    [anon_sym_return] = ACTIONS(1030),
    [anon_sym_del] = ACTIONS(1030),
    [anon_sym_raise] = ACTIONS(1030),
    [anon_sym_pass] = ACTIONS(1030),
    [anon_sym_break] = ACTIONS(1030),
    [anon_sym_continue] = ACTIONS(1030),
    [anon_sym_if] = ACTIONS(1030),
    [anon_sym_match] = ACTIONS(1030),
    [anon_sym_async] = ACTIONS(1030),
    [anon_sym_for] = ACTIONS(1030),
    [anon_sym_while] = ACTIONS(1030),
    [anon_sym_try] = ACTIONS(1030),
    [anon_sym_with] = ACTIONS(1030),
    [anon_sym_def] = ACTIONS(1030),
    [anon_sym_global] = ACTIONS(1030),
    [anon_sym_nonlocal] = ACTIONS(1030),
    [anon_sym_exec] = ACTIONS(1030),
    [anon_sym_type] = ACTIONS(1030),
    [anon_sym_class] = ACTIONS(1030),
    [anon_sym_LBRACK] = ACTIONS(1032),
    [anon_sym_AT] = ACTIONS(1032),
    [anon_sym_DASH] = ACTIONS(1032),
    [anon_sym_LBRACE] = ACTIONS(1032),
    [anon_sym_PLUS] = ACTIONS(1032),
    [anon_sym_not] = ACTIONS(1030),
    [anon_sym_TILDE] = ACTIONS(1032),
    [anon_sym_lambda] = ACTIONS(1030),
    [anon_sym_yield] = ACTIONS(1030),
    [sym_ellipsis] = ACTIONS(1032),
    [sym_integer] = ACTIONS(1030),
    [sym_float] = ACTIONS(1032),
    [anon_sym_await] = ACTIONS(1030),
    [sym_true] = ACTIONS(1030),
    [sym_false] = ACTIONS(1030),
    [sym_none] = ACTIONS(1030),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1030),
    [anon_sym_container] = ACTIONS(1030),
    [anon_sym_envvars] = ACTIONS(1030),
    [anon_sym_include] = ACTIONS(1030),
    [anon_sym_pepfile] = ACTIONS(1030),
    [anon_sym_pepschema] = ACTIONS(1030),
    [anon_sym_scattergather] = ACTIONS(1030),
    [anon_sym_version] = ACTIONS(1030),
    [anon_sym_wildcard_constraints] = ACTIONS(1030),
    [anon_sym_workdir] = ACTIONS(1030),
    [anon_sym_onerror] = ACTIONS(1030),
    [anon_sym_onstart] = ACTIONS(1030),
    [anon_sym_onsuccess] = ACTIONS(1030),
    [anon_sym_localrules] = ACTIONS(1030),
    [anon_sym_ruleorder] = ACTIONS(1030),
    [anon_sym_rule] = ACTIONS(1030),
    [anon_sym_checkpoint] = ACTIONS(1030),
    [anon_sym_use] = ACTIONS(1030),
    [anon_sym_module] = ACTIONS(1030),
    [sym_string_start] = ACTIONS(1032),
  },
  [350] = {
    [ts_builtin_sym_end] = ACTIONS(1296),
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_import] = ACTIONS(1298),
    [anon_sym_from] = ACTIONS(1298),
    [anon_sym_LPAREN] = ACTIONS(1296),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_print] = ACTIONS(1298),
    [anon_sym_assert] = ACTIONS(1298),
    [anon_sym_return] = ACTIONS(1298),
    [anon_sym_del] = ACTIONS(1298),
    [anon_sym_raise] = ACTIONS(1298),
    [anon_sym_pass] = ACTIONS(1298),
    [anon_sym_break] = ACTIONS(1298),
    [anon_sym_continue] = ACTIONS(1298),
    [anon_sym_if] = ACTIONS(1298),
    [anon_sym_match] = ACTIONS(1298),
    [anon_sym_async] = ACTIONS(1298),
    [anon_sym_for] = ACTIONS(1298),
    [anon_sym_while] = ACTIONS(1298),
    [anon_sym_try] = ACTIONS(1298),
    [anon_sym_with] = ACTIONS(1298),
    [anon_sym_def] = ACTIONS(1298),
    [anon_sym_global] = ACTIONS(1298),
    [anon_sym_nonlocal] = ACTIONS(1298),
    [anon_sym_exec] = ACTIONS(1298),
    [anon_sym_type] = ACTIONS(1298),
    [anon_sym_class] = ACTIONS(1298),
    [anon_sym_LBRACK] = ACTIONS(1296),
    [anon_sym_AT] = ACTIONS(1296),
    [anon_sym_DASH] = ACTIONS(1296),
    [anon_sym_LBRACE] = ACTIONS(1296),
    [anon_sym_PLUS] = ACTIONS(1296),
    [anon_sym_not] = ACTIONS(1298),
    [anon_sym_TILDE] = ACTIONS(1296),
    [anon_sym_lambda] = ACTIONS(1298),
    [anon_sym_yield] = ACTIONS(1298),
    [sym_ellipsis] = ACTIONS(1296),
    [sym_integer] = ACTIONS(1298),
    [sym_float] = ACTIONS(1296),
    [anon_sym_await] = ACTIONS(1298),
    [sym_true] = ACTIONS(1298),
    [sym_false] = ACTIONS(1298),
    [sym_none] = ACTIONS(1298),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1298),
    [anon_sym_container] = ACTIONS(1298),
    [anon_sym_envvars] = ACTIONS(1298),
    [anon_sym_include] = ACTIONS(1298),
    [anon_sym_pepfile] = ACTIONS(1298),
    [anon_sym_pepschema] = ACTIONS(1298),
    [anon_sym_scattergather] = ACTIONS(1298),
    [anon_sym_version] = ACTIONS(1298),
    [anon_sym_wildcard_constraints] = ACTIONS(1298),
    [anon_sym_workdir] = ACTIONS(1298),
    [anon_sym_onerror] = ACTIONS(1298),
    [anon_sym_onstart] = ACTIONS(1298),
    [anon_sym_onsuccess] = ACTIONS(1298),
    [anon_sym_localrules] = ACTIONS(1298),
    [anon_sym_ruleorder] = ACTIONS(1298),
    [anon_sym_rule] = ACTIONS(1298),
    [anon_sym_checkpoint] = ACTIONS(1298),
    [anon_sym_use] = ACTIONS(1298),
    [anon_sym_module] = ACTIONS(1298),
    [sym_string_start] = ACTIONS(1296),
  },
  [351] = {
    [sym_identifier] = ACTIONS(1300),
    [anon_sym_import] = ACTIONS(1300),
    [anon_sym_from] = ACTIONS(1300),
    [anon_sym_LPAREN] = ACTIONS(1302),
    [anon_sym_STAR] = ACTIONS(1302),
    [anon_sym_print] = ACTIONS(1300),
    [anon_sym_assert] = ACTIONS(1300),
    [anon_sym_return] = ACTIONS(1300),
    [anon_sym_del] = ACTIONS(1300),
    [anon_sym_raise] = ACTIONS(1300),
    [anon_sym_pass] = ACTIONS(1300),
    [anon_sym_break] = ACTIONS(1300),
    [anon_sym_continue] = ACTIONS(1300),
    [anon_sym_if] = ACTIONS(1300),
    [anon_sym_match] = ACTIONS(1300),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_for] = ACTIONS(1300),
    [anon_sym_while] = ACTIONS(1300),
    [anon_sym_try] = ACTIONS(1300),
    [anon_sym_with] = ACTIONS(1300),
    [anon_sym_def] = ACTIONS(1300),
    [anon_sym_global] = ACTIONS(1300),
    [anon_sym_nonlocal] = ACTIONS(1300),
    [anon_sym_exec] = ACTIONS(1300),
    [anon_sym_type] = ACTIONS(1300),
    [anon_sym_class] = ACTIONS(1300),
    [anon_sym_LBRACK] = ACTIONS(1302),
    [anon_sym_AT] = ACTIONS(1302),
    [anon_sym_DASH] = ACTIONS(1302),
    [anon_sym_LBRACE] = ACTIONS(1302),
    [anon_sym_PLUS] = ACTIONS(1302),
    [anon_sym_not] = ACTIONS(1300),
    [anon_sym_TILDE] = ACTIONS(1302),
    [anon_sym_lambda] = ACTIONS(1300),
    [anon_sym_yield] = ACTIONS(1300),
    [sym_ellipsis] = ACTIONS(1302),
    [sym_integer] = ACTIONS(1300),
    [sym_float] = ACTIONS(1302),
    [anon_sym_await] = ACTIONS(1300),
    [sym_true] = ACTIONS(1300),
    [sym_false] = ACTIONS(1300),
    [sym_none] = ACTIONS(1300),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1300),
    [anon_sym_container] = ACTIONS(1300),
    [anon_sym_envvars] = ACTIONS(1300),
    [anon_sym_include] = ACTIONS(1300),
    [anon_sym_pepfile] = ACTIONS(1300),
    [anon_sym_pepschema] = ACTIONS(1300),
    [anon_sym_scattergather] = ACTIONS(1300),
    [anon_sym_version] = ACTIONS(1300),
    [anon_sym_wildcard_constraints] = ACTIONS(1300),
    [anon_sym_workdir] = ACTIONS(1300),
    [anon_sym_onerror] = ACTIONS(1300),
    [anon_sym_onstart] = ACTIONS(1300),
    [anon_sym_onsuccess] = ACTIONS(1300),
    [anon_sym_localrules] = ACTIONS(1300),
    [anon_sym_ruleorder] = ACTIONS(1300),
    [anon_sym_rule] = ACTIONS(1300),
    [anon_sym_checkpoint] = ACTIONS(1300),
    [anon_sym_use] = ACTIONS(1300),
    [anon_sym_module] = ACTIONS(1300),
    [sym__dedent] = ACTIONS(1302),
    [sym_string_start] = ACTIONS(1302),
  },
  [352] = {
    [ts_builtin_sym_end] = ACTIONS(1304),
    [sym_identifier] = ACTIONS(1306),
    [anon_sym_import] = ACTIONS(1306),
    [anon_sym_from] = ACTIONS(1306),
    [anon_sym_LPAREN] = ACTIONS(1304),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_print] = ACTIONS(1306),
    [anon_sym_assert] = ACTIONS(1306),
    [anon_sym_return] = ACTIONS(1306),
    [anon_sym_del] = ACTIONS(1306),
    [anon_sym_raise] = ACTIONS(1306),
    [anon_sym_pass] = ACTIONS(1306),
    [anon_sym_break] = ACTIONS(1306),
    [anon_sym_continue] = ACTIONS(1306),
    [anon_sym_if] = ACTIONS(1306),
    [anon_sym_match] = ACTIONS(1306),
    [anon_sym_async] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1306),
    [anon_sym_while] = ACTIONS(1306),
    [anon_sym_try] = ACTIONS(1306),
    [anon_sym_with] = ACTIONS(1306),
    [anon_sym_def] = ACTIONS(1306),
    [anon_sym_global] = ACTIONS(1306),
    [anon_sym_nonlocal] = ACTIONS(1306),
    [anon_sym_exec] = ACTIONS(1306),
    [anon_sym_type] = ACTIONS(1306),
    [anon_sym_class] = ACTIONS(1306),
    [anon_sym_LBRACK] = ACTIONS(1304),
    [anon_sym_AT] = ACTIONS(1304),
    [anon_sym_DASH] = ACTIONS(1304),
    [anon_sym_LBRACE] = ACTIONS(1304),
    [anon_sym_PLUS] = ACTIONS(1304),
    [anon_sym_not] = ACTIONS(1306),
    [anon_sym_TILDE] = ACTIONS(1304),
    [anon_sym_lambda] = ACTIONS(1306),
    [anon_sym_yield] = ACTIONS(1306),
    [sym_ellipsis] = ACTIONS(1304),
    [sym_integer] = ACTIONS(1306),
    [sym_float] = ACTIONS(1304),
    [anon_sym_await] = ACTIONS(1306),
    [sym_true] = ACTIONS(1306),
    [sym_false] = ACTIONS(1306),
    [sym_none] = ACTIONS(1306),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1306),
    [anon_sym_container] = ACTIONS(1306),
    [anon_sym_envvars] = ACTIONS(1306),
    [anon_sym_include] = ACTIONS(1306),
    [anon_sym_pepfile] = ACTIONS(1306),
    [anon_sym_pepschema] = ACTIONS(1306),
    [anon_sym_scattergather] = ACTIONS(1306),
    [anon_sym_version] = ACTIONS(1306),
    [anon_sym_wildcard_constraints] = ACTIONS(1306),
    [anon_sym_workdir] = ACTIONS(1306),
    [anon_sym_onerror] = ACTIONS(1306),
    [anon_sym_onstart] = ACTIONS(1306),
    [anon_sym_onsuccess] = ACTIONS(1306),
    [anon_sym_localrules] = ACTIONS(1306),
    [anon_sym_ruleorder] = ACTIONS(1306),
    [anon_sym_rule] = ACTIONS(1306),
    [anon_sym_checkpoint] = ACTIONS(1306),
    [anon_sym_use] = ACTIONS(1306),
    [anon_sym_module] = ACTIONS(1306),
    [sym_string_start] = ACTIONS(1304),
  },
  [353] = {
    [ts_builtin_sym_end] = ACTIONS(1308),
    [sym_identifier] = ACTIONS(1310),
    [anon_sym_import] = ACTIONS(1310),
    [anon_sym_from] = ACTIONS(1310),
    [anon_sym_LPAREN] = ACTIONS(1308),
    [anon_sym_STAR] = ACTIONS(1308),
    [anon_sym_print] = ACTIONS(1310),
    [anon_sym_assert] = ACTIONS(1310),
    [anon_sym_return] = ACTIONS(1310),
    [anon_sym_del] = ACTIONS(1310),
    [anon_sym_raise] = ACTIONS(1310),
    [anon_sym_pass] = ACTIONS(1310),
    [anon_sym_break] = ACTIONS(1310),
    [anon_sym_continue] = ACTIONS(1310),
    [anon_sym_if] = ACTIONS(1310),
    [anon_sym_match] = ACTIONS(1310),
    [anon_sym_async] = ACTIONS(1310),
    [anon_sym_for] = ACTIONS(1310),
    [anon_sym_while] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(1310),
    [anon_sym_with] = ACTIONS(1310),
    [anon_sym_def] = ACTIONS(1310),
    [anon_sym_global] = ACTIONS(1310),
    [anon_sym_nonlocal] = ACTIONS(1310),
    [anon_sym_exec] = ACTIONS(1310),
    [anon_sym_type] = ACTIONS(1310),
    [anon_sym_class] = ACTIONS(1310),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [anon_sym_AT] = ACTIONS(1308),
    [anon_sym_DASH] = ACTIONS(1308),
    [anon_sym_LBRACE] = ACTIONS(1308),
    [anon_sym_PLUS] = ACTIONS(1308),
    [anon_sym_not] = ACTIONS(1310),
    [anon_sym_TILDE] = ACTIONS(1308),
    [anon_sym_lambda] = ACTIONS(1310),
    [anon_sym_yield] = ACTIONS(1310),
    [sym_ellipsis] = ACTIONS(1308),
    [sym_integer] = ACTIONS(1310),
    [sym_float] = ACTIONS(1308),
    [anon_sym_await] = ACTIONS(1310),
    [sym_true] = ACTIONS(1310),
    [sym_false] = ACTIONS(1310),
    [sym_none] = ACTIONS(1310),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1310),
    [anon_sym_container] = ACTIONS(1310),
    [anon_sym_envvars] = ACTIONS(1310),
    [anon_sym_include] = ACTIONS(1310),
    [anon_sym_pepfile] = ACTIONS(1310),
    [anon_sym_pepschema] = ACTIONS(1310),
    [anon_sym_scattergather] = ACTIONS(1310),
    [anon_sym_version] = ACTIONS(1310),
    [anon_sym_wildcard_constraints] = ACTIONS(1310),
    [anon_sym_workdir] = ACTIONS(1310),
    [anon_sym_onerror] = ACTIONS(1310),
    [anon_sym_onstart] = ACTIONS(1310),
    [anon_sym_onsuccess] = ACTIONS(1310),
    [anon_sym_localrules] = ACTIONS(1310),
    [anon_sym_ruleorder] = ACTIONS(1310),
    [anon_sym_rule] = ACTIONS(1310),
    [anon_sym_checkpoint] = ACTIONS(1310),
    [anon_sym_use] = ACTIONS(1310),
    [anon_sym_module] = ACTIONS(1310),
    [sym_string_start] = ACTIONS(1308),
  },
  [354] = {
    [ts_builtin_sym_end] = ACTIONS(1312),
    [sym_identifier] = ACTIONS(1314),
    [anon_sym_import] = ACTIONS(1314),
    [anon_sym_from] = ACTIONS(1314),
    [anon_sym_LPAREN] = ACTIONS(1312),
    [anon_sym_STAR] = ACTIONS(1312),
    [anon_sym_print] = ACTIONS(1314),
    [anon_sym_assert] = ACTIONS(1314),
    [anon_sym_return] = ACTIONS(1314),
    [anon_sym_del] = ACTIONS(1314),
    [anon_sym_raise] = ACTIONS(1314),
    [anon_sym_pass] = ACTIONS(1314),
    [anon_sym_break] = ACTIONS(1314),
    [anon_sym_continue] = ACTIONS(1314),
    [anon_sym_if] = ACTIONS(1314),
    [anon_sym_match] = ACTIONS(1314),
    [anon_sym_async] = ACTIONS(1314),
    [anon_sym_for] = ACTIONS(1314),
    [anon_sym_while] = ACTIONS(1314),
    [anon_sym_try] = ACTIONS(1314),
    [anon_sym_with] = ACTIONS(1314),
    [anon_sym_def] = ACTIONS(1314),
    [anon_sym_global] = ACTIONS(1314),
    [anon_sym_nonlocal] = ACTIONS(1314),
    [anon_sym_exec] = ACTIONS(1314),
    [anon_sym_type] = ACTIONS(1314),
    [anon_sym_class] = ACTIONS(1314),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_AT] = ACTIONS(1312),
    [anon_sym_DASH] = ACTIONS(1312),
    [anon_sym_LBRACE] = ACTIONS(1312),
    [anon_sym_PLUS] = ACTIONS(1312),
    [anon_sym_not] = ACTIONS(1314),
    [anon_sym_TILDE] = ACTIONS(1312),
    [anon_sym_lambda] = ACTIONS(1314),
    [anon_sym_yield] = ACTIONS(1314),
    [sym_ellipsis] = ACTIONS(1312),
    [sym_integer] = ACTIONS(1314),
    [sym_float] = ACTIONS(1312),
    [anon_sym_await] = ACTIONS(1314),
    [sym_true] = ACTIONS(1314),
    [sym_false] = ACTIONS(1314),
    [sym_none] = ACTIONS(1314),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1314),
    [anon_sym_container] = ACTIONS(1314),
    [anon_sym_envvars] = ACTIONS(1314),
    [anon_sym_include] = ACTIONS(1314),
    [anon_sym_pepfile] = ACTIONS(1314),
    [anon_sym_pepschema] = ACTIONS(1314),
    [anon_sym_scattergather] = ACTIONS(1314),
    [anon_sym_version] = ACTIONS(1314),
    [anon_sym_wildcard_constraints] = ACTIONS(1314),
    [anon_sym_workdir] = ACTIONS(1314),
    [anon_sym_onerror] = ACTIONS(1314),
    [anon_sym_onstart] = ACTIONS(1314),
    [anon_sym_onsuccess] = ACTIONS(1314),
    [anon_sym_localrules] = ACTIONS(1314),
    [anon_sym_ruleorder] = ACTIONS(1314),
    [anon_sym_rule] = ACTIONS(1314),
    [anon_sym_checkpoint] = ACTIONS(1314),
    [anon_sym_use] = ACTIONS(1314),
    [anon_sym_module] = ACTIONS(1314),
    [sym_string_start] = ACTIONS(1312),
  },
  [355] = {
    [ts_builtin_sym_end] = ACTIONS(1316),
    [sym_identifier] = ACTIONS(1318),
    [anon_sym_import] = ACTIONS(1318),
    [anon_sym_from] = ACTIONS(1318),
    [anon_sym_LPAREN] = ACTIONS(1316),
    [anon_sym_STAR] = ACTIONS(1316),
    [anon_sym_print] = ACTIONS(1318),
    [anon_sym_assert] = ACTIONS(1318),
    [anon_sym_return] = ACTIONS(1318),
    [anon_sym_del] = ACTIONS(1318),
    [anon_sym_raise] = ACTIONS(1318),
    [anon_sym_pass] = ACTIONS(1318),
    [anon_sym_break] = ACTIONS(1318),
    [anon_sym_continue] = ACTIONS(1318),
    [anon_sym_if] = ACTIONS(1318),
    [anon_sym_match] = ACTIONS(1318),
    [anon_sym_async] = ACTIONS(1318),
    [anon_sym_for] = ACTIONS(1318),
    [anon_sym_while] = ACTIONS(1318),
    [anon_sym_try] = ACTIONS(1318),
    [anon_sym_with] = ACTIONS(1318),
    [anon_sym_def] = ACTIONS(1318),
    [anon_sym_global] = ACTIONS(1318),
    [anon_sym_nonlocal] = ACTIONS(1318),
    [anon_sym_exec] = ACTIONS(1318),
    [anon_sym_type] = ACTIONS(1318),
    [anon_sym_class] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1316),
    [anon_sym_AT] = ACTIONS(1316),
    [anon_sym_DASH] = ACTIONS(1316),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_PLUS] = ACTIONS(1316),
    [anon_sym_not] = ACTIONS(1318),
    [anon_sym_TILDE] = ACTIONS(1316),
    [anon_sym_lambda] = ACTIONS(1318),
    [anon_sym_yield] = ACTIONS(1318),
    [sym_ellipsis] = ACTIONS(1316),
    [sym_integer] = ACTIONS(1318),
    [sym_float] = ACTIONS(1316),
    [anon_sym_await] = ACTIONS(1318),
    [sym_true] = ACTIONS(1318),
    [sym_false] = ACTIONS(1318),
    [sym_none] = ACTIONS(1318),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1318),
    [anon_sym_container] = ACTIONS(1318),
    [anon_sym_envvars] = ACTIONS(1318),
    [anon_sym_include] = ACTIONS(1318),
    [anon_sym_pepfile] = ACTIONS(1318),
    [anon_sym_pepschema] = ACTIONS(1318),
    [anon_sym_scattergather] = ACTIONS(1318),
    [anon_sym_version] = ACTIONS(1318),
    [anon_sym_wildcard_constraints] = ACTIONS(1318),
    [anon_sym_workdir] = ACTIONS(1318),
    [anon_sym_onerror] = ACTIONS(1318),
    [anon_sym_onstart] = ACTIONS(1318),
    [anon_sym_onsuccess] = ACTIONS(1318),
    [anon_sym_localrules] = ACTIONS(1318),
    [anon_sym_ruleorder] = ACTIONS(1318),
    [anon_sym_rule] = ACTIONS(1318),
    [anon_sym_checkpoint] = ACTIONS(1318),
    [anon_sym_use] = ACTIONS(1318),
    [anon_sym_module] = ACTIONS(1318),
    [sym_string_start] = ACTIONS(1316),
  },
  [356] = {
    [ts_builtin_sym_end] = ACTIONS(1320),
    [sym_identifier] = ACTIONS(1322),
    [anon_sym_import] = ACTIONS(1322),
    [anon_sym_from] = ACTIONS(1322),
    [anon_sym_LPAREN] = ACTIONS(1320),
    [anon_sym_STAR] = ACTIONS(1320),
    [anon_sym_print] = ACTIONS(1322),
    [anon_sym_assert] = ACTIONS(1322),
    [anon_sym_return] = ACTIONS(1322),
    [anon_sym_del] = ACTIONS(1322),
    [anon_sym_raise] = ACTIONS(1322),
    [anon_sym_pass] = ACTIONS(1322),
    [anon_sym_break] = ACTIONS(1322),
    [anon_sym_continue] = ACTIONS(1322),
    [anon_sym_if] = ACTIONS(1322),
    [anon_sym_match] = ACTIONS(1322),
    [anon_sym_async] = ACTIONS(1322),
    [anon_sym_for] = ACTIONS(1322),
    [anon_sym_while] = ACTIONS(1322),
    [anon_sym_try] = ACTIONS(1322),
    [anon_sym_with] = ACTIONS(1322),
    [anon_sym_def] = ACTIONS(1322),
    [anon_sym_global] = ACTIONS(1322),
    [anon_sym_nonlocal] = ACTIONS(1322),
    [anon_sym_exec] = ACTIONS(1322),
    [anon_sym_type] = ACTIONS(1322),
    [anon_sym_class] = ACTIONS(1322),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_AT] = ACTIONS(1320),
    [anon_sym_DASH] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1320),
    [anon_sym_PLUS] = ACTIONS(1320),
    [anon_sym_not] = ACTIONS(1322),
    [anon_sym_TILDE] = ACTIONS(1320),
    [anon_sym_lambda] = ACTIONS(1322),
    [anon_sym_yield] = ACTIONS(1322),
    [sym_ellipsis] = ACTIONS(1320),
    [sym_integer] = ACTIONS(1322),
    [sym_float] = ACTIONS(1320),
    [anon_sym_await] = ACTIONS(1322),
    [sym_true] = ACTIONS(1322),
    [sym_false] = ACTIONS(1322),
    [sym_none] = ACTIONS(1322),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1322),
    [anon_sym_container] = ACTIONS(1322),
    [anon_sym_envvars] = ACTIONS(1322),
    [anon_sym_include] = ACTIONS(1322),
    [anon_sym_pepfile] = ACTIONS(1322),
    [anon_sym_pepschema] = ACTIONS(1322),
    [anon_sym_scattergather] = ACTIONS(1322),
    [anon_sym_version] = ACTIONS(1322),
    [anon_sym_wildcard_constraints] = ACTIONS(1322),
    [anon_sym_workdir] = ACTIONS(1322),
    [anon_sym_onerror] = ACTIONS(1322),
    [anon_sym_onstart] = ACTIONS(1322),
    [anon_sym_onsuccess] = ACTIONS(1322),
    [anon_sym_localrules] = ACTIONS(1322),
    [anon_sym_ruleorder] = ACTIONS(1322),
    [anon_sym_rule] = ACTIONS(1322),
    [anon_sym_checkpoint] = ACTIONS(1322),
    [anon_sym_use] = ACTIONS(1322),
    [anon_sym_module] = ACTIONS(1322),
    [sym_string_start] = ACTIONS(1320),
  },
  [357] = {
    [ts_builtin_sym_end] = ACTIONS(1324),
    [sym_identifier] = ACTIONS(1326),
    [anon_sym_import] = ACTIONS(1326),
    [anon_sym_from] = ACTIONS(1326),
    [anon_sym_LPAREN] = ACTIONS(1324),
    [anon_sym_STAR] = ACTIONS(1324),
    [anon_sym_print] = ACTIONS(1326),
    [anon_sym_assert] = ACTIONS(1326),
    [anon_sym_return] = ACTIONS(1326),
    [anon_sym_del] = ACTIONS(1326),
    [anon_sym_raise] = ACTIONS(1326),
    [anon_sym_pass] = ACTIONS(1326),
    [anon_sym_break] = ACTIONS(1326),
    [anon_sym_continue] = ACTIONS(1326),
    [anon_sym_if] = ACTIONS(1326),
    [anon_sym_match] = ACTIONS(1326),
    [anon_sym_async] = ACTIONS(1326),
    [anon_sym_for] = ACTIONS(1326),
    [anon_sym_while] = ACTIONS(1326),
    [anon_sym_try] = ACTIONS(1326),
    [anon_sym_with] = ACTIONS(1326),
    [anon_sym_def] = ACTIONS(1326),
    [anon_sym_global] = ACTIONS(1326),
    [anon_sym_nonlocal] = ACTIONS(1326),
    [anon_sym_exec] = ACTIONS(1326),
    [anon_sym_type] = ACTIONS(1326),
    [anon_sym_class] = ACTIONS(1326),
    [anon_sym_LBRACK] = ACTIONS(1324),
    [anon_sym_AT] = ACTIONS(1324),
    [anon_sym_DASH] = ACTIONS(1324),
    [anon_sym_LBRACE] = ACTIONS(1324),
    [anon_sym_PLUS] = ACTIONS(1324),
    [anon_sym_not] = ACTIONS(1326),
    [anon_sym_TILDE] = ACTIONS(1324),
    [anon_sym_lambda] = ACTIONS(1326),
    [anon_sym_yield] = ACTIONS(1326),
    [sym_ellipsis] = ACTIONS(1324),
    [sym_integer] = ACTIONS(1326),
    [sym_float] = ACTIONS(1324),
    [anon_sym_await] = ACTIONS(1326),
    [sym_true] = ACTIONS(1326),
    [sym_false] = ACTIONS(1326),
    [sym_none] = ACTIONS(1326),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1326),
    [anon_sym_container] = ACTIONS(1326),
    [anon_sym_envvars] = ACTIONS(1326),
    [anon_sym_include] = ACTIONS(1326),
    [anon_sym_pepfile] = ACTIONS(1326),
    [anon_sym_pepschema] = ACTIONS(1326),
    [anon_sym_scattergather] = ACTIONS(1326),
    [anon_sym_version] = ACTIONS(1326),
    [anon_sym_wildcard_constraints] = ACTIONS(1326),
    [anon_sym_workdir] = ACTIONS(1326),
    [anon_sym_onerror] = ACTIONS(1326),
    [anon_sym_onstart] = ACTIONS(1326),
    [anon_sym_onsuccess] = ACTIONS(1326),
    [anon_sym_localrules] = ACTIONS(1326),
    [anon_sym_ruleorder] = ACTIONS(1326),
    [anon_sym_rule] = ACTIONS(1326),
    [anon_sym_checkpoint] = ACTIONS(1326),
    [anon_sym_use] = ACTIONS(1326),
    [anon_sym_module] = ACTIONS(1326),
    [sym_string_start] = ACTIONS(1324),
  },
  [358] = {
    [ts_builtin_sym_end] = ACTIONS(1328),
    [sym_identifier] = ACTIONS(1330),
    [anon_sym_import] = ACTIONS(1330),
    [anon_sym_from] = ACTIONS(1330),
    [anon_sym_LPAREN] = ACTIONS(1328),
    [anon_sym_STAR] = ACTIONS(1328),
    [anon_sym_print] = ACTIONS(1330),
    [anon_sym_assert] = ACTIONS(1330),
    [anon_sym_return] = ACTIONS(1330),
    [anon_sym_del] = ACTIONS(1330),
    [anon_sym_raise] = ACTIONS(1330),
    [anon_sym_pass] = ACTIONS(1330),
    [anon_sym_break] = ACTIONS(1330),
    [anon_sym_continue] = ACTIONS(1330),
    [anon_sym_if] = ACTIONS(1330),
    [anon_sym_match] = ACTIONS(1330),
    [anon_sym_async] = ACTIONS(1330),
    [anon_sym_for] = ACTIONS(1330),
    [anon_sym_while] = ACTIONS(1330),
    [anon_sym_try] = ACTIONS(1330),
    [anon_sym_with] = ACTIONS(1330),
    [anon_sym_def] = ACTIONS(1330),
    [anon_sym_global] = ACTIONS(1330),
    [anon_sym_nonlocal] = ACTIONS(1330),
    [anon_sym_exec] = ACTIONS(1330),
    [anon_sym_type] = ACTIONS(1330),
    [anon_sym_class] = ACTIONS(1330),
    [anon_sym_LBRACK] = ACTIONS(1328),
    [anon_sym_AT] = ACTIONS(1328),
    [anon_sym_DASH] = ACTIONS(1328),
    [anon_sym_LBRACE] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1328),
    [anon_sym_not] = ACTIONS(1330),
    [anon_sym_TILDE] = ACTIONS(1328),
    [anon_sym_lambda] = ACTIONS(1330),
    [anon_sym_yield] = ACTIONS(1330),
    [sym_ellipsis] = ACTIONS(1328),
    [sym_integer] = ACTIONS(1330),
    [sym_float] = ACTIONS(1328),
    [anon_sym_await] = ACTIONS(1330),
    [sym_true] = ACTIONS(1330),
    [sym_false] = ACTIONS(1330),
    [sym_none] = ACTIONS(1330),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1330),
    [anon_sym_container] = ACTIONS(1330),
    [anon_sym_envvars] = ACTIONS(1330),
    [anon_sym_include] = ACTIONS(1330),
    [anon_sym_pepfile] = ACTIONS(1330),
    [anon_sym_pepschema] = ACTIONS(1330),
    [anon_sym_scattergather] = ACTIONS(1330),
    [anon_sym_version] = ACTIONS(1330),
    [anon_sym_wildcard_constraints] = ACTIONS(1330),
    [anon_sym_workdir] = ACTIONS(1330),
    [anon_sym_onerror] = ACTIONS(1330),
    [anon_sym_onstart] = ACTIONS(1330),
    [anon_sym_onsuccess] = ACTIONS(1330),
    [anon_sym_localrules] = ACTIONS(1330),
    [anon_sym_ruleorder] = ACTIONS(1330),
    [anon_sym_rule] = ACTIONS(1330),
    [anon_sym_checkpoint] = ACTIONS(1330),
    [anon_sym_use] = ACTIONS(1330),
    [anon_sym_module] = ACTIONS(1330),
    [sym_string_start] = ACTIONS(1328),
  },
  [359] = {
    [sym_identifier] = ACTIONS(1332),
    [anon_sym_import] = ACTIONS(1332),
    [anon_sym_from] = ACTIONS(1332),
    [anon_sym_LPAREN] = ACTIONS(1334),
    [anon_sym_STAR] = ACTIONS(1334),
    [anon_sym_print] = ACTIONS(1332),
    [anon_sym_assert] = ACTIONS(1332),
    [anon_sym_return] = ACTIONS(1332),
    [anon_sym_del] = ACTIONS(1332),
    [anon_sym_raise] = ACTIONS(1332),
    [anon_sym_pass] = ACTIONS(1332),
    [anon_sym_break] = ACTIONS(1332),
    [anon_sym_continue] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(1332),
    [anon_sym_match] = ACTIONS(1332),
    [anon_sym_async] = ACTIONS(1332),
    [anon_sym_for] = ACTIONS(1332),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_try] = ACTIONS(1332),
    [anon_sym_with] = ACTIONS(1332),
    [anon_sym_def] = ACTIONS(1332),
    [anon_sym_global] = ACTIONS(1332),
    [anon_sym_nonlocal] = ACTIONS(1332),
    [anon_sym_exec] = ACTIONS(1332),
    [anon_sym_type] = ACTIONS(1332),
    [anon_sym_class] = ACTIONS(1332),
    [anon_sym_LBRACK] = ACTIONS(1334),
    [anon_sym_AT] = ACTIONS(1334),
    [anon_sym_DASH] = ACTIONS(1334),
    [anon_sym_LBRACE] = ACTIONS(1334),
    [anon_sym_PLUS] = ACTIONS(1334),
    [anon_sym_not] = ACTIONS(1332),
    [anon_sym_TILDE] = ACTIONS(1334),
    [anon_sym_lambda] = ACTIONS(1332),
    [anon_sym_yield] = ACTIONS(1332),
    [sym_ellipsis] = ACTIONS(1334),
    [sym_integer] = ACTIONS(1332),
    [sym_float] = ACTIONS(1334),
    [anon_sym_await] = ACTIONS(1332),
    [sym_true] = ACTIONS(1332),
    [sym_false] = ACTIONS(1332),
    [sym_none] = ACTIONS(1332),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1332),
    [anon_sym_container] = ACTIONS(1332),
    [anon_sym_envvars] = ACTIONS(1332),
    [anon_sym_include] = ACTIONS(1332),
    [anon_sym_pepfile] = ACTIONS(1332),
    [anon_sym_pepschema] = ACTIONS(1332),
    [anon_sym_scattergather] = ACTIONS(1332),
    [anon_sym_version] = ACTIONS(1332),
    [anon_sym_wildcard_constraints] = ACTIONS(1332),
    [anon_sym_workdir] = ACTIONS(1332),
    [anon_sym_onerror] = ACTIONS(1332),
    [anon_sym_onstart] = ACTIONS(1332),
    [anon_sym_onsuccess] = ACTIONS(1332),
    [anon_sym_localrules] = ACTIONS(1332),
    [anon_sym_ruleorder] = ACTIONS(1332),
    [anon_sym_rule] = ACTIONS(1332),
    [anon_sym_checkpoint] = ACTIONS(1332),
    [anon_sym_use] = ACTIONS(1332),
    [anon_sym_module] = ACTIONS(1332),
    [sym__dedent] = ACTIONS(1334),
    [sym_string_start] = ACTIONS(1334),
  },
  [360] = {
    [ts_builtin_sym_end] = ACTIONS(1336),
    [sym_identifier] = ACTIONS(1338),
    [anon_sym_import] = ACTIONS(1338),
    [anon_sym_from] = ACTIONS(1338),
    [anon_sym_LPAREN] = ACTIONS(1336),
    [anon_sym_STAR] = ACTIONS(1336),
    [anon_sym_print] = ACTIONS(1338),
    [anon_sym_assert] = ACTIONS(1338),
    [anon_sym_return] = ACTIONS(1338),
    [anon_sym_del] = ACTIONS(1338),
    [anon_sym_raise] = ACTIONS(1338),
    [anon_sym_pass] = ACTIONS(1338),
    [anon_sym_break] = ACTIONS(1338),
    [anon_sym_continue] = ACTIONS(1338),
    [anon_sym_if] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1338),
    [anon_sym_async] = ACTIONS(1338),
    [anon_sym_for] = ACTIONS(1338),
    [anon_sym_while] = ACTIONS(1338),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_with] = ACTIONS(1338),
    [anon_sym_def] = ACTIONS(1338),
    [anon_sym_global] = ACTIONS(1338),
    [anon_sym_nonlocal] = ACTIONS(1338),
    [anon_sym_exec] = ACTIONS(1338),
    [anon_sym_type] = ACTIONS(1338),
    [anon_sym_class] = ACTIONS(1338),
    [anon_sym_LBRACK] = ACTIONS(1336),
    [anon_sym_AT] = ACTIONS(1336),
    [anon_sym_DASH] = ACTIONS(1336),
    [anon_sym_LBRACE] = ACTIONS(1336),
    [anon_sym_PLUS] = ACTIONS(1336),
    [anon_sym_not] = ACTIONS(1338),
    [anon_sym_TILDE] = ACTIONS(1336),
    [anon_sym_lambda] = ACTIONS(1338),
    [anon_sym_yield] = ACTIONS(1338),
    [sym_ellipsis] = ACTIONS(1336),
    [sym_integer] = ACTIONS(1338),
    [sym_float] = ACTIONS(1336),
    [anon_sym_await] = ACTIONS(1338),
    [sym_true] = ACTIONS(1338),
    [sym_false] = ACTIONS(1338),
    [sym_none] = ACTIONS(1338),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1338),
    [anon_sym_container] = ACTIONS(1338),
    [anon_sym_envvars] = ACTIONS(1338),
    [anon_sym_include] = ACTIONS(1338),
    [anon_sym_pepfile] = ACTIONS(1338),
    [anon_sym_pepschema] = ACTIONS(1338),
    [anon_sym_scattergather] = ACTIONS(1338),
    [anon_sym_version] = ACTIONS(1338),
    [anon_sym_wildcard_constraints] = ACTIONS(1338),
    [anon_sym_workdir] = ACTIONS(1338),
    [anon_sym_onerror] = ACTIONS(1338),
    [anon_sym_onstart] = ACTIONS(1338),
    [anon_sym_onsuccess] = ACTIONS(1338),
    [anon_sym_localrules] = ACTIONS(1338),
    [anon_sym_ruleorder] = ACTIONS(1338),
    [anon_sym_rule] = ACTIONS(1338),
    [anon_sym_checkpoint] = ACTIONS(1338),
    [anon_sym_use] = ACTIONS(1338),
    [anon_sym_module] = ACTIONS(1338),
    [sym_string_start] = ACTIONS(1336),
  },
  [361] = {
    [sym_identifier] = ACTIONS(1340),
    [anon_sym_import] = ACTIONS(1340),
    [anon_sym_from] = ACTIONS(1340),
    [anon_sym_LPAREN] = ACTIONS(1342),
    [anon_sym_STAR] = ACTIONS(1342),
    [anon_sym_print] = ACTIONS(1340),
    [anon_sym_assert] = ACTIONS(1340),
    [anon_sym_return] = ACTIONS(1340),
    [anon_sym_del] = ACTIONS(1340),
    [anon_sym_raise] = ACTIONS(1340),
    [anon_sym_pass] = ACTIONS(1340),
    [anon_sym_break] = ACTIONS(1340),
    [anon_sym_continue] = ACTIONS(1340),
    [anon_sym_if] = ACTIONS(1340),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_async] = ACTIONS(1340),
    [anon_sym_for] = ACTIONS(1340),
    [anon_sym_while] = ACTIONS(1340),
    [anon_sym_try] = ACTIONS(1340),
    [anon_sym_with] = ACTIONS(1340),
    [anon_sym_def] = ACTIONS(1340),
    [anon_sym_global] = ACTIONS(1340),
    [anon_sym_nonlocal] = ACTIONS(1340),
    [anon_sym_exec] = ACTIONS(1340),
    [anon_sym_type] = ACTIONS(1340),
    [anon_sym_class] = ACTIONS(1340),
    [anon_sym_LBRACK] = ACTIONS(1342),
    [anon_sym_AT] = ACTIONS(1342),
    [anon_sym_DASH] = ACTIONS(1342),
    [anon_sym_LBRACE] = ACTIONS(1342),
    [anon_sym_PLUS] = ACTIONS(1342),
    [anon_sym_not] = ACTIONS(1340),
    [anon_sym_TILDE] = ACTIONS(1342),
    [anon_sym_lambda] = ACTIONS(1340),
    [anon_sym_yield] = ACTIONS(1340),
    [sym_ellipsis] = ACTIONS(1342),
    [sym_integer] = ACTIONS(1340),
    [sym_float] = ACTIONS(1342),
    [anon_sym_await] = ACTIONS(1340),
    [sym_true] = ACTIONS(1340),
    [sym_false] = ACTIONS(1340),
    [sym_none] = ACTIONS(1340),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1340),
    [anon_sym_container] = ACTIONS(1340),
    [anon_sym_envvars] = ACTIONS(1340),
    [anon_sym_include] = ACTIONS(1340),
    [anon_sym_pepfile] = ACTIONS(1340),
    [anon_sym_pepschema] = ACTIONS(1340),
    [anon_sym_scattergather] = ACTIONS(1340),
    [anon_sym_version] = ACTIONS(1340),
    [anon_sym_wildcard_constraints] = ACTIONS(1340),
    [anon_sym_workdir] = ACTIONS(1340),
    [anon_sym_onerror] = ACTIONS(1340),
    [anon_sym_onstart] = ACTIONS(1340),
    [anon_sym_onsuccess] = ACTIONS(1340),
    [anon_sym_localrules] = ACTIONS(1340),
    [anon_sym_ruleorder] = ACTIONS(1340),
    [anon_sym_rule] = ACTIONS(1340),
    [anon_sym_checkpoint] = ACTIONS(1340),
    [anon_sym_use] = ACTIONS(1340),
    [anon_sym_module] = ACTIONS(1340),
    [sym__dedent] = ACTIONS(1342),
    [sym_string_start] = ACTIONS(1342),
  },
  [362] = {
    [ts_builtin_sym_end] = ACTIONS(1344),
    [sym_identifier] = ACTIONS(1346),
    [anon_sym_import] = ACTIONS(1346),
    [anon_sym_from] = ACTIONS(1346),
    [anon_sym_LPAREN] = ACTIONS(1344),
    [anon_sym_STAR] = ACTIONS(1344),
    [anon_sym_print] = ACTIONS(1346),
    [anon_sym_assert] = ACTIONS(1346),
    [anon_sym_return] = ACTIONS(1346),
    [anon_sym_del] = ACTIONS(1346),
    [anon_sym_raise] = ACTIONS(1346),
    [anon_sym_pass] = ACTIONS(1346),
    [anon_sym_break] = ACTIONS(1346),
    [anon_sym_continue] = ACTIONS(1346),
    [anon_sym_if] = ACTIONS(1346),
    [anon_sym_match] = ACTIONS(1346),
    [anon_sym_async] = ACTIONS(1346),
    [anon_sym_for] = ACTIONS(1346),
    [anon_sym_while] = ACTIONS(1346),
    [anon_sym_try] = ACTIONS(1346),
    [anon_sym_with] = ACTIONS(1346),
    [anon_sym_def] = ACTIONS(1346),
    [anon_sym_global] = ACTIONS(1346),
    [anon_sym_nonlocal] = ACTIONS(1346),
    [anon_sym_exec] = ACTIONS(1346),
    [anon_sym_type] = ACTIONS(1346),
    [anon_sym_class] = ACTIONS(1346),
    [anon_sym_LBRACK] = ACTIONS(1344),
    [anon_sym_AT] = ACTIONS(1344),
    [anon_sym_DASH] = ACTIONS(1344),
    [anon_sym_LBRACE] = ACTIONS(1344),
    [anon_sym_PLUS] = ACTIONS(1344),
    [anon_sym_not] = ACTIONS(1346),
    [anon_sym_TILDE] = ACTIONS(1344),
    [anon_sym_lambda] = ACTIONS(1346),
    [anon_sym_yield] = ACTIONS(1346),
    [sym_ellipsis] = ACTIONS(1344),
    [sym_integer] = ACTIONS(1346),
    [sym_float] = ACTIONS(1344),
    [anon_sym_await] = ACTIONS(1346),
    [sym_true] = ACTIONS(1346),
    [sym_false] = ACTIONS(1346),
    [sym_none] = ACTIONS(1346),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1346),
    [anon_sym_container] = ACTIONS(1346),
    [anon_sym_envvars] = ACTIONS(1346),
    [anon_sym_include] = ACTIONS(1346),
    [anon_sym_pepfile] = ACTIONS(1346),
    [anon_sym_pepschema] = ACTIONS(1346),
    [anon_sym_scattergather] = ACTIONS(1346),
    [anon_sym_version] = ACTIONS(1346),
    [anon_sym_wildcard_constraints] = ACTIONS(1346),
    [anon_sym_workdir] = ACTIONS(1346),
    [anon_sym_onerror] = ACTIONS(1346),
    [anon_sym_onstart] = ACTIONS(1346),
    [anon_sym_onsuccess] = ACTIONS(1346),
    [anon_sym_localrules] = ACTIONS(1346),
    [anon_sym_ruleorder] = ACTIONS(1346),
    [anon_sym_rule] = ACTIONS(1346),
    [anon_sym_checkpoint] = ACTIONS(1346),
    [anon_sym_use] = ACTIONS(1346),
    [anon_sym_module] = ACTIONS(1346),
    [sym_string_start] = ACTIONS(1344),
  },
  [363] = {
    [ts_builtin_sym_end] = ACTIONS(1348),
    [sym_identifier] = ACTIONS(1350),
    [anon_sym_import] = ACTIONS(1350),
    [anon_sym_from] = ACTIONS(1350),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_STAR] = ACTIONS(1348),
    [anon_sym_print] = ACTIONS(1350),
    [anon_sym_assert] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_del] = ACTIONS(1350),
    [anon_sym_raise] = ACTIONS(1350),
    [anon_sym_pass] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_match] = ACTIONS(1350),
    [anon_sym_async] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_try] = ACTIONS(1350),
    [anon_sym_with] = ACTIONS(1350),
    [anon_sym_def] = ACTIONS(1350),
    [anon_sym_global] = ACTIONS(1350),
    [anon_sym_nonlocal] = ACTIONS(1350),
    [anon_sym_exec] = ACTIONS(1350),
    [anon_sym_type] = ACTIONS(1350),
    [anon_sym_class] = ACTIONS(1350),
    [anon_sym_LBRACK] = ACTIONS(1348),
    [anon_sym_AT] = ACTIONS(1348),
    [anon_sym_DASH] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(1348),
    [anon_sym_PLUS] = ACTIONS(1348),
    [anon_sym_not] = ACTIONS(1350),
    [anon_sym_TILDE] = ACTIONS(1348),
    [anon_sym_lambda] = ACTIONS(1350),
    [anon_sym_yield] = ACTIONS(1350),
    [sym_ellipsis] = ACTIONS(1348),
    [sym_integer] = ACTIONS(1350),
    [sym_float] = ACTIONS(1348),
    [anon_sym_await] = ACTIONS(1350),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [sym_none] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1350),
    [anon_sym_container] = ACTIONS(1350),
    [anon_sym_envvars] = ACTIONS(1350),
    [anon_sym_include] = ACTIONS(1350),
    [anon_sym_pepfile] = ACTIONS(1350),
    [anon_sym_pepschema] = ACTIONS(1350),
    [anon_sym_scattergather] = ACTIONS(1350),
    [anon_sym_version] = ACTIONS(1350),
    [anon_sym_wildcard_constraints] = ACTIONS(1350),
    [anon_sym_workdir] = ACTIONS(1350),
    [anon_sym_onerror] = ACTIONS(1350),
    [anon_sym_onstart] = ACTIONS(1350),
    [anon_sym_onsuccess] = ACTIONS(1350),
    [anon_sym_localrules] = ACTIONS(1350),
    [anon_sym_ruleorder] = ACTIONS(1350),
    [anon_sym_rule] = ACTIONS(1350),
    [anon_sym_checkpoint] = ACTIONS(1350),
    [anon_sym_use] = ACTIONS(1350),
    [anon_sym_module] = ACTIONS(1350),
    [sym_string_start] = ACTIONS(1348),
  },
  [364] = {
    [sym_identifier] = ACTIONS(1352),
    [anon_sym_import] = ACTIONS(1352),
    [anon_sym_from] = ACTIONS(1352),
    [anon_sym_LPAREN] = ACTIONS(1354),
    [anon_sym_STAR] = ACTIONS(1354),
    [anon_sym_print] = ACTIONS(1352),
    [anon_sym_assert] = ACTIONS(1352),
    [anon_sym_return] = ACTIONS(1352),
    [anon_sym_del] = ACTIONS(1352),
    [anon_sym_raise] = ACTIONS(1352),
    [anon_sym_pass] = ACTIONS(1352),
    [anon_sym_break] = ACTIONS(1352),
    [anon_sym_continue] = ACTIONS(1352),
    [anon_sym_if] = ACTIONS(1352),
    [anon_sym_match] = ACTIONS(1352),
    [anon_sym_async] = ACTIONS(1352),
    [anon_sym_for] = ACTIONS(1352),
    [anon_sym_while] = ACTIONS(1352),
    [anon_sym_try] = ACTIONS(1352),
    [anon_sym_with] = ACTIONS(1352),
    [anon_sym_def] = ACTIONS(1352),
    [anon_sym_global] = ACTIONS(1352),
    [anon_sym_nonlocal] = ACTIONS(1352),
    [anon_sym_exec] = ACTIONS(1352),
    [anon_sym_type] = ACTIONS(1352),
    [anon_sym_class] = ACTIONS(1352),
    [anon_sym_LBRACK] = ACTIONS(1354),
    [anon_sym_AT] = ACTIONS(1354),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_LBRACE] = ACTIONS(1354),
    [anon_sym_PLUS] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1354),
    [anon_sym_lambda] = ACTIONS(1352),
    [anon_sym_yield] = ACTIONS(1352),
    [sym_ellipsis] = ACTIONS(1354),
    [sym_integer] = ACTIONS(1352),
    [sym_float] = ACTIONS(1354),
    [anon_sym_await] = ACTIONS(1352),
    [sym_true] = ACTIONS(1352),
    [sym_false] = ACTIONS(1352),
    [sym_none] = ACTIONS(1352),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1352),
    [anon_sym_container] = ACTIONS(1352),
    [anon_sym_envvars] = ACTIONS(1352),
    [anon_sym_include] = ACTIONS(1352),
    [anon_sym_pepfile] = ACTIONS(1352),
    [anon_sym_pepschema] = ACTIONS(1352),
    [anon_sym_scattergather] = ACTIONS(1352),
    [anon_sym_version] = ACTIONS(1352),
    [anon_sym_wildcard_constraints] = ACTIONS(1352),
    [anon_sym_workdir] = ACTIONS(1352),
    [anon_sym_onerror] = ACTIONS(1352),
    [anon_sym_onstart] = ACTIONS(1352),
    [anon_sym_onsuccess] = ACTIONS(1352),
    [anon_sym_localrules] = ACTIONS(1352),
    [anon_sym_ruleorder] = ACTIONS(1352),
    [anon_sym_rule] = ACTIONS(1352),
    [anon_sym_checkpoint] = ACTIONS(1352),
    [anon_sym_use] = ACTIONS(1352),
    [anon_sym_module] = ACTIONS(1352),
    [sym__dedent] = ACTIONS(1354),
    [sym_string_start] = ACTIONS(1354),
  },
  [365] = {
    [ts_builtin_sym_end] = ACTIONS(1356),
    [sym_identifier] = ACTIONS(1358),
    [anon_sym_import] = ACTIONS(1358),
    [anon_sym_from] = ACTIONS(1358),
    [anon_sym_LPAREN] = ACTIONS(1356),
    [anon_sym_STAR] = ACTIONS(1356),
    [anon_sym_print] = ACTIONS(1358),
    [anon_sym_assert] = ACTIONS(1358),
    [anon_sym_return] = ACTIONS(1358),
    [anon_sym_del] = ACTIONS(1358),
    [anon_sym_raise] = ACTIONS(1358),
    [anon_sym_pass] = ACTIONS(1358),
    [anon_sym_break] = ACTIONS(1358),
    [anon_sym_continue] = ACTIONS(1358),
    [anon_sym_if] = ACTIONS(1358),
    [anon_sym_match] = ACTIONS(1358),
    [anon_sym_async] = ACTIONS(1358),
    [anon_sym_for] = ACTIONS(1358),
    [anon_sym_while] = ACTIONS(1358),
    [anon_sym_try] = ACTIONS(1358),
    [anon_sym_with] = ACTIONS(1358),
    [anon_sym_def] = ACTIONS(1358),
    [anon_sym_global] = ACTIONS(1358),
    [anon_sym_nonlocal] = ACTIONS(1358),
    [anon_sym_exec] = ACTIONS(1358),
    [anon_sym_type] = ACTIONS(1358),
    [anon_sym_class] = ACTIONS(1358),
    [anon_sym_LBRACK] = ACTIONS(1356),
    [anon_sym_AT] = ACTIONS(1356),
    [anon_sym_DASH] = ACTIONS(1356),
    [anon_sym_LBRACE] = ACTIONS(1356),
    [anon_sym_PLUS] = ACTIONS(1356),
    [anon_sym_not] = ACTIONS(1358),
    [anon_sym_TILDE] = ACTIONS(1356),
    [anon_sym_lambda] = ACTIONS(1358),
    [anon_sym_yield] = ACTIONS(1358),
    [sym_ellipsis] = ACTIONS(1356),
    [sym_integer] = ACTIONS(1358),
    [sym_float] = ACTIONS(1356),
    [anon_sym_await] = ACTIONS(1358),
    [sym_true] = ACTIONS(1358),
    [sym_false] = ACTIONS(1358),
    [sym_none] = ACTIONS(1358),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1358),
    [anon_sym_container] = ACTIONS(1358),
    [anon_sym_envvars] = ACTIONS(1358),
    [anon_sym_include] = ACTIONS(1358),
    [anon_sym_pepfile] = ACTIONS(1358),
    [anon_sym_pepschema] = ACTIONS(1358),
    [anon_sym_scattergather] = ACTIONS(1358),
    [anon_sym_version] = ACTIONS(1358),
    [anon_sym_wildcard_constraints] = ACTIONS(1358),
    [anon_sym_workdir] = ACTIONS(1358),
    [anon_sym_onerror] = ACTIONS(1358),
    [anon_sym_onstart] = ACTIONS(1358),
    [anon_sym_onsuccess] = ACTIONS(1358),
    [anon_sym_localrules] = ACTIONS(1358),
    [anon_sym_ruleorder] = ACTIONS(1358),
    [anon_sym_rule] = ACTIONS(1358),
    [anon_sym_checkpoint] = ACTIONS(1358),
    [anon_sym_use] = ACTIONS(1358),
    [anon_sym_module] = ACTIONS(1358),
    [sym_string_start] = ACTIONS(1356),
  },
  [366] = {
    [sym_identifier] = ACTIONS(1360),
    [anon_sym_import] = ACTIONS(1360),
    [anon_sym_from] = ACTIONS(1360),
    [anon_sym_LPAREN] = ACTIONS(1362),
    [anon_sym_STAR] = ACTIONS(1362),
    [anon_sym_print] = ACTIONS(1360),
    [anon_sym_assert] = ACTIONS(1360),
    [anon_sym_return] = ACTIONS(1360),
    [anon_sym_del] = ACTIONS(1360),
    [anon_sym_raise] = ACTIONS(1360),
    [anon_sym_pass] = ACTIONS(1360),
    [anon_sym_break] = ACTIONS(1360),
    [anon_sym_continue] = ACTIONS(1360),
    [anon_sym_if] = ACTIONS(1360),
    [anon_sym_match] = ACTIONS(1360),
    [anon_sym_async] = ACTIONS(1360),
    [anon_sym_for] = ACTIONS(1360),
    [anon_sym_while] = ACTIONS(1360),
    [anon_sym_try] = ACTIONS(1360),
    [anon_sym_with] = ACTIONS(1360),
    [anon_sym_def] = ACTIONS(1360),
    [anon_sym_global] = ACTIONS(1360),
    [anon_sym_nonlocal] = ACTIONS(1360),
    [anon_sym_exec] = ACTIONS(1360),
    [anon_sym_type] = ACTIONS(1360),
    [anon_sym_class] = ACTIONS(1360),
    [anon_sym_LBRACK] = ACTIONS(1362),
    [anon_sym_AT] = ACTIONS(1362),
    [anon_sym_DASH] = ACTIONS(1362),
    [anon_sym_LBRACE] = ACTIONS(1362),
    [anon_sym_PLUS] = ACTIONS(1362),
    [anon_sym_not] = ACTIONS(1360),
    [anon_sym_TILDE] = ACTIONS(1362),
    [anon_sym_lambda] = ACTIONS(1360),
    [anon_sym_yield] = ACTIONS(1360),
    [sym_ellipsis] = ACTIONS(1362),
    [sym_integer] = ACTIONS(1360),
    [sym_float] = ACTIONS(1362),
    [anon_sym_await] = ACTIONS(1360),
    [sym_true] = ACTIONS(1360),
    [sym_false] = ACTIONS(1360),
    [sym_none] = ACTIONS(1360),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1360),
    [anon_sym_container] = ACTIONS(1360),
    [anon_sym_envvars] = ACTIONS(1360),
    [anon_sym_include] = ACTIONS(1360),
    [anon_sym_pepfile] = ACTIONS(1360),
    [anon_sym_pepschema] = ACTIONS(1360),
    [anon_sym_scattergather] = ACTIONS(1360),
    [anon_sym_version] = ACTIONS(1360),
    [anon_sym_wildcard_constraints] = ACTIONS(1360),
    [anon_sym_workdir] = ACTIONS(1360),
    [anon_sym_onerror] = ACTIONS(1360),
    [anon_sym_onstart] = ACTIONS(1360),
    [anon_sym_onsuccess] = ACTIONS(1360),
    [anon_sym_localrules] = ACTIONS(1360),
    [anon_sym_ruleorder] = ACTIONS(1360),
    [anon_sym_rule] = ACTIONS(1360),
    [anon_sym_checkpoint] = ACTIONS(1360),
    [anon_sym_use] = ACTIONS(1360),
    [anon_sym_module] = ACTIONS(1360),
    [sym__dedent] = ACTIONS(1362),
    [sym_string_start] = ACTIONS(1362),
  },
  [367] = {
    [ts_builtin_sym_end] = ACTIONS(1364),
    [sym_identifier] = ACTIONS(1366),
    [anon_sym_import] = ACTIONS(1366),
    [anon_sym_from] = ACTIONS(1366),
    [anon_sym_LPAREN] = ACTIONS(1364),
    [anon_sym_STAR] = ACTIONS(1364),
    [anon_sym_print] = ACTIONS(1366),
    [anon_sym_assert] = ACTIONS(1366),
    [anon_sym_return] = ACTIONS(1366),
    [anon_sym_del] = ACTIONS(1366),
    [anon_sym_raise] = ACTIONS(1366),
    [anon_sym_pass] = ACTIONS(1366),
    [anon_sym_break] = ACTIONS(1366),
    [anon_sym_continue] = ACTIONS(1366),
    [anon_sym_if] = ACTIONS(1366),
    [anon_sym_match] = ACTIONS(1366),
    [anon_sym_async] = ACTIONS(1366),
    [anon_sym_for] = ACTIONS(1366),
    [anon_sym_while] = ACTIONS(1366),
    [anon_sym_try] = ACTIONS(1366),
    [anon_sym_with] = ACTIONS(1368),
    [anon_sym_def] = ACTIONS(1366),
    [anon_sym_global] = ACTIONS(1366),
    [anon_sym_nonlocal] = ACTIONS(1366),
    [anon_sym_exec] = ACTIONS(1366),
    [anon_sym_type] = ACTIONS(1366),
    [anon_sym_class] = ACTIONS(1366),
    [anon_sym_LBRACK] = ACTIONS(1364),
    [anon_sym_AT] = ACTIONS(1364),
    [anon_sym_DASH] = ACTIONS(1364),
    [anon_sym_LBRACE] = ACTIONS(1364),
    [anon_sym_PLUS] = ACTIONS(1364),
    [anon_sym_not] = ACTIONS(1366),
    [anon_sym_TILDE] = ACTIONS(1364),
    [anon_sym_lambda] = ACTIONS(1366),
    [anon_sym_yield] = ACTIONS(1366),
    [sym_ellipsis] = ACTIONS(1364),
    [sym_integer] = ACTIONS(1366),
    [sym_float] = ACTIONS(1364),
    [anon_sym_await] = ACTIONS(1366),
    [sym_true] = ACTIONS(1366),
    [sym_false] = ACTIONS(1366),
    [sym_none] = ACTIONS(1366),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1366),
    [anon_sym_container] = ACTIONS(1366),
    [anon_sym_envvars] = ACTIONS(1366),
    [anon_sym_include] = ACTIONS(1366),
    [anon_sym_pepfile] = ACTIONS(1366),
    [anon_sym_pepschema] = ACTIONS(1366),
    [anon_sym_scattergather] = ACTIONS(1366),
    [anon_sym_version] = ACTIONS(1366),
    [anon_sym_wildcard_constraints] = ACTIONS(1366),
    [anon_sym_workdir] = ACTIONS(1366),
    [anon_sym_onerror] = ACTIONS(1366),
    [anon_sym_onstart] = ACTIONS(1366),
    [anon_sym_onsuccess] = ACTIONS(1366),
    [anon_sym_localrules] = ACTIONS(1366),
    [anon_sym_ruleorder] = ACTIONS(1366),
    [anon_sym_rule] = ACTIONS(1366),
    [anon_sym_checkpoint] = ACTIONS(1366),
    [anon_sym_use] = ACTIONS(1366),
    [anon_sym_module] = ACTIONS(1366),
    [sym_string_start] = ACTIONS(1364),
  },
  [368] = {
    [sym_identifier] = ACTIONS(1370),
    [anon_sym_import] = ACTIONS(1370),
    [anon_sym_from] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(1372),
    [anon_sym_STAR] = ACTIONS(1372),
    [anon_sym_print] = ACTIONS(1370),
    [anon_sym_assert] = ACTIONS(1370),
    [anon_sym_return] = ACTIONS(1370),
    [anon_sym_del] = ACTIONS(1370),
    [anon_sym_raise] = ACTIONS(1370),
    [anon_sym_pass] = ACTIONS(1370),
    [anon_sym_break] = ACTIONS(1370),
    [anon_sym_continue] = ACTIONS(1370),
    [anon_sym_if] = ACTIONS(1370),
    [anon_sym_match] = ACTIONS(1370),
    [anon_sym_async] = ACTIONS(1370),
    [anon_sym_for] = ACTIONS(1370),
    [anon_sym_while] = ACTIONS(1370),
    [anon_sym_try] = ACTIONS(1370),
    [anon_sym_with] = ACTIONS(1370),
    [anon_sym_def] = ACTIONS(1370),
    [anon_sym_global] = ACTIONS(1370),
    [anon_sym_nonlocal] = ACTIONS(1370),
    [anon_sym_exec] = ACTIONS(1370),
    [anon_sym_type] = ACTIONS(1370),
    [anon_sym_class] = ACTIONS(1370),
    [anon_sym_LBRACK] = ACTIONS(1372),
    [anon_sym_AT] = ACTIONS(1372),
    [anon_sym_DASH] = ACTIONS(1372),
    [anon_sym_LBRACE] = ACTIONS(1372),
    [anon_sym_PLUS] = ACTIONS(1372),
    [anon_sym_not] = ACTIONS(1370),
    [anon_sym_TILDE] = ACTIONS(1372),
    [anon_sym_lambda] = ACTIONS(1370),
    [anon_sym_yield] = ACTIONS(1370),
    [sym_ellipsis] = ACTIONS(1372),
    [sym_integer] = ACTIONS(1370),
    [sym_float] = ACTIONS(1372),
    [anon_sym_await] = ACTIONS(1370),
    [sym_true] = ACTIONS(1370),
    [sym_false] = ACTIONS(1370),
    [sym_none] = ACTIONS(1370),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1370),
    [anon_sym_container] = ACTIONS(1370),
    [anon_sym_envvars] = ACTIONS(1370),
    [anon_sym_include] = ACTIONS(1370),
    [anon_sym_pepfile] = ACTIONS(1370),
    [anon_sym_pepschema] = ACTIONS(1370),
    [anon_sym_scattergather] = ACTIONS(1370),
    [anon_sym_version] = ACTIONS(1370),
    [anon_sym_wildcard_constraints] = ACTIONS(1370),
    [anon_sym_workdir] = ACTIONS(1370),
    [anon_sym_onerror] = ACTIONS(1370),
    [anon_sym_onstart] = ACTIONS(1370),
    [anon_sym_onsuccess] = ACTIONS(1370),
    [anon_sym_localrules] = ACTIONS(1370),
    [anon_sym_ruleorder] = ACTIONS(1370),
    [anon_sym_rule] = ACTIONS(1370),
    [anon_sym_checkpoint] = ACTIONS(1370),
    [anon_sym_use] = ACTIONS(1370),
    [anon_sym_module] = ACTIONS(1370),
    [sym__dedent] = ACTIONS(1372),
    [sym_string_start] = ACTIONS(1372),
  },
  [369] = {
    [sym_identifier] = ACTIONS(1374),
    [anon_sym_import] = ACTIONS(1374),
    [anon_sym_from] = ACTIONS(1374),
    [anon_sym_LPAREN] = ACTIONS(1376),
    [anon_sym_STAR] = ACTIONS(1376),
    [anon_sym_print] = ACTIONS(1374),
    [anon_sym_assert] = ACTIONS(1374),
    [anon_sym_return] = ACTIONS(1374),
    [anon_sym_del] = ACTIONS(1374),
    [anon_sym_raise] = ACTIONS(1374),
    [anon_sym_pass] = ACTIONS(1374),
    [anon_sym_break] = ACTIONS(1374),
    [anon_sym_continue] = ACTIONS(1374),
    [anon_sym_if] = ACTIONS(1374),
    [anon_sym_match] = ACTIONS(1374),
    [anon_sym_async] = ACTIONS(1374),
    [anon_sym_for] = ACTIONS(1374),
    [anon_sym_while] = ACTIONS(1374),
    [anon_sym_try] = ACTIONS(1374),
    [anon_sym_with] = ACTIONS(1374),
    [anon_sym_def] = ACTIONS(1374),
    [anon_sym_global] = ACTIONS(1374),
    [anon_sym_nonlocal] = ACTIONS(1374),
    [anon_sym_exec] = ACTIONS(1374),
    [anon_sym_type] = ACTIONS(1374),
    [anon_sym_class] = ACTIONS(1374),
    [anon_sym_LBRACK] = ACTIONS(1376),
    [anon_sym_AT] = ACTIONS(1376),
    [anon_sym_DASH] = ACTIONS(1376),
    [anon_sym_LBRACE] = ACTIONS(1376),
    [anon_sym_PLUS] = ACTIONS(1376),
    [anon_sym_not] = ACTIONS(1374),
    [anon_sym_TILDE] = ACTIONS(1376),
    [anon_sym_lambda] = ACTIONS(1374),
    [anon_sym_yield] = ACTIONS(1374),
    [sym_ellipsis] = ACTIONS(1376),
    [sym_integer] = ACTIONS(1374),
    [sym_float] = ACTIONS(1376),
    [anon_sym_await] = ACTIONS(1374),
    [sym_true] = ACTIONS(1374),
    [sym_false] = ACTIONS(1374),
    [sym_none] = ACTIONS(1374),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1374),
    [anon_sym_container] = ACTIONS(1374),
    [anon_sym_envvars] = ACTIONS(1374),
    [anon_sym_include] = ACTIONS(1374),
    [anon_sym_pepfile] = ACTIONS(1374),
    [anon_sym_pepschema] = ACTIONS(1374),
    [anon_sym_scattergather] = ACTIONS(1374),
    [anon_sym_version] = ACTIONS(1374),
    [anon_sym_wildcard_constraints] = ACTIONS(1374),
    [anon_sym_workdir] = ACTIONS(1374),
    [anon_sym_onerror] = ACTIONS(1374),
    [anon_sym_onstart] = ACTIONS(1374),
    [anon_sym_onsuccess] = ACTIONS(1374),
    [anon_sym_localrules] = ACTIONS(1374),
    [anon_sym_ruleorder] = ACTIONS(1374),
    [anon_sym_rule] = ACTIONS(1374),
    [anon_sym_checkpoint] = ACTIONS(1374),
    [anon_sym_use] = ACTIONS(1374),
    [anon_sym_module] = ACTIONS(1374),
    [sym__dedent] = ACTIONS(1376),
    [sym_string_start] = ACTIONS(1376),
  },
  [370] = {
    [sym_identifier] = ACTIONS(1378),
    [anon_sym_import] = ACTIONS(1378),
    [anon_sym_from] = ACTIONS(1378),
    [anon_sym_LPAREN] = ACTIONS(1380),
    [anon_sym_STAR] = ACTIONS(1380),
    [anon_sym_print] = ACTIONS(1378),
    [anon_sym_assert] = ACTIONS(1378),
    [anon_sym_return] = ACTIONS(1378),
    [anon_sym_del] = ACTIONS(1378),
    [anon_sym_raise] = ACTIONS(1378),
    [anon_sym_pass] = ACTIONS(1378),
    [anon_sym_break] = ACTIONS(1378),
    [anon_sym_continue] = ACTIONS(1378),
    [anon_sym_if] = ACTIONS(1378),
    [anon_sym_match] = ACTIONS(1378),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_for] = ACTIONS(1378),
    [anon_sym_while] = ACTIONS(1378),
    [anon_sym_try] = ACTIONS(1378),
    [anon_sym_with] = ACTIONS(1378),
    [anon_sym_def] = ACTIONS(1378),
    [anon_sym_global] = ACTIONS(1378),
    [anon_sym_nonlocal] = ACTIONS(1378),
    [anon_sym_exec] = ACTIONS(1378),
    [anon_sym_type] = ACTIONS(1378),
    [anon_sym_class] = ACTIONS(1378),
    [anon_sym_LBRACK] = ACTIONS(1380),
    [anon_sym_AT] = ACTIONS(1380),
    [anon_sym_DASH] = ACTIONS(1380),
    [anon_sym_LBRACE] = ACTIONS(1380),
    [anon_sym_PLUS] = ACTIONS(1380),
    [anon_sym_not] = ACTIONS(1378),
    [anon_sym_TILDE] = ACTIONS(1380),
    [anon_sym_lambda] = ACTIONS(1378),
    [anon_sym_yield] = ACTIONS(1378),
    [sym_ellipsis] = ACTIONS(1380),
    [sym_integer] = ACTIONS(1378),
    [sym_float] = ACTIONS(1380),
    [anon_sym_await] = ACTIONS(1378),
    [sym_true] = ACTIONS(1378),
    [sym_false] = ACTIONS(1378),
    [sym_none] = ACTIONS(1378),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1378),
    [anon_sym_container] = ACTIONS(1378),
    [anon_sym_envvars] = ACTIONS(1378),
    [anon_sym_include] = ACTIONS(1378),
    [anon_sym_pepfile] = ACTIONS(1378),
    [anon_sym_pepschema] = ACTIONS(1378),
    [anon_sym_scattergather] = ACTIONS(1378),
    [anon_sym_version] = ACTIONS(1378),
    [anon_sym_wildcard_constraints] = ACTIONS(1378),
    [anon_sym_workdir] = ACTIONS(1378),
    [anon_sym_onerror] = ACTIONS(1378),
    [anon_sym_onstart] = ACTIONS(1378),
    [anon_sym_onsuccess] = ACTIONS(1378),
    [anon_sym_localrules] = ACTIONS(1378),
    [anon_sym_ruleorder] = ACTIONS(1378),
    [anon_sym_rule] = ACTIONS(1378),
    [anon_sym_checkpoint] = ACTIONS(1378),
    [anon_sym_use] = ACTIONS(1378),
    [anon_sym_module] = ACTIONS(1378),
    [sym__dedent] = ACTIONS(1380),
    [sym_string_start] = ACTIONS(1380),
  },
  [371] = {
    [ts_builtin_sym_end] = ACTIONS(1382),
    [sym_identifier] = ACTIONS(1384),
    [anon_sym_import] = ACTIONS(1384),
    [anon_sym_from] = ACTIONS(1384),
    [anon_sym_LPAREN] = ACTIONS(1382),
    [anon_sym_STAR] = ACTIONS(1382),
    [anon_sym_print] = ACTIONS(1384),
    [anon_sym_assert] = ACTIONS(1384),
    [anon_sym_return] = ACTIONS(1384),
    [anon_sym_del] = ACTIONS(1384),
    [anon_sym_raise] = ACTIONS(1384),
    [anon_sym_pass] = ACTIONS(1384),
    [anon_sym_break] = ACTIONS(1384),
    [anon_sym_continue] = ACTIONS(1384),
    [anon_sym_if] = ACTIONS(1384),
    [anon_sym_match] = ACTIONS(1384),
    [anon_sym_async] = ACTIONS(1384),
    [anon_sym_for] = ACTIONS(1384),
    [anon_sym_while] = ACTIONS(1384),
    [anon_sym_try] = ACTIONS(1384),
    [anon_sym_with] = ACTIONS(1384),
    [anon_sym_def] = ACTIONS(1384),
    [anon_sym_global] = ACTIONS(1384),
    [anon_sym_nonlocal] = ACTIONS(1384),
    [anon_sym_exec] = ACTIONS(1384),
    [anon_sym_type] = ACTIONS(1384),
    [anon_sym_class] = ACTIONS(1384),
    [anon_sym_LBRACK] = ACTIONS(1382),
    [anon_sym_AT] = ACTIONS(1382),
    [anon_sym_DASH] = ACTIONS(1382),
    [anon_sym_LBRACE] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(1382),
    [anon_sym_not] = ACTIONS(1384),
    [anon_sym_TILDE] = ACTIONS(1382),
    [anon_sym_lambda] = ACTIONS(1384),
    [anon_sym_yield] = ACTIONS(1384),
    [sym_ellipsis] = ACTIONS(1382),
    [sym_integer] = ACTIONS(1384),
    [sym_float] = ACTIONS(1382),
    [anon_sym_await] = ACTIONS(1384),
    [sym_true] = ACTIONS(1384),
    [sym_false] = ACTIONS(1384),
    [sym_none] = ACTIONS(1384),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1384),
    [anon_sym_container] = ACTIONS(1384),
    [anon_sym_envvars] = ACTIONS(1384),
    [anon_sym_include] = ACTIONS(1384),
    [anon_sym_pepfile] = ACTIONS(1384),
    [anon_sym_pepschema] = ACTIONS(1384),
    [anon_sym_scattergather] = ACTIONS(1384),
    [anon_sym_version] = ACTIONS(1384),
    [anon_sym_wildcard_constraints] = ACTIONS(1384),
    [anon_sym_workdir] = ACTIONS(1384),
    [anon_sym_onerror] = ACTIONS(1384),
    [anon_sym_onstart] = ACTIONS(1384),
    [anon_sym_onsuccess] = ACTIONS(1384),
    [anon_sym_localrules] = ACTIONS(1384),
    [anon_sym_ruleorder] = ACTIONS(1384),
    [anon_sym_rule] = ACTIONS(1384),
    [anon_sym_checkpoint] = ACTIONS(1384),
    [anon_sym_use] = ACTIONS(1384),
    [anon_sym_module] = ACTIONS(1384),
    [sym_string_start] = ACTIONS(1382),
  },
  [372] = {
    [ts_builtin_sym_end] = ACTIONS(1036),
    [sym_identifier] = ACTIONS(1034),
    [anon_sym_import] = ACTIONS(1034),
    [anon_sym_from] = ACTIONS(1034),
    [anon_sym_LPAREN] = ACTIONS(1036),
    [anon_sym_STAR] = ACTIONS(1036),
    [anon_sym_print] = ACTIONS(1034),
    [anon_sym_assert] = ACTIONS(1034),
    [anon_sym_return] = ACTIONS(1034),
    [anon_sym_del] = ACTIONS(1034),
    [anon_sym_raise] = ACTIONS(1034),
    [anon_sym_pass] = ACTIONS(1034),
    [anon_sym_break] = ACTIONS(1034),
    [anon_sym_continue] = ACTIONS(1034),
    [anon_sym_if] = ACTIONS(1034),
    [anon_sym_match] = ACTIONS(1034),
    [anon_sym_async] = ACTIONS(1034),
    [anon_sym_for] = ACTIONS(1034),
    [anon_sym_while] = ACTIONS(1034),
    [anon_sym_try] = ACTIONS(1034),
    [anon_sym_with] = ACTIONS(1034),
    [anon_sym_def] = ACTIONS(1034),
    [anon_sym_global] = ACTIONS(1034),
    [anon_sym_nonlocal] = ACTIONS(1034),
    [anon_sym_exec] = ACTIONS(1034),
    [anon_sym_type] = ACTIONS(1034),
    [anon_sym_class] = ACTIONS(1034),
    [anon_sym_LBRACK] = ACTIONS(1036),
    [anon_sym_AT] = ACTIONS(1036),
    [anon_sym_DASH] = ACTIONS(1036),
    [anon_sym_LBRACE] = ACTIONS(1036),
    [anon_sym_PLUS] = ACTIONS(1036),
    [anon_sym_not] = ACTIONS(1034),
    [anon_sym_TILDE] = ACTIONS(1036),
    [anon_sym_lambda] = ACTIONS(1034),
    [anon_sym_yield] = ACTIONS(1034),
    [sym_ellipsis] = ACTIONS(1036),
    [sym_integer] = ACTIONS(1034),
    [sym_float] = ACTIONS(1036),
    [anon_sym_await] = ACTIONS(1034),
    [sym_true] = ACTIONS(1034),
    [sym_false] = ACTIONS(1034),
    [sym_none] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1034),
    [anon_sym_container] = ACTIONS(1034),
    [anon_sym_envvars] = ACTIONS(1034),
    [anon_sym_include] = ACTIONS(1034),
    [anon_sym_pepfile] = ACTIONS(1034),
    [anon_sym_pepschema] = ACTIONS(1034),
    [anon_sym_scattergather] = ACTIONS(1034),
    [anon_sym_version] = ACTIONS(1034),
    [anon_sym_wildcard_constraints] = ACTIONS(1034),
    [anon_sym_workdir] = ACTIONS(1034),
    [anon_sym_onerror] = ACTIONS(1034),
    [anon_sym_onstart] = ACTIONS(1034),
    [anon_sym_onsuccess] = ACTIONS(1034),
    [anon_sym_localrules] = ACTIONS(1034),
    [anon_sym_ruleorder] = ACTIONS(1034),
    [anon_sym_rule] = ACTIONS(1034),
    [anon_sym_checkpoint] = ACTIONS(1034),
    [anon_sym_use] = ACTIONS(1034),
    [anon_sym_module] = ACTIONS(1034),
    [sym_string_start] = ACTIONS(1036),
  },
  [373] = {
    [ts_builtin_sym_end] = ACTIONS(1386),
    [sym_identifier] = ACTIONS(1388),
    [anon_sym_import] = ACTIONS(1388),
    [anon_sym_from] = ACTIONS(1388),
    [anon_sym_LPAREN] = ACTIONS(1386),
    [anon_sym_STAR] = ACTIONS(1386),
    [anon_sym_print] = ACTIONS(1388),
    [anon_sym_assert] = ACTIONS(1388),
    [anon_sym_return] = ACTIONS(1388),
    [anon_sym_del] = ACTIONS(1388),
    [anon_sym_raise] = ACTIONS(1388),
    [anon_sym_pass] = ACTIONS(1388),
    [anon_sym_break] = ACTIONS(1388),
    [anon_sym_continue] = ACTIONS(1388),
    [anon_sym_if] = ACTIONS(1388),
    [anon_sym_match] = ACTIONS(1388),
    [anon_sym_async] = ACTIONS(1388),
    [anon_sym_for] = ACTIONS(1388),
    [anon_sym_while] = ACTIONS(1388),
    [anon_sym_try] = ACTIONS(1388),
    [anon_sym_with] = ACTIONS(1388),
    [anon_sym_def] = ACTIONS(1388),
    [anon_sym_global] = ACTIONS(1388),
    [anon_sym_nonlocal] = ACTIONS(1388),
    [anon_sym_exec] = ACTIONS(1388),
    [anon_sym_type] = ACTIONS(1388),
    [anon_sym_class] = ACTIONS(1388),
    [anon_sym_LBRACK] = ACTIONS(1386),
    [anon_sym_AT] = ACTIONS(1386),
    [anon_sym_DASH] = ACTIONS(1386),
    [anon_sym_LBRACE] = ACTIONS(1386),
    [anon_sym_PLUS] = ACTIONS(1386),
    [anon_sym_not] = ACTIONS(1388),
    [anon_sym_TILDE] = ACTIONS(1386),
    [anon_sym_lambda] = ACTIONS(1388),
    [anon_sym_yield] = ACTIONS(1388),
    [sym_ellipsis] = ACTIONS(1386),
    [sym_integer] = ACTIONS(1388),
    [sym_float] = ACTIONS(1386),
    [anon_sym_await] = ACTIONS(1388),
    [sym_true] = ACTIONS(1388),
    [sym_false] = ACTIONS(1388),
    [sym_none] = ACTIONS(1388),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1388),
    [anon_sym_container] = ACTIONS(1388),
    [anon_sym_envvars] = ACTIONS(1388),
    [anon_sym_include] = ACTIONS(1388),
    [anon_sym_pepfile] = ACTIONS(1388),
    [anon_sym_pepschema] = ACTIONS(1388),
    [anon_sym_scattergather] = ACTIONS(1388),
    [anon_sym_version] = ACTIONS(1388),
    [anon_sym_wildcard_constraints] = ACTIONS(1388),
    [anon_sym_workdir] = ACTIONS(1388),
    [anon_sym_onerror] = ACTIONS(1388),
    [anon_sym_onstart] = ACTIONS(1388),
    [anon_sym_onsuccess] = ACTIONS(1388),
    [anon_sym_localrules] = ACTIONS(1388),
    [anon_sym_ruleorder] = ACTIONS(1388),
    [anon_sym_rule] = ACTIONS(1388),
    [anon_sym_checkpoint] = ACTIONS(1388),
    [anon_sym_use] = ACTIONS(1388),
    [anon_sym_module] = ACTIONS(1388),
    [sym_string_start] = ACTIONS(1386),
  },
  [374] = {
    [sym_identifier] = ACTIONS(1388),
    [anon_sym_import] = ACTIONS(1388),
    [anon_sym_from] = ACTIONS(1388),
    [anon_sym_LPAREN] = ACTIONS(1386),
    [anon_sym_STAR] = ACTIONS(1386),
    [anon_sym_print] = ACTIONS(1388),
    [anon_sym_assert] = ACTIONS(1388),
    [anon_sym_return] = ACTIONS(1388),
    [anon_sym_del] = ACTIONS(1388),
    [anon_sym_raise] = ACTIONS(1388),
    [anon_sym_pass] = ACTIONS(1388),
    [anon_sym_break] = ACTIONS(1388),
    [anon_sym_continue] = ACTIONS(1388),
    [anon_sym_if] = ACTIONS(1388),
    [anon_sym_match] = ACTIONS(1388),
    [anon_sym_async] = ACTIONS(1388),
    [anon_sym_for] = ACTIONS(1388),
    [anon_sym_while] = ACTIONS(1388),
    [anon_sym_try] = ACTIONS(1388),
    [anon_sym_with] = ACTIONS(1388),
    [anon_sym_def] = ACTIONS(1388),
    [anon_sym_global] = ACTIONS(1388),
    [anon_sym_nonlocal] = ACTIONS(1388),
    [anon_sym_exec] = ACTIONS(1388),
    [anon_sym_type] = ACTIONS(1388),
    [anon_sym_class] = ACTIONS(1388),
    [anon_sym_LBRACK] = ACTIONS(1386),
    [anon_sym_AT] = ACTIONS(1386),
    [anon_sym_DASH] = ACTIONS(1386),
    [anon_sym_LBRACE] = ACTIONS(1386),
    [anon_sym_PLUS] = ACTIONS(1386),
    [anon_sym_not] = ACTIONS(1388),
    [anon_sym_TILDE] = ACTIONS(1386),
    [anon_sym_lambda] = ACTIONS(1388),
    [anon_sym_yield] = ACTIONS(1388),
    [sym_ellipsis] = ACTIONS(1386),
    [sym_integer] = ACTIONS(1388),
    [sym_float] = ACTIONS(1386),
    [anon_sym_await] = ACTIONS(1388),
    [sym_true] = ACTIONS(1388),
    [sym_false] = ACTIONS(1388),
    [sym_none] = ACTIONS(1388),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1388),
    [anon_sym_container] = ACTIONS(1388),
    [anon_sym_envvars] = ACTIONS(1388),
    [anon_sym_include] = ACTIONS(1388),
    [anon_sym_pepfile] = ACTIONS(1388),
    [anon_sym_pepschema] = ACTIONS(1388),
    [anon_sym_scattergather] = ACTIONS(1388),
    [anon_sym_version] = ACTIONS(1388),
    [anon_sym_wildcard_constraints] = ACTIONS(1388),
    [anon_sym_workdir] = ACTIONS(1388),
    [anon_sym_onerror] = ACTIONS(1388),
    [anon_sym_onstart] = ACTIONS(1388),
    [anon_sym_onsuccess] = ACTIONS(1388),
    [anon_sym_localrules] = ACTIONS(1388),
    [anon_sym_ruleorder] = ACTIONS(1388),
    [anon_sym_rule] = ACTIONS(1388),
    [anon_sym_checkpoint] = ACTIONS(1388),
    [anon_sym_use] = ACTIONS(1388),
    [anon_sym_module] = ACTIONS(1388),
    [sym__dedent] = ACTIONS(1386),
    [sym_string_start] = ACTIONS(1386),
  },
  [375] = {
    [ts_builtin_sym_end] = ACTIONS(1380),
    [sym_identifier] = ACTIONS(1378),
    [anon_sym_import] = ACTIONS(1378),
    [anon_sym_from] = ACTIONS(1378),
    [anon_sym_LPAREN] = ACTIONS(1380),
    [anon_sym_STAR] = ACTIONS(1380),
    [anon_sym_print] = ACTIONS(1378),
    [anon_sym_assert] = ACTIONS(1378),
    [anon_sym_return] = ACTIONS(1378),
    [anon_sym_del] = ACTIONS(1378),
    [anon_sym_raise] = ACTIONS(1378),
    [anon_sym_pass] = ACTIONS(1378),
    [anon_sym_break] = ACTIONS(1378),
    [anon_sym_continue] = ACTIONS(1378),
    [anon_sym_if] = ACTIONS(1378),
    [anon_sym_match] = ACTIONS(1378),
    [anon_sym_async] = ACTIONS(1378),
    [anon_sym_for] = ACTIONS(1378),
    [anon_sym_while] = ACTIONS(1378),
    [anon_sym_try] = ACTIONS(1378),
    [anon_sym_with] = ACTIONS(1378),
    [anon_sym_def] = ACTIONS(1378),
    [anon_sym_global] = ACTIONS(1378),
    [anon_sym_nonlocal] = ACTIONS(1378),
    [anon_sym_exec] = ACTIONS(1378),
    [anon_sym_type] = ACTIONS(1378),
    [anon_sym_class] = ACTIONS(1378),
    [anon_sym_LBRACK] = ACTIONS(1380),
    [anon_sym_AT] = ACTIONS(1380),
    [anon_sym_DASH] = ACTIONS(1380),
    [anon_sym_LBRACE] = ACTIONS(1380),
    [anon_sym_PLUS] = ACTIONS(1380),
    [anon_sym_not] = ACTIONS(1378),
    [anon_sym_TILDE] = ACTIONS(1380),
    [anon_sym_lambda] = ACTIONS(1378),
    [anon_sym_yield] = ACTIONS(1378),
    [sym_ellipsis] = ACTIONS(1380),
    [sym_integer] = ACTIONS(1378),
    [sym_float] = ACTIONS(1380),
    [anon_sym_await] = ACTIONS(1378),
    [sym_true] = ACTIONS(1378),
    [sym_false] = ACTIONS(1378),
    [sym_none] = ACTIONS(1378),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1378),
    [anon_sym_container] = ACTIONS(1378),
    [anon_sym_envvars] = ACTIONS(1378),
    [anon_sym_include] = ACTIONS(1378),
    [anon_sym_pepfile] = ACTIONS(1378),
    [anon_sym_pepschema] = ACTIONS(1378),
    [anon_sym_scattergather] = ACTIONS(1378),
    [anon_sym_version] = ACTIONS(1378),
    [anon_sym_wildcard_constraints] = ACTIONS(1378),
    [anon_sym_workdir] = ACTIONS(1378),
    [anon_sym_onerror] = ACTIONS(1378),
    [anon_sym_onstart] = ACTIONS(1378),
    [anon_sym_onsuccess] = ACTIONS(1378),
    [anon_sym_localrules] = ACTIONS(1378),
    [anon_sym_ruleorder] = ACTIONS(1378),
    [anon_sym_rule] = ACTIONS(1378),
    [anon_sym_checkpoint] = ACTIONS(1378),
    [anon_sym_use] = ACTIONS(1378),
    [anon_sym_module] = ACTIONS(1378),
    [sym_string_start] = ACTIONS(1380),
  },
  [376] = {
    [sym_identifier] = ACTIONS(1384),
    [anon_sym_import] = ACTIONS(1384),
    [anon_sym_from] = ACTIONS(1384),
    [anon_sym_LPAREN] = ACTIONS(1382),
    [anon_sym_STAR] = ACTIONS(1382),
    [anon_sym_print] = ACTIONS(1384),
    [anon_sym_assert] = ACTIONS(1384),
    [anon_sym_return] = ACTIONS(1384),
    [anon_sym_del] = ACTIONS(1384),
    [anon_sym_raise] = ACTIONS(1384),
    [anon_sym_pass] = ACTIONS(1384),
    [anon_sym_break] = ACTIONS(1384),
    [anon_sym_continue] = ACTIONS(1384),
    [anon_sym_if] = ACTIONS(1384),
    [anon_sym_match] = ACTIONS(1384),
    [anon_sym_async] = ACTIONS(1384),
    [anon_sym_for] = ACTIONS(1384),
    [anon_sym_while] = ACTIONS(1384),
    [anon_sym_try] = ACTIONS(1384),
    [anon_sym_with] = ACTIONS(1384),
    [anon_sym_def] = ACTIONS(1384),
    [anon_sym_global] = ACTIONS(1384),
    [anon_sym_nonlocal] = ACTIONS(1384),
    [anon_sym_exec] = ACTIONS(1384),
    [anon_sym_type] = ACTIONS(1384),
    [anon_sym_class] = ACTIONS(1384),
    [anon_sym_LBRACK] = ACTIONS(1382),
    [anon_sym_AT] = ACTIONS(1382),
    [anon_sym_DASH] = ACTIONS(1382),
    [anon_sym_LBRACE] = ACTIONS(1382),
    [anon_sym_PLUS] = ACTIONS(1382),
    [anon_sym_not] = ACTIONS(1384),
    [anon_sym_TILDE] = ACTIONS(1382),
    [anon_sym_lambda] = ACTIONS(1384),
    [anon_sym_yield] = ACTIONS(1384),
    [sym_ellipsis] = ACTIONS(1382),
    [sym_integer] = ACTIONS(1384),
    [sym_float] = ACTIONS(1382),
    [anon_sym_await] = ACTIONS(1384),
    [sym_true] = ACTIONS(1384),
    [sym_false] = ACTIONS(1384),
    [sym_none] = ACTIONS(1384),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1384),
    [anon_sym_container] = ACTIONS(1384),
    [anon_sym_envvars] = ACTIONS(1384),
    [anon_sym_include] = ACTIONS(1384),
    [anon_sym_pepfile] = ACTIONS(1384),
    [anon_sym_pepschema] = ACTIONS(1384),
    [anon_sym_scattergather] = ACTIONS(1384),
    [anon_sym_version] = ACTIONS(1384),
    [anon_sym_wildcard_constraints] = ACTIONS(1384),
    [anon_sym_workdir] = ACTIONS(1384),
    [anon_sym_onerror] = ACTIONS(1384),
    [anon_sym_onstart] = ACTIONS(1384),
    [anon_sym_onsuccess] = ACTIONS(1384),
    [anon_sym_localrules] = ACTIONS(1384),
    [anon_sym_ruleorder] = ACTIONS(1384),
    [anon_sym_rule] = ACTIONS(1384),
    [anon_sym_checkpoint] = ACTIONS(1384),
    [anon_sym_use] = ACTIONS(1384),
    [anon_sym_module] = ACTIONS(1384),
    [sym__dedent] = ACTIONS(1382),
    [sym_string_start] = ACTIONS(1382),
  },
  [377] = {
    [ts_builtin_sym_end] = ACTIONS(1376),
    [sym_identifier] = ACTIONS(1374),
    [anon_sym_import] = ACTIONS(1374),
    [anon_sym_from] = ACTIONS(1374),
    [anon_sym_LPAREN] = ACTIONS(1376),
    [anon_sym_STAR] = ACTIONS(1376),
    [anon_sym_print] = ACTIONS(1374),
    [anon_sym_assert] = ACTIONS(1374),
    [anon_sym_return] = ACTIONS(1374),
    [anon_sym_del] = ACTIONS(1374),
    [anon_sym_raise] = ACTIONS(1374),
    [anon_sym_pass] = ACTIONS(1374),
    [anon_sym_break] = ACTIONS(1374),
    [anon_sym_continue] = ACTIONS(1374),
    [anon_sym_if] = ACTIONS(1374),
    [anon_sym_match] = ACTIONS(1374),
    [anon_sym_async] = ACTIONS(1374),
    [anon_sym_for] = ACTIONS(1374),
    [anon_sym_while] = ACTIONS(1374),
    [anon_sym_try] = ACTIONS(1374),
    [anon_sym_with] = ACTIONS(1374),
    [anon_sym_def] = ACTIONS(1374),
    [anon_sym_global] = ACTIONS(1374),
    [anon_sym_nonlocal] = ACTIONS(1374),
    [anon_sym_exec] = ACTIONS(1374),
    [anon_sym_type] = ACTIONS(1374),
    [anon_sym_class] = ACTIONS(1374),
    [anon_sym_LBRACK] = ACTIONS(1376),
    [anon_sym_AT] = ACTIONS(1376),
    [anon_sym_DASH] = ACTIONS(1376),
    [anon_sym_LBRACE] = ACTIONS(1376),
    [anon_sym_PLUS] = ACTIONS(1376),
    [anon_sym_not] = ACTIONS(1374),
    [anon_sym_TILDE] = ACTIONS(1376),
    [anon_sym_lambda] = ACTIONS(1374),
    [anon_sym_yield] = ACTIONS(1374),
    [sym_ellipsis] = ACTIONS(1376),
    [sym_integer] = ACTIONS(1374),
    [sym_float] = ACTIONS(1376),
    [anon_sym_await] = ACTIONS(1374),
    [sym_true] = ACTIONS(1374),
    [sym_false] = ACTIONS(1374),
    [sym_none] = ACTIONS(1374),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1374),
    [anon_sym_container] = ACTIONS(1374),
    [anon_sym_envvars] = ACTIONS(1374),
    [anon_sym_include] = ACTIONS(1374),
    [anon_sym_pepfile] = ACTIONS(1374),
    [anon_sym_pepschema] = ACTIONS(1374),
    [anon_sym_scattergather] = ACTIONS(1374),
    [anon_sym_version] = ACTIONS(1374),
    [anon_sym_wildcard_constraints] = ACTIONS(1374),
    [anon_sym_workdir] = ACTIONS(1374),
    [anon_sym_onerror] = ACTIONS(1374),
    [anon_sym_onstart] = ACTIONS(1374),
    [anon_sym_onsuccess] = ACTIONS(1374),
    [anon_sym_localrules] = ACTIONS(1374),
    [anon_sym_ruleorder] = ACTIONS(1374),
    [anon_sym_rule] = ACTIONS(1374),
    [anon_sym_checkpoint] = ACTIONS(1374),
    [anon_sym_use] = ACTIONS(1374),
    [anon_sym_module] = ACTIONS(1374),
    [sym_string_start] = ACTIONS(1376),
  },
  [378] = {
    [ts_builtin_sym_end] = ACTIONS(1372),
    [sym_identifier] = ACTIONS(1370),
    [anon_sym_import] = ACTIONS(1370),
    [anon_sym_from] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(1372),
    [anon_sym_STAR] = ACTIONS(1372),
    [anon_sym_print] = ACTIONS(1370),
    [anon_sym_assert] = ACTIONS(1370),
    [anon_sym_return] = ACTIONS(1370),
    [anon_sym_del] = ACTIONS(1370),
    [anon_sym_raise] = ACTIONS(1370),
    [anon_sym_pass] = ACTIONS(1370),
    [anon_sym_break] = ACTIONS(1370),
    [anon_sym_continue] = ACTIONS(1370),
    [anon_sym_if] = ACTIONS(1370),
    [anon_sym_match] = ACTIONS(1370),
    [anon_sym_async] = ACTIONS(1370),
    [anon_sym_for] = ACTIONS(1370),
    [anon_sym_while] = ACTIONS(1370),
    [anon_sym_try] = ACTIONS(1370),
    [anon_sym_with] = ACTIONS(1370),
    [anon_sym_def] = ACTIONS(1370),
    [anon_sym_global] = ACTIONS(1370),
    [anon_sym_nonlocal] = ACTIONS(1370),
    [anon_sym_exec] = ACTIONS(1370),
    [anon_sym_type] = ACTIONS(1370),
    [anon_sym_class] = ACTIONS(1370),
    [anon_sym_LBRACK] = ACTIONS(1372),
    [anon_sym_AT] = ACTIONS(1372),
    [anon_sym_DASH] = ACTIONS(1372),
    [anon_sym_LBRACE] = ACTIONS(1372),
    [anon_sym_PLUS] = ACTIONS(1372),
    [anon_sym_not] = ACTIONS(1370),
    [anon_sym_TILDE] = ACTIONS(1372),
    [anon_sym_lambda] = ACTIONS(1370),
    [anon_sym_yield] = ACTIONS(1370),
    [sym_ellipsis] = ACTIONS(1372),
    [sym_integer] = ACTIONS(1370),
    [sym_float] = ACTIONS(1372),
    [anon_sym_await] = ACTIONS(1370),
    [sym_true] = ACTIONS(1370),
    [sym_false] = ACTIONS(1370),
    [sym_none] = ACTIONS(1370),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1370),
    [anon_sym_container] = ACTIONS(1370),
    [anon_sym_envvars] = ACTIONS(1370),
    [anon_sym_include] = ACTIONS(1370),
    [anon_sym_pepfile] = ACTIONS(1370),
    [anon_sym_pepschema] = ACTIONS(1370),
    [anon_sym_scattergather] = ACTIONS(1370),
    [anon_sym_version] = ACTIONS(1370),
    [anon_sym_wildcard_constraints] = ACTIONS(1370),
    [anon_sym_workdir] = ACTIONS(1370),
    [anon_sym_onerror] = ACTIONS(1370),
    [anon_sym_onstart] = ACTIONS(1370),
    [anon_sym_onsuccess] = ACTIONS(1370),
    [anon_sym_localrules] = ACTIONS(1370),
    [anon_sym_ruleorder] = ACTIONS(1370),
    [anon_sym_rule] = ACTIONS(1370),
    [anon_sym_checkpoint] = ACTIONS(1370),
    [anon_sym_use] = ACTIONS(1370),
    [anon_sym_module] = ACTIONS(1370),
    [sym_string_start] = ACTIONS(1372),
  },
  [379] = {
    [ts_builtin_sym_end] = ACTIONS(1362),
    [sym_identifier] = ACTIONS(1360),
    [anon_sym_import] = ACTIONS(1360),
    [anon_sym_from] = ACTIONS(1360),
    [anon_sym_LPAREN] = ACTIONS(1362),
    [anon_sym_STAR] = ACTIONS(1362),
    [anon_sym_print] = ACTIONS(1360),
    [anon_sym_assert] = ACTIONS(1360),
    [anon_sym_return] = ACTIONS(1360),
    [anon_sym_del] = ACTIONS(1360),
    [anon_sym_raise] = ACTIONS(1360),
    [anon_sym_pass] = ACTIONS(1360),
    [anon_sym_break] = ACTIONS(1360),
    [anon_sym_continue] = ACTIONS(1360),
    [anon_sym_if] = ACTIONS(1360),
    [anon_sym_match] = ACTIONS(1360),
    [anon_sym_async] = ACTIONS(1360),
    [anon_sym_for] = ACTIONS(1360),
    [anon_sym_while] = ACTIONS(1360),
    [anon_sym_try] = ACTIONS(1360),
    [anon_sym_with] = ACTIONS(1360),
    [anon_sym_def] = ACTIONS(1360),
    [anon_sym_global] = ACTIONS(1360),
    [anon_sym_nonlocal] = ACTIONS(1360),
    [anon_sym_exec] = ACTIONS(1360),
    [anon_sym_type] = ACTIONS(1360),
    [anon_sym_class] = ACTIONS(1360),
    [anon_sym_LBRACK] = ACTIONS(1362),
    [anon_sym_AT] = ACTIONS(1362),
    [anon_sym_DASH] = ACTIONS(1362),
    [anon_sym_LBRACE] = ACTIONS(1362),
    [anon_sym_PLUS] = ACTIONS(1362),
    [anon_sym_not] = ACTIONS(1360),
    [anon_sym_TILDE] = ACTIONS(1362),
    [anon_sym_lambda] = ACTIONS(1360),
    [anon_sym_yield] = ACTIONS(1360),
    [sym_ellipsis] = ACTIONS(1362),
    [sym_integer] = ACTIONS(1360),
    [sym_float] = ACTIONS(1362),
    [anon_sym_await] = ACTIONS(1360),
    [sym_true] = ACTIONS(1360),
    [sym_false] = ACTIONS(1360),
    [sym_none] = ACTIONS(1360),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1360),
    [anon_sym_container] = ACTIONS(1360),
    [anon_sym_envvars] = ACTIONS(1360),
    [anon_sym_include] = ACTIONS(1360),
    [anon_sym_pepfile] = ACTIONS(1360),
    [anon_sym_pepschema] = ACTIONS(1360),
    [anon_sym_scattergather] = ACTIONS(1360),
    [anon_sym_version] = ACTIONS(1360),
    [anon_sym_wildcard_constraints] = ACTIONS(1360),
    [anon_sym_workdir] = ACTIONS(1360),
    [anon_sym_onerror] = ACTIONS(1360),
    [anon_sym_onstart] = ACTIONS(1360),
    [anon_sym_onsuccess] = ACTIONS(1360),
    [anon_sym_localrules] = ACTIONS(1360),
    [anon_sym_ruleorder] = ACTIONS(1360),
    [anon_sym_rule] = ACTIONS(1360),
    [anon_sym_checkpoint] = ACTIONS(1360),
    [anon_sym_use] = ACTIONS(1360),
    [anon_sym_module] = ACTIONS(1360),
    [sym_string_start] = ACTIONS(1362),
  },
  [380] = {
    [sym_identifier] = ACTIONS(1366),
    [anon_sym_import] = ACTIONS(1366),
    [anon_sym_from] = ACTIONS(1366),
    [anon_sym_LPAREN] = ACTIONS(1364),
    [anon_sym_STAR] = ACTIONS(1364),
    [anon_sym_print] = ACTIONS(1366),
    [anon_sym_assert] = ACTIONS(1366),
    [anon_sym_return] = ACTIONS(1366),
    [anon_sym_del] = ACTIONS(1366),
    [anon_sym_raise] = ACTIONS(1366),
    [anon_sym_pass] = ACTIONS(1366),
    [anon_sym_break] = ACTIONS(1366),
    [anon_sym_continue] = ACTIONS(1366),
    [anon_sym_if] = ACTIONS(1366),
    [anon_sym_match] = ACTIONS(1366),
    [anon_sym_async] = ACTIONS(1366),
    [anon_sym_for] = ACTIONS(1366),
    [anon_sym_while] = ACTIONS(1366),
    [anon_sym_try] = ACTIONS(1366),
    [anon_sym_with] = ACTIONS(1390),
    [anon_sym_def] = ACTIONS(1366),
    [anon_sym_global] = ACTIONS(1366),
    [anon_sym_nonlocal] = ACTIONS(1366),
    [anon_sym_exec] = ACTIONS(1366),
    [anon_sym_type] = ACTIONS(1366),
    [anon_sym_class] = ACTIONS(1366),
    [anon_sym_LBRACK] = ACTIONS(1364),
    [anon_sym_AT] = ACTIONS(1364),
    [anon_sym_DASH] = ACTIONS(1364),
    [anon_sym_LBRACE] = ACTIONS(1364),
    [anon_sym_PLUS] = ACTIONS(1364),
    [anon_sym_not] = ACTIONS(1366),
    [anon_sym_TILDE] = ACTIONS(1364),
    [anon_sym_lambda] = ACTIONS(1366),
    [anon_sym_yield] = ACTIONS(1366),
    [sym_ellipsis] = ACTIONS(1364),
    [sym_integer] = ACTIONS(1366),
    [sym_float] = ACTIONS(1364),
    [anon_sym_await] = ACTIONS(1366),
    [sym_true] = ACTIONS(1366),
    [sym_false] = ACTIONS(1366),
    [sym_none] = ACTIONS(1366),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1366),
    [anon_sym_container] = ACTIONS(1366),
    [anon_sym_envvars] = ACTIONS(1366),
    [anon_sym_include] = ACTIONS(1366),
    [anon_sym_pepfile] = ACTIONS(1366),
    [anon_sym_pepschema] = ACTIONS(1366),
    [anon_sym_scattergather] = ACTIONS(1366),
    [anon_sym_version] = ACTIONS(1366),
    [anon_sym_wildcard_constraints] = ACTIONS(1366),
    [anon_sym_workdir] = ACTIONS(1366),
    [anon_sym_onerror] = ACTIONS(1366),
    [anon_sym_onstart] = ACTIONS(1366),
    [anon_sym_onsuccess] = ACTIONS(1366),
    [anon_sym_localrules] = ACTIONS(1366),
    [anon_sym_ruleorder] = ACTIONS(1366),
    [anon_sym_rule] = ACTIONS(1366),
    [anon_sym_checkpoint] = ACTIONS(1366),
    [anon_sym_use] = ACTIONS(1366),
    [anon_sym_module] = ACTIONS(1366),
    [sym__dedent] = ACTIONS(1364),
    [sym_string_start] = ACTIONS(1364),
  },
  [381] = {
    [ts_builtin_sym_end] = ACTIONS(976),
    [sym_identifier] = ACTIONS(974),
    [anon_sym_import] = ACTIONS(974),
    [anon_sym_from] = ACTIONS(974),
    [anon_sym_LPAREN] = ACTIONS(976),
    [anon_sym_STAR] = ACTIONS(976),
    [anon_sym_print] = ACTIONS(974),
    [anon_sym_assert] = ACTIONS(974),
    [anon_sym_return] = ACTIONS(974),
    [anon_sym_del] = ACTIONS(974),
    [anon_sym_raise] = ACTIONS(974),
    [anon_sym_pass] = ACTIONS(974),
    [anon_sym_break] = ACTIONS(974),
    [anon_sym_continue] = ACTIONS(974),
    [anon_sym_if] = ACTIONS(974),
    [anon_sym_match] = ACTIONS(974),
    [anon_sym_async] = ACTIONS(974),
    [anon_sym_for] = ACTIONS(974),
    [anon_sym_while] = ACTIONS(974),
    [anon_sym_try] = ACTIONS(974),
    [anon_sym_with] = ACTIONS(974),
    [anon_sym_def] = ACTIONS(974),
    [anon_sym_global] = ACTIONS(974),
    [anon_sym_nonlocal] = ACTIONS(974),
    [anon_sym_exec] = ACTIONS(974),
    [anon_sym_type] = ACTIONS(974),
    [anon_sym_class] = ACTIONS(974),
    [anon_sym_LBRACK] = ACTIONS(976),
    [anon_sym_AT] = ACTIONS(976),
    [anon_sym_DASH] = ACTIONS(976),
    [anon_sym_LBRACE] = ACTIONS(976),
    [anon_sym_PLUS] = ACTIONS(976),
    [anon_sym_not] = ACTIONS(974),
    [anon_sym_TILDE] = ACTIONS(976),
    [anon_sym_lambda] = ACTIONS(974),
    [anon_sym_yield] = ACTIONS(974),
    [sym_ellipsis] = ACTIONS(976),
    [sym_integer] = ACTIONS(974),
    [sym_float] = ACTIONS(976),
    [anon_sym_await] = ACTIONS(974),
    [sym_true] = ACTIONS(974),
    [sym_false] = ACTIONS(974),
    [sym_none] = ACTIONS(974),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(974),
    [anon_sym_container] = ACTIONS(974),
    [anon_sym_envvars] = ACTIONS(974),
    [anon_sym_include] = ACTIONS(974),
    [anon_sym_pepfile] = ACTIONS(974),
    [anon_sym_pepschema] = ACTIONS(974),
    [anon_sym_scattergather] = ACTIONS(974),
    [anon_sym_version] = ACTIONS(974),
    [anon_sym_wildcard_constraints] = ACTIONS(974),
    [anon_sym_workdir] = ACTIONS(974),
    [anon_sym_onerror] = ACTIONS(974),
    [anon_sym_onstart] = ACTIONS(974),
    [anon_sym_onsuccess] = ACTIONS(974),
    [anon_sym_localrules] = ACTIONS(974),
    [anon_sym_ruleorder] = ACTIONS(974),
    [anon_sym_rule] = ACTIONS(974),
    [anon_sym_checkpoint] = ACTIONS(974),
    [anon_sym_use] = ACTIONS(974),
    [anon_sym_module] = ACTIONS(974),
    [sym_string_start] = ACTIONS(976),
  },
  [382] = {
    [sym_identifier] = ACTIONS(1392),
    [anon_sym_import] = ACTIONS(1392),
    [anon_sym_from] = ACTIONS(1392),
    [anon_sym_LPAREN] = ACTIONS(1394),
    [anon_sym_STAR] = ACTIONS(1394),
    [anon_sym_print] = ACTIONS(1392),
    [anon_sym_assert] = ACTIONS(1392),
    [anon_sym_return] = ACTIONS(1392),
    [anon_sym_del] = ACTIONS(1392),
    [anon_sym_raise] = ACTIONS(1392),
    [anon_sym_pass] = ACTIONS(1392),
    [anon_sym_break] = ACTIONS(1392),
    [anon_sym_continue] = ACTIONS(1392),
    [anon_sym_if] = ACTIONS(1392),
    [anon_sym_match] = ACTIONS(1392),
    [anon_sym_async] = ACTIONS(1392),
    [anon_sym_for] = ACTIONS(1392),
    [anon_sym_while] = ACTIONS(1392),
    [anon_sym_try] = ACTIONS(1392),
    [anon_sym_with] = ACTIONS(1392),
    [anon_sym_def] = ACTIONS(1392),
    [anon_sym_global] = ACTIONS(1392),
    [anon_sym_nonlocal] = ACTIONS(1392),
    [anon_sym_exec] = ACTIONS(1392),
    [anon_sym_type] = ACTIONS(1392),
    [anon_sym_class] = ACTIONS(1392),
    [anon_sym_LBRACK] = ACTIONS(1394),
    [anon_sym_AT] = ACTIONS(1394),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_LBRACE] = ACTIONS(1394),
    [anon_sym_PLUS] = ACTIONS(1394),
    [anon_sym_not] = ACTIONS(1392),
    [anon_sym_TILDE] = ACTIONS(1394),
    [anon_sym_lambda] = ACTIONS(1392),
    [anon_sym_yield] = ACTIONS(1392),
    [sym_ellipsis] = ACTIONS(1394),
    [sym_integer] = ACTIONS(1392),
    [sym_float] = ACTIONS(1394),
    [anon_sym_await] = ACTIONS(1392),
    [sym_true] = ACTIONS(1392),
    [sym_false] = ACTIONS(1392),
    [sym_none] = ACTIONS(1392),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1392),
    [anon_sym_container] = ACTIONS(1392),
    [anon_sym_envvars] = ACTIONS(1392),
    [anon_sym_include] = ACTIONS(1392),
    [anon_sym_pepfile] = ACTIONS(1392),
    [anon_sym_pepschema] = ACTIONS(1392),
    [anon_sym_scattergather] = ACTIONS(1392),
    [anon_sym_version] = ACTIONS(1392),
    [anon_sym_wildcard_constraints] = ACTIONS(1392),
    [anon_sym_workdir] = ACTIONS(1392),
    [anon_sym_onerror] = ACTIONS(1392),
    [anon_sym_onstart] = ACTIONS(1392),
    [anon_sym_onsuccess] = ACTIONS(1392),
    [anon_sym_localrules] = ACTIONS(1392),
    [anon_sym_ruleorder] = ACTIONS(1392),
    [anon_sym_rule] = ACTIONS(1392),
    [anon_sym_checkpoint] = ACTIONS(1392),
    [anon_sym_use] = ACTIONS(1392),
    [anon_sym_module] = ACTIONS(1392),
    [sym__dedent] = ACTIONS(1394),
    [sym_string_start] = ACTIONS(1394),
  },
  [383] = {
    [sym_identifier] = ACTIONS(1396),
    [anon_sym_import] = ACTIONS(1396),
    [anon_sym_from] = ACTIONS(1396),
    [anon_sym_LPAREN] = ACTIONS(1398),
    [anon_sym_STAR] = ACTIONS(1398),
    [anon_sym_print] = ACTIONS(1396),
    [anon_sym_assert] = ACTIONS(1396),
    [anon_sym_return] = ACTIONS(1396),
    [anon_sym_del] = ACTIONS(1396),
    [anon_sym_raise] = ACTIONS(1396),
    [anon_sym_pass] = ACTIONS(1396),
    [anon_sym_break] = ACTIONS(1396),
    [anon_sym_continue] = ACTIONS(1396),
    [anon_sym_if] = ACTIONS(1396),
    [anon_sym_match] = ACTIONS(1396),
    [anon_sym_async] = ACTIONS(1396),
    [anon_sym_for] = ACTIONS(1396),
    [anon_sym_while] = ACTIONS(1396),
    [anon_sym_try] = ACTIONS(1396),
    [anon_sym_with] = ACTIONS(1396),
    [anon_sym_def] = ACTIONS(1396),
    [anon_sym_global] = ACTIONS(1396),
    [anon_sym_nonlocal] = ACTIONS(1396),
    [anon_sym_exec] = ACTIONS(1396),
    [anon_sym_type] = ACTIONS(1396),
    [anon_sym_class] = ACTIONS(1396),
    [anon_sym_LBRACK] = ACTIONS(1398),
    [anon_sym_AT] = ACTIONS(1398),
    [anon_sym_DASH] = ACTIONS(1398),
    [anon_sym_LBRACE] = ACTIONS(1398),
    [anon_sym_PLUS] = ACTIONS(1398),
    [anon_sym_not] = ACTIONS(1396),
    [anon_sym_TILDE] = ACTIONS(1398),
    [anon_sym_lambda] = ACTIONS(1396),
    [anon_sym_yield] = ACTIONS(1396),
    [sym_ellipsis] = ACTIONS(1398),
    [sym_integer] = ACTIONS(1396),
    [sym_float] = ACTIONS(1398),
    [anon_sym_await] = ACTIONS(1396),
    [sym_true] = ACTIONS(1396),
    [sym_false] = ACTIONS(1396),
    [sym_none] = ACTIONS(1396),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1396),
    [anon_sym_container] = ACTIONS(1396),
    [anon_sym_envvars] = ACTIONS(1396),
    [anon_sym_include] = ACTIONS(1396),
    [anon_sym_pepfile] = ACTIONS(1396),
    [anon_sym_pepschema] = ACTIONS(1396),
    [anon_sym_scattergather] = ACTIONS(1396),
    [anon_sym_version] = ACTIONS(1396),
    [anon_sym_wildcard_constraints] = ACTIONS(1396),
    [anon_sym_workdir] = ACTIONS(1396),
    [anon_sym_onerror] = ACTIONS(1396),
    [anon_sym_onstart] = ACTIONS(1396),
    [anon_sym_onsuccess] = ACTIONS(1396),
    [anon_sym_localrules] = ACTIONS(1396),
    [anon_sym_ruleorder] = ACTIONS(1396),
    [anon_sym_rule] = ACTIONS(1396),
    [anon_sym_checkpoint] = ACTIONS(1396),
    [anon_sym_use] = ACTIONS(1396),
    [anon_sym_module] = ACTIONS(1396),
    [sym__dedent] = ACTIONS(1398),
    [sym_string_start] = ACTIONS(1398),
  },
  [384] = {
    [ts_builtin_sym_end] = ACTIONS(1400),
    [sym_identifier] = ACTIONS(1402),
    [anon_sym_import] = ACTIONS(1402),
    [anon_sym_from] = ACTIONS(1402),
    [anon_sym_LPAREN] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(1400),
    [anon_sym_print] = ACTIONS(1402),
    [anon_sym_assert] = ACTIONS(1402),
    [anon_sym_return] = ACTIONS(1402),
    [anon_sym_del] = ACTIONS(1402),
    [anon_sym_raise] = ACTIONS(1402),
    [anon_sym_pass] = ACTIONS(1402),
    [anon_sym_break] = ACTIONS(1402),
    [anon_sym_continue] = ACTIONS(1402),
    [anon_sym_if] = ACTIONS(1402),
    [anon_sym_match] = ACTIONS(1402),
    [anon_sym_async] = ACTIONS(1402),
    [anon_sym_for] = ACTIONS(1402),
    [anon_sym_while] = ACTIONS(1402),
    [anon_sym_try] = ACTIONS(1402),
    [anon_sym_with] = ACTIONS(1402),
    [anon_sym_def] = ACTIONS(1402),
    [anon_sym_global] = ACTIONS(1402),
    [anon_sym_nonlocal] = ACTIONS(1402),
    [anon_sym_exec] = ACTIONS(1402),
    [anon_sym_type] = ACTIONS(1402),
    [anon_sym_class] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1400),
    [anon_sym_AT] = ACTIONS(1400),
    [anon_sym_DASH] = ACTIONS(1400),
    [anon_sym_LBRACE] = ACTIONS(1400),
    [anon_sym_PLUS] = ACTIONS(1400),
    [anon_sym_not] = ACTIONS(1402),
    [anon_sym_TILDE] = ACTIONS(1400),
    [anon_sym_lambda] = ACTIONS(1402),
    [anon_sym_yield] = ACTIONS(1402),
    [sym_ellipsis] = ACTIONS(1400),
    [sym_integer] = ACTIONS(1402),
    [sym_float] = ACTIONS(1400),
    [anon_sym_await] = ACTIONS(1402),
    [sym_true] = ACTIONS(1402),
    [sym_false] = ACTIONS(1402),
    [sym_none] = ACTIONS(1402),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1402),
    [anon_sym_container] = ACTIONS(1402),
    [anon_sym_envvars] = ACTIONS(1402),
    [anon_sym_include] = ACTIONS(1402),
    [anon_sym_pepfile] = ACTIONS(1402),
    [anon_sym_pepschema] = ACTIONS(1402),
    [anon_sym_scattergather] = ACTIONS(1402),
    [anon_sym_version] = ACTIONS(1402),
    [anon_sym_wildcard_constraints] = ACTIONS(1402),
    [anon_sym_workdir] = ACTIONS(1402),
    [anon_sym_onerror] = ACTIONS(1402),
    [anon_sym_onstart] = ACTIONS(1402),
    [anon_sym_onsuccess] = ACTIONS(1402),
    [anon_sym_localrules] = ACTIONS(1402),
    [anon_sym_ruleorder] = ACTIONS(1402),
    [anon_sym_rule] = ACTIONS(1402),
    [anon_sym_checkpoint] = ACTIONS(1402),
    [anon_sym_use] = ACTIONS(1402),
    [anon_sym_module] = ACTIONS(1402),
    [sym_string_start] = ACTIONS(1400),
  },
  [385] = {
    [ts_builtin_sym_end] = ACTIONS(1404),
    [sym_identifier] = ACTIONS(1406),
    [anon_sym_import] = ACTIONS(1406),
    [anon_sym_from] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1404),
    [anon_sym_STAR] = ACTIONS(1404),
    [anon_sym_print] = ACTIONS(1406),
    [anon_sym_assert] = ACTIONS(1406),
    [anon_sym_return] = ACTIONS(1406),
    [anon_sym_del] = ACTIONS(1406),
    [anon_sym_raise] = ACTIONS(1406),
    [anon_sym_pass] = ACTIONS(1406),
    [anon_sym_break] = ACTIONS(1406),
    [anon_sym_continue] = ACTIONS(1406),
    [anon_sym_if] = ACTIONS(1406),
    [anon_sym_match] = ACTIONS(1406),
    [anon_sym_async] = ACTIONS(1406),
    [anon_sym_for] = ACTIONS(1406),
    [anon_sym_while] = ACTIONS(1406),
    [anon_sym_try] = ACTIONS(1406),
    [anon_sym_with] = ACTIONS(1406),
    [anon_sym_def] = ACTIONS(1406),
    [anon_sym_global] = ACTIONS(1406),
    [anon_sym_nonlocal] = ACTIONS(1406),
    [anon_sym_exec] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_class] = ACTIONS(1406),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_AT] = ACTIONS(1404),
    [anon_sym_DASH] = ACTIONS(1404),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_PLUS] = ACTIONS(1404),
    [anon_sym_not] = ACTIONS(1406),
    [anon_sym_TILDE] = ACTIONS(1404),
    [anon_sym_lambda] = ACTIONS(1406),
    [anon_sym_yield] = ACTIONS(1406),
    [sym_ellipsis] = ACTIONS(1404),
    [sym_integer] = ACTIONS(1406),
    [sym_float] = ACTIONS(1404),
    [anon_sym_await] = ACTIONS(1406),
    [sym_true] = ACTIONS(1406),
    [sym_false] = ACTIONS(1406),
    [sym_none] = ACTIONS(1406),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1406),
    [anon_sym_container] = ACTIONS(1406),
    [anon_sym_envvars] = ACTIONS(1406),
    [anon_sym_include] = ACTIONS(1406),
    [anon_sym_pepfile] = ACTIONS(1406),
    [anon_sym_pepschema] = ACTIONS(1406),
    [anon_sym_scattergather] = ACTIONS(1406),
    [anon_sym_version] = ACTIONS(1406),
    [anon_sym_wildcard_constraints] = ACTIONS(1406),
    [anon_sym_workdir] = ACTIONS(1406),
    [anon_sym_onerror] = ACTIONS(1406),
    [anon_sym_onstart] = ACTIONS(1406),
    [anon_sym_onsuccess] = ACTIONS(1406),
    [anon_sym_localrules] = ACTIONS(1406),
    [anon_sym_ruleorder] = ACTIONS(1406),
    [anon_sym_rule] = ACTIONS(1406),
    [anon_sym_checkpoint] = ACTIONS(1406),
    [anon_sym_use] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [sym_string_start] = ACTIONS(1404),
  },
  [386] = {
    [ts_builtin_sym_end] = ACTIONS(1354),
    [sym_identifier] = ACTIONS(1352),
    [anon_sym_import] = ACTIONS(1352),
    [anon_sym_from] = ACTIONS(1352),
    [anon_sym_LPAREN] = ACTIONS(1354),
    [anon_sym_STAR] = ACTIONS(1354),
    [anon_sym_print] = ACTIONS(1352),
    [anon_sym_assert] = ACTIONS(1352),
    [anon_sym_return] = ACTIONS(1352),
    [anon_sym_del] = ACTIONS(1352),
    [anon_sym_raise] = ACTIONS(1352),
    [anon_sym_pass] = ACTIONS(1352),
    [anon_sym_break] = ACTIONS(1352),
    [anon_sym_continue] = ACTIONS(1352),
    [anon_sym_if] = ACTIONS(1352),
    [anon_sym_match] = ACTIONS(1352),
    [anon_sym_async] = ACTIONS(1352),
    [anon_sym_for] = ACTIONS(1352),
    [anon_sym_while] = ACTIONS(1352),
    [anon_sym_try] = ACTIONS(1352),
    [anon_sym_with] = ACTIONS(1352),
    [anon_sym_def] = ACTIONS(1352),
    [anon_sym_global] = ACTIONS(1352),
    [anon_sym_nonlocal] = ACTIONS(1352),
    [anon_sym_exec] = ACTIONS(1352),
    [anon_sym_type] = ACTIONS(1352),
    [anon_sym_class] = ACTIONS(1352),
    [anon_sym_LBRACK] = ACTIONS(1354),
    [anon_sym_AT] = ACTIONS(1354),
    [anon_sym_DASH] = ACTIONS(1354),
    [anon_sym_LBRACE] = ACTIONS(1354),
    [anon_sym_PLUS] = ACTIONS(1354),
    [anon_sym_not] = ACTIONS(1352),
    [anon_sym_TILDE] = ACTIONS(1354),
    [anon_sym_lambda] = ACTIONS(1352),
    [anon_sym_yield] = ACTIONS(1352),
    [sym_ellipsis] = ACTIONS(1354),
    [sym_integer] = ACTIONS(1352),
    [sym_float] = ACTIONS(1354),
    [anon_sym_await] = ACTIONS(1352),
    [sym_true] = ACTIONS(1352),
    [sym_false] = ACTIONS(1352),
    [sym_none] = ACTIONS(1352),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1352),
    [anon_sym_container] = ACTIONS(1352),
    [anon_sym_envvars] = ACTIONS(1352),
    [anon_sym_include] = ACTIONS(1352),
    [anon_sym_pepfile] = ACTIONS(1352),
    [anon_sym_pepschema] = ACTIONS(1352),
    [anon_sym_scattergather] = ACTIONS(1352),
    [anon_sym_version] = ACTIONS(1352),
    [anon_sym_wildcard_constraints] = ACTIONS(1352),
    [anon_sym_workdir] = ACTIONS(1352),
    [anon_sym_onerror] = ACTIONS(1352),
    [anon_sym_onstart] = ACTIONS(1352),
    [anon_sym_onsuccess] = ACTIONS(1352),
    [anon_sym_localrules] = ACTIONS(1352),
    [anon_sym_ruleorder] = ACTIONS(1352),
    [anon_sym_rule] = ACTIONS(1352),
    [anon_sym_checkpoint] = ACTIONS(1352),
    [anon_sym_use] = ACTIONS(1352),
    [anon_sym_module] = ACTIONS(1352),
    [sym_string_start] = ACTIONS(1354),
  },
  [387] = {
    [ts_builtin_sym_end] = ACTIONS(1408),
    [sym_identifier] = ACTIONS(1410),
    [anon_sym_import] = ACTIONS(1410),
    [anon_sym_from] = ACTIONS(1410),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_STAR] = ACTIONS(1408),
    [anon_sym_print] = ACTIONS(1410),
    [anon_sym_assert] = ACTIONS(1410),
    [anon_sym_return] = ACTIONS(1410),
    [anon_sym_del] = ACTIONS(1410),
    [anon_sym_raise] = ACTIONS(1410),
    [anon_sym_pass] = ACTIONS(1410),
    [anon_sym_break] = ACTIONS(1410),
    [anon_sym_continue] = ACTIONS(1410),
    [anon_sym_if] = ACTIONS(1410),
    [anon_sym_match] = ACTIONS(1410),
    [anon_sym_async] = ACTIONS(1410),
    [anon_sym_for] = ACTIONS(1410),
    [anon_sym_while] = ACTIONS(1410),
    [anon_sym_try] = ACTIONS(1410),
    [anon_sym_with] = ACTIONS(1410),
    [anon_sym_def] = ACTIONS(1410),
    [anon_sym_global] = ACTIONS(1410),
    [anon_sym_nonlocal] = ACTIONS(1410),
    [anon_sym_exec] = ACTIONS(1410),
    [anon_sym_type] = ACTIONS(1410),
    [anon_sym_class] = ACTIONS(1410),
    [anon_sym_LBRACK] = ACTIONS(1408),
    [anon_sym_AT] = ACTIONS(1408),
    [anon_sym_DASH] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(1408),
    [anon_sym_PLUS] = ACTIONS(1408),
    [anon_sym_not] = ACTIONS(1410),
    [anon_sym_TILDE] = ACTIONS(1408),
    [anon_sym_lambda] = ACTIONS(1410),
    [anon_sym_yield] = ACTIONS(1410),
    [sym_ellipsis] = ACTIONS(1408),
    [sym_integer] = ACTIONS(1410),
    [sym_float] = ACTIONS(1408),
    [anon_sym_await] = ACTIONS(1410),
    [sym_true] = ACTIONS(1410),
    [sym_false] = ACTIONS(1410),
    [sym_none] = ACTIONS(1410),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1410),
    [anon_sym_container] = ACTIONS(1410),
    [anon_sym_envvars] = ACTIONS(1410),
    [anon_sym_include] = ACTIONS(1410),
    [anon_sym_pepfile] = ACTIONS(1410),
    [anon_sym_pepschema] = ACTIONS(1410),
    [anon_sym_scattergather] = ACTIONS(1410),
    [anon_sym_version] = ACTIONS(1410),
    [anon_sym_wildcard_constraints] = ACTIONS(1410),
    [anon_sym_workdir] = ACTIONS(1410),
    [anon_sym_onerror] = ACTIONS(1410),
    [anon_sym_onstart] = ACTIONS(1410),
    [anon_sym_onsuccess] = ACTIONS(1410),
    [anon_sym_localrules] = ACTIONS(1410),
    [anon_sym_ruleorder] = ACTIONS(1410),
    [anon_sym_rule] = ACTIONS(1410),
    [anon_sym_checkpoint] = ACTIONS(1410),
    [anon_sym_use] = ACTIONS(1410),
    [anon_sym_module] = ACTIONS(1410),
    [sym_string_start] = ACTIONS(1408),
  },
  [388] = {
    [ts_builtin_sym_end] = ACTIONS(1342),
    [sym_identifier] = ACTIONS(1340),
    [anon_sym_import] = ACTIONS(1340),
    [anon_sym_from] = ACTIONS(1340),
    [anon_sym_LPAREN] = ACTIONS(1342),
    [anon_sym_STAR] = ACTIONS(1342),
    [anon_sym_print] = ACTIONS(1340),
    [anon_sym_assert] = ACTIONS(1340),
    [anon_sym_return] = ACTIONS(1340),
    [anon_sym_del] = ACTIONS(1340),
    [anon_sym_raise] = ACTIONS(1340),
    [anon_sym_pass] = ACTIONS(1340),
    [anon_sym_break] = ACTIONS(1340),
    [anon_sym_continue] = ACTIONS(1340),
    [anon_sym_if] = ACTIONS(1340),
    [anon_sym_match] = ACTIONS(1340),
    [anon_sym_async] = ACTIONS(1340),
    [anon_sym_for] = ACTIONS(1340),
    [anon_sym_while] = ACTIONS(1340),
    [anon_sym_try] = ACTIONS(1340),
    [anon_sym_with] = ACTIONS(1340),
    [anon_sym_def] = ACTIONS(1340),
    [anon_sym_global] = ACTIONS(1340),
    [anon_sym_nonlocal] = ACTIONS(1340),
    [anon_sym_exec] = ACTIONS(1340),
    [anon_sym_type] = ACTIONS(1340),
    [anon_sym_class] = ACTIONS(1340),
    [anon_sym_LBRACK] = ACTIONS(1342),
    [anon_sym_AT] = ACTIONS(1342),
    [anon_sym_DASH] = ACTIONS(1342),
    [anon_sym_LBRACE] = ACTIONS(1342),
    [anon_sym_PLUS] = ACTIONS(1342),
    [anon_sym_not] = ACTIONS(1340),
    [anon_sym_TILDE] = ACTIONS(1342),
    [anon_sym_lambda] = ACTIONS(1340),
    [anon_sym_yield] = ACTIONS(1340),
    [sym_ellipsis] = ACTIONS(1342),
    [sym_integer] = ACTIONS(1340),
    [sym_float] = ACTIONS(1342),
    [anon_sym_await] = ACTIONS(1340),
    [sym_true] = ACTIONS(1340),
    [sym_false] = ACTIONS(1340),
    [sym_none] = ACTIONS(1340),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1340),
    [anon_sym_container] = ACTIONS(1340),
    [anon_sym_envvars] = ACTIONS(1340),
    [anon_sym_include] = ACTIONS(1340),
    [anon_sym_pepfile] = ACTIONS(1340),
    [anon_sym_pepschema] = ACTIONS(1340),
    [anon_sym_scattergather] = ACTIONS(1340),
    [anon_sym_version] = ACTIONS(1340),
    [anon_sym_wildcard_constraints] = ACTIONS(1340),
    [anon_sym_workdir] = ACTIONS(1340),
    [anon_sym_onerror] = ACTIONS(1340),
    [anon_sym_onstart] = ACTIONS(1340),
    [anon_sym_onsuccess] = ACTIONS(1340),
    [anon_sym_localrules] = ACTIONS(1340),
    [anon_sym_ruleorder] = ACTIONS(1340),
    [anon_sym_rule] = ACTIONS(1340),
    [anon_sym_checkpoint] = ACTIONS(1340),
    [anon_sym_use] = ACTIONS(1340),
    [anon_sym_module] = ACTIONS(1340),
    [sym_string_start] = ACTIONS(1342),
  },
  [389] = {
    [sym_identifier] = ACTIONS(1412),
    [anon_sym_import] = ACTIONS(1412),
    [anon_sym_from] = ACTIONS(1412),
    [anon_sym_LPAREN] = ACTIONS(1414),
    [anon_sym_STAR] = ACTIONS(1414),
    [anon_sym_print] = ACTIONS(1412),
    [anon_sym_assert] = ACTIONS(1412),
    [anon_sym_return] = ACTIONS(1412),
    [anon_sym_del] = ACTIONS(1412),
    [anon_sym_raise] = ACTIONS(1412),
    [anon_sym_pass] = ACTIONS(1412),
    [anon_sym_break] = ACTIONS(1412),
    [anon_sym_continue] = ACTIONS(1412),
    [anon_sym_if] = ACTIONS(1412),
    [anon_sym_match] = ACTIONS(1412),
    [anon_sym_async] = ACTIONS(1412),
    [anon_sym_for] = ACTIONS(1412),
    [anon_sym_while] = ACTIONS(1412),
    [anon_sym_try] = ACTIONS(1412),
    [anon_sym_with] = ACTIONS(1412),
    [anon_sym_def] = ACTIONS(1412),
    [anon_sym_global] = ACTIONS(1412),
    [anon_sym_nonlocal] = ACTIONS(1412),
    [anon_sym_exec] = ACTIONS(1412),
    [anon_sym_type] = ACTIONS(1412),
    [anon_sym_class] = ACTIONS(1412),
    [anon_sym_LBRACK] = ACTIONS(1414),
    [anon_sym_AT] = ACTIONS(1414),
    [anon_sym_DASH] = ACTIONS(1414),
    [anon_sym_LBRACE] = ACTIONS(1414),
    [anon_sym_PLUS] = ACTIONS(1414),
    [anon_sym_not] = ACTIONS(1412),
    [anon_sym_TILDE] = ACTIONS(1414),
    [anon_sym_lambda] = ACTIONS(1412),
    [anon_sym_yield] = ACTIONS(1412),
    [sym_ellipsis] = ACTIONS(1414),
    [sym_integer] = ACTIONS(1412),
    [sym_float] = ACTIONS(1414),
    [anon_sym_await] = ACTIONS(1412),
    [sym_true] = ACTIONS(1412),
    [sym_false] = ACTIONS(1412),
    [sym_none] = ACTIONS(1412),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1412),
    [anon_sym_container] = ACTIONS(1412),
    [anon_sym_envvars] = ACTIONS(1412),
    [anon_sym_include] = ACTIONS(1412),
    [anon_sym_pepfile] = ACTIONS(1412),
    [anon_sym_pepschema] = ACTIONS(1412),
    [anon_sym_scattergather] = ACTIONS(1412),
    [anon_sym_version] = ACTIONS(1412),
    [anon_sym_wildcard_constraints] = ACTIONS(1412),
    [anon_sym_workdir] = ACTIONS(1412),
    [anon_sym_onerror] = ACTIONS(1412),
    [anon_sym_onstart] = ACTIONS(1412),
    [anon_sym_onsuccess] = ACTIONS(1412),
    [anon_sym_localrules] = ACTIONS(1412),
    [anon_sym_ruleorder] = ACTIONS(1412),
    [anon_sym_rule] = ACTIONS(1412),
    [anon_sym_checkpoint] = ACTIONS(1412),
    [anon_sym_use] = ACTIONS(1412),
    [anon_sym_module] = ACTIONS(1412),
    [sym__dedent] = ACTIONS(1414),
    [sym_string_start] = ACTIONS(1414),
  },
  [390] = {
    [ts_builtin_sym_end] = ACTIONS(1334),
    [sym_identifier] = ACTIONS(1332),
    [anon_sym_import] = ACTIONS(1332),
    [anon_sym_from] = ACTIONS(1332),
    [anon_sym_LPAREN] = ACTIONS(1334),
    [anon_sym_STAR] = ACTIONS(1334),
    [anon_sym_print] = ACTIONS(1332),
    [anon_sym_assert] = ACTIONS(1332),
    [anon_sym_return] = ACTIONS(1332),
    [anon_sym_del] = ACTIONS(1332),
    [anon_sym_raise] = ACTIONS(1332),
    [anon_sym_pass] = ACTIONS(1332),
    [anon_sym_break] = ACTIONS(1332),
    [anon_sym_continue] = ACTIONS(1332),
    [anon_sym_if] = ACTIONS(1332),
    [anon_sym_match] = ACTIONS(1332),
    [anon_sym_async] = ACTIONS(1332),
    [anon_sym_for] = ACTIONS(1332),
    [anon_sym_while] = ACTIONS(1332),
    [anon_sym_try] = ACTIONS(1332),
    [anon_sym_with] = ACTIONS(1332),
    [anon_sym_def] = ACTIONS(1332),
    [anon_sym_global] = ACTIONS(1332),
    [anon_sym_nonlocal] = ACTIONS(1332),
    [anon_sym_exec] = ACTIONS(1332),
    [anon_sym_type] = ACTIONS(1332),
    [anon_sym_class] = ACTIONS(1332),
    [anon_sym_LBRACK] = ACTIONS(1334),
    [anon_sym_AT] = ACTIONS(1334),
    [anon_sym_DASH] = ACTIONS(1334),
    [anon_sym_LBRACE] = ACTIONS(1334),
    [anon_sym_PLUS] = ACTIONS(1334),
    [anon_sym_not] = ACTIONS(1332),
    [anon_sym_TILDE] = ACTIONS(1334),
    [anon_sym_lambda] = ACTIONS(1332),
    [anon_sym_yield] = ACTIONS(1332),
    [sym_ellipsis] = ACTIONS(1334),
    [sym_integer] = ACTIONS(1332),
    [sym_float] = ACTIONS(1334),
    [anon_sym_await] = ACTIONS(1332),
    [sym_true] = ACTIONS(1332),
    [sym_false] = ACTIONS(1332),
    [sym_none] = ACTIONS(1332),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1332),
    [anon_sym_container] = ACTIONS(1332),
    [anon_sym_envvars] = ACTIONS(1332),
    [anon_sym_include] = ACTIONS(1332),
    [anon_sym_pepfile] = ACTIONS(1332),
    [anon_sym_pepschema] = ACTIONS(1332),
    [anon_sym_scattergather] = ACTIONS(1332),
    [anon_sym_version] = ACTIONS(1332),
    [anon_sym_wildcard_constraints] = ACTIONS(1332),
    [anon_sym_workdir] = ACTIONS(1332),
    [anon_sym_onerror] = ACTIONS(1332),
    [anon_sym_onstart] = ACTIONS(1332),
    [anon_sym_onsuccess] = ACTIONS(1332),
    [anon_sym_localrules] = ACTIONS(1332),
    [anon_sym_ruleorder] = ACTIONS(1332),
    [anon_sym_rule] = ACTIONS(1332),
    [anon_sym_checkpoint] = ACTIONS(1332),
    [anon_sym_use] = ACTIONS(1332),
    [anon_sym_module] = ACTIONS(1332),
    [sym_string_start] = ACTIONS(1334),
  },
  [391] = {
    [sym_identifier] = ACTIONS(1144),
    [anon_sym_import] = ACTIONS(1144),
    [anon_sym_from] = ACTIONS(1144),
    [anon_sym_LPAREN] = ACTIONS(1146),
    [anon_sym_STAR] = ACTIONS(1146),
    [anon_sym_print] = ACTIONS(1144),
    [anon_sym_assert] = ACTIONS(1144),
    [anon_sym_return] = ACTIONS(1144),
    [anon_sym_del] = ACTIONS(1144),
    [anon_sym_raise] = ACTIONS(1144),
    [anon_sym_pass] = ACTIONS(1144),
    [anon_sym_break] = ACTIONS(1144),
    [anon_sym_continue] = ACTIONS(1144),
    [anon_sym_if] = ACTIONS(1144),
    [anon_sym_match] = ACTIONS(1144),
    [anon_sym_async] = ACTIONS(1144),
    [anon_sym_for] = ACTIONS(1144),
    [anon_sym_while] = ACTIONS(1144),
    [anon_sym_try] = ACTIONS(1144),
    [anon_sym_with] = ACTIONS(1144),
    [anon_sym_def] = ACTIONS(1144),
    [anon_sym_global] = ACTIONS(1144),
    [anon_sym_nonlocal] = ACTIONS(1144),
    [anon_sym_exec] = ACTIONS(1144),
    [anon_sym_type] = ACTIONS(1144),
    [anon_sym_class] = ACTIONS(1144),
    [anon_sym_LBRACK] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(1146),
    [anon_sym_DASH] = ACTIONS(1146),
    [anon_sym_LBRACE] = ACTIONS(1146),
    [anon_sym_PLUS] = ACTIONS(1146),
    [anon_sym_not] = ACTIONS(1144),
    [anon_sym_TILDE] = ACTIONS(1146),
    [anon_sym_lambda] = ACTIONS(1144),
    [anon_sym_yield] = ACTIONS(1144),
    [sym_ellipsis] = ACTIONS(1146),
    [sym_integer] = ACTIONS(1144),
    [sym_float] = ACTIONS(1146),
    [anon_sym_await] = ACTIONS(1144),
    [sym_true] = ACTIONS(1144),
    [sym_false] = ACTIONS(1144),
    [sym_none] = ACTIONS(1144),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1144),
    [anon_sym_container] = ACTIONS(1144),
    [anon_sym_envvars] = ACTIONS(1144),
    [anon_sym_include] = ACTIONS(1144),
    [anon_sym_pepfile] = ACTIONS(1144),
    [anon_sym_pepschema] = ACTIONS(1144),
    [anon_sym_scattergather] = ACTIONS(1144),
    [anon_sym_version] = ACTIONS(1144),
    [anon_sym_wildcard_constraints] = ACTIONS(1144),
    [anon_sym_workdir] = ACTIONS(1144),
    [anon_sym_onerror] = ACTIONS(1144),
    [anon_sym_onstart] = ACTIONS(1144),
    [anon_sym_onsuccess] = ACTIONS(1144),
    [anon_sym_localrules] = ACTIONS(1144),
    [anon_sym_ruleorder] = ACTIONS(1144),
    [anon_sym_rule] = ACTIONS(1144),
    [anon_sym_checkpoint] = ACTIONS(1144),
    [anon_sym_use] = ACTIONS(1144),
    [anon_sym_module] = ACTIONS(1144),
    [sym__dedent] = ACTIONS(1146),
    [sym_string_start] = ACTIONS(1146),
  },
  [392] = {
    [ts_builtin_sym_end] = ACTIONS(1416),
    [sym_identifier] = ACTIONS(1418),
    [anon_sym_import] = ACTIONS(1418),
    [anon_sym_from] = ACTIONS(1418),
    [anon_sym_LPAREN] = ACTIONS(1416),
    [anon_sym_STAR] = ACTIONS(1416),
    [anon_sym_print] = ACTIONS(1418),
    [anon_sym_assert] = ACTIONS(1418),
    [anon_sym_return] = ACTIONS(1418),
    [anon_sym_del] = ACTIONS(1418),
    [anon_sym_raise] = ACTIONS(1418),
    [anon_sym_pass] = ACTIONS(1418),
    [anon_sym_break] = ACTIONS(1418),
    [anon_sym_continue] = ACTIONS(1418),
    [anon_sym_if] = ACTIONS(1418),
    [anon_sym_match] = ACTIONS(1418),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_for] = ACTIONS(1418),
    [anon_sym_while] = ACTIONS(1418),
    [anon_sym_try] = ACTIONS(1418),
    [anon_sym_with] = ACTIONS(1418),
    [anon_sym_def] = ACTIONS(1418),
    [anon_sym_global] = ACTIONS(1418),
    [anon_sym_nonlocal] = ACTIONS(1418),
    [anon_sym_exec] = ACTIONS(1418),
    [anon_sym_type] = ACTIONS(1418),
    [anon_sym_class] = ACTIONS(1418),
    [anon_sym_LBRACK] = ACTIONS(1416),
    [anon_sym_AT] = ACTIONS(1416),
    [anon_sym_DASH] = ACTIONS(1416),
    [anon_sym_LBRACE] = ACTIONS(1416),
    [anon_sym_PLUS] = ACTIONS(1416),
    [anon_sym_not] = ACTIONS(1418),
    [anon_sym_TILDE] = ACTIONS(1416),
    [anon_sym_lambda] = ACTIONS(1418),
    [anon_sym_yield] = ACTIONS(1418),
    [sym_ellipsis] = ACTIONS(1416),
    [sym_integer] = ACTIONS(1418),
    [sym_float] = ACTIONS(1416),
    [anon_sym_await] = ACTIONS(1418),
    [sym_true] = ACTIONS(1418),
    [sym_false] = ACTIONS(1418),
    [sym_none] = ACTIONS(1418),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1418),
    [anon_sym_container] = ACTIONS(1418),
    [anon_sym_envvars] = ACTIONS(1418),
    [anon_sym_include] = ACTIONS(1418),
    [anon_sym_pepfile] = ACTIONS(1418),
    [anon_sym_pepschema] = ACTIONS(1418),
    [anon_sym_scattergather] = ACTIONS(1418),
    [anon_sym_version] = ACTIONS(1418),
    [anon_sym_wildcard_constraints] = ACTIONS(1418),
    [anon_sym_workdir] = ACTIONS(1418),
    [anon_sym_onerror] = ACTIONS(1418),
    [anon_sym_onstart] = ACTIONS(1418),
    [anon_sym_onsuccess] = ACTIONS(1418),
    [anon_sym_localrules] = ACTIONS(1418),
    [anon_sym_ruleorder] = ACTIONS(1418),
    [anon_sym_rule] = ACTIONS(1418),
    [anon_sym_checkpoint] = ACTIONS(1418),
    [anon_sym_use] = ACTIONS(1418),
    [anon_sym_module] = ACTIONS(1418),
    [sym_string_start] = ACTIONS(1416),
  },
  [393] = {
    [sym_identifier] = ACTIONS(1358),
    [anon_sym_import] = ACTIONS(1358),
    [anon_sym_from] = ACTIONS(1358),
    [anon_sym_LPAREN] = ACTIONS(1356),
    [anon_sym_STAR] = ACTIONS(1356),
    [anon_sym_print] = ACTIONS(1358),
    [anon_sym_assert] = ACTIONS(1358),
    [anon_sym_return] = ACTIONS(1358),
    [anon_sym_del] = ACTIONS(1358),
    [anon_sym_raise] = ACTIONS(1358),
    [anon_sym_pass] = ACTIONS(1358),
    [anon_sym_break] = ACTIONS(1358),
    [anon_sym_continue] = ACTIONS(1358),
    [anon_sym_if] = ACTIONS(1358),
    [anon_sym_match] = ACTIONS(1358),
    [anon_sym_async] = ACTIONS(1358),
    [anon_sym_for] = ACTIONS(1358),
    [anon_sym_while] = ACTIONS(1358),
    [anon_sym_try] = ACTIONS(1358),
    [anon_sym_with] = ACTIONS(1358),
    [anon_sym_def] = ACTIONS(1358),
    [anon_sym_global] = ACTIONS(1358),
    [anon_sym_nonlocal] = ACTIONS(1358),
    [anon_sym_exec] = ACTIONS(1358),
    [anon_sym_type] = ACTIONS(1358),
    [anon_sym_class] = ACTIONS(1358),
    [anon_sym_LBRACK] = ACTIONS(1356),
    [anon_sym_AT] = ACTIONS(1356),
    [anon_sym_DASH] = ACTIONS(1356),
    [anon_sym_LBRACE] = ACTIONS(1356),
    [anon_sym_PLUS] = ACTIONS(1356),
    [anon_sym_not] = ACTIONS(1358),
    [anon_sym_TILDE] = ACTIONS(1356),
    [anon_sym_lambda] = ACTIONS(1358),
    [anon_sym_yield] = ACTIONS(1358),
    [sym_ellipsis] = ACTIONS(1356),
    [sym_integer] = ACTIONS(1358),
    [sym_float] = ACTIONS(1356),
    [anon_sym_await] = ACTIONS(1358),
    [sym_true] = ACTIONS(1358),
    [sym_false] = ACTIONS(1358),
    [sym_none] = ACTIONS(1358),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1358),
    [anon_sym_container] = ACTIONS(1358),
    [anon_sym_envvars] = ACTIONS(1358),
    [anon_sym_include] = ACTIONS(1358),
    [anon_sym_pepfile] = ACTIONS(1358),
    [anon_sym_pepschema] = ACTIONS(1358),
    [anon_sym_scattergather] = ACTIONS(1358),
    [anon_sym_version] = ACTIONS(1358),
    [anon_sym_wildcard_constraints] = ACTIONS(1358),
    [anon_sym_workdir] = ACTIONS(1358),
    [anon_sym_onerror] = ACTIONS(1358),
    [anon_sym_onstart] = ACTIONS(1358),
    [anon_sym_onsuccess] = ACTIONS(1358),
    [anon_sym_localrules] = ACTIONS(1358),
    [anon_sym_ruleorder] = ACTIONS(1358),
    [anon_sym_rule] = ACTIONS(1358),
    [anon_sym_checkpoint] = ACTIONS(1358),
    [anon_sym_use] = ACTIONS(1358),
    [anon_sym_module] = ACTIONS(1358),
    [sym__dedent] = ACTIONS(1356),
    [sym_string_start] = ACTIONS(1356),
  },
  [394] = {
    [ts_builtin_sym_end] = ACTIONS(1302),
    [sym_identifier] = ACTIONS(1300),
    [anon_sym_import] = ACTIONS(1300),
    [anon_sym_from] = ACTIONS(1300),
    [anon_sym_LPAREN] = ACTIONS(1302),
    [anon_sym_STAR] = ACTIONS(1302),
    [anon_sym_print] = ACTIONS(1300),
    [anon_sym_assert] = ACTIONS(1300),
    [anon_sym_return] = ACTIONS(1300),
    [anon_sym_del] = ACTIONS(1300),
    [anon_sym_raise] = ACTIONS(1300),
    [anon_sym_pass] = ACTIONS(1300),
    [anon_sym_break] = ACTIONS(1300),
    [anon_sym_continue] = ACTIONS(1300),
    [anon_sym_if] = ACTIONS(1300),
    [anon_sym_match] = ACTIONS(1300),
    [anon_sym_async] = ACTIONS(1300),
    [anon_sym_for] = ACTIONS(1300),
    [anon_sym_while] = ACTIONS(1300),
    [anon_sym_try] = ACTIONS(1300),
    [anon_sym_with] = ACTIONS(1300),
    [anon_sym_def] = ACTIONS(1300),
    [anon_sym_global] = ACTIONS(1300),
    [anon_sym_nonlocal] = ACTIONS(1300),
    [anon_sym_exec] = ACTIONS(1300),
    [anon_sym_type] = ACTIONS(1300),
    [anon_sym_class] = ACTIONS(1300),
    [anon_sym_LBRACK] = ACTIONS(1302),
    [anon_sym_AT] = ACTIONS(1302),
    [anon_sym_DASH] = ACTIONS(1302),
    [anon_sym_LBRACE] = ACTIONS(1302),
    [anon_sym_PLUS] = ACTIONS(1302),
    [anon_sym_not] = ACTIONS(1300),
    [anon_sym_TILDE] = ACTIONS(1302),
    [anon_sym_lambda] = ACTIONS(1300),
    [anon_sym_yield] = ACTIONS(1300),
    [sym_ellipsis] = ACTIONS(1302),
    [sym_integer] = ACTIONS(1300),
    [sym_float] = ACTIONS(1302),
    [anon_sym_await] = ACTIONS(1300),
    [sym_true] = ACTIONS(1300),
    [sym_false] = ACTIONS(1300),
    [sym_none] = ACTIONS(1300),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1300),
    [anon_sym_container] = ACTIONS(1300),
    [anon_sym_envvars] = ACTIONS(1300),
    [anon_sym_include] = ACTIONS(1300),
    [anon_sym_pepfile] = ACTIONS(1300),
    [anon_sym_pepschema] = ACTIONS(1300),
    [anon_sym_scattergather] = ACTIONS(1300),
    [anon_sym_version] = ACTIONS(1300),
    [anon_sym_wildcard_constraints] = ACTIONS(1300),
    [anon_sym_workdir] = ACTIONS(1300),
    [anon_sym_onerror] = ACTIONS(1300),
    [anon_sym_onstart] = ACTIONS(1300),
    [anon_sym_onsuccess] = ACTIONS(1300),
    [anon_sym_localrules] = ACTIONS(1300),
    [anon_sym_ruleorder] = ACTIONS(1300),
    [anon_sym_rule] = ACTIONS(1300),
    [anon_sym_checkpoint] = ACTIONS(1300),
    [anon_sym_use] = ACTIONS(1300),
    [anon_sym_module] = ACTIONS(1300),
    [sym_string_start] = ACTIONS(1302),
  },
  [395] = {
    [ts_builtin_sym_end] = ACTIONS(1420),
    [sym_identifier] = ACTIONS(1422),
    [anon_sym_import] = ACTIONS(1422),
    [anon_sym_from] = ACTIONS(1422),
    [anon_sym_LPAREN] = ACTIONS(1420),
    [anon_sym_STAR] = ACTIONS(1420),
    [anon_sym_print] = ACTIONS(1422),
    [anon_sym_assert] = ACTIONS(1422),
    [anon_sym_return] = ACTIONS(1422),
    [anon_sym_del] = ACTIONS(1422),
    [anon_sym_raise] = ACTIONS(1422),
    [anon_sym_pass] = ACTIONS(1422),
    [anon_sym_break] = ACTIONS(1422),
    [anon_sym_continue] = ACTIONS(1422),
    [anon_sym_if] = ACTIONS(1422),
    [anon_sym_match] = ACTIONS(1422),
    [anon_sym_async] = ACTIONS(1422),
    [anon_sym_for] = ACTIONS(1422),
    [anon_sym_while] = ACTIONS(1422),
    [anon_sym_try] = ACTIONS(1422),
    [anon_sym_with] = ACTIONS(1424),
    [anon_sym_def] = ACTIONS(1422),
    [anon_sym_global] = ACTIONS(1422),
    [anon_sym_nonlocal] = ACTIONS(1422),
    [anon_sym_exec] = ACTIONS(1422),
    [anon_sym_type] = ACTIONS(1422),
    [anon_sym_class] = ACTIONS(1422),
    [anon_sym_LBRACK] = ACTIONS(1420),
    [anon_sym_AT] = ACTIONS(1420),
    [anon_sym_DASH] = ACTIONS(1420),
    [anon_sym_LBRACE] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(1420),
    [anon_sym_not] = ACTIONS(1422),
    [anon_sym_TILDE] = ACTIONS(1420),
    [anon_sym_lambda] = ACTIONS(1422),
    [anon_sym_yield] = ACTIONS(1422),
    [sym_ellipsis] = ACTIONS(1420),
    [sym_integer] = ACTIONS(1422),
    [sym_float] = ACTIONS(1420),
    [anon_sym_await] = ACTIONS(1422),
    [sym_true] = ACTIONS(1422),
    [sym_false] = ACTIONS(1422),
    [sym_none] = ACTIONS(1422),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1422),
    [anon_sym_container] = ACTIONS(1422),
    [anon_sym_envvars] = ACTIONS(1422),
    [anon_sym_include] = ACTIONS(1422),
    [anon_sym_pepfile] = ACTIONS(1422),
    [anon_sym_pepschema] = ACTIONS(1422),
    [anon_sym_scattergather] = ACTIONS(1422),
    [anon_sym_version] = ACTIONS(1422),
    [anon_sym_wildcard_constraints] = ACTIONS(1422),
    [anon_sym_workdir] = ACTIONS(1422),
    [anon_sym_onerror] = ACTIONS(1422),
    [anon_sym_onstart] = ACTIONS(1422),
    [anon_sym_onsuccess] = ACTIONS(1422),
    [anon_sym_localrules] = ACTIONS(1422),
    [anon_sym_ruleorder] = ACTIONS(1422),
    [anon_sym_rule] = ACTIONS(1422),
    [anon_sym_checkpoint] = ACTIONS(1422),
    [anon_sym_use] = ACTIONS(1422),
    [anon_sym_module] = ACTIONS(1422),
    [sym_string_start] = ACTIONS(1420),
  },
  [396] = {
    [sym_identifier] = ACTIONS(1426),
    [anon_sym_import] = ACTIONS(1426),
    [anon_sym_from] = ACTIONS(1426),
    [anon_sym_LPAREN] = ACTIONS(1428),
    [anon_sym_STAR] = ACTIONS(1428),
    [anon_sym_print] = ACTIONS(1426),
    [anon_sym_assert] = ACTIONS(1426),
    [anon_sym_return] = ACTIONS(1426),
    [anon_sym_del] = ACTIONS(1426),
    [anon_sym_raise] = ACTIONS(1426),
    [anon_sym_pass] = ACTIONS(1426),
    [anon_sym_break] = ACTIONS(1426),
    [anon_sym_continue] = ACTIONS(1426),
    [anon_sym_if] = ACTIONS(1426),
    [anon_sym_match] = ACTIONS(1426),
    [anon_sym_async] = ACTIONS(1426),
    [anon_sym_for] = ACTIONS(1426),
    [anon_sym_while] = ACTIONS(1426),
    [anon_sym_try] = ACTIONS(1426),
    [anon_sym_with] = ACTIONS(1426),
    [anon_sym_def] = ACTIONS(1426),
    [anon_sym_global] = ACTIONS(1426),
    [anon_sym_nonlocal] = ACTIONS(1426),
    [anon_sym_exec] = ACTIONS(1426),
    [anon_sym_type] = ACTIONS(1426),
    [anon_sym_class] = ACTIONS(1426),
    [anon_sym_LBRACK] = ACTIONS(1428),
    [anon_sym_AT] = ACTIONS(1428),
    [anon_sym_DASH] = ACTIONS(1428),
    [anon_sym_LBRACE] = ACTIONS(1428),
    [anon_sym_PLUS] = ACTIONS(1428),
    [anon_sym_not] = ACTIONS(1426),
    [anon_sym_TILDE] = ACTIONS(1428),
    [anon_sym_lambda] = ACTIONS(1426),
    [anon_sym_yield] = ACTIONS(1426),
    [sym_ellipsis] = ACTIONS(1428),
    [sym_integer] = ACTIONS(1426),
    [sym_float] = ACTIONS(1428),
    [anon_sym_await] = ACTIONS(1426),
    [sym_true] = ACTIONS(1426),
    [sym_false] = ACTIONS(1426),
    [sym_none] = ACTIONS(1426),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1426),
    [anon_sym_container] = ACTIONS(1426),
    [anon_sym_envvars] = ACTIONS(1426),
    [anon_sym_include] = ACTIONS(1426),
    [anon_sym_pepfile] = ACTIONS(1426),
    [anon_sym_pepschema] = ACTIONS(1426),
    [anon_sym_scattergather] = ACTIONS(1426),
    [anon_sym_version] = ACTIONS(1426),
    [anon_sym_wildcard_constraints] = ACTIONS(1426),
    [anon_sym_workdir] = ACTIONS(1426),
    [anon_sym_onerror] = ACTIONS(1426),
    [anon_sym_onstart] = ACTIONS(1426),
    [anon_sym_onsuccess] = ACTIONS(1426),
    [anon_sym_localrules] = ACTIONS(1426),
    [anon_sym_ruleorder] = ACTIONS(1426),
    [anon_sym_rule] = ACTIONS(1426),
    [anon_sym_checkpoint] = ACTIONS(1426),
    [anon_sym_use] = ACTIONS(1426),
    [anon_sym_module] = ACTIONS(1426),
    [sym__dedent] = ACTIONS(1428),
    [sym_string_start] = ACTIONS(1428),
  },
  [397] = {
    [sym_identifier] = ACTIONS(1350),
    [anon_sym_import] = ACTIONS(1350),
    [anon_sym_from] = ACTIONS(1350),
    [anon_sym_LPAREN] = ACTIONS(1348),
    [anon_sym_STAR] = ACTIONS(1348),
    [anon_sym_print] = ACTIONS(1350),
    [anon_sym_assert] = ACTIONS(1350),
    [anon_sym_return] = ACTIONS(1350),
    [anon_sym_del] = ACTIONS(1350),
    [anon_sym_raise] = ACTIONS(1350),
    [anon_sym_pass] = ACTIONS(1350),
    [anon_sym_break] = ACTIONS(1350),
    [anon_sym_continue] = ACTIONS(1350),
    [anon_sym_if] = ACTIONS(1350),
    [anon_sym_match] = ACTIONS(1350),
    [anon_sym_async] = ACTIONS(1350),
    [anon_sym_for] = ACTIONS(1350),
    [anon_sym_while] = ACTIONS(1350),
    [anon_sym_try] = ACTIONS(1350),
    [anon_sym_with] = ACTIONS(1350),
    [anon_sym_def] = ACTIONS(1350),
    [anon_sym_global] = ACTIONS(1350),
    [anon_sym_nonlocal] = ACTIONS(1350),
    [anon_sym_exec] = ACTIONS(1350),
    [anon_sym_type] = ACTIONS(1350),
    [anon_sym_class] = ACTIONS(1350),
    [anon_sym_LBRACK] = ACTIONS(1348),
    [anon_sym_AT] = ACTIONS(1348),
    [anon_sym_DASH] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(1348),
    [anon_sym_PLUS] = ACTIONS(1348),
    [anon_sym_not] = ACTIONS(1350),
    [anon_sym_TILDE] = ACTIONS(1348),
    [anon_sym_lambda] = ACTIONS(1350),
    [anon_sym_yield] = ACTIONS(1350),
    [sym_ellipsis] = ACTIONS(1348),
    [sym_integer] = ACTIONS(1350),
    [sym_float] = ACTIONS(1348),
    [anon_sym_await] = ACTIONS(1350),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [sym_none] = ACTIONS(1350),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1350),
    [anon_sym_container] = ACTIONS(1350),
    [anon_sym_envvars] = ACTIONS(1350),
    [anon_sym_include] = ACTIONS(1350),
    [anon_sym_pepfile] = ACTIONS(1350),
    [anon_sym_pepschema] = ACTIONS(1350),
    [anon_sym_scattergather] = ACTIONS(1350),
    [anon_sym_version] = ACTIONS(1350),
    [anon_sym_wildcard_constraints] = ACTIONS(1350),
    [anon_sym_workdir] = ACTIONS(1350),
    [anon_sym_onerror] = ACTIONS(1350),
    [anon_sym_onstart] = ACTIONS(1350),
    [anon_sym_onsuccess] = ACTIONS(1350),
    [anon_sym_localrules] = ACTIONS(1350),
    [anon_sym_ruleorder] = ACTIONS(1350),
    [anon_sym_rule] = ACTIONS(1350),
    [anon_sym_checkpoint] = ACTIONS(1350),
    [anon_sym_use] = ACTIONS(1350),
    [anon_sym_module] = ACTIONS(1350),
    [sym__dedent] = ACTIONS(1348),
    [sym_string_start] = ACTIONS(1348),
  },
  [398] = {
    [ts_builtin_sym_end] = ACTIONS(1278),
    [sym_identifier] = ACTIONS(1276),
    [anon_sym_import] = ACTIONS(1276),
    [anon_sym_from] = ACTIONS(1276),
    [anon_sym_LPAREN] = ACTIONS(1278),
    [anon_sym_STAR] = ACTIONS(1278),
    [anon_sym_print] = ACTIONS(1276),
    [anon_sym_assert] = ACTIONS(1276),
    [anon_sym_return] = ACTIONS(1276),
    [anon_sym_del] = ACTIONS(1276),
    [anon_sym_raise] = ACTIONS(1276),
    [anon_sym_pass] = ACTIONS(1276),
    [anon_sym_break] = ACTIONS(1276),
    [anon_sym_continue] = ACTIONS(1276),
    [anon_sym_if] = ACTIONS(1276),
    [anon_sym_match] = ACTIONS(1276),
    [anon_sym_async] = ACTIONS(1276),
    [anon_sym_for] = ACTIONS(1276),
    [anon_sym_while] = ACTIONS(1276),
    [anon_sym_try] = ACTIONS(1276),
    [anon_sym_with] = ACTIONS(1276),
    [anon_sym_def] = ACTIONS(1276),
    [anon_sym_global] = ACTIONS(1276),
    [anon_sym_nonlocal] = ACTIONS(1276),
    [anon_sym_exec] = ACTIONS(1276),
    [anon_sym_type] = ACTIONS(1276),
    [anon_sym_class] = ACTIONS(1276),
    [anon_sym_LBRACK] = ACTIONS(1278),
    [anon_sym_AT] = ACTIONS(1278),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_LBRACE] = ACTIONS(1278),
    [anon_sym_PLUS] = ACTIONS(1278),
    [anon_sym_not] = ACTIONS(1276),
    [anon_sym_TILDE] = ACTIONS(1278),
    [anon_sym_lambda] = ACTIONS(1276),
    [anon_sym_yield] = ACTIONS(1276),
    [sym_ellipsis] = ACTIONS(1278),
    [sym_integer] = ACTIONS(1276),
    [sym_float] = ACTIONS(1278),
    [anon_sym_await] = ACTIONS(1276),
    [sym_true] = ACTIONS(1276),
    [sym_false] = ACTIONS(1276),
    [sym_none] = ACTIONS(1276),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1276),
    [anon_sym_container] = ACTIONS(1276),
    [anon_sym_envvars] = ACTIONS(1276),
    [anon_sym_include] = ACTIONS(1276),
    [anon_sym_pepfile] = ACTIONS(1276),
    [anon_sym_pepschema] = ACTIONS(1276),
    [anon_sym_scattergather] = ACTIONS(1276),
    [anon_sym_version] = ACTIONS(1276),
    [anon_sym_wildcard_constraints] = ACTIONS(1276),
    [anon_sym_workdir] = ACTIONS(1276),
    [anon_sym_onerror] = ACTIONS(1276),
    [anon_sym_onstart] = ACTIONS(1276),
    [anon_sym_onsuccess] = ACTIONS(1276),
    [anon_sym_localrules] = ACTIONS(1276),
    [anon_sym_ruleorder] = ACTIONS(1276),
    [anon_sym_rule] = ACTIONS(1276),
    [anon_sym_checkpoint] = ACTIONS(1276),
    [anon_sym_use] = ACTIONS(1276),
    [anon_sym_module] = ACTIONS(1276),
    [sym_string_start] = ACTIONS(1278),
  },
  [399] = {
    [sym_identifier] = ACTIONS(1346),
    [anon_sym_import] = ACTIONS(1346),
    [anon_sym_from] = ACTIONS(1346),
    [anon_sym_LPAREN] = ACTIONS(1344),
    [anon_sym_STAR] = ACTIONS(1344),
    [anon_sym_print] = ACTIONS(1346),
    [anon_sym_assert] = ACTIONS(1346),
    [anon_sym_return] = ACTIONS(1346),
    [anon_sym_del] = ACTIONS(1346),
    [anon_sym_raise] = ACTIONS(1346),
    [anon_sym_pass] = ACTIONS(1346),
    [anon_sym_break] = ACTIONS(1346),
    [anon_sym_continue] = ACTIONS(1346),
    [anon_sym_if] = ACTIONS(1346),
    [anon_sym_match] = ACTIONS(1346),
    [anon_sym_async] = ACTIONS(1346),
    [anon_sym_for] = ACTIONS(1346),
    [anon_sym_while] = ACTIONS(1346),
    [anon_sym_try] = ACTIONS(1346),
    [anon_sym_with] = ACTIONS(1346),
    [anon_sym_def] = ACTIONS(1346),
    [anon_sym_global] = ACTIONS(1346),
    [anon_sym_nonlocal] = ACTIONS(1346),
    [anon_sym_exec] = ACTIONS(1346),
    [anon_sym_type] = ACTIONS(1346),
    [anon_sym_class] = ACTIONS(1346),
    [anon_sym_LBRACK] = ACTIONS(1344),
    [anon_sym_AT] = ACTIONS(1344),
    [anon_sym_DASH] = ACTIONS(1344),
    [anon_sym_LBRACE] = ACTIONS(1344),
    [anon_sym_PLUS] = ACTIONS(1344),
    [anon_sym_not] = ACTIONS(1346),
    [anon_sym_TILDE] = ACTIONS(1344),
    [anon_sym_lambda] = ACTIONS(1346),
    [anon_sym_yield] = ACTIONS(1346),
    [sym_ellipsis] = ACTIONS(1344),
    [sym_integer] = ACTIONS(1346),
    [sym_float] = ACTIONS(1344),
    [anon_sym_await] = ACTIONS(1346),
    [sym_true] = ACTIONS(1346),
    [sym_false] = ACTIONS(1346),
    [sym_none] = ACTIONS(1346),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1346),
    [anon_sym_container] = ACTIONS(1346),
    [anon_sym_envvars] = ACTIONS(1346),
    [anon_sym_include] = ACTIONS(1346),
    [anon_sym_pepfile] = ACTIONS(1346),
    [anon_sym_pepschema] = ACTIONS(1346),
    [anon_sym_scattergather] = ACTIONS(1346),
    [anon_sym_version] = ACTIONS(1346),
    [anon_sym_wildcard_constraints] = ACTIONS(1346),
    [anon_sym_workdir] = ACTIONS(1346),
    [anon_sym_onerror] = ACTIONS(1346),
    [anon_sym_onstart] = ACTIONS(1346),
    [anon_sym_onsuccess] = ACTIONS(1346),
    [anon_sym_localrules] = ACTIONS(1346),
    [anon_sym_ruleorder] = ACTIONS(1346),
    [anon_sym_rule] = ACTIONS(1346),
    [anon_sym_checkpoint] = ACTIONS(1346),
    [anon_sym_use] = ACTIONS(1346),
    [anon_sym_module] = ACTIONS(1346),
    [sym__dedent] = ACTIONS(1344),
    [sym_string_start] = ACTIONS(1344),
  },
  [400] = {
    [ts_builtin_sym_end] = ACTIONS(1274),
    [sym_identifier] = ACTIONS(1272),
    [anon_sym_import] = ACTIONS(1272),
    [anon_sym_from] = ACTIONS(1272),
    [anon_sym_LPAREN] = ACTIONS(1274),
    [anon_sym_STAR] = ACTIONS(1274),
    [anon_sym_print] = ACTIONS(1272),
    [anon_sym_assert] = ACTIONS(1272),
    [anon_sym_return] = ACTIONS(1272),
    [anon_sym_del] = ACTIONS(1272),
    [anon_sym_raise] = ACTIONS(1272),
    [anon_sym_pass] = ACTIONS(1272),
    [anon_sym_break] = ACTIONS(1272),
    [anon_sym_continue] = ACTIONS(1272),
    [anon_sym_if] = ACTIONS(1272),
    [anon_sym_match] = ACTIONS(1272),
    [anon_sym_async] = ACTIONS(1272),
    [anon_sym_for] = ACTIONS(1272),
    [anon_sym_while] = ACTIONS(1272),
    [anon_sym_try] = ACTIONS(1272),
    [anon_sym_with] = ACTIONS(1272),
    [anon_sym_def] = ACTIONS(1272),
    [anon_sym_global] = ACTIONS(1272),
    [anon_sym_nonlocal] = ACTIONS(1272),
    [anon_sym_exec] = ACTIONS(1272),
    [anon_sym_type] = ACTIONS(1272),
    [anon_sym_class] = ACTIONS(1272),
    [anon_sym_LBRACK] = ACTIONS(1274),
    [anon_sym_AT] = ACTIONS(1274),
    [anon_sym_DASH] = ACTIONS(1274),
    [anon_sym_LBRACE] = ACTIONS(1274),
    [anon_sym_PLUS] = ACTIONS(1274),
    [anon_sym_not] = ACTIONS(1272),
    [anon_sym_TILDE] = ACTIONS(1274),
    [anon_sym_lambda] = ACTIONS(1272),
    [anon_sym_yield] = ACTIONS(1272),
    [sym_ellipsis] = ACTIONS(1274),
    [sym_integer] = ACTIONS(1272),
    [sym_float] = ACTIONS(1274),
    [anon_sym_await] = ACTIONS(1272),
    [sym_true] = ACTIONS(1272),
    [sym_false] = ACTIONS(1272),
    [sym_none] = ACTIONS(1272),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1272),
    [anon_sym_container] = ACTIONS(1272),
    [anon_sym_envvars] = ACTIONS(1272),
    [anon_sym_include] = ACTIONS(1272),
    [anon_sym_pepfile] = ACTIONS(1272),
    [anon_sym_pepschema] = ACTIONS(1272),
    [anon_sym_scattergather] = ACTIONS(1272),
    [anon_sym_version] = ACTIONS(1272),
    [anon_sym_wildcard_constraints] = ACTIONS(1272),
    [anon_sym_workdir] = ACTIONS(1272),
    [anon_sym_onerror] = ACTIONS(1272),
    [anon_sym_onstart] = ACTIONS(1272),
    [anon_sym_onsuccess] = ACTIONS(1272),
    [anon_sym_localrules] = ACTIONS(1272),
    [anon_sym_ruleorder] = ACTIONS(1272),
    [anon_sym_rule] = ACTIONS(1272),
    [anon_sym_checkpoint] = ACTIONS(1272),
    [anon_sym_use] = ACTIONS(1272),
    [anon_sym_module] = ACTIONS(1272),
    [sym_string_start] = ACTIONS(1274),
  },
  [401] = {
    [ts_builtin_sym_end] = ACTIONS(968),
    [sym_identifier] = ACTIONS(966),
    [anon_sym_import] = ACTIONS(966),
    [anon_sym_from] = ACTIONS(966),
    [anon_sym_LPAREN] = ACTIONS(968),
    [anon_sym_STAR] = ACTIONS(968),
    [anon_sym_print] = ACTIONS(966),
    [anon_sym_assert] = ACTIONS(966),
    [anon_sym_return] = ACTIONS(966),
    [anon_sym_del] = ACTIONS(966),
    [anon_sym_raise] = ACTIONS(966),
    [anon_sym_pass] = ACTIONS(966),
    [anon_sym_break] = ACTIONS(966),
    [anon_sym_continue] = ACTIONS(966),
    [anon_sym_if] = ACTIONS(966),
    [anon_sym_match] = ACTIONS(966),
    [anon_sym_async] = ACTIONS(966),
    [anon_sym_for] = ACTIONS(966),
    [anon_sym_while] = ACTIONS(966),
    [anon_sym_try] = ACTIONS(966),
    [anon_sym_with] = ACTIONS(966),
    [anon_sym_def] = ACTIONS(966),
    [anon_sym_global] = ACTIONS(966),
    [anon_sym_nonlocal] = ACTIONS(966),
    [anon_sym_exec] = ACTIONS(966),
    [anon_sym_type] = ACTIONS(966),
    [anon_sym_class] = ACTIONS(966),
    [anon_sym_LBRACK] = ACTIONS(968),
    [anon_sym_AT] = ACTIONS(968),
    [anon_sym_DASH] = ACTIONS(968),
    [anon_sym_LBRACE] = ACTIONS(968),
    [anon_sym_PLUS] = ACTIONS(968),
    [anon_sym_not] = ACTIONS(966),
    [anon_sym_TILDE] = ACTIONS(968),
    [anon_sym_lambda] = ACTIONS(966),
    [anon_sym_yield] = ACTIONS(966),
    [sym_ellipsis] = ACTIONS(968),
    [sym_integer] = ACTIONS(966),
    [sym_float] = ACTIONS(968),
    [anon_sym_await] = ACTIONS(966),
    [sym_true] = ACTIONS(966),
    [sym_false] = ACTIONS(966),
    [sym_none] = ACTIONS(966),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(966),
    [anon_sym_container] = ACTIONS(966),
    [anon_sym_envvars] = ACTIONS(966),
    [anon_sym_include] = ACTIONS(966),
    [anon_sym_pepfile] = ACTIONS(966),
    [anon_sym_pepschema] = ACTIONS(966),
    [anon_sym_scattergather] = ACTIONS(966),
    [anon_sym_version] = ACTIONS(966),
    [anon_sym_wildcard_constraints] = ACTIONS(966),
    [anon_sym_workdir] = ACTIONS(966),
    [anon_sym_onerror] = ACTIONS(966),
    [anon_sym_onstart] = ACTIONS(966),
    [anon_sym_onsuccess] = ACTIONS(966),
    [anon_sym_localrules] = ACTIONS(966),
    [anon_sym_ruleorder] = ACTIONS(966),
    [anon_sym_rule] = ACTIONS(966),
    [anon_sym_checkpoint] = ACTIONS(966),
    [anon_sym_use] = ACTIONS(966),
    [anon_sym_module] = ACTIONS(966),
    [sym_string_start] = ACTIONS(968),
  },
  [402] = {
    [ts_builtin_sym_end] = ACTIONS(1270),
    [sym_identifier] = ACTIONS(1268),
    [anon_sym_import] = ACTIONS(1268),
    [anon_sym_from] = ACTIONS(1268),
    [anon_sym_LPAREN] = ACTIONS(1270),
    [anon_sym_STAR] = ACTIONS(1270),
    [anon_sym_print] = ACTIONS(1268),
    [anon_sym_assert] = ACTIONS(1268),
    [anon_sym_return] = ACTIONS(1268),
    [anon_sym_del] = ACTIONS(1268),
    [anon_sym_raise] = ACTIONS(1268),
    [anon_sym_pass] = ACTIONS(1268),
    [anon_sym_break] = ACTIONS(1268),
    [anon_sym_continue] = ACTIONS(1268),
    [anon_sym_if] = ACTIONS(1268),
    [anon_sym_match] = ACTIONS(1268),
    [anon_sym_async] = ACTIONS(1268),
    [anon_sym_for] = ACTIONS(1268),
    [anon_sym_while] = ACTIONS(1268),
    [anon_sym_try] = ACTIONS(1268),
    [anon_sym_with] = ACTIONS(1268),
    [anon_sym_def] = ACTIONS(1268),
    [anon_sym_global] = ACTIONS(1268),
    [anon_sym_nonlocal] = ACTIONS(1268),
    [anon_sym_exec] = ACTIONS(1268),
    [anon_sym_type] = ACTIONS(1268),
    [anon_sym_class] = ACTIONS(1268),
    [anon_sym_LBRACK] = ACTIONS(1270),
    [anon_sym_AT] = ACTIONS(1270),
    [anon_sym_DASH] = ACTIONS(1270),
    [anon_sym_LBRACE] = ACTIONS(1270),
    [anon_sym_PLUS] = ACTIONS(1270),
    [anon_sym_not] = ACTIONS(1268),
    [anon_sym_TILDE] = ACTIONS(1270),
    [anon_sym_lambda] = ACTIONS(1268),
    [anon_sym_yield] = ACTIONS(1268),
    [sym_ellipsis] = ACTIONS(1270),
    [sym_integer] = ACTIONS(1268),
    [sym_float] = ACTIONS(1270),
    [anon_sym_await] = ACTIONS(1268),
    [sym_true] = ACTIONS(1268),
    [sym_false] = ACTIONS(1268),
    [sym_none] = ACTIONS(1268),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1268),
    [anon_sym_container] = ACTIONS(1268),
    [anon_sym_envvars] = ACTIONS(1268),
    [anon_sym_include] = ACTIONS(1268),
    [anon_sym_pepfile] = ACTIONS(1268),
    [anon_sym_pepschema] = ACTIONS(1268),
    [anon_sym_scattergather] = ACTIONS(1268),
    [anon_sym_version] = ACTIONS(1268),
    [anon_sym_wildcard_constraints] = ACTIONS(1268),
    [anon_sym_workdir] = ACTIONS(1268),
    [anon_sym_onerror] = ACTIONS(1268),
    [anon_sym_onstart] = ACTIONS(1268),
    [anon_sym_onsuccess] = ACTIONS(1268),
    [anon_sym_localrules] = ACTIONS(1268),
    [anon_sym_ruleorder] = ACTIONS(1268),
    [anon_sym_rule] = ACTIONS(1268),
    [anon_sym_checkpoint] = ACTIONS(1268),
    [anon_sym_use] = ACTIONS(1268),
    [anon_sym_module] = ACTIONS(1268),
    [sym_string_start] = ACTIONS(1270),
  },
  [403] = {
    [sym_identifier] = ACTIONS(1338),
    [anon_sym_import] = ACTIONS(1338),
    [anon_sym_from] = ACTIONS(1338),
    [anon_sym_LPAREN] = ACTIONS(1336),
    [anon_sym_STAR] = ACTIONS(1336),
    [anon_sym_print] = ACTIONS(1338),
    [anon_sym_assert] = ACTIONS(1338),
    [anon_sym_return] = ACTIONS(1338),
    [anon_sym_del] = ACTIONS(1338),
    [anon_sym_raise] = ACTIONS(1338),
    [anon_sym_pass] = ACTIONS(1338),
    [anon_sym_break] = ACTIONS(1338),
    [anon_sym_continue] = ACTIONS(1338),
    [anon_sym_if] = ACTIONS(1338),
    [anon_sym_match] = ACTIONS(1338),
    [anon_sym_async] = ACTIONS(1338),
    [anon_sym_for] = ACTIONS(1338),
    [anon_sym_while] = ACTIONS(1338),
    [anon_sym_try] = ACTIONS(1338),
    [anon_sym_with] = ACTIONS(1338),
    [anon_sym_def] = ACTIONS(1338),
    [anon_sym_global] = ACTIONS(1338),
    [anon_sym_nonlocal] = ACTIONS(1338),
    [anon_sym_exec] = ACTIONS(1338),
    [anon_sym_type] = ACTIONS(1338),
    [anon_sym_class] = ACTIONS(1338),
    [anon_sym_LBRACK] = ACTIONS(1336),
    [anon_sym_AT] = ACTIONS(1336),
    [anon_sym_DASH] = ACTIONS(1336),
    [anon_sym_LBRACE] = ACTIONS(1336),
    [anon_sym_PLUS] = ACTIONS(1336),
    [anon_sym_not] = ACTIONS(1338),
    [anon_sym_TILDE] = ACTIONS(1336),
    [anon_sym_lambda] = ACTIONS(1338),
    [anon_sym_yield] = ACTIONS(1338),
    [sym_ellipsis] = ACTIONS(1336),
    [sym_integer] = ACTIONS(1338),
    [sym_float] = ACTIONS(1336),
    [anon_sym_await] = ACTIONS(1338),
    [sym_true] = ACTIONS(1338),
    [sym_false] = ACTIONS(1338),
    [sym_none] = ACTIONS(1338),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1338),
    [anon_sym_container] = ACTIONS(1338),
    [anon_sym_envvars] = ACTIONS(1338),
    [anon_sym_include] = ACTIONS(1338),
    [anon_sym_pepfile] = ACTIONS(1338),
    [anon_sym_pepschema] = ACTIONS(1338),
    [anon_sym_scattergather] = ACTIONS(1338),
    [anon_sym_version] = ACTIONS(1338),
    [anon_sym_wildcard_constraints] = ACTIONS(1338),
    [anon_sym_workdir] = ACTIONS(1338),
    [anon_sym_onerror] = ACTIONS(1338),
    [anon_sym_onstart] = ACTIONS(1338),
    [anon_sym_onsuccess] = ACTIONS(1338),
    [anon_sym_localrules] = ACTIONS(1338),
    [anon_sym_ruleorder] = ACTIONS(1338),
    [anon_sym_rule] = ACTIONS(1338),
    [anon_sym_checkpoint] = ACTIONS(1338),
    [anon_sym_use] = ACTIONS(1338),
    [anon_sym_module] = ACTIONS(1338),
    [sym__dedent] = ACTIONS(1336),
    [sym_string_start] = ACTIONS(1336),
  },
  [404] = {
    [ts_builtin_sym_end] = ACTIONS(1266),
    [sym_identifier] = ACTIONS(1264),
    [anon_sym_import] = ACTIONS(1264),
    [anon_sym_from] = ACTIONS(1264),
    [anon_sym_LPAREN] = ACTIONS(1266),
    [anon_sym_STAR] = ACTIONS(1266),
    [anon_sym_print] = ACTIONS(1264),
    [anon_sym_assert] = ACTIONS(1264),
    [anon_sym_return] = ACTIONS(1264),
    [anon_sym_del] = ACTIONS(1264),
    [anon_sym_raise] = ACTIONS(1264),
    [anon_sym_pass] = ACTIONS(1264),
    [anon_sym_break] = ACTIONS(1264),
    [anon_sym_continue] = ACTIONS(1264),
    [anon_sym_if] = ACTIONS(1264),
    [anon_sym_match] = ACTIONS(1264),
    [anon_sym_async] = ACTIONS(1264),
    [anon_sym_for] = ACTIONS(1264),
    [anon_sym_while] = ACTIONS(1264),
    [anon_sym_try] = ACTIONS(1264),
    [anon_sym_with] = ACTIONS(1264),
    [anon_sym_def] = ACTIONS(1264),
    [anon_sym_global] = ACTIONS(1264),
    [anon_sym_nonlocal] = ACTIONS(1264),
    [anon_sym_exec] = ACTIONS(1264),
    [anon_sym_type] = ACTIONS(1264),
    [anon_sym_class] = ACTIONS(1264),
    [anon_sym_LBRACK] = ACTIONS(1266),
    [anon_sym_AT] = ACTIONS(1266),
    [anon_sym_DASH] = ACTIONS(1266),
    [anon_sym_LBRACE] = ACTIONS(1266),
    [anon_sym_PLUS] = ACTIONS(1266),
    [anon_sym_not] = ACTIONS(1264),
    [anon_sym_TILDE] = ACTIONS(1266),
    [anon_sym_lambda] = ACTIONS(1264),
    [anon_sym_yield] = ACTIONS(1264),
    [sym_ellipsis] = ACTIONS(1266),
    [sym_integer] = ACTIONS(1264),
    [sym_float] = ACTIONS(1266),
    [anon_sym_await] = ACTIONS(1264),
    [sym_true] = ACTIONS(1264),
    [sym_false] = ACTIONS(1264),
    [sym_none] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1264),
    [anon_sym_container] = ACTIONS(1264),
    [anon_sym_envvars] = ACTIONS(1264),
    [anon_sym_include] = ACTIONS(1264),
    [anon_sym_pepfile] = ACTIONS(1264),
    [anon_sym_pepschema] = ACTIONS(1264),
    [anon_sym_scattergather] = ACTIONS(1264),
    [anon_sym_version] = ACTIONS(1264),
    [anon_sym_wildcard_constraints] = ACTIONS(1264),
    [anon_sym_workdir] = ACTIONS(1264),
    [anon_sym_onerror] = ACTIONS(1264),
    [anon_sym_onstart] = ACTIONS(1264),
    [anon_sym_onsuccess] = ACTIONS(1264),
    [anon_sym_localrules] = ACTIONS(1264),
    [anon_sym_ruleorder] = ACTIONS(1264),
    [anon_sym_rule] = ACTIONS(1264),
    [anon_sym_checkpoint] = ACTIONS(1264),
    [anon_sym_use] = ACTIONS(1264),
    [anon_sym_module] = ACTIONS(1264),
    [sym_string_start] = ACTIONS(1266),
  },
  [405] = {
    [ts_builtin_sym_end] = ACTIONS(1430),
    [sym_identifier] = ACTIONS(1432),
    [anon_sym_import] = ACTIONS(1432),
    [anon_sym_from] = ACTIONS(1432),
    [anon_sym_LPAREN] = ACTIONS(1430),
    [anon_sym_STAR] = ACTIONS(1430),
    [anon_sym_print] = ACTIONS(1432),
    [anon_sym_assert] = ACTIONS(1432),
    [anon_sym_return] = ACTIONS(1432),
    [anon_sym_del] = ACTIONS(1432),
    [anon_sym_raise] = ACTIONS(1432),
    [anon_sym_pass] = ACTIONS(1432),
    [anon_sym_break] = ACTIONS(1432),
    [anon_sym_continue] = ACTIONS(1432),
    [anon_sym_if] = ACTIONS(1432),
    [anon_sym_match] = ACTIONS(1432),
    [anon_sym_async] = ACTIONS(1432),
    [anon_sym_for] = ACTIONS(1432),
    [anon_sym_while] = ACTIONS(1432),
    [anon_sym_try] = ACTIONS(1432),
    [anon_sym_with] = ACTIONS(1432),
    [anon_sym_def] = ACTIONS(1432),
    [anon_sym_global] = ACTIONS(1432),
    [anon_sym_nonlocal] = ACTIONS(1432),
    [anon_sym_exec] = ACTIONS(1432),
    [anon_sym_type] = ACTIONS(1432),
    [anon_sym_class] = ACTIONS(1432),
    [anon_sym_LBRACK] = ACTIONS(1430),
    [anon_sym_AT] = ACTIONS(1430),
    [anon_sym_DASH] = ACTIONS(1430),
    [anon_sym_LBRACE] = ACTIONS(1430),
    [anon_sym_PLUS] = ACTIONS(1430),
    [anon_sym_not] = ACTIONS(1432),
    [anon_sym_TILDE] = ACTIONS(1430),
    [anon_sym_lambda] = ACTIONS(1432),
    [anon_sym_yield] = ACTIONS(1432),
    [sym_ellipsis] = ACTIONS(1430),
    [sym_integer] = ACTIONS(1432),
    [sym_float] = ACTIONS(1430),
    [anon_sym_await] = ACTIONS(1432),
    [sym_true] = ACTIONS(1432),
    [sym_false] = ACTIONS(1432),
    [sym_none] = ACTIONS(1432),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1432),
    [anon_sym_container] = ACTIONS(1432),
    [anon_sym_envvars] = ACTIONS(1432),
    [anon_sym_include] = ACTIONS(1432),
    [anon_sym_pepfile] = ACTIONS(1432),
    [anon_sym_pepschema] = ACTIONS(1432),
    [anon_sym_scattergather] = ACTIONS(1432),
    [anon_sym_version] = ACTIONS(1432),
    [anon_sym_wildcard_constraints] = ACTIONS(1432),
    [anon_sym_workdir] = ACTIONS(1432),
    [anon_sym_onerror] = ACTIONS(1432),
    [anon_sym_onstart] = ACTIONS(1432),
    [anon_sym_onsuccess] = ACTIONS(1432),
    [anon_sym_localrules] = ACTIONS(1432),
    [anon_sym_ruleorder] = ACTIONS(1432),
    [anon_sym_rule] = ACTIONS(1432),
    [anon_sym_checkpoint] = ACTIONS(1432),
    [anon_sym_use] = ACTIONS(1432),
    [anon_sym_module] = ACTIONS(1432),
    [sym_string_start] = ACTIONS(1430),
  },
  [406] = {
    [sym_identifier] = ACTIONS(1162),
    [anon_sym_import] = ACTIONS(1162),
    [anon_sym_from] = ACTIONS(1162),
    [anon_sym_LPAREN] = ACTIONS(1164),
    [anon_sym_STAR] = ACTIONS(1164),
    [anon_sym_print] = ACTIONS(1162),
    [anon_sym_assert] = ACTIONS(1162),
    [anon_sym_return] = ACTIONS(1162),
    [anon_sym_del] = ACTIONS(1162),
    [anon_sym_raise] = ACTIONS(1162),
    [anon_sym_pass] = ACTIONS(1162),
    [anon_sym_break] = ACTIONS(1162),
    [anon_sym_continue] = ACTIONS(1162),
    [anon_sym_if] = ACTIONS(1162),
    [anon_sym_match] = ACTIONS(1162),
    [anon_sym_async] = ACTIONS(1162),
    [anon_sym_for] = ACTIONS(1162),
    [anon_sym_while] = ACTIONS(1162),
    [anon_sym_try] = ACTIONS(1162),
    [anon_sym_with] = ACTIONS(1162),
    [anon_sym_def] = ACTIONS(1162),
    [anon_sym_global] = ACTIONS(1162),
    [anon_sym_nonlocal] = ACTIONS(1162),
    [anon_sym_exec] = ACTIONS(1162),
    [anon_sym_type] = ACTIONS(1162),
    [anon_sym_class] = ACTIONS(1162),
    [anon_sym_LBRACK] = ACTIONS(1164),
    [anon_sym_AT] = ACTIONS(1164),
    [anon_sym_DASH] = ACTIONS(1164),
    [anon_sym_LBRACE] = ACTIONS(1164),
    [anon_sym_PLUS] = ACTIONS(1164),
    [anon_sym_not] = ACTIONS(1162),
    [anon_sym_TILDE] = ACTIONS(1164),
    [anon_sym_lambda] = ACTIONS(1162),
    [anon_sym_yield] = ACTIONS(1162),
    [sym_ellipsis] = ACTIONS(1164),
    [sym_integer] = ACTIONS(1162),
    [sym_float] = ACTIONS(1164),
    [anon_sym_await] = ACTIONS(1162),
    [sym_true] = ACTIONS(1162),
    [sym_false] = ACTIONS(1162),
    [sym_none] = ACTIONS(1162),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1162),
    [anon_sym_container] = ACTIONS(1162),
    [anon_sym_envvars] = ACTIONS(1162),
    [anon_sym_include] = ACTIONS(1162),
    [anon_sym_pepfile] = ACTIONS(1162),
    [anon_sym_pepschema] = ACTIONS(1162),
    [anon_sym_scattergather] = ACTIONS(1162),
    [anon_sym_version] = ACTIONS(1162),
    [anon_sym_wildcard_constraints] = ACTIONS(1162),
    [anon_sym_workdir] = ACTIONS(1162),
    [anon_sym_onerror] = ACTIONS(1162),
    [anon_sym_onstart] = ACTIONS(1162),
    [anon_sym_onsuccess] = ACTIONS(1162),
    [anon_sym_localrules] = ACTIONS(1162),
    [anon_sym_ruleorder] = ACTIONS(1162),
    [anon_sym_rule] = ACTIONS(1162),
    [anon_sym_checkpoint] = ACTIONS(1162),
    [anon_sym_use] = ACTIONS(1162),
    [anon_sym_module] = ACTIONS(1162),
    [sym__dedent] = ACTIONS(1164),
    [sym_string_start] = ACTIONS(1164),
  },
  [407] = {
    [ts_builtin_sym_end] = ACTIONS(1394),
    [sym_identifier] = ACTIONS(1392),
    [anon_sym_import] = ACTIONS(1392),
    [anon_sym_from] = ACTIONS(1392),
    [anon_sym_LPAREN] = ACTIONS(1394),
    [anon_sym_STAR] = ACTIONS(1394),
    [anon_sym_print] = ACTIONS(1392),
    [anon_sym_assert] = ACTIONS(1392),
    [anon_sym_return] = ACTIONS(1392),
    [anon_sym_del] = ACTIONS(1392),
    [anon_sym_raise] = ACTIONS(1392),
    [anon_sym_pass] = ACTIONS(1392),
    [anon_sym_break] = ACTIONS(1392),
    [anon_sym_continue] = ACTIONS(1392),
    [anon_sym_if] = ACTIONS(1392),
    [anon_sym_match] = ACTIONS(1392),
    [anon_sym_async] = ACTIONS(1392),
    [anon_sym_for] = ACTIONS(1392),
    [anon_sym_while] = ACTIONS(1392),
    [anon_sym_try] = ACTIONS(1392),
    [anon_sym_with] = ACTIONS(1392),
    [anon_sym_def] = ACTIONS(1392),
    [anon_sym_global] = ACTIONS(1392),
    [anon_sym_nonlocal] = ACTIONS(1392),
    [anon_sym_exec] = ACTIONS(1392),
    [anon_sym_type] = ACTIONS(1392),
    [anon_sym_class] = ACTIONS(1392),
    [anon_sym_LBRACK] = ACTIONS(1394),
    [anon_sym_AT] = ACTIONS(1394),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_LBRACE] = ACTIONS(1394),
    [anon_sym_PLUS] = ACTIONS(1394),
    [anon_sym_not] = ACTIONS(1392),
    [anon_sym_TILDE] = ACTIONS(1394),
    [anon_sym_lambda] = ACTIONS(1392),
    [anon_sym_yield] = ACTIONS(1392),
    [sym_ellipsis] = ACTIONS(1394),
    [sym_integer] = ACTIONS(1392),
    [sym_float] = ACTIONS(1394),
    [anon_sym_await] = ACTIONS(1392),
    [sym_true] = ACTIONS(1392),
    [sym_false] = ACTIONS(1392),
    [sym_none] = ACTIONS(1392),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1392),
    [anon_sym_container] = ACTIONS(1392),
    [anon_sym_envvars] = ACTIONS(1392),
    [anon_sym_include] = ACTIONS(1392),
    [anon_sym_pepfile] = ACTIONS(1392),
    [anon_sym_pepschema] = ACTIONS(1392),
    [anon_sym_scattergather] = ACTIONS(1392),
    [anon_sym_version] = ACTIONS(1392),
    [anon_sym_wildcard_constraints] = ACTIONS(1392),
    [anon_sym_workdir] = ACTIONS(1392),
    [anon_sym_onerror] = ACTIONS(1392),
    [anon_sym_onstart] = ACTIONS(1392),
    [anon_sym_onsuccess] = ACTIONS(1392),
    [anon_sym_localrules] = ACTIONS(1392),
    [anon_sym_ruleorder] = ACTIONS(1392),
    [anon_sym_rule] = ACTIONS(1392),
    [anon_sym_checkpoint] = ACTIONS(1392),
    [anon_sym_use] = ACTIONS(1392),
    [anon_sym_module] = ACTIONS(1392),
    [sym_string_start] = ACTIONS(1394),
  },
  [408] = {
    [ts_builtin_sym_end] = ACTIONS(1434),
    [sym_identifier] = ACTIONS(1436),
    [anon_sym_import] = ACTIONS(1436),
    [anon_sym_from] = ACTIONS(1436),
    [anon_sym_LPAREN] = ACTIONS(1434),
    [anon_sym_STAR] = ACTIONS(1434),
    [anon_sym_print] = ACTIONS(1436),
    [anon_sym_assert] = ACTIONS(1436),
    [anon_sym_return] = ACTIONS(1436),
    [anon_sym_del] = ACTIONS(1436),
    [anon_sym_raise] = ACTIONS(1436),
    [anon_sym_pass] = ACTIONS(1436),
    [anon_sym_break] = ACTIONS(1436),
    [anon_sym_continue] = ACTIONS(1436),
    [anon_sym_if] = ACTIONS(1436),
    [anon_sym_match] = ACTIONS(1436),
    [anon_sym_async] = ACTIONS(1436),
    [anon_sym_for] = ACTIONS(1436),
    [anon_sym_while] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(1436),
    [anon_sym_with] = ACTIONS(1436),
    [anon_sym_def] = ACTIONS(1436),
    [anon_sym_global] = ACTIONS(1436),
    [anon_sym_nonlocal] = ACTIONS(1436),
    [anon_sym_exec] = ACTIONS(1436),
    [anon_sym_type] = ACTIONS(1436),
    [anon_sym_class] = ACTIONS(1436),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_AT] = ACTIONS(1434),
    [anon_sym_DASH] = ACTIONS(1434),
    [anon_sym_LBRACE] = ACTIONS(1434),
    [anon_sym_PLUS] = ACTIONS(1434),
    [anon_sym_not] = ACTIONS(1436),
    [anon_sym_TILDE] = ACTIONS(1434),
    [anon_sym_lambda] = ACTIONS(1436),
    [anon_sym_yield] = ACTIONS(1436),
    [sym_ellipsis] = ACTIONS(1434),
    [sym_integer] = ACTIONS(1436),
    [sym_float] = ACTIONS(1434),
    [anon_sym_await] = ACTIONS(1436),
    [sym_true] = ACTIONS(1436),
    [sym_false] = ACTIONS(1436),
    [sym_none] = ACTIONS(1436),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1436),
    [anon_sym_container] = ACTIONS(1436),
    [anon_sym_envvars] = ACTIONS(1436),
    [anon_sym_include] = ACTIONS(1436),
    [anon_sym_pepfile] = ACTIONS(1436),
    [anon_sym_pepschema] = ACTIONS(1436),
    [anon_sym_scattergather] = ACTIONS(1436),
    [anon_sym_version] = ACTIONS(1436),
    [anon_sym_wildcard_constraints] = ACTIONS(1436),
    [anon_sym_workdir] = ACTIONS(1436),
    [anon_sym_onerror] = ACTIONS(1436),
    [anon_sym_onstart] = ACTIONS(1436),
    [anon_sym_onsuccess] = ACTIONS(1436),
    [anon_sym_localrules] = ACTIONS(1436),
    [anon_sym_ruleorder] = ACTIONS(1436),
    [anon_sym_rule] = ACTIONS(1436),
    [anon_sym_checkpoint] = ACTIONS(1436),
    [anon_sym_use] = ACTIONS(1436),
    [anon_sym_module] = ACTIONS(1436),
    [sym_string_start] = ACTIONS(1434),
  },
  [409] = {
    [ts_builtin_sym_end] = ACTIONS(1398),
    [sym_identifier] = ACTIONS(1396),
    [anon_sym_import] = ACTIONS(1396),
    [anon_sym_from] = ACTIONS(1396),
    [anon_sym_LPAREN] = ACTIONS(1398),
    [anon_sym_STAR] = ACTIONS(1398),
    [anon_sym_print] = ACTIONS(1396),
    [anon_sym_assert] = ACTIONS(1396),
    [anon_sym_return] = ACTIONS(1396),
    [anon_sym_del] = ACTIONS(1396),
    [anon_sym_raise] = ACTIONS(1396),
    [anon_sym_pass] = ACTIONS(1396),
    [anon_sym_break] = ACTIONS(1396),
    [anon_sym_continue] = ACTIONS(1396),
    [anon_sym_if] = ACTIONS(1396),
    [anon_sym_match] = ACTIONS(1396),
    [anon_sym_async] = ACTIONS(1396),
    [anon_sym_for] = ACTIONS(1396),
    [anon_sym_while] = ACTIONS(1396),
    [anon_sym_try] = ACTIONS(1396),
    [anon_sym_with] = ACTIONS(1396),
    [anon_sym_def] = ACTIONS(1396),
    [anon_sym_global] = ACTIONS(1396),
    [anon_sym_nonlocal] = ACTIONS(1396),
    [anon_sym_exec] = ACTIONS(1396),
    [anon_sym_type] = ACTIONS(1396),
    [anon_sym_class] = ACTIONS(1396),
    [anon_sym_LBRACK] = ACTIONS(1398),
    [anon_sym_AT] = ACTIONS(1398),
    [anon_sym_DASH] = ACTIONS(1398),
    [anon_sym_LBRACE] = ACTIONS(1398),
    [anon_sym_PLUS] = ACTIONS(1398),
    [anon_sym_not] = ACTIONS(1396),
    [anon_sym_TILDE] = ACTIONS(1398),
    [anon_sym_lambda] = ACTIONS(1396),
    [anon_sym_yield] = ACTIONS(1396),
    [sym_ellipsis] = ACTIONS(1398),
    [sym_integer] = ACTIONS(1396),
    [sym_float] = ACTIONS(1398),
    [anon_sym_await] = ACTIONS(1396),
    [sym_true] = ACTIONS(1396),
    [sym_false] = ACTIONS(1396),
    [sym_none] = ACTIONS(1396),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1396),
    [anon_sym_container] = ACTIONS(1396),
    [anon_sym_envvars] = ACTIONS(1396),
    [anon_sym_include] = ACTIONS(1396),
    [anon_sym_pepfile] = ACTIONS(1396),
    [anon_sym_pepschema] = ACTIONS(1396),
    [anon_sym_scattergather] = ACTIONS(1396),
    [anon_sym_version] = ACTIONS(1396),
    [anon_sym_wildcard_constraints] = ACTIONS(1396),
    [anon_sym_workdir] = ACTIONS(1396),
    [anon_sym_onerror] = ACTIONS(1396),
    [anon_sym_onstart] = ACTIONS(1396),
    [anon_sym_onsuccess] = ACTIONS(1396),
    [anon_sym_localrules] = ACTIONS(1396),
    [anon_sym_ruleorder] = ACTIONS(1396),
    [anon_sym_rule] = ACTIONS(1396),
    [anon_sym_checkpoint] = ACTIONS(1396),
    [anon_sym_use] = ACTIONS(1396),
    [anon_sym_module] = ACTIONS(1396),
    [sym_string_start] = ACTIONS(1398),
  },
  [410] = {
    [ts_builtin_sym_end] = ACTIONS(1146),
    [sym_identifier] = ACTIONS(1144),
    [anon_sym_import] = ACTIONS(1144),
    [anon_sym_from] = ACTIONS(1144),
    [anon_sym_LPAREN] = ACTIONS(1146),
    [anon_sym_STAR] = ACTIONS(1146),
    [anon_sym_print] = ACTIONS(1144),
    [anon_sym_assert] = ACTIONS(1144),
    [anon_sym_return] = ACTIONS(1144),
    [anon_sym_del] = ACTIONS(1144),
    [anon_sym_raise] = ACTIONS(1144),
    [anon_sym_pass] = ACTIONS(1144),
    [anon_sym_break] = ACTIONS(1144),
    [anon_sym_continue] = ACTIONS(1144),
    [anon_sym_if] = ACTIONS(1144),
    [anon_sym_match] = ACTIONS(1144),
    [anon_sym_async] = ACTIONS(1144),
    [anon_sym_for] = ACTIONS(1144),
    [anon_sym_while] = ACTIONS(1144),
    [anon_sym_try] = ACTIONS(1144),
    [anon_sym_with] = ACTIONS(1144),
    [anon_sym_def] = ACTIONS(1144),
    [anon_sym_global] = ACTIONS(1144),
    [anon_sym_nonlocal] = ACTIONS(1144),
    [anon_sym_exec] = ACTIONS(1144),
    [anon_sym_type] = ACTIONS(1144),
    [anon_sym_class] = ACTIONS(1144),
    [anon_sym_LBRACK] = ACTIONS(1146),
    [anon_sym_AT] = ACTIONS(1146),
    [anon_sym_DASH] = ACTIONS(1146),
    [anon_sym_LBRACE] = ACTIONS(1146),
    [anon_sym_PLUS] = ACTIONS(1146),
    [anon_sym_not] = ACTIONS(1144),
    [anon_sym_TILDE] = ACTIONS(1146),
    [anon_sym_lambda] = ACTIONS(1144),
    [anon_sym_yield] = ACTIONS(1144),
    [sym_ellipsis] = ACTIONS(1146),
    [sym_integer] = ACTIONS(1144),
    [sym_float] = ACTIONS(1146),
    [anon_sym_await] = ACTIONS(1144),
    [sym_true] = ACTIONS(1144),
    [sym_false] = ACTIONS(1144),
    [sym_none] = ACTIONS(1144),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1144),
    [anon_sym_container] = ACTIONS(1144),
    [anon_sym_envvars] = ACTIONS(1144),
    [anon_sym_include] = ACTIONS(1144),
    [anon_sym_pepfile] = ACTIONS(1144),
    [anon_sym_pepschema] = ACTIONS(1144),
    [anon_sym_scattergather] = ACTIONS(1144),
    [anon_sym_version] = ACTIONS(1144),
    [anon_sym_wildcard_constraints] = ACTIONS(1144),
    [anon_sym_workdir] = ACTIONS(1144),
    [anon_sym_onerror] = ACTIONS(1144),
    [anon_sym_onstart] = ACTIONS(1144),
    [anon_sym_onsuccess] = ACTIONS(1144),
    [anon_sym_localrules] = ACTIONS(1144),
    [anon_sym_ruleorder] = ACTIONS(1144),
    [anon_sym_rule] = ACTIONS(1144),
    [anon_sym_checkpoint] = ACTIONS(1144),
    [anon_sym_use] = ACTIONS(1144),
    [anon_sym_module] = ACTIONS(1144),
    [sym_string_start] = ACTIONS(1146),
  },
  [411] = {
    [ts_builtin_sym_end] = ACTIONS(996),
    [sym_identifier] = ACTIONS(994),
    [anon_sym_import] = ACTIONS(994),
    [anon_sym_from] = ACTIONS(994),
    [anon_sym_LPAREN] = ACTIONS(996),
    [anon_sym_STAR] = ACTIONS(996),
    [anon_sym_print] = ACTIONS(994),
    [anon_sym_assert] = ACTIONS(994),
    [anon_sym_return] = ACTIONS(994),
    [anon_sym_del] = ACTIONS(994),
    [anon_sym_raise] = ACTIONS(994),
    [anon_sym_pass] = ACTIONS(994),
    [anon_sym_break] = ACTIONS(994),
    [anon_sym_continue] = ACTIONS(994),
    [anon_sym_if] = ACTIONS(994),
    [anon_sym_match] = ACTIONS(994),
    [anon_sym_async] = ACTIONS(994),
    [anon_sym_for] = ACTIONS(994),
    [anon_sym_while] = ACTIONS(994),
    [anon_sym_try] = ACTIONS(994),
    [anon_sym_with] = ACTIONS(994),
    [anon_sym_def] = ACTIONS(994),
    [anon_sym_global] = ACTIONS(994),
    [anon_sym_nonlocal] = ACTIONS(994),
    [anon_sym_exec] = ACTIONS(994),
    [anon_sym_type] = ACTIONS(994),
    [anon_sym_class] = ACTIONS(994),
    [anon_sym_LBRACK] = ACTIONS(996),
    [anon_sym_AT] = ACTIONS(996),
    [anon_sym_DASH] = ACTIONS(996),
    [anon_sym_LBRACE] = ACTIONS(996),
    [anon_sym_PLUS] = ACTIONS(996),
    [anon_sym_not] = ACTIONS(994),
    [anon_sym_TILDE] = ACTIONS(996),
    [anon_sym_lambda] = ACTIONS(994),
    [anon_sym_yield] = ACTIONS(994),
    [sym_ellipsis] = ACTIONS(996),
    [sym_integer] = ACTIONS(994),
    [sym_float] = ACTIONS(996),
    [anon_sym_await] = ACTIONS(994),
    [sym_true] = ACTIONS(994),
    [sym_false] = ACTIONS(994),
    [sym_none] = ACTIONS(994),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(994),
    [anon_sym_container] = ACTIONS(994),
    [anon_sym_envvars] = ACTIONS(994),
    [anon_sym_include] = ACTIONS(994),
    [anon_sym_pepfile] = ACTIONS(994),
    [anon_sym_pepschema] = ACTIONS(994),
    [anon_sym_scattergather] = ACTIONS(994),
    [anon_sym_version] = ACTIONS(994),
    [anon_sym_wildcard_constraints] = ACTIONS(994),
    [anon_sym_workdir] = ACTIONS(994),
    [anon_sym_onerror] = ACTIONS(994),
    [anon_sym_onstart] = ACTIONS(994),
    [anon_sym_onsuccess] = ACTIONS(994),
    [anon_sym_localrules] = ACTIONS(994),
    [anon_sym_ruleorder] = ACTIONS(994),
    [anon_sym_rule] = ACTIONS(994),
    [anon_sym_checkpoint] = ACTIONS(994),
    [anon_sym_use] = ACTIONS(994),
    [anon_sym_module] = ACTIONS(994),
    [sym_string_start] = ACTIONS(996),
  },
  [412] = {
    [ts_builtin_sym_end] = ACTIONS(1428),
    [sym_identifier] = ACTIONS(1426),
    [anon_sym_import] = ACTIONS(1426),
    [anon_sym_from] = ACTIONS(1426),
    [anon_sym_LPAREN] = ACTIONS(1428),
    [anon_sym_STAR] = ACTIONS(1428),
    [anon_sym_print] = ACTIONS(1426),
    [anon_sym_assert] = ACTIONS(1426),
    [anon_sym_return] = ACTIONS(1426),
    [anon_sym_del] = ACTIONS(1426),
    [anon_sym_raise] = ACTIONS(1426),
    [anon_sym_pass] = ACTIONS(1426),
    [anon_sym_break] = ACTIONS(1426),
    [anon_sym_continue] = ACTIONS(1426),
    [anon_sym_if] = ACTIONS(1426),
    [anon_sym_match] = ACTIONS(1426),
    [anon_sym_async] = ACTIONS(1426),
    [anon_sym_for] = ACTIONS(1426),
    [anon_sym_while] = ACTIONS(1426),
    [anon_sym_try] = ACTIONS(1426),
    [anon_sym_with] = ACTIONS(1426),
    [anon_sym_def] = ACTIONS(1426),
    [anon_sym_global] = ACTIONS(1426),
    [anon_sym_nonlocal] = ACTIONS(1426),
    [anon_sym_exec] = ACTIONS(1426),
    [anon_sym_type] = ACTIONS(1426),
    [anon_sym_class] = ACTIONS(1426),
    [anon_sym_LBRACK] = ACTIONS(1428),
    [anon_sym_AT] = ACTIONS(1428),
    [anon_sym_DASH] = ACTIONS(1428),
    [anon_sym_LBRACE] = ACTIONS(1428),
    [anon_sym_PLUS] = ACTIONS(1428),
    [anon_sym_not] = ACTIONS(1426),
    [anon_sym_TILDE] = ACTIONS(1428),
    [anon_sym_lambda] = ACTIONS(1426),
    [anon_sym_yield] = ACTIONS(1426),
    [sym_ellipsis] = ACTIONS(1428),
    [sym_integer] = ACTIONS(1426),
    [sym_float] = ACTIONS(1428),
    [anon_sym_await] = ACTIONS(1426),
    [sym_true] = ACTIONS(1426),
    [sym_false] = ACTIONS(1426),
    [sym_none] = ACTIONS(1426),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1426),
    [anon_sym_container] = ACTIONS(1426),
    [anon_sym_envvars] = ACTIONS(1426),
    [anon_sym_include] = ACTIONS(1426),
    [anon_sym_pepfile] = ACTIONS(1426),
    [anon_sym_pepschema] = ACTIONS(1426),
    [anon_sym_scattergather] = ACTIONS(1426),
    [anon_sym_version] = ACTIONS(1426),
    [anon_sym_wildcard_constraints] = ACTIONS(1426),
    [anon_sym_workdir] = ACTIONS(1426),
    [anon_sym_onerror] = ACTIONS(1426),
    [anon_sym_onstart] = ACTIONS(1426),
    [anon_sym_onsuccess] = ACTIONS(1426),
    [anon_sym_localrules] = ACTIONS(1426),
    [anon_sym_ruleorder] = ACTIONS(1426),
    [anon_sym_rule] = ACTIONS(1426),
    [anon_sym_checkpoint] = ACTIONS(1426),
    [anon_sym_use] = ACTIONS(1426),
    [anon_sym_module] = ACTIONS(1426),
    [sym_string_start] = ACTIONS(1428),
  },
  [413] = {
    [sym_identifier] = ACTIONS(1322),
    [anon_sym_import] = ACTIONS(1322),
    [anon_sym_from] = ACTIONS(1322),
    [anon_sym_LPAREN] = ACTIONS(1320),
    [anon_sym_STAR] = ACTIONS(1320),
    [anon_sym_print] = ACTIONS(1322),
    [anon_sym_assert] = ACTIONS(1322),
    [anon_sym_return] = ACTIONS(1322),
    [anon_sym_del] = ACTIONS(1322),
    [anon_sym_raise] = ACTIONS(1322),
    [anon_sym_pass] = ACTIONS(1322),
    [anon_sym_break] = ACTIONS(1322),
    [anon_sym_continue] = ACTIONS(1322),
    [anon_sym_if] = ACTIONS(1322),
    [anon_sym_match] = ACTIONS(1322),
    [anon_sym_async] = ACTIONS(1322),
    [anon_sym_for] = ACTIONS(1322),
    [anon_sym_while] = ACTIONS(1322),
    [anon_sym_try] = ACTIONS(1322),
    [anon_sym_with] = ACTIONS(1322),
    [anon_sym_def] = ACTIONS(1322),
    [anon_sym_global] = ACTIONS(1322),
    [anon_sym_nonlocal] = ACTIONS(1322),
    [anon_sym_exec] = ACTIONS(1322),
    [anon_sym_type] = ACTIONS(1322),
    [anon_sym_class] = ACTIONS(1322),
    [anon_sym_LBRACK] = ACTIONS(1320),
    [anon_sym_AT] = ACTIONS(1320),
    [anon_sym_DASH] = ACTIONS(1320),
    [anon_sym_LBRACE] = ACTIONS(1320),
    [anon_sym_PLUS] = ACTIONS(1320),
    [anon_sym_not] = ACTIONS(1322),
    [anon_sym_TILDE] = ACTIONS(1320),
    [anon_sym_lambda] = ACTIONS(1322),
    [anon_sym_yield] = ACTIONS(1322),
    [sym_ellipsis] = ACTIONS(1320),
    [sym_integer] = ACTIONS(1322),
    [sym_float] = ACTIONS(1320),
    [anon_sym_await] = ACTIONS(1322),
    [sym_true] = ACTIONS(1322),
    [sym_false] = ACTIONS(1322),
    [sym_none] = ACTIONS(1322),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1322),
    [anon_sym_container] = ACTIONS(1322),
    [anon_sym_envvars] = ACTIONS(1322),
    [anon_sym_include] = ACTIONS(1322),
    [anon_sym_pepfile] = ACTIONS(1322),
    [anon_sym_pepschema] = ACTIONS(1322),
    [anon_sym_scattergather] = ACTIONS(1322),
    [anon_sym_version] = ACTIONS(1322),
    [anon_sym_wildcard_constraints] = ACTIONS(1322),
    [anon_sym_workdir] = ACTIONS(1322),
    [anon_sym_onerror] = ACTIONS(1322),
    [anon_sym_onstart] = ACTIONS(1322),
    [anon_sym_onsuccess] = ACTIONS(1322),
    [anon_sym_localrules] = ACTIONS(1322),
    [anon_sym_ruleorder] = ACTIONS(1322),
    [anon_sym_rule] = ACTIONS(1322),
    [anon_sym_checkpoint] = ACTIONS(1322),
    [anon_sym_use] = ACTIONS(1322),
    [anon_sym_module] = ACTIONS(1322),
    [sym__dedent] = ACTIONS(1320),
    [sym_string_start] = ACTIONS(1320),
  },
  [414] = {
    [ts_builtin_sym_end] = ACTIONS(1246),
    [sym_identifier] = ACTIONS(1244),
    [anon_sym_import] = ACTIONS(1244),
    [anon_sym_from] = ACTIONS(1244),
    [anon_sym_LPAREN] = ACTIONS(1246),
    [anon_sym_STAR] = ACTIONS(1246),
    [anon_sym_print] = ACTIONS(1244),
    [anon_sym_assert] = ACTIONS(1244),
    [anon_sym_return] = ACTIONS(1244),
    [anon_sym_del] = ACTIONS(1244),
    [anon_sym_raise] = ACTIONS(1244),
    [anon_sym_pass] = ACTIONS(1244),
    [anon_sym_break] = ACTIONS(1244),
    [anon_sym_continue] = ACTIONS(1244),
    [anon_sym_if] = ACTIONS(1244),
    [anon_sym_match] = ACTIONS(1244),
    [anon_sym_async] = ACTIONS(1244),
    [anon_sym_for] = ACTIONS(1244),
    [anon_sym_while] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(1244),
    [anon_sym_with] = ACTIONS(1244),
    [anon_sym_def] = ACTIONS(1244),
    [anon_sym_global] = ACTIONS(1244),
    [anon_sym_nonlocal] = ACTIONS(1244),
    [anon_sym_exec] = ACTIONS(1244),
    [anon_sym_type] = ACTIONS(1244),
    [anon_sym_class] = ACTIONS(1244),
    [anon_sym_LBRACK] = ACTIONS(1246),
    [anon_sym_AT] = ACTIONS(1246),
    [anon_sym_DASH] = ACTIONS(1246),
    [anon_sym_LBRACE] = ACTIONS(1246),
    [anon_sym_PLUS] = ACTIONS(1246),
    [anon_sym_not] = ACTIONS(1244),
    [anon_sym_TILDE] = ACTIONS(1246),
    [anon_sym_lambda] = ACTIONS(1244),
    [anon_sym_yield] = ACTIONS(1244),
    [sym_ellipsis] = ACTIONS(1246),
    [sym_integer] = ACTIONS(1244),
    [sym_float] = ACTIONS(1246),
    [anon_sym_await] = ACTIONS(1244),
    [sym_true] = ACTIONS(1244),
    [sym_false] = ACTIONS(1244),
    [sym_none] = ACTIONS(1244),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1244),
    [anon_sym_container] = ACTIONS(1244),
    [anon_sym_envvars] = ACTIONS(1244),
    [anon_sym_include] = ACTIONS(1244),
    [anon_sym_pepfile] = ACTIONS(1244),
    [anon_sym_pepschema] = ACTIONS(1244),
    [anon_sym_scattergather] = ACTIONS(1244),
    [anon_sym_version] = ACTIONS(1244),
    [anon_sym_wildcard_constraints] = ACTIONS(1244),
    [anon_sym_workdir] = ACTIONS(1244),
    [anon_sym_onerror] = ACTIONS(1244),
    [anon_sym_onstart] = ACTIONS(1244),
    [anon_sym_onsuccess] = ACTIONS(1244),
    [anon_sym_localrules] = ACTIONS(1244),
    [anon_sym_ruleorder] = ACTIONS(1244),
    [anon_sym_rule] = ACTIONS(1244),
    [anon_sym_checkpoint] = ACTIONS(1244),
    [anon_sym_use] = ACTIONS(1244),
    [anon_sym_module] = ACTIONS(1244),
    [sym_string_start] = ACTIONS(1246),
  },
  [415] = {
    [sym_identifier] = ACTIONS(1310),
    [anon_sym_import] = ACTIONS(1310),
    [anon_sym_from] = ACTIONS(1310),
    [anon_sym_LPAREN] = ACTIONS(1308),
    [anon_sym_STAR] = ACTIONS(1308),
    [anon_sym_print] = ACTIONS(1310),
    [anon_sym_assert] = ACTIONS(1310),
    [anon_sym_return] = ACTIONS(1310),
    [anon_sym_del] = ACTIONS(1310),
    [anon_sym_raise] = ACTIONS(1310),
    [anon_sym_pass] = ACTIONS(1310),
    [anon_sym_break] = ACTIONS(1310),
    [anon_sym_continue] = ACTIONS(1310),
    [anon_sym_if] = ACTIONS(1310),
    [anon_sym_match] = ACTIONS(1310),
    [anon_sym_async] = ACTIONS(1310),
    [anon_sym_for] = ACTIONS(1310),
    [anon_sym_while] = ACTIONS(1310),
    [anon_sym_try] = ACTIONS(1310),
    [anon_sym_with] = ACTIONS(1310),
    [anon_sym_def] = ACTIONS(1310),
    [anon_sym_global] = ACTIONS(1310),
    [anon_sym_nonlocal] = ACTIONS(1310),
    [anon_sym_exec] = ACTIONS(1310),
    [anon_sym_type] = ACTIONS(1310),
    [anon_sym_class] = ACTIONS(1310),
    [anon_sym_LBRACK] = ACTIONS(1308),
    [anon_sym_AT] = ACTIONS(1308),
    [anon_sym_DASH] = ACTIONS(1308),
    [anon_sym_LBRACE] = ACTIONS(1308),
    [anon_sym_PLUS] = ACTIONS(1308),
    [anon_sym_not] = ACTIONS(1310),
    [anon_sym_TILDE] = ACTIONS(1308),
    [anon_sym_lambda] = ACTIONS(1310),
    [anon_sym_yield] = ACTIONS(1310),
    [sym_ellipsis] = ACTIONS(1308),
    [sym_integer] = ACTIONS(1310),
    [sym_float] = ACTIONS(1308),
    [anon_sym_await] = ACTIONS(1310),
    [sym_true] = ACTIONS(1310),
    [sym_false] = ACTIONS(1310),
    [sym_none] = ACTIONS(1310),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1310),
    [anon_sym_container] = ACTIONS(1310),
    [anon_sym_envvars] = ACTIONS(1310),
    [anon_sym_include] = ACTIONS(1310),
    [anon_sym_pepfile] = ACTIONS(1310),
    [anon_sym_pepschema] = ACTIONS(1310),
    [anon_sym_scattergather] = ACTIONS(1310),
    [anon_sym_version] = ACTIONS(1310),
    [anon_sym_wildcard_constraints] = ACTIONS(1310),
    [anon_sym_workdir] = ACTIONS(1310),
    [anon_sym_onerror] = ACTIONS(1310),
    [anon_sym_onstart] = ACTIONS(1310),
    [anon_sym_onsuccess] = ACTIONS(1310),
    [anon_sym_localrules] = ACTIONS(1310),
    [anon_sym_ruleorder] = ACTIONS(1310),
    [anon_sym_rule] = ACTIONS(1310),
    [anon_sym_checkpoint] = ACTIONS(1310),
    [anon_sym_use] = ACTIONS(1310),
    [anon_sym_module] = ACTIONS(1310),
    [sym__dedent] = ACTIONS(1308),
    [sym_string_start] = ACTIONS(1308),
  },
  [416] = {
    [sym_identifier] = ACTIONS(1290),
    [anon_sym_import] = ACTIONS(1290),
    [anon_sym_from] = ACTIONS(1290),
    [anon_sym_LPAREN] = ACTIONS(1288),
    [anon_sym_STAR] = ACTIONS(1288),
    [anon_sym_print] = ACTIONS(1290),
    [anon_sym_assert] = ACTIONS(1290),
    [anon_sym_return] = ACTIONS(1290),
    [anon_sym_del] = ACTIONS(1290),
    [anon_sym_raise] = ACTIONS(1290),
    [anon_sym_pass] = ACTIONS(1290),
    [anon_sym_break] = ACTIONS(1290),
    [anon_sym_continue] = ACTIONS(1290),
    [anon_sym_if] = ACTIONS(1290),
    [anon_sym_match] = ACTIONS(1290),
    [anon_sym_async] = ACTIONS(1290),
    [anon_sym_for] = ACTIONS(1290),
    [anon_sym_while] = ACTIONS(1290),
    [anon_sym_try] = ACTIONS(1290),
    [anon_sym_with] = ACTIONS(1290),
    [anon_sym_def] = ACTIONS(1290),
    [anon_sym_global] = ACTIONS(1290),
    [anon_sym_nonlocal] = ACTIONS(1290),
    [anon_sym_exec] = ACTIONS(1290),
    [anon_sym_type] = ACTIONS(1290),
    [anon_sym_class] = ACTIONS(1290),
    [anon_sym_LBRACK] = ACTIONS(1288),
    [anon_sym_AT] = ACTIONS(1288),
    [anon_sym_DASH] = ACTIONS(1288),
    [anon_sym_LBRACE] = ACTIONS(1288),
    [anon_sym_PLUS] = ACTIONS(1288),
    [anon_sym_not] = ACTIONS(1290),
    [anon_sym_TILDE] = ACTIONS(1288),
    [anon_sym_lambda] = ACTIONS(1290),
    [anon_sym_yield] = ACTIONS(1290),
    [sym_ellipsis] = ACTIONS(1288),
    [sym_integer] = ACTIONS(1290),
    [sym_float] = ACTIONS(1288),
    [anon_sym_await] = ACTIONS(1290),
    [sym_true] = ACTIONS(1290),
    [sym_false] = ACTIONS(1290),
    [sym_none] = ACTIONS(1290),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1290),
    [anon_sym_container] = ACTIONS(1290),
    [anon_sym_envvars] = ACTIONS(1290),
    [anon_sym_include] = ACTIONS(1290),
    [anon_sym_pepfile] = ACTIONS(1290),
    [anon_sym_pepschema] = ACTIONS(1290),
    [anon_sym_scattergather] = ACTIONS(1290),
    [anon_sym_version] = ACTIONS(1290),
    [anon_sym_wildcard_constraints] = ACTIONS(1290),
    [anon_sym_workdir] = ACTIONS(1290),
    [anon_sym_onerror] = ACTIONS(1290),
    [anon_sym_onstart] = ACTIONS(1290),
    [anon_sym_onsuccess] = ACTIONS(1290),
    [anon_sym_localrules] = ACTIONS(1290),
    [anon_sym_ruleorder] = ACTIONS(1290),
    [anon_sym_rule] = ACTIONS(1290),
    [anon_sym_checkpoint] = ACTIONS(1290),
    [anon_sym_use] = ACTIONS(1290),
    [anon_sym_module] = ACTIONS(1290),
    [sym__dedent] = ACTIONS(1288),
    [sym_string_start] = ACTIONS(1288),
  },
  [417] = {
    [sym_identifier] = ACTIONS(1286),
    [anon_sym_import] = ACTIONS(1286),
    [anon_sym_from] = ACTIONS(1286),
    [anon_sym_LPAREN] = ACTIONS(1284),
    [anon_sym_STAR] = ACTIONS(1284),
    [anon_sym_print] = ACTIONS(1286),
    [anon_sym_assert] = ACTIONS(1286),
    [anon_sym_return] = ACTIONS(1286),
    [anon_sym_del] = ACTIONS(1286),
    [anon_sym_raise] = ACTIONS(1286),
    [anon_sym_pass] = ACTIONS(1286),
    [anon_sym_break] = ACTIONS(1286),
    [anon_sym_continue] = ACTIONS(1286),
    [anon_sym_if] = ACTIONS(1286),
    [anon_sym_match] = ACTIONS(1286),
    [anon_sym_async] = ACTIONS(1286),
    [anon_sym_for] = ACTIONS(1286),
    [anon_sym_while] = ACTIONS(1286),
    [anon_sym_try] = ACTIONS(1286),
    [anon_sym_with] = ACTIONS(1286),
    [anon_sym_def] = ACTIONS(1286),
    [anon_sym_global] = ACTIONS(1286),
    [anon_sym_nonlocal] = ACTIONS(1286),
    [anon_sym_exec] = ACTIONS(1286),
    [anon_sym_type] = ACTIONS(1286),
    [anon_sym_class] = ACTIONS(1286),
    [anon_sym_LBRACK] = ACTIONS(1284),
    [anon_sym_AT] = ACTIONS(1284),
    [anon_sym_DASH] = ACTIONS(1284),
    [anon_sym_LBRACE] = ACTIONS(1284),
    [anon_sym_PLUS] = ACTIONS(1284),
    [anon_sym_not] = ACTIONS(1286),
    [anon_sym_TILDE] = ACTIONS(1284),
    [anon_sym_lambda] = ACTIONS(1286),
    [anon_sym_yield] = ACTIONS(1286),
    [sym_ellipsis] = ACTIONS(1284),
    [sym_integer] = ACTIONS(1286),
    [sym_float] = ACTIONS(1284),
    [anon_sym_await] = ACTIONS(1286),
    [sym_true] = ACTIONS(1286),
    [sym_false] = ACTIONS(1286),
    [sym_none] = ACTIONS(1286),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1286),
    [anon_sym_container] = ACTIONS(1286),
    [anon_sym_envvars] = ACTIONS(1286),
    [anon_sym_include] = ACTIONS(1286),
    [anon_sym_pepfile] = ACTIONS(1286),
    [anon_sym_pepschema] = ACTIONS(1286),
    [anon_sym_scattergather] = ACTIONS(1286),
    [anon_sym_version] = ACTIONS(1286),
    [anon_sym_wildcard_constraints] = ACTIONS(1286),
    [anon_sym_workdir] = ACTIONS(1286),
    [anon_sym_onerror] = ACTIONS(1286),
    [anon_sym_onstart] = ACTIONS(1286),
    [anon_sym_onsuccess] = ACTIONS(1286),
    [anon_sym_localrules] = ACTIONS(1286),
    [anon_sym_ruleorder] = ACTIONS(1286),
    [anon_sym_rule] = ACTIONS(1286),
    [anon_sym_checkpoint] = ACTIONS(1286),
    [anon_sym_use] = ACTIONS(1286),
    [anon_sym_module] = ACTIONS(1286),
    [sym__dedent] = ACTIONS(1284),
    [sym_string_start] = ACTIONS(1284),
  },
  [418] = {
    [sym_identifier] = ACTIONS(1282),
    [anon_sym_import] = ACTIONS(1282),
    [anon_sym_from] = ACTIONS(1282),
    [anon_sym_LPAREN] = ACTIONS(1280),
    [anon_sym_STAR] = ACTIONS(1280),
    [anon_sym_print] = ACTIONS(1282),
    [anon_sym_assert] = ACTIONS(1282),
    [anon_sym_return] = ACTIONS(1282),
    [anon_sym_del] = ACTIONS(1282),
    [anon_sym_raise] = ACTIONS(1282),
    [anon_sym_pass] = ACTIONS(1282),
    [anon_sym_break] = ACTIONS(1282),
    [anon_sym_continue] = ACTIONS(1282),
    [anon_sym_if] = ACTIONS(1282),
    [anon_sym_match] = ACTIONS(1282),
    [anon_sym_async] = ACTIONS(1282),
    [anon_sym_for] = ACTIONS(1282),
    [anon_sym_while] = ACTIONS(1282),
    [anon_sym_try] = ACTIONS(1282),
    [anon_sym_with] = ACTIONS(1282),
    [anon_sym_def] = ACTIONS(1282),
    [anon_sym_global] = ACTIONS(1282),
    [anon_sym_nonlocal] = ACTIONS(1282),
    [anon_sym_exec] = ACTIONS(1282),
    [anon_sym_type] = ACTIONS(1282),
    [anon_sym_class] = ACTIONS(1282),
    [anon_sym_LBRACK] = ACTIONS(1280),
    [anon_sym_AT] = ACTIONS(1280),
    [anon_sym_DASH] = ACTIONS(1280),
    [anon_sym_LBRACE] = ACTIONS(1280),
    [anon_sym_PLUS] = ACTIONS(1280),
    [anon_sym_not] = ACTIONS(1282),
    [anon_sym_TILDE] = ACTIONS(1280),
    [anon_sym_lambda] = ACTIONS(1282),
    [anon_sym_yield] = ACTIONS(1282),
    [sym_ellipsis] = ACTIONS(1280),
    [sym_integer] = ACTIONS(1282),
    [sym_float] = ACTIONS(1280),
    [anon_sym_await] = ACTIONS(1282),
    [sym_true] = ACTIONS(1282),
    [sym_false] = ACTIONS(1282),
    [sym_none] = ACTIONS(1282),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1282),
    [anon_sym_container] = ACTIONS(1282),
    [anon_sym_envvars] = ACTIONS(1282),
    [anon_sym_include] = ACTIONS(1282),
    [anon_sym_pepfile] = ACTIONS(1282),
    [anon_sym_pepschema] = ACTIONS(1282),
    [anon_sym_scattergather] = ACTIONS(1282),
    [anon_sym_version] = ACTIONS(1282),
    [anon_sym_wildcard_constraints] = ACTIONS(1282),
    [anon_sym_workdir] = ACTIONS(1282),
    [anon_sym_onerror] = ACTIONS(1282),
    [anon_sym_onstart] = ACTIONS(1282),
    [anon_sym_onsuccess] = ACTIONS(1282),
    [anon_sym_localrules] = ACTIONS(1282),
    [anon_sym_ruleorder] = ACTIONS(1282),
    [anon_sym_rule] = ACTIONS(1282),
    [anon_sym_checkpoint] = ACTIONS(1282),
    [anon_sym_use] = ACTIONS(1282),
    [anon_sym_module] = ACTIONS(1282),
    [sym__dedent] = ACTIONS(1280),
    [sym_string_start] = ACTIONS(1280),
  },
  [419] = {
    [ts_builtin_sym_end] = ACTIONS(1438),
    [sym_identifier] = ACTIONS(1440),
    [anon_sym_import] = ACTIONS(1440),
    [anon_sym_from] = ACTIONS(1440),
    [anon_sym_LPAREN] = ACTIONS(1438),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_print] = ACTIONS(1440),
    [anon_sym_assert] = ACTIONS(1440),
    [anon_sym_return] = ACTIONS(1440),
    [anon_sym_del] = ACTIONS(1440),
    [anon_sym_raise] = ACTIONS(1440),
    [anon_sym_pass] = ACTIONS(1440),
    [anon_sym_break] = ACTIONS(1440),
    [anon_sym_continue] = ACTIONS(1440),
    [anon_sym_if] = ACTIONS(1440),
    [anon_sym_match] = ACTIONS(1440),
    [anon_sym_async] = ACTIONS(1440),
    [anon_sym_for] = ACTIONS(1440),
    [anon_sym_while] = ACTIONS(1440),
    [anon_sym_try] = ACTIONS(1440),
    [anon_sym_with] = ACTIONS(1440),
    [anon_sym_def] = ACTIONS(1440),
    [anon_sym_global] = ACTIONS(1440),
    [anon_sym_nonlocal] = ACTIONS(1440),
    [anon_sym_exec] = ACTIONS(1440),
    [anon_sym_type] = ACTIONS(1440),
    [anon_sym_class] = ACTIONS(1440),
    [anon_sym_LBRACK] = ACTIONS(1438),
    [anon_sym_AT] = ACTIONS(1438),
    [anon_sym_DASH] = ACTIONS(1438),
    [anon_sym_LBRACE] = ACTIONS(1438),
    [anon_sym_PLUS] = ACTIONS(1438),
    [anon_sym_not] = ACTIONS(1440),
    [anon_sym_TILDE] = ACTIONS(1438),
    [anon_sym_lambda] = ACTIONS(1440),
    [anon_sym_yield] = ACTIONS(1440),
    [sym_ellipsis] = ACTIONS(1438),
    [sym_integer] = ACTIONS(1440),
    [sym_float] = ACTIONS(1438),
    [anon_sym_await] = ACTIONS(1440),
    [sym_true] = ACTIONS(1440),
    [sym_false] = ACTIONS(1440),
    [sym_none] = ACTIONS(1440),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1440),
    [anon_sym_container] = ACTIONS(1440),
    [anon_sym_envvars] = ACTIONS(1440),
    [anon_sym_include] = ACTIONS(1440),
    [anon_sym_pepfile] = ACTIONS(1440),
    [anon_sym_pepschema] = ACTIONS(1440),
    [anon_sym_scattergather] = ACTIONS(1440),
    [anon_sym_version] = ACTIONS(1440),
    [anon_sym_wildcard_constraints] = ACTIONS(1440),
    [anon_sym_workdir] = ACTIONS(1440),
    [anon_sym_onerror] = ACTIONS(1440),
    [anon_sym_onstart] = ACTIONS(1440),
    [anon_sym_onsuccess] = ACTIONS(1440),
    [anon_sym_localrules] = ACTIONS(1440),
    [anon_sym_ruleorder] = ACTIONS(1440),
    [anon_sym_rule] = ACTIONS(1440),
    [anon_sym_checkpoint] = ACTIONS(1440),
    [anon_sym_use] = ACTIONS(1440),
    [anon_sym_module] = ACTIONS(1440),
    [sym_string_start] = ACTIONS(1438),
  },
  [420] = {
    [ts_builtin_sym_end] = ACTIONS(1442),
    [sym_identifier] = ACTIONS(1444),
    [anon_sym_import] = ACTIONS(1444),
    [anon_sym_from] = ACTIONS(1444),
    [anon_sym_LPAREN] = ACTIONS(1442),
    [anon_sym_STAR] = ACTIONS(1442),
    [anon_sym_print] = ACTIONS(1444),
    [anon_sym_assert] = ACTIONS(1444),
    [anon_sym_return] = ACTIONS(1444),
    [anon_sym_del] = ACTIONS(1444),
    [anon_sym_raise] = ACTIONS(1444),
    [anon_sym_pass] = ACTIONS(1444),
    [anon_sym_break] = ACTIONS(1444),
    [anon_sym_continue] = ACTIONS(1444),
    [anon_sym_if] = ACTIONS(1444),
    [anon_sym_match] = ACTIONS(1444),
    [anon_sym_async] = ACTIONS(1444),
    [anon_sym_for] = ACTIONS(1444),
    [anon_sym_while] = ACTIONS(1444),
    [anon_sym_try] = ACTIONS(1444),
    [anon_sym_with] = ACTIONS(1444),
    [anon_sym_def] = ACTIONS(1444),
    [anon_sym_global] = ACTIONS(1444),
    [anon_sym_nonlocal] = ACTIONS(1444),
    [anon_sym_exec] = ACTIONS(1444),
    [anon_sym_type] = ACTIONS(1444),
    [anon_sym_class] = ACTIONS(1444),
    [anon_sym_LBRACK] = ACTIONS(1442),
    [anon_sym_AT] = ACTIONS(1442),
    [anon_sym_DASH] = ACTIONS(1442),
    [anon_sym_LBRACE] = ACTIONS(1442),
    [anon_sym_PLUS] = ACTIONS(1442),
    [anon_sym_not] = ACTIONS(1444),
    [anon_sym_TILDE] = ACTIONS(1442),
    [anon_sym_lambda] = ACTIONS(1444),
    [anon_sym_yield] = ACTIONS(1444),
    [sym_ellipsis] = ACTIONS(1442),
    [sym_integer] = ACTIONS(1444),
    [sym_float] = ACTIONS(1442),
    [anon_sym_await] = ACTIONS(1444),
    [sym_true] = ACTIONS(1444),
    [sym_false] = ACTIONS(1444),
    [sym_none] = ACTIONS(1444),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1444),
    [anon_sym_container] = ACTIONS(1444),
    [anon_sym_envvars] = ACTIONS(1444),
    [anon_sym_include] = ACTIONS(1444),
    [anon_sym_pepfile] = ACTIONS(1444),
    [anon_sym_pepschema] = ACTIONS(1444),
    [anon_sym_scattergather] = ACTIONS(1444),
    [anon_sym_version] = ACTIONS(1444),
    [anon_sym_wildcard_constraints] = ACTIONS(1444),
    [anon_sym_workdir] = ACTIONS(1444),
    [anon_sym_onerror] = ACTIONS(1444),
    [anon_sym_onstart] = ACTIONS(1444),
    [anon_sym_onsuccess] = ACTIONS(1444),
    [anon_sym_localrules] = ACTIONS(1444),
    [anon_sym_ruleorder] = ACTIONS(1444),
    [anon_sym_rule] = ACTIONS(1444),
    [anon_sym_checkpoint] = ACTIONS(1444),
    [anon_sym_use] = ACTIONS(1444),
    [anon_sym_module] = ACTIONS(1444),
    [sym_string_start] = ACTIONS(1442),
  },
  [421] = {
    [ts_builtin_sym_end] = ACTIONS(1446),
    [sym_identifier] = ACTIONS(1448),
    [anon_sym_import] = ACTIONS(1448),
    [anon_sym_from] = ACTIONS(1448),
    [anon_sym_LPAREN] = ACTIONS(1446),
    [anon_sym_STAR] = ACTIONS(1446),
    [anon_sym_print] = ACTIONS(1448),
    [anon_sym_assert] = ACTIONS(1448),
    [anon_sym_return] = ACTIONS(1448),
    [anon_sym_del] = ACTIONS(1448),
    [anon_sym_raise] = ACTIONS(1448),
    [anon_sym_pass] = ACTIONS(1448),
    [anon_sym_break] = ACTIONS(1448),
    [anon_sym_continue] = ACTIONS(1448),
    [anon_sym_if] = ACTIONS(1448),
    [anon_sym_match] = ACTIONS(1448),
    [anon_sym_async] = ACTIONS(1448),
    [anon_sym_for] = ACTIONS(1448),
    [anon_sym_while] = ACTIONS(1448),
    [anon_sym_try] = ACTIONS(1448),
    [anon_sym_with] = ACTIONS(1448),
    [anon_sym_def] = ACTIONS(1448),
    [anon_sym_global] = ACTIONS(1448),
    [anon_sym_nonlocal] = ACTIONS(1448),
    [anon_sym_exec] = ACTIONS(1448),
    [anon_sym_type] = ACTIONS(1448),
    [anon_sym_class] = ACTIONS(1448),
    [anon_sym_LBRACK] = ACTIONS(1446),
    [anon_sym_AT] = ACTIONS(1446),
    [anon_sym_DASH] = ACTIONS(1446),
    [anon_sym_LBRACE] = ACTIONS(1446),
    [anon_sym_PLUS] = ACTIONS(1446),
    [anon_sym_not] = ACTIONS(1448),
    [anon_sym_TILDE] = ACTIONS(1446),
    [anon_sym_lambda] = ACTIONS(1448),
    [anon_sym_yield] = ACTIONS(1448),
    [sym_ellipsis] = ACTIONS(1446),
    [sym_integer] = ACTIONS(1448),
    [sym_float] = ACTIONS(1446),
    [anon_sym_await] = ACTIONS(1448),
    [sym_true] = ACTIONS(1448),
    [sym_false] = ACTIONS(1448),
    [sym_none] = ACTIONS(1448),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1448),
    [anon_sym_container] = ACTIONS(1448),
    [anon_sym_envvars] = ACTIONS(1448),
    [anon_sym_include] = ACTIONS(1448),
    [anon_sym_pepfile] = ACTIONS(1448),
    [anon_sym_pepschema] = ACTIONS(1448),
    [anon_sym_scattergather] = ACTIONS(1448),
    [anon_sym_version] = ACTIONS(1448),
    [anon_sym_wildcard_constraints] = ACTIONS(1448),
    [anon_sym_workdir] = ACTIONS(1448),
    [anon_sym_onerror] = ACTIONS(1448),
    [anon_sym_onstart] = ACTIONS(1448),
    [anon_sym_onsuccess] = ACTIONS(1448),
    [anon_sym_localrules] = ACTIONS(1448),
    [anon_sym_ruleorder] = ACTIONS(1448),
    [anon_sym_rule] = ACTIONS(1448),
    [anon_sym_checkpoint] = ACTIONS(1448),
    [anon_sym_use] = ACTIONS(1448),
    [anon_sym_module] = ACTIONS(1448),
    [sym_string_start] = ACTIONS(1446),
  },
  [422] = {
    [ts_builtin_sym_end] = ACTIONS(1450),
    [sym_identifier] = ACTIONS(1452),
    [anon_sym_import] = ACTIONS(1452),
    [anon_sym_from] = ACTIONS(1452),
    [anon_sym_LPAREN] = ACTIONS(1450),
    [anon_sym_STAR] = ACTIONS(1450),
    [anon_sym_print] = ACTIONS(1452),
    [anon_sym_assert] = ACTIONS(1452),
    [anon_sym_return] = ACTIONS(1452),
    [anon_sym_del] = ACTIONS(1452),
    [anon_sym_raise] = ACTIONS(1452),
    [anon_sym_pass] = ACTIONS(1452),
    [anon_sym_break] = ACTIONS(1452),
    [anon_sym_continue] = ACTIONS(1452),
    [anon_sym_if] = ACTIONS(1452),
    [anon_sym_match] = ACTIONS(1452),
    [anon_sym_async] = ACTIONS(1452),
    [anon_sym_for] = ACTIONS(1452),
    [anon_sym_while] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(1452),
    [anon_sym_with] = ACTIONS(1452),
    [anon_sym_def] = ACTIONS(1452),
    [anon_sym_global] = ACTIONS(1452),
    [anon_sym_nonlocal] = ACTIONS(1452),
    [anon_sym_exec] = ACTIONS(1452),
    [anon_sym_type] = ACTIONS(1452),
    [anon_sym_class] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_AT] = ACTIONS(1450),
    [anon_sym_DASH] = ACTIONS(1450),
    [anon_sym_LBRACE] = ACTIONS(1450),
    [anon_sym_PLUS] = ACTIONS(1450),
    [anon_sym_not] = ACTIONS(1452),
    [anon_sym_TILDE] = ACTIONS(1450),
    [anon_sym_lambda] = ACTIONS(1452),
    [anon_sym_yield] = ACTIONS(1452),
    [sym_ellipsis] = ACTIONS(1450),
    [sym_integer] = ACTIONS(1452),
    [sym_float] = ACTIONS(1450),
    [anon_sym_await] = ACTIONS(1452),
    [sym_true] = ACTIONS(1452),
    [sym_false] = ACTIONS(1452),
    [sym_none] = ACTIONS(1452),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1452),
    [anon_sym_container] = ACTIONS(1452),
    [anon_sym_envvars] = ACTIONS(1452),
    [anon_sym_include] = ACTIONS(1452),
    [anon_sym_pepfile] = ACTIONS(1452),
    [anon_sym_pepschema] = ACTIONS(1452),
    [anon_sym_scattergather] = ACTIONS(1452),
    [anon_sym_version] = ACTIONS(1452),
    [anon_sym_wildcard_constraints] = ACTIONS(1452),
    [anon_sym_workdir] = ACTIONS(1452),
    [anon_sym_onerror] = ACTIONS(1452),
    [anon_sym_onstart] = ACTIONS(1452),
    [anon_sym_onsuccess] = ACTIONS(1452),
    [anon_sym_localrules] = ACTIONS(1452),
    [anon_sym_ruleorder] = ACTIONS(1452),
    [anon_sym_rule] = ACTIONS(1452),
    [anon_sym_checkpoint] = ACTIONS(1452),
    [anon_sym_use] = ACTIONS(1452),
    [anon_sym_module] = ACTIONS(1452),
    [sym_string_start] = ACTIONS(1450),
  },
  [423] = {
    [sym_identifier] = ACTIONS(1444),
    [anon_sym_import] = ACTIONS(1444),
    [anon_sym_from] = ACTIONS(1444),
    [anon_sym_LPAREN] = ACTIONS(1442),
    [anon_sym_STAR] = ACTIONS(1442),
    [anon_sym_print] = ACTIONS(1444),
    [anon_sym_assert] = ACTIONS(1444),
    [anon_sym_return] = ACTIONS(1444),
    [anon_sym_del] = ACTIONS(1444),
    [anon_sym_raise] = ACTIONS(1444),
    [anon_sym_pass] = ACTIONS(1444),
    [anon_sym_break] = ACTIONS(1444),
    [anon_sym_continue] = ACTIONS(1444),
    [anon_sym_if] = ACTIONS(1444),
    [anon_sym_match] = ACTIONS(1444),
    [anon_sym_async] = ACTIONS(1444),
    [anon_sym_for] = ACTIONS(1444),
    [anon_sym_while] = ACTIONS(1444),
    [anon_sym_try] = ACTIONS(1444),
    [anon_sym_with] = ACTIONS(1444),
    [anon_sym_def] = ACTIONS(1444),
    [anon_sym_global] = ACTIONS(1444),
    [anon_sym_nonlocal] = ACTIONS(1444),
    [anon_sym_exec] = ACTIONS(1444),
    [anon_sym_type] = ACTIONS(1444),
    [anon_sym_class] = ACTIONS(1444),
    [anon_sym_LBRACK] = ACTIONS(1442),
    [anon_sym_AT] = ACTIONS(1442),
    [anon_sym_DASH] = ACTIONS(1442),
    [anon_sym_LBRACE] = ACTIONS(1442),
    [anon_sym_PLUS] = ACTIONS(1442),
    [anon_sym_not] = ACTIONS(1444),
    [anon_sym_TILDE] = ACTIONS(1442),
    [anon_sym_lambda] = ACTIONS(1444),
    [anon_sym_yield] = ACTIONS(1444),
    [sym_ellipsis] = ACTIONS(1442),
    [sym_integer] = ACTIONS(1444),
    [sym_float] = ACTIONS(1442),
    [anon_sym_await] = ACTIONS(1444),
    [sym_true] = ACTIONS(1444),
    [sym_false] = ACTIONS(1444),
    [sym_none] = ACTIONS(1444),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1444),
    [anon_sym_container] = ACTIONS(1444),
    [anon_sym_envvars] = ACTIONS(1444),
    [anon_sym_include] = ACTIONS(1444),
    [anon_sym_pepfile] = ACTIONS(1444),
    [anon_sym_pepschema] = ACTIONS(1444),
    [anon_sym_scattergather] = ACTIONS(1444),
    [anon_sym_version] = ACTIONS(1444),
    [anon_sym_wildcard_constraints] = ACTIONS(1444),
    [anon_sym_workdir] = ACTIONS(1444),
    [anon_sym_onerror] = ACTIONS(1444),
    [anon_sym_onstart] = ACTIONS(1444),
    [anon_sym_onsuccess] = ACTIONS(1444),
    [anon_sym_localrules] = ACTIONS(1444),
    [anon_sym_ruleorder] = ACTIONS(1444),
    [anon_sym_rule] = ACTIONS(1444),
    [anon_sym_checkpoint] = ACTIONS(1444),
    [anon_sym_use] = ACTIONS(1444),
    [anon_sym_module] = ACTIONS(1444),
    [sym__dedent] = ACTIONS(1442),
    [sym_string_start] = ACTIONS(1442),
  },
  [424] = {
    [sym_identifier] = ACTIONS(1432),
    [anon_sym_import] = ACTIONS(1432),
    [anon_sym_from] = ACTIONS(1432),
    [anon_sym_LPAREN] = ACTIONS(1430),
    [anon_sym_STAR] = ACTIONS(1430),
    [anon_sym_print] = ACTIONS(1432),
    [anon_sym_assert] = ACTIONS(1432),
    [anon_sym_return] = ACTIONS(1432),
    [anon_sym_del] = ACTIONS(1432),
    [anon_sym_raise] = ACTIONS(1432),
    [anon_sym_pass] = ACTIONS(1432),
    [anon_sym_break] = ACTIONS(1432),
    [anon_sym_continue] = ACTIONS(1432),
    [anon_sym_if] = ACTIONS(1432),
    [anon_sym_match] = ACTIONS(1432),
    [anon_sym_async] = ACTIONS(1432),
    [anon_sym_for] = ACTIONS(1432),
    [anon_sym_while] = ACTIONS(1432),
    [anon_sym_try] = ACTIONS(1432),
    [anon_sym_with] = ACTIONS(1432),
    [anon_sym_def] = ACTIONS(1432),
    [anon_sym_global] = ACTIONS(1432),
    [anon_sym_nonlocal] = ACTIONS(1432),
    [anon_sym_exec] = ACTIONS(1432),
    [anon_sym_type] = ACTIONS(1432),
    [anon_sym_class] = ACTIONS(1432),
    [anon_sym_LBRACK] = ACTIONS(1430),
    [anon_sym_AT] = ACTIONS(1430),
    [anon_sym_DASH] = ACTIONS(1430),
    [anon_sym_LBRACE] = ACTIONS(1430),
    [anon_sym_PLUS] = ACTIONS(1430),
    [anon_sym_not] = ACTIONS(1432),
    [anon_sym_TILDE] = ACTIONS(1430),
    [anon_sym_lambda] = ACTIONS(1432),
    [anon_sym_yield] = ACTIONS(1432),
    [sym_ellipsis] = ACTIONS(1430),
    [sym_integer] = ACTIONS(1432),
    [sym_float] = ACTIONS(1430),
    [anon_sym_await] = ACTIONS(1432),
    [sym_true] = ACTIONS(1432),
    [sym_false] = ACTIONS(1432),
    [sym_none] = ACTIONS(1432),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1432),
    [anon_sym_container] = ACTIONS(1432),
    [anon_sym_envvars] = ACTIONS(1432),
    [anon_sym_include] = ACTIONS(1432),
    [anon_sym_pepfile] = ACTIONS(1432),
    [anon_sym_pepschema] = ACTIONS(1432),
    [anon_sym_scattergather] = ACTIONS(1432),
    [anon_sym_version] = ACTIONS(1432),
    [anon_sym_wildcard_constraints] = ACTIONS(1432),
    [anon_sym_workdir] = ACTIONS(1432),
    [anon_sym_onerror] = ACTIONS(1432),
    [anon_sym_onstart] = ACTIONS(1432),
    [anon_sym_onsuccess] = ACTIONS(1432),
    [anon_sym_localrules] = ACTIONS(1432),
    [anon_sym_ruleorder] = ACTIONS(1432),
    [anon_sym_rule] = ACTIONS(1432),
    [anon_sym_checkpoint] = ACTIONS(1432),
    [anon_sym_use] = ACTIONS(1432),
    [anon_sym_module] = ACTIONS(1432),
    [sym__dedent] = ACTIONS(1430),
    [sym_string_start] = ACTIONS(1430),
  },
  [425] = {
    [sym_identifier] = ACTIONS(1262),
    [anon_sym_import] = ACTIONS(1262),
    [anon_sym_from] = ACTIONS(1262),
    [anon_sym_LPAREN] = ACTIONS(1260),
    [anon_sym_STAR] = ACTIONS(1260),
    [anon_sym_print] = ACTIONS(1262),
    [anon_sym_assert] = ACTIONS(1262),
    [anon_sym_return] = ACTIONS(1262),
    [anon_sym_del] = ACTIONS(1262),
    [anon_sym_raise] = ACTIONS(1262),
    [anon_sym_pass] = ACTIONS(1262),
    [anon_sym_break] = ACTIONS(1262),
    [anon_sym_continue] = ACTIONS(1262),
    [anon_sym_if] = ACTIONS(1262),
    [anon_sym_match] = ACTIONS(1262),
    [anon_sym_async] = ACTIONS(1262),
    [anon_sym_for] = ACTIONS(1262),
    [anon_sym_while] = ACTIONS(1262),
    [anon_sym_try] = ACTIONS(1262),
    [anon_sym_with] = ACTIONS(1262),
    [anon_sym_def] = ACTIONS(1262),
    [anon_sym_global] = ACTIONS(1262),
    [anon_sym_nonlocal] = ACTIONS(1262),
    [anon_sym_exec] = ACTIONS(1262),
    [anon_sym_type] = ACTIONS(1262),
    [anon_sym_class] = ACTIONS(1262),
    [anon_sym_LBRACK] = ACTIONS(1260),
    [anon_sym_AT] = ACTIONS(1260),
    [anon_sym_DASH] = ACTIONS(1260),
    [anon_sym_LBRACE] = ACTIONS(1260),
    [anon_sym_PLUS] = ACTIONS(1260),
    [anon_sym_not] = ACTIONS(1262),
    [anon_sym_TILDE] = ACTIONS(1260),
    [anon_sym_lambda] = ACTIONS(1262),
    [anon_sym_yield] = ACTIONS(1262),
    [sym_ellipsis] = ACTIONS(1260),
    [sym_integer] = ACTIONS(1262),
    [sym_float] = ACTIONS(1260),
    [anon_sym_await] = ACTIONS(1262),
    [sym_true] = ACTIONS(1262),
    [sym_false] = ACTIONS(1262),
    [sym_none] = ACTIONS(1262),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1262),
    [anon_sym_container] = ACTIONS(1262),
    [anon_sym_envvars] = ACTIONS(1262),
    [anon_sym_include] = ACTIONS(1262),
    [anon_sym_pepfile] = ACTIONS(1262),
    [anon_sym_pepschema] = ACTIONS(1262),
    [anon_sym_scattergather] = ACTIONS(1262),
    [anon_sym_version] = ACTIONS(1262),
    [anon_sym_wildcard_constraints] = ACTIONS(1262),
    [anon_sym_workdir] = ACTIONS(1262),
    [anon_sym_onerror] = ACTIONS(1262),
    [anon_sym_onstart] = ACTIONS(1262),
    [anon_sym_onsuccess] = ACTIONS(1262),
    [anon_sym_localrules] = ACTIONS(1262),
    [anon_sym_ruleorder] = ACTIONS(1262),
    [anon_sym_rule] = ACTIONS(1262),
    [anon_sym_checkpoint] = ACTIONS(1262),
    [anon_sym_use] = ACTIONS(1262),
    [anon_sym_module] = ACTIONS(1262),
    [sym__dedent] = ACTIONS(1260),
    [sym_string_start] = ACTIONS(1260),
  },
  [426] = {
    [sym_identifier] = ACTIONS(1258),
    [anon_sym_import] = ACTIONS(1258),
    [anon_sym_from] = ACTIONS(1258),
    [anon_sym_LPAREN] = ACTIONS(1256),
    [anon_sym_STAR] = ACTIONS(1256),
    [anon_sym_print] = ACTIONS(1258),
    [anon_sym_assert] = ACTIONS(1258),
    [anon_sym_return] = ACTIONS(1258),
    [anon_sym_del] = ACTIONS(1258),
    [anon_sym_raise] = ACTIONS(1258),
    [anon_sym_pass] = ACTIONS(1258),
    [anon_sym_break] = ACTIONS(1258),
    [anon_sym_continue] = ACTIONS(1258),
    [anon_sym_if] = ACTIONS(1258),
    [anon_sym_match] = ACTIONS(1258),
    [anon_sym_async] = ACTIONS(1258),
    [anon_sym_for] = ACTIONS(1258),
    [anon_sym_while] = ACTIONS(1258),
    [anon_sym_try] = ACTIONS(1258),
    [anon_sym_with] = ACTIONS(1258),
    [anon_sym_def] = ACTIONS(1258),
    [anon_sym_global] = ACTIONS(1258),
    [anon_sym_nonlocal] = ACTIONS(1258),
    [anon_sym_exec] = ACTIONS(1258),
    [anon_sym_type] = ACTIONS(1258),
    [anon_sym_class] = ACTIONS(1258),
    [anon_sym_LBRACK] = ACTIONS(1256),
    [anon_sym_AT] = ACTIONS(1256),
    [anon_sym_DASH] = ACTIONS(1256),
    [anon_sym_LBRACE] = ACTIONS(1256),
    [anon_sym_PLUS] = ACTIONS(1256),
    [anon_sym_not] = ACTIONS(1258),
    [anon_sym_TILDE] = ACTIONS(1256),
    [anon_sym_lambda] = ACTIONS(1258),
    [anon_sym_yield] = ACTIONS(1258),
    [sym_ellipsis] = ACTIONS(1256),
    [sym_integer] = ACTIONS(1258),
    [sym_float] = ACTIONS(1256),
    [anon_sym_await] = ACTIONS(1258),
    [sym_true] = ACTIONS(1258),
    [sym_false] = ACTIONS(1258),
    [sym_none] = ACTIONS(1258),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1258),
    [anon_sym_container] = ACTIONS(1258),
    [anon_sym_envvars] = ACTIONS(1258),
    [anon_sym_include] = ACTIONS(1258),
    [anon_sym_pepfile] = ACTIONS(1258),
    [anon_sym_pepschema] = ACTIONS(1258),
    [anon_sym_scattergather] = ACTIONS(1258),
    [anon_sym_version] = ACTIONS(1258),
    [anon_sym_wildcard_constraints] = ACTIONS(1258),
    [anon_sym_workdir] = ACTIONS(1258),
    [anon_sym_onerror] = ACTIONS(1258),
    [anon_sym_onstart] = ACTIONS(1258),
    [anon_sym_onsuccess] = ACTIONS(1258),
    [anon_sym_localrules] = ACTIONS(1258),
    [anon_sym_ruleorder] = ACTIONS(1258),
    [anon_sym_rule] = ACTIONS(1258),
    [anon_sym_checkpoint] = ACTIONS(1258),
    [anon_sym_use] = ACTIONS(1258),
    [anon_sym_module] = ACTIONS(1258),
    [sym__dedent] = ACTIONS(1256),
    [sym_string_start] = ACTIONS(1256),
  },
  [427] = {
    [ts_builtin_sym_end] = ACTIONS(1250),
    [sym_identifier] = ACTIONS(1248),
    [anon_sym_import] = ACTIONS(1248),
    [anon_sym_from] = ACTIONS(1248),
    [anon_sym_LPAREN] = ACTIONS(1250),
    [anon_sym_STAR] = ACTIONS(1250),
    [anon_sym_print] = ACTIONS(1248),
    [anon_sym_assert] = ACTIONS(1248),
    [anon_sym_return] = ACTIONS(1248),
    [anon_sym_del] = ACTIONS(1248),
    [anon_sym_raise] = ACTIONS(1248),
    [anon_sym_pass] = ACTIONS(1248),
    [anon_sym_break] = ACTIONS(1248),
    [anon_sym_continue] = ACTIONS(1248),
    [anon_sym_if] = ACTIONS(1248),
    [anon_sym_match] = ACTIONS(1248),
    [anon_sym_async] = ACTIONS(1248),
    [anon_sym_for] = ACTIONS(1248),
    [anon_sym_while] = ACTIONS(1248),
    [anon_sym_try] = ACTIONS(1248),
    [anon_sym_with] = ACTIONS(1248),
    [anon_sym_def] = ACTIONS(1248),
    [anon_sym_global] = ACTIONS(1248),
    [anon_sym_nonlocal] = ACTIONS(1248),
    [anon_sym_exec] = ACTIONS(1248),
    [anon_sym_type] = ACTIONS(1248),
    [anon_sym_class] = ACTIONS(1248),
    [anon_sym_LBRACK] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1250),
    [anon_sym_DASH] = ACTIONS(1250),
    [anon_sym_LBRACE] = ACTIONS(1250),
    [anon_sym_PLUS] = ACTIONS(1250),
    [anon_sym_not] = ACTIONS(1248),
    [anon_sym_TILDE] = ACTIONS(1250),
    [anon_sym_lambda] = ACTIONS(1248),
    [anon_sym_yield] = ACTIONS(1248),
    [sym_ellipsis] = ACTIONS(1250),
    [sym_integer] = ACTIONS(1248),
    [sym_float] = ACTIONS(1250),
    [anon_sym_await] = ACTIONS(1248),
    [sym_true] = ACTIONS(1248),
    [sym_false] = ACTIONS(1248),
    [sym_none] = ACTIONS(1248),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1248),
    [anon_sym_container] = ACTIONS(1248),
    [anon_sym_envvars] = ACTIONS(1248),
    [anon_sym_include] = ACTIONS(1248),
    [anon_sym_pepfile] = ACTIONS(1248),
    [anon_sym_pepschema] = ACTIONS(1248),
    [anon_sym_scattergather] = ACTIONS(1248),
    [anon_sym_version] = ACTIONS(1248),
    [anon_sym_wildcard_constraints] = ACTIONS(1248),
    [anon_sym_workdir] = ACTIONS(1248),
    [anon_sym_onerror] = ACTIONS(1248),
    [anon_sym_onstart] = ACTIONS(1248),
    [anon_sym_onsuccess] = ACTIONS(1248),
    [anon_sym_localrules] = ACTIONS(1248),
    [anon_sym_ruleorder] = ACTIONS(1248),
    [anon_sym_rule] = ACTIONS(1248),
    [anon_sym_checkpoint] = ACTIONS(1248),
    [anon_sym_use] = ACTIONS(1248),
    [anon_sym_module] = ACTIONS(1248),
    [sym_string_start] = ACTIONS(1250),
  },
  [428] = {
    [ts_builtin_sym_end] = ACTIONS(1454),
    [sym_identifier] = ACTIONS(1456),
    [anon_sym_import] = ACTIONS(1456),
    [anon_sym_from] = ACTIONS(1456),
    [anon_sym_LPAREN] = ACTIONS(1454),
    [anon_sym_STAR] = ACTIONS(1454),
    [anon_sym_print] = ACTIONS(1456),
    [anon_sym_assert] = ACTIONS(1456),
    [anon_sym_return] = ACTIONS(1456),
    [anon_sym_del] = ACTIONS(1456),
    [anon_sym_raise] = ACTIONS(1456),
    [anon_sym_pass] = ACTIONS(1456),
    [anon_sym_break] = ACTIONS(1456),
    [anon_sym_continue] = ACTIONS(1456),
    [anon_sym_if] = ACTIONS(1456),
    [anon_sym_match] = ACTIONS(1456),
    [anon_sym_async] = ACTIONS(1456),
    [anon_sym_for] = ACTIONS(1456),
    [anon_sym_while] = ACTIONS(1456),
    [anon_sym_try] = ACTIONS(1456),
    [anon_sym_with] = ACTIONS(1456),
    [anon_sym_def] = ACTIONS(1456),
    [anon_sym_global] = ACTIONS(1456),
    [anon_sym_nonlocal] = ACTIONS(1456),
    [anon_sym_exec] = ACTIONS(1456),
    [anon_sym_type] = ACTIONS(1456),
    [anon_sym_class] = ACTIONS(1456),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_AT] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1454),
    [anon_sym_PLUS] = ACTIONS(1454),
    [anon_sym_not] = ACTIONS(1456),
    [anon_sym_TILDE] = ACTIONS(1454),
    [anon_sym_lambda] = ACTIONS(1456),
    [anon_sym_yield] = ACTIONS(1456),
    [sym_ellipsis] = ACTIONS(1454),
    [sym_integer] = ACTIONS(1456),
    [sym_float] = ACTIONS(1454),
    [anon_sym_await] = ACTIONS(1456),
    [sym_true] = ACTIONS(1456),
    [sym_false] = ACTIONS(1456),
    [sym_none] = ACTIONS(1456),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1456),
    [anon_sym_container] = ACTIONS(1456),
    [anon_sym_envvars] = ACTIONS(1456),
    [anon_sym_include] = ACTIONS(1456),
    [anon_sym_pepfile] = ACTIONS(1456),
    [anon_sym_pepschema] = ACTIONS(1456),
    [anon_sym_scattergather] = ACTIONS(1456),
    [anon_sym_version] = ACTIONS(1456),
    [anon_sym_wildcard_constraints] = ACTIONS(1456),
    [anon_sym_workdir] = ACTIONS(1456),
    [anon_sym_onerror] = ACTIONS(1456),
    [anon_sym_onstart] = ACTIONS(1456),
    [anon_sym_onsuccess] = ACTIONS(1456),
    [anon_sym_localrules] = ACTIONS(1456),
    [anon_sym_ruleorder] = ACTIONS(1456),
    [anon_sym_rule] = ACTIONS(1456),
    [anon_sym_checkpoint] = ACTIONS(1456),
    [anon_sym_use] = ACTIONS(1456),
    [anon_sym_module] = ACTIONS(1456),
    [sym_string_start] = ACTIONS(1454),
  },
  [429] = {
    [sym_identifier] = ACTIONS(1254),
    [anon_sym_import] = ACTIONS(1254),
    [anon_sym_from] = ACTIONS(1254),
    [anon_sym_LPAREN] = ACTIONS(1252),
    [anon_sym_STAR] = ACTIONS(1252),
    [anon_sym_print] = ACTIONS(1254),
    [anon_sym_assert] = ACTIONS(1254),
    [anon_sym_return] = ACTIONS(1254),
    [anon_sym_del] = ACTIONS(1254),
    [anon_sym_raise] = ACTIONS(1254),
    [anon_sym_pass] = ACTIONS(1254),
    [anon_sym_break] = ACTIONS(1254),
    [anon_sym_continue] = ACTIONS(1254),
    [anon_sym_if] = ACTIONS(1254),
    [anon_sym_match] = ACTIONS(1254),
    [anon_sym_async] = ACTIONS(1254),
    [anon_sym_for] = ACTIONS(1254),
    [anon_sym_while] = ACTIONS(1254),
    [anon_sym_try] = ACTIONS(1254),
    [anon_sym_with] = ACTIONS(1254),
    [anon_sym_def] = ACTIONS(1254),
    [anon_sym_global] = ACTIONS(1254),
    [anon_sym_nonlocal] = ACTIONS(1254),
    [anon_sym_exec] = ACTIONS(1254),
    [anon_sym_type] = ACTIONS(1254),
    [anon_sym_class] = ACTIONS(1254),
    [anon_sym_LBRACK] = ACTIONS(1252),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_DASH] = ACTIONS(1252),
    [anon_sym_LBRACE] = ACTIONS(1252),
    [anon_sym_PLUS] = ACTIONS(1252),
    [anon_sym_not] = ACTIONS(1254),
    [anon_sym_TILDE] = ACTIONS(1252),
    [anon_sym_lambda] = ACTIONS(1254),
    [anon_sym_yield] = ACTIONS(1254),
    [sym_ellipsis] = ACTIONS(1252),
    [sym_integer] = ACTIONS(1254),
    [sym_float] = ACTIONS(1252),
    [anon_sym_await] = ACTIONS(1254),
    [sym_true] = ACTIONS(1254),
    [sym_false] = ACTIONS(1254),
    [sym_none] = ACTIONS(1254),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1254),
    [anon_sym_container] = ACTIONS(1254),
    [anon_sym_envvars] = ACTIONS(1254),
    [anon_sym_include] = ACTIONS(1254),
    [anon_sym_pepfile] = ACTIONS(1254),
    [anon_sym_pepschema] = ACTIONS(1254),
    [anon_sym_scattergather] = ACTIONS(1254),
    [anon_sym_version] = ACTIONS(1254),
    [anon_sym_wildcard_constraints] = ACTIONS(1254),
    [anon_sym_workdir] = ACTIONS(1254),
    [anon_sym_onerror] = ACTIONS(1254),
    [anon_sym_onstart] = ACTIONS(1254),
    [anon_sym_onsuccess] = ACTIONS(1254),
    [anon_sym_localrules] = ACTIONS(1254),
    [anon_sym_ruleorder] = ACTIONS(1254),
    [anon_sym_rule] = ACTIONS(1254),
    [anon_sym_checkpoint] = ACTIONS(1254),
    [anon_sym_use] = ACTIONS(1254),
    [anon_sym_module] = ACTIONS(1254),
    [sym__dedent] = ACTIONS(1252),
    [sym_string_start] = ACTIONS(1252),
  },
  [430] = {
    [ts_builtin_sym_end] = ACTIONS(1458),
    [sym_identifier] = ACTIONS(1460),
    [anon_sym_import] = ACTIONS(1460),
    [anon_sym_from] = ACTIONS(1460),
    [anon_sym_LPAREN] = ACTIONS(1458),
    [anon_sym_STAR] = ACTIONS(1458),
    [anon_sym_print] = ACTIONS(1460),
    [anon_sym_assert] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_del] = ACTIONS(1460),
    [anon_sym_raise] = ACTIONS(1460),
    [anon_sym_pass] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_match] = ACTIONS(1460),
    [anon_sym_async] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_try] = ACTIONS(1460),
    [anon_sym_with] = ACTIONS(1460),
    [anon_sym_def] = ACTIONS(1460),
    [anon_sym_global] = ACTIONS(1460),
    [anon_sym_nonlocal] = ACTIONS(1460),
    [anon_sym_exec] = ACTIONS(1460),
    [anon_sym_type] = ACTIONS(1460),
    [anon_sym_class] = ACTIONS(1460),
    [anon_sym_LBRACK] = ACTIONS(1458),
    [anon_sym_AT] = ACTIONS(1458),
    [anon_sym_DASH] = ACTIONS(1458),
    [anon_sym_LBRACE] = ACTIONS(1458),
    [anon_sym_PLUS] = ACTIONS(1458),
    [anon_sym_not] = ACTIONS(1460),
    [anon_sym_TILDE] = ACTIONS(1458),
    [anon_sym_lambda] = ACTIONS(1460),
    [anon_sym_yield] = ACTIONS(1460),
    [sym_ellipsis] = ACTIONS(1458),
    [sym_integer] = ACTIONS(1460),
    [sym_float] = ACTIONS(1458),
    [anon_sym_await] = ACTIONS(1460),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [sym_none] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1460),
    [anon_sym_container] = ACTIONS(1460),
    [anon_sym_envvars] = ACTIONS(1460),
    [anon_sym_include] = ACTIONS(1460),
    [anon_sym_pepfile] = ACTIONS(1460),
    [anon_sym_pepschema] = ACTIONS(1460),
    [anon_sym_scattergather] = ACTIONS(1460),
    [anon_sym_version] = ACTIONS(1460),
    [anon_sym_wildcard_constraints] = ACTIONS(1460),
    [anon_sym_workdir] = ACTIONS(1460),
    [anon_sym_onerror] = ACTIONS(1460),
    [anon_sym_onstart] = ACTIONS(1460),
    [anon_sym_onsuccess] = ACTIONS(1460),
    [anon_sym_localrules] = ACTIONS(1460),
    [anon_sym_ruleorder] = ACTIONS(1460),
    [anon_sym_rule] = ACTIONS(1460),
    [anon_sym_checkpoint] = ACTIONS(1460),
    [anon_sym_use] = ACTIONS(1460),
    [anon_sym_module] = ACTIONS(1460),
    [sym_string_start] = ACTIONS(1458),
  },
  [431] = {
    [ts_builtin_sym_end] = ACTIONS(1462),
    [sym_identifier] = ACTIONS(1464),
    [anon_sym_import] = ACTIONS(1464),
    [anon_sym_from] = ACTIONS(1464),
    [anon_sym_LPAREN] = ACTIONS(1462),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_print] = ACTIONS(1464),
    [anon_sym_assert] = ACTIONS(1464),
    [anon_sym_return] = ACTIONS(1464),
    [anon_sym_del] = ACTIONS(1464),
    [anon_sym_raise] = ACTIONS(1464),
    [anon_sym_pass] = ACTIONS(1464),
    [anon_sym_break] = ACTIONS(1464),
    [anon_sym_continue] = ACTIONS(1464),
    [anon_sym_if] = ACTIONS(1464),
    [anon_sym_match] = ACTIONS(1464),
    [anon_sym_async] = ACTIONS(1464),
    [anon_sym_for] = ACTIONS(1464),
    [anon_sym_while] = ACTIONS(1464),
    [anon_sym_try] = ACTIONS(1464),
    [anon_sym_with] = ACTIONS(1464),
    [anon_sym_def] = ACTIONS(1464),
    [anon_sym_global] = ACTIONS(1464),
    [anon_sym_nonlocal] = ACTIONS(1464),
    [anon_sym_exec] = ACTIONS(1464),
    [anon_sym_type] = ACTIONS(1464),
    [anon_sym_class] = ACTIONS(1464),
    [anon_sym_LBRACK] = ACTIONS(1462),
    [anon_sym_AT] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1462),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_PLUS] = ACTIONS(1462),
    [anon_sym_not] = ACTIONS(1464),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_lambda] = ACTIONS(1464),
    [anon_sym_yield] = ACTIONS(1464),
    [sym_ellipsis] = ACTIONS(1462),
    [sym_integer] = ACTIONS(1464),
    [sym_float] = ACTIONS(1462),
    [anon_sym_await] = ACTIONS(1464),
    [sym_true] = ACTIONS(1464),
    [sym_false] = ACTIONS(1464),
    [sym_none] = ACTIONS(1464),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1464),
    [anon_sym_container] = ACTIONS(1464),
    [anon_sym_envvars] = ACTIONS(1464),
    [anon_sym_include] = ACTIONS(1464),
    [anon_sym_pepfile] = ACTIONS(1464),
    [anon_sym_pepschema] = ACTIONS(1464),
    [anon_sym_scattergather] = ACTIONS(1464),
    [anon_sym_version] = ACTIONS(1464),
    [anon_sym_wildcard_constraints] = ACTIONS(1464),
    [anon_sym_workdir] = ACTIONS(1464),
    [anon_sym_onerror] = ACTIONS(1464),
    [anon_sym_onstart] = ACTIONS(1464),
    [anon_sym_onsuccess] = ACTIONS(1464),
    [anon_sym_localrules] = ACTIONS(1464),
    [anon_sym_ruleorder] = ACTIONS(1464),
    [anon_sym_rule] = ACTIONS(1464),
    [anon_sym_checkpoint] = ACTIONS(1464),
    [anon_sym_use] = ACTIONS(1464),
    [anon_sym_module] = ACTIONS(1464),
    [sym_string_start] = ACTIONS(1462),
  },
  [432] = {
    [sym_identifier] = ACTIONS(1456),
    [anon_sym_import] = ACTIONS(1456),
    [anon_sym_from] = ACTIONS(1456),
    [anon_sym_LPAREN] = ACTIONS(1454),
    [anon_sym_STAR] = ACTIONS(1454),
    [anon_sym_print] = ACTIONS(1456),
    [anon_sym_assert] = ACTIONS(1456),
    [anon_sym_return] = ACTIONS(1456),
    [anon_sym_del] = ACTIONS(1456),
    [anon_sym_raise] = ACTIONS(1456),
    [anon_sym_pass] = ACTIONS(1456),
    [anon_sym_break] = ACTIONS(1456),
    [anon_sym_continue] = ACTIONS(1456),
    [anon_sym_if] = ACTIONS(1456),
    [anon_sym_match] = ACTIONS(1456),
    [anon_sym_async] = ACTIONS(1456),
    [anon_sym_for] = ACTIONS(1456),
    [anon_sym_while] = ACTIONS(1456),
    [anon_sym_try] = ACTIONS(1456),
    [anon_sym_with] = ACTIONS(1456),
    [anon_sym_def] = ACTIONS(1456),
    [anon_sym_global] = ACTIONS(1456),
    [anon_sym_nonlocal] = ACTIONS(1456),
    [anon_sym_exec] = ACTIONS(1456),
    [anon_sym_type] = ACTIONS(1456),
    [anon_sym_class] = ACTIONS(1456),
    [anon_sym_LBRACK] = ACTIONS(1454),
    [anon_sym_AT] = ACTIONS(1454),
    [anon_sym_DASH] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(1454),
    [anon_sym_PLUS] = ACTIONS(1454),
    [anon_sym_not] = ACTIONS(1456),
    [anon_sym_TILDE] = ACTIONS(1454),
    [anon_sym_lambda] = ACTIONS(1456),
    [anon_sym_yield] = ACTIONS(1456),
    [sym_ellipsis] = ACTIONS(1454),
    [sym_integer] = ACTIONS(1456),
    [sym_float] = ACTIONS(1454),
    [anon_sym_await] = ACTIONS(1456),
    [sym_true] = ACTIONS(1456),
    [sym_false] = ACTIONS(1456),
    [sym_none] = ACTIONS(1456),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1456),
    [anon_sym_container] = ACTIONS(1456),
    [anon_sym_envvars] = ACTIONS(1456),
    [anon_sym_include] = ACTIONS(1456),
    [anon_sym_pepfile] = ACTIONS(1456),
    [anon_sym_pepschema] = ACTIONS(1456),
    [anon_sym_scattergather] = ACTIONS(1456),
    [anon_sym_version] = ACTIONS(1456),
    [anon_sym_wildcard_constraints] = ACTIONS(1456),
    [anon_sym_workdir] = ACTIONS(1456),
    [anon_sym_onerror] = ACTIONS(1456),
    [anon_sym_onstart] = ACTIONS(1456),
    [anon_sym_onsuccess] = ACTIONS(1456),
    [anon_sym_localrules] = ACTIONS(1456),
    [anon_sym_ruleorder] = ACTIONS(1456),
    [anon_sym_rule] = ACTIONS(1456),
    [anon_sym_checkpoint] = ACTIONS(1456),
    [anon_sym_use] = ACTIONS(1456),
    [anon_sym_module] = ACTIONS(1456),
    [sym__dedent] = ACTIONS(1454),
    [sym_string_start] = ACTIONS(1454),
  },
  [433] = {
    [ts_builtin_sym_end] = ACTIONS(1466),
    [sym_identifier] = ACTIONS(1468),
    [anon_sym_import] = ACTIONS(1468),
    [anon_sym_from] = ACTIONS(1468),
    [anon_sym_LPAREN] = ACTIONS(1466),
    [anon_sym_STAR] = ACTIONS(1466),
    [anon_sym_print] = ACTIONS(1468),
    [anon_sym_assert] = ACTIONS(1468),
    [anon_sym_return] = ACTIONS(1468),
    [anon_sym_del] = ACTIONS(1468),
    [anon_sym_raise] = ACTIONS(1468),
    [anon_sym_pass] = ACTIONS(1468),
    [anon_sym_break] = ACTIONS(1468),
    [anon_sym_continue] = ACTIONS(1468),
    [anon_sym_if] = ACTIONS(1468),
    [anon_sym_match] = ACTIONS(1468),
    [anon_sym_async] = ACTIONS(1468),
    [anon_sym_for] = ACTIONS(1468),
    [anon_sym_while] = ACTIONS(1468),
    [anon_sym_try] = ACTIONS(1468),
    [anon_sym_with] = ACTIONS(1468),
    [anon_sym_def] = ACTIONS(1468),
    [anon_sym_global] = ACTIONS(1468),
    [anon_sym_nonlocal] = ACTIONS(1468),
    [anon_sym_exec] = ACTIONS(1468),
    [anon_sym_type] = ACTIONS(1468),
    [anon_sym_class] = ACTIONS(1468),
    [anon_sym_LBRACK] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1466),
    [anon_sym_DASH] = ACTIONS(1466),
    [anon_sym_LBRACE] = ACTIONS(1466),
    [anon_sym_PLUS] = ACTIONS(1466),
    [anon_sym_not] = ACTIONS(1468),
    [anon_sym_TILDE] = ACTIONS(1466),
    [anon_sym_lambda] = ACTIONS(1468),
    [anon_sym_yield] = ACTIONS(1468),
    [sym_ellipsis] = ACTIONS(1466),
    [sym_integer] = ACTIONS(1468),
    [sym_float] = ACTIONS(1466),
    [anon_sym_await] = ACTIONS(1468),
    [sym_true] = ACTIONS(1468),
    [sym_false] = ACTIONS(1468),
    [sym_none] = ACTIONS(1468),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1468),
    [anon_sym_container] = ACTIONS(1468),
    [anon_sym_envvars] = ACTIONS(1468),
    [anon_sym_include] = ACTIONS(1468),
    [anon_sym_pepfile] = ACTIONS(1468),
    [anon_sym_pepschema] = ACTIONS(1468),
    [anon_sym_scattergather] = ACTIONS(1468),
    [anon_sym_version] = ACTIONS(1468),
    [anon_sym_wildcard_constraints] = ACTIONS(1468),
    [anon_sym_workdir] = ACTIONS(1468),
    [anon_sym_onerror] = ACTIONS(1468),
    [anon_sym_onstart] = ACTIONS(1468),
    [anon_sym_onsuccess] = ACTIONS(1468),
    [anon_sym_localrules] = ACTIONS(1468),
    [anon_sym_ruleorder] = ACTIONS(1468),
    [anon_sym_rule] = ACTIONS(1468),
    [anon_sym_checkpoint] = ACTIONS(1468),
    [anon_sym_use] = ACTIONS(1468),
    [anon_sym_module] = ACTIONS(1468),
    [sym_string_start] = ACTIONS(1466),
  },
  [434] = {
    [sym_identifier] = ACTIONS(1406),
    [anon_sym_import] = ACTIONS(1406),
    [anon_sym_from] = ACTIONS(1406),
    [anon_sym_LPAREN] = ACTIONS(1404),
    [anon_sym_STAR] = ACTIONS(1404),
    [anon_sym_print] = ACTIONS(1406),
    [anon_sym_assert] = ACTIONS(1406),
    [anon_sym_return] = ACTIONS(1406),
    [anon_sym_del] = ACTIONS(1406),
    [anon_sym_raise] = ACTIONS(1406),
    [anon_sym_pass] = ACTIONS(1406),
    [anon_sym_break] = ACTIONS(1406),
    [anon_sym_continue] = ACTIONS(1406),
    [anon_sym_if] = ACTIONS(1406),
    [anon_sym_match] = ACTIONS(1406),
    [anon_sym_async] = ACTIONS(1406),
    [anon_sym_for] = ACTIONS(1406),
    [anon_sym_while] = ACTIONS(1406),
    [anon_sym_try] = ACTIONS(1406),
    [anon_sym_with] = ACTIONS(1406),
    [anon_sym_def] = ACTIONS(1406),
    [anon_sym_global] = ACTIONS(1406),
    [anon_sym_nonlocal] = ACTIONS(1406),
    [anon_sym_exec] = ACTIONS(1406),
    [anon_sym_type] = ACTIONS(1406),
    [anon_sym_class] = ACTIONS(1406),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_AT] = ACTIONS(1404),
    [anon_sym_DASH] = ACTIONS(1404),
    [anon_sym_LBRACE] = ACTIONS(1404),
    [anon_sym_PLUS] = ACTIONS(1404),
    [anon_sym_not] = ACTIONS(1406),
    [anon_sym_TILDE] = ACTIONS(1404),
    [anon_sym_lambda] = ACTIONS(1406),
    [anon_sym_yield] = ACTIONS(1406),
    [sym_ellipsis] = ACTIONS(1404),
    [sym_integer] = ACTIONS(1406),
    [sym_float] = ACTIONS(1404),
    [anon_sym_await] = ACTIONS(1406),
    [sym_true] = ACTIONS(1406),
    [sym_false] = ACTIONS(1406),
    [sym_none] = ACTIONS(1406),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1406),
    [anon_sym_container] = ACTIONS(1406),
    [anon_sym_envvars] = ACTIONS(1406),
    [anon_sym_include] = ACTIONS(1406),
    [anon_sym_pepfile] = ACTIONS(1406),
    [anon_sym_pepschema] = ACTIONS(1406),
    [anon_sym_scattergather] = ACTIONS(1406),
    [anon_sym_version] = ACTIONS(1406),
    [anon_sym_wildcard_constraints] = ACTIONS(1406),
    [anon_sym_workdir] = ACTIONS(1406),
    [anon_sym_onerror] = ACTIONS(1406),
    [anon_sym_onstart] = ACTIONS(1406),
    [anon_sym_onsuccess] = ACTIONS(1406),
    [anon_sym_localrules] = ACTIONS(1406),
    [anon_sym_ruleorder] = ACTIONS(1406),
    [anon_sym_rule] = ACTIONS(1406),
    [anon_sym_checkpoint] = ACTIONS(1406),
    [anon_sym_use] = ACTIONS(1406),
    [anon_sym_module] = ACTIONS(1406),
    [sym__dedent] = ACTIONS(1404),
    [sym_string_start] = ACTIONS(1404),
  },
  [435] = {
    [ts_builtin_sym_end] = ACTIONS(1470),
    [sym_identifier] = ACTIONS(1472),
    [anon_sym_import] = ACTIONS(1472),
    [anon_sym_from] = ACTIONS(1472),
    [anon_sym_LPAREN] = ACTIONS(1470),
    [anon_sym_STAR] = ACTIONS(1470),
    [anon_sym_print] = ACTIONS(1472),
    [anon_sym_assert] = ACTIONS(1472),
    [anon_sym_return] = ACTIONS(1472),
    [anon_sym_del] = ACTIONS(1472),
    [anon_sym_raise] = ACTIONS(1472),
    [anon_sym_pass] = ACTIONS(1472),
    [anon_sym_break] = ACTIONS(1472),
    [anon_sym_continue] = ACTIONS(1472),
    [anon_sym_if] = ACTIONS(1472),
    [anon_sym_match] = ACTIONS(1472),
    [anon_sym_async] = ACTIONS(1472),
    [anon_sym_for] = ACTIONS(1472),
    [anon_sym_while] = ACTIONS(1472),
    [anon_sym_try] = ACTIONS(1472),
    [anon_sym_with] = ACTIONS(1472),
    [anon_sym_def] = ACTIONS(1472),
    [anon_sym_global] = ACTIONS(1472),
    [anon_sym_nonlocal] = ACTIONS(1472),
    [anon_sym_exec] = ACTIONS(1472),
    [anon_sym_type] = ACTIONS(1472),
    [anon_sym_class] = ACTIONS(1472),
    [anon_sym_LBRACK] = ACTIONS(1470),
    [anon_sym_AT] = ACTIONS(1470),
    [anon_sym_DASH] = ACTIONS(1470),
    [anon_sym_LBRACE] = ACTIONS(1470),
    [anon_sym_PLUS] = ACTIONS(1470),
    [anon_sym_not] = ACTIONS(1472),
    [anon_sym_TILDE] = ACTIONS(1470),
    [anon_sym_lambda] = ACTIONS(1472),
    [anon_sym_yield] = ACTIONS(1472),
    [sym_ellipsis] = ACTIONS(1470),
    [sym_integer] = ACTIONS(1472),
    [sym_float] = ACTIONS(1470),
    [anon_sym_await] = ACTIONS(1472),
    [sym_true] = ACTIONS(1472),
    [sym_false] = ACTIONS(1472),
    [sym_none] = ACTIONS(1472),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1472),
    [anon_sym_container] = ACTIONS(1472),
    [anon_sym_envvars] = ACTIONS(1472),
    [anon_sym_include] = ACTIONS(1472),
    [anon_sym_pepfile] = ACTIONS(1472),
    [anon_sym_pepschema] = ACTIONS(1472),
    [anon_sym_scattergather] = ACTIONS(1472),
    [anon_sym_version] = ACTIONS(1472),
    [anon_sym_wildcard_constraints] = ACTIONS(1472),
    [anon_sym_workdir] = ACTIONS(1472),
    [anon_sym_onerror] = ACTIONS(1472),
    [anon_sym_onstart] = ACTIONS(1472),
    [anon_sym_onsuccess] = ACTIONS(1472),
    [anon_sym_localrules] = ACTIONS(1472),
    [anon_sym_ruleorder] = ACTIONS(1472),
    [anon_sym_rule] = ACTIONS(1472),
    [anon_sym_checkpoint] = ACTIONS(1472),
    [anon_sym_use] = ACTIONS(1472),
    [anon_sym_module] = ACTIONS(1472),
    [sym_string_start] = ACTIONS(1470),
  },
  [436] = {
    [sym_identifier] = ACTIONS(1418),
    [anon_sym_import] = ACTIONS(1418),
    [anon_sym_from] = ACTIONS(1418),
    [anon_sym_LPAREN] = ACTIONS(1416),
    [anon_sym_STAR] = ACTIONS(1416),
    [anon_sym_print] = ACTIONS(1418),
    [anon_sym_assert] = ACTIONS(1418),
    [anon_sym_return] = ACTIONS(1418),
    [anon_sym_del] = ACTIONS(1418),
    [anon_sym_raise] = ACTIONS(1418),
    [anon_sym_pass] = ACTIONS(1418),
    [anon_sym_break] = ACTIONS(1418),
    [anon_sym_continue] = ACTIONS(1418),
    [anon_sym_if] = ACTIONS(1418),
    [anon_sym_match] = ACTIONS(1418),
    [anon_sym_async] = ACTIONS(1418),
    [anon_sym_for] = ACTIONS(1418),
    [anon_sym_while] = ACTIONS(1418),
    [anon_sym_try] = ACTIONS(1418),
    [anon_sym_with] = ACTIONS(1418),
    [anon_sym_def] = ACTIONS(1418),
    [anon_sym_global] = ACTIONS(1418),
    [anon_sym_nonlocal] = ACTIONS(1418),
    [anon_sym_exec] = ACTIONS(1418),
    [anon_sym_type] = ACTIONS(1418),
    [anon_sym_class] = ACTIONS(1418),
    [anon_sym_LBRACK] = ACTIONS(1416),
    [anon_sym_AT] = ACTIONS(1416),
    [anon_sym_DASH] = ACTIONS(1416),
    [anon_sym_LBRACE] = ACTIONS(1416),
    [anon_sym_PLUS] = ACTIONS(1416),
    [anon_sym_not] = ACTIONS(1418),
    [anon_sym_TILDE] = ACTIONS(1416),
    [anon_sym_lambda] = ACTIONS(1418),
    [anon_sym_yield] = ACTIONS(1418),
    [sym_ellipsis] = ACTIONS(1416),
    [sym_integer] = ACTIONS(1418),
    [sym_float] = ACTIONS(1416),
    [anon_sym_await] = ACTIONS(1418),
    [sym_true] = ACTIONS(1418),
    [sym_false] = ACTIONS(1418),
    [sym_none] = ACTIONS(1418),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1418),
    [anon_sym_container] = ACTIONS(1418),
    [anon_sym_envvars] = ACTIONS(1418),
    [anon_sym_include] = ACTIONS(1418),
    [anon_sym_pepfile] = ACTIONS(1418),
    [anon_sym_pepschema] = ACTIONS(1418),
    [anon_sym_scattergather] = ACTIONS(1418),
    [anon_sym_version] = ACTIONS(1418),
    [anon_sym_wildcard_constraints] = ACTIONS(1418),
    [anon_sym_workdir] = ACTIONS(1418),
    [anon_sym_onerror] = ACTIONS(1418),
    [anon_sym_onstart] = ACTIONS(1418),
    [anon_sym_onsuccess] = ACTIONS(1418),
    [anon_sym_localrules] = ACTIONS(1418),
    [anon_sym_ruleorder] = ACTIONS(1418),
    [anon_sym_rule] = ACTIONS(1418),
    [anon_sym_checkpoint] = ACTIONS(1418),
    [anon_sym_use] = ACTIONS(1418),
    [anon_sym_module] = ACTIONS(1418),
    [sym__dedent] = ACTIONS(1416),
    [sym_string_start] = ACTIONS(1416),
  },
  [437] = {
    [ts_builtin_sym_end] = ACTIONS(1474),
    [sym_identifier] = ACTIONS(1476),
    [anon_sym_import] = ACTIONS(1476),
    [anon_sym_from] = ACTIONS(1476),
    [anon_sym_LPAREN] = ACTIONS(1474),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_print] = ACTIONS(1476),
    [anon_sym_assert] = ACTIONS(1476),
    [anon_sym_return] = ACTIONS(1476),
    [anon_sym_del] = ACTIONS(1476),
    [anon_sym_raise] = ACTIONS(1476),
    [anon_sym_pass] = ACTIONS(1476),
    [anon_sym_break] = ACTIONS(1476),
    [anon_sym_continue] = ACTIONS(1476),
    [anon_sym_if] = ACTIONS(1476),
    [anon_sym_match] = ACTIONS(1476),
    [anon_sym_async] = ACTIONS(1476),
    [anon_sym_for] = ACTIONS(1476),
    [anon_sym_while] = ACTIONS(1476),
    [anon_sym_try] = ACTIONS(1476),
    [anon_sym_with] = ACTIONS(1476),
    [anon_sym_def] = ACTIONS(1476),
    [anon_sym_global] = ACTIONS(1476),
    [anon_sym_nonlocal] = ACTIONS(1476),
    [anon_sym_exec] = ACTIONS(1476),
    [anon_sym_type] = ACTIONS(1476),
    [anon_sym_class] = ACTIONS(1476),
    [anon_sym_LBRACK] = ACTIONS(1474),
    [anon_sym_AT] = ACTIONS(1474),
    [anon_sym_DASH] = ACTIONS(1474),
    [anon_sym_LBRACE] = ACTIONS(1474),
    [anon_sym_PLUS] = ACTIONS(1474),
    [anon_sym_not] = ACTIONS(1476),
    [anon_sym_TILDE] = ACTIONS(1474),
    [anon_sym_lambda] = ACTIONS(1476),
    [anon_sym_yield] = ACTIONS(1476),
    [sym_ellipsis] = ACTIONS(1474),
    [sym_integer] = ACTIONS(1476),
    [sym_float] = ACTIONS(1474),
    [anon_sym_await] = ACTIONS(1476),
    [sym_true] = ACTIONS(1476),
    [sym_false] = ACTIONS(1476),
    [sym_none] = ACTIONS(1476),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1476),
    [anon_sym_container] = ACTIONS(1476),
    [anon_sym_envvars] = ACTIONS(1476),
    [anon_sym_include] = ACTIONS(1476),
    [anon_sym_pepfile] = ACTIONS(1476),
    [anon_sym_pepschema] = ACTIONS(1476),
    [anon_sym_scattergather] = ACTIONS(1476),
    [anon_sym_version] = ACTIONS(1476),
    [anon_sym_wildcard_constraints] = ACTIONS(1476),
    [anon_sym_workdir] = ACTIONS(1476),
    [anon_sym_onerror] = ACTIONS(1476),
    [anon_sym_onstart] = ACTIONS(1476),
    [anon_sym_onsuccess] = ACTIONS(1476),
    [anon_sym_localrules] = ACTIONS(1476),
    [anon_sym_ruleorder] = ACTIONS(1476),
    [anon_sym_rule] = ACTIONS(1476),
    [anon_sym_checkpoint] = ACTIONS(1476),
    [anon_sym_use] = ACTIONS(1476),
    [anon_sym_module] = ACTIONS(1476),
    [sym_string_start] = ACTIONS(1474),
  },
  [438] = {
    [ts_builtin_sym_end] = ACTIONS(1478),
    [sym_identifier] = ACTIONS(1480),
    [anon_sym_import] = ACTIONS(1480),
    [anon_sym_from] = ACTIONS(1480),
    [anon_sym_LPAREN] = ACTIONS(1478),
    [anon_sym_STAR] = ACTIONS(1478),
    [anon_sym_print] = ACTIONS(1480),
    [anon_sym_assert] = ACTIONS(1480),
    [anon_sym_return] = ACTIONS(1480),
    [anon_sym_del] = ACTIONS(1480),
    [anon_sym_raise] = ACTIONS(1480),
    [anon_sym_pass] = ACTIONS(1480),
    [anon_sym_break] = ACTIONS(1480),
    [anon_sym_continue] = ACTIONS(1480),
    [anon_sym_if] = ACTIONS(1480),
    [anon_sym_match] = ACTIONS(1480),
    [anon_sym_async] = ACTIONS(1480),
    [anon_sym_for] = ACTIONS(1480),
    [anon_sym_while] = ACTIONS(1480),
    [anon_sym_try] = ACTIONS(1480),
    [anon_sym_with] = ACTIONS(1480),
    [anon_sym_def] = ACTIONS(1480),
    [anon_sym_global] = ACTIONS(1480),
    [anon_sym_nonlocal] = ACTIONS(1480),
    [anon_sym_exec] = ACTIONS(1480),
    [anon_sym_type] = ACTIONS(1480),
    [anon_sym_class] = ACTIONS(1480),
    [anon_sym_LBRACK] = ACTIONS(1478),
    [anon_sym_AT] = ACTIONS(1478),
    [anon_sym_DASH] = ACTIONS(1478),
    [anon_sym_LBRACE] = ACTIONS(1478),
    [anon_sym_PLUS] = ACTIONS(1478),
    [anon_sym_not] = ACTIONS(1480),
    [anon_sym_TILDE] = ACTIONS(1478),
    [anon_sym_lambda] = ACTIONS(1480),
    [anon_sym_yield] = ACTIONS(1480),
    [sym_ellipsis] = ACTIONS(1478),
    [sym_integer] = ACTIONS(1480),
    [sym_float] = ACTIONS(1478),
    [anon_sym_await] = ACTIONS(1480),
    [sym_true] = ACTIONS(1480),
    [sym_false] = ACTIONS(1480),
    [sym_none] = ACTIONS(1480),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1480),
    [anon_sym_container] = ACTIONS(1480),
    [anon_sym_envvars] = ACTIONS(1480),
    [anon_sym_include] = ACTIONS(1480),
    [anon_sym_pepfile] = ACTIONS(1480),
    [anon_sym_pepschema] = ACTIONS(1480),
    [anon_sym_scattergather] = ACTIONS(1480),
    [anon_sym_version] = ACTIONS(1480),
    [anon_sym_wildcard_constraints] = ACTIONS(1480),
    [anon_sym_workdir] = ACTIONS(1480),
    [anon_sym_onerror] = ACTIONS(1480),
    [anon_sym_onstart] = ACTIONS(1480),
    [anon_sym_onsuccess] = ACTIONS(1480),
    [anon_sym_localrules] = ACTIONS(1480),
    [anon_sym_ruleorder] = ACTIONS(1480),
    [anon_sym_rule] = ACTIONS(1480),
    [anon_sym_checkpoint] = ACTIONS(1480),
    [anon_sym_use] = ACTIONS(1480),
    [anon_sym_module] = ACTIONS(1480),
    [sym_string_start] = ACTIONS(1478),
  },
  [439] = {
    [ts_builtin_sym_end] = ACTIONS(1482),
    [sym_identifier] = ACTIONS(1484),
    [anon_sym_import] = ACTIONS(1484),
    [anon_sym_from] = ACTIONS(1484),
    [anon_sym_LPAREN] = ACTIONS(1482),
    [anon_sym_STAR] = ACTIONS(1482),
    [anon_sym_print] = ACTIONS(1484),
    [anon_sym_assert] = ACTIONS(1484),
    [anon_sym_return] = ACTIONS(1484),
    [anon_sym_del] = ACTIONS(1484),
    [anon_sym_raise] = ACTIONS(1484),
    [anon_sym_pass] = ACTIONS(1484),
    [anon_sym_break] = ACTIONS(1484),
    [anon_sym_continue] = ACTIONS(1484),
    [anon_sym_if] = ACTIONS(1484),
    [anon_sym_match] = ACTIONS(1484),
    [anon_sym_async] = ACTIONS(1484),
    [anon_sym_for] = ACTIONS(1484),
    [anon_sym_while] = ACTIONS(1484),
    [anon_sym_try] = ACTIONS(1484),
    [anon_sym_with] = ACTIONS(1484),
    [anon_sym_def] = ACTIONS(1484),
    [anon_sym_global] = ACTIONS(1484),
    [anon_sym_nonlocal] = ACTIONS(1484),
    [anon_sym_exec] = ACTIONS(1484),
    [anon_sym_type] = ACTIONS(1484),
    [anon_sym_class] = ACTIONS(1484),
    [anon_sym_LBRACK] = ACTIONS(1482),
    [anon_sym_AT] = ACTIONS(1482),
    [anon_sym_DASH] = ACTIONS(1482),
    [anon_sym_LBRACE] = ACTIONS(1482),
    [anon_sym_PLUS] = ACTIONS(1482),
    [anon_sym_not] = ACTIONS(1484),
    [anon_sym_TILDE] = ACTIONS(1482),
    [anon_sym_lambda] = ACTIONS(1484),
    [anon_sym_yield] = ACTIONS(1484),
    [sym_ellipsis] = ACTIONS(1482),
    [sym_integer] = ACTIONS(1484),
    [sym_float] = ACTIONS(1482),
    [anon_sym_await] = ACTIONS(1484),
    [sym_true] = ACTIONS(1484),
    [sym_false] = ACTIONS(1484),
    [sym_none] = ACTIONS(1484),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1484),
    [anon_sym_container] = ACTIONS(1484),
    [anon_sym_envvars] = ACTIONS(1484),
    [anon_sym_include] = ACTIONS(1484),
    [anon_sym_pepfile] = ACTIONS(1484),
    [anon_sym_pepschema] = ACTIONS(1484),
    [anon_sym_scattergather] = ACTIONS(1484),
    [anon_sym_version] = ACTIONS(1484),
    [anon_sym_wildcard_constraints] = ACTIONS(1484),
    [anon_sym_workdir] = ACTIONS(1484),
    [anon_sym_onerror] = ACTIONS(1484),
    [anon_sym_onstart] = ACTIONS(1484),
    [anon_sym_onsuccess] = ACTIONS(1484),
    [anon_sym_localrules] = ACTIONS(1484),
    [anon_sym_ruleorder] = ACTIONS(1484),
    [anon_sym_rule] = ACTIONS(1484),
    [anon_sym_checkpoint] = ACTIONS(1484),
    [anon_sym_use] = ACTIONS(1484),
    [anon_sym_module] = ACTIONS(1484),
    [sym_string_start] = ACTIONS(1482),
  },
  [440] = {
    [sym_identifier] = ACTIONS(1460),
    [anon_sym_import] = ACTIONS(1460),
    [anon_sym_from] = ACTIONS(1460),
    [anon_sym_LPAREN] = ACTIONS(1458),
    [anon_sym_STAR] = ACTIONS(1458),
    [anon_sym_print] = ACTIONS(1460),
    [anon_sym_assert] = ACTIONS(1460),
    [anon_sym_return] = ACTIONS(1460),
    [anon_sym_del] = ACTIONS(1460),
    [anon_sym_raise] = ACTIONS(1460),
    [anon_sym_pass] = ACTIONS(1460),
    [anon_sym_break] = ACTIONS(1460),
    [anon_sym_continue] = ACTIONS(1460),
    [anon_sym_if] = ACTIONS(1460),
    [anon_sym_match] = ACTIONS(1460),
    [anon_sym_async] = ACTIONS(1460),
    [anon_sym_for] = ACTIONS(1460),
    [anon_sym_while] = ACTIONS(1460),
    [anon_sym_try] = ACTIONS(1460),
    [anon_sym_with] = ACTIONS(1460),
    [anon_sym_def] = ACTIONS(1460),
    [anon_sym_global] = ACTIONS(1460),
    [anon_sym_nonlocal] = ACTIONS(1460),
    [anon_sym_exec] = ACTIONS(1460),
    [anon_sym_type] = ACTIONS(1460),
    [anon_sym_class] = ACTIONS(1460),
    [anon_sym_LBRACK] = ACTIONS(1458),
    [anon_sym_AT] = ACTIONS(1458),
    [anon_sym_DASH] = ACTIONS(1458),
    [anon_sym_LBRACE] = ACTIONS(1458),
    [anon_sym_PLUS] = ACTIONS(1458),
    [anon_sym_not] = ACTIONS(1460),
    [anon_sym_TILDE] = ACTIONS(1458),
    [anon_sym_lambda] = ACTIONS(1460),
    [anon_sym_yield] = ACTIONS(1460),
    [sym_ellipsis] = ACTIONS(1458),
    [sym_integer] = ACTIONS(1460),
    [sym_float] = ACTIONS(1458),
    [anon_sym_await] = ACTIONS(1460),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [sym_none] = ACTIONS(1460),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1460),
    [anon_sym_container] = ACTIONS(1460),
    [anon_sym_envvars] = ACTIONS(1460),
    [anon_sym_include] = ACTIONS(1460),
    [anon_sym_pepfile] = ACTIONS(1460),
    [anon_sym_pepschema] = ACTIONS(1460),
    [anon_sym_scattergather] = ACTIONS(1460),
    [anon_sym_version] = ACTIONS(1460),
    [anon_sym_wildcard_constraints] = ACTIONS(1460),
    [anon_sym_workdir] = ACTIONS(1460),
    [anon_sym_onerror] = ACTIONS(1460),
    [anon_sym_onstart] = ACTIONS(1460),
    [anon_sym_onsuccess] = ACTIONS(1460),
    [anon_sym_localrules] = ACTIONS(1460),
    [anon_sym_ruleorder] = ACTIONS(1460),
    [anon_sym_rule] = ACTIONS(1460),
    [anon_sym_checkpoint] = ACTIONS(1460),
    [anon_sym_use] = ACTIONS(1460),
    [anon_sym_module] = ACTIONS(1460),
    [sym__dedent] = ACTIONS(1458),
    [sym_string_start] = ACTIONS(1458),
  },
  [441] = {
    [sym_identifier] = ACTIONS(1422),
    [anon_sym_import] = ACTIONS(1422),
    [anon_sym_from] = ACTIONS(1422),
    [anon_sym_LPAREN] = ACTIONS(1420),
    [anon_sym_STAR] = ACTIONS(1420),
    [anon_sym_print] = ACTIONS(1422),
    [anon_sym_assert] = ACTIONS(1422),
    [anon_sym_return] = ACTIONS(1422),
    [anon_sym_del] = ACTIONS(1422),
    [anon_sym_raise] = ACTIONS(1422),
    [anon_sym_pass] = ACTIONS(1422),
    [anon_sym_break] = ACTIONS(1422),
    [anon_sym_continue] = ACTIONS(1422),
    [anon_sym_if] = ACTIONS(1422),
    [anon_sym_match] = ACTIONS(1422),
    [anon_sym_async] = ACTIONS(1422),
    [anon_sym_for] = ACTIONS(1422),
    [anon_sym_while] = ACTIONS(1422),
    [anon_sym_try] = ACTIONS(1422),
    [anon_sym_with] = ACTIONS(1486),
    [anon_sym_def] = ACTIONS(1422),
    [anon_sym_global] = ACTIONS(1422),
    [anon_sym_nonlocal] = ACTIONS(1422),
    [anon_sym_exec] = ACTIONS(1422),
    [anon_sym_type] = ACTIONS(1422),
    [anon_sym_class] = ACTIONS(1422),
    [anon_sym_LBRACK] = ACTIONS(1420),
    [anon_sym_AT] = ACTIONS(1420),
    [anon_sym_DASH] = ACTIONS(1420),
    [anon_sym_LBRACE] = ACTIONS(1420),
    [anon_sym_PLUS] = ACTIONS(1420),
    [anon_sym_not] = ACTIONS(1422),
    [anon_sym_TILDE] = ACTIONS(1420),
    [anon_sym_lambda] = ACTIONS(1422),
    [anon_sym_yield] = ACTIONS(1422),
    [sym_ellipsis] = ACTIONS(1420),
    [sym_integer] = ACTIONS(1422),
    [sym_float] = ACTIONS(1420),
    [anon_sym_await] = ACTIONS(1422),
    [sym_true] = ACTIONS(1422),
    [sym_false] = ACTIONS(1422),
    [sym_none] = ACTIONS(1422),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1422),
    [anon_sym_container] = ACTIONS(1422),
    [anon_sym_envvars] = ACTIONS(1422),
    [anon_sym_include] = ACTIONS(1422),
    [anon_sym_pepfile] = ACTIONS(1422),
    [anon_sym_pepschema] = ACTIONS(1422),
    [anon_sym_scattergather] = ACTIONS(1422),
    [anon_sym_version] = ACTIONS(1422),
    [anon_sym_wildcard_constraints] = ACTIONS(1422),
    [anon_sym_workdir] = ACTIONS(1422),
    [anon_sym_onerror] = ACTIONS(1422),
    [anon_sym_onstart] = ACTIONS(1422),
    [anon_sym_onsuccess] = ACTIONS(1422),
    [anon_sym_localrules] = ACTIONS(1422),
    [anon_sym_ruleorder] = ACTIONS(1422),
    [anon_sym_rule] = ACTIONS(1422),
    [anon_sym_checkpoint] = ACTIONS(1422),
    [anon_sym_use] = ACTIONS(1422),
    [anon_sym_module] = ACTIONS(1422),
    [sym__dedent] = ACTIONS(1420),
    [sym_string_start] = ACTIONS(1420),
  },
  [442] = {
    [sym_identifier] = ACTIONS(1436),
    [anon_sym_import] = ACTIONS(1436),
    [anon_sym_from] = ACTIONS(1436),
    [anon_sym_LPAREN] = ACTIONS(1434),
    [anon_sym_STAR] = ACTIONS(1434),
    [anon_sym_print] = ACTIONS(1436),
    [anon_sym_assert] = ACTIONS(1436),
    [anon_sym_return] = ACTIONS(1436),
    [anon_sym_del] = ACTIONS(1436),
    [anon_sym_raise] = ACTIONS(1436),
    [anon_sym_pass] = ACTIONS(1436),
    [anon_sym_break] = ACTIONS(1436),
    [anon_sym_continue] = ACTIONS(1436),
    [anon_sym_if] = ACTIONS(1436),
    [anon_sym_match] = ACTIONS(1436),
    [anon_sym_async] = ACTIONS(1436),
    [anon_sym_for] = ACTIONS(1436),
    [anon_sym_while] = ACTIONS(1436),
    [anon_sym_try] = ACTIONS(1436),
    [anon_sym_with] = ACTIONS(1436),
    [anon_sym_def] = ACTIONS(1436),
    [anon_sym_global] = ACTIONS(1436),
    [anon_sym_nonlocal] = ACTIONS(1436),
    [anon_sym_exec] = ACTIONS(1436),
    [anon_sym_type] = ACTIONS(1436),
    [anon_sym_class] = ACTIONS(1436),
    [anon_sym_LBRACK] = ACTIONS(1434),
    [anon_sym_AT] = ACTIONS(1434),
    [anon_sym_DASH] = ACTIONS(1434),
    [anon_sym_LBRACE] = ACTIONS(1434),
    [anon_sym_PLUS] = ACTIONS(1434),
    [anon_sym_not] = ACTIONS(1436),
    [anon_sym_TILDE] = ACTIONS(1434),
    [anon_sym_lambda] = ACTIONS(1436),
    [anon_sym_yield] = ACTIONS(1436),
    [sym_ellipsis] = ACTIONS(1434),
    [sym_integer] = ACTIONS(1436),
    [sym_float] = ACTIONS(1434),
    [anon_sym_await] = ACTIONS(1436),
    [sym_true] = ACTIONS(1436),
    [sym_false] = ACTIONS(1436),
    [sym_none] = ACTIONS(1436),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1436),
    [anon_sym_container] = ACTIONS(1436),
    [anon_sym_envvars] = ACTIONS(1436),
    [anon_sym_include] = ACTIONS(1436),
    [anon_sym_pepfile] = ACTIONS(1436),
    [anon_sym_pepschema] = ACTIONS(1436),
    [anon_sym_scattergather] = ACTIONS(1436),
    [anon_sym_version] = ACTIONS(1436),
    [anon_sym_wildcard_constraints] = ACTIONS(1436),
    [anon_sym_workdir] = ACTIONS(1436),
    [anon_sym_onerror] = ACTIONS(1436),
    [anon_sym_onstart] = ACTIONS(1436),
    [anon_sym_onsuccess] = ACTIONS(1436),
    [anon_sym_localrules] = ACTIONS(1436),
    [anon_sym_ruleorder] = ACTIONS(1436),
    [anon_sym_rule] = ACTIONS(1436),
    [anon_sym_checkpoint] = ACTIONS(1436),
    [anon_sym_use] = ACTIONS(1436),
    [anon_sym_module] = ACTIONS(1436),
    [sym__dedent] = ACTIONS(1434),
    [sym_string_start] = ACTIONS(1434),
  },
  [443] = {
    [sym_identifier] = ACTIONS(1464),
    [anon_sym_import] = ACTIONS(1464),
    [anon_sym_from] = ACTIONS(1464),
    [anon_sym_LPAREN] = ACTIONS(1462),
    [anon_sym_STAR] = ACTIONS(1462),
    [anon_sym_print] = ACTIONS(1464),
    [anon_sym_assert] = ACTIONS(1464),
    [anon_sym_return] = ACTIONS(1464),
    [anon_sym_del] = ACTIONS(1464),
    [anon_sym_raise] = ACTIONS(1464),
    [anon_sym_pass] = ACTIONS(1464),
    [anon_sym_break] = ACTIONS(1464),
    [anon_sym_continue] = ACTIONS(1464),
    [anon_sym_if] = ACTIONS(1464),
    [anon_sym_match] = ACTIONS(1464),
    [anon_sym_async] = ACTIONS(1464),
    [anon_sym_for] = ACTIONS(1464),
    [anon_sym_while] = ACTIONS(1464),
    [anon_sym_try] = ACTIONS(1464),
    [anon_sym_with] = ACTIONS(1464),
    [anon_sym_def] = ACTIONS(1464),
    [anon_sym_global] = ACTIONS(1464),
    [anon_sym_nonlocal] = ACTIONS(1464),
    [anon_sym_exec] = ACTIONS(1464),
    [anon_sym_type] = ACTIONS(1464),
    [anon_sym_class] = ACTIONS(1464),
    [anon_sym_LBRACK] = ACTIONS(1462),
    [anon_sym_AT] = ACTIONS(1462),
    [anon_sym_DASH] = ACTIONS(1462),
    [anon_sym_LBRACE] = ACTIONS(1462),
    [anon_sym_PLUS] = ACTIONS(1462),
    [anon_sym_not] = ACTIONS(1464),
    [anon_sym_TILDE] = ACTIONS(1462),
    [anon_sym_lambda] = ACTIONS(1464),
    [anon_sym_yield] = ACTIONS(1464),
    [sym_ellipsis] = ACTIONS(1462),
    [sym_integer] = ACTIONS(1464),
    [sym_float] = ACTIONS(1462),
    [anon_sym_await] = ACTIONS(1464),
    [sym_true] = ACTIONS(1464),
    [sym_false] = ACTIONS(1464),
    [sym_none] = ACTIONS(1464),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1464),
    [anon_sym_container] = ACTIONS(1464),
    [anon_sym_envvars] = ACTIONS(1464),
    [anon_sym_include] = ACTIONS(1464),
    [anon_sym_pepfile] = ACTIONS(1464),
    [anon_sym_pepschema] = ACTIONS(1464),
    [anon_sym_scattergather] = ACTIONS(1464),
    [anon_sym_version] = ACTIONS(1464),
    [anon_sym_wildcard_constraints] = ACTIONS(1464),
    [anon_sym_workdir] = ACTIONS(1464),
    [anon_sym_onerror] = ACTIONS(1464),
    [anon_sym_onstart] = ACTIONS(1464),
    [anon_sym_onsuccess] = ACTIONS(1464),
    [anon_sym_localrules] = ACTIONS(1464),
    [anon_sym_ruleorder] = ACTIONS(1464),
    [anon_sym_rule] = ACTIONS(1464),
    [anon_sym_checkpoint] = ACTIONS(1464),
    [anon_sym_use] = ACTIONS(1464),
    [anon_sym_module] = ACTIONS(1464),
    [sym__dedent] = ACTIONS(1462),
    [sym_string_start] = ACTIONS(1462),
  },
  [444] = {
    [sym_identifier] = ACTIONS(1472),
    [anon_sym_import] = ACTIONS(1472),
    [anon_sym_from] = ACTIONS(1472),
    [anon_sym_LPAREN] = ACTIONS(1470),
    [anon_sym_STAR] = ACTIONS(1470),
    [anon_sym_print] = ACTIONS(1472),
    [anon_sym_assert] = ACTIONS(1472),
    [anon_sym_return] = ACTIONS(1472),
    [anon_sym_del] = ACTIONS(1472),
    [anon_sym_raise] = ACTIONS(1472),
    [anon_sym_pass] = ACTIONS(1472),
    [anon_sym_break] = ACTIONS(1472),
    [anon_sym_continue] = ACTIONS(1472),
    [anon_sym_if] = ACTIONS(1472),
    [anon_sym_match] = ACTIONS(1472),
    [anon_sym_async] = ACTIONS(1472),
    [anon_sym_for] = ACTIONS(1472),
    [anon_sym_while] = ACTIONS(1472),
    [anon_sym_try] = ACTIONS(1472),
    [anon_sym_with] = ACTIONS(1472),
    [anon_sym_def] = ACTIONS(1472),
    [anon_sym_global] = ACTIONS(1472),
    [anon_sym_nonlocal] = ACTIONS(1472),
    [anon_sym_exec] = ACTIONS(1472),
    [anon_sym_type] = ACTIONS(1472),
    [anon_sym_class] = ACTIONS(1472),
    [anon_sym_LBRACK] = ACTIONS(1470),
    [anon_sym_AT] = ACTIONS(1470),
    [anon_sym_DASH] = ACTIONS(1470),
    [anon_sym_LBRACE] = ACTIONS(1470),
    [anon_sym_PLUS] = ACTIONS(1470),
    [anon_sym_not] = ACTIONS(1472),
    [anon_sym_TILDE] = ACTIONS(1470),
    [anon_sym_lambda] = ACTIONS(1472),
    [anon_sym_yield] = ACTIONS(1472),
    [sym_ellipsis] = ACTIONS(1470),
    [sym_integer] = ACTIONS(1472),
    [sym_float] = ACTIONS(1470),
    [anon_sym_await] = ACTIONS(1472),
    [sym_true] = ACTIONS(1472),
    [sym_false] = ACTIONS(1472),
    [sym_none] = ACTIONS(1472),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1472),
    [anon_sym_container] = ACTIONS(1472),
    [anon_sym_envvars] = ACTIONS(1472),
    [anon_sym_include] = ACTIONS(1472),
    [anon_sym_pepfile] = ACTIONS(1472),
    [anon_sym_pepschema] = ACTIONS(1472),
    [anon_sym_scattergather] = ACTIONS(1472),
    [anon_sym_version] = ACTIONS(1472),
    [anon_sym_wildcard_constraints] = ACTIONS(1472),
    [anon_sym_workdir] = ACTIONS(1472),
    [anon_sym_onerror] = ACTIONS(1472),
    [anon_sym_onstart] = ACTIONS(1472),
    [anon_sym_onsuccess] = ACTIONS(1472),
    [anon_sym_localrules] = ACTIONS(1472),
    [anon_sym_ruleorder] = ACTIONS(1472),
    [anon_sym_rule] = ACTIONS(1472),
    [anon_sym_checkpoint] = ACTIONS(1472),
    [anon_sym_use] = ACTIONS(1472),
    [anon_sym_module] = ACTIONS(1472),
    [sym__dedent] = ACTIONS(1470),
    [sym_string_start] = ACTIONS(1470),
  },
  [445] = {
    [sym_identifier] = ACTIONS(1410),
    [anon_sym_import] = ACTIONS(1410),
    [anon_sym_from] = ACTIONS(1410),
    [anon_sym_LPAREN] = ACTIONS(1408),
    [anon_sym_STAR] = ACTIONS(1408),
    [anon_sym_print] = ACTIONS(1410),
    [anon_sym_assert] = ACTIONS(1410),
    [anon_sym_return] = ACTIONS(1410),
    [anon_sym_del] = ACTIONS(1410),
    [anon_sym_raise] = ACTIONS(1410),
    [anon_sym_pass] = ACTIONS(1410),
    [anon_sym_break] = ACTIONS(1410),
    [anon_sym_continue] = ACTIONS(1410),
    [anon_sym_if] = ACTIONS(1410),
    [anon_sym_match] = ACTIONS(1410),
    [anon_sym_async] = ACTIONS(1410),
    [anon_sym_for] = ACTIONS(1410),
    [anon_sym_while] = ACTIONS(1410),
    [anon_sym_try] = ACTIONS(1410),
    [anon_sym_with] = ACTIONS(1410),
    [anon_sym_def] = ACTIONS(1410),
    [anon_sym_global] = ACTIONS(1410),
    [anon_sym_nonlocal] = ACTIONS(1410),
    [anon_sym_exec] = ACTIONS(1410),
    [anon_sym_type] = ACTIONS(1410),
    [anon_sym_class] = ACTIONS(1410),
    [anon_sym_LBRACK] = ACTIONS(1408),
    [anon_sym_AT] = ACTIONS(1408),
    [anon_sym_DASH] = ACTIONS(1408),
    [anon_sym_LBRACE] = ACTIONS(1408),
    [anon_sym_PLUS] = ACTIONS(1408),
    [anon_sym_not] = ACTIONS(1410),
    [anon_sym_TILDE] = ACTIONS(1408),
    [anon_sym_lambda] = ACTIONS(1410),
    [anon_sym_yield] = ACTIONS(1410),
    [sym_ellipsis] = ACTIONS(1408),
    [sym_integer] = ACTIONS(1410),
    [sym_float] = ACTIONS(1408),
    [anon_sym_await] = ACTIONS(1410),
    [sym_true] = ACTIONS(1410),
    [sym_false] = ACTIONS(1410),
    [sym_none] = ACTIONS(1410),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1410),
    [anon_sym_container] = ACTIONS(1410),
    [anon_sym_envvars] = ACTIONS(1410),
    [anon_sym_include] = ACTIONS(1410),
    [anon_sym_pepfile] = ACTIONS(1410),
    [anon_sym_pepschema] = ACTIONS(1410),
    [anon_sym_scattergather] = ACTIONS(1410),
    [anon_sym_version] = ACTIONS(1410),
    [anon_sym_wildcard_constraints] = ACTIONS(1410),
    [anon_sym_workdir] = ACTIONS(1410),
    [anon_sym_onerror] = ACTIONS(1410),
    [anon_sym_onstart] = ACTIONS(1410),
    [anon_sym_onsuccess] = ACTIONS(1410),
    [anon_sym_localrules] = ACTIONS(1410),
    [anon_sym_ruleorder] = ACTIONS(1410),
    [anon_sym_rule] = ACTIONS(1410),
    [anon_sym_checkpoint] = ACTIONS(1410),
    [anon_sym_use] = ACTIONS(1410),
    [anon_sym_module] = ACTIONS(1410),
    [sym__dedent] = ACTIONS(1408),
    [sym_string_start] = ACTIONS(1408),
  },
  [446] = {
    [sym_identifier] = ACTIONS(1440),
    [anon_sym_import] = ACTIONS(1440),
    [anon_sym_from] = ACTIONS(1440),
    [anon_sym_LPAREN] = ACTIONS(1438),
    [anon_sym_STAR] = ACTIONS(1438),
    [anon_sym_print] = ACTIONS(1440),
    [anon_sym_assert] = ACTIONS(1440),
    [anon_sym_return] = ACTIONS(1440),
    [anon_sym_del] = ACTIONS(1440),
    [anon_sym_raise] = ACTIONS(1440),
    [anon_sym_pass] = ACTIONS(1440),
    [anon_sym_break] = ACTIONS(1440),
    [anon_sym_continue] = ACTIONS(1440),
    [anon_sym_if] = ACTIONS(1440),
    [anon_sym_match] = ACTIONS(1440),
    [anon_sym_async] = ACTIONS(1440),
    [anon_sym_for] = ACTIONS(1440),
    [anon_sym_while] = ACTIONS(1440),
    [anon_sym_try] = ACTIONS(1440),
    [anon_sym_with] = ACTIONS(1440),
    [anon_sym_def] = ACTIONS(1440),
    [anon_sym_global] = ACTIONS(1440),
    [anon_sym_nonlocal] = ACTIONS(1440),
    [anon_sym_exec] = ACTIONS(1440),
    [anon_sym_type] = ACTIONS(1440),
    [anon_sym_class] = ACTIONS(1440),
    [anon_sym_LBRACK] = ACTIONS(1438),
    [anon_sym_AT] = ACTIONS(1438),
    [anon_sym_DASH] = ACTIONS(1438),
    [anon_sym_LBRACE] = ACTIONS(1438),
    [anon_sym_PLUS] = ACTIONS(1438),
    [anon_sym_not] = ACTIONS(1440),
    [anon_sym_TILDE] = ACTIONS(1438),
    [anon_sym_lambda] = ACTIONS(1440),
    [anon_sym_yield] = ACTIONS(1440),
    [sym_ellipsis] = ACTIONS(1438),
    [sym_integer] = ACTIONS(1440),
    [sym_float] = ACTIONS(1438),
    [anon_sym_await] = ACTIONS(1440),
    [sym_true] = ACTIONS(1440),
    [sym_false] = ACTIONS(1440),
    [sym_none] = ACTIONS(1440),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1440),
    [anon_sym_container] = ACTIONS(1440),
    [anon_sym_envvars] = ACTIONS(1440),
    [anon_sym_include] = ACTIONS(1440),
    [anon_sym_pepfile] = ACTIONS(1440),
    [anon_sym_pepschema] = ACTIONS(1440),
    [anon_sym_scattergather] = ACTIONS(1440),
    [anon_sym_version] = ACTIONS(1440),
    [anon_sym_wildcard_constraints] = ACTIONS(1440),
    [anon_sym_workdir] = ACTIONS(1440),
    [anon_sym_onerror] = ACTIONS(1440),
    [anon_sym_onstart] = ACTIONS(1440),
    [anon_sym_onsuccess] = ACTIONS(1440),
    [anon_sym_localrules] = ACTIONS(1440),
    [anon_sym_ruleorder] = ACTIONS(1440),
    [anon_sym_rule] = ACTIONS(1440),
    [anon_sym_checkpoint] = ACTIONS(1440),
    [anon_sym_use] = ACTIONS(1440),
    [anon_sym_module] = ACTIONS(1440),
    [sym__dedent] = ACTIONS(1438),
    [sym_string_start] = ACTIONS(1438),
  },
  [447] = {
    [ts_builtin_sym_end] = ACTIONS(1488),
    [sym_identifier] = ACTIONS(1490),
    [anon_sym_import] = ACTIONS(1490),
    [anon_sym_from] = ACTIONS(1490),
    [anon_sym_LPAREN] = ACTIONS(1488),
    [anon_sym_STAR] = ACTIONS(1488),
    [anon_sym_print] = ACTIONS(1490),
    [anon_sym_assert] = ACTIONS(1490),
    [anon_sym_return] = ACTIONS(1490),
    [anon_sym_del] = ACTIONS(1490),
    [anon_sym_raise] = ACTIONS(1490),
    [anon_sym_pass] = ACTIONS(1490),
    [anon_sym_break] = ACTIONS(1490),
    [anon_sym_continue] = ACTIONS(1490),
    [anon_sym_if] = ACTIONS(1490),
    [anon_sym_match] = ACTIONS(1490),
    [anon_sym_async] = ACTIONS(1490),
    [anon_sym_for] = ACTIONS(1490),
    [anon_sym_while] = ACTIONS(1490),
    [anon_sym_try] = ACTIONS(1490),
    [anon_sym_with] = ACTIONS(1490),
    [anon_sym_def] = ACTIONS(1490),
    [anon_sym_global] = ACTIONS(1490),
    [anon_sym_nonlocal] = ACTIONS(1490),
    [anon_sym_exec] = ACTIONS(1490),
    [anon_sym_type] = ACTIONS(1490),
    [anon_sym_class] = ACTIONS(1490),
    [anon_sym_LBRACK] = ACTIONS(1488),
    [anon_sym_AT] = ACTIONS(1488),
    [anon_sym_DASH] = ACTIONS(1488),
    [anon_sym_LBRACE] = ACTIONS(1488),
    [anon_sym_PLUS] = ACTIONS(1488),
    [anon_sym_not] = ACTIONS(1490),
    [anon_sym_TILDE] = ACTIONS(1488),
    [anon_sym_lambda] = ACTIONS(1490),
    [anon_sym_yield] = ACTIONS(1490),
    [sym_ellipsis] = ACTIONS(1488),
    [sym_integer] = ACTIONS(1490),
    [sym_float] = ACTIONS(1488),
    [anon_sym_await] = ACTIONS(1490),
    [sym_true] = ACTIONS(1490),
    [sym_false] = ACTIONS(1490),
    [sym_none] = ACTIONS(1490),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1490),
    [anon_sym_container] = ACTIONS(1490),
    [anon_sym_envvars] = ACTIONS(1490),
    [anon_sym_include] = ACTIONS(1490),
    [anon_sym_pepfile] = ACTIONS(1490),
    [anon_sym_pepschema] = ACTIONS(1490),
    [anon_sym_scattergather] = ACTIONS(1490),
    [anon_sym_version] = ACTIONS(1490),
    [anon_sym_wildcard_constraints] = ACTIONS(1490),
    [anon_sym_workdir] = ACTIONS(1490),
    [anon_sym_onerror] = ACTIONS(1490),
    [anon_sym_onstart] = ACTIONS(1490),
    [anon_sym_onsuccess] = ACTIONS(1490),
    [anon_sym_localrules] = ACTIONS(1490),
    [anon_sym_ruleorder] = ACTIONS(1490),
    [anon_sym_rule] = ACTIONS(1490),
    [anon_sym_checkpoint] = ACTIONS(1490),
    [anon_sym_use] = ACTIONS(1490),
    [anon_sym_module] = ACTIONS(1490),
    [sym_string_start] = ACTIONS(1488),
  },
  [448] = {
    [sym_identifier] = ACTIONS(1448),
    [anon_sym_import] = ACTIONS(1448),
    [anon_sym_from] = ACTIONS(1448),
    [anon_sym_LPAREN] = ACTIONS(1446),
    [anon_sym_STAR] = ACTIONS(1446),
    [anon_sym_print] = ACTIONS(1448),
    [anon_sym_assert] = ACTIONS(1448),
    [anon_sym_return] = ACTIONS(1448),
    [anon_sym_del] = ACTIONS(1448),
    [anon_sym_raise] = ACTIONS(1448),
    [anon_sym_pass] = ACTIONS(1448),
    [anon_sym_break] = ACTIONS(1448),
    [anon_sym_continue] = ACTIONS(1448),
    [anon_sym_if] = ACTIONS(1448),
    [anon_sym_match] = ACTIONS(1448),
    [anon_sym_async] = ACTIONS(1448),
    [anon_sym_for] = ACTIONS(1448),
    [anon_sym_while] = ACTIONS(1448),
    [anon_sym_try] = ACTIONS(1448),
    [anon_sym_with] = ACTIONS(1448),
    [anon_sym_def] = ACTIONS(1448),
    [anon_sym_global] = ACTIONS(1448),
    [anon_sym_nonlocal] = ACTIONS(1448),
    [anon_sym_exec] = ACTIONS(1448),
    [anon_sym_type] = ACTIONS(1448),
    [anon_sym_class] = ACTIONS(1448),
    [anon_sym_LBRACK] = ACTIONS(1446),
    [anon_sym_AT] = ACTIONS(1446),
    [anon_sym_DASH] = ACTIONS(1446),
    [anon_sym_LBRACE] = ACTIONS(1446),
    [anon_sym_PLUS] = ACTIONS(1446),
    [anon_sym_not] = ACTIONS(1448),
    [anon_sym_TILDE] = ACTIONS(1446),
    [anon_sym_lambda] = ACTIONS(1448),
    [anon_sym_yield] = ACTIONS(1448),
    [sym_ellipsis] = ACTIONS(1446),
    [sym_integer] = ACTIONS(1448),
    [sym_float] = ACTIONS(1446),
    [anon_sym_await] = ACTIONS(1448),
    [sym_true] = ACTIONS(1448),
    [sym_false] = ACTIONS(1448),
    [sym_none] = ACTIONS(1448),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1448),
    [anon_sym_container] = ACTIONS(1448),
    [anon_sym_envvars] = ACTIONS(1448),
    [anon_sym_include] = ACTIONS(1448),
    [anon_sym_pepfile] = ACTIONS(1448),
    [anon_sym_pepschema] = ACTIONS(1448),
    [anon_sym_scattergather] = ACTIONS(1448),
    [anon_sym_version] = ACTIONS(1448),
    [anon_sym_wildcard_constraints] = ACTIONS(1448),
    [anon_sym_workdir] = ACTIONS(1448),
    [anon_sym_onerror] = ACTIONS(1448),
    [anon_sym_onstart] = ACTIONS(1448),
    [anon_sym_onsuccess] = ACTIONS(1448),
    [anon_sym_localrules] = ACTIONS(1448),
    [anon_sym_ruleorder] = ACTIONS(1448),
    [anon_sym_rule] = ACTIONS(1448),
    [anon_sym_checkpoint] = ACTIONS(1448),
    [anon_sym_use] = ACTIONS(1448),
    [anon_sym_module] = ACTIONS(1448),
    [sym__dedent] = ACTIONS(1446),
    [sym_string_start] = ACTIONS(1446),
  },
  [449] = {
    [sym_identifier] = ACTIONS(1480),
    [anon_sym_import] = ACTIONS(1480),
    [anon_sym_from] = ACTIONS(1480),
    [anon_sym_LPAREN] = ACTIONS(1478),
    [anon_sym_STAR] = ACTIONS(1478),
    [anon_sym_print] = ACTIONS(1480),
    [anon_sym_assert] = ACTIONS(1480),
    [anon_sym_return] = ACTIONS(1480),
    [anon_sym_del] = ACTIONS(1480),
    [anon_sym_raise] = ACTIONS(1480),
    [anon_sym_pass] = ACTIONS(1480),
    [anon_sym_break] = ACTIONS(1480),
    [anon_sym_continue] = ACTIONS(1480),
    [anon_sym_if] = ACTIONS(1480),
    [anon_sym_match] = ACTIONS(1480),
    [anon_sym_async] = ACTIONS(1480),
    [anon_sym_for] = ACTIONS(1480),
    [anon_sym_while] = ACTIONS(1480),
    [anon_sym_try] = ACTIONS(1480),
    [anon_sym_with] = ACTIONS(1480),
    [anon_sym_def] = ACTIONS(1480),
    [anon_sym_global] = ACTIONS(1480),
    [anon_sym_nonlocal] = ACTIONS(1480),
    [anon_sym_exec] = ACTIONS(1480),
    [anon_sym_type] = ACTIONS(1480),
    [anon_sym_class] = ACTIONS(1480),
    [anon_sym_LBRACK] = ACTIONS(1478),
    [anon_sym_AT] = ACTIONS(1478),
    [anon_sym_DASH] = ACTIONS(1478),
    [anon_sym_LBRACE] = ACTIONS(1478),
    [anon_sym_PLUS] = ACTIONS(1478),
    [anon_sym_not] = ACTIONS(1480),
    [anon_sym_TILDE] = ACTIONS(1478),
    [anon_sym_lambda] = ACTIONS(1480),
    [anon_sym_yield] = ACTIONS(1480),
    [sym_ellipsis] = ACTIONS(1478),
    [sym_integer] = ACTIONS(1480),
    [sym_float] = ACTIONS(1478),
    [anon_sym_await] = ACTIONS(1480),
    [sym_true] = ACTIONS(1480),
    [sym_false] = ACTIONS(1480),
    [sym_none] = ACTIONS(1480),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1480),
    [anon_sym_container] = ACTIONS(1480),
    [anon_sym_envvars] = ACTIONS(1480),
    [anon_sym_include] = ACTIONS(1480),
    [anon_sym_pepfile] = ACTIONS(1480),
    [anon_sym_pepschema] = ACTIONS(1480),
    [anon_sym_scattergather] = ACTIONS(1480),
    [anon_sym_version] = ACTIONS(1480),
    [anon_sym_wildcard_constraints] = ACTIONS(1480),
    [anon_sym_workdir] = ACTIONS(1480),
    [anon_sym_onerror] = ACTIONS(1480),
    [anon_sym_onstart] = ACTIONS(1480),
    [anon_sym_onsuccess] = ACTIONS(1480),
    [anon_sym_localrules] = ACTIONS(1480),
    [anon_sym_ruleorder] = ACTIONS(1480),
    [anon_sym_rule] = ACTIONS(1480),
    [anon_sym_checkpoint] = ACTIONS(1480),
    [anon_sym_use] = ACTIONS(1480),
    [anon_sym_module] = ACTIONS(1480),
    [sym__dedent] = ACTIONS(1478),
    [sym_string_start] = ACTIONS(1478),
  },
  [450] = {
    [sym_identifier] = ACTIONS(1452),
    [anon_sym_import] = ACTIONS(1452),
    [anon_sym_from] = ACTIONS(1452),
    [anon_sym_LPAREN] = ACTIONS(1450),
    [anon_sym_STAR] = ACTIONS(1450),
    [anon_sym_print] = ACTIONS(1452),
    [anon_sym_assert] = ACTIONS(1452),
    [anon_sym_return] = ACTIONS(1452),
    [anon_sym_del] = ACTIONS(1452),
    [anon_sym_raise] = ACTIONS(1452),
    [anon_sym_pass] = ACTIONS(1452),
    [anon_sym_break] = ACTIONS(1452),
    [anon_sym_continue] = ACTIONS(1452),
    [anon_sym_if] = ACTIONS(1452),
    [anon_sym_match] = ACTIONS(1452),
    [anon_sym_async] = ACTIONS(1452),
    [anon_sym_for] = ACTIONS(1452),
    [anon_sym_while] = ACTIONS(1452),
    [anon_sym_try] = ACTIONS(1452),
    [anon_sym_with] = ACTIONS(1452),
    [anon_sym_def] = ACTIONS(1452),
    [anon_sym_global] = ACTIONS(1452),
    [anon_sym_nonlocal] = ACTIONS(1452),
    [anon_sym_exec] = ACTIONS(1452),
    [anon_sym_type] = ACTIONS(1452),
    [anon_sym_class] = ACTIONS(1452),
    [anon_sym_LBRACK] = ACTIONS(1450),
    [anon_sym_AT] = ACTIONS(1450),
    [anon_sym_DASH] = ACTIONS(1450),
    [anon_sym_LBRACE] = ACTIONS(1450),
    [anon_sym_PLUS] = ACTIONS(1450),
    [anon_sym_not] = ACTIONS(1452),
    [anon_sym_TILDE] = ACTIONS(1450),
    [anon_sym_lambda] = ACTIONS(1452),
    [anon_sym_yield] = ACTIONS(1452),
    [sym_ellipsis] = ACTIONS(1450),
    [sym_integer] = ACTIONS(1452),
    [sym_float] = ACTIONS(1450),
    [anon_sym_await] = ACTIONS(1452),
    [sym_true] = ACTIONS(1452),
    [sym_false] = ACTIONS(1452),
    [sym_none] = ACTIONS(1452),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1452),
    [anon_sym_container] = ACTIONS(1452),
    [anon_sym_envvars] = ACTIONS(1452),
    [anon_sym_include] = ACTIONS(1452),
    [anon_sym_pepfile] = ACTIONS(1452),
    [anon_sym_pepschema] = ACTIONS(1452),
    [anon_sym_scattergather] = ACTIONS(1452),
    [anon_sym_version] = ACTIONS(1452),
    [anon_sym_wildcard_constraints] = ACTIONS(1452),
    [anon_sym_workdir] = ACTIONS(1452),
    [anon_sym_onerror] = ACTIONS(1452),
    [anon_sym_onstart] = ACTIONS(1452),
    [anon_sym_onsuccess] = ACTIONS(1452),
    [anon_sym_localrules] = ACTIONS(1452),
    [anon_sym_ruleorder] = ACTIONS(1452),
    [anon_sym_rule] = ACTIONS(1452),
    [anon_sym_checkpoint] = ACTIONS(1452),
    [anon_sym_use] = ACTIONS(1452),
    [anon_sym_module] = ACTIONS(1452),
    [sym__dedent] = ACTIONS(1450),
    [sym_string_start] = ACTIONS(1450),
  },
  [451] = {
    [sym_identifier] = ACTIONS(1492),
    [anon_sym_import] = ACTIONS(1492),
    [anon_sym_from] = ACTIONS(1492),
    [anon_sym_LPAREN] = ACTIONS(1494),
    [anon_sym_STAR] = ACTIONS(1494),
    [anon_sym_print] = ACTIONS(1492),
    [anon_sym_assert] = ACTIONS(1492),
    [anon_sym_return] = ACTIONS(1492),
    [anon_sym_del] = ACTIONS(1492),
    [anon_sym_raise] = ACTIONS(1492),
    [anon_sym_pass] = ACTIONS(1492),
    [anon_sym_break] = ACTIONS(1492),
    [anon_sym_continue] = ACTIONS(1492),
    [anon_sym_if] = ACTIONS(1492),
    [anon_sym_match] = ACTIONS(1492),
    [anon_sym_async] = ACTIONS(1492),
    [anon_sym_for] = ACTIONS(1492),
    [anon_sym_while] = ACTIONS(1492),
    [anon_sym_try] = ACTIONS(1492),
    [anon_sym_with] = ACTIONS(1492),
    [anon_sym_def] = ACTIONS(1492),
    [anon_sym_global] = ACTIONS(1492),
    [anon_sym_nonlocal] = ACTIONS(1492),
    [anon_sym_exec] = ACTIONS(1492),
    [anon_sym_type] = ACTIONS(1492),
    [anon_sym_class] = ACTIONS(1492),
    [anon_sym_LBRACK] = ACTIONS(1494),
    [anon_sym_AT] = ACTIONS(1494),
    [anon_sym_DASH] = ACTIONS(1494),
    [anon_sym_LBRACE] = ACTIONS(1494),
    [anon_sym_PLUS] = ACTIONS(1494),
    [anon_sym_not] = ACTIONS(1492),
    [anon_sym_TILDE] = ACTIONS(1494),
    [anon_sym_lambda] = ACTIONS(1492),
    [anon_sym_yield] = ACTIONS(1492),
    [sym_ellipsis] = ACTIONS(1494),
    [sym_integer] = ACTIONS(1492),
    [sym_float] = ACTIONS(1494),
    [anon_sym_await] = ACTIONS(1492),
    [sym_true] = ACTIONS(1492),
    [sym_false] = ACTIONS(1492),
    [sym_none] = ACTIONS(1492),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1492),
    [anon_sym_container] = ACTIONS(1492),
    [anon_sym_envvars] = ACTIONS(1492),
    [anon_sym_include] = ACTIONS(1492),
    [anon_sym_pepfile] = ACTIONS(1492),
    [anon_sym_pepschema] = ACTIONS(1492),
    [anon_sym_scattergather] = ACTIONS(1492),
    [anon_sym_version] = ACTIONS(1492),
    [anon_sym_wildcard_constraints] = ACTIONS(1492),
    [anon_sym_workdir] = ACTIONS(1492),
    [anon_sym_onerror] = ACTIONS(1492),
    [anon_sym_onstart] = ACTIONS(1492),
    [anon_sym_onsuccess] = ACTIONS(1492),
    [anon_sym_localrules] = ACTIONS(1492),
    [anon_sym_ruleorder] = ACTIONS(1492),
    [anon_sym_rule] = ACTIONS(1492),
    [anon_sym_checkpoint] = ACTIONS(1492),
    [anon_sym_use] = ACTIONS(1492),
    [anon_sym_module] = ACTIONS(1492),
    [sym__dedent] = ACTIONS(1494),
    [sym_string_start] = ACTIONS(1494),
  },
  [452] = {
    [sym_identifier] = ACTIONS(1490),
    [anon_sym_import] = ACTIONS(1490),
    [anon_sym_from] = ACTIONS(1490),
    [anon_sym_LPAREN] = ACTIONS(1488),
    [anon_sym_STAR] = ACTIONS(1488),
    [anon_sym_print] = ACTIONS(1490),
    [anon_sym_assert] = ACTIONS(1490),
    [anon_sym_return] = ACTIONS(1490),
    [anon_sym_del] = ACTIONS(1490),
    [anon_sym_raise] = ACTIONS(1490),
    [anon_sym_pass] = ACTIONS(1490),
    [anon_sym_break] = ACTIONS(1490),
    [anon_sym_continue] = ACTIONS(1490),
    [anon_sym_if] = ACTIONS(1490),
    [anon_sym_match] = ACTIONS(1490),
    [anon_sym_async] = ACTIONS(1490),
    [anon_sym_for] = ACTIONS(1490),
    [anon_sym_while] = ACTIONS(1490),
    [anon_sym_try] = ACTIONS(1490),
    [anon_sym_with] = ACTIONS(1490),
    [anon_sym_def] = ACTIONS(1490),
    [anon_sym_global] = ACTIONS(1490),
    [anon_sym_nonlocal] = ACTIONS(1490),
    [anon_sym_exec] = ACTIONS(1490),
    [anon_sym_type] = ACTIONS(1490),
    [anon_sym_class] = ACTIONS(1490),
    [anon_sym_LBRACK] = ACTIONS(1488),
    [anon_sym_AT] = ACTIONS(1488),
    [anon_sym_DASH] = ACTIONS(1488),
    [anon_sym_LBRACE] = ACTIONS(1488),
    [anon_sym_PLUS] = ACTIONS(1488),
    [anon_sym_not] = ACTIONS(1490),
    [anon_sym_TILDE] = ACTIONS(1488),
    [anon_sym_lambda] = ACTIONS(1490),
    [anon_sym_yield] = ACTIONS(1490),
    [sym_ellipsis] = ACTIONS(1488),
    [sym_integer] = ACTIONS(1490),
    [sym_float] = ACTIONS(1488),
    [anon_sym_await] = ACTIONS(1490),
    [sym_true] = ACTIONS(1490),
    [sym_false] = ACTIONS(1490),
    [sym_none] = ACTIONS(1490),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1490),
    [anon_sym_container] = ACTIONS(1490),
    [anon_sym_envvars] = ACTIONS(1490),
    [anon_sym_include] = ACTIONS(1490),
    [anon_sym_pepfile] = ACTIONS(1490),
    [anon_sym_pepschema] = ACTIONS(1490),
    [anon_sym_scattergather] = ACTIONS(1490),
    [anon_sym_version] = ACTIONS(1490),
    [anon_sym_wildcard_constraints] = ACTIONS(1490),
    [anon_sym_workdir] = ACTIONS(1490),
    [anon_sym_onerror] = ACTIONS(1490),
    [anon_sym_onstart] = ACTIONS(1490),
    [anon_sym_onsuccess] = ACTIONS(1490),
    [anon_sym_localrules] = ACTIONS(1490),
    [anon_sym_ruleorder] = ACTIONS(1490),
    [anon_sym_rule] = ACTIONS(1490),
    [anon_sym_checkpoint] = ACTIONS(1490),
    [anon_sym_use] = ACTIONS(1490),
    [anon_sym_module] = ACTIONS(1490),
    [sym__dedent] = ACTIONS(1488),
    [sym_string_start] = ACTIONS(1488),
  },
  [453] = {
    [ts_builtin_sym_end] = ACTIONS(1496),
    [sym_identifier] = ACTIONS(1498),
    [anon_sym_import] = ACTIONS(1498),
    [anon_sym_from] = ACTIONS(1498),
    [anon_sym_LPAREN] = ACTIONS(1496),
    [anon_sym_STAR] = ACTIONS(1496),
    [anon_sym_print] = ACTIONS(1498),
    [anon_sym_assert] = ACTIONS(1498),
    [anon_sym_return] = ACTIONS(1498),
    [anon_sym_del] = ACTIONS(1498),
    [anon_sym_raise] = ACTIONS(1498),
    [anon_sym_pass] = ACTIONS(1498),
    [anon_sym_break] = ACTIONS(1498),
    [anon_sym_continue] = ACTIONS(1498),
    [anon_sym_if] = ACTIONS(1498),
    [anon_sym_match] = ACTIONS(1498),
    [anon_sym_async] = ACTIONS(1498),
    [anon_sym_for] = ACTIONS(1498),
    [anon_sym_while] = ACTIONS(1498),
    [anon_sym_try] = ACTIONS(1498),
    [anon_sym_with] = ACTIONS(1498),
    [anon_sym_def] = ACTIONS(1498),
    [anon_sym_global] = ACTIONS(1498),
    [anon_sym_nonlocal] = ACTIONS(1498),
    [anon_sym_exec] = ACTIONS(1498),
    [anon_sym_type] = ACTIONS(1498),
    [anon_sym_class] = ACTIONS(1498),
    [anon_sym_LBRACK] = ACTIONS(1496),
    [anon_sym_AT] = ACTIONS(1496),
    [anon_sym_DASH] = ACTIONS(1496),
    [anon_sym_LBRACE] = ACTIONS(1496),
    [anon_sym_PLUS] = ACTIONS(1496),
    [anon_sym_not] = ACTIONS(1498),
    [anon_sym_TILDE] = ACTIONS(1496),
    [anon_sym_lambda] = ACTIONS(1498),
    [anon_sym_yield] = ACTIONS(1498),
    [sym_ellipsis] = ACTIONS(1496),
    [sym_integer] = ACTIONS(1498),
    [sym_float] = ACTIONS(1496),
    [anon_sym_await] = ACTIONS(1498),
    [sym_true] = ACTIONS(1498),
    [sym_false] = ACTIONS(1498),
    [sym_none] = ACTIONS(1498),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1498),
    [anon_sym_container] = ACTIONS(1498),
    [anon_sym_envvars] = ACTIONS(1498),
    [anon_sym_include] = ACTIONS(1498),
    [anon_sym_pepfile] = ACTIONS(1498),
    [anon_sym_pepschema] = ACTIONS(1498),
    [anon_sym_scattergather] = ACTIONS(1498),
    [anon_sym_version] = ACTIONS(1498),
    [anon_sym_wildcard_constraints] = ACTIONS(1498),
    [anon_sym_workdir] = ACTIONS(1498),
    [anon_sym_onerror] = ACTIONS(1498),
    [anon_sym_onstart] = ACTIONS(1498),
    [anon_sym_onsuccess] = ACTIONS(1498),
    [anon_sym_localrules] = ACTIONS(1498),
    [anon_sym_ruleorder] = ACTIONS(1498),
    [anon_sym_rule] = ACTIONS(1498),
    [anon_sym_checkpoint] = ACTIONS(1498),
    [anon_sym_use] = ACTIONS(1498),
    [anon_sym_module] = ACTIONS(1498),
    [sym_string_start] = ACTIONS(1496),
  },
  [454] = {
    [ts_builtin_sym_end] = ACTIONS(804),
    [sym_identifier] = ACTIONS(806),
    [anon_sym_import] = ACTIONS(806),
    [anon_sym_from] = ACTIONS(806),
    [anon_sym_LPAREN] = ACTIONS(804),
    [anon_sym_STAR] = ACTIONS(804),
    [anon_sym_print] = ACTIONS(806),
    [anon_sym_assert] = ACTIONS(806),
    [anon_sym_return] = ACTIONS(806),
    [anon_sym_del] = ACTIONS(806),
    [anon_sym_raise] = ACTIONS(806),
    [anon_sym_pass] = ACTIONS(806),
    [anon_sym_break] = ACTIONS(806),
    [anon_sym_continue] = ACTIONS(806),
    [anon_sym_if] = ACTIONS(806),
    [anon_sym_match] = ACTIONS(806),
    [anon_sym_async] = ACTIONS(806),
    [anon_sym_for] = ACTIONS(806),
    [anon_sym_while] = ACTIONS(806),
    [anon_sym_try] = ACTIONS(806),
    [anon_sym_with] = ACTIONS(806),
    [anon_sym_def] = ACTIONS(806),
    [anon_sym_global] = ACTIONS(806),
    [anon_sym_nonlocal] = ACTIONS(806),
    [anon_sym_exec] = ACTIONS(806),
    [anon_sym_type] = ACTIONS(806),
    [anon_sym_class] = ACTIONS(806),
    [anon_sym_LBRACK] = ACTIONS(804),
    [anon_sym_AT] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_LBRACE] = ACTIONS(804),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_not] = ACTIONS(806),
    [anon_sym_TILDE] = ACTIONS(804),
    [anon_sym_lambda] = ACTIONS(806),
    [anon_sym_yield] = ACTIONS(806),
    [sym_ellipsis] = ACTIONS(804),
    [sym_integer] = ACTIONS(806),
    [sym_float] = ACTIONS(804),
    [anon_sym_await] = ACTIONS(806),
    [sym_true] = ACTIONS(806),
    [sym_false] = ACTIONS(806),
    [sym_none] = ACTIONS(806),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(806),
    [anon_sym_container] = ACTIONS(806),
    [anon_sym_envvars] = ACTIONS(806),
    [anon_sym_include] = ACTIONS(806),
    [anon_sym_pepfile] = ACTIONS(806),
    [anon_sym_pepschema] = ACTIONS(806),
    [anon_sym_scattergather] = ACTIONS(806),
    [anon_sym_version] = ACTIONS(806),
    [anon_sym_wildcard_constraints] = ACTIONS(806),
    [anon_sym_workdir] = ACTIONS(806),
    [anon_sym_onerror] = ACTIONS(806),
    [anon_sym_onstart] = ACTIONS(806),
    [anon_sym_onsuccess] = ACTIONS(806),
    [anon_sym_localrules] = ACTIONS(806),
    [anon_sym_ruleorder] = ACTIONS(806),
    [anon_sym_rule] = ACTIONS(806),
    [anon_sym_checkpoint] = ACTIONS(806),
    [anon_sym_use] = ACTIONS(806),
    [anon_sym_module] = ACTIONS(806),
    [sym_string_start] = ACTIONS(804),
  },
  [455] = {
    [sym_identifier] = ACTIONS(1468),
    [anon_sym_import] = ACTIONS(1468),
    [anon_sym_from] = ACTIONS(1468),
    [anon_sym_LPAREN] = ACTIONS(1466),
    [anon_sym_STAR] = ACTIONS(1466),
    [anon_sym_print] = ACTIONS(1468),
    [anon_sym_assert] = ACTIONS(1468),
    [anon_sym_return] = ACTIONS(1468),
    [anon_sym_del] = ACTIONS(1468),
    [anon_sym_raise] = ACTIONS(1468),
    [anon_sym_pass] = ACTIONS(1468),
    [anon_sym_break] = ACTIONS(1468),
    [anon_sym_continue] = ACTIONS(1468),
    [anon_sym_if] = ACTIONS(1468),
    [anon_sym_match] = ACTIONS(1468),
    [anon_sym_async] = ACTIONS(1468),
    [anon_sym_for] = ACTIONS(1468),
    [anon_sym_while] = ACTIONS(1468),
    [anon_sym_try] = ACTIONS(1468),
    [anon_sym_with] = ACTIONS(1468),
    [anon_sym_def] = ACTIONS(1468),
    [anon_sym_global] = ACTIONS(1468),
    [anon_sym_nonlocal] = ACTIONS(1468),
    [anon_sym_exec] = ACTIONS(1468),
    [anon_sym_type] = ACTIONS(1468),
    [anon_sym_class] = ACTIONS(1468),
    [anon_sym_LBRACK] = ACTIONS(1466),
    [anon_sym_AT] = ACTIONS(1466),
    [anon_sym_DASH] = ACTIONS(1466),
    [anon_sym_LBRACE] = ACTIONS(1466),
    [anon_sym_PLUS] = ACTIONS(1466),
    [anon_sym_not] = ACTIONS(1468),
    [anon_sym_TILDE] = ACTIONS(1466),
    [anon_sym_lambda] = ACTIONS(1468),
    [anon_sym_yield] = ACTIONS(1468),
    [sym_ellipsis] = ACTIONS(1466),
    [sym_integer] = ACTIONS(1468),
    [sym_float] = ACTIONS(1466),
    [anon_sym_await] = ACTIONS(1468),
    [sym_true] = ACTIONS(1468),
    [sym_false] = ACTIONS(1468),
    [sym_none] = ACTIONS(1468),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1468),
    [anon_sym_container] = ACTIONS(1468),
    [anon_sym_envvars] = ACTIONS(1468),
    [anon_sym_include] = ACTIONS(1468),
    [anon_sym_pepfile] = ACTIONS(1468),
    [anon_sym_pepschema] = ACTIONS(1468),
    [anon_sym_scattergather] = ACTIONS(1468),
    [anon_sym_version] = ACTIONS(1468),
    [anon_sym_wildcard_constraints] = ACTIONS(1468),
    [anon_sym_workdir] = ACTIONS(1468),
    [anon_sym_onerror] = ACTIONS(1468),
    [anon_sym_onstart] = ACTIONS(1468),
    [anon_sym_onsuccess] = ACTIONS(1468),
    [anon_sym_localrules] = ACTIONS(1468),
    [anon_sym_ruleorder] = ACTIONS(1468),
    [anon_sym_rule] = ACTIONS(1468),
    [anon_sym_checkpoint] = ACTIONS(1468),
    [anon_sym_use] = ACTIONS(1468),
    [anon_sym_module] = ACTIONS(1468),
    [sym__dedent] = ACTIONS(1466),
    [sym_string_start] = ACTIONS(1466),
  },
  [456] = {
    [ts_builtin_sym_end] = ACTIONS(1500),
    [sym_identifier] = ACTIONS(1502),
    [anon_sym_import] = ACTIONS(1502),
    [anon_sym_from] = ACTIONS(1502),
    [anon_sym_LPAREN] = ACTIONS(1500),
    [anon_sym_STAR] = ACTIONS(1500),
    [anon_sym_print] = ACTIONS(1502),
    [anon_sym_assert] = ACTIONS(1502),
    [anon_sym_return] = ACTIONS(1502),
    [anon_sym_del] = ACTIONS(1502),
    [anon_sym_raise] = ACTIONS(1502),
    [anon_sym_pass] = ACTIONS(1502),
    [anon_sym_break] = ACTIONS(1502),
    [anon_sym_continue] = ACTIONS(1502),
    [anon_sym_if] = ACTIONS(1502),
    [anon_sym_match] = ACTIONS(1502),
    [anon_sym_async] = ACTIONS(1502),
    [anon_sym_for] = ACTIONS(1502),
    [anon_sym_while] = ACTIONS(1502),
    [anon_sym_try] = ACTIONS(1502),
    [anon_sym_with] = ACTIONS(1502),
    [anon_sym_def] = ACTIONS(1502),
    [anon_sym_global] = ACTIONS(1502),
    [anon_sym_nonlocal] = ACTIONS(1502),
    [anon_sym_exec] = ACTIONS(1502),
    [anon_sym_type] = ACTIONS(1502),
    [anon_sym_class] = ACTIONS(1502),
    [anon_sym_LBRACK] = ACTIONS(1500),
    [anon_sym_AT] = ACTIONS(1500),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_LBRACE] = ACTIONS(1500),
    [anon_sym_PLUS] = ACTIONS(1500),
    [anon_sym_not] = ACTIONS(1502),
    [anon_sym_TILDE] = ACTIONS(1500),
    [anon_sym_lambda] = ACTIONS(1502),
    [anon_sym_yield] = ACTIONS(1502),
    [sym_ellipsis] = ACTIONS(1500),
    [sym_integer] = ACTIONS(1502),
    [sym_float] = ACTIONS(1500),
    [anon_sym_await] = ACTIONS(1502),
    [sym_true] = ACTIONS(1502),
    [sym_false] = ACTIONS(1502),
    [sym_none] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1502),
    [anon_sym_container] = ACTIONS(1502),
    [anon_sym_envvars] = ACTIONS(1502),
    [anon_sym_include] = ACTIONS(1502),
    [anon_sym_pepfile] = ACTIONS(1502),
    [anon_sym_pepschema] = ACTIONS(1502),
    [anon_sym_scattergather] = ACTIONS(1502),
    [anon_sym_version] = ACTIONS(1502),
    [anon_sym_wildcard_constraints] = ACTIONS(1502),
    [anon_sym_workdir] = ACTIONS(1502),
    [anon_sym_onerror] = ACTIONS(1502),
    [anon_sym_onstart] = ACTIONS(1502),
    [anon_sym_onsuccess] = ACTIONS(1502),
    [anon_sym_localrules] = ACTIONS(1502),
    [anon_sym_ruleorder] = ACTIONS(1502),
    [anon_sym_rule] = ACTIONS(1502),
    [anon_sym_checkpoint] = ACTIONS(1502),
    [anon_sym_use] = ACTIONS(1502),
    [anon_sym_module] = ACTIONS(1502),
    [sym_string_start] = ACTIONS(1500),
  },
  [457] = {
    [ts_builtin_sym_end] = ACTIONS(972),
    [sym_identifier] = ACTIONS(970),
    [anon_sym_import] = ACTIONS(970),
    [anon_sym_from] = ACTIONS(970),
    [anon_sym_LPAREN] = ACTIONS(972),
    [anon_sym_STAR] = ACTIONS(972),
    [anon_sym_print] = ACTIONS(970),
    [anon_sym_assert] = ACTIONS(970),
    [anon_sym_return] = ACTIONS(970),
    [anon_sym_del] = ACTIONS(970),
    [anon_sym_raise] = ACTIONS(970),
    [anon_sym_pass] = ACTIONS(970),
    [anon_sym_break] = ACTIONS(970),
    [anon_sym_continue] = ACTIONS(970),
    [anon_sym_if] = ACTIONS(970),
    [anon_sym_match] = ACTIONS(970),
    [anon_sym_async] = ACTIONS(970),
    [anon_sym_for] = ACTIONS(970),
    [anon_sym_while] = ACTIONS(970),
    [anon_sym_try] = ACTIONS(970),
    [anon_sym_with] = ACTIONS(970),
    [anon_sym_def] = ACTIONS(970),
    [anon_sym_global] = ACTIONS(970),
    [anon_sym_nonlocal] = ACTIONS(970),
    [anon_sym_exec] = ACTIONS(970),
    [anon_sym_type] = ACTIONS(970),
    [anon_sym_class] = ACTIONS(970),
    [anon_sym_LBRACK] = ACTIONS(972),
    [anon_sym_AT] = ACTIONS(972),
    [anon_sym_DASH] = ACTIONS(972),
    [anon_sym_LBRACE] = ACTIONS(972),
    [anon_sym_PLUS] = ACTIONS(972),
    [anon_sym_not] = ACTIONS(970),
    [anon_sym_TILDE] = ACTIONS(972),
    [anon_sym_lambda] = ACTIONS(970),
    [anon_sym_yield] = ACTIONS(970),
    [sym_ellipsis] = ACTIONS(972),
    [sym_integer] = ACTIONS(970),
    [sym_float] = ACTIONS(972),
    [anon_sym_await] = ACTIONS(970),
    [sym_true] = ACTIONS(970),
    [sym_false] = ACTIONS(970),
    [sym_none] = ACTIONS(970),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(970),
    [anon_sym_container] = ACTIONS(970),
    [anon_sym_envvars] = ACTIONS(970),
    [anon_sym_include] = ACTIONS(970),
    [anon_sym_pepfile] = ACTIONS(970),
    [anon_sym_pepschema] = ACTIONS(970),
    [anon_sym_scattergather] = ACTIONS(970),
    [anon_sym_version] = ACTIONS(970),
    [anon_sym_wildcard_constraints] = ACTIONS(970),
    [anon_sym_workdir] = ACTIONS(970),
    [anon_sym_onerror] = ACTIONS(970),
    [anon_sym_onstart] = ACTIONS(970),
    [anon_sym_onsuccess] = ACTIONS(970),
    [anon_sym_localrules] = ACTIONS(970),
    [anon_sym_ruleorder] = ACTIONS(970),
    [anon_sym_rule] = ACTIONS(970),
    [anon_sym_checkpoint] = ACTIONS(970),
    [anon_sym_use] = ACTIONS(970),
    [anon_sym_module] = ACTIONS(970),
    [sym_string_start] = ACTIONS(972),
  },
  [458] = {
    [sym_identifier] = ACTIONS(1502),
    [anon_sym_import] = ACTIONS(1502),
    [anon_sym_from] = ACTIONS(1502),
    [anon_sym_LPAREN] = ACTIONS(1500),
    [anon_sym_STAR] = ACTIONS(1500),
    [anon_sym_print] = ACTIONS(1502),
    [anon_sym_assert] = ACTIONS(1502),
    [anon_sym_return] = ACTIONS(1502),
    [anon_sym_del] = ACTIONS(1502),
    [anon_sym_raise] = ACTIONS(1502),
    [anon_sym_pass] = ACTIONS(1502),
    [anon_sym_break] = ACTIONS(1502),
    [anon_sym_continue] = ACTIONS(1502),
    [anon_sym_if] = ACTIONS(1502),
    [anon_sym_match] = ACTIONS(1502),
    [anon_sym_async] = ACTIONS(1502),
    [anon_sym_for] = ACTIONS(1502),
    [anon_sym_while] = ACTIONS(1502),
    [anon_sym_try] = ACTIONS(1502),
    [anon_sym_with] = ACTIONS(1502),
    [anon_sym_def] = ACTIONS(1502),
    [anon_sym_global] = ACTIONS(1502),
    [anon_sym_nonlocal] = ACTIONS(1502),
    [anon_sym_exec] = ACTIONS(1502),
    [anon_sym_type] = ACTIONS(1502),
    [anon_sym_class] = ACTIONS(1502),
    [anon_sym_LBRACK] = ACTIONS(1500),
    [anon_sym_AT] = ACTIONS(1500),
    [anon_sym_DASH] = ACTIONS(1500),
    [anon_sym_LBRACE] = ACTIONS(1500),
    [anon_sym_PLUS] = ACTIONS(1500),
    [anon_sym_not] = ACTIONS(1502),
    [anon_sym_TILDE] = ACTIONS(1500),
    [anon_sym_lambda] = ACTIONS(1502),
    [anon_sym_yield] = ACTIONS(1502),
    [sym_ellipsis] = ACTIONS(1500),
    [sym_integer] = ACTIONS(1502),
    [sym_float] = ACTIONS(1500),
    [anon_sym_await] = ACTIONS(1502),
    [sym_true] = ACTIONS(1502),
    [sym_false] = ACTIONS(1502),
    [sym_none] = ACTIONS(1502),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1502),
    [anon_sym_container] = ACTIONS(1502),
    [anon_sym_envvars] = ACTIONS(1502),
    [anon_sym_include] = ACTIONS(1502),
    [anon_sym_pepfile] = ACTIONS(1502),
    [anon_sym_pepschema] = ACTIONS(1502),
    [anon_sym_scattergather] = ACTIONS(1502),
    [anon_sym_version] = ACTIONS(1502),
    [anon_sym_wildcard_constraints] = ACTIONS(1502),
    [anon_sym_workdir] = ACTIONS(1502),
    [anon_sym_onerror] = ACTIONS(1502),
    [anon_sym_onstart] = ACTIONS(1502),
    [anon_sym_onsuccess] = ACTIONS(1502),
    [anon_sym_localrules] = ACTIONS(1502),
    [anon_sym_ruleorder] = ACTIONS(1502),
    [anon_sym_rule] = ACTIONS(1502),
    [anon_sym_checkpoint] = ACTIONS(1502),
    [anon_sym_use] = ACTIONS(1502),
    [anon_sym_module] = ACTIONS(1502),
    [sym__dedent] = ACTIONS(1500),
    [sym_string_start] = ACTIONS(1500),
  },
  [459] = {
    [sym_identifier] = ACTIONS(1498),
    [anon_sym_import] = ACTIONS(1498),
    [anon_sym_from] = ACTIONS(1498),
    [anon_sym_LPAREN] = ACTIONS(1496),
    [anon_sym_STAR] = ACTIONS(1496),
    [anon_sym_print] = ACTIONS(1498),
    [anon_sym_assert] = ACTIONS(1498),
    [anon_sym_return] = ACTIONS(1498),
    [anon_sym_del] = ACTIONS(1498),
    [anon_sym_raise] = ACTIONS(1498),
    [anon_sym_pass] = ACTIONS(1498),
    [anon_sym_break] = ACTIONS(1498),
    [anon_sym_continue] = ACTIONS(1498),
    [anon_sym_if] = ACTIONS(1498),
    [anon_sym_match] = ACTIONS(1498),
    [anon_sym_async] = ACTIONS(1498),
    [anon_sym_for] = ACTIONS(1498),
    [anon_sym_while] = ACTIONS(1498),
    [anon_sym_try] = ACTIONS(1498),
    [anon_sym_with] = ACTIONS(1498),
    [anon_sym_def] = ACTIONS(1498),
    [anon_sym_global] = ACTIONS(1498),
    [anon_sym_nonlocal] = ACTIONS(1498),
    [anon_sym_exec] = ACTIONS(1498),
    [anon_sym_type] = ACTIONS(1498),
    [anon_sym_class] = ACTIONS(1498),
    [anon_sym_LBRACK] = ACTIONS(1496),
    [anon_sym_AT] = ACTIONS(1496),
    [anon_sym_DASH] = ACTIONS(1496),
    [anon_sym_LBRACE] = ACTIONS(1496),
    [anon_sym_PLUS] = ACTIONS(1496),
    [anon_sym_not] = ACTIONS(1498),
    [anon_sym_TILDE] = ACTIONS(1496),
    [anon_sym_lambda] = ACTIONS(1498),
    [anon_sym_yield] = ACTIONS(1498),
    [sym_ellipsis] = ACTIONS(1496),
    [sym_integer] = ACTIONS(1498),
    [sym_float] = ACTIONS(1496),
    [anon_sym_await] = ACTIONS(1498),
    [sym_true] = ACTIONS(1498),
    [sym_false] = ACTIONS(1498),
    [sym_none] = ACTIONS(1498),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1498),
    [anon_sym_container] = ACTIONS(1498),
    [anon_sym_envvars] = ACTIONS(1498),
    [anon_sym_include] = ACTIONS(1498),
    [anon_sym_pepfile] = ACTIONS(1498),
    [anon_sym_pepschema] = ACTIONS(1498),
    [anon_sym_scattergather] = ACTIONS(1498),
    [anon_sym_version] = ACTIONS(1498),
    [anon_sym_wildcard_constraints] = ACTIONS(1498),
    [anon_sym_workdir] = ACTIONS(1498),
    [anon_sym_onerror] = ACTIONS(1498),
    [anon_sym_onstart] = ACTIONS(1498),
    [anon_sym_onsuccess] = ACTIONS(1498),
    [anon_sym_localrules] = ACTIONS(1498),
    [anon_sym_ruleorder] = ACTIONS(1498),
    [anon_sym_rule] = ACTIONS(1498),
    [anon_sym_checkpoint] = ACTIONS(1498),
    [anon_sym_use] = ACTIONS(1498),
    [anon_sym_module] = ACTIONS(1498),
    [sym__dedent] = ACTIONS(1496),
    [sym_string_start] = ACTIONS(1496),
  },
  [460] = {
    [ts_builtin_sym_end] = ACTIONS(1504),
    [sym_identifier] = ACTIONS(1506),
    [anon_sym_import] = ACTIONS(1506),
    [anon_sym_from] = ACTIONS(1506),
    [anon_sym_LPAREN] = ACTIONS(1504),
    [anon_sym_STAR] = ACTIONS(1504),
    [anon_sym_print] = ACTIONS(1506),
    [anon_sym_assert] = ACTIONS(1506),
    [anon_sym_return] = ACTIONS(1506),
    [anon_sym_del] = ACTIONS(1506),
    [anon_sym_raise] = ACTIONS(1506),
    [anon_sym_pass] = ACTIONS(1506),
    [anon_sym_break] = ACTIONS(1506),
    [anon_sym_continue] = ACTIONS(1506),
    [anon_sym_if] = ACTIONS(1506),
    [anon_sym_match] = ACTIONS(1506),
    [anon_sym_async] = ACTIONS(1506),
    [anon_sym_for] = ACTIONS(1506),
    [anon_sym_while] = ACTIONS(1506),
    [anon_sym_try] = ACTIONS(1506),
    [anon_sym_with] = ACTIONS(1506),
    [anon_sym_def] = ACTIONS(1506),
    [anon_sym_global] = ACTIONS(1506),
    [anon_sym_nonlocal] = ACTIONS(1506),
    [anon_sym_exec] = ACTIONS(1506),
    [anon_sym_type] = ACTIONS(1506),
    [anon_sym_class] = ACTIONS(1506),
    [anon_sym_LBRACK] = ACTIONS(1504),
    [anon_sym_AT] = ACTIONS(1504),
    [anon_sym_DASH] = ACTIONS(1504),
    [anon_sym_LBRACE] = ACTIONS(1504),
    [anon_sym_PLUS] = ACTIONS(1504),
    [anon_sym_not] = ACTIONS(1506),
    [anon_sym_TILDE] = ACTIONS(1504),
    [anon_sym_lambda] = ACTIONS(1506),
    [anon_sym_yield] = ACTIONS(1506),
    [sym_ellipsis] = ACTIONS(1504),
    [sym_integer] = ACTIONS(1506),
    [sym_float] = ACTIONS(1504),
    [anon_sym_await] = ACTIONS(1506),
    [sym_true] = ACTIONS(1506),
    [sym_false] = ACTIONS(1506),
    [sym_none] = ACTIONS(1506),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1506),
    [anon_sym_container] = ACTIONS(1506),
    [anon_sym_envvars] = ACTIONS(1506),
    [anon_sym_include] = ACTIONS(1506),
    [anon_sym_pepfile] = ACTIONS(1506),
    [anon_sym_pepschema] = ACTIONS(1506),
    [anon_sym_scattergather] = ACTIONS(1506),
    [anon_sym_version] = ACTIONS(1506),
    [anon_sym_wildcard_constraints] = ACTIONS(1506),
    [anon_sym_workdir] = ACTIONS(1506),
    [anon_sym_onerror] = ACTIONS(1506),
    [anon_sym_onstart] = ACTIONS(1506),
    [anon_sym_onsuccess] = ACTIONS(1506),
    [anon_sym_localrules] = ACTIONS(1506),
    [anon_sym_ruleorder] = ACTIONS(1506),
    [anon_sym_rule] = ACTIONS(1506),
    [anon_sym_checkpoint] = ACTIONS(1506),
    [anon_sym_use] = ACTIONS(1506),
    [anon_sym_module] = ACTIONS(1506),
    [sym_string_start] = ACTIONS(1504),
  },
  [461] = {
    [sym_identifier] = ACTIONS(1506),
    [anon_sym_import] = ACTIONS(1506),
    [anon_sym_from] = ACTIONS(1506),
    [anon_sym_LPAREN] = ACTIONS(1504),
    [anon_sym_STAR] = ACTIONS(1504),
    [anon_sym_print] = ACTIONS(1506),
    [anon_sym_assert] = ACTIONS(1506),
    [anon_sym_return] = ACTIONS(1506),
    [anon_sym_del] = ACTIONS(1506),
    [anon_sym_raise] = ACTIONS(1506),
    [anon_sym_pass] = ACTIONS(1506),
    [anon_sym_break] = ACTIONS(1506),
    [anon_sym_continue] = ACTIONS(1506),
    [anon_sym_if] = ACTIONS(1506),
    [anon_sym_match] = ACTIONS(1506),
    [anon_sym_async] = ACTIONS(1506),
    [anon_sym_for] = ACTIONS(1506),
    [anon_sym_while] = ACTIONS(1506),
    [anon_sym_try] = ACTIONS(1506),
    [anon_sym_with] = ACTIONS(1506),
    [anon_sym_def] = ACTIONS(1506),
    [anon_sym_global] = ACTIONS(1506),
    [anon_sym_nonlocal] = ACTIONS(1506),
    [anon_sym_exec] = ACTIONS(1506),
    [anon_sym_type] = ACTIONS(1506),
    [anon_sym_class] = ACTIONS(1506),
    [anon_sym_LBRACK] = ACTIONS(1504),
    [anon_sym_AT] = ACTIONS(1504),
    [anon_sym_DASH] = ACTIONS(1504),
    [anon_sym_LBRACE] = ACTIONS(1504),
    [anon_sym_PLUS] = ACTIONS(1504),
    [anon_sym_not] = ACTIONS(1506),
    [anon_sym_TILDE] = ACTIONS(1504),
    [anon_sym_lambda] = ACTIONS(1506),
    [anon_sym_yield] = ACTIONS(1506),
    [sym_ellipsis] = ACTIONS(1504),
    [sym_integer] = ACTIONS(1506),
    [sym_float] = ACTIONS(1504),
    [anon_sym_await] = ACTIONS(1506),
    [sym_true] = ACTIONS(1506),
    [sym_false] = ACTIONS(1506),
    [sym_none] = ACTIONS(1506),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1506),
    [anon_sym_container] = ACTIONS(1506),
    [anon_sym_envvars] = ACTIONS(1506),
    [anon_sym_include] = ACTIONS(1506),
    [anon_sym_pepfile] = ACTIONS(1506),
    [anon_sym_pepschema] = ACTIONS(1506),
    [anon_sym_scattergather] = ACTIONS(1506),
    [anon_sym_version] = ACTIONS(1506),
    [anon_sym_wildcard_constraints] = ACTIONS(1506),
    [anon_sym_workdir] = ACTIONS(1506),
    [anon_sym_onerror] = ACTIONS(1506),
    [anon_sym_onstart] = ACTIONS(1506),
    [anon_sym_onsuccess] = ACTIONS(1506),
    [anon_sym_localrules] = ACTIONS(1506),
    [anon_sym_ruleorder] = ACTIONS(1506),
    [anon_sym_rule] = ACTIONS(1506),
    [anon_sym_checkpoint] = ACTIONS(1506),
    [anon_sym_use] = ACTIONS(1506),
    [anon_sym_module] = ACTIONS(1506),
    [sym__dedent] = ACTIONS(1504),
    [sym_string_start] = ACTIONS(1504),
  },
  [462] = {
    [sym_identifier] = ACTIONS(1508),
    [anon_sym_import] = ACTIONS(1508),
    [anon_sym_from] = ACTIONS(1508),
    [anon_sym_LPAREN] = ACTIONS(1510),
    [anon_sym_STAR] = ACTIONS(1510),
    [anon_sym_print] = ACTIONS(1508),
    [anon_sym_assert] = ACTIONS(1508),
    [anon_sym_return] = ACTIONS(1508),
    [anon_sym_del] = ACTIONS(1508),
    [anon_sym_raise] = ACTIONS(1508),
    [anon_sym_pass] = ACTIONS(1508),
    [anon_sym_break] = ACTIONS(1508),
    [anon_sym_continue] = ACTIONS(1508),
    [anon_sym_if] = ACTIONS(1508),
    [anon_sym_match] = ACTIONS(1508),
    [anon_sym_async] = ACTIONS(1508),
    [anon_sym_for] = ACTIONS(1508),
    [anon_sym_while] = ACTIONS(1508),
    [anon_sym_try] = ACTIONS(1508),
    [anon_sym_with] = ACTIONS(1508),
    [anon_sym_def] = ACTIONS(1508),
    [anon_sym_global] = ACTIONS(1508),
    [anon_sym_nonlocal] = ACTIONS(1508),
    [anon_sym_exec] = ACTIONS(1508),
    [anon_sym_type] = ACTIONS(1508),
    [anon_sym_class] = ACTIONS(1508),
    [anon_sym_LBRACK] = ACTIONS(1510),
    [anon_sym_AT] = ACTIONS(1510),
    [anon_sym_DASH] = ACTIONS(1510),
    [anon_sym_LBRACE] = ACTIONS(1510),
    [anon_sym_PLUS] = ACTIONS(1510),
    [anon_sym_not] = ACTIONS(1508),
    [anon_sym_TILDE] = ACTIONS(1510),
    [anon_sym_lambda] = ACTIONS(1508),
    [anon_sym_yield] = ACTIONS(1508),
    [sym_ellipsis] = ACTIONS(1510),
    [sym_integer] = ACTIONS(1508),
    [sym_float] = ACTIONS(1510),
    [anon_sym_await] = ACTIONS(1508),
    [sym_true] = ACTIONS(1508),
    [sym_false] = ACTIONS(1508),
    [sym_none] = ACTIONS(1508),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1508),
    [anon_sym_container] = ACTIONS(1508),
    [anon_sym_envvars] = ACTIONS(1508),
    [anon_sym_include] = ACTIONS(1508),
    [anon_sym_pepfile] = ACTIONS(1508),
    [anon_sym_pepschema] = ACTIONS(1508),
    [anon_sym_scattergather] = ACTIONS(1508),
    [anon_sym_version] = ACTIONS(1508),
    [anon_sym_wildcard_constraints] = ACTIONS(1508),
    [anon_sym_workdir] = ACTIONS(1508),
    [anon_sym_onerror] = ACTIONS(1508),
    [anon_sym_onstart] = ACTIONS(1508),
    [anon_sym_onsuccess] = ACTIONS(1508),
    [anon_sym_localrules] = ACTIONS(1508),
    [anon_sym_ruleorder] = ACTIONS(1508),
    [anon_sym_rule] = ACTIONS(1508),
    [anon_sym_checkpoint] = ACTIONS(1508),
    [anon_sym_use] = ACTIONS(1508),
    [anon_sym_module] = ACTIONS(1508),
    [sym__dedent] = ACTIONS(1510),
    [sym_string_start] = ACTIONS(1510),
  },
  [463] = {
    [ts_builtin_sym_end] = ACTIONS(1512),
    [sym_identifier] = ACTIONS(1514),
    [anon_sym_import] = ACTIONS(1514),
    [anon_sym_from] = ACTIONS(1514),
    [anon_sym_LPAREN] = ACTIONS(1512),
    [anon_sym_STAR] = ACTIONS(1512),
    [anon_sym_print] = ACTIONS(1514),
    [anon_sym_assert] = ACTIONS(1514),
    [anon_sym_return] = ACTIONS(1514),
    [anon_sym_del] = ACTIONS(1514),
    [anon_sym_raise] = ACTIONS(1514),
    [anon_sym_pass] = ACTIONS(1514),
    [anon_sym_break] = ACTIONS(1514),
    [anon_sym_continue] = ACTIONS(1514),
    [anon_sym_if] = ACTIONS(1514),
    [anon_sym_match] = ACTIONS(1514),
    [anon_sym_async] = ACTIONS(1514),
    [anon_sym_for] = ACTIONS(1514),
    [anon_sym_while] = ACTIONS(1514),
    [anon_sym_try] = ACTIONS(1514),
    [anon_sym_with] = ACTIONS(1514),
    [anon_sym_def] = ACTIONS(1514),
    [anon_sym_global] = ACTIONS(1514),
    [anon_sym_nonlocal] = ACTIONS(1514),
    [anon_sym_exec] = ACTIONS(1514),
    [anon_sym_type] = ACTIONS(1514),
    [anon_sym_class] = ACTIONS(1514),
    [anon_sym_LBRACK] = ACTIONS(1512),
    [anon_sym_AT] = ACTIONS(1512),
    [anon_sym_DASH] = ACTIONS(1512),
    [anon_sym_LBRACE] = ACTIONS(1512),
    [anon_sym_PLUS] = ACTIONS(1512),
    [anon_sym_not] = ACTIONS(1514),
    [anon_sym_TILDE] = ACTIONS(1512),
    [anon_sym_lambda] = ACTIONS(1514),
    [anon_sym_yield] = ACTIONS(1514),
    [sym_ellipsis] = ACTIONS(1512),
    [sym_integer] = ACTIONS(1514),
    [sym_float] = ACTIONS(1512),
    [anon_sym_await] = ACTIONS(1514),
    [sym_true] = ACTIONS(1514),
    [sym_false] = ACTIONS(1514),
    [sym_none] = ACTIONS(1514),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1514),
    [anon_sym_container] = ACTIONS(1514),
    [anon_sym_envvars] = ACTIONS(1514),
    [anon_sym_include] = ACTIONS(1514),
    [anon_sym_pepfile] = ACTIONS(1514),
    [anon_sym_pepschema] = ACTIONS(1514),
    [anon_sym_scattergather] = ACTIONS(1514),
    [anon_sym_version] = ACTIONS(1514),
    [anon_sym_wildcard_constraints] = ACTIONS(1514),
    [anon_sym_workdir] = ACTIONS(1514),
    [anon_sym_onerror] = ACTIONS(1514),
    [anon_sym_onstart] = ACTIONS(1514),
    [anon_sym_onsuccess] = ACTIONS(1514),
    [anon_sym_localrules] = ACTIONS(1514),
    [anon_sym_ruleorder] = ACTIONS(1514),
    [anon_sym_rule] = ACTIONS(1514),
    [anon_sym_checkpoint] = ACTIONS(1514),
    [anon_sym_use] = ACTIONS(1514),
    [anon_sym_module] = ACTIONS(1514),
    [sym_string_start] = ACTIONS(1512),
  },
  [464] = {
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_import] = ACTIONS(1516),
    [anon_sym_from] = ACTIONS(1516),
    [anon_sym_LPAREN] = ACTIONS(1518),
    [anon_sym_STAR] = ACTIONS(1518),
    [anon_sym_print] = ACTIONS(1516),
    [anon_sym_assert] = ACTIONS(1516),
    [anon_sym_return] = ACTIONS(1516),
    [anon_sym_del] = ACTIONS(1516),
    [anon_sym_raise] = ACTIONS(1516),
    [anon_sym_pass] = ACTIONS(1516),
    [anon_sym_break] = ACTIONS(1516),
    [anon_sym_continue] = ACTIONS(1516),
    [anon_sym_if] = ACTIONS(1516),
    [anon_sym_match] = ACTIONS(1516),
    [anon_sym_async] = ACTIONS(1516),
    [anon_sym_for] = ACTIONS(1516),
    [anon_sym_while] = ACTIONS(1516),
    [anon_sym_try] = ACTIONS(1516),
    [anon_sym_with] = ACTIONS(1516),
    [anon_sym_def] = ACTIONS(1516),
    [anon_sym_global] = ACTIONS(1516),
    [anon_sym_nonlocal] = ACTIONS(1516),
    [anon_sym_exec] = ACTIONS(1516),
    [anon_sym_type] = ACTIONS(1516),
    [anon_sym_class] = ACTIONS(1516),
    [anon_sym_LBRACK] = ACTIONS(1518),
    [anon_sym_AT] = ACTIONS(1518),
    [anon_sym_DASH] = ACTIONS(1518),
    [anon_sym_LBRACE] = ACTIONS(1518),
    [anon_sym_PLUS] = ACTIONS(1518),
    [anon_sym_not] = ACTIONS(1516),
    [anon_sym_TILDE] = ACTIONS(1518),
    [anon_sym_lambda] = ACTIONS(1516),
    [anon_sym_yield] = ACTIONS(1516),
    [sym_ellipsis] = ACTIONS(1518),
    [sym_integer] = ACTIONS(1516),
    [sym_float] = ACTIONS(1518),
    [anon_sym_await] = ACTIONS(1516),
    [sym_true] = ACTIONS(1516),
    [sym_false] = ACTIONS(1516),
    [sym_none] = ACTIONS(1516),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1516),
    [anon_sym_container] = ACTIONS(1516),
    [anon_sym_envvars] = ACTIONS(1516),
    [anon_sym_include] = ACTIONS(1516),
    [anon_sym_pepfile] = ACTIONS(1516),
    [anon_sym_pepschema] = ACTIONS(1516),
    [anon_sym_scattergather] = ACTIONS(1516),
    [anon_sym_version] = ACTIONS(1516),
    [anon_sym_wildcard_constraints] = ACTIONS(1516),
    [anon_sym_workdir] = ACTIONS(1516),
    [anon_sym_onerror] = ACTIONS(1516),
    [anon_sym_onstart] = ACTIONS(1516),
    [anon_sym_onsuccess] = ACTIONS(1516),
    [anon_sym_localrules] = ACTIONS(1516),
    [anon_sym_ruleorder] = ACTIONS(1516),
    [anon_sym_rule] = ACTIONS(1516),
    [anon_sym_checkpoint] = ACTIONS(1516),
    [anon_sym_use] = ACTIONS(1516),
    [anon_sym_module] = ACTIONS(1516),
    [sym__dedent] = ACTIONS(1518),
    [sym_string_start] = ACTIONS(1518),
  },
  [465] = {
    [ts_builtin_sym_end] = ACTIONS(1510),
    [sym_identifier] = ACTIONS(1508),
    [anon_sym_import] = ACTIONS(1508),
    [anon_sym_from] = ACTIONS(1508),
    [anon_sym_LPAREN] = ACTIONS(1510),
    [anon_sym_STAR] = ACTIONS(1510),
    [anon_sym_print] = ACTIONS(1508),
    [anon_sym_assert] = ACTIONS(1508),
    [anon_sym_return] = ACTIONS(1508),
    [anon_sym_del] = ACTIONS(1508),
    [anon_sym_raise] = ACTIONS(1508),
    [anon_sym_pass] = ACTIONS(1508),
    [anon_sym_break] = ACTIONS(1508),
    [anon_sym_continue] = ACTIONS(1508),
    [anon_sym_if] = ACTIONS(1508),
    [anon_sym_match] = ACTIONS(1508),
    [anon_sym_async] = ACTIONS(1508),
    [anon_sym_for] = ACTIONS(1508),
    [anon_sym_while] = ACTIONS(1508),
    [anon_sym_try] = ACTIONS(1508),
    [anon_sym_with] = ACTIONS(1508),
    [anon_sym_def] = ACTIONS(1508),
    [anon_sym_global] = ACTIONS(1508),
    [anon_sym_nonlocal] = ACTIONS(1508),
    [anon_sym_exec] = ACTIONS(1508),
    [anon_sym_type] = ACTIONS(1508),
    [anon_sym_class] = ACTIONS(1508),
    [anon_sym_LBRACK] = ACTIONS(1510),
    [anon_sym_AT] = ACTIONS(1510),
    [anon_sym_DASH] = ACTIONS(1510),
    [anon_sym_LBRACE] = ACTIONS(1510),
    [anon_sym_PLUS] = ACTIONS(1510),
    [anon_sym_not] = ACTIONS(1508),
    [anon_sym_TILDE] = ACTIONS(1510),
    [anon_sym_lambda] = ACTIONS(1508),
    [anon_sym_yield] = ACTIONS(1508),
    [sym_ellipsis] = ACTIONS(1510),
    [sym_integer] = ACTIONS(1508),
    [sym_float] = ACTIONS(1510),
    [anon_sym_await] = ACTIONS(1508),
    [sym_true] = ACTIONS(1508),
    [sym_false] = ACTIONS(1508),
    [sym_none] = ACTIONS(1508),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1508),
    [anon_sym_container] = ACTIONS(1508),
    [anon_sym_envvars] = ACTIONS(1508),
    [anon_sym_include] = ACTIONS(1508),
    [anon_sym_pepfile] = ACTIONS(1508),
    [anon_sym_pepschema] = ACTIONS(1508),
    [anon_sym_scattergather] = ACTIONS(1508),
    [anon_sym_version] = ACTIONS(1508),
    [anon_sym_wildcard_constraints] = ACTIONS(1508),
    [anon_sym_workdir] = ACTIONS(1508),
    [anon_sym_onerror] = ACTIONS(1508),
    [anon_sym_onstart] = ACTIONS(1508),
    [anon_sym_onsuccess] = ACTIONS(1508),
    [anon_sym_localrules] = ACTIONS(1508),
    [anon_sym_ruleorder] = ACTIONS(1508),
    [anon_sym_rule] = ACTIONS(1508),
    [anon_sym_checkpoint] = ACTIONS(1508),
    [anon_sym_use] = ACTIONS(1508),
    [anon_sym_module] = ACTIONS(1508),
    [sym_string_start] = ACTIONS(1510),
  },
  [466] = {
    [ts_builtin_sym_end] = ACTIONS(1518),
    [sym_identifier] = ACTIONS(1516),
    [anon_sym_import] = ACTIONS(1516),
    [anon_sym_from] = ACTIONS(1516),
    [anon_sym_LPAREN] = ACTIONS(1518),
    [anon_sym_STAR] = ACTIONS(1518),
    [anon_sym_print] = ACTIONS(1516),
    [anon_sym_assert] = ACTIONS(1516),
    [anon_sym_return] = ACTIONS(1516),
    [anon_sym_del] = ACTIONS(1516),
    [anon_sym_raise] = ACTIONS(1516),
    [anon_sym_pass] = ACTIONS(1516),
    [anon_sym_break] = ACTIONS(1516),
    [anon_sym_continue] = ACTIONS(1516),
    [anon_sym_if] = ACTIONS(1516),
    [anon_sym_match] = ACTIONS(1516),
    [anon_sym_async] = ACTIONS(1516),
    [anon_sym_for] = ACTIONS(1516),
    [anon_sym_while] = ACTIONS(1516),
    [anon_sym_try] = ACTIONS(1516),
    [anon_sym_with] = ACTIONS(1516),
    [anon_sym_def] = ACTIONS(1516),
    [anon_sym_global] = ACTIONS(1516),
    [anon_sym_nonlocal] = ACTIONS(1516),
    [anon_sym_exec] = ACTIONS(1516),
    [anon_sym_type] = ACTIONS(1516),
    [anon_sym_class] = ACTIONS(1516),
    [anon_sym_LBRACK] = ACTIONS(1518),
    [anon_sym_AT] = ACTIONS(1518),
    [anon_sym_DASH] = ACTIONS(1518),
    [anon_sym_LBRACE] = ACTIONS(1518),
    [anon_sym_PLUS] = ACTIONS(1518),
    [anon_sym_not] = ACTIONS(1516),
    [anon_sym_TILDE] = ACTIONS(1518),
    [anon_sym_lambda] = ACTIONS(1516),
    [anon_sym_yield] = ACTIONS(1516),
    [sym_ellipsis] = ACTIONS(1518),
    [sym_integer] = ACTIONS(1516),
    [sym_float] = ACTIONS(1518),
    [anon_sym_await] = ACTIONS(1516),
    [sym_true] = ACTIONS(1516),
    [sym_false] = ACTIONS(1516),
    [sym_none] = ACTIONS(1516),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1516),
    [anon_sym_container] = ACTIONS(1516),
    [anon_sym_envvars] = ACTIONS(1516),
    [anon_sym_include] = ACTIONS(1516),
    [anon_sym_pepfile] = ACTIONS(1516),
    [anon_sym_pepschema] = ACTIONS(1516),
    [anon_sym_scattergather] = ACTIONS(1516),
    [anon_sym_version] = ACTIONS(1516),
    [anon_sym_wildcard_constraints] = ACTIONS(1516),
    [anon_sym_workdir] = ACTIONS(1516),
    [anon_sym_onerror] = ACTIONS(1516),
    [anon_sym_onstart] = ACTIONS(1516),
    [anon_sym_onsuccess] = ACTIONS(1516),
    [anon_sym_localrules] = ACTIONS(1516),
    [anon_sym_ruleorder] = ACTIONS(1516),
    [anon_sym_rule] = ACTIONS(1516),
    [anon_sym_checkpoint] = ACTIONS(1516),
    [anon_sym_use] = ACTIONS(1516),
    [anon_sym_module] = ACTIONS(1516),
    [sym_string_start] = ACTIONS(1518),
  },
  [467] = {
    [sym_identifier] = ACTIONS(1520),
    [anon_sym_import] = ACTIONS(1520),
    [anon_sym_from] = ACTIONS(1520),
    [anon_sym_LPAREN] = ACTIONS(1522),
    [anon_sym_STAR] = ACTIONS(1522),
    [anon_sym_print] = ACTIONS(1520),
    [anon_sym_assert] = ACTIONS(1520),
    [anon_sym_return] = ACTIONS(1520),
    [anon_sym_del] = ACTIONS(1520),
    [anon_sym_raise] = ACTIONS(1520),
    [anon_sym_pass] = ACTIONS(1520),
    [anon_sym_break] = ACTIONS(1520),
    [anon_sym_continue] = ACTIONS(1520),
    [anon_sym_if] = ACTIONS(1520),
    [anon_sym_match] = ACTIONS(1520),
    [anon_sym_async] = ACTIONS(1520),
    [anon_sym_for] = ACTIONS(1520),
    [anon_sym_while] = ACTIONS(1520),
    [anon_sym_try] = ACTIONS(1520),
    [anon_sym_with] = ACTIONS(1520),
    [anon_sym_def] = ACTIONS(1520),
    [anon_sym_global] = ACTIONS(1520),
    [anon_sym_nonlocal] = ACTIONS(1520),
    [anon_sym_exec] = ACTIONS(1520),
    [anon_sym_type] = ACTIONS(1520),
    [anon_sym_class] = ACTIONS(1520),
    [anon_sym_LBRACK] = ACTIONS(1522),
    [anon_sym_AT] = ACTIONS(1522),
    [anon_sym_DASH] = ACTIONS(1522),
    [anon_sym_LBRACE] = ACTIONS(1522),
    [anon_sym_PLUS] = ACTIONS(1522),
    [anon_sym_not] = ACTIONS(1520),
    [anon_sym_TILDE] = ACTIONS(1522),
    [anon_sym_lambda] = ACTIONS(1520),
    [anon_sym_yield] = ACTIONS(1520),
    [sym_ellipsis] = ACTIONS(1522),
    [sym_integer] = ACTIONS(1520),
    [sym_float] = ACTIONS(1522),
    [anon_sym_await] = ACTIONS(1520),
    [sym_true] = ACTIONS(1520),
    [sym_false] = ACTIONS(1520),
    [sym_none] = ACTIONS(1520),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1520),
    [anon_sym_container] = ACTIONS(1520),
    [anon_sym_envvars] = ACTIONS(1520),
    [anon_sym_include] = ACTIONS(1520),
    [anon_sym_pepfile] = ACTIONS(1520),
    [anon_sym_pepschema] = ACTIONS(1520),
    [anon_sym_scattergather] = ACTIONS(1520),
    [anon_sym_version] = ACTIONS(1520),
    [anon_sym_wildcard_constraints] = ACTIONS(1520),
    [anon_sym_workdir] = ACTIONS(1520),
    [anon_sym_onerror] = ACTIONS(1520),
    [anon_sym_onstart] = ACTIONS(1520),
    [anon_sym_onsuccess] = ACTIONS(1520),
    [anon_sym_localrules] = ACTIONS(1520),
    [anon_sym_ruleorder] = ACTIONS(1520),
    [anon_sym_rule] = ACTIONS(1520),
    [anon_sym_checkpoint] = ACTIONS(1520),
    [anon_sym_use] = ACTIONS(1520),
    [anon_sym_module] = ACTIONS(1520),
    [sym__dedent] = ACTIONS(1522),
    [sym_string_start] = ACTIONS(1522),
  },
  [468] = {
    [sym_identifier] = ACTIONS(1294),
    [anon_sym_import] = ACTIONS(1294),
    [anon_sym_from] = ACTIONS(1294),
    [anon_sym_LPAREN] = ACTIONS(1292),
    [anon_sym_STAR] = ACTIONS(1292),
    [anon_sym_print] = ACTIONS(1294),
    [anon_sym_assert] = ACTIONS(1294),
    [anon_sym_return] = ACTIONS(1294),
    [anon_sym_del] = ACTIONS(1294),
    [anon_sym_raise] = ACTIONS(1294),
    [anon_sym_pass] = ACTIONS(1294),
    [anon_sym_break] = ACTIONS(1294),
    [anon_sym_continue] = ACTIONS(1294),
    [anon_sym_if] = ACTIONS(1294),
    [anon_sym_match] = ACTIONS(1294),
    [anon_sym_async] = ACTIONS(1294),
    [anon_sym_for] = ACTIONS(1294),
    [anon_sym_while] = ACTIONS(1294),
    [anon_sym_try] = ACTIONS(1294),
    [anon_sym_with] = ACTIONS(1294),
    [anon_sym_def] = ACTIONS(1294),
    [anon_sym_global] = ACTIONS(1294),
    [anon_sym_nonlocal] = ACTIONS(1294),
    [anon_sym_exec] = ACTIONS(1294),
    [anon_sym_type] = ACTIONS(1294),
    [anon_sym_class] = ACTIONS(1294),
    [anon_sym_LBRACK] = ACTIONS(1292),
    [anon_sym_AT] = ACTIONS(1292),
    [anon_sym_DASH] = ACTIONS(1292),
    [anon_sym_LBRACE] = ACTIONS(1292),
    [anon_sym_PLUS] = ACTIONS(1292),
    [anon_sym_not] = ACTIONS(1294),
    [anon_sym_TILDE] = ACTIONS(1292),
    [anon_sym_lambda] = ACTIONS(1294),
    [anon_sym_yield] = ACTIONS(1294),
    [sym_ellipsis] = ACTIONS(1292),
    [sym_integer] = ACTIONS(1294),
    [sym_float] = ACTIONS(1292),
    [anon_sym_await] = ACTIONS(1294),
    [sym_true] = ACTIONS(1294),
    [sym_false] = ACTIONS(1294),
    [sym_none] = ACTIONS(1294),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1294),
    [anon_sym_container] = ACTIONS(1294),
    [anon_sym_envvars] = ACTIONS(1294),
    [anon_sym_include] = ACTIONS(1294),
    [anon_sym_pepfile] = ACTIONS(1294),
    [anon_sym_pepschema] = ACTIONS(1294),
    [anon_sym_scattergather] = ACTIONS(1294),
    [anon_sym_version] = ACTIONS(1294),
    [anon_sym_wildcard_constraints] = ACTIONS(1294),
    [anon_sym_workdir] = ACTIONS(1294),
    [anon_sym_onerror] = ACTIONS(1294),
    [anon_sym_onstart] = ACTIONS(1294),
    [anon_sym_onsuccess] = ACTIONS(1294),
    [anon_sym_localrules] = ACTIONS(1294),
    [anon_sym_ruleorder] = ACTIONS(1294),
    [anon_sym_rule] = ACTIONS(1294),
    [anon_sym_checkpoint] = ACTIONS(1294),
    [anon_sym_use] = ACTIONS(1294),
    [anon_sym_module] = ACTIONS(1294),
    [sym__dedent] = ACTIONS(1292),
    [sym_string_start] = ACTIONS(1292),
  },
  [469] = {
    [sym_identifier] = ACTIONS(1298),
    [anon_sym_import] = ACTIONS(1298),
    [anon_sym_from] = ACTIONS(1298),
    [anon_sym_LPAREN] = ACTIONS(1296),
    [anon_sym_STAR] = ACTIONS(1296),
    [anon_sym_print] = ACTIONS(1298),
    [anon_sym_assert] = ACTIONS(1298),
    [anon_sym_return] = ACTIONS(1298),
    [anon_sym_del] = ACTIONS(1298),
    [anon_sym_raise] = ACTIONS(1298),
    [anon_sym_pass] = ACTIONS(1298),
    [anon_sym_break] = ACTIONS(1298),
    [anon_sym_continue] = ACTIONS(1298),
    [anon_sym_if] = ACTIONS(1298),
    [anon_sym_match] = ACTIONS(1298),
    [anon_sym_async] = ACTIONS(1298),
    [anon_sym_for] = ACTIONS(1298),
    [anon_sym_while] = ACTIONS(1298),
    [anon_sym_try] = ACTIONS(1298),
    [anon_sym_with] = ACTIONS(1298),
    [anon_sym_def] = ACTIONS(1298),
    [anon_sym_global] = ACTIONS(1298),
    [anon_sym_nonlocal] = ACTIONS(1298),
    [anon_sym_exec] = ACTIONS(1298),
    [anon_sym_type] = ACTIONS(1298),
    [anon_sym_class] = ACTIONS(1298),
    [anon_sym_LBRACK] = ACTIONS(1296),
    [anon_sym_AT] = ACTIONS(1296),
    [anon_sym_DASH] = ACTIONS(1296),
    [anon_sym_LBRACE] = ACTIONS(1296),
    [anon_sym_PLUS] = ACTIONS(1296),
    [anon_sym_not] = ACTIONS(1298),
    [anon_sym_TILDE] = ACTIONS(1296),
    [anon_sym_lambda] = ACTIONS(1298),
    [anon_sym_yield] = ACTIONS(1298),
    [sym_ellipsis] = ACTIONS(1296),
    [sym_integer] = ACTIONS(1298),
    [sym_float] = ACTIONS(1296),
    [anon_sym_await] = ACTIONS(1298),
    [sym_true] = ACTIONS(1298),
    [sym_false] = ACTIONS(1298),
    [sym_none] = ACTIONS(1298),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1298),
    [anon_sym_container] = ACTIONS(1298),
    [anon_sym_envvars] = ACTIONS(1298),
    [anon_sym_include] = ACTIONS(1298),
    [anon_sym_pepfile] = ACTIONS(1298),
    [anon_sym_pepschema] = ACTIONS(1298),
    [anon_sym_scattergather] = ACTIONS(1298),
    [anon_sym_version] = ACTIONS(1298),
    [anon_sym_wildcard_constraints] = ACTIONS(1298),
    [anon_sym_workdir] = ACTIONS(1298),
    [anon_sym_onerror] = ACTIONS(1298),
    [anon_sym_onstart] = ACTIONS(1298),
    [anon_sym_onsuccess] = ACTIONS(1298),
    [anon_sym_localrules] = ACTIONS(1298),
    [anon_sym_ruleorder] = ACTIONS(1298),
    [anon_sym_rule] = ACTIONS(1298),
    [anon_sym_checkpoint] = ACTIONS(1298),
    [anon_sym_use] = ACTIONS(1298),
    [anon_sym_module] = ACTIONS(1298),
    [sym__dedent] = ACTIONS(1296),
    [sym_string_start] = ACTIONS(1296),
  },
  [470] = {
    [ts_builtin_sym_end] = ACTIONS(1522),
    [sym_identifier] = ACTIONS(1520),
    [anon_sym_import] = ACTIONS(1520),
    [anon_sym_from] = ACTIONS(1520),
    [anon_sym_LPAREN] = ACTIONS(1522),
    [anon_sym_STAR] = ACTIONS(1522),
    [anon_sym_print] = ACTIONS(1520),
    [anon_sym_assert] = ACTIONS(1520),
    [anon_sym_return] = ACTIONS(1520),
    [anon_sym_del] = ACTIONS(1520),
    [anon_sym_raise] = ACTIONS(1520),
    [anon_sym_pass] = ACTIONS(1520),
    [anon_sym_break] = ACTIONS(1520),
    [anon_sym_continue] = ACTIONS(1520),
    [anon_sym_if] = ACTIONS(1520),
    [anon_sym_match] = ACTIONS(1520),
    [anon_sym_async] = ACTIONS(1520),
    [anon_sym_for] = ACTIONS(1520),
    [anon_sym_while] = ACTIONS(1520),
    [anon_sym_try] = ACTIONS(1520),
    [anon_sym_with] = ACTIONS(1520),
    [anon_sym_def] = ACTIONS(1520),
    [anon_sym_global] = ACTIONS(1520),
    [anon_sym_nonlocal] = ACTIONS(1520),
    [anon_sym_exec] = ACTIONS(1520),
    [anon_sym_type] = ACTIONS(1520),
    [anon_sym_class] = ACTIONS(1520),
    [anon_sym_LBRACK] = ACTIONS(1522),
    [anon_sym_AT] = ACTIONS(1522),
    [anon_sym_DASH] = ACTIONS(1522),
    [anon_sym_LBRACE] = ACTIONS(1522),
    [anon_sym_PLUS] = ACTIONS(1522),
    [anon_sym_not] = ACTIONS(1520),
    [anon_sym_TILDE] = ACTIONS(1522),
    [anon_sym_lambda] = ACTIONS(1520),
    [anon_sym_yield] = ACTIONS(1520),
    [sym_ellipsis] = ACTIONS(1522),
    [sym_integer] = ACTIONS(1520),
    [sym_float] = ACTIONS(1522),
    [anon_sym_await] = ACTIONS(1520),
    [sym_true] = ACTIONS(1520),
    [sym_false] = ACTIONS(1520),
    [sym_none] = ACTIONS(1520),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1520),
    [anon_sym_container] = ACTIONS(1520),
    [anon_sym_envvars] = ACTIONS(1520),
    [anon_sym_include] = ACTIONS(1520),
    [anon_sym_pepfile] = ACTIONS(1520),
    [anon_sym_pepschema] = ACTIONS(1520),
    [anon_sym_scattergather] = ACTIONS(1520),
    [anon_sym_version] = ACTIONS(1520),
    [anon_sym_wildcard_constraints] = ACTIONS(1520),
    [anon_sym_workdir] = ACTIONS(1520),
    [anon_sym_onerror] = ACTIONS(1520),
    [anon_sym_onstart] = ACTIONS(1520),
    [anon_sym_onsuccess] = ACTIONS(1520),
    [anon_sym_localrules] = ACTIONS(1520),
    [anon_sym_ruleorder] = ACTIONS(1520),
    [anon_sym_rule] = ACTIONS(1520),
    [anon_sym_checkpoint] = ACTIONS(1520),
    [anon_sym_use] = ACTIONS(1520),
    [anon_sym_module] = ACTIONS(1520),
    [sym_string_start] = ACTIONS(1522),
  },
  [471] = {
    [sym_identifier] = ACTIONS(1306),
    [anon_sym_import] = ACTIONS(1306),
    [anon_sym_from] = ACTIONS(1306),
    [anon_sym_LPAREN] = ACTIONS(1304),
    [anon_sym_STAR] = ACTIONS(1304),
    [anon_sym_print] = ACTIONS(1306),
    [anon_sym_assert] = ACTIONS(1306),
    [anon_sym_return] = ACTIONS(1306),
    [anon_sym_del] = ACTIONS(1306),
    [anon_sym_raise] = ACTIONS(1306),
    [anon_sym_pass] = ACTIONS(1306),
    [anon_sym_break] = ACTIONS(1306),
    [anon_sym_continue] = ACTIONS(1306),
    [anon_sym_if] = ACTIONS(1306),
    [anon_sym_match] = ACTIONS(1306),
    [anon_sym_async] = ACTIONS(1306),
    [anon_sym_for] = ACTIONS(1306),
    [anon_sym_while] = ACTIONS(1306),
    [anon_sym_try] = ACTIONS(1306),
    [anon_sym_with] = ACTIONS(1306),
    [anon_sym_def] = ACTIONS(1306),
    [anon_sym_global] = ACTIONS(1306),
    [anon_sym_nonlocal] = ACTIONS(1306),
    [anon_sym_exec] = ACTIONS(1306),
    [anon_sym_type] = ACTIONS(1306),
    [anon_sym_class] = ACTIONS(1306),
    [anon_sym_LBRACK] = ACTIONS(1304),
    [anon_sym_AT] = ACTIONS(1304),
    [anon_sym_DASH] = ACTIONS(1304),
    [anon_sym_LBRACE] = ACTIONS(1304),
    [anon_sym_PLUS] = ACTIONS(1304),
    [anon_sym_not] = ACTIONS(1306),
    [anon_sym_TILDE] = ACTIONS(1304),
    [anon_sym_lambda] = ACTIONS(1306),
    [anon_sym_yield] = ACTIONS(1306),
    [sym_ellipsis] = ACTIONS(1304),
    [sym_integer] = ACTIONS(1306),
    [sym_float] = ACTIONS(1304),
    [anon_sym_await] = ACTIONS(1306),
    [sym_true] = ACTIONS(1306),
    [sym_false] = ACTIONS(1306),
    [sym_none] = ACTIONS(1306),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1306),
    [anon_sym_container] = ACTIONS(1306),
    [anon_sym_envvars] = ACTIONS(1306),
    [anon_sym_include] = ACTIONS(1306),
    [anon_sym_pepfile] = ACTIONS(1306),
    [anon_sym_pepschema] = ACTIONS(1306),
    [anon_sym_scattergather] = ACTIONS(1306),
    [anon_sym_version] = ACTIONS(1306),
    [anon_sym_wildcard_constraints] = ACTIONS(1306),
    [anon_sym_workdir] = ACTIONS(1306),
    [anon_sym_onerror] = ACTIONS(1306),
    [anon_sym_onstart] = ACTIONS(1306),
    [anon_sym_onsuccess] = ACTIONS(1306),
    [anon_sym_localrules] = ACTIONS(1306),
    [anon_sym_ruleorder] = ACTIONS(1306),
    [anon_sym_rule] = ACTIONS(1306),
    [anon_sym_checkpoint] = ACTIONS(1306),
    [anon_sym_use] = ACTIONS(1306),
    [anon_sym_module] = ACTIONS(1306),
    [sym__dedent] = ACTIONS(1304),
    [sym_string_start] = ACTIONS(1304),
  },
  [472] = {
    [ts_builtin_sym_end] = ACTIONS(1524),
    [sym_identifier] = ACTIONS(1526),
    [anon_sym_import] = ACTIONS(1526),
    [anon_sym_from] = ACTIONS(1526),
    [anon_sym_LPAREN] = ACTIONS(1524),
    [anon_sym_STAR] = ACTIONS(1524),
    [anon_sym_print] = ACTIONS(1526),
    [anon_sym_assert] = ACTIONS(1526),
    [anon_sym_return] = ACTIONS(1526),
    [anon_sym_del] = ACTIONS(1526),
    [anon_sym_raise] = ACTIONS(1526),
    [anon_sym_pass] = ACTIONS(1526),
    [anon_sym_break] = ACTIONS(1526),
    [anon_sym_continue] = ACTIONS(1526),
    [anon_sym_if] = ACTIONS(1526),
    [anon_sym_match] = ACTIONS(1526),
    [anon_sym_async] = ACTIONS(1526),
    [anon_sym_for] = ACTIONS(1526),
    [anon_sym_while] = ACTIONS(1526),
    [anon_sym_try] = ACTIONS(1526),
    [anon_sym_with] = ACTIONS(1526),
    [anon_sym_def] = ACTIONS(1526),
    [anon_sym_global] = ACTIONS(1526),
    [anon_sym_nonlocal] = ACTIONS(1526),
    [anon_sym_exec] = ACTIONS(1526),
    [anon_sym_type] = ACTIONS(1526),
    [anon_sym_class] = ACTIONS(1526),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_AT] = ACTIONS(1524),
    [anon_sym_DASH] = ACTIONS(1524),
    [anon_sym_LBRACE] = ACTIONS(1524),
    [anon_sym_PLUS] = ACTIONS(1524),
    [anon_sym_not] = ACTIONS(1526),
    [anon_sym_TILDE] = ACTIONS(1524),
    [anon_sym_lambda] = ACTIONS(1526),
    [anon_sym_yield] = ACTIONS(1526),
    [sym_ellipsis] = ACTIONS(1524),
    [sym_integer] = ACTIONS(1526),
    [sym_float] = ACTIONS(1524),
    [anon_sym_await] = ACTIONS(1526),
    [sym_true] = ACTIONS(1526),
    [sym_false] = ACTIONS(1526),
    [sym_none] = ACTIONS(1526),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1526),
    [anon_sym_container] = ACTIONS(1526),
    [anon_sym_envvars] = ACTIONS(1526),
    [anon_sym_include] = ACTIONS(1526),
    [anon_sym_pepfile] = ACTIONS(1526),
    [anon_sym_pepschema] = ACTIONS(1526),
    [anon_sym_scattergather] = ACTIONS(1526),
    [anon_sym_version] = ACTIONS(1526),
    [anon_sym_wildcard_constraints] = ACTIONS(1526),
    [anon_sym_workdir] = ACTIONS(1526),
    [anon_sym_onerror] = ACTIONS(1526),
    [anon_sym_onstart] = ACTIONS(1526),
    [anon_sym_onsuccess] = ACTIONS(1526),
    [anon_sym_localrules] = ACTIONS(1526),
    [anon_sym_ruleorder] = ACTIONS(1526),
    [anon_sym_rule] = ACTIONS(1526),
    [anon_sym_checkpoint] = ACTIONS(1526),
    [anon_sym_use] = ACTIONS(1526),
    [anon_sym_module] = ACTIONS(1526),
    [sym_string_start] = ACTIONS(1524),
  },
  [473] = {
    [sym_identifier] = ACTIONS(1314),
    [anon_sym_import] = ACTIONS(1314),
    [anon_sym_from] = ACTIONS(1314),
    [anon_sym_LPAREN] = ACTIONS(1312),
    [anon_sym_STAR] = ACTIONS(1312),
    [anon_sym_print] = ACTIONS(1314),
    [anon_sym_assert] = ACTIONS(1314),
    [anon_sym_return] = ACTIONS(1314),
    [anon_sym_del] = ACTIONS(1314),
    [anon_sym_raise] = ACTIONS(1314),
    [anon_sym_pass] = ACTIONS(1314),
    [anon_sym_break] = ACTIONS(1314),
    [anon_sym_continue] = ACTIONS(1314),
    [anon_sym_if] = ACTIONS(1314),
    [anon_sym_match] = ACTIONS(1314),
    [anon_sym_async] = ACTIONS(1314),
    [anon_sym_for] = ACTIONS(1314),
    [anon_sym_while] = ACTIONS(1314),
    [anon_sym_try] = ACTIONS(1314),
    [anon_sym_with] = ACTIONS(1314),
    [anon_sym_def] = ACTIONS(1314),
    [anon_sym_global] = ACTIONS(1314),
    [anon_sym_nonlocal] = ACTIONS(1314),
    [anon_sym_exec] = ACTIONS(1314),
    [anon_sym_type] = ACTIONS(1314),
    [anon_sym_class] = ACTIONS(1314),
    [anon_sym_LBRACK] = ACTIONS(1312),
    [anon_sym_AT] = ACTIONS(1312),
    [anon_sym_DASH] = ACTIONS(1312),
    [anon_sym_LBRACE] = ACTIONS(1312),
    [anon_sym_PLUS] = ACTIONS(1312),
    [anon_sym_not] = ACTIONS(1314),
    [anon_sym_TILDE] = ACTIONS(1312),
    [anon_sym_lambda] = ACTIONS(1314),
    [anon_sym_yield] = ACTIONS(1314),
    [sym_ellipsis] = ACTIONS(1312),
    [sym_integer] = ACTIONS(1314),
    [sym_float] = ACTIONS(1312),
    [anon_sym_await] = ACTIONS(1314),
    [sym_true] = ACTIONS(1314),
    [sym_false] = ACTIONS(1314),
    [sym_none] = ACTIONS(1314),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1314),
    [anon_sym_container] = ACTIONS(1314),
    [anon_sym_envvars] = ACTIONS(1314),
    [anon_sym_include] = ACTIONS(1314),
    [anon_sym_pepfile] = ACTIONS(1314),
    [anon_sym_pepschema] = ACTIONS(1314),
    [anon_sym_scattergather] = ACTIONS(1314),
    [anon_sym_version] = ACTIONS(1314),
    [anon_sym_wildcard_constraints] = ACTIONS(1314),
    [anon_sym_workdir] = ACTIONS(1314),
    [anon_sym_onerror] = ACTIONS(1314),
    [anon_sym_onstart] = ACTIONS(1314),
    [anon_sym_onsuccess] = ACTIONS(1314),
    [anon_sym_localrules] = ACTIONS(1314),
    [anon_sym_ruleorder] = ACTIONS(1314),
    [anon_sym_rule] = ACTIONS(1314),
    [anon_sym_checkpoint] = ACTIONS(1314),
    [anon_sym_use] = ACTIONS(1314),
    [anon_sym_module] = ACTIONS(1314),
    [sym__dedent] = ACTIONS(1312),
    [sym_string_start] = ACTIONS(1312),
  },
  [474] = {
    [sym_identifier] = ACTIONS(1318),
    [anon_sym_import] = ACTIONS(1318),
    [anon_sym_from] = ACTIONS(1318),
    [anon_sym_LPAREN] = ACTIONS(1316),
    [anon_sym_STAR] = ACTIONS(1316),
    [anon_sym_print] = ACTIONS(1318),
    [anon_sym_assert] = ACTIONS(1318),
    [anon_sym_return] = ACTIONS(1318),
    [anon_sym_del] = ACTIONS(1318),
    [anon_sym_raise] = ACTIONS(1318),
    [anon_sym_pass] = ACTIONS(1318),
    [anon_sym_break] = ACTIONS(1318),
    [anon_sym_continue] = ACTIONS(1318),
    [anon_sym_if] = ACTIONS(1318),
    [anon_sym_match] = ACTIONS(1318),
    [anon_sym_async] = ACTIONS(1318),
    [anon_sym_for] = ACTIONS(1318),
    [anon_sym_while] = ACTIONS(1318),
    [anon_sym_try] = ACTIONS(1318),
    [anon_sym_with] = ACTIONS(1318),
    [anon_sym_def] = ACTIONS(1318),
    [anon_sym_global] = ACTIONS(1318),
    [anon_sym_nonlocal] = ACTIONS(1318),
    [anon_sym_exec] = ACTIONS(1318),
    [anon_sym_type] = ACTIONS(1318),
    [anon_sym_class] = ACTIONS(1318),
    [anon_sym_LBRACK] = ACTIONS(1316),
    [anon_sym_AT] = ACTIONS(1316),
    [anon_sym_DASH] = ACTIONS(1316),
    [anon_sym_LBRACE] = ACTIONS(1316),
    [anon_sym_PLUS] = ACTIONS(1316),
    [anon_sym_not] = ACTIONS(1318),
    [anon_sym_TILDE] = ACTIONS(1316),
    [anon_sym_lambda] = ACTIONS(1318),
    [anon_sym_yield] = ACTIONS(1318),
    [sym_ellipsis] = ACTIONS(1316),
    [sym_integer] = ACTIONS(1318),
    [sym_float] = ACTIONS(1316),
    [anon_sym_await] = ACTIONS(1318),
    [sym_true] = ACTIONS(1318),
    [sym_false] = ACTIONS(1318),
    [sym_none] = ACTIONS(1318),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1318),
    [anon_sym_container] = ACTIONS(1318),
    [anon_sym_envvars] = ACTIONS(1318),
    [anon_sym_include] = ACTIONS(1318),
    [anon_sym_pepfile] = ACTIONS(1318),
    [anon_sym_pepschema] = ACTIONS(1318),
    [anon_sym_scattergather] = ACTIONS(1318),
    [anon_sym_version] = ACTIONS(1318),
    [anon_sym_wildcard_constraints] = ACTIONS(1318),
    [anon_sym_workdir] = ACTIONS(1318),
    [anon_sym_onerror] = ACTIONS(1318),
    [anon_sym_onstart] = ACTIONS(1318),
    [anon_sym_onsuccess] = ACTIONS(1318),
    [anon_sym_localrules] = ACTIONS(1318),
    [anon_sym_ruleorder] = ACTIONS(1318),
    [anon_sym_rule] = ACTIONS(1318),
    [anon_sym_checkpoint] = ACTIONS(1318),
    [anon_sym_use] = ACTIONS(1318),
    [anon_sym_module] = ACTIONS(1318),
    [sym__dedent] = ACTIONS(1316),
    [sym_string_start] = ACTIONS(1316),
  },
  [475] = {
    [sym_identifier] = ACTIONS(1526),
    [anon_sym_import] = ACTIONS(1526),
    [anon_sym_from] = ACTIONS(1526),
    [anon_sym_LPAREN] = ACTIONS(1524),
    [anon_sym_STAR] = ACTIONS(1524),
    [anon_sym_print] = ACTIONS(1526),
    [anon_sym_assert] = ACTIONS(1526),
    [anon_sym_return] = ACTIONS(1526),
    [anon_sym_del] = ACTIONS(1526),
    [anon_sym_raise] = ACTIONS(1526),
    [anon_sym_pass] = ACTIONS(1526),
    [anon_sym_break] = ACTIONS(1526),
    [anon_sym_continue] = ACTIONS(1526),
    [anon_sym_if] = ACTIONS(1526),
    [anon_sym_match] = ACTIONS(1526),
    [anon_sym_async] = ACTIONS(1526),
    [anon_sym_for] = ACTIONS(1526),
    [anon_sym_while] = ACTIONS(1526),
    [anon_sym_try] = ACTIONS(1526),
    [anon_sym_with] = ACTIONS(1526),
    [anon_sym_def] = ACTIONS(1526),
    [anon_sym_global] = ACTIONS(1526),
    [anon_sym_nonlocal] = ACTIONS(1526),
    [anon_sym_exec] = ACTIONS(1526),
    [anon_sym_type] = ACTIONS(1526),
    [anon_sym_class] = ACTIONS(1526),
    [anon_sym_LBRACK] = ACTIONS(1524),
    [anon_sym_AT] = ACTIONS(1524),
    [anon_sym_DASH] = ACTIONS(1524),
    [anon_sym_LBRACE] = ACTIONS(1524),
    [anon_sym_PLUS] = ACTIONS(1524),
    [anon_sym_not] = ACTIONS(1526),
    [anon_sym_TILDE] = ACTIONS(1524),
    [anon_sym_lambda] = ACTIONS(1526),
    [anon_sym_yield] = ACTIONS(1526),
    [sym_ellipsis] = ACTIONS(1524),
    [sym_integer] = ACTIONS(1526),
    [sym_float] = ACTIONS(1524),
    [anon_sym_await] = ACTIONS(1526),
    [sym_true] = ACTIONS(1526),
    [sym_false] = ACTIONS(1526),
    [sym_none] = ACTIONS(1526),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1526),
    [anon_sym_container] = ACTIONS(1526),
    [anon_sym_envvars] = ACTIONS(1526),
    [anon_sym_include] = ACTIONS(1526),
    [anon_sym_pepfile] = ACTIONS(1526),
    [anon_sym_pepschema] = ACTIONS(1526),
    [anon_sym_scattergather] = ACTIONS(1526),
    [anon_sym_version] = ACTIONS(1526),
    [anon_sym_wildcard_constraints] = ACTIONS(1526),
    [anon_sym_workdir] = ACTIONS(1526),
    [anon_sym_onerror] = ACTIONS(1526),
    [anon_sym_onstart] = ACTIONS(1526),
    [anon_sym_onsuccess] = ACTIONS(1526),
    [anon_sym_localrules] = ACTIONS(1526),
    [anon_sym_ruleorder] = ACTIONS(1526),
    [anon_sym_rule] = ACTIONS(1526),
    [anon_sym_checkpoint] = ACTIONS(1526),
    [anon_sym_use] = ACTIONS(1526),
    [anon_sym_module] = ACTIONS(1526),
    [sym__dedent] = ACTIONS(1524),
    [sym_string_start] = ACTIONS(1524),
  },
  [476] = {
    [ts_builtin_sym_end] = ACTIONS(814),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_import] = ACTIONS(816),
    [anon_sym_from] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(814),
    [anon_sym_STAR] = ACTIONS(814),
    [anon_sym_print] = ACTIONS(816),
    [anon_sym_assert] = ACTIONS(816),
    [anon_sym_return] = ACTIONS(816),
    [anon_sym_del] = ACTIONS(816),
    [anon_sym_raise] = ACTIONS(816),
    [anon_sym_pass] = ACTIONS(816),
    [anon_sym_break] = ACTIONS(816),
    [anon_sym_continue] = ACTIONS(816),
    [anon_sym_if] = ACTIONS(816),
    [anon_sym_match] = ACTIONS(816),
    [anon_sym_async] = ACTIONS(816),
    [anon_sym_for] = ACTIONS(816),
    [anon_sym_while] = ACTIONS(816),
    [anon_sym_try] = ACTIONS(816),
    [anon_sym_with] = ACTIONS(816),
    [anon_sym_def] = ACTIONS(816),
    [anon_sym_global] = ACTIONS(816),
    [anon_sym_nonlocal] = ACTIONS(816),
    [anon_sym_exec] = ACTIONS(816),
    [anon_sym_type] = ACTIONS(816),
    [anon_sym_class] = ACTIONS(816),
    [anon_sym_LBRACK] = ACTIONS(814),
    [anon_sym_AT] = ACTIONS(814),
    [anon_sym_DASH] = ACTIONS(814),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_PLUS] = ACTIONS(814),
    [anon_sym_not] = ACTIONS(816),
    [anon_sym_TILDE] = ACTIONS(814),
    [anon_sym_lambda] = ACTIONS(816),
    [anon_sym_yield] = ACTIONS(816),
    [sym_ellipsis] = ACTIONS(814),
    [sym_integer] = ACTIONS(816),
    [sym_float] = ACTIONS(814),
    [anon_sym_await] = ACTIONS(816),
    [sym_true] = ACTIONS(816),
    [sym_false] = ACTIONS(816),
    [sym_none] = ACTIONS(816),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(816),
    [anon_sym_container] = ACTIONS(816),
    [anon_sym_envvars] = ACTIONS(816),
    [anon_sym_include] = ACTIONS(816),
    [anon_sym_pepfile] = ACTIONS(816),
    [anon_sym_pepschema] = ACTIONS(816),
    [anon_sym_scattergather] = ACTIONS(816),
    [anon_sym_version] = ACTIONS(816),
    [anon_sym_wildcard_constraints] = ACTIONS(816),
    [anon_sym_workdir] = ACTIONS(816),
    [anon_sym_onerror] = ACTIONS(816),
    [anon_sym_onstart] = ACTIONS(816),
    [anon_sym_onsuccess] = ACTIONS(816),
    [anon_sym_localrules] = ACTIONS(816),
    [anon_sym_ruleorder] = ACTIONS(816),
    [anon_sym_rule] = ACTIONS(816),
    [anon_sym_checkpoint] = ACTIONS(816),
    [anon_sym_use] = ACTIONS(816),
    [anon_sym_module] = ACTIONS(816),
    [sym_string_start] = ACTIONS(814),
  },
  [477] = {
    [sym_identifier] = ACTIONS(1326),
    [anon_sym_import] = ACTIONS(1326),
    [anon_sym_from] = ACTIONS(1326),
    [anon_sym_LPAREN] = ACTIONS(1324),
    [anon_sym_STAR] = ACTIONS(1324),
    [anon_sym_print] = ACTIONS(1326),
    [anon_sym_assert] = ACTIONS(1326),
    [anon_sym_return] = ACTIONS(1326),
    [anon_sym_del] = ACTIONS(1326),
    [anon_sym_raise] = ACTIONS(1326),
    [anon_sym_pass] = ACTIONS(1326),
    [anon_sym_break] = ACTIONS(1326),
    [anon_sym_continue] = ACTIONS(1326),
    [anon_sym_if] = ACTIONS(1326),
    [anon_sym_match] = ACTIONS(1326),
    [anon_sym_async] = ACTIONS(1326),
    [anon_sym_for] = ACTIONS(1326),
    [anon_sym_while] = ACTIONS(1326),
    [anon_sym_try] = ACTIONS(1326),
    [anon_sym_with] = ACTIONS(1326),
    [anon_sym_def] = ACTIONS(1326),
    [anon_sym_global] = ACTIONS(1326),
    [anon_sym_nonlocal] = ACTIONS(1326),
    [anon_sym_exec] = ACTIONS(1326),
    [anon_sym_type] = ACTIONS(1326),
    [anon_sym_class] = ACTIONS(1326),
    [anon_sym_LBRACK] = ACTIONS(1324),
    [anon_sym_AT] = ACTIONS(1324),
    [anon_sym_DASH] = ACTIONS(1324),
    [anon_sym_LBRACE] = ACTIONS(1324),
    [anon_sym_PLUS] = ACTIONS(1324),
    [anon_sym_not] = ACTIONS(1326),
    [anon_sym_TILDE] = ACTIONS(1324),
    [anon_sym_lambda] = ACTIONS(1326),
    [anon_sym_yield] = ACTIONS(1326),
    [sym_ellipsis] = ACTIONS(1324),
    [sym_integer] = ACTIONS(1326),
    [sym_float] = ACTIONS(1324),
    [anon_sym_await] = ACTIONS(1326),
    [sym_true] = ACTIONS(1326),
    [sym_false] = ACTIONS(1326),
    [sym_none] = ACTIONS(1326),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1326),
    [anon_sym_container] = ACTIONS(1326),
    [anon_sym_envvars] = ACTIONS(1326),
    [anon_sym_include] = ACTIONS(1326),
    [anon_sym_pepfile] = ACTIONS(1326),
    [anon_sym_pepschema] = ACTIONS(1326),
    [anon_sym_scattergather] = ACTIONS(1326),
    [anon_sym_version] = ACTIONS(1326),
    [anon_sym_wildcard_constraints] = ACTIONS(1326),
    [anon_sym_workdir] = ACTIONS(1326),
    [anon_sym_onerror] = ACTIONS(1326),
    [anon_sym_onstart] = ACTIONS(1326),
    [anon_sym_onsuccess] = ACTIONS(1326),
    [anon_sym_localrules] = ACTIONS(1326),
    [anon_sym_ruleorder] = ACTIONS(1326),
    [anon_sym_rule] = ACTIONS(1326),
    [anon_sym_checkpoint] = ACTIONS(1326),
    [anon_sym_use] = ACTIONS(1326),
    [anon_sym_module] = ACTIONS(1326),
    [sym__dedent] = ACTIONS(1324),
    [sym_string_start] = ACTIONS(1324),
  },
  [478] = {
    [sym_identifier] = ACTIONS(1330),
    [anon_sym_import] = ACTIONS(1330),
    [anon_sym_from] = ACTIONS(1330),
    [anon_sym_LPAREN] = ACTIONS(1328),
    [anon_sym_STAR] = ACTIONS(1328),
    [anon_sym_print] = ACTIONS(1330),
    [anon_sym_assert] = ACTIONS(1330),
    [anon_sym_return] = ACTIONS(1330),
    [anon_sym_del] = ACTIONS(1330),
    [anon_sym_raise] = ACTIONS(1330),
    [anon_sym_pass] = ACTIONS(1330),
    [anon_sym_break] = ACTIONS(1330),
    [anon_sym_continue] = ACTIONS(1330),
    [anon_sym_if] = ACTIONS(1330),
    [anon_sym_match] = ACTIONS(1330),
    [anon_sym_async] = ACTIONS(1330),
    [anon_sym_for] = ACTIONS(1330),
    [anon_sym_while] = ACTIONS(1330),
    [anon_sym_try] = ACTIONS(1330),
    [anon_sym_with] = ACTIONS(1330),
    [anon_sym_def] = ACTIONS(1330),
    [anon_sym_global] = ACTIONS(1330),
    [anon_sym_nonlocal] = ACTIONS(1330),
    [anon_sym_exec] = ACTIONS(1330),
    [anon_sym_type] = ACTIONS(1330),
    [anon_sym_class] = ACTIONS(1330),
    [anon_sym_LBRACK] = ACTIONS(1328),
    [anon_sym_AT] = ACTIONS(1328),
    [anon_sym_DASH] = ACTIONS(1328),
    [anon_sym_LBRACE] = ACTIONS(1328),
    [anon_sym_PLUS] = ACTIONS(1328),
    [anon_sym_not] = ACTIONS(1330),
    [anon_sym_TILDE] = ACTIONS(1328),
    [anon_sym_lambda] = ACTIONS(1330),
    [anon_sym_yield] = ACTIONS(1330),
    [sym_ellipsis] = ACTIONS(1328),
    [sym_integer] = ACTIONS(1330),
    [sym_float] = ACTIONS(1328),
    [anon_sym_await] = ACTIONS(1330),
    [sym_true] = ACTIONS(1330),
    [sym_false] = ACTIONS(1330),
    [sym_none] = ACTIONS(1330),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1330),
    [anon_sym_container] = ACTIONS(1330),
    [anon_sym_envvars] = ACTIONS(1330),
    [anon_sym_include] = ACTIONS(1330),
    [anon_sym_pepfile] = ACTIONS(1330),
    [anon_sym_pepschema] = ACTIONS(1330),
    [anon_sym_scattergather] = ACTIONS(1330),
    [anon_sym_version] = ACTIONS(1330),
    [anon_sym_wildcard_constraints] = ACTIONS(1330),
    [anon_sym_workdir] = ACTIONS(1330),
    [anon_sym_onerror] = ACTIONS(1330),
    [anon_sym_onstart] = ACTIONS(1330),
    [anon_sym_onsuccess] = ACTIONS(1330),
    [anon_sym_localrules] = ACTIONS(1330),
    [anon_sym_ruleorder] = ACTIONS(1330),
    [anon_sym_rule] = ACTIONS(1330),
    [anon_sym_checkpoint] = ACTIONS(1330),
    [anon_sym_use] = ACTIONS(1330),
    [anon_sym_module] = ACTIONS(1330),
    [sym__dedent] = ACTIONS(1328),
    [sym_string_start] = ACTIONS(1328),
  },
  [479] = {
    [ts_builtin_sym_end] = ACTIONS(1164),
    [sym_identifier] = ACTIONS(1162),
    [anon_sym_import] = ACTIONS(1162),
    [anon_sym_from] = ACTIONS(1162),
    [anon_sym_LPAREN] = ACTIONS(1164),
    [anon_sym_STAR] = ACTIONS(1164),
    [anon_sym_print] = ACTIONS(1162),
    [anon_sym_assert] = ACTIONS(1162),
    [anon_sym_return] = ACTIONS(1162),
    [anon_sym_del] = ACTIONS(1162),
    [anon_sym_raise] = ACTIONS(1162),
    [anon_sym_pass] = ACTIONS(1162),
    [anon_sym_break] = ACTIONS(1162),
    [anon_sym_continue] = ACTIONS(1162),
    [anon_sym_if] = ACTIONS(1162),
    [anon_sym_match] = ACTIONS(1162),
    [anon_sym_async] = ACTIONS(1162),
    [anon_sym_for] = ACTIONS(1162),
    [anon_sym_while] = ACTIONS(1162),
    [anon_sym_try] = ACTIONS(1162),
    [anon_sym_with] = ACTIONS(1162),
    [anon_sym_def] = ACTIONS(1162),
    [anon_sym_global] = ACTIONS(1162),
    [anon_sym_nonlocal] = ACTIONS(1162),
    [anon_sym_exec] = ACTIONS(1162),
    [anon_sym_type] = ACTIONS(1162),
    [anon_sym_class] = ACTIONS(1162),
    [anon_sym_LBRACK] = ACTIONS(1164),
    [anon_sym_AT] = ACTIONS(1164),
    [anon_sym_DASH] = ACTIONS(1164),
    [anon_sym_LBRACE] = ACTIONS(1164),
    [anon_sym_PLUS] = ACTIONS(1164),
    [anon_sym_not] = ACTIONS(1162),
    [anon_sym_TILDE] = ACTIONS(1164),
    [anon_sym_lambda] = ACTIONS(1162),
    [anon_sym_yield] = ACTIONS(1162),
    [sym_ellipsis] = ACTIONS(1164),
    [sym_integer] = ACTIONS(1162),
    [sym_float] = ACTIONS(1164),
    [anon_sym_await] = ACTIONS(1162),
    [sym_true] = ACTIONS(1162),
    [sym_false] = ACTIONS(1162),
    [sym_none] = ACTIONS(1162),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1162),
    [anon_sym_container] = ACTIONS(1162),
    [anon_sym_envvars] = ACTIONS(1162),
    [anon_sym_include] = ACTIONS(1162),
    [anon_sym_pepfile] = ACTIONS(1162),
    [anon_sym_pepschema] = ACTIONS(1162),
    [anon_sym_scattergather] = ACTIONS(1162),
    [anon_sym_version] = ACTIONS(1162),
    [anon_sym_wildcard_constraints] = ACTIONS(1162),
    [anon_sym_workdir] = ACTIONS(1162),
    [anon_sym_onerror] = ACTIONS(1162),
    [anon_sym_onstart] = ACTIONS(1162),
    [anon_sym_onsuccess] = ACTIONS(1162),
    [anon_sym_localrules] = ACTIONS(1162),
    [anon_sym_ruleorder] = ACTIONS(1162),
    [anon_sym_rule] = ACTIONS(1162),
    [anon_sym_checkpoint] = ACTIONS(1162),
    [anon_sym_use] = ACTIONS(1162),
    [anon_sym_module] = ACTIONS(1162),
    [sym_string_start] = ACTIONS(1164),
  },
  [480] = {
    [sym_identifier] = ACTIONS(1476),
    [anon_sym_import] = ACTIONS(1476),
    [anon_sym_from] = ACTIONS(1476),
    [anon_sym_LPAREN] = ACTIONS(1474),
    [anon_sym_STAR] = ACTIONS(1474),
    [anon_sym_print] = ACTIONS(1476),
    [anon_sym_assert] = ACTIONS(1476),
    [anon_sym_return] = ACTIONS(1476),
    [anon_sym_del] = ACTIONS(1476),
    [anon_sym_raise] = ACTIONS(1476),
    [anon_sym_pass] = ACTIONS(1476),
    [anon_sym_break] = ACTIONS(1476),
    [anon_sym_continue] = ACTIONS(1476),
    [anon_sym_if] = ACTIONS(1476),
    [anon_sym_match] = ACTIONS(1476),
    [anon_sym_async] = ACTIONS(1476),
    [anon_sym_for] = ACTIONS(1476),
    [anon_sym_while] = ACTIONS(1476),
    [anon_sym_try] = ACTIONS(1476),
    [anon_sym_with] = ACTIONS(1476),
    [anon_sym_def] = ACTIONS(1476),
    [anon_sym_global] = ACTIONS(1476),
    [anon_sym_nonlocal] = ACTIONS(1476),
    [anon_sym_exec] = ACTIONS(1476),
    [anon_sym_type] = ACTIONS(1476),
    [anon_sym_class] = ACTIONS(1476),
    [anon_sym_LBRACK] = ACTIONS(1474),
    [anon_sym_AT] = ACTIONS(1474),
    [anon_sym_DASH] = ACTIONS(1474),
    [anon_sym_LBRACE] = ACTIONS(1474),
    [anon_sym_PLUS] = ACTIONS(1474),
    [anon_sym_not] = ACTIONS(1476),
    [anon_sym_TILDE] = ACTIONS(1474),
    [anon_sym_lambda] = ACTIONS(1476),
    [anon_sym_yield] = ACTIONS(1476),
    [sym_ellipsis] = ACTIONS(1474),
    [sym_integer] = ACTIONS(1476),
    [sym_float] = ACTIONS(1474),
    [anon_sym_await] = ACTIONS(1476),
    [sym_true] = ACTIONS(1476),
    [sym_false] = ACTIONS(1476),
    [sym_none] = ACTIONS(1476),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1476),
    [anon_sym_container] = ACTIONS(1476),
    [anon_sym_envvars] = ACTIONS(1476),
    [anon_sym_include] = ACTIONS(1476),
    [anon_sym_pepfile] = ACTIONS(1476),
    [anon_sym_pepschema] = ACTIONS(1476),
    [anon_sym_scattergather] = ACTIONS(1476),
    [anon_sym_version] = ACTIONS(1476),
    [anon_sym_wildcard_constraints] = ACTIONS(1476),
    [anon_sym_workdir] = ACTIONS(1476),
    [anon_sym_onerror] = ACTIONS(1476),
    [anon_sym_onstart] = ACTIONS(1476),
    [anon_sym_onsuccess] = ACTIONS(1476),
    [anon_sym_localrules] = ACTIONS(1476),
    [anon_sym_ruleorder] = ACTIONS(1476),
    [anon_sym_rule] = ACTIONS(1476),
    [anon_sym_checkpoint] = ACTIONS(1476),
    [anon_sym_use] = ACTIONS(1476),
    [anon_sym_module] = ACTIONS(1476),
    [sym__dedent] = ACTIONS(1474),
    [sym_string_start] = ACTIONS(1474),
  },
  [481] = {
    [sym_identifier] = ACTIONS(1484),
    [anon_sym_import] = ACTIONS(1484),
    [anon_sym_from] = ACTIONS(1484),
    [anon_sym_LPAREN] = ACTIONS(1482),
    [anon_sym_STAR] = ACTIONS(1482),
    [anon_sym_print] = ACTIONS(1484),
    [anon_sym_assert] = ACTIONS(1484),
    [anon_sym_return] = ACTIONS(1484),
    [anon_sym_del] = ACTIONS(1484),
    [anon_sym_raise] = ACTIONS(1484),
    [anon_sym_pass] = ACTIONS(1484),
    [anon_sym_break] = ACTIONS(1484),
    [anon_sym_continue] = ACTIONS(1484),
    [anon_sym_if] = ACTIONS(1484),
    [anon_sym_match] = ACTIONS(1484),
    [anon_sym_async] = ACTIONS(1484),
    [anon_sym_for] = ACTIONS(1484),
    [anon_sym_while] = ACTIONS(1484),
    [anon_sym_try] = ACTIONS(1484),
    [anon_sym_with] = ACTIONS(1484),
    [anon_sym_def] = ACTIONS(1484),
    [anon_sym_global] = ACTIONS(1484),
    [anon_sym_nonlocal] = ACTIONS(1484),
    [anon_sym_exec] = ACTIONS(1484),
    [anon_sym_type] = ACTIONS(1484),
    [anon_sym_class] = ACTIONS(1484),
    [anon_sym_LBRACK] = ACTIONS(1482),
    [anon_sym_AT] = ACTIONS(1482),
    [anon_sym_DASH] = ACTIONS(1482),
    [anon_sym_LBRACE] = ACTIONS(1482),
    [anon_sym_PLUS] = ACTIONS(1482),
    [anon_sym_not] = ACTIONS(1484),
    [anon_sym_TILDE] = ACTIONS(1482),
    [anon_sym_lambda] = ACTIONS(1484),
    [anon_sym_yield] = ACTIONS(1484),
    [sym_ellipsis] = ACTIONS(1482),
    [sym_integer] = ACTIONS(1484),
    [sym_float] = ACTIONS(1482),
    [anon_sym_await] = ACTIONS(1484),
    [sym_true] = ACTIONS(1484),
    [sym_false] = ACTIONS(1484),
    [sym_none] = ACTIONS(1484),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1484),
    [anon_sym_container] = ACTIONS(1484),
    [anon_sym_envvars] = ACTIONS(1484),
    [anon_sym_include] = ACTIONS(1484),
    [anon_sym_pepfile] = ACTIONS(1484),
    [anon_sym_pepschema] = ACTIONS(1484),
    [anon_sym_scattergather] = ACTIONS(1484),
    [anon_sym_version] = ACTIONS(1484),
    [anon_sym_wildcard_constraints] = ACTIONS(1484),
    [anon_sym_workdir] = ACTIONS(1484),
    [anon_sym_onerror] = ACTIONS(1484),
    [anon_sym_onstart] = ACTIONS(1484),
    [anon_sym_onsuccess] = ACTIONS(1484),
    [anon_sym_localrules] = ACTIONS(1484),
    [anon_sym_ruleorder] = ACTIONS(1484),
    [anon_sym_rule] = ACTIONS(1484),
    [anon_sym_checkpoint] = ACTIONS(1484),
    [anon_sym_use] = ACTIONS(1484),
    [anon_sym_module] = ACTIONS(1484),
    [sym__dedent] = ACTIONS(1482),
    [sym_string_start] = ACTIONS(1482),
  },
  [482] = {
    [ts_builtin_sym_end] = ACTIONS(1528),
    [sym_identifier] = ACTIONS(1530),
    [anon_sym_import] = ACTIONS(1530),
    [anon_sym_from] = ACTIONS(1530),
    [anon_sym_LPAREN] = ACTIONS(1528),
    [anon_sym_STAR] = ACTIONS(1528),
    [anon_sym_print] = ACTIONS(1530),
    [anon_sym_assert] = ACTIONS(1530),
    [anon_sym_return] = ACTIONS(1530),
    [anon_sym_del] = ACTIONS(1530),
    [anon_sym_raise] = ACTIONS(1530),
    [anon_sym_pass] = ACTIONS(1530),
    [anon_sym_break] = ACTIONS(1530),
    [anon_sym_continue] = ACTIONS(1530),
    [anon_sym_if] = ACTIONS(1530),
    [anon_sym_match] = ACTIONS(1530),
    [anon_sym_async] = ACTIONS(1530),
    [anon_sym_for] = ACTIONS(1530),
    [anon_sym_while] = ACTIONS(1530),
    [anon_sym_try] = ACTIONS(1530),
    [anon_sym_with] = ACTIONS(1530),
    [anon_sym_def] = ACTIONS(1530),
    [anon_sym_global] = ACTIONS(1530),
    [anon_sym_nonlocal] = ACTIONS(1530),
    [anon_sym_exec] = ACTIONS(1530),
    [anon_sym_type] = ACTIONS(1530),
    [anon_sym_class] = ACTIONS(1530),
    [anon_sym_LBRACK] = ACTIONS(1528),
    [anon_sym_AT] = ACTIONS(1528),
    [anon_sym_DASH] = ACTIONS(1528),
    [anon_sym_LBRACE] = ACTIONS(1528),
    [anon_sym_PLUS] = ACTIONS(1528),
    [anon_sym_not] = ACTIONS(1530),
    [anon_sym_TILDE] = ACTIONS(1528),
    [anon_sym_lambda] = ACTIONS(1530),
    [anon_sym_yield] = ACTIONS(1530),
    [sym_ellipsis] = ACTIONS(1528),
    [sym_integer] = ACTIONS(1530),
    [sym_float] = ACTIONS(1528),
    [anon_sym_await] = ACTIONS(1530),
    [sym_true] = ACTIONS(1530),
    [sym_false] = ACTIONS(1530),
    [sym_none] = ACTIONS(1530),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1530),
    [anon_sym_container] = ACTIONS(1530),
    [anon_sym_envvars] = ACTIONS(1530),
    [anon_sym_include] = ACTIONS(1530),
    [anon_sym_pepfile] = ACTIONS(1530),
    [anon_sym_pepschema] = ACTIONS(1530),
    [anon_sym_scattergather] = ACTIONS(1530),
    [anon_sym_version] = ACTIONS(1530),
    [anon_sym_wildcard_constraints] = ACTIONS(1530),
    [anon_sym_workdir] = ACTIONS(1530),
    [anon_sym_onerror] = ACTIONS(1530),
    [anon_sym_onstart] = ACTIONS(1530),
    [anon_sym_onsuccess] = ACTIONS(1530),
    [anon_sym_localrules] = ACTIONS(1530),
    [anon_sym_ruleorder] = ACTIONS(1530),
    [anon_sym_rule] = ACTIONS(1530),
    [anon_sym_checkpoint] = ACTIONS(1530),
    [anon_sym_use] = ACTIONS(1530),
    [anon_sym_module] = ACTIONS(1530),
    [sym_string_start] = ACTIONS(1528),
  },
  [483] = {
    [sym_identifier] = ACTIONS(806),
    [anon_sym_import] = ACTIONS(806),
    [anon_sym_from] = ACTIONS(806),
    [anon_sym_LPAREN] = ACTIONS(804),
    [anon_sym_STAR] = ACTIONS(804),
    [anon_sym_print] = ACTIONS(806),
    [anon_sym_assert] = ACTIONS(806),
    [anon_sym_return] = ACTIONS(806),
    [anon_sym_del] = ACTIONS(806),
    [anon_sym_raise] = ACTIONS(806),
    [anon_sym_pass] = ACTIONS(806),
    [anon_sym_break] = ACTIONS(806),
    [anon_sym_continue] = ACTIONS(806),
    [anon_sym_if] = ACTIONS(806),
    [anon_sym_match] = ACTIONS(806),
    [anon_sym_async] = ACTIONS(806),
    [anon_sym_for] = ACTIONS(806),
    [anon_sym_while] = ACTIONS(806),
    [anon_sym_try] = ACTIONS(806),
    [anon_sym_with] = ACTIONS(806),
    [anon_sym_def] = ACTIONS(806),
    [anon_sym_global] = ACTIONS(806),
    [anon_sym_nonlocal] = ACTIONS(806),
    [anon_sym_exec] = ACTIONS(806),
    [anon_sym_type] = ACTIONS(806),
    [anon_sym_class] = ACTIONS(806),
    [anon_sym_LBRACK] = ACTIONS(804),
    [anon_sym_AT] = ACTIONS(804),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_LBRACE] = ACTIONS(804),
    [anon_sym_PLUS] = ACTIONS(804),
    [anon_sym_not] = ACTIONS(806),
    [anon_sym_TILDE] = ACTIONS(804),
    [anon_sym_lambda] = ACTIONS(806),
    [anon_sym_yield] = ACTIONS(806),
    [sym_ellipsis] = ACTIONS(804),
    [sym_integer] = ACTIONS(806),
    [sym_float] = ACTIONS(804),
    [anon_sym_await] = ACTIONS(806),
    [sym_true] = ACTIONS(806),
    [sym_false] = ACTIONS(806),
    [sym_none] = ACTIONS(806),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(806),
    [anon_sym_container] = ACTIONS(806),
    [anon_sym_envvars] = ACTIONS(806),
    [anon_sym_include] = ACTIONS(806),
    [anon_sym_pepfile] = ACTIONS(806),
    [anon_sym_pepschema] = ACTIONS(806),
    [anon_sym_scattergather] = ACTIONS(806),
    [anon_sym_version] = ACTIONS(806),
    [anon_sym_wildcard_constraints] = ACTIONS(806),
    [anon_sym_workdir] = ACTIONS(806),
    [anon_sym_onerror] = ACTIONS(806),
    [anon_sym_onstart] = ACTIONS(806),
    [anon_sym_onsuccess] = ACTIONS(806),
    [anon_sym_localrules] = ACTIONS(806),
    [anon_sym_ruleorder] = ACTIONS(806),
    [anon_sym_rule] = ACTIONS(806),
    [anon_sym_checkpoint] = ACTIONS(806),
    [anon_sym_use] = ACTIONS(806),
    [anon_sym_module] = ACTIONS(806),
    [sym__dedent] = ACTIONS(804),
    [sym_string_start] = ACTIONS(804),
  },
  [484] = {
    [sym_identifier] = ACTIONS(816),
    [anon_sym_import] = ACTIONS(816),
    [anon_sym_from] = ACTIONS(816),
    [anon_sym_LPAREN] = ACTIONS(814),
    [anon_sym_STAR] = ACTIONS(814),
    [anon_sym_print] = ACTIONS(816),
    [anon_sym_assert] = ACTIONS(816),
    [anon_sym_return] = ACTIONS(816),
    [anon_sym_del] = ACTIONS(816),
    [anon_sym_raise] = ACTIONS(816),
    [anon_sym_pass] = ACTIONS(816),
    [anon_sym_break] = ACTIONS(816),
    [anon_sym_continue] = ACTIONS(816),
    [anon_sym_if] = ACTIONS(816),
    [anon_sym_match] = ACTIONS(816),
    [anon_sym_async] = ACTIONS(816),
    [anon_sym_for] = ACTIONS(816),
    [anon_sym_while] = ACTIONS(816),
    [anon_sym_try] = ACTIONS(816),
    [anon_sym_with] = ACTIONS(816),
    [anon_sym_def] = ACTIONS(816),
    [anon_sym_global] = ACTIONS(816),
    [anon_sym_nonlocal] = ACTIONS(816),
    [anon_sym_exec] = ACTIONS(816),
    [anon_sym_type] = ACTIONS(816),
    [anon_sym_class] = ACTIONS(816),
    [anon_sym_LBRACK] = ACTIONS(814),
    [anon_sym_AT] = ACTIONS(814),
    [anon_sym_DASH] = ACTIONS(814),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_PLUS] = ACTIONS(814),
    [anon_sym_not] = ACTIONS(816),
    [anon_sym_TILDE] = ACTIONS(814),
    [anon_sym_lambda] = ACTIONS(816),
    [anon_sym_yield] = ACTIONS(816),
    [sym_ellipsis] = ACTIONS(814),
    [sym_integer] = ACTIONS(816),
    [sym_float] = ACTIONS(814),
    [anon_sym_await] = ACTIONS(816),
    [sym_true] = ACTIONS(816),
    [sym_false] = ACTIONS(816),
    [sym_none] = ACTIONS(816),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(816),
    [anon_sym_container] = ACTIONS(816),
    [anon_sym_envvars] = ACTIONS(816),
    [anon_sym_include] = ACTIONS(816),
    [anon_sym_pepfile] = ACTIONS(816),
    [anon_sym_pepschema] = ACTIONS(816),
    [anon_sym_scattergather] = ACTIONS(816),
    [anon_sym_version] = ACTIONS(816),
    [anon_sym_wildcard_constraints] = ACTIONS(816),
    [anon_sym_workdir] = ACTIONS(816),
    [anon_sym_onerror] = ACTIONS(816),
    [anon_sym_onstart] = ACTIONS(816),
    [anon_sym_onsuccess] = ACTIONS(816),
    [anon_sym_localrules] = ACTIONS(816),
    [anon_sym_ruleorder] = ACTIONS(816),
    [anon_sym_rule] = ACTIONS(816),
    [anon_sym_checkpoint] = ACTIONS(816),
    [anon_sym_use] = ACTIONS(816),
    [anon_sym_module] = ACTIONS(816),
    [sym__dedent] = ACTIONS(814),
    [sym_string_start] = ACTIONS(814),
  },
  [485] = {
    [sym_identifier] = ACTIONS(1514),
    [anon_sym_import] = ACTIONS(1514),
    [anon_sym_from] = ACTIONS(1514),
    [anon_sym_LPAREN] = ACTIONS(1512),
    [anon_sym_STAR] = ACTIONS(1512),
    [anon_sym_print] = ACTIONS(1514),
    [anon_sym_assert] = ACTIONS(1514),
    [anon_sym_return] = ACTIONS(1514),
    [anon_sym_del] = ACTIONS(1514),
    [anon_sym_raise] = ACTIONS(1514),
    [anon_sym_pass] = ACTIONS(1514),
    [anon_sym_break] = ACTIONS(1514),
    [anon_sym_continue] = ACTIONS(1514),
    [anon_sym_if] = ACTIONS(1514),
    [anon_sym_match] = ACTIONS(1514),
    [anon_sym_async] = ACTIONS(1514),
    [anon_sym_for] = ACTIONS(1514),
    [anon_sym_while] = ACTIONS(1514),
    [anon_sym_try] = ACTIONS(1514),
    [anon_sym_with] = ACTIONS(1514),
    [anon_sym_def] = ACTIONS(1514),
    [anon_sym_global] = ACTIONS(1514),
    [anon_sym_nonlocal] = ACTIONS(1514),
    [anon_sym_exec] = ACTIONS(1514),
    [anon_sym_type] = ACTIONS(1514),
    [anon_sym_class] = ACTIONS(1514),
    [anon_sym_LBRACK] = ACTIONS(1512),
    [anon_sym_AT] = ACTIONS(1512),
    [anon_sym_DASH] = ACTIONS(1512),
    [anon_sym_LBRACE] = ACTIONS(1512),
    [anon_sym_PLUS] = ACTIONS(1512),
    [anon_sym_not] = ACTIONS(1514),
    [anon_sym_TILDE] = ACTIONS(1512),
    [anon_sym_lambda] = ACTIONS(1514),
    [anon_sym_yield] = ACTIONS(1514),
    [sym_ellipsis] = ACTIONS(1512),
    [sym_integer] = ACTIONS(1514),
    [sym_float] = ACTIONS(1512),
    [anon_sym_await] = ACTIONS(1514),
    [sym_true] = ACTIONS(1514),
    [sym_false] = ACTIONS(1514),
    [sym_none] = ACTIONS(1514),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1514),
    [anon_sym_container] = ACTIONS(1514),
    [anon_sym_envvars] = ACTIONS(1514),
    [anon_sym_include] = ACTIONS(1514),
    [anon_sym_pepfile] = ACTIONS(1514),
    [anon_sym_pepschema] = ACTIONS(1514),
    [anon_sym_scattergather] = ACTIONS(1514),
    [anon_sym_version] = ACTIONS(1514),
    [anon_sym_wildcard_constraints] = ACTIONS(1514),
    [anon_sym_workdir] = ACTIONS(1514),
    [anon_sym_onerror] = ACTIONS(1514),
    [anon_sym_onstart] = ACTIONS(1514),
    [anon_sym_onsuccess] = ACTIONS(1514),
    [anon_sym_localrules] = ACTIONS(1514),
    [anon_sym_ruleorder] = ACTIONS(1514),
    [anon_sym_rule] = ACTIONS(1514),
    [anon_sym_checkpoint] = ACTIONS(1514),
    [anon_sym_use] = ACTIONS(1514),
    [anon_sym_module] = ACTIONS(1514),
    [sym__dedent] = ACTIONS(1512),
    [sym_string_start] = ACTIONS(1512),
  },
  [486] = {
    [sym_identifier] = ACTIONS(1530),
    [anon_sym_import] = ACTIONS(1530),
    [anon_sym_from] = ACTIONS(1530),
    [anon_sym_LPAREN] = ACTIONS(1528),
    [anon_sym_STAR] = ACTIONS(1528),
    [anon_sym_print] = ACTIONS(1530),
    [anon_sym_assert] = ACTIONS(1530),
    [anon_sym_return] = ACTIONS(1530),
    [anon_sym_del] = ACTIONS(1530),
    [anon_sym_raise] = ACTIONS(1530),
    [anon_sym_pass] = ACTIONS(1530),
    [anon_sym_break] = ACTIONS(1530),
    [anon_sym_continue] = ACTIONS(1530),
    [anon_sym_if] = ACTIONS(1530),
    [anon_sym_match] = ACTIONS(1530),
    [anon_sym_async] = ACTIONS(1530),
    [anon_sym_for] = ACTIONS(1530),
    [anon_sym_while] = ACTIONS(1530),
    [anon_sym_try] = ACTIONS(1530),
    [anon_sym_with] = ACTIONS(1530),
    [anon_sym_def] = ACTIONS(1530),
    [anon_sym_global] = ACTIONS(1530),
    [anon_sym_nonlocal] = ACTIONS(1530),
    [anon_sym_exec] = ACTIONS(1530),
    [anon_sym_type] = ACTIONS(1530),
    [anon_sym_class] = ACTIONS(1530),
    [anon_sym_LBRACK] = ACTIONS(1528),
    [anon_sym_AT] = ACTIONS(1528),
    [anon_sym_DASH] = ACTIONS(1528),
    [anon_sym_LBRACE] = ACTIONS(1528),
    [anon_sym_PLUS] = ACTIONS(1528),
    [anon_sym_not] = ACTIONS(1530),
    [anon_sym_TILDE] = ACTIONS(1528),
    [anon_sym_lambda] = ACTIONS(1530),
    [anon_sym_yield] = ACTIONS(1530),
    [sym_ellipsis] = ACTIONS(1528),
    [sym_integer] = ACTIONS(1530),
    [sym_float] = ACTIONS(1528),
    [anon_sym_await] = ACTIONS(1530),
    [sym_true] = ACTIONS(1530),
    [sym_false] = ACTIONS(1530),
    [sym_none] = ACTIONS(1530),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1530),
    [anon_sym_container] = ACTIONS(1530),
    [anon_sym_envvars] = ACTIONS(1530),
    [anon_sym_include] = ACTIONS(1530),
    [anon_sym_pepfile] = ACTIONS(1530),
    [anon_sym_pepschema] = ACTIONS(1530),
    [anon_sym_scattergather] = ACTIONS(1530),
    [anon_sym_version] = ACTIONS(1530),
    [anon_sym_wildcard_constraints] = ACTIONS(1530),
    [anon_sym_workdir] = ACTIONS(1530),
    [anon_sym_onerror] = ACTIONS(1530),
    [anon_sym_onstart] = ACTIONS(1530),
    [anon_sym_onsuccess] = ACTIONS(1530),
    [anon_sym_localrules] = ACTIONS(1530),
    [anon_sym_ruleorder] = ACTIONS(1530),
    [anon_sym_rule] = ACTIONS(1530),
    [anon_sym_checkpoint] = ACTIONS(1530),
    [anon_sym_use] = ACTIONS(1530),
    [anon_sym_module] = ACTIONS(1530),
    [sym__dedent] = ACTIONS(1528),
    [sym_string_start] = ACTIONS(1528),
  },
  [487] = {
    [sym_identifier] = ACTIONS(1532),
    [anon_sym_import] = ACTIONS(1532),
    [anon_sym_from] = ACTIONS(1532),
    [anon_sym_LPAREN] = ACTIONS(1534),
    [anon_sym_STAR] = ACTIONS(1534),
    [anon_sym_print] = ACTIONS(1532),
    [anon_sym_assert] = ACTIONS(1532),
    [anon_sym_return] = ACTIONS(1532),
    [anon_sym_del] = ACTIONS(1532),
    [anon_sym_raise] = ACTIONS(1532),
    [anon_sym_pass] = ACTIONS(1532),
    [anon_sym_break] = ACTIONS(1532),
    [anon_sym_continue] = ACTIONS(1532),
    [anon_sym_if] = ACTIONS(1532),
    [anon_sym_match] = ACTIONS(1532),
    [anon_sym_async] = ACTIONS(1532),
    [anon_sym_for] = ACTIONS(1532),
    [anon_sym_while] = ACTIONS(1532),
    [anon_sym_try] = ACTIONS(1532),
    [anon_sym_with] = ACTIONS(1532),
    [anon_sym_def] = ACTIONS(1532),
    [anon_sym_global] = ACTIONS(1532),
    [anon_sym_nonlocal] = ACTIONS(1532),
    [anon_sym_exec] = ACTIONS(1532),
    [anon_sym_type] = ACTIONS(1532),
    [anon_sym_class] = ACTIONS(1532),
    [anon_sym_LBRACK] = ACTIONS(1534),
    [anon_sym_AT] = ACTIONS(1534),
    [anon_sym_DASH] = ACTIONS(1534),
    [anon_sym_LBRACE] = ACTIONS(1534),
    [anon_sym_PLUS] = ACTIONS(1534),
    [anon_sym_not] = ACTIONS(1532),
    [anon_sym_TILDE] = ACTIONS(1534),
    [anon_sym_lambda] = ACTIONS(1532),
    [anon_sym_yield] = ACTIONS(1532),
    [sym_ellipsis] = ACTIONS(1534),
    [sym_integer] = ACTIONS(1532),
    [sym_float] = ACTIONS(1534),
    [anon_sym_await] = ACTIONS(1532),
    [sym_true] = ACTIONS(1532),
    [sym_false] = ACTIONS(1532),
    [sym_none] = ACTIONS(1532),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1532),
    [anon_sym_container] = ACTIONS(1532),
    [anon_sym_envvars] = ACTIONS(1532),
    [anon_sym_include] = ACTIONS(1532),
    [anon_sym_pepfile] = ACTIONS(1532),
    [anon_sym_pepschema] = ACTIONS(1532),
    [anon_sym_scattergather] = ACTIONS(1532),
    [anon_sym_version] = ACTIONS(1532),
    [anon_sym_wildcard_constraints] = ACTIONS(1532),
    [anon_sym_workdir] = ACTIONS(1532),
    [anon_sym_onerror] = ACTIONS(1532),
    [anon_sym_onstart] = ACTIONS(1532),
    [anon_sym_onsuccess] = ACTIONS(1532),
    [anon_sym_localrules] = ACTIONS(1532),
    [anon_sym_ruleorder] = ACTIONS(1532),
    [anon_sym_rule] = ACTIONS(1532),
    [anon_sym_checkpoint] = ACTIONS(1532),
    [anon_sym_use] = ACTIONS(1532),
    [anon_sym_module] = ACTIONS(1532),
    [sym__dedent] = ACTIONS(1534),
    [sym_string_start] = ACTIONS(1534),
  },
  [488] = {
    [ts_builtin_sym_end] = ACTIONS(1414),
    [sym_identifier] = ACTIONS(1412),
    [anon_sym_import] = ACTIONS(1412),
    [anon_sym_from] = ACTIONS(1412),
    [anon_sym_LPAREN] = ACTIONS(1414),
    [anon_sym_STAR] = ACTIONS(1414),
    [anon_sym_print] = ACTIONS(1412),
    [anon_sym_assert] = ACTIONS(1412),
    [anon_sym_return] = ACTIONS(1412),
    [anon_sym_del] = ACTIONS(1412),
    [anon_sym_raise] = ACTIONS(1412),
    [anon_sym_pass] = ACTIONS(1412),
    [anon_sym_break] = ACTIONS(1412),
    [anon_sym_continue] = ACTIONS(1412),
    [anon_sym_if] = ACTIONS(1412),
    [anon_sym_match] = ACTIONS(1412),
    [anon_sym_async] = ACTIONS(1412),
    [anon_sym_for] = ACTIONS(1412),
    [anon_sym_while] = ACTIONS(1412),
    [anon_sym_try] = ACTIONS(1412),
    [anon_sym_with] = ACTIONS(1412),
    [anon_sym_def] = ACTIONS(1412),
    [anon_sym_global] = ACTIONS(1412),
    [anon_sym_nonlocal] = ACTIONS(1412),
    [anon_sym_exec] = ACTIONS(1412),
    [anon_sym_type] = ACTIONS(1412),
    [anon_sym_class] = ACTIONS(1412),
    [anon_sym_LBRACK] = ACTIONS(1414),
    [anon_sym_AT] = ACTIONS(1414),
    [anon_sym_DASH] = ACTIONS(1414),
    [anon_sym_LBRACE] = ACTIONS(1414),
    [anon_sym_PLUS] = ACTIONS(1414),
    [anon_sym_not] = ACTIONS(1412),
    [anon_sym_TILDE] = ACTIONS(1414),
    [anon_sym_lambda] = ACTIONS(1412),
    [anon_sym_yield] = ACTIONS(1412),
    [sym_ellipsis] = ACTIONS(1414),
    [sym_integer] = ACTIONS(1412),
    [sym_float] = ACTIONS(1414),
    [anon_sym_await] = ACTIONS(1412),
    [sym_true] = ACTIONS(1412),
    [sym_false] = ACTIONS(1412),
    [sym_none] = ACTIONS(1412),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1412),
    [anon_sym_container] = ACTIONS(1412),
    [anon_sym_envvars] = ACTIONS(1412),
    [anon_sym_include] = ACTIONS(1412),
    [anon_sym_pepfile] = ACTIONS(1412),
    [anon_sym_pepschema] = ACTIONS(1412),
    [anon_sym_scattergather] = ACTIONS(1412),
    [anon_sym_version] = ACTIONS(1412),
    [anon_sym_wildcard_constraints] = ACTIONS(1412),
    [anon_sym_workdir] = ACTIONS(1412),
    [anon_sym_onerror] = ACTIONS(1412),
    [anon_sym_onstart] = ACTIONS(1412),
    [anon_sym_onsuccess] = ACTIONS(1412),
    [anon_sym_localrules] = ACTIONS(1412),
    [anon_sym_ruleorder] = ACTIONS(1412),
    [anon_sym_rule] = ACTIONS(1412),
    [anon_sym_checkpoint] = ACTIONS(1412),
    [anon_sym_use] = ACTIONS(1412),
    [anon_sym_module] = ACTIONS(1412),
    [sym_string_start] = ACTIONS(1414),
  },
  [489] = {
    [sym_identifier] = ACTIONS(1536),
    [anon_sym_import] = ACTIONS(1536),
    [anon_sym_from] = ACTIONS(1536),
    [anon_sym_LPAREN] = ACTIONS(1538),
    [anon_sym_STAR] = ACTIONS(1538),
    [anon_sym_print] = ACTIONS(1536),
    [anon_sym_assert] = ACTIONS(1536),
    [anon_sym_return] = ACTIONS(1536),
    [anon_sym_del] = ACTIONS(1536),
    [anon_sym_raise] = ACTIONS(1536),
    [anon_sym_pass] = ACTIONS(1536),
    [anon_sym_break] = ACTIONS(1536),
    [anon_sym_continue] = ACTIONS(1536),
    [anon_sym_if] = ACTIONS(1536),
    [anon_sym_match] = ACTIONS(1536),
    [anon_sym_async] = ACTIONS(1536),
    [anon_sym_for] = ACTIONS(1536),
    [anon_sym_while] = ACTIONS(1536),
    [anon_sym_try] = ACTIONS(1536),
    [anon_sym_with] = ACTIONS(1536),
    [anon_sym_def] = ACTIONS(1536),
    [anon_sym_global] = ACTIONS(1536),
    [anon_sym_nonlocal] = ACTIONS(1536),
    [anon_sym_exec] = ACTIONS(1536),
    [anon_sym_type] = ACTIONS(1536),
    [anon_sym_class] = ACTIONS(1536),
    [anon_sym_LBRACK] = ACTIONS(1538),
    [anon_sym_AT] = ACTIONS(1538),
    [anon_sym_DASH] = ACTIONS(1538),
    [anon_sym_LBRACE] = ACTIONS(1538),
    [anon_sym_PLUS] = ACTIONS(1538),
    [anon_sym_not] = ACTIONS(1536),
    [anon_sym_TILDE] = ACTIONS(1538),
    [anon_sym_lambda] = ACTIONS(1536),
    [anon_sym_yield] = ACTIONS(1536),
    [sym_ellipsis] = ACTIONS(1538),
    [sym_integer] = ACTIONS(1536),
    [sym_float] = ACTIONS(1538),
    [anon_sym_await] = ACTIONS(1536),
    [sym_true] = ACTIONS(1536),
    [sym_false] = ACTIONS(1536),
    [sym_none] = ACTIONS(1536),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1536),
    [anon_sym_container] = ACTIONS(1536),
    [anon_sym_envvars] = ACTIONS(1536),
    [anon_sym_include] = ACTIONS(1536),
    [anon_sym_pepfile] = ACTIONS(1536),
    [anon_sym_pepschema] = ACTIONS(1536),
    [anon_sym_scattergather] = ACTIONS(1536),
    [anon_sym_version] = ACTIONS(1536),
    [anon_sym_wildcard_constraints] = ACTIONS(1536),
    [anon_sym_workdir] = ACTIONS(1536),
    [anon_sym_onerror] = ACTIONS(1536),
    [anon_sym_onstart] = ACTIONS(1536),
    [anon_sym_onsuccess] = ACTIONS(1536),
    [anon_sym_localrules] = ACTIONS(1536),
    [anon_sym_ruleorder] = ACTIONS(1536),
    [anon_sym_rule] = ACTIONS(1536),
    [anon_sym_checkpoint] = ACTIONS(1536),
    [anon_sym_use] = ACTIONS(1536),
    [anon_sym_module] = ACTIONS(1536),
    [sym__dedent] = ACTIONS(1538),
    [sym_string_start] = ACTIONS(1538),
  },
  [490] = {
    [sym_identifier] = ACTIONS(1402),
    [anon_sym_import] = ACTIONS(1402),
    [anon_sym_from] = ACTIONS(1402),
    [anon_sym_LPAREN] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(1400),
    [anon_sym_print] = ACTIONS(1402),
    [anon_sym_assert] = ACTIONS(1402),
    [anon_sym_return] = ACTIONS(1402),
    [anon_sym_del] = ACTIONS(1402),
    [anon_sym_raise] = ACTIONS(1402),
    [anon_sym_pass] = ACTIONS(1402),
    [anon_sym_break] = ACTIONS(1402),
    [anon_sym_continue] = ACTIONS(1402),
    [anon_sym_if] = ACTIONS(1402),
    [anon_sym_match] = ACTIONS(1402),
    [anon_sym_async] = ACTIONS(1402),
    [anon_sym_for] = ACTIONS(1402),
    [anon_sym_while] = ACTIONS(1402),
    [anon_sym_try] = ACTIONS(1402),
    [anon_sym_with] = ACTIONS(1402),
    [anon_sym_def] = ACTIONS(1402),
    [anon_sym_global] = ACTIONS(1402),
    [anon_sym_nonlocal] = ACTIONS(1402),
    [anon_sym_exec] = ACTIONS(1402),
    [anon_sym_type] = ACTIONS(1402),
    [anon_sym_class] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1400),
    [anon_sym_AT] = ACTIONS(1400),
    [anon_sym_DASH] = ACTIONS(1400),
    [anon_sym_LBRACE] = ACTIONS(1400),
    [anon_sym_PLUS] = ACTIONS(1400),
    [anon_sym_not] = ACTIONS(1402),
    [anon_sym_TILDE] = ACTIONS(1400),
    [anon_sym_lambda] = ACTIONS(1402),
    [anon_sym_yield] = ACTIONS(1402),
    [sym_ellipsis] = ACTIONS(1400),
    [sym_integer] = ACTIONS(1402),
    [sym_float] = ACTIONS(1400),
    [anon_sym_await] = ACTIONS(1402),
    [sym_true] = ACTIONS(1402),
    [sym_false] = ACTIONS(1402),
    [sym_none] = ACTIONS(1402),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1402),
    [anon_sym_container] = ACTIONS(1402),
    [anon_sym_envvars] = ACTIONS(1402),
    [anon_sym_include] = ACTIONS(1402),
    [anon_sym_pepfile] = ACTIONS(1402),
    [anon_sym_pepschema] = ACTIONS(1402),
    [anon_sym_scattergather] = ACTIONS(1402),
    [anon_sym_version] = ACTIONS(1402),
    [anon_sym_wildcard_constraints] = ACTIONS(1402),
    [anon_sym_workdir] = ACTIONS(1402),
    [anon_sym_onerror] = ACTIONS(1402),
    [anon_sym_onstart] = ACTIONS(1402),
    [anon_sym_onsuccess] = ACTIONS(1402),
    [anon_sym_localrules] = ACTIONS(1402),
    [anon_sym_ruleorder] = ACTIONS(1402),
    [anon_sym_rule] = ACTIONS(1402),
    [anon_sym_checkpoint] = ACTIONS(1402),
    [anon_sym_use] = ACTIONS(1402),
    [anon_sym_module] = ACTIONS(1402),
    [sym__dedent] = ACTIONS(1400),
    [sym_string_start] = ACTIONS(1400),
  },
  [491] = {
    [sym_identifier] = ACTIONS(1540),
    [anon_sym_import] = ACTIONS(1540),
    [anon_sym_from] = ACTIONS(1540),
    [anon_sym_LPAREN] = ACTIONS(1542),
    [anon_sym_STAR] = ACTIONS(1542),
    [anon_sym_print] = ACTIONS(1540),
    [anon_sym_assert] = ACTIONS(1540),
    [anon_sym_return] = ACTIONS(1540),
    [anon_sym_del] = ACTIONS(1540),
    [anon_sym_raise] = ACTIONS(1540),
    [anon_sym_pass] = ACTIONS(1540),
    [anon_sym_break] = ACTIONS(1540),
    [anon_sym_continue] = ACTIONS(1540),
    [anon_sym_if] = ACTIONS(1540),
    [anon_sym_match] = ACTIONS(1540),
    [anon_sym_async] = ACTIONS(1540),
    [anon_sym_for] = ACTIONS(1540),
    [anon_sym_while] = ACTIONS(1540),
    [anon_sym_try] = ACTIONS(1540),
    [anon_sym_with] = ACTIONS(1540),
    [anon_sym_def] = ACTIONS(1540),
    [anon_sym_global] = ACTIONS(1540),
    [anon_sym_nonlocal] = ACTIONS(1540),
    [anon_sym_exec] = ACTIONS(1540),
    [anon_sym_type] = ACTIONS(1540),
    [anon_sym_class] = ACTIONS(1540),
    [anon_sym_LBRACK] = ACTIONS(1542),
    [anon_sym_AT] = ACTIONS(1542),
    [anon_sym_DASH] = ACTIONS(1542),
    [anon_sym_LBRACE] = ACTIONS(1542),
    [anon_sym_PLUS] = ACTIONS(1542),
    [anon_sym_not] = ACTIONS(1540),
    [anon_sym_TILDE] = ACTIONS(1542),
    [anon_sym_lambda] = ACTIONS(1540),
    [anon_sym_yield] = ACTIONS(1540),
    [sym_ellipsis] = ACTIONS(1542),
    [sym_integer] = ACTIONS(1540),
    [sym_float] = ACTIONS(1542),
    [anon_sym_await] = ACTIONS(1540),
    [sym_true] = ACTIONS(1540),
    [sym_false] = ACTIONS(1540),
    [sym_none] = ACTIONS(1540),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1540),
    [anon_sym_container] = ACTIONS(1540),
    [anon_sym_envvars] = ACTIONS(1540),
    [anon_sym_include] = ACTIONS(1540),
    [anon_sym_pepfile] = ACTIONS(1540),
    [anon_sym_pepschema] = ACTIONS(1540),
    [anon_sym_scattergather] = ACTIONS(1540),
    [anon_sym_version] = ACTIONS(1540),
    [anon_sym_wildcard_constraints] = ACTIONS(1540),
    [anon_sym_workdir] = ACTIONS(1540),
    [anon_sym_onerror] = ACTIONS(1540),
    [anon_sym_onstart] = ACTIONS(1540),
    [anon_sym_onsuccess] = ACTIONS(1540),
    [anon_sym_localrules] = ACTIONS(1540),
    [anon_sym_ruleorder] = ACTIONS(1540),
    [anon_sym_rule] = ACTIONS(1540),
    [anon_sym_checkpoint] = ACTIONS(1540),
    [anon_sym_use] = ACTIONS(1540),
    [anon_sym_module] = ACTIONS(1540),
    [sym__dedent] = ACTIONS(1542),
    [sym_string_start] = ACTIONS(1542),
  },
  [492] = {
    [ts_builtin_sym_end] = ACTIONS(1544),
    [sym_identifier] = ACTIONS(1546),
    [anon_sym_import] = ACTIONS(1546),
    [anon_sym_from] = ACTIONS(1546),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [anon_sym_STAR] = ACTIONS(1544),
    [anon_sym_print] = ACTIONS(1546),
    [anon_sym_assert] = ACTIONS(1546),
    [anon_sym_return] = ACTIONS(1546),
    [anon_sym_del] = ACTIONS(1546),
    [anon_sym_raise] = ACTIONS(1546),
    [anon_sym_pass] = ACTIONS(1546),
    [anon_sym_break] = ACTIONS(1546),
    [anon_sym_continue] = ACTIONS(1546),
    [anon_sym_if] = ACTIONS(1546),
    [anon_sym_match] = ACTIONS(1546),
    [anon_sym_async] = ACTIONS(1546),
    [anon_sym_for] = ACTIONS(1546),
    [anon_sym_while] = ACTIONS(1546),
    [anon_sym_try] = ACTIONS(1546),
    [anon_sym_with] = ACTIONS(1546),
    [anon_sym_def] = ACTIONS(1546),
    [anon_sym_global] = ACTIONS(1546),
    [anon_sym_nonlocal] = ACTIONS(1546),
    [anon_sym_exec] = ACTIONS(1546),
    [anon_sym_type] = ACTIONS(1546),
    [anon_sym_class] = ACTIONS(1546),
    [anon_sym_LBRACK] = ACTIONS(1544),
    [anon_sym_AT] = ACTIONS(1544),
    [anon_sym_DASH] = ACTIONS(1544),
    [anon_sym_LBRACE] = ACTIONS(1544),
    [anon_sym_PLUS] = ACTIONS(1544),
    [anon_sym_not] = ACTIONS(1546),
    [anon_sym_TILDE] = ACTIONS(1544),
    [anon_sym_lambda] = ACTIONS(1546),
    [anon_sym_yield] = ACTIONS(1546),
    [sym_ellipsis] = ACTIONS(1544),
    [sym_integer] = ACTIONS(1546),
    [sym_float] = ACTIONS(1544),
    [anon_sym_await] = ACTIONS(1546),
    [sym_true] = ACTIONS(1546),
    [sym_false] = ACTIONS(1546),
    [sym_none] = ACTIONS(1546),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1546),
    [anon_sym_container] = ACTIONS(1546),
    [anon_sym_envvars] = ACTIONS(1546),
    [anon_sym_include] = ACTIONS(1546),
    [anon_sym_pepfile] = ACTIONS(1546),
    [anon_sym_pepschema] = ACTIONS(1546),
    [anon_sym_scattergather] = ACTIONS(1546),
    [anon_sym_version] = ACTIONS(1546),
    [anon_sym_wildcard_constraints] = ACTIONS(1546),
    [anon_sym_workdir] = ACTIONS(1546),
    [anon_sym_onerror] = ACTIONS(1546),
    [anon_sym_onstart] = ACTIONS(1546),
    [anon_sym_onsuccess] = ACTIONS(1546),
    [anon_sym_localrules] = ACTIONS(1546),
    [anon_sym_ruleorder] = ACTIONS(1546),
    [anon_sym_rule] = ACTIONS(1546),
    [anon_sym_checkpoint] = ACTIONS(1546),
    [anon_sym_use] = ACTIONS(1546),
    [anon_sym_module] = ACTIONS(1546),
    [sym_string_start] = ACTIONS(1544),
  },
  [493] = {
    [ts_builtin_sym_end] = ACTIONS(1548),
    [sym_identifier] = ACTIONS(1550),
    [anon_sym_import] = ACTIONS(1550),
    [anon_sym_from] = ACTIONS(1550),
    [anon_sym_LPAREN] = ACTIONS(1548),
    [anon_sym_STAR] = ACTIONS(1548),
    [anon_sym_print] = ACTIONS(1550),
    [anon_sym_assert] = ACTIONS(1550),
    [anon_sym_return] = ACTIONS(1550),
    [anon_sym_del] = ACTIONS(1550),
    [anon_sym_raise] = ACTIONS(1550),
    [anon_sym_pass] = ACTIONS(1550),
    [anon_sym_break] = ACTIONS(1550),
    [anon_sym_continue] = ACTIONS(1550),
    [anon_sym_if] = ACTIONS(1550),
    [anon_sym_match] = ACTIONS(1550),
    [anon_sym_async] = ACTIONS(1550),
    [anon_sym_for] = ACTIONS(1550),
    [anon_sym_while] = ACTIONS(1550),
    [anon_sym_try] = ACTIONS(1550),
    [anon_sym_with] = ACTIONS(1550),
    [anon_sym_def] = ACTIONS(1550),
    [anon_sym_global] = ACTIONS(1550),
    [anon_sym_nonlocal] = ACTIONS(1550),
    [anon_sym_exec] = ACTIONS(1550),
    [anon_sym_type] = ACTIONS(1550),
    [anon_sym_class] = ACTIONS(1550),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [anon_sym_AT] = ACTIONS(1548),
    [anon_sym_DASH] = ACTIONS(1548),
    [anon_sym_LBRACE] = ACTIONS(1548),
    [anon_sym_PLUS] = ACTIONS(1548),
    [anon_sym_not] = ACTIONS(1550),
    [anon_sym_TILDE] = ACTIONS(1548),
    [anon_sym_lambda] = ACTIONS(1550),
    [anon_sym_yield] = ACTIONS(1550),
    [sym_ellipsis] = ACTIONS(1548),
    [sym_integer] = ACTIONS(1550),
    [sym_float] = ACTIONS(1548),
    [anon_sym_await] = ACTIONS(1550),
    [sym_true] = ACTIONS(1550),
    [sym_false] = ACTIONS(1550),
    [sym_none] = ACTIONS(1550),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1550),
    [anon_sym_container] = ACTIONS(1550),
    [anon_sym_envvars] = ACTIONS(1550),
    [anon_sym_include] = ACTIONS(1550),
    [anon_sym_pepfile] = ACTIONS(1550),
    [anon_sym_pepschema] = ACTIONS(1550),
    [anon_sym_scattergather] = ACTIONS(1550),
    [anon_sym_version] = ACTIONS(1550),
    [anon_sym_wildcard_constraints] = ACTIONS(1550),
    [anon_sym_workdir] = ACTIONS(1550),
    [anon_sym_onerror] = ACTIONS(1550),
    [anon_sym_onstart] = ACTIONS(1550),
    [anon_sym_onsuccess] = ACTIONS(1550),
    [anon_sym_localrules] = ACTIONS(1550),
    [anon_sym_ruleorder] = ACTIONS(1550),
    [anon_sym_rule] = ACTIONS(1550),
    [anon_sym_checkpoint] = ACTIONS(1550),
    [anon_sym_use] = ACTIONS(1550),
    [anon_sym_module] = ACTIONS(1550),
    [sym_string_start] = ACTIONS(1548),
  },
  [494] = {
    [sym_identifier] = ACTIONS(1552),
    [anon_sym_import] = ACTIONS(1552),
    [anon_sym_from] = ACTIONS(1552),
    [anon_sym_LPAREN] = ACTIONS(1554),
    [anon_sym_STAR] = ACTIONS(1554),
    [anon_sym_print] = ACTIONS(1552),
    [anon_sym_assert] = ACTIONS(1552),
    [anon_sym_return] = ACTIONS(1552),
    [anon_sym_del] = ACTIONS(1552),
    [anon_sym_raise] = ACTIONS(1552),
    [anon_sym_pass] = ACTIONS(1552),
    [anon_sym_break] = ACTIONS(1552),
    [anon_sym_continue] = ACTIONS(1552),
    [anon_sym_if] = ACTIONS(1552),
    [anon_sym_match] = ACTIONS(1552),
    [anon_sym_async] = ACTIONS(1552),
    [anon_sym_for] = ACTIONS(1552),
    [anon_sym_while] = ACTIONS(1552),
    [anon_sym_try] = ACTIONS(1552),
    [anon_sym_with] = ACTIONS(1552),
    [anon_sym_def] = ACTIONS(1552),
    [anon_sym_global] = ACTIONS(1552),
    [anon_sym_nonlocal] = ACTIONS(1552),
    [anon_sym_exec] = ACTIONS(1552),
    [anon_sym_type] = ACTIONS(1552),
    [anon_sym_class] = ACTIONS(1552),
    [anon_sym_LBRACK] = ACTIONS(1554),
    [anon_sym_AT] = ACTIONS(1554),
    [anon_sym_DASH] = ACTIONS(1554),
    [anon_sym_LBRACE] = ACTIONS(1554),
    [anon_sym_PLUS] = ACTIONS(1554),
    [anon_sym_not] = ACTIONS(1552),
    [anon_sym_TILDE] = ACTIONS(1554),
    [anon_sym_lambda] = ACTIONS(1552),
    [anon_sym_yield] = ACTIONS(1552),
    [sym_ellipsis] = ACTIONS(1554),
    [sym_integer] = ACTIONS(1552),
    [sym_float] = ACTIONS(1554),
    [anon_sym_await] = ACTIONS(1552),
    [sym_true] = ACTIONS(1552),
    [sym_false] = ACTIONS(1552),
    [sym_none] = ACTIONS(1552),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1552),
    [anon_sym_container] = ACTIONS(1552),
    [anon_sym_envvars] = ACTIONS(1552),
    [anon_sym_include] = ACTIONS(1552),
    [anon_sym_pepfile] = ACTIONS(1552),
    [anon_sym_pepschema] = ACTIONS(1552),
    [anon_sym_scattergather] = ACTIONS(1552),
    [anon_sym_version] = ACTIONS(1552),
    [anon_sym_wildcard_constraints] = ACTIONS(1552),
    [anon_sym_workdir] = ACTIONS(1552),
    [anon_sym_onerror] = ACTIONS(1552),
    [anon_sym_onstart] = ACTIONS(1552),
    [anon_sym_onsuccess] = ACTIONS(1552),
    [anon_sym_localrules] = ACTIONS(1552),
    [anon_sym_ruleorder] = ACTIONS(1552),
    [anon_sym_rule] = ACTIONS(1552),
    [anon_sym_checkpoint] = ACTIONS(1552),
    [anon_sym_use] = ACTIONS(1552),
    [anon_sym_module] = ACTIONS(1552),
    [sym__dedent] = ACTIONS(1554),
    [sym_string_start] = ACTIONS(1554),
  },
  [495] = {
    [ts_builtin_sym_end] = ACTIONS(1556),
    [sym_identifier] = ACTIONS(1558),
    [anon_sym_import] = ACTIONS(1558),
    [anon_sym_from] = ACTIONS(1558),
    [anon_sym_LPAREN] = ACTIONS(1556),
    [anon_sym_STAR] = ACTIONS(1556),
    [anon_sym_print] = ACTIONS(1558),
    [anon_sym_assert] = ACTIONS(1558),
    [anon_sym_return] = ACTIONS(1558),
    [anon_sym_del] = ACTIONS(1558),
    [anon_sym_raise] = ACTIONS(1558),
    [anon_sym_pass] = ACTIONS(1558),
    [anon_sym_break] = ACTIONS(1558),
    [anon_sym_continue] = ACTIONS(1558),
    [anon_sym_if] = ACTIONS(1558),
    [anon_sym_match] = ACTIONS(1558),
    [anon_sym_async] = ACTIONS(1558),
    [anon_sym_for] = ACTIONS(1558),
    [anon_sym_while] = ACTIONS(1558),
    [anon_sym_try] = ACTIONS(1558),
    [anon_sym_with] = ACTIONS(1558),
    [anon_sym_def] = ACTIONS(1558),
    [anon_sym_global] = ACTIONS(1558),
    [anon_sym_nonlocal] = ACTIONS(1558),
    [anon_sym_exec] = ACTIONS(1558),
    [anon_sym_type] = ACTIONS(1558),
    [anon_sym_class] = ACTIONS(1558),
    [anon_sym_LBRACK] = ACTIONS(1556),
    [anon_sym_AT] = ACTIONS(1556),
    [anon_sym_DASH] = ACTIONS(1556),
    [anon_sym_LBRACE] = ACTIONS(1556),
    [anon_sym_PLUS] = ACTIONS(1556),
    [anon_sym_not] = ACTIONS(1558),
    [anon_sym_TILDE] = ACTIONS(1556),
    [anon_sym_lambda] = ACTIONS(1558),
    [anon_sym_yield] = ACTIONS(1558),
    [sym_ellipsis] = ACTIONS(1556),
    [sym_integer] = ACTIONS(1558),
    [sym_float] = ACTIONS(1556),
    [anon_sym_await] = ACTIONS(1558),
    [sym_true] = ACTIONS(1558),
    [sym_false] = ACTIONS(1558),
    [sym_none] = ACTIONS(1558),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1558),
    [anon_sym_container] = ACTIONS(1558),
    [anon_sym_envvars] = ACTIONS(1558),
    [anon_sym_include] = ACTIONS(1558),
    [anon_sym_pepfile] = ACTIONS(1558),
    [anon_sym_pepschema] = ACTIONS(1558),
    [anon_sym_scattergather] = ACTIONS(1558),
    [anon_sym_version] = ACTIONS(1558),
    [anon_sym_wildcard_constraints] = ACTIONS(1558),
    [anon_sym_workdir] = ACTIONS(1558),
    [anon_sym_onerror] = ACTIONS(1558),
    [anon_sym_onstart] = ACTIONS(1558),
    [anon_sym_onsuccess] = ACTIONS(1558),
    [anon_sym_localrules] = ACTIONS(1558),
    [anon_sym_ruleorder] = ACTIONS(1558),
    [anon_sym_rule] = ACTIONS(1558),
    [anon_sym_checkpoint] = ACTIONS(1558),
    [anon_sym_use] = ACTIONS(1558),
    [anon_sym_module] = ACTIONS(1558),
    [sym_string_start] = ACTIONS(1556),
  },
  [496] = {
    [ts_builtin_sym_end] = ACTIONS(1560),
    [sym_identifier] = ACTIONS(1562),
    [anon_sym_import] = ACTIONS(1562),
    [anon_sym_from] = ACTIONS(1562),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_STAR] = ACTIONS(1560),
    [anon_sym_print] = ACTIONS(1562),
    [anon_sym_assert] = ACTIONS(1562),
    [anon_sym_return] = ACTIONS(1562),
    [anon_sym_del] = ACTIONS(1562),
    [anon_sym_raise] = ACTIONS(1562),
    [anon_sym_pass] = ACTIONS(1562),
    [anon_sym_break] = ACTIONS(1562),
    [anon_sym_continue] = ACTIONS(1562),
    [anon_sym_if] = ACTIONS(1562),
    [anon_sym_match] = ACTIONS(1562),
    [anon_sym_async] = ACTIONS(1562),
    [anon_sym_for] = ACTIONS(1562),
    [anon_sym_while] = ACTIONS(1562),
    [anon_sym_try] = ACTIONS(1562),
    [anon_sym_with] = ACTIONS(1562),
    [anon_sym_def] = ACTIONS(1562),
    [anon_sym_global] = ACTIONS(1562),
    [anon_sym_nonlocal] = ACTIONS(1562),
    [anon_sym_exec] = ACTIONS(1562),
    [anon_sym_type] = ACTIONS(1562),
    [anon_sym_class] = ACTIONS(1562),
    [anon_sym_LBRACK] = ACTIONS(1560),
    [anon_sym_AT] = ACTIONS(1560),
    [anon_sym_DASH] = ACTIONS(1560),
    [anon_sym_LBRACE] = ACTIONS(1560),
    [anon_sym_PLUS] = ACTIONS(1560),
    [anon_sym_not] = ACTIONS(1562),
    [anon_sym_TILDE] = ACTIONS(1560),
    [anon_sym_lambda] = ACTIONS(1562),
    [anon_sym_yield] = ACTIONS(1562),
    [sym_ellipsis] = ACTIONS(1560),
    [sym_integer] = ACTIONS(1562),
    [sym_float] = ACTIONS(1560),
    [anon_sym_await] = ACTIONS(1562),
    [sym_true] = ACTIONS(1562),
    [sym_false] = ACTIONS(1562),
    [sym_none] = ACTIONS(1562),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1562),
    [anon_sym_container] = ACTIONS(1562),
    [anon_sym_envvars] = ACTIONS(1562),
    [anon_sym_include] = ACTIONS(1562),
    [anon_sym_pepfile] = ACTIONS(1562),
    [anon_sym_pepschema] = ACTIONS(1562),
    [anon_sym_scattergather] = ACTIONS(1562),
    [anon_sym_version] = ACTIONS(1562),
    [anon_sym_wildcard_constraints] = ACTIONS(1562),
    [anon_sym_workdir] = ACTIONS(1562),
    [anon_sym_onerror] = ACTIONS(1562),
    [anon_sym_onstart] = ACTIONS(1562),
    [anon_sym_onsuccess] = ACTIONS(1562),
    [anon_sym_localrules] = ACTIONS(1562),
    [anon_sym_ruleorder] = ACTIONS(1562),
    [anon_sym_rule] = ACTIONS(1562),
    [anon_sym_checkpoint] = ACTIONS(1562),
    [anon_sym_use] = ACTIONS(1562),
    [anon_sym_module] = ACTIONS(1562),
    [sym_string_start] = ACTIONS(1560),
  },
  [497] = {
    [sym_identifier] = ACTIONS(1564),
    [anon_sym_import] = ACTIONS(1564),
    [anon_sym_from] = ACTIONS(1564),
    [anon_sym_LPAREN] = ACTIONS(1566),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_print] = ACTIONS(1564),
    [anon_sym_assert] = ACTIONS(1564),
    [anon_sym_return] = ACTIONS(1564),
    [anon_sym_del] = ACTIONS(1564),
    [anon_sym_raise] = ACTIONS(1564),
    [anon_sym_pass] = ACTIONS(1564),
    [anon_sym_break] = ACTIONS(1564),
    [anon_sym_continue] = ACTIONS(1564),
    [anon_sym_if] = ACTIONS(1564),
    [anon_sym_match] = ACTIONS(1564),
    [anon_sym_async] = ACTIONS(1564),
    [anon_sym_for] = ACTIONS(1564),
    [anon_sym_while] = ACTIONS(1564),
    [anon_sym_try] = ACTIONS(1564),
    [anon_sym_with] = ACTIONS(1564),
    [anon_sym_def] = ACTIONS(1564),
    [anon_sym_global] = ACTIONS(1564),
    [anon_sym_nonlocal] = ACTIONS(1564),
    [anon_sym_exec] = ACTIONS(1564),
    [anon_sym_type] = ACTIONS(1564),
    [anon_sym_class] = ACTIONS(1564),
    [anon_sym_LBRACK] = ACTIONS(1566),
    [anon_sym_AT] = ACTIONS(1566),
    [anon_sym_DASH] = ACTIONS(1566),
    [anon_sym_LBRACE] = ACTIONS(1566),
    [anon_sym_PLUS] = ACTIONS(1566),
    [anon_sym_not] = ACTIONS(1564),
    [anon_sym_TILDE] = ACTIONS(1566),
    [anon_sym_lambda] = ACTIONS(1564),
    [anon_sym_yield] = ACTIONS(1564),
    [sym_ellipsis] = ACTIONS(1566),
    [sym_integer] = ACTIONS(1564),
    [sym_float] = ACTIONS(1566),
    [anon_sym_await] = ACTIONS(1564),
    [sym_true] = ACTIONS(1564),
    [sym_false] = ACTIONS(1564),
    [sym_none] = ACTIONS(1564),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1564),
    [anon_sym_container] = ACTIONS(1564),
    [anon_sym_envvars] = ACTIONS(1564),
    [anon_sym_include] = ACTIONS(1564),
    [anon_sym_pepfile] = ACTIONS(1564),
    [anon_sym_pepschema] = ACTIONS(1564),
    [anon_sym_scattergather] = ACTIONS(1564),
    [anon_sym_version] = ACTIONS(1564),
    [anon_sym_wildcard_constraints] = ACTIONS(1564),
    [anon_sym_workdir] = ACTIONS(1564),
    [anon_sym_onerror] = ACTIONS(1564),
    [anon_sym_onstart] = ACTIONS(1564),
    [anon_sym_onsuccess] = ACTIONS(1564),
    [anon_sym_localrules] = ACTIONS(1564),
    [anon_sym_ruleorder] = ACTIONS(1564),
    [anon_sym_rule] = ACTIONS(1564),
    [anon_sym_checkpoint] = ACTIONS(1564),
    [anon_sym_use] = ACTIONS(1564),
    [anon_sym_module] = ACTIONS(1564),
    [sym__dedent] = ACTIONS(1566),
    [sym_string_start] = ACTIONS(1566),
  },
  [498] = {
    [sym_identifier] = ACTIONS(1568),
    [anon_sym_import] = ACTIONS(1568),
    [anon_sym_from] = ACTIONS(1568),
    [anon_sym_LPAREN] = ACTIONS(1570),
    [anon_sym_STAR] = ACTIONS(1570),
    [anon_sym_print] = ACTIONS(1568),
    [anon_sym_assert] = ACTIONS(1568),
    [anon_sym_return] = ACTIONS(1568),
    [anon_sym_del] = ACTIONS(1568),
    [anon_sym_raise] = ACTIONS(1568),
    [anon_sym_pass] = ACTIONS(1568),
    [anon_sym_break] = ACTIONS(1568),
    [anon_sym_continue] = ACTIONS(1568),
    [anon_sym_if] = ACTIONS(1568),
    [anon_sym_match] = ACTIONS(1568),
    [anon_sym_async] = ACTIONS(1568),
    [anon_sym_for] = ACTIONS(1568),
    [anon_sym_while] = ACTIONS(1568),
    [anon_sym_try] = ACTIONS(1568),
    [anon_sym_with] = ACTIONS(1568),
    [anon_sym_def] = ACTIONS(1568),
    [anon_sym_global] = ACTIONS(1568),
    [anon_sym_nonlocal] = ACTIONS(1568),
    [anon_sym_exec] = ACTIONS(1568),
    [anon_sym_type] = ACTIONS(1568),
    [anon_sym_class] = ACTIONS(1568),
    [anon_sym_LBRACK] = ACTIONS(1570),
    [anon_sym_AT] = ACTIONS(1570),
    [anon_sym_DASH] = ACTIONS(1570),
    [anon_sym_LBRACE] = ACTIONS(1570),
    [anon_sym_PLUS] = ACTIONS(1570),
    [anon_sym_not] = ACTIONS(1568),
    [anon_sym_TILDE] = ACTIONS(1570),
    [anon_sym_lambda] = ACTIONS(1568),
    [anon_sym_yield] = ACTIONS(1568),
    [sym_ellipsis] = ACTIONS(1570),
    [sym_integer] = ACTIONS(1568),
    [sym_float] = ACTIONS(1570),
    [anon_sym_await] = ACTIONS(1568),
    [sym_true] = ACTIONS(1568),
    [sym_false] = ACTIONS(1568),
    [sym_none] = ACTIONS(1568),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1568),
    [anon_sym_container] = ACTIONS(1568),
    [anon_sym_envvars] = ACTIONS(1568),
    [anon_sym_include] = ACTIONS(1568),
    [anon_sym_pepfile] = ACTIONS(1568),
    [anon_sym_pepschema] = ACTIONS(1568),
    [anon_sym_scattergather] = ACTIONS(1568),
    [anon_sym_version] = ACTIONS(1568),
    [anon_sym_wildcard_constraints] = ACTIONS(1568),
    [anon_sym_workdir] = ACTIONS(1568),
    [anon_sym_onerror] = ACTIONS(1568),
    [anon_sym_onstart] = ACTIONS(1568),
    [anon_sym_onsuccess] = ACTIONS(1568),
    [anon_sym_localrules] = ACTIONS(1568),
    [anon_sym_ruleorder] = ACTIONS(1568),
    [anon_sym_rule] = ACTIONS(1568),
    [anon_sym_checkpoint] = ACTIONS(1568),
    [anon_sym_use] = ACTIONS(1568),
    [anon_sym_module] = ACTIONS(1568),
    [sym__dedent] = ACTIONS(1570),
    [sym_string_start] = ACTIONS(1570),
  },
  [499] = {
    [ts_builtin_sym_end] = ACTIONS(1572),
    [sym_identifier] = ACTIONS(1574),
    [anon_sym_import] = ACTIONS(1574),
    [anon_sym_from] = ACTIONS(1574),
    [anon_sym_LPAREN] = ACTIONS(1572),
    [anon_sym_STAR] = ACTIONS(1572),
    [anon_sym_print] = ACTIONS(1574),
    [anon_sym_assert] = ACTIONS(1574),
    [anon_sym_return] = ACTIONS(1574),
    [anon_sym_del] = ACTIONS(1574),
    [anon_sym_raise] = ACTIONS(1574),
    [anon_sym_pass] = ACTIONS(1574),
    [anon_sym_break] = ACTIONS(1574),
    [anon_sym_continue] = ACTIONS(1574),
    [anon_sym_if] = ACTIONS(1574),
    [anon_sym_match] = ACTIONS(1574),
    [anon_sym_async] = ACTIONS(1574),
    [anon_sym_for] = ACTIONS(1574),
    [anon_sym_while] = ACTIONS(1574),
    [anon_sym_try] = ACTIONS(1574),
    [anon_sym_with] = ACTIONS(1574),
    [anon_sym_def] = ACTIONS(1574),
    [anon_sym_global] = ACTIONS(1574),
    [anon_sym_nonlocal] = ACTIONS(1574),
    [anon_sym_exec] = ACTIONS(1574),
    [anon_sym_type] = ACTIONS(1574),
    [anon_sym_class] = ACTIONS(1574),
    [anon_sym_LBRACK] = ACTIONS(1572),
    [anon_sym_AT] = ACTIONS(1572),
    [anon_sym_DASH] = ACTIONS(1572),
    [anon_sym_LBRACE] = ACTIONS(1572),
    [anon_sym_PLUS] = ACTIONS(1572),
    [anon_sym_not] = ACTIONS(1574),
    [anon_sym_TILDE] = ACTIONS(1572),
    [anon_sym_lambda] = ACTIONS(1574),
    [anon_sym_yield] = ACTIONS(1574),
    [sym_ellipsis] = ACTIONS(1572),
    [sym_integer] = ACTIONS(1574),
    [sym_float] = ACTIONS(1572),
    [anon_sym_await] = ACTIONS(1574),
    [sym_true] = ACTIONS(1574),
    [sym_false] = ACTIONS(1574),
    [sym_none] = ACTIONS(1574),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1574),
    [anon_sym_container] = ACTIONS(1574),
    [anon_sym_envvars] = ACTIONS(1574),
    [anon_sym_include] = ACTIONS(1574),
    [anon_sym_pepfile] = ACTIONS(1574),
    [anon_sym_pepschema] = ACTIONS(1574),
    [anon_sym_scattergather] = ACTIONS(1574),
    [anon_sym_version] = ACTIONS(1574),
    [anon_sym_wildcard_constraints] = ACTIONS(1574),
    [anon_sym_workdir] = ACTIONS(1574),
    [anon_sym_onerror] = ACTIONS(1574),
    [anon_sym_onstart] = ACTIONS(1574),
    [anon_sym_onsuccess] = ACTIONS(1574),
    [anon_sym_localrules] = ACTIONS(1574),
    [anon_sym_ruleorder] = ACTIONS(1574),
    [anon_sym_rule] = ACTIONS(1574),
    [anon_sym_checkpoint] = ACTIONS(1574),
    [anon_sym_use] = ACTIONS(1574),
    [anon_sym_module] = ACTIONS(1574),
    [sym_string_start] = ACTIONS(1572),
  },
  [500] = {
    [sym_identifier] = ACTIONS(1576),
    [anon_sym_import] = ACTIONS(1576),
    [anon_sym_from] = ACTIONS(1576),
    [anon_sym_LPAREN] = ACTIONS(1578),
    [anon_sym_STAR] = ACTIONS(1578),
    [anon_sym_print] = ACTIONS(1576),
    [anon_sym_assert] = ACTIONS(1576),
    [anon_sym_return] = ACTIONS(1576),
    [anon_sym_del] = ACTIONS(1576),
    [anon_sym_raise] = ACTIONS(1576),
    [anon_sym_pass] = ACTIONS(1576),
    [anon_sym_break] = ACTIONS(1576),
    [anon_sym_continue] = ACTIONS(1576),
    [anon_sym_if] = ACTIONS(1576),
    [anon_sym_match] = ACTIONS(1576),
    [anon_sym_async] = ACTIONS(1576),
    [anon_sym_for] = ACTIONS(1576),
    [anon_sym_while] = ACTIONS(1576),
    [anon_sym_try] = ACTIONS(1576),
    [anon_sym_with] = ACTIONS(1576),
    [anon_sym_def] = ACTIONS(1576),
    [anon_sym_global] = ACTIONS(1576),
    [anon_sym_nonlocal] = ACTIONS(1576),
    [anon_sym_exec] = ACTIONS(1576),
    [anon_sym_type] = ACTIONS(1576),
    [anon_sym_class] = ACTIONS(1576),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [anon_sym_AT] = ACTIONS(1578),
    [anon_sym_DASH] = ACTIONS(1578),
    [anon_sym_LBRACE] = ACTIONS(1578),
    [anon_sym_PLUS] = ACTIONS(1578),
    [anon_sym_not] = ACTIONS(1576),
    [anon_sym_TILDE] = ACTIONS(1578),
    [anon_sym_lambda] = ACTIONS(1576),
    [anon_sym_yield] = ACTIONS(1576),
    [sym_ellipsis] = ACTIONS(1578),
    [sym_integer] = ACTIONS(1576),
    [sym_float] = ACTIONS(1578),
    [anon_sym_await] = ACTIONS(1576),
    [sym_true] = ACTIONS(1576),
    [sym_false] = ACTIONS(1576),
    [sym_none] = ACTIONS(1576),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1576),
    [anon_sym_container] = ACTIONS(1576),
    [anon_sym_envvars] = ACTIONS(1576),
    [anon_sym_include] = ACTIONS(1576),
    [anon_sym_pepfile] = ACTIONS(1576),
    [anon_sym_pepschema] = ACTIONS(1576),
    [anon_sym_scattergather] = ACTIONS(1576),
    [anon_sym_version] = ACTIONS(1576),
    [anon_sym_wildcard_constraints] = ACTIONS(1576),
    [anon_sym_workdir] = ACTIONS(1576),
    [anon_sym_onerror] = ACTIONS(1576),
    [anon_sym_onstart] = ACTIONS(1576),
    [anon_sym_onsuccess] = ACTIONS(1576),
    [anon_sym_localrules] = ACTIONS(1576),
    [anon_sym_ruleorder] = ACTIONS(1576),
    [anon_sym_rule] = ACTIONS(1576),
    [anon_sym_checkpoint] = ACTIONS(1576),
    [anon_sym_use] = ACTIONS(1576),
    [anon_sym_module] = ACTIONS(1576),
    [sym__dedent] = ACTIONS(1578),
    [sym_string_start] = ACTIONS(1578),
  },
  [501] = {
    [sym_identifier] = ACTIONS(1574),
    [anon_sym_import] = ACTIONS(1574),
    [anon_sym_from] = ACTIONS(1574),
    [anon_sym_LPAREN] = ACTIONS(1572),
    [anon_sym_STAR] = ACTIONS(1572),
    [anon_sym_print] = ACTIONS(1574),
    [anon_sym_assert] = ACTIONS(1574),
    [anon_sym_return] = ACTIONS(1574),
    [anon_sym_del] = ACTIONS(1574),
    [anon_sym_raise] = ACTIONS(1574),
    [anon_sym_pass] = ACTIONS(1574),
    [anon_sym_break] = ACTIONS(1574),
    [anon_sym_continue] = ACTIONS(1574),
    [anon_sym_if] = ACTIONS(1574),
    [anon_sym_match] = ACTIONS(1574),
    [anon_sym_async] = ACTIONS(1574),
    [anon_sym_for] = ACTIONS(1574),
    [anon_sym_while] = ACTIONS(1574),
    [anon_sym_try] = ACTIONS(1574),
    [anon_sym_with] = ACTIONS(1574),
    [anon_sym_def] = ACTIONS(1574),
    [anon_sym_global] = ACTIONS(1574),
    [anon_sym_nonlocal] = ACTIONS(1574),
    [anon_sym_exec] = ACTIONS(1574),
    [anon_sym_type] = ACTIONS(1574),
    [anon_sym_class] = ACTIONS(1574),
    [anon_sym_LBRACK] = ACTIONS(1572),
    [anon_sym_AT] = ACTIONS(1572),
    [anon_sym_DASH] = ACTIONS(1572),
    [anon_sym_LBRACE] = ACTIONS(1572),
    [anon_sym_PLUS] = ACTIONS(1572),
    [anon_sym_not] = ACTIONS(1574),
    [anon_sym_TILDE] = ACTIONS(1572),
    [anon_sym_lambda] = ACTIONS(1574),
    [anon_sym_yield] = ACTIONS(1574),
    [sym_ellipsis] = ACTIONS(1572),
    [sym_integer] = ACTIONS(1574),
    [sym_float] = ACTIONS(1572),
    [anon_sym_await] = ACTIONS(1574),
    [sym_true] = ACTIONS(1574),
    [sym_false] = ACTIONS(1574),
    [sym_none] = ACTIONS(1574),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1574),
    [anon_sym_container] = ACTIONS(1574),
    [anon_sym_envvars] = ACTIONS(1574),
    [anon_sym_include] = ACTIONS(1574),
    [anon_sym_pepfile] = ACTIONS(1574),
    [anon_sym_pepschema] = ACTIONS(1574),
    [anon_sym_scattergather] = ACTIONS(1574),
    [anon_sym_version] = ACTIONS(1574),
    [anon_sym_wildcard_constraints] = ACTIONS(1574),
    [anon_sym_workdir] = ACTIONS(1574),
    [anon_sym_onerror] = ACTIONS(1574),
    [anon_sym_onstart] = ACTIONS(1574),
    [anon_sym_onsuccess] = ACTIONS(1574),
    [anon_sym_localrules] = ACTIONS(1574),
    [anon_sym_ruleorder] = ACTIONS(1574),
    [anon_sym_rule] = ACTIONS(1574),
    [anon_sym_checkpoint] = ACTIONS(1574),
    [anon_sym_use] = ACTIONS(1574),
    [anon_sym_module] = ACTIONS(1574),
    [sym__dedent] = ACTIONS(1572),
    [sym_string_start] = ACTIONS(1572),
  },
  [502] = {
    [sym_identifier] = ACTIONS(1562),
    [anon_sym_import] = ACTIONS(1562),
    [anon_sym_from] = ACTIONS(1562),
    [anon_sym_LPAREN] = ACTIONS(1560),
    [anon_sym_STAR] = ACTIONS(1560),
    [anon_sym_print] = ACTIONS(1562),
    [anon_sym_assert] = ACTIONS(1562),
    [anon_sym_return] = ACTIONS(1562),
    [anon_sym_del] = ACTIONS(1562),
    [anon_sym_raise] = ACTIONS(1562),
    [anon_sym_pass] = ACTIONS(1562),
    [anon_sym_break] = ACTIONS(1562),
    [anon_sym_continue] = ACTIONS(1562),
    [anon_sym_if] = ACTIONS(1562),
    [anon_sym_match] = ACTIONS(1562),
    [anon_sym_async] = ACTIONS(1562),
    [anon_sym_for] = ACTIONS(1562),
    [anon_sym_while] = ACTIONS(1562),
    [anon_sym_try] = ACTIONS(1562),
    [anon_sym_with] = ACTIONS(1562),
    [anon_sym_def] = ACTIONS(1562),
    [anon_sym_global] = ACTIONS(1562),
    [anon_sym_nonlocal] = ACTIONS(1562),
    [anon_sym_exec] = ACTIONS(1562),
    [anon_sym_type] = ACTIONS(1562),
    [anon_sym_class] = ACTIONS(1562),
    [anon_sym_LBRACK] = ACTIONS(1560),
    [anon_sym_AT] = ACTIONS(1560),
    [anon_sym_DASH] = ACTIONS(1560),
    [anon_sym_LBRACE] = ACTIONS(1560),
    [anon_sym_PLUS] = ACTIONS(1560),
    [anon_sym_not] = ACTIONS(1562),
    [anon_sym_TILDE] = ACTIONS(1560),
    [anon_sym_lambda] = ACTIONS(1562),
    [anon_sym_yield] = ACTIONS(1562),
    [sym_ellipsis] = ACTIONS(1560),
    [sym_integer] = ACTIONS(1562),
    [sym_float] = ACTIONS(1560),
    [anon_sym_await] = ACTIONS(1562),
    [sym_true] = ACTIONS(1562),
    [sym_false] = ACTIONS(1562),
    [sym_none] = ACTIONS(1562),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1562),
    [anon_sym_container] = ACTIONS(1562),
    [anon_sym_envvars] = ACTIONS(1562),
    [anon_sym_include] = ACTIONS(1562),
    [anon_sym_pepfile] = ACTIONS(1562),
    [anon_sym_pepschema] = ACTIONS(1562),
    [anon_sym_scattergather] = ACTIONS(1562),
    [anon_sym_version] = ACTIONS(1562),
    [anon_sym_wildcard_constraints] = ACTIONS(1562),
    [anon_sym_workdir] = ACTIONS(1562),
    [anon_sym_onerror] = ACTIONS(1562),
    [anon_sym_onstart] = ACTIONS(1562),
    [anon_sym_onsuccess] = ACTIONS(1562),
    [anon_sym_localrules] = ACTIONS(1562),
    [anon_sym_ruleorder] = ACTIONS(1562),
    [anon_sym_rule] = ACTIONS(1562),
    [anon_sym_checkpoint] = ACTIONS(1562),
    [anon_sym_use] = ACTIONS(1562),
    [anon_sym_module] = ACTIONS(1562),
    [sym__dedent] = ACTIONS(1560),
    [sym_string_start] = ACTIONS(1560),
  },
  [503] = {
    [ts_builtin_sym_end] = ACTIONS(1028),
    [sym_identifier] = ACTIONS(1026),
    [anon_sym_import] = ACTIONS(1026),
    [anon_sym_from] = ACTIONS(1026),
    [anon_sym_LPAREN] = ACTIONS(1028),
    [anon_sym_STAR] = ACTIONS(1028),
    [anon_sym_print] = ACTIONS(1026),
    [anon_sym_assert] = ACTIONS(1026),
    [anon_sym_return] = ACTIONS(1026),
    [anon_sym_del] = ACTIONS(1026),
    [anon_sym_raise] = ACTIONS(1026),
    [anon_sym_pass] = ACTIONS(1026),
    [anon_sym_break] = ACTIONS(1026),
    [anon_sym_continue] = ACTIONS(1026),
    [anon_sym_if] = ACTIONS(1026),
    [anon_sym_match] = ACTIONS(1026),
    [anon_sym_async] = ACTIONS(1026),
    [anon_sym_for] = ACTIONS(1026),
    [anon_sym_while] = ACTIONS(1026),
    [anon_sym_try] = ACTIONS(1026),
    [anon_sym_with] = ACTIONS(1026),
    [anon_sym_def] = ACTIONS(1026),
    [anon_sym_global] = ACTIONS(1026),
    [anon_sym_nonlocal] = ACTIONS(1026),
    [anon_sym_exec] = ACTIONS(1026),
    [anon_sym_type] = ACTIONS(1026),
    [anon_sym_class] = ACTIONS(1026),
    [anon_sym_LBRACK] = ACTIONS(1028),
    [anon_sym_AT] = ACTIONS(1028),
    [anon_sym_DASH] = ACTIONS(1028),
    [anon_sym_LBRACE] = ACTIONS(1028),
    [anon_sym_PLUS] = ACTIONS(1028),
    [anon_sym_not] = ACTIONS(1026),
    [anon_sym_TILDE] = ACTIONS(1028),
    [anon_sym_lambda] = ACTIONS(1026),
    [anon_sym_yield] = ACTIONS(1026),
    [sym_ellipsis] = ACTIONS(1028),
    [sym_integer] = ACTIONS(1026),
    [sym_float] = ACTIONS(1028),
    [anon_sym_await] = ACTIONS(1026),
    [sym_true] = ACTIONS(1026),
    [sym_false] = ACTIONS(1026),
    [sym_none] = ACTIONS(1026),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1026),
    [anon_sym_container] = ACTIONS(1026),
    [anon_sym_envvars] = ACTIONS(1026),
    [anon_sym_include] = ACTIONS(1026),
    [anon_sym_pepfile] = ACTIONS(1026),
    [anon_sym_pepschema] = ACTIONS(1026),
    [anon_sym_scattergather] = ACTIONS(1026),
    [anon_sym_version] = ACTIONS(1026),
    [anon_sym_wildcard_constraints] = ACTIONS(1026),
    [anon_sym_workdir] = ACTIONS(1026),
    [anon_sym_onerror] = ACTIONS(1026),
    [anon_sym_onstart] = ACTIONS(1026),
    [anon_sym_onsuccess] = ACTIONS(1026),
    [anon_sym_localrules] = ACTIONS(1026),
    [anon_sym_ruleorder] = ACTIONS(1026),
    [anon_sym_rule] = ACTIONS(1026),
    [anon_sym_checkpoint] = ACTIONS(1026),
    [anon_sym_use] = ACTIONS(1026),
    [anon_sym_module] = ACTIONS(1026),
    [sym_string_start] = ACTIONS(1028),
  },
  [504] = {
    [ts_builtin_sym_end] = ACTIONS(1578),
    [sym_identifier] = ACTIONS(1576),
    [anon_sym_import] = ACTIONS(1576),
    [anon_sym_from] = ACTIONS(1576),
    [anon_sym_LPAREN] = ACTIONS(1578),
    [anon_sym_STAR] = ACTIONS(1578),
    [anon_sym_print] = ACTIONS(1576),
    [anon_sym_assert] = ACTIONS(1576),
    [anon_sym_return] = ACTIONS(1576),
    [anon_sym_del] = ACTIONS(1576),
    [anon_sym_raise] = ACTIONS(1576),
    [anon_sym_pass] = ACTIONS(1576),
    [anon_sym_break] = ACTIONS(1576),
    [anon_sym_continue] = ACTIONS(1576),
    [anon_sym_if] = ACTIONS(1576),
    [anon_sym_match] = ACTIONS(1576),
    [anon_sym_async] = ACTIONS(1576),
    [anon_sym_for] = ACTIONS(1576),
    [anon_sym_while] = ACTIONS(1576),
    [anon_sym_try] = ACTIONS(1576),
    [anon_sym_with] = ACTIONS(1576),
    [anon_sym_def] = ACTIONS(1576),
    [anon_sym_global] = ACTIONS(1576),
    [anon_sym_nonlocal] = ACTIONS(1576),
    [anon_sym_exec] = ACTIONS(1576),
    [anon_sym_type] = ACTIONS(1576),
    [anon_sym_class] = ACTIONS(1576),
    [anon_sym_LBRACK] = ACTIONS(1578),
    [anon_sym_AT] = ACTIONS(1578),
    [anon_sym_DASH] = ACTIONS(1578),
    [anon_sym_LBRACE] = ACTIONS(1578),
    [anon_sym_PLUS] = ACTIONS(1578),
    [anon_sym_not] = ACTIONS(1576),
    [anon_sym_TILDE] = ACTIONS(1578),
    [anon_sym_lambda] = ACTIONS(1576),
    [anon_sym_yield] = ACTIONS(1576),
    [sym_ellipsis] = ACTIONS(1578),
    [sym_integer] = ACTIONS(1576),
    [sym_float] = ACTIONS(1578),
    [anon_sym_await] = ACTIONS(1576),
    [sym_true] = ACTIONS(1576),
    [sym_false] = ACTIONS(1576),
    [sym_none] = ACTIONS(1576),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1576),
    [anon_sym_container] = ACTIONS(1576),
    [anon_sym_envvars] = ACTIONS(1576),
    [anon_sym_include] = ACTIONS(1576),
    [anon_sym_pepfile] = ACTIONS(1576),
    [anon_sym_pepschema] = ACTIONS(1576),
    [anon_sym_scattergather] = ACTIONS(1576),
    [anon_sym_version] = ACTIONS(1576),
    [anon_sym_wildcard_constraints] = ACTIONS(1576),
    [anon_sym_workdir] = ACTIONS(1576),
    [anon_sym_onerror] = ACTIONS(1576),
    [anon_sym_onstart] = ACTIONS(1576),
    [anon_sym_onsuccess] = ACTIONS(1576),
    [anon_sym_localrules] = ACTIONS(1576),
    [anon_sym_ruleorder] = ACTIONS(1576),
    [anon_sym_rule] = ACTIONS(1576),
    [anon_sym_checkpoint] = ACTIONS(1576),
    [anon_sym_use] = ACTIONS(1576),
    [anon_sym_module] = ACTIONS(1576),
    [sym_string_start] = ACTIONS(1578),
  },
  [505] = {
    [ts_builtin_sym_end] = ACTIONS(1570),
    [sym_identifier] = ACTIONS(1568),
    [anon_sym_import] = ACTIONS(1568),
    [anon_sym_from] = ACTIONS(1568),
    [anon_sym_LPAREN] = ACTIONS(1570),
    [anon_sym_STAR] = ACTIONS(1570),
    [anon_sym_print] = ACTIONS(1568),
    [anon_sym_assert] = ACTIONS(1568),
    [anon_sym_return] = ACTIONS(1568),
    [anon_sym_del] = ACTIONS(1568),
    [anon_sym_raise] = ACTIONS(1568),
    [anon_sym_pass] = ACTIONS(1568),
    [anon_sym_break] = ACTIONS(1568),
    [anon_sym_continue] = ACTIONS(1568),
    [anon_sym_if] = ACTIONS(1568),
    [anon_sym_match] = ACTIONS(1568),
    [anon_sym_async] = ACTIONS(1568),
    [anon_sym_for] = ACTIONS(1568),
    [anon_sym_while] = ACTIONS(1568),
    [anon_sym_try] = ACTIONS(1568),
    [anon_sym_with] = ACTIONS(1568),
    [anon_sym_def] = ACTIONS(1568),
    [anon_sym_global] = ACTIONS(1568),
    [anon_sym_nonlocal] = ACTIONS(1568),
    [anon_sym_exec] = ACTIONS(1568),
    [anon_sym_type] = ACTIONS(1568),
    [anon_sym_class] = ACTIONS(1568),
    [anon_sym_LBRACK] = ACTIONS(1570),
    [anon_sym_AT] = ACTIONS(1570),
    [anon_sym_DASH] = ACTIONS(1570),
    [anon_sym_LBRACE] = ACTIONS(1570),
    [anon_sym_PLUS] = ACTIONS(1570),
    [anon_sym_not] = ACTIONS(1568),
    [anon_sym_TILDE] = ACTIONS(1570),
    [anon_sym_lambda] = ACTIONS(1568),
    [anon_sym_yield] = ACTIONS(1568),
    [sym_ellipsis] = ACTIONS(1570),
    [sym_integer] = ACTIONS(1568),
    [sym_float] = ACTIONS(1570),
    [anon_sym_await] = ACTIONS(1568),
    [sym_true] = ACTIONS(1568),
    [sym_false] = ACTIONS(1568),
    [sym_none] = ACTIONS(1568),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1568),
    [anon_sym_container] = ACTIONS(1568),
    [anon_sym_envvars] = ACTIONS(1568),
    [anon_sym_include] = ACTIONS(1568),
    [anon_sym_pepfile] = ACTIONS(1568),
    [anon_sym_pepschema] = ACTIONS(1568),
    [anon_sym_scattergather] = ACTIONS(1568),
    [anon_sym_version] = ACTIONS(1568),
    [anon_sym_wildcard_constraints] = ACTIONS(1568),
    [anon_sym_workdir] = ACTIONS(1568),
    [anon_sym_onerror] = ACTIONS(1568),
    [anon_sym_onstart] = ACTIONS(1568),
    [anon_sym_onsuccess] = ACTIONS(1568),
    [anon_sym_localrules] = ACTIONS(1568),
    [anon_sym_ruleorder] = ACTIONS(1568),
    [anon_sym_rule] = ACTIONS(1568),
    [anon_sym_checkpoint] = ACTIONS(1568),
    [anon_sym_use] = ACTIONS(1568),
    [anon_sym_module] = ACTIONS(1568),
    [sym_string_start] = ACTIONS(1570),
  },
  [506] = {
    [sym_identifier] = ACTIONS(1558),
    [anon_sym_import] = ACTIONS(1558),
    [anon_sym_from] = ACTIONS(1558),
    [anon_sym_LPAREN] = ACTIONS(1556),
    [anon_sym_STAR] = ACTIONS(1556),
    [anon_sym_print] = ACTIONS(1558),
    [anon_sym_assert] = ACTIONS(1558),
    [anon_sym_return] = ACTIONS(1558),
    [anon_sym_del] = ACTIONS(1558),
    [anon_sym_raise] = ACTIONS(1558),
    [anon_sym_pass] = ACTIONS(1558),
    [anon_sym_break] = ACTIONS(1558),
    [anon_sym_continue] = ACTIONS(1558),
    [anon_sym_if] = ACTIONS(1558),
    [anon_sym_match] = ACTIONS(1558),
    [anon_sym_async] = ACTIONS(1558),
    [anon_sym_for] = ACTIONS(1558),
    [anon_sym_while] = ACTIONS(1558),
    [anon_sym_try] = ACTIONS(1558),
    [anon_sym_with] = ACTIONS(1558),
    [anon_sym_def] = ACTIONS(1558),
    [anon_sym_global] = ACTIONS(1558),
    [anon_sym_nonlocal] = ACTIONS(1558),
    [anon_sym_exec] = ACTIONS(1558),
    [anon_sym_type] = ACTIONS(1558),
    [anon_sym_class] = ACTIONS(1558),
    [anon_sym_LBRACK] = ACTIONS(1556),
    [anon_sym_AT] = ACTIONS(1556),
    [anon_sym_DASH] = ACTIONS(1556),
    [anon_sym_LBRACE] = ACTIONS(1556),
    [anon_sym_PLUS] = ACTIONS(1556),
    [anon_sym_not] = ACTIONS(1558),
    [anon_sym_TILDE] = ACTIONS(1556),
    [anon_sym_lambda] = ACTIONS(1558),
    [anon_sym_yield] = ACTIONS(1558),
    [sym_ellipsis] = ACTIONS(1556),
    [sym_integer] = ACTIONS(1558),
    [sym_float] = ACTIONS(1556),
    [anon_sym_await] = ACTIONS(1558),
    [sym_true] = ACTIONS(1558),
    [sym_false] = ACTIONS(1558),
    [sym_none] = ACTIONS(1558),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1558),
    [anon_sym_container] = ACTIONS(1558),
    [anon_sym_envvars] = ACTIONS(1558),
    [anon_sym_include] = ACTIONS(1558),
    [anon_sym_pepfile] = ACTIONS(1558),
    [anon_sym_pepschema] = ACTIONS(1558),
    [anon_sym_scattergather] = ACTIONS(1558),
    [anon_sym_version] = ACTIONS(1558),
    [anon_sym_wildcard_constraints] = ACTIONS(1558),
    [anon_sym_workdir] = ACTIONS(1558),
    [anon_sym_onerror] = ACTIONS(1558),
    [anon_sym_onstart] = ACTIONS(1558),
    [anon_sym_onsuccess] = ACTIONS(1558),
    [anon_sym_localrules] = ACTIONS(1558),
    [anon_sym_ruleorder] = ACTIONS(1558),
    [anon_sym_rule] = ACTIONS(1558),
    [anon_sym_checkpoint] = ACTIONS(1558),
    [anon_sym_use] = ACTIONS(1558),
    [anon_sym_module] = ACTIONS(1558),
    [sym__dedent] = ACTIONS(1556),
    [sym_string_start] = ACTIONS(1556),
  },
  [507] = {
    [ts_builtin_sym_end] = ACTIONS(1566),
    [sym_identifier] = ACTIONS(1564),
    [anon_sym_import] = ACTIONS(1564),
    [anon_sym_from] = ACTIONS(1564),
    [anon_sym_LPAREN] = ACTIONS(1566),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_print] = ACTIONS(1564),
    [anon_sym_assert] = ACTIONS(1564),
    [anon_sym_return] = ACTIONS(1564),
    [anon_sym_del] = ACTIONS(1564),
    [anon_sym_raise] = ACTIONS(1564),
    [anon_sym_pass] = ACTIONS(1564),
    [anon_sym_break] = ACTIONS(1564),
    [anon_sym_continue] = ACTIONS(1564),
    [anon_sym_if] = ACTIONS(1564),
    [anon_sym_match] = ACTIONS(1564),
    [anon_sym_async] = ACTIONS(1564),
    [anon_sym_for] = ACTIONS(1564),
    [anon_sym_while] = ACTIONS(1564),
    [anon_sym_try] = ACTIONS(1564),
    [anon_sym_with] = ACTIONS(1564),
    [anon_sym_def] = ACTIONS(1564),
    [anon_sym_global] = ACTIONS(1564),
    [anon_sym_nonlocal] = ACTIONS(1564),
    [anon_sym_exec] = ACTIONS(1564),
    [anon_sym_type] = ACTIONS(1564),
    [anon_sym_class] = ACTIONS(1564),
    [anon_sym_LBRACK] = ACTIONS(1566),
    [anon_sym_AT] = ACTIONS(1566),
    [anon_sym_DASH] = ACTIONS(1566),
    [anon_sym_LBRACE] = ACTIONS(1566),
    [anon_sym_PLUS] = ACTIONS(1566),
    [anon_sym_not] = ACTIONS(1564),
    [anon_sym_TILDE] = ACTIONS(1566),
    [anon_sym_lambda] = ACTIONS(1564),
    [anon_sym_yield] = ACTIONS(1564),
    [sym_ellipsis] = ACTIONS(1566),
    [sym_integer] = ACTIONS(1564),
    [sym_float] = ACTIONS(1566),
    [anon_sym_await] = ACTIONS(1564),
    [sym_true] = ACTIONS(1564),
    [sym_false] = ACTIONS(1564),
    [sym_none] = ACTIONS(1564),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1564),
    [anon_sym_container] = ACTIONS(1564),
    [anon_sym_envvars] = ACTIONS(1564),
    [anon_sym_include] = ACTIONS(1564),
    [anon_sym_pepfile] = ACTIONS(1564),
    [anon_sym_pepschema] = ACTIONS(1564),
    [anon_sym_scattergather] = ACTIONS(1564),
    [anon_sym_version] = ACTIONS(1564),
    [anon_sym_wildcard_constraints] = ACTIONS(1564),
    [anon_sym_workdir] = ACTIONS(1564),
    [anon_sym_onerror] = ACTIONS(1564),
    [anon_sym_onstart] = ACTIONS(1564),
    [anon_sym_onsuccess] = ACTIONS(1564),
    [anon_sym_localrules] = ACTIONS(1564),
    [anon_sym_ruleorder] = ACTIONS(1564),
    [anon_sym_rule] = ACTIONS(1564),
    [anon_sym_checkpoint] = ACTIONS(1564),
    [anon_sym_use] = ACTIONS(1564),
    [anon_sym_module] = ACTIONS(1564),
    [sym_string_start] = ACTIONS(1566),
  },
  [508] = {
    [ts_builtin_sym_end] = ACTIONS(1554),
    [sym_identifier] = ACTIONS(1552),
    [anon_sym_import] = ACTIONS(1552),
    [anon_sym_from] = ACTIONS(1552),
    [anon_sym_LPAREN] = ACTIONS(1554),
    [anon_sym_STAR] = ACTIONS(1554),
    [anon_sym_print] = ACTIONS(1552),
    [anon_sym_assert] = ACTIONS(1552),
    [anon_sym_return] = ACTIONS(1552),
    [anon_sym_del] = ACTIONS(1552),
    [anon_sym_raise] = ACTIONS(1552),
    [anon_sym_pass] = ACTIONS(1552),
    [anon_sym_break] = ACTIONS(1552),
    [anon_sym_continue] = ACTIONS(1552),
    [anon_sym_if] = ACTIONS(1552),
    [anon_sym_match] = ACTIONS(1552),
    [anon_sym_async] = ACTIONS(1552),
    [anon_sym_for] = ACTIONS(1552),
    [anon_sym_while] = ACTIONS(1552),
    [anon_sym_try] = ACTIONS(1552),
    [anon_sym_with] = ACTIONS(1552),
    [anon_sym_def] = ACTIONS(1552),
    [anon_sym_global] = ACTIONS(1552),
    [anon_sym_nonlocal] = ACTIONS(1552),
    [anon_sym_exec] = ACTIONS(1552),
    [anon_sym_type] = ACTIONS(1552),
    [anon_sym_class] = ACTIONS(1552),
    [anon_sym_LBRACK] = ACTIONS(1554),
    [anon_sym_AT] = ACTIONS(1554),
    [anon_sym_DASH] = ACTIONS(1554),
    [anon_sym_LBRACE] = ACTIONS(1554),
    [anon_sym_PLUS] = ACTIONS(1554),
    [anon_sym_not] = ACTIONS(1552),
    [anon_sym_TILDE] = ACTIONS(1554),
    [anon_sym_lambda] = ACTIONS(1552),
    [anon_sym_yield] = ACTIONS(1552),
    [sym_ellipsis] = ACTIONS(1554),
    [sym_integer] = ACTIONS(1552),
    [sym_float] = ACTIONS(1554),
    [anon_sym_await] = ACTIONS(1552),
    [sym_true] = ACTIONS(1552),
    [sym_false] = ACTIONS(1552),
    [sym_none] = ACTIONS(1552),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1552),
    [anon_sym_container] = ACTIONS(1552),
    [anon_sym_envvars] = ACTIONS(1552),
    [anon_sym_include] = ACTIONS(1552),
    [anon_sym_pepfile] = ACTIONS(1552),
    [anon_sym_pepschema] = ACTIONS(1552),
    [anon_sym_scattergather] = ACTIONS(1552),
    [anon_sym_version] = ACTIONS(1552),
    [anon_sym_wildcard_constraints] = ACTIONS(1552),
    [anon_sym_workdir] = ACTIONS(1552),
    [anon_sym_onerror] = ACTIONS(1552),
    [anon_sym_onstart] = ACTIONS(1552),
    [anon_sym_onsuccess] = ACTIONS(1552),
    [anon_sym_localrules] = ACTIONS(1552),
    [anon_sym_ruleorder] = ACTIONS(1552),
    [anon_sym_rule] = ACTIONS(1552),
    [anon_sym_checkpoint] = ACTIONS(1552),
    [anon_sym_use] = ACTIONS(1552),
    [anon_sym_module] = ACTIONS(1552),
    [sym_string_start] = ACTIONS(1554),
  },
  [509] = {
    [ts_builtin_sym_end] = ACTIONS(1534),
    [sym_identifier] = ACTIONS(1532),
    [anon_sym_import] = ACTIONS(1532),
    [anon_sym_from] = ACTIONS(1532),
    [anon_sym_LPAREN] = ACTIONS(1534),
    [anon_sym_STAR] = ACTIONS(1534),
    [anon_sym_print] = ACTIONS(1532),
    [anon_sym_assert] = ACTIONS(1532),
    [anon_sym_return] = ACTIONS(1532),
    [anon_sym_del] = ACTIONS(1532),
    [anon_sym_raise] = ACTIONS(1532),
    [anon_sym_pass] = ACTIONS(1532),
    [anon_sym_break] = ACTIONS(1532),
    [anon_sym_continue] = ACTIONS(1532),
    [anon_sym_if] = ACTIONS(1532),
    [anon_sym_match] = ACTIONS(1532),
    [anon_sym_async] = ACTIONS(1532),
    [anon_sym_for] = ACTIONS(1532),
    [anon_sym_while] = ACTIONS(1532),
    [anon_sym_try] = ACTIONS(1532),
    [anon_sym_with] = ACTIONS(1532),
    [anon_sym_def] = ACTIONS(1532),
    [anon_sym_global] = ACTIONS(1532),
    [anon_sym_nonlocal] = ACTIONS(1532),
    [anon_sym_exec] = ACTIONS(1532),
    [anon_sym_type] = ACTIONS(1532),
    [anon_sym_class] = ACTIONS(1532),
    [anon_sym_LBRACK] = ACTIONS(1534),
    [anon_sym_AT] = ACTIONS(1534),
    [anon_sym_DASH] = ACTIONS(1534),
    [anon_sym_LBRACE] = ACTIONS(1534),
    [anon_sym_PLUS] = ACTIONS(1534),
    [anon_sym_not] = ACTIONS(1532),
    [anon_sym_TILDE] = ACTIONS(1534),
    [anon_sym_lambda] = ACTIONS(1532),
    [anon_sym_yield] = ACTIONS(1532),
    [sym_ellipsis] = ACTIONS(1534),
    [sym_integer] = ACTIONS(1532),
    [sym_float] = ACTIONS(1534),
    [anon_sym_await] = ACTIONS(1532),
    [sym_true] = ACTIONS(1532),
    [sym_false] = ACTIONS(1532),
    [sym_none] = ACTIONS(1532),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1532),
    [anon_sym_container] = ACTIONS(1532),
    [anon_sym_envvars] = ACTIONS(1532),
    [anon_sym_include] = ACTIONS(1532),
    [anon_sym_pepfile] = ACTIONS(1532),
    [anon_sym_pepschema] = ACTIONS(1532),
    [anon_sym_scattergather] = ACTIONS(1532),
    [anon_sym_version] = ACTIONS(1532),
    [anon_sym_wildcard_constraints] = ACTIONS(1532),
    [anon_sym_workdir] = ACTIONS(1532),
    [anon_sym_onerror] = ACTIONS(1532),
    [anon_sym_onstart] = ACTIONS(1532),
    [anon_sym_onsuccess] = ACTIONS(1532),
    [anon_sym_localrules] = ACTIONS(1532),
    [anon_sym_ruleorder] = ACTIONS(1532),
    [anon_sym_rule] = ACTIONS(1532),
    [anon_sym_checkpoint] = ACTIONS(1532),
    [anon_sym_use] = ACTIONS(1532),
    [anon_sym_module] = ACTIONS(1532),
    [sym_string_start] = ACTIONS(1534),
  },
  [510] = {
    [ts_builtin_sym_end] = ACTIONS(1538),
    [sym_identifier] = ACTIONS(1536),
    [anon_sym_import] = ACTIONS(1536),
    [anon_sym_from] = ACTIONS(1536),
    [anon_sym_LPAREN] = ACTIONS(1538),
    [anon_sym_STAR] = ACTIONS(1538),
    [anon_sym_print] = ACTIONS(1536),
    [anon_sym_assert] = ACTIONS(1536),
    [anon_sym_return] = ACTIONS(1536),
    [anon_sym_del] = ACTIONS(1536),
    [anon_sym_raise] = ACTIONS(1536),
    [anon_sym_pass] = ACTIONS(1536),
    [anon_sym_break] = ACTIONS(1536),
    [anon_sym_continue] = ACTIONS(1536),
    [anon_sym_if] = ACTIONS(1536),
    [anon_sym_match] = ACTIONS(1536),
    [anon_sym_async] = ACTIONS(1536),
    [anon_sym_for] = ACTIONS(1536),
    [anon_sym_while] = ACTIONS(1536),
    [anon_sym_try] = ACTIONS(1536),
    [anon_sym_with] = ACTIONS(1536),
    [anon_sym_def] = ACTIONS(1536),
    [anon_sym_global] = ACTIONS(1536),
    [anon_sym_nonlocal] = ACTIONS(1536),
    [anon_sym_exec] = ACTIONS(1536),
    [anon_sym_type] = ACTIONS(1536),
    [anon_sym_class] = ACTIONS(1536),
    [anon_sym_LBRACK] = ACTIONS(1538),
    [anon_sym_AT] = ACTIONS(1538),
    [anon_sym_DASH] = ACTIONS(1538),
    [anon_sym_LBRACE] = ACTIONS(1538),
    [anon_sym_PLUS] = ACTIONS(1538),
    [anon_sym_not] = ACTIONS(1536),
    [anon_sym_TILDE] = ACTIONS(1538),
    [anon_sym_lambda] = ACTIONS(1536),
    [anon_sym_yield] = ACTIONS(1536),
    [sym_ellipsis] = ACTIONS(1538),
    [sym_integer] = ACTIONS(1536),
    [sym_float] = ACTIONS(1538),
    [anon_sym_await] = ACTIONS(1536),
    [sym_true] = ACTIONS(1536),
    [sym_false] = ACTIONS(1536),
    [sym_none] = ACTIONS(1536),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1536),
    [anon_sym_container] = ACTIONS(1536),
    [anon_sym_envvars] = ACTIONS(1536),
    [anon_sym_include] = ACTIONS(1536),
    [anon_sym_pepfile] = ACTIONS(1536),
    [anon_sym_pepschema] = ACTIONS(1536),
    [anon_sym_scattergather] = ACTIONS(1536),
    [anon_sym_version] = ACTIONS(1536),
    [anon_sym_wildcard_constraints] = ACTIONS(1536),
    [anon_sym_workdir] = ACTIONS(1536),
    [anon_sym_onerror] = ACTIONS(1536),
    [anon_sym_onstart] = ACTIONS(1536),
    [anon_sym_onsuccess] = ACTIONS(1536),
    [anon_sym_localrules] = ACTIONS(1536),
    [anon_sym_ruleorder] = ACTIONS(1536),
    [anon_sym_rule] = ACTIONS(1536),
    [anon_sym_checkpoint] = ACTIONS(1536),
    [anon_sym_use] = ACTIONS(1536),
    [anon_sym_module] = ACTIONS(1536),
    [sym_string_start] = ACTIONS(1538),
  },
  [511] = {
    [ts_builtin_sym_end] = ACTIONS(1542),
    [sym_identifier] = ACTIONS(1540),
    [anon_sym_import] = ACTIONS(1540),
    [anon_sym_from] = ACTIONS(1540),
    [anon_sym_LPAREN] = ACTIONS(1542),
    [anon_sym_STAR] = ACTIONS(1542),
    [anon_sym_print] = ACTIONS(1540),
    [anon_sym_assert] = ACTIONS(1540),
    [anon_sym_return] = ACTIONS(1540),
    [anon_sym_del] = ACTIONS(1540),
    [anon_sym_raise] = ACTIONS(1540),
    [anon_sym_pass] = ACTIONS(1540),
    [anon_sym_break] = ACTIONS(1540),
    [anon_sym_continue] = ACTIONS(1540),
    [anon_sym_if] = ACTIONS(1540),
    [anon_sym_match] = ACTIONS(1540),
    [anon_sym_async] = ACTIONS(1540),
    [anon_sym_for] = ACTIONS(1540),
    [anon_sym_while] = ACTIONS(1540),
    [anon_sym_try] = ACTIONS(1540),
    [anon_sym_with] = ACTIONS(1540),
    [anon_sym_def] = ACTIONS(1540),
    [anon_sym_global] = ACTIONS(1540),
    [anon_sym_nonlocal] = ACTIONS(1540),
    [anon_sym_exec] = ACTIONS(1540),
    [anon_sym_type] = ACTIONS(1540),
    [anon_sym_class] = ACTIONS(1540),
    [anon_sym_LBRACK] = ACTIONS(1542),
    [anon_sym_AT] = ACTIONS(1542),
    [anon_sym_DASH] = ACTIONS(1542),
    [anon_sym_LBRACE] = ACTIONS(1542),
    [anon_sym_PLUS] = ACTIONS(1542),
    [anon_sym_not] = ACTIONS(1540),
    [anon_sym_TILDE] = ACTIONS(1542),
    [anon_sym_lambda] = ACTIONS(1540),
    [anon_sym_yield] = ACTIONS(1540),
    [sym_ellipsis] = ACTIONS(1542),
    [sym_integer] = ACTIONS(1540),
    [sym_float] = ACTIONS(1542),
    [anon_sym_await] = ACTIONS(1540),
    [sym_true] = ACTIONS(1540),
    [sym_false] = ACTIONS(1540),
    [sym_none] = ACTIONS(1540),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1540),
    [anon_sym_container] = ACTIONS(1540),
    [anon_sym_envvars] = ACTIONS(1540),
    [anon_sym_include] = ACTIONS(1540),
    [anon_sym_pepfile] = ACTIONS(1540),
    [anon_sym_pepschema] = ACTIONS(1540),
    [anon_sym_scattergather] = ACTIONS(1540),
    [anon_sym_version] = ACTIONS(1540),
    [anon_sym_wildcard_constraints] = ACTIONS(1540),
    [anon_sym_workdir] = ACTIONS(1540),
    [anon_sym_onerror] = ACTIONS(1540),
    [anon_sym_onstart] = ACTIONS(1540),
    [anon_sym_onsuccess] = ACTIONS(1540),
    [anon_sym_localrules] = ACTIONS(1540),
    [anon_sym_ruleorder] = ACTIONS(1540),
    [anon_sym_rule] = ACTIONS(1540),
    [anon_sym_checkpoint] = ACTIONS(1540),
    [anon_sym_use] = ACTIONS(1540),
    [anon_sym_module] = ACTIONS(1540),
    [sym_string_start] = ACTIONS(1542),
  },
  [512] = {
    [sym_identifier] = ACTIONS(1550),
    [anon_sym_import] = ACTIONS(1550),
    [anon_sym_from] = ACTIONS(1550),
    [anon_sym_LPAREN] = ACTIONS(1548),
    [anon_sym_STAR] = ACTIONS(1548),
    [anon_sym_print] = ACTIONS(1550),
    [anon_sym_assert] = ACTIONS(1550),
    [anon_sym_return] = ACTIONS(1550),
    [anon_sym_del] = ACTIONS(1550),
    [anon_sym_raise] = ACTIONS(1550),
    [anon_sym_pass] = ACTIONS(1550),
    [anon_sym_break] = ACTIONS(1550),
    [anon_sym_continue] = ACTIONS(1550),
    [anon_sym_if] = ACTIONS(1550),
    [anon_sym_match] = ACTIONS(1550),
    [anon_sym_async] = ACTIONS(1550),
    [anon_sym_for] = ACTIONS(1550),
    [anon_sym_while] = ACTIONS(1550),
    [anon_sym_try] = ACTIONS(1550),
    [anon_sym_with] = ACTIONS(1550),
    [anon_sym_def] = ACTIONS(1550),
    [anon_sym_global] = ACTIONS(1550),
    [anon_sym_nonlocal] = ACTIONS(1550),
    [anon_sym_exec] = ACTIONS(1550),
    [anon_sym_type] = ACTIONS(1550),
    [anon_sym_class] = ACTIONS(1550),
    [anon_sym_LBRACK] = ACTIONS(1548),
    [anon_sym_AT] = ACTIONS(1548),
    [anon_sym_DASH] = ACTIONS(1548),
    [anon_sym_LBRACE] = ACTIONS(1548),
    [anon_sym_PLUS] = ACTIONS(1548),
    [anon_sym_not] = ACTIONS(1550),
    [anon_sym_TILDE] = ACTIONS(1548),
    [anon_sym_lambda] = ACTIONS(1550),
    [anon_sym_yield] = ACTIONS(1550),
    [sym_ellipsis] = ACTIONS(1548),
    [sym_integer] = ACTIONS(1550),
    [sym_float] = ACTIONS(1548),
    [anon_sym_await] = ACTIONS(1550),
    [sym_true] = ACTIONS(1550),
    [sym_false] = ACTIONS(1550),
    [sym_none] = ACTIONS(1550),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1550),
    [anon_sym_container] = ACTIONS(1550),
    [anon_sym_envvars] = ACTIONS(1550),
    [anon_sym_include] = ACTIONS(1550),
    [anon_sym_pepfile] = ACTIONS(1550),
    [anon_sym_pepschema] = ACTIONS(1550),
    [anon_sym_scattergather] = ACTIONS(1550),
    [anon_sym_version] = ACTIONS(1550),
    [anon_sym_wildcard_constraints] = ACTIONS(1550),
    [anon_sym_workdir] = ACTIONS(1550),
    [anon_sym_onerror] = ACTIONS(1550),
    [anon_sym_onstart] = ACTIONS(1550),
    [anon_sym_onsuccess] = ACTIONS(1550),
    [anon_sym_localrules] = ACTIONS(1550),
    [anon_sym_ruleorder] = ACTIONS(1550),
    [anon_sym_rule] = ACTIONS(1550),
    [anon_sym_checkpoint] = ACTIONS(1550),
    [anon_sym_use] = ACTIONS(1550),
    [anon_sym_module] = ACTIONS(1550),
    [sym__dedent] = ACTIONS(1548),
    [sym_string_start] = ACTIONS(1548),
  },
  [513] = {
    [ts_builtin_sym_end] = ACTIONS(1494),
    [sym_identifier] = ACTIONS(1492),
    [anon_sym_import] = ACTIONS(1492),
    [anon_sym_from] = ACTIONS(1492),
    [anon_sym_LPAREN] = ACTIONS(1494),
    [anon_sym_STAR] = ACTIONS(1494),
    [anon_sym_print] = ACTIONS(1492),
    [anon_sym_assert] = ACTIONS(1492),
    [anon_sym_return] = ACTIONS(1492),
    [anon_sym_del] = ACTIONS(1492),
    [anon_sym_raise] = ACTIONS(1492),
    [anon_sym_pass] = ACTIONS(1492),
    [anon_sym_break] = ACTIONS(1492),
    [anon_sym_continue] = ACTIONS(1492),
    [anon_sym_if] = ACTIONS(1492),
    [anon_sym_match] = ACTIONS(1492),
    [anon_sym_async] = ACTIONS(1492),
    [anon_sym_for] = ACTIONS(1492),
    [anon_sym_while] = ACTIONS(1492),
    [anon_sym_try] = ACTIONS(1492),
    [anon_sym_with] = ACTIONS(1492),
    [anon_sym_def] = ACTIONS(1492),
    [anon_sym_global] = ACTIONS(1492),
    [anon_sym_nonlocal] = ACTIONS(1492),
    [anon_sym_exec] = ACTIONS(1492),
    [anon_sym_type] = ACTIONS(1492),
    [anon_sym_class] = ACTIONS(1492),
    [anon_sym_LBRACK] = ACTIONS(1494),
    [anon_sym_AT] = ACTIONS(1494),
    [anon_sym_DASH] = ACTIONS(1494),
    [anon_sym_LBRACE] = ACTIONS(1494),
    [anon_sym_PLUS] = ACTIONS(1494),
    [anon_sym_not] = ACTIONS(1492),
    [anon_sym_TILDE] = ACTIONS(1494),
    [anon_sym_lambda] = ACTIONS(1492),
    [anon_sym_yield] = ACTIONS(1492),
    [sym_ellipsis] = ACTIONS(1494),
    [sym_integer] = ACTIONS(1492),
    [sym_float] = ACTIONS(1494),
    [anon_sym_await] = ACTIONS(1492),
    [sym_true] = ACTIONS(1492),
    [sym_false] = ACTIONS(1492),
    [sym_none] = ACTIONS(1492),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1492),
    [anon_sym_container] = ACTIONS(1492),
    [anon_sym_envvars] = ACTIONS(1492),
    [anon_sym_include] = ACTIONS(1492),
    [anon_sym_pepfile] = ACTIONS(1492),
    [anon_sym_pepschema] = ACTIONS(1492),
    [anon_sym_scattergather] = ACTIONS(1492),
    [anon_sym_version] = ACTIONS(1492),
    [anon_sym_wildcard_constraints] = ACTIONS(1492),
    [anon_sym_workdir] = ACTIONS(1492),
    [anon_sym_onerror] = ACTIONS(1492),
    [anon_sym_onstart] = ACTIONS(1492),
    [anon_sym_onsuccess] = ACTIONS(1492),
    [anon_sym_localrules] = ACTIONS(1492),
    [anon_sym_ruleorder] = ACTIONS(1492),
    [anon_sym_rule] = ACTIONS(1492),
    [anon_sym_checkpoint] = ACTIONS(1492),
    [anon_sym_use] = ACTIONS(1492),
    [anon_sym_module] = ACTIONS(1492),
    [sym_string_start] = ACTIONS(1494),
  },
  [514] = {
    [sym_identifier] = ACTIONS(1546),
    [anon_sym_import] = ACTIONS(1546),
    [anon_sym_from] = ACTIONS(1546),
    [anon_sym_LPAREN] = ACTIONS(1544),
    [anon_sym_STAR] = ACTIONS(1544),
    [anon_sym_print] = ACTIONS(1546),
    [anon_sym_assert] = ACTIONS(1546),
    [anon_sym_return] = ACTIONS(1546),
    [anon_sym_del] = ACTIONS(1546),
    [anon_sym_raise] = ACTIONS(1546),
    [anon_sym_pass] = ACTIONS(1546),
    [anon_sym_break] = ACTIONS(1546),
    [anon_sym_continue] = ACTIONS(1546),
    [anon_sym_if] = ACTIONS(1546),
    [anon_sym_match] = ACTIONS(1546),
    [anon_sym_async] = ACTIONS(1546),
    [anon_sym_for] = ACTIONS(1546),
    [anon_sym_while] = ACTIONS(1546),
    [anon_sym_try] = ACTIONS(1546),
    [anon_sym_with] = ACTIONS(1546),
    [anon_sym_def] = ACTIONS(1546),
    [anon_sym_global] = ACTIONS(1546),
    [anon_sym_nonlocal] = ACTIONS(1546),
    [anon_sym_exec] = ACTIONS(1546),
    [anon_sym_type] = ACTIONS(1546),
    [anon_sym_class] = ACTIONS(1546),
    [anon_sym_LBRACK] = ACTIONS(1544),
    [anon_sym_AT] = ACTIONS(1544),
    [anon_sym_DASH] = ACTIONS(1544),
    [anon_sym_LBRACE] = ACTIONS(1544),
    [anon_sym_PLUS] = ACTIONS(1544),
    [anon_sym_not] = ACTIONS(1546),
    [anon_sym_TILDE] = ACTIONS(1544),
    [anon_sym_lambda] = ACTIONS(1546),
    [anon_sym_yield] = ACTIONS(1546),
    [sym_ellipsis] = ACTIONS(1544),
    [sym_integer] = ACTIONS(1546),
    [sym_float] = ACTIONS(1544),
    [anon_sym_await] = ACTIONS(1546),
    [sym_true] = ACTIONS(1546),
    [sym_false] = ACTIONS(1546),
    [sym_none] = ACTIONS(1546),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [anon_sym_configfile] = ACTIONS(1546),
    [anon_sym_container] = ACTIONS(1546),
    [anon_sym_envvars] = ACTIONS(1546),
    [anon_sym_include] = ACTIONS(1546),
    [anon_sym_pepfile] = ACTIONS(1546),
    [anon_sym_pepschema] = ACTIONS(1546),
    [anon_sym_scattergather] = ACTIONS(1546),
    [anon_sym_version] = ACTIONS(1546),
    [anon_sym_wildcard_constraints] = ACTIONS(1546),
    [anon_sym_workdir] = ACTIONS(1546),
    [anon_sym_onerror] = ACTIONS(1546),
    [anon_sym_onstart] = ACTIONS(1546),
    [anon_sym_onsuccess] = ACTIONS(1546),
    [anon_sym_localrules] = ACTIONS(1546),
    [anon_sym_ruleorder] = ACTIONS(1546),
    [anon_sym_rule] = ACTIONS(1546),
    [anon_sym_checkpoint] = ACTIONS(1546),
    [anon_sym_use] = ACTIONS(1546),
    [anon_sym_module] = ACTIONS(1546),
    [sym__dedent] = ACTIONS(1544),
    [sym_string_start] = ACTIONS(1544),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 31,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(1580), 1,
      sym_identifier,
    ACTIONS(1582), 1,
      anon_sym_LPAREN,
    ACTIONS(1584), 1,
      anon_sym_RPAREN,
    ACTIONS(1586), 1,
      anon_sym_STAR,
    ACTIONS(1590), 1,
      anon_sym_type,
    ACTIONS(1592), 1,
      anon_sym_LBRACK,
    ACTIONS(1594), 1,
      anon_sym_not,
    ACTIONS(1596), 1,
      anon_sym_lambda,
    ACTIONS(1598), 1,
      anon_sym_yield,
    ACTIONS(1600), 1,
      anon_sym_await,
    STATE(1271), 1,
      sym_string,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1645), 1,
      sym_list_splat_pattern,
    STATE(2078), 1,
      sym_expression,
    STATE(2685), 1,
      sym_pattern,
    STATE(2792), 1,
      sym_yield,
    STATE(3182), 1,
      sym__patterns,
    STATE(3278), 1,
      sym__collection_elements,
    STATE(3306), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    STATE(1542), 2,
      sym_attribute,
      sym_subscript,
    STATE(2683), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    STATE(3029), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(828), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1588), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2173), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1660), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [126] = 28,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(15), 1,
      anon_sym_LPAREN,
    ACTIONS(17), 1,
      anon_sym_STAR,
    ACTIONS(61), 1,
      anon_sym_LBRACK,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(73), 1,
      anon_sym_yield,
    ACTIONS(79), 1,
      anon_sym_await,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(1602), 1,
      anon_sym_type,
    STATE(1024), 1,
      sym_list_splat_pattern,
    STATE(1200), 1,
      sym_string,
    STATE(1237), 1,
      sym_primary_expression,
    STATE(2009), 1,
      sym_pattern,
    STATE(2010), 1,
      sym_pattern_list,
    STATE(2175), 1,
      sym_expression,
    STATE(3427), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    STATE(1029), 2,
      sym_attribute,
      sym_subscript,
    STATE(2015), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(502), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(3120), 5,
      sym_expression_list,
      sym_assignment,
      sym_augmented_assignment,
      sym__right_hand_side,
      sym_yield,
    STATE(2070), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1312), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [246] = 31,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(1580), 1,
      sym_identifier,
    ACTIONS(1582), 1,
      anon_sym_LPAREN,
    ACTIONS(1586), 1,
      anon_sym_STAR,
    ACTIONS(1590), 1,
      anon_sym_type,
    ACTIONS(1592), 1,
      anon_sym_LBRACK,
    ACTIONS(1594), 1,
      anon_sym_not,
    ACTIONS(1596), 1,
      anon_sym_lambda,
    ACTIONS(1598), 1,
      anon_sym_yield,
    ACTIONS(1600), 1,
      anon_sym_await,
    ACTIONS(1604), 1,
      anon_sym_RPAREN,
    STATE(1271), 1,
      sym_string,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1645), 1,
      sym_list_splat_pattern,
    STATE(2103), 1,
      sym_expression,
    STATE(2685), 1,
      sym_pattern,
    STATE(2986), 1,
      sym_yield,
    STATE(3306), 1,
      sym__named_expression_lhs,
    STATE(3315), 1,
      sym__collection_elements,
    STATE(3414), 1,
      sym__patterns,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    STATE(1542), 2,
      sym_attribute,
      sym_subscript,
    STATE(2683), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    STATE(3029), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(828), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1588), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2173), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1660), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [372] = 30,
    ACTIONS(862), 1,
      anon_sym_LBRACK,
    ACTIONS(866), 1,
      anon_sym_LBRACE,
    ACTIONS(872), 1,
      sym_string_start,
    ACTIONS(1606), 1,
      sym_identifier,
    ACTIONS(1608), 1,
      anon_sym_LPAREN,
    ACTIONS(1610), 1,
      anon_sym_COMMA,
    ACTIONS(1612), 1,
      anon_sym_STAR,
    ACTIONS(1616), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1618), 1,
      anon_sym_type,
    ACTIONS(1620), 1,
      anon_sym_RBRACE,
    ACTIONS(1622), 1,
      anon_sym_not,
    ACTIONS(1624), 1,
      anon_sym_lambda,
    ACTIONS(1626), 1,
      anon_sym_yield,
    ACTIONS(1628), 1,
      anon_sym_await,
    STATE(1220), 1,
      sym_primary_expression,
    STATE(1227), 1,
      sym_string,
    STATE(1504), 1,
      sym_list_splat_pattern,
    STATE(2054), 1,
      sym_expression,
    STATE(2258), 1,
      sym_pair,
    STATE(2803), 1,
      sym_dictionary_splat,
    STATE(3263), 1,
      sym__collection_elements,
    STATE(3456), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(868), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(864), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2823), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(852), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1614), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2165), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [496] = 30,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_string_start,
    ACTIONS(1630), 1,
      sym_identifier,
    ACTIONS(1632), 1,
      anon_sym_LPAREN,
    ACTIONS(1634), 1,
      anon_sym_STAR,
    ACTIONS(1638), 1,
      anon_sym_type,
    ACTIONS(1640), 1,
      anon_sym_LBRACK,
    ACTIONS(1642), 1,
      anon_sym_RBRACK,
    ACTIONS(1644), 1,
      anon_sym_not,
    ACTIONS(1646), 1,
      anon_sym_lambda,
    ACTIONS(1648), 1,
      anon_sym_yield,
    ACTIONS(1650), 1,
      anon_sym_await,
    STATE(1264), 1,
      sym_primary_expression,
    STATE(1279), 1,
      sym_string,
    STATE(1650), 1,
      sym_list_splat_pattern,
    STATE(2075), 1,
      sym_expression,
    STATE(2911), 1,
      sym_pattern,
    STATE(3166), 1,
      sym__collection_elements,
    STATE(3184), 1,
      sym__named_expression_lhs,
    STATE(3270), 1,
      sym__patterns,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(934), 2,
      sym_ellipsis,
      sym_float,
    STATE(1647), 2,
      sym_attribute,
      sym_subscript,
    STATE(3133), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(930), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2912), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(918), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1636), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2189), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1654), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [620] = 30,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_string_start,
    ACTIONS(1630), 1,
      sym_identifier,
    ACTIONS(1632), 1,
      anon_sym_LPAREN,
    ACTIONS(1634), 1,
      anon_sym_STAR,
    ACTIONS(1638), 1,
      anon_sym_type,
    ACTIONS(1640), 1,
      anon_sym_LBRACK,
    ACTIONS(1644), 1,
      anon_sym_not,
    ACTIONS(1646), 1,
      anon_sym_lambda,
    ACTIONS(1648), 1,
      anon_sym_yield,
    ACTIONS(1650), 1,
      anon_sym_await,
    ACTIONS(1652), 1,
      anon_sym_RBRACK,
    STATE(1264), 1,
      sym_primary_expression,
    STATE(1279), 1,
      sym_string,
    STATE(1650), 1,
      sym_list_splat_pattern,
    STATE(2076), 1,
      sym_expression,
    STATE(2911), 1,
      sym_pattern,
    STATE(3184), 1,
      sym__named_expression_lhs,
    STATE(3269), 1,
      sym__collection_elements,
    STATE(3270), 1,
      sym__patterns,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(934), 2,
      sym_ellipsis,
      sym_float,
    STATE(1647), 2,
      sym_attribute,
      sym_subscript,
    STATE(3133), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(930), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2912), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(918), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1636), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2189), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1654), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [744] = 30,
    ACTIONS(862), 1,
      anon_sym_LBRACK,
    ACTIONS(866), 1,
      anon_sym_LBRACE,
    ACTIONS(872), 1,
      sym_string_start,
    ACTIONS(1606), 1,
      sym_identifier,
    ACTIONS(1608), 1,
      anon_sym_LPAREN,
    ACTIONS(1612), 1,
      anon_sym_STAR,
    ACTIONS(1616), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1618), 1,
      anon_sym_type,
    ACTIONS(1622), 1,
      anon_sym_not,
    ACTIONS(1624), 1,
      anon_sym_lambda,
    ACTIONS(1626), 1,
      anon_sym_yield,
    ACTIONS(1628), 1,
      anon_sym_await,
    ACTIONS(1654), 1,
      anon_sym_COMMA,
    ACTIONS(1656), 1,
      anon_sym_RBRACE,
    STATE(1220), 1,
      sym_primary_expression,
    STATE(1227), 1,
      sym_string,
    STATE(1504), 1,
      sym_list_splat_pattern,
    STATE(2059), 1,
      sym_expression,
    STATE(2274), 1,
      sym_pair,
    STATE(2983), 1,
      sym_dictionary_splat,
    STATE(3302), 1,
      sym__collection_elements,
    STATE(3456), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(868), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(864), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2823), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(852), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1614), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2165), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [868] = 31,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(1580), 1,
      sym_identifier,
    ACTIONS(1582), 1,
      anon_sym_LPAREN,
    ACTIONS(1586), 1,
      anon_sym_STAR,
    ACTIONS(1590), 1,
      anon_sym_type,
    ACTIONS(1592), 1,
      anon_sym_LBRACK,
    ACTIONS(1594), 1,
      anon_sym_not,
    ACTIONS(1596), 1,
      anon_sym_lambda,
    ACTIONS(1598), 1,
      anon_sym_yield,
    ACTIONS(1600), 1,
      anon_sym_await,
    ACTIONS(1658), 1,
      anon_sym_RPAREN,
    STATE(1271), 1,
      sym_string,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1645), 1,
      sym_list_splat_pattern,
    STATE(2083), 1,
      sym_expression,
    STATE(2685), 1,
      sym_pattern,
    STATE(2687), 1,
      sym_yield,
    STATE(3306), 1,
      sym__named_expression_lhs,
    STATE(3411), 1,
      sym__collection_elements,
    STATE(3414), 1,
      sym__patterns,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    STATE(1542), 2,
      sym_attribute,
      sym_subscript,
    STATE(2683), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    STATE(3029), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(828), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1588), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2173), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1660), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [994] = 30,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_string_start,
    ACTIONS(1630), 1,
      sym_identifier,
    ACTIONS(1632), 1,
      anon_sym_LPAREN,
    ACTIONS(1634), 1,
      anon_sym_STAR,
    ACTIONS(1638), 1,
      anon_sym_type,
    ACTIONS(1640), 1,
      anon_sym_LBRACK,
    ACTIONS(1644), 1,
      anon_sym_not,
    ACTIONS(1646), 1,
      anon_sym_lambda,
    ACTIONS(1648), 1,
      anon_sym_yield,
    ACTIONS(1650), 1,
      anon_sym_await,
    ACTIONS(1660), 1,
      anon_sym_RBRACK,
    STATE(1264), 1,
      sym_primary_expression,
    STATE(1279), 1,
      sym_string,
    STATE(1650), 1,
      sym_list_splat_pattern,
    STATE(2076), 1,
      sym_expression,
    STATE(2911), 1,
      sym_pattern,
    STATE(3184), 1,
      sym__named_expression_lhs,
    STATE(3269), 1,
      sym__collection_elements,
    STATE(3330), 1,
      sym__patterns,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(934), 2,
      sym_ellipsis,
      sym_float,
    STATE(1647), 2,
      sym_attribute,
      sym_subscript,
    STATE(3133), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(930), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2912), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(918), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1636), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2189), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1654), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [1118] = 30,
    ACTIONS(862), 1,
      anon_sym_LBRACK,
    ACTIONS(866), 1,
      anon_sym_LBRACE,
    ACTIONS(872), 1,
      sym_string_start,
    ACTIONS(1606), 1,
      sym_identifier,
    ACTIONS(1608), 1,
      anon_sym_LPAREN,
    ACTIONS(1612), 1,
      anon_sym_STAR,
    ACTIONS(1616), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1618), 1,
      anon_sym_type,
    ACTIONS(1622), 1,
      anon_sym_not,
    ACTIONS(1624), 1,
      anon_sym_lambda,
    ACTIONS(1626), 1,
      anon_sym_yield,
    ACTIONS(1628), 1,
      anon_sym_await,
    ACTIONS(1662), 1,
      anon_sym_COMMA,
    ACTIONS(1664), 1,
      anon_sym_RBRACE,
    STATE(1220), 1,
      sym_primary_expression,
    STATE(1227), 1,
      sym_string,
    STATE(1504), 1,
      sym_list_splat_pattern,
    STATE(2058), 1,
      sym_expression,
    STATE(2267), 1,
      sym_pair,
    STATE(2701), 1,
      sym_dictionary_splat,
    STATE(3396), 1,
      sym__collection_elements,
    STATE(3456), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(868), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(864), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2823), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(852), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1614), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2165), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [1242] = 31,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(1580), 1,
      sym_identifier,
    ACTIONS(1582), 1,
      anon_sym_LPAREN,
    ACTIONS(1586), 1,
      anon_sym_STAR,
    ACTIONS(1590), 1,
      anon_sym_type,
    ACTIONS(1592), 1,
      anon_sym_LBRACK,
    ACTIONS(1594), 1,
      anon_sym_not,
    ACTIONS(1596), 1,
      anon_sym_lambda,
    ACTIONS(1598), 1,
      anon_sym_yield,
    ACTIONS(1600), 1,
      anon_sym_await,
    ACTIONS(1666), 1,
      anon_sym_RPAREN,
    STATE(1271), 1,
      sym_string,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1645), 1,
      sym_list_splat_pattern,
    STATE(2078), 1,
      sym_expression,
    STATE(2685), 1,
      sym_pattern,
    STATE(2792), 1,
      sym_yield,
    STATE(3278), 1,
      sym__collection_elements,
    STATE(3281), 1,
      sym__patterns,
    STATE(3306), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    STATE(1542), 2,
      sym_attribute,
      sym_subscript,
    STATE(2683), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    STATE(3029), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(828), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1588), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2173), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1660), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [1368] = 32,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(1580), 1,
      sym_identifier,
    ACTIONS(1582), 1,
      anon_sym_LPAREN,
    ACTIONS(1586), 1,
      anon_sym_STAR,
    ACTIONS(1590), 1,
      anon_sym_type,
    ACTIONS(1592), 1,
      anon_sym_LBRACK,
    ACTIONS(1594), 1,
      anon_sym_not,
    ACTIONS(1596), 1,
      anon_sym_lambda,
    ACTIONS(1598), 1,
      anon_sym_yield,
    ACTIONS(1600), 1,
      anon_sym_await,
    ACTIONS(1668), 1,
      anon_sym_RPAREN,
    STATE(1271), 1,
      sym_string,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1645), 1,
      sym_list_splat_pattern,
    STATE(2097), 1,
      sym_expression,
    STATE(2685), 1,
      sym_pattern,
    STATE(2714), 1,
      sym_list_splat,
    STATE(2717), 1,
      sym_parenthesized_list_splat,
    STATE(2752), 1,
      sym_yield,
    STATE(3306), 1,
      sym__named_expression_lhs,
    STATE(3307), 1,
      sym__patterns,
    STATE(3322), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    STATE(1542), 2,
      sym_attribute,
      sym_subscript,
    STATE(3029), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(828), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1588), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2173), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1660), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [1496] = 30,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_string_start,
    ACTIONS(1630), 1,
      sym_identifier,
    ACTIONS(1632), 1,
      anon_sym_LPAREN,
    ACTIONS(1634), 1,
      anon_sym_STAR,
    ACTIONS(1638), 1,
      anon_sym_type,
    ACTIONS(1640), 1,
      anon_sym_LBRACK,
    ACTIONS(1644), 1,
      anon_sym_not,
    ACTIONS(1646), 1,
      anon_sym_lambda,
    ACTIONS(1648), 1,
      anon_sym_yield,
    ACTIONS(1650), 1,
      anon_sym_await,
    ACTIONS(1670), 1,
      anon_sym_RBRACK,
    STATE(1264), 1,
      sym_primary_expression,
    STATE(1279), 1,
      sym_string,
    STATE(1650), 1,
      sym_list_splat_pattern,
    STATE(2076), 1,
      sym_expression,
    STATE(2911), 1,
      sym_pattern,
    STATE(3184), 1,
      sym__named_expression_lhs,
    STATE(3269), 1,
      sym__collection_elements,
    STATE(3429), 1,
      sym__patterns,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(934), 2,
      sym_ellipsis,
      sym_float,
    STATE(1647), 2,
      sym_attribute,
      sym_subscript,
    STATE(3133), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(930), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2912), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(918), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1636), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2189), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1654), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [1620] = 31,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(1580), 1,
      sym_identifier,
    ACTIONS(1582), 1,
      anon_sym_LPAREN,
    ACTIONS(1586), 1,
      anon_sym_STAR,
    ACTIONS(1590), 1,
      anon_sym_type,
    ACTIONS(1592), 1,
      anon_sym_LBRACK,
    ACTIONS(1594), 1,
      anon_sym_not,
    ACTIONS(1596), 1,
      anon_sym_lambda,
    ACTIONS(1598), 1,
      anon_sym_yield,
    ACTIONS(1600), 1,
      anon_sym_await,
    ACTIONS(1672), 1,
      anon_sym_RPAREN,
    STATE(1271), 1,
      sym_string,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1645), 1,
      sym_list_splat_pattern,
    STATE(2078), 1,
      sym_expression,
    STATE(2685), 1,
      sym_pattern,
    STATE(2792), 1,
      sym_yield,
    STATE(3278), 1,
      sym__collection_elements,
    STATE(3306), 1,
      sym__named_expression_lhs,
    STATE(3414), 1,
      sym__patterns,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    STATE(1542), 2,
      sym_attribute,
      sym_subscript,
    STATE(2683), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    STATE(3029), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(828), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1588), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2173), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1660), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [1746] = 30,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_string_start,
    ACTIONS(1630), 1,
      sym_identifier,
    ACTIONS(1632), 1,
      anon_sym_LPAREN,
    ACTIONS(1634), 1,
      anon_sym_STAR,
    ACTIONS(1638), 1,
      anon_sym_type,
    ACTIONS(1640), 1,
      anon_sym_LBRACK,
    ACTIONS(1644), 1,
      anon_sym_not,
    ACTIONS(1646), 1,
      anon_sym_lambda,
    ACTIONS(1648), 1,
      anon_sym_yield,
    ACTIONS(1650), 1,
      anon_sym_await,
    ACTIONS(1674), 1,
      anon_sym_RBRACK,
    STATE(1264), 1,
      sym_primary_expression,
    STATE(1279), 1,
      sym_string,
    STATE(1650), 1,
      sym_list_splat_pattern,
    STATE(2080), 1,
      sym_expression,
    STATE(2911), 1,
      sym_pattern,
    STATE(3184), 1,
      sym__named_expression_lhs,
    STATE(3330), 1,
      sym__patterns,
    STATE(3333), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(934), 2,
      sym_ellipsis,
      sym_float,
    STATE(1647), 2,
      sym_attribute,
      sym_subscript,
    STATE(3133), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(930), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2912), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(918), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1636), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2189), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1654), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [1870] = 30,
    ACTIONS(862), 1,
      anon_sym_LBRACK,
    ACTIONS(866), 1,
      anon_sym_LBRACE,
    ACTIONS(872), 1,
      sym_string_start,
    ACTIONS(1606), 1,
      sym_identifier,
    ACTIONS(1608), 1,
      anon_sym_LPAREN,
    ACTIONS(1612), 1,
      anon_sym_STAR,
    ACTIONS(1616), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1618), 1,
      anon_sym_type,
    ACTIONS(1622), 1,
      anon_sym_not,
    ACTIONS(1624), 1,
      anon_sym_lambda,
    ACTIONS(1626), 1,
      anon_sym_yield,
    ACTIONS(1628), 1,
      anon_sym_await,
    ACTIONS(1676), 1,
      anon_sym_COMMA,
    ACTIONS(1678), 1,
      anon_sym_RBRACE,
    STATE(1220), 1,
      sym_primary_expression,
    STATE(1227), 1,
      sym_string,
    STATE(1504), 1,
      sym_list_splat_pattern,
    STATE(2063), 1,
      sym_expression,
    STATE(2240), 1,
      sym_pair,
    STATE(2745), 1,
      sym_dictionary_splat,
    STATE(3340), 1,
      sym__collection_elements,
    STATE(3456), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(868), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(864), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2823), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(852), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1614), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2165), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [1994] = 32,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(1580), 1,
      sym_identifier,
    ACTIONS(1582), 1,
      anon_sym_LPAREN,
    ACTIONS(1586), 1,
      anon_sym_STAR,
    ACTIONS(1590), 1,
      anon_sym_type,
    ACTIONS(1592), 1,
      anon_sym_LBRACK,
    ACTIONS(1594), 1,
      anon_sym_not,
    ACTIONS(1596), 1,
      anon_sym_lambda,
    ACTIONS(1598), 1,
      anon_sym_yield,
    ACTIONS(1600), 1,
      anon_sym_await,
    ACTIONS(1680), 1,
      anon_sym_RPAREN,
    STATE(1271), 1,
      sym_string,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1645), 1,
      sym_list_splat_pattern,
    STATE(2090), 1,
      sym_expression,
    STATE(2685), 1,
      sym_pattern,
    STATE(2719), 1,
      sym_parenthesized_list_splat,
    STATE(2721), 1,
      sym_list_splat,
    STATE(2919), 1,
      sym_yield,
    STATE(3178), 1,
      sym__collection_elements,
    STATE(3281), 1,
      sym__patterns,
    STATE(3306), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    STATE(1542), 2,
      sym_attribute,
      sym_subscript,
    STATE(3029), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(828), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1588), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2173), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1660), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [2122] = 30,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_string_start,
    ACTIONS(1630), 1,
      sym_identifier,
    ACTIONS(1632), 1,
      anon_sym_LPAREN,
    ACTIONS(1634), 1,
      anon_sym_STAR,
    ACTIONS(1638), 1,
      anon_sym_type,
    ACTIONS(1640), 1,
      anon_sym_LBRACK,
    ACTIONS(1644), 1,
      anon_sym_not,
    ACTIONS(1646), 1,
      anon_sym_lambda,
    ACTIONS(1648), 1,
      anon_sym_yield,
    ACTIONS(1650), 1,
      anon_sym_await,
    ACTIONS(1682), 1,
      anon_sym_RBRACK,
    STATE(1264), 1,
      sym_primary_expression,
    STATE(1279), 1,
      sym_string,
    STATE(1650), 1,
      sym_list_splat_pattern,
    STATE(2072), 1,
      sym_expression,
    STATE(2911), 1,
      sym_pattern,
    STATE(3184), 1,
      sym__named_expression_lhs,
    STATE(3356), 1,
      sym__patterns,
    STATE(3399), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(934), 2,
      sym_ellipsis,
      sym_float,
    STATE(1647), 2,
      sym_attribute,
      sym_subscript,
    STATE(3133), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(930), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2912), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(918), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1636), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2189), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1654), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [2246] = 28,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(15), 1,
      anon_sym_LPAREN,
    ACTIONS(17), 1,
      anon_sym_STAR,
    ACTIONS(61), 1,
      anon_sym_LBRACK,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(73), 1,
      anon_sym_yield,
    ACTIONS(79), 1,
      anon_sym_await,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(1602), 1,
      anon_sym_type,
    STATE(1024), 1,
      sym_list_splat_pattern,
    STATE(1200), 1,
      sym_string,
    STATE(1237), 1,
      sym_primary_expression,
    STATE(2009), 1,
      sym_pattern,
    STATE(2010), 1,
      sym_pattern_list,
    STATE(2175), 1,
      sym_expression,
    STATE(3427), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    STATE(1029), 2,
      sym_attribute,
      sym_subscript,
    STATE(2015), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(502), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(3089), 5,
      sym_expression_list,
      sym_assignment,
      sym_augmented_assignment,
      sym__right_hand_side,
      sym_yield,
    STATE(2070), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1312), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [2366] = 30,
    ACTIONS(862), 1,
      anon_sym_LBRACK,
    ACTIONS(866), 1,
      anon_sym_LBRACE,
    ACTIONS(872), 1,
      sym_string_start,
    ACTIONS(1606), 1,
      sym_identifier,
    ACTIONS(1608), 1,
      anon_sym_LPAREN,
    ACTIONS(1612), 1,
      anon_sym_STAR,
    ACTIONS(1616), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1618), 1,
      anon_sym_type,
    ACTIONS(1622), 1,
      anon_sym_not,
    ACTIONS(1624), 1,
      anon_sym_lambda,
    ACTIONS(1626), 1,
      anon_sym_yield,
    ACTIONS(1628), 1,
      anon_sym_await,
    ACTIONS(1684), 1,
      anon_sym_COMMA,
    ACTIONS(1686), 1,
      anon_sym_RBRACE,
    STATE(1220), 1,
      sym_primary_expression,
    STATE(1227), 1,
      sym_string,
    STATE(1504), 1,
      sym_list_splat_pattern,
    STATE(2071), 1,
      sym_expression,
    STATE(2281), 1,
      sym_pair,
    STATE(3025), 1,
      sym_dictionary_splat,
    STATE(3422), 1,
      sym__collection_elements,
    STATE(3456), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(868), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(864), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2823), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(852), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1614), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2165), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [2490] = 30,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_string_start,
    ACTIONS(1630), 1,
      sym_identifier,
    ACTIONS(1632), 1,
      anon_sym_LPAREN,
    ACTIONS(1634), 1,
      anon_sym_STAR,
    ACTIONS(1638), 1,
      anon_sym_type,
    ACTIONS(1640), 1,
      anon_sym_LBRACK,
    ACTIONS(1644), 1,
      anon_sym_not,
    ACTIONS(1646), 1,
      anon_sym_lambda,
    ACTIONS(1648), 1,
      anon_sym_yield,
    ACTIONS(1650), 1,
      anon_sym_await,
    ACTIONS(1688), 1,
      anon_sym_RBRACK,
    STATE(1264), 1,
      sym_primary_expression,
    STATE(1279), 1,
      sym_string,
    STATE(1650), 1,
      sym_list_splat_pattern,
    STATE(2094), 1,
      sym_expression,
    STATE(2911), 1,
      sym_pattern,
    STATE(3184), 1,
      sym__named_expression_lhs,
    STATE(3313), 1,
      sym__collection_elements,
    STATE(3356), 1,
      sym__patterns,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(934), 2,
      sym_ellipsis,
      sym_float,
    STATE(1647), 2,
      sym_attribute,
      sym_subscript,
    STATE(3133), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(930), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2912), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(918), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1636), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2189), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1654), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [2614] = 31,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(1580), 1,
      sym_identifier,
    ACTIONS(1582), 1,
      anon_sym_LPAREN,
    ACTIONS(1586), 1,
      anon_sym_STAR,
    ACTIONS(1590), 1,
      anon_sym_type,
    ACTIONS(1592), 1,
      anon_sym_LBRACK,
    ACTIONS(1594), 1,
      anon_sym_not,
    ACTIONS(1596), 1,
      anon_sym_lambda,
    ACTIONS(1598), 1,
      anon_sym_yield,
    ACTIONS(1600), 1,
      anon_sym_await,
    ACTIONS(1690), 1,
      anon_sym_RPAREN,
    STATE(1271), 1,
      sym_string,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1645), 1,
      sym_list_splat_pattern,
    STATE(2078), 1,
      sym_expression,
    STATE(2685), 1,
      sym_pattern,
    STATE(2792), 1,
      sym_yield,
    STATE(3278), 1,
      sym__collection_elements,
    STATE(3306), 1,
      sym__named_expression_lhs,
    STATE(3414), 1,
      sym__patterns,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    STATE(1542), 2,
      sym_attribute,
      sym_subscript,
    STATE(2683), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    STATE(3029), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(828), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1588), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2173), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1660), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [2740] = 28,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(15), 1,
      anon_sym_LPAREN,
    ACTIONS(17), 1,
      anon_sym_STAR,
    ACTIONS(61), 1,
      anon_sym_LBRACK,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(73), 1,
      anon_sym_yield,
    ACTIONS(79), 1,
      anon_sym_await,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(1602), 1,
      anon_sym_type,
    STATE(1024), 1,
      sym_list_splat_pattern,
    STATE(1200), 1,
      sym_string,
    STATE(1237), 1,
      sym_primary_expression,
    STATE(2009), 1,
      sym_pattern,
    STATE(2010), 1,
      sym_pattern_list,
    STATE(2175), 1,
      sym_expression,
    STATE(3427), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    STATE(1029), 2,
      sym_attribute,
      sym_subscript,
    STATE(2015), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(502), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(3090), 5,
      sym_expression_list,
      sym_assignment,
      sym_augmented_assignment,
      sym__right_hand_side,
      sym_yield,
    STATE(2070), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1312), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [2860] = 31,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(1580), 1,
      sym_identifier,
    ACTIONS(1582), 1,
      anon_sym_LPAREN,
    ACTIONS(1586), 1,
      anon_sym_STAR,
    ACTIONS(1590), 1,
      anon_sym_type,
    ACTIONS(1592), 1,
      anon_sym_LBRACK,
    ACTIONS(1594), 1,
      anon_sym_not,
    ACTIONS(1596), 1,
      anon_sym_lambda,
    ACTIONS(1598), 1,
      anon_sym_yield,
    ACTIONS(1600), 1,
      anon_sym_await,
    ACTIONS(1692), 1,
      anon_sym_RPAREN,
    STATE(1271), 1,
      sym_string,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1645), 1,
      sym_list_splat_pattern,
    STATE(2078), 1,
      sym_expression,
    STATE(2685), 1,
      sym_pattern,
    STATE(2792), 1,
      sym_yield,
    STATE(3278), 1,
      sym__collection_elements,
    STATE(3306), 1,
      sym__named_expression_lhs,
    STATE(3307), 1,
      sym__patterns,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    STATE(1542), 2,
      sym_attribute,
      sym_subscript,
    STATE(2683), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    STATE(3029), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(828), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1588), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2173), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1660), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [2986] = 30,
    ACTIONS(862), 1,
      anon_sym_LBRACK,
    ACTIONS(866), 1,
      anon_sym_LBRACE,
    ACTIONS(872), 1,
      sym_string_start,
    ACTIONS(1606), 1,
      sym_identifier,
    ACTIONS(1608), 1,
      anon_sym_LPAREN,
    ACTIONS(1612), 1,
      anon_sym_STAR,
    ACTIONS(1616), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1618), 1,
      anon_sym_type,
    ACTIONS(1622), 1,
      anon_sym_not,
    ACTIONS(1624), 1,
      anon_sym_lambda,
    ACTIONS(1626), 1,
      anon_sym_yield,
    ACTIONS(1628), 1,
      anon_sym_await,
    ACTIONS(1694), 1,
      anon_sym_COMMA,
    ACTIONS(1696), 1,
      anon_sym_RBRACE,
    STATE(1220), 1,
      sym_primary_expression,
    STATE(1227), 1,
      sym_string,
    STATE(1504), 1,
      sym_list_splat_pattern,
    STATE(2060), 1,
      sym_expression,
    STATE(2246), 1,
      sym_pair,
    STATE(2887), 1,
      sym_dictionary_splat,
    STATE(3196), 1,
      sym__collection_elements,
    STATE(3456), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(868), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(864), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2823), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(852), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1614), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2165), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [3110] = 31,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(1580), 1,
      sym_identifier,
    ACTIONS(1582), 1,
      anon_sym_LPAREN,
    ACTIONS(1586), 1,
      anon_sym_STAR,
    ACTIONS(1590), 1,
      anon_sym_type,
    ACTIONS(1592), 1,
      anon_sym_LBRACK,
    ACTIONS(1594), 1,
      anon_sym_not,
    ACTIONS(1596), 1,
      anon_sym_lambda,
    ACTIONS(1598), 1,
      anon_sym_yield,
    ACTIONS(1600), 1,
      anon_sym_await,
    ACTIONS(1698), 1,
      anon_sym_RPAREN,
    STATE(1271), 1,
      sym_string,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1645), 1,
      sym_list_splat_pattern,
    STATE(2078), 1,
      sym_expression,
    STATE(2685), 1,
      sym_pattern,
    STATE(2792), 1,
      sym_yield,
    STATE(3278), 1,
      sym__collection_elements,
    STATE(3306), 1,
      sym__named_expression_lhs,
    STATE(3455), 1,
      sym__patterns,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    STATE(1542), 2,
      sym_attribute,
      sym_subscript,
    STATE(2683), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    STATE(3029), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(828), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1588), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2173), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1660), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [3236] = 30,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_string_start,
    ACTIONS(1630), 1,
      sym_identifier,
    ACTIONS(1632), 1,
      anon_sym_LPAREN,
    ACTIONS(1634), 1,
      anon_sym_STAR,
    ACTIONS(1638), 1,
      anon_sym_type,
    ACTIONS(1640), 1,
      anon_sym_LBRACK,
    ACTIONS(1644), 1,
      anon_sym_not,
    ACTIONS(1646), 1,
      anon_sym_lambda,
    ACTIONS(1648), 1,
      anon_sym_yield,
    ACTIONS(1650), 1,
      anon_sym_await,
    ACTIONS(1700), 1,
      anon_sym_RBRACK,
    STATE(1264), 1,
      sym_primary_expression,
    STATE(1279), 1,
      sym_string,
    STATE(1650), 1,
      sym_list_splat_pattern,
    STATE(2076), 1,
      sym_expression,
    STATE(2911), 1,
      sym_pattern,
    STATE(3184), 1,
      sym__named_expression_lhs,
    STATE(3269), 1,
      sym__collection_elements,
    STATE(3356), 1,
      sym__patterns,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(934), 2,
      sym_ellipsis,
      sym_float,
    STATE(1647), 2,
      sym_attribute,
      sym_subscript,
    STATE(3133), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(930), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2912), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(918), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1636), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2189), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1654), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [3360] = 30,
    ACTIONS(862), 1,
      anon_sym_LBRACK,
    ACTIONS(866), 1,
      anon_sym_LBRACE,
    ACTIONS(872), 1,
      sym_string_start,
    ACTIONS(1606), 1,
      sym_identifier,
    ACTIONS(1608), 1,
      anon_sym_LPAREN,
    ACTIONS(1612), 1,
      anon_sym_STAR,
    ACTIONS(1616), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1618), 1,
      anon_sym_type,
    ACTIONS(1622), 1,
      anon_sym_not,
    ACTIONS(1624), 1,
      anon_sym_lambda,
    ACTIONS(1626), 1,
      anon_sym_yield,
    ACTIONS(1628), 1,
      anon_sym_await,
    ACTIONS(1702), 1,
      anon_sym_COMMA,
    ACTIONS(1704), 1,
      anon_sym_RBRACE,
    STATE(1220), 1,
      sym_primary_expression,
    STATE(1227), 1,
      sym_string,
    STATE(1504), 1,
      sym_list_splat_pattern,
    STATE(2057), 1,
      sym_expression,
    STATE(2271), 1,
      sym_pair,
    STATE(2940), 1,
      sym_dictionary_splat,
    STATE(3221), 1,
      sym__collection_elements,
    STATE(3456), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(868), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(864), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2823), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(852), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1614), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2165), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [3484] = 31,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(1580), 1,
      sym_identifier,
    ACTIONS(1582), 1,
      anon_sym_LPAREN,
    ACTIONS(1586), 1,
      anon_sym_STAR,
    ACTIONS(1590), 1,
      anon_sym_type,
    ACTIONS(1592), 1,
      anon_sym_LBRACK,
    ACTIONS(1594), 1,
      anon_sym_not,
    ACTIONS(1596), 1,
      anon_sym_lambda,
    ACTIONS(1598), 1,
      anon_sym_yield,
    ACTIONS(1600), 1,
      anon_sym_await,
    ACTIONS(1706), 1,
      anon_sym_RPAREN,
    STATE(1271), 1,
      sym_string,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1645), 1,
      sym_list_splat_pattern,
    STATE(2083), 1,
      sym_expression,
    STATE(2685), 1,
      sym_pattern,
    STATE(2687), 1,
      sym_yield,
    STATE(3306), 1,
      sym__named_expression_lhs,
    STATE(3411), 1,
      sym__collection_elements,
    STATE(3414), 1,
      sym__patterns,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    STATE(1542), 2,
      sym_attribute,
      sym_subscript,
    STATE(2683), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    STATE(3029), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(828), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1588), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2173), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1660), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [3610] = 30,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_string_start,
    ACTIONS(1630), 1,
      sym_identifier,
    ACTIONS(1632), 1,
      anon_sym_LPAREN,
    ACTIONS(1634), 1,
      anon_sym_STAR,
    ACTIONS(1638), 1,
      anon_sym_type,
    ACTIONS(1640), 1,
      anon_sym_LBRACK,
    ACTIONS(1644), 1,
      anon_sym_not,
    ACTIONS(1646), 1,
      anon_sym_lambda,
    ACTIONS(1648), 1,
      anon_sym_yield,
    ACTIONS(1650), 1,
      anon_sym_await,
    ACTIONS(1708), 1,
      anon_sym_RBRACK,
    STATE(1264), 1,
      sym_primary_expression,
    STATE(1279), 1,
      sym_string,
    STATE(1650), 1,
      sym_list_splat_pattern,
    STATE(2076), 1,
      sym_expression,
    STATE(2911), 1,
      sym_pattern,
    STATE(3184), 1,
      sym__named_expression_lhs,
    STATE(3269), 1,
      sym__collection_elements,
    STATE(3356), 1,
      sym__patterns,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(934), 2,
      sym_ellipsis,
      sym_float,
    STATE(1647), 2,
      sym_attribute,
      sym_subscript,
    STATE(3133), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(930), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2912), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(918), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1636), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2189), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1654), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [3734] = 30,
    ACTIONS(862), 1,
      anon_sym_LBRACK,
    ACTIONS(866), 1,
      anon_sym_LBRACE,
    ACTIONS(872), 1,
      sym_string_start,
    ACTIONS(1606), 1,
      sym_identifier,
    ACTIONS(1608), 1,
      anon_sym_LPAREN,
    ACTIONS(1612), 1,
      anon_sym_STAR,
    ACTIONS(1616), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1618), 1,
      anon_sym_type,
    ACTIONS(1622), 1,
      anon_sym_not,
    ACTIONS(1624), 1,
      anon_sym_lambda,
    ACTIONS(1626), 1,
      anon_sym_yield,
    ACTIONS(1628), 1,
      anon_sym_await,
    ACTIONS(1710), 1,
      anon_sym_COMMA,
    ACTIONS(1712), 1,
      anon_sym_RBRACE,
    STATE(1220), 1,
      sym_primary_expression,
    STATE(1227), 1,
      sym_string,
    STATE(1504), 1,
      sym_list_splat_pattern,
    STATE(2068), 1,
      sym_expression,
    STATE(2260), 1,
      sym_pair,
    STATE(2929), 1,
      sym_dictionary_splat,
    STATE(3165), 1,
      sym__collection_elements,
    STATE(3456), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(868), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(864), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2823), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(852), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1614), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2165), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [3858] = 30,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_string_start,
    ACTIONS(1630), 1,
      sym_identifier,
    ACTIONS(1632), 1,
      anon_sym_LPAREN,
    ACTIONS(1634), 1,
      anon_sym_STAR,
    ACTIONS(1638), 1,
      anon_sym_type,
    ACTIONS(1640), 1,
      anon_sym_LBRACK,
    ACTIONS(1644), 1,
      anon_sym_not,
    ACTIONS(1646), 1,
      anon_sym_lambda,
    ACTIONS(1648), 1,
      anon_sym_yield,
    ACTIONS(1650), 1,
      anon_sym_await,
    ACTIONS(1714), 1,
      anon_sym_RBRACK,
    STATE(1264), 1,
      sym_primary_expression,
    STATE(1279), 1,
      sym_string,
    STATE(1650), 1,
      sym_list_splat_pattern,
    STATE(2072), 1,
      sym_expression,
    STATE(2911), 1,
      sym_pattern,
    STATE(3184), 1,
      sym__named_expression_lhs,
    STATE(3356), 1,
      sym__patterns,
    STATE(3399), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(934), 2,
      sym_ellipsis,
      sym_float,
    STATE(1647), 2,
      sym_attribute,
      sym_subscript,
    STATE(3133), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(930), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2912), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(918), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1636), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2189), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1654), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [3982] = 30,
    ACTIONS(862), 1,
      anon_sym_LBRACK,
    ACTIONS(866), 1,
      anon_sym_LBRACE,
    ACTIONS(872), 1,
      sym_string_start,
    ACTIONS(1606), 1,
      sym_identifier,
    ACTIONS(1608), 1,
      anon_sym_LPAREN,
    ACTIONS(1612), 1,
      anon_sym_STAR,
    ACTIONS(1616), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1618), 1,
      anon_sym_type,
    ACTIONS(1622), 1,
      anon_sym_not,
    ACTIONS(1624), 1,
      anon_sym_lambda,
    ACTIONS(1626), 1,
      anon_sym_yield,
    ACTIONS(1628), 1,
      anon_sym_await,
    ACTIONS(1716), 1,
      anon_sym_COMMA,
    ACTIONS(1718), 1,
      anon_sym_RBRACE,
    STATE(1220), 1,
      sym_primary_expression,
    STATE(1227), 1,
      sym_string,
    STATE(1504), 1,
      sym_list_splat_pattern,
    STATE(2064), 1,
      sym_expression,
    STATE(2249), 1,
      sym_pair,
    STATE(2811), 1,
      sym_dictionary_splat,
    STATE(3250), 1,
      sym__collection_elements,
    STATE(3456), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(868), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(864), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2823), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(852), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1614), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2165), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [4106] = 30,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_string_start,
    ACTIONS(1630), 1,
      sym_identifier,
    ACTIONS(1632), 1,
      anon_sym_LPAREN,
    ACTIONS(1634), 1,
      anon_sym_STAR,
    ACTIONS(1638), 1,
      anon_sym_type,
    ACTIONS(1640), 1,
      anon_sym_LBRACK,
    ACTIONS(1644), 1,
      anon_sym_not,
    ACTIONS(1646), 1,
      anon_sym_lambda,
    ACTIONS(1648), 1,
      anon_sym_yield,
    ACTIONS(1650), 1,
      anon_sym_await,
    ACTIONS(1720), 1,
      anon_sym_RBRACK,
    STATE(1264), 1,
      sym_primary_expression,
    STATE(1279), 1,
      sym_string,
    STATE(1650), 1,
      sym_list_splat_pattern,
    STATE(2076), 1,
      sym_expression,
    STATE(2911), 1,
      sym_pattern,
    STATE(3168), 1,
      sym__patterns,
    STATE(3184), 1,
      sym__named_expression_lhs,
    STATE(3269), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(934), 2,
      sym_ellipsis,
      sym_float,
    STATE(1647), 2,
      sym_attribute,
      sym_subscript,
    STATE(3133), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(930), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2912), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(918), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1636), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2189), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1654), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [4230] = 27,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(1722), 1,
      sym_identifier,
    ACTIONS(1724), 1,
      anon_sym_STAR,
    ACTIONS(1728), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1730), 1,
      anon_sym_type,
    ACTIONS(1732), 1,
      anon_sym_await,
    ACTIONS(1734), 1,
      sym__newline,
    ACTIONS(1736), 1,
      sym__indent,
    STATE(1200), 1,
      sym_string,
    STATE(1203), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    STATE(2311), 1,
      sym_expression,
    STATE(3427), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    STATE(348), 2,
      sym___directive_parameters_wc_none,
      sym__directive_parameters_wc_none,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1726), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2756), 4,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
      sym__directive_parameter,
    STATE(2070), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [4347] = 22,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(396), 1,
      anon_sym_TILDE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(1738), 1,
      sym_identifier,
    ACTIONS(1742), 1,
      anon_sym_LPAREN,
    ACTIONS(1744), 1,
      anon_sym_STAR,
    ACTIONS(1748), 1,
      anon_sym_type,
    ACTIONS(1750), 1,
      anon_sym_LBRACK,
    ACTIONS(1752), 1,
      anon_sym_await,
    STATE(1234), 1,
      sym_string,
    STATE(1639), 1,
      sym_list_splat_pattern,
    STATE(1979), 1,
      sym_primary_expression,
    STATE(1992), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(498), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1638), 2,
      sym_attribute,
      sym_subscript,
    STATE(1975), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1746), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1536), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
    ACTIONS(1740), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [4454] = 27,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(1722), 1,
      sym_identifier,
    ACTIONS(1724), 1,
      anon_sym_STAR,
    ACTIONS(1728), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1730), 1,
      anon_sym_type,
    ACTIONS(1732), 1,
      anon_sym_await,
    ACTIONS(1754), 1,
      sym__newline,
    ACTIONS(1756), 1,
      sym__indent,
    STATE(1200), 1,
      sym_string,
    STATE(1203), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    STATE(2311), 1,
      sym_expression,
    STATE(3427), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    STATE(1835), 2,
      sym___directive_parameters_wc_none,
      sym__directive_parameters_wc_none,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1726), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2824), 4,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
      sym__directive_parameter,
    STATE(2070), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [4571] = 22,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(396), 1,
      anon_sym_TILDE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(1738), 1,
      sym_identifier,
    ACTIONS(1742), 1,
      anon_sym_LPAREN,
    ACTIONS(1744), 1,
      anon_sym_STAR,
    ACTIONS(1748), 1,
      anon_sym_type,
    ACTIONS(1750), 1,
      anon_sym_LBRACK,
    ACTIONS(1752), 1,
      anon_sym_await,
    STATE(1234), 1,
      sym_string,
    STATE(1639), 1,
      sym_list_splat_pattern,
    STATE(1979), 1,
      sym_primary_expression,
    STATE(1992), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(498), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1638), 2,
      sym_attribute,
      sym_subscript,
    STATE(1975), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1746), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1536), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
    ACTIONS(1758), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [4678] = 27,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(1722), 1,
      sym_identifier,
    ACTIONS(1724), 1,
      anon_sym_STAR,
    ACTIONS(1728), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1730), 1,
      anon_sym_type,
    ACTIONS(1732), 1,
      anon_sym_await,
    ACTIONS(1760), 1,
      sym__newline,
    ACTIONS(1762), 1,
      sym__indent,
    STATE(1200), 1,
      sym_string,
    STATE(1203), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    STATE(2311), 1,
      sym_expression,
    STATE(3427), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    STATE(468), 2,
      sym___directive_parameters_wc_none,
      sym__directive_parameters_wc_none,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1726), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2700), 4,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
      sym__directive_parameter,
    STATE(2070), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [4795] = 27,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(1722), 1,
      sym_identifier,
    ACTIONS(1724), 1,
      anon_sym_STAR,
    ACTIONS(1728), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1730), 1,
      anon_sym_type,
    ACTIONS(1732), 1,
      anon_sym_await,
    ACTIONS(1760), 1,
      sym__newline,
    ACTIONS(1762), 1,
      sym__indent,
    STATE(1200), 1,
      sym_string,
    STATE(1203), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    STATE(2311), 1,
      sym_expression,
    STATE(3427), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    STATE(2262), 2,
      sym___directive_parameters_wc_none,
      sym__directive_parameters_wc_none,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1726), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2700), 4,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
      sym__directive_parameter,
    STATE(2070), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [4912] = 26,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1764), 1,
      sym_identifier,
    ACTIONS(1766), 1,
      anon_sym_STAR,
    ACTIONS(1770), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1774), 1,
      anon_sym_RBRACK,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2151), 1,
      sym_expression,
    STATE(2416), 1,
      sym_type,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2519), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [5026] = 26,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1764), 1,
      sym_identifier,
    ACTIONS(1766), 1,
      anon_sym_STAR,
    ACTIONS(1770), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(1782), 1,
      anon_sym_RBRACK,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2151), 1,
      sym_expression,
    STATE(2416), 1,
      sym_type,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2519), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [5140] = 26,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1764), 1,
      sym_identifier,
    ACTIONS(1766), 1,
      anon_sym_STAR,
    ACTIONS(1770), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(1784), 1,
      anon_sym_RBRACK,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2151), 1,
      sym_expression,
    STATE(2416), 1,
      sym_type,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2519), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [5254] = 26,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1764), 1,
      sym_identifier,
    ACTIONS(1766), 1,
      anon_sym_STAR,
    ACTIONS(1770), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(1786), 1,
      anon_sym_RBRACK,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2151), 1,
      sym_expression,
    STATE(2416), 1,
      sym_type,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2519), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [5368] = 27,
    ACTIONS(793), 1,
      anon_sym_LBRACE,
    ACTIONS(799), 1,
      sym_string_start,
    ACTIONS(1626), 1,
      anon_sym_yield,
    ACTIONS(1788), 1,
      sym_identifier,
    ACTIONS(1790), 1,
      anon_sym_LPAREN,
    ACTIONS(1792), 1,
      anon_sym_STAR,
    ACTIONS(1796), 1,
      anon_sym_type,
    ACTIONS(1798), 1,
      anon_sym_LBRACK,
    ACTIONS(1800), 1,
      anon_sym_not,
    ACTIONS(1802), 1,
      anon_sym_lambda,
    ACTIONS(1804), 1,
      anon_sym_await,
    STATE(1221), 1,
      sym_primary_expression,
    STATE(1223), 1,
      sym_string,
    STATE(1478), 1,
      sym_list_splat_pattern,
    STATE(2117), 1,
      sym_expression,
    STATE(3058), 1,
      sym_pattern,
    STATE(3201), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(795), 2,
      sym_ellipsis,
      sym_float,
    STATE(1479), 2,
      sym_attribute,
      sym_subscript,
    STATE(2015), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(791), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(779), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1794), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2498), 4,
      sym_expression_list,
      sym_pattern_list,
      sym_yield,
      sym__f_expression,
    STATE(2139), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1449), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [5484] = 27,
    ACTIONS(793), 1,
      anon_sym_LBRACE,
    ACTIONS(799), 1,
      sym_string_start,
    ACTIONS(1626), 1,
      anon_sym_yield,
    ACTIONS(1788), 1,
      sym_identifier,
    ACTIONS(1790), 1,
      anon_sym_LPAREN,
    ACTIONS(1792), 1,
      anon_sym_STAR,
    ACTIONS(1796), 1,
      anon_sym_type,
    ACTIONS(1798), 1,
      anon_sym_LBRACK,
    ACTIONS(1800), 1,
      anon_sym_not,
    ACTIONS(1802), 1,
      anon_sym_lambda,
    ACTIONS(1804), 1,
      anon_sym_await,
    STATE(1221), 1,
      sym_primary_expression,
    STATE(1223), 1,
      sym_string,
    STATE(1478), 1,
      sym_list_splat_pattern,
    STATE(2117), 1,
      sym_expression,
    STATE(3058), 1,
      sym_pattern,
    STATE(3201), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(795), 2,
      sym_ellipsis,
      sym_float,
    STATE(1479), 2,
      sym_attribute,
      sym_subscript,
    STATE(2015), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(791), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(779), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1794), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2511), 4,
      sym_expression_list,
      sym_pattern_list,
      sym_yield,
      sym__f_expression,
    STATE(2139), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1449), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [5600] = 26,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1764), 1,
      sym_identifier,
    ACTIONS(1766), 1,
      anon_sym_STAR,
    ACTIONS(1770), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(1806), 1,
      anon_sym_RBRACK,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2151), 1,
      sym_expression,
    STATE(2416), 1,
      sym_type,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2519), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [5714] = 26,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1764), 1,
      sym_identifier,
    ACTIONS(1766), 1,
      anon_sym_STAR,
    ACTIONS(1770), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(1808), 1,
      anon_sym_RBRACK,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2151), 1,
      sym_expression,
    STATE(2416), 1,
      sym_type,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2519), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [5828] = 26,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1764), 1,
      sym_identifier,
    ACTIONS(1766), 1,
      anon_sym_STAR,
    ACTIONS(1770), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(1810), 1,
      anon_sym_RBRACK,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2151), 1,
      sym_expression,
    STATE(2416), 1,
      sym_type,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2519), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [5942] = 26,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1764), 1,
      sym_identifier,
    ACTIONS(1766), 1,
      anon_sym_STAR,
    ACTIONS(1770), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(1812), 1,
      anon_sym_RBRACK,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2151), 1,
      sym_expression,
    STATE(2416), 1,
      sym_type,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2519), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [6056] = 25,
    ACTIONS(359), 1,
      sym_identifier,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(423), 1,
      anon_sym_STAR_STAR,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(1814), 1,
      anon_sym_STAR,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2153), 1,
      sym_expression,
    STATE(2984), 1,
      sym_type,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2508), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [6167] = 25,
    ACTIONS(359), 1,
      sym_identifier,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(423), 1,
      anon_sym_STAR_STAR,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(1814), 1,
      anon_sym_STAR,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2153), 1,
      sym_expression,
    STATE(2724), 1,
      sym_type,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2508), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [6278] = 26,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(1722), 1,
      sym_identifier,
    ACTIONS(1724), 1,
      anon_sym_STAR,
    ACTIONS(1728), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1730), 1,
      anon_sym_type,
    ACTIONS(1732), 1,
      anon_sym_await,
    ACTIONS(1816), 1,
      sym__newline,
    ACTIONS(1818), 1,
      sym__indent,
    STATE(1200), 1,
      sym_string,
    STATE(1203), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    STATE(2311), 1,
      sym_expression,
    STATE(3427), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1726), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(3141), 4,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
      sym__directive_parameter,
    STATE(2070), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [6391] = 25,
    ACTIONS(359), 1,
      sym_identifier,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(423), 1,
      anon_sym_STAR_STAR,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(1814), 1,
      anon_sym_STAR,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2153), 1,
      sym_expression,
    STATE(2995), 1,
      sym_type,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2508), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [6502] = 26,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(1722), 1,
      sym_identifier,
    ACTIONS(1724), 1,
      anon_sym_STAR,
    ACTIONS(1728), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1730), 1,
      anon_sym_type,
    ACTIONS(1732), 1,
      anon_sym_await,
    ACTIONS(1820), 1,
      sym__newline,
    ACTIONS(1822), 1,
      sym__indent,
    STATE(1200), 1,
      sym_string,
    STATE(1203), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    STATE(2311), 1,
      sym_expression,
    STATE(3427), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1726), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(3141), 4,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
      sym__directive_parameter,
    STATE(2070), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [6615] = 25,
    ACTIONS(876), 1,
      anon_sym_LPAREN,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1824), 1,
      sym_identifier,
    ACTIONS(1826), 1,
      anon_sym_STAR,
    ACTIONS(1830), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1832), 1,
      anon_sym_type,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1838), 1,
      anon_sym_await,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2120), 1,
      sym_expression,
    STATE(2444), 1,
      sym_type,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1828), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2386), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [6726] = 27,
    ACTIONS(840), 1,
      anon_sym_LBRACK,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(1594), 1,
      anon_sym_not,
    ACTIONS(1596), 1,
      anon_sym_lambda,
    ACTIONS(1840), 1,
      sym_identifier,
    ACTIONS(1842), 1,
      anon_sym_LPAREN,
    ACTIONS(1844), 1,
      anon_sym_RPAREN,
    ACTIONS(1846), 1,
      anon_sym_COMMA,
    ACTIONS(1848), 1,
      anon_sym_STAR,
    ACTIONS(1852), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1854), 1,
      anon_sym_type,
    ACTIONS(1856), 1,
      anon_sym_await,
    STATE(1271), 1,
      sym_string,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1530), 1,
      sym_list_splat_pattern,
    STATE(2089), 1,
      sym_expression,
    STATE(2874), 1,
      sym_parenthesized_list_splat,
    STATE(3306), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2875), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(828), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1850), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2173), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1660), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [6841] = 25,
    ACTIONS(876), 1,
      anon_sym_LPAREN,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1824), 1,
      sym_identifier,
    ACTIONS(1826), 1,
      anon_sym_STAR,
    ACTIONS(1830), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1832), 1,
      anon_sym_type,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1838), 1,
      anon_sym_await,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2120), 1,
      sym_expression,
    STATE(2302), 1,
      sym_type,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1828), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2386), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [6952] = 25,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(477), 1,
      anon_sym_type,
    ACTIONS(488), 1,
      anon_sym_await,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(1858), 1,
      sym_identifier,
    ACTIONS(1860), 1,
      anon_sym_STAR,
    ACTIONS(1862), 1,
      anon_sym_STAR_STAR,
    STATE(1200), 1,
      sym_string,
    STATE(1203), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    STATE(2113), 1,
      sym_expression,
    STATE(2345), 1,
      sym_type,
    STATE(3427), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(473), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2329), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(2070), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [7063] = 26,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(1722), 1,
      sym_identifier,
    ACTIONS(1724), 1,
      anon_sym_STAR,
    ACTIONS(1728), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1730), 1,
      anon_sym_type,
    ACTIONS(1732), 1,
      anon_sym_await,
    ACTIONS(1864), 1,
      sym__newline,
    ACTIONS(1866), 1,
      sym__indent,
    STATE(1200), 1,
      sym_string,
    STATE(1203), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    STATE(2311), 1,
      sym_expression,
    STATE(3427), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1726), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(3027), 4,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
      sym__directive_parameter,
    STATE(2070), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [7176] = 22,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(396), 1,
      anon_sym_TILDE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(1868), 1,
      sym_identifier,
    ACTIONS(1870), 1,
      anon_sym_LPAREN,
    ACTIONS(1872), 1,
      anon_sym_STAR,
    ACTIONS(1876), 1,
      anon_sym_type,
    ACTIONS(1878), 1,
      anon_sym_LBRACK,
    ACTIONS(1880), 1,
      anon_sym_await,
    STATE(1234), 1,
      sym_string,
    STATE(1770), 1,
      sym_list_splat_pattern,
    STATE(1968), 1,
      sym_primary_expression,
    STATE(2007), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(498), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1768), 2,
      sym_attribute,
      sym_subscript,
    STATE(2015), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1874), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1536), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
    ACTIONS(1740), 15,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [7281] = 25,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1764), 1,
      sym_identifier,
    ACTIONS(1766), 1,
      anon_sym_STAR,
    ACTIONS(1770), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2151), 1,
      sym_expression,
    STATE(2379), 1,
      sym_type,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2519), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [7392] = 26,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(1722), 1,
      sym_identifier,
    ACTIONS(1724), 1,
      anon_sym_STAR,
    ACTIONS(1728), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1730), 1,
      anon_sym_type,
    ACTIONS(1732), 1,
      anon_sym_await,
    ACTIONS(1882), 1,
      sym__newline,
    ACTIONS(1884), 1,
      sym__indent,
    STATE(1200), 1,
      sym_string,
    STATE(1203), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    STATE(2311), 1,
      sym_expression,
    STATE(3427), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1726), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(3019), 4,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
      sym__directive_parameter,
    STATE(2070), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [7505] = 25,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(477), 1,
      anon_sym_type,
    ACTIONS(488), 1,
      anon_sym_await,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(1858), 1,
      sym_identifier,
    ACTIONS(1860), 1,
      anon_sym_STAR,
    ACTIONS(1862), 1,
      anon_sym_STAR_STAR,
    STATE(1200), 1,
      sym_string,
    STATE(1203), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    STATE(2113), 1,
      sym_expression,
    STATE(2300), 1,
      sym_type,
    STATE(3427), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(473), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2329), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(2070), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [7616] = 25,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(477), 1,
      anon_sym_type,
    ACTIONS(488), 1,
      anon_sym_await,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(1858), 1,
      sym_identifier,
    ACTIONS(1860), 1,
      anon_sym_STAR,
    ACTIONS(1862), 1,
      anon_sym_STAR_STAR,
    STATE(1200), 1,
      sym_string,
    STATE(1203), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    STATE(2113), 1,
      sym_expression,
    STATE(2295), 1,
      sym_type,
    STATE(3427), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(473), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2329), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(2070), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [7727] = 26,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(1722), 1,
      sym_identifier,
    ACTIONS(1724), 1,
      anon_sym_STAR,
    ACTIONS(1728), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1730), 1,
      anon_sym_type,
    ACTIONS(1732), 1,
      anon_sym_await,
    ACTIONS(1886), 1,
      sym__newline,
    ACTIONS(1888), 1,
      sym__indent,
    STATE(1200), 1,
      sym_string,
    STATE(1203), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    STATE(2311), 1,
      sym_expression,
    STATE(3427), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1726), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(3141), 4,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
      sym__directive_parameter,
    STATE(2070), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [7840] = 26,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(1722), 1,
      sym_identifier,
    ACTIONS(1724), 1,
      anon_sym_STAR,
    ACTIONS(1728), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1730), 1,
      anon_sym_type,
    ACTIONS(1732), 1,
      anon_sym_await,
    ACTIONS(1890), 1,
      sym__newline,
    ACTIONS(1892), 1,
      sym__indent,
    STATE(1200), 1,
      sym_string,
    STATE(1203), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    STATE(2311), 1,
      sym_expression,
    STATE(3427), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1726), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(3141), 4,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
      sym__directive_parameter,
    STATE(2070), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [7953] = 27,
    ACTIONS(840), 1,
      anon_sym_LBRACK,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(1594), 1,
      anon_sym_not,
    ACTIONS(1596), 1,
      anon_sym_lambda,
    ACTIONS(1840), 1,
      sym_identifier,
    ACTIONS(1842), 1,
      anon_sym_LPAREN,
    ACTIONS(1848), 1,
      anon_sym_STAR,
    ACTIONS(1852), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1854), 1,
      anon_sym_type,
    ACTIONS(1856), 1,
      anon_sym_await,
    ACTIONS(1894), 1,
      anon_sym_RPAREN,
    ACTIONS(1896), 1,
      anon_sym_COMMA,
    STATE(1271), 1,
      sym_string,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1530), 1,
      sym_list_splat_pattern,
    STATE(2098), 1,
      sym_expression,
    STATE(2972), 1,
      sym_parenthesized_list_splat,
    STATE(3306), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2973), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(828), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1850), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2173), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1660), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [8068] = 25,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1764), 1,
      sym_identifier,
    ACTIONS(1766), 1,
      anon_sym_STAR,
    ACTIONS(1770), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2151), 1,
      sym_expression,
    STATE(2416), 1,
      sym_type,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2519), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [8179] = 27,
    ACTIONS(840), 1,
      anon_sym_LBRACK,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(1594), 1,
      anon_sym_not,
    ACTIONS(1596), 1,
      anon_sym_lambda,
    ACTIONS(1840), 1,
      sym_identifier,
    ACTIONS(1842), 1,
      anon_sym_LPAREN,
    ACTIONS(1848), 1,
      anon_sym_STAR,
    ACTIONS(1852), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1854), 1,
      anon_sym_type,
    ACTIONS(1856), 1,
      anon_sym_await,
    ACTIONS(1898), 1,
      anon_sym_RPAREN,
    ACTIONS(1900), 1,
      anon_sym_COMMA,
    STATE(1271), 1,
      sym_string,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1530), 1,
      sym_list_splat_pattern,
    STATE(2073), 1,
      sym_expression,
    STATE(2800), 1,
      sym_parenthesized_list_splat,
    STATE(3306), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2801), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(828), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1850), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2173), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1660), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [8294] = 26,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(1722), 1,
      sym_identifier,
    ACTIONS(1724), 1,
      anon_sym_STAR,
    ACTIONS(1728), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1730), 1,
      anon_sym_type,
    ACTIONS(1732), 1,
      anon_sym_await,
    ACTIONS(1902), 1,
      sym__newline,
    ACTIONS(1904), 1,
      sym__indent,
    STATE(1200), 1,
      sym_string,
    STATE(1203), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    STATE(2311), 1,
      sym_expression,
    STATE(3427), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1726), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(3141), 4,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
      sym__directive_parameter,
    STATE(2070), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [8407] = 27,
    ACTIONS(840), 1,
      anon_sym_LBRACK,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(1594), 1,
      anon_sym_not,
    ACTIONS(1596), 1,
      anon_sym_lambda,
    ACTIONS(1840), 1,
      sym_identifier,
    ACTIONS(1842), 1,
      anon_sym_LPAREN,
    ACTIONS(1848), 1,
      anon_sym_STAR,
    ACTIONS(1852), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1854), 1,
      anon_sym_type,
    ACTIONS(1856), 1,
      anon_sym_await,
    ACTIONS(1906), 1,
      anon_sym_RPAREN,
    ACTIONS(1908), 1,
      anon_sym_COMMA,
    STATE(1271), 1,
      sym_string,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1530), 1,
      sym_list_splat_pattern,
    STATE(2081), 1,
      sym_expression,
    STATE(3018), 1,
      sym_parenthesized_list_splat,
    STATE(3306), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(3016), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(828), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1850), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2173), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1660), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [8522] = 22,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(396), 1,
      anon_sym_TILDE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(1868), 1,
      sym_identifier,
    ACTIONS(1870), 1,
      anon_sym_LPAREN,
    ACTIONS(1872), 1,
      anon_sym_STAR,
    ACTIONS(1876), 1,
      anon_sym_type,
    ACTIONS(1878), 1,
      anon_sym_LBRACK,
    ACTIONS(1880), 1,
      anon_sym_await,
    STATE(1234), 1,
      sym_string,
    STATE(1770), 1,
      sym_list_splat_pattern,
    STATE(1968), 1,
      sym_primary_expression,
    STATE(2007), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(498), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1768), 2,
      sym_attribute,
      sym_subscript,
    STATE(2015), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1874), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1536), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
    ACTIONS(1758), 15,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [8627] = 26,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(1722), 1,
      sym_identifier,
    ACTIONS(1724), 1,
      anon_sym_STAR,
    ACTIONS(1728), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1730), 1,
      anon_sym_type,
    ACTIONS(1732), 1,
      anon_sym_await,
    ACTIONS(1910), 1,
      sym__newline,
    ACTIONS(1912), 1,
      sym__indent,
    STATE(1200), 1,
      sym_string,
    STATE(1203), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    STATE(2311), 1,
      sym_expression,
    STATE(3427), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1726), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(3141), 4,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
      sym__directive_parameter,
    STATE(2070), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [8740] = 26,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(1722), 1,
      sym_identifier,
    ACTIONS(1724), 1,
      anon_sym_STAR,
    ACTIONS(1728), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1730), 1,
      anon_sym_type,
    ACTIONS(1732), 1,
      anon_sym_await,
    ACTIONS(1914), 1,
      sym__newline,
    ACTIONS(1916), 1,
      sym__indent,
    STATE(1200), 1,
      sym_string,
    STATE(1203), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    STATE(2311), 1,
      sym_expression,
    STATE(3427), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1726), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(3141), 4,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
      sym__directive_parameter,
    STATE(2070), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [8853] = 25,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1764), 1,
      sym_identifier,
    ACTIONS(1766), 1,
      anon_sym_STAR,
    ACTIONS(1770), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2151), 1,
      sym_expression,
    STATE(2308), 1,
      sym_type,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2519), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [8964] = 25,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1764), 1,
      sym_identifier,
    ACTIONS(1766), 1,
      anon_sym_STAR,
    ACTIONS(1770), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2151), 1,
      sym_expression,
    STATE(2392), 1,
      sym_type,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2519), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [9075] = 26,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(1722), 1,
      sym_identifier,
    ACTIONS(1724), 1,
      anon_sym_STAR,
    ACTIONS(1728), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1730), 1,
      anon_sym_type,
    ACTIONS(1732), 1,
      anon_sym_await,
    ACTIONS(1918), 1,
      sym__newline,
    ACTIONS(1920), 1,
      sym__indent,
    STATE(1200), 1,
      sym_string,
    STATE(1203), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    STATE(2311), 1,
      sym_expression,
    STATE(3427), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1726), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(3141), 4,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
      sym__directive_parameter,
    STATE(2070), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [9188] = 28,
    ACTIONS(840), 1,
      anon_sym_LBRACK,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(1586), 1,
      anon_sym_STAR,
    ACTIONS(1594), 1,
      anon_sym_not,
    ACTIONS(1596), 1,
      anon_sym_lambda,
    ACTIONS(1598), 1,
      anon_sym_yield,
    ACTIONS(1842), 1,
      anon_sym_LPAREN,
    ACTIONS(1922), 1,
      sym_identifier,
    ACTIONS(1924), 1,
      anon_sym_RPAREN,
    ACTIONS(1928), 1,
      anon_sym_type,
    ACTIONS(1930), 1,
      anon_sym_await,
    STATE(1271), 1,
      sym_string,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1530), 1,
      sym_list_splat_pattern,
    STATE(2099), 1,
      sym_expression,
    STATE(2740), 1,
      sym_with_item,
    STATE(2792), 1,
      sym_yield,
    STATE(3278), 1,
      sym__collection_elements,
    STATE(3306), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    STATE(2683), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(828), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1926), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2173), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1660), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [9305] = 25,
    ACTIONS(876), 1,
      anon_sym_LPAREN,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1824), 1,
      sym_identifier,
    ACTIONS(1826), 1,
      anon_sym_STAR,
    ACTIONS(1830), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1832), 1,
      anon_sym_type,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1838), 1,
      anon_sym_await,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2120), 1,
      sym_expression,
    STATE(2337), 1,
      sym_type,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1828), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2386), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [9416] = 27,
    ACTIONS(840), 1,
      anon_sym_LBRACK,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(1594), 1,
      anon_sym_not,
    ACTIONS(1596), 1,
      anon_sym_lambda,
    ACTIONS(1840), 1,
      sym_identifier,
    ACTIONS(1842), 1,
      anon_sym_LPAREN,
    ACTIONS(1848), 1,
      anon_sym_STAR,
    ACTIONS(1852), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1854), 1,
      anon_sym_type,
    ACTIONS(1856), 1,
      anon_sym_await,
    ACTIONS(1932), 1,
      anon_sym_RPAREN,
    ACTIONS(1934), 1,
      anon_sym_COMMA,
    STATE(1271), 1,
      sym_string,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1530), 1,
      sym_list_splat_pattern,
    STATE(2100), 1,
      sym_expression,
    STATE(2829), 1,
      sym_parenthesized_list_splat,
    STATE(3306), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2828), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(828), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1850), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2173), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1660), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [9531] = 27,
    ACTIONS(840), 1,
      anon_sym_LBRACK,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(1594), 1,
      anon_sym_not,
    ACTIONS(1596), 1,
      anon_sym_lambda,
    ACTIONS(1840), 1,
      sym_identifier,
    ACTIONS(1842), 1,
      anon_sym_LPAREN,
    ACTIONS(1848), 1,
      anon_sym_STAR,
    ACTIONS(1852), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1854), 1,
      anon_sym_type,
    ACTIONS(1856), 1,
      anon_sym_await,
    ACTIONS(1936), 1,
      anon_sym_RPAREN,
    ACTIONS(1938), 1,
      anon_sym_COMMA,
    STATE(1271), 1,
      sym_string,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1530), 1,
      sym_list_splat_pattern,
    STATE(2077), 1,
      sym_expression,
    STATE(2693), 1,
      sym_parenthesized_list_splat,
    STATE(3306), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2694), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(828), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1850), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2173), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1660), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [9646] = 25,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1764), 1,
      sym_identifier,
    ACTIONS(1766), 1,
      anon_sym_STAR,
    ACTIONS(1770), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2151), 1,
      sym_expression,
    STATE(2320), 1,
      sym_type,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2519), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [9757] = 25,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1764), 1,
      sym_identifier,
    ACTIONS(1766), 1,
      anon_sym_STAR,
    ACTIONS(1770), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2151), 1,
      sym_expression,
    STATE(2426), 1,
      sym_type,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2519), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [9868] = 25,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1764), 1,
      sym_identifier,
    ACTIONS(1766), 1,
      anon_sym_STAR,
    ACTIONS(1770), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2151), 1,
      sym_expression,
    STATE(2435), 1,
      sym_type,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2519), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [9979] = 26,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(1722), 1,
      sym_identifier,
    ACTIONS(1724), 1,
      anon_sym_STAR,
    ACTIONS(1728), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1730), 1,
      anon_sym_type,
    ACTIONS(1732), 1,
      anon_sym_await,
    ACTIONS(1940), 1,
      sym__newline,
    ACTIONS(1942), 1,
      sym__indent,
    STATE(1200), 1,
      sym_string,
    STATE(1203), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    STATE(2311), 1,
      sym_expression,
    STATE(3427), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1726), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(3141), 4,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
      sym__directive_parameter,
    STATE(2070), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [10092] = 25,
    ACTIONS(876), 1,
      anon_sym_LPAREN,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1824), 1,
      sym_identifier,
    ACTIONS(1826), 1,
      anon_sym_STAR,
    ACTIONS(1830), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1832), 1,
      anon_sym_type,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1838), 1,
      anon_sym_await,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2120), 1,
      sym_expression,
    STATE(2339), 1,
      sym_type,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1828), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2386), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [10203] = 25,
    ACTIONS(359), 1,
      sym_identifier,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(423), 1,
      anon_sym_STAR_STAR,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(1814), 1,
      anon_sym_STAR,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2153), 1,
      sym_expression,
    STATE(2726), 1,
      sym_type,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2508), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [10314] = 27,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1852), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1932), 1,
      anon_sym_RPAREN,
    ACTIONS(1934), 1,
      anon_sym_COMMA,
    ACTIONS(1944), 1,
      sym_identifier,
    ACTIONS(1946), 1,
      anon_sym_LPAREN,
    ACTIONS(1948), 1,
      anon_sym_STAR,
    ACTIONS(1952), 1,
      anon_sym_type,
    ACTIONS(1954), 1,
      anon_sym_await,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2289), 1,
      sym_expression,
    STATE(2829), 1,
      sym_parenthesized_list_splat,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2828), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1950), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [10429] = 25,
    ACTIONS(359), 1,
      sym_identifier,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(423), 1,
      anon_sym_STAR_STAR,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(1814), 1,
      anon_sym_STAR,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2153), 1,
      sym_expression,
    STATE(2464), 1,
      sym_type,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2508), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [10540] = 25,
    ACTIONS(781), 1,
      anon_sym_LPAREN,
    ACTIONS(789), 1,
      anon_sym_LBRACK,
    ACTIONS(793), 1,
      anon_sym_LBRACE,
    ACTIONS(799), 1,
      sym_string_start,
    ACTIONS(1792), 1,
      anon_sym_STAR,
    ACTIONS(1800), 1,
      anon_sym_not,
    ACTIONS(1802), 1,
      anon_sym_lambda,
    ACTIONS(1956), 1,
      sym_identifier,
    ACTIONS(1958), 1,
      anon_sym_from,
    ACTIONS(1964), 1,
      anon_sym_type,
    ACTIONS(1966), 1,
      anon_sym_await,
    STATE(1221), 1,
      sym_primary_expression,
    STATE(1223), 1,
      sym_string,
    STATE(1459), 1,
      sym_list_splat_pattern,
    STATE(2126), 1,
      sym_expression,
    STATE(2474), 1,
      sym_expression_list,
    STATE(3201), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(795), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(791), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(779), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1962), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(1960), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
    STATE(2139), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1449), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [10651] = 25,
    ACTIONS(359), 1,
      sym_identifier,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(423), 1,
      anon_sym_STAR_STAR,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(1814), 1,
      anon_sym_STAR,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2153), 1,
      sym_expression,
    STATE(2975), 1,
      sym_type,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2508), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [10762] = 27,
    ACTIONS(840), 1,
      anon_sym_LBRACK,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(1594), 1,
      anon_sym_not,
    ACTIONS(1596), 1,
      anon_sym_lambda,
    ACTIONS(1840), 1,
      sym_identifier,
    ACTIONS(1842), 1,
      anon_sym_LPAREN,
    ACTIONS(1848), 1,
      anon_sym_STAR,
    ACTIONS(1852), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1854), 1,
      anon_sym_type,
    ACTIONS(1856), 1,
      anon_sym_await,
    ACTIONS(1968), 1,
      anon_sym_RPAREN,
    ACTIONS(1970), 1,
      anon_sym_COMMA,
    STATE(1271), 1,
      sym_string,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1530), 1,
      sym_list_splat_pattern,
    STATE(2079), 1,
      sym_expression,
    STATE(2951), 1,
      sym_parenthesized_list_splat,
    STATE(3306), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2950), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(828), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1850), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2173), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1660), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [10877] = 25,
    ACTIONS(359), 1,
      sym_identifier,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(423), 1,
      anon_sym_STAR_STAR,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(1814), 1,
      anon_sym_STAR,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2153), 1,
      sym_expression,
    STATE(2725), 1,
      sym_type,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2508), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [10988] = 26,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(1722), 1,
      sym_identifier,
    ACTIONS(1724), 1,
      anon_sym_STAR,
    ACTIONS(1728), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1730), 1,
      anon_sym_type,
    ACTIONS(1732), 1,
      anon_sym_await,
    ACTIONS(1972), 1,
      sym__newline,
    ACTIONS(1974), 1,
      sym__indent,
    STATE(1200), 1,
      sym_string,
    STATE(1203), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    STATE(2311), 1,
      sym_expression,
    STATE(3427), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1726), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(3141), 4,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
      sym__directive_parameter,
    STATE(2070), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [11101] = 27,
    ACTIONS(840), 1,
      anon_sym_LBRACK,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(1594), 1,
      anon_sym_not,
    ACTIONS(1596), 1,
      anon_sym_lambda,
    ACTIONS(1840), 1,
      sym_identifier,
    ACTIONS(1842), 1,
      anon_sym_LPAREN,
    ACTIONS(1848), 1,
      anon_sym_STAR,
    ACTIONS(1852), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1854), 1,
      anon_sym_type,
    ACTIONS(1856), 1,
      anon_sym_await,
    ACTIONS(1976), 1,
      anon_sym_RPAREN,
    ACTIONS(1978), 1,
      anon_sym_COMMA,
    STATE(1271), 1,
      sym_string,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1530), 1,
      sym_list_splat_pattern,
    STATE(2082), 1,
      sym_expression,
    STATE(2783), 1,
      sym_parenthesized_list_splat,
    STATE(3306), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2775), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(828), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1850), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2173), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1660), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [11216] = 27,
    ACTIONS(840), 1,
      anon_sym_LBRACK,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(1594), 1,
      anon_sym_not,
    ACTIONS(1596), 1,
      anon_sym_lambda,
    ACTIONS(1840), 1,
      sym_identifier,
    ACTIONS(1842), 1,
      anon_sym_LPAREN,
    ACTIONS(1848), 1,
      anon_sym_STAR,
    ACTIONS(1852), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1854), 1,
      anon_sym_type,
    ACTIONS(1856), 1,
      anon_sym_await,
    ACTIONS(1980), 1,
      anon_sym_RPAREN,
    ACTIONS(1982), 1,
      anon_sym_COMMA,
    STATE(1271), 1,
      sym_string,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1530), 1,
      sym_list_splat_pattern,
    STATE(2092), 1,
      sym_expression,
    STATE(2931), 1,
      sym_parenthesized_list_splat,
    STATE(3306), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2932), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(828), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1850), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2173), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1660), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [11331] = 25,
    ACTIONS(359), 1,
      sym_identifier,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(423), 1,
      anon_sym_STAR_STAR,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(1814), 1,
      anon_sym_STAR,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2153), 1,
      sym_expression,
    STATE(2937), 1,
      sym_type,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2508), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [11442] = 25,
    ACTIONS(359), 1,
      sym_identifier,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(423), 1,
      anon_sym_STAR_STAR,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(1814), 1,
      anon_sym_STAR,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2153), 1,
      sym_expression,
    STATE(2466), 1,
      sym_type,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2508), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [11553] = 25,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(477), 1,
      anon_sym_type,
    ACTIONS(488), 1,
      anon_sym_await,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(1858), 1,
      sym_identifier,
    ACTIONS(1860), 1,
      anon_sym_STAR,
    ACTIONS(1862), 1,
      anon_sym_STAR_STAR,
    STATE(1200), 1,
      sym_string,
    STATE(1203), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    STATE(2113), 1,
      sym_expression,
    STATE(2465), 1,
      sym_type,
    STATE(3427), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(473), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2329), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(2070), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [11664] = 25,
    ACTIONS(359), 1,
      sym_identifier,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(423), 1,
      anon_sym_STAR_STAR,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(1814), 1,
      anon_sym_STAR,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2153), 1,
      sym_expression,
    STATE(2723), 1,
      sym_type,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2508), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [11775] = 25,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(1984), 1,
      sym_identifier,
    ACTIONS(1986), 1,
      anon_sym_STAR,
    ACTIONS(1990), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1992), 1,
      anon_sym_type,
    ACTIONS(1994), 1,
      anon_sym_not,
    ACTIONS(1996), 1,
      anon_sym_lambda,
    ACTIONS(1998), 1,
      anon_sym_await,
    ACTIONS(2000), 1,
      sym__dedent,
    STATE(1488), 1,
      sym_string,
    STATE(1491), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    STATE(2376), 1,
      sym_expression,
    STATE(3239), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(942), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1988), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(3138), 4,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
      sym__directive_parameter,
    STATE(2383), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [11885] = 26,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1852), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1944), 1,
      sym_identifier,
    ACTIONS(1946), 1,
      anon_sym_LPAREN,
    ACTIONS(1948), 1,
      anon_sym_STAR,
    ACTIONS(1952), 1,
      anon_sym_type,
    ACTIONS(1954), 1,
      anon_sym_await,
    ACTIONS(2002), 1,
      anon_sym_RPAREN,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2335), 1,
      sym_expression,
    STATE(3118), 1,
      sym_parenthesized_list_splat,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(3119), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1950), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [11997] = 26,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1852), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1944), 1,
      sym_identifier,
    ACTIONS(1946), 1,
      anon_sym_LPAREN,
    ACTIONS(1948), 1,
      anon_sym_STAR,
    ACTIONS(1952), 1,
      anon_sym_type,
    ACTIONS(1954), 1,
      anon_sym_await,
    ACTIONS(2004), 1,
      anon_sym_RPAREN,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2335), 1,
      sym_expression,
    STATE(3118), 1,
      sym_parenthesized_list_splat,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(3119), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1950), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [12109] = 26,
    ACTIONS(928), 1,
      anon_sym_LBRACK,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_string_start,
    ACTIONS(1634), 1,
      anon_sym_STAR,
    ACTIONS(1644), 1,
      anon_sym_not,
    ACTIONS(1646), 1,
      anon_sym_lambda,
    ACTIONS(1648), 1,
      anon_sym_yield,
    ACTIONS(2006), 1,
      sym_identifier,
    ACTIONS(2008), 1,
      anon_sym_LPAREN,
    ACTIONS(2012), 1,
      anon_sym_type,
    ACTIONS(2014), 1,
      anon_sym_RBRACK,
    ACTIONS(2016), 1,
      anon_sym_await,
    STATE(1264), 1,
      sym_primary_expression,
    STATE(1279), 1,
      sym_string,
    STATE(1590), 1,
      sym_list_splat_pattern,
    STATE(2075), 1,
      sym_expression,
    STATE(3166), 1,
      sym__collection_elements,
    STATE(3184), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(934), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(930), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2912), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(918), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2010), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2189), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1654), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [12221] = 25,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(1984), 1,
      sym_identifier,
    ACTIONS(1986), 1,
      anon_sym_STAR,
    ACTIONS(1990), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1992), 1,
      anon_sym_type,
    ACTIONS(1994), 1,
      anon_sym_not,
    ACTIONS(1996), 1,
      anon_sym_lambda,
    ACTIONS(1998), 1,
      anon_sym_await,
    ACTIONS(2018), 1,
      sym__dedent,
    STATE(1488), 1,
      sym_string,
    STATE(1491), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    STATE(2376), 1,
      sym_expression,
    STATE(3239), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(942), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1988), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(3138), 4,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
      sym__directive_parameter,
    STATE(2383), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [12331] = 27,
    ACTIONS(840), 1,
      anon_sym_LBRACK,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(1586), 1,
      anon_sym_STAR,
    ACTIONS(1594), 1,
      anon_sym_not,
    ACTIONS(1596), 1,
      anon_sym_lambda,
    ACTIONS(1598), 1,
      anon_sym_yield,
    ACTIONS(1842), 1,
      anon_sym_LPAREN,
    ACTIONS(1922), 1,
      sym_identifier,
    ACTIONS(1928), 1,
      anon_sym_type,
    ACTIONS(1930), 1,
      anon_sym_await,
    ACTIONS(2020), 1,
      anon_sym_RPAREN,
    STATE(1271), 1,
      sym_string,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1530), 1,
      sym_list_splat_pattern,
    STATE(2097), 1,
      sym_expression,
    STATE(2752), 1,
      sym_yield,
    STATE(3306), 1,
      sym__named_expression_lhs,
    STATE(3322), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    STATE(2683), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(828), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1926), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2173), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1660), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [12445] = 26,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1852), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1944), 1,
      sym_identifier,
    ACTIONS(1946), 1,
      anon_sym_LPAREN,
    ACTIONS(1948), 1,
      anon_sym_STAR,
    ACTIONS(1952), 1,
      anon_sym_type,
    ACTIONS(1954), 1,
      anon_sym_await,
    ACTIONS(2022), 1,
      anon_sym_RPAREN,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2335), 1,
      sym_expression,
    STATE(3118), 1,
      sym_parenthesized_list_splat,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(3119), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1950), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [12557] = 26,
    ACTIONS(928), 1,
      anon_sym_LBRACK,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_string_start,
    ACTIONS(1634), 1,
      anon_sym_STAR,
    ACTIONS(1644), 1,
      anon_sym_not,
    ACTIONS(1646), 1,
      anon_sym_lambda,
    ACTIONS(1648), 1,
      anon_sym_yield,
    ACTIONS(2006), 1,
      sym_identifier,
    ACTIONS(2008), 1,
      anon_sym_LPAREN,
    ACTIONS(2012), 1,
      anon_sym_type,
    ACTIONS(2016), 1,
      anon_sym_await,
    ACTIONS(2024), 1,
      anon_sym_RBRACK,
    STATE(1264), 1,
      sym_primary_expression,
    STATE(1279), 1,
      sym_string,
    STATE(1590), 1,
      sym_list_splat_pattern,
    STATE(2095), 1,
      sym_expression,
    STATE(3184), 1,
      sym__named_expression_lhs,
    STATE(3225), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(934), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(930), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2912), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(918), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2010), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2189), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1654), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [12669] = 26,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1852), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1944), 1,
      sym_identifier,
    ACTIONS(1946), 1,
      anon_sym_LPAREN,
    ACTIONS(1948), 1,
      anon_sym_STAR,
    ACTIONS(1952), 1,
      anon_sym_type,
    ACTIONS(1954), 1,
      anon_sym_await,
    ACTIONS(2026), 1,
      anon_sym_RPAREN,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2335), 1,
      sym_expression,
    STATE(3118), 1,
      sym_parenthesized_list_splat,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(3119), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1950), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [12781] = 25,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(1984), 1,
      sym_identifier,
    ACTIONS(1986), 1,
      anon_sym_STAR,
    ACTIONS(1990), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1992), 1,
      anon_sym_type,
    ACTIONS(1994), 1,
      anon_sym_not,
    ACTIONS(1996), 1,
      anon_sym_lambda,
    ACTIONS(1998), 1,
      anon_sym_await,
    ACTIONS(2028), 1,
      sym__dedent,
    STATE(1488), 1,
      sym_string,
    STATE(1491), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    STATE(2376), 1,
      sym_expression,
    STATE(3239), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(942), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1988), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(3138), 4,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
      sym__directive_parameter,
    STATE(2383), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [12891] = 28,
    ACTIONS(840), 1,
      anon_sym_LBRACK,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(1586), 1,
      anon_sym_STAR,
    ACTIONS(1594), 1,
      anon_sym_not,
    ACTIONS(1596), 1,
      anon_sym_lambda,
    ACTIONS(1598), 1,
      anon_sym_yield,
    ACTIONS(1842), 1,
      anon_sym_LPAREN,
    ACTIONS(1922), 1,
      sym_identifier,
    ACTIONS(1928), 1,
      anon_sym_type,
    ACTIONS(1930), 1,
      anon_sym_await,
    ACTIONS(2030), 1,
      anon_sym_RPAREN,
    STATE(1271), 1,
      sym_string,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1530), 1,
      sym_list_splat_pattern,
    STATE(2085), 1,
      sym_expression,
    STATE(2714), 1,
      sym_list_splat,
    STATE(2717), 1,
      sym_parenthesized_list_splat,
    STATE(2942), 1,
      sym_yield,
    STATE(3228), 1,
      sym__collection_elements,
    STATE(3306), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(828), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1926), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2173), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1660), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [13007] = 25,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(1984), 1,
      sym_identifier,
    ACTIONS(1986), 1,
      anon_sym_STAR,
    ACTIONS(1990), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1992), 1,
      anon_sym_type,
    ACTIONS(1994), 1,
      anon_sym_not,
    ACTIONS(1996), 1,
      anon_sym_lambda,
    ACTIONS(1998), 1,
      anon_sym_await,
    ACTIONS(2032), 1,
      sym__dedent,
    STATE(1488), 1,
      sym_string,
    STATE(1491), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    STATE(2376), 1,
      sym_expression,
    STATE(3239), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(942), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1988), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(3138), 4,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
      sym__directive_parameter,
    STATE(2383), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [13117] = 26,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1852), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1944), 1,
      sym_identifier,
    ACTIONS(1946), 1,
      anon_sym_LPAREN,
    ACTIONS(1948), 1,
      anon_sym_STAR,
    ACTIONS(1952), 1,
      anon_sym_type,
    ACTIONS(1954), 1,
      anon_sym_await,
    ACTIONS(2034), 1,
      anon_sym_RPAREN,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2335), 1,
      sym_expression,
    STATE(3118), 1,
      sym_parenthesized_list_splat,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(3119), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1950), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [13229] = 25,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(1984), 1,
      sym_identifier,
    ACTIONS(1986), 1,
      anon_sym_STAR,
    ACTIONS(1990), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1992), 1,
      anon_sym_type,
    ACTIONS(1994), 1,
      anon_sym_not,
    ACTIONS(1996), 1,
      anon_sym_lambda,
    ACTIONS(1998), 1,
      anon_sym_await,
    ACTIONS(2036), 1,
      sym__dedent,
    STATE(1488), 1,
      sym_string,
    STATE(1491), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    STATE(2376), 1,
      sym_expression,
    STATE(3239), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(942), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1988), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2667), 4,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
      sym__directive_parameter,
    STATE(2383), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [13339] = 25,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(1984), 1,
      sym_identifier,
    ACTIONS(1986), 1,
      anon_sym_STAR,
    ACTIONS(1990), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1992), 1,
      anon_sym_type,
    ACTIONS(1994), 1,
      anon_sym_not,
    ACTIONS(1996), 1,
      anon_sym_lambda,
    ACTIONS(1998), 1,
      anon_sym_await,
    ACTIONS(2038), 1,
      sym__dedent,
    STATE(1488), 1,
      sym_string,
    STATE(1491), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    STATE(2376), 1,
      sym_expression,
    STATE(3239), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(942), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1988), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(3021), 4,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
      sym__directive_parameter,
    STATE(2383), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [13449] = 25,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(1984), 1,
      sym_identifier,
    ACTIONS(1986), 1,
      anon_sym_STAR,
    ACTIONS(1990), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1992), 1,
      anon_sym_type,
    ACTIONS(1994), 1,
      anon_sym_not,
    ACTIONS(1996), 1,
      anon_sym_lambda,
    ACTIONS(1998), 1,
      anon_sym_await,
    ACTIONS(2040), 1,
      sym__dedent,
    STATE(1488), 1,
      sym_string,
    STATE(1491), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    STATE(2376), 1,
      sym_expression,
    STATE(3239), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(942), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1988), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(3138), 4,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
      sym__directive_parameter,
    STATE(2383), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [13559] = 25,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(1984), 1,
      sym_identifier,
    ACTIONS(1986), 1,
      anon_sym_STAR,
    ACTIONS(1990), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1992), 1,
      anon_sym_type,
    ACTIONS(1994), 1,
      anon_sym_not,
    ACTIONS(1996), 1,
      anon_sym_lambda,
    ACTIONS(1998), 1,
      anon_sym_await,
    ACTIONS(2042), 1,
      sym__dedent,
    STATE(1488), 1,
      sym_string,
    STATE(1491), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    STATE(2376), 1,
      sym_expression,
    STATE(3239), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(942), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1988), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(3138), 4,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
      sym__directive_parameter,
    STATE(2383), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [13669] = 26,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1852), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1944), 1,
      sym_identifier,
    ACTIONS(1946), 1,
      anon_sym_LPAREN,
    ACTIONS(1948), 1,
      anon_sym_STAR,
    ACTIONS(1952), 1,
      anon_sym_type,
    ACTIONS(1954), 1,
      anon_sym_await,
    ACTIONS(2044), 1,
      anon_sym_RPAREN,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2335), 1,
      sym_expression,
    STATE(3118), 1,
      sym_parenthesized_list_splat,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(3119), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1950), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [13781] = 27,
    ACTIONS(840), 1,
      anon_sym_LBRACK,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(1586), 1,
      anon_sym_STAR,
    ACTIONS(1594), 1,
      anon_sym_not,
    ACTIONS(1596), 1,
      anon_sym_lambda,
    ACTIONS(1598), 1,
      anon_sym_yield,
    ACTIONS(1842), 1,
      anon_sym_LPAREN,
    ACTIONS(1922), 1,
      sym_identifier,
    ACTIONS(1928), 1,
      anon_sym_type,
    ACTIONS(1930), 1,
      anon_sym_await,
    ACTIONS(2046), 1,
      anon_sym_RPAREN,
    STATE(1271), 1,
      sym_string,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1530), 1,
      sym_list_splat_pattern,
    STATE(2090), 1,
      sym_expression,
    STATE(2919), 1,
      sym_yield,
    STATE(3178), 1,
      sym__collection_elements,
    STATE(3306), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    STATE(2683), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(828), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1926), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2173), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1660), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [13895] = 26,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1852), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1944), 1,
      sym_identifier,
    ACTIONS(1946), 1,
      anon_sym_LPAREN,
    ACTIONS(1948), 1,
      anon_sym_STAR,
    ACTIONS(1952), 1,
      anon_sym_type,
    ACTIONS(1954), 1,
      anon_sym_await,
    ACTIONS(2048), 1,
      anon_sym_RPAREN,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2335), 1,
      sym_expression,
    STATE(3118), 1,
      sym_parenthesized_list_splat,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(3119), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1950), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [14007] = 25,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(1984), 1,
      sym_identifier,
    ACTIONS(1986), 1,
      anon_sym_STAR,
    ACTIONS(1990), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1992), 1,
      anon_sym_type,
    ACTIONS(1994), 1,
      anon_sym_not,
    ACTIONS(1996), 1,
      anon_sym_lambda,
    ACTIONS(1998), 1,
      anon_sym_await,
    ACTIONS(2050), 1,
      sym__dedent,
    STATE(1488), 1,
      sym_string,
    STATE(1491), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    STATE(2376), 1,
      sym_expression,
    STATE(3239), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(942), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1988), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2948), 4,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
      sym__directive_parameter,
    STATE(2383), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [14117] = 25,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(1984), 1,
      sym_identifier,
    ACTIONS(1986), 1,
      anon_sym_STAR,
    ACTIONS(1990), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1992), 1,
      anon_sym_type,
    ACTIONS(1994), 1,
      anon_sym_not,
    ACTIONS(1996), 1,
      anon_sym_lambda,
    ACTIONS(1998), 1,
      anon_sym_await,
    ACTIONS(2052), 1,
      sym__dedent,
    STATE(1488), 1,
      sym_string,
    STATE(1491), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    STATE(2376), 1,
      sym_expression,
    STATE(3239), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(942), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1988), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(3138), 4,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
      sym__directive_parameter,
    STATE(2383), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [14227] = 26,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1852), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1944), 1,
      sym_identifier,
    ACTIONS(1946), 1,
      anon_sym_LPAREN,
    ACTIONS(1948), 1,
      anon_sym_STAR,
    ACTIONS(1952), 1,
      anon_sym_type,
    ACTIONS(1954), 1,
      anon_sym_await,
    ACTIONS(2054), 1,
      anon_sym_RPAREN,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2335), 1,
      sym_expression,
    STATE(3118), 1,
      sym_parenthesized_list_splat,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(3119), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1950), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [14339] = 25,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(1984), 1,
      sym_identifier,
    ACTIONS(1986), 1,
      anon_sym_STAR,
    ACTIONS(1990), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1992), 1,
      anon_sym_type,
    ACTIONS(1994), 1,
      anon_sym_not,
    ACTIONS(1996), 1,
      anon_sym_lambda,
    ACTIONS(1998), 1,
      anon_sym_await,
    ACTIONS(2050), 1,
      sym__dedent,
    STATE(1488), 1,
      sym_string,
    STATE(1491), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    STATE(2376), 1,
      sym_expression,
    STATE(3239), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(942), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1988), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(3138), 4,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
      sym__directive_parameter,
    STATE(2383), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [14449] = 25,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(1984), 1,
      sym_identifier,
    ACTIONS(1986), 1,
      anon_sym_STAR,
    ACTIONS(1990), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1992), 1,
      anon_sym_type,
    ACTIONS(1994), 1,
      anon_sym_not,
    ACTIONS(1996), 1,
      anon_sym_lambda,
    ACTIONS(1998), 1,
      anon_sym_await,
    ACTIONS(2056), 1,
      sym__dedent,
    STATE(1488), 1,
      sym_string,
    STATE(1491), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    STATE(2376), 1,
      sym_expression,
    STATE(3239), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(942), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1988), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2955), 4,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
      sym__directive_parameter,
    STATE(2383), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [14559] = 25,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(1984), 1,
      sym_identifier,
    ACTIONS(1986), 1,
      anon_sym_STAR,
    ACTIONS(1990), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1992), 1,
      anon_sym_type,
    ACTIONS(1994), 1,
      anon_sym_not,
    ACTIONS(1996), 1,
      anon_sym_lambda,
    ACTIONS(1998), 1,
      anon_sym_await,
    ACTIONS(2058), 1,
      sym__dedent,
    STATE(1488), 1,
      sym_string,
    STATE(1491), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    STATE(2376), 1,
      sym_expression,
    STATE(3239), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(942), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1988), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(3138), 4,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
      sym__directive_parameter,
    STATE(2383), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [14669] = 26,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1852), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1944), 1,
      sym_identifier,
    ACTIONS(1946), 1,
      anon_sym_LPAREN,
    ACTIONS(1948), 1,
      anon_sym_STAR,
    ACTIONS(1952), 1,
      anon_sym_type,
    ACTIONS(1954), 1,
      anon_sym_await,
    ACTIONS(2060), 1,
      anon_sym_RPAREN,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2335), 1,
      sym_expression,
    STATE(3118), 1,
      sym_parenthesized_list_splat,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(3119), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1950), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [14781] = 25,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(1984), 1,
      sym_identifier,
    ACTIONS(1986), 1,
      anon_sym_STAR,
    ACTIONS(1990), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1992), 1,
      anon_sym_type,
    ACTIONS(1994), 1,
      anon_sym_not,
    ACTIONS(1996), 1,
      anon_sym_lambda,
    ACTIONS(1998), 1,
      anon_sym_await,
    ACTIONS(2056), 1,
      sym__dedent,
    STATE(1488), 1,
      sym_string,
    STATE(1491), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    STATE(2376), 1,
      sym_expression,
    STATE(3239), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(942), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1988), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(3138), 4,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
      sym__directive_parameter,
    STATE(2383), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [14891] = 26,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1852), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1944), 1,
      sym_identifier,
    ACTIONS(1946), 1,
      anon_sym_LPAREN,
    ACTIONS(1948), 1,
      anon_sym_STAR,
    ACTIONS(1952), 1,
      anon_sym_type,
    ACTIONS(1954), 1,
      anon_sym_await,
    ACTIONS(2062), 1,
      anon_sym_RPAREN,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2335), 1,
      sym_expression,
    STATE(3118), 1,
      sym_parenthesized_list_splat,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(3119), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1950), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [15003] = 25,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(1984), 1,
      sym_identifier,
    ACTIONS(1986), 1,
      anon_sym_STAR,
    ACTIONS(1990), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1992), 1,
      anon_sym_type,
    ACTIONS(1994), 1,
      anon_sym_not,
    ACTIONS(1996), 1,
      anon_sym_lambda,
    ACTIONS(1998), 1,
      anon_sym_await,
    ACTIONS(2058), 1,
      sym__dedent,
    STATE(1488), 1,
      sym_string,
    STATE(1491), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    STATE(2376), 1,
      sym_expression,
    STATE(3239), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(942), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1988), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2732), 4,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
      sym__directive_parameter,
    STATE(2383), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [15113] = 25,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(1972), 1,
      sym__dedent,
    ACTIONS(1984), 1,
      sym_identifier,
    ACTIONS(1986), 1,
      anon_sym_STAR,
    ACTIONS(1990), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1992), 1,
      anon_sym_type,
    ACTIONS(1994), 1,
      anon_sym_not,
    ACTIONS(1996), 1,
      anon_sym_lambda,
    ACTIONS(1998), 1,
      anon_sym_await,
    STATE(1488), 1,
      sym_string,
    STATE(1491), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    STATE(2376), 1,
      sym_expression,
    STATE(3239), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(942), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1988), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(3138), 4,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
      sym__directive_parameter,
    STATE(2383), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [15223] = 26,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1852), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1944), 1,
      sym_identifier,
    ACTIONS(1946), 1,
      anon_sym_LPAREN,
    ACTIONS(1948), 1,
      anon_sym_STAR,
    ACTIONS(1952), 1,
      anon_sym_type,
    ACTIONS(1954), 1,
      anon_sym_await,
    ACTIONS(2064), 1,
      anon_sym_RPAREN,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2335), 1,
      sym_expression,
    STATE(3118), 1,
      sym_parenthesized_list_splat,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(3119), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1950), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [15335] = 25,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(1972), 1,
      sym__dedent,
    ACTIONS(1984), 1,
      sym_identifier,
    ACTIONS(1986), 1,
      anon_sym_STAR,
    ACTIONS(1990), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1992), 1,
      anon_sym_type,
    ACTIONS(1994), 1,
      anon_sym_not,
    ACTIONS(1996), 1,
      anon_sym_lambda,
    ACTIONS(1998), 1,
      anon_sym_await,
    STATE(1488), 1,
      sym_string,
    STATE(1491), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    STATE(2376), 1,
      sym_expression,
    STATE(3239), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(942), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1988), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2985), 4,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
      sym__directive_parameter,
    STATE(2383), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [15445] = 26,
    ACTIONS(928), 1,
      anon_sym_LBRACK,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_string_start,
    ACTIONS(1634), 1,
      anon_sym_STAR,
    ACTIONS(1644), 1,
      anon_sym_not,
    ACTIONS(1646), 1,
      anon_sym_lambda,
    ACTIONS(1648), 1,
      anon_sym_yield,
    ACTIONS(2006), 1,
      sym_identifier,
    ACTIONS(2008), 1,
      anon_sym_LPAREN,
    ACTIONS(2012), 1,
      anon_sym_type,
    ACTIONS(2016), 1,
      anon_sym_await,
    ACTIONS(2066), 1,
      anon_sym_RBRACK,
    STATE(1264), 1,
      sym_primary_expression,
    STATE(1279), 1,
      sym_string,
    STATE(1590), 1,
      sym_list_splat_pattern,
    STATE(2102), 1,
      sym_expression,
    STATE(3184), 1,
      sym__named_expression_lhs,
    STATE(3192), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(934), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(930), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2912), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(918), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2010), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2189), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1654), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [15557] = 27,
    ACTIONS(840), 1,
      anon_sym_LBRACK,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(1586), 1,
      anon_sym_STAR,
    ACTIONS(1594), 1,
      anon_sym_not,
    ACTIONS(1596), 1,
      anon_sym_lambda,
    ACTIONS(1598), 1,
      anon_sym_yield,
    ACTIONS(1842), 1,
      anon_sym_LPAREN,
    ACTIONS(1922), 1,
      sym_identifier,
    ACTIONS(1928), 1,
      anon_sym_type,
    ACTIONS(1930), 1,
      anon_sym_await,
    ACTIONS(2068), 1,
      anon_sym_RPAREN,
    STATE(1271), 1,
      sym_string,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1530), 1,
      sym_list_splat_pattern,
    STATE(2103), 1,
      sym_expression,
    STATE(2986), 1,
      sym_yield,
    STATE(3306), 1,
      sym__named_expression_lhs,
    STATE(3315), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    STATE(2683), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(828), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1926), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2173), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1660), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [15671] = 26,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1852), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1944), 1,
      sym_identifier,
    ACTIONS(1946), 1,
      anon_sym_LPAREN,
    ACTIONS(1948), 1,
      anon_sym_STAR,
    ACTIONS(1952), 1,
      anon_sym_type,
    ACTIONS(1954), 1,
      anon_sym_await,
    ACTIONS(2070), 1,
      anon_sym_RPAREN,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2335), 1,
      sym_expression,
    STATE(3118), 1,
      sym_parenthesized_list_splat,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(3119), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1950), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [15783] = 28,
    ACTIONS(840), 1,
      anon_sym_LBRACK,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(1586), 1,
      anon_sym_STAR,
    ACTIONS(1594), 1,
      anon_sym_not,
    ACTIONS(1596), 1,
      anon_sym_lambda,
    ACTIONS(1598), 1,
      anon_sym_yield,
    ACTIONS(1842), 1,
      anon_sym_LPAREN,
    ACTIONS(1922), 1,
      sym_identifier,
    ACTIONS(1928), 1,
      anon_sym_type,
    ACTIONS(1930), 1,
      anon_sym_await,
    ACTIONS(2068), 1,
      anon_sym_RPAREN,
    STATE(1271), 1,
      sym_string,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1530), 1,
      sym_list_splat_pattern,
    STATE(2103), 1,
      sym_expression,
    STATE(2813), 1,
      sym_list_splat,
    STATE(2814), 1,
      sym_parenthesized_list_splat,
    STATE(2986), 1,
      sym_yield,
    STATE(3306), 1,
      sym__named_expression_lhs,
    STATE(3315), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(828), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1926), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2173), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1660), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [15899] = 27,
    ACTIONS(840), 1,
      anon_sym_LBRACK,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(1586), 1,
      anon_sym_STAR,
    ACTIONS(1594), 1,
      anon_sym_not,
    ACTIONS(1596), 1,
      anon_sym_lambda,
    ACTIONS(1598), 1,
      anon_sym_yield,
    ACTIONS(1842), 1,
      anon_sym_LPAREN,
    ACTIONS(1922), 1,
      sym_identifier,
    ACTIONS(1928), 1,
      anon_sym_type,
    ACTIONS(1930), 1,
      anon_sym_await,
    ACTIONS(2030), 1,
      anon_sym_RPAREN,
    STATE(1271), 1,
      sym_string,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1530), 1,
      sym_list_splat_pattern,
    STATE(2085), 1,
      sym_expression,
    STATE(2942), 1,
      sym_yield,
    STATE(3228), 1,
      sym__collection_elements,
    STATE(3306), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    STATE(2683), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(828), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1926), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2173), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1660), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [16013] = 26,
    ACTIONS(928), 1,
      anon_sym_LBRACK,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_string_start,
    ACTIONS(1634), 1,
      anon_sym_STAR,
    ACTIONS(1644), 1,
      anon_sym_not,
    ACTIONS(1646), 1,
      anon_sym_lambda,
    ACTIONS(1648), 1,
      anon_sym_yield,
    ACTIONS(2006), 1,
      sym_identifier,
    ACTIONS(2008), 1,
      anon_sym_LPAREN,
    ACTIONS(2012), 1,
      anon_sym_type,
    ACTIONS(2016), 1,
      anon_sym_await,
    ACTIONS(2072), 1,
      anon_sym_RBRACK,
    STATE(1264), 1,
      sym_primary_expression,
    STATE(1279), 1,
      sym_string,
    STATE(1590), 1,
      sym_list_splat_pattern,
    STATE(2086), 1,
      sym_expression,
    STATE(3184), 1,
      sym__named_expression_lhs,
    STATE(3426), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(934), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(930), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2912), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(918), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2010), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2189), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1654), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [16125] = 25,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(1940), 1,
      sym__dedent,
    ACTIONS(1984), 1,
      sym_identifier,
    ACTIONS(1986), 1,
      anon_sym_STAR,
    ACTIONS(1990), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1992), 1,
      anon_sym_type,
    ACTIONS(1994), 1,
      anon_sym_not,
    ACTIONS(1996), 1,
      anon_sym_lambda,
    ACTIONS(1998), 1,
      anon_sym_await,
    STATE(1488), 1,
      sym_string,
    STATE(1491), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    STATE(2376), 1,
      sym_expression,
    STATE(3239), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(942), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1988), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2964), 4,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
      sym__directive_parameter,
    STATE(2383), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [16235] = 26,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1852), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1944), 1,
      sym_identifier,
    ACTIONS(1946), 1,
      anon_sym_LPAREN,
    ACTIONS(1948), 1,
      anon_sym_STAR,
    ACTIONS(1952), 1,
      anon_sym_type,
    ACTIONS(1954), 1,
      anon_sym_await,
    ACTIONS(2074), 1,
      anon_sym_RPAREN,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2335), 1,
      sym_expression,
    STATE(3118), 1,
      sym_parenthesized_list_splat,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(3119), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1950), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [16347] = 26,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1852), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1944), 1,
      sym_identifier,
    ACTIONS(1946), 1,
      anon_sym_LPAREN,
    ACTIONS(1948), 1,
      anon_sym_STAR,
    ACTIONS(1952), 1,
      anon_sym_type,
    ACTIONS(1954), 1,
      anon_sym_await,
    ACTIONS(2076), 1,
      anon_sym_RPAREN,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2335), 1,
      sym_expression,
    STATE(3118), 1,
      sym_parenthesized_list_splat,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(3119), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1950), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [16459] = 26,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1852), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1944), 1,
      sym_identifier,
    ACTIONS(1946), 1,
      anon_sym_LPAREN,
    ACTIONS(1948), 1,
      anon_sym_STAR,
    ACTIONS(1952), 1,
      anon_sym_type,
    ACTIONS(1954), 1,
      anon_sym_await,
    ACTIONS(2078), 1,
      anon_sym_RPAREN,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2335), 1,
      sym_expression,
    STATE(3118), 1,
      sym_parenthesized_list_splat,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(3119), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1950), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [16571] = 25,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(1940), 1,
      sym__dedent,
    ACTIONS(1984), 1,
      sym_identifier,
    ACTIONS(1986), 1,
      anon_sym_STAR,
    ACTIONS(1990), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1992), 1,
      anon_sym_type,
    ACTIONS(1994), 1,
      anon_sym_not,
    ACTIONS(1996), 1,
      anon_sym_lambda,
    ACTIONS(1998), 1,
      anon_sym_await,
    STATE(1488), 1,
      sym_string,
    STATE(1491), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    STATE(2376), 1,
      sym_expression,
    STATE(3239), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(942), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1988), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(3138), 4,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
      sym__directive_parameter,
    STATE(2383), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [16681] = 28,
    ACTIONS(840), 1,
      anon_sym_LBRACK,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(1586), 1,
      anon_sym_STAR,
    ACTIONS(1594), 1,
      anon_sym_not,
    ACTIONS(1596), 1,
      anon_sym_lambda,
    ACTIONS(1598), 1,
      anon_sym_yield,
    ACTIONS(1842), 1,
      anon_sym_LPAREN,
    ACTIONS(1922), 1,
      sym_identifier,
    ACTIONS(1928), 1,
      anon_sym_type,
    ACTIONS(1930), 1,
      anon_sym_await,
    ACTIONS(2046), 1,
      anon_sym_RPAREN,
    STATE(1271), 1,
      sym_string,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1530), 1,
      sym_list_splat_pattern,
    STATE(2090), 1,
      sym_expression,
    STATE(2719), 1,
      sym_parenthesized_list_splat,
    STATE(2721), 1,
      sym_list_splat,
    STATE(2919), 1,
      sym_yield,
    STATE(3178), 1,
      sym__collection_elements,
    STATE(3306), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(828), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1926), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2173), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1660), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [16797] = 25,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(1816), 1,
      sym__dedent,
    ACTIONS(1984), 1,
      sym_identifier,
    ACTIONS(1986), 1,
      anon_sym_STAR,
    ACTIONS(1990), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1992), 1,
      anon_sym_type,
    ACTIONS(1994), 1,
      anon_sym_not,
    ACTIONS(1996), 1,
      anon_sym_lambda,
    ACTIONS(1998), 1,
      anon_sym_await,
    STATE(1488), 1,
      sym_string,
    STATE(1491), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    STATE(2376), 1,
      sym_expression,
    STATE(3239), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(942), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1988), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2704), 4,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
      sym__directive_parameter,
    STATE(2383), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [16907] = 26,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1852), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1944), 1,
      sym_identifier,
    ACTIONS(1946), 1,
      anon_sym_LPAREN,
    ACTIONS(1948), 1,
      anon_sym_STAR,
    ACTIONS(1952), 1,
      anon_sym_type,
    ACTIONS(1954), 1,
      anon_sym_await,
    ACTIONS(2080), 1,
      anon_sym_RPAREN,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2335), 1,
      sym_expression,
    STATE(3118), 1,
      sym_parenthesized_list_splat,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(3119), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1950), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [17019] = 26,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1852), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1944), 1,
      sym_identifier,
    ACTIONS(1946), 1,
      anon_sym_LPAREN,
    ACTIONS(1948), 1,
      anon_sym_STAR,
    ACTIONS(1952), 1,
      anon_sym_type,
    ACTIONS(1954), 1,
      anon_sym_await,
    ACTIONS(2082), 1,
      anon_sym_RPAREN,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2335), 1,
      sym_expression,
    STATE(3118), 1,
      sym_parenthesized_list_splat,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(3119), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1950), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [17131] = 25,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(1918), 1,
      sym__dedent,
    ACTIONS(1984), 1,
      sym_identifier,
    ACTIONS(1986), 1,
      anon_sym_STAR,
    ACTIONS(1990), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1992), 1,
      anon_sym_type,
    ACTIONS(1994), 1,
      anon_sym_not,
    ACTIONS(1996), 1,
      anon_sym_lambda,
    ACTIONS(1998), 1,
      anon_sym_await,
    STATE(1488), 1,
      sym_string,
    STATE(1491), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    STATE(2376), 1,
      sym_expression,
    STATE(3239), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(942), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1988), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2969), 4,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
      sym__directive_parameter,
    STATE(2383), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [17241] = 27,
    ACTIONS(840), 1,
      anon_sym_LBRACK,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(1586), 1,
      anon_sym_STAR,
    ACTIONS(1594), 1,
      anon_sym_not,
    ACTIONS(1596), 1,
      anon_sym_lambda,
    ACTIONS(1598), 1,
      anon_sym_yield,
    ACTIONS(1842), 1,
      anon_sym_LPAREN,
    ACTIONS(1922), 1,
      sym_identifier,
    ACTIONS(1928), 1,
      anon_sym_type,
    ACTIONS(1930), 1,
      anon_sym_await,
    ACTIONS(2084), 1,
      anon_sym_RPAREN,
    STATE(1271), 1,
      sym_string,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1530), 1,
      sym_list_splat_pattern,
    STATE(2087), 1,
      sym_expression,
    STATE(2812), 1,
      sym_yield,
    STATE(3162), 1,
      sym__collection_elements,
    STATE(3306), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    STATE(2683), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(828), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1926), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2173), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1660), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [17355] = 25,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(1918), 1,
      sym__dedent,
    ACTIONS(1984), 1,
      sym_identifier,
    ACTIONS(1986), 1,
      anon_sym_STAR,
    ACTIONS(1990), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1992), 1,
      anon_sym_type,
    ACTIONS(1994), 1,
      anon_sym_not,
    ACTIONS(1996), 1,
      anon_sym_lambda,
    ACTIONS(1998), 1,
      anon_sym_await,
    STATE(1488), 1,
      sym_string,
    STATE(1491), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    STATE(2376), 1,
      sym_expression,
    STATE(3239), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(942), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1988), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(3138), 4,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
      sym__directive_parameter,
    STATE(2383), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [17465] = 26,
    ACTIONS(928), 1,
      anon_sym_LBRACK,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_string_start,
    ACTIONS(1634), 1,
      anon_sym_STAR,
    ACTIONS(1644), 1,
      anon_sym_not,
    ACTIONS(1646), 1,
      anon_sym_lambda,
    ACTIONS(1648), 1,
      anon_sym_yield,
    ACTIONS(2006), 1,
      sym_identifier,
    ACTIONS(2008), 1,
      anon_sym_LPAREN,
    ACTIONS(2012), 1,
      anon_sym_type,
    ACTIONS(2016), 1,
      anon_sym_await,
    ACTIONS(2086), 1,
      anon_sym_RBRACK,
    STATE(1264), 1,
      sym_primary_expression,
    STATE(1279), 1,
      sym_string,
    STATE(1590), 1,
      sym_list_splat_pattern,
    STATE(2088), 1,
      sym_expression,
    STATE(3184), 1,
      sym__named_expression_lhs,
    STATE(3246), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(934), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(930), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2912), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(918), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2010), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2189), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1654), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [17577] = 26,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1852), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1944), 1,
      sym_identifier,
    ACTIONS(1946), 1,
      anon_sym_LPAREN,
    ACTIONS(1948), 1,
      anon_sym_STAR,
    ACTIONS(1952), 1,
      anon_sym_type,
    ACTIONS(1954), 1,
      anon_sym_await,
    ACTIONS(2088), 1,
      anon_sym_RPAREN,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2335), 1,
      sym_expression,
    STATE(3118), 1,
      sym_parenthesized_list_splat,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(3119), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1950), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [17689] = 25,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(1984), 1,
      sym_identifier,
    ACTIONS(1986), 1,
      anon_sym_STAR,
    ACTIONS(1990), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1992), 1,
      anon_sym_type,
    ACTIONS(1994), 1,
      anon_sym_not,
    ACTIONS(1996), 1,
      anon_sym_lambda,
    ACTIONS(1998), 1,
      anon_sym_await,
    ACTIONS(2090), 1,
      sym__dedent,
    STATE(1488), 1,
      sym_string,
    STATE(1491), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    STATE(2376), 1,
      sym_expression,
    STATE(3239), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(942), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1988), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(3138), 4,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
      sym__directive_parameter,
    STATE(2383), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [17799] = 25,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(1984), 1,
      sym_identifier,
    ACTIONS(1986), 1,
      anon_sym_STAR,
    ACTIONS(1990), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1992), 1,
      anon_sym_type,
    ACTIONS(1994), 1,
      anon_sym_not,
    ACTIONS(1996), 1,
      anon_sym_lambda,
    ACTIONS(1998), 1,
      anon_sym_await,
    ACTIONS(2092), 1,
      sym__dedent,
    STATE(1488), 1,
      sym_string,
    STATE(1491), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    STATE(2376), 1,
      sym_expression,
    STATE(3239), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(942), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1988), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2837), 4,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
      sym__directive_parameter,
    STATE(2383), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [17909] = 25,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(1984), 1,
      sym_identifier,
    ACTIONS(1986), 1,
      anon_sym_STAR,
    ACTIONS(1990), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1992), 1,
      anon_sym_type,
    ACTIONS(1994), 1,
      anon_sym_not,
    ACTIONS(1996), 1,
      anon_sym_lambda,
    ACTIONS(1998), 1,
      anon_sym_await,
    ACTIONS(2094), 1,
      sym__dedent,
    STATE(1488), 1,
      sym_string,
    STATE(1491), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    STATE(2376), 1,
      sym_expression,
    STATE(3239), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(942), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1988), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(3138), 4,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
      sym__directive_parameter,
    STATE(2383), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [18019] = 25,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(1984), 1,
      sym_identifier,
    ACTIONS(1986), 1,
      anon_sym_STAR,
    ACTIONS(1990), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1992), 1,
      anon_sym_type,
    ACTIONS(1994), 1,
      anon_sym_not,
    ACTIONS(1996), 1,
      anon_sym_lambda,
    ACTIONS(1998), 1,
      anon_sym_await,
    ACTIONS(2096), 1,
      sym__dedent,
    STATE(1488), 1,
      sym_string,
    STATE(1491), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    STATE(2376), 1,
      sym_expression,
    STATE(3239), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(942), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1988), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(3138), 4,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
      sym__directive_parameter,
    STATE(2383), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [18129] = 25,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(1984), 1,
      sym_identifier,
    ACTIONS(1986), 1,
      anon_sym_STAR,
    ACTIONS(1990), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1992), 1,
      anon_sym_type,
    ACTIONS(1994), 1,
      anon_sym_not,
    ACTIONS(1996), 1,
      anon_sym_lambda,
    ACTIONS(1998), 1,
      anon_sym_await,
    ACTIONS(2098), 1,
      sym__dedent,
    STATE(1488), 1,
      sym_string,
    STATE(1491), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    STATE(2376), 1,
      sym_expression,
    STATE(3239), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(942), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1988), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(3138), 4,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
      sym__directive_parameter,
    STATE(2383), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [18239] = 25,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(1984), 1,
      sym_identifier,
    ACTIONS(1986), 1,
      anon_sym_STAR,
    ACTIONS(1990), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1992), 1,
      anon_sym_type,
    ACTIONS(1994), 1,
      anon_sym_not,
    ACTIONS(1996), 1,
      anon_sym_lambda,
    ACTIONS(1998), 1,
      anon_sym_await,
    ACTIONS(2100), 1,
      sym__dedent,
    STATE(1488), 1,
      sym_string,
    STATE(1491), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    STATE(2376), 1,
      sym_expression,
    STATE(3239), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(942), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1988), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2850), 4,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
      sym__directive_parameter,
    STATE(2383), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [18349] = 26,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1852), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1944), 1,
      sym_identifier,
    ACTIONS(1946), 1,
      anon_sym_LPAREN,
    ACTIONS(1948), 1,
      anon_sym_STAR,
    ACTIONS(1952), 1,
      anon_sym_type,
    ACTIONS(1954), 1,
      anon_sym_await,
    ACTIONS(2102), 1,
      anon_sym_RPAREN,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2335), 1,
      sym_expression,
    STATE(3118), 1,
      sym_parenthesized_list_splat,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(3119), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1950), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [18461] = 26,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1852), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1944), 1,
      sym_identifier,
    ACTIONS(1946), 1,
      anon_sym_LPAREN,
    ACTIONS(1948), 1,
      anon_sym_STAR,
    ACTIONS(1952), 1,
      anon_sym_type,
    ACTIONS(1954), 1,
      anon_sym_await,
    ACTIONS(2104), 1,
      anon_sym_RPAREN,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2335), 1,
      sym_expression,
    STATE(3118), 1,
      sym_parenthesized_list_splat,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(3119), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1950), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [18573] = 25,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(1984), 1,
      sym_identifier,
    ACTIONS(1986), 1,
      anon_sym_STAR,
    ACTIONS(1990), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1992), 1,
      anon_sym_type,
    ACTIONS(1994), 1,
      anon_sym_not,
    ACTIONS(1996), 1,
      anon_sym_lambda,
    ACTIONS(1998), 1,
      anon_sym_await,
    ACTIONS(2038), 1,
      sym__dedent,
    STATE(1488), 1,
      sym_string,
    STATE(1491), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    STATE(2376), 1,
      sym_expression,
    STATE(3239), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(942), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1988), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(3138), 4,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
      sym__directive_parameter,
    STATE(2383), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [18683] = 26,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1852), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1944), 1,
      sym_identifier,
    ACTIONS(1946), 1,
      anon_sym_LPAREN,
    ACTIONS(1948), 1,
      anon_sym_STAR,
    ACTIONS(1952), 1,
      anon_sym_type,
    ACTIONS(1954), 1,
      anon_sym_await,
    ACTIONS(2106), 1,
      anon_sym_RPAREN,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2335), 1,
      sym_expression,
    STATE(3118), 1,
      sym_parenthesized_list_splat,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(3119), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1950), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [18795] = 25,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(1816), 1,
      sym__dedent,
    ACTIONS(1984), 1,
      sym_identifier,
    ACTIONS(1986), 1,
      anon_sym_STAR,
    ACTIONS(1990), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1992), 1,
      anon_sym_type,
    ACTIONS(1994), 1,
      anon_sym_not,
    ACTIONS(1996), 1,
      anon_sym_lambda,
    ACTIONS(1998), 1,
      anon_sym_await,
    STATE(1488), 1,
      sym_string,
    STATE(1491), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    STATE(2376), 1,
      sym_expression,
    STATE(3239), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(942), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1988), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(3138), 4,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
      sym__directive_parameter,
    STATE(2383), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [18905] = 25,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(1984), 1,
      sym_identifier,
    ACTIONS(1986), 1,
      anon_sym_STAR,
    ACTIONS(1990), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1992), 1,
      anon_sym_type,
    ACTIONS(1994), 1,
      anon_sym_not,
    ACTIONS(1996), 1,
      anon_sym_lambda,
    ACTIONS(1998), 1,
      anon_sym_await,
    ACTIONS(2108), 1,
      sym__dedent,
    STATE(1488), 1,
      sym_string,
    STATE(1491), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    STATE(2376), 1,
      sym_expression,
    STATE(3239), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(942), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1988), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(3138), 4,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
      sym__directive_parameter,
    STATE(2383), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [19015] = 26,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1852), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1944), 1,
      sym_identifier,
    ACTIONS(1946), 1,
      anon_sym_LPAREN,
    ACTIONS(1948), 1,
      anon_sym_STAR,
    ACTIONS(1952), 1,
      anon_sym_type,
    ACTIONS(1954), 1,
      anon_sym_await,
    ACTIONS(2110), 1,
      anon_sym_RPAREN,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2335), 1,
      sym_expression,
    STATE(3118), 1,
      sym_parenthesized_list_splat,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(3119), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1950), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [19127] = 25,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(1984), 1,
      sym_identifier,
    ACTIONS(1986), 1,
      anon_sym_STAR,
    ACTIONS(1990), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1992), 1,
      anon_sym_type,
    ACTIONS(1994), 1,
      anon_sym_not,
    ACTIONS(1996), 1,
      anon_sym_lambda,
    ACTIONS(1998), 1,
      anon_sym_await,
    ACTIONS(2098), 1,
      sym__dedent,
    STATE(1488), 1,
      sym_string,
    STATE(1491), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    STATE(2376), 1,
      sym_expression,
    STATE(3239), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(942), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1988), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2880), 4,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
      sym__directive_parameter,
    STATE(2383), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [19237] = 25,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(1890), 1,
      sym__dedent,
    ACTIONS(1984), 1,
      sym_identifier,
    ACTIONS(1986), 1,
      anon_sym_STAR,
    ACTIONS(1990), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1992), 1,
      anon_sym_type,
    ACTIONS(1994), 1,
      anon_sym_not,
    ACTIONS(1996), 1,
      anon_sym_lambda,
    ACTIONS(1998), 1,
      anon_sym_await,
    STATE(1488), 1,
      sym_string,
    STATE(1491), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    STATE(2376), 1,
      sym_expression,
    STATE(3239), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(942), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1988), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(3138), 4,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
      sym__directive_parameter,
    STATE(2383), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [19347] = 28,
    ACTIONS(840), 1,
      anon_sym_LBRACK,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(1586), 1,
      anon_sym_STAR,
    ACTIONS(1594), 1,
      anon_sym_not,
    ACTIONS(1596), 1,
      anon_sym_lambda,
    ACTIONS(1598), 1,
      anon_sym_yield,
    ACTIONS(1842), 1,
      anon_sym_LPAREN,
    ACTIONS(1922), 1,
      sym_identifier,
    ACTIONS(1928), 1,
      anon_sym_type,
    ACTIONS(1930), 1,
      anon_sym_await,
    ACTIONS(2112), 1,
      anon_sym_RPAREN,
    STATE(1271), 1,
      sym_string,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1530), 1,
      sym_list_splat_pattern,
    STATE(2091), 1,
      sym_expression,
    STATE(2813), 1,
      sym_list_splat,
    STATE(2814), 1,
      sym_parenthesized_list_splat,
    STATE(3017), 1,
      sym_yield,
    STATE(3306), 1,
      sym__named_expression_lhs,
    STATE(3435), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(828), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1926), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2173), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1660), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [19463] = 25,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(1984), 1,
      sym_identifier,
    ACTIONS(1986), 1,
      anon_sym_STAR,
    ACTIONS(1990), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1992), 1,
      anon_sym_type,
    ACTIONS(1994), 1,
      anon_sym_not,
    ACTIONS(1996), 1,
      anon_sym_lambda,
    ACTIONS(1998), 1,
      anon_sym_await,
    ACTIONS(2114), 1,
      sym__dedent,
    STATE(1488), 1,
      sym_string,
    STATE(1491), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    STATE(2376), 1,
      sym_expression,
    STATE(3239), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(942), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1988), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(3138), 4,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
      sym__directive_parameter,
    STATE(2383), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [19573] = 26,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1852), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1944), 1,
      sym_identifier,
    ACTIONS(1946), 1,
      anon_sym_LPAREN,
    ACTIONS(1948), 1,
      anon_sym_STAR,
    ACTIONS(1952), 1,
      anon_sym_type,
    ACTIONS(1954), 1,
      anon_sym_await,
    ACTIONS(2116), 1,
      anon_sym_RPAREN,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2335), 1,
      sym_expression,
    STATE(3118), 1,
      sym_parenthesized_list_splat,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(3119), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1950), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [19685] = 28,
    ACTIONS(840), 1,
      anon_sym_LBRACK,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(1586), 1,
      anon_sym_STAR,
    ACTIONS(1594), 1,
      anon_sym_not,
    ACTIONS(1596), 1,
      anon_sym_lambda,
    ACTIONS(1598), 1,
      anon_sym_yield,
    ACTIONS(1842), 1,
      anon_sym_LPAREN,
    ACTIONS(1922), 1,
      sym_identifier,
    ACTIONS(1928), 1,
      anon_sym_type,
    ACTIONS(1930), 1,
      anon_sym_await,
    ACTIONS(2020), 1,
      anon_sym_RPAREN,
    STATE(1271), 1,
      sym_string,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1530), 1,
      sym_list_splat_pattern,
    STATE(2097), 1,
      sym_expression,
    STATE(2714), 1,
      sym_list_splat,
    STATE(2717), 1,
      sym_parenthesized_list_splat,
    STATE(2752), 1,
      sym_yield,
    STATE(3306), 1,
      sym__named_expression_lhs,
    STATE(3322), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(828), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1926), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2173), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1660), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [19801] = 26,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1852), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1944), 1,
      sym_identifier,
    ACTIONS(1946), 1,
      anon_sym_LPAREN,
    ACTIONS(1948), 1,
      anon_sym_STAR,
    ACTIONS(1952), 1,
      anon_sym_type,
    ACTIONS(1954), 1,
      anon_sym_await,
    ACTIONS(2118), 1,
      anon_sym_RPAREN,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2335), 1,
      sym_expression,
    STATE(3118), 1,
      sym_parenthesized_list_splat,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(3119), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1950), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [19913] = 25,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(1984), 1,
      sym_identifier,
    ACTIONS(1986), 1,
      anon_sym_STAR,
    ACTIONS(1990), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1992), 1,
      anon_sym_type,
    ACTIONS(1994), 1,
      anon_sym_not,
    ACTIONS(1996), 1,
      anon_sym_lambda,
    ACTIONS(1998), 1,
      anon_sym_await,
    ACTIONS(2120), 1,
      sym__dedent,
    STATE(1488), 1,
      sym_string,
    STATE(1491), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    STATE(2376), 1,
      sym_expression,
    STATE(3239), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(942), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1988), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(3138), 4,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
      sym__directive_parameter,
    STATE(2383), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [20023] = 26,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1852), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1944), 1,
      sym_identifier,
    ACTIONS(1946), 1,
      anon_sym_LPAREN,
    ACTIONS(1948), 1,
      anon_sym_STAR,
    ACTIONS(1952), 1,
      anon_sym_type,
    ACTIONS(1954), 1,
      anon_sym_await,
    ACTIONS(2122), 1,
      anon_sym_RPAREN,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2335), 1,
      sym_expression,
    STATE(3118), 1,
      sym_parenthesized_list_splat,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(3119), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1950), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [20135] = 27,
    ACTIONS(840), 1,
      anon_sym_LBRACK,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(1586), 1,
      anon_sym_STAR,
    ACTIONS(1594), 1,
      anon_sym_not,
    ACTIONS(1596), 1,
      anon_sym_lambda,
    ACTIONS(1598), 1,
      anon_sym_yield,
    ACTIONS(1842), 1,
      anon_sym_LPAREN,
    ACTIONS(1922), 1,
      sym_identifier,
    ACTIONS(1928), 1,
      anon_sym_type,
    ACTIONS(1930), 1,
      anon_sym_await,
    ACTIONS(2112), 1,
      anon_sym_RPAREN,
    STATE(1271), 1,
      sym_string,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1530), 1,
      sym_list_splat_pattern,
    STATE(2091), 1,
      sym_expression,
    STATE(3017), 1,
      sym_yield,
    STATE(3306), 1,
      sym__named_expression_lhs,
    STATE(3435), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    STATE(2683), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(828), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1926), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2173), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1660), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [20249] = 26,
    ACTIONS(928), 1,
      anon_sym_LBRACK,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_string_start,
    ACTIONS(1634), 1,
      anon_sym_STAR,
    ACTIONS(1644), 1,
      anon_sym_not,
    ACTIONS(1646), 1,
      anon_sym_lambda,
    ACTIONS(1648), 1,
      anon_sym_yield,
    ACTIONS(2006), 1,
      sym_identifier,
    ACTIONS(2008), 1,
      anon_sym_LPAREN,
    ACTIONS(2012), 1,
      anon_sym_type,
    ACTIONS(2016), 1,
      anon_sym_await,
    ACTIONS(2124), 1,
      anon_sym_RBRACK,
    STATE(1264), 1,
      sym_primary_expression,
    STATE(1279), 1,
      sym_string,
    STATE(1590), 1,
      sym_list_splat_pattern,
    STATE(2076), 1,
      sym_expression,
    STATE(3184), 1,
      sym__named_expression_lhs,
    STATE(3269), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(934), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(930), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2912), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(918), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2010), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2189), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1654), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [20361] = 27,
    ACTIONS(840), 1,
      anon_sym_LBRACK,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(1586), 1,
      anon_sym_STAR,
    ACTIONS(1594), 1,
      anon_sym_not,
    ACTIONS(1596), 1,
      anon_sym_lambda,
    ACTIONS(1598), 1,
      anon_sym_yield,
    ACTIONS(1842), 1,
      anon_sym_LPAREN,
    ACTIONS(1922), 1,
      sym_identifier,
    ACTIONS(1924), 1,
      anon_sym_RPAREN,
    ACTIONS(1928), 1,
      anon_sym_type,
    ACTIONS(1930), 1,
      anon_sym_await,
    STATE(1271), 1,
      sym_string,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1530), 1,
      sym_list_splat_pattern,
    STATE(2078), 1,
      sym_expression,
    STATE(2792), 1,
      sym_yield,
    STATE(3278), 1,
      sym__collection_elements,
    STATE(3306), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    STATE(2683), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(828), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1926), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2173), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1660), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [20475] = 27,
    ACTIONS(840), 1,
      anon_sym_LBRACK,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(1586), 1,
      anon_sym_STAR,
    ACTIONS(1594), 1,
      anon_sym_not,
    ACTIONS(1596), 1,
      anon_sym_lambda,
    ACTIONS(1598), 1,
      anon_sym_yield,
    ACTIONS(1842), 1,
      anon_sym_LPAREN,
    ACTIONS(1922), 1,
      sym_identifier,
    ACTIONS(1928), 1,
      anon_sym_type,
    ACTIONS(1930), 1,
      anon_sym_await,
    ACTIONS(2126), 1,
      anon_sym_RPAREN,
    STATE(1271), 1,
      sym_string,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1530), 1,
      sym_list_splat_pattern,
    STATE(2101), 1,
      sym_expression,
    STATE(2897), 1,
      sym_yield,
    STATE(3189), 1,
      sym__collection_elements,
    STATE(3306), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    STATE(2683), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(828), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1926), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2173), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1660), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [20589] = 26,
    ACTIONS(928), 1,
      anon_sym_LBRACK,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_string_start,
    ACTIONS(1634), 1,
      anon_sym_STAR,
    ACTIONS(1644), 1,
      anon_sym_not,
    ACTIONS(1646), 1,
      anon_sym_lambda,
    ACTIONS(1648), 1,
      anon_sym_yield,
    ACTIONS(2006), 1,
      sym_identifier,
    ACTIONS(2008), 1,
      anon_sym_LPAREN,
    ACTIONS(2012), 1,
      anon_sym_type,
    ACTIONS(2016), 1,
      anon_sym_await,
    ACTIONS(2128), 1,
      anon_sym_RBRACK,
    STATE(1264), 1,
      sym_primary_expression,
    STATE(1279), 1,
      sym_string,
    STATE(1590), 1,
      sym_list_splat_pattern,
    STATE(2072), 1,
      sym_expression,
    STATE(3184), 1,
      sym__named_expression_lhs,
    STATE(3399), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(934), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(930), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2912), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(918), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2010), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2189), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1654), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [20701] = 27,
    ACTIONS(840), 1,
      anon_sym_LBRACK,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(1586), 1,
      anon_sym_STAR,
    ACTIONS(1594), 1,
      anon_sym_not,
    ACTIONS(1596), 1,
      anon_sym_lambda,
    ACTIONS(1598), 1,
      anon_sym_yield,
    ACTIONS(1842), 1,
      anon_sym_LPAREN,
    ACTIONS(1922), 1,
      sym_identifier,
    ACTIONS(1928), 1,
      anon_sym_type,
    ACTIONS(1930), 1,
      anon_sym_await,
    ACTIONS(2130), 1,
      anon_sym_RPAREN,
    STATE(1271), 1,
      sym_string,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1530), 1,
      sym_list_splat_pattern,
    STATE(2083), 1,
      sym_expression,
    STATE(2687), 1,
      sym_yield,
    STATE(3306), 1,
      sym__named_expression_lhs,
    STATE(3411), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    STATE(2683), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(828), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1926), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2173), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1660), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [20815] = 26,
    ACTIONS(928), 1,
      anon_sym_LBRACK,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_string_start,
    ACTIONS(1634), 1,
      anon_sym_STAR,
    ACTIONS(1644), 1,
      anon_sym_not,
    ACTIONS(1646), 1,
      anon_sym_lambda,
    ACTIONS(1648), 1,
      anon_sym_yield,
    ACTIONS(2006), 1,
      sym_identifier,
    ACTIONS(2008), 1,
      anon_sym_LPAREN,
    ACTIONS(2012), 1,
      anon_sym_type,
    ACTIONS(2016), 1,
      anon_sym_await,
    ACTIONS(2132), 1,
      anon_sym_RBRACK,
    STATE(1264), 1,
      sym_primary_expression,
    STATE(1279), 1,
      sym_string,
    STATE(1590), 1,
      sym_list_splat_pattern,
    STATE(2080), 1,
      sym_expression,
    STATE(3184), 1,
      sym__named_expression_lhs,
    STATE(3333), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(934), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(930), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2912), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(918), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2010), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2189), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1654), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [20927] = 25,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(1984), 1,
      sym_identifier,
    ACTIONS(1986), 1,
      anon_sym_STAR,
    ACTIONS(1990), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1992), 1,
      anon_sym_type,
    ACTIONS(1994), 1,
      anon_sym_not,
    ACTIONS(1996), 1,
      anon_sym_lambda,
    ACTIONS(1998), 1,
      anon_sym_await,
    ACTIONS(2134), 1,
      sym__dedent,
    STATE(1488), 1,
      sym_string,
    STATE(1491), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    STATE(2376), 1,
      sym_expression,
    STATE(3239), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(942), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1988), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(3138), 4,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
      sym__directive_parameter,
    STATE(2383), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [21037] = 28,
    ACTIONS(840), 1,
      anon_sym_LBRACK,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(1586), 1,
      anon_sym_STAR,
    ACTIONS(1594), 1,
      anon_sym_not,
    ACTIONS(1596), 1,
      anon_sym_lambda,
    ACTIONS(1598), 1,
      anon_sym_yield,
    ACTIONS(1842), 1,
      anon_sym_LPAREN,
    ACTIONS(1922), 1,
      sym_identifier,
    ACTIONS(1928), 1,
      anon_sym_type,
    ACTIONS(1930), 1,
      anon_sym_await,
    ACTIONS(2126), 1,
      anon_sym_RPAREN,
    STATE(1271), 1,
      sym_string,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1530), 1,
      sym_list_splat_pattern,
    STATE(2101), 1,
      sym_expression,
    STATE(2719), 1,
      sym_parenthesized_list_splat,
    STATE(2721), 1,
      sym_list_splat,
    STATE(2897), 1,
      sym_yield,
    STATE(3189), 1,
      sym__collection_elements,
    STATE(3306), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(828), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1926), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2173), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1660), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [21153] = 26,
    ACTIONS(928), 1,
      anon_sym_LBRACK,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_string_start,
    ACTIONS(1634), 1,
      anon_sym_STAR,
    ACTIONS(1644), 1,
      anon_sym_not,
    ACTIONS(1646), 1,
      anon_sym_lambda,
    ACTIONS(1648), 1,
      anon_sym_yield,
    ACTIONS(2006), 1,
      sym_identifier,
    ACTIONS(2008), 1,
      anon_sym_LPAREN,
    ACTIONS(2012), 1,
      anon_sym_type,
    ACTIONS(2016), 1,
      anon_sym_await,
    ACTIONS(2136), 1,
      anon_sym_RBRACK,
    STATE(1264), 1,
      sym_primary_expression,
    STATE(1279), 1,
      sym_string,
    STATE(1590), 1,
      sym_list_splat_pattern,
    STATE(2094), 1,
      sym_expression,
    STATE(3184), 1,
      sym__named_expression_lhs,
    STATE(3313), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(934), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(930), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2912), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(918), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2010), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2189), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1654), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [21265] = 26,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1852), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1944), 1,
      sym_identifier,
    ACTIONS(1946), 1,
      anon_sym_LPAREN,
    ACTIONS(1948), 1,
      anon_sym_STAR,
    ACTIONS(1952), 1,
      anon_sym_type,
    ACTIONS(1954), 1,
      anon_sym_await,
    ACTIONS(2138), 1,
      anon_sym_RPAREN,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2335), 1,
      sym_expression,
    STATE(3118), 1,
      sym_parenthesized_list_splat,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(3119), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1950), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [21377] = 26,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1852), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1944), 1,
      sym_identifier,
    ACTIONS(1946), 1,
      anon_sym_LPAREN,
    ACTIONS(1948), 1,
      anon_sym_STAR,
    ACTIONS(1952), 1,
      anon_sym_type,
    ACTIONS(1954), 1,
      anon_sym_await,
    ACTIONS(2140), 1,
      anon_sym_RPAREN,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2335), 1,
      sym_expression,
    STATE(3118), 1,
      sym_parenthesized_list_splat,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(3119), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1950), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [21489] = 26,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1852), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1944), 1,
      sym_identifier,
    ACTIONS(1946), 1,
      anon_sym_LPAREN,
    ACTIONS(1948), 1,
      anon_sym_STAR,
    ACTIONS(1952), 1,
      anon_sym_type,
    ACTIONS(1954), 1,
      anon_sym_await,
    ACTIONS(2142), 1,
      anon_sym_RPAREN,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2335), 1,
      sym_expression,
    STATE(3118), 1,
      sym_parenthesized_list_splat,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(3119), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1950), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [21601] = 26,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1852), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1944), 1,
      sym_identifier,
    ACTIONS(1946), 1,
      anon_sym_LPAREN,
    ACTIONS(1948), 1,
      anon_sym_STAR,
    ACTIONS(1952), 1,
      anon_sym_type,
    ACTIONS(1954), 1,
      anon_sym_await,
    ACTIONS(2144), 1,
      anon_sym_RPAREN,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2335), 1,
      sym_expression,
    STATE(3118), 1,
      sym_parenthesized_list_splat,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(3119), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1950), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [21713] = 26,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1852), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1944), 1,
      sym_identifier,
    ACTIONS(1946), 1,
      anon_sym_LPAREN,
    ACTIONS(1948), 1,
      anon_sym_STAR,
    ACTIONS(1952), 1,
      anon_sym_type,
    ACTIONS(1954), 1,
      anon_sym_await,
    ACTIONS(2146), 1,
      anon_sym_RPAREN,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2335), 1,
      sym_expression,
    STATE(3118), 1,
      sym_parenthesized_list_splat,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(3119), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1950), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [21825] = 25,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(1984), 1,
      sym_identifier,
    ACTIONS(1986), 1,
      anon_sym_STAR,
    ACTIONS(1990), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1992), 1,
      anon_sym_type,
    ACTIONS(1994), 1,
      anon_sym_not,
    ACTIONS(1996), 1,
      anon_sym_lambda,
    ACTIONS(1998), 1,
      anon_sym_await,
    ACTIONS(2148), 1,
      sym__dedent,
    STATE(1488), 1,
      sym_string,
    STATE(1491), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    STATE(2376), 1,
      sym_expression,
    STATE(3239), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(942), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1988), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(3005), 4,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
      sym__directive_parameter,
    STATE(2383), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [21935] = 26,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1852), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1944), 1,
      sym_identifier,
    ACTIONS(1946), 1,
      anon_sym_LPAREN,
    ACTIONS(1948), 1,
      anon_sym_STAR,
    ACTIONS(1952), 1,
      anon_sym_type,
    ACTIONS(1954), 1,
      anon_sym_await,
    ACTIONS(2150), 1,
      anon_sym_RPAREN,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2335), 1,
      sym_expression,
    STATE(3118), 1,
      sym_parenthesized_list_splat,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(3119), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1950), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [22047] = 26,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1852), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1944), 1,
      sym_identifier,
    ACTIONS(1946), 1,
      anon_sym_LPAREN,
    ACTIONS(1948), 1,
      anon_sym_STAR,
    ACTIONS(1952), 1,
      anon_sym_type,
    ACTIONS(1954), 1,
      anon_sym_await,
    ACTIONS(2152), 1,
      anon_sym_RPAREN,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2335), 1,
      sym_expression,
    STATE(3118), 1,
      sym_parenthesized_list_splat,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(3119), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1950), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [22159] = 25,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(1984), 1,
      sym_identifier,
    ACTIONS(1986), 1,
      anon_sym_STAR,
    ACTIONS(1990), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1992), 1,
      anon_sym_type,
    ACTIONS(1994), 1,
      anon_sym_not,
    ACTIONS(1996), 1,
      anon_sym_lambda,
    ACTIONS(1998), 1,
      anon_sym_await,
    ACTIONS(2154), 1,
      sym__dedent,
    STATE(1488), 1,
      sym_string,
    STATE(1491), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    STATE(2376), 1,
      sym_expression,
    STATE(3239), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(942), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1988), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(3008), 4,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
      sym__directive_parameter,
    STATE(2383), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [22269] = 26,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1852), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1944), 1,
      sym_identifier,
    ACTIONS(1946), 1,
      anon_sym_LPAREN,
    ACTIONS(1948), 1,
      anon_sym_STAR,
    ACTIONS(1952), 1,
      anon_sym_type,
    ACTIONS(1954), 1,
      anon_sym_await,
    ACTIONS(2156), 1,
      anon_sym_RPAREN,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2335), 1,
      sym_expression,
    STATE(3118), 1,
      sym_parenthesized_list_splat,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(3119), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1950), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [22381] = 26,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1852), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1944), 1,
      sym_identifier,
    ACTIONS(1946), 1,
      anon_sym_LPAREN,
    ACTIONS(1948), 1,
      anon_sym_STAR,
    ACTIONS(1952), 1,
      anon_sym_type,
    ACTIONS(1954), 1,
      anon_sym_await,
    ACTIONS(2158), 1,
      anon_sym_RPAREN,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2335), 1,
      sym_expression,
    STATE(3118), 1,
      sym_parenthesized_list_splat,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(3119), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1950), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [22493] = 26,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1852), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1944), 1,
      sym_identifier,
    ACTIONS(1946), 1,
      anon_sym_LPAREN,
    ACTIONS(1948), 1,
      anon_sym_STAR,
    ACTIONS(1952), 1,
      anon_sym_type,
    ACTIONS(1954), 1,
      anon_sym_await,
    ACTIONS(2160), 1,
      anon_sym_RPAREN,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2335), 1,
      sym_expression,
    STATE(3118), 1,
      sym_parenthesized_list_splat,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(3119), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1950), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [22605] = 25,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(1984), 1,
      sym_identifier,
    ACTIONS(1986), 1,
      anon_sym_STAR,
    ACTIONS(1990), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1992), 1,
      anon_sym_type,
    ACTIONS(1994), 1,
      anon_sym_not,
    ACTIONS(1996), 1,
      anon_sym_lambda,
    ACTIONS(1998), 1,
      anon_sym_await,
    ACTIONS(2162), 1,
      sym__dedent,
    STATE(1488), 1,
      sym_string,
    STATE(1491), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    STATE(2376), 1,
      sym_expression,
    STATE(3239), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(942), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1988), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(3138), 4,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
      sym__directive_parameter,
    STATE(2383), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [22715] = 25,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(1890), 1,
      sym__dedent,
    ACTIONS(1984), 1,
      sym_identifier,
    ACTIONS(1986), 1,
      anon_sym_STAR,
    ACTIONS(1990), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1992), 1,
      anon_sym_type,
    ACTIONS(1994), 1,
      anon_sym_not,
    ACTIONS(1996), 1,
      anon_sym_lambda,
    ACTIONS(1998), 1,
      anon_sym_await,
    STATE(1488), 1,
      sym_string,
    STATE(1491), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    STATE(2376), 1,
      sym_expression,
    STATE(3239), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(942), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1988), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2868), 4,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
      sym__directive_parameter,
    STATE(2383), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [22825] = 26,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1852), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1944), 1,
      sym_identifier,
    ACTIONS(1946), 1,
      anon_sym_LPAREN,
    ACTIONS(1948), 1,
      anon_sym_STAR,
    ACTIONS(1952), 1,
      anon_sym_type,
    ACTIONS(1954), 1,
      anon_sym_await,
    ACTIONS(2164), 1,
      anon_sym_RPAREN,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2335), 1,
      sym_expression,
    STATE(3118), 1,
      sym_parenthesized_list_splat,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(3119), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1950), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [22937] = 25,
    ACTIONS(789), 1,
      anon_sym_LBRACK,
    ACTIONS(793), 1,
      anon_sym_LBRACE,
    ACTIONS(799), 1,
      sym_string_start,
    ACTIONS(1626), 1,
      anon_sym_yield,
    ACTIONS(1800), 1,
      anon_sym_not,
    ACTIONS(1802), 1,
      anon_sym_lambda,
    ACTIONS(1956), 1,
      sym_identifier,
    ACTIONS(1964), 1,
      anon_sym_type,
    ACTIONS(1966), 1,
      anon_sym_await,
    ACTIONS(2166), 1,
      anon_sym_LPAREN,
    ACTIONS(2168), 1,
      anon_sym_STAR,
    ACTIONS(2170), 1,
      anon_sym_RBRACE,
    STATE(1221), 1,
      sym_primary_expression,
    STATE(1223), 1,
      sym_string,
    STATE(1459), 1,
      sym_list_splat_pattern,
    STATE(2297), 1,
      sym_expression,
    STATE(3201), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(795), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(791), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(3102), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(779), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1962), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2139), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1449), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [23046] = 25,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1852), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1944), 1,
      sym_identifier,
    ACTIONS(1946), 1,
      anon_sym_LPAREN,
    ACTIONS(1948), 1,
      anon_sym_STAR,
    ACTIONS(1952), 1,
      anon_sym_type,
    ACTIONS(1954), 1,
      anon_sym_await,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2335), 1,
      sym_expression,
    STATE(3118), 1,
      sym_parenthesized_list_splat,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(3119), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1950), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [23155] = 25,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1648), 1,
      anon_sym_yield,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2174), 1,
      anon_sym_LPAREN,
    ACTIONS(2176), 1,
      anon_sym_STAR,
    ACTIONS(2178), 1,
      anon_sym_RBRACK,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2334), 1,
      sym_expression,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(3143), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [23264] = 25,
    ACTIONS(830), 1,
      anon_sym_LPAREN,
    ACTIONS(840), 1,
      anon_sym_LBRACK,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(1594), 1,
      anon_sym_not,
    ACTIONS(1922), 1,
      sym_identifier,
    ACTIONS(1928), 1,
      anon_sym_type,
    ACTIONS(1930), 1,
      anon_sym_await,
    ACTIONS(2180), 1,
      anon_sym_RPAREN,
    ACTIONS(2182), 1,
      anon_sym_STAR,
    ACTIONS(2186), 1,
      anon_sym_lambda,
    STATE(1271), 1,
      sym_string,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1530), 1,
      sym_list_splat_pattern,
    STATE(2188), 1,
      sym_expression,
    STATE(3306), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    STATE(2496), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1926), 3,
      anon_sym_print,
      anon_sym_match,
      anon_sym_exec,
    ACTIONS(2184), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(828), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2173), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1660), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [23373] = 25,
    ACTIONS(830), 1,
      anon_sym_LPAREN,
    ACTIONS(840), 1,
      anon_sym_LBRACK,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(1594), 1,
      anon_sym_not,
    ACTIONS(1922), 1,
      sym_identifier,
    ACTIONS(1928), 1,
      anon_sym_type,
    ACTIONS(1930), 1,
      anon_sym_await,
    ACTIONS(2182), 1,
      anon_sym_STAR,
    ACTIONS(2186), 1,
      anon_sym_lambda,
    ACTIONS(2188), 1,
      anon_sym_RPAREN,
    STATE(1271), 1,
      sym_string,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1530), 1,
      sym_list_splat_pattern,
    STATE(2188), 1,
      sym_expression,
    STATE(3306), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    STATE(2496), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1926), 3,
      anon_sym_print,
      anon_sym_match,
      anon_sym_exec,
    ACTIONS(2190), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(828), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2173), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1660), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [23482] = 25,
    ACTIONS(830), 1,
      anon_sym_LPAREN,
    ACTIONS(840), 1,
      anon_sym_LBRACK,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(1594), 1,
      anon_sym_not,
    ACTIONS(1922), 1,
      sym_identifier,
    ACTIONS(1928), 1,
      anon_sym_type,
    ACTIONS(1930), 1,
      anon_sym_await,
    ACTIONS(2182), 1,
      anon_sym_STAR,
    ACTIONS(2186), 1,
      anon_sym_lambda,
    ACTIONS(2192), 1,
      anon_sym_RPAREN,
    STATE(1271), 1,
      sym_string,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1530), 1,
      sym_list_splat_pattern,
    STATE(2188), 1,
      sym_expression,
    STATE(3306), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    STATE(2496), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1926), 3,
      anon_sym_print,
      anon_sym_match,
      anon_sym_exec,
    ACTIONS(2194), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(828), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2173), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1660), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [23591] = 25,
    ACTIONS(830), 1,
      anon_sym_LPAREN,
    ACTIONS(840), 1,
      anon_sym_LBRACK,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(1594), 1,
      anon_sym_not,
    ACTIONS(1922), 1,
      sym_identifier,
    ACTIONS(1928), 1,
      anon_sym_type,
    ACTIONS(1930), 1,
      anon_sym_await,
    ACTIONS(2182), 1,
      anon_sym_STAR,
    ACTIONS(2186), 1,
      anon_sym_lambda,
    ACTIONS(2196), 1,
      anon_sym_RPAREN,
    STATE(1271), 1,
      sym_string,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1530), 1,
      sym_list_splat_pattern,
    STATE(2188), 1,
      sym_expression,
    STATE(3306), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    STATE(2496), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1926), 3,
      anon_sym_print,
      anon_sym_match,
      anon_sym_exec,
    ACTIONS(2198), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(828), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2173), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1660), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [23700] = 25,
    ACTIONS(920), 1,
      anon_sym_LPAREN,
    ACTIONS(928), 1,
      anon_sym_LBRACK,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_string_start,
    ACTIONS(1644), 1,
      anon_sym_not,
    ACTIONS(2006), 1,
      sym_identifier,
    ACTIONS(2012), 1,
      anon_sym_type,
    ACTIONS(2016), 1,
      anon_sym_await,
    ACTIONS(2196), 1,
      anon_sym_RBRACK,
    ACTIONS(2200), 1,
      anon_sym_STAR,
    ACTIONS(2202), 1,
      anon_sym_lambda,
    STATE(1264), 1,
      sym_primary_expression,
    STATE(1279), 1,
      sym_string,
    STATE(1590), 1,
      sym_list_splat_pattern,
    STATE(2238), 1,
      sym_expression,
    STATE(3184), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(934), 2,
      sym_ellipsis,
      sym_float,
    STATE(2430), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(930), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(2010), 3,
      anon_sym_print,
      anon_sym_match,
      anon_sym_exec,
    ACTIONS(2198), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(918), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2189), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1654), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [23809] = 25,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1598), 1,
      anon_sym_yield,
    ACTIONS(1832), 1,
      anon_sym_type,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1838), 1,
      anon_sym_await,
    ACTIONS(1946), 1,
      anon_sym_LPAREN,
    ACTIONS(2178), 1,
      anon_sym_RPAREN,
    ACTIONS(2204), 1,
      sym_identifier,
    ACTIONS(2206), 1,
      anon_sym_STAR,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2293), 1,
      sym_expression,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(3121), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1828), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [23918] = 25,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1648), 1,
      anon_sym_yield,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2170), 1,
      anon_sym_RBRACK,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2174), 1,
      anon_sym_LPAREN,
    ACTIONS(2176), 1,
      anon_sym_STAR,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2334), 1,
      sym_expression,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(3143), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [24027] = 25,
    ACTIONS(920), 1,
      anon_sym_LPAREN,
    ACTIONS(928), 1,
      anon_sym_LBRACK,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_string_start,
    ACTIONS(1644), 1,
      anon_sym_not,
    ACTIONS(2006), 1,
      sym_identifier,
    ACTIONS(2012), 1,
      anon_sym_type,
    ACTIONS(2016), 1,
      anon_sym_await,
    ACTIONS(2192), 1,
      anon_sym_RBRACK,
    ACTIONS(2200), 1,
      anon_sym_STAR,
    ACTIONS(2202), 1,
      anon_sym_lambda,
    STATE(1264), 1,
      sym_primary_expression,
    STATE(1279), 1,
      sym_string,
    STATE(1590), 1,
      sym_list_splat_pattern,
    STATE(2238), 1,
      sym_expression,
    STATE(3184), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(934), 2,
      sym_ellipsis,
      sym_float,
    STATE(2430), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(930), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(2010), 3,
      anon_sym_print,
      anon_sym_match,
      anon_sym_exec,
    ACTIONS(2194), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(918), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2189), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1654), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [24136] = 25,
    ACTIONS(920), 1,
      anon_sym_LPAREN,
    ACTIONS(928), 1,
      anon_sym_LBRACK,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_string_start,
    ACTIONS(1644), 1,
      anon_sym_not,
    ACTIONS(2006), 1,
      sym_identifier,
    ACTIONS(2012), 1,
      anon_sym_type,
    ACTIONS(2016), 1,
      anon_sym_await,
    ACTIONS(2180), 1,
      anon_sym_RBRACK,
    ACTIONS(2200), 1,
      anon_sym_STAR,
    ACTIONS(2202), 1,
      anon_sym_lambda,
    STATE(1264), 1,
      sym_primary_expression,
    STATE(1279), 1,
      sym_string,
    STATE(1590), 1,
      sym_list_splat_pattern,
    STATE(2238), 1,
      sym_expression,
    STATE(3184), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(934), 2,
      sym_ellipsis,
      sym_float,
    STATE(2430), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(930), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(2010), 3,
      anon_sym_print,
      anon_sym_match,
      anon_sym_exec,
    ACTIONS(2184), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(918), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2189), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1654), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [24245] = 24,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(1722), 1,
      sym_identifier,
    ACTIONS(1724), 1,
      anon_sym_STAR,
    ACTIONS(1728), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1730), 1,
      anon_sym_type,
    ACTIONS(1732), 1,
      anon_sym_await,
    STATE(1200), 1,
      sym_string,
    STATE(1203), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    STATE(2311), 1,
      sym_expression,
    STATE(3427), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1726), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(3141), 4,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
      sym__directive_parameter,
    STATE(2070), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [24352] = 19,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(494), 1,
      anon_sym_STAR,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(775), 1,
      anon_sym_type,
    ACTIONS(777), 1,
      anon_sym_await,
    STATE(1234), 1,
      sym_string,
    STATE(1298), 1,
      sym_primary_expression,
    STATE(1541), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 2,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(773), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(400), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
    ACTIONS(404), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(361), 9,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [24449] = 25,
    ACTIONS(789), 1,
      anon_sym_LBRACK,
    ACTIONS(793), 1,
      anon_sym_LBRACE,
    ACTIONS(799), 1,
      sym_string_start,
    ACTIONS(1626), 1,
      anon_sym_yield,
    ACTIONS(1800), 1,
      anon_sym_not,
    ACTIONS(1802), 1,
      anon_sym_lambda,
    ACTIONS(1956), 1,
      sym_identifier,
    ACTIONS(1964), 1,
      anon_sym_type,
    ACTIONS(1966), 1,
      anon_sym_await,
    ACTIONS(2166), 1,
      anon_sym_LPAREN,
    ACTIONS(2168), 1,
      anon_sym_STAR,
    ACTIONS(2178), 1,
      anon_sym_RBRACE,
    STATE(1221), 1,
      sym_primary_expression,
    STATE(1223), 1,
      sym_string,
    STATE(1459), 1,
      sym_list_splat_pattern,
    STATE(2297), 1,
      sym_expression,
    STATE(3201), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(795), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(791), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(3102), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(779), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1962), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2139), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1449), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [24558] = 24,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(1984), 1,
      sym_identifier,
    ACTIONS(1986), 1,
      anon_sym_STAR,
    ACTIONS(1990), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1992), 1,
      anon_sym_type,
    ACTIONS(1994), 1,
      anon_sym_not,
    ACTIONS(1996), 1,
      anon_sym_lambda,
    ACTIONS(1998), 1,
      anon_sym_await,
    STATE(1488), 1,
      sym_string,
    STATE(1491), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    STATE(2376), 1,
      sym_expression,
    STATE(3239), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(942), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1988), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(3138), 4,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
      sym__directive_parameter,
    STATE(2383), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [24665] = 23,
    ACTIONS(781), 1,
      anon_sym_LPAREN,
    ACTIONS(789), 1,
      anon_sym_LBRACK,
    ACTIONS(793), 1,
      anon_sym_LBRACE,
    ACTIONS(799), 1,
      sym_string_start,
    ACTIONS(1792), 1,
      anon_sym_STAR,
    ACTIONS(1800), 1,
      anon_sym_not,
    ACTIONS(1802), 1,
      anon_sym_lambda,
    ACTIONS(1956), 1,
      sym_identifier,
    ACTIONS(1964), 1,
      anon_sym_type,
    ACTIONS(1966), 1,
      anon_sym_await,
    STATE(1221), 1,
      sym_primary_expression,
    STATE(1223), 1,
      sym_string,
    STATE(1459), 1,
      sym_list_splat_pattern,
    STATE(2154), 1,
      sym_expression,
    STATE(3201), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(795), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(791), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(779), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1962), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(2208), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
    STATE(2139), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1449), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [24770] = 23,
    ACTIONS(781), 1,
      anon_sym_LPAREN,
    ACTIONS(789), 1,
      anon_sym_LBRACK,
    ACTIONS(793), 1,
      anon_sym_LBRACE,
    ACTIONS(799), 1,
      sym_string_start,
    ACTIONS(1792), 1,
      anon_sym_STAR,
    ACTIONS(1800), 1,
      anon_sym_not,
    ACTIONS(1802), 1,
      anon_sym_lambda,
    ACTIONS(1956), 1,
      sym_identifier,
    ACTIONS(1964), 1,
      anon_sym_type,
    ACTIONS(1966), 1,
      anon_sym_await,
    STATE(1221), 1,
      sym_primary_expression,
    STATE(1223), 1,
      sym_string,
    STATE(1459), 1,
      sym_list_splat_pattern,
    STATE(2154), 1,
      sym_expression,
    STATE(3201), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(795), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(791), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(779), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1962), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(2210), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
    STATE(2139), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1449), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [24875] = 25,
    ACTIONS(920), 1,
      anon_sym_LPAREN,
    ACTIONS(928), 1,
      anon_sym_LBRACK,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_string_start,
    ACTIONS(1644), 1,
      anon_sym_not,
    ACTIONS(2006), 1,
      sym_identifier,
    ACTIONS(2012), 1,
      anon_sym_type,
    ACTIONS(2016), 1,
      anon_sym_await,
    ACTIONS(2188), 1,
      anon_sym_RBRACK,
    ACTIONS(2200), 1,
      anon_sym_STAR,
    ACTIONS(2202), 1,
      anon_sym_lambda,
    STATE(1264), 1,
      sym_primary_expression,
    STATE(1279), 1,
      sym_string,
    STATE(1590), 1,
      sym_list_splat_pattern,
    STATE(2238), 1,
      sym_expression,
    STATE(3184), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(934), 2,
      sym_ellipsis,
      sym_float,
    STATE(2430), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(930), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(2010), 3,
      anon_sym_print,
      anon_sym_match,
      anon_sym_exec,
    ACTIONS(2190), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(918), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2189), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1654), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [24984] = 25,
    ACTIONS(854), 1,
      anon_sym_LPAREN,
    ACTIONS(862), 1,
      anon_sym_LBRACK,
    ACTIONS(866), 1,
      anon_sym_LBRACE,
    ACTIONS(872), 1,
      sym_string_start,
    ACTIONS(1606), 1,
      sym_identifier,
    ACTIONS(1618), 1,
      anon_sym_type,
    ACTIONS(1622), 1,
      anon_sym_not,
    ACTIONS(1628), 1,
      anon_sym_await,
    ACTIONS(2196), 1,
      anon_sym_RBRACE,
    ACTIONS(2212), 1,
      anon_sym_STAR,
    ACTIONS(2214), 1,
      anon_sym_lambda,
    STATE(1220), 1,
      sym_primary_expression,
    STATE(1227), 1,
      sym_string,
    STATE(1504), 1,
      sym_list_splat_pattern,
    STATE(2212), 1,
      sym_expression,
    STATE(3456), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(868), 2,
      sym_ellipsis,
      sym_float,
    STATE(2428), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(864), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1614), 3,
      anon_sym_print,
      anon_sym_match,
      anon_sym_exec,
    ACTIONS(2198), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(852), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2165), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [25093] = 25,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1598), 1,
      anon_sym_yield,
    ACTIONS(1832), 1,
      anon_sym_type,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1838), 1,
      anon_sym_await,
    ACTIONS(1946), 1,
      anon_sym_LPAREN,
    ACTIONS(2170), 1,
      anon_sym_RPAREN,
    ACTIONS(2204), 1,
      sym_identifier,
    ACTIONS(2206), 1,
      anon_sym_STAR,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2293), 1,
      sym_expression,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(3121), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1828), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [25202] = 25,
    ACTIONS(854), 1,
      anon_sym_LPAREN,
    ACTIONS(862), 1,
      anon_sym_LBRACK,
    ACTIONS(866), 1,
      anon_sym_LBRACE,
    ACTIONS(872), 1,
      sym_string_start,
    ACTIONS(1606), 1,
      sym_identifier,
    ACTIONS(1618), 1,
      anon_sym_type,
    ACTIONS(1622), 1,
      anon_sym_not,
    ACTIONS(1628), 1,
      anon_sym_await,
    ACTIONS(2192), 1,
      anon_sym_RBRACE,
    ACTIONS(2212), 1,
      anon_sym_STAR,
    ACTIONS(2214), 1,
      anon_sym_lambda,
    STATE(1220), 1,
      sym_primary_expression,
    STATE(1227), 1,
      sym_string,
    STATE(1504), 1,
      sym_list_splat_pattern,
    STATE(2212), 1,
      sym_expression,
    STATE(3456), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(868), 2,
      sym_ellipsis,
      sym_float,
    STATE(2428), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(864), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1614), 3,
      anon_sym_print,
      anon_sym_match,
      anon_sym_exec,
    ACTIONS(2194), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(852), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2165), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [25311] = 25,
    ACTIONS(854), 1,
      anon_sym_LPAREN,
    ACTIONS(862), 1,
      anon_sym_LBRACK,
    ACTIONS(866), 1,
      anon_sym_LBRACE,
    ACTIONS(872), 1,
      sym_string_start,
    ACTIONS(1606), 1,
      sym_identifier,
    ACTIONS(1618), 1,
      anon_sym_type,
    ACTIONS(1622), 1,
      anon_sym_not,
    ACTIONS(1628), 1,
      anon_sym_await,
    ACTIONS(2180), 1,
      anon_sym_RBRACE,
    ACTIONS(2212), 1,
      anon_sym_STAR,
    ACTIONS(2214), 1,
      anon_sym_lambda,
    STATE(1220), 1,
      sym_primary_expression,
    STATE(1227), 1,
      sym_string,
    STATE(1504), 1,
      sym_list_splat_pattern,
    STATE(2212), 1,
      sym_expression,
    STATE(3456), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(868), 2,
      sym_ellipsis,
      sym_float,
    STATE(2428), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(864), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1614), 3,
      anon_sym_print,
      anon_sym_match,
      anon_sym_exec,
    ACTIONS(2184), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(852), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2165), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [25420] = 25,
    ACTIONS(854), 1,
      anon_sym_LPAREN,
    ACTIONS(862), 1,
      anon_sym_LBRACK,
    ACTIONS(866), 1,
      anon_sym_LBRACE,
    ACTIONS(872), 1,
      sym_string_start,
    ACTIONS(1606), 1,
      sym_identifier,
    ACTIONS(1618), 1,
      anon_sym_type,
    ACTIONS(1622), 1,
      anon_sym_not,
    ACTIONS(1628), 1,
      anon_sym_await,
    ACTIONS(2188), 1,
      anon_sym_RBRACE,
    ACTIONS(2212), 1,
      anon_sym_STAR,
    ACTIONS(2214), 1,
      anon_sym_lambda,
    STATE(1220), 1,
      sym_primary_expression,
    STATE(1227), 1,
      sym_string,
    STATE(1504), 1,
      sym_list_splat_pattern,
    STATE(2212), 1,
      sym_expression,
    STATE(3456), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(868), 2,
      sym_ellipsis,
      sym_float,
    STATE(2428), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(864), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1614), 3,
      anon_sym_print,
      anon_sym_match,
      anon_sym_exec,
    ACTIONS(2190), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(852), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2165), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [25529] = 25,
    ACTIONS(876), 1,
      anon_sym_LPAREN,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1832), 1,
      anon_sym_type,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1838), 1,
      anon_sym_await,
    ACTIONS(2204), 1,
      sym_identifier,
    ACTIONS(2216), 1,
      anon_sym_from,
    ACTIONS(2218), 1,
      anon_sym_STAR,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2241), 1,
      sym_expression,
    STATE(3154), 1,
      sym_expression_list,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1960), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1828), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [25637] = 25,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(494), 1,
      anon_sym_STAR,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(1616), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2220), 1,
      anon_sym_RBRACE,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2450), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(3132), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [25745] = 25,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(494), 1,
      anon_sym_STAR,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(1616), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2222), 1,
      anon_sym_RBRACE,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2450), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(3132), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [25853] = 25,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(494), 1,
      anon_sym_STAR,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(1616), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2224), 1,
      anon_sym_RBRACE,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2450), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(3132), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [25961] = 25,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(494), 1,
      anon_sym_STAR,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(1616), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2226), 1,
      anon_sym_RBRACE,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2450), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(3132), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [26069] = 25,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(494), 1,
      anon_sym_STAR,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(1616), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2228), 1,
      anon_sym_RBRACE,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2450), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(3132), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [26177] = 25,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(494), 1,
      anon_sym_STAR,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(1616), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2230), 1,
      anon_sym_RBRACE,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2450), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(3132), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [26285] = 25,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(494), 1,
      anon_sym_STAR,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(1616), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2232), 1,
      anon_sym_RBRACE,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2450), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(3132), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [26393] = 25,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(494), 1,
      anon_sym_STAR,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(1616), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2234), 1,
      anon_sym_RBRACE,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2450), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(3132), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [26501] = 25,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(494), 1,
      anon_sym_STAR,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(1616), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2236), 1,
      anon_sym_RBRACE,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2450), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(3132), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [26609] = 25,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(494), 1,
      anon_sym_STAR,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(1616), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2238), 1,
      anon_sym_RBRACE,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2450), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(3132), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [26717] = 25,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(494), 1,
      anon_sym_STAR,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(1616), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2240), 1,
      anon_sym_RBRACE,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2450), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(3132), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [26825] = 24,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1648), 1,
      anon_sym_yield,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2174), 1,
      anon_sym_LPAREN,
    ACTIONS(2176), 1,
      anon_sym_STAR,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2334), 1,
      sym_expression,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(3143), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [26931] = 25,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(494), 1,
      anon_sym_STAR,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(1616), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2242), 1,
      anon_sym_RBRACE,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2450), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(3132), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [27039] = 25,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(494), 1,
      anon_sym_STAR,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(1616), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2244), 1,
      anon_sym_RBRACE,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2450), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(3132), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [27147] = 25,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(465), 1,
      sym_identifier,
    ACTIONS(477), 1,
      anon_sym_type,
    ACTIONS(488), 1,
      anon_sym_await,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(2246), 1,
      anon_sym_from,
    ACTIONS(2248), 1,
      anon_sym_STAR,
    STATE(1200), 1,
      sym_string,
    STATE(1203), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    STATE(2190), 1,
      sym_expression,
    STATE(3054), 1,
      sym_expression_list,
    STATE(3427), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1960), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(473), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2070), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [27255] = 25,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(494), 1,
      anon_sym_STAR,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(1616), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2250), 1,
      anon_sym_RBRACE,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2450), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(3132), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [27363] = 25,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(494), 1,
      anon_sym_STAR,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(1616), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2252), 1,
      anon_sym_RBRACE,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2450), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(3132), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [27471] = 25,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(494), 1,
      anon_sym_STAR,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(1616), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2254), 1,
      anon_sym_RBRACE,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2450), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(3132), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [27579] = 24,
    ACTIONS(789), 1,
      anon_sym_LBRACK,
    ACTIONS(793), 1,
      anon_sym_LBRACE,
    ACTIONS(799), 1,
      sym_string_start,
    ACTIONS(1626), 1,
      anon_sym_yield,
    ACTIONS(1800), 1,
      anon_sym_not,
    ACTIONS(1802), 1,
      anon_sym_lambda,
    ACTIONS(1956), 1,
      sym_identifier,
    ACTIONS(1964), 1,
      anon_sym_type,
    ACTIONS(1966), 1,
      anon_sym_await,
    ACTIONS(2166), 1,
      anon_sym_LPAREN,
    ACTIONS(2168), 1,
      anon_sym_STAR,
    STATE(1221), 1,
      sym_primary_expression,
    STATE(1223), 1,
      sym_string,
    STATE(1459), 1,
      sym_list_splat_pattern,
    STATE(2297), 1,
      sym_expression,
    STATE(3201), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(795), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(791), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(3102), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(779), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1962), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2139), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1449), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [27685] = 25,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2256), 1,
      anon_sym_from,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2248), 1,
      sym_expression,
    STATE(3094), 1,
      sym_expression_list,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1960), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [27793] = 25,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(494), 1,
      anon_sym_STAR,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(1616), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2260), 1,
      anon_sym_RBRACE,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2450), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(3132), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [27901] = 25,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(494), 1,
      anon_sym_STAR,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(1616), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2262), 1,
      anon_sym_RBRACE,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2450), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(3132), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [28009] = 24,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1598), 1,
      anon_sym_yield,
    ACTIONS(1832), 1,
      anon_sym_type,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1838), 1,
      anon_sym_await,
    ACTIONS(1946), 1,
      anon_sym_LPAREN,
    ACTIONS(2204), 1,
      sym_identifier,
    ACTIONS(2206), 1,
      anon_sym_STAR,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2293), 1,
      sym_expression,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(3121), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1828), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [28115] = 25,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(465), 1,
      sym_identifier,
    ACTIONS(477), 1,
      anon_sym_type,
    ACTIONS(488), 1,
      anon_sym_await,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(2248), 1,
      anon_sym_STAR,
    ACTIONS(2266), 1,
      anon_sym_from,
    STATE(1200), 1,
      sym_string,
    STATE(1203), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    STATE(2164), 1,
      sym_expression,
    STATE(2688), 1,
      sym_expression_list,
    STATE(3427), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(2264), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(473), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2070), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [28223] = 24,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    ACTIONS(2270), 1,
      anon_sym_COLON,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2266), 1,
      sym_expression,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(2268), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [28328] = 25,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    ACTIONS(2272), 1,
      anon_sym_COLON,
    ACTIONS(2274), 1,
      anon_sym_RBRACK,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2247), 1,
      sym_expression,
    STATE(3114), 1,
      sym_slice,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [28435] = 25,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    ACTIONS(2272), 1,
      anon_sym_COLON,
    ACTIONS(2276), 1,
      anon_sym_RBRACK,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2247), 1,
      sym_expression,
    STATE(3114), 1,
      sym_slice,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [28542] = 25,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    ACTIONS(2272), 1,
      anon_sym_COLON,
    ACTIONS(2278), 1,
      anon_sym_RBRACK,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2247), 1,
      sym_expression,
    STATE(3114), 1,
      sym_slice,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [28649] = 25,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    ACTIONS(2272), 1,
      anon_sym_COLON,
    ACTIONS(2280), 1,
      anon_sym_RBRACK,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2247), 1,
      sym_expression,
    STATE(3114), 1,
      sym_slice,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [28756] = 25,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    ACTIONS(2272), 1,
      anon_sym_COLON,
    ACTIONS(2282), 1,
      anon_sym_RBRACK,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2247), 1,
      sym_expression,
    STATE(3114), 1,
      sym_slice,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [28863] = 25,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    ACTIONS(2272), 1,
      anon_sym_COLON,
    ACTIONS(2284), 1,
      anon_sym_RBRACK,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2247), 1,
      sym_expression,
    STATE(3114), 1,
      sym_slice,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [28970] = 25,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    ACTIONS(2272), 1,
      anon_sym_COLON,
    ACTIONS(2286), 1,
      anon_sym_RBRACK,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2247), 1,
      sym_expression,
    STATE(3114), 1,
      sym_slice,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [29077] = 25,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    ACTIONS(2272), 1,
      anon_sym_COLON,
    ACTIONS(2288), 1,
      anon_sym_RBRACK,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2247), 1,
      sym_expression,
    STATE(3114), 1,
      sym_slice,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [29184] = 25,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    ACTIONS(2272), 1,
      anon_sym_COLON,
    ACTIONS(2290), 1,
      anon_sym_RBRACK,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2247), 1,
      sym_expression,
    STATE(3114), 1,
      sym_slice,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [29291] = 25,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    ACTIONS(2272), 1,
      anon_sym_COLON,
    ACTIONS(2292), 1,
      anon_sym_RBRACK,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2247), 1,
      sym_expression,
    STATE(3114), 1,
      sym_slice,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [29398] = 19,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(494), 1,
      anon_sym_STAR,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(775), 1,
      anon_sym_type,
    ACTIONS(777), 1,
      anon_sym_await,
    STATE(1234), 1,
      sym_string,
    STATE(1298), 1,
      sym_primary_expression,
    STATE(1541), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 2,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(766), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(773), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(361), 9,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [29493] = 25,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    ACTIONS(2272), 1,
      anon_sym_COLON,
    ACTIONS(2294), 1,
      anon_sym_RBRACK,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2247), 1,
      sym_expression,
    STATE(3114), 1,
      sym_slice,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [29600] = 24,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    ACTIONS(2298), 1,
      anon_sym_COLON,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2244), 1,
      sym_expression,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(2296), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [29705] = 24,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(465), 1,
      sym_identifier,
    ACTIONS(477), 1,
      anon_sym_type,
    ACTIONS(488), 1,
      anon_sym_await,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(2248), 1,
      anon_sym_STAR,
    ACTIONS(2300), 1,
      anon_sym_from,
    STATE(1200), 1,
      sym_string,
    STATE(1203), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    STATE(2208), 1,
      sym_expression,
    STATE(3427), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(2208), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(473), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2070), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [29810] = 25,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    ACTIONS(2272), 1,
      anon_sym_COLON,
    ACTIONS(2302), 1,
      anon_sym_RBRACK,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2247), 1,
      sym_expression,
    STATE(3114), 1,
      sym_slice,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [29917] = 19,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(494), 1,
      anon_sym_STAR,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(775), 1,
      anon_sym_type,
    ACTIONS(777), 1,
      anon_sym_await,
    STATE(1234), 1,
      sym_string,
    STATE(1298), 1,
      sym_primary_expression,
    STATE(1541), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 2,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(2304), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(773), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(361), 9,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [30012] = 25,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    ACTIONS(2272), 1,
      anon_sym_COLON,
    ACTIONS(2306), 1,
      anon_sym_RBRACK,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2247), 1,
      sym_expression,
    STATE(3114), 1,
      sym_slice,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [30119] = 25,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    ACTIONS(2272), 1,
      anon_sym_COLON,
    ACTIONS(2308), 1,
      anon_sym_RBRACK,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2247), 1,
      sym_expression,
    STATE(3114), 1,
      sym_slice,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [30226] = 24,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(465), 1,
      sym_identifier,
    ACTIONS(477), 1,
      anon_sym_type,
    ACTIONS(488), 1,
      anon_sym_await,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(2248), 1,
      anon_sym_STAR,
    ACTIONS(2310), 1,
      anon_sym_from,
    STATE(1200), 1,
      sym_string,
    STATE(1203), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    STATE(2208), 1,
      sym_expression,
    STATE(3427), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(2210), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(473), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2070), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [30331] = 25,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    ACTIONS(2272), 1,
      anon_sym_COLON,
    ACTIONS(2312), 1,
      anon_sym_RBRACK,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2247), 1,
      sym_expression,
    STATE(3114), 1,
      sym_slice,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [30438] = 25,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    ACTIONS(2272), 1,
      anon_sym_COLON,
    ACTIONS(2314), 1,
      anon_sym_RBRACK,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2247), 1,
      sym_expression,
    STATE(3114), 1,
      sym_slice,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [30545] = 25,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    ACTIONS(2272), 1,
      anon_sym_COLON,
    ACTIONS(2316), 1,
      anon_sym_RBRACK,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2247), 1,
      sym_expression,
    STATE(3114), 1,
      sym_slice,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [30652] = 25,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    ACTIONS(2272), 1,
      anon_sym_COLON,
    ACTIONS(2318), 1,
      anon_sym_RBRACK,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2247), 1,
      sym_expression,
    STATE(3114), 1,
      sym_slice,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [30759] = 25,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    ACTIONS(2272), 1,
      anon_sym_COLON,
    ACTIONS(2320), 1,
      anon_sym_RBRACK,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2247), 1,
      sym_expression,
    STATE(3114), 1,
      sym_slice,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [30866] = 25,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    ACTIONS(2272), 1,
      anon_sym_COLON,
    ACTIONS(2322), 1,
      anon_sym_RBRACK,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2247), 1,
      sym_expression,
    STATE(3114), 1,
      sym_slice,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [30973] = 25,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    ACTIONS(2272), 1,
      anon_sym_COLON,
    ACTIONS(2324), 1,
      anon_sym_RBRACK,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2247), 1,
      sym_expression,
    STATE(3114), 1,
      sym_slice,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [31080] = 25,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    ACTIONS(2272), 1,
      anon_sym_COLON,
    ACTIONS(2326), 1,
      anon_sym_RBRACK,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2247), 1,
      sym_expression,
    STATE(3114), 1,
      sym_slice,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [31187] = 25,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    ACTIONS(2272), 1,
      anon_sym_COLON,
    ACTIONS(2328), 1,
      anon_sym_RBRACK,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2247), 1,
      sym_expression,
    STATE(3114), 1,
      sym_slice,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [31294] = 25,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    ACTIONS(2272), 1,
      anon_sym_COLON,
    ACTIONS(2330), 1,
      anon_sym_RBRACK,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2247), 1,
      sym_expression,
    STATE(3114), 1,
      sym_slice,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [31401] = 25,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    ACTIONS(2272), 1,
      anon_sym_COLON,
    ACTIONS(2332), 1,
      anon_sym_RBRACK,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2247), 1,
      sym_expression,
    STATE(3114), 1,
      sym_slice,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [31508] = 25,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    ACTIONS(2272), 1,
      anon_sym_COLON,
    ACTIONS(2334), 1,
      anon_sym_RBRACK,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2247), 1,
      sym_expression,
    STATE(3114), 1,
      sym_slice,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [31615] = 25,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    ACTIONS(2272), 1,
      anon_sym_COLON,
    ACTIONS(2336), 1,
      anon_sym_RBRACK,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2247), 1,
      sym_expression,
    STATE(3114), 1,
      sym_slice,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [31722] = 24,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(494), 1,
      anon_sym_STAR,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(1616), 1,
      anon_sym_STAR_STAR,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2450), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(3132), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [31827] = 25,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    ACTIONS(2272), 1,
      anon_sym_COLON,
    ACTIONS(2338), 1,
      anon_sym_RBRACK,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2247), 1,
      sym_expression,
    STATE(3114), 1,
      sym_slice,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [31934] = 25,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    ACTIONS(2272), 1,
      anon_sym_COLON,
    ACTIONS(2340), 1,
      anon_sym_RBRACK,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2247), 1,
      sym_expression,
    STATE(3114), 1,
      sym_slice,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [32041] = 24,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(465), 1,
      sym_identifier,
    ACTIONS(477), 1,
      anon_sym_type,
    ACTIONS(488), 1,
      anon_sym_await,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(2248), 1,
      anon_sym_STAR,
    STATE(1200), 1,
      sym_string,
    STATE(1203), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    STATE(2227), 1,
      sym_expression,
    STATE(3044), 1,
      sym_expression_list,
    STATE(3427), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(2342), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(473), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2070), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [32146] = 25,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    ACTIONS(2272), 1,
      anon_sym_COLON,
    ACTIONS(2344), 1,
      anon_sym_RBRACK,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2247), 1,
      sym_expression,
    STATE(3114), 1,
      sym_slice,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [32253] = 25,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    ACTIONS(2272), 1,
      anon_sym_COLON,
    ACTIONS(2346), 1,
      anon_sym_RBRACK,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2247), 1,
      sym_expression,
    STATE(3114), 1,
      sym_slice,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [32360] = 25,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    ACTIONS(2272), 1,
      anon_sym_COLON,
    ACTIONS(2348), 1,
      anon_sym_RBRACK,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2247), 1,
      sym_expression,
    STATE(3114), 1,
      sym_slice,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [32467] = 25,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    ACTIONS(2272), 1,
      anon_sym_COLON,
    ACTIONS(2350), 1,
      anon_sym_RBRACK,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2247), 1,
      sym_expression,
    STATE(3114), 1,
      sym_slice,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [32574] = 24,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    ACTIONS(2272), 1,
      anon_sym_COLON,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2228), 1,
      sym_expression,
    STATE(2971), 1,
      sym_slice,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [32678] = 24,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    ACTIONS(2272), 1,
      anon_sym_COLON,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2191), 1,
      sym_expression,
    STATE(2928), 1,
      sym_slice,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [32782] = 24,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(2352), 1,
      anon_sym_LPAREN,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2299), 1,
      sym_expression,
    STATE(2695), 1,
      sym_with_item,
    STATE(3286), 1,
      sym__named_expression_lhs,
    STATE(3329), 1,
      sym_with_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [32886] = 24,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(2352), 1,
      anon_sym_LPAREN,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2299), 1,
      sym_expression,
    STATE(2695), 1,
      sym_with_item,
    STATE(3286), 1,
      sym__named_expression_lhs,
    STATE(3321), 1,
      sym_with_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [32990] = 23,
    ACTIONS(830), 1,
      anon_sym_LPAREN,
    ACTIONS(840), 1,
      anon_sym_LBRACK,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(1594), 1,
      anon_sym_not,
    ACTIONS(1922), 1,
      sym_identifier,
    ACTIONS(1928), 1,
      anon_sym_type,
    ACTIONS(1930), 1,
      anon_sym_await,
    ACTIONS(2182), 1,
      anon_sym_STAR,
    ACTIONS(2186), 1,
      anon_sym_lambda,
    STATE(1271), 1,
      sym_string,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1530), 1,
      sym_list_splat_pattern,
    STATE(2188), 1,
      sym_expression,
    STATE(3306), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    STATE(2310), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(828), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1926), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2173), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1660), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [33092] = 20,
    ACTIONS(378), 1,
      anon_sym_in,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(400), 1,
      anon_sym_COMMA,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(494), 1,
      anon_sym_STAR,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(775), 1,
      anon_sym_type,
    ACTIONS(777), 1,
      anon_sym_await,
    STATE(1234), 1,
      sym_string,
    STATE(1298), 1,
      sym_primary_expression,
    STATE(1541), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 2,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(773), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(361), 9,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [33188] = 24,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(2352), 1,
      anon_sym_LPAREN,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2299), 1,
      sym_expression,
    STATE(2695), 1,
      sym_with_item,
    STATE(3286), 1,
      sym__named_expression_lhs,
    STATE(3404), 1,
      sym_with_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [33292] = 23,
    ACTIONS(830), 1,
      anon_sym_LPAREN,
    ACTIONS(840), 1,
      anon_sym_LBRACK,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(1594), 1,
      anon_sym_not,
    ACTIONS(1922), 1,
      sym_identifier,
    ACTIONS(1928), 1,
      anon_sym_type,
    ACTIONS(1930), 1,
      anon_sym_await,
    ACTIONS(2182), 1,
      anon_sym_STAR,
    ACTIONS(2186), 1,
      anon_sym_lambda,
    STATE(1271), 1,
      sym_string,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1530), 1,
      sym_list_splat_pattern,
    STATE(2207), 1,
      sym_expression,
    STATE(3306), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    STATE(2411), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(828), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1926), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2173), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1660), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [33394] = 24,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    ACTIONS(2272), 1,
      anon_sym_COLON,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2170), 1,
      sym_expression,
    STATE(2692), 1,
      sym_slice,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [33498] = 23,
    ACTIONS(876), 1,
      anon_sym_LPAREN,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1832), 1,
      anon_sym_type,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1838), 1,
      anon_sym_await,
    ACTIONS(2204), 1,
      sym_identifier,
    ACTIONS(2218), 1,
      anon_sym_STAR,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2296), 1,
      sym_expression,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(2210), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1828), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [33600] = 23,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(465), 1,
      sym_identifier,
    ACTIONS(477), 1,
      anon_sym_type,
    ACTIONS(488), 1,
      anon_sym_await,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(2248), 1,
      anon_sym_STAR,
    STATE(1200), 1,
      sym_string,
    STATE(1203), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    STATE(2278), 1,
      sym_expression,
    STATE(3427), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(2356), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(473), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2070), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [33702] = 23,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(465), 1,
      sym_identifier,
    ACTIONS(477), 1,
      anon_sym_type,
    ACTIONS(488), 1,
      anon_sym_await,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(2248), 1,
      anon_sym_STAR,
    STATE(1200), 1,
      sym_string,
    STATE(1203), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    STATE(2278), 1,
      sym_expression,
    STATE(3427), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(2358), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(473), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2070), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [33804] = 23,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(465), 1,
      sym_identifier,
    ACTIONS(477), 1,
      anon_sym_type,
    ACTIONS(488), 1,
      anon_sym_await,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(2248), 1,
      anon_sym_STAR,
    STATE(1200), 1,
      sym_string,
    STATE(1203), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    STATE(2278), 1,
      sym_expression,
    STATE(3427), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(2360), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(473), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2070), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [33906] = 24,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(2352), 1,
      anon_sym_LPAREN,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2299), 1,
      sym_expression,
    STATE(2695), 1,
      sym_with_item,
    STATE(3286), 1,
      sym__named_expression_lhs,
    STATE(3345), 1,
      sym_with_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [34010] = 24,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    ACTIONS(2272), 1,
      anon_sym_COLON,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2204), 1,
      sym_expression,
    STATE(2832), 1,
      sym_slice,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [34114] = 23,
    ACTIONS(876), 1,
      anon_sym_LPAREN,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1832), 1,
      anon_sym_type,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1838), 1,
      anon_sym_await,
    ACTIONS(2204), 1,
      sym_identifier,
    ACTIONS(2218), 1,
      anon_sym_STAR,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2296), 1,
      sym_expression,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(2208), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1828), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [34216] = 23,
    ACTIONS(920), 1,
      anon_sym_LPAREN,
    ACTIONS(928), 1,
      anon_sym_LBRACK,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_string_start,
    ACTIONS(1644), 1,
      anon_sym_not,
    ACTIONS(2006), 1,
      sym_identifier,
    ACTIONS(2012), 1,
      anon_sym_type,
    ACTIONS(2016), 1,
      anon_sym_await,
    ACTIONS(2200), 1,
      anon_sym_STAR,
    ACTIONS(2202), 1,
      anon_sym_lambda,
    STATE(1264), 1,
      sym_primary_expression,
    STATE(1279), 1,
      sym_string,
    STATE(1590), 1,
      sym_list_splat_pattern,
    STATE(2238), 1,
      sym_expression,
    STATE(3184), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(934), 2,
      sym_ellipsis,
      sym_float,
    STATE(2378), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(930), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(918), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2010), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2189), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1654), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [34318] = 19,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(494), 1,
      anon_sym_STAR,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(775), 1,
      anon_sym_type,
    ACTIONS(777), 1,
      anon_sym_await,
    STATE(1234), 1,
      sym_string,
    STATE(1298), 1,
      sym_primary_expression,
    STATE(1541), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 2,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(400), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(773), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(361), 9,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [34412] = 23,
    ACTIONS(854), 1,
      anon_sym_LPAREN,
    ACTIONS(862), 1,
      anon_sym_LBRACK,
    ACTIONS(866), 1,
      anon_sym_LBRACE,
    ACTIONS(872), 1,
      sym_string_start,
    ACTIONS(1606), 1,
      sym_identifier,
    ACTIONS(1618), 1,
      anon_sym_type,
    ACTIONS(1622), 1,
      anon_sym_not,
    ACTIONS(1628), 1,
      anon_sym_await,
    ACTIONS(2212), 1,
      anon_sym_STAR,
    ACTIONS(2214), 1,
      anon_sym_lambda,
    STATE(1220), 1,
      sym_primary_expression,
    STATE(1227), 1,
      sym_string,
    STATE(1504), 1,
      sym_list_splat_pattern,
    STATE(2216), 1,
      sym_expression,
    STATE(3456), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(868), 2,
      sym_ellipsis,
      sym_float,
    STATE(2482), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(864), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(852), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1614), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2165), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [34514] = 24,
    ACTIONS(876), 1,
      anon_sym_LPAREN,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1832), 1,
      anon_sym_type,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1838), 1,
      anon_sym_await,
    ACTIONS(2204), 1,
      sym_identifier,
    ACTIONS(2218), 1,
      anon_sym_STAR,
    ACTIONS(2362), 1,
      anon_sym_RPAREN,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2327), 1,
      sym_expression,
    STATE(3142), 1,
      sym_with_item,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1828), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [34618] = 24,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    ACTIONS(2272), 1,
      anon_sym_COLON,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2193), 1,
      sym_expression,
    STATE(2762), 1,
      sym_slice,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [34722] = 23,
    ACTIONS(830), 1,
      anon_sym_LPAREN,
    ACTIONS(840), 1,
      anon_sym_LBRACK,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(1594), 1,
      anon_sym_not,
    ACTIONS(1922), 1,
      sym_identifier,
    ACTIONS(1928), 1,
      anon_sym_type,
    ACTIONS(1930), 1,
      anon_sym_await,
    ACTIONS(2182), 1,
      anon_sym_STAR,
    ACTIONS(2186), 1,
      anon_sym_lambda,
    STATE(1271), 1,
      sym_string,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1530), 1,
      sym_list_splat_pattern,
    STATE(2226), 1,
      sym_expression,
    STATE(3306), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    STATE(2492), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(828), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1926), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2173), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1660), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [34824] = 24,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    ACTIONS(2272), 1,
      anon_sym_COLON,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2179), 1,
      sym_expression,
    STATE(2772), 1,
      sym_slice,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [34928] = 19,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(494), 1,
      anon_sym_STAR,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(775), 1,
      anon_sym_type,
    ACTIONS(777), 1,
      anon_sym_await,
    STATE(1234), 1,
      sym_string,
    STATE(1298), 1,
      sym_primary_expression,
    STATE(1541), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 2,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(766), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(773), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(361), 9,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [35022] = 19,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(494), 1,
      anon_sym_STAR,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(775), 1,
      anon_sym_type,
    ACTIONS(777), 1,
      anon_sym_await,
    STATE(1234), 1,
      sym_string,
    STATE(1298), 1,
      sym_primary_expression,
    STATE(1541), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 2,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(400), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(773), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(361), 9,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [35116] = 23,
    ACTIONS(854), 1,
      anon_sym_LPAREN,
    ACTIONS(862), 1,
      anon_sym_LBRACK,
    ACTIONS(866), 1,
      anon_sym_LBRACE,
    ACTIONS(872), 1,
      sym_string_start,
    ACTIONS(1606), 1,
      sym_identifier,
    ACTIONS(1618), 1,
      anon_sym_type,
    ACTIONS(1622), 1,
      anon_sym_not,
    ACTIONS(1628), 1,
      anon_sym_await,
    ACTIONS(2212), 1,
      anon_sym_STAR,
    ACTIONS(2214), 1,
      anon_sym_lambda,
    STATE(1220), 1,
      sym_primary_expression,
    STATE(1227), 1,
      sym_string,
    STATE(1504), 1,
      sym_list_splat_pattern,
    STATE(2231), 1,
      sym_expression,
    STATE(3456), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(868), 2,
      sym_ellipsis,
      sym_float,
    STATE(2516), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(864), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(852), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1614), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2165), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [35218] = 24,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    ACTIONS(2364), 1,
      anon_sym_COLON,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2299), 1,
      sym_expression,
    STATE(3129), 1,
      sym_with_item,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [35322] = 24,
    ACTIONS(876), 1,
      anon_sym_LPAREN,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1832), 1,
      anon_sym_type,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1838), 1,
      anon_sym_await,
    ACTIONS(2204), 1,
      sym_identifier,
    ACTIONS(2218), 1,
      anon_sym_STAR,
    ACTIONS(2366), 1,
      anon_sym_RPAREN,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2327), 1,
      sym_expression,
    STATE(3142), 1,
      sym_with_item,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1828), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [35426] = 23,
    ACTIONS(920), 1,
      anon_sym_LPAREN,
    ACTIONS(928), 1,
      anon_sym_LBRACK,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_string_start,
    ACTIONS(1644), 1,
      anon_sym_not,
    ACTIONS(2006), 1,
      sym_identifier,
    ACTIONS(2012), 1,
      anon_sym_type,
    ACTIONS(2016), 1,
      anon_sym_await,
    ACTIONS(2200), 1,
      anon_sym_STAR,
    ACTIONS(2202), 1,
      anon_sym_lambda,
    STATE(1264), 1,
      sym_primary_expression,
    STATE(1279), 1,
      sym_string,
    STATE(1590), 1,
      sym_list_splat_pattern,
    STATE(2238), 1,
      sym_expression,
    STATE(3184), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(934), 2,
      sym_ellipsis,
      sym_float,
    STATE(2365), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(930), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(918), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2010), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2189), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1654), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [35528] = 23,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(465), 1,
      sym_identifier,
    ACTIONS(477), 1,
      anon_sym_type,
    ACTIONS(488), 1,
      anon_sym_await,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(2248), 1,
      anon_sym_STAR,
    STATE(1200), 1,
      sym_string,
    STATE(1203), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    STATE(2278), 1,
      sym_expression,
    STATE(3427), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(2368), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(473), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2070), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [35630] = 24,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    ACTIONS(2272), 1,
      anon_sym_COLON,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2186), 1,
      sym_expression,
    STATE(2872), 1,
      sym_slice,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [35734] = 24,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    ACTIONS(2370), 1,
      anon_sym_COLON,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2299), 1,
      sym_expression,
    STATE(3129), 1,
      sym_with_item,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [35838] = 23,
    ACTIONS(920), 1,
      anon_sym_LPAREN,
    ACTIONS(928), 1,
      anon_sym_LBRACK,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_string_start,
    ACTIONS(1644), 1,
      anon_sym_not,
    ACTIONS(2006), 1,
      sym_identifier,
    ACTIONS(2012), 1,
      anon_sym_type,
    ACTIONS(2016), 1,
      anon_sym_await,
    ACTIONS(2200), 1,
      anon_sym_STAR,
    ACTIONS(2202), 1,
      anon_sym_lambda,
    STATE(1264), 1,
      sym_primary_expression,
    STATE(1279), 1,
      sym_string,
    STATE(1590), 1,
      sym_list_splat_pattern,
    STATE(2194), 1,
      sym_expression,
    STATE(3184), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(934), 2,
      sym_ellipsis,
      sym_float,
    STATE(2439), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(930), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(918), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2010), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2189), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1654), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [35940] = 24,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    ACTIONS(2272), 1,
      anon_sym_COLON,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2247), 1,
      sym_expression,
    STATE(3114), 1,
      sym_slice,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [36044] = 23,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2371), 1,
      sym_expression,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(2372), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [36146] = 23,
    ACTIONS(854), 1,
      anon_sym_LPAREN,
    ACTIONS(862), 1,
      anon_sym_LBRACK,
    ACTIONS(866), 1,
      anon_sym_LBRACE,
    ACTIONS(872), 1,
      sym_string_start,
    ACTIONS(1606), 1,
      sym_identifier,
    ACTIONS(1618), 1,
      anon_sym_type,
    ACTIONS(1622), 1,
      anon_sym_not,
    ACTIONS(1628), 1,
      anon_sym_await,
    ACTIONS(2212), 1,
      anon_sym_STAR,
    ACTIONS(2214), 1,
      anon_sym_lambda,
    STATE(1220), 1,
      sym_primary_expression,
    STATE(1227), 1,
      sym_string,
    STATE(1504), 1,
      sym_list_splat_pattern,
    STATE(2212), 1,
      sym_expression,
    STATE(3456), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(868), 2,
      sym_ellipsis,
      sym_float,
    STATE(2325), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(864), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(852), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1614), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2165), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [36248] = 23,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2351), 1,
      sym_expression,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(2208), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [36350] = 23,
    ACTIONS(854), 1,
      anon_sym_LPAREN,
    ACTIONS(862), 1,
      anon_sym_LBRACK,
    ACTIONS(866), 1,
      anon_sym_LBRACE,
    ACTIONS(872), 1,
      sym_string_start,
    ACTIONS(1606), 1,
      sym_identifier,
    ACTIONS(1618), 1,
      anon_sym_type,
    ACTIONS(1622), 1,
      anon_sym_not,
    ACTIONS(1628), 1,
      anon_sym_await,
    ACTIONS(2212), 1,
      anon_sym_STAR,
    ACTIONS(2214), 1,
      anon_sym_lambda,
    STATE(1220), 1,
      sym_primary_expression,
    STATE(1227), 1,
      sym_string,
    STATE(1504), 1,
      sym_list_splat_pattern,
    STATE(2212), 1,
      sym_expression,
    STATE(3456), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(868), 2,
      sym_ellipsis,
      sym_float,
    STATE(2317), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(864), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(852), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1614), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2165), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [36452] = 24,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    ACTIONS(2272), 1,
      anon_sym_COLON,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2200), 1,
      sym_expression,
    STATE(2785), 1,
      sym_slice,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [36556] = 23,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2336), 1,
      sym_expression,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(2296), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [36658] = 23,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(465), 1,
      sym_identifier,
    ACTIONS(477), 1,
      anon_sym_type,
    ACTIONS(488), 1,
      anon_sym_await,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(2248), 1,
      anon_sym_STAR,
    STATE(1200), 1,
      sym_string,
    STATE(1203), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    STATE(2208), 1,
      sym_expression,
    STATE(3427), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(2374), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(473), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2070), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [36760] = 24,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    ACTIONS(2272), 1,
      anon_sym_COLON,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2197), 1,
      sym_expression,
    STATE(2797), 1,
      sym_slice,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [36864] = 24,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    ACTIONS(2272), 1,
      anon_sym_COLON,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2171), 1,
      sym_expression,
    STATE(3026), 1,
      sym_slice,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [36968] = 23,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(465), 1,
      sym_identifier,
    ACTIONS(477), 1,
      anon_sym_type,
    ACTIONS(488), 1,
      anon_sym_await,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(2248), 1,
      anon_sym_STAR,
    STATE(1200), 1,
      sym_string,
    STATE(1203), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    STATE(2208), 1,
      sym_expression,
    STATE(3427), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(2376), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(473), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2070), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [37070] = 23,
    ACTIONS(830), 1,
      anon_sym_LPAREN,
    ACTIONS(840), 1,
      anon_sym_LBRACK,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(1594), 1,
      anon_sym_not,
    ACTIONS(1922), 1,
      sym_identifier,
    ACTIONS(1928), 1,
      anon_sym_type,
    ACTIONS(1930), 1,
      anon_sym_await,
    ACTIONS(2182), 1,
      anon_sym_STAR,
    ACTIONS(2186), 1,
      anon_sym_lambda,
    STATE(1271), 1,
      sym_string,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1530), 1,
      sym_list_splat_pattern,
    STATE(2188), 1,
      sym_expression,
    STATE(3306), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    STATE(2348), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(828), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1926), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2173), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1660), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [37172] = 23,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2351), 1,
      sym_expression,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(2210), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [37274] = 23,
    ACTIONS(920), 1,
      anon_sym_LPAREN,
    ACTIONS(928), 1,
      anon_sym_LBRACK,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_string_start,
    ACTIONS(1644), 1,
      anon_sym_not,
    ACTIONS(2006), 1,
      sym_identifier,
    ACTIONS(2012), 1,
      anon_sym_type,
    ACTIONS(2016), 1,
      anon_sym_await,
    ACTIONS(2200), 1,
      anon_sym_STAR,
    ACTIONS(2202), 1,
      anon_sym_lambda,
    STATE(1264), 1,
      sym_primary_expression,
    STATE(1279), 1,
      sym_string,
    STATE(1590), 1,
      sym_list_splat_pattern,
    STATE(2215), 1,
      sym_expression,
    STATE(3184), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(934), 2,
      sym_ellipsis,
      sym_float,
    STATE(2453), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(930), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(918), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2010), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2189), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1654), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [37376] = 19,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(494), 1,
      anon_sym_STAR,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(775), 1,
      anon_sym_type,
    ACTIONS(777), 1,
      anon_sym_await,
    STATE(1234), 1,
      sym_string,
    STATE(1298), 1,
      sym_primary_expression,
    STATE(1541), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 2,
      anon_sym_DOT,
      anon_sym_SLASH,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(2304), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(773), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(361), 9,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [37470] = 23,
    ACTIONS(854), 1,
      anon_sym_LPAREN,
    ACTIONS(862), 1,
      anon_sym_LBRACK,
    ACTIONS(866), 1,
      anon_sym_LBRACE,
    ACTIONS(872), 1,
      sym_string_start,
    ACTIONS(1606), 1,
      sym_identifier,
    ACTIONS(1618), 1,
      anon_sym_type,
    ACTIONS(1622), 1,
      anon_sym_not,
    ACTIONS(1628), 1,
      anon_sym_await,
    ACTIONS(2212), 1,
      anon_sym_STAR,
    ACTIONS(2214), 1,
      anon_sym_lambda,
    STATE(1220), 1,
      sym_primary_expression,
    STATE(1227), 1,
      sym_string,
    STATE(1504), 1,
      sym_list_splat_pattern,
    STATE(2212), 1,
      sym_expression,
    STATE(3456), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(868), 2,
      sym_ellipsis,
      sym_float,
    STATE(2428), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(864), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(852), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1614), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2165), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [37572] = 23,
    ACTIONS(920), 1,
      anon_sym_LPAREN,
    ACTIONS(928), 1,
      anon_sym_LBRACK,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_string_start,
    ACTIONS(1644), 1,
      anon_sym_not,
    ACTIONS(2006), 1,
      sym_identifier,
    ACTIONS(2012), 1,
      anon_sym_type,
    ACTIONS(2016), 1,
      anon_sym_await,
    ACTIONS(2200), 1,
      anon_sym_STAR,
    ACTIONS(2202), 1,
      anon_sym_lambda,
    STATE(1264), 1,
      sym_primary_expression,
    STATE(1279), 1,
      sym_string,
    STATE(1590), 1,
      sym_list_splat_pattern,
    STATE(2238), 1,
      sym_expression,
    STATE(3184), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(934), 2,
      sym_ellipsis,
      sym_float,
    STATE(2430), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(930), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(918), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2010), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2189), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1654), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [37674] = 23,
    ACTIONS(830), 1,
      anon_sym_LPAREN,
    ACTIONS(840), 1,
      anon_sym_LBRACK,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(1594), 1,
      anon_sym_not,
    ACTIONS(1922), 1,
      sym_identifier,
    ACTIONS(1928), 1,
      anon_sym_type,
    ACTIONS(1930), 1,
      anon_sym_await,
    ACTIONS(2182), 1,
      anon_sym_STAR,
    ACTIONS(2186), 1,
      anon_sym_lambda,
    STATE(1271), 1,
      sym_string,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1530), 1,
      sym_list_splat_pattern,
    STATE(2188), 1,
      sym_expression,
    STATE(3306), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    STATE(2496), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(828), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1926), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2173), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1660), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [37776] = 23,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2314), 1,
      sym_expression,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(2378), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [37878] = 24,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    ACTIONS(2272), 1,
      anon_sym_COLON,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2182), 1,
      sym_expression,
    STATE(2954), 1,
      sym_slice,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [37982] = 23,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(465), 1,
      sym_identifier,
    ACTIONS(477), 1,
      anon_sym_type,
    ACTIONS(488), 1,
      anon_sym_await,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(2248), 1,
      anon_sym_STAR,
    STATE(1200), 1,
      sym_string,
    STATE(1203), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    STATE(2214), 1,
      sym_expression,
    STATE(3045), 1,
      sym_expression_list,
    STATE(3427), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(473), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2070), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [38083] = 23,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(2210), 1,
      anon_sym_COLON,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2306), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [38184] = 23,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(2208), 1,
      anon_sym_COLON,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2306), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [38285] = 23,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2264), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    STATE(3339), 1,
      sym_expression_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [38386] = 23,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2261), 1,
      sym_expression,
    STATE(3245), 1,
      sym_expression_list,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [38487] = 23,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    ACTIONS(2380), 1,
      anon_sym_COLON,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2373), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [38588] = 23,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    ACTIONS(2382), 1,
      anon_sym_COLON,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2318), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [38689] = 23,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    ACTIONS(2384), 1,
      anon_sym_COLON,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2350), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [38790] = 23,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2250), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    STATE(3349), 1,
      sym_expression_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [38891] = 23,
    ACTIONS(876), 1,
      anon_sym_LPAREN,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1832), 1,
      anon_sym_type,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1838), 1,
      anon_sym_await,
    ACTIONS(2204), 1,
      sym_identifier,
    ACTIONS(2218), 1,
      anon_sym_STAR,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2327), 1,
      sym_expression,
    STATE(3142), 1,
      sym_with_item,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1828), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [38992] = 10,
    ACTIONS(368), 1,
      anon_sym_COMMA,
    ACTIONS(376), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2386), 1,
      anon_sym_for,
    ACTIONS(2388), 1,
      anon_sym_with,
    ACTIONS(2390), 1,
      anon_sym_def,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(378), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(400), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(363), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(361), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [39067] = 23,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    ACTIONS(2392), 1,
      anon_sym_COLON,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2350), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [39168] = 10,
    ACTIONS(368), 1,
      anon_sym_COMMA,
    ACTIONS(376), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2394), 1,
      anon_sym_for,
    ACTIONS(2396), 1,
      anon_sym_with,
    ACTIONS(2398), 1,
      anon_sym_def,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(378), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(400), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(363), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(361), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [39243] = 23,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2299), 1,
      sym_expression,
    STATE(3129), 1,
      sym_with_item,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [39344] = 10,
    ACTIONS(368), 1,
      anon_sym_COMMA,
    ACTIONS(376), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2400), 1,
      sym_identifier,
    ACTIONS(2402), 1,
      sym_string_start,
    STATE(2699), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(378), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(361), 10,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(400), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(363), 22,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_is,
  [39419] = 11,
    ACTIONS(368), 1,
      anon_sym_COMMA,
    ACTIONS(376), 1,
      anon_sym_COLON_EQ,
    ACTIONS(378), 1,
      anon_sym_EQ,
    ACTIONS(410), 1,
      anon_sym_COLON,
    ACTIONS(2400), 1,
      sym_identifier,
    ACTIONS(2402), 1,
      sym_string_start,
    STATE(2699), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(361), 10,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(400), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(363), 22,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_is,
  [39496] = 23,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    ACTIONS(2404), 1,
      anon_sym_COLON,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2350), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [39597] = 23,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2275), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    STATE(3309), 1,
      sym_expression_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [39698] = 23,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    ACTIONS(2406), 1,
      anon_sym_COLON,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2350), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [39799] = 22,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2351), 1,
      sym_expression,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [39897] = 22,
    ACTIONS(854), 1,
      anon_sym_LPAREN,
    ACTIONS(862), 1,
      anon_sym_LBRACK,
    ACTIONS(866), 1,
      anon_sym_LBRACE,
    ACTIONS(872), 1,
      sym_string_start,
    ACTIONS(1606), 1,
      sym_identifier,
    ACTIONS(1618), 1,
      anon_sym_type,
    ACTIONS(1622), 1,
      anon_sym_not,
    ACTIONS(1624), 1,
      anon_sym_lambda,
    ACTIONS(1628), 1,
      anon_sym_await,
    ACTIONS(2212), 1,
      anon_sym_STAR,
    STATE(1220), 1,
      sym_primary_expression,
    STATE(1227), 1,
      sym_string,
    STATE(1504), 1,
      sym_list_splat_pattern,
    STATE(2160), 1,
      sym_expression,
    STATE(3456), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(868), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(864), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(852), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1614), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2165), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [39995] = 22,
    ACTIONS(830), 1,
      anon_sym_LPAREN,
    ACTIONS(840), 1,
      anon_sym_LBRACK,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(1594), 1,
      anon_sym_not,
    ACTIONS(1596), 1,
      anon_sym_lambda,
    ACTIONS(1922), 1,
      sym_identifier,
    ACTIONS(1928), 1,
      anon_sym_type,
    ACTIONS(1930), 1,
      anon_sym_await,
    ACTIONS(2182), 1,
      anon_sym_STAR,
    STATE(1271), 1,
      sym_string,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1530), 1,
      sym_list_splat_pattern,
    STATE(2290), 1,
      sym_expression,
    STATE(3306), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(828), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1926), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2173), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1660), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [40093] = 22,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(465), 1,
      sym_identifier,
    ACTIONS(477), 1,
      anon_sym_type,
    ACTIONS(488), 1,
      anon_sym_await,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(2248), 1,
      anon_sym_STAR,
    STATE(1200), 1,
      sym_string,
    STATE(1203), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    STATE(2208), 1,
      sym_expression,
    STATE(3427), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(473), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2070), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [40191] = 22,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2306), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [40289] = 22,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2142), 1,
      sym_expression,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [40387] = 22,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2141), 1,
      sym_expression,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [40485] = 22,
    ACTIONS(876), 1,
      anon_sym_LPAREN,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1832), 1,
      anon_sym_type,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1838), 1,
      anon_sym_await,
    ACTIONS(2204), 1,
      sym_identifier,
    ACTIONS(2218), 1,
      anon_sym_STAR,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2360), 1,
      sym_expression,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1828), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [40583] = 22,
    ACTIONS(830), 1,
      anon_sym_LPAREN,
    ACTIONS(840), 1,
      anon_sym_LBRACK,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(1594), 1,
      anon_sym_not,
    ACTIONS(1596), 1,
      anon_sym_lambda,
    ACTIONS(1922), 1,
      sym_identifier,
    ACTIONS(1928), 1,
      anon_sym_type,
    ACTIONS(1930), 1,
      anon_sym_await,
    ACTIONS(2182), 1,
      anon_sym_STAR,
    STATE(1271), 1,
      sym_string,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1530), 1,
      sym_list_splat_pattern,
    STATE(2192), 1,
      sym_expression,
    STATE(3306), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(828), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1926), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2173), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1660), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [40681] = 22,
    ACTIONS(876), 1,
      anon_sym_LPAREN,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1832), 1,
      anon_sym_type,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1838), 1,
      anon_sym_await,
    ACTIONS(2204), 1,
      sym_identifier,
    ACTIONS(2218), 1,
      anon_sym_STAR,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2361), 1,
      sym_expression,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1828), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [40779] = 22,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(1994), 1,
      anon_sym_not,
    ACTIONS(1996), 1,
      anon_sym_lambda,
    ACTIONS(2408), 1,
      sym_identifier,
    ACTIONS(2410), 1,
      anon_sym_STAR,
    ACTIONS(2414), 1,
      anon_sym_type,
    ACTIONS(2416), 1,
      anon_sym_await,
    STATE(1488), 1,
      sym_string,
    STATE(1491), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    STATE(2355), 1,
      sym_expression,
    STATE(3239), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(942), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2412), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2383), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [40877] = 22,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2505), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [40975] = 22,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(465), 1,
      sym_identifier,
    ACTIONS(477), 1,
      anon_sym_type,
    ACTIONS(488), 1,
      anon_sym_await,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(2248), 1,
      anon_sym_STAR,
    STATE(1200), 1,
      sym_string,
    STATE(1203), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    STATE(2180), 1,
      sym_expression,
    STATE(3427), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(473), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2070), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [41073] = 22,
    ACTIONS(876), 1,
      anon_sym_LPAREN,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1832), 1,
      anon_sym_type,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1838), 1,
      anon_sym_await,
    ACTIONS(2204), 1,
      sym_identifier,
    ACTIONS(2218), 1,
      anon_sym_STAR,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2116), 1,
      sym_expression,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1828), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [41171] = 22,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2440), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [41269] = 22,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2402), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [41367] = 22,
    ACTIONS(781), 1,
      anon_sym_LPAREN,
    ACTIONS(789), 1,
      anon_sym_LBRACK,
    ACTIONS(793), 1,
      anon_sym_LBRACE,
    ACTIONS(799), 1,
      sym_string_start,
    ACTIONS(1792), 1,
      anon_sym_STAR,
    ACTIONS(1800), 1,
      anon_sym_not,
    ACTIONS(1802), 1,
      anon_sym_lambda,
    ACTIONS(1956), 1,
      sym_identifier,
    ACTIONS(1964), 1,
      anon_sym_type,
    ACTIONS(1966), 1,
      anon_sym_await,
    STATE(1221), 1,
      sym_primary_expression,
    STATE(1223), 1,
      sym_string,
    STATE(1459), 1,
      sym_list_splat_pattern,
    STATE(2166), 1,
      sym_expression,
    STATE(3201), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(795), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(791), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(779), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1962), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2139), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1449), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [41465] = 22,
    ACTIONS(920), 1,
      anon_sym_LPAREN,
    ACTIONS(928), 1,
      anon_sym_LBRACK,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_string_start,
    ACTIONS(1644), 1,
      anon_sym_not,
    ACTIONS(1646), 1,
      anon_sym_lambda,
    ACTIONS(2006), 1,
      sym_identifier,
    ACTIONS(2012), 1,
      anon_sym_type,
    ACTIONS(2016), 1,
      anon_sym_await,
    ACTIONS(2200), 1,
      anon_sym_STAR,
    STATE(1264), 1,
      sym_primary_expression,
    STATE(1279), 1,
      sym_string,
    STATE(1590), 1,
      sym_list_splat_pattern,
    STATE(2176), 1,
      sym_expression,
    STATE(3184), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(934), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(930), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(918), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2010), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2189), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1654), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [41563] = 22,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2350), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [41661] = 22,
    ACTIONS(830), 1,
      anon_sym_LPAREN,
    ACTIONS(840), 1,
      anon_sym_LBRACK,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(1594), 1,
      anon_sym_not,
    ACTIONS(1596), 1,
      anon_sym_lambda,
    ACTIONS(1922), 1,
      sym_identifier,
    ACTIONS(1928), 1,
      anon_sym_type,
    ACTIONS(1930), 1,
      anon_sym_await,
    ACTIONS(2182), 1,
      anon_sym_STAR,
    STATE(1271), 1,
      sym_string,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1530), 1,
      sym_list_splat_pattern,
    STATE(2222), 1,
      sym_expression,
    STATE(3306), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(828), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1926), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2173), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1660), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [41759] = 22,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2485), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [41857] = 22,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2422), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [41955] = 22,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(465), 1,
      sym_identifier,
    ACTIONS(477), 1,
      anon_sym_type,
    ACTIONS(488), 1,
      anon_sym_await,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(2248), 1,
      anon_sym_STAR,
    STATE(1200), 1,
      sym_string,
    STATE(1203), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    STATE(2322), 1,
      sym_expression,
    STATE(3427), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(473), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2070), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [42053] = 22,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(465), 1,
      sym_identifier,
    ACTIONS(477), 1,
      anon_sym_type,
    ACTIONS(488), 1,
      anon_sym_await,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(2248), 1,
      anon_sym_STAR,
    STATE(1200), 1,
      sym_string,
    STATE(1203), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    STATE(2321), 1,
      sym_expression,
    STATE(3427), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(473), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2070), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [42151] = 23,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    ACTIONS(2418), 1,
      sym_identifier,
    ACTIONS(2422), 1,
      anon_sym_type,
    ACTIONS(2424), 1,
      anon_sym_await,
    STATE(1337), 1,
      sym_string,
    STATE(1444), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2390), 1,
      sym_expression,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    STATE(1531), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2420), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [42251] = 23,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(2248), 1,
      anon_sym_STAR,
    ACTIONS(2426), 1,
      sym_identifier,
    ACTIONS(2430), 1,
      anon_sym_type,
    ACTIONS(2432), 1,
      anon_sym_await,
    STATE(1200), 1,
      sym_string,
    STATE(1203), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    STATE(2367), 1,
      sym_expression,
    STATE(3427), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    STATE(1789), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2428), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2070), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1312), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [42351] = 22,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2491), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [42449] = 22,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2118), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [42547] = 22,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(465), 1,
      sym_identifier,
    ACTIONS(477), 1,
      anon_sym_type,
    ACTIONS(488), 1,
      anon_sym_await,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(2248), 1,
      anon_sym_STAR,
    STATE(1200), 1,
      sym_string,
    STATE(1203), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    STATE(2056), 1,
      sym_expression,
    STATE(3427), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(473), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2070), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [42645] = 22,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(1994), 1,
      anon_sym_not,
    ACTIONS(1996), 1,
      anon_sym_lambda,
    ACTIONS(2408), 1,
      sym_identifier,
    ACTIONS(2410), 1,
      anon_sym_STAR,
    ACTIONS(2414), 1,
      anon_sym_type,
    ACTIONS(2416), 1,
      anon_sym_await,
    STATE(1488), 1,
      sym_string,
    STATE(1491), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    STATE(2397), 1,
      sym_expression,
    STATE(3239), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(942), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2412), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2383), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [42743] = 22,
    ACTIONS(781), 1,
      anon_sym_LPAREN,
    ACTIONS(789), 1,
      anon_sym_LBRACK,
    ACTIONS(793), 1,
      anon_sym_LBRACE,
    ACTIONS(799), 1,
      sym_string_start,
    ACTIONS(1792), 1,
      anon_sym_STAR,
    ACTIONS(1800), 1,
      anon_sym_not,
    ACTIONS(1802), 1,
      anon_sym_lambda,
    ACTIONS(1956), 1,
      sym_identifier,
    ACTIONS(1964), 1,
      anon_sym_type,
    ACTIONS(1966), 1,
      anon_sym_await,
    STATE(1221), 1,
      sym_primary_expression,
    STATE(1223), 1,
      sym_string,
    STATE(1459), 1,
      sym_list_splat_pattern,
    STATE(2146), 1,
      sym_expression,
    STATE(3201), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(795), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(791), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(779), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1962), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2139), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1449), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [42841] = 22,
    ACTIONS(781), 1,
      anon_sym_LPAREN,
    ACTIONS(789), 1,
      anon_sym_LBRACK,
    ACTIONS(793), 1,
      anon_sym_LBRACE,
    ACTIONS(799), 1,
      sym_string_start,
    ACTIONS(1792), 1,
      anon_sym_STAR,
    ACTIONS(1800), 1,
      anon_sym_not,
    ACTIONS(1802), 1,
      anon_sym_lambda,
    ACTIONS(1956), 1,
      sym_identifier,
    ACTIONS(1964), 1,
      anon_sym_type,
    ACTIONS(1966), 1,
      anon_sym_await,
    STATE(1221), 1,
      sym_primary_expression,
    STATE(1223), 1,
      sym_string,
    STATE(1459), 1,
      sym_list_splat_pattern,
    STATE(2145), 1,
      sym_expression,
    STATE(3201), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(795), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(791), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(779), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1962), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2139), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1449), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [42939] = 22,
    ACTIONS(781), 1,
      anon_sym_LPAREN,
    ACTIONS(789), 1,
      anon_sym_LBRACK,
    ACTIONS(793), 1,
      anon_sym_LBRACE,
    ACTIONS(799), 1,
      sym_string_start,
    ACTIONS(1792), 1,
      anon_sym_STAR,
    ACTIONS(1800), 1,
      anon_sym_not,
    ACTIONS(1802), 1,
      anon_sym_lambda,
    ACTIONS(1956), 1,
      sym_identifier,
    ACTIONS(1964), 1,
      anon_sym_type,
    ACTIONS(1966), 1,
      anon_sym_await,
    STATE(1221), 1,
      sym_primary_expression,
    STATE(1223), 1,
      sym_string,
    STATE(1459), 1,
      sym_list_splat_pattern,
    STATE(2144), 1,
      sym_expression,
    STATE(3201), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(795), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(791), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(779), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1962), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2139), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1449), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [43037] = 22,
    ACTIONS(781), 1,
      anon_sym_LPAREN,
    ACTIONS(789), 1,
      anon_sym_LBRACK,
    ACTIONS(793), 1,
      anon_sym_LBRACE,
    ACTIONS(799), 1,
      sym_string_start,
    ACTIONS(1792), 1,
      anon_sym_STAR,
    ACTIONS(1800), 1,
      anon_sym_not,
    ACTIONS(1802), 1,
      anon_sym_lambda,
    ACTIONS(1956), 1,
      sym_identifier,
    ACTIONS(1964), 1,
      anon_sym_type,
    ACTIONS(1966), 1,
      anon_sym_await,
    STATE(1221), 1,
      sym_primary_expression,
    STATE(1223), 1,
      sym_string,
    STATE(1459), 1,
      sym_list_splat_pattern,
    STATE(2143), 1,
      sym_expression,
    STATE(3201), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(795), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(791), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(779), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1962), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2139), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1449), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [43135] = 22,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2518), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [43233] = 22,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(1994), 1,
      anon_sym_not,
    ACTIONS(1996), 1,
      anon_sym_lambda,
    ACTIONS(2408), 1,
      sym_identifier,
    ACTIONS(2410), 1,
      anon_sym_STAR,
    ACTIONS(2414), 1,
      anon_sym_type,
    ACTIONS(2416), 1,
      anon_sym_await,
    STATE(1488), 1,
      sym_string,
    STATE(1491), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    STATE(2398), 1,
      sym_expression,
    STATE(3239), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(942), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2412), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2383), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [43331] = 23,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    ACTIONS(2424), 1,
      anon_sym_await,
    ACTIONS(2434), 1,
      sym_identifier,
    ACTIONS(2438), 1,
      anon_sym_type,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2390), 1,
      sym_expression,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    STATE(1779), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2436), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [43431] = 22,
    ACTIONS(781), 1,
      anon_sym_LPAREN,
    ACTIONS(789), 1,
      anon_sym_LBRACK,
    ACTIONS(793), 1,
      anon_sym_LBRACE,
    ACTIONS(799), 1,
      sym_string_start,
    ACTIONS(1792), 1,
      anon_sym_STAR,
    ACTIONS(1800), 1,
      anon_sym_not,
    ACTIONS(1802), 1,
      anon_sym_lambda,
    ACTIONS(1956), 1,
      sym_identifier,
    ACTIONS(1964), 1,
      anon_sym_type,
    ACTIONS(1966), 1,
      anon_sym_await,
    STATE(1221), 1,
      sym_primary_expression,
    STATE(1223), 1,
      sym_string,
    STATE(1459), 1,
      sym_list_splat_pattern,
    STATE(2140), 1,
      sym_expression,
    STATE(3201), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(795), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(791), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(779), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1962), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2139), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1449), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [43529] = 22,
    ACTIONS(876), 1,
      anon_sym_LPAREN,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1832), 1,
      anon_sym_type,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1838), 1,
      anon_sym_await,
    ACTIONS(2204), 1,
      sym_identifier,
    ACTIONS(2218), 1,
      anon_sym_STAR,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2114), 1,
      sym_expression,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1828), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [43627] = 23,
    ACTIONS(781), 1,
      anon_sym_LPAREN,
    ACTIONS(789), 1,
      anon_sym_LBRACK,
    ACTIONS(793), 1,
      anon_sym_LBRACE,
    ACTIONS(799), 1,
      sym_string_start,
    ACTIONS(1792), 1,
      anon_sym_STAR,
    ACTIONS(1800), 1,
      anon_sym_not,
    ACTIONS(1802), 1,
      anon_sym_lambda,
    ACTIONS(2440), 1,
      sym_identifier,
    ACTIONS(2444), 1,
      anon_sym_type,
    ACTIONS(2446), 1,
      anon_sym_await,
    STATE(1223), 1,
      sym_string,
    STATE(1451), 1,
      sym_primary_expression,
    STATE(1459), 1,
      sym_list_splat_pattern,
    STATE(2323), 1,
      sym_expression,
    STATE(3201), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(795), 2,
      sym_ellipsis,
      sym_float,
    STATE(1437), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(791), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(779), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2442), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2139), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1449), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [43727] = 22,
    ACTIONS(920), 1,
      anon_sym_LPAREN,
    ACTIONS(928), 1,
      anon_sym_LBRACK,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_string_start,
    ACTIONS(1644), 1,
      anon_sym_not,
    ACTIONS(1646), 1,
      anon_sym_lambda,
    ACTIONS(2006), 1,
      sym_identifier,
    ACTIONS(2012), 1,
      anon_sym_type,
    ACTIONS(2016), 1,
      anon_sym_await,
    ACTIONS(2200), 1,
      anon_sym_STAR,
    STATE(1264), 1,
      sym_primary_expression,
    STATE(1279), 1,
      sym_string,
    STATE(1590), 1,
      sym_list_splat_pattern,
    STATE(2288), 1,
      sym_expression,
    STATE(3184), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(934), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(930), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(918), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2010), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2189), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1654), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [43825] = 22,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2112), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [43923] = 22,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(465), 1,
      sym_identifier,
    ACTIONS(477), 1,
      anon_sym_type,
    ACTIONS(488), 1,
      anon_sym_await,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(2248), 1,
      anon_sym_STAR,
    STATE(1200), 1,
      sym_string,
    STATE(1203), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    STATE(2201), 1,
      sym_expression,
    STATE(3427), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(473), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2070), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [44021] = 22,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2115), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [44119] = 23,
    ACTIONS(876), 1,
      anon_sym_LPAREN,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(2218), 1,
      anon_sym_STAR,
    ACTIONS(2448), 1,
      sym_identifier,
    ACTIONS(2452), 1,
      anon_sym_type,
    ACTIONS(2454), 1,
      anon_sym_await,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2353), 1,
      sym_expression,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    STATE(1772), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2450), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [44219] = 22,
    ACTIONS(781), 1,
      anon_sym_LPAREN,
    ACTIONS(789), 1,
      anon_sym_LBRACK,
    ACTIONS(793), 1,
      anon_sym_LBRACE,
    ACTIONS(799), 1,
      sym_string_start,
    ACTIONS(1792), 1,
      anon_sym_STAR,
    ACTIONS(1800), 1,
      anon_sym_not,
    ACTIONS(1802), 1,
      anon_sym_lambda,
    ACTIONS(1956), 1,
      sym_identifier,
    ACTIONS(1964), 1,
      anon_sym_type,
    ACTIONS(1966), 1,
      anon_sym_await,
    STATE(1221), 1,
      sym_primary_expression,
    STATE(1223), 1,
      sym_string,
    STATE(1459), 1,
      sym_list_splat_pattern,
    STATE(2163), 1,
      sym_expression,
    STATE(3201), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(795), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(791), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(779), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1962), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2139), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1449), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [44317] = 22,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2523), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [44415] = 22,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(1994), 1,
      anon_sym_not,
    ACTIONS(1996), 1,
      anon_sym_lambda,
    ACTIONS(2408), 1,
      sym_identifier,
    ACTIONS(2410), 1,
      anon_sym_STAR,
    ACTIONS(2414), 1,
      anon_sym_type,
    ACTIONS(2416), 1,
      anon_sym_await,
    STATE(1488), 1,
      sym_string,
    STATE(1491), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    STATE(2399), 1,
      sym_expression,
    STATE(3239), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(942), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2412), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2383), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [44513] = 22,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(465), 1,
      sym_identifier,
    ACTIONS(477), 1,
      anon_sym_type,
    ACTIONS(488), 1,
      anon_sym_await,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(2248), 1,
      anon_sym_STAR,
    STATE(1200), 1,
      sym_string,
    STATE(1203), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    STATE(2477), 1,
      sym_expression,
    STATE(3427), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(473), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2070), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [44611] = 22,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(465), 1,
      sym_identifier,
    ACTIONS(477), 1,
      anon_sym_type,
    ACTIONS(488), 1,
      anon_sym_await,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(2248), 1,
      anon_sym_STAR,
    STATE(1200), 1,
      sym_string,
    STATE(1203), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    STATE(2388), 1,
      sym_expression,
    STATE(3427), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(473), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2070), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [44709] = 22,
    ACTIONS(854), 1,
      anon_sym_LPAREN,
    ACTIONS(862), 1,
      anon_sym_LBRACK,
    ACTIONS(866), 1,
      anon_sym_LBRACE,
    ACTIONS(872), 1,
      sym_string_start,
    ACTIONS(1606), 1,
      sym_identifier,
    ACTIONS(1618), 1,
      anon_sym_type,
    ACTIONS(1622), 1,
      anon_sym_not,
    ACTIONS(1624), 1,
      anon_sym_lambda,
    ACTIONS(1628), 1,
      anon_sym_await,
    ACTIONS(2212), 1,
      anon_sym_STAR,
    STATE(1220), 1,
      sym_primary_expression,
    STATE(1227), 1,
      sym_string,
    STATE(1504), 1,
      sym_list_splat_pattern,
    STATE(2136), 1,
      sym_expression,
    STATE(3456), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(868), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(864), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(852), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1614), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2165), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [44807] = 22,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(465), 1,
      sym_identifier,
    ACTIONS(477), 1,
      anon_sym_type,
    ACTIONS(488), 1,
      anon_sym_await,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(2248), 1,
      anon_sym_STAR,
    STATE(1200), 1,
      sym_string,
    STATE(1203), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    STATE(2066), 1,
      sym_expression,
    STATE(3427), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(473), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2070), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [44905] = 22,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(1994), 1,
      anon_sym_not,
    ACTIONS(1996), 1,
      anon_sym_lambda,
    ACTIONS(2408), 1,
      sym_identifier,
    ACTIONS(2410), 1,
      anon_sym_STAR,
    ACTIONS(2414), 1,
      anon_sym_type,
    ACTIONS(2416), 1,
      anon_sym_await,
    STATE(1488), 1,
      sym_string,
    STATE(1491), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    STATE(2400), 1,
      sym_expression,
    STATE(3239), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(942), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2412), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2383), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [45003] = 22,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(1994), 1,
      anon_sym_not,
    ACTIONS(1996), 1,
      anon_sym_lambda,
    ACTIONS(2408), 1,
      sym_identifier,
    ACTIONS(2410), 1,
      anon_sym_STAR,
    ACTIONS(2414), 1,
      anon_sym_type,
    ACTIONS(2416), 1,
      anon_sym_await,
    STATE(1488), 1,
      sym_string,
    STATE(1491), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    STATE(2401), 1,
      sym_expression,
    STATE(3239), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(942), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2412), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2383), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [45101] = 22,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2157), 1,
      sym_expression,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [45199] = 22,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(465), 1,
      sym_identifier,
    ACTIONS(477), 1,
      anon_sym_type,
    ACTIONS(488), 1,
      anon_sym_await,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(2248), 1,
      anon_sym_STAR,
    STATE(1200), 1,
      sym_string,
    STATE(1203), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    STATE(2067), 1,
      sym_expression,
    STATE(3427), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(473), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2070), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [45297] = 22,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(465), 1,
      sym_identifier,
    ACTIONS(477), 1,
      anon_sym_type,
    ACTIONS(488), 1,
      anon_sym_await,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(2248), 1,
      anon_sym_STAR,
    STATE(1200), 1,
      sym_string,
    STATE(1203), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    STATE(2061), 1,
      sym_expression,
    STATE(3427), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(473), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2070), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [45395] = 22,
    ACTIONS(876), 1,
      anon_sym_LPAREN,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1832), 1,
      anon_sym_type,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1838), 1,
      anon_sym_await,
    ACTIONS(2204), 1,
      sym_identifier,
    ACTIONS(2218), 1,
      anon_sym_STAR,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2304), 1,
      sym_expression,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1828), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [45493] = 22,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2529), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [45591] = 22,
    ACTIONS(876), 1,
      anon_sym_LPAREN,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1832), 1,
      anon_sym_type,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1838), 1,
      anon_sym_await,
    ACTIONS(2204), 1,
      sym_identifier,
    ACTIONS(2218), 1,
      anon_sym_STAR,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2111), 1,
      sym_expression,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1828), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [45689] = 22,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(465), 1,
      sym_identifier,
    ACTIONS(477), 1,
      anon_sym_type,
    ACTIONS(488), 1,
      anon_sym_await,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(2248), 1,
      anon_sym_STAR,
    STATE(1200), 1,
      sym_string,
    STATE(1203), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    STATE(2062), 1,
      sym_expression,
    STATE(3427), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(473), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2070), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [45787] = 22,
    ACTIONS(854), 1,
      anon_sym_LPAREN,
    ACTIONS(862), 1,
      anon_sym_LBRACK,
    ACTIONS(866), 1,
      anon_sym_LBRACE,
    ACTIONS(872), 1,
      sym_string_start,
    ACTIONS(1606), 1,
      sym_identifier,
    ACTIONS(1618), 1,
      anon_sym_type,
    ACTIONS(1622), 1,
      anon_sym_not,
    ACTIONS(1624), 1,
      anon_sym_lambda,
    ACTIONS(1628), 1,
      anon_sym_await,
    ACTIONS(2212), 1,
      anon_sym_STAR,
    STATE(1220), 1,
      sym_primary_expression,
    STATE(1227), 1,
      sym_string,
    STATE(1504), 1,
      sym_list_splat_pattern,
    STATE(2131), 1,
      sym_expression,
    STATE(3456), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(868), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(864), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(852), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1614), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2165), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [45885] = 23,
    ACTIONS(781), 1,
      anon_sym_LPAREN,
    ACTIONS(789), 1,
      anon_sym_LBRACK,
    ACTIONS(793), 1,
      anon_sym_LBRACE,
    ACTIONS(799), 1,
      sym_string_start,
    ACTIONS(1792), 1,
      anon_sym_STAR,
    ACTIONS(1800), 1,
      anon_sym_not,
    ACTIONS(1802), 1,
      anon_sym_lambda,
    ACTIONS(2446), 1,
      anon_sym_await,
    ACTIONS(2456), 1,
      sym_identifier,
    ACTIONS(2460), 1,
      anon_sym_type,
    STATE(1221), 1,
      sym_primary_expression,
    STATE(1223), 1,
      sym_string,
    STATE(1459), 1,
      sym_list_splat_pattern,
    STATE(2323), 1,
      sym_expression,
    STATE(3201), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(795), 2,
      sym_ellipsis,
      sym_float,
    STATE(1784), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(791), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(779), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2458), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2139), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1449), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [45985] = 22,
    ACTIONS(876), 1,
      anon_sym_LPAREN,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1832), 1,
      anon_sym_type,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1838), 1,
      anon_sym_await,
    ACTIONS(2204), 1,
      sym_identifier,
    ACTIONS(2218), 1,
      anon_sym_STAR,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2109), 1,
      sym_expression,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1828), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [46083] = 22,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2509), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [46181] = 22,
    ACTIONS(876), 1,
      anon_sym_LPAREN,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1832), 1,
      anon_sym_type,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1838), 1,
      anon_sym_await,
    ACTIONS(2204), 1,
      sym_identifier,
    ACTIONS(2218), 1,
      anon_sym_STAR,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2315), 1,
      sym_expression,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1828), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [46279] = 22,
    ACTIONS(781), 1,
      anon_sym_LPAREN,
    ACTIONS(789), 1,
      anon_sym_LBRACK,
    ACTIONS(793), 1,
      anon_sym_LBRACE,
    ACTIONS(799), 1,
      sym_string_start,
    ACTIONS(1792), 1,
      anon_sym_STAR,
    ACTIONS(1800), 1,
      anon_sym_not,
    ACTIONS(1802), 1,
      anon_sym_lambda,
    ACTIONS(1956), 1,
      sym_identifier,
    ACTIONS(1964), 1,
      anon_sym_type,
    ACTIONS(1966), 1,
      anon_sym_await,
    STATE(1221), 1,
      sym_primary_expression,
    STATE(1223), 1,
      sym_string,
    STATE(1459), 1,
      sym_list_splat_pattern,
    STATE(2301), 1,
      sym_expression,
    STATE(3201), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(795), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(791), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(779), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1962), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2139), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1449), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [46377] = 22,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2135), 1,
      sym_expression,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [46475] = 22,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2155), 1,
      sym_expression,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [46573] = 22,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2461), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [46671] = 22,
    ACTIONS(876), 1,
      anon_sym_LPAREN,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1832), 1,
      anon_sym_type,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1838), 1,
      anon_sym_await,
    ACTIONS(2204), 1,
      sym_identifier,
    ACTIONS(2218), 1,
      anon_sym_STAR,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2108), 1,
      sym_expression,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1828), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [46769] = 22,
    ACTIONS(830), 1,
      anon_sym_LPAREN,
    ACTIONS(840), 1,
      anon_sym_LBRACK,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(1594), 1,
      anon_sym_not,
    ACTIONS(1596), 1,
      anon_sym_lambda,
    ACTIONS(1922), 1,
      sym_identifier,
    ACTIONS(1928), 1,
      anon_sym_type,
    ACTIONS(1930), 1,
      anon_sym_await,
    ACTIONS(2182), 1,
      anon_sym_STAR,
    STATE(1271), 1,
      sym_string,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1530), 1,
      sym_list_splat_pattern,
    STATE(2213), 1,
      sym_expression,
    STATE(3306), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(828), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1926), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2173), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1660), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [46867] = 22,
    ACTIONS(920), 1,
      anon_sym_LPAREN,
    ACTIONS(928), 1,
      anon_sym_LBRACK,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_string_start,
    ACTIONS(1644), 1,
      anon_sym_not,
    ACTIONS(1646), 1,
      anon_sym_lambda,
    ACTIONS(2006), 1,
      sym_identifier,
    ACTIONS(2012), 1,
      anon_sym_type,
    ACTIONS(2016), 1,
      anon_sym_await,
    ACTIONS(2200), 1,
      anon_sym_STAR,
    STATE(1264), 1,
      sym_primary_expression,
    STATE(1279), 1,
      sym_string,
    STATE(1590), 1,
      sym_list_splat_pattern,
    STATE(2221), 1,
      sym_expression,
    STATE(3184), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(934), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(930), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(918), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2010), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2189), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1654), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [46965] = 22,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(465), 1,
      sym_identifier,
    ACTIONS(477), 1,
      anon_sym_type,
    ACTIONS(488), 1,
      anon_sym_await,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(2248), 1,
      anon_sym_STAR,
    STATE(1200), 1,
      sym_string,
    STATE(1203), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    STATE(2055), 1,
      sym_expression,
    STATE(3427), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(473), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2070), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [47063] = 22,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2413), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [47161] = 22,
    ACTIONS(876), 1,
      anon_sym_LPAREN,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1832), 1,
      anon_sym_type,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1838), 1,
      anon_sym_await,
    ACTIONS(2204), 1,
      sym_identifier,
    ACTIONS(2218), 1,
      anon_sym_STAR,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2377), 1,
      sym_expression,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1828), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [47259] = 22,
    ACTIONS(781), 1,
      anon_sym_LPAREN,
    ACTIONS(789), 1,
      anon_sym_LBRACK,
    ACTIONS(793), 1,
      anon_sym_LBRACE,
    ACTIONS(799), 1,
      sym_string_start,
    ACTIONS(1792), 1,
      anon_sym_STAR,
    ACTIONS(1800), 1,
      anon_sym_not,
    ACTIONS(1802), 1,
      anon_sym_lambda,
    ACTIONS(1956), 1,
      sym_identifier,
    ACTIONS(1964), 1,
      anon_sym_type,
    ACTIONS(1966), 1,
      anon_sym_await,
    STATE(1221), 1,
      sym_primary_expression,
    STATE(1223), 1,
      sym_string,
    STATE(1459), 1,
      sym_list_splat_pattern,
    STATE(2129), 1,
      sym_expression,
    STATE(3201), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(795), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(791), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(779), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1962), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2139), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1449), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [47357] = 22,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(465), 1,
      sym_identifier,
    ACTIONS(477), 1,
      anon_sym_type,
    ACTIONS(488), 1,
      anon_sym_await,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(2248), 1,
      anon_sym_STAR,
    STATE(1200), 1,
      sym_string,
    STATE(1203), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    STATE(2294), 1,
      sym_expression,
    STATE(3427), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(473), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2070), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [47455] = 22,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2475), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [47553] = 22,
    ACTIONS(781), 1,
      anon_sym_LPAREN,
    ACTIONS(789), 1,
      anon_sym_LBRACK,
    ACTIONS(793), 1,
      anon_sym_LBRACE,
    ACTIONS(799), 1,
      sym_string_start,
    ACTIONS(1792), 1,
      anon_sym_STAR,
    ACTIONS(1800), 1,
      anon_sym_not,
    ACTIONS(1802), 1,
      anon_sym_lambda,
    ACTIONS(1956), 1,
      sym_identifier,
    ACTIONS(1964), 1,
      anon_sym_type,
    ACTIONS(1966), 1,
      anon_sym_await,
    STATE(1221), 1,
      sym_primary_expression,
    STATE(1223), 1,
      sym_string,
    STATE(1459), 1,
      sym_list_splat_pattern,
    STATE(2154), 1,
      sym_expression,
    STATE(3201), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(795), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(791), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(779), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1962), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2139), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1449), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [47651] = 22,
    ACTIONS(854), 1,
      anon_sym_LPAREN,
    ACTIONS(862), 1,
      anon_sym_LBRACK,
    ACTIONS(866), 1,
      anon_sym_LBRACE,
    ACTIONS(872), 1,
      sym_string_start,
    ACTIONS(1606), 1,
      sym_identifier,
    ACTIONS(1618), 1,
      anon_sym_type,
    ACTIONS(1622), 1,
      anon_sym_not,
    ACTIONS(1624), 1,
      anon_sym_lambda,
    ACTIONS(1628), 1,
      anon_sym_await,
    ACTIONS(2212), 1,
      anon_sym_STAR,
    STATE(1220), 1,
      sym_primary_expression,
    STATE(1227), 1,
      sym_string,
    STATE(1504), 1,
      sym_list_splat_pattern,
    STATE(2134), 1,
      sym_expression,
    STATE(3456), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(868), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(864), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(852), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1614), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2165), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [47749] = 22,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(1994), 1,
      anon_sym_not,
    ACTIONS(1996), 1,
      anon_sym_lambda,
    ACTIONS(2408), 1,
      sym_identifier,
    ACTIONS(2410), 1,
      anon_sym_STAR,
    ACTIONS(2414), 1,
      anon_sym_type,
    ACTIONS(2416), 1,
      anon_sym_await,
    STATE(1488), 1,
      sym_string,
    STATE(1491), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    STATE(2404), 1,
      sym_expression,
    STATE(3239), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(942), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2412), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2383), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [47847] = 22,
    ACTIONS(854), 1,
      anon_sym_LPAREN,
    ACTIONS(862), 1,
      anon_sym_LBRACK,
    ACTIONS(866), 1,
      anon_sym_LBRACE,
    ACTIONS(872), 1,
      sym_string_start,
    ACTIONS(1606), 1,
      sym_identifier,
    ACTIONS(1618), 1,
      anon_sym_type,
    ACTIONS(1622), 1,
      anon_sym_not,
    ACTIONS(1624), 1,
      anon_sym_lambda,
    ACTIONS(1628), 1,
      anon_sym_await,
    ACTIONS(2212), 1,
      anon_sym_STAR,
    STATE(1220), 1,
      sym_primary_expression,
    STATE(1227), 1,
      sym_string,
    STATE(1504), 1,
      sym_list_splat_pattern,
    STATE(2251), 1,
      sym_expression,
    STATE(3456), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(868), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(864), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(852), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1614), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2165), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [47945] = 22,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2527), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [48043] = 22,
    ACTIONS(920), 1,
      anon_sym_LPAREN,
    ACTIONS(928), 1,
      anon_sym_LBRACK,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_string_start,
    ACTIONS(1644), 1,
      anon_sym_not,
    ACTIONS(1646), 1,
      anon_sym_lambda,
    ACTIONS(2006), 1,
      sym_identifier,
    ACTIONS(2012), 1,
      anon_sym_type,
    ACTIONS(2016), 1,
      anon_sym_await,
    ACTIONS(2200), 1,
      anon_sym_STAR,
    STATE(1264), 1,
      sym_primary_expression,
    STATE(1279), 1,
      sym_string,
    STATE(1590), 1,
      sym_list_splat_pattern,
    STATE(2203), 1,
      sym_expression,
    STATE(3184), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(934), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(930), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(918), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2010), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2189), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1654), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [48141] = 22,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(465), 1,
      sym_identifier,
    ACTIONS(477), 1,
      anon_sym_type,
    ACTIONS(488), 1,
      anon_sym_await,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(2248), 1,
      anon_sym_STAR,
    STATE(1200), 1,
      sym_string,
    STATE(1203), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    STATE(2069), 1,
      sym_expression,
    STATE(3427), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(473), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2070), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [48239] = 22,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(465), 1,
      sym_identifier,
    ACTIONS(477), 1,
      anon_sym_type,
    ACTIONS(488), 1,
      anon_sym_await,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(2248), 1,
      anon_sym_STAR,
    STATE(1200), 1,
      sym_string,
    STATE(1203), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    STATE(2252), 1,
      sym_expression,
    STATE(3427), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(473), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2070), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [48337] = 22,
    ACTIONS(876), 1,
      anon_sym_LPAREN,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1832), 1,
      anon_sym_type,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1838), 1,
      anon_sym_await,
    ACTIONS(2204), 1,
      sym_identifier,
    ACTIONS(2218), 1,
      anon_sym_STAR,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2107), 1,
      sym_expression,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1828), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [48435] = 22,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2407), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [48533] = 22,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2493), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [48631] = 22,
    ACTIONS(876), 1,
      anon_sym_LPAREN,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1832), 1,
      anon_sym_type,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1838), 1,
      anon_sym_await,
    ACTIONS(2204), 1,
      sym_identifier,
    ACTIONS(2218), 1,
      anon_sym_STAR,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2106), 1,
      sym_expression,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1828), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [48729] = 22,
    ACTIONS(781), 1,
      anon_sym_LPAREN,
    ACTIONS(789), 1,
      anon_sym_LBRACK,
    ACTIONS(793), 1,
      anon_sym_LBRACE,
    ACTIONS(799), 1,
      sym_string_start,
    ACTIONS(1792), 1,
      anon_sym_STAR,
    ACTIONS(1800), 1,
      anon_sym_not,
    ACTIONS(1802), 1,
      anon_sym_lambda,
    ACTIONS(1956), 1,
      sym_identifier,
    ACTIONS(1964), 1,
      anon_sym_type,
    ACTIONS(1966), 1,
      anon_sym_await,
    STATE(1221), 1,
      sym_primary_expression,
    STATE(1223), 1,
      sym_string,
    STATE(1459), 1,
      sym_list_splat_pattern,
    STATE(2357), 1,
      sym_expression,
    STATE(3201), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(795), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(791), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(779), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1962), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2139), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1449), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [48827] = 22,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2469), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [48925] = 22,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(465), 1,
      sym_identifier,
    ACTIONS(477), 1,
      anon_sym_type,
    ACTIONS(488), 1,
      anon_sym_await,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(2248), 1,
      anon_sym_STAR,
    STATE(1200), 1,
      sym_string,
    STATE(1203), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    STATE(2278), 1,
      sym_expression,
    STATE(3427), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(473), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2070), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [49023] = 22,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2532), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [49121] = 23,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(1994), 1,
      anon_sym_not,
    ACTIONS(1996), 1,
      anon_sym_lambda,
    ACTIONS(2410), 1,
      anon_sym_STAR,
    ACTIONS(2462), 1,
      sym_identifier,
    ACTIONS(2466), 1,
      anon_sym_type,
    ACTIONS(2468), 1,
      anon_sym_await,
    STATE(1488), 1,
      sym_string,
    STATE(1491), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    STATE(2305), 1,
      sym_expression,
    STATE(3239), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    STATE(1793), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(942), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2464), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2383), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1780), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [49221] = 22,
    ACTIONS(920), 1,
      anon_sym_LPAREN,
    ACTIONS(928), 1,
      anon_sym_LBRACK,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_string_start,
    ACTIONS(1644), 1,
      anon_sym_not,
    ACTIONS(1646), 1,
      anon_sym_lambda,
    ACTIONS(2006), 1,
      sym_identifier,
    ACTIONS(2012), 1,
      anon_sym_type,
    ACTIONS(2016), 1,
      anon_sym_await,
    ACTIONS(2200), 1,
      anon_sym_STAR,
    STATE(1264), 1,
      sym_primary_expression,
    STATE(1279), 1,
      sym_string,
    STATE(1590), 1,
      sym_list_splat_pattern,
    STATE(2183), 1,
      sym_expression,
    STATE(3184), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(934), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(930), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(918), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2010), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2189), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1654), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [49319] = 22,
    ACTIONS(854), 1,
      anon_sym_LPAREN,
    ACTIONS(862), 1,
      anon_sym_LBRACK,
    ACTIONS(866), 1,
      anon_sym_LBRACE,
    ACTIONS(872), 1,
      sym_string_start,
    ACTIONS(1606), 1,
      sym_identifier,
    ACTIONS(1618), 1,
      anon_sym_type,
    ACTIONS(1622), 1,
      anon_sym_not,
    ACTIONS(1624), 1,
      anon_sym_lambda,
    ACTIONS(1628), 1,
      anon_sym_await,
    ACTIONS(2212), 1,
      anon_sym_STAR,
    STATE(1220), 1,
      sym_primary_expression,
    STATE(1227), 1,
      sym_string,
    STATE(1504), 1,
      sym_list_splat_pattern,
    STATE(2162), 1,
      sym_expression,
    STATE(3456), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(868), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(864), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(852), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1614), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2165), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [49417] = 22,
    ACTIONS(854), 1,
      anon_sym_LPAREN,
    ACTIONS(862), 1,
      anon_sym_LBRACK,
    ACTIONS(866), 1,
      anon_sym_LBRACE,
    ACTIONS(872), 1,
      sym_string_start,
    ACTIONS(1606), 1,
      sym_identifier,
    ACTIONS(1618), 1,
      anon_sym_type,
    ACTIONS(1622), 1,
      anon_sym_not,
    ACTIONS(1624), 1,
      anon_sym_lambda,
    ACTIONS(1628), 1,
      anon_sym_await,
    ACTIONS(2212), 1,
      anon_sym_STAR,
    STATE(1220), 1,
      sym_primary_expression,
    STATE(1227), 1,
      sym_string,
    STATE(1504), 1,
      sym_list_splat_pattern,
    STATE(2161), 1,
      sym_expression,
    STATE(3456), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(868), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(864), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(852), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1614), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2165), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [49515] = 22,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2123), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [49613] = 22,
    ACTIONS(854), 1,
      anon_sym_LPAREN,
    ACTIONS(862), 1,
      anon_sym_LBRACK,
    ACTIONS(866), 1,
      anon_sym_LBRACE,
    ACTIONS(872), 1,
      sym_string_start,
    ACTIONS(1606), 1,
      sym_identifier,
    ACTIONS(1618), 1,
      anon_sym_type,
    ACTIONS(1622), 1,
      anon_sym_not,
    ACTIONS(1624), 1,
      anon_sym_lambda,
    ACTIONS(1628), 1,
      anon_sym_await,
    ACTIONS(2212), 1,
      anon_sym_STAR,
    STATE(1220), 1,
      sym_primary_expression,
    STATE(1227), 1,
      sym_string,
    STATE(1504), 1,
      sym_list_splat_pattern,
    STATE(2159), 1,
      sym_expression,
    STATE(3456), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(868), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(864), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(852), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1614), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2165), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [49711] = 22,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(1994), 1,
      anon_sym_not,
    ACTIONS(1996), 1,
      anon_sym_lambda,
    ACTIONS(2408), 1,
      sym_identifier,
    ACTIONS(2410), 1,
      anon_sym_STAR,
    ACTIONS(2414), 1,
      anon_sym_type,
    ACTIONS(2416), 1,
      anon_sym_await,
    STATE(1488), 1,
      sym_string,
    STATE(1491), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    STATE(2385), 1,
      sym_expression,
    STATE(3239), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(942), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2412), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2383), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [49809] = 22,
    ACTIONS(854), 1,
      anon_sym_LPAREN,
    ACTIONS(862), 1,
      anon_sym_LBRACK,
    ACTIONS(866), 1,
      anon_sym_LBRACE,
    ACTIONS(872), 1,
      sym_string_start,
    ACTIONS(1606), 1,
      sym_identifier,
    ACTIONS(1618), 1,
      anon_sym_type,
    ACTIONS(1622), 1,
      anon_sym_not,
    ACTIONS(1624), 1,
      anon_sym_lambda,
    ACTIONS(1628), 1,
      anon_sym_await,
    ACTIONS(2212), 1,
      anon_sym_STAR,
    STATE(1220), 1,
      sym_primary_expression,
    STATE(1227), 1,
      sym_string,
    STATE(1504), 1,
      sym_list_splat_pattern,
    STATE(2158), 1,
      sym_expression,
    STATE(3456), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(868), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(864), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(852), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1614), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2165), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [49907] = 22,
    ACTIONS(920), 1,
      anon_sym_LPAREN,
    ACTIONS(928), 1,
      anon_sym_LBRACK,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_string_start,
    ACTIONS(1644), 1,
      anon_sym_not,
    ACTIONS(1646), 1,
      anon_sym_lambda,
    ACTIONS(2006), 1,
      sym_identifier,
    ACTIONS(2012), 1,
      anon_sym_type,
    ACTIONS(2016), 1,
      anon_sym_await,
    ACTIONS(2200), 1,
      anon_sym_STAR,
    STATE(1264), 1,
      sym_primary_expression,
    STATE(1279), 1,
      sym_string,
    STATE(1590), 1,
      sym_list_splat_pattern,
    STATE(2209), 1,
      sym_expression,
    STATE(3184), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(934), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(930), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(918), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2010), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2189), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1654), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [50005] = 22,
    ACTIONS(830), 1,
      anon_sym_LPAREN,
    ACTIONS(840), 1,
      anon_sym_LBRACK,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(1594), 1,
      anon_sym_not,
    ACTIONS(1596), 1,
      anon_sym_lambda,
    ACTIONS(1922), 1,
      sym_identifier,
    ACTIONS(1928), 1,
      anon_sym_type,
    ACTIONS(1930), 1,
      anon_sym_await,
    ACTIONS(2182), 1,
      anon_sym_STAR,
    STATE(1271), 1,
      sym_string,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1530), 1,
      sym_list_splat_pattern,
    STATE(2237), 1,
      sym_expression,
    STATE(3306), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(828), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1926), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2173), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1660), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [50103] = 22,
    ACTIONS(830), 1,
      anon_sym_LPAREN,
    ACTIONS(840), 1,
      anon_sym_LBRACK,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(1594), 1,
      anon_sym_not,
    ACTIONS(1596), 1,
      anon_sym_lambda,
    ACTIONS(1922), 1,
      sym_identifier,
    ACTIONS(1928), 1,
      anon_sym_type,
    ACTIONS(1930), 1,
      anon_sym_await,
    ACTIONS(2182), 1,
      anon_sym_STAR,
    STATE(1271), 1,
      sym_string,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1530), 1,
      sym_list_splat_pattern,
    STATE(2236), 1,
      sym_expression,
    STATE(3306), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(828), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1926), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2173), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1660), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [50201] = 22,
    ACTIONS(830), 1,
      anon_sym_LPAREN,
    ACTIONS(840), 1,
      anon_sym_LBRACK,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(1594), 1,
      anon_sym_not,
    ACTIONS(1596), 1,
      anon_sym_lambda,
    ACTIONS(1922), 1,
      sym_identifier,
    ACTIONS(1928), 1,
      anon_sym_type,
    ACTIONS(1930), 1,
      anon_sym_await,
    ACTIONS(2182), 1,
      anon_sym_STAR,
    STATE(1271), 1,
      sym_string,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1530), 1,
      sym_list_splat_pattern,
    STATE(2219), 1,
      sym_expression,
    STATE(3306), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(828), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1926), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2173), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1660), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [50299] = 22,
    ACTIONS(920), 1,
      anon_sym_LPAREN,
    ACTIONS(928), 1,
      anon_sym_LBRACK,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_string_start,
    ACTIONS(1644), 1,
      anon_sym_not,
    ACTIONS(1646), 1,
      anon_sym_lambda,
    ACTIONS(2006), 1,
      sym_identifier,
    ACTIONS(2012), 1,
      anon_sym_type,
    ACTIONS(2016), 1,
      anon_sym_await,
    ACTIONS(2200), 1,
      anon_sym_STAR,
    STATE(1264), 1,
      sym_primary_expression,
    STATE(1279), 1,
      sym_string,
    STATE(1590), 1,
      sym_list_splat_pattern,
    STATE(2217), 1,
      sym_expression,
    STATE(3184), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(934), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(930), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(918), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2010), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2189), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1654), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [50397] = 22,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(465), 1,
      sym_identifier,
    ACTIONS(477), 1,
      anon_sym_type,
    ACTIONS(488), 1,
      anon_sym_await,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(2248), 1,
      anon_sym_STAR,
    STATE(1200), 1,
      sym_string,
    STATE(1203), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    STATE(2065), 1,
      sym_expression,
    STATE(3427), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(473), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2070), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [50495] = 22,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2150), 1,
      sym_expression,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [50593] = 22,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2473), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [50691] = 22,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2307), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [50789] = 22,
    ACTIONS(830), 1,
      anon_sym_LPAREN,
    ACTIONS(840), 1,
      anon_sym_LBRACK,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(1594), 1,
      anon_sym_not,
    ACTIONS(1596), 1,
      anon_sym_lambda,
    ACTIONS(1922), 1,
      sym_identifier,
    ACTIONS(1928), 1,
      anon_sym_type,
    ACTIONS(1930), 1,
      anon_sym_await,
    ACTIONS(2182), 1,
      anon_sym_STAR,
    STATE(1271), 1,
      sym_string,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1530), 1,
      sym_list_splat_pattern,
    STATE(2223), 1,
      sym_expression,
    STATE(3306), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(828), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1926), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2173), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1660), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [50887] = 22,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2124), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [50985] = 22,
    ACTIONS(920), 1,
      anon_sym_LPAREN,
    ACTIONS(928), 1,
      anon_sym_LBRACK,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_string_start,
    ACTIONS(1644), 1,
      anon_sym_not,
    ACTIONS(1646), 1,
      anon_sym_lambda,
    ACTIONS(2006), 1,
      sym_identifier,
    ACTIONS(2012), 1,
      anon_sym_type,
    ACTIONS(2016), 1,
      anon_sym_await,
    ACTIONS(2200), 1,
      anon_sym_STAR,
    STATE(1264), 1,
      sym_primary_expression,
    STATE(1279), 1,
      sym_string,
    STATE(1590), 1,
      sym_list_splat_pattern,
    STATE(2234), 1,
      sym_expression,
    STATE(3184), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(934), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(930), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(918), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2010), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2189), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1654), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [51083] = 22,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2303), 1,
      sym_expression,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [51181] = 22,
    ACTIONS(876), 1,
      anon_sym_LPAREN,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1832), 1,
      anon_sym_type,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1838), 1,
      anon_sym_await,
    ACTIONS(2204), 1,
      sym_identifier,
    ACTIONS(2218), 1,
      anon_sym_STAR,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2296), 1,
      sym_expression,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1828), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [51279] = 22,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2125), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [51377] = 22,
    ACTIONS(781), 1,
      anon_sym_LPAREN,
    ACTIONS(789), 1,
      anon_sym_LBRACK,
    ACTIONS(793), 1,
      anon_sym_LBRACE,
    ACTIONS(799), 1,
      sym_string_start,
    ACTIONS(1792), 1,
      anon_sym_STAR,
    ACTIONS(1800), 1,
      anon_sym_not,
    ACTIONS(1802), 1,
      anon_sym_lambda,
    ACTIONS(1956), 1,
      sym_identifier,
    ACTIONS(1964), 1,
      anon_sym_type,
    ACTIONS(1966), 1,
      anon_sym_await,
    STATE(1221), 1,
      sym_primary_expression,
    STATE(1223), 1,
      sym_string,
    STATE(1459), 1,
      sym_list_splat_pattern,
    STATE(2137), 1,
      sym_expression,
    STATE(3201), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(795), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(791), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(779), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1962), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2139), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1449), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [51475] = 22,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2480), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [51573] = 22,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2148), 1,
      sym_expression,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [51671] = 22,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(465), 1,
      sym_identifier,
    ACTIONS(477), 1,
      anon_sym_type,
    ACTIONS(488), 1,
      anon_sym_await,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(2248), 1,
      anon_sym_STAR,
    STATE(1200), 1,
      sym_string,
    STATE(1203), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    STATE(2387), 1,
      sym_expression,
    STATE(3427), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(473), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2070), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [51769] = 22,
    ACTIONS(854), 1,
      anon_sym_LPAREN,
    ACTIONS(862), 1,
      anon_sym_LBRACK,
    ACTIONS(866), 1,
      anon_sym_LBRACE,
    ACTIONS(872), 1,
      sym_string_start,
    ACTIONS(1606), 1,
      sym_identifier,
    ACTIONS(1618), 1,
      anon_sym_type,
    ACTIONS(1622), 1,
      anon_sym_not,
    ACTIONS(1624), 1,
      anon_sym_lambda,
    ACTIONS(1628), 1,
      anon_sym_await,
    ACTIONS(2212), 1,
      anon_sym_STAR,
    STATE(1220), 1,
      sym_primary_expression,
    STATE(1227), 1,
      sym_string,
    STATE(1504), 1,
      sym_list_splat_pattern,
    STATE(2225), 1,
      sym_expression,
    STATE(3456), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(868), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(864), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(852), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1614), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2165), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [51867] = 22,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(1772), 1,
      anon_sym_type,
    ACTIONS(1776), 1,
      anon_sym_not,
    ACTIONS(1778), 1,
      anon_sym_lambda,
    ACTIONS(1780), 1,
      anon_sym_await,
    ACTIONS(2172), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    STATE(1337), 1,
      sym_string,
    STATE(1341), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    STATE(2147), 1,
      sym_expression,
    STATE(3185), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(896), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1768), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2130), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [51965] = 22,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(1994), 1,
      anon_sym_not,
    ACTIONS(1996), 1,
      anon_sym_lambda,
    ACTIONS(2408), 1,
      sym_identifier,
    ACTIONS(2410), 1,
      anon_sym_STAR,
    ACTIONS(2414), 1,
      anon_sym_type,
    ACTIONS(2416), 1,
      anon_sym_await,
    STATE(1488), 1,
      sym_string,
    STATE(1491), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    STATE(2312), 1,
      sym_expression,
    STATE(3239), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(942), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2412), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2383), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [52063] = 22,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2121), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [52161] = 22,
    ACTIONS(876), 1,
      anon_sym_LPAREN,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1832), 1,
      anon_sym_type,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1838), 1,
      anon_sym_await,
    ACTIONS(2204), 1,
      sym_identifier,
    ACTIONS(2218), 1,
      anon_sym_STAR,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2409), 1,
      sym_expression,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1828), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [52259] = 22,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2421), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [52357] = 22,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(465), 1,
      sym_identifier,
    ACTIONS(477), 1,
      anon_sym_type,
    ACTIONS(488), 1,
      anon_sym_await,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(2248), 1,
      anon_sym_STAR,
    STATE(1200), 1,
      sym_string,
    STATE(1203), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    STATE(2292), 1,
      sym_expression,
    STATE(3427), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(473), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2070), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [52455] = 23,
    ACTIONS(876), 1,
      anon_sym_LPAREN,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(2218), 1,
      anon_sym_STAR,
    ACTIONS(2454), 1,
      anon_sym_await,
    ACTIONS(2470), 1,
      sym_identifier,
    ACTIONS(2474), 1,
      anon_sym_type,
    STATE(1245), 1,
      sym_string,
    STATE(1407), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2353), 1,
      sym_expression,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    STATE(1605), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2472), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [52555] = 22,
    ACTIONS(920), 1,
      anon_sym_LPAREN,
    ACTIONS(928), 1,
      anon_sym_LBRACK,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(938), 1,
      sym_string_start,
    ACTIONS(1644), 1,
      anon_sym_not,
    ACTIONS(1646), 1,
      anon_sym_lambda,
    ACTIONS(2006), 1,
      sym_identifier,
    ACTIONS(2012), 1,
      anon_sym_type,
    ACTIONS(2016), 1,
      anon_sym_await,
    ACTIONS(2200), 1,
      anon_sym_STAR,
    STATE(1264), 1,
      sym_primary_expression,
    STATE(1279), 1,
      sym_string,
    STATE(1590), 1,
      sym_list_splat_pattern,
    STATE(2232), 1,
      sym_expression,
    STATE(3184), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(934), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(930), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(918), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2010), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2189), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1654), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [52653] = 22,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2470), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [52751] = 22,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2119), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [52849] = 22,
    ACTIONS(830), 1,
      anon_sym_LPAREN,
    ACTIONS(840), 1,
      anon_sym_LBRACK,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(1594), 1,
      anon_sym_not,
    ACTIONS(1596), 1,
      anon_sym_lambda,
    ACTIONS(1922), 1,
      sym_identifier,
    ACTIONS(1928), 1,
      anon_sym_type,
    ACTIONS(1930), 1,
      anon_sym_await,
    ACTIONS(2182), 1,
      anon_sym_STAR,
    STATE(1271), 1,
      sym_string,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1530), 1,
      sym_list_splat_pattern,
    STATE(2178), 1,
      sym_expression,
    STATE(3306), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(828), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1926), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2173), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1660), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [52947] = 22,
    ACTIONS(876), 1,
      anon_sym_LPAREN,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(1832), 1,
      anon_sym_type,
    ACTIONS(1834), 1,
      anon_sym_not,
    ACTIONS(1836), 1,
      anon_sym_lambda,
    ACTIONS(1838), 1,
      anon_sym_await,
    ACTIONS(2204), 1,
      sym_identifier,
    ACTIONS(2218), 1,
      anon_sym_STAR,
    STATE(1245), 1,
      sym_string,
    STATE(1253), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    STATE(2110), 1,
      sym_expression,
    STATE(3236), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(874), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1828), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2122), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [53045] = 22,
    ACTIONS(383), 1,
      anon_sym_type,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(398), 1,
      anon_sym_lambda,
    ACTIONS(406), 1,
      anon_sym_await,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(500), 1,
      anon_sym_not,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    STATE(1233), 1,
      sym_primary_expression,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(2459), 1,
      sym_expression,
    STATE(3286), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(374), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2104), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [53143] = 22,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(1994), 1,
      anon_sym_not,
    ACTIONS(1996), 1,
      anon_sym_lambda,
    ACTIONS(2408), 1,
      sym_identifier,
    ACTIONS(2410), 1,
      anon_sym_STAR,
    ACTIONS(2414), 1,
      anon_sym_type,
    ACTIONS(2416), 1,
      anon_sym_await,
    STATE(1488), 1,
      sym_string,
    STATE(1491), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    STATE(2313), 1,
      sym_expression,
    STATE(3239), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(942), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2412), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2383), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [53241] = 22,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(1994), 1,
      anon_sym_not,
    ACTIONS(1996), 1,
      anon_sym_lambda,
    ACTIONS(2408), 1,
      sym_identifier,
    ACTIONS(2410), 1,
      anon_sym_STAR,
    ACTIONS(2414), 1,
      anon_sym_type,
    ACTIONS(2416), 1,
      anon_sym_await,
    STATE(1488), 1,
      sym_string,
    STATE(1491), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    STATE(2381), 1,
      sym_expression,
    STATE(3239), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(942), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2412), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(2383), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [53339] = 10,
    ACTIONS(2478), 1,
      anon_sym_COMMA,
    ACTIONS(2483), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2485), 1,
      anon_sym_COLON,
    ACTIONS(2488), 1,
      anon_sym_EQ,
    ACTIONS(2490), 1,
      anon_sym_LBRACK,
    STATE(2456), 1,
      sym_type_parameter,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2492), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(2481), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2476), 16,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [53412] = 7,
    ACTIONS(2478), 1,
      anon_sym_COMMA,
    ACTIONS(2483), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2488), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(2492), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(2481), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2476), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [53478] = 7,
    ACTIONS(368), 1,
      anon_sym_COMMA,
    ACTIONS(376), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(378), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(400), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(363), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(361), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [53544] = 7,
    ACTIONS(368), 1,
      anon_sym_COMMA,
    ACTIONS(376), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(378), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(400), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(363), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(361), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [53610] = 8,
    ACTIONS(368), 1,
      anon_sym_COMMA,
    ACTIONS(376), 1,
      anon_sym_COLON_EQ,
    ACTIONS(378), 1,
      anon_sym_EQ,
    ACTIONS(410), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(400), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(363), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(361), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [53678] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2496), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2494), 32,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [53735] = 7,
    ACTIONS(2510), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2500), 2,
      anon_sym_DOT,
      anon_sym_COLON,
    ACTIONS(2502), 2,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(2508), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2505), 12,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(2498), 28,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [53800] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2514), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2512), 32,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [53857] = 6,
    ACTIONS(2488), 1,
      anon_sym_EQ,
    ACTIONS(2518), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2492), 14,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(2521), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2516), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [53920] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2525), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2523), 32,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [53977] = 6,
    ACTIONS(2534), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2529), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(2536), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(2532), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2527), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [54040] = 6,
    ACTIONS(2529), 1,
      anon_sym_COMMA,
    ACTIONS(2534), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2536), 14,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(2532), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2527), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [54103] = 6,
    ACTIONS(2545), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2540), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(2547), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(2543), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2538), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [54166] = 6,
    ACTIONS(2478), 1,
      anon_sym_COMMA,
    ACTIONS(2488), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2492), 14,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(2481), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2476), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [54229] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2496), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2494), 32,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [54286] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2551), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2549), 32,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [54343] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2555), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2553), 32,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [54400] = 6,
    ACTIONS(2540), 1,
      anon_sym_COMMA,
    ACTIONS(2545), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2547), 14,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(2543), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2538), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [54463] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(771), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(801), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(768), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(766), 29,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [54524] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(771), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(801), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(768), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(766), 29,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [54585] = 6,
    ACTIONS(2488), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2518), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(2492), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(2521), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2516), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [54648] = 6,
    ACTIONS(2488), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2478), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(2492), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(2481), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2476), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [54711] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2514), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2512), 32,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [54768] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2502), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(2508), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2505), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(2498), 29,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [54829] = 21,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(2557), 1,
      sym_identifier,
    ACTIONS(2559), 1,
      anon_sym_LPAREN,
    ACTIONS(2561), 1,
      anon_sym_STAR,
    ACTIONS(2565), 1,
      anon_sym_type,
    ACTIONS(2567), 1,
      anon_sym_LBRACK,
    ACTIONS(2569), 1,
      anon_sym_await,
    STATE(1234), 1,
      sym_string,
    STATE(1940), 1,
      sym_list_splat_pattern,
    STATE(1988), 1,
      sym_primary_expression,
    STATE(2522), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(1941), 2,
      sym_attribute,
      sym_subscript,
    STATE(2451), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1758), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
    ACTIONS(2563), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1536), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [54921] = 21,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(2557), 1,
      sym_identifier,
    ACTIONS(2559), 1,
      anon_sym_LPAREN,
    ACTIONS(2561), 1,
      anon_sym_STAR,
    ACTIONS(2565), 1,
      anon_sym_type,
    ACTIONS(2567), 1,
      anon_sym_LBRACK,
    ACTIONS(2569), 1,
      anon_sym_await,
    STATE(1234), 1,
      sym_string,
    STATE(1940), 1,
      sym_list_splat_pattern,
    STATE(1988), 1,
      sym_primary_expression,
    STATE(2522), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(1941), 2,
      sym_attribute,
      sym_subscript,
    STATE(2451), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1740), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
    ACTIONS(2563), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1536), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [55013] = 22,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(2571), 1,
      sym_identifier,
    ACTIONS(2573), 1,
      anon_sym_LPAREN,
    ACTIONS(2575), 1,
      anon_sym_RPAREN,
    ACTIONS(2577), 1,
      anon_sym_STAR,
    ACTIONS(2581), 1,
      anon_sym_type,
    ACTIONS(2583), 1,
      anon_sym_LBRACK,
    ACTIONS(2585), 1,
      anon_sym_await,
    STATE(1234), 1,
      sym_string,
    STATE(1989), 1,
      sym_list_splat_pattern,
    STATE(1991), 1,
      sym_primary_expression,
    STATE(2685), 1,
      sym_pattern,
    STATE(3307), 1,
      sym__patterns,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(1982), 2,
      sym_attribute,
      sym_subscript,
    STATE(3029), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2579), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1536), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [55105] = 22,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(2571), 1,
      sym_identifier,
    ACTIONS(2573), 1,
      anon_sym_LPAREN,
    ACTIONS(2577), 1,
      anon_sym_STAR,
    ACTIONS(2581), 1,
      anon_sym_type,
    ACTIONS(2583), 1,
      anon_sym_LBRACK,
    ACTIONS(2585), 1,
      anon_sym_await,
    ACTIONS(2587), 1,
      anon_sym_RPAREN,
    STATE(1234), 1,
      sym_string,
    STATE(1989), 1,
      sym_list_splat_pattern,
    STATE(1991), 1,
      sym_primary_expression,
    STATE(2685), 1,
      sym_pattern,
    STATE(3414), 1,
      sym__patterns,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(1982), 2,
      sym_attribute,
      sym_subscript,
    STATE(3029), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2579), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1536), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [55197] = 21,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(2571), 1,
      sym_identifier,
    ACTIONS(2573), 1,
      anon_sym_LPAREN,
    ACTIONS(2577), 1,
      anon_sym_STAR,
    ACTIONS(2581), 1,
      anon_sym_type,
    ACTIONS(2583), 1,
      anon_sym_LBRACK,
    ACTIONS(2585), 1,
      anon_sym_await,
    ACTIONS(2589), 1,
      anon_sym_RPAREN,
    STATE(1234), 1,
      sym_string,
    STATE(1989), 1,
      sym_list_splat_pattern,
    STATE(1991), 1,
      sym_primary_expression,
    STATE(3159), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(1982), 2,
      sym_attribute,
      sym_subscript,
    STATE(3029), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2579), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1536), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [55286] = 21,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    ACTIONS(2591), 1,
      sym_identifier,
    ACTIONS(2593), 1,
      anon_sym_LPAREN,
    ACTIONS(2597), 1,
      anon_sym_in,
    ACTIONS(2599), 1,
      anon_sym_type,
    ACTIONS(2601), 1,
      anon_sym_LBRACK,
    ACTIONS(2603), 1,
      anon_sym_await,
    STATE(1234), 1,
      sym_string,
    STATE(1976), 1,
      sym_list_splat_pattern,
    STATE(1977), 1,
      sym_primary_expression,
    STATE(2007), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(1985), 2,
      sym_attribute,
      sym_subscript,
    STATE(2015), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2595), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1536), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [55375] = 21,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    ACTIONS(2591), 1,
      sym_identifier,
    ACTIONS(2593), 1,
      anon_sym_LPAREN,
    ACTIONS(2599), 1,
      anon_sym_type,
    ACTIONS(2601), 1,
      anon_sym_LBRACK,
    ACTIONS(2603), 1,
      anon_sym_await,
    STATE(1234), 1,
      sym_string,
    STATE(1976), 1,
      sym_list_splat_pattern,
    STATE(1977), 1,
      sym_primary_expression,
    STATE(2736), 1,
      sym_pattern,
    STATE(3347), 1,
      sym_pattern_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(1985), 2,
      sym_attribute,
      sym_subscript,
    STATE(2015), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2595), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1536), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [55464] = 21,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    ACTIONS(2591), 1,
      sym_identifier,
    ACTIONS(2593), 1,
      anon_sym_LPAREN,
    ACTIONS(2599), 1,
      anon_sym_type,
    ACTIONS(2601), 1,
      anon_sym_LBRACK,
    ACTIONS(2603), 1,
      anon_sym_await,
    STATE(1234), 1,
      sym_string,
    STATE(1976), 1,
      sym_list_splat_pattern,
    STATE(1977), 1,
      sym_primary_expression,
    STATE(2689), 1,
      sym_pattern,
    STATE(3405), 1,
      sym_pattern_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(1985), 2,
      sym_attribute,
      sym_subscript,
    STATE(2015), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2595), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1536), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [55553] = 21,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    ACTIONS(2591), 1,
      sym_identifier,
    ACTIONS(2593), 1,
      anon_sym_LPAREN,
    ACTIONS(2599), 1,
      anon_sym_type,
    ACTIONS(2601), 1,
      anon_sym_LBRACK,
    ACTIONS(2603), 1,
      anon_sym_await,
    STATE(1234), 1,
      sym_string,
    STATE(1976), 1,
      sym_list_splat_pattern,
    STATE(1977), 1,
      sym_primary_expression,
    STATE(2921), 1,
      sym_pattern,
    STATE(3169), 1,
      sym_pattern_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(1985), 2,
      sym_attribute,
      sym_subscript,
    STATE(2015), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2595), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1536), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [55642] = 21,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    ACTIONS(2591), 1,
      sym_identifier,
    ACTIONS(2593), 1,
      anon_sym_LPAREN,
    ACTIONS(2599), 1,
      anon_sym_type,
    ACTIONS(2601), 1,
      anon_sym_LBRACK,
    ACTIONS(2603), 1,
      anon_sym_await,
    STATE(1234), 1,
      sym_string,
    STATE(1976), 1,
      sym_list_splat_pattern,
    STATE(1977), 1,
      sym_primary_expression,
    STATE(2733), 1,
      sym_pattern,
    STATE(3350), 1,
      sym_pattern_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(1985), 2,
      sym_attribute,
      sym_subscript,
    STATE(2015), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2595), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1536), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [55731] = 21,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(2571), 1,
      sym_identifier,
    ACTIONS(2573), 1,
      anon_sym_LPAREN,
    ACTIONS(2577), 1,
      anon_sym_STAR,
    ACTIONS(2581), 1,
      anon_sym_type,
    ACTIONS(2583), 1,
      anon_sym_LBRACK,
    ACTIONS(2585), 1,
      anon_sym_await,
    ACTIONS(2605), 1,
      anon_sym_RPAREN,
    STATE(1234), 1,
      sym_string,
    STATE(1989), 1,
      sym_list_splat_pattern,
    STATE(1991), 1,
      sym_primary_expression,
    STATE(3159), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(1982), 2,
      sym_attribute,
      sym_subscript,
    STATE(3029), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2579), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1536), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [55820] = 21,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    ACTIONS(2591), 1,
      sym_identifier,
    ACTIONS(2593), 1,
      anon_sym_LPAREN,
    ACTIONS(2599), 1,
      anon_sym_type,
    ACTIONS(2601), 1,
      anon_sym_LBRACK,
    ACTIONS(2603), 1,
      anon_sym_await,
    STATE(1234), 1,
      sym_string,
    STATE(1976), 1,
      sym_list_splat_pattern,
    STATE(1977), 1,
      sym_primary_expression,
    STATE(2673), 1,
      sym_pattern,
    STATE(3448), 1,
      sym_pattern_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(1985), 2,
      sym_attribute,
      sym_subscript,
    STATE(2015), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2595), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1536), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [55909] = 21,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    ACTIONS(2591), 1,
      sym_identifier,
    ACTIONS(2593), 1,
      anon_sym_LPAREN,
    ACTIONS(2599), 1,
      anon_sym_type,
    ACTIONS(2601), 1,
      anon_sym_LBRACK,
    ACTIONS(2603), 1,
      anon_sym_await,
    STATE(1234), 1,
      sym_string,
    STATE(1976), 1,
      sym_list_splat_pattern,
    STATE(1977), 1,
      sym_primary_expression,
    STATE(2799), 1,
      sym_pattern,
    STATE(3264), 1,
      sym_pattern_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(1985), 2,
      sym_attribute,
      sym_subscript,
    STATE(2015), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2595), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1536), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [55998] = 21,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    ACTIONS(2591), 1,
      sym_identifier,
    ACTIONS(2593), 1,
      anon_sym_LPAREN,
    ACTIONS(2599), 1,
      anon_sym_type,
    ACTIONS(2601), 1,
      anon_sym_LBRACK,
    ACTIONS(2603), 1,
      anon_sym_await,
    ACTIONS(2607), 1,
      anon_sym_in,
    STATE(1234), 1,
      sym_string,
    STATE(1976), 1,
      sym_list_splat_pattern,
    STATE(1977), 1,
      sym_primary_expression,
    STATE(2007), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(1985), 2,
      sym_attribute,
      sym_subscript,
    STATE(2015), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2595), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1536), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [56087] = 21,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    ACTIONS(2591), 1,
      sym_identifier,
    ACTIONS(2593), 1,
      anon_sym_LPAREN,
    ACTIONS(2599), 1,
      anon_sym_type,
    ACTIONS(2601), 1,
      anon_sym_LBRACK,
    ACTIONS(2603), 1,
      anon_sym_await,
    STATE(1234), 1,
      sym_string,
    STATE(1976), 1,
      sym_list_splat_pattern,
    STATE(1977), 1,
      sym_primary_expression,
    STATE(2713), 1,
      sym_pattern,
    STATE(3373), 1,
      sym_pattern_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(1985), 2,
      sym_attribute,
      sym_subscript,
    STATE(2015), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2595), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1536), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [56176] = 21,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(2605), 1,
      anon_sym_RBRACK,
    ACTIONS(2609), 1,
      sym_identifier,
    ACTIONS(2611), 1,
      anon_sym_LPAREN,
    ACTIONS(2613), 1,
      anon_sym_STAR,
    ACTIONS(2617), 1,
      anon_sym_type,
    ACTIONS(2619), 1,
      anon_sym_LBRACK,
    ACTIONS(2621), 1,
      anon_sym_await,
    STATE(1234), 1,
      sym_string,
    STATE(1964), 1,
      sym_primary_expression,
    STATE(1969), 1,
      sym_list_splat_pattern,
    STATE(3150), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(1999), 2,
      sym_attribute,
      sym_subscript,
    STATE(3133), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2615), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1536), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [56265] = 21,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    ACTIONS(2591), 1,
      sym_identifier,
    ACTIONS(2593), 1,
      anon_sym_LPAREN,
    ACTIONS(2599), 1,
      anon_sym_type,
    ACTIONS(2601), 1,
      anon_sym_LBRACK,
    ACTIONS(2603), 1,
      anon_sym_await,
    STATE(1234), 1,
      sym_string,
    STATE(1976), 1,
      sym_list_splat_pattern,
    STATE(1977), 1,
      sym_primary_expression,
    STATE(2672), 1,
      sym_pattern,
    STATE(3452), 1,
      sym_pattern_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(1985), 2,
      sym_attribute,
      sym_subscript,
    STATE(2015), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2595), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1536), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [56354] = 21,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    ACTIONS(2591), 1,
      sym_identifier,
    ACTIONS(2593), 1,
      anon_sym_LPAREN,
    ACTIONS(2599), 1,
      anon_sym_type,
    ACTIONS(2601), 1,
      anon_sym_LBRACK,
    ACTIONS(2603), 1,
      anon_sym_await,
    STATE(1234), 1,
      sym_string,
    STATE(1976), 1,
      sym_list_splat_pattern,
    STATE(1977), 1,
      sym_primary_expression,
    STATE(2743), 1,
      sym_pattern,
    STATE(3337), 1,
      sym_pattern_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(1985), 2,
      sym_attribute,
      sym_subscript,
    STATE(2015), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2595), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1536), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [56443] = 21,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(2589), 1,
      anon_sym_RBRACK,
    ACTIONS(2609), 1,
      sym_identifier,
    ACTIONS(2611), 1,
      anon_sym_LPAREN,
    ACTIONS(2613), 1,
      anon_sym_STAR,
    ACTIONS(2617), 1,
      anon_sym_type,
    ACTIONS(2619), 1,
      anon_sym_LBRACK,
    ACTIONS(2621), 1,
      anon_sym_await,
    STATE(1234), 1,
      sym_string,
    STATE(1964), 1,
      sym_primary_expression,
    STATE(1969), 1,
      sym_list_splat_pattern,
    STATE(3150), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(1999), 2,
      sym_attribute,
      sym_subscript,
    STATE(3133), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2615), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1536), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [56532] = 21,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    ACTIONS(2591), 1,
      sym_identifier,
    ACTIONS(2593), 1,
      anon_sym_LPAREN,
    ACTIONS(2599), 1,
      anon_sym_type,
    ACTIONS(2601), 1,
      anon_sym_LBRACK,
    ACTIONS(2603), 1,
      anon_sym_await,
    STATE(1234), 1,
      sym_string,
    STATE(1976), 1,
      sym_list_splat_pattern,
    STATE(1977), 1,
      sym_primary_expression,
    STATE(2712), 1,
      sym_pattern,
    STATE(3375), 1,
      sym_pattern_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(1985), 2,
      sym_attribute,
      sym_subscript,
    STATE(2015), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2595), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1536), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [56621] = 20,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(2571), 1,
      sym_identifier,
    ACTIONS(2573), 1,
      anon_sym_LPAREN,
    ACTIONS(2577), 1,
      anon_sym_STAR,
    ACTIONS(2581), 1,
      anon_sym_type,
    ACTIONS(2583), 1,
      anon_sym_LBRACK,
    ACTIONS(2585), 1,
      anon_sym_await,
    STATE(1234), 1,
      sym_string,
    STATE(1989), 1,
      sym_list_splat_pattern,
    STATE(1991), 1,
      sym_primary_expression,
    STATE(3159), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(1982), 2,
      sym_attribute,
      sym_subscript,
    STATE(3029), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2579), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1536), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [56707] = 20,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    ACTIONS(2591), 1,
      sym_identifier,
    ACTIONS(2593), 1,
      anon_sym_LPAREN,
    ACTIONS(2599), 1,
      anon_sym_type,
    ACTIONS(2601), 1,
      anon_sym_LBRACK,
    ACTIONS(2603), 1,
      anon_sym_await,
    STATE(1234), 1,
      sym_string,
    STATE(1976), 1,
      sym_list_splat_pattern,
    STATE(1977), 1,
      sym_primary_expression,
    STATE(2007), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(1985), 2,
      sym_attribute,
      sym_subscript,
    STATE(2015), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2595), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1536), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [56793] = 20,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(2609), 1,
      sym_identifier,
    ACTIONS(2611), 1,
      anon_sym_LPAREN,
    ACTIONS(2613), 1,
      anon_sym_STAR,
    ACTIONS(2617), 1,
      anon_sym_type,
    ACTIONS(2619), 1,
      anon_sym_LBRACK,
    ACTIONS(2621), 1,
      anon_sym_await,
    STATE(1234), 1,
      sym_string,
    STATE(1964), 1,
      sym_primary_expression,
    STATE(1969), 1,
      sym_list_splat_pattern,
    STATE(3150), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(1999), 2,
      sym_attribute,
      sym_subscript,
    STATE(3133), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2615), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1536), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [56879] = 20,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(2557), 1,
      sym_identifier,
    ACTIONS(2559), 1,
      anon_sym_LPAREN,
    ACTIONS(2561), 1,
      anon_sym_STAR,
    ACTIONS(2565), 1,
      anon_sym_type,
    ACTIONS(2567), 1,
      anon_sym_LBRACK,
    ACTIONS(2569), 1,
      anon_sym_await,
    STATE(1234), 1,
      sym_string,
    STATE(1940), 1,
      sym_list_splat_pattern,
    STATE(1988), 1,
      sym_primary_expression,
    STATE(2522), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(1941), 2,
      sym_attribute,
      sym_subscript,
    STATE(2451), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2563), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1536), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [56965] = 20,
    ACTIONS(17), 1,
      anon_sym_STAR,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(1738), 1,
      sym_identifier,
    ACTIONS(1742), 1,
      anon_sym_LPAREN,
    ACTIONS(1748), 1,
      anon_sym_type,
    ACTIONS(1750), 1,
      anon_sym_LBRACK,
    ACTIONS(1752), 1,
      anon_sym_await,
    STATE(1234), 1,
      sym_string,
    STATE(1639), 1,
      sym_list_splat_pattern,
    STATE(1979), 1,
      sym_primary_expression,
    STATE(1992), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(1638), 2,
      sym_attribute,
      sym_subscript,
    STATE(1975), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1746), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1536), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [57051] = 20,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(1868), 1,
      sym_identifier,
    ACTIONS(1870), 1,
      anon_sym_LPAREN,
    ACTIONS(1876), 1,
      anon_sym_type,
    ACTIONS(1878), 1,
      anon_sym_LBRACK,
    ACTIONS(1880), 1,
      anon_sym_await,
    ACTIONS(2623), 1,
      anon_sym_STAR,
    STATE(1234), 1,
      sym_string,
    STATE(1770), 1,
      sym_list_splat_pattern,
    STATE(1968), 1,
      sym_primary_expression,
    STATE(2007), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(1768), 2,
      sym_attribute,
      sym_subscript,
    STATE(2015), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1874), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1536), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [57137] = 19,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    ACTIONS(2625), 1,
      sym_identifier,
    ACTIONS(2631), 1,
      anon_sym_type,
    ACTIONS(2633), 1,
      anon_sym_await,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(1977), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(2627), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    STATE(1960), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2629), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1536), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [57220] = 19,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    ACTIONS(2635), 1,
      sym_identifier,
    ACTIONS(2639), 1,
      anon_sym_type,
    ACTIONS(2641), 1,
      anon_sym_await,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(1991), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(2627), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(1948), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2637), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1536), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [57303] = 17,
    ACTIONS(854), 1,
      anon_sym_LPAREN,
    ACTIONS(860), 1,
      anon_sym_type,
    ACTIONS(862), 1,
      anon_sym_LBRACK,
    ACTIONS(866), 1,
      anon_sym_LBRACE,
    ACTIONS(870), 1,
      anon_sym_await,
    ACTIONS(872), 1,
      sym_string_start,
    ACTIONS(2212), 1,
      anon_sym_STAR,
    ACTIONS(2643), 1,
      anon_sym_not,
    STATE(1227), 1,
      sym_string,
    STATE(1242), 1,
      sym_primary_expression,
    STATE(1504), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(868), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(864), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(858), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(852), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [57381] = 17,
    ACTIONS(876), 1,
      anon_sym_LPAREN,
    ACTIONS(882), 1,
      anon_sym_type,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(892), 1,
      anon_sym_await,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(2218), 1,
      anon_sym_STAR,
    ACTIONS(2645), 1,
      anon_sym_not,
    STATE(1245), 1,
      sym_string,
    STATE(1374), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(880), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(874), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [57459] = 17,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(904), 1,
      anon_sym_type,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(914), 1,
      anon_sym_await,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    ACTIONS(2647), 1,
      anon_sym_not,
    STATE(1337), 1,
      sym_string,
    STATE(1505), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(902), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(896), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [57537] = 17,
    ACTIONS(830), 1,
      anon_sym_LPAREN,
    ACTIONS(836), 1,
      anon_sym_type,
    ACTIONS(840), 1,
      anon_sym_LBRACK,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(848), 1,
      anon_sym_await,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(2182), 1,
      anon_sym_STAR,
    ACTIONS(2649), 1,
      anon_sym_not,
    STATE(1271), 1,
      sym_string,
    STATE(1366), 1,
      sym_primary_expression,
    STATE(1530), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(834), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(828), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1660), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [57615] = 17,
    ACTIONS(781), 1,
      anon_sym_LPAREN,
    ACTIONS(787), 1,
      anon_sym_type,
    ACTIONS(789), 1,
      anon_sym_LBRACK,
    ACTIONS(793), 1,
      anon_sym_LBRACE,
    ACTIONS(797), 1,
      anon_sym_await,
    ACTIONS(799), 1,
      sym_string_start,
    ACTIONS(1792), 1,
      anon_sym_STAR,
    ACTIONS(2651), 1,
      anon_sym_not,
    STATE(1223), 1,
      sym_string,
    STATE(1272), 1,
      sym_primary_expression,
    STATE(1459), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(795), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(791), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(785), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(779), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1449), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [57693] = 17,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(758), 1,
      anon_sym_type,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_await,
    ACTIONS(2248), 1,
      anon_sym_STAR,
    ACTIONS(2653), 1,
      anon_sym_not,
    STATE(1200), 1,
      sym_string,
    STATE(1213), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(756), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(77), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [57771] = 17,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(950), 1,
      anon_sym_type,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(962), 1,
      anon_sym_await,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(2410), 1,
      anon_sym_STAR,
    ACTIONS(2655), 1,
      anon_sym_not,
    STATE(1488), 1,
      sym_string,
    STATE(1649), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(948), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(942), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [57849] = 17,
    ACTIONS(920), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_type,
    ACTIONS(928), 1,
      anon_sym_LBRACK,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(936), 1,
      anon_sym_await,
    ACTIONS(938), 1,
      sym_string_start,
    ACTIONS(2200), 1,
      anon_sym_STAR,
    ACTIONS(2657), 1,
      anon_sym_not,
    STATE(1279), 1,
      sym_string,
    STATE(1356), 1,
      sym_primary_expression,
    STATE(1590), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(934), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(930), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(924), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(918), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1654), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [57927] = 17,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(775), 1,
      anon_sym_type,
    ACTIONS(777), 1,
      anon_sym_await,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    ACTIONS(2659), 1,
      anon_sym_not,
    STATE(1234), 1,
      sym_string,
    STATE(1331), 1,
      sym_primary_expression,
    STATE(1541), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(773), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [58005] = 16,
    ACTIONS(876), 1,
      anon_sym_LPAREN,
    ACTIONS(882), 1,
      anon_sym_type,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(892), 1,
      anon_sym_await,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(2218), 1,
      anon_sym_STAR,
    STATE(1245), 1,
      sym_string,
    STATE(1373), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(880), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(874), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [58080] = 16,
    ACTIONS(854), 1,
      anon_sym_LPAREN,
    ACTIONS(860), 1,
      anon_sym_type,
    ACTIONS(862), 1,
      anon_sym_LBRACK,
    ACTIONS(866), 1,
      anon_sym_LBRACE,
    ACTIONS(870), 1,
      anon_sym_await,
    ACTIONS(872), 1,
      sym_string_start,
    ACTIONS(2212), 1,
      anon_sym_STAR,
    STATE(1227), 1,
      sym_string,
    STATE(1259), 1,
      sym_primary_expression,
    STATE(1504), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(868), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(864), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(858), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(852), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [58155] = 16,
    ACTIONS(876), 1,
      anon_sym_LPAREN,
    ACTIONS(882), 1,
      anon_sym_type,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(892), 1,
      anon_sym_await,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(2218), 1,
      anon_sym_STAR,
    STATE(1245), 1,
      sym_string,
    STATE(1374), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(880), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(874), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [58230] = 16,
    ACTIONS(920), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_type,
    ACTIONS(928), 1,
      anon_sym_LBRACK,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(936), 1,
      anon_sym_await,
    ACTIONS(938), 1,
      sym_string_start,
    ACTIONS(2200), 1,
      anon_sym_STAR,
    STATE(1279), 1,
      sym_string,
    STATE(1354), 1,
      sym_primary_expression,
    STATE(1590), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(934), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(930), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(924), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(918), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1654), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [58305] = 18,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    ACTIONS(2661), 1,
      sym_identifier,
    ACTIONS(2665), 1,
      anon_sym_type,
    ACTIONS(2667), 1,
      anon_sym_await,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(1964), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(1736), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2663), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1536), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [58384] = 18,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    ACTIONS(2669), 1,
      sym_identifier,
    ACTIONS(2673), 1,
      anon_sym_type,
    ACTIONS(2675), 1,
      anon_sym_await,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(1988), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(1434), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2671), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1536), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [58463] = 16,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(775), 1,
      anon_sym_type,
    ACTIONS(777), 1,
      anon_sym_await,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    STATE(1234), 1,
      sym_string,
    STATE(1297), 1,
      sym_primary_expression,
    STATE(1541), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(773), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [58538] = 16,
    ACTIONS(876), 1,
      anon_sym_LPAREN,
    ACTIONS(882), 1,
      anon_sym_type,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(892), 1,
      anon_sym_await,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(2218), 1,
      anon_sym_STAR,
    STATE(1245), 1,
      sym_string,
    STATE(1372), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(880), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(874), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [58613] = 5,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1190), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2679), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2677), 33,
      sym__dedent,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_config,
      anon_sym_meta_wrapper,
      anon_sym_prefix,
      anon_sym_skip_validation,
      anon_sym_snakefile,
  [58666] = 16,
    ACTIONS(920), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_type,
    ACTIONS(928), 1,
      anon_sym_LBRACK,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(936), 1,
      anon_sym_await,
    ACTIONS(938), 1,
      sym_string_start,
    ACTIONS(2200), 1,
      anon_sym_STAR,
    STATE(1279), 1,
      sym_string,
    STATE(1356), 1,
      sym_primary_expression,
    STATE(1590), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(934), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(930), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(924), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(918), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1654), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [58741] = 16,
    ACTIONS(876), 1,
      anon_sym_LPAREN,
    ACTIONS(882), 1,
      anon_sym_type,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(892), 1,
      anon_sym_await,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(2218), 1,
      anon_sym_STAR,
    STATE(1245), 1,
      sym_string,
    STATE(1371), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(880), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(874), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [58816] = 16,
    ACTIONS(920), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_type,
    ACTIONS(928), 1,
      anon_sym_LBRACK,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(936), 1,
      anon_sym_await,
    ACTIONS(938), 1,
      sym_string_start,
    ACTIONS(2200), 1,
      anon_sym_STAR,
    STATE(1279), 1,
      sym_string,
    STATE(1357), 1,
      sym_primary_expression,
    STATE(1590), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(934), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(930), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(924), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(918), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1654), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [58891] = 16,
    ACTIONS(876), 1,
      anon_sym_LPAREN,
    ACTIONS(882), 1,
      anon_sym_type,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(892), 1,
      anon_sym_await,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(2218), 1,
      anon_sym_STAR,
    STATE(1245), 1,
      sym_string,
    STATE(1370), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(880), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(874), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [58966] = 16,
    ACTIONS(830), 1,
      anon_sym_LPAREN,
    ACTIONS(836), 1,
      anon_sym_type,
    ACTIONS(840), 1,
      anon_sym_LBRACK,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(848), 1,
      anon_sym_await,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(2182), 1,
      anon_sym_STAR,
    STATE(1271), 1,
      sym_string,
    STATE(1302), 1,
      sym_primary_expression,
    STATE(1530), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(834), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(828), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1660), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [59041] = 16,
    ACTIONS(876), 1,
      anon_sym_LPAREN,
    ACTIONS(882), 1,
      anon_sym_type,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(892), 1,
      anon_sym_await,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(2218), 1,
      anon_sym_STAR,
    STATE(1245), 1,
      sym_string,
    STATE(1369), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(880), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(874), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [59116] = 16,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(758), 1,
      anon_sym_type,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_await,
    ACTIONS(2248), 1,
      anon_sym_STAR,
    STATE(1200), 1,
      sym_string,
    STATE(1212), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(756), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(77), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [59191] = 16,
    ACTIONS(781), 1,
      anon_sym_LPAREN,
    ACTIONS(787), 1,
      anon_sym_type,
    ACTIONS(789), 1,
      anon_sym_LBRACK,
    ACTIONS(793), 1,
      anon_sym_LBRACE,
    ACTIONS(797), 1,
      anon_sym_await,
    ACTIONS(799), 1,
      sym_string_start,
    ACTIONS(1792), 1,
      anon_sym_STAR,
    STATE(1223), 1,
      sym_string,
    STATE(1230), 1,
      sym_primary_expression,
    STATE(1459), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(795), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(791), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(785), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(779), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1449), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [59266] = 16,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(950), 1,
      anon_sym_type,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(962), 1,
      anon_sym_await,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(2410), 1,
      anon_sym_STAR,
    STATE(1488), 1,
      sym_string,
    STATE(1675), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(948), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(942), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [59341] = 16,
    ACTIONS(781), 1,
      anon_sym_LPAREN,
    ACTIONS(787), 1,
      anon_sym_type,
    ACTIONS(789), 1,
      anon_sym_LBRACK,
    ACTIONS(793), 1,
      anon_sym_LBRACE,
    ACTIONS(797), 1,
      anon_sym_await,
    ACTIONS(799), 1,
      sym_string_start,
    ACTIONS(1792), 1,
      anon_sym_STAR,
    STATE(1223), 1,
      sym_string,
    STATE(1231), 1,
      sym_primary_expression,
    STATE(1459), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(795), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(791), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(785), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(779), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1449), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [59416] = 16,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(775), 1,
      anon_sym_type,
    ACTIONS(777), 1,
      anon_sym_await,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    STATE(1234), 1,
      sym_string,
    STATE(1344), 1,
      sym_primary_expression,
    STATE(1541), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(773), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [59491] = 16,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(775), 1,
      anon_sym_type,
    ACTIONS(777), 1,
      anon_sym_await,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    STATE(1234), 1,
      sym_string,
    STATE(1343), 1,
      sym_primary_expression,
    STATE(1541), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(773), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [59566] = 16,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(950), 1,
      anon_sym_type,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(962), 1,
      anon_sym_await,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(2410), 1,
      anon_sym_STAR,
    STATE(1488), 1,
      sym_string,
    STATE(1663), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(948), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(942), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [59641] = 16,
    ACTIONS(920), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_type,
    ACTIONS(928), 1,
      anon_sym_LBRACK,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(936), 1,
      anon_sym_await,
    ACTIONS(938), 1,
      sym_string_start,
    ACTIONS(2200), 1,
      anon_sym_STAR,
    STATE(1279), 1,
      sym_string,
    STATE(1358), 1,
      sym_primary_expression,
    STATE(1590), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(934), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(930), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(924), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(918), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1654), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [59716] = 18,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    ACTIONS(2681), 1,
      sym_identifier,
    ACTIONS(2685), 1,
      anon_sym_type,
    ACTIONS(2687), 1,
      anon_sym_await,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(1979), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(1039), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2683), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1536), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [59795] = 16,
    ACTIONS(781), 1,
      anon_sym_LPAREN,
    ACTIONS(787), 1,
      anon_sym_type,
    ACTIONS(789), 1,
      anon_sym_LBRACK,
    ACTIONS(793), 1,
      anon_sym_LBRACE,
    ACTIONS(797), 1,
      anon_sym_await,
    ACTIONS(799), 1,
      sym_string_start,
    ACTIONS(1792), 1,
      anon_sym_STAR,
    STATE(1223), 1,
      sym_string,
    STATE(1280), 1,
      sym_primary_expression,
    STATE(1459), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(795), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(791), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(785), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(779), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1449), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [59870] = 16,
    ACTIONS(781), 1,
      anon_sym_LPAREN,
    ACTIONS(787), 1,
      anon_sym_type,
    ACTIONS(789), 1,
      anon_sym_LBRACK,
    ACTIONS(793), 1,
      anon_sym_LBRACE,
    ACTIONS(797), 1,
      anon_sym_await,
    ACTIONS(799), 1,
      sym_string_start,
    ACTIONS(1792), 1,
      anon_sym_STAR,
    STATE(1223), 1,
      sym_string,
    STATE(1278), 1,
      sym_primary_expression,
    STATE(1459), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(795), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(791), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(785), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(779), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1449), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [59945] = 16,
    ACTIONS(876), 1,
      anon_sym_LPAREN,
    ACTIONS(882), 1,
      anon_sym_type,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(892), 1,
      anon_sym_await,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(2218), 1,
      anon_sym_STAR,
    STATE(1245), 1,
      sym_string,
    STATE(1346), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(880), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(874), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [60020] = 16,
    ACTIONS(781), 1,
      anon_sym_LPAREN,
    ACTIONS(787), 1,
      anon_sym_type,
    ACTIONS(789), 1,
      anon_sym_LBRACK,
    ACTIONS(793), 1,
      anon_sym_LBRACE,
    ACTIONS(797), 1,
      anon_sym_await,
    ACTIONS(799), 1,
      sym_string_start,
    ACTIONS(1792), 1,
      anon_sym_STAR,
    STATE(1223), 1,
      sym_string,
    STATE(1276), 1,
      sym_primary_expression,
    STATE(1459), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(795), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(791), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(785), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(779), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1449), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [60095] = 18,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    ACTIONS(2665), 1,
      anon_sym_type,
    ACTIONS(2667), 1,
      anon_sym_await,
    ACTIONS(2689), 1,
      sym_identifier,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(1972), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(1736), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2663), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1536), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [60174] = 16,
    ACTIONS(876), 1,
      anon_sym_LPAREN,
    ACTIONS(882), 1,
      anon_sym_type,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(892), 1,
      anon_sym_await,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(2218), 1,
      anon_sym_STAR,
    STATE(1245), 1,
      sym_string,
    STATE(1345), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(880), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(874), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [60249] = 16,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(950), 1,
      anon_sym_type,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(962), 1,
      anon_sym_await,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(2410), 1,
      anon_sym_STAR,
    STATE(1488), 1,
      sym_string,
    STATE(1543), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(948), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(942), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [60324] = 18,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    ACTIONS(2675), 1,
      anon_sym_await,
    ACTIONS(2691), 1,
      sym_identifier,
    ACTIONS(2695), 1,
      anon_sym_type,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(1988), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(1457), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2693), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1536), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [60403] = 16,
    ACTIONS(876), 1,
      anon_sym_LPAREN,
    ACTIONS(882), 1,
      anon_sym_type,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(892), 1,
      anon_sym_await,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(2218), 1,
      anon_sym_STAR,
    STATE(1245), 1,
      sym_string,
    STATE(1377), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(880), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(874), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [60478] = 16,
    ACTIONS(781), 1,
      anon_sym_LPAREN,
    ACTIONS(787), 1,
      anon_sym_type,
    ACTIONS(789), 1,
      anon_sym_LBRACK,
    ACTIONS(793), 1,
      anon_sym_LBRACE,
    ACTIONS(797), 1,
      anon_sym_await,
    ACTIONS(799), 1,
      sym_string_start,
    ACTIONS(1792), 1,
      anon_sym_STAR,
    STATE(1223), 1,
      sym_string,
    STATE(1274), 1,
      sym_primary_expression,
    STATE(1459), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(795), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(791), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(785), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(779), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1449), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [60553] = 16,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(950), 1,
      anon_sym_type,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(962), 1,
      anon_sym_await,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(2410), 1,
      anon_sym_STAR,
    STATE(1488), 1,
      sym_string,
    STATE(1662), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(948), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(942), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [60628] = 18,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    ACTIONS(2697), 1,
      sym_identifier,
    ACTIONS(2701), 1,
      anon_sym_type,
    ACTIONS(2703), 1,
      anon_sym_await,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(1968), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(1771), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2699), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1536), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [60707] = 16,
    ACTIONS(876), 1,
      anon_sym_LPAREN,
    ACTIONS(882), 1,
      anon_sym_type,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(892), 1,
      anon_sym_await,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(2218), 1,
      anon_sym_STAR,
    STATE(1245), 1,
      sym_string,
    STATE(1376), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(880), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(874), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [60782] = 18,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    ACTIONS(2705), 1,
      sym_identifier,
    ACTIONS(2709), 1,
      anon_sym_type,
    ACTIONS(2711), 1,
      anon_sym_await,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(1966), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(1390), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2707), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1536), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [60861] = 16,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(904), 1,
      anon_sym_type,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(914), 1,
      anon_sym_await,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    STATE(1337), 1,
      sym_string,
    STATE(1493), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(902), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(896), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [60936] = 16,
    ACTIONS(781), 1,
      anon_sym_LPAREN,
    ACTIONS(787), 1,
      anon_sym_type,
    ACTIONS(789), 1,
      anon_sym_LBRACK,
    ACTIONS(793), 1,
      anon_sym_LBRACE,
    ACTIONS(797), 1,
      anon_sym_await,
    ACTIONS(799), 1,
      sym_string_start,
    ACTIONS(1792), 1,
      anon_sym_STAR,
    STATE(1223), 1,
      sym_string,
    STATE(1273), 1,
      sym_primary_expression,
    STATE(1459), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(795), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(791), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(785), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(779), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1449), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [61011] = 18,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    ACTIONS(2713), 1,
      sym_identifier,
    ACTIONS(2717), 1,
      anon_sym_type,
    ACTIONS(2719), 1,
      anon_sym_await,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(1967), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(1588), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2715), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1536), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [61090] = 16,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(758), 1,
      anon_sym_type,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_await,
    ACTIONS(2248), 1,
      anon_sym_STAR,
    STATE(1200), 1,
      sym_string,
    STATE(1217), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(756), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(77), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [61165] = 16,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(950), 1,
      anon_sym_type,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(962), 1,
      anon_sym_await,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(2410), 1,
      anon_sym_STAR,
    STATE(1488), 1,
      sym_string,
    STATE(1658), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(948), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(942), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [61240] = 16,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(950), 1,
      anon_sym_type,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(962), 1,
      anon_sym_await,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(2410), 1,
      anon_sym_STAR,
    STATE(1488), 1,
      sym_string,
    STATE(1652), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(948), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(942), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [61315] = 16,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(775), 1,
      anon_sym_type,
    ACTIONS(777), 1,
      anon_sym_await,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    STATE(1234), 1,
      sym_string,
    STATE(1336), 1,
      sym_primary_expression,
    STATE(1541), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(773), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [61390] = 16,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(775), 1,
      anon_sym_type,
    ACTIONS(777), 1,
      anon_sym_await,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    STATE(1234), 1,
      sym_string,
    STATE(1335), 1,
      sym_primary_expression,
    STATE(1541), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(773), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [61465] = 16,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(775), 1,
      anon_sym_type,
    ACTIONS(777), 1,
      anon_sym_await,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    STATE(1234), 1,
      sym_string,
    STATE(1334), 1,
      sym_primary_expression,
    STATE(1541), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(773), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [61540] = 16,
    ACTIONS(781), 1,
      anon_sym_LPAREN,
    ACTIONS(787), 1,
      anon_sym_type,
    ACTIONS(789), 1,
      anon_sym_LBRACK,
    ACTIONS(793), 1,
      anon_sym_LBRACE,
    ACTIONS(797), 1,
      anon_sym_await,
    ACTIONS(799), 1,
      sym_string_start,
    ACTIONS(1792), 1,
      anon_sym_STAR,
    STATE(1223), 1,
      sym_string,
    STATE(1272), 1,
      sym_primary_expression,
    STATE(1459), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(795), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(791), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(785), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(779), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1449), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [61615] = 16,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(775), 1,
      anon_sym_type,
    ACTIONS(777), 1,
      anon_sym_await,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    STATE(1234), 1,
      sym_string,
    STATE(1333), 1,
      sym_primary_expression,
    STATE(1541), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(773), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [61690] = 18,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    ACTIONS(2685), 1,
      anon_sym_type,
    ACTIONS(2687), 1,
      anon_sym_await,
    ACTIONS(2721), 1,
      sym_identifier,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(1979), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(1039), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2683), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1536), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [61769] = 16,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(775), 1,
      anon_sym_type,
    ACTIONS(777), 1,
      anon_sym_await,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    STATE(1234), 1,
      sym_string,
    STATE(1332), 1,
      sym_primary_expression,
    STATE(1541), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(773), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [61844] = 16,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(775), 1,
      anon_sym_type,
    ACTIONS(777), 1,
      anon_sym_await,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    STATE(1234), 1,
      sym_string,
    STATE(1331), 1,
      sym_primary_expression,
    STATE(1541), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(773), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [61919] = 16,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(775), 1,
      anon_sym_type,
    ACTIONS(777), 1,
      anon_sym_await,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    STATE(1234), 1,
      sym_string,
    STATE(1330), 1,
      sym_primary_expression,
    STATE(1541), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(773), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [61994] = 16,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(775), 1,
      anon_sym_type,
    ACTIONS(777), 1,
      anon_sym_await,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    STATE(1234), 1,
      sym_string,
    STATE(1329), 1,
      sym_primary_expression,
    STATE(1541), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(773), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(404), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1536), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [62069] = 16,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(758), 1,
      anon_sym_type,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_await,
    ACTIONS(2248), 1,
      anon_sym_STAR,
    STATE(1200), 1,
      sym_string,
    STATE(1210), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(756), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(77), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [62144] = 16,
    ACTIONS(876), 1,
      anon_sym_LPAREN,
    ACTIONS(882), 1,
      anon_sym_type,
    ACTIONS(884), 1,
      anon_sym_LBRACK,
    ACTIONS(888), 1,
      anon_sym_LBRACE,
    ACTIONS(892), 1,
      anon_sym_await,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(2218), 1,
      anon_sym_STAR,
    STATE(1245), 1,
      sym_string,
    STATE(1380), 1,
      sym_primary_expression,
    STATE(1641), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(890), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(886), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(880), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(874), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1642), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [62219] = 16,
    ACTIONS(920), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_type,
    ACTIONS(928), 1,
      anon_sym_LBRACK,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(936), 1,
      anon_sym_await,
    ACTIONS(938), 1,
      sym_string_start,
    ACTIONS(2200), 1,
      anon_sym_STAR,
    STATE(1279), 1,
      sym_string,
    STATE(1353), 1,
      sym_primary_expression,
    STATE(1590), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(934), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(930), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(924), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(918), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1654), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [62294] = 16,
    ACTIONS(920), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_type,
    ACTIONS(928), 1,
      anon_sym_LBRACK,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(936), 1,
      anon_sym_await,
    ACTIONS(938), 1,
      sym_string_start,
    ACTIONS(2200), 1,
      anon_sym_STAR,
    STATE(1279), 1,
      sym_string,
    STATE(1352), 1,
      sym_primary_expression,
    STATE(1590), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(934), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(930), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(924), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(918), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1654), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [62369] = 16,
    ACTIONS(920), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_type,
    ACTIONS(928), 1,
      anon_sym_LBRACK,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(936), 1,
      anon_sym_await,
    ACTIONS(938), 1,
      sym_string_start,
    ACTIONS(2200), 1,
      anon_sym_STAR,
    STATE(1279), 1,
      sym_string,
    STATE(1351), 1,
      sym_primary_expression,
    STATE(1590), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(934), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(930), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(924), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(918), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1654), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [62444] = 16,
    ACTIONS(920), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_type,
    ACTIONS(928), 1,
      anon_sym_LBRACK,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(936), 1,
      anon_sym_await,
    ACTIONS(938), 1,
      sym_string_start,
    ACTIONS(2200), 1,
      anon_sym_STAR,
    STATE(1279), 1,
      sym_string,
    STATE(1350), 1,
      sym_primary_expression,
    STATE(1590), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(934), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(930), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(924), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(918), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1654), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [62519] = 16,
    ACTIONS(830), 1,
      anon_sym_LPAREN,
    ACTIONS(836), 1,
      anon_sym_type,
    ACTIONS(840), 1,
      anon_sym_LBRACK,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(848), 1,
      anon_sym_await,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(2182), 1,
      anon_sym_STAR,
    STATE(1271), 1,
      sym_string,
    STATE(1325), 1,
      sym_primary_expression,
    STATE(1530), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(834), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(828), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1660), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [62594] = 16,
    ACTIONS(830), 1,
      anon_sym_LPAREN,
    ACTIONS(836), 1,
      anon_sym_type,
    ACTIONS(840), 1,
      anon_sym_LBRACK,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(848), 1,
      anon_sym_await,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(2182), 1,
      anon_sym_STAR,
    STATE(1271), 1,
      sym_string,
    STATE(1324), 1,
      sym_primary_expression,
    STATE(1530), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(834), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(828), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1660), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [62669] = 16,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(950), 1,
      anon_sym_type,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(962), 1,
      anon_sym_await,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(2410), 1,
      anon_sym_STAR,
    STATE(1488), 1,
      sym_string,
    STATE(1649), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(948), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(942), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [62744] = 16,
    ACTIONS(920), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_type,
    ACTIONS(928), 1,
      anon_sym_LBRACK,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(936), 1,
      anon_sym_await,
    ACTIONS(938), 1,
      sym_string_start,
    ACTIONS(2200), 1,
      anon_sym_STAR,
    STATE(1279), 1,
      sym_string,
    STATE(1391), 1,
      sym_primary_expression,
    STATE(1590), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(934), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(930), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(924), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(918), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1654), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [62819] = 16,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(950), 1,
      anon_sym_type,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(962), 1,
      anon_sym_await,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(2410), 1,
      anon_sym_STAR,
    STATE(1488), 1,
      sym_string,
    STATE(1644), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(948), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(942), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [62894] = 16,
    ACTIONS(781), 1,
      anon_sym_LPAREN,
    ACTIONS(787), 1,
      anon_sym_type,
    ACTIONS(789), 1,
      anon_sym_LBRACK,
    ACTIONS(793), 1,
      anon_sym_LBRACE,
    ACTIONS(797), 1,
      anon_sym_await,
    ACTIONS(799), 1,
      sym_string_start,
    ACTIONS(1792), 1,
      anon_sym_STAR,
    STATE(1223), 1,
      sym_string,
    STATE(1270), 1,
      sym_primary_expression,
    STATE(1459), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(795), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(791), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(785), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(779), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1449), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [62969] = 18,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    ACTIONS(2675), 1,
      anon_sym_await,
    ACTIONS(2691), 1,
      sym_identifier,
    ACTIONS(2695), 1,
      anon_sym_type,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(1987), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(1457), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2693), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1536), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [63048] = 18,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(775), 1,
      anon_sym_type,
    ACTIONS(777), 1,
      anon_sym_await,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    ACTIONS(2723), 1,
      sym_identifier,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(1988), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(1997), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(773), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1536), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [63127] = 18,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    ACTIONS(2661), 1,
      sym_identifier,
    ACTIONS(2665), 1,
      anon_sym_type,
    ACTIONS(2667), 1,
      anon_sym_await,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(1972), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(1736), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2663), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1536), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [63206] = 16,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(950), 1,
      anon_sym_type,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(962), 1,
      anon_sym_await,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(2410), 1,
      anon_sym_STAR,
    STATE(1488), 1,
      sym_string,
    STATE(1643), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(948), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(942), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [63281] = 16,
    ACTIONS(781), 1,
      anon_sym_LPAREN,
    ACTIONS(787), 1,
      anon_sym_type,
    ACTIONS(789), 1,
      anon_sym_LBRACK,
    ACTIONS(793), 1,
      anon_sym_LBRACE,
    ACTIONS(797), 1,
      anon_sym_await,
    ACTIONS(799), 1,
      sym_string_start,
    ACTIONS(1792), 1,
      anon_sym_STAR,
    STATE(1223), 1,
      sym_string,
    STATE(1269), 1,
      sym_primary_expression,
    STATE(1459), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(795), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(791), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(785), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(779), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1449), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [63356] = 16,
    ACTIONS(920), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_type,
    ACTIONS(928), 1,
      anon_sym_LBRACK,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(936), 1,
      anon_sym_await,
    ACTIONS(938), 1,
      sym_string_start,
    ACTIONS(2200), 1,
      anon_sym_STAR,
    STATE(1279), 1,
      sym_string,
    STATE(1342), 1,
      sym_primary_expression,
    STATE(1590), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(934), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(930), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(924), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(918), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1654), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [63431] = 16,
    ACTIONS(920), 1,
      anon_sym_LPAREN,
    ACTIONS(926), 1,
      anon_sym_type,
    ACTIONS(928), 1,
      anon_sym_LBRACK,
    ACTIONS(932), 1,
      anon_sym_LBRACE,
    ACTIONS(936), 1,
      anon_sym_await,
    ACTIONS(938), 1,
      sym_string_start,
    ACTIONS(2200), 1,
      anon_sym_STAR,
    STATE(1279), 1,
      sym_string,
    STATE(1340), 1,
      sym_primary_expression,
    STATE(1590), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(934), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(930), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(924), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(918), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1654), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [63506] = 18,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    ACTIONS(2709), 1,
      anon_sym_type,
    ACTIONS(2711), 1,
      anon_sym_await,
    ACTIONS(2725), 1,
      sym_identifier,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(1966), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(1390), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2707), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1536), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [63585] = 16,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(758), 1,
      anon_sym_type,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_await,
    ACTIONS(2248), 1,
      anon_sym_STAR,
    STATE(1200), 1,
      sym_string,
    STATE(1206), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(756), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(77), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [63660] = 18,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    ACTIONS(2727), 1,
      sym_identifier,
    ACTIONS(2731), 1,
      anon_sym_type,
    ACTIONS(2733), 1,
      anon_sym_await,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(1996), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(1794), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2729), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1536), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [63739] = 16,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(758), 1,
      anon_sym_type,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_await,
    ACTIONS(2248), 1,
      anon_sym_STAR,
    STATE(1200), 1,
      sym_string,
    STATE(1225), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(756), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(77), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [63814] = 16,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(758), 1,
      anon_sym_type,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_await,
    ACTIONS(2248), 1,
      anon_sym_STAR,
    STATE(1200), 1,
      sym_string,
    STATE(1214), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(756), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(77), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [63889] = 16,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(758), 1,
      anon_sym_type,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_await,
    ACTIONS(2248), 1,
      anon_sym_STAR,
    STATE(1200), 1,
      sym_string,
    STATE(1215), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(756), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(77), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [63964] = 16,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(758), 1,
      anon_sym_type,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_await,
    ACTIONS(2248), 1,
      anon_sym_STAR,
    STATE(1200), 1,
      sym_string,
    STATE(1211), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(756), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(77), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [64039] = 16,
    ACTIONS(830), 1,
      anon_sym_LPAREN,
    ACTIONS(836), 1,
      anon_sym_type,
    ACTIONS(840), 1,
      anon_sym_LBRACK,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(848), 1,
      anon_sym_await,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(2182), 1,
      anon_sym_STAR,
    STATE(1271), 1,
      sym_string,
    STATE(1375), 1,
      sym_primary_expression,
    STATE(1530), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(834), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(828), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1660), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [64114] = 16,
    ACTIONS(830), 1,
      anon_sym_LPAREN,
    ACTIONS(836), 1,
      anon_sym_type,
    ACTIONS(840), 1,
      anon_sym_LBRACK,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(848), 1,
      anon_sym_await,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(2182), 1,
      anon_sym_STAR,
    STATE(1271), 1,
      sym_string,
    STATE(1368), 1,
      sym_primary_expression,
    STATE(1530), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(834), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(828), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1660), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [64189] = 16,
    ACTIONS(830), 1,
      anon_sym_LPAREN,
    ACTIONS(836), 1,
      anon_sym_type,
    ACTIONS(840), 1,
      anon_sym_LBRACK,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(848), 1,
      anon_sym_await,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(2182), 1,
      anon_sym_STAR,
    STATE(1271), 1,
      sym_string,
    STATE(1366), 1,
      sym_primary_expression,
    STATE(1530), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(834), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(828), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1660), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [64264] = 16,
    ACTIONS(830), 1,
      anon_sym_LPAREN,
    ACTIONS(836), 1,
      anon_sym_type,
    ACTIONS(840), 1,
      anon_sym_LBRACK,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(848), 1,
      anon_sym_await,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(2182), 1,
      anon_sym_STAR,
    STATE(1271), 1,
      sym_string,
    STATE(1365), 1,
      sym_primary_expression,
    STATE(1530), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(834), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(828), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1660), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [64339] = 16,
    ACTIONS(830), 1,
      anon_sym_LPAREN,
    ACTIONS(836), 1,
      anon_sym_type,
    ACTIONS(840), 1,
      anon_sym_LBRACK,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(848), 1,
      anon_sym_await,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(2182), 1,
      anon_sym_STAR,
    STATE(1271), 1,
      sym_string,
    STATE(1364), 1,
      sym_primary_expression,
    STATE(1530), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(834), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(828), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1660), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [64414] = 16,
    ACTIONS(830), 1,
      anon_sym_LPAREN,
    ACTIONS(836), 1,
      anon_sym_type,
    ACTIONS(840), 1,
      anon_sym_LBRACK,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(848), 1,
      anon_sym_await,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(2182), 1,
      anon_sym_STAR,
    STATE(1271), 1,
      sym_string,
    STATE(1363), 1,
      sym_primary_expression,
    STATE(1530), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(834), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(828), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1660), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [64489] = 16,
    ACTIONS(830), 1,
      anon_sym_LPAREN,
    ACTIONS(836), 1,
      anon_sym_type,
    ACTIONS(840), 1,
      anon_sym_LBRACK,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(848), 1,
      anon_sym_await,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(2182), 1,
      anon_sym_STAR,
    STATE(1271), 1,
      sym_string,
    STATE(1362), 1,
      sym_primary_expression,
    STATE(1530), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(834), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(828), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1660), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [64564] = 16,
    ACTIONS(830), 1,
      anon_sym_LPAREN,
    ACTIONS(836), 1,
      anon_sym_type,
    ACTIONS(840), 1,
      anon_sym_LBRACK,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(848), 1,
      anon_sym_await,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(2182), 1,
      anon_sym_STAR,
    STATE(1271), 1,
      sym_string,
    STATE(1355), 1,
      sym_primary_expression,
    STATE(1530), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(846), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(842), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(834), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(828), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1660), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [64639] = 18,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    ACTIONS(2735), 1,
      sym_identifier,
    ACTIONS(2739), 1,
      anon_sym_type,
    ACTIONS(2741), 1,
      anon_sym_await,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(1977), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(1545), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2737), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1536), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [64718] = 16,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(758), 1,
      anon_sym_type,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_await,
    ACTIONS(2248), 1,
      anon_sym_STAR,
    STATE(1200), 1,
      sym_string,
    STATE(1213), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(756), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(77), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [64793] = 16,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(758), 1,
      anon_sym_type,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_await,
    ACTIONS(2248), 1,
      anon_sym_STAR,
    STATE(1200), 1,
      sym_string,
    STATE(1204), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(756), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(77), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [64868] = 16,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(758), 1,
      anon_sym_type,
    ACTIONS(760), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_await,
    ACTIONS(2248), 1,
      anon_sym_STAR,
    STATE(1200), 1,
      sym_string,
    STATE(1205), 1,
      sym_primary_expression,
    STATE(1314), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(65), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(756), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(77), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1312), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [64943] = 16,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(904), 1,
      anon_sym_type,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(914), 1,
      anon_sym_await,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    STATE(1337), 1,
      sym_string,
    STATE(1511), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(902), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(896), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [65018] = 16,
    ACTIONS(854), 1,
      anon_sym_LPAREN,
    ACTIONS(860), 1,
      anon_sym_type,
    ACTIONS(862), 1,
      anon_sym_LBRACK,
    ACTIONS(866), 1,
      anon_sym_LBRACE,
    ACTIONS(870), 1,
      anon_sym_await,
    ACTIONS(872), 1,
      sym_string_start,
    ACTIONS(2212), 1,
      anon_sym_STAR,
    STATE(1227), 1,
      sym_string,
    STATE(1241), 1,
      sym_primary_expression,
    STATE(1504), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(868), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(864), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(858), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(852), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [65093] = 16,
    ACTIONS(854), 1,
      anon_sym_LPAREN,
    ACTIONS(860), 1,
      anon_sym_type,
    ACTIONS(862), 1,
      anon_sym_LBRACK,
    ACTIONS(866), 1,
      anon_sym_LBRACE,
    ACTIONS(870), 1,
      anon_sym_await,
    ACTIONS(872), 1,
      sym_string_start,
    ACTIONS(2212), 1,
      anon_sym_STAR,
    STATE(1227), 1,
      sym_string,
    STATE(1267), 1,
      sym_primary_expression,
    STATE(1504), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(868), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(864), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(858), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(852), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [65168] = 18,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    ACTIONS(2739), 1,
      anon_sym_type,
    ACTIONS(2741), 1,
      anon_sym_await,
    ACTIONS(2743), 1,
      sym_identifier,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(1977), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(1545), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2737), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1536), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [65247] = 16,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(904), 1,
      anon_sym_type,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(914), 1,
      anon_sym_await,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    STATE(1337), 1,
      sym_string,
    STATE(1496), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(902), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(896), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [65322] = 16,
    ACTIONS(854), 1,
      anon_sym_LPAREN,
    ACTIONS(860), 1,
      anon_sym_type,
    ACTIONS(862), 1,
      anon_sym_LBRACK,
    ACTIONS(866), 1,
      anon_sym_LBRACE,
    ACTIONS(870), 1,
      anon_sym_await,
    ACTIONS(872), 1,
      sym_string_start,
    ACTIONS(2212), 1,
      anon_sym_STAR,
    STATE(1227), 1,
      sym_string,
    STATE(1255), 1,
      sym_primary_expression,
    STATE(1504), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(868), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(864), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(858), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(852), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [65397] = 16,
    ACTIONS(854), 1,
      anon_sym_LPAREN,
    ACTIONS(860), 1,
      anon_sym_type,
    ACTIONS(862), 1,
      anon_sym_LBRACK,
    ACTIONS(866), 1,
      anon_sym_LBRACE,
    ACTIONS(870), 1,
      anon_sym_await,
    ACTIONS(872), 1,
      sym_string_start,
    ACTIONS(2212), 1,
      anon_sym_STAR,
    STATE(1227), 1,
      sym_string,
    STATE(1283), 1,
      sym_primary_expression,
    STATE(1504), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(868), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(864), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(858), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(852), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [65472] = 16,
    ACTIONS(854), 1,
      anon_sym_LPAREN,
    ACTIONS(860), 1,
      anon_sym_type,
    ACTIONS(862), 1,
      anon_sym_LBRACK,
    ACTIONS(866), 1,
      anon_sym_LBRACE,
    ACTIONS(870), 1,
      anon_sym_await,
    ACTIONS(872), 1,
      sym_string_start,
    ACTIONS(2212), 1,
      anon_sym_STAR,
    STATE(1227), 1,
      sym_string,
    STATE(1242), 1,
      sym_primary_expression,
    STATE(1504), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(868), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(864), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(858), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(852), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [65547] = 16,
    ACTIONS(854), 1,
      anon_sym_LPAREN,
    ACTIONS(860), 1,
      anon_sym_type,
    ACTIONS(862), 1,
      anon_sym_LBRACK,
    ACTIONS(866), 1,
      anon_sym_LBRACE,
    ACTIONS(870), 1,
      anon_sym_await,
    ACTIONS(872), 1,
      sym_string_start,
    ACTIONS(2212), 1,
      anon_sym_STAR,
    STATE(1227), 1,
      sym_string,
    STATE(1282), 1,
      sym_primary_expression,
    STATE(1504), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(868), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(864), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(858), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(852), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [65622] = 16,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(904), 1,
      anon_sym_type,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(914), 1,
      anon_sym_await,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    STATE(1337), 1,
      sym_string,
    STATE(1505), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(902), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(896), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [65697] = 16,
    ACTIONS(854), 1,
      anon_sym_LPAREN,
    ACTIONS(860), 1,
      anon_sym_type,
    ACTIONS(862), 1,
      anon_sym_LBRACK,
    ACTIONS(866), 1,
      anon_sym_LBRACE,
    ACTIONS(870), 1,
      anon_sym_await,
    ACTIONS(872), 1,
      sym_string_start,
    ACTIONS(2212), 1,
      anon_sym_STAR,
    STATE(1227), 1,
      sym_string,
    STATE(1281), 1,
      sym_primary_expression,
    STATE(1504), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(868), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(864), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(858), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(852), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [65772] = 18,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    ACTIONS(2717), 1,
      anon_sym_type,
    ACTIONS(2719), 1,
      anon_sym_await,
    ACTIONS(2745), 1,
      sym_identifier,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(1991), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(1588), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2715), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1536), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [65851] = 16,
    ACTIONS(854), 1,
      anon_sym_LPAREN,
    ACTIONS(860), 1,
      anon_sym_type,
    ACTIONS(862), 1,
      anon_sym_LBRACK,
    ACTIONS(866), 1,
      anon_sym_LBRACE,
    ACTIONS(870), 1,
      anon_sym_await,
    ACTIONS(872), 1,
      sym_string_start,
    ACTIONS(2212), 1,
      anon_sym_STAR,
    STATE(1227), 1,
      sym_string,
    STATE(1251), 1,
      sym_primary_expression,
    STATE(1504), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(868), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(864), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(858), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(852), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [65926] = 16,
    ACTIONS(854), 1,
      anon_sym_LPAREN,
    ACTIONS(860), 1,
      anon_sym_type,
    ACTIONS(862), 1,
      anon_sym_LBRACK,
    ACTIONS(866), 1,
      anon_sym_LBRACE,
    ACTIONS(870), 1,
      anon_sym_await,
    ACTIONS(872), 1,
      sym_string_start,
    ACTIONS(2212), 1,
      anon_sym_STAR,
    STATE(1227), 1,
      sym_string,
    STATE(1249), 1,
      sym_primary_expression,
    STATE(1504), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(868), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(864), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(858), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(852), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [66001] = 16,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(904), 1,
      anon_sym_type,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(914), 1,
      anon_sym_await,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    STATE(1337), 1,
      sym_string,
    STATE(1512), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(902), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(896), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [66076] = 18,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    ACTIONS(2717), 1,
      anon_sym_type,
    ACTIONS(2719), 1,
      anon_sym_await,
    ACTIONS(2745), 1,
      sym_identifier,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(1967), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(1588), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2715), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1536), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [66155] = 18,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    ACTIONS(2747), 1,
      sym_identifier,
    ACTIONS(2751), 1,
      anon_sym_type,
    ACTIONS(2753), 1,
      anon_sym_await,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(1977), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(1973), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2749), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1536), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [66234] = 16,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(904), 1,
      anon_sym_type,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(914), 1,
      anon_sym_await,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    STATE(1337), 1,
      sym_string,
    STATE(1508), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(902), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(896), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [66309] = 16,
    ACTIONS(854), 1,
      anon_sym_LPAREN,
    ACTIONS(860), 1,
      anon_sym_type,
    ACTIONS(862), 1,
      anon_sym_LBRACK,
    ACTIONS(866), 1,
      anon_sym_LBRACE,
    ACTIONS(870), 1,
      anon_sym_await,
    ACTIONS(872), 1,
      sym_string_start,
    ACTIONS(2212), 1,
      anon_sym_STAR,
    STATE(1227), 1,
      sym_string,
    STATE(1238), 1,
      sym_primary_expression,
    STATE(1504), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(868), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(864), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(858), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(852), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1477), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [66384] = 16,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(904), 1,
      anon_sym_type,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(914), 1,
      anon_sym_await,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    STATE(1337), 1,
      sym_string,
    STATE(1465), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(902), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(896), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [66459] = 16,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(904), 1,
      anon_sym_type,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(914), 1,
      anon_sym_await,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    STATE(1337), 1,
      sym_string,
    STATE(1510), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(902), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(896), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [66534] = 5,
    ACTIONS(2759), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1190), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2757), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2755), 33,
      sym__dedent,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_config,
      anon_sym_meta_wrapper,
      anon_sym_prefix,
      anon_sym_skip_validation,
      anon_sym_snakefile,
  [66587] = 18,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    ACTIONS(2667), 1,
      anon_sym_await,
    ACTIONS(2762), 1,
      sym_identifier,
    ACTIONS(2766), 1,
      anon_sym_type,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(1964), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(1592), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2764), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1536), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [66666] = 18,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    ACTIONS(2719), 1,
      anon_sym_await,
    ACTIONS(2768), 1,
      sym_identifier,
    ACTIONS(2772), 1,
      anon_sym_type,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(1991), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(1636), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2770), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1536), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [66745] = 16,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(950), 1,
      anon_sym_type,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(962), 1,
      anon_sym_await,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(2410), 1,
      anon_sym_STAR,
    STATE(1488), 1,
      sym_string,
    STATE(1685), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(948), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(942), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [66820] = 18,
    ACTIONS(391), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(492), 1,
      anon_sym_LPAREN,
    ACTIONS(496), 1,
      anon_sym_LBRACK,
    ACTIONS(2354), 1,
      anon_sym_STAR,
    ACTIONS(2774), 1,
      sym_identifier,
    ACTIONS(2778), 1,
      anon_sym_type,
    ACTIONS(2780), 1,
      anon_sym_await,
    STATE(1234), 1,
      sym_string,
    STATE(1541), 1,
      sym_list_splat_pattern,
    STATE(1991), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(402), 2,
      sym_ellipsis,
      sym_float,
    STATE(1959), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(396), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(404), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(2776), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    STATE(1536), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [66899] = 16,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(904), 1,
      anon_sym_type,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(914), 1,
      anon_sym_await,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    STATE(1337), 1,
      sym_string,
    STATE(1514), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(902), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(896), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [66974] = 16,
    ACTIONS(781), 1,
      anon_sym_LPAREN,
    ACTIONS(787), 1,
      anon_sym_type,
    ACTIONS(789), 1,
      anon_sym_LBRACK,
    ACTIONS(793), 1,
      anon_sym_LBRACE,
    ACTIONS(797), 1,
      anon_sym_await,
    ACTIONS(799), 1,
      sym_string_start,
    ACTIONS(1792), 1,
      anon_sym_STAR,
    STATE(1223), 1,
      sym_string,
    STATE(1243), 1,
      sym_primary_expression,
    STATE(1459), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(795), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(791), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(785), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(779), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1449), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [67049] = 16,
    ACTIONS(944), 1,
      anon_sym_LPAREN,
    ACTIONS(950), 1,
      anon_sym_type,
    ACTIONS(954), 1,
      anon_sym_LBRACK,
    ACTIONS(958), 1,
      anon_sym_LBRACE,
    ACTIONS(962), 1,
      anon_sym_await,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(2410), 1,
      anon_sym_STAR,
    STATE(1488), 1,
      sym_string,
    STATE(1701), 1,
      sym_primary_expression,
    STATE(1761), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(960), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(956), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(948), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(942), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1780), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [67124] = 16,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(904), 1,
      anon_sym_type,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(914), 1,
      anon_sym_await,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    STATE(1337), 1,
      sym_string,
    STATE(1515), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(902), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(896), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [67199] = 16,
    ACTIONS(898), 1,
      anon_sym_LPAREN,
    ACTIONS(904), 1,
      anon_sym_type,
    ACTIONS(906), 1,
      anon_sym_LBRACK,
    ACTIONS(910), 1,
      anon_sym_LBRACE,
    ACTIONS(914), 1,
      anon_sym_await,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(2258), 1,
      anon_sym_STAR,
    STATE(1337), 1,
      sym_string,
    STATE(1519), 1,
      sym_primary_expression,
    STATE(1756), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(912), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(908), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(902), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
    ACTIONS(896), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(1752), 16,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
      sym_await,
  [67274] = 5,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1202), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2481), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2476), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [67326] = 5,
    ACTIONS(2782), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1201), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2757), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2755), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [67378] = 5,
    ACTIONS(97), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1201), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2679), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2677), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [67430] = 20,
    ACTIONS(2787), 1,
      anon_sym_DOT,
    ACTIONS(2789), 1,
      anon_sym_LPAREN,
    ACTIONS(2797), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2799), 1,
      anon_sym_EQ,
    ACTIONS(2801), 1,
      anon_sym_LBRACK,
    ACTIONS(2807), 1,
      anon_sym_PIPE,
    ACTIONS(2809), 1,
      anon_sym_not,
    ACTIONS(2811), 1,
      anon_sym_AMP,
    ACTIONS(2813), 1,
      anon_sym_CARET,
    ACTIONS(2817), 1,
      anon_sym_is,
    STATE(1930), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2791), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2793), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2805), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2815), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1382), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2803), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2795), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2785), 9,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
  [67512] = 11,
    ACTIONS(2787), 1,
      anon_sym_DOT,
    ACTIONS(2789), 1,
      anon_sym_LPAREN,
    ACTIONS(2797), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2801), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2791), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2805), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1382), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2803), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2821), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2819), 22,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [67575] = 8,
    ACTIONS(2787), 1,
      anon_sym_DOT,
    ACTIONS(2789), 1,
      anon_sym_LPAREN,
    ACTIONS(2797), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2801), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1382), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2821), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2819), 27,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [67632] = 12,
    ACTIONS(2787), 1,
      anon_sym_DOT,
    ACTIONS(2789), 1,
      anon_sym_LPAREN,
    ACTIONS(2797), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2801), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2791), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2793), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2805), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1382), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2803), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2821), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2819), 20,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [67697] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2825), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2823), 34,
      sym__dedent,
      sym_string_start,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_config,
      anon_sym_meta_wrapper,
      anon_sym_prefix,
      anon_sym_skip_validation,
      anon_sym_snakefile,
  [67744] = 14,
    ACTIONS(2833), 1,
      anon_sym_run,
    ACTIONS(2835), 1,
      sym__dedent,
    ACTIONS(2837), 1,
      sym_string_start,
    STATE(491), 1,
      sym_rule_body,
    STATE(1814), 1,
      sym_string,
    STATE(1847), 1,
      sym__rule_directive_wc_def,
    STATE(1848), 1,
      sym__rule_directive_wc_interp,
    STATE(1852), 1,
      sym__rule_directive_wc_none,
    STATE(1853), 1,
      sym__rule_directive_block,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1262), 2,
      sym_concatenated_string,
      aux_sym_rule_body_repeat1,
    ACTIONS(2829), 4,
      anon_sym_benchmark,
      anon_sym_input,
      anon_sym_log,
      anon_sym_output,
    ACTIONS(2831), 4,
      anon_sym_message,
      anon_sym_notebook,
      anon_sym_script,
      anon_sym_shell,
    ACTIONS(2827), 19,
      anon_sym_container,
      anon_sym_wildcard_constraints,
      anon_sym_cache,
      anon_sym_conda,
      anon_sym_cwl,
      anon_sym_default_target,
      anon_sym_envmodules,
      anon_sym_group,
      anon_sym_handover,
      anon_sym_localrule,
      anon_sym_params,
      anon_sym_priority,
      anon_sym_resources,
      anon_sym_retries,
      anon_sym_shadow,
      anon_sym_singularity,
      anon_sym_template_engine,
      anon_sym_threads,
      anon_sym_wrapper,
  [67813] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2841), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2839), 34,
      sym__dedent,
      sym_string_start,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_config,
      anon_sym_meta_wrapper,
      anon_sym_prefix,
      anon_sym_skip_validation,
      anon_sym_snakefile,
  [67860] = 15,
    ACTIONS(2787), 1,
      anon_sym_DOT,
    ACTIONS(2789), 1,
      anon_sym_LPAREN,
    ACTIONS(2797), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2801), 1,
      anon_sym_LBRACK,
    ACTIONS(2807), 1,
      anon_sym_PIPE,
    ACTIONS(2811), 1,
      anon_sym_AMP,
    ACTIONS(2813), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2791), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2793), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2805), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1382), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2803), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2845), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2843), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [67931] = 8,
    ACTIONS(2787), 1,
      anon_sym_DOT,
    ACTIONS(2789), 1,
      anon_sym_LPAREN,
    ACTIONS(2797), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2801), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1382), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2821), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2819), 27,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [67988] = 15,
    ACTIONS(2787), 1,
      anon_sym_DOT,
    ACTIONS(2789), 1,
      anon_sym_LPAREN,
    ACTIONS(2797), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2801), 1,
      anon_sym_LBRACK,
    ACTIONS(2807), 1,
      anon_sym_PIPE,
    ACTIONS(2811), 1,
      anon_sym_AMP,
    ACTIONS(2813), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2791), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2793), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2805), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1382), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2803), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2849), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2847), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68059] = 15,
    ACTIONS(2787), 1,
      anon_sym_DOT,
    ACTIONS(2789), 1,
      anon_sym_LPAREN,
    ACTIONS(2797), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2801), 1,
      anon_sym_LBRACK,
    ACTIONS(2807), 1,
      anon_sym_PIPE,
    ACTIONS(2811), 1,
      anon_sym_AMP,
    ACTIONS(2813), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2791), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2793), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2805), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1382), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2803), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2853), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2851), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68130] = 14,
    ACTIONS(2787), 1,
      anon_sym_DOT,
    ACTIONS(2789), 1,
      anon_sym_LPAREN,
    ACTIONS(2797), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2801), 1,
      anon_sym_LBRACK,
    ACTIONS(2811), 1,
      anon_sym_AMP,
    ACTIONS(2813), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2791), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2793), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2805), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1382), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2803), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2821), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2819), 18,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68199] = 10,
    ACTIONS(2787), 1,
      anon_sym_DOT,
    ACTIONS(2789), 1,
      anon_sym_LPAREN,
    ACTIONS(2797), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2801), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2791), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1382), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2803), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2821), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2819), 24,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68260] = 5,
    ACTIONS(872), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1219), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2679), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2677), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68311] = 8,
    ACTIONS(2787), 1,
      anon_sym_DOT,
    ACTIONS(2789), 1,
      anon_sym_LPAREN,
    ACTIONS(2797), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2801), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1382), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2857), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2855), 27,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68368] = 8,
    ACTIONS(2787), 1,
      anon_sym_DOT,
    ACTIONS(2789), 1,
      anon_sym_LPAREN,
    ACTIONS(2797), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2801), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1382), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2861), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2859), 27,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68425] = 5,
    ACTIONS(2863), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1219), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2757), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2755), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68476] = 20,
    ACTIONS(2799), 1,
      anon_sym_as,
    ACTIONS(2866), 1,
      anon_sym_DOT,
    ACTIONS(2868), 1,
      anon_sym_LPAREN,
    ACTIONS(2876), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2878), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_PIPE,
    ACTIONS(2886), 1,
      anon_sym_not,
    ACTIONS(2888), 1,
      anon_sym_AMP,
    ACTIONS(2890), 1,
      anon_sym_CARET,
    ACTIONS(2894), 1,
      anon_sym_is,
    STATE(1944), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2870), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2872), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2882), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2892), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1513), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2880), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2874), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2785), 8,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
  [68557] = 20,
    ACTIONS(2799), 1,
      anon_sym_EQ,
    ACTIONS(2896), 1,
      anon_sym_DOT,
    ACTIONS(2898), 1,
      anon_sym_LPAREN,
    ACTIONS(2906), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2908), 1,
      anon_sym_LBRACK,
    ACTIONS(2914), 1,
      anon_sym_PIPE,
    ACTIONS(2916), 1,
      anon_sym_not,
    ACTIONS(2918), 1,
      anon_sym_AMP,
    ACTIONS(2920), 1,
      anon_sym_CARET,
    ACTIONS(2924), 1,
      anon_sym_is,
    STATE(1946), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2900), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2902), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2912), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2922), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1428), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2910), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2904), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2785), 8,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      sym_type_conversion,
  [68638] = 5,
    ACTIONS(799), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1226), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2679), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2677), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [68689] = 5,
    ACTIONS(799), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1222), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2481), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2476), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [68740] = 14,
    ACTIONS(2833), 1,
      anon_sym_run,
    ACTIONS(2837), 1,
      sym_string_start,
    ACTIONS(2926), 1,
      sym__dedent,
    STATE(511), 1,
      sym_rule_body,
    STATE(1814), 1,
      sym_string,
    STATE(1847), 1,
      sym__rule_directive_wc_def,
    STATE(1848), 1,
      sym__rule_directive_wc_interp,
    STATE(1852), 1,
      sym__rule_directive_wc_none,
    STATE(1853), 1,
      sym__rule_directive_block,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1263), 2,
      sym_concatenated_string,
      aux_sym_rule_body_repeat1,
    ACTIONS(2829), 4,
      anon_sym_benchmark,
      anon_sym_input,
      anon_sym_log,
      anon_sym_output,
    ACTIONS(2831), 4,
      anon_sym_message,
      anon_sym_notebook,
      anon_sym_script,
      anon_sym_shell,
    ACTIONS(2827), 19,
      anon_sym_container,
      anon_sym_wildcard_constraints,
      anon_sym_cache,
      anon_sym_conda,
      anon_sym_cwl,
      anon_sym_default_target,
      anon_sym_envmodules,
      anon_sym_group,
      anon_sym_handover,
      anon_sym_localrule,
      anon_sym_params,
      anon_sym_priority,
      anon_sym_resources,
      anon_sym_retries,
      anon_sym_shadow,
      anon_sym_singularity,
      anon_sym_template_engine,
      anon_sym_threads,
      anon_sym_wrapper,
  [68809] = 13,
    ACTIONS(2787), 1,
      anon_sym_DOT,
    ACTIONS(2789), 1,
      anon_sym_LPAREN,
    ACTIONS(2797), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2801), 1,
      anon_sym_LBRACK,
    ACTIONS(2813), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2791), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2793), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2805), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1382), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2803), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2821), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2819), 19,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68876] = 5,
    ACTIONS(2928), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1226), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2757), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2755), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [68927] = 5,
    ACTIONS(872), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1216), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2481), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2476), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [68978] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2496), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2494), 31,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [69024] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2841), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2839), 32,
      sym__newline,
      sym_string_start,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [69070] = 15,
    ACTIONS(2896), 1,
      anon_sym_DOT,
    ACTIONS(2898), 1,
      anon_sym_LPAREN,
    ACTIONS(2906), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2908), 1,
      anon_sym_LBRACK,
    ACTIONS(2914), 1,
      anon_sym_PIPE,
    ACTIONS(2918), 1,
      anon_sym_AMP,
    ACTIONS(2920), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2900), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2902), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2912), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1428), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2845), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2910), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2843), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [69140] = 15,
    ACTIONS(2896), 1,
      anon_sym_DOT,
    ACTIONS(2898), 1,
      anon_sym_LPAREN,
    ACTIONS(2906), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2908), 1,
      anon_sym_LBRACK,
    ACTIONS(2914), 1,
      anon_sym_PIPE,
    ACTIONS(2918), 1,
      anon_sym_AMP,
    ACTIONS(2920), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2900), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2902), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2912), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1428), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2849), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2910), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2847), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [69210] = 5,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1256), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2679), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2677), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [69260] = 20,
    ACTIONS(2799), 1,
      anon_sym_EQ,
    ACTIONS(2931), 1,
      anon_sym_DOT,
    ACTIONS(2933), 1,
      anon_sym_LPAREN,
    ACTIONS(2941), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2943), 1,
      anon_sym_LBRACK,
    ACTIONS(2949), 1,
      anon_sym_PIPE,
    ACTIONS(2951), 1,
      anon_sym_not,
    ACTIONS(2953), 1,
      anon_sym_AMP,
    ACTIONS(2955), 1,
      anon_sym_CARET,
    ACTIONS(2959), 1,
      anon_sym_is,
    STATE(1936), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2935), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2937), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2947), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2957), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1585), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2945), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2939), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2785), 7,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_and,
      anon_sym_or,
  [69340] = 5,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1258), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2481), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2476), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [69390] = 4,
    ACTIONS(376), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(361), 30,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [69438] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2525), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2523), 31,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [69484] = 19,
    ACTIONS(2789), 1,
      anon_sym_LPAREN,
    ACTIONS(2797), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2807), 1,
      anon_sym_PIPE,
    ACTIONS(2809), 1,
      anon_sym_not,
    ACTIONS(2811), 1,
      anon_sym_AMP,
    ACTIONS(2813), 1,
      anon_sym_CARET,
    ACTIONS(2817), 1,
      anon_sym_is,
    ACTIONS(2961), 1,
      anon_sym_DOT,
    ACTIONS(2963), 1,
      anon_sym_LBRACK,
    STATE(1930), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2791), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2793), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2805), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2815), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1382), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2803), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2795), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2785), 8,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
  [69562] = 15,
    ACTIONS(2866), 1,
      anon_sym_DOT,
    ACTIONS(2868), 1,
      anon_sym_LPAREN,
    ACTIONS(2876), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2878), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_PIPE,
    ACTIONS(2888), 1,
      anon_sym_AMP,
    ACTIONS(2890), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2870), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2872), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2882), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1513), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2849), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2880), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2847), 16,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [69632] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2496), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2494), 31,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [69678] = 5,
    ACTIONS(2965), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1240), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2757), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2755), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [69728] = 15,
    ACTIONS(2866), 1,
      anon_sym_DOT,
    ACTIONS(2868), 1,
      anon_sym_LPAREN,
    ACTIONS(2876), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2878), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_PIPE,
    ACTIONS(2888), 1,
      anon_sym_AMP,
    ACTIONS(2890), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2870), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2872), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2882), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1513), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2845), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2880), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2843), 16,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [69798] = 15,
    ACTIONS(2866), 1,
      anon_sym_DOT,
    ACTIONS(2868), 1,
      anon_sym_LPAREN,
    ACTIONS(2876), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2878), 1,
      anon_sym_LBRACK,
    ACTIONS(2884), 1,
      anon_sym_PIPE,
    ACTIONS(2888), 1,
      anon_sym_AMP,
    ACTIONS(2890), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2870), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2872), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2882), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1513), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2853), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2880), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2851), 16,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [69868] = 8,
    ACTIONS(2896), 1,
      anon_sym_DOT,
    ACTIONS(2898), 1,
      anon_sym_LPAREN,
    ACTIONS(2906), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2908), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1428), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2857), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2855), 26,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [69924] = 8,
    ACTIONS(2896), 1,
      anon_sym_DOT,
    ACTIONS(2898), 1,
      anon_sym_LPAREN,
    ACTIONS(2906), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2908), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1428), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2861), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2859), 26,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [69980] = 5,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1265), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2481), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2476), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [70030] = 8,
    ACTIONS(2866), 1,
      anon_sym_DOT,
    ACTIONS(2868), 1,
      anon_sym_LPAREN,
    ACTIONS(2876), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2878), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1513), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2861), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2859), 26,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [70086] = 4,
    ACTIONS(2483), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2481), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2476), 30,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [70134] = 13,
    ACTIONS(2977), 1,
      anon_sym_run,
    ACTIONS(2980), 1,
      sym__dedent,
    ACTIONS(2982), 1,
      sym_string_start,
    STATE(1814), 1,
      sym_string,
    STATE(1847), 1,
      sym__rule_directive_wc_def,
    STATE(1848), 1,
      sym__rule_directive_wc_interp,
    STATE(1852), 1,
      sym__rule_directive_wc_none,
    STATE(1853), 1,
      sym__rule_directive_block,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1248), 2,
      sym_concatenated_string,
      aux_sym_rule_body_repeat1,
    ACTIONS(2971), 4,
      anon_sym_benchmark,
      anon_sym_input,
      anon_sym_log,
      anon_sym_output,
    ACTIONS(2974), 4,
      anon_sym_message,
      anon_sym_notebook,
      anon_sym_script,
      anon_sym_shell,
    ACTIONS(2968), 19,
      anon_sym_container,
      anon_sym_wildcard_constraints,
      anon_sym_cache,
      anon_sym_conda,
      anon_sym_cwl,
      anon_sym_default_target,
      anon_sym_envmodules,
      anon_sym_group,
      anon_sym_handover,
      anon_sym_localrule,
      anon_sym_params,
      anon_sym_priority,
      anon_sym_resources,
      anon_sym_retries,
      anon_sym_shadow,
      anon_sym_singularity,
      anon_sym_template_engine,
      anon_sym_threads,
      anon_sym_wrapper,
  [70200] = 12,
    ACTIONS(2866), 1,
      anon_sym_DOT,
    ACTIONS(2868), 1,
      anon_sym_LPAREN,
    ACTIONS(2876), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2878), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2870), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2872), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2882), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1513), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2821), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2880), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2819), 19,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [70264] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2514), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2512), 31,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [70310] = 13,
    ACTIONS(2866), 1,
      anon_sym_DOT,
    ACTIONS(2868), 1,
      anon_sym_LPAREN,
    ACTIONS(2876), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2878), 1,
      anon_sym_LBRACK,
    ACTIONS(2890), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2870), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2872), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2882), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1513), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2821), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2880), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2819), 18,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [70376] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2825), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2823), 32,
      sym__newline,
      sym_string_start,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [70422] = 20,
    ACTIONS(2799), 1,
      anon_sym_EQ,
    ACTIONS(2985), 1,
      anon_sym_DOT,
    ACTIONS(2987), 1,
      anon_sym_LPAREN,
    ACTIONS(2995), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2997), 1,
      anon_sym_LBRACK,
    ACTIONS(3003), 1,
      anon_sym_PIPE,
    ACTIONS(3005), 1,
      anon_sym_not,
    ACTIONS(3007), 1,
      anon_sym_AMP,
    ACTIONS(3009), 1,
      anon_sym_CARET,
    ACTIONS(3013), 1,
      anon_sym_is,
    STATE(1935), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2989), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2991), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3001), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3011), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1683), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2999), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2993), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2785), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
  [70502] = 5,
    ACTIONS(938), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1240), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2679), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2677), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [70552] = 8,
    ACTIONS(2866), 1,
      anon_sym_DOT,
    ACTIONS(2868), 1,
      anon_sym_LPAREN,
    ACTIONS(2876), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2878), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1513), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2857), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2855), 26,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [70608] = 5,
    ACTIONS(3015), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1256), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2757), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2755), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [70658] = 4,
    ACTIONS(376), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(361), 30,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [70706] = 5,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1277), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2679), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2677), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [70756] = 14,
    ACTIONS(2866), 1,
      anon_sym_DOT,
    ACTIONS(2868), 1,
      anon_sym_LPAREN,
    ACTIONS(2876), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2878), 1,
      anon_sym_LBRACK,
    ACTIONS(2888), 1,
      anon_sym_AMP,
    ACTIONS(2890), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2870), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2872), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2882), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1513), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2821), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2880), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2819), 17,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [70824] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2514), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2512), 31,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [70870] = 5,
    ACTIONS(3018), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1261), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2757), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2755), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [70920] = 13,
    ACTIONS(2833), 1,
      anon_sym_run,
    ACTIONS(2837), 1,
      sym_string_start,
    ACTIONS(3021), 1,
      sym__dedent,
    STATE(1814), 1,
      sym_string,
    STATE(1847), 1,
      sym__rule_directive_wc_def,
    STATE(1848), 1,
      sym__rule_directive_wc_interp,
    STATE(1852), 1,
      sym__rule_directive_wc_none,
    STATE(1853), 1,
      sym__rule_directive_block,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1248), 2,
      sym_concatenated_string,
      aux_sym_rule_body_repeat1,
    ACTIONS(2829), 4,
      anon_sym_benchmark,
      anon_sym_input,
      anon_sym_log,
      anon_sym_output,
    ACTIONS(2831), 4,
      anon_sym_message,
      anon_sym_notebook,
      anon_sym_script,
      anon_sym_shell,
    ACTIONS(2827), 19,
      anon_sym_container,
      anon_sym_wildcard_constraints,
      anon_sym_cache,
      anon_sym_conda,
      anon_sym_cwl,
      anon_sym_default_target,
      anon_sym_envmodules,
      anon_sym_group,
      anon_sym_handover,
      anon_sym_localrule,
      anon_sym_params,
      anon_sym_priority,
      anon_sym_resources,
      anon_sym_retries,
      anon_sym_shadow,
      anon_sym_singularity,
      anon_sym_template_engine,
      anon_sym_threads,
      anon_sym_wrapper,
  [70986] = 13,
    ACTIONS(2833), 1,
      anon_sym_run,
    ACTIONS(2837), 1,
      sym_string_start,
    ACTIONS(3023), 1,
      sym__dedent,
    STATE(1814), 1,
      sym_string,
    STATE(1847), 1,
      sym__rule_directive_wc_def,
    STATE(1848), 1,
      sym__rule_directive_wc_interp,
    STATE(1852), 1,
      sym__rule_directive_wc_none,
    STATE(1853), 1,
      sym__rule_directive_block,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1248), 2,
      sym_concatenated_string,
      aux_sym_rule_body_repeat1,
    ACTIONS(2829), 4,
      anon_sym_benchmark,
      anon_sym_input,
      anon_sym_log,
      anon_sym_output,
    ACTIONS(2831), 4,
      anon_sym_message,
      anon_sym_notebook,
      anon_sym_script,
      anon_sym_shell,
    ACTIONS(2827), 19,
      anon_sym_container,
      anon_sym_wildcard_constraints,
      anon_sym_cache,
      anon_sym_conda,
      anon_sym_cwl,
      anon_sym_default_target,
      anon_sym_envmodules,
      anon_sym_group,
      anon_sym_handover,
      anon_sym_localrule,
      anon_sym_params,
      anon_sym_priority,
      anon_sym_resources,
      anon_sym_retries,
      anon_sym_shadow,
      anon_sym_singularity,
      anon_sym_template_engine,
      anon_sym_threads,
      anon_sym_wrapper,
  [71052] = 20,
    ACTIONS(2799), 1,
      anon_sym_as,
    ACTIONS(3025), 1,
      anon_sym_DOT,
    ACTIONS(3027), 1,
      anon_sym_LPAREN,
    ACTIONS(3035), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3037), 1,
      anon_sym_LBRACK,
    ACTIONS(3043), 1,
      anon_sym_PIPE,
    ACTIONS(3045), 1,
      anon_sym_not,
    ACTIONS(3047), 1,
      anon_sym_AMP,
    ACTIONS(3049), 1,
      anon_sym_CARET,
    ACTIONS(3053), 1,
      anon_sym_is,
    STATE(1952), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3029), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3031), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3041), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3051), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1629), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(3039), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(3033), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2785), 7,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [71132] = 5,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1261), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2679), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2677), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [71182] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2551), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2549), 31,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [71228] = 8,
    ACTIONS(2866), 1,
      anon_sym_DOT,
    ACTIONS(2868), 1,
      anon_sym_LPAREN,
    ACTIONS(2876), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2878), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1513), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2821), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2819), 26,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [71284] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2555), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2553), 31,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [71330] = 8,
    ACTIONS(2896), 1,
      anon_sym_DOT,
    ACTIONS(2898), 1,
      anon_sym_LPAREN,
    ACTIONS(2906), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2908), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1428), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2821), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2819), 26,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [71386] = 11,
    ACTIONS(2896), 1,
      anon_sym_DOT,
    ACTIONS(2898), 1,
      anon_sym_LPAREN,
    ACTIONS(2906), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2908), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2900), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2912), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1428), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2821), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2910), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2819), 21,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [71448] = 5,
    ACTIONS(850), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1232), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2481), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2476), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [71498] = 15,
    ACTIONS(2896), 1,
      anon_sym_DOT,
    ACTIONS(2898), 1,
      anon_sym_LPAREN,
    ACTIONS(2906), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2908), 1,
      anon_sym_LBRACK,
    ACTIONS(2914), 1,
      anon_sym_PIPE,
    ACTIONS(2918), 1,
      anon_sym_AMP,
    ACTIONS(2920), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2900), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2902), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2912), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1428), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2853), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2910), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2851), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [71568] = 8,
    ACTIONS(2896), 1,
      anon_sym_DOT,
    ACTIONS(2898), 1,
      anon_sym_LPAREN,
    ACTIONS(2906), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2908), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1428), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2821), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2819), 26,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [71624] = 10,
    ACTIONS(2896), 1,
      anon_sym_DOT,
    ACTIONS(2898), 1,
      anon_sym_LPAREN,
    ACTIONS(2906), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2908), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2900), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1428), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2821), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2910), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2819), 23,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [71684] = 20,
    ACTIONS(2799), 1,
      anon_sym_as,
    ACTIONS(3055), 1,
      anon_sym_DOT,
    ACTIONS(3057), 1,
      anon_sym_LPAREN,
    ACTIONS(3065), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3067), 1,
      anon_sym_LBRACK,
    ACTIONS(3073), 1,
      anon_sym_PIPE,
    ACTIONS(3075), 1,
      anon_sym_not,
    ACTIONS(3077), 1,
      anon_sym_AMP,
    ACTIONS(3079), 1,
      anon_sym_CARET,
    ACTIONS(3083), 1,
      anon_sym_is,
    STATE(1957), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3059), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3061), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3071), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3081), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1533), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(3069), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(3063), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2785), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_and,
      anon_sym_or,
  [71764] = 14,
    ACTIONS(2896), 1,
      anon_sym_DOT,
    ACTIONS(2898), 1,
      anon_sym_LPAREN,
    ACTIONS(2906), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2908), 1,
      anon_sym_LBRACK,
    ACTIONS(2918), 1,
      anon_sym_AMP,
    ACTIONS(2920), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2900), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2902), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2912), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1428), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2821), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2910), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2819), 17,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [71832] = 5,
    ACTIONS(3085), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1277), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2757), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2755), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [71882] = 13,
    ACTIONS(2896), 1,
      anon_sym_DOT,
    ACTIONS(2898), 1,
      anon_sym_LPAREN,
    ACTIONS(2906), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2908), 1,
      anon_sym_LBRACK,
    ACTIONS(2920), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2900), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2902), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2912), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1428), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2821), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2910), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2819), 18,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [71948] = 5,
    ACTIONS(938), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1254), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2481), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2476), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [71998] = 12,
    ACTIONS(2896), 1,
      anon_sym_DOT,
    ACTIONS(2898), 1,
      anon_sym_LPAREN,
    ACTIONS(2906), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2908), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2900), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2902), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2912), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1428), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2821), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2910), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2819), 19,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [72062] = 10,
    ACTIONS(2866), 1,
      anon_sym_DOT,
    ACTIONS(2868), 1,
      anon_sym_LPAREN,
    ACTIONS(2876), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2878), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2870), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1513), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2821), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2880), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2819), 23,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72122] = 8,
    ACTIONS(2866), 1,
      anon_sym_DOT,
    ACTIONS(2868), 1,
      anon_sym_LPAREN,
    ACTIONS(2876), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2878), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1513), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2821), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2819), 26,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72178] = 11,
    ACTIONS(2866), 1,
      anon_sym_DOT,
    ACTIONS(2868), 1,
      anon_sym_LPAREN,
    ACTIONS(2876), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2878), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2870), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2882), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1513), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2821), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2880), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2819), 21,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72240] = 6,
    ACTIONS(376), 1,
      anon_sym_COLON_EQ,
    ACTIONS(771), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(768), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(801), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72291] = 6,
    ACTIONS(2483), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3088), 1,
      anon_sym_LBRACK,
    STATE(2358), 1,
      sym_type_parameter,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2481), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2476), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72342] = 5,
    ACTIONS(368), 1,
      anon_sym_COMMA,
    ACTIONS(376), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(361), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [72391] = 5,
    ACTIONS(368), 1,
      anon_sym_COMMA,
    ACTIONS(376), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(361), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [72440] = 5,
    ACTIONS(3090), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1288), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2757), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2755), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72489] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(768), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(771), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(801), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(766), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72538] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(768), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(771), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(801), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(766), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72587] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(361), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72632] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(361), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72677] = 4,
    ACTIONS(376), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(361), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72724] = 4,
    ACTIONS(376), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(361), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72771] = 4,
    ACTIONS(2483), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2481), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2476), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72818] = 8,
    ACTIONS(3055), 1,
      anon_sym_DOT,
    ACTIONS(3057), 1,
      anon_sym_LPAREN,
    ACTIONS(3065), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3067), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1533), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2861), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2859), 25,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72873] = 8,
    ACTIONS(2931), 1,
      anon_sym_DOT,
    ACTIONS(2933), 1,
      anon_sym_LPAREN,
    ACTIONS(2941), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2943), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1585), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2857), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2855), 25,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72928] = 8,
    ACTIONS(2931), 1,
      anon_sym_DOT,
    ACTIONS(2933), 1,
      anon_sym_LPAREN,
    ACTIONS(2941), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2943), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1585), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2861), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2859), 25,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [72983] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3095), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3093), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73028] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3099), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3097), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73073] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3103), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3101), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73118] = 8,
    ACTIONS(3055), 1,
      anon_sym_DOT,
    ACTIONS(3057), 1,
      anon_sym_LPAREN,
    ACTIONS(3065), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3067), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1533), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2857), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2855), 25,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73173] = 6,
    ACTIONS(2483), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3105), 1,
      anon_sym_LBRACK,
    STATE(2393), 1,
      sym_type_parameter,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2481), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2476), 27,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73224] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3109), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3107), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73269] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3113), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3111), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73314] = 6,
    ACTIONS(376), 1,
      anon_sym_COLON_EQ,
    ACTIONS(771), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(768), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(801), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73365] = 5,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1288), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2679), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2677), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73414] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3117), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3115), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73459] = 6,
    ACTIONS(2483), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2508), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2498), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(2505), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2502), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73510] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3121), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3119), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73555] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3125), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3123), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73600] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2481), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2476), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73645] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3129), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3127), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73690] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2521), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2516), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73735] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3133), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3131), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73780] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3137), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3135), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73825] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3141), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3139), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73870] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3145), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3143), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73915] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3149), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3147), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [73960] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2532), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2527), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74005] = 4,
    ACTIONS(2483), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2481), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2476), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [74052] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3153), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3151), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74097] = 4,
    ACTIONS(376), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(361), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [74144] = 15,
    ACTIONS(3055), 1,
      anon_sym_DOT,
    ACTIONS(3057), 1,
      anon_sym_LPAREN,
    ACTIONS(3065), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3067), 1,
      anon_sym_LBRACK,
    ACTIONS(3073), 1,
      anon_sym_PIPE,
    ACTIONS(3077), 1,
      anon_sym_AMP,
    ACTIONS(3079), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3059), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3061), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3071), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1533), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2849), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3069), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2847), 15,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74213] = 15,
    ACTIONS(3055), 1,
      anon_sym_DOT,
    ACTIONS(3057), 1,
      anon_sym_LPAREN,
    ACTIONS(3065), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3067), 1,
      anon_sym_LBRACK,
    ACTIONS(3073), 1,
      anon_sym_PIPE,
    ACTIONS(3077), 1,
      anon_sym_AMP,
    ACTIONS(3079), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3059), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3061), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3071), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1533), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2845), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3069), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2843), 15,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74282] = 4,
    ACTIONS(376), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(361), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [74329] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2543), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2538), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74374] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2555), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2553), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74419] = 8,
    ACTIONS(2931), 1,
      anon_sym_DOT,
    ACTIONS(2933), 1,
      anon_sym_LPAREN,
    ACTIONS(2941), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2943), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1585), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2821), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2819), 25,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74474] = 11,
    ACTIONS(2931), 1,
      anon_sym_DOT,
    ACTIONS(2933), 1,
      anon_sym_LPAREN,
    ACTIONS(2941), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2943), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2935), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2947), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1585), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2821), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2945), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2819), 20,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74535] = 15,
    ACTIONS(2931), 1,
      anon_sym_DOT,
    ACTIONS(2933), 1,
      anon_sym_LPAREN,
    ACTIONS(2941), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2943), 1,
      anon_sym_LBRACK,
    ACTIONS(2949), 1,
      anon_sym_PIPE,
    ACTIONS(2953), 1,
      anon_sym_AMP,
    ACTIONS(2955), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2935), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2937), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2947), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1585), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2853), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2945), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2851), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74604] = 8,
    ACTIONS(2931), 1,
      anon_sym_DOT,
    ACTIONS(2933), 1,
      anon_sym_LPAREN,
    ACTIONS(2941), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2943), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1585), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2821), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2819), 25,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74659] = 10,
    ACTIONS(2931), 1,
      anon_sym_DOT,
    ACTIONS(2933), 1,
      anon_sym_LPAREN,
    ACTIONS(2941), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2943), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2935), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1585), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2821), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2945), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2819), 22,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74718] = 14,
    ACTIONS(2931), 1,
      anon_sym_DOT,
    ACTIONS(2933), 1,
      anon_sym_LPAREN,
    ACTIONS(2941), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2943), 1,
      anon_sym_LBRACK,
    ACTIONS(2953), 1,
      anon_sym_AMP,
    ACTIONS(2955), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2935), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2937), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2947), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1585), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2821), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2945), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2819), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74785] = 13,
    ACTIONS(2931), 1,
      anon_sym_DOT,
    ACTIONS(2933), 1,
      anon_sym_LPAREN,
    ACTIONS(2941), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2943), 1,
      anon_sym_LBRACK,
    ACTIONS(2955), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2935), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2937), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2947), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1585), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2821), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2945), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2819), 17,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74850] = 12,
    ACTIONS(2931), 1,
      anon_sym_DOT,
    ACTIONS(2933), 1,
      anon_sym_LPAREN,
    ACTIONS(2941), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2943), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2935), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2937), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2947), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1585), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2821), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2945), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2819), 18,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74913] = 5,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1307), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2481), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2476), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [74962] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2841), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2839), 31,
      sym_string_start,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75007] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2525), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2523), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75052] = 15,
    ACTIONS(3025), 1,
      anon_sym_DOT,
    ACTIONS(3027), 1,
      anon_sym_LPAREN,
    ACTIONS(3035), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3037), 1,
      anon_sym_LBRACK,
    ACTIONS(3043), 1,
      anon_sym_PIPE,
    ACTIONS(3047), 1,
      anon_sym_AMP,
    ACTIONS(3049), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3029), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3031), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3041), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1629), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2845), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3039), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2843), 15,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75121] = 19,
    ACTIONS(3155), 1,
      anon_sym_DOT,
    ACTIONS(3157), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3167), 1,
      anon_sym_LBRACK,
    ACTIONS(3173), 1,
      anon_sym_PIPE,
    ACTIONS(3175), 1,
      anon_sym_not,
    ACTIONS(3177), 1,
      anon_sym_AMP,
    ACTIONS(3179), 1,
      anon_sym_CARET,
    ACTIONS(3183), 1,
      anon_sym_is,
    STATE(1947), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3159), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3161), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3171), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3181), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1748), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(3169), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(3163), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2785), 7,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [75198] = 15,
    ACTIONS(3025), 1,
      anon_sym_DOT,
    ACTIONS(3027), 1,
      anon_sym_LPAREN,
    ACTIONS(3035), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3037), 1,
      anon_sym_LBRACK,
    ACTIONS(3043), 1,
      anon_sym_PIPE,
    ACTIONS(3047), 1,
      anon_sym_AMP,
    ACTIONS(3049), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3029), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3031), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3041), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1629), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2849), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3039), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2847), 15,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75267] = 15,
    ACTIONS(2931), 1,
      anon_sym_DOT,
    ACTIONS(2933), 1,
      anon_sym_LPAREN,
    ACTIONS(2941), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2943), 1,
      anon_sym_LBRACK,
    ACTIONS(2949), 1,
      anon_sym_PIPE,
    ACTIONS(2953), 1,
      anon_sym_AMP,
    ACTIONS(2955), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2935), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2937), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2947), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1585), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2849), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2945), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2847), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75336] = 15,
    ACTIONS(2931), 1,
      anon_sym_DOT,
    ACTIONS(2933), 1,
      anon_sym_LPAREN,
    ACTIONS(2941), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2943), 1,
      anon_sym_LBRACK,
    ACTIONS(2949), 1,
      anon_sym_PIPE,
    ACTIONS(2953), 1,
      anon_sym_AMP,
    ACTIONS(2955), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2935), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2937), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2947), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1585), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2845), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2945), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2843), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75405] = 15,
    ACTIONS(2985), 1,
      anon_sym_DOT,
    ACTIONS(2987), 1,
      anon_sym_LPAREN,
    ACTIONS(2995), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2997), 1,
      anon_sym_LBRACK,
    ACTIONS(3003), 1,
      anon_sym_PIPE,
    ACTIONS(3007), 1,
      anon_sym_AMP,
    ACTIONS(3009), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2989), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2991), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3001), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1683), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2845), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2999), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2843), 15,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75474] = 15,
    ACTIONS(2985), 1,
      anon_sym_DOT,
    ACTIONS(2987), 1,
      anon_sym_LPAREN,
    ACTIONS(2995), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2997), 1,
      anon_sym_LBRACK,
    ACTIONS(3003), 1,
      anon_sym_PIPE,
    ACTIONS(3007), 1,
      anon_sym_AMP,
    ACTIONS(3009), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2989), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2991), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3001), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1683), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2849), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2999), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2847), 15,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75543] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2551), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2549), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75588] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3187), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3185), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75633] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2514), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2512), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75678] = 12,
    ACTIONS(3025), 1,
      anon_sym_DOT,
    ACTIONS(3027), 1,
      anon_sym_LPAREN,
    ACTIONS(3035), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3037), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3029), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3031), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3041), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1629), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2821), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3039), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2819), 18,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75741] = 13,
    ACTIONS(3025), 1,
      anon_sym_DOT,
    ACTIONS(3027), 1,
      anon_sym_LPAREN,
    ACTIONS(3035), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3037), 1,
      anon_sym_LBRACK,
    ACTIONS(3049), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3029), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3031), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3041), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1629), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2821), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3039), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2819), 17,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75806] = 14,
    ACTIONS(3025), 1,
      anon_sym_DOT,
    ACTIONS(3027), 1,
      anon_sym_LPAREN,
    ACTIONS(3035), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3037), 1,
      anon_sym_LBRACK,
    ACTIONS(3047), 1,
      anon_sym_AMP,
    ACTIONS(3049), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3029), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3031), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3041), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1629), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2821), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3039), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2819), 16,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75873] = 10,
    ACTIONS(3025), 1,
      anon_sym_DOT,
    ACTIONS(3027), 1,
      anon_sym_LPAREN,
    ACTIONS(3035), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3037), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3029), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1629), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2821), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3039), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2819), 22,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75932] = 8,
    ACTIONS(3025), 1,
      anon_sym_DOT,
    ACTIONS(3027), 1,
      anon_sym_LPAREN,
    ACTIONS(3035), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3037), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1629), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2821), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2819), 25,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [75987] = 12,
    ACTIONS(3055), 1,
      anon_sym_DOT,
    ACTIONS(3057), 1,
      anon_sym_LPAREN,
    ACTIONS(3065), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3067), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3059), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3061), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3071), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1533), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2821), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3069), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2819), 18,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76050] = 15,
    ACTIONS(3025), 1,
      anon_sym_DOT,
    ACTIONS(3027), 1,
      anon_sym_LPAREN,
    ACTIONS(3035), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3037), 1,
      anon_sym_LBRACK,
    ACTIONS(3043), 1,
      anon_sym_PIPE,
    ACTIONS(3047), 1,
      anon_sym_AMP,
    ACTIONS(3049), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3029), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3031), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3041), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1629), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2853), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3039), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2851), 15,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76119] = 11,
    ACTIONS(3025), 1,
      anon_sym_DOT,
    ACTIONS(3027), 1,
      anon_sym_LPAREN,
    ACTIONS(3035), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3037), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3029), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3041), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1629), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2821), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3039), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2819), 20,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76180] = 8,
    ACTIONS(3025), 1,
      anon_sym_DOT,
    ACTIONS(3027), 1,
      anon_sym_LPAREN,
    ACTIONS(3035), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3037), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1629), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2821), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2819), 25,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76235] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2514), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2512), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76280] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2496), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2494), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76325] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2496), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2494), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76370] = 13,
    ACTIONS(3055), 1,
      anon_sym_DOT,
    ACTIONS(3057), 1,
      anon_sym_LPAREN,
    ACTIONS(3065), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3067), 1,
      anon_sym_LBRACK,
    ACTIONS(3079), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3059), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3061), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3071), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1533), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2821), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3069), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2819), 17,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76435] = 14,
    ACTIONS(3055), 1,
      anon_sym_DOT,
    ACTIONS(3057), 1,
      anon_sym_LPAREN,
    ACTIONS(3065), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3067), 1,
      anon_sym_LBRACK,
    ACTIONS(3077), 1,
      anon_sym_AMP,
    ACTIONS(3079), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3059), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3061), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3071), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1533), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2821), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3069), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2819), 16,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76502] = 10,
    ACTIONS(3055), 1,
      anon_sym_DOT,
    ACTIONS(3057), 1,
      anon_sym_LPAREN,
    ACTIONS(3065), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3067), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3059), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1533), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2821), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3069), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2819), 22,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76561] = 8,
    ACTIONS(3055), 1,
      anon_sym_DOT,
    ACTIONS(3057), 1,
      anon_sym_LPAREN,
    ACTIONS(3065), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3067), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1533), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2821), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2819), 25,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76616] = 15,
    ACTIONS(3055), 1,
      anon_sym_DOT,
    ACTIONS(3057), 1,
      anon_sym_LPAREN,
    ACTIONS(3065), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3067), 1,
      anon_sym_LBRACK,
    ACTIONS(3073), 1,
      anon_sym_PIPE,
    ACTIONS(3077), 1,
      anon_sym_AMP,
    ACTIONS(3079), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3059), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3061), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3071), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1533), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2853), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3069), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2851), 15,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76685] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2825), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2823), 31,
      sym_string_start,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76730] = 11,
    ACTIONS(3055), 1,
      anon_sym_DOT,
    ACTIONS(3057), 1,
      anon_sym_LPAREN,
    ACTIONS(3065), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3067), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3059), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3071), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1533), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2821), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3069), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2819), 20,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76791] = 12,
    ACTIONS(2985), 1,
      anon_sym_DOT,
    ACTIONS(2987), 1,
      anon_sym_LPAREN,
    ACTIONS(2995), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2997), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2989), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2991), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3001), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1683), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2821), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2999), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2819), 18,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76854] = 13,
    ACTIONS(2985), 1,
      anon_sym_DOT,
    ACTIONS(2987), 1,
      anon_sym_LPAREN,
    ACTIONS(2995), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2997), 1,
      anon_sym_LBRACK,
    ACTIONS(3009), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2989), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2991), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3001), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1683), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2821), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2999), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2819), 17,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76919] = 14,
    ACTIONS(2985), 1,
      anon_sym_DOT,
    ACTIONS(2987), 1,
      anon_sym_LPAREN,
    ACTIONS(2995), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2997), 1,
      anon_sym_LBRACK,
    ACTIONS(3007), 1,
      anon_sym_AMP,
    ACTIONS(3009), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2989), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2991), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3001), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1683), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2821), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2999), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2819), 16,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [76986] = 10,
    ACTIONS(2985), 1,
      anon_sym_DOT,
    ACTIONS(2987), 1,
      anon_sym_LPAREN,
    ACTIONS(2995), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2997), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2989), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1683), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2821), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2999), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2819), 22,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [77045] = 8,
    ACTIONS(2985), 1,
      anon_sym_DOT,
    ACTIONS(2987), 1,
      anon_sym_LPAREN,
    ACTIONS(2995), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2997), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1683), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2821), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2819), 25,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [77100] = 15,
    ACTIONS(2985), 1,
      anon_sym_DOT,
    ACTIONS(2987), 1,
      anon_sym_LPAREN,
    ACTIONS(2995), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2997), 1,
      anon_sym_LBRACK,
    ACTIONS(3003), 1,
      anon_sym_PIPE,
    ACTIONS(3007), 1,
      anon_sym_AMP,
    ACTIONS(3009), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2989), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2991), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3001), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1683), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2853), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2999), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2851), 15,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [77169] = 8,
    ACTIONS(3055), 1,
      anon_sym_DOT,
    ACTIONS(3057), 1,
      anon_sym_LPAREN,
    ACTIONS(3065), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3067), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1533), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2821), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2819), 25,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [77224] = 11,
    ACTIONS(2985), 1,
      anon_sym_DOT,
    ACTIONS(2987), 1,
      anon_sym_LPAREN,
    ACTIONS(2995), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2997), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2989), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3001), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1683), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2821), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2999), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2819), 20,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [77285] = 8,
    ACTIONS(2985), 1,
      anon_sym_DOT,
    ACTIONS(2987), 1,
      anon_sym_LPAREN,
    ACTIONS(2995), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2997), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1683), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2821), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2819), 25,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [77340] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2825), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2823), 31,
      sym_string_start,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [77385] = 8,
    ACTIONS(2985), 1,
      anon_sym_DOT,
    ACTIONS(2987), 1,
      anon_sym_LPAREN,
    ACTIONS(2995), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2997), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1683), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2861), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2859), 25,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [77440] = 8,
    ACTIONS(2985), 1,
      anon_sym_DOT,
    ACTIONS(2987), 1,
      anon_sym_LPAREN,
    ACTIONS(2995), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2997), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1683), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2857), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2855), 25,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [77495] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3191), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3189), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [77540] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3195), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3193), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [77585] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3199), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3197), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [77630] = 5,
    ACTIONS(2478), 1,
      anon_sym_COMMA,
    ACTIONS(2483), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2481), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2476), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [77679] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2841), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2839), 31,
      sym_string_start,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [77724] = 5,
    ACTIONS(376), 1,
      anon_sym_COLON_EQ,
    ACTIONS(838), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(361), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [77773] = 5,
    ACTIONS(376), 1,
      anon_sym_COLON_EQ,
    ACTIONS(838), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(361), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [77822] = 5,
    ACTIONS(2483), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3201), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2481), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2476), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [77871] = 8,
    ACTIONS(3025), 1,
      anon_sym_DOT,
    ACTIONS(3027), 1,
      anon_sym_LPAREN,
    ACTIONS(3035), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3037), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1629), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2861), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2859), 25,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [77926] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2505), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2508), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2502), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(2498), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [77975] = 8,
    ACTIONS(3025), 1,
      anon_sym_DOT,
    ACTIONS(3027), 1,
      anon_sym_LPAREN,
    ACTIONS(3035), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3037), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1629), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2857), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2855), 25,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78030] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3205), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3203), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78075] = 4,
    ACTIONS(376), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(361), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78121] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2841), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2839), 30,
      sym_string_start,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78165] = 5,
    ACTIONS(376), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(368), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(363), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(361), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78213] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3129), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3127), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [78257] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3137), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3135), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [78301] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3145), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3143), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [78345] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(768), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(771), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(801), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(766), 16,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78393] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(768), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(771), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(801), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(766), 16,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78441] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3141), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3139), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [78485] = 4,
    ACTIONS(2483), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2481), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2476), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78531] = 4,
    ACTIONS(376), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(361), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78577] = 4,
    ACTIONS(376), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(361), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78623] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3149), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3147), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [78667] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2825), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2823), 30,
      sym_string_start,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78711] = 19,
    ACTIONS(2987), 1,
      anon_sym_LPAREN,
    ACTIONS(2995), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3003), 1,
      anon_sym_PIPE,
    ACTIONS(3005), 1,
      anon_sym_not,
    ACTIONS(3007), 1,
      anon_sym_AMP,
    ACTIONS(3009), 1,
      anon_sym_CARET,
    ACTIONS(3013), 1,
      anon_sym_is,
    ACTIONS(3055), 1,
      anon_sym_DOT,
    ACTIONS(3067), 1,
      anon_sym_LBRACK,
    STATE(1935), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2989), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2991), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3001), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3011), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1683), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2999), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2785), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2993), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [78787] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3099), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3097), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [78831] = 5,
    ACTIONS(376), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(368), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(363), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(361), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [78879] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3109), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3107), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [78923] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3113), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3111), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [78967] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3117), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3115), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [79011] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3125), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3123), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [79055] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2496), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2494), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79099] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2496), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2494), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79143] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3153), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3151), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [79187] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3205), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3203), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [79231] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2555), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2553), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [79275] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3187), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3185), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [79319] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2555), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2553), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79363] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3191), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3189), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [79407] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2514), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2512), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79451] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2514), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2512), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79495] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2551), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2549), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79539] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3199), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3197), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [79583] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3121), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3119), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [79627] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3133), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3131), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [79671] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3195), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3193), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [79715] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3095), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3093), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [79759] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(361), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [79803] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(361), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [79847] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2525), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2523), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [79891] = 4,
    ACTIONS(2483), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2481), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2476), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79937] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2505), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2508), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2502), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(2498), 16,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [79985] = 4,
    ACTIONS(376), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(361), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80031] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2825), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2823), 30,
      sym_string_start,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80075] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2498), 3,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(2505), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2502), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80121] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2551), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2549), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [80165] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2514), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2512), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [80209] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2514), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2512), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [80253] = 5,
    ACTIONS(2483), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2478), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(2481), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2476), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80301] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2496), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2494), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [80345] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2496), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2494), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [80389] = 19,
    ACTIONS(3025), 1,
      anon_sym_DOT,
    ACTIONS(3037), 1,
      anon_sym_LBRACK,
    ACTIONS(3157), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3173), 1,
      anon_sym_PIPE,
    ACTIONS(3175), 1,
      anon_sym_not,
    ACTIONS(3177), 1,
      anon_sym_AMP,
    ACTIONS(3179), 1,
      anon_sym_CARET,
    ACTIONS(3183), 1,
      anon_sym_is,
    STATE(1947), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3159), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3161), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3171), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3181), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1748), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(3169), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2785), 6,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3163), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [80465] = 5,
    ACTIONS(376), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(768), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(801), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80513] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2841), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2839), 30,
      sym_string_start,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80557] = 5,
    ACTIONS(376), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(768), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(801), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80605] = 5,
    ACTIONS(2483), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2498), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(2505), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2502), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80653] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2481), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2476), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [80697] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3149), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3147), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80741] = 19,
    ACTIONS(2866), 1,
      anon_sym_DOT,
    ACTIONS(2878), 1,
      anon_sym_LBRACK,
    ACTIONS(2898), 1,
      anon_sym_LPAREN,
    ACTIONS(2906), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2914), 1,
      anon_sym_PIPE,
    ACTIONS(2916), 1,
      anon_sym_not,
    ACTIONS(2918), 1,
      anon_sym_AMP,
    ACTIONS(2920), 1,
      anon_sym_CARET,
    ACTIONS(2924), 1,
      anon_sym_is,
    STATE(1946), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2900), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2902), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2912), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2922), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1428), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2910), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2785), 6,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2904), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [80817] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3141), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3139), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80861] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3145), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3143), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80905] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3137), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3135), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80949] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3129), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3127), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [80993] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3103), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3101), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [81037] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2505), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2508), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2502), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(2498), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [81085] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3103), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3101), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81129] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2521), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2516), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [81173] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3099), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3097), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81217] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3109), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3107), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81261] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3191), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3189), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81305] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2525), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2523), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81349] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3113), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3111), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81393] = 8,
    ACTIONS(3155), 1,
      anon_sym_DOT,
    ACTIONS(3157), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3167), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1748), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2857), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2855), 25,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81447] = 5,
    ACTIONS(376), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(368), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(363), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(361), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81495] = 8,
    ACTIONS(3155), 1,
      anon_sym_DOT,
    ACTIONS(3157), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3167), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1748), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2861), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2859), 25,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81549] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3117), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3115), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81593] = 5,
    ACTIONS(376), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(368), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(363), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(361), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81641] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3125), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3123), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81685] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3153), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3151), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81729] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3205), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3203), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81773] = 4,
    ACTIONS(376), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(361), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81819] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2543), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2538), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81863] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2532), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2527), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81907] = 4,
    ACTIONS(376), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(361), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81953] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2481), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2476), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [81997] = 4,
    ACTIONS(2518), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2521), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2516), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [82043] = 4,
    ACTIONS(2478), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2481), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2476), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [82089] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2825), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2823), 30,
      sym_string_start,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82133] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2825), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2823), 30,
      sym_string_start,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82177] = 4,
    ACTIONS(2483), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2481), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2476), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82223] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2841), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2839), 30,
      sym_string_start,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82267] = 4,
    ACTIONS(2529), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2532), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2527), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [82313] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(768), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(771), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(801), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(766), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [82361] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2532), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2527), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [82405] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2543), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2538), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [82449] = 5,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1085), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2481), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2476), 28,
      sym__dedent,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82497] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(768), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(771), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(801), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(766), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [82545] = 5,
    ACTIONS(2483), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2498), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(2505), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2502), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82593] = 19,
    ACTIONS(3207), 1,
      anon_sym_DOT,
    ACTIONS(3209), 1,
      anon_sym_LPAREN,
    ACTIONS(3217), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3219), 1,
      anon_sym_LBRACK,
    ACTIONS(3225), 1,
      anon_sym_PIPE,
    ACTIONS(3227), 1,
      anon_sym_not,
    ACTIONS(3229), 1,
      anon_sym_AMP,
    ACTIONS(3231), 1,
      anon_sym_CARET,
    ACTIONS(3235), 1,
      anon_sym_is,
    STATE(2011), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3211), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3213), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3223), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(3233), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(1783), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(3221), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2785), 6,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3215), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [82669] = 4,
    ACTIONS(376), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(361), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82715] = 8,
    ACTIONS(3155), 1,
      anon_sym_DOT,
    ACTIONS(3157), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3167), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1748), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2821), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2819), 25,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82769] = 6,
    ACTIONS(2483), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3237), 1,
      anon_sym_LBRACK,
    STATE(2442), 1,
      sym_type_parameter,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2481), 5,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2476), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82819] = 4,
    ACTIONS(376), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(361), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82865] = 11,
    ACTIONS(3155), 1,
      anon_sym_DOT,
    ACTIONS(3157), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3167), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2821), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3159), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3171), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1748), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(3169), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2819), 20,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82925] = 4,
    ACTIONS(2483), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2481), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2476), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [82971] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3187), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3185), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83015] = 4,
    ACTIONS(2540), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2543), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2538), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [83061] = 5,
    ACTIONS(376), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(768), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(801), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83109] = 5,
    ACTIONS(376), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(766), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(768), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(801), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83157] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(361), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83201] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(361), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83245] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2521), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2516), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83289] = 15,
    ACTIONS(3155), 1,
      anon_sym_DOT,
    ACTIONS(3157), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3167), 1,
      anon_sym_LBRACK,
    ACTIONS(3173), 1,
      anon_sym_PIPE,
    ACTIONS(3177), 1,
      anon_sym_AMP,
    ACTIONS(3179), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2853), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3159), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3161), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3171), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1748), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(3169), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2851), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83357] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3095), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3093), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83401] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3133), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3131), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83445] = 8,
    ACTIONS(3155), 1,
      anon_sym_DOT,
    ACTIONS(3157), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3167), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1748), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2821), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2819), 25,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83499] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3121), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3119), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83543] = 10,
    ACTIONS(3155), 1,
      anon_sym_DOT,
    ACTIONS(3157), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3167), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2821), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3159), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1748), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(3169), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2819), 22,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83601] = 15,
    ACTIONS(3155), 1,
      anon_sym_DOT,
    ACTIONS(3157), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3167), 1,
      anon_sym_LBRACK,
    ACTIONS(3173), 1,
      anon_sym_PIPE,
    ACTIONS(3177), 1,
      anon_sym_AMP,
    ACTIONS(3179), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2845), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3159), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3161), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3171), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1748), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(3169), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2843), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83669] = 15,
    ACTIONS(3155), 1,
      anon_sym_DOT,
    ACTIONS(3157), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3167), 1,
      anon_sym_LBRACK,
    ACTIONS(3173), 1,
      anon_sym_PIPE,
    ACTIONS(3177), 1,
      anon_sym_AMP,
    ACTIONS(3179), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2849), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3159), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3161), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3171), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1748), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(3169), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2847), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83737] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3195), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3193), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83781] = 12,
    ACTIONS(3155), 1,
      anon_sym_DOT,
    ACTIONS(3157), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3167), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2821), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3159), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3161), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3171), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1748), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(3169), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2819), 18,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83843] = 13,
    ACTIONS(3155), 1,
      anon_sym_DOT,
    ACTIONS(3157), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3167), 1,
      anon_sym_LBRACK,
    ACTIONS(3179), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2821), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3159), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3161), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3171), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1748), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(3169), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2819), 17,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83907] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3199), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3197), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83951] = 5,
    ACTIONS(2483), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2478), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(2481), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2476), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [83999] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2841), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2839), 30,
      sym_string_start,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84043] = 14,
    ACTIONS(3155), 1,
      anon_sym_DOT,
    ACTIONS(3157), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3167), 1,
      anon_sym_LBRACK,
    ACTIONS(3177), 1,
      anon_sym_AMP,
    ACTIONS(3179), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2821), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3159), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3161), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3171), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1748), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(3169), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2819), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84109] = 6,
    ACTIONS(2483), 1,
      anon_sym_COLON_EQ,
    ACTIONS(2490), 1,
      anon_sym_LBRACK,
    STATE(2456), 1,
      sym_type_parameter,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2481), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2476), 26,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84159] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2825), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2823), 30,
      sym_string_start,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84202] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3141), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3139), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84245] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2543), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2538), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84288] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2532), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2527), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84331] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2525), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2523), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84374] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3125), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3123), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84417] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3117), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3115), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84460] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3113), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3111), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84503] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3109), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3107), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84546] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2521), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2516), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84589] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2498), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(2505), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2502), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84634] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2543), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2538), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84677] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3195), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3193), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84720] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2532), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2527), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84763] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3153), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3151), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84806] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2481), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2476), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84849] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2555), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2553), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84892] = 5,
    ACTIONS(376), 1,
      anon_sym_COLON_EQ,
    ACTIONS(940), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(361), 28,
      sym__newline,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84939] = 5,
    ACTIONS(376), 1,
      anon_sym_COLON_EQ,
    ACTIONS(940), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(361), 28,
      sym__newline,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [84986] = 5,
    ACTIONS(2483), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3239), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2481), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2476), 28,
      sym__newline,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85033] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2521), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2516), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85076] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2478), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(2481), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2476), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85121] = 8,
    ACTIONS(3207), 1,
      anon_sym_DOT,
    ACTIONS(3209), 1,
      anon_sym_LPAREN,
    ACTIONS(3217), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3219), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1783), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2857), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2855), 24,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85174] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3099), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3097), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85217] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2505), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2508), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2502), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(2498), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85264] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2551), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2549), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85307] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3103), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3101), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85350] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2514), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2512), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85393] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2525), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2523), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85436] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2514), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2512), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85479] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2551), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2549), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85522] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2514), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2512), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85565] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2514), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2512), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85608] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2496), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2494), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85651] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2496), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2494), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85694] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2496), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2494), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85737] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2496), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2494), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85780] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3149), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3147), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85823] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(361), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85866] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(361), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85909] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2555), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2553), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85952] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3141), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3139), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [85995] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3095), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3093), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86038] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2496), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2494), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86081] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2496), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2494), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86124] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2514), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2512), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86167] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2514), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2512), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86210] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2551), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2549), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86253] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3145), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3143), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86296] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2841), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2839), 30,
      sym_string_start,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86339] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3095), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3093), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86382] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3137), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3135), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86425] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3129), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3127), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86468] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(768), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(771), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(801), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(766), 15,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86515] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(361), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86558] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(361), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86601] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2540), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(2543), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2538), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86646] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2525), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2523), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86689] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3103), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3101), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86732] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(768), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(771), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(801), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(766), 15,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86779] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3099), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3097), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86822] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(768), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(771), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(801), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(766), 15,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86869] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3109), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3107), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86912] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3113), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3111), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86955] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3195), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3193), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [86998] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3117), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3115), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87041] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(768), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(771), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(801), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(766), 15,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87088] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2505), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2508), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2502), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(2498), 15,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87135] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3125), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3123), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87178] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2521), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2516), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87221] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(361), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(363), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(400), 18,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [87266] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2505), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2508), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2502), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(2498), 15,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87313] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3153), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3151), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87356] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(361), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(363), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(400), 18,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [87401] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3129), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3127), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87444] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3205), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3203), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87487] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2555), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2553), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87530] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3133), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3131), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87573] = 5,
    ACTIONS(2483), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3241), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2481), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2476), 28,
      sym__dedent,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87620] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3121), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3119), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87663] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3133), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3131), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87706] = 5,
    ACTIONS(376), 1,
      anon_sym_COLON_EQ,
    ACTIONS(952), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(361), 28,
      sym__dedent,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87753] = 5,
    ACTIONS(376), 1,
      anon_sym_COLON_EQ,
    ACTIONS(952), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(361), 28,
      sym__dedent,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87800] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3121), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3119), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87843] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2498), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(2505), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2502), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87888] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3137), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3135), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87931] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3187), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3185), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [87974] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3145), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3143), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88017] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(768), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(771), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(801), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(766), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88064] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(768), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(771), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(801), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(766), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88111] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3191), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3189), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88154] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3199), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3197), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88197] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3191), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3189), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88240] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3199), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3197), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88283] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3187), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3185), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88326] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2532), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2527), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88369] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2543), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2538), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88412] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3205), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3203), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88455] = 7,
    ACTIONS(2510), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2505), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2508), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2500), 5,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(2498), 12,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
    ACTIONS(2502), 12,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [88506] = 5,
    ACTIONS(376), 1,
      anon_sym_COLON_EQ,
    ACTIONS(838), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(361), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88553] = 5,
    ACTIONS(376), 1,
      anon_sym_COLON_EQ,
    ACTIONS(838), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(361), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88600] = 5,
    ACTIONS(2483), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3201), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2481), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2476), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88647] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2529), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(2532), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2527), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88692] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2543), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2538), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88735] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2532), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2527), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88778] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3121), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3119), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88821] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3133), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3131), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88864] = 8,
    ACTIONS(3207), 1,
      anon_sym_DOT,
    ACTIONS(3209), 1,
      anon_sym_LPAREN,
    ACTIONS(3217), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3219), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1783), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2861), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2859), 24,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88917] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3195), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3193), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [88960] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2538), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(2543), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(2547), 18,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [89005] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3095), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3093), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89048] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(361), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89091] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(361), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89134] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2540), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(2543), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2538), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89179] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3205), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3203), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89222] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2505), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2508), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2502), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(2498), 15,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89269] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2527), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(2532), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(2536), 18,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [89314] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2476), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(2481), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(2492), 18,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [89359] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2516), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(2521), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(2492), 18,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [89404] = 7,
    ACTIONS(2510), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2505), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2508), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2500), 5,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(2498), 12,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
    ACTIONS(2502), 12,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [89455] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2521), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2516), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89498] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2481), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2476), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89541] = 8,
    ACTIONS(3207), 1,
      anon_sym_DOT,
    ACTIONS(3209), 1,
      anon_sym_LPAREN,
    ACTIONS(3217), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3219), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1783), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2821), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2819), 24,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89594] = 11,
    ACTIONS(3207), 1,
      anon_sym_DOT,
    ACTIONS(3209), 1,
      anon_sym_LPAREN,
    ACTIONS(3217), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3219), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2821), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3211), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3223), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1783), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(3221), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2819), 19,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89653] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2518), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(2521), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2516), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89698] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2529), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(2532), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2527), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89743] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2478), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(2481), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2476), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89788] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3141), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3139), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89831] = 15,
    ACTIONS(3207), 1,
      anon_sym_DOT,
    ACTIONS(3209), 1,
      anon_sym_LPAREN,
    ACTIONS(3217), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3219), 1,
      anon_sym_LBRACK,
    ACTIONS(3225), 1,
      anon_sym_PIPE,
    ACTIONS(3229), 1,
      anon_sym_AMP,
    ACTIONS(3231), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2853), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3211), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3213), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3223), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1783), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(3221), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2851), 14,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89898] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2518), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(2521), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2516), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89943] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(768), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(771), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(801), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(766), 15,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [89990] = 8,
    ACTIONS(3207), 1,
      anon_sym_DOT,
    ACTIONS(3209), 1,
      anon_sym_LPAREN,
    ACTIONS(3217), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3219), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1783), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2821), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2819), 24,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90043] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3149), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3147), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90086] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2481), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2476), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90129] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3199), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3197), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90172] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3153), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3151), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90215] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3191), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3189), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90258] = 10,
    ACTIONS(3207), 1,
      anon_sym_DOT,
    ACTIONS(3209), 1,
      anon_sym_LPAREN,
    ACTIONS(3217), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3219), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2821), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3211), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(1783), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(3221), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2819), 21,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90315] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3149), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3147), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90358] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2481), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2476), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90401] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3141), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3139), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90444] = 14,
    ACTIONS(3207), 1,
      anon_sym_DOT,
    ACTIONS(3209), 1,
      anon_sym_LPAREN,
    ACTIONS(3217), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3219), 1,
      anon_sym_LBRACK,
    ACTIONS(3229), 1,
      anon_sym_AMP,
    ACTIONS(3231), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2821), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3211), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3213), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3223), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1783), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(3221), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2819), 15,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90509] = 13,
    ACTIONS(3207), 1,
      anon_sym_DOT,
    ACTIONS(3209), 1,
      anon_sym_LPAREN,
    ACTIONS(3217), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3219), 1,
      anon_sym_LBRACK,
    ACTIONS(3231), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2821), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3211), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3213), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3223), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1783), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(3221), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2819), 16,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90572] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(768), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(771), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(801), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(766), 15,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90619] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3125), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3123), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90662] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3117), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3115), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90705] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3113), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3111), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90748] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3109), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3107), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90791] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3145), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3143), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90834] = 4,
    ACTIONS(376), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 5,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(361), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90879] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3137), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3135), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90922] = 4,
    ACTIONS(376), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 5,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(361), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [90967] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3099), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3097), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91010] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3103), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3101), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91053] = 12,
    ACTIONS(3207), 1,
      anon_sym_DOT,
    ACTIONS(3209), 1,
      anon_sym_LPAREN,
    ACTIONS(3217), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3219), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2821), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3211), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3213), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3223), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1783), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(3221), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2819), 17,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91114] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3187), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3185), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91157] = 4,
    ACTIONS(2483), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2481), 5,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2476), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91202] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3129), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3127), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91245] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(361), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91288] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(361), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91331] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3095), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3093), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91374] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3129), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3127), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91417] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3195), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3193), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91460] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3149), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3147), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91503] = 15,
    ACTIONS(3207), 1,
      anon_sym_DOT,
    ACTIONS(3209), 1,
      anon_sym_LPAREN,
    ACTIONS(3217), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3219), 1,
      anon_sym_LBRACK,
    ACTIONS(3225), 1,
      anon_sym_PIPE,
    ACTIONS(3229), 1,
      anon_sym_AMP,
    ACTIONS(3231), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2845), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3211), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3213), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3223), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1783), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(3221), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2843), 14,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91570] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3103), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3101), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91613] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3137), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3135), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91656] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3145), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3143), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91699] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3133), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3131), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91742] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3199), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3197), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91785] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3121), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3119), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91828] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3099), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3097), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91871] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3187), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3185), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91914] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3109), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3107), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [91957] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3113), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3111), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92000] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3117), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3115), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92043] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3125), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3123), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92086] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3205), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3203), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92129] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3191), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3189), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92172] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3153), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3151), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92215] = 15,
    ACTIONS(3207), 1,
      anon_sym_DOT,
    ACTIONS(3209), 1,
      anon_sym_LPAREN,
    ACTIONS(3217), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3219), 1,
      anon_sym_LBRACK,
    ACTIONS(3225), 1,
      anon_sym_PIPE,
    ACTIONS(3229), 1,
      anon_sym_AMP,
    ACTIONS(3231), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2849), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3211), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3213), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(3223), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1783), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(3221), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(2847), 14,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92282] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(768), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(771), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(801), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(766), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92328] = 4,
    ACTIONS(376), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(361), 28,
      sym__dedent,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92372] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(361), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92414] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(361), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92456] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3129), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3127), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92498] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3103), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3101), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92540] = 4,
    ACTIONS(2483), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2505), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2502), 28,
      sym__newline,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92584] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3099), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3097), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92626] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3109), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3107), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92668] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3113), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3111), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92710] = 4,
    ACTIONS(376), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(768), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(801), 28,
      sym__newline,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92754] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3117), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3115), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92796] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3125), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3123), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92838] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3153), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3151), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92880] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2551), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2549), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92922] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3095), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3093), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [92964] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2525), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2523), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [93006] = 4,
    ACTIONS(2483), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2505), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2502), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [93050] = 4,
    ACTIONS(376), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(768), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(801), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [93094] = 4,
    ACTIONS(376), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(768), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(801), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [93138] = 4,
    ACTIONS(2483), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2481), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2476), 28,
      sym__dedent,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [93182] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3141), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3139), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [93224] = 4,
    ACTIONS(2483), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2505), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2502), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [93268] = 4,
    ACTIONS(376), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(768), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(801), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [93312] = 6,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2505), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2508), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2500), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
    ACTIONS(2498), 12,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
    ACTIONS(2502), 12,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [93360] = 4,
    ACTIONS(376), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(361), 28,
      sym__dedent,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [93404] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2543), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2538), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [93446] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2532), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2527), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [93488] = 4,
    ACTIONS(2483), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2505), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2502), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [93532] = 4,
    ACTIONS(376), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(768), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(801), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [93576] = 4,
    ACTIONS(376), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(768), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(801), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [93620] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2555), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2553), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [93662] = 7,
    ACTIONS(2510), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2505), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2508), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2500), 4,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(2498), 12,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
    ACTIONS(2502), 12,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [93712] = 4,
    ACTIONS(376), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(768), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(801), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [93756] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2505), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2508), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2502), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(2498), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [93802] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3149), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3147), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [93844] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2496), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2494), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [93886] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3205), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3203), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [93928] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2496), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2494), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [93970] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3145), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3143), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [94012] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3137), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3135), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [94054] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3187), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3185), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [94096] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3191), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3189), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [94138] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2514), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2512), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [94180] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3199), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3197), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [94222] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3121), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3119), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [94264] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3195), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3193), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [94306] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3133), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3131), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [94348] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(768), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(771), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(801), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(766), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [94394] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2514), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2512), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [94436] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2481), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2476), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [94478] = 4,
    ACTIONS(2483), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2505), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2502), 28,
      sym__dedent,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [94522] = 4,
    ACTIONS(376), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(768), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(801), 28,
      sym__dedent,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [94566] = 4,
    ACTIONS(376), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(768), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(801), 28,
      sym__dedent,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [94610] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2521), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2516), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [94652] = 4,
    ACTIONS(376), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(768), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(801), 28,
      sym__newline,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [94696] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(768), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(771), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(766), 14,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
    ACTIONS(801), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [94741] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3199), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3197), 28,
      sym__dedent,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [94782] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3117), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3115), 28,
      sym__dedent,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [94823] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2521), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2516), 28,
      sym__dedent,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [94864] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(768), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(771), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(766), 14,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
    ACTIONS(801), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [94909] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2496), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2494), 28,
      sym__dedent,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [94950] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2527), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(2532), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(2536), 16,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [94993] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2496), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2494), 28,
      sym__dedent,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [95034] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2514), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2512), 28,
      sym__dedent,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [95075] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2514), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2512), 28,
      sym__dedent,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [95116] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2476), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(2481), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(2492), 16,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [95159] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2538), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(2543), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(2547), 16,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [95202] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2516), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(2521), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(2492), 16,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [95245] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2502), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(2505), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(2498), 16,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [95288] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2505), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2502), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [95329] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2551), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2549), 28,
      sym__dedent,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [95370] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2525), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2523), 28,
      sym__dedent,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [95411] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3153), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3151), 28,
      sym__dedent,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [95452] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3141), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3139), 28,
      sym__dedent,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [95493] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3149), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3147), 28,
      sym__dedent,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [95534] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(801), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(768), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(766), 16,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [95577] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2505), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2502), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [95618] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2481), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2476), 28,
      sym__dedent,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [95659] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3205), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3203), 28,
      sym__dedent,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [95700] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2555), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2553), 28,
      sym__dedent,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [95741] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3195), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3193), 28,
      sym__dedent,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [95782] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2505), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2502), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [95823] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3145), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3143), 28,
      sym__dedent,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [95864] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(361), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(363), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(400), 16,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [95907] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3187), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3185), 28,
      sym__dedent,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [95948] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3191), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3189), 28,
      sym__dedent,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [95989] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2505), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2502), 28,
      sym__newline,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [96030] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2543), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2538), 28,
      sym__dedent,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [96071] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2532), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2527), 28,
      sym__dedent,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [96112] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(361), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(363), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(400), 16,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [96155] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2505), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2502), 28,
      sym__dedent,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [96196] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2505), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2508), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2498), 14,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
    ACTIONS(2502), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [96241] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3121), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3119), 28,
      sym__dedent,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [96282] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3137), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3135), 28,
      sym__dedent,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [96323] = 4,
    ACTIONS(2837), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1800), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2677), 29,
      sym__dedent,
      anon_sym_container,
      anon_sym_wildcard_constraints,
      anon_sym_benchmark,
      anon_sym_input,
      anon_sym_log,
      anon_sym_output,
      anon_sym_message,
      anon_sym_notebook,
      anon_sym_script,
      anon_sym_shell,
      anon_sym_cache,
      anon_sym_conda,
      anon_sym_cwl,
      anon_sym_default_target,
      anon_sym_envmodules,
      anon_sym_group,
      anon_sym_handover,
      anon_sym_localrule,
      anon_sym_params,
      anon_sym_priority,
      anon_sym_resources,
      anon_sym_retries,
      anon_sym_shadow,
      anon_sym_singularity,
      anon_sym_template_engine,
      anon_sym_threads,
      anon_sym_wrapper,
      anon_sym_run,
  [96366] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3125), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3123), 28,
      sym__dedent,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [96407] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2555), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(2553), 19,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [96448] = 4,
    ACTIONS(3243), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1800), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2755), 29,
      sym__dedent,
      anon_sym_container,
      anon_sym_wildcard_constraints,
      anon_sym_benchmark,
      anon_sym_input,
      anon_sym_log,
      anon_sym_output,
      anon_sym_message,
      anon_sym_notebook,
      anon_sym_script,
      anon_sym_shell,
      anon_sym_cache,
      anon_sym_conda,
      anon_sym_cwl,
      anon_sym_default_target,
      anon_sym_envmodules,
      anon_sym_group,
      anon_sym_handover,
      anon_sym_localrule,
      anon_sym_params,
      anon_sym_priority,
      anon_sym_resources,
      anon_sym_retries,
      anon_sym_shadow,
      anon_sym_singularity,
      anon_sym_template_engine,
      anon_sym_threads,
      anon_sym_wrapper,
      anon_sym_run,
  [96491] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2525), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(2523), 19,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [96532] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(361), 28,
      sym__dedent,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [96573] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(361), 28,
      sym__dedent,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [96614] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2551), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(2549), 19,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [96655] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2514), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(2512), 19,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [96696] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2514), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(2512), 19,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [96737] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3129), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3127), 28,
      sym__dedent,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [96778] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2496), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(2494), 19,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [96819] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3103), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3101), 28,
      sym__dedent,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [96860] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2496), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(2494), 19,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [96901] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3095), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3093), 28,
      sym__dedent,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [96942] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3099), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3097), 28,
      sym__dedent,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [96983] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3109), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3107), 28,
      sym__dedent,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [97024] = 4,
    ACTIONS(2837), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1797), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(3246), 29,
      sym__dedent,
      anon_sym_container,
      anon_sym_wildcard_constraints,
      anon_sym_benchmark,
      anon_sym_input,
      anon_sym_log,
      anon_sym_output,
      anon_sym_message,
      anon_sym_notebook,
      anon_sym_script,
      anon_sym_shell,
      anon_sym_cache,
      anon_sym_conda,
      anon_sym_cwl,
      anon_sym_default_target,
      anon_sym_envmodules,
      anon_sym_group,
      anon_sym_handover,
      anon_sym_localrule,
      anon_sym_params,
      anon_sym_priority,
      anon_sym_resources,
      anon_sym_retries,
      anon_sym_shadow,
      anon_sym_singularity,
      anon_sym_template_engine,
      anon_sym_threads,
      anon_sym_wrapper,
      anon_sym_run,
  [97067] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3133), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3131), 28,
      sym__dedent,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [97108] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3113), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3111), 28,
      sym__dedent,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [97149] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(801), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(768), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(766), 16,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [97192] = 20,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(3248), 1,
      sym_identifier,
    ACTIONS(3250), 1,
      anon_sym_LPAREN,
    ACTIONS(3252), 1,
      anon_sym_STAR,
    ACTIONS(3254), 1,
      anon_sym_if,
    ACTIONS(3256), 1,
      anon_sym_COLON,
    ACTIONS(3258), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3260), 1,
      anon_sym_LBRACK,
    ACTIONS(3262), 1,
      anon_sym_DASH,
    ACTIONS(3266), 1,
      anon_sym_LBRACE,
    ACTIONS(3268), 1,
      sym_integer,
    ACTIONS(3270), 1,
      sym_float,
    STATE(2177), 1,
      sym_string,
    STATE(2372), 1,
      sym_dotted_name,
    STATE(2540), 1,
      sym_case_pattern,
    STATE(3318), 1,
      sym_if_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2607), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(3264), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2382), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [97266] = 20,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(3248), 1,
      sym_identifier,
    ACTIONS(3250), 1,
      anon_sym_LPAREN,
    ACTIONS(3252), 1,
      anon_sym_STAR,
    ACTIONS(3254), 1,
      anon_sym_if,
    ACTIONS(3258), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3260), 1,
      anon_sym_LBRACK,
    ACTIONS(3262), 1,
      anon_sym_DASH,
    ACTIONS(3266), 1,
      anon_sym_LBRACE,
    ACTIONS(3268), 1,
      sym_integer,
    ACTIONS(3270), 1,
      sym_float,
    ACTIONS(3272), 1,
      anon_sym_COLON,
    STATE(2177), 1,
      sym_string,
    STATE(2372), 1,
      sym_dotted_name,
    STATE(2540), 1,
      sym_case_pattern,
    STATE(3276), 1,
      sym_if_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2607), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(3264), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2382), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [97340] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1058), 30,
      sym__dedent,
      sym_string_start,
      anon_sym_container,
      anon_sym_wildcard_constraints,
      anon_sym_benchmark,
      anon_sym_input,
      anon_sym_log,
      anon_sym_output,
      anon_sym_message,
      anon_sym_notebook,
      anon_sym_script,
      anon_sym_shell,
      anon_sym_cache,
      anon_sym_conda,
      anon_sym_cwl,
      anon_sym_default_target,
      anon_sym_envmodules,
      anon_sym_group,
      anon_sym_handover,
      anon_sym_localrule,
      anon_sym_params,
      anon_sym_priority,
      anon_sym_resources,
      anon_sym_retries,
      anon_sym_shadow,
      anon_sym_singularity,
      anon_sym_template_engine,
      anon_sym_threads,
      anon_sym_wrapper,
      anon_sym_run,
  [97377] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3274), 30,
      sym__dedent,
      sym_string_start,
      anon_sym_container,
      anon_sym_wildcard_constraints,
      anon_sym_benchmark,
      anon_sym_input,
      anon_sym_log,
      anon_sym_output,
      anon_sym_message,
      anon_sym_notebook,
      anon_sym_script,
      anon_sym_shell,
      anon_sym_cache,
      anon_sym_conda,
      anon_sym_cwl,
      anon_sym_default_target,
      anon_sym_envmodules,
      anon_sym_group,
      anon_sym_handover,
      anon_sym_localrule,
      anon_sym_params,
      anon_sym_priority,
      anon_sym_resources,
      anon_sym_retries,
      anon_sym_shadow,
      anon_sym_singularity,
      anon_sym_template_engine,
      anon_sym_threads,
      anon_sym_wrapper,
      anon_sym_run,
  [97414] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1066), 30,
      sym__dedent,
      sym_string_start,
      anon_sym_container,
      anon_sym_wildcard_constraints,
      anon_sym_benchmark,
      anon_sym_input,
      anon_sym_log,
      anon_sym_output,
      anon_sym_message,
      anon_sym_notebook,
      anon_sym_script,
      anon_sym_shell,
      anon_sym_cache,
      anon_sym_conda,
      anon_sym_cwl,
      anon_sym_default_target,
      anon_sym_envmodules,
      anon_sym_group,
      anon_sym_handover,
      anon_sym_localrule,
      anon_sym_params,
      anon_sym_priority,
      anon_sym_resources,
      anon_sym_retries,
      anon_sym_shadow,
      anon_sym_singularity,
      anon_sym_template_engine,
      anon_sym_threads,
      anon_sym_wrapper,
      anon_sym_run,
  [97451] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2839), 30,
      sym__dedent,
      sym_string_start,
      anon_sym_container,
      anon_sym_wildcard_constraints,
      anon_sym_benchmark,
      anon_sym_input,
      anon_sym_log,
      anon_sym_output,
      anon_sym_message,
      anon_sym_notebook,
      anon_sym_script,
      anon_sym_shell,
      anon_sym_cache,
      anon_sym_conda,
      anon_sym_cwl,
      anon_sym_default_target,
      anon_sym_envmodules,
      anon_sym_group,
      anon_sym_handover,
      anon_sym_localrule,
      anon_sym_params,
      anon_sym_priority,
      anon_sym_resources,
      anon_sym_retries,
      anon_sym_shadow,
      anon_sym_singularity,
      anon_sym_template_engine,
      anon_sym_threads,
      anon_sym_wrapper,
      anon_sym_run,
  [97488] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1062), 30,
      sym__dedent,
      sym_string_start,
      anon_sym_container,
      anon_sym_wildcard_constraints,
      anon_sym_benchmark,
      anon_sym_input,
      anon_sym_log,
      anon_sym_output,
      anon_sym_message,
      anon_sym_notebook,
      anon_sym_script,
      anon_sym_shell,
      anon_sym_cache,
      anon_sym_conda,
      anon_sym_cwl,
      anon_sym_default_target,
      anon_sym_envmodules,
      anon_sym_group,
      anon_sym_handover,
      anon_sym_localrule,
      anon_sym_params,
      anon_sym_priority,
      anon_sym_resources,
      anon_sym_retries,
      anon_sym_shadow,
      anon_sym_singularity,
      anon_sym_template_engine,
      anon_sym_threads,
      anon_sym_wrapper,
      anon_sym_run,
  [97525] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3276), 30,
      sym__dedent,
      sym_string_start,
      anon_sym_container,
      anon_sym_wildcard_constraints,
      anon_sym_benchmark,
      anon_sym_input,
      anon_sym_log,
      anon_sym_output,
      anon_sym_message,
      anon_sym_notebook,
      anon_sym_script,
      anon_sym_shell,
      anon_sym_cache,
      anon_sym_conda,
      anon_sym_cwl,
      anon_sym_default_target,
      anon_sym_envmodules,
      anon_sym_group,
      anon_sym_handover,
      anon_sym_localrule,
      anon_sym_params,
      anon_sym_priority,
      anon_sym_resources,
      anon_sym_retries,
      anon_sym_shadow,
      anon_sym_singularity,
      anon_sym_template_engine,
      anon_sym_threads,
      anon_sym_wrapper,
      anon_sym_run,
  [97562] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3278), 30,
      sym__dedent,
      sym_string_start,
      anon_sym_container,
      anon_sym_wildcard_constraints,
      anon_sym_benchmark,
      anon_sym_input,
      anon_sym_log,
      anon_sym_output,
      anon_sym_message,
      anon_sym_notebook,
      anon_sym_script,
      anon_sym_shell,
      anon_sym_cache,
      anon_sym_conda,
      anon_sym_cwl,
      anon_sym_default_target,
      anon_sym_envmodules,
      anon_sym_group,
      anon_sym_handover,
      anon_sym_localrule,
      anon_sym_params,
      anon_sym_priority,
      anon_sym_resources,
      anon_sym_retries,
      anon_sym_shadow,
      anon_sym_singularity,
      anon_sym_template_engine,
      anon_sym_threads,
      anon_sym_wrapper,
      anon_sym_run,
  [97599] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3280), 30,
      sym__dedent,
      sym_string_start,
      anon_sym_container,
      anon_sym_wildcard_constraints,
      anon_sym_benchmark,
      anon_sym_input,
      anon_sym_log,
      anon_sym_output,
      anon_sym_message,
      anon_sym_notebook,
      anon_sym_script,
      anon_sym_shell,
      anon_sym_cache,
      anon_sym_conda,
      anon_sym_cwl,
      anon_sym_default_target,
      anon_sym_envmodules,
      anon_sym_group,
      anon_sym_handover,
      anon_sym_localrule,
      anon_sym_params,
      anon_sym_priority,
      anon_sym_resources,
      anon_sym_retries,
      anon_sym_shadow,
      anon_sym_singularity,
      anon_sym_template_engine,
      anon_sym_threads,
      anon_sym_wrapper,
      anon_sym_run,
  [97636] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3282), 30,
      sym__dedent,
      sym_string_start,
      anon_sym_container,
      anon_sym_wildcard_constraints,
      anon_sym_benchmark,
      anon_sym_input,
      anon_sym_log,
      anon_sym_output,
      anon_sym_message,
      anon_sym_notebook,
      anon_sym_script,
      anon_sym_shell,
      anon_sym_cache,
      anon_sym_conda,
      anon_sym_cwl,
      anon_sym_default_target,
      anon_sym_envmodules,
      anon_sym_group,
      anon_sym_handover,
      anon_sym_localrule,
      anon_sym_params,
      anon_sym_priority,
      anon_sym_resources,
      anon_sym_retries,
      anon_sym_shadow,
      anon_sym_singularity,
      anon_sym_template_engine,
      anon_sym_threads,
      anon_sym_wrapper,
      anon_sym_run,
  [97673] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1032), 30,
      sym__dedent,
      sym_string_start,
      anon_sym_container,
      anon_sym_wildcard_constraints,
      anon_sym_benchmark,
      anon_sym_input,
      anon_sym_log,
      anon_sym_output,
      anon_sym_message,
      anon_sym_notebook,
      anon_sym_script,
      anon_sym_shell,
      anon_sym_cache,
      anon_sym_conda,
      anon_sym_cwl,
      anon_sym_default_target,
      anon_sym_envmodules,
      anon_sym_group,
      anon_sym_handover,
      anon_sym_localrule,
      anon_sym_params,
      anon_sym_priority,
      anon_sym_resources,
      anon_sym_retries,
      anon_sym_shadow,
      anon_sym_singularity,
      anon_sym_template_engine,
      anon_sym_threads,
      anon_sym_wrapper,
      anon_sym_run,
  [97710] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3284), 30,
      sym__dedent,
      sym_string_start,
      anon_sym_container,
      anon_sym_wildcard_constraints,
      anon_sym_benchmark,
      anon_sym_input,
      anon_sym_log,
      anon_sym_output,
      anon_sym_message,
      anon_sym_notebook,
      anon_sym_script,
      anon_sym_shell,
      anon_sym_cache,
      anon_sym_conda,
      anon_sym_cwl,
      anon_sym_default_target,
      anon_sym_envmodules,
      anon_sym_group,
      anon_sym_handover,
      anon_sym_localrule,
      anon_sym_params,
      anon_sym_priority,
      anon_sym_resources,
      anon_sym_retries,
      anon_sym_shadow,
      anon_sym_singularity,
      anon_sym_template_engine,
      anon_sym_threads,
      anon_sym_wrapper,
      anon_sym_run,
  [97747] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(972), 30,
      sym__dedent,
      sym_string_start,
      anon_sym_container,
      anon_sym_wildcard_constraints,
      anon_sym_benchmark,
      anon_sym_input,
      anon_sym_log,
      anon_sym_output,
      anon_sym_message,
      anon_sym_notebook,
      anon_sym_script,
      anon_sym_shell,
      anon_sym_cache,
      anon_sym_conda,
      anon_sym_cwl,
      anon_sym_default_target,
      anon_sym_envmodules,
      anon_sym_group,
      anon_sym_handover,
      anon_sym_localrule,
      anon_sym_params,
      anon_sym_priority,
      anon_sym_resources,
      anon_sym_retries,
      anon_sym_shadow,
      anon_sym_singularity,
      anon_sym_template_engine,
      anon_sym_threads,
      anon_sym_wrapper,
      anon_sym_run,
  [97784] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3286), 30,
      sym__dedent,
      sym_string_start,
      anon_sym_container,
      anon_sym_wildcard_constraints,
      anon_sym_benchmark,
      anon_sym_input,
      anon_sym_log,
      anon_sym_output,
      anon_sym_message,
      anon_sym_notebook,
      anon_sym_script,
      anon_sym_shell,
      anon_sym_cache,
      anon_sym_conda,
      anon_sym_cwl,
      anon_sym_default_target,
      anon_sym_envmodules,
      anon_sym_group,
      anon_sym_handover,
      anon_sym_localrule,
      anon_sym_params,
      anon_sym_priority,
      anon_sym_resources,
      anon_sym_retries,
      anon_sym_shadow,
      anon_sym_singularity,
      anon_sym_template_engine,
      anon_sym_threads,
      anon_sym_wrapper,
      anon_sym_run,
  [97821] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3288), 30,
      sym__dedent,
      sym_string_start,
      anon_sym_container,
      anon_sym_wildcard_constraints,
      anon_sym_benchmark,
      anon_sym_input,
      anon_sym_log,
      anon_sym_output,
      anon_sym_message,
      anon_sym_notebook,
      anon_sym_script,
      anon_sym_shell,
      anon_sym_cache,
      anon_sym_conda,
      anon_sym_cwl,
      anon_sym_default_target,
      anon_sym_envmodules,
      anon_sym_group,
      anon_sym_handover,
      anon_sym_localrule,
      anon_sym_params,
      anon_sym_priority,
      anon_sym_resources,
      anon_sym_retries,
      anon_sym_shadow,
      anon_sym_singularity,
      anon_sym_template_engine,
      anon_sym_threads,
      anon_sym_wrapper,
      anon_sym_run,
  [97858] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1018), 30,
      sym__dedent,
      sym_string_start,
      anon_sym_container,
      anon_sym_wildcard_constraints,
      anon_sym_benchmark,
      anon_sym_input,
      anon_sym_log,
      anon_sym_output,
      anon_sym_message,
      anon_sym_notebook,
      anon_sym_script,
      anon_sym_shell,
      anon_sym_cache,
      anon_sym_conda,
      anon_sym_cwl,
      anon_sym_default_target,
      anon_sym_envmodules,
      anon_sym_group,
      anon_sym_handover,
      anon_sym_localrule,
      anon_sym_params,
      anon_sym_priority,
      anon_sym_resources,
      anon_sym_retries,
      anon_sym_shadow,
      anon_sym_singularity,
      anon_sym_template_engine,
      anon_sym_threads,
      anon_sym_wrapper,
      anon_sym_run,
  [97895] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3290), 30,
      sym__dedent,
      sym_string_start,
      anon_sym_container,
      anon_sym_wildcard_constraints,
      anon_sym_benchmark,
      anon_sym_input,
      anon_sym_log,
      anon_sym_output,
      anon_sym_message,
      anon_sym_notebook,
      anon_sym_script,
      anon_sym_shell,
      anon_sym_cache,
      anon_sym_conda,
      anon_sym_cwl,
      anon_sym_default_target,
      anon_sym_envmodules,
      anon_sym_group,
      anon_sym_handover,
      anon_sym_localrule,
      anon_sym_params,
      anon_sym_priority,
      anon_sym_resources,
      anon_sym_retries,
      anon_sym_shadow,
      anon_sym_singularity,
      anon_sym_template_engine,
      anon_sym_threads,
      anon_sym_wrapper,
      anon_sym_run,
  [97932] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1036), 30,
      sym__dedent,
      sym_string_start,
      anon_sym_container,
      anon_sym_wildcard_constraints,
      anon_sym_benchmark,
      anon_sym_input,
      anon_sym_log,
      anon_sym_output,
      anon_sym_message,
      anon_sym_notebook,
      anon_sym_script,
      anon_sym_shell,
      anon_sym_cache,
      anon_sym_conda,
      anon_sym_cwl,
      anon_sym_default_target,
      anon_sym_envmodules,
      anon_sym_group,
      anon_sym_handover,
      anon_sym_localrule,
      anon_sym_params,
      anon_sym_priority,
      anon_sym_resources,
      anon_sym_retries,
      anon_sym_shadow,
      anon_sym_singularity,
      anon_sym_template_engine,
      anon_sym_threads,
      anon_sym_wrapper,
      anon_sym_run,
  [97969] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3292), 30,
      sym__dedent,
      sym_string_start,
      anon_sym_container,
      anon_sym_wildcard_constraints,
      anon_sym_benchmark,
      anon_sym_input,
      anon_sym_log,
      anon_sym_output,
      anon_sym_message,
      anon_sym_notebook,
      anon_sym_script,
      anon_sym_shell,
      anon_sym_cache,
      anon_sym_conda,
      anon_sym_cwl,
      anon_sym_default_target,
      anon_sym_envmodules,
      anon_sym_group,
      anon_sym_handover,
      anon_sym_localrule,
      anon_sym_params,
      anon_sym_priority,
      anon_sym_resources,
      anon_sym_retries,
      anon_sym_shadow,
      anon_sym_singularity,
      anon_sym_template_engine,
      anon_sym_threads,
      anon_sym_wrapper,
      anon_sym_run,
  [98006] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(976), 30,
      sym__dedent,
      sym_string_start,
      anon_sym_container,
      anon_sym_wildcard_constraints,
      anon_sym_benchmark,
      anon_sym_input,
      anon_sym_log,
      anon_sym_output,
      anon_sym_message,
      anon_sym_notebook,
      anon_sym_script,
      anon_sym_shell,
      anon_sym_cache,
      anon_sym_conda,
      anon_sym_cwl,
      anon_sym_default_target,
      anon_sym_envmodules,
      anon_sym_group,
      anon_sym_handover,
      anon_sym_localrule,
      anon_sym_params,
      anon_sym_priority,
      anon_sym_resources,
      anon_sym_retries,
      anon_sym_shadow,
      anon_sym_singularity,
      anon_sym_template_engine,
      anon_sym_threads,
      anon_sym_wrapper,
      anon_sym_run,
  [98043] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3294), 30,
      sym__dedent,
      sym_string_start,
      anon_sym_container,
      anon_sym_wildcard_constraints,
      anon_sym_benchmark,
      anon_sym_input,
      anon_sym_log,
      anon_sym_output,
      anon_sym_message,
      anon_sym_notebook,
      anon_sym_script,
      anon_sym_shell,
      anon_sym_cache,
      anon_sym_conda,
      anon_sym_cwl,
      anon_sym_default_target,
      anon_sym_envmodules,
      anon_sym_group,
      anon_sym_handover,
      anon_sym_localrule,
      anon_sym_params,
      anon_sym_priority,
      anon_sym_resources,
      anon_sym_retries,
      anon_sym_shadow,
      anon_sym_singularity,
      anon_sym_template_engine,
      anon_sym_threads,
      anon_sym_wrapper,
      anon_sym_run,
  [98080] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3296), 30,
      sym__dedent,
      sym_string_start,
      anon_sym_container,
      anon_sym_wildcard_constraints,
      anon_sym_benchmark,
      anon_sym_input,
      anon_sym_log,
      anon_sym_output,
      anon_sym_message,
      anon_sym_notebook,
      anon_sym_script,
      anon_sym_shell,
      anon_sym_cache,
      anon_sym_conda,
      anon_sym_cwl,
      anon_sym_default_target,
      anon_sym_envmodules,
      anon_sym_group,
      anon_sym_handover,
      anon_sym_localrule,
      anon_sym_params,
      anon_sym_priority,
      anon_sym_resources,
      anon_sym_retries,
      anon_sym_shadow,
      anon_sym_singularity,
      anon_sym_template_engine,
      anon_sym_threads,
      anon_sym_wrapper,
      anon_sym_run,
  [98117] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1070), 30,
      sym__dedent,
      sym_string_start,
      anon_sym_container,
      anon_sym_wildcard_constraints,
      anon_sym_benchmark,
      anon_sym_input,
      anon_sym_log,
      anon_sym_output,
      anon_sym_message,
      anon_sym_notebook,
      anon_sym_script,
      anon_sym_shell,
      anon_sym_cache,
      anon_sym_conda,
      anon_sym_cwl,
      anon_sym_default_target,
      anon_sym_envmodules,
      anon_sym_group,
      anon_sym_handover,
      anon_sym_localrule,
      anon_sym_params,
      anon_sym_priority,
      anon_sym_resources,
      anon_sym_retries,
      anon_sym_shadow,
      anon_sym_singularity,
      anon_sym_template_engine,
      anon_sym_threads,
      anon_sym_wrapper,
      anon_sym_run,
  [98154] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3298), 30,
      sym__dedent,
      sym_string_start,
      anon_sym_container,
      anon_sym_wildcard_constraints,
      anon_sym_benchmark,
      anon_sym_input,
      anon_sym_log,
      anon_sym_output,
      anon_sym_message,
      anon_sym_notebook,
      anon_sym_script,
      anon_sym_shell,
      anon_sym_cache,
      anon_sym_conda,
      anon_sym_cwl,
      anon_sym_default_target,
      anon_sym_envmodules,
      anon_sym_group,
      anon_sym_handover,
      anon_sym_localrule,
      anon_sym_params,
      anon_sym_priority,
      anon_sym_resources,
      anon_sym_retries,
      anon_sym_shadow,
      anon_sym_singularity,
      anon_sym_template_engine,
      anon_sym_threads,
      anon_sym_wrapper,
      anon_sym_run,
  [98191] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3300), 30,
      sym__dedent,
      sym_string_start,
      anon_sym_container,
      anon_sym_wildcard_constraints,
      anon_sym_benchmark,
      anon_sym_input,
      anon_sym_log,
      anon_sym_output,
      anon_sym_message,
      anon_sym_notebook,
      anon_sym_script,
      anon_sym_shell,
      anon_sym_cache,
      anon_sym_conda,
      anon_sym_cwl,
      anon_sym_default_target,
      anon_sym_envmodules,
      anon_sym_group,
      anon_sym_handover,
      anon_sym_localrule,
      anon_sym_params,
      anon_sym_priority,
      anon_sym_resources,
      anon_sym_retries,
      anon_sym_shadow,
      anon_sym_singularity,
      anon_sym_template_engine,
      anon_sym_threads,
      anon_sym_wrapper,
      anon_sym_run,
  [98228] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(996), 30,
      sym__dedent,
      sym_string_start,
      anon_sym_container,
      anon_sym_wildcard_constraints,
      anon_sym_benchmark,
      anon_sym_input,
      anon_sym_log,
      anon_sym_output,
      anon_sym_message,
      anon_sym_notebook,
      anon_sym_script,
      anon_sym_shell,
      anon_sym_cache,
      anon_sym_conda,
      anon_sym_cwl,
      anon_sym_default_target,
      anon_sym_envmodules,
      anon_sym_group,
      anon_sym_handover,
      anon_sym_localrule,
      anon_sym_params,
      anon_sym_priority,
      anon_sym_resources,
      anon_sym_retries,
      anon_sym_shadow,
      anon_sym_singularity,
      anon_sym_template_engine,
      anon_sym_threads,
      anon_sym_wrapper,
      anon_sym_run,
  [98265] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1028), 30,
      sym__dedent,
      sym_string_start,
      anon_sym_container,
      anon_sym_wildcard_constraints,
      anon_sym_benchmark,
      anon_sym_input,
      anon_sym_log,
      anon_sym_output,
      anon_sym_message,
      anon_sym_notebook,
      anon_sym_script,
      anon_sym_shell,
      anon_sym_cache,
      anon_sym_conda,
      anon_sym_cwl,
      anon_sym_default_target,
      anon_sym_envmodules,
      anon_sym_group,
      anon_sym_handover,
      anon_sym_localrule,
      anon_sym_params,
      anon_sym_priority,
      anon_sym_resources,
      anon_sym_retries,
      anon_sym_shadow,
      anon_sym_singularity,
      anon_sym_template_engine,
      anon_sym_threads,
      anon_sym_wrapper,
      anon_sym_run,
  [98302] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3302), 30,
      sym__dedent,
      sym_string_start,
      anon_sym_container,
      anon_sym_wildcard_constraints,
      anon_sym_benchmark,
      anon_sym_input,
      anon_sym_log,
      anon_sym_output,
      anon_sym_message,
      anon_sym_notebook,
      anon_sym_script,
      anon_sym_shell,
      anon_sym_cache,
      anon_sym_conda,
      anon_sym_cwl,
      anon_sym_default_target,
      anon_sym_envmodules,
      anon_sym_group,
      anon_sym_handover,
      anon_sym_localrule,
      anon_sym_params,
      anon_sym_priority,
      anon_sym_resources,
      anon_sym_retries,
      anon_sym_shadow,
      anon_sym_singularity,
      anon_sym_template_engine,
      anon_sym_threads,
      anon_sym_wrapper,
      anon_sym_run,
  [98339] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3304), 30,
      sym__dedent,
      sym_string_start,
      anon_sym_container,
      anon_sym_wildcard_constraints,
      anon_sym_benchmark,
      anon_sym_input,
      anon_sym_log,
      anon_sym_output,
      anon_sym_message,
      anon_sym_notebook,
      anon_sym_script,
      anon_sym_shell,
      anon_sym_cache,
      anon_sym_conda,
      anon_sym_cwl,
      anon_sym_default_target,
      anon_sym_envmodules,
      anon_sym_group,
      anon_sym_handover,
      anon_sym_localrule,
      anon_sym_params,
      anon_sym_priority,
      anon_sym_resources,
      anon_sym_retries,
      anon_sym_shadow,
      anon_sym_singularity,
      anon_sym_template_engine,
      anon_sym_threads,
      anon_sym_wrapper,
      anon_sym_run,
  [98376] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3304), 30,
      sym__dedent,
      sym_string_start,
      anon_sym_container,
      anon_sym_wildcard_constraints,
      anon_sym_benchmark,
      anon_sym_input,
      anon_sym_log,
      anon_sym_output,
      anon_sym_message,
      anon_sym_notebook,
      anon_sym_script,
      anon_sym_shell,
      anon_sym_cache,
      anon_sym_conda,
      anon_sym_cwl,
      anon_sym_default_target,
      anon_sym_envmodules,
      anon_sym_group,
      anon_sym_handover,
      anon_sym_localrule,
      anon_sym_params,
      anon_sym_priority,
      anon_sym_resources,
      anon_sym_retries,
      anon_sym_shadow,
      anon_sym_singularity,
      anon_sym_template_engine,
      anon_sym_threads,
      anon_sym_wrapper,
      anon_sym_run,
  [98413] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3306), 30,
      sym__dedent,
      sym_string_start,
      anon_sym_container,
      anon_sym_wildcard_constraints,
      anon_sym_benchmark,
      anon_sym_input,
      anon_sym_log,
      anon_sym_output,
      anon_sym_message,
      anon_sym_notebook,
      anon_sym_script,
      anon_sym_shell,
      anon_sym_cache,
      anon_sym_conda,
      anon_sym_cwl,
      anon_sym_default_target,
      anon_sym_envmodules,
      anon_sym_group,
      anon_sym_handover,
      anon_sym_localrule,
      anon_sym_params,
      anon_sym_priority,
      anon_sym_resources,
      anon_sym_retries,
      anon_sym_shadow,
      anon_sym_singularity,
      anon_sym_template_engine,
      anon_sym_threads,
      anon_sym_wrapper,
      anon_sym_run,
  [98450] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3308), 30,
      sym__dedent,
      sym_string_start,
      anon_sym_container,
      anon_sym_wildcard_constraints,
      anon_sym_benchmark,
      anon_sym_input,
      anon_sym_log,
      anon_sym_output,
      anon_sym_message,
      anon_sym_notebook,
      anon_sym_script,
      anon_sym_shell,
      anon_sym_cache,
      anon_sym_conda,
      anon_sym_cwl,
      anon_sym_default_target,
      anon_sym_envmodules,
      anon_sym_group,
      anon_sym_handover,
      anon_sym_localrule,
      anon_sym_params,
      anon_sym_priority,
      anon_sym_resources,
      anon_sym_retries,
      anon_sym_shadow,
      anon_sym_singularity,
      anon_sym_template_engine,
      anon_sym_threads,
      anon_sym_wrapper,
      anon_sym_run,
  [98487] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3310), 30,
      sym__dedent,
      sym_string_start,
      anon_sym_container,
      anon_sym_wildcard_constraints,
      anon_sym_benchmark,
      anon_sym_input,
      anon_sym_log,
      anon_sym_output,
      anon_sym_message,
      anon_sym_notebook,
      anon_sym_script,
      anon_sym_shell,
      anon_sym_cache,
      anon_sym_conda,
      anon_sym_cwl,
      anon_sym_default_target,
      anon_sym_envmodules,
      anon_sym_group,
      anon_sym_handover,
      anon_sym_localrule,
      anon_sym_params,
      anon_sym_priority,
      anon_sym_resources,
      anon_sym_retries,
      anon_sym_shadow,
      anon_sym_singularity,
      anon_sym_template_engine,
      anon_sym_threads,
      anon_sym_wrapper,
      anon_sym_run,
  [98524] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3304), 30,
      sym__dedent,
      sym_string_start,
      anon_sym_container,
      anon_sym_wildcard_constraints,
      anon_sym_benchmark,
      anon_sym_input,
      anon_sym_log,
      anon_sym_output,
      anon_sym_message,
      anon_sym_notebook,
      anon_sym_script,
      anon_sym_shell,
      anon_sym_cache,
      anon_sym_conda,
      anon_sym_cwl,
      anon_sym_default_target,
      anon_sym_envmodules,
      anon_sym_group,
      anon_sym_handover,
      anon_sym_localrule,
      anon_sym_params,
      anon_sym_priority,
      anon_sym_resources,
      anon_sym_retries,
      anon_sym_shadow,
      anon_sym_singularity,
      anon_sym_template_engine,
      anon_sym_threads,
      anon_sym_wrapper,
      anon_sym_run,
  [98561] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3312), 30,
      sym__dedent,
      sym_string_start,
      anon_sym_container,
      anon_sym_wildcard_constraints,
      anon_sym_benchmark,
      anon_sym_input,
      anon_sym_log,
      anon_sym_output,
      anon_sym_message,
      anon_sym_notebook,
      anon_sym_script,
      anon_sym_shell,
      anon_sym_cache,
      anon_sym_conda,
      anon_sym_cwl,
      anon_sym_default_target,
      anon_sym_envmodules,
      anon_sym_group,
      anon_sym_handover,
      anon_sym_localrule,
      anon_sym_params,
      anon_sym_priority,
      anon_sym_resources,
      anon_sym_retries,
      anon_sym_shadow,
      anon_sym_singularity,
      anon_sym_template_engine,
      anon_sym_threads,
      anon_sym_wrapper,
      anon_sym_run,
  [98598] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(968), 30,
      sym__dedent,
      sym_string_start,
      anon_sym_container,
      anon_sym_wildcard_constraints,
      anon_sym_benchmark,
      anon_sym_input,
      anon_sym_log,
      anon_sym_output,
      anon_sym_message,
      anon_sym_notebook,
      anon_sym_script,
      anon_sym_shell,
      anon_sym_cache,
      anon_sym_conda,
      anon_sym_cwl,
      anon_sym_default_target,
      anon_sym_envmodules,
      anon_sym_group,
      anon_sym_handover,
      anon_sym_localrule,
      anon_sym_params,
      anon_sym_priority,
      anon_sym_resources,
      anon_sym_retries,
      anon_sym_shadow,
      anon_sym_singularity,
      anon_sym_template_engine,
      anon_sym_threads,
      anon_sym_wrapper,
      anon_sym_run,
  [98635] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3314), 30,
      sym__dedent,
      sym_string_start,
      anon_sym_container,
      anon_sym_wildcard_constraints,
      anon_sym_benchmark,
      anon_sym_input,
      anon_sym_log,
      anon_sym_output,
      anon_sym_message,
      anon_sym_notebook,
      anon_sym_script,
      anon_sym_shell,
      anon_sym_cache,
      anon_sym_conda,
      anon_sym_cwl,
      anon_sym_default_target,
      anon_sym_envmodules,
      anon_sym_group,
      anon_sym_handover,
      anon_sym_localrule,
      anon_sym_params,
      anon_sym_priority,
      anon_sym_resources,
      anon_sym_retries,
      anon_sym_shadow,
      anon_sym_singularity,
      anon_sym_template_engine,
      anon_sym_threads,
      anon_sym_wrapper,
      anon_sym_run,
  [98672] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2823), 30,
      sym__dedent,
      sym_string_start,
      anon_sym_container,
      anon_sym_wildcard_constraints,
      anon_sym_benchmark,
      anon_sym_input,
      anon_sym_log,
      anon_sym_output,
      anon_sym_message,
      anon_sym_notebook,
      anon_sym_script,
      anon_sym_shell,
      anon_sym_cache,
      anon_sym_conda,
      anon_sym_cwl,
      anon_sym_default_target,
      anon_sym_envmodules,
      anon_sym_group,
      anon_sym_handover,
      anon_sym_localrule,
      anon_sym_params,
      anon_sym_priority,
      anon_sym_resources,
      anon_sym_retries,
      anon_sym_shadow,
      anon_sym_singularity,
      anon_sym_template_engine,
      anon_sym_threads,
      anon_sym_wrapper,
      anon_sym_run,
  [98709] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3316), 30,
      sym__dedent,
      sym_string_start,
      anon_sym_container,
      anon_sym_wildcard_constraints,
      anon_sym_benchmark,
      anon_sym_input,
      anon_sym_log,
      anon_sym_output,
      anon_sym_message,
      anon_sym_notebook,
      anon_sym_script,
      anon_sym_shell,
      anon_sym_cache,
      anon_sym_conda,
      anon_sym_cwl,
      anon_sym_default_target,
      anon_sym_envmodules,
      anon_sym_group,
      anon_sym_handover,
      anon_sym_localrule,
      anon_sym_params,
      anon_sym_priority,
      anon_sym_resources,
      anon_sym_retries,
      anon_sym_shadow,
      anon_sym_singularity,
      anon_sym_template_engine,
      anon_sym_threads,
      anon_sym_wrapper,
      anon_sym_run,
  [98746] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1092), 30,
      sym__dedent,
      sym_string_start,
      anon_sym_container,
      anon_sym_wildcard_constraints,
      anon_sym_benchmark,
      anon_sym_input,
      anon_sym_log,
      anon_sym_output,
      anon_sym_message,
      anon_sym_notebook,
      anon_sym_script,
      anon_sym_shell,
      anon_sym_cache,
      anon_sym_conda,
      anon_sym_cwl,
      anon_sym_default_target,
      anon_sym_envmodules,
      anon_sym_group,
      anon_sym_handover,
      anon_sym_localrule,
      anon_sym_params,
      anon_sym_priority,
      anon_sym_resources,
      anon_sym_retries,
      anon_sym_shadow,
      anon_sym_singularity,
      anon_sym_template_engine,
      anon_sym_threads,
      anon_sym_wrapper,
      anon_sym_run,
  [98783] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3318), 30,
      sym__dedent,
      sym_string_start,
      anon_sym_container,
      anon_sym_wildcard_constraints,
      anon_sym_benchmark,
      anon_sym_input,
      anon_sym_log,
      anon_sym_output,
      anon_sym_message,
      anon_sym_notebook,
      anon_sym_script,
      anon_sym_shell,
      anon_sym_cache,
      anon_sym_conda,
      anon_sym_cwl,
      anon_sym_default_target,
      anon_sym_envmodules,
      anon_sym_group,
      anon_sym_handover,
      anon_sym_localrule,
      anon_sym_params,
      anon_sym_priority,
      anon_sym_resources,
      anon_sym_retries,
      anon_sym_shadow,
      anon_sym_singularity,
      anon_sym_template_engine,
      anon_sym_threads,
      anon_sym_wrapper,
      anon_sym_run,
  [98820] = 18,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(3320), 1,
      sym_identifier,
    ACTIONS(3322), 1,
      anon_sym_LPAREN,
    ACTIONS(3324), 1,
      anon_sym_RPAREN,
    ACTIONS(3326), 1,
      anon_sym_STAR,
    ACTIONS(3328), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3330), 1,
      anon_sym_LBRACK,
    ACTIONS(3332), 1,
      anon_sym_DASH,
    ACTIONS(3336), 1,
      anon_sym_LBRACE,
    ACTIONS(3338), 1,
      sym_integer,
    ACTIONS(3340), 1,
      sym_float,
    STATE(2239), 1,
      sym_string,
    STATE(2495), 1,
      sym_dotted_name,
    STATE(2835), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2841), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(3334), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2494), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [98888] = 18,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(3342), 1,
      sym_identifier,
    ACTIONS(3344), 1,
      anon_sym_LPAREN,
    ACTIONS(3346), 1,
      anon_sym_STAR,
    ACTIONS(3348), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3350), 1,
      anon_sym_LBRACK,
    ACTIONS(3352), 1,
      anon_sym_RBRACK,
    ACTIONS(3354), 1,
      anon_sym_DASH,
    ACTIONS(3358), 1,
      anon_sym_LBRACE,
    ACTIONS(3360), 1,
      sym_integer,
    ACTIONS(3362), 1,
      sym_float,
    STATE(2257), 1,
      sym_string,
    STATE(2472), 1,
      sym_dotted_name,
    STATE(2782), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2778), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(3356), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2476), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [98956] = 18,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(3320), 1,
      sym_identifier,
    ACTIONS(3322), 1,
      anon_sym_LPAREN,
    ACTIONS(3326), 1,
      anon_sym_STAR,
    ACTIONS(3328), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3330), 1,
      anon_sym_LBRACK,
    ACTIONS(3332), 1,
      anon_sym_DASH,
    ACTIONS(3336), 1,
      anon_sym_LBRACE,
    ACTIONS(3338), 1,
      sym_integer,
    ACTIONS(3340), 1,
      sym_float,
    ACTIONS(3364), 1,
      anon_sym_RPAREN,
    STATE(2239), 1,
      sym_string,
    STATE(2495), 1,
      sym_dotted_name,
    STATE(2562), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2841), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(3334), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2494), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [99024] = 18,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(3320), 1,
      sym_identifier,
    ACTIONS(3322), 1,
      anon_sym_LPAREN,
    ACTIONS(3326), 1,
      anon_sym_STAR,
    ACTIONS(3328), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3330), 1,
      anon_sym_LBRACK,
    ACTIONS(3332), 1,
      anon_sym_DASH,
    ACTIONS(3336), 1,
      anon_sym_LBRACE,
    ACTIONS(3338), 1,
      sym_integer,
    ACTIONS(3340), 1,
      sym_float,
    ACTIONS(3366), 1,
      anon_sym_RPAREN,
    STATE(2239), 1,
      sym_string,
    STATE(2495), 1,
      sym_dotted_name,
    STATE(2835), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2841), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(3334), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2494), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [99092] = 18,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(3342), 1,
      sym_identifier,
    ACTIONS(3344), 1,
      anon_sym_LPAREN,
    ACTIONS(3346), 1,
      anon_sym_STAR,
    ACTIONS(3348), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3350), 1,
      anon_sym_LBRACK,
    ACTIONS(3354), 1,
      anon_sym_DASH,
    ACTIONS(3358), 1,
      anon_sym_LBRACE,
    ACTIONS(3360), 1,
      sym_integer,
    ACTIONS(3362), 1,
      sym_float,
    ACTIONS(3368), 1,
      anon_sym_RBRACK,
    STATE(2257), 1,
      sym_string,
    STATE(2472), 1,
      sym_dotted_name,
    STATE(2547), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2778), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(3356), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2476), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [99160] = 18,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(3320), 1,
      sym_identifier,
    ACTIONS(3322), 1,
      anon_sym_LPAREN,
    ACTIONS(3326), 1,
      anon_sym_STAR,
    ACTIONS(3328), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3330), 1,
      anon_sym_LBRACK,
    ACTIONS(3332), 1,
      anon_sym_DASH,
    ACTIONS(3336), 1,
      anon_sym_LBRACE,
    ACTIONS(3338), 1,
      sym_integer,
    ACTIONS(3340), 1,
      sym_float,
    ACTIONS(3370), 1,
      anon_sym_RPAREN,
    STATE(2239), 1,
      sym_string,
    STATE(2495), 1,
      sym_dotted_name,
    STATE(2835), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2841), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(3334), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2494), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [99228] = 18,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(3320), 1,
      sym_identifier,
    ACTIONS(3322), 1,
      anon_sym_LPAREN,
    ACTIONS(3326), 1,
      anon_sym_STAR,
    ACTIONS(3328), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3330), 1,
      anon_sym_LBRACK,
    ACTIONS(3332), 1,
      anon_sym_DASH,
    ACTIONS(3336), 1,
      anon_sym_LBRACE,
    ACTIONS(3338), 1,
      sym_integer,
    ACTIONS(3340), 1,
      sym_float,
    ACTIONS(3372), 1,
      anon_sym_RPAREN,
    STATE(2239), 1,
      sym_string,
    STATE(2495), 1,
      sym_dotted_name,
    STATE(2835), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2841), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(3334), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2494), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [99296] = 18,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(3320), 1,
      sym_identifier,
    ACTIONS(3322), 1,
      anon_sym_LPAREN,
    ACTIONS(3326), 1,
      anon_sym_STAR,
    ACTIONS(3328), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3330), 1,
      anon_sym_LBRACK,
    ACTIONS(3332), 1,
      anon_sym_DASH,
    ACTIONS(3336), 1,
      anon_sym_LBRACE,
    ACTIONS(3338), 1,
      sym_integer,
    ACTIONS(3340), 1,
      sym_float,
    ACTIONS(3374), 1,
      anon_sym_RPAREN,
    STATE(2239), 1,
      sym_string,
    STATE(2495), 1,
      sym_dotted_name,
    STATE(2579), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2841), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(3334), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2494), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [99364] = 18,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(3320), 1,
      sym_identifier,
    ACTIONS(3322), 1,
      anon_sym_LPAREN,
    ACTIONS(3326), 1,
      anon_sym_STAR,
    ACTIONS(3328), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3330), 1,
      anon_sym_LBRACK,
    ACTIONS(3332), 1,
      anon_sym_DASH,
    ACTIONS(3336), 1,
      anon_sym_LBRACE,
    ACTIONS(3338), 1,
      sym_integer,
    ACTIONS(3340), 1,
      sym_float,
    ACTIONS(3376), 1,
      anon_sym_RPAREN,
    STATE(2239), 1,
      sym_string,
    STATE(2495), 1,
      sym_dotted_name,
    STATE(2835), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2841), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(3334), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2494), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [99432] = 18,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(3320), 1,
      sym_identifier,
    ACTIONS(3322), 1,
      anon_sym_LPAREN,
    ACTIONS(3326), 1,
      anon_sym_STAR,
    ACTIONS(3328), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3330), 1,
      anon_sym_LBRACK,
    ACTIONS(3332), 1,
      anon_sym_DASH,
    ACTIONS(3336), 1,
      anon_sym_LBRACE,
    ACTIONS(3338), 1,
      sym_integer,
    ACTIONS(3340), 1,
      sym_float,
    ACTIONS(3378), 1,
      anon_sym_RPAREN,
    STATE(2239), 1,
      sym_string,
    STATE(2495), 1,
      sym_dotted_name,
    STATE(2835), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2841), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(3334), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2494), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [99500] = 18,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(3320), 1,
      sym_identifier,
    ACTIONS(3322), 1,
      anon_sym_LPAREN,
    ACTIONS(3326), 1,
      anon_sym_STAR,
    ACTIONS(3328), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3330), 1,
      anon_sym_LBRACK,
    ACTIONS(3332), 1,
      anon_sym_DASH,
    ACTIONS(3336), 1,
      anon_sym_LBRACE,
    ACTIONS(3338), 1,
      sym_integer,
    ACTIONS(3340), 1,
      sym_float,
    ACTIONS(3380), 1,
      anon_sym_RPAREN,
    STATE(2239), 1,
      sym_string,
    STATE(2495), 1,
      sym_dotted_name,
    STATE(2583), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2841), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(3334), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2494), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [99568] = 18,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(3342), 1,
      sym_identifier,
    ACTIONS(3344), 1,
      anon_sym_LPAREN,
    ACTIONS(3346), 1,
      anon_sym_STAR,
    ACTIONS(3348), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3350), 1,
      anon_sym_LBRACK,
    ACTIONS(3354), 1,
      anon_sym_DASH,
    ACTIONS(3358), 1,
      anon_sym_LBRACE,
    ACTIONS(3360), 1,
      sym_integer,
    ACTIONS(3362), 1,
      sym_float,
    ACTIONS(3382), 1,
      anon_sym_RBRACK,
    STATE(2257), 1,
      sym_string,
    STATE(2472), 1,
      sym_dotted_name,
    STATE(2782), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2778), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(3356), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2476), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [99636] = 18,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(3320), 1,
      sym_identifier,
    ACTIONS(3322), 1,
      anon_sym_LPAREN,
    ACTIONS(3326), 1,
      anon_sym_STAR,
    ACTIONS(3328), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3330), 1,
      anon_sym_LBRACK,
    ACTIONS(3332), 1,
      anon_sym_DASH,
    ACTIONS(3336), 1,
      anon_sym_LBRACE,
    ACTIONS(3338), 1,
      sym_integer,
    ACTIONS(3340), 1,
      sym_float,
    ACTIONS(3384), 1,
      anon_sym_RPAREN,
    STATE(2239), 1,
      sym_string,
    STATE(2495), 1,
      sym_dotted_name,
    STATE(2661), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2841), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(3334), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2494), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [99704] = 18,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(3320), 1,
      sym_identifier,
    ACTIONS(3322), 1,
      anon_sym_LPAREN,
    ACTIONS(3326), 1,
      anon_sym_STAR,
    ACTIONS(3328), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3330), 1,
      anon_sym_LBRACK,
    ACTIONS(3332), 1,
      anon_sym_DASH,
    ACTIONS(3336), 1,
      anon_sym_LBRACE,
    ACTIONS(3338), 1,
      sym_integer,
    ACTIONS(3340), 1,
      sym_float,
    ACTIONS(3386), 1,
      anon_sym_RPAREN,
    STATE(2239), 1,
      sym_string,
    STATE(2495), 1,
      sym_dotted_name,
    STATE(2835), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2841), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(3334), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2494), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [99772] = 18,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(3342), 1,
      sym_identifier,
    ACTIONS(3344), 1,
      anon_sym_LPAREN,
    ACTIONS(3346), 1,
      anon_sym_STAR,
    ACTIONS(3348), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3350), 1,
      anon_sym_LBRACK,
    ACTIONS(3354), 1,
      anon_sym_DASH,
    ACTIONS(3358), 1,
      anon_sym_LBRACE,
    ACTIONS(3360), 1,
      sym_integer,
    ACTIONS(3362), 1,
      sym_float,
    ACTIONS(3388), 1,
      anon_sym_RBRACK,
    STATE(2257), 1,
      sym_string,
    STATE(2472), 1,
      sym_dotted_name,
    STATE(2782), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2778), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(3356), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2476), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [99840] = 18,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(3320), 1,
      sym_identifier,
    ACTIONS(3322), 1,
      anon_sym_LPAREN,
    ACTIONS(3326), 1,
      anon_sym_STAR,
    ACTIONS(3328), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3330), 1,
      anon_sym_LBRACK,
    ACTIONS(3332), 1,
      anon_sym_DASH,
    ACTIONS(3336), 1,
      anon_sym_LBRACE,
    ACTIONS(3338), 1,
      sym_integer,
    ACTIONS(3340), 1,
      sym_float,
    ACTIONS(3390), 1,
      anon_sym_RPAREN,
    STATE(2239), 1,
      sym_string,
    STATE(2495), 1,
      sym_dotted_name,
    STATE(2539), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2841), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(3334), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2494), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [99908] = 18,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(3342), 1,
      sym_identifier,
    ACTIONS(3344), 1,
      anon_sym_LPAREN,
    ACTIONS(3346), 1,
      anon_sym_STAR,
    ACTIONS(3348), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3350), 1,
      anon_sym_LBRACK,
    ACTIONS(3354), 1,
      anon_sym_DASH,
    ACTIONS(3358), 1,
      anon_sym_LBRACE,
    ACTIONS(3360), 1,
      sym_integer,
    ACTIONS(3362), 1,
      sym_float,
    ACTIONS(3392), 1,
      anon_sym_RBRACK,
    STATE(2257), 1,
      sym_string,
    STATE(2472), 1,
      sym_dotted_name,
    STATE(2782), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2778), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(3356), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2476), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [99976] = 18,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(3320), 1,
      sym_identifier,
    ACTIONS(3322), 1,
      anon_sym_LPAREN,
    ACTIONS(3326), 1,
      anon_sym_STAR,
    ACTIONS(3328), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3330), 1,
      anon_sym_LBRACK,
    ACTIONS(3332), 1,
      anon_sym_DASH,
    ACTIONS(3336), 1,
      anon_sym_LBRACE,
    ACTIONS(3338), 1,
      sym_integer,
    ACTIONS(3340), 1,
      sym_float,
    ACTIONS(3394), 1,
      anon_sym_RPAREN,
    STATE(2239), 1,
      sym_string,
    STATE(2495), 1,
      sym_dotted_name,
    STATE(2552), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2841), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(3334), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2494), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [100044] = 18,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(3320), 1,
      sym_identifier,
    ACTIONS(3322), 1,
      anon_sym_LPAREN,
    ACTIONS(3326), 1,
      anon_sym_STAR,
    ACTIONS(3328), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3330), 1,
      anon_sym_LBRACK,
    ACTIONS(3332), 1,
      anon_sym_DASH,
    ACTIONS(3336), 1,
      anon_sym_LBRACE,
    ACTIONS(3338), 1,
      sym_integer,
    ACTIONS(3340), 1,
      sym_float,
    ACTIONS(3396), 1,
      anon_sym_RPAREN,
    STATE(2239), 1,
      sym_string,
    STATE(2495), 1,
      sym_dotted_name,
    STATE(2835), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2841), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(3334), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2494), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [100112] = 18,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(3342), 1,
      sym_identifier,
    ACTIONS(3344), 1,
      anon_sym_LPAREN,
    ACTIONS(3346), 1,
      anon_sym_STAR,
    ACTIONS(3348), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3350), 1,
      anon_sym_LBRACK,
    ACTIONS(3354), 1,
      anon_sym_DASH,
    ACTIONS(3358), 1,
      anon_sym_LBRACE,
    ACTIONS(3360), 1,
      sym_integer,
    ACTIONS(3362), 1,
      sym_float,
    ACTIONS(3398), 1,
      anon_sym_RBRACK,
    STATE(2257), 1,
      sym_string,
    STATE(2472), 1,
      sym_dotted_name,
    STATE(2558), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2778), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(3356), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2476), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [100180] = 18,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(3320), 1,
      sym_identifier,
    ACTIONS(3322), 1,
      anon_sym_LPAREN,
    ACTIONS(3326), 1,
      anon_sym_STAR,
    ACTIONS(3328), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3330), 1,
      anon_sym_LBRACK,
    ACTIONS(3332), 1,
      anon_sym_DASH,
    ACTIONS(3336), 1,
      anon_sym_LBRACE,
    ACTIONS(3338), 1,
      sym_integer,
    ACTIONS(3340), 1,
      sym_float,
    ACTIONS(3400), 1,
      anon_sym_RPAREN,
    STATE(2239), 1,
      sym_string,
    STATE(2495), 1,
      sym_dotted_name,
    STATE(2581), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2841), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(3334), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2494), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [100248] = 18,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(3320), 1,
      sym_identifier,
    ACTIONS(3322), 1,
      anon_sym_LPAREN,
    ACTIONS(3326), 1,
      anon_sym_STAR,
    ACTIONS(3328), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3330), 1,
      anon_sym_LBRACK,
    ACTIONS(3332), 1,
      anon_sym_DASH,
    ACTIONS(3336), 1,
      anon_sym_LBRACE,
    ACTIONS(3338), 1,
      sym_integer,
    ACTIONS(3340), 1,
      sym_float,
    ACTIONS(3402), 1,
      anon_sym_RPAREN,
    STATE(2239), 1,
      sym_string,
    STATE(2495), 1,
      sym_dotted_name,
    STATE(2835), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2841), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(3334), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2494), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [100316] = 18,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(3342), 1,
      sym_identifier,
    ACTIONS(3344), 1,
      anon_sym_LPAREN,
    ACTIONS(3346), 1,
      anon_sym_STAR,
    ACTIONS(3348), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3350), 1,
      anon_sym_LBRACK,
    ACTIONS(3354), 1,
      anon_sym_DASH,
    ACTIONS(3358), 1,
      anon_sym_LBRACE,
    ACTIONS(3360), 1,
      sym_integer,
    ACTIONS(3362), 1,
      sym_float,
    ACTIONS(3404), 1,
      anon_sym_RBRACK,
    STATE(2257), 1,
      sym_string,
    STATE(2472), 1,
      sym_dotted_name,
    STATE(2543), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2778), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(3356), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2476), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [100384] = 18,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(3320), 1,
      sym_identifier,
    ACTIONS(3322), 1,
      anon_sym_LPAREN,
    ACTIONS(3326), 1,
      anon_sym_STAR,
    ACTIONS(3328), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3330), 1,
      anon_sym_LBRACK,
    ACTIONS(3332), 1,
      anon_sym_DASH,
    ACTIONS(3336), 1,
      anon_sym_LBRACE,
    ACTIONS(3338), 1,
      sym_integer,
    ACTIONS(3340), 1,
      sym_float,
    ACTIONS(3406), 1,
      anon_sym_RPAREN,
    STATE(2239), 1,
      sym_string,
    STATE(2495), 1,
      sym_dotted_name,
    STATE(2835), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2841), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(3334), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2494), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [100452] = 18,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(3342), 1,
      sym_identifier,
    ACTIONS(3344), 1,
      anon_sym_LPAREN,
    ACTIONS(3346), 1,
      anon_sym_STAR,
    ACTIONS(3348), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3350), 1,
      anon_sym_LBRACK,
    ACTIONS(3354), 1,
      anon_sym_DASH,
    ACTIONS(3358), 1,
      anon_sym_LBRACE,
    ACTIONS(3360), 1,
      sym_integer,
    ACTIONS(3362), 1,
      sym_float,
    ACTIONS(3408), 1,
      anon_sym_RBRACK,
    STATE(2257), 1,
      sym_string,
    STATE(2472), 1,
      sym_dotted_name,
    STATE(2782), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2778), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(3356), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2476), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [100520] = 18,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(3342), 1,
      sym_identifier,
    ACTIONS(3344), 1,
      anon_sym_LPAREN,
    ACTIONS(3346), 1,
      anon_sym_STAR,
    ACTIONS(3348), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3350), 1,
      anon_sym_LBRACK,
    ACTIONS(3354), 1,
      anon_sym_DASH,
    ACTIONS(3358), 1,
      anon_sym_LBRACE,
    ACTIONS(3360), 1,
      sym_integer,
    ACTIONS(3362), 1,
      sym_float,
    ACTIONS(3410), 1,
      anon_sym_RBRACK,
    STATE(2257), 1,
      sym_string,
    STATE(2472), 1,
      sym_dotted_name,
    STATE(2580), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2778), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(3356), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2476), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [100588] = 18,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(3320), 1,
      sym_identifier,
    ACTIONS(3322), 1,
      anon_sym_LPAREN,
    ACTIONS(3326), 1,
      anon_sym_STAR,
    ACTIONS(3328), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3330), 1,
      anon_sym_LBRACK,
    ACTIONS(3332), 1,
      anon_sym_DASH,
    ACTIONS(3336), 1,
      anon_sym_LBRACE,
    ACTIONS(3338), 1,
      sym_integer,
    ACTIONS(3340), 1,
      sym_float,
    ACTIONS(3412), 1,
      anon_sym_RPAREN,
    STATE(2239), 1,
      sym_string,
    STATE(2495), 1,
      sym_dotted_name,
    STATE(2835), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2841), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(3334), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2494), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [100656] = 18,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(3320), 1,
      sym_identifier,
    ACTIONS(3322), 1,
      anon_sym_LPAREN,
    ACTIONS(3326), 1,
      anon_sym_STAR,
    ACTIONS(3328), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3330), 1,
      anon_sym_LBRACK,
    ACTIONS(3332), 1,
      anon_sym_DASH,
    ACTIONS(3336), 1,
      anon_sym_LBRACE,
    ACTIONS(3338), 1,
      sym_integer,
    ACTIONS(3340), 1,
      sym_float,
    ACTIONS(3414), 1,
      anon_sym_RPAREN,
    STATE(2239), 1,
      sym_string,
    STATE(2495), 1,
      sym_dotted_name,
    STATE(2835), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2841), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(3334), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2494), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [100724] = 18,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(3320), 1,
      sym_identifier,
    ACTIONS(3322), 1,
      anon_sym_LPAREN,
    ACTIONS(3326), 1,
      anon_sym_STAR,
    ACTIONS(3328), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3330), 1,
      anon_sym_LBRACK,
    ACTIONS(3332), 1,
      anon_sym_DASH,
    ACTIONS(3336), 1,
      anon_sym_LBRACE,
    ACTIONS(3338), 1,
      sym_integer,
    ACTIONS(3340), 1,
      sym_float,
    ACTIONS(3416), 1,
      anon_sym_RPAREN,
    STATE(2239), 1,
      sym_string,
    STATE(2495), 1,
      sym_dotted_name,
    STATE(2835), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2841), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(3334), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2494), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [100792] = 18,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(3342), 1,
      sym_identifier,
    ACTIONS(3344), 1,
      anon_sym_LPAREN,
    ACTIONS(3346), 1,
      anon_sym_STAR,
    ACTIONS(3348), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3350), 1,
      anon_sym_LBRACK,
    ACTIONS(3354), 1,
      anon_sym_DASH,
    ACTIONS(3358), 1,
      anon_sym_LBRACE,
    ACTIONS(3360), 1,
      sym_integer,
    ACTIONS(3362), 1,
      sym_float,
    ACTIONS(3418), 1,
      anon_sym_RBRACK,
    STATE(2257), 1,
      sym_string,
    STATE(2472), 1,
      sym_dotted_name,
    STATE(2782), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2778), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(3356), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2476), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [100860] = 18,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(3320), 1,
      sym_identifier,
    ACTIONS(3322), 1,
      anon_sym_LPAREN,
    ACTIONS(3326), 1,
      anon_sym_STAR,
    ACTIONS(3328), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3330), 1,
      anon_sym_LBRACK,
    ACTIONS(3332), 1,
      anon_sym_DASH,
    ACTIONS(3336), 1,
      anon_sym_LBRACE,
    ACTIONS(3338), 1,
      sym_integer,
    ACTIONS(3340), 1,
      sym_float,
    ACTIONS(3420), 1,
      anon_sym_RPAREN,
    STATE(2239), 1,
      sym_string,
    STATE(2495), 1,
      sym_dotted_name,
    STATE(2549), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2841), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(3334), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2494), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [100928] = 18,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(3342), 1,
      sym_identifier,
    ACTIONS(3344), 1,
      anon_sym_LPAREN,
    ACTIONS(3346), 1,
      anon_sym_STAR,
    ACTIONS(3348), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3350), 1,
      anon_sym_LBRACK,
    ACTIONS(3354), 1,
      anon_sym_DASH,
    ACTIONS(3358), 1,
      anon_sym_LBRACE,
    ACTIONS(3360), 1,
      sym_integer,
    ACTIONS(3362), 1,
      sym_float,
    ACTIONS(3422), 1,
      anon_sym_RBRACK,
    STATE(2257), 1,
      sym_string,
    STATE(2472), 1,
      sym_dotted_name,
    STATE(2782), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2778), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(3356), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2476), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [100996] = 18,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(3320), 1,
      sym_identifier,
    ACTIONS(3322), 1,
      anon_sym_LPAREN,
    ACTIONS(3326), 1,
      anon_sym_STAR,
    ACTIONS(3328), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3330), 1,
      anon_sym_LBRACK,
    ACTIONS(3332), 1,
      anon_sym_DASH,
    ACTIONS(3336), 1,
      anon_sym_LBRACE,
    ACTIONS(3338), 1,
      sym_integer,
    ACTIONS(3340), 1,
      sym_float,
    ACTIONS(3424), 1,
      anon_sym_RPAREN,
    STATE(2239), 1,
      sym_string,
    STATE(2495), 1,
      sym_dotted_name,
    STATE(2835), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2841), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(3334), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2494), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [101064] = 18,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(3342), 1,
      sym_identifier,
    ACTIONS(3344), 1,
      anon_sym_LPAREN,
    ACTIONS(3346), 1,
      anon_sym_STAR,
    ACTIONS(3348), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3350), 1,
      anon_sym_LBRACK,
    ACTIONS(3354), 1,
      anon_sym_DASH,
    ACTIONS(3358), 1,
      anon_sym_LBRACE,
    ACTIONS(3360), 1,
      sym_integer,
    ACTIONS(3362), 1,
      sym_float,
    ACTIONS(3426), 1,
      anon_sym_RBRACK,
    STATE(2257), 1,
      sym_string,
    STATE(2472), 1,
      sym_dotted_name,
    STATE(2782), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2778), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(3356), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2476), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [101132] = 18,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(3320), 1,
      sym_identifier,
    ACTIONS(3322), 1,
      anon_sym_LPAREN,
    ACTIONS(3326), 1,
      anon_sym_STAR,
    ACTIONS(3328), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3330), 1,
      anon_sym_LBRACK,
    ACTIONS(3332), 1,
      anon_sym_DASH,
    ACTIONS(3336), 1,
      anon_sym_LBRACE,
    ACTIONS(3338), 1,
      sym_integer,
    ACTIONS(3340), 1,
      sym_float,
    ACTIONS(3428), 1,
      anon_sym_RPAREN,
    STATE(2239), 1,
      sym_string,
    STATE(2495), 1,
      sym_dotted_name,
    STATE(2835), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2841), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(3334), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2494), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [101200] = 18,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(3320), 1,
      sym_identifier,
    ACTIONS(3322), 1,
      anon_sym_LPAREN,
    ACTIONS(3326), 1,
      anon_sym_STAR,
    ACTIONS(3328), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3330), 1,
      anon_sym_LBRACK,
    ACTIONS(3332), 1,
      anon_sym_DASH,
    ACTIONS(3336), 1,
      anon_sym_LBRACE,
    ACTIONS(3338), 1,
      sym_integer,
    ACTIONS(3340), 1,
      sym_float,
    ACTIONS(3430), 1,
      anon_sym_RPAREN,
    STATE(2239), 1,
      sym_string,
    STATE(2495), 1,
      sym_dotted_name,
    STATE(2835), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2841), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(3334), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2494), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [101268] = 17,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(3342), 1,
      sym_identifier,
    ACTIONS(3344), 1,
      anon_sym_LPAREN,
    ACTIONS(3346), 1,
      anon_sym_STAR,
    ACTIONS(3348), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3350), 1,
      anon_sym_LBRACK,
    ACTIONS(3354), 1,
      anon_sym_DASH,
    ACTIONS(3358), 1,
      anon_sym_LBRACE,
    ACTIONS(3360), 1,
      sym_integer,
    ACTIONS(3362), 1,
      sym_float,
    STATE(2257), 1,
      sym_string,
    STATE(2472), 1,
      sym_dotted_name,
    STATE(2782), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2778), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(3356), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2476), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [101333] = 17,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(3248), 1,
      sym_identifier,
    ACTIONS(3250), 1,
      anon_sym_LPAREN,
    ACTIONS(3252), 1,
      anon_sym_STAR,
    ACTIONS(3258), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3260), 1,
      anon_sym_LBRACK,
    ACTIONS(3262), 1,
      anon_sym_DASH,
    ACTIONS(3266), 1,
      anon_sym_LBRACE,
    ACTIONS(3268), 1,
      sym_integer,
    ACTIONS(3270), 1,
      sym_float,
    STATE(2177), 1,
      sym_string,
    STATE(2372), 1,
      sym_dotted_name,
    STATE(2375), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2607), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(3264), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2382), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [101398] = 17,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(3248), 1,
      sym_identifier,
    ACTIONS(3250), 1,
      anon_sym_LPAREN,
    ACTIONS(3252), 1,
      anon_sym_STAR,
    ACTIONS(3258), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3260), 1,
      anon_sym_LBRACK,
    ACTIONS(3262), 1,
      anon_sym_DASH,
    ACTIONS(3266), 1,
      anon_sym_LBRACE,
    ACTIONS(3268), 1,
      sym_integer,
    ACTIONS(3270), 1,
      sym_float,
    STATE(2177), 1,
      sym_string,
    STATE(2372), 1,
      sym_dotted_name,
    STATE(2540), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2607), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(3264), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2382), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [101463] = 17,
    ACTIONS(799), 1,
      sym_string_start,
    ACTIONS(3432), 1,
      sym_identifier,
    ACTIONS(3434), 1,
      anon_sym_LPAREN,
    ACTIONS(3436), 1,
      anon_sym_STAR,
    ACTIONS(3438), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3440), 1,
      anon_sym_LBRACK,
    ACTIONS(3442), 1,
      anon_sym_DASH,
    ACTIONS(3446), 1,
      anon_sym_LBRACE,
    ACTIONS(3448), 1,
      sym_integer,
    ACTIONS(3450), 1,
      sym_float,
    STATE(2253), 1,
      sym_string,
    STATE(2410), 1,
      sym_dotted_name,
    STATE(2999), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2773), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(3444), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2504), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [101528] = 17,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(3320), 1,
      sym_identifier,
    ACTIONS(3322), 1,
      anon_sym_LPAREN,
    ACTIONS(3326), 1,
      anon_sym_STAR,
    ACTIONS(3328), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3330), 1,
      anon_sym_LBRACK,
    ACTIONS(3332), 1,
      anon_sym_DASH,
    ACTIONS(3336), 1,
      anon_sym_LBRACE,
    ACTIONS(3338), 1,
      sym_integer,
    ACTIONS(3340), 1,
      sym_float,
    STATE(2239), 1,
      sym_string,
    STATE(2495), 1,
      sym_dotted_name,
    STATE(2835), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2841), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(3334), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2494), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [101593] = 18,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(3250), 1,
      anon_sym_LPAREN,
    ACTIONS(3260), 1,
      anon_sym_LBRACK,
    ACTIONS(3262), 1,
      anon_sym_DASH,
    ACTIONS(3266), 1,
      anon_sym_LBRACE,
    ACTIONS(3268), 1,
      sym_integer,
    ACTIONS(3270), 1,
      sym_float,
    ACTIONS(3436), 1,
      anon_sym_STAR,
    ACTIONS(3438), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3452), 1,
      sym_identifier,
    ACTIONS(3456), 1,
      anon_sym_RBRACE,
    STATE(2177), 1,
      sym_string,
    STATE(2372), 1,
      sym_dotted_name,
    STATE(2651), 1,
      sym_splat_pattern,
    STATE(3060), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3454), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2991), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [101659] = 18,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(3250), 1,
      anon_sym_LPAREN,
    ACTIONS(3260), 1,
      anon_sym_LBRACK,
    ACTIONS(3262), 1,
      anon_sym_DASH,
    ACTIONS(3266), 1,
      anon_sym_LBRACE,
    ACTIONS(3268), 1,
      sym_integer,
    ACTIONS(3270), 1,
      sym_float,
    ACTIONS(3436), 1,
      anon_sym_STAR,
    ACTIONS(3438), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3452), 1,
      sym_identifier,
    ACTIONS(3458), 1,
      anon_sym_RBRACE,
    STATE(2177), 1,
      sym_string,
    STATE(2372), 1,
      sym_dotted_name,
    STATE(2651), 1,
      sym_splat_pattern,
    STATE(3060), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3454), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2991), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [101725] = 18,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(3250), 1,
      anon_sym_LPAREN,
    ACTIONS(3260), 1,
      anon_sym_LBRACK,
    ACTIONS(3262), 1,
      anon_sym_DASH,
    ACTIONS(3266), 1,
      anon_sym_LBRACE,
    ACTIONS(3268), 1,
      sym_integer,
    ACTIONS(3270), 1,
      sym_float,
    ACTIONS(3436), 1,
      anon_sym_STAR,
    ACTIONS(3438), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3452), 1,
      sym_identifier,
    ACTIONS(3460), 1,
      anon_sym_RBRACE,
    STATE(2177), 1,
      sym_string,
    STATE(2372), 1,
      sym_dotted_name,
    STATE(2487), 1,
      sym_splat_pattern,
    STATE(2718), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3454), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2991), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [101791] = 18,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(3250), 1,
      anon_sym_LPAREN,
    ACTIONS(3260), 1,
      anon_sym_LBRACK,
    ACTIONS(3262), 1,
      anon_sym_DASH,
    ACTIONS(3266), 1,
      anon_sym_LBRACE,
    ACTIONS(3268), 1,
      sym_integer,
    ACTIONS(3270), 1,
      sym_float,
    ACTIONS(3436), 1,
      anon_sym_STAR,
    ACTIONS(3438), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3452), 1,
      sym_identifier,
    ACTIONS(3462), 1,
      anon_sym_RBRACE,
    STATE(2177), 1,
      sym_string,
    STATE(2372), 1,
      sym_dotted_name,
    STATE(2651), 1,
      sym_splat_pattern,
    STATE(3060), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3454), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2991), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [101857] = 18,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(3250), 1,
      anon_sym_LPAREN,
    ACTIONS(3260), 1,
      anon_sym_LBRACK,
    ACTIONS(3262), 1,
      anon_sym_DASH,
    ACTIONS(3266), 1,
      anon_sym_LBRACE,
    ACTIONS(3268), 1,
      sym_integer,
    ACTIONS(3270), 1,
      sym_float,
    ACTIONS(3436), 1,
      anon_sym_STAR,
    ACTIONS(3438), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3452), 1,
      sym_identifier,
    ACTIONS(3464), 1,
      anon_sym_RBRACE,
    STATE(2177), 1,
      sym_string,
    STATE(2372), 1,
      sym_dotted_name,
    STATE(2651), 1,
      sym_splat_pattern,
    STATE(3060), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3454), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2991), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [101923] = 18,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(3250), 1,
      anon_sym_LPAREN,
    ACTIONS(3260), 1,
      anon_sym_LBRACK,
    ACTIONS(3262), 1,
      anon_sym_DASH,
    ACTIONS(3266), 1,
      anon_sym_LBRACE,
    ACTIONS(3268), 1,
      sym_integer,
    ACTIONS(3270), 1,
      sym_float,
    ACTIONS(3436), 1,
      anon_sym_STAR,
    ACTIONS(3438), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3452), 1,
      sym_identifier,
    ACTIONS(3466), 1,
      anon_sym_RBRACE,
    STATE(2177), 1,
      sym_string,
    STATE(2372), 1,
      sym_dotted_name,
    STATE(2651), 1,
      sym_splat_pattern,
    STATE(3060), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3454), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2991), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [101989] = 18,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(3250), 1,
      anon_sym_LPAREN,
    ACTIONS(3260), 1,
      anon_sym_LBRACK,
    ACTIONS(3262), 1,
      anon_sym_DASH,
    ACTIONS(3266), 1,
      anon_sym_LBRACE,
    ACTIONS(3268), 1,
      sym_integer,
    ACTIONS(3270), 1,
      sym_float,
    ACTIONS(3436), 1,
      anon_sym_STAR,
    ACTIONS(3438), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3452), 1,
      sym_identifier,
    ACTIONS(3468), 1,
      anon_sym_RBRACE,
    STATE(2177), 1,
      sym_string,
    STATE(2372), 1,
      sym_dotted_name,
    STATE(2651), 1,
      sym_splat_pattern,
    STATE(3060), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3454), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2991), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [102055] = 18,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(3250), 1,
      anon_sym_LPAREN,
    ACTIONS(3260), 1,
      anon_sym_LBRACK,
    ACTIONS(3262), 1,
      anon_sym_DASH,
    ACTIONS(3266), 1,
      anon_sym_LBRACE,
    ACTIONS(3268), 1,
      sym_integer,
    ACTIONS(3270), 1,
      sym_float,
    ACTIONS(3436), 1,
      anon_sym_STAR,
    ACTIONS(3438), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3452), 1,
      sym_identifier,
    ACTIONS(3470), 1,
      anon_sym_RBRACE,
    STATE(2177), 1,
      sym_string,
    STATE(2372), 1,
      sym_dotted_name,
    STATE(2651), 1,
      sym_splat_pattern,
    STATE(3060), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3454), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2991), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [102121] = 18,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(3250), 1,
      anon_sym_LPAREN,
    ACTIONS(3260), 1,
      anon_sym_LBRACK,
    ACTIONS(3262), 1,
      anon_sym_DASH,
    ACTIONS(3266), 1,
      anon_sym_LBRACE,
    ACTIONS(3268), 1,
      sym_integer,
    ACTIONS(3270), 1,
      sym_float,
    ACTIONS(3436), 1,
      anon_sym_STAR,
    ACTIONS(3438), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3452), 1,
      sym_identifier,
    ACTIONS(3472), 1,
      anon_sym_RBRACE,
    STATE(2177), 1,
      sym_string,
    STATE(2372), 1,
      sym_dotted_name,
    STATE(2525), 1,
      sym_splat_pattern,
    STATE(2981), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3454), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2991), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [102187] = 18,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(3250), 1,
      anon_sym_LPAREN,
    ACTIONS(3260), 1,
      anon_sym_LBRACK,
    ACTIONS(3262), 1,
      anon_sym_DASH,
    ACTIONS(3266), 1,
      anon_sym_LBRACE,
    ACTIONS(3268), 1,
      sym_integer,
    ACTIONS(3270), 1,
      sym_float,
    ACTIONS(3436), 1,
      anon_sym_STAR,
    ACTIONS(3438), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3452), 1,
      sym_identifier,
    ACTIONS(3474), 1,
      anon_sym_RBRACE,
    STATE(2177), 1,
      sym_string,
    STATE(2372), 1,
      sym_dotted_name,
    STATE(2651), 1,
      sym_splat_pattern,
    STATE(3060), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3454), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2991), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [102253] = 18,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(3250), 1,
      anon_sym_LPAREN,
    ACTIONS(3260), 1,
      anon_sym_LBRACK,
    ACTIONS(3262), 1,
      anon_sym_DASH,
    ACTIONS(3266), 1,
      anon_sym_LBRACE,
    ACTIONS(3268), 1,
      sym_integer,
    ACTIONS(3270), 1,
      sym_float,
    ACTIONS(3436), 1,
      anon_sym_STAR,
    ACTIONS(3438), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3452), 1,
      sym_identifier,
    ACTIONS(3476), 1,
      anon_sym_RBRACE,
    STATE(2177), 1,
      sym_string,
    STATE(2372), 1,
      sym_dotted_name,
    STATE(2651), 1,
      sym_splat_pattern,
    STATE(3060), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3454), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2991), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [102319] = 18,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(3250), 1,
      anon_sym_LPAREN,
    ACTIONS(3260), 1,
      anon_sym_LBRACK,
    ACTIONS(3262), 1,
      anon_sym_DASH,
    ACTIONS(3266), 1,
      anon_sym_LBRACE,
    ACTIONS(3268), 1,
      sym_integer,
    ACTIONS(3270), 1,
      sym_float,
    ACTIONS(3436), 1,
      anon_sym_STAR,
    ACTIONS(3438), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3452), 1,
      sym_identifier,
    ACTIONS(3478), 1,
      anon_sym_RBRACE,
    STATE(2177), 1,
      sym_string,
    STATE(2372), 1,
      sym_dotted_name,
    STATE(2651), 1,
      sym_splat_pattern,
    STATE(3060), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3454), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2991), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [102385] = 18,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(3250), 1,
      anon_sym_LPAREN,
    ACTIONS(3260), 1,
      anon_sym_LBRACK,
    ACTIONS(3262), 1,
      anon_sym_DASH,
    ACTIONS(3266), 1,
      anon_sym_LBRACE,
    ACTIONS(3268), 1,
      sym_integer,
    ACTIONS(3270), 1,
      sym_float,
    ACTIONS(3436), 1,
      anon_sym_STAR,
    ACTIONS(3438), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3452), 1,
      sym_identifier,
    ACTIONS(3480), 1,
      anon_sym_RBRACE,
    STATE(2177), 1,
      sym_string,
    STATE(2372), 1,
      sym_dotted_name,
    STATE(2651), 1,
      sym_splat_pattern,
    STATE(3060), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3454), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2991), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [102451] = 18,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(3250), 1,
      anon_sym_LPAREN,
    ACTIONS(3260), 1,
      anon_sym_LBRACK,
    ACTIONS(3262), 1,
      anon_sym_DASH,
    ACTIONS(3266), 1,
      anon_sym_LBRACE,
    ACTIONS(3268), 1,
      sym_integer,
    ACTIONS(3270), 1,
      sym_float,
    ACTIONS(3436), 1,
      anon_sym_STAR,
    ACTIONS(3438), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3452), 1,
      sym_identifier,
    ACTIONS(3482), 1,
      anon_sym_RBRACE,
    STATE(2177), 1,
      sym_string,
    STATE(2372), 1,
      sym_dotted_name,
    STATE(2651), 1,
      sym_splat_pattern,
    STATE(3060), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3454), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2991), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [102517] = 18,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(3250), 1,
      anon_sym_LPAREN,
    ACTIONS(3260), 1,
      anon_sym_LBRACK,
    ACTIONS(3262), 1,
      anon_sym_DASH,
    ACTIONS(3266), 1,
      anon_sym_LBRACE,
    ACTIONS(3268), 1,
      sym_integer,
    ACTIONS(3270), 1,
      sym_float,
    ACTIONS(3436), 1,
      anon_sym_STAR,
    ACTIONS(3438), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3452), 1,
      sym_identifier,
    ACTIONS(3484), 1,
      anon_sym_RBRACE,
    STATE(2177), 1,
      sym_string,
    STATE(2372), 1,
      sym_dotted_name,
    STATE(2651), 1,
      sym_splat_pattern,
    STATE(3060), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3454), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2991), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [102583] = 18,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(3250), 1,
      anon_sym_LPAREN,
    ACTIONS(3260), 1,
      anon_sym_LBRACK,
    ACTIONS(3262), 1,
      anon_sym_DASH,
    ACTIONS(3266), 1,
      anon_sym_LBRACE,
    ACTIONS(3268), 1,
      sym_integer,
    ACTIONS(3270), 1,
      sym_float,
    ACTIONS(3436), 1,
      anon_sym_STAR,
    ACTIONS(3438), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3452), 1,
      sym_identifier,
    ACTIONS(3486), 1,
      anon_sym_RBRACE,
    STATE(2177), 1,
      sym_string,
    STATE(2372), 1,
      sym_dotted_name,
    STATE(2514), 1,
      sym_splat_pattern,
    STATE(2873), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3454), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2991), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [102649] = 18,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(3250), 1,
      anon_sym_LPAREN,
    ACTIONS(3260), 1,
      anon_sym_LBRACK,
    ACTIONS(3262), 1,
      anon_sym_DASH,
    ACTIONS(3266), 1,
      anon_sym_LBRACE,
    ACTIONS(3268), 1,
      sym_integer,
    ACTIONS(3270), 1,
      sym_float,
    ACTIONS(3436), 1,
      anon_sym_STAR,
    ACTIONS(3438), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3452), 1,
      sym_identifier,
    ACTIONS(3488), 1,
      anon_sym_RBRACE,
    STATE(2177), 1,
      sym_string,
    STATE(2372), 1,
      sym_dotted_name,
    STATE(2458), 1,
      sym_splat_pattern,
    STATE(2993), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3454), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2991), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [102715] = 18,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(3250), 1,
      anon_sym_LPAREN,
    ACTIONS(3260), 1,
      anon_sym_LBRACK,
    ACTIONS(3262), 1,
      anon_sym_DASH,
    ACTIONS(3266), 1,
      anon_sym_LBRACE,
    ACTIONS(3268), 1,
      sym_integer,
    ACTIONS(3270), 1,
      sym_float,
    ACTIONS(3436), 1,
      anon_sym_STAR,
    ACTIONS(3438), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3452), 1,
      sym_identifier,
    ACTIONS(3490), 1,
      anon_sym_RBRACE,
    STATE(2177), 1,
      sym_string,
    STATE(2372), 1,
      sym_dotted_name,
    STATE(2651), 1,
      sym_splat_pattern,
    STATE(3060), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3454), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2991), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [102781] = 18,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(3250), 1,
      anon_sym_LPAREN,
    ACTIONS(3260), 1,
      anon_sym_LBRACK,
    ACTIONS(3262), 1,
      anon_sym_DASH,
    ACTIONS(3266), 1,
      anon_sym_LBRACE,
    ACTIONS(3268), 1,
      sym_integer,
    ACTIONS(3270), 1,
      sym_float,
    ACTIONS(3436), 1,
      anon_sym_STAR,
    ACTIONS(3438), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3452), 1,
      sym_identifier,
    ACTIONS(3492), 1,
      anon_sym_RBRACE,
    STATE(2177), 1,
      sym_string,
    STATE(2372), 1,
      sym_dotted_name,
    STATE(2651), 1,
      sym_splat_pattern,
    STATE(3060), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3454), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2991), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [102847] = 18,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(3250), 1,
      anon_sym_LPAREN,
    ACTIONS(3260), 1,
      anon_sym_LBRACK,
    ACTIONS(3262), 1,
      anon_sym_DASH,
    ACTIONS(3266), 1,
      anon_sym_LBRACE,
    ACTIONS(3268), 1,
      sym_integer,
    ACTIONS(3270), 1,
      sym_float,
    ACTIONS(3436), 1,
      anon_sym_STAR,
    ACTIONS(3438), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3452), 1,
      sym_identifier,
    ACTIONS(3494), 1,
      anon_sym_RBRACE,
    STATE(2177), 1,
      sym_string,
    STATE(2372), 1,
      sym_dotted_name,
    STATE(2651), 1,
      sym_splat_pattern,
    STATE(3060), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3454), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2991), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [102913] = 17,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(3250), 1,
      anon_sym_LPAREN,
    ACTIONS(3260), 1,
      anon_sym_LBRACK,
    ACTIONS(3262), 1,
      anon_sym_DASH,
    ACTIONS(3266), 1,
      anon_sym_LBRACE,
    ACTIONS(3268), 1,
      sym_integer,
    ACTIONS(3270), 1,
      sym_float,
    ACTIONS(3436), 1,
      anon_sym_STAR,
    ACTIONS(3438), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3452), 1,
      sym_identifier,
    STATE(2177), 1,
      sym_string,
    STATE(2372), 1,
      sym_dotted_name,
    STATE(2651), 1,
      sym_splat_pattern,
    STATE(3060), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3454), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2991), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [102976] = 15,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(3322), 1,
      anon_sym_LPAREN,
    ACTIONS(3326), 1,
      anon_sym_STAR,
    ACTIONS(3328), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3330), 1,
      anon_sym_LBRACK,
    ACTIONS(3332), 1,
      anon_sym_DASH,
    ACTIONS(3336), 1,
      anon_sym_LBRACE,
    ACTIONS(3338), 1,
      sym_integer,
    ACTIONS(3340), 1,
      sym_float,
    ACTIONS(3496), 1,
      sym_identifier,
    STATE(2239), 1,
      sym_string,
    STATE(2495), 1,
      sym_dotted_name,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3498), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2526), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [103034] = 15,
    ACTIONS(799), 1,
      sym_string_start,
    ACTIONS(3434), 1,
      anon_sym_LPAREN,
    ACTIONS(3436), 1,
      anon_sym_STAR,
    ACTIONS(3438), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3440), 1,
      anon_sym_LBRACK,
    ACTIONS(3442), 1,
      anon_sym_DASH,
    ACTIONS(3446), 1,
      anon_sym_LBRACE,
    ACTIONS(3448), 1,
      sym_integer,
    ACTIONS(3450), 1,
      sym_float,
    ACTIONS(3500), 1,
      sym_identifier,
    STATE(2253), 1,
      sym_string,
    STATE(2410), 1,
      sym_dotted_name,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3502), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2463), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [103092] = 15,
    ACTIONS(799), 1,
      sym_string_start,
    ACTIONS(3434), 1,
      anon_sym_LPAREN,
    ACTIONS(3436), 1,
      anon_sym_STAR,
    ACTIONS(3438), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3440), 1,
      anon_sym_LBRACK,
    ACTIONS(3442), 1,
      anon_sym_DASH,
    ACTIONS(3446), 1,
      anon_sym_LBRACE,
    ACTIONS(3448), 1,
      sym_integer,
    ACTIONS(3450), 1,
      sym_float,
    ACTIONS(3500), 1,
      sym_identifier,
    STATE(2253), 1,
      sym_string,
    STATE(2410), 1,
      sym_dotted_name,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3504), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2431), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [103150] = 15,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(3344), 1,
      anon_sym_LPAREN,
    ACTIONS(3346), 1,
      anon_sym_STAR,
    ACTIONS(3348), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3350), 1,
      anon_sym_LBRACK,
    ACTIONS(3354), 1,
      anon_sym_DASH,
    ACTIONS(3358), 1,
      anon_sym_LBRACE,
    ACTIONS(3360), 1,
      sym_integer,
    ACTIONS(3362), 1,
      sym_float,
    ACTIONS(3506), 1,
      sym_identifier,
    STATE(2257), 1,
      sym_string,
    STATE(2472), 1,
      sym_dotted_name,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3508), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2507), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [103208] = 15,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(3250), 1,
      anon_sym_LPAREN,
    ACTIONS(3252), 1,
      anon_sym_STAR,
    ACTIONS(3258), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3260), 1,
      anon_sym_LBRACK,
    ACTIONS(3262), 1,
      anon_sym_DASH,
    ACTIONS(3266), 1,
      anon_sym_LBRACE,
    ACTIONS(3268), 1,
      sym_integer,
    ACTIONS(3270), 1,
      sym_float,
    ACTIONS(3452), 1,
      sym_identifier,
    STATE(2177), 1,
      sym_string,
    STATE(2372), 1,
      sym_dotted_name,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3510), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2364), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [103266] = 15,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(3322), 1,
      anon_sym_LPAREN,
    ACTIONS(3326), 1,
      anon_sym_STAR,
    ACTIONS(3328), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3330), 1,
      anon_sym_LBRACK,
    ACTIONS(3332), 1,
      anon_sym_DASH,
    ACTIONS(3336), 1,
      anon_sym_LBRACE,
    ACTIONS(3338), 1,
      sym_integer,
    ACTIONS(3340), 1,
      sym_float,
    ACTIONS(3496), 1,
      sym_identifier,
    STATE(2239), 1,
      sym_string,
    STATE(2495), 1,
      sym_dotted_name,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3512), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2436), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [103324] = 15,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(3344), 1,
      anon_sym_LPAREN,
    ACTIONS(3346), 1,
      anon_sym_STAR,
    ACTIONS(3348), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3350), 1,
      anon_sym_LBRACK,
    ACTIONS(3354), 1,
      anon_sym_DASH,
    ACTIONS(3358), 1,
      anon_sym_LBRACE,
    ACTIONS(3360), 1,
      sym_integer,
    ACTIONS(3362), 1,
      sym_float,
    ACTIONS(3506), 1,
      sym_identifier,
    STATE(2257), 1,
      sym_string,
    STATE(2472), 1,
      sym_dotted_name,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3514), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2497), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [103382] = 15,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(3250), 1,
      anon_sym_LPAREN,
    ACTIONS(3252), 1,
      anon_sym_STAR,
    ACTIONS(3258), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3260), 1,
      anon_sym_LBRACK,
    ACTIONS(3262), 1,
      anon_sym_DASH,
    ACTIONS(3266), 1,
      anon_sym_LBRACE,
    ACTIONS(3268), 1,
      sym_integer,
    ACTIONS(3270), 1,
      sym_float,
    ACTIONS(3452), 1,
      sym_identifier,
    STATE(2177), 1,
      sym_string,
    STATE(2372), 1,
      sym_dotted_name,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3516), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(2343), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [103440] = 8,
    ACTIONS(2809), 1,
      anon_sym_not,
    ACTIONS(2817), 1,
      anon_sym_is,
    ACTIONS(3520), 1,
      anon_sym_EQ,
    STATE(1931), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2815), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2795), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(3518), 11,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [103482] = 8,
    ACTIONS(3527), 1,
      anon_sym_EQ,
    ACTIONS(3529), 1,
      anon_sym_not,
    ACTIONS(3535), 1,
      anon_sym_is,
    STATE(1931), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3532), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3524), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(3522), 11,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [103524] = 8,
    ACTIONS(3527), 1,
      anon_sym_EQ,
    ACTIONS(3541), 1,
      anon_sym_not,
    ACTIONS(3547), 1,
      anon_sym_is,
    STATE(1932), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3544), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3538), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(3522), 9,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [103564] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2532), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2536), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
    ACTIONS(2527), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [103596] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2543), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2547), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
    ACTIONS(2538), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [103628] = 8,
    ACTIONS(3005), 1,
      anon_sym_not,
    ACTIONS(3013), 1,
      anon_sym_is,
    ACTIONS(3520), 1,
      anon_sym_EQ,
    STATE(1937), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3011), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2993), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(3518), 9,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [103668] = 8,
    ACTIONS(2951), 1,
      anon_sym_not,
    ACTIONS(2959), 1,
      anon_sym_is,
    ACTIONS(3520), 1,
      anon_sym_EQ,
    STATE(1932), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2957), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2939), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(3518), 9,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [103708] = 8,
    ACTIONS(3527), 1,
      anon_sym_EQ,
    ACTIONS(3553), 1,
      anon_sym_not,
    ACTIONS(3559), 1,
      anon_sym_is,
    STATE(1937), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3556), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3550), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(3522), 9,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [103748] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(400), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
    ACTIONS(361), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [103780] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(400), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
    ACTIONS(361), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [103812] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2521), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2492), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
    ACTIONS(2516), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [103844] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2481), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2492), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
    ACTIONS(2476), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [103876] = 7,
    ACTIONS(3565), 1,
      anon_sym_not,
    ACTIONS(3571), 1,
      anon_sym_is,
    STATE(1942), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3568), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3562), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(3522), 9,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [103913] = 8,
    ACTIONS(3527), 1,
      anon_sym_EQ,
    ACTIONS(3577), 1,
      anon_sym_not,
    ACTIONS(3583), 1,
      anon_sym_is,
    STATE(1943), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3580), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3574), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(3522), 8,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      sym_type_conversion,
  [103952] = 8,
    ACTIONS(2886), 1,
      anon_sym_not,
    ACTIONS(2894), 1,
      anon_sym_is,
    ACTIONS(3520), 1,
      anon_sym_as,
    STATE(1945), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2892), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2874), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(3518), 8,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
  [103991] = 8,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3589), 1,
      anon_sym_not,
    ACTIONS(3595), 1,
      anon_sym_is,
    STATE(1945), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3592), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3586), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(3522), 8,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
  [104030] = 8,
    ACTIONS(2916), 1,
      anon_sym_not,
    ACTIONS(2924), 1,
      anon_sym_is,
    ACTIONS(3520), 1,
      anon_sym_EQ,
    STATE(1943), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2922), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2904), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(3518), 8,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      sym_type_conversion,
  [104069] = 7,
    ACTIONS(3175), 1,
      anon_sym_not,
    ACTIONS(3183), 1,
      anon_sym_is,
    STATE(1942), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3181), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3163), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(3518), 9,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [104106] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2481), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2498), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(2476), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [104136] = 8,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3601), 1,
      anon_sym_not,
    ACTIONS(3607), 1,
      anon_sym_is,
    STATE(1949), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3604), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3598), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(3522), 7,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [104174] = 4,
    ACTIONS(3610), 1,
      anon_sym_COMMA,
    STATE(1951), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1740), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [104204] = 4,
    ACTIONS(3614), 1,
      anon_sym_COMMA,
    STATE(1951), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3612), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [104234] = 8,
    ACTIONS(3045), 1,
      anon_sym_not,
    ACTIONS(3053), 1,
      anon_sym_is,
    ACTIONS(3520), 1,
      anon_sym_as,
    STATE(1949), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3051), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3033), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(3518), 7,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [104272] = 8,
    ACTIONS(3527), 1,
      anon_sym_as,
    ACTIONS(3620), 1,
      anon_sym_not,
    ACTIONS(3626), 1,
      anon_sym_is,
    STATE(1953), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3623), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3617), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(3522), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_and,
      anon_sym_or,
  [104310] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(766), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(361), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [104340] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(766), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(361), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [104370] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2304), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(361), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [104400] = 8,
    ACTIONS(3075), 1,
      anon_sym_not,
    ACTIONS(3083), 1,
      anon_sym_is,
    ACTIONS(3520), 1,
      anon_sym_as,
    STATE(1953), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3081), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3063), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(3518), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_and,
      anon_sym_or,
  [104438] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2304), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(361), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [104468] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2481), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3629), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(2476), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [104498] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2481), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2498), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(2476), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [104527] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3631), 18,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [104552] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(400), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(361), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [104581] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2304), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(361), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [104610] = 13,
    ACTIONS(2933), 1,
      anon_sym_LPAREN,
    ACTIONS(2941), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2949), 1,
      anon_sym_PIPE,
    ACTIONS(2953), 1,
      anon_sym_AMP,
    ACTIONS(2955), 1,
      anon_sym_CARET,
    ACTIONS(3025), 1,
      anon_sym_DOT,
    ACTIONS(3037), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2935), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2937), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2947), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1585), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2945), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [104657] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(400), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(361), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [104686] = 13,
    ACTIONS(2787), 1,
      anon_sym_DOT,
    ACTIONS(2801), 1,
      anon_sym_LBRACK,
    ACTIONS(2933), 1,
      anon_sym_LPAREN,
    ACTIONS(2941), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2949), 1,
      anon_sym_PIPE,
    ACTIONS(2953), 1,
      anon_sym_AMP,
    ACTIONS(2955), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2935), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2937), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2947), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1585), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2945), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [104733] = 13,
    ACTIONS(2933), 1,
      anon_sym_LPAREN,
    ACTIONS(2941), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2949), 1,
      anon_sym_PIPE,
    ACTIONS(2953), 1,
      anon_sym_AMP,
    ACTIONS(2955), 1,
      anon_sym_CARET,
    ACTIONS(2985), 1,
      anon_sym_DOT,
    ACTIONS(2997), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2935), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2937), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2947), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1585), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2945), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [104780] = 13,
    ACTIONS(2933), 1,
      anon_sym_LPAREN,
    ACTIONS(2941), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2949), 1,
      anon_sym_PIPE,
    ACTIONS(2953), 1,
      anon_sym_AMP,
    ACTIONS(2955), 1,
      anon_sym_CARET,
    ACTIONS(3633), 1,
      anon_sym_DOT,
    ACTIONS(3635), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2935), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2937), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2947), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1585), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2945), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [104827] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2492), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(2521), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2516), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [104856] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2532), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2536), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(2527), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [104885] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(400), 2,
      anon_sym_COMMA,
      anon_sym_in,
    ACTIONS(361), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [104914] = 13,
    ACTIONS(2933), 1,
      anon_sym_LPAREN,
    ACTIONS(2941), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2949), 1,
      anon_sym_PIPE,
    ACTIONS(2953), 1,
      anon_sym_AMP,
    ACTIONS(2955), 1,
      anon_sym_CARET,
    ACTIONS(3155), 1,
      anon_sym_DOT,
    ACTIONS(3167), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2935), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2937), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2947), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1585), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2945), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [104961] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2481), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(3629), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(2476), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [104990] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2543), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2547), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(2538), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [105019] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2492), 18,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [105044] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2492), 2,
      anon_sym_COMMA,
      anon_sym_in,
    ACTIONS(2521), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2516), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [105073] = 13,
    ACTIONS(2931), 1,
      anon_sym_DOT,
    ACTIONS(2933), 1,
      anon_sym_LPAREN,
    ACTIONS(2941), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2943), 1,
      anon_sym_LBRACK,
    ACTIONS(2949), 1,
      anon_sym_PIPE,
    ACTIONS(2953), 1,
      anon_sym_AMP,
    ACTIONS(2955), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2935), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2937), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2947), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1585), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2945), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [105120] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2532), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2536), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(2527), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [105149] = 13,
    ACTIONS(2933), 1,
      anon_sym_LPAREN,
    ACTIONS(2941), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2949), 1,
      anon_sym_PIPE,
    ACTIONS(2953), 1,
      anon_sym_AMP,
    ACTIONS(2955), 1,
      anon_sym_CARET,
    ACTIONS(2961), 1,
      anon_sym_DOT,
    ACTIONS(2963), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2935), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2937), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2947), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1585), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2945), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [105196] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(766), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(361), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [105225] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(766), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(361), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [105254] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2481), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2492), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(2476), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [105283] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(400), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(361), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [105312] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(400), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(361), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [105341] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2481), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2492), 2,
      anon_sym_COMMA,
      anon_sym_in,
    ACTIONS(2476), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [105370] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2532), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2536), 2,
      anon_sym_COMMA,
      anon_sym_in,
    ACTIONS(2527), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [105399] = 13,
    ACTIONS(2896), 1,
      anon_sym_DOT,
    ACTIONS(2908), 1,
      anon_sym_LBRACK,
    ACTIONS(2933), 1,
      anon_sym_LPAREN,
    ACTIONS(2941), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2949), 1,
      anon_sym_PIPE,
    ACTIONS(2953), 1,
      anon_sym_AMP,
    ACTIONS(2955), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2935), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2937), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2947), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1585), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2945), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [105446] = 13,
    ACTIONS(2866), 1,
      anon_sym_DOT,
    ACTIONS(2878), 1,
      anon_sym_LBRACK,
    ACTIONS(2933), 1,
      anon_sym_LPAREN,
    ACTIONS(2941), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2949), 1,
      anon_sym_PIPE,
    ACTIONS(2953), 1,
      anon_sym_AMP,
    ACTIONS(2955), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2935), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2937), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2947), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1585), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2945), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [105493] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2492), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(2521), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2516), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [105522] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2304), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(361), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [105551] = 13,
    ACTIONS(2933), 1,
      anon_sym_LPAREN,
    ACTIONS(2941), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2949), 1,
      anon_sym_PIPE,
    ACTIONS(2953), 1,
      anon_sym_AMP,
    ACTIONS(2955), 1,
      anon_sym_CARET,
    ACTIONS(3055), 1,
      anon_sym_DOT,
    ACTIONS(3067), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2935), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2937), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2947), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1585), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2945), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [105598] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3612), 18,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [105623] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(363), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(400), 2,
      anon_sym_COMMA,
      anon_sym_in,
    ACTIONS(361), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [105652] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3637), 18,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [105677] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2543), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2547), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(2538), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [105706] = 13,
    ACTIONS(2933), 1,
      anon_sym_LPAREN,
    ACTIONS(2941), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2949), 1,
      anon_sym_PIPE,
    ACTIONS(2953), 1,
      anon_sym_AMP,
    ACTIONS(2955), 1,
      anon_sym_CARET,
    ACTIONS(3207), 1,
      anon_sym_DOT,
    ACTIONS(3219), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2935), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2937), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(2947), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(1585), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(2945), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [105753] = 5,
    ACTIONS(3639), 1,
      anon_sym_COLON,
    ACTIONS(3641), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2481), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2476), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [105784] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2543), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2547), 2,
      anon_sym_COMMA,
      anon_sym_in,
    ACTIONS(2538), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [105813] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2481), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2492), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(2476), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [105842] = 13,
    ACTIONS(3643), 1,
      sym_identifier,
    ACTIONS(3645), 1,
      anon_sym_LPAREN,
    ACTIONS(3647), 1,
      anon_sym_STAR,
    ACTIONS(3649), 1,
      anon_sym_COLON,
    ACTIONS(3651), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3653), 1,
      anon_sym_SLASH,
    STATE(2705), 1,
      sym_parameter,
    STATE(2706), 1,
      sym_tuple_pattern,
    STATE(3298), 1,
      sym_lambda_parameters,
    STATE(3392), 1,
      sym__parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(3053), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(3052), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [105888] = 13,
    ACTIONS(3643), 1,
      sym_identifier,
    ACTIONS(3645), 1,
      anon_sym_LPAREN,
    ACTIONS(3647), 1,
      anon_sym_STAR,
    ACTIONS(3651), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3653), 1,
      anon_sym_SLASH,
    ACTIONS(3655), 1,
      anon_sym_COLON,
    STATE(2705), 1,
      sym_parameter,
    STATE(2706), 1,
      sym_tuple_pattern,
    STATE(3251), 1,
      sym_lambda_parameters,
    STATE(3392), 1,
      sym__parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(3053), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(3052), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [105934] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3631), 17,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [105958] = 13,
    ACTIONS(3643), 1,
      sym_identifier,
    ACTIONS(3645), 1,
      anon_sym_LPAREN,
    ACTIONS(3647), 1,
      anon_sym_STAR,
    ACTIONS(3651), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3653), 1,
      anon_sym_SLASH,
    ACTIONS(3657), 1,
      anon_sym_COLON,
    STATE(2705), 1,
      sym_parameter,
    STATE(2706), 1,
      sym_tuple_pattern,
    STATE(3220), 1,
      sym_lambda_parameters,
    STATE(3392), 1,
      sym__parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(3053), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(3052), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [106004] = 13,
    ACTIONS(3643), 1,
      sym_identifier,
    ACTIONS(3645), 1,
      anon_sym_LPAREN,
    ACTIONS(3647), 1,
      anon_sym_STAR,
    ACTIONS(3651), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3653), 1,
      anon_sym_SLASH,
    ACTIONS(3659), 1,
      anon_sym_COLON,
    STATE(2705), 1,
      sym_parameter,
    STATE(2706), 1,
      sym_tuple_pattern,
    STATE(3260), 1,
      sym_lambda_parameters,
    STATE(3392), 1,
      sym__parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(3053), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(3052), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [106050] = 13,
    ACTIONS(3643), 1,
      sym_identifier,
    ACTIONS(3645), 1,
      anon_sym_LPAREN,
    ACTIONS(3647), 1,
      anon_sym_STAR,
    ACTIONS(3651), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3653), 1,
      anon_sym_SLASH,
    ACTIONS(3661), 1,
      anon_sym_COLON,
    STATE(2705), 1,
      sym_parameter,
    STATE(2706), 1,
      sym_tuple_pattern,
    STATE(3346), 1,
      sym_lambda_parameters,
    STATE(3392), 1,
      sym__parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(3053), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(3052), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [106096] = 13,
    ACTIONS(3643), 1,
      sym_identifier,
    ACTIONS(3645), 1,
      anon_sym_LPAREN,
    ACTIONS(3647), 1,
      anon_sym_STAR,
    ACTIONS(3651), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3653), 1,
      anon_sym_SLASH,
    ACTIONS(3663), 1,
      anon_sym_COLON,
    STATE(2705), 1,
      sym_parameter,
    STATE(2706), 1,
      sym_tuple_pattern,
    STATE(3164), 1,
      sym_lambda_parameters,
    STATE(3392), 1,
      sym__parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(3053), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(3052), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [106142] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3612), 17,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [106166] = 13,
    ACTIONS(3643), 1,
      sym_identifier,
    ACTIONS(3645), 1,
      anon_sym_LPAREN,
    ACTIONS(3647), 1,
      anon_sym_STAR,
    ACTIONS(3651), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3653), 1,
      anon_sym_SLASH,
    ACTIONS(3665), 1,
      anon_sym_COLON,
    STATE(2705), 1,
      sym_parameter,
    STATE(2706), 1,
      sym_tuple_pattern,
    STATE(3351), 1,
      sym_lambda_parameters,
    STATE(3392), 1,
      sym__parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(3053), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(3052), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [106212] = 6,
    ACTIONS(3667), 1,
      anon_sym_COMMA,
    ACTIONS(3669), 1,
      anon_sym_COLON,
    ACTIONS(3671), 1,
      anon_sym_EQ,
    STATE(1950), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3673), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [106244] = 5,
    ACTIONS(3669), 1,
      anon_sym_COLON,
    ACTIONS(3671), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3675), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3673), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [106274] = 7,
    ACTIONS(3227), 1,
      anon_sym_not,
    ACTIONS(3235), 1,
      anon_sym_is,
    STATE(2022), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3233), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3215), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(3518), 6,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
  [106308] = 13,
    ACTIONS(3643), 1,
      sym_identifier,
    ACTIONS(3645), 1,
      anon_sym_LPAREN,
    ACTIONS(3647), 1,
      anon_sym_STAR,
    ACTIONS(3651), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3653), 1,
      anon_sym_SLASH,
    ACTIONS(3677), 1,
      anon_sym_COLON,
    STATE(2705), 1,
      sym_parameter,
    STATE(2706), 1,
      sym_tuple_pattern,
    STATE(3392), 1,
      sym__parameters,
    STATE(3393), 1,
      sym_lambda_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(3053), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(3052), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [106354] = 13,
    ACTIONS(3643), 1,
      sym_identifier,
    ACTIONS(3645), 1,
      anon_sym_LPAREN,
    ACTIONS(3647), 1,
      anon_sym_STAR,
    ACTIONS(3651), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3653), 1,
      anon_sym_SLASH,
    ACTIONS(3679), 1,
      anon_sym_COLON,
    STATE(2705), 1,
      sym_parameter,
    STATE(2706), 1,
      sym_tuple_pattern,
    STATE(3360), 1,
      sym_lambda_parameters,
    STATE(3392), 1,
      sym__parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(3053), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(3052), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [106400] = 13,
    ACTIONS(3643), 1,
      sym_identifier,
    ACTIONS(3645), 1,
      anon_sym_LPAREN,
    ACTIONS(3647), 1,
      anon_sym_STAR,
    ACTIONS(3651), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3653), 1,
      anon_sym_SLASH,
    ACTIONS(3681), 1,
      anon_sym_COLON,
    STATE(2705), 1,
      sym_parameter,
    STATE(2706), 1,
      sym_tuple_pattern,
    STATE(3392), 1,
      sym__parameters,
    STATE(3420), 1,
      sym_lambda_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(3053), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(3052), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [106446] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2492), 17,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [106470] = 4,
    ACTIONS(3683), 1,
      anon_sym_COMMA,
    STATE(2016), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3612), 15,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [106498] = 13,
    ACTIONS(3643), 1,
      sym_identifier,
    ACTIONS(3645), 1,
      anon_sym_LPAREN,
    ACTIONS(3647), 1,
      anon_sym_STAR,
    ACTIONS(3651), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3653), 1,
      anon_sym_SLASH,
    ACTIONS(3686), 1,
      anon_sym_COLON,
    STATE(2705), 1,
      sym_parameter,
    STATE(2706), 1,
      sym_tuple_pattern,
    STATE(3377), 1,
      sym_lambda_parameters,
    STATE(3392), 1,
      sym__parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(3053), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(3052), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [106544] = 13,
    ACTIONS(3643), 1,
      sym_identifier,
    ACTIONS(3645), 1,
      anon_sym_LPAREN,
    ACTIONS(3647), 1,
      anon_sym_STAR,
    ACTIONS(3651), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3653), 1,
      anon_sym_SLASH,
    ACTIONS(3688), 1,
      anon_sym_COLON,
    STATE(2705), 1,
      sym_parameter,
    STATE(2706), 1,
      sym_tuple_pattern,
    STATE(3197), 1,
      sym_lambda_parameters,
    STATE(3392), 1,
      sym__parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(3053), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(3052), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [106590] = 6,
    ACTIONS(3669), 1,
      anon_sym_COLON,
    ACTIONS(3671), 1,
      anon_sym_EQ,
    ACTIONS(3690), 1,
      anon_sym_COMMA,
    STATE(2021), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3673), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [106622] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3637), 17,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [106646] = 4,
    ACTIONS(3692), 1,
      anon_sym_COMMA,
    STATE(2016), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1740), 15,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [106674] = 7,
    ACTIONS(3697), 1,
      anon_sym_not,
    ACTIONS(3703), 1,
      anon_sym_is,
    STATE(2022), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3700), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3522), 6,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3694), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [106708] = 12,
    ACTIONS(3706), 1,
      sym_identifier,
    ACTIONS(3708), 1,
      anon_sym_LPAREN,
    ACTIONS(3710), 1,
      anon_sym_RPAREN,
    ACTIONS(3712), 1,
      anon_sym_STAR,
    ACTIONS(3714), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3716), 1,
      anon_sym_SLASH,
    STATE(2908), 1,
      sym_tuple_pattern,
    STATE(2909), 1,
      sym_parameter,
    STATE(3233), 1,
      sym__parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2906), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(3156), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [106751] = 11,
    ACTIONS(3643), 1,
      sym_identifier,
    ACTIONS(3645), 1,
      anon_sym_LPAREN,
    ACTIONS(3647), 1,
      anon_sym_STAR,
    ACTIONS(3651), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3653), 1,
      anon_sym_SLASH,
    ACTIONS(3718), 1,
      anon_sym_COLON,
    STATE(2706), 1,
      sym_tuple_pattern,
    STATE(3135), 1,
      sym_parameter,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(3053), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(3052), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [106791] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3720), 1,
      anon_sym_LBRACE,
    ACTIONS(3724), 1,
      sym__not_escape_sequence,
    ACTIONS(3726), 1,
      sym_string_end,
    ACTIONS(3728), 1,
      sym__WILDCARD_DEF_OPEN,
    ACTIONS(3730), 1,
      sym__WILDCARD_INTERP_OPEN,
    STATE(2156), 1,
      aux_sym_string_content_repeat1,
    STATE(2172), 2,
      sym__wildcard_definition,
      sym__wildcard_interpolation,
    ACTIONS(3722), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(2026), 4,
      sym_string_content,
      sym_interpolation,
      sym_wildcard,
      aux_sym_string_repeat1,
  [106831] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3720), 1,
      anon_sym_LBRACE,
    ACTIONS(3724), 1,
      sym__not_escape_sequence,
    ACTIONS(3728), 1,
      sym__WILDCARD_DEF_OPEN,
    ACTIONS(3730), 1,
      sym__WILDCARD_INTERP_OPEN,
    ACTIONS(3732), 1,
      sym_string_end,
    STATE(2156), 1,
      aux_sym_string_content_repeat1,
    STATE(2172), 2,
      sym__wildcard_definition,
      sym__wildcard_interpolation,
    ACTIONS(3722), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(2033), 4,
      sym_string_content,
      sym_interpolation,
      sym_wildcard,
      aux_sym_string_repeat1,
  [106871] = 4,
    ACTIONS(3669), 1,
      anon_sym_COLON,
    ACTIONS(3671), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3673), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [106897] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3720), 1,
      anon_sym_LBRACE,
    ACTIONS(3724), 1,
      sym__not_escape_sequence,
    ACTIONS(3728), 1,
      sym__WILDCARD_DEF_OPEN,
    ACTIONS(3730), 1,
      sym__WILDCARD_INTERP_OPEN,
    ACTIONS(3734), 1,
      sym_string_end,
    STATE(2156), 1,
      aux_sym_string_content_repeat1,
    STATE(2172), 2,
      sym__wildcard_definition,
      sym__wildcard_interpolation,
    ACTIONS(3722), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(2037), 4,
      sym_string_content,
      sym_interpolation,
      sym_wildcard,
      aux_sym_string_repeat1,
  [106937] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3720), 1,
      anon_sym_LBRACE,
    ACTIONS(3724), 1,
      sym__not_escape_sequence,
    ACTIONS(3728), 1,
      sym__WILDCARD_DEF_OPEN,
    ACTIONS(3730), 1,
      sym__WILDCARD_INTERP_OPEN,
    ACTIONS(3736), 1,
      sym_string_end,
    STATE(2156), 1,
      aux_sym_string_content_repeat1,
    STATE(2172), 2,
      sym__wildcard_definition,
      sym__wildcard_interpolation,
    ACTIONS(3722), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(2035), 4,
      sym_string_content,
      sym_interpolation,
      sym_wildcard,
      aux_sym_string_repeat1,
  [106977] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3720), 1,
      anon_sym_LBRACE,
    ACTIONS(3724), 1,
      sym__not_escape_sequence,
    ACTIONS(3728), 1,
      sym__WILDCARD_DEF_OPEN,
    ACTIONS(3730), 1,
      sym__WILDCARD_INTERP_OPEN,
    ACTIONS(3738), 1,
      sym_string_end,
    STATE(2156), 1,
      aux_sym_string_content_repeat1,
    STATE(2172), 2,
      sym__wildcard_definition,
      sym__wildcard_interpolation,
    ACTIONS(3722), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(2033), 4,
      sym_string_content,
      sym_interpolation,
      sym_wildcard,
      aux_sym_string_repeat1,
  [107017] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3720), 1,
      anon_sym_LBRACE,
    ACTIONS(3724), 1,
      sym__not_escape_sequence,
    ACTIONS(3728), 1,
      sym__WILDCARD_DEF_OPEN,
    ACTIONS(3730), 1,
      sym__WILDCARD_INTERP_OPEN,
    ACTIONS(3740), 1,
      sym_string_end,
    STATE(2156), 1,
      aux_sym_string_content_repeat1,
    STATE(2172), 2,
      sym__wildcard_definition,
      sym__wildcard_interpolation,
    ACTIONS(3722), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(2046), 4,
      sym_string_content,
      sym_interpolation,
      sym_wildcard,
      aux_sym_string_repeat1,
  [107057] = 11,
    ACTIONS(3706), 1,
      sym_identifier,
    ACTIONS(3708), 1,
      anon_sym_LPAREN,
    ACTIONS(3712), 1,
      anon_sym_STAR,
    ACTIONS(3714), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3716), 1,
      anon_sym_SLASH,
    ACTIONS(3742), 1,
      anon_sym_RPAREN,
    STATE(2908), 1,
      sym_tuple_pattern,
    STATE(3137), 1,
      sym_parameter,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2906), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(3156), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [107097] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3744), 1,
      anon_sym_LBRACE,
    ACTIONS(3750), 1,
      sym__not_escape_sequence,
    ACTIONS(3753), 1,
      sym_string_end,
    ACTIONS(3755), 1,
      sym__WILDCARD_DEF_OPEN,
    ACTIONS(3758), 1,
      sym__WILDCARD_INTERP_OPEN,
    STATE(2156), 1,
      aux_sym_string_content_repeat1,
    STATE(2172), 2,
      sym__wildcard_definition,
      sym__wildcard_interpolation,
    ACTIONS(3747), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(2033), 4,
      sym_string_content,
      sym_interpolation,
      sym_wildcard,
      aux_sym_string_repeat1,
  [107137] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3720), 1,
      anon_sym_LBRACE,
    ACTIONS(3724), 1,
      sym__not_escape_sequence,
    ACTIONS(3728), 1,
      sym__WILDCARD_DEF_OPEN,
    ACTIONS(3730), 1,
      sym__WILDCARD_INTERP_OPEN,
    ACTIONS(3761), 1,
      sym_string_end,
    STATE(2156), 1,
      aux_sym_string_content_repeat1,
    STATE(2172), 2,
      sym__wildcard_definition,
      sym__wildcard_interpolation,
    ACTIONS(3722), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(2033), 4,
      sym_string_content,
      sym_interpolation,
      sym_wildcard,
      aux_sym_string_repeat1,
  [107177] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3720), 1,
      anon_sym_LBRACE,
    ACTIONS(3724), 1,
      sym__not_escape_sequence,
    ACTIONS(3728), 1,
      sym__WILDCARD_DEF_OPEN,
    ACTIONS(3730), 1,
      sym__WILDCARD_INTERP_OPEN,
    ACTIONS(3763), 1,
      sym_string_end,
    STATE(2156), 1,
      aux_sym_string_content_repeat1,
    STATE(2172), 2,
      sym__wildcard_definition,
      sym__wildcard_interpolation,
    ACTIONS(3722), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(2033), 4,
      sym_string_content,
      sym_interpolation,
      sym_wildcard,
      aux_sym_string_repeat1,
  [107217] = 11,
    ACTIONS(3643), 1,
      sym_identifier,
    ACTIONS(3645), 1,
      anon_sym_LPAREN,
    ACTIONS(3647), 1,
      anon_sym_STAR,
    ACTIONS(3651), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3653), 1,
      anon_sym_SLASH,
    ACTIONS(3742), 1,
      anon_sym_COLON,
    STATE(2706), 1,
      sym_tuple_pattern,
    STATE(3135), 1,
      sym_parameter,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(3053), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(3052), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [107257] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3720), 1,
      anon_sym_LBRACE,
    ACTIONS(3724), 1,
      sym__not_escape_sequence,
    ACTIONS(3728), 1,
      sym__WILDCARD_DEF_OPEN,
    ACTIONS(3730), 1,
      sym__WILDCARD_INTERP_OPEN,
    ACTIONS(3765), 1,
      sym_string_end,
    STATE(2156), 1,
      aux_sym_string_content_repeat1,
    STATE(2172), 2,
      sym__wildcard_definition,
      sym__wildcard_interpolation,
    ACTIONS(3722), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(2033), 4,
      sym_string_content,
      sym_interpolation,
      sym_wildcard,
      aux_sym_string_repeat1,
  [107297] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3720), 1,
      anon_sym_LBRACE,
    ACTIONS(3724), 1,
      sym__not_escape_sequence,
    ACTIONS(3728), 1,
      sym__WILDCARD_DEF_OPEN,
    ACTIONS(3730), 1,
      sym__WILDCARD_INTERP_OPEN,
    ACTIONS(3767), 1,
      sym_string_end,
    STATE(2156), 1,
      aux_sym_string_content_repeat1,
    STATE(2172), 2,
      sym__wildcard_definition,
      sym__wildcard_interpolation,
    ACTIONS(3722), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(2034), 4,
      sym_string_content,
      sym_interpolation,
      sym_wildcard,
      aux_sym_string_repeat1,
  [107337] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3720), 1,
      anon_sym_LBRACE,
    ACTIONS(3724), 1,
      sym__not_escape_sequence,
    ACTIONS(3728), 1,
      sym__WILDCARD_DEF_OPEN,
    ACTIONS(3730), 1,
      sym__WILDCARD_INTERP_OPEN,
    ACTIONS(3769), 1,
      sym_string_end,
    STATE(2156), 1,
      aux_sym_string_content_repeat1,
    STATE(2172), 2,
      sym__wildcard_definition,
      sym__wildcard_interpolation,
    ACTIONS(3722), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(2049), 4,
      sym_string_content,
      sym_interpolation,
      sym_wildcard,
      aux_sym_string_repeat1,
  [107377] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3720), 1,
      anon_sym_LBRACE,
    ACTIONS(3724), 1,
      sym__not_escape_sequence,
    ACTIONS(3728), 1,
      sym__WILDCARD_DEF_OPEN,
    ACTIONS(3730), 1,
      sym__WILDCARD_INTERP_OPEN,
    ACTIONS(3771), 1,
      sym_string_end,
    STATE(2156), 1,
      aux_sym_string_content_repeat1,
    STATE(2172), 2,
      sym__wildcard_definition,
      sym__wildcard_interpolation,
    ACTIONS(3722), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(2033), 4,
      sym_string_content,
      sym_interpolation,
      sym_wildcard,
      aux_sym_string_repeat1,
  [107417] = 11,
    ACTIONS(3706), 1,
      sym_identifier,
    ACTIONS(3708), 1,
      anon_sym_LPAREN,
    ACTIONS(3712), 1,
      anon_sym_STAR,
    ACTIONS(3714), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3716), 1,
      anon_sym_SLASH,
    ACTIONS(3718), 1,
      anon_sym_RPAREN,
    STATE(2908), 1,
      sym_tuple_pattern,
    STATE(3137), 1,
      sym_parameter,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2906), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(3156), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [107457] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3720), 1,
      anon_sym_LBRACE,
    ACTIONS(3724), 1,
      sym__not_escape_sequence,
    ACTIONS(3728), 1,
      sym__WILDCARD_DEF_OPEN,
    ACTIONS(3730), 1,
      sym__WILDCARD_INTERP_OPEN,
    ACTIONS(3773), 1,
      sym_string_end,
    STATE(2156), 1,
      aux_sym_string_content_repeat1,
    STATE(2172), 2,
      sym__wildcard_definition,
      sym__wildcard_interpolation,
    ACTIONS(3722), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(2033), 4,
      sym_string_content,
      sym_interpolation,
      sym_wildcard,
      aux_sym_string_repeat1,
  [107497] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3720), 1,
      anon_sym_LBRACE,
    ACTIONS(3724), 1,
      sym__not_escape_sequence,
    ACTIONS(3728), 1,
      sym__WILDCARD_DEF_OPEN,
    ACTIONS(3730), 1,
      sym__WILDCARD_INTERP_OPEN,
    ACTIONS(3775), 1,
      sym_string_end,
    STATE(2156), 1,
      aux_sym_string_content_repeat1,
    STATE(2172), 2,
      sym__wildcard_definition,
      sym__wildcard_interpolation,
    ACTIONS(3722), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(2048), 4,
      sym_string_content,
      sym_interpolation,
      sym_wildcard,
      aux_sym_string_repeat1,
  [107537] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3720), 1,
      anon_sym_LBRACE,
    ACTIONS(3724), 1,
      sym__not_escape_sequence,
    ACTIONS(3728), 1,
      sym__WILDCARD_DEF_OPEN,
    ACTIONS(3730), 1,
      sym__WILDCARD_INTERP_OPEN,
    ACTIONS(3777), 1,
      sym_string_end,
    STATE(2156), 1,
      aux_sym_string_content_repeat1,
    STATE(2172), 2,
      sym__wildcard_definition,
      sym__wildcard_interpolation,
    ACTIONS(3722), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(2033), 4,
      sym_string_content,
      sym_interpolation,
      sym_wildcard,
      aux_sym_string_repeat1,
  [107577] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3720), 1,
      anon_sym_LBRACE,
    ACTIONS(3724), 1,
      sym__not_escape_sequence,
    ACTIONS(3728), 1,
      sym__WILDCARD_DEF_OPEN,
    ACTIONS(3730), 1,
      sym__WILDCARD_INTERP_OPEN,
    ACTIONS(3779), 1,
      sym_string_end,
    STATE(2156), 1,
      aux_sym_string_content_repeat1,
    STATE(2172), 2,
      sym__wildcard_definition,
      sym__wildcard_interpolation,
    ACTIONS(3722), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(2044), 4,
      sym_string_content,
      sym_interpolation,
      sym_wildcard,
      aux_sym_string_repeat1,
  [107617] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3720), 1,
      anon_sym_LBRACE,
    ACTIONS(3724), 1,
      sym__not_escape_sequence,
    ACTIONS(3728), 1,
      sym__WILDCARD_DEF_OPEN,
    ACTIONS(3730), 1,
      sym__WILDCARD_INTERP_OPEN,
    ACTIONS(3781), 1,
      sym_string_end,
    STATE(2156), 1,
      aux_sym_string_content_repeat1,
    STATE(2172), 2,
      sym__wildcard_definition,
      sym__wildcard_interpolation,
    ACTIONS(3722), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(2033), 4,
      sym_string_content,
      sym_interpolation,
      sym_wildcard,
      aux_sym_string_repeat1,
  [107657] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3720), 1,
      anon_sym_LBRACE,
    ACTIONS(3724), 1,
      sym__not_escape_sequence,
    ACTIONS(3728), 1,
      sym__WILDCARD_DEF_OPEN,
    ACTIONS(3730), 1,
      sym__WILDCARD_INTERP_OPEN,
    ACTIONS(3783), 1,
      sym_string_end,
    STATE(2156), 1,
      aux_sym_string_content_repeat1,
    STATE(2172), 2,
      sym__wildcard_definition,
      sym__wildcard_interpolation,
    ACTIONS(3722), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(2042), 4,
      sym_string_content,
      sym_interpolation,
      sym_wildcard,
      aux_sym_string_repeat1,
  [107697] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3720), 1,
      anon_sym_LBRACE,
    ACTIONS(3724), 1,
      sym__not_escape_sequence,
    ACTIONS(3728), 1,
      sym__WILDCARD_DEF_OPEN,
    ACTIONS(3730), 1,
      sym__WILDCARD_INTERP_OPEN,
    ACTIONS(3785), 1,
      sym_string_end,
    STATE(2156), 1,
      aux_sym_string_content_repeat1,
    STATE(2172), 2,
      sym__wildcard_definition,
      sym__wildcard_interpolation,
    ACTIONS(3722), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(2033), 4,
      sym_string_content,
      sym_interpolation,
      sym_wildcard,
      aux_sym_string_repeat1,
  [107737] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3720), 1,
      anon_sym_LBRACE,
    ACTIONS(3724), 1,
      sym__not_escape_sequence,
    ACTIONS(3728), 1,
      sym__WILDCARD_DEF_OPEN,
    ACTIONS(3730), 1,
      sym__WILDCARD_INTERP_OPEN,
    ACTIONS(3787), 1,
      sym_string_end,
    STATE(2156), 1,
      aux_sym_string_content_repeat1,
    STATE(2172), 2,
      sym__wildcard_definition,
      sym__wildcard_interpolation,
    ACTIONS(3722), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(2033), 4,
      sym_string_content,
      sym_interpolation,
      sym_wildcard,
      aux_sym_string_repeat1,
  [107777] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3720), 1,
      anon_sym_LBRACE,
    ACTIONS(3724), 1,
      sym__not_escape_sequence,
    ACTIONS(3728), 1,
      sym__WILDCARD_DEF_OPEN,
    ACTIONS(3730), 1,
      sym__WILDCARD_INTERP_OPEN,
    ACTIONS(3789), 1,
      sym_string_end,
    STATE(2156), 1,
      aux_sym_string_content_repeat1,
    STATE(2172), 2,
      sym__wildcard_definition,
      sym__wildcard_interpolation,
    ACTIONS(3722), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(2040), 4,
      sym_string_content,
      sym_interpolation,
      sym_wildcard,
      aux_sym_string_repeat1,
  [107817] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3720), 1,
      anon_sym_LBRACE,
    ACTIONS(3724), 1,
      sym__not_escape_sequence,
    ACTIONS(3728), 1,
      sym__WILDCARD_DEF_OPEN,
    ACTIONS(3730), 1,
      sym__WILDCARD_INTERP_OPEN,
    ACTIONS(3791), 1,
      sym_string_end,
    STATE(2156), 1,
      aux_sym_string_content_repeat1,
    STATE(2172), 2,
      sym__wildcard_definition,
      sym__wildcard_interpolation,
    ACTIONS(3722), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(2030), 4,
      sym_string_content,
      sym_interpolation,
      sym_wildcard,
      aux_sym_string_repeat1,
  [107857] = 10,
    ACTIONS(3643), 1,
      sym_identifier,
    ACTIONS(3645), 1,
      anon_sym_LPAREN,
    ACTIONS(3647), 1,
      anon_sym_STAR,
    ACTIONS(3651), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3653), 1,
      anon_sym_SLASH,
    STATE(2706), 1,
      sym_tuple_pattern,
    STATE(3135), 1,
      sym_parameter,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(3053), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(3052), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [107894] = 10,
    ACTIONS(3706), 1,
      sym_identifier,
    ACTIONS(3708), 1,
      anon_sym_LPAREN,
    ACTIONS(3712), 1,
      anon_sym_STAR,
    ACTIONS(3714), 1,
      anon_sym_STAR_STAR,
    ACTIONS(3716), 1,
      anon_sym_SLASH,
    STATE(2908), 1,
      sym_tuple_pattern,
    STATE(3137), 1,
      sym_parameter,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2906), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(3156), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [107931] = 13,
    ACTIONS(3793), 1,
      anon_sym_COMMA,
    ACTIONS(3795), 1,
      anon_sym_as,
    ACTIONS(3797), 1,
      anon_sym_if,
    ACTIONS(3799), 1,
      anon_sym_COLON,
    ACTIONS(3801), 1,
      anon_sym_async,
    ACTIONS(3803), 1,
      anon_sym_for,
    ACTIONS(3805), 1,
      anon_sym_RBRACE,
    ACTIONS(3807), 1,
      anon_sym_and,
    ACTIONS(3809), 1,
      anon_sym_or,
    STATE(2259), 1,
      sym_for_in_clause,
    STATE(2810), 1,
      aux_sym__collection_elements_repeat1,
    STATE(3235), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [107972] = 5,
    ACTIONS(3813), 1,
      anon_sym_as,
    ACTIONS(3816), 1,
      anon_sym_and,
    ACTIONS(3818), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3811), 9,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [107997] = 6,
    ACTIONS(3816), 1,
      anon_sym_and,
    ACTIONS(3818), 1,
      anon_sym_or,
    ACTIONS(3822), 1,
      anon_sym_as,
    ACTIONS(3824), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3820), 8,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [108024] = 13,
    ACTIONS(3793), 1,
      anon_sym_COMMA,
    ACTIONS(3795), 1,
      anon_sym_as,
    ACTIONS(3797), 1,
      anon_sym_if,
    ACTIONS(3799), 1,
      anon_sym_COLON,
    ACTIONS(3801), 1,
      anon_sym_async,
    ACTIONS(3803), 1,
      anon_sym_for,
    ACTIONS(3805), 1,
      anon_sym_RBRACE,
    ACTIONS(3807), 1,
      anon_sym_and,
    ACTIONS(3809), 1,
      anon_sym_or,
    STATE(2259), 1,
      sym_for_in_clause,
    STATE(2810), 1,
      aux_sym__collection_elements_repeat1,
    STATE(3194), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [108065] = 13,
    ACTIONS(3793), 1,
      anon_sym_COMMA,
    ACTIONS(3795), 1,
      anon_sym_as,
    ACTIONS(3797), 1,
      anon_sym_if,
    ACTIONS(3799), 1,
      anon_sym_COLON,
    ACTIONS(3801), 1,
      anon_sym_async,
    ACTIONS(3803), 1,
      anon_sym_for,
    ACTIONS(3805), 1,
      anon_sym_RBRACE,
    ACTIONS(3807), 1,
      anon_sym_and,
    ACTIONS(3809), 1,
      anon_sym_or,
    STATE(2259), 1,
      sym_for_in_clause,
    STATE(2810), 1,
      aux_sym__collection_elements_repeat1,
    STATE(3320), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [108106] = 13,
    ACTIONS(3793), 1,
      anon_sym_COMMA,
    ACTIONS(3795), 1,
      anon_sym_as,
    ACTIONS(3797), 1,
      anon_sym_if,
    ACTIONS(3799), 1,
      anon_sym_COLON,
    ACTIONS(3801), 1,
      anon_sym_async,
    ACTIONS(3803), 1,
      anon_sym_for,
    ACTIONS(3805), 1,
      anon_sym_RBRACE,
    ACTIONS(3807), 1,
      anon_sym_and,
    ACTIONS(3809), 1,
      anon_sym_or,
    STATE(2259), 1,
      sym_for_in_clause,
    STATE(2810), 1,
      aux_sym__collection_elements_repeat1,
    STATE(3287), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [108147] = 13,
    ACTIONS(3793), 1,
      anon_sym_COMMA,
    ACTIONS(3795), 1,
      anon_sym_as,
    ACTIONS(3797), 1,
      anon_sym_if,
    ACTIONS(3799), 1,
      anon_sym_COLON,
    ACTIONS(3801), 1,
      anon_sym_async,
    ACTIONS(3803), 1,
      anon_sym_for,
    ACTIONS(3805), 1,
      anon_sym_RBRACE,
    ACTIONS(3807), 1,
      anon_sym_and,
    ACTIONS(3809), 1,
      anon_sym_or,
    STATE(2259), 1,
      sym_for_in_clause,
    STATE(2810), 1,
      aux_sym__collection_elements_repeat1,
    STATE(3207), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [108188] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3826), 12,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [108207] = 4,
    ACTIONS(3816), 1,
      anon_sym_and,
    ACTIONS(3818), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3828), 10,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [108230] = 13,
    ACTIONS(3793), 1,
      anon_sym_COMMA,
    ACTIONS(3795), 1,
      anon_sym_as,
    ACTIONS(3797), 1,
      anon_sym_if,
    ACTIONS(3799), 1,
      anon_sym_COLON,
    ACTIONS(3801), 1,
      anon_sym_async,
    ACTIONS(3803), 1,
      anon_sym_for,
    ACTIONS(3805), 1,
      anon_sym_RBRACE,
    ACTIONS(3807), 1,
      anon_sym_and,
    ACTIONS(3809), 1,
      anon_sym_or,
    STATE(2259), 1,
      sym_for_in_clause,
    STATE(2810), 1,
      aux_sym__collection_elements_repeat1,
    STATE(3397), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [108271] = 13,
    ACTIONS(3793), 1,
      anon_sym_COMMA,
    ACTIONS(3795), 1,
      anon_sym_as,
    ACTIONS(3797), 1,
      anon_sym_if,
    ACTIONS(3799), 1,
      anon_sym_COLON,
    ACTIONS(3801), 1,
      anon_sym_async,
    ACTIONS(3803), 1,
      anon_sym_for,
    ACTIONS(3805), 1,
      anon_sym_RBRACE,
    ACTIONS(3807), 1,
      anon_sym_and,
    ACTIONS(3809), 1,
      anon_sym_or,
    STATE(2259), 1,
      sym_for_in_clause,
    STATE(2810), 1,
      aux_sym__collection_elements_repeat1,
    STATE(3261), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [108312] = 6,
    ACTIONS(3816), 1,
      anon_sym_and,
    ACTIONS(3818), 1,
      anon_sym_or,
    ACTIONS(3822), 1,
      anon_sym_as,
    ACTIONS(3824), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3830), 8,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [108339] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3832), 12,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [108358] = 3,
    ACTIONS(3816), 1,
      anon_sym_and,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3826), 11,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_or,
  [108379] = 13,
    ACTIONS(3793), 1,
      anon_sym_COMMA,
    ACTIONS(3795), 1,
      anon_sym_as,
    ACTIONS(3797), 1,
      anon_sym_if,
    ACTIONS(3799), 1,
      anon_sym_COLON,
    ACTIONS(3801), 1,
      anon_sym_async,
    ACTIONS(3803), 1,
      anon_sym_for,
    ACTIONS(3805), 1,
      anon_sym_RBRACE,
    ACTIONS(3807), 1,
      anon_sym_and,
    ACTIONS(3809), 1,
      anon_sym_or,
    STATE(2259), 1,
      sym_for_in_clause,
    STATE(2810), 1,
      aux_sym__collection_elements_repeat1,
    STATE(3229), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [108420] = 6,
    ACTIONS(3816), 1,
      anon_sym_and,
    ACTIONS(3818), 1,
      anon_sym_or,
    ACTIONS(3822), 1,
      anon_sym_as,
    ACTIONS(3824), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3834), 8,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [108447] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2785), 12,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [108466] = 13,
    ACTIONS(3793), 1,
      anon_sym_COMMA,
    ACTIONS(3795), 1,
      anon_sym_as,
    ACTIONS(3797), 1,
      anon_sym_if,
    ACTIONS(3799), 1,
      anon_sym_COLON,
    ACTIONS(3801), 1,
      anon_sym_async,
    ACTIONS(3803), 1,
      anon_sym_for,
    ACTIONS(3805), 1,
      anon_sym_RBRACE,
    ACTIONS(3807), 1,
      anon_sym_and,
    ACTIONS(3809), 1,
      anon_sym_or,
    STATE(2259), 1,
      sym_for_in_clause,
    STATE(2810), 1,
      aux_sym__collection_elements_repeat1,
    STATE(3400), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [108507] = 12,
    ACTIONS(3805), 1,
      anon_sym_RBRACK,
    ACTIONS(3836), 1,
      anon_sym_COMMA,
    ACTIONS(3838), 1,
      anon_sym_as,
    ACTIONS(3840), 1,
      anon_sym_if,
    ACTIONS(3842), 1,
      anon_sym_async,
    ACTIONS(3844), 1,
      anon_sym_for,
    ACTIONS(3846), 1,
      anon_sym_and,
    ACTIONS(3848), 1,
      anon_sym_or,
    STATE(2268), 1,
      sym_for_in_clause,
    STATE(2901), 1,
      aux_sym__collection_elements_repeat1,
    STATE(3323), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [108545] = 12,
    ACTIONS(3850), 1,
      anon_sym_RPAREN,
    ACTIONS(3852), 1,
      anon_sym_COMMA,
    ACTIONS(3854), 1,
      anon_sym_as,
    ACTIONS(3856), 1,
      anon_sym_if,
    ACTIONS(3858), 1,
      anon_sym_async,
    ACTIONS(3860), 1,
      anon_sym_for,
    ACTIONS(3862), 1,
      anon_sym_and,
    ACTIONS(3864), 1,
      anon_sym_or,
    STATE(2282), 1,
      sym_for_in_clause,
    STATE(2794), 1,
      aux_sym_argument_list_repeat1,
    STATE(3257), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [108583] = 9,
    ACTIONS(3816), 1,
      anon_sym_and,
    ACTIONS(3818), 1,
      anon_sym_or,
    ACTIONS(3822), 1,
      anon_sym_as,
    ACTIONS(3824), 1,
      anon_sym_if,
    ACTIONS(3870), 1,
      anon_sym_COMMA,
    STATE(2585), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3866), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(3868), 3,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_PIPE,
  [108615] = 12,
    ACTIONS(3805), 1,
      anon_sym_RBRACK,
    ACTIONS(3836), 1,
      anon_sym_COMMA,
    ACTIONS(3838), 1,
      anon_sym_as,
    ACTIONS(3840), 1,
      anon_sym_if,
    ACTIONS(3842), 1,
      anon_sym_async,
    ACTIONS(3844), 1,
      anon_sym_for,
    ACTIONS(3846), 1,
      anon_sym_and,
    ACTIONS(3848), 1,
      anon_sym_or,
    STATE(2268), 1,
      sym_for_in_clause,
    STATE(2901), 1,
      aux_sym__collection_elements_repeat1,
    STATE(3227), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [108653] = 12,
    ACTIONS(3805), 1,
      anon_sym_RBRACK,
    ACTIONS(3836), 1,
      anon_sym_COMMA,
    ACTIONS(3838), 1,
      anon_sym_as,
    ACTIONS(3840), 1,
      anon_sym_if,
    ACTIONS(3842), 1,
      anon_sym_async,
    ACTIONS(3844), 1,
      anon_sym_for,
    ACTIONS(3846), 1,
      anon_sym_and,
    ACTIONS(3848), 1,
      anon_sym_or,
    STATE(2268), 1,
      sym_for_in_clause,
    STATE(2901), 1,
      aux_sym__collection_elements_repeat1,
    STATE(3237), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [108691] = 12,
    ACTIONS(3854), 1,
      anon_sym_as,
    ACTIONS(3856), 1,
      anon_sym_if,
    ACTIONS(3858), 1,
      anon_sym_async,
    ACTIONS(3860), 1,
      anon_sym_for,
    ACTIONS(3862), 1,
      anon_sym_and,
    ACTIONS(3864), 1,
      anon_sym_or,
    ACTIONS(3872), 1,
      anon_sym_RPAREN,
    ACTIONS(3874), 1,
      anon_sym_COMMA,
    STATE(2282), 1,
      sym_for_in_clause,
    STATE(2674), 1,
      aux_sym_argument_list_repeat1,
    STATE(3366), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [108729] = 12,
    ACTIONS(3854), 1,
      anon_sym_as,
    ACTIONS(3856), 1,
      anon_sym_if,
    ACTIONS(3858), 1,
      anon_sym_async,
    ACTIONS(3860), 1,
      anon_sym_for,
    ACTIONS(3862), 1,
      anon_sym_and,
    ACTIONS(3864), 1,
      anon_sym_or,
    ACTIONS(3876), 1,
      anon_sym_RPAREN,
    ACTIONS(3878), 1,
      anon_sym_COMMA,
    STATE(2282), 1,
      sym_for_in_clause,
    STATE(2720), 1,
      aux_sym__collection_elements_repeat1,
    STATE(3242), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [108767] = 12,
    ACTIONS(3854), 1,
      anon_sym_as,
    ACTIONS(3856), 1,
      anon_sym_if,
    ACTIONS(3858), 1,
      anon_sym_async,
    ACTIONS(3860), 1,
      anon_sym_for,
    ACTIONS(3862), 1,
      anon_sym_and,
    ACTIONS(3864), 1,
      anon_sym_or,
    ACTIONS(3880), 1,
      anon_sym_RPAREN,
    ACTIONS(3882), 1,
      anon_sym_COMMA,
    STATE(2282), 1,
      sym_for_in_clause,
    STATE(2961), 1,
      aux_sym_argument_list_repeat1,
    STATE(3218), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [108805] = 12,
    ACTIONS(3805), 1,
      anon_sym_RBRACK,
    ACTIONS(3836), 1,
      anon_sym_COMMA,
    ACTIONS(3838), 1,
      anon_sym_as,
    ACTIONS(3840), 1,
      anon_sym_if,
    ACTIONS(3842), 1,
      anon_sym_async,
    ACTIONS(3844), 1,
      anon_sym_for,
    ACTIONS(3846), 1,
      anon_sym_and,
    ACTIONS(3848), 1,
      anon_sym_or,
    STATE(2268), 1,
      sym_for_in_clause,
    STATE(2901), 1,
      aux_sym__collection_elements_repeat1,
    STATE(3394), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [108843] = 12,
    ACTIONS(3854), 1,
      anon_sym_as,
    ACTIONS(3856), 1,
      anon_sym_if,
    ACTIONS(3858), 1,
      anon_sym_async,
    ACTIONS(3860), 1,
      anon_sym_for,
    ACTIONS(3862), 1,
      anon_sym_and,
    ACTIONS(3864), 1,
      anon_sym_or,
    ACTIONS(3884), 1,
      anon_sym_RPAREN,
    ACTIONS(3886), 1,
      anon_sym_COMMA,
    STATE(2282), 1,
      sym_for_in_clause,
    STATE(3012), 1,
      aux_sym_argument_list_repeat1,
    STATE(3409), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [108881] = 12,
    ACTIONS(3854), 1,
      anon_sym_as,
    ACTIONS(3856), 1,
      anon_sym_if,
    ACTIONS(3858), 1,
      anon_sym_async,
    ACTIONS(3860), 1,
      anon_sym_for,
    ACTIONS(3862), 1,
      anon_sym_and,
    ACTIONS(3864), 1,
      anon_sym_or,
    ACTIONS(3888), 1,
      anon_sym_RPAREN,
    ACTIONS(3890), 1,
      anon_sym_COMMA,
    STATE(2282), 1,
      sym_for_in_clause,
    STATE(2905), 1,
      aux_sym_argument_list_repeat1,
    STATE(3357), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [108919] = 12,
    ACTIONS(3854), 1,
      anon_sym_as,
    ACTIONS(3856), 1,
      anon_sym_if,
    ACTIONS(3858), 1,
      anon_sym_async,
    ACTIONS(3860), 1,
      anon_sym_for,
    ACTIONS(3862), 1,
      anon_sym_and,
    ACTIONS(3864), 1,
      anon_sym_or,
    ACTIONS(3878), 1,
      anon_sym_COMMA,
    ACTIONS(3892), 1,
      anon_sym_RPAREN,
    STATE(2282), 1,
      sym_for_in_clause,
    STATE(2720), 1,
      aux_sym__collection_elements_repeat1,
    STATE(3357), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [108957] = 7,
    ACTIONS(3897), 1,
      sym__dedent,
    ACTIONS(3899), 1,
      sym_string_start,
    STATE(2138), 1,
      sym_string,
    STATE(2255), 1,
      sym__module_directive_wc_none,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2084), 2,
      sym_concatenated_string,
      aux_sym_module_body_repeat1,
    ACTIONS(3894), 5,
      anon_sym_config,
      anon_sym_meta_wrapper,
      anon_sym_prefix,
      anon_sym_skip_validation,
      anon_sym_snakefile,
  [108985] = 12,
    ACTIONS(3854), 1,
      anon_sym_as,
    ACTIONS(3856), 1,
      anon_sym_if,
    ACTIONS(3858), 1,
      anon_sym_async,
    ACTIONS(3860), 1,
      anon_sym_for,
    ACTIONS(3862), 1,
      anon_sym_and,
    ACTIONS(3864), 1,
      anon_sym_or,
    ACTIONS(3878), 1,
      anon_sym_COMMA,
    ACTIONS(3902), 1,
      anon_sym_RPAREN,
    STATE(2282), 1,
      sym_for_in_clause,
    STATE(2720), 1,
      aux_sym__collection_elements_repeat1,
    STATE(3206), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [109023] = 12,
    ACTIONS(3805), 1,
      anon_sym_RBRACK,
    ACTIONS(3836), 1,
      anon_sym_COMMA,
    ACTIONS(3838), 1,
      anon_sym_as,
    ACTIONS(3840), 1,
      anon_sym_if,
    ACTIONS(3842), 1,
      anon_sym_async,
    ACTIONS(3844), 1,
      anon_sym_for,
    ACTIONS(3846), 1,
      anon_sym_and,
    ACTIONS(3848), 1,
      anon_sym_or,
    STATE(2268), 1,
      sym_for_in_clause,
    STATE(2901), 1,
      aux_sym__collection_elements_repeat1,
    STATE(3403), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [109061] = 12,
    ACTIONS(3854), 1,
      anon_sym_as,
    ACTIONS(3856), 1,
      anon_sym_if,
    ACTIONS(3858), 1,
      anon_sym_async,
    ACTIONS(3860), 1,
      anon_sym_for,
    ACTIONS(3862), 1,
      anon_sym_and,
    ACTIONS(3864), 1,
      anon_sym_or,
    ACTIONS(3878), 1,
      anon_sym_COMMA,
    ACTIONS(3904), 1,
      anon_sym_RPAREN,
    STATE(2282), 1,
      sym_for_in_clause,
    STATE(2720), 1,
      aux_sym__collection_elements_repeat1,
    STATE(3257), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [109099] = 12,
    ACTIONS(3805), 1,
      anon_sym_RBRACK,
    ACTIONS(3836), 1,
      anon_sym_COMMA,
    ACTIONS(3838), 1,
      anon_sym_as,
    ACTIONS(3840), 1,
      anon_sym_if,
    ACTIONS(3842), 1,
      anon_sym_async,
    ACTIONS(3844), 1,
      anon_sym_for,
    ACTIONS(3846), 1,
      anon_sym_and,
    ACTIONS(3848), 1,
      anon_sym_or,
    STATE(2268), 1,
      sym_for_in_clause,
    STATE(2901), 1,
      aux_sym__collection_elements_repeat1,
    STATE(3258), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [109137] = 12,
    ACTIONS(3854), 1,
      anon_sym_as,
    ACTIONS(3856), 1,
      anon_sym_if,
    ACTIONS(3858), 1,
      anon_sym_async,
    ACTIONS(3860), 1,
      anon_sym_for,
    ACTIONS(3862), 1,
      anon_sym_and,
    ACTIONS(3864), 1,
      anon_sym_or,
    ACTIONS(3906), 1,
      anon_sym_RPAREN,
    ACTIONS(3908), 1,
      anon_sym_COMMA,
    STATE(2282), 1,
      sym_for_in_clause,
    STATE(2864), 1,
      aux_sym_argument_list_repeat1,
    STATE(3203), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [109175] = 12,
    ACTIONS(3854), 1,
      anon_sym_as,
    ACTIONS(3856), 1,
      anon_sym_if,
    ACTIONS(3858), 1,
      anon_sym_async,
    ACTIONS(3860), 1,
      anon_sym_for,
    ACTIONS(3862), 1,
      anon_sym_and,
    ACTIONS(3864), 1,
      anon_sym_or,
    ACTIONS(3878), 1,
      anon_sym_COMMA,
    ACTIONS(3910), 1,
      anon_sym_RPAREN,
    STATE(2282), 1,
      sym_for_in_clause,
    STATE(2720), 1,
      aux_sym__collection_elements_repeat1,
    STATE(3218), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [109213] = 12,
    ACTIONS(3854), 1,
      anon_sym_as,
    ACTIONS(3856), 1,
      anon_sym_if,
    ACTIONS(3858), 1,
      anon_sym_async,
    ACTIONS(3860), 1,
      anon_sym_for,
    ACTIONS(3862), 1,
      anon_sym_and,
    ACTIONS(3864), 1,
      anon_sym_or,
    ACTIONS(3878), 1,
      anon_sym_COMMA,
    ACTIONS(3912), 1,
      anon_sym_RPAREN,
    STATE(2282), 1,
      sym_for_in_clause,
    STATE(2720), 1,
      aux_sym__collection_elements_repeat1,
    STATE(3409), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [109251] = 12,
    ACTIONS(3854), 1,
      anon_sym_as,
    ACTIONS(3856), 1,
      anon_sym_if,
    ACTIONS(3858), 1,
      anon_sym_async,
    ACTIONS(3860), 1,
      anon_sym_for,
    ACTIONS(3862), 1,
      anon_sym_and,
    ACTIONS(3864), 1,
      anon_sym_or,
    ACTIONS(3914), 1,
      anon_sym_RPAREN,
    ACTIONS(3916), 1,
      anon_sym_COMMA,
    STATE(2282), 1,
      sym_for_in_clause,
    STATE(2925), 1,
      aux_sym_argument_list_repeat1,
    STATE(3206), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [109289] = 7,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(3920), 1,
      sym__dedent,
    STATE(2138), 1,
      sym_string,
    STATE(2255), 1,
      sym__module_directive_wc_none,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2084), 2,
      sym_concatenated_string,
      aux_sym_module_body_repeat1,
    ACTIONS(3918), 5,
      anon_sym_config,
      anon_sym_meta_wrapper,
      anon_sym_prefix,
      anon_sym_skip_validation,
      anon_sym_snakefile,
  [109317] = 12,
    ACTIONS(3805), 1,
      anon_sym_RBRACK,
    ACTIONS(3836), 1,
      anon_sym_COMMA,
    ACTIONS(3838), 1,
      anon_sym_as,
    ACTIONS(3840), 1,
      anon_sym_if,
    ACTIONS(3842), 1,
      anon_sym_async,
    ACTIONS(3844), 1,
      anon_sym_for,
    ACTIONS(3846), 1,
      anon_sym_and,
    ACTIONS(3848), 1,
      anon_sym_or,
    STATE(2268), 1,
      sym_for_in_clause,
    STATE(2901), 1,
      aux_sym__collection_elements_repeat1,
    STATE(3289), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [109355] = 12,
    ACTIONS(3805), 1,
      anon_sym_RBRACK,
    ACTIONS(3836), 1,
      anon_sym_COMMA,
    ACTIONS(3838), 1,
      anon_sym_as,
    ACTIONS(3840), 1,
      anon_sym_if,
    ACTIONS(3842), 1,
      anon_sym_async,
    ACTIONS(3844), 1,
      anon_sym_for,
    ACTIONS(3846), 1,
      anon_sym_and,
    ACTIONS(3848), 1,
      anon_sym_or,
    STATE(2268), 1,
      sym_for_in_clause,
    STATE(2901), 1,
      aux_sym__collection_elements_repeat1,
    STATE(3186), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [109393] = 7,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(3922), 1,
      sym__dedent,
    STATE(2138), 1,
      sym_string,
    STATE(2255), 1,
      sym__module_directive_wc_none,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2084), 2,
      sym_concatenated_string,
      aux_sym_module_body_repeat1,
    ACTIONS(3918), 5,
      anon_sym_config,
      anon_sym_meta_wrapper,
      anon_sym_prefix,
      anon_sym_skip_validation,
      anon_sym_snakefile,
  [109421] = 12,
    ACTIONS(3854), 1,
      anon_sym_as,
    ACTIONS(3856), 1,
      anon_sym_if,
    ACTIONS(3858), 1,
      anon_sym_async,
    ACTIONS(3860), 1,
      anon_sym_for,
    ACTIONS(3862), 1,
      anon_sym_and,
    ACTIONS(3864), 1,
      anon_sym_or,
    ACTIONS(3878), 1,
      anon_sym_COMMA,
    ACTIONS(3924), 1,
      anon_sym_RPAREN,
    STATE(2282), 1,
      sym_for_in_clause,
    STATE(2720), 1,
      aux_sym__collection_elements_repeat1,
    STATE(3366), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [109459] = 12,
    ACTIONS(3854), 1,
      anon_sym_as,
    ACTIONS(3856), 1,
      anon_sym_if,
    ACTIONS(3858), 1,
      anon_sym_async,
    ACTIONS(3860), 1,
      anon_sym_for,
    ACTIONS(3862), 1,
      anon_sym_and,
    ACTIONS(3864), 1,
      anon_sym_or,
    ACTIONS(3926), 1,
      anon_sym_RPAREN,
    ACTIONS(3928), 1,
      anon_sym_COMMA,
    STATE(2282), 1,
      sym_for_in_clause,
    STATE(2970), 1,
      aux_sym_argument_list_repeat1,
    STATE(3293), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [109497] = 12,
    ACTIONS(3854), 1,
      anon_sym_as,
    ACTIONS(3856), 1,
      anon_sym_if,
    ACTIONS(3858), 1,
      anon_sym_async,
    ACTIONS(3860), 1,
      anon_sym_for,
    ACTIONS(3862), 1,
      anon_sym_and,
    ACTIONS(3864), 1,
      anon_sym_or,
    ACTIONS(3876), 1,
      anon_sym_RPAREN,
    ACTIONS(3930), 1,
      anon_sym_COMMA,
    STATE(2282), 1,
      sym_for_in_clause,
    STATE(2720), 1,
      aux_sym__collection_elements_repeat1,
    STATE(3242), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [109535] = 12,
    ACTIONS(3854), 1,
      anon_sym_as,
    ACTIONS(3856), 1,
      anon_sym_if,
    ACTIONS(3858), 1,
      anon_sym_async,
    ACTIONS(3860), 1,
      anon_sym_for,
    ACTIONS(3862), 1,
      anon_sym_and,
    ACTIONS(3864), 1,
      anon_sym_or,
    ACTIONS(3933), 1,
      anon_sym_RPAREN,
    ACTIONS(3935), 1,
      anon_sym_COMMA,
    STATE(2282), 1,
      sym_for_in_clause,
    STATE(2842), 1,
      aux_sym_argument_list_repeat1,
    STATE(3242), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [109573] = 12,
    ACTIONS(3854), 1,
      anon_sym_as,
    ACTIONS(3856), 1,
      anon_sym_if,
    ACTIONS(3858), 1,
      anon_sym_async,
    ACTIONS(3860), 1,
      anon_sym_for,
    ACTIONS(3862), 1,
      anon_sym_and,
    ACTIONS(3864), 1,
      anon_sym_or,
    ACTIONS(3878), 1,
      anon_sym_COMMA,
    ACTIONS(3937), 1,
      anon_sym_RPAREN,
    STATE(2282), 1,
      sym_for_in_clause,
    STATE(2720), 1,
      aux_sym__collection_elements_repeat1,
    STATE(3203), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [109611] = 12,
    ACTIONS(3805), 1,
      anon_sym_RBRACK,
    ACTIONS(3836), 1,
      anon_sym_COMMA,
    ACTIONS(3838), 1,
      anon_sym_as,
    ACTIONS(3840), 1,
      anon_sym_if,
    ACTIONS(3842), 1,
      anon_sym_async,
    ACTIONS(3844), 1,
      anon_sym_for,
    ACTIONS(3846), 1,
      anon_sym_and,
    ACTIONS(3848), 1,
      anon_sym_or,
    STATE(2268), 1,
      sym_for_in_clause,
    STATE(2901), 1,
      aux_sym__collection_elements_repeat1,
    STATE(3204), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [109649] = 12,
    ACTIONS(3854), 1,
      anon_sym_as,
    ACTIONS(3856), 1,
      anon_sym_if,
    ACTIONS(3858), 1,
      anon_sym_async,
    ACTIONS(3860), 1,
      anon_sym_for,
    ACTIONS(3862), 1,
      anon_sym_and,
    ACTIONS(3864), 1,
      anon_sym_or,
    ACTIONS(3878), 1,
      anon_sym_COMMA,
    ACTIONS(3939), 1,
      anon_sym_RPAREN,
    STATE(2282), 1,
      sym_for_in_clause,
    STATE(2720), 1,
      aux_sym__collection_elements_repeat1,
    STATE(3293), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [109687] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2785), 10,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [109704] = 6,
    ACTIONS(964), 1,
      sym_string_start,
    STATE(2138), 1,
      sym_string,
    STATE(2255), 1,
      sym__module_directive_wc_none,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2093), 2,
      sym_concatenated_string,
      aux_sym_module_body_repeat1,
    ACTIONS(3918), 5,
      anon_sym_config,
      anon_sym_meta_wrapper,
      anon_sym_prefix,
      anon_sym_skip_validation,
      anon_sym_snakefile,
  [109729] = 6,
    ACTIONS(3941), 1,
      anon_sym_as,
    ACTIONS(3943), 1,
      anon_sym_if,
    ACTIONS(3945), 1,
      anon_sym_and,
    ACTIONS(3947), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3834), 6,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [109754] = 5,
    ACTIONS(3945), 1,
      anon_sym_and,
    ACTIONS(3947), 1,
      anon_sym_or,
    ACTIONS(3949), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3811), 7,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [109777] = 4,
    ACTIONS(3945), 1,
      anon_sym_and,
    ACTIONS(3947), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3828), 8,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [109798] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3826), 10,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [109815] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3832), 10,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [109832] = 3,
    ACTIONS(3945), 1,
      anon_sym_and,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3826), 9,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_or,
  [109851] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3832), 10,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [109868] = 6,
    ACTIONS(3816), 1,
      anon_sym_and,
    ACTIONS(3818), 1,
      anon_sym_or,
    ACTIONS(3822), 1,
      anon_sym_as,
    ACTIONS(3824), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3868), 6,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [109893] = 6,
    ACTIONS(3941), 1,
      anon_sym_as,
    ACTIONS(3943), 1,
      anon_sym_if,
    ACTIONS(3945), 1,
      anon_sym_and,
    ACTIONS(3947), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3830), 6,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [109918] = 6,
    ACTIONS(3952), 1,
      anon_sym_as,
    ACTIONS(3954), 1,
      anon_sym_if,
    ACTIONS(3956), 1,
      anon_sym_and,
    ACTIONS(3958), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3820), 6,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_EQ,
      anon_sym_PIPE,
  [109943] = 6,
    ACTIONS(3941), 1,
      anon_sym_as,
    ACTIONS(3943), 1,
      anon_sym_if,
    ACTIONS(3945), 1,
      anon_sym_and,
    ACTIONS(3947), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3820), 6,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [109968] = 8,
    ACTIONS(3960), 1,
      anon_sym_COMMA,
    ACTIONS(3962), 1,
      anon_sym_as,
    ACTIONS(3964), 1,
      anon_sym_if,
    ACTIONS(3968), 1,
      anon_sym_and,
    ACTIONS(3970), 1,
      anon_sym_or,
    STATE(2403), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3966), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [109997] = 6,
    ACTIONS(3952), 1,
      anon_sym_as,
    ACTIONS(3954), 1,
      anon_sym_if,
    ACTIONS(3956), 1,
      anon_sym_and,
    ACTIONS(3958), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3830), 6,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_EQ,
      anon_sym_PIPE,
  [110022] = 6,
    ACTIONS(3952), 1,
      anon_sym_as,
    ACTIONS(3954), 1,
      anon_sym_if,
    ACTIONS(3956), 1,
      anon_sym_and,
    ACTIONS(3958), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3834), 6,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_EQ,
      anon_sym_PIPE,
  [110047] = 6,
    ACTIONS(3941), 1,
      anon_sym_as,
    ACTIONS(3943), 1,
      anon_sym_if,
    ACTIONS(3945), 1,
      anon_sym_and,
    ACTIONS(3947), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3868), 6,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [110072] = 5,
    ACTIONS(3956), 1,
      anon_sym_and,
    ACTIONS(3958), 1,
      anon_sym_or,
    ACTIONS(3972), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3811), 7,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_EQ,
      anon_sym_PIPE,
  [110095] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2785), 10,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [110112] = 3,
    ACTIONS(3956), 1,
      anon_sym_and,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3826), 9,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_or,
  [110131] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3826), 10,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [110148] = 4,
    ACTIONS(3956), 1,
      anon_sym_and,
    ACTIONS(3958), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3828), 8,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_EQ,
      anon_sym_PIPE,
  [110169] = 8,
    ACTIONS(3960), 1,
      anon_sym_COMMA,
    ACTIONS(3962), 1,
      anon_sym_as,
    ACTIONS(3964), 1,
      anon_sym_if,
    ACTIONS(3968), 1,
      anon_sym_and,
    ACTIONS(3970), 1,
      anon_sym_or,
    STATE(2403), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3975), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [110198] = 6,
    ACTIONS(964), 1,
      sym_string_start,
    STATE(2138), 1,
      sym_string,
    STATE(2255), 1,
      sym__module_directive_wc_none,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2096), 2,
      sym_concatenated_string,
      aux_sym_module_body_repeat1,
    ACTIONS(3918), 5,
      anon_sym_config,
      anon_sym_meta_wrapper,
      anon_sym_prefix,
      anon_sym_skip_validation,
      anon_sym_snakefile,
  [110223] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(3982), 1,
      sym__not_escape_sequence,
    STATE(2128), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(3979), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    ACTIONS(3977), 4,
      sym_string_end,
      sym__WILDCARD_DEF_OPEN,
      sym__WILDCARD_INTERP_OPEN,
      anon_sym_LBRACE,
  [110247] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3832), 9,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      sym_type_conversion,
  [110263] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2785), 9,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [110279] = 3,
    ACTIONS(3985), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3832), 8,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
  [110297] = 4,
    ACTIONS(3989), 1,
      anon_sym_DOT,
    STATE(2132), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3987), 7,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [110317] = 4,
    ACTIONS(3994), 1,
      anon_sym_DOT,
    STATE(2152), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3992), 7,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [110337] = 6,
    ACTIONS(3795), 1,
      anon_sym_as,
    ACTIONS(3797), 1,
      anon_sym_if,
    ACTIONS(3807), 1,
      anon_sym_and,
    ACTIONS(3809), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3830), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [110361] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3832), 9,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [110377] = 6,
    ACTIONS(3795), 1,
      anon_sym_as,
    ACTIONS(3797), 1,
      anon_sym_if,
    ACTIONS(3807), 1,
      anon_sym_and,
    ACTIONS(3809), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3820), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [110401] = 6,
    ACTIONS(3962), 1,
      anon_sym_as,
    ACTIONS(3964), 1,
      anon_sym_if,
    ACTIONS(3968), 1,
      anon_sym_and,
    ACTIONS(3970), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3996), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [110425] = 4,
    ACTIONS(964), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1085), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(3998), 6,
      sym__dedent,
      anon_sym_config,
      anon_sym_meta_wrapper,
      anon_sym_prefix,
      anon_sym_skip_validation,
      anon_sym_snakefile,
  [110445] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2785), 9,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      sym_type_conversion,
  [110461] = 6,
    ACTIONS(3962), 1,
      anon_sym_as,
    ACTIONS(3964), 1,
      anon_sym_if,
    ACTIONS(3968), 1,
      anon_sym_and,
    ACTIONS(3970), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3834), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [110485] = 6,
    ACTIONS(4000), 1,
      anon_sym_as,
    ACTIONS(4002), 1,
      anon_sym_if,
    ACTIONS(4004), 1,
      anon_sym_and,
    ACTIONS(4006), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3834), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [110509] = 5,
    ACTIONS(4004), 1,
      anon_sym_and,
    ACTIONS(4006), 1,
      anon_sym_or,
    ACTIONS(4008), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3811), 6,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [110531] = 5,
    ACTIONS(3968), 1,
      anon_sym_and,
    ACTIONS(3970), 1,
      anon_sym_or,
    ACTIONS(4011), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3811), 6,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [110553] = 4,
    ACTIONS(3968), 1,
      anon_sym_and,
    ACTIONS(3970), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3828), 7,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [110573] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3826), 9,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      sym_type_conversion,
  [110589] = 3,
    ACTIONS(3968), 1,
      anon_sym_and,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3826), 8,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_or,
      sym_type_conversion,
  [110607] = 4,
    ACTIONS(4004), 1,
      anon_sym_and,
    ACTIONS(4006), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3828), 7,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [110627] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3826), 9,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [110643] = 5,
    ACTIONS(3994), 1,
      anon_sym_DOT,
    ACTIONS(4014), 1,
      anon_sym_EQ,
    STATE(2152), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3992), 6,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [110665] = 3,
    ACTIONS(4004), 1,
      anon_sym_and,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3826), 8,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_or,
  [110683] = 6,
    ACTIONS(4000), 1,
      anon_sym_as,
    ACTIONS(4002), 1,
      anon_sym_if,
    ACTIONS(4004), 1,
      anon_sym_and,
    ACTIONS(4006), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3868), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [110707] = 4,
    ACTIONS(3994), 1,
      anon_sym_DOT,
    STATE(2132), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4016), 7,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [110727] = 6,
    ACTIONS(3952), 1,
      anon_sym_as,
    ACTIONS(3954), 1,
      anon_sym_if,
    ACTIONS(3956), 1,
      anon_sym_and,
    ACTIONS(3958), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3868), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [110751] = 6,
    ACTIONS(3962), 1,
      anon_sym_as,
    ACTIONS(3964), 1,
      anon_sym_if,
    ACTIONS(3968), 1,
      anon_sym_and,
    ACTIONS(3970), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4018), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [110775] = 6,
    ACTIONS(4000), 1,
      anon_sym_as,
    ACTIONS(4002), 1,
      anon_sym_if,
    ACTIONS(4004), 1,
      anon_sym_and,
    ACTIONS(4006), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3830), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [110799] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(4024), 1,
      sym__not_escape_sequence,
    STATE(2128), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(4022), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    ACTIONS(4020), 4,
      sym_string_end,
      sym__WILDCARD_DEF_OPEN,
      sym__WILDCARD_INTERP_OPEN,
      anon_sym_LBRACE,
  [110823] = 6,
    ACTIONS(4000), 1,
      anon_sym_as,
    ACTIONS(4002), 1,
      anon_sym_if,
    ACTIONS(4004), 1,
      anon_sym_and,
    ACTIONS(4006), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3820), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [110847] = 6,
    ACTIONS(3795), 1,
      anon_sym_as,
    ACTIONS(3797), 1,
      anon_sym_if,
    ACTIONS(3807), 1,
      anon_sym_and,
    ACTIONS(3809), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3834), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [110871] = 5,
    ACTIONS(3807), 1,
      anon_sym_and,
    ACTIONS(3809), 1,
      anon_sym_or,
    ACTIONS(4026), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3811), 6,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [110893] = 5,
    ACTIONS(3807), 1,
      anon_sym_and,
    ACTIONS(3809), 1,
      anon_sym_or,
    ACTIONS(4029), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3828), 6,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [110915] = 3,
    ACTIONS(4031), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3826), 8,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
  [110933] = 4,
    ACTIONS(3807), 1,
      anon_sym_and,
    ACTIONS(4031), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3826), 7,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
      anon_sym_or,
  [110953] = 6,
    ACTIONS(3962), 1,
      anon_sym_as,
    ACTIONS(3964), 1,
      anon_sym_if,
    ACTIONS(3968), 1,
      anon_sym_and,
    ACTIONS(3970), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3820), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [110977] = 9,
    ACTIONS(3816), 1,
      anon_sym_and,
    ACTIONS(3818), 1,
      anon_sym_or,
    ACTIONS(3822), 1,
      anon_sym_as,
    ACTIONS(3824), 1,
      anon_sym_if,
    ACTIONS(4035), 1,
      anon_sym_from,
    ACTIONS(4037), 1,
      anon_sym_COMMA,
    STATE(2447), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4033), 2,
      sym__newline,
      anon_sym_SEMI,
  [111007] = 3,
    ACTIONS(2799), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2785), 8,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
  [111025] = 6,
    ACTIONS(3962), 1,
      anon_sym_as,
    ACTIONS(3964), 1,
      anon_sym_if,
    ACTIONS(3968), 1,
      anon_sym_and,
    ACTIONS(3970), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3830), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [111049] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(4041), 1,
      sym__not_escape_sequence,
    ACTIONS(4039), 7,
      sym__string_content,
      sym_escape_interpolation,
      sym_string_end,
      sym__WILDCARD_DEF_OPEN,
      sym__WILDCARD_INTERP_OPEN,
      anon_sym_LBRACE,
      sym_escape_sequence,
  [111068] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(4045), 1,
      sym__not_escape_sequence,
    ACTIONS(4043), 7,
      sym__string_content,
      sym_escape_interpolation,
      sym_string_end,
      sym__WILDCARD_DEF_OPEN,
      sym__WILDCARD_INTERP_OPEN,
      anon_sym_LBRACE,
      sym_escape_sequence,
  [111087] = 7,
    ACTIONS(810), 1,
      anon_sym_except_STAR,
    ACTIONS(818), 1,
      anon_sym_except,
    ACTIONS(4047), 1,
      anon_sym_finally,
    STATE(454), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(172), 2,
      sym_except_group_clause,
      aux_sym_try_statement_repeat2,
    STATE(182), 2,
      sym_except_clause,
      aux_sym_try_statement_repeat1,
  [111112] = 9,
    ACTIONS(4000), 1,
      anon_sym_as,
    ACTIONS(4002), 1,
      anon_sym_if,
    ACTIONS(4004), 1,
      anon_sym_and,
    ACTIONS(4006), 1,
      anon_sym_or,
    ACTIONS(4049), 1,
      anon_sym_COMMA,
    ACTIONS(4051), 1,
      anon_sym_COLON,
    ACTIONS(4053), 1,
      anon_sym_RBRACK,
    STATE(2676), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [111141] = 9,
    ACTIONS(4000), 1,
      anon_sym_as,
    ACTIONS(4002), 1,
      anon_sym_if,
    ACTIONS(4004), 1,
      anon_sym_and,
    ACTIONS(4006), 1,
      anon_sym_or,
    ACTIONS(4051), 1,
      anon_sym_COLON,
    ACTIONS(4055), 1,
      anon_sym_COMMA,
    ACTIONS(4057), 1,
      anon_sym_RBRACK,
    STATE(3000), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [111170] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(4061), 1,
      sym__not_escape_sequence,
    ACTIONS(4059), 7,
      sym__string_content,
      sym_escape_interpolation,
      sym_string_end,
      sym__WILDCARD_DEF_OPEN,
      sym__WILDCARD_INTERP_OPEN,
      anon_sym_LBRACE,
      sym_escape_sequence,
  [111189] = 3,
    ACTIONS(2799), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2785), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_and,
      anon_sym_or,
  [111206] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(4065), 1,
      sym__not_escape_sequence,
    ACTIONS(4063), 7,
      sym__string_content,
      sym_escape_interpolation,
      sym_string_end,
      sym__WILDCARD_DEF_OPEN,
      sym__WILDCARD_INTERP_OPEN,
      anon_sym_LBRACE,
      sym_escape_sequence,
  [111225] = 8,
    ACTIONS(3816), 1,
      anon_sym_and,
    ACTIONS(3818), 1,
      anon_sym_or,
    ACTIONS(3822), 1,
      anon_sym_as,
    ACTIONS(3824), 1,
      anon_sym_if,
    ACTIONS(4037), 1,
      anon_sym_COMMA,
    STATE(2447), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3675), 2,
      sym__newline,
      anon_sym_SEMI,
  [111252] = 3,
    ACTIONS(3985), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3832), 7,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [111269] = 4,
    ACTIONS(408), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1258), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(4067), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [111288] = 6,
    ACTIONS(3854), 1,
      anon_sym_as,
    ACTIONS(3856), 1,
      anon_sym_if,
    ACTIONS(3862), 1,
      anon_sym_and,
    ACTIONS(3864), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3834), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_async,
      anon_sym_for,
  [111311] = 9,
    ACTIONS(4000), 1,
      anon_sym_as,
    ACTIONS(4002), 1,
      anon_sym_if,
    ACTIONS(4004), 1,
      anon_sym_and,
    ACTIONS(4006), 1,
      anon_sym_or,
    ACTIONS(4051), 1,
      anon_sym_COLON,
    ACTIONS(4069), 1,
      anon_sym_COMMA,
    ACTIONS(4071), 1,
      anon_sym_RBRACK,
    STATE(2770), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [111340] = 8,
    ACTIONS(3816), 1,
      anon_sym_and,
    ACTIONS(3818), 1,
      anon_sym_or,
    ACTIONS(3822), 1,
      anon_sym_as,
    ACTIONS(3824), 1,
      anon_sym_if,
    ACTIONS(4075), 1,
      anon_sym_COMMA,
    STATE(2626), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4073), 2,
      sym__newline,
      anon_sym_SEMI,
  [111367] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(4079), 1,
      sym__not_escape_sequence,
    ACTIONS(4077), 7,
      sym__string_content,
      sym_escape_interpolation,
      sym_string_end,
      sym__WILDCARD_DEF_OPEN,
      sym__WILDCARD_INTERP_OPEN,
      anon_sym_LBRACE,
      sym_escape_sequence,
  [111386] = 9,
    ACTIONS(4000), 1,
      anon_sym_as,
    ACTIONS(4002), 1,
      anon_sym_if,
    ACTIONS(4004), 1,
      anon_sym_and,
    ACTIONS(4006), 1,
      anon_sym_or,
    ACTIONS(4051), 1,
      anon_sym_COLON,
    ACTIONS(4081), 1,
      anon_sym_COMMA,
    ACTIONS(4083), 1,
      anon_sym_RBRACK,
    STATE(2965), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [111415] = 5,
    ACTIONS(3846), 1,
      anon_sym_and,
    ACTIONS(3848), 1,
      anon_sym_or,
    ACTIONS(4029), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3828), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [111436] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(4087), 1,
      sym__not_escape_sequence,
    ACTIONS(4085), 7,
      sym__string_content,
      sym_escape_interpolation,
      sym_string_end,
      sym__WILDCARD_DEF_OPEN,
      sym__WILDCARD_INTERP_OPEN,
      anon_sym_LBRACE,
      sym_escape_sequence,
  [111455] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3987), 8,
      anon_sym_import,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [111470] = 9,
    ACTIONS(4000), 1,
      anon_sym_as,
    ACTIONS(4002), 1,
      anon_sym_if,
    ACTIONS(4004), 1,
      anon_sym_and,
    ACTIONS(4006), 1,
      anon_sym_or,
    ACTIONS(4051), 1,
      anon_sym_COLON,
    ACTIONS(4089), 1,
      anon_sym_COMMA,
    ACTIONS(4091), 1,
      anon_sym_RBRACK,
    STATE(2838), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [111499] = 7,
    ACTIONS(63), 1,
      anon_sym_AT,
    ACTIONS(4093), 1,
      anon_sym_async,
    ACTIONS(4095), 1,
      anon_sym_def,
    ACTIONS(4097), 1,
      anon_sym_class,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(456), 2,
      sym_function_definition,
      sym_class_definition,
    STATE(2362), 2,
      sym_decorator,
      aux_sym_decorated_definition_repeat1,
  [111524] = 5,
    ACTIONS(3854), 1,
      anon_sym_as,
    ACTIONS(3862), 1,
      anon_sym_and,
    ACTIONS(3864), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4099), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [111545] = 3,
    ACTIONS(2799), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2785), 7,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [111562] = 8,
    ACTIONS(3816), 1,
      anon_sym_and,
    ACTIONS(3818), 1,
      anon_sym_or,
    ACTIONS(3822), 1,
      anon_sym_as,
    ACTIONS(3824), 1,
      anon_sym_if,
    ACTIONS(4037), 1,
      anon_sym_COMMA,
    STATE(2447), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3975), 2,
      sym__newline,
      anon_sym_SEMI,
  [111589] = 9,
    ACTIONS(4000), 1,
      anon_sym_as,
    ACTIONS(4002), 1,
      anon_sym_if,
    ACTIONS(4004), 1,
      anon_sym_and,
    ACTIONS(4006), 1,
      anon_sym_or,
    ACTIONS(4051), 1,
      anon_sym_COLON,
    ACTIONS(4101), 1,
      anon_sym_COMMA,
    ACTIONS(4103), 1,
      anon_sym_RBRACK,
    STATE(2923), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [111618] = 3,
    ACTIONS(3985), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3832), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_and,
      anon_sym_or,
  [111635] = 9,
    ACTIONS(4000), 1,
      anon_sym_as,
    ACTIONS(4002), 1,
      anon_sym_if,
    ACTIONS(4004), 1,
      anon_sym_and,
    ACTIONS(4006), 1,
      anon_sym_or,
    ACTIONS(4051), 1,
      anon_sym_COLON,
    ACTIONS(4105), 1,
      anon_sym_COMMA,
    ACTIONS(4107), 1,
      anon_sym_RBRACK,
    STATE(2761), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [111664] = 5,
    ACTIONS(3838), 1,
      anon_sym_as,
    ACTIONS(3846), 1,
      anon_sym_and,
    ACTIONS(3848), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4099), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [111685] = 7,
    ACTIONS(810), 1,
      anon_sym_except_STAR,
    ACTIONS(818), 1,
      anon_sym_except,
    ACTIONS(4047), 1,
      anon_sym_finally,
    STATE(476), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(173), 2,
      sym_except_clause,
      aux_sym_try_statement_repeat1,
    STATE(185), 2,
      sym_except_group_clause,
      aux_sym_try_statement_repeat2,
  [111710] = 7,
    ACTIONS(63), 1,
      anon_sym_AT,
    ACTIONS(4109), 1,
      anon_sym_async,
    ACTIONS(4111), 1,
      anon_sym_def,
    ACTIONS(4113), 1,
      anon_sym_class,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(458), 2,
      sym_function_definition,
      sym_class_definition,
    STATE(2362), 2,
      sym_decorator,
      aux_sym_decorated_definition_repeat1,
  [111735] = 9,
    ACTIONS(4000), 1,
      anon_sym_as,
    ACTIONS(4002), 1,
      anon_sym_if,
    ACTIONS(4004), 1,
      anon_sym_and,
    ACTIONS(4006), 1,
      anon_sym_or,
    ACTIONS(4051), 1,
      anon_sym_COLON,
    ACTIONS(4115), 1,
      anon_sym_COMMA,
    ACTIONS(4117), 1,
      anon_sym_RBRACK,
    STATE(2791), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [111764] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(4121), 1,
      sym__not_escape_sequence,
    ACTIONS(4119), 7,
      sym__string_content,
      sym_escape_interpolation,
      sym_string_end,
      sym__WILDCARD_DEF_OPEN,
      sym__WILDCARD_INTERP_OPEN,
      anon_sym_LBRACE,
      sym_escape_sequence,
  [111783] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(4125), 1,
      sym__not_escape_sequence,
    ACTIONS(4123), 7,
      sym__string_content,
      sym_escape_interpolation,
      sym_string_end,
      sym__WILDCARD_DEF_OPEN,
      sym__WILDCARD_INTERP_OPEN,
      anon_sym_LBRACE,
      sym_escape_sequence,
  [111802] = 9,
    ACTIONS(4000), 1,
      anon_sym_as,
    ACTIONS(4002), 1,
      anon_sym_if,
    ACTIONS(4004), 1,
      anon_sym_and,
    ACTIONS(4006), 1,
      anon_sym_or,
    ACTIONS(4051), 1,
      anon_sym_COLON,
    ACTIONS(4127), 1,
      anon_sym_COMMA,
    ACTIONS(4129), 1,
      anon_sym_RBRACK,
    STATE(2914), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [111831] = 8,
    ACTIONS(3816), 1,
      anon_sym_and,
    ACTIONS(3818), 1,
      anon_sym_or,
    ACTIONS(3822), 1,
      anon_sym_as,
    ACTIONS(3824), 1,
      anon_sym_if,
    ACTIONS(4075), 1,
      anon_sym_COMMA,
    STATE(2594), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4131), 2,
      sym__newline,
      anon_sym_SEMI,
  [111858] = 7,
    ACTIONS(822), 1,
      anon_sym_except_STAR,
    ACTIONS(826), 1,
      anon_sym_except,
    ACTIONS(4133), 1,
      anon_sym_finally,
    STATE(484), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(175), 2,
      sym_except_clause,
      aux_sym_try_statement_repeat1,
    STATE(176), 2,
      sym_except_group_clause,
      aux_sym_try_statement_repeat2,
  [111883] = 5,
    ACTIONS(3846), 1,
      anon_sym_and,
    ACTIONS(3848), 1,
      anon_sym_or,
    ACTIONS(4135), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3811), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [111904] = 9,
    ACTIONS(4000), 1,
      anon_sym_as,
    ACTIONS(4002), 1,
      anon_sym_if,
    ACTIONS(4004), 1,
      anon_sym_and,
    ACTIONS(4006), 1,
      anon_sym_or,
    ACTIONS(4051), 1,
      anon_sym_COLON,
    ACTIONS(4138), 1,
      anon_sym_COMMA,
    ACTIONS(4140), 1,
      anon_sym_RBRACK,
    STATE(2846), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [111933] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(4144), 1,
      sym__not_escape_sequence,
    ACTIONS(4142), 7,
      sym__string_content,
      sym_escape_interpolation,
      sym_string_end,
      sym__WILDCARD_DEF_OPEN,
      sym__WILDCARD_INTERP_OPEN,
      anon_sym_LBRACE,
      sym_escape_sequence,
  [111952] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(4148), 1,
      sym__not_escape_sequence,
    ACTIONS(4146), 7,
      sym__string_content,
      sym_escape_interpolation,
      sym_string_end,
      sym__WILDCARD_DEF_OPEN,
      sym__WILDCARD_INTERP_OPEN,
      anon_sym_LBRACE,
      sym_escape_sequence,
  [111971] = 5,
    ACTIONS(3854), 1,
      anon_sym_as,
    ACTIONS(3862), 1,
      anon_sym_and,
    ACTIONS(3864), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4099), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [111992] = 6,
    ACTIONS(3816), 1,
      anon_sym_and,
    ACTIONS(3818), 1,
      anon_sym_or,
    ACTIONS(3822), 1,
      anon_sym_as,
    ACTIONS(3824), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4018), 4,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
      anon_sym_COMMA,
  [112015] = 3,
    ACTIONS(4031), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3826), 7,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [112032] = 7,
    ACTIONS(822), 1,
      anon_sym_except_STAR,
    ACTIONS(826), 1,
      anon_sym_except,
    ACTIONS(4133), 1,
      anon_sym_finally,
    STATE(483), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(174), 2,
      sym_except_group_clause,
      aux_sym_try_statement_repeat2,
    STATE(177), 2,
      sym_except_clause,
      aux_sym_try_statement_repeat1,
  [112057] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(4152), 1,
      sym__not_escape_sequence,
    ACTIONS(4150), 7,
      sym__string_content,
      sym_escape_interpolation,
      sym_string_end,
      sym__WILDCARD_DEF_OPEN,
      sym__WILDCARD_INTERP_OPEN,
      anon_sym_LBRACE,
      sym_escape_sequence,
  [112076] = 5,
    ACTIONS(3795), 1,
      anon_sym_as,
    ACTIONS(3807), 1,
      anon_sym_and,
    ACTIONS(3809), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4099), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [112097] = 6,
    ACTIONS(3854), 1,
      anon_sym_as,
    ACTIONS(3856), 1,
      anon_sym_if,
    ACTIONS(3862), 1,
      anon_sym_and,
    ACTIONS(3864), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3830), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_async,
      anon_sym_for,
  [112120] = 8,
    ACTIONS(3816), 1,
      anon_sym_and,
    ACTIONS(3818), 1,
      anon_sym_or,
    ACTIONS(3822), 1,
      anon_sym_as,
    ACTIONS(3824), 1,
      anon_sym_if,
    ACTIONS(4037), 1,
      anon_sym_COMMA,
    STATE(2447), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4154), 2,
      sym__newline,
      anon_sym_SEMI,
  [112147] = 5,
    ACTIONS(3838), 1,
      anon_sym_as,
    ACTIONS(3846), 1,
      anon_sym_and,
    ACTIONS(3848), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4099), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [112168] = 5,
    ACTIONS(3795), 1,
      anon_sym_as,
    ACTIONS(3807), 1,
      anon_sym_and,
    ACTIONS(3809), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4099), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [112189] = 4,
    ACTIONS(3846), 1,
      anon_sym_and,
    ACTIONS(4031), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3826), 6,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_or,
  [112208] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(4158), 1,
      sym__not_escape_sequence,
    ACTIONS(4156), 7,
      sym__string_content,
      sym_escape_interpolation,
      sym_string_end,
      sym__WILDCARD_DEF_OPEN,
      sym__WILDCARD_INTERP_OPEN,
      anon_sym_LBRACE,
      sym_escape_sequence,
  [112227] = 5,
    ACTIONS(3862), 1,
      anon_sym_and,
    ACTIONS(3864), 1,
      anon_sym_or,
    ACTIONS(4029), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3828), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [112248] = 5,
    ACTIONS(4160), 1,
      anon_sym_DOT,
    ACTIONS(4162), 1,
      anon_sym_EQ,
    STATE(2269), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3992), 5,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [112269] = 6,
    ACTIONS(3838), 1,
      anon_sym_as,
    ACTIONS(3840), 1,
      anon_sym_if,
    ACTIONS(3846), 1,
      anon_sym_and,
    ACTIONS(3848), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3834), 4,
      anon_sym_COMMA,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [112292] = 6,
    ACTIONS(3854), 1,
      anon_sym_as,
    ACTIONS(3856), 1,
      anon_sym_if,
    ACTIONS(3862), 1,
      anon_sym_and,
    ACTIONS(3864), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3820), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_async,
      anon_sym_for,
  [112315] = 5,
    ACTIONS(3862), 1,
      anon_sym_and,
    ACTIONS(3864), 1,
      anon_sym_or,
    ACTIONS(4164), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3811), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [112336] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(4169), 1,
      sym__not_escape_sequence,
    ACTIONS(4167), 7,
      sym__string_content,
      sym_escape_interpolation,
      sym_string_end,
      sym__WILDCARD_DEF_OPEN,
      sym__WILDCARD_INTERP_OPEN,
      anon_sym_LBRACE,
      sym_escape_sequence,
  [112355] = 6,
    ACTIONS(3795), 1,
      anon_sym_as,
    ACTIONS(3797), 1,
      anon_sym_if,
    ACTIONS(3807), 1,
      anon_sym_and,
    ACTIONS(3809), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4171), 4,
      anon_sym_COMMA,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [112378] = 5,
    ACTIONS(3854), 1,
      anon_sym_as,
    ACTIONS(3862), 1,
      anon_sym_and,
    ACTIONS(3864), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4099), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [112399] = 8,
    ACTIONS(3816), 1,
      anon_sym_and,
    ACTIONS(3818), 1,
      anon_sym_or,
    ACTIONS(3822), 1,
      anon_sym_as,
    ACTIONS(3824), 1,
      anon_sym_if,
    ACTIONS(4037), 1,
      anon_sym_COMMA,
    STATE(2447), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4173), 2,
      sym__newline,
      anon_sym_SEMI,
  [112426] = 9,
    ACTIONS(4000), 1,
      anon_sym_as,
    ACTIONS(4002), 1,
      anon_sym_if,
    ACTIONS(4004), 1,
      anon_sym_and,
    ACTIONS(4006), 1,
      anon_sym_or,
    ACTIONS(4051), 1,
      anon_sym_COLON,
    ACTIONS(4175), 1,
      anon_sym_COMMA,
    ACTIONS(4177), 1,
      anon_sym_RBRACK,
    STATE(2960), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112455] = 8,
    ACTIONS(3816), 1,
      anon_sym_and,
    ACTIONS(3818), 1,
      anon_sym_or,
    ACTIONS(3822), 1,
      anon_sym_as,
    ACTIONS(3824), 1,
      anon_sym_if,
    ACTIONS(4181), 1,
      anon_sym_COMMA,
    STATE(2645), 1,
      aux_sym_print_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4179), 2,
      sym__newline,
      anon_sym_SEMI,
  [112482] = 5,
    ACTIONS(4183), 1,
      anon_sym_DOT,
    ACTIONS(4185), 1,
      anon_sym_EQ,
    STATE(2254), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3992), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [112503] = 5,
    ACTIONS(3795), 1,
      anon_sym_as,
    ACTIONS(3807), 1,
      anon_sym_and,
    ACTIONS(3809), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4099), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [112524] = 6,
    ACTIONS(3838), 1,
      anon_sym_as,
    ACTIONS(3840), 1,
      anon_sym_if,
    ACTIONS(3846), 1,
      anon_sym_and,
    ACTIONS(3848), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3830), 4,
      anon_sym_COMMA,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [112547] = 8,
    ACTIONS(3816), 1,
      anon_sym_and,
    ACTIONS(3818), 1,
      anon_sym_or,
    ACTIONS(3822), 1,
      anon_sym_as,
    ACTIONS(3824), 1,
      anon_sym_if,
    ACTIONS(3870), 1,
      anon_sym_COMMA,
    STATE(2585), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3866), 2,
      sym__newline,
      anon_sym_SEMI,
  [112574] = 6,
    ACTIONS(3838), 1,
      anon_sym_as,
    ACTIONS(3840), 1,
      anon_sym_if,
    ACTIONS(3846), 1,
      anon_sym_and,
    ACTIONS(3848), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3820), 4,
      anon_sym_COMMA,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [112597] = 5,
    ACTIONS(4187), 1,
      anon_sym_DOT,
    ACTIONS(4189), 1,
      anon_sym_EQ,
    STATE(2265), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3992), 5,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [112618] = 3,
    ACTIONS(4031), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3826), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_and,
      anon_sym_or,
  [112635] = 4,
    ACTIONS(3862), 1,
      anon_sym_and,
    ACTIONS(4031), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3826), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_or,
  [112654] = 5,
    ACTIONS(3838), 1,
      anon_sym_as,
    ACTIONS(3846), 1,
      anon_sym_and,
    ACTIONS(3848), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4099), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [112675] = 4,
    ACTIONS(894), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1265), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(4067), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [112693] = 8,
    ACTIONS(3801), 1,
      anon_sym_async,
    ACTIONS(3803), 1,
      anon_sym_for,
    ACTIONS(4191), 1,
      anon_sym_COMMA,
    ACTIONS(4193), 1,
      anon_sym_RBRACE,
    STATE(2259), 1,
      sym_for_in_clause,
    STATE(2703), 1,
      aux_sym_dictionary_repeat1,
    STATE(3402), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112719] = 8,
    ACTIONS(3941), 1,
      anon_sym_as,
    ACTIONS(3943), 1,
      anon_sym_if,
    ACTIONS(3945), 1,
      anon_sym_and,
    ACTIONS(3947), 1,
      anon_sym_or,
    ACTIONS(3975), 1,
      anon_sym_RPAREN,
    ACTIONS(4195), 1,
      anon_sym_COMMA,
    STATE(2804), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112745] = 6,
    ACTIONS(4197), 1,
      anon_sym_RPAREN,
    ACTIONS(4199), 1,
      anon_sym_if,
    ACTIONS(4202), 1,
      anon_sym_async,
    ACTIONS(4205), 1,
      anon_sym_for,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2242), 3,
      sym_for_in_clause,
      sym_if_clause,
      aux_sym__comprehension_clauses_repeat1,
  [112767] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4208), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(4067), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [112783] = 7,
    ACTIONS(4000), 1,
      anon_sym_as,
    ACTIONS(4002), 1,
      anon_sym_if,
    ACTIONS(4004), 1,
      anon_sym_and,
    ACTIONS(4006), 1,
      anon_sym_or,
    ACTIONS(4210), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2378), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [112807] = 4,
    ACTIONS(4183), 1,
      anon_sym_DOT,
    STATE(2254), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3992), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [112825] = 8,
    ACTIONS(3801), 1,
      anon_sym_async,
    ACTIONS(3803), 1,
      anon_sym_for,
    ACTIONS(4212), 1,
      anon_sym_COMMA,
    ACTIONS(4214), 1,
      anon_sym_RBRACE,
    STATE(2259), 1,
      sym_for_in_clause,
    STATE(2877), 1,
      aux_sym_dictionary_repeat1,
    STATE(3208), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112851] = 7,
    ACTIONS(4000), 1,
      anon_sym_as,
    ACTIONS(4002), 1,
      anon_sym_if,
    ACTIONS(4004), 1,
      anon_sym_and,
    ACTIONS(4006), 1,
      anon_sym_or,
    ACTIONS(4051), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4216), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [112875] = 8,
    ACTIONS(3975), 1,
      anon_sym_RBRACK,
    ACTIONS(4000), 1,
      anon_sym_as,
    ACTIONS(4002), 1,
      anon_sym_if,
    ACTIONS(4004), 1,
      anon_sym_and,
    ACTIONS(4006), 1,
      anon_sym_or,
    ACTIONS(4218), 1,
      anon_sym_COMMA,
    STATE(2777), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112901] = 8,
    ACTIONS(3801), 1,
      anon_sym_async,
    ACTIONS(3803), 1,
      anon_sym_for,
    ACTIONS(4220), 1,
      anon_sym_COMMA,
    ACTIONS(4222), 1,
      anon_sym_RBRACE,
    STATE(2259), 1,
      sym_for_in_clause,
    STATE(2805), 1,
      aux_sym_dictionary_repeat1,
    STATE(3262), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112927] = 8,
    ACTIONS(3952), 1,
      anon_sym_as,
    ACTIONS(3954), 1,
      anon_sym_if,
    ACTIONS(3956), 1,
      anon_sym_and,
    ACTIONS(3958), 1,
      anon_sym_or,
    ACTIONS(4224), 1,
      anon_sym_COMMA,
    ACTIONS(4226), 1,
      anon_sym_COLON,
    STATE(2769), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [112953] = 5,
    ACTIONS(3795), 1,
      anon_sym_as,
    ACTIONS(3807), 1,
      anon_sym_and,
    ACTIONS(3809), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4228), 4,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [112973] = 6,
    ACTIONS(3816), 1,
      anon_sym_and,
    ACTIONS(3818), 1,
      anon_sym_or,
    ACTIONS(3822), 1,
      anon_sym_as,
    ACTIONS(3824), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4230), 3,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [112995] = 4,
    ACTIONS(799), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1222), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(4067), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [113013] = 4,
    ACTIONS(4183), 1,
      anon_sym_DOT,
    STATE(2286), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4016), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [113031] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4232), 7,
      sym__dedent,
      sym_string_start,
      anon_sym_config,
      anon_sym_meta_wrapper,
      anon_sym_prefix,
      anon_sym_skip_validation,
      anon_sym_snakefile,
  [113045] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4236), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(4234), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [113061] = 4,
    ACTIONS(916), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1307), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(4067), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [113079] = 8,
    ACTIONS(3801), 1,
      anon_sym_async,
    ACTIONS(3803), 1,
      anon_sym_for,
    ACTIONS(4238), 1,
      anon_sym_COMMA,
    ACTIONS(4240), 1,
      anon_sym_RBRACE,
    STATE(2259), 1,
      sym_for_in_clause,
    STATE(2820), 1,
      aux_sym_dictionary_repeat1,
    STATE(3231), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113105] = 6,
    ACTIONS(3801), 1,
      anon_sym_async,
    ACTIONS(3803), 1,
      anon_sym_for,
    ACTIONS(4242), 1,
      anon_sym_if,
    ACTIONS(4244), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2280), 3,
      sym_for_in_clause,
      sym_if_clause,
      aux_sym__comprehension_clauses_repeat1,
  [113127] = 8,
    ACTIONS(3801), 1,
      anon_sym_async,
    ACTIONS(3803), 1,
      anon_sym_for,
    ACTIONS(4246), 1,
      anon_sym_COMMA,
    ACTIONS(4248), 1,
      anon_sym_RBRACE,
    STATE(2259), 1,
      sym_for_in_clause,
    STATE(2944), 1,
      aux_sym_dictionary_repeat1,
    STATE(3232), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113153] = 8,
    ACTIONS(3952), 1,
      anon_sym_as,
    ACTIONS(3954), 1,
      anon_sym_if,
    ACTIONS(3956), 1,
      anon_sym_and,
    ACTIONS(3958), 1,
      anon_sym_or,
    ACTIONS(4224), 1,
      anon_sym_COMMA,
    ACTIONS(4250), 1,
      anon_sym_COLON,
    STATE(2769), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113179] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4252), 7,
      sym__dedent,
      sym_string_start,
      anon_sym_config,
      anon_sym_meta_wrapper,
      anon_sym_prefix,
      anon_sym_skip_validation,
      anon_sym_snakefile,
  [113193] = 4,
    ACTIONS(4254), 1,
      anon_sym_DOT,
    STATE(2263), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3987), 5,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [113211] = 8,
    ACTIONS(3952), 1,
      anon_sym_as,
    ACTIONS(3954), 1,
      anon_sym_if,
    ACTIONS(3956), 1,
      anon_sym_and,
    ACTIONS(3958), 1,
      anon_sym_or,
    ACTIONS(4224), 1,
      anon_sym_COMMA,
    ACTIONS(4257), 1,
      anon_sym_COLON,
    STATE(2769), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113237] = 4,
    ACTIONS(4187), 1,
      anon_sym_DOT,
    STATE(2291), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4016), 5,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [113255] = 7,
    ACTIONS(2298), 1,
      anon_sym_COLON,
    ACTIONS(4000), 1,
      anon_sym_as,
    ACTIONS(4002), 1,
      anon_sym_if,
    ACTIONS(4004), 1,
      anon_sym_and,
    ACTIONS(4006), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2296), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [113279] = 8,
    ACTIONS(3801), 1,
      anon_sym_async,
    ACTIONS(3803), 1,
      anon_sym_for,
    ACTIONS(4259), 1,
      anon_sym_COMMA,
    ACTIONS(4261), 1,
      anon_sym_RBRACE,
    STATE(2259), 1,
      sym_for_in_clause,
    STATE(2750), 1,
      aux_sym_dictionary_repeat1,
    STATE(3319), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113305] = 6,
    ACTIONS(3842), 1,
      anon_sym_async,
    ACTIONS(3844), 1,
      anon_sym_for,
    ACTIONS(4244), 1,
      anon_sym_RBRACK,
    ACTIONS(4263), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2285), 3,
      sym_for_in_clause,
      sym_if_clause,
      aux_sym__comprehension_clauses_repeat1,
  [113327] = 4,
    ACTIONS(4160), 1,
      anon_sym_DOT,
    STATE(2263), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4016), 5,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [113345] = 6,
    ACTIONS(4197), 1,
      anon_sym_RBRACE,
    ACTIONS(4265), 1,
      anon_sym_if,
    ACTIONS(4268), 1,
      anon_sym_async,
    ACTIONS(4271), 1,
      anon_sym_for,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2270), 3,
      sym_for_in_clause,
      sym_if_clause,
      aux_sym__comprehension_clauses_repeat1,
  [113367] = 8,
    ACTIONS(3801), 1,
      anon_sym_async,
    ACTIONS(3803), 1,
      anon_sym_for,
    ACTIONS(4274), 1,
      anon_sym_COMMA,
    ACTIONS(4276), 1,
      anon_sym_RBRACE,
    STATE(2259), 1,
      sym_for_in_clause,
    STATE(2935), 1,
      aux_sym_dictionary_repeat1,
    STATE(3191), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113393] = 8,
    ACTIONS(3952), 1,
      anon_sym_as,
    ACTIONS(3954), 1,
      anon_sym_if,
    ACTIONS(3956), 1,
      anon_sym_and,
    ACTIONS(3958), 1,
      anon_sym_or,
    ACTIONS(4278), 1,
      anon_sym_COMMA,
    ACTIONS(4280), 1,
      anon_sym_COLON,
    STATE(2729), 1,
      aux_sym_match_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113419] = 7,
    ACTIONS(3452), 1,
      sym_identifier,
    ACTIONS(4282), 1,
      anon_sym_DOT,
    ACTIONS(4284), 1,
      anon_sym___future__,
    STATE(2628), 1,
      aux_sym_import_prefix_repeat1,
    STATE(2680), 1,
      sym_import_prefix,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(3417), 2,
      sym_relative_import,
      sym_dotted_name,
  [113443] = 8,
    ACTIONS(3801), 1,
      anon_sym_async,
    ACTIONS(3803), 1,
      anon_sym_for,
    ACTIONS(4286), 1,
      anon_sym_COMMA,
    ACTIONS(4288), 1,
      anon_sym_RBRACE,
    STATE(2259), 1,
      sym_for_in_clause,
    STATE(2974), 1,
      aux_sym_dictionary_repeat1,
    STATE(3285), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113469] = 8,
    ACTIONS(3952), 1,
      anon_sym_as,
    ACTIONS(3954), 1,
      anon_sym_if,
    ACTIONS(3956), 1,
      anon_sym_and,
    ACTIONS(3958), 1,
      anon_sym_or,
    ACTIONS(4224), 1,
      anon_sym_COMMA,
    ACTIONS(4290), 1,
      anon_sym_COLON,
    STATE(2769), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113495] = 6,
    ACTIONS(3858), 1,
      anon_sym_async,
    ACTIONS(3860), 1,
      anon_sym_for,
    ACTIONS(4292), 1,
      anon_sym_RPAREN,
    ACTIONS(4294), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2242), 3,
      sym_for_in_clause,
      sym_if_clause,
      aux_sym__comprehension_clauses_repeat1,
  [113517] = 8,
    ACTIONS(4296), 1,
      sym_identifier,
    ACTIONS(4298), 1,
      anon_sym_LPAREN,
    ACTIONS(4300), 1,
      anon_sym_STAR,
    STATE(2432), 1,
      sym_dotted_name,
    STATE(2560), 1,
      sym_aliased_import,
    STATE(3109), 1,
      sym__import_list,
    STATE(3112), 1,
      sym_wildcard_import,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113543] = 6,
    ACTIONS(3816), 1,
      anon_sym_and,
    ACTIONS(3818), 1,
      anon_sym_or,
    ACTIONS(3822), 1,
      anon_sym_as,
    ACTIONS(3824), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4302), 3,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [113565] = 6,
    ACTIONS(4197), 1,
      anon_sym_RBRACK,
    ACTIONS(4304), 1,
      anon_sym_if,
    ACTIONS(4307), 1,
      anon_sym_async,
    ACTIONS(4310), 1,
      anon_sym_for,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2279), 3,
      sym_for_in_clause,
      sym_if_clause,
      aux_sym__comprehension_clauses_repeat1,
  [113587] = 6,
    ACTIONS(3801), 1,
      anon_sym_async,
    ACTIONS(3803), 1,
      anon_sym_for,
    ACTIONS(4242), 1,
      anon_sym_if,
    ACTIONS(4292), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2270), 3,
      sym_for_in_clause,
      sym_if_clause,
      aux_sym__comprehension_clauses_repeat1,
  [113609] = 8,
    ACTIONS(3801), 1,
      anon_sym_async,
    ACTIONS(3803), 1,
      anon_sym_for,
    ACTIONS(4313), 1,
      anon_sym_COMMA,
    ACTIONS(4315), 1,
      anon_sym_RBRACE,
    STATE(2259), 1,
      sym_for_in_clause,
    STATE(3024), 1,
      aux_sym_dictionary_repeat1,
    STATE(3395), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113635] = 6,
    ACTIONS(3858), 1,
      anon_sym_async,
    ACTIONS(3860), 1,
      anon_sym_for,
    ACTIONS(4244), 1,
      anon_sym_RPAREN,
    ACTIONS(4294), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2276), 3,
      sym_for_in_clause,
      sym_if_clause,
      aux_sym__comprehension_clauses_repeat1,
  [113657] = 4,
    ACTIONS(4160), 1,
      anon_sym_DOT,
    STATE(2269), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3992), 5,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [113675] = 8,
    ACTIONS(3952), 1,
      anon_sym_as,
    ACTIONS(3954), 1,
      anon_sym_if,
    ACTIONS(3956), 1,
      anon_sym_and,
    ACTIONS(3958), 1,
      anon_sym_or,
    ACTIONS(4317), 1,
      anon_sym_COMMA,
    ACTIONS(4319), 1,
      anon_sym_COLON,
    STATE(2715), 1,
      aux_sym_match_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113701] = 6,
    ACTIONS(3842), 1,
      anon_sym_async,
    ACTIONS(3844), 1,
      anon_sym_for,
    ACTIONS(4263), 1,
      anon_sym_if,
    ACTIONS(4292), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2279), 3,
      sym_for_in_clause,
      sym_if_clause,
      aux_sym__comprehension_clauses_repeat1,
  [113723] = 4,
    ACTIONS(4321), 1,
      anon_sym_DOT,
    STATE(2286), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3987), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [113741] = 4,
    ACTIONS(4187), 1,
      anon_sym_DOT,
    STATE(2265), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3992), 5,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [113759] = 5,
    ACTIONS(3838), 1,
      anon_sym_as,
    ACTIONS(3846), 1,
      anon_sym_and,
    ACTIONS(3848), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4228), 4,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [113779] = 8,
    ACTIONS(3933), 1,
      anon_sym_RPAREN,
    ACTIONS(3935), 1,
      anon_sym_COMMA,
    ACTIONS(3941), 1,
      anon_sym_as,
    ACTIONS(3943), 1,
      anon_sym_if,
    ACTIONS(3945), 1,
      anon_sym_and,
    ACTIONS(3947), 1,
      anon_sym_or,
    STATE(2842), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [113805] = 5,
    ACTIONS(3854), 1,
      anon_sym_as,
    ACTIONS(3862), 1,
      anon_sym_and,
    ACTIONS(3864), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4228), 4,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [113825] = 4,
    ACTIONS(4324), 1,
      anon_sym_DOT,
    STATE(2291), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3987), 5,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [113843] = 6,
    ACTIONS(3816), 1,
      anon_sym_and,
    ACTIONS(3818), 1,
      anon_sym_or,
    ACTIONS(3822), 1,
      anon_sym_as,
    ACTIONS(3824), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4327), 2,
      sym__newline,
      anon_sym_SEMI,
  [113864] = 6,
    ACTIONS(3941), 1,
      anon_sym_as,
    ACTIONS(3943), 1,
      anon_sym_if,
    ACTIONS(3945), 1,
      anon_sym_and,
    ACTIONS(3947), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4329), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [113885] = 6,
    ACTIONS(3816), 1,
      anon_sym_and,
    ACTIONS(3818), 1,
      anon_sym_or,
    ACTIONS(3822), 1,
      anon_sym_as,
    ACTIONS(3824), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3996), 2,
      sym__newline,
      anon_sym_SEMI,
  [113906] = 5,
    ACTIONS(4333), 1,
      anon_sym_DOT,
    ACTIONS(4335), 1,
      anon_sym_COLON,
    ACTIONS(4337), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4331), 3,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_EQ,
  [113925] = 6,
    ACTIONS(3941), 1,
      anon_sym_as,
    ACTIONS(3943), 1,
      anon_sym_if,
    ACTIONS(3945), 1,
      anon_sym_and,
    ACTIONS(3947), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4018), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [113946] = 6,
    ACTIONS(3962), 1,
      anon_sym_as,
    ACTIONS(3964), 1,
      anon_sym_if,
    ACTIONS(3968), 1,
      anon_sym_and,
    ACTIONS(3970), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4329), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [113967] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4339), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(4067), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [113982] = 6,
    ACTIONS(3952), 1,
      anon_sym_as,
    ACTIONS(3954), 1,
      anon_sym_if,
    ACTIONS(3956), 1,
      anon_sym_and,
    ACTIONS(3958), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4341), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [114003] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4343), 6,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [114016] = 6,
    ACTIONS(3962), 1,
      anon_sym_as,
    ACTIONS(3964), 1,
      anon_sym_if,
    ACTIONS(3968), 1,
      anon_sym_and,
    ACTIONS(3970), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4171), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [114037] = 6,
    ACTIONS(4345), 1,
      anon_sym_DOT,
    ACTIONS(4349), 1,
      anon_sym_COLON,
    ACTIONS(4351), 1,
      anon_sym_EQ,
    ACTIONS(4353), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4347), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [114058] = 6,
    ACTIONS(4000), 1,
      anon_sym_as,
    ACTIONS(4002), 1,
      anon_sym_if,
    ACTIONS(4004), 1,
      anon_sym_and,
    ACTIONS(4006), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3996), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [114079] = 6,
    ACTIONS(3941), 1,
      anon_sym_as,
    ACTIONS(3943), 1,
      anon_sym_if,
    ACTIONS(3945), 1,
      anon_sym_and,
    ACTIONS(3947), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4355), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [114100] = 6,
    ACTIONS(4359), 1,
      anon_sym_as,
    ACTIONS(4361), 1,
      anon_sym_if,
    ACTIONS(4363), 1,
      anon_sym_and,
    ACTIONS(4365), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4357), 2,
      sym__dedent,
      anon_sym_COMMA,
  [114121] = 6,
    ACTIONS(3952), 1,
      anon_sym_as,
    ACTIONS(3954), 1,
      anon_sym_if,
    ACTIONS(3956), 1,
      anon_sym_and,
    ACTIONS(3958), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4018), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [114142] = 6,
    ACTIONS(3952), 1,
      anon_sym_as,
    ACTIONS(3954), 1,
      anon_sym_if,
    ACTIONS(3956), 1,
      anon_sym_and,
    ACTIONS(3958), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4355), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [114163] = 7,
    ACTIONS(4367), 1,
      anon_sym_DOT,
    ACTIONS(4369), 1,
      anon_sym_COMMA,
    ACTIONS(4371), 1,
      anon_sym_COLON,
    ACTIONS(4373), 1,
      anon_sym_RBRACK,
    ACTIONS(4375), 1,
      anon_sym_PIPE,
    STATE(2681), 1,
      aux_sym_type_parameter_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114186] = 4,
    ACTIONS(4379), 1,
      anon_sym_COMMA,
    STATE(2368), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4377), 4,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [114203] = 4,
    ACTIONS(4383), 1,
      anon_sym_COMMA,
    STATE(2370), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4381), 4,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [114220] = 6,
    ACTIONS(3816), 1,
      anon_sym_and,
    ACTIONS(3818), 1,
      anon_sym_or,
    ACTIONS(3822), 1,
      anon_sym_as,
    ACTIONS(3824), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4385), 2,
      sym__newline,
      anon_sym_COMMA,
  [114241] = 6,
    ACTIONS(4359), 1,
      anon_sym_as,
    ACTIONS(4361), 1,
      anon_sym_if,
    ACTIONS(4363), 1,
      anon_sym_and,
    ACTIONS(4365), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4387), 2,
      sym__dedent,
      anon_sym_COMMA,
  [114262] = 6,
    ACTIONS(4359), 1,
      anon_sym_as,
    ACTIONS(4361), 1,
      anon_sym_if,
    ACTIONS(4363), 1,
      anon_sym_and,
    ACTIONS(4365), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4389), 2,
      sym__dedent,
      anon_sym_COMMA,
  [114283] = 6,
    ACTIONS(4000), 1,
      anon_sym_as,
    ACTIONS(4002), 1,
      anon_sym_if,
    ACTIONS(4004), 1,
      anon_sym_and,
    ACTIONS(4006), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2372), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [114304] = 6,
    ACTIONS(3941), 1,
      anon_sym_as,
    ACTIONS(3943), 1,
      anon_sym_if,
    ACTIONS(3945), 1,
      anon_sym_and,
    ACTIONS(3947), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4391), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [114325] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3987), 6,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [114338] = 4,
    ACTIONS(4393), 1,
      anon_sym_COMMA,
    STATE(2330), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4395), 4,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [114355] = 7,
    ACTIONS(3954), 1,
      anon_sym_if,
    ACTIONS(3956), 1,
      anon_sym_and,
    ACTIONS(3958), 1,
      anon_sym_or,
    ACTIONS(4397), 1,
      anon_sym_COMMA,
    ACTIONS(4399), 1,
      anon_sym_as,
    ACTIONS(4401), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114378] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4403), 6,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [114391] = 7,
    ACTIONS(4367), 1,
      anon_sym_DOT,
    ACTIONS(4371), 1,
      anon_sym_COLON,
    ACTIONS(4375), 1,
      anon_sym_PIPE,
    ACTIONS(4405), 1,
      anon_sym_COMMA,
    ACTIONS(4407), 1,
      anon_sym_RBRACK,
    STATE(2936), 1,
      aux_sym_type_parameter_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [114414] = 6,
    ACTIONS(3816), 1,
      anon_sym_and,
    ACTIONS(3818), 1,
      anon_sym_or,
    ACTIONS(3822), 1,
      anon_sym_as,
    ACTIONS(3824), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4387), 2,
      sym__newline,
      anon_sym_COMMA,
  [114435] = 6,
    ACTIONS(3816), 1,
      anon_sym_and,
    ACTIONS(3818), 1,
      anon_sym_or,
    ACTIONS(3822), 1,
      anon_sym_as,
    ACTIONS(3824), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4389), 2,
      sym__newline,
      anon_sym_COMMA,
  [114456] = 6,
    ACTIONS(3962), 1,
      anon_sym_as,
    ACTIONS(3964), 1,
      anon_sym_if,
    ACTIONS(3968), 1,
      anon_sym_and,
    ACTIONS(3970), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4357), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [114477] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4409), 6,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [114490] = 4,
    ACTIONS(4411), 1,
      anon_sym_COMMA,
    STATE(2342), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4381), 4,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [114507] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4413), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(4234), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [114522] = 6,
    ACTIONS(3941), 1,
      anon_sym_as,
    ACTIONS(3943), 1,
      anon_sym_if,
    ACTIONS(3945), 1,
      anon_sym_and,
    ACTIONS(3947), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4341), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [114543] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4415), 6,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [114556] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3868), 6,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [114569] = 4,
    ACTIONS(4417), 1,
      anon_sym_COMMA,
    STATE(2349), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4377), 4,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [114586] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3987), 6,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [114599] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4419), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(4067), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [114614] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4403), 6,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [114627] = 6,
    ACTIONS(4000), 1,
      anon_sym_as,
    ACTIONS(4002), 1,
      anon_sym_if,
    ACTIONS(4004), 1,
      anon_sym_and,
    ACTIONS(4006), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4329), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [114648] = 6,
    ACTIONS(3941), 1,
      anon_sym_as,
    ACTIONS(3943), 1,
      anon_sym_if,
    ACTIONS(3945), 1,
      anon_sym_and,
    ACTIONS(3947), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4421), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [114669] = 6,
    ACTIONS(4000), 1,
      anon_sym_as,
    ACTIONS(4002), 1,
      anon_sym_if,
    ACTIONS(4004), 1,
      anon_sym_and,
    ACTIONS(4006), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2378), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [114690] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4343), 6,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [114703] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4423), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(4234), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [114718] = 5,
    ACTIONS(4345), 1,
      anon_sym_DOT,
    ACTIONS(4349), 1,
      anon_sym_COLON,
    ACTIONS(4353), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4331), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
  [114737] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4425), 6,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [114750] = 4,
    ACTIONS(4429), 1,
      anon_sym_PIPE,
    STATE(2341), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4427), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
  [114767] = 4,
    ACTIONS(4432), 1,
      anon_sym_COMMA,
    STATE(2349), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4434), 4,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [114784] = 3,
    STATE(2395), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4427), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [114799] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3987), 6,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [114812] = 6,
    ACTIONS(4333), 1,
      anon_sym_DOT,
    ACTIONS(4335), 1,
      anon_sym_COLON,
    ACTIONS(4337), 1,
      anon_sym_PIPE,
    ACTIONS(4438), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4436), 2,
      sym__newline,
      anon_sym_SEMI,
  [114833] = 4,
    ACTIONS(4440), 1,
      anon_sym_COMMA,
    STATE(2352), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1740), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [114850] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4425), 6,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [114863] = 4,
    ACTIONS(4442), 1,
      anon_sym_COMMA,
    STATE(2309), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4395), 4,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [114880] = 4,
    ACTIONS(4444), 1,
      anon_sym_COMMA,
    STATE(2349), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4447), 4,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [114897] = 6,
    ACTIONS(3952), 1,
      anon_sym_as,
    ACTIONS(3954), 1,
      anon_sym_if,
    ACTIONS(3956), 1,
      anon_sym_and,
    ACTIONS(3958), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4449), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [114918] = 6,
    ACTIONS(4000), 1,
      anon_sym_as,
    ACTIONS(4002), 1,
      anon_sym_if,
    ACTIONS(4004), 1,
      anon_sym_and,
    ACTIONS(4006), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4018), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [114939] = 4,
    ACTIONS(4451), 1,
      anon_sym_COMMA,
    STATE(2352), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3612), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [114956] = 6,
    ACTIONS(3941), 1,
      anon_sym_as,
    ACTIONS(3943), 1,
      anon_sym_if,
    ACTIONS(3945), 1,
      anon_sym_and,
    ACTIONS(3947), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4357), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [114977] = 4,
    ACTIONS(4454), 1,
      anon_sym_DOT,
    STATE(2405), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4016), 4,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
  [114994] = 6,
    ACTIONS(4359), 1,
      anon_sym_as,
    ACTIONS(4361), 1,
      anon_sym_if,
    ACTIONS(4363), 1,
      anon_sym_and,
    ACTIONS(4365), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4391), 2,
      sym__dedent,
      anon_sym_COMMA,
  [115015] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4403), 6,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [115028] = 6,
    ACTIONS(3962), 1,
      anon_sym_as,
    ACTIONS(3964), 1,
      anon_sym_if,
    ACTIONS(3968), 1,
      anon_sym_and,
    ACTIONS(3970), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4391), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [115049] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4456), 6,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [115062] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2500), 6,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [115075] = 6,
    ACTIONS(3941), 1,
      anon_sym_as,
    ACTIONS(3943), 1,
      anon_sym_if,
    ACTIONS(3945), 1,
      anon_sym_and,
    ACTIONS(3947), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4387), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [115096] = 6,
    ACTIONS(3941), 1,
      anon_sym_as,
    ACTIONS(3943), 1,
      anon_sym_if,
    ACTIONS(3945), 1,
      anon_sym_and,
    ACTIONS(3947), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4389), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [115117] = 4,
    ACTIONS(4460), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2362), 2,
      sym_decorator,
      aux_sym_decorated_definition_repeat1,
    ACTIONS(4458), 3,
      anon_sym_async,
      anon_sym_def,
      anon_sym_class,
  [115134] = 4,
    ACTIONS(4454), 1,
      anon_sym_DOT,
    STATE(2354), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3992), 4,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
  [115151] = 4,
    ACTIONS(4465), 1,
      anon_sym_PIPE,
    STATE(2395), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4463), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
  [115168] = 4,
    ACTIONS(4467), 1,
      anon_sym_COMMA,
    STATE(2380), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4395), 4,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [115185] = 4,
    ACTIONS(4469), 1,
      anon_sym_COMMA,
    STATE(2366), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4018), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [115202] = 6,
    ACTIONS(3816), 1,
      anon_sym_and,
    ACTIONS(3818), 1,
      anon_sym_or,
    ACTIONS(3822), 1,
      anon_sym_as,
    ACTIONS(3824), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4357), 2,
      sym__newline,
      anon_sym_COMMA,
  [115223] = 4,
    ACTIONS(4472), 1,
      anon_sym_COMMA,
    STATE(2368), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4447), 4,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [115240] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4475), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(4067), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [115255] = 4,
    ACTIONS(4477), 1,
      anon_sym_COMMA,
    STATE(2368), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4434), 4,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [115272] = 6,
    ACTIONS(4000), 1,
      anon_sym_as,
    ACTIONS(4002), 1,
      anon_sym_if,
    ACTIONS(4004), 1,
      anon_sym_and,
    ACTIONS(4006), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4479), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [115293] = 3,
    ACTIONS(4481), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4067), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [115308] = 7,
    ACTIONS(3954), 1,
      anon_sym_if,
    ACTIONS(3956), 1,
      anon_sym_and,
    ACTIONS(3958), 1,
      anon_sym_or,
    ACTIONS(4399), 1,
      anon_sym_as,
    ACTIONS(4483), 1,
      anon_sym_COMMA,
    ACTIONS(4485), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115331] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4415), 6,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [115344] = 7,
    ACTIONS(4487), 1,
      anon_sym_COMMA,
    ACTIONS(4489), 1,
      anon_sym_as,
    ACTIONS(4491), 1,
      anon_sym_if,
    ACTIONS(4493), 1,
      anon_sym_COLON,
    STATE(2445), 1,
      aux_sym_case_clause_repeat1,
    STATE(3365), 1,
      sym_if_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115367] = 6,
    ACTIONS(4359), 1,
      anon_sym_as,
    ACTIONS(4361), 1,
      anon_sym_if,
    ACTIONS(4363), 1,
      anon_sym_and,
    ACTIONS(4365), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4385), 2,
      sym__dedent,
      anon_sym_COMMA,
  [115388] = 6,
    ACTIONS(3941), 1,
      anon_sym_as,
    ACTIONS(3943), 1,
      anon_sym_if,
    ACTIONS(3945), 1,
      anon_sym_and,
    ACTIONS(3947), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4495), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [115409] = 4,
    ACTIONS(4497), 1,
      anon_sym_COMMA,
    STATE(2396), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4381), 4,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [115426] = 7,
    ACTIONS(4367), 1,
      anon_sym_DOT,
    ACTIONS(4371), 1,
      anon_sym_COLON,
    ACTIONS(4375), 1,
      anon_sym_PIPE,
    ACTIONS(4499), 1,
      anon_sym_COMMA,
    ACTIONS(4501), 1,
      anon_sym_RBRACK,
    STATE(2968), 1,
      aux_sym_type_parameter_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115449] = 4,
    ACTIONS(4503), 1,
      anon_sym_COMMA,
    STATE(2406), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4377), 4,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [115466] = 6,
    ACTIONS(4359), 1,
      anon_sym_as,
    ACTIONS(4361), 1,
      anon_sym_if,
    ACTIONS(4363), 1,
      anon_sym_and,
    ACTIONS(4365), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3820), 2,
      sym__dedent,
      anon_sym_COMMA,
  [115487] = 4,
    ACTIONS(4465), 1,
      anon_sym_PIPE,
    STATE(2395), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4505), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
  [115504] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2785), 6,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
  [115517] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4507), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(4234), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [115532] = 6,
    ACTIONS(4359), 1,
      anon_sym_as,
    ACTIONS(4361), 1,
      anon_sym_if,
    ACTIONS(4363), 1,
      anon_sym_and,
    ACTIONS(4365), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3830), 2,
      sym__dedent,
      anon_sym_COMMA,
  [115553] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3868), 6,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [115566] = 6,
    ACTIONS(3816), 1,
      anon_sym_and,
    ACTIONS(3818), 1,
      anon_sym_or,
    ACTIONS(3822), 1,
      anon_sym_as,
    ACTIONS(3824), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4391), 2,
      sym__newline,
      anon_sym_COMMA,
  [115587] = 6,
    ACTIONS(3816), 1,
      anon_sym_and,
    ACTIONS(3818), 1,
      anon_sym_or,
    ACTIONS(3822), 1,
      anon_sym_as,
    ACTIONS(3824), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4509), 2,
      sym__newline,
      anon_sym_SEMI,
  [115608] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4409), 6,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [115621] = 6,
    ACTIONS(4000), 1,
      anon_sym_as,
    ACTIONS(4002), 1,
      anon_sym_if,
    ACTIONS(4004), 1,
      anon_sym_and,
    ACTIONS(4006), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4357), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [115642] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4409), 6,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [115655] = 7,
    ACTIONS(4367), 1,
      anon_sym_DOT,
    ACTIONS(4371), 1,
      anon_sym_COLON,
    ACTIONS(4375), 1,
      anon_sym_PIPE,
    ACTIONS(4511), 1,
      anon_sym_COMMA,
    ACTIONS(4513), 1,
      anon_sym_RBRACK,
    STATE(2851), 1,
      aux_sym_type_parameter_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [115678] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4456), 6,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [115691] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2500), 6,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [115704] = 4,
    ACTIONS(4465), 1,
      anon_sym_PIPE,
    STATE(2341), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4515), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
  [115721] = 4,
    ACTIONS(4517), 1,
      anon_sym_COMMA,
    STATE(2406), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4434), 4,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [115738] = 3,
    ACTIONS(4363), 1,
      anon_sym_and,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3826), 5,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_or,
  [115753] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3826), 6,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
  [115766] = 4,
    ACTIONS(4363), 1,
      anon_sym_and,
    ACTIONS(4365), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3828), 4,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
  [115783] = 5,
    ACTIONS(4363), 1,
      anon_sym_and,
    ACTIONS(4365), 1,
      anon_sym_or,
    ACTIONS(4519), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3811), 3,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_if,
  [115802] = 6,
    ACTIONS(4359), 1,
      anon_sym_as,
    ACTIONS(4361), 1,
      anon_sym_if,
    ACTIONS(4363), 1,
      anon_sym_and,
    ACTIONS(4365), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3834), 2,
      sym__dedent,
      anon_sym_COMMA,
  [115823] = 4,
    ACTIONS(3956), 1,
      anon_sym_and,
    ACTIONS(3958), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3828), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
  [115840] = 4,
    ACTIONS(4522), 1,
      anon_sym_COMMA,
    STATE(2366), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2208), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [115857] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3832), 6,
      sym__dedent,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
  [115870] = 4,
    ACTIONS(4524), 1,
      anon_sym_DOT,
    STATE(2405), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3987), 4,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
  [115887] = 4,
    ACTIONS(4527), 1,
      anon_sym_COMMA,
    STATE(2406), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4447), 4,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [115904] = 6,
    ACTIONS(3952), 1,
      anon_sym_as,
    ACTIONS(3954), 1,
      anon_sym_if,
    ACTIONS(3956), 1,
      anon_sym_and,
    ACTIONS(3958), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4495), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [115925] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4415), 6,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [115938] = 6,
    ACTIONS(3941), 1,
      anon_sym_as,
    ACTIONS(3943), 1,
      anon_sym_if,
    ACTIONS(3945), 1,
      anon_sym_and,
    ACTIONS(3947), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3996), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [115959] = 3,
    ACTIONS(4530), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4067), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [115973] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4532), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [115985] = 5,
    ACTIONS(4296), 1,
      sym_identifier,
    STATE(2541), 1,
      sym_dotted_name,
    STATE(2787), 1,
      sym_aliased_import,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4534), 2,
      sym__newline,
      anon_sym_SEMI,
  [116003] = 6,
    ACTIONS(3952), 1,
      anon_sym_as,
    ACTIONS(3954), 1,
      anon_sym_if,
    ACTIONS(3956), 1,
      anon_sym_and,
    ACTIONS(3958), 1,
      anon_sym_or,
    ACTIONS(4536), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116023] = 5,
    ACTIONS(4296), 1,
      sym_identifier,
    STATE(2541), 1,
      sym_dotted_name,
    STATE(2787), 1,
      sym_aliased_import,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4534), 2,
      sym__newline,
      anon_sym_SEMI,
  [116041] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4538), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [116053] = 5,
    ACTIONS(4367), 1,
      anon_sym_DOT,
    ACTIONS(4371), 1,
      anon_sym_COLON,
    ACTIONS(4375), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4540), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [116071] = 6,
    ACTIONS(4542), 1,
      anon_sym_LBRACE,
    ACTIONS(4544), 1,
      anon_sym_RBRACE,
    ACTIONS(4546), 1,
      aux_sym_format_specifier_token1,
    STATE(2433), 1,
      aux_sym_format_specifier_repeat1,
    STATE(2917), 1,
      sym_interpolation,
    ACTIONS(5), 2,
      sym_comment,
      sym_line_continuation,
  [116091] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4548), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [116103] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4425), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [116115] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4550), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [116127] = 6,
    ACTIONS(3952), 1,
      anon_sym_as,
    ACTIONS(3954), 1,
      anon_sym_if,
    ACTIONS(3956), 1,
      anon_sym_and,
    ACTIONS(3958), 1,
      anon_sym_or,
    ACTIONS(4552), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116147] = 4,
    ACTIONS(3956), 1,
      anon_sym_and,
    ACTIONS(3958), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3828), 3,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
  [116163] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4554), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [116175] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4556), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [116187] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4558), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [116199] = 5,
    ACTIONS(4367), 1,
      anon_sym_DOT,
    ACTIONS(4371), 1,
      anon_sym_COLON,
    ACTIONS(4375), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4331), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [116217] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4560), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [116229] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4447), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [116241] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4562), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [116253] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4447), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [116265] = 4,
    ACTIONS(4564), 1,
      anon_sym_PIPE,
    STATE(2484), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4463), 3,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
  [116281] = 5,
    ACTIONS(4568), 1,
      anon_sym_COMMA,
    ACTIONS(4570), 1,
      anon_sym_as,
    STATE(2548), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4566), 2,
      sym__newline,
      anon_sym_SEMI,
  [116299] = 6,
    ACTIONS(4542), 1,
      anon_sym_LBRACE,
    ACTIONS(4572), 1,
      anon_sym_RBRACE,
    ACTIONS(4574), 1,
      aux_sym_format_specifier_token1,
    STATE(2520), 1,
      aux_sym_format_specifier_repeat1,
    STATE(2917), 1,
      sym_interpolation,
    ACTIONS(5), 2,
      sym_comment,
      sym_line_continuation,
  [116319] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4576), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [116331] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4343), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [116343] = 3,
    STATE(2462), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4427), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [116357] = 4,
    ACTIONS(4578), 1,
      anon_sym_PIPE,
    STATE(2437), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4427), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
  [116373] = 6,
    ACTIONS(4347), 1,
      anon_sym_COMMA,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_COLON,
    ACTIONS(4585), 1,
      anon_sym_EQ,
    ACTIONS(4587), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116393] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4589), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [116405] = 6,
    ACTIONS(3952), 1,
      anon_sym_as,
    ACTIONS(3954), 1,
      anon_sym_if,
    ACTIONS(3956), 1,
      anon_sym_and,
    ACTIONS(3958), 1,
      anon_sym_or,
    ACTIONS(4591), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116425] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4403), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [116437] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4456), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [116449] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3987), 5,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
  [116461] = 5,
    ACTIONS(4345), 1,
      anon_sym_DOT,
    ACTIONS(4349), 1,
      anon_sym_COLON,
    ACTIONS(4353), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4347), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [116479] = 6,
    ACTIONS(3272), 1,
      anon_sym_COLON,
    ACTIONS(4491), 1,
      anon_sym_if,
    ACTIONS(4593), 1,
      anon_sym_COMMA,
    STATE(2545), 1,
      aux_sym_case_clause_repeat1,
    STATE(3276), 1,
      sym_if_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116499] = 5,
    ACTIONS(4595), 1,
      sym_identifier,
    ACTIONS(4597), 1,
      sym__newline,
    ACTIONS(4599), 1,
      sym__indent,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(354), 2,
      sym___directive_parameters_identifiers,
      sym__directive_parameters_identifiers,
  [116517] = 4,
    ACTIONS(4601), 1,
      anon_sym_COMMA,
    STATE(2460), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2208), 3,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
  [116533] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2500), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [116545] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4603), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [116557] = 6,
    ACTIONS(3952), 1,
      anon_sym_as,
    ACTIONS(3954), 1,
      anon_sym_if,
    ACTIONS(3956), 1,
      anon_sym_and,
    ACTIONS(3958), 1,
      anon_sym_or,
    ACTIONS(4605), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116577] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2492), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [116589] = 4,
    ACTIONS(4607), 1,
      anon_sym_PIPE,
    STATE(2452), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4427), 3,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
  [116605] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4532), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [116617] = 5,
    ACTIONS(4610), 1,
      sym_identifier,
    ACTIONS(4612), 1,
      anon_sym_LPAREN,
    ACTIONS(4614), 1,
      anon_sym_STAR,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(3335), 2,
      sym_wildcard_import,
      sym_rule_import_list,
  [116635] = 5,
    ACTIONS(4612), 1,
      anon_sym_LPAREN,
    ACTIONS(4614), 1,
      anon_sym_STAR,
    ACTIONS(4616), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(3299), 2,
      sym_wildcard_import,
      sym_rule_import_list,
  [116653] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4456), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [116665] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2500), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [116677] = 5,
    ACTIONS(4618), 1,
      anon_sym_COMMA,
    ACTIONS(4620), 1,
      anon_sym_RBRACE,
    STATE(3020), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4067), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
  [116695] = 6,
    ACTIONS(3954), 1,
      anon_sym_if,
    ACTIONS(3956), 1,
      anon_sym_and,
    ACTIONS(3958), 1,
      anon_sym_or,
    ACTIONS(4622), 1,
      anon_sym_as,
    ACTIONS(4624), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116715] = 4,
    ACTIONS(4626), 1,
      anon_sym_COMMA,
    STATE(2460), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4018), 3,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_from,
  [116731] = 6,
    ACTIONS(3952), 1,
      anon_sym_as,
    ACTIONS(3954), 1,
      anon_sym_if,
    ACTIONS(3956), 1,
      anon_sym_and,
    ACTIONS(3958), 1,
      anon_sym_or,
    ACTIONS(4629), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116751] = 4,
    ACTIONS(4631), 1,
      anon_sym_PIPE,
    STATE(2437), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4515), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
  [116767] = 3,
    STATE(2484), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4427), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [116781] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4343), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [116793] = 5,
    ACTIONS(4333), 1,
      anon_sym_DOT,
    ACTIONS(4335), 1,
      anon_sym_COLON,
    ACTIONS(4337), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4633), 2,
      sym__newline,
      anon_sym_SEMI,
  [116811] = 5,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_COLON,
    ACTIONS(4587), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4331), 2,
      anon_sym_COMMA,
      anon_sym_EQ,
  [116829] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4425), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [116841] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4635), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [116853] = 6,
    ACTIONS(3952), 1,
      anon_sym_as,
    ACTIONS(3954), 1,
      anon_sym_if,
    ACTIONS(3956), 1,
      anon_sym_and,
    ACTIONS(3958), 1,
      anon_sym_or,
    ACTIONS(4637), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116873] = 6,
    ACTIONS(3952), 1,
      anon_sym_as,
    ACTIONS(3954), 1,
      anon_sym_if,
    ACTIONS(3956), 1,
      anon_sym_and,
    ACTIONS(3958), 1,
      anon_sym_or,
    ACTIONS(4639), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116893] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4641), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [116905] = 3,
    ACTIONS(4643), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4067), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [116919] = 6,
    ACTIONS(3952), 1,
      anon_sym_as,
    ACTIONS(3954), 1,
      anon_sym_if,
    ACTIONS(3956), 1,
      anon_sym_and,
    ACTIONS(3958), 1,
      anon_sym_or,
    ACTIONS(4645), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116939] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3975), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [116951] = 6,
    ACTIONS(3952), 1,
      anon_sym_as,
    ACTIONS(3954), 1,
      anon_sym_if,
    ACTIONS(3956), 1,
      anon_sym_and,
    ACTIONS(3958), 1,
      anon_sym_or,
    ACTIONS(4647), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [116971] = 4,
    ACTIONS(4649), 1,
      anon_sym_PIPE,
    STATE(2512), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4505), 3,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
  [116987] = 6,
    ACTIONS(3816), 1,
      anon_sym_and,
    ACTIONS(3818), 1,
      anon_sym_or,
    ACTIONS(3822), 1,
      anon_sym_as,
    ACTIONS(3824), 1,
      anon_sym_if,
    ACTIONS(4651), 1,
      sym__newline,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117007] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4415), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [117019] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4653), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [117031] = 6,
    ACTIONS(3952), 1,
      anon_sym_as,
    ACTIONS(3954), 1,
      anon_sym_if,
    ACTIONS(3956), 1,
      anon_sym_and,
    ACTIONS(3958), 1,
      anon_sym_or,
    ACTIONS(4655), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117051] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4657), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [117063] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4532), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [117075] = 6,
    ACTIONS(2490), 1,
      anon_sym_LBRACK,
    ACTIONS(4659), 1,
      anon_sym_LPAREN,
    ACTIONS(4661), 1,
      anon_sym_COLON,
    STATE(2747), 1,
      sym_type_parameter,
    STATE(3334), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117095] = 4,
    ACTIONS(4564), 1,
      anon_sym_PIPE,
    STATE(2452), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4515), 3,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
  [117111] = 6,
    ACTIONS(3954), 1,
      anon_sym_if,
    ACTIONS(3956), 1,
      anon_sym_and,
    ACTIONS(3958), 1,
      anon_sym_or,
    ACTIONS(4622), 1,
      anon_sym_as,
    ACTIONS(4663), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117131] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4665), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [117143] = 5,
    ACTIONS(4667), 1,
      anon_sym_COMMA,
    ACTIONS(4669), 1,
      anon_sym_RBRACE,
    STATE(2746), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4067), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
  [117161] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4671), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [117173] = 6,
    ACTIONS(2490), 1,
      anon_sym_LBRACK,
    ACTIONS(4659), 1,
      anon_sym_LPAREN,
    ACTIONS(4673), 1,
      anon_sym_COLON,
    STATE(2749), 1,
      sym_type_parameter,
    STATE(3324), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117193] = 4,
    ACTIONS(4675), 1,
      anon_sym_PIPE,
    STATE(2490), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4427), 3,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
  [117209] = 6,
    ACTIONS(3952), 1,
      anon_sym_as,
    ACTIONS(3954), 1,
      anon_sym_if,
    ACTIONS(3956), 1,
      anon_sym_and,
    ACTIONS(3958), 1,
      anon_sym_or,
    ACTIONS(4678), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117229] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4589), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [117241] = 6,
    ACTIONS(3952), 1,
      anon_sym_as,
    ACTIONS(3954), 1,
      anon_sym_if,
    ACTIONS(3956), 1,
      anon_sym_and,
    ACTIONS(3958), 1,
      anon_sym_or,
    ACTIONS(4680), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117261] = 4,
    ACTIONS(4631), 1,
      anon_sym_PIPE,
    STATE(2462), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4505), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
  [117277] = 3,
    ACTIONS(4682), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4067), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [117291] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4447), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
  [117303] = 3,
    STATE(2512), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4427), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [117317] = 6,
    ACTIONS(4684), 1,
      anon_sym_COLON,
    ACTIONS(4686), 1,
      anon_sym_EQ,
    ACTIONS(4688), 1,
      anon_sym_RBRACE,
    ACTIONS(4690), 1,
      sym_type_conversion,
    STATE(3222), 1,
      sym_format_specifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117337] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4692), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [117349] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4694), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [117361] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4696), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [117373] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4696), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [117385] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3631), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [117397] = 4,
    ACTIONS(4564), 1,
      anon_sym_PIPE,
    STATE(2484), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4505), 3,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
  [117413] = 6,
    ACTIONS(3952), 1,
      anon_sym_as,
    ACTIONS(3954), 1,
      anon_sym_if,
    ACTIONS(3956), 1,
      anon_sym_and,
    ACTIONS(3958), 1,
      anon_sym_or,
    ACTIONS(4698), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117433] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4700), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [117445] = 4,
    ACTIONS(4649), 1,
      anon_sym_PIPE,
    STATE(2512), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4463), 3,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
  [117461] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3868), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [117473] = 6,
    ACTIONS(3952), 1,
      anon_sym_as,
    ACTIONS(3954), 1,
      anon_sym_if,
    ACTIONS(3956), 1,
      anon_sym_and,
    ACTIONS(3958), 1,
      anon_sym_or,
    ACTIONS(4228), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117493] = 5,
    ACTIONS(4702), 1,
      sym_identifier,
    ACTIONS(4704), 1,
      sym__newline,
    ACTIONS(4706), 1,
      sym__indent,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(473), 2,
      sym___directive_parameters_identifiers,
      sym__directive_parameters_identifiers,
  [117511] = 6,
    ACTIONS(4684), 1,
      anon_sym_COLON,
    ACTIONS(4708), 1,
      anon_sym_EQ,
    ACTIONS(4710), 1,
      anon_sym_RBRACE,
    ACTIONS(4712), 1,
      sym_type_conversion,
    STATE(3283), 1,
      sym_format_specifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117531] = 4,
    ACTIONS(4649), 1,
      anon_sym_PIPE,
    STATE(2490), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4515), 3,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
  [117547] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3637), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [117559] = 5,
    ACTIONS(4714), 1,
      anon_sym_COMMA,
    ACTIONS(4716), 1,
      anon_sym_RBRACE,
    STATE(2890), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4067), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
  [117577] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4409), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [117589] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4589), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [117601] = 5,
    ACTIONS(4296), 1,
      sym_identifier,
    STATE(2541), 1,
      sym_dotted_name,
    STATE(2787), 1,
      sym_aliased_import,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4718), 2,
      sym__newline,
      anon_sym_SEMI,
  [117619] = 6,
    ACTIONS(3952), 1,
      anon_sym_as,
    ACTIONS(3954), 1,
      anon_sym_if,
    ACTIONS(3956), 1,
      anon_sym_and,
    ACTIONS(3958), 1,
      anon_sym_or,
    ACTIONS(4720), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117639] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3868), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [117651] = 6,
    ACTIONS(4722), 1,
      anon_sym_LBRACE,
    ACTIONS(4725), 1,
      anon_sym_RBRACE,
    ACTIONS(4727), 1,
      aux_sym_format_specifier_token1,
    STATE(2520), 1,
      aux_sym_format_specifier_repeat1,
    STATE(2917), 1,
      sym_interpolation,
    ACTIONS(5), 2,
      sym_comment,
      sym_line_continuation,
  [117671] = 6,
    ACTIONS(4296), 1,
      sym_identifier,
    ACTIONS(4730), 1,
      anon_sym_LPAREN,
    STATE(2432), 1,
      sym_dotted_name,
    STATE(2560), 1,
      sym_aliased_import,
    STATE(3106), 1,
      sym__import_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117691] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3612), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [117703] = 6,
    ACTIONS(3952), 1,
      anon_sym_as,
    ACTIONS(3954), 1,
      anon_sym_if,
    ACTIONS(3956), 1,
      anon_sym_and,
    ACTIONS(3958), 1,
      anon_sym_or,
    ACTIONS(4732), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117723] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4734), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [117735] = 5,
    ACTIONS(4736), 1,
      anon_sym_COMMA,
    ACTIONS(4738), 1,
      anon_sym_RBRACE,
    STATE(2994), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4067), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
  [117753] = 4,
    ACTIONS(4631), 1,
      anon_sym_PIPE,
    STATE(2462), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4463), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
  [117769] = 6,
    ACTIONS(3952), 1,
      anon_sym_as,
    ACTIONS(3954), 1,
      anon_sym_if,
    ACTIONS(3956), 1,
      anon_sym_and,
    ACTIONS(3958), 1,
      anon_sym_or,
    ACTIONS(4740), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117789] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4742), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [117801] = 6,
    ACTIONS(3952), 1,
      anon_sym_as,
    ACTIONS(3954), 1,
      anon_sym_if,
    ACTIONS(3956), 1,
      anon_sym_and,
    ACTIONS(3958), 1,
      anon_sym_or,
    ACTIONS(4744), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117821] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4746), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [117833] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4748), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [117845] = 6,
    ACTIONS(3952), 1,
      anon_sym_as,
    ACTIONS(3954), 1,
      anon_sym_if,
    ACTIONS(3956), 1,
      anon_sym_and,
    ACTIONS(3958), 1,
      anon_sym_or,
    ACTIONS(4750), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117865] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4548), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [117876] = 5,
    ACTIONS(4752), 1,
      anon_sym_case,
    ACTIONS(4754), 1,
      sym__dedent,
    STATE(2625), 1,
      aux_sym__match_block_repeat1,
    STATE(3160), 1,
      sym_case_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117893] = 5,
    ACTIONS(2490), 1,
      anon_sym_LBRACK,
    ACTIONS(4756), 1,
      anon_sym_LPAREN,
    STATE(3072), 1,
      sym_parameters,
    STATE(3099), 1,
      sym_type_parameter,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117910] = 4,
    ACTIONS(4760), 1,
      anon_sym_COMMA,
    STATE(2600), 1,
      aux_sym_global_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4758), 2,
      sym__newline,
      anon_sym_SEMI,
  [117925] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4742), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [117936] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4734), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [117947] = 5,
    ACTIONS(4762), 1,
      anon_sym_RPAREN,
    ACTIONS(4764), 1,
      anon_sym_COMMA,
    ACTIONS(4766), 1,
      anon_sym_as,
    STATE(2996), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [117964] = 3,
    ACTIONS(4489), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4768), 3,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
  [117977] = 3,
    ACTIONS(4570), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4770), 3,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [117990] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4772), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
  [118001] = 5,
    ACTIONS(4774), 1,
      anon_sym_COMMA,
    ACTIONS(4776), 1,
      anon_sym_as,
    ACTIONS(4778), 1,
      anon_sym_RBRACK,
    STATE(2989), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118018] = 4,
    ACTIONS(4760), 1,
      anon_sym_COMMA,
    STATE(2536), 1,
      aux_sym_global_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4780), 2,
      sym__newline,
      anon_sym_SEMI,
  [118033] = 4,
    ACTIONS(4782), 1,
      anon_sym_COMMA,
    STATE(2545), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4768), 2,
      anon_sym_if,
      anon_sym_COLON,
  [118048] = 4,
    ACTIONS(4787), 1,
      anon_sym_DOT,
    STATE(2546), 1,
      aux_sym_import_prefix_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4785), 2,
      anon_sym_import,
      sym_identifier,
  [118063] = 5,
    ACTIONS(4776), 1,
      anon_sym_as,
    ACTIONS(4790), 1,
      anon_sym_COMMA,
    ACTIONS(4792), 1,
      anon_sym_RBRACK,
    STATE(3006), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118080] = 4,
    ACTIONS(4796), 1,
      anon_sym_COMMA,
    STATE(2663), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4794), 2,
      sym__newline,
      anon_sym_SEMI,
  [118095] = 5,
    ACTIONS(4766), 1,
      anon_sym_as,
    ACTIONS(4798), 1,
      anon_sym_RPAREN,
    ACTIONS(4800), 1,
      anon_sym_COMMA,
    STATE(2987), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118112] = 4,
    ACTIONS(4802), 1,
      anon_sym_COMMA,
    STATE(2663), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4794), 2,
      sym__newline,
      anon_sym_SEMI,
  [118127] = 5,
    ACTIONS(2490), 1,
      anon_sym_LBRACK,
    ACTIONS(4756), 1,
      anon_sym_LPAREN,
    STATE(3036), 1,
      sym_type_parameter,
    STATE(3069), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118144] = 5,
    ACTIONS(4766), 1,
      anon_sym_as,
    ACTIONS(4804), 1,
      anon_sym_RPAREN,
    ACTIONS(4806), 1,
      anon_sym_COMMA,
    STATE(2765), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118161] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4653), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [118172] = 5,
    ACTIONS(4534), 1,
      anon_sym_RPAREN,
    ACTIONS(4808), 1,
      sym_identifier,
    STATE(2878), 1,
      sym_dotted_name,
    STATE(3148), 1,
      sym_aliased_import,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118189] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4576), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [118200] = 5,
    ACTIONS(2490), 1,
      anon_sym_LBRACK,
    ACTIONS(4756), 1,
      anon_sym_LPAREN,
    STATE(3037), 1,
      sym_type_parameter,
    STATE(3070), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118217] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4748), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [118228] = 5,
    ACTIONS(4776), 1,
      anon_sym_as,
    ACTIONS(4810), 1,
      anon_sym_COMMA,
    ACTIONS(4812), 1,
      anon_sym_RBRACK,
    STATE(2885), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118245] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4556), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [118256] = 4,
    ACTIONS(4568), 1,
      anon_sym_COMMA,
    STATE(2550), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4566), 2,
      sym__newline,
      anon_sym_SEMI,
  [118271] = 5,
    ACTIONS(4534), 1,
      anon_sym_RPAREN,
    ACTIONS(4808), 1,
      sym_identifier,
    STATE(2878), 1,
      sym_dotted_name,
    STATE(3148), 1,
      sym_aliased_import,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118288] = 5,
    ACTIONS(4766), 1,
      anon_sym_as,
    ACTIONS(4814), 1,
      anon_sym_RPAREN,
    ACTIONS(4816), 1,
      anon_sym_COMMA,
    STATE(2883), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118305] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4700), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [118316] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4746), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [118327] = 5,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_COLON,
    ACTIONS(4587), 1,
      anon_sym_PIPE,
    ACTIONS(4818), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118344] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4696), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [118355] = 4,
    ACTIONS(4822), 1,
      anon_sym_COLON,
    ACTIONS(4824), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4820), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [118370] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4742), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [118381] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4665), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [118392] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4671), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [118403] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4603), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [118414] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4603), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [118425] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4641), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [118436] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4700), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [118447] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4694), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [118458] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4635), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [118469] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4657), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [118480] = 5,
    ACTIONS(4718), 1,
      anon_sym_RPAREN,
    ACTIONS(4808), 1,
      sym_identifier,
    STATE(2878), 1,
      sym_dotted_name,
    STATE(3148), 1,
      sym_aliased_import,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118497] = 5,
    ACTIONS(4766), 1,
      anon_sym_as,
    ACTIONS(4826), 1,
      anon_sym_RPAREN,
    ACTIONS(4828), 1,
      anon_sym_COMMA,
    STATE(2900), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118514] = 5,
    ACTIONS(4776), 1,
      anon_sym_as,
    ACTIONS(4830), 1,
      anon_sym_COMMA,
    ACTIONS(4832), 1,
      anon_sym_RBRACK,
    STATE(2741), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118531] = 5,
    ACTIONS(4766), 1,
      anon_sym_as,
    ACTIONS(4834), 1,
      anon_sym_RPAREN,
    ACTIONS(4836), 1,
      anon_sym_COMMA,
    STATE(2739), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118548] = 4,
    ACTIONS(4760), 1,
      anon_sym_COMMA,
    STATE(2656), 1,
      aux_sym_global_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4838), 2,
      sym__newline,
      anon_sym_SEMI,
  [118563] = 5,
    ACTIONS(4766), 1,
      anon_sym_as,
    ACTIONS(4840), 1,
      anon_sym_RPAREN,
    ACTIONS(4842), 1,
      anon_sym_COMMA,
    STATE(3013), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118580] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4692), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [118591] = 4,
    ACTIONS(4844), 1,
      anon_sym_COMMA,
    STATE(2460), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2376), 2,
      sym__newline,
      anon_sym_SEMI,
  [118606] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4734), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [118617] = 5,
    ACTIONS(2490), 1,
      anon_sym_LBRACK,
    ACTIONS(4756), 1,
      anon_sym_LPAREN,
    STATE(3127), 1,
      sym_parameters,
    STATE(3128), 1,
      sym_type_parameter,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118634] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4538), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [118645] = 5,
    ACTIONS(4846), 1,
      anon_sym_from,
    ACTIONS(4848), 1,
      anon_sym_COMMA,
    ACTIONS(4850), 1,
      anon_sym_as,
    STATE(2891), 1,
      aux_sym_global_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118662] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4576), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [118673] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4748), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [118684] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4548), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [118695] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4746), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [118706] = 4,
    ACTIONS(4075), 1,
      anon_sym_COMMA,
    STATE(2460), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4852), 2,
      sym__newline,
      anon_sym_SEMI,
  [118721] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4550), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [118732] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4554), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [118743] = 4,
    ACTIONS(4856), 1,
      anon_sym_COMMA,
    STATE(2615), 1,
      aux_sym_print_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4854), 2,
      sym__newline,
      anon_sym_SEMI,
  [118758] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4692), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [118769] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4657), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [118780] = 4,
    ACTIONS(4858), 1,
      anon_sym_COMMA,
    STATE(2600), 1,
      aux_sym_global_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1102), 2,
      sym__newline,
      anon_sym_SEMI,
  [118795] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4603), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [118806] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4558), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [118817] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4696), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [118828] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4700), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [118839] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4560), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [118850] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4657), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [118861] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4505), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
  [118872] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4562), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [118883] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4861), 4,
      anon_sym_async,
      anon_sym_def,
      anon_sym_class,
      anon_sym_AT,
  [118894] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4562), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [118905] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4562), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [118916] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4560), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [118927] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4558), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [118938] = 5,
    ACTIONS(4684), 1,
      anon_sym_COLON,
    ACTIONS(4863), 1,
      anon_sym_RBRACE,
    ACTIONS(4865), 1,
      sym_type_conversion,
    STATE(3447), 1,
      sym_format_specifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118955] = 4,
    ACTIONS(4869), 1,
      anon_sym_COMMA,
    STATE(2622), 1,
      aux_sym_print_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4867), 2,
      sym__newline,
      anon_sym_SEMI,
  [118970] = 5,
    ACTIONS(4871), 1,
      anon_sym_case,
    ACTIONS(4874), 1,
      sym__dedent,
    STATE(2616), 1,
      aux_sym__match_block_repeat1,
    STATE(3160), 1,
      sym_case_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [118987] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4560), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [118998] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4556), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [119009] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4554), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [119020] = 5,
    ACTIONS(4752), 1,
      anon_sym_case,
    ACTIONS(4876), 1,
      sym__dedent,
    STATE(2655), 1,
      aux_sym__match_block_repeat1,
    STATE(3160), 1,
      sym_case_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119037] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4550), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [119048] = 4,
    ACTIONS(4880), 1,
      anon_sym_COMMA,
    STATE(2622), 1,
      aux_sym_print_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4878), 2,
      sym__newline,
      anon_sym_SEMI,
  [119063] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4653), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [119074] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4558), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [119085] = 5,
    ACTIONS(4752), 1,
      anon_sym_case,
    ACTIONS(4883), 1,
      sym__dedent,
    STATE(2616), 1,
      aux_sym__match_block_repeat1,
    STATE(3160), 1,
      sym_case_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119102] = 4,
    ACTIONS(4075), 1,
      anon_sym_COMMA,
    STATE(2460), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4885), 2,
      sym__newline,
      anon_sym_SEMI,
  [119117] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4556), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [119128] = 4,
    ACTIONS(4889), 1,
      anon_sym_DOT,
    STATE(2546), 1,
      aux_sym_import_prefix_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4887), 2,
      anon_sym_import,
      sym_identifier,
  [119143] = 5,
    ACTIONS(4846), 1,
      anon_sym_from,
    ACTIONS(4848), 1,
      anon_sym_COMMA,
    ACTIONS(4891), 1,
      anon_sym_as,
    STATE(2891), 1,
      aux_sym_global_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119160] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4554), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [119171] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4548), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [119182] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4538), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [119193] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4635), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [119204] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4694), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [119215] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4641), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [119226] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4671), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [119237] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4665), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [119248] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4665), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [119259] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4671), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [119270] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4653), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [119281] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4550), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [119292] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4641), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [119303] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4742), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [119314] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4692), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [119325] = 4,
    ACTIONS(4895), 1,
      anon_sym_COMMA,
    STATE(2622), 1,
      aux_sym_print_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4893), 2,
      sym__newline,
      anon_sym_SEMI,
  [119340] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4734), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [119351] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4576), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [119362] = 5,
    ACTIONS(4347), 1,
      anon_sym_COMMA,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4583), 1,
      anon_sym_COLON,
    ACTIONS(4587), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119379] = 5,
    ACTIONS(4684), 1,
      anon_sym_COLON,
    ACTIONS(4897), 1,
      anon_sym_RBRACE,
    ACTIONS(4899), 1,
      sym_type_conversion,
    STATE(3177), 1,
      sym_format_specifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119396] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4748), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [119407] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4067), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(4901), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [119420] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4746), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [119431] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4694), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [119442] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4635), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [119453] = 5,
    ACTIONS(4752), 1,
      anon_sym_case,
    ACTIONS(4903), 1,
      sym__dedent,
    STATE(2616), 1,
      aux_sym__match_block_repeat1,
    STATE(3160), 1,
      sym_case_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119470] = 4,
    ACTIONS(4760), 1,
      anon_sym_COMMA,
    STATE(2600), 1,
      aux_sym_global_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4905), 2,
      sym__newline,
      anon_sym_SEMI,
  [119485] = 5,
    ACTIONS(4808), 1,
      sym_identifier,
    STATE(2662), 1,
      sym_dotted_name,
    STATE(2915), 1,
      sym_aliased_import,
    STATE(3173), 1,
      sym__import_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119502] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4538), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [119513] = 5,
    ACTIONS(4808), 1,
      sym_identifier,
    STATE(2662), 1,
      sym_dotted_name,
    STATE(2915), 1,
      sym_aliased_import,
    STATE(3174), 1,
      sym__import_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119530] = 5,
    ACTIONS(4296), 1,
      sym_identifier,
    STATE(2432), 1,
      sym_dotted_name,
    STATE(2560), 1,
      sym_aliased_import,
    STATE(3039), 1,
      sym__import_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119547] = 5,
    ACTIONS(4766), 1,
      anon_sym_as,
    ACTIONS(4907), 1,
      anon_sym_RPAREN,
    ACTIONS(4909), 1,
      anon_sym_COMMA,
    STATE(3001), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119564] = 5,
    ACTIONS(4566), 1,
      anon_sym_RPAREN,
    ACTIONS(4911), 1,
      anon_sym_COMMA,
    ACTIONS(4913), 1,
      anon_sym_as,
    STATE(2902), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119581] = 4,
    ACTIONS(4917), 1,
      anon_sym_COMMA,
    STATE(2663), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4915), 2,
      sym__newline,
      anon_sym_SEMI,
  [119596] = 4,
    ACTIONS(4920), 1,
      anon_sym_COMMA,
    ACTIONS(4922), 1,
      sym__dedent,
    STATE(3010), 1,
      aux_sym_global_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119610] = 4,
    ACTIONS(4924), 1,
      sym__newline,
    ACTIONS(4926), 1,
      sym__indent,
    STATE(346), 1,
      sym__rule_suite,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119624] = 4,
    ACTIONS(4928), 1,
      sym__newline,
    ACTIONS(4930), 1,
      sym__indent,
    STATE(502), 1,
      sym__match_block,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119638] = 4,
    ACTIONS(1886), 1,
      sym__dedent,
    ACTIONS(4932), 1,
      anon_sym_COMMA,
    STATE(2682), 1,
      aux_sym___directive_parameters_wc_none_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119652] = 4,
    ACTIONS(1886), 1,
      sym__newline,
    ACTIONS(4934), 1,
      anon_sym_COMMA,
    STATE(2941), 1,
      aux_sym___directive_parameters_wc_none_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119666] = 4,
    ACTIONS(4936), 1,
      anon_sym_COMMA,
    ACTIONS(4938), 1,
      sym__dedent,
    STATE(2684), 1,
      aux_sym_global_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119680] = 4,
    ACTIONS(4938), 1,
      sym__newline,
    ACTIONS(4940), 1,
      sym_identifier,
    ACTIONS(4942), 1,
      sym__indent,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119694] = 4,
    ACTIONS(4938), 1,
      sym__newline,
    ACTIONS(4944), 1,
      anon_sym_COMMA,
    STATE(2600), 1,
      aux_sym_global_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119708] = 4,
    ACTIONS(4946), 1,
      anon_sym_COMMA,
    ACTIONS(4948), 1,
      anon_sym_in,
    STATE(2690), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119722] = 4,
    ACTIONS(4946), 1,
      anon_sym_COMMA,
    ACTIONS(4950), 1,
      anon_sym_in,
    STATE(2690), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119736] = 4,
    ACTIONS(2064), 1,
      anon_sym_RPAREN,
    ACTIONS(4952), 1,
      anon_sym_COMMA,
    STATE(2958), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119750] = 4,
    ACTIONS(2074), 1,
      anon_sym_RPAREN,
    ACTIONS(4954), 1,
      anon_sym_COMMA,
    STATE(2958), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119764] = 4,
    ACTIONS(4956), 1,
      anon_sym_COMMA,
    ACTIONS(4958), 1,
      anon_sym_RBRACK,
    STATE(2967), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119778] = 4,
    ACTIONS(4960), 1,
      anon_sym_COMMA,
    ACTIONS(4962), 1,
      anon_sym_RBRACK,
    STATE(2967), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119792] = 4,
    ACTIONS(4684), 1,
      anon_sym_COLON,
    ACTIONS(4964), 1,
      anon_sym_RBRACE,
    STATE(3413), 1,
      sym_format_specifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119806] = 4,
    ACTIONS(4966), 1,
      anon_sym_SEMI,
    ACTIONS(4968), 1,
      sym__newline,
    STATE(2711), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119820] = 4,
    ACTIONS(3452), 1,
      sym_identifier,
    ACTIONS(4970), 1,
      anon_sym_import,
    STATE(3367), 1,
      sym_dotted_name,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119834] = 4,
    ACTIONS(1810), 1,
      anon_sym_RBRACK,
    ACTIONS(4972), 1,
      anon_sym_COMMA,
    STATE(2980), 1,
      aux_sym_type_parameter_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119848] = 4,
    ACTIONS(1816), 1,
      sym__dedent,
    ACTIONS(4974), 1,
      anon_sym_COMMA,
    STATE(2849), 1,
      aux_sym___directive_parameters_wc_none_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119862] = 4,
    ACTIONS(3805), 1,
      anon_sym_RPAREN,
    ACTIONS(3878), 1,
      anon_sym_COMMA,
    STATE(2720), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119876] = 4,
    ACTIONS(4976), 1,
      anon_sym_COMMA,
    ACTIONS(4978), 1,
      sym__dedent,
    STATE(2784), 1,
      aux_sym_global_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119890] = 4,
    ACTIONS(4980), 1,
      anon_sym_RPAREN,
    ACTIONS(4982), 1,
      anon_sym_COMMA,
    STATE(2722), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119904] = 4,
    ACTIONS(4940), 1,
      sym_identifier,
    ACTIONS(4978), 1,
      sym__newline,
    ACTIONS(4984), 1,
      sym__indent,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119918] = 4,
    ACTIONS(3878), 1,
      anon_sym_COMMA,
    ACTIONS(3892), 1,
      anon_sym_RPAREN,
    STATE(2720), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119932] = 3,
    ACTIONS(4035), 1,
      anon_sym_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4033), 2,
      sym__newline,
      anon_sym_SEMI,
  [119944] = 4,
    ACTIONS(4946), 1,
      anon_sym_COMMA,
    ACTIONS(4986), 1,
      anon_sym_in,
    STATE(2690), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119958] = 4,
    ACTIONS(1740), 1,
      anon_sym_in,
    ACTIONS(4988), 1,
      anon_sym_COMMA,
    STATE(2696), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119972] = 4,
    ACTIONS(4684), 1,
      anon_sym_COLON,
    ACTIONS(4990), 1,
      anon_sym_RBRACE,
    STATE(3428), 1,
      sym_format_specifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [119986] = 4,
    ACTIONS(4049), 1,
      anon_sym_COMMA,
    ACTIONS(4053), 1,
      anon_sym_RBRACK,
    STATE(2677), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120000] = 4,
    ACTIONS(4992), 1,
      anon_sym_RPAREN,
    ACTIONS(4994), 1,
      anon_sym_COMMA,
    STATE(2675), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120014] = 4,
    ACTIONS(3872), 1,
      anon_sym_RPAREN,
    ACTIONS(3874), 1,
      anon_sym_COMMA,
    STATE(2674), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120028] = 4,
    ACTIONS(4996), 1,
      anon_sym_COMMA,
    ACTIONS(4998), 1,
      anon_sym_COLON,
    STATE(2742), 1,
      aux_sym_with_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120042] = 4,
    ACTIONS(3612), 1,
      anon_sym_in,
    ACTIONS(5000), 1,
      anon_sym_COMMA,
    STATE(2696), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120056] = 4,
    ACTIONS(5003), 1,
      sym__newline,
    ACTIONS(5005), 1,
      sym__indent,
    STATE(500), 1,
      sym_module_body,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120070] = 4,
    ACTIONS(5007), 1,
      anon_sym_COMMA,
    ACTIONS(5009), 1,
      sym__newline,
    STATE(2671), 1,
      aux_sym_global_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120084] = 3,
    ACTIONS(5013), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(5011), 2,
      sym__newline,
      anon_sym_SEMI,
  [120096] = 4,
    ACTIONS(2036), 1,
      sym__newline,
    ACTIONS(5015), 1,
      anon_sym_COMMA,
    STATE(2668), 1,
      aux_sym___directive_parameters_wc_none_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120110] = 4,
    ACTIONS(4259), 1,
      anon_sym_COMMA,
    ACTIONS(4261), 1,
      anon_sym_RBRACE,
    STATE(2750), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120124] = 3,
    ACTIONS(5017), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4820), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [120136] = 4,
    ACTIONS(2236), 1,
      anon_sym_RBRACE,
    ACTIONS(5019), 1,
      anon_sym_COMMA,
    STATE(2822), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120150] = 4,
    ACTIONS(2058), 1,
      sym__dedent,
    ACTIONS(5021), 1,
      anon_sym_COMMA,
    STATE(2731), 1,
      aux_sym___directive_parameters_wc_none_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120164] = 4,
    ACTIONS(5023), 1,
      anon_sym_COMMA,
    ACTIONS(5025), 1,
      anon_sym_COLON,
    STATE(2754), 1,
      aux_sym__parameters_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120178] = 3,
    ACTIONS(5017), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4820), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [120190] = 4,
    ACTIONS(5027), 1,
      anon_sym_COMMA,
    ACTIONS(5029), 1,
      sym__dedent,
    STATE(2734), 1,
      aux_sym_global_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120204] = 3,
    ACTIONS(5031), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(355), 2,
      sym___directive_parameters_ruleorder,
      sym__directive_parameters_ruleorder,
  [120216] = 4,
    ACTIONS(4926), 1,
      sym__indent,
    ACTIONS(5033), 1,
      sym__newline,
    STATE(357), 1,
      sym__rule_suite,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120230] = 4,
    ACTIONS(4926), 1,
      sym__indent,
    ACTIONS(5035), 1,
      sym__newline,
    STATE(358), 1,
      sym__rule_suite,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120244] = 4,
    ACTIONS(742), 1,
      sym__newline,
    ACTIONS(5037), 1,
      anon_sym_SEMI,
    STATE(2764), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120258] = 4,
    ACTIONS(4946), 1,
      anon_sym_COMMA,
    ACTIONS(5039), 1,
      anon_sym_in,
    STATE(2690), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120272] = 4,
    ACTIONS(4946), 1,
      anon_sym_COMMA,
    ACTIONS(5041), 1,
      anon_sym_in,
    STATE(2690), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120286] = 4,
    ACTIONS(3878), 1,
      anon_sym_COMMA,
    ACTIONS(5043), 1,
      anon_sym_RPAREN,
    STATE(2720), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120300] = 4,
    ACTIONS(5045), 1,
      anon_sym_COMMA,
    ACTIONS(5047), 1,
      anon_sym_COLON,
    STATE(2807), 1,
      aux_sym_match_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120314] = 4,
    ACTIONS(4928), 1,
      sym__newline,
    ACTIONS(4930), 1,
      sym__indent,
    STATE(481), 1,
      sym__match_block,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120328] = 4,
    ACTIONS(3878), 1,
      anon_sym_COMMA,
    ACTIONS(5049), 1,
      anon_sym_RPAREN,
    STATE(2720), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120342] = 4,
    ACTIONS(5051), 1,
      anon_sym_COMMA,
    ACTIONS(5053), 1,
      anon_sym_RBRACE,
    STATE(2744), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120356] = 4,
    ACTIONS(3878), 1,
      anon_sym_COMMA,
    ACTIONS(5055), 1,
      anon_sym_RPAREN,
    STATE(2720), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120370] = 4,
    ACTIONS(2178), 1,
      anon_sym_RPAREN,
    ACTIONS(5057), 1,
      anon_sym_COMMA,
    STATE(2798), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120384] = 4,
    ACTIONS(3878), 1,
      anon_sym_COMMA,
    ACTIONS(5059), 1,
      anon_sym_RPAREN,
    STATE(2720), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120398] = 4,
    ACTIONS(2589), 1,
      anon_sym_RPAREN,
    ACTIONS(5061), 1,
      anon_sym_COMMA,
    STATE(2884), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120412] = 4,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4587), 1,
      anon_sym_PIPE,
    ACTIONS(5063), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120426] = 4,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4587), 1,
      anon_sym_PIPE,
    ACTIONS(5065), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120440] = 4,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4587), 1,
      anon_sym_PIPE,
    ACTIONS(5067), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120454] = 4,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4587), 1,
      anon_sym_PIPE,
    ACTIONS(5069), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120468] = 4,
    ACTIONS(5071), 1,
      anon_sym_SEMI,
    ACTIONS(5073), 1,
      sym__newline,
    STATE(2728), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120482] = 4,
    ACTIONS(736), 1,
      sym__newline,
    ACTIONS(5075), 1,
      anon_sym_SEMI,
    STATE(2764), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120496] = 4,
    ACTIONS(5077), 1,
      anon_sym_COMMA,
    ACTIONS(5079), 1,
      anon_sym_COLON,
    STATE(2807), 1,
      aux_sym_match_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120510] = 4,
    ACTIONS(5081), 1,
      sym__newline,
    ACTIONS(5083), 1,
      sym__indent,
    STATE(478), 1,
      sym__rule_suite,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120524] = 4,
    ACTIONS(2094), 1,
      sym__dedent,
    ACTIONS(5085), 1,
      anon_sym_COMMA,
    STATE(2849), 1,
      aux_sym___directive_parameters_wc_none_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120538] = 4,
    ACTIONS(2094), 1,
      sym__dedent,
    ACTIONS(5085), 1,
      anon_sym_COMMA,
    STATE(2753), 1,
      aux_sym___directive_parameters_wc_none_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120552] = 4,
    ACTIONS(4946), 1,
      anon_sym_COMMA,
    ACTIONS(5087), 1,
      anon_sym_in,
    STATE(2690), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120566] = 4,
    ACTIONS(5089), 1,
      anon_sym_COMMA,
    ACTIONS(5091), 1,
      sym__dedent,
    STATE(2784), 1,
      aux_sym_global_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120580] = 4,
    ACTIONS(5089), 1,
      anon_sym_COMMA,
    ACTIONS(5091), 1,
      sym__dedent,
    STATE(2755), 1,
      aux_sym_global_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120594] = 4,
    ACTIONS(4946), 1,
      anon_sym_COMMA,
    ACTIONS(5093), 1,
      anon_sym_in,
    STATE(2690), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120608] = 4,
    ACTIONS(5083), 1,
      sym__indent,
    ACTIONS(5095), 1,
      sym__newline,
    STATE(477), 1,
      sym__rule_suite,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120622] = 3,
    ACTIONS(5097), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(474), 2,
      sym___directive_parameters_ruleorder,
      sym__directive_parameters_ruleorder,
  [120634] = 4,
    ACTIONS(3324), 1,
      anon_sym_RPAREN,
    ACTIONS(5099), 1,
      anon_sym_COMMA,
    STATE(2833), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120648] = 4,
    ACTIONS(5101), 1,
      anon_sym_RPAREN,
    ACTIONS(5103), 1,
      anon_sym_COMMA,
    STATE(2817), 1,
      aux_sym_with_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120662] = 4,
    ACTIONS(3418), 1,
      anon_sym_RBRACK,
    ACTIONS(5105), 1,
      anon_sym_COMMA,
    STATE(2780), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120676] = 4,
    ACTIONS(2370), 1,
      anon_sym_COLON,
    ACTIONS(5107), 1,
      anon_sym_COMMA,
    STATE(2818), 1,
      aux_sym_with_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120690] = 4,
    ACTIONS(4946), 1,
      anon_sym_COMMA,
    ACTIONS(5109), 1,
      anon_sym_in,
    STATE(2690), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120704] = 4,
    ACTIONS(5111), 1,
      anon_sym_COMMA,
    ACTIONS(5113), 1,
      anon_sym_RBRACE,
    STATE(2997), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120718] = 4,
    ACTIONS(4191), 1,
      anon_sym_COMMA,
    ACTIONS(4193), 1,
      anon_sym_RBRACE,
    STATE(2703), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120732] = 4,
    ACTIONS(5115), 1,
      anon_sym_COMMA,
    ACTIONS(5117), 1,
      anon_sym_RBRACE,
    STATE(2997), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120746] = 4,
    ACTIONS(4659), 1,
      anon_sym_LPAREN,
    ACTIONS(5119), 1,
      anon_sym_COLON,
    STATE(3344), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120760] = 4,
    ACTIONS(5121), 1,
      sym__newline,
    ACTIONS(5123), 1,
      sym__indent,
    STATE(439), 1,
      sym__match_block,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120774] = 4,
    ACTIONS(4659), 1,
      anon_sym_LPAREN,
    ACTIONS(5125), 1,
      anon_sym_COLON,
    STATE(3230), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120788] = 4,
    ACTIONS(2234), 1,
      anon_sym_RBRACE,
    ACTIONS(5127), 1,
      anon_sym_COMMA,
    STATE(2822), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120802] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2536), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
  [120812] = 4,
    ACTIONS(3878), 1,
      anon_sym_COMMA,
    ACTIONS(3924), 1,
      anon_sym_RPAREN,
    STATE(2720), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120826] = 4,
    ACTIONS(2134), 1,
      sym__dedent,
    ACTIONS(5129), 1,
      anon_sym_COMMA,
    STATE(2849), 1,
      aux_sym___directive_parameters_wc_none_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120840] = 4,
    ACTIONS(3742), 1,
      anon_sym_COLON,
    ACTIONS(5131), 1,
      anon_sym_COMMA,
    STATE(2825), 1,
      aux_sym__parameters_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120854] = 4,
    ACTIONS(5133), 1,
      anon_sym_COMMA,
    ACTIONS(5135), 1,
      sym__dedent,
    STATE(2784), 1,
      aux_sym_global_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120868] = 4,
    ACTIONS(2100), 1,
      sym__newline,
    ACTIONS(5137), 1,
      anon_sym_COMMA,
    STATE(2863), 1,
      aux_sym___directive_parameters_wc_none_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120882] = 4,
    ACTIONS(5139), 1,
      anon_sym_COMMA,
    ACTIONS(5141), 1,
      sym__newline,
    STATE(2871), 1,
      aux_sym_global_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120896] = 4,
    ACTIONS(4926), 1,
      sym__indent,
    ACTIONS(5143), 1,
      sym__newline,
    STATE(508), 1,
      sym__rule_suite,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120910] = 4,
    ACTIONS(4926), 1,
      sym__indent,
    ACTIONS(5145), 1,
      sym__newline,
    STATE(507), 1,
      sym__rule_suite,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120924] = 4,
    ACTIONS(5147), 1,
      anon_sym_COMMA,
    ACTIONS(5149), 1,
      anon_sym_RBRACK,
    STATE(2967), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120938] = 4,
    ACTIONS(5151), 1,
      anon_sym_COMMA,
    ACTIONS(5153), 1,
      anon_sym_RBRACK,
    STATE(2967), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120952] = 4,
    ACTIONS(4105), 1,
      anon_sym_COMMA,
    ACTIONS(4107), 1,
      anon_sym_RBRACK,
    STATE(2760), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120966] = 4,
    ACTIONS(5155), 1,
      sym__newline,
    ACTIONS(5157), 1,
      sym__indent,
    STATE(504), 1,
      sym_module_body,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120980] = 4,
    ACTIONS(5159), 1,
      anon_sym_SEMI,
    ACTIONS(5162), 1,
      sym__newline,
    STATE(2764), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [120994] = 4,
    ACTIONS(3376), 1,
      anon_sym_RPAREN,
    ACTIONS(5164), 1,
      anon_sym_COMMA,
    STATE(2833), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121008] = 4,
    ACTIONS(5166), 1,
      anon_sym_COMMA,
    ACTIONS(5168), 1,
      anon_sym_RBRACK,
    STATE(2967), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121022] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4772), 3,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
  [121032] = 4,
    ACTIONS(4018), 1,
      anon_sym_COLON,
    ACTIONS(5170), 1,
      anon_sym_COMMA,
    STATE(2768), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121046] = 4,
    ACTIONS(2208), 1,
      anon_sym_COLON,
    ACTIONS(5173), 1,
      anon_sym_COMMA,
    STATE(2768), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121060] = 4,
    ACTIONS(5175), 1,
      anon_sym_COMMA,
    ACTIONS(5177), 1,
      anon_sym_RBRACK,
    STATE(2967), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121074] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2823), 3,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_in,
  [121084] = 4,
    ACTIONS(4069), 1,
      anon_sym_COMMA,
    ACTIONS(4071), 1,
      anon_sym_RBRACK,
    STATE(2766), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121098] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4505), 3,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
  [121108] = 4,
    ACTIONS(1102), 1,
      anon_sym_RPAREN,
    ACTIONS(5179), 1,
      anon_sym_COMMA,
    STATE(2774), 1,
      aux_sym_global_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121122] = 4,
    ACTIONS(3888), 1,
      anon_sym_RPAREN,
    ACTIONS(3890), 1,
      anon_sym_COMMA,
    STATE(2905), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121136] = 4,
    ACTIONS(4018), 1,
      anon_sym_RBRACK,
    ACTIONS(5182), 1,
      anon_sym_COMMA,
    STATE(2776), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121150] = 4,
    ACTIONS(2208), 1,
      anon_sym_RBRACK,
    ACTIONS(5185), 1,
      anon_sym_COMMA,
    STATE(2776), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121164] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4505), 3,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
  [121174] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2839), 3,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_in,
  [121184] = 4,
    ACTIONS(4768), 1,
      anon_sym_RBRACK,
    ACTIONS(5187), 1,
      anon_sym_COMMA,
    STATE(2780), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121198] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4772), 3,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
  [121208] = 3,
    ACTIONS(4776), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4768), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [121220] = 4,
    ACTIONS(5190), 1,
      anon_sym_RPAREN,
    ACTIONS(5192), 1,
      anon_sym_COMMA,
    STATE(2907), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121234] = 4,
    ACTIONS(1102), 1,
      sym__dedent,
    ACTIONS(5194), 1,
      anon_sym_COMMA,
    STATE(2784), 1,
      aux_sym_global_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121248] = 4,
    ACTIONS(4127), 1,
      anon_sym_COMMA,
    ACTIONS(4129), 1,
      anon_sym_RBRACK,
    STATE(2916), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121262] = 4,
    ACTIONS(5197), 1,
      anon_sym_SEMI,
    ACTIONS(5199), 1,
      sym__newline,
    STATE(2808), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121276] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4770), 3,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [121286] = 4,
    ACTIONS(4329), 1,
      anon_sym_RBRACE,
    ACTIONS(5201), 1,
      anon_sym_COMMA,
    STATE(2788), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121300] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(5204), 3,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [121310] = 4,
    ACTIONS(5206), 1,
      anon_sym_COMMA,
    ACTIONS(5208), 1,
      anon_sym_RBRACK,
    STATE(2967), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121324] = 4,
    ACTIONS(5210), 1,
      anon_sym_COMMA,
    ACTIONS(5212), 1,
      anon_sym_RBRACK,
    STATE(2967), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121338] = 4,
    ACTIONS(3876), 1,
      anon_sym_RPAREN,
    ACTIONS(3878), 1,
      anon_sym_COMMA,
    STATE(2720), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121352] = 4,
    ACTIONS(2026), 1,
      anon_sym_RPAREN,
    ACTIONS(5214), 1,
      anon_sym_COMMA,
    STATE(2958), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121366] = 4,
    ACTIONS(2034), 1,
      anon_sym_RPAREN,
    ACTIONS(5216), 1,
      anon_sym_COMMA,
    STATE(2958), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121380] = 4,
    ACTIONS(4018), 1,
      anon_sym_RPAREN,
    ACTIONS(5218), 1,
      anon_sym_COMMA,
    STATE(2795), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121394] = 4,
    ACTIONS(3612), 1,
      anon_sym_RBRACK,
    ACTIONS(5221), 1,
      anon_sym_COMMA,
    STATE(2796), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121408] = 4,
    ACTIONS(4115), 1,
      anon_sym_COMMA,
    ACTIONS(4117), 1,
      anon_sym_RBRACK,
    STATE(2790), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121422] = 4,
    ACTIONS(4329), 1,
      anon_sym_RPAREN,
    ACTIONS(5224), 1,
      anon_sym_COMMA,
    STATE(2798), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121436] = 4,
    ACTIONS(4946), 1,
      anon_sym_COMMA,
    ACTIONS(5227), 1,
      anon_sym_in,
    STATE(2690), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121450] = 4,
    ACTIONS(5229), 1,
      anon_sym_RPAREN,
    ACTIONS(5231), 1,
      anon_sym_COMMA,
    STATE(2793), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121464] = 4,
    ACTIONS(3850), 1,
      anon_sym_RPAREN,
    ACTIONS(3852), 1,
      anon_sym_COMMA,
    STATE(2794), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121478] = 4,
    ACTIONS(5121), 1,
      sym__newline,
    ACTIONS(5123), 1,
      sym__indent,
    STATE(496), 1,
      sym__match_block,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121492] = 4,
    ACTIONS(4238), 1,
      anon_sym_COMMA,
    ACTIONS(4240), 1,
      anon_sym_RBRACE,
    STATE(2820), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121506] = 4,
    ACTIONS(2208), 1,
      anon_sym_RPAREN,
    ACTIONS(5233), 1,
      anon_sym_COMMA,
    STATE(2795), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121520] = 4,
    ACTIONS(2228), 1,
      anon_sym_RBRACE,
    ACTIONS(5235), 1,
      anon_sym_COMMA,
    STATE(2822), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121534] = 4,
    ACTIONS(5121), 1,
      sym__newline,
    ACTIONS(5123), 1,
      sym__indent,
    STATE(493), 1,
      sym__match_block,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121548] = 4,
    ACTIONS(5237), 1,
      anon_sym_COMMA,
    ACTIONS(5240), 1,
      anon_sym_COLON,
    STATE(2807), 1,
      aux_sym_match_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121562] = 4,
    ACTIONS(748), 1,
      sym__newline,
    ACTIONS(5242), 1,
      anon_sym_SEMI,
    STATE(2764), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121576] = 4,
    ACTIONS(746), 1,
      sym__newline,
    ACTIONS(5244), 1,
      anon_sym_SEMI,
    STATE(2764), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121590] = 4,
    ACTIONS(2178), 1,
      anon_sym_RBRACE,
    ACTIONS(5246), 1,
      anon_sym_COMMA,
    STATE(2788), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121604] = 4,
    ACTIONS(4220), 1,
      anon_sym_COMMA,
    ACTIONS(4222), 1,
      anon_sym_RBRACE,
    STATE(2805), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121618] = 4,
    ACTIONS(3878), 1,
      anon_sym_COMMA,
    ACTIONS(3904), 1,
      anon_sym_RPAREN,
    STATE(2720), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121632] = 4,
    ACTIONS(3878), 1,
      anon_sym_COMMA,
    ACTIONS(5248), 1,
      anon_sym_RPAREN,
    STATE(2720), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121646] = 4,
    ACTIONS(3878), 1,
      anon_sym_COMMA,
    ACTIONS(5250), 1,
      anon_sym_RPAREN,
    STATE(2720), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121660] = 3,
    ACTIONS(1064), 1,
      anon_sym_except,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1066), 2,
      anon_sym_except_STAR,
      anon_sym_finally,
  [121672] = 4,
    ACTIONS(5252), 1,
      anon_sym_SEMI,
    ACTIONS(5254), 1,
      sym__newline,
    STATE(2809), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121686] = 4,
    ACTIONS(2366), 1,
      anon_sym_RPAREN,
    ACTIONS(5256), 1,
      anon_sym_COMMA,
    STATE(2865), 1,
      aux_sym_with_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121700] = 4,
    ACTIONS(5258), 1,
      anon_sym_COMMA,
    ACTIONS(5261), 1,
      anon_sym_COLON,
    STATE(2818), 1,
      aux_sym_with_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121714] = 4,
    ACTIONS(5083), 1,
      sym__indent,
    ACTIONS(5263), 1,
      sym__newline,
    STATE(417), 1,
      sym__rule_suite,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121728] = 4,
    ACTIONS(2260), 1,
      anon_sym_RBRACE,
    ACTIONS(5265), 1,
      anon_sym_COMMA,
    STATE(2822), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121742] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1102), 3,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [121752] = 4,
    ACTIONS(5267), 1,
      anon_sym_COMMA,
    ACTIONS(5270), 1,
      anon_sym_RBRACE,
    STATE(2822), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121766] = 4,
    ACTIONS(3793), 1,
      anon_sym_COMMA,
    ACTIONS(3805), 1,
      anon_sym_RBRACE,
    STATE(2810), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121780] = 4,
    ACTIONS(2092), 1,
      sym__newline,
    ACTIONS(5272), 1,
      anon_sym_COMMA,
    STATE(2839), 1,
      aux_sym___directive_parameters_wc_none_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121794] = 4,
    ACTIONS(5274), 1,
      anon_sym_COMMA,
    ACTIONS(5277), 1,
      anon_sym_COLON,
    STATE(2825), 1,
      aux_sym__parameters_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121808] = 4,
    ACTIONS(5083), 1,
      sym__indent,
    ACTIONS(5279), 1,
      sym__newline,
    STATE(455), 1,
      sym__rule_suite,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121822] = 4,
    ACTIONS(5281), 1,
      anon_sym_COMMA,
    ACTIONS(5283), 1,
      anon_sym_RBRACK,
    STATE(2967), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121836] = 4,
    ACTIONS(3933), 1,
      anon_sym_RPAREN,
    ACTIONS(3935), 1,
      anon_sym_COMMA,
    STATE(2842), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121850] = 4,
    ACTIONS(5285), 1,
      anon_sym_RPAREN,
    ACTIONS(5287), 1,
      anon_sym_COMMA,
    STATE(2844), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121864] = 4,
    ACTIONS(5083), 1,
      sym__indent,
    ACTIONS(5289), 1,
      sym__newline,
    STATE(450), 1,
      sym__rule_suite,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121878] = 4,
    ACTIONS(5083), 1,
      sym__indent,
    ACTIONS(5291), 1,
      sym__newline,
    STATE(448), 1,
      sym__rule_suite,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121892] = 4,
    ACTIONS(4138), 1,
      anon_sym_COMMA,
    ACTIONS(4140), 1,
      anon_sym_RBRACK,
    STATE(2847), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121906] = 4,
    ACTIONS(4768), 1,
      anon_sym_RPAREN,
    ACTIONS(5293), 1,
      anon_sym_COMMA,
    STATE(2833), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121920] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4772), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
  [121930] = 3,
    ACTIONS(4766), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4768), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [121942] = 4,
    ACTIONS(5083), 1,
      sym__indent,
    ACTIONS(5296), 1,
      sym__newline,
    STATE(418), 1,
      sym__rule_suite,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121956] = 4,
    ACTIONS(1820), 1,
      sym__dedent,
    ACTIONS(5298), 1,
      anon_sym_COMMA,
    STATE(2853), 1,
      aux_sym___directive_parameters_wc_none_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121970] = 4,
    ACTIONS(5300), 1,
      anon_sym_COMMA,
    ACTIONS(5302), 1,
      anon_sym_RBRACK,
    STATE(2967), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121984] = 4,
    ACTIONS(1820), 1,
      sym__newline,
    ACTIONS(5304), 1,
      anon_sym_COMMA,
    STATE(2941), 1,
      aux_sym___directive_parameters_wc_none_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [121998] = 3,
    ACTIONS(4142), 1,
      aux_sym_format_specifier_token1,
    ACTIONS(5), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4144), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [122010] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4505), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
  [122020] = 4,
    ACTIONS(2078), 1,
      anon_sym_RPAREN,
    ACTIONS(5306), 1,
      anon_sym_COMMA,
    STATE(2958), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [122034] = 3,
    ACTIONS(4039), 1,
      aux_sym_format_specifier_token1,
    ACTIONS(5), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4041), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [122046] = 4,
    ACTIONS(2082), 1,
      anon_sym_RPAREN,
    ACTIONS(5308), 1,
      anon_sym_COMMA,
    STATE(2958), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [122060] = 3,
    ACTIONS(4156), 1,
      aux_sym_format_specifier_token1,
    ACTIONS(5), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4158), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [122072] = 4,
    ACTIONS(5310), 1,
      anon_sym_COMMA,
    ACTIONS(5312), 1,
      anon_sym_RBRACK,
    STATE(2967), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [122086] = 4,
    ACTIONS(5314), 1,
      anon_sym_COMMA,
    ACTIONS(5316), 1,
      anon_sym_RBRACK,
    STATE(2967), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [122100] = 3,
    ACTIONS(4167), 1,
      aux_sym_format_specifier_token1,
    ACTIONS(5), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4169), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [122112] = 4,
    ACTIONS(5318), 1,
      anon_sym_COMMA,
    ACTIONS(5321), 1,
      sym__dedent,
    STATE(2849), 1,
      aux_sym___directive_parameters_wc_none_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [122126] = 4,
    ACTIONS(1902), 1,
      sym__dedent,
    ACTIONS(5323), 1,
      anon_sym_COMMA,
    STATE(2939), 1,
      aux_sym___directive_parameters_wc_none_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [122140] = 4,
    ACTIONS(1786), 1,
      anon_sym_RBRACK,
    ACTIONS(5325), 1,
      anon_sym_COMMA,
    STATE(2980), 1,
      aux_sym_type_parameter_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [122154] = 4,
    ACTIONS(4928), 1,
      sym__newline,
    ACTIONS(4930), 1,
      sym__indent,
    STATE(440), 1,
      sym__match_block,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [122168] = 4,
    ACTIONS(1890), 1,
      sym__dedent,
    ACTIONS(5327), 1,
      anon_sym_COMMA,
    STATE(2849), 1,
      aux_sym___directive_parameters_wc_none_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [122182] = 4,
    ACTIONS(4808), 1,
      sym_identifier,
    STATE(2878), 1,
      sym_dotted_name,
    STATE(3148), 1,
      sym_aliased_import,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [122196] = 3,
    ACTIONS(4063), 1,
      aux_sym_format_specifier_token1,
    ACTIONS(5), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4065), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [122208] = 3,
    ACTIONS(4077), 1,
      aux_sym_format_specifier_token1,
    ACTIONS(5), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4079), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [122220] = 3,
    ACTIONS(4085), 1,
      aux_sym_format_specifier_token1,
    ACTIONS(5), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4087), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [122232] = 3,
    ACTIONS(1060), 1,
      anon_sym_except,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1062), 2,
      anon_sym_except_STAR,
      anon_sym_finally,
  [122244] = 4,
    ACTIONS(5277), 1,
      anon_sym_RPAREN,
    ACTIONS(5329), 1,
      anon_sym_COMMA,
    STATE(2859), 1,
      aux_sym__parameters_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [122258] = 4,
    ACTIONS(4794), 1,
      anon_sym_RPAREN,
    ACTIONS(5332), 1,
      anon_sym_COMMA,
    STATE(2876), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [122272] = 4,
    ACTIONS(1102), 1,
      anon_sym_from,
    ACTIONS(5334), 1,
      anon_sym_COMMA,
    STATE(2861), 1,
      aux_sym_global_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [122286] = 4,
    ACTIONS(2002), 1,
      anon_sym_RPAREN,
    ACTIONS(5337), 1,
      anon_sym_COMMA,
    STATE(2958), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [122300] = 4,
    ACTIONS(1902), 1,
      sym__newline,
    ACTIONS(5339), 1,
      anon_sym_COMMA,
    STATE(2941), 1,
      aux_sym___directive_parameters_wc_none_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [122314] = 4,
    ACTIONS(2158), 1,
      anon_sym_RPAREN,
    ACTIONS(5341), 1,
      anon_sym_COMMA,
    STATE(2958), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [122328] = 4,
    ACTIONS(5261), 1,
      anon_sym_RPAREN,
    ACTIONS(5343), 1,
      anon_sym_COMMA,
    STATE(2865), 1,
      aux_sym_with_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [122342] = 4,
    ACTIONS(5346), 1,
      anon_sym_COMMA,
    ACTIONS(5348), 1,
      sym__dedent,
    STATE(2943), 1,
      aux_sym_global_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [122356] = 4,
    ACTIONS(4928), 1,
      sym__newline,
    ACTIONS(4930), 1,
      sym__indent,
    STATE(512), 1,
      sym__match_block,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [122370] = 4,
    ACTIONS(2098), 1,
      sym__dedent,
    ACTIONS(5350), 1,
      anon_sym_COMMA,
    STATE(2879), 1,
      aux_sym___directive_parameters_wc_none_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [122384] = 4,
    ACTIONS(4329), 1,
      anon_sym_RBRACK,
    ACTIONS(5352), 1,
      anon_sym_COMMA,
    STATE(2869), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [122398] = 4,
    ACTIONS(4940), 1,
      sym_identifier,
    ACTIONS(5348), 1,
      sym__newline,
    ACTIONS(5355), 1,
      sym__indent,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [122412] = 4,
    ACTIONS(5348), 1,
      sym__newline,
    ACTIONS(5357), 1,
      anon_sym_COMMA,
    STATE(2600), 1,
      aux_sym_global_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [122426] = 4,
    ACTIONS(4089), 1,
      anon_sym_COMMA,
    ACTIONS(4091), 1,
      anon_sym_RBRACK,
    STATE(2827), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [122440] = 4,
    ACTIONS(5359), 1,
      anon_sym_COMMA,
    ACTIONS(5361), 1,
      anon_sym_RBRACE,
    STATE(2888), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [122454] = 4,
    ACTIONS(5363), 1,
      anon_sym_RPAREN,
    ACTIONS(5365), 1,
      anon_sym_COMMA,
    STATE(2862), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [122468] = 4,
    ACTIONS(3906), 1,
      anon_sym_RPAREN,
    ACTIONS(3908), 1,
      anon_sym_COMMA,
    STATE(2864), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [122482] = 4,
    ACTIONS(4915), 1,
      anon_sym_RPAREN,
    ACTIONS(5367), 1,
      anon_sym_COMMA,
    STATE(2876), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [122496] = 4,
    ACTIONS(2230), 1,
      anon_sym_RBRACE,
    ACTIONS(5370), 1,
      anon_sym_COMMA,
    STATE(2822), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [122510] = 3,
    ACTIONS(4913), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4770), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [122522] = 4,
    ACTIONS(2114), 1,
      sym__dedent,
    ACTIONS(5372), 1,
      anon_sym_COMMA,
    STATE(2849), 1,
      aux_sym___directive_parameters_wc_none_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [122536] = 4,
    ACTIONS(2114), 1,
      sym__dedent,
    ACTIONS(5372), 1,
      anon_sym_COMMA,
    STATE(2893), 1,
      aux_sym___directive_parameters_wc_none_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [122550] = 4,
    ACTIONS(4684), 1,
      anon_sym_COLON,
    ACTIONS(5374), 1,
      anon_sym_RBRACE,
    STATE(3176), 1,
      sym_format_specifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [122564] = 3,
    ACTIONS(4119), 1,
      aux_sym_format_specifier_token1,
    ACTIONS(5), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4121), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [122576] = 4,
    ACTIONS(3428), 1,
      anon_sym_RPAREN,
    ACTIONS(5376), 1,
      anon_sym_COMMA,
    STATE(2833), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [122590] = 4,
    ACTIONS(3612), 1,
      anon_sym_RPAREN,
    ACTIONS(5378), 1,
      anon_sym_COMMA,
    STATE(2884), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [122604] = 4,
    ACTIONS(3422), 1,
      anon_sym_RBRACK,
    ACTIONS(5381), 1,
      anon_sym_COMMA,
    STATE(2780), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [122618] = 4,
    ACTIONS(718), 1,
      sym__newline,
    ACTIONS(5383), 1,
      anon_sym_SEMI,
    STATE(2764), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [122632] = 4,
    ACTIONS(4212), 1,
      anon_sym_COMMA,
    ACTIONS(4214), 1,
      anon_sym_RBRACE,
    STATE(2877), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [122646] = 4,
    ACTIONS(5385), 1,
      anon_sym_COMMA,
    ACTIONS(5387), 1,
      anon_sym_RBRACE,
    STATE(2997), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [122660] = 3,
    ACTIONS(1068), 1,
      anon_sym_except,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1070), 2,
      anon_sym_except_STAR,
      anon_sym_finally,
  [122672] = 4,
    ACTIONS(5389), 1,
      anon_sym_COMMA,
    ACTIONS(5391), 1,
      anon_sym_RBRACE,
    STATE(2997), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [122686] = 4,
    ACTIONS(5393), 1,
      anon_sym_from,
    ACTIONS(5395), 1,
      anon_sym_COMMA,
    STATE(2861), 1,
      aux_sym_global_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [122700] = 4,
    ACTIONS(5083), 1,
      sym__indent,
    ACTIONS(5397), 1,
      sym__newline,
    STATE(497), 1,
      sym__rule_suite,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [122714] = 4,
    ACTIONS(2052), 1,
      sym__dedent,
    ACTIONS(5399), 1,
      anon_sym_COMMA,
    STATE(2849), 1,
      aux_sym___directive_parameters_wc_none_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [122728] = 4,
    ACTIONS(5083), 1,
      sym__indent,
    ACTIONS(5401), 1,
      sym__newline,
    STATE(494), 1,
      sym__rule_suite,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [122742] = 4,
    ACTIONS(3742), 1,
      anon_sym_RPAREN,
    ACTIONS(5403), 1,
      anon_sym_COMMA,
    STATE(2859), 1,
      aux_sym__parameters_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [122756] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2536), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
  [122766] = 4,
    ACTIONS(3878), 1,
      anon_sym_COMMA,
    ACTIONS(3937), 1,
      anon_sym_RPAREN,
    STATE(2720), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [122780] = 4,
    ACTIONS(2589), 1,
      anon_sym_RBRACK,
    ACTIONS(5405), 1,
      anon_sym_COMMA,
    STATE(2796), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [122794] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3631), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
  [122804] = 4,
    ACTIONS(3402), 1,
      anon_sym_RPAREN,
    ACTIONS(5407), 1,
      anon_sym_COMMA,
    STATE(2833), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [122818] = 4,
    ACTIONS(2178), 1,
      anon_sym_RBRACK,
    ACTIONS(5409), 1,
      anon_sym_COMMA,
    STATE(2869), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [122832] = 4,
    ACTIONS(4794), 1,
      anon_sym_RPAREN,
    ACTIONS(5411), 1,
      anon_sym_COMMA,
    STATE(2876), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [122846] = 4,
    ACTIONS(4926), 1,
      sym__indent,
    ACTIONS(5413), 1,
      sym__newline,
    STATE(433), 1,
      sym__rule_suite,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [122860] = 3,
    ACTIONS(1090), 1,
      anon_sym_except,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1092), 2,
      anon_sym_except_STAR,
      anon_sym_finally,
  [122872] = 4,
    ACTIONS(2076), 1,
      anon_sym_RPAREN,
    ACTIONS(5415), 1,
      anon_sym_COMMA,
    STATE(2958), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [122886] = 3,
    ACTIONS(5417), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4820), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [122898] = 4,
    ACTIONS(2060), 1,
      anon_sym_RPAREN,
    ACTIONS(5419), 1,
      anon_sym_COMMA,
    STATE(2958), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [122912] = 3,
    ACTIONS(4824), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4820), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [122924] = 4,
    ACTIONS(5025), 1,
      anon_sym_RPAREN,
    ACTIONS(5421), 1,
      anon_sym_COMMA,
    STATE(2895), 1,
      aux_sym__parameters_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [122938] = 4,
    ACTIONS(5423), 1,
      anon_sym_SEMI,
    ACTIONS(5425), 1,
      sym__newline,
    STATE(2886), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [122952] = 4,
    ACTIONS(4980), 1,
      anon_sym_RBRACK,
    ACTIONS(5427), 1,
      anon_sym_COMMA,
    STATE(2898), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [122966] = 4,
    ACTIONS(3805), 1,
      anon_sym_RBRACK,
    ACTIONS(3836), 1,
      anon_sym_COMMA,
    STATE(2901), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [122980] = 4,
    ACTIONS(5429), 1,
      anon_sym_SEMI,
    ACTIONS(5431), 1,
      sym__newline,
    STATE(2934), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [122994] = 4,
    ACTIONS(5433), 1,
      anon_sym_COMMA,
    ACTIONS(5435), 1,
      anon_sym_RBRACK,
    STATE(2967), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123008] = 4,
    ACTIONS(4566), 1,
      anon_sym_RPAREN,
    ACTIONS(4911), 1,
      anon_sym_COMMA,
    STATE(2860), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123022] = 4,
    ACTIONS(5437), 1,
      anon_sym_COMMA,
    ACTIONS(5439), 1,
      anon_sym_RBRACK,
    STATE(2967), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123036] = 3,
    ACTIONS(5443), 1,
      aux_sym_format_specifier_token1,
    ACTIONS(5), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(5441), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [123048] = 4,
    ACTIONS(4684), 1,
      anon_sym_COLON,
    ACTIONS(5445), 1,
      anon_sym_RBRACE,
    STATE(3282), 1,
      sym_format_specifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123062] = 4,
    ACTIONS(3878), 1,
      anon_sym_COMMA,
    ACTIONS(3910), 1,
      anon_sym_RPAREN,
    STATE(2720), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123076] = 4,
    ACTIONS(4296), 1,
      sym_identifier,
    STATE(2541), 1,
      sym_dotted_name,
    STATE(2787), 1,
      sym_aliased_import,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123090] = 4,
    ACTIONS(4946), 1,
      anon_sym_COMMA,
    ACTIONS(5447), 1,
      anon_sym_in,
    STATE(2690), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123104] = 4,
    ACTIONS(5449), 1,
      anon_sym_COMMA,
    ACTIONS(5451), 1,
      anon_sym_RBRACK,
    STATE(2967), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123118] = 4,
    ACTIONS(5453), 1,
      anon_sym_COMMA,
    ACTIONS(5455), 1,
      anon_sym_RBRACK,
    STATE(2967), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123132] = 4,
    ACTIONS(2150), 1,
      anon_sym_RPAREN,
    ACTIONS(5457), 1,
      anon_sym_COMMA,
    STATE(2958), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123146] = 4,
    ACTIONS(2088), 1,
      anon_sym_RPAREN,
    ACTIONS(5459), 1,
      anon_sym_COMMA,
    STATE(2958), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123160] = 4,
    ACTIONS(5121), 1,
      sym__newline,
    ACTIONS(5123), 1,
      sym__indent,
    STATE(430), 1,
      sym__match_block,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123174] = 4,
    ACTIONS(2028), 1,
      sym__dedent,
    ACTIONS(5461), 1,
      anon_sym_COMMA,
    STATE(2849), 1,
      aux_sym___directive_parameters_wc_none_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123188] = 4,
    ACTIONS(4101), 1,
      anon_sym_COMMA,
    ACTIONS(4103), 1,
      anon_sym_RBRACK,
    STATE(2922), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123202] = 4,
    ACTIONS(4246), 1,
      anon_sym_COMMA,
    ACTIONS(4248), 1,
      anon_sym_RBRACE,
    STATE(2944), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123216] = 3,
    ACTIONS(1056), 1,
      anon_sym_except,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1058), 2,
      anon_sym_except_STAR,
      anon_sym_finally,
  [123228] = 4,
    ACTIONS(5463), 1,
      anon_sym_RPAREN,
    ACTIONS(5465), 1,
      anon_sym_COMMA,
    STATE(2924), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123242] = 4,
    ACTIONS(3914), 1,
      anon_sym_RPAREN,
    ACTIONS(3916), 1,
      anon_sym_COMMA,
    STATE(2925), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123256] = 4,
    ACTIONS(2032), 1,
      sym__dedent,
    ACTIONS(5467), 1,
      anon_sym_COMMA,
    STATE(2849), 1,
      aux_sym___directive_parameters_wc_none_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123270] = 4,
    ACTIONS(730), 1,
      sym__newline,
    ACTIONS(5469), 1,
      anon_sym_SEMI,
    STATE(2764), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123284] = 4,
    ACTIONS(2244), 1,
      anon_sym_RBRACE,
    ACTIONS(5471), 1,
      anon_sym_COMMA,
    STATE(2822), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123298] = 4,
    ACTIONS(1782), 1,
      anon_sym_RBRACK,
    ACTIONS(5473), 1,
      anon_sym_COMMA,
    STATE(2980), 1,
      aux_sym_type_parameter_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123312] = 4,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4587), 1,
      anon_sym_PIPE,
    ACTIONS(5475), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123326] = 4,
    ACTIONS(738), 1,
      sym__newline,
    ACTIONS(5477), 1,
      anon_sym_SEMI,
    STATE(2764), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123340] = 4,
    ACTIONS(1972), 1,
      sym__dedent,
    ACTIONS(5479), 1,
      anon_sym_COMMA,
    STATE(2849), 1,
      aux_sym___directive_parameters_wc_none_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123354] = 4,
    ACTIONS(4274), 1,
      anon_sym_COMMA,
    ACTIONS(4276), 1,
      anon_sym_RBRACE,
    STATE(2935), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123368] = 4,
    ACTIONS(5321), 1,
      sym__newline,
    ACTIONS(5481), 1,
      anon_sym_COMMA,
    STATE(2941), 1,
      aux_sym___directive_parameters_wc_none_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123382] = 4,
    ACTIONS(3878), 1,
      anon_sym_COMMA,
    ACTIONS(3902), 1,
      anon_sym_RPAREN,
    STATE(2720), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123396] = 4,
    ACTIONS(5484), 1,
      anon_sym_COMMA,
    ACTIONS(5486), 1,
      sym__dedent,
    STATE(2784), 1,
      aux_sym_global_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123410] = 4,
    ACTIONS(2240), 1,
      anon_sym_RBRACE,
    ACTIONS(5488), 1,
      anon_sym_COMMA,
    STATE(2822), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123424] = 4,
    ACTIONS(5490), 1,
      anon_sym_RPAREN,
    ACTIONS(5492), 1,
      anon_sym_COMMA,
    STATE(2957), 1,
      aux_sym_global_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123438] = 4,
    ACTIONS(4940), 1,
      sym_identifier,
    ACTIONS(5486), 1,
      sym__newline,
    ACTIONS(5494), 1,
      sym__indent,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123452] = 4,
    ACTIONS(5496), 1,
      anon_sym_SEMI,
    ACTIONS(5498), 1,
      sym__newline,
    STATE(2938), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123466] = 4,
    ACTIONS(2040), 1,
      sym__dedent,
    ACTIONS(5500), 1,
      anon_sym_COMMA,
    STATE(2927), 1,
      aux_sym___directive_parameters_wc_none_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123480] = 3,
    ACTIONS(5502), 1,
      sym__ALLOW_WC_DEF,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1830), 2,
      sym___directive_parameters_wc_def,
      sym__directive_parameters_wc_def,
  [123492] = 4,
    ACTIONS(3880), 1,
      anon_sym_RPAREN,
    ACTIONS(3882), 1,
      anon_sym_COMMA,
    STATE(2961), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123506] = 4,
    ACTIONS(5504), 1,
      anon_sym_RPAREN,
    ACTIONS(5506), 1,
      anon_sym_COMMA,
    STATE(2963), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123520] = 4,
    ACTIONS(2040), 1,
      sym__dedent,
    ACTIONS(5500), 1,
      anon_sym_COMMA,
    STATE(2849), 1,
      aux_sym___directive_parameters_wc_none_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123534] = 3,
    ACTIONS(5508), 1,
      sym__ALLOW_WC_INTERP,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1821), 2,
      sym___directive_parameters_wc_interp,
      sym__directive_parameters_wc_interp,
  [123546] = 4,
    ACTIONS(4081), 1,
      anon_sym_COMMA,
    ACTIONS(4083), 1,
      anon_sym_RBRACK,
    STATE(2966), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123560] = 4,
    ACTIONS(2042), 1,
      sym__dedent,
    ACTIONS(5510), 1,
      anon_sym_COMMA,
    STATE(2933), 1,
      aux_sym___directive_parameters_wc_none_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123574] = 4,
    ACTIONS(2042), 1,
      sym__dedent,
    ACTIONS(5510), 1,
      anon_sym_COMMA,
    STATE(2849), 1,
      aux_sym___directive_parameters_wc_none_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123588] = 4,
    ACTIONS(5512), 1,
      anon_sym_RPAREN,
    ACTIONS(5514), 1,
      anon_sym_COMMA,
    STATE(2774), 1,
      aux_sym_global_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123602] = 4,
    ACTIONS(4421), 1,
      anon_sym_RPAREN,
    ACTIONS(5516), 1,
      anon_sym_COMMA,
    STATE(2958), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123616] = 4,
    ACTIONS(5519), 1,
      anon_sym_COMMA,
    ACTIONS(5521), 1,
      anon_sym_RBRACK,
    STATE(2967), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123630] = 4,
    ACTIONS(5523), 1,
      anon_sym_COMMA,
    ACTIONS(5525), 1,
      anon_sym_RBRACK,
    STATE(2967), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123644] = 4,
    ACTIONS(2048), 1,
      anon_sym_RPAREN,
    ACTIONS(5527), 1,
      anon_sym_COMMA,
    STATE(2958), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123658] = 4,
    ACTIONS(2116), 1,
      anon_sym_RPAREN,
    ACTIONS(5529), 1,
      anon_sym_COMMA,
    STATE(2958), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123672] = 4,
    ACTIONS(2054), 1,
      anon_sym_RPAREN,
    ACTIONS(5531), 1,
      anon_sym_COMMA,
    STATE(2958), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123686] = 4,
    ACTIONS(2050), 1,
      sym__dedent,
    ACTIONS(5533), 1,
      anon_sym_COMMA,
    STATE(2952), 1,
      aux_sym___directive_parameters_wc_none_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123700] = 4,
    ACTIONS(5535), 1,
      anon_sym_COMMA,
    ACTIONS(5537), 1,
      anon_sym_RBRACK,
    STATE(2967), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123714] = 4,
    ACTIONS(5539), 1,
      anon_sym_COMMA,
    ACTIONS(5541), 1,
      anon_sym_RBRACK,
    STATE(2967), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123728] = 4,
    ACTIONS(5543), 1,
      anon_sym_COMMA,
    ACTIONS(5546), 1,
      anon_sym_RBRACK,
    STATE(2967), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123742] = 4,
    ACTIONS(1774), 1,
      anon_sym_RBRACK,
    ACTIONS(5548), 1,
      anon_sym_COMMA,
    STATE(2980), 1,
      aux_sym_type_parameter_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123756] = 4,
    ACTIONS(2056), 1,
      sym__dedent,
    ACTIONS(5550), 1,
      anon_sym_COMMA,
    STATE(2956), 1,
      aux_sym___directive_parameters_wc_none_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123770] = 4,
    ACTIONS(2122), 1,
      anon_sym_RPAREN,
    ACTIONS(5552), 1,
      anon_sym_COMMA,
    STATE(2958), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123784] = 4,
    ACTIONS(4175), 1,
      anon_sym_COMMA,
    ACTIONS(4177), 1,
      anon_sym_RBRACK,
    STATE(2959), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123798] = 4,
    ACTIONS(5554), 1,
      anon_sym_RPAREN,
    ACTIONS(5556), 1,
      anon_sym_COMMA,
    STATE(2962), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123812] = 4,
    ACTIONS(3926), 1,
      anon_sym_RPAREN,
    ACTIONS(3928), 1,
      anon_sym_COMMA,
    STATE(2970), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123826] = 4,
    ACTIONS(2232), 1,
      anon_sym_RBRACE,
    ACTIONS(5558), 1,
      anon_sym_COMMA,
    STATE(2822), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123840] = 4,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4587), 1,
      anon_sym_PIPE,
    ACTIONS(5560), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123854] = 4,
    ACTIONS(740), 1,
      sym__newline,
    ACTIONS(5562), 1,
      anon_sym_SEMI,
    STATE(2764), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123868] = 4,
    ACTIONS(4926), 1,
      sym__indent,
    ACTIONS(5564), 1,
      sym__newline,
    STATE(422), 1,
      sym__rule_suite,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123882] = 4,
    ACTIONS(4926), 1,
      sym__indent,
    ACTIONS(5566), 1,
      sym__newline,
    STATE(421), 1,
      sym__rule_suite,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123896] = 4,
    ACTIONS(1940), 1,
      sym__dedent,
    ACTIONS(5568), 1,
      anon_sym_COMMA,
    STATE(2849), 1,
      aux_sym___directive_parameters_wc_none_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123910] = 4,
    ACTIONS(4540), 1,
      anon_sym_RBRACK,
    ACTIONS(5570), 1,
      anon_sym_COMMA,
    STATE(2980), 1,
      aux_sym_type_parameter_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123924] = 4,
    ACTIONS(5573), 1,
      anon_sym_COMMA,
    ACTIONS(5575), 1,
      anon_sym_RBRACE,
    STATE(2992), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123938] = 4,
    ACTIONS(1918), 1,
      sym__dedent,
    ACTIONS(5577), 1,
      anon_sym_COMMA,
    STATE(2849), 1,
      aux_sym___directive_parameters_wc_none_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123952] = 4,
    ACTIONS(4286), 1,
      anon_sym_COMMA,
    ACTIONS(4288), 1,
      anon_sym_RBRACE,
    STATE(2974), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123966] = 4,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4587), 1,
      anon_sym_PIPE,
    ACTIONS(5579), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123980] = 4,
    ACTIONS(2038), 1,
      sym__dedent,
    ACTIONS(5581), 1,
      anon_sym_COMMA,
    STATE(3002), 1,
      aux_sym___directive_parameters_wc_none_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [123994] = 4,
    ACTIONS(3878), 1,
      anon_sym_COMMA,
    ACTIONS(3939), 1,
      anon_sym_RPAREN,
    STATE(2720), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124008] = 4,
    ACTIONS(3416), 1,
      anon_sym_RPAREN,
    ACTIONS(5583), 1,
      anon_sym_COMMA,
    STATE(2833), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124022] = 4,
    ACTIONS(5585), 1,
      anon_sym_COMMA,
    ACTIONS(5587), 1,
      sym__dedent,
    STATE(3015), 1,
      aux_sym_global_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124036] = 4,
    ACTIONS(3392), 1,
      anon_sym_RBRACK,
    ACTIONS(5589), 1,
      anon_sym_COMMA,
    STATE(2780), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124050] = 4,
    ACTIONS(5591), 1,
      anon_sym_SEMI,
    ACTIONS(5593), 1,
      sym__newline,
    STATE(2976), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124064] = 4,
    ACTIONS(4465), 1,
      anon_sym_PIPE,
    ACTIONS(5595), 1,
      anon_sym_COLON,
    STATE(2395), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124078] = 4,
    ACTIONS(5597), 1,
      anon_sym_COMMA,
    ACTIONS(5599), 1,
      anon_sym_RBRACE,
    STATE(2997), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124092] = 4,
    ACTIONS(5601), 1,
      anon_sym_COMMA,
    ACTIONS(5603), 1,
      anon_sym_RBRACE,
    STATE(3023), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124106] = 4,
    ACTIONS(5605), 1,
      anon_sym_COMMA,
    ACTIONS(5607), 1,
      anon_sym_RBRACE,
    STATE(2997), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124120] = 4,
    ACTIONS(4581), 1,
      anon_sym_DOT,
    ACTIONS(4587), 1,
      anon_sym_PIPE,
    ACTIONS(5609), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124134] = 4,
    ACTIONS(3366), 1,
      anon_sym_RPAREN,
    ACTIONS(5611), 1,
      anon_sym_COMMA,
    STATE(2833), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124148] = 4,
    ACTIONS(5613), 1,
      anon_sym_COMMA,
    ACTIONS(5616), 1,
      anon_sym_RBRACE,
    STATE(2997), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124162] = 4,
    ACTIONS(5618), 1,
      anon_sym_COMMA,
    ACTIONS(5620), 1,
      anon_sym_RBRACK,
    STATE(2967), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124176] = 3,
    ACTIONS(5624), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(5622), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [124188] = 4,
    ACTIONS(5626), 1,
      anon_sym_COMMA,
    ACTIONS(5628), 1,
      anon_sym_RBRACK,
    STATE(2967), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124202] = 4,
    ACTIONS(3414), 1,
      anon_sym_RPAREN,
    ACTIONS(5630), 1,
      anon_sym_COMMA,
    STATE(2833), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124216] = 4,
    ACTIONS(2162), 1,
      sym__dedent,
    ACTIONS(5632), 1,
      anon_sym_COMMA,
    STATE(2849), 1,
      aux_sym___directive_parameters_wc_none_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124230] = 4,
    ACTIONS(2160), 1,
      anon_sym_RPAREN,
    ACTIONS(5634), 1,
      anon_sym_COMMA,
    STATE(2958), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124244] = 4,
    ACTIONS(1914), 1,
      sym__newline,
    ACTIONS(5636), 1,
      anon_sym_COMMA,
    STATE(2941), 1,
      aux_sym___directive_parameters_wc_none_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124258] = 4,
    ACTIONS(1914), 1,
      sym__dedent,
    ACTIONS(5638), 1,
      anon_sym_COMMA,
    STATE(2979), 1,
      aux_sym___directive_parameters_wc_none_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124272] = 4,
    ACTIONS(3388), 1,
      anon_sym_RBRACK,
    ACTIONS(5640), 1,
      anon_sym_COMMA,
    STATE(2780), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124286] = 4,
    ACTIONS(1910), 1,
      sym__newline,
    ACTIONS(5642), 1,
      anon_sym_COMMA,
    STATE(2941), 1,
      aux_sym___directive_parameters_wc_none_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124300] = 4,
    ACTIONS(1910), 1,
      sym__dedent,
    ACTIONS(5644), 1,
      anon_sym_COMMA,
    STATE(2982), 1,
      aux_sym___directive_parameters_wc_none_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124314] = 4,
    ACTIONS(724), 1,
      sym__newline,
    ACTIONS(5646), 1,
      anon_sym_SEMI,
    STATE(2764), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124328] = 4,
    ACTIONS(5648), 1,
      anon_sym_COMMA,
    ACTIONS(5650), 1,
      sym__dedent,
    STATE(2784), 1,
      aux_sym_global_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124342] = 4,
    ACTIONS(5652), 1,
      anon_sym_SEMI,
    ACTIONS(5654), 1,
      sym__newline,
    STATE(3009), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124356] = 4,
    ACTIONS(2156), 1,
      anon_sym_RPAREN,
    ACTIONS(5656), 1,
      anon_sym_COMMA,
    STATE(2958), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124370] = 4,
    ACTIONS(3386), 1,
      anon_sym_RPAREN,
    ACTIONS(5658), 1,
      anon_sym_COMMA,
    STATE(2833), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124384] = 4,
    ACTIONS(2120), 1,
      sym__dedent,
    ACTIONS(5660), 1,
      anon_sym_COMMA,
    STATE(2849), 1,
      aux_sym___directive_parameters_wc_none_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124398] = 4,
    ACTIONS(4920), 1,
      anon_sym_COMMA,
    ACTIONS(4922), 1,
      sym__dedent,
    STATE(2784), 1,
      aux_sym_global_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124412] = 4,
    ACTIONS(3884), 1,
      anon_sym_RPAREN,
    ACTIONS(3886), 1,
      anon_sym_COMMA,
    STATE(3012), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124426] = 4,
    ACTIONS(3878), 1,
      anon_sym_COMMA,
    ACTIONS(3912), 1,
      anon_sym_RPAREN,
    STATE(2720), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124440] = 4,
    ACTIONS(5662), 1,
      anon_sym_RPAREN,
    ACTIONS(5664), 1,
      anon_sym_COMMA,
    STATE(3003), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124454] = 4,
    ACTIONS(2148), 1,
      sym__newline,
    ACTIONS(5666), 1,
      anon_sym_COMMA,
    STATE(3004), 1,
      aux_sym___directive_parameters_wc_none_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124468] = 4,
    ACTIONS(5668), 1,
      anon_sym_COMMA,
    ACTIONS(5670), 1,
      anon_sym_RBRACE,
    STATE(2997), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124482] = 4,
    ACTIONS(2162), 1,
      sym__dedent,
    ACTIONS(5632), 1,
      anon_sym_COMMA,
    STATE(3014), 1,
      aux_sym___directive_parameters_wc_none_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124496] = 4,
    ACTIONS(4926), 1,
      sym__indent,
    ACTIONS(5672), 1,
      sym__newline,
    STATE(345), 1,
      sym__rule_suite,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124510] = 4,
    ACTIONS(5674), 1,
      anon_sym_COMMA,
    ACTIONS(5676), 1,
      anon_sym_RBRACE,
    STATE(2997), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124524] = 4,
    ACTIONS(2222), 1,
      anon_sym_RBRACE,
    ACTIONS(5678), 1,
      anon_sym_COMMA,
    STATE(2822), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124538] = 4,
    ACTIONS(4313), 1,
      anon_sym_COMMA,
    ACTIONS(4315), 1,
      anon_sym_RBRACE,
    STATE(3024), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124552] = 4,
    ACTIONS(4055), 1,
      anon_sym_COMMA,
    ACTIONS(4057), 1,
      anon_sym_RBRACK,
    STATE(2998), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124566] = 4,
    ACTIONS(2154), 1,
      sym__newline,
    ACTIONS(5680), 1,
      anon_sym_COMMA,
    STATE(3007), 1,
      aux_sym___directive_parameters_wc_none_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124580] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1102), 2,
      anon_sym_from,
      anon_sym_COMMA,
  [124589] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2492), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [124598] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(5682), 2,
      sym__newline,
      anon_sym_SEMI,
  [124607] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(5684), 2,
      sym__newline,
      anon_sym_SEMI,
  [124616] = 3,
    ACTIONS(5650), 1,
      sym__dedent,
    ACTIONS(5686), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124627] = 3,
    ACTIONS(5688), 1,
      sym_identifier,
    ACTIONS(5690), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124638] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(5692), 2,
      sym__dedent,
      anon_sym_case,
  [124647] = 3,
    ACTIONS(5694), 1,
      sym_identifier,
    ACTIONS(5696), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124658] = 3,
    ACTIONS(4756), 1,
      anon_sym_LPAREN,
    STATE(3062), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124669] = 3,
    ACTIONS(4756), 1,
      anon_sym_LPAREN,
    STATE(3066), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124680] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3866), 2,
      sym__newline,
      anon_sym_SEMI,
  [124689] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(5698), 2,
      sym__newline,
      anon_sym_SEMI,
  [124698] = 3,
    ACTIONS(5700), 1,
      sym_integer,
    ACTIONS(5702), 1,
      sym_float,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124709] = 3,
    ACTIONS(4978), 1,
      sym__dedent,
    ACTIONS(5686), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124720] = 3,
    ACTIONS(4978), 1,
      sym__dedent,
    ACTIONS(5704), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124731] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(5706), 2,
      anon_sym__,
      sym_identifier,
  [124740] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4173), 2,
      sym__newline,
      anon_sym_SEMI,
  [124749] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4154), 2,
      sym__newline,
      anon_sym_SEMI,
  [124758] = 3,
    ACTIONS(5708), 1,
      sym_integer,
    ACTIONS(5710), 1,
      sym_float,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124769] = 3,
    ACTIONS(5009), 1,
      sym__dedent,
    ACTIONS(5712), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124780] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(5714), 2,
      sym__newline,
      anon_sym_SEMI,
  [124789] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(5716), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [124798] = 3,
    ACTIONS(5029), 1,
      sym__dedent,
    ACTIONS(5686), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124809] = 3,
    ACTIONS(5029), 1,
      sym__dedent,
    ACTIONS(5718), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124820] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4820), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [124829] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4820), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [124838] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3975), 2,
      sym__newline,
      anon_sym_SEMI,
  [124847] = 3,
    ACTIONS(4922), 1,
      sym__dedent,
    ACTIONS(5686), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124858] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(5720), 2,
      sym__dedent,
      anon_sym_case,
  [124867] = 3,
    ACTIONS(5722), 1,
      sym_identifier,
    STATE(325), 1,
      sym_rule_exclude_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124878] = 3,
    ACTIONS(5724), 1,
      anon_sym_COMMA,
    STATE(2346), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124889] = 3,
    ACTIONS(5726), 1,
      sym_integer,
    ACTIONS(5728), 1,
      sym_float,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124900] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(5730), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [124909] = 3,
    ACTIONS(5091), 1,
      sym__dedent,
    ACTIONS(5686), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124920] = 3,
    ACTIONS(5732), 1,
      anon_sym_COLON,
    ACTIONS(5734), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124931] = 3,
    ACTIONS(5736), 1,
      sym_integer,
    ACTIONS(5738), 1,
      sym_float,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124942] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(5740), 2,
      sym__dedent,
      anon_sym_case,
  [124951] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(5742), 2,
      sym__dedent,
      anon_sym_case,
  [124960] = 3,
    ACTIONS(5744), 1,
      anon_sym_COLON,
    ACTIONS(5746), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124971] = 3,
    ACTIONS(5748), 1,
      sym_identifier,
    STATE(326), 1,
      sym_rule_exclude_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124982] = 3,
    ACTIONS(5750), 1,
      sym_integer,
    ACTIONS(5752), 1,
      sym_float,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [124993] = 3,
    ACTIONS(5754), 1,
      anon_sym_COLON,
    ACTIONS(5756), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [125004] = 3,
    ACTIONS(5758), 1,
      anon_sym_COLON,
    ACTIONS(5760), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [125015] = 3,
    ACTIONS(5762), 1,
      sym_identifier,
    ACTIONS(5764), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [125026] = 3,
    ACTIONS(5766), 1,
      anon_sym_COLON,
    ACTIONS(5768), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [125037] = 3,
    ACTIONS(5135), 1,
      sym__dedent,
    ACTIONS(5686), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [125048] = 3,
    ACTIONS(5486), 1,
      sym__dedent,
    ACTIONS(5770), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [125059] = 3,
    ACTIONS(5587), 1,
      sym__dedent,
    ACTIONS(5772), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [125070] = 3,
    ACTIONS(5774), 1,
      sym_integer,
    ACTIONS(5776), 1,
      sym_float,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [125081] = 3,
    ACTIONS(5141), 1,
      sym__dedent,
    ACTIONS(5778), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [125092] = 3,
    ACTIONS(5780), 1,
      sym_identifier,
    ACTIONS(5782), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [125103] = 3,
    ACTIONS(5587), 1,
      sym__dedent,
    ACTIONS(5686), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [125114] = 3,
    ACTIONS(5686), 1,
      sym_identifier,
    ACTIONS(5784), 1,
      sym__dedent,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [125125] = 3,
    ACTIONS(5786), 1,
      sym_identifier,
    ACTIONS(5788), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [125136] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1092), 2,
      sym__dedent,
      anon_sym_case,
  [125145] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1058), 2,
      sym__dedent,
      anon_sym_case,
  [125154] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1062), 2,
      sym__dedent,
      anon_sym_case,
  [125163] = 3,
    ACTIONS(5790), 1,
      sym_integer,
    ACTIONS(5792), 1,
      sym_float,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [125174] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1066), 2,
      sym__dedent,
      anon_sym_case,
  [125183] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(5162), 2,
      sym__newline,
      anon_sym_SEMI,
  [125192] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1070), 2,
      sym__dedent,
      anon_sym_case,
  [125201] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(5794), 2,
      sym__newline,
      anon_sym_SEMI,
  [125210] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(5796), 2,
      sym__newline,
      anon_sym_SEMI,
  [125219] = 3,
    ACTIONS(5798), 1,
      sym_integer,
    ACTIONS(5800), 1,
      sym_float,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [125230] = 3,
    ACTIONS(5686), 1,
      sym_identifier,
    ACTIONS(5802), 1,
      sym__dedent,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [125241] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1102), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [125250] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3975), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [125259] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1102), 2,
      sym__dedent,
      anon_sym_COMMA,
  [125268] = 3,
    ACTIONS(5804), 1,
      sym_integer,
    ACTIONS(5806), 1,
      sym_float,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [125279] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(5808), 2,
      sym__dedent,
      anon_sym_case,
  [125288] = 3,
    ACTIONS(5810), 1,
      anon_sym_COMMA,
    ACTIONS(5812), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [125299] = 3,
    ACTIONS(4756), 1,
      anon_sym_LPAREN,
    STATE(3131), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [125310] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(5814), 2,
      anon_sym__,
      sym_identifier,
  [125319] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(5816), 2,
      sym__newline,
      anon_sym_SEMI,
  [125328] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4329), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [125337] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(5818), 2,
      anon_sym__,
      sym_identifier,
  [125346] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(5820), 2,
      sym__dedent,
      anon_sym_case,
  [125355] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(5822), 2,
      sym__newline,
      anon_sym_SEMI,
  [125364] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(5824), 2,
      sym__newline,
      anon_sym_SEMI,
  [125373] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(5826), 2,
      sym__dedent,
      anon_sym_case,
  [125382] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(5828), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [125391] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(5830), 2,
      sym__newline,
      anon_sym_SEMI,
  [125400] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(5832), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [125409] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(5834), 2,
      sym__dedent,
      anon_sym_case,
  [125418] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(5836), 2,
      sym__newline,
      anon_sym_SEMI,
  [125427] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(5832), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [125436] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4216), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [125445] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(5828), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [125454] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(5838), 2,
      sym__dedent,
      anon_sym_case,
  [125463] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(5840), 2,
      sym__dedent,
      anon_sym_case,
  [125472] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(5842), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [125481] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4421), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [125490] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(5844), 2,
      sym__newline,
      anon_sym_SEMI,
  [125499] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4329), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [125508] = 3,
    ACTIONS(5846), 1,
      sym_identifier,
    ACTIONS(5848), 1,
      anon_sym_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [125519] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3637), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [125528] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(5850), 2,
      sym__dedent,
      anon_sym_case,
  [125537] = 3,
    ACTIONS(5512), 1,
      anon_sym_RPAREN,
    ACTIONS(5762), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [125548] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3631), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [125557] = 3,
    ACTIONS(5852), 1,
      anon_sym_COLON,
    ACTIONS(5854), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [125568] = 3,
    ACTIONS(4756), 1,
      anon_sym_LPAREN,
    STATE(3158), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [125579] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(5261), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [125588] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(5856), 2,
      anon_sym_COLON,
      anon_sym_DASH_GT,
  [125597] = 3,
    ACTIONS(5858), 1,
      anon_sym_COLON,
    ACTIONS(5860), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [125608] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(5270), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [125617] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2492), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [125626] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(5862), 2,
      sym__dedent,
      anon_sym_case,
  [125635] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(5277), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [125644] = 3,
    ACTIONS(5486), 1,
      sym__dedent,
    ACTIONS(5686), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [125655] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(5277), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [125664] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(5321), 2,
      sym__dedent,
      anon_sym_COMMA,
  [125673] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(5864), 2,
      anon_sym__,
      sym_identifier,
  [125682] = 3,
    ACTIONS(5866), 1,
      sym_integer,
    ACTIONS(5868), 1,
      sym_float,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [125693] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(5321), 2,
      sym__newline,
      anon_sym_COMMA,
  [125702] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(5261), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [125711] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4329), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [125720] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(5828), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [125729] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(5832), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [125738] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(5204), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [125747] = 3,
    ACTIONS(5870), 1,
      sym_integer,
    ACTIONS(5872), 1,
      sym_float,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [125758] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4770), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [125767] = 3,
    ACTIONS(5874), 1,
      sym_integer,
    ACTIONS(5876), 1,
      sym_float,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [125778] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3612), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [125787] = 3,
    ACTIONS(5846), 1,
      sym_identifier,
    ACTIONS(5878), 1,
      anon_sym_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [125798] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(5880), 2,
      sym__newline,
      anon_sym_SEMI,
  [125807] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3637), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [125816] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3975), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [125825] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(5882), 2,
      anon_sym_COLON,
      anon_sym_DASH_GT,
  [125834] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(4820), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [125843] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(5716), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [125852] = 3,
    ACTIONS(5884), 1,
      anon_sym_COLON,
    ACTIONS(5886), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [125863] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3612), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [125872] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(5888), 2,
      sym__dedent,
      anon_sym_case,
  [125881] = 3,
    ACTIONS(5890), 1,
      anon_sym_q,
    STATE(3280), 1,
      sym_flag,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [125892] = 2,
    ACTIONS(5892), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [125900] = 2,
    ACTIONS(5894), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [125908] = 2,
    ACTIONS(5896), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [125916] = 2,
    ACTIONS(5898), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [125924] = 2,
    ACTIONS(5900), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [125932] = 2,
    ACTIONS(5902), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [125940] = 2,
    ACTIONS(5904), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [125948] = 2,
    ACTIONS(5447), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [125956] = 2,
    ACTIONS(5906), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [125964] = 2,
    ACTIONS(5908), 1,
      sym__DISALLOW_WC,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [125972] = 2,
    ACTIONS(5910), 1,
      sym__DISALLOW_WC,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [125980] = 2,
    ACTIONS(5912), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [125988] = 2,
    ACTIONS(5914), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [125996] = 2,
    ACTIONS(5916), 1,
      sym__DISALLOW_WC,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126004] = 2,
    ACTIONS(5918), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126012] = 2,
    ACTIONS(5920), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126020] = 2,
    ACTIONS(5922), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126028] = 2,
    ACTIONS(5924), 1,
      sym__DISALLOW_WC,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126036] = 2,
    ACTIONS(5926), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126044] = 2,
    ACTIONS(5928), 1,
      sym_constraint,
    ACTIONS(5), 2,
      sym_comment,
      sym_line_continuation,
  [126052] = 2,
    ACTIONS(5930), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126060] = 2,
    ACTIONS(5932), 1,
      sym__DISALLOW_WC,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126068] = 2,
    ACTIONS(5934), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126076] = 2,
    ACTIONS(5936), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126084] = 2,
    ACTIONS(5938), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126092] = 2,
    ACTIONS(3914), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126100] = 2,
    ACTIONS(5940), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126108] = 2,
    ACTIONS(5942), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126116] = 2,
    ACTIONS(5944), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126124] = 2,
    ACTIONS(5946), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126132] = 2,
    ACTIONS(5948), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126140] = 2,
    ACTIONS(4214), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126148] = 2,
    ACTIONS(5950), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126156] = 2,
    ACTIONS(5952), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126164] = 2,
    ACTIONS(5954), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126172] = 2,
    ACTIONS(5956), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126180] = 2,
    ACTIONS(5958), 1,
      sym__DISALLOW_WC,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126188] = 2,
    ACTIONS(5960), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126196] = 2,
    ACTIONS(5962), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126204] = 2,
    ACTIONS(5964), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126212] = 2,
    ACTIONS(5966), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126220] = 2,
    ACTIONS(5968), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126228] = 2,
    ACTIONS(5970), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126236] = 2,
    ACTIONS(5972), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126244] = 2,
    ACTIONS(5974), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126252] = 2,
    ACTIONS(5976), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126260] = 2,
    ACTIONS(5978), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126268] = 2,
    ACTIONS(5980), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126276] = 2,
    ACTIONS(5982), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126284] = 2,
    ACTIONS(3906), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126292] = 2,
    ACTIONS(5984), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126300] = 2,
    ACTIONS(5986), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126308] = 2,
    ACTIONS(5988), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126316] = 2,
    ACTIONS(5990), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126324] = 2,
    ACTIONS(5992), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126332] = 2,
    ACTIONS(5994), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126340] = 2,
    ACTIONS(5996), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126348] = 2,
    ACTIONS(5762), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126356] = 2,
    ACTIONS(5998), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126364] = 2,
    ACTIONS(6000), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126372] = 2,
    ACTIONS(6002), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126380] = 2,
    ACTIONS(6004), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126388] = 2,
    ACTIONS(4276), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126396] = 2,
    ACTIONS(6006), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126404] = 2,
    ACTIONS(3933), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126412] = 2,
    ACTIONS(6008), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126420] = 2,
    ACTIONS(6010), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126428] = 2,
    ACTIONS(6012), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126436] = 2,
    ACTIONS(6014), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126444] = 2,
    ACTIONS(6016), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126452] = 2,
    ACTIONS(6018), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126460] = 2,
    ACTIONS(6020), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126468] = 2,
    ACTIONS(6022), 1,
      sym__DISALLOW_WC,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126476] = 2,
    ACTIONS(6024), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126484] = 2,
    ACTIONS(6026), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126492] = 2,
    ACTIONS(6028), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126500] = 2,
    ACTIONS(6030), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126508] = 2,
    ACTIONS(6032), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126516] = 2,
    ACTIONS(2364), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126524] = 2,
    ACTIONS(5686), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126532] = 2,
    ACTIONS(6034), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126540] = 2,
    ACTIONS(6036), 1,
      sym__DISALLOW_WC,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126548] = 2,
    ACTIONS(6038), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126556] = 2,
    ACTIONS(4250), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126564] = 2,
    ACTIONS(6040), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126572] = 2,
    ACTIONS(4222), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126580] = 2,
    ACTIONS(6042), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126588] = 2,
    ACTIONS(3880), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126596] = 2,
    ACTIONS(6044), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126604] = 2,
    ACTIONS(6046), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126612] = 2,
    ACTIONS(6048), 1,
      sym__DISALLOW_WC,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126620] = 2,
    ACTIONS(6050), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126628] = 2,
    ACTIONS(6052), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126636] = 2,
    ACTIONS(6054), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126644] = 2,
    ACTIONS(6056), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126652] = 2,
    ACTIONS(6058), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126660] = 2,
    ACTIONS(6060), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126668] = 2,
    ACTIONS(6062), 1,
      sym__DISALLOW_WC,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126676] = 2,
    ACTIONS(6064), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126684] = 2,
    ACTIONS(6066), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126692] = 2,
    ACTIONS(6068), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126700] = 2,
    ACTIONS(6070), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126708] = 2,
    ACTIONS(5227), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126716] = 2,
    ACTIONS(3850), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126724] = 2,
    ACTIONS(6072), 1,
      anon_sym_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126732] = 2,
    ACTIONS(4240), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126740] = 2,
    ACTIONS(6074), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126748] = 2,
    ACTIONS(6076), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126756] = 2,
    ACTIONS(6078), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126764] = 2,
    ACTIONS(6080), 1,
      anon_sym_with,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126772] = 2,
    ACTIONS(6082), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126780] = 2,
    ACTIONS(6084), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126788] = 2,
    ACTIONS(6086), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126796] = 2,
    ACTIONS(6088), 1,
      sym__DISALLOW_WC,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126804] = 2,
    ACTIONS(6090), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126812] = 2,
    ACTIONS(6092), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126820] = 2,
    ACTIONS(6094), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126828] = 2,
    ACTIONS(6096), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126836] = 2,
    ACTIONS(6098), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126844] = 2,
    ACTIONS(6100), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126852] = 2,
    ACTIONS(6102), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126860] = 2,
    ACTIONS(6104), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126868] = 2,
    ACTIONS(3926), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126876] = 2,
    ACTIONS(6106), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126884] = 2,
    ACTIONS(6108), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126892] = 2,
    ACTIONS(6110), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126900] = 2,
    ACTIONS(6112), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126908] = 2,
    ACTIONS(6114), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126916] = 2,
    ACTIONS(6116), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126924] = 2,
    ACTIONS(3888), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126932] = 2,
    ACTIONS(6118), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126940] = 2,
    ACTIONS(6120), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126948] = 2,
    ACTIONS(6122), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126956] = 2,
    ACTIONS(6124), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126964] = 2,
    ACTIONS(6126), 1,
      sym__DISALLOW_WC,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126972] = 2,
    ACTIONS(6128), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126980] = 2,
    ACTIONS(6130), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126988] = 2,
    ACTIONS(6132), 1,
      anon_sym_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [126996] = 2,
    ACTIONS(6134), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127004] = 2,
    ACTIONS(5880), 1,
      anon_sym_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127012] = 2,
    ACTIONS(6136), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127020] = 2,
    ACTIONS(6138), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127028] = 2,
    ACTIONS(6140), 1,
      sym__DISALLOW_WC,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127036] = 2,
    ACTIONS(4288), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127044] = 2,
    ACTIONS(6142), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127052] = 2,
    ACTIONS(6144), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127060] = 2,
    ACTIONS(6146), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127068] = 2,
    ACTIONS(4290), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127076] = 2,
    ACTIONS(6148), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127084] = 2,
    ACTIONS(6150), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127092] = 2,
    ACTIONS(6152), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127100] = 2,
    ACTIONS(6154), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127108] = 2,
    ACTIONS(6156), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127116] = 2,
    ACTIONS(6158), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127124] = 2,
    ACTIONS(6160), 1,
      sym__rule_import_as_pattern_target,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127132] = 2,
    ACTIONS(6162), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127140] = 2,
    ACTIONS(6164), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127148] = 2,
    ACTIONS(6166), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127156] = 2,
    ACTIONS(6168), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127164] = 2,
    ACTIONS(6170), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127172] = 2,
    ACTIONS(6172), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127180] = 2,
    ACTIONS(6174), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127188] = 2,
    ACTIONS(6176), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127196] = 2,
    ACTIONS(6178), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127204] = 2,
    ACTIONS(6180), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127212] = 2,
    ACTIONS(6182), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127220] = 2,
    ACTIONS(4940), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127228] = 2,
    ACTIONS(6184), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127236] = 2,
    ACTIONS(6186), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127244] = 2,
    ACTIONS(6188), 1,
      sym__DISALLOW_WC,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127252] = 2,
    ACTIONS(4248), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127260] = 2,
    ACTIONS(6190), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127268] = 2,
    ACTIONS(6192), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127276] = 2,
    ACTIONS(6194), 1,
      anon_sym_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127284] = 2,
    ACTIONS(4193), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127292] = 2,
    ACTIONS(5109), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127300] = 2,
    ACTIONS(6196), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127308] = 2,
    ACTIONS(4257), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127316] = 2,
    ACTIONS(6198), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127324] = 2,
    ACTIONS(6200), 1,
      sym__rule_import_as_pattern_target,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127332] = 2,
    ACTIONS(6202), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127340] = 2,
    ACTIONS(6204), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127348] = 2,
    ACTIONS(6206), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127356] = 2,
    ACTIONS(6208), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127364] = 2,
    ACTIONS(6210), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127372] = 2,
    ACTIONS(5093), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127380] = 2,
    ACTIONS(6212), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127388] = 2,
    ACTIONS(4226), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127396] = 2,
    ACTIONS(5087), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127404] = 2,
    ACTIONS(6214), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127412] = 2,
    ACTIONS(6216), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127420] = 2,
    ACTIONS(6218), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127428] = 2,
    ACTIONS(6220), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127436] = 2,
    ACTIONS(6222), 1,
      anon_sym_with,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127444] = 2,
    ACTIONS(6224), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127452] = 2,
    ACTIONS(6226), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127460] = 2,
    ACTIONS(6228), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127468] = 2,
    ACTIONS(6230), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127476] = 2,
    ACTIONS(6232), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127484] = 2,
    ACTIONS(6234), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127492] = 2,
    ACTIONS(6236), 1,
      anon_sym_for,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127500] = 2,
    ACTIONS(6238), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127508] = 2,
    ACTIONS(6240), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127516] = 2,
    ACTIONS(6242), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127524] = 2,
    ACTIONS(6244), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127532] = 2,
    ACTIONS(6246), 1,
      anon_sym_import,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127540] = 2,
    ACTIONS(6248), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127548] = 2,
    ACTIONS(6250), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127556] = 2,
    ACTIONS(6252), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127564] = 2,
    ACTIONS(6254), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127572] = 2,
    ACTIONS(6256), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127580] = 2,
    ACTIONS(5041), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127588] = 2,
    ACTIONS(6258), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127596] = 2,
    ACTIONS(5039), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127604] = 2,
    ACTIONS(2398), 1,
      anon_sym_def,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127612] = 2,
    ACTIONS(6260), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127620] = 2,
    ACTIONS(6262), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127628] = 2,
    ACTIONS(6264), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127636] = 2,
    ACTIONS(6266), 1,
      sym__rule_import_as_pattern_target,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127644] = 2,
    ACTIONS(6268), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127652] = 2,
    ACTIONS(6270), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127660] = 2,
    ACTIONS(6272), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127668] = 2,
    ACTIONS(6274), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127676] = 2,
    ACTIONS(6276), 1,
      sym__rule_import_as_pattern_target,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127684] = 2,
    ACTIONS(6278), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127692] = 2,
    ACTIONS(6280), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127700] = 2,
    ACTIONS(6282), 1,
      sym__DISALLOW_WC,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127708] = 2,
    ACTIONS(6284), 1,
      sym__DISALLOW_WC,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127716] = 2,
    ACTIONS(3884), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127724] = 2,
    ACTIONS(6286), 1,
      anon_sym_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127732] = 2,
    ACTIONS(6288), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127740] = 2,
    ACTIONS(6290), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127748] = 2,
    ACTIONS(6292), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127756] = 2,
    ACTIONS(6294), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127764] = 2,
    ACTIONS(6296), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127772] = 2,
    ACTIONS(6298), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127780] = 2,
    ACTIONS(4261), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127788] = 2,
    ACTIONS(6300), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127796] = 2,
    ACTIONS(6302), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127804] = 2,
    ACTIONS(6304), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127812] = 2,
    ACTIONS(6306), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127820] = 2,
    ACTIONS(6308), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127828] = 2,
    ACTIONS(6310), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127836] = 2,
    ACTIONS(4986), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127844] = 2,
    ACTIONS(3872), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127852] = 2,
    ACTIONS(6312), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127860] = 2,
    ACTIONS(6314), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127868] = 2,
    ACTIONS(6316), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127876] = 2,
    ACTIONS(6318), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127884] = 2,
    ACTIONS(6320), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127892] = 2,
    ACTIONS(6322), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127900] = 2,
    ACTIONS(6324), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127908] = 2,
    ACTIONS(6326), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127916] = 2,
    ACTIONS(6328), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127924] = 2,
    ACTIONS(6330), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127932] = 2,
    ACTIONS(6332), 1,
      anon_sym_import,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127940] = 2,
    ACTIONS(6334), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127948] = 2,
    ACTIONS(6336), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127956] = 2,
    ACTIONS(6338), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127964] = 2,
    ACTIONS(6340), 1,
      anon_sym_import,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127972] = 2,
    ACTIONS(6342), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127980] = 2,
    ACTIONS(6344), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127988] = 2,
    ACTIONS(6346), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [127996] = 2,
    ACTIONS(4315), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [128004] = 2,
    ACTIONS(6348), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [128012] = 2,
    ACTIONS(6350), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [128020] = 2,
    ACTIONS(6352), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [128028] = 2,
    ACTIONS(6354), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [128036] = 2,
    ACTIONS(6356), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [128044] = 2,
    ACTIONS(6358), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [128052] = 2,
    ACTIONS(6360), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [128060] = 2,
    ACTIONS(6362), 1,
      anon_sym_rule,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [128068] = 2,
    ACTIONS(6364), 1,
      anon_sym_from,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [128076] = 2,
    ACTIONS(6366), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [128084] = 2,
    ACTIONS(6368), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [128092] = 2,
    ACTIONS(6370), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [128100] = 2,
    ACTIONS(6372), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [128108] = 2,
    ACTIONS(6374), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [128116] = 2,
    ACTIONS(6376), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [128124] = 2,
    ACTIONS(6378), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [128132] = 2,
    ACTIONS(6380), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [128140] = 2,
    ACTIONS(6382), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [128148] = 2,
    ACTIONS(6384), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [128156] = 2,
    ACTIONS(6386), 1,
      anon_sym_rule,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [128164] = 2,
    ACTIONS(6388), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [128172] = 2,
    ACTIONS(6390), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [128180] = 2,
    ACTIONS(4950), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [128188] = 2,
    ACTIONS(2390), 1,
      anon_sym_def,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [128196] = 2,
    ACTIONS(6392), 1,
      anon_sym_for,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [128204] = 2,
    ACTIONS(6394), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [128212] = 2,
    ACTIONS(4948), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [128220] = 2,
    ACTIONS(6396), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [128228] = 2,
    ACTIONS(6398), 1,
      anon_sym_for,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [128236] = 2,
    ACTIONS(6400), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [128244] = 2,
    ACTIONS(6402), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(515)] = 0,
  [SMALL_STATE(516)] = 126,
  [SMALL_STATE(517)] = 246,
  [SMALL_STATE(518)] = 372,
  [SMALL_STATE(519)] = 496,
  [SMALL_STATE(520)] = 620,
  [SMALL_STATE(521)] = 744,
  [SMALL_STATE(522)] = 868,
  [SMALL_STATE(523)] = 994,
  [SMALL_STATE(524)] = 1118,
  [SMALL_STATE(525)] = 1242,
  [SMALL_STATE(526)] = 1368,
  [SMALL_STATE(527)] = 1496,
  [SMALL_STATE(528)] = 1620,
  [SMALL_STATE(529)] = 1746,
  [SMALL_STATE(530)] = 1870,
  [SMALL_STATE(531)] = 1994,
  [SMALL_STATE(532)] = 2122,
  [SMALL_STATE(533)] = 2246,
  [SMALL_STATE(534)] = 2366,
  [SMALL_STATE(535)] = 2490,
  [SMALL_STATE(536)] = 2614,
  [SMALL_STATE(537)] = 2740,
  [SMALL_STATE(538)] = 2860,
  [SMALL_STATE(539)] = 2986,
  [SMALL_STATE(540)] = 3110,
  [SMALL_STATE(541)] = 3236,
  [SMALL_STATE(542)] = 3360,
  [SMALL_STATE(543)] = 3484,
  [SMALL_STATE(544)] = 3610,
  [SMALL_STATE(545)] = 3734,
  [SMALL_STATE(546)] = 3858,
  [SMALL_STATE(547)] = 3982,
  [SMALL_STATE(548)] = 4106,
  [SMALL_STATE(549)] = 4230,
  [SMALL_STATE(550)] = 4347,
  [SMALL_STATE(551)] = 4454,
  [SMALL_STATE(552)] = 4571,
  [SMALL_STATE(553)] = 4678,
  [SMALL_STATE(554)] = 4795,
  [SMALL_STATE(555)] = 4912,
  [SMALL_STATE(556)] = 5026,
  [SMALL_STATE(557)] = 5140,
  [SMALL_STATE(558)] = 5254,
  [SMALL_STATE(559)] = 5368,
  [SMALL_STATE(560)] = 5484,
  [SMALL_STATE(561)] = 5600,
  [SMALL_STATE(562)] = 5714,
  [SMALL_STATE(563)] = 5828,
  [SMALL_STATE(564)] = 5942,
  [SMALL_STATE(565)] = 6056,
  [SMALL_STATE(566)] = 6167,
  [SMALL_STATE(567)] = 6278,
  [SMALL_STATE(568)] = 6391,
  [SMALL_STATE(569)] = 6502,
  [SMALL_STATE(570)] = 6615,
  [SMALL_STATE(571)] = 6726,
  [SMALL_STATE(572)] = 6841,
  [SMALL_STATE(573)] = 6952,
  [SMALL_STATE(574)] = 7063,
  [SMALL_STATE(575)] = 7176,
  [SMALL_STATE(576)] = 7281,
  [SMALL_STATE(577)] = 7392,
  [SMALL_STATE(578)] = 7505,
  [SMALL_STATE(579)] = 7616,
  [SMALL_STATE(580)] = 7727,
  [SMALL_STATE(581)] = 7840,
  [SMALL_STATE(582)] = 7953,
  [SMALL_STATE(583)] = 8068,
  [SMALL_STATE(584)] = 8179,
  [SMALL_STATE(585)] = 8294,
  [SMALL_STATE(586)] = 8407,
  [SMALL_STATE(587)] = 8522,
  [SMALL_STATE(588)] = 8627,
  [SMALL_STATE(589)] = 8740,
  [SMALL_STATE(590)] = 8853,
  [SMALL_STATE(591)] = 8964,
  [SMALL_STATE(592)] = 9075,
  [SMALL_STATE(593)] = 9188,
  [SMALL_STATE(594)] = 9305,
  [SMALL_STATE(595)] = 9416,
  [SMALL_STATE(596)] = 9531,
  [SMALL_STATE(597)] = 9646,
  [SMALL_STATE(598)] = 9757,
  [SMALL_STATE(599)] = 9868,
  [SMALL_STATE(600)] = 9979,
  [SMALL_STATE(601)] = 10092,
  [SMALL_STATE(602)] = 10203,
  [SMALL_STATE(603)] = 10314,
  [SMALL_STATE(604)] = 10429,
  [SMALL_STATE(605)] = 10540,
  [SMALL_STATE(606)] = 10651,
  [SMALL_STATE(607)] = 10762,
  [SMALL_STATE(608)] = 10877,
  [SMALL_STATE(609)] = 10988,
  [SMALL_STATE(610)] = 11101,
  [SMALL_STATE(611)] = 11216,
  [SMALL_STATE(612)] = 11331,
  [SMALL_STATE(613)] = 11442,
  [SMALL_STATE(614)] = 11553,
  [SMALL_STATE(615)] = 11664,
  [SMALL_STATE(616)] = 11775,
  [SMALL_STATE(617)] = 11885,
  [SMALL_STATE(618)] = 11997,
  [SMALL_STATE(619)] = 12109,
  [SMALL_STATE(620)] = 12221,
  [SMALL_STATE(621)] = 12331,
  [SMALL_STATE(622)] = 12445,
  [SMALL_STATE(623)] = 12557,
  [SMALL_STATE(624)] = 12669,
  [SMALL_STATE(625)] = 12781,
  [SMALL_STATE(626)] = 12891,
  [SMALL_STATE(627)] = 13007,
  [SMALL_STATE(628)] = 13117,
  [SMALL_STATE(629)] = 13229,
  [SMALL_STATE(630)] = 13339,
  [SMALL_STATE(631)] = 13449,
  [SMALL_STATE(632)] = 13559,
  [SMALL_STATE(633)] = 13669,
  [SMALL_STATE(634)] = 13781,
  [SMALL_STATE(635)] = 13895,
  [SMALL_STATE(636)] = 14007,
  [SMALL_STATE(637)] = 14117,
  [SMALL_STATE(638)] = 14227,
  [SMALL_STATE(639)] = 14339,
  [SMALL_STATE(640)] = 14449,
  [SMALL_STATE(641)] = 14559,
  [SMALL_STATE(642)] = 14669,
  [SMALL_STATE(643)] = 14781,
  [SMALL_STATE(644)] = 14891,
  [SMALL_STATE(645)] = 15003,
  [SMALL_STATE(646)] = 15113,
  [SMALL_STATE(647)] = 15223,
  [SMALL_STATE(648)] = 15335,
  [SMALL_STATE(649)] = 15445,
  [SMALL_STATE(650)] = 15557,
  [SMALL_STATE(651)] = 15671,
  [SMALL_STATE(652)] = 15783,
  [SMALL_STATE(653)] = 15899,
  [SMALL_STATE(654)] = 16013,
  [SMALL_STATE(655)] = 16125,
  [SMALL_STATE(656)] = 16235,
  [SMALL_STATE(657)] = 16347,
  [SMALL_STATE(658)] = 16459,
  [SMALL_STATE(659)] = 16571,
  [SMALL_STATE(660)] = 16681,
  [SMALL_STATE(661)] = 16797,
  [SMALL_STATE(662)] = 16907,
  [SMALL_STATE(663)] = 17019,
  [SMALL_STATE(664)] = 17131,
  [SMALL_STATE(665)] = 17241,
  [SMALL_STATE(666)] = 17355,
  [SMALL_STATE(667)] = 17465,
  [SMALL_STATE(668)] = 17577,
  [SMALL_STATE(669)] = 17689,
  [SMALL_STATE(670)] = 17799,
  [SMALL_STATE(671)] = 17909,
  [SMALL_STATE(672)] = 18019,
  [SMALL_STATE(673)] = 18129,
  [SMALL_STATE(674)] = 18239,
  [SMALL_STATE(675)] = 18349,
  [SMALL_STATE(676)] = 18461,
  [SMALL_STATE(677)] = 18573,
  [SMALL_STATE(678)] = 18683,
  [SMALL_STATE(679)] = 18795,
  [SMALL_STATE(680)] = 18905,
  [SMALL_STATE(681)] = 19015,
  [SMALL_STATE(682)] = 19127,
  [SMALL_STATE(683)] = 19237,
  [SMALL_STATE(684)] = 19347,
  [SMALL_STATE(685)] = 19463,
  [SMALL_STATE(686)] = 19573,
  [SMALL_STATE(687)] = 19685,
  [SMALL_STATE(688)] = 19801,
  [SMALL_STATE(689)] = 19913,
  [SMALL_STATE(690)] = 20023,
  [SMALL_STATE(691)] = 20135,
  [SMALL_STATE(692)] = 20249,
  [SMALL_STATE(693)] = 20361,
  [SMALL_STATE(694)] = 20475,
  [SMALL_STATE(695)] = 20589,
  [SMALL_STATE(696)] = 20701,
  [SMALL_STATE(697)] = 20815,
  [SMALL_STATE(698)] = 20927,
  [SMALL_STATE(699)] = 21037,
  [SMALL_STATE(700)] = 21153,
  [SMALL_STATE(701)] = 21265,
  [SMALL_STATE(702)] = 21377,
  [SMALL_STATE(703)] = 21489,
  [SMALL_STATE(704)] = 21601,
  [SMALL_STATE(705)] = 21713,
  [SMALL_STATE(706)] = 21825,
  [SMALL_STATE(707)] = 21935,
  [SMALL_STATE(708)] = 22047,
  [SMALL_STATE(709)] = 22159,
  [SMALL_STATE(710)] = 22269,
  [SMALL_STATE(711)] = 22381,
  [SMALL_STATE(712)] = 22493,
  [SMALL_STATE(713)] = 22605,
  [SMALL_STATE(714)] = 22715,
  [SMALL_STATE(715)] = 22825,
  [SMALL_STATE(716)] = 22937,
  [SMALL_STATE(717)] = 23046,
  [SMALL_STATE(718)] = 23155,
  [SMALL_STATE(719)] = 23264,
  [SMALL_STATE(720)] = 23373,
  [SMALL_STATE(721)] = 23482,
  [SMALL_STATE(722)] = 23591,
  [SMALL_STATE(723)] = 23700,
  [SMALL_STATE(724)] = 23809,
  [SMALL_STATE(725)] = 23918,
  [SMALL_STATE(726)] = 24027,
  [SMALL_STATE(727)] = 24136,
  [SMALL_STATE(728)] = 24245,
  [SMALL_STATE(729)] = 24352,
  [SMALL_STATE(730)] = 24449,
  [SMALL_STATE(731)] = 24558,
  [SMALL_STATE(732)] = 24665,
  [SMALL_STATE(733)] = 24770,
  [SMALL_STATE(734)] = 24875,
  [SMALL_STATE(735)] = 24984,
  [SMALL_STATE(736)] = 25093,
  [SMALL_STATE(737)] = 25202,
  [SMALL_STATE(738)] = 25311,
  [SMALL_STATE(739)] = 25420,
  [SMALL_STATE(740)] = 25529,
  [SMALL_STATE(741)] = 25637,
  [SMALL_STATE(742)] = 25745,
  [SMALL_STATE(743)] = 25853,
  [SMALL_STATE(744)] = 25961,
  [SMALL_STATE(745)] = 26069,
  [SMALL_STATE(746)] = 26177,
  [SMALL_STATE(747)] = 26285,
  [SMALL_STATE(748)] = 26393,
  [SMALL_STATE(749)] = 26501,
  [SMALL_STATE(750)] = 26609,
  [SMALL_STATE(751)] = 26717,
  [SMALL_STATE(752)] = 26825,
  [SMALL_STATE(753)] = 26931,
  [SMALL_STATE(754)] = 27039,
  [SMALL_STATE(755)] = 27147,
  [SMALL_STATE(756)] = 27255,
  [SMALL_STATE(757)] = 27363,
  [SMALL_STATE(758)] = 27471,
  [SMALL_STATE(759)] = 27579,
  [SMALL_STATE(760)] = 27685,
  [SMALL_STATE(761)] = 27793,
  [SMALL_STATE(762)] = 27901,
  [SMALL_STATE(763)] = 28009,
  [SMALL_STATE(764)] = 28115,
  [SMALL_STATE(765)] = 28223,
  [SMALL_STATE(766)] = 28328,
  [SMALL_STATE(767)] = 28435,
  [SMALL_STATE(768)] = 28542,
  [SMALL_STATE(769)] = 28649,
  [SMALL_STATE(770)] = 28756,
  [SMALL_STATE(771)] = 28863,
  [SMALL_STATE(772)] = 28970,
  [SMALL_STATE(773)] = 29077,
  [SMALL_STATE(774)] = 29184,
  [SMALL_STATE(775)] = 29291,
  [SMALL_STATE(776)] = 29398,
  [SMALL_STATE(777)] = 29493,
  [SMALL_STATE(778)] = 29600,
  [SMALL_STATE(779)] = 29705,
  [SMALL_STATE(780)] = 29810,
  [SMALL_STATE(781)] = 29917,
  [SMALL_STATE(782)] = 30012,
  [SMALL_STATE(783)] = 30119,
  [SMALL_STATE(784)] = 30226,
  [SMALL_STATE(785)] = 30331,
  [SMALL_STATE(786)] = 30438,
  [SMALL_STATE(787)] = 30545,
  [SMALL_STATE(788)] = 30652,
  [SMALL_STATE(789)] = 30759,
  [SMALL_STATE(790)] = 30866,
  [SMALL_STATE(791)] = 30973,
  [SMALL_STATE(792)] = 31080,
  [SMALL_STATE(793)] = 31187,
  [SMALL_STATE(794)] = 31294,
  [SMALL_STATE(795)] = 31401,
  [SMALL_STATE(796)] = 31508,
  [SMALL_STATE(797)] = 31615,
  [SMALL_STATE(798)] = 31722,
  [SMALL_STATE(799)] = 31827,
  [SMALL_STATE(800)] = 31934,
  [SMALL_STATE(801)] = 32041,
  [SMALL_STATE(802)] = 32146,
  [SMALL_STATE(803)] = 32253,
  [SMALL_STATE(804)] = 32360,
  [SMALL_STATE(805)] = 32467,
  [SMALL_STATE(806)] = 32574,
  [SMALL_STATE(807)] = 32678,
  [SMALL_STATE(808)] = 32782,
  [SMALL_STATE(809)] = 32886,
  [SMALL_STATE(810)] = 32990,
  [SMALL_STATE(811)] = 33092,
  [SMALL_STATE(812)] = 33188,
  [SMALL_STATE(813)] = 33292,
  [SMALL_STATE(814)] = 33394,
  [SMALL_STATE(815)] = 33498,
  [SMALL_STATE(816)] = 33600,
  [SMALL_STATE(817)] = 33702,
  [SMALL_STATE(818)] = 33804,
  [SMALL_STATE(819)] = 33906,
  [SMALL_STATE(820)] = 34010,
  [SMALL_STATE(821)] = 34114,
  [SMALL_STATE(822)] = 34216,
  [SMALL_STATE(823)] = 34318,
  [SMALL_STATE(824)] = 34412,
  [SMALL_STATE(825)] = 34514,
  [SMALL_STATE(826)] = 34618,
  [SMALL_STATE(827)] = 34722,
  [SMALL_STATE(828)] = 34824,
  [SMALL_STATE(829)] = 34928,
  [SMALL_STATE(830)] = 35022,
  [SMALL_STATE(831)] = 35116,
  [SMALL_STATE(832)] = 35218,
  [SMALL_STATE(833)] = 35322,
  [SMALL_STATE(834)] = 35426,
  [SMALL_STATE(835)] = 35528,
  [SMALL_STATE(836)] = 35630,
  [SMALL_STATE(837)] = 35734,
  [SMALL_STATE(838)] = 35838,
  [SMALL_STATE(839)] = 35940,
  [SMALL_STATE(840)] = 36044,
  [SMALL_STATE(841)] = 36146,
  [SMALL_STATE(842)] = 36248,
  [SMALL_STATE(843)] = 36350,
  [SMALL_STATE(844)] = 36452,
  [SMALL_STATE(845)] = 36556,
  [SMALL_STATE(846)] = 36658,
  [SMALL_STATE(847)] = 36760,
  [SMALL_STATE(848)] = 36864,
  [SMALL_STATE(849)] = 36968,
  [SMALL_STATE(850)] = 37070,
  [SMALL_STATE(851)] = 37172,
  [SMALL_STATE(852)] = 37274,
  [SMALL_STATE(853)] = 37376,
  [SMALL_STATE(854)] = 37470,
  [SMALL_STATE(855)] = 37572,
  [SMALL_STATE(856)] = 37674,
  [SMALL_STATE(857)] = 37776,
  [SMALL_STATE(858)] = 37878,
  [SMALL_STATE(859)] = 37982,
  [SMALL_STATE(860)] = 38083,
  [SMALL_STATE(861)] = 38184,
  [SMALL_STATE(862)] = 38285,
  [SMALL_STATE(863)] = 38386,
  [SMALL_STATE(864)] = 38487,
  [SMALL_STATE(865)] = 38588,
  [SMALL_STATE(866)] = 38689,
  [SMALL_STATE(867)] = 38790,
  [SMALL_STATE(868)] = 38891,
  [SMALL_STATE(869)] = 38992,
  [SMALL_STATE(870)] = 39067,
  [SMALL_STATE(871)] = 39168,
  [SMALL_STATE(872)] = 39243,
  [SMALL_STATE(873)] = 39344,
  [SMALL_STATE(874)] = 39419,
  [SMALL_STATE(875)] = 39496,
  [SMALL_STATE(876)] = 39597,
  [SMALL_STATE(877)] = 39698,
  [SMALL_STATE(878)] = 39799,
  [SMALL_STATE(879)] = 39897,
  [SMALL_STATE(880)] = 39995,
  [SMALL_STATE(881)] = 40093,
  [SMALL_STATE(882)] = 40191,
  [SMALL_STATE(883)] = 40289,
  [SMALL_STATE(884)] = 40387,
  [SMALL_STATE(885)] = 40485,
  [SMALL_STATE(886)] = 40583,
  [SMALL_STATE(887)] = 40681,
  [SMALL_STATE(888)] = 40779,
  [SMALL_STATE(889)] = 40877,
  [SMALL_STATE(890)] = 40975,
  [SMALL_STATE(891)] = 41073,
  [SMALL_STATE(892)] = 41171,
  [SMALL_STATE(893)] = 41269,
  [SMALL_STATE(894)] = 41367,
  [SMALL_STATE(895)] = 41465,
  [SMALL_STATE(896)] = 41563,
  [SMALL_STATE(897)] = 41661,
  [SMALL_STATE(898)] = 41759,
  [SMALL_STATE(899)] = 41857,
  [SMALL_STATE(900)] = 41955,
  [SMALL_STATE(901)] = 42053,
  [SMALL_STATE(902)] = 42151,
  [SMALL_STATE(903)] = 42251,
  [SMALL_STATE(904)] = 42351,
  [SMALL_STATE(905)] = 42449,
  [SMALL_STATE(906)] = 42547,
  [SMALL_STATE(907)] = 42645,
  [SMALL_STATE(908)] = 42743,
  [SMALL_STATE(909)] = 42841,
  [SMALL_STATE(910)] = 42939,
  [SMALL_STATE(911)] = 43037,
  [SMALL_STATE(912)] = 43135,
  [SMALL_STATE(913)] = 43233,
  [SMALL_STATE(914)] = 43331,
  [SMALL_STATE(915)] = 43431,
  [SMALL_STATE(916)] = 43529,
  [SMALL_STATE(917)] = 43627,
  [SMALL_STATE(918)] = 43727,
  [SMALL_STATE(919)] = 43825,
  [SMALL_STATE(920)] = 43923,
  [SMALL_STATE(921)] = 44021,
  [SMALL_STATE(922)] = 44119,
  [SMALL_STATE(923)] = 44219,
  [SMALL_STATE(924)] = 44317,
  [SMALL_STATE(925)] = 44415,
  [SMALL_STATE(926)] = 44513,
  [SMALL_STATE(927)] = 44611,
  [SMALL_STATE(928)] = 44709,
  [SMALL_STATE(929)] = 44807,
  [SMALL_STATE(930)] = 44905,
  [SMALL_STATE(931)] = 45003,
  [SMALL_STATE(932)] = 45101,
  [SMALL_STATE(933)] = 45199,
  [SMALL_STATE(934)] = 45297,
  [SMALL_STATE(935)] = 45395,
  [SMALL_STATE(936)] = 45493,
  [SMALL_STATE(937)] = 45591,
  [SMALL_STATE(938)] = 45689,
  [SMALL_STATE(939)] = 45787,
  [SMALL_STATE(940)] = 45885,
  [SMALL_STATE(941)] = 45985,
  [SMALL_STATE(942)] = 46083,
  [SMALL_STATE(943)] = 46181,
  [SMALL_STATE(944)] = 46279,
  [SMALL_STATE(945)] = 46377,
  [SMALL_STATE(946)] = 46475,
  [SMALL_STATE(947)] = 46573,
  [SMALL_STATE(948)] = 46671,
  [SMALL_STATE(949)] = 46769,
  [SMALL_STATE(950)] = 46867,
  [SMALL_STATE(951)] = 46965,
  [SMALL_STATE(952)] = 47063,
  [SMALL_STATE(953)] = 47161,
  [SMALL_STATE(954)] = 47259,
  [SMALL_STATE(955)] = 47357,
  [SMALL_STATE(956)] = 47455,
  [SMALL_STATE(957)] = 47553,
  [SMALL_STATE(958)] = 47651,
  [SMALL_STATE(959)] = 47749,
  [SMALL_STATE(960)] = 47847,
  [SMALL_STATE(961)] = 47945,
  [SMALL_STATE(962)] = 48043,
  [SMALL_STATE(963)] = 48141,
  [SMALL_STATE(964)] = 48239,
  [SMALL_STATE(965)] = 48337,
  [SMALL_STATE(966)] = 48435,
  [SMALL_STATE(967)] = 48533,
  [SMALL_STATE(968)] = 48631,
  [SMALL_STATE(969)] = 48729,
  [SMALL_STATE(970)] = 48827,
  [SMALL_STATE(971)] = 48925,
  [SMALL_STATE(972)] = 49023,
  [SMALL_STATE(973)] = 49121,
  [SMALL_STATE(974)] = 49221,
  [SMALL_STATE(975)] = 49319,
  [SMALL_STATE(976)] = 49417,
  [SMALL_STATE(977)] = 49515,
  [SMALL_STATE(978)] = 49613,
  [SMALL_STATE(979)] = 49711,
  [SMALL_STATE(980)] = 49809,
  [SMALL_STATE(981)] = 49907,
  [SMALL_STATE(982)] = 50005,
  [SMALL_STATE(983)] = 50103,
  [SMALL_STATE(984)] = 50201,
  [SMALL_STATE(985)] = 50299,
  [SMALL_STATE(986)] = 50397,
  [SMALL_STATE(987)] = 50495,
  [SMALL_STATE(988)] = 50593,
  [SMALL_STATE(989)] = 50691,
  [SMALL_STATE(990)] = 50789,
  [SMALL_STATE(991)] = 50887,
  [SMALL_STATE(992)] = 50985,
  [SMALL_STATE(993)] = 51083,
  [SMALL_STATE(994)] = 51181,
  [SMALL_STATE(995)] = 51279,
  [SMALL_STATE(996)] = 51377,
  [SMALL_STATE(997)] = 51475,
  [SMALL_STATE(998)] = 51573,
  [SMALL_STATE(999)] = 51671,
  [SMALL_STATE(1000)] = 51769,
  [SMALL_STATE(1001)] = 51867,
  [SMALL_STATE(1002)] = 51965,
  [SMALL_STATE(1003)] = 52063,
  [SMALL_STATE(1004)] = 52161,
  [SMALL_STATE(1005)] = 52259,
  [SMALL_STATE(1006)] = 52357,
  [SMALL_STATE(1007)] = 52455,
  [SMALL_STATE(1008)] = 52555,
  [SMALL_STATE(1009)] = 52653,
  [SMALL_STATE(1010)] = 52751,
  [SMALL_STATE(1011)] = 52849,
  [SMALL_STATE(1012)] = 52947,
  [SMALL_STATE(1013)] = 53045,
  [SMALL_STATE(1014)] = 53143,
  [SMALL_STATE(1015)] = 53241,
  [SMALL_STATE(1016)] = 53339,
  [SMALL_STATE(1017)] = 53412,
  [SMALL_STATE(1018)] = 53478,
  [SMALL_STATE(1019)] = 53544,
  [SMALL_STATE(1020)] = 53610,
  [SMALL_STATE(1021)] = 53678,
  [SMALL_STATE(1022)] = 53735,
  [SMALL_STATE(1023)] = 53800,
  [SMALL_STATE(1024)] = 53857,
  [SMALL_STATE(1025)] = 53920,
  [SMALL_STATE(1026)] = 53977,
  [SMALL_STATE(1027)] = 54040,
  [SMALL_STATE(1028)] = 54103,
  [SMALL_STATE(1029)] = 54166,
  [SMALL_STATE(1030)] = 54229,
  [SMALL_STATE(1031)] = 54286,
  [SMALL_STATE(1032)] = 54343,
  [SMALL_STATE(1033)] = 54400,
  [SMALL_STATE(1034)] = 54463,
  [SMALL_STATE(1035)] = 54524,
  [SMALL_STATE(1036)] = 54585,
  [SMALL_STATE(1037)] = 54648,
  [SMALL_STATE(1038)] = 54711,
  [SMALL_STATE(1039)] = 54768,
  [SMALL_STATE(1040)] = 54829,
  [SMALL_STATE(1041)] = 54921,
  [SMALL_STATE(1042)] = 55013,
  [SMALL_STATE(1043)] = 55105,
  [SMALL_STATE(1044)] = 55197,
  [SMALL_STATE(1045)] = 55286,
  [SMALL_STATE(1046)] = 55375,
  [SMALL_STATE(1047)] = 55464,
  [SMALL_STATE(1048)] = 55553,
  [SMALL_STATE(1049)] = 55642,
  [SMALL_STATE(1050)] = 55731,
  [SMALL_STATE(1051)] = 55820,
  [SMALL_STATE(1052)] = 55909,
  [SMALL_STATE(1053)] = 55998,
  [SMALL_STATE(1054)] = 56087,
  [SMALL_STATE(1055)] = 56176,
  [SMALL_STATE(1056)] = 56265,
  [SMALL_STATE(1057)] = 56354,
  [SMALL_STATE(1058)] = 56443,
  [SMALL_STATE(1059)] = 56532,
  [SMALL_STATE(1060)] = 56621,
  [SMALL_STATE(1061)] = 56707,
  [SMALL_STATE(1062)] = 56793,
  [SMALL_STATE(1063)] = 56879,
  [SMALL_STATE(1064)] = 56965,
  [SMALL_STATE(1065)] = 57051,
  [SMALL_STATE(1066)] = 57137,
  [SMALL_STATE(1067)] = 57220,
  [SMALL_STATE(1068)] = 57303,
  [SMALL_STATE(1069)] = 57381,
  [SMALL_STATE(1070)] = 57459,
  [SMALL_STATE(1071)] = 57537,
  [SMALL_STATE(1072)] = 57615,
  [SMALL_STATE(1073)] = 57693,
  [SMALL_STATE(1074)] = 57771,
  [SMALL_STATE(1075)] = 57849,
  [SMALL_STATE(1076)] = 57927,
  [SMALL_STATE(1077)] = 58005,
  [SMALL_STATE(1078)] = 58080,
  [SMALL_STATE(1079)] = 58155,
  [SMALL_STATE(1080)] = 58230,
  [SMALL_STATE(1081)] = 58305,
  [SMALL_STATE(1082)] = 58384,
  [SMALL_STATE(1083)] = 58463,
  [SMALL_STATE(1084)] = 58538,
  [SMALL_STATE(1085)] = 58613,
  [SMALL_STATE(1086)] = 58666,
  [SMALL_STATE(1087)] = 58741,
  [SMALL_STATE(1088)] = 58816,
  [SMALL_STATE(1089)] = 58891,
  [SMALL_STATE(1090)] = 58966,
  [SMALL_STATE(1091)] = 59041,
  [SMALL_STATE(1092)] = 59116,
  [SMALL_STATE(1093)] = 59191,
  [SMALL_STATE(1094)] = 59266,
  [SMALL_STATE(1095)] = 59341,
  [SMALL_STATE(1096)] = 59416,
  [SMALL_STATE(1097)] = 59491,
  [SMALL_STATE(1098)] = 59566,
  [SMALL_STATE(1099)] = 59641,
  [SMALL_STATE(1100)] = 59716,
  [SMALL_STATE(1101)] = 59795,
  [SMALL_STATE(1102)] = 59870,
  [SMALL_STATE(1103)] = 59945,
  [SMALL_STATE(1104)] = 60020,
  [SMALL_STATE(1105)] = 60095,
  [SMALL_STATE(1106)] = 60174,
  [SMALL_STATE(1107)] = 60249,
  [SMALL_STATE(1108)] = 60324,
  [SMALL_STATE(1109)] = 60403,
  [SMALL_STATE(1110)] = 60478,
  [SMALL_STATE(1111)] = 60553,
  [SMALL_STATE(1112)] = 60628,
  [SMALL_STATE(1113)] = 60707,
  [SMALL_STATE(1114)] = 60782,
  [SMALL_STATE(1115)] = 60861,
  [SMALL_STATE(1116)] = 60936,
  [SMALL_STATE(1117)] = 61011,
  [SMALL_STATE(1118)] = 61090,
  [SMALL_STATE(1119)] = 61165,
  [SMALL_STATE(1120)] = 61240,
  [SMALL_STATE(1121)] = 61315,
  [SMALL_STATE(1122)] = 61390,
  [SMALL_STATE(1123)] = 61465,
  [SMALL_STATE(1124)] = 61540,
  [SMALL_STATE(1125)] = 61615,
  [SMALL_STATE(1126)] = 61690,
  [SMALL_STATE(1127)] = 61769,
  [SMALL_STATE(1128)] = 61844,
  [SMALL_STATE(1129)] = 61919,
  [SMALL_STATE(1130)] = 61994,
  [SMALL_STATE(1131)] = 62069,
  [SMALL_STATE(1132)] = 62144,
  [SMALL_STATE(1133)] = 62219,
  [SMALL_STATE(1134)] = 62294,
  [SMALL_STATE(1135)] = 62369,
  [SMALL_STATE(1136)] = 62444,
  [SMALL_STATE(1137)] = 62519,
  [SMALL_STATE(1138)] = 62594,
  [SMALL_STATE(1139)] = 62669,
  [SMALL_STATE(1140)] = 62744,
  [SMALL_STATE(1141)] = 62819,
  [SMALL_STATE(1142)] = 62894,
  [SMALL_STATE(1143)] = 62969,
  [SMALL_STATE(1144)] = 63048,
  [SMALL_STATE(1145)] = 63127,
  [SMALL_STATE(1146)] = 63206,
  [SMALL_STATE(1147)] = 63281,
  [SMALL_STATE(1148)] = 63356,
  [SMALL_STATE(1149)] = 63431,
  [SMALL_STATE(1150)] = 63506,
  [SMALL_STATE(1151)] = 63585,
  [SMALL_STATE(1152)] = 63660,
  [SMALL_STATE(1153)] = 63739,
  [SMALL_STATE(1154)] = 63814,
  [SMALL_STATE(1155)] = 63889,
  [SMALL_STATE(1156)] = 63964,
  [SMALL_STATE(1157)] = 64039,
  [SMALL_STATE(1158)] = 64114,
  [SMALL_STATE(1159)] = 64189,
  [SMALL_STATE(1160)] = 64264,
  [SMALL_STATE(1161)] = 64339,
  [SMALL_STATE(1162)] = 64414,
  [SMALL_STATE(1163)] = 64489,
  [SMALL_STATE(1164)] = 64564,
  [SMALL_STATE(1165)] = 64639,
  [SMALL_STATE(1166)] = 64718,
  [SMALL_STATE(1167)] = 64793,
  [SMALL_STATE(1168)] = 64868,
  [SMALL_STATE(1169)] = 64943,
  [SMALL_STATE(1170)] = 65018,
  [SMALL_STATE(1171)] = 65093,
  [SMALL_STATE(1172)] = 65168,
  [SMALL_STATE(1173)] = 65247,
  [SMALL_STATE(1174)] = 65322,
  [SMALL_STATE(1175)] = 65397,
  [SMALL_STATE(1176)] = 65472,
  [SMALL_STATE(1177)] = 65547,
  [SMALL_STATE(1178)] = 65622,
  [SMALL_STATE(1179)] = 65697,
  [SMALL_STATE(1180)] = 65772,
  [SMALL_STATE(1181)] = 65851,
  [SMALL_STATE(1182)] = 65926,
  [SMALL_STATE(1183)] = 66001,
  [SMALL_STATE(1184)] = 66076,
  [SMALL_STATE(1185)] = 66155,
  [SMALL_STATE(1186)] = 66234,
  [SMALL_STATE(1187)] = 66309,
  [SMALL_STATE(1188)] = 66384,
  [SMALL_STATE(1189)] = 66459,
  [SMALL_STATE(1190)] = 66534,
  [SMALL_STATE(1191)] = 66587,
  [SMALL_STATE(1192)] = 66666,
  [SMALL_STATE(1193)] = 66745,
  [SMALL_STATE(1194)] = 66820,
  [SMALL_STATE(1195)] = 66899,
  [SMALL_STATE(1196)] = 66974,
  [SMALL_STATE(1197)] = 67049,
  [SMALL_STATE(1198)] = 67124,
  [SMALL_STATE(1199)] = 67199,
  [SMALL_STATE(1200)] = 67274,
  [SMALL_STATE(1201)] = 67326,
  [SMALL_STATE(1202)] = 67378,
  [SMALL_STATE(1203)] = 67430,
  [SMALL_STATE(1204)] = 67512,
  [SMALL_STATE(1205)] = 67575,
  [SMALL_STATE(1206)] = 67632,
  [SMALL_STATE(1207)] = 67697,
  [SMALL_STATE(1208)] = 67744,
  [SMALL_STATE(1209)] = 67813,
  [SMALL_STATE(1210)] = 67860,
  [SMALL_STATE(1211)] = 67931,
  [SMALL_STATE(1212)] = 67988,
  [SMALL_STATE(1213)] = 68059,
  [SMALL_STATE(1214)] = 68130,
  [SMALL_STATE(1215)] = 68199,
  [SMALL_STATE(1216)] = 68260,
  [SMALL_STATE(1217)] = 68311,
  [SMALL_STATE(1218)] = 68368,
  [SMALL_STATE(1219)] = 68425,
  [SMALL_STATE(1220)] = 68476,
  [SMALL_STATE(1221)] = 68557,
  [SMALL_STATE(1222)] = 68638,
  [SMALL_STATE(1223)] = 68689,
  [SMALL_STATE(1224)] = 68740,
  [SMALL_STATE(1225)] = 68809,
  [SMALL_STATE(1226)] = 68876,
  [SMALL_STATE(1227)] = 68927,
  [SMALL_STATE(1228)] = 68978,
  [SMALL_STATE(1229)] = 69024,
  [SMALL_STATE(1230)] = 69070,
  [SMALL_STATE(1231)] = 69140,
  [SMALL_STATE(1232)] = 69210,
  [SMALL_STATE(1233)] = 69260,
  [SMALL_STATE(1234)] = 69340,
  [SMALL_STATE(1235)] = 69390,
  [SMALL_STATE(1236)] = 69438,
  [SMALL_STATE(1237)] = 69484,
  [SMALL_STATE(1238)] = 69562,
  [SMALL_STATE(1239)] = 69632,
  [SMALL_STATE(1240)] = 69678,
  [SMALL_STATE(1241)] = 69728,
  [SMALL_STATE(1242)] = 69798,
  [SMALL_STATE(1243)] = 69868,
  [SMALL_STATE(1244)] = 69924,
  [SMALL_STATE(1245)] = 69980,
  [SMALL_STATE(1246)] = 70030,
  [SMALL_STATE(1247)] = 70086,
  [SMALL_STATE(1248)] = 70134,
  [SMALL_STATE(1249)] = 70200,
  [SMALL_STATE(1250)] = 70264,
  [SMALL_STATE(1251)] = 70310,
  [SMALL_STATE(1252)] = 70376,
  [SMALL_STATE(1253)] = 70422,
  [SMALL_STATE(1254)] = 70502,
  [SMALL_STATE(1255)] = 70552,
  [SMALL_STATE(1256)] = 70608,
  [SMALL_STATE(1257)] = 70658,
  [SMALL_STATE(1258)] = 70706,
  [SMALL_STATE(1259)] = 70756,
  [SMALL_STATE(1260)] = 70824,
  [SMALL_STATE(1261)] = 70870,
  [SMALL_STATE(1262)] = 70920,
  [SMALL_STATE(1263)] = 70986,
  [SMALL_STATE(1264)] = 71052,
  [SMALL_STATE(1265)] = 71132,
  [SMALL_STATE(1266)] = 71182,
  [SMALL_STATE(1267)] = 71228,
  [SMALL_STATE(1268)] = 71284,
  [SMALL_STATE(1269)] = 71330,
  [SMALL_STATE(1270)] = 71386,
  [SMALL_STATE(1271)] = 71448,
  [SMALL_STATE(1272)] = 71498,
  [SMALL_STATE(1273)] = 71568,
  [SMALL_STATE(1274)] = 71624,
  [SMALL_STATE(1275)] = 71684,
  [SMALL_STATE(1276)] = 71764,
  [SMALL_STATE(1277)] = 71832,
  [SMALL_STATE(1278)] = 71882,
  [SMALL_STATE(1279)] = 71948,
  [SMALL_STATE(1280)] = 71998,
  [SMALL_STATE(1281)] = 72062,
  [SMALL_STATE(1282)] = 72122,
  [SMALL_STATE(1283)] = 72178,
  [SMALL_STATE(1284)] = 72240,
  [SMALL_STATE(1285)] = 72291,
  [SMALL_STATE(1286)] = 72342,
  [SMALL_STATE(1287)] = 72391,
  [SMALL_STATE(1288)] = 72440,
  [SMALL_STATE(1289)] = 72489,
  [SMALL_STATE(1290)] = 72538,
  [SMALL_STATE(1291)] = 72587,
  [SMALL_STATE(1292)] = 72632,
  [SMALL_STATE(1293)] = 72677,
  [SMALL_STATE(1294)] = 72724,
  [SMALL_STATE(1295)] = 72771,
  [SMALL_STATE(1296)] = 72818,
  [SMALL_STATE(1297)] = 72873,
  [SMALL_STATE(1298)] = 72928,
  [SMALL_STATE(1299)] = 72983,
  [SMALL_STATE(1300)] = 73028,
  [SMALL_STATE(1301)] = 73073,
  [SMALL_STATE(1302)] = 73118,
  [SMALL_STATE(1303)] = 73173,
  [SMALL_STATE(1304)] = 73224,
  [SMALL_STATE(1305)] = 73269,
  [SMALL_STATE(1306)] = 73314,
  [SMALL_STATE(1307)] = 73365,
  [SMALL_STATE(1308)] = 73414,
  [SMALL_STATE(1309)] = 73459,
  [SMALL_STATE(1310)] = 73510,
  [SMALL_STATE(1311)] = 73555,
  [SMALL_STATE(1312)] = 73600,
  [SMALL_STATE(1313)] = 73645,
  [SMALL_STATE(1314)] = 73690,
  [SMALL_STATE(1315)] = 73735,
  [SMALL_STATE(1316)] = 73780,
  [SMALL_STATE(1317)] = 73825,
  [SMALL_STATE(1318)] = 73870,
  [SMALL_STATE(1319)] = 73915,
  [SMALL_STATE(1320)] = 73960,
  [SMALL_STATE(1321)] = 74005,
  [SMALL_STATE(1322)] = 74052,
  [SMALL_STATE(1323)] = 74097,
  [SMALL_STATE(1324)] = 74144,
  [SMALL_STATE(1325)] = 74213,
  [SMALL_STATE(1326)] = 74282,
  [SMALL_STATE(1327)] = 74329,
  [SMALL_STATE(1328)] = 74374,
  [SMALL_STATE(1329)] = 74419,
  [SMALL_STATE(1330)] = 74474,
  [SMALL_STATE(1331)] = 74535,
  [SMALL_STATE(1332)] = 74604,
  [SMALL_STATE(1333)] = 74659,
  [SMALL_STATE(1334)] = 74718,
  [SMALL_STATE(1335)] = 74785,
  [SMALL_STATE(1336)] = 74850,
  [SMALL_STATE(1337)] = 74913,
  [SMALL_STATE(1338)] = 74962,
  [SMALL_STATE(1339)] = 75007,
  [SMALL_STATE(1340)] = 75052,
  [SMALL_STATE(1341)] = 75121,
  [SMALL_STATE(1342)] = 75198,
  [SMALL_STATE(1343)] = 75267,
  [SMALL_STATE(1344)] = 75336,
  [SMALL_STATE(1345)] = 75405,
  [SMALL_STATE(1346)] = 75474,
  [SMALL_STATE(1347)] = 75543,
  [SMALL_STATE(1348)] = 75588,
  [SMALL_STATE(1349)] = 75633,
  [SMALL_STATE(1350)] = 75678,
  [SMALL_STATE(1351)] = 75741,
  [SMALL_STATE(1352)] = 75806,
  [SMALL_STATE(1353)] = 75873,
  [SMALL_STATE(1354)] = 75932,
  [SMALL_STATE(1355)] = 75987,
  [SMALL_STATE(1356)] = 76050,
  [SMALL_STATE(1357)] = 76119,
  [SMALL_STATE(1358)] = 76180,
  [SMALL_STATE(1359)] = 76235,
  [SMALL_STATE(1360)] = 76280,
  [SMALL_STATE(1361)] = 76325,
  [SMALL_STATE(1362)] = 76370,
  [SMALL_STATE(1363)] = 76435,
  [SMALL_STATE(1364)] = 76502,
  [SMALL_STATE(1365)] = 76561,
  [SMALL_STATE(1366)] = 76616,
  [SMALL_STATE(1367)] = 76685,
  [SMALL_STATE(1368)] = 76730,
  [SMALL_STATE(1369)] = 76791,
  [SMALL_STATE(1370)] = 76854,
  [SMALL_STATE(1371)] = 76919,
  [SMALL_STATE(1372)] = 76986,
  [SMALL_STATE(1373)] = 77045,
  [SMALL_STATE(1374)] = 77100,
  [SMALL_STATE(1375)] = 77169,
  [SMALL_STATE(1376)] = 77224,
  [SMALL_STATE(1377)] = 77285,
  [SMALL_STATE(1378)] = 77340,
  [SMALL_STATE(1379)] = 77385,
  [SMALL_STATE(1380)] = 77440,
  [SMALL_STATE(1381)] = 77495,
  [SMALL_STATE(1382)] = 77540,
  [SMALL_STATE(1383)] = 77585,
  [SMALL_STATE(1384)] = 77630,
  [SMALL_STATE(1385)] = 77679,
  [SMALL_STATE(1386)] = 77724,
  [SMALL_STATE(1387)] = 77773,
  [SMALL_STATE(1388)] = 77822,
  [SMALL_STATE(1389)] = 77871,
  [SMALL_STATE(1390)] = 77926,
  [SMALL_STATE(1391)] = 77975,
  [SMALL_STATE(1392)] = 78030,
  [SMALL_STATE(1393)] = 78075,
  [SMALL_STATE(1394)] = 78121,
  [SMALL_STATE(1395)] = 78165,
  [SMALL_STATE(1396)] = 78213,
  [SMALL_STATE(1397)] = 78257,
  [SMALL_STATE(1398)] = 78301,
  [SMALL_STATE(1399)] = 78345,
  [SMALL_STATE(1400)] = 78393,
  [SMALL_STATE(1401)] = 78441,
  [SMALL_STATE(1402)] = 78485,
  [SMALL_STATE(1403)] = 78531,
  [SMALL_STATE(1404)] = 78577,
  [SMALL_STATE(1405)] = 78623,
  [SMALL_STATE(1406)] = 78667,
  [SMALL_STATE(1407)] = 78711,
  [SMALL_STATE(1408)] = 78787,
  [SMALL_STATE(1409)] = 78831,
  [SMALL_STATE(1410)] = 78879,
  [SMALL_STATE(1411)] = 78923,
  [SMALL_STATE(1412)] = 78967,
  [SMALL_STATE(1413)] = 79011,
  [SMALL_STATE(1414)] = 79055,
  [SMALL_STATE(1415)] = 79099,
  [SMALL_STATE(1416)] = 79143,
  [SMALL_STATE(1417)] = 79187,
  [SMALL_STATE(1418)] = 79231,
  [SMALL_STATE(1419)] = 79275,
  [SMALL_STATE(1420)] = 79319,
  [SMALL_STATE(1421)] = 79363,
  [SMALL_STATE(1422)] = 79407,
  [SMALL_STATE(1423)] = 79451,
  [SMALL_STATE(1424)] = 79495,
  [SMALL_STATE(1425)] = 79539,
  [SMALL_STATE(1426)] = 79583,
  [SMALL_STATE(1427)] = 79627,
  [SMALL_STATE(1428)] = 79671,
  [SMALL_STATE(1429)] = 79715,
  [SMALL_STATE(1430)] = 79759,
  [SMALL_STATE(1431)] = 79803,
  [SMALL_STATE(1432)] = 79847,
  [SMALL_STATE(1433)] = 79891,
  [SMALL_STATE(1434)] = 79937,
  [SMALL_STATE(1435)] = 79985,
  [SMALL_STATE(1436)] = 80031,
  [SMALL_STATE(1437)] = 80075,
  [SMALL_STATE(1438)] = 80121,
  [SMALL_STATE(1439)] = 80165,
  [SMALL_STATE(1440)] = 80209,
  [SMALL_STATE(1441)] = 80253,
  [SMALL_STATE(1442)] = 80301,
  [SMALL_STATE(1443)] = 80345,
  [SMALL_STATE(1444)] = 80389,
  [SMALL_STATE(1445)] = 80465,
  [SMALL_STATE(1446)] = 80513,
  [SMALL_STATE(1447)] = 80557,
  [SMALL_STATE(1448)] = 80605,
  [SMALL_STATE(1449)] = 80653,
  [SMALL_STATE(1450)] = 80697,
  [SMALL_STATE(1451)] = 80741,
  [SMALL_STATE(1452)] = 80817,
  [SMALL_STATE(1453)] = 80861,
  [SMALL_STATE(1454)] = 80905,
  [SMALL_STATE(1455)] = 80949,
  [SMALL_STATE(1456)] = 80993,
  [SMALL_STATE(1457)] = 81037,
  [SMALL_STATE(1458)] = 81085,
  [SMALL_STATE(1459)] = 81129,
  [SMALL_STATE(1460)] = 81173,
  [SMALL_STATE(1461)] = 81217,
  [SMALL_STATE(1462)] = 81261,
  [SMALL_STATE(1463)] = 81305,
  [SMALL_STATE(1464)] = 81349,
  [SMALL_STATE(1465)] = 81393,
  [SMALL_STATE(1466)] = 81447,
  [SMALL_STATE(1467)] = 81495,
  [SMALL_STATE(1468)] = 81549,
  [SMALL_STATE(1469)] = 81593,
  [SMALL_STATE(1470)] = 81641,
  [SMALL_STATE(1471)] = 81685,
  [SMALL_STATE(1472)] = 81729,
  [SMALL_STATE(1473)] = 81773,
  [SMALL_STATE(1474)] = 81819,
  [SMALL_STATE(1475)] = 81863,
  [SMALL_STATE(1476)] = 81907,
  [SMALL_STATE(1477)] = 81953,
  [SMALL_STATE(1478)] = 81997,
  [SMALL_STATE(1479)] = 82043,
  [SMALL_STATE(1480)] = 82089,
  [SMALL_STATE(1481)] = 82133,
  [SMALL_STATE(1482)] = 82177,
  [SMALL_STATE(1483)] = 82223,
  [SMALL_STATE(1484)] = 82267,
  [SMALL_STATE(1485)] = 82313,
  [SMALL_STATE(1486)] = 82361,
  [SMALL_STATE(1487)] = 82405,
  [SMALL_STATE(1488)] = 82449,
  [SMALL_STATE(1489)] = 82497,
  [SMALL_STATE(1490)] = 82545,
  [SMALL_STATE(1491)] = 82593,
  [SMALL_STATE(1492)] = 82669,
  [SMALL_STATE(1493)] = 82715,
  [SMALL_STATE(1494)] = 82769,
  [SMALL_STATE(1495)] = 82819,
  [SMALL_STATE(1496)] = 82865,
  [SMALL_STATE(1497)] = 82925,
  [SMALL_STATE(1498)] = 82971,
  [SMALL_STATE(1499)] = 83015,
  [SMALL_STATE(1500)] = 83061,
  [SMALL_STATE(1501)] = 83109,
  [SMALL_STATE(1502)] = 83157,
  [SMALL_STATE(1503)] = 83201,
  [SMALL_STATE(1504)] = 83245,
  [SMALL_STATE(1505)] = 83289,
  [SMALL_STATE(1506)] = 83357,
  [SMALL_STATE(1507)] = 83401,
  [SMALL_STATE(1508)] = 83445,
  [SMALL_STATE(1509)] = 83499,
  [SMALL_STATE(1510)] = 83543,
  [SMALL_STATE(1511)] = 83601,
  [SMALL_STATE(1512)] = 83669,
  [SMALL_STATE(1513)] = 83737,
  [SMALL_STATE(1514)] = 83781,
  [SMALL_STATE(1515)] = 83843,
  [SMALL_STATE(1516)] = 83907,
  [SMALL_STATE(1517)] = 83951,
  [SMALL_STATE(1518)] = 83999,
  [SMALL_STATE(1519)] = 84043,
  [SMALL_STATE(1520)] = 84109,
  [SMALL_STATE(1521)] = 84159,
  [SMALL_STATE(1522)] = 84202,
  [SMALL_STATE(1523)] = 84245,
  [SMALL_STATE(1524)] = 84288,
  [SMALL_STATE(1525)] = 84331,
  [SMALL_STATE(1526)] = 84374,
  [SMALL_STATE(1527)] = 84417,
  [SMALL_STATE(1528)] = 84460,
  [SMALL_STATE(1529)] = 84503,
  [SMALL_STATE(1530)] = 84546,
  [SMALL_STATE(1531)] = 84589,
  [SMALL_STATE(1532)] = 84634,
  [SMALL_STATE(1533)] = 84677,
  [SMALL_STATE(1534)] = 84720,
  [SMALL_STATE(1535)] = 84763,
  [SMALL_STATE(1536)] = 84806,
  [SMALL_STATE(1537)] = 84849,
  [SMALL_STATE(1538)] = 84892,
  [SMALL_STATE(1539)] = 84939,
  [SMALL_STATE(1540)] = 84986,
  [SMALL_STATE(1541)] = 85033,
  [SMALL_STATE(1542)] = 85076,
  [SMALL_STATE(1543)] = 85121,
  [SMALL_STATE(1544)] = 85174,
  [SMALL_STATE(1545)] = 85217,
  [SMALL_STATE(1546)] = 85264,
  [SMALL_STATE(1547)] = 85307,
  [SMALL_STATE(1548)] = 85350,
  [SMALL_STATE(1549)] = 85393,
  [SMALL_STATE(1550)] = 85436,
  [SMALL_STATE(1551)] = 85479,
  [SMALL_STATE(1552)] = 85522,
  [SMALL_STATE(1553)] = 85565,
  [SMALL_STATE(1554)] = 85608,
  [SMALL_STATE(1555)] = 85651,
  [SMALL_STATE(1556)] = 85694,
  [SMALL_STATE(1557)] = 85737,
  [SMALL_STATE(1558)] = 85780,
  [SMALL_STATE(1559)] = 85823,
  [SMALL_STATE(1560)] = 85866,
  [SMALL_STATE(1561)] = 85909,
  [SMALL_STATE(1562)] = 85952,
  [SMALL_STATE(1563)] = 85995,
  [SMALL_STATE(1564)] = 86038,
  [SMALL_STATE(1565)] = 86081,
  [SMALL_STATE(1566)] = 86124,
  [SMALL_STATE(1567)] = 86167,
  [SMALL_STATE(1568)] = 86210,
  [SMALL_STATE(1569)] = 86253,
  [SMALL_STATE(1570)] = 86296,
  [SMALL_STATE(1571)] = 86339,
  [SMALL_STATE(1572)] = 86382,
  [SMALL_STATE(1573)] = 86425,
  [SMALL_STATE(1574)] = 86468,
  [SMALL_STATE(1575)] = 86515,
  [SMALL_STATE(1576)] = 86558,
  [SMALL_STATE(1577)] = 86601,
  [SMALL_STATE(1578)] = 86646,
  [SMALL_STATE(1579)] = 86689,
  [SMALL_STATE(1580)] = 86732,
  [SMALL_STATE(1581)] = 86779,
  [SMALL_STATE(1582)] = 86822,
  [SMALL_STATE(1583)] = 86869,
  [SMALL_STATE(1584)] = 86912,
  [SMALL_STATE(1585)] = 86955,
  [SMALL_STATE(1586)] = 86998,
  [SMALL_STATE(1587)] = 87041,
  [SMALL_STATE(1588)] = 87088,
  [SMALL_STATE(1589)] = 87135,
  [SMALL_STATE(1590)] = 87178,
  [SMALL_STATE(1591)] = 87221,
  [SMALL_STATE(1592)] = 87266,
  [SMALL_STATE(1593)] = 87313,
  [SMALL_STATE(1594)] = 87356,
  [SMALL_STATE(1595)] = 87401,
  [SMALL_STATE(1596)] = 87444,
  [SMALL_STATE(1597)] = 87487,
  [SMALL_STATE(1598)] = 87530,
  [SMALL_STATE(1599)] = 87573,
  [SMALL_STATE(1600)] = 87620,
  [SMALL_STATE(1601)] = 87663,
  [SMALL_STATE(1602)] = 87706,
  [SMALL_STATE(1603)] = 87753,
  [SMALL_STATE(1604)] = 87800,
  [SMALL_STATE(1605)] = 87843,
  [SMALL_STATE(1606)] = 87888,
  [SMALL_STATE(1607)] = 87931,
  [SMALL_STATE(1608)] = 87974,
  [SMALL_STATE(1609)] = 88017,
  [SMALL_STATE(1610)] = 88064,
  [SMALL_STATE(1611)] = 88111,
  [SMALL_STATE(1612)] = 88154,
  [SMALL_STATE(1613)] = 88197,
  [SMALL_STATE(1614)] = 88240,
  [SMALL_STATE(1615)] = 88283,
  [SMALL_STATE(1616)] = 88326,
  [SMALL_STATE(1617)] = 88369,
  [SMALL_STATE(1618)] = 88412,
  [SMALL_STATE(1619)] = 88455,
  [SMALL_STATE(1620)] = 88506,
  [SMALL_STATE(1621)] = 88553,
  [SMALL_STATE(1622)] = 88600,
  [SMALL_STATE(1623)] = 88647,
  [SMALL_STATE(1624)] = 88692,
  [SMALL_STATE(1625)] = 88735,
  [SMALL_STATE(1626)] = 88778,
  [SMALL_STATE(1627)] = 88821,
  [SMALL_STATE(1628)] = 88864,
  [SMALL_STATE(1629)] = 88917,
  [SMALL_STATE(1630)] = 88960,
  [SMALL_STATE(1631)] = 89005,
  [SMALL_STATE(1632)] = 89048,
  [SMALL_STATE(1633)] = 89091,
  [SMALL_STATE(1634)] = 89134,
  [SMALL_STATE(1635)] = 89179,
  [SMALL_STATE(1636)] = 89222,
  [SMALL_STATE(1637)] = 89269,
  [SMALL_STATE(1638)] = 89314,
  [SMALL_STATE(1639)] = 89359,
  [SMALL_STATE(1640)] = 89404,
  [SMALL_STATE(1641)] = 89455,
  [SMALL_STATE(1642)] = 89498,
  [SMALL_STATE(1643)] = 89541,
  [SMALL_STATE(1644)] = 89594,
  [SMALL_STATE(1645)] = 89653,
  [SMALL_STATE(1646)] = 89698,
  [SMALL_STATE(1647)] = 89743,
  [SMALL_STATE(1648)] = 89788,
  [SMALL_STATE(1649)] = 89831,
  [SMALL_STATE(1650)] = 89898,
  [SMALL_STATE(1651)] = 89943,
  [SMALL_STATE(1652)] = 89990,
  [SMALL_STATE(1653)] = 90043,
  [SMALL_STATE(1654)] = 90086,
  [SMALL_STATE(1655)] = 90129,
  [SMALL_STATE(1656)] = 90172,
  [SMALL_STATE(1657)] = 90215,
  [SMALL_STATE(1658)] = 90258,
  [SMALL_STATE(1659)] = 90315,
  [SMALL_STATE(1660)] = 90358,
  [SMALL_STATE(1661)] = 90401,
  [SMALL_STATE(1662)] = 90444,
  [SMALL_STATE(1663)] = 90509,
  [SMALL_STATE(1664)] = 90572,
  [SMALL_STATE(1665)] = 90619,
  [SMALL_STATE(1666)] = 90662,
  [SMALL_STATE(1667)] = 90705,
  [SMALL_STATE(1668)] = 90748,
  [SMALL_STATE(1669)] = 90791,
  [SMALL_STATE(1670)] = 90834,
  [SMALL_STATE(1671)] = 90879,
  [SMALL_STATE(1672)] = 90922,
  [SMALL_STATE(1673)] = 90967,
  [SMALL_STATE(1674)] = 91010,
  [SMALL_STATE(1675)] = 91053,
  [SMALL_STATE(1676)] = 91114,
  [SMALL_STATE(1677)] = 91157,
  [SMALL_STATE(1678)] = 91202,
  [SMALL_STATE(1679)] = 91245,
  [SMALL_STATE(1680)] = 91288,
  [SMALL_STATE(1681)] = 91331,
  [SMALL_STATE(1682)] = 91374,
  [SMALL_STATE(1683)] = 91417,
  [SMALL_STATE(1684)] = 91460,
  [SMALL_STATE(1685)] = 91503,
  [SMALL_STATE(1686)] = 91570,
  [SMALL_STATE(1687)] = 91613,
  [SMALL_STATE(1688)] = 91656,
  [SMALL_STATE(1689)] = 91699,
  [SMALL_STATE(1690)] = 91742,
  [SMALL_STATE(1691)] = 91785,
  [SMALL_STATE(1692)] = 91828,
  [SMALL_STATE(1693)] = 91871,
  [SMALL_STATE(1694)] = 91914,
  [SMALL_STATE(1695)] = 91957,
  [SMALL_STATE(1696)] = 92000,
  [SMALL_STATE(1697)] = 92043,
  [SMALL_STATE(1698)] = 92086,
  [SMALL_STATE(1699)] = 92129,
  [SMALL_STATE(1700)] = 92172,
  [SMALL_STATE(1701)] = 92215,
  [SMALL_STATE(1702)] = 92282,
  [SMALL_STATE(1703)] = 92328,
  [SMALL_STATE(1704)] = 92372,
  [SMALL_STATE(1705)] = 92414,
  [SMALL_STATE(1706)] = 92456,
  [SMALL_STATE(1707)] = 92498,
  [SMALL_STATE(1708)] = 92540,
  [SMALL_STATE(1709)] = 92584,
  [SMALL_STATE(1710)] = 92626,
  [SMALL_STATE(1711)] = 92668,
  [SMALL_STATE(1712)] = 92710,
  [SMALL_STATE(1713)] = 92754,
  [SMALL_STATE(1714)] = 92796,
  [SMALL_STATE(1715)] = 92838,
  [SMALL_STATE(1716)] = 92880,
  [SMALL_STATE(1717)] = 92922,
  [SMALL_STATE(1718)] = 92964,
  [SMALL_STATE(1719)] = 93006,
  [SMALL_STATE(1720)] = 93050,
  [SMALL_STATE(1721)] = 93094,
  [SMALL_STATE(1722)] = 93138,
  [SMALL_STATE(1723)] = 93182,
  [SMALL_STATE(1724)] = 93224,
  [SMALL_STATE(1725)] = 93268,
  [SMALL_STATE(1726)] = 93312,
  [SMALL_STATE(1727)] = 93360,
  [SMALL_STATE(1728)] = 93404,
  [SMALL_STATE(1729)] = 93446,
  [SMALL_STATE(1730)] = 93488,
  [SMALL_STATE(1731)] = 93532,
  [SMALL_STATE(1732)] = 93576,
  [SMALL_STATE(1733)] = 93620,
  [SMALL_STATE(1734)] = 93662,
  [SMALL_STATE(1735)] = 93712,
  [SMALL_STATE(1736)] = 93756,
  [SMALL_STATE(1737)] = 93802,
  [SMALL_STATE(1738)] = 93844,
  [SMALL_STATE(1739)] = 93886,
  [SMALL_STATE(1740)] = 93928,
  [SMALL_STATE(1741)] = 93970,
  [SMALL_STATE(1742)] = 94012,
  [SMALL_STATE(1743)] = 94054,
  [SMALL_STATE(1744)] = 94096,
  [SMALL_STATE(1745)] = 94138,
  [SMALL_STATE(1746)] = 94180,
  [SMALL_STATE(1747)] = 94222,
  [SMALL_STATE(1748)] = 94264,
  [SMALL_STATE(1749)] = 94306,
  [SMALL_STATE(1750)] = 94348,
  [SMALL_STATE(1751)] = 94394,
  [SMALL_STATE(1752)] = 94436,
  [SMALL_STATE(1753)] = 94478,
  [SMALL_STATE(1754)] = 94522,
  [SMALL_STATE(1755)] = 94566,
  [SMALL_STATE(1756)] = 94610,
  [SMALL_STATE(1757)] = 94652,
  [SMALL_STATE(1758)] = 94696,
  [SMALL_STATE(1759)] = 94741,
  [SMALL_STATE(1760)] = 94782,
  [SMALL_STATE(1761)] = 94823,
  [SMALL_STATE(1762)] = 94864,
  [SMALL_STATE(1763)] = 94909,
  [SMALL_STATE(1764)] = 94950,
  [SMALL_STATE(1765)] = 94993,
  [SMALL_STATE(1766)] = 95034,
  [SMALL_STATE(1767)] = 95075,
  [SMALL_STATE(1768)] = 95116,
  [SMALL_STATE(1769)] = 95159,
  [SMALL_STATE(1770)] = 95202,
  [SMALL_STATE(1771)] = 95245,
  [SMALL_STATE(1772)] = 95288,
  [SMALL_STATE(1773)] = 95329,
  [SMALL_STATE(1774)] = 95370,
  [SMALL_STATE(1775)] = 95411,
  [SMALL_STATE(1776)] = 95452,
  [SMALL_STATE(1777)] = 95493,
  [SMALL_STATE(1778)] = 95534,
  [SMALL_STATE(1779)] = 95577,
  [SMALL_STATE(1780)] = 95618,
  [SMALL_STATE(1781)] = 95659,
  [SMALL_STATE(1782)] = 95700,
  [SMALL_STATE(1783)] = 95741,
  [SMALL_STATE(1784)] = 95782,
  [SMALL_STATE(1785)] = 95823,
  [SMALL_STATE(1786)] = 95864,
  [SMALL_STATE(1787)] = 95907,
  [SMALL_STATE(1788)] = 95948,
  [SMALL_STATE(1789)] = 95989,
  [SMALL_STATE(1790)] = 96030,
  [SMALL_STATE(1791)] = 96071,
  [SMALL_STATE(1792)] = 96112,
  [SMALL_STATE(1793)] = 96155,
  [SMALL_STATE(1794)] = 96196,
  [SMALL_STATE(1795)] = 96241,
  [SMALL_STATE(1796)] = 96282,
  [SMALL_STATE(1797)] = 96323,
  [SMALL_STATE(1798)] = 96366,
  [SMALL_STATE(1799)] = 96407,
  [SMALL_STATE(1800)] = 96448,
  [SMALL_STATE(1801)] = 96491,
  [SMALL_STATE(1802)] = 96532,
  [SMALL_STATE(1803)] = 96573,
  [SMALL_STATE(1804)] = 96614,
  [SMALL_STATE(1805)] = 96655,
  [SMALL_STATE(1806)] = 96696,
  [SMALL_STATE(1807)] = 96737,
  [SMALL_STATE(1808)] = 96778,
  [SMALL_STATE(1809)] = 96819,
  [SMALL_STATE(1810)] = 96860,
  [SMALL_STATE(1811)] = 96901,
  [SMALL_STATE(1812)] = 96942,
  [SMALL_STATE(1813)] = 96983,
  [SMALL_STATE(1814)] = 97024,
  [SMALL_STATE(1815)] = 97067,
  [SMALL_STATE(1816)] = 97108,
  [SMALL_STATE(1817)] = 97149,
  [SMALL_STATE(1818)] = 97192,
  [SMALL_STATE(1819)] = 97266,
  [SMALL_STATE(1820)] = 97340,
  [SMALL_STATE(1821)] = 97377,
  [SMALL_STATE(1822)] = 97414,
  [SMALL_STATE(1823)] = 97451,
  [SMALL_STATE(1824)] = 97488,
  [SMALL_STATE(1825)] = 97525,
  [SMALL_STATE(1826)] = 97562,
  [SMALL_STATE(1827)] = 97599,
  [SMALL_STATE(1828)] = 97636,
  [SMALL_STATE(1829)] = 97673,
  [SMALL_STATE(1830)] = 97710,
  [SMALL_STATE(1831)] = 97747,
  [SMALL_STATE(1832)] = 97784,
  [SMALL_STATE(1833)] = 97821,
  [SMALL_STATE(1834)] = 97858,
  [SMALL_STATE(1835)] = 97895,
  [SMALL_STATE(1836)] = 97932,
  [SMALL_STATE(1837)] = 97969,
  [SMALL_STATE(1838)] = 98006,
  [SMALL_STATE(1839)] = 98043,
  [SMALL_STATE(1840)] = 98080,
  [SMALL_STATE(1841)] = 98117,
  [SMALL_STATE(1842)] = 98154,
  [SMALL_STATE(1843)] = 98191,
  [SMALL_STATE(1844)] = 98228,
  [SMALL_STATE(1845)] = 98265,
  [SMALL_STATE(1846)] = 98302,
  [SMALL_STATE(1847)] = 98339,
  [SMALL_STATE(1848)] = 98376,
  [SMALL_STATE(1849)] = 98413,
  [SMALL_STATE(1850)] = 98450,
  [SMALL_STATE(1851)] = 98487,
  [SMALL_STATE(1852)] = 98524,
  [SMALL_STATE(1853)] = 98561,
  [SMALL_STATE(1854)] = 98598,
  [SMALL_STATE(1855)] = 98635,
  [SMALL_STATE(1856)] = 98672,
  [SMALL_STATE(1857)] = 98709,
  [SMALL_STATE(1858)] = 98746,
  [SMALL_STATE(1859)] = 98783,
  [SMALL_STATE(1860)] = 98820,
  [SMALL_STATE(1861)] = 98888,
  [SMALL_STATE(1862)] = 98956,
  [SMALL_STATE(1863)] = 99024,
  [SMALL_STATE(1864)] = 99092,
  [SMALL_STATE(1865)] = 99160,
  [SMALL_STATE(1866)] = 99228,
  [SMALL_STATE(1867)] = 99296,
  [SMALL_STATE(1868)] = 99364,
  [SMALL_STATE(1869)] = 99432,
  [SMALL_STATE(1870)] = 99500,
  [SMALL_STATE(1871)] = 99568,
  [SMALL_STATE(1872)] = 99636,
  [SMALL_STATE(1873)] = 99704,
  [SMALL_STATE(1874)] = 99772,
  [SMALL_STATE(1875)] = 99840,
  [SMALL_STATE(1876)] = 99908,
  [SMALL_STATE(1877)] = 99976,
  [SMALL_STATE(1878)] = 100044,
  [SMALL_STATE(1879)] = 100112,
  [SMALL_STATE(1880)] = 100180,
  [SMALL_STATE(1881)] = 100248,
  [SMALL_STATE(1882)] = 100316,
  [SMALL_STATE(1883)] = 100384,
  [SMALL_STATE(1884)] = 100452,
  [SMALL_STATE(1885)] = 100520,
  [SMALL_STATE(1886)] = 100588,
  [SMALL_STATE(1887)] = 100656,
  [SMALL_STATE(1888)] = 100724,
  [SMALL_STATE(1889)] = 100792,
  [SMALL_STATE(1890)] = 100860,
  [SMALL_STATE(1891)] = 100928,
  [SMALL_STATE(1892)] = 100996,
  [SMALL_STATE(1893)] = 101064,
  [SMALL_STATE(1894)] = 101132,
  [SMALL_STATE(1895)] = 101200,
  [SMALL_STATE(1896)] = 101268,
  [SMALL_STATE(1897)] = 101333,
  [SMALL_STATE(1898)] = 101398,
  [SMALL_STATE(1899)] = 101463,
  [SMALL_STATE(1900)] = 101528,
  [SMALL_STATE(1901)] = 101593,
  [SMALL_STATE(1902)] = 101659,
  [SMALL_STATE(1903)] = 101725,
  [SMALL_STATE(1904)] = 101791,
  [SMALL_STATE(1905)] = 101857,
  [SMALL_STATE(1906)] = 101923,
  [SMALL_STATE(1907)] = 101989,
  [SMALL_STATE(1908)] = 102055,
  [SMALL_STATE(1909)] = 102121,
  [SMALL_STATE(1910)] = 102187,
  [SMALL_STATE(1911)] = 102253,
  [SMALL_STATE(1912)] = 102319,
  [SMALL_STATE(1913)] = 102385,
  [SMALL_STATE(1914)] = 102451,
  [SMALL_STATE(1915)] = 102517,
  [SMALL_STATE(1916)] = 102583,
  [SMALL_STATE(1917)] = 102649,
  [SMALL_STATE(1918)] = 102715,
  [SMALL_STATE(1919)] = 102781,
  [SMALL_STATE(1920)] = 102847,
  [SMALL_STATE(1921)] = 102913,
  [SMALL_STATE(1922)] = 102976,
  [SMALL_STATE(1923)] = 103034,
  [SMALL_STATE(1924)] = 103092,
  [SMALL_STATE(1925)] = 103150,
  [SMALL_STATE(1926)] = 103208,
  [SMALL_STATE(1927)] = 103266,
  [SMALL_STATE(1928)] = 103324,
  [SMALL_STATE(1929)] = 103382,
  [SMALL_STATE(1930)] = 103440,
  [SMALL_STATE(1931)] = 103482,
  [SMALL_STATE(1932)] = 103524,
  [SMALL_STATE(1933)] = 103564,
  [SMALL_STATE(1934)] = 103596,
  [SMALL_STATE(1935)] = 103628,
  [SMALL_STATE(1936)] = 103668,
  [SMALL_STATE(1937)] = 103708,
  [SMALL_STATE(1938)] = 103748,
  [SMALL_STATE(1939)] = 103780,
  [SMALL_STATE(1940)] = 103812,
  [SMALL_STATE(1941)] = 103844,
  [SMALL_STATE(1942)] = 103876,
  [SMALL_STATE(1943)] = 103913,
  [SMALL_STATE(1944)] = 103952,
  [SMALL_STATE(1945)] = 103991,
  [SMALL_STATE(1946)] = 104030,
  [SMALL_STATE(1947)] = 104069,
  [SMALL_STATE(1948)] = 104106,
  [SMALL_STATE(1949)] = 104136,
  [SMALL_STATE(1950)] = 104174,
  [SMALL_STATE(1951)] = 104204,
  [SMALL_STATE(1952)] = 104234,
  [SMALL_STATE(1953)] = 104272,
  [SMALL_STATE(1954)] = 104310,
  [SMALL_STATE(1955)] = 104340,
  [SMALL_STATE(1956)] = 104370,
  [SMALL_STATE(1957)] = 104400,
  [SMALL_STATE(1958)] = 104438,
  [SMALL_STATE(1959)] = 104468,
  [SMALL_STATE(1960)] = 104498,
  [SMALL_STATE(1961)] = 104527,
  [SMALL_STATE(1962)] = 104552,
  [SMALL_STATE(1963)] = 104581,
  [SMALL_STATE(1964)] = 104610,
  [SMALL_STATE(1965)] = 104657,
  [SMALL_STATE(1966)] = 104686,
  [SMALL_STATE(1967)] = 104733,
  [SMALL_STATE(1968)] = 104780,
  [SMALL_STATE(1969)] = 104827,
  [SMALL_STATE(1970)] = 104856,
  [SMALL_STATE(1971)] = 104885,
  [SMALL_STATE(1972)] = 104914,
  [SMALL_STATE(1973)] = 104961,
  [SMALL_STATE(1974)] = 104990,
  [SMALL_STATE(1975)] = 105019,
  [SMALL_STATE(1976)] = 105044,
  [SMALL_STATE(1977)] = 105073,
  [SMALL_STATE(1978)] = 105120,
  [SMALL_STATE(1979)] = 105149,
  [SMALL_STATE(1980)] = 105196,
  [SMALL_STATE(1981)] = 105225,
  [SMALL_STATE(1982)] = 105254,
  [SMALL_STATE(1983)] = 105283,
  [SMALL_STATE(1984)] = 105312,
  [SMALL_STATE(1985)] = 105341,
  [SMALL_STATE(1986)] = 105370,
  [SMALL_STATE(1987)] = 105399,
  [SMALL_STATE(1988)] = 105446,
  [SMALL_STATE(1989)] = 105493,
  [SMALL_STATE(1990)] = 105522,
  [SMALL_STATE(1991)] = 105551,
  [SMALL_STATE(1992)] = 105598,
  [SMALL_STATE(1993)] = 105623,
  [SMALL_STATE(1994)] = 105652,
  [SMALL_STATE(1995)] = 105677,
  [SMALL_STATE(1996)] = 105706,
  [SMALL_STATE(1997)] = 105753,
  [SMALL_STATE(1998)] = 105784,
  [SMALL_STATE(1999)] = 105813,
  [SMALL_STATE(2000)] = 105842,
  [SMALL_STATE(2001)] = 105888,
  [SMALL_STATE(2002)] = 105934,
  [SMALL_STATE(2003)] = 105958,
  [SMALL_STATE(2004)] = 106004,
  [SMALL_STATE(2005)] = 106050,
  [SMALL_STATE(2006)] = 106096,
  [SMALL_STATE(2007)] = 106142,
  [SMALL_STATE(2008)] = 106166,
  [SMALL_STATE(2009)] = 106212,
  [SMALL_STATE(2010)] = 106244,
  [SMALL_STATE(2011)] = 106274,
  [SMALL_STATE(2012)] = 106308,
  [SMALL_STATE(2013)] = 106354,
  [SMALL_STATE(2014)] = 106400,
  [SMALL_STATE(2015)] = 106446,
  [SMALL_STATE(2016)] = 106470,
  [SMALL_STATE(2017)] = 106498,
  [SMALL_STATE(2018)] = 106544,
  [SMALL_STATE(2019)] = 106590,
  [SMALL_STATE(2020)] = 106622,
  [SMALL_STATE(2021)] = 106646,
  [SMALL_STATE(2022)] = 106674,
  [SMALL_STATE(2023)] = 106708,
  [SMALL_STATE(2024)] = 106751,
  [SMALL_STATE(2025)] = 106791,
  [SMALL_STATE(2026)] = 106831,
  [SMALL_STATE(2027)] = 106871,
  [SMALL_STATE(2028)] = 106897,
  [SMALL_STATE(2029)] = 106937,
  [SMALL_STATE(2030)] = 106977,
  [SMALL_STATE(2031)] = 107017,
  [SMALL_STATE(2032)] = 107057,
  [SMALL_STATE(2033)] = 107097,
  [SMALL_STATE(2034)] = 107137,
  [SMALL_STATE(2035)] = 107177,
  [SMALL_STATE(2036)] = 107217,
  [SMALL_STATE(2037)] = 107257,
  [SMALL_STATE(2038)] = 107297,
  [SMALL_STATE(2039)] = 107337,
  [SMALL_STATE(2040)] = 107377,
  [SMALL_STATE(2041)] = 107417,
  [SMALL_STATE(2042)] = 107457,
  [SMALL_STATE(2043)] = 107497,
  [SMALL_STATE(2044)] = 107537,
  [SMALL_STATE(2045)] = 107577,
  [SMALL_STATE(2046)] = 107617,
  [SMALL_STATE(2047)] = 107657,
  [SMALL_STATE(2048)] = 107697,
  [SMALL_STATE(2049)] = 107737,
  [SMALL_STATE(2050)] = 107777,
  [SMALL_STATE(2051)] = 107817,
  [SMALL_STATE(2052)] = 107857,
  [SMALL_STATE(2053)] = 107894,
  [SMALL_STATE(2054)] = 107931,
  [SMALL_STATE(2055)] = 107972,
  [SMALL_STATE(2056)] = 107997,
  [SMALL_STATE(2057)] = 108024,
  [SMALL_STATE(2058)] = 108065,
  [SMALL_STATE(2059)] = 108106,
  [SMALL_STATE(2060)] = 108147,
  [SMALL_STATE(2061)] = 108188,
  [SMALL_STATE(2062)] = 108207,
  [SMALL_STATE(2063)] = 108230,
  [SMALL_STATE(2064)] = 108271,
  [SMALL_STATE(2065)] = 108312,
  [SMALL_STATE(2066)] = 108339,
  [SMALL_STATE(2067)] = 108358,
  [SMALL_STATE(2068)] = 108379,
  [SMALL_STATE(2069)] = 108420,
  [SMALL_STATE(2070)] = 108447,
  [SMALL_STATE(2071)] = 108466,
  [SMALL_STATE(2072)] = 108507,
  [SMALL_STATE(2073)] = 108545,
  [SMALL_STATE(2074)] = 108583,
  [SMALL_STATE(2075)] = 108615,
  [SMALL_STATE(2076)] = 108653,
  [SMALL_STATE(2077)] = 108691,
  [SMALL_STATE(2078)] = 108729,
  [SMALL_STATE(2079)] = 108767,
  [SMALL_STATE(2080)] = 108805,
  [SMALL_STATE(2081)] = 108843,
  [SMALL_STATE(2082)] = 108881,
  [SMALL_STATE(2083)] = 108919,
  [SMALL_STATE(2084)] = 108957,
  [SMALL_STATE(2085)] = 108985,
  [SMALL_STATE(2086)] = 109023,
  [SMALL_STATE(2087)] = 109061,
  [SMALL_STATE(2088)] = 109099,
  [SMALL_STATE(2089)] = 109137,
  [SMALL_STATE(2090)] = 109175,
  [SMALL_STATE(2091)] = 109213,
  [SMALL_STATE(2092)] = 109251,
  [SMALL_STATE(2093)] = 109289,
  [SMALL_STATE(2094)] = 109317,
  [SMALL_STATE(2095)] = 109355,
  [SMALL_STATE(2096)] = 109393,
  [SMALL_STATE(2097)] = 109421,
  [SMALL_STATE(2098)] = 109459,
  [SMALL_STATE(2099)] = 109497,
  [SMALL_STATE(2100)] = 109535,
  [SMALL_STATE(2101)] = 109573,
  [SMALL_STATE(2102)] = 109611,
  [SMALL_STATE(2103)] = 109649,
  [SMALL_STATE(2104)] = 109687,
  [SMALL_STATE(2105)] = 109704,
  [SMALL_STATE(2106)] = 109729,
  [SMALL_STATE(2107)] = 109754,
  [SMALL_STATE(2108)] = 109777,
  [SMALL_STATE(2109)] = 109798,
  [SMALL_STATE(2110)] = 109815,
  [SMALL_STATE(2111)] = 109832,
  [SMALL_STATE(2112)] = 109851,
  [SMALL_STATE(2113)] = 109868,
  [SMALL_STATE(2114)] = 109893,
  [SMALL_STATE(2115)] = 109918,
  [SMALL_STATE(2116)] = 109943,
  [SMALL_STATE(2117)] = 109968,
  [SMALL_STATE(2118)] = 109997,
  [SMALL_STATE(2119)] = 110022,
  [SMALL_STATE(2120)] = 110047,
  [SMALL_STATE(2121)] = 110072,
  [SMALL_STATE(2122)] = 110095,
  [SMALL_STATE(2123)] = 110112,
  [SMALL_STATE(2124)] = 110131,
  [SMALL_STATE(2125)] = 110148,
  [SMALL_STATE(2126)] = 110169,
  [SMALL_STATE(2127)] = 110198,
  [SMALL_STATE(2128)] = 110223,
  [SMALL_STATE(2129)] = 110247,
  [SMALL_STATE(2130)] = 110263,
  [SMALL_STATE(2131)] = 110279,
  [SMALL_STATE(2132)] = 110297,
  [SMALL_STATE(2133)] = 110317,
  [SMALL_STATE(2134)] = 110337,
  [SMALL_STATE(2135)] = 110361,
  [SMALL_STATE(2136)] = 110377,
  [SMALL_STATE(2137)] = 110401,
  [SMALL_STATE(2138)] = 110425,
  [SMALL_STATE(2139)] = 110445,
  [SMALL_STATE(2140)] = 110461,
  [SMALL_STATE(2141)] = 110485,
  [SMALL_STATE(2142)] = 110509,
  [SMALL_STATE(2143)] = 110531,
  [SMALL_STATE(2144)] = 110553,
  [SMALL_STATE(2145)] = 110573,
  [SMALL_STATE(2146)] = 110589,
  [SMALL_STATE(2147)] = 110607,
  [SMALL_STATE(2148)] = 110627,
  [SMALL_STATE(2149)] = 110643,
  [SMALL_STATE(2150)] = 110665,
  [SMALL_STATE(2151)] = 110683,
  [SMALL_STATE(2152)] = 110707,
  [SMALL_STATE(2153)] = 110727,
  [SMALL_STATE(2154)] = 110751,
  [SMALL_STATE(2155)] = 110775,
  [SMALL_STATE(2156)] = 110799,
  [SMALL_STATE(2157)] = 110823,
  [SMALL_STATE(2158)] = 110847,
  [SMALL_STATE(2159)] = 110871,
  [SMALL_STATE(2160)] = 110893,
  [SMALL_STATE(2161)] = 110915,
  [SMALL_STATE(2162)] = 110933,
  [SMALL_STATE(2163)] = 110953,
  [SMALL_STATE(2164)] = 110977,
  [SMALL_STATE(2165)] = 111007,
  [SMALL_STATE(2166)] = 111025,
  [SMALL_STATE(2167)] = 111049,
  [SMALL_STATE(2168)] = 111068,
  [SMALL_STATE(2169)] = 111087,
  [SMALL_STATE(2170)] = 111112,
  [SMALL_STATE(2171)] = 111141,
  [SMALL_STATE(2172)] = 111170,
  [SMALL_STATE(2173)] = 111189,
  [SMALL_STATE(2174)] = 111206,
  [SMALL_STATE(2175)] = 111225,
  [SMALL_STATE(2176)] = 111252,
  [SMALL_STATE(2177)] = 111269,
  [SMALL_STATE(2178)] = 111288,
  [SMALL_STATE(2179)] = 111311,
  [SMALL_STATE(2180)] = 111340,
  [SMALL_STATE(2181)] = 111367,
  [SMALL_STATE(2182)] = 111386,
  [SMALL_STATE(2183)] = 111415,
  [SMALL_STATE(2184)] = 111436,
  [SMALL_STATE(2185)] = 111455,
  [SMALL_STATE(2186)] = 111470,
  [SMALL_STATE(2187)] = 111499,
  [SMALL_STATE(2188)] = 111524,
  [SMALL_STATE(2189)] = 111545,
  [SMALL_STATE(2190)] = 111562,
  [SMALL_STATE(2191)] = 111589,
  [SMALL_STATE(2192)] = 111618,
  [SMALL_STATE(2193)] = 111635,
  [SMALL_STATE(2194)] = 111664,
  [SMALL_STATE(2195)] = 111685,
  [SMALL_STATE(2196)] = 111710,
  [SMALL_STATE(2197)] = 111735,
  [SMALL_STATE(2198)] = 111764,
  [SMALL_STATE(2199)] = 111783,
  [SMALL_STATE(2200)] = 111802,
  [SMALL_STATE(2201)] = 111831,
  [SMALL_STATE(2202)] = 111858,
  [SMALL_STATE(2203)] = 111883,
  [SMALL_STATE(2204)] = 111904,
  [SMALL_STATE(2205)] = 111933,
  [SMALL_STATE(2206)] = 111952,
  [SMALL_STATE(2207)] = 111971,
  [SMALL_STATE(2208)] = 111992,
  [SMALL_STATE(2209)] = 112015,
  [SMALL_STATE(2210)] = 112032,
  [SMALL_STATE(2211)] = 112057,
  [SMALL_STATE(2212)] = 112076,
  [SMALL_STATE(2213)] = 112097,
  [SMALL_STATE(2214)] = 112120,
  [SMALL_STATE(2215)] = 112147,
  [SMALL_STATE(2216)] = 112168,
  [SMALL_STATE(2217)] = 112189,
  [SMALL_STATE(2218)] = 112208,
  [SMALL_STATE(2219)] = 112227,
  [SMALL_STATE(2220)] = 112248,
  [SMALL_STATE(2221)] = 112269,
  [SMALL_STATE(2222)] = 112292,
  [SMALL_STATE(2223)] = 112315,
  [SMALL_STATE(2224)] = 112336,
  [SMALL_STATE(2225)] = 112355,
  [SMALL_STATE(2226)] = 112378,
  [SMALL_STATE(2227)] = 112399,
  [SMALL_STATE(2228)] = 112426,
  [SMALL_STATE(2229)] = 112455,
  [SMALL_STATE(2230)] = 112482,
  [SMALL_STATE(2231)] = 112503,
  [SMALL_STATE(2232)] = 112524,
  [SMALL_STATE(2233)] = 112547,
  [SMALL_STATE(2234)] = 112574,
  [SMALL_STATE(2235)] = 112597,
  [SMALL_STATE(2236)] = 112618,
  [SMALL_STATE(2237)] = 112635,
  [SMALL_STATE(2238)] = 112654,
  [SMALL_STATE(2239)] = 112675,
  [SMALL_STATE(2240)] = 112693,
  [SMALL_STATE(2241)] = 112719,
  [SMALL_STATE(2242)] = 112745,
  [SMALL_STATE(2243)] = 112767,
  [SMALL_STATE(2244)] = 112783,
  [SMALL_STATE(2245)] = 112807,
  [SMALL_STATE(2246)] = 112825,
  [SMALL_STATE(2247)] = 112851,
  [SMALL_STATE(2248)] = 112875,
  [SMALL_STATE(2249)] = 112901,
  [SMALL_STATE(2250)] = 112927,
  [SMALL_STATE(2251)] = 112953,
  [SMALL_STATE(2252)] = 112973,
  [SMALL_STATE(2253)] = 112995,
  [SMALL_STATE(2254)] = 113013,
  [SMALL_STATE(2255)] = 113031,
  [SMALL_STATE(2256)] = 113045,
  [SMALL_STATE(2257)] = 113061,
  [SMALL_STATE(2258)] = 113079,
  [SMALL_STATE(2259)] = 113105,
  [SMALL_STATE(2260)] = 113127,
  [SMALL_STATE(2261)] = 113153,
  [SMALL_STATE(2262)] = 113179,
  [SMALL_STATE(2263)] = 113193,
  [SMALL_STATE(2264)] = 113211,
  [SMALL_STATE(2265)] = 113237,
  [SMALL_STATE(2266)] = 113255,
  [SMALL_STATE(2267)] = 113279,
  [SMALL_STATE(2268)] = 113305,
  [SMALL_STATE(2269)] = 113327,
  [SMALL_STATE(2270)] = 113345,
  [SMALL_STATE(2271)] = 113367,
  [SMALL_STATE(2272)] = 113393,
  [SMALL_STATE(2273)] = 113419,
  [SMALL_STATE(2274)] = 113443,
  [SMALL_STATE(2275)] = 113469,
  [SMALL_STATE(2276)] = 113495,
  [SMALL_STATE(2277)] = 113517,
  [SMALL_STATE(2278)] = 113543,
  [SMALL_STATE(2279)] = 113565,
  [SMALL_STATE(2280)] = 113587,
  [SMALL_STATE(2281)] = 113609,
  [SMALL_STATE(2282)] = 113635,
  [SMALL_STATE(2283)] = 113657,
  [SMALL_STATE(2284)] = 113675,
  [SMALL_STATE(2285)] = 113701,
  [SMALL_STATE(2286)] = 113723,
  [SMALL_STATE(2287)] = 113741,
  [SMALL_STATE(2288)] = 113759,
  [SMALL_STATE(2289)] = 113779,
  [SMALL_STATE(2290)] = 113805,
  [SMALL_STATE(2291)] = 113825,
  [SMALL_STATE(2292)] = 113843,
  [SMALL_STATE(2293)] = 113864,
  [SMALL_STATE(2294)] = 113885,
  [SMALL_STATE(2295)] = 113906,
  [SMALL_STATE(2296)] = 113925,
  [SMALL_STATE(2297)] = 113946,
  [SMALL_STATE(2298)] = 113967,
  [SMALL_STATE(2299)] = 113982,
  [SMALL_STATE(2300)] = 114003,
  [SMALL_STATE(2301)] = 114016,
  [SMALL_STATE(2302)] = 114037,
  [SMALL_STATE(2303)] = 114058,
  [SMALL_STATE(2304)] = 114079,
  [SMALL_STATE(2305)] = 114100,
  [SMALL_STATE(2306)] = 114121,
  [SMALL_STATE(2307)] = 114142,
  [SMALL_STATE(2308)] = 114163,
  [SMALL_STATE(2309)] = 114186,
  [SMALL_STATE(2310)] = 114203,
  [SMALL_STATE(2311)] = 114220,
  [SMALL_STATE(2312)] = 114241,
  [SMALL_STATE(2313)] = 114262,
  [SMALL_STATE(2314)] = 114283,
  [SMALL_STATE(2315)] = 114304,
  [SMALL_STATE(2316)] = 114325,
  [SMALL_STATE(2317)] = 114338,
  [SMALL_STATE(2318)] = 114355,
  [SMALL_STATE(2319)] = 114378,
  [SMALL_STATE(2320)] = 114391,
  [SMALL_STATE(2321)] = 114414,
  [SMALL_STATE(2322)] = 114435,
  [SMALL_STATE(2323)] = 114456,
  [SMALL_STATE(2324)] = 114477,
  [SMALL_STATE(2325)] = 114490,
  [SMALL_STATE(2326)] = 114507,
  [SMALL_STATE(2327)] = 114522,
  [SMALL_STATE(2328)] = 114543,
  [SMALL_STATE(2329)] = 114556,
  [SMALL_STATE(2330)] = 114569,
  [SMALL_STATE(2331)] = 114586,
  [SMALL_STATE(2332)] = 114599,
  [SMALL_STATE(2333)] = 114614,
  [SMALL_STATE(2334)] = 114627,
  [SMALL_STATE(2335)] = 114648,
  [SMALL_STATE(2336)] = 114669,
  [SMALL_STATE(2337)] = 114690,
  [SMALL_STATE(2338)] = 114703,
  [SMALL_STATE(2339)] = 114718,
  [SMALL_STATE(2340)] = 114737,
  [SMALL_STATE(2341)] = 114750,
  [SMALL_STATE(2342)] = 114767,
  [SMALL_STATE(2343)] = 114784,
  [SMALL_STATE(2344)] = 114799,
  [SMALL_STATE(2345)] = 114812,
  [SMALL_STATE(2346)] = 114833,
  [SMALL_STATE(2347)] = 114850,
  [SMALL_STATE(2348)] = 114863,
  [SMALL_STATE(2349)] = 114880,
  [SMALL_STATE(2350)] = 114897,
  [SMALL_STATE(2351)] = 114918,
  [SMALL_STATE(2352)] = 114939,
  [SMALL_STATE(2353)] = 114956,
  [SMALL_STATE(2354)] = 114977,
  [SMALL_STATE(2355)] = 114994,
  [SMALL_STATE(2356)] = 115015,
  [SMALL_STATE(2357)] = 115028,
  [SMALL_STATE(2358)] = 115049,
  [SMALL_STATE(2359)] = 115062,
  [SMALL_STATE(2360)] = 115075,
  [SMALL_STATE(2361)] = 115096,
  [SMALL_STATE(2362)] = 115117,
  [SMALL_STATE(2363)] = 115134,
  [SMALL_STATE(2364)] = 115151,
  [SMALL_STATE(2365)] = 115168,
  [SMALL_STATE(2366)] = 115185,
  [SMALL_STATE(2367)] = 115202,
  [SMALL_STATE(2368)] = 115223,
  [SMALL_STATE(2369)] = 115240,
  [SMALL_STATE(2370)] = 115255,
  [SMALL_STATE(2371)] = 115272,
  [SMALL_STATE(2372)] = 115293,
  [SMALL_STATE(2373)] = 115308,
  [SMALL_STATE(2374)] = 115331,
  [SMALL_STATE(2375)] = 115344,
  [SMALL_STATE(2376)] = 115367,
  [SMALL_STATE(2377)] = 115388,
  [SMALL_STATE(2378)] = 115409,
  [SMALL_STATE(2379)] = 115426,
  [SMALL_STATE(2380)] = 115449,
  [SMALL_STATE(2381)] = 115466,
  [SMALL_STATE(2382)] = 115487,
  [SMALL_STATE(2383)] = 115504,
  [SMALL_STATE(2384)] = 115517,
  [SMALL_STATE(2385)] = 115532,
  [SMALL_STATE(2386)] = 115553,
  [SMALL_STATE(2387)] = 115566,
  [SMALL_STATE(2388)] = 115587,
  [SMALL_STATE(2389)] = 115608,
  [SMALL_STATE(2390)] = 115621,
  [SMALL_STATE(2391)] = 115642,
  [SMALL_STATE(2392)] = 115655,
  [SMALL_STATE(2393)] = 115678,
  [SMALL_STATE(2394)] = 115691,
  [SMALL_STATE(2395)] = 115704,
  [SMALL_STATE(2396)] = 115721,
  [SMALL_STATE(2397)] = 115738,
  [SMALL_STATE(2398)] = 115753,
  [SMALL_STATE(2399)] = 115766,
  [SMALL_STATE(2400)] = 115783,
  [SMALL_STATE(2401)] = 115802,
  [SMALL_STATE(2402)] = 115823,
  [SMALL_STATE(2403)] = 115840,
  [SMALL_STATE(2404)] = 115857,
  [SMALL_STATE(2405)] = 115870,
  [SMALL_STATE(2406)] = 115887,
  [SMALL_STATE(2407)] = 115904,
  [SMALL_STATE(2408)] = 115925,
  [SMALL_STATE(2409)] = 115938,
  [SMALL_STATE(2410)] = 115959,
  [SMALL_STATE(2411)] = 115973,
  [SMALL_STATE(2412)] = 115985,
  [SMALL_STATE(2413)] = 116003,
  [SMALL_STATE(2414)] = 116023,
  [SMALL_STATE(2415)] = 116041,
  [SMALL_STATE(2416)] = 116053,
  [SMALL_STATE(2417)] = 116071,
  [SMALL_STATE(2418)] = 116091,
  [SMALL_STATE(2419)] = 116103,
  [SMALL_STATE(2420)] = 116115,
  [SMALL_STATE(2421)] = 116127,
  [SMALL_STATE(2422)] = 116147,
  [SMALL_STATE(2423)] = 116163,
  [SMALL_STATE(2424)] = 116175,
  [SMALL_STATE(2425)] = 116187,
  [SMALL_STATE(2426)] = 116199,
  [SMALL_STATE(2427)] = 116217,
  [SMALL_STATE(2428)] = 116229,
  [SMALL_STATE(2429)] = 116241,
  [SMALL_STATE(2430)] = 116253,
  [SMALL_STATE(2431)] = 116265,
  [SMALL_STATE(2432)] = 116281,
  [SMALL_STATE(2433)] = 116299,
  [SMALL_STATE(2434)] = 116319,
  [SMALL_STATE(2435)] = 116331,
  [SMALL_STATE(2436)] = 116343,
  [SMALL_STATE(2437)] = 116357,
  [SMALL_STATE(2438)] = 116373,
  [SMALL_STATE(2439)] = 116393,
  [SMALL_STATE(2440)] = 116405,
  [SMALL_STATE(2441)] = 116425,
  [SMALL_STATE(2442)] = 116437,
  [SMALL_STATE(2443)] = 116449,
  [SMALL_STATE(2444)] = 116461,
  [SMALL_STATE(2445)] = 116479,
  [SMALL_STATE(2446)] = 116499,
  [SMALL_STATE(2447)] = 116517,
  [SMALL_STATE(2448)] = 116533,
  [SMALL_STATE(2449)] = 116545,
  [SMALL_STATE(2450)] = 116557,
  [SMALL_STATE(2451)] = 116577,
  [SMALL_STATE(2452)] = 116589,
  [SMALL_STATE(2453)] = 116605,
  [SMALL_STATE(2454)] = 116617,
  [SMALL_STATE(2455)] = 116635,
  [SMALL_STATE(2456)] = 116653,
  [SMALL_STATE(2457)] = 116665,
  [SMALL_STATE(2458)] = 116677,
  [SMALL_STATE(2459)] = 116695,
  [SMALL_STATE(2460)] = 116715,
  [SMALL_STATE(2461)] = 116731,
  [SMALL_STATE(2462)] = 116751,
  [SMALL_STATE(2463)] = 116767,
  [SMALL_STATE(2464)] = 116781,
  [SMALL_STATE(2465)] = 116793,
  [SMALL_STATE(2466)] = 116811,
  [SMALL_STATE(2467)] = 116829,
  [SMALL_STATE(2468)] = 116841,
  [SMALL_STATE(2469)] = 116853,
  [SMALL_STATE(2470)] = 116873,
  [SMALL_STATE(2471)] = 116893,
  [SMALL_STATE(2472)] = 116905,
  [SMALL_STATE(2473)] = 116919,
  [SMALL_STATE(2474)] = 116939,
  [SMALL_STATE(2475)] = 116951,
  [SMALL_STATE(2476)] = 116971,
  [SMALL_STATE(2477)] = 116987,
  [SMALL_STATE(2478)] = 117007,
  [SMALL_STATE(2479)] = 117019,
  [SMALL_STATE(2480)] = 117031,
  [SMALL_STATE(2481)] = 117051,
  [SMALL_STATE(2482)] = 117063,
  [SMALL_STATE(2483)] = 117075,
  [SMALL_STATE(2484)] = 117095,
  [SMALL_STATE(2485)] = 117111,
  [SMALL_STATE(2486)] = 117131,
  [SMALL_STATE(2487)] = 117143,
  [SMALL_STATE(2488)] = 117161,
  [SMALL_STATE(2489)] = 117173,
  [SMALL_STATE(2490)] = 117193,
  [SMALL_STATE(2491)] = 117209,
  [SMALL_STATE(2492)] = 117229,
  [SMALL_STATE(2493)] = 117241,
  [SMALL_STATE(2494)] = 117261,
  [SMALL_STATE(2495)] = 117277,
  [SMALL_STATE(2496)] = 117291,
  [SMALL_STATE(2497)] = 117303,
  [SMALL_STATE(2498)] = 117317,
  [SMALL_STATE(2499)] = 117337,
  [SMALL_STATE(2500)] = 117349,
  [SMALL_STATE(2501)] = 117361,
  [SMALL_STATE(2502)] = 117373,
  [SMALL_STATE(2503)] = 117385,
  [SMALL_STATE(2504)] = 117397,
  [SMALL_STATE(2505)] = 117413,
  [SMALL_STATE(2506)] = 117433,
  [SMALL_STATE(2507)] = 117445,
  [SMALL_STATE(2508)] = 117461,
  [SMALL_STATE(2509)] = 117473,
  [SMALL_STATE(2510)] = 117493,
  [SMALL_STATE(2511)] = 117511,
  [SMALL_STATE(2512)] = 117531,
  [SMALL_STATE(2513)] = 117547,
  [SMALL_STATE(2514)] = 117559,
  [SMALL_STATE(2515)] = 117577,
  [SMALL_STATE(2516)] = 117589,
  [SMALL_STATE(2517)] = 117601,
  [SMALL_STATE(2518)] = 117619,
  [SMALL_STATE(2519)] = 117639,
  [SMALL_STATE(2520)] = 117651,
  [SMALL_STATE(2521)] = 117671,
  [SMALL_STATE(2522)] = 117691,
  [SMALL_STATE(2523)] = 117703,
  [SMALL_STATE(2524)] = 117723,
  [SMALL_STATE(2525)] = 117735,
  [SMALL_STATE(2526)] = 117753,
  [SMALL_STATE(2527)] = 117769,
  [SMALL_STATE(2528)] = 117789,
  [SMALL_STATE(2529)] = 117801,
  [SMALL_STATE(2530)] = 117821,
  [SMALL_STATE(2531)] = 117833,
  [SMALL_STATE(2532)] = 117845,
  [SMALL_STATE(2533)] = 117865,
  [SMALL_STATE(2534)] = 117876,
  [SMALL_STATE(2535)] = 117893,
  [SMALL_STATE(2536)] = 117910,
  [SMALL_STATE(2537)] = 117925,
  [SMALL_STATE(2538)] = 117936,
  [SMALL_STATE(2539)] = 117947,
  [SMALL_STATE(2540)] = 117964,
  [SMALL_STATE(2541)] = 117977,
  [SMALL_STATE(2542)] = 117990,
  [SMALL_STATE(2543)] = 118001,
  [SMALL_STATE(2544)] = 118018,
  [SMALL_STATE(2545)] = 118033,
  [SMALL_STATE(2546)] = 118048,
  [SMALL_STATE(2547)] = 118063,
  [SMALL_STATE(2548)] = 118080,
  [SMALL_STATE(2549)] = 118095,
  [SMALL_STATE(2550)] = 118112,
  [SMALL_STATE(2551)] = 118127,
  [SMALL_STATE(2552)] = 118144,
  [SMALL_STATE(2553)] = 118161,
  [SMALL_STATE(2554)] = 118172,
  [SMALL_STATE(2555)] = 118189,
  [SMALL_STATE(2556)] = 118200,
  [SMALL_STATE(2557)] = 118217,
  [SMALL_STATE(2558)] = 118228,
  [SMALL_STATE(2559)] = 118245,
  [SMALL_STATE(2560)] = 118256,
  [SMALL_STATE(2561)] = 118271,
  [SMALL_STATE(2562)] = 118288,
  [SMALL_STATE(2563)] = 118305,
  [SMALL_STATE(2564)] = 118316,
  [SMALL_STATE(2565)] = 118327,
  [SMALL_STATE(2566)] = 118344,
  [SMALL_STATE(2567)] = 118355,
  [SMALL_STATE(2568)] = 118370,
  [SMALL_STATE(2569)] = 118381,
  [SMALL_STATE(2570)] = 118392,
  [SMALL_STATE(2571)] = 118403,
  [SMALL_STATE(2572)] = 118414,
  [SMALL_STATE(2573)] = 118425,
  [SMALL_STATE(2574)] = 118436,
  [SMALL_STATE(2575)] = 118447,
  [SMALL_STATE(2576)] = 118458,
  [SMALL_STATE(2577)] = 118469,
  [SMALL_STATE(2578)] = 118480,
  [SMALL_STATE(2579)] = 118497,
  [SMALL_STATE(2580)] = 118514,
  [SMALL_STATE(2581)] = 118531,
  [SMALL_STATE(2582)] = 118548,
  [SMALL_STATE(2583)] = 118563,
  [SMALL_STATE(2584)] = 118580,
  [SMALL_STATE(2585)] = 118591,
  [SMALL_STATE(2586)] = 118606,
  [SMALL_STATE(2587)] = 118617,
  [SMALL_STATE(2588)] = 118634,
  [SMALL_STATE(2589)] = 118645,
  [SMALL_STATE(2590)] = 118662,
  [SMALL_STATE(2591)] = 118673,
  [SMALL_STATE(2592)] = 118684,
  [SMALL_STATE(2593)] = 118695,
  [SMALL_STATE(2594)] = 118706,
  [SMALL_STATE(2595)] = 118721,
  [SMALL_STATE(2596)] = 118732,
  [SMALL_STATE(2597)] = 118743,
  [SMALL_STATE(2598)] = 118758,
  [SMALL_STATE(2599)] = 118769,
  [SMALL_STATE(2600)] = 118780,
  [SMALL_STATE(2601)] = 118795,
  [SMALL_STATE(2602)] = 118806,
  [SMALL_STATE(2603)] = 118817,
  [SMALL_STATE(2604)] = 118828,
  [SMALL_STATE(2605)] = 118839,
  [SMALL_STATE(2606)] = 118850,
  [SMALL_STATE(2607)] = 118861,
  [SMALL_STATE(2608)] = 118872,
  [SMALL_STATE(2609)] = 118883,
  [SMALL_STATE(2610)] = 118894,
  [SMALL_STATE(2611)] = 118905,
  [SMALL_STATE(2612)] = 118916,
  [SMALL_STATE(2613)] = 118927,
  [SMALL_STATE(2614)] = 118938,
  [SMALL_STATE(2615)] = 118955,
  [SMALL_STATE(2616)] = 118970,
  [SMALL_STATE(2617)] = 118987,
  [SMALL_STATE(2618)] = 118998,
  [SMALL_STATE(2619)] = 119009,
  [SMALL_STATE(2620)] = 119020,
  [SMALL_STATE(2621)] = 119037,
  [SMALL_STATE(2622)] = 119048,
  [SMALL_STATE(2623)] = 119063,
  [SMALL_STATE(2624)] = 119074,
  [SMALL_STATE(2625)] = 119085,
  [SMALL_STATE(2626)] = 119102,
  [SMALL_STATE(2627)] = 119117,
  [SMALL_STATE(2628)] = 119128,
  [SMALL_STATE(2629)] = 119143,
  [SMALL_STATE(2630)] = 119160,
  [SMALL_STATE(2631)] = 119171,
  [SMALL_STATE(2632)] = 119182,
  [SMALL_STATE(2633)] = 119193,
  [SMALL_STATE(2634)] = 119204,
  [SMALL_STATE(2635)] = 119215,
  [SMALL_STATE(2636)] = 119226,
  [SMALL_STATE(2637)] = 119237,
  [SMALL_STATE(2638)] = 119248,
  [SMALL_STATE(2639)] = 119259,
  [SMALL_STATE(2640)] = 119270,
  [SMALL_STATE(2641)] = 119281,
  [SMALL_STATE(2642)] = 119292,
  [SMALL_STATE(2643)] = 119303,
  [SMALL_STATE(2644)] = 119314,
  [SMALL_STATE(2645)] = 119325,
  [SMALL_STATE(2646)] = 119340,
  [SMALL_STATE(2647)] = 119351,
  [SMALL_STATE(2648)] = 119362,
  [SMALL_STATE(2649)] = 119379,
  [SMALL_STATE(2650)] = 119396,
  [SMALL_STATE(2651)] = 119407,
  [SMALL_STATE(2652)] = 119420,
  [SMALL_STATE(2653)] = 119431,
  [SMALL_STATE(2654)] = 119442,
  [SMALL_STATE(2655)] = 119453,
  [SMALL_STATE(2656)] = 119470,
  [SMALL_STATE(2657)] = 119485,
  [SMALL_STATE(2658)] = 119502,
  [SMALL_STATE(2659)] = 119513,
  [SMALL_STATE(2660)] = 119530,
  [SMALL_STATE(2661)] = 119547,
  [SMALL_STATE(2662)] = 119564,
  [SMALL_STATE(2663)] = 119581,
  [SMALL_STATE(2664)] = 119596,
  [SMALL_STATE(2665)] = 119610,
  [SMALL_STATE(2666)] = 119624,
  [SMALL_STATE(2667)] = 119638,
  [SMALL_STATE(2668)] = 119652,
  [SMALL_STATE(2669)] = 119666,
  [SMALL_STATE(2670)] = 119680,
  [SMALL_STATE(2671)] = 119694,
  [SMALL_STATE(2672)] = 119708,
  [SMALL_STATE(2673)] = 119722,
  [SMALL_STATE(2674)] = 119736,
  [SMALL_STATE(2675)] = 119750,
  [SMALL_STATE(2676)] = 119764,
  [SMALL_STATE(2677)] = 119778,
  [SMALL_STATE(2678)] = 119792,
  [SMALL_STATE(2679)] = 119806,
  [SMALL_STATE(2680)] = 119820,
  [SMALL_STATE(2681)] = 119834,
  [SMALL_STATE(2682)] = 119848,
  [SMALL_STATE(2683)] = 119862,
  [SMALL_STATE(2684)] = 119876,
  [SMALL_STATE(2685)] = 119890,
  [SMALL_STATE(2686)] = 119904,
  [SMALL_STATE(2687)] = 119918,
  [SMALL_STATE(2688)] = 119932,
  [SMALL_STATE(2689)] = 119944,
  [SMALL_STATE(2690)] = 119958,
  [SMALL_STATE(2691)] = 119972,
  [SMALL_STATE(2692)] = 119986,
  [SMALL_STATE(2693)] = 120000,
  [SMALL_STATE(2694)] = 120014,
  [SMALL_STATE(2695)] = 120028,
  [SMALL_STATE(2696)] = 120042,
  [SMALL_STATE(2697)] = 120056,
  [SMALL_STATE(2698)] = 120070,
  [SMALL_STATE(2699)] = 120084,
  [SMALL_STATE(2700)] = 120096,
  [SMALL_STATE(2701)] = 120110,
  [SMALL_STATE(2702)] = 120124,
  [SMALL_STATE(2703)] = 120136,
  [SMALL_STATE(2704)] = 120150,
  [SMALL_STATE(2705)] = 120164,
  [SMALL_STATE(2706)] = 120178,
  [SMALL_STATE(2707)] = 120190,
  [SMALL_STATE(2708)] = 120204,
  [SMALL_STATE(2709)] = 120216,
  [SMALL_STATE(2710)] = 120230,
  [SMALL_STATE(2711)] = 120244,
  [SMALL_STATE(2712)] = 120258,
  [SMALL_STATE(2713)] = 120272,
  [SMALL_STATE(2714)] = 120286,
  [SMALL_STATE(2715)] = 120300,
  [SMALL_STATE(2716)] = 120314,
  [SMALL_STATE(2717)] = 120328,
  [SMALL_STATE(2718)] = 120342,
  [SMALL_STATE(2719)] = 120356,
  [SMALL_STATE(2720)] = 120370,
  [SMALL_STATE(2721)] = 120384,
  [SMALL_STATE(2722)] = 120398,
  [SMALL_STATE(2723)] = 120412,
  [SMALL_STATE(2724)] = 120426,
  [SMALL_STATE(2725)] = 120440,
  [SMALL_STATE(2726)] = 120454,
  [SMALL_STATE(2727)] = 120468,
  [SMALL_STATE(2728)] = 120482,
  [SMALL_STATE(2729)] = 120496,
  [SMALL_STATE(2730)] = 120510,
  [SMALL_STATE(2731)] = 120524,
  [SMALL_STATE(2732)] = 120538,
  [SMALL_STATE(2733)] = 120552,
  [SMALL_STATE(2734)] = 120566,
  [SMALL_STATE(2735)] = 120580,
  [SMALL_STATE(2736)] = 120594,
  [SMALL_STATE(2737)] = 120608,
  [SMALL_STATE(2738)] = 120622,
  [SMALL_STATE(2739)] = 120634,
  [SMALL_STATE(2740)] = 120648,
  [SMALL_STATE(2741)] = 120662,
  [SMALL_STATE(2742)] = 120676,
  [SMALL_STATE(2743)] = 120690,
  [SMALL_STATE(2744)] = 120704,
  [SMALL_STATE(2745)] = 120718,
  [SMALL_STATE(2746)] = 120732,
  [SMALL_STATE(2747)] = 120746,
  [SMALL_STATE(2748)] = 120760,
  [SMALL_STATE(2749)] = 120774,
  [SMALL_STATE(2750)] = 120788,
  [SMALL_STATE(2751)] = 120802,
  [SMALL_STATE(2752)] = 120812,
  [SMALL_STATE(2753)] = 120826,
  [SMALL_STATE(2754)] = 120840,
  [SMALL_STATE(2755)] = 120854,
  [SMALL_STATE(2756)] = 120868,
  [SMALL_STATE(2757)] = 120882,
  [SMALL_STATE(2758)] = 120896,
  [SMALL_STATE(2759)] = 120910,
  [SMALL_STATE(2760)] = 120924,
  [SMALL_STATE(2761)] = 120938,
  [SMALL_STATE(2762)] = 120952,
  [SMALL_STATE(2763)] = 120966,
  [SMALL_STATE(2764)] = 120980,
  [SMALL_STATE(2765)] = 120994,
  [SMALL_STATE(2766)] = 121008,
  [SMALL_STATE(2767)] = 121022,
  [SMALL_STATE(2768)] = 121032,
  [SMALL_STATE(2769)] = 121046,
  [SMALL_STATE(2770)] = 121060,
  [SMALL_STATE(2771)] = 121074,
  [SMALL_STATE(2772)] = 121084,
  [SMALL_STATE(2773)] = 121098,
  [SMALL_STATE(2774)] = 121108,
  [SMALL_STATE(2775)] = 121122,
  [SMALL_STATE(2776)] = 121136,
  [SMALL_STATE(2777)] = 121150,
  [SMALL_STATE(2778)] = 121164,
  [SMALL_STATE(2779)] = 121174,
  [SMALL_STATE(2780)] = 121184,
  [SMALL_STATE(2781)] = 121198,
  [SMALL_STATE(2782)] = 121208,
  [SMALL_STATE(2783)] = 121220,
  [SMALL_STATE(2784)] = 121234,
  [SMALL_STATE(2785)] = 121248,
  [SMALL_STATE(2786)] = 121262,
  [SMALL_STATE(2787)] = 121276,
  [SMALL_STATE(2788)] = 121286,
  [SMALL_STATE(2789)] = 121300,
  [SMALL_STATE(2790)] = 121310,
  [SMALL_STATE(2791)] = 121324,
  [SMALL_STATE(2792)] = 121338,
  [SMALL_STATE(2793)] = 121352,
  [SMALL_STATE(2794)] = 121366,
  [SMALL_STATE(2795)] = 121380,
  [SMALL_STATE(2796)] = 121394,
  [SMALL_STATE(2797)] = 121408,
  [SMALL_STATE(2798)] = 121422,
  [SMALL_STATE(2799)] = 121436,
  [SMALL_STATE(2800)] = 121450,
  [SMALL_STATE(2801)] = 121464,
  [SMALL_STATE(2802)] = 121478,
  [SMALL_STATE(2803)] = 121492,
  [SMALL_STATE(2804)] = 121506,
  [SMALL_STATE(2805)] = 121520,
  [SMALL_STATE(2806)] = 121534,
  [SMALL_STATE(2807)] = 121548,
  [SMALL_STATE(2808)] = 121562,
  [SMALL_STATE(2809)] = 121576,
  [SMALL_STATE(2810)] = 121590,
  [SMALL_STATE(2811)] = 121604,
  [SMALL_STATE(2812)] = 121618,
  [SMALL_STATE(2813)] = 121632,
  [SMALL_STATE(2814)] = 121646,
  [SMALL_STATE(2815)] = 121660,
  [SMALL_STATE(2816)] = 121672,
  [SMALL_STATE(2817)] = 121686,
  [SMALL_STATE(2818)] = 121700,
  [SMALL_STATE(2819)] = 121714,
  [SMALL_STATE(2820)] = 121728,
  [SMALL_STATE(2821)] = 121742,
  [SMALL_STATE(2822)] = 121752,
  [SMALL_STATE(2823)] = 121766,
  [SMALL_STATE(2824)] = 121780,
  [SMALL_STATE(2825)] = 121794,
  [SMALL_STATE(2826)] = 121808,
  [SMALL_STATE(2827)] = 121822,
  [SMALL_STATE(2828)] = 121836,
  [SMALL_STATE(2829)] = 121850,
  [SMALL_STATE(2830)] = 121864,
  [SMALL_STATE(2831)] = 121878,
  [SMALL_STATE(2832)] = 121892,
  [SMALL_STATE(2833)] = 121906,
  [SMALL_STATE(2834)] = 121920,
  [SMALL_STATE(2835)] = 121930,
  [SMALL_STATE(2836)] = 121942,
  [SMALL_STATE(2837)] = 121956,
  [SMALL_STATE(2838)] = 121970,
  [SMALL_STATE(2839)] = 121984,
  [SMALL_STATE(2840)] = 121998,
  [SMALL_STATE(2841)] = 122010,
  [SMALL_STATE(2842)] = 122020,
  [SMALL_STATE(2843)] = 122034,
  [SMALL_STATE(2844)] = 122046,
  [SMALL_STATE(2845)] = 122060,
  [SMALL_STATE(2846)] = 122072,
  [SMALL_STATE(2847)] = 122086,
  [SMALL_STATE(2848)] = 122100,
  [SMALL_STATE(2849)] = 122112,
  [SMALL_STATE(2850)] = 122126,
  [SMALL_STATE(2851)] = 122140,
  [SMALL_STATE(2852)] = 122154,
  [SMALL_STATE(2853)] = 122168,
  [SMALL_STATE(2854)] = 122182,
  [SMALL_STATE(2855)] = 122196,
  [SMALL_STATE(2856)] = 122208,
  [SMALL_STATE(2857)] = 122220,
  [SMALL_STATE(2858)] = 122232,
  [SMALL_STATE(2859)] = 122244,
  [SMALL_STATE(2860)] = 122258,
  [SMALL_STATE(2861)] = 122272,
  [SMALL_STATE(2862)] = 122286,
  [SMALL_STATE(2863)] = 122300,
  [SMALL_STATE(2864)] = 122314,
  [SMALL_STATE(2865)] = 122328,
  [SMALL_STATE(2866)] = 122342,
  [SMALL_STATE(2867)] = 122356,
  [SMALL_STATE(2868)] = 122370,
  [SMALL_STATE(2869)] = 122384,
  [SMALL_STATE(2870)] = 122398,
  [SMALL_STATE(2871)] = 122412,
  [SMALL_STATE(2872)] = 122426,
  [SMALL_STATE(2873)] = 122440,
  [SMALL_STATE(2874)] = 122454,
  [SMALL_STATE(2875)] = 122468,
  [SMALL_STATE(2876)] = 122482,
  [SMALL_STATE(2877)] = 122496,
  [SMALL_STATE(2878)] = 122510,
  [SMALL_STATE(2879)] = 122522,
  [SMALL_STATE(2880)] = 122536,
  [SMALL_STATE(2881)] = 122550,
  [SMALL_STATE(2882)] = 122564,
  [SMALL_STATE(2883)] = 122576,
  [SMALL_STATE(2884)] = 122590,
  [SMALL_STATE(2885)] = 122604,
  [SMALL_STATE(2886)] = 122618,
  [SMALL_STATE(2887)] = 122632,
  [SMALL_STATE(2888)] = 122646,
  [SMALL_STATE(2889)] = 122660,
  [SMALL_STATE(2890)] = 122672,
  [SMALL_STATE(2891)] = 122686,
  [SMALL_STATE(2892)] = 122700,
  [SMALL_STATE(2893)] = 122714,
  [SMALL_STATE(2894)] = 122728,
  [SMALL_STATE(2895)] = 122742,
  [SMALL_STATE(2896)] = 122756,
  [SMALL_STATE(2897)] = 122766,
  [SMALL_STATE(2898)] = 122780,
  [SMALL_STATE(2899)] = 122794,
  [SMALL_STATE(2900)] = 122804,
  [SMALL_STATE(2901)] = 122818,
  [SMALL_STATE(2902)] = 122832,
  [SMALL_STATE(2903)] = 122846,
  [SMALL_STATE(2904)] = 122860,
  [SMALL_STATE(2905)] = 122872,
  [SMALL_STATE(2906)] = 122886,
  [SMALL_STATE(2907)] = 122898,
  [SMALL_STATE(2908)] = 122912,
  [SMALL_STATE(2909)] = 122924,
  [SMALL_STATE(2910)] = 122938,
  [SMALL_STATE(2911)] = 122952,
  [SMALL_STATE(2912)] = 122966,
  [SMALL_STATE(2913)] = 122980,
  [SMALL_STATE(2914)] = 122994,
  [SMALL_STATE(2915)] = 123008,
  [SMALL_STATE(2916)] = 123022,
  [SMALL_STATE(2917)] = 123036,
  [SMALL_STATE(2918)] = 123048,
  [SMALL_STATE(2919)] = 123062,
  [SMALL_STATE(2920)] = 123076,
  [SMALL_STATE(2921)] = 123090,
  [SMALL_STATE(2922)] = 123104,
  [SMALL_STATE(2923)] = 123118,
  [SMALL_STATE(2924)] = 123132,
  [SMALL_STATE(2925)] = 123146,
  [SMALL_STATE(2926)] = 123160,
  [SMALL_STATE(2927)] = 123174,
  [SMALL_STATE(2928)] = 123188,
  [SMALL_STATE(2929)] = 123202,
  [SMALL_STATE(2930)] = 123216,
  [SMALL_STATE(2931)] = 123228,
  [SMALL_STATE(2932)] = 123242,
  [SMALL_STATE(2933)] = 123256,
  [SMALL_STATE(2934)] = 123270,
  [SMALL_STATE(2935)] = 123284,
  [SMALL_STATE(2936)] = 123298,
  [SMALL_STATE(2937)] = 123312,
  [SMALL_STATE(2938)] = 123326,
  [SMALL_STATE(2939)] = 123340,
  [SMALL_STATE(2940)] = 123354,
  [SMALL_STATE(2941)] = 123368,
  [SMALL_STATE(2942)] = 123382,
  [SMALL_STATE(2943)] = 123396,
  [SMALL_STATE(2944)] = 123410,
  [SMALL_STATE(2945)] = 123424,
  [SMALL_STATE(2946)] = 123438,
  [SMALL_STATE(2947)] = 123452,
  [SMALL_STATE(2948)] = 123466,
  [SMALL_STATE(2949)] = 123480,
  [SMALL_STATE(2950)] = 123492,
  [SMALL_STATE(2951)] = 123506,
  [SMALL_STATE(2952)] = 123520,
  [SMALL_STATE(2953)] = 123534,
  [SMALL_STATE(2954)] = 123546,
  [SMALL_STATE(2955)] = 123560,
  [SMALL_STATE(2956)] = 123574,
  [SMALL_STATE(2957)] = 123588,
  [SMALL_STATE(2958)] = 123602,
  [SMALL_STATE(2959)] = 123616,
  [SMALL_STATE(2960)] = 123630,
  [SMALL_STATE(2961)] = 123644,
  [SMALL_STATE(2962)] = 123658,
  [SMALL_STATE(2963)] = 123672,
  [SMALL_STATE(2964)] = 123686,
  [SMALL_STATE(2965)] = 123700,
  [SMALL_STATE(2966)] = 123714,
  [SMALL_STATE(2967)] = 123728,
  [SMALL_STATE(2968)] = 123742,
  [SMALL_STATE(2969)] = 123756,
  [SMALL_STATE(2970)] = 123770,
  [SMALL_STATE(2971)] = 123784,
  [SMALL_STATE(2972)] = 123798,
  [SMALL_STATE(2973)] = 123812,
  [SMALL_STATE(2974)] = 123826,
  [SMALL_STATE(2975)] = 123840,
  [SMALL_STATE(2976)] = 123854,
  [SMALL_STATE(2977)] = 123868,
  [SMALL_STATE(2978)] = 123882,
  [SMALL_STATE(2979)] = 123896,
  [SMALL_STATE(2980)] = 123910,
  [SMALL_STATE(2981)] = 123924,
  [SMALL_STATE(2982)] = 123938,
  [SMALL_STATE(2983)] = 123952,
  [SMALL_STATE(2984)] = 123966,
  [SMALL_STATE(2985)] = 123980,
  [SMALL_STATE(2986)] = 123994,
  [SMALL_STATE(2987)] = 124008,
  [SMALL_STATE(2988)] = 124022,
  [SMALL_STATE(2989)] = 124036,
  [SMALL_STATE(2990)] = 124050,
  [SMALL_STATE(2991)] = 124064,
  [SMALL_STATE(2992)] = 124078,
  [SMALL_STATE(2993)] = 124092,
  [SMALL_STATE(2994)] = 124106,
  [SMALL_STATE(2995)] = 124120,
  [SMALL_STATE(2996)] = 124134,
  [SMALL_STATE(2997)] = 124148,
  [SMALL_STATE(2998)] = 124162,
  [SMALL_STATE(2999)] = 124176,
  [SMALL_STATE(3000)] = 124188,
  [SMALL_STATE(3001)] = 124202,
  [SMALL_STATE(3002)] = 124216,
  [SMALL_STATE(3003)] = 124230,
  [SMALL_STATE(3004)] = 124244,
  [SMALL_STATE(3005)] = 124258,
  [SMALL_STATE(3006)] = 124272,
  [SMALL_STATE(3007)] = 124286,
  [SMALL_STATE(3008)] = 124300,
  [SMALL_STATE(3009)] = 124314,
  [SMALL_STATE(3010)] = 124328,
  [SMALL_STATE(3011)] = 124342,
  [SMALL_STATE(3012)] = 124356,
  [SMALL_STATE(3013)] = 124370,
  [SMALL_STATE(3014)] = 124384,
  [SMALL_STATE(3015)] = 124398,
  [SMALL_STATE(3016)] = 124412,
  [SMALL_STATE(3017)] = 124426,
  [SMALL_STATE(3018)] = 124440,
  [SMALL_STATE(3019)] = 124454,
  [SMALL_STATE(3020)] = 124468,
  [SMALL_STATE(3021)] = 124482,
  [SMALL_STATE(3022)] = 124496,
  [SMALL_STATE(3023)] = 124510,
  [SMALL_STATE(3024)] = 124524,
  [SMALL_STATE(3025)] = 124538,
  [SMALL_STATE(3026)] = 124552,
  [SMALL_STATE(3027)] = 124566,
  [SMALL_STATE(3028)] = 124580,
  [SMALL_STATE(3029)] = 124589,
  [SMALL_STATE(3030)] = 124598,
  [SMALL_STATE(3031)] = 124607,
  [SMALL_STATE(3032)] = 124616,
  [SMALL_STATE(3033)] = 124627,
  [SMALL_STATE(3034)] = 124638,
  [SMALL_STATE(3035)] = 124647,
  [SMALL_STATE(3036)] = 124658,
  [SMALL_STATE(3037)] = 124669,
  [SMALL_STATE(3038)] = 124680,
  [SMALL_STATE(3039)] = 124689,
  [SMALL_STATE(3040)] = 124698,
  [SMALL_STATE(3041)] = 124709,
  [SMALL_STATE(3042)] = 124720,
  [SMALL_STATE(3043)] = 124731,
  [SMALL_STATE(3044)] = 124740,
  [SMALL_STATE(3045)] = 124749,
  [SMALL_STATE(3046)] = 124758,
  [SMALL_STATE(3047)] = 124769,
  [SMALL_STATE(3048)] = 124780,
  [SMALL_STATE(3049)] = 124789,
  [SMALL_STATE(3050)] = 124798,
  [SMALL_STATE(3051)] = 124809,
  [SMALL_STATE(3052)] = 124820,
  [SMALL_STATE(3053)] = 124829,
  [SMALL_STATE(3054)] = 124838,
  [SMALL_STATE(3055)] = 124847,
  [SMALL_STATE(3056)] = 124858,
  [SMALL_STATE(3057)] = 124867,
  [SMALL_STATE(3058)] = 124878,
  [SMALL_STATE(3059)] = 124889,
  [SMALL_STATE(3060)] = 124900,
  [SMALL_STATE(3061)] = 124909,
  [SMALL_STATE(3062)] = 124920,
  [SMALL_STATE(3063)] = 124931,
  [SMALL_STATE(3064)] = 124942,
  [SMALL_STATE(3065)] = 124951,
  [SMALL_STATE(3066)] = 124960,
  [SMALL_STATE(3067)] = 124971,
  [SMALL_STATE(3068)] = 124982,
  [SMALL_STATE(3069)] = 124993,
  [SMALL_STATE(3070)] = 125004,
  [SMALL_STATE(3071)] = 125015,
  [SMALL_STATE(3072)] = 125026,
  [SMALL_STATE(3073)] = 125037,
  [SMALL_STATE(3074)] = 125048,
  [SMALL_STATE(3075)] = 125059,
  [SMALL_STATE(3076)] = 125070,
  [SMALL_STATE(3077)] = 125081,
  [SMALL_STATE(3078)] = 125092,
  [SMALL_STATE(3079)] = 125103,
  [SMALL_STATE(3080)] = 125114,
  [SMALL_STATE(3081)] = 125125,
  [SMALL_STATE(3082)] = 125136,
  [SMALL_STATE(3083)] = 125145,
  [SMALL_STATE(3084)] = 125154,
  [SMALL_STATE(3085)] = 125163,
  [SMALL_STATE(3086)] = 125174,
  [SMALL_STATE(3087)] = 125183,
  [SMALL_STATE(3088)] = 125192,
  [SMALL_STATE(3089)] = 125201,
  [SMALL_STATE(3090)] = 125210,
  [SMALL_STATE(3091)] = 125219,
  [SMALL_STATE(3092)] = 125230,
  [SMALL_STATE(3093)] = 125241,
  [SMALL_STATE(3094)] = 125250,
  [SMALL_STATE(3095)] = 125259,
  [SMALL_STATE(3096)] = 125268,
  [SMALL_STATE(3097)] = 125279,
  [SMALL_STATE(3098)] = 125288,
  [SMALL_STATE(3099)] = 125299,
  [SMALL_STATE(3100)] = 125310,
  [SMALL_STATE(3101)] = 125319,
  [SMALL_STATE(3102)] = 125328,
  [SMALL_STATE(3103)] = 125337,
  [SMALL_STATE(3104)] = 125346,
  [SMALL_STATE(3105)] = 125355,
  [SMALL_STATE(3106)] = 125364,
  [SMALL_STATE(3107)] = 125373,
  [SMALL_STATE(3108)] = 125382,
  [SMALL_STATE(3109)] = 125391,
  [SMALL_STATE(3110)] = 125400,
  [SMALL_STATE(3111)] = 125409,
  [SMALL_STATE(3112)] = 125418,
  [SMALL_STATE(3113)] = 125427,
  [SMALL_STATE(3114)] = 125436,
  [SMALL_STATE(3115)] = 125445,
  [SMALL_STATE(3116)] = 125454,
  [SMALL_STATE(3117)] = 125463,
  [SMALL_STATE(3118)] = 125472,
  [SMALL_STATE(3119)] = 125481,
  [SMALL_STATE(3120)] = 125490,
  [SMALL_STATE(3121)] = 125499,
  [SMALL_STATE(3122)] = 125508,
  [SMALL_STATE(3123)] = 125519,
  [SMALL_STATE(3124)] = 125528,
  [SMALL_STATE(3125)] = 125537,
  [SMALL_STATE(3126)] = 125548,
  [SMALL_STATE(3127)] = 125557,
  [SMALL_STATE(3128)] = 125568,
  [SMALL_STATE(3129)] = 125579,
  [SMALL_STATE(3130)] = 125588,
  [SMALL_STATE(3131)] = 125597,
  [SMALL_STATE(3132)] = 125608,
  [SMALL_STATE(3133)] = 125617,
  [SMALL_STATE(3134)] = 125626,
  [SMALL_STATE(3135)] = 125635,
  [SMALL_STATE(3136)] = 125644,
  [SMALL_STATE(3137)] = 125655,
  [SMALL_STATE(3138)] = 125664,
  [SMALL_STATE(3139)] = 125673,
  [SMALL_STATE(3140)] = 125682,
  [SMALL_STATE(3141)] = 125693,
  [SMALL_STATE(3142)] = 125702,
  [SMALL_STATE(3143)] = 125711,
  [SMALL_STATE(3144)] = 125720,
  [SMALL_STATE(3145)] = 125729,
  [SMALL_STATE(3146)] = 125738,
  [SMALL_STATE(3147)] = 125747,
  [SMALL_STATE(3148)] = 125758,
  [SMALL_STATE(3149)] = 125767,
  [SMALL_STATE(3150)] = 125778,
  [SMALL_STATE(3151)] = 125787,
  [SMALL_STATE(3152)] = 125798,
  [SMALL_STATE(3153)] = 125807,
  [SMALL_STATE(3154)] = 125816,
  [SMALL_STATE(3155)] = 125825,
  [SMALL_STATE(3156)] = 125834,
  [SMALL_STATE(3157)] = 125843,
  [SMALL_STATE(3158)] = 125852,
  [SMALL_STATE(3159)] = 125863,
  [SMALL_STATE(3160)] = 125872,
  [SMALL_STATE(3161)] = 125881,
  [SMALL_STATE(3162)] = 125892,
  [SMALL_STATE(3163)] = 125900,
  [SMALL_STATE(3164)] = 125908,
  [SMALL_STATE(3165)] = 125916,
  [SMALL_STATE(3166)] = 125924,
  [SMALL_STATE(3167)] = 125932,
  [SMALL_STATE(3168)] = 125940,
  [SMALL_STATE(3169)] = 125948,
  [SMALL_STATE(3170)] = 125956,
  [SMALL_STATE(3171)] = 125964,
  [SMALL_STATE(3172)] = 125972,
  [SMALL_STATE(3173)] = 125980,
  [SMALL_STATE(3174)] = 125988,
  [SMALL_STATE(3175)] = 125996,
  [SMALL_STATE(3176)] = 126004,
  [SMALL_STATE(3177)] = 126012,
  [SMALL_STATE(3178)] = 126020,
  [SMALL_STATE(3179)] = 126028,
  [SMALL_STATE(3180)] = 126036,
  [SMALL_STATE(3181)] = 126044,
  [SMALL_STATE(3182)] = 126052,
  [SMALL_STATE(3183)] = 126060,
  [SMALL_STATE(3184)] = 126068,
  [SMALL_STATE(3185)] = 126076,
  [SMALL_STATE(3186)] = 126084,
  [SMALL_STATE(3187)] = 126092,
  [SMALL_STATE(3188)] = 126100,
  [SMALL_STATE(3189)] = 126108,
  [SMALL_STATE(3190)] = 126116,
  [SMALL_STATE(3191)] = 126124,
  [SMALL_STATE(3192)] = 126132,
  [SMALL_STATE(3193)] = 126140,
  [SMALL_STATE(3194)] = 126148,
  [SMALL_STATE(3195)] = 126156,
  [SMALL_STATE(3196)] = 126164,
  [SMALL_STATE(3197)] = 126172,
  [SMALL_STATE(3198)] = 126180,
  [SMALL_STATE(3199)] = 126188,
  [SMALL_STATE(3200)] = 126196,
  [SMALL_STATE(3201)] = 126204,
  [SMALL_STATE(3202)] = 126212,
  [SMALL_STATE(3203)] = 126220,
  [SMALL_STATE(3204)] = 126228,
  [SMALL_STATE(3205)] = 126236,
  [SMALL_STATE(3206)] = 126244,
  [SMALL_STATE(3207)] = 126252,
  [SMALL_STATE(3208)] = 126260,
  [SMALL_STATE(3209)] = 126268,
  [SMALL_STATE(3210)] = 126276,
  [SMALL_STATE(3211)] = 126284,
  [SMALL_STATE(3212)] = 126292,
  [SMALL_STATE(3213)] = 126300,
  [SMALL_STATE(3214)] = 126308,
  [SMALL_STATE(3215)] = 126316,
  [SMALL_STATE(3216)] = 126324,
  [SMALL_STATE(3217)] = 126332,
  [SMALL_STATE(3218)] = 126340,
  [SMALL_STATE(3219)] = 126348,
  [SMALL_STATE(3220)] = 126356,
  [SMALL_STATE(3221)] = 126364,
  [SMALL_STATE(3222)] = 126372,
  [SMALL_STATE(3223)] = 126380,
  [SMALL_STATE(3224)] = 126388,
  [SMALL_STATE(3225)] = 126396,
  [SMALL_STATE(3226)] = 126404,
  [SMALL_STATE(3227)] = 126412,
  [SMALL_STATE(3228)] = 126420,
  [SMALL_STATE(3229)] = 126428,
  [SMALL_STATE(3230)] = 126436,
  [SMALL_STATE(3231)] = 126444,
  [SMALL_STATE(3232)] = 126452,
  [SMALL_STATE(3233)] = 126460,
  [SMALL_STATE(3234)] = 126468,
  [SMALL_STATE(3235)] = 126476,
  [SMALL_STATE(3236)] = 126484,
  [SMALL_STATE(3237)] = 126492,
  [SMALL_STATE(3238)] = 126500,
  [SMALL_STATE(3239)] = 126508,
  [SMALL_STATE(3240)] = 126516,
  [SMALL_STATE(3241)] = 126524,
  [SMALL_STATE(3242)] = 126532,
  [SMALL_STATE(3243)] = 126540,
  [SMALL_STATE(3244)] = 126548,
  [SMALL_STATE(3245)] = 126556,
  [SMALL_STATE(3246)] = 126564,
  [SMALL_STATE(3247)] = 126572,
  [SMALL_STATE(3248)] = 126580,
  [SMALL_STATE(3249)] = 126588,
  [SMALL_STATE(3250)] = 126596,
  [SMALL_STATE(3251)] = 126604,
  [SMALL_STATE(3252)] = 126612,
  [SMALL_STATE(3253)] = 126620,
  [SMALL_STATE(3254)] = 126628,
  [SMALL_STATE(3255)] = 126636,
  [SMALL_STATE(3256)] = 126644,
  [SMALL_STATE(3257)] = 126652,
  [SMALL_STATE(3258)] = 126660,
  [SMALL_STATE(3259)] = 126668,
  [SMALL_STATE(3260)] = 126676,
  [SMALL_STATE(3261)] = 126684,
  [SMALL_STATE(3262)] = 126692,
  [SMALL_STATE(3263)] = 126700,
  [SMALL_STATE(3264)] = 126708,
  [SMALL_STATE(3265)] = 126716,
  [SMALL_STATE(3266)] = 126724,
  [SMALL_STATE(3267)] = 126732,
  [SMALL_STATE(3268)] = 126740,
  [SMALL_STATE(3269)] = 126748,
  [SMALL_STATE(3270)] = 126756,
  [SMALL_STATE(3271)] = 126764,
  [SMALL_STATE(3272)] = 126772,
  [SMALL_STATE(3273)] = 126780,
  [SMALL_STATE(3274)] = 126788,
  [SMALL_STATE(3275)] = 126796,
  [SMALL_STATE(3276)] = 126804,
  [SMALL_STATE(3277)] = 126812,
  [SMALL_STATE(3278)] = 126820,
  [SMALL_STATE(3279)] = 126828,
  [SMALL_STATE(3280)] = 126836,
  [SMALL_STATE(3281)] = 126844,
  [SMALL_STATE(3282)] = 126852,
  [SMALL_STATE(3283)] = 126860,
  [SMALL_STATE(3284)] = 126868,
  [SMALL_STATE(3285)] = 126876,
  [SMALL_STATE(3286)] = 126884,
  [SMALL_STATE(3287)] = 126892,
  [SMALL_STATE(3288)] = 126900,
  [SMALL_STATE(3289)] = 126908,
  [SMALL_STATE(3290)] = 126916,
  [SMALL_STATE(3291)] = 126924,
  [SMALL_STATE(3292)] = 126932,
  [SMALL_STATE(3293)] = 126940,
  [SMALL_STATE(3294)] = 126948,
  [SMALL_STATE(3295)] = 126956,
  [SMALL_STATE(3296)] = 126964,
  [SMALL_STATE(3297)] = 126972,
  [SMALL_STATE(3298)] = 126980,
  [SMALL_STATE(3299)] = 126988,
  [SMALL_STATE(3300)] = 126996,
  [SMALL_STATE(3301)] = 127004,
  [SMALL_STATE(3302)] = 127012,
  [SMALL_STATE(3303)] = 127020,
  [SMALL_STATE(3304)] = 127028,
  [SMALL_STATE(3305)] = 127036,
  [SMALL_STATE(3306)] = 127044,
  [SMALL_STATE(3307)] = 127052,
  [SMALL_STATE(3308)] = 127060,
  [SMALL_STATE(3309)] = 127068,
  [SMALL_STATE(3310)] = 127076,
  [SMALL_STATE(3311)] = 127084,
  [SMALL_STATE(3312)] = 127092,
  [SMALL_STATE(3313)] = 127100,
  [SMALL_STATE(3314)] = 127108,
  [SMALL_STATE(3315)] = 127116,
  [SMALL_STATE(3316)] = 127124,
  [SMALL_STATE(3317)] = 127132,
  [SMALL_STATE(3318)] = 127140,
  [SMALL_STATE(3319)] = 127148,
  [SMALL_STATE(3320)] = 127156,
  [SMALL_STATE(3321)] = 127164,
  [SMALL_STATE(3322)] = 127172,
  [SMALL_STATE(3323)] = 127180,
  [SMALL_STATE(3324)] = 127188,
  [SMALL_STATE(3325)] = 127196,
  [SMALL_STATE(3326)] = 127204,
  [SMALL_STATE(3327)] = 127212,
  [SMALL_STATE(3328)] = 127220,
  [SMALL_STATE(3329)] = 127228,
  [SMALL_STATE(3330)] = 127236,
  [SMALL_STATE(3331)] = 127244,
  [SMALL_STATE(3332)] = 127252,
  [SMALL_STATE(3333)] = 127260,
  [SMALL_STATE(3334)] = 127268,
  [SMALL_STATE(3335)] = 127276,
  [SMALL_STATE(3336)] = 127284,
  [SMALL_STATE(3337)] = 127292,
  [SMALL_STATE(3338)] = 127300,
  [SMALL_STATE(3339)] = 127308,
  [SMALL_STATE(3340)] = 127316,
  [SMALL_STATE(3341)] = 127324,
  [SMALL_STATE(3342)] = 127332,
  [SMALL_STATE(3343)] = 127340,
  [SMALL_STATE(3344)] = 127348,
  [SMALL_STATE(3345)] = 127356,
  [SMALL_STATE(3346)] = 127364,
  [SMALL_STATE(3347)] = 127372,
  [SMALL_STATE(3348)] = 127380,
  [SMALL_STATE(3349)] = 127388,
  [SMALL_STATE(3350)] = 127396,
  [SMALL_STATE(3351)] = 127404,
  [SMALL_STATE(3352)] = 127412,
  [SMALL_STATE(3353)] = 127420,
  [SMALL_STATE(3354)] = 127428,
  [SMALL_STATE(3355)] = 127436,
  [SMALL_STATE(3356)] = 127444,
  [SMALL_STATE(3357)] = 127452,
  [SMALL_STATE(3358)] = 127460,
  [SMALL_STATE(3359)] = 127468,
  [SMALL_STATE(3360)] = 127476,
  [SMALL_STATE(3361)] = 127484,
  [SMALL_STATE(3362)] = 127492,
  [SMALL_STATE(3363)] = 127500,
  [SMALL_STATE(3364)] = 127508,
  [SMALL_STATE(3365)] = 127516,
  [SMALL_STATE(3366)] = 127524,
  [SMALL_STATE(3367)] = 127532,
  [SMALL_STATE(3368)] = 127540,
  [SMALL_STATE(3369)] = 127548,
  [SMALL_STATE(3370)] = 127556,
  [SMALL_STATE(3371)] = 127564,
  [SMALL_STATE(3372)] = 127572,
  [SMALL_STATE(3373)] = 127580,
  [SMALL_STATE(3374)] = 127588,
  [SMALL_STATE(3375)] = 127596,
  [SMALL_STATE(3376)] = 127604,
  [SMALL_STATE(3377)] = 127612,
  [SMALL_STATE(3378)] = 127620,
  [SMALL_STATE(3379)] = 127628,
  [SMALL_STATE(3380)] = 127636,
  [SMALL_STATE(3381)] = 127644,
  [SMALL_STATE(3382)] = 127652,
  [SMALL_STATE(3383)] = 127660,
  [SMALL_STATE(3384)] = 127668,
  [SMALL_STATE(3385)] = 127676,
  [SMALL_STATE(3386)] = 127684,
  [SMALL_STATE(3387)] = 127692,
  [SMALL_STATE(3388)] = 127700,
  [SMALL_STATE(3389)] = 127708,
  [SMALL_STATE(3390)] = 127716,
  [SMALL_STATE(3391)] = 127724,
  [SMALL_STATE(3392)] = 127732,
  [SMALL_STATE(3393)] = 127740,
  [SMALL_STATE(3394)] = 127748,
  [SMALL_STATE(3395)] = 127756,
  [SMALL_STATE(3396)] = 127764,
  [SMALL_STATE(3397)] = 127772,
  [SMALL_STATE(3398)] = 127780,
  [SMALL_STATE(3399)] = 127788,
  [SMALL_STATE(3400)] = 127796,
  [SMALL_STATE(3401)] = 127804,
  [SMALL_STATE(3402)] = 127812,
  [SMALL_STATE(3403)] = 127820,
  [SMALL_STATE(3404)] = 127828,
  [SMALL_STATE(3405)] = 127836,
  [SMALL_STATE(3406)] = 127844,
  [SMALL_STATE(3407)] = 127852,
  [SMALL_STATE(3408)] = 127860,
  [SMALL_STATE(3409)] = 127868,
  [SMALL_STATE(3410)] = 127876,
  [SMALL_STATE(3411)] = 127884,
  [SMALL_STATE(3412)] = 127892,
  [SMALL_STATE(3413)] = 127900,
  [SMALL_STATE(3414)] = 127908,
  [SMALL_STATE(3415)] = 127916,
  [SMALL_STATE(3416)] = 127924,
  [SMALL_STATE(3417)] = 127932,
  [SMALL_STATE(3418)] = 127940,
  [SMALL_STATE(3419)] = 127948,
  [SMALL_STATE(3420)] = 127956,
  [SMALL_STATE(3421)] = 127964,
  [SMALL_STATE(3422)] = 127972,
  [SMALL_STATE(3423)] = 127980,
  [SMALL_STATE(3424)] = 127988,
  [SMALL_STATE(3425)] = 127996,
  [SMALL_STATE(3426)] = 128004,
  [SMALL_STATE(3427)] = 128012,
  [SMALL_STATE(3428)] = 128020,
  [SMALL_STATE(3429)] = 128028,
  [SMALL_STATE(3430)] = 128036,
  [SMALL_STATE(3431)] = 128044,
  [SMALL_STATE(3432)] = 128052,
  [SMALL_STATE(3433)] = 128060,
  [SMALL_STATE(3434)] = 128068,
  [SMALL_STATE(3435)] = 128076,
  [SMALL_STATE(3436)] = 128084,
  [SMALL_STATE(3437)] = 128092,
  [SMALL_STATE(3438)] = 128100,
  [SMALL_STATE(3439)] = 128108,
  [SMALL_STATE(3440)] = 128116,
  [SMALL_STATE(3441)] = 128124,
  [SMALL_STATE(3442)] = 128132,
  [SMALL_STATE(3443)] = 128140,
  [SMALL_STATE(3444)] = 128148,
  [SMALL_STATE(3445)] = 128156,
  [SMALL_STATE(3446)] = 128164,
  [SMALL_STATE(3447)] = 128172,
  [SMALL_STATE(3448)] = 128180,
  [SMALL_STATE(3449)] = 128188,
  [SMALL_STATE(3450)] = 128196,
  [SMALL_STATE(3451)] = 128204,
  [SMALL_STATE(3452)] = 128212,
  [SMALL_STATE(3453)] = 128220,
  [SMALL_STATE(3454)] = 128228,
  [SMALL_STATE(3455)] = 128236,
  [SMALL_STATE(3456)] = 128244,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [7] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 0),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1017),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2660),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2273),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1100),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(88),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(890),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(801),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(859),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(764),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3048),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3030),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3031),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1009),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(90),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(871),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1047),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(889),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3453),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(812),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3443),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3442),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3441),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(873),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(77),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3440),
  [61] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [63] = {.entry = {.count = 1, .reusable = true}}, SHIFT(926),
  [65] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1118),
  [67] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(929),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2012),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(755),
  [75] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1312),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1312),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(163),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3439),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3438),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3437),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3436),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3033),
  [91] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3035),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3433),
  [95] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3431),
  [97] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2025),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(912),
  [101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(89),
  [103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(869),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1051),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(924),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3416),
  [111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(809),
  [113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3444),
  [115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3418),
  [117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3308),
  [119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3163),
  [121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3310),
  [123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3311),
  [125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3081),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3078),
  [129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3445),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3419),
  [133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2815),
  [139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3086),
  [143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1822),
  [151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3083),
  [155] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2),
  [157] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1017),
  [160] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(2660),
  [163] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(2273),
  [166] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(522),
  [169] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1100),
  [172] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(88),
  [175] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(890),
  [178] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(801),
  [181] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(859),
  [184] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(764),
  [187] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(3048),
  [190] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(3030),
  [193] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(3031),
  [196] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1009),
  [199] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(90),
  [202] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(871),
  [205] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1047),
  [208] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(889),
  [211] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(3453),
  [214] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(812),
  [217] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(3443),
  [220] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(3442),
  [223] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(3441),
  [226] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(873),
  [229] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(77),
  [232] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(3440),
  [235] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(546),
  [238] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(926),
  [241] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1118),
  [244] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(524),
  [247] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(929),
  [250] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(2012),
  [253] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(755),
  [256] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1312),
  [259] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1312),
  [262] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(163),
  [265] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(3439),
  [268] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(3438),
  [271] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(3437),
  [274] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(3436),
  [277] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(3033),
  [280] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(3035),
  [283] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(3433),
  [286] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(3431),
  [289] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(2025),
  [292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 1),
  [294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1820),
  [298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2930),
  [300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [308] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(912),
  [311] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(89),
  [314] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(869),
  [317] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1051),
  [320] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(924),
  [323] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(3416),
  [326] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(809),
  [329] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(3444),
  [332] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(3418),
  [335] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(3308),
  [338] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(3163),
  [341] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(3310),
  [344] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(3311),
  [347] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(3081),
  [350] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(3078),
  [353] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(3445),
  [356] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(3419),
  [359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1520),
  [361] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1),
  [363] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1),
  [365] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(693),
  [368] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, .production_id = 1), REDUCE(sym_primary_expression, 1, .production_id = 1),
  [371] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(1172),
  [374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1473),
  [376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__named_expression_lhs, 1, .production_id = 1),
  [378] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern, 1, .production_id = 1),
  [380] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(3401),
  [383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1476),
  [385] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(692),
  [388] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(1083),
  [391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [393] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(919),
  [396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1083),
  [398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2004),
  [400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1, .production_id = 1),
  [402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1536),
  [404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1536),
  [406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(181),
  [408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2029),
  [410] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, .production_id = 1), REDUCE(sym_primary_expression, 1, .production_id = 1),
  [413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1016),
  [415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1126),
  [419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(87),
  [421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1020),
  [423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3401),
  [425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(874),
  [427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(78),
  [429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(164),
  [433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1247),
  [467] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(696),
  [470] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(1114),
  [473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1257),
  [475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(964),
  [477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1235),
  [479] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(695),
  [482] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(1118),
  [485] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), SHIFT(929),
  [488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(166),
  [490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1482),
  [492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1165),
  [496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(692),
  [498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1083),
  [500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(919),
  [502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1018),
  [504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2210),
  [510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3124),
  [570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3111),
  [594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3104),
  [606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3056),
  [630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2169),
  [634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3064),
  [642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3034),
  [658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1859),
  [662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1824),
  [722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3084),
  [724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1841),
  [726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2858),
  [736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2889),
  [738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3088),
  [740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1114),
  [756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1291),
  [758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1292),
  [760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1118),
  [764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(170),
  [766] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_splat_pattern, 2, .production_id = 7),
  [768] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym_list_splat_pattern, 2, .production_id = 7),
  [771] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_splat_pattern, 2, .production_id = 7),
  [773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1559),
  [775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1560),
  [777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(197),
  [779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1449),
  [781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1143),
  [785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1431),
  [787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1430),
  [789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1196),
  [793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1449),
  [797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(186),
  [799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2028),
  [801] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym_list_splat_pattern, 2, .production_id = 7),
  [804] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 4, .production_id = 46),
  [806] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 4, .production_id = 46),
  [808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3167),
  [810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1013),
  [812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3244),
  [814] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 5, .production_id = 69),
  [816] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 5, .production_id = 69),
  [818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(865),
  [820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3348),
  [822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3342),
  [826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(864),
  [828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1660),
  [830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1192),
  [834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1576),
  [836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1575),
  [838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(885),
  [840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1090),
  [844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1660),
  [848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(215),
  [850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2045),
  [852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1477),
  [854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1082),
  [858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1502),
  [860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1503),
  [862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1174),
  [866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1477),
  [870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(201),
  [872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2043),
  [874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1642),
  [876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(653),
  [878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1184),
  [880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1679),
  [882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1680),
  [884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1132),
  [888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1642),
  [892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(198),
  [894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2031),
  [896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1752),
  [898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1145),
  [902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1705),
  [904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1704),
  [906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1188),
  [910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1752),
  [914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(210),
  [916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2050),
  [918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1654),
  [920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1191),
  [924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1633),
  [926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1632),
  [928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1140),
  [932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1654),
  [936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(220),
  [938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2039),
  [940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(901),
  [942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1780),
  [944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1152),
  [948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1802),
  [950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1803),
  [952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1002),
  [954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1107),
  [958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1780),
  [962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(233),
  [964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2051),
  [966] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym___directive_parameters_wc_none, 4),
  [968] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___directive_parameters_wc_none, 4),
  [970] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym___directive_parameters_wc_none, 3),
  [972] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___directive_parameters_wc_none, 3),
  [974] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym___directive_parameters_wc_none, 7),
  [976] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___directive_parameters_wc_none, 7),
  [978] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, .production_id = 41),
  [980] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, .production_id = 41),
  [982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(972),
  [984] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, .production_id = 62),
  [986] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, .production_id = 62),
  [988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(988),
  [990] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, .production_id = 90),
  [992] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, .production_id = 90),
  [994] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym___directive_parameters_wc_none, 8),
  [996] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___directive_parameters_wc_none, 8),
  [998] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, .production_id = 63),
  [1000] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, .production_id = 63),
  [1002] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2),
  [1004] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat1, 2),
  [1006] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(864),
  [1009] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat2, 2),
  [1011] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat2, 2),
  [1013] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat2, 2), SHIFT_REPEAT(898),
  [1016] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym___directive_parameters_wc_none, 1),
  [1018] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___directive_parameters_wc_none, 1),
  [1020] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat2, 2), SHIFT_REPEAT(1013),
  [1023] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(865),
  [1026] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym___directive_parameters_wc_none, 2),
  [1028] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___directive_parameters_wc_none, 2),
  [1030] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym___directive_parameters_wc_none, 6),
  [1032] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___directive_parameters_wc_none, 6),
  [1034] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym___directive_parameters_wc_none, 5),
  [1036] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___directive_parameters_wc_none, 5),
  [1038] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 2, .production_id = 88),
  [1040] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 2, .production_id = 88),
  [1042] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 2, .production_id = 88), SHIFT_REPEAT(988),
  [1045] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 2, .production_id = 88), SHIFT_REPEAT(972),
  [1048] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_clause, 4),
  [1050] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_clause, 4),
  [1052] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_group_clause, 6, .production_id = 139),
  [1054] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_group_clause, 6, .production_id = 139),
  [1056] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 2),
  [1058] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 2),
  [1060] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_statements, 4),
  [1062] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_statements, 4),
  [1064] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 1),
  [1066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 1),
  [1068] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_statements, 3),
  [1070] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_statements, 3),
  [1072] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_clause, 4, .production_id = 113),
  [1074] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_clause, 4, .production_id = 113),
  [1076] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_clause, 5),
  [1078] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_clause, 5),
  [1080] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_group_clause, 5),
  [1082] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_group_clause, 5),
  [1084] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rule_exclude_list, 2),
  [1086] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rule_exclude_list, 2),
  [1088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [1090] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_statements, 2),
  [1092] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_statements, 2),
  [1094] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rule_exclude_list, 1),
  [1096] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rule_exclude_list, 1),
  [1098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [1100] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_global_statement_repeat1, 2),
  [1102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_global_statement_repeat1, 2),
  [1104] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_global_statement_repeat1, 2), SHIFT_REPEAT(3290),
  [1107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_clause, 6, .production_id = 139),
  [1109] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_clause, 6, .production_id = 139),
  [1111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_group_clause, 4, .production_id = 113),
  [1113] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_group_clause, 4, .production_id = 113),
  [1115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [1117] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_global_statement_repeat1, 2), SHIFT_REPEAT(3408),
  [1120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [1122] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_clause, 7),
  [1124] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_clause, 7),
  [1126] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_group_clause, 7),
  [1128] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_group_clause, 7),
  [1130] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_clause, 3, .production_id = 97),
  [1132] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_clause, 3, .production_id = 97),
  [1134] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rule_import, 5, .production_id = 76),
  [1136] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rule_import, 5, .production_id = 76),
  [1138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3385),
  [1140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3383),
  [1142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3057),
  [1144] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 6, .production_id = 69),
  [1146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 6, .production_id = 69),
  [1148] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 5, .production_id = 68),
  [1150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 5, .production_id = 68),
  [1152] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, .production_id = 95),
  [1154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, .production_id = 95),
  [1156] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___directive_parameters_ruleorder, 2),
  [1158] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym___directive_parameters_ruleorder, 2),
  [1160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3215),
  [1162] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 5, .production_id = 46),
  [1164] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 5, .production_id = 46),
  [1166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3341),
  [1168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3343),
  [1170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3067),
  [1172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 4, .production_id = 45),
  [1174] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 4, .production_id = 45),
  [1176] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym___directive_parameters_ruleorder_repeat1, 2),
  [1178] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym___directive_parameters_ruleorder_repeat1, 2),
  [1180] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym___directive_parameters_ruleorder_repeat1, 2), SHIFT_REPEAT(3215),
  [1183] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elif_clause, 5, .production_id = 63),
  [1185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elif_clause, 5, .production_id = 63),
  [1187] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym___directive_parameters_ruleorder_repeat1, 2), SHIFT_REPEAT(3326),
  [1190] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 1, .production_id = 60),
  [1192] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 1, .production_id = 60),
  [1194] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 122),
  [1196] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 122),
  [1198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 108),
  [1200] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 108),
  [1202] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 112),
  [1204] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 112),
  [1206] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elif_clause, 4, .production_id = 41),
  [1208] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elif_clause, 4, .production_id = 41),
  [1210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3326),
  [1212] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym___directive_parameters_ruleorder, 1),
  [1214] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___directive_parameters_ruleorder, 1),
  [1216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 4, .production_id = 69),
  [1218] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 4, .production_id = 69),
  [1220] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rule_import, 7, .production_id = 76),
  [1222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rule_import, 7, .production_id = 76),
  [1224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3316),
  [1226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3314),
  [1228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3380),
  [1230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3370),
  [1232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(317),
  [1234] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rule_exclude_list, 3),
  [1236] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rule_exclude_list, 3),
  [1238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(314),
  [1240] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 3, .production_id = 46),
  [1242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 3, .production_id = 46),
  [1244] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finally_clause, 3, .production_id = 97),
  [1246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally_clause, 3, .production_id = 97),
  [1248] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 6, .production_id = 94),
  [1250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 6, .production_id = 94),
  [1252] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 9, .production_id = 138),
  [1254] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 9, .production_id = 138),
  [1256] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 9, .production_id = 137),
  [1258] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 9, .production_id = 137),
  [1260] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9, .production_id = 136),
  [1262] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9, .production_id = 136),
  [1264] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 6, .production_id = 101),
  [1266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 6, .production_id = 101),
  [1268] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 6, .production_id = 102),
  [1270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 6, .production_id = 102),
  [1272] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym___directive_parameters_identifiers, 4),
  [1274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___directive_parameters_identifiers, 4),
  [1276] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_body, 3),
  [1278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_body, 3),
  [1280] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rule_import, 8, .production_id = 129),
  [1282] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rule_import, 8, .production_id = 129),
  [1284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rule_inheritance, 8, .production_id = 128),
  [1286] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rule_inheritance, 8, .production_id = 128),
  [1288] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___directive_parameters_identifiers, 6),
  [1290] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym___directive_parameters_identifiers, 6),
  [1292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_directive_wc_none, 3, .production_id = 20),
  [1294] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_directive_wc_none, 3, .production_id = 20),
  [1296] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_directive_block, 3, .production_id = 21),
  [1298] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_directive_block, 3, .production_id = 21),
  [1300] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 7, .production_id = 107),
  [1302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 7, .production_id = 107),
  [1304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___directive_parameters_identifiers, 1),
  [1306] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym___directive_parameters_identifiers, 1),
  [1308] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 8, .production_id = 127),
  [1310] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 8, .production_id = 127),
  [1312] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_localrules_directive, 3, .production_id = 20),
  [1314] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_localrules_directive, 3, .production_id = 20),
  [1316] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ruleorder_directive, 3, .production_id = 20),
  [1318] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ruleorder_directive, 3, .production_id = 20),
  [1320] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 8, .production_id = 126),
  [1322] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 8, .production_id = 126),
  [1324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rule_definition, 3, .production_id = 19),
  [1326] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rule_definition, 3, .production_id = 19),
  [1328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_checkpoint_definition, 3, .production_id = 19),
  [1330] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_checkpoint_definition, 3, .production_id = 19),
  [1332] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 7, .production_id = 109),
  [1334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 7, .production_id = 109),
  [1336] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 125),
  [1338] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 125),
  [1340] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 7, .production_id = 110),
  [1342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 7, .production_id = 110),
  [1344] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 8, .production_id = 124),
  [1346] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 8, .production_id = 124),
  [1348] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 8, .production_id = 123),
  [1350] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 8, .production_id = 123),
  [1352] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 111),
  [1354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 111),
  [1356] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 121),
  [1358] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 121),
  [1360] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finally_clause, 4),
  [1362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally_clause, 4),
  [1364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rule_import, 7, .production_id = 117),
  [1366] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rule_import, 7, .production_id = 117),
  [1368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3387),
  [1370] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 7, .production_id = 69),
  [1372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 7, .production_id = 69),
  [1374] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 7, .production_id = 114),
  [1376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 7, .production_id = 114),
  [1378] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 7, .production_id = 115),
  [1380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 7, .production_id = 115),
  [1382] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___directive_parameters_identifiers, 5),
  [1384] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym___directive_parameters_identifiers, 5),
  [1386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 7, .production_id = 116),
  [1388] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 7, .production_id = 116),
  [1390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3317),
  [1392] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 6, .production_id = 99),
  [1394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 6, .production_id = 99),
  [1396] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 6, .production_id = 98),
  [1398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 6, .production_id = 98),
  [1400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rule_body, 1),
  [1402] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rule_body, 1),
  [1404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 9, .production_id = 140),
  [1406] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 9, .production_id = 140),
  [1408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statement, 1, .production_id = 3),
  [1410] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statement, 1, .production_id = 3),
  [1412] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 5, .production_id = 67),
  [1414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 5, .production_id = 67),
  [1416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___directive_parameters_identifiers, 7),
  [1418] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym___directive_parameters_identifiers, 7),
  [1420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rule_import, 9, .production_id = 141),
  [1422] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rule_import, 9, .production_id = 141),
  [1424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3273),
  [1426] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 6, .production_id = 46),
  [1428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 6, .production_id = 46),
  [1430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 6, .production_id = 100),
  [1432] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 6, .production_id = 100),
  [1434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 10, .production_id = 146),
  [1436] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 10, .production_id = 146),
  [1438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___directive_parameters_identifiers, 8),
  [1440] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym___directive_parameters_identifiers, 8),
  [1442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 6, .production_id = 96),
  [1444] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 6, .production_id = 96),
  [1446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rule_import, 10, .production_id = 147),
  [1448] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rule_import, 10, .production_id = 147),
  [1450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rule_import, 10, .production_id = 148),
  [1452] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rule_import, 10, .production_id = 148),
  [1454] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_statement, 6, .production_id = 93),
  [1456] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_statement, 6, .production_id = 93),
  [1458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_statement, 6, .production_id = 92),
  [1460] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_statement, 6, .production_id = 92),
  [1462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__match_block, 3, .production_id = 91),
  [1464] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__match_block, 3, .production_id = 91),
  [1466] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rule_import, 12, .production_id = 153),
  [1468] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rule_import, 12, .production_id = 153),
  [1470] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, .production_id = 89),
  [1472] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, .production_id = 89),
  [1474] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__match_block, 1),
  [1476] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__match_block, 1),
  [1478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, .production_id = 87),
  [1480] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, .production_id = 87),
  [1482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_statement, 4, .production_id = 43),
  [1484] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_statement, 4, .production_id = 43),
  [1486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3292),
  [1488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rule_body, 2),
  [1490] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rule_body, 2),
  [1492] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statement, 1, .production_id = 4),
  [1494] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statement, 1, .production_id = 4),
  [1496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___directive_parameters_identifiers, 3),
  [1498] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym___directive_parameters_identifiers, 3),
  [1500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorated_definition, 2, .production_id = 14),
  [1502] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorated_definition, 2, .production_id = 14),
  [1504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 5, .production_id = 74),
  [1506] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 5, .production_id = 74),
  [1508] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 5, .production_id = 73),
  [1510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 5, .production_id = 73),
  [1512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_statement, 4, .production_id = 47),
  [1514] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_statement, 4, .production_id = 47),
  [1516] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 5, .production_id = 72),
  [1518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 5, .production_id = 72),
  [1520] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 5, .production_id = 71),
  [1522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 5, .production_id = 71),
  [1524] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_statement, 5, .production_id = 70),
  [1526] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_statement, 5, .production_id = 70),
  [1528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 4, .production_id = 48),
  [1530] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 4, .production_id = 48),
  [1532] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_directive_block, 4, .production_id = 52),
  [1534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_directive_block, 4, .production_id = 52),
  [1536] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym___directive_parameters_identifiers, 2),
  [1538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___directive_parameters_identifiers, 2),
  [1540] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__rule_suite, 2),
  [1542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__rule_suite, 2),
  [1544] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_statement, 5, .production_id = 66),
  [1546] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_statement, 5, .production_id = 66),
  [1548] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_statement, 5, .production_id = 65),
  [1550] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_statement, 5, .production_id = 65),
  [1552] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rule_definition, 4, .production_id = 53),
  [1554] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rule_definition, 4, .production_id = 53),
  [1556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__match_block, 2),
  [1558] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__match_block, 2),
  [1560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_statement, 5, .production_id = 64),
  [1562] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_statement, 5, .production_id = 64),
  [1564] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_checkpoint_definition, 4, .production_id = 53),
  [1566] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_checkpoint_definition, 4, .production_id = 53),
  [1568] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_body, 1),
  [1570] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_body, 1),
  [1572] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, .production_id = 61),
  [1574] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, .production_id = 61),
  [1576] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_definition, 4, .production_id = 53),
  [1578] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_definition, 4, .production_id = 53),
  [1580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1441),
  [1582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [1584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1933),
  [1586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1007),
  [1588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1395),
  [1590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1409),
  [1592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [1594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(886),
  [1596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2005),
  [1598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(740),
  [1600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(202),
  [1602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1019),
  [1604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1484),
  [1606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1295),
  [1608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [1610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3267),
  [1612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(917),
  [1614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1293),
  [1616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [1618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1294),
  [1620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1563),
  [1622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(939),
  [1624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2014),
  [1626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(605),
  [1628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(179),
  [1630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1517),
  [1632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [1634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [1636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1466),
  [1638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1469),
  [1640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [1642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1634),
  [1644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(895),
  [1646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2006),
  [1648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(760),
  [1650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(193),
  [1652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1995),
  [1654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3305),
  [1656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1429),
  [1658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1027),
  [1660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1974),
  [1662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3398),
  [1664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1299),
  [1666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1978),
  [1668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1623),
  [1670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1630),
  [1672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1986),
  [1674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1577),
  [1676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3336),
  [1678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1571),
  [1680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1646),
  [1682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1028),
  [1684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3425),
  [1686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1506),
  [1688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1499),
  [1690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1764),
  [1692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1970),
  [1694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3193),
  [1696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1717),
  [1698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1637),
  [1700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1769),
  [1702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3224),
  [1704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1681),
  [1706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1026),
  [1708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1998),
  [1710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3332),
  [1712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1631),
  [1714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1033),
  [1716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3247),
  [1718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1811),
  [1720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1934),
  [1722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1540),
  [1724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(903),
  [1726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1538),
  [1728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(999),
  [1730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1539),
  [1732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(191),
  [1734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [1736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [1738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1638),
  [1740] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern_list, 2),
  [1742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [1744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1100),
  [1746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1591),
  [1748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1594),
  [1750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [1752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(194),
  [1754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1834),
  [1756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [1758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern_list, 3),
  [1760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [1762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [1764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1494),
  [1766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1105),
  [1768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1670),
  [1770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3274),
  [1772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1672),
  [1774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2328),
  [1776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(945),
  [1778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2018),
  [1780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(187),
  [1782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2408),
  [1784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2324),
  [1786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2478),
  [1788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1384),
  [1790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [1792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1143),
  [1794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1286),
  [1796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1287),
  [1798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [1800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(954),
  [1802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2000),
  [1804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(167),
  [1806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2391),
  [1808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2389),
  [1810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2374),
  [1812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2515),
  [1814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1172),
  [1816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [1818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [1820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1831),
  [1822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [1824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1285),
  [1826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1117),
  [1828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1492),
  [1830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3170),
  [1832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1495),
  [1834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1012),
  [1836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2003),
  [1838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(184),
  [1840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1388),
  [1842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [1844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1739),
  [1846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3211),
  [1848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1007),
  [1850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1386),
  [1852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(943),
  [1854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1387),
  [1856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(178),
  [1858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1303),
  [1860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1150),
  [1862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3268),
  [1864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3388),
  [1866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [1868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1768),
  [1870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [1872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1112),
  [1874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1792),
  [1876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1786),
  [1878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [1880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(229),
  [1882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3389),
  [1884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [1886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [1888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [1890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1854),
  [1892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [1894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1417),
  [1896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3284),
  [1898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1781),
  [1900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3265),
  [1902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [1904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(648),
  [1906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1472),
  [1908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3390),
  [1910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3304),
  [1912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [1914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3296),
  [1916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [1918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3234),
  [1920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [1922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1402),
  [1924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1534),
  [1926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1404),
  [1928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1403),
  [1930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(196),
  [1932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1635),
  [1934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3226),
  [1936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1618),
  [1938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3406),
  [1940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3275),
  [1942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [1944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1622),
  [1946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [1948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(922),
  [1950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1620),
  [1952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1621),
  [1954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(189),
  [1956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1321),
  [1958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(996),
  [1960] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield, 1),
  [1962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1326),
  [1964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1323),
  [1966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(168),
  [1968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1596),
  [1970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3249),
  [1972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [1974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(630),
  [1976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1392),
  [1978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3291),
  [1980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1698),
  [1982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3187),
  [1984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1599),
  [1986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(973),
  [1988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1603),
  [1990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [1992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1602),
  [1994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(959),
  [1996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2001),
  [1998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(200),
  [2000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3175),
  [2002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1741),
  [2004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1737),
  [2006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1433),
  [2008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [2010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1393),
  [2012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1435),
  [2014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1617),
  [2016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(188),
  [2018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3179),
  [2020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1524),
  [2022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1776),
  [2024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1624),
  [2026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1785),
  [2028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3172),
  [2030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1625),
  [2032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3171),
  [2034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1796),
  [2036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [2038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [2040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3183),
  [2042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3198),
  [2044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1777),
  [2046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1616),
  [2048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1572),
  [2050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3252),
  [2052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1838),
  [2054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1569),
  [2056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3259),
  [2058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [2060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1318),
  [2062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1562),
  [2064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1606),
  [2066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1728),
  [2068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1486),
  [2070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1558),
  [2072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1474),
  [2074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1608),
  [2076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1316),
  [2078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1687),
  [2080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1723),
  [2082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1688),
  [2084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1791),
  [2086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1790),
  [2088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1671),
  [2090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [2092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1845),
  [2094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [2096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [2098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1836),
  [2100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [2102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1405),
  [2104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1401),
  [2106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1317),
  [2108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1844),
  [2110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1319),
  [2112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1475),
  [2114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1829),
  [2116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1398),
  [2118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1648),
  [2120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [2122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1397),
  [2124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1532),
  [2126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1729),
  [2128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1327),
  [2130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1320),
  [2132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1523),
  [2134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [2136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1487),
  [2138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1684),
  [2140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1522),
  [2142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1450),
  [2144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1452),
  [2146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1653),
  [2148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3243),
  [2150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1669),
  [2152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1659),
  [2154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3331),
  [2156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1454),
  [2158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1742),
  [2160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1453),
  [2162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [2164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1661),
  [2166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [2168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [2170] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__collection_elements, 3),
  [2172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1677),
  [2174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [2176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [2178] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__collection_elements, 2),
  [2180] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 6, .production_id = 105),
  [2182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1192),
  [2184] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_clause, 6, .production_id = 105),
  [2186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2008),
  [2188] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 5, .production_id = 86),
  [2190] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_clause, 5, .production_id = 86),
  [2192] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 6, .production_id = 106),
  [2194] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_clause, 6, .production_id = 106),
  [2196] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 7, .production_id = 118),
  [2198] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_clause, 7, .production_id = 118),
  [2200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1191),
  [2202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2013),
  [2204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1497),
  [2206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [2208] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_list, 2),
  [2210] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_list, 3),
  [2212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1082),
  [2214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2017),
  [2216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1004),
  [2218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1184),
  [2220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1595),
  [2222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1468),
  [2224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1396),
  [2226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1455),
  [2228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1760),
  [2230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1713),
  [2232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1412),
  [2234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1308),
  [2236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1527),
  [2238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1573),
  [2240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1586),
  [2242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1706),
  [2244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1696),
  [2246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(955),
  [2248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1114),
  [2250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1313),
  [2252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1807),
  [2254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1678),
  [2256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(993),
  [2258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1145),
  [2260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1666),
  [2262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1682),
  [2264] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raise_statement, 1),
  [2266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1006),
  [2268] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice, 1),
  [2270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [2272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(765),
  [2274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1565),
  [2276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1808),
  [2278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1347),
  [2280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1716),
  [2282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1810),
  [2284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1773),
  [2286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1765),
  [2288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1361),
  [2290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1031),
  [2292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1763),
  [2294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1030),
  [2296] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice, 2),
  [2298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [2300] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_list, 2),
  [2302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1360),
  [2304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary_splat_pattern, 2, .production_id = 7),
  [2306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1021),
  [2308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1415),
  [2310] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_list, 3),
  [2312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1266),
  [2314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1239),
  [2316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1740),
  [2318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1443),
  [2320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1442),
  [2322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1438),
  [2324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1228),
  [2326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1804),
  [2328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1738),
  [2330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1554),
  [2332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1557),
  [2334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1546),
  [2336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1414),
  [2338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1551),
  [2340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1568),
  [2342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 1),
  [2344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1424),
  [2346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1556),
  [2348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1555),
  [2350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1564),
  [2352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(593),
  [2354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1165),
  [2356] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 3),
  [2358] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 3, .dynamic_precedence = -1, .production_id = 8),
  [2360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 4, .production_id = 16),
  [2362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3297),
  [2364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 3),
  [2366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3188),
  [2368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 4, .dynamic_precedence = -1, .production_id = 17),
  [2370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 2),
  [2372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice, 4),
  [2374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 3),
  [2376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2),
  [2378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice, 3),
  [2380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [2382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [2384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2802),
  [2386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1056),
  [2388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [2390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3446),
  [2392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2926),
  [2394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1049),
  [2396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [2398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3407),
  [2400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2699),
  [2402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2038),
  [2404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2666),
  [2406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2852),
  [2408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1722),
  [2410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1152),
  [2412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1703),
  [2414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1727),
  [2416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(208),
  [2418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1490),
  [2420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1501),
  [2422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1500),
  [2424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(195),
  [2426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1708),
  [2428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1757),
  [2430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1712),
  [2432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(212),
  [2434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1724),
  [2436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1735),
  [2438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1725),
  [2440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1309),
  [2442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1306),
  [2444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1284),
  [2446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(183),
  [2448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1719),
  [2450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1721),
  [2452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1720),
  [2454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(190),
  [2456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1730),
  [2458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1732),
  [2460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1731),
  [2462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1753),
  [2464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1755),
  [2466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1754),
  [2468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(214),
  [2470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1448),
  [2472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1445),
  [2474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1447),
  [2476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_expression, 1),
  [2478] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1), REDUCE(sym_primary_expression, 1),
  [2481] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primary_expression, 1),
  [2483] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__named_expression_lhs, 1),
  [2485] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1), REDUCE(sym_primary_expression, 1),
  [2488] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern, 1),
  [2490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [2492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1),
  [2494] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript, 6, .production_id = 79),
  [2496] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript, 6, .production_id = 79),
  [2498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_splat_pattern, 2),
  [2500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_splat_type, 2),
  [2502] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_list_splat_pattern, 2),
  [2505] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_list_splat_pattern, 2),
  [2508] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_splat_pattern, 2),
  [2510] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_splat_type, 2),
  [2512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript, 5, .production_id = 79),
  [2514] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript, 5, .production_id = 79),
  [2516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 2),
  [2518] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1), REDUCE(sym_primary_expression, 1, .production_id = 2),
  [2521] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 2),
  [2523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript, 4, .production_id = 54),
  [2525] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript, 4, .production_id = 54),
  [2527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple, 2),
  [2529] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_tuple_pattern, 2), REDUCE(sym_tuple, 2),
  [2532] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple, 2),
  [2534] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_pattern, 2),
  [2536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 2),
  [2538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 2),
  [2540] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_list_pattern, 2), REDUCE(sym_list, 2),
  [2543] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 2),
  [2545] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_pattern, 2),
  [2547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_pattern, 2),
  [2549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript, 5, .production_id = 54),
  [2551] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript, 5, .production_id = 54),
  [2553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 3, .production_id = 27),
  [2555] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute, 3, .production_id = 27),
  [2557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1941),
  [2559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [2561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1108),
  [2563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1938),
  [2565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1939),
  [2567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [2569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(729),
  [2571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1982),
  [2573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [2575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2896),
  [2577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1180),
  [2579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1965),
  [2581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1962),
  [2583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [2585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(823),
  [2587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2751),
  [2589] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__patterns, 2),
  [2591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1985),
  [2593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [2595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1971),
  [2597] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern_list, 2),
  [2599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1993),
  [2601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [2603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(811),
  [2605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__patterns, 3),
  [2607] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern_list, 3),
  [2609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1999),
  [2611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [2613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1081),
  [2615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1983),
  [2617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1984),
  [2619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [2621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(830),
  [2623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1112),
  [2625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1960),
  [2627] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_separator, 1),
  [2629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1980),
  [2631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1981),
  [2633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(829),
  [2635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1948),
  [2637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1955),
  [2639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1954),
  [2641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(776),
  [2643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1170),
  [2645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1106),
  [2647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1169),
  [2649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1137),
  [2651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1093),
  [2653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1131),
  [2655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1193),
  [2657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1149),
  [2659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1096),
  [2661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1736),
  [2663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1750),
  [2665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1702),
  [2667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(192),
  [2669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1434),
  [2671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1400),
  [2673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1399),
  [2675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(169),
  [2677] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concatenated_string, 2),
  [2679] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concatenated_string, 2),
  [2681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1039),
  [2683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1034),
  [2685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1035),
  [2687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(165),
  [2689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1726),
  [2691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1457),
  [2693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1485),
  [2695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1489),
  [2697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1771),
  [2699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1817),
  [2701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1778),
  [2703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(231),
  [2705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1390),
  [2707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1289),
  [2709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1290),
  [2711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(171),
  [2713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1619),
  [2715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1574),
  [2717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1582),
  [2719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(180),
  [2721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1022),
  [2723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1997),
  [2725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1640),
  [2727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1794),
  [2729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1762),
  [2731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1758),
  [2733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(234),
  [2735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1545),
  [2737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1610),
  [2739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1609),
  [2741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(199),
  [2743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1734),
  [2745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1588),
  [2747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1973),
  [2749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1963),
  [2751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1990),
  [2753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(853),
  [2755] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2),
  [2757] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2),
  [2759] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(2051),
  [2762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1592),
  [2764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1580),
  [2766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1587),
  [2768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1636),
  [2770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1651),
  [2772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1664),
  [2774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1959),
  [2776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1956),
  [2778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1958),
  [2780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(781),
  [2782] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(2025),
  [2785] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1),
  [2787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3255),
  [2789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [2791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1168),
  [2793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1167),
  [2795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1166),
  [2797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1156),
  [2799] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1),
  [2801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [2803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1168),
  [2805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1155),
  [2807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1154),
  [2809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3378),
  [2811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1153),
  [2813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1151),
  [2815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1166),
  [2817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1073),
  [2819] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_operator, 3, .production_id = 25),
  [2821] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_operator, 3, .production_id = 25),
  [2823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3),
  [2825] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 3),
  [2827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3214),
  [2829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3210),
  [2831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3209),
  [2833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3205),
  [2835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [2837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2047),
  [2839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2),
  [2841] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 2),
  [2843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 3, .production_id = 56),
  [2845] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 3, .production_id = 56),
  [2847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 3, .production_id = 55),
  [2849] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 3, .production_id = 55),
  [2851] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 28),
  [2853] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 28),
  [2855] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_operator, 2, .production_id = 11),
  [2857] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_operator, 2, .production_id = 11),
  [2859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_await, 2),
  [2861] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_await, 2),
  [2863] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(2043),
  [2866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3295),
  [2868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [2870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1171),
  [2872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1175),
  [2874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1176),
  [2876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1177),
  [2878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(806),
  [2880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1171),
  [2882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1179),
  [2884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1078),
  [2886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3412),
  [2888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1181),
  [2890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1182),
  [2892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1176),
  [2894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1068),
  [2896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3217),
  [2898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [2900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1147),
  [2902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1142),
  [2904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1124),
  [2906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1116),
  [2908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [2910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1147),
  [2912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1110),
  [2914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1104),
  [2916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3294),
  [2918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1102),
  [2920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1101),
  [2922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1124),
  [2924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1072),
  [2926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [2928] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(2028),
  [2931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3180),
  [2933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(595),
  [2935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1130),
  [2937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1129),
  [2939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1128),
  [2941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1127),
  [2943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [2945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1130),
  [2947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1125),
  [2949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1123),
  [2951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3253),
  [2953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1122),
  [2955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1121),
  [2957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1128),
  [2959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1076),
  [2961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3379),
  [2963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(844),
  [2965] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(2039),
  [2968] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rule_body_repeat1, 2), SHIFT_REPEAT(3214),
  [2971] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rule_body_repeat1, 2), SHIFT_REPEAT(3210),
  [2974] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rule_body_repeat1, 2), SHIFT_REPEAT(3209),
  [2977] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rule_body_repeat1, 2), SHIFT_REPEAT(3205),
  [2980] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_rule_body_repeat1, 2),
  [2982] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rule_body_repeat1, 2), SHIFT_REPEAT(2047),
  [2985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3200),
  [2987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [2989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1109),
  [2991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1113),
  [2993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1079),
  [2995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1077),
  [2997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [2999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1109),
  [3001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1084),
  [3003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1087),
  [3005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3213),
  [3007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1089),
  [3009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1091),
  [3011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1079),
  [3013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1069),
  [3015] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(2045),
  [3018] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(2031),
  [3021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [3023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [3025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3415),
  [3027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [3029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1099),
  [3031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1088),
  [3033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1086),
  [3035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1080),
  [3037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [3039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1099),
  [3041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1133),
  [3043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1134),
  [3045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3199),
  [3047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1135),
  [3049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1136),
  [3051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1086),
  [3053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1075),
  [3055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3358),
  [3057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [3059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1157),
  [3061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1158),
  [3063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1159),
  [3065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1160),
  [3067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [3069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1157),
  [3071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1161),
  [3073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1162),
  [3075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3359),
  [3077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1163),
  [3079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1164),
  [3081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1159),
  [3083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1071),
  [3085] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(2029),
  [3088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [3090] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(2050),
  [3093] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary, 2),
  [3095] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dictionary, 2),
  [3097] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 3),
  [3099] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 3),
  [3101] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 3, .production_id = 37),
  [3103] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 3, .production_id = 37),
  [3105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [3107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary_comprehension, 4, .production_id = 38),
  [3109] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dictionary_comprehension, 4, .production_id = 38),
  [3111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set_comprehension, 4, .production_id = 38),
  [3113] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_set_comprehension, 4, .production_id = 38),
  [3115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary, 4),
  [3117] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dictionary, 4),
  [3119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple, 3),
  [3121] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple, 3),
  [3123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_comprehension, 4, .production_id = 38),
  [3125] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_comprehension, 4, .production_id = 38),
  [3127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary, 5),
  [3129] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dictionary, 5),
  [3131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3),
  [3133] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3),
  [3135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 4),
  [3137] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 4),
  [3139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 5),
  [3141] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 5),
  [3143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 4, .production_id = 37),
  [3145] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 4, .production_id = 37),
  [3147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 5, .production_id = 37),
  [3149] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 5, .production_id = 37),
  [3151] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_expression, 4, .production_id = 38),
  [3153] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_expression, 4, .production_id = 38),
  [3155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3254),
  [3157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [3159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1115),
  [3161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1173),
  [3163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1178),
  [3165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1186),
  [3167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [3169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1115),
  [3171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1189),
  [3173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [3175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3202),
  [3177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1198),
  [3179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1195),
  [3181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1178),
  [3183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1070),
  [3185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set, 3),
  [3187] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_set, 3),
  [3189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary, 3),
  [3191] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dictionary, 3),
  [3193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call, 2, .production_id = 12),
  [3195] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call, 2, .production_id = 12),
  [3197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 3),
  [3199] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 3),
  [3201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(887),
  [3203] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 2),
  [3205] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 2),
  [3207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3300),
  [3209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [3211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1146),
  [3213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1141),
  [3215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1139),
  [3217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1120),
  [3219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [3221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1146),
  [3223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1119),
  [3225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1111),
  [3227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3256),
  [3229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1098),
  [3231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1094),
  [3233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1139),
  [3235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1074),
  [3237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [3239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(900),
  [3241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1014),
  [3243] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(2047),
  [3246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_rule_body_repeat1, 1),
  [3248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2149),
  [3250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1870),
  [3252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3100),
  [3254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(942),
  [3256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [3258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3100),
  [3260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1864),
  [3262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3096),
  [3264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2382),
  [3266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1917),
  [3268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2243),
  [3270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2243),
  [3272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [3274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__rule_directive_wc_interp, 3, .production_id = 20),
  [3276] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___directive_parameters_wc_def, 9),
  [3278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___directive_parameters_wc_interp, 8),
  [3280] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___directive_parameters_wc_def, 8),
  [3282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___directive_parameters_wc_interp, 7),
  [3284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__rule_directive_wc_def, 3, .production_id = 20),
  [3286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___directive_parameters_wc_def, 3),
  [3288] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___directive_parameters_wc_interp, 3),
  [3290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__rule_directive_wc_none, 3, .production_id = 20),
  [3292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___directive_parameters_wc_def, 10),
  [3294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__rule_directive_block, 4, .production_id = 52),
  [3296] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___directive_parameters_wc_def, 5),
  [3298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___directive_parameters_wc_interp, 5),
  [3300] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___directive_parameters_wc_interp, 10),
  [3302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___directive_parameters_wc_def, 7),
  [3304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_rule_body_repeat1, 1, .production_id = 3),
  [3306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___directive_parameters_wc_interp, 4),
  [3308] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___directive_parameters_wc_def, 6),
  [3310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___directive_parameters_wc_interp, 6),
  [3312] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_rule_body_repeat1, 1, .production_id = 4),
  [3314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___directive_parameters_wc_def, 4),
  [3316] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___directive_parameters_wc_interp, 9),
  [3318] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__rule_directive_block, 3, .production_id = 21),
  [3320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2230),
  [3322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1880),
  [3324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2608),
  [3326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3043),
  [3328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3043),
  [3330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1885),
  [3332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3046),
  [3334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2494),
  [3336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1903),
  [3338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2369),
  [3340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2369),
  [3342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2220),
  [3344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1862),
  [3346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3139),
  [3348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3139),
  [3350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1879),
  [3352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2634),
  [3354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3140),
  [3356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2476),
  [3358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1916),
  [3360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2298),
  [3362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2298),
  [3364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2571),
  [3366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2486),
  [3368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2506),
  [3370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2623),
  [3372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2576),
  [3374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2568),
  [3376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2569),
  [3378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2479),
  [3380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2449),
  [3382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2653),
  [3384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2537),
  [3386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2429),
  [3388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2427),
  [3390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2528),
  [3392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2612),
  [3394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2643),
  [3396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2553),
  [3398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2563),
  [3400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2601),
  [3402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2637),
  [3404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2574),
  [3406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2468),
  [3408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2500),
  [3410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2604),
  [3412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2640),
  [3414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2638),
  [3416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2611),
  [3418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2605),
  [3420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2572),
  [3422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2617),
  [3424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2654),
  [3426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2575),
  [3428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2610),
  [3430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2633),
  [3432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2235),
  [3434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1890),
  [3436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3103),
  [3438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3103),
  [3440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1882),
  [3442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3091),
  [3444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2504),
  [3446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1909),
  [3448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2332),
  [3450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2332),
  [3452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2133),
  [3454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2991),
  [3456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2639),
  [3458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2420),
  [3460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2606),
  [3462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2636),
  [3464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2573),
  [3466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2488),
  [3468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2471),
  [3470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2627),
  [3472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2577),
  [3474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2424),
  [3476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2559),
  [3478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2595),
  [3480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2641),
  [3482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2642),
  [3484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2635),
  [3486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2599),
  [3488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2481),
  [3490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2570),
  [3492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2618),
  [3494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2621),
  [3496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2245),
  [3498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2526),
  [3500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2287),
  [3502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2463),
  [3504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2431),
  [3506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2283),
  [3508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2507),
  [3510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2364),
  [3512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2436),
  [3514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2497),
  [3516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2343),
  [3518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comparison_operator, 2, .production_id = 13),
  [3520] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_comparison_operator, 2, .production_id = 13),
  [3522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 29),
  [3524] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 29), SHIFT_REPEAT(1166),
  [3527] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 29),
  [3529] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 29), SHIFT_REPEAT(3378),
  [3532] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 29), SHIFT_REPEAT(1166),
  [3535] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 29), SHIFT_REPEAT(1073),
  [3538] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 29), SHIFT_REPEAT(1128),
  [3541] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 29), SHIFT_REPEAT(3253),
  [3544] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 29), SHIFT_REPEAT(1128),
  [3547] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 29), SHIFT_REPEAT(1076),
  [3550] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 29), SHIFT_REPEAT(1079),
  [3553] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 29), SHIFT_REPEAT(3213),
  [3556] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 29), SHIFT_REPEAT(1079),
  [3559] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 29), SHIFT_REPEAT(1069),
  [3562] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 29), SHIFT_REPEAT(1178),
  [3565] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 29), SHIFT_REPEAT(3202),
  [3568] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 29), SHIFT_REPEAT(1178),
  [3571] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 29), SHIFT_REPEAT(1070),
  [3574] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 29), SHIFT_REPEAT(1124),
  [3577] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 29), SHIFT_REPEAT(3294),
  [3580] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 29), SHIFT_REPEAT(1124),
  [3583] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 29), SHIFT_REPEAT(1072),
  [3586] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 29), SHIFT_REPEAT(1176),
  [3589] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 29), SHIFT_REPEAT(3412),
  [3592] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 29), SHIFT_REPEAT(1176),
  [3595] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 29), SHIFT_REPEAT(1068),
  [3598] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 29), SHIFT_REPEAT(1086),
  [3601] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 29), SHIFT_REPEAT(3199),
  [3604] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 29), SHIFT_REPEAT(1086),
  [3607] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 29), SHIFT_REPEAT(1075),
  [3610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [3612] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__patterns_repeat1, 2),
  [3614] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__patterns_repeat1, 2), SHIFT_REPEAT(1064),
  [3617] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 29), SHIFT_REPEAT(1159),
  [3620] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 29), SHIFT_REPEAT(3359),
  [3623] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 29), SHIFT_REPEAT(1159),
  [3626] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 29), SHIFT_REPEAT(1071),
  [3629] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary_splat_pattern, 2),
  [3631] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 3),
  [3633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3288),
  [3635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [3637] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_pattern, 3),
  [3639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3161),
  [3641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2199),
  [3643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2702),
  [3645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [3647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1066),
  [3649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [3651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1185),
  [3653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3049),
  [3655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [3657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(968),
  [3659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [3661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1011),
  [3663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(950),
  [3665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [3667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [3669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [3671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [3673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [3675] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__right_hand_side, 1),
  [3677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(963),
  [3679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [3681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(980),
  [3683] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__patterns_repeat1, 2), SHIFT_REPEAT(1065),
  [3686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [3688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [3690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [3692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [3694] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 29), SHIFT_REPEAT(1139),
  [3697] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 29), SHIFT_REPEAT(3256),
  [3700] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 29), SHIFT_REPEAT(1139),
  [3703] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 29), SHIFT_REPEAT(1074),
  [3706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2567),
  [3708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1042),
  [3710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3130),
  [3712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1067),
  [3714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1194),
  [3716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3157),
  [3718] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameters, 3),
  [3720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [3722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2156),
  [3724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2156),
  [3726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1229),
  [3728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3424),
  [3730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3423),
  [3732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1252),
  [3734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1385),
  [3736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1518),
  [3738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1207),
  [3740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1446),
  [3742] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameters, 2),
  [3744] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(560),
  [3747] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(2156),
  [3750] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(2156),
  [3753] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2),
  [3755] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(3424),
  [3758] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(3423),
  [3761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2771),
  [3763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1481),
  [3765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1378),
  [3767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2779),
  [3769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1483),
  [3771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1521),
  [3773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1856),
  [3775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1338),
  [3777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1436),
  [3779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1394),
  [3781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1480),
  [3783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1823),
  [3785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1367),
  [3787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1406),
  [3789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1570),
  [3791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1209),
  [3793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [3795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(879),
  [3797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(956),
  [3799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1000),
  [3801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3454),
  [3803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1054),
  [3805] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__collection_elements, 1),
  [3807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(976),
  [3809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(975),
  [3811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_expression, 3, .production_id = 22),
  [3813] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_named_expression, 3, .production_id = 22), SHIFT(938),
  [3816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [3818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(933),
  [3820] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_expression, 5),
  [3822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [3824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [3826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_boolean_operator, 3, .production_id = 25),
  [3828] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_as_pattern, 3, .production_id = 26),
  [3830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda, 4, .production_id = 51),
  [3832] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_not_operator, 2, .production_id = 8),
  [3834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda, 3, .production_id = 19),
  [3836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(718),
  [3838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(974),
  [3840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(952),
  [3842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3450),
  [3844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1057),
  [3846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(981),
  [3848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [3850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1812),
  [3852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [3854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(984),
  [3856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [3858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3362),
  [3860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1052),
  [3862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(983),
  [3864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(982),
  [3866] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 1),
  [3868] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 1),
  [3870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [3872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1544),
  [3874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(647),
  [3876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1598),
  [3878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [3880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1581),
  [3882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [3884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1460),
  [3886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [3888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1300),
  [3890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [3892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1315),
  [3894] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat1, 2), SHIFT_REPEAT(3272),
  [3897] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_module_body_repeat1, 2),
  [3899] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat1, 2), SHIFT_REPEAT(2051),
  [3902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1689),
  [3904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1815),
  [3906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1709),
  [3908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [3910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1627),
  [3912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1507),
  [3914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1692),
  [3916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [3918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3272),
  [3920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [3922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [3924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1601),
  [3926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1408),
  [3928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [3930] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_item, 1, .dynamic_precedence = 1, .production_id = 9), SHIFT(724),
  [3933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1673),
  [3935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(658),
  [3937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1749),
  [3939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1427),
  [3941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [3943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [3945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(941),
  [3947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [3949] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_named_expression, 3, .production_id = 22), SHIFT(948),
  [3952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(995),
  [3954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [3956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(991),
  [3958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(977),
  [3960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [3962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [3964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(961),
  [3966] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__f_expression, 1),
  [3968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [3970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [3972] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_named_expression, 3, .production_id = 22), SHIFT(995),
  [3975] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield, 2),
  [3977] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_content_repeat1, 2),
  [3979] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_content_repeat1, 2), SHIFT_REPEAT(2128),
  [3982] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_content_repeat1, 2), SHIFT_REPEAT(2128),
  [3985] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_not_operator, 2, .production_id = 8),
  [3987] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_dotted_name_repeat1, 2),
  [3989] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dotted_name_repeat1, 2), SHIFT_REPEAT(3361),
  [3992] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dotted_name, 1),
  [3994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3361),
  [3996] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield, 3),
  [3998] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_module_body_repeat1, 1),
  [4000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1001),
  [4002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(997),
  [4004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [4006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(987),
  [4008] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_named_expression, 3, .production_id = 22), SHIFT(1001),
  [4011] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_named_expression, 3, .production_id = 22), SHIFT(910),
  [4014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1926),
  [4016] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dotted_name, 2),
  [4018] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_assert_statement_repeat1, 2),
  [4020] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_content, 1),
  [4022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2128),
  [4024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2128),
  [4026] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_named_expression, 3, .production_id = 22), SHIFT(879),
  [4029] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_as_pattern, 3, .production_id = 26),
  [4031] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_boolean_operator, 3, .production_id = 25),
  [4033] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raise_statement, 2),
  [4035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [4037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [4039] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 5, .production_id = 83),
  [4041] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 5, .production_id = 83),
  [4043] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__wildcard_definition, 4),
  [4045] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__wildcard_definition, 4),
  [4047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3244),
  [4049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [4051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [4053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1463),
  [4055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [4057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1549),
  [4059] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_wildcard, 1),
  [4061] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_wildcard, 1),
  [4063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 4, .production_id = 59),
  [4065] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 4, .production_id = 59),
  [4067] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_pattern, 1),
  [4069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [4071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1801),
  [4073] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assert_statement, 2),
  [4075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [4077] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 4, .production_id = 58),
  [4079] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 4, .production_id = 58),
  [4081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [4083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1578),
  [4085] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 4, .production_id = 30),
  [4087] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 4, .production_id = 30),
  [4089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [4091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1525),
  [4093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3376),
  [4095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3443),
  [4097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3440),
  [4099] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_within_for_in_clause, 1),
  [4101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [4103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1432),
  [4105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [4107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1774),
  [4109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3449),
  [4111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3444),
  [4113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3418),
  [4115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [4117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1718),
  [4119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 3, .production_id = 30),
  [4121] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 3, .production_id = 30),
  [4123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__wildcard_interpolation, 4),
  [4125] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__wildcard_interpolation, 4),
  [4127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [4129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1025),
  [4131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exec_statement, 4, .production_id = 10),
  [4133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3342),
  [4135] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_named_expression, 3, .production_id = 22), SHIFT(974),
  [4138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [4140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1339),
  [4142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 6, .production_id = 104),
  [4144] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 6, .production_id = 104),
  [4146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__wildcard_interpolation, 6),
  [4148] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__wildcard_interpolation, 6),
  [4150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__wildcard_definition, 6),
  [4152] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__wildcard_definition, 6),
  [4154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delete_statement, 2),
  [4156] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 5, .production_id = 82),
  [4158] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 5, .production_id = 82),
  [4160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3216),
  [4162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1925),
  [4164] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_named_expression, 3, .production_id = 22), SHIFT(984),
  [4167] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 5, .production_id = 81),
  [4169] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 5, .production_id = 81),
  [4171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair, 3, .production_id = 49),
  [4173] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2),
  [4175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [4177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1236),
  [4179] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 2, .dynamic_precedence = -1, .production_id = 8),
  [4181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [4183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3248),
  [4185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1922),
  [4187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3410),
  [4189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1924),
  [4191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [4193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1657),
  [4195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [4197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2),
  [4199] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2), SHIFT_REPEAT(880),
  [4202] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2), SHIFT_REPEAT(3362),
  [4205] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2), SHIFT_REPEAT(1052),
  [4208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3063),
  [4210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(840),
  [4212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [4214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1744),
  [4216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_subscript_repeat1, 2, .production_id = 78),
  [4218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [4220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [4222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1788),
  [4224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [4226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [4228] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_clause, 2),
  [4230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_chevron, 2),
  [4232] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_module_body_repeat1, 1, .production_id = 3),
  [4234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_pattern, 2),
  [4236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3040),
  [4238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [4240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1613),
  [4242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(960),
  [4244] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__comprehension_clauses, 1),
  [4246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [4248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1611),
  [4250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [4252] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module_directive_wc_none, 3, .production_id = 20),
  [4254] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dotted_name_repeat1, 2), SHIFT_REPEAT(3216),
  [4257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [4259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [4261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1381),
  [4263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [4265] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2), SHIFT_REPEAT(960),
  [4268] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2), SHIFT_REPEAT(3454),
  [4271] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2), SHIFT_REPEAT(1054),
  [4274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [4276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1699),
  [4278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [4280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2748),
  [4282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2628),
  [4284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3421),
  [4286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [4288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1421),
  [4290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [4292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__comprehension_clauses, 2),
  [4294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [4296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2363),
  [4298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2657),
  [4300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3152),
  [4302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_print_statement_repeat1, 2, .production_id = 8),
  [4304] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2), SHIFT_REPEAT(918),
  [4307] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2), SHIFT_REPEAT(3450),
  [4310] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2), SHIFT_REPEAT(1057),
  [4313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [4315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1462),
  [4317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [4319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2716),
  [4321] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dotted_name_repeat1, 2), SHIFT_REPEAT(3248),
  [4324] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dotted_name_repeat1, 2), SHIFT_REPEAT(3410),
  [4327] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raise_statement, 3, .production_id = 18),
  [4329] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__collection_elements_repeat1, 2),
  [4331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constrained_type, 3),
  [4333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3374),
  [4335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [4337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [4339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3147),
  [4341] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_item, 1, .dynamic_precedence = 1, .production_id = 9),
  [4343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type, 3),
  [4345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3223),
  [4347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_parameter, 3, .production_id = 50),
  [4349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [4351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(953),
  [4353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [4355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_parameter, 3, .production_id = 22),
  [4357] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_splat, 2),
  [4359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [4361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1005),
  [4363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [4365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [4367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3238),
  [4369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [4371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(598),
  [4373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2356),
  [4375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(599),
  [4377] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 5, .production_id = 106),
  [4379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [4381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 5, .production_id = 105),
  [4383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [4385] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__directive_parameter, 1),
  [4387] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_argument, 3, .production_id = 75),
  [4389] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_argument, 3, .production_id = 22),
  [4391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary_splat, 2),
  [4393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [4395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 4, .production_id = 86),
  [4397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [4399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [4401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [4403] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 3),
  [4405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [4407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2319),
  [4409] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 5),
  [4411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [4413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3076),
  [4415] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 4),
  [4417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [4419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3085),
  [4421] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2),
  [4423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3149),
  [4425] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_type, 3),
  [4427] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_union_pattern_repeat1, 2),
  [4429] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_union_pattern_repeat1, 2), SHIFT_REPEAT(1929),
  [4432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [4434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 6, .production_id = 118),
  [4436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment, 3, .production_id = 23),
  [4438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [4440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1040),
  [4442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [4444] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_for_in_clause_repeat1, 2), SHIFT_REPEAT(854),
  [4447] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_for_in_clause_repeat1, 2),
  [4449] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_match_statement_repeat1, 2, .production_id = 42),
  [4451] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__patterns_repeat1, 2), SHIFT_REPEAT(1063),
  [4454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3369),
  [4456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2),
  [4458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_decorated_definition_repeat1, 2),
  [4460] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decorated_definition_repeat1, 2), SHIFT_REPEAT(926),
  [4463] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_pattern, 3),
  [4465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1929),
  [4467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [4469] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_assert_statement_repeat1, 2), SHIFT_REPEAT(957),
  [4472] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_for_in_clause_repeat1, 2), SHIFT_REPEAT(856),
  [4475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3059),
  [4477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [4479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice, 5),
  [4481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1875),
  [4483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(967),
  [4485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [4487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1819),
  [4489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3353),
  [4491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [4493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [4495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_default_parameter, 5, .production_id = 103),
  [4497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [4499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [4501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2333),
  [4503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [4505] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_pattern, 1),
  [4507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3068),
  [4509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raise_statement, 4, .production_id = 40),
  [4511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [4513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2441),
  [4515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_pattern, 2),
  [4517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [4519] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_named_expression, 3, .production_id = 22), SHIFT(925),
  [4522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [4524] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dotted_name_repeat1, 2), SHIFT_REPEAT(3369),
  [4527] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_for_in_clause_repeat1, 2), SHIFT_REPEAT(855),
  [4530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1872),
  [4532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_within_for_in_clause, 4, .production_id = 51),
  [4534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_list, 3, .production_id = 15),
  [4536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(992),
  [4538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_pattern, 4),
  [4540] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameter_repeat1, 2),
  [4542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(559),
  [4544] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_format_specifier, 1),
  [4546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2433),
  [4548] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dict_pattern, 4, .production_id = 132),
  [4550] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dict_pattern, 4),
  [4552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1015),
  [4554] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dict_pattern, 4, .production_id = 130),
  [4556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dict_pattern, 4, .production_id = 119),
  [4558] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_complex_pattern, 4),
  [4560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_pattern, 4),
  [4562] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tuple_pattern, 4),
  [4564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1923),
  [4566] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_list, 1, .production_id = 6),
  [4568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2517),
  [4570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3368),
  [4572] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_format_specifier, 2),
  [4574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2520),
  [4576] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dict_pattern, 3, .production_id = 119),
  [4578] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_union_pattern_repeat1, 2), SHIFT_REPEAT(1927),
  [4581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3327),
  [4583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [4585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(966),
  [4587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(604),
  [4589] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_within_for_in_clause, 3, .production_id = 19),
  [4591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [4593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1818),
  [4595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2757),
  [4597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [4599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3077),
  [4601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [4603] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tuple_pattern, 2),
  [4605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [4607] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_union_pattern_repeat1, 2), SHIFT_REPEAT(1923),
  [4610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2629),
  [4612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3303),
  [4614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3301),
  [4616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2589),
  [4618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1902),
  [4620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2531),
  [4622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [4624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [4626] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_assert_statement_repeat1, 2), SHIFT_REPEAT(881),
  [4629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(897),
  [4631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1927),
  [4633] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias_statement, 4, .dynamic_precedence = 1),
  [4635] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tuple_pattern, 5),
  [4637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [4639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [4641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dict_pattern, 5, .production_id = 130),
  [4643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1867),
  [4645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [4647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(928),
  [4649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1928),
  [4651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2609),
  [4653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_pattern, 6),
  [4655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(932),
  [4657] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dict_pattern, 2),
  [4659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [4661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [4663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [4665] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_pattern, 5),
  [4667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1912),
  [4669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2650),
  [4671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dict_pattern, 5, .production_id = 132),
  [4673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [4675] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_union_pattern_repeat1, 2), SHIFT_REPEAT(1928),
  [4678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [4680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [4682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1877),
  [4684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2417),
  [4686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2614),
  [4688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2882),
  [4690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2691),
  [4692] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tuple_pattern, 3),
  [4694] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_pattern, 5),
  [4696] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_splat_pattern, 2),
  [4698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [4700] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_pattern, 2),
  [4702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2698),
  [4704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [4706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3047),
  [4708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2649),
  [4710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2198),
  [4712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2881),
  [4714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1913),
  [4716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2557),
  [4718] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_list, 2, .production_id = 6),
  [4720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [4722] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_format_specifier_repeat1, 2), SHIFT_REPEAT(559),
  [4725] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_format_specifier_repeat1, 2),
  [4727] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_format_specifier_repeat1, 2), SHIFT_REPEAT(2520),
  [4730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2659),
  [4732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [4734] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_pattern, 3),
  [4736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1920),
  [4738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2591),
  [4740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [4742] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_pattern, 3),
  [4744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [4746] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_complex_pattern, 3),
  [4748] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dict_pattern, 3),
  [4750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [4752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1897),
  [4754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [4756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2023),
  [4758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_statement, 3),
  [4760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3328),
  [4762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2415),
  [4764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1863),
  [4766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3364),
  [4768] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_case_clause_repeat1, 2),
  [4770] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__import_list_repeat1, 2, .production_id = 31),
  [4772] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__as_pattern, 3),
  [4774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1876),
  [4776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3212),
  [4778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2586),
  [4780] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_statement, 2),
  [4782] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_clause_repeat1, 2), SHIFT_REPEAT(1898),
  [4785] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_import_prefix_repeat1, 2),
  [4787] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_import_prefix_repeat1, 2), SHIFT_REPEAT(2546),
  [4790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1874),
  [4792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2524),
  [4794] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_list, 2, .production_id = 15),
  [4796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2414),
  [4798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2584),
  [4800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1888),
  [4802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2412),
  [4804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2588),
  [4806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1868),
  [4808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2245),
  [4810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1891),
  [4812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2538),
  [4814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2598),
  [4816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1894),
  [4818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [4820] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 1),
  [4822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [4824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [4826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2658),
  [4828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1881),
  [4830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1889),
  [4832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2646),
  [4834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2644),
  [4836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1860),
  [4838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nonlocal_statement, 2),
  [4840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2499),
  [4842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1873),
  [4844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [4846] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rule_import_list, 1),
  [4848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3151),
  [4850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3195),
  [4852] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exec_statement, 5, .production_id = 10),
  [4854] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 2),
  [4856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [4858] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_global_statement_repeat1, 2), SHIFT_REPEAT(3328),
  [4861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator, 3),
  [4863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2857),
  [4865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2678),
  [4867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 3, .production_id = 16),
  [4869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [4871] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__match_block_repeat1, 2, .production_id = 88), SHIFT_REPEAT(1897),
  [4874] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__match_block_repeat1, 2, .production_id = 88),
  [4876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [4878] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_print_statement_repeat1, 2, .production_id = 39),
  [4880] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_print_statement_repeat1, 2, .production_id = 39), SHIFT_REPEAT(971),
  [4883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [4885] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assert_statement, 3),
  [4887] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_prefix, 1),
  [4889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2546),
  [4891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3432),
  [4893] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 3, .dynamic_precedence = -1, .production_id = 17),
  [4895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [4897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2184),
  [4899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2918),
  [4901] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_dict_pattern_repeat1, 2),
  [4903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [4905] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nonlocal_statement, 3),
  [4907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2632),
  [4909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1887),
  [4911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2578),
  [4913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3363),
  [4915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__import_list_repeat1, 2, .production_id = 32),
  [4917] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__import_list_repeat1, 2, .production_id = 32), SHIFT_REPEAT(2920),
  [4920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3032),
  [4922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [4924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [4926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1224),
  [4928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [4930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2620),
  [4932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [4934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [4936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3041),
  [4938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [4940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2821),
  [4942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3042),
  [4944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2686),
  [4946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1045),
  [4948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(867),
  [4950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [4952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [4954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [4956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [4958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1423),
  [4960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [4962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1422),
  [4964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2848),
  [4966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [4968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [4970] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_relative_import, 1),
  [4972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [4974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [4976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3050),
  [4978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [4980] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__patterns, 1),
  [4982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1044),
  [4984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3051),
  [4986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [4988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1053),
  [4990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2856),
  [4992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1547),
  [4994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [4996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [4998] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 1),
  [5000] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__patterns_repeat1, 2), SHIFT_REPEAT(1061),
  [5003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [5005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2127),
  [5007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2670),
  [5009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [5011] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exec_statement, 2, .production_id = 10),
  [5013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(920),
  [5015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [5017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(989),
  [5019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [5021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [5023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2036),
  [5025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameters, 1),
  [5027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3061),
  [5029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [5031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [5033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [5035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [5037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [5039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [5041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [5043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3113),
  [5045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [5047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2867),
  [5049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3115),
  [5051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1911),
  [5053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2647),
  [5055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3144),
  [5057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [5059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3145),
  [5061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1050),
  [5063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [5065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [5067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [5069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [5071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [5073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2904),
  [5075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [5077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [5079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2806),
  [5081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [5083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1208),
  [5085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [5087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [5089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3073),
  [5091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [5093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [5095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [5097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [5099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1866),
  [5101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3240),
  [5103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [5105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1893),
  [5107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [5109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [5111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1905),
  [5113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2596),
  [5115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1918),
  [5117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2592),
  [5119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [5121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [5123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2534),
  [5125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [5127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [5129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [5131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2024),
  [5133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3092),
  [5135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [5137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [5139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2870),
  [5141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [5143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [5145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [5147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [5149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1766),
  [5151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [5153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1767),
  [5155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [5157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2105),
  [5159] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__simple_statements_repeat1, 2), SHIFT_REPEAT(162),
  [5162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__simple_statements_repeat1, 2),
  [5164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1878),
  [5166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [5168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1806),
  [5170] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_assert_statement_repeat1, 2), SHIFT_REPEAT(882),
  [5173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [5175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [5177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1805),
  [5179] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_global_statement_repeat1, 2), SHIFT_REPEAT(3219),
  [5182] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_assert_statement_repeat1, 2), SHIFT_REPEAT(878),
  [5185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [5187] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_clause_repeat1, 2), SHIFT_REPEAT(1896),
  [5190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1301),
  [5192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [5194] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_global_statement_repeat1, 2), SHIFT_REPEAT(3241),
  [5197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [5199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [5201] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__collection_elements_repeat1, 2), SHIFT_REPEAT(759),
  [5204] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_aliased_import, 3, .production_id = 33),
  [5206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [5208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1751),
  [5210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [5212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1745),
  [5214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [5216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [5218] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_assert_statement_repeat1, 2), SHIFT_REPEAT(994),
  [5221] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__patterns_repeat1, 2), SHIFT_REPEAT(1062),
  [5224] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__collection_elements_repeat1, 2), SHIFT_REPEAT(763),
  [5227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [5229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1809),
  [5231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [5233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [5235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [5237] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_statement_repeat1, 2, .production_id = 44), SHIFT_REPEAT(896),
  [5240] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_match_statement_repeat1, 2, .production_id = 44),
  [5242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [5244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [5246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [5248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3110),
  [5250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3108),
  [5252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [5254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [5256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [5258] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_with_clause_repeat1, 2), SHIFT_REPEAT(872),
  [5261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_with_clause_repeat1, 2),
  [5263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [5265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [5267] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dictionary_repeat1, 2), SHIFT_REPEAT(798),
  [5270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_dictionary_repeat1, 2),
  [5272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [5274] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__parameters_repeat1, 2), SHIFT_REPEAT(2052),
  [5277] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__parameters_repeat1, 2),
  [5279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [5281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [5283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1550),
  [5285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1674),
  [5287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [5289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [5291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [5293] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_clause_repeat1, 2), SHIFT_REPEAT(1900),
  [5296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [5298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [5300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [5302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1548),
  [5304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [5306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [5308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [5310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [5312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1349),
  [5314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [5316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1359),
  [5318] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym___directive_parameters_wc_none_repeat1, 2), SHIFT_REPEAT(731),
  [5321] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym___directive_parameters_wc_none_repeat1, 2),
  [5323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [5325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [5327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [5329] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__parameters_repeat1, 2), SHIFT_REPEAT(2053),
  [5332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2554),
  [5334] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_global_statement_repeat1, 2), SHIFT_REPEAT(3372),
  [5337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(618),
  [5339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [5341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [5343] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_with_clause_repeat1, 2), SHIFT_REPEAT(868),
  [5346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3136),
  [5348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [5350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [5352] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__collection_elements_repeat1, 2), SHIFT_REPEAT(752),
  [5355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3074),
  [5357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2946),
  [5359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1908),
  [5361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2555),
  [5363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1707),
  [5365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [5367] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__import_list_repeat1, 2, .production_id = 32), SHIFT_REPEAT(2854),
  [5370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [5372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(637),
  [5374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2181),
  [5376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1892),
  [5378] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__patterns_repeat1, 2), SHIFT_REPEAT(1060),
  [5381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1871),
  [5383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [5385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1914),
  [5387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2630),
  [5389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1901),
  [5391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2533),
  [5393] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rule_import_list, 2),
  [5395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3122),
  [5397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [5399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [5401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [5403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2041),
  [5405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1055),
  [5407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1865),
  [5409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [5411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2561),
  [5413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [5415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [5417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [5419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [5421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2032),
  [5423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [5425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [5427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1058),
  [5429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [5431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [5433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [5435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1023),
  [5437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [5439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1038),
  [5441] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_format_specifier_repeat1, 1, .production_id = 57),
  [5443] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_format_specifier_repeat1, 1, .production_id = 57),
  [5445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2224),
  [5447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [5449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [5451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1440),
  [5453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(789),
  [5455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1439),
  [5457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(708),
  [5459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [5461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(620),
  [5463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1686),
  [5465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(707),
  [5467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [5469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [5471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(758),
  [5473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [5475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [5477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [5479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [5481] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym___directive_parameters_wc_none_repeat1, 2), SHIFT_REPEAT(728),
  [5484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3079),
  [5486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [5488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [5490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3266),
  [5492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3125),
  [5494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3075),
  [5496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [5498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3082),
  [5500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [5502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [5504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1579),
  [5506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [5508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [5510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [5512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3434),
  [5514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3071),
  [5516] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(717),
  [5519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [5521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1250),
  [5523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [5525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1260),
  [5527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [5529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [5531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [5533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [5535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [5537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1567),
  [5539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [5541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1566),
  [5543] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subscript_repeat1, 2, .production_id = 80), SHIFT_REPEAT(839),
  [5546] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_subscript_repeat1, 2, .production_id = 80),
  [5548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [5550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(632),
  [5552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [5554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1456),
  [5556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [5558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [5560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [5562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [5564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [5566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [5568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [5570] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_parameter_repeat1, 2), SHIFT_REPEAT(583),
  [5573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1919),
  [5575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2590),
  [5577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(643),
  [5579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [5581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
  [5583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1895),
  [5585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3055),
  [5587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [5589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1861),
  [5591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [5593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [5595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1899),
  [5597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1915),
  [5599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2619),
  [5601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1910),
  [5603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2434),
  [5605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1904),
  [5607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2631),
  [5609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [5611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1869),
  [5613] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dict_pattern_repeat1, 2, .production_id = 131), SHIFT_REPEAT(1921),
  [5616] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_dict_pattern_repeat1, 2, .production_id = 131),
  [5618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [5620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1553),
  [5622] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__key_value_pattern, 3, .production_id = 49),
  [5624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3312),
  [5626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [5628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1552),
  [5630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1886),
  [5632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [5634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [5636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [5638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [5640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1884),
  [5642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [5644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [5646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [5648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3080),
  [5650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [5652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [5654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1858),
  [5656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [5658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1883),
  [5660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [5662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1458),
  [5664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [5666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [5668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1906),
  [5670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2418),
  [5672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [5674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1907),
  [5676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2423),
  [5678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [5680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [5682] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 1),
  [5684] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 1),
  [5686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3095),
  [5688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3384),
  [5690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2709),
  [5692] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause, 4, .production_id = 120),
  [5694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3382),
  [5696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2710),
  [5698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 2, .production_id = 5),
  [5700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2425),
  [5702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2425),
  [5704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2707),
  [5706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2603),
  [5708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2384),
  [5710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2384),
  [5712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2669),
  [5714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pass_statement, 1),
  [5716] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_positional_separator, 1),
  [5718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2735),
  [5720] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause, 5, .production_id = 135),
  [5722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [5724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1041),
  [5726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2652),
  [5728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2652),
  [5730] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_dict_pattern_repeat1, 2, .production_id = 119),
  [5732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [5734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [5736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2530),
  [5738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2530),
  [5740] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause, 5, .production_id = 133),
  [5742] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause, 5, .production_id = 134),
  [5744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [5746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [5748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [5750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2602),
  [5752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2602),
  [5754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [5756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(608),
  [5758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [5760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [5762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3093),
  [5764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3391),
  [5766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [5768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [5770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2988),
  [5772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2664),
  [5774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2613),
  [5776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2613),
  [5778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2866),
  [5780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3354),
  [5782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2730),
  [5784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [5786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3352),
  [5788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2737),
  [5790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2593),
  [5792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2593),
  [5794] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment, 3, .production_id = 24),
  [5796] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_augmented_assignment, 3, .production_id = 25),
  [5798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2326),
  [5800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2326),
  [5802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [5804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2256),
  [5806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2256),
  [5808] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause, 6, .production_id = 142),
  [5810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3181),
  [5812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2168),
  [5814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2501),
  [5816] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_from_statement, 6, .production_id = 85),
  [5818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2502),
  [5820] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause, 6, .production_id = 143),
  [5822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_future_import_statement, 6, .production_id = 84),
  [5824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_future_import_statement, 4, .production_id = 34),
  [5826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause, 6, .production_id = 144),
  [5828] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_list_splat, 3, .production_id = 37),
  [5830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_from_statement, 4, .production_id = 35),
  [5832] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_list_splat, 3),
  [5834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause, 6, .production_id = 145),
  [5836] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_from_statement, 4, .production_id = 36),
  [5838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause, 7, .production_id = 149),
  [5840] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause, 7, .production_id = 150),
  [5842] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, .production_id = 37),
  [5844] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment, 5, .production_id = 77),
  [5846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3028),
  [5848] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rule_import_list, 3),
  [5850] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause, 7, .production_id = 151),
  [5852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [5854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [5856] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 2),
  [5858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [5860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [5862] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause, 8, .production_id = 152),
  [5864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2566),
  [5866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2338),
  [5868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2338),
  [5870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2564),
  [5872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2564),
  [5874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2624),
  [5876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2624),
  [5878] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rule_import_list, 2),
  [5880] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_wildcard_import, 1),
  [5882] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 3),
  [5884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [5886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(568),
  [5888] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__match_block_repeat1, 1, .production_id = 60),
  [5890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3279),
  [5892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1795),
  [5894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [5896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1008),
  [5898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1607),
  [5900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1614),
  [5902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [5904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2513),
  [5906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2359),
  [5908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1825),
  [5910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1857),
  [5912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3101),
  [5914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3105),
  [5916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1837),
  [5918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2167),
  [5920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2218),
  [5922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1626),
  [5924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1843),
  [5926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1597),
  [5928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3277),
  [5930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2503),
  [5932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1826),
  [5934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [5936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [5938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1697),
  [5940] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 4),
  [5942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1747),
  [5944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [5946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1694),
  [5948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1746),
  [5950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1695),
  [5952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3271),
  [5954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1743),
  [5956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [5958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1827),
  [5960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1148),
  [5962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1561),
  [5964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [5966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1183),
  [5968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1715),
  [5970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1714),
  [5972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [5974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1700),
  [5976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1711),
  [5978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1710),
  [5980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2953),
  [5982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2949),
  [5984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2781),
  [5986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1103),
  [5988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [5990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [5992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2344),
  [5994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1418),
  [5996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1593),
  [5998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(916),
  [6000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1693),
  [6002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2855),
  [6004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2340),
  [6006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1690),
  [6008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1589),
  [6010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1691),
  [6012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1584),
  [6014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [6016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1668),
  [6018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1583),
  [6020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3155),
  [6022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1850),
  [6024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1667),
  [6026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(965),
  [6028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1665),
  [6030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2419),
  [6032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [6034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1656),
  [6036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1849),
  [6038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [6040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1759),
  [6042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2331),
  [6044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1787),
  [6046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(979),
  [6048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1828),
  [6050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1097),
  [6052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1733),
  [6054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1328),
  [6056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1197),
  [6058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1775),
  [6060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1798),
  [6062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1846),
  [6064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [6066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1816),
  [6068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1813),
  [6070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1615),
  [6072] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rule_import_list, 3),
  [6074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2394),
  [6076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1612),
  [6078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3123),
  [6080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3338),
  [6082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [6084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2903),
  [6086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2457),
  [6088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1851),
  [6090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [6092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2211),
  [6094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1600),
  [6096] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_flag, 1),
  [6098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2206),
  [6100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3126),
  [6102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2205),
  [6104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2174),
  [6106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1410),
  [6108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1003),
  [6110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1411),
  [6112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1799),
  [6114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1413),
  [6116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [6118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2826),
  [6120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1416),
  [6122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1095),
  [6124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1268),
  [6126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1842),
  [6128] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 5),
  [6130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [6132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3190),
  [6134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1782),
  [6136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1419),
  [6138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2945),
  [6140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1840),
  [6142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(990),
  [6144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2899),
  [6146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [6148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2510),
  [6150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2738),
  [6152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2767),
  [6154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1425),
  [6156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2830),
  [6158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1426),
  [6160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [6162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2831),
  [6164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [6166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1304),
  [6168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1305),
  [6170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [6172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1604),
  [6174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1311),
  [6176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [6178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2697),
  [6180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [6182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2467),
  [6184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [6186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3153),
  [6188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1855),
  [6190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1655),
  [6192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [6194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3451),
  [6196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2665),
  [6198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1676),
  [6200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [6202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [6204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3022),
  [6206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [6208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [6210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(949),
  [6212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [6214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [6216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2894),
  [6218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2542),
  [6220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2892),
  [6222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3386),
  [6224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2020),
  [6226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1322),
  [6228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1420),
  [6230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1138),
  [6232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [6234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2185),
  [6236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1048),
  [6238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3146),
  [6240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2834),
  [6242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [6244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1535),
  [6246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_relative_import, 2),
  [6248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2789),
  [6250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2443),
  [6252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2977),
  [6254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3098),
  [6256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3028),
  [6258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2347),
  [6260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [6262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1092),
  [6264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1032),
  [6266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [6268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2763),
  [6270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2759),
  [6272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2836),
  [6274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2758),
  [6276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [6278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2819),
  [6280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2978),
  [6282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1832),
  [6284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1833),
  [6286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rule_import_list, 5),
  [6288] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_parameters, 1),
  [6290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(986),
  [6292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1526),
  [6294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1461),
  [6296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1348),
  [6298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1528),
  [6300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1383),
  [6302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1464),
  [6304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2448),
  [6306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1529),
  [6308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1470),
  [6310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [6312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2587),
  [6314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [6316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1471),
  [6318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2316),
  [6320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1310),
  [6322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1187),
  [6324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2840),
  [6326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2002),
  [6328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1537),
  [6330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [6332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2277),
  [6334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2483),
  [6336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3325),
  [6338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(958),
  [6340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2521),
  [6342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1498),
  [6344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1144),
  [6346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3371),
  [6348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1516),
  [6350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [6352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2843),
  [6354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1994),
  [6356] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [6358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3381),
  [6360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3355),
  [6362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2455),
  [6364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rule_import_list, 4),
  [6366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1509),
  [6368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2708),
  [6370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2446),
  [6372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [6374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [6376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2489),
  [6378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2582),
  [6380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2544),
  [6382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2535),
  [6384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2556),
  [6386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2454),
  [6388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2551),
  [6390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2845),
  [6392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1046),
  [6394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [6396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [6398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1059),
  [6400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1961),
  [6402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(978),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token__newline = 0,
  ts_external_token__indent = 1,
  ts_external_token__dedent = 2,
  ts_external_token_string_start = 3,
  ts_external_token__string_content = 4,
  ts_external_token_escape_interpolation = 5,
  ts_external_token_string_end = 6,
  ts_external_token_comment = 7,
  ts_external_token_RBRACK = 8,
  ts_external_token_RPAREN = 9,
  ts_external_token_RBRACE = 10,
  ts_external_token_except = 11,
  ts_external_token__ALLOW_WC_DEF = 12,
  ts_external_token__ALLOW_WC_INTERP = 13,
  ts_external_token__DISALLOW_WC = 14,
  ts_external_token__WILDCARD_DEF_OPEN = 15,
  ts_external_token__WILDCARD_INTERP_OPEN = 16,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__newline] = sym__newline,
  [ts_external_token__indent] = sym__indent,
  [ts_external_token__dedent] = sym__dedent,
  [ts_external_token_string_start] = sym_string_start,
  [ts_external_token__string_content] = sym__string_content,
  [ts_external_token_escape_interpolation] = sym_escape_interpolation,
  [ts_external_token_string_end] = sym_string_end,
  [ts_external_token_comment] = sym_comment,
  [ts_external_token_RBRACK] = anon_sym_RBRACK,
  [ts_external_token_RPAREN] = anon_sym_RPAREN,
  [ts_external_token_RBRACE] = anon_sym_RBRACE,
  [ts_external_token_except] = anon_sym_except,
  [ts_external_token__ALLOW_WC_DEF] = sym__ALLOW_WC_DEF,
  [ts_external_token__ALLOW_WC_INTERP] = sym__ALLOW_WC_INTERP,
  [ts_external_token__DISALLOW_WC] = sym__DISALLOW_WC,
  [ts_external_token__WILDCARD_DEF_OPEN] = sym__WILDCARD_DEF_OPEN,
  [ts_external_token__WILDCARD_INTERP_OPEN] = sym__WILDCARD_INTERP_OPEN,
};

static const bool ts_external_scanner_states[23][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__newline] = true,
    [ts_external_token__indent] = true,
    [ts_external_token__dedent] = true,
    [ts_external_token_string_start] = true,
    [ts_external_token__string_content] = true,
    [ts_external_token_escape_interpolation] = true,
    [ts_external_token_string_end] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_RBRACK] = true,
    [ts_external_token_RPAREN] = true,
    [ts_external_token_RBRACE] = true,
    [ts_external_token_except] = true,
    [ts_external_token__ALLOW_WC_DEF] = true,
    [ts_external_token__ALLOW_WC_INTERP] = true,
    [ts_external_token__DISALLOW_WC] = true,
    [ts_external_token__WILDCARD_DEF_OPEN] = true,
    [ts_external_token__WILDCARD_INTERP_OPEN] = true,
  },
  [2] = {
    [ts_external_token_string_start] = true,
    [ts_external_token_comment] = true,
  },
  [3] = {
    [ts_external_token__dedent] = true,
    [ts_external_token_string_start] = true,
    [ts_external_token_comment] = true,
  },
  [4] = {
    [ts_external_token__newline] = true,
    [ts_external_token_string_start] = true,
    [ts_external_token_comment] = true,
  },
  [5] = {
    [ts_external_token__newline] = true,
    [ts_external_token__indent] = true,
    [ts_external_token_string_start] = true,
    [ts_external_token_comment] = true,
  },
  [6] = {
    [ts_external_token_string_start] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_RBRACE] = true,
  },
  [7] = {
    [ts_external_token_string_start] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_except] = true,
  },
  [8] = {
    [ts_external_token__dedent] = true,
    [ts_external_token_string_start] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_except] = true,
  },
  [9] = {
    [ts_external_token_string_start] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_RPAREN] = true,
  },
  [10] = {
    [ts_external_token_string_start] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_RBRACK] = true,
  },
  [11] = {
    [ts_external_token__newline] = true,
    [ts_external_token_comment] = true,
  },
  [12] = {
    [ts_external_token_comment] = true,
    [ts_external_token_RBRACE] = true,
  },
  [13] = {
    [ts_external_token_comment] = true,
  },
  [14] = {
    [ts_external_token_comment] = true,
    [ts_external_token_RPAREN] = true,
  },
  [15] = {
    [ts_external_token_comment] = true,
    [ts_external_token_RBRACK] = true,
  },
  [16] = {
    [ts_external_token__dedent] = true,
    [ts_external_token_comment] = true,
  },
  [17] = {
    [ts_external_token__string_content] = true,
    [ts_external_token_escape_interpolation] = true,
    [ts_external_token_string_end] = true,
    [ts_external_token_comment] = true,
    [ts_external_token__WILDCARD_DEF_OPEN] = true,
    [ts_external_token__WILDCARD_INTERP_OPEN] = true,
  },
  [18] = {
    [ts_external_token_comment] = true,
    [ts_external_token_except] = true,
  },
  [19] = {
    [ts_external_token__newline] = true,
    [ts_external_token__indent] = true,
    [ts_external_token_comment] = true,
  },
  [20] = {
    [ts_external_token_comment] = true,
    [ts_external_token__ALLOW_WC_DEF] = true,
  },
  [21] = {
    [ts_external_token_comment] = true,
    [ts_external_token__ALLOW_WC_INTERP] = true,
  },
  [22] = {
    [ts_external_token_comment] = true,
    [ts_external_token__DISALLOW_WC] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_snakemake_external_scanner_create(void);
void tree_sitter_snakemake_external_scanner_destroy(void *);
bool tree_sitter_snakemake_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_snakemake_external_scanner_serialize(void *, char *);
void tree_sitter_snakemake_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_snakemake(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_snakemake_external_scanner_create,
      tree_sitter_snakemake_external_scanner_destroy,
      tree_sitter_snakemake_external_scanner_scan,
      tree_sitter_snakemake_external_scanner_serialize,
      tree_sitter_snakemake_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
